/*

Sakila for Microsoft SQL Server is a port of the Sakila example database available for MySQL, which was originally developed by Mike Hillyer of the MySQL AB documentation team. 
This project is designed to help database administrators to decide which database to use for development of new products
The user can run the same SQL against different kind of databases and compare the performance

License: BSD
Copyright DB Software Laboratory
http://www.etl-tools.com

*/
USE sakila;

-- Delete data
ALTER TABLE staff DROP CONSTRAINT fk_staff_address;
ALTER TABLE staff DROP CONSTRAINT fk_staff_store;
DELETE FROM payment ;
DELETE FROM rental ;
DELETE FROM customer ;
DELETE FROM film_category ;
DELETE FROM film_text ;
DELETE FROM film_actor ;
DELETE FROM inventory ;
DELETE FROM film ;
DELETE FROM category ;
ALTER TABLE store ALTER COLUMN manager_staff_id TINYINT NULL;
update store set manager_staff_id=null;
DELETE FROM staff ;
DELETE FROM store ;
DELETE FROM actor ;
DELETE FROM address ;
DELETE FROM city ;
DELETE FROM country ;
DELETE FROM language ;

ALTER TABLE store DROP CONSTRAINT fk_store_staff;
DROP INDEX idx_fk_address_id ON store;
ALTER TABLE store ALTER COLUMN manager_staff_id TINYINT NOT NULL;
ALTER TABLE store ADD CONSTRAINT fk_store_staff FOREIGN KEY (manager_staff_id) REFERENCES staff (staff_id);
CREATE UNIQUE NONCLUSTERED INDEX idx_fk_address_id ON store(manager_staff_id);

-- Automatically generated by Advanced ETl Processor
-- http://www.etl-tools.com/
-- table language
-- Start of script

SET IDENTITY_INSERT language ON

Insert into language
 (language_id,name,last_update)
Values
('1','English','2006-02-15T05:02:19.000')
;
Insert into language
 (language_id,name,last_update)
Values
('2','Italian','2006-02-15T05:02:19.000')
;
Insert into language
 (language_id,name,last_update)
Values
('3','Japanese','2006-02-15T05:02:19.000')
;
Insert into language
 (language_id,name,last_update)
Values
('4','Mandarin','2006-02-15T05:02:19.000')
;
Insert into language
 (language_id,name,last_update)
Values
('5','French','2006-02-15T05:02:19.000')
;
Insert into language
 (language_id,name,last_update)
Values
('6','German','2006-02-15T05:02:19.000')
;
SET IDENTITY_INSERT language OFF

-- End of Script
--
--
-- Automatically generated by Advanced ETl Processor
-- http://www.etl-tools.com/
-- table country
-- Start of script

SET IDENTITY_INSERT country ON

Insert into country
 (country_id,country,last_update)
Values
('1','Afghanistan','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('2','Algeria','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('3','American Samoa','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('4','Angola','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('5','Anguilla','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('6','Argentina','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('7','Armenia','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('8','Australia','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('9','Austria','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('10','Azerbaijan','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('11','Bahrain','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('12','Bangladesh','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('13','Belarus','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('14','Bolivia','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('15','Brazil','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('16','Brunei','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('17','Bulgaria','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('18','Cambodia','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('19','Cameroon','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('20','Canada','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('21','Chad','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('22','Chile','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('23','China','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('24','Colombia','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('25','Congo, The Democratic Republic of the','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('26','Czech Republic','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('27','Dominican Republic','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('28','Ecuador','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('29','Egypt','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('30','Estonia','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('31','Ethiopia','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('32','Faroe Islands','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('33','Finland','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('34','France','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('35','French Guiana','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('36','French Polynesia','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('37','Gambia','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('38','Germany','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('39','Greece','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('40','Greenland','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('41','Holy See (Vatican City State)','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('42','Hong Kong','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('43','Hungary','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('44','India','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('45','Indonesia','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('46','Iran','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('47','Iraq','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('48','Israel','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('49','Italy','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('50','Japan','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('51','Kazakstan','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('52','Kenya','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('53','Kuwait','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('54','Latvia','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('55','Liechtenstein','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('56','Lithuania','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('57','Madagascar','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('58','Malawi','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('59','Malaysia','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('60','Mexico','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('61','Moldova','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('62','Morocco','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('63','Mozambique','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('64','Myanmar','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('65','Nauru','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('66','Nepal','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('67','Netherlands','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('68','New Zealand','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('69','Nigeria','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('70','North Korea','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('71','Oman','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('72','Pakistan','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('73','Paraguay','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('74','Peru','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('75','Philippines','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('76','Poland','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('77','Puerto Rico','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('78','Romania','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('79','Runion','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('80','Russian Federation','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('81','Saint Vincent and the Grenadines','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('82','Saudi Arabia','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('83','Senegal','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('84','Slovakia','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('85','South Africa','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('86','South Korea','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('87','Spain','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('88','Sri Lanka','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('89','Sudan','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('90','Sweden','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('91','Switzerland','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('92','Taiwan','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('93','Tanzania','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('94','Thailand','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('95','Tonga','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('96','Tunisia','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('97','Turkey','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('98','Turkmenistan','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('99','Tuvalu','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('100','Ukraine','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('101','United Arab Emirates','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('102','United Kingdom','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('103','United States','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('104','Venezuela','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('105','Vietnam','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('106','Virgin Islands, U.S.','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('107','Yemen','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('108','Yugoslavia','2006-02-15T04:44:00.000')
;
Insert into country
 (country_id,country,last_update)
Values
('109','Zambia','2006-02-15T04:44:00.000')
;

SET IDENTITY_INSERT country OFF
-- End of Script
--
--
-- Automatically generated by Advanced ETl Processor
-- http://www.etl-tools.com/
-- table country
-- Start of script

SET IDENTITY_INSERT city ON

Insert into city
 (city_id,city,country_id,last_update)
Values
('1','A Corua (La Corua)','87','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('2','Abha','82','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('3','Abu Dhabi','101','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('4','Acua','60','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('5','Adana','97','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('6','Addis Abeba','31','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('7','Aden','107','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('8','Adoni','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('9','Ahmadnagar','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('10','Akishima','50','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('11','Akron','103','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('12','al-Ayn','101','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('13','al-Hawiya','82','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('14','al-Manama','11','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('15','al-Qadarif','89','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('16','al-Qatif','82','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('17','Alessandria','49','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('18','Allappuzha (Alleppey)','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('19','Allende','60','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('20','Almirante Brown','6','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('21','Alvorada','15','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('22','Ambattur','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('23','Amersfoort','67','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('24','Amroha','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('25','Angra dos Reis','15','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('26','Anpolis','15','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('27','Antofagasta','22','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('28','Aparecida de Goinia','15','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('29','Apeldoorn','67','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('30','Araatuba','15','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('31','Arak','46','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('32','Arecibo','77','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('33','Arlington','103','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('34','Ashdod','48','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('35','Ashgabat','98','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('36','Ashqelon','48','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('37','Asuncin','73','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('38','Athenai','39','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('39','Atinsk','80','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('40','Atlixco','60','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('41','Augusta-Richmond County','103','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('42','Aurora','103','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('43','Avellaneda','6','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('44','Bag','15','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('45','Baha Blanca','6','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('46','Baicheng','23','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('47','Baiyin','23','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('48','Baku','10','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('49','Balaiha','80','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('50','Balikesir','97','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('51','Balurghat','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('52','Bamenda','19','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('53','Bandar Seri Begawan','16','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('54','Banjul','37','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('55','Barcelona','104','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('56','Basel','91','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('57','Bat Yam','48','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('58','Batman','97','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('59','Batna','2','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('60','Battambang','18','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('61','Baybay','75','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('62','Bayugan','75','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('63','Bchar','2','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('64','Beira','63','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('65','Bellevue','103','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('66','Belm','15','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('67','Benguela','4','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('68','Beni-Mellal','62','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('69','Benin City','69','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('70','Bergamo','49','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('71','Berhampore (Baharampur)','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('72','Bern','91','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('73','Bhavnagar','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('74','Bhilwara','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('75','Bhimavaram','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('76','Bhopal','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('77','Bhusawal','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('78','Bijapur','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('79','Bilbays','29','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('80','Binzhou','23','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('81','Birgunj','66','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('82','Bislig','75','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('83','Blumenau','15','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('84','Boa Vista','15','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('85','Boksburg','85','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('86','Botosani','78','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('87','Botshabelo','85','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('88','Bradford','102','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('89','Braslia','15','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('90','Bratislava','84','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('91','Brescia','49','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('92','Brest','34','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('93','Brindisi','49','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('94','Brockton','103','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('95','Bucuresti','78','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('96','Buenaventura','24','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('97','Bydgoszcz','76','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('98','Cabuyao','75','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('99','Callao','74','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('100','Cam Ranh','105','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('101','Cape Coral','103','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('102','Caracas','104','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('103','Carmen','60','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('104','Cavite','75','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('105','Cayenne','35','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('106','Celaya','60','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('107','Chandrapur','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('108','Changhwa','92','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('109','Changzhou','23','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('110','Chapra','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('111','Charlotte Amalie','106','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('112','Chatsworth','85','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('113','Cheju','86','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('114','Chiayi','92','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('115','Chisinau','61','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('116','Chungho','92','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('117','Cianjur','45','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('118','Ciomas','45','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('119','Ciparay','45','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('120','Citrus Heights','103','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('121','Citt del Vaticano','41','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('122','Ciudad del Este','73','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('123','Clarksville','103','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('124','Coacalco de Berriozbal','60','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('125','Coatzacoalcos','60','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('126','Compton','103','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('127','Coquimbo','22','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('128','Crdoba','6','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('129','Cuauhtmoc','60','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('130','Cuautla','60','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('131','Cuernavaca','60','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('132','Cuman','104','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('133','Czestochowa','76','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('134','Dadu','72','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('135','Dallas','103','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('136','Datong','23','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('137','Daugavpils','54','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('138','Davao','75','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('139','Daxian','23','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('140','Dayton','103','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('141','Deba Habe','69','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('142','Denizli','97','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('143','Dhaka','12','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('144','Dhule (Dhulia)','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('145','Dongying','23','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('146','Donostia-San Sebastin','87','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('147','Dos Quebradas','24','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('148','Duisburg','38','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('149','Dundee','102','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('150','Dzerzinsk','80','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('151','Ede','67','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('152','Effon-Alaiye','69','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('153','El Alto','14','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('154','El Fuerte','60','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('155','El Monte','103','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('156','Elista','80','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('157','Emeishan','23','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('158','Emmen','67','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('159','Enshi','23','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('160','Erlangen','38','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('161','Escobar','6','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('162','Esfahan','46','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('163','Eskisehir','97','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('164','Etawah','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('165','Ezeiza','6','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('166','Ezhou','23','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('167','Faaa','36','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('168','Fengshan','92','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('169','Firozabad','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('170','Florencia','24','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('171','Fontana','103','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('172','Fukuyama','50','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('173','Funafuti','99','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('174','Fuyu','23','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('175','Fuzhou','23','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('176','Gandhinagar','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('177','Garden Grove','103','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('178','Garland','103','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('179','Gatineau','20','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('180','Gaziantep','97','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('181','Gijn','87','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('182','Gingoog','75','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('183','Goinia','15','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('184','Gorontalo','45','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('185','Grand Prairie','103','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('186','Graz','9','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('187','Greensboro','103','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('188','Guadalajara','60','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('189','Guaruj','15','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('190','guas Lindas de Gois','15','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('191','Gulbarga','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('192','Hagonoy','75','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('193','Haining','23','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('194','Haiphong','105','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('195','Haldia','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('196','Halifax','20','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('197','Halisahar','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('198','Halle/Saale','38','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('199','Hami','23','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('200','Hamilton','68','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('201','Hanoi','105','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('202','Hidalgo','60','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('203','Higashiosaka','50','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('204','Hino','50','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('205','Hiroshima','50','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('206','Hodeida','107','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('207','Hohhot','23','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('208','Hoshiarpur','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('209','Hsichuh','92','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('210','Huaian','23','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('211','Hubli-Dharwad','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('212','Huejutla de Reyes','60','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('213','Huixquilucan','60','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('214','Hunuco','74','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('215','Ibirit','15','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('216','Idfu','29','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('217','Ife','69','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('218','Ikerre','69','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('219','Iligan','75','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('220','Ilorin','69','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('221','Imus','75','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('222','Inegl','97','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('223','Ipoh','59','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('224','Isesaki','50','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('225','Ivanovo','80','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('226','Iwaki','50','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('227','Iwakuni','50','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('228','Iwatsuki','50','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('229','Izumisano','50','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('230','Jaffna','88','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('231','Jaipur','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('232','Jakarta','45','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('233','Jalib al-Shuyukh','53','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('234','Jamalpur','12','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('235','Jaroslavl','80','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('236','Jastrzebie-Zdrj','76','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('237','Jedda','82','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('238','Jelets','80','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('239','Jhansi','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('240','Jinchang','23','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('241','Jining','23','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('242','Jinzhou','23','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('243','Jodhpur','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('244','Johannesburg','85','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('245','Joliet','103','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('246','Jos Azueta','60','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('247','Juazeiro do Norte','15','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('248','Juiz de Fora','15','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('249','Junan','23','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('250','Jurez','60','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('251','Kabul','1','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('252','Kaduna','69','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('253','Kakamigahara','50','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('254','Kaliningrad','80','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('255','Kalisz','76','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('256','Kamakura','50','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('257','Kamarhati','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('258','Kamjanets-Podilskyi','100','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('259','Kamyin','80','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('260','Kanazawa','50','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('261','Kanchrapara','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('262','Kansas City','103','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('263','Karnal','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('264','Katihar','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('265','Kermanshah','46','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('266','Kilis','97','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('267','Kimberley','85','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('268','Kimchon','86','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('269','Kingstown','81','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('270','Kirovo-Tepetsk','80','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('271','Kisumu','52','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('272','Kitwe','109','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('273','Klerksdorp','85','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('274','Kolpino','80','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('275','Konotop','100','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('276','Koriyama','50','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('277','Korla','23','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('278','Korolev','80','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('279','Kowloon and New Kowloon','42','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('280','Kragujevac','108','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('281','Ktahya','97','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('282','Kuching','59','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('283','Kumbakonam','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('284','Kurashiki','50','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('285','Kurgan','80','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('286','Kursk','80','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('287','Kuwana','50','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('288','La Paz','60','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('289','La Plata','6','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('290','La Romana','27','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('291','Laiwu','23','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('292','Lancaster','103','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('293','Laohekou','23','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('294','Lapu-Lapu','75','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('295','Laredo','103','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('296','Lausanne','91','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('297','Le Mans','34','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('298','Lengshuijiang','23','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('299','Leshan','23','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('300','Lethbridge','20','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('301','Lhokseumawe','45','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('302','Liaocheng','23','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('303','Liepaja','54','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('304','Lilongwe','58','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('305','Lima','74','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('306','Lincoln','103','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('307','Linz','9','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('308','Lipetsk','80','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('309','Livorno','49','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('310','Ljubertsy','80','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('311','Loja','28','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('312','London','102','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('313','London','20','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('314','Lublin','76','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('315','Lubumbashi','25','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('316','Lungtan','92','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('317','Luzinia','15','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('318','Madiun','45','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('319','Mahajanga','57','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('320','Maikop','80','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('321','Malm','90','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('322','Manchester','103','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('323','Mandaluyong','75','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('324','Mandi Bahauddin','72','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('325','Mannheim','38','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('326','Maracabo','104','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('327','Mardan','72','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('328','Maring','15','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('329','Masqat','71','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('330','Matamoros','60','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('331','Matsue','50','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('332','Meixian','23','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('333','Memphis','103','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('334','Merlo','6','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('335','Mexicali','60','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('336','Miraj','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('337','Mit Ghamr','29','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('338','Miyakonojo','50','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('339','Mogiljov','13','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('340','Molodetno','13','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('341','Monclova','60','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('342','Monywa','64','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('343','Moscow','80','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('344','Mosul','47','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('345','Mukateve','100','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('346','Munger (Monghyr)','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('347','Mwanza','93','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('348','Mwene-Ditu','25','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('349','Myingyan','64','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('350','Mysore','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('351','Naala-Porto','63','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('352','Nabereznyje Telny','80','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('353','Nador','62','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('354','Nagaon','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('355','Nagareyama','50','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('356','Najafabad','46','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('357','Naju','86','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('358','Nakhon Sawan','94','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('359','Nam Dinh','105','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('360','Namibe','4','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('361','Nantou','92','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('362','Nanyang','23','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('363','NDjamna','21','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('364','Newcastle','85','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('365','Nezahualcyotl','60','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('366','Nha Trang','105','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('367','Niznekamsk','80','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('368','Novi Sad','108','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('369','Novoterkassk','80','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('370','Nukualofa','95','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('371','Nuuk','40','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('372','Nyeri','52','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('373','Ocumare del Tuy','104','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('374','Ogbomosho','69','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('375','Okara','72','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('376','Okayama','50','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('377','Okinawa','50','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('378','Olomouc','26','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('379','Omdurman','89','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('380','Omiya','50','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('381','Ondo','69','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('382','Onomichi','50','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('383','Oshawa','20','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('384','Osmaniye','97','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('385','ostka','100','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('386','Otsu','50','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('387','Oulu','33','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('388','Ourense (Orense)','87','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('389','Owo','69','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('390','Oyo','69','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('391','Ozamis','75','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('392','Paarl','85','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('393','Pachuca de Soto','60','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('394','Pak Kret','94','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('395','Palghat (Palakkad)','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('396','Pangkal Pinang','45','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('397','Papeete','36','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('398','Parbhani','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('399','Pathankot','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('400','Patiala','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('401','Patras','39','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('402','Pavlodar','51','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('403','Pemalang','45','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('404','Peoria','103','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('405','Pereira','24','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('406','Phnom Penh','18','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('407','Pingxiang','23','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('408','Pjatigorsk','80','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('409','Plock','76','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('410','Po','15','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('411','Ponce','77','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('412','Pontianak','45','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('413','Poos de Caldas','15','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('414','Portoviejo','28','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('415','Probolinggo','45','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('416','Pudukkottai','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('417','Pune','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('418','Purnea (Purnia)','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('419','Purwakarta','45','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('420','Pyongyang','70','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('421','Qalyub','29','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('422','Qinhuangdao','23','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('423','Qomsheh','46','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('424','Quilmes','6','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('425','Rae Bareli','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('426','Rajkot','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('427','Rampur','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('428','Rancagua','22','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('429','Ranchi','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('430','Richmond Hill','20','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('431','Rio Claro','15','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('432','Rizhao','23','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('433','Roanoke','103','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('434','Robamba','28','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('435','Rockford','103','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('436','Ruse','17','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('437','Rustenburg','85','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('438','s-Hertogenbosch','67','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('439','Saarbrcken','38','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('440','Sagamihara','50','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('441','Saint Louis','103','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('442','Saint-Denis','79','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('443','Sal','62','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('444','Salala','71','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('445','Salamanca','60','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('446','Salinas','103','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('447','Salzburg','9','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('448','Sambhal','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('449','San Bernardino','103','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('450','San Felipe de Puerto Plata','27','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('451','San Felipe del Progreso','60','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('452','San Juan Bautista Tuxtepec','60','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('453','San Lorenzo','73','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('454','San Miguel de Tucumn','6','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('455','Sanaa','107','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('456','Santa Brbara dOeste','15','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('457','Santa F','6','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('458','Santa Rosa','75','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('459','Santiago de Compostela','87','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('460','Santiago de los Caballeros','27','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('461','Santo Andr','15','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('462','Sanya','23','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('463','Sasebo','50','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('464','Satna','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('465','Sawhaj','29','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('466','Serpuhov','80','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('467','Shahr-e Kord','46','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('468','Shanwei','23','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('469','Shaoguan','23','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('470','Sharja','101','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('471','Shenzhen','23','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('472','Shikarpur','72','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('473','Shimoga','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('474','Shimonoseki','50','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('475','Shivapuri','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('476','Shubra al-Khayma','29','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('477','Siegen','38','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('478','Siliguri (Shiliguri)','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('479','Simferopol','100','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('480','Sincelejo','24','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('481','Sirjan','46','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('482','Sivas','97','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('483','Skikda','2','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('484','Smolensk','80','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('485','So Bernardo do Campo','15','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('486','So Leopoldo','15','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('487','Sogamoso','24','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('488','Sokoto','69','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('489','Songkhla','94','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('490','Sorocaba','15','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('491','Soshanguve','85','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('492','Sousse','96','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('493','South Hill','5','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('494','Southampton','102','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('495','Southend-on-Sea','102','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('496','Southport','102','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('497','Springs','85','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('498','Stara Zagora','17','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('499','Sterling Heights','103','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('500','Stockport','102','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('501','Sucre','14','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('502','Suihua','23','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('503','Sullana','74','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('504','Sultanbeyli','97','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('505','Sumqayit','10','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('506','Sumy','100','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('507','Sungai Petani','59','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('508','Sunnyvale','103','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('509','Surakarta','45','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('510','Syktyvkar','80','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('511','Syrakusa','49','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('512','Szkesfehrvr','43','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('513','Tabora','93','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('514','Tabriz','46','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('515','Tabuk','82','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('516','Tafuna','3','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('517','Taguig','75','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('518','Taizz','107','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('519','Talavera','75','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('520','Tallahassee','103','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('521','Tama','50','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('522','Tambaram','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('523','Tanauan','75','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('524','Tandil','6','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('525','Tangail','12','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('526','Tanshui','92','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('527','Tanza','75','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('528','Tarlac','75','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('529','Tarsus','97','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('530','Tartu','30','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('531','Teboksary','80','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('532','Tegal','45','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('533','Tel Aviv-Jaffa','48','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('534','Tete','63','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('535','Tianjin','23','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('536','Tiefa','23','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('537','Tieli','23','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('538','Tokat','97','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('539','Tonghae','86','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('540','Tongliao','23','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('541','Torren','60','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('542','Touliu','92','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('543','Toulon','34','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('544','Toulouse','34','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('545','Trshavn','32','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('546','Tsaotun','92','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('547','Tsuyama','50','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('548','Tuguegarao','75','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('549','Tychy','76','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('550','Udaipur','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('551','Udine','49','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('552','Ueda','50','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('553','Uijongbu','86','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('554','Uluberia','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('555','Urawa','50','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('556','Uruapan','60','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('557','Usak','97','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('558','Usolje-Sibirskoje','80','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('559','Uttarpara-Kotrung','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('560','Vaduz','55','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('561','Valencia','104','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('562','Valle de la Pascua','104','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('563','Valle de Santiago','60','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('564','Valparai','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('565','Vancouver','20','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('566','Varanasi (Benares)','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('567','Vicente Lpez','6','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('568','Vijayawada','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('569','Vila Velha','15','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('570','Vilnius','56','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('571','Vinh','105','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('572','Vitria de Santo Anto','15','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('573','Warren','103','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('574','Weifang','23','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('575','Witten','38','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('576','Woodridge','8','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('577','Wroclaw','76','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('578','Xiangfan','23','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('579','Xiangtan','23','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('580','Xintai','23','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('581','Xinxiang','23','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('582','Yamuna Nagar','44','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('583','Yangor','65','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('584','Yantai','23','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('585','Yaound','19','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('586','Yerevan','7','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('587','Yinchuan','23','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('588','Yingkou','23','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('589','York','102','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('590','Yuncheng','23','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('591','Yuzhou','23','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('592','Zalantun','23','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('593','Zanzibar','93','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('594','Zaoyang','23','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('595','Zapopan','60','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('596','Zaria','69','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('597','Zeleznogorsk','80','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('598','Zhezqazghan','51','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('599','Zhoushan','23','2006-02-15T04:45:25.000')
;
Insert into city
 (city_id,city,country_id,last_update)
Values
('600','Ziguinchor','83','2006-02-15T04:45:25.000')
;
SET IDENTITY_INSERT city OFF

-- End of Script
--
--
-- Automatically generated by Advanced ETl Processor
-- http://www.etl-tools.com/
-- table country
-- Start of script

SET IDENTITY_INSERT address ON

Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('1','47 MySakila Drive',NULL,' ','300',NULL,' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('2','28 MySQL Boulevard',NULL,' ','576',NULL,' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('3','23 Workhaven Lane',NULL,' ','300',NULL,' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('4','1411 Lillydale Drive',NULL,' ','576',NULL,' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('5','1913 Hanoi Way',NULL,' ','463','35200',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('6','1121 Loja Avenue',NULL,' ','449','17886',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('7','692 Joliet Street',NULL,' ','38','83579',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('8','1566 Inegl Manor',NULL,' ','349','53561',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('9','53 Idfu Parkway',NULL,' ','361','42399',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('10','1795 Santiago de Compostela Way',NULL,' ','295','18743',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('11','900 Santiago de Compostela Parkway',NULL,' ','280','93896',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('12','478 Joliet Way',NULL,' ','200','77948',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('13','613 Korolev Drive',NULL,' ','329','45844',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('14','1531 Sal Drive',NULL,' ','162','53628',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('15','1542 Tarlac Parkway',NULL,' ','440','1027',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('16','808 Bhopal Manor',NULL,' ','582','10672',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('17','270 Amroha Parkway',NULL,' ','384','29610',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('18','770 Bydgoszcz Avenue',NULL,' ','120','16266',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('19','419 Iligan Lane',NULL,' ','76','72878',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('20','360 Toulouse Parkway',NULL,' ','495','54308',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('21','270 Toulon Boulevard',NULL,' ','156','81766',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('22','320 Brest Avenue',NULL,' ','252','43331',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('23','1417 Lancaster Avenue',NULL,' ','267','72192',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('24','1688 Okara Way',NULL,' ','327','21954',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('25','262 A Corua (La Corua) Parkway',NULL,' ','525','34418',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('26','28 Charlotte Amalie Street',NULL,' ','443','37551',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('27','1780 Hino Boulevard',NULL,' ','303','7716',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('28','96 Tafuna Way',NULL,' ','128','99865',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('29','934 San Felipe de Puerto Plata Street',NULL,' ','472','99780',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('30','18 Duisburg Boulevard',NULL,' ','121','58327',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('31','217 Botshabelo Place',NULL,' ','138','49521',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('32','1425 Shikarpur Manor',NULL,' ','346','65599',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('33','786 Aurora Avenue',NULL,' ','474','65750',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('34','1668 Anpolis Street',NULL,' ','316','50199',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('35','33 Gorontalo Way',NULL,' ','257','30348',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('36','176 Mandaluyong Place',NULL,' ','239','65213',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('37','127 Purnea (Purnia) Manor',NULL,' ','17','79388',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('38','61 Tama Street',NULL,' ','284','94065',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('39','391 Callao Drive',NULL,' ','544','34021',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('40','334 Munger (Monghyr) Lane',NULL,' ','31','38145',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('41','1440 Fukuyama Loop',NULL,' ','362','47929',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('42','269 Cam Ranh Parkway',NULL,' ','115','34689',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('43','306 Antofagasta Place',NULL,' ','569','3989',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('44','671 Graz Street',NULL,' ','353','94399',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('45','42 Brindisi Place',NULL,' ','586','16744',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('46','1632 Bislig Avenue',NULL,' ','394','61117',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('47','1447 Imus Way',NULL,' ','167','48942',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('48','1998 Halifax Drive',NULL,' ','308','76022',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('49','1718 Valencia Street',NULL,' ','27','37359',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('50','46 Pjatigorsk Lane',NULL,' ','343','23616',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('51','686 Garland Manor',NULL,' ','247','52535',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('52','909 Garland Manor',NULL,' ','367','69367',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('53','725 Isesaki Place',NULL,' ','237','74428',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('54','115 Hidalgo Parkway',NULL,' ','379','80168',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('55','1135 Izumisano Parkway',NULL,' ','171','48150',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('56','939 Probolinggo Loop',NULL,' ','1','4166',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('57','17 Kabul Boulevard',NULL,' ','355','38594',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('58','1964 Allappuzha (Alleppey) Street',NULL,' ','227','48980',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('59','1697 Kowloon and New Kowloon Loop',NULL,' ','49','57807',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('60','1668 Saint Louis Place',NULL,' ','397','39072',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('61','943 Tokat Street',NULL,' ','560','45428',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('62','1114 Liepaja Street',NULL,' ','282','69226',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('63','1213 Ranchi Parkway',NULL,' ','350','94352',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('64','81 Hodeida Way',NULL,' ','231','55561',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('65','915 Ponce Place',NULL,' ','56','83980',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('66','1717 Guadalajara Lane',NULL,' ','441','85505',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('67','1214 Hanoi Way',NULL,' ','306','67055',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('68','1966 Amroha Avenue',NULL,' ','139','70385',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('69','698 Otsu Street',NULL,' ','105','71110',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('70','1150 Kimchon Manor',NULL,' ','321','96109',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('71','1586 Guaruj Place',NULL,' ','579','5135',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('72','57 Arlington Manor',NULL,' ','475','48960',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('73','1031 Daugavpils Parkway',NULL,' ','63','59025',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('74','1124 Buenaventura Drive',NULL,' ','13','6856',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('75','492 Cam Ranh Street',NULL,' ','61','50805',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('76','89 Allappuzha (Alleppey) Manor',NULL,' ','517','75444',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('77','1947 Poos de Caldas Boulevard',NULL,' ','114','60951',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('78','1206 Dos Quebradas Place',NULL,' ','431','20207',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('79','1551 Rampur Lane',NULL,' ','108','72394',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('80','602 Paarl Street',NULL,' ','402','98889',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('81','1692 Ede Loop',NULL,' ','30','9223',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('82','936 Salzburg Lane',NULL,' ','425','96709',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('83','586 Tete Way',NULL,' ','256','1079',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('84','1888 Kabul Drive',NULL,' ','217','20936',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('85','320 Baiyin Parkway',NULL,' ','319','37307',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('86','927 Baha Blanca Parkway',NULL,' ','479','9495',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('87','929 Tallahassee Loop',NULL,' ','497','74671',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('88','125 Citt del Vaticano Boulevard',NULL,' ','40','67912',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('89','1557 Ktahya Boulevard',NULL,' ','88','88002',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('90','870 Ashqelon Loop',NULL,' ','489','84931',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('91','1740 Portoviejo Avenue',NULL,' ','480','29932',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('92','1942 Ciparay Parkway',NULL,' ','113','82624',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('93','1926 El Alto Avenue',NULL,' ','289','75543',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('94','1952 Chatsworth Drive',NULL,' ','332','25958',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('95','1370 Le Mans Avenue',NULL,' ','53','52163',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('96','984 Effon-Alaiye Avenue',NULL,' ','183','17119',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('97','832 Nakhon Sawan Manor',NULL,' ','592','49021',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('98','152 Kitwe Parkway',NULL,' ','82','53182',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('99','1697 Tanauan Lane',NULL,' ','399','22870',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('100','1308 Arecibo Way',NULL,' ','41','30695',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('101','1599 Plock Drive',NULL,' ','534','71986',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('102','669 Firozabad Loop',NULL,' ','12','92265',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('103','588 Vila Velha Manor',NULL,' ','268','51540',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('104','1913 Kamakura Place',NULL,' ','238','97287',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('105','733 Mandaluyong Place',NULL,' ','2','77459',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('106','659 Vaduz Drive',NULL,' ','34','49708',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('107','1177 Jelets Way',NULL,' ','220','3305',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('108','1386 Yangor Avenue',NULL,' ','543','80720',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('109','454 Nakhon Sawan Boulevard',NULL,' ','173','76383',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('110','1867 San Juan Bautista Tuxtepec Avenue',NULL,' ','225','78311',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('111','1532 Dzerzinsk Way',NULL,' ','334','9599',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('112','1002 Ahmadnagar Manor',NULL,' ','213','93026',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('113','682 Junan Way',NULL,' ','273','30418',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('114','804 Elista Drive',NULL,' ','159','61069',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('115','1378 Alvorada Avenue',NULL,' ','102','75834',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('116','793 Cam Ranh Avenue',NULL,' ','292','87057',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('117','1079 Tel Aviv-Jaffa Boulevard',NULL,' ','132','10885',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('118','442 Rae Bareli Place',NULL,' ','148','24321',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('119','1107 Nakhon Sawan Avenue',NULL,' ','365','75149',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('120','544 Malm Parkway',NULL,' ','403','63502',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('121','1967 Sincelejo Place',NULL,' ','176','73644',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('122','333 Goinia Way',NULL,' ','185','78625',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('123','1987 Coacalco de Berriozbal Loop',NULL,' ','476','96065',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('124','241 Mosul Lane',NULL,' ','147','76157',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('125','211 Chiayi Drive',NULL,' ','164','58186',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('126','1175 Tanauan Way',NULL,' ','305','64615',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('127','117 Boa Vista Way',NULL,' ','566','6804',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('128','848 Tafuna Manor',NULL,' ','281','45142',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('129','569 Baicheng Lane',NULL,' ','85','60304',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('130','1666 Qomsheh Drive',NULL,' ','410','66255',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('131','801 Hagonoy Drive',NULL,' ','484','8439',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('132','1050 Garden Grove Avenue',NULL,' ','236','4999',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('133','1854 Tieli Street',NULL,' ','302','15819',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('134','758 Junan Lane',NULL,' ','190','82639',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('135','1752 So Leopoldo Parkway',NULL,' ','345','14014',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('136','898 Belm Manor',NULL,' ','87','49757',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('137','261 Saint Louis Way',NULL,' ','541','83401',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('138','765 Southampton Drive',NULL,' ','421','4285',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('139','943 Johannesburg Avenue',NULL,' ','417','5892',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('140','788 Atinsk Street',NULL,' ','211','81691',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('141','1749 Daxian Place',NULL,' ','29','11044',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('142','1587 Sullana Lane',NULL,' ','207','85769',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('143','1029 Dzerzinsk Manor',NULL,' ','542','57519',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('144','1666 Beni-Mellal Place',NULL,' ','123','13377',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('145','928 Jaffna Loop',NULL,' ','172','93762',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('146','483 Ljubertsy Parkway',NULL,' ','149','60562',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('147','374 Bat Yam Boulevard',NULL,' ','266','97700',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('148','1027 Songkhla Manor',NULL,' ','340','30861',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('149','999 Sanaa Loop',NULL,' ','491','3439',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('150','879 Newcastle Way',NULL,' ','499','90732',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('151','1337 Lincoln Parkway',NULL,' ','555','99457',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('152','1952 Pune Lane',NULL,' ','442','92150',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('153','782 Mosul Street',NULL,' ','94','25545',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('154','781 Shimonoseki Drive',NULL,' ','202','95444',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('155','1560 Jelets Boulevard',NULL,' ','291','77777',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('156','1963 Moscow Place',NULL,' ','354','64863',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('157','456 Escobar Way',NULL,' ','232','36061',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('158','798 Cianjur Avenue',NULL,' ','590','76990',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('159','185 Novi Sad Place',NULL,' ','72','41778',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('160','1367 Yantai Manor',NULL,' ','381','21294',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('161','1386 Nakhon Sawan Boulevard',NULL,' ','420','53502',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('162','369 Papeete Way',NULL,' ','187','66639',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('163','1440 Compton Place',NULL,' ','307','81037',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('164','1623 Baha Blanca Manor',NULL,' ','310','81511',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('165','97 Shimoga Avenue',NULL,' ','533','44660',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('166','1740 Le Mans Loop',NULL,' ','297','22853',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('167','1287 Xiangfan Boulevard',NULL,' ','253','57844',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('168','842 Salzburg Lane',NULL,' ','529','3313',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('169','154 Tallahassee Loop',NULL,' ','199','62250',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('170','710 San Felipe del Progreso Avenue',NULL,' ','304','76901',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('171','1540 Wroclaw Drive',NULL,' ','107','62686',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('172','475 Atinsk Way',NULL,' ','240','59571',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('173','1294 Firozabad Drive',NULL,' ','407','70618',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('174','1877 Ezhou Lane',NULL,' ','550','63337',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('175','316 Uruapan Street',NULL,' ','223','58194',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('176','29 Pyongyang Loop',NULL,' ','58','47753',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('177','1010 Klerksdorp Way',NULL,' ','186','6802',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('178','1848 Salala Boulevard',NULL,' ','373','25220',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('179','431 Xiangtan Avenue',NULL,' ','18','4854',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('180','757 Rustenburg Avenue',NULL,' ','483','89668',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('181','146 Johannesburg Way',NULL,' ','330','54132',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('182','1891 Rizhao Boulevard',NULL,' ','456','47288',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('183','1089 Iwatsuki Avenue',NULL,' ','270','35109',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('184','1410 Benin City Parkway',NULL,' ','405','29747',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('185','682 Garden Grove Place',NULL,' ','333','67497',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('186','533 al-Ayn Boulevard',NULL,' ','126','8862',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('187','1839 Szkesfehrvr Parkway',NULL,' ','317','55709',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('188','741 Ambattur Manor',NULL,' ','438','43310',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('189','927 Barcelona Street',NULL,' ','467','65121',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('190','435 0 Way',NULL,' ','195','74750',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('191','140 Chiayi Parkway',NULL,' ','506','38982',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('192','1166 Changhwa Street',NULL,' ','62','58852',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('193','891 Novi Sad Manor',NULL,' ','383','5379',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('194','605 Rio Claro Parkway',NULL,' ','513','49348',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('195','1077 San Felipe de Puerto Plata Place',NULL,' ','369','65387',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('196','9 San Miguel de Tucumn Manor',NULL,' ','169','90845',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('197','447 Surakarta Loop',NULL,' ','271','10428',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('198','345 Oshawa Boulevard',NULL,' ','204','32114',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('199','1792 Valle de la Pascua Place',NULL,' ','477','15540',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('200','1074 Binzhou Manor',NULL,' ','325','36490',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('201','817 Bradford Loop',NULL,' ','109','89459',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('202','955 Bamenda Way',NULL,' ','218','1545',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('203','1149 A Corua (La Corua) Boulevard',NULL,' ','194','95824',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('204','387 Mwene-Ditu Drive',NULL,' ','35','8073',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('205','68 Molodetno Manor',NULL,' ','575','4662',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('206','642 Nador Drive',NULL,' ','77','3924',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('207','1688 Nador Lane',NULL,' ','184','61613',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('208','1215 Pyongyang Parkway',NULL,' ','557','25238',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('209','1679 Antofagasta Street',NULL,' ','122','86599',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('210','1304 s-Hertogenbosch Way',NULL,' ','83','10925',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('211','850 Salala Loop',NULL,' ','371','10800',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('212','624 Oshawa Boulevard',NULL,' ','51','89959',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('213','43 Dadu Avenue',NULL,' ','74','4855',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('214','751 Lima Loop',NULL,' ','7','99405',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('215','1333 Haldia Street',NULL,' ','174','82161',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('216','660 Jedda Boulevard',NULL,' ','65','25053',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('217','1001 Miyakonojo Lane',NULL,' ','518','67924',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('218','226 Brest Manor',NULL,' ','508','2299',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('219','1229 Valencia Parkway',NULL,' ','498','99124',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('220','1201 Qomsheh Manor',NULL,' ','28','21464',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('221','866 Shivapuri Manor',NULL,' ','448','22474',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('222','1168 Najafabad Parkway',NULL,' ','251','40301',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('223','1244 Allappuzha (Alleppey) Place',NULL,' ','567','20657',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('224','1842 Luzinia Boulevard',NULL,' ','593','94420',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('225','1926 Gingoog Street',NULL,' ','511','22824',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('226','810 Palghat (Palakkad) Boulevard',NULL,' ','235','73431',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('227','1820 Maring Parkway',NULL,' ','324','88307',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('228','60 Poos de Caldas Street',NULL,' ','243','82338',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('229','1014 Loja Manor',NULL,' ','22','66851',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('230','201 Effon-Alaiye Way',NULL,' ','37','64344',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('231','430 Alessandria Loop',NULL,' ','439','47446',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('232','754 Valencia Place',NULL,' ','406','87911',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('233','356 Olomouc Manor',NULL,' ','26','93323',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('234','1256 Bislig Boulevard',NULL,' ','86','50598',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('235','954 Kimchon Place',NULL,' ','559','42420',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('236','885 Yingkou Manor',NULL,' ','596','31390',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('237','1736 Cavite Place',NULL,' ','216','98775',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('238','346 Skikda Parkway',NULL,' ','233','90628',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('239','98 Stara Zagora Boulevard',NULL,' ','96','76448',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('240','1479 Rustenburg Boulevard',NULL,' ','527','18727',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('241','647 A Corua (La Corua) Street',NULL,' ','357','36971',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('242','1964 Gijn Manor',NULL,' ','473','14408',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('243','47 Syktyvkar Lane',NULL,' ','118','22236',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('244','1148 Saarbrcken Parkway',NULL,' ','226','1921',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('245','1103 Bilbays Parkway',NULL,' ','578','87660',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('246','1246 Boksburg Parkway',NULL,' ','422','28349',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('247','1483 Pathankot Street',NULL,' ','454','37288',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('248','582 Papeete Loop',NULL,' ','294','27722',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('249','300 Junan Street',NULL,' ','553','81314',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('250','829 Grand Prairie Way',NULL,' ','328','6461',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('251','1473 Changhwa Parkway',NULL,' ','124','75933',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('252','1309 Weifang Street',NULL,' ','520','57338',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('253','1760 Oshawa Manor',NULL,' ','535','38140',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('254','786 Stara Zagora Way',NULL,' ','390','98332',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('255','1966 Tonghae Street',NULL,' ','198','36481',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('256','1497 Yuzhou Drive',NULL,' ','312','3433',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('258','752 Ondo Loop',NULL,' ','338','32474',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('259','1338 Zalantun Lane',NULL,' ','413','45403',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('260','127 Iwakuni Boulevard',NULL,' ','192','20777',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('261','51 Laredo Avenue',NULL,' ','342','68146',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('262','771 Yaound Manor',NULL,' ','64','86768',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('263','532 Toulon Street',NULL,' ','460','69517',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('264','1027 Banjul Place',NULL,' ','197','50390',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('265','1158 Mandi Bahauddin Parkway',NULL,' ','136','98484',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('266','862 Xintai Lane',NULL,' ','548','30065',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('267','816 Cayenne Parkway',NULL,' ','414','93629',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('268','1831 Nam Dinh Loop',NULL,' ','323','51990',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('269','446 Kirovo-Tepetsk Lane',NULL,' ','203','19428',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('270','682 Halisahar Place',NULL,' ','378','20536',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('271','1587 Loja Manor',NULL,' ','447','5410',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('272','1762 Paarl Parkway',NULL,' ','298','53928',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('273','1519 Ilorin Place',NULL,' ','395','49298',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('274','920 Kumbakonam Loop',NULL,' ','446','75090',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('275','906 Goinia Way',NULL,' ','255','83565',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('276','1675 Xiangfan Manor',NULL,' ','283','11763',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('277','85 San Felipe de Puerto Plata Drive',NULL,' ','584','46063',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('278','144 South Hill Loop',NULL,' ','445','2012',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('279','1884 Shikarpur Avenue',NULL,' ','263','85548',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('280','1980 Kamjanets-Podilskyi Street',NULL,' ','404','89502',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('281','1944 Bamenda Way',NULL,' ','573','24645',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('282','556 Baybay Manor',NULL,' ','374','55802',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('283','457 Tongliao Loop',NULL,' ','222','56254',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('284','600 Bradford Street',NULL,' ','514','96204',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('285','1006 Santa Brbara dOeste Manor',NULL,' ','389','36229',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('286','1308 Sumy Loop',NULL,' ','175','30657',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('287','1405 Chisinau Place',NULL,' ','411','8160',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('288','226 Halifax Street',NULL,' ','277','58492',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('289','1279 Udine Parkway',NULL,' ','69','75860',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('290','1336 Benin City Drive',NULL,' ','386','46044',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('291','1155 Liaocheng Place',NULL,' ','152','22650',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('292','1993 Tabuk Lane',NULL,' ','522','64221',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('293','86 Higashiosaka Lane',NULL,' ','563','33768',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('294','1912 Allende Manor',NULL,' ','279','58124',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('295','544 Tarsus Boulevard',NULL,' ','562','53145',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('296','1936 Cuman Avenue',NULL,' ','433','61195',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('297','1192 Tongliao Street',NULL,' ','470','19065',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('298','44 Najafabad Way',NULL,' ','146','61391',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('299','32 Pudukkottai Lane',NULL,' ','140','38834',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('300','661 Chisinau Lane',NULL,' ','274','8856',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('301','951 Stara Zagora Manor',NULL,' ','400','98573',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('302','922 Vila Velha Loop',NULL,' ','9','4085',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('303','898 Jining Lane',NULL,' ','387','40070',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('304','1635 Kuwana Boulevard',NULL,' ','205','52137',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('305','41 El Alto Parkway',NULL,' ','398','56883',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('306','1883 Maikop Lane',NULL,' ','254','68469',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('307','1908 Gaziantep Place',NULL,' ','536','58979',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('308','687 Alessandria Parkway',NULL,' ','455','57587',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('309','827 Yuncheng Drive',NULL,' ','99','79047',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('310','913 Coacalco de Berriozbal Loop',NULL,' ','33','42141',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('311','715 So Bernardo do Campo Lane',NULL,' ','507','84804',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('312','1354 Siegen Street',NULL,' ','25','80184',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('313','1191 Sungai Petani Boulevard',NULL,' ','262','9668',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('314','1224 Huejutla de Reyes Boulevard',NULL,' ','91','70923',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('315','543 Bergamo Avenue',NULL,' ','215','59686',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('316','746 Joliet Lane',NULL,' ','286','94878',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('317','780 Kimberley Way',NULL,' ','515','17032',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('318','1774 Yaound Place',NULL,' ','166','91400',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('319','1957 Yantai Lane',NULL,' ','490','59255',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('320','1542 Lubumbashi Boulevard',NULL,' ','57','62472',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('321','651 Pathankot Loop',NULL,' ','336','59811',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('322','1359 Zhoushan Parkway',NULL,' ','545','29763',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('323','1769 Iwaki Lane',NULL,' ','97','25787',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('324','1145 Vilnius Manor',NULL,' ','451','73170',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('325','1892 Nabereznyje Telny Lane',NULL,' ','516','28396',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('326','470 Boksburg Street',NULL,' ','81','97960',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('327','1427 A Corua (La Corua) Place',NULL,' ','45','85799',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('328','479 San Felipe del Progreso Avenue',NULL,' ','130','54949',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('329','867 Benin City Avenue',NULL,' ','591','78543',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('330','981 Kumbakonam Place',NULL,' ','89','87611',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('331','1016 Iwakuni Street',NULL,' ','269','49833',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('332','663 Baha Blanca Parkway',NULL,' ','5','33463',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('333','1860 Taguig Loop',NULL,' ','119','59550',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('334','1816 Bydgoszcz Loop',NULL,' ','234','64308',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('335','587 Benguela Manor',NULL,' ','42','91590',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('336','430 Kumbakonam Drive',NULL,' ','457','28814',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('337','1838 Tabriz Lane',NULL,' ','143','1195',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('338','431 Szkesfehrvr Avenue',NULL,' ','48','57828',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('339','503 Sogamoso Loop',NULL,' ','505','49812',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('340','507 Smolensk Loop',NULL,' ','492','22971',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('341','1920 Weifang Avenue',NULL,' ','427','15643',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('342','124 al-Manama Way',NULL,' ','382','52368',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('343','1443 Mardan Street',NULL,' ','392','31483',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('344','1909 Benguela Lane',NULL,' ','581','19913',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('345','68 Ponce Parkway',NULL,' ','201','85926',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('346','1217 Konotop Avenue',NULL,' ','151','504',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('347','1293 Nam Dinh Way',NULL,' ','84','71583',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('348','785 Vaduz Street',NULL,' ','335','36170',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('349','1516 Escobar Drive',NULL,' ','370','46069',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('350','1628 Nagareyama Lane',NULL,' ','453','60079',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('351','1157 Nyeri Loop',NULL,' ','320','56380',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('352','1673 Tangail Drive',NULL,' ','137','26857',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('353','381 Kabul Way',NULL,' ','209','87272',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('354','953 Hodeida Street',NULL,' ','221','18841',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('355','469 Nakhon Sawan Street',NULL,' ','531','58866',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('356','1378 Beira Loop',NULL,' ','597','40792',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('357','1641 Changhwa Place',NULL,' ','52','37636',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('358','1698 Southport Loop',NULL,' ','393','49009',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('359','519 Nyeri Manor',NULL,' ','461','37650',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('360','619 Hunuco Avenue',NULL,' ','331','81508',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('361','45 Aparecida de Goinia Place',NULL,' ','464','7431',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('362','482 Kowloon and New Kowloon Manor',NULL,' ','90','97056',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('363','604 Bern Place',NULL,' ','429','5373',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('364','1623 Kingstown Drive',NULL,' ','20','91299',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('365','1009 Zanzibar Lane',NULL,' ','32','64875',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('366','114 Jalib al-Shuyukh Manor',NULL,' ','585','60440',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('367','1163 London Parkway',NULL,' ','66','6066',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('368','1658 Jastrzebie-Zdrj Loop',NULL,' ','372','96584',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('369','817 Laredo Avenue',NULL,' ','188','77449',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('370','1565 Tangail Manor',NULL,' ','377','45750',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('371','1912 Emeishan Drive',NULL,' ','50','33050',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('372','230 Urawa Drive',NULL,' ','8','2738',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('373','1922 Miraj Way',NULL,' ','356','13203',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('374','433 Florencia Street',NULL,' ','250','91330',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('375','1049 Matamoros Parkway',NULL,' ','191','69640',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('376','1061 Ede Avenue',NULL,' ','98','57810',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('377','154 Oshawa Manor',NULL,' ','415','72771',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('378','1191 Tandil Drive',NULL,' ','523','6362',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('379','1133 Rizhao Avenue',NULL,' ','572','2800',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('380','1519 Santiago de los Caballeros Loop',NULL,' ','348','22025',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('381','1618 Olomouc Manor',NULL,' ','285','26385',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('382','220 Hidalgo Drive',NULL,' ','265','45298',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('383','686 Donostia-San Sebastin Lane',NULL,' ','471','97390',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('384','97 Mogiljov Lane',NULL,' ','73','89294',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('385','1642 Charlotte Amalie Drive',NULL,' ','549','75442',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('386','1368 Maracabo Boulevard',NULL,' ','493','32716',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('387','401 Sucre Boulevard',NULL,' ','322','25007',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('388','368 Hunuco Boulevard',NULL,' ','360','17165',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('389','500 Lincoln Parkway',NULL,' ','210','95509',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('390','102 Chapra Drive',NULL,' ','521','14073',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('391','1793 Meixian Place',NULL,' ','258','33535',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('392','514 Ife Way',NULL,' ','315','69973',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('393','717 Changzhou Lane',NULL,' ','104','21615',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('394','753 Ilorin Avenue',NULL,' ','157','3656',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('395','1337 Mit Ghamr Avenue',NULL,' ','358','29810',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('396','767 Pyongyang Drive',NULL,' ','229','83536',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('397','614 Pak Kret Street',NULL,' ','6','27796',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('398','954 Lapu-Lapu Way',NULL,' ','278','8816',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('399','331 Bydgoszcz Parkway',NULL,' ','181','966',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('400','1152 Citrus Heights Manor',NULL,' ','15','5239',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('401','168 Cianjur Manor',NULL,' ','228','73824',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('402','616 Hagonoy Avenue',NULL,' ','39','46043',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('403','1190 0 Place',NULL,' ','44','10417',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('404','734 Bchar Place',NULL,' ','375','30586',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('405','530 Lausanne Lane',NULL,' ','135','11067',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('406','454 Patiala Lane',NULL,' ','276','13496',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('407','1346 Mysore Drive',NULL,' ','92','61507',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('408','990 Etawah Loop',NULL,' ','564','79940',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('409','1266 Laredo Parkway',NULL,' ','380','7664',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('410','88 Nagaon Manor',NULL,' ','524','86868',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('411','264 Bhimavaram Manor',NULL,' ','111','54749',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('412','1639 Saarbrcken Drive',NULL,' ','437','9827',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('413','692 Amroha Drive',NULL,' ','230','35575',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('414','1936 Lapu-Lapu Parkway',NULL,' ','141','7122',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('415','432 Garden Grove Street',NULL,' ','430','65630',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('416','1445 Carmen Parkway',NULL,' ','117','70809',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('417','791 Salinas Street',NULL,' ','208','40509',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('418','126 Acua Parkway',NULL,' ','71','58888',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('419','397 Sunnyvale Avenue',NULL,' ','19','55566',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('420','992 Klerksdorp Loop',NULL,' ','23','33711',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('421','966 Arecibo Loop',NULL,' ','134','94018',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('422','289 Santo Andr Manor',NULL,' ','16','72410',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('423','437 Chungho Drive',NULL,' ','450','59489',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('424','1948 Bayugan Parkway',NULL,' ','264','60622',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('425','1866 al-Qatif Avenue',NULL,' ','155','89420',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('426','1661 Abha Drive',NULL,' ','416','14400',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('427','1557 Cape Coral Parkway',NULL,' ','293','46875',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('428','1727 Matamoros Place',NULL,' ','465','78813',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('429','1269 Botosani Manor',NULL,' ','468','47394',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('430','355 Vitria de Santo Anto Way',NULL,' ','452','81758',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('431','1596 Acua Parkway',NULL,' ','418','70425',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('432','259 Ipoh Drive',NULL,' ','189','64964',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('433','1823 Hoshiarpur Lane',NULL,' ','510','33191',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('434','1404 Taguig Drive',NULL,' ','547','87212',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('435','740 Udaipur Lane',NULL,' ','150','33505',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('436','287 Cuautla Boulevard',NULL,' ','501','72736',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('437','1766 Almirante Brown Street',NULL,' ','364','63104',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('438','596 Huixquilucan Place',NULL,' ','351','65892',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('439','1351 Aparecida de Goinia Parkway',NULL,' ','391','41775',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('440','722 Bradford Lane',NULL,' ','249','90920',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('441','983 Santa F Way',NULL,' ','565','47472',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('442','1245 Ibirit Way',NULL,' ','290','40926',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('443','1836 Korla Parkway',NULL,' ','272','55405',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('444','231 Kaliningrad Place',NULL,' ','70','57833',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('445','495 Bhimavaram Lane',NULL,' ','144','3',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('446','1924 Shimonoseki Drive',NULL,' ','59','52625',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('447','105 Dzerzinsk Manor',NULL,' ','540','48570',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('448','614 Denizli Parkway',NULL,' ','486','29444',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('449','1289 Belm Boulevard',NULL,' ','530','88306',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('450','203 Tambaram Street',NULL,' ','161','73942',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('451','1704 Tambaram Manor',NULL,' ','554','2834',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('452','207 Cuernavaca Loop',NULL,' ','352','52671',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('453','319 Springs Loop',NULL,' ','160','99552',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('454','956 Nam Dinh Manor',NULL,' ','481','21872',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('455','1947 Paarl Way',NULL,' ','509','23636',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('456','814 Simferopol Loop',NULL,' ','154','48745',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('457','535 Ahmadnagar Manor',NULL,' ','3','41136',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('458','138 Caracas Boulevard',NULL,' ','326','16790',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('459','251 Florencia Drive',NULL,' ','556','16119',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('460','659 Gatineau Boulevard',NULL,' ','153','28587',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('461','1889 Valparai Way',NULL,' ','600','75559',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('462','1485 Bratislava Place',NULL,' ','435','83183',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('463','935 Aden Boulevard',NULL,' ','532','64709',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('464','76 Kermanshah Manor',NULL,' ','423','23343',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('465','734 Tanshui Avenue',NULL,' ','170','70664',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('466','118 Jaffna Loop',NULL,' ','182','10447',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('467','1621 Tongliao Avenue',NULL,' ','558','22173',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('468','1844 Usak Avenue',NULL,' ','196','84461',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('469','1872 Toulon Loop',NULL,' ','428','7939',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('470','1088 Ibirit Place',NULL,' ','595','88502',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('471','1322 Mosul Parkway',NULL,' ','145','95400',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('472','1447 Chatsworth Place',NULL,' ','129','41545',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('473','1257 Guadalajara Street',NULL,' ','78','33599',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('474','1469 Plock Lane',NULL,' ','388','95835',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('475','434 Ourense (Orense) Manor',NULL,' ','206','14122',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('476','270 Tambaram Parkway',NULL,' ','244','9668',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('477','1786 Salinas Place',NULL,' ','359','66546',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('478','1078 Stara Zagora Drive',NULL,' ','301','69221',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('479','1854 Okara Boulevard',NULL,' ','158','42123',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('480','421 Yaound Street',NULL,' ','385','11363',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('481','1153 Allende Way',NULL,' ','179','20336',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('482','808 Naala-Porto Parkway',NULL,' ','500','41060',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('483','632 Usolje-Sibirskoje Parkway',NULL,' ','36','73085',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('484','98 Pyongyang Boulevard',NULL,' ','11','88749',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('485','984 Novoterkassk Loop',NULL,' ','180','28165',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('486','64 Korla Street',NULL,' ','347','25145',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('487','1785 So Bernardo do Campo Street',NULL,' ','125','71182',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('488','698 Jelets Boulevard',NULL,' ','142','2596',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('489','1297 Alvorada Parkway',NULL,' ','587','11839',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('490','1909 Dayton Avenue',NULL,' ','469','88513',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('491','1789 Saint-Denis Parkway',NULL,' ','4','8268',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('492','185 Mannheim Lane',NULL,' ','408','23661',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('493','184 Mandaluyong Street',NULL,' ','288','94239',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('494','591 Sungai Petani Drive',NULL,' ','376','46400',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('495','656 Matamoros Drive',NULL,' ','487','19489',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('496','775 ostka Drive',NULL,' ','337','22358',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('497','1013 Tabuk Boulevard',NULL,' ','261','96203',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('498','319 Plock Parkway',NULL,' ','504','26101',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('499','1954 Kowloon and New Kowloon Way',NULL,' ','434','63667',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('500','362 Rajkot Lane',NULL,' ','47','98030',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('501','1060 Tandil Lane',NULL,' ','432','72349',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('502','1515 Korla Way',NULL,' ','589','57197',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('503','1416 San Juan Bautista Tuxtepec Avenue',NULL,' ','444','50592',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('504','1 Valle de Santiago Avenue',NULL,' ','93','86208',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('505','519 Brescia Parkway',NULL,' ','318','69504',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('506','414 Mandaluyong Street',NULL,' ','314','16370',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('507','1197 Sokoto Boulevard',NULL,' ','478','87687',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('508','496 Celaya Drive',NULL,' ','552','90797',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('509','786 Matsue Way',NULL,' ','245','37469',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('510','48 Maracabo Place',NULL,' ','519','1570',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('511','1152 al-Qatif Lane',NULL,' ','412','44816',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('512','1269 Ipoh Avenue',NULL,' ','163','54674',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('513','758 Korolev Parkway',NULL,' ','568','75474',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('514','1747 Rustenburg Place',NULL,' ','110','51369',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('515','886 Tonghae Place',NULL,' ','259','19450',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('516','1574 Goinia Boulevard',NULL,' ','502','39529',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('517','548 Uruapan Street',NULL,' ','312','35653',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('519','962 Tama Loop',NULL,' ','583','65952',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('520','1778 Gijn Manor',NULL,' ','594','35156',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('521','568 Dhule (Dhulia) Loop',NULL,' ','127','92568',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('522','1768 Udine Loop',NULL,' ','60','32347',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('523','608 Birgunj Parkway',NULL,' ','116','400',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('524','680 A Corua (La Corua) Manor',NULL,' ','482','49806',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('525','1949 Sanya Street',NULL,' ','224','61244',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('526','617 Klerksdorp Place',NULL,' ','366','94707',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('527','1993 0 Loop',NULL,' ','588','41214',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('528','1176 Southend-on-Sea Manor',NULL,' ','458','81651',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('529','600 Purnea (Purnia) Avenue',NULL,' ','571','18043',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('530','1003 Qinhuangdao Street',NULL,' ','419','25972',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('531','1986 Sivas Place',NULL,' ','551','95775',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('532','1427 Tabuk Place',NULL,' ','101','31342',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('533','556 Asuncin Way',NULL,' ','339','35364',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('534','486 Ondo Parkway',NULL,' ','67','35202',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('535','635 Brest Manor',NULL,' ','75','40899',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('536','166 Jinchang Street',NULL,' ','165','86760',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('537','958 Sagamihara Lane',NULL,' ','287','88408',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('538','1817 Livorno Way',NULL,' ','100','79401',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('539','1332 Gaziantep Lane',NULL,' ','80','22813',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('540','949 Allende Lane',NULL,' ','24','67521',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('541','195 Ilorin Street',NULL,' ','363','49250',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('542','193 Bhusawal Place',NULL,' ','539','9750',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('543','43 Vilnius Manor',NULL,' ','42','79814',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('544','183 Haiphong Street',NULL,' ','46','69953',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('545','163 Augusta-Richmond County Loop',NULL,' ','561','33030',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('546','191 Jos Azueta Parkway',NULL,' ','436','13629',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('547','379 Lublin Parkway',NULL,' ','309','74568',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('548','1658 Cuman Loop',NULL,' ','396','51309',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('549','454 Qinhuangdao Drive',NULL,' ','68','25866',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('550','1715 Okayama Street',NULL,' ','485','55676',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('551','182 Nukualofa Drive',NULL,' ','275','15414',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('552','390 Wroclaw Way',NULL,' ','462','5753',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('553','1421 Quilmes Lane',NULL,' ','260','19151',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('554','947 Trshavn Place',NULL,' ','528','841',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('555','1764 Jalib al-Shuyukh Parkway',NULL,' ','459','77642',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('556','346 Cam Ranh Avenue',NULL,' ','599','39976',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('557','1407 Pachuca de Soto Place',NULL,' ','21','26284',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('558','904 Clarksville Drive',NULL,' ','193','52234',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('559','1917 Kumbakonam Parkway',NULL,' ','368','11892',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('560','1447 Imus Place',NULL,' ','426','12905',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('561','1497 Fengshan Drive',NULL,' ','112','63022',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('562','869 Shikarpur Way',NULL,' ','496','57380',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('563','1059 Yuncheng Avenue',NULL,' ','570','47498',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('564','505 Madiun Boulevard',NULL,' ','577','97271',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('565','1741 Hoshiarpur Boulevard',NULL,' ','79','22372',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('566','1229 Varanasi (Benares) Manor',NULL,' ','43','40195',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('567','1894 Boa Vista Way',NULL,' ','178','77464',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('568','1342 Sharja Way',NULL,' ','488','93655',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('569','1342 Abha Boulevard',NULL,' ','95','10714',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('570','415 Pune Avenue',NULL,' ','580','44274',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('571','1746 Faaa Way',NULL,' ','214','32515',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('572','539 Hami Way',NULL,' ','538','52196',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('573','1407 Surakarta Manor',NULL,' ','466','33224',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('574','502 Mandi Bahauddin Parkway',NULL,' ','55','15992',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('575','1052 Pathankot Avenue',NULL,' ','299','77397',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('576','1351 Sousse Lane',NULL,' ','341','37815',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('577','1501 Pangkal Pinang Avenue',NULL,' ','409','943',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('578','1405 Hagonoy Avenue',NULL,' ','133','86587',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('579','521 San Juan Bautista Tuxtepec Place',NULL,' ','598','95093',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('580','923 Tangail Boulevard',NULL,' ','10','33384',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('581','186 Skikda Lane',NULL,' ','131','89422',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('582','1568 Celaya Parkway',NULL,' ','168','34750',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('583','1489 Kakamigahara Lane',NULL,' ','526','98883',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('584','1819 Alessandria Loop',NULL,' ','103','53829',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('585','1208 Tama Loop',NULL,' ','344','73605',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('586','951 Springs Lane',NULL,' ','219','96115',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('587','760 Miyakonojo Drive',NULL,' ','246','64682',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('588','966 Asuncin Way',NULL,' ','212','62703',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('589','1584 Ljubertsy Lane',NULL,' ','494','22954',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('590','247 Jining Parkway',NULL,' ','54','53446',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('591','773 Dallas Manor',NULL,' ','424','12664',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('592','1923 Stara Zagora Lane',NULL,' ','546','95179',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('593','1402 Zanzibar Boulevard',NULL,' ','106','71102',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('594','1464 Kursk Parkway',NULL,' ','574','17381',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('595','1074 Sanaa Parkway',NULL,' ','311','22474',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('596','1759 Niznekamsk Avenue',NULL,' ','14','39414',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('597','32 Liaocheng Way',NULL,' ','248','1944',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('598','42 Fontana Avenue',NULL,' ','512','14684',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('599','1895 Zhezqazghan Drive',NULL,' ','177','36693',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('600','1837 Kaduna Parkway',NULL,' ','241','82580',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('601','844 Bucuresti Place',NULL,' ','242','36603',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('602','1101 Bucuresti Boulevard',NULL,' ','401','97661',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('603','1103 Quilmes Boulevard',NULL,' ','503','52137',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('604','1331 Usak Boulevard',NULL,' ','296','61960',' ','2006-02-15T04:45:30.000')
;
Insert into address
 (address_id,address,address2,district,city_id,postal_code,phone,last_update)
Values
 ('605','1325 Fukuyama Street',NULL,' ','537','27107',' ','2006-02-15T04:45:30.000')
;
SET IDENTITY_INSERT address OFF

-- End of Script
--
--
-- Automatically generated by Advanced ETl Processor
-- http://www.etl-tools.com/
-- table country
-- Start of script

SET IDENTITY_INSERT actor ON

Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('1','PENELOPE','GUINESS','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('2','NICK','WAHLBERG','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('3','ED','CHASE','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('4','JENNIFER','DAVIS','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('5','JOHNNY','LOLLOBRIGIDA','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('6','BETTE','NICHOLSON','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('7','GRACE','MOSTEL','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('8','MATTHEW','JOHANSSON','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('9','JOE','SWANK','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('10','CHRISTIAN','GABLE','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('11','ZERO','CAGE','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('12','KARL','BERRY','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('13','UMA','WOOD','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('14','VIVIEN','BERGEN','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('15','CUBA','OLIVIER','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('16','FRED','COSTNER','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('17','HELEN','VOIGHT','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('18','DAN','TORN','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('19','BOB','FAWCETT','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('20','LUCILLE','TRACY','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('21','KIRSTEN','PALTROW','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('22','ELVIS','MARX','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('23','SANDRA','KILMER','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('24','CAMERON','STREEP','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('25','KEVIN','BLOOM','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('26','RIP','CRAWFORD','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('27','JULIA','MCQUEEN','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('28','WOODY','HOFFMAN','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('29','ALEC','WAYNE','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('30','SANDRA','PECK','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('31','SISSY','SOBIESKI','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('32','TIM','HACKMAN','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('33','MILLA','PECK','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('34','AUDREY','OLIVIER','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('35','JUDY','DEAN','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('36','BURT','DUKAKIS','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('37','VAL','BOLGER','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('38','TOM','MCKELLEN','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('39','GOLDIE','BRODY','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('40','JOHNNY','CAGE','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('41','JODIE','DEGENERES','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('42','TOM','MIRANDA','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('43','KIRK','JOVOVICH','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('44','NICK','STALLONE','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('45','REESE','KILMER','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('46','PARKER','GOLDBERG','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('47','JULIA','BARRYMORE','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('48','FRANCES','DAY-LEWIS','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('49','ANNE','CRONYN','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('50','NATALIE','HOPKINS','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('51','GARY','PHOENIX','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('52','CARMEN','HUNT','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('53','MENA','TEMPLE','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('54','PENELOPE','PINKETT','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('55','FAY','KILMER','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('56','DAN','HARRIS','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('57','JUDE','CRUISE','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('58','CHRISTIAN','AKROYD','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('59','DUSTIN','TAUTOU','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('60','HENRY','BERRY','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('61','CHRISTIAN','NEESON','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('62','JAYNE','NEESON','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('63','CAMERON','WRAY','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('64','RAY','JOHANSSON','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('65','ANGELA','HUDSON','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('66','MARY','TANDY','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('67','JESSICA','BAILEY','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('68','RIP','WINSLET','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('69','KENNETH','PALTROW','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('70','MICHELLE','MCCONAUGHEY','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('71','ADAM','GRANT','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('72','SEAN','WILLIAMS','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('73','GARY','PENN','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('74','MILLA','KEITEL','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('75','BURT','POSEY','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('76','ANGELINA','ASTAIRE','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('77','CARY','MCCONAUGHEY','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('78','GROUCHO','SINATRA','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('79','MAE','HOFFMAN','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('80','RALPH','CRUZ','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('81','SCARLETT','DAMON','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('82','WOODY','JOLIE','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('83','BEN','WILLIS','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('84','JAMES','PITT','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('85','MINNIE','ZELLWEGER','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('86','GREG','CHAPLIN','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('87','SPENCER','PECK','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('88','KENNETH','PESCI','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('89','CHARLIZE','DENCH','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('90','SEAN','GUINESS','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('91','CHRISTOPHER','BERRY','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('92','KIRSTEN','AKROYD','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('93','ELLEN','PRESLEY','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('94','KENNETH','TORN','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('95','DARYL','WAHLBERG','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('96','GENE','WILLIS','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('97','MEG','HAWKE','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('98','CHRIS','BRIDGES','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('99','JIM','MOSTEL','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('100','SPENCER','DEPP','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('101','SUSAN','DAVIS','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('102','WALTER','TORN','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('103','MATTHEW','LEIGH','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('104','PENELOPE','CRONYN','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('105','SIDNEY','CROWE','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('106','GROUCHO','DUNST','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('107','GINA','DEGENERES','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('108','WARREN','NOLTE','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('109','SYLVESTER','DERN','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('110','SUSAN','DAVIS','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('111','CAMERON','ZELLWEGER','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('112','RUSSELL','BACALL','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('113','MORGAN','HOPKINS','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('114','MORGAN','MCDORMAND','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('115','HARRISON','BALE','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('116','DAN','STREEP','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('117','RENEE','TRACY','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('118','CUBA','ALLEN','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('119','WARREN','JACKMAN','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('120','PENELOPE','MONROE','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('121','LIZA','BERGMAN','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('122','SALMA','NOLTE','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('123','JULIANNE','DENCH','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('124','SCARLETT','BENING','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('125','ALBERT','NOLTE','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('126','FRANCES','TOMEI','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('127','KEVIN','GARLAND','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('128','CATE','MCQUEEN','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('129','DARYL','CRAWFORD','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('130','GRETA','KEITEL','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('131','JANE','JACKMAN','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('132','ADAM','HOPPER','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('133','RICHARD','PENN','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('134','GENE','HOPKINS','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('135','RITA','REYNOLDS','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('136','ED','MANSFIELD','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('137','MORGAN','WILLIAMS','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('138','LUCILLE','DEE','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('139','EWAN','GOODING','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('140','WHOOPI','HURT','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('141','CATE','HARRIS','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('142','JADA','RYDER','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('143','RIVER','DEAN','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('144','ANGELA','WITHERSPOON','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('145','KIM','ALLEN','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('146','ALBERT','JOHANSSON','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('147','FAY','WINSLET','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('148','EMILY','DEE','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('149','RUSSELL','TEMPLE','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('150','JAYNE','NOLTE','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('151','GEOFFREY','HESTON','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('152','BEN','HARRIS','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('153','MINNIE','KILMER','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('154','MERYL','GIBSON','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('155','IAN','TANDY','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('156','FAY','WOOD','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('157','GRETA','MALDEN','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('158','VIVIEN','BASINGER','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('159','LAURA','BRODY','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('160','CHRIS','DEPP','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('161','HARVEY','HOPE','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('162','OPRAH','KILMER','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('163','CHRISTOPHER','WEST','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('164','HUMPHREY','WILLIS','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('165','AL','GARLAND','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('166','NICK','DEGENERES','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('167','LAURENCE','BULLOCK','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('168','WILL','WILSON','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('169','KENNETH','HOFFMAN','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('170','MENA','HOPPER','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('171','OLYMPIA','PFEIFFER','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('172','GROUCHO','WILLIAMS','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('173','ALAN','DREYFUSS','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('174','MICHAEL','BENING','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('175','WILLIAM','HACKMAN','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('176','JON','CHASE','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('177','GENE','MCKELLEN','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('178','LISA','MONROE','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('179','ED','GUINESS','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('180','JEFF','SILVERSTONE','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('181','MATTHEW','CARREY','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('182','DEBBIE','AKROYD','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('183','RUSSELL','CLOSE','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('184','HUMPHREY','GARLAND','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('185','MICHAEL','BOLGER','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('186','JULIA','ZELLWEGER','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('187','RENEE','BALL','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('188','ROCK','DUKAKIS','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('189','CUBA','BIRCH','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('190','AUDREY','BAILEY','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('191','GREGORY','GOODING','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('192','JOHN','SUVARI','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('193','BURT','TEMPLE','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('194','MERYL','ALLEN','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('195','JAYNE','SILVERSTONE','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('196','BELA','WALKEN','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('197','REESE','WEST','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('198','MARY','KEITEL','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('199','JULIA','FAWCETT','2006-02-15T04:34:33.000')
;
Insert into actor
 (actor_id,first_name,last_name,last_update)
Values
('200','THORA','TEMPLE','2006-02-15T04:34:33.000')
;
SET IDENTITY_INSERT actor OFF

-- End of Script
--
--
-- Automatically generated by Advanced ETl Processor
-- http://www.etl-tools.com/
-- table country
-- Start of script

SET IDENTITY_INSERT staff ON

Insert into staff
 (staff_id,first_name,last_name,address_id,picture,email,store_id,active,username,password,last_update)
Values
 ('1','Mike','Hillyer','3',NULL,'Mike.Hillyer@sakilastaff.com','1','1','Mike','8cb2237d0679ca88db6464eac60da96345513964','2006-02-15T04:57:16.000')
;
Insert into staff
 (staff_id,first_name,last_name,address_id,picture,email,store_id,active,username,password,last_update)
Values
 ('2','Jon','Stephens','4',NULL,'Jon.Stephens@sakilastaff.com','2','1','Jon','8cb2237d0679ca88db6464eac60da96345513964','2006-02-15T04:57:16.000')
;
SET IDENTITY_INSERT staff OFF

-- End of Script
--
--
-- Automatically generated by Advanced ETl Processor
-- http://www.etl-tools.com/
-- table country
-- Start of script

SET IDENTITY_INSERT store ON

Insert into store
 (store_id,manager_staff_id,address_id,last_update)
Values
('1','1','1','2006-02-15T04:57:12.000')
;
Insert into store
 (store_id,manager_staff_id,address_id,last_update)
Values
('2','2','2','2006-02-15T04:57:12.000')
;
SET IDENTITY_INSERT store OFF

-- End of Script
--
--
-- Automatically generated by Advanced ETl Processor
-- http://www.etl-tools.com/
-- table country
-- Start of script

SET IDENTITY_INSERT category ON

Insert into category
 (category_id,name,last_update)
Values
('1','Action','2006-02-15T04:46:27.000')
;
Insert into category
 (category_id,name,last_update)
Values
('2','Animation','2006-02-15T04:46:27.000')
;
Insert into category
 (category_id,name,last_update)
Values
('3','Children','2006-02-15T04:46:27.000')
;
Insert into category
 (category_id,name,last_update)
Values
('4','Classics','2006-02-15T04:46:27.000')
;
Insert into category
 (category_id,name,last_update)
Values
('5','Comedy','2006-02-15T04:46:27.000')
;
Insert into category
 (category_id,name,last_update)
Values
('6','Documentary','2006-02-15T04:46:27.000')
;
Insert into category
 (category_id,name,last_update)
Values
('7','Drama','2006-02-15T04:46:27.000')
;
Insert into category
 (category_id,name,last_update)
Values
('8','Family','2006-02-15T04:46:27.000')
;
Insert into category
 (category_id,name,last_update)
Values
('9','Foreign','2006-02-15T04:46:27.000')
;
Insert into category
 (category_id,name,last_update)
Values
('10','Games','2006-02-15T04:46:27.000')
;
Insert into category
 (category_id,name,last_update)
Values
('11','Horror','2006-02-15T04:46:27.000')
;
Insert into category
 (category_id,name,last_update)
Values
('12','Music','2006-02-15T04:46:27.000')
;
Insert into category
 (category_id,name,last_update)
Values
('13','New','2006-02-15T04:46:27.000')
;
Insert into category
 (category_id,name,last_update)
Values
('14','Sci-Fi','2006-02-15T04:46:27.000')
;
Insert into category
 (category_id,name,last_update)
Values
('15','Sports','2006-02-15T04:46:27.000')
;
Insert into category
 (category_id,name,last_update)
Values
('16','Travel','2006-02-15T04:46:27.000')
;
SET IDENTITY_INSERT category OFF

-- End of Script
--
--
-- Automatically generated by Advanced ETl Processor
-- http://www.etl-tools.com/
-- table country
-- Start of script

SET IDENTITY_INSERT film ON

Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('1','ACADEMY DINOSAUR','A Epic Drama of a Feminist And a Mad Scientist who must Battle a Teacher in The Canadian Rockies','2006','1',NULL,'6','0.99','86','20.99','PG','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('2','ACE GOLDFINGER','A Astounding Epistle of a Database Administrator And a Explorer who must Find a Car in Ancient China','2006','1',NULL,'3','4.99','48','12.99','G','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('3','ADAPTATION HOLES','A Astounding Reflection of a Lumberjack And a Car who must Sink a Lumberjack in A Baloon Factory','2006','1',NULL,'7','2.99','50','18.99','NC-17','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('4','AFFAIR PREJUDICE','A Fanciful Documentary of a Frisbee And a Lumberjack who must Chase a Monkey in A Shark Tank','2006','1',NULL,'5','2.99','117','26.99','G','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('5','AFRICAN EGG','A Fast-Paced Documentary of a Pastry Chef And a Dentist who must Pursue a Forensic Psychologist in The Gulf of Mexico','2006','1',NULL,'6','2.99','130','22.99','G','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('6','AGENT TRUMAN','A Intrepid Panorama of a Robot And a Boy who must Escape a Sumo Wrestler in Ancient China','2006','1',NULL,'3','2.99','169','17.99','PG','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('7','AIRPLANE SIERRA','A Touching Saga of a Hunter And a Butler who must Discover a Butler in A Jet Boat','2006','1',NULL,'6','4.99','62','28.99','PG-13','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('8','AIRPORT POLLOCK','A Epic Tale of a Moose And a Girl who must Confront a Monkey in Ancient India','2006','1',NULL,'6','4.99','54','15.99','R','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('9','ALABAMA DEVIL','A Thoughtful Panorama of a Database Administrator And a Mad Scientist who must Outgun a Mad Scientist in A Jet Boat','2006','1',NULL,'3','2.99','114','21.99','PG-13','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('10','ALADDIN CALENDAR','A Action-Packed Tale of a Man And a Lumberjack who must Reach a Feminist in Ancient China','2006','1',NULL,'6','4.99','63','24.99','NC-17','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('11','ALAMO VIDEOTAPE','A Boring Epistle of a Butler And a Cat who must Fight a Pastry Chef in A MySQL Convention','2006','1',NULL,'6','0.99','126','16.99','G','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('12','ALASKA PHANTOM','A Fanciful Saga of a Hunter And a Pastry Chef who must Vanquish a Boy in Australia','2006','1',NULL,'6','0.99','136','22.99','PG','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('13','ALI FOREVER','A Action-Packed Drama of a Dentist And a Crocodile who must Battle a Feminist in The Canadian Rockies','2006','1',NULL,'4','4.99','150','21.99','PG','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('14','ALICE FANTASIA','A Emotional Drama of a A Shark And a Database Administrator who must Vanquish a Pioneer in Soviet Georgia','2006','1',NULL,'6','0.99','94','23.99','NC-17','Trailers,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('15','ALIEN CENTER','A Brilliant Drama of a Cat And a Mad Scientist who must Battle a Feminist in A MySQL Convention','2006','1',NULL,'5','2.99','46','10.99','NC-17','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('16','ALLEY EVOLUTION','A Fast-Paced Drama of a Robot And a Composer who must Battle a Astronaut in New Orleans','2006','1',NULL,'6','2.99','180','23.99','NC-17','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('17','ALONE TRIP','A Fast-Paced Character Study of a Composer And a Dog who must Outgun a Boat in An Abandoned Fun House','2006','1',NULL,'3','0.99','82','14.99','R','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('18','ALTER VICTORY','A Thoughtful Drama of a Composer And a Feminist who must Meet a Secret Agent in The Canadian Rockies','2006','1',NULL,'6','0.99','57','27.99','PG-13','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('19','AMADEUS HOLY','A Emotional Display of a Pioneer And a Technical Writer who must Battle a Man in A Baloon','2006','1',NULL,'6','0.99','113','20.99','PG','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('20','AMELIE HELLFIGHTERS','A Boring Drama of a Woman And a Squirrel who must Conquer a Student in A Baloon','2006','1',NULL,'4','4.99','79','23.99','R','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('21','AMERICAN CIRCUS','A Insightful Drama of a Girl And a Astronaut who must Face a Database Administrator in A Shark Tank','2006','1',NULL,'3','4.99','129','17.99','R','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('22','AMISTAD MIDSUMMER','A Emotional Character Study of a Dentist And a Crocodile who must Meet a Sumo Wrestler in California','2006','1',NULL,'6','2.99','85','10.99','G','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('23','ANACONDA CONFESSIONS','A Lacklusture Display of a Dentist And a Dentist who must Fight a Girl in Australia','2006','1',NULL,'3','0.99','92','9.99','R','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('24','ANALYZE HOOSIERS','A Thoughtful Display of a Explorer And a Pastry Chef who must Overcome a Feminist in The Sahara Desert','2006','1',NULL,'6','2.99','181','19.99','R','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('25','ANGELS LIFE','A Thoughtful Display of a Woman And a Astronaut who must Battle a Robot in Berlin','2006','1',NULL,'3','2.99','74','15.99','G','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('26','ANNIE IDENTITY','A Amazing Panorama of a Pastry Chef And a Boat who must Escape a Woman in An Abandoned Amusement Park','2006','1',NULL,'3','0.99','86','15.99','G','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('27','ANONYMOUS HUMAN','A Amazing Reflection of a Database Administrator And a Astronaut who must Outrace a Database Administrator in A Shark Tank','2006','1',NULL,'7','0.99','179','12.99','NC-17','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('28','ANTHEM LUKE','A Touching Panorama of a Waitress And a Woman who must Outrace a Dog in An Abandoned Amusement Park','2006','1',NULL,'5','4.99','91','16.99','PG-13','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('29','ANTITRUST TOMATOES','A Fateful Yarn of a Womanizer And a Feminist who must Succumb a Database Administrator in Ancient India','2006','1',NULL,'5','2.99','168','11.99','NC-17','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('30','ANYTHING SAVANNAH','A Epic Story of a Pastry Chef And a Woman who must Chase a Feminist in An Abandoned Fun House','2006','1',NULL,'4','2.99','82','27.99','R','Trailers,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('31','APACHE DIVINE','A Awe-Inspiring Reflection of a Pastry Chef And a Teacher who must Overcome a Sumo Wrestler in A U-Boat','2006','1',NULL,'5','4.99','92','16.99','NC-17','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('32','APOCALYPSE FLAMINGOS','A Astounding Story of a Dog And a Squirrel who must Defeat a Woman in An Abandoned Amusement Park','2006','1',NULL,'6','4.99','119','11.99','R','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('33','APOLLO TEEN','A Action-Packed Reflection of a Crocodile And a Explorer who must Find a Sumo Wrestler in An Abandoned Mine Shaft','2006','1',NULL,'5','2.99','153','15.99','PG-13','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('34','ARABIA DOGMA','A Touching Epistle of a Madman And a Mad Cow who must Defeat a Student in Nigeria','2006','1',NULL,'6','0.99','62','29.99','NC-17','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('35','ARACHNOPHOBIA ROLLERCOASTER','A Action-Packed Reflection of a Pastry Chef And a Composer who must Discover a Mad Scientist in The First Manned Space Station','2006','1',NULL,'4','2.99','147','24.99','PG-13','Trailers,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('36','ARGONAUTS TOWN','A Emotional Epistle of a Forensic Psychologist And a Butler who must Challenge a Waitress in An Abandoned Mine Shaft','2006','1',NULL,'7','0.99','127','12.99','PG-13','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('37','ARIZONA BANG','A Brilliant Panorama of a Mad Scientist And a Mad Cow who must Meet a Pioneer in A Monastery','2006','1',NULL,'3','2.99','121','28.99','PG','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('38','ARK RIDGEMONT','A Beautiful Yarn of a Pioneer And a Monkey who must Pursue a Explorer in The Sahara Desert','2006','1',NULL,'6','0.99','68','25.99','NC-17','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('39','ARMAGEDDON LOST','A Fast-Paced Tale of a Boat And a Teacher who must Succumb a Composer in An Abandoned Mine Shaft','2006','1',NULL,'5','0.99','99','10.99','G','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('40','ARMY FLINTSTONES','A Boring Saga of a Database Administrator And a Womanizer who must Battle a Waitress in Nigeria','2006','1',NULL,'4','0.99','148','22.99','R','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('41','ARSENIC INDEPENDENCE','A Fanciful Documentary of a Mad Cow And a Womanizer who must Find a Dentist in Berlin','2006','1',NULL,'4','0.99','137','17.99','PG','Trailers,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('42','ARTIST COLDBLOODED','A Stunning Reflection of a Robot And a Moose who must Challenge a Woman in California','2006','1',NULL,'5','2.99','170','10.99','NC-17','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('43','ATLANTIS CAUSE','A Thrilling Yarn of a Feminist And a Hunter who must Fight a Technical Writer in A Shark Tank','2006','1',NULL,'6','2.99','170','15.99','G','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('44','ATTACKS HATE','A Fast-Paced Panorama of a Technical Writer And a Mad Scientist who must Find a Feminist in An Abandoned Mine Shaft','2006','1',NULL,'5','4.99','113','21.99','PG-13','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('45','ATTRACTION NEWTON','A Astounding Panorama of a Composer And a Frisbee who must Reach a Husband in Ancient Japan','2006','1',NULL,'5','4.99','83','14.99','PG-13','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('46','AUTUMN CROW','A Beautiful Tale of a Dentist And a Mad Cow who must Battle a Moose in The Sahara Desert','2006','1',NULL,'3','4.99','108','13.99','G','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('47','BABY HALL','A Boring Character Study of a A Shark And a Girl who must Outrace a Feminist in An Abandoned Mine Shaft','2006','1',NULL,'5','4.99','153','23.99','NC-17','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('48','BACKLASH UNDEFEATED','A Stunning Character Study of a Mad Scientist And a Mad Cow who must Kill a Car in A Monastery','2006','1',NULL,'3','4.99','118','24.99','PG-13','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('49','BADMAN DAWN','A Emotional Panorama of a Pioneer And a Composer who must Escape a Mad Scientist in A Jet Boat','2006','1',NULL,'6','2.99','162','22.99','R','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('50','BAKED CLEOPATRA','A Stunning Drama of a Forensic Psychologist And a Husband who must Overcome a Waitress in A Monastery','2006','1',NULL,'3','2.99','182','20.99','G','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('51','BALLOON HOMEWARD','A Insightful Panorama of a Forensic Psychologist And a Mad Cow who must Build a Mad Scientist in The First Manned Space Station','2006','1',NULL,'5','2.99','75','10.99','NC-17','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('52','BALLROOM MOCKINGBIRD','A Thrilling Documentary of a Composer And a Monkey who must Find a Feminist in California','2006','1',NULL,'6','0.99','173','29.99','G','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('53','BANG KWAI','A Epic Drama of a Madman And a Cat who must Face a A Shark in An Abandoned Amusement Park','2006','1',NULL,'5','2.99','87','25.99','NC-17','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('54','BANGER PINOCCHIO','A Awe-Inspiring Drama of a Car And a Pastry Chef who must Chase a Crocodile in The First Manned Space Station','2006','1',NULL,'5','0.99','113','15.99','R','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('55','BARBARELLA STREETCAR','A Awe-Inspiring Story of a Feminist And a Cat who must Conquer a Dog in A Monastery','2006','1',NULL,'6','2.99','65','27.99','G','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('56','BAREFOOT MANCHURIAN','A Intrepid Story of a Cat And a Student who must Vanquish a Girl in An Abandoned Amusement Park','2006','1',NULL,'6','2.99','129','15.99','G','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('57','BASIC EASY','A Stunning Epistle of a Man And a Husband who must Reach a Mad Scientist in A Jet Boat','2006','1',NULL,'4','2.99','90','18.99','PG-13','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('58','BEACH HEARTBREAKERS','A Fateful Display of a Womanizer And a Mad Scientist who must Outgun a A Shark in Soviet Georgia','2006','1',NULL,'6','2.99','122','16.99','G','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('59','BEAR GRACELAND','A Astounding Saga of a Dog And a Boy who must Kill a Teacher in The First Manned Space Station','2006','1',NULL,'4','2.99','160','20.99','R','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('60','BEAST HUNCHBACK','A Awe-Inspiring Epistle of a Student And a Squirrel who must Defeat a Boy in Ancient China','2006','1',NULL,'3','4.99','89','22.99','R','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('61','BEAUTY GREASE','A Fast-Paced Display of a Composer And a Moose who must Sink a Robot in An Abandoned Mine Shaft','2006','1',NULL,'5','4.99','175','28.99','G','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('62','BED HIGHBALL','A Astounding Panorama of a Lumberjack And a Dog who must Redeem a Woman in An Abandoned Fun House','2006','1',NULL,'5','2.99','106','23.99','NC-17','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('63','BEDAZZLED MARRIED','A Astounding Character Study of a Madman And a Robot who must Meet a Mad Scientist in An Abandoned Fun House','2006','1',NULL,'6','0.99','73','21.99','PG','Trailers,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('64','BEETHOVEN EXORCIST','A Epic Display of a Pioneer And a Student who must Challenge a Butler in The Gulf of Mexico','2006','1',NULL,'6','0.99','151','26.99','PG-13','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('65','BEHAVIOR RUNAWAY','A Unbelieveable Drama of a Student And a Husband who must Outrace a Sumo Wrestler in Berlin','2006','1',NULL,'3','4.99','100','20.99','PG','Trailers,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('66','BENEATH RUSH','A Astounding Panorama of a Man And a Monkey who must Discover a Man in The First Manned Space Station','2006','1',NULL,'6','0.99','53','27.99','NC-17','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('67','BERETS AGENT','A Taut Saga of a Crocodile And a Boy who must Overcome a Technical Writer in Ancient China','2006','1',NULL,'5','2.99','77','24.99','PG-13','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('68','BETRAYED REAR','A Emotional Character Study of a Boat And a Pioneer who must Find a Explorer in A Shark Tank','2006','1',NULL,'5','4.99','122','26.99','NC-17','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('69','BEVERLY OUTLAW','A Fanciful Documentary of a Womanizer And a Boat who must Defeat a Madman in The First Manned Space Station','2006','1',NULL,'3','2.99','85','21.99','R','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('70','BIKINI BORROWERS','A Astounding Drama of a Astronaut And a Cat who must Discover a Woman in The First Manned Space Station','2006','1',NULL,'7','4.99','142','26.99','NC-17','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('71','BILKO ANONYMOUS','A Emotional Reflection of a Teacher And a Man who must Meet a Cat in The First Manned Space Station','2006','1',NULL,'3','4.99','100','25.99','PG-13','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('72','BILL OTHERS','A Stunning Saga of a Mad Scientist And a Forensic Psychologist who must Challenge a Squirrel in A MySQL Convention','2006','1',NULL,'6','2.99','93','12.99','PG','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('73','BINGO TALENTED','A Touching Tale of a Girl And a Crocodile who must Discover a Waitress in Nigeria','2006','1',NULL,'5','2.99','150','22.99','PG-13','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('74','BIRCH ANTITRUST','A Fanciful Panorama of a Husband And a Pioneer who must Outgun a Dog in A Baloon','2006','1',NULL,'4','4.99','162','18.99','PG','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('75','BIRD INDEPENDENCE','A Thrilling Documentary of a Car And a Student who must Sink a Hunter in The Canadian Rockies','2006','1',NULL,'6','4.99','163','14.99','G','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('76','BIRDCAGE CASPER','A Fast-Paced Saga of a Frisbee And a Astronaut who must Overcome a Feminist in Ancient India','2006','1',NULL,'4','0.99','103','23.99','NC-17','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('77','BIRDS PERDITION','A Boring Story of a Womanizer And a Pioneer who must Face a Dog in California','2006','1',NULL,'5','4.99','61','15.99','G','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('78','BLACKOUT PRIVATE','A Intrepid Yarn of a Pastry Chef And a Mad Scientist who must Challenge a Secret Agent in Ancient Japan','2006','1',NULL,'7','2.99','85','12.99','PG','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('79','BLADE POLISH','A Thoughtful Character Study of a Frisbee And a Pastry Chef who must Fight a Dentist in The First Manned Space Station','2006','1',NULL,'5','0.99','114','10.99','PG-13','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('80','BLANKET BEVERLY','A Emotional Documentary of a Student And a Girl who must Build a Boat in Nigeria','2006','1',NULL,'7','2.99','148','21.99','G','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('81','BLINDNESS GUN','A Touching Drama of a Robot And a Dentist who must Meet a Hunter in A Jet Boat','2006','1',NULL,'6','4.99','103','29.99','PG-13','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('82','BLOOD ARGONAUTS','A Boring Drama of a Explorer And a Man who must Kill a Lumberjack in A Manhattan Penthouse','2006','1',NULL,'3','0.99','71','13.99','G','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('83','BLUES INSTINCT','A Insightful Documentary of a Boat And a Composer who must Meet a Forensic Psychologist in An Abandoned Fun House','2006','1',NULL,'5','2.99','50','18.99','G','Trailers,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('84','BOILED DARES','A Awe-Inspiring Story of a Waitress And a Dog who must Discover a Dentist in Ancient Japan','2006','1',NULL,'7','4.99','102','13.99','PG','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('85','BONNIE HOLOCAUST','A Fast-Paced Story of a Crocodile And a Robot who must Find a Moose in Ancient Japan','2006','1',NULL,'4','0.99','63','29.99','G','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('86','BOOGIE AMELIE','A Lacklusture Character Study of a Husband And a Sumo Wrestler who must Succumb a Technical Writer in The Gulf of Mexico','2006','1',NULL,'6','4.99','121','11.99','R','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('87','BOONDOCK BALLROOM','A Fateful Panorama of a Crocodile And a Boy who must Defeat a Monkey in The Gulf of Mexico','2006','1',NULL,'7','0.99','76','14.99','NC-17','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('88','BORN SPINAL','A Touching Epistle of a Frisbee And a Husband who must Pursue a Student in Nigeria','2006','1',NULL,'7','4.99','179','17.99','PG','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('89','BORROWERS BEDAZZLED','A Brilliant Epistle of a Teacher And a Sumo Wrestler who must Defeat a Man in An Abandoned Fun House','2006','1',NULL,'7','0.99','63','22.99','G','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('90','BOULEVARD MOB','A Fateful Epistle of a Moose And a Monkey who must Confront a Lumberjack in Ancient China','2006','1',NULL,'3','0.99','63','11.99','R','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('91','BOUND CHEAPER','A Thrilling Panorama of a Database Administrator And a Astronaut who must Challenge a Lumberjack in A Baloon','2006','1',NULL,'5','0.99','98','17.99','PG','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('92','BOWFINGER GABLES','A Fast-Paced Yarn of a Waitress And a Composer who must Outgun a Dentist in California','2006','1',NULL,'7','4.99','72','19.99','NC-17','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('93','BRANNIGAN SUNRISE','A Amazing Epistle of a Moose And a Crocodile who must Outrace a Dog in Berlin','2006','1',NULL,'4','4.99','121','27.99','PG','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('94','BRAVEHEART HUMAN','A Insightful Story of a Dog And a Pastry Chef who must Battle a Girl in Berlin','2006','1',NULL,'7','2.99','176','14.99','PG-13','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('95','BREAKFAST GOLDFINGER','A Beautiful Reflection of a Student And a Student who must Fight a Moose in Berlin','2006','1',NULL,'5','4.99','123','18.99','G','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('96','BREAKING HOME','A Beautiful Display of a Secret Agent And a Monkey who must Battle a Sumo Wrestler in An Abandoned Mine Shaft','2006','1',NULL,'4','2.99','169','21.99','PG-13','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('97','BRIDE INTRIGUE','A Epic Tale of a Robot And a Monkey who must Vanquish a Man in New Orleans','2006','1',NULL,'7','0.99','56','24.99','G','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('98','BRIGHT ENCOUNTERS','A Fateful Yarn of a Lumberjack And a Feminist who must Conquer a Student in A Jet Boat','2006','1',NULL,'4','4.99','73','12.99','PG-13','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('99','BRINGING HYSTERICAL','A Fateful Saga of a A Shark And a Technical Writer who must Find a Woman in A Jet Boat','2006','1',NULL,'7','2.99','136','14.99','PG','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('100','BROOKLYN DESERT','A Beautiful Drama of a Dentist And a Composer who must Battle a Sumo Wrestler in The First Manned Space Station','2006','1',NULL,'7','4.99','161','21.99','R','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('101','BROTHERHOOD BLANKET','A Fateful Character Study of a Butler And a Technical Writer who must Sink a Astronaut in Ancient Japan','2006','1',NULL,'3','0.99','73','26.99','R','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('102','BUBBLE GROSSE','A Awe-Inspiring Panorama of a Crocodile And a Moose who must Confront a Girl in A Baloon','2006','1',NULL,'4','4.99','60','20.99','R','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('103','BUCKET BROTHERHOOD','A Amazing Display of a Girl And a Womanizer who must Succumb a Lumberjack in A Baloon Factory','2006','1',NULL,'7','4.99','133','27.99','PG','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('104','BUGSY SONG','A Awe-Inspiring Character Study of a Secret Agent And a Boat who must Find a Squirrel in The First Manned Space Station','2006','1',NULL,'4','2.99','119','17.99','G','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('105','BULL SHAWSHANK','A Fanciful Drama of a Moose And a Squirrel who must Conquer a Pioneer in The Canadian Rockies','2006','1',NULL,'6','0.99','125','21.99','NC-17','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('106','BULWORTH COMMANDMENTS','A Amazing Display of a Mad Cow And a Pioneer who must Redeem a Sumo Wrestler in The Outback','2006','1',NULL,'4','2.99','61','14.99','G','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('107','BUNCH MINDS','A Emotional Story of a Feminist And a Feminist who must Escape a Pastry Chef in A MySQL Convention','2006','1',NULL,'4','2.99','63','13.99','G','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('108','BUTCH PANTHER','A Lacklusture Yarn of a Feminist And a Database Administrator who must Face a Hunter in New Orleans','2006','1',NULL,'6','0.99','67','19.99','PG-13','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('109','BUTTERFLY CHOCOLAT','A Fateful Story of a Girl And a Composer who must Conquer a Husband in A Shark Tank','2006','1',NULL,'3','0.99','89','17.99','G','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('110','CABIN FLASH','A Stunning Epistle of a Boat And a Man who must Challenge a A Shark in A Baloon Factory','2006','1',NULL,'4','0.99','53','25.99','NC-17','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('111','CADDYSHACK JEDI','A Awe-Inspiring Epistle of a Woman And a Madman who must Fight a Robot in Soviet Georgia','2006','1',NULL,'3','0.99','52','17.99','NC-17','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('112','CALENDAR GUNFIGHT','A Thrilling Drama of a Frisbee And a Lumberjack who must Sink a Man in Nigeria','2006','1',NULL,'4','4.99','120','22.99','NC-17','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('113','CALIFORNIA BIRDS','A Thrilling Yarn of a Database Administrator And a Robot who must Battle a Database Administrator in Ancient India','2006','1',NULL,'4','4.99','75','19.99','NC-17','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('114','CAMELOT VACATION','A Touching Character Study of a Woman And a Waitress who must Battle a Pastry Chef in A MySQL Convention','2006','1',NULL,'3','0.99','61','26.99','NC-17','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('115','CAMPUS REMEMBER','A Astounding Drama of a Crocodile And a Mad Cow who must Build a Robot in A Jet Boat','2006','1',NULL,'5','2.99','167','27.99','R','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('116','CANDIDATE PERDITION','A Brilliant Epistle of a Composer And a Database Administrator who must Vanquish a Mad Scientist in The First Manned Space Station','2006','1',NULL,'4','2.99','70','10.99','R','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('117','CANDLES GRAPES','A Fanciful Character Study of a Monkey And a Explorer who must Build a Astronaut in An Abandoned Fun House','2006','1',NULL,'6','4.99','135','15.99','NC-17','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('118','CANYON STOCK','A Thoughtful Reflection of a Waitress And a Feminist who must Escape a Squirrel in A Manhattan Penthouse','2006','1',NULL,'7','0.99','85','26.99','R','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('119','CAPER MOTIONS','A Fateful Saga of a Moose And a Car who must Pursue a Woman in A MySQL Convention','2006','1',NULL,'6','0.99','176','22.99','G','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('120','CARIBBEAN LIBERTY','A Fanciful Tale of a Pioneer And a Technical Writer who must Outgun a Pioneer in A Shark Tank','2006','1',NULL,'3','4.99','92','16.99','NC-17','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('121','CAROL TEXAS','A Astounding Character Study of a Composer And a Student who must Overcome a Composer in A Monastery','2006','1',NULL,'4','2.99','151','15.99','PG','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('122','CARRIE BUNCH','A Amazing Epistle of a Student And a Astronaut who must Discover a Frisbee in The Canadian Rockies','2006','1',NULL,'7','0.99','114','11.99','PG','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('123','CASABLANCA SUPER','A Amazing Panorama of a Crocodile And a Forensic Psychologist who must Pursue a Secret Agent in The First Manned Space Station','2006','1',NULL,'6','4.99','85','22.99','G','Trailers,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('124','CASPER DRAGONFLY','A Intrepid Documentary of a Boat And a Crocodile who must Chase a Robot in The Sahara Desert','2006','1',NULL,'3','4.99','163','16.99','PG-13','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('125','CASSIDY WYOMING','A Intrepid Drama of a Frisbee And a Hunter who must Kill a Secret Agent in New Orleans','2006','1',NULL,'5','2.99','61','19.99','NC-17','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('126','CASUALTIES ENCINO','A Insightful Yarn of a A Shark And a Pastry Chef who must Face a Boy in A Monastery','2006','1',NULL,'3','4.99','179','16.99','G','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('127','CAT CONEHEADS','A Fast-Paced Panorama of a Girl And a A Shark who must Confront a Boy in Ancient India','2006','1',NULL,'5','4.99','112','14.99','G','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('128','CATCH AMISTAD','A Boring Reflection of a Lumberjack And a Feminist who must Discover a Woman in Nigeria','2006','1',NULL,'7','0.99','183','10.99','G','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('129','CAUSE DATE','A Taut Tale of a Explorer And a Pastry Chef who must Conquer a Hunter in A MySQL Convention','2006','1',NULL,'3','2.99','179','16.99','R','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('130','CELEBRITY HORN','A Amazing Documentary of a Secret Agent And a Astronaut who must Vanquish a Hunter in A Shark Tank','2006','1',NULL,'7','0.99','110','24.99','PG-13','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('131','CENTER DINOSAUR','A Beautiful Character Study of a Sumo Wrestler And a Dentist who must Find a Dog in California','2006','1',NULL,'5','4.99','152','12.99','PG','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('132','CHAINSAW UPTOWN','A Beautiful Documentary of a Boy And a Robot who must Discover a Squirrel in Australia','2006','1',NULL,'6','0.99','114','25.99','PG','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('133','CHAMBER ITALIAN','A Fateful Reflection of a Moose And a Husband who must Overcome a Monkey in Nigeria','2006','1',NULL,'7','4.99','117','14.99','NC-17','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('134','CHAMPION FLATLINERS','A Amazing Story of a Mad Cow And a Dog who must Kill a Husband in A Monastery','2006','1',NULL,'4','4.99','51','21.99','PG','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('135','CHANCE RESURRECTION','A Astounding Story of a Forensic Psychologist And a Forensic Psychologist who must Overcome a Moose in Ancient China','2006','1',NULL,'3','2.99','70','22.99','R','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('136','CHAPLIN LICENSE','A Boring Drama of a Dog And a Forensic Psychologist who must Outrace a Explorer in Ancient India','2006','1',NULL,'7','2.99','146','26.99','NC-17','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('137','CHARADE DUFFEL','A Action-Packed Display of a Man And a Waitress who must Build a Dog in A MySQL Convention','2006','1',NULL,'3','2.99','66','21.99','PG','Trailers,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('138','CHARIOTS CONSPIRACY','A Unbelieveable Epistle of a Robot And a Husband who must Chase a Robot in The First Manned Space Station','2006','1',NULL,'5','2.99','71','29.99','R','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('139','CHASING FIGHT','A Astounding Saga of a Technical Writer And a Butler who must Battle a Butler in A Shark Tank','2006','1',NULL,'7','4.99','114','21.99','PG','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('140','CHEAPER CLYDE','A Emotional Character Study of a Pioneer And a Girl who must Discover a Dog in Ancient Japan','2006','1',NULL,'6','0.99','87','23.99','G','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('141','CHICAGO NORTH','A Fateful Yarn of a Mad Cow And a Waitress who must Battle a Student in California','2006','1',NULL,'6','4.99','185','11.99','PG-13','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('142','CHICKEN HELLFIGHTERS','A Emotional Drama of a Dog And a Explorer who must Outrace a Technical Writer in Australia','2006','1',NULL,'3','0.99','122','24.99','PG','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('143','CHILL LUCK','A Lacklusture Epistle of a Boat And a Technical Writer who must Fight a A Shark in The Canadian Rockies','2006','1',NULL,'6','0.99','142','17.99','PG','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('144','CHINATOWN GLADIATOR','A Brilliant Panorama of a Technical Writer And a Lumberjack who must Escape a Butler in Ancient India','2006','1',NULL,'7','4.99','61','24.99','PG','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('145','CHISUM BEHAVIOR','A Epic Documentary of a Sumo Wrestler And a Butler who must Kill a Car in Ancient India','2006','1',NULL,'5','4.99','124','25.99','G','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('146','CHITTY LOCK','A Boring Epistle of a Boat And a Database Administrator who must Kill a Sumo Wrestler in The First Manned Space Station','2006','1',NULL,'6','2.99','107','24.99','G','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('147','CHOCOLAT HARRY','A Action-Packed Epistle of a Dentist And a Moose who must Meet a Mad Cow in Ancient Japan','2006','1',NULL,'5','0.99','101','16.99','NC-17','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('148','CHOCOLATE DUCK','A Unbelieveable Story of a Mad Scientist And a Technical Writer who must Discover a Composer in Ancient China','2006','1',NULL,'3','2.99','132','13.99','R','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('149','CHRISTMAS MOONSHINE','A Action-Packed Epistle of a Feminist And a Astronaut who must Conquer a Boat in A Manhattan Penthouse','2006','1',NULL,'7','0.99','150','21.99','NC-17','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('150','CIDER DESIRE','A Stunning Character Study of a Composer And a Mad Cow who must Succumb a Cat in Soviet Georgia','2006','1',NULL,'7','2.99','101','9.99','PG','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('151','CINCINATTI WHISPERER','A Brilliant Saga of a Pastry Chef And a Hunter who must Confront a Butler in Berlin','2006','1',NULL,'5','4.99','143','26.99','NC-17','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('152','CIRCUS YOUTH','A Thoughtful Drama of a Pastry Chef And a Dentist who must Pursue a Girl in A Baloon','2006','1',NULL,'5','2.99','90','13.99','PG-13','Trailers,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('153','CITIZEN SHREK','A Fanciful Character Study of a Technical Writer And a Husband who must Redeem a Robot in The Outback','2006','1',NULL,'7','0.99','165','18.99','G','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('154','CLASH FREDDY','A Amazing Yarn of a Composer And a Squirrel who must Escape a Astronaut in Australia','2006','1',NULL,'6','2.99','81','12.99','G','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('155','CLEOPATRA DEVIL','A Fanciful Documentary of a Crocodile And a Technical Writer who must Fight a A Shark in A Baloon','2006','1',NULL,'6','0.99','150','26.99','PG-13','Trailers,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('156','CLERKS ANGELS','A Thrilling Display of a Sumo Wrestler And a Girl who must Confront a Man in A Baloon','2006','1',NULL,'3','4.99','164','15.99','G','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('157','CLOCKWORK PARADISE','A Insightful Documentary of a Technical Writer And a Feminist who must Challenge a Cat in A Baloon','2006','1',NULL,'7','0.99','143','29.99','PG-13','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('158','CLONES PINOCCHIO','A Amazing Drama of a Car And a Robot who must Pursue a Dentist in New Orleans','2006','1',NULL,'6','2.99','124','16.99','R','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('159','CLOSER BANG','A Unbelieveable Panorama of a Frisbee And a Hunter who must Vanquish a Monkey in Ancient India','2006','1',NULL,'5','4.99','58','12.99','R','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('160','CLUB GRAFFITI','A Epic Tale of a Pioneer And a Hunter who must Escape a Girl in A U-Boat','2006','1',NULL,'4','0.99','65','12.99','PG-13','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('161','CLUE GRAIL','A Taut Tale of a Butler And a Mad Scientist who must Build a Crocodile in Ancient China','2006','1',NULL,'6','4.99','70','27.99','NC-17','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('162','CLUELESS BUCKET','A Taut Tale of a Car And a Pioneer who must Conquer a Sumo Wrestler in An Abandoned Fun House','2006','1',NULL,'4','2.99','95','13.99','R','Trailers,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('163','CLYDE THEORY','A Beautiful Yarn of a Astronaut And a Frisbee who must Overcome a Explorer in A Jet Boat','2006','1',NULL,'4','0.99','139','29.99','PG-13','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('164','COAST RAINBOW','A Astounding Documentary of a Mad Cow And a Pioneer who must Challenge a Butler in The Sahara Desert','2006','1',NULL,'4','0.99','55','20.99','PG','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('165','COLDBLOODED DARLING','A Brilliant Panorama of a Dentist And a Moose who must Find a Student in The Gulf of Mexico','2006','1',NULL,'7','4.99','70','27.99','G','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('166','COLOR PHILADELPHIA','A Thoughtful Panorama of a Car And a Crocodile who must Sink a Monkey in The Sahara Desert','2006','1',NULL,'6','2.99','149','19.99','G','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('167','COMA HEAD','A Awe-Inspiring Drama of a Boy And a Frisbee who must Escape a Pastry Chef in California','2006','1',NULL,'6','4.99','109','10.99','NC-17','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('168','COMANCHEROS ENEMY','A Boring Saga of a Lumberjack And a Monkey who must Find a Monkey in The Gulf of Mexico','2006','1',NULL,'5','0.99','67','23.99','R','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('169','COMFORTS RUSH','A Unbelieveable Panorama of a Pioneer And a Husband who must Meet a Mad Cow in An Abandoned Mine Shaft','2006','1',NULL,'3','2.99','76','19.99','NC-17','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('170','COMMAND DARLING','A Awe-Inspiring Tale of a Forensic Psychologist And a Woman who must Challenge a Database Administrator in Ancient Japan','2006','1',NULL,'5','4.99','120','28.99','PG-13','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('171','COMMANDMENTS EXPRESS','A Fanciful Saga of a Student And a Mad Scientist who must Battle a Hunter in An Abandoned Mine Shaft','2006','1',NULL,'6','4.99','59','13.99','R','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('172','CONEHEADS SMOOCHY','A Touching Story of a Womanizer And a Composer who must Pursue a Husband in Nigeria','2006','1',NULL,'7','4.99','112','12.99','NC-17','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('173','CONFESSIONS MAGUIRE','A Insightful Story of a Car And a Boy who must Battle a Technical Writer in A Baloon','2006','1',NULL,'7','4.99','65','25.99','PG-13','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('174','CONFIDENTIAL INTERVIEW','A Stunning Reflection of a Cat And a Woman who must Find a Astronaut in Ancient Japan','2006','1',NULL,'6','4.99','180','13.99','NC-17','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('175','CONFUSED CANDLES','A Stunning Epistle of a Cat And a Forensic Psychologist who must Confront a Pioneer in A Baloon','2006','1',NULL,'3','2.99','122','27.99','PG-13','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('176','CONGENIALITY QUEST','A Touching Documentary of a Cat And a Pastry Chef who must Find a Lumberjack in A Baloon','2006','1',NULL,'6','0.99','87','21.99','PG-13','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('177','CONNECTICUT TRAMP','A Unbelieveable Drama of a Crocodile And a Mad Cow who must Reach a Dentist in A Shark Tank','2006','1',NULL,'4','4.99','172','20.99','R','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('178','CONNECTION MICROCOSMOS','A Fateful Documentary of a Crocodile And a Husband who must Face a Husband in The First Manned Space Station','2006','1',NULL,'6','0.99','115','25.99','G','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('179','CONQUERER NUTS','A Taut Drama of a Mad Scientist And a Man who must Escape a Pioneer in An Abandoned Mine Shaft','2006','1',NULL,'4','4.99','173','14.99','G','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('180','CONSPIRACY SPIRIT','A Awe-Inspiring Story of a Student And a Frisbee who must Conquer a Crocodile in An Abandoned Mine Shaft','2006','1',NULL,'4','2.99','184','27.99','PG-13','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('181','CONTACT ANONYMOUS','A Insightful Display of a A Shark And a Monkey who must Face a Database Administrator in Ancient India','2006','1',NULL,'7','2.99','166','10.99','PG-13','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('182','CONTROL ANTHEM','A Fateful Documentary of a Robot And a Student who must Battle a Cat in A Monastery','2006','1',NULL,'7','4.99','185','9.99','G','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('183','CONVERSATION DOWNHILL','A Taut Character Study of a Husband And a Waitress who must Sink a Squirrel in A MySQL Convention','2006','1',NULL,'4','4.99','112','14.99','R','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('184','CORE SUIT','A Unbelieveable Tale of a Car And a Explorer who must Confront a Boat in A Manhattan Penthouse','2006','1',NULL,'3','2.99','92','24.99','PG-13','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('185','COWBOY DOOM','A Astounding Drama of a Boy And a Lumberjack who must Fight a Butler in A Baloon','2006','1',NULL,'3','2.99','146','10.99','PG','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('186','CRAFT OUTFIELD','A Lacklusture Display of a Explorer And a Hunter who must Succumb a Database Administrator in A Baloon Factory','2006','1',NULL,'6','0.99','64','17.99','NC-17','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('187','CRANES RESERVOIR','A Fanciful Documentary of a Teacher And a Dog who must Outgun a Forensic Psychologist in A Baloon Factory','2006','1',NULL,'5','2.99','57','12.99','NC-17','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('188','CRAZY HOME','A Fanciful Panorama of a Boy And a Woman who must Vanquish a Database Administrator in The Outback','2006','1',NULL,'7','2.99','136','24.99','PG','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('189','CREATURES SHAKESPEARE','A Emotional Drama of a Womanizer And a Squirrel who must Vanquish a Crocodile in Ancient India','2006','1',NULL,'3','0.99','139','23.99','NC-17','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('190','CREEPERS KANE','A Awe-Inspiring Reflection of a Squirrel And a Boat who must Outrace a Car in A Jet Boat','2006','1',NULL,'5','4.99','172','23.99','NC-17','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('191','CROOKED FROGMEN','A Unbelieveable Drama of a Hunter And a Database Administrator who must Battle a Crocodile in An Abandoned Amusement Park','2006','1',NULL,'6','0.99','143','27.99','PG-13','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('192','CROSSING DIVORCE','A Beautiful Documentary of a Dog And a Robot who must Redeem a Womanizer in Berlin','2006','1',NULL,'4','4.99','50','19.99','R','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('193','CROSSROADS CASUALTIES','A Intrepid Documentary of a Sumo Wrestler And a Astronaut who must Battle a Composer in The Outback','2006','1',NULL,'5','2.99','153','20.99','G','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('194','CROW GREASE','A Awe-Inspiring Documentary of a Woman And a Husband who must Sink a Database Administrator in The First Manned Space Station','2006','1',NULL,'6','0.99','104','22.99','PG','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('195','CROWDS TELEMARK','A Intrepid Documentary of a Astronaut And a Forensic Psychologist who must Find a Frisbee in An Abandoned Fun House','2006','1',NULL,'3','4.99','112','16.99','R','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('196','CRUELTY UNFORGIVEN','A Brilliant Tale of a Car And a Moose who must Battle a Dentist in Nigeria','2006','1',NULL,'7','0.99','69','29.99','G','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('197','CRUSADE HONEY','A Fast-Paced Reflection of a Explorer And a Butler who must Battle a Madman in An Abandoned Amusement Park','2006','1',NULL,'4','2.99','112','27.99','R','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('198','CRYSTAL BREAKING','A Fast-Paced Character Study of a Feminist And a Explorer who must Face a Pastry Chef in Ancient Japan','2006','1',NULL,'6','2.99','184','22.99','NC-17','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('199','CUPBOARD SINNERS','A Emotional Reflection of a Frisbee And a Boat who must Reach a Pastry Chef in An Abandoned Amusement Park','2006','1',NULL,'4','2.99','56','29.99','R','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('200','CURTAIN VIDEOTAPE','A Boring Reflection of a Dentist And a Mad Cow who must Chase a Secret Agent in A Shark Tank','2006','1',NULL,'7','0.99','133','27.99','PG-13','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('201','CYCLONE FAMILY','A Lacklusture Drama of a Student And a Monkey who must Sink a Womanizer in A MySQL Convention','2006','1',NULL,'7','2.99','176','18.99','PG','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('202','DADDY PITTSBURGH','A Epic Story of a A Shark And a Student who must Confront a Explorer in The Gulf of Mexico','2006','1',NULL,'5','4.99','161','26.99','G','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('203','DAISY MENAGERIE','A Fast-Paced Saga of a Pastry Chef And a Monkey who must Sink a Composer in Ancient India','2006','1',NULL,'5','4.99','84','9.99','G','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('204','DALMATIONS SWEDEN','A Emotional Epistle of a Moose And a Hunter who must Overcome a Robot in A Manhattan Penthouse','2006','1',NULL,'4','0.99','106','25.99','PG','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('205','DANCES NONE','A Insightful Reflection of a A Shark And a Dog who must Kill a Butler in An Abandoned Amusement Park','2006','1',NULL,'3','0.99','58','22.99','NC-17','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('206','DANCING FEVER','A Stunning Story of a Explorer And a Forensic Psychologist who must Face a Crocodile in A Shark Tank','2006','1',NULL,'6','0.99','144','25.99','G','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('207','DANGEROUS UPTOWN','A Unbelieveable Story of a Mad Scientist And a Woman who must Overcome a Dog in California','2006','1',NULL,'7','4.99','121','26.99','PG','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('208','DARES PLUTO','A Fateful Story of a Robot And a Dentist who must Defeat a Astronaut in New Orleans','2006','1',NULL,'7','2.99','89','16.99','PG-13','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('209','DARKNESS WAR','A Touching Documentary of a Husband And a Hunter who must Escape a Boy in The Sahara Desert','2006','1',NULL,'6','2.99','99','24.99','NC-17','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('210','DARKO DORADO','A Stunning Reflection of a Frisbee And a Husband who must Redeem a Dog in New Orleans','2006','1',NULL,'3','4.99','130','13.99','NC-17','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('211','DARLING BREAKING','A Brilliant Documentary of a Astronaut And a Squirrel who must Succumb a Student in The Gulf of Mexico','2006','1',NULL,'7','4.99','165','20.99','PG-13','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('212','DARN FORRESTER','A Fateful Story of a A Shark And a Explorer who must Succumb a Technical Writer in A Jet Boat','2006','1',NULL,'7','4.99','185','14.99','G','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('213','DATE SPEED','A Touching Saga of a Composer And a Moose who must Discover a Dentist in A MySQL Convention','2006','1',NULL,'4','0.99','104','19.99','R','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('214','DAUGHTER MADIGAN','A Beautiful Tale of a Hunter And a Mad Scientist who must Confront a Squirrel in The First Manned Space Station','2006','1',NULL,'3','4.99','59','13.99','PG-13','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('215','DAWN POND','A Thoughtful Documentary of a Dentist And a Forensic Psychologist who must Defeat a Waitress in Berlin','2006','1',NULL,'4','4.99','57','27.99','PG','Trailers,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('216','DAY UNFAITHFUL','A Stunning Documentary of a Composer And a Mad Scientist who must Find a Technical Writer in A U-Boat','2006','1',NULL,'3','4.99','113','16.99','G','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('217','DAZED PUNK','A Action-Packed Story of a Pioneer And a Technical Writer who must Discover a Forensic Psychologist in An Abandoned Amusement Park','2006','1',NULL,'6','4.99','120','20.99','G','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('218','DECEIVER BETRAYED','A Taut Story of a Moose And a Squirrel who must Build a Husband in Ancient India','2006','1',NULL,'7','0.99','122','22.99','NC-17','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('219','DEEP CRUSADE','A Amazing Tale of a Crocodile And a Squirrel who must Discover a Composer in Australia','2006','1',NULL,'6','4.99','51','20.99','PG-13','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('220','DEER VIRGINIAN','A Thoughtful Story of a Mad Cow And a Womanizer who must Overcome a Mad Scientist in Soviet Georgia','2006','1',NULL,'7','2.99','106','13.99','NC-17','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('221','DELIVERANCE MULHOLLAND','A Astounding Saga of a Monkey And a Moose who must Conquer a Butler in A Shark Tank','2006','1',NULL,'4','0.99','100','9.99','R','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('222','DESERT POSEIDON','A Brilliant Documentary of a Butler And a Frisbee who must Build a Astronaut in New Orleans','2006','1',NULL,'4','4.99','64','27.99','R','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('223','DESIRE ALIEN','A Fast-Paced Tale of a Dog And a Forensic Psychologist who must Meet a Astronaut in The First Manned Space Station','2006','1',NULL,'7','2.99','76','24.99','NC-17','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('224','DESPERATE TRAINSPOTTING','A Epic Yarn of a Forensic Psychologist And a Teacher who must Face a Lumberjack in California','2006','1',NULL,'7','4.99','81','29.99','G','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('225','DESTINATION JERK','A Beautiful Yarn of a Teacher And a Cat who must Build a Car in A U-Boat','2006','1',NULL,'3','0.99','76','19.99','PG-13','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('226','DESTINY SATURDAY','A Touching Drama of a Crocodile And a Crocodile who must Conquer a Explorer in Soviet Georgia','2006','1',NULL,'4','4.99','56','20.99','G','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('227','DETAILS PACKER','A Epic Saga of a Waitress And a Composer who must Face a Boat in A U-Boat','2006','1',NULL,'4','4.99','88','17.99','R','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('228','DETECTIVE VISION','A Fanciful Documentary of a Pioneer And a Woman who must Redeem a Hunter in Ancient Japan','2006','1',NULL,'4','0.99','143','16.99','PG-13','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('229','DEVIL DESIRE','A Beautiful Reflection of a Monkey And a Dentist who must Face a Database Administrator in Ancient Japan','2006','1',NULL,'6','4.99','87','12.99','R','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('230','DIARY PANIC','A Thoughtful Character Study of a Frisbee And a Mad Cow who must Outgun a Man in Ancient India','2006','1',NULL,'7','2.99','107','20.99','G','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('231','DINOSAUR SECRETARY','A Action-Packed Drama of a Feminist And a Girl who must Reach a Robot in The Canadian Rockies','2006','1',NULL,'7','2.99','63','27.99','R','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('232','DIRTY ACE','A Action-Packed Character Study of a Forensic Psychologist And a Girl who must Build a Dentist in The Outback','2006','1',NULL,'7','2.99','147','29.99','NC-17','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('233','DISCIPLE MOTHER','A Touching Reflection of a Mad Scientist And a Boat who must Face a Moose in A Shark Tank','2006','1',NULL,'3','0.99','141','17.99','PG','Trailers,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('234','DISTURBING SCARFACE','A Lacklusture Display of a Crocodile And a Butler who must Overcome a Monkey in A U-Boat','2006','1',NULL,'6','2.99','94','27.99','R','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('235','DIVIDE MONSTER','A Intrepid Saga of a Man And a Forensic Psychologist who must Reach a Squirrel in A Monastery','2006','1',NULL,'6','2.99','68','13.99','PG-13','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('236','DIVINE RESURRECTION','A Boring Character Study of a Man And a Womanizer who must Succumb a Teacher in An Abandoned Amusement Park','2006','1',NULL,'4','2.99','100','19.99','R','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('237','DIVORCE SHINING','A Unbelieveable Saga of a Crocodile And a Student who must Discover a Cat in Ancient India','2006','1',NULL,'3','2.99','47','21.99','G','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('238','DOCTOR GRAIL','A Insightful Drama of a Womanizer And a Waitress who must Reach a Forensic Psychologist in The Outback','2006','1',NULL,'4','2.99','57','29.99','G','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('239','DOGMA FAMILY','A Brilliant Character Study of a Database Administrator And a Monkey who must Succumb a Astronaut in New Orleans','2006','1',NULL,'5','4.99','122','16.99','G','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('240','DOLLS RAGE','A Thrilling Display of a Pioneer And a Frisbee who must Escape a Teacher in The Outback','2006','1',NULL,'7','2.99','120','10.99','PG-13','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('241','DONNIE ALLEY','A Awe-Inspiring Tale of a Butler And a Frisbee who must Vanquish a Teacher in Ancient Japan','2006','1',NULL,'4','0.99','125','20.99','NC-17','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('242','DOOM DANCING','A Astounding Panorama of a Car And a Mad Scientist who must Battle a Lumberjack in A MySQL Convention','2006','1',NULL,'4','0.99','68','13.99','R','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('243','DOORS PRESIDENT','A Awe-Inspiring Display of a Squirrel And a Woman who must Overcome a Boy in The Gulf of Mexico','2006','1',NULL,'3','4.99','49','22.99','NC-17','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('244','DORADO NOTTING','A Action-Packed Tale of a Sumo Wrestler And a A Shark who must Meet a Frisbee in California','2006','1',NULL,'5','4.99','139','26.99','NC-17','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('245','DOUBLE WRATH','A Thoughtful Yarn of a Womanizer And a Dog who must Challenge a Madman in The Gulf of Mexico','2006','1',NULL,'4','0.99','177','28.99','R','Trailers,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('246','DOUBTFIRE LABYRINTH','A Intrepid Panorama of a Butler And a Composer who must Meet a Mad Cow in The Sahara Desert','2006','1',NULL,'5','4.99','154','16.99','R','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('247','DOWNHILL ENOUGH','A Emotional Tale of a Pastry Chef And a Forensic Psychologist who must Succumb a Monkey in The Sahara Desert','2006','1',NULL,'3','0.99','47','19.99','G','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('248','DOZEN LION','A Taut Drama of a Cat And a Girl who must Defeat a Frisbee in The Canadian Rockies','2006','1',NULL,'6','4.99','177','20.99','NC-17','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('249','DRACULA CRYSTAL','A Thrilling Reflection of a Feminist And a Cat who must Find a Frisbee in An Abandoned Fun House','2006','1',NULL,'7','0.99','176','26.99','G','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('250','DRAGON SQUAD','A Taut Reflection of a Boy And a Waitress who must Outgun a Teacher in Ancient China','2006','1',NULL,'4','0.99','170','26.99','NC-17','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('251','DRAGONFLY STRANGERS','A Boring Documentary of a Pioneer And a Man who must Vanquish a Man in Nigeria','2006','1',NULL,'6','4.99','133','19.99','NC-17','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('252','DREAM PICKUP','A Epic Display of a Car And a Composer who must Overcome a Forensic Psychologist in The Gulf of Mexico','2006','1',NULL,'6','2.99','135','18.99','PG','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('253','DRIFTER COMMANDMENTS','A Epic Reflection of a Womanizer And a Squirrel who must Discover a Husband in A Jet Boat','2006','1',NULL,'5','4.99','61','18.99','PG-13','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('254','DRIVER ANNIE','A Lacklusture Character Study of a Butler And a Car who must Redeem a Boat in An Abandoned Fun House','2006','1',NULL,'4','2.99','159','11.99','PG-13','Trailers,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('255','DRIVING POLISH','A Action-Packed Yarn of a Feminist And a Technical Writer who must Sink a Boat in An Abandoned Mine Shaft','2006','1',NULL,'6','4.99','175','21.99','NC-17','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('256','DROP WATERFRONT','A Fanciful Documentary of a Husband And a Explorer who must Reach a Madman in Ancient China','2006','1',NULL,'6','4.99','178','20.99','R','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('257','DRUMLINE CYCLONE','A Insightful Panorama of a Monkey And a Sumo Wrestler who must Outrace a Mad Scientist in The Canadian Rockies','2006','1',NULL,'3','0.99','110','14.99','G','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('258','DRUMS DYNAMITE','A Epic Display of a Crocodile And a Crocodile who must Confront a Dog in An Abandoned Amusement Park','2006','1',NULL,'6','0.99','96','11.99','PG','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('259','DUCK RACER','A Lacklusture Yarn of a Teacher And a Squirrel who must Overcome a Dog in A Shark Tank','2006','1',NULL,'4','2.99','116','15.99','NC-17','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('260','DUDE BLINDNESS','A Stunning Reflection of a Husband And a Lumberjack who must Face a Frisbee in An Abandoned Fun House','2006','1',NULL,'3','4.99','132','9.99','G','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('261','DUFFEL APOCALYPSE','A Emotional Display of a Boat And a Explorer who must Challenge a Madman in A MySQL Convention','2006','1',NULL,'5','0.99','171','13.99','G','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('262','DUMBO LUST','A Touching Display of a Feminist And a Dentist who must Conquer a Husband in The Gulf of Mexico','2006','1',NULL,'5','0.99','119','17.99','NC-17','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('263','DURHAM PANKY','A Brilliant Panorama of a Girl And a Boy who must Face a Mad Scientist in An Abandoned Mine Shaft','2006','1',NULL,'6','4.99','154','14.99','R','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('264','DWARFS ALTER','A Emotional Yarn of a Girl And a Dog who must Challenge a Composer in Ancient Japan','2006','1',NULL,'6','2.99','101','13.99','G','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('265','DYING MAKER','A Intrepid Tale of a Boat And a Monkey who must Kill a Cat in California','2006','1',NULL,'5','4.99','168','28.99','PG','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('266','DYNAMITE TARZAN','A Intrepid Documentary of a Forensic Psychologist And a Mad Scientist who must Face a Explorer in A U-Boat','2006','1',NULL,'4','0.99','141','27.99','PG-13','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('267','EAGLES PANKY','A Thoughtful Story of a Car And a Boy who must Find a A Shark in The Sahara Desert','2006','1',NULL,'4','4.99','140','14.99','NC-17','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('268','EARLY HOME','A Amazing Panorama of a Mad Scientist And a Husband who must Meet a Woman in The Outback','2006','1',NULL,'6','4.99','96','27.99','NC-17','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('269','EARRING INSTINCT','A Stunning Character Study of a Dentist And a Mad Cow who must Find a Teacher in Nigeria','2006','1',NULL,'3','0.99','98','22.99','R','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('270','EARTH VISION','A Stunning Drama of a Butler And a Madman who must Outrace a Womanizer in Ancient India','2006','1',NULL,'7','0.99','85','29.99','NC-17','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('271','EASY GLADIATOR','A Fateful Story of a Monkey And a Girl who must Overcome a Pastry Chef in Ancient India','2006','1',NULL,'5','4.99','148','12.99','G','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('272','EDGE KISSING','A Beautiful Yarn of a Composer And a Mad Cow who must Redeem a Mad Scientist in A Jet Boat','2006','1',NULL,'5','4.99','153','9.99','NC-17','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('273','EFFECT GLADIATOR','A Beautiful Display of a Pastry Chef And a Pastry Chef who must Outgun a Forensic Psychologist in A Manhattan Penthouse','2006','1',NULL,'6','0.99','107','14.99','PG','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('274','EGG IGBY','A Beautiful Documentary of a Boat And a Sumo Wrestler who must Succumb a Database Administrator in The First Manned Space Station','2006','1',NULL,'4','2.99','67','20.99','PG','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('275','EGYPT TENENBAUMS','A Intrepid Story of a Madman And a Secret Agent who must Outrace a Astronaut in An Abandoned Amusement Park','2006','1',NULL,'3','0.99','85','11.99','PG','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('276','ELEMENT FREDDY','A Awe-Inspiring Reflection of a Waitress And a Squirrel who must Kill a Mad Cow in A Jet Boat','2006','1',NULL,'6','4.99','115','28.99','NC-17','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('277','ELEPHANT TROJAN','A Beautiful Panorama of a Lumberjack And a Forensic Psychologist who must Overcome a Frisbee in A Baloon','2006','1',NULL,'4','4.99','126','24.99','PG-13','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('278','ELF MURDER','A Action-Packed Story of a Frisbee And a Woman who must Reach a Girl in An Abandoned Mine Shaft','2006','1',NULL,'4','4.99','155','19.99','NC-17','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('279','ELIZABETH SHANE','A Lacklusture Display of a Womanizer And a Dog who must Face a Sumo Wrestler in Ancient Japan','2006','1',NULL,'7','4.99','152','11.99','NC-17','Trailers,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('280','EMPIRE MALKOVICH','A Amazing Story of a Feminist And a Cat who must Face a Car in An Abandoned Fun House','2006','1',NULL,'7','0.99','177','26.99','G','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('281','ENCINO ELF','A Astounding Drama of a Feminist And a Teacher who must Confront a Husband in A Baloon','2006','1',NULL,'6','0.99','143','9.99','G','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('282','ENCOUNTERS CURTAIN','A Insightful Epistle of a Pastry Chef And a Womanizer who must Build a Boat in New Orleans','2006','1',NULL,'5','0.99','92','20.99','NC-17','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('283','ENDING CROWDS','A Unbelieveable Display of a Dentist And a Madman who must Vanquish a Squirrel in Berlin','2006','1',NULL,'6','0.99','85','10.99','NC-17','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('284','ENEMY ODDS','A Fanciful Panorama of a Mad Scientist And a Woman who must Pursue a Astronaut in Ancient India','2006','1',NULL,'5','4.99','77','23.99','NC-17','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('285','ENGLISH BULWORTH','A Intrepid Epistle of a Pastry Chef And a Pastry Chef who must Pursue a Crocodile in Ancient China','2006','1',NULL,'3','0.99','51','18.99','PG-13','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('286','ENOUGH RAGING','A Astounding Character Study of a Boat And a Secret Agent who must Find a Mad Cow in The Sahara Desert','2006','1',NULL,'7','2.99','158','16.99','NC-17','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('287','ENTRAPMENT SATISFACTION','A Thoughtful Panorama of a Hunter And a Teacher who must Reach a Mad Cow in A U-Boat','2006','1',NULL,'5','0.99','176','19.99','R','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('288','ESCAPE METROPOLIS','A Taut Yarn of a Astronaut And a Technical Writer who must Outgun a Boat in New Orleans','2006','1',NULL,'7','2.99','167','20.99','R','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('289','EVE RESURRECTION','A Awe-Inspiring Yarn of a Pastry Chef And a Database Administrator who must Challenge a Teacher in A Baloon','2006','1',NULL,'5','4.99','66','25.99','G','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('290','EVERYONE CRAFT','A Fateful Display of a Waitress And a Dentist who must Reach a Butler in Nigeria','2006','1',NULL,'4','0.99','163','29.99','PG','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('291','EVOLUTION ALTER','A Fanciful Character Study of a Feminist And a Madman who must Find a Explorer in A Baloon Factory','2006','1',NULL,'5','0.99','174','10.99','PG-13','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('292','EXCITEMENT EVE','A Brilliant Documentary of a Monkey And a Car who must Conquer a Crocodile in A Shark Tank','2006','1',NULL,'3','0.99','51','20.99','G','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('293','EXORCIST STING','A Touching Drama of a Dog And a Sumo Wrestler who must Conquer a Mad Scientist in Berlin','2006','1',NULL,'6','2.99','167','17.99','G','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('294','EXPECATIONS NATURAL','A Amazing Drama of a Butler And a Husband who must Reach a A Shark in A U-Boat','2006','1',NULL,'5','4.99','138','26.99','PG-13','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('295','EXPENDABLE STALLION','A Amazing Character Study of a Mad Cow And a Squirrel who must Discover a Hunter in A U-Boat','2006','1',NULL,'3','0.99','97','14.99','PG','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('296','EXPRESS LONELY','A Boring Drama of a Astronaut And a Boat who must Face a Boat in California','2006','1',NULL,'5','2.99','178','23.99','R','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('297','EXTRAORDINARY CONQUERER','A Stunning Story of a Dog And a Feminist who must Face a Forensic Psychologist in Berlin','2006','1',NULL,'6','2.99','122','29.99','G','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('298','EYES DRIVING','A Thrilling Story of a Cat And a Waitress who must Fight a Explorer in The Outback','2006','1',NULL,'4','2.99','172','13.99','PG-13','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('299','FACTORY DRAGON','A Action-Packed Saga of a Teacher And a Frisbee who must Escape a Lumberjack in The Sahara Desert','2006','1',NULL,'4','0.99','144','9.99','PG-13','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('300','FALCON VOLUME','A Fateful Saga of a Sumo Wrestler And a Hunter who must Redeem a A Shark in New Orleans','2006','1',NULL,'5','4.99','102','21.99','PG-13','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('301','FAMILY SWEET','A Epic Documentary of a Teacher And a Boy who must Escape a Woman in Berlin','2006','1',NULL,'4','0.99','155','24.99','R','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('302','FANTASIA PARK','A Thoughtful Documentary of a Mad Scientist And a A Shark who must Outrace a Feminist in Australia','2006','1',NULL,'5','2.99','131','29.99','G','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('303','FANTASY TROOPERS','A Touching Saga of a Teacher And a Monkey who must Overcome a Secret Agent in A MySQL Convention','2006','1',NULL,'6','0.99','58','27.99','PG-13','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('304','FARGO GANDHI','A Thrilling Reflection of a Pastry Chef And a Crocodile who must Reach a Teacher in The Outback','2006','1',NULL,'3','2.99','130','28.99','G','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('305','FATAL HAUNTED','A Beautiful Drama of a Student And a Secret Agent who must Confront a Dentist in Ancient Japan','2006','1',NULL,'6','2.99','91','24.99','PG','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('306','FEATHERS METAL','A Thoughtful Yarn of a Monkey And a Teacher who must Find a Dog in Australia','2006','1',NULL,'3','0.99','104','12.99','PG-13','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('307','FELLOWSHIP AUTUMN','A Lacklusture Reflection of a Dentist And a Hunter who must Meet a Teacher in A Baloon','2006','1',NULL,'6','4.99','77','9.99','NC-17','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('308','FERRIS MOTHER','A Touching Display of a Frisbee And a Frisbee who must Kill a Girl in The Gulf of Mexico','2006','1',NULL,'3','2.99','142','13.99','PG','Trailers,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('309','FEUD FROGMEN','A Brilliant Reflection of a Database Administrator And a Mad Cow who must Chase a Woman in The Canadian Rockies','2006','1',NULL,'6','0.99','98','29.99','R','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('310','FEVER EMPIRE','A Insightful Panorama of a Cat And a Boat who must Defeat a Boat in The Gulf of Mexico','2006','1',NULL,'5','4.99','158','20.99','R','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('311','FICTION CHRISTMAS','A Emotional Yarn of a A Shark And a Student who must Battle a Robot in An Abandoned Mine Shaft','2006','1',NULL,'4','0.99','72','14.99','PG','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('312','FIDDLER LOST','A Boring Tale of a Squirrel And a Dog who must Challenge a Madman in The Gulf of Mexico','2006','1',NULL,'4','4.99','75','20.99','R','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('313','FIDELITY DEVIL','A Awe-Inspiring Drama of a Technical Writer And a Composer who must Reach a Pastry Chef in A U-Boat','2006','1',NULL,'5','4.99','118','11.99','G','Trailers,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('314','FIGHT JAWBREAKER','A Intrepid Panorama of a Womanizer And a Girl who must Escape a Girl in A Manhattan Penthouse','2006','1',NULL,'3','0.99','91','13.99','R','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('315','FINDING ANACONDA','A Fateful Tale of a Database Administrator And a Girl who must Battle a Squirrel in New Orleans','2006','1',NULL,'4','0.99','156','10.99','R','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('316','FIRE WOLVES','A Intrepid Documentary of a Frisbee And a Dog who must Outrace a Lumberjack in Nigeria','2006','1',NULL,'5','4.99','173','18.99','R','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('317','FIREBALL PHILADELPHIA','A Amazing Yarn of a Dentist And a A Shark who must Vanquish a Madman in An Abandoned Mine Shaft','2006','1',NULL,'4','0.99','148','25.99','PG','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('318','FIREHOUSE VIETNAM','A Awe-Inspiring Character Study of a Boat And a Boy who must Kill a Pastry Chef in The Sahara Desert','2006','1',NULL,'7','0.99','103','14.99','G','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('319','FISH OPUS','A Touching Display of a Feminist And a Girl who must Confront a Astronaut in Australia','2006','1',NULL,'4','2.99','125','22.99','R','Trailers,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('320','FLAMINGOS CONNECTICUT','A Fast-Paced Reflection of a Composer And a Composer who must Meet a Cat in The Sahara Desert','2006','1',NULL,'4','4.99','80','28.99','PG-13','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('321','FLASH WARS','A Astounding Saga of a Moose And a Pastry Chef who must Chase a Student in The Gulf of Mexico','2006','1',NULL,'3','4.99','123','21.99','NC-17','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('322','FLATLINERS KILLER','A Taut Display of a Secret Agent And a Waitress who must Sink a Robot in An Abandoned Mine Shaft','2006','1',NULL,'5','2.99','100','29.99','G','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('323','FLIGHT LIES','A Stunning Character Study of a Crocodile And a Pioneer who must Pursue a Teacher in New Orleans','2006','1',NULL,'7','4.99','179','22.99','R','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('324','FLINTSTONES HAPPINESS','A Fateful Story of a Husband And a Moose who must Vanquish a Boy in California','2006','1',NULL,'3','4.99','148','11.99','PG-13','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('325','FLOATS GARDEN','A Action-Packed Epistle of a Robot And a Car who must Chase a Boat in Ancient Japan','2006','1',NULL,'6','2.99','145','29.99','PG-13','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('326','FLYING HOOK','A Thrilling Display of a Mad Cow And a Dog who must Challenge a Frisbee in Nigeria','2006','1',NULL,'6','2.99','69','18.99','NC-17','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('327','FOOL MOCKINGBIRD','A Lacklusture Tale of a Crocodile And a Composer who must Defeat a Madman in A U-Boat','2006','1',NULL,'3','4.99','158','24.99','PG','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('328','FOREVER CANDIDATE','A Unbelieveable Panorama of a Technical Writer And a Man who must Pursue a Frisbee in A U-Boat','2006','1',NULL,'7','2.99','131','28.99','NC-17','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('329','FORREST SONS','A Thrilling Documentary of a Forensic Psychologist And a Butler who must Defeat a Explorer in A Jet Boat','2006','1',NULL,'4','2.99','63','15.99','R','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('330','FORRESTER COMANCHEROS','A Fateful Tale of a Squirrel And a Forensic Psychologist who must Redeem a Man in Nigeria','2006','1',NULL,'7','4.99','112','22.99','NC-17','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('331','FORWARD TEMPLE','A Astounding Display of a Forensic Psychologist And a Mad Scientist who must Challenge a Girl in New Orleans','2006','1',NULL,'6','2.99','90','25.99','NC-17','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('332','FRANKENSTEIN STRANGER','A Insightful Character Study of a Feminist And a Pioneer who must Pursue a Pastry Chef in Nigeria','2006','1',NULL,'7','0.99','159','16.99','NC-17','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('333','FREAKY POCUS','A Fast-Paced Documentary of a Pastry Chef And a Crocodile who must Chase a Squirrel in The Gulf of Mexico','2006','1',NULL,'7','2.99','126','16.99','R','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('334','FREDDY STORM','A Intrepid Saga of a Man And a Lumberjack who must Vanquish a Husband in The Outback','2006','1',NULL,'6','4.99','65','21.99','NC-17','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('335','FREEDOM CLEOPATRA','A Emotional Reflection of a Dentist And a Mad Cow who must Face a Squirrel in A Baloon','2006','1',NULL,'5','0.99','133','23.99','PG-13','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('336','FRENCH HOLIDAY','A Thrilling Epistle of a Dog And a Feminist who must Kill a Madman in Berlin','2006','1',NULL,'5','4.99','99','22.99','PG','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('337','FRIDA SLIPPER','A Fateful Story of a Lumberjack And a Car who must Escape a Boat in An Abandoned Mine Shaft','2006','1',NULL,'6','2.99','73','11.99','R','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('338','FRISCO FORREST','A Beautiful Documentary of a Woman And a Pioneer who must Pursue a Mad Scientist in A Shark Tank','2006','1',NULL,'6','4.99','51','23.99','PG','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('339','FROGMEN BREAKING','A Unbelieveable Yarn of a Mad Scientist And a Cat who must Chase a Lumberjack in Australia','2006','1',NULL,'5','0.99','111','17.99','R','Trailers,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('340','FRONTIER CABIN','A Emotional Story of a Madman And a Waitress who must Battle a Teacher in An Abandoned Fun House','2006','1',NULL,'6','4.99','183','14.99','PG-13','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('341','FROST HEAD','A Amazing Reflection of a Lumberjack And a Cat who must Discover a Husband in A MySQL Convention','2006','1',NULL,'5','0.99','82','13.99','PG','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('342','FUGITIVE MAGUIRE','A Taut Epistle of a Feminist And a Sumo Wrestler who must Battle a Crocodile in Australia','2006','1',NULL,'7','4.99','83','28.99','R','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('343','FULL FLATLINERS','A Beautiful Documentary of a Astronaut And a Moose who must Pursue a Monkey in A Shark Tank','2006','1',NULL,'6','2.99','94','14.99','PG','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('344','FURY MURDER','A Lacklusture Reflection of a Boat And a Forensic Psychologist who must Fight a Waitress in A Monastery','2006','1',NULL,'3','0.99','178','28.99','PG-13','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('345','GABLES METROPOLIS','A Fateful Display of a Cat And a Pioneer who must Challenge a Pastry Chef in A Baloon Factory','2006','1',NULL,'3','0.99','161','17.99','PG','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('346','GALAXY SWEETHEARTS','A Emotional Reflection of a Womanizer And a Pioneer who must Face a Squirrel in Berlin','2006','1',NULL,'4','4.99','128','13.99','R','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('347','GAMES BOWFINGER','A Astounding Documentary of a Butler And a Explorer who must Challenge a Butler in A Monastery','2006','1',NULL,'7','4.99','119','17.99','PG-13','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('348','GANDHI KWAI','A Thoughtful Display of a Mad Scientist And a Secret Agent who must Chase a Boat in Berlin','2006','1',NULL,'7','0.99','86','9.99','PG-13','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('349','GANGS PRIDE','A Taut Character Study of a Woman And a A Shark who must Confront a Frisbee in Berlin','2006','1',NULL,'4','2.99','185','27.99','PG-13','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('350','GARDEN ISLAND','A Unbelieveable Character Study of a Womanizer And a Madman who must Reach a Man in The Outback','2006','1',NULL,'3','4.99','80','21.99','G','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('351','GASLIGHT CRUSADE','A Amazing Epistle of a Boy And a Astronaut who must Redeem a Man in The Gulf of Mexico','2006','1',NULL,'4','2.99','106','10.99','PG','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('352','GATHERING CALENDAR','A Intrepid Tale of a Pioneer And a Moose who must Conquer a Frisbee in A MySQL Convention','2006','1',NULL,'4','0.99','176','22.99','PG-13','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('353','GENTLEMEN STAGE','A Awe-Inspiring Reflection of a Monkey And a Student who must Overcome a Dentist in The First Manned Space Station','2006','1',NULL,'6','2.99','125','22.99','NC-17','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('354','GHOST GROUNDHOG','A Brilliant Panorama of a Madman And a Composer who must Succumb a Car in Ancient India','2006','1',NULL,'6','4.99','85','18.99','G','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('355','GHOSTBUSTERS ELF','A Thoughtful Epistle of a Dog And a Feminist who must Chase a Composer in Berlin','2006','1',NULL,'7','0.99','101','18.99','R','Trailers,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('356','GIANT TROOPERS','A Fateful Display of a Feminist And a Monkey who must Vanquish a Monkey in The Canadian Rockies','2006','1',NULL,'5','2.99','102','10.99','R','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('357','GILBERT PELICAN','A Fateful Tale of a Man And a Feminist who must Conquer a Crocodile in A Manhattan Penthouse','2006','1',NULL,'7','0.99','114','13.99','G','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('358','GILMORE BOILED','A Unbelieveable Documentary of a Boat And a Husband who must Succumb a Student in A U-Boat','2006','1',NULL,'5','0.99','163','29.99','R','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('359','GLADIATOR WESTWARD','A Astounding Reflection of a Squirrel And a Sumo Wrestler who must Sink a Dentist in Ancient Japan','2006','1',NULL,'6','4.99','173','20.99','PG','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('360','GLASS DYING','A Astounding Drama of a Frisbee And a Astronaut who must Fight a Dog in Ancient Japan','2006','1',NULL,'4','0.99','103','24.99','G','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('361','GLEAMING JAWBREAKER','A Amazing Display of a Composer And a Forensic Psychologist who must Discover a Car in The Canadian Rockies','2006','1',NULL,'5','2.99','89','25.99','NC-17','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('362','GLORY TRACY','A Amazing Saga of a Woman And a Womanizer who must Discover a Cat in The First Manned Space Station','2006','1',NULL,'7','2.99','115','13.99','PG-13','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('363','GO PURPLE','A Fast-Paced Display of a Car And a Database Administrator who must Battle a Woman in A Baloon','2006','1',NULL,'3','0.99','54','12.99','R','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('364','GODFATHER DIARY','A Stunning Saga of a Lumberjack And a Squirrel who must Chase a Car in The Outback','2006','1',NULL,'3','2.99','73','14.99','NC-17','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('365','GOLD RIVER','A Taut Documentary of a Database Administrator And a Waitress who must Reach a Mad Scientist in A Baloon Factory','2006','1',NULL,'4','4.99','154','21.99','R','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('366','GOLDFINGER SENSIBILITY','A Insightful Drama of a Mad Scientist And a Hunter who must Defeat a Pastry Chef in New Orleans','2006','1',NULL,'3','0.99','93','29.99','G','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('367','GOLDMINE TYCOON','A Brilliant Epistle of a Composer And a Frisbee who must Conquer a Husband in The Outback','2006','1',NULL,'6','0.99','153','20.99','R','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('368','GONE TROUBLE','A Insightful Character Study of a Mad Cow And a Forensic Psychologist who must Conquer a A Shark in A Manhattan Penthouse','2006','1',NULL,'7','2.99','84','20.99','R','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('369','GOODFELLAS SALUTE','A Unbelieveable Tale of a Dog And a Explorer who must Sink a Mad Cow in A Baloon Factory','2006','1',NULL,'4','4.99','56','22.99','PG','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('370','GORGEOUS BINGO','A Action-Packed Display of a Sumo Wrestler And a Car who must Overcome a Waitress in A Baloon Factory','2006','1',NULL,'4','2.99','108','26.99','R','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('371','GOSFORD DONNIE','A Epic Panorama of a Mad Scientist And a Monkey who must Redeem a Secret Agent in Berlin','2006','1',NULL,'5','4.99','129','17.99','G','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('372','GRACELAND DYNAMITE','A Taut Display of a Cat And a Girl who must Overcome a Database Administrator in New Orleans','2006','1',NULL,'5','4.99','140','26.99','R','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('373','GRADUATE LORD','A Lacklusture Epistle of a Girl And a A Shark who must Meet a Mad Scientist in Ancient China','2006','1',NULL,'7','2.99','156','14.99','G','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('374','GRAFFITI LOVE','A Unbelieveable Epistle of a Sumo Wrestler And a Hunter who must Build a Composer in Berlin','2006','1',NULL,'3','0.99','117','29.99','PG','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('375','GRAIL FRANKENSTEIN','A Unbelieveable Saga of a Teacher And a Monkey who must Fight a Girl in An Abandoned Mine Shaft','2006','1',NULL,'4','2.99','85','17.99','NC-17','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('376','GRAPES FURY','A Boring Yarn of a Mad Cow And a Sumo Wrestler who must Meet a Robot in Australia','2006','1',NULL,'4','0.99','155','20.99','G','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('377','GREASE YOUTH','A Emotional Panorama of a Secret Agent And a Waitress who must Escape a Composer in Soviet Georgia','2006','1',NULL,'7','0.99','135','20.99','G','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('378','GREATEST NORTH','A Astounding Character Study of a Secret Agent And a Robot who must Build a A Shark in Berlin','2006','1',NULL,'5','2.99','93','24.99','NC-17','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('379','GREEDY ROOTS','A Amazing Reflection of a A Shark And a Butler who must Chase a Hunter in The Canadian Rockies','2006','1',NULL,'7','0.99','166','14.99','R','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('380','GREEK EVERYONE','A Stunning Display of a Butler And a Teacher who must Confront a A Shark in The First Manned Space Station','2006','1',NULL,'7','2.99','176','11.99','PG','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('381','GRINCH MASSAGE','A Intrepid Display of a Madman And a Feminist who must Pursue a Pioneer in The First Manned Space Station','2006','1',NULL,'7','4.99','150','25.99','R','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('382','GRIT CLOCKWORK','A Thoughtful Display of a Dentist And a Squirrel who must Confront a Lumberjack in A Shark Tank','2006','1',NULL,'3','0.99','137','21.99','PG','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('383','GROOVE FICTION','A Unbelieveable Reflection of a Moose And a A Shark who must Defeat a Lumberjack in An Abandoned Mine Shaft','2006','1',NULL,'6','0.99','111','13.99','NC-17','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('384','GROSSE WONDERFUL','A Epic Drama of a Cat And a Explorer who must Redeem a Moose in Australia','2006','1',NULL,'5','4.99','49','19.99','R','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('385','GROUNDHOG UNCUT','A Brilliant Panorama of a Astronaut And a Technical Writer who must Discover a Butler in A Manhattan Penthouse','2006','1',NULL,'6','4.99','139','26.99','PG-13','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('386','GUMP DATE','A Intrepid Yarn of a Explorer And a Student who must Kill a Husband in An Abandoned Mine Shaft','2006','1',NULL,'3','4.99','53','12.99','NC-17','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('387','GUN BONNIE','A Boring Display of a Sumo Wrestler And a Husband who must Build a Waitress in The Gulf of Mexico','2006','1',NULL,'7','0.99','100','27.99','G','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('388','GUNFIGHT MOON','A Epic Reflection of a Pastry Chef And a Explorer who must Reach a Dentist in The Sahara Desert','2006','1',NULL,'5','0.99','70','16.99','NC-17','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('389','GUNFIGHTER MUSSOLINI','A Touching Saga of a Robot And a Boy who must Kill a Man in Ancient Japan','2006','1',NULL,'3','2.99','127','9.99','PG-13','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('390','GUYS FALCON','A Boring Story of a Woman And a Feminist who must Redeem a Squirrel in A U-Boat','2006','1',NULL,'4','4.99','84','20.99','R','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('391','HALF OUTFIELD','A Epic Epistle of a Database Administrator And a Crocodile who must Face a Madman in A Jet Boat','2006','1',NULL,'6','2.99','146','25.99','PG-13','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('392','HALL CASSIDY','A Beautiful Panorama of a Pastry Chef And a A Shark who must Battle a Pioneer in Soviet Georgia','2006','1',NULL,'5','4.99','51','13.99','NC-17','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('393','HALLOWEEN NUTS','A Amazing Panorama of a Forensic Psychologist And a Technical Writer who must Fight a Dentist in A U-Boat','2006','1',NULL,'6','2.99','47','19.99','PG-13','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('394','HAMLET WISDOM','A Touching Reflection of a Man And a Man who must Sink a Robot in The Outback','2006','1',NULL,'7','2.99','146','21.99','R','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('395','HANDICAP BOONDOCK','A Beautiful Display of a Pioneer And a Squirrel who must Vanquish a Sumo Wrestler in Soviet Georgia','2006','1',NULL,'4','0.99','108','28.99','R','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('396','HANGING DEEP','A Action-Packed Yarn of a Boat And a Crocodile who must Build a Monkey in Berlin','2006','1',NULL,'5','4.99','62','18.99','G','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('397','HANKY OCTOBER','A Boring Epistle of a Database Administrator And a Explorer who must Pursue a Madman in Soviet Georgia','2006','1',NULL,'5','2.99','107','26.99','NC-17','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('398','HANOVER GALAXY','A Stunning Reflection of a Girl And a Secret Agent who must Succumb a Boy in A MySQL Convention','2006','1',NULL,'5','4.99','47','21.99','NC-17','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('399','HAPPINESS UNITED','A Action-Packed Panorama of a Husband And a Feminist who must Meet a Forensic Psychologist in Ancient Japan','2006','1',NULL,'6','2.99','100','23.99','G','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('400','HARDLY ROBBERS','A Emotional Character Study of a Hunter And a Car who must Kill a Woman in Berlin','2006','1',NULL,'7','2.99','72','15.99','R','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('401','HAROLD FRENCH','A Stunning Saga of a Sumo Wrestler And a Student who must Outrace a Moose in The Sahara Desert','2006','1',NULL,'6','0.99','168','10.99','NC-17','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('402','HARPER DYING','A Awe-Inspiring Reflection of a Woman And a Cat who must Confront a Feminist in The Sahara Desert','2006','1',NULL,'3','0.99','52','15.99','G','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('403','HARRY IDAHO','A Taut Yarn of a Technical Writer And a Feminist who must Outrace a Dog in California','2006','1',NULL,'5','4.99','121','18.99','PG-13','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('404','HATE HANDICAP','A Intrepid Reflection of a Mad Scientist And a Pioneer who must Overcome a Hunter in The First Manned Space Station','2006','1',NULL,'4','0.99','107','26.99','PG','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('405','HAUNTED ANTITRUST','A Amazing Saga of a Man And a Dentist who must Reach a Technical Writer in Ancient India','2006','1',NULL,'6','4.99','76','13.99','NC-17','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('406','HAUNTING PIANIST','A Fast-Paced Story of a Database Administrator And a Composer who must Defeat a Squirrel in An Abandoned Amusement Park','2006','1',NULL,'5','0.99','181','22.99','R','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('407','HAWK CHILL','A Action-Packed Drama of a Mad Scientist And a Composer who must Outgun a Car in Australia','2006','1',NULL,'5','0.99','47','12.99','PG-13','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('408','HEAD STRANGER','A Thoughtful Saga of a Hunter And a Crocodile who must Confront a Dog in The Gulf of Mexico','2006','1',NULL,'4','4.99','69','28.99','R','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('409','HEARTBREAKERS BRIGHT','A Awe-Inspiring Documentary of a A Shark And a Dentist who must Outrace a Pastry Chef in The Canadian Rockies','2006','1',NULL,'3','4.99','59','9.99','G','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('410','HEAVEN FREEDOM','A Intrepid Story of a Butler And a Car who must Vanquish a Man in New Orleans','2006','1',NULL,'7','2.99','48','19.99','PG','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('411','HEAVENLY GUN','A Beautiful Yarn of a Forensic Psychologist And a Frisbee who must Battle a Moose in A Jet Boat','2006','1',NULL,'5','4.99','49','13.99','NC-17','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('412','HEAVYWEIGHTS BEAST','A Unbelieveable Story of a Composer And a Dog who must Overcome a Womanizer in An Abandoned Amusement Park','2006','1',NULL,'6','4.99','102','25.99','G','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('413','HEDWIG ALTER','A Action-Packed Yarn of a Womanizer And a Lumberjack who must Chase a Sumo Wrestler in A Monastery','2006','1',NULL,'7','2.99','169','16.99','NC-17','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('414','HELLFIGHTERS SIERRA','A Taut Reflection of a A Shark And a Dentist who must Battle a Boat in Soviet Georgia','2006','1',NULL,'3','2.99','75','23.99','PG','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('415','HIGH ENCINO','A Fateful Saga of a Waitress And a Hunter who must Outrace a Sumo Wrestler in Australia','2006','1',NULL,'3','2.99','84','23.99','R','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('416','HIGHBALL POTTER','A Action-Packed Saga of a Husband And a Dog who must Redeem a Database Administrator in The Sahara Desert','2006','1',NULL,'6','0.99','110','10.99','R','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('417','HILLS NEIGHBORS','A Epic Display of a Hunter And a Feminist who must Sink a Car in A U-Boat','2006','1',NULL,'5','0.99','93','29.99','G','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('418','HOBBIT ALIEN','A Emotional Drama of a Husband And a Girl who must Outgun a Composer in The First Manned Space Station','2006','1',NULL,'5','0.99','157','27.99','PG-13','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('419','HOCUS FRIDA','A Awe-Inspiring Tale of a Girl And a Madman who must Outgun a Student in A Shark Tank','2006','1',NULL,'4','2.99','141','19.99','G','Trailers,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('420','HOLES BRANNIGAN','A Fast-Paced Reflection of a Technical Writer And a Student who must Fight a Boy in The Canadian Rockies','2006','1',NULL,'7','4.99','128','27.99','PG','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('421','HOLIDAY GAMES','A Insightful Reflection of a Waitress And a Madman who must Pursue a Boy in Ancient Japan','2006','1',NULL,'7','4.99','78','10.99','PG-13','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('422','HOLLOW JEOPARDY','A Beautiful Character Study of a Robot And a Astronaut who must Overcome a Boat in A Monastery','2006','1',NULL,'7','4.99','136','25.99','NC-17','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('423','HOLLYWOOD ANONYMOUS','A Fast-Paced Epistle of a Boy And a Explorer who must Escape a Dog in A U-Boat','2006','1',NULL,'7','0.99','69','29.99','PG','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('424','HOLOCAUST HIGHBALL','A Awe-Inspiring Yarn of a Composer And a Man who must Find a Robot in Soviet Georgia','2006','1',NULL,'6','0.99','149','12.99','R','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('425','HOLY TADPOLE','A Action-Packed Display of a Feminist And a Pioneer who must Pursue a Dog in A Baloon Factory','2006','1',NULL,'6','0.99','88','20.99','R','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('426','HOME PITY','A Touching Panorama of a Man And a Secret Agent who must Challenge a Teacher in A MySQL Convention','2006','1',NULL,'7','4.99','185','15.99','R','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('427','HOMEWARD CIDER','A Taut Reflection of a Astronaut And a Squirrel who must Fight a Squirrel in A Manhattan Penthouse','2006','1',NULL,'5','0.99','103','19.99','R','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('428','HOMICIDE PEACH','A Astounding Documentary of a Hunter And a Boy who must Confront a Boy in A MySQL Convention','2006','1',NULL,'6','2.99','141','21.99','PG-13','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('429','HONEY TIES','A Taut Story of a Waitress And a Crocodile who must Outrace a Lumberjack in A Shark Tank','2006','1',NULL,'3','0.99','84','29.99','R','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('430','HOOK CHARIOTS','A Insightful Story of a Boy And a Dog who must Redeem a Boy in Australia','2006','1',NULL,'7','0.99','49','23.99','G','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('431','HOOSIERS BIRDCAGE','A Astounding Display of a Explorer And a Boat who must Vanquish a Car in The First Manned Space Station','2006','1',NULL,'3','2.99','176','12.99','G','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('432','HOPE TOOTSIE','A Amazing Documentary of a Student And a Sumo Wrestler who must Outgun a A Shark in A Shark Tank','2006','1',NULL,'4','2.99','139','22.99','NC-17','Trailers,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('433','HORN WORKING','A Stunning Display of a Mad Scientist And a Technical Writer who must Succumb a Monkey in A Shark Tank','2006','1',NULL,'4','2.99','95','23.99','PG','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('434','HORROR REIGN','A Touching Documentary of a A Shark And a Car who must Build a Husband in Nigeria','2006','1',NULL,'3','0.99','139','25.99','R','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('435','HOTEL HAPPINESS','A Thrilling Yarn of a Pastry Chef And a A Shark who must Challenge a Mad Scientist in The Outback','2006','1',NULL,'6','4.99','181','28.99','PG-13','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('436','HOURS RAGE','A Fateful Story of a Explorer And a Feminist who must Meet a Technical Writer in Soviet Georgia','2006','1',NULL,'4','0.99','122','14.99','NC-17','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('437','HOUSE DYNAMITE','A Taut Story of a Pioneer And a Squirrel who must Battle a Student in Soviet Georgia','2006','1',NULL,'7','2.99','109','13.99','R','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('438','HUMAN GRAFFITI','A Beautiful Reflection of a Womanizer And a Sumo Wrestler who must Chase a Database Administrator in The Gulf of Mexico','2006','1',NULL,'3','2.99','68','22.99','NC-17','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('439','HUNCHBACK IMPOSSIBLE','A Touching Yarn of a Frisbee And a Dentist who must Fight a Composer in Ancient Japan','2006','1',NULL,'4','4.99','151','28.99','PG-13','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('440','HUNGER ROOF','A Unbelieveable Yarn of a Student And a Database Administrator who must Outgun a Husband in An Abandoned Mine Shaft','2006','1',NULL,'6','0.99','105','21.99','G','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('441','HUNTER ALTER','A Emotional Drama of a Mad Cow And a Boat who must Redeem a Secret Agent in A Shark Tank','2006','1',NULL,'5','2.99','125','21.99','PG-13','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('442','HUNTING MUSKETEERS','A Thrilling Reflection of a Pioneer And a Dentist who must Outrace a Womanizer in An Abandoned Mine Shaft','2006','1',NULL,'6','2.99','65','24.99','NC-17','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('443','HURRICANE AFFAIR','A Lacklusture Epistle of a Database Administrator And a Woman who must Meet a Hunter in An Abandoned Mine Shaft','2006','1',NULL,'6','2.99','49','11.99','PG','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('444','HUSTLER PARTY','A Emotional Reflection of a Sumo Wrestler And a Monkey who must Conquer a Robot in The Sahara Desert','2006','1',NULL,'3','4.99','83','22.99','NC-17','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('445','HYDE DOCTOR','A Fanciful Documentary of a Boy And a Woman who must Redeem a Womanizer in A Jet Boat','2006','1',NULL,'5','2.99','100','11.99','G','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('446','HYSTERICAL GRAIL','A Amazing Saga of a Madman And a Dentist who must Build a Car in A Manhattan Penthouse','2006','1',NULL,'5','4.99','150','19.99','PG','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('447','ICE CROSSING','A Fast-Paced Tale of a Butler And a Moose who must Overcome a Pioneer in A Manhattan Penthouse','2006','1',NULL,'5','2.99','131','28.99','R','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('448','IDAHO LOVE','A Fast-Paced Drama of a Student And a Crocodile who must Meet a Database Administrator in The Outback','2006','1',NULL,'3','2.99','172','25.99','PG-13','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('449','IDENTITY LOVER','A Boring Tale of a Composer And a Mad Cow who must Defeat a Car in The Outback','2006','1',NULL,'4','2.99','119','12.99','PG-13','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('450','IDOLS SNATCHERS','A Insightful Drama of a Car And a Composer who must Fight a Man in A Monastery','2006','1',NULL,'5','2.99','84','29.99','NC-17','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('451','IGBY MAKER','A Epic Documentary of a Hunter And a Dog who must Outgun a Dog in A Baloon Factory','2006','1',NULL,'7','4.99','160','12.99','NC-17','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('452','ILLUSION AMELIE','A Emotional Epistle of a Boat And a Mad Scientist who must Outrace a Robot in An Abandoned Mine Shaft','2006','1',NULL,'4','0.99','122','15.99','R','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('453','IMAGE PRINCESS','A Lacklusture Panorama of a Secret Agent And a Crocodile who must Discover a Madman in The Canadian Rockies','2006','1',NULL,'3','2.99','178','17.99','PG-13','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('454','IMPACT ALADDIN','A Epic Character Study of a Frisbee And a Moose who must Outgun a Technical Writer in A Shark Tank','2006','1',NULL,'6','0.99','180','20.99','PG-13','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('455','IMPOSSIBLE PREJUDICE','A Awe-Inspiring Yarn of a Monkey And a Hunter who must Chase a Teacher in Ancient China','2006','1',NULL,'7','4.99','103','11.99','NC-17','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('456','INCH JET','A Fateful Saga of a Womanizer And a Student who must Defeat a Butler in A Monastery','2006','1',NULL,'6','4.99','167','18.99','NC-17','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('457','INDEPENDENCE HOTEL','A Thrilling Tale of a Technical Writer And a Boy who must Face a Pioneer in A Monastery','2006','1',NULL,'5','0.99','157','21.99','NC-17','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('458','INDIAN LOVE','A Insightful Saga of a Mad Scientist And a Mad Scientist who must Kill a Astronaut in An Abandoned Fun House','2006','1',NULL,'4','0.99','135','26.99','NC-17','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('459','INFORMER DOUBLE','A Action-Packed Display of a Woman And a Dentist who must Redeem a Forensic Psychologist in The Canadian Rockies','2006','1',NULL,'4','4.99','74','23.99','NC-17','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('460','INNOCENT USUAL','A Beautiful Drama of a Pioneer And a Crocodile who must Challenge a Student in The Outback','2006','1',NULL,'3','4.99','178','26.99','PG-13','Trailers,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('461','INSECTS STONE','A Epic Display of a Butler And a Dog who must Vanquish a Crocodile in A Manhattan Penthouse','2006','1',NULL,'3','0.99','123','14.99','NC-17','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('462','INSIDER ARIZONA','A Astounding Saga of a Mad Scientist And a Hunter who must Pursue a Robot in A Baloon Factory','2006','1',NULL,'5','2.99','78','17.99','NC-17','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('463','INSTINCT AIRPORT','A Touching Documentary of a Mad Cow And a Explorer who must Confront a Butler in A Manhattan Penthouse','2006','1',NULL,'4','2.99','116','21.99','PG','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('464','INTENTIONS EMPIRE','A Astounding Epistle of a Cat And a Cat who must Conquer a Mad Cow in A U-Boat','2006','1',NULL,'3','2.99','107','13.99','PG-13','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('465','INTERVIEW LIAISONS','A Action-Packed Reflection of a Student And a Butler who must Discover a Database Administrator in A Manhattan Penthouse','2006','1',NULL,'4','4.99','59','17.99','R','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('466','INTOLERABLE INTENTIONS','A Awe-Inspiring Story of a Monkey And a Pastry Chef who must Succumb a Womanizer in A MySQL Convention','2006','1',NULL,'6','4.99','63','20.99','PG-13','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('467','INTRIGUE WORST','A Fanciful Character Study of a Explorer And a Mad Scientist who must Vanquish a Squirrel in A Jet Boat','2006','1',NULL,'6','0.99','181','10.99','G','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('468','INVASION CYCLONE','A Lacklusture Character Study of a Mad Scientist And a Womanizer who must Outrace a Explorer in A Monastery','2006','1',NULL,'5','2.99','97','12.99','PG','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('469','IRON MOON','A Fast-Paced Documentary of a Mad Cow And a Boy who must Pursue a Dentist in A Baloon','2006','1',NULL,'7','4.99','46','27.99','PG','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('470','ISHTAR ROCKETEER','A Astounding Saga of a Dog And a Squirrel who must Conquer a Dog in An Abandoned Fun House','2006','1',NULL,'4','4.99','79','24.99','R','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('471','ISLAND EXORCIST','A Fanciful Panorama of a Technical Writer And a Boy who must Find a Dentist in An Abandoned Fun House','2006','1',NULL,'7','2.99','84','23.99','NC-17','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('472','ITALIAN AFRICAN','A Astounding Character Study of a Monkey And a Moose who must Outgun a Cat in A U-Boat','2006','1',NULL,'3','4.99','174','24.99','G','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('473','JACKET FRISCO','A Insightful Reflection of a Womanizer And a Husband who must Conquer a Pastry Chef in A Baloon','2006','1',NULL,'5','2.99','181','16.99','PG-13','Trailers,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('474','JADE BUNCH','A Insightful Panorama of a Squirrel And a Mad Cow who must Confront a Student in The First Manned Space Station','2006','1',NULL,'6','2.99','174','21.99','NC-17','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('475','JAPANESE RUN','A Awe-Inspiring Epistle of a Feminist And a Girl who must Sink a Girl in The Outback','2006','1',NULL,'6','0.99','135','29.99','G','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('476','JASON TRAP','A Thoughtful Tale of a Woman And a A Shark who must Conquer a Dog in A Monastery','2006','1',NULL,'5','2.99','130','9.99','NC-17','Trailers,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('477','JAWBREAKER BROOKLYN','A Stunning Reflection of a Boat And a Pastry Chef who must Succumb a A Shark in A Jet Boat','2006','1',NULL,'5','0.99','118','15.99','PG','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('478','JAWS HARRY','A Thrilling Display of a Database Administrator And a Monkey who must Overcome a Dog in An Abandoned Fun House','2006','1',NULL,'4','2.99','112','10.99','G','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('479','JEDI BENEATH','A Astounding Reflection of a Explorer And a Dentist who must Pursue a Student in Nigeria','2006','1',NULL,'7','0.99','128','12.99','PG','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('480','JEEPERS WEDDING','A Astounding Display of a Composer And a Dog who must Kill a Pastry Chef in Soviet Georgia','2006','1',NULL,'3','2.99','84','29.99','R','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('481','JEKYLL FROGMEN','A Fanciful Epistle of a Student And a Astronaut who must Kill a Waitress in A Shark Tank','2006','1',NULL,'4','2.99','58','22.99','PG','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('482','JEOPARDY ENCINO','A Boring Panorama of a Man And a Mad Cow who must Face a Explorer in Ancient India','2006','1',NULL,'3','0.99','102','12.99','R','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('483','JERICHO MULAN','A Amazing Yarn of a Hunter And a Butler who must Defeat a Boy in A Jet Boat','2006','1',NULL,'3','2.99','171','29.99','NC-17','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('484','JERK PAYCHECK','A Touching Character Study of a Pastry Chef And a Database Administrator who must Reach a A Shark in Ancient Japan','2006','1',NULL,'3','2.99','172','13.99','NC-17','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('485','JERSEY SASSY','A Lacklusture Documentary of a Madman And a Mad Cow who must Find a Feminist in Ancient Japan','2006','1',NULL,'6','4.99','60','16.99','PG','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('486','JET NEIGHBORS','A Amazing Display of a Lumberjack And a Teacher who must Outrace a Woman in A U-Boat','2006','1',NULL,'7','4.99','59','14.99','R','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('487','JINGLE SAGEBRUSH','A Epic Character Study of a Feminist And a Student who must Meet a Woman in A Baloon','2006','1',NULL,'6','4.99','124','29.99','PG-13','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('488','JOON NORTHWEST','A Thrilling Panorama of a Technical Writer And a Car who must Discover a Forensic Psychologist in A Shark Tank','2006','1',NULL,'3','0.99','105','23.99','NC-17','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('489','JUGGLER HARDLY','A Epic Story of a Mad Cow And a Astronaut who must Challenge a Car in California','2006','1',NULL,'4','0.99','54','14.99','PG-13','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('490','JUMANJI BLADE','A Intrepid Yarn of a Husband And a Womanizer who must Pursue a Mad Scientist in New Orleans','2006','1',NULL,'4','2.99','121','13.99','G','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('491','JUMPING WRATH','A Touching Epistle of a Monkey And a Feminist who must Discover a Boat in Berlin','2006','1',NULL,'4','0.99','74','18.99','NC-17','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('492','JUNGLE CLOSER','A Boring Character Study of a Boy And a Woman who must Battle a Astronaut in Australia','2006','1',NULL,'6','0.99','134','11.99','NC-17','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('493','KANE EXORCIST','A Epic Documentary of a Composer And a Robot who must Overcome a Car in Berlin','2006','1',NULL,'5','0.99','92','18.99','R','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('494','KARATE MOON','A Astounding Yarn of a Womanizer And a Dog who must Reach a Waitress in A MySQL Convention','2006','1',NULL,'4','0.99','120','21.99','PG-13','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('495','KENTUCKIAN GIANT','A Stunning Yarn of a Woman And a Frisbee who must Escape a Waitress in A U-Boat','2006','1',NULL,'5','2.99','169','10.99','PG','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('496','KICK SAVANNAH','A Emotional Drama of a Monkey And a Robot who must Defeat a Monkey in New Orleans','2006','1',NULL,'3','0.99','179','10.99','PG-13','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('497','KILL BROTHERHOOD','A Touching Display of a Hunter And a Secret Agent who must Redeem a Husband in The Outback','2006','1',NULL,'4','0.99','54','15.99','G','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('498','KILLER INNOCENT','A Fanciful Character Study of a Student And a Explorer who must Succumb a Composer in An Abandoned Mine Shaft','2006','1',NULL,'7','2.99','161','11.99','R','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('499','KING EVOLUTION','A Action-Packed Tale of a Boy And a Lumberjack who must Chase a Madman in A Baloon','2006','1',NULL,'3','4.99','184','24.99','NC-17','Trailers,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('500','KISS GLORY','A Lacklusture Reflection of a Girl And a Husband who must Find a Robot in The Canadian Rockies','2006','1',NULL,'5','4.99','163','11.99','PG-13','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('501','KISSING DOLLS','A Insightful Reflection of a Pioneer And a Teacher who must Build a Composer in The First Manned Space Station','2006','1',NULL,'3','4.99','141','9.99','R','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('502','KNOCK WARLOCK','A Unbelieveable Story of a Teacher And a Boat who must Confront a Moose in A Baloon','2006','1',NULL,'4','2.99','71','21.99','PG-13','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('503','KRAMER CHOCOLATE','A Amazing Yarn of a Robot And a Pastry Chef who must Redeem a Mad Scientist in The Outback','2006','1',NULL,'3','2.99','171','24.99','R','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('504','KWAI HOMEWARD','A Amazing Drama of a Car And a Squirrel who must Pursue a Car in Soviet Georgia','2006','1',NULL,'5','0.99','46','25.99','PG-13','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('505','LABYRINTH LEAGUE','A Awe-Inspiring Saga of a Composer And a Frisbee who must Succumb a Pioneer in The Sahara Desert','2006','1',NULL,'6','2.99','46','24.99','PG-13','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('506','LADY STAGE','A Beautiful Character Study of a Woman And a Man who must Pursue a Explorer in A U-Boat','2006','1',NULL,'4','4.99','67','14.99','PG','Trailers,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('507','LADYBUGS ARMAGEDDON','A Fateful Reflection of a Dog And a Mad Scientist who must Meet a Mad Scientist in New Orleans','2006','1',NULL,'4','0.99','113','13.99','NC-17','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('508','LAMBS CINCINATTI','A Insightful Story of a Man And a Feminist who must Fight a Composer in Australia','2006','1',NULL,'6','4.99','144','18.99','PG-13','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('509','LANGUAGE COWBOY','A Epic Yarn of a Cat And a Madman who must Vanquish a Dentist in An Abandoned Amusement Park','2006','1',NULL,'5','0.99','78','26.99','NC-17','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('510','LAWLESS VISION','A Insightful Yarn of a Boy And a Sumo Wrestler who must Outgun a Car in The Outback','2006','1',NULL,'6','4.99','181','29.99','G','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('511','LAWRENCE LOVE','A Fanciful Yarn of a Database Administrator And a Mad Cow who must Pursue a Womanizer in Berlin','2006','1',NULL,'7','0.99','175','23.99','NC-17','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('512','LEAGUE HELLFIGHTERS','A Thoughtful Saga of a A Shark And a Monkey who must Outgun a Student in Ancient China','2006','1',NULL,'5','4.99','110','25.99','PG-13','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('513','LEATHERNECKS DWARFS','A Fateful Reflection of a Dog And a Mad Cow who must Outrace a Teacher in An Abandoned Mine Shaft','2006','1',NULL,'6','2.99','153','21.99','PG-13','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('514','LEBOWSKI SOLDIERS','A Beautiful Epistle of a Secret Agent And a Pioneer who must Chase a Astronaut in Ancient China','2006','1',NULL,'6','2.99','69','17.99','PG-13','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('515','LEGALLY SECRETARY','A Astounding Tale of a A Shark And a Moose who must Meet a Womanizer in The Sahara Desert','2006','1',NULL,'7','4.99','113','14.99','PG','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('516','LEGEND JEDI','A Awe-Inspiring Epistle of a Pioneer And a Student who must Outgun a Crocodile in The Outback','2006','1',NULL,'7','0.99','59','18.99','PG','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('517','LESSON CLEOPATRA','A Emotional Display of a Man And a Explorer who must Build a Boy in A Manhattan Penthouse','2006','1',NULL,'3','0.99','167','28.99','NC-17','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('518','LIAISONS SWEET','A Boring Drama of a A Shark And a Explorer who must Redeem a Waitress in The Canadian Rockies','2006','1',NULL,'5','4.99','140','15.99','PG','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('519','LIBERTY MAGNIFICENT','A Boring Drama of a Student And a Cat who must Sink a Technical Writer in A Baloon','2006','1',NULL,'3','2.99','138','27.99','G','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('520','LICENSE WEEKEND','A Insightful Story of a Man And a Husband who must Overcome a Madman in A Monastery','2006','1',NULL,'7','2.99','91','28.99','NC-17','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('521','LIES TREATMENT','A Fast-Paced Character Study of a Dentist And a Moose who must Defeat a Composer in The First Manned Space Station','2006','1',NULL,'7','4.99','147','28.99','NC-17','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('522','LIFE TWISTED','A Thrilling Reflection of a Teacher And a Composer who must Find a Man in The First Manned Space Station','2006','1',NULL,'4','2.99','137','9.99','NC-17','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('523','LIGHTS DEER','A Unbelieveable Epistle of a Dog And a Woman who must Confront a Moose in The Gulf of Mexico','2006','1',NULL,'7','0.99','174','21.99','R','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('524','LION UNCUT','A Intrepid Display of a Pastry Chef And a Cat who must Kill a A Shark in Ancient China','2006','1',NULL,'6','0.99','50','13.99','PG','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('525','LOATHING LEGALLY','A Boring Epistle of a Pioneer And a Mad Scientist who must Escape a Frisbee in The Gulf of Mexico','2006','1',NULL,'4','0.99','140','29.99','R','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('526','LOCK REAR','A Thoughtful Character Study of a Squirrel And a Technical Writer who must Outrace a Student in Ancient Japan','2006','1',NULL,'7','2.99','120','10.99','R','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('527','LOLA AGENT','A Astounding Tale of a Mad Scientist And a Husband who must Redeem a Database Administrator in Ancient Japan','2006','1',NULL,'4','4.99','85','24.99','PG','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('528','LOLITA WORLD','A Thrilling Drama of a Girl And a Robot who must Redeem a Waitress in An Abandoned Mine Shaft','2006','1',NULL,'4','2.99','155','25.99','NC-17','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('529','LONELY ELEPHANT','A Intrepid Story of a Student And a Dog who must Challenge a Explorer in Soviet Georgia','2006','1',NULL,'3','2.99','67','12.99','G','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('530','LORD ARIZONA','A Action-Packed Display of a Frisbee And a Pastry Chef who must Pursue a Crocodile in A Jet Boat','2006','1',NULL,'5','2.99','108','27.99','PG-13','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('531','LOSE INCH','A Stunning Reflection of a Student And a Technical Writer who must Battle a Butler in The First Manned Space Station','2006','1',NULL,'3','0.99','137','18.99','R','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('532','LOSER HUSTLER','A Stunning Drama of a Robot And a Feminist who must Outgun a Butler in Nigeria','2006','1',NULL,'5','4.99','80','28.99','PG','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('533','LOST BIRD','A Emotional Character Study of a Robot And a A Shark who must Defeat a Technical Writer in A Manhattan Penthouse','2006','1',NULL,'4','2.99','98','21.99','PG-13','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('534','LOUISIANA HARRY','A Lacklusture Drama of a Girl And a Technical Writer who must Redeem a Monkey in A Shark Tank','2006','1',NULL,'5','0.99','70','18.99','PG-13','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('535','LOVE SUICIDES','A Brilliant Panorama of a Hunter And a Explorer who must Pursue a Dentist in An Abandoned Fun House','2006','1',NULL,'6','0.99','181','21.99','R','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('536','LOVELY JINGLE','A Fanciful Yarn of a Crocodile And a Forensic Psychologist who must Discover a Crocodile in The Outback','2006','1',NULL,'3','2.99','65','18.99','PG','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('537','LOVER TRUMAN','A Emotional Yarn of a Robot And a Boy who must Outgun a Technical Writer in A U-Boat','2006','1',NULL,'3','2.99','75','29.99','G','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('538','LOVERBOY ATTACKS','A Boring Story of a Car And a Butler who must Build a Girl in Soviet Georgia','2006','1',NULL,'7','0.99','162','19.99','PG-13','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('539','LUCK OPUS','A Boring Display of a Moose And a Squirrel who must Outrace a Teacher in A Shark Tank','2006','1',NULL,'7','2.99','152','21.99','NC-17','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('540','LUCKY FLYING','A Lacklusture Character Study of a A Shark And a Man who must Find a Forensic Psychologist in A U-Boat','2006','1',NULL,'7','2.99','97','10.99','PG-13','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('541','LUKE MUMMY','A Taut Character Study of a Boy And a Robot who must Redeem a Mad Scientist in Ancient India','2006','1',NULL,'5','2.99','74','21.99','NC-17','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('542','LUST LOCK','A Fanciful Panorama of a Hunter And a Dentist who must Meet a Secret Agent in The Sahara Desert','2006','1',NULL,'3','2.99','52','28.99','G','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('543','MADIGAN DORADO','A Astounding Character Study of a A Shark And a A Shark who must Discover a Crocodile in The Outback','2006','1',NULL,'5','4.99','116','20.99','R','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('544','MADISON TRAP','A Awe-Inspiring Reflection of a Monkey And a Dentist who must Overcome a Pioneer in A U-Boat','2006','1',NULL,'4','2.99','147','11.99','R','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('545','MADNESS ATTACKS','A Fanciful Tale of a Squirrel And a Boat who must Defeat a Crocodile in The Gulf of Mexico','2006','1',NULL,'4','0.99','178','14.99','PG-13','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('546','MADRE GABLES','A Intrepid Panorama of a Sumo Wrestler And a Forensic Psychologist who must Discover a Moose in The First Manned Space Station','2006','1',NULL,'7','2.99','98','27.99','PG-13','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('547','MAGIC MALLRATS','A Touching Documentary of a Pastry Chef And a Pastry Chef who must Build a Mad Scientist in California','2006','1',NULL,'3','0.99','117','19.99','PG','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('548','MAGNIFICENT CHITTY','A Insightful Story of a Teacher And a Hunter who must Face a Mad Cow in California','2006','1',NULL,'3','2.99','53','27.99','R','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('549','MAGNOLIA FORRESTER','A Thoughtful Documentary of a Composer And a Explorer who must Conquer a Dentist in New Orleans','2006','1',NULL,'4','0.99','171','28.99','PG-13','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('550','MAGUIRE APACHE','A Fast-Paced Reflection of a Waitress And a Hunter who must Defeat a Forensic Psychologist in A Baloon','2006','1',NULL,'6','2.99','74','22.99','NC-17','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('551','MAIDEN HOME','A Lacklusture Saga of a Moose And a Teacher who must Kill a Forensic Psychologist in A MySQL Convention','2006','1',NULL,'3','4.99','138','9.99','PG','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('552','MAJESTIC FLOATS','A Thrilling Character Study of a Moose And a Student who must Escape a Butler in The First Manned Space Station','2006','1',NULL,'5','0.99','130','15.99','PG','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('553','MAKER GABLES','A Stunning Display of a Moose And a Database Administrator who must Pursue a Composer in A Jet Boat','2006','1',NULL,'4','0.99','136','12.99','PG-13','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('554','MALKOVICH PET','A Intrepid Reflection of a Waitress And a A Shark who must Kill a Squirrel in The Outback','2006','1',NULL,'6','2.99','159','22.99','G','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('555','MALLRATS UNITED','A Thrilling Yarn of a Waitress And a Dentist who must Find a Hunter in A Monastery','2006','1',NULL,'4','0.99','133','25.99','PG','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('556','MALTESE HOPE','A Fast-Paced Documentary of a Crocodile And a Sumo Wrestler who must Conquer a Explorer in California','2006','1',NULL,'6','4.99','127','26.99','PG-13','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('557','MANCHURIAN CURTAIN','A Stunning Tale of a Mad Cow And a Boy who must Battle a Boy in Berlin','2006','1',NULL,'5','2.99','177','27.99','PG','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('558','MANNEQUIN WORST','A Astounding Saga of a Mad Cow And a Pastry Chef who must Discover a Husband in Ancient India','2006','1',NULL,'3','2.99','71','18.99','PG-13','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('559','MARRIED GO','A Fanciful Story of a Womanizer And a Dog who must Face a Forensic Psychologist in The Sahara Desert','2006','1',NULL,'7','2.99','114','22.99','G','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('560','MARS ROMAN','A Boring Drama of a Car And a Dog who must Succumb a Madman in Soviet Georgia','2006','1',NULL,'6','0.99','62','21.99','NC-17','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('561','MASK PEACH','A Boring Character Study of a Student And a Robot who must Meet a Woman in California','2006','1',NULL,'6','2.99','123','26.99','NC-17','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('562','MASKED BUBBLE','A Fanciful Documentary of a Pioneer And a Boat who must Pursue a Pioneer in An Abandoned Mine Shaft','2006','1',NULL,'6','0.99','151','12.99','PG-13','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('563','MASSACRE USUAL','A Fateful Reflection of a Waitress And a Crocodile who must Challenge a Forensic Psychologist in California','2006','1',NULL,'6','4.99','165','16.99','R','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('564','MASSAGE IMAGE','A Fateful Drama of a Frisbee And a Crocodile who must Vanquish a Dog in The First Manned Space Station','2006','1',NULL,'4','2.99','161','11.99','PG','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('565','MATRIX SNOWMAN','A Action-Packed Saga of a Womanizer And a Woman who must Overcome a Student in California','2006','1',NULL,'6','4.99','56','9.99','PG-13','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('566','MAUDE MOD','A Beautiful Documentary of a Forensic Psychologist And a Cat who must Reach a Astronaut in Nigeria','2006','1',NULL,'6','0.99','72','20.99','R','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('567','MEET CHOCOLATE','A Boring Documentary of a Dentist And a Butler who must Confront a Monkey in A MySQL Convention','2006','1',NULL,'3','2.99','80','26.99','G','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('568','MEMENTO ZOOLANDER','A Touching Epistle of a Squirrel And a Explorer who must Redeem a Pastry Chef in The Sahara Desert','2006','1',NULL,'4','4.99','77','11.99','NC-17','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('569','MENAGERIE RUSHMORE','A Unbelieveable Panorama of a Composer And a Butler who must Overcome a Database Administrator in The First Manned Space Station','2006','1',NULL,'7','2.99','147','18.99','G','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('570','MERMAID INSECTS','A Lacklusture Drama of a Waitress And a Husband who must Fight a Husband in California','2006','1',NULL,'5','4.99','104','20.99','NC-17','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('571','METAL ARMAGEDDON','A Thrilling Display of a Lumberjack And a Crocodile who must Meet a Monkey in A Baloon Factory','2006','1',NULL,'6','2.99','161','26.99','PG-13','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('572','METROPOLIS COMA','A Emotional Saga of a Database Administrator And a Pastry Chef who must Confront a Teacher in A Baloon Factory','2006','1',NULL,'4','2.99','64','9.99','PG-13','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('573','MICROCOSMOS PARADISE','A Touching Character Study of a Boat And a Student who must Sink a A Shark in Nigeria','2006','1',NULL,'6','2.99','105','22.99','PG-13','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('574','MIDNIGHT WESTWARD','A Taut Reflection of a Husband And a A Shark who must Redeem a Pastry Chef in A Monastery','2006','1',NULL,'3','0.99','86','19.99','G','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('575','MIDSUMMER GROUNDHOG','A Fateful Panorama of a Moose And a Dog who must Chase a Crocodile in Ancient Japan','2006','1',NULL,'3','4.99','48','27.99','G','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('576','MIGHTY LUCK','A Astounding Epistle of a Mad Scientist And a Pioneer who must Escape a Database Administrator in A MySQL Convention','2006','1',NULL,'7','2.99','122','13.99','PG','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('577','MILE MULAN','A Lacklusture Epistle of a Cat And a Husband who must Confront a Boy in A MySQL Convention','2006','1',NULL,'4','0.99','64','10.99','PG','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('578','MILLION ACE','A Brilliant Documentary of a Womanizer And a Squirrel who must Find a Technical Writer in The Sahara Desert','2006','1',NULL,'4','4.99','142','16.99','PG-13','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('579','MINDS TRUMAN','A Taut Yarn of a Mad Scientist And a Crocodile who must Outgun a Database Administrator in A Monastery','2006','1',NULL,'3','4.99','149','22.99','PG-13','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('580','MINE TITANS','A Amazing Yarn of a Robot And a Womanizer who must Discover a Forensic Psychologist in Berlin','2006','1',NULL,'3','4.99','166','12.99','PG-13','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('581','MINORITY KISS','A Insightful Display of a Lumberjack And a Sumo Wrestler who must Meet a Man in The Outback','2006','1',NULL,'4','0.99','59','16.99','G','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('582','MIRACLE VIRTUAL','A Touching Epistle of a Butler And a Boy who must Find a Mad Scientist in The Sahara Desert','2006','1',NULL,'3','2.99','162','19.99','PG-13','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('583','MISSION ZOOLANDER','A Intrepid Story of a Sumo Wrestler And a Teacher who must Meet a A Shark in An Abandoned Fun House','2006','1',NULL,'3','4.99','164','26.99','PG-13','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('584','MIXED DOORS','A Taut Drama of a Womanizer And a Lumberjack who must Succumb a Pioneer in Ancient India','2006','1',NULL,'6','2.99','180','26.99','PG-13','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('585','MOB DUFFEL','A Unbelieveable Documentary of a Frisbee And a Boat who must Meet a Boy in The Canadian Rockies','2006','1',NULL,'4','0.99','105','25.99','G','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('586','MOCKINGBIRD HOLLYWOOD','A Thoughtful Panorama of a Man And a Car who must Sink a Composer in Berlin','2006','1',NULL,'4','0.99','60','27.99','PG','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('587','MOD SECRETARY','A Boring Documentary of a Mad Cow And a Cat who must Build a Lumberjack in New Orleans','2006','1',NULL,'6','4.99','77','20.99','NC-17','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('588','MODEL FISH','A Beautiful Panorama of a Boat And a Crocodile who must Outrace a Dog in Australia','2006','1',NULL,'4','4.99','175','11.99','NC-17','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('589','MODERN DORADO','A Awe-Inspiring Story of a Butler And a Sumo Wrestler who must Redeem a Boy in New Orleans','2006','1',NULL,'3','0.99','74','20.99','PG','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('590','MONEY HAROLD','A Touching Tale of a Explorer And a Boat who must Defeat a Robot in Australia','2006','1',NULL,'3','2.99','135','17.99','PG','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('591','MONSOON CAUSE','A Astounding Tale of a Crocodile And a Car who must Outrace a Squirrel in A U-Boat','2006','1',NULL,'6','4.99','182','20.99','PG','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('592','MONSTER SPARTACUS','A Fast-Paced Story of a Waitress And a Cat who must Fight a Girl in Australia','2006','1',NULL,'6','2.99','107','28.99','PG','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('593','MONTEREY LABYRINTH','A Awe-Inspiring Drama of a Monkey And a Composer who must Escape a Feminist in A U-Boat','2006','1',NULL,'6','0.99','158','13.99','G','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('594','MONTEZUMA COMMAND','A Thrilling Reflection of a Waitress And a Butler who must Battle a Butler in A Jet Boat','2006','1',NULL,'6','0.99','126','22.99','NC-17','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('595','MOON BUNCH','A Beautiful Tale of a Astronaut And a Mad Cow who must Challenge a Cat in A Baloon Factory','2006','1',NULL,'7','0.99','83','20.99','PG','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('596','MOONSHINE CABIN','A Thoughtful Display of a Astronaut And a Feminist who must Chase a Frisbee in A Jet Boat','2006','1',NULL,'4','4.99','171','25.99','PG-13','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('597','MOONWALKER FOOL','A Epic Drama of a Feminist And a Pioneer who must Sink a Composer in New Orleans','2006','1',NULL,'5','4.99','184','12.99','G','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('598','MOSQUITO ARMAGEDDON','A Thoughtful Character Study of a Waitress And a Feminist who must Build a Teacher in Ancient Japan','2006','1',NULL,'6','0.99','57','22.99','G','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('599','MOTHER OLEANDER','A Boring Tale of a Husband And a Boy who must Fight a Squirrel in Ancient China','2006','1',NULL,'3','0.99','103','20.99','R','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('600','MOTIONS DETAILS','A Awe-Inspiring Reflection of a Dog And a Student who must Kill a Car in An Abandoned Fun House','2006','1',NULL,'5','0.99','166','16.99','PG','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('601','MOULIN WAKE','A Astounding Story of a Forensic Psychologist And a Cat who must Battle a Teacher in An Abandoned Mine Shaft','2006','1',NULL,'4','0.99','79','20.99','PG-13','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('602','MOURNING PURPLE','A Lacklusture Display of a Waitress And a Lumberjack who must Chase a Pioneer in New Orleans','2006','1',NULL,'5','0.99','146','14.99','PG','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('603','MOVIE SHAKESPEARE','A Insightful Display of a Database Administrator And a Student who must Build a Hunter in Berlin','2006','1',NULL,'6','4.99','53','27.99','PG','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('604','MULAN MOON','A Emotional Saga of a Womanizer And a Pioneer who must Overcome a Dentist in A Baloon','2006','1',NULL,'4','0.99','160','10.99','G','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('605','MULHOLLAND BEAST','A Awe-Inspiring Display of a Husband And a Squirrel who must Battle a Sumo Wrestler in A Jet Boat','2006','1',NULL,'7','2.99','157','13.99','PG','Trailers,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('606','MUMMY CREATURES','A Fateful Character Study of a Crocodile And a Monkey who must Meet a Dentist in Australia','2006','1',NULL,'3','0.99','160','15.99','NC-17','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('607','MUPPET MILE','A Lacklusture Story of a Madman And a Teacher who must Kill a Frisbee in The Gulf of Mexico','2006','1',NULL,'5','4.99','50','18.99','PG','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('608','MURDER ANTITRUST','A Brilliant Yarn of a Car And a Database Administrator who must Escape a Boy in A MySQL Convention','2006','1',NULL,'6','2.99','166','11.99','PG','Trailers,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('609','MUSCLE BRIGHT','A Stunning Panorama of a Sumo Wrestler And a Husband who must Redeem a Madman in Ancient India','2006','1',NULL,'7','2.99','185','23.99','G','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('610','MUSIC BOONDOCK','A Thrilling Tale of a Butler And a Astronaut who must Battle a Explorer in The First Manned Space Station','2006','1',NULL,'7','0.99','129','17.99','R','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('611','MUSKETEERS WAIT','A Touching Yarn of a Student And a Moose who must Fight a Mad Cow in Australia','2006','1',NULL,'7','4.99','73','17.99','PG','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('612','MUSSOLINI SPOILERS','A Thrilling Display of a Boat And a Monkey who must Meet a Composer in Ancient China','2006','1',NULL,'6','2.99','180','10.99','G','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('613','MYSTIC TRUMAN','A Epic Yarn of a Teacher And a Hunter who must Outgun a Explorer in Soviet Georgia','2006','1',NULL,'5','0.99','92','19.99','NC-17','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('614','NAME DETECTIVE','A Touching Saga of a Sumo Wrestler And a Cat who must Pursue a Mad Scientist in Nigeria','2006','1',NULL,'5','4.99','178','11.99','PG-13','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('615','NASH CHOCOLAT','A Epic Reflection of a Monkey And a Mad Cow who must Kill a Forensic Psychologist in An Abandoned Mine Shaft','2006','1',NULL,'6','2.99','180','21.99','PG-13','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('616','NATIONAL STORY','A Taut Epistle of a Mad Scientist And a Girl who must Escape a Monkey in California','2006','1',NULL,'4','2.99','92','19.99','NC-17','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('617','NATURAL STOCK','A Fast-Paced Story of a Sumo Wrestler And a Girl who must Defeat a Car in A Baloon Factory','2006','1',NULL,'4','0.99','50','24.99','PG-13','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('618','NECKLACE OUTBREAK','A Astounding Epistle of a Database Administrator And a Mad Scientist who must Pursue a Cat in California','2006','1',NULL,'3','0.99','132','21.99','PG','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('619','NEIGHBORS CHARADE','A Fanciful Reflection of a Crocodile And a Astronaut who must Outrace a Feminist in An Abandoned Amusement Park','2006','1',NULL,'3','0.99','161','20.99','R','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('620','NEMO CAMPUS','A Lacklusture Reflection of a Monkey And a Squirrel who must Outrace a Womanizer in A Manhattan Penthouse','2006','1',NULL,'5','2.99','131','23.99','NC-17','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('621','NETWORK PEAK','A Unbelieveable Reflection of a Butler And a Boat who must Outgun a Mad Scientist in California','2006','1',NULL,'5','2.99','75','23.99','PG-13','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('622','NEWSIES STORY','A Action-Packed Character Study of a Dog And a Lumberjack who must Outrace a Moose in The Gulf of Mexico','2006','1',NULL,'4','0.99','159','25.99','G','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('623','NEWTON LABYRINTH','A Intrepid Character Study of a Moose And a Waitress who must Find a A Shark in Ancient India','2006','1',NULL,'4','0.99','75','9.99','PG','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('624','NIGHTMARE CHILL','A Brilliant Display of a Robot And a Butler who must Fight a Waitress in An Abandoned Mine Shaft','2006','1',NULL,'3','4.99','149','25.99','PG','Trailers,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('625','NONE SPIKING','A Boring Reflection of a Secret Agent And a Astronaut who must Face a Composer in A Manhattan Penthouse','2006','1',NULL,'3','0.99','83','18.99','NC-17','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('626','NOON PAPI','A Unbelieveable Character Study of a Mad Scientist And a Astronaut who must Find a Pioneer in A Manhattan Penthouse','2006','1',NULL,'5','2.99','57','12.99','G','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('627','NORTH TEQUILA','A Beautiful Character Study of a Mad Cow And a Robot who must Reach a Womanizer in New Orleans','2006','1',NULL,'4','4.99','67','9.99','NC-17','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('628','NORTHWEST POLISH','A Boring Character Study of a Boy And a A Shark who must Outrace a Womanizer in The Outback','2006','1',NULL,'5','2.99','172','24.99','PG','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('629','NOTORIOUS REUNION','A Amazing Epistle of a Woman And a Squirrel who must Fight a Hunter in A Baloon','2006','1',NULL,'7','0.99','128','9.99','NC-17','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('630','NOTTING SPEAKEASY','A Thoughtful Display of a Butler And a Womanizer who must Find a Waitress in The Canadian Rockies','2006','1',NULL,'7','0.99','48','19.99','PG-13','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('631','NOVOCAINE FLIGHT','A Fanciful Display of a Student And a Teacher who must Outgun a Crocodile in Nigeria','2006','1',NULL,'4','0.99','64','11.99','G','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('632','NUTS TIES','A Thoughtful Drama of a Explorer And a Womanizer who must Meet a Teacher in California','2006','1',NULL,'5','4.99','145','10.99','NC-17','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('633','OCTOBER SUBMARINE','A Taut Epistle of a Monkey And a Boy who must Confront a Husband in A Jet Boat','2006','1',NULL,'6','4.99','54','10.99','PG-13','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('634','ODDS BOOGIE','A Thrilling Yarn of a Feminist And a Madman who must Battle a Hunter in Berlin','2006','1',NULL,'6','0.99','48','14.99','NC-17','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('635','OKLAHOMA JUMANJI','A Thoughtful Drama of a Dentist And a Womanizer who must Meet a Husband in The Sahara Desert','2006','1',NULL,'7','0.99','58','15.99','PG','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('636','OLEANDER CLUE','A Boring Story of a Teacher And a Monkey who must Succumb a Forensic Psychologist in A Jet Boat','2006','1',NULL,'5','0.99','161','12.99','PG','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('637','OPEN AFRICAN','A Lacklusture Drama of a Secret Agent And a Explorer who must Discover a Car in A U-Boat','2006','1',NULL,'7','4.99','131','16.99','PG','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('638','OPERATION OPERATION','A Intrepid Character Study of a Man And a Frisbee who must Overcome a Madman in Ancient China','2006','1',NULL,'7','2.99','156','23.99','G','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('639','OPPOSITE NECKLACE','A Fateful Epistle of a Crocodile And a Moose who must Kill a Explorer in Nigeria','2006','1',NULL,'7','4.99','92','9.99','PG','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('640','OPUS ICE','A Fast-Paced Drama of a Hunter And a Boy who must Discover a Feminist in The Sahara Desert','2006','1',NULL,'5','4.99','102','21.99','R','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('641','ORANGE GRAPES','A Astounding Documentary of a Butler And a Womanizer who must Face a Dog in A U-Boat','2006','1',NULL,'4','0.99','76','21.99','PG-13','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('642','ORDER BETRAYED','A Amazing Saga of a Dog And a A Shark who must Challenge a Cat in The Sahara Desert','2006','1',NULL,'7','2.99','120','13.99','PG-13','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('643','ORIENT CLOSER','A Astounding Epistle of a Technical Writer And a Teacher who must Fight a Squirrel in The Sahara Desert','2006','1',NULL,'3','2.99','118','22.99','R','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('644','OSCAR GOLD','A Insightful Tale of a Database Administrator And a Dog who must Face a Madman in Soviet Georgia','2006','1',NULL,'7','2.99','115','29.99','PG','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('645','OTHERS SOUP','A Lacklusture Documentary of a Mad Cow And a Madman who must Sink a Moose in The Gulf of Mexico','2006','1',NULL,'7','2.99','118','18.99','PG','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('646','OUTBREAK DIVINE','A Unbelieveable Yarn of a Database Administrator And a Woman who must Succumb a A Shark in A U-Boat','2006','1',NULL,'6','0.99','169','12.99','NC-17','Trailers,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('647','OUTFIELD MASSACRE','A Thoughtful Drama of a Husband And a Secret Agent who must Pursue a Database Administrator in Ancient India','2006','1',NULL,'4','0.99','129','18.99','NC-17','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('648','OUTLAW HANKY','A Thoughtful Story of a Astronaut And a Composer who must Conquer a Dog in The Sahara Desert','2006','1',NULL,'7','4.99','148','17.99','PG-13','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('649','OZ LIAISONS','A Epic Yarn of a Mad Scientist And a Cat who must Confront a Womanizer in A Baloon Factory','2006','1',NULL,'4','2.99','85','14.99','R','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('650','PACIFIC AMISTAD','A Thrilling Yarn of a Dog And a Moose who must Kill a Pastry Chef in A Manhattan Penthouse','2006','1',NULL,'3','0.99','144','27.99','G','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('651','PACKER MADIGAN','A Epic Display of a Sumo Wrestler And a Forensic Psychologist who must Build a Woman in An Abandoned Amusement Park','2006','1',NULL,'3','0.99','84','20.99','PG-13','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('652','PAJAMA JAWBREAKER','A Emotional Drama of a Boy And a Technical Writer who must Redeem a Sumo Wrestler in California','2006','1',NULL,'3','0.99','126','14.99','R','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('653','PANIC CLUB','A Fanciful Display of a Teacher And a Crocodile who must Succumb a Girl in A Baloon','2006','1',NULL,'3','4.99','102','15.99','G','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('654','PANKY SUBMARINE','A Touching Documentary of a Dentist And a Sumo Wrestler who must Overcome a Boy in The Gulf of Mexico','2006','1',NULL,'4','4.99','93','19.99','G','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('655','PANTHER REDS','A Brilliant Panorama of a Moose And a Man who must Reach a Teacher in The Gulf of Mexico','2006','1',NULL,'5','4.99','109','22.99','NC-17','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('656','PAPI NECKLACE','A Fanciful Display of a Car And a Monkey who must Escape a Squirrel in Ancient Japan','2006','1',NULL,'3','0.99','128','9.99','PG','Trailers,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('657','PARADISE SABRINA','A Intrepid Yarn of a Car And a Moose who must Outrace a Crocodile in A Manhattan Penthouse','2006','1',NULL,'5','2.99','48','12.99','PG-13','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('658','PARIS WEEKEND','A Intrepid Story of a Squirrel And a Crocodile who must Defeat a Monkey in The Outback','2006','1',NULL,'7','2.99','121','19.99','PG-13','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('659','PARK CITIZEN','A Taut Epistle of a Sumo Wrestler And a Girl who must Face a Husband in Ancient Japan','2006','1',NULL,'3','4.99','109','14.99','PG-13','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('660','PARTY KNOCK','A Fateful Display of a Technical Writer And a Butler who must Battle a Sumo Wrestler in An Abandoned Mine Shaft','2006','1',NULL,'7','2.99','107','11.99','PG','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('661','PAST SUICIDES','A Intrepid Tale of a Madman And a Astronaut who must Challenge a Hunter in A Monastery','2006','1',NULL,'5','4.99','157','17.99','PG-13','Trailers,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('662','PATHS CONTROL','A Astounding Documentary of a Butler And a Cat who must Find a Frisbee in Ancient China','2006','1',NULL,'3','4.99','118','9.99','PG','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('663','PATIENT SISTER','A Emotional Epistle of a Squirrel And a Robot who must Confront a Lumberjack in Soviet Georgia','2006','1',NULL,'7','0.99','99','29.99','NC-17','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('664','PATRIOT ROMAN','A Taut Saga of a Robot And a Database Administrator who must Challenge a Astronaut in California','2006','1',NULL,'6','2.99','65','12.99','PG','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('665','PATTON INTERVIEW','A Thrilling Documentary of a Composer And a Secret Agent who must Succumb a Cat in Berlin','2006','1',NULL,'4','2.99','175','22.99','PG','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('666','PAYCHECK WAIT','A Awe-Inspiring Reflection of a Boy And a Man who must Discover a Moose in The Sahara Desert','2006','1',NULL,'4','4.99','145','27.99','PG-13','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('667','PEACH INNOCENT','A Action-Packed Drama of a Monkey And a Dentist who must Chase a Butler in Berlin','2006','1',NULL,'3','2.99','160','20.99','PG-13','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('668','PEAK FOREVER','A Insightful Reflection of a Boat And a Secret Agent who must Vanquish a Astronaut in An Abandoned Mine Shaft','2006','1',NULL,'7','4.99','80','25.99','PG','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('669','PEARL DESTINY','A Lacklusture Yarn of a Astronaut And a Pastry Chef who must Sink a Dog in A U-Boat','2006','1',NULL,'3','2.99','74','10.99','NC-17','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('670','PELICAN COMFORTS','A Epic Documentary of a Boy And a Monkey who must Pursue a Astronaut in Berlin','2006','1',NULL,'4','4.99','48','17.99','PG','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('671','PERDITION FARGO','A Fast-Paced Story of a Car And a Cat who must Outgun a Hunter in Berlin','2006','1',NULL,'7','4.99','99','27.99','NC-17','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('672','PERFECT GROOVE','A Thrilling Yarn of a Dog And a Dog who must Build a Husband in A Baloon','2006','1',NULL,'7','2.99','82','17.99','PG-13','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('673','PERSONAL LADYBUGS','A Epic Saga of a Hunter And a Technical Writer who must Conquer a Cat in Ancient Japan','2006','1',NULL,'3','0.99','118','19.99','PG-13','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('674','PET HAUNTING','A Unbelieveable Reflection of a Explorer And a Boat who must Conquer a Woman in California','2006','1',NULL,'3','0.99','99','11.99','PG','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('675','PHANTOM GLORY','A Beautiful Documentary of a Astronaut And a Crocodile who must Discover a Madman in A Monastery','2006','1',NULL,'6','2.99','60','17.99','NC-17','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('676','PHILADELPHIA WIFE','A Taut Yarn of a Hunter And a Astronaut who must Conquer a Database Administrator in The Sahara Desert','2006','1',NULL,'7','4.99','137','16.99','PG-13','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('677','PIANIST OUTFIELD','A Intrepid Story of a Boy And a Technical Writer who must Pursue a Lumberjack in A Monastery','2006','1',NULL,'6','0.99','136','25.99','NC-17','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('678','PICKUP DRIVING','A Touching Documentary of a Husband And a Boat who must Meet a Pastry Chef in A Baloon Factory','2006','1',NULL,'3','2.99','77','23.99','G','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('679','PILOT HOOSIERS','A Awe-Inspiring Reflection of a Crocodile And a Sumo Wrestler who must Meet a Forensic Psychologist in An Abandoned Mine Shaft','2006','1',NULL,'6','2.99','50','17.99','PG','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('680','PINOCCHIO SIMON','A Action-Packed Reflection of a Mad Scientist And a A Shark who must Find a Feminist in California','2006','1',NULL,'4','4.99','103','21.99','PG','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('681','PIRATES ROXANNE','A Stunning Drama of a Woman And a Lumberjack who must Overcome a A Shark in The Canadian Rockies','2006','1',NULL,'4','0.99','100','20.99','PG','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('682','PITTSBURGH HUNCHBACK','A Thrilling Epistle of a Boy And a Boat who must Find a Student in Soviet Georgia','2006','1',NULL,'4','4.99','134','17.99','PG-13','Trailers,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('683','PITY BOUND','A Boring Panorama of a Feminist And a Moose who must Defeat a Database Administrator in Nigeria','2006','1',NULL,'5','4.99','60','19.99','NC-17','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('684','PIZZA JUMANJI','A Epic Saga of a Cat And a Squirrel who must Outgun a Robot in A U-Boat','2006','1',NULL,'4','2.99','173','11.99','NC-17','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('685','PLATOON INSTINCT','A Thrilling Panorama of a Man And a Woman who must Reach a Woman in Australia','2006','1',NULL,'6','4.99','132','10.99','PG-13','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('686','PLUTO OLEANDER','A Action-Packed Reflection of a Car And a Moose who must Outgun a Car in A Shark Tank','2006','1',NULL,'5','4.99','84','9.99','R','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('687','POCUS PULP','A Intrepid Yarn of a Frisbee And a Dog who must Build a Astronaut in A Baloon Factory','2006','1',NULL,'6','0.99','138','15.99','NC-17','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('688','POLISH BROOKLYN','A Boring Character Study of a Database Administrator And a Lumberjack who must Reach a Madman in The Outback','2006','1',NULL,'6','0.99','61','12.99','PG','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('689','POLLOCK DELIVERANCE','A Intrepid Story of a Madman And a Frisbee who must Outgun a Boat in The Sahara Desert','2006','1',NULL,'5','2.99','137','14.99','PG','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('690','POND SEATTLE','A Stunning Drama of a Teacher And a Boat who must Battle a Feminist in Ancient China','2006','1',NULL,'7','2.99','185','25.99','PG-13','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('691','POSEIDON FOREVER','A Thoughtful Epistle of a Womanizer And a Monkey who must Vanquish a Dentist in A Monastery','2006','1',NULL,'6','4.99','159','29.99','PG-13','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('692','POTLUCK MIXED','A Beautiful Story of a Dog And a Technical Writer who must Outgun a Student in A Baloon','2006','1',NULL,'3','2.99','179','10.99','G','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('693','POTTER CONNECTICUT','A Thrilling Epistle of a Frisbee And a Cat who must Fight a Technical Writer in Berlin','2006','1',NULL,'5','2.99','115','16.99','PG','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('694','PREJUDICE OLEANDER','A Epic Saga of a Boy And a Dentist who must Outrace a Madman in A U-Boat','2006','1',NULL,'6','4.99','98','15.99','PG-13','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('695','PRESIDENT BANG','A Fateful Panorama of a Technical Writer And a Moose who must Battle a Robot in Soviet Georgia','2006','1',NULL,'6','4.99','144','12.99','PG','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('696','PRIDE ALAMO','A Thoughtful Drama of a A Shark And a Forensic Psychologist who must Vanquish a Student in Ancient India','2006','1',NULL,'6','0.99','114','20.99','NC-17','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('697','PRIMARY GLASS','A Fateful Documentary of a Pastry Chef And a Butler who must Build a Dog in The Canadian Rockies','2006','1',NULL,'7','0.99','53','16.99','G','Trailers,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('698','PRINCESS GIANT','A Thrilling Yarn of a Pastry Chef And a Monkey who must Battle a Monkey in A Shark Tank','2006','1',NULL,'3','2.99','71','29.99','NC-17','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('699','PRIVATE DROP','A Stunning Story of a Technical Writer And a Hunter who must Succumb a Secret Agent in A Baloon','2006','1',NULL,'7','4.99','106','26.99','PG','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('700','PRIX UNDEFEATED','A Stunning Saga of a Mad Scientist And a Boat who must Overcome a Dentist in Ancient China','2006','1',NULL,'4','2.99','115','13.99','R','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('701','PSYCHO SHRUNK','A Amazing Panorama of a Crocodile And a Explorer who must Fight a Husband in Nigeria','2006','1',NULL,'5','2.99','155','11.99','PG-13','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('702','PULP BEVERLY','A Unbelieveable Display of a Dog And a Crocodile who must Outrace a Man in Nigeria','2006','1',NULL,'4','2.99','89','12.99','G','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('703','PUNK DIVORCE','A Fast-Paced Tale of a Pastry Chef And a Boat who must Face a Frisbee in The Canadian Rockies','2006','1',NULL,'6','4.99','100','18.99','PG','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('704','PURE RUNNER','A Thoughtful Documentary of a Student And a Madman who must Challenge a Squirrel in A Manhattan Penthouse','2006','1',NULL,'3','2.99','121','25.99','NC-17','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('705','PURPLE MOVIE','A Boring Display of a Pastry Chef And a Sumo Wrestler who must Discover a Frisbee in An Abandoned Amusement Park','2006','1',NULL,'4','2.99','88','9.99','R','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('706','QUEEN LUKE','A Astounding Story of a Girl And a Boy who must Challenge a Composer in New Orleans','2006','1',NULL,'5','4.99','163','22.99','PG','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('707','QUEST MUSSOLINI','A Fateful Drama of a Husband And a Sumo Wrestler who must Battle a Pastry Chef in A Baloon Factory','2006','1',NULL,'5','2.99','177','29.99','R','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('708','QUILLS BULL','A Thoughtful Story of a Pioneer And a Woman who must Reach a Moose in Australia','2006','1',NULL,'4','4.99','112','19.99','R','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('709','RACER EGG','A Emotional Display of a Monkey And a Waitress who must Reach a Secret Agent in California','2006','1',NULL,'7','2.99','147','19.99','NC-17','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('710','RAGE GAMES','A Fast-Paced Saga of a Astronaut And a Secret Agent who must Escape a Hunter in An Abandoned Amusement Park','2006','1',NULL,'4','4.99','120','18.99','R','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('711','RAGING AIRPLANE','A Astounding Display of a Secret Agent And a Technical Writer who must Escape a Mad Scientist in A Jet Boat','2006','1',NULL,'4','4.99','154','18.99','R','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('712','RAIDERS ANTITRUST','A Amazing Drama of a Teacher And a Feminist who must Meet a Woman in The First Manned Space Station','2006','1',NULL,'4','0.99','82','11.99','PG-13','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('713','RAINBOW SHOCK','A Action-Packed Story of a Hunter And a Boy who must Discover a Lumberjack in Ancient India','2006','1',NULL,'3','4.99','74','14.99','PG','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('714','RANDOM GO','A Fateful Drama of a Frisbee And a Student who must Confront a Cat in A Shark Tank','2006','1',NULL,'6','2.99','73','29.99','NC-17','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('715','RANGE MOONWALKER','A Insightful Documentary of a Hunter And a Dentist who must Confront a Crocodile in A Baloon','2006','1',NULL,'3','4.99','147','25.99','PG','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('716','REAP UNFAITHFUL','A Thrilling Epistle of a Composer And a Sumo Wrestler who must Challenge a Mad Cow in A MySQL Convention','2006','1',NULL,'6','2.99','136','26.99','PG-13','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('717','REAR TRADING','A Awe-Inspiring Reflection of a Forensic Psychologist And a Secret Agent who must Succumb a Pastry Chef in Soviet Georgia','2006','1',NULL,'6','0.99','97','23.99','NC-17','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('718','REBEL AIRPORT','A Intrepid Yarn of a Database Administrator And a Boat who must Outrace a Husband in Ancient India','2006','1',NULL,'7','0.99','73','24.99','G','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('719','RECORDS ZORRO','A Amazing Drama of a Mad Scientist And a Composer who must Build a Husband in The Outback','2006','1',NULL,'7','4.99','182','11.99','PG','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('720','REDEMPTION COMFORTS','A Emotional Documentary of a Dentist And a Woman who must Battle a Mad Scientist in Ancient China','2006','1',NULL,'3','2.99','179','20.99','NC-17','Trailers,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('721','REDS POCUS','A Lacklusture Yarn of a Sumo Wrestler And a Squirrel who must Redeem a Monkey in Soviet Georgia','2006','1',NULL,'7','4.99','182','23.99','PG-13','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('722','REEF SALUTE','A Action-Packed Saga of a Teacher And a Lumberjack who must Battle a Dentist in A Baloon','2006','1',NULL,'5','0.99','123','26.99','NC-17','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('723','REIGN GENTLEMEN','A Emotional Yarn of a Composer And a Man who must Escape a Butler in The Gulf of Mexico','2006','1',NULL,'3','2.99','82','29.99','PG-13','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('724','REMEMBER DIARY','A Insightful Tale of a Technical Writer And a Waitress who must Conquer a Monkey in Ancient India','2006','1',NULL,'5','2.99','110','15.99','R','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('725','REQUIEM TYCOON','A Unbelieveable Character Study of a Cat And a Database Administrator who must Pursue a Teacher in A Monastery','2006','1',NULL,'6','4.99','167','25.99','R','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('726','RESERVOIR ADAPTATION','A Intrepid Drama of a Teacher And a Moose who must Kill a Car in California','2006','1',NULL,'7','2.99','61','29.99','PG-13','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('727','RESURRECTION SILVERADO','A Epic Yarn of a Robot And a Explorer who must Challenge a Girl in A MySQL Convention','2006','1',NULL,'6','0.99','117','12.99','PG','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('728','REUNION WITCHES','A Unbelieveable Documentary of a Database Administrator And a Frisbee who must Redeem a Mad Scientist in A Baloon Factory','2006','1',NULL,'3','0.99','63','26.99','R','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('729','RIDER CADDYSHACK','A Taut Reflection of a Monkey And a Womanizer who must Chase a Moose in Nigeria','2006','1',NULL,'5','2.99','177','28.99','PG','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('730','RIDGEMONT SUBMARINE','A Unbelieveable Drama of a Waitress And a Composer who must Sink a Mad Cow in Ancient Japan','2006','1',NULL,'3','0.99','46','28.99','PG-13','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('731','RIGHT CRANES','A Fateful Character Study of a Boat And a Cat who must Find a Database Administrator in A Jet Boat','2006','1',NULL,'7','4.99','153','29.99','PG-13','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('732','RINGS HEARTBREAKERS','A Amazing Yarn of a Sumo Wrestler And a Boat who must Conquer a Waitress in New Orleans','2006','1',NULL,'5','0.99','58','17.99','G','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('733','RIVER OUTLAW','A Thrilling Character Study of a Squirrel And a Lumberjack who must Face a Hunter in A MySQL Convention','2006','1',NULL,'4','0.99','149','29.99','PG-13','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('734','ROAD ROXANNE','A Boring Character Study of a Waitress And a Astronaut who must Fight a Crocodile in Ancient Japan','2006','1',NULL,'4','4.99','158','12.99','R','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('735','ROBBERS JOON','A Thoughtful Story of a Mad Scientist And a Waitress who must Confront a Forensic Psychologist in Soviet Georgia','2006','1',NULL,'7','2.99','102','26.99','PG-13','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('736','ROBBERY BRIGHT','A Taut Reflection of a Robot And a Squirrel who must Fight a Boat in Ancient Japan','2006','1',NULL,'4','0.99','134','21.99','R','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('737','ROCK INSTINCT','A Astounding Character Study of a Robot And a Moose who must Overcome a Astronaut in Ancient India','2006','1',NULL,'4','0.99','102','28.99','G','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('738','ROCKETEER MOTHER','A Awe-Inspiring Character Study of a Robot And a Sumo Wrestler who must Discover a Womanizer in A Shark Tank','2006','1',NULL,'3','0.99','178','27.99','PG-13','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('739','ROCKY WAR','A Fast-Paced Display of a Squirrel And a Explorer who must Outgun a Mad Scientist in Nigeria','2006','1',NULL,'4','4.99','145','17.99','PG-13','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('740','ROLLERCOASTER BRINGING','A Beautiful Drama of a Robot And a Lumberjack who must Discover a Technical Writer in A Shark Tank','2006','1',NULL,'5','2.99','153','13.99','PG-13','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('741','ROMAN PUNK','A Thoughtful Panorama of a Mad Cow And a Student who must Battle a Forensic Psychologist in Berlin','2006','1',NULL,'7','0.99','81','28.99','NC-17','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('742','ROOF CHAMPION','A Lacklusture Reflection of a Car And a Explorer who must Find a Monkey in A Baloon','2006','1',NULL,'7','0.99','101','25.99','R','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('743','ROOM ROMAN','A Awe-Inspiring Panorama of a Composer And a Secret Agent who must Sink a Composer in A Shark Tank','2006','1',NULL,'7','0.99','60','27.99','PG','Trailers,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('744','ROOTS REMEMBER','A Brilliant Drama of a Mad Cow And a Hunter who must Escape a Hunter in Berlin','2006','1',NULL,'4','0.99','89','23.99','PG-13','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('745','ROSES TREASURE','A Astounding Panorama of a Monkey And a Secret Agent who must Defeat a Woman in The First Manned Space Station','2006','1',NULL,'5','4.99','162','23.99','PG-13','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('746','ROUGE SQUAD','A Awe-Inspiring Drama of a Astronaut And a Frisbee who must Conquer a Mad Scientist in Australia','2006','1',NULL,'3','0.99','118','10.99','NC-17','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('747','ROXANNE REBEL','A Astounding Story of a Pastry Chef And a Database Administrator who must Fight a Man in The Outback','2006','1',NULL,'5','0.99','171','9.99','R','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('748','RUGRATS SHAKESPEARE','A Touching Saga of a Crocodile And a Crocodile who must Discover a Technical Writer in Nigeria','2006','1',NULL,'4','0.99','109','16.99','PG-13','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('749','RULES HUMAN','A Beautiful Epistle of a Astronaut And a Student who must Confront a Monkey in An Abandoned Fun House','2006','1',NULL,'6','4.99','153','19.99','R','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('750','RUN PACIFIC','A Touching Tale of a Cat And a Pastry Chef who must Conquer a Pastry Chef in A MySQL Convention','2006','1',NULL,'3','0.99','145','25.99','R','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('751','RUNAWAY TENENBAUMS','A Thoughtful Documentary of a Boat And a Man who must Meet a Boat in An Abandoned Fun House','2006','1',NULL,'6','0.99','181','17.99','NC-17','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('752','RUNNER MADIGAN','A Thoughtful Documentary of a Crocodile And a Robot who must Outrace a Womanizer in The Outback','2006','1',NULL,'6','0.99','101','27.99','NC-17','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('753','RUSH GOODFELLAS','A Emotional Display of a Man And a Dentist who must Challenge a Squirrel in Australia','2006','1',NULL,'3','0.99','48','20.99','PG','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('754','RUSHMORE MERMAID','A Boring Story of a Woman And a Moose who must Reach a Husband in A Shark Tank','2006','1',NULL,'6','2.99','150','17.99','PG-13','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('755','SABRINA MIDNIGHT','A Emotional Story of a Squirrel And a Crocodile who must Succumb a Husband in The Sahara Desert','2006','1',NULL,'5','4.99','99','11.99','PG','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('756','SADDLE ANTITRUST','A Stunning Epistle of a Feminist And a A Shark who must Battle a Woman in An Abandoned Fun House','2006','1',NULL,'7','2.99','80','10.99','PG-13','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('757','SAGEBRUSH CLUELESS','A Insightful Story of a Lumberjack And a Hunter who must Kill a Boy in Ancient Japan','2006','1',NULL,'4','2.99','106','28.99','G','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('758','SAINTS BRIDE','A Fateful Tale of a Technical Writer And a Composer who must Pursue a Explorer in The Gulf of Mexico','2006','1',NULL,'5','2.99','125','11.99','G','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('759','SALUTE APOLLO','A Awe-Inspiring Character Study of a Boy And a Feminist who must Sink a Crocodile in Ancient China','2006','1',NULL,'4','2.99','73','29.99','R','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('760','SAMURAI LION','A Fast-Paced Story of a Pioneer And a Astronaut who must Reach a Boat in A Baloon','2006','1',NULL,'5','2.99','110','21.99','G','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('761','SANTA PARIS','A Emotional Documentary of a Moose And a Car who must Redeem a Mad Cow in A Baloon Factory','2006','1',NULL,'7','2.99','154','23.99','PG','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('762','SASSY PACKER','A Fast-Paced Documentary of a Dog And a Teacher who must Find a Moose in A Manhattan Penthouse','2006','1',NULL,'6','0.99','154','29.99','G','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('763','SATISFACTION CONFIDENTIAL','A Lacklusture Yarn of a Dentist And a Butler who must Meet a Secret Agent in Ancient China','2006','1',NULL,'3','4.99','75','26.99','G','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('764','SATURDAY LAMBS','A Thoughtful Reflection of a Mad Scientist And a Moose who must Kill a Husband in A Baloon','2006','1',NULL,'3','4.99','150','28.99','G','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('765','SATURN NAME','A Fateful Epistle of a Butler And a Boy who must Redeem a Teacher in Berlin','2006','1',NULL,'7','4.99','182','18.99','R','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('766','SAVANNAH TOWN','A Awe-Inspiring Tale of a Astronaut And a Database Administrator who must Chase a Secret Agent in The Gulf of Mexico','2006','1',NULL,'5','0.99','84','25.99','PG-13','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('767','SCALAWAG DUCK','A Fateful Reflection of a Car And a Teacher who must Confront a Waitress in A Monastery','2006','1',NULL,'6','4.99','183','13.99','NC-17','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('768','SCARFACE BANG','A Emotional Yarn of a Teacher And a Girl who must Find a Teacher in A Baloon Factory','2006','1',NULL,'3','4.99','102','11.99','PG-13','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('769','SCHOOL JACKET','A Intrepid Yarn of a Monkey And a Boy who must Fight a Composer in A Manhattan Penthouse','2006','1',NULL,'5','4.99','151','21.99','PG-13','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('770','SCISSORHANDS SLUMS','A Awe-Inspiring Drama of a Girl And a Technical Writer who must Meet a Feminist in The Canadian Rockies','2006','1',NULL,'5','2.99','147','13.99','G','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('771','SCORPION APOLLO','A Awe-Inspiring Documentary of a Technical Writer And a Husband who must Meet a Monkey in An Abandoned Fun House','2006','1',NULL,'3','4.99','137','23.99','NC-17','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('772','SEA VIRGIN','A Fast-Paced Documentary of a Technical Writer And a Pastry Chef who must Escape a Moose in A U-Boat','2006','1',NULL,'4','2.99','80','24.99','PG','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('773','SEABISCUIT PUNK','A Insightful Saga of a Man And a Forensic Psychologist who must Discover a Mad Cow in A MySQL Convention','2006','1',NULL,'6','2.99','112','28.99','NC-17','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('774','SEARCHERS WAIT','A Fast-Paced Tale of a Car And a Mad Scientist who must Kill a Womanizer in Ancient Japan','2006','1',NULL,'3','2.99','182','22.99','NC-17','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('775','SEATTLE EXPECATIONS','A Insightful Reflection of a Crocodile And a Sumo Wrestler who must Meet a Technical Writer in The Sahara Desert','2006','1',NULL,'4','4.99','110','18.99','PG-13','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('776','SECRET GROUNDHOG','A Astounding Story of a Cat And a Database Administrator who must Build a Technical Writer in New Orleans','2006','1',NULL,'6','4.99','90','11.99','PG','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('777','SECRETARY ROUGE','A Action-Packed Panorama of a Mad Cow And a Composer who must Discover a Robot in A Baloon Factory','2006','1',NULL,'5','4.99','158','10.99','PG','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('778','SECRETS PARADISE','A Fateful Saga of a Cat And a Frisbee who must Kill a Girl in A Manhattan Penthouse','2006','1',NULL,'3','4.99','109','24.99','G','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('779','SENSE GREEK','A Taut Saga of a Lumberjack And a Pastry Chef who must Escape a Sumo Wrestler in An Abandoned Fun House','2006','1',NULL,'4','4.99','54','23.99','R','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('780','SENSIBILITY REAR','A Emotional Tale of a Robot And a Sumo Wrestler who must Redeem a Pastry Chef in A Baloon Factory','2006','1',NULL,'7','4.99','98','15.99','PG','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('781','SEVEN SWARM','A Unbelieveable Character Study of a Dog And a Mad Cow who must Kill a Monkey in Berlin','2006','1',NULL,'4','4.99','127','15.99','R','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('782','SHAKESPEARE SADDLE','A Fast-Paced Panorama of a Lumberjack And a Database Administrator who must Defeat a Madman in A MySQL Convention','2006','1',NULL,'6','2.99','60','26.99','PG-13','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('783','SHANE DARKNESS','A Action-Packed Saga of a Moose And a Lumberjack who must Find a Woman in Berlin','2006','1',NULL,'5','2.99','93','22.99','PG','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('784','SHANGHAI TYCOON','A Fast-Paced Character Study of a Crocodile And a Lumberjack who must Build a Husband in An Abandoned Fun House','2006','1',NULL,'7','2.99','47','20.99','PG','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('785','SHAWSHANK BUBBLE','A Lacklusture Story of a Moose And a Monkey who must Confront a Butler in An Abandoned Amusement Park','2006','1',NULL,'6','4.99','80','20.99','PG','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('786','SHEPHERD MIDSUMMER','A Thoughtful Drama of a Robot And a Womanizer who must Kill a Lumberjack in A Baloon','2006','1',NULL,'7','0.99','113','14.99','R','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('787','SHINING ROSES','A Awe-Inspiring Character Study of a Astronaut And a Forensic Psychologist who must Challenge a Madman in Ancient India','2006','1',NULL,'4','0.99','125','12.99','G','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('788','SHIP WONDERLAND','A Thrilling Saga of a Monkey And a Frisbee who must Escape a Explorer in The Outback','2006','1',NULL,'5','2.99','104','15.99','R','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('789','SHOCK CABIN','A Fateful Tale of a Mad Cow And a Crocodile who must Meet a Husband in New Orleans','2006','1',NULL,'7','2.99','79','15.99','PG-13','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('790','SHOOTIST SUPERFLY','A Fast-Paced Story of a Crocodile And a A Shark who must Sink a Pioneer in Berlin','2006','1',NULL,'6','0.99','67','22.99','PG-13','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('791','SHOW LORD','A Fanciful Saga of a Student And a Girl who must Find a Butler in Ancient Japan','2006','1',NULL,'3','4.99','167','24.99','PG-13','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('792','SHREK LICENSE','A Fateful Yarn of a Secret Agent And a Feminist who must Find a Feminist in A Jet Boat','2006','1',NULL,'7','2.99','154','15.99','PG-13','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('793','SHRUNK DIVINE','A Fateful Character Study of a Waitress And a Technical Writer who must Battle a Hunter in A Baloon','2006','1',NULL,'6','2.99','139','14.99','R','Trailers,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('794','SIDE ARK','A Stunning Panorama of a Crocodile And a Womanizer who must Meet a Feminist in The Canadian Rockies','2006','1',NULL,'5','0.99','52','28.99','G','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('795','SIEGE MADRE','A Boring Tale of a Frisbee And a Crocodile who must Vanquish a Moose in An Abandoned Mine Shaft','2006','1',NULL,'7','0.99','111','23.99','R','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('796','SIERRA DIVIDE','A Emotional Character Study of a Frisbee And a Mad Scientist who must Build a Madman in California','2006','1',NULL,'3','0.99','135','12.99','NC-17','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('797','SILENCE KANE','A Emotional Drama of a Sumo Wrestler And a Dentist who must Confront a Sumo Wrestler in A Baloon','2006','1',NULL,'7','0.99','67','23.99','R','Trailers,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('798','SILVERADO GOLDFINGER','A Stunning Epistle of a Sumo Wrestler And a Man who must Challenge a Waitress in Ancient India','2006','1',NULL,'4','4.99','74','11.99','PG','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('799','SIMON NORTH','A Thrilling Documentary of a Technical Writer And a A Shark who must Face a Pioneer in A Shark Tank','2006','1',NULL,'3','0.99','51','26.99','NC-17','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('800','SINNERS ATLANTIS','A Epic Display of a Dog And a Boat who must Succumb a Mad Scientist in An Abandoned Mine Shaft','2006','1',NULL,'7','2.99','126','19.99','PG-13','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('801','SISTER FREDDY','A Stunning Saga of a Butler And a Woman who must Pursue a Explorer in Australia','2006','1',NULL,'5','4.99','152','19.99','PG-13','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('802','SKY MIRACLE','A Epic Drama of a Mad Scientist And a Explorer who must Succumb a Waitress in An Abandoned Fun House','2006','1',NULL,'7','2.99','132','15.99','PG','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('803','SLACKER LIAISONS','A Fast-Paced Tale of a A Shark And a Student who must Meet a Crocodile in Ancient China','2006','1',NULL,'7','4.99','179','29.99','R','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('804','SLEEPING SUSPECTS','A Stunning Reflection of a Sumo Wrestler And a Explorer who must Sink a Frisbee in A MySQL Convention','2006','1',NULL,'7','4.99','129','13.99','PG-13','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('805','SLEEPLESS MONSOON','A Amazing Saga of a Moose And a Pastry Chef who must Escape a Butler in Australia','2006','1',NULL,'5','4.99','64','12.99','G','Trailers,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('806','SLEEPY JAPANESE','A Emotional Epistle of a Moose And a Composer who must Fight a Technical Writer in The Outback','2006','1',NULL,'4','2.99','137','25.99','PG','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('807','SLEUTH ORIENT','A Fateful Character Study of a Husband And a Dog who must Find a Feminist in Ancient India','2006','1',NULL,'4','0.99','87','25.99','NC-17','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('808','SLING LUKE','A Intrepid Character Study of a Robot And a Monkey who must Reach a Secret Agent in An Abandoned Amusement Park','2006','1',NULL,'5','0.99','84','10.99','R','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('809','SLIPPER FIDELITY','A Taut Reflection of a Secret Agent And a Man who must Redeem a Explorer in A MySQL Convention','2006','1',NULL,'5','0.99','156','14.99','PG-13','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('810','SLUMS DUCK','A Amazing Character Study of a Teacher And a Database Administrator who must Defeat a Waitress in A Jet Boat','2006','1',NULL,'5','0.99','147','21.99','PG','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('811','SMILE EARRING','A Intrepid Drama of a Teacher And a Butler who must Build a Pastry Chef in Berlin','2006','1',NULL,'4','2.99','60','29.99','G','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('812','SMOKING BARBARELLA','A Lacklusture Saga of a Mad Cow And a Mad Scientist who must Sink a Cat in A MySQL Convention','2006','1',NULL,'7','0.99','50','13.99','PG-13','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('813','SMOOCHY CONTROL','A Thrilling Documentary of a Husband And a Feminist who must Face a Mad Scientist in Ancient China','2006','1',NULL,'7','0.99','184','18.99','R','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('814','SNATCH SLIPPER','A Insightful Panorama of a Woman And a Feminist who must Defeat a Forensic Psychologist in Berlin','2006','1',NULL,'6','4.99','110','15.99','PG','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('815','SNATCHERS MONTEZUMA','A Boring Epistle of a Sumo Wrestler And a Woman who must Escape a Man in The Canadian Rockies','2006','1',NULL,'4','2.99','74','14.99','PG-13','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('816','SNOWMAN ROLLERCOASTER','A Fateful Display of a Lumberjack And a Girl who must Succumb a Mad Cow in A Manhattan Penthouse','2006','1',NULL,'3','0.99','62','27.99','G','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('817','SOLDIERS EVOLUTION','A Lacklusture Panorama of a A Shark And a Pioneer who must Confront a Student in The First Manned Space Station','2006','1',NULL,'7','4.99','185','27.99','R','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('818','SOMETHING DUCK','A Boring Character Study of a Car And a Husband who must Outgun a Frisbee in The First Manned Space Station','2006','1',NULL,'4','4.99','180','17.99','NC-17','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('819','SONG HEDWIG','A Amazing Documentary of a Man And a Husband who must Confront a Squirrel in A MySQL Convention','2006','1',NULL,'3','0.99','165','29.99','PG-13','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('820','SONS INTERVIEW','A Taut Character Study of a Explorer And a Mad Cow who must Battle a Hunter in Ancient China','2006','1',NULL,'3','2.99','184','11.99','NC-17','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('821','SORORITY QUEEN','A Fast-Paced Display of a Squirrel And a Composer who must Fight a Forensic Psychologist in A Jet Boat','2006','1',NULL,'6','0.99','184','17.99','NC-17','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('822','SOUP WISDOM','A Fast-Paced Display of a Robot And a Butler who must Defeat a Butler in A MySQL Convention','2006','1',NULL,'6','0.99','169','12.99','R','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('823','SOUTH WAIT','A Amazing Documentary of a Car And a Robot who must Escape a Lumberjack in An Abandoned Amusement Park','2006','1',NULL,'4','2.99','143','21.99','R','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('824','SPARTACUS CHEAPER','A Thrilling Panorama of a Pastry Chef And a Secret Agent who must Overcome a Student in A Manhattan Penthouse','2006','1',NULL,'4','4.99','52','19.99','NC-17','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('825','SPEAKEASY DATE','A Lacklusture Drama of a Forensic Psychologist And a Car who must Redeem a Man in A Manhattan Penthouse','2006','1',NULL,'6','2.99','165','22.99','PG-13','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('826','SPEED SUIT','A Brilliant Display of a Frisbee And a Mad Scientist who must Succumb a Robot in Ancient China','2006','1',NULL,'7','4.99','124','19.99','PG-13','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('827','SPICE SORORITY','A Fateful Display of a Pioneer And a Hunter who must Defeat a Husband in An Abandoned Mine Shaft','2006','1',NULL,'5','4.99','141','22.99','NC-17','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('828','SPIKING ELEMENT','A Lacklusture Epistle of a Dentist And a Technical Writer who must Find a Dog in A Monastery','2006','1',NULL,'7','2.99','79','12.99','G','Trailers,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('829','SPINAL ROCKY','A Lacklusture Epistle of a Sumo Wrestler And a Squirrel who must Defeat a Explorer in California','2006','1',NULL,'7','2.99','138','12.99','PG-13','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('830','SPIRIT FLINTSTONES','A Brilliant Yarn of a Cat And a Car who must Confront a Explorer in Ancient Japan','2006','1',NULL,'7','0.99','149','23.99','R','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('831','SPIRITED CASUALTIES','A Taut Story of a Waitress And a Man who must Face a Car in A Baloon Factory','2006','1',NULL,'5','0.99','138','20.99','PG-13','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('832','SPLASH GUMP','A Taut Saga of a Crocodile And a Boat who must Conquer a Hunter in A Shark Tank','2006','1',NULL,'5','0.99','175','16.99','PG','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('833','SPLENDOR PATTON','A Taut Story of a Dog And a Explorer who must Find a Astronaut in Berlin','2006','1',NULL,'5','0.99','134','20.99','R','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('834','SPOILERS HELLFIGHTERS','A Fanciful Story of a Technical Writer And a Squirrel who must Defeat a Dog in The Gulf of Mexico','2006','1',NULL,'4','0.99','151','26.99','G','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('835','SPY MILE','A Thrilling Documentary of a Feminist And a Feminist who must Confront a Feminist in A Baloon','2006','1',NULL,'6','2.99','112','13.99','PG-13','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('836','SQUAD FISH','A Fast-Paced Display of a Pastry Chef And a Dog who must Kill a Teacher in Berlin','2006','1',NULL,'3','2.99','136','14.99','PG','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('837','STAGE WORLD','A Lacklusture Panorama of a Woman And a Frisbee who must Chase a Crocodile in A Jet Boat','2006','1',NULL,'4','2.99','85','19.99','PG','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('838','STAGECOACH ARMAGEDDON','A Touching Display of a Pioneer And a Butler who must Chase a Car in California','2006','1',NULL,'5','4.99','112','25.99','R','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('839','STALLION SUNDANCE','A Fast-Paced Tale of a Car And a Dog who must Outgun a A Shark in Australia','2006','1',NULL,'5','0.99','130','23.99','PG-13','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('840','STAMPEDE DISTURBING','A Unbelieveable Tale of a Woman And a Lumberjack who must Fight a Frisbee in A U-Boat','2006','1',NULL,'5','0.99','75','26.99','R','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('841','STAR OPERATION','A Insightful Character Study of a Girl And a Car who must Pursue a Mad Cow in A Shark Tank','2006','1',NULL,'5','2.99','181','9.99','PG','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('842','STATE WASTELAND','A Beautiful Display of a Cat And a Pastry Chef who must Outrace a Mad Cow in A Jet Boat','2006','1',NULL,'4','2.99','113','13.99','NC-17','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('843','STEEL SANTA','A Fast-Paced Yarn of a Composer And a Frisbee who must Face a Moose in Nigeria','2006','1',NULL,'4','4.99','143','15.99','NC-17','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('844','STEERS ARMAGEDDON','A Stunning Character Study of a Car And a Girl who must Succumb a Car in A MySQL Convention','2006','1',NULL,'6','4.99','140','16.99','PG','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('845','STEPMOM DREAM','A Touching Epistle of a Crocodile And a Teacher who must Build a Forensic Psychologist in A MySQL Convention','2006','1',NULL,'7','4.99','48','9.99','NC-17','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('846','STING PERSONAL','A Fanciful Drama of a Frisbee And a Dog who must Fight a Madman in A Jet Boat','2006','1',NULL,'3','4.99','93','9.99','NC-17','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('847','STOCK GLASS','A Boring Epistle of a Crocodile And a Lumberjack who must Outgun a Moose in Ancient China','2006','1',NULL,'7','2.99','160','10.99','PG','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('848','STONE FIRE','A Intrepid Drama of a Astronaut And a Crocodile who must Find a Boat in Soviet Georgia','2006','1',NULL,'3','0.99','94','19.99','G','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('849','STORM HAPPINESS','A Insightful Drama of a Feminist And a A Shark who must Vanquish a Boat in A Shark Tank','2006','1',NULL,'6','0.99','57','28.99','NC-17','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('850','STORY SIDE','A Lacklusture Saga of a Boy And a Cat who must Sink a Dentist in An Abandoned Mine Shaft','2006','1',NULL,'7','0.99','163','27.99','R','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('851','STRAIGHT HOURS','A Boring Panorama of a Secret Agent And a Girl who must Sink a Waitress in The Outback','2006','1',NULL,'3','0.99','151','19.99','R','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('852','STRANGELOVE DESIRE','A Awe-Inspiring Panorama of a Lumberjack And a Waitress who must Defeat a Crocodile in An Abandoned Amusement Park','2006','1',NULL,'4','0.99','103','27.99','NC-17','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('853','STRANGER STRANGERS','A Awe-Inspiring Yarn of a Womanizer And a Explorer who must Fight a Woman in The First Manned Space Station','2006','1',NULL,'3','4.99','139','12.99','G','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('854','STRANGERS GRAFFITI','A Brilliant Character Study of a Secret Agent And a Man who must Find a Cat in The Gulf of Mexico','2006','1',NULL,'4','4.99','119','22.99','R','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('855','STREAK RIDGEMONT','A Astounding Character Study of a Hunter And a Waitress who must Sink a Man in New Orleans','2006','1',NULL,'7','0.99','132','28.99','PG-13','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('856','STREETCAR INTENTIONS','A Insightful Character Study of a Waitress And a Crocodile who must Sink a Waitress in The Gulf of Mexico','2006','1',NULL,'5','4.99','73','11.99','R','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('857','STRICTLY SCARFACE','A Touching Reflection of a Crocodile And a Dog who must Chase a Hunter in An Abandoned Fun House','2006','1',NULL,'3','2.99','144','24.99','PG-13','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('858','SUBMARINE BED','A Amazing Display of a Car And a Monkey who must Fight a Teacher in Soviet Georgia','2006','1',NULL,'5','4.99','127','21.99','R','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('859','SUGAR WONKA','A Touching Story of a Dentist And a Database Administrator who must Conquer a Astronaut in An Abandoned Amusement Park','2006','1',NULL,'3','4.99','114','20.99','PG','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('860','SUICIDES SILENCE','A Emotional Character Study of a Car And a Girl who must Face a Composer in A U-Boat','2006','1',NULL,'4','4.99','93','13.99','G','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('861','SUIT WALLS','A Touching Panorama of a Lumberjack And a Frisbee who must Build a Dog in Australia','2006','1',NULL,'3','4.99','111','12.99','R','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('862','SUMMER SCARFACE','A Emotional Panorama of a Lumberjack And a Hunter who must Meet a Girl in A Shark Tank','2006','1',NULL,'5','0.99','53','25.99','G','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('863','SUN CONFESSIONS','A Beautiful Display of a Mad Cow And a Dog who must Redeem a Waitress in An Abandoned Amusement Park','2006','1',NULL,'5','0.99','141','9.99','R','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('864','SUNDANCE INVASION','A Epic Drama of a Lumberjack And a Explorer who must Confront a Hunter in A Baloon Factory','2006','1',NULL,'5','0.99','92','21.99','NC-17','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('865','SUNRISE LEAGUE','A Beautiful Epistle of a Madman And a Butler who must Face a Crocodile in A Manhattan Penthouse','2006','1',NULL,'3','4.99','135','19.99','PG-13','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('866','SUNSET RACER','A Awe-Inspiring Reflection of a Astronaut And a A Shark who must Defeat a Forensic Psychologist in California','2006','1',NULL,'6','0.99','48','28.99','NC-17','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('867','SUPER WYOMING','A Action-Packed Saga of a Pastry Chef And a Explorer who must Discover a A Shark in The Outback','2006','1',NULL,'5','4.99','58','10.99','PG','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('868','SUPERFLY TRIP','A Beautiful Saga of a Lumberjack And a Teacher who must Build a Technical Writer in An Abandoned Fun House','2006','1',NULL,'5','0.99','114','27.99','PG','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('869','SUSPECTS QUILLS','A Emotional Epistle of a Pioneer And a Crocodile who must Battle a Man in A Manhattan Penthouse','2006','1',NULL,'4','2.99','47','22.99','PG','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('870','SWARM GOLD','A Insightful Panorama of a Crocodile And a Boat who must Conquer a Sumo Wrestler in A MySQL Convention','2006','1',NULL,'4','0.99','123','12.99','PG-13','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('871','SWEDEN SHINING','A Taut Documentary of a Car And a Robot who must Conquer a Boy in The Canadian Rockies','2006','1',NULL,'6','4.99','176','19.99','PG','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('872','SWEET BROTHERHOOD','A Unbelieveable Epistle of a Sumo Wrestler And a Hunter who must Chase a Forensic Psychologist in A Baloon','2006','1',NULL,'3','2.99','185','27.99','R','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('873','SWEETHEARTS SUSPECTS','A Brilliant Character Study of a Frisbee And a Sumo Wrestler who must Confront a Woman in The Gulf of Mexico','2006','1',NULL,'3','0.99','108','13.99','G','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('874','TADPOLE PARK','A Beautiful Tale of a Frisbee And a Moose who must Vanquish a Dog in An Abandoned Amusement Park','2006','1',NULL,'6','2.99','155','13.99','PG','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('875','TALENTED HOMICIDE','A Lacklusture Panorama of a Dentist And a Forensic Psychologist who must Outrace a Pioneer in A U-Boat','2006','1',NULL,'6','0.99','173','9.99','PG','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('876','TARZAN VIDEOTAPE','A Fast-Paced Display of a Lumberjack And a Mad Scientist who must Succumb a Sumo Wrestler in The Sahara Desert','2006','1',NULL,'3','2.99','91','11.99','PG-13','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('877','TAXI KICK','A Amazing Epistle of a Girl And a Woman who must Outrace a Waitress in Soviet Georgia','2006','1',NULL,'4','0.99','64','23.99','PG-13','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('878','TEEN APOLLO','A Awe-Inspiring Drama of a Dog And a Man who must Escape a Robot in A Shark Tank','2006','1',NULL,'3','4.99','74','25.99','G','Trailers,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('879','TELEGRAPH VOYAGE','A Fateful Yarn of a Husband And a Dog who must Battle a Waitress in A Jet Boat','2006','1',NULL,'3','4.99','148','20.99','PG','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('880','TELEMARK HEARTBREAKERS','A Action-Packed Panorama of a Technical Writer And a Man who must Build a Forensic Psychologist in A Manhattan Penthouse','2006','1',NULL,'6','2.99','152','9.99','PG-13','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('881','TEMPLE ATTRACTION','A Action-Packed Saga of a Forensic Psychologist And a Woman who must Battle a Womanizer in Soviet Georgia','2006','1',NULL,'5','4.99','71','13.99','PG','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('882','TENENBAUMS COMMAND','A Taut Display of a Pioneer And a Man who must Reach a Girl in The Gulf of Mexico','2006','1',NULL,'4','0.99','99','24.99','PG-13','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('883','TEQUILA PAST','A Action-Packed Panorama of a Mad Scientist And a Robot who must Challenge a Student in Nigeria','2006','1',NULL,'6','4.99','53','17.99','PG','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('884','TERMINATOR CLUB','A Touching Story of a Crocodile And a Girl who must Sink a Man in The Gulf of Mexico','2006','1',NULL,'5','4.99','88','11.99','R','Trailers,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('885','TEXAS WATCH','A Awe-Inspiring Yarn of a Student And a Teacher who must Fight a Teacher in An Abandoned Amusement Park','2006','1',NULL,'7','0.99','179','22.99','NC-17','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('886','THEORY MERMAID','A Fateful Yarn of a Composer And a Monkey who must Vanquish a Womanizer in The First Manned Space Station','2006','1',NULL,'5','0.99','184','9.99','PG-13','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('887','THIEF PELICAN','A Touching Documentary of a Madman And a Mad Scientist who must Outrace a Feminist in An Abandoned Mine Shaft','2006','1',NULL,'5','4.99','135','28.99','PG-13','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('888','THIN SAGEBRUSH','A Emotional Drama of a Husband And a Lumberjack who must Build a Cat in Ancient India','2006','1',NULL,'5','4.99','53','9.99','PG-13','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('889','TIES HUNGER','A Insightful Saga of a Astronaut And a Explorer who must Pursue a Mad Scientist in A U-Boat','2006','1',NULL,'3','4.99','111','28.99','R','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('890','TIGHTS DAWN','A Thrilling Epistle of a Boat And a Secret Agent who must Face a Boy in A Baloon','2006','1',NULL,'5','0.99','172','14.99','R','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('891','TIMBERLAND SKY','A Boring Display of a Man And a Dog who must Redeem a Girl in A U-Boat','2006','1',NULL,'3','0.99','69','13.99','G','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('892','TITANIC BOONDOCK','A Brilliant Reflection of a Feminist And a Dog who must Fight a Boy in A Baloon Factory','2006','1',NULL,'3','4.99','104','18.99','R','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('893','TITANS JERK','A Unbelieveable Panorama of a Feminist And a Sumo Wrestler who must Challenge a Technical Writer in Ancient China','2006','1',NULL,'4','4.99','91','11.99','PG','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('894','TOMATOES HELLFIGHTERS','A Thoughtful Epistle of a Madman And a Astronaut who must Overcome a Monkey in A Shark Tank','2006','1',NULL,'6','0.99','68','23.99','PG','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('895','TOMORROW HUSTLER','A Thoughtful Story of a Moose And a Husband who must Face a Secret Agent in The Sahara Desert','2006','1',NULL,'3','2.99','142','21.99','R','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('896','TOOTSIE PILOT','A Awe-Inspiring Documentary of a Womanizer And a Pastry Chef who must Kill a Lumberjack in Berlin','2006','1',NULL,'3','0.99','157','10.99','PG','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('897','TORQUE BOUND','A Emotional Display of a Crocodile And a Husband who must Reach a Man in Ancient Japan','2006','1',NULL,'3','4.99','179','27.99','G','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('898','TOURIST PELICAN','A Boring Story of a Butler And a Astronaut who must Outrace a Pioneer in Australia','2006','1',NULL,'4','4.99','152','18.99','PG-13','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('899','TOWERS HURRICANE','A Fateful Display of a Monkey And a Car who must Sink a Husband in A MySQL Convention','2006','1',NULL,'7','0.99','144','14.99','NC-17','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('900','TOWN ARK','A Awe-Inspiring Documentary of a Moose And a Madman who must Meet a Dog in An Abandoned Mine Shaft','2006','1',NULL,'6','2.99','136','17.99','R','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('901','TRACY CIDER','A Touching Reflection of a Database Administrator And a Madman who must Build a Lumberjack in Nigeria','2006','1',NULL,'3','0.99','142','29.99','G','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('902','TRADING PINOCCHIO','A Emotional Character Study of a Student And a Explorer who must Discover a Frisbee in The First Manned Space Station','2006','1',NULL,'6','4.99','170','22.99','PG','Trailers,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('903','TRAFFIC HOBBIT','A Amazing Epistle of a Squirrel And a Lumberjack who must Succumb a Database Administrator in A U-Boat','2006','1',NULL,'5','4.99','139','13.99','G','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('904','TRAIN BUNCH','A Thrilling Character Study of a Robot And a Squirrel who must Face a Dog in Ancient India','2006','1',NULL,'3','4.99','71','26.99','R','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('905','TRAINSPOTTING STRANGERS','A Fast-Paced Drama of a Pioneer And a Mad Cow who must Challenge a Madman in Ancient Japan','2006','1',NULL,'7','4.99','132','10.99','PG-13','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('906','TRAMP OTHERS','A Brilliant Display of a Composer And a Cat who must Succumb a A Shark in Ancient India','2006','1',NULL,'4','0.99','171','27.99','PG','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('907','TRANSLATION SUMMER','A Touching Reflection of a Man And a Monkey who must Pursue a Womanizer in A MySQL Convention','2006','1',NULL,'4','0.99','168','10.99','PG-13','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('908','TRAP GUYS','A Unbelieveable Story of a Boy And a Mad Cow who must Challenge a Database Administrator in The Sahara Desert','2006','1',NULL,'3','4.99','110','11.99','G','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('909','TREASURE COMMAND','A Emotional Saga of a Car And a Madman who must Discover a Pioneer in California','2006','1',NULL,'3','0.99','102','28.99','PG-13','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('910','TREATMENT JEKYLL','A Boring Story of a Teacher And a Student who must Outgun a Cat in An Abandoned Mine Shaft','2006','1',NULL,'3','0.99','87','19.99','PG','Trailers,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('911','TRIP NEWTON','A Fanciful Character Study of a Lumberjack And a Car who must Discover a Cat in An Abandoned Amusement Park','2006','1',NULL,'7','4.99','64','14.99','PG-13','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('912','TROJAN TOMORROW','A Astounding Panorama of a Husband And a Sumo Wrestler who must Pursue a Boat in Ancient India','2006','1',NULL,'3','2.99','52','9.99','PG','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('913','TROOPERS METAL','A Fanciful Drama of a Monkey And a Feminist who must Sink a Man in Berlin','2006','1',NULL,'3','0.99','115','20.99','R','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('914','TROUBLE DATE','A Lacklusture Panorama of a Forensic Psychologist And a Woman who must Kill a Explorer in Ancient Japan','2006','1',NULL,'6','2.99','61','13.99','PG','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('915','TRUMAN CRAZY','A Thrilling Epistle of a Moose And a Boy who must Meet a Database Administrator in A Monastery','2006','1',NULL,'7','4.99','92','9.99','G','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('916','TURN STAR','A Stunning Tale of a Man And a Monkey who must Chase a Student in New Orleans','2006','1',NULL,'3','2.99','80','10.99','G','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('917','TUXEDO MILE','A Boring Drama of a Man And a Forensic Psychologist who must Face a Frisbee in Ancient India','2006','1',NULL,'3','2.99','152','24.99','R','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('918','TWISTED PIRATES','A Touching Display of a Frisbee And a Boat who must Kill a Girl in A MySQL Convention','2006','1',NULL,'4','4.99','152','23.99','PG','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('919','TYCOON GATHERING','A Emotional Display of a Husband And a A Shark who must Succumb a Madman in A Manhattan Penthouse','2006','1',NULL,'3','4.99','82','17.99','G','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('920','UNBREAKABLE KARATE','A Amazing Character Study of a Robot And a Student who must Chase a Robot in Australia','2006','1',NULL,'3','0.99','62','16.99','G','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('921','UNCUT SUICIDES','A Intrepid Yarn of a Explorer And a Pastry Chef who must Pursue a Mad Cow in A U-Boat','2006','1',NULL,'7','2.99','172','29.99','PG-13','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('922','UNDEFEATED DALMATIONS','A Unbelieveable Display of a Crocodile And a Feminist who must Overcome a Moose in An Abandoned Amusement Park','2006','1',NULL,'7','4.99','107','22.99','PG-13','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('923','UNFAITHFUL KILL','A Taut Documentary of a Waitress And a Mad Scientist who must Battle a Technical Writer in New Orleans','2006','1',NULL,'7','2.99','78','12.99','R','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('924','UNFORGIVEN ZOOLANDER','A Taut Epistle of a Monkey And a Sumo Wrestler who must Vanquish a A Shark in A Baloon Factory','2006','1',NULL,'7','0.99','129','15.99','PG','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('925','UNITED PILOT','A Fast-Paced Reflection of a Cat And a Mad Cow who must Fight a Car in The Sahara Desert','2006','1',NULL,'3','0.99','164','27.99','R','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('926','UNTOUCHABLES SUNRISE','A Amazing Documentary of a Woman And a Astronaut who must Outrace a Teacher in An Abandoned Fun House','2006','1',NULL,'5','2.99','120','11.99','NC-17','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('927','UPRISING UPTOWN','A Fanciful Reflection of a Boy And a Butler who must Pursue a Woman in Berlin','2006','1',NULL,'6','2.99','174','16.99','NC-17','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('928','UPTOWN YOUNG','A Fateful Documentary of a Dog And a Hunter who must Pursue a Teacher in An Abandoned Amusement Park','2006','1',NULL,'5','2.99','84','16.99','PG','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('929','USUAL UNTOUCHABLES','A Touching Display of a Explorer And a Lumberjack who must Fight a Forensic Psychologist in A Shark Tank','2006','1',NULL,'5','4.99','128','21.99','PG-13','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('930','VACATION BOONDOCK','A Fanciful Character Study of a Secret Agent And a Mad Scientist who must Reach a Teacher in Australia','2006','1',NULL,'4','2.99','145','23.99','R','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('931','VALENTINE VANISHING','A Thrilling Display of a Husband And a Butler who must Reach a Pastry Chef in California','2006','1',NULL,'7','0.99','48','9.99','PG-13','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('932','VALLEY PACKER','A Astounding Documentary of a Astronaut And a Boy who must Outrace a Sumo Wrestler in Berlin','2006','1',NULL,'3','0.99','73','21.99','G','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('933','VAMPIRE WHALE','A Epic Story of a Lumberjack And a Monkey who must Confront a Pioneer in A MySQL Convention','2006','1',NULL,'4','4.99','126','11.99','NC-17','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('934','VANILLA DAY','A Fast-Paced Saga of a Girl And a Forensic Psychologist who must Redeem a Girl in Nigeria','2006','1',NULL,'7','4.99','122','20.99','NC-17','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('935','VANISHED GARDEN','A Intrepid Character Study of a Squirrel And a A Shark who must Kill a Lumberjack in California','2006','1',NULL,'5','0.99','142','17.99','R','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('936','VANISHING ROCKY','A Brilliant Reflection of a Man And a Woman who must Conquer a Pioneer in A MySQL Convention','2006','1',NULL,'3','2.99','123','21.99','NC-17','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('937','VARSITY TRIP','A Action-Packed Character Study of a Astronaut And a Explorer who must Reach a Monkey in A MySQL Convention','2006','1',NULL,'7','2.99','85','14.99','NC-17','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('938','VELVET TERMINATOR','A Lacklusture Tale of a Pastry Chef And a Technical Writer who must Confront a Crocodile in An Abandoned Amusement Park','2006','1',NULL,'3','4.99','173','14.99','R','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('939','VERTIGO NORTHWEST','A Unbelieveable Display of a Mad Scientist And a Mad Scientist who must Outgun a Mad Cow in Ancient Japan','2006','1',NULL,'4','2.99','90','17.99','R','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('940','VICTORY ACADEMY','A Insightful Epistle of a Mad Scientist And a Explorer who must Challenge a Cat in The Sahara Desert','2006','1',NULL,'6','0.99','64','19.99','PG-13','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('941','VIDEOTAPE ARSENIC','A Lacklusture Display of a Girl And a Astronaut who must Succumb a Student in Australia','2006','1',NULL,'4','4.99','145','10.99','NC-17','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('942','VIETNAM SMOOCHY','A Lacklusture Display of a Butler And a Man who must Sink a Explorer in Soviet Georgia','2006','1',NULL,'7','0.99','174','27.99','PG-13','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('943','VILLAIN DESPERATE','A Boring Yarn of a Pioneer And a Feminist who must Redeem a Cat in An Abandoned Amusement Park','2006','1',NULL,'4','4.99','76','27.99','PG-13','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('944','VIRGIN DAISY','A Awe-Inspiring Documentary of a Robot And a Mad Scientist who must Reach a Database Administrator in A Shark Tank','2006','1',NULL,'6','4.99','179','29.99','PG-13','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('945','VIRGINIAN PLUTO','A Emotional Panorama of a Dentist And a Crocodile who must Meet a Boy in Berlin','2006','1',NULL,'5','0.99','164','22.99','R','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('946','VIRTUAL SPOILERS','A Fateful Tale of a Database Administrator And a Squirrel who must Discover a Student in Soviet Georgia','2006','1',NULL,'3','4.99','144','14.99','NC-17','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('947','VISION TORQUE','A Thoughtful Documentary of a Dog And a Man who must Sink a Man in A Shark Tank','2006','1',NULL,'5','0.99','59','16.99','PG-13','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('948','VOICE PEACH','A Amazing Panorama of a Pioneer And a Student who must Overcome a Mad Scientist in A Manhattan Penthouse','2006','1',NULL,'6','0.99','139','22.99','PG-13','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('949','VOLCANO TEXAS','A Awe-Inspiring Yarn of a Hunter And a Feminist who must Challenge a Dentist in The Outback','2006','1',NULL,'6','0.99','157','27.99','NC-17','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('950','VOLUME HOUSE','A Boring Tale of a Dog And a Woman who must Meet a Dentist in California','2006','1',NULL,'7','4.99','132','12.99','PG','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('951','VOYAGE LEGALLY','A Epic Tale of a Squirrel And a Hunter who must Conquer a Boy in An Abandoned Mine Shaft','2006','1',NULL,'6','0.99','78','28.99','PG-13','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('952','WAGON JAWS','A Intrepid Drama of a Moose And a Boat who must Kill a Explorer in A Manhattan Penthouse','2006','1',NULL,'7','2.99','152','17.99','PG','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('953','WAIT CIDER','A Intrepid Epistle of a Woman And a Forensic Psychologist who must Succumb a Astronaut in A Manhattan Penthouse','2006','1',NULL,'3','0.99','112','9.99','PG-13','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('954','WAKE JAWS','A Beautiful Saga of a Feminist And a Composer who must Challenge a Moose in Berlin','2006','1',NULL,'7','4.99','73','18.99','G','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('955','WALLS ARTIST','A Insightful Panorama of a Teacher And a Teacher who must Overcome a Mad Cow in An Abandoned Fun House','2006','1',NULL,'7','4.99','135','19.99','PG','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('956','WANDA CHAMBER','A Insightful Drama of a A Shark And a Pioneer who must Find a Womanizer in The Outback','2006','1',NULL,'7','4.99','107','23.99','PG-13','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('957','WAR NOTTING','A Boring Drama of a Teacher And a Sumo Wrestler who must Challenge a Secret Agent in The Canadian Rockies','2006','1',NULL,'7','4.99','80','26.99','G','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('958','WARDROBE PHANTOM','A Action-Packed Display of a Mad Cow And a Astronaut who must Kill a Car in Ancient India','2006','1',NULL,'6','2.99','178','19.99','G','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('959','WARLOCK WEREWOLF','A Astounding Yarn of a Pioneer And a Crocodile who must Defeat a A Shark in The Outback','2006','1',NULL,'6','2.99','83','10.99','G','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('960','WARS PLUTO','A Taut Reflection of a Teacher And a Database Administrator who must Chase a Madman in The Sahara Desert','2006','1',NULL,'5','2.99','128','15.99','G','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('961','WASH HEAVENLY','A Awe-Inspiring Reflection of a Cat And a Pioneer who must Escape a Hunter in Ancient China','2006','1',NULL,'7','4.99','161','22.99','R','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('962','WASTELAND DIVINE','A Fanciful Story of a Database Administrator And a Womanizer who must Fight a Database Administrator in Ancient China','2006','1',NULL,'7','2.99','85','18.99','PG','Trailers,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('963','WATCH TRACY','A Fast-Paced Yarn of a Dog And a Frisbee who must Conquer a Hunter in Nigeria','2006','1',NULL,'5','0.99','78','12.99','PG','Trailers,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('964','WATERFRONT DELIVERANCE','A Unbelieveable Documentary of a Dentist And a Technical Writer who must Build a Womanizer in Nigeria','2006','1',NULL,'4','4.99','61','17.99','G','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('965','WATERSHIP FRONTIER','A Emotional Yarn of a Boat And a Crocodile who must Meet a Moose in Soviet Georgia','2006','1',NULL,'6','0.99','112','28.99','G','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('966','WEDDING APOLLO','A Action-Packed Tale of a Student And a Waitress who must Conquer a Lumberjack in An Abandoned Mine Shaft','2006','1',NULL,'3','0.99','70','14.99','PG','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('967','WEEKEND PERSONAL','A Fast-Paced Documentary of a Car And a Butler who must Find a Frisbee in A Jet Boat','2006','1',NULL,'5','2.99','134','26.99','R','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('968','WEREWOLF LOLA','A Fanciful Story of a Man And a Sumo Wrestler who must Outrace a Student in A Monastery','2006','1',NULL,'6','4.99','79','19.99','G','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('969','WEST LION','A Intrepid Drama of a Butler And a Lumberjack who must Challenge a Database Administrator in A Manhattan Penthouse','2006','1',NULL,'4','4.99','159','29.99','G','Trailers','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('970','WESTWARD SEABISCUIT','A Lacklusture Tale of a Butler And a Husband who must Face a Boy in Ancient China','2006','1',NULL,'7','0.99','52','11.99','NC-17','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('971','WHALE BIKINI','A Intrepid Story of a Pastry Chef And a Database Administrator who must Kill a Feminist in A MySQL Convention','2006','1',NULL,'4','4.99','109','11.99','PG-13','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('972','WHISPERER GIANT','A Intrepid Story of a Dentist And a Hunter who must Confront a Monkey in Ancient Japan','2006','1',NULL,'4','4.99','59','24.99','PG-13','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('973','WIFE TURN','A Awe-Inspiring Epistle of a Teacher And a Feminist who must Confront a Pioneer in Ancient Japan','2006','1',NULL,'3','4.99','183','27.99','NC-17','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('974','WILD APOLLO','A Beautiful Story of a Monkey And a Sumo Wrestler who must Conquer a A Shark in A MySQL Convention','2006','1',NULL,'4','0.99','181','24.99','R','Trailers,Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('975','WILLOW TRACY','A Brilliant Panorama of a Boat And a Astronaut who must Challenge a Teacher in A Manhattan Penthouse','2006','1',NULL,'6','2.99','137','22.99','R','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('976','WIND PHANTOM','A Touching Saga of a Madman And a Forensic Psychologist who must Build a Sumo Wrestler in An Abandoned Mine Shaft','2006','1',NULL,'6','0.99','111','12.99','R','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('977','WINDOW SIDE','A Astounding Character Study of a Womanizer And a Hunter who must Escape a Robot in A Monastery','2006','1',NULL,'3','2.99','85','25.99','R','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('978','WISDOM WORKER','A Unbelieveable Saga of a Forensic Psychologist And a Student who must Face a Squirrel in The First Manned Space Station','2006','1',NULL,'3','0.99','98','12.99','R','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('979','WITCHES PANIC','A Awe-Inspiring Drama of a Secret Agent And a Hunter who must Fight a Moose in Nigeria','2006','1',NULL,'6','4.99','100','10.99','NC-17','Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('980','WIZARD COLDBLOODED','A Lacklusture Display of a Robot And a Girl who must Defeat a Sumo Wrestler in A MySQL Convention','2006','1',NULL,'4','4.99','75','12.99','PG','Commentaries,Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('981','WOLVES DESIRE','A Fast-Paced Drama of a Squirrel And a Robot who must Succumb a Technical Writer in A Manhattan Penthouse','2006','1',NULL,'7','0.99','55','13.99','NC-17','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('982','WOMEN DORADO','A Insightful Documentary of a Waitress And a Butler who must Vanquish a Composer in Australia','2006','1',NULL,'4','0.99','126','23.99','R','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('983','WON DARES','A Unbelieveable Documentary of a Teacher And a Monkey who must Defeat a Explorer in A U-Boat','2006','1',NULL,'7','2.99','105','18.99','PG','Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('984','WONDERFUL DROP','A Boring Panorama of a Woman And a Madman who must Overcome a Butler in A U-Boat','2006','1',NULL,'3','2.99','126','20.99','NC-17','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('985','WONDERLAND CHRISTMAS','A Awe-Inspiring Character Study of a Waitress And a Car who must Pursue a Mad Scientist in The First Manned Space Station','2006','1',NULL,'4','4.99','111','19.99','PG','Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('986','WONKA SEA','A Brilliant Saga of a Boat And a Mad Scientist who must Meet a Moose in Ancient India','2006','1',NULL,'6','2.99','85','24.99','NC-17','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('987','WORDS HUNTER','A Action-Packed Reflection of a Composer And a Mad Scientist who must Face a Pioneer in A MySQL Convention','2006','1',NULL,'3','2.99','116','13.99','PG','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('988','WORKER TARZAN','A Action-Packed Yarn of a Secret Agent And a Technical Writer who must Battle a Sumo Wrestler in The First Manned Space Station','2006','1',NULL,'7','2.99','139','26.99','R','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('989','WORKING MICROCOSMOS','A Stunning Epistle of a Dentist And a Dog who must Kill a Madman in Ancient China','2006','1',NULL,'4','4.99','74','22.99','R','Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('990','WORLD LEATHERNECKS','A Unbelieveable Tale of a Pioneer And a Astronaut who must Overcome a Robot in An Abandoned Amusement Park','2006','1',NULL,'3','0.99','171','13.99','PG-13','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('991','WORST BANGER','A Thrilling Drama of a Madman And a Dentist who must Conquer a Boy in The Outback','2006','1',NULL,'4','2.99','185','26.99','PG','Deleted Scenes,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('992','WRATH MILE','A Intrepid Reflection of a Technical Writer And a Hunter who must Defeat a Sumo Wrestler in A Monastery','2006','1',NULL,'5','0.99','176','17.99','NC-17','Trailers,Commentaries','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('993','WRONG BEHAVIOR','A Emotional Saga of a Crocodile And a Sumo Wrestler who must Discover a Mad Cow in New Orleans','2006','1',NULL,'6','2.99','178','10.99','PG-13','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('994','WYOMING STORM','A Awe-Inspiring Panorama of a Robot And a Boat who must Overcome a Feminist in A U-Boat','2006','1',NULL,'6','4.99','100','29.99','PG-13','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('995','YENTL IDAHO','A Amazing Display of a Robot And a Astronaut who must Fight a Womanizer in Berlin','2006','1',NULL,'5','4.99','86','11.99','R','Trailers,Commentaries,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('996','YOUNG LANGUAGE','A Unbelieveable Yarn of a Boat And a Database Administrator who must Meet a Boy in The First Manned Space Station','2006','1',NULL,'6','0.99','183','9.99','G','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('997','YOUTH KICK','A Touching Drama of a Teacher And a Cat who must Challenge a Technical Writer in A U-Boat','2006','1',NULL,'4','0.99','179','14.99','NC-17','Trailers,Behind the Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('998','ZHIVAGO CORE','A Fateful Yarn of a Composer And a Man who must Face a Boy in The Canadian Rockies','2006','1',NULL,'6','0.99','105','10.99','NC-17','Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('999','ZOOLANDER FICTION','A Fateful Reflection of a Waitress And a Boat who must Discover a Sumo Wrestler in Ancient China','2006','1',NULL,'5','2.99','101','28.99','R','Trailers,Deleted Scenes','2006-02-15T05:03:42.000')
;
Insert into film
 (film_id,title,description,release_year,language_id,original_language_id,rental_duration,rental_rate,length,replacement_cost,rating,special_features,last_update)
Values
('1000','ZORRO ARK','A Intrepid Panorama of a Mad Scientist And a Boy who must Redeem a Boy in A Monastery','2006','1',NULL,'3','4.99','50','18.99','NC-17','Trailers,Commentaries,Behind the Scenes','2006-02-15T05:03:42.000')
;
SET IDENTITY_INSERT film OFF

-- End of Script
--
--
-- Automatically generated by Advanced ETl Processor
-- http://www.etl-tools.com/
-- table country
-- Start of script

SET IDENTITY_INSERT inventory ON

Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1','1','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2','1','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3','1','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4','1','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('5','1','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('6','1','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('7','1','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('8','1','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('9','2','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('10','2','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('11','2','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('12','3','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('13','3','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('14','3','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('15','3','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('16','4','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('17','4','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('18','4','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('19','4','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('20','4','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('21','4','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('22','4','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('23','5','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('24','5','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('25','5','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('26','6','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('27','6','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('28','6','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('29','6','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('30','6','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('31','6','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('32','7','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('33','7','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('34','7','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('35','7','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('36','7','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('37','8','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('38','8','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('39','8','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('40','8','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('41','9','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('42','9','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('43','9','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('44','9','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('45','9','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('46','10','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('47','10','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('48','10','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('49','10','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('50','10','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('51','10','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('52','10','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('53','11','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('54','11','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('55','11','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('56','11','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('57','11','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('58','11','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('59','11','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('60','12','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('61','12','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('62','12','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('63','12','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('64','12','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('65','12','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('66','12','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('67','13','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('68','13','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('69','13','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('70','13','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('71','15','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('72','15','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('73','15','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('74','15','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('75','15','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('76','15','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('77','16','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('78','16','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('79','16','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('80','16','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('81','17','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('82','17','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('83','17','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('84','17','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('85','17','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('86','17','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('87','18','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('88','18','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('89','18','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('90','18','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('91','18','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('92','18','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('93','19','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('94','19','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('95','19','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('96','19','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('97','19','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('98','19','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('99','20','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('100','20','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('101','20','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('102','21','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('103','21','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('104','21','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('105','21','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('106','21','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('107','21','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('108','22','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('109','22','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('110','22','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('111','22','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('112','22','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('113','22','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('114','22','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('115','23','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('116','23','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('117','23','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('118','23','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('119','23','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('120','24','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('121','24','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('122','24','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('123','24','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('124','25','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('125','25','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('126','25','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('127','25','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('128','25','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('129','25','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('130','26','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('131','26','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('132','26','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('133','26','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('134','26','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('135','27','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('136','27','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('137','27','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('138','27','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('139','28','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('140','28','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('141','28','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('142','29','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('143','29','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('144','30','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('145','30','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('146','31','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('147','31','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('148','31','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('149','31','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('150','31','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('151','31','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('152','31','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('153','31','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('154','32','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('155','32','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('156','34','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('157','34','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('158','34','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('159','34','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('160','35','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('161','35','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('162','35','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('163','35','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('164','35','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('165','35','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('166','35','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('167','37','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('168','37','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('169','37','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('170','37','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('171','37','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('172','37','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('173','37','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('174','39','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('175','39','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('176','39','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('177','39','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('178','39','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('179','39','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('180','39','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('181','40','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('182','40','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('183','40','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('184','40','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('185','42','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('186','42','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('187','42','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('188','42','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('189','43','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('190','43','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('191','43','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('192','43','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('193','43','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('194','43','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('195','43','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('196','44','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('197','44','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('198','44','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('199','44','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('200','44','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('201','45','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('202','45','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('203','45','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('204','45','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('205','45','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('206','45','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('207','46','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('208','46','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('209','46','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('210','47','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('211','47','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('212','48','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('213','48','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('214','48','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('215','48','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('216','49','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('217','49','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('218','49','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('219','49','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('220','49','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('221','49','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('222','50','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('223','50','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('224','50','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('225','50','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('226','50','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('227','51','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('228','51','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('229','51','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('230','51','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('231','51','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('232','51','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('233','52','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('234','52','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('235','53','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('236','53','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('237','54','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('238','54','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('239','54','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('240','54','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('241','54','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('242','55','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('243','55','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('244','55','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('245','55','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('246','55','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('247','55','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('248','56','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('249','56','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('250','56','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('251','56','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('252','56','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('253','57','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('254','57','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('255','57','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('256','57','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('257','57','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('258','57','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('259','57','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('260','58','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('261','58','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('262','58','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('263','58','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('264','59','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('265','59','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('266','59','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('267','59','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('268','59','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('269','60','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('270','60','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('271','60','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('272','61','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('273','61','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('274','61','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('275','61','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('276','61','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('277','61','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('278','62','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('279','62','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('280','63','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('281','63','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('282','63','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('283','63','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('284','64','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('285','64','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('286','64','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('287','65','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('288','65','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('289','65','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('290','65','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('291','66','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('292','66','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('293','66','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('294','67','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('295','67','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('296','67','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('297','67','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('298','67','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('299','67','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('300','68','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('301','68','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('302','68','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('303','68','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('304','69','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('305','69','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('306','69','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('307','69','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('308','69','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('309','69','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('310','69','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('311','69','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('312','70','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('313','70','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('314','70','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('315','70','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('316','71','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('317','71','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('318','71','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('319','71','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('320','72','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('321','72','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('322','72','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('323','72','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('324','72','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('325','72','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('326','73','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('327','73','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('328','73','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('329','73','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('330','73','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('331','73','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('332','73','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('333','73','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('334','74','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('335','74','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('336','74','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('337','74','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('338','74','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('339','75','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('340','75','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('341','75','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('342','76','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('343','76','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('344','76','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('345','77','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('346','77','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('347','77','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('348','77','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('349','77','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('350','77','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('351','78','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('352','78','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('353','78','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('354','78','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('355','78','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('356','78','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('357','78','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('358','79','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('359','79','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('360','79','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('361','79','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('362','79','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('363','79','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('364','80','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('365','80','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('366','80','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('367','80','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('368','81','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('369','81','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('370','81','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('371','81','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('372','82','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('373','82','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('374','83','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('375','83','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('376','83','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('377','83','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('378','83','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('379','84','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('380','84','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('381','84','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('382','84','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('383','85','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('384','85','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('385','85','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('386','85','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('387','86','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('388','86','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('389','86','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('390','86','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('391','86','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('392','86','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('393','86','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('394','86','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('395','88','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('396','88','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('397','88','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('398','88','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('399','89','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('400','89','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('401','89','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('402','89','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('403','89','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('404','89','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('405','90','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('406','90','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('407','90','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('408','90','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('409','90','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('410','90','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('411','91','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('412','91','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('413','91','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('414','91','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('415','91','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('416','91','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('417','91','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('418','91','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('419','92','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('420','92','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('421','92','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('422','92','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('423','93','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('424','93','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('425','93','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('426','94','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('427','94','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('428','95','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('429','95','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('430','95','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('431','95','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('432','95','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('433','96','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('434','96','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('435','96','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('436','97','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('437','97','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('438','97','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('439','97','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('440','97','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('441','97','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('442','98','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('443','98','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('444','98','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('445','99','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('446','99','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('447','99','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('448','99','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('449','99','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('450','99','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('451','100','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('452','100','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('453','100','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('454','100','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('455','100','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('456','100','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('457','101','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('458','101','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('459','101','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('460','101','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('461','101','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('462','101','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('463','102','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('464','102','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('465','103','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('466','103','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('467','103','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('468','103','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('469','103','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('470','103','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('471','103','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('472','103','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('473','104','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('474','104','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('475','104','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('476','105','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('477','105','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('478','105','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('479','105','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('480','105','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('481','106','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('482','106','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('483','107','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('484','107','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('485','109','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('486','109','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('487','109','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('488','109','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('489','109','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('490','109','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('491','109','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('492','109','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('493','110','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('494','110','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('495','110','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('496','110','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('497','111','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('498','111','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('499','111','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('500','111','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('501','112','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('502','112','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('503','112','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('504','112','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('505','112','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('506','112','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('507','112','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('508','113','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('509','113','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('510','113','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('511','113','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('512','114','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('513','114','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('514','114','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('515','114','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('516','114','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('517','114','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('518','114','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('519','115','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('520','115','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('521','115','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('522','115','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('523','115','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('524','115','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('525','115','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('526','116','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('527','116','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('528','116','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('529','116','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('530','116','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('531','116','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('532','117','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('533','117','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('534','117','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('535','117','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('536','117','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('537','117','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('538','118','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('539','118','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('540','118','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('541','118','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('542','118','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('543','118','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('544','119','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('545','119','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('546','119','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('547','119','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('548','119','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('549','119','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('550','119','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('551','120','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('552','120','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('553','120','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('554','121','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('555','121','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('556','121','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('557','121','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('558','121','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('559','121','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('560','122','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('561','122','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('562','122','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('563','122','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('564','122','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('565','122','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('566','122','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('567','123','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('568','123','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('569','123','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('570','123','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('571','123','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('572','124','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('573','124','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('574','124','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('575','125','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('576','125','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('577','126','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('578','126','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('579','126','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('580','127','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('581','127','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('582','127','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('583','127','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('584','127','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('585','127','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('586','127','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('587','127','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('588','129','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('589','129','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('590','129','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('591','129','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('592','129','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('593','129','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('594','130','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('595','130','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('596','130','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('597','130','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('598','130','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('599','130','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('600','131','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('601','131','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('602','131','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('603','131','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('604','131','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('605','131','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('606','132','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('607','132','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('608','132','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('609','132','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('610','132','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('611','132','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('612','133','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('613','133','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('614','133','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('615','133','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('616','134','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('617','134','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('618','134','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('619','135','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('620','135','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('621','135','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('622','135','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('623','135','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('624','135','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('625','135','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('626','136','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('627','136','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('628','136','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('629','137','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('630','137','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('631','137','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('632','137','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('633','138','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('634','138','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('635','138','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('636','138','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('637','138','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('638','139','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('639','139','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('640','139','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('641','139','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('642','139','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('643','139','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('644','140','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('645','140','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('646','140','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('647','140','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('648','140','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('649','141','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('650','141','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('651','141','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('652','141','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('653','141','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('654','142','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('655','142','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('656','142','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('657','142','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('658','142','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('659','143','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('660','143','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('661','143','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('662','143','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('663','143','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('664','143','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('665','143','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('666','145','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('667','145','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('668','145','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('669','146','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('670','146','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('671','146','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('672','147','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('673','147','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('674','147','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('675','147','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('676','147','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('677','147','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('678','149','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('679','149','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('680','149','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('681','149','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('682','149','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('683','149','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('684','150','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('685','150','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('686','150','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('687','150','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('688','150','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('689','150','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('690','151','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('691','151','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('692','151','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('693','151','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('694','152','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('695','152','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('696','152','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('697','152','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('698','153','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('699','153','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('700','153','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('701','153','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('702','154','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('703','154','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('704','154','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('705','154','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('706','154','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('707','154','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('708','154','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('709','155','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('710','155','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('711','155','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('712','155','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('713','155','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('714','156','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('715','156','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('716','157','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('717','157','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('718','157','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('719','158','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('720','158','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('721','158','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('722','158','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('723','158','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('724','159','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('725','159','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('726','159','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('727','159','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('728','159','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('729','159','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('730','159','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('731','160','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('732','160','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('733','160','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('734','160','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('735','160','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('736','161','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('737','161','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('738','162','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('739','162','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('740','162','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('741','162','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('742','162','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('743','162','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('744','162','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('745','163','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('746','163','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('747','163','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('748','164','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('749','164','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('750','164','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('751','164','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('752','164','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('753','165','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('754','165','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('755','165','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('756','165','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('757','165','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('758','166','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('759','166','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('760','166','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('761','166','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('762','166','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('763','166','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('764','167','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('765','167','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('766','167','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('767','167','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('768','167','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('769','167','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('770','167','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('771','168','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('772','168','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('773','169','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('774','169','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('775','169','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('776','169','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('777','170','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('778','170','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('779','170','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('780','170','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('781','170','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('782','170','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('783','172','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('784','172','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('785','172','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('786','172','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('787','172','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('788','172','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('789','172','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('790','173','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('791','173','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('792','173','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('793','173','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('794','173','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('795','174','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('796','174','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('797','174','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('798','174','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('799','174','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('800','174','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('801','174','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('802','174','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('803','175','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('804','175','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('805','175','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('806','175','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('807','175','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('808','176','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('809','176','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('810','176','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('811','176','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('812','176','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('813','176','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('814','177','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('815','177','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('816','177','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('817','178','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('818','178','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('819','179','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('820','179','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('821','179','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('822','179','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('823','180','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('824','180','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('825','181','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('826','181','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('827','181','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('828','181','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('829','181','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('830','181','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('831','181','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('832','182','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('833','182','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('834','183','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('835','183','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('836','183','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('837','183','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('838','183','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('839','183','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('840','184','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('841','184','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('842','184','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('843','184','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('844','184','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('845','185','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('846','185','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('847','186','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('848','186','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('849','186','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('850','186','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('851','187','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('852','187','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('853','187','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('854','188','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('855','188','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('856','188','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('857','189','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('858','189','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('859','189','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('860','189','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('861','189','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('862','189','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('863','190','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('864','190','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('865','190','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('866','190','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('867','191','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('868','191','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('869','191','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('870','191','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('871','191','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('872','191','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('873','193','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('874','193','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('875','193','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('876','193','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('877','193','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('878','193','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('879','193','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('880','193','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('881','194','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('882','194','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('883','194','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('884','194','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('885','196','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('886','196','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('887','197','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('888','197','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('889','199','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('890','199','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('891','199','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('892','199','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('893','199','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('894','199','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('895','199','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('896','199','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('897','200','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('898','200','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('899','200','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('900','200','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('901','200','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('902','200','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('903','200','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('904','200','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('905','201','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('906','201','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('907','201','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('908','201','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('909','202','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('910','202','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('911','202','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('912','203','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('913','203','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('914','203','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('915','203','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('916','204','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('917','204','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('918','204','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('919','204','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('920','204','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('921','204','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('922','205','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('923','205','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('924','205','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('925','205','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('926','206','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('927','206','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('928','206','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('929','206','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('930','206','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('931','206','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('932','206','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('933','206','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('934','207','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('935','207','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('936','207','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('937','207','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('938','208','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('939','208','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('940','208','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('941','209','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('942','209','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('943','209','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('944','209','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('945','210','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('946','210','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('947','210','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('948','211','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('949','211','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('950','212','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('951','212','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('952','212','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('953','212','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('954','212','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('955','213','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('956','213','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('957','213','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('958','213','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('959','214','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('960','214','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('961','214','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('962','214','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('963','215','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('964','215','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('965','215','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('966','215','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('967','215','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('968','215','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('969','216','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('970','216','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('971','216','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('972','216','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('973','216','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('974','218','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('975','218','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('976','218','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('977','218','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('978','218','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('979','218','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('980','218','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('981','219','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('982','219','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('983','219','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('984','219','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('985','220','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('986','220','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('987','220','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('988','220','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('989','220','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('990','220','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('991','220','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('992','220','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('993','222','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('994','222','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('995','222','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('996','222','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('997','222','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('998','222','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('999','223','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1000','223','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1001','224','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1002','224','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1003','225','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1004','225','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1005','225','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1006','226','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1007','226','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1008','226','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1009','226','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1010','226','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1011','227','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1012','227','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1013','227','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1014','227','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1015','227','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1016','228','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1017','228','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1018','228','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1019','228','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1020','228','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1021','228','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1022','228','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1023','229','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1024','229','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1025','229','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1026','229','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1027','230','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1028','230','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1029','231','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1030','231','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1031','231','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1032','231','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1033','231','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1034','231','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1035','231','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1036','231','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1037','232','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1038','232','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1039','232','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1040','232','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1041','232','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1042','233','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1043','233','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1044','233','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1045','233','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1046','233','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1047','233','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1048','234','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1049','234','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1050','234','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1051','234','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1052','234','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1053','234','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1054','234','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1055','235','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1056','235','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1057','235','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1058','235','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1059','235','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1060','235','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1061','236','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1062','236','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1063','236','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1064','236','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1065','237','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1066','237','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1067','238','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1068','238','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1069','239','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1070','239','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1071','239','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1072','239','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1073','239','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1074','239','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1075','239','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1076','239','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1077','240','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1078','240','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1079','240','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1080','241','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1081','241','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1082','241','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1083','241','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1084','242','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1085','242','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1086','242','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1087','242','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1088','242','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1089','243','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1090','243','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1091','243','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1092','243','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1093','243','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1094','243','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1095','244','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1096','244','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1097','244','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1098','244','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1099','244','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1100','244','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1101','244','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1102','245','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1103','245','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1104','245','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1105','245','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1106','245','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1107','245','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1108','245','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1109','246','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1110','246','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1111','246','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1112','247','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1113','247','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1114','247','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1115','247','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1116','247','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1117','247','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1118','247','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1119','248','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1120','248','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1121','249','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1122','249','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1123','249','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1124','249','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1125','249','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1126','249','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1127','250','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1128','250','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1129','250','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1130','250','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1131','251','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1132','251','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1133','251','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1134','251','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1135','251','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1136','252','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1137','252','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1138','252','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1139','252','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1140','252','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1141','252','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1142','253','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1143','253','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1144','253','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1145','253','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1146','253','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1147','253','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1148','254','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1149','254','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1150','254','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1151','254','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1152','254','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1153','255','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1154','255','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1155','255','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1156','255','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1157','255','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1158','255','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1159','256','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1160','256','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1161','256','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1162','257','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1163','257','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1164','257','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1165','258','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1166','258','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1167','258','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1168','258','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1169','259','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1170','259','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1171','260','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1172','260','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1173','260','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1174','260','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1175','261','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1176','261','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1177','262','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1178','262','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1179','263','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1180','263','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1181','263','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1182','263','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1183','263','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1184','263','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1185','263','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1186','264','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1187','264','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1188','265','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1189','265','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1190','265','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1191','265','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1192','266','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1193','266','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1194','266','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1195','266','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1196','266','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1197','266','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1198','266','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1199','266','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1200','267','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1201','267','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1202','267','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1203','267','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1204','267','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1205','267','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1206','268','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1207','268','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1208','269','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1209','269','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1210','269','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1211','269','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1212','269','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1213','269','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1214','270','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1215','270','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1216','270','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1217','270','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1218','270','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1219','270','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1220','270','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1221','271','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1222','271','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1223','271','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1224','271','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1225','271','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1226','272','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1227','272','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1228','272','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1229','272','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1230','273','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1231','273','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1232','273','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1233','273','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1234','273','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1235','273','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1236','273','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1237','274','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1238','274','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1239','274','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1240','274','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1241','274','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1242','274','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1243','274','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1244','275','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1245','275','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1246','275','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1247','275','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1248','275','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1249','276','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1250','276','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1251','276','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1252','276','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1253','277','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1254','277','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1255','277','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1256','278','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1257','278','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1258','279','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1259','279','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1260','280','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1261','280','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1262','280','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1263','280','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1264','280','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1265','280','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1266','281','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1267','281','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1268','281','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1269','281','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1270','281','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1271','281','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1272','282','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1273','282','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1274','282','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1275','282','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1276','282','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1277','282','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1278','283','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1279','283','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1280','283','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1281','284','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1282','284','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1283','284','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1284','284','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1285','284','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1286','284','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1287','284','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1288','285','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1289','285','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1290','285','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1291','285','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1292','285','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1293','285','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1294','285','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1295','286','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1296','286','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1297','286','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1298','286','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1299','286','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1300','287','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1301','287','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1302','287','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1303','287','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1304','288','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1305','288','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1306','288','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1307','288','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1308','288','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1309','288','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1310','289','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1311','289','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1312','290','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1313','290','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1314','290','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1315','291','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1316','291','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1317','291','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1318','291','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1319','292','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1320','292','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1321','292','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1322','292','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1323','292','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1324','292','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1325','293','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1326','293','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1327','293','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1328','293','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1329','293','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1330','294','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1331','294','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1332','294','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1333','294','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1334','294','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1335','295','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1336','295','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1337','295','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1338','295','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1339','295','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1340','295','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1341','295','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1342','295','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1343','296','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1344','296','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1345','296','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1346','296','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1347','297','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1348','297','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1349','298','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1350','298','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1351','298','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1352','298','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1353','298','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1354','299','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1355','299','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1356','299','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1357','299','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1358','300','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1359','300','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1360','300','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1361','300','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1362','300','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1363','300','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1364','301','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1365','301','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1366','301','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1367','301','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1368','301','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1369','301','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1370','301','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1371','301','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1372','302','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1373','302','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1374','302','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1375','302','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1376','302','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1377','302','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1378','303','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1379','303','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1380','303','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1381','303','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1382','303','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1383','303','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1384','304','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1385','304','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1386','304','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1387','304','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1388','304','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1389','304','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1390','305','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1391','305','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1392','305','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1393','305','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1394','305','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1395','305','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1396','305','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1397','306','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1398','306','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1399','306','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1400','307','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1401','307','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1402','307','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1403','307','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1404','307','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1405','307','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1406','308','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1407','308','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1408','308','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1409','308','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1410','309','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1411','309','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1412','309','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1413','309','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1414','309','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1415','309','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1416','310','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1417','310','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1418','311','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1419','311','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1420','311','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1421','311','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1422','311','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1423','311','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1424','311','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1425','312','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1426','312','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1427','312','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1428','313','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1429','313','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1430','313','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1431','313','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1432','313','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1433','313','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1434','314','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1435','314','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1436','314','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1437','314','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1438','314','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1439','314','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1440','315','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1441','315','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1442','315','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1443','316','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1444','316','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1445','317','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1446','317','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1447','317','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1448','317','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1449','317','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1450','317','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1451','317','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1452','319','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1453','319','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1454','319','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1455','319','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1456','319','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1457','319','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1458','319','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1459','320','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1460','320','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1461','320','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1462','320','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1463','320','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1464','320','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1465','320','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1466','321','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1467','321','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1468','321','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1469','321','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1470','322','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1471','322','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1472','322','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1473','322','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1474','322','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1475','322','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1476','323','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1477','323','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1478','323','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1479','323','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1480','324','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1481','324','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1482','324','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1483','324','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1484','324','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1485','326','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1486','326','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1487','326','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1488','326','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1489','326','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1490','326','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1491','327','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1492','327','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1493','327','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1494','327','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1495','327','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1496','327','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1497','328','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1498','328','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1499','328','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1500','328','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1501','329','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1502','329','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1503','329','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1504','329','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1505','329','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1506','329','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1507','330','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1508','330','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1509','330','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1510','330','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1511','330','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1512','330','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1513','330','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1514','331','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1515','331','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1516','331','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1517','331','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1518','331','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1519','331','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1520','331','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1521','331','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1522','333','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1523','333','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1524','333','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1525','333','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1526','334','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1527','334','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1528','334','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1529','334','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1530','334','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1531','334','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1532','335','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1533','335','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1534','336','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1535','336','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1536','336','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1537','336','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1538','336','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1539','337','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1540','337','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1541','337','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1542','337','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1543','338','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1544','338','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1545','338','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1546','339','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1547','339','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1548','339','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1549','340','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1550','340','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1551','341','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1552','341','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1553','341','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1554','341','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1555','341','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1556','341','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1557','341','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1558','341','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1559','342','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1560','342','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1561','342','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1562','342','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1563','343','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1564','343','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1565','344','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1566','344','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1567','344','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1568','344','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1569','344','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1570','345','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1571','345','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1572','345','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1573','345','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1574','345','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1575','346','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1576','346','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1577','346','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1578','346','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1579','346','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1580','346','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1581','347','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1582','347','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1583','347','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1584','347','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1585','348','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1586','348','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1587','348','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1588','348','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1589','349','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1590','349','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1591','349','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1592','349','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1593','349','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1594','349','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1595','349','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1596','350','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1597','350','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1598','350','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1599','350','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1600','350','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1601','350','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1602','350','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1603','350','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1604','351','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1605','351','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1606','351','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1607','351','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1608','351','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1609','351','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1610','352','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1611','352','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1612','352','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1613','352','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1614','353','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1615','353','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1616','353','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1617','353','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1618','353','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1619','353','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1620','354','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1621','354','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1622','354','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1623','354','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1624','354','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1625','355','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1626','355','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1627','356','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1628','356','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1629','356','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1630','356','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1631','356','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1632','356','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1633','356','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1634','356','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1635','357','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1636','357','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1637','357','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1638','357','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1639','358','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1640','358','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1641','358','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1642','358','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1643','358','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1644','358','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1645','358','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1646','358','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1647','360','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1648','360','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1649','360','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1650','360','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1651','361','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1652','361','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1653','361','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1654','361','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1655','361','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1656','361','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1657','361','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1658','361','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1659','362','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1660','362','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1661','363','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1662','363','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1663','363','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1664','363','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1665','363','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1666','363','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1667','364','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1668','364','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1669','364','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1670','365','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1671','365','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1672','365','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1673','365','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1674','366','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1675','366','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1676','366','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1677','366','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1678','366','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1679','366','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1680','366','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1681','367','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1682','367','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1683','367','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1684','367','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1685','367','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1686','367','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1687','367','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1688','368','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1689','368','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1690','369','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1691','369','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1692','369','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1693','369','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1694','369','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1695','369','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1696','369','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1697','369','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1698','370','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1699','370','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1700','370','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1701','370','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1702','370','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1703','371','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1704','371','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1705','371','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1706','372','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1707','372','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1708','373','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1709','373','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1710','373','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1711','373','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1712','373','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1713','374','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1714','374','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1715','374','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1716','374','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1717','374','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1718','374','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1719','374','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1720','375','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1721','375','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1722','376','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1723','376','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1724','376','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1725','376','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1726','376','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1727','376','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1728','376','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1729','377','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1730','377','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1731','377','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1732','377','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1733','377','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1734','377','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1735','378','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1736','378','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1737','378','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1738','378','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1739','378','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1740','378','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1741','378','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1742','378','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1743','379','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1744','379','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1745','379','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1746','379','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1747','380','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1748','380','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1749','380','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1750','380','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1751','380','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1752','381','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1753','381','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1754','381','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1755','381','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1756','381','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1757','382','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1758','382','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1759','382','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1760','382','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1761','382','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1762','382','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1763','382','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1764','382','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1765','383','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1766','383','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1767','383','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1768','383','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1769','383','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1770','384','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1771','384','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1772','384','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1773','385','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1774','385','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1775','385','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1776','385','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1777','385','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1778','387','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1779','387','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1780','387','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1781','387','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1782','387','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1783','387','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1784','388','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1785','388','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1786','388','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1787','388','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1788','388','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1789','388','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1790','389','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1791','389','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1792','389','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1793','389','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1794','390','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1795','390','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1796','390','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1797','391','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1798','391','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1799','391','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1800','391','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1801','391','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1802','391','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1803','391','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1804','392','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1805','392','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1806','392','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1807','392','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1808','392','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1809','392','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1810','393','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1811','393','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1812','394','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1813','394','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1814','394','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1815','394','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1816','395','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1817','395','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1818','395','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1819','395','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1820','395','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1821','395','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1822','396','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1823','396','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1824','396','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1825','396','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1826','397','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1827','397','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1828','397','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1829','397','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1830','397','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1831','397','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1832','397','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1833','398','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1834','398','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1835','398','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1836','398','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1837','399','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1838','399','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1839','400','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1840','400','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1841','401','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1842','401','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1843','402','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1844','402','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1845','402','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1846','402','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1847','402','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1848','402','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1849','403','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1850','403','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1851','403','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1852','403','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1853','403','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1854','403','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1855','403','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1856','403','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1857','405','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1858','405','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1859','406','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1860','406','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1861','406','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1862','406','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1863','406','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1864','406','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1865','407','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1866','407','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1867','408','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1868','408','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1869','408','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1870','408','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1871','408','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1872','408','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1873','408','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1874','409','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1875','409','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1876','409','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1877','409','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1878','409','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1879','409','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1880','409','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1881','410','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1882','410','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1883','410','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1884','410','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1885','410','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1886','411','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1887','411','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1888','412','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1889','412','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1890','412','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1891','412','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1892','412','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1893','412','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1894','412','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1895','412','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1896','413','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1897','413','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1898','413','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1899','414','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1900','414','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1901','414','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1902','414','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1903','414','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1904','414','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1905','415','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1906','415','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1907','415','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1908','415','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1909','415','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1910','415','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1911','416','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1912','416','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1913','416','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1914','416','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1915','416','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1916','416','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1917','417','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1918','417','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1919','417','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1920','417','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1921','417','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1922','417','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1923','418','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1924','418','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1925','418','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1926','418','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1927','418','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1928','418','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1929','418','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1930','418','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1931','420','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1932','420','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1933','420','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1934','420','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1935','420','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1936','421','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1937','421','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1938','421','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1939','421','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1940','422','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1941','422','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1942','423','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1943','423','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1944','423','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1945','423','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1946','424','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1947','424','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1948','424','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1949','424','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1950','424','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1951','425','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1952','425','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1953','426','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1954','426','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1955','426','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1956','427','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1957','427','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1958','427','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1959','427','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1960','428','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1961','428','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1962','428','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1963','428','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1964','428','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1965','428','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1966','429','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1967','429','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1968','429','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1969','429','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1970','429','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1971','429','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1972','430','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1973','430','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1974','430','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1975','430','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1976','431','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1977','431','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1978','431','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1979','432','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1980','432','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1981','432','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1982','432','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1983','432','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1984','433','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1985','433','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1986','433','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1987','433','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1988','433','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1989','433','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1990','434','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1991','434','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1992','434','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1993','434','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1994','434','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1995','434','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1996','434','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1997','434','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1998','435','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('1999','435','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2000','436','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2001','436','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2002','436','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2003','436','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2004','436','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2005','436','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2006','437','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2007','437','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2008','437','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2009','437','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2010','437','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2011','437','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2012','438','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2013','438','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2014','438','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2015','438','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2016','438','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2017','439','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2018','439','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2019','439','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2020','439','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2021','439','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2022','439','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2023','440','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2024','440','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2025','440','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2026','440','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2027','441','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2028','441','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2029','442','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2030','442','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2031','442','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2032','443','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2033','443','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2034','443','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2035','443','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2036','443','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2037','443','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2038','443','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2039','444','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2040','444','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2041','444','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2042','444','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2043','444','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2044','444','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2045','444','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2046','444','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2047','445','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2048','445','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2049','445','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2050','445','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2051','445','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2052','445','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2053','446','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2054','446','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2055','446','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2056','446','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2057','447','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2058','447','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2059','447','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2060','447','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2061','447','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2062','447','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2063','447','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2064','448','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2065','448','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2066','448','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2067','448','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2068','448','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2069','449','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2070','449','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2071','449','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2072','449','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2073','450','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2074','450','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2075','450','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2076','450','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2077','450','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2078','450','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2079','450','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2080','451','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2081','451','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2082','451','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2083','451','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2084','451','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2085','452','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2086','452','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2087','452','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2088','452','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2089','453','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2090','453','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2091','453','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2092','453','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2093','453','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2094','454','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2095','454','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2096','455','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2097','455','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2098','455','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2099','455','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2100','456','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2101','456','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2102','456','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2103','456','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2104','456','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2105','456','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2106','457','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2107','457','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2108','457','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2109','457','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2110','457','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2111','457','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2112','458','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2113','458','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2114','458','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2115','458','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2116','458','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2117','458','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2118','459','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2119','459','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2120','460','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2121','460','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2122','460','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2123','460','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2124','460','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2125','460','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2126','460','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2127','460','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2128','461','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2129','461','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2130','461','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2131','461','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2132','461','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2133','461','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2134','462','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2135','462','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2136','462','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2137','462','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2138','462','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2139','463','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2140','463','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2141','463','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2142','463','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2143','463','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2144','464','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2145','464','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2146','464','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2147','464','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2148','464','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2149','464','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2150','464','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2151','465','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2152','465','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2153','465','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2154','465','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2155','465','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2156','466','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2157','466','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2158','467','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2159','467','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2160','467','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2161','467','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2162','467','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2163','467','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2164','467','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2165','468','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2166','468','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2167','468','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2168','468','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2169','468','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2170','468','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2171','468','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2172','468','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2173','469','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2174','469','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2175','469','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2176','470','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2177','470','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2178','471','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2179','471','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2180','471','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2181','471','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2182','471','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2183','471','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2184','471','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2185','472','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2186','472','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2187','473','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2188','473','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2189','473','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2190','473','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2191','473','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2192','474','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2193','474','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2194','474','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2195','474','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2196','475','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2197','475','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2198','476','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2199','476','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2200','476','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2201','476','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2202','476','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2203','476','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2204','476','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2205','477','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2206','477','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2207','477','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2208','478','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2209','478','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2210','478','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2211','478','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2212','478','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2213','479','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2214','479','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2215','479','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2216','479','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2217','479','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2218','480','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2219','480','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2220','480','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2221','480','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2222','481','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2223','481','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2224','481','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2225','481','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2226','481','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2227','481','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2228','482','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2229','482','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2230','482','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2231','483','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2232','483','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2233','483','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2234','483','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2235','483','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2236','484','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2237','484','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2238','484','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2239','484','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2240','484','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2241','484','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2242','484','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2243','485','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2244','485','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2245','485','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2246','486','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2247','486','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2248','486','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2249','486','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2250','486','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2251','486','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2252','487','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2253','487','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2254','487','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2255','488','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2256','488','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2257','488','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2258','488','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2259','488','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2260','489','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2261','489','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2262','489','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2263','489','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2264','489','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2265','489','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2266','489','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2267','489','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2268','490','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2269','490','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2270','491','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2271','491','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2272','491','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2273','491','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2274','491','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2275','491','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2276','492','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2277','492','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2278','493','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2279','493','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2280','493','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2281','494','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2282','494','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2283','494','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2284','494','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2285','494','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2286','494','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2287','496','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2288','496','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2289','496','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2290','496','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2291','496','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2292','498','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2293','498','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2294','499','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2295','499','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2296','500','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2297','500','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2298','500','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2299','500','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2300','500','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2301','500','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2302','500','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2303','500','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2304','501','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2305','501','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2306','501','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2307','501','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2308','501','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2309','502','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2310','502','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2311','502','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2312','502','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2313','502','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2314','502','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2315','502','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2316','503','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2317','503','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2318','503','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2319','504','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2320','504','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2321','504','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2322','504','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2323','504','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2324','504','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2325','505','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2326','505','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2327','505','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2328','505','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2329','506','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2330','506','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2331','506','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2332','506','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2333','506','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2334','506','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2335','507','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2336','507','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2337','508','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2338','508','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2339','508','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2340','509','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2341','509','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2342','509','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2343','510','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2344','510','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2345','510','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2346','510','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2347','511','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2348','511','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2349','511','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2350','511','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2351','511','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2352','512','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2353','512','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2354','512','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2355','512','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2356','512','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2357','512','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2358','513','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2359','513','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2360','514','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2361','514','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2362','514','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2363','514','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2364','514','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2365','514','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2366','515','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2367','515','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2368','516','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2369','516','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2370','516','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2371','517','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2372','517','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2373','518','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2374','518','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2375','518','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2376','518','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2377','518','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2378','518','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2379','519','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2380','519','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2381','519','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2382','519','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2383','520','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2384','520','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2385','521','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2386','521','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2387','521','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2388','521','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2389','521','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2390','521','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2391','521','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2392','522','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2393','522','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2394','523','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2395','523','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2396','524','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2397','524','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2398','524','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2399','524','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2400','524','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2401','524','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2402','525','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2403','525','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2404','525','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2405','525','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2406','525','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2407','525','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2408','525','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2409','525','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2410','526','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2411','526','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2412','526','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2413','526','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2414','527','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2415','527','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2416','527','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2417','527','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2418','527','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2419','527','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2420','528','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2421','528','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2422','528','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2423','529','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2424','529','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2425','529','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2426','529','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2427','530','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2428','530','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2429','530','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2430','531','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2431','531','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2432','531','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2433','531','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2434','531','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2435','531','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2436','531','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2437','531','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2438','532','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2439','532','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2440','532','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2441','532','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2442','533','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2443','533','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2444','533','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2445','534','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2446','534','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2447','534','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2448','534','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2449','534','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2450','535','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2451','535','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2452','535','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2453','535','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2454','536','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2455','536','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2456','536','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2457','536','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2458','536','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2459','537','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2460','537','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2461','537','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2462','538','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2463','538','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2464','538','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2465','539','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2466','539','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2467','540','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2468','540','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2469','540','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2470','541','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2471','541','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2472','542','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2473','542','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2474','542','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2475','542','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2476','542','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2477','542','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2478','543','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2479','543','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2480','544','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2481','544','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2482','544','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2483','544','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2484','545','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2485','545','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2486','545','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2487','545','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2488','545','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2489','545','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2490','546','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2491','546','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2492','546','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2493','546','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2494','547','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2495','547','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2496','548','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2497','548','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2498','549','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2499','549','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2500','549','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2501','549','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2502','550','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2503','550','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2504','550','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2505','551','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2506','551','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2507','551','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2508','551','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2509','551','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2510','551','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2511','552','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2512','552','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2513','552','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2514','552','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2515','553','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2516','553','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2517','553','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2518','554','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2519','554','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2520','554','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2521','554','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2522','554','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2523','554','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2524','554','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2525','555','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2526','555','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2527','555','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2528','555','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2529','555','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2530','555','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2531','555','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2532','556','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2533','556','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2534','556','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2535','556','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2536','556','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2537','556','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2538','556','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2539','557','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2540','557','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2541','557','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2542','557','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2543','557','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2544','558','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2545','558','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2546','559','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2547','559','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2548','559','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2549','559','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2550','559','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2551','559','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2552','559','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2553','559','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2554','560','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2555','560','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2556','560','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2557','560','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2558','560','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2559','561','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2560','561','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2561','561','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2562','561','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2563','562','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2564','562','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2565','562','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2566','562','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2567','562','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2568','562','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2569','563','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2570','563','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2571','563','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2572','563','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2573','563','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2574','563','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2575','563','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2576','564','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2577','564','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2578','564','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2579','565','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2580','565','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2581','566','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2582','566','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2583','567','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2584','567','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2585','567','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2586','567','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2587','568','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2588','568','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2589','568','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2590','568','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2591','569','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2592','569','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2593','570','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2594','570','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2595','570','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2596','570','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2597','570','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2598','571','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2599','571','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2600','571','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2601','571','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2602','571','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2603','571','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2604','572','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2605','572','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2606','572','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2607','572','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2608','572','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2609','572','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2610','572','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2611','572','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2612','573','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2613','573','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2614','573','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2615','573','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2616','574','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2617','574','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2618','574','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2619','574','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2620','574','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2621','575','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2622','575','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2623','575','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2624','575','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2625','575','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2626','575','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2627','576','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2628','576','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2629','576','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2630','577','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2631','577','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2632','577','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2633','578','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2634','578','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2635','578','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2636','578','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2637','578','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2638','579','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2639','579','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2640','579','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2641','579','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2642','579','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2643','579','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2644','579','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2645','580','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2646','580','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2647','580','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2648','580','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2649','580','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2650','580','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2651','581','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2652','581','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2653','581','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2654','582','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2655','582','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2656','583','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2657','583','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2658','583','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2659','583','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2660','583','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2661','584','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2662','584','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2663','585','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2664','585','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2665','585','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2666','585','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2667','586','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2668','586','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2669','586','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2670','586','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2671','586','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2672','586','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2673','586','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2674','586','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2675','587','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2676','587','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2677','587','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2678','588','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2679','588','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2680','588','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2681','588','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2682','589','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2683','589','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2684','589','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2685','589','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2686','590','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2687','590','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2688','590','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2689','590','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2690','590','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2691','590','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2692','590','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2693','591','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2694','591','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2695','591','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2696','592','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2697','592','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2698','592','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2699','592','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2700','593','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2701','593','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2702','593','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2703','593','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2704','594','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2705','594','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2706','594','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2707','595','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2708','595','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2709','595','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2710','595','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2711','595','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2712','595','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2713','595','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2714','595','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2715','596','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2716','596','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2717','596','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2718','596','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2719','596','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2720','596','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2721','597','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2722','597','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2723','597','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2724','597','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2725','598','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2726','598','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2727','598','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2728','598','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2729','599','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2730','599','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2731','599','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2732','599','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2733','599','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2734','600','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2735','600','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2736','600','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2737','600','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2738','601','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2739','601','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2740','601','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2741','601','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2742','601','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2743','602','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2744','602','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2745','602','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2746','602','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2747','602','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2748','603','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2749','603','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2750','603','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2751','603','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2752','603','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2753','603','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2754','604','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2755','604','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2756','604','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2757','605','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2758','605','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2759','606','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2760','606','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2761','606','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2762','606','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2763','606','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2764','606','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2765','608','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2766','608','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2767','608','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2768','608','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2769','608','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2770','608','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2771','609','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2772','609','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2773','609','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2774','609','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2775','609','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2776','609','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2777','609','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2778','609','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2779','610','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2780','610','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2781','610','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2782','610','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2783','610','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2784','611','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2785','611','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2786','611','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2787','611','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2788','611','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2789','611','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2790','612','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2791','612','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2792','613','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2793','613','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2794','614','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2795','614','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2796','614','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2797','614','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2798','614','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2799','614','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2800','615','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2801','615','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2802','615','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2803','615','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2804','616','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2805','616','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2806','616','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2807','616','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2808','616','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2809','616','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2810','617','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2811','617','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2812','617','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2813','618','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2814','618','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2815','618','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2816','618','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2817','619','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2818','619','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2819','619','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2820','619','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2821','619','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2822','619','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2823','620','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2824','620','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2825','620','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2826','620','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2827','620','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2828','621','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2829','621','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2830','621','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2831','621','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2832','621','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2833','621','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2834','621','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2835','621','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2836','622','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2837','622','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2838','623','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2839','623','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2840','623','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2841','623','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2842','623','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2843','624','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2844','624','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2845','624','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2846','624','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2847','624','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2848','624','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2849','624','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2850','625','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2851','625','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2852','625','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2853','625','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2854','625','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2855','625','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2856','625','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2857','626','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2858','626','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2859','626','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2860','626','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2861','627','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2862','627','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2863','627','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2864','628','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2865','628','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2866','628','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2867','628','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2868','628','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2869','629','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2870','629','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2871','629','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2872','629','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2873','630','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2874','630','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2875','630','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2876','631','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2877','631','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2878','631','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2879','631','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2880','631','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2881','632','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2882','632','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2883','632','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2884','633','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2885','633','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2886','633','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2887','634','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2888','634','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2889','634','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2890','634','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2891','635','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2892','635','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2893','636','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2894','636','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2895','636','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2896','637','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2897','637','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2898','637','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2899','637','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2900','637','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2901','638','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2902','638','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2903','638','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2904','638','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2905','638','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2906','638','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2907','638','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2908','638','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2909','639','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2910','639','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2911','639','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2912','640','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2913','640','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2914','640','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2915','641','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2916','641','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2917','641','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2918','641','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2919','641','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2920','641','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2921','641','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2922','643','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2923','643','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2924','643','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2925','643','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2926','643','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2927','643','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2928','644','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2929','644','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2930','644','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2931','644','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2932','644','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2933','644','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2934','644','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2935','645','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2936','645','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2937','645','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2938','645','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2939','645','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2940','645','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2941','646','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2942','646','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2943','646','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2944','646','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2945','646','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2946','647','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2947','647','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2948','647','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2949','647','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2950','647','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2951','647','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2952','648','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2953','648','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2954','648','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2955','648','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2956','648','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2957','648','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2958','649','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2959','649','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2960','649','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2961','649','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2962','649','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2963','649','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2964','650','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2965','650','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2966','650','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2967','650','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2968','650','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2969','650','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2970','651','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2971','651','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2972','651','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2973','651','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2974','651','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2975','651','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2976','652','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2977','652','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2978','652','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2979','652','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2980','653','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2981','653','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2982','654','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2983','654','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2984','654','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2985','654','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2986','655','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2987','655','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2988','655','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2989','655','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2990','655','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2991','655','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2992','656','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2993','656','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2994','657','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2995','657','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2996','657','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2997','657','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2998','657','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('2999','657','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3000','658','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3001','658','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3002','658','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3003','658','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3004','659','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3005','659','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3006','660','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3007','660','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3008','660','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3009','660','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3010','661','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3011','661','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3012','661','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3013','661','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3014','662','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3015','662','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3016','662','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3017','662','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3018','663','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3019','663','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3020','663','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3021','663','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3022','663','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3023','664','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3024','664','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3025','664','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3026','664','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3027','664','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3028','665','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3029','665','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3030','665','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3031','665','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3032','665','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3033','665','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3034','665','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3035','666','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3036','666','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3037','666','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3038','666','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3039','666','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3040','667','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3041','667','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3042','667','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3043','667','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3044','668','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3045','668','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3046','668','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3047','668','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3048','668','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3049','670','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3050','670','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3051','670','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3052','670','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3053','670','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3054','670','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3055','670','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3056','672','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3057','672','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3058','672','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3059','672','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3060','672','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3061','672','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3062','673','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3063','673','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3064','673','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3065','673','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3066','674','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3067','674','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3068','674','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3069','675','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3070','675','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3071','676','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3072','676','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3073','676','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3074','676','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3075','676','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3076','676','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3077','677','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3078','677','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3079','677','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3080','677','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3081','677','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3082','677','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3083','677','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3084','678','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3085','678','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3086','678','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3087','678','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3088','679','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3089','679','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3090','679','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3091','679','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3092','680','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3093','680','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3094','680','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3095','680','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3096','680','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3097','680','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3098','681','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3099','681','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3100','681','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3101','681','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3102','681','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3103','681','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3104','682','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3105','682','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3106','682','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3107','683','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3108','683','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3109','683','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3110','683','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3111','683','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3112','683','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3113','683','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3114','683','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3115','684','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3116','684','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3117','685','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3118','685','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3119','686','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3120','686','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3121','686','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3122','686','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3123','687','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3124','687','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3125','687','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3126','687','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3127','687','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3128','687','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3129','687','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3130','688','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3131','688','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3132','688','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3133','688','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3134','689','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3135','689','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3136','689','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3137','689','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3138','689','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3139','689','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3140','690','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3141','690','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3142','690','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3143','690','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3144','690','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3145','690','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3146','691','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3147','691','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3148','691','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3149','691','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3150','691','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3151','692','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3152','692','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3153','692','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3154','693','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3155','693','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3156','693','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3157','693','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3158','693','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3159','694','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3160','694','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3161','694','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3162','694','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3163','694','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3164','694','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3165','695','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3166','695','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3167','696','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3168','696','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3169','696','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3170','696','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3171','696','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3172','697','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3173','697','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3174','697','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3175','697','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3176','697','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3177','697','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3178','697','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3179','697','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3180','698','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3181','698','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3182','698','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3183','698','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3184','698','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3185','698','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3186','698','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3187','699','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3188','699','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3189','700','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3190','700','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3191','700','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3192','702','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3193','702','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3194','702','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3195','702','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3196','702','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3197','702','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3198','702','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3199','702','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3200','703','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3201','703','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3202','704','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3203','704','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3204','704','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3205','704','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3206','704','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3207','705','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3208','705','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3209','705','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3210','705','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3211','706','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3212','706','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3213','706','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3214','706','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3215','706','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3216','706','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3217','707','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3218','707','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3219','707','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3220','707','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3221','707','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3222','707','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3223','708','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3224','708','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3225','708','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3226','708','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3227','709','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3228','709','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3229','709','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3230','709','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3231','709','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3232','709','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3233','710','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3234','710','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3235','710','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3236','710','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3237','710','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3238','710','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3239','711','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3240','711','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3241','711','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3242','711','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3243','714','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3244','714','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3245','714','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3246','715','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3247','715','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3248','715','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3249','715','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3250','715','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3251','715','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3252','715','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3253','716','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3254','716','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3255','716','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3256','716','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3257','716','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3258','717','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3259','717','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3260','717','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3261','717','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3262','718','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3263','718','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3264','719','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3265','719','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3266','720','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3267','720','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3268','720','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3269','720','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3270','720','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3271','720','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3272','720','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3273','721','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3274','721','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3275','722','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3276','722','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3277','722','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3278','722','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3279','723','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3280','723','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3281','723','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3282','723','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3283','723','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3284','723','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3285','723','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3286','724','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3287','724','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3288','724','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3289','724','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3290','724','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3291','724','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3292','725','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3293','725','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3294','725','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3295','725','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3296','725','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3297','725','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3298','726','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3299','726','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3300','726','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3301','727','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3302','727','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3303','727','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3304','727','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3305','727','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3306','728','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3307','728','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3308','728','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3309','728','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3310','728','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3311','729','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3312','729','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3313','729','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3314','729','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3315','730','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3316','730','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3317','730','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3318','730','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3319','730','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3320','730','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3321','730','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3322','730','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3323','731','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3324','731','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3325','731','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3326','732','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3327','732','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3328','732','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3329','732','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3330','733','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3331','733','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3332','733','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3333','733','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3334','733','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3335','733','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3336','733','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3337','734','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3338','734','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3339','734','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3340','734','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3341','734','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3342','734','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3343','735','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3344','735','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3345','735','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3346','735','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3347','735','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3348','735','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3349','735','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3350','736','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3351','736','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3352','736','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3353','736','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3354','737','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3355','737','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3356','737','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3357','737','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3358','737','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3359','737','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3360','738','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3361','738','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3362','738','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3363','738','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3364','738','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3365','738','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3366','738','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3367','738','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3368','739','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3369','739','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3370','739','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3371','739','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3372','739','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3373','740','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3374','740','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3375','740','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3376','741','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3377','741','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3378','741','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3379','741','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3380','741','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3381','741','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3382','743','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3383','743','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3384','743','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3385','743','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3386','743','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3387','743','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3388','744','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3389','744','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3390','744','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3391','744','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3392','744','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3393','745','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3394','745','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3395','745','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3396','745','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3397','745','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3398','745','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3399','745','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3400','745','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3401','746','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3402','746','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3403','746','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3404','746','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3405','746','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3406','747','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3407','747','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3408','747','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3409','747','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3410','747','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3411','748','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3412','748','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3413','748','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3414','748','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3415','748','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3416','748','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3417','748','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3418','748','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3419','749','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3420','749','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3421','749','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3422','749','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3423','750','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3424','750','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3425','750','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3426','751','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3427','751','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3428','752','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3429','752','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3430','752','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3431','753','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3432','753','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3433','753','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3434','753','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3435','753','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3436','753','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3437','753','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3438','753','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3439','754','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3440','754','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3441','755','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3442','755','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3443','755','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3444','755','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3445','755','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3446','755','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3447','755','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3448','756','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3449','756','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3450','756','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3451','757','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3452','757','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3453','757','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3454','757','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3455','757','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3456','758','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3457','758','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3458','758','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3459','759','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3460','759','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3461','759','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3462','759','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3463','759','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3464','759','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3465','760','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3466','760','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3467','760','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3468','760','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3469','760','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3470','760','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3471','760','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3472','761','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3473','761','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3474','761','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3475','762','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3476','762','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3477','762','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3478','762','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3479','763','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3480','763','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3481','763','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3482','763','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3483','763','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3484','764','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3485','764','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3486','764','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3487','764','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3488','764','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3489','764','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3490','764','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3491','764','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3492','765','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3493','765','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3494','765','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3495','765','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3496','766','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3497','766','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3498','766','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3499','767','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3500','767','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3501','767','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3502','767','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3503','767','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3504','767','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3505','767','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3506','767','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3507','768','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3508','768','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3509','768','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3510','768','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3511','768','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3512','768','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3513','769','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3514','769','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3515','770','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3516','770','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3517','770','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3518','771','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3519','771','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3520','771','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3521','771','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3522','771','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3523','771','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3524','771','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3525','772','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3526','772','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3527','772','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3528','772','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3529','772','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3530','772','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3531','773','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3532','773','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3533','773','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3534','773','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3535','773','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3536','773','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3537','773','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3538','773','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3539','774','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3540','774','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3541','774','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3542','774','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3543','775','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3544','775','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3545','775','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3546','775','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3547','775','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3548','776','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3549','776','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3550','776','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3551','776','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3552','776','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3553','777','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3554','777','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3555','777','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3556','777','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3557','777','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3558','777','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3559','778','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3560','778','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3561','778','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3562','778','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3563','778','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3564','778','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3565','779','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3566','779','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3567','780','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3568','780','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3569','780','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3570','781','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3571','781','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3572','782','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3573','782','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3574','782','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3575','782','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3576','782','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3577','782','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3578','783','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3579','783','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3580','783','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3581','783','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3582','784','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3583','784','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3584','784','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3585','784','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3586','784','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3587','784','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3588','785','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3589','785','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3590','785','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3591','785','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3592','785','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3593','785','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3594','786','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3595','786','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3596','786','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3597','786','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3598','786','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3599','786','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3600','786','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3601','787','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3602','787','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3603','787','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3604','788','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3605','788','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3606','788','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3607','788','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3608','789','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3609','789','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3610','789','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3611','789','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3612','789','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3613','789','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3614','789','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3615','789','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3616','790','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3617','790','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3618','790','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3619','790','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3620','790','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3621','790','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3622','790','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3623','791','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3624','791','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3625','791','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3626','791','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3627','791','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3628','791','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3629','792','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3630','792','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3631','792','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3632','793','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3633','793','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3634','793','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3635','793','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3636','794','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3637','794','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3638','794','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3639','794','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3640','795','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3641','795','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3642','795','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3643','795','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3644','796','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3645','796','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3646','796','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3647','796','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3648','796','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3649','797','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3650','797','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3651','797','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3652','797','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3653','797','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3654','798','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3655','798','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3656','798','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3657','798','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3658','799','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3659','799','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3660','800','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3661','800','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3662','800','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3663','800','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3664','800','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3665','800','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3666','803','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3667','803','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3668','803','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3669','803','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3670','803','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3671','803','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3672','804','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3673','804','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3674','804','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3675','804','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3676','804','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3677','804','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3678','804','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3679','805','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3680','805','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3681','805','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3682','805','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3683','805','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3684','806','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3685','806','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3686','806','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3687','806','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3688','806','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3689','807','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3690','807','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3691','807','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3692','807','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3693','807','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3694','808','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3695','808','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3696','809','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3697','809','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3698','809','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3699','809','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3700','810','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3701','810','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3702','810','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3703','810','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3704','810','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3705','810','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3706','810','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3707','811','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3708','811','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3709','811','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3710','812','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3711','812','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3712','812','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3713','812','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3714','812','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3715','812','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3716','813','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3717','813','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3718','813','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3719','813','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3720','814','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3721','814','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3722','814','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3723','814','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3724','814','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3725','814','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3726','814','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3727','815','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3728','815','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3729','815','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3730','816','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3731','816','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3732','816','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3733','816','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3734','816','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3735','816','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3736','816','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3737','817','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3738','817','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3739','818','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3740','818','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3741','818','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3742','818','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3743','818','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3744','819','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3745','819','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3746','819','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3747','820','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3748','820','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3749','820','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3750','820','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3751','820','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3752','820','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3753','821','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3754','821','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3755','821','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3756','821','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3757','822','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3758','822','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3759','823','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3760','823','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3761','823','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3762','823','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3763','823','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3764','823','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3765','823','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3766','824','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3767','824','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3768','824','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3769','824','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3770','825','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3771','825','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3772','825','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3773','826','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3774','826','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3775','827','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3776','827','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3777','827','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3778','827','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3779','827','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3780','827','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3781','828','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3782','828','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3783','828','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3784','828','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3785','829','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3786','829','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3787','829','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3788','829','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3789','829','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3790','830','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3791','830','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3792','830','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3793','830','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3794','831','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3795','831','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3796','831','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3797','832','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3798','832','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3799','832','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3800','832','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3801','833','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3802','833','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3803','833','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3804','833','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3805','833','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3806','833','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3807','833','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3808','834','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3809','834','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3810','834','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3811','835','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3812','835','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3813','835','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3814','835','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3815','835','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3816','835','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3817','835','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3818','835','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3819','836','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3820','836','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3821','836','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3822','837','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3823','837','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3824','837','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3825','838','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3826','838','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3827','838','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3828','838','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3829','838','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3830','838','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3831','839','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3832','839','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3833','840','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3834','840','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3835','840','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3836','840','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3837','841','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3838','841','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3839','841','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3840','841','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3841','841','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3842','841','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3843','841','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3844','842','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3845','842','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3846','842','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3847','842','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3848','843','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3849','843','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3850','843','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3851','843','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3852','843','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3853','843','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3854','843','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3855','844','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3856','844','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3857','844','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3858','844','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3859','845','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3860','845','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3861','845','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3862','845','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3863','845','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3864','845','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3865','845','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3866','846','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3867','846','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3868','846','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3869','846','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3870','846','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3871','846','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3872','846','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3873','846','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3874','847','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3875','847','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3876','847','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3877','847','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3878','848','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3879','848','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3880','848','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3881','849','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3882','849','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3883','849','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3884','849','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3885','849','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3886','849','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3887','849','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3888','849','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3889','850','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3890','850','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3891','850','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3892','850','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3893','850','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3894','850','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3895','850','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3896','851','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3897','851','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3898','851','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3899','851','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3900','851','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3901','851','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3902','852','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3903','852','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3904','852','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3905','852','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3906','852','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3907','852','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3908','852','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3909','853','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3910','853','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3911','853','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3912','854','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3913','854','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3914','854','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3915','854','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3916','855','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3917','855','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3918','855','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3919','855','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3920','856','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3921','856','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3922','856','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3923','856','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3924','856','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3925','856','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3926','856','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3927','856','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3928','857','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3929','857','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3930','857','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3931','857','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3932','857','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3933','857','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3934','857','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3935','858','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3936','858','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3937','858','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3938','858','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3939','859','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3940','859','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3941','859','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3942','859','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3943','859','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3944','859','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3945','861','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3946','861','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3947','861','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3948','861','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3949','861','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3950','861','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3951','862','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3952','862','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3953','862','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3954','862','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3955','862','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3956','863','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3957','863','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3958','863','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3959','863','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3960','863','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3961','863','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3962','863','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3963','864','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3964','864','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3965','864','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3966','864','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3967','864','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3968','864','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3969','865','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3970','865','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3971','865','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3972','865','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3973','865','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3974','865','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3975','866','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3976','866','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3977','867','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3978','867','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3979','867','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3980','867','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3981','868','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3982','868','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3983','868','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3984','869','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3985','869','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3986','869','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3987','869','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3988','869','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3989','869','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3990','869','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3991','870','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3992','870','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3993','870','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3994','870','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3995','870','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3996','870','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3997','870','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3998','870','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('3999','871','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4000','871','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4001','871','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4002','871','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4003','871','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4004','872','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4005','872','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4006','872','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4007','873','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4008','873','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4009','873','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4010','873','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4011','873','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4012','873','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4013','873','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4014','873','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4015','875','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4016','875','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4017','875','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4018','875','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4019','875','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4020','875','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4021','875','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4022','876','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4023','876','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4024','877','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4025','877','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4026','877','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4027','877','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4028','877','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4029','878','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4030','878','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4031','878','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4032','878','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4033','879','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4034','879','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4035','879','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4036','879','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4037','879','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4038','879','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4039','879','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4040','880','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4041','880','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4042','880','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4043','880','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4044','880','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4045','880','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4046','880','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4047','880','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4048','881','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4049','881','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4050','881','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4051','881','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4052','882','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4053','882','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4054','882','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4055','882','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4056','883','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4057','883','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4058','884','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4059','884','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4060','884','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4061','885','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4062','885','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4063','886','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4064','886','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4065','886','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4066','886','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4067','887','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4068','887','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4069','887','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4070','887','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4071','887','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4072','887','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4073','888','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4074','888','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4075','888','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4076','888','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4077','889','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4078','889','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4079','889','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4080','890','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4081','890','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4082','890','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4083','890','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4084','890','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4085','890','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4086','890','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4087','891','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4088','891','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4089','891','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4090','891','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4091','891','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4092','891','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4093','891','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4094','892','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4095','892','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4096','892','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4097','892','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4098','892','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4099','892','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4100','892','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4101','893','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4102','893','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4103','893','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4104','893','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4105','893','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4106','893','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4107','893','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4108','893','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4109','894','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4110','894','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4111','894','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4112','894','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4113','894','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4114','895','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4115','895','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4116','895','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4117','895','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4118','895','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4119','895','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4120','895','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4121','896','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4122','896','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4123','896','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4124','896','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4125','897','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4126','897','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4127','897','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4128','897','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4129','897','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4130','897','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4131','897','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4132','897','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4133','898','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4134','898','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4135','898','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4136','898','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4137','898','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4138','899','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4139','899','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4140','899','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4141','900','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4142','900','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4143','900','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4144','900','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4145','901','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4146','901','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4147','901','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4148','901','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4149','901','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4150','901','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4151','901','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4152','902','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4153','902','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4154','902','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4155','902','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4156','902','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4157','902','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4158','902','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4159','903','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4160','903','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4161','904','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4162','904','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4163','905','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4164','905','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4165','905','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4166','906','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4167','906','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4168','906','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4169','906','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4170','906','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4171','907','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4172','907','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4173','907','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4174','907','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4175','908','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4176','908','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4177','908','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4178','908','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4179','910','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4180','910','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4181','911','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4182','911','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4183','911','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4184','911','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4185','911','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4186','911','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4187','911','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4188','911','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4189','912','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4190','912','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4191','912','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4192','912','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4193','912','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4194','912','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4195','913','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4196','913','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4197','913','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4198','913','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4199','913','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4200','913','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4201','914','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4202','914','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4203','914','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4204','914','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4205','914','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4206','914','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4207','915','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4208','915','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4209','915','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4210','915','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4211','915','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4212','915','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4213','916','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4214','916','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4215','916','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4216','916','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4217','917','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4218','917','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4219','917','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4220','917','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4221','917','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4222','918','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4223','918','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4224','918','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4225','918','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4226','919','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4227','919','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4228','919','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4229','919','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4230','920','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4231','920','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4232','920','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4233','920','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4234','920','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4235','921','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4236','921','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4237','921','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4238','921','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4239','922','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4240','922','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4241','922','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4242','922','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4243','922','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4244','922','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4245','922','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4246','923','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4247','923','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4248','923','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4249','924','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4250','924','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4251','924','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4252','924','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4253','924','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4254','925','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4255','925','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4256','925','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4257','925','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4258','925','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4259','926','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4260','926','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4261','927','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4262','927','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4263','927','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4264','927','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4265','928','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4266','928','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4267','928','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4268','929','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4269','929','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4270','929','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4271','929','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4272','930','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4273','930','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4274','930','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4275','930','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4276','930','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4277','930','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4278','931','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4279','931','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4280','931','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4281','932','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4282','932','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4283','932','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4284','932','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4285','933','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4286','933','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4287','933','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4288','934','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4289','934','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4290','934','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4291','935','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4292','935','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4293','936','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4294','936','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4295','936','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4296','936','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4297','936','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4298','936','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4299','937','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4300','937','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4301','937','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4302','937','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4303','937','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4304','938','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4305','938','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4306','938','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4307','938','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4308','938','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4309','938','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4310','939','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4311','939','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4312','939','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4313','939','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4314','940','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4315','940','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4316','940','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4317','941','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4318','941','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4319','941','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4320','941','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4321','941','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4322','941','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4323','941','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4324','942','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4325','942','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4326','942','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4327','942','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4328','944','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4329','944','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4330','944','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4331','944','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4332','944','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4333','945','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4334','945','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4335','945','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4336','945','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4337','945','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4338','945','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4339','945','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4340','945','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4341','946','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4342','946','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4343','946','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4344','946','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4345','947','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4346','947','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4347','948','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4348','948','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4349','948','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4350','948','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4351','948','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4352','948','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4353','949','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4354','949','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4355','949','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4356','949','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4357','949','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4358','949','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4359','951','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4360','951','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4361','951','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4362','951','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4363','951','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4364','951','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4365','951','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4366','952','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4367','952','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4368','952','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4369','953','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4370','953','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4371','953','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4372','953','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4373','953','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4374','953','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4375','956','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4376','956','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4377','956','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4378','956','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4379','957','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4380','957','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4381','957','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4382','957','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4383','957','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4384','958','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4385','958','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4386','958','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4387','958','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4388','958','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4389','958','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4390','959','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4391','959','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4392','960','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4393','960','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4394','960','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4395','961','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4396','961','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4397','961','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4398','961','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4399','961','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4400','962','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4401','962','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4402','962','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4403','962','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4404','963','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4405','963','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4406','963','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4407','963','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4408','963','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4409','964','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4410','964','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4411','964','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4412','964','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4413','964','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4414','965','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4415','965','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4416','966','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4417','966','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4418','966','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4419','966','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4420','966','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4421','966','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4422','967','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4423','967','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4424','967','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4425','967','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4426','967','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4427','968','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4428','968','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4429','968','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4430','969','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4431','969','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4432','969','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4433','969','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4434','970','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4435','970','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4436','970','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4437','970','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4438','970','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4439','970','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4440','970','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4441','971','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4442','971','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4443','971','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4444','971','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4445','972','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4446','972','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4447','972','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4448','972','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4449','972','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4450','972','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4451','973','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4452','973','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4453','973','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4454','973','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4455','973','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4456','973','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4457','973','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4458','973','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4459','974','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4460','974','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4461','975','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4462','975','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4463','975','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4464','975','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4465','975','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4466','976','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4467','976','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4468','976','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4469','976','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4470','976','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4471','976','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4472','977','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4473','977','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4474','977','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4475','978','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4476','978','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4477','978','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4478','979','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4479','979','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4480','979','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4481','979','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4482','979','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4483','979','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4484','979','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4485','980','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4486','980','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4487','980','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4488','980','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4489','980','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4490','981','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4491','981','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4492','981','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4493','981','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4494','981','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4495','981','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4496','982','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4497','982','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4498','982','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4499','982','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4500','982','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4501','982','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4502','982','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4503','983','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4504','983','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4505','983','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4506','984','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4507','984','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4508','985','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4509','985','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4510','985','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4511','985','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4512','985','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4513','985','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4514','985','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4515','986','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4516','986','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4517','986','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4518','986','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4519','986','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4520','986','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4521','987','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4522','987','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4523','987','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4524','987','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4525','988','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4526','988','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4527','988','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4528','988','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4529','988','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4530','989','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4531','989','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4532','989','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4533','989','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4534','989','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4535','989','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4536','990','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4537','990','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4538','991','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4539','991','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4540','991','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4541','991','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4542','991','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4543','992','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4544','992','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4545','992','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4546','992','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4547','993','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4548','993','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4549','993','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4550','993','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4551','993','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4552','993','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4553','993','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4554','994','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4555','994','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4556','994','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4557','995','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4558','995','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4559','995','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4560','995','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4561','995','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4562','995','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4563','996','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4564','996','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4565','997','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4566','997','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4567','998','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4568','998','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4569','999','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4570','999','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4571','999','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4572','999','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4573','999','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4574','1000','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4575','1000','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4576','1000','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4577','1000','1','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4578','1000','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4579','1000','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4580','1000','2','2006-02-15T05:09:17.000')
;
Insert into inventory
 (inventory_id,film_id,store_id,last_update)
Values
('4581','1000','2','2006-02-15T05:09:17.000')
;
SET IDENTITY_INSERT inventory OFF

-- End of Script
--
--
-- Automatically generated by Advanced ETl Processor
-- http://www.etl-tools.com/
-- table country
-- Start of script

Insert into film_actor
 (actor_id,film_id,last_update)
Values
('1','1','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('1','23','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('1','25','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('1','106','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('1','140','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('1','166','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('1','277','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('1','361','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('1','438','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('1','499','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('1','506','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('1','509','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('1','605','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('1','635','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('1','749','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('1','832','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('1','939','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('1','970','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('1','980','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('2','3','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('2','31','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('2','47','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('2','105','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('2','132','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('2','145','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('2','226','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('2','249','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('2','314','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('2','321','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('2','357','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('2','369','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('2','399','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('2','458','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('2','481','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('2','485','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('2','518','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('2','540','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('2','550','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('2','555','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('2','561','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('2','742','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('2','754','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('2','811','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('2','958','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('3','17','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('3','40','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('3','42','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('3','87','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('3','111','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('3','185','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('3','289','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('3','329','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('3','336','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('3','341','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('3','393','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('3','441','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('3','453','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('3','480','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('3','539','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('3','618','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('3','685','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('3','827','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('3','966','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('3','967','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('3','971','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('3','996','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('4','23','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('4','25','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('4','56','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('4','62','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('4','79','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('4','87','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('4','355','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('4','379','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('4','398','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('4','463','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('4','490','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('4','616','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('4','635','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('4','691','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('4','712','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('4','714','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('4','721','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('4','798','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('4','832','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('4','858','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('4','909','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('4','924','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('5','19','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('5','54','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('5','85','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('5','146','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('5','171','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('5','172','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('5','202','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('5','203','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('5','286','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('5','288','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('5','316','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('5','340','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('5','369','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('5','375','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('5','383','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('5','392','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('5','411','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('5','503','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('5','535','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('5','571','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('5','650','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('5','665','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('5','687','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('5','730','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('5','732','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('5','811','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('5','817','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('5','841','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('5','865','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('6','29','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('6','53','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('6','60','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('6','70','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('6','112','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('6','164','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('6','165','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('6','193','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('6','256','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('6','451','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('6','503','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('6','509','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('6','517','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('6','519','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('6','605','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('6','692','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('6','826','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('6','892','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('6','902','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('6','994','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('7','25','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('7','27','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('7','35','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('7','67','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('7','96','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('7','170','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('7','173','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('7','217','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('7','218','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('7','225','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('7','292','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('7','351','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('7','414','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('7','463','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('7','554','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('7','618','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('7','633','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('7','637','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('7','691','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('7','758','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('7','766','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('7','770','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('7','805','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('7','806','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('7','846','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('7','900','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('7','901','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('7','910','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('7','957','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('7','959','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('8','47','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('8','115','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('8','158','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('8','179','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('8','195','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('8','205','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('8','255','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('8','263','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('8','321','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('8','396','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('8','458','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('8','523','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('8','532','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('8','554','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('8','752','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('8','769','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('8','771','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('8','859','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('8','895','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('8','936','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('9','30','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('9','74','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('9','147','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('9','148','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('9','191','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('9','200','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('9','204','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('9','434','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('9','510','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('9','514','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('9','552','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('9','650','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('9','671','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('9','697','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('9','722','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('9','752','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('9','811','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('9','815','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('9','865','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('9','873','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('9','889','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('9','903','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('9','926','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('9','964','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('9','974','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('10','1','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('10','9','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('10','191','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('10','236','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('10','251','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('10','366','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('10','477','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('10','480','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('10','522','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('10','530','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('10','587','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('10','694','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('10','703','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('10','716','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('10','782','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('10','914','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('10','929','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('10','930','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('10','964','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('10','966','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('10','980','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('10','983','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('11','118','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('11','205','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('11','281','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('11','283','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('11','348','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('11','364','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('11','395','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('11','429','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('11','433','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('11','453','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('11','485','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('11','532','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('11','567','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('11','587','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('11','597','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('11','636','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('11','709','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('11','850','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('11','854','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('11','888','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('11','896','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('11','928','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('11','938','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('11','969','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('11','988','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('12','16','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('12','17','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('12','34','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('12','37','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('12','91','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('12','92','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('12','107','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('12','155','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('12','177','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('12','208','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('12','213','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('12','216','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('12','243','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('12','344','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('12','400','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('12','416','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('12','420','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('12','457','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('12','513','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('12','540','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('12','593','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('12','631','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('12','635','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('12','672','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('12','716','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('12','728','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('12','812','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('12','838','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('12','871','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('12','880','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('12','945','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('13','17','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('13','29','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('13','45','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('13','87','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('13','110','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('13','144','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('13','154','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('13','162','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('13','203','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('13','254','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('13','337','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('13','346','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('13','381','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('13','385','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('13','427','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('13','456','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('13','513','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('13','515','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('13','522','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('13','524','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('13','528','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('13','571','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('13','588','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('13','597','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('13','600','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('13','718','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('13','729','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('13','816','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('13','817','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('13','832','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('13','833','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('13','843','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('13','897','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('13','966','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('13','998','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('14','154','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('14','187','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('14','232','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('14','241','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('14','253','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('14','255','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('14','258','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('14','284','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('14','292','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('14','370','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('14','415','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('14','417','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('14','418','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('14','454','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('14','472','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('14','475','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('14','495','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('14','536','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('14','537','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('14','612','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('14','688','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('14','759','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('14','764','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('14','847','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('14','856','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('14','890','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('14','908','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('14','919','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('14','948','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('14','970','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('15','31','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('15','89','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('15','91','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('15','108','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('15','125','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('15','236','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('15','275','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('15','280','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('15','326','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('15','342','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('15','414','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('15','445','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('15','500','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('15','502','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('15','541','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('15','553','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('15','594','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('15','626','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('15','635','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('15','745','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('15','783','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('15','795','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('15','817','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('15','886','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('15','924','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('15','949','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('15','968','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('15','985','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('16','80','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('16','87','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('16','101','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('16','121','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('16','155','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('16','177','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('16','218','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('16','221','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('16','267','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('16','269','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('16','271','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('16','280','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('16','287','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('16','345','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('16','438','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('16','453','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('16','455','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('16','456','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('16','503','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('16','548','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('16','582','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('16','583','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('16','717','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('16','758','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('16','779','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('16','886','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('16','967','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('17','96','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('17','119','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('17','124','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('17','127','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('17','154','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('17','199','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('17','201','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('17','236','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('17','280','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('17','310','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('17','313','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('17','378','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('17','457','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('17','469','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('17','478','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('17','500','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('17','515','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('17','521','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('17','573','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('17','603','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('17','606','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('17','734','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('17','770','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('17','794','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('17','800','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('17','853','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('17','873','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('17','874','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('17','880','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('17','948','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('17','957','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('17','959','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('18','44','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('18','84','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('18','144','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('18','172','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('18','268','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('18','279','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('18','280','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('18','321','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('18','386','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('18','460','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('18','462','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('18','484','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('18','536','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('18','561','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('18','612','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('18','717','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('18','808','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('18','842','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('18','863','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('18','883','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('18','917','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('18','944','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('19','2','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('19','3','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('19','144','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('19','152','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('19','182','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('19','208','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('19','212','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('19','217','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('19','266','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('19','404','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('19','428','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('19','473','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('19','490','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('19','510','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('19','513','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('19','644','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('19','670','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('19','673','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('19','711','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('19','750','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('19','752','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('19','756','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('19','771','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('19','785','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('19','877','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('20','1','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('20','54','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('20','63','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('20','140','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('20','146','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('20','165','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('20','231','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('20','243','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('20','269','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('20','274','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('20','348','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('20','366','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('20','445','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('20','478','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('20','492','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('20','499','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('20','527','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('20','531','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('20','538','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('20','589','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('20','643','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('20','652','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('20','663','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('20','714','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('20','717','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('20','757','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('20','784','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('20','863','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('20','962','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('20','977','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('21','6','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('21','87','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('21','88','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('21','142','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('21','159','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('21','179','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('21','253','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('21','281','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('21','321','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('21','398','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('21','426','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('21','429','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('21','497','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('21','507','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('21','530','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('21','680','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('21','686','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('21','700','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('21','702','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('21','733','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('21','734','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('21','798','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('21','804','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('21','887','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('21','893','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('21','920','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('21','983','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('22','9','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('22','23','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('22','56','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('22','89','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('22','111','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('22','146','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('22','291','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('22','294','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('22','349','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('22','369','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('22','418','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('22','430','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('22','483','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('22','491','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('22','495','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('22','536','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('22','600','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('22','634','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('22','648','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('22','688','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('22','731','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('22','742','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('22','775','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('22','802','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('22','912','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('22','964','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('23','6','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('23','42','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('23','78','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('23','105','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('23','116','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('23','117','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('23','125','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('23','212','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('23','226','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('23','235','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('23','254','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('23','367','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('23','370','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('23','414','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('23','419','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('23','435','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('23','449','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('23','491','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('23','536','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('23','549','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('23','636','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('23','649','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('23','673','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('23','691','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('23','766','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('23','782','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('23','804','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('23','820','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('23','826','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('23','833','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('23','842','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('23','853','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('23','855','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('23','856','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('23','935','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('23','981','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('23','997','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('24','3','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('24','83','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('24','112','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('24','126','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('24','148','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('24','164','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('24','178','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('24','194','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('24','199','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('24','242','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('24','256','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('24','277','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('24','335','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('24','405','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('24','463','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('24','515','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('24','585','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('24','603','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('24','653','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('24','704','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('24','781','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('24','829','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('24','832','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('24','969','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('25','21','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('25','86','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('25','153','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('25','179','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('25','204','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('25','213','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('25','226','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('25','245','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('25','311','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('25','404','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('25','411','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('25','420','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('25','538','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('25','564','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('25','583','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('25','606','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('25','688','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('25','697','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('25','755','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('25','871','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('25','914','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('26','9','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('26','21','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('26','34','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('26','90','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('26','93','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('26','103','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('26','147','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('26','186','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('26','201','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('26','225','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('26','241','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('26','327','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('26','329','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('26','340','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('26','345','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('26','390','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('26','392','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('26','529','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('26','544','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('26','564','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('26','635','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('26','644','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('26','682','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('26','688','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('26','715','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('26','732','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('26','758','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('26','764','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('26','795','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('26','821','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('26','885','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('26','904','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('26','906','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('27','19','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('27','34','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('27','85','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('27','150','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('27','172','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('27','273','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('27','334','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('27','347','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('27','359','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('27','398','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('27','415','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('27','462','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('27','477','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('27','500','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('27','503','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('27','540','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('27','586','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('27','593','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('27','637','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('27','679','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('27','682','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('27','695','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('27','771','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('27','805','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('27','830','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('27','854','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('27','873','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('27','880','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('27','889','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('27','904','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('27','967','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('27','986','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('27','996','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('28','14','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('28','43','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('28','58','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('28','74','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('28','96','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('28','107','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('28','259','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('28','263','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('28','287','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('28','358','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('28','502','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('28','508','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('28','532','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('28','551','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('28','574','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('28','597','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('28','619','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('28','625','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('28','652','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('28','679','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('28','743','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('28','790','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('28','793','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('28','816','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('28','827','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('28','835','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('28','879','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('28','908','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('28','953','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('28','973','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('28','994','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('29','10','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('29','79','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('29','105','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('29','110','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('29','131','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('29','133','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('29','172','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('29','226','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('29','273','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('29','282','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('29','296','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('29','311','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('29','335','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('29','342','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('29','436','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('29','444','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('29','449','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('29','462','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('29','482','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('29','488','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('29','519','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('29','547','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('29','590','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('29','646','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('29','723','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('29','812','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('29','862','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('29','928','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('29','944','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('30','1','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('30','53','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('30','64','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('30','69','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('30','77','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('30','87','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('30','260','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('30','262','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('30','286','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('30','292','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('30','301','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('30','318','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('30','321','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('30','357','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('30','565','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('30','732','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('30','797','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('30','838','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('30','945','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('31','88','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('31','146','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('31','163','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('31','164','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('31','188','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('31','299','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('31','308','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('31','368','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('31','380','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('31','431','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('31','585','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('31','637','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('31','700','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('31','739','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('31','793','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('31','802','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('31','880','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('31','978','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('32','65','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('32','84','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('32','103','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('32','112','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('32','136','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('32','197','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('32','199','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('32','219','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('32','309','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('32','312','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('32','401','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('32','427','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('32','431','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('32','523','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('32','567','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('32','585','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('32','606','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('32','651','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('32','667','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('32','669','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('32','815','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('32','928','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('32','980','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('33','56','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('33','112','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('33','135','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('33','154','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('33','214','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('33','252','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('33','305','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('33','306','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('33','473','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('33','489','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('33','574','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('33','618','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('33','667','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('33','694','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('33','712','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('33','735','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('33','737','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('33','754','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('33','775','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('33','878','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('33','881','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('33','965','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('33','972','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('33','993','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('34','43','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('34','90','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('34','119','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('34','125','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('34','172','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('34','182','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('34','244','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('34','336','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('34','389','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('34','393','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('34','438','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('34','493','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('34','502','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('34','525','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('34','668','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('34','720','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('34','779','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('34','788','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('34','794','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('34','836','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('34','846','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('34','853','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('34','929','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('34','950','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('34','971','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('35','10','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('35','35','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('35','52','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('35','201','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('35','256','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('35','389','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('35','589','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('35','612','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('35','615','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('35','707','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('35','732','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('35','738','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('35','748','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('35','817','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('35','914','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('36','15','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('36','81','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('36','171','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('36','231','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('36','245','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('36','283','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('36','380','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('36','381','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('36','387','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('36','390','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('36','410','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('36','426','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('36','427','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('36','453','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('36','466','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('36','484','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('36','493','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('36','499','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('36','569','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('36','590','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('36','600','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('36','714','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('36','715','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('36','716','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('36','731','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('36','875','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('36','915','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('36','931','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('36','956','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('37','10','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('37','12','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('37','19','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('37','118','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('37','119','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('37','122','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('37','146','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('37','204','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('37','253','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('37','260','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('37','277','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('37','317','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('37','467','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('37','477','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('37','485','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('37','508','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('37','529','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('37','553','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('37','555','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('37','572','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('37','588','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('37','662','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('37','663','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('37','694','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('37','697','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('37','785','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('37','839','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('37','840','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('37','853','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('37','900','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('37','925','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('37','963','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('37','966','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('37','989','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('37','997','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('38','24','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('38','111','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('38','160','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('38','176','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('38','223','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('38','241','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('38','274','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('38','335','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('38','338','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('38','353','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('38','448','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('38','450','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('38','458','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('38','501','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('38','516','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('38','547','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('38','583','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('38','618','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('38','619','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('38','705','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('38','793','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('38','827','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('38','839','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('38','853','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('38','876','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('39','71','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('39','73','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('39','168','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('39','203','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('39','222','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('39','290','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('39','293','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('39','320','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('39','415','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('39','425','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('39','431','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('39','456','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('39','476','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('39','559','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('39','587','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('39','598','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('39','606','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('39','648','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('39','683','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('39','689','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('39','696','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('39','700','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('39','703','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('39','736','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('39','772','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('39','815','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('39','831','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('39','920','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('40','1','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('40','11','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('40','34','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('40','107','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('40','128','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('40','163','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('40','177','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('40','223','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('40','233','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('40','326','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('40','374','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('40','394','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('40','396','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('40','463','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('40','466','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('40','494','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('40','521','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('40','723','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('40','737','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('40','744','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('40','747','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('40','754','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('40','799','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('40','835','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('40','868','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('40','869','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('40','887','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('40','933','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('40','938','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('41','4','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('41','60','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('41','69','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('41','86','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('41','100','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('41','150','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('41','159','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('41','194','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('41','203','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('41','212','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('41','230','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('41','249','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('41','252','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('41','305','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('41','336','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('41','383','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('41','544','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('41','596','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('41','657','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('41','674','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('41','678','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('41','721','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('41','724','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('41','779','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('41','784','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('41','799','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('41','894','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('41','912','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('41','942','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('42','24','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('42','139','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('42','309','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('42','320','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('42','333','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('42','500','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('42','502','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('42','505','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('42','527','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('42','535','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('42','546','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('42','568','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('42','648','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('42','665','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('42','673','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('42','687','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('42','713','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('42','738','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('42','798','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('42','861','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('42','865','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('42','867','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('42','876','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('42','890','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('42','907','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('42','922','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('42','932','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('43','19','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('43','42','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('43','56','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('43','89','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('43','105','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('43','147','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('43','161','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('43','180','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('43','239','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('43','276','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('43','330','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('43','344','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('43','359','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('43','377','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('43','410','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('43','462','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('43','533','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('43','598','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('43','605','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('43','608','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('43','621','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('43','753','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('43','827','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('43','833','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('43','917','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('43','958','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('44','58','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('44','84','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('44','88','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('44','94','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('44','109','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('44','176','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('44','242','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('44','273','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('44','322','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('44','420','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('44','434','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('44','490','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('44','591','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('44','598','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('44','604','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('44','699','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('44','751','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('44','784','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('44','825','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('44','854','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('44','875','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('44','878','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('44','883','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('44','896','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('44','902','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('44','937','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('44','944','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('44','952','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('44','982','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('44','998','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('45','18','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('45','65','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('45','66','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('45','115','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('45','117','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('45','164','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('45','187','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('45','198','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('45','219','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('45','330','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('45','407','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('45','416','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('45','463','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('45','467','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('45','484','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('45','502','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('45','503','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('45','508','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('45','537','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('45','680','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('45','714','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('45','767','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('45','778','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('45','797','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('45','810','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('45','895','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('45','900','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('45','901','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('45','920','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('45','925','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('45','975','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('45','978','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('46','38','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('46','51','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('46','174','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('46','254','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('46','296','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('46','319','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('46','407','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('46','448','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('46','456','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('46','463','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('46','478','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('46','538','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('46','540','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('46','567','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('46','731','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('46','766','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('46','768','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('46','820','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('46','829','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('46','830','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('46','836','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('46','889','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('46','980','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('46','991','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('47','25','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('47','36','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('47','53','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('47','67','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('47','172','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('47','233','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('47','273','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('47','351','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('47','385','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('47','484','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('47','508','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('47','576','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('47','670','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('47','734','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('47','737','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('47','770','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('47','777','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('47','787','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('47','790','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('47','913','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('47','923','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('47','924','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('47','944','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('47','973','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('48','99','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('48','101','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('48','134','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('48','150','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('48','164','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('48','211','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('48','245','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('48','267','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('48','287','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('48','295','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('48','312','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('48','315','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('48','345','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('48','349','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('48','428','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('48','506','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('48','545','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('48','559','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('48','570','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('48','599','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('48','645','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('48','705','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('48','757','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('48','792','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('48','922','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('48','926','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('49','31','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('49','151','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('49','195','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('49','207','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('49','250','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('49','282','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('49','348','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('49','391','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('49','400','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('49','407','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('49','423','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('49','433','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('49','469','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('49','506','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('49','542','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('49','558','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('49','579','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('49','595','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('49','662','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('49','709','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('49','716','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('49','725','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('49','729','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('49','811','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('49','927','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('49','977','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('49','980','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('50','111','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('50','178','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('50','243','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('50','248','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('50','274','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('50','288','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('50','303','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('50','306','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('50','327','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('50','372','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('50','401','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('50','417','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('50','420','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('50','437','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('50','476','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('50','504','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('50','520','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('50','552','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('50','591','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('50','621','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('50','632','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('50','645','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('50','672','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('50','717','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('50','732','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('50','795','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('50','829','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('50','840','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('50','897','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('50','918','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('50','924','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('50','957','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('51','5','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('51','63','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('51','103','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('51','112','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('51','121','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('51','153','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('51','395','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('51','408','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('51','420','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('51','461','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('51','490','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('51','525','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('51','627','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('51','678','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('51','733','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('51','734','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('51','737','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('51','750','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('51','847','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('51','891','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('51','895','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('51','940','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('51','974','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('51','990','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('51','993','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('52','20','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('52','92','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('52','96','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('52','108','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('52','203','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('52','249','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('52','341','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('52','376','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('52','388','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('52','407','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('52','424','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('52','474','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('52','515','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('52','517','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('52','584','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('52','596','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('52','664','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('52','675','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('52','689','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('52','714','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('52','812','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('52','878','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('52','879','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('52','915','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('52','951','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('52','999','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('53','1','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('53','9','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('53','51','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('53','58','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('53','109','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('53','122','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('53','126','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('53','181','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('53','256','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('53','268','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('53','285','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('53','307','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('53','358','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('53','386','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('53','447','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('53','465','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('53','490','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('53','492','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('53','508','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('53','518','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('53','573','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('53','576','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('53','577','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('53','697','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('53','725','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('53','727','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('53','937','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('53','947','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('53','961','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('53','980','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('54','84','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('54','129','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('54','150','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('54','184','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('54','285','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('54','292','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('54','301','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('54','348','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('54','489','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('54','510','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('54','524','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('54','546','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('54','600','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('54','636','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('54','649','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('54','658','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('54','754','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('54','764','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('54','842','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('54','858','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('54','861','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('54','913','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('54','970','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('54','988','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('54','990','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('55','8','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('55','27','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('55','75','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('55','197','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('55','307','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('55','320','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('55','340','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('55','403','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('55','485','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('55','486','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('55','603','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('55','612','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('55','620','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('55','709','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('55','776','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('55','790','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('55','815','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('55','827','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('55','930','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('55','963','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('56','63','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('56','87','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('56','226','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('56','236','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('56','298','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('56','307','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('56','354','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('56','383','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('56','417','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('56','421','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('56','457','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('56','462','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('56','474','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('56','521','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('56','593','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('56','728','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('56','750','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('56','769','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('56','781','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('56','795','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('56','844','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('56','851','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('56','862','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('56','868','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('56','892','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('56','893','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('56','936','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('56','965','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('57','16','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('57','34','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('57','101','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('57','114','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('57','122','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('57','134','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('57','144','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('57','153','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('57','192','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('57','213','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('57','258','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('57','267','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('57','317','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('57','340','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('57','393','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('57','437','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('57','447','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('57','502','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('57','592','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('57','605','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('57','637','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('57','685','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('57','707','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('57','714','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('57','717','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('57','737','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('57','767','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('57','852','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('57','891','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('57','918','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('58','48','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('58','68','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('58','119','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('58','128','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('58','135','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('58','175','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('58','199','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('58','235','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('58','242','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('58','243','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('58','254','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('58','306','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('58','316','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('58','417','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('58','426','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('58','460','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('58','477','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('58','541','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('58','549','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('58','551','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('58','553','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('58','578','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('58','602','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('58','632','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('58','635','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('58','638','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('58','698','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('58','726','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('58','755','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('58','800','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('58','856','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('58','858','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('59','5','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('59','46','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('59','54','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('59','72','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('59','88','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('59','121','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('59','129','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('59','130','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('59','183','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('59','210','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('59','241','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('59','295','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('59','418','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('59','572','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('59','644','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('59','650','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('59','689','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('59','694','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('59','702','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('59','713','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('59','749','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('59','772','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('59','853','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('59','862','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('59','943','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('59','946','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('59','984','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('60','31','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('60','85','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('60','133','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('60','142','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('60','177','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('60','179','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('60','186','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('60','222','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('60','235','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('60','239','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('60','253','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('60','262','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('60','297','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('60','299','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('60','334','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('60','376','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('60','423','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('60','436','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('60','493','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('60','534','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('60','551','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('60','658','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('60','665','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('60','679','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('60','754','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('60','771','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('60','783','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('60','784','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('60','805','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('60','830','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('60','835','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('60','928','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('60','952','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('60','971','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('60','986','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('61','235','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('61','237','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('61','307','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('61','362','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('61','372','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('61','374','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('61','423','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('61','433','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('61','508','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('61','518','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('61','519','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('61','535','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('61','537','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('61','585','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('61','639','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('61','648','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('61','649','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('61','703','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('61','752','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('61','766','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('61','767','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('61','780','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('61','831','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('61','832','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('61','990','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('62','6','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('62','42','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('62','54','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('62','100','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('62','101','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('62','129','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('62','198','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('62','211','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('62','231','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('62','272','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('62','295','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('62','337','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('62','375','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('62','385','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('62','393','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('62','398','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('62','406','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('62','413','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('62','428','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('62','445','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('62','457','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('62','465','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('62','688','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('62','707','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('62','719','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('62','951','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('62','981','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('62','988','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('62','990','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('63','73','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('63','134','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('63','167','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('63','208','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('63','225','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('63','248','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('63','249','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('63','278','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('63','392','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('63','517','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('63','633','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('63','763','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('63','781','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('63','809','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('63','893','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('63','932','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('63','944','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('63','945','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('63','981','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('64','3','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('64','10','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('64','37','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('64','87','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('64','88','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('64','124','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('64','197','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('64','280','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('64','291','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('64','307','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('64','335','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('64','345','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('64','448','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('64','469','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('64','471','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('64','506','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('64','543','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('64','557','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('64','569','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('64','572','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('64','597','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('64','616','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('64','646','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('64','694','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('64','832','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('64','852','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('64','860','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('64','921','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('64','925','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('64','980','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('65','39','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('65','46','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('65','97','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('65','106','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('65','117','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('65','125','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('65','158','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('65','276','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('65','305','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('65','338','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('65','347','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('65','371','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('65','398','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('65','471','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('65','475','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('65','476','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('65','491','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('65','496','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('65','516','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('65','517','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('65','541','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('65','556','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('65','571','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('65','577','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('65','615','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('65','658','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('65','683','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('65','694','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('65','714','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('65','735','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('65','852','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('65','938','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('65','951','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('65','965','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('66','55','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('66','143','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('66','207','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('66','226','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('66','229','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('66','230','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('66','283','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('66','300','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('66','342','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('66','350','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('66','361','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('66','376','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('66','424','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('66','434','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('66','553','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('66','608','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('66','676','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('66','697','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('66','706','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('66','725','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('66','769','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('66','793','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('66','829','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('66','871','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('66','909','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('66','915','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('66','928','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('66','951','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('66','957','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('66','960','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('66','999','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('67','24','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('67','57','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('67','67','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('67','144','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('67','242','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('67','244','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('67','256','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('67','408','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('67','477','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('67','496','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('67','512','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('67','576','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('67','601','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('67','725','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('67','726','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('67','731','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('67','766','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('67','861','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('67','870','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('67','915','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('67','945','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('67','972','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('67','981','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('68','9','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('68','45','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('68','133','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('68','161','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('68','205','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('68','213','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('68','215','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('68','255','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('68','296','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('68','315','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('68','325','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('68','331','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('68','347','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('68','357','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('68','378','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('68','380','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('68','386','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('68','396','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('68','435','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('68','497','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('68','607','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('68','654','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('68','665','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('68','671','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('68','706','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('68','747','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('68','834','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('68','839','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('68','840','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('68','971','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('69','15','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('69','88','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('69','111','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('69','202','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('69','236','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('69','292','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('69','300','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('69','306','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('69','374','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('69','396','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('69','452','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('69','466','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('69','529','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('69','612','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('69','720','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('69','722','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('69','761','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('69','791','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('69','864','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('69','877','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('69','914','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('70','50','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('70','53','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('70','92','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('70','202','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('70','227','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('70','249','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('70','290','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('70','304','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('70','343','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('70','414','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('70','453','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('70','466','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('70','504','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('70','584','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('70','628','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('70','654','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('70','725','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('70','823','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('70','834','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('70','856','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('70','869','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('70','953','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('70','964','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('71','26','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('71','52','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('71','233','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('71','317','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('71','359','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('71','362','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('71','385','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('71','399','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('71','450','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('71','532','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('71','560','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('71','574','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('71','638','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('71','773','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('71','833','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('71','874','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('71','918','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('71','956','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('72','34','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('72','144','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('72','237','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('72','249','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('72','286','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('72','296','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('72','325','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('72','331','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('72','405','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('72','450','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('72','550','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('72','609','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('72','623','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('72','636','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('72','640','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('72','665','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('72','718','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('72','743','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('72','757','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('72','773','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('72','854','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('72','865','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('72','938','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('72','956','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('72','964','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('72','969','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('73','36','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('73','45','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('73','51','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('73','77','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('73','148','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('73','245','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('73','275','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('73','322','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('73','374','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('73','379','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('73','467','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('73','548','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('73','561','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('73','562','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('73','565','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('73','627','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('73','666','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('73','667','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('73','707','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('73','748','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('73','772','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('73','823','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('73','936','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('73','946','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('73','950','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('73','998','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('74','28','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('74','44','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('74','117','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('74','185','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('74','192','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('74','203','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('74','263','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('74','321','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('74','415','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('74','484','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('74','503','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('74','537','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('74','543','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('74','617','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('74','626','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('74','637','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('74','663','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('74','704','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('74','720','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('74','747','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('74','780','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('74','804','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('74','834','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('74','836','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('74','848','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('74','872','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('74','902','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('74','956','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('75','12','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('75','34','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('75','143','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('75','170','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('75','222','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('75','301','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('75','347','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('75','372','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('75','436','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('75','445','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('75','446','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('75','492','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('75','498','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('75','508','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('75','541','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('75','547','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('75','579','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('75','645','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('75','667','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('75','744','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('75','764','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('75','780','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('75','870','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('75','920','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('76','60','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('76','66','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('76','68','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('76','95','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('76','122','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('76','187','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('76','223','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('76','234','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('76','251','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('76','348','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('76','444','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('76','464','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('76','474','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('76','498','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('76','568','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('76','604','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('76','606','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('76','642','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('76','648','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('76','650','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('76','709','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('76','760','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('76','765','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('76','781','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('76','850','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('76','862','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('76','866','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('76','870','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('76','912','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('76','935','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('76','958','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('77','13','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('77','22','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('77','40','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('77','73','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('77','78','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('77','153','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('77','224','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('77','240','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('77','245','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('77','261','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('77','343','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('77','442','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('77','458','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('77','538','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('77','566','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('77','612','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('77','635','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('77','694','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('77','749','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('77','938','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('77','943','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('77','963','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('77','969','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('77','993','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('78','86','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('78','239','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('78','260','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('78','261','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('78','265','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('78','301','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('78','387','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('78','393','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('78','428','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('78','457','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('78','505','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('78','520','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('78','530','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('78','549','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('78','552','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('78','599','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('78','670','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('78','674','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('78','689','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('78','762','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('78','767','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('78','811','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('78','852','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('78','880','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('78','963','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('78','968','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('79','32','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('79','33','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('79','40','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('79','141','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('79','205','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('79','230','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('79','242','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('79','262','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('79','267','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('79','269','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('79','299','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('79','367','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('79','428','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('79','430','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('79','473','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('79','607','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('79','628','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('79','634','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('79','646','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('79','727','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('79','750','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('79','753','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('79','769','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('79','776','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('79','788','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('79','840','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('79','853','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('79','916','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('80','69','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('80','118','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('80','124','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('80','175','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('80','207','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('80','212','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('80','260','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('80','262','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('80','280','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('80','341','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('80','342','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('80','343','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('80','362','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('80','436','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('80','475','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('80','553','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('80','619','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('80','622','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('80','680','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('80','687','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('80','688','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('80','709','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('80','788','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('80','807','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('80','858','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('80','888','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('80','941','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('80','979','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('81','4','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('81','11','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('81','59','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('81','89','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('81','178','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('81','186','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('81','194','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('81','215','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('81','219','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('81','232','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('81','260','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('81','267','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('81','268','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('81','304','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('81','332','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('81','389','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('81','398','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('81','453','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('81','458','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('81','465','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('81','505','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('81','508','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('81','527','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('81','545','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('81','564','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('81','578','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('81','579','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('81','613','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('81','619','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('81','643','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('81','692','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('81','710','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('81','729','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('81','761','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('81','827','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('81','910','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('82','17','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('82','33','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('82','104','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('82','143','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('82','188','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('82','242','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('82','247','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('82','290','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('82','306','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('82','316','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('82','344','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('82','453','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('82','468','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('82','480','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('82','497','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('82','503','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('82','527','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('82','551','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('82','561','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('82','750','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('82','787','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('82','802','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('82','838','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('82','839','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('82','870','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('82','877','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('82','893','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('82','911','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('82','954','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('82','978','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('82','985','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('83','49','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('83','52','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('83','58','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('83','110','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('83','120','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('83','121','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('83','135','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('83','165','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('83','217','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('83','247','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('83','249','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('83','263','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('83','268','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('83','279','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('83','281','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('83','339','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('83','340','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('83','369','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('83','412','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('83','519','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('83','529','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('83','615','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('83','631','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('83','655','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('83','672','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('83','686','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('83','719','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('83','764','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('83','777','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('83','784','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('83','833','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('83','873','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('83','932','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('84','19','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('84','39','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('84','46','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('84','175','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('84','238','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('84','281','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('84','290','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('84','312','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('84','317','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('84','413','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('84','414','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('84','460','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('84','479','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('84','491','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('84','529','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('84','540','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('84','566','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('84','574','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('84','589','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('84','616','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('84','646','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('84','703','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('84','729','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('84','764','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('84','782','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('84','809','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('84','830','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('84','843','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('84','887','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('84','975','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('84','996','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('85','2','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('85','14','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('85','72','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('85','85','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('85','92','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('85','148','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('85','216','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('85','290','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('85','296','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('85','297','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('85','337','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('85','383','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('85','421','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('85','446','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('85','461','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('85','475','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('85','478','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('85','522','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('85','543','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('85','558','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('85','591','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('85','630','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('85','678','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('85','711','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('85','761','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('85','812','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('85','869','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('85','875','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('85','895','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('85','957','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('85','960','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('86','137','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('86','163','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('86','196','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('86','216','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('86','249','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('86','303','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('86','331','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('86','364','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('86','391','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('86','432','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('86','482','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('86','486','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('86','519','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('86','520','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('86','548','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('86','623','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('86','631','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('86','636','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('86','752','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('86','760','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('86','808','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('86','857','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('86','878','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('86','893','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('86','905','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('86','923','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('86','929','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('87','48','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('87','157','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('87','161','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('87','199','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('87','207','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('87','250','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('87','253','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('87','312','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('87','421','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('87','570','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('87','599','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('87','606','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('87','654','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('87','679','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('87','706','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('87','718','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('87','721','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('87','830','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('87','870','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('87','952','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('87','961','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('88','4','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('88','76','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('88','87','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('88','128','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('88','170','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('88','193','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('88','234','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('88','304','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('88','602','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('88','620','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('88','668','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('88','717','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('88','785','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('88','819','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('88','839','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('88','881','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('88','908','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('88','929','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('88','940','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('88','968','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('89','47','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('89','103','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('89','117','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('89','162','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('89','182','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('89','187','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('89','212','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('89','254','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('89','266','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('89','306','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('89','342','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('89','406','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('89','410','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('89','446','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('89','473','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('89','488','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('89','529','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('89','542','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('89','564','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('89','697','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('89','833','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('89','864','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('89','970','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('89','976','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('90','2','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('90','11','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('90','100','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('90','197','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('90','212','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('90','262','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('90','303','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('90','330','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('90','363','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('90','374','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('90','384','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('90','385','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('90','391','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('90','406','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('90','433','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('90','442','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('90','451','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('90','520','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('90','529','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('90','542','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('90','586','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('90','633','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('90','663','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('90','676','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('90','771','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('90','817','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('90','838','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('90','855','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('90','858','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('90','868','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('90','880','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('90','901','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('90','925','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('91','13','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('91','25','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('91','48','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('91','176','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('91','181','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('91','190','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('91','335','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('91','416','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('91','447','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('91','480','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('91','493','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('91','509','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('91','511','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('91','608','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('91','807','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('91','829','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('91','849','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('91','859','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('91','941','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('91','982','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('92','90','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('92','94','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('92','103','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('92','104','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('92','123','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('92','137','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('92','207','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('92','229','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('92','338','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('92','381','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('92','436','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('92','443','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('92','453','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('92','470','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('92','505','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('92','512','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('92','543','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('92','545','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('92','547','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('92','553','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('92','564','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('92','568','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('92','618','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('92','662','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('92','686','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('92','699','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('92','712','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('92','728','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('92','802','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('92','825','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('92','838','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('92','889','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('92','929','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('92','991','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('93','71','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('93','120','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('93','124','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('93','280','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('93','325','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('93','339','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('93','427','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('93','445','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('93','453','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('93','473','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('93','573','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('93','621','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('93','644','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('93','678','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('93','680','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('93','699','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('93','744','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('93','768','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('93','777','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('93','835','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('93','856','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('93','874','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('93','909','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('93','916','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('93','982','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('94','13','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('94','60','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('94','76','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('94','122','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('94','153','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('94','193','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('94','206','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('94','228','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('94','270','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('94','275','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('94','320','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('94','322','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('94','337','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('94','354','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('94','402','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('94','428','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('94','457','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('94','473','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('94','475','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('94','512','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('94','517','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('94','521','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('94','533','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('94','540','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('94','548','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('94','551','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('94','712','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('94','713','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('94','724','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('94','775','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('94','788','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('94','950','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('94','989','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('95','22','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('95','35','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('95','47','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('95','52','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('95','65','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('95','74','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('95','126','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('95','207','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('95','245','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('95','294','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('95','301','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('95','312','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('95','329','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('95','353','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('95','375','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('95','420','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('95','424','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('95','431','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('95','498','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('95','522','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('95','546','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('95','551','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('95','619','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('95','627','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('95','690','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('95','748','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('95','813','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('95','828','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('95','855','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('95','903','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('95','923','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('96','8','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('96','36','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('96','40','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('96','54','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('96','58','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('96','66','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('96','134','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('96','209','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('96','244','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('96','320','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('96','430','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('96','452','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('96','486','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('96','572','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('96','590','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('96','661','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('96','778','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('96','832','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('96','846','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('96','874','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('96','945','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('96','968','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('96','987','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('97','143','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('97','177','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('97','188','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('97','197','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('97','256','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('97','312','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('97','342','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('97','348','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('97','358','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('97','370','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('97','437','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('97','446','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('97','466','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('97','518','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('97','553','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('97','561','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('97','641','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('97','656','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('97','728','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('97','755','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('97','757','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('97','826','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('97','862','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('97','930','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('97','933','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('97','947','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('97','951','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('98','66','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('98','72','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('98','81','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('98','87','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('98','107','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('98','120','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('98','183','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('98','194','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('98','212','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('98','297','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('98','607','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('98','634','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('98','686','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('98','705','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('98','710','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('98','721','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('98','725','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('98','734','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('98','738','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('98','765','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('98','782','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('98','824','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('98','829','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('98','912','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('98','955','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('98','985','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('98','990','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('99','7','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('99','27','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('99','84','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('99','250','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('99','322','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('99','325','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('99','381','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('99','414','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('99','475','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('99','490','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('99','512','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('99','540','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('99','572','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('99','600','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('99','618','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('99','620','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('99','622','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('99','636','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('99','672','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('99','726','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('99','741','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('99','796','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('99','835','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('99','967','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('99','978','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('99','982','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('100','17','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('100','118','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('100','250','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('100','411','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('100','414','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('100','513','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('100','563','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('100','642','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('100','714','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('100','718','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('100','759','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('100','779','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('100','815','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('100','846','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('100','850','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('100','872','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('100','877','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('100','909','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('100','919','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('100','944','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('100','967','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('100','979','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('100','991','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('100','992','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('101','60','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('101','66','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('101','85','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('101','146','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('101','189','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('101','250','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('101','255','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('101','263','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('101','275','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('101','289','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('101','491','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('101','494','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('101','511','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('101','568','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('101','608','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('101','617','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('101','655','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('101','662','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('101','700','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('101','702','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('101','758','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('101','774','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('101','787','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('101','828','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('101','841','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('101','928','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('101','932','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('101','936','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('101','941','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('101','978','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('101','980','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('101','984','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('101','988','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('102','20','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('102','34','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('102','53','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('102','123','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('102','124','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('102','194','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('102','200','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('102','205','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('102','268','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('102','326','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('102','329','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('102','334','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('102','351','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('102','418','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('102','431','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('102','446','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('102','485','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('102','508','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('102','517','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('102','521','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('102','526','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('102','529','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('102','544','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('102','600','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('102','605','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('102','606','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('102','624','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('102','631','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('102','712','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('102','728','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('102','744','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('102','796','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('102','802','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('102','810','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('102','828','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('102','837','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('102','845','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('102','852','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('102','958','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('102','979','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('102','980','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('103','5','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('103','118','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('103','130','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('103','197','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('103','199','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('103','206','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('103','215','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('103','221','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('103','271','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('103','285','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('103','315','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('103','318','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('103','333','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('103','347','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('103','356','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('103','360','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('103','378','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('103','437','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('103','585','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('103','609','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('103','639','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('103','643','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('103','692','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('103','735','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('103','822','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('103','895','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('103','903','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('103','912','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('103','942','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('103','956','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('104','19','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('104','39','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('104','40','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('104','59','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('104','70','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('104','136','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('104','156','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('104','184','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('104','198','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('104','233','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('104','259','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('104','287','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('104','309','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('104','313','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('104','394','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('104','401','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('104','463','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('104','506','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('104','516','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('104','583','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('104','600','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('104','607','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('104','657','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('104','677','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('104','739','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('104','892','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('104','904','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('104','926','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('104','945','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('104','984','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('104','999','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('105','12','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('105','15','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('105','21','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('105','29','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('105','42','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('105','116','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('105','158','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('105','239','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('105','280','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('105','283','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('105','315','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('105','333','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('105','372','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('105','377','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('105','530','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('105','558','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('105','561','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('105','606','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('105','649','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('105','686','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('105','750','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('105','795','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('105','831','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('105','835','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('105','858','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('105','864','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('105','893','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('105','906','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('105','910','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('105','915','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('105','954','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('105','990','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('105','993','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('105','994','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('106','44','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('106','83','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('106','108','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('106','126','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('106','136','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('106','166','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('106','189','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('106','194','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('106','204','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('106','229','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('106','241','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('106','345','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('106','365','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('106','399','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('106','439','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('106','457','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('106','469','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('106','500','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('106','505','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('106','559','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('106','566','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('106','585','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('106','639','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('106','654','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('106','659','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('106','675','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('106','687','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('106','752','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('106','763','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('106','780','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('106','858','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('106','866','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('106','881','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('106','894','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('106','934','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('107','62','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('107','112','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('107','133','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('107','136','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('107','138','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('107','162','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('107','165','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('107','172','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('107','209','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('107','220','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('107','239','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('107','277','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('107','292','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('107','338','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('107','348','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('107','369','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('107','388','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('107','392','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('107','409','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('107','430','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('107','445','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('107','454','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('107','458','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('107','467','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('107','520','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('107','534','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('107','548','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('107','571','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('107','574','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('107','603','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('107','606','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('107','637','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('107','774','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('107','781','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('107','796','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('107','831','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('107','849','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('107','859','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('107','879','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('107','905','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('107','973','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('107','977','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('108','1','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('108','6','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('108','9','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('108','137','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('108','208','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('108','219','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('108','242','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('108','278','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('108','302','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('108','350','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('108','378','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('108','379','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('108','495','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('108','507','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('108','517','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('108','561','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('108','567','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('108','648','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('108','652','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('108','655','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('108','673','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('108','693','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('108','696','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('108','702','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('108','721','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('108','733','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('108','741','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('108','744','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('108','887','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('108','892','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('108','894','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('108','920','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('108','958','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('108','966','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('109','12','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('109','48','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('109','77','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('109','157','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('109','174','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('109','190','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('109','243','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('109','281','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('109','393','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('109','463','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('109','622','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('109','657','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('109','694','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('109','700','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('109','732','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('109','753','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('109','785','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('109','786','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('109','863','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('109','885','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('109','955','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('109','967','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('110','8','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('110','27','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('110','62','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('110','120','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('110','126','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('110','156','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('110','292','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('110','343','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('110','360','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('110','369','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('110','435','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('110','513','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('110','525','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('110','539','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('110','545','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('110','625','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('110','650','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('110','801','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('110','912','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('110','961','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('110','987','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('111','61','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('111','78','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('111','98','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('111','162','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('111','179','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('111','194','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('111','325','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('111','359','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('111','382','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('111','403','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('111','407','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('111','414','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('111','474','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('111','489','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('111','508','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('111','555','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('111','603','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('111','608','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('111','643','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('111','669','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('111','679','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('111','680','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('111','699','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('111','731','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('111','732','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('111','737','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('111','744','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('111','777','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('111','847','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('111','894','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('111','919','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('111','962','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('111','973','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('112','34','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('112','37','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('112','151','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('112','173','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('112','188','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('112','231','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('112','312','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('112','322','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('112','443','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('112','450','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('112','565','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('112','603','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('112','606','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('112','654','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('112','666','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('112','700','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('112','728','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('112','772','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('112','796','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('112','817','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('112','829','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('112','856','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('112','865','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('112','869','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('112','988','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('113','35','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('113','84','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('113','116','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('113','181','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('113','218','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('113','249','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('113','258','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('113','292','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('113','322','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('113','353','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('113','403','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('113','525','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('113','642','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('113','656','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('113','674','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('113','680','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('113','700','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('113','719','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('113','723','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('113','726','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('113','732','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('113','748','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('113','838','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('113','890','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('113','921','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('113','969','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('113','981','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('114','13','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('114','68','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('114','90','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('114','162','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('114','188','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('114','194','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('114','210','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('114','237','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('114','254','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('114','305','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('114','339','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('114','420','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('114','425','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('114','452','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('114','538','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('114','619','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('114','757','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('114','807','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('114','827','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('114','841','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('114','861','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('114','866','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('114','913','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('114','961','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('114','993','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('115','49','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('115','52','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('115','245','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('115','246','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('115','277','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('115','302','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('115','379','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('115','383','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('115','391','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('115','428','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('115','506','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('115','531','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('115','607','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('115','615','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('115','661','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('115','671','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('115','686','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('115','703','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('115','714','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('115','740','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('115','754','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('115','846','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('115','887','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('115','952','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('115','955','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('115','966','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('115','985','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('115','994','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('116','36','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('116','48','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('116','88','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('116','90','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('116','105','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('116','128','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('116','336','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('116','338','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('116','384','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('116','412','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('116','420','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('116','451','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('116','481','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('116','492','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('116','584','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('116','606','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('116','622','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('116','647','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('116','653','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('116','742','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('116','784','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('116','844','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('116','939','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('116','956','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('117','10','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('117','15','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('117','42','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('117','167','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('117','178','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('117','190','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('117','197','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('117','224','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('117','246','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('117','273','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('117','298','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('117','316','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('117','337','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('117','395','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('117','423','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('117','432','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('117','459','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('117','468','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('117','550','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('117','578','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('117','707','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('117','710','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('117','738','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('117','739','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('117','778','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('117','783','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('117','785','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('117','797','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('117','812','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('117','831','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('117','864','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('117','887','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('117','926','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('118','35','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('118','39','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('118','41','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('118','49','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('118','55','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('118','136','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('118','141','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('118','151','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('118','311','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('118','384','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('118','399','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('118','499','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('118','517','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('118','553','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('118','558','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('118','572','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('118','641','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('118','656','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('118','695','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('118','735','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('118','788','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('118','852','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('118','938','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('118','957','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('118','969','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('119','21','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('119','49','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('119','64','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('119','87','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('119','143','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('119','171','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('119','172','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('119','173','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('119','381','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('119','394','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('119','412','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('119','418','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('119','454','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('119','509','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('119','521','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('119','567','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('119','570','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('119','592','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('119','614','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('119','636','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('119','649','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('119','693','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('119','738','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('119','751','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('119','782','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('119','786','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('119','788','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('119','802','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('119','858','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('119','868','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('119','900','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('119','939','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('120','57','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('120','63','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('120','144','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('120','149','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('120','208','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('120','231','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('120','238','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('120','255','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('120','414','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('120','424','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('120','489','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('120','513','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('120','590','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('120','641','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('120','642','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('120','659','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('120','682','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('120','691','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('120','715','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('120','717','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('120','722','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('120','746','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('120','830','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('120','894','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('120','898','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('120','911','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('120','994','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('121','141','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('121','154','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('121','161','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('121','170','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('121','186','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('121','198','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('121','220','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('121','222','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('121','284','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('121','297','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('121','338','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('121','353','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('121','449','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('121','479','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('121','517','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('121','633','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('121','654','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('121','658','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('121','666','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('121','771','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('121','780','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('121','847','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('121','884','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('121','885','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('121','966','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('122','22','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('122','29','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('122','76','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('122','83','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('122','157','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('122','158','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('122','166','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('122','227','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('122','238','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('122','300','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('122','307','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('122','363','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('122','470','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('122','489','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('122','491','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('122','542','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('122','620','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('122','649','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('122','654','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('122','673','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('122','718','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('122','795','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('122','957','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('122','961','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('122','998','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('123','3','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('123','43','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('123','67','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('123','105','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('123','148','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('123','151','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('123','185','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('123','223','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('123','234','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('123','245','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('123','246','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('123','266','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('123','286','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('123','429','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('123','442','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('123','446','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('123','479','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('123','480','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('123','494','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('123','503','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('123','530','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('123','576','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('123','577','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('123','589','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('123','593','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('123','725','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('123','730','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('123','786','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('123','860','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('123','892','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('123','926','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('123','988','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('124','22','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('124','64','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('124','106','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('124','113','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('124','190','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('124','246','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('124','260','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('124','263','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('124','289','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('124','306','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('124','312','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('124','322','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('124','343','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('124','449','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('124','468','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('124','539','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('124','601','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('124','726','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('124','742','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('124','775','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('124','785','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('124','814','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('124','858','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('124','882','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('124','987','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('124','997','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('125','62','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('125','98','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('125','100','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('125','114','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('125','175','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('125','188','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('125','204','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('125','238','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('125','250','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('125','324','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('125','338','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('125','361','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('125','367','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('125','395','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('125','414','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('125','428','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('125','429','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('125','450','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('125','497','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('125','557','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('125','568','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('125','584','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('125','602','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('125','623','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('125','664','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('125','683','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('125','710','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('125','877','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('125','908','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('125','949','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('125','965','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('126','21','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('126','34','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('126','43','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('126','58','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('126','85','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('126','96','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('126','193','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('126','194','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('126','199','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('126','256','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('126','263','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('126','288','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('126','317','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('126','347','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('126','369','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('126','370','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('126','419','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('126','468','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('126','469','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('126','545','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('126','685','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('126','836','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('126','860','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('127','36','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('127','47','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('127','48','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('127','79','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('127','119','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('127','141','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('127','157','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('127','202','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('127','286','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('127','333','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('127','354','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('127','366','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('127','382','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('127','388','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('127','411','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('127','459','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('127','553','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('127','573','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('127','613','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('127','617','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('127','641','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('127','710','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('127','727','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('127','749','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('127','763','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('127','771','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('127','791','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('127','819','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('127','839','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('127','846','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('127','911','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('127','953','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('127','970','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('128','26','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('128','82','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('128','119','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('128','168','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('128','212','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('128','238','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('128','299','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('128','312','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('128','326','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('128','336','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('128','345','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('128','407','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('128','462','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('128','485','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('128','516','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('128','564','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('128','614','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('128','650','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('128','665','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('128','671','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('128','693','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('128','696','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('128','759','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('128','774','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('128','814','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('128','899','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('128','912','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('128','944','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('128','949','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('128','965','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('129','56','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('129','89','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('129','101','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('129','166','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('129','202','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('129','230','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('129','247','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('129','249','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('129','348','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('129','367','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('129','391','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('129','418','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('129','431','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('129','452','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('129','471','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('129','520','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('129','597','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('129','602','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('129','640','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('129','669','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('129','684','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('129','705','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('129','805','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('129','826','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('129','834','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('129','857','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('129','910','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('129','920','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('129','938','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('129','962','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('130','9','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('130','26','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('130','37','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('130','43','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('130','49','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('130','57','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('130','107','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('130','112','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('130','208','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('130','326','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('130','375','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('130','416','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('130','431','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('130','452','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('130','453','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('130','478','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('130','507','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('130','525','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('130','549','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('130','592','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('130','702','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('130','725','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('130','764','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('130','809','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('130','869','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('130','930','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('130','981','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('131','48','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('131','66','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('131','94','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('131','120','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('131','147','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('131','206','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('131','320','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('131','383','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('131','432','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('131','436','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('131','450','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('131','479','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('131','494','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('131','515','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('131','539','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('131','590','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('131','647','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('131','693','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('131','713','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('131','770','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('131','798','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('131','809','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('131','875','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('131','881','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('131','921','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('132','81','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('132','82','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('132','133','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('132','156','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('132','162','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('132','311','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('132','345','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('132','377','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('132','410','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('132','538','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('132','562','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('132','586','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('132','626','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('132','637','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('132','698','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('132','756','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('132','806','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('132','897','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('132','899','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('132','904','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('132','930','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('132','987','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('133','7','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('133','51','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('133','133','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('133','172','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('133','210','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('133','270','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('133','280','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('133','286','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('133','338','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('133','342','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('133','351','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('133','368','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('133','385','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('133','390','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('133','397','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('133','410','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('133','452','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('133','463','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('133','514','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('133','588','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('133','594','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('133','635','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('133','652','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('133','727','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('133','806','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('133','868','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('133','882','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('133','894','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('133','933','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('133','952','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('134','132','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('134','145','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('134','161','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('134','219','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('134','243','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('134','250','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('134','278','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('134','341','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('134','386','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('134','413','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('134','558','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('134','588','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('134','624','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('134','655','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('134','683','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('134','690','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('134','861','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('134','896','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('134','897','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('134','915','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('134','927','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('134','936','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('135','35','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('135','41','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('135','65','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('135','88','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('135','170','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('135','269','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('135','320','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('135','353','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('135','357','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('135','364','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('135','455','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('135','458','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('135','484','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('135','541','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('135','553','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('135','616','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('135','628','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('135','719','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('135','814','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('135','905','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('136','20','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('136','25','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('136','33','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('136','56','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('136','61','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('136','193','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('136','214','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('136','229','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('136','243','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('136','256','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('136','262','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('136','271','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('136','288','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('136','300','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('136','364','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('136','401','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('136','414','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('136','420','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('136','474','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('136','485','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('136','542','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('136','552','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('136','620','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('136','649','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('136','686','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('136','781','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('136','806','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('136','808','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('136','818','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('136','842','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('136','933','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('136','993','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('137','6','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('137','14','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('137','56','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('137','96','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('137','160','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('137','224','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('137','249','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('137','254','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('137','263','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('137','268','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('137','304','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('137','390','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('137','410','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('137','433','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('137','446','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('137','489','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('137','530','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('137','564','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('137','603','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('137','610','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('137','688','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('137','703','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('137','745','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('137','758','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('137','832','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('137','841','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('137','917','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('138','8','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('138','52','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('138','61','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('138','125','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('138','157','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('138','214','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('138','258','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('138','376','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('138','403','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('138','446','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('138','453','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('138','508','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('138','553','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('138','561','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('138','583','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('138','627','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('138','639','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('138','695','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('138','747','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('138','879','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('138','885','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('138','923','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('138','970','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('138','989','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('139','20','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('139','35','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('139','57','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('139','74','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('139','90','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('139','107','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('139','155','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('139','170','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('139','181','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('139','200','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('139','229','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('139','233','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('139','261','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('139','262','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('139','266','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('139','282','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('139','284','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('139','373','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('139','447','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('139','489','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('139','529','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('139','540','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('139','570','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('139','602','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('139','605','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('139','636','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('139','691','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('139','706','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('139','719','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('139','744','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('139','746','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('139','862','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('139','892','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('140','27','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('140','77','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('140','112','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('140','135','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('140','185','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('140','258','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('140','370','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('140','373','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('140','498','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('140','509','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('140','576','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('140','587','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('140','599','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('140','608','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('140','647','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('140','665','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('140','670','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('140','693','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('140','702','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('140','729','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('140','730','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('140','731','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('140','736','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('140','742','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('140','778','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('140','820','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('140','830','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('140','835','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('140','857','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('140','923','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('140','934','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('140','999','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('141','43','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('141','67','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('141','188','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('141','191','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('141','207','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('141','223','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('141','341','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('141','358','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('141','380','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('141','395','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('141','467','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('141','491','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('141','589','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('141','607','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('141','673','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('141','740','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('141','752','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('141','768','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('141','772','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('141','787','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('141','821','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('141','829','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('141','840','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('141','849','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('141','862','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('141','863','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('141','909','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('141','992','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('142','10','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('142','18','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('142','107','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('142','139','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('142','186','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('142','199','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('142','248','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('142','328','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('142','350','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('142','371','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('142','470','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('142','481','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('142','494','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('142','501','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('142','504','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('142','540','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('142','554','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('142','575','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('142','608','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('142','710','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('142','712','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('142','735','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('142','759','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('142','794','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('142','842','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('142','859','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('142','863','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('142','875','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('142','906','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('142','914','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('142','999','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('143','47','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('143','79','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('143','141','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('143','175','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('143','232','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('143','239','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('143','316','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('143','339','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('143','361','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('143','386','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('143','404','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('143','457','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('143','485','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('143','497','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('143','560','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('143','576','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('143','603','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('143','613','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('143','659','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('143','660','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('143','680','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('143','687','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('143','690','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('143','706','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('143','792','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('143','821','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('143','830','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('143','872','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('143','878','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('143','906','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('143','958','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('144','18','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('144','67','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('144','79','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('144','90','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('144','99','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('144','105','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('144','123','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('144','125','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('144','127','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('144','130','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('144','135','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('144','164','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('144','184','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('144','216','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('144','228','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('144','260','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('144','272','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('144','291','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('144','293','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('144','312','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('144','393','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('144','396','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('144','473','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('144','504','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('144','540','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('144','599','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('144','668','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('144','702','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('144','753','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('144','762','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('144','776','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('144','785','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('144','845','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('144','894','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('144','953','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('145','39','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('145','109','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('145','120','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('145','154','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('145','155','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('145','243','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('145','293','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('145','402','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('145','409','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('145','457','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('145','475','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('145','487','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('145','494','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('145','527','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('145','592','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('145','625','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('145','629','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('145','641','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('145','661','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('145','664','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('145','692','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('145','713','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('145','726','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('145','748','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('145','822','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('145','893','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('145','923','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('145','953','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('146','12','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('146','16','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('146','33','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('146','117','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('146','177','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('146','191','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('146','197','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('146','207','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('146','218','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('146','278','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('146','296','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('146','314','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('146','320','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('146','372','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('146','384','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('146','402','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('146','410','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('146','427','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('146','429','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('146','512','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('146','514','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('146','571','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('146','591','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('146','720','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('146','731','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('146','734','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('146','871','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('146','909','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('146','922','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('146','945','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('146','955','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('146','966','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('146','969','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('147','4','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('147','85','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('147','131','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('147','139','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('147','145','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('147','178','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('147','251','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('147','254','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('147','295','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('147','298','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('147','305','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('147','310','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('147','318','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('147','333','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('147','341','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('147','351','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('147','394','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('147','402','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('147','405','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('147','410','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('147','431','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('147','443','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('147','508','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('147','554','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('147','563','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('147','649','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('147','688','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('147','708','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('147','864','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('147','957','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('147','987','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('148','27','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('148','57','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('148','133','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('148','149','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('148','226','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('148','342','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('148','368','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('148','422','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('148','468','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('148','633','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('148','718','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('148','768','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('148','772','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('148','792','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('149','53','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('149','72','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('149','95','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('149','118','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('149','139','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('149','146','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('149','153','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('149','159','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('149','169','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('149','178','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('149','188','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('149','193','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('149','339','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('149','354','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('149','362','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('149','365','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('149','458','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('149','631','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('149','670','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('149','685','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('149','761','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('149','782','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('149','810','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('149','811','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('149','899','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('149','905','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('149','913','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('149','921','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('149','947','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('149','949','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('149','992','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('150','23','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('150','63','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('150','75','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('150','94','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('150','105','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('150','168','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('150','190','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('150','206','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('150','233','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('150','270','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('150','285','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('150','306','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('150','386','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('150','433','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('150','446','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('150','447','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('150','468','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('150','508','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('150','542','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('150','551','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('150','629','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('150','647','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('150','672','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('150','697','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('150','728','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('150','777','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('150','854','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('150','873','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('150','880','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('150','887','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('150','889','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('150','892','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('150','953','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('150','962','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('151','131','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('151','144','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('151','167','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('151','170','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('151','217','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('151','232','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('151','342','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('151','367','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('151','370','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('151','382','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('151','451','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('151','463','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('151','482','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('151','501','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('151','527','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('151','539','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('151','570','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('151','574','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('151','634','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('151','658','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('151','665','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('151','703','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('151','880','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('151','892','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('151','895','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('151','989','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('152','59','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('152','153','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('152','217','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('152','248','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('152','318','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('152','332','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('152','475','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('152','476','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('152','578','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('152','607','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('152','611','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('152','615','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('152','674','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('152','680','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('152','729','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('152','768','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('152','821','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('152','846','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('152','891','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('152','898','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('152','927','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('152','964','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('152','968','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('153','47','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('153','64','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('153','136','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('153','180','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('153','203','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('153','231','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('153','444','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('153','476','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('153','480','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('153','486','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('153','536','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('153','627','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('153','732','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('153','756','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('153','766','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('153','817','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('153','847','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('153','919','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('153','938','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('153','988','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('154','27','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('154','111','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('154','141','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('154','158','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('154','169','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('154','170','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('154','193','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('154','208','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('154','274','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('154','276','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('154','282','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('154','299','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('154','314','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('154','396','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('154','399','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('154','421','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('154','440','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('154','467','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('154','474','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('154','489','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('154','588','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('154','602','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('154','680','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('154','698','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('154','802','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('154','842','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('154','954','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('154','988','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('155','20','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('155','67','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('155','128','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('155','153','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('155','220','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('155','249','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('155','303','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('155','312','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('155','359','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('155','361','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('155','383','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('155','387','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('155','407','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('155','427','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('155','459','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('155','513','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('155','584','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('155','590','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('155','630','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('155','688','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('155','757','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('155','768','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('155','785','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('155','849','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('155','885','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('155','890','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('155','941','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('155','966','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('155','987','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('155','997','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('155','1000','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('156','53','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('156','155','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('156','198','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('156','244','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('156','262','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('156','263','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('156','285','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('156','297','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('156','301','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('156','349','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('156','379','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('156','448','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('156','462','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('156','467','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('156','504','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('156','518','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('156','593','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('156','646','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('156','705','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('156','754','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('156','775','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('156','844','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('157','10','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('157','24','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('157','34','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('157','122','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('157','159','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('157','183','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('157','210','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('157','217','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('157','291','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('157','303','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('157','321','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('157','326','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('157','353','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('157','400','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('157','406','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('157','431','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('157','496','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('157','535','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('157','573','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('157','574','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('157','604','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('157','616','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('157','642','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('157','661','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('157','696','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('157','713','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('157','802','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('157','835','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('157','874','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('157','913','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('157','967','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('157','973','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('158','32','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('158','47','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('158','64','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('158','66','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('158','102','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('158','121','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('158','177','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('158','178','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('158','188','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('158','215','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('158','241','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('158','293','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('158','437','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('158','473','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('158','483','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('158','532','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('158','555','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('158','581','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('158','601','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('158','616','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('158','626','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('158','637','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('158','799','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('158','812','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('158','824','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('158','830','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('158','840','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('158','869','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('158','879','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('158','880','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('158','894','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('158','896','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('158','967','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('158','968','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('158','990','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('159','20','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('159','82','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('159','127','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('159','187','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('159','206','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('159','208','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('159','223','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('159','248','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('159','342','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('159','343','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('159','344','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('159','364','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('159','418','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('159','549','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('159','561','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('159','600','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('159','674','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('159','680','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('159','784','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('159','789','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('159','800','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('159','802','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('159','818','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('159','876','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('159','907','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('159','978','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('160','2','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('160','17','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('160','43','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('160','242','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('160','267','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('160','275','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('160','368','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('160','455','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('160','469','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('160','484','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('160','579','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('160','660','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('160','755','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('160','767','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('160','769','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('160','794','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('160','826','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('160','883','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('160','950','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('160','954','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('161','43','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('161','58','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('161','89','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('161','90','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('161','120','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('161','188','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('161','247','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('161','269','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('161','281','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('161','340','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('161','353','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('161','401','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('161','414','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('161','425','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('161','469','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('161','526','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('161','588','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('161','644','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('161','653','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('161','655','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('161','669','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('161','684','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('161','714','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('161','749','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('161','807','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('161','825','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('161','850','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('161','880','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('161','920','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('161','921','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('161','924','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('161','927','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('162','1','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('162','4','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('162','7','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('162','18','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('162','28','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('162','32','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('162','33','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('162','41','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('162','85','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('162','121','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('162','164','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('162','274','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('162','279','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('162','409','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('162','410','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('162','415','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('162','500','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('162','574','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('162','612','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('162','636','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('162','659','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('162','786','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('162','844','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('162','909','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('162','968','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('163','30','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('163','45','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('163','166','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('163','180','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('163','239','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('163','283','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('163','303','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('163','304','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('163','307','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('163','394','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('163','409','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('163','434','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('163','444','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('163','522','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('163','719','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('163','785','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('163','833','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('163','881','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('163','891','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('163','947','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('163','996','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('164','15','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('164','23','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('164','148','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('164','169','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('164','252','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('164','324','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('164','347','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('164','367','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('164','431','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('164','448','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('164','469','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('164','545','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('164','610','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('164','613','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('164','673','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('164','681','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('164','698','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('164','801','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('164','820','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('164','832','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('164','834','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('164','851','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('164','884','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('164','908','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('164','957','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('164','984','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('165','72','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('165','95','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('165','146','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('165','204','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('165','253','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('165','286','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('165','360','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('165','375','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('165','395','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('165','421','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('165','437','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('165','473','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('165','607','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('165','644','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('165','659','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('165','693','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('165','737','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('165','779','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('165','798','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('165','807','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('165','809','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('165','832','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('165','833','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('165','947','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('165','948','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('165','962','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('166','25','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('166','38','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('166','55','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('166','61','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('166','68','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('166','86','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('166','146','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('166','255','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('166','297','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('166','306','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('166','326','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('166','361','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('166','366','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('166','426','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('166','580','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('166','622','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('166','674','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('166','714','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('166','788','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('166','867','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('166','944','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('166','1000','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('167','17','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('167','25','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('167','63','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('167','72','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('167','107','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('167','120','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('167','191','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('167','294','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('167','319','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('167','339','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('167','341','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('167','496','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('167','554','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('167','626','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('167','628','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('167','672','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('167','692','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('167','717','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('167','734','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('167','794','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('167','800','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('167','802','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('167','856','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('167','864','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('167','882','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('167','923','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('168','32','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('168','56','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('168','92','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('168','115','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('168','188','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('168','196','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('168','208','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('168','237','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('168','241','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('168','255','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('168','305','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('168','336','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('168','387','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('168','433','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('168','438','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('168','519','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('168','602','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('168','619','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('168','626','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('168','652','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('168','678','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('168','685','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('168','804','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('168','807','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('168','826','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('168','841','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('168','886','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('168','889','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('168','892','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('168','927','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('168','959','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('169','6','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('169','78','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('169','93','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('169','246','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('169','248','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('169','289','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('169','301','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('169','326','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('169','349','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('169','372','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('169','398','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('169','434','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('169','505','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('169','564','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('169','571','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('169','634','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('169','642','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('169','673','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('169','694','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('169','727','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('169','778','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('169','815','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('169','847','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('169','849','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('169','894','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('169','897','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('169','954','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('169','992','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('169','998','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('170','7','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('170','15','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('170','27','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('170','33','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('170','102','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('170','139','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('170','180','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('170','184','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('170','212','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('170','299','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('170','322','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('170','358','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('170','416','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('170','508','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('170','537','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('170','705','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('170','758','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('170','764','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('170','868','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('170','877','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('170','886','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('170','925','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('170','993','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('170','996','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('171','49','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('171','146','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('171','166','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('171','181','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('171','219','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('171','273','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('171','296','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('171','318','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('171','342','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('171','397','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('171','447','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('171','450','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('171','466','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('171','549','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('171','560','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('171','566','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('171','608','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('171','625','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('171','645','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('171','701','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('171','761','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('171','779','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('171','849','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('171','872','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('171','892','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('171','898','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('171','903','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('171','953','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('172','57','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('172','100','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('172','148','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('172','215','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('172','302','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('172','345','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('172','368','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('172','385','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('172','423','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('172','487','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('172','493','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('172','529','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('172','538','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('172','567','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('172','609','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('172','639','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('172','649','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('172','661','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('172','667','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('172','710','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('172','744','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('172','758','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('172','771','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('172','833','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('172','959','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('173','49','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('173','55','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('173','74','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('173','80','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('173','106','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('173','154','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('173','162','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('173','188','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('173','235','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('173','313','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('173','379','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('173','405','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('173','491','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('173','496','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('173','529','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('173','550','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('173','564','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('173','571','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('173','592','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('173','688','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('173','753','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('173','757','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('173','852','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('173','857','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('173','921','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('173','928','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('173','933','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('174','11','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('174','61','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('174','168','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('174','298','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('174','352','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('174','442','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('174','451','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('174','496','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('174','610','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('174','618','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('174','622','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('174','659','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('174','677','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('174','705','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('174','722','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('174','780','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('174','797','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('174','809','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('174','827','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('174','830','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('174','852','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('174','853','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('174','879','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('174','982','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('175','9','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('175','29','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('175','67','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('175','129','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('175','155','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('175','190','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('175','191','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('175','362','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('175','405','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('175','424','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('175','439','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('175','442','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('175','483','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('175','591','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('175','596','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('175','616','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('175','719','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('175','729','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('175','772','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('175','778','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('175','828','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('175','842','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('175','890','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('175','908','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('175','977','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('175','978','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('175','998','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('176','13','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('176','73','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('176','89','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('176','150','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('176','162','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('176','238','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('176','252','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('176','303','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('176','320','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('176','401','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('176','417','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('176','441','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('176','458','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('176','461','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('176','517','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('176','521','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('176','543','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('176','573','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('176','699','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('176','726','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('176','740','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('176','746','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('176','758','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('176','802','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('176','827','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('176','839','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('176','859','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('176','872','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('176','946','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('177','12','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('177','39','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('177','52','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('177','55','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('177','86','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('177','175','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('177','188','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('177','235','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('177','237','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('177','289','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('177','363','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('177','401','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('177','433','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('177','458','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('177','522','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('177','543','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('177','563','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('177','649','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('177','683','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('177','684','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('177','726','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('177','751','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('177','763','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('177','764','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('177','827','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('177','910','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('177','956','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('178','30','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('178','34','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('178','109','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('178','146','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('178','160','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('178','164','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('178','194','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('178','197','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('178','273','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('178','311','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('178','397','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('178','483','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('178','517','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('178','537','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('178','587','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('178','708','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('178','733','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('178','744','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('178','762','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('178','930','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('178','974','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('178','983','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('178','1000','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('179','24','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('179','27','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('179','65','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('179','85','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('179','109','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('179','131','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('179','159','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('179','193','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('179','250','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('179','291','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('179','353','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('179','415','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('179','463','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('179','468','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('179','489','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('179','566','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('179','588','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('179','650','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('179','698','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('179','732','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('179','737','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('179','769','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('179','811','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('179','817','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('179','852','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('179','924','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('179','931','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('179','960','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('179','976','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('180','12','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('180','33','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('180','144','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('180','195','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('180','258','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('180','441','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('180','506','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('180','561','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('180','609','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('180','622','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('180','628','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('180','657','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('180','724','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('180','729','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('180','732','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('180','777','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('180','809','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('180','811','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('180','820','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('180','824','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('180','847','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('180','869','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('180','874','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('180','955','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('180','963','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('181','5','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('181','40','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('181','74','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('181','78','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('181','83','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('181','152','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('181','195','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('181','233','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('181','286','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('181','301','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('181','311','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('181','381','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('181','387','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('181','403','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('181','409','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('181','420','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('181','437','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('181','456','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('181','507','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('181','522','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('181','539','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('181','542','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('181','546','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('181','579','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('181','596','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('181','604','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('181','609','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('181','625','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('181','744','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('181','816','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('181','836','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('181','868','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('181','870','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('181','874','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('181','892','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('181','907','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('181','911','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('181','921','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('181','991','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('182','33','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('182','160','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('182','301','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('182','324','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('182','346','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('182','362','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('182','391','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('182','413','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('182','421','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('182','437','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('182','590','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('182','639','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('182','668','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('182','677','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('182','679','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('182','695','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('182','714','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('182','720','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('182','819','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('182','828','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('182','845','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('182','864','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('182','940','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('182','990','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('183','32','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('183','40','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('183','71','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('183','113','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('183','313','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('183','388','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('183','389','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('183','390','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('183','495','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('183','520','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('183','576','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('183','636','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('183','715','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('183','850','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('183','862','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('183','914','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('183','941','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('183','949','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('183','983','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('184','35','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('184','87','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('184','146','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('184','169','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('184','221','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('184','336','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('184','371','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('184','452','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('184','486','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('184','492','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('184','500','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('184','574','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('184','580','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('184','597','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('184','615','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('184','640','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('184','642','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('184','650','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('184','661','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('184','684','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('184','745','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('184','772','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('184','787','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('184','867','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('184','959','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('184','966','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('184','967','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('184','969','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('184','985','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('185','7','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('185','95','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('185','138','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('185','265','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('185','286','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('185','360','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('185','411','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('185','427','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('185','437','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('185','448','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('185','494','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('185','510','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('185','518','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('185','554','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('185','560','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('185','571','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('185','584','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('185','631','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('185','665','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('185','694','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('185','730','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('185','761','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('185','818','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('185','845','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('185','880','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('185','882','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('185','919','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('185','920','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('185','965','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('185','973','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('186','95','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('186','187','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('186','208','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('186','228','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('186','237','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('186','422','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('186','482','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('186','508','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('186','552','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('186','579','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('186','637','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('186','648','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('186','654','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('186','729','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('186','983','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('186','994','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('187','17','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('187','25','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('187','29','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('187','51','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('187','73','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('187','76','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('187','98','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('187','110','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('187','127','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('187','168','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('187','222','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('187','224','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('187','297','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('187','354','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('187','379','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('187','417','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('187','435','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('187','441','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('187','474','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('187','499','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('187','538','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('187','548','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('187','561','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('187','617','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('187','625','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('187','664','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('187','671','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('187','768','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('187','779','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('187','906','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('187','914','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('187','923','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('187','976','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('188','1','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('188','10','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('188','14','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('188','51','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('188','102','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('188','111','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('188','146','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('188','206','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('188','223','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('188','289','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('188','311','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('188','322','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('188','338','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('188','396','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('188','412','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('188','506','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('188','517','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('188','529','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('188','566','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('188','593','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('188','606','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('188','662','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('188','770','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('188','773','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('188','774','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('188','815','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('188','849','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('188','925','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('188','988','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('188','989','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('189','43','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('189','82','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('189','171','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('189','266','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('189','272','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('189','315','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('189','378','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('189','492','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('189','509','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('189','512','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('189','519','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('189','533','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('189','548','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('189','560','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('189','628','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('189','734','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('189','748','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('189','788','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('189','820','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('189','853','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('189','882','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('189','896','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('189','899','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('189','940','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('190','38','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('190','54','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('190','62','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('190','87','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('190','173','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('190','234','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('190','253','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('190','278','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('190','310','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('190','374','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('190','411','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('190','426','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('190','472','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('190','549','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('190','562','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('190','606','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('190','623','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('190','679','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('190','682','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('190','693','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('190','695','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('190','705','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('190','708','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('190','802','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('190','806','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('190','874','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('190','959','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('191','16','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('191','39','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('191','84','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('191','185','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('191','219','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('191','293','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('191','296','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('191','378','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('191','410','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('191','420','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('191','461','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('191','544','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('191','551','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('191','596','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('191','638','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('191','668','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('191','692','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('191','775','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('191','801','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('191','819','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('191','827','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('191','830','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('191','834','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('191','849','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('191','858','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('191','914','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('191','958','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('191','969','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('191','971','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('191','993','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('192','16','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('192','69','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('192','117','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('192','155','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('192','166','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('192','179','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('192','214','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('192','361','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('192','367','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('192','426','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('192','465','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('192','470','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('192','475','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('192','485','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('192','541','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('192','578','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('192','592','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('192','614','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('192','618','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('192','622','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('192','674','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('192','677','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('192','680','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('192','682','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('192','708','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('192','711','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('192','747','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('192','763','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('192','819','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('193','44','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('193','80','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('193','103','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('193','109','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('193','119','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('193','141','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('193','164','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('193','291','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('193','352','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('193','358','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('193','376','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('193','412','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('193','462','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('193','689','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('193','709','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('193','745','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('193','807','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('193','828','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('193','834','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('193','851','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('193','937','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('193','953','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('193','960','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('194','9','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('194','42','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('194','67','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('194','86','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('194','88','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('194','98','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('194','135','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('194','161','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('194','163','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('194','215','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('194','232','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('194','352','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('194','415','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('194','486','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('194','498','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('194','531','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('194','719','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('194','738','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('194','786','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('194','872','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('194','938','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('194','940','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('195','129','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('195','130','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('195','141','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('195','144','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('195','298','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('195','359','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('195','361','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('195','392','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('195','403','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('195','494','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('195','520','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('195','534','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('195','560','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('195','592','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('195','649','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('195','658','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('195','673','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('195','677','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('195','706','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('195','738','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('195','769','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('195','781','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('195','794','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('195','813','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('195','869','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('195','885','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('195','962','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('196','64','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('196','122','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('196','156','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('196','169','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('196','276','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('196','284','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('196','303','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('196','324','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('196','423','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('196','473','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('196','484','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('196','515','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('196','524','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('196','541','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('196','560','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('196','575','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('196','576','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('196','587','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('196','615','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('196','635','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('196','684','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('196','795','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('196','815','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('196','833','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('196','837','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('196','906','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('196','908','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('196','919','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('196','939','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('196','972','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('197','6','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('197','29','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('197','63','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('197','123','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('197','129','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('197','147','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('197','164','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('197','189','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('197','243','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('197','249','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('197','258','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('197','364','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('197','369','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('197','370','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('197','418','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('197','522','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('197','531','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('197','554','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('197','598','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('197','628','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('197','691','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('197','724','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('197','746','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('197','752','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('197','758','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('197','769','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('197','815','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('197','916','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('197','950','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('197','967','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('197','974','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('197','979','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('197','995','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('198','1','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('198','109','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('198','125','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('198','186','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('198','262','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('198','264','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('198','303','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('198','309','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('198','311','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('198','329','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('198','347','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('198','379','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('198','395','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('198','406','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('198','450','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('198','464','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('198','482','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('198','499','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('198','536','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('198','541','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('198','545','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('198','555','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('198','568','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('198','570','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('198','588','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('198','597','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('198','628','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('198','745','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('198','758','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('198','796','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('198','806','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('198','817','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('198','843','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('198','858','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('198','871','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('198','886','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('198','892','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('198','924','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('198','952','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('198','997','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('199','67','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('199','84','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('199','145','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('199','159','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('199','216','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('199','432','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('199','541','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('199','604','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('199','640','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('199','689','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('199','730','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('199','784','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('199','785','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('199','886','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('199','953','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('200','5','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('200','49','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('200','80','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('200','116','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('200','121','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('200','149','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('200','346','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('200','419','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('200','462','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('200','465','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('200','474','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('200','537','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('200','538','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('200','544','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('200','714','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('200','879','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('200','912','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('200','945','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('200','958','2006-02-15T05:05:03.000')
;
Insert into film_actor
 (actor_id,film_id,last_update)
Values
('200','993','2006-02-15T05:05:03.000')
;
-- End of Script
--
--
-- Automatically generated by Advanced ETl Processor
-- http://www.etl-tools.com/
-- table film_category
-- Start of script
Insert into film_category
 (film_id,category_id,last_update)
Values
('1','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('2','11','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('3','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('4','11','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('5','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('6','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('7','5','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('8','11','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('9','11','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('10','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('11','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('12','12','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('13','11','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('14','4','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('15','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('16','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('17','12','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('18','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('19','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('20','12','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('21','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('22','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('23','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('24','11','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('25','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('26','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('27','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('28','5','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('29','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('30','11','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('31','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('32','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('33','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('34','11','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('35','11','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('36','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('37','4','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('38','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('39','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('40','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('41','16','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('42','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('43','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('44','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('45','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('46','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('47','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('48','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('49','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('50','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('51','12','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('52','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('53','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('54','12','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('55','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('56','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('57','16','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('58','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('59','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('60','4','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('61','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('62','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('63','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('64','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('65','11','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('66','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('67','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('68','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('69','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('70','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('71','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('72','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('73','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('74','12','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('75','16','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('76','12','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('77','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('78','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('79','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('80','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('81','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('82','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('83','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('84','16','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('85','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('86','12','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('87','16','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('88','16','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('89','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('90','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('91','4','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('92','11','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('93','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('94','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('95','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('96','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('97','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('98','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('99','5','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('100','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('101','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('102','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('103','16','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('104','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('105','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('106','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('107','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('108','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('109','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('110','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('111','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('112','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('113','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('114','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('115','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('116','4','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('117','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('118','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('119','5','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('120','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('121','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('122','11','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('123','16','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('124','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('125','16','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('126','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('127','5','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('128','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('129','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('130','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('131','4','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('132','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('133','12','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('134','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('135','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('136','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('137','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('138','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('139','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('140','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('141','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('142','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('143','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('144','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('145','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('146','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('147','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('148','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('149','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('150','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('151','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('152','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('153','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('154','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('155','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('156','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('157','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('158','12','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('159','5','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('160','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('161','12','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('162','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('163','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('164','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('165','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('166','4','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('167','16','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('168','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('169','16','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('170','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('171','11','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('172','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('173','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('174','12','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('175','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('176','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('177','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('178','5','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('179','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('180','4','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('181','16','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('182','5','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('183','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('184','4','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('185','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('186','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('187','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('188','5','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('189','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('190','4','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('191','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('192','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('193','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('194','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('195','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('196','4','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('197','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('198','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('199','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('200','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('201','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('202','5','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('203','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('204','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('205','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('206','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('207','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('208','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('209','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('210','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('211','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('212','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('213','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('214','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('215','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('216','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('217','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('218','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('219','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('220','12','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('221','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('222','11','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('223','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('224','16','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('225','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('226','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('227','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('228','4','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('229','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('230','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('231','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('232','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('233','16','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('234','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('235','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('236','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('237','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('238','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('239','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('240','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('241','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('242','5','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('243','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('244','12','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('245','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('246','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('247','5','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('248','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('249','4','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('250','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('251','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('252','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('253','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('254','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('255','12','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('256','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('257','16','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('258','11','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('259','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('260','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('261','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('262','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('263','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('264','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('265','5','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('266','4','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('267','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('268','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('269','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('270','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('271','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('272','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('273','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('274','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('275','11','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('276','5','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('277','11','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('278','12','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('279','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('280','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('281','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('282','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('283','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('284','12','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('285','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('286','16','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('287','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('288','16','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('289','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('290','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('291','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('292','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('293','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('294','16','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('295','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('296','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('297','4','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('298','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('299','16','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('300','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('301','11','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('302','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('303','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('304','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('305','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('306','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('307','16','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('308','5','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('309','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('310','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('311','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('312','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('313','11','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('314','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('315','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('316','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('317','5','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('318','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('319','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('320','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('321','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('322','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('323','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('324','5','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('325','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('326','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('327','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('328','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('329','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('330','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('331','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('332','5','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('333','12','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('334','11','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('335','5','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('336','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('337','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('338','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('339','16','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('340','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('341','4','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('342','16','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('343','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('344','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('345','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('346','4','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('347','16','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('348','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('349','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('350','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('351','11','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('352','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('353','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('354','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('355','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('356','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('357','4','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('358','4','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('359','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('360','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('361','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('362','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('363','12','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('364','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('365','5','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('366','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('367','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('368','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('369','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('370','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('371','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('372','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('373','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('374','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('375','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('376','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('377','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('378','12','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('379','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('380','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('381','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('382','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('383','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('384','12','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('385','5','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('386','16','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('387','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('388','5','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('389','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('390','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('391','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('392','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('393','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('394','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('395','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('396','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('397','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('398','12','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('399','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('400','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('401','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('402','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('403','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('404','5','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('405','16','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('406','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('407','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('408','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('409','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('410','5','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('411','12','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('412','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('413','5','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('414','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('415','11','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('416','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('417','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('418','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('419','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('420','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('421','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('422','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('423','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('424','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('425','4','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('426','12','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('427','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('428','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('429','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('430','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('431','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('432','4','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('433','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('434','16','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('435','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('436','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('437','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('438','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('439','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('440','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('441','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('442','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('443','5','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('444','5','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('445','4','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('446','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('447','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('448','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('449','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('450','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('451','16','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('452','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('453','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('454','12','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('455','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('456','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('457','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('458','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('459','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('460','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('461','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('462','12','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('463','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('464','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('465','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('466','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('467','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('468','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('469','4','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('470','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('471','4','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('472','16','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('473','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('474','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('475','11','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('476','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('477','12','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('478','5','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('479','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('480','4','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('481','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('482','4','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('483','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('484','4','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('485','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('486','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('487','4','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('488','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('489','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('490','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('491','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('492','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('493','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('494','11','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('495','11','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('496','16','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('497','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('498','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('499','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('500','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('501','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('502','5','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('503','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('504','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('505','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('506','11','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('507','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('508','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('509','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('510','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('511','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('512','4','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('513','16','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('514','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('515','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('516','12','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('517','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('518','16','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('519','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('520','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('521','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('522','5','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('523','4','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('524','5','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('525','4','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('526','16','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('527','11','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('528','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('529','5','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('530','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('531','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('532','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('533','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('534','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('535','11','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('536','4','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('537','4','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('538','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('539','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('540','12','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('541','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('542','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('543','16','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('544','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('545','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('546','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('547','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('548','4','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('549','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('550','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('551','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('552','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('553','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('554','4','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('555','5','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('556','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('557','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('558','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('559','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('560','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('561','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('562','12','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('563','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('564','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('565','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('566','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('567','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('568','5','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('569','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('570','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('571','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('572','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('573','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('574','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('575','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('576','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('577','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('578','4','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('579','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('580','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('581','12','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('582','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('583','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('584','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('585','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('586','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('587','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('588','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('589','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('590','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('591','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('592','12','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('593','11','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('594','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('595','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('596','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('597','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('598','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('599','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('600','11','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('601','16','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('602','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('603','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('604','5','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('605','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('606','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('607','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('608','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('609','16','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('610','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('611','4','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('612','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('613','5','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('614','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('615','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('616','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('617','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('618','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('619','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('620','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('621','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('622','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('623','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('624','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('625','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('626','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('627','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('628','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('629','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('630','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('631','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('632','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('633','4','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('634','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('635','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('636','12','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('637','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('638','5','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('639','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('640','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('641','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('642','16','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('643','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('644','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('645','16','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('646','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('647','12','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('648','16','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('649','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('650','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('651','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('652','4','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('653','11','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('654','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('655','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('656','16','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('657','5','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('658','11','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('659','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('660','5','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('661','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('662','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('663','4','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('664','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('665','11','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('666','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('667','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('668','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('669','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('670','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('671','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('672','5','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('673','12','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('674','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('675','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('676','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('677','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('678','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('679','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('680','5','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('681','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('682','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('683','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('684','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('685','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('686','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('687','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('688','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('689','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('690','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('691','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('692','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('693','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('694','4','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('695','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('696','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('697','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('698','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('699','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('700','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('701','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('702','11','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('703','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('704','5','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('705','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('706','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('707','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('708','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('709','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('710','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('711','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('712','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('713','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('714','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('715','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('716','11','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('717','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('718','12','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('719','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('720','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('721','12','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('722','11','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('723','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('724','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('725','4','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('726','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('727','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('728','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('729','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('730','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('731','4','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('732','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('733','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('734','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('735','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('736','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('737','11','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('738','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('739','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('740','11','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('741','12','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('742','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('743','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('744','4','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('745','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('746','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('747','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('748','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('749','11','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('750','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('751','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('752','12','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('753','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('754','5','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('755','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('756','5','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('757','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('758','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('759','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('760','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('761','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('762','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('763','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('764','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('765','5','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('766','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('767','12','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('768','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('769','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('770','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('771','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('772','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('773','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('774','5','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('775','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('776','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('777','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('778','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('779','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('780','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('781','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('782','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('783','16','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('784','16','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('785','16','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('786','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('787','16','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('788','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('789','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('790','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('791','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('792','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('793','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('794','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('795','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('796','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('797','12','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('798','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('799','11','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('800','11','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('801','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('802','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('803','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('804','11','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('805','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('806','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('807','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('808','4','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('809','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('810','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('811','16','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('812','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('813','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('814','5','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('815','4','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('816','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('817','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('818','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('819','12','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('820','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('821','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('822','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('823','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('824','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('825','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('826','16','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('827','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('828','4','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('829','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('830','11','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('831','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('832','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('833','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('834','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('835','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('836','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('837','5','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('838','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('839','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('840','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('841','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('842','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('843','4','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('844','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('845','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('846','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('847','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('848','16','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('849','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('850','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('851','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('852','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('853','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('854','11','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('855','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('856','11','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('857','5','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('858','5','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('859','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('860','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('861','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('862','4','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('863','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('864','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('865','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('866','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('867','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('868','16','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('869','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('870','11','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('871','5','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('872','16','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('873','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('874','4','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('875','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('876','11','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('877','12','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('878','16','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('879','12','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('880','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('881','11','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('882','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('883','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('884','12','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('885','11','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('886','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('887','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('888','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('889','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('890','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('891','4','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('892','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('893','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('894','16','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('895','4','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('896','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('897','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('898','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('899','4','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('900','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('901','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('902','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('903','16','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('904','11','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('905','5','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('906','5','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('907','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('908','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('909','11','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('910','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('911','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('912','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('913','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('914','16','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('915','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('916','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('917','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('918','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('919','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('920','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('921','12','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('922','11','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('923','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('924','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('925','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('926','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('927','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('928','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('929','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('930','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('931','16','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('932','5','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('933','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('934','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('935','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('936','12','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('937','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('938','5','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('939','5','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('940','15','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('941','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('942','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('943','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('944','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('945','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('946','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('947','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('948','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('949','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('950','4','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('951','4','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('952','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('953','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('954','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('955','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('956','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('957','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('958','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('959','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('960','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('961','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('962','4','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('963','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('964','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('965','11','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('966','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('967','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('968','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('969','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('970','4','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('971','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('972','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('973','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('974','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('975','8','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('976','10','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('977','16','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('978','5','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('979','7','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('980','12','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('981','16','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('982','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('983','12','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('984','9','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('985','14','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('986','2','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('987','12','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('988','16','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('989','16','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('990','11','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('991','1','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('992','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('993','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('994','13','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('995','11','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('996','6','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('997','12','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('998','11','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('999','3','2006-02-15T05:07:09.000')
;
Insert into film_category
 (film_id,category_id,last_update)
Values
('1000','5','2006-02-15T05:07:09.000')
;

-- End of Script
--
--
-- Automatically generated by Advanced ETl Processor
-- http://www.etl-tools.com/
-- table country
-- Start of script

SET IDENTITY_INSERT customer ON

Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('1','1','MARY','SMITH','MARY.SMITH@sakilacustomer.org','5','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('2','1','PATRICIA','JOHNSON','PATRICIA.JOHNSON@sakilacustomer.org','6','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('3','1','LINDA','WILLIAMS','LINDA.WILLIAMS@sakilacustomer.org','7','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('4','2','BARBARA','JONES','BARBARA.JONES@sakilacustomer.org','8','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('5','1','ELIZABETH','BROWN','ELIZABETH.BROWN@sakilacustomer.org','9','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('6','2','JENNIFER','DAVIS','JENNIFER.DAVIS@sakilacustomer.org','10','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('7','1','MARIA','MILLER','MARIA.MILLER@sakilacustomer.org','11','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('8','2','SUSAN','WILSON','SUSAN.WILSON@sakilacustomer.org','12','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('9','2','MARGARET','MOORE','MARGARET.MOORE@sakilacustomer.org','13','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('10','1','DOROTHY','TAYLOR','DOROTHY.TAYLOR@sakilacustomer.org','14','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('11','2','LISA','ANDERSON','LISA.ANDERSON@sakilacustomer.org','15','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('12','1','NANCY','THOMAS','NANCY.THOMAS@sakilacustomer.org','16','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('13','2','KAREN','JACKSON','KAREN.JACKSON@sakilacustomer.org','17','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('14','2','BETTY','WHITE','BETTY.WHITE@sakilacustomer.org','18','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('15','1','HELEN','HARRIS','HELEN.HARRIS@sakilacustomer.org','19','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('16','2','SANDRA','MARTIN','SANDRA.MARTIN@sakilacustomer.org','20','0','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('17','1','DONNA','THOMPSON','DONNA.THOMPSON@sakilacustomer.org','21','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('18','2','CAROL','GARCIA','CAROL.GARCIA@sakilacustomer.org','22','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('19','1','RUTH','MARTINEZ','RUTH.MARTINEZ@sakilacustomer.org','23','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('20','2','SHARON','ROBINSON','SHARON.ROBINSON@sakilacustomer.org','24','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('21','1','MICHELLE','CLARK','MICHELLE.CLARK@sakilacustomer.org','25','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('22','1','LAURA','RODRIGUEZ','LAURA.RODRIGUEZ@sakilacustomer.org','26','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('23','2','SARAH','LEWIS','SARAH.LEWIS@sakilacustomer.org','27','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('24','2','KIMBERLY','LEE','KIMBERLY.LEE@sakilacustomer.org','28','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('25','1','DEBORAH','WALKER','DEBORAH.WALKER@sakilacustomer.org','29','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('26','2','JESSICA','HALL','JESSICA.HALL@sakilacustomer.org','30','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('27','2','SHIRLEY','ALLEN','SHIRLEY.ALLEN@sakilacustomer.org','31','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('28','1','CYNTHIA','YOUNG','CYNTHIA.YOUNG@sakilacustomer.org','32','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('29','2','ANGELA','HERNANDEZ','ANGELA.HERNANDEZ@sakilacustomer.org','33','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('30','1','MELISSA','KING','MELISSA.KING@sakilacustomer.org','34','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('31','2','BRENDA','WRIGHT','BRENDA.WRIGHT@sakilacustomer.org','35','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('32','1','AMY','LOPEZ','AMY.LOPEZ@sakilacustomer.org','36','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('33','2','ANNA','HILL','ANNA.HILL@sakilacustomer.org','37','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('34','2','REBECCA','SCOTT','REBECCA.SCOTT@sakilacustomer.org','38','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('35','2','VIRGINIA','GREEN','VIRGINIA.GREEN@sakilacustomer.org','39','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('36','2','KATHLEEN','ADAMS','KATHLEEN.ADAMS@sakilacustomer.org','40','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('37','1','PAMELA','BAKER','PAMELA.BAKER@sakilacustomer.org','41','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('38','1','MARTHA','GONZALEZ','MARTHA.GONZALEZ@sakilacustomer.org','42','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('39','1','DEBRA','NELSON','DEBRA.NELSON@sakilacustomer.org','43','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('40','2','AMANDA','CARTER','AMANDA.CARTER@sakilacustomer.org','44','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('41','1','STEPHANIE','MITCHELL','STEPHANIE.MITCHELL@sakilacustomer.org','45','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('42','2','CAROLYN','PEREZ','CAROLYN.PEREZ@sakilacustomer.org','46','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('43','2','CHRISTINE','ROBERTS','CHRISTINE.ROBERTS@sakilacustomer.org','47','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('44','1','MARIE','TURNER','MARIE.TURNER@sakilacustomer.org','48','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('45','1','JANET','PHILLIPS','JANET.PHILLIPS@sakilacustomer.org','49','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('46','2','CATHERINE','CAMPBELL','CATHERINE.CAMPBELL@sakilacustomer.org','50','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('47','1','FRANCES','PARKER','FRANCES.PARKER@sakilacustomer.org','51','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('48','1','ANN','EVANS','ANN.EVANS@sakilacustomer.org','52','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('49','2','JOYCE','EDWARDS','JOYCE.EDWARDS@sakilacustomer.org','53','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('50','1','DIANE','COLLINS','DIANE.COLLINS@sakilacustomer.org','54','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('51','1','ALICE','STEWART','ALICE.STEWART@sakilacustomer.org','55','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('52','1','JULIE','SANCHEZ','JULIE.SANCHEZ@sakilacustomer.org','56','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('53','1','HEATHER','MORRIS','HEATHER.MORRIS@sakilacustomer.org','57','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('54','1','TERESA','ROGERS','TERESA.ROGERS@sakilacustomer.org','58','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('55','2','DORIS','REED','DORIS.REED@sakilacustomer.org','59','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('56','1','GLORIA','COOK','GLORIA.COOK@sakilacustomer.org','60','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('57','2','EVELYN','MORGAN','EVELYN.MORGAN@sakilacustomer.org','61','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('58','1','JEAN','BELL','JEAN.BELL@sakilacustomer.org','62','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('59','1','CHERYL','MURPHY','CHERYL.MURPHY@sakilacustomer.org','63','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('60','1','MILDRED','BAILEY','MILDRED.BAILEY@sakilacustomer.org','64','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('61','2','KATHERINE','RIVERA','KATHERINE.RIVERA@sakilacustomer.org','65','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('62','1','JOAN','COOPER','JOAN.COOPER@sakilacustomer.org','66','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('63','1','ASHLEY','RICHARDSON','ASHLEY.RICHARDSON@sakilacustomer.org','67','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('64','2','JUDITH','COX','JUDITH.COX@sakilacustomer.org','68','0','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('65','2','ROSE','HOWARD','ROSE.HOWARD@sakilacustomer.org','69','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('66','2','JANICE','WARD','JANICE.WARD@sakilacustomer.org','70','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('67','1','KELLY','TORRES','KELLY.TORRES@sakilacustomer.org','71','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('68','1','NICOLE','PETERSON','NICOLE.PETERSON@sakilacustomer.org','72','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('69','2','JUDY','GRAY','JUDY.GRAY@sakilacustomer.org','73','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('70','2','CHRISTINA','RAMIREZ','CHRISTINA.RAMIREZ@sakilacustomer.org','74','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('71','1','KATHY','JAMES','KATHY.JAMES@sakilacustomer.org','75','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('72','2','THERESA','WATSON','THERESA.WATSON@sakilacustomer.org','76','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('73','2','BEVERLY','BROOKS','BEVERLY.BROOKS@sakilacustomer.org','77','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('74','1','DENISE','KELLY','DENISE.KELLY@sakilacustomer.org','78','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('75','2','TAMMY','SANDERS','TAMMY.SANDERS@sakilacustomer.org','79','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('76','2','IRENE','PRICE','IRENE.PRICE@sakilacustomer.org','80','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('77','2','JANE','BENNETT','JANE.BENNETT@sakilacustomer.org','81','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('78','1','LORI','WOOD','LORI.WOOD@sakilacustomer.org','82','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('79','1','RACHEL','BARNES','RACHEL.BARNES@sakilacustomer.org','83','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('80','1','MARILYN','ROSS','MARILYN.ROSS@sakilacustomer.org','84','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('81','1','ANDREA','HENDERSON','ANDREA.HENDERSON@sakilacustomer.org','85','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('82','1','KATHRYN','COLEMAN','KATHRYN.COLEMAN@sakilacustomer.org','86','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('83','1','LOUISE','JENKINS','LOUISE.JENKINS@sakilacustomer.org','87','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('84','2','SARA','PERRY','SARA.PERRY@sakilacustomer.org','88','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('85','2','ANNE','POWELL','ANNE.POWELL@sakilacustomer.org','89','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('86','2','JACQUELINE','LONG','JACQUELINE.LONG@sakilacustomer.org','90','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('87','1','WANDA','PATTERSON','WANDA.PATTERSON@sakilacustomer.org','91','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('88','2','BONNIE','HUGHES','BONNIE.HUGHES@sakilacustomer.org','92','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('89','1','JULIA','FLORES','JULIA.FLORES@sakilacustomer.org','93','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('90','2','RUBY','WASHINGTON','RUBY.WASHINGTON@sakilacustomer.org','94','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('91','2','LOIS','BUTLER','LOIS.BUTLER@sakilacustomer.org','95','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('92','2','TINA','SIMMONS','TINA.SIMMONS@sakilacustomer.org','96','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('93','1','PHYLLIS','FOSTER','PHYLLIS.FOSTER@sakilacustomer.org','97','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('94','1','NORMA','GONZALES','NORMA.GONZALES@sakilacustomer.org','98','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('95','2','PAULA','BRYANT','PAULA.BRYANT@sakilacustomer.org','99','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('96','1','DIANA','ALEXANDER','DIANA.ALEXANDER@sakilacustomer.org','100','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('97','2','ANNIE','RUSSELL','ANNIE.RUSSELL@sakilacustomer.org','101','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('98','1','LILLIAN','GRIFFIN','LILLIAN.GRIFFIN@sakilacustomer.org','102','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('99','2','EMILY','DIAZ','EMILY.DIAZ@sakilacustomer.org','103','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('100','1','ROBIN','HAYES','ROBIN.HAYES@sakilacustomer.org','104','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('101','1','PEGGY','MYERS','PEGGY.MYERS@sakilacustomer.org','105','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('102','1','CRYSTAL','FORD','CRYSTAL.FORD@sakilacustomer.org','106','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('103','1','GLADYS','HAMILTON','GLADYS.HAMILTON@sakilacustomer.org','107','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('104','1','RITA','GRAHAM','RITA.GRAHAM@sakilacustomer.org','108','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('105','1','DAWN','SULLIVAN','DAWN.SULLIVAN@sakilacustomer.org','109','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('106','1','CONNIE','WALLACE','CONNIE.WALLACE@sakilacustomer.org','110','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('107','1','FLORENCE','WOODS','FLORENCE.WOODS@sakilacustomer.org','111','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('108','1','TRACY','COLE','TRACY.COLE@sakilacustomer.org','112','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('109','2','EDNA','WEST','EDNA.WEST@sakilacustomer.org','113','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('110','2','TIFFANY','JORDAN','TIFFANY.JORDAN@sakilacustomer.org','114','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('111','1','CARMEN','OWENS','CARMEN.OWENS@sakilacustomer.org','115','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('112','2','ROSA','REYNOLDS','ROSA.REYNOLDS@sakilacustomer.org','116','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('113','2','CINDY','FISHER','CINDY.FISHER@sakilacustomer.org','117','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('114','2','GRACE','ELLIS','GRACE.ELLIS@sakilacustomer.org','118','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('115','1','WENDY','HARRISON','WENDY.HARRISON@sakilacustomer.org','119','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('116','1','VICTORIA','GIBSON','VICTORIA.GIBSON@sakilacustomer.org','120','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('117','1','EDITH','MCDONALD','EDITH.MCDONALD@sakilacustomer.org','121','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('118','1','KIM','CRUZ','KIM.CRUZ@sakilacustomer.org','122','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('119','1','SHERRY','MARSHALL','SHERRY.MARSHALL@sakilacustomer.org','123','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('120','2','SYLVIA','ORTIZ','SYLVIA.ORTIZ@sakilacustomer.org','124','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('121','1','JOSEPHINE','GOMEZ','JOSEPHINE.GOMEZ@sakilacustomer.org','125','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('122','1','THELMA','MURRAY','THELMA.MURRAY@sakilacustomer.org','126','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('123','2','SHANNON','FREEMAN','SHANNON.FREEMAN@sakilacustomer.org','127','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('124','1','SHEILA','WELLS','SHEILA.WELLS@sakilacustomer.org','128','0','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('125','1','ETHEL','WEBB','ETHEL.WEBB@sakilacustomer.org','129','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('126','1','ELLEN','SIMPSON','ELLEN.SIMPSON@sakilacustomer.org','130','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('127','2','ELAINE','STEVENS','ELAINE.STEVENS@sakilacustomer.org','131','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('128','1','MARJORIE','TUCKER','MARJORIE.TUCKER@sakilacustomer.org','132','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('129','1','CARRIE','PORTER','CARRIE.PORTER@sakilacustomer.org','133','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('130','1','CHARLOTTE','HUNTER','CHARLOTTE.HUNTER@sakilacustomer.org','134','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('131','2','MONICA','HICKS','MONICA.HICKS@sakilacustomer.org','135','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('132','2','ESTHER','CRAWFORD','ESTHER.CRAWFORD@sakilacustomer.org','136','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('133','1','PAULINE','HENRY','PAULINE.HENRY@sakilacustomer.org','137','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('134','1','EMMA','BOYD','EMMA.BOYD@sakilacustomer.org','138','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('135','2','JUANITA','MASON','JUANITA.MASON@sakilacustomer.org','139','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('136','2','ANITA','MORALES','ANITA.MORALES@sakilacustomer.org','140','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('137','2','RHONDA','KENNEDY','RHONDA.KENNEDY@sakilacustomer.org','141','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('138','1','HAZEL','WARREN','HAZEL.WARREN@sakilacustomer.org','142','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('139','1','AMBER','DIXON','AMBER.DIXON@sakilacustomer.org','143','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('140','1','EVA','RAMOS','EVA.RAMOS@sakilacustomer.org','144','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('141','1','DEBBIE','REYES','DEBBIE.REYES@sakilacustomer.org','145','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('142','1','APRIL','BURNS','APRIL.BURNS@sakilacustomer.org','146','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('143','1','LESLIE','GORDON','LESLIE.GORDON@sakilacustomer.org','147','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('144','1','CLARA','SHAW','CLARA.SHAW@sakilacustomer.org','148','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('145','1','LUCILLE','HOLMES','LUCILLE.HOLMES@sakilacustomer.org','149','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('146','1','JAMIE','RICE','JAMIE.RICE@sakilacustomer.org','150','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('147','2','JOANNE','ROBERTSON','JOANNE.ROBERTSON@sakilacustomer.org','151','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('148','1','ELEANOR','HUNT','ELEANOR.HUNT@sakilacustomer.org','152','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('149','1','VALERIE','BLACK','VALERIE.BLACK@sakilacustomer.org','153','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('150','2','DANIELLE','DANIELS','DANIELLE.DANIELS@sakilacustomer.org','154','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('151','2','MEGAN','PALMER','MEGAN.PALMER@sakilacustomer.org','155','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('152','1','ALICIA','MILLS','ALICIA.MILLS@sakilacustomer.org','156','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('153','2','SUZANNE','NICHOLS','SUZANNE.NICHOLS@sakilacustomer.org','157','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('154','2','MICHELE','GRANT','MICHELE.GRANT@sakilacustomer.org','158','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('155','1','GAIL','KNIGHT','GAIL.KNIGHT@sakilacustomer.org','159','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('156','1','BERTHA','FERGUSON','BERTHA.FERGUSON@sakilacustomer.org','160','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('157','2','DARLENE','ROSE','DARLENE.ROSE@sakilacustomer.org','161','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('158','1','VERONICA','STONE','VERONICA.STONE@sakilacustomer.org','162','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('159','1','JILL','HAWKINS','JILL.HAWKINS@sakilacustomer.org','163','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('160','2','ERIN','DUNN','ERIN.DUNN@sakilacustomer.org','164','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('161','1','GERALDINE','PERKINS','GERALDINE.PERKINS@sakilacustomer.org','165','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('162','2','LAUREN','HUDSON','LAUREN.HUDSON@sakilacustomer.org','166','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('163','1','CATHY','SPENCER','CATHY.SPENCER@sakilacustomer.org','167','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('164','2','JOANN','GARDNER','JOANN.GARDNER@sakilacustomer.org','168','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('165','2','LORRAINE','STEPHENS','LORRAINE.STEPHENS@sakilacustomer.org','169','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('166','1','LYNN','PAYNE','LYNN.PAYNE@sakilacustomer.org','170','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('167','2','SALLY','PIERCE','SALLY.PIERCE@sakilacustomer.org','171','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('168','1','REGINA','BERRY','REGINA.BERRY@sakilacustomer.org','172','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('169','2','ERICA','MATTHEWS','ERICA.MATTHEWS@sakilacustomer.org','173','0','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('170','1','BEATRICE','ARNOLD','BEATRICE.ARNOLD@sakilacustomer.org','174','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('171','2','DOLORES','WAGNER','DOLORES.WAGNER@sakilacustomer.org','175','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('172','1','BERNICE','WILLIS','BERNICE.WILLIS@sakilacustomer.org','176','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('173','1','AUDREY','RAY','AUDREY.RAY@sakilacustomer.org','177','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('174','2','YVONNE','WATKINS','YVONNE.WATKINS@sakilacustomer.org','178','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('175','1','ANNETTE','OLSON','ANNETTE.OLSON@sakilacustomer.org','179','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('176','1','JUNE','CARROLL','JUNE.CARROLL@sakilacustomer.org','180','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('177','2','SAMANTHA','DUNCAN','SAMANTHA.DUNCAN@sakilacustomer.org','181','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('178','2','MARION','SNYDER','MARION.SNYDER@sakilacustomer.org','182','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('179','1','DANA','HART','DANA.HART@sakilacustomer.org','183','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('180','2','STACY','CUNNINGHAM','STACY.CUNNINGHAM@sakilacustomer.org','184','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('181','2','ANA','BRADLEY','ANA.BRADLEY@sakilacustomer.org','185','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('182','1','RENEE','LANE','RENEE.LANE@sakilacustomer.org','186','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('183','2','IDA','ANDREWS','IDA.ANDREWS@sakilacustomer.org','187','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('184','1','VIVIAN','RUIZ','VIVIAN.RUIZ@sakilacustomer.org','188','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('185','1','ROBERTA','HARPER','ROBERTA.HARPER@sakilacustomer.org','189','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('186','2','HOLLY','FOX','HOLLY.FOX@sakilacustomer.org','190','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('187','2','BRITTANY','RILEY','BRITTANY.RILEY@sakilacustomer.org','191','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('188','1','MELANIE','ARMSTRONG','MELANIE.ARMSTRONG@sakilacustomer.org','192','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('189','1','LORETTA','CARPENTER','LORETTA.CARPENTER@sakilacustomer.org','193','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('190','2','YOLANDA','WEAVER','YOLANDA.WEAVER@sakilacustomer.org','194','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('191','1','JEANETTE','GREENE','JEANETTE.GREENE@sakilacustomer.org','195','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('192','1','LAURIE','LAWRENCE','LAURIE.LAWRENCE@sakilacustomer.org','196','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('193','2','KATIE','ELLIOTT','KATIE.ELLIOTT@sakilacustomer.org','197','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('194','2','KRISTEN','CHAVEZ','KRISTEN.CHAVEZ@sakilacustomer.org','198','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('195','1','VANESSA','SIMS','VANESSA.SIMS@sakilacustomer.org','199','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('196','1','ALMA','AUSTIN','ALMA.AUSTIN@sakilacustomer.org','200','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('197','2','SUE','PETERS','SUE.PETERS@sakilacustomer.org','201','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('198','2','ELSIE','KELLEY','ELSIE.KELLEY@sakilacustomer.org','202','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('199','2','BETH','FRANKLIN','BETH.FRANKLIN@sakilacustomer.org','203','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('200','2','JEANNE','LAWSON','JEANNE.LAWSON@sakilacustomer.org','204','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('201','1','VICKI','FIELDS','VICKI.FIELDS@sakilacustomer.org','205','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('202','2','CARLA','GUTIERREZ','CARLA.GUTIERREZ@sakilacustomer.org','206','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('203','1','TARA','RYAN','TARA.RYAN@sakilacustomer.org','207','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('204','1','ROSEMARY','SCHMIDT','ROSEMARY.SCHMIDT@sakilacustomer.org','208','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('205','2','EILEEN','CARR','EILEEN.CARR@sakilacustomer.org','209','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('206','1','TERRI','VASQUEZ','TERRI.VASQUEZ@sakilacustomer.org','210','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('207','1','GERTRUDE','CASTILLO','GERTRUDE.CASTILLO@sakilacustomer.org','211','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('208','1','LUCY','WHEELER','LUCY.WHEELER@sakilacustomer.org','212','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('209','2','TONYA','CHAPMAN','TONYA.CHAPMAN@sakilacustomer.org','213','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('210','2','ELLA','OLIVER','ELLA.OLIVER@sakilacustomer.org','214','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('211','1','STACEY','MONTGOMERY','STACEY.MONTGOMERY@sakilacustomer.org','215','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('212','2','WILMA','RICHARDS','WILMA.RICHARDS@sakilacustomer.org','216','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('213','1','GINA','WILLIAMSON','GINA.WILLIAMSON@sakilacustomer.org','217','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('214','1','KRISTIN','JOHNSTON','KRISTIN.JOHNSTON@sakilacustomer.org','218','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('215','2','JESSIE','BANKS','JESSIE.BANKS@sakilacustomer.org','219','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('216','1','NATALIE','MEYER','NATALIE.MEYER@sakilacustomer.org','220','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('217','2','AGNES','BISHOP','AGNES.BISHOP@sakilacustomer.org','221','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('218','1','VERA','MCCOY','VERA.MCCOY@sakilacustomer.org','222','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('219','2','WILLIE','HOWELL','WILLIE.HOWELL@sakilacustomer.org','223','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('220','2','CHARLENE','ALVAREZ','CHARLENE.ALVAREZ@sakilacustomer.org','224','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('221','1','BESSIE','MORRISON','BESSIE.MORRISON@sakilacustomer.org','225','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('222','2','DELORES','HANSEN','DELORES.HANSEN@sakilacustomer.org','226','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('223','1','MELINDA','FERNANDEZ','MELINDA.FERNANDEZ@sakilacustomer.org','227','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('224','2','PEARL','GARZA','PEARL.GARZA@sakilacustomer.org','228','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('225','1','ARLENE','HARVEY','ARLENE.HARVEY@sakilacustomer.org','229','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('226','2','MAUREEN','LITTLE','MAUREEN.LITTLE@sakilacustomer.org','230','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('227','1','COLLEEN','BURTON','COLLEEN.BURTON@sakilacustomer.org','231','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('228','2','ALLISON','STANLEY','ALLISON.STANLEY@sakilacustomer.org','232','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('229','1','TAMARA','NGUYEN','TAMARA.NGUYEN@sakilacustomer.org','233','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('230','2','JOY','GEORGE','JOY.GEORGE@sakilacustomer.org','234','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('231','1','GEORGIA','JACOBS','GEORGIA.JACOBS@sakilacustomer.org','235','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('232','2','CONSTANCE','REID','CONSTANCE.REID@sakilacustomer.org','236','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('233','2','LILLIE','KIM','LILLIE.KIM@sakilacustomer.org','237','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('234','1','CLAUDIA','FULLER','CLAUDIA.FULLER@sakilacustomer.org','238','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('235','1','JACKIE','LYNCH','JACKIE.LYNCH@sakilacustomer.org','239','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('236','1','MARCIA','DEAN','MARCIA.DEAN@sakilacustomer.org','240','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('237','1','TANYA','GILBERT','TANYA.GILBERT@sakilacustomer.org','241','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('238','1','NELLIE','GARRETT','NELLIE.GARRETT@sakilacustomer.org','242','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('239','2','MINNIE','ROMERO','MINNIE.ROMERO@sakilacustomer.org','243','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('240','1','MARLENE','WELCH','MARLENE.WELCH@sakilacustomer.org','244','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('241','2','HEIDI','LARSON','HEIDI.LARSON@sakilacustomer.org','245','0','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('242','1','GLENDA','FRAZIER','GLENDA.FRAZIER@sakilacustomer.org','246','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('243','1','LYDIA','BURKE','LYDIA.BURKE@sakilacustomer.org','247','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('244','2','VIOLA','HANSON','VIOLA.HANSON@sakilacustomer.org','248','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('245','1','COURTNEY','DAY','COURTNEY.DAY@sakilacustomer.org','249','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('246','1','MARIAN','MENDOZA','MARIAN.MENDOZA@sakilacustomer.org','250','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('247','1','STELLA','MORENO','STELLA.MORENO@sakilacustomer.org','251','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('248','1','CAROLINE','BOWMAN','CAROLINE.BOWMAN@sakilacustomer.org','252','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('249','2','DORA','MEDINA','DORA.MEDINA@sakilacustomer.org','253','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('250','2','JO','FOWLER','JO.FOWLER@sakilacustomer.org','254','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('251','2','VICKIE','BREWER','VICKIE.BREWER@sakilacustomer.org','255','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('252','2','MATTIE','HOFFMAN','MATTIE.HOFFMAN@sakilacustomer.org','256','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('253','1','TERRY','CARLSON','TERRY.CARLSON@sakilacustomer.org','258','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('254','2','MAXINE','SILVA','MAXINE.SILVA@sakilacustomer.org','259','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('255','2','IRMA','PEARSON','IRMA.PEARSON@sakilacustomer.org','260','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('256','2','MABEL','HOLLAND','MABEL.HOLLAND@sakilacustomer.org','261','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('257','2','MARSHA','DOUGLAS','MARSHA.DOUGLAS@sakilacustomer.org','262','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('258','1','MYRTLE','FLEMING','MYRTLE.FLEMING@sakilacustomer.org','263','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('259','2','LENA','JENSEN','LENA.JENSEN@sakilacustomer.org','264','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('260','1','CHRISTY','VARGAS','CHRISTY.VARGAS@sakilacustomer.org','265','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('261','1','DEANNA','BYRD','DEANNA.BYRD@sakilacustomer.org','266','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('262','2','PATSY','DAVIDSON','PATSY.DAVIDSON@sakilacustomer.org','267','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('263','1','HILDA','HOPKINS','HILDA.HOPKINS@sakilacustomer.org','268','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('264','1','GWENDOLYN','MAY','GWENDOLYN.MAY@sakilacustomer.org','269','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('265','2','JENNIE','TERRY','JENNIE.TERRY@sakilacustomer.org','270','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('266','2','NORA','HERRERA','NORA.HERRERA@sakilacustomer.org','271','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('267','1','MARGIE','WADE','MARGIE.WADE@sakilacustomer.org','272','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('268','1','NINA','SOTO','NINA.SOTO@sakilacustomer.org','273','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('269','1','CASSANDRA','WALTERS','CASSANDRA.WALTERS@sakilacustomer.org','274','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('270','1','LEAH','CURTIS','LEAH.CURTIS@sakilacustomer.org','275','1','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('271','1','PENNY','NEAL','PENNY.NEAL@sakilacustomer.org','276','0','2006-02-14T22:04:36.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('272','1','KAY','CALDWELL','KAY.CALDWELL@sakilacustomer.org','277','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('273','2','PRISCILLA','LOWE','PRISCILLA.LOWE@sakilacustomer.org','278','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('274','1','NAOMI','JENNINGS','NAOMI.JENNINGS@sakilacustomer.org','279','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('275','2','CAROLE','BARNETT','CAROLE.BARNETT@sakilacustomer.org','280','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('276','1','BRANDY','GRAVES','BRANDY.GRAVES@sakilacustomer.org','281','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('277','2','OLGA','JIMENEZ','OLGA.JIMENEZ@sakilacustomer.org','282','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('278','2','BILLIE','HORTON','BILLIE.HORTON@sakilacustomer.org','283','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('279','2','DIANNE','SHELTON','DIANNE.SHELTON@sakilacustomer.org','284','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('280','2','TRACEY','BARRETT','TRACEY.BARRETT@sakilacustomer.org','285','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('281','2','LEONA','OBRIEN','LEONA.OBRIEN@sakilacustomer.org','286','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('282','2','JENNY','CASTRO','JENNY.CASTRO@sakilacustomer.org','287','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('283','1','FELICIA','SUTTON','FELICIA.SUTTON@sakilacustomer.org','288','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('284','1','SONIA','GREGORY','SONIA.GREGORY@sakilacustomer.org','289','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('285','1','MIRIAM','MCKINNEY','MIRIAM.MCKINNEY@sakilacustomer.org','290','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('286','1','VELMA','LUCAS','VELMA.LUCAS@sakilacustomer.org','291','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('287','2','BECKY','MILES','BECKY.MILES@sakilacustomer.org','292','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('288','1','BOBBIE','CRAIG','BOBBIE.CRAIG@sakilacustomer.org','293','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('289','1','VIOLET','RODRIQUEZ','VIOLET.RODRIQUEZ@sakilacustomer.org','294','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('290','1','KRISTINA','CHAMBERS','KRISTINA.CHAMBERS@sakilacustomer.org','295','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('291','1','TONI','HOLT','TONI.HOLT@sakilacustomer.org','296','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('292','2','MISTY','LAMBERT','MISTY.LAMBERT@sakilacustomer.org','297','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('293','2','MAE','FLETCHER','MAE.FLETCHER@sakilacustomer.org','298','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('294','2','SHELLY','WATTS','SHELLY.WATTS@sakilacustomer.org','299','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('295','1','DAISY','BATES','DAISY.BATES@sakilacustomer.org','300','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('296','2','RAMONA','HALE','RAMONA.HALE@sakilacustomer.org','301','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('297','1','SHERRI','RHODES','SHERRI.RHODES@sakilacustomer.org','302','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('298','1','ERIKA','PENA','ERIKA.PENA@sakilacustomer.org','303','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('299','2','JAMES','GANNON','JAMES.GANNON@sakilacustomer.org','304','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('300','1','JOHN','FARNSWORTH','JOHN.FARNSWORTH@sakilacustomer.org','305','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('301','2','ROBERT','BAUGHMAN','ROBERT.BAUGHMAN@sakilacustomer.org','306','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('302','1','MICHAEL','SILVERMAN','MICHAEL.SILVERMAN@sakilacustomer.org','307','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('303','2','WILLIAM','SATTERFIELD','WILLIAM.SATTERFIELD@sakilacustomer.org','308','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('304','2','DAVID','ROYAL','DAVID.ROYAL@sakilacustomer.org','309','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('305','1','RICHARD','MCCRARY','RICHARD.MCCRARY@sakilacustomer.org','310','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('306','1','CHARLES','KOWALSKI','CHARLES.KOWALSKI@sakilacustomer.org','311','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('307','2','JOSEPH','JOY','JOSEPH.JOY@sakilacustomer.org','312','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('308','1','THOMAS','GRIGSBY','THOMAS.GRIGSBY@sakilacustomer.org','313','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('309','1','CHRISTOPHER','GRECO','CHRISTOPHER.GRECO@sakilacustomer.org','314','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('310','2','DANIEL','CABRAL','DANIEL.CABRAL@sakilacustomer.org','315','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('311','2','PAUL','TROUT','PAUL.TROUT@sakilacustomer.org','316','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('312','2','MARK','RINEHART','MARK.RINEHART@sakilacustomer.org','317','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('313','2','DONALD','MAHON','DONALD.MAHON@sakilacustomer.org','318','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('314','1','GEORGE','LINTON','GEORGE.LINTON@sakilacustomer.org','319','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('315','2','KENNETH','GOODEN','KENNETH.GOODEN@sakilacustomer.org','320','0','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('316','1','STEVEN','CURLEY','STEVEN.CURLEY@sakilacustomer.org','321','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('317','2','EDWARD','BAUGH','EDWARD.BAUGH@sakilacustomer.org','322','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('318','1','BRIAN','WYMAN','BRIAN.WYMAN@sakilacustomer.org','323','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('319','2','RONALD','WEINER','RONALD.WEINER@sakilacustomer.org','324','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('320','2','ANTHONY','SCHWAB','ANTHONY.SCHWAB@sakilacustomer.org','325','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('321','1','KEVIN','SCHULER','KEVIN.SCHULER@sakilacustomer.org','326','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('322','1','JASON','MORRISSEY','JASON.MORRISSEY@sakilacustomer.org','327','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('323','2','MATTHEW','MAHAN','MATTHEW.MAHAN@sakilacustomer.org','328','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('324','2','GARY','COY','GARY.COY@sakilacustomer.org','329','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('325','1','TIMOTHY','BUNN','TIMOTHY.BUNN@sakilacustomer.org','330','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('326','1','JOSE','ANDREW','JOSE.ANDREW@sakilacustomer.org','331','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('327','2','LARRY','THRASHER','LARRY.THRASHER@sakilacustomer.org','332','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('328','2','JEFFREY','SPEAR','JEFFREY.SPEAR@sakilacustomer.org','333','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('329','2','FRANK','WAGGONER','FRANK.WAGGONER@sakilacustomer.org','334','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('330','1','SCOTT','SHELLEY','SCOTT.SHELLEY@sakilacustomer.org','335','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('331','1','ERIC','ROBERT','ERIC.ROBERT@sakilacustomer.org','336','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('332','1','STEPHEN','QUALLS','STEPHEN.QUALLS@sakilacustomer.org','337','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('333','2','ANDREW','PURDY','ANDREW.PURDY@sakilacustomer.org','338','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('334','2','RAYMOND','MCWHORTER','RAYMOND.MCWHORTER@sakilacustomer.org','339','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('335','1','GREGORY','MAULDIN','GREGORY.MAULDIN@sakilacustomer.org','340','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('336','1','JOSHUA','MARK','JOSHUA.MARK@sakilacustomer.org','341','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('337','1','JERRY','JORDON','JERRY.JORDON@sakilacustomer.org','342','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('338','1','DENNIS','GILMAN','DENNIS.GILMAN@sakilacustomer.org','343','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('339','2','WALTER','PERRYMAN','WALTER.PERRYMAN@sakilacustomer.org','344','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('340','1','PATRICK','NEWSOM','PATRICK.NEWSOM@sakilacustomer.org','345','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('341','1','PETER','MENARD','PETER.MENARD@sakilacustomer.org','346','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('342','1','HAROLD','MARTINO','HAROLD.MARTINO@sakilacustomer.org','347','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('343','1','DOUGLAS','GRAF','DOUGLAS.GRAF@sakilacustomer.org','348','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('344','1','HENRY','BILLINGSLEY','HENRY.BILLINGSLEY@sakilacustomer.org','349','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('345','1','CARL','ARTIS','CARL.ARTIS@sakilacustomer.org','350','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('346','1','ARTHUR','SIMPKINS','ARTHUR.SIMPKINS@sakilacustomer.org','351','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('347','2','RYAN','SALISBURY','RYAN.SALISBURY@sakilacustomer.org','352','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('348','2','ROGER','QUINTANILLA','ROGER.QUINTANILLA@sakilacustomer.org','353','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('349','2','JOE','GILLILAND','JOE.GILLILAND@sakilacustomer.org','354','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('350','1','JUAN','FRALEY','JUAN.FRALEY@sakilacustomer.org','355','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('351','1','JACK','FOUST','JACK.FOUST@sakilacustomer.org','356','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('352','1','ALBERT','CROUSE','ALBERT.CROUSE@sakilacustomer.org','357','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('353','1','JONATHAN','SCARBOROUGH','JONATHAN.SCARBOROUGH@sakilacustomer.org','358','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('354','2','JUSTIN','NGO','JUSTIN.NGO@sakilacustomer.org','359','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('355','2','TERRY','GRISSOM','TERRY.GRISSOM@sakilacustomer.org','360','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('356','2','GERALD','FULTZ','GERALD.FULTZ@sakilacustomer.org','361','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('357','1','KEITH','RICO','KEITH.RICO@sakilacustomer.org','362','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('358','2','SAMUEL','MARLOW','SAMUEL.MARLOW@sakilacustomer.org','363','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('359','2','WILLIE','MARKHAM','WILLIE.MARKHAM@sakilacustomer.org','364','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('360','2','RALPH','MADRIGAL','RALPH.MADRIGAL@sakilacustomer.org','365','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('361','2','LAWRENCE','LAWTON','LAWRENCE.LAWTON@sakilacustomer.org','366','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('362','1','NICHOLAS','BARFIELD','NICHOLAS.BARFIELD@sakilacustomer.org','367','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('363','2','ROY','WHITING','ROY.WHITING@sakilacustomer.org','368','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('364','1','BENJAMIN','VARNEY','BENJAMIN.VARNEY@sakilacustomer.org','369','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('365','2','BRUCE','SCHWARZ','BRUCE.SCHWARZ@sakilacustomer.org','370','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('366','1','BRANDON','HUEY','BRANDON.HUEY@sakilacustomer.org','371','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('367','1','ADAM','GOOCH','ADAM.GOOCH@sakilacustomer.org','372','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('368','1','HARRY','ARCE','HARRY.ARCE@sakilacustomer.org','373','0','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('369','2','FRED','WHEAT','FRED.WHEAT@sakilacustomer.org','374','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('370','2','WAYNE','TRUONG','WAYNE.TRUONG@sakilacustomer.org','375','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('371','1','BILLY','POULIN','BILLY.POULIN@sakilacustomer.org','376','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('372','2','STEVE','MACKENZIE','STEVE.MACKENZIE@sakilacustomer.org','377','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('373','1','LOUIS','LEONE','LOUIS.LEONE@sakilacustomer.org','378','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('374','2','JEREMY','HURTADO','JEREMY.HURTADO@sakilacustomer.org','379','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('375','2','AARON','SELBY','AARON.SELBY@sakilacustomer.org','380','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('376','1','RANDY','GAITHER','RANDY.GAITHER@sakilacustomer.org','381','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('377','1','HOWARD','FORTNER','HOWARD.FORTNER@sakilacustomer.org','382','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('378','1','EUGENE','CULPEPPER','EUGENE.CULPEPPER@sakilacustomer.org','383','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('379','1','CARLOS','COUGHLIN','CARLOS.COUGHLIN@sakilacustomer.org','384','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('380','1','RUSSELL','BRINSON','RUSSELL.BRINSON@sakilacustomer.org','385','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('381','2','BOBBY','BOUDREAU','BOBBY.BOUDREAU@sakilacustomer.org','386','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('382','2','VICTOR','BARKLEY','VICTOR.BARKLEY@sakilacustomer.org','387','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('383','1','MARTIN','BALES','MARTIN.BALES@sakilacustomer.org','388','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('384','2','ERNEST','STEPP','ERNEST.STEPP@sakilacustomer.org','389','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('385','1','PHILLIP','HOLM','PHILLIP.HOLM@sakilacustomer.org','390','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('386','1','TODD','TAN','TODD.TAN@sakilacustomer.org','391','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('387','2','JESSE','SCHILLING','JESSE.SCHILLING@sakilacustomer.org','392','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('388','2','CRAIG','MORRELL','CRAIG.MORRELL@sakilacustomer.org','393','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('389','1','ALAN','KAHN','ALAN.KAHN@sakilacustomer.org','394','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('390','1','SHAWN','HEATON','SHAWN.HEATON@sakilacustomer.org','395','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('391','1','CLARENCE','GAMEZ','CLARENCE.GAMEZ@sakilacustomer.org','396','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('392','2','SEAN','DOUGLASS','SEAN.DOUGLASS@sakilacustomer.org','397','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('393','1','PHILIP','CAUSEY','PHILIP.CAUSEY@sakilacustomer.org','398','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('394','2','CHRIS','BROTHERS','CHRIS.BROTHERS@sakilacustomer.org','399','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('395','2','JOHNNY','TURPIN','JOHNNY.TURPIN@sakilacustomer.org','400','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('396','1','EARL','SHANKS','EARL.SHANKS@sakilacustomer.org','401','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('397','1','JIMMY','SCHRADER','JIMMY.SCHRADER@sakilacustomer.org','402','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('398','1','ANTONIO','MEEK','ANTONIO.MEEK@sakilacustomer.org','403','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('399','1','DANNY','ISOM','DANNY.ISOM@sakilacustomer.org','404','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('400','2','BRYAN','HARDISON','BRYAN.HARDISON@sakilacustomer.org','405','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('401','2','TONY','CARRANZA','TONY.CARRANZA@sakilacustomer.org','406','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('402','1','LUIS','YANEZ','LUIS.YANEZ@sakilacustomer.org','407','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('403','1','MIKE','WAY','MIKE.WAY@sakilacustomer.org','408','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('404','2','STANLEY','SCROGGINS','STANLEY.SCROGGINS@sakilacustomer.org','409','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('405','1','LEONARD','SCHOFIELD','LEONARD.SCHOFIELD@sakilacustomer.org','410','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('406','1','NATHAN','RUNYON','NATHAN.RUNYON@sakilacustomer.org','411','0','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('407','1','DALE','RATCLIFF','DALE.RATCLIFF@sakilacustomer.org','412','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('408','1','MANUEL','MURRELL','MANUEL.MURRELL@sakilacustomer.org','413','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('409','2','RODNEY','MOELLER','RODNEY.MOELLER@sakilacustomer.org','414','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('410','2','CURTIS','IRBY','CURTIS.IRBY@sakilacustomer.org','415','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('411','1','NORMAN','CURRIER','NORMAN.CURRIER@sakilacustomer.org','416','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('412','2','ALLEN','BUTTERFIELD','ALLEN.BUTTERFIELD@sakilacustomer.org','417','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('413','2','MARVIN','YEE','MARVIN.YEE@sakilacustomer.org','418','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('414','1','VINCENT','RALSTON','VINCENT.RALSTON@sakilacustomer.org','419','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('415','1','GLENN','PULLEN','GLENN.PULLEN@sakilacustomer.org','420','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('416','2','JEFFERY','PINSON','JEFFERY.PINSON@sakilacustomer.org','421','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('417','1','TRAVIS','ESTEP','TRAVIS.ESTEP@sakilacustomer.org','422','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('418','2','JEFF','EAST','JEFF.EAST@sakilacustomer.org','423','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('419','1','CHAD','CARBONE','CHAD.CARBONE@sakilacustomer.org','424','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('420','1','JACOB','LANCE','JACOB.LANCE@sakilacustomer.org','425','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('421','1','LEE','HAWKS','LEE.HAWKS@sakilacustomer.org','426','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('422','1','MELVIN','ELLINGTON','MELVIN.ELLINGTON@sakilacustomer.org','427','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('423','2','ALFRED','CASILLAS','ALFRED.CASILLAS@sakilacustomer.org','428','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('424','2','KYLE','SPURLOCK','KYLE.SPURLOCK@sakilacustomer.org','429','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('425','2','FRANCIS','SIKES','FRANCIS.SIKES@sakilacustomer.org','430','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('426','1','BRADLEY','MOTLEY','BRADLEY.MOTLEY@sakilacustomer.org','431','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('427','2','JESUS','MCCARTNEY','JESUS.MCCARTNEY@sakilacustomer.org','432','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('428','2','HERBERT','KRUGER','HERBERT.KRUGER@sakilacustomer.org','433','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('429','2','FREDERICK','ISBELL','FREDERICK.ISBELL@sakilacustomer.org','434','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('430','1','RAY','HOULE','RAY.HOULE@sakilacustomer.org','435','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('431','2','JOEL','FRANCISCO','JOEL.FRANCISCO@sakilacustomer.org','436','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('432','1','EDWIN','BURK','EDWIN.BURK@sakilacustomer.org','437','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('433','1','DON','BONE','DON.BONE@sakilacustomer.org','438','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('434','1','EDDIE','TOMLIN','EDDIE.TOMLIN@sakilacustomer.org','439','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('435','2','RICKY','SHELBY','RICKY.SHELBY@sakilacustomer.org','440','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('436','1','TROY','QUIGLEY','TROY.QUIGLEY@sakilacustomer.org','441','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('437','2','RANDALL','NEUMANN','RANDALL.NEUMANN@sakilacustomer.org','442','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('438','1','BARRY','LOVELACE','BARRY.LOVELACE@sakilacustomer.org','443','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('439','2','ALEXANDER','FENNELL','ALEXANDER.FENNELL@sakilacustomer.org','444','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('440','1','BERNARD','COLBY','BERNARD.COLBY@sakilacustomer.org','445','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('441','1','MARIO','CHEATHAM','MARIO.CHEATHAM@sakilacustomer.org','446','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('442','1','LEROY','BUSTAMANTE','LEROY.BUSTAMANTE@sakilacustomer.org','447','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('443','2','FRANCISCO','SKIDMORE','FRANCISCO.SKIDMORE@sakilacustomer.org','448','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('444','2','MARCUS','HIDALGO','MARCUS.HIDALGO@sakilacustomer.org','449','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('445','1','MICHEAL','FORMAN','MICHEAL.FORMAN@sakilacustomer.org','450','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('446','2','THEODORE','CULP','THEODORE.CULP@sakilacustomer.org','451','0','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('447','1','CLIFFORD','BOWENS','CLIFFORD.BOWENS@sakilacustomer.org','452','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('448','1','MIGUEL','BETANCOURT','MIGUEL.BETANCOURT@sakilacustomer.org','453','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('449','2','OSCAR','AQUINO','OSCAR.AQUINO@sakilacustomer.org','454','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('450','1','JAY','ROBB','JAY.ROBB@sakilacustomer.org','455','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('451','1','JIM','REA','JIM.REA@sakilacustomer.org','456','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('452','1','TOM','MILNER','TOM.MILNER@sakilacustomer.org','457','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('453','1','CALVIN','MARTEL','CALVIN.MARTEL@sakilacustomer.org','458','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('454','2','ALEX','GRESHAM','ALEX.GRESHAM@sakilacustomer.org','459','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('455','2','JON','WILES','JON.WILES@sakilacustomer.org','460','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('456','2','RONNIE','RICKETTS','RONNIE.RICKETTS@sakilacustomer.org','461','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('457','2','BILL','GAVIN','BILL.GAVIN@sakilacustomer.org','462','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('458','1','LLOYD','DOWD','LLOYD.DOWD@sakilacustomer.org','463','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('459','1','TOMMY','COLLAZO','TOMMY.COLLAZO@sakilacustomer.org','464','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('460','1','LEON','BOSTIC','LEON.BOSTIC@sakilacustomer.org','465','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('461','1','DEREK','BLAKELY','DEREK.BLAKELY@sakilacustomer.org','466','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('462','2','WARREN','SHERROD','WARREN.SHERROD@sakilacustomer.org','467','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('463','2','DARRELL','POWER','DARRELL.POWER@sakilacustomer.org','468','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('464','1','JEROME','KENYON','JEROME.KENYON@sakilacustomer.org','469','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('465','1','FLOYD','GANDY','FLOYD.GANDY@sakilacustomer.org','470','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('466','1','LEO','EBERT','LEO.EBERT@sakilacustomer.org','471','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('467','2','ALVIN','DELOACH','ALVIN.DELOACH@sakilacustomer.org','472','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('468','1','TIM','CARY','TIM.CARY@sakilacustomer.org','473','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('469','2','WESLEY','BULL','WESLEY.BULL@sakilacustomer.org','474','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('470','1','GORDON','ALLARD','GORDON.ALLARD@sakilacustomer.org','475','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('471','1','DEAN','SAUER','DEAN.SAUER@sakilacustomer.org','476','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('472','1','GREG','ROBINS','GREG.ROBINS@sakilacustomer.org','477','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('473','2','JORGE','OLIVARES','JORGE.OLIVARES@sakilacustomer.org','478','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('474','2','DUSTIN','GILLETTE','DUSTIN.GILLETTE@sakilacustomer.org','479','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('475','2','PEDRO','CHESTNUT','PEDRO.CHESTNUT@sakilacustomer.org','480','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('476','1','DERRICK','BOURQUE','DERRICK.BOURQUE@sakilacustomer.org','481','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('477','1','DAN','PAINE','DAN.PAINE@sakilacustomer.org','482','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('478','1','LEWIS','LYMAN','LEWIS.LYMAN@sakilacustomer.org','483','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('479','1','ZACHARY','HITE','ZACHARY.HITE@sakilacustomer.org','484','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('480','1','COREY','HAUSER','COREY.HAUSER@sakilacustomer.org','485','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('481','1','HERMAN','DEVORE','HERMAN.DEVORE@sakilacustomer.org','486','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('482','1','MAURICE','CRAWLEY','MAURICE.CRAWLEY@sakilacustomer.org','487','0','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('483','2','VERNON','CHAPA','VERNON.CHAPA@sakilacustomer.org','488','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('484','1','ROBERTO','VU','ROBERTO.VU@sakilacustomer.org','489','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('485','1','CLYDE','TOBIAS','CLYDE.TOBIAS@sakilacustomer.org','490','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('486','1','GLEN','TALBERT','GLEN.TALBERT@sakilacustomer.org','491','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('487','2','HECTOR','POINDEXTER','HECTOR.POINDEXTER@sakilacustomer.org','492','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('488','2','SHANE','MILLARD','SHANE.MILLARD@sakilacustomer.org','493','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('489','1','RICARDO','MEADOR','RICARDO.MEADOR@sakilacustomer.org','494','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('490','1','SAM','MCDUFFIE','SAM.MCDUFFIE@sakilacustomer.org','495','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('491','2','RICK','MATTOX','RICK.MATTOX@sakilacustomer.org','496','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('492','2','LESTER','KRAUS','LESTER.KRAUS@sakilacustomer.org','497','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('493','1','BRENT','HARKINS','BRENT.HARKINS@sakilacustomer.org','498','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('494','2','RAMON','CHOATE','RAMON.CHOATE@sakilacustomer.org','499','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('495','2','CHARLIE','BESS','CHARLIE.BESS@sakilacustomer.org','500','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('496','2','TYLER','WREN','TYLER.WREN@sakilacustomer.org','501','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('497','2','GILBERT','SLEDGE','GILBERT.SLEDGE@sakilacustomer.org','502','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('498','1','GENE','SANBORN','GENE.SANBORN@sakilacustomer.org','503','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('499','2','MARC','OUTLAW','MARC.OUTLAW@sakilacustomer.org','504','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('500','1','REGINALD','KINDER','REGINALD.KINDER@sakilacustomer.org','505','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('501','1','RUBEN','GEARY','RUBEN.GEARY@sakilacustomer.org','506','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('502','1','BRETT','CORNWELL','BRETT.CORNWELL@sakilacustomer.org','507','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('503','1','ANGEL','BARCLAY','ANGEL.BARCLAY@sakilacustomer.org','508','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('504','1','NATHANIEL','ADAM','NATHANIEL.ADAM@sakilacustomer.org','509','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('505','1','RAFAEL','ABNEY','RAFAEL.ABNEY@sakilacustomer.org','510','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('506','2','LESLIE','SEWARD','LESLIE.SEWARD@sakilacustomer.org','511','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('507','2','EDGAR','RHOADS','EDGAR.RHOADS@sakilacustomer.org','512','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('508','2','MILTON','HOWLAND','MILTON.HOWLAND@sakilacustomer.org','513','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('509','1','RAUL','FORTIER','RAUL.FORTIER@sakilacustomer.org','514','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('510','2','BEN','EASTER','BEN.EASTER@sakilacustomer.org','515','0','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('511','1','CHESTER','BENNER','CHESTER.BENNER@sakilacustomer.org','516','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('512','1','CECIL','VINES','CECIL.VINES@sakilacustomer.org','517','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('513','2','DUANE','TUBBS','DUANE.TUBBS@sakilacustomer.org','519','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('514','2','FRANKLIN','TROUTMAN','FRANKLIN.TROUTMAN@sakilacustomer.org','520','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('515','1','ANDRE','RAPP','ANDRE.RAPP@sakilacustomer.org','521','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('516','2','ELMER','NOE','ELMER.NOE@sakilacustomer.org','522','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('517','2','BRAD','MCCURDY','BRAD.MCCURDY@sakilacustomer.org','523','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('518','1','GABRIEL','HARDER','GABRIEL.HARDER@sakilacustomer.org','524','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('519','2','RON','DELUCA','RON.DELUCA@sakilacustomer.org','525','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('520','2','MITCHELL','WESTMORELAND','MITCHELL.WESTMORELAND@sakilacustomer.org','526','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('521','2','ROLAND','SOUTH','ROLAND.SOUTH@sakilacustomer.org','527','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('522','2','ARNOLD','HAVENS','ARNOLD.HAVENS@sakilacustomer.org','528','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('523','1','HARVEY','GUAJARDO','HARVEY.GUAJARDO@sakilacustomer.org','529','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('524','1','JARED','ELY','JARED.ELY@sakilacustomer.org','530','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('525','2','ADRIAN','CLARY','ADRIAN.CLARY@sakilacustomer.org','531','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('526','2','KARL','SEAL','KARL.SEAL@sakilacustomer.org','532','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('527','1','CORY','MEEHAN','CORY.MEEHAN@sakilacustomer.org','533','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('528','1','CLAUDE','HERZOG','CLAUDE.HERZOG@sakilacustomer.org','534','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('529','2','ERIK','GUILLEN','ERIK.GUILLEN@sakilacustomer.org','535','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('530','2','DARRYL','ASHCRAFT','DARRYL.ASHCRAFT@sakilacustomer.org','536','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('531','2','JAMIE','WAUGH','JAMIE.WAUGH@sakilacustomer.org','537','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('532','2','NEIL','RENNER','NEIL.RENNER@sakilacustomer.org','538','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('533','1','JESSIE','MILAM','JESSIE.MILAM@sakilacustomer.org','539','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('534','1','CHRISTIAN','JUNG','CHRISTIAN.JUNG@sakilacustomer.org','540','0','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('535','1','JAVIER','ELROD','JAVIER.ELROD@sakilacustomer.org','541','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('536','2','FERNANDO','CHURCHILL','FERNANDO.CHURCHILL@sakilacustomer.org','542','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('537','2','CLINTON','BUFORD','CLINTON.BUFORD@sakilacustomer.org','543','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('538','2','TED','BREAUX','TED.BREAUX@sakilacustomer.org','544','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('539','1','MATHEW','BOLIN','MATHEW.BOLIN@sakilacustomer.org','545','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('540','1','TYRONE','ASHER','TYRONE.ASHER@sakilacustomer.org','546','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('541','2','DARREN','WINDHAM','DARREN.WINDHAM@sakilacustomer.org','547','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('542','2','LONNIE','TIRADO','LONNIE.TIRADO@sakilacustomer.org','548','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('543','1','LANCE','PEMBERTON','LANCE.PEMBERTON@sakilacustomer.org','549','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('544','2','CODY','NOLEN','CODY.NOLEN@sakilacustomer.org','550','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('545','2','JULIO','NOLAND','JULIO.NOLAND@sakilacustomer.org','551','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('546','1','KELLY','KNOTT','KELLY.KNOTT@sakilacustomer.org','552','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('547','1','KURT','EMMONS','KURT.EMMONS@sakilacustomer.org','553','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('548','1','ALLAN','CORNISH','ALLAN.CORNISH@sakilacustomer.org','554','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('549','1','NELSON','CHRISTENSON','NELSON.CHRISTENSON@sakilacustomer.org','555','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('550','2','GUY','BROWNLEE','GUY.BROWNLEE@sakilacustomer.org','556','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('551','2','CLAYTON','BARBEE','CLAYTON.BARBEE@sakilacustomer.org','557','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('552','2','HUGH','WALDROP','HUGH.WALDROP@sakilacustomer.org','558','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('553','1','MAX','PITT','MAX.PITT@sakilacustomer.org','559','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('554','1','DWAYNE','OLVERA','DWAYNE.OLVERA@sakilacustomer.org','560','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('555','1','DWIGHT','LOMBARDI','DWIGHT.LOMBARDI@sakilacustomer.org','561','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('556','2','ARMANDO','GRUBER','ARMANDO.GRUBER@sakilacustomer.org','562','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('557','1','FELIX','GAFFNEY','FELIX.GAFFNEY@sakilacustomer.org','563','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('558','1','JIMMIE','EGGLESTON','JIMMIE.EGGLESTON@sakilacustomer.org','564','0','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('559','2','EVERETT','BANDA','EVERETT.BANDA@sakilacustomer.org','565','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('560','1','JORDAN','ARCHULETA','JORDAN.ARCHULETA@sakilacustomer.org','566','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('561','2','IAN','STILL','IAN.STILL@sakilacustomer.org','567','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('562','1','WALLACE','SLONE','WALLACE.SLONE@sakilacustomer.org','568','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('563','2','KEN','PREWITT','KEN.PREWITT@sakilacustomer.org','569','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('564','2','BOB','PFEIFFER','BOB.PFEIFFER@sakilacustomer.org','570','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('565','2','JAIME','NETTLES','JAIME.NETTLES@sakilacustomer.org','571','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('566','1','CASEY','MENA','CASEY.MENA@sakilacustomer.org','572','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('567','2','ALFREDO','MCADAMS','ALFREDO.MCADAMS@sakilacustomer.org','573','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('568','2','ALBERTO','HENNING','ALBERTO.HENNING@sakilacustomer.org','574','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('569','2','DAVE','GARDINER','DAVE.GARDINER@sakilacustomer.org','575','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('570','2','IVAN','CROMWELL','IVAN.CROMWELL@sakilacustomer.org','576','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('571','2','JOHNNIE','CHISHOLM','JOHNNIE.CHISHOLM@sakilacustomer.org','577','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('572','1','SIDNEY','BURLESON','SIDNEY.BURLESON@sakilacustomer.org','578','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('573','1','BYRON','BOX','BYRON.BOX@sakilacustomer.org','579','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('574','2','JULIAN','VEST','JULIAN.VEST@sakilacustomer.org','580','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('575','2','ISAAC','OGLESBY','ISAAC.OGLESBY@sakilacustomer.org','581','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('576','2','MORRIS','MCCARTER','MORRIS.MCCARTER@sakilacustomer.org','582','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('577','2','CLIFTON','MALCOLM','CLIFTON.MALCOLM@sakilacustomer.org','583','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('578','2','WILLARD','LUMPKIN','WILLARD.LUMPKIN@sakilacustomer.org','584','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('579','2','DARYL','LARUE','DARYL.LARUE@sakilacustomer.org','585','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('580','1','ROSS','GREY','ROSS.GREY@sakilacustomer.org','586','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('581','1','VIRGIL','WOFFORD','VIRGIL.WOFFORD@sakilacustomer.org','587','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('582','2','ANDY','VANHORN','ANDY.VANHORN@sakilacustomer.org','588','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('583','1','MARSHALL','THORN','MARSHALL.THORN@sakilacustomer.org','589','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('584','2','SALVADOR','TEEL','SALVADOR.TEEL@sakilacustomer.org','590','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('585','1','PERRY','SWAFFORD','PERRY.SWAFFORD@sakilacustomer.org','591','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('586','1','KIRK','STCLAIR','KIRK.STCLAIR@sakilacustomer.org','592','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('587','1','SERGIO','STANFIELD','SERGIO.STANFIELD@sakilacustomer.org','593','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('588','1','MARION','OCAMPO','MARION.OCAMPO@sakilacustomer.org','594','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('589','1','TRACY','HERRMANN','TRACY.HERRMANN@sakilacustomer.org','595','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('590','2','SETH','HANNON','SETH.HANNON@sakilacustomer.org','596','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('591','1','KENT','ARSENAULT','KENT.ARSENAULT@sakilacustomer.org','597','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('592','1','TERRANCE','ROUSH','TERRANCE.ROUSH@sakilacustomer.org','598','0','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('593','2','RENE','MCALISTER','RENE.MCALISTER@sakilacustomer.org','599','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('594','1','EDUARDO','HIATT','EDUARDO.HIATT@sakilacustomer.org','600','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('595','1','TERRENCE','GUNDERSON','TERRENCE.GUNDERSON@sakilacustomer.org','601','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('596','1','ENRIQUE','FORSYTHE','ENRIQUE.FORSYTHE@sakilacustomer.org','602','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('597','1','FREDDIE','DUGGAN','FREDDIE.DUGGAN@sakilacustomer.org','603','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('598','1','WADE','DELVALLE','WADE.DELVALLE@sakilacustomer.org','604','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;
Insert into customer
 (customer_id,store_id,first_name,last_name,email,address_id,active,create_date,last_update)
Values
('599','2','AUSTIN','CINTRON','AUSTIN.CINTRON@sakilacustomer.org','605','1','2006-02-14T22:04:37.000','2006-02-15T04:57:20.000')
;

SET IDENTITY_INSERT customer OFF

-- End of Script
--
--
-- Automatically generated by Advanced ETl Processor
-- http://www.etl-tools.com/
-- table country
-- Start of script

SET IDENTITY_INSERT rental ON

Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1','2005-05-24T22:53:30.000','367','130','2005-05-26T22:04:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2','2005-05-24T22:54:33.000','1525','459','2005-05-28T19:40:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3','2005-05-24T23:03:39.000','1711','408','2005-06-01T22:12:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4','2005-05-24T23:04:41.000','2452','333','2005-06-03T01:43:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5','2005-05-24T23:05:21.000','2079','222','2005-06-02T04:33:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6','2005-05-24T23:08:07.000','2792','549','2005-05-27T01:32:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7','2005-05-24T23:11:53.000','3995','269','2005-05-29T20:34:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8','2005-05-24T23:31:46.000','2346','239','2005-05-27T23:33:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9','2005-05-25T00:00:40.000','2580','126','2005-05-28T00:22:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10','2005-05-25T00:02:21.000','1824','399','2005-05-31T22:44:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11','2005-05-25T00:09:02.000','4443','142','2005-06-02T20:56:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12','2005-05-25T00:19:27.000','1584','261','2005-05-30T05:44:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13','2005-05-25T00:22:55.000','2294','334','2005-05-30T04:28:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14','2005-05-25T00:31:15.000','2701','446','2005-05-26T02:56:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15','2005-05-25T00:39:22.000','3049','319','2005-06-03T03:30:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('16','2005-05-25T00:43:11.000','389','316','2005-05-26T04:42:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('17','2005-05-25T01:06:36.000','830','575','2005-05-27T00:43:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('18','2005-05-25T01:10:47.000','3376','19','2005-05-31T06:35:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('19','2005-05-25T01:17:24.000','1941','456','2005-05-31T06:00:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('20','2005-05-25T01:48:41.000','3517','185','2005-05-27T02:20:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('21','2005-05-25T01:59:46.000','146','388','2005-05-26T01:01:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('22','2005-05-25T02:19:23.000','727','509','2005-05-26T04:52:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('23','2005-05-25T02:40:21.000','4441','438','2005-05-29T06:34:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('24','2005-05-25T02:53:02.000','3273','350','2005-05-27T01:15:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('25','2005-05-25T03:21:20.000','3961','37','2005-05-27T21:25:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('26','2005-05-25T03:36:50.000','4371','371','2005-05-31T00:34:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('27','2005-05-25T03:41:50.000','1225','301','2005-05-30T01:13:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('28','2005-05-25T03:42:37.000','4068','232','2005-05-26T09:26:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('29','2005-05-25T03:47:12.000','611','44','2005-05-30T00:31:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('30','2005-05-25T04:01:32.000','3744','430','2005-05-30T03:12:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('31','2005-05-25T04:05:17.000','4482','369','2005-05-30T07:15:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('32','2005-05-25T04:06:21.000','3832','230','2005-05-25T23:55:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('33','2005-05-25T04:18:51.000','1681','272','2005-05-27T03:58:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('34','2005-05-25T04:19:28.000','2613','597','2005-05-29T00:10:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('35','2005-05-25T04:24:36.000','1286','484','2005-05-27T07:02:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('36','2005-05-25T04:36:26.000','1308','88','2005-05-29T00:31:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('37','2005-05-25T04:44:31.000','403','535','2005-05-29T01:03:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('38','2005-05-25T04:47:44.000','2540','302','2005-06-01T00:58:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('39','2005-05-25T04:51:46.000','4466','207','2005-05-31T03:14:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('40','2005-05-25T05:09:04.000','2638','413','2005-05-27T23:12:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('41','2005-05-25T05:12:29.000','1761','174','2005-06-02T00:28:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('42','2005-05-25T05:24:58.000','380','523','2005-05-31T02:47:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('43','2005-05-25T05:39:25.000','2578','532','2005-05-26T06:54:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('44','2005-05-25T05:53:23.000','3098','207','2005-05-29T10:56:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('45','2005-05-25T05:59:39.000','1853','436','2005-06-02T09:56:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('46','2005-05-25T06:04:08.000','3318','7','2005-06-02T08:18:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('47','2005-05-25T06:05:20.000','2211','35','2005-05-30T03:04:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('48','2005-05-25T06:20:46.000','1780','282','2005-06-02T05:42:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('49','2005-05-25T06:39:35.000','2965','498','2005-05-30T10:12:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('50','2005-05-25T06:44:53.000','1983','18','2005-05-28T11:28:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('51','2005-05-25T06:49:10.000','1257','256','2005-05-26T06:42:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('52','2005-05-25T06:51:29.000','4017','507','2005-05-31T01:27:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('53','2005-05-25T07:19:16.000','1255','569','2005-05-27T05:19:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('54','2005-05-25T07:23:25.000','2787','291','2005-06-01T05:05:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('55','2005-05-25T08:26:13.000','1139','131','2005-05-30T10:57:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('56','2005-05-25T08:28:11.000','1352','511','2005-05-26T14:21:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('57','2005-05-25T08:43:32.000','3938','6','2005-05-29T06:42:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('58','2005-05-25T08:53:14.000','3050','323','2005-05-28T14:40:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('59','2005-05-25T08:56:42.000','2884','408','2005-06-01T09:52:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('60','2005-05-25T08:58:25.000','330','470','2005-05-30T14:14:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('61','2005-05-25T09:01:57.000','4210','250','2005-06-02T07:22:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('62','2005-05-25T09:18:52.000','261','419','2005-05-30T10:55:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('63','2005-05-25T09:19:16.000','4008','383','2005-05-27T04:24:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('64','2005-05-25T09:21:29.000','79','368','2005-06-03T11:31:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('65','2005-05-25T09:32:03.000','3552','346','2005-05-29T14:21:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('66','2005-05-25T09:35:12.000','1162','86','2005-05-29T04:16:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('67','2005-05-25T09:41:01.000','239','119','2005-05-27T13:46:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('68','2005-05-25T09:47:31.000','4029','120','2005-05-31T10:20:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('69','2005-05-25T10:10:14.000','3207','305','2005-05-27T14:02:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('70','2005-05-25T10:15:23.000','2168','73','2005-05-27T05:56:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('71','2005-05-25T10:26:39.000','2408','100','2005-05-28T04:59:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('72','2005-05-25T10:52:13.000','2260','48','2005-05-28T05:52:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('73','2005-05-25T11:00:07.000','517','391','2005-06-01T13:56:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('74','2005-05-25T11:09:48.000','1744','265','2005-05-26T12:23:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('75','2005-05-25T11:13:34.000','3393','510','2005-06-03T12:58:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('76','2005-05-25T11:30:37.000','3021','1','2005-06-03T12:00:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('77','2005-05-25T11:31:59.000','1303','451','2005-05-26T16:53:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('78','2005-05-25T11:35:18.000','4067','135','2005-05-31T12:48:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('79','2005-05-25T12:11:07.000','3299','245','2005-06-03T10:54:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('80','2005-05-25T12:12:07.000','2478','314','2005-05-31T17:46:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('81','2005-05-25T12:15:19.000','2610','286','2005-06-02T14:08:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('82','2005-05-25T12:17:46.000','1388','427','2005-06-01T10:48:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('83','2005-05-25T12:30:15.000','466','131','2005-05-27T15:40:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('84','2005-05-25T12:36:30.000','1829','492','2005-05-29T18:33:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('85','2005-05-25T13:05:34.000','470','414','2005-05-29T16:53:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('86','2005-05-25T13:36:12.000','2275','266','2005-05-30T14:53:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('87','2005-05-25T13:52:43.000','1586','331','2005-05-29T11:12:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('88','2005-05-25T14:13:54.000','2221','53','2005-05-29T09:32:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('89','2005-05-25T14:28:29.000','2181','499','2005-05-29T14:33:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('90','2005-05-25T14:31:25.000','2984','25','2005-06-01T10:07:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('91','2005-05-25T14:57:22.000','139','267','2005-06-01T18:32:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('92','2005-05-25T15:38:46.000','775','302','2005-05-31T13:40:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('93','2005-05-25T15:54:16.000','4360','288','2005-06-03T20:18:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('94','2005-05-25T16:03:42.000','1675','197','2005-05-30T14:23:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('95','2005-05-25T16:12:52.000','178','400','2005-06-02T18:55:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('96','2005-05-25T16:32:19.000','3418','49','2005-05-30T10:47:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('97','2005-05-25T16:34:24.000','1283','263','2005-05-28T12:13:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('98','2005-05-25T16:48:24.000','2970','269','2005-05-27T11:29:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('99','2005-05-25T16:50:20.000','535','44','2005-05-28T18:52:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('100','2005-05-25T16:50:28.000','2599','208','2005-06-02T22:11:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('101','2005-05-25T17:17:04.000','617','468','2005-05-31T19:47:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('102','2005-05-25T17:22:10.000','373','343','2005-05-31T19:47:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('103','2005-05-25T17:30:42.000','3343','384','2005-06-03T22:36:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('104','2005-05-25T17:46:33.000','4281','310','2005-05-27T15:20:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('105','2005-05-25T17:54:12.000','794','108','2005-05-30T12:03:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('106','2005-05-25T18:18:19.000','3627','196','2005-06-04T00:01:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('107','2005-05-25T18:28:09.000','2833','317','2005-06-03T22:46:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('108','2005-05-25T18:30:05.000','3289','242','2005-05-30T19:40:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('109','2005-05-25T18:40:20.000','1044','503','2005-05-29T20:39:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('110','2005-05-25T18:43:49.000','4108','19','2005-06-03T18:13:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('111','2005-05-25T18:45:19.000','3725','227','2005-05-28T17:18:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('112','2005-05-25T18:57:24.000','2153','500','2005-06-02T20:44:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('113','2005-05-25T19:07:40.000','2963','93','2005-05-27T22:16:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('114','2005-05-25T19:12:42.000','4502','506','2005-06-01T23:10:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('115','2005-05-25T19:13:25.000','749','455','2005-05-29T20:17:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('116','2005-05-25T19:27:51.000','4453','18','2005-05-26T16:23:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('117','2005-05-25T19:30:46.000','4278','7','2005-05-31T23:59:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('118','2005-05-25T19:31:18.000','872','524','2005-05-31T15:00:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('119','2005-05-25T19:37:02.000','1359','51','2005-05-29T23:51:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('120','2005-05-25T19:37:47.000','37','365','2005-06-01T23:29:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('121','2005-05-25T19:41:29.000','1053','405','2005-05-29T21:31:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('122','2005-05-25T19:46:21.000','2908','273','2005-06-02T19:07:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('123','2005-05-25T20:26:42.000','1795','43','2005-05-26T19:41:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('124','2005-05-25T20:46:11.000','212','246','2005-05-30T00:47:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('125','2005-05-25T20:48:50.000','952','368','2005-06-02T21:39:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('126','2005-05-25T21:07:59.000','2047','439','2005-05-28T18:51:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('127','2005-05-25T21:10:40.000','2026','94','2005-06-02T21:38:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('128','2005-05-25T21:19:53.000','4322','40','2005-05-29T23:34:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('129','2005-05-25T21:20:03.000','4154','23','2005-06-04T01:25:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('130','2005-05-25T21:21:56.000','3990','56','2005-05-30T22:41:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('131','2005-05-25T21:42:46.000','815','325','2005-05-30T23:25:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('132','2005-05-25T21:46:54.000','3367','479','2005-05-31T21:02:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('133','2005-05-25T21:48:30.000','399','237','2005-05-30T00:26:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('134','2005-05-25T21:48:41.000','2272','222','2005-06-02T18:28:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('135','2005-05-25T21:58:58.000','103','304','2005-06-03T17:50:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('136','2005-05-25T22:02:30.000','2296','504','2005-05-31T18:06:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('137','2005-05-25T22:25:18.000','2591','560','2005-06-01T02:30:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('138','2005-05-25T22:48:22.000','4134','586','2005-05-29T20:21:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('139','2005-05-25T23:00:21.000','327','257','2005-05-29T17:12:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('140','2005-05-25T23:34:22.000','655','354','2005-05-27T01:10:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('141','2005-05-25T23:34:53.000','811','89','2005-06-02T01:57:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('142','2005-05-25T23:43:47.000','4407','472','2005-05-29T00:46:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('143','2005-05-25T23:45:52.000','847','297','2005-05-27T21:41:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('144','2005-05-25T23:49:56.000','1689','357','2005-06-01T21:41:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('145','2005-05-25T23:59:03.000','3905','82','2005-05-31T02:56:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('146','2005-05-26T00:07:11.000','1431','433','2005-06-04T00:20:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('147','2005-05-26T00:17:50.000','633','274','2005-05-29T23:21:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('148','2005-05-26T00:25:23.000','4252','142','2005-06-01T19:29:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('149','2005-05-26T00:28:05.000','1084','319','2005-06-02T21:30:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('150','2005-05-26T00:28:39.000','909','429','2005-06-01T02:10:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('151','2005-05-26T00:37:28.000','2942','14','2005-05-30T06:28:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('152','2005-05-26T00:41:10.000','2622','57','2005-06-03T06:05:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('153','2005-05-26T00:47:47.000','3888','348','2005-05-27T21:28:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('154','2005-05-26T00:55:56.000','1354','185','2005-05-29T23:18:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('155','2005-05-26T01:15:05.000','288','551','2005-06-01T00:03:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('156','2005-05-26T01:19:05.000','3193','462','2005-05-27T23:43:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('157','2005-05-26T01:25:21.000','887','344','2005-05-26T21:17:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('158','2005-05-26T01:27:11.000','2395','354','2005-06-03T00:30:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('159','2005-05-26T01:34:28.000','3453','505','2005-05-29T04:00:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('160','2005-05-26T01:46:20.000','1885','290','2005-06-01T05:45:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('161','2005-05-26T01:51:48.000','2941','182','2005-05-27T05:42:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('162','2005-05-26T02:02:05.000','1229','296','2005-05-27T03:38:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('163','2005-05-26T02:26:23.000','2306','104','2005-06-04T06:36:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('164','2005-05-26T02:26:49.000','1070','151','2005-05-28T00:32:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('165','2005-05-26T02:28:36.000','2735','33','2005-06-02T03:21:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('166','2005-05-26T02:49:11.000','3894','322','2005-05-31T01:28:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('167','2005-05-26T02:50:31.000','865','401','2005-05-27T03:07:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('168','2005-05-26T03:07:43.000','2714','469','2005-06-02T02:09:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('169','2005-05-26T03:09:30.000','1758','381','2005-05-27T01:37:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('170','2005-05-26T03:11:12.000','3688','107','2005-06-02T03:53:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('171','2005-05-26T03:14:15.000','4483','400','2005-06-03T00:24:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('172','2005-05-26T03:17:42.000','2873','176','2005-05-29T04:11:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('173','2005-05-26T03:42:10.000','3596','533','2005-05-28T01:37:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('174','2005-05-26T03:44:10.000','3954','552','2005-05-28T07:13:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('175','2005-05-26T03:46:26.000','4346','47','2005-06-03T06:01:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('176','2005-05-26T03:47:39.000','851','250','2005-06-01T02:36:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('177','2005-05-26T04:14:29.000','3545','548','2005-06-01T08:16:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('178','2005-05-26T04:21:46.000','1489','196','2005-06-04T07:09:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('179','2005-05-26T04:26:06.000','2575','19','2005-06-03T10:06:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('180','2005-05-26T04:46:23.000','2752','75','2005-06-01T09:58:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('181','2005-05-26T04:47:06.000','2417','587','2005-05-29T06:34:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('182','2005-05-26T04:49:17.000','4396','237','2005-06-01T05:43:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('183','2005-05-26T05:01:18.000','2877','254','2005-06-01T09:04:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('184','2005-05-26T05:29:49.000','1970','556','2005-05-28T10:10:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('185','2005-05-26T05:30:03.000','2598','125','2005-06-02T09:48:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('186','2005-05-26T05:32:52.000','1799','468','2005-06-03T07:19:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('187','2005-05-26T05:42:37.000','4004','515','2005-06-04T00:38:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('188','2005-05-26T05:47:12.000','3342','243','2005-05-26T23:48:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('189','2005-05-26T06:01:41.000','984','247','2005-05-27T06:11:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('190','2005-05-26T06:11:28.000','3962','533','2005-06-01T09:44:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('191','2005-05-26T06:14:06.000','4365','412','2005-05-28T05:33:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('192','2005-05-26T06:20:37.000','1897','437','2005-06-02T10:57:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('193','2005-05-26T06:41:48.000','3900','270','2005-05-30T06:21:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('194','2005-05-26T06:52:33.000','1337','29','2005-05-30T04:08:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('195','2005-05-26T06:52:36.000','506','564','2005-05-31T02:47:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('196','2005-05-26T06:55:58.000','190','184','2005-05-27T10:54:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('197','2005-05-26T06:59:21.000','4212','546','2005-06-03T05:04:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('198','2005-05-26T07:03:49.000','1789','54','2005-06-04T11:45:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('199','2005-05-26T07:11:58.000','2135','71','2005-05-28T09:06:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('200','2005-05-26T07:12:21.000','3926','321','2005-05-31T12:07:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('201','2005-05-26T07:13:45.000','776','444','2005-06-04T02:02:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('202','2005-05-26T07:27:36.000','674','20','2005-06-02T03:52:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('203','2005-05-26T07:27:57.000','3374','109','2005-06-03T12:52:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('204','2005-05-26T07:30:37.000','1842','528','2005-05-30T08:11:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('205','2005-05-26T07:59:37.000','303','114','2005-05-29T09:43:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('206','2005-05-26T08:01:54.000','1717','345','2005-05-27T06:26:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('207','2005-05-26T08:04:38.000','102','47','2005-05-27T09:32:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('208','2005-05-26T08:10:22.000','3669','274','2005-05-27T03:55:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('209','2005-05-26T08:14:01.000','729','379','2005-05-27T09:00:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('210','2005-05-26T08:14:15.000','1801','391','2005-05-27T12:12:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('211','2005-05-26T08:33:10.000','4005','170','2005-05-28T14:09:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('212','2005-05-26T08:34:41.000','764','59','2005-05-30T12:46:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('213','2005-05-26T08:44:08.000','1505','394','2005-05-31T12:33:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('214','2005-05-26T08:48:49.000','1453','98','2005-05-31T04:06:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('215','2005-05-26T09:02:47.000','679','197','2005-05-28T09:45:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('216','2005-05-26T09:17:43.000','1398','91','2005-06-03T08:21:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('217','2005-05-26T09:24:26.000','4395','121','2005-05-31T03:24:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('218','2005-05-26T09:27:09.000','2291','309','2005-06-04T11:53:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('219','2005-05-26T09:41:45.000','3074','489','2005-05-28T04:40:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('220','2005-05-26T10:06:49.000','1259','542','2005-06-01T07:43:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('221','2005-05-26T10:14:09.000','3578','143','2005-05-29T05:57:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('222','2005-05-26T10:14:38.000','2745','83','2005-05-31T08:36:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('223','2005-05-26T10:15:23.000','3121','460','2005-05-30T11:43:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('224','2005-05-26T10:18:27.000','4285','318','2005-06-04T06:59:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('225','2005-05-26T10:27:50.000','651','467','2005-06-01T07:01:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('226','2005-05-26T10:44:04.000','4181','221','2005-05-31T13:26:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('227','2005-05-26T10:51:46.000','214','301','2005-05-30T07:24:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('228','2005-05-26T10:54:28.000','511','571','2005-06-04T09:39:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('229','2005-05-26T11:19:20.000','1131','312','2005-05-31T11:56:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('230','2005-05-26T11:31:50.000','1085','58','2005-05-30T15:22:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('231','2005-05-26T11:31:59.000','4032','365','2005-05-27T07:27:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('232','2005-05-26T11:38:05.000','2945','256','2005-05-27T08:42:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('233','2005-05-26T11:43:44.000','715','531','2005-05-28T17:28:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('234','2005-05-26T11:47:20.000','1321','566','2005-06-03T10:39:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('235','2005-05-26T11:51:09.000','3537','119','2005-06-04T09:36:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('236','2005-05-26T11:53:49.000','1265','446','2005-05-28T13:55:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('237','2005-05-26T12:15:13.000','241','536','2005-05-29T18:10:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('238','2005-05-26T12:30:22.000','503','211','2005-05-27T06:49:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('239','2005-05-26T12:30:26.000','131','49','2005-06-01T13:26:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('240','2005-05-26T12:40:23.000','3420','103','2005-06-04T07:22:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('241','2005-05-26T12:49:01.000','4438','245','2005-05-28T11:43:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('242','2005-05-26T13:05:08.000','2095','214','2005-06-02T15:26:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('243','2005-05-26T13:06:05.000','1721','543','2005-06-03T17:28:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('244','2005-05-26T13:40:40.000','1041','257','2005-05-31T11:58:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('245','2005-05-26T13:46:59.000','3045','158','2005-05-27T09:58:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('246','2005-05-26T13:57:07.000','2829','240','2005-05-29T10:12:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('247','2005-05-26T14:01:05.000','4095','102','2005-05-28T13:38:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('248','2005-05-26T14:07:58.000','1913','545','2005-05-31T14:03:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('249','2005-05-26T14:19:09.000','2428','472','2005-05-28T17:47:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('250','2005-05-26T14:30:24.000','368','539','2005-05-27T08:50:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('251','2005-05-26T14:35:40.000','4352','204','2005-05-29T17:17:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('252','2005-05-26T14:39:53.000','1203','187','2005-06-02T14:48:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('253','2005-05-26T14:43:14.000','2969','416','2005-05-27T12:21:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('254','2005-05-26T14:43:48.000','1835','390','2005-05-31T09:19:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('255','2005-05-26T14:52:15.000','3264','114','2005-05-27T12:45:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('256','2005-05-26T15:20:58.000','3194','436','2005-05-31T15:58:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('257','2005-05-26T15:27:05.000','2570','373','2005-05-29T16:25:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('258','2005-05-26T15:28:14.000','3534','502','2005-05-30T18:38:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('259','2005-05-26T15:32:46.000','30','482','2005-06-04T15:27:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('260','2005-05-26T15:42:20.000','435','21','2005-05-31T13:21:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('261','2005-05-26T15:44:23.000','1369','414','2005-06-02T09:47:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('262','2005-05-26T15:46:56.000','4261','236','2005-05-28T15:49:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('263','2005-05-26T15:47:40.000','1160','449','2005-05-30T10:07:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('264','2005-05-26T16:00:49.000','2069','251','2005-05-27T10:12:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('265','2005-05-26T16:07:38.000','2276','303','2005-06-01T14:20:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('266','2005-05-26T16:08:05.000','3303','263','2005-05-27T10:55:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('267','2005-05-26T16:16:21.000','1206','417','2005-05-30T16:53:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('268','2005-05-26T16:19:08.000','1714','75','2005-05-27T14:35:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('269','2005-05-26T16:19:46.000','3501','322','2005-05-27T15:59:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('270','2005-05-26T16:20:56.000','207','200','2005-06-03T12:40:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('271','2005-05-26T16:22:01.000','2388','92','2005-06-03T17:30:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('272','2005-05-26T16:27:11.000','971','71','2005-06-03T13:10:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('273','2005-05-26T16:29:36.000','1590','193','2005-05-29T18:49:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('274','2005-05-26T16:48:51.000','656','311','2005-06-03T18:17:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('275','2005-05-26T17:09:53.000','1718','133','2005-06-04T22:35:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('276','2005-05-26T17:16:07.000','1221','58','2005-06-03T12:59:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('277','2005-05-26T17:32:11.000','1409','45','2005-05-28T22:54:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('278','2005-05-26T17:40:58.000','182','214','2005-06-02T16:43:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('279','2005-05-26T18:02:50.000','661','384','2005-06-03T18:48:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('280','2005-05-26T18:36:58.000','1896','167','2005-05-27T23:42:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('281','2005-05-26T18:49:35.000','1208','582','2005-05-27T18:11:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('282','2005-05-26T18:56:26.000','4486','282','2005-06-01T16:32:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('283','2005-05-26T19:05:05.000','3530','242','2005-05-31T19:19:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('284','2005-05-26T19:21:44.000','350','359','2005-06-04T14:18:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('285','2005-05-26T19:41:40.000','2486','162','2005-05-31T16:58:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('286','2005-05-26T19:44:51.000','314','371','2005-06-04T18:00:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('287','2005-05-26T19:44:54.000','3631','17','2005-06-02T01:10:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('288','2005-05-26T19:47:49.000','3546','82','2005-06-03T20:53:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('289','2005-05-26T20:01:09.000','2449','81','2005-05-28T15:09:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('290','2005-05-26T20:08:33.000','2776','429','2005-05-30T00:32:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('291','2005-05-26T20:20:47.000','485','577','2005-06-03T02:06:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('292','2005-05-26T20:22:12.000','4264','515','2005-06-05T00:58:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('293','2005-05-26T20:27:02.000','1828','158','2005-06-03T16:45:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('294','2005-05-26T20:29:57.000','2751','369','2005-05-28T17:20:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('295','2005-05-26T20:33:20.000','4030','65','2005-05-27T18:23:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('296','2005-05-26T20:35:19.000','3878','468','2005-06-04T02:31:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('297','2005-05-26T20:48:48.000','1594','48','2005-05-27T19:52:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('298','2005-05-26T20:52:26.000','1083','460','2005-05-29T22:08:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('299','2005-05-26T20:55:36.000','4376','448','2005-05-28T00:25:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('300','2005-05-26T20:57:00.000','249','47','2005-06-05T01:34:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('301','2005-05-26T21:06:14.000','3448','274','2005-06-01T01:54:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('302','2005-05-26T21:13:46.000','2921','387','2005-06-03T15:49:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('303','2005-05-26T21:16:52.000','1111','596','2005-05-27T23:41:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('304','2005-05-26T21:21:28.000','1701','534','2005-06-02T00:05:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('305','2005-05-26T21:22:07.000','2665','464','2005-06-02T22:33:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('306','2005-05-26T21:31:57.000','2781','547','2005-05-28T19:37:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('307','2005-05-26T21:48:13.000','1097','375','2005-06-04T22:24:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('308','2005-05-26T22:01:39.000','187','277','2005-06-04T20:24:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('309','2005-05-26T22:38:10.000','1946','251','2005-06-02T03:10:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('310','2005-05-26T22:41:07.000','593','409','2005-06-02T04:09:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('311','2005-05-26T22:51:37.000','2830','201','2005-06-01T00:02:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('312','2005-05-26T22:52:19.000','2008','143','2005-06-02T18:14:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('313','2005-05-26T22:56:19.000','4156','594','2005-05-29T01:29:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('314','2005-05-26T23:09:41.000','2851','203','2005-05-28T22:49:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('315','2005-05-26T23:12:55.000','2847','238','2005-05-29T23:33:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('316','2005-05-26T23:22:55.000','3828','249','2005-05-29T23:25:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('317','2005-05-26T23:23:56.000','26','391','2005-06-01T19:56:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('318','2005-05-26T23:37:39.000','2559','60','2005-06-03T04:31:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('319','2005-05-26T23:52:13.000','3024','77','2005-05-30T18:55:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('320','2005-05-27T00:09:24.000','1090','2','2005-05-28T04:30:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('322','2005-05-27T00:47:35.000','4556','496','2005-06-02T00:32:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('323','2005-05-27T00:49:27.000','2362','144','2005-05-30T03:12:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('324','2005-05-27T01:00:04.000','3364','292','2005-05-30T04:27:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('325','2005-05-27T01:09:55.000','2510','449','2005-05-31T07:01:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('326','2005-05-27T01:10:11.000','3979','432','2005-06-04T20:25:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('327','2005-05-27T01:18:57.000','2678','105','2005-06-04T04:06:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('328','2005-05-27T01:29:31.000','2524','451','2005-06-01T02:27:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('329','2005-05-27T01:57:14.000','2659','231','2005-05-31T04:19:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('330','2005-05-27T02:15:30.000','1536','248','2005-06-04T05:09:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('331','2005-05-27T02:22:26.000','1872','67','2005-06-05T00:25:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('332','2005-05-27T02:27:10.000','1529','299','2005-06-03T01:26:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('333','2005-05-27T02:52:21.000','4001','412','2005-06-01T00:55:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('334','2005-05-27T03:03:07.000','3973','194','2005-05-29T03:54:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('335','2005-05-27T03:07:10.000','1411','16','2005-06-05T00:15:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('336','2005-05-27T03:15:23.000','1811','275','2005-05-29T22:43:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('337','2005-05-27T03:22:30.000','751','19','2005-06-02T03:27:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('338','2005-05-27T03:42:52.000','2596','165','2005-06-01T05:23:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('339','2005-05-27T03:47:18.000','2410','516','2005-06-04T05:46:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('340','2005-05-27T03:55:25.000','946','209','2005-06-04T07:57:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('341','2005-05-27T04:01:42.000','4168','56','2005-06-05T08:51:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('342','2005-05-27T04:11:04.000','4019','539','2005-05-29T01:28:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('343','2005-05-27T04:13:41.000','3301','455','2005-05-28T08:34:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('344','2005-05-27T04:30:22.000','2327','236','2005-05-29T10:13:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('345','2005-05-27T04:32:25.000','1396','144','2005-05-31T09:50:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('346','2005-05-27T04:34:41.000','4319','14','2005-06-05T04:24:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('347','2005-05-27T04:40:33.000','1625','378','2005-05-28T09:56:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('348','2005-05-27T04:50:56.000','1825','473','2005-06-01T04:43:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('349','2005-05-27T04:53:11.000','2920','36','2005-05-28T06:33:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('350','2005-05-27T05:01:28.000','2756','9','2005-06-04T05:01:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('351','2005-05-27T05:39:03.000','3371','118','2005-06-01T11:10:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('352','2005-05-27T05:48:19.000','4369','157','2005-05-29T09:05:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('353','2005-05-27T06:03:39.000','3989','503','2005-06-03T04:39:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('354','2005-05-27T06:12:26.000','2058','452','2005-06-01T06:48:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('355','2005-05-27T06:15:33.000','141','446','2005-06-01T02:50:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('356','2005-05-27T06:32:30.000','2868','382','2005-05-30T06:24:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('357','2005-05-27T06:37:15.000','4417','198','2005-05-30T07:04:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('358','2005-05-27T06:43:59.000','1925','102','2005-05-29T11:28:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('359','2005-05-27T06:48:33.000','1156','152','2005-05-29T03:55:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('360','2005-05-27T06:51:14.000','3489','594','2005-06-03T01:58:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('361','2005-05-27T07:03:28.000','6','587','2005-05-31T08:01:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('362','2005-05-27T07:10:25.000','2324','147','2005-06-01T08:34:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('363','2005-05-27T07:14:00.000','4282','345','2005-05-28T12:22:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('364','2005-05-27T07:20:12.000','833','430','2005-05-31T10:44:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('365','2005-05-27T07:31:20.000','2887','167','2005-06-04T04:46:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('366','2005-05-27T07:33:54.000','360','134','2005-06-04T01:55:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('367','2005-05-27T07:37:02.000','3437','439','2005-05-30T05:43:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('368','2005-05-27T07:42:29.000','1247','361','2005-06-04T11:20:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('369','2005-05-27T07:46:49.000','944','508','2005-06-01T06:20:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('370','2005-05-27T07:49:43.000','3347','22','2005-06-05T06:39:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('371','2005-05-27T08:08:18.000','1235','295','2005-06-05T03:05:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('372','2005-05-27T08:13:58.000','4089','510','2005-06-04T03:50:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('373','2005-05-27T08:16:25.000','1649','464','2005-06-01T11:41:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('374','2005-05-27T08:26:30.000','4420','337','2005-06-05T07:13:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('375','2005-05-27T08:49:21.000','1815','306','2005-06-04T14:11:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('376','2005-05-27T08:58:15.000','3197','542','2005-06-02T04:48:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('377','2005-05-27T09:04:05.000','3012','170','2005-06-02T03:36:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('378','2005-05-27T09:23:22.000','2242','53','2005-05-29T15:20:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('379','2005-05-27T09:25:32.000','3462','584','2005-06-02T06:19:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('380','2005-05-27T09:34:39.000','1777','176','2005-06-04T11:45:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('381','2005-05-27T09:43:25.000','2748','371','2005-05-31T12:00:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('382','2005-05-27T10:12:00.000','4358','183','2005-05-31T15:03:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('383','2005-05-27T10:12:20.000','955','298','2005-06-03T10:37:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('384','2005-05-27T10:18:20.000','910','371','2005-06-02T09:21:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('385','2005-05-27T10:23:25.000','1565','213','2005-05-30T15:27:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('386','2005-05-27T10:26:31.000','1288','109','2005-05-30T08:32:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('387','2005-05-27T10:35:27.000','2684','506','2005-06-01T13:37:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('388','2005-05-27T10:37:27.000','434','28','2005-05-30T05:45:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('389','2005-05-27T10:45:41.000','691','500','2005-06-05T06:22:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('390','2005-05-27T11:02:26.000','3759','48','2005-06-02T16:09:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('391','2005-05-27T11:03:55.000','2193','197','2005-06-01T11:59:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('392','2005-05-27T11:14:42.000','263','359','2005-06-01T14:28:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('393','2005-05-27T11:18:25.000','145','251','2005-05-28T07:10:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('394','2005-05-27T11:26:11.000','1890','274','2005-06-03T16:44:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('395','2005-05-27T11:45:49.000','752','575','2005-05-31T13:42:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('396','2005-05-27T11:47:04.000','1020','112','2005-05-29T10:14:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('397','2005-05-27T12:29:02.000','4193','544','2005-05-28T17:36:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('398','2005-05-27T12:44:03.000','1686','422','2005-06-02T08:19:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('399','2005-05-27T12:48:38.000','553','204','2005-05-29T15:27:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('400','2005-05-27T12:51:44.000','258','249','2005-05-31T08:34:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('401','2005-05-27T12:57:55.000','2179','46','2005-05-29T17:55:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('402','2005-05-27T13:17:18.000','461','354','2005-05-30T08:53:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('403','2005-05-27T13:28:52.000','3983','424','2005-05-29T11:47:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('404','2005-05-27T13:31:51.000','1293','168','2005-05-30T16:58:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('405','2005-05-27T13:32:39.000','4090','272','2005-06-05T18:53:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('406','2005-05-27T13:46:46.000','2136','381','2005-05-30T12:43:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('407','2005-05-27T13:57:38.000','1077','44','2005-05-31T18:23:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('408','2005-05-27T13:57:39.000','1438','84','2005-05-28T11:57:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('409','2005-05-27T14:10:58.000','3652','220','2005-06-02T10:40:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('410','2005-05-27T14:11:22.000','4010','506','2005-06-02T20:06:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('411','2005-05-27T14:14:14.000','1434','388','2005-06-03T17:39:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('412','2005-05-27T14:17:23.000','1400','375','2005-05-29T15:07:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('413','2005-05-27T14:45:37.000','3516','307','2005-06-03T11:11:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('414','2005-05-27T14:48:20.000','1019','219','2005-05-31T14:39:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('415','2005-05-27T14:51:45.000','3698','304','2005-05-28T19:07:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('416','2005-05-27T15:02:10.000','2371','222','2005-05-29T10:34:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('417','2005-05-27T15:07:27.000','2253','475','2005-05-29T20:01:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('418','2005-05-27T15:13:17.000','3063','151','2005-06-04T12:05:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('419','2005-05-27T15:15:11.000','2514','77','2005-06-02T11:53:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('420','2005-05-27T15:19:38.000','619','93','2005-06-03T15:07:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('421','2005-05-27T15:30:13.000','2985','246','2005-06-04T13:19:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('422','2005-05-27T15:31:55.000','1152','150','2005-06-01T11:47:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('423','2005-05-27T15:32:57.000','1783','284','2005-06-02T19:03:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('424','2005-05-27T15:34:01.000','2815','35','2005-06-05T09:44:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('425','2005-05-27T15:51:30.000','1518','182','2005-06-03T16:52:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('426','2005-05-27T15:56:57.000','1103','522','2005-06-05T11:45:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('427','2005-05-27T16:10:04.000','1677','288','2005-06-05T13:22:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('428','2005-05-27T16:10:58.000','3349','161','2005-05-31T17:24:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('429','2005-05-27T16:21:26.000','129','498','2005-06-05T20:23:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('430','2005-05-27T16:22:10.000','1920','190','2005-06-05T13:10:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('431','2005-05-27T16:31:05.000','4507','334','2005-06-05T11:29:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('432','2005-05-27T16:40:29.000','1119','46','2005-05-29T16:20:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('433','2005-05-27T16:40:40.000','4364','574','2005-05-30T19:55:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('434','2005-05-27T16:54:27.000','3360','246','2005-06-04T22:26:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('435','2005-05-27T17:17:09.000','3328','3','2005-06-02T11:20:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('436','2005-05-27T17:21:04.000','4317','267','2005-05-30T21:26:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('437','2005-05-27T17:47:22.000','1800','525','2005-06-05T14:22:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('438','2005-05-27T17:52:34.000','4260','249','2005-06-05T22:23:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('439','2005-05-27T17:54:48.000','354','319','2005-06-02T23:01:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('440','2005-05-27T18:00:35.000','4452','314','2005-05-29T16:15:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('441','2005-05-27T18:11:05.000','1578','54','2005-05-30T22:45:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('442','2005-05-27T18:12:13.000','1457','403','2005-05-30T12:30:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('443','2005-05-27T18:35:20.000','2021','547','2005-06-04T18:58:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('444','2005-05-27T18:39:15.000','723','239','2005-06-01T15:56:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('445','2005-05-27T18:42:57.000','1757','293','2005-05-30T22:35:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('446','2005-05-27T18:48:41.000','1955','401','2005-06-03T16:42:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('447','2005-05-27T18:57:02.000','3890','133','2005-06-05T18:38:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('448','2005-05-27T19:03:08.000','2671','247','2005-06-03T20:28:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('449','2005-05-27T19:13:15.000','2469','172','2005-06-04T01:08:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('450','2005-05-27T19:18:54.000','1343','247','2005-06-05T23:52:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('451','2005-05-27T19:27:54.000','205','87','2005-05-29T01:07:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('452','2005-05-27T19:30:33.000','2993','127','2005-05-30T20:53:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('453','2005-05-27T19:31:16.000','4425','529','2005-05-29T23:06:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('454','2005-05-27T19:31:36.000','3499','575','2005-05-30T15:46:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('455','2005-05-27T19:43:29.000','3344','343','2005-06-04T23:40:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('456','2005-05-27T19:50:06.000','1699','92','2005-06-02T22:14:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('457','2005-05-27T19:52:29.000','2368','300','2005-06-02T17:17:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('458','2005-05-27T19:58:36.000','3350','565','2005-06-06T00:51:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('459','2005-05-27T20:00:04.000','597','468','2005-05-29T22:47:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('460','2005-05-27T20:02:03.000','4238','240','2005-05-28T16:14:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('461','2005-05-27T20:08:55.000','2077','447','2005-06-01T14:32:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('462','2005-05-27T20:10:36.000','2314','364','2005-06-03T21:12:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('463','2005-05-27T20:11:47.000','826','21','2005-06-04T21:18:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('464','2005-05-27T20:42:44.000','1313','193','2005-05-30T00:49:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('465','2005-05-27T20:44:36.000','20','261','2005-06-02T02:43:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('466','2005-05-27T20:57:07.000','1786','442','2005-05-29T15:52:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('467','2005-05-27T21:10:03.000','339','557','2005-06-01T16:08:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('468','2005-05-27T21:13:10.000','2656','101','2005-06-04T15:26:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('469','2005-05-27T21:14:26.000','4463','154','2005-06-05T21:51:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('470','2005-05-27T21:17:08.000','1613','504','2005-06-04T17:47:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('471','2005-05-27T21:32:42.000','2872','209','2005-05-31T00:39:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('472','2005-05-27T21:36:15.000','1338','528','2005-05-29T21:07:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('473','2005-05-27T21:36:34.000','802','105','2005-06-05T17:02:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('474','2005-05-27T22:11:56.000','1474','274','2005-05-31T19:07:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('475','2005-05-27T22:16:26.000','2520','159','2005-05-28T19:58:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('476','2005-05-27T22:31:36.000','2451','543','2005-06-03T19:12:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('477','2005-05-27T22:33:33.000','2437','161','2005-06-02T18:35:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('478','2005-05-27T22:38:20.000','424','557','2005-05-31T18:39:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('479','2005-05-27T22:39:10.000','2060','231','2005-06-05T22:46:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('480','2005-05-27T22:47:39.000','2108','220','2005-06-04T21:17:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('481','2005-05-27T22:49:27.000','72','445','2005-05-30T17:46:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('482','2005-05-27T22:53:02.000','4178','546','2005-06-01T22:53:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('483','2005-05-27T23:00:25.000','1510','32','2005-05-28T21:30:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('484','2005-05-27T23:26:45.000','3115','491','2005-05-29T21:16:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('485','2005-05-27T23:40:52.000','2392','105','2005-05-28T22:40:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('486','2005-05-27T23:51:12.000','1822','398','2005-05-28T20:26:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('487','2005-05-28T00:00:30.000','3774','569','2005-05-28T19:18:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('488','2005-05-28T00:07:50.000','393','168','2005-06-03T22:30:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('489','2005-05-28T00:09:12.000','1940','476','2005-05-31T04:44:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('490','2005-05-28T00:09:56.000','3524','95','2005-05-30T22:32:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('491','2005-05-28T00:13:35.000','1326','196','2005-05-29T00:11:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('492','2005-05-28T00:24:58.000','1999','228','2005-05-28T22:34:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('493','2005-05-28T00:34:11.000','184','501','2005-05-30T18:40:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('494','2005-05-28T00:39:31.000','1850','64','2005-06-02T19:35:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('495','2005-05-28T00:40:48.000','1007','526','2005-05-29T06:07:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('496','2005-05-28T00:43:41.000','1785','56','2005-06-04T03:56:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('497','2005-05-28T00:54:39.000','2636','20','2005-06-03T20:47:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('498','2005-05-28T01:01:21.000','458','287','2005-05-30T21:20:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('499','2005-05-28T01:05:07.000','2381','199','2005-06-05T19:54:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('500','2005-05-28T01:05:25.000','4500','145','2005-05-31T20:04:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('501','2005-05-28T01:09:36.000','601','162','2005-05-30T06:14:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('502','2005-05-28T01:34:43.000','3131','179','2005-05-31T01:02:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('503','2005-05-28T01:35:25.000','3005','288','2005-05-28T22:12:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('504','2005-05-28T02:05:34.000','2086','170','2005-05-30T23:03:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('505','2005-05-28T02:06:37.000','71','111','2005-05-29T06:57:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('506','2005-05-28T02:09:19.000','667','469','2005-06-05T20:34:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('507','2005-05-28T02:31:19.000','3621','421','2005-06-02T05:07:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('508','2005-05-28T02:40:50.000','4179','434','2005-06-05T03:05:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('509','2005-05-28T02:51:12.000','3416','147','2005-05-31T06:27:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('510','2005-05-28T02:52:14.000','4338','113','2005-05-30T21:20:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('511','2005-05-28T03:04:04.000','3827','296','2005-06-03T04:58:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('512','2005-05-28T03:07:50.000','2176','231','2005-06-05T02:12:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('513','2005-05-28T03:08:10.000','225','489','2005-05-29T07:22:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('514','2005-05-28T03:09:28.000','1697','597','2005-06-05T00:49:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('515','2005-05-28T03:10:10.000','3369','110','2005-06-04T02:18:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('516','2005-05-28T03:11:47.000','4357','400','2005-06-04T02:19:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('517','2005-05-28T03:17:57.000','234','403','2005-05-29T06:33:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('518','2005-05-28T03:18:02.000','4087','480','2005-05-30T05:32:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('519','2005-05-28T03:22:33.000','3564','245','2005-06-03T05:06:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('520','2005-05-28T03:27:37.000','3845','161','2005-06-04T05:47:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('521','2005-05-28T03:32:22.000','2397','374','2005-05-28T22:37:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('522','2005-05-28T03:33:20.000','3195','382','2005-05-31T04:23:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('523','2005-05-28T03:53:26.000','1905','138','2005-05-31T05:58:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('524','2005-05-28T03:57:28.000','1962','223','2005-05-31T05:20:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('525','2005-05-28T04:25:33.000','1817','14','2005-06-06T04:18:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('526','2005-05-28T04:27:37.000','1387','408','2005-05-30T07:52:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('527','2005-05-28T04:28:38.000','266','169','2005-06-02T08:19:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('528','2005-05-28T04:30:05.000','1655','359','2005-06-03T10:01:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('529','2005-05-28T04:34:17.000','2624','469','2005-05-30T00:35:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('530','2005-05-28T05:13:01.000','3332','312','2005-06-01T10:21:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('531','2005-05-28T05:23:38.000','1113','589','2005-05-29T08:00:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('532','2005-05-28T05:36:58.000','2793','120','2005-06-02T01:50:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('533','2005-05-28T06:14:46.000','4306','528','2005-06-01T06:26:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('534','2005-05-28T06:15:25.000','992','184','2005-06-06T07:51:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('535','2005-05-28T06:16:32.000','4209','307','2005-05-31T02:48:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('536','2005-05-28T06:17:33.000','2962','514','2005-06-03T10:02:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('537','2005-05-28T06:20:55.000','3095','315','2005-06-05T11:48:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('538','2005-05-28T06:21:05.000','2262','110','2005-06-02T01:22:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('539','2005-05-28T06:26:16.000','3427','161','2005-05-30T02:02:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('540','2005-05-28T06:40:25.000','3321','119','2005-06-06T00:47:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('541','2005-05-28T06:41:58.000','1662','535','2005-06-02T09:12:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('542','2005-05-28T06:42:13.000','4444','261','2005-06-03T09:05:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('543','2005-05-28T06:43:34.000','530','493','2005-06-06T07:16:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('544','2005-05-28T07:03:00.000','2964','311','2005-06-06T06:23:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('545','2005-05-28T07:10:20.000','1086','54','2005-06-04T01:47:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('546','2005-05-28T07:16:25.000','487','20','2005-06-01T08:36:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('547','2005-05-28T07:24:28.000','2065','506','2005-06-06T01:31:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('548','2005-05-28T07:34:56.000','3704','450','2005-06-05T03:14:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('549','2005-05-28T07:35:37.000','1818','159','2005-06-02T09:08:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('550','2005-05-28T07:39:16.000','3632','432','2005-06-06T12:20:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('551','2005-05-28T07:44:18.000','3119','315','2005-06-02T12:55:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('552','2005-05-28T07:53:38.000','23','106','2005-06-04T12:45:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('553','2005-05-28T08:14:44.000','1349','176','2005-06-02T03:01:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('554','2005-05-28T08:23:16.000','1951','376','2005-05-31T03:29:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('555','2005-05-28T08:31:14.000','4397','55','2005-05-30T07:34:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('556','2005-05-28T08:31:36.000','1814','22','2005-06-06T07:29:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('557','2005-05-28T08:36:22.000','158','444','2005-06-03T10:42:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('558','2005-05-28T08:38:43.000','4163','442','2005-06-06T13:52:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('559','2005-05-28T08:39:02.000','1227','572','2005-06-05T08:38:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('560','2005-05-28T08:53:02.000','644','463','2005-06-04T12:27:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('561','2005-05-28T08:54:06.000','928','77','2005-06-05T05:54:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('562','2005-05-28T09:01:21.000','3390','102','2005-06-02T05:26:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('563','2005-05-28T09:10:49.000','53','324','2005-06-06T11:32:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('564','2005-05-28T09:12:09.000','2973','282','2005-05-29T05:07:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('565','2005-05-28T09:26:31.000','1494','288','2005-06-01T07:28:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('566','2005-05-28T09:51:39.000','4330','253','2005-06-05T09:35:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('567','2005-05-28T09:56:20.000','3308','184','2005-06-01T06:41:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('568','2005-05-28T09:57:36.000','2232','155','2005-05-31T15:44:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('569','2005-05-28T10:12:41.000','4534','56','2005-06-03T10:08:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('570','2005-05-28T10:15:04.000','1122','21','2005-05-30T08:32:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('571','2005-05-28T10:17:41.000','4250','516','2005-06-05T07:56:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('572','2005-05-28T10:30:13.000','1899','337','2005-06-02T05:04:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('573','2005-05-28T10:35:23.000','4020','1','2005-06-03T06:32:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('574','2005-05-28T10:44:28.000','3883','76','2005-06-04T11:42:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('575','2005-05-28T10:56:09.000','4451','142','2005-06-05T15:39:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('576','2005-05-28T10:56:10.000','1866','588','2005-06-04T13:15:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('577','2005-05-28T11:09:14.000','375','6','2005-06-01T13:27:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('578','2005-05-28T11:15:48.000','2938','173','2005-06-02T09:59:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('579','2005-05-28T11:19:23.000','3481','181','2005-06-02T13:51:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('580','2005-05-28T11:19:53.000','3515','17','2005-06-01T10:44:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('581','2005-05-28T11:20:29.000','1380','186','2005-06-04T12:37:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('582','2005-05-28T11:33:46.000','4579','198','2005-05-29T08:33:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('583','2005-05-28T11:48:55.000','2679','386','2005-06-04T07:09:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('584','2005-05-28T11:49:00.000','1833','69','2005-06-01T11:54:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('585','2005-05-28T11:50:45.000','3544','490','2005-06-03T15:35:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('586','2005-05-28T12:03:00.000','898','77','2005-05-29T13:16:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('587','2005-05-28T12:05:33.000','1413','64','2005-05-30T13:45:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('588','2005-05-28T12:08:37.000','95','89','2005-05-29T16:25:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('589','2005-05-28T12:27:50.000','4231','308','2005-06-03T07:15:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('590','2005-05-28T13:06:50.000','473','462','2005-06-02T09:18:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('591','2005-05-28T13:11:04.000','377','19','2005-05-29T17:20:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('592','2005-05-28T13:21:08.000','638','244','2005-05-29T16:55:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('593','2005-05-28T13:33:23.000','1810','16','2005-05-30T17:10:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('594','2005-05-28T13:41:56.000','2766','538','2005-05-30T12:00:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('595','2005-05-28T13:59:54.000','595','294','2005-06-05T15:16:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('596','2005-05-28T14:00:03.000','821','589','2005-05-29T17:10:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('597','2005-05-28T14:01:02.000','4469','249','2005-06-06T19:06:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('598','2005-05-28T14:04:50.000','599','159','2005-06-03T18:00:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('599','2005-05-28T14:05:57.000','4136','393','2005-06-01T16:41:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('600','2005-05-28T14:08:19.000','1567','332','2005-06-03T11:57:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('601','2005-05-28T14:08:22.000','3225','429','2005-06-04T10:50:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('602','2005-05-28T14:15:54.000','1300','590','2005-06-05T15:16:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('603','2005-05-28T14:27:51.000','3248','537','2005-05-29T13:13:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('604','2005-05-28T14:37:07.000','1585','426','2005-06-03T11:03:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('605','2005-05-28T14:39:10.000','4232','501','2005-06-01T09:28:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('606','2005-05-28T14:48:39.000','3509','299','2005-06-04T09:44:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('607','2005-05-28T15:02:41.000','2561','554','2005-05-30T12:54:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('608','2005-05-28T15:03:44.000','4254','494','2005-06-04T17:14:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('609','2005-05-28T15:04:02.000','2944','150','2005-06-05T14:47:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('610','2005-05-28T15:15:25.000','3642','500','2005-06-02T12:30:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('611','2005-05-28T15:18:18.000','1230','580','2005-05-31T20:15:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('612','2005-05-28T15:24:54.000','2180','161','2005-05-30T14:22:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('613','2005-05-28T15:27:22.000','270','595','2005-06-02T20:01:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('614','2005-05-28T15:33:28.000','280','307','2005-06-04T12:27:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('615','2005-05-28T15:35:52.000','3397','533','2005-06-03T17:35:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('616','2005-05-28T15:45:39.000','989','471','2005-06-02T09:55:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('617','2005-05-28T15:49:14.000','4142','372','2005-05-31T14:29:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('618','2005-05-28T15:50:07.000','4445','248','2005-06-01T19:45:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('619','2005-05-28T15:52:26.000','2482','407','2005-06-06T17:55:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('620','2005-05-28T15:54:45.000','2444','321','2005-06-04T20:26:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('621','2005-05-28T15:58:12.000','1144','239','2005-05-30T21:54:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('622','2005-05-28T15:58:22.000','2363','109','2005-06-04T10:13:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('623','2005-05-28T16:01:28.000','1222','495','2005-05-30T11:19:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('624','2005-05-28T16:13:22.000','3660','569','2005-06-06T20:35:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('625','2005-05-28T16:35:46.000','2889','596','2005-06-01T14:19:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('626','2005-05-28T16:58:09.000','452','584','2005-06-01T14:02:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('627','2005-05-28T17:04:43.000','425','241','2005-06-04T19:58:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('628','2005-05-28T17:05:46.000','2513','173','2005-06-06T16:29:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('629','2005-05-28T17:19:15.000','1527','94','2005-06-02T20:01:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('630','2005-05-28T17:24:51.000','1254','417','2005-06-05T20:05:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('631','2005-05-28T17:36:32.000','2465','503','2005-06-03T14:56:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('632','2005-05-28T17:37:50.000','1287','442','2005-06-03T16:04:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('633','2005-05-28T17:37:59.000','58','360','2005-06-03T22:49:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('634','2005-05-28T17:40:35.000','2630','428','2005-06-05T16:18:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('635','2005-05-28T17:46:57.000','1648','42','2005-06-06T18:24:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('636','2005-05-28T17:47:58.000','4213','239','2005-06-04T16:32:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('637','2005-05-28T18:14:29.000','1581','250','2005-05-29T23:48:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('638','2005-05-28T18:24:43.000','2685','372','2005-06-02T19:03:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('639','2005-05-28T18:25:02.000','4204','198','2005-05-29T18:22:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('640','2005-05-28T18:43:26.000','495','465','2005-05-30T13:39:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('641','2005-05-28T18:45:47.000','3548','396','2005-06-04T15:24:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('642','2005-05-28T18:49:12.000','140','157','2005-06-01T20:50:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('643','2005-05-28T18:52:11.000','3105','240','2005-05-31T15:15:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('644','2005-05-28T18:59:12.000','4304','316','2005-06-04T18:06:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('645','2005-05-28T19:14:09.000','3128','505','2005-06-05T14:01:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('646','2005-05-28T19:16:14.000','1922','185','2005-05-31T16:50:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('647','2005-05-28T19:22:52.000','3435','569','2005-06-01T00:10:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('648','2005-05-28T19:25:54.000','3476','253','2005-06-03T15:57:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('649','2005-05-28T19:35:45.000','1781','197','2005-06-05T16:00:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('650','2005-05-28T19:45:40.000','4384','281','2005-05-29T21:02:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('651','2005-05-28T19:46:50.000','739','266','2005-05-30T16:29:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('652','2005-05-28T20:08:47.000','1201','43','2005-05-29T14:57:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('653','2005-05-28T20:12:20.000','126','327','2005-06-04T14:44:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('654','2005-05-28T20:15:30.000','2312','23','2005-05-30T22:02:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('655','2005-05-28T20:16:20.000','331','287','2005-05-31T16:46:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('656','2005-05-28T20:18:24.000','2846','437','2005-05-30T16:19:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('657','2005-05-28T20:23:09.000','848','65','2005-06-01T02:11:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('658','2005-05-28T20:23:23.000','3226','103','2005-06-06T19:31:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('659','2005-05-28T20:27:53.000','1382','207','2005-05-31T01:36:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('660','2005-05-28T20:53:31.000','1414','578','2005-05-30T15:26:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('661','2005-05-28T21:01:25.000','2247','51','2005-06-02T01:22:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('662','2005-05-28T21:09:31.000','2968','166','2005-06-01T19:00:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('663','2005-05-28T21:23:02.000','3997','176','2005-06-02T17:39:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('664','2005-05-28T21:31:08.000','87','523','2005-06-02T20:56:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('665','2005-05-28T21:38:39.000','1012','415','2005-05-29T21:37:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('666','2005-05-28T21:48:51.000','3075','437','2005-06-05T16:45:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('667','2005-05-28T21:49:02.000','797','596','2005-05-31T03:07:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('668','2005-05-28T21:54:45.000','3528','484','2005-05-29T22:32:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('669','2005-05-28T22:03:25.000','3677','313','2005-06-03T03:39:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('670','2005-05-28T22:04:03.000','227','201','2005-06-06T22:43:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('671','2005-05-28T22:04:30.000','1027','14','2005-06-03T01:21:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('672','2005-05-28T22:05:29.000','697','306','2005-06-06T02:10:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('673','2005-05-28T22:07:30.000','1769','468','2005-06-01T23:42:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('674','2005-05-28T22:11:35.000','1150','87','2005-06-01T23:58:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('675','2005-05-28T22:22:44.000','1273','338','2005-06-01T02:57:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('676','2005-05-28T22:27:51.000','2329','490','2005-05-29T20:36:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('677','2005-05-28T23:00:08.000','4558','194','2005-06-05T19:11:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('678','2005-05-28T23:15:48.000','3741','269','2005-06-03T04:43:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('679','2005-05-28T23:24:57.000','907','526','2005-06-06T21:59:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('680','2005-05-28T23:27:26.000','4147','482','2005-06-02T02:28:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('681','2005-05-28T23:39:44.000','3346','531','2005-06-01T01:42:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('682','2005-05-28T23:53:18.000','3160','148','2005-05-29T19:14:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('683','2005-05-29T00:09:48.000','2038','197','2005-06-02T04:27:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('684','2005-05-29T00:13:15.000','3242','461','2005-06-04T21:26:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('685','2005-05-29T00:17:51.000','1385','172','2005-06-05T05:32:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('686','2005-05-29T00:27:10.000','2441','411','2005-05-30T02:29:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('687','2005-05-29T00:32:09.000','1731','250','2005-05-31T23:53:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('688','2005-05-29T00:45:24.000','4135','162','2005-06-02T01:30:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('689','2005-05-29T00:46:53.000','742','571','2005-06-03T23:48:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('690','2005-05-29T00:54:53.000','2646','85','2005-06-06T00:45:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('691','2005-05-29T01:01:26.000','4034','433','2005-06-07T06:21:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('692','2005-05-29T01:32:10.000','800','18','2005-06-02T03:54:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('693','2005-05-29T01:42:31.000','635','190','2005-06-03T02:29:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('694','2005-05-29T01:49:43.000','592','399','2005-06-05T06:52:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('695','2005-05-29T01:50:53.000','4276','528','2005-06-03T02:28:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('696','2005-05-29T01:59:10.000','2076','19','2005-06-01T02:45:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('697','2005-05-29T02:04:04.000','3949','387','2005-06-04T00:47:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('698','2005-05-29T02:10:52.000','1412','109','2005-06-01T21:52:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('699','2005-05-29T02:11:44.000','130','246','2005-06-04T20:23:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('700','2005-05-29T02:18:54.000','500','117','2005-05-30T05:54:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('701','2005-05-29T02:26:27.000','372','112','2005-06-03T04:59:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('702','2005-05-29T02:27:30.000','2556','475','2005-05-30T01:52:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('703','2005-05-29T02:29:36.000','1123','269','2005-06-03T04:54:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('704','2005-05-29T02:44:43.000','2628','330','2005-06-06T01:51:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('705','2005-05-29T02:48:52.000','2809','257','2005-05-30T06:21:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('706','2005-05-29T03:05:49.000','2278','60','2005-06-04T22:48:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('707','2005-05-29T03:18:19.000','819','252','2005-05-30T02:45:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('708','2005-05-29T03:23:47.000','3133','127','2005-05-31T21:27:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('709','2005-05-29T03:48:01.000','2459','479','2005-06-06T05:21:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('710','2005-05-29T03:48:36.000','194','518','2005-06-03T05:03:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('711','2005-05-29T03:49:03.000','4581','215','2005-05-31T08:29:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('712','2005-05-29T04:02:24.000','4191','313','2005-05-30T03:09:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('713','2005-05-29T04:10:17.000','3664','507','2005-06-07T07:13:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('714','2005-05-29T04:15:21.000','2010','452','2005-06-01T23:05:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('715','2005-05-29T04:22:41.000','2030','545','2005-06-05T09:28:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('716','2005-05-29T04:35:29.000','85','36','2005-06-01T07:42:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('717','2005-05-29T04:37:44.000','1383','412','2005-05-30T05:48:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('718','2005-05-29T04:52:23.000','1736','498','2005-06-02T02:27:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('719','2005-05-29T05:16:05.000','267','245','2005-06-01T07:53:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('720','2005-05-29T05:17:30.000','3687','480','2005-06-06T02:47:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('721','2005-05-29T05:28:47.000','1116','44','2005-05-31T11:24:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('722','2005-05-29T05:30:31.000','4540','259','2005-06-06T04:51:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('723','2005-05-29T05:34:44.000','3407','309','2005-05-30T05:50:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('724','2005-05-29T05:53:23.000','3770','416','2005-06-05T04:01:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('725','2005-05-29T06:03:41.000','4088','245','2005-06-03T08:52:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('726','2005-05-29T06:05:29.000','933','452','2005-06-05T04:40:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('727','2005-05-29T06:08:15.000','1629','484','2005-05-30T07:16:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('728','2005-05-29T06:12:38.000','242','551','2005-06-03T07:41:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('729','2005-05-29T06:35:13.000','1688','323','2005-06-04T03:23:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('730','2005-05-29T07:00:59.000','3473','197','2005-06-06T01:17:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('731','2005-05-29T07:25:16.000','4124','5','2005-05-30T05:21:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('732','2005-05-29T07:32:51.000','2530','447','2005-05-30T10:08:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('733','2005-05-29T07:35:21.000','2951','363','2005-06-05T09:14:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('734','2005-05-29T07:38:52.000','3084','538','2005-06-03T10:17:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('735','2005-05-29T08:08:13.000','3421','454','2005-06-07T13:35:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('736','2005-05-29T08:10:07.000','3689','276','2005-06-05T10:21:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('737','2005-05-29T08:11:31.000','769','589','2005-06-04T11:18:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('738','2005-05-29T08:20:08.000','2284','256','2005-06-06T08:59:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('739','2005-05-29T08:28:18.000','1183','84','2005-06-06T09:21:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('740','2005-05-29T08:30:36.000','600','89','2005-06-04T12:47:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('741','2005-05-29T08:35:49.000','3189','495','2005-06-04T11:55:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('742','2005-05-29T08:36:30.000','273','483','2005-06-05T11:30:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('743','2005-05-29T08:39:02.000','2528','548','2005-06-06T08:42:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('744','2005-05-29T09:13:08.000','3722','420','2005-06-01T07:05:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('745','2005-05-29T09:22:57.000','581','152','2005-06-01T09:10:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('746','2005-05-29T09:25:10.000','4272','130','2005-06-02T04:20:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('747','2005-05-29T09:26:34.000','1993','291','2005-06-05T07:28:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('748','2005-05-29T09:27:00.000','2803','7','2005-06-03T04:25:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('749','2005-05-29T09:33:33.000','1146','375','2005-05-31T11:45:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('750','2005-05-29T09:41:40.000','730','269','2005-05-30T13:31:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('751','2005-05-29T09:55:43.000','2711','53','2005-06-02T04:54:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('752','2005-05-29T10:14:15.000','1720','126','2005-06-04T06:30:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('753','2005-05-29T10:16:42.000','1021','135','2005-06-05T08:52:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('754','2005-05-29T10:18:59.000','734','281','2005-06-04T05:03:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('755','2005-05-29T10:26:29.000','3090','576','2005-06-01T10:25:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('756','2005-05-29T10:28:45.000','3152','201','2005-06-04T12:50:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('757','2005-05-29T10:29:47.000','1067','435','2005-06-07T15:27:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('758','2005-05-29T10:31:56.000','1191','563','2005-06-01T14:53:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('759','2005-05-29T10:57:57.000','2367','179','2005-06-07T16:23:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('760','2005-05-29T11:07:25.000','3250','77','2005-06-02T14:16:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('761','2005-05-29T11:09:01.000','2342','58','2005-06-03T16:18:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('762','2005-05-29T11:15:51.000','3683','146','2005-06-06T07:48:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('763','2005-05-29T11:32:15.000','2022','50','2005-05-31T17:31:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('764','2005-05-29T11:37:35.000','1069','149','2005-05-31T16:47:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('765','2005-05-29T11:38:34.000','515','69','2005-06-02T17:04:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('766','2005-05-29T11:47:02.000','2154','383','2005-06-06T07:14:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('767','2005-05-29T12:20:19.000','687','67','2005-06-02T14:15:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('768','2005-05-29T12:30:46.000','2895','566','2005-06-07T09:00:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('769','2005-05-29T12:51:44.000','1523','575','2005-06-01T17:43:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('770','2005-05-29T12:56:50.000','2491','405','2005-06-07T15:54:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('771','2005-05-29T12:59:14.000','353','476','2005-06-01T16:05:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('772','2005-05-29T13:08:06.000','3319','556','2005-06-06T08:19:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('773','2005-05-29T13:18:05.000','245','563','2005-06-07T17:22:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('774','2005-05-29T13:19:43.000','1188','575','2005-06-01T18:51:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('775','2005-05-29T13:23:26.000','1197','124','2005-05-30T07:53:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('776','2005-05-29T13:35:35.000','4339','113','2005-06-03T17:33:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('777','2005-05-29T14:07:58.000','451','360','2005-06-03T08:41:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('778','2005-05-29T14:09:53.000','1816','535','2005-06-05T20:05:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('779','2005-05-29T14:17:17.000','533','105','2005-06-06T16:46:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('780','2005-05-29T14:18:32.000','1919','300','2005-06-06T20:14:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('781','2005-05-29T14:23:58.000','88','313','2005-05-30T17:44:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('782','2005-05-29T14:38:57.000','2255','596','2005-06-02T13:18:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('783','2005-05-29T14:41:18.000','3046','53','2005-06-06T10:39:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('784','2005-05-29T14:44:22.000','2936','352','2005-06-01T17:28:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('785','2005-05-29T15:08:41.000','39','72','2005-05-30T15:51:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('786','2005-05-29T15:17:28.000','2637','439','2005-06-07T10:07:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('787','2005-05-29T16:03:03.000','3919','27','2005-06-07T11:07:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('788','2005-05-29T16:13:55.000','763','562','2005-05-31T16:40:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('789','2005-05-29T16:17:07.000','708','553','2005-06-06T18:15:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('790','2005-05-29T16:19:29.000','2858','593','2005-06-02T17:22:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('791','2005-05-29T16:30:42.000','1554','284','2005-06-01T19:11:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('792','2005-05-29T16:32:10.000','2841','261','2005-05-31T18:01:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('793','2005-05-29T16:44:08.000','379','528','2005-06-06T19:21:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('794','2005-05-29T16:44:11.000','1995','50','2005-06-05T16:11:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('795','2005-05-29T16:57:39.000','609','551','2005-06-01T11:33:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('796','2005-05-29T16:59:44.000','2697','26','2005-06-03T16:22:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('797','2005-05-29T17:12:17.000','1446','244','2005-06-03T16:06:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('798','2005-05-29T17:23:43.000','1102','134','2005-06-01T13:06:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('799','2005-05-29T17:24:48.000','1713','429','2005-06-05T12:25:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('800','2005-05-29T17:28:12.000','441','472','2005-05-30T14:59:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('801','2005-05-29T17:35:50.000','1642','402','2005-06-04T17:05:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('802','2005-05-29T17:38:59.000','785','350','2005-05-31T22:42:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('803','2005-05-29T17:52:30.000','1602','32','2005-05-30T14:35:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('804','2005-05-29T18:10:24.000','3909','171','2005-06-06T22:53:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('805','2005-05-29T18:18:18.000','3132','232','2005-06-07T15:11:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('806','2005-05-29T18:31:30.000','2386','435','2005-05-31T00:18:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('807','2005-05-29T18:50:50.000','2195','235','2005-06-03T18:36:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('808','2005-05-29T19:08:20.000','1928','104','2005-06-06T20:32:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('809','2005-05-29T19:10:20.000','2114','222','2005-06-05T19:05:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('810','2005-05-29T19:12:04.000','2533','346','2005-06-04T21:12:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('811','2005-05-29T19:30:42.000','4419','401','2005-06-02T16:19:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('812','2005-05-29T20:00:30.000','1099','225','2005-05-30T19:43:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('813','2005-05-29T20:14:34.000','4554','344','2005-06-05T20:56:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('814','2005-05-29T20:16:12.000','1572','134','2005-06-07T17:47:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('815','2005-05-29T20:24:28.000','3757','14','2005-06-03T15:32:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('816','2005-05-29T20:26:39.000','630','474','2005-06-06T22:31:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('817','2005-05-29T20:39:14.000','186','554','2005-05-31T18:24:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('818','2005-05-29T20:47:53.000','4106','321','2005-06-02T23:18:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('819','2005-05-29T21:00:32.000','623','511','2005-06-02T15:15:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('820','2005-05-29T21:07:22.000','2584','22','2005-06-07T00:22:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('821','2005-05-29T21:31:12.000','3380','348','2005-06-04T22:49:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('822','2005-05-29T21:36:00.000','2634','480','2005-06-07T17:24:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('823','2005-05-29T21:39:37.000','3249','441','2005-05-30T22:06:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('824','2005-05-29T21:45:32.000','3518','357','2005-05-31T19:01:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('825','2005-05-29T21:49:41.000','712','371','2005-06-04T20:27:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('826','2005-05-29T21:56:15.000','2263','207','2005-06-08T03:18:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('827','2005-05-29T21:58:43.000','62','573','2005-06-06T00:54:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('828','2005-05-29T22:14:55.000','2468','217','2005-05-30T17:22:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('829','2005-05-29T22:16:42.000','1684','371','2005-06-06T01:38:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('830','2005-05-29T22:43:55.000','3464','3','2005-06-01T17:43:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('831','2005-05-29T22:50:25.000','3912','509','2005-06-06T02:27:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('832','2005-05-29T22:51:20.000','1381','159','2005-06-07T17:37:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('833','2005-05-29T23:21:56.000','2898','417','2005-06-02T18:40:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('834','2005-05-29T23:24:30.000','3628','84','2005-05-30T22:00:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('835','2005-05-29T23:37:00.000','299','381','2005-06-02T23:38:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('836','2005-05-29T23:56:42.000','3140','368','2005-05-31T04:11:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('837','2005-05-30T00:02:08.000','977','172','2005-06-02T05:31:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('838','2005-05-30T00:27:57.000','2859','504','2005-06-06T22:19:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('839','2005-05-30T00:28:12.000','1886','337','2005-06-08T02:43:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('840','2005-05-30T00:28:41.000','4049','79','2005-05-31T20:39:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('841','2005-05-30T00:31:17.000','4318','387','2005-06-02T19:14:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('842','2005-05-30T00:32:04.000','2328','238','2005-06-01T02:21:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('843','2005-05-30T00:44:24.000','2214','313','2005-05-31T00:58:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('844','2005-05-30T00:58:20.000','536','429','2005-06-01T00:38:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('845','2005-05-30T01:17:25.000','2001','72','2005-06-07T02:00:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('846','2005-05-30T01:17:45.000','938','49','2005-06-01T00:56:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('847','2005-05-30T01:18:15.000','4387','380','2005-06-06T20:20:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('848','2005-05-30T01:19:53.000','1363','436','2005-06-05T23:40:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('849','2005-05-30T01:23:07.000','2424','449','2005-06-07T01:50:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('850','2005-05-30T01:35:12.000','2390','517','2005-05-31T01:51:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('851','2005-05-30T01:35:15.000','2780','530','2005-06-06T07:27:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('852','2005-05-30T01:36:57.000','1622','549','2005-06-01T22:44:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('853','2005-05-30T01:43:31.000','3693','122','2005-06-01T02:05:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('854','2005-05-30T01:56:11.000','921','369','2005-06-01T06:34:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('855','2005-05-30T02:00:28.000','2527','406','2005-06-03T20:16:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('856','2005-05-30T02:01:21.000','3969','53','2005-06-07T03:25:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('857','2005-05-30T02:01:23.000','2569','204','2005-06-02T06:07:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('858','2005-05-30T02:10:32.000','1258','358','2005-06-01T04:42:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('859','2005-05-30T02:36:20.000','3032','79','2005-06-02T07:49:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('860','2005-05-30T02:45:16.000','578','276','2005-06-08T07:28:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('861','2005-05-30T02:48:32.000','3711','502','2005-06-06T05:43:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('862','2005-05-30T03:09:11.000','1186','328','2005-06-03T21:27:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('863','2005-05-30T03:14:59.000','3999','379','2005-06-05T04:34:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('864','2005-05-30T03:27:17.000','2777','544','2005-06-06T08:28:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('865','2005-05-30T03:39:44.000','3183','154','2005-06-07T08:10:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('866','2005-05-30T03:43:54.000','2867','8','2005-06-08T04:28:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('867','2005-05-30T03:54:43.000','3389','99','2005-06-01T22:59:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('868','2005-05-30T04:19:55.000','3604','28','2005-05-31T02:28:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('869','2005-05-30T04:22:06.000','3399','296','2005-06-03T09:18:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('870','2005-05-30T04:25:47.000','2903','391','2005-06-06T04:32:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('871','2005-05-30T05:01:30.000','4573','303','2005-06-04T06:22:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('872','2005-05-30T05:03:04.000','3904','548','2005-06-06T10:35:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('873','2005-05-30T05:15:20.000','4568','375','2005-06-07T00:49:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('874','2005-05-30T05:36:21.000','363','52','2005-06-01T09:32:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('875','2005-05-30T05:38:24.000','1428','326','2005-06-06T00:34:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('876','2005-05-30T05:41:22.000','1471','339','2005-06-07T09:06:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('877','2005-05-30T05:48:59.000','886','9','2005-06-02T09:30:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('878','2005-05-30T05:49:13.000','4265','323','2005-06-07T04:35:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('879','2005-05-30T05:49:42.000','4021','482','2005-06-05T01:45:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('880','2005-05-30T06:12:33.000','1819','460','2005-06-02T04:35:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('881','2005-05-30T06:15:36.000','602','242','2005-06-02T10:21:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('882','2005-05-30T06:16:06.000','3841','477','2005-06-02T11:57:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('883','2005-05-30T06:21:05.000','2271','399','2005-06-07T04:50:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('884','2005-05-30T06:41:32.000','4079','17','2005-05-31T07:39:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('885','2005-05-30T06:54:28.000','646','62','2005-06-03T07:03:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('886','2005-05-30T06:54:51.000','4356','393','2005-06-01T06:04:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('887','2005-05-30T07:10:00.000','2727','16','2005-06-01T06:48:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('888','2005-05-30T07:13:14.000','387','128','2005-06-06T09:50:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('889','2005-05-30T07:14:53.000','1299','114','2005-05-31T07:56:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('890','2005-05-30T07:43:04.000','1464','349','2005-06-01T11:26:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('891','2005-05-30T07:43:12.000','2611','391','2005-06-08T09:21:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('892','2005-05-30T08:02:56.000','471','274','2005-06-05T12:51:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('893','2005-05-30T08:06:59.000','3260','502','2005-06-07T08:23:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('894','2005-05-30T08:31:31.000','1118','400','2005-06-07T12:39:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('895','2005-05-30T08:50:43.000','2744','192','2005-06-05T10:58:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('896','2005-05-30T09:03:52.000','2817','207','2005-06-05T07:37:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('897','2005-05-30T09:10:01.000','1334','432','2005-06-08T03:43:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('898','2005-05-30T09:26:19.000','3497','384','2005-06-01T10:45:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('899','2005-05-30T09:29:30.000','1096','156','2005-06-06T12:39:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('900','2005-05-30T09:38:41.000','3543','586','2005-06-07T11:54:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('901','2005-05-30T09:40:40.000','760','259','2005-06-02T10:32:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('902','2005-05-30T09:53:36.000','1514','561','2005-06-07T12:10:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('903','2005-05-30T10:11:29.000','2423','197','2005-06-03T09:33:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('904','2005-05-30T10:19:42.000','2466','44','2005-06-05T04:58:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('905','2005-05-30T10:25:00.000','4372','50','2005-06-06T06:23:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('906','2005-05-30T10:30:38.000','1862','549','2005-06-07T06:44:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('907','2005-05-30T10:37:27.000','3320','506','2005-06-02T09:51:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('908','2005-05-30T10:38:37.000','4427','85','2005-06-03T09:56:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('909','2005-05-30T10:43:38.000','3775','486','2005-06-08T12:07:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('910','2005-05-30T10:46:16.000','2601','374','2005-06-04T13:32:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('911','2005-05-30T10:50:22.000','1404','366','2005-06-07T12:26:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('912','2005-05-30T10:58:33.000','3200','390','2005-05-31T09:31:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('913','2005-05-30T11:04:58.000','3213','369','2005-06-07T13:22:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('914','2005-05-30T11:06:00.000','1393','596','2005-06-04T06:07:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('915','2005-05-30T11:20:27.000','1859','115','2005-06-02T11:55:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('916','2005-05-30T11:25:01.000','1290','6','2005-05-31T09:06:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('917','2005-05-30T11:27:06.000','3629','385','2005-06-02T08:31:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('918','2005-05-30T11:32:24.000','818','197','2005-05-31T07:55:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('919','2005-05-30T11:35:06.000','4052','374','2005-06-02T13:16:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('920','2005-05-30T11:44:01.000','3860','584','2005-06-02T08:19:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('921','2005-05-30T11:53:09.000','1827','508','2005-06-03T10:00:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('922','2005-05-30T11:55:55.000','2442','550','2005-06-08T10:12:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('923','2005-05-30T11:58:50.000','1884','37','2005-06-05T09:57:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('924','2005-05-30T12:10:59.000','3279','293','2005-06-04T17:28:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('925','2005-05-30T12:13:52.000','3203','137','2005-06-02T14:41:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('926','2005-05-30T12:15:54.000','4327','76','2005-06-01T08:53:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('927','2005-05-30T12:16:40.000','1158','167','2005-05-31T16:20:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('928','2005-05-30T12:27:14.000','246','79','2005-06-05T13:56:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('929','2005-05-30T12:32:39.000','4296','536','2005-06-06T12:17:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('930','2005-05-30T12:44:57.000','2835','141','2005-06-04T10:53:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('931','2005-05-30T12:53:01.000','3384','421','2005-05-31T14:28:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('932','2005-05-30T12:55:36.000','719','198','2005-05-31T10:30:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('933','2005-05-30T13:08:45.000','3672','66','2005-06-01T18:56:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('934','2005-05-30T13:24:46.000','3595','60','2005-06-08T16:44:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('935','2005-05-30T13:29:36.000','2421','256','2005-06-02T11:08:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('936','2005-05-30T13:52:49.000','901','469','2005-06-07T16:56:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('937','2005-05-30T14:47:31.000','1054','304','2005-06-05T09:53:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('938','2005-05-30T14:47:31.000','1521','46','2005-06-04T10:10:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('939','2005-05-30T14:49:34.000','1314','367','2005-06-01T19:00:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('940','2005-05-30T15:01:02.000','1278','534','2005-06-01T18:26:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('941','2005-05-30T15:02:25.000','3630','562','2005-06-01T17:19:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('942','2005-05-30T15:05:47.000','4279','473','2005-06-08T15:59:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('943','2005-05-30T15:20:19.000','3737','57','2005-06-06T18:53:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('944','2005-05-30T15:26:24.000','151','131','2005-06-07T18:09:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('945','2005-05-30T15:33:17.000','1441','357','2005-06-02T15:02:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('946','2005-05-30T15:35:08.000','1264','486','2005-06-08T11:38:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('947','2005-05-30T15:36:57.000','4478','62','2005-06-04T18:48:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('948','2005-05-30T15:44:27.000','585','245','2005-06-08T17:30:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('949','2005-05-30T15:50:39.000','2202','368','2005-06-03T14:25:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('950','2005-05-30T16:06:08.000','491','83','2005-06-01T11:43:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('951','2005-05-30T16:10:35.000','1395','59','2005-05-31T19:01:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('952','2005-05-30T16:28:07.000','4389','311','2005-06-02T16:12:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('953','2005-05-30T16:34:02.000','2194','210','2005-05-31T20:34:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('954','2005-05-30T16:57:29.000','1231','297','2005-06-08T13:30:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('955','2005-05-30T16:59:03.000','4140','301','2005-05-31T11:58:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('956','2005-05-30T17:30:28.000','647','296','2005-06-07T13:54:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('957','2005-05-30T17:53:29.000','4428','440','2005-06-03T15:31:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('958','2005-05-30T17:58:03.000','548','186','2005-06-01T19:17:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('959','2005-05-30T18:07:00.000','3108','535','2005-06-02T14:37:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('960','2005-05-30T18:13:23.000','1966','445','2005-06-04T00:12:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('961','2005-05-30T18:16:44.000','3293','588','2005-06-04T23:40:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('962','2005-05-30T18:45:17.000','4535','520','2005-06-05T22:47:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('963','2005-05-30T18:52:53.000','1921','225','2005-06-07T16:19:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('964','2005-05-30T18:53:21.000','657','287','2005-06-04T22:32:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('965','2005-05-30T19:00:14.000','3363','502','2005-05-31T17:10:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('966','2005-05-30T19:00:37.000','1294','496','2005-05-31T23:51:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('967','2005-05-30T19:12:06.000','1954','330','2005-06-09T00:02:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('968','2005-05-30T19:20:03.000','119','576','2005-05-31T18:17:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('969','2005-05-30T19:23:48.000','443','551','2005-05-31T21:14:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('970','2005-05-30T19:50:28.000','1520','307','2005-06-09T01:19:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('971','2005-05-30T20:10:52.000','2911','561','2005-06-06T20:47:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('972','2005-05-30T20:21:07.000','2','411','2005-06-06T00:36:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('973','2005-05-30T20:27:45.000','1914','473','2005-06-08T22:47:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('974','2005-05-30T20:28:42.000','2617','596','2005-06-08T23:45:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('975','2005-05-30T21:07:15.000','3109','7','2005-06-03T01:48:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('976','2005-05-30T21:11:19.000','2290','581','2005-06-06T02:16:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('977','2005-05-30T21:22:26.000','2029','394','2005-06-04T22:32:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('978','2005-05-30T21:30:52.000','407','154','2005-06-07T16:22:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('979','2005-05-30T21:37:11.000','3917','279','2005-06-08T00:24:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('980','2005-05-30T21:45:19.000','4169','273','2005-06-01T20:32:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('981','2005-05-30T21:52:42.000','2913','326','2005-06-01T03:15:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('982','2005-05-30T22:15:24.000','3560','524','2005-06-02T16:18:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('983','2005-05-30T22:15:51.000','63','115','2005-06-02T22:56:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('984','2005-05-30T22:17:17.000','2305','262','2005-06-01T20:15:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('985','2005-05-30T22:18:35.000','1573','564','2005-06-04T23:36:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('986','2005-05-30T22:22:52.000','4045','253','2005-06-01T02:24:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('987','2005-05-30T22:59:12.000','390','11','2005-06-07T20:56:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('988','2005-05-30T23:08:03.000','1364','12','2005-06-07T00:22:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('989','2005-05-30T23:11:51.000','4388','83','2005-06-03T20:36:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('990','2005-05-30T23:25:14.000','4171','311','2005-06-06T18:41:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('991','2005-05-30T23:29:22.000','2863','593','2005-06-07T23:16:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('992','2005-05-30T23:47:56.000','3572','123','2005-06-05T19:01:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('993','2005-05-30T23:54:19.000','2080','513','2005-06-04T21:27:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('994','2005-05-30T23:55:36.000','2798','472','2005-06-04T01:00:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('995','2005-05-31T00:06:02.000','17','150','2005-06-06T02:30:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('996','2005-05-31T00:06:20.000','2075','331','2005-05-31T21:29:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('997','2005-05-31T00:08:25.000','4243','216','2005-06-02T00:17:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('998','2005-05-31T00:16:57.000','3395','389','2005-06-01T22:41:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('999','2005-05-31T00:25:10.000','4433','413','2005-06-03T06:05:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1000','2005-05-31T00:25:56.000','1774','332','2005-06-08T19:42:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1001','2005-05-31T00:46:31.000','1498','64','2005-06-06T06:14:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1002','2005-05-31T00:47:56.000','709','397','2005-06-06T19:51:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1003','2005-05-31T00:48:20.000','133','161','2005-06-02T04:53:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1004','2005-05-31T00:48:36.000','1588','565','2005-06-01T20:56:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1005','2005-05-31T00:53:25.000','4006','551','2005-06-04T01:21:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1006','2005-05-31T00:57:08.000','3461','222','2005-06-02T22:35:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1007','2005-05-31T01:02:28.000','3185','24','2005-06-07T01:36:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1008','2005-05-31T01:18:56.000','914','599','2005-06-01T01:24:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1009','2005-05-31T01:47:35.000','2523','485','2005-06-03T20:26:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1010','2005-05-31T01:57:32.000','4038','49','2005-06-01T06:50:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1011','2005-05-31T02:05:39.000','118','164','2005-06-04T21:27:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1012','2005-05-31T02:18:05.000','688','291','2005-06-03T06:47:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1013','2005-05-31T02:37:00.000','4522','384','2005-06-02T06:39:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1014','2005-05-31T02:39:16.000','766','280','2005-06-01T06:03:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1015','2005-05-31T02:44:57.000','3702','526','2005-06-07T23:01:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1016','2005-05-31T02:49:43.000','3423','204','2005-06-04T03:48:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1017','2005-05-31T02:53:36.000','1242','16','2005-06-03T05:04:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1018','2005-05-31T02:53:42.000','1930','594','2005-06-03T00:47:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1019','2005-05-31T03:05:07.000','3975','279','2005-06-03T08:34:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1020','2005-05-31T03:06:08.000','3402','138','2005-06-02T08:57:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1021','2005-05-31T03:16:15.000','2724','541','2005-06-08T06:43:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1022','2005-05-31T03:16:45.000','842','239','2005-06-08T09:04:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1023','2005-05-31T03:26:50.000','2483','227','2005-06-05T08:19:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1024','2005-05-31T03:30:19.000','2310','457','2005-06-09T05:52:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1025','2005-05-31T03:41:37.000','1618','93','2005-06-08T07:05:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1026','2005-05-31T03:45:26.000','632','107','2005-06-06T22:30:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1027','2005-05-31T03:46:19.000','2718','55','2005-06-09T03:50:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1028','2005-05-31T03:48:05.000','4479','51','2005-06-01T03:51:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1029','2005-05-31T03:52:02.000','2082','50','2005-06-06T08:10:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1030','2005-05-31T04:06:47.000','3948','267','2005-06-02T02:59:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1031','2005-05-31T04:23:01.000','917','416','2005-06-06T08:35:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1032','2005-05-31T04:28:43.000','2937','236','2005-06-02T02:00:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1033','2005-05-31T04:50:07.000','14','25','2005-06-02T01:53:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1034','2005-05-31T04:53:40.000','4117','293','2005-06-09T08:25:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1035','2005-05-31T05:01:09.000','949','362','2005-06-02T03:59:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1036','2005-05-31T05:21:10.000','2164','438','2005-06-04T04:19:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1037','2005-05-31T05:22:25.000','810','569','2005-06-09T04:52:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1038','2005-05-31T05:23:47.000','1253','385','2005-06-02T03:57:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1039','2005-05-31T05:32:29.000','2479','124','2005-06-01T06:04:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1040','2005-05-31T05:35:16.000','2546','270','2005-06-09T04:14:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1041','2005-05-31T05:46:23.000','4432','272','2005-06-06T09:50:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1042','2005-05-31T05:53:00.000','3155','506','2005-06-01T05:24:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1043','2005-05-31T06:11:40.000','2322','412','2005-06-08T09:15:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1044','2005-05-31T06:24:44.000','2574','70','2005-06-03T04:51:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1045','2005-05-31T06:29:01.000','3470','594','2005-06-09T04:31:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1046','2005-05-31T06:42:30.000','468','179','2005-06-03T04:33:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1047','2005-05-31T06:45:57.000','1366','72','2005-06-04T09:49:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1048','2005-05-31T06:49:53.000','2811','55','2005-06-02T11:33:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1049','2005-05-31T06:57:04.000','3913','312','2005-06-02T11:32:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1050','2005-05-31T07:01:27.000','726','303','2005-06-03T07:50:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1051','2005-05-31T07:02:09.000','1025','246','2005-06-03T01:32:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1052','2005-05-31T07:07:03.000','2157','156','2005-06-05T09:38:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1053','2005-05-31T07:12:44.000','3734','196','2005-06-04T12:33:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1054','2005-05-31T07:33:25.000','1575','126','2005-06-02T01:40:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1055','2005-05-31T07:47:18.000','1639','108','2005-06-03T01:57:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1056','2005-05-31T07:48:07.000','1591','519','2005-06-05T08:51:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1057','2005-05-31T07:58:06.000','497','124','2005-06-06T03:21:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1058','2005-05-31T08:04:17.000','40','116','2005-06-03T11:12:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1059','2005-05-31T08:20:43.000','3041','241','2005-06-04T09:05:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1060','2005-05-31T08:21:43.000','2676','570','2005-06-09T04:02:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1061','2005-05-31T08:27:58.000','965','109','2005-06-07T02:34:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1062','2005-05-31T08:38:20.000','2223','176','2005-06-09T08:23:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1063','2005-05-31T08:44:29.000','2484','7','2005-06-09T08:00:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1064','2005-05-31T08:50:07.000','2373','460','2005-06-02T14:47:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1065','2005-05-31T08:54:56.000','3379','316','2005-06-08T09:21:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1066','2005-05-31T09:07:33.000','2383','541','2005-06-09T05:34:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1067','2005-05-31T09:12:13.000','2345','32','2005-06-01T06:15:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1068','2005-05-31T09:32:15.000','150','443','2005-06-01T11:20:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1069','2005-05-31T09:32:31.000','3057','251','2005-06-08T10:19:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1070','2005-05-31T09:39:56.000','3170','228','2005-06-05T10:23:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1071','2005-05-31T09:48:56.000','469','174','2005-06-02T03:52:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1072','2005-05-31T09:52:50.000','2557','272','2005-06-05T05:39:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1073','2005-05-31T09:55:04.000','522','146','2005-06-07T03:55:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1074','2005-05-31T10:04:42.000','2508','503','2005-06-02T15:27:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1075','2005-05-31T10:13:34.000','2279','9','2005-06-09T08:11:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1076','2005-05-31T10:14:31.000','2551','214','2005-06-05T10:13:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1077','2005-05-31T10:22:54.000','1986','24','2005-06-02T12:21:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1078','2005-05-31T10:28:33.000','3682','230','2005-06-03T14:45:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1079','2005-05-31T10:48:17.000','268','312','2005-06-08T12:30:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1080','2005-05-31T10:55:26.000','3491','215','2005-06-03T13:13:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1081','2005-05-31T10:56:32.000','4524','404','2005-06-06T11:31:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1082','2005-05-31T11:02:01.000','4510','239','2005-06-05T08:43:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1083','2005-05-31T11:04:48.000','2393','556','2005-06-05T13:32:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1084','2005-05-31T11:10:17.000','4577','12','2005-06-01T11:15:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1085','2005-05-31T11:15:43.000','301','5','2005-06-07T12:02:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1086','2005-05-31T11:17:37.000','2909','549','2005-06-06T13:58:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1087','2005-05-31T11:18:08.000','431','169','2005-06-04T08:33:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1088','2005-05-31T11:35:13.000','3988','356','2005-06-06T16:01:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1089','2005-05-31T11:38:29.000','3784','367','2005-06-02T08:06:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1090','2005-05-31T12:03:44.000','3329','23','2005-06-02T15:54:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1091','2005-05-31T12:11:04.000','3853','251','2005-06-04T11:42:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1092','2005-05-31T12:15:57.000','4412','278','2005-06-03T15:39:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1093','2005-05-31T12:32:26.000','2189','214','2005-06-03T07:51:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1094','2005-05-31T13:03:49.000','3810','547','2005-06-05T14:30:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1095','2005-05-31T13:15:41.000','4546','252','2005-06-05T12:10:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1096','2005-05-31T13:30:49.000','1066','271','2005-06-09T13:53:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1097','2005-05-31T13:38:42.000','2285','491','2005-06-01T13:54:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1098','2005-05-31T13:51:48.000','1050','425','2005-06-09T18:42:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1099','2005-05-31T13:54:48.000','924','269','2005-06-05T13:04:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1100','2005-05-31T14:03:21.000','316','497','2005-06-06T16:08:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1101','2005-05-31T14:13:59.000','1174','260','2005-06-07T15:49:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1102','2005-05-31T14:20:29.000','2052','115','2005-06-04T17:38:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1103','2005-05-31T14:24:18.000','3154','353','2005-06-09T10:27:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1104','2005-05-31T14:30:01.000','1619','466','2005-06-05T12:07:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1105','2005-05-31T14:33:56.000','1708','26','2005-06-07T11:30:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1106','2005-05-31T14:36:52.000','4185','109','2005-06-01T14:33:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1107','2005-05-31T15:04:05.000','3449','53','2005-06-07T16:42:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1108','2005-05-31T15:05:12.000','2562','254','2005-06-09T19:48:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1109','2005-05-31T15:12:15.000','2031','481','2005-06-09T16:21:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1110','2005-05-31T15:22:51.000','2085','355','2005-06-07T14:32:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1111','2005-05-31T15:24:19.000','1137','300','2005-06-08T21:18:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1112','2005-05-31T15:51:39.000','2453','214','2005-06-03T14:04:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1113','2005-05-31T15:58:44.000','2078','451','2005-06-05T18:05:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1114','2005-05-31T16:00:33.000','2287','117','2005-06-01T19:05:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1115','2005-05-31T16:07:09.000','2140','109','2005-06-04T18:51:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1116','2005-05-31T16:10:46.000','1356','256','2005-06-01T20:27:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1117','2005-05-31T16:15:31.000','4125','189','2005-06-04T17:20:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1118','2005-05-31T16:23:02.000','213','510','2005-06-03T20:00:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1119','2005-05-31T16:34:27.000','4401','469','2005-06-02T10:54:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1120','2005-05-31T16:37:14.000','2897','361','2005-06-04T12:53:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1121','2005-05-31T16:37:36.000','1691','74','2005-06-06T21:02:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1122','2005-05-31T16:39:33.000','1392','180','2005-06-04T17:25:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1123','2005-05-31T16:48:43.000','142','448','2005-06-02T19:17:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1124','2005-05-31T16:49:34.000','4560','134','2005-06-04T19:32:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1125','2005-05-31T17:23:44.000','1172','234','2005-06-01T15:02:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1126','2005-05-31T17:27:45.000','2765','431','2005-06-04T20:06:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1127','2005-05-31T17:45:49.000','2412','387','2005-06-08T22:41:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1128','2005-05-31T17:49:26.000','1496','311','2005-06-05T19:51:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1129','2005-05-31T18:00:48.000','386','486','2005-06-04T23:05:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1130','2005-05-31T18:13:57.000','3186','124','2005-06-06T22:50:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1131','2005-05-31T18:44:19.000','2654','128','2005-06-01T20:13:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1132','2005-05-31T18:44:53.000','1763','198','2005-06-07T22:02:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1133','2005-05-31T19:12:21.000','4271','73','2005-06-02T20:12:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1134','2005-05-31T19:14:15.000','143','191','2005-06-02T17:13:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1135','2005-05-31T19:15:11.000','3118','122','2005-06-01T14:44:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1136','2005-05-31T19:19:36.000','3963','50','2005-06-09T16:04:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1137','2005-05-31T19:20:14.000','3259','351','2005-06-07T16:10:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1138','2005-05-31T19:30:27.000','3944','438','2005-06-05T21:42:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1139','2005-05-31T19:34:52.000','666','562','2005-06-06T17:40:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1140','2005-05-31T19:36:30.000','3731','10','2005-06-07T18:33:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1141','2005-05-31T19:42:02.000','4128','217','2005-06-07T00:59:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1142','2005-05-31T19:46:38.000','3998','5','2005-06-05T14:03:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1143','2005-05-31T19:53:03.000','2632','209','2005-06-06T20:56:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1144','2005-05-31T20:04:10.000','2450','207','2005-06-09T16:34:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1145','2005-05-31T20:13:45.000','1133','284','2005-06-08T02:10:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1146','2005-05-31T20:34:45.000','3134','250','2005-06-03T18:12:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1147','2005-05-31T20:37:52.000','622','259','2005-06-06T19:23:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1148','2005-05-31T20:38:40.000','3307','235','2005-06-02T18:35:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1149','2005-05-31T21:03:17.000','352','326','2005-06-08T19:58:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1150','2005-05-31T21:20:09.000','1632','136','2005-06-03T19:15:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1151','2005-05-31T21:29:00.000','1281','581','2005-06-03T23:24:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1152','2005-05-31T21:32:17.000','210','191','2005-06-04T21:07:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1153','2005-05-31T21:36:44.000','2725','506','2005-06-10T01:26:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1154','2005-05-31T21:42:09.000','2732','59','2005-06-08T16:40:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1155','2005-05-31T22:17:11.000','2048','251','2005-06-04T20:27:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1156','2005-05-31T22:37:34.000','460','106','2005-06-01T23:02:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1157','2005-05-31T22:47:45.000','1449','61','2005-06-02T18:01:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1158','2005-06-14T22:53:33.000','1632','416','2005-06-18T21:37:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1159','2005-06-14T22:55:13.000','4395','516','2005-06-17T02:11:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1160','2005-06-14T23:00:34.000','2795','239','2005-06-18T01:58:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1161','2005-06-14T23:07:08.000','1690','285','2005-06-21T17:12:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1162','2005-06-14T23:09:38.000','987','310','2005-06-23T22:00:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1163','2005-06-14T23:12:46.000','4209','592','2005-06-23T21:53:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1164','2005-06-14T23:16:26.000','3691','49','2005-06-16T21:00:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1165','2005-06-14T23:16:27.000','2855','264','2005-06-20T02:40:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1166','2005-06-14T23:17:03.000','2508','46','2005-06-15T20:43:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1167','2005-06-14T23:25:58.000','4021','323','2005-06-18T05:18:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1168','2005-06-14T23:35:09.000','4368','481','2005-06-19T03:20:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1169','2005-06-14T23:42:56.000','1062','139','2005-06-16T04:02:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1170','2005-06-14T23:47:35.000','2444','595','2005-06-17T05:28:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1171','2005-06-14T23:50:11.000','4082','284','2005-06-17T21:44:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1172','2005-06-14T23:54:34.000','2685','306','2005-06-16T02:26:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1173','2005-06-14T23:54:46.000','1050','191','2005-06-19T23:26:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1174','2005-06-15T00:12:51.000','2653','95','2005-06-21T02:10:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1175','2005-06-15T00:15:15.000','3255','197','2005-06-20T19:23:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1176','2005-06-15T00:28:37.000','2715','512','2005-06-21T21:42:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1177','2005-06-15T00:33:04.000','1897','210','2005-06-16T03:47:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1178','2005-06-15T00:36:40.000','2553','279','2005-06-21T00:27:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1179','2005-06-15T00:36:50.000','816','119','2005-06-22T22:09:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1180','2005-06-15T00:39:01.000','3119','432','2005-06-21T22:44:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1181','2005-06-15T00:42:17.000','2973','546','2005-06-19T03:36:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1182','2005-06-15T00:45:21.000','1061','196','2005-06-22T03:52:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1183','2005-06-15T00:49:19.000','706','329','2005-06-20T04:33:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1184','2005-06-15T00:49:36.000','473','295','2005-06-22T23:39:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1185','2005-06-15T00:54:12.000','2785','1','2005-06-23T02:42:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1186','2005-06-15T00:56:45.000','1556','368','2005-06-16T02:23:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1187','2005-06-15T00:58:50.000','1108','334','2005-06-23T02:19:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1188','2005-06-15T01:04:07.000','246','173','2005-06-19T03:48:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1189','2005-06-15T01:04:22.000','142','244','2005-06-24T06:48:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1190','2005-06-15T01:05:32.000','2572','370','2005-06-23T02:34:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1191','2005-06-15T01:10:35.000','2221','291','2005-06-17T20:36:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1192','2005-06-15T01:18:39.000','4134','186','2005-06-19T22:46:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1193','2005-06-15T01:24:20.000','4504','561','2005-06-21T02:29:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1194','2005-06-15T01:25:08.000','3774','402','2005-06-21T01:16:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1195','2005-06-15T01:37:38.000','2272','84','2005-06-17T21:50:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1196','2005-06-15T01:38:31.000','994','52','2005-06-18T06:55:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1197','2005-06-15T01:42:46.000','3812','349','2005-06-20T00:22:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1198','2005-06-15T01:48:58.000','1138','491','2005-06-20T01:07:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1199','2005-06-15T01:58:50.000','253','238','2005-06-16T20:30:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1200','2005-06-15T01:59:51.000','3329','516','2005-06-21T21:33:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1201','2005-06-15T02:06:28.000','2679','209','2005-06-16T21:38:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1202','2005-06-15T02:08:04.000','2821','451','2005-06-16T21:56:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1203','2005-06-15T02:09:02.000','2223','452','2005-06-21T00:04:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1204','2005-06-15T02:21:46.000','2450','249','2005-06-20T07:14:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1205','2005-06-15T02:25:56.000','470','340','2005-06-22T23:19:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1206','2005-06-15T02:27:07.000','1097','264','2005-06-18T22:46:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1207','2005-06-15T02:27:08.000','2277','430','2005-06-19T08:18:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1208','2005-06-15T02:30:03.000','750','376','2005-06-18T00:04:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1209','2005-06-15T02:31:12.000','1494','146','2005-06-21T07:39:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1210','2005-06-15T02:57:51.000','7','345','2005-06-20T01:41:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1211','2005-06-15T03:01:20.000','3360','122','2005-06-18T07:52:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1212','2005-06-15T03:03:33.000','3611','371','2005-06-17T06:31:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1213','2005-06-15T03:14:05.000','3191','94','2005-06-15T21:41:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1214','2005-06-15T03:18:40.000','4482','46','2005-06-20T07:32:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1215','2005-06-15T03:21:00.000','242','102','2005-06-19T03:39:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1216','2005-06-15T03:23:48.000','3973','100','2005-06-18T03:35:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1217','2005-06-15T03:24:14.000','600','203','2005-06-18T22:37:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1218','2005-06-15T03:24:44.000','239','371','2005-06-21T22:45:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1219','2005-06-15T03:25:59.000','3005','330','2005-06-20T00:37:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1220','2005-06-15T03:26:15.000','1621','290','2005-06-23T08:17:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1221','2005-06-15T03:35:16.000','2124','403','2005-06-18T03:11:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1222','2005-06-15T03:38:49.000','2799','168','2005-06-17T22:30:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1223','2005-06-15T03:38:53.000','1299','50','2005-06-20T01:00:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1224','2005-06-15T03:44:25.000','1572','369','2005-06-17T03:49:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1225','2005-06-15T03:45:35.000','1929','434','2005-06-19T02:03:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1226','2005-06-15T03:46:10.000','2290','409','2005-06-23T02:00:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1227','2005-06-15T03:50:03.000','654','428','2005-06-21T23:48:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1228','2005-06-15T03:50:36.000','4473','398','2005-06-17T22:41:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1229','2005-06-15T03:53:13.000','2140','468','2005-06-18T04:09:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1230','2005-06-15T04:04:09.000','2324','447','2005-06-16T02:21:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1231','2005-06-15T04:04:41.000','3003','302','2005-06-20T23:52:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1232','2005-06-15T04:18:10.000','2743','391','2005-06-17T06:02:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1233','2005-06-15T04:18:37.000','4214','550','2005-06-22T03:36:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1234','2005-06-15T04:21:52.000','709','529','2005-06-22T03:25:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1235','2005-06-15T04:31:28.000','1000','255','2005-06-22T10:08:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1236','2005-06-15T04:34:27.000','3182','66','2005-06-18T08:15:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1237','2005-06-15T04:44:10.000','3249','49','2005-06-23T07:00:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1238','2005-06-15T04:49:08.000','3534','205','2005-06-20T00:06:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1239','2005-06-15T04:53:01.000','3731','444','2005-06-16T07:03:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1240','2005-06-15T04:58:07.000','3841','28','2005-06-17T23:56:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1241','2005-06-15T04:59:43.000','4377','62','2005-06-24T03:32:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1242','2005-06-15T05:05:07.000','821','141','2005-06-22T04:57:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1243','2005-06-15T05:07:32.000','2629','107','2005-06-21T08:17:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1244','2005-06-15T05:08:40.000','1026','515','2005-06-20T10:41:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1245','2005-06-15T05:09:01.000','1314','234','2005-06-22T06:55:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1246','2005-06-15T05:11:19.000','431','357','2005-06-21T02:21:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1247','2005-06-15T05:16:40.000','4049','287','2005-06-23T11:01:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1248','2005-06-15T05:33:52.000','3878','544','2005-06-19T06:56:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1249','2005-06-15T05:38:09.000','2120','403','2005-06-22T10:29:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1250','2005-06-15T05:55:40.000','4360','38','2005-06-23T03:11:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1251','2005-06-15T05:58:55.000','3307','442','2005-06-23T02:45:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1252','2005-06-15T06:05:18.000','1147','89','2005-06-24T07:40:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1253','2005-06-15T06:06:33.000','3242','498','2005-06-21T04:13:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1254','2005-06-15T06:11:16.000','3986','571','2005-06-21T06:40:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1255','2005-06-15T06:13:45.000','1433','526','2005-06-16T03:59:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1256','2005-06-15T06:13:57.000','1437','470','2005-06-16T06:54:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1257','2005-06-15T06:15:36.000','1938','267','2005-06-21T01:04:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1258','2005-06-15T06:21:30.000','4530','320','2005-06-18T05:43:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1259','2005-06-15T06:37:55.000','4460','570','2005-06-23T04:02:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1260','2005-06-15T06:42:25.000','330','586','2005-06-16T10:44:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1261','2005-06-15T06:52:57.000','2447','95','2005-06-21T01:47:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1262','2005-06-15T06:54:53.000','4495','236','2005-06-22T08:09:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1263','2005-06-15T06:56:39.000','4144','540','2005-06-16T11:08:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1264','2005-06-15T06:59:39.000','4176','439','2005-06-18T08:10:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1265','2005-06-15T07:00:50.000','982','163','2005-06-19T12:27:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1266','2005-06-15T07:11:39.000','2230','96','2005-06-21T02:59:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1267','2005-06-15T07:21:21.000','4246','509','2005-06-17T08:12:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1268','2005-06-15T07:29:30.000','3641','142','2005-06-23T12:36:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1269','2005-06-15T07:29:59.000','108','59','2005-06-16T13:26:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1270','2005-06-15T07:30:22.000','62','395','2005-06-18T11:31:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1271','2005-06-15T07:32:24.000','379','560','2005-06-21T05:12:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1272','2005-06-15T07:42:58.000','3128','135','2005-06-18T12:00:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1273','2005-06-15T07:52:35.000','361','530','2005-06-21T04:55:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1274','2005-06-15T07:52:52.000','2765','430','2005-06-20T10:01:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1275','2005-06-15T07:55:43.000','950','214','2005-06-20T06:30:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1276','2005-06-15T08:00:13.000','1508','388','2005-06-24T02:55:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1277','2005-06-15T08:01:29.000','76','464','2005-06-22T07:16:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1278','2005-06-15T08:09:12.000','4471','191','2005-06-17T04:05:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1279','2005-06-15T08:13:57.000','698','183','2005-06-18T09:36:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1280','2005-06-15T08:16:06.000','2597','266','2005-06-21T04:10:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1281','2005-06-15T08:21:39.000','2963','511','2005-06-17T11:03:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1282','2005-06-15T08:25:33.000','186','539','2005-06-21T04:02:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1283','2005-06-15T08:27:30.000','3177','470','2005-06-16T09:46:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1284','2005-06-15T08:27:33.000','1387','463','2005-06-17T03:58:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1285','2005-06-15T08:33:06.000','1054','254','2005-06-19T07:36:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1286','2005-06-15T08:41:13.000','774','179','2005-06-23T13:13:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1287','2005-06-15T08:41:38.000','4204','104','2005-06-22T14:02:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1288','2005-06-15T08:41:52.000','830','456','2005-06-19T05:30:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1289','2005-06-15T08:44:09.000','3154','522','2005-06-21T06:04:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1290','2005-06-15T08:52:44.000','1921','540','2005-06-24T13:36:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1291','2005-06-15T08:55:01.000','3090','176','2005-06-24T04:22:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1292','2005-06-15T09:03:52.000','4535','178','2005-06-21T07:53:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1293','2005-06-15T09:06:24.000','2882','127','2005-06-18T06:58:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1294','2005-06-15T09:09:27.000','339','327','2005-06-19T04:43:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1295','2005-06-15T09:17:20.000','2897','449','2005-06-18T10:14:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1296','2005-06-15T09:23:59.000','1760','200','2005-06-19T03:44:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1297','2005-06-15T09:31:28.000','1075','4','2005-06-19T04:33:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1298','2005-06-15T09:32:53.000','4163','334','2005-06-16T12:40:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1299','2005-06-15T09:34:50.000','1584','91','2005-06-21T12:07:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1300','2005-06-15T09:36:19.000','2524','186','2005-06-17T13:54:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1301','2005-06-15T09:46:33.000','1484','33','2005-06-24T08:56:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1302','2005-06-15T09:48:37.000','324','285','2005-06-22T06:18:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1303','2005-06-15T09:55:57.000','2001','365','2005-06-20T14:26:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1304','2005-06-15T09:56:02.000','1304','242','2005-06-24T07:00:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1305','2005-06-15T09:59:16.000','187','8','2005-06-19T09:48:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1306','2005-06-15T09:59:24.000','2132','524','2005-06-19T09:37:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1307','2005-06-15T10:06:15.000','368','507','2005-06-20T04:50:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1308','2005-06-15T10:07:48.000','220','236','2005-06-24T15:24:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1309','2005-06-15T10:10:49.000','2356','200','2005-06-16T12:44:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1310','2005-06-15T10:11:42.000','2045','27','2005-06-16T15:00:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1311','2005-06-15T10:11:59.000','3114','326','2005-06-17T08:44:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1312','2005-06-15T10:16:27.000','3608','313','2005-06-20T06:53:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1313','2005-06-15T10:18:34.000','1657','448','2005-06-23T06:25:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1314','2005-06-15T10:21:45.000','1359','538','2005-06-21T14:10:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1315','2005-06-15T10:23:08.000','3844','405','2005-06-21T15:06:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1316','2005-06-15T10:26:23.000','3891','138','2005-06-21T09:25:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1317','2005-06-15T10:30:19.000','3696','316','2005-06-24T08:18:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1318','2005-06-15T10:34:26.000','2760','341','2005-06-20T16:20:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1319','2005-06-15T10:39:05.000','4296','190','2005-06-18T05:25:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1320','2005-06-15T10:42:13.000','4484','84','2005-06-17T13:44:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1321','2005-06-15T10:49:17.000','3516','204','2005-06-16T15:30:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1322','2005-06-15T10:55:09.000','2076','217','2005-06-18T15:14:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1323','2005-06-15T10:55:17.000','3273','187','2005-06-24T09:51:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1324','2005-06-15T11:02:45.000','764','394','2005-06-17T07:14:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1325','2005-06-15T11:03:24.000','52','193','2005-06-20T10:54:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1326','2005-06-15T11:07:39.000','59','548','2005-06-22T05:55:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1327','2005-06-15T11:11:39.000','403','539','2005-06-22T10:45:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1328','2005-06-15T11:23:27.000','3665','295','2005-06-19T12:42:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1329','2005-06-15T11:25:06.000','1154','359','2005-06-17T16:10:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1330','2005-06-15T11:29:17.000','1219','587','2005-06-24T13:36:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1331','2005-06-15T11:34:33.000','3089','277','2005-06-21T09:46:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1332','2005-06-15T11:36:01.000','1412','116','2005-06-17T14:29:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1333','2005-06-15T11:37:08.000','448','310','2005-06-16T10:13:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1334','2005-06-15T11:43:09.000','1242','269','2005-06-20T15:45:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1335','2005-06-15T11:51:30.000','1713','64','2005-06-16T16:42:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1336','2005-06-15T12:01:34.000','1696','290','2005-06-23T12:05:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1337','2005-06-15T12:12:42.000','4014','465','2005-06-20T12:38:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1338','2005-06-15T12:17:34.000','1206','25','2005-06-19T07:40:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1339','2005-06-15T12:21:56.000','424','162','2005-06-19T07:46:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1340','2005-06-15T12:24:15.000','251','100','2005-06-22T13:02:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1341','2005-06-15T12:26:18.000','3363','344','2005-06-21T07:26:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1342','2005-06-15T12:26:21.000','4429','427','2005-06-22T11:23:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1343','2005-06-15T12:27:19.000','2393','416','2005-06-21T16:57:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1344','2005-06-15T12:29:41.000','1625','585','2005-06-22T12:45:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1345','2005-06-15T12:32:13.000','1041','270','2005-06-24T14:02:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1346','2005-06-15T12:39:52.000','4540','585','2005-06-24T17:43:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1347','2005-06-15T12:43:43.000','374','190','2005-06-16T09:55:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1348','2005-06-15T12:45:30.000','2078','196','2005-06-17T17:12:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1349','2005-06-15T12:49:02.000','1131','267','2005-06-17T15:20:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1350','2005-06-15T12:50:25.000','4261','316','2005-06-23T11:35:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1351','2005-06-15T12:51:03.000','2364','484','2005-06-22T07:23:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1352','2005-06-15T12:58:27.000','4352','276','2005-06-18T10:57:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1353','2005-06-15T13:13:36.000','2711','480','2005-06-21T08:46:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1354','2005-06-15T13:13:49.000','1294','83','2005-06-23T13:08:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1355','2005-06-15T13:13:59.000','4203','499','2005-06-20T12:23:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1356','2005-06-15T13:17:01.000','1318','212','2005-06-19T16:22:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1357','2005-06-15T13:26:23.000','2285','205','2005-06-23T14:12:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1358','2005-06-15T13:28:48.000','2025','442','2005-06-21T13:40:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1359','2005-06-15T13:30:30.000','3140','353','2005-06-17T14:55:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1360','2005-06-15T13:32:15.000','4107','14','2005-06-18T10:59:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1361','2005-06-15T13:37:38.000','4338','115','2005-06-19T17:08:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1362','2005-06-15T13:53:32.000','4524','98','2005-06-19T16:05:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1363','2005-06-15T14:05:11.000','771','197','2005-06-17T19:53:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1364','2005-06-15T14:05:32.000','115','400','2005-06-16T15:31:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1365','2005-06-15T14:09:55.000','3813','25','2005-06-19T18:11:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1366','2005-06-15T14:21:00.000','4238','576','2005-06-24T17:36:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1367','2005-06-15T14:25:17.000','1505','94','2005-06-21T19:15:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1368','2005-06-15T14:27:47.000','2020','222','2005-06-23T18:07:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1369','2005-06-15T14:29:14.000','679','221','2005-06-16T13:01:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1370','2005-06-15T14:31:05.000','644','396','2005-06-22T19:23:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1371','2005-06-15T14:38:15.000','760','491','2005-06-23T15:36:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1372','2005-06-15T14:45:48.000','3740','108','2005-06-17T18:02:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1373','2005-06-15T14:48:04.000','284','51','2005-06-22T09:48:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1374','2005-06-15T14:49:54.000','3353','120','2005-06-22T12:30:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1375','2005-06-15T14:54:56.000','3555','500','2005-06-21T14:48:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1376','2005-06-15T14:59:06.000','4271','215','2005-06-19T17:34:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1377','2005-06-15T15:02:03.000','3410','245','2005-06-22T14:54:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1378','2005-06-15T15:03:15.000','4372','253','2005-06-19T16:50:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1379','2005-06-15T15:05:10.000','810','212','2005-06-18T12:11:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1380','2005-06-15T15:13:10.000','3376','158','2005-06-18T12:42:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1381','2005-06-15T15:17:21.000','3262','300','2005-06-20T17:07:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1382','2005-06-15T15:18:08.000','3133','455','2005-06-22T09:22:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1383','2005-06-15T15:20:06.000','1281','379','2005-06-24T18:42:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1384','2005-06-15T15:22:03.000','4242','242','2005-06-18T18:11:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1385','2005-06-15T15:28:23.000','4073','396','2005-06-18T18:37:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1386','2005-06-15T15:38:58.000','1296','322','2005-06-20T16:28:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1387','2005-06-15T15:40:56.000','515','278','2005-06-17T10:39:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1388','2005-06-15T15:48:41.000','3987','500','2005-06-22T17:51:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1389','2005-06-15T15:49:01.000','965','472','2005-06-19T11:08:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1390','2005-06-15T16:06:29.000','4502','254','2005-06-19T13:11:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1391','2005-06-15T16:11:21.000','4213','273','2005-06-22T21:32:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1392','2005-06-15T16:12:27.000','363','460','2005-06-16T17:30:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1393','2005-06-15T16:12:50.000','2767','177','2005-06-19T10:40:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1394','2005-06-15T16:17:21.000','2802','268','2005-06-21T20:44:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1395','2005-06-15T16:21:04.000','753','252','2005-06-23T12:52:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1396','2005-06-15T16:22:38.000','1007','103','2005-06-17T15:53:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1397','2005-06-15T16:25:26.000','1830','444','2005-06-21T20:45:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1398','2005-06-15T16:28:42.000','4402','527','2005-06-16T12:11:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1399','2005-06-15T16:29:51.000','1435','469','2005-06-18T14:06:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1400','2005-06-15T16:29:56.000','230','571','2005-06-21T14:43:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1401','2005-06-15T16:30:22.000','4081','366','2005-06-21T11:07:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1402','2005-06-15T16:31:08.000','1951','381','2005-06-24T19:31:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1403','2005-06-15T16:31:59.000','3380','546','2005-06-22T14:23:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1404','2005-06-15T16:38:53.000','2776','375','2005-06-16T20:37:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1405','2005-06-15T16:41:26.000','3184','243','2005-06-21T18:16:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1406','2005-06-15T16:44:00.000','3118','199','2005-06-21T11:22:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1407','2005-06-15T16:45:07.000','1286','89','2005-06-23T14:01:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1408','2005-06-15T16:57:58.000','2655','396','2005-06-22T21:08:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1409','2005-06-15T16:58:12.000','1398','297','2005-06-21T11:21:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1410','2005-06-15T16:59:46.000','809','356','2005-06-21T16:38:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1411','2005-06-15T17:05:36.000','2276','520','2005-06-21T14:05:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1412','2005-06-15T17:09:48.000','4236','166','2005-06-18T17:05:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1413','2005-06-15T17:25:07.000','3625','96','2005-06-21T17:17:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1414','2005-06-15T17:26:32.000','4005','304','2005-06-22T22:30:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1415','2005-06-15T17:31:57.000','1885','331','2005-06-16T22:22:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1416','2005-06-15T17:44:57.000','3816','167','2005-06-22T20:53:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1417','2005-06-15T17:45:51.000','1334','570','2005-06-19T14:00:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1418','2005-06-15T17:51:27.000','2974','591','2005-06-18T23:20:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1419','2005-06-15T17:54:50.000','1208','312','2005-06-17T19:44:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1420','2005-06-15T17:56:14.000','4149','255','2005-06-24T15:45:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1421','2005-06-15T17:57:04.000','2439','533','2005-06-21T20:38:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1422','2005-06-15T18:02:53.000','1021','1','2005-06-19T15:54:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1423','2005-06-15T18:08:12.000','1396','592','2005-06-24T19:13:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1424','2005-06-15T18:08:14.000','887','224','2005-06-24T23:16:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1425','2005-06-15T18:13:46.000','1308','108','2005-06-18T22:50:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1426','2005-06-15T18:16:24.000','4412','363','2005-06-18T22:15:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1427','2005-06-15T18:17:28.000','14','100','2005-06-16T15:47:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1428','2005-06-15T18:19:30.000','3689','583','2005-06-22T23:05:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1429','2005-06-15T18:24:10.000','4116','362','2005-06-18T16:30:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1430','2005-06-15T18:24:55.000','3412','194','2005-06-16T12:26:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1431','2005-06-15T18:26:29.000','3193','438','2005-06-21T17:33:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1432','2005-06-15T18:27:24.000','523','339','2005-06-21T14:03:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1433','2005-06-15T18:30:00.000','2310','88','2005-06-16T15:14:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1434','2005-06-15T18:30:46.000','4228','544','2005-06-24T17:51:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1435','2005-06-15T18:32:30.000','2769','510','2005-06-24T12:44:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1436','2005-06-15T18:35:40.000','924','584','2005-06-21T15:04:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1437','2005-06-15T18:37:04.000','3263','96','2005-06-20T12:56:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1438','2005-06-15T18:38:51.000','1816','82','2005-06-17T23:50:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1439','2005-06-15T18:45:32.000','3155','589','2005-06-22T15:57:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1440','2005-06-15T18:53:14.000','2921','26','2005-06-24T15:28:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1441','2005-06-15T18:54:21.000','2095','444','2005-06-22T22:48:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1442','2005-06-15T18:55:34.000','3912','122','2005-06-22T20:41:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1443','2005-06-15T18:57:51.000','2485','435','2005-06-18T14:18:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1444','2005-06-15T19:08:16.000','1303','539','2005-06-24T15:20:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1445','2005-06-15T19:10:07.000','3189','537','2005-06-19T20:27:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1446','2005-06-15T19:13:45.000','1989','506','2005-06-23T19:43:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1447','2005-06-15T19:13:51.000','984','471','2005-06-21T22:56:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1448','2005-06-15T19:17:16.000','2781','246','2005-06-23T21:56:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1449','2005-06-15T19:19:16.000','1525','471','2005-06-18T15:24:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1450','2005-06-15T19:22:08.000','4132','268','2005-06-16T17:53:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1451','2005-06-15T19:30:18.000','3560','18','2005-06-19T19:22:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1452','2005-06-15T19:32:52.000','4348','243','2005-06-16T13:45:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1453','2005-06-15T19:36:39.000','3274','457','2005-06-19T00:16:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1454','2005-06-15T19:49:41.000','102','298','2005-06-17T15:17:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1455','2005-06-15T19:51:06.000','2194','358','2005-06-18T21:54:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1456','2005-06-15T20:00:11.000','632','590','2005-06-23T18:03:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1457','2005-06-15T20:05:49.000','730','345','2005-06-19T15:35:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1458','2005-06-15T20:24:05.000','3546','178','2005-06-21T01:22:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1459','2005-06-15T20:25:53.000','1862','218','2005-06-22T23:34:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1460','2005-06-15T20:27:02.000','1405','565','2005-06-16T16:21:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1461','2005-06-15T20:32:08.000','4479','216','2005-06-23T01:08:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1462','2005-06-15T20:37:40.000','653','187','2005-06-18T19:36:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1463','2005-06-15T20:37:51.000','2984','569','2005-06-21T16:46:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1464','2005-06-15T20:38:14.000','4113','387','2005-06-17T14:52:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1465','2005-06-15T20:43:08.000','609','387','2005-06-18T23:00:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1466','2005-06-15T20:46:04.000','1057','288','2005-06-24T22:46:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1467','2005-06-15T20:47:10.000','688','506','2005-06-22T00:30:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1468','2005-06-15T20:48:22.000','228','230','2005-06-21T19:48:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1469','2005-06-15T20:52:36.000','2451','580','2005-06-21T19:55:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1470','2005-06-15T20:53:07.000','4044','11','2005-06-25T02:12:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1471','2005-06-15T20:53:26.000','565','428','2005-06-24T18:25:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1472','2005-06-15T20:54:55.000','4233','373','2005-06-24T21:52:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1473','2005-06-15T20:55:20.000','2377','249','2005-06-21T16:40:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1474','2005-06-15T20:55:42.000','164','202','2005-06-19T02:41:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1475','2005-06-15T21:08:01.000','1834','344','2005-06-18T22:33:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1476','2005-06-15T21:08:46.000','1407','1','2005-06-25T02:26:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1477','2005-06-15T21:11:18.000','418','51','2005-06-19T02:05:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1478','2005-06-15T21:12:13.000','435','336','2005-06-18T21:43:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1479','2005-06-15T21:13:38.000','172','592','2005-06-17T01:26:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1480','2005-06-15T21:17:17.000','2598','27','2005-06-23T22:01:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1481','2005-06-15T21:17:58.000','3041','125','2005-06-18T17:53:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1482','2005-06-15T21:18:16.000','3980','60','2005-06-16T17:07:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1483','2005-06-15T21:21:58.000','1926','242','2005-06-24T00:44:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1484','2005-06-15T21:22:35.000','1589','320','2005-06-20T02:27:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1485','2005-06-15T21:24:10.000','194','281','2005-06-24T23:03:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1486','2005-06-15T21:25:30.000','847','62','2005-06-16T16:36:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1487','2005-06-15T21:27:42.000','3791','76','2005-06-22T03:09:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1488','2005-06-15T21:39:54.000','1081','355','2005-06-16T20:33:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1489','2005-06-15T21:41:38.000','699','213','2005-06-22T17:00:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1490','2005-06-15T21:42:17.000','3515','123','2005-06-22T02:01:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1491','2005-06-15T21:48:18.000','848','354','2005-06-20T16:40:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1492','2005-06-15T21:48:35.000','4148','360','2005-06-17T17:18:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1493','2005-06-15T21:50:32.000','4581','235','2005-06-17T01:02:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1494','2005-06-15T21:54:20.000','244','575','2005-06-19T18:46:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1495','2005-06-15T21:54:31.000','1842','175','2005-06-19T00:08:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1496','2005-06-15T21:55:58.000','3915','290','2005-06-17T02:28:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1497','2005-06-15T21:56:39.000','2958','44','2005-06-20T20:32:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1498','2005-06-15T21:58:00.000','3690','352','2005-06-17T21:50:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1499','2005-06-15T21:58:07.000','165','375','2005-06-22T19:37:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1500','2005-06-15T22:00:45.000','2652','237','2005-06-18T16:19:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1501','2005-06-15T22:02:35.000','1780','148','2005-06-23T18:59:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1502','2005-06-15T22:03:14.000','3277','5','2005-06-23T18:42:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1503','2005-06-15T22:07:09.000','763','197','2005-06-20T23:15:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1504','2005-06-15T22:08:06.000','3621','423','2005-06-24T01:16:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1505','2005-06-15T22:12:50.000','2961','561','2005-06-17T21:37:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1506','2005-06-15T22:19:37.000','4085','404','2005-06-22T18:28:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1507','2005-06-15T22:25:26.000','2514','172','2005-06-19T17:00:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1508','2005-06-15T22:33:24.000','1141','511','2005-06-18T02:27:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1509','2005-06-15T22:35:53.000','655','167','2005-06-23T17:09:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1510','2005-06-15T22:39:34.000','989','338','2005-06-24T19:21:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1511','2005-06-15T22:45:06.000','1135','330','2005-06-22T22:48:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1512','2005-06-15T22:53:03.000','1628','452','2005-06-23T18:56:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1513','2005-06-15T22:53:30.000','1173','368','2005-06-23T01:00:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1514','2005-06-15T22:57:34.000','2937','410','2005-06-19T20:27:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1515','2005-06-15T23:07:50.000','3244','115','2005-06-20T02:33:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1516','2005-06-15T23:11:10.000','3702','530','2005-06-17T20:37:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1517','2005-06-15T23:20:26.000','3728','148','2005-06-23T23:23:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1518','2005-06-15T23:36:37.000','4537','237','2005-06-16T18:24:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1519','2005-06-15T23:55:27.000','1553','155','2005-06-21T04:06:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1520','2005-06-15T23:57:20.000','3419','341','2005-06-24T23:46:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1521','2005-06-15T23:58:53.000','4299','149','2005-06-18T03:10:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1522','2005-06-16T00:17:39.000','235','133','2005-06-22T05:38:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1523','2005-06-16T00:18:40.000','681','349','2005-06-17T02:50:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1524','2005-06-16T00:25:52.000','3439','177','2005-06-19T03:32:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1525','2005-06-16T00:26:07.000','1467','304','2005-06-19T22:37:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1526','2005-06-16T00:27:51.000','1940','499','2005-06-19T00:19:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1527','2005-06-16T00:31:40.000','296','188','2005-06-21T05:20:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1528','2005-06-16T00:32:52.000','4297','110','2005-06-25T01:07:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1529','2005-06-16T00:37:35.000','1688','362','2005-06-22T18:58:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1530','2005-06-16T00:38:07.000','2421','392','2005-06-24T02:45:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1531','2005-06-16T00:40:34.000','1388','515','2005-06-22T02:44:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1532','2005-06-16T00:41:31.000','3793','290','2005-06-20T21:36:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1533','2005-06-16T00:46:02.000','2452','116','2005-06-17T20:11:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1534','2005-06-16T00:49:32.000','3124','42','2005-06-18T02:41:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1535','2005-06-16T00:52:04.000','1096','202','2005-06-20T22:47:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1536','2005-06-16T00:52:22.000','3248','339','2005-06-17T21:43:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1537','2005-06-16T00:52:51.000','4577','594','2005-06-20T19:33:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1538','2005-06-16T01:05:50.000','708','430','2005-06-18T19:48:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1539','2005-06-16T01:11:25.000','267','390','2005-06-23T03:43:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1540','2005-06-16T01:14:56.000','2707','586','2005-06-20T23:31:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1541','2005-06-16T01:15:59.000','1911','189','2005-06-22T21:26:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1542','2005-06-16T01:20:05.000','1714','182','2005-06-22T03:59:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1543','2005-06-16T01:24:08.000','1188','28','2005-06-18T06:24:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1544','2005-06-16T01:28:22.000','269','43','2005-06-17T06:57:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1545','2005-06-16T01:31:23.000','762','563','2005-06-24T05:50:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1546','2005-06-16T01:34:05.000','3913','3','2005-06-24T04:27:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1547','2005-06-16T01:42:24.000','2909','343','2005-06-19T01:13:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1548','2005-06-16T01:43:33.000','2094','374','2005-06-23T22:04:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1549','2005-06-16T01:57:15.000','266','69','2005-06-18T23:30:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1550','2005-06-16T01:58:35.000','2003','345','2005-06-18T23:56:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1551','2005-06-16T02:01:15.000','4088','268','2005-06-22T07:33:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1552','2005-06-16T02:01:37.000','819','518','2005-06-21T00:59:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1553','2005-06-16T02:02:44.000','4026','416','2005-06-19T07:50:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1554','2005-06-16T02:16:47.000','715','155','2005-06-22T05:15:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1555','2005-06-16T02:17:07.000','4168','256','2005-06-22T06:28:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1556','2005-06-16T02:19:02.000','533','54','2005-06-17T22:36:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1557','2005-06-16T02:28:35.000','2617','439','2005-06-16T22:11:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1558','2005-06-16T02:33:53.000','4350','20','2005-06-19T20:50:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1559','2005-06-16T02:35:03.000','716','574','2005-06-19T21:22:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1560','2005-06-16T02:36:43.000','3418','239','2005-06-24T23:10:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1561','2005-06-16T02:41:30.000','2263','431','2005-06-22T05:19:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1562','2005-06-16T02:46:27.000','595','395','2005-06-23T00:56:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1563','2005-06-16T02:46:28.000','1516','262','2005-06-18T02:37:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1564','2005-06-16T02:47:07.000','145','343','2005-06-24T03:12:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1565','2005-06-16T03:13:09.000','3833','506','2005-06-16T22:42:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1566','2005-06-16T03:13:20.000','3215','174','2005-06-24T01:59:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1567','2005-06-16T03:13:30.000','3098','320','2005-06-21T23:56:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1568','2005-06-16T03:14:01.000','635','178','2005-06-19T21:17:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1569','2005-06-16T03:19:09.000','3927','363','2005-06-18T21:55:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1570','2005-06-16T03:21:33.000','3711','82','2005-06-22T22:03:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1571','2005-06-16T03:22:00.000','1019','54','2005-06-22T23:27:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1572','2005-06-16T03:23:22.000','4179','560','2005-06-20T06:03:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1573','2005-06-16T03:31:39.000','4536','371','2005-06-25T04:04:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1574','2005-06-16T03:39:56.000','161','305','2005-06-22T05:40:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1575','2005-06-16T03:41:38.000','3317','6','2005-06-22T03:01:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1576','2005-06-16T03:54:39.000','1014','442','2005-06-24T21:55:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1577','2005-06-16T04:03:28.000','367','327','2005-06-24T22:40:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1578','2005-06-16T04:08:16.000','3397','365','2005-06-23T07:57:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1579','2005-06-16T04:09:08.000','158','35','2005-06-21T05:21:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1580','2005-06-16T04:12:25.000','2479','87','2005-06-20T06:53:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1581','2005-06-16T04:28:45.000','4004','109','2005-06-18T07:07:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1582','2005-06-16T04:31:57.000','163','536','2005-06-22T01:25:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1583','2005-06-16T04:44:23.000','270','37','2005-06-18T03:44:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1584','2005-06-16T04:50:50.000','3545','434','2005-06-21T22:51:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1585','2005-06-16T04:51:13.000','1708','386','2005-06-24T00:23:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1586','2005-06-16T04:51:18.000','769','140','2005-06-21T06:54:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1587','2005-06-16T04:52:28.000','1781','62','2005-06-23T07:36:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1588','2005-06-16T04:53:21.000','4472','322','2005-06-25T07:29:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1589','2005-06-16T04:58:03.000','4307','293','2005-06-24T08:36:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1590','2005-06-16T05:11:41.000','3685','98','2005-06-23T10:11:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1591','2005-06-16T05:12:37.000','1648','83','2005-06-25T06:28:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1592','2005-06-16T05:14:37.000','3798','187','2005-06-20T10:52:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1593','2005-06-16T05:14:52.000','766','111','2005-06-24T08:00:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1594','2005-06-16T05:15:12.000','3858','470','2005-06-25T00:38:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1595','2005-06-16T05:23:46.000','1481','244','2005-06-20T00:37:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1596','2005-06-16T05:30:58.000','2552','416','2005-06-21T04:18:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1597','2005-06-16T05:47:03.000','743','432','2005-06-18T04:21:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1598','2005-06-16T06:02:39.000','4171','314','2005-06-23T09:09:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1599','2005-06-16T06:03:33.000','1476','215','2005-06-21T07:46:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1600','2005-06-16T06:04:12.000','2264','196','2005-06-19T09:39:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1601','2005-06-16T06:11:13.000','3115','428','2005-06-21T08:57:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1602','2005-06-16T06:12:40.000','1777','441','2005-06-19T03:50:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1603','2005-06-16T06:14:03.000','3308','395','2005-06-17T06:04:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1604','2005-06-16T06:14:25.000','3226','272','2005-06-17T03:53:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1605','2005-06-16T06:17:55.000','593','197','2005-06-25T01:25:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1606','2005-06-16T06:18:31.000','4290','253','2005-06-25T09:15:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1607','2005-06-16T06:25:35.000','3289','513','2005-06-20T02:50:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1608','2005-06-16T06:28:57.000','2581','386','2005-06-24T05:20:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1609','2005-06-16T06:34:59.000','2279','174','2005-06-17T09:41:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1610','2005-06-16T06:36:33.000','3551','534','2005-06-19T07:12:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1611','2005-06-16T06:41:35.000','1739','393','2005-06-25T06:13:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1612','2005-06-16T06:52:05.000','3025','355','2005-06-19T01:51:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1613','2005-06-16T06:55:10.000','4462','573','2005-06-24T12:08:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1614','2005-06-16T06:58:02.000','23','489','2005-06-23T11:24:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1615','2005-06-16T07:00:28.000','3894','362','2005-06-25T08:53:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1616','2005-06-16T07:04:52.000','2296','204','2005-06-24T04:06:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1617','2005-06-16T07:06:06.000','1382','83','2005-06-25T03:35:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1618','2005-06-16T07:08:38.000','3741','134','2005-06-25T05:26:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1619','2005-06-16T07:14:13.000','4258','232','2005-06-19T05:50:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1620','2005-06-16T07:21:30.000','389','561','2005-06-17T09:46:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1621','2005-06-16T07:24:12.000','3677','177','2005-06-19T02:35:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1622','2005-06-16T07:33:18.000','1774','311','2005-06-21T07:23:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1623','2005-06-16T07:48:50.000','4485','378','2005-06-17T03:53:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1624','2005-06-16T07:48:57.000','1066','314','2005-06-17T05:52:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1625','2005-06-16T07:49:08.000','3367','39','2005-06-24T09:08:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1626','2005-06-16T07:49:47.000','694','260','2005-06-22T13:32:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1627','2005-06-16T07:51:09.000','4135','468','2005-06-24T02:24:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1628','2005-06-16T07:52:55.000','868','427','2005-06-25T11:09:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1629','2005-06-16T07:53:47.000','4375','339','2005-06-22T13:03:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1630','2005-06-16T07:55:01.000','2413','130','2005-06-19T06:38:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1631','2005-06-16T08:01:02.000','2466','5','2005-06-19T09:04:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1632','2005-06-16T08:03:42.000','1518','319','2005-06-17T03:40:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1633','2005-06-16T08:08:40.000','280','4','2005-06-17T11:12:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1634','2005-06-16T08:16:05.000','3990','121','2005-06-17T04:49:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1635','2005-06-16T08:26:56.000','1187','566','2005-06-25T06:17:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1636','2005-06-16T08:28:54.000','2052','574','2005-06-24T09:23:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1637','2005-06-16T08:29:58.000','906','212','2005-06-23T04:55:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1638','2005-06-16T08:32:36.000','1905','181','2005-06-18T07:11:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1639','2005-06-16T08:33:39.000','176','450','2005-06-25T07:51:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1640','2005-06-16T08:35:39.000','443','86','2005-06-17T05:37:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1641','2005-06-16T08:46:26.000','2925','259','2005-06-24T14:39:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1642','2005-06-16T08:54:15.000','3875','287','2005-06-18T12:36:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1643','2005-06-16T08:55:35.000','1352','484','2005-06-21T05:36:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1644','2005-06-16T08:58:18.000','749','596','2005-06-21T06:47:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1645','2005-06-16T09:10:06.000','4434','234','2005-06-23T04:36:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1646','2005-06-16T09:12:53.000','4037','131','2005-06-24T08:03:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1647','2005-06-16T09:14:58.000','1936','454','2005-06-17T10:46:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1648','2005-06-16T09:17:07.000','457','427','2005-06-24T06:31:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1649','2005-06-16T09:20:33.000','390','352','2005-06-18T13:42:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1650','2005-06-16T09:23:20.000','4125','299','2005-06-23T11:25:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1651','2005-06-16T09:24:38.000','4444','524','2005-06-17T09:50:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1652','2005-06-16T09:31:37.000','3416','533','2005-06-19T14:02:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1653','2005-06-16T09:34:45.000','2294','517','2005-06-18T09:13:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1654','2005-06-16T09:42:48.000','1039','348','2005-06-20T14:28:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1655','2005-06-16T09:51:39.000','3693','488','2005-06-23T14:53:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1656','2005-06-16T10:05:40.000','2253','31','2005-06-22T06:26:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1657','2005-06-16T10:06:49.000','953','209','2005-06-22T10:34:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1658','2005-06-16T10:07:10.000','272','568','2005-06-21T09:23:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1659','2005-06-16T10:11:46.000','1182','296','2005-06-20T13:51:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1660','2005-06-16T10:12:55.000','2374','238','2005-06-18T05:56:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1661','2005-06-16T10:12:57.000','2403','508','2005-06-24T09:23:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1662','2005-06-16T10:13:35.000','3552','378','2005-06-23T13:54:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1663','2005-06-16T10:14:15.000','1558','186','2005-06-23T08:34:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1664','2005-06-16T10:15:20.000','2464','216','2005-06-18T12:11:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1665','2005-06-16T10:16:02.000','2613','490','2005-06-23T09:32:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1666','2005-06-16T10:17:19.000','4019','557','2005-06-21T05:50:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1667','2005-06-16T10:18:59.000','2362','333','2005-06-22T14:45:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1668','2005-06-16T10:19:52.000','2483','569','2005-06-23T12:22:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1669','2005-06-16T10:20:20.000','360','73','2005-06-18T04:26:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1670','2005-06-16T10:26:33.000','2066','328','2005-06-19T07:15:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1671','2005-06-16T10:30:22.000','3805','135','2005-06-22T11:08:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1672','2005-06-16T10:37:34.000','4206','216','2005-06-23T05:30:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1673','2005-06-16T10:40:17.000','907','534','2005-06-18T16:13:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1674','2005-06-16T10:57:00.000','3606','234','2005-06-18T07:31:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1675','2005-06-16T11:04:47.000','3048','371','2005-06-24T06:56:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1676','2005-06-16T11:06:09.000','931','171','2005-06-21T05:17:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1677','2005-06-16T11:07:11.000','240','191','2005-06-23T10:50:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1678','2005-06-16T11:08:28.000','1856','352','2005-06-19T15:44:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1679','2005-06-16T11:11:01.000','3959','227','2005-06-23T08:11:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1680','2005-06-16T11:17:22.000','4441','469','2005-06-25T15:55:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1681','2005-06-16T11:38:17.000','530','255','2005-06-19T13:05:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1682','2005-06-16T11:54:25.000','2165','476','2005-06-22T11:09:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1683','2005-06-16T11:54:55.000','2361','494','2005-06-18T08:51:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1684','2005-06-16T11:57:34.000','806','485','2005-06-19T09:12:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1685','2005-06-16T12:06:57.000','2754','85','2005-06-21T16:53:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1686','2005-06-16T12:08:20.000','3883','529','2005-06-20T10:59:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1687','2005-06-16T12:09:20.000','3686','140','2005-06-18T06:18:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1688','2005-06-16T12:11:20.000','383','49','2005-06-18T08:39:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1689','2005-06-16T12:18:41.000','4036','48','2005-06-24T13:33:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1690','2005-06-16T12:24:18.000','1099','286','2005-06-25T15:00:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1691','2005-06-16T12:24:28.000','4438','492','2005-06-24T08:24:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1692','2005-06-16T12:30:19.000','3544','514','2005-06-17T17:31:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1693','2005-06-16T12:39:51.000','2386','421','2005-06-19T16:19:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1694','2005-06-16T12:40:23.000','147','532','2005-06-20T09:18:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1695','2005-06-16T12:40:28.000','4436','159','2005-06-22T13:41:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1696','2005-06-16T12:50:01.000','3928','502','2005-06-24T12:08:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1697','2005-06-16T12:55:20.000','1801','340','2005-06-23T17:41:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1698','2005-06-16T13:04:42.000','1474','407','2005-06-21T15:54:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1699','2005-06-16T13:05:09.000','4507','27','2005-06-17T09:53:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1700','2005-06-16T13:18:23.000','4251','456','2005-06-21T16:46:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1701','2005-06-16T13:18:48.000','3000','315','2005-06-22T15:00:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1702','2005-06-16T13:21:05.000','1822','242','2005-06-19T10:13:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1703','2005-06-16T13:28:44.000','2346','589','2005-06-17T11:03:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1704','2005-06-16T13:45:56.000','4425','488','2005-06-24T18:12:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1705','2005-06-16T13:59:42.000','123','564','2005-06-18T19:54:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1706','2005-06-16T14:01:02.000','2935','26','2005-06-25T19:29:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1707','2005-06-16T14:01:27.000','185','4','2005-06-18T09:35:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1708','2005-06-16T14:08:44.000','2259','478','2005-06-19T08:35:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1709','2005-06-16T14:10:15.000','3501','426','2005-06-24T16:38:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1710','2005-06-16T14:11:24.000','144','77','2005-06-22T15:26:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1711','2005-06-16T14:11:52.000','273','347','2005-06-25T08:49:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1712','2005-06-16T14:25:09.000','1363','535','2005-06-17T17:55:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1713','2005-06-16T14:28:33.000','2580','164','2005-06-18T09:02:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1714','2005-06-16T14:29:59.000','535','477','2005-06-24T17:27:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1715','2005-06-16T14:37:12.000','1594','203','2005-06-20T19:36:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1716','2005-06-16T14:39:31.000','20','24','2005-06-19T15:37:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1717','2005-06-16T14:47:16.000','3007','277','2005-06-19T10:11:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1718','2005-06-16T14:52:02.000','288','516','2005-06-25T10:53:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1719','2005-06-16T14:55:53.000','2699','582','2005-06-18T14:12:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1720','2005-06-16T15:00:14.000','3500','543','2005-06-21T13:57:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1721','2005-06-16T15:01:36.000','3521','485','2005-06-23T10:48:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1722','2005-06-16T15:12:52.000','2142','364','2005-06-19T13:01:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1723','2005-06-16T15:14:18.000','2417','259','2005-06-23T15:45:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1724','2005-06-16T15:15:43.000','61','146','2005-06-23T10:14:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1725','2005-06-16T15:18:57.000','726','1','2005-06-17T21:05:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1726','2005-06-16T15:19:10.000','116','3','2005-06-25T11:39:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1727','2005-06-16T15:21:47.000','2951','457','2005-06-17T14:12:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1728','2005-06-16T15:29:29.000','1366','59','2005-06-23T12:47:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1729','2005-06-16T15:29:47.000','3364','523','2005-06-25T20:55:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1730','2005-06-16T15:30:01.000','1372','390','2005-06-19T12:56:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1731','2005-06-16T15:32:12.000','3698','344','2005-06-19T18:58:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1732','2005-06-16T15:34:41.000','2287','129','2005-06-18T13:05:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1733','2005-06-16T15:37:07.000','542','480','2005-06-23T15:53:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1734','2005-06-16T15:49:30.000','1113','94','2005-06-22T13:52:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1735','2005-06-16T15:51:52.000','97','4','2005-06-20T13:27:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1736','2005-06-16T15:52:32.000','3771','139','2005-06-21T14:39:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1737','2005-06-16T15:59:44.000','4029','467','2005-06-23T12:22:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1738','2005-06-16T16:07:27.000','3260','177','2005-06-20T15:22:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1739','2005-06-16T16:09:38.000','2557','450','2005-06-22T18:04:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1740','2005-06-16T16:29:00.000','2282','324','2005-06-20T14:07:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1741','2005-06-16T16:31:37.000','3722','176','2005-06-25T21:38:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1742','2005-06-16T16:37:48.000','2772','576','2005-06-17T19:47:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1743','2005-06-16T16:38:10.000','2777','258','2005-06-17T13:13:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1744','2005-06-16T16:39:58.000','3075','230','2005-06-18T19:50:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1745','2005-06-16T16:41:16.000','2812','178','2005-06-23T21:02:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1746','2005-06-16T16:41:19.000','4272','385','2005-06-19T11:28:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1747','2005-06-16T16:53:33.000','1661','273','2005-06-25T21:48:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1748','2005-06-16T16:54:03.000','2434','473','2005-06-18T20:11:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1749','2005-06-16T16:56:00.000','1554','283','2005-06-21T21:02:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1750','2005-06-16T16:57:36.000','1103','321','2005-06-25T21:51:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1751','2005-06-16T17:00:14.000','138','123','2005-06-17T12:12:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1752','2005-06-16T17:02:55.000','3529','12','2005-06-23T19:09:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1753','2005-06-16T17:08:17.000','3817','249','2005-06-21T21:47:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1754','2005-06-16T17:13:23.000','4106','25','2005-06-22T20:46:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1755','2005-06-16T17:18:44.000','1721','117','2005-06-17T16:54:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1756','2005-06-16T17:22:33.000','1401','571','2005-06-21T16:52:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1757','2005-06-16T17:32:24.000','4491','510','2005-06-18T13:12:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1758','2005-06-16T17:39:39.000','2654','474','2005-06-25T13:06:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1759','2005-06-16T17:46:37.000','1402','430','2005-06-24T19:40:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1760','2005-06-16T17:48:37.000','3929','261','2005-06-18T16:01:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1761','2005-06-16T17:49:57.000','1570','521','2005-06-17T21:03:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1762','2005-06-16T17:50:19.000','3050','116','2005-06-19T21:35:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1763','2005-06-16T17:51:01.000','1941','389','2005-06-20T17:27:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1764','2005-06-16T17:51:54.000','705','392','2005-06-21T20:36:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1765','2005-06-16T17:56:10.000','822','273','2005-06-19T23:40:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1766','2005-06-16T17:59:37.000','2041','118','2005-06-18T16:32:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1767','2005-06-16T18:01:36.000','1162','205','2005-06-18T12:39:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1768','2005-06-16T18:02:06.000','2131','131','2005-06-23T17:19:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1769','2005-06-16T18:07:48.000','1229','397','2005-06-22T12:39:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1770','2005-06-16T18:07:55.000','1681','359','2005-06-23T23:49:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1771','2005-06-16T18:12:17.000','1769','416','2005-06-18T16:11:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1772','2005-06-16T18:12:54.000','1269','525','2005-06-24T19:55:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1773','2005-06-16T18:13:43.000','4396','462','2005-06-24T17:43:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1774','2005-06-16T18:27:52.000','3058','442','2005-06-21T13:35:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1775','2005-06-16T18:28:19.000','1922','123','2005-06-25T13:09:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1776','2005-06-16T18:46:58.000','1404','472','2005-06-24T16:01:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1777','2005-06-16T18:52:12.000','3325','49','2005-06-25T13:55:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1778','2005-06-16T18:54:48.000','2512','341','2005-06-22T16:08:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1779','2005-06-16T18:55:11.000','1044','438','2005-06-17T20:11:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1780','2005-06-16T19:11:45.000','146','352','2005-06-19T15:34:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1781','2005-06-16T19:20:24.000','2841','429','2005-06-25T17:02:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1782','2005-06-16T19:21:12.000','1820','498','2005-06-22T16:03:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1783','2005-06-16T19:23:23.000','50','18','2005-06-18T00:57:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1784','2005-06-16T19:25:32.000','3792','134','2005-06-20T00:00:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1785','2005-06-16T19:27:12.000','3413','50','2005-06-24T19:25:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1786','2005-06-16T19:30:54.000','263','323','2005-06-19T14:24:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1787','2005-06-16T19:30:59.000','3823','546','2005-06-21T18:25:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1788','2005-06-16T19:47:18.000','3794','357','2005-06-22T23:10:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1789','2005-06-16T19:49:18.000','4264','105','2005-06-23T17:07:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1790','2005-06-16T19:58:40.000','1070','158','2005-06-17T19:31:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1791','2005-06-16T20:04:28.000','301','76','2005-06-23T22:30:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1792','2005-06-16T20:04:50.000','3800','351','2005-06-26T00:57:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1793','2005-06-16T20:07:27.000','4356','230','2005-06-19T20:55:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1794','2005-06-16T20:08:37.000','497','452','2005-06-22T01:54:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1795','2005-06-16T20:09:01.000','536','56','2005-06-24T17:50:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1796','2005-06-16T20:10:43.000','3229','283','2005-06-20T19:12:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1797','2005-06-16T20:13:03.000','3435','275','2005-06-22T22:56:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1798','2005-06-16T20:16:15.000','1654','429','2005-06-20T22:23:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1799','2005-06-16T20:17:20.000','2847','505','2005-06-20T23:55:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1800','2005-06-16T20:18:46.000','2058','149','2005-06-20T17:12:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1801','2005-06-16T20:21:53.000','1015','10','2005-06-18T23:18:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1802','2005-06-16T20:23:30.000','4174','455','2005-06-21T20:02:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1803','2005-06-16T20:32:47.000','3784','127','2005-06-21T02:03:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1804','2005-06-16T20:33:15.000','1152','570','2005-06-18T02:31:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1805','2005-06-16T20:36:00.000','3962','208','2005-06-17T16:27:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1806','2005-06-16T20:41:57.000','2053','45','2005-06-18T19:25:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1807','2005-06-16T20:58:59.000','1174','338','2005-06-20T21:31:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1808','2005-06-16T20:59:35.000','2424','466','2005-06-24T15:31:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1809','2005-06-16T21:00:20.000','1071','517','2005-06-25T20:25:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1810','2005-06-16T21:06:00.000','2368','7','2005-06-21T21:24:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1811','2005-06-16T21:06:20.000','3700','235','2005-06-21T21:59:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1812','2005-06-16T21:08:46.000','751','37','2005-06-21T15:44:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1813','2005-06-16T21:11:00.000','1236','259','2005-06-24T15:30:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1814','2005-06-16T21:15:22.000','39','144','2005-06-23T17:00:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1815','2005-06-16T21:16:07.000','1551','84','2005-06-17T16:37:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1816','2005-06-16T21:20:41.000','2861','594','2005-06-18T02:21:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1817','2005-06-16T21:20:52.000','1354','574','2005-06-19T16:24:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1818','2005-06-16T21:30:34.000','1218','63','2005-06-20T03:27:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1819','2005-06-16T21:32:50.000','1689','386','2005-06-26T01:11:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1820','2005-06-16T21:34:50.000','3672','120','2005-06-20T16:50:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1821','2005-06-16T21:42:49.000','3207','468','2005-06-20T16:25:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1822','2005-06-16T21:43:45.000','674','86','2005-06-17T21:37:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1823','2005-06-16T21:48:16.000','3871','448','2005-06-22T03:09:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1824','2005-06-16T21:51:04.000','2269','575','2005-06-18T18:12:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1825','2005-06-16T21:53:05.000','2908','55','2005-06-20T17:22:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1826','2005-06-16T21:53:52.000','421','578','2005-06-25T18:46:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1827','2005-06-16T21:54:40.000','3804','423','2005-06-19T21:28:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1828','2005-06-16T22:04:34.000','316','68','2005-06-20T21:07:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1829','2005-06-16T22:14:21.000','617','293','2005-06-21T16:51:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1830','2005-06-16T22:18:43.000','4010','499','2005-06-23T21:14:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1831','2005-06-16T22:22:17.000','2610','383','2005-06-25T23:23:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1832','2005-06-16T22:35:20.000','500','220','2005-06-19T03:09:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1833','2005-06-16T22:45:03.000','1337','121','2005-06-20T22:02:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1834','2005-06-16T22:49:08.000','4018','189','2005-06-22T21:08:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1835','2005-06-16T23:05:36.000','1482','112','2005-06-19T04:46:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1836','2005-06-16T23:13:05.000','2753','176','2005-06-24T01:40:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1837','2005-06-16T23:16:15.000','1259','309','2005-06-21T21:54:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1838','2005-06-16T23:20:16.000','513','31','2005-06-20T02:34:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1839','2005-06-16T23:22:22.000','2750','223','2005-06-23T00:33:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1840','2005-06-16T23:39:34.000','340','404','2005-06-21T23:36:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1841','2005-06-16T23:44:13.000','2363','6','2005-06-22T04:09:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1842','2005-06-16T23:45:59.000','1472','426','2005-06-26T05:31:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1843','2005-06-16T23:53:42.000','2714','132','2005-06-22T18:33:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1844','2005-06-16T23:53:53.000','2307','454','2005-06-22T02:19:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1845','2005-06-16T23:56:11.000','3395','215','2005-06-19T01:41:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1846','2005-06-17T00:02:44.000','1725','422','2005-06-18T23:47:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1847','2005-06-17T00:05:22.000','1189','363','2005-06-20T21:09:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1848','2005-06-17T00:07:07.000','3797','526','2005-06-21T21:41:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1849','2005-06-17T00:13:19.000','2507','341','2005-06-23T18:37:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1850','2005-06-17T00:31:35.000','761','517','2005-06-25T05:19:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1851','2005-06-17T00:32:26.000','1121','451','2005-06-22T19:54:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1852','2005-06-17T00:38:20.000','4122','271','2005-06-22T20:04:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1853','2005-06-17T00:39:54.000','2949','301','2005-06-19T00:22:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1854','2005-06-17T00:43:57.000','119','37','2005-06-23T05:49:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1855','2005-06-17T00:54:58.000','4457','492','2005-06-20T19:29:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1856','2005-06-17T01:02:00.000','3034','161','2005-06-19T21:29:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1857','2005-06-17T01:12:58.000','4257','427','2005-06-21T04:49:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1858','2005-06-17T01:13:11.000','3200','99','2005-06-18T21:33:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1859','2005-06-17T01:13:38.000','3405','533','2005-06-18T03:13:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1860','2005-06-17T01:17:12.000','1853','293','2005-06-21T22:35:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1861','2005-06-17T01:17:31.000','135','454','2005-06-25T02:11:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1862','2005-06-17T01:29:30.000','3299','553','2005-06-25T20:43:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1863','2005-06-17T01:31:46.000','4466','550','2005-06-26T02:09:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1864','2005-06-17T01:39:47.000','1815','130','2005-06-24T19:39:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1865','2005-06-17T01:49:36.000','2657','526','2005-06-23T21:13:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1866','2005-06-17T01:53:19.000','2579','575','2005-06-19T06:14:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1867','2005-06-17T02:01:37.000','3537','415','2005-06-25T04:52:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1868','2005-06-17T02:03:22.000','2412','380','2005-06-25T04:38:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1869','2005-06-17T02:08:00.000','871','351','2005-06-19T21:43:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1870','2005-06-17T02:24:36.000','895','191','2005-06-17T23:04:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1871','2005-06-17T02:25:12.000','481','204','2005-06-23T03:16:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1872','2005-06-17T02:27:03.000','3596','206','2005-06-20T22:41:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1873','2005-06-17T02:38:28.000','2933','71','2005-06-23T04:39:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1874','2005-06-17T02:39:20.000','3884','30','2005-06-24T04:41:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1875','2005-06-17T02:45:10.000','1652','528','2005-06-22T22:54:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1876','2005-06-17T02:50:51.000','384','459','2005-06-18T07:21:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1877','2005-06-17T02:54:16.000','3404','261','2005-06-25T21:51:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1878','2005-06-17T02:55:32.000','3319','381','2005-06-21T03:44:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1879','2005-06-17T02:57:34.000','3983','343','2005-06-19T00:00:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1880','2005-06-17T03:08:59.000','1133','289','2005-06-19T07:16:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1881','2005-06-17T03:09:56.000','159','134','2005-06-18T01:49:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1882','2005-06-17T03:17:21.000','1400','47','2005-06-19T22:23:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1883','2005-06-17T03:18:51.000','3504','550','2005-06-18T05:46:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1884','2005-06-17T03:19:20.000','4567','305','2005-06-21T00:19:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1885','2005-06-17T03:35:59.000','740','588','2005-06-21T05:57:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1886','2005-06-17T03:36:02.000','2367','505','2005-06-19T08:12:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1887','2005-06-17T03:53:18.000','3591','32','2005-06-25T07:37:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1888','2005-06-17T03:58:36.000','2872','405','2005-06-22T09:28:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1889','2005-06-17T04:05:12.000','3909','572','2005-06-26T04:13:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1890','2005-06-17T04:06:13.000','1764','447','2005-06-22T07:46:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1891','2005-06-17T04:16:44.000','3576','109','2005-06-24T07:20:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1892','2005-06-17T04:17:33.000','139','319','2005-06-20T00:06:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1893','2005-06-17T04:18:37.000','3346','390','2005-06-23T23:35:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1894','2005-06-17T04:18:48.000','3707','204','2005-06-26T00:07:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1895','2005-06-17T04:25:12.000','680','30','2005-06-26T08:44:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1896','2005-06-17T04:25:46.000','2077','270','2005-06-26T09:37:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1897','2005-06-17T04:26:23.000','4142','422','2005-06-25T09:32:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1898','2005-06-17T04:28:11.000','2873','143','2005-06-25T07:04:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1899','2005-06-17T04:29:15.000','858','200','2005-06-26T08:39:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1900','2005-06-17T04:29:58.000','1425','34','2005-06-21T05:58:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1901','2005-06-17T04:35:19.000','2469','292','2005-06-25T06:09:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1902','2005-06-17T04:35:52.000','2905','479','2005-06-20T06:52:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1903','2005-06-17T04:37:20.000','1939','588','2005-06-26T09:05:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1904','2005-06-17T04:45:41.000','2472','87','2005-06-17T23:56:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1905','2005-06-17T04:51:43.000','1043','39','2005-06-24T09:35:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1906','2005-06-17T04:53:35.000','1049','455','2005-06-21T01:16:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1907','2005-06-17T05:08:27.000','988','66','2005-06-23T09:13:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1908','2005-06-17T05:10:36.000','399','358','2005-06-19T03:52:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1909','2005-06-17T05:11:04.000','2599','269','2005-06-19T04:33:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1910','2005-06-17T05:11:27.000','3903','199','2005-06-23T23:16:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1911','2005-06-17T05:15:15.000','910','3','2005-06-24T11:05:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1912','2005-06-17T05:18:32.000','4136','538','2005-06-20T10:01:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1913','2005-06-17T05:19:47.000','1825','116','2005-06-21T03:39:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1914','2005-06-17T05:25:54.000','3406','450','2005-06-24T04:25:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1915','2005-06-17T05:28:28.000','2620','393','2005-06-21T07:12:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1916','2005-06-17T05:29:59.000','4428','429','2005-06-26T05:35:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1917','2005-06-17T05:36:07.000','2667','400','2005-06-24T01:44:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1918','2005-06-17T05:40:14.000','3749','310','2005-06-21T08:53:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1919','2005-06-17T05:40:52.000','3855','197','2005-06-23T05:58:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1920','2005-06-17T06:00:23.000','2199','75','2005-06-24T04:49:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1921','2005-06-17T06:04:16.000','4369','417','2005-06-23T05:26:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1922','2005-06-17T06:04:25.000','2484','343','2005-06-18T09:15:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1923','2005-06-17T06:06:10.000','691','400','2005-06-24T04:29:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1924','2005-06-17T06:13:34.000','2577','86','2005-06-18T01:51:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1925','2005-06-17T06:16:47.000','3995','510','2005-06-21T06:03:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1926','2005-06-17T06:24:30.000','3509','462','2005-06-25T03:39:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1927','2005-06-17T06:48:19.000','3304','188','2005-06-21T03:23:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1928','2005-06-17T06:48:31.000','3454','353','2005-06-26T08:17:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1929','2005-06-17T06:49:30.000','573','327','2005-06-22T12:07:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1930','2005-06-17T06:50:46.000','79','112','2005-06-19T08:51:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1931','2005-06-17T06:51:56.000','1411','391','2005-06-22T08:27:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1932','2005-06-17T06:54:41.000','3185','120','2005-06-19T05:12:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1933','2005-06-17T06:54:42.000','980','13','2005-06-26T02:00:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1934','2005-06-17T07:04:57.000','4000','16','2005-06-25T12:21:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1935','2005-06-17T07:14:15.000','1962','295','2005-06-20T05:59:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1936','2005-06-17T07:15:41.000','3037','213','2005-06-18T11:37:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1937','2005-06-17T07:16:46.000','1266','385','2005-06-21T04:22:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1938','2005-06-17T07:18:36.000','570','454','2005-06-19T01:43:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1939','2005-06-17T07:26:45.000','605','11','2005-06-25T13:06:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1940','2005-06-17T07:42:22.000','105','451','2005-06-22T11:59:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1941','2005-06-17T07:42:45.000','1063','519','2005-06-20T07:12:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1942','2005-06-17T07:43:39.000','261','143','2005-06-25T02:24:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1943','2005-06-17T07:49:17.000','4327','144','2005-06-20T03:47:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1944','2005-06-17T07:50:53.000','318','16','2005-06-23T02:52:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1945','2005-06-17T07:51:26.000','3366','207','2005-06-23T13:22:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1946','2005-06-17T07:58:39.000','2335','389','2005-06-25T06:49:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1947','2005-06-17T08:02:20.000','3344','479','2005-06-25T10:25:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1948','2005-06-17T08:06:53.000','46','89','2005-06-21T05:00:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1949','2005-06-17T08:19:22.000','1478','208','2005-06-25T08:43:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1950','2005-06-17T08:26:52.000','723','594','2005-06-22T08:08:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1951','2005-06-17T08:30:35.000','955','123','2005-06-20T10:43:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1952','2005-06-17T08:33:02.000','1823','338','2005-06-21T14:00:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1953','2005-06-17T08:34:57.000','3549','405','2005-06-24T09:38:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1954','2005-06-17T08:37:55.000','3203','533','2005-06-20T02:55:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1955','2005-06-17T08:40:22.000','811','311','2005-06-19T10:47:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1956','2005-06-17T08:43:32.000','1403','492','2005-06-21T11:08:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1957','2005-06-17T08:50:58.000','2496','68','2005-06-26T13:39:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1958','2005-06-17T08:52:01.000','1843','581','2005-06-23T07:55:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1959','2005-06-17T08:54:10.000','1464','554','2005-06-20T05:02:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1960','2005-06-17T08:59:57.000','2202','27','2005-06-23T14:38:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1961','2005-06-17T09:02:58.000','2851','384','2005-06-20T03:07:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1962','2005-06-17T09:08:58.000','4386','536','2005-06-23T14:55:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1963','2005-06-17T09:09:31.000','1943','154','2005-06-24T13:16:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1964','2005-06-17T09:10:09.000','3390','53','2005-06-21T15:08:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1965','2005-06-17T09:17:39.000','480','256','2005-06-18T12:35:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1966','2005-06-17T09:19:45.000','2085','6','2005-06-20T11:19:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1967','2005-06-17T09:19:52.000','3225','558','2005-06-21T03:35:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1968','2005-06-17T09:20:36.000','1139','246','2005-06-18T11:06:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1969','2005-06-17T09:22:22.000','4450','337','2005-06-21T05:31:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1970','2005-06-17T09:23:16.000','1358','303','2005-06-22T09:40:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1971','2005-06-17T09:23:59.000','2870','357','2005-06-25T13:20:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1972','2005-06-17T09:25:49.000','2758','526','2005-06-24T09:59:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1973','2005-06-17T09:26:15.000','3669','256','2005-06-21T10:18:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1974','2005-06-17T09:30:05.000','1979','111','2005-06-21T12:10:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1975','2005-06-17T09:32:10.000','2520','468','2005-06-23T03:50:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1976','2005-06-17T09:38:08.000','3631','184','2005-06-23T07:23:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1977','2005-06-17T09:38:22.000','2468','459','2005-06-23T14:19:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1978','2005-06-17T09:42:34.000','1590','278','2005-06-20T09:13:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1979','2005-06-17T09:45:30.000','3470','45','2005-06-20T10:52:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1980','2005-06-17T09:48:05.000','2985','328','2005-06-23T14:43:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1981','2005-06-17T10:03:34.000','3186','526','2005-06-20T13:14:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1982','2005-06-17T10:12:15.000','1091','566','2005-06-20T13:56:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1983','2005-06-17T10:22:13.000','1955','365','2005-06-24T05:04:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1984','2005-06-17T10:25:28.000','3417','380','2005-06-23T08:18:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1985','2005-06-17T10:31:37.000','87','411','2005-06-22T11:17:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1986','2005-06-17T10:34:59.000','2894','541','2005-06-24T04:57:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1987','2005-06-17T10:40:36.000','110','479','2005-06-23T14:23:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1988','2005-06-17T10:42:34.000','3054','261','2005-06-25T11:47:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1989','2005-06-17T10:47:24.000','634','35','2005-06-19T05:12:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1990','2005-06-17T10:48:44.000','1471','571','2005-06-24T08:11:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1991','2005-06-17T10:49:23.000','3963','105','2005-06-25T10:48:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1992','2005-06-17T10:58:53.000','636','233','2005-06-19T08:42:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1993','2005-06-17T10:59:24.000','168','234','2005-06-23T07:30:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1994','2005-06-17T11:07:06.000','2203','346','2005-06-25T08:32:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1995','2005-06-17T11:11:14.000','1866','10','2005-06-26T16:37:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1996','2005-06-17T11:17:45.000','3074','149','2005-06-26T09:42:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1997','2005-06-17T11:19:43.000','846','411','2005-06-19T14:18:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1998','2005-06-17T11:24:57.000','4365','562','2005-06-26T09:48:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('1999','2005-06-17T11:30:08.000','3704','111','2005-06-23T08:36:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2000','2005-06-17T11:32:30.000','323','163','2005-06-22T13:37:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2001','2005-06-17T11:35:09.000','2069','260','2005-06-21T14:52:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2002','2005-06-17T11:39:58.000','2406','514','2005-06-24T15:41:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2003','2005-06-17T11:40:35.000','1581','515','2005-06-19T08:30:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2004','2005-06-17T11:43:38.000','1342','171','2005-06-24T08:05:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2005','2005-06-17T11:44:54.000','4177','234','2005-06-19T10:53:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2006','2005-06-17T11:47:03.000','992','215','2005-06-19T13:47:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2007','2005-06-17T11:47:17.000','1123','572','2005-06-21T07:19:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2008','2005-06-17T11:48:05.000','2081','570','2005-06-25T13:16:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2009','2005-06-17T11:48:31.000','1902','119','2005-06-18T09:34:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2010','2005-06-17T11:54:15.000','2845','329','2005-06-21T05:55:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2011','2005-06-17T11:56:09.000','734','350','2005-06-24T06:47:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2012','2005-06-17T11:57:15.000','3588','84','2005-06-24T17:18:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2013','2005-06-17T12:03:01.000','3256','165','2005-06-24T10:04:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2014','2005-06-17T12:03:28.000','2969','337','2005-06-25T16:00:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2015','2005-06-17T12:16:29.000','3776','484','2005-06-18T14:40:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2016','2005-06-17T12:18:36.000','4265','282','2005-06-20T12:13:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2017','2005-06-17T12:33:30.000','1434','516','2005-06-19T10:08:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2018','2005-06-17T12:35:58.000','1278','380','2005-06-26T13:16:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2019','2005-06-17T12:38:44.000','2314','528','2005-06-23T17:38:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2020','2005-06-17T12:39:50.000','1914','384','2005-06-19T14:59:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2021','2005-06-17T12:41:18.000','2852','319','2005-06-23T17:17:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2022','2005-06-17T12:44:39.000','3053','547','2005-06-25T12:32:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2023','2005-06-17T12:52:58.000','787','169','2005-06-23T11:07:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2024','2005-06-17T13:00:51.000','2566','329','2005-06-22T07:03:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2025','2005-06-17T13:04:00.000','1203','447','2005-06-18T18:45:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2026','2005-06-17T13:05:38.000','3681','491','2005-06-21T17:19:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2027','2005-06-17T13:06:56.000','4309','265','2005-06-23T13:46:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2028','2005-06-17T13:08:08.000','4451','155','2005-06-23T10:54:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2029','2005-06-17T13:10:59.000','914','512','2005-06-19T18:15:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2030','2005-06-17T13:13:27.000','4024','457','2005-06-19T10:44:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2031','2005-06-17T13:14:03.000','4275','570','2005-06-25T10:06:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2032','2005-06-17T13:24:07.000','425','316','2005-06-18T18:18:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2033','2005-06-17T13:24:43.000','58','90','2005-06-20T12:34:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2034','2005-06-17T13:27:16.000','1512','587','2005-06-22T08:53:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2035','2005-06-17T13:45:09.000','4371','158','2005-06-26T15:30:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2036','2005-06-17T13:46:52.000','100','486','2005-06-18T15:42:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2037','2005-06-17T13:54:20.000','2582','308','2005-06-20T14:49:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2038','2005-06-17T14:00:51.000','4231','138','2005-06-19T11:54:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2039','2005-06-17T14:03:43.000','1514','304','2005-06-24T09:21:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2040','2005-06-17T14:18:37.000','227','260','2005-06-22T19:08:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2041','2005-06-17T14:19:00.000','782','348','2005-06-26T08:38:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2042','2005-06-17T14:31:02.000','3102','84','2005-06-18T14:43:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2043','2005-06-17T14:31:12.000','2495','4','2005-06-19T11:04:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2044','2005-06-17T14:37:57.000','2418','484','2005-06-22T17:15:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2045','2005-06-17T14:38:11.000','561','391','2005-06-26T13:44:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2046','2005-06-17T14:39:50.000','872','374','2005-06-24T16:02:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2047','2005-06-17T14:40:58.000','2371','201','2005-06-21T08:52:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2048','2005-06-17T14:55:29.000','2055','454','2005-06-23T16:29:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2049','2005-06-17T14:58:36.000','1053','182','2005-06-22T14:53:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2050','2005-06-17T15:07:30.000','1963','549','2005-06-18T14:43:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2051','2005-06-17T15:10:16.000','2366','191','2005-06-19T20:45:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2052','2005-06-17T15:14:43.000','1686','172','2005-06-21T11:08:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2053','2005-06-17T15:19:34.000','4279','521','2005-06-19T10:06:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2054','2005-06-17T15:26:37.000','1588','295','2005-06-26T14:22:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2055','2005-06-17T15:27:03.000','1399','593','2005-06-25T13:44:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2056','2005-06-17T15:27:33.000','229','42','2005-06-20T13:04:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2057','2005-06-17T15:31:58.000','2803','190','2005-06-25T09:39:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2058','2005-06-17T15:34:41.000','1324','57','2005-06-25T14:50:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2059','2005-06-17T15:36:12.000','739','114','2005-06-18T19:01:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2060','2005-06-17T15:42:42.000','1523','64','2005-06-22T16:39:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2061','2005-06-17T15:47:00.000','4575','108','2005-06-24T16:36:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2062','2005-06-17T15:56:43.000','1749','55','2005-06-20T21:37:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2063','2005-06-17T15:56:53.000','4323','5','2005-06-21T14:19:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2064','2005-06-17T15:57:56.000','1970','67','2005-06-23T21:04:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2065','2005-06-17T16:03:46.000','844','266','2005-06-22T16:41:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2066','2005-06-17T16:07:08.000','2561','248','2005-06-24T15:20:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2067','2005-06-17T16:11:08.000','1711','297','2005-06-22T13:01:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2068','2005-06-17T16:11:46.000','4252','387','2005-06-20T11:28:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2069','2005-06-17T16:19:39.000','2746','551','2005-06-26T16:48:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2070','2005-06-17T16:27:51.000','2609','24','2005-06-20T20:46:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2071','2005-06-17T16:33:17.000','2867','479','2005-06-23T21:51:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2072','2005-06-17T16:33:32.000','86','261','2005-06-23T13:22:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2073','2005-06-17T16:33:59.000','3530','410','2005-06-19T11:57:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2074','2005-06-17T16:40:03.000','71','495','2005-06-20T21:34:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2075','2005-06-17T16:40:33.000','2415','459','2005-06-19T13:55:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2076','2005-06-17T16:43:47.000','2242','217','2005-06-24T11:12:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2077','2005-06-17T16:46:11.000','4478','113','2005-06-19T15:10:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2078','2005-06-17T16:48:55.000','2021','278','2005-06-19T18:01:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2079','2005-06-17T16:49:45.000','3853','465','2005-06-18T18:10:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2080','2005-06-17T16:59:40.000','1231','476','2005-06-21T11:28:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2081','2005-06-17T17:05:02.000','917','253','2005-06-26T20:26:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2082','2005-06-17T17:13:32.000','434','254','2005-06-19T16:16:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2083','2005-06-17T17:14:00.000','2423','97','2005-06-18T18:31:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2084','2005-06-17T17:17:19.000','428','92','2005-06-22T14:57:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2085','2005-06-17T17:30:56.000','2275','214','2005-06-23T12:13:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2086','2005-06-17T17:32:07.000','898','326','2005-06-21T20:19:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2087','2005-06-17T17:35:10.000','466','398','2005-06-26T13:52:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2088','2005-06-17T17:35:30.000','506','310','2005-06-23T20:13:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2089','2005-06-17T17:45:09.000','4030','156','2005-06-25T16:41:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2090','2005-06-17T18:06:14.000','17','197','2005-06-22T23:52:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2091','2005-06-17T18:09:04.000','4033','260','2005-06-26T12:11:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2092','2005-06-17T18:12:16.000','4427','556','2005-06-25T15:06:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2093','2005-06-17T18:14:08.000','814','26','2005-06-26T18:10:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2094','2005-06-17T18:18:56.000','2205','308','2005-06-18T19:36:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2095','2005-06-17T18:21:35.000','1907','8','2005-06-23T23:49:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2096','2005-06-17T18:33:04.000','1069','431','2005-06-21T17:29:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2097','2005-06-17T18:40:04.000','569','439','2005-06-23T13:49:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2098','2005-06-17T18:42:09.000','3951','274','2005-06-19T20:40:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2099','2005-06-17T18:47:26.000','3660','146','2005-06-24T22:31:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2100','2005-06-17T18:53:21.000','2267','387','2005-06-19T21:49:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2101','2005-06-17T18:57:02.000','2137','581','2005-06-20T15:38:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2102','2005-06-17T19:05:22.000','2316','486','2005-06-23T23:21:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2103','2005-06-17T19:13:10.000','1469','456','2005-06-21T21:32:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2104','2005-06-17T19:14:30.000','3084','136','2005-06-19T16:26:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2105','2005-06-17T19:15:45.000','4090','57','2005-06-20T16:00:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2106','2005-06-17T19:29:03.000','643','66','2005-06-23T18:17:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2107','2005-06-17T19:31:16.000','1270','104','2005-06-18T23:33:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2108','2005-06-17T19:35:26.000','1395','503','2005-06-25T15:45:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2109','2005-06-17T19:41:42.000','2292','493','2005-06-25T17:03:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2110','2005-06-17T19:45:49.000','3592','163','2005-06-26T18:59:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2111','2005-06-17T19:47:21.000','2108','76','2005-06-19T22:46:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2112','2005-06-17T19:52:42.000','1629','18','2005-06-25T00:00:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2113','2005-06-17T19:57:46.000','1509','406','2005-06-24T00:22:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2114','2005-06-17T20:00:25.000','3541','358','2005-06-23T18:51:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2115','2005-06-17T20:02:16.000','3448','270','2005-06-25T16:56:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2116','2005-06-17T20:16:12.000','2373','24','2005-06-18T17:03:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2117','2005-06-17T20:24:00.000','2','170','2005-06-23T17:45:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2118','2005-06-17T20:28:29.000','1261','103','2005-06-23T22:47:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2119','2005-06-17T20:34:42.000','2104','561','2005-06-22T00:05:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2120','2005-06-17T20:36:50.000','1498','182','2005-06-27T01:18:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2121','2005-06-17T20:38:54.000','141','467','2005-06-22T23:06:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2122','2005-06-17T20:48:27.000','2932','245','2005-06-23T00:58:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2123','2005-06-17T20:48:30.000','2497','545','2005-06-18T19:17:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2124','2005-06-17T20:49:14.000','1273','178','2005-06-23T17:44:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2125','2005-06-17T20:53:42.000','4303','473','2005-06-19T01:53:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2126','2005-06-17T20:54:36.000','4276','263','2005-06-27T02:16:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2127','2005-06-17T20:54:48.000','3757','187','2005-06-18T16:28:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2128','2005-06-17T20:54:58.000','352','2','2005-06-24T00:41:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2129','2005-06-17T20:58:32.000','1930','249','2005-06-23T22:22:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2130','2005-06-17T21:00:44.000','1369','413','2005-06-26T00:05:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2131','2005-06-17T21:02:25.000','4424','85','2005-06-25T18:45:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2132','2005-06-17T21:05:06.000','2636','186','2005-06-20T18:10:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2133','2005-06-17T21:10:05.000','932','268','2005-06-23T22:41:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2134','2005-06-17T21:13:44.000','1699','378','2005-06-26T16:28:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2135','2005-06-17T21:14:02.000','4091','39','2005-06-19T00:59:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2136','2005-06-17T21:16:41.000','2651','20','2005-06-24T22:42:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2137','2005-06-17T21:18:28.000','1158','581','2005-06-20T21:05:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2138','2005-06-17T21:28:14.000','512','254','2005-06-22T01:16:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2139','2005-06-17T21:29:34.000','807','236','2005-06-26T21:05:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2140','2005-06-17T21:40:29.000','2395','56','2005-06-19T00:42:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2141','2005-06-17T21:41:34.000','2176','86','2005-06-19T00:15:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2142','2005-06-17T21:55:43.000','1787','253','2005-06-26T19:41:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2143','2005-06-17T21:58:13.000','1257','507','2005-06-19T23:59:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2144','2005-06-17T22:05:40.000','3303','46','2005-06-21T02:53:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2145','2005-06-17T22:10:36.000','238','388','2005-06-18T21:07:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2146','2005-06-17T22:26:23.000','326','456','2005-06-26T17:10:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2147','2005-06-17T22:28:13.000','2752','279','2005-06-22T20:50:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2148','2005-06-17T22:44:35.000','315','338','2005-06-26T19:43:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2149','2005-06-17T22:50:00.000','3365','333','2005-06-26T18:40:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2150','2005-06-17T22:50:36.000','1910','406','2005-06-21T19:33:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2151','2005-06-17T22:52:37.000','407','329','2005-06-20T22:00:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2152','2005-06-17T22:53:27.000','2665','307','2005-06-23T19:19:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2153','2005-06-17T22:58:04.000','2440','357','2005-06-24T19:38:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2154','2005-06-17T22:59:42.000','1655','30','2005-06-24T04:11:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2155','2005-06-17T23:07:29.000','3640','227','2005-06-25T03:23:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2156','2005-06-17T23:08:12.000','623','237','2005-06-22T19:44:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2157','2005-06-17T23:30:52.000','1619','201','2005-06-24T01:56:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2158','2005-06-17T23:36:27.000','243','530','2005-06-19T19:25:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2159','2005-06-17T23:37:29.000','3095','465','2005-06-25T00:18:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2160','2005-06-17T23:39:11.000','1644','32','2005-06-22T20:04:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2161','2005-06-17T23:39:50.000','3149','75','2005-06-26T23:28:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2162','2005-06-17T23:45:47.000','1790','277','2005-06-21T21:03:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2163','2005-06-17T23:46:16.000','2600','130','2005-06-22T22:48:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2164','2005-06-17T23:46:21.000','3442','227','2005-06-24T19:10:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2165','2005-06-17T23:51:10.000','2392','471','2005-06-21T23:54:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2166','2005-06-17T23:51:21.000','4343','305','2005-06-27T01:06:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2167','2005-06-17T23:51:28.000','3796','307','2005-06-21T00:43:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2168','2005-06-17T23:53:24.000','802','308','2005-06-20T01:11:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2169','2005-06-17T23:57:23.000','785','120','2005-06-19T20:14:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2170','2005-06-17T23:57:34.000','3989','42','2005-06-22T03:37:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2171','2005-06-18T00:06:04.000','1768','147','2005-06-24T18:09:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2172','2005-06-18T00:06:16.000','2912','457','2005-06-26T00:50:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2173','2005-06-18T00:08:20.000','995','65','2005-06-25T05:30:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2174','2005-06-18T00:09:01.000','3279','520','2005-06-25T23:14:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2175','2005-06-18T00:17:58.000','4038','17','2005-06-22T23:18:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2176','2005-06-18T00:29:51.000','4201','282','2005-06-21T01:41:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2177','2005-06-18T00:34:45.000','492','340','2005-06-26T18:40:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2178','2005-06-18T00:38:35.000','2950','260','2005-06-21T02:56:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2179','2005-06-18T00:41:36.000','4334','338','2005-06-19T02:17:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2180','2005-06-18T00:47:43.000','3564','497','2005-06-25T04:12:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2181','2005-06-18T00:48:31.000','3481','176','2005-06-25T06:43:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2182','2005-06-18T00:56:18.000','3494','454','2005-06-26T20:01:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2183','2005-06-18T01:06:01.000','1776','340','2005-06-22T01:20:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2184','2005-06-18T01:10:36.000','3468','537','2005-06-21T05:59:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2185','2005-06-18T01:12:22.000','4326','198','2005-06-20T20:41:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2186','2005-06-18T01:15:27.000','2050','204','2005-06-21T06:16:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2187','2005-06-18T01:17:27.000','1385','477','2005-06-20T22:18:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2188','2005-06-18T01:19:04.000','712','183','2005-06-25T03:59:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2189','2005-06-18T01:20:26.000','249','500','2005-06-25T00:30:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2190','2005-06-18T01:29:51.000','4398','342','2005-06-26T04:31:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2191','2005-06-18T01:33:09.000','3369','58','2005-06-19T20:18:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2192','2005-06-18T01:35:47.000','1886','456','2005-06-23T23:38:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2193','2005-06-18T01:38:45.000','1013','112','2005-06-22T19:51:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2194','2005-06-18T01:41:37.000','1827','149','2005-06-25T04:27:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2195','2005-06-18T01:44:46.000','2247','286','2005-06-25T20:50:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2196','2005-06-18T01:47:07.000','1925','240','2005-06-26T03:18:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2197','2005-06-18T01:50:27.000','3350','103','2005-06-19T01:31:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2198','2005-06-18T01:51:22.000','1983','109','2005-06-26T06:57:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2199','2005-06-18T01:57:56.000','99','171','2005-06-23T20:34:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2200','2005-06-18T01:59:16.000','1085','229','2005-06-26T23:25:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2201','2005-06-18T02:08:27.000','1864','489','2005-06-23T01:40:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2202','2005-06-18T02:09:24.000','815','297','2005-06-26T07:17:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2203','2005-06-18T02:10:42.000','1347','46','2005-06-22T06:25:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2204','2005-06-18T02:11:38.000','1137','426','2005-06-24T00:28:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2205','2005-06-18T02:14:34.000','1245','593','2005-06-25T05:11:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2206','2005-06-18T02:14:45.000','3651','438','2005-06-24T23:20:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2207','2005-06-18T02:19:21.000','182','78','2005-06-24T02:25:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2208','2005-06-18T02:22:07.000','2345','132','2005-06-23T07:24:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2209','2005-06-18T02:24:01.000','2441','13','2005-06-22T04:13:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2210','2005-06-18T02:27:01.000','219','108','2005-06-21T00:45:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2211','2005-06-18T02:29:10.000','4114','166','2005-06-22T02:02:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2212','2005-06-18T02:36:10.000','2458','336','2005-06-19T21:21:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2213','2005-06-18T02:36:47.000','949','98','2005-06-23T05:02:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2214','2005-06-18T02:44:37.000','2430','366','2005-06-18T23:37:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2215','2005-06-18T02:48:21.000','2060','239','2005-06-22T01:03:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2216','2005-06-18T03:08:17.000','1428','320','2005-06-19T08:13:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2217','2005-06-18T03:12:29.000','2260','118','2005-06-20T06:08:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2218','2005-06-18T03:13:13.000','3577','176','2005-06-18T21:16:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2219','2005-06-18T03:16:54.000','1881','393','2005-06-22T01:29:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2220','2005-06-18T03:21:36.000','320','587','2005-06-21T07:45:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2221','2005-06-18T03:24:56.000','3905','156','2005-06-22T08:27:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2222','2005-06-18T03:26:23.000','3834','10','2005-06-26T08:50:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2223','2005-06-18T03:27:03.000','4068','303','2005-06-27T09:19:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2224','2005-06-18T03:33:58.000','1336','153','2005-06-18T22:10:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2225','2005-06-18T03:35:40.000','2829','503','2005-06-23T03:05:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2226','2005-06-18T03:39:56.000','3487','225','2005-06-24T07:26:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2227','2005-06-18T03:43:23.000','3623','200','2005-06-19T05:55:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2228','2005-06-18T03:44:50.000','490','383','2005-06-23T00:28:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2229','2005-06-18T03:50:18.000','2840','35','2005-06-26T07:16:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2230','2005-06-18T03:50:49.000','833','256','2005-06-25T01:12:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2231','2005-06-18T03:52:14.000','2280','35','2005-06-23T06:52:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2232','2005-06-18T03:54:31.000','2463','52','2005-06-22T07:29:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2233','2005-06-18T03:57:36.000','3063','31','2005-06-21T09:42:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2234','2005-06-18T04:01:28.000','234','182','2005-06-24T04:55:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2235','2005-06-18T04:08:50.000','3463','21','2005-06-27T07:58:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2236','2005-06-18T04:12:33.000','4001','375','2005-06-23T04:07:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2237','2005-06-18T04:17:44.000','1821','205','2005-06-27T09:08:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2238','2005-06-18T04:22:06.000','2859','251','2005-06-27T03:29:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2239','2005-06-18T04:23:54.000','4419','437','2005-06-26T00:12:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2240','2005-06-18T04:28:27.000','1409','122','2005-06-22T07:48:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2241','2005-06-18T04:31:41.000','921','406','2005-06-24T22:34:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2242','2005-06-18T04:32:28.000','1995','146','2005-06-24T03:26:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2243','2005-06-18T04:33:03.000','1254','328','2005-06-23T04:14:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2244','2005-06-18T04:46:33.000','3629','233','2005-06-20T04:28:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2245','2005-06-18T04:52:59.000','1496','194','2005-06-24T05:07:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2246','2005-06-18T04:54:29.000','4287','414','2005-06-22T09:14:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2248','2005-06-18T04:59:48.000','1999','446','2005-06-19T08:51:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2249','2005-06-18T05:03:08.000','117','285','2005-06-26T05:43:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2250','2005-06-18T05:03:36.000','4042','7','2005-06-22T02:25:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2251','2005-06-18T05:05:08.000','1458','143','2005-06-23T08:34:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2252','2005-06-18T05:05:18.000','1987','383','2005-06-21T08:19:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2253','2005-06-18T05:11:43.000','3719','122','2005-06-25T03:30:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2254','2005-06-18T05:15:14.000','1084','281','2005-06-27T04:10:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2255','2005-06-18T05:21:12.000','24','410','2005-06-26T09:19:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2256','2005-06-18T05:21:56.000','1863','93','2005-06-27T02:06:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2257','2005-06-18T05:29:52.000','2846','34','2005-06-22T00:19:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2258','2005-06-18T05:30:36.000','4573','292','2005-06-24T09:09:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2259','2005-06-18T05:37:45.000','4103','491','2005-06-21T01:51:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2260','2005-06-18T05:38:36.000','2773','297','2005-06-20T08:08:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2261','2005-06-18T05:46:15.000','1763','570','2005-06-24T05:06:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2262','2005-06-18T05:49:46.000','4172','218','2005-06-20T00:25:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2263','2005-06-18T05:57:47.000','3259','452','2005-06-20T06:13:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2264','2005-06-18T05:58:45.000','150','240','2005-06-19T00:57:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2265','2005-06-18T06:03:27.000','3069','267','2005-06-20T01:16:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2266','2005-06-18T06:05:02.000','2596','452','2005-06-20T06:54:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2267','2005-06-18T06:10:23.000','2086','218','2005-06-20T00:39:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2268','2005-06-18T06:13:41.000','4380','21','2005-06-22T08:53:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2269','2005-06-18T06:20:54.000','3088','431','2005-06-25T04:51:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2270','2005-06-18T06:29:01.000','3447','588','2005-06-26T07:21:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2271','2005-06-18T06:29:52.000','2416','145','2005-06-21T09:46:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2272','2005-06-18T06:29:53.000','1364','599','2005-06-23T10:58:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2273','2005-06-18T06:30:02.000','4456','327','2005-06-20T07:07:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2274','2005-06-18T06:31:15.000','3021','347','2005-06-21T01:24:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2275','2005-06-18T06:31:29.000','2805','354','2005-06-24T10:04:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2276','2005-06-18T06:33:48.000','1145','594','2005-06-25T00:50:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2277','2005-06-18T06:35:03.000','3770','224','2005-06-19T01:26:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2278','2005-06-18T06:37:57.000','1166','450','2005-06-22T10:57:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2279','2005-06-18T06:38:22.000','1953','554','2005-06-27T07:16:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2280','2005-06-18T06:46:54.000','4568','548','2005-06-26T09:48:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2281','2005-06-18T06:47:29.000','4212','431','2005-06-20T10:27:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2282','2005-06-18T06:48:23.000','4388','113','2005-06-24T11:04:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2283','2005-06-18T06:56:06.000','2056','507','2005-06-19T05:11:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2284','2005-06-18T06:59:51.000','2682','228','2005-06-24T04:58:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2285','2005-06-18T07:00:54.000','755','447','2005-06-25T08:58:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2286','2005-06-18T07:02:32.000','618','287','2005-06-27T12:33:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2287','2005-06-18T07:04:36.000','1473','317','2005-06-27T03:00:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2288','2005-06-18T07:23:17.000','877','247','2005-06-26T07:44:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2289','2005-06-18T07:29:43.000','2030','392','2005-06-24T11:16:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2290','2005-06-18T07:34:37.000','200','513','2005-06-26T11:45:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2291','2005-06-18T07:36:46.000','3949','436','2005-06-26T04:57:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2292','2005-06-18T07:37:48.000','173','130','2005-06-20T02:45:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2293','2005-06-18T07:45:03.000','3209','178','2005-06-24T08:12:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2294','2005-06-18T07:46:34.000','2096','72','2005-06-22T12:34:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2295','2005-06-18T07:56:18.000','3250','106','2005-06-21T07:10:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2296','2005-06-18T08:10:42.000','4558','481','2005-06-20T12:26:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2297','2005-06-18T08:17:41.000','2262','111','2005-06-26T05:08:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2298','2005-06-18T08:18:29.000','1227','497','2005-06-24T11:51:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2299','2005-06-18T08:18:52.000','4339','28','2005-06-26T11:48:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2300','2005-06-18T08:22:34.000','1617','291','2005-06-24T04:51:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2301','2005-06-18T08:24:03.000','869','273','2005-06-25T10:31:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2302','2005-06-18T08:27:33.000','1852','42','2005-06-22T02:46:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2303','2005-06-18T08:27:59.000','1524','329','2005-06-22T10:58:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2304','2005-06-18T08:30:15.000','3543','327','2005-06-23T06:17:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2305','2005-06-18T08:31:18.000','622','149','2005-06-24T06:18:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2306','2005-06-18T08:33:23.000','208','477','2005-06-27T10:01:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2307','2005-06-18T08:34:59.000','4576','47','2005-06-23T04:42:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2308','2005-06-18T08:41:48.000','197','1','2005-06-22T03:36:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2309','2005-06-18T08:43:24.000','611','576','2005-06-20T03:56:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2310','2005-06-18T08:45:59.000','2590','409','2005-06-26T05:06:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2311','2005-06-18T08:51:29.000','4506','236','2005-06-25T07:51:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2312','2005-06-18T08:55:46.000','402','184','2005-06-24T04:34:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2313','2005-06-18T08:56:45.000','3134','379','2005-06-26T10:30:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2314','2005-06-18T09:03:19.000','2157','160','2005-06-19T12:14:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2315','2005-06-18T09:03:39.000','2766','372','2005-06-22T11:18:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2316','2005-06-18T09:04:59.000','372','289','2005-06-20T09:39:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2317','2005-06-18T09:12:18.000','1602','326','2005-06-21T05:50:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2318','2005-06-18T09:13:54.000','2328','383','2005-06-23T07:19:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2319','2005-06-18T09:24:22.000','1521','393','2005-06-26T14:12:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2320','2005-06-18T09:24:50.000','597','552','2005-06-24T07:59:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2321','2005-06-18T09:42:42.000','1160','565','2005-06-25T14:28:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2322','2005-06-18T09:44:21.000','1893','213','2005-06-25T09:29:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2323','2005-06-18T09:55:02.000','207','54','2005-06-23T07:19:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2324','2005-06-18T10:00:33.000','2987','268','2005-06-23T14:10:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2325','2005-06-18T10:08:07.000','752','406','2005-06-21T15:07:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2326','2005-06-18T10:14:22.000','3829','174','2005-06-24T07:01:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2327','2005-06-18T10:16:40.000','1351','571','2005-06-20T15:06:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2328','2005-06-18T10:17:21.000','2304','441','2005-06-21T04:18:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2329','2005-06-18T10:22:52.000','4156','587','2005-06-20T12:03:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2330','2005-06-18T10:41:19.000','4285','390','2005-06-25T10:48:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2331','2005-06-18T10:50:09.000','1546','221','2005-06-25T14:30:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2332','2005-06-18T10:53:51.000','2152','140','2005-06-24T12:06:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2333','2005-06-18T10:55:54.000','2323','283','2005-06-25T07:09:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2334','2005-06-18T10:56:24.000','3076','223','2005-06-22T10:38:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2335','2005-06-18T10:59:36.000','3968','446','2005-06-26T06:42:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2336','2005-06-18T11:00:05.000','3888','124','2005-06-25T06:02:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2337','2005-06-18T11:15:27.000','4522','582','2005-06-26T06:59:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2338','2005-06-18T11:24:54.000','3165','316','2005-06-19T07:34:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2339','2005-06-18T11:29:22.000','313','297','2005-06-21T10:29:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2340','2005-06-18T11:30:56.000','1913','157','2005-06-23T06:00:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2341','2005-06-18T11:35:30.000','638','31','2005-06-27T11:56:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2342','2005-06-18T11:42:40.000','2169','146','2005-06-20T14:40:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2343','2005-06-18T11:46:26.000','4554','20','2005-06-22T11:37:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2344','2005-06-18T12:01:47.000','2015','498','2005-06-19T11:56:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2345','2005-06-18T12:03:23.000','1818','6','2005-06-22T14:25:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2346','2005-06-18T12:08:16.000','2575','308','2005-06-27T15:02:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2347','2005-06-18T12:12:29.000','4516','194','2005-06-23T14:03:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2348','2005-06-18T12:15:43.000','3622','449','2005-06-24T14:03:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2349','2005-06-18T12:25:14.000','1536','495','2005-06-19T11:24:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2350','2005-06-18T12:25:29.000','1179','471','2005-06-23T11:35:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2351','2005-06-18T12:27:57.000','2942','216','2005-06-23T16:14:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2352','2005-06-18T12:40:15.000','2141','590','2005-06-22T07:07:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2353','2005-06-18T12:53:25.000','3223','361','2005-06-19T13:53:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2354','2005-06-18T12:54:18.000','2793','77','2005-06-26T07:23:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2355','2005-06-18T12:57:06.000','3613','125','2005-06-26T07:32:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2356','2005-06-18T12:59:23.000','2207','455','2005-06-21T10:12:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2357','2005-06-18T12:59:41.000','1323','561','2005-06-26T16:40:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2358','2005-06-18T13:00:51.000','1728','478','2005-06-26T12:58:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2359','2005-06-18T13:04:42.000','3087','201','2005-06-25T11:52:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2360','2005-06-18T13:11:13.000','37','57','2005-06-23T15:32:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2361','2005-06-18T13:19:05.000','3547','546','2005-06-23T07:59:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2362','2005-06-18T13:31:15.000','2815','514','2005-06-19T12:35:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2363','2005-06-18T13:33:59.000','3497','1','2005-06-19T17:40:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2364','2005-06-18T13:37:32.000','2856','512','2005-06-23T14:18:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2365','2005-06-18T13:45:34.000','3109','493','2005-06-21T12:12:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2366','2005-06-18T13:46:39.000','1413','162','2005-06-23T18:49:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2367','2005-06-18T14:00:31.000','4086','566','2005-06-22T14:45:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2368','2005-06-18T14:10:27.000','1058','99','2005-06-23T10:49:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2369','2005-06-18T14:25:29.000','1515','44','2005-06-23T18:45:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2370','2005-06-18T14:29:54.000','2656','489','2005-06-24T10:23:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2371','2005-06-18T14:35:29.000','178','248','2005-06-22T09:38:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2372','2005-06-18T14:37:37.000','1567','96','2005-06-21T08:40:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2373','2005-06-18T14:37:57.000','2780','544','2005-06-23T19:29:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2374','2005-06-18T14:44:06.000','2634','71','2005-06-22T17:14:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2375','2005-06-18T14:47:29.000','2175','259','2005-06-26T13:52:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2376','2005-06-18T14:55:30.000','3664','479','2005-06-25T17:40:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2377','2005-06-18T14:56:23.000','3568','193','2005-06-27T12:36:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2378','2005-06-18T14:57:49.000','2796','384','2005-06-26T18:23:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2379','2005-06-18T14:59:39.000','2708','597','2005-06-24T13:26:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2380','2005-06-18T15:00:04.000','4413','256','2005-06-24T13:29:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2381','2005-06-18T15:00:30.000','1491','167','2005-06-22T11:38:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2382','2005-06-18T15:03:52.000','915','568','2005-06-20T10:16:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2383','2005-06-18T15:17:59.000','2459','149','2005-06-26T18:42:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2384','2005-06-18T15:18:49.000','3378','132','2005-06-21T18:10:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2385','2005-06-18T15:22:40.000','1641','298','2005-06-26T10:02:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2386','2005-06-18T15:22:51.000','1361','293','2005-06-22T20:01:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2387','2005-06-18T15:24:19.000','692','289','2005-06-25T17:41:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2388','2005-06-18T15:26:30.000','2923','53','2005-06-20T20:24:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2389','2005-06-18T15:27:47.000','731','382','2005-06-21T12:26:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2390','2005-06-18T15:29:26.000','2748','239','2005-06-23T17:50:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2391','2005-06-18T15:33:30.000','2850','491','2005-06-25T14:30:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2392','2005-06-18T15:34:18.000','2213','261','2005-06-19T16:22:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2393','2005-06-18T15:37:55.000','3143','21','2005-06-25T17:11:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2394','2005-06-18T15:42:30.000','2669','60','2005-06-26T16:12:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2395','2005-06-18T15:45:15.000','899','544','2005-06-27T19:11:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2396','2005-06-18T15:49:48.000','1986','31','2005-06-27T20:31:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2397','2005-06-18T15:51:25.000','2895','76','2005-06-24T15:52:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2398','2005-06-18T15:56:53.000','3001','526','2005-06-27T14:25:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2399','2005-06-18T16:06:14.000','2492','577','2005-06-26T16:56:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2400','2005-06-18T16:10:46.000','3194','410','2005-06-25T20:34:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2401','2005-06-18T16:22:03.000','85','359','2005-06-19T13:49:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2402','2005-06-18T16:24:45.000','2833','360','2005-06-27T14:39:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2403','2005-06-18T16:33:22.000','2697','536','2005-06-23T19:25:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2404','2005-06-18T16:33:48.000','4138','456','2005-06-23T20:39:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2405','2005-06-18T16:36:38.000','3604','356','2005-06-21T19:15:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2406','2005-06-18T16:39:37.000','1321','497','2005-06-23T12:04:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2407','2005-06-18T16:50:41.000','2547','421','2005-06-24T15:29:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2408','2005-06-18T16:50:44.000','258','87','2005-06-19T20:11:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2409','2005-06-18T16:53:33.000','656','84','2005-06-20T18:23:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2410','2005-06-18T16:55:08.000','265','381','2005-06-20T12:40:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2411','2005-06-18T16:55:54.000','3302','558','2005-06-25T12:44:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2412','2005-06-18T16:58:58.000','1946','127','2005-06-27T22:57:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2413','2005-06-18T16:59:34.000','1851','170','2005-06-27T16:10:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2414','2005-06-18T17:01:55.000','4500','275','2005-06-20T17:42:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2415','2005-06-18T17:02:42.000','3105','434','2005-06-25T13:16:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2416','2005-06-18T17:07:34.000','2868','26','2005-06-24T19:16:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2417','2005-06-18T17:12:01.000','1956','219','2005-06-26T13:32:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2418','2005-06-18T17:14:42.000','2756','381','2005-06-26T16:33:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2419','2005-06-18T17:21:24.000','1255','102','2005-06-26T18:25:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2420','2005-06-18T17:22:28.000','241','502','2005-06-23T17:45:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2421','2005-06-18T17:25:05.000','3524','26','2005-06-23T21:09:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2422','2005-06-18T17:28:57.000','3170','527','2005-06-23T15:22:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2423','2005-06-18T17:32:08.000','1744','231','2005-06-21T11:58:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2424','2005-06-18T17:35:08.000','1884','233','2005-06-23T15:33:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2425','2005-06-18T17:37:45.000','2630','579','2005-06-27T18:40:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2426','2005-06-18T17:40:44.000','474','543','2005-06-22T14:30:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2427','2005-06-18T17:45:00.000','4278','176','2005-06-27T20:07:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2428','2005-06-18T17:47:34.000','3892','241','2005-06-19T14:39:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2429','2005-06-18T17:48:28.000','3238','583','2005-06-27T15:52:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2430','2005-06-18T17:51:46.000','1984','434','2005-06-23T19:17:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2431','2005-06-18T17:53:03.000','1383','295','2005-06-25T15:08:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2432','2005-06-18T17:59:18.000','4420','250','2005-06-25T15:19:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2433','2005-06-18T18:10:17.000','937','356','2005-06-23T14:46:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2434','2005-06-18T18:11:51.000','3739','12','2005-06-23T12:52:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2435','2005-06-18T18:12:26.000','3548','173','2005-06-22T13:43:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2436','2005-06-18T18:13:32.000','3328','534','2005-06-21T13:33:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2437','2005-06-18T18:30:26.000','1799','454','2005-06-21T18:36:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2438','2005-06-18T18:34:21.000','184','31','2005-06-19T16:50:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2439','2005-06-18T18:35:04.000','909','39','2005-06-21T19:47:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2440','2005-06-18T18:41:09.000','2866','380','2005-06-22T12:46:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2441','2005-06-18T18:45:11.000','3148','593','2005-06-20T00:42:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2442','2005-06-18T18:49:18.000','4045','364','2005-06-22T16:18:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2443','2005-06-18T18:52:30.000','1622','233','2005-06-24T21:27:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2444','2005-06-18T18:58:12.000','2233','576','2005-06-27T20:48:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2445','2005-06-18T19:02:11.000','2887','98','2005-06-23T22:25:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2446','2005-06-18T19:04:41.000','1283','466','2005-06-27T17:10:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2447','2005-06-18T19:10:55.000','2353','523','2005-06-27T16:35:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2448','2005-06-18T19:13:45.000','1642','308','2005-06-27T14:43:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2449','2005-06-18T19:18:36.000','3630','498','2005-06-27T23:49:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2450','2005-06-18T19:25:47.000','863','230','2005-06-27T15:54:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2451','2005-06-18T19:28:02.000','835','24','2005-06-23T16:41:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2452','2005-06-18T19:29:21.000','4318','77','2005-06-26T22:27:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2453','2005-06-18T19:30:53.000','2562','588','2005-06-20T17:22:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2454','2005-06-18T19:32:51.000','314','253','2005-06-24T20:03:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2455','2005-06-18T19:33:06.000','870','241','2005-06-21T15:21:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2456','2005-06-18T19:36:50.000','553','147','2005-06-23T22:48:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2457','2005-06-18T19:38:20.000','1277','91','2005-06-26T20:48:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2458','2005-06-18T19:39:05.000','599','572','2005-06-21T13:54:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2459','2005-06-18T19:44:08.000','1024','185','2005-06-23T19:14:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2460','2005-06-18T19:54:13.000','3933','553','2005-06-27T22:36:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2461','2005-06-18T19:58:12.000','78','343','2005-06-28T01:35:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2462','2005-06-18T20:00:15.000','2151','468','2005-06-21T21:54:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2463','2005-06-18T20:01:43.000','1186','194','2005-06-25T15:04:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2464','2005-06-18T20:06:05.000','463','380','2005-06-20T19:22:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2465','2005-06-18T20:07:02.000','3783','160','2005-06-25T20:55:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2466','2005-06-18T20:18:42.000','1356','427','2005-06-20T01:32:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2467','2005-06-18T20:20:05.000','4387','177','2005-06-20T17:01:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2468','2005-06-18T20:23:52.000','1833','382','2005-06-23T14:34:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2469','2005-06-18T20:24:23.000','1993','137','2005-06-27T15:39:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2470','2005-06-18T20:28:31.000','4319','40','2005-06-25T18:48:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2471','2005-06-18T20:31:00.000','3399','183','2005-06-24T18:01:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2472','2005-06-18T20:32:40.000','4556','70','2005-06-20T00:40:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2473','2005-06-18T20:42:45.000','3876','221','2005-06-19T20:17:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2474','2005-06-18T20:51:34.000','3450','151','2005-06-25T01:39:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2475','2005-06-18T20:52:46.000','889','336','2005-06-21T19:40:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2476','2005-06-18T20:57:12.000','3998','334','2005-06-20T15:42:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2477','2005-06-18T20:58:46.000','2510','206','2005-06-22T21:49:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2478','2005-06-18T21:01:21.000','2798','241','2005-06-24T00:20:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2479','2005-06-18T21:03:08.000','1624','408','2005-06-22T16:49:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2480','2005-06-18T21:04:09.000','4078','310','2005-06-22T16:24:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2481','2005-06-18T21:08:30.000','800','322','2005-06-23T02:35:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2482','2005-06-18T21:10:44.000','452','122','2005-06-19T20:39:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2483','2005-06-18T21:22:23.000','4225','88','2005-06-25T01:14:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2484','2005-06-18T21:25:23.000','1511','515','2005-06-24T16:03:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2485','2005-06-18T21:26:03.000','1562','56','2005-06-21T22:09:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2486','2005-06-18T21:26:56.000','268','15','2005-06-22T23:42:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2487','2005-06-18T21:32:54.000','3683','374','2005-06-23T21:11:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2488','2005-06-18T21:38:26.000','1338','403','2005-06-24T02:08:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2489','2005-06-18T22:00:44.000','4012','382','2005-06-22T02:06:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2490','2005-06-18T22:00:50.000','1934','402','2005-06-19T23:45:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2491','2005-06-18T22:01:31.000','1779','316','2005-06-26T02:46:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2492','2005-06-18T22:04:15.000','2858','237','2005-06-23T21:58:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2493','2005-06-18T22:12:09.000','4121','269','2005-06-27T23:44:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2494','2005-06-18T22:15:09.000','1313','434','2005-06-25T17:23:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2495','2005-06-18T22:15:42.000','3826','338','2005-06-21T23:21:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2496','2005-06-18T22:20:11.000','646','527','2005-06-20T03:08:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2497','2005-06-18T22:50:40.000','2327','171','2005-06-26T22:39:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2498','2005-06-18T22:56:26.000','2291','74','2005-06-22T20:02:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2499','2005-06-18T23:01:36.000','3172','348','2005-06-20T21:50:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2500','2005-06-18T23:07:12.000','4241','12','2005-06-26T17:27:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2501','2005-06-18T23:10:11.000','1185','450','2005-06-24T18:40:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2502','2005-06-18T23:12:13.000','2622','325','2005-06-20T04:19:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2503','2005-06-18T23:17:19.000','2486','176','2005-06-23T03:57:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2504','2005-06-18T23:19:53.000','1684','452','2005-06-21T04:43:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2505','2005-06-18T23:28:27.000','1670','519','2005-06-26T01:36:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2506','2005-06-18T23:29:53.000','2308','82','2005-06-25T18:11:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2507','2005-06-18T23:39:22.000','3121','325','2005-06-21T19:23:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2508','2005-06-18T23:43:58.000','4322','476','2005-06-20T19:26:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2509','2005-06-18T23:44:08.000','4469','213','2005-06-20T01:36:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2510','2005-06-18T23:44:21.000','3827','384','2005-06-24T00:31:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2511','2005-06-18T23:45:30.000','1824','234','2005-06-24T01:21:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2512','2005-06-18T23:48:47.000','4515','27','2005-06-21T04:58:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2513','2005-06-18T23:53:15.000','3379','515','2005-06-24T21:16:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2514','2005-06-18T23:56:44.000','2559','382','2005-06-23T21:10:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2515','2005-06-18T23:57:31.000','3213','188','2005-06-22T05:31:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2516','2005-06-19T00:03:28.000','2678','87','2005-06-21T00:30:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2517','2005-06-19T00:11:26.000','53','74','2005-06-25T02:19:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2518','2005-06-19T00:16:23.000','3503','86','2005-06-25T19:28:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2519','2005-06-19T00:19:21.000','1172','128','2005-06-25T01:46:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2520','2005-06-19T00:29:00.000','4181','446','2005-06-28T04:36:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2521','2005-06-19T00:41:08.000','132','92','2005-06-22T00:40:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2522','2005-06-19T00:43:42.000','550','579','2005-06-28T04:26:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2523','2005-06-19T00:45:56.000','460','89','2005-06-21T00:54:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2524','2005-06-19T00:48:11.000','441','465','2005-06-25T01:46:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2525','2005-06-19T00:48:22.000','1307','365','2005-06-24T19:10:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2526','2005-06-19T01:03:07.000','3309','500','2005-06-28T06:57:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2527','2005-06-19T01:10:31.000','387','463','2005-06-20T05:37:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2528','2005-06-19T01:14:12.000','1836','331','2005-06-26T05:08:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2529','2005-06-19T01:18:27.000','2306','478','2005-06-24T00:26:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2530','2005-06-19T01:20:00.000','4166','31','2005-06-23T04:10:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2531','2005-06-19T01:20:49.000','768','368','2005-06-22T01:50:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2532','2005-06-19T01:27:46.000','1870','26','2005-06-20T02:15:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2533','2005-06-19T01:34:26.000','4564','187','2005-06-22T20:19:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2534','2005-06-19T01:38:39.000','2540','517','2005-06-23T00:16:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2535','2005-06-19T01:39:04.000','901','130','2005-06-28T01:33:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2536','2005-06-19T01:41:34.000','4232','163','2005-06-27T03:11:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2537','2005-06-19T01:52:21.000','3499','388','2005-06-26T02:09:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2538','2005-06-19T01:56:59.000','1287','472','2005-06-25T00:54:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2539','2005-06-19T01:58:39.000','4474','527','2005-06-19T22:17:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2540','2005-06-19T02:04:48.000','4305','363','2005-06-20T22:42:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2541','2005-06-19T02:08:10.000','129','360','2005-06-23T23:32:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2542','2005-06-19T02:08:39.000','1446','67','2005-06-26T20:25:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2543','2005-06-19T02:14:11.000','1729','58','2005-06-21T00:40:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2544','2005-06-19T02:16:17.000','1465','558','2005-06-22T21:45:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2545','2005-06-19T02:23:36.000','3237','413','2005-06-20T03:17:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2546','2005-06-19T02:39:39.000','971','272','2005-06-23T03:56:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2547','2005-06-19T02:44:17.000','4560','162','2005-06-24T08:01:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2548','2005-06-19T02:45:35.000','4292','561','2005-06-22T06:52:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2549','2005-06-19T02:46:39.000','3854','495','2005-06-26T22:30:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2550','2005-06-19T02:49:55.000','1370','38','2005-06-24T01:37:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2551','2005-06-19T02:51:04.000','2007','444','2005-06-28T05:02:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2552','2005-06-19T03:01:29.000','664','389','2005-06-28T04:13:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2553','2005-06-19T03:04:59.000','923','473','2005-06-26T02:36:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2554','2005-06-19T03:05:38.000','3916','322','2005-06-25T23:03:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2555','2005-06-19T03:07:02.000','260','191','2005-06-25T05:25:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2556','2005-06-19T03:07:32.000','125','377','2005-06-23T23:09:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2557','2005-06-19T03:08:51.000','4546','257','2005-06-20T07:59:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2558','2005-06-19T03:09:16.000','2920','361','2005-06-24T05:29:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2559','2005-06-19T03:09:46.000','4433','414','2005-06-28T07:49:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2560','2005-06-19T03:12:42.000','3340','309','2005-06-28T02:28:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2561','2005-06-19T03:14:52.000','4128','256','2005-06-21T02:42:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2562','2005-06-19T03:15:05.000','51','265','2005-06-21T08:26:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2563','2005-06-19T03:24:17.000','1935','41','2005-06-23T04:08:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2564','2005-06-19T03:41:10.000','4008','408','2005-06-24T03:10:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2565','2005-06-19T03:44:03.000','2347','128','2005-06-24T01:26:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2566','2005-06-19T03:45:39.000','495','486','2005-06-25T08:43:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2567','2005-06-19T04:04:46.000','216','496','2005-06-19T23:39:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2568','2005-06-19T04:09:03.000','3032','190','2005-06-24T23:24:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2569','2005-06-19T04:19:04.000','30','213','2005-06-26T04:31:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2570','2005-06-19T04:20:13.000','1105','5','2005-06-25T07:00:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2571','2005-06-19T04:20:14.000','1800','66','2005-06-21T07:28:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2572','2005-06-19T04:21:26.000','2449','159','2005-06-23T09:22:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2573','2005-06-19T04:23:18.000','3354','563','2005-06-23T06:04:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2574','2005-06-19T04:23:52.000','3320','143','2005-06-20T05:24:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2575','2005-06-19T04:32:52.000','354','336','2005-06-24T09:37:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2576','2005-06-19T04:34:15.000','2928','559','2005-06-28T10:02:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2577','2005-06-19T04:36:03.000','447','66','2005-06-28T00:38:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2578','2005-06-19T04:40:06.000','1695','267','2005-06-26T09:37:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2579','2005-06-19T04:40:44.000','3836','493','2005-06-22T09:22:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2580','2005-06-19T04:44:30.000','2527','219','2005-06-23T04:15:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2581','2005-06-19T04:54:13.000','376','456','2005-06-23T23:28:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2582','2005-06-19T04:56:27.000','201','267','2005-06-26T08:56:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2583','2005-06-19T05:01:40.000','3999','523','2005-06-28T00:04:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2584','2005-06-19T05:02:36.000','3733','90','2005-06-28T04:52:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2585','2005-06-19T05:05:03.000','91','406','2005-06-20T09:28:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2586','2005-06-19T05:05:11.000','4104','537','2005-06-27T00:23:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2587','2005-06-19T05:06:14.000','2188','331','2005-06-24T10:50:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2588','2005-06-19T05:20:31.000','3626','143','2005-06-22T04:20:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2589','2005-06-19T05:21:27.000','225','164','2005-06-21T09:55:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2590','2005-06-19T05:31:40.000','3572','324','2005-06-20T07:58:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2591','2005-06-19T05:32:22.000','4481','438','2005-06-25T23:42:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2592','2005-06-19T05:36:54.000','282','208','2005-06-21T08:44:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2593','2005-06-19T05:40:11.000','2031','556','2005-06-28T08:11:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2594','2005-06-19T05:43:43.000','829','123','2005-06-25T03:41:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2595','2005-06-19T05:43:55.000','3197','122','2005-06-25T10:20:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2596','2005-06-19T05:48:26.000','2229','80','2005-06-24T10:16:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2597','2005-06-19T05:53:46.000','2278','407','2005-06-20T05:14:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2598','2005-06-19T05:59:57.000','2079','265','2005-06-24T11:44:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2599','2005-06-19T06:06:07.000','461','171','2005-06-27T01:10:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2600','2005-06-19T06:07:25.000','469','423','2005-06-28T03:37:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2601','2005-06-19T06:09:44.000','2898','98','2005-06-20T08:03:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2602','2005-06-19T06:10:08.000','4124','173','2005-06-24T00:39:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2603','2005-06-19T06:21:25.000','587','222','2005-06-26T03:19:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2604','2005-06-19T06:30:10.000','2889','28','2005-06-25T11:16:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2605','2005-06-19T06:48:01.000','2342','38','2005-06-25T07:00:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2606','2005-06-19T06:51:32.000','4133','364','2005-06-21T03:15:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2607','2005-06-19T06:55:01.000','3922','340','2005-06-25T03:21:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2608','2005-06-19T07:10:36.000','1618','132','2005-06-24T13:09:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2609','2005-06-19T07:13:12.000','2254','383','2005-06-28T12:30:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2610','2005-06-19T07:16:20.000','3845','542','2005-06-25T09:39:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2611','2005-06-19T07:18:17.000','3682','301','2005-06-21T10:19:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2612','2005-06-19T07:19:41.000','1691','287','2005-06-25T11:10:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2613','2005-06-19T07:25:50.000','3830','179','2005-06-21T03:04:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2614','2005-06-19T07:28:11.000','4147','145','2005-06-22T12:33:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2615','2005-06-19T07:29:13.000','3810','578','2005-06-27T12:50:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2616','2005-06-19T07:33:00.000','581','478','2005-06-28T03:05:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2617','2005-06-19T07:48:31.000','204','313','2005-06-27T11:56:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2618','2005-06-19T08:03:01.000','2465','310','2005-06-24T03:23:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2619','2005-06-19T08:03:12.000','1848','350','2005-06-21T05:02:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2620','2005-06-19T08:06:29.000','3183','94','2005-06-24T11:42:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2621','2005-06-19T08:07:31.000','1746','439','2005-06-28T05:36:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2622','2005-06-19T08:10:41.000','1393','573','2005-06-28T10:44:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2623','2005-06-19T08:11:51.000','4477','12','2005-06-26T12:28:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2624','2005-06-19T08:22:09.000','3071','32','2005-06-27T11:13:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2625','2005-06-19T08:23:11.000','3946','25','2005-06-26T09:52:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2626','2005-06-19T08:28:44.000','2816','450','2005-06-24T03:58:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2627','2005-06-19T08:32:00.000','2779','592','2005-06-24T04:31:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2628','2005-06-19T08:34:53.000','3917','3','2005-06-28T04:19:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2629','2005-06-19T08:42:12.000','1810','458','2005-06-28T03:38:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2630','2005-06-19T08:47:21.000','3904','236','2005-06-25T09:31:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2631','2005-06-19T08:49:53.000','3471','39','2005-06-26T03:25:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2632','2005-06-19T08:51:47.000','2274','574','2005-06-23T07:13:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2633','2005-06-19T08:53:10.000','3462','68','2005-06-20T07:56:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2634','2005-06-19T08:55:17.000','3687','318','2005-06-20T11:44:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2635','2005-06-19T09:08:45.000','3332','105','2005-06-26T09:20:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2636','2005-06-19T09:13:06.000','2102','253','2005-06-25T07:47:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2637','2005-06-19T09:20:56.000','2736','327','2005-06-27T10:09:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2638','2005-06-19T09:23:30.000','2944','295','2005-06-26T14:56:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2639','2005-06-19T09:24:02.000','3971','116','2005-06-21T14:16:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2640','2005-06-19T09:26:13.000','721','540','2005-06-20T14:38:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2641','2005-06-19T09:38:33.000','231','374','2005-06-22T09:55:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2642','2005-06-19T09:39:01.000','2065','4','2005-06-25T08:33:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2643','2005-06-19T09:39:27.000','1928','318','2005-06-26T10:27:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2644','2005-06-19T09:42:30.000','1923','309','2005-06-27T07:23:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2645','2005-06-19T09:50:35.000','2284','181','2005-06-28T06:47:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2646','2005-06-19T09:56:01.000','3511','275','2005-06-21T04:15:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2647','2005-06-19T09:57:56.000','1954','54','2005-06-22T15:55:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2648','2005-06-19T10:06:20.000','1620','31','2005-06-21T04:30:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2649','2005-06-19T10:20:09.000','98','153','2005-06-21T10:05:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2650','2005-06-19T10:21:45.000','4211','209','2005-06-21T08:01:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2651','2005-06-19T10:22:56.000','2181','576','2005-06-27T13:37:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2652','2005-06-19T10:35:26.000','3108','589','2005-06-28T08:03:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2653','2005-06-19T10:36:53.000','3528','340','2005-06-26T15:15:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2654','2005-06-19T10:37:54.000','3697','405','2005-06-27T11:44:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2655','2005-06-19T10:38:42.000','1649','29','2005-06-23T14:20:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2656','2005-06-19T10:42:33.000','559','280','2005-06-24T08:31:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2657','2005-06-19T10:42:59.000','3595','19','2005-06-28T12:37:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2658','2005-06-19T10:43:42.000','3281','156','2005-06-24T16:23:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2659','2005-06-19T10:47:42.000','66','139','2005-06-23T14:03:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2660','2005-06-19T10:50:02.000','4341','221','2005-06-28T12:49:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2661','2005-06-19T10:50:52.000','3652','452','2005-06-25T08:44:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2662','2005-06-19T10:53:42.000','3936','68','2005-06-20T11:41:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2663','2005-06-19T10:54:00.000','1012','583','2005-06-20T16:48:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2664','2005-06-19T11:11:23.000','3496','299','2005-06-28T08:30:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2665','2005-06-19T11:12:35.000','4531','133','2005-06-26T11:55:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2666','2005-06-19T11:17:12.000','1872','454','2005-06-28T12:47:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2667','2005-06-19T11:28:46.000','1028','200','2005-06-27T11:48:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2668','2005-06-19T11:28:47.000','3127','568','2005-06-24T10:12:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2669','2005-06-19T11:28:52.000','2734','523','2005-06-20T16:43:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2670','2005-06-19T11:30:16.000','3518','457','2005-06-21T17:25:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2671','2005-06-19T11:33:11.000','2164','451','2005-06-26T14:30:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2672','2005-06-19T11:42:04.000','1164','420','2005-06-25T09:14:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2673','2005-06-19T11:42:20.000','2487','29','2005-06-23T07:16:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2674','2005-06-19T11:47:59.000','3744','585','2005-06-20T08:09:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2675','2005-06-19T11:52:15.000','3078','230','2005-06-23T16:45:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2676','2005-06-19T11:54:57.000','3938','477','2005-06-24T15:34:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2677','2005-06-19T12:01:59.000','4384','428','2005-06-21T06:15:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2678','2005-06-19T12:12:23.000','4230','258','2005-06-21T16:28:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2679','2005-06-19T12:12:30.000','1994','109','2005-06-27T08:27:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2680','2005-06-19T12:13:37.000','865','114','2005-06-27T15:15:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2681','2005-06-19T12:15:27.000','2704','196','2005-06-21T16:48:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2682','2005-06-19T12:18:17.000','3609','538','2005-06-28T14:09:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2683','2005-06-19T12:27:19.000','2860','241','2005-06-21T16:26:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2684','2005-06-19T12:29:08.000','1225','17','2005-06-28T08:50:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2685','2005-06-19T12:35:21.000','1170','283','2005-06-22T16:58:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2686','2005-06-19T12:44:20.000','2686','68','2005-06-20T16:00:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2687','2005-06-19T12:46:52.000','3152','254','2005-06-23T06:58:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2688','2005-06-19T12:50:56.000','4281','309','2005-06-28T17:58:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2689','2005-06-19T12:58:53.000','2478','567','2005-06-24T17:35:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2690','2005-06-19T13:00:02.000','1381','391','2005-06-27T14:29:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2691','2005-06-19T13:06:50.000','3469','242','2005-06-26T15:56:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2692','2005-06-19T13:08:19.000','3162','388','2005-06-21T16:45:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2693','2005-06-19T13:11:47.000','2570','107','2005-06-27T11:17:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2694','2005-06-19T13:17:21.000','380','368','2005-06-24T15:09:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2695','2005-06-19T13:25:53.000','190','208','2005-06-24T17:12:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2696','2005-06-19T13:28:42.000','2110','597','2005-06-28T14:06:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2697','2005-06-19T13:29:08.000','2271','448','2005-06-23T13:21:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2698','2005-06-19T13:29:11.000','3900','420','2005-06-20T07:31:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2699','2005-06-19T13:29:28.000','72','267','2005-06-24T11:15:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2700','2005-06-19T13:31:52.000','928','180','2005-06-27T19:30:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2701','2005-06-19T13:33:06.000','1623','29','2005-06-28T15:11:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2702','2005-06-19T13:35:56.000','1736','329','2005-06-20T14:07:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2703','2005-06-19T13:36:06.000','4080','319','2005-06-28T08:26:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2704','2005-06-19T13:50:10.000','2026','246','2005-06-26T18:25:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2705','2005-06-19T13:54:30.000','1191','562','2005-06-20T12:31:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2706','2005-06-19T13:56:51.000','373','559','2005-06-21T17:23:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2707','2005-06-19T13:57:08.000','4486','589','2005-06-27T11:09:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2708','2005-06-19T13:59:05.000','2659','541','2005-06-24T10:02:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2709','2005-06-19T14:00:26.000','2877','7','2005-06-23T14:56:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2710','2005-06-19T14:03:56.000','2965','446','2005-06-21T16:15:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2711','2005-06-19T14:12:22.000','3944','313','2005-06-21T09:29:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2712','2005-06-19T14:20:13.000','3132','411','2005-06-22T19:08:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2713','2005-06-19T14:23:09.000','3979','378','2005-06-20T17:55:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2714','2005-06-19T14:26:09.000','2853','81','2005-06-23T17:24:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2715','2005-06-19T14:29:35.000','2082','404','2005-06-26T08:44:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2716','2005-06-19T14:40:17.000','944','252','2005-06-27T17:45:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2717','2005-06-19T14:46:10.000','140','200','2005-06-22T20:17:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2718','2005-06-19T14:49:42.000','4443','139','2005-06-26T19:37:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2719','2005-06-19T14:50:19.000','1200','336','2005-06-20T14:33:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2720','2005-06-19T14:51:55.000','3597','504','2005-06-27T13:06:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2721','2005-06-19T14:53:24.000','3786','358','2005-06-21T18:22:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2722','2005-06-19T14:55:17.000','952','45','2005-06-25T13:11:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2723','2005-06-19T14:55:23.000','4317','277','2005-06-20T14:28:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2724','2005-06-19T14:57:54.000','3879','103','2005-06-22T16:31:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2725','2005-06-19T15:01:23.000','63','246','2005-06-22T09:08:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2726','2005-06-19T15:02:20.000','2970','420','2005-06-21T15:38:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2727','2005-06-19T15:02:39.000','3261','129','2005-06-28T17:49:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2728','2005-06-19T15:04:04.000','775','408','2005-06-22T12:22:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2729','2005-06-19T15:06:15.000','4449','510','2005-06-27T17:58:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2730','2005-06-19T15:10:09.000','1264','30','2005-06-28T13:05:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2731','2005-06-19T15:14:55.000','4218','138','2005-06-27T14:30:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2732','2005-06-19T15:19:39.000','610','386','2005-06-25T19:39:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2733','2005-06-19T15:21:53.000','1535','188','2005-06-23T11:58:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2734','2005-06-19T15:36:27.000','794','204','2005-06-20T13:44:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2735','2005-06-19T15:42:07.000','4550','29','2005-06-22T17:28:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2736','2005-06-19T15:43:20.000','4510','359','2005-06-21T13:03:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2737','2005-06-19T15:48:33.000','3131','513','2005-06-26T18:44:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2738','2005-06-19T15:56:30.000','350','75','2005-06-20T16:14:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2739','2005-06-19T15:58:38.000','213','212','2005-06-27T15:01:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2740','2005-06-19T15:59:04.000','1534','92','2005-06-28T12:18:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2741','2005-06-19T16:05:41.000','1662','36','2005-06-20T20:48:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2742','2005-06-19T16:05:47.000','4154','187','2005-06-26T21:34:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2743','2005-06-19T16:15:56.000','2611','35','2005-06-23T12:30:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2744','2005-06-19T16:20:40.000','4511','368','2005-06-22T11:44:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2745','2005-06-19T16:21:19.000','1253','26','2005-06-21T22:07:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2746','2005-06-19T16:21:40.000','933','562','2005-06-28T11:56:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2747','2005-06-19T16:22:07.000','1374','422','2005-06-24T19:28:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2748','2005-06-19T16:22:26.000','511','473','2005-06-21T21:55:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2749','2005-06-19T16:27:35.000','1540','358','2005-06-25T21:06:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2750','2005-06-19T16:37:24.000','3775','197','2005-06-20T13:55:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2751','2005-06-19T16:39:23.000','1291','148','2005-06-25T13:57:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2752','2005-06-19T16:44:18.000','386','149','2005-06-22T12:40:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2753','2005-06-19T16:44:35.000','2408','23','2005-06-24T13:45:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2754','2005-06-19T16:55:59.000','1761','267','2005-06-26T18:11:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2755','2005-06-19T16:56:31.000','946','506','2005-06-27T12:02:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2756','2005-06-19T16:57:42.000','3264','144','2005-06-26T15:30:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2757','2005-06-19T17:01:14.000','3814','243','2005-06-28T11:38:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2758','2005-06-19T17:04:35.000','3558','423','2005-06-26T14:45:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2759','2005-06-19T17:10:24.000','687','351','2005-06-24T21:56:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2760','2005-06-19T17:16:33.000','2602','192','2005-06-26T14:58:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2761','2005-06-19T17:22:17.000','2134','431','2005-06-20T20:20:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2762','2005-06-19T17:22:31.000','3431','457','2005-06-25T22:43:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2763','2005-06-19T17:23:34.000','3096','276','2005-06-21T21:37:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2764','2005-06-19T17:27:25.000','1718','479','2005-06-28T17:18:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2765','2005-06-19T17:34:39.000','1017','478','2005-06-27T23:26:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2766','2005-06-19T17:45:15.000','3421','345','2005-06-23T20:11:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2767','2005-06-19T17:46:35.000','4052','596','2005-06-24T22:42:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2768','2005-06-19T17:46:52.000','3018','129','2005-06-25T21:49:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2769','2005-06-19T17:52:14.000','1222','354','2005-06-26T20:30:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2770','2005-06-19T17:54:22.000','3042','533','2005-06-26T23:09:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2771','2005-06-19T17:54:48.000','40','262','2005-06-27T17:14:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2772','2005-06-19T17:59:27.000','1221','520','2005-06-23T17:52:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2773','2005-06-19T18:04:18.000','4155','505','2005-06-28T23:52:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2774','2005-06-19T18:05:11.000','2809','299','2005-06-21T16:21:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2775','2005-06-19T18:14:20.000','672','590','2005-06-26T19:52:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2776','2005-06-19T18:16:24.000','1726','551','2005-06-26T14:43:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2777','2005-06-19T18:16:26.000','4092','230','2005-06-20T13:43:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2778','2005-06-19T18:18:12.000','3357','422','2005-06-28T21:43:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2779','2005-06-19T18:19:07.000','1020','376','2005-06-23T18:25:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2780','2005-06-19T18:19:33.000','1513','360','2005-06-28T22:29:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2781','2005-06-19T18:24:42.000','1230','197','2005-06-27T17:02:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2782','2005-06-19T18:25:07.000','3644','156','2005-06-22T14:10:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2783','2005-06-19T18:29:10.000','2778','113','2005-06-21T22:09:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2784','2005-06-19T18:40:29.000','2305','289','2005-06-28T15:27:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2785','2005-06-19T18:43:57.000','826','137','2005-06-24T15:36:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2786','2005-06-19T18:46:43.000','2255','594','2005-06-22T16:52:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2787','2005-06-19T18:47:00.000','3371','307','2005-06-22T20:22:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2788','2005-06-19T18:48:11.000','1457','171','2005-06-21T13:32:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2789','2005-06-19T18:48:21.000','2398','514','2005-06-21T21:50:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2790','2005-06-19T18:49:45.000','202','97','2005-06-21T00:13:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2791','2005-06-19T18:51:27.000','2174','299','2005-06-22T19:35:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2792','2005-06-19T18:52:25.000','3057','437','2005-06-23T17:39:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2793','2005-06-19T18:52:37.000','732','419','2005-06-25T19:45:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2794','2005-06-19T18:53:05.000','1957','85','2005-06-22T13:15:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2795','2005-06-19T18:58:53.000','3694','129','2005-06-28T18:56:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2796','2005-06-19T19:00:37.000','2337','209','2005-06-25T17:18:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2797','2005-06-19T19:04:32.000','3222','486','2005-06-20T22:43:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2798','2005-06-19T19:07:48.000','1343','180','2005-06-23T00:09:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2799','2005-06-19T19:15:21.000','4579','576','2005-06-21T21:35:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2800','2005-06-19T19:15:56.000','183','146','2005-06-23T00:15:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2801','2005-06-19T19:18:09.000','4572','29','2005-06-20T20:11:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2802','2005-06-19T19:18:17.000','4067','489','2005-06-21T17:58:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2803','2005-06-19T19:18:27.000','103','120','2005-06-27T21:48:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2804','2005-06-19T19:24:54.000','88','426','2005-06-25T01:19:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2805','2005-06-19T19:29:17.000','2153','80','2005-06-27T23:14:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2806','2005-06-19T19:30:48.000','2114','510','2005-06-20T19:42:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2807','2005-06-19T19:32:53.000','2825','194','2005-06-25T00:30:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2808','2005-06-19T19:34:45.000','65','325','2005-06-27T14:49:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2809','2005-06-19T19:40:27.000','1786','44','2005-06-27T15:28:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2810','2005-06-19T19:44:12.000','2558','67','2005-06-20T19:41:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2811','2005-06-19T19:53:30.000','3890','457','2005-06-22T23:21:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2812','2005-06-19T19:58:16.000','3016','211','2005-06-26T15:26:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2813','2005-06-19T20:01:47.000','3420','284','2005-06-27T01:51:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2814','2005-06-19T20:01:59.000','1783','10','2005-06-26T01:28:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2815','2005-06-19T20:03:29.000','3046','27','2005-06-25T22:50:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2816','2005-06-19T20:04:23.000','2180','94','2005-06-20T21:09:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2817','2005-06-19T20:05:22.000','3476','510','2005-06-24T23:29:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2818','2005-06-19T20:05:52.000','2376','497','2005-06-22T01:01:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2819','2005-06-19T20:13:33.000','4100','82','2005-06-26T16:44:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2820','2005-06-19T20:20:33.000','851','316','2005-06-26T20:32:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2821','2005-06-19T20:26:52.000','2551','532','2005-06-27T23:48:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2822','2005-06-19T20:29:24.000','3599','48','2005-06-23T02:21:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2823','2005-06-19T20:30:21.000','3566','260','2005-06-26T17:58:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2824','2005-06-19T20:31:45.000','2878','506','2005-06-29T00:40:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2825','2005-06-19T20:32:19.000','2601','418','2005-06-22T22:32:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2826','2005-06-19T20:41:35.000','2980','125','2005-06-25T17:23:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2827','2005-06-19T20:50:01.000','2745','23','2005-06-20T18:54:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2828','2005-06-19T20:51:33.000','3230','526','2005-06-25T17:38:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2829','2005-06-19T21:11:30.000','2047','341','2005-06-24T18:10:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2830','2005-06-19T21:14:33.000','2080','21','2005-06-21T17:46:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2831','2005-06-19T21:17:06.000','4089','468','2005-06-22T16:56:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2832','2005-06-19T21:21:53.000','828','593','2005-06-28T23:00:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2833','2005-06-19T21:34:54.000','1976','232','2005-06-28T16:21:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2834','2005-06-19T21:41:46.000','2876','122','2005-06-24T20:47:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2835','2005-06-19T21:44:11.000','4411','89','2005-06-26T16:46:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2836','2005-06-19T21:58:21.000','1453','306','2005-06-27T00:41:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2837','2005-06-19T22:03:50.000','417','371','2005-06-20T21:24:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2838','2005-06-19T22:06:06.000','143','292','2005-06-25T22:30:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2839','2005-06-19T22:07:24.000','3856','256','2005-06-23T16:37:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2840','2005-06-19T22:17:44.000','1102','236','2005-06-26T00:36:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2841','2005-06-19T22:21:06.000','614','193','2005-06-28T00:56:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2842','2005-06-19T22:34:20.000','4183','217','2005-06-22T03:46:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2843','2005-06-19T22:36:39.000','1520','148','2005-06-26T22:33:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2844','2005-06-19T22:40:12.000','4452','178','2005-06-24T03:58:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2845','2005-06-19T22:46:37.000','3948','583','2005-06-23T03:31:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2846','2005-06-19T22:52:14.000','651','193','2005-06-22T17:12:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2847','2005-06-19T22:54:01.000','1247','148','2005-06-27T23:05:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2848','2005-06-19T22:55:37.000','3449','19','2005-06-25T23:10:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2849','2005-06-19T23:06:00.000','3628','283','2005-06-25T18:36:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2850','2005-06-19T23:06:28.000','206','262','2005-06-28T03:30:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2851','2005-06-19T23:07:03.000','2168','361','2005-06-22T17:26:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2852','2005-06-19T23:08:50.000','2695','453','2005-06-26T04:00:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2853','2005-06-19T23:09:41.000','2578','453','2005-06-28T00:51:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2854','2005-06-19T23:11:48.000','4453','81','2005-06-23T19:37:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2855','2005-06-19T23:11:49.000','3495','483','2005-06-26T21:52:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2856','2005-06-19T23:13:04.000','1859','210','2005-06-23T22:47:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2857','2005-06-19T23:15:15.000','2886','364','2005-06-25T04:24:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2858','2005-06-19T23:17:11.000','2628','268','2005-06-21T19:07:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2859','2005-06-19T23:18:42.000','126','147','2005-06-20T22:38:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2860','2005-06-19T23:20:40.000','3045','107','2005-06-21T04:59:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2861','2005-06-19T23:21:34.000','1489','116','2005-06-26T17:32:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2862','2005-06-19T23:47:24.000','4260','52','2005-06-23T03:39:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2863','2005-06-19T23:58:38.000','2410','228','2005-06-23T23:27:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2864','2005-06-20T00:00:52.000','1056','493','2005-06-26T04:21:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2865','2005-06-20T00:00:55.000','1569','10','2005-06-21T02:20:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2866','2005-06-20T00:01:36.000','2718','44','2005-06-20T21:39:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2867','2005-06-20T00:08:38.000','95','483','2005-06-23T19:35:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2868','2005-06-20T00:08:58.000','1213','214','2005-06-25T21:23:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2869','2005-06-20T00:09:25.000','1331','155','2005-06-24T04:40:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2870','2005-06-20T00:17:46.000','214','467','2005-06-28T20:21:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2871','2005-06-20T00:27:49.000','1731','443','2005-06-29T01:36:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2872','2005-06-20T00:38:21.000','3779','240','2005-06-26T19:56:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2873','2005-06-20T00:41:25.000','3321','160','2005-06-25T02:06:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2874','2005-06-20T00:42:26.000','331','166','2005-06-28T01:37:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2875','2005-06-20T00:47:18.000','3012','186','2005-06-25T18:54:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2876','2005-06-20T01:06:34.000','3117','39','2005-06-23T04:55:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2877','2005-06-20T01:07:16.000','485','267','2005-06-24T01:05:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2878','2005-06-20T01:09:14.000','4120','88','2005-06-21T21:40:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2879','2005-06-20T01:24:10.000','1920','583','2005-06-28T20:12:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2880','2005-06-20T01:24:54.000','1700','193','2005-06-23T02:42:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2881','2005-06-20T01:26:18.000','1391','307','2005-06-26T23:42:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2882','2005-06-20T01:26:26.000','205','152','2005-06-21T19:33:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2883','2005-06-20T01:29:10.000','585','320','2005-06-28T06:12:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2884','2005-06-20T01:31:16.000','3384','319','2005-06-21T04:03:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2885','2005-06-20T01:33:42.000','2701','330','2005-06-22T22:23:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2886','2005-06-20T01:38:39.000','1755','154','2005-06-23T04:28:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2887','2005-06-20T01:39:43.000','1073','453','2005-06-25T05:22:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2888','2005-06-20T01:50:56.000','468','7','2005-06-22T05:05:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2889','2005-06-20T01:54:08.000','151','213','2005-06-23T06:33:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2890','2005-06-20T02:00:45.000','3437','392','2005-06-27T21:12:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2891','2005-06-20T02:02:05.000','343','32','2005-06-25T02:45:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2892','2005-06-20T02:06:39.000','2993','430','2005-06-21T02:50:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2893','2005-06-20T02:22:08.000','397','153','2005-06-26T21:01:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2894','2005-06-20T02:22:42.000','4316','76','2005-06-22T00:38:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2895','2005-06-20T02:26:31.000','4445','141','2005-06-27T23:42:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2896','2005-06-20T02:33:42.000','1086','40','2005-06-26T05:29:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2897','2005-06-20T02:34:23.000','3464','107','2005-06-25T05:29:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2898','2005-06-20T02:38:06.000','3106','178','2005-06-29T08:18:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2899','2005-06-20T02:39:21.000','1919','459','2005-06-23T06:47:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2900','2005-06-20T02:40:04.000','3407','294','2005-06-27T20:47:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2901','2005-06-20T02:41:28.000','667','25','2005-06-23T04:43:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2902','2005-06-20T02:45:35.000','2787','304','2005-06-26T07:51:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2903','2005-06-20T02:49:01.000','3580','53','2005-06-25T05:03:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2904','2005-06-20T02:54:06.000','2195','55','2005-06-21T06:57:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2905','2005-06-20T02:56:16.000','3898','189','2005-06-24T23:51:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2906','2005-06-20T03:04:56.000','1087','58','2005-06-23T05:57:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2907','2005-06-20T03:15:09.000','2516','208','2005-06-20T21:56:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2908','2005-06-20T03:16:52.000','517','91','2005-06-22T08:46:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2909','2005-06-20T03:19:10.000','1701','451','2005-06-25T06:06:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2910','2005-06-20T03:31:18.000','630','57','2005-06-28T00:35:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2911','2005-06-20T03:32:37.000','3645','502','2005-06-22T22:06:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2912','2005-06-20T03:32:45.000','1076','196','2005-06-21T23:32:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2913','2005-06-20T03:42:27.000','3456','402','2005-06-23T04:47:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2914','2005-06-20T03:43:18.000','2419','342','2005-06-25T03:44:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2915','2005-06-20T03:57:17.000','1293','262','2005-06-24T05:59:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2916','2005-06-20T04:01:04.000','3086','590','2005-06-27T22:40:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2917','2005-06-20T04:08:35.000','647','451','2005-06-24T01:17:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2918','2005-06-20T04:09:04.000','1985','215','2005-06-21T10:07:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2919','2005-06-20T04:10:16.000','2835','509','2005-06-27T06:34:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2920','2005-06-20T04:12:46.000','487','588','2005-06-26T23:34:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2921','2005-06-20T04:13:04.000','1785','59','2005-06-28T01:28:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2922','2005-06-20T04:13:47.000','1671','176','2005-06-22T04:38:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2923','2005-06-20T04:16:07.000','109','29','2005-06-21T05:04:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2924','2005-06-20T04:20:14.000','580','132','2005-06-21T01:13:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2925','2005-06-20T04:23:49.000','804','301','2005-06-22T04:37:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2926','2005-06-20T04:37:45.000','1055','379','2005-06-26T02:17:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2927','2005-06-20T04:41:41.000','393','403','2005-06-23T01:59:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2928','2005-06-20T04:43:45.000','1265','104','2005-06-21T06:58:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2929','2005-06-20T04:47:39.000','3389','333','2005-06-25T23:16:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2930','2005-06-20T04:50:29.000','3615','585','2005-06-28T06:00:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2931','2005-06-20T04:50:45.000','3122','258','2005-06-29T09:18:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2932','2005-06-20T04:51:19.000','4418','526','2005-06-29T08:31:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2933','2005-06-20T04:52:23.000','4483','323','2005-06-26T07:12:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2934','2005-06-20T05:05:53.000','697','228','2005-06-22T02:44:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2935','2005-06-20T05:07:24.000','2735','384','2005-06-28T09:17:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2936','2005-06-20T05:09:27.000','2675','330','2005-06-26T10:16:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2937','2005-06-20T05:15:37.000','1998','15','2005-06-27T02:45:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2938','2005-06-20T05:17:22.000','1795','504','2005-06-26T09:38:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2939','2005-06-20T05:18:16.000','2638','203','2005-06-26T06:56:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2940','2005-06-20T05:20:01.000','2504','73','2005-06-28T06:11:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2941','2005-06-20T05:22:18.000','3632','135','2005-06-26T07:40:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2942','2005-06-20T05:27:31.000','999','242','2005-06-29T00:35:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2943','2005-06-20T05:43:05.000','2591','418','2005-06-25T04:31:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2944','2005-06-20T05:43:42.000','1550','474','2005-06-29T09:40:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2945','2005-06-20T05:49:27.000','4193','153','2005-06-26T09:48:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2946','2005-06-20T05:50:40.000','3737','213','2005-06-21T00:42:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2947','2005-06-20T06:00:21.000','4302','151','2005-06-23T10:04:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2948','2005-06-20T06:02:35.000','4254','289','2005-06-29T09:12:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2949','2005-06-20T06:05:53.000','375','78','2005-06-29T03:19:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2950','2005-06-20T06:08:36.000','1438','561','2005-06-27T07:45:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2951','2005-06-20T06:23:01.000','2903','404','2005-06-24T00:26:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2952','2005-06-20T06:26:57.000','3759','13','2005-06-22T11:51:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2953','2005-06-20T06:39:11.000','1829','540','2005-06-26T06:19:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2954','2005-06-20T06:45:00.000','377','336','2005-06-23T11:43:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2955','2005-06-20T06:46:35.000','2312','244','2005-06-25T05:34:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2956','2005-06-20T06:47:23.000','2684','533','2005-06-22T07:24:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2957','2005-06-20T06:53:47.000','4034','542','2005-06-29T09:21:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2958','2005-06-20T06:56:20.000','1380','260','2005-06-29T02:33:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2959','2005-06-20T07:07:54.000','4185','372','2005-06-27T03:31:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2960','2005-06-20T07:10:09.000','3970','16','2005-06-26T08:14:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2961','2005-06-20T07:29:15.000','4539','399','2005-06-24T08:05:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2962','2005-06-20T07:31:55.000','2978','364','2005-06-26T04:43:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2963','2005-06-20T07:33:09.000','1444','24','2005-06-28T09:23:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2964','2005-06-20T07:33:29.000','1201','590','2005-06-29T12:48:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2965','2005-06-20T07:33:38.000','27','46','2005-06-29T11:45:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2966','2005-06-20T07:39:33.000','3483','511','2005-06-29T07:48:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2967','2005-06-20T07:40:35.000','4243','311','2005-06-29T05:50:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2968','2005-06-20T07:41:47.000','4415','252','2005-06-23T04:27:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2969','2005-06-20T07:44:27.000','1748','418','2005-06-22T06:12:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2970','2005-06-20T07:51:51.000','1167','449','2005-06-28T10:14:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2971','2005-06-20T07:56:00.000','1585','410','2005-06-27T11:38:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2972','2005-06-20T07:57:54.000','2232','531','2005-06-21T12:48:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2973','2005-06-20T07:59:27.000','2626','96','2005-06-24T12:31:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2974','2005-06-20T08:00:24.000','2322','472','2005-06-25T05:10:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2975','2005-06-20T08:06:18.000','4534','46','2005-06-21T08:01:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2976','2005-06-20T08:09:11.000','4210','55','2005-06-21T10:45:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2977','2005-06-20T08:15:27.000','2645','571','2005-06-29T04:30:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2978','2005-06-20T08:25:16.000','4364','548','2005-06-23T05:42:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2979','2005-06-20T08:31:05.000','3961','589','2005-06-27T12:25:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2980','2005-06-20T08:35:03.000','310','343','2005-06-29T07:57:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2981','2005-06-20T08:35:17.000','522','387','2005-06-28T09:14:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2982','2005-06-20T08:38:29.000','2574','130','2005-06-28T13:21:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2983','2005-06-20T08:41:42.000','1349','322','2005-06-29T04:02:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2984','2005-06-20T08:43:44.000','1819','435','2005-06-22T03:08:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2985','2005-06-20T08:45:08.000','122','154','2005-06-22T04:26:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2986','2005-06-20T08:50:28.000','478','556','2005-06-26T05:24:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2987','2005-06-20T08:55:50.000','1531','349','2005-06-28T13:02:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2988','2005-06-20T08:59:08.000','3160','557','2005-06-28T04:31:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2989','2005-06-20T08:59:37.000','1586','56','2005-06-22T03:27:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2990','2005-06-20T09:02:51.000','4559','18','2005-06-29T13:19:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2991','2005-06-20T09:10:43.000','4308','472','2005-06-23T13:04:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2992','2005-06-20T09:11:51.000','3347','439','2005-06-24T05:59:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2993','2005-06-20T09:12:12.000','1527','40','2005-06-22T13:36:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2994','2005-06-20T09:17:05.000','1290','163','2005-06-29T04:41:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2995','2005-06-20T09:18:22.000','4544','573','2005-06-26T14:31:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2996','2005-06-20T09:20:29.000','4064','500','2005-06-27T09:18:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2997','2005-06-20T09:23:45.000','1449','519','2005-06-29T08:15:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2998','2005-06-20T09:30:22.000','1288','380','2005-06-24T06:31:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('2999','2005-06-20T09:30:34.000','735','295','2005-06-26T05:51:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3000','2005-06-20T09:32:33.000','549','50','2005-06-22T07:45:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3001','2005-06-20T09:50:16.000','2941','393','2005-06-28T05:13:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3002','2005-06-20T09:56:12.000','2749','266','2005-06-24T12:15:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3003','2005-06-20T10:00:51.000','616','38','2005-06-22T06:28:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3004','2005-06-20T10:04:36.000','2836','113','2005-06-23T07:38:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3005','2005-06-20T10:10:29.000','286','598','2005-06-28T15:48:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3006','2005-06-20T10:10:29.000','1677','133','2005-06-22T07:26:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3007','2005-06-20T10:11:53.000','1950','7','2005-06-25T04:51:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3008','2005-06-20T10:23:25.000','3383','202','2005-06-26T11:00:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3009','2005-06-20T10:24:44.000','2721','280','2005-06-23T13:39:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3010','2005-06-20T10:29:59.000','1298','567','2005-06-27T06:52:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3011','2005-06-20T10:39:10.000','4376','147','2005-06-28T07:02:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3012','2005-06-20T10:43:13.000','1392','206','2005-06-28T10:07:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3013','2005-06-20T10:45:09.000','4146','290','2005-06-26T04:55:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3014','2005-06-20T10:45:20.000','2179','434','2005-06-23T06:29:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3015','2005-06-20T10:48:56.000','1311','23','2005-06-26T11:30:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3016','2005-06-20T10:55:08.000','3514','558','2005-06-24T14:05:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3017','2005-06-20T11:08:56.000','2513','151','2005-06-28T16:26:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3018','2005-06-20T11:10:35.000','4150','112','2005-06-25T07:17:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3019','2005-06-20T11:11:52.000','491','144','2005-06-27T08:30:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3020','2005-06-20T11:12:04.000','4363','74','2005-06-27T07:31:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3021','2005-06-20T11:13:01.000','120','62','2005-06-28T16:15:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3022','2005-06-20T11:17:20.000','3745','466','2005-06-26T13:15:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3023','2005-06-20T11:18:11.000','4304','106','2005-06-21T12:43:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3024','2005-06-20T11:29:17.000','1966','328','2005-06-27T12:51:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3025','2005-06-20T11:46:48.000','1309','293','2005-06-22T08:43:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3026','2005-06-20T11:48:00.000','4032','347','2005-06-21T12:51:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3027','2005-06-20T11:50:30.000','4028','397','2005-06-25T15:58:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3028','2005-06-20T11:50:52.000','886','264','2005-06-21T11:05:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3029','2005-06-20T11:51:30.000','327','317','2005-06-25T16:42:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3030','2005-06-20T11:51:59.000','1543','395','2005-06-24T10:51:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3031','2005-06-20T11:52:49.000','1184','491','2005-06-22T07:00:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3032','2005-06-20T11:58:30.000','3734','172','2005-06-24T09:49:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3033','2005-06-20T12:02:05.000','4422','107','2005-06-26T15:58:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3034','2005-06-20T12:15:50.000','2755','296','2005-06-24T06:21:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3035','2005-06-20T12:17:03.000','1223','62','2005-06-26T17:42:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3036','2005-06-20T12:18:31.000','4463','399','2005-06-29T09:52:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3037','2005-06-20T12:28:03.000','2033','434','2005-06-21T08:21:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3038','2005-06-20T12:28:59.000','2919','27','2005-06-25T07:48:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3039','2005-06-20T12:32:30.000','4098','186','2005-06-21T07:38:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3040','2005-06-20T12:34:13.000','2568','162','2005-06-21T12:33:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3041','2005-06-20T12:35:44.000','2676','459','2005-06-23T18:28:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3042','2005-06-20T12:38:27.000','3103','291','2005-06-26T11:18:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3043','2005-06-20T12:38:35.000','633','599','2005-06-29T14:16:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3044','2005-06-20T12:38:49.000','3216','424','2005-06-25T07:49:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3045','2005-06-20T12:42:00.000','3065','459','2005-06-23T10:49:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3046','2005-06-20T12:42:59.000','471','559','2005-06-26T17:40:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3047','2005-06-20T12:45:33.000','624','13','2005-06-29T13:09:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3048','2005-06-20T12:49:55.000','4389','482','2005-06-26T11:06:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3049','2005-06-20T12:51:01.000','518','403','2005-06-29T10:53:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3050','2005-06-20T13:03:03.000','2397','557','2005-06-29T07:22:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3051','2005-06-20T13:06:52.000','1408','65','2005-06-25T13:03:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3052','2005-06-20T13:09:19.000','2359','329','2005-06-29T11:55:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3053','2005-06-20T13:10:30.000','818','329','2005-06-25T17:22:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3054','2005-06-20T13:16:41.000','2817','322','2005-06-28T13:45:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3055','2005-06-20T13:19:58.000','1510','23','2005-06-27T14:54:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3056','2005-06-20T13:20:58.000','2010','95','2005-06-26T08:35:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3057','2005-06-20T13:22:48.000','1101','307','2005-06-26T17:22:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3058','2005-06-20T13:28:35.000','938','137','2005-06-28T13:57:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3059','2005-06-20T13:38:41.000','2911','266','2005-06-21T10:13:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3060','2005-06-20T13:47:20.000','2075','446','2005-06-25T16:00:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3061','2005-06-20T13:48:21.000','4202','330','2005-06-22T17:36:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3062','2005-06-20T13:50:00.000','591','75','2005-06-27T08:18:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3063','2005-06-20T13:52:03.000','3954','515','2005-06-28T13:36:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3064','2005-06-20T13:53:13.000','2624','276','2005-06-25T16:33:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3065','2005-06-20T13:53:53.000','1687','227','2005-06-24T11:31:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3066','2005-06-20T13:55:41.000','1116','268','2005-06-26T09:38:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3067','2005-06-20T13:59:21.000','3094','349','2005-06-28T19:09:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3068','2005-06-20T14:02:22.000','1958','516','2005-06-22T12:52:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3069','2005-06-20T14:13:00.000','1952','237','2005-06-28T10:57:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3070','2005-06-20T14:15:39.000','3860','543','2005-06-25T12:52:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3071','2005-06-20T14:20:42.000','1198','582','2005-06-24T19:01:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3072','2005-06-20T14:21:31.000','4131','423','2005-06-27T18:46:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3073','2005-06-20T14:33:26.000','3164','471','2005-06-26T08:42:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3074','2005-06-20T14:41:41.000','1441','299','2005-06-21T15:56:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3075','2005-06-20T14:52:19.000','4346','161','2005-06-28T18:48:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3076','2005-06-20T15:01:19.000','1344','109','2005-06-28T16:53:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3077','2005-06-20T15:05:18.000','1675','303','2005-06-26T20:52:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3078','2005-06-20T15:09:48.000','3642','367','2005-06-24T16:54:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3079','2005-06-20T15:13:40.000','2135','350','2005-06-21T12:03:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3080','2005-06-20T15:22:32.000','118','377','2005-06-24T11:08:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3081','2005-06-20T15:29:13.000','2071','342','2005-06-24T21:00:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3082','2005-06-20T15:32:11.000','4431','164','2005-06-28T13:08:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3083','2005-06-20T15:33:47.000','2896','257','2005-06-26T16:14:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3084','2005-06-20T15:35:24.000','3578','514','2005-06-23T19:11:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3085','2005-06-20T15:42:33.000','4282','166','2005-06-21T16:51:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3086','2005-06-20T15:42:40.000','4437','377','2005-06-25T19:21:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3087','2005-06-20T15:53:59.000','1305','111','2005-06-27T10:54:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3088','2005-06-20T15:56:05.000','3049','384','2005-06-29T13:02:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3089','2005-06-20T15:57:01.000','539','151','2005-06-25T13:15:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3090','2005-06-20T16:00:19.000','3301','267','2005-06-23T14:55:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3091','2005-06-20T16:02:59.000','854','383','2005-06-22T21:30:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3092','2005-06-20T16:04:42.000','4344','347','2005-06-27T19:54:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3093','2005-06-20T16:06:14.000','2534','556','2005-06-22T13:22:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3094','2005-06-20T16:06:51.000','2048','114','2005-06-24T13:23:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3095','2005-06-20T16:16:53.000','3937','298','2005-06-22T10:35:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3096','2005-06-20T16:17:56.000','3851','79','2005-06-24T10:17:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3097','2005-06-20T16:26:14.000','4337','280','2005-06-23T14:46:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3098','2005-06-20T16:37:01.000','3409','498','2005-06-22T22:24:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3099','2005-06-20T16:44:33.000','3756','380','2005-06-27T12:17:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3100','2005-06-20T16:47:57.000','2428','487','2005-06-26T16:59:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3101','2005-06-20T16:48:58.000','1738','384','2005-06-27T18:13:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3102','2005-06-20T16:55:55.000','1144','522','2005-06-29T13:49:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3103','2005-06-20T16:58:19.000','1877','553','2005-06-25T21:18:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3104','2005-06-20T17:06:46.000','1490','196','2005-06-28T13:18:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3105','2005-06-20T17:11:46.000','130','385','2005-06-21T11:48:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3106','2005-06-20T17:18:06.000','2637','201','2005-06-24T14:50:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3107','2005-06-20T17:26:05.000','4527','303','2005-06-25T12:36:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3108','2005-06-20T17:28:43.000','2218','189','2005-06-27T21:23:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3109','2005-06-20T17:33:55.000','977','93','2005-06-22T23:09:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3110','2005-06-20T17:40:12.000','2008','333','2005-06-24T17:09:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3111','2005-06-20T17:46:47.000','4494','579','2005-06-29T19:45:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3112','2005-06-20T17:53:30.000','3725','35','2005-06-26T16:03:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3113','2005-06-20T17:56:40.000','3620','517','2005-06-23T14:45:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3114','2005-06-20T17:57:47.000','2388','8','2005-06-21T19:18:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3115','2005-06-20T17:59:05.000','2193','457','2005-06-26T13:28:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3116','2005-06-20T18:04:55.000','276','108','2005-06-21T12:12:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3117','2005-06-20T18:05:15.000','2184','31','2005-06-26T17:28:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3118','2005-06-20T18:05:57.000','1258','125','2005-06-23T23:01:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3119','2005-06-20T18:11:44.000','683','296','2005-06-27T16:14:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3120','2005-06-20T18:19:29.000','2530','107','2005-06-23T23:40:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3121','2005-06-20T18:23:30.000','797','132','2005-06-21T20:36:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3122','2005-06-20T18:25:57.000','2720','87','2005-06-29T16:08:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3123','2005-06-20T18:26:14.000','1656','289','2005-06-29T17:17:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3124','2005-06-20T18:28:19.000','3342','113','2005-06-28T21:08:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3125','2005-06-20T18:31:58.000','3293','382','2005-06-21T15:03:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3126','2005-06-20T18:38:22.000','1183','5','2005-06-26T00:00:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3127','2005-06-20T18:39:43.000','1292','461','2005-06-28T17:55:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3128','2005-06-20T18:41:47.000','189','543','2005-06-24T20:54:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3129','2005-06-20T18:57:48.000','1789','495','2005-06-28T13:45:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3130','2005-06-20T19:03:22.000','2569','341','2005-06-29T18:05:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3131','2005-06-20T19:08:00.000','3678','146','2005-06-24T20:59:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3132','2005-06-20T19:09:46.000','711','90','2005-06-24T19:42:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3133','2005-06-20T19:18:32.000','4529','120','2005-06-26T17:54:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3134','2005-06-20T19:29:09.000','1389','537','2005-06-29T19:31:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3135','2005-06-20T19:33:52.000','1122','12','2005-06-29T18:20:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3136','2005-06-20T19:39:08.000','3349','377','2005-06-22T23:35:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3137','2005-06-20T19:41:28.000','786','505','2005-06-28T00:32:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3138','2005-06-20T19:43:45.000','2265','570','2005-06-26T20:41:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3139','2005-06-20T19:44:45.000','3474','354','2005-06-23T16:24:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3140','2005-06-20T19:47:12.000','2936','53','2005-06-24T23:24:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3141','2005-06-20T19:55:47.000','1806','398','2005-06-30T00:31:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3142','2005-06-20T19:59:28.000','3926','9','2005-06-28T19:51:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3143','2005-06-20T20:01:52.000','1355','215','2005-06-26T19:26:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3144','2005-06-20T20:14:20.000','1300','114','2005-06-30T01:46:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3145','2005-06-20T20:21:17.000','2211','144','2005-06-22T14:44:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3146','2005-06-20T20:21:48.000','2249','339','2005-06-29T22:57:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3147','2005-06-20T20:25:17.000','615','390','2005-06-28T20:22:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3148','2005-06-20T20:27:18.000','4490','202','2005-06-24T20:30:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3149','2005-06-20T20:34:55.000','3295','55','2005-06-21T18:51:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3150','2005-06-20T20:35:28.000','94','34','2005-06-26T01:01:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3151','2005-06-20T20:36:53.000','2976','77','2005-06-25T18:56:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3152','2005-06-20T20:42:41.000','1022','246','2005-06-28T21:12:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3153','2005-06-20T20:44:15.000','659','430','2005-06-23T16:04:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3154','2005-06-20T20:44:40.000','3195','550','2005-06-23T19:10:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3155','2005-06-20T21:02:38.000','458','450','2005-06-27T19:34:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3156','2005-06-20T21:03:46.000','2217','365','2005-06-21T23:32:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3157','2005-06-20T21:07:54.000','1899','245','2005-06-23T16:01:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3158','2005-06-20T21:08:19.000','3461','592','2005-06-29T18:59:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3159','2005-06-20T21:11:50.000','33','388','2005-06-29T19:35:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3160','2005-06-20T21:20:51.000','4333','561','2005-06-29T18:06:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3161','2005-06-20T21:21:01.000','1326','373','2005-06-21T18:22:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3162','2005-06-20T21:21:15.000','3220','113','2005-06-29T18:42:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3163','2005-06-20T21:22:13.000','2632','391','2005-06-26T15:22:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3164','2005-06-20T21:29:00.000','155','270','2005-06-27T15:50:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3165','2005-06-20T21:29:17.000','796','85','2005-06-22T18:03:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3166','2005-06-20T21:32:32.000','1850','424','2005-06-27T20:29:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3167','2005-06-20T21:42:29.000','353','464','2005-06-22T00:36:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3168','2005-06-20T21:46:01.000','2407','446','2005-06-22T20:40:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3169','2005-06-20T21:55:54.000','2437','50','2005-06-25T19:45:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3170','2005-06-20T22:02:54.000','1306','421','2005-06-29T00:41:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3171','2005-06-20T22:15:47.000','2838','140','2005-06-24T18:14:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3172','2005-06-20T22:19:25.000','1758','31','2005-06-24T17:18:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3173','2005-06-20T22:21:10.000','4306','33','2005-06-27T19:41:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3174','2005-06-20T22:24:00.000','3331','107','2005-06-22T21:22:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3175','2005-06-20T22:30:23.000','4093','249','2005-06-30T03:28:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3176','2005-06-20T22:31:54.000','1982','371','2005-06-25T02:58:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3177','2005-06-20T22:32:44.000','2546','300','2005-06-22T23:01:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3178','2005-06-20T22:35:12.000','3517','79','2005-06-23T19:39:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3179','2005-06-20T22:37:59.000','2214','163','2005-06-26T22:26:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3180','2005-06-20T22:48:44.000','3997','162','2005-06-21T21:25:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3181','2005-06-20T22:51:02.000','3473','238','2005-06-27T21:21:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3182','2005-06-20T22:52:18.000','4017','15','2005-06-21T21:00:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3183','2005-06-20T22:55:55.000','4397','129','2005-06-23T17:22:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3184','2005-06-20T22:57:44.000','3179','457','2005-06-29T20:57:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3185','2005-06-20T22:58:01.000','601','234','2005-06-27T00:26:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3186','2005-06-20T23:04:20.000','3198','406','2005-06-29T02:56:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3187','2005-06-20T23:06:07.000','4357','150','2005-06-27T01:14:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3188','2005-06-20T23:10:27.000','2471','522','2005-06-25T19:37:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3189','2005-06-20T23:19:33.000','1502','538','2005-06-24T17:46:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3190','2005-06-20T23:27:15.000','351','200','2005-06-28T01:22:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3191','2005-06-20T23:46:39.000','4358','522','2005-06-25T03:21:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3192','2005-06-20T23:49:12.000','3713','11','2005-06-24T03:00:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3193','2005-06-20T23:52:30.000','3176','260','2005-06-22T21:21:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3194','2005-06-20T23:59:57.000','1835','432','2005-06-24T19:21:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3195','2005-06-21T00:02:10.000','2383','165','2005-06-21T23:11:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3196','2005-06-21T00:02:28.000','1575','52','2005-06-22T23:08:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3197','2005-06-21T00:07:23.000','1811','362','2005-06-23T00:53:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3198','2005-06-21T00:08:54.000','1626','295','2005-06-29T02:11:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3199','2005-06-21T00:12:40.000','3824','234','2005-06-27T23:26:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3200','2005-06-21T00:22:47.000','4117','221','2005-06-27T05:52:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3201','2005-06-21T00:30:26.000','6','597','2005-06-28T03:42:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3202','2005-06-21T00:33:47.000','2725','273','2005-06-24T04:05:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3203','2005-06-21T00:34:56.000','442','158','2005-06-29T23:30:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3204','2005-06-21T00:37:50.000','2848','336','2005-06-22T23:46:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3205','2005-06-21T00:38:47.000','2964','31','2005-06-21T22:49:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3206','2005-06-21T00:39:39.000','2196','350','2005-06-22T05:12:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3207','2005-06-21T00:43:16.000','4020','86','2005-06-24T22:13:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3208','2005-06-21T00:50:03.000','3169','229','2005-06-24T06:15:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3209','2005-06-21T00:51:06.000','287','307','2005-06-22T21:49:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3210','2005-06-21T01:00:25.000','467','75','2005-06-23T06:10:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3211','2005-06-21T01:01:29.000','1150','415','2005-06-23T04:05:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3212','2005-06-21T01:04:35.000','4178','21','2005-06-30T00:10:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3213','2005-06-21T01:05:19.000','3832','534','2005-06-27T21:55:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3214','2005-06-21T01:08:26.000','776','142','2005-06-23T03:24:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3215','2005-06-21T01:11:32.000','4140','279','2005-06-26T19:42:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3216','2005-06-21T01:19:37.000','719','534','2005-06-29T06:45:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3217','2005-06-21T01:28:12.000','1027','463','2005-06-25T02:51:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3218','2005-06-21T01:38:09.000','1828','117','2005-06-23T02:00:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3219','2005-06-21T01:43:26.000','3024','129','2005-06-28T23:50:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3220','2005-06-21T01:46:25.000','1880','574','2005-06-26T07:44:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3221','2005-06-21T01:49:47.000','245','454','2005-06-25T06:31:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3222','2005-06-21T01:50:29.000','4023','501','2005-06-27T00:52:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3223','2005-06-21T02:06:45.000','1033','299','2005-06-22T07:16:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3224','2005-06-21T02:11:36.000','3318','173','2005-06-23T21:17:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3225','2005-06-21T02:16:55.000','1003','448','2005-06-27T05:39:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3226','2005-06-21T02:18:14.000','4079','576','2005-06-26T22:32:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3227','2005-06-21T02:18:25.000','1156','568','2005-06-27T00:59:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3228','2005-06-21T02:20:24.000','2489','535','2005-06-29T00:50:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3229','2005-06-21T02:20:41.000','2301','81','2005-06-26T00:39:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3230','2005-06-21T02:23:16.000','215','83','2005-06-22T01:37:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3231','2005-06-21T02:25:00.000','237','28','2005-06-23T05:46:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3232','2005-06-21T02:30:37.000','1972','555','2005-06-29T03:10:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3233','2005-06-21T02:39:31.000','3542','353','2005-06-28T05:23:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3234','2005-06-21T02:39:44.000','3252','459','2005-06-29T07:27:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3235','2005-06-21T02:46:17.000','212','49','2005-06-22T20:58:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3236','2005-06-21T02:47:43.000','1492','550','2005-06-29T08:04:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3237','2005-06-21T02:47:56.000','4399','466','2005-06-27T03:16:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3238','2005-06-21T02:48:21.000','2732','77','2005-06-23T04:43:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3239','2005-06-21T02:48:40.000','3402','328','2005-06-22T02:49:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3240','2005-06-21T02:53:17.000','2938','405','2005-06-30T03:25:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3241','2005-06-21T02:54:32.000','1442','499','2005-06-26T21:56:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3242','2005-06-21T02:56:24.000','1421','562','2005-06-29T21:41:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3243','2005-06-21T03:00:11.000','2556','426','2005-06-25T21:53:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3244','2005-06-21T03:01:10.000','291','53','2005-06-24T06:59:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3245','2005-06-21T03:06:11.000','2057','358','2005-06-25T08:06:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3246','2005-06-21T03:10:01.000','4432','41','2005-06-28T00:46:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3247','2005-06-21T03:12:15.000','1406','277','2005-06-27T00:44:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3248','2005-06-21T03:12:21.000','3656','78','2005-06-28T03:54:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3249','2005-06-21T03:13:19.000','703','410','2005-06-29T04:04:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3250','2005-06-21T03:16:36.000','736','467','2005-06-29T00:53:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3251','2005-06-21T03:20:37.000','1414','317','2005-06-23T04:54:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3252','2005-06-21T03:25:26.000','2009','213','2005-06-24T00:38:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3253','2005-06-21T03:25:37.000','1906','405','2005-06-27T02:46:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3254','2005-06-21T03:27:10.000','3893','472','2005-06-22T22:01:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3255','2005-06-21T03:39:52.000','2564','482','2005-06-24T04:02:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3256','2005-06-21T03:45:42.000','1235','319','2005-06-30T02:51:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3257','2005-06-21T03:47:19.000','3975','263','2005-06-28T01:24:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3258','2005-06-21T03:53:58.000','4417','241','2005-06-22T22:49:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3259','2005-06-21T03:57:15.000','2751','478','2005-06-24T03:32:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3260','2005-06-21T03:59:13.000','3627','380','2005-06-23T03:29:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3261','2005-06-21T04:07:41.000','2029','169','2005-06-24T06:25:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3262','2005-06-21T04:08:43.000','3773','9','2005-06-28T02:55:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3263','2005-06-21T04:15:52.000','3491','118','2005-06-24T02:19:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3264','2005-06-21T04:19:03.000','1666','340','2005-06-23T01:29:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3265','2005-06-21T04:23:13.000','3637','437','2005-06-28T03:37:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3266','2005-06-21T04:49:07.000','2533','175','2005-06-26T05:19:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3267','2005-06-21T04:55:21.000','1118','134','2005-06-29T23:46:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3268','2005-06-21T04:55:49.000','4366','329','2005-06-30T00:23:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3269','2005-06-21T05:06:30.000','3828','17','2005-06-27T09:26:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3270','2005-06-21T05:07:31.000','1578','86','2005-06-22T07:45:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3271','2005-06-21T05:16:10.000','4191','196','2005-06-27T10:46:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3272','2005-06-21T05:18:27.000','1090','550','2005-06-30T02:51:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3273','2005-06-21T05:24:17.000','3538','104','2005-06-23T01:21:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3274','2005-06-21T05:30:36.000','2156','277','2005-06-24T05:12:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3275','2005-06-21T05:33:04.000','2320','368','2005-06-30T00:37:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3276','2005-06-21T05:35:52.000','1890','425','2005-06-29T03:26:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3277','2005-06-21T05:36:37.000','1330','229','2005-06-29T10:54:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3278','2005-06-21T05:41:30.000','2832','554','2005-06-22T03:43:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3279','2005-06-21T06:05:53.000','1672','462','2005-06-25T09:40:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3280','2005-06-21T06:08:12.000','661','229','2005-06-24T09:34:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3281','2005-06-21T06:08:47.000','4006','363','2005-06-24T11:22:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3282','2005-06-21T06:18:42.000','1676','224','2005-06-28T09:18:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3283','2005-06-21T06:19:07.000','3988','372','2005-06-26T10:59:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3284','2005-06-21T06:24:45.000','4566','1','2005-06-28T03:28:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3285','2005-06-21T06:30:13.000','948','481','2005-06-23T10:31:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3286','2005-06-21T06:31:29.000','742','577','2005-06-25T00:46:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3287','2005-06-21T06:32:39.000','4406','62','2005-06-24T09:29:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3288','2005-06-21T06:36:59.000','1961','299','2005-06-30T06:50:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3289','2005-06-21T06:41:48.000','2248','115','2005-06-30T00:54:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3290','2005-06-21T06:45:34.000','2727','293','2005-06-28T09:44:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3291','2005-06-21T06:55:36.000','3866','274','2005-06-29T03:41:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3292','2005-06-21T06:59:11.000','3288','412','2005-06-23T07:11:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3293','2005-06-21T06:59:33.000','4407','481','2005-06-25T06:54:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3294','2005-06-21T07:03:23.000','2390','439','2005-06-30T02:22:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3295','2005-06-21T07:04:17.000','1703','573','2005-06-29T01:52:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3296','2005-06-21T07:04:53.000','2453','284','2005-06-25T08:36:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3297','2005-06-21T07:08:19.000','3969','193','2005-06-28T11:53:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3298','2005-06-21T07:09:44.000','444','492','2005-06-30T11:26:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3299','2005-06-21T07:23:34.000','3427','199','2005-06-27T04:02:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3300','2005-06-21T07:25:01.000','2505','565','2005-06-25T01:47:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3301','2005-06-21T07:32:25.000','503','444','2005-06-28T06:26:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3302','2005-06-21T07:33:40.000','562','594','2005-06-29T06:02:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3303','2005-06-21T07:34:14.000','1565','361','2005-06-26T13:18:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3304','2005-06-21T07:43:40.000','2154','431','2005-06-27T08:06:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3305','2005-06-21T07:46:57.000','2811','578','2005-06-27T06:16:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3306','2005-06-21T07:46:58.000','1669','406','2005-06-26T11:22:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3307','2005-06-21T07:52:30.000','462','85','2005-06-25T02:36:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3308','2005-06-21T07:58:36.000','3129','96','2005-06-23T05:23:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3309','2005-06-21T08:00:49.000','248','463','2005-06-29T04:11:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3310','2005-06-21T08:04:51.000','1717','395','2005-06-22T04:20:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3311','2005-06-21T08:05:27.000','3438','518','2005-06-22T06:51:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3312','2005-06-21T08:05:32.000','1008','554','2005-06-27T03:34:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3313','2005-06-21T08:11:18.000','4267','213','2005-06-23T04:28:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3314','2005-06-21T08:17:00.000','4332','185','2005-06-22T06:00:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3315','2005-06-21T08:17:04.000','4108','438','2005-06-24T11:04:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3316','2005-06-21T08:20:18.000','3271','451','2005-06-28T07:44:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3317','2005-06-21T08:22:32.000','4095','584','2005-06-26T14:18:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3318','2005-06-21T08:23:05.000','1111','414','2005-06-27T14:07:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3319','2005-06-21T08:25:46.000','2482','461','2005-06-27T03:54:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3320','2005-06-21T08:29:41.000','860','47','2005-06-29T13:54:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3321','2005-06-21T08:33:26.000','1750','144','2005-06-24T10:09:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3322','2005-06-21T08:42:37.000','4324','458','2005-06-22T13:17:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3323','2005-06-21T08:45:33.000','2252','272','2005-06-28T08:17:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3324','2005-06-21T08:49:16.000','2830','29','2005-06-22T12:31:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3325','2005-06-21T08:51:44.000','1720','185','2005-06-27T06:16:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3326','2005-06-21T09:04:50.000','1025','347','2005-06-30T12:10:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3327','2005-06-21T09:04:50.000','3083','62','2005-06-30T05:45:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3328','2005-06-21T09:08:44.000','2462','292','2005-06-30T12:28:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3329','2005-06-21T09:20:31.000','3506','335','2005-06-22T10:00:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3330','2005-06-21T09:22:37.000','299','294','2005-06-23T07:16:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3331','2005-06-21T09:37:53.000','2913','352','2005-06-26T04:01:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3332','2005-06-21T09:55:12.000','1975','82','2005-06-25T08:32:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3333','2005-06-21T10:01:36.000','3688','111','2005-06-25T10:27:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3334','2005-06-21T10:04:33.000','2491','66','2005-06-29T06:09:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3335','2005-06-21T10:09:08.000','3033','339','2005-06-27T11:33:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3336','2005-06-21T10:14:27.000','2122','173','2005-06-22T09:29:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3337','2005-06-21T10:24:35.000','1176','318','2005-06-22T13:51:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3338','2005-06-21T10:27:31.000','2097','171','2005-06-30T14:15:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3339','2005-06-21T10:37:11.000','312','526','2005-06-30T05:04:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3340','2005-06-21T10:37:23.000','2962','540','2005-06-26T07:21:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3341','2005-06-21T10:37:25.000','2189','591','2005-06-26T15:38:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3342','2005-06-21T10:46:36.000','2884','196','2005-06-23T09:46:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3343','2005-06-21T10:56:59.000','2038','466','2005-06-25T16:41:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3344','2005-06-21T10:57:27.000','4401','277','2005-06-28T10:53:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3345','2005-06-21T11:05:07.000','4442','71','2005-06-26T15:14:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3346','2005-06-21T11:06:53.000','4393','189','2005-06-22T15:19:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3347','2005-06-21T11:08:32.000','4330','448','2005-06-28T09:59:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3348','2005-06-21T11:16:42.000','2945','16','2005-06-27T13:50:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3349','2005-06-21T11:17:35.000','3885','336','2005-06-22T12:51:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3350','2005-06-21T11:21:38.000','3221','20','2005-06-28T15:37:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3351','2005-06-21T11:21:39.000','1591','386','2005-06-23T07:23:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3352','2005-06-21T11:26:29.000','578','510','2005-06-28T07:26:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3353','2005-06-21T11:29:23.000','3984','236','2005-06-27T15:06:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3354','2005-06-21T11:29:49.000','1083','529','2005-06-25T07:39:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3355','2005-06-21T11:30:47.000','1960','275','2005-06-23T06:04:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3356','2005-06-21T11:38:45.000','4532','403','2005-06-26T17:18:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3357','2005-06-21T11:55:42.000','2528','57','2005-06-22T07:19:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3358','2005-06-21T11:56:40.000','1772','69','2005-06-26T08:28:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3359','2005-06-21T12:08:18.000','3825','67','2005-06-25T16:35:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3360','2005-06-21T12:12:41.000','2792','498','2005-06-26T06:32:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3361','2005-06-21T12:14:23.000','2671','268','2005-06-26T10:01:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3362','2005-06-21T12:19:54.000','1284','454','2005-06-23T06:59:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3363','2005-06-21T12:25:07.000','538','261','2005-06-27T11:52:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3364','2005-06-21T12:37:46.000','2329','201','2005-06-28T07:18:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3365','2005-06-21T12:55:48.000','657','133','2005-06-23T13:38:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3366','2005-06-21T13:03:37.000','2584','511','2005-06-26T16:29:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3367','2005-06-21T13:08:21.000','2442','80','2005-06-26T08:43:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3368','2005-06-21T13:18:38.000','548','438','2005-06-23T11:13:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3369','2005-06-21T13:20:31.000','303','431','2005-06-30T13:45:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3370','2005-06-21T13:27:01.000','1573','559','2005-06-25T09:27:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3371','2005-06-21T13:27:22.000','2526','595','2005-06-29T14:04:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3372','2005-06-21T13:34:19.000','4169','346','2005-06-27T08:41:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3373','2005-06-21T13:35:32.000','2219','316','2005-06-30T12:03:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3374','2005-06-21T13:36:30.000','1067','279','2005-06-23T15:10:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3375','2005-06-21T13:37:18.000','912','279','2005-06-22T11:26:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3376','2005-06-21T13:43:02.000','3055','318','2005-06-28T18:07:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3377','2005-06-21T13:51:12.000','1845','428','2005-06-22T18:16:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3378','2005-06-21T13:51:28.000','35','387','2005-06-25T09:21:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3379','2005-06-21T13:54:58.000','2022','566','2005-06-23T13:43:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3380','2005-06-21T13:58:46.000','3212','483','2005-06-30T09:29:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3381','2005-06-21T14:02:59.000','1373','183','2005-06-29T18:11:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3382','2005-06-21T14:05:23.000','131','341','2005-06-29T19:13:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3383','2005-06-21T14:07:19.000','2968','239','2005-06-29T17:00:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3384','2005-06-21T14:07:35.000','409','91','2005-06-26T16:34:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3385','2005-06-21T14:16:48.000','2810','514','2005-06-24T10:32:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3386','2005-06-21T14:21:06.000','1224','190','2005-06-24T08:32:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3387','2005-06-21T14:21:49.000','2709','305','2005-06-24T16:46:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3388','2005-06-21T14:34:51.000','556','119','2005-06-28T18:19:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3389','2005-06-21T14:37:55.000','727','395','2005-06-28T18:13:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3390','2005-06-21T15:10:50.000','2034','151','2005-06-26T12:38:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3391','2005-06-21T15:11:02.000','26','45','2005-06-25T14:12:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3392','2005-06-21T15:12:44.000','3343','38','2005-06-29T18:19:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3393','2005-06-21T15:14:27.000','1631','362','2005-06-25T19:54:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3394','2005-06-21T15:17:39.000','3393','295','2005-06-30T13:55:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3395','2005-06-21T15:19:19.000','3764','66','2005-06-29T14:23:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3396','2005-06-21T15:23:08.000','2744','371','2005-06-23T10:25:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3397','2005-06-21T15:30:11.000','602','552','2005-06-22T21:12:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3398','2005-06-21T15:34:38.000','221','599','2005-06-29T11:23:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3399','2005-06-21T15:47:48.000','619','98','2005-06-26T13:46:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3400','2005-06-21T15:50:30.000','1697','298','2005-06-25T18:07:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3401','2005-06-21T15:52:43.000','3423','577','2005-06-30T21:09:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3402','2005-06-21T15:54:37.000','596','187','2005-06-30T13:43:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3403','2005-06-21T15:55:06.000','1741','264','2005-06-27T12:34:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3404','2005-06-21T15:57:52.000','2005','424','2005-06-24T20:58:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3405','2005-06-21T15:58:25.000','2344','155','2005-06-23T10:58:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3406','2005-06-21T16:00:18.000','2049','203','2005-06-23T18:25:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3407','2005-06-21T16:14:02.000','3919','343','2005-06-24T15:38:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3408','2005-06-21T16:15:11.000','3453','282','2005-06-27T14:55:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3409','2005-06-21T16:17:38.000','3374','429','2005-06-22T14:16:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3410','2005-06-21T16:20:47.000','1197','321','2005-06-24T19:09:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3411','2005-06-21T16:31:27.000','4250','12','2005-06-28T12:27:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3412','2005-06-21T16:44:31.000','3036','501','2005-06-28T16:15:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3413','2005-06-21T16:57:07.000','666','322','2005-06-30T12:03:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3414','2005-06-21T16:58:50.000','2929','226','2005-06-24T17:26:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3415','2005-06-21T16:59:49.000','3540','444','2005-06-27T17:19:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3416','2005-06-21T17:05:29.000','1215','76','2005-06-23T17:58:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3417','2005-06-21T17:06:20.000','874','282','2005-06-23T17:00:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3418','2005-06-21T17:06:38.000','4115','85','2005-06-25T19:43:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3419','2005-06-21T17:18:01.000','4022','22','2005-06-22T15:08:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3420','2005-06-21T17:22:36.000','2523','27','2005-06-28T12:34:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3421','2005-06-21T17:22:58.000','3930','346','2005-06-24T18:57:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3422','2005-06-21T17:24:40.000','2724','251','2005-06-29T13:59:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3423','2005-06-21T17:38:02.000','3612','19','2005-06-23T19:47:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3424','2005-06-21T17:42:51.000','1279','583','2005-06-24T23:22:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3425','2005-06-21T18:07:07.000','4548','381','2005-06-27T22:59:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3426','2005-06-21T18:12:10.000','3019','95','2005-06-23T18:22:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3427','2005-06-21T18:31:09.000','560','561','2005-06-22T14:18:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3428','2005-06-21T18:39:34.000','1959','40','2005-06-22T18:23:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3429','2005-06-21T18:46:05.000','456','599','2005-06-30T17:28:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3430','2005-06-21T18:46:08.000','1613','503','2005-06-22T13:49:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3431','2005-06-21T18:46:48.000','133','516','2005-06-26T23:08:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3432','2005-06-21T19:02:03.000','1814','216','2005-06-25T00:57:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3433','2005-06-21T19:07:19.000','1077','228','2005-06-29T18:01:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3434','2005-06-21T19:08:28.000','2295','141','2005-06-23T14:25:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3435','2005-06-21T19:14:58.000','451','591','2005-06-24T19:58:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3436','2005-06-21T19:16:09.000','2740','137','2005-06-30T13:58:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3437','2005-06-21T19:20:17.000','1798','211','2005-07-01T01:09:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3438','2005-06-21T19:31:40.000','1757','556','2005-06-30T19:08:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3439','2005-06-21T19:36:15.000','1529','46','2005-06-23T14:54:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3440','2005-06-21T19:58:18.000','853','491','2005-06-27T22:08:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3441','2005-06-21T20:00:12.000','2863','326','2005-06-24T00:24:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3442','2005-06-21T20:06:51.000','1896','255','2005-06-25T17:35:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3443','2005-06-21T20:19:00.000','1639','377','2005-06-30T15:39:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3444','2005-06-21T20:39:39.000','493','45','2005-06-25T23:44:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3445','2005-06-21T20:40:28.000','2381','74','2005-06-29T00:47:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3446','2005-06-21T20:45:51.000','1817','174','2005-06-26T17:02:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3447','2005-06-21T20:53:31.000','1146','25','2005-06-24T02:20:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3448','2005-06-21T20:59:20.000','592','476','2005-06-24T15:40:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3449','2005-06-21T21:01:27.000','210','181','2005-06-27T21:20:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3450','2005-06-21T21:01:57.000','2268','126','2005-06-25T23:57:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3451','2005-06-21T21:10:39.000','3489','558','2005-06-30T19:03:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3452','2005-06-21T21:11:27.000','2646','293','2005-06-24T16:31:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3453','2005-06-21T21:12:11.000','842','278','2005-06-23T17:39:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3454','2005-06-21T21:12:13.000','3009','524','2005-06-25T23:23:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3455','2005-06-21T21:17:51.000','4403','340','2005-06-23T17:22:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3456','2005-06-21T21:19:47.000','1119','150','2005-06-28T18:18:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3457','2005-06-21T21:42:33.000','883','312','2005-06-30T19:54:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3458','2005-06-21T21:42:49.000','2136','338','2005-06-29T01:26:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3459','2005-06-21T21:45:47.000','3080','97','2005-06-25T00:46:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3460','2005-06-21T21:46:56.000','1765','236','2005-06-29T20:08:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3461','2005-06-21T21:49:18.000','1715','23','2005-06-26T19:51:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3462','2005-06-21T21:52:52.000','547','568','2005-06-28T21:41:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3463','2005-06-21T22:00:00.000','3436','96','2005-06-22T19:22:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3464','2005-06-21T22:08:58.000','2698','251','2005-06-26T16:23:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3465','2005-06-21T22:10:01.000','1488','510','2005-06-30T21:35:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3466','2005-06-21T22:13:33.000','371','226','2005-06-25T21:01:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3467','2005-06-21T22:19:25.000','729','543','2005-06-27T00:03:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3468','2005-06-21T22:43:45.000','2899','100','2005-06-30T01:49:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3469','2005-06-21T22:48:59.000','4087','181','2005-06-28T19:32:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3470','2005-07-05T22:49:24.000','883','565','2005-07-07T19:36:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3471','2005-07-05T22:51:44.000','1724','242','2005-07-13T01:38:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3472','2005-07-05T22:56:33.000','841','37','2005-07-13T17:18:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3473','2005-07-05T22:57:34.000','2735','60','2005-07-12T23:53:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3474','2005-07-05T22:59:53.000','97','594','2005-07-08T20:32:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3475','2005-07-05T23:01:21.000','2189','8','2005-07-13T23:07:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3476','2005-07-05T23:02:37.000','3011','490','2005-07-10T22:17:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3477','2005-07-05T23:05:17.000','4289','476','2005-07-15T02:20:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3478','2005-07-05T23:05:44.000','2528','322','2005-07-07T00:14:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3479','2005-07-05T23:08:53.000','2277','298','2005-07-11T21:42:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3480','2005-07-05T23:11:43.000','1488','382','2005-07-12T02:01:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3481','2005-07-05T23:13:07.000','3575','138','2005-07-07T20:36:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3482','2005-07-05T23:13:22.000','1291','520','2005-07-12T19:02:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3483','2005-07-05T23:13:51.000','79','536','2005-07-13T18:31:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3484','2005-07-05T23:23:11.000','1934','114','2005-07-11T00:27:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3485','2005-07-05T23:25:54.000','117','111','2005-07-09T17:38:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3486','2005-07-05T23:29:55.000','4067','296','2005-07-13T19:54:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3487','2005-07-05T23:30:36.000','1575','586','2005-07-11T04:00:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3488','2005-07-05T23:32:49.000','898','349','2005-07-15T02:01:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3489','2005-07-05T23:33:40.000','2936','397','2005-07-15T02:15:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3490','2005-07-05T23:37:13.000','3041','369','2005-07-12T22:07:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3491','2005-07-05T23:41:08.000','1835','421','2005-07-13T21:53:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3492','2005-07-05T23:44:37.000','980','142','2005-07-14T03:54:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3493','2005-07-05T23:46:19.000','473','169','2005-07-15T02:31:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3494','2005-07-05T23:47:30.000','3149','348','2005-07-11T18:10:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3495','2005-07-05T23:50:04.000','2306','553','2005-07-10T01:06:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3496','2005-07-05T23:59:15.000','2430','295','2005-07-09T19:39:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3497','2005-07-06T00:00:03.000','1970','299','2005-07-09T01:27:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3498','2005-07-06T00:02:08.000','1869','444','2005-07-10T00:19:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3499','2005-07-06T00:04:20.000','1850','520','2005-07-14T21:12:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3500','2005-07-06T00:11:13.000','2447','32','2005-07-13T19:01:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3501','2005-07-06T00:11:28.000','2219','270','2005-07-10T20:32:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3502','2005-07-06T00:15:06.000','1026','126','2005-07-13T01:35:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3503','2005-07-06T00:17:24.000','2944','449','2005-07-08T03:47:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3504','2005-07-06T00:18:29.000','268','209','2005-07-10T00:24:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3505','2005-07-06T00:19:32.000','2630','331','2005-07-14T20:14:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3506','2005-07-06T00:22:29.000','19','459','2005-07-07T22:15:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3507','2005-07-06T00:23:43.000','166','480','2005-07-15T04:19:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3508','2005-07-06T00:24:25.000','2381','34','2005-07-10T05:38:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3509','2005-07-06T00:24:57.000','4394','182','2005-07-09T18:48:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3510','2005-07-06T00:27:41.000','2250','443','2005-07-14T23:20:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3511','2005-07-06T00:42:01.000','2128','494','2005-07-09T23:08:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3512','2005-07-06T00:43:06.000','371','291','2005-07-12T06:18:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3513','2005-07-06T00:45:57.000','4225','223','2005-07-11T19:04:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3514','2005-07-06T00:46:54.000','4546','536','2005-07-09T05:47:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3515','2005-07-06T00:48:55.000','3220','131','2005-07-09T00:15:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3516','2005-07-06T00:50:30.000','385','338','2005-07-09T19:12:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3517','2005-07-06T00:52:35.000','2762','314','2005-07-08T20:10:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3518','2005-07-06T00:56:03.000','2502','167','2005-07-14T02:27:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3519','2005-07-06T00:57:29.000','4314','320','2005-07-10T21:12:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3520','2005-07-06T00:58:27.000','2872','102','2005-07-14T05:56:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3521','2005-07-06T01:00:11.000','1440','262','2005-07-11T19:15:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3522','2005-07-06T01:00:21.000','4522','469','2005-07-11T01:18:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3523','2005-07-06T01:01:38.000','2171','549','2005-07-10T20:24:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3524','2005-07-06T01:01:51.000','1626','88','2005-07-11T19:52:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3525','2005-07-06T01:02:39.000','208','51','2005-07-14T02:27:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3526','2005-07-06T01:03:29.000','3871','469','2005-07-15T01:22:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3527','2005-07-06T01:11:08.000','4537','389','2005-07-08T01:21:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3528','2005-07-06T01:13:27.000','1954','201','2005-07-06T23:45:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3529','2005-07-06T01:15:26.000','4316','350','2005-07-07T04:28:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3530','2005-07-06T01:22:45.000','4542','168','2005-07-10T03:23:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3531','2005-07-06T01:24:08.000','1890','165','2005-07-11T22:00:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3532','2005-07-06T01:24:38.000','2635','274','2005-07-11T06:42:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3533','2005-07-06T01:26:44.000','2028','206','2005-07-14T21:37:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3534','2005-07-06T01:32:27.000','2055','283','2005-07-08T23:14:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3535','2005-07-06T01:32:46.000','4214','65','2005-07-11T03:15:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3536','2005-07-06T01:36:11.000','2328','339','2005-07-12T20:00:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3537','2005-07-06T01:36:53.000','4220','479','2005-07-13T07:01:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3538','2005-07-06T01:37:07.000','4361','228','2005-07-11T06:02:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3539','2005-07-06T01:39:08.000','4081','444','2005-07-07T05:38:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3540','2005-07-06T01:47:20.000','1295','97','2005-07-08T23:48:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3541','2005-07-06T01:50:11.000','1204','501','2005-07-12T03:24:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3542','2005-07-06T01:51:42.000','4391','593','2005-07-11T03:29:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3543','2005-07-06T02:01:08.000','3997','394','2005-07-07T03:14:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3544','2005-07-06T02:06:32.000','3098','115','2005-07-09T04:35:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3545','2005-07-06T02:16:17.000','3924','442','2005-07-11T00:54:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3546','2005-07-06T02:17:54.000','959','594','2005-07-07T00:19:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3547','2005-07-06T02:18:06.000','2730','239','2005-07-08T05:24:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3548','2005-07-06T02:23:39.000','4498','16','2005-07-08T07:53:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3549','2005-07-06T02:24:55.000','3921','19','2005-07-06T21:40:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3550','2005-07-06T02:29:21.000','2417','15','2005-07-13T05:26:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3551','2005-07-06T02:33:48.000','3602','111','2005-07-13T04:38:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3552','2005-07-06T02:34:09.000','1099','239','2005-07-12T05:31:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3553','2005-07-06T02:35:41.000','4510','422','2005-07-08T06:38:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3554','2005-07-06T02:37:10.000','793','538','2005-07-09T01:58:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3555','2005-07-06T02:45:35.000','869','537','2005-07-10T07:17:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3556','2005-07-06T02:46:13.000','3142','273','2005-07-06T22:08:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3557','2005-07-06T02:48:39.000','3832','292','2005-07-08T22:52:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3558','2005-07-06T02:49:06.000','1742','575','2005-07-15T01:38:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3559','2005-07-06T02:49:42.000','2211','483','2005-07-12T04:44:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3560','2005-07-06T02:51:37.000','888','592','2005-07-10T01:35:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3561','2005-07-06T02:54:33.000','213','231','2005-07-14T07:44:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3562','2005-07-06T02:54:36.000','1660','587','2005-07-11T05:48:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3563','2005-07-06T02:57:01.000','4261','210','2005-07-14T02:25:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3564','2005-07-06T03:02:13.000','1096','402','2005-07-13T01:41:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3565','2005-07-06T03:02:58.000','599','97','2005-07-13T21:31:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3566','2005-07-06T03:08:51.000','2774','392','2005-07-12T05:04:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3567','2005-07-06T03:09:36.000','27','355','2005-07-12T02:15:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3568','2005-07-06T03:11:57.000','2084','283','2005-07-15T03:14:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3569','2005-07-06T03:17:23.000','1929','496','2005-07-14T03:58:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3570','2005-07-06T03:23:43.000','1300','450','2005-07-14T07:28:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3571','2005-07-06T03:32:31.000','4166','580','2005-07-11T06:15:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3572','2005-07-06T03:33:23.000','1915','284','2005-07-08T07:54:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3573','2005-07-06T03:33:48.000','146','66','2005-07-07T22:39:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3574','2005-07-06T03:36:01.000','2799','225','2005-07-10T01:29:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3575','2005-07-06T03:36:19.000','3234','49','2005-07-08T06:21:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3576','2005-07-06T03:40:01.000','324','227','2005-07-15T07:22:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3577','2005-07-06T03:40:36.000','4390','152','2005-07-10T05:54:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3578','2005-07-06T03:47:05.000','2954','263','2005-07-08T02:26:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3579','2005-07-06T03:47:47.000','3309','485','2005-07-08T02:16:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3580','2005-07-06T03:48:44.000','3837','200','2005-07-13T01:15:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3581','2005-07-06T03:57:35.000','4520','235','2005-07-07T08:07:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3582','2005-07-06T04:10:35.000','1866','297','2005-07-11T01:29:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3583','2005-07-06T04:10:43.000','204','574','2005-07-14T22:17:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3584','2005-07-06T04:16:43.000','367','207','2005-07-13T07:08:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3585','2005-07-06T04:22:36.000','2726','266','2005-07-09T06:16:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3586','2005-07-06T04:24:42.000','616','493','2005-07-09T02:37:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3587','2005-07-06T04:27:52.000','462','110','2005-07-13T08:19:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3588','2005-07-06T04:29:13.000','3154','289','2005-07-07T23:49:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3589','2005-07-06T04:30:18.000','3740','137','2005-07-10T09:18:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3590','2005-07-06T04:35:12.000','1510','283','2005-07-10T05:14:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3591','2005-07-06T04:37:10.000','1241','53','2005-07-09T23:32:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3592','2005-07-06T04:38:50.000','1272','286','2005-07-15T06:36:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3593','2005-07-06T04:39:52.000','619','78','2005-07-11T23:20:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3594','2005-07-06T04:42:47.000','4566','522','2005-07-10T00:49:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3595','2005-07-06T04:59:49.000','1431','92','2005-07-15T06:26:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3596','2005-07-06T05:03:11.000','594','419','2005-07-07T05:30:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3597','2005-07-06T05:03:59.000','4080','35','2005-07-13T06:49:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3598','2005-07-06T05:11:04.000','1317','68','2005-07-09T02:03:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3599','2005-07-06T05:16:36.000','3262','577','2005-07-13T07:14:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3600','2005-07-06T05:19:42.000','2748','511','2005-07-11T00:34:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3601','2005-07-06T05:20:25.000','2806','205','2005-07-15T03:13:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3602','2005-07-06T05:23:10.000','2192','100','2005-07-15T03:22:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3603','2005-07-06T05:25:03.000','2442','330','2005-07-12T08:14:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3604','2005-07-06T05:25:22.000','1380','242','2005-07-07T23:52:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3605','2005-07-06T05:27:15.000','384','347','2005-07-10T00:05:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3606','2005-07-06T05:28:02.000','1737','166','2005-07-10T04:51:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3607','2005-07-06T05:30:09.000','542','335','2005-07-08T01:36:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3608','2005-07-06T05:35:39.000','3095','368','2005-07-10T07:46:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3609','2005-07-06T05:36:22.000','1064','373','2005-07-10T05:55:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3610','2005-07-06T05:36:59.000','1509','348','2005-07-13T07:07:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3611','2005-07-06T05:37:18.000','4502','86','2005-07-10T05:14:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3612','2005-07-06T05:37:26.000','2465','402','2005-07-14T01:51:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3613','2005-07-06T05:45:53.000','3776','331','2005-07-07T10:02:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3614','2005-07-06T05:46:05.000','853','502','2005-07-11T01:24:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3615','2005-07-06T05:47:47.000','711','49','2005-07-11T05:01:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3616','2005-07-06T05:52:13.000','557','571','2005-07-10T10:24:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3617','2005-07-06T05:58:06.000','1337','125','2005-07-13T02:10:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3618','2005-07-06T05:58:45.000','330','264','2005-07-15T09:13:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3619','2005-07-06T05:59:44.000','3350','526','2005-07-11T08:58:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3620','2005-07-06T06:01:50.000','1661','88','2005-07-08T05:04:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3621','2005-07-06T06:03:55.000','3132','171','2005-07-11T09:25:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3622','2005-07-06T06:05:04.000','3489','454','2005-07-12T03:14:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3623','2005-07-06T06:05:23.000','430','80','2005-07-07T05:59:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3624','2005-07-06T06:06:27.000','1778','115','2005-07-13T08:30:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3625','2005-07-06T06:12:52.000','1133','175','2005-07-12T07:37:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3626','2005-07-06T06:15:35.000','1599','337','2005-07-10T10:18:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3627','2005-07-06T06:19:25.000','1087','322','2005-07-11T05:53:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3628','2005-07-06T06:19:43.000','3509','588','2005-07-07T02:23:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3629','2005-07-06T06:23:22.000','4019','441','2005-07-08T09:32:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3630','2005-07-06T06:27:15.000','2448','102','2005-07-12T10:36:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3631','2005-07-06T06:36:53.000','4068','47','2005-07-07T10:32:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3632','2005-07-06T06:38:21.000','2583','366','2005-07-11T03:19:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3633','2005-07-06T06:43:26.000','2978','95','2005-07-10T04:54:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3634','2005-07-06T06:51:14.000','3688','245','2005-07-10T02:30:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3635','2005-07-06T06:55:36.000','421','250','2005-07-09T07:57:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3636','2005-07-06T07:03:52.000','3379','591','2005-07-08T03:14:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3637','2005-07-06T07:06:31.000','3823','380','2005-07-10T02:11:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3638','2005-07-06T07:08:17.000','190','452','2005-07-13T12:30:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3639','2005-07-06T07:09:17.000','2812','7','2005-07-15T05:12:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3640','2005-07-06T07:12:26.000','3432','271','2005-07-10T04:54:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3641','2005-07-06T07:17:09.000','3834','79','2005-07-11T07:25:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3642','2005-07-06T07:18:20.000','4204','166','2005-07-09T01:37:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3643','2005-07-06T07:20:08.000','845','176','2005-07-11T07:01:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3644','2005-07-06T07:20:11.000','4309','403','2005-07-11T10:26:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3645','2005-07-06T07:22:09.000','3390','236','2005-07-10T11:45:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3646','2005-07-06T07:28:59.000','3591','322','2005-07-11T05:19:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3647','2005-07-06T07:29:17.000','3762','145','2005-07-13T08:32:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3648','2005-07-06T07:30:41.000','2810','598','2005-07-10T06:00:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3649','2005-07-06T07:32:42.000','3564','24','2005-07-12T09:37:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3650','2005-07-06T07:34:15.000','3606','482','2005-07-08T01:50:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3651','2005-07-06T07:40:31.000','3323','170','2005-07-08T03:39:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3652','2005-07-06T07:44:30.000','1231','518','2005-07-08T04:41:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3653','2005-07-06T07:45:13.000','2513','148','2005-07-10T11:51:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3654','2005-07-06T07:45:31.000','1621','528','2005-07-12T09:59:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3655','2005-07-06T07:52:54.000','1540','493','2005-07-15T10:49:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3656','2005-07-06T07:55:22.000','4544','314','2005-07-13T10:36:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3657','2005-07-06T07:55:30.000','4134','113','2005-07-11T07:18:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3658','2005-07-06T08:01:08.000','3453','253','2005-07-15T06:36:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3659','2005-07-06T08:03:14.000','2271','330','2005-07-12T09:50:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3660','2005-07-06T08:07:29.000','1129','507','2005-07-14T08:46:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3661','2005-07-06T08:10:02.000','2600','442','2005-07-10T10:17:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3662','2005-07-06T08:11:48.000','3827','334','2005-07-09T12:25:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3663','2005-07-06T08:15:47.000','2646','566','2005-07-07T08:57:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3664','2005-07-06T08:15:57.000','3366','528','2005-07-08T06:11:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3665','2005-07-06T08:23:08.000','922','102','2005-07-13T13:38:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3666','2005-07-06T08:27:43.000','4212','347','2005-07-09T07:37:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3667','2005-07-06T08:36:34.000','447','373','2005-07-15T04:25:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3668','2005-07-06T08:36:48.000','269','514','2005-07-10T11:31:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3669','2005-07-06T08:38:29.000','1299','530','2005-07-10T05:28:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3670','2005-07-06T08:56:43.000','4271','268','2005-07-11T09:11:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3671','2005-07-06T09:01:29.000','2821','179','2005-07-15T08:08:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3672','2005-07-06T09:01:56.000','3883','283','2005-07-11T14:18:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3673','2005-07-06T09:02:09.000','1837','88','2005-07-15T06:45:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3674','2005-07-06T09:03:13.000','3686','559','2005-07-13T08:43:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3675','2005-07-06T09:09:19.000','3662','282','2005-07-12T08:51:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3676','2005-07-06T09:10:37.000','1967','137','2005-07-14T08:24:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3677','2005-07-06T09:11:58.000','600','5','2005-07-08T10:50:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3678','2005-07-06T09:15:15.000','3861','364','2005-07-10T05:01:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3679','2005-07-06T09:15:57.000','2186','547','2005-07-08T03:20:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3680','2005-07-06T09:16:10.000','2427','82','2005-07-08T07:52:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3681','2005-07-06T09:19:30.000','3325','294','2005-07-11T09:40:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3682','2005-07-06T09:22:48.000','2597','98','2005-07-14T11:17:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3683','2005-07-06T09:25:56.000','3020','43','2005-07-14T12:10:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3684','2005-07-06T09:29:22.000','3261','395','2005-07-12T08:19:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3685','2005-07-06T09:30:45.000','2015','58','2005-07-11T15:16:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3686','2005-07-06T09:37:50.000','376','548','2005-07-09T10:15:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3687','2005-07-06T09:38:33.000','2040','207','2005-07-14T07:50:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3688','2005-07-06T09:41:53.000','1102','380','2005-07-14T10:30:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3689','2005-07-06T09:43:01.000','3168','129','2005-07-11T09:57:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3690','2005-07-06T09:46:03.000','4405','435','2005-07-07T12:12:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3691','2005-07-06T09:46:12.000','1937','478','2005-07-07T14:08:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3692','2005-07-06T09:54:12.000','1237','286','2005-07-11T09:42:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3693','2005-07-06T09:56:09.000','2989','545','2005-07-15T06:50:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3694','2005-07-06T10:01:23.000','3848','419','2005-07-08T11:44:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3695','2005-07-06T10:02:08.000','2823','441','2005-07-09T15:43:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3696','2005-07-06T10:04:55.000','3244','497','2005-07-11T15:58:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3697','2005-07-06T10:07:22.000','1223','182','2005-07-13T14:04:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3698','2005-07-06T10:09:20.000','1263','461','2005-07-08T15:49:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3699','2005-07-06T10:11:25.000','418','262','2005-07-14T05:18:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3700','2005-07-06T10:12:19.000','343','72','2005-07-07T14:21:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3701','2005-07-06T10:12:45.000','3679','31','2005-07-09T08:52:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3702','2005-07-06T10:13:56.000','2204','428','2005-07-10T08:12:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3703','2005-07-06T10:15:26.000','4276','421','2005-07-13T13:00:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3704','2005-07-06T10:16:45.000','2687','323','2005-07-13T12:44:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3705','2005-07-06T10:17:59.000','65','223','2005-07-10T15:31:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3706','2005-07-06T10:18:01.000','681','132','2005-07-09T09:07:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3707','2005-07-06T10:21:49.000','1080','14','2005-07-12T05:14:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3708','2005-07-06T10:23:27.000','2105','201','2005-07-14T09:26:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3709','2005-07-06T10:26:56.000','4033','187','2005-07-15T13:51:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3710','2005-07-06T10:28:53.000','2596','228','2005-07-15T06:17:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3711','2005-07-06T10:46:15.000','1914','75','2005-07-07T09:25:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3712','2005-07-06T10:47:35.000','3741','504','2005-07-15T09:39:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3713','2005-07-06T10:49:30.000','1823','504','2005-07-13T10:44:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3714','2005-07-06T10:51:28.000','1985','276','2005-07-09T13:57:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3715','2005-07-06T10:51:48.000','4456','228','2005-07-11T06:08:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3716','2005-07-06T10:52:32.000','3271','92','2005-07-14T08:45:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3717','2005-07-06T10:53:34.000','1677','173','2005-07-07T13:43:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3718','2005-07-06T10:57:56.000','2624','56','2005-07-12T12:54:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3719','2005-07-06T11:05:55.000','3573','376','2005-07-11T08:10:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3720','2005-07-06T11:06:57.000','2958','96','2005-07-09T14:16:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3721','2005-07-06T11:10:09.000','2654','226','2005-07-11T07:45:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3722','2005-07-06T11:10:27.000','604','83','2005-07-13T12:56:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3723','2005-07-06T11:12:02.000','4554','501','2005-07-14T16:45:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3724','2005-07-06T11:12:48.000','3622','468','2005-07-14T14:41:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3725','2005-07-06T11:15:04.000','2789','126','2005-07-09T06:39:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3726','2005-07-06T11:15:49.000','742','363','2005-07-11T05:54:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3727','2005-07-06T11:16:43.000','2886','57','2005-07-07T15:39:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3728','2005-07-06T11:29:00.000','1798','298','2005-07-11T06:28:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3729','2005-07-06T11:30:29.000','3156','90','2005-07-12T07:18:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3730','2005-07-06T11:31:24.000','1665','355','2005-07-15T06:53:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3731','2005-07-06T11:33:36.000','4133','558','2005-07-15T12:23:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3732','2005-07-06T11:33:37.000','106','318','2005-07-08T08:31:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3733','2005-07-06T11:33:55.000','3242','586','2005-07-09T10:08:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3734','2005-07-06T11:40:27.000','4569','37','2005-07-14T12:08:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3735','2005-07-06T11:42:04.000','2262','534','2005-07-12T14:33:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3736','2005-07-06T11:43:44.000','1515','23','2005-07-13T07:55:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3737','2005-07-06T11:45:53.000','123','403','2005-07-13T15:27:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3738','2005-07-06T11:50:57.000','578','546','2005-07-09T08:07:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3739','2005-07-06T11:54:18.000','4333','157','2005-07-09T10:48:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3740','2005-07-06T11:55:35.000','1829','277','2005-07-14T09:44:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3741','2005-07-06T12:00:18.000','1449','584','2005-07-12T09:02:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3742','2005-07-06T12:01:38.000','2873','96','2005-07-15T10:46:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3743','2005-07-06T12:03:54.000','1012','456','2005-07-13T10:56:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3744','2005-07-06T12:10:02.000','3343','510','2005-07-08T11:49:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3745','2005-07-06T12:10:32.000','1518','171','2005-07-12T15:20:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3746','2005-07-06T12:10:51.000','3387','424','2005-07-07T11:36:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3747','2005-07-06T12:11:14.000','1093','437','2005-07-09T17:14:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3748','2005-07-06T12:11:22.000','2920','79','2005-07-12T07:22:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3749','2005-07-06T12:18:03.000','1531','170','2005-07-11T07:25:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3750','2005-07-06T12:19:28.000','2422','103','2005-07-14T13:16:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3751','2005-07-06T12:23:41.000','3652','128','2005-07-10T06:58:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3752','2005-07-06T12:30:12.000','4561','235','2005-07-13T12:13:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3753','2005-07-06T12:34:06.000','774','358','2005-07-07T14:19:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3754','2005-07-06T12:35:44.000','4042','83','2005-07-08T16:28:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3755','2005-07-06T12:37:16.000','3147','402','2005-07-13T07:22:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3756','2005-07-06T12:40:38.000','30','320','2005-07-11T09:29:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3757','2005-07-06T12:42:26.000','2816','66','2005-07-11T10:30:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3758','2005-07-06T12:43:11.000','2498','48','2005-07-14T12:52:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3759','2005-07-06T12:46:38.000','4165','378','2005-07-10T11:31:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3760','2005-07-06T12:49:28.000','1306','330','2005-07-09T16:29:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3761','2005-07-06T12:52:44.000','4304','464','2005-07-08T17:22:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3762','2005-07-06T12:52:49.000','1941','413','2005-07-12T11:41:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3763','2005-07-06T12:56:31.000','1573','189','2005-07-09T14:49:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3764','2005-07-06T13:01:03.000','3115','470','2005-07-13T15:26:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3765','2005-07-06T13:01:47.000','1805','547','2005-07-09T07:10:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3766','2005-07-06T13:04:35.000','4504','312','2005-07-07T15:46:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3767','2005-07-06T13:07:27.000','923','582','2005-07-08T18:48:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3768','2005-07-06T13:07:30.000','3995','573','2005-07-09T16:26:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3769','2005-07-06T13:11:33.000','467','567','2005-07-14T17:54:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3770','2005-07-06T13:14:28.000','3836','198','2005-07-13T09:23:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3771','2005-07-06T13:19:34.000','1373','56','2005-07-10T10:27:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3772','2005-07-06T13:22:53.000','434','338','2005-07-10T11:54:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3773','2005-07-06T13:23:34.000','2034','263','2005-07-08T17:23:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3774','2005-07-06T13:25:07.000','4044','439','2005-07-15T12:56:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3775','2005-07-06T13:27:33.000','3696','300','2005-07-09T10:27:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3776','2005-07-06T13:31:37.000','4387','278','2005-07-10T10:53:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3777','2005-07-06T13:36:48.000','2470','548','2005-07-11T14:26:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3778','2005-07-06T13:44:48.000','2181','122','2005-07-13T09:31:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3779','2005-07-06T13:46:36.000','634','583','2005-07-10T15:49:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3780','2005-07-06T13:52:02.000','1209','99','2005-07-15T08:41:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3781','2005-07-06T13:53:41.000','3894','23','2005-07-15T10:03:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3782','2005-07-06T13:57:03.000','3365','515','2005-07-09T11:13:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3783','2005-07-06T13:57:31.000','2345','386','2005-07-14T10:44:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3784','2005-07-06T13:57:56.000','2287','165','2005-07-14T17:24:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3785','2005-07-06T14:00:13.000','3279','577','2005-07-14T10:13:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3786','2005-07-06T14:00:41.000','4508','152','2005-07-13T16:49:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3787','2005-07-06T14:02:01.000','288','474','2005-07-09T19:09:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3788','2005-07-06T14:02:02.000','1363','379','2005-07-10T18:24:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3789','2005-07-06T14:02:26.000','3560','595','2005-07-14T18:13:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3790','2005-07-06T14:13:45.000','1711','10','2005-07-14T13:35:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3791','2005-07-06T14:24:56.000','3426','452','2005-07-14T11:06:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3792','2005-07-06T14:26:38.000','2651','312','2005-07-11T16:34:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3793','2005-07-06T14:32:44.000','4558','553','2005-07-08T13:55:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3794','2005-07-06T14:35:26.000','584','499','2005-07-11T14:40:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3795','2005-07-06T14:37:41.000','240','153','2005-07-11T20:27:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3796','2005-07-06T14:45:22.000','1649','228','2005-07-07T11:01:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3797','2005-07-06T14:54:52.000','1047','374','2005-07-10T09:50:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3798','2005-07-06T14:57:53.000','1942','479','2005-07-07T10:48:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3799','2005-07-06T15:00:14.000','4532','251','2005-07-10T15:39:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3800','2005-07-06T15:01:27.000','4004','100','2005-07-15T11:12:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3801','2005-07-06T15:05:50.000','4209','68','2005-07-12T12:56:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3802','2005-07-06T15:06:09.000','1017','91','2005-07-08T09:33:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3803','2005-07-06T15:06:55.000','2062','494','2005-07-08T18:53:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3804','2005-07-06T15:08:08.000','537','126','2005-07-15T14:01:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3805','2005-07-06T15:08:42.000','1716','418','2005-07-07T14:34:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3806','2005-07-06T15:09:41.000','3555','154','2005-07-14T09:14:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3807','2005-07-06T15:11:44.000','39','425','2005-07-10T09:20:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3808','2005-07-06T15:15:35.000','4339','314','2005-07-07T16:10:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3809','2005-07-06T15:16:37.000','2932','358','2005-07-09T14:45:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3810','2005-07-06T15:18:44.000','342','296','2005-07-12T09:52:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3811','2005-07-06T15:20:37.000','695','208','2005-07-08T16:26:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3812','2005-07-06T15:22:19.000','4490','381','2005-07-08T13:04:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3813','2005-07-06T15:23:34.000','4100','189','2005-07-08T19:03:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3814','2005-07-06T15:23:56.000','3826','306','2005-07-13T20:51:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3815','2005-07-06T15:26:36.000','4038','472','2005-07-11T17:07:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3816','2005-07-06T15:27:04.000','2941','489','2005-07-14T13:12:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3817','2005-07-06T15:31:45.000','2933','267','2005-07-11T17:11:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3818','2005-07-06T15:33:31.000','653','97','2005-07-11T16:35:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3819','2005-07-06T15:35:06.000','1814','74','2005-07-14T19:08:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3820','2005-07-06T15:35:26.000','4192','460','2005-07-11T12:22:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3821','2005-07-06T15:36:20.000','4385','354','2005-07-11T20:04:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3822','2005-07-06T15:41:15.000','1314','241','2005-07-07T16:41:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3823','2005-07-06T15:41:27.000','124','265','2005-07-09T09:48:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3824','2005-07-06T15:43:15.000','3107','107','2005-07-13T16:05:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3825','2005-07-06T15:50:03.000','630','132','2005-07-09T19:20:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3826','2005-07-06T15:51:58.000','73','451','2005-07-13T12:35:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3827','2005-07-06T15:52:03.000','2072','41','2005-07-08T21:43:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3828','2005-07-06T15:57:30.000','4493','498','2005-07-10T12:17:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3829','2005-07-06T15:59:40.000','4126','356','2005-07-11T10:29:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3830','2005-07-06T16:01:16.000','553','310','2005-07-15T19:35:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3831','2005-07-06T16:06:35.000','1338','206','2005-07-08T15:14:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3832','2005-07-06T16:12:23.000','4499','233','2005-07-12T21:29:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3833','2005-07-06T16:18:28.000','3232','416','2005-07-14T20:09:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3834','2005-07-06T16:19:56.000','3001','366','2005-07-13T11:38:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3835','2005-07-06T16:22:45.000','935','486','2005-07-11T17:04:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3836','2005-07-06T16:26:04.000','1148','351','2005-07-10T15:08:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3837','2005-07-06T16:27:43.000','3166','309','2005-07-07T18:02:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3838','2005-07-06T16:29:43.000','3404','565','2005-07-11T20:50:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3839','2005-07-06T16:30:30.000','3230','231','2005-07-11T19:00:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3840','2005-07-06T16:30:59.000','4384','468','2005-07-15T22:08:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3841','2005-07-06T16:34:00.000','4228','470','2005-07-08T15:12:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3842','2005-07-06T16:34:32.000','3119','583','2005-07-08T11:55:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3843','2005-07-06T16:35:40.000','3844','62','2005-07-07T18:29:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3844','2005-07-06T16:37:58.000','2814','179','2005-07-09T19:54:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3845','2005-07-06T16:38:14.000','4495','28','2005-07-09T14:59:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3846','2005-07-06T16:43:10.000','2829','88','2005-07-14T11:09:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3847','2005-07-06T16:44:41.000','782','206','2005-07-07T21:54:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3848','2005-07-06T16:47:32.000','2906','188','2005-07-14T15:00:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3849','2005-07-06T16:49:43.000','3660','60','2005-07-12T17:20:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3850','2005-07-06T16:51:21.000','1700','103','2005-07-12T13:58:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3851','2005-07-06T16:54:12.000','493','436','2005-07-11T22:49:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3852','2005-07-06T16:57:49.000','3329','511','2005-07-11T17:11:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3853','2005-07-06T16:59:20.000','1411','537','2005-07-07T12:30:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3854','2005-07-06T17:02:33.000','2054','243','2005-07-12T17:32:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3855','2005-07-06T17:03:48.000','2931','46','2005-07-12T14:32:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3856','2005-07-06T17:04:46.000','3083','498','2005-07-14T19:23:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3857','2005-07-06T17:07:54.000','1135','236','2005-07-07T13:28:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3858','2005-07-06T17:17:57.000','829','377','2005-07-10T23:10:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3859','2005-07-06T17:18:15.000','2548','553','2005-07-09T16:48:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3860','2005-07-06T17:20:24.000','144','514','2005-07-09T22:33:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3861','2005-07-06T17:24:49.000','4506','202','2005-07-15T22:19:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3862','2005-07-06T17:35:22.000','471','181','2005-07-15T17:13:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3863','2005-07-06T17:40:18.000','363','481','2005-07-07T17:58:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3864','2005-07-06T17:41:42.000','2811','68','2005-07-08T14:17:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3865','2005-07-06T17:46:57.000','3579','357','2005-07-12T12:20:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3866','2005-07-06T17:47:20.000','194','409','2005-07-15T18:12:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3867','2005-07-06T17:52:19.000','3620','580','2005-07-13T21:48:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3868','2005-07-06T17:54:13.000','1606','416','2005-07-10T14:51:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3869','2005-07-06T17:56:46.000','2540','183','2005-07-10T20:44:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3870','2005-07-06T17:57:54.000','3357','12','2005-07-13T12:30:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3871','2005-07-06T17:58:51.000','3114','331','2005-07-15T22:18:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3872','2005-07-06T18:00:19.000','1785','513','2005-07-07T17:26:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3873','2005-07-06T18:03:16.000','4148','394','2005-07-15T23:58:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3874','2005-07-06T18:06:12.000','1870','137','2005-07-12T16:55:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3875','2005-07-06T18:15:39.000','712','108','2005-07-11T17:34:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3876','2005-07-06T18:21:13.000','4039','295','2005-07-14T16:57:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3877','2005-07-06T18:22:10.000','2796','576','2005-07-07T23:38:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3878','2005-07-06T18:27:09.000','4022','385','2005-07-15T20:13:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3879','2005-07-06T18:31:20.000','1376','81','2005-07-09T19:03:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3880','2005-07-06T18:32:49.000','42','507','2005-07-07T20:46:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3881','2005-07-06T18:35:37.000','143','456','2005-07-10T00:06:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3882','2005-07-06T18:38:21.000','788','254','2005-07-09T14:55:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3883','2005-07-06T18:39:38.000','3238','69','2005-07-14T15:59:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3884','2005-07-06T18:41:33.000','1806','210','2005-07-07T22:06:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3885','2005-07-06T18:43:43.000','1820','282','2005-07-12T19:48:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3886','2005-07-06T18:44:24.000','2368','326','2005-07-08T15:11:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3887','2005-07-06T18:46:34.000','1695','530','2005-07-07T13:15:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3888','2005-07-06T18:54:20.000','1945','412','2005-07-12T17:13:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3889','2005-07-06T18:56:25.000','2005','576','2005-07-08T21:22:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3890','2005-07-06T18:58:15.000','2570','553','2005-07-10T18:51:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3891','2005-07-06T18:58:25.000','3216','553','2005-07-09T23:20:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3892','2005-07-06T18:58:58.000','778','549','2005-07-10T19:29:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3893','2005-07-06T18:59:31.000','1281','350','2005-07-12T19:21:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3894','2005-07-06T19:01:39.000','2087','149','2005-07-12T21:35:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3895','2005-07-06T19:04:24.000','145','584','2005-07-15T17:48:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3896','2005-07-06T19:09:15.000','1755','309','2005-07-16T00:52:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3897','2005-07-06T19:11:43.000','14','277','2005-07-11T21:50:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3898','2005-07-06T19:12:37.000','3858','53','2005-07-11T15:50:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3899','2005-07-06T19:12:40.000','4020','485','2005-07-13T23:41:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3900','2005-07-06T19:21:28.000','1497','129','2005-07-15T21:06:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3901','2005-07-06T19:24:55.000','3367','321','2005-07-14T20:30:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3902','2005-07-06T19:25:18.000','2868','192','2005-07-10T17:42:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3903','2005-07-06T19:27:32.000','3614','369','2005-07-08T23:27:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3904','2005-07-06T19:30:57.000','3600','485','2005-07-11T18:47:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3905','2005-07-06T19:33:34.000','3817','526','2005-07-15T17:55:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3906','2005-07-06T19:35:55.000','1383','293','2005-07-15T22:35:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3907','2005-07-06T19:39:14.000','2507','452','2005-07-11T17:45:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3908','2005-07-06T19:47:26.000','3980','116','2005-07-13T19:59:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3909','2005-07-06T19:54:41.000','3423','396','2005-07-15T18:11:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3910','2005-07-06T20:05:18.000','2085','248','2005-07-10T18:51:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3911','2005-07-06T20:09:11.000','4548','34','2005-07-08T23:53:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3912','2005-07-06T20:10:03.000','2449','154','2005-07-08T18:39:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3913','2005-07-06T20:11:00.000','752','494','2005-07-08T14:42:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3914','2005-07-06T20:11:10.000','4092','159','2005-07-14T14:42:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3915','2005-07-06T20:16:46.000','125','163','2005-07-10T17:24:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3916','2005-07-06T20:18:50.000','3198','46','2005-07-12T21:56:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3917','2005-07-06T20:19:29.000','2747','471','2005-07-11T00:49:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3918','2005-07-06T20:26:15.000','1111','435','2005-07-15T20:32:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3919','2005-07-06T20:26:21.000','2695','147','2005-07-15T00:13:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3920','2005-07-06T20:26:40.000','1551','321','2005-07-15T15:00:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3921','2005-07-06T20:29:48.000','949','531','2005-07-14T01:44:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3922','2005-07-06T20:32:27.000','2878','470','2005-07-14T19:00:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3923','2005-07-06T20:34:10.000','2039','63','2005-07-13T19:20:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3924','2005-07-06T20:38:02.000','187','114','2005-07-11T23:35:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3925','2005-07-06T20:41:44.000','2653','428','2005-07-15T21:05:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3926','2005-07-06T20:42:35.000','4241','500','2005-07-09T16:30:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3927','2005-07-06T20:48:14.000','2194','404','2005-07-10T15:37:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3928','2005-07-06T20:52:09.000','1960','411','2005-07-08T18:51:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3929','2005-07-06T20:52:39.000','1235','453','2005-07-12T00:27:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3930','2005-07-06T20:54:07.000','165','573','2005-07-10T18:31:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3931','2005-07-06T21:03:46.000','182','176','2005-07-16T01:32:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3932','2005-07-06T21:06:17.000','4396','490','2005-07-07T19:25:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3933','2005-07-06T21:06:37.000','1202','229','2005-07-08T20:23:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3934','2005-07-06T21:07:23.000','3187','576','2005-07-10T18:20:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3935','2005-07-06T21:08:29.000','3402','503','2005-07-15T23:28:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3936','2005-07-06T21:15:03.000','4258','129','2005-07-08T17:45:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3937','2005-07-06T21:15:38.000','2091','211','2005-07-15T00:01:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3938','2005-07-06T21:15:45.000','1991','341','2005-07-13T20:02:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3939','2005-07-06T21:16:32.000','3627','149','2005-07-11T03:12:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3940','2005-07-06T21:16:59.000','1502','116','2005-07-07T19:17:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3941','2005-07-06T21:20:37.000','382','560','2005-07-09T01:35:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3942','2005-07-06T21:21:34.000','677','553','2005-07-15T02:34:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3943','2005-07-06T21:22:17.000','1816','566','2005-07-07T21:26:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3944','2005-07-06T21:34:11.000','4213','436','2005-07-08T23:46:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3945','2005-07-06T21:35:00.000','754','86','2005-07-08T00:31:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3946','2005-07-06T21:39:24.000','294','13','2005-07-11T16:10:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3947','2005-07-06T21:42:21.000','4188','324','2005-07-08T19:37:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3948','2005-07-06T21:45:53.000','2254','161','2005-07-08T19:24:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3949','2005-07-06T21:46:36.000','1765','153','2005-07-11T03:18:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3950','2005-07-06T21:48:44.000','4153','598','2005-07-14T02:25:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3951','2005-07-06T21:50:41.000','2288','250','2005-07-12T02:09:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3952','2005-07-06T21:51:31.000','1719','417','2005-07-13T15:54:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3953','2005-07-06T21:54:55.000','3879','385','2005-07-09T18:52:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3954','2005-07-06T21:57:44.000','4250','558','2005-07-08T02:37:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3955','2005-07-06T21:58:08.000','2523','247','2005-07-08T03:43:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3956','2005-07-06T22:01:51.000','15','147','2005-07-12T21:35:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3957','2005-07-06T22:05:47.000','443','414','2005-07-16T01:08:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3958','2005-07-06T22:07:33.000','4117','288','2005-07-10T19:31:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3959','2005-07-06T22:07:58.000','40','448','2005-07-13T02:30:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3960','2005-07-06T22:08:53.000','2090','594','2005-07-07T23:21:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3961','2005-07-06T22:11:43.000','4320','364','2005-07-09T03:14:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3962','2005-07-06T22:13:45.000','379','307','2005-07-15T00:22:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3963','2005-07-06T22:19:17.000','3912','111','2005-07-15T01:22:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3964','2005-07-06T22:23:02.000','1853','30','2005-07-07T22:21:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3965','2005-07-06T22:36:20.000','2863','243','2005-07-09T17:45:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3966','2005-07-06T22:38:49.000','556','495','2005-07-07T23:33:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3967','2005-07-06T22:45:10.000','2510','31','2005-07-09T23:54:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3968','2005-07-06T22:47:09.000','558','235','2005-07-12T21:01:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3969','2005-07-06T22:47:59.000','383','587','2005-07-08T02:11:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3970','2005-07-06T22:48:17.000','701','381','2005-07-15T19:07:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3971','2005-07-06T22:50:40.000','4415','473','2005-07-08T01:02:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3972','2005-07-06T22:53:57.000','1895','598','2005-07-11T01:32:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3973','2005-07-06T22:58:31.000','2625','592','2005-07-16T03:27:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3974','2005-07-06T22:59:16.000','4282','318','2005-07-11T22:30:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3975','2005-07-06T23:00:09.000','4343','545','2005-07-10T01:39:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3976','2005-07-06T23:00:20.000','2424','329','2005-07-07T21:51:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3977','2005-07-06T23:00:49.000','1284','449','2005-07-15T00:41:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3978','2005-07-06T23:04:33.000','4341','343','2005-07-10T17:45:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3979','2005-07-06T23:04:35.000','794','550','2005-07-13T01:38:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3980','2005-07-06T23:11:11.000','1845','475','2005-07-14T18:22:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3981','2005-07-06T23:12:12.000','842','375','2005-07-13T01:47:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3982','2005-07-06T23:14:16.000','4327','64','2005-07-08T21:21:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3983','2005-07-06T23:14:21.000','1261','6','2005-07-12T17:55:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3984','2005-07-06T23:22:36.000','2205','570','2005-07-08T21:40:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3985','2005-07-06T23:24:03.000','2096','307','2005-07-10T00:20:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3986','2005-07-06T23:25:13.000','3737','122','2005-07-09T21:26:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3987','2005-07-06T23:28:24.000','3104','270','2005-07-15T00:52:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3988','2005-07-06T23:30:42.000','2981','421','2005-07-13T03:06:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3989','2005-07-06T23:30:54.000','2366','213','2005-07-12T01:28:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3990','2005-07-06T23:32:44.000','2009','558','2005-07-14T01:35:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3991','2005-07-06T23:33:41.000','587','583','2005-07-16T01:31:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3992','2005-07-06T23:36:56.000','3219','448','2005-07-15T03:13:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3993','2005-07-06T23:37:06.000','1061','525','2005-07-14T19:31:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3994','2005-07-06T23:39:01.000','902','487','2005-07-14T00:33:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3995','2005-07-06T23:43:03.000','3990','128','2005-07-13T04:13:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3996','2005-07-06T23:46:43.000','2857','551','2005-07-14T22:34:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3997','2005-07-06T23:46:52.000','3895','52','2005-07-14T05:39:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3998','2005-07-06T23:49:20.000','1245','566','2005-07-12T20:39:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('3999','2005-07-06T23:50:54.000','707','390','2005-07-09T22:09:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4000','2005-07-06T23:58:37.000','2122','95','2005-07-08T21:43:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4001','2005-07-07T00:07:00.000','864','120','2005-07-13T21:27:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4002','2005-07-07T00:08:18.000','2790','308','2005-07-14T01:29:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4003','2005-07-07T00:09:02.000','4054','8','2005-07-08T04:27:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4004','2005-07-07T00:20:51.000','667','574','2005-07-11T18:55:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4005','2005-07-07T00:22:26.000','3677','190','2005-07-15T04:34:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4006','2005-07-07T00:25:29.000','397','473','2005-07-08T05:30:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4007','2005-07-07T00:26:05.000','2071','285','2005-07-15T19:53:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4008','2005-07-07T00:26:43.000','1107','505','2005-07-16T03:58:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4009','2005-07-07T00:28:55.000','3607','394','2005-07-10T00:37:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4010','2005-07-07T00:47:00.000','4509','476','2005-07-12T06:23:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4011','2005-07-07T00:48:25.000','2052','20','2005-07-13T06:30:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4012','2005-07-07T00:56:09.000','1400','104','2005-07-10T21:49:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4013','2005-07-07T00:58:00.000','2344','475','2005-07-15T19:42:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4014','2005-07-07T00:58:54.000','583','510','2005-07-12T02:40:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4015','2005-07-07T00:59:46.000','3032','233','2005-07-14T03:16:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4016','2005-07-07T01:05:50.000','3318','335','2005-07-09T05:59:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4017','2005-07-07T01:08:18.000','3117','595','2005-07-09T01:47:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4018','2005-07-07T01:10:33.000','906','207','2005-07-12T20:54:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4019','2005-07-07T01:27:44.000','3200','294','2005-07-10T21:30:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4020','2005-07-07T01:42:22.000','3760','471','2005-07-10T00:53:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4021','2005-07-07T01:46:44.000','1676','315','2005-07-12T00:16:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4022','2005-07-07T01:50:06.000','3914','390','2005-07-09T21:47:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4023','2005-07-07T01:55:25.000','274','573','2005-07-08T02:43:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4024','2005-07-07T02:11:23.000','3976','448','2005-07-11T02:00:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4025','2005-07-07T02:13:24.000','3908','114','2005-07-08T00:47:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4026','2005-07-07T02:15:48.000','4142','251','2005-07-14T04:15:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4027','2005-07-07T02:19:01.000','56','116','2005-07-10T01:12:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4028','2005-07-07T02:19:14.000','1651','344','2005-07-15T08:09:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4029','2005-07-07T02:19:44.000','4075','518','2005-07-15T02:30:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4030','2005-07-07T02:25:42.000','1734','300','2005-07-08T22:53:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4031','2005-07-07T02:32:07.000','3094','143','2005-07-14T06:01:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4032','2005-07-07T02:34:13.000','2628','335','2005-07-14T22:43:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4033','2005-07-07T02:35:46.000','203','453','2005-07-16T01:12:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4034','2005-07-07T02:36:33.000','1666','354','2005-07-09T08:32:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4035','2005-07-07T02:45:02.000','3611','539','2005-07-14T01:41:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4036','2005-07-07T02:48:00.000','500','397','2005-07-07T22:46:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4037','2005-07-07T02:52:52.000','3903','594','2005-07-16T00:09:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4038','2005-07-07T02:52:53.000','1264','27','2005-07-11T22:32:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4039','2005-07-07T02:57:59.000','4050','290','2005-07-12T03:44:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4040','2005-07-07T03:02:40.000','3046','103','2005-07-16T06:05:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4041','2005-07-07T03:03:33.000','2217','445','2005-07-09T07:57:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4042','2005-07-07T03:06:40.000','50','10','2005-07-10T02:37:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4043','2005-07-07T03:09:50.000','3427','204','2005-07-10T07:49:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4044','2005-07-07T03:22:23.000','3263','94','2005-07-13T03:23:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4045','2005-07-07T03:26:14.000','1422','529','2005-07-11T06:52:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4046','2005-07-07T03:27:59.000','3518','491','2005-07-14T01:14:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4047','2005-07-07T03:28:49.000','3475','364','2005-07-09T02:42:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4048','2005-07-07T03:30:52.000','659','474','2005-07-14T05:05:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4049','2005-07-07T03:34:53.000','4172','79','2005-07-15T04:10:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4050','2005-07-07T03:35:33.000','104','528','2005-07-15T03:11:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4051','2005-07-07T03:37:28.000','2715','331','2005-07-09T01:40:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4052','2005-07-07T03:38:22.000','206','442','2005-07-13T02:56:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4053','2005-07-07T03:39:22.000','2889','377','2005-07-09T22:32:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4054','2005-07-07T03:42:07.000','3885','260','2005-07-10T03:22:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4055','2005-07-07T03:49:13.000','2561','513','2005-07-11T03:15:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4056','2005-07-07T03:57:36.000','4211','360','2005-07-09T08:53:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4057','2005-07-07T04:00:20.000','2838','141','2005-07-12T08:14:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4058','2005-07-07T04:02:50.000','3877','442','2005-07-10T04:30:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4059','2005-07-07T04:04:26.000','292','401','2005-07-10T22:35:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4060','2005-07-07T04:10:13.000','2697','211','2005-07-13T07:44:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4061','2005-07-07T04:13:35.000','62','70','2005-07-10T23:58:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4062','2005-07-07T04:22:27.000','1323','410','2005-07-09T03:27:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4063','2005-07-07T04:23:57.000','1452','331','2005-07-14T23:35:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4064','2005-07-07T04:29:20.000','1402','47','2005-07-14T05:48:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4065','2005-07-07T04:32:28.000','1339','26','2005-07-12T08:30:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4066','2005-07-07T04:34:09.000','1975','368','2005-07-10T23:54:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4067','2005-07-07T04:34:23.000','2945','469','2005-07-16T04:04:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4068','2005-07-07T04:34:38.000','4152','206','2005-07-11T09:16:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4069','2005-07-07T04:35:06.000','3361','570','2005-07-10T23:59:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4070','2005-07-07T04:37:09.000','2926','496','2005-07-08T04:19:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4071','2005-07-07T04:37:26.000','2883','209','2005-07-13T06:45:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4072','2005-07-07T04:48:02.000','3130','310','2005-07-12T10:32:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4073','2005-07-07T04:49:13.000','647','290','2005-07-10T03:20:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4074','2005-07-07T04:49:49.000','2347','412','2005-07-12T04:51:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4075','2005-07-07T04:51:44.000','1989','593','2005-07-09T03:07:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4076','2005-07-07T04:52:15.000','3148','329','2005-07-13T23:22:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4077','2005-07-07T04:53:40.000','2445','377','2005-07-09T09:56:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4078','2005-07-07T05:05:05.000','1671','522','2005-07-10T05:39:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4079','2005-07-07T05:06:27.000','2202','84','2005-07-16T08:46:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4080','2005-07-07T05:09:54.000','1364','148','2005-07-11T23:58:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4081','2005-07-07T05:10:08.000','1138','284','2005-07-12T00:47:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4082','2005-07-07T05:11:53.000','2904','108','2005-07-12T00:55:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4083','2005-07-07T05:13:15.000','3454','490','2005-07-08T09:11:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4084','2005-07-07T05:16:00.000','2588','441','2005-07-15T09:23:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4085','2005-07-07T05:25:39.000','1683','573','2005-07-12T04:30:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4086','2005-07-07T05:26:06.000','253','494','2005-07-12T00:45:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4087','2005-07-07T05:30:56.000','3066','433','2005-07-16T10:20:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4088','2005-07-07T05:31:55.000','234','66','2005-07-15T07:35:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4089','2005-07-07T05:45:59.000','3431','102','2005-07-16T07:34:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4090','2005-07-07T05:47:33.000','3096','67','2005-07-08T04:25:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4091','2005-07-07T05:53:38.000','3928','337','2005-07-14T03:12:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4092','2005-07-07T05:54:18.000','1721','246','2005-07-16T09:14:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4093','2005-07-07T05:54:50.000','1534','337','2005-07-12T00:34:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4094','2005-07-07T06:00:21.000','2412','517','2005-07-10T03:24:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4095','2005-07-07T06:01:48.000','2900','33','2005-07-15T02:52:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4096','2005-07-07T06:09:11.000','3911','403','2005-07-08T09:17:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4097','2005-07-07T06:10:55.000','2454','56','2005-07-11T02:45:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4098','2005-07-07T06:14:51.000','2865','35','2005-07-14T06:51:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4099','2005-07-07T06:20:33.000','1930','76','2005-07-16T08:39:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4100','2005-07-07T06:20:52.000','2346','332','2005-07-15T05:58:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4101','2005-07-07T06:25:11.000','2891','588','2005-07-12T07:44:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4102','2005-07-07T06:25:19.000','3998','135','2005-07-11T00:50:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4103','2005-07-07T06:25:28.000','3632','91','2005-07-12T11:18:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4104','2005-07-07T06:25:41.000','1066','338','2005-07-13T04:18:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4105','2005-07-07T06:31:00.000','439','423','2005-07-09T03:52:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4106','2005-07-07T06:33:35.000','4083','563','2005-07-13T04:03:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4107','2005-07-07T06:36:32.000','4232','206','2005-07-14T03:36:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4108','2005-07-07T06:38:31.000','4535','66','2005-07-08T10:44:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4109','2005-07-07T06:39:43.000','532','517','2005-07-10T06:30:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4110','2005-07-07T06:44:27.000','226','486','2005-07-12T05:43:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4111','2005-07-07T06:47:56.000','1009','515','2005-07-13T02:13:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4112','2005-07-07T06:49:09.000','3284','533','2005-07-16T06:53:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4113','2005-07-07T06:49:52.000','915','170','2005-07-12T04:00:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4114','2005-07-07T06:51:12.000','4109','426','2005-07-15T01:36:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4115','2005-07-07T06:52:23.000','102','371','2005-07-14T06:12:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4116','2005-07-07T06:56:13.000','666','352','2005-07-11T11:13:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4117','2005-07-07T06:58:14.000','780','158','2005-07-16T05:28:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4118','2005-07-07T07:03:30.000','355','224','2005-07-08T09:20:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4119','2005-07-07T07:06:03.000','2078','319','2005-07-13T01:56:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4120','2005-07-07T07:07:03.000','987','559','2005-07-16T04:07:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4121','2005-07-07T07:13:50.000','2429','176','2005-07-13T04:32:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4122','2005-07-07T07:15:35.000','273','31','2005-07-14T12:10:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4123','2005-07-07T07:16:19.000','2707','469','2005-07-10T05:23:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4124','2005-07-07T07:19:54.000','2856','330','2005-07-11T05:54:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4125','2005-07-07T07:20:29.000','4131','269','2005-07-15T06:41:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4126','2005-07-07T07:24:11.000','3018','163','2005-07-15T07:31:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4127','2005-07-07T07:26:19.000','1774','15','2005-07-14T07:50:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4128','2005-07-07T07:35:25.000','3563','492','2005-07-14T08:13:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4129','2005-07-07T07:37:03.000','1413','592','2005-07-14T13:31:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4130','2005-07-07T07:51:53.000','4170','256','2005-07-11T12:41:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4131','2005-07-07T07:53:18.000','2621','58','2005-07-08T04:48:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4132','2005-07-07T08:06:07.000','993','154','2005-07-10T14:04:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4133','2005-07-07T08:12:26.000','3672','488','2005-07-16T03:43:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4134','2005-07-07T08:14:24.000','2917','183','2005-07-09T10:42:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4135','2005-07-07T08:15:03.000','3384','36','2005-07-11T10:56:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4136','2005-07-07T08:15:52.000','3461','203','2005-07-10T04:22:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4137','2005-07-07T08:17:06.000','2065','485','2005-07-11T10:52:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4138','2005-07-07T08:17:13.000','1588','317','2005-07-14T05:18:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4139','2005-07-07T08:17:35.000','2094','509','2005-07-14T14:01:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4140','2005-07-07T08:19:10.000','1897','190','2005-07-14T07:27:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4141','2005-07-07T08:19:20.000','1904','456','2005-07-11T06:54:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4142','2005-07-07T08:19:45.000','4045','492','2005-07-08T13:55:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4143','2005-07-07T08:22:07.000','597','238','2005-07-13T11:42:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4144','2005-07-07T08:25:44.000','550','431','2005-07-16T13:10:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4145','2005-07-07T08:26:39.000','3050','592','2005-07-16T12:54:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4146','2005-07-07T08:30:16.000','176','411','2005-07-12T07:52:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4147','2005-07-07T08:32:12.000','2776','274','2005-07-12T10:10:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4148','2005-07-07T08:36:58.000','260','59','2005-07-09T05:51:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4149','2005-07-07T08:40:17.000','3028','50','2005-07-10T02:58:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4150','2005-07-07T08:43:22.000','4424','188','2005-07-08T05:21:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4151','2005-07-07T08:49:02.000','4564','428','2005-07-11T05:19:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4152','2005-07-07T08:50:33.000','1761','89','2005-07-14T10:56:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4153','2005-07-07T08:53:08.000','2185','299','2005-07-11T05:09:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4154','2005-07-07T08:58:23.000','191','594','2005-07-14T03:16:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4155','2005-07-07T09:00:49.000','212','548','2005-07-13T10:59:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4156','2005-07-07T09:03:51.000','1259','585','2005-07-12T09:46:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4157','2005-07-07T09:04:26.000','304','183','2005-07-08T09:55:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4158','2005-07-07T09:05:42.000','291','433','2005-07-09T04:28:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4159','2005-07-07T09:10:57.000','3625','62','2005-07-09T10:19:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4160','2005-07-07T09:13:17.000','1909','326','2005-07-15T11:50:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4161','2005-07-07T09:15:11.000','4021','216','2005-07-15T06:59:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4162','2005-07-07T09:17:26.000','745','571','2005-07-15T10:15:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4163','2005-07-07T09:19:28.000','3176','376','2005-07-10T06:47:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4164','2005-07-07T09:20:11.000','3133','295','2005-07-14T09:35:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4165','2005-07-07T09:23:27.000','3845','66','2005-07-15T06:00:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4166','2005-07-07T09:33:30.000','3267','376','2005-07-16T06:06:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4167','2005-07-07T09:37:08.000','3771','175','2005-07-16T06:16:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4168','2005-07-07T09:37:24.000','1872','132','2005-07-09T14:32:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4169','2005-07-07T09:39:18.000','3360','580','2005-07-11T13:43:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4170','2005-07-07T09:44:36.000','2665','99','2005-07-13T14:10:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4171','2005-07-07T09:49:04.000','4199','476','2005-07-14T03:58:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4172','2005-07-07T09:49:09.000','1158','309','2005-07-11T15:14:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4173','2005-07-07T09:57:26.000','4272','320','2005-07-10T04:05:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4174','2005-07-07T09:59:49.000','3814','182','2005-07-11T13:34:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4175','2005-07-07T10:02:03.000','1979','8','2005-07-10T06:09:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4176','2005-07-07T10:03:34.000','2745','420','2005-07-16T08:43:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4177','2005-07-07T10:12:36.000','4106','317','2005-07-15T15:48:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4178','2005-07-07T10:14:31.000','2898','513','2005-07-12T09:38:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4179','2005-07-07T10:17:15.000','559','75','2005-07-10T05:12:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4180','2005-07-07T10:23:25.000','1704','3','2005-07-10T13:18:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4181','2005-07-07T10:27:54.000','3725','598','2005-07-13T06:09:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4182','2005-07-07T10:28:00.000','3080','256','2005-07-08T12:50:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4183','2005-07-07T10:28:33.000','3342','479','2005-07-15T12:29:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4184','2005-07-07T10:30:08.000','1022','468','2005-07-14T12:56:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4185','2005-07-07T10:31:05.000','2425','395','2005-07-13T05:30:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4186','2005-07-07T10:32:25.000','3910','185','2005-07-15T06:22:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4187','2005-07-07T10:41:31.000','2','161','2005-07-11T06:25:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4188','2005-07-07T10:45:29.000','3243','391','2005-07-16T09:39:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4189','2005-07-07T10:51:07.000','1492','386','2005-07-14T14:46:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4190','2005-07-07T10:52:39.000','826','349','2005-07-11T13:19:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4191','2005-07-07T10:56:14.000','2475','390','2005-07-11T09:56:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4192','2005-07-07T10:57:06.000','624','558','2005-07-13T16:30:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4193','2005-07-07T10:57:21.000','3791','445','2005-07-09T07:33:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4194','2005-07-07T10:59:39.000','1753','153','2005-07-15T09:34:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4195','2005-07-07T11:00:02.000','450','455','2005-07-14T16:54:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4196','2005-07-07T11:06:33.000','3407','564','2005-07-14T13:46:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4197','2005-07-07T11:07:52.000','2515','324','2005-07-10T10:19:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4198','2005-07-07T11:08:11.000','333','247','2005-07-16T15:29:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4199','2005-07-07T11:13:07.000','2120','259','2005-07-11T07:17:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4200','2005-07-07T11:15:11.000','1097','292','2005-07-11T11:46:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4201','2005-07-07T11:19:51.000','3682','145','2005-07-16T08:48:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4202','2005-07-07T11:23:48.000','2274','38','2005-07-16T16:32:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4203','2005-07-07T11:24:14.000','2743','189','2005-07-11T16:26:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4204','2005-07-07T11:24:18.000','1513','569','2005-07-15T12:42:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4205','2005-07-07T11:25:39.000','3922','486','2005-07-11T06:12:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4206','2005-07-07T11:32:16.000','1557','448','2005-07-14T13:07:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4207','2005-07-07T11:32:45.000','1119','588','2005-07-14T05:49:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4208','2005-07-07T11:34:22.000','3617','441','2005-07-09T08:25:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4209','2005-07-07T11:35:08.000','2010','100','2005-07-10T10:58:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4210','2005-07-07T11:36:20.000','1972','581','2005-07-16T12:38:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4211','2005-07-07T11:50:41.000','2001','214','2005-07-09T13:58:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4212','2005-07-07T11:53:14.000','1825','574','2005-07-09T07:12:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4213','2005-07-07T11:53:49.000','705','103','2005-07-13T07:51:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4214','2005-07-07T11:54:33.000','2534','484','2005-07-08T10:49:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4215','2005-07-07T12:00:52.000','1239','22','2005-07-11T15:14:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4216','2005-07-07T12:01:34.000','1216','467','2005-07-08T09:59:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4217','2005-07-07T12:08:59.000','3186','228','2005-07-11T15:07:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4218','2005-07-07T12:10:24.000','152','497','2005-07-15T16:09:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4219','2005-07-07T12:11:22.000','2800','16','2005-07-11T11:05:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4220','2005-07-07T12:12:36.000','821','513','2005-07-10T13:37:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4221','2005-07-07T12:18:57.000','4567','143','2005-07-12T09:47:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4222','2005-07-07T12:20:21.000','2053','467','2005-07-11T11:09:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4223','2005-07-07T12:23:54.000','2407','405','2005-07-10T14:46:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4224','2005-07-07T12:24:21.000','3659','419','2005-07-10T11:48:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4225','2005-07-07T12:24:37.000','1766','377','2005-07-12T06:47:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4226','2005-07-07T12:37:56.000','1692','57','2005-07-09T08:48:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4227','2005-07-07T12:41:36.000','4186','78','2005-07-15T12:33:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4228','2005-07-07T12:42:02.000','1020','38','2005-07-12T10:52:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4229','2005-07-07T12:43:23.000','953','106','2005-07-13T15:00:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4230','2005-07-07T12:46:47.000','353','205','2005-07-15T06:52:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4231','2005-07-07T12:48:19.000','3522','194','2005-07-13T18:45:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4232','2005-07-07T12:49:12.000','3841','347','2005-07-15T16:45:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4233','2005-07-07T13:00:20.000','1849','488','2005-07-13T16:37:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4234','2005-07-07T13:01:35.000','1179','195','2005-07-15T13:05:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4235','2005-07-07T13:05:52.000','3525','86','2005-07-10T12:17:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4236','2005-07-07T13:12:07.000','642','213','2005-07-08T15:00:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4237','2005-07-07T13:16:55.000','3773','477','2005-07-15T16:33:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4238','2005-07-07T13:22:20.000','3024','7','2005-07-10T07:44:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4239','2005-07-07T13:23:17.000','3866','122','2005-07-13T17:49:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4240','2005-07-07T13:33:12.000','1024','65','2005-07-13T12:28:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4241','2005-07-07T13:39:00.000','4154','595','2005-07-12T17:49:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4242','2005-07-07T13:39:01.000','3626','286','2005-07-12T18:29:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4243','2005-07-07T13:39:58.000','4559','339','2005-07-12T19:27:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4244','2005-07-07T13:41:58.000','592','581','2005-07-09T15:32:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4245','2005-07-07T13:48:33.000','3743','91','2005-07-10T09:54:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4246','2005-07-07T13:49:03.000','1141','411','2005-07-09T13:01:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4247','2005-07-07T13:51:54.000','808','539','2005-07-10T09:43:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4248','2005-07-07T13:59:20.000','773','161','2005-07-14T15:18:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4249','2005-07-07T14:05:17.000','4185','111','2005-07-10T09:21:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4250','2005-07-07T14:08:11.000','2556','423','2005-07-13T08:09:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4251','2005-07-07T14:11:55.000','3541','367','2005-07-16T14:01:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4252','2005-07-07T14:13:05.000','474','154','2005-07-09T14:17:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4253','2005-07-07T14:13:13.000','3355','157','2005-07-16T18:55:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4254','2005-07-07T14:13:52.000','3957','529','2005-07-12T10:39:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4255','2005-07-07T14:14:13.000','749','10','2005-07-12T18:32:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4256','2005-07-07T14:14:36.000','1386','129','2005-07-10T09:41:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4257','2005-07-07T14:18:41.000','3927','553','2005-07-08T14:58:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4258','2005-07-07T14:20:59.000','1562','492','2005-07-16T10:03:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4259','2005-07-07T14:22:18.000','4378','467','2005-07-11T19:38:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4260','2005-07-07T14:22:45.000','4575','305','2005-07-08T15:10:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4261','2005-07-07T14:23:56.000','1405','496','2005-07-13T15:26:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4262','2005-07-07T14:24:30.000','3122','29','2005-07-14T13:12:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4263','2005-07-07T14:24:44.000','2975','16','2005-07-13T18:22:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4264','2005-07-07T14:25:28.000','3499','406','2005-07-08T08:49:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4265','2005-07-07T14:27:51.000','1685','69','2005-07-12T19:55:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4266','2005-07-07T14:34:50.000','1578','509','2005-07-08T09:23:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4267','2005-07-07T14:35:30.000','136','410','2005-07-11T10:41:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4268','2005-07-07T14:36:05.000','432','80','2005-07-16T14:36:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4269','2005-07-07T14:38:33.000','415','496','2005-07-09T10:27:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4270','2005-07-07T14:38:41.000','183','210','2005-07-10T19:07:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4271','2005-07-07T14:38:52.000','533','150','2005-07-15T12:05:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4272','2005-07-07T14:39:20.000','488','120','2005-07-13T08:57:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4273','2005-07-07T14:40:22.000','4163','159','2005-07-13T09:58:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4274','2005-07-07T14:42:04.000','787','26','2005-07-13T20:23:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4275','2005-07-07T14:43:51.000','1167','393','2005-07-15T18:04:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4276','2005-07-07T14:50:59.000','221','366','2005-07-09T15:42:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4277','2005-07-07T14:52:12.000','1983','106','2005-07-09T13:10:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4278','2005-07-07T14:53:24.000','3693','6','2005-07-13T14:21:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4279','2005-07-07T15:01:53.000','581','335','2005-07-08T09:43:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4280','2005-07-07T15:09:31.000','1115','593','2005-07-13T14:47:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4281','2005-07-07T15:17:50.000','1182','321','2005-07-08T11:42:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4282','2005-07-07T15:26:31.000','3134','25','2005-07-11T14:27:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4283','2005-07-07T15:29:35.000','2807','477','2005-07-11T17:12:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4284','2005-07-07T15:31:57.000','1313','521','2005-07-09T10:20:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4285','2005-07-07T15:34:35.000','511','308','2005-07-15T09:43:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4286','2005-07-07T15:36:44.000','4496','111','2005-07-11T13:04:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4287','2005-07-07T15:37:31.000','3558','94','2005-07-16T19:59:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4288','2005-07-07T15:38:25.000','1508','64','2005-07-13T16:23:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4289','2005-07-07T15:45:58.000','3172','231','2005-07-09T11:11:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4290','2005-07-07T15:47:10.000','4174','277','2005-07-15T15:03:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4291','2005-07-07T15:47:47.000','2074','298','2005-07-10T11:45:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4292','2005-07-07T15:48:38.000','3084','401','2005-07-15T17:53:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4293','2005-07-07T15:53:47.000','984','221','2005-07-10T18:11:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4294','2005-07-07T15:56:23.000','2845','41','2005-07-15T14:50:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4295','2005-07-07T16:08:51.000','2490','319','2005-07-13T13:06:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4296','2005-07-07T16:16:03.000','977','407','2005-07-08T20:16:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4297','2005-07-07T16:24:09.000','882','141','2005-07-13T15:08:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4298','2005-07-07T16:27:25.000','1055','560','2005-07-12T18:20:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4299','2005-07-07T16:33:48.000','870','80','2005-07-16T11:48:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4300','2005-07-07T16:36:16.000','1189','38','2005-07-10T13:59:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4301','2005-07-07T16:37:23.000','1630','440','2005-07-11T18:05:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4302','2005-07-07T16:47:53.000','3669','332','2005-07-16T22:22:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4303','2005-07-07T16:57:32.000','818','108','2005-07-14T17:42:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4304','2005-07-07T17:01:19.000','3382','165','2005-07-12T22:47:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4305','2005-07-07T17:07:11.000','3926','240','2005-07-08T16:15:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4306','2005-07-07T17:12:32.000','1219','210','2005-07-16T11:24:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4307','2005-07-07T17:20:39.000','2827','394','2005-07-16T14:42:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4308','2005-07-07T17:29:16.000','1482','168','2005-07-11T21:47:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4309','2005-07-07T17:29:41.000','3549','209','2005-07-14T22:22:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4310','2005-07-07T17:30:56.000','3842','390','2005-07-12T13:19:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4311','2005-07-07T17:31:14.000','2985','498','2005-07-11T19:21:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4312','2005-07-07T17:34:59.000','3870','97','2005-07-09T17:45:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4313','2005-07-07T17:36:56.000','91','29','2005-07-13T12:00:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4314','2005-07-07T17:38:31.000','539','184','2005-07-09T20:24:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4315','2005-07-07T17:40:26.000','1472','195','2005-07-09T22:58:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4316','2005-07-07T17:44:22.000','517','301','2005-07-14T15:12:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4317','2005-07-07T17:44:49.000','2234','110','2005-07-08T21:48:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4318','2005-07-07T17:47:50.000','1607','321','2005-07-14T12:15:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4319','2005-07-07T17:50:27.000','3389','25','2005-07-10T13:53:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4320','2005-07-07T17:51:59.000','3437','376','2005-07-13T18:39:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4321','2005-07-07T17:52:38.000','612','91','2005-07-11T23:37:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4322','2005-07-07T17:54:37.000','1522','568','2005-07-14T13:56:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4323','2005-07-07T17:55:53.000','1287','336','2005-07-13T16:43:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4324','2005-07-07T17:57:56.000','952','226','2005-07-13T22:34:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4325','2005-07-07T17:59:24.000','3728','373','2005-07-16T17:10:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4326','2005-07-07T18:01:22.000','4037','331','2005-07-16T15:45:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4327','2005-07-07T18:01:39.000','860','73','2005-07-12T22:40:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4328','2005-07-07T18:03:17.000','2174','264','2005-07-14T16:14:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4329','2005-07-07T18:04:16.000','638','504','2005-07-15T17:58:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4330','2005-07-07T18:09:41.000','2408','408','2005-07-14T22:05:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4331','2005-07-07T18:22:30.000','419','535','2005-07-13T18:20:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4332','2005-07-07T18:25:26.000','1714','137','2005-07-16T15:05:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4333','2005-07-07T18:31:50.000','76','113','2005-07-08T21:26:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4334','2005-07-07T18:32:04.000','3021','210','2005-07-08T16:19:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4335','2005-07-07T18:33:57.000','1332','375','2005-07-11T13:23:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4336','2005-07-07T18:34:36.000','482','532','2005-07-10T17:58:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4337','2005-07-07T18:36:37.000','2313','464','2005-07-14T14:59:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4338','2005-07-07T18:39:56.000','3152','581','2005-07-12T21:03:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4339','2005-07-07T18:41:42.000','3215','130','2005-07-08T13:00:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4340','2005-07-07T18:41:46.000','3919','227','2005-07-16T21:27:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4341','2005-07-07T18:44:23.000','4523','124','2005-07-15T18:13:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4342','2005-07-07T18:47:03.000','1355','120','2005-07-09T21:59:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4343','2005-07-07T18:48:54.000','1926','293','2005-07-12T15:19:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4344','2005-07-07T18:50:47.000','1185','99','2005-07-12T16:38:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4345','2005-07-07T18:52:57.000','2235','225','2005-07-15T21:24:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4346','2005-07-07T18:58:45.000','1906','520','2005-07-10T16:37:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4347','2005-07-07T18:58:57.000','1964','344','2005-07-14T16:35:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4348','2005-07-07T19:02:05.000','1948','452','2005-07-09T20:51:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4349','2005-07-07T19:02:37.000','3430','182','2005-07-09T17:25:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4350','2005-07-07T19:02:41.000','2223','299','2005-07-09T15:27:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4351','2005-07-07T19:04:24.000','3567','382','2005-07-14T00:03:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4352','2005-07-07T19:15:58.000','2636','249','2005-07-16T20:22:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4353','2005-07-07T19:19:05.000','368','452','2005-07-13T13:40:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4354','2005-07-07T19:21:02.000','4423','208','2005-07-15T17:03:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4355','2005-07-07T19:21:19.000','4557','438','2005-07-09T00:55:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4356','2005-07-07T19:21:22.000','1907','318','2005-07-16T15:57:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4357','2005-07-07T19:24:39.000','3413','103','2005-07-12T00:11:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4358','2005-07-07T19:27:04.000','3136','446','2005-07-14T23:46:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4359','2005-07-07T19:30:20.000','3222','282','2005-07-09T13:34:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4360','2005-07-07T19:31:12.000','1811','92','2005-07-10T23:11:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4361','2005-07-07T19:33:23.000','116','425','2005-07-12T22:36:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4362','2005-07-07T19:35:30.000','3759','425','2005-07-14T14:59:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4363','2005-07-07T19:43:28.000','3202','168','2005-07-13T00:15:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4364','2005-07-07T19:46:51.000','10','145','2005-07-08T21:55:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4365','2005-07-07T19:47:46.000','3207','442','2005-07-08T23:21:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4366','2005-07-07T19:48:36.000','2961','524','2005-07-14T01:14:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4367','2005-07-07T19:52:01.000','4529','48','2005-07-13T19:41:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4368','2005-07-07T19:55:19.000','736','324','2005-07-09T00:11:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4369','2005-07-07T20:01:38.000','3552','517','2005-07-13T01:19:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4370','2005-07-07T20:05:36.000','1591','559','2005-07-16T23:58:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4371','2005-07-07T20:06:45.000','2533','90','2005-07-08T18:50:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4372','2005-07-07T20:09:01.000','2207','252','2005-07-09T18:24:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4373','2005-07-07T20:10:59.000','3593','470','2005-07-12T21:30:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4374','2005-07-07T20:13:58.000','4377','517','2005-07-11T18:11:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4375','2005-07-07T20:20:29.000','3035','560','2005-07-16T19:29:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4376','2005-07-07T20:24:33.000','1344','151','2005-07-11T18:32:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4377','2005-07-07T20:28:57.000','3294','205','2005-07-16T02:13:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4378','2005-07-07T20:29:08.000','1244','24','2005-07-12T19:17:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4379','2005-07-07T20:32:30.000','2773','316','2005-07-11T20:40:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4380','2005-07-07T20:35:00.000','3164','353','2005-07-14T17:06:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4381','2005-07-07T20:37:53.000','3727','486','2005-07-10T16:54:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4382','2005-07-07T20:41:03.000','657','26','2005-07-14T15:15:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4383','2005-07-07T20:45:51.000','2649','591','2005-07-17T00:52:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4384','2005-07-07T20:46:45.000','1178','59','2005-07-16T21:54:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4385','2005-07-07T20:48:38.000','849','564','2005-07-11T17:03:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4386','2005-07-07T20:55:19.000','499','314','2005-07-10T21:51:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4387','2005-07-07T20:56:47.000','591','335','2005-07-16T00:51:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4388','2005-07-07T20:58:03.000','3150','210','2005-07-16T20:05:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4389','2005-07-07T20:58:58.000','1672','166','2005-07-13T19:57:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4390','2005-07-07T20:59:06.000','6','44','2005-07-09T00:04:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4391','2005-07-07T21:09:38.000','2135','42','2005-07-09T17:35:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4392','2005-07-07T21:11:02.000','4236','491','2005-07-13T21:52:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4393','2005-07-07T21:12:36.000','4034','395','2005-07-09T22:41:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4394','2005-07-07T21:12:45.000','563','156','2005-07-16T18:24:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4395','2005-07-07T21:13:22.000','360','544','2005-07-08T22:59:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4396','2005-07-07T21:14:19.000','750','275','2005-07-10T19:22:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4397','2005-07-07T21:14:54.000','3085','494','2005-07-13T19:24:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4398','2005-07-07T21:18:44.000','3628','426','2005-07-10T22:45:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4399','2005-07-07T21:20:28.000','4515','402','2005-07-12T20:57:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4400','2005-07-07T21:22:26.000','49','370','2005-07-16T00:59:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4401','2005-07-07T21:26:27.000','2725','405','2005-07-12T17:18:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4402','2005-07-07T21:28:46.000','1198','26','2005-07-08T17:04:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4403','2005-07-07T21:29:40.000','3973','447','2005-07-09T17:58:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4404','2005-07-07T21:31:53.000','944','25','2005-07-13T19:00:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4405','2005-07-07T21:33:16.000','2102','145','2005-07-15T00:33:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4406','2005-07-07T21:35:16.000','438','448','2005-07-15T16:13:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4407','2005-07-07T21:39:45.000','267','20','2005-07-11T23:40:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4408','2005-07-07T21:41:06.000','2482','258','2005-07-11T00:32:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4409','2005-07-07T21:47:29.000','3153','8','2005-07-11T20:14:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4410','2005-07-07T21:48:16.000','2754','584','2005-07-09T03:15:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4411','2005-07-07T21:54:58.000','320','224','2005-07-14T16:14:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4412','2005-07-07T21:56:53.000','1181','282','2005-07-11T19:28:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4413','2005-07-07T22:00:04.000','1062','565','2005-07-10T18:20:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4414','2005-07-07T22:00:21.000','991','434','2005-07-12T02:51:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4415','2005-07-07T22:01:43.000','1403','329','2005-07-13T03:09:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4416','2005-07-07T22:04:36.000','1247','290','2005-07-09T02:44:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4417','2005-07-07T22:05:05.000','743','452','2005-07-09T16:16:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4418','2005-07-07T22:05:30.000','4368','417','2005-07-11T18:42:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4419','2005-07-07T22:06:24.000','783','39','2005-07-15T23:59:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4420','2005-07-07T22:07:31.000','4427','346','2005-07-12T19:14:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4421','2005-07-07T22:07:55.000','4103','417','2005-07-16T20:21:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4422','2005-07-07T22:09:45.000','1741','345','2005-07-10T01:43:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4423','2005-07-07T22:11:28.000','2721','526','2005-07-14T18:49:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4424','2005-07-07T22:14:43.000','662','384','2005-07-11T01:17:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4425','2005-07-07T22:22:44.000','877','345','2005-07-08T22:23:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4426','2005-07-07T22:28:32.000','364','242','2005-07-16T02:04:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4427','2005-07-07T22:28:51.000','1021','69','2005-07-11T21:37:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4428','2005-07-07T22:29:40.000','2575','181','2005-07-11T02:46:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4429','2005-07-07T22:32:47.000','2949','187','2005-07-15T03:10:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4430','2005-07-07T22:35:24.000','3436','278','2005-07-14T23:49:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4431','2005-07-07T22:39:02.000','936','26','2005-07-16T19:24:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4432','2005-07-07T22:40:02.000','2779','295','2005-07-15T01:46:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4433','2005-07-07T22:45:41.000','88','449','2005-07-16T23:30:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4434','2005-07-07T22:48:34.000','1801','32','2005-07-09T18:55:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4435','2005-07-07T22:51:04.000','3815','157','2005-07-14T23:15:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4436','2005-07-07T22:52:04.000','4326','563','2005-07-10T04:51:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4437','2005-07-07T22:55:41.000','3578','414','2005-07-13T19:40:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4438','2005-07-07T22:56:17.000','4371','104','2005-07-16T17:28:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4439','2005-07-07T22:57:30.000','2393','521','2005-07-10T18:28:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4440','2005-07-07T23:00:58.000','1236','507','2005-07-08T21:31:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4441','2005-07-07T23:04:23.000','3680','211','2005-07-13T19:07:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4442','2005-07-07T23:05:30.000','461','123','2005-07-13T22:20:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4443','2005-07-07T23:05:53.000','72','389','2005-07-16T01:46:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4444','2005-07-07T23:07:44.000','764','529','2005-07-14T02:51:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4445','2005-07-07T23:08:22.000','3328','327','2005-07-16T03:49:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4446','2005-07-07T23:12:16.000','2629','438','2005-07-13T19:42:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4447','2005-07-07T23:15:28.000','404','549','2005-07-14T22:53:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4448','2005-07-07T23:17:12.000','2768','536','2005-07-13T18:26:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4449','2005-07-07T23:18:58.000','2813','354','2005-07-15T20:40:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4450','2005-07-07T23:20:05.000','1252','345','2005-07-13T19:50:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4451','2005-07-07T23:29:54.000','179','85','2005-07-10T23:29:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4452','2005-07-07T23:31:54.000','2414','460','2005-07-14T04:05:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4453','2005-07-07T23:32:39.000','89','560','2005-07-12T01:38:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4454','2005-07-07T23:37:00.000','1395','9','2005-07-11T02:30:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4455','2005-07-07T23:43:46.000','1396','507','2005-07-08T21:34:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4456','2005-07-07T23:45:21.000','3395','421','2005-07-13T23:03:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4457','2005-07-07T23:45:38.000','407','567','2005-07-09T20:02:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4458','2005-07-07T23:47:47.000','1307','229','2005-07-09T19:17:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4459','2005-07-07T23:48:52.000','3987','227','2005-07-13T19:37:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4460','2005-07-07T23:50:14.000','4121','592','2005-07-09T21:55:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4461','2005-07-07T23:59:43.000','3656','286','2005-07-16T19:44:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4462','2005-07-08T00:02:49.000','4120','257','2005-07-15T20:48:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4463','2005-07-08T00:04:59.000','4356','422','2005-07-16T01:19:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4464','2005-07-08T00:07:18.000','4484','583','2005-07-08T22:14:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4465','2005-07-08T00:07:45.000','2877','329','2005-07-13T18:08:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4466','2005-07-08T00:12:53.000','3320','304','2005-07-17T03:49:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4467','2005-07-08T00:13:52.000','4466','339','2005-07-09T00:52:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4468','2005-07-08T00:17:59.000','3302','170','2005-07-12T05:51:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4469','2005-07-08T00:18:32.000','2173','192','2005-07-12T21:17:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4470','2005-07-08T00:20:57.000','3605','145','2005-07-10T02:31:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4471','2005-07-08T00:21:29.000','263','30','2005-07-11T18:48:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4472','2005-07-08T00:22:06.000','2089','343','2005-07-16T20:16:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4473','2005-07-08T00:22:10.000','1387','481','2005-07-09T21:11:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4474','2005-07-08T00:26:56.000','4474','137','2005-07-12T23:07:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4475','2005-07-08T00:27:30.000','3466','340','2005-07-09T05:39:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4476','2005-07-08T00:34:25.000','395','279','2005-07-08T22:55:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4477','2005-07-08T00:38:24.000','1602','552','2005-07-13T05:14:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4478','2005-07-08T00:39:08.000','1764','357','2005-07-11T21:57:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4479','2005-07-08T00:52:35.000','3516','211','2005-07-09T20:19:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4480','2005-07-08T00:56:30.000','4457','296','2005-07-10T20:52:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4481','2005-07-08T00:58:15.000','1669','474','2005-07-11T23:22:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4482','2005-07-08T01:01:18.000','3500','511','2005-07-11T01:18:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4483','2005-07-08T01:03:12.000','1222','425','2005-07-17T00:20:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4484','2005-07-08T01:05:57.000','2867','306','2005-07-16T00:41:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4485','2005-07-08T01:07:54.000','2614','130','2005-07-16T03:19:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4486','2005-07-08T01:09:09.000','837','197','2005-07-16T23:40:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4487','2005-07-08T01:20:22.000','2220','360','2005-07-16T21:23:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4488','2005-07-08T01:22:23.000','2108','89','2005-07-13T21:17:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4489','2005-07-08T01:23:58.000','4306','259','2005-07-09T01:35:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4490','2005-07-08T01:26:32.000','2690','161','2005-07-09T01:13:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4491','2005-07-08T01:30:46.000','1168','413','2005-07-11T03:12:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4492','2005-07-08T01:32:04.000','1152','247','2005-07-10T22:11:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4493','2005-07-08T01:40:24.000','1369','167','2005-07-09T02:17:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4494','2005-07-08T01:42:45.000','1655','349','2005-07-16T22:29:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4495','2005-07-08T01:43:46.000','3515','404','2005-07-10T07:38:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4496','2005-07-08T01:44:19.000','150','578','2005-07-08T20:34:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4497','2005-07-08T01:51:32.000','1995','142','2005-07-15T22:56:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4498','2005-07-08T02:07:50.000','4299','43','2005-07-12T23:54:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4499','2005-07-08T02:08:48.000','851','199','2005-07-10T07:06:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4500','2005-07-08T02:10:01.000','398','462','2005-07-15T05:49:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4501','2005-07-08T02:12:00.000','1412','262','2005-07-10T02:16:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4502','2005-07-08T02:12:04.000','225','470','2005-07-15T02:19:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4503','2005-07-08T02:17:12.000','1503','8','2005-07-13T08:12:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4504','2005-07-08T02:19:27.000','361','422','2005-07-12T21:15:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4505','2005-07-08T02:20:04.000','1864','481','2005-07-14T20:28:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4506','2005-07-08T02:22:18.000','1484','133','2005-07-13T04:54:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4507','2005-07-08T02:22:45.000','819','505','2005-07-14T20:53:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4508','2005-07-08T02:28:41.000','3996','97','2005-07-16T23:59:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4509','2005-07-08T02:32:38.000','1760','230','2005-07-14T01:05:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4510','2005-07-08T02:34:51.000','1085','27','2005-07-17T06:03:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4511','2005-07-08T02:36:21.000','4438','75','2005-07-15T06:01:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4512','2005-07-08T02:38:56.000','1569','424','2005-07-10T20:46:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4513','2005-07-08T02:39:59.000','3704','182','2005-07-14T07:48:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4514','2005-07-08T02:41:25.000','1938','576','2005-07-15T06:17:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4515','2005-07-08T02:42:03.000','1998','229','2005-07-10T07:22:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4516','2005-07-08T02:43:41.000','2314','497','2005-07-14T02:20:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4517','2005-07-08T02:45:19.000','453','16','2005-07-12T03:04:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4518','2005-07-08T02:48:36.000','697','592','2005-07-13T04:53:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4519','2005-07-08T02:51:23.000','4425','459','2005-07-12T06:52:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4520','2005-07-08T02:53:46.000','3505','104','2005-07-08T22:27:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4521','2005-07-08T02:57:56.000','2652','327','2005-07-11T22:49:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4522','2005-07-08T03:03:12.000','4114','307','2005-07-10T04:49:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4523','2005-07-08T03:06:59.000','2785','347','2005-07-17T04:44:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4524','2005-07-08T03:10:48.000','2218','185','2005-07-09T07:49:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4525','2005-07-08T03:15:00.000','3631','458','2005-07-11T04:53:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4526','2005-07-08T03:17:05.000','1443','1','2005-07-14T01:19:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4527','2005-07-08T03:20:10.000','2263','468','2005-07-15T02:21:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4528','2005-07-08T03:24:54.000','3209','439','2005-07-09T03:50:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4529','2005-07-08T03:26:20.000','1361','104','2005-07-16T05:04:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4530','2005-07-08T03:27:05.000','3775','79','2005-07-11T07:44:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4531','2005-07-08T03:27:59.000','3108','142','2005-07-10T22:48:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4532','2005-07-08T03:30:39.000','4012','481','2005-07-11T21:49:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4533','2005-07-08T03:32:01.000','1105','474','2005-07-10T21:57:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4534','2005-07-08T03:36:55.000','2518','132','2005-07-16T00:49:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4535','2005-07-08T03:40:46.000','561','29','2005-07-13T06:53:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4536','2005-07-08T03:43:22.000','220','26','2005-07-15T08:44:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4537','2005-07-08T03:48:40.000','1305','448','2005-07-13T22:54:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4538','2005-07-08T03:56:29.000','3638','451','2005-07-15T08:24:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4539','2005-07-08T04:01:02.000','2450','264','2005-07-14T22:32:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4540','2005-07-08T04:03:28.000','4160','309','2005-07-13T03:31:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4541','2005-07-08T04:04:19.000','1976','248','2005-07-13T07:27:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4542','2005-07-08T04:06:30.000','4169','293','2005-07-16T06:54:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4543','2005-07-08T04:06:55.000','913','41','2005-07-12T23:17:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4544','2005-07-08T04:11:04.000','4471','351','2005-07-09T22:48:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4545','2005-07-08T04:17:47.000','3658','271','2005-07-13T07:19:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4546','2005-07-08T04:18:36.000','4507','393','2005-07-17T08:23:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4547','2005-07-08T04:20:19.000','3386','255','2005-07-09T00:28:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4548','2005-07-08T04:21:54.000','765','164','2005-07-14T23:16:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4549','2005-07-08T04:25:03.000','2797','98','2005-07-10T09:01:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4550','2005-07-08T04:34:00.000','615','409','2005-07-14T23:45:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4551','2005-07-08T04:36:21.000','1160','494','2005-07-17T10:23:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4552','2005-07-08T04:36:35.000','2549','313','2005-07-14T05:48:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4553','2005-07-08T04:43:41.000','2114','529','2005-07-09T23:55:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4554','2005-07-08T04:48:03.000','3878','376','2005-07-16T04:34:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4555','2005-07-08T04:48:36.000','1757','68','2005-07-17T07:57:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4556','2005-07-08T04:48:41.000','4099','348','2005-07-16T08:51:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4557','2005-07-08T04:49:15.000','1191','132','2005-07-14T00:00:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4558','2005-07-08T04:55:26.000','828','448','2005-07-09T10:53:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4559','2005-07-08T04:56:49.000','1911','424','2005-07-12T08:56:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4560','2005-07-08T04:58:48.000','303','36','2005-07-10T04:27:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4561','2005-07-08T05:02:43.000','1643','500','2005-07-11T04:56:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4562','2005-07-08T05:08:32.000','963','454','2005-07-12T08:16:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4563','2005-07-08T05:08:55.000','287','522','2005-07-16T05:44:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4564','2005-07-08T05:09:38.000','2494','519','2005-07-11T05:37:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4565','2005-07-08T05:12:28.000','3755','563','2005-07-17T03:38:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4566','2005-07-08T05:18:50.000','4302','133','2005-07-15T01:53:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4567','2005-07-08T05:20:04.000','4073','202','2005-07-10T01:35:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4568','2005-07-08T05:23:59.000','2626','122','2005-07-09T06:07:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4569','2005-07-08T05:30:51.000','2925','366','2005-07-14T04:14:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4570','2005-07-08T05:33:59.000','2612','503','2005-07-14T09:27:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4571','2005-07-08T05:34:41.000','2416','86','2005-07-17T02:15:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4572','2005-07-08T05:36:59.000','1324','323','2005-07-12T04:46:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4573','2005-07-08T05:38:46.000','2478','400','2005-07-15T07:07:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4574','2005-07-08T05:39:42.000','536','257','2005-07-08T23:44:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4575','2005-07-08T05:49:14.000','231','41','2005-07-11T04:08:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4576','2005-07-08T05:51:19.000','1920','567','2005-07-10T11:36:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4577','2005-07-08T05:59:00.000','1688','442','2005-07-16T06:23:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4578','2005-07-08T06:00:17.000','1533','497','2005-07-10T06:58:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4579','2005-07-08T06:01:56.000','4290','585','2005-07-13T11:24:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4580','2005-07-08T06:04:23.000','3512','199','2005-07-15T05:42:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4581','2005-07-08T06:05:06.000','887','591','2005-07-16T00:54:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4582','2005-07-08T06:09:09.000','688','274','2005-07-14T02:23:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4583','2005-07-08T06:09:44.000','4151','365','2005-07-12T03:44:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4584','2005-07-08T06:11:02.000','2322','368','2005-07-11T05:14:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4585','2005-07-08T06:11:58.000','1622','143','2005-07-17T01:58:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4586','2005-07-08T06:12:33.000','1374','461','2005-07-13T11:06:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4587','2005-07-08T06:16:26.000','3502','63','2005-07-13T00:59:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4588','2005-07-08T06:18:01.000','3629','198','2005-07-10T08:59:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4589','2005-07-08T06:26:04.000','1192','99','2005-07-09T10:31:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4590','2005-07-08T06:27:48.000','4233','580','2005-07-14T07:46:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4591','2005-07-08T06:29:43.000','2276','182','2005-07-17T07:20:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4592','2005-07-08T06:31:28.000','2141','235','2005-07-10T06:08:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4593','2005-07-08T06:38:12.000','2897','528','2005-07-16T10:48:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4594','2005-07-08T06:40:06.000','26','506','2005-07-16T05:51:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4595','2005-07-08T06:40:25.000','760','336','2005-07-14T08:54:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4596','2005-07-08T06:41:25.000','2280','306','2005-07-14T01:36:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4597','2005-07-08T06:43:42.000','3767','545','2005-07-13T01:32:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4598','2005-07-08T06:46:26.000','258','82','2005-07-16T01:21:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4599','2005-07-08T06:48:26.000','2098','356','2005-07-11T07:06:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4600','2005-07-08T06:48:37.000','1526','457','2005-07-15T10:11:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4601','2005-07-08T06:49:10.000','3184','572','2005-07-09T07:43:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4602','2005-07-08T06:52:40.000','3616','129','2005-07-10T06:30:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4603','2005-07-08T06:57:07.000','755','334','2005-07-17T04:32:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4604','2005-07-08T06:58:43.000','4230','402','2005-07-14T06:41:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4605','2005-07-08T07:00:14.000','1139','523','2005-07-16T08:38:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4606','2005-07-08T07:05:50.000','1946','502','2005-07-16T09:11:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4607','2005-07-08T07:15:14.000','1193','281','2005-07-11T01:32:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4608','2005-07-08T07:19:11.000','758','11','2005-07-11T01:37:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4609','2005-07-08T07:22:29.000','3711','573','2005-07-10T08:06:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4610','2005-07-08T07:28:05.000','1279','265','2005-07-14T02:10:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4611','2005-07-08T07:33:56.000','3486','1','2005-07-12T13:25:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4612','2005-07-08T07:40:44.000','82','371','2005-07-12T03:48:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4613','2005-07-08T07:44:49.000','476','581','2005-07-09T04:47:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4614','2005-07-08T07:45:17.000','2579','71','2005-07-12T02:10:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4615','2005-07-08T07:46:53.000','1200','404','2005-07-16T12:43:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4616','2005-07-08T07:48:12.000','2580','280','2005-07-10T08:13:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4617','2005-07-08T07:55:08.000','3784','475','2005-07-17T02:49:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4618','2005-07-08T08:00:20.000','3691','179','2005-07-14T05:59:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4619','2005-07-08T08:01:09.000','2127','579','2005-07-16T05:52:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4620','2005-07-08T08:01:44.000','3467','210','2005-07-16T07:43:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4621','2005-07-08T08:02:18.000','1594','297','2005-07-12T08:53:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4622','2005-07-08T08:02:42.000','2710','289','2005-07-10T07:46:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4623','2005-07-08T08:03:22.000','4171','593','2005-07-12T09:11:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4624','2005-07-08T08:12:17.000','1548','341','2005-07-15T12:24:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4625','2005-07-08T08:14:26.000','318','473','2005-07-09T03:45:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4626','2005-07-08T08:18:21.000','37','268','2005-07-10T11:36:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4627','2005-07-08T08:24:39.000','2383','78','2005-07-13T11:04:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4628','2005-07-08T08:25:52.000','1888','540','2005-07-10T11:22:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4629','2005-07-08T08:31:26.000','228','563','2005-07-17T12:07:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4630','2005-07-08T08:33:38.000','3446','319','2005-07-09T13:09:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4631','2005-07-08T08:38:22.000','470','59','2005-07-11T03:33:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4632','2005-07-08T08:38:57.000','4330','393','2005-07-15T09:33:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4633','2005-07-08T08:39:39.000','3178','348','2005-07-15T10:23:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4634','2005-07-08T08:40:02.000','811','275','2005-07-12T04:45:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4635','2005-07-08T08:42:40.000','2434','65','2005-07-14T10:31:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4636','2005-07-08T08:44:32.000','1858','228','2005-07-10T08:59:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4637','2005-07-08T08:49:54.000','1917','263','2005-07-11T13:12:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4638','2005-07-08T08:57:20.000','2240','305','2005-07-10T05:08:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4639','2005-07-08T08:57:21.000','2459','75','2005-07-14T11:22:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4640','2005-07-08T08:59:34.000','1147','506','2005-07-15T03:31:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4641','2005-07-08T09:09:46.000','2436','26','2005-07-17T03:54:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4642','2005-07-08T09:13:28.000','1962','30','2005-07-10T06:17:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4643','2005-07-08T09:13:56.000','239','436','2005-07-10T12:09:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4644','2005-07-08T09:14:29.000','3239','38','2005-07-10T07:20:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4645','2005-07-08T09:20:09.000','687','400','2005-07-09T06:07:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4646','2005-07-08T09:23:26.000','618','362','2005-07-16T04:03:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4647','2005-07-08T09:27:36.000','674','312','2005-07-16T14:56:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4648','2005-07-08T09:31:27.000','3490','444','2005-07-13T03:55:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4649','2005-07-08T09:32:05.000','1116','221','2005-07-15T08:37:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4650','2005-07-08T09:32:08.000','2850','108','2005-07-15T15:20:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4651','2005-07-08T09:39:39.000','4064','557','2005-07-09T12:14:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4652','2005-07-08T09:47:51.000','4198','127','2005-07-16T04:09:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4653','2005-07-08T09:48:01.000','2511','404','2005-07-17T05:18:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4654','2005-07-08T09:48:03.000','4210','434','2005-07-17T13:17:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4655','2005-07-08T09:49:22.000','4078','213','2005-07-15T13:08:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4656','2005-07-08T09:50:10.000','839','141','2005-07-13T15:00:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4657','2005-07-08T09:51:02.000','1002','54','2005-07-09T09:29:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4658','2005-07-08T09:51:11.000','3131','166','2005-07-10T12:30:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4659','2005-07-08T09:53:28.000','4389','425','2005-07-14T14:56:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4660','2005-07-08T09:54:47.000','1208','139','2005-07-11T15:19:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4661','2005-07-08T09:55:06.000','2641','518','2005-07-11T08:26:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4662','2005-07-08T09:58:54.000','1370','553','2005-07-10T12:51:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4663','2005-07-08T09:59:18.000','2959','139','2005-07-10T11:25:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4664','2005-07-08T10:01:28.000','1318','546','2005-07-12T10:37:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4665','2005-07-08T10:04:24.000','575','106','2005-07-14T15:13:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4666','2005-07-08T10:05:02.000','4576','120','2005-07-16T07:28:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4667','2005-07-08T10:06:26.000','3348','485','2005-07-14T04:48:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4668','2005-07-08T10:11:45.000','3971','481','2005-07-17T13:01:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4669','2005-07-08T10:13:08.000','3494','581','2005-07-16T07:52:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4670','2005-07-08T10:14:18.000','3317','153','2005-07-16T15:10:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4671','2005-07-08T10:15:32.000','2139','55','2005-07-14T08:19:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4672','2005-07-08T10:15:38.000','1922','18','2005-07-16T05:06:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4673','2005-07-08T10:16:00.000','2792','91','2005-07-17T10:03:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4674','2005-07-08T10:19:28.000','1617','329','2005-07-12T12:54:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4675','2005-07-08T10:24:22.000','1309','380','2005-07-14T11:09:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4676','2005-07-08T10:26:02.000','2590','302','2005-07-10T13:38:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4677','2005-07-08T10:30:36.000','1226','258','2005-07-14T12:40:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4678','2005-07-08T10:30:40.000','241','219','2005-07-13T11:08:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4679','2005-07-08T10:33:14.000','3610','423','2005-07-15T14:30:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4680','2005-07-08T10:35:28.000','4043','227','2005-07-14T08:42:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4681','2005-07-08T10:36:03.000','1025','133','2005-07-16T09:21:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4682','2005-07-08T10:38:27.000','873','263','2005-07-11T06:29:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4683','2005-07-08T10:38:28.000','3464','283','2005-07-09T12:07:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4684','2005-07-08T10:41:06.000','503','585','2005-07-17T10:35:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4685','2005-07-08T10:45:13.000','602','590','2005-07-12T08:29:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4686','2005-07-08T10:53:39.000','1398','234','2005-07-10T05:34:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4687','2005-07-08T10:54:19.000','1156','169','2005-07-10T08:00:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4688','2005-07-08T11:03:29.000','3574','80','2005-07-17T15:41:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4689','2005-07-08T11:03:47.000','2519','364','2005-07-16T06:07:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4690','2005-07-08T11:04:02.000','3304','64','2005-07-15T10:27:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4691','2005-07-08T11:04:53.000','596','126','2005-07-09T07:48:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4692','2005-07-08T11:07:06.000','1490','288','2005-07-09T14:08:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4693','2005-07-08T11:07:36.000','1694','221','2005-07-14T08:40:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4694','2005-07-08T11:07:37.000','3637','229','2005-07-12T06:53:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4695','2005-07-08T11:07:59.000','805','39','2005-07-17T16:35:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4696','2005-07-08T11:12:27.000','1358','424','2005-07-14T05:41:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4697','2005-07-08T11:19:14.000','4143','224','2005-07-12T07:14:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4698','2005-07-08T11:19:31.000','3963','570','2005-07-13T13:45:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4699','2005-07-08T11:36:56.000','2462','348','2005-07-14T11:35:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4700','2005-07-08T11:37:21.000','3889','317','2005-07-12T15:41:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4701','2005-07-08T11:38:48.000','3012','522','2005-07-13T15:59:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4702','2005-07-08T11:41:36.000','2593','56','2005-07-10T06:55:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4703','2005-07-08T11:44:56.000','2859','544','2005-07-13T09:17:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4704','2005-07-08T11:45:35.000','2291','28','2005-07-10T09:46:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4705','2005-07-08T11:50:38.000','3709','85','2005-07-12T15:58:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4706','2005-07-08T11:51:41.000','2512','380','2005-07-17T12:58:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4707','2005-07-08T11:57:28.000','52','286','2005-07-10T17:47:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4708','2005-07-08T11:59:19.000','3249','212','2005-07-17T07:11:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4709','2005-07-08T12:04:34.000','3964','124','2005-07-15T06:48:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4710','2005-07-08T12:04:53.000','248','590','2005-07-13T11:28:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4711','2005-07-08T12:06:58.000','2327','563','2005-07-12T08:37:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4712','2005-07-08T12:10:50.000','2371','39','2005-07-17T14:54:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4713','2005-07-08T12:12:33.000','1399','207','2005-07-16T17:13:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4714','2005-07-08T12:12:48.000','1932','385','2005-07-17T08:43:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4715','2005-07-08T12:15:37.000','4010','276','2005-07-10T10:37:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4716','2005-07-08T12:18:51.000','1923','391','2005-07-11T11:06:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4717','2005-07-08T12:22:43.000','1491','453','2005-07-11T10:24:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4718','2005-07-08T12:32:08.000','1653','535','2005-07-17T17:34:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4719','2005-07-08T12:33:00.000','1315','556','2005-07-15T12:30:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4720','2005-07-08T12:34:34.000','2669','452','2005-07-09T10:28:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4721','2005-07-08T12:39:31.000','3105','234','2005-07-15T18:07:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4722','2005-07-08T12:42:27.000','3738','590','2005-07-09T09:14:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4723','2005-07-08T12:44:59.000','965','44','2005-07-17T07:22:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4724','2005-07-08T12:46:30.000','3375','18','2005-07-14T12:39:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4725','2005-07-08T12:47:11.000','2058','3','2005-07-15T09:08:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4726','2005-07-08T12:50:54.000','4369','144','2005-07-17T07:09:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4727','2005-07-08T12:54:15.000','1251','39','2005-07-17T14:32:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4728','2005-07-08T12:59:01.000','3687','462','2005-07-13T13:00:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4729','2005-07-08T12:59:40.000','1429','205','2005-07-10T13:35:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4730','2005-07-08T12:59:49.000','1619','126','2005-07-14T16:15:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4731','2005-07-08T13:08:18.000','4124','241','2005-07-09T13:16:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4732','2005-07-08T13:09:45.000','308','562','2005-07-14T10:10:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4733','2005-07-08T13:12:07.000','2230','93','2005-07-13T07:34:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4734','2005-07-08T13:12:12.000','1928','546','2005-07-10T09:01:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4735','2005-07-08T13:12:27.000','4324','381','2005-07-13T10:06:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4736','2005-07-08T13:22:55.000','3009','79','2005-07-17T07:27:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4737','2005-07-08T13:23:53.000','4286','116','2005-07-12T18:49:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4738','2005-07-08T13:24:58.000','2021','31','2005-07-17T17:44:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4739','2005-07-08T13:25:57.000','140','197','2005-07-11T17:36:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4740','2005-07-08T13:30:35.000','2559','379','2005-07-14T18:43:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4741','2005-07-08T13:31:23.000','516','260','2005-07-17T12:02:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4742','2005-07-08T13:35:23.000','3022','340','2005-07-11T10:24:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4743','2005-07-08T13:42:36.000','80','535','2005-07-11T18:54:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4744','2005-07-08T13:43:57.000','2948','507','2005-07-12T09:21:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4745','2005-07-08T13:45:09.000','1351','354','2005-07-12T18:54:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4746','2005-07-08T13:47:55.000','173','148','2005-07-11T09:06:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4747','2005-07-08T13:53:01.000','3942','383','2005-07-12T17:10:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4748','2005-07-08T13:59:38.000','4279','9','2005-07-15T16:51:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4749','2005-07-08T14:05:58.000','1190','236','2005-07-10T18:35:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4750','2005-07-08T14:07:03.000','3383','198','2005-07-13T18:05:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4751','2005-07-08T14:07:52.000','3469','436','2005-07-13T10:37:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4752','2005-07-08T14:15:20.000','3250','512','2005-07-12T13:22:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4753','2005-07-08T14:18:41.000','1642','391','2005-07-09T10:00:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4754','2005-07-08T14:20:01.000','3177','108','2005-07-11T11:50:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4755','2005-07-08T14:23:41.000','661','378','2005-07-10T19:35:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4756','2005-07-08T14:24:00.000','3068','351','2005-07-12T16:16:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4757','2005-07-08T14:36:51.000','1278','504','2005-07-12T15:28:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4758','2005-07-08T14:38:02.000','3698','288','2005-07-13T12:09:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4759','2005-07-08T14:39:22.000','3999','284','2005-07-17T15:02:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4760','2005-07-08T14:48:07.000','3718','177','2005-07-10T12:41:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4761','2005-07-08T14:51:45.000','3556','351','2005-07-14T20:28:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4762','2005-07-08T14:54:42.000','390','36','2005-07-12T18:08:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4763','2005-07-08T14:57:32.000','899','465','2005-07-15T10:00:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4764','2005-07-08T15:01:25.000','1188','89','2005-07-17T15:16:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4765','2005-07-08T15:08:45.000','469','437','2005-07-13T10:44:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4766','2005-07-08T15:16:04.000','1057','149','2005-07-15T11:04:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4767','2005-07-08T15:18:53.000','3744','350','2005-07-13T15:48:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4768','2005-07-08T15:28:20.000','2787','482','2005-07-09T11:46:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4769','2005-07-08T15:29:16.000','3462','501','2005-07-09T18:42:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4770','2005-07-08T15:29:46.000','2406','573','2005-07-14T13:31:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4771','2005-07-08T15:33:32.000','1060','32','2005-07-10T12:38:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4772','2005-07-08T15:41:11.000','2156','486','2005-07-17T15:25:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4773','2005-07-08T15:41:39.000','3025','519','2005-07-13T18:16:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4774','2005-07-08T15:42:28.000','673','489','2005-07-16T18:29:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4775','2005-07-08T15:44:05.000','4277','595','2005-07-11T20:39:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4776','2005-07-08T15:44:20.000','2598','563','2005-07-17T10:50:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4777','2005-07-08T15:48:34.000','449','102','2005-07-16T15:25:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4778','2005-07-08T15:51:51.000','611','78','2005-07-12T16:58:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4779','2005-07-08T15:53:41.000','1321','338','2005-07-15T20:30:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4780','2005-07-08T16:06:51.000','2740','115','2005-07-13T18:34:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4781','2005-07-08T16:06:55.000','1818','593','2005-07-16T11:22:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4782','2005-07-08T16:08:51.000','445','436','2005-07-17T17:56:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4783','2005-07-08T16:09:24.000','3952','214','2005-07-16T21:53:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4784','2005-07-08T16:09:56.000','549','182','2005-07-09T20:35:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4785','2005-07-08T16:10:19.000','58','474','2005-07-11T18:52:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4786','2005-07-08T16:13:05.000','2724','294','2005-07-16T15:29:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4787','2005-07-08T16:16:04.000','3929','7','2005-07-14T18:02:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4788','2005-07-08T16:17:35.000','691','533','2005-07-11T11:56:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4789','2005-07-08T16:22:01.000','20','73','2005-07-15T18:29:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4790','2005-07-08T16:25:27.000','100','500','2005-07-11T11:35:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4791','2005-07-08T16:27:24.000','2505','393','2005-07-14T21:50:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4792','2005-07-08T16:29:38.000','2132','147','2005-07-10T16:31:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4793','2005-07-08T16:30:01.000','3090','427','2005-07-15T17:56:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4794','2005-07-08T16:30:11.000','2497','451','2005-07-17T12:41:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4795','2005-07-08T16:32:54.000','3409','497','2005-07-09T14:15:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4796','2005-07-08T16:35:44.000','2484','9','2005-07-13T11:08:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4797','2005-07-08T16:39:05.000','1389','265','2005-07-09T11:41:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4798','2005-07-08T16:45:16.000','3874','212','2005-07-16T13:45:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4799','2005-07-08T16:49:27.000','4112','512','2005-07-12T19:58:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4800','2005-07-08T16:51:08.000','1940','99','2005-07-13T14:16:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4801','2005-07-08T16:51:36.000','761','431','2005-07-13T17:23:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4802','2005-07-08T16:55:17.000','22','562','2005-07-15T19:34:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4803','2005-07-08T16:56:34.000','1786','174','2005-07-14T20:16:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4804','2005-07-08T16:57:30.000','3756','269','2005-07-10T18:25:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4805','2005-07-08T16:59:12.000','377','453','2005-07-09T15:02:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4806','2005-07-08T17:01:02.000','214','506','2005-07-15T21:41:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4807','2005-07-08T17:01:48.000','4511','348','2005-07-16T22:33:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4808','2005-07-08T17:02:49.000','2544','563','2005-07-12T22:49:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4809','2005-07-08T17:03:22.000','4251','474','2005-07-17T22:39:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4810','2005-07-08T17:04:06.000','4056','209','2005-07-09T13:41:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4811','2005-07-08T17:04:24.000','4032','127','2005-07-12T16:41:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4812','2005-07-08T17:07:11.000','3281','304','2005-07-17T21:03:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4813','2005-07-08T17:09:56.000','2752','439','2005-07-09T22:29:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4814','2005-07-08T17:11:09.000','3497','244','2005-07-17T12:43:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4815','2005-07-08T17:12:51.000','840','581','2005-07-17T13:14:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4816','2005-07-08T17:14:14.000','2700','207','2005-07-11T15:03:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4817','2005-07-08T17:17:31.000','1608','145','2005-07-09T22:32:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4818','2005-07-08T17:18:22.000','115','144','2005-07-14T14:40:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4819','2005-07-08T17:19:15.000','1342','64','2005-07-16T14:32:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4820','2005-07-08T17:25:23.000','2672','172','2005-07-17T20:32:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4821','2005-07-08T17:28:08.000','1690','172','2005-07-11T17:44:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4822','2005-07-08T17:28:47.000','3970','185','2005-07-14T13:06:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4823','2005-07-08T17:28:54.000','155','206','2005-07-11T23:10:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4824','2005-07-08T17:37:39.000','1855','225','2005-07-16T18:27:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4825','2005-07-08T17:43:01.000','2419','563','2005-07-11T20:58:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4826','2005-07-08T17:44:25.000','911','180','2005-07-16T20:14:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4827','2005-07-08T17:46:30.000','4455','110','2005-07-11T14:12:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4828','2005-07-08T17:52:29.000','1100','92','2005-07-11T14:35:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4829','2005-07-08T17:54:18.000','2661','133','2005-07-11T23:41:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4830','2005-07-08T17:56:23.000','1150','359','2005-07-17T21:40:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4831','2005-07-08T18:00:14.000','2739','243','2005-07-12T15:54:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4832','2005-07-08T18:07:05.000','1838','509','2005-07-10T19:37:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4833','2005-07-08T18:07:35.000','2921','581','2005-07-13T15:29:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4834','2005-07-08T18:07:45.000','1288','301','2005-07-14T15:27:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4835','2005-07-08T18:08:13.000','2499','95','2005-07-17T16:51:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4836','2005-07-08T18:09:08.000','2756','311','2005-07-15T20:19:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4837','2005-07-08T18:09:12.000','1944','149','2005-07-11T16:40:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4838','2005-07-08T18:11:00.000','3733','84','2005-07-17T12:57:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4839','2005-07-08T18:13:10.000','1810','556','2005-07-15T12:49:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4840','2005-07-08T18:18:16.000','1670','119','2005-07-16T14:59:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4841','2005-07-08T18:18:23.000','518','248','2005-07-11T16:51:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4842','2005-07-08T18:21:30.000','1438','160','2005-07-10T22:25:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4843','2005-07-08T18:27:28.000','3640','45','2005-07-15T00:26:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4844','2005-07-08T18:28:13.000','4057','237','2005-07-09T21:17:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4845','2005-07-08T18:28:20.000','2337','553','2005-07-09T14:38:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4846','2005-07-08T18:29:05.000','417','556','2005-07-10T22:33:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4847','2005-07-08T18:29:13.000','3397','544','2005-07-15T18:12:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4848','2005-07-08T18:30:16.000','2962','251','2005-07-12T19:53:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4849','2005-07-08T18:34:34.000','4323','146','2005-07-14T20:27:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4850','2005-07-08T18:39:31.000','3039','154','2005-07-13T00:18:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4851','2005-07-08T18:40:05.000','134','557','2005-07-12T21:46:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4852','2005-07-08T18:43:15.000','3545','418','2005-07-15T18:48:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4853','2005-07-08T18:43:18.000','1454','23','2005-07-12T14:28:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4854','2005-07-08T18:44:44.000','3644','487','2005-07-13T13:37:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4855','2005-07-08T18:45:50.000','1146','337','2005-07-11T18:23:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4856','2005-07-08T18:47:38.000','2441','7','2005-07-13T15:02:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4857','2005-07-08T18:52:07.000','2069','211','2005-07-11T22:06:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4858','2005-07-08T18:53:24.000','3424','447','2005-07-17T20:32:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4859','2005-07-08T18:54:04.000','1939','369','2005-07-13T13:04:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4860','2005-07-08T18:54:07.000','428','123','2005-07-17T15:09:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4861','2005-07-08T18:57:30.000','2984','455','2005-07-16T15:12:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4862','2005-07-08T19:02:46.000','293','291','2005-07-17T20:17:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4863','2005-07-08T19:03:15.000','1','431','2005-07-11T21:29:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4864','2005-07-08T19:05:34.000','2974','281','2005-07-17T15:05:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4865','2005-07-08T19:09:04.000','1614','418','2005-07-13T21:25:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4866','2005-07-08T19:09:59.000','4036','278','2005-07-15T00:51:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4867','2005-07-08T19:10:52.000','4090','593','2005-07-09T21:43:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4868','2005-07-08T19:13:50.000','1157','307','2005-07-14T20:59:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4869','2005-07-08T19:14:05.000','2860','376','2005-07-15T22:27:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4870','2005-07-08T19:14:45.000','3089','260','2005-07-12T18:58:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4871','2005-07-08T19:19:52.000','2509','210','2005-07-13T20:27:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4872','2005-07-08T19:23:16.000','1836','103','2005-07-10T14:17:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4873','2005-07-08T19:23:32.000','4500','473','2005-07-11T15:24:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4874','2005-07-08T19:23:38.000','2386','223','2005-07-13T14:39:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4875','2005-07-08T19:24:17.000','843','555','2005-07-11T19:15:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4876','2005-07-08T19:27:50.000','1959','283','2005-07-14T15:42:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4877','2005-07-08T19:31:02.000','1846','287','2005-07-15T19:05:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4878','2005-07-08T19:33:49.000','4009','172','2005-07-17T17:47:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4879','2005-07-08T19:34:55.000','1406','196','2005-07-09T15:53:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4880','2005-07-08T19:36:17.000','4178','269','2005-07-13T00:01:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4881','2005-07-08T19:40:34.000','4346','349','2005-07-09T17:08:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4882','2005-07-08T19:42:03.000','4540','184','2005-07-16T22:24:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4883','2005-07-08T19:46:58.000','1366','563','2005-07-10T15:48:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4884','2005-07-08T19:49:17.000','3543','425','2005-07-15T23:14:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4885','2005-07-08T19:51:17.000','442','233','2005-07-12T16:02:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4886','2005-07-08T19:53:22.000','3393','474','2005-07-09T17:05:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4887','2005-07-08T19:59:14.000','3613','543','2005-07-15T22:53:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4888','2005-07-08T20:04:27.000','1220','527','2005-07-10T14:53:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4889','2005-07-08T20:04:43.000','4463','5','2005-07-13T17:57:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4890','2005-07-08T20:05:38.000','3576','574','2005-07-14T14:55:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4891','2005-07-08T20:06:19.000','1787','59','2005-07-16T18:52:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4892','2005-07-08T20:06:25.000','3566','193','2005-07-14T20:04:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4893','2005-07-08T20:19:55.000','2060','210','2005-07-15T21:28:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4894','2005-07-08T20:21:31.000','1028','286','2005-07-11T01:59:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4895','2005-07-08T20:22:05.000','2620','242','2005-07-12T20:49:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4896','2005-07-08T20:23:15.000','3006','129','2005-07-10T15:38:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4897','2005-07-08T20:25:11.000','2950','258','2005-07-09T17:16:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4898','2005-07-08T20:31:43.000','3212','218','2005-07-15T15:58:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4899','2005-07-08T20:37:11.000','414','32','2005-07-10T21:53:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4900','2005-07-08T20:38:06.000','3487','426','2005-07-09T22:45:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4901','2005-07-08T20:44:51.000','2187','507','2005-07-10T01:04:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4902','2005-07-08T20:49:30.000','2238','554','2005-07-13T16:54:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4903','2005-07-08T20:50:05.000','1769','132','2005-07-13T15:27:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4904','2005-07-08T20:53:27.000','2051','173','2005-07-18T01:16:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4905','2005-07-08T20:56:00.000','4101','246','2005-07-12T00:19:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4906','2005-07-08T20:59:13.000','1527','490','2005-07-15T01:12:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4907','2005-07-08T21:01:41.000','1206','209','2005-07-13T02:23:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4908','2005-07-08T21:05:44.000','1963','160','2005-07-17T21:33:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4909','2005-07-08T21:07:24.000','1451','228','2005-07-10T22:34:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4910','2005-07-08T21:13:56.000','3675','219','2005-07-18T02:39:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4911','2005-07-08T21:20:26.000','4479','66','2005-07-15T03:11:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4912','2005-07-08T21:26:11.000','2012','275','2005-07-18T02:19:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4913','2005-07-08T21:27:48.000','982','368','2005-07-18T02:51:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4914','2005-07-08T21:30:53.000','298','535','2005-07-17T01:29:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4915','2005-07-08T21:31:22.000','2772','178','2005-07-13T16:45:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4916','2005-07-08T21:32:17.000','2680','212','2005-07-14T20:55:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4917','2005-07-08T21:32:30.000','3231','104','2005-07-09T15:34:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4918','2005-07-08T21:37:31.000','3819','220','2005-07-11T20:16:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4919','2005-07-08T21:41:54.000','2106','157','2005-07-11T23:14:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4920','2005-07-08T21:42:10.000','4285','239','2005-07-15T03:08:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4921','2005-07-08T21:43:21.000','425','109','2005-07-10T16:06:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4922','2005-07-08T21:44:00.000','2928','577','2005-07-10T02:58:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4923','2005-07-08T21:44:39.000','932','18','2005-07-17T15:50:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4924','2005-07-08T21:55:25.000','4344','180','2005-07-16T16:52:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4925','2005-07-08T21:56:00.000','2169','68','2005-07-14T17:17:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4926','2005-07-08T22:01:48.000','4155','415','2005-07-18T03:27:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4927','2005-07-08T22:05:35.000','2566','136','2005-07-14T23:22:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4928','2005-07-08T22:05:41.000','4363','77','2005-07-09T23:09:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4929','2005-07-08T22:06:18.000','734','297','2005-07-17T18:17:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4930','2005-07-08T22:15:48.000','2057','451','2005-07-15T21:02:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4931','2005-07-08T22:16:18.000','2750','284','2005-07-17T03:42:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4932','2005-07-08T22:17:40.000','4237','558','2005-07-15T22:13:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4933','2005-07-08T22:18:29.000','322','579','2005-07-13T03:47:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4934','2005-07-08T22:18:42.000','1744','517','2005-07-10T20:44:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4935','2005-07-08T22:20:56.000','2708','230','2005-07-12T01:01:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4936','2005-07-08T22:24:50.000','2033','298','2005-07-15T03:14:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4937','2005-07-08T22:29:59.000','33','273','2005-07-15T21:51:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4938','2005-07-08T22:32:53.000','2164','418','2005-07-14T16:48:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4939','2005-07-08T22:35:30.000','3201','425','2005-07-17T22:05:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4940','2005-07-08T22:36:06.000','971','215','2005-07-15T04:28:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4941','2005-07-08T22:39:10.000','3816','553','2005-07-15T17:49:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4942','2005-07-08T22:42:47.000','4467','120','2005-07-15T04:36:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4943','2005-07-08T22:43:05.000','2732','11','2005-07-15T18:17:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4944','2005-07-08T22:44:28.000','3648','293','2005-07-17T21:51:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4945','2005-07-08T22:45:02.000','2079','165','2005-07-11T23:59:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4946','2005-07-08T22:46:23.000','272','440','2005-07-16T17:19:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4947','2005-07-08T22:49:37.000','3905','388','2005-07-17T21:03:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4948','2005-07-08T22:54:21.000','2972','518','2005-07-17T03:52:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4949','2005-07-08T22:57:10.000','1184','567','2005-07-11T01:26:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4950','2005-07-08T22:58:07.000','3291','148','2005-07-09T20:41:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4951','2005-07-08T22:58:21.000','2766','28','2005-07-16T18:58:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4952','2005-07-08T23:00:07.000','459','14','2005-07-09T21:47:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4953','2005-07-08T23:09:48.000','2460','168','2005-07-11T02:08:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4954','2005-07-08T23:14:16.000','627','99','2005-07-14T23:23:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4955','2005-07-08T23:16:21.000','1103','225','2005-07-14T02:09:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4956','2005-07-08T23:17:10.000','1512','477','2005-07-18T00:14:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4957','2005-07-08T23:18:48.000','4082','399','2005-07-09T23:13:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4958','2005-07-08T23:19:52.000','2354','346','2005-07-17T20:31:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4959','2005-07-08T23:22:23.000','3898','236','2005-07-10T03:17:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4960','2005-07-08T23:27:16.000','2176','434','2005-07-18T02:01:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4961','2005-07-08T23:35:53.000','3668','96','2005-07-14T22:46:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4962','2005-07-08T23:36:13.000','4399','532','2005-07-15T03:39:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4963','2005-07-08T23:38:40.000','737','404','2005-07-12T05:33:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4964','2005-07-08T23:46:38.000','1033','455','2005-07-09T22:19:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4965','2005-07-08T23:46:57.000','535','432','2005-07-15T18:47:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4966','2005-07-08T23:47:25.000','4360','118','2005-07-14T03:35:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4967','2005-07-08T23:48:03.000','108','339','2005-07-15T23:51:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4968','2005-07-08T23:49:19.000','3204','390','2005-07-14T02:46:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4969','2005-07-08T23:51:26.000','4563','231','2005-07-12T03:21:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4970','2005-07-08T23:54:29.000','2983','100','2005-07-16T22:47:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4971','2005-07-08T23:54:49.000','460','64','2005-07-16T00:15:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4972','2005-07-08T23:56:09.000','2451','498','2005-07-16T19:15:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4973','2005-07-08T23:58:18.000','391','432','2005-07-14T21:42:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4974','2005-07-09T00:00:36.000','1071','152','2005-07-13T21:03:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4975','2005-07-09T00:02:46.000','3730','101','2005-07-14T18:05:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4976','2005-07-09T00:03:30.000','617','199','2005-07-10T19:05:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4977','2005-07-09T00:15:50.000','3310','584','2005-07-10T00:34:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4978','2005-07-09T00:22:02.000','2578','279','2005-07-18T04:37:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4979','2005-07-09T00:24:34.000','3447','204','2005-07-12T20:04:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4980','2005-07-09T00:26:59.000','2638','100','2005-07-14T19:42:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4981','2005-07-09T00:29:29.000','3363','399','2005-07-16T19:06:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4982','2005-07-09T00:30:52.000','249','162','2005-07-15T23:50:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4983','2005-07-09T00:34:16.000','1469','81','2005-07-17T03:21:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4984','2005-07-09T00:35:31.000','1303','214','2005-07-17T03:44:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4985','2005-07-09T00:36:02.000','2146','208','2005-07-14T04:06:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4986','2005-07-09T00:44:33.000','3517','589','2005-07-09T19:45:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4987','2005-07-09T00:45:41.000','996','277','2005-07-14T03:32:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4988','2005-07-09T00:46:14.000','2718','433','2005-07-16T01:45:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4989','2005-07-09T00:46:56.000','3326','210','2005-07-17T06:24:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4990','2005-07-09T00:48:49.000','3305','35','2005-07-10T06:36:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4991','2005-07-09T00:49:03.000','1856','540','2005-07-13T05:02:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4992','2005-07-09T00:49:37.000','2081','315','2005-07-16T02:05:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4993','2005-07-09T00:49:47.000','1740','517','2005-07-11T21:19:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4994','2005-07-09T00:54:13.000','2546','246','2005-07-09T21:02:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4995','2005-07-09T00:57:46.000','2063','247','2005-07-13T03:32:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4996','2005-07-09T00:59:46.000','4440','129','2005-07-16T01:30:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4997','2005-07-09T01:06:03.000','186','102','2005-07-18T04:21:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4998','2005-07-09T01:07:21.000','202','534','2005-07-10T05:48:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('4999','2005-07-09T01:12:57.000','1797','196','2005-07-17T00:12:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5000','2005-07-09T01:16:13.000','668','146','2005-07-14T21:55:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5001','2005-07-09T01:17:04.000','2025','40','2005-07-16T03:25:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5002','2005-07-09T01:17:08.000','2388','430','2005-07-15T21:53:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5003','2005-07-09T01:19:03.000','3438','569','2005-07-10T04:28:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5004','2005-07-09T01:20:50.000','2637','382','2005-07-09T19:56:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5005','2005-07-09T01:21:44.000','3034','451','2005-07-14T20:27:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5006','2005-07-09T01:24:07.000','1277','486','2005-07-18T03:56:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5007','2005-07-09T01:26:22.000','3079','207','2005-07-12T20:48:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5008','2005-07-09T01:31:42.000','824','509','2005-07-11T22:34:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5009','2005-07-09T01:32:17.000','1539','102','2005-07-18T03:39:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5010','2005-07-09T01:33:23.000','1999','574','2005-07-14T04:00:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5011','2005-07-09T01:44:40.000','463','249','2005-07-11T00:58:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5012','2005-07-09T01:45:04.000','1456','251','2005-07-12T02:13:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5013','2005-07-09T01:46:45.000','3000','35','2005-07-16T06:57:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5014','2005-07-09T01:51:49.000','4095','334','2005-07-10T04:48:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5015','2005-07-09T01:54:24.000','1564','178','2005-07-12T20:07:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5016','2005-07-09T01:57:57.000','1871','5','2005-07-09T22:07:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5017','2005-07-09T02:00:16.000','3745','241','2005-07-14T06:28:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5018','2005-07-09T02:01:05.000','2317','541','2005-07-10T04:09:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5019','2005-07-09T02:04:32.000','3534','295','2005-07-15T07:01:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5020','2005-07-09T02:07:56.000','4113','565','2005-07-09T23:59:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5021','2005-07-09T02:09:41.000','3445','73','2005-07-13T05:47:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5022','2005-07-09T02:10:54.000','928','499','2005-07-17T08:07:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5023','2005-07-09T02:23:16.000','3206','358','2005-07-15T20:37:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5024','2005-07-09T02:25:12.000','2987','335','2005-07-12T03:15:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5025','2005-07-09T02:28:24.000','153','91','2005-07-12T04:43:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5026','2005-07-09T02:32:34.000','989','463','2005-07-13T04:39:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5027','2005-07-09T02:32:37.000','2179','109','2005-07-16T23:13:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5028','2005-07-09T02:34:45.000','4531','30','2005-07-14T20:45:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5029','2005-07-09T02:35:32.000','3938','265','2005-07-17T22:46:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5030','2005-07-09T02:35:43.000','25','497','2005-07-17T02:05:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5031','2005-07-09T02:36:37.000','4224','312','2005-07-14T03:09:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5032','2005-07-09T02:39:47.000','2257','333','2005-07-10T07:45:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5033','2005-07-09T02:42:01.000','2841','299','2005-07-14T00:29:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5034','2005-07-09T02:48:15.000','340','148','2005-07-11T23:13:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5035','2005-07-09T02:51:34.000','3699','99','2005-07-16T21:38:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5036','2005-07-09T02:58:41.000','75','573','2005-07-17T04:09:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5037','2005-07-09T02:59:10.000','435','524','2005-07-15T07:54:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5038','2005-07-09T03:12:52.000','3086','10','2005-07-17T22:27:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5039','2005-07-09T03:14:45.000','2020','268','2005-07-16T06:57:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5040','2005-07-09T03:16:34.000','2479','405','2005-07-17T01:13:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5041','2005-07-09T03:18:51.000','2711','305','2005-07-13T03:08:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5042','2005-07-09T03:20:30.000','3609','254','2005-07-15T07:22:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5043','2005-07-09T03:25:18.000','2979','369','2005-07-13T00:57:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5044','2005-07-09T03:30:25.000','1625','147','2005-07-11T02:32:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5045','2005-07-09T03:33:32.000','1041','230','2005-07-18T06:15:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5046','2005-07-09T03:34:57.000','1639','227','2005-07-17T22:36:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5047','2005-07-09T03:44:15.000','230','272','2005-07-15T09:07:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5048','2005-07-09T03:46:33.000','1271','466','2005-07-15T01:14:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5049','2005-07-09T03:54:12.000','3336','144','2005-07-11T22:39:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5050','2005-07-09T03:54:38.000','3876','337','2005-07-10T02:23:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5051','2005-07-09T03:57:53.000','4091','85','2005-07-16T08:22:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5052','2005-07-09T03:59:43.000','1884','305','2005-07-12T05:48:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5053','2005-07-09T03:59:46.000','570','295','2005-07-09T23:53:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5054','2005-07-09T04:01:02.000','4001','135','2005-07-18T05:16:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5055','2005-07-09T04:05:28.000','751','54','2005-07-14T04:26:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5056','2005-07-09T04:13:45.000','2599','526','2005-07-10T06:17:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5057','2005-07-09T04:20:29.000','1076','178','2005-07-14T23:59:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5058','2005-07-09T04:20:35.000','917','221','2005-07-18T08:09:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5059','2005-07-09T04:28:01.000','3951','396','2005-07-15T22:57:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5060','2005-07-09T04:28:03.000','4317','57','2005-07-12T07:41:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5061','2005-07-09T04:30:50.000','3893','230','2005-07-12T03:24:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5062','2005-07-09T04:36:49.000','2190','141','2005-07-10T06:26:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5063','2005-07-09T04:37:31.000','1027','133','2005-07-13T09:56:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5064','2005-07-09T04:38:51.000','373','512','2005-07-18T00:33:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5065','2005-07-09T04:42:00.000','1788','599','2005-07-12T08:55:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5066','2005-07-09T04:48:50.000','1702','169','2005-07-12T22:54:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5067','2005-07-09T04:52:35.000','1480','225','2005-07-11T23:33:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5068','2005-07-09T04:53:18.000','2937','10','2005-07-13T09:21:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5069','2005-07-09T04:56:30.000','4417','183','2005-07-13T23:53:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5070','2005-07-09T04:58:26.000','2305','407','2005-07-09T23:00:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5071','2005-07-09T05:00:39.000','4358','12','2005-07-09T23:08:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5072','2005-07-09T05:01:58.000','94','254','2005-07-18T08:17:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5073','2005-07-09T05:02:35.000','546','408','2005-07-15T01:22:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5074','2005-07-09T05:06:24.000','1379','12','2005-07-12T04:37:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5075','2005-07-09T05:12:07.000','903','170','2005-07-12T08:29:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5076','2005-07-09T05:13:22.000','4388','574','2005-07-16T09:11:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5077','2005-07-09T05:18:01.000','686','574','2005-07-17T10:39:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5078','2005-07-09T05:20:24.000','1994','78','2005-07-13T06:41:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5079','2005-07-09T05:20:40.000','3948','566','2005-07-17T00:06:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5080','2005-07-09T05:23:55.000','635','254','2005-07-11T05:56:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5081','2005-07-09T05:25:20.000','1953','420','2005-07-13T23:45:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5082','2005-07-09T05:28:38.000','1584','470','2005-07-10T02:46:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5083','2005-07-09T05:30:32.000','148','494','2005-07-11T02:20:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5084','2005-07-09T05:33:27.000','3113','87','2005-07-17T08:54:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5085','2005-07-09T05:36:49.000','4164','437','2005-07-13T09:26:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5086','2005-07-09T05:40:04.000','3072','539','2005-07-16T07:51:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5087','2005-07-09T05:44:28.000','3716','395','2005-07-10T02:25:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5088','2005-07-09T05:45:16.000','3324','454','2005-07-15T00:41:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5089','2005-07-09T05:45:40.000','451','289','2005-07-15T05:31:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5090','2005-07-09T05:48:22.000','1728','296','2005-07-11T06:50:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5091','2005-07-09T05:52:54.000','4572','149','2005-07-10T02:49:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5092','2005-07-09T05:57:39.000','3256','139','2005-07-12T00:45:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5093','2005-07-09T05:59:12.000','2734','597','2005-07-10T11:45:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5094','2005-07-09T05:59:47.000','4451','178','2005-07-18T05:34:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5095','2005-07-09T06:08:22.000','2788','292','2005-07-11T10:52:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5096','2005-07-09T06:08:23.000','490','231','2005-07-14T11:36:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5097','2005-07-09T06:09:51.000','3252','343','2005-07-10T03:55:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5098','2005-07-09T06:13:54.000','1772','406','2005-07-10T04:27:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5099','2005-07-09T06:14:30.000','768','393','2005-07-12T08:23:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5100','2005-07-09T06:16:03.000','3193','101','2005-07-10T10:21:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5101','2005-07-09T06:21:29.000','2737','154','2005-07-11T02:58:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5102','2005-07-09T06:25:48.000','242','316','2005-07-16T11:32:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5103','2005-07-09T06:34:40.000','2390','397','2005-07-10T03:44:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5104','2005-07-09T06:37:07.000','2109','14','2005-07-14T12:32:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5105','2005-07-09T06:38:59.000','2555','290','2005-07-17T03:06:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5106','2005-07-09T06:40:24.000','110','137','2005-07-13T10:28:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5107','2005-07-09T06:42:32.000','1697','21','2005-07-10T08:21:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5108','2005-07-09T06:44:30.000','4229','30','2005-07-17T04:24:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5109','2005-07-09T06:48:49.000','2373','102','2005-07-14T01:17:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5110','2005-07-09T06:57:25.000','195','200','2005-07-12T05:39:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5111','2005-07-09T07:02:19.000','2875','12','2005-07-10T06:27:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5112','2005-07-09T07:04:04.000','3529','285','2005-07-13T08:42:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5113','2005-07-09T07:06:18.000','3618','282','2005-07-13T07:10:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5114','2005-07-09T07:07:05.000','3734','64','2005-07-15T03:06:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5115','2005-07-09T07:07:18.000','2296','212','2005-07-16T03:28:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5116','2005-07-09T07:10:12.000','2491','332','2005-07-14T09:16:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5117','2005-07-09T07:11:22.000','2284','208','2005-07-15T08:44:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5118','2005-07-09T07:13:52.000','957','5','2005-07-18T05:18:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5119','2005-07-09T07:14:18.000','2996','301','2005-07-18T04:07:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5120','2005-07-09T07:14:23.000','4431','373','2005-07-14T04:00:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5121','2005-07-09T07:18:31.000','3321','526','2005-07-15T01:48:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5122','2005-07-09T07:19:35.000','1423','261','2005-07-16T03:04:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5123','2005-07-09T07:20:30.000','4278','219','2005-07-14T05:24:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5124','2005-07-09T07:25:19.000','1857','565','2005-07-15T01:51:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5125','2005-07-09T07:25:28.000','990','263','2005-07-12T12:34:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5126','2005-07-09T07:25:35.000','3312','315','2005-07-18T05:05:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5127','2005-07-09T07:25:47.000','3649','129','2005-07-13T11:44:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5128','2005-07-09T07:25:54.000','3757','155','2005-07-16T04:04:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5129','2005-07-09T07:28:33.000','4516','441','2005-07-14T05:12:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5130','2005-07-09T07:29:45.000','3264','93','2005-07-13T05:56:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5131','2005-07-09T07:35:03.000','3179','167','2005-07-10T06:05:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5132','2005-07-09T07:40:32.000','4158','101','2005-07-16T02:16:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5133','2005-07-09T07:43:22.000','3403','469','2005-07-12T04:52:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5134','2005-07-09T07:53:12.000','149','491','2005-07-16T05:30:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5135','2005-07-09T07:53:22.000','3005','538','2005-07-16T04:50:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5136','2005-07-09T07:55:01.000','3498','395','2005-07-11T05:26:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5137','2005-07-09T08:00:34.000','409','126','2005-07-12T05:34:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5138','2005-07-09T08:00:46.000','1283','548','2005-07-12T09:31:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5139','2005-07-09T08:01:51.000','51','539','2005-07-18T09:16:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5140','2005-07-09T08:04:59.000','947','303','2005-07-11T08:28:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5141','2005-07-09T08:05:14.000','590','488','2005-07-18T04:36:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5142','2005-07-09T08:05:23.000','369','56','2005-07-13T12:37:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5143','2005-07-09T08:07:07.000','3803','196','2005-07-18T10:17:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5144','2005-07-09T08:09:53.000','3530','89','2005-07-18T07:11:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5145','2005-07-09T08:13:25.000','2397','204','2005-07-10T03:56:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5146','2005-07-09T08:14:58.000','776','194','2005-07-11T07:04:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5147','2005-07-09T08:17:41.000','2270','326','2005-07-18T09:45:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5148','2005-07-09T08:22:46.000','456','48','2005-07-18T04:36:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5149','2005-07-09T08:28:23.000','1500','330','2005-07-16T06:19:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5150','2005-07-09T08:28:40.000','1961','410','2005-07-16T04:47:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5151','2005-07-09T08:31:03.000','224','228','2005-07-10T08:18:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5152','2005-07-09T08:34:44.000','4005','331','2005-07-10T05:26:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5153','2005-07-09T08:35:05.000','2826','504','2005-07-18T14:21:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5154','2005-07-09T08:46:18.000','3785','361','2005-07-14T03:19:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5155','2005-07-09T08:46:54.000','988','523','2005-07-14T04:13:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5156','2005-07-09T08:51:42.000','416','5','2005-07-15T03:59:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5157','2005-07-09T08:52:12.000','637','463','2005-07-12T04:32:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5158','2005-07-09T08:53:09.000','2825','272','2005-07-10T11:05:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5159','2005-07-09T08:55:52.000','3479','213','2005-07-10T04:32:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5160','2005-07-09T08:57:07.000','1925','467','2005-07-18T06:01:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5161','2005-07-09T08:57:56.000','2617','284','2005-07-18T07:41:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5162','2005-07-09T09:00:11.000','2765','43','2005-07-17T07:26:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5163','2005-07-09T09:00:28.000','1486','103','2005-07-17T08:07:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5164','2005-07-09T09:03:14.000','1170','511','2005-07-14T04:20:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5165','2005-07-09T09:08:53.000','280','590','2005-07-14T06:01:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5166','2005-07-09T09:15:48.000','2771','298','2005-07-16T06:04:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5167','2005-07-09T09:18:43.000','2485','437','2005-07-14T12:59:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5168','2005-07-09T09:20:01.000','4096','420','2005-07-11T14:42:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5169','2005-07-09T09:22:25.000','2608','116','2005-07-10T03:48:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5170','2005-07-09T09:24:19.000','66','209','2005-07-18T04:02:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5171','2005-07-09T09:26:55.000','2099','371','2005-07-10T10:34:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5172','2005-07-09T09:31:27.000','4046','214','2005-07-13T04:03:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5173','2005-07-09T09:31:44.000','2848','490','2005-07-15T04:20:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5174','2005-07-09T09:31:59.000','3621','47','2005-07-15T03:49:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5175','2005-07-09T09:34:28.000','1003','409','2005-07-15T15:19:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5176','2005-07-09T09:39:31.000','328','119','2005-07-17T11:56:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5177','2005-07-09T09:43:21.000','1675','452','2005-07-13T07:29:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5178','2005-07-09T09:59:52.000','1750','167','2005-07-18T13:01:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5179','2005-07-09T10:00:44.000','2995','256','2005-07-11T06:52:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5180','2005-07-09T10:06:53.000','3684','494','2005-07-12T15:25:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5181','2005-07-09T10:07:27.000','2569','45','2005-07-17T10:18:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5182','2005-07-09T10:08:10.000','725','197','2005-07-16T14:36:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5183','2005-07-09T10:13:45.000','2866','394','2005-07-16T15:55:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5184','2005-07-09T10:14:34.000','1101','166','2005-07-14T16:05:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5185','2005-07-09T10:14:39.000','357','53','2005-07-10T13:31:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5186','2005-07-09T10:18:40.000','2415','276','2005-07-13T05:05:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5187','2005-07-09T10:19:51.000','2631','91','2005-07-14T10:35:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5188','2005-07-09T10:22:31.000','3265','34','2005-07-13T04:41:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5189','2005-07-09T10:23:21.000','2539','113','2005-07-14T08:06:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5190','2005-07-09T10:25:24.000','2213','532','2005-07-18T04:33:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5191','2005-07-09T10:26:48.000','2131','167','2005-07-10T15:52:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5192','2005-07-09T10:27:09.000','1225','410','2005-07-10T12:04:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5193','2005-07-09T10:28:18.000','2166','485','2005-07-12T12:18:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5194','2005-07-09T10:31:34.000','3809','202','2005-07-15T08:50:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5195','2005-07-09T10:39:31.000','3399','59','2005-07-18T13:54:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5196','2005-07-09T10:43:34.000','2278','536','2005-07-13T12:10:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5197','2005-07-09T10:43:54.000','1571','541','2005-07-16T10:19:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5198','2005-07-09T10:49:10.000','218','101','2005-07-13T04:52:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5199','2005-07-09T10:50:56.000','349','42','2005-07-10T06:43:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5200','2005-07-09T10:52:09.000','4528','125','2005-07-13T15:12:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5201','2005-07-09T10:52:53.000','2453','551','2005-07-16T12:41:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5202','2005-07-09T10:53:48.000','3417','321','2005-07-15T13:31:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5203','2005-07-09T10:53:59.000','3661','588','2005-07-15T09:45:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5204','2005-07-09T10:54:14.000','1791','432','2005-07-12T14:29:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5205','2005-07-09T10:56:37.000','161','79','2005-07-13T05:45:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5206','2005-07-09T11:11:01.000','692','517','2005-07-17T07:23:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5207','2005-07-09T11:15:44.000','3496','59','2005-07-17T06:00:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5208','2005-07-09T11:16:56.000','1881','560','2005-07-10T07:21:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5209','2005-07-09T11:22:39.000','4441','222','2005-07-17T09:31:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5210','2005-07-09T11:24:19.000','4514','355','2005-07-11T06:27:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5211','2005-07-09T11:26:50.000','2216','241','2005-07-16T15:30:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5212','2005-07-09T11:37:47.000','3240','400','2005-07-15T14:42:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5213','2005-07-09T11:39:43.000','3708','552','2005-07-18T16:20:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5214','2005-07-09T11:43:08.000','1657','290','2005-07-17T08:58:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5215','2005-07-09T11:47:58.000','3888','528','2005-07-18T09:58:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5216','2005-07-09T11:54:58.000','1644','515','2005-07-12T09:46:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5217','2005-07-09T11:56:50.000','4150','430','2005-07-17T07:10:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5218','2005-07-09T11:57:12.000','1121','83','2005-07-13T06:34:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5219','2005-07-09T11:57:55.000','3933','209','2005-07-15T09:43:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5220','2005-07-09T11:59:04.000','2577','435','2005-07-15T06:20:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5221','2005-07-09T12:02:23.000','2339','84','2005-07-16T15:43:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5222','2005-07-09T12:05:45.000','2508','400','2005-07-13T12:11:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5223','2005-07-09T12:06:03.000','2335','72','2005-07-17T15:50:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5224','2005-07-09T12:07:27.000','279','311','2005-07-17T08:59:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5225','2005-07-09T12:10:16.000','703','445','2005-07-12T09:55:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5226','2005-07-09T12:10:44.000','3128','218','2005-07-11T17:32:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5227','2005-07-09T12:16:39.000','1862','362','2005-07-18T15:38:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5228','2005-07-09T12:26:01.000','622','195','2005-07-14T13:31:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5229','2005-07-09T12:30:18.000','4472','372','2005-07-14T15:31:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5230','2005-07-09T12:30:23.000','3707','51','2005-07-13T08:41:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5231','2005-07-09T12:35:02.000','1275','405','2005-07-10T09:22:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5232','2005-07-09T12:35:08.000','3353','175','2005-07-14T14:55:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5233','2005-07-09T12:44:26.000','1401','131','2005-07-15T12:31:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5234','2005-07-09T12:44:47.000','4182','398','2005-07-17T10:02:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5235','2005-07-09T12:54:25.000','1044','122','2005-07-18T16:28:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5236','2005-07-09T12:56:29.000','1215','519','2005-07-13T08:26:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5237','2005-07-09T12:56:58.000','2341','84','2005-07-11T15:41:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5238','2005-07-09T13:11:14.000','3297','100','2005-07-10T07:27:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5239','2005-07-09T13:12:35.000','380','497','2005-07-10T13:37:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5240','2005-07-09T13:14:48.000','1378','350','2005-07-10T18:47:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5241','2005-07-09T13:19:14.000','4079','314','2005-07-11T14:32:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5242','2005-07-09T13:20:25.000','848','12','2005-07-18T07:38:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5243','2005-07-09T13:22:08.000','122','587','2005-07-16T09:25:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5244','2005-07-09T13:24:07.000','3726','1','2005-07-14T14:01:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5245','2005-07-09T13:24:14.000','3547','115','2005-07-12T11:16:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5246','2005-07-09T13:25:18.000','3548','276','2005-07-13T18:38:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5247','2005-07-09T13:26:28.000','1186','298','2005-07-12T14:00:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5248','2005-07-09T13:29:44.000','246','279','2005-07-12T18:12:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5249','2005-07-09T13:33:53.000','1950','389','2005-07-11T12:55:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5250','2005-07-09T13:35:32.000','2162','384','2005-07-13T12:19:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5251','2005-07-09T13:36:10.000','478','474','2005-07-15T11:40:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5252','2005-07-09T13:40:44.000','2581','335','2005-07-14T09:41:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5253','2005-07-09T13:41:17.000','2241','532','2005-07-17T17:09:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5254','2005-07-09T13:50:11.000','654','263','2005-07-13T09:07:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5255','2005-07-09T13:51:08.000','4418','313','2005-07-17T13:58:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5256','2005-07-09T13:55:45.000','4226','273','2005-07-15T17:02:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5257','2005-07-09T13:56:43.000','286','292','2005-07-10T14:26:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5258','2005-07-09T13:56:56.000','3125','207','2005-07-11T16:01:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5259','2005-07-09T14:02:50.000','1310','207','2005-07-11T19:13:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5260','2005-07-09T14:05:45.000','3143','75','2005-07-14T08:41:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5261','2005-07-09T14:06:56.000','2899','105','2005-07-11T14:21:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5262','2005-07-09T14:08:01.000','1092','240','2005-07-12T16:48:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5263','2005-07-09T14:10:36.000','119','406','2005-07-12T15:07:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5264','2005-07-09T14:11:28.000','3307','545','2005-07-12T18:24:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5265','2005-07-09T14:15:01.000','4482','139','2005-07-18T14:43:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5266','2005-07-09T14:17:40.000','2409','222','2005-07-16T10:42:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5267','2005-07-09T14:21:10.000','2242','233','2005-07-15T12:02:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5268','2005-07-09T14:22:43.000','1083','119','2005-07-12T08:27:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5269','2005-07-09T14:23:05.000','3886','230','2005-07-17T14:03:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5270','2005-07-09T14:23:46.000','1523','128','2005-07-13T15:04:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5271','2005-07-09T14:25:01.000','2691','522','2005-07-16T17:28:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5272','2005-07-09T14:26:01.000','1547','90','2005-07-12T20:20:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5273','2005-07-09T14:31:24.000','4570','38','2005-07-14T13:27:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5274','2005-07-09T14:34:09.000','4579','108','2005-07-14T13:02:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5275','2005-07-09T14:34:18.000','729','249','2005-07-13T12:56:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5276','2005-07-09T14:35:13.000','2524','521','2005-07-12T14:24:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5277','2005-07-09T14:40:42.000','2026','332','2005-07-16T14:18:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5278','2005-07-09T14:44:23.000','2573','532','2005-07-15T10:48:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5279','2005-07-09T14:46:36.000','709','64','2005-07-17T10:04:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5280','2005-07-09T14:55:07.000','1177','351','2005-07-12T10:05:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5281','2005-07-09T14:55:07.000','1966','71','2005-07-13T15:24:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5282','2005-07-09T15:01:23.000','4386','226','2005-07-13T11:06:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5283','2005-07-09T15:07:17.000','644','295','2005-07-17T09:52:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5284','2005-07-09T15:08:21.000','1036','585','2005-07-16T09:53:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5285','2005-07-09T15:10:44.000','676','468','2005-07-16T13:02:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5286','2005-07-09T15:11:41.000','483','498','2005-07-10T19:19:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5287','2005-07-09T15:11:54.000','3110','523','2005-07-16T16:05:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5288','2005-07-09T15:13:07.000','850','120','2005-07-16T12:39:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5289','2005-07-09T15:14:08.000','4336','30','2005-07-12T12:51:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5290','2005-07-09T15:14:47.000','277','50','2005-07-11T20:30:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5291','2005-07-09T15:15:02.000','1367','194','2005-07-15T10:22:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5292','2005-07-09T15:16:54.000','3195','62','2005-07-11T15:21:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5293','2005-07-09T15:17:23.000','2880','542','2005-07-11T11:23:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5294','2005-07-09T15:23:42.000','3237','22','2005-07-15T15:28:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5295','2005-07-09T15:25:06.000','4460','86','2005-07-10T12:40:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5296','2005-07-09T15:26:27.000','495','109','2005-07-15T10:03:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5297','2005-07-09T15:32:29.000','3434','202','2005-07-14T14:58:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5298','2005-07-09T15:36:17.000','3491','149','2005-07-18T19:07:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5299','2005-07-09T15:38:09.000','4416','469','2005-07-15T16:39:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5300','2005-07-09T15:40:46.000','2520','8','2005-07-15T13:46:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5301','2005-07-09T15:42:10.000','245','459','2005-07-16T21:27:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5302','2005-07-09T15:42:36.000','4270','72','2005-07-10T21:04:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5303','2005-07-09T15:44:09.000','3572','350','2005-07-15T18:09:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5304','2005-07-09T15:48:06.000','4411','51','2005-07-14T19:29:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5305','2005-07-09T15:55:36.000','625','309','2005-07-18T15:59:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5306','2005-07-09T15:56:45.000','2221','409','2005-07-15T19:02:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5307','2005-07-09T15:57:15.000','2847','32','2005-07-17T13:42:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5308','2005-07-09T15:58:38.000','1684','52','2005-07-15T13:55:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5309','2005-07-09T16:00:16.000','4026','338','2005-07-17T17:56:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5310','2005-07-09T16:00:34.000','1565','24','2005-07-12T12:45:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5311','2005-07-09T16:02:54.000','986','107','2005-07-18T10:44:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5312','2005-07-09T16:03:09.000','2123','258','2005-07-13T16:41:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5313','2005-07-09T16:04:45.000','1885','52','2005-07-17T18:53:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5314','2005-07-09T16:05:28.000','3770','372','2005-07-10T18:18:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5315','2005-07-09T16:09:19.000','585','134','2005-07-14T21:10:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5316','2005-07-09T16:09:42.000','3856','438','2005-07-11T15:20:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5317','2005-07-09T16:10:25.000','2693','14','2005-07-18T17:10:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5318','2005-07-09T16:11:33.000','1738','472','2005-07-14T12:49:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5319','2005-07-09T16:17:44.000','1899','282','2005-07-18T16:35:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5320','2005-07-09T16:23:32.000','3140','228','2005-07-18T18:16:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5321','2005-07-09T16:26:33.000','3347','245','2005-07-15T15:05:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5322','2005-07-09T16:28:13.000','4420','432','2005-07-18T14:53:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5323','2005-07-09T16:34:07.000','1302','35','2005-07-13T21:37:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5324','2005-07-09T16:34:18.000','4024','113','2005-07-15T12:35:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5325','2005-07-09T16:35:47.000','2703','492','2005-07-10T11:52:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5326','2005-07-09T16:38:01.000','797','1','2005-07-13T18:02:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5327','2005-07-09T16:39:49.000','3657','547','2005-07-12T18:47:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5328','2005-07-09T16:48:29.000','2444','247','2005-07-17T20:20:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5329','2005-07-09T16:49:46.000','1628','402','2005-07-16T19:05:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5330','2005-07-09T16:53:57.000','3812','410','2005-07-18T19:54:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5331','2005-07-09T16:54:06.000','4181','447','2005-07-10T19:04:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5332','2005-07-09T16:59:23.000','3269','568','2005-07-10T16:01:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5333','2005-07-09T16:59:38.000','2142','419','2005-07-16T17:23:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5334','2005-07-09T17:00:13.000','3852','482','2005-07-11T15:50:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5335','2005-07-09T17:00:49.000','2353','588','2005-07-12T12:21:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5336','2005-07-09T17:01:08.000','4144','410','2005-07-11T19:22:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5337','2005-07-09T17:03:50.000','4168','343','2005-07-16T22:25:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5338','2005-07-09T17:07:07.000','3449','191','2005-07-14T11:15:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5339','2005-07-09T17:09:17.000','698','380','2005-07-10T21:07:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5340','2005-07-09T17:11:35.000','650','267','2005-07-17T17:59:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5341','2005-07-09T17:13:23.000','2522','8','2005-07-14T18:11:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5342','2005-07-09T17:20:03.000','3828','289','2005-07-18T12:44:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5343','2005-07-09T17:23:43.000','92','485','2005-07-18T22:14:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5344','2005-07-09T17:27:05.000','159','197','2005-07-10T15:51:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5345','2005-07-09T17:28:18.000','3055','348','2005-07-11T14:30:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5346','2005-07-09T17:29:01.000','2488','287','2005-07-14T12:47:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5347','2005-07-09T17:31:32.000','1293','246','2005-07-10T21:06:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5348','2005-07-09T17:34:11.000','3495','597','2005-07-15T18:32:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5349','2005-07-09T17:35:35.000','3139','161','2005-07-18T14:05:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5350','2005-07-09T17:39:30.000','724','129','2005-07-11T16:43:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5351','2005-07-09T17:40:52.000','3722','112','2005-07-14T16:55:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5352','2005-07-09T17:54:58.000','908','372','2005-07-15T16:20:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5353','2005-07-09T18:04:29.000','2994','196','2005-07-15T17:46:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5354','2005-07-09T18:04:33.000','951','354','2005-07-15T18:19:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5355','2005-07-09T18:07:17.000','2458','100','2005-07-16T20:33:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5356','2005-07-09T18:08:28.000','2905','188','2005-07-14T14:11:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5357','2005-07-09T18:08:59.000','1988','411','2005-07-16T17:28:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5358','2005-07-09T18:09:21.000','3764','71','2005-07-14T23:59:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5359','2005-07-09T18:10:52.000','4392','453','2005-07-18T13:34:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5360','2005-07-09T18:14:03.000','679','562','2005-07-10T15:17:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5361','2005-07-09T18:15:32.000','2045','279','2005-07-17T23:32:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5362','2005-07-09T18:16:08.000','24','266','2005-07-18T18:27:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5363','2005-07-09T18:18:49.000','2180','425','2005-07-14T22:16:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5364','2005-07-09T18:24:48.000','2746','366','2005-07-10T12:30:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5365','2005-07-09T18:27:00.000','4469','527','2005-07-11T14:18:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5366','2005-07-09T18:28:37.000','886','187','2005-07-13T20:45:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5367','2005-07-09T18:39:15.000','1446','485','2005-07-16T14:19:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5368','2005-07-09T18:41:59.000','4429','502','2005-07-16T00:32:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5369','2005-07-09T18:42:16.000','1550','538','2005-07-12T18:16:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5370','2005-07-09T18:43:19.000','2193','248','2005-07-15T19:59:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5371','2005-07-09T18:47:48.000','789','425','2005-07-14T14:39:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5372','2005-07-09T18:48:39.000','3551','148','2005-07-11T17:40:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5373','2005-07-09T18:48:57.000','950','428','2005-07-10T16:34:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5374','2005-07-09T18:52:08.000','946','144','2005-07-16T16:34:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5375','2005-07-09T18:52:55.000','1407','558','2005-07-16T15:32:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5376','2005-07-09T18:54:08.000','1730','104','2005-07-17T22:01:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5377','2005-07-09T19:04:30.000','3118','578','2005-07-11T14:42:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5378','2005-07-09T19:05:56.000','1570','138','2005-07-10T18:03:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5379','2005-07-09T19:08:03.000','2110','475','2005-07-10T17:58:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5380','2005-07-09T19:08:44.000','3047','166','2005-07-11T20:09:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5381','2005-07-09T19:11:11.000','3033','332','2005-07-13T17:10:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5382','2005-07-09T19:12:57.000','78','586','2005-07-14T15:44:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5383','2005-07-09T19:14:32.000','573','14','2005-07-11T19:57:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5384','2005-07-09T19:17:46.000','1729','180','2005-07-12T13:50:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5385','2005-07-09T19:18:11.000','4291','112','2005-07-16T18:50:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5386','2005-07-09T19:19:09.000','721','594','2005-07-13T00:13:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5387','2005-07-09T19:25:14.000','4452','244','2005-07-11T21:00:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5388','2005-07-09T19:25:25.000','1546','332','2005-07-14T19:51:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5389','2005-07-09T19:25:45.000','3882','484','2005-07-17T13:31:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5390','2005-07-09T19:26:22.000','715','139','2005-07-14T22:46:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5391','2005-07-09T19:28:34.000','402','132','2005-07-18T01:07:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5392','2005-07-09T19:32:30.000','2552','499','2005-07-16T15:01:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5393','2005-07-09T19:35:12.000','1417','446','2005-07-11T14:00:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5394','2005-07-09T19:36:15.000','1828','83','2005-07-18T18:10:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5395','2005-07-09T19:42:37.000','4428','131','2005-07-10T15:39:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5396','2005-07-09T19:42:52.000','3795','559','2005-07-15T21:45:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5397','2005-07-09T19:43:51.000','4376','191','2005-07-17T00:11:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5398','2005-07-09T19:44:58.000','4352','199','2005-07-17T00:56:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5399','2005-07-09T19:52:44.000','261','67','2005-07-10T18:31:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5400','2005-07-09T19:56:40.000','3435','192','2005-07-14T20:43:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5401','2005-07-09T19:59:10.000','431','43','2005-07-11T23:21:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5402','2005-07-09T20:01:58.000','4450','379','2005-07-10T14:07:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5403','2005-07-09T20:07:09.000','3991','36','2005-07-12T18:33:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5404','2005-07-09T20:10:43.000','3685','236','2005-07-13T15:16:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5405','2005-07-09T20:11:49.000','799','45','2005-07-18T18:37:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5406','2005-07-09T20:13:23.000','1322','563','2005-07-11T22:05:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5407','2005-07-09T20:16:07.000','3641','475','2005-07-14T21:41:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5408','2005-07-09T20:16:51.000','3162','144','2005-07-18T22:19:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5409','2005-07-09T20:17:19.000','3538','446','2005-07-13T23:30:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5410','2005-07-09T20:21:10.000','2261','281','2005-07-18T21:43:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5411','2005-07-09T20:23:38.000','4292','304','2005-07-16T01:17:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5412','2005-07-09T20:23:52.000','3174','458','2005-07-18T18:40:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5413','2005-07-09T20:28:42.000','2056','167','2005-07-10T19:23:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5414','2005-07-09T20:29:36.000','1201','174','2005-07-13T01:55:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5415','2005-07-09T20:30:03.000','4413','475','2005-07-18T00:20:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5416','2005-07-09T20:33:50.000','568','219','2005-07-14T01:50:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5417','2005-07-09T20:34:09.000','3569','265','2005-07-14T00:36:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5418','2005-07-09T20:41:35.000','55','114','2005-07-14T00:15:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5419','2005-07-09T20:47:36.000','1516','226','2005-07-12T01:36:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5420','2005-07-09T20:48:42.000','1739','80','2005-07-15T21:35:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5421','2005-07-09T20:49:12.000','2437','33','2005-07-10T16:30:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5422','2005-07-09T20:55:47.000','436','409','2005-07-15T15:15:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5423','2005-07-09T20:56:48.000','1952','440','2005-07-17T14:58:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5424','2005-07-09T20:59:09.000','3694','72','2005-07-12T00:05:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5425','2005-07-09T21:02:26.000','531','37','2005-07-16T23:38:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5426','2005-07-09T21:04:47.000','251','438','2005-07-17T00:55:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5427','2005-07-09T21:12:26.000','3197','499','2005-07-14T01:02:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5428','2005-07-09T21:12:50.000','3109','346','2005-07-14T16:25:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5429','2005-07-09T21:14:03.000','2467','105','2005-07-18T01:33:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5430','2005-07-09T21:19:54.000','1441','173','2005-07-15T22:53:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5431','2005-07-09T21:21:11.000','2780','213','2005-07-10T21:16:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5432','2005-07-09T21:21:25.000','1958','64','2005-07-14T21:34:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5433','2005-07-09T21:22:00.000','2679','349','2005-07-10T21:18:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5434','2005-07-09T21:25:20.000','3790','334','2005-07-15T03:12:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5435','2005-07-09T21:28:07.000','2884','273','2005-07-18T21:16:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5436','2005-07-09T21:31:11.000','2364','89','2005-07-13T16:59:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5437','2005-07-09T21:32:29.000','3532','26','2005-07-15T00:27:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5438','2005-07-09T21:34:32.000','487','241','2005-07-16T02:21:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5439','2005-07-09T21:39:35.000','1993','58','2005-07-13T17:45:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5440','2005-07-09T21:45:17.000','138','332','2005-07-11T22:43:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5441','2005-07-09T21:52:05.000','3913','7','2005-07-17T02:54:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5442','2005-07-09T21:55:19.000','3093','29','2005-07-19T01:18:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5443','2005-07-09T21:56:09.000','2951','137','2005-07-16T00:33:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5444','2005-07-09T21:58:57.000','2968','10','2005-07-11T03:09:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5445','2005-07-09T21:59:41.000','565','578','2005-07-15T00:40:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5446','2005-07-09T21:59:55.000','2769','454','2005-07-11T01:45:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5447','2005-07-09T22:09:28.000','2530','473','2005-07-18T20:03:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5448','2005-07-09T22:11:14.000','646','463','2005-07-15T21:08:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5449','2005-07-09T22:12:01.000','921','261','2005-07-18T01:18:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5450','2005-07-09T22:13:25.000','2356','328','2005-07-13T23:28:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5451','2005-07-09T22:22:10.000','3484','39','2005-07-11T02:43:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5452','2005-07-09T22:23:21.000','2036','80','2005-07-17T00:20:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5453','2005-07-09T22:24:11.000','1780','106','2005-07-19T04:08:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5454','2005-07-09T22:24:25.000','3049','97','2005-07-11T01:52:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5455','2005-07-09T22:28:45.000','1955','464','2005-07-18T02:50:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5456','2005-07-09T22:31:45.000','3003','360','2005-07-12T03:53:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5457','2005-07-09T22:33:14.000','4179','433','2005-07-12T02:30:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5458','2005-07-09T22:35:49.000','2203','521','2005-07-16T22:55:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5459','2005-07-09T22:43:56.000','1847','168','2005-07-12T18:05:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5460','2005-07-09T22:46:14.000','2410','38','2005-07-12T21:26:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5461','2005-07-09T22:48:04.000','53','244','2005-07-10T17:56:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5462','2005-07-09T22:56:53.000','871','583','2005-07-11T21:50:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5463','2005-07-09T22:57:02.000','601','374','2005-07-11T03:10:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5464','2005-07-09T22:58:14.000','3692','434','2005-07-15T02:48:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5465','2005-07-09T23:01:13.000','723','503','2005-07-13T01:03:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5466','2005-07-09T23:03:21.000','2302','482','2005-07-10T20:11:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5467','2005-07-09T23:05:47.000','374','543','2005-07-16T17:06:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5468','2005-07-09T23:06:09.000','2196','81','2005-07-13T00:48:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5469','2005-07-09T23:08:07.000','2201','475','2005-07-13T19:13:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5470','2005-07-09T23:10:49.000','3254','325','2005-07-18T04:30:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5471','2005-07-09T23:11:52.000','4086','347','2005-07-13T02:08:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5472','2005-07-09T23:16:40.000','865','165','2005-07-10T18:43:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5473','2005-07-09T23:19:11.000','4283','51','2005-07-19T02:30:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5474','2005-07-09T23:23:57.000','3608','375','2005-07-15T03:11:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5475','2005-07-09T23:31:38.000','726','219','2005-07-12T03:51:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5476','2005-07-09T23:37:09.000','1199','427','2005-07-15T23:57:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5477','2005-07-09T23:43:49.000','994','542','2005-07-15T05:03:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5478','2005-07-09T23:45:15.000','3213','583','2005-07-15T22:48:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5479','2005-07-09T23:47:33.000','216','250','2005-07-13T01:09:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5480','2005-07-09T23:49:07.000','847','452','2005-07-12T00:15:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5481','2005-07-09T23:51:57.000','562','479','2005-07-11T05:28:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5482','2005-07-09T23:53:04.000','2136','460','2005-07-15T04:59:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5483','2005-07-09T23:54:09.000','4362','89','2005-07-17T23:36:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5484','2005-07-09T23:54:37.000','3248','495','2005-07-15T02:05:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5485','2005-07-09T23:55:25.000','3930','173','2005-07-14T04:08:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5486','2005-07-09T23:57:44.000','2864','538','2005-07-14T00:23:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5487','2005-07-10T00:01:50.000','1144','341','2005-07-10T20:43:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5488','2005-07-10T00:02:06.000','4262','173','2005-07-15T01:45:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5489','2005-07-10T00:07:03.000','2319','490','2005-07-15T19:52:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5490','2005-07-10T00:09:11.000','3044','367','2005-07-14T21:23:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5491','2005-07-10T00:09:45.000','2007','49','2005-07-11T02:25:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5492','2005-07-10T00:11:09.000','4524','558','2005-07-14T01:27:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5493','2005-07-10T00:11:44.000','2037','539','2005-07-15T19:24:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5494','2005-07-10T00:15:00.000','3087','139','2005-07-17T01:12:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5495','2005-07-10T00:16:54.000','2199','257','2005-07-19T01:22:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5496','2005-07-10T00:20:23.000','3182','369','2005-07-18T21:10:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5497','2005-07-10T00:23:23.000','4473','92','2005-07-16T03:54:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5498','2005-07-10T00:27:21.000','63','302','2005-07-13T20:11:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5499','2005-07-10T00:27:45.000','1525','127','2005-07-17T06:11:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5500','2005-07-10T00:28:17.000','3380','457','2005-07-15T19:09:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5501','2005-07-10T00:33:48.000','3979','372','2005-07-17T02:58:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5502','2005-07-10T00:34:15.000','3712','243','2005-07-11T21:44:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5503','2005-07-10T00:35:37.000','3892','262','2005-07-12T20:29:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5504','2005-07-10T00:36:38.000','3053','455','2005-07-16T19:36:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5505','2005-07-10T00:38:48.000','896','253','2005-07-12T03:12:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5506','2005-07-10T00:45:48.000','2432','117','2005-07-18T20:35:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5507','2005-07-10T00:49:04.000','716','399','2005-07-15T22:06:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5508','2005-07-10T00:50:01.000','2977','345','2005-07-16T19:07:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5509','2005-07-10T00:54:46.000','1142','102','2005-07-16T05:10:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5510','2005-07-10T00:58:37.000','1298','67','2005-07-17T22:02:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5511','2005-07-10T01:00:00.000','3678','301','2005-07-12T20:44:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5512','2005-07-10T01:05:38.000','4470','405','2005-07-17T20:47:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5513','2005-07-10T01:05:41.000','2558','356','2005-07-11T02:05:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5514','2005-07-10T01:09:42.000','1824','522','2005-07-17T05:47:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5515','2005-07-10T01:12:44.000','3772','39','2005-07-13T00:39:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5516','2005-07-10T01:13:52.000','1902','581','2005-07-15T22:56:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5517','2005-07-10T01:15:00.000','3689','42','2005-07-19T01:59:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5518','2005-07-10T01:15:11.000','3340','451','2005-07-18T19:28:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5519','2005-07-10T01:18:32.000','1312','85','2005-07-11T20:39:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5520','2005-07-10T01:30:41.000','2527','501','2005-07-15T21:37:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5521','2005-07-10T01:31:22.000','1956','182','2005-07-17T05:42:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5522','2005-07-10T01:46:29.000','2622','573','2005-07-18T00:41:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5523','2005-07-10T01:47:55.000','2233','125','2005-07-18T22:25:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5524','2005-07-10T01:49:24.000','3596','386','2005-07-14T22:55:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5525','2005-07-10T02:03:08.000','3141','241','2005-07-18T07:32:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5526','2005-07-10T02:04:03.000','3909','144','2005-07-16T22:15:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5527','2005-07-10T02:06:01.000','4462','554','2005-07-15T00:55:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5528','2005-07-10T02:09:21.000','680','551','2005-07-17T06:22:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5529','2005-07-10T02:11:13.000','1652','590','2005-07-15T06:56:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5530','2005-07-10T02:13:49.000','2701','74','2005-07-18T08:01:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5531','2005-07-10T02:13:59.000','2992','173','2005-07-15T00:01:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5532','2005-07-10T02:17:31.000','983','522','2005-07-16T02:57:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5533','2005-07-10T02:19:28.000','2567','270','2005-07-11T01:37:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5534','2005-07-10T02:26:49.000','3251','156','2005-07-11T07:13:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5535','2005-07-10T02:27:42.000','1623','394','2005-07-12T21:13:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5536','2005-07-10T02:29:42.000','1919','195','2005-07-13T04:06:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5537','2005-07-10T02:35:41.000','1781','254','2005-07-13T07:11:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5538','2005-07-10T02:39:40.000','2119','367','2005-07-12T01:39:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5539','2005-07-10T02:42:58.000','3217','90','2005-07-16T02:27:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5540','2005-07-10T02:44:21.000','132','250','2005-07-11T07:13:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5541','2005-07-10T02:44:27.000','1211','135','2005-07-13T04:13:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5542','2005-07-10T02:45:53.000','1713','105','2005-07-15T23:23:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5543','2005-07-10T02:48:03.000','1496','71','2005-07-17T05:49:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5544','2005-07-10T02:48:07.000','1014','316','2005-07-17T01:08:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5545','2005-07-10T02:50:29.000','118','236','2005-07-16T02:11:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5546','2005-07-10T02:50:37.000','2918','515','2005-07-16T08:22:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5547','2005-07-10T02:52:47.000','1432','519','2005-07-16T02:10:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5548','2005-07-10T02:56:45.000','2973','317','2005-07-13T01:33:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5549','2005-07-10T02:58:29.000','2685','163','2005-07-17T05:24:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5550','2005-07-10T02:58:35.000','1905','254','2005-07-16T02:38:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5551','2005-07-10T03:01:09.000','4238','44','2005-07-18T02:04:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5552','2005-07-10T03:01:19.000','2879','27','2005-07-13T06:53:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5553','2005-07-10T03:03:35.000','1686','6','2005-07-14T07:49:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5554','2005-07-10T03:03:38.000','4084','252','2005-07-17T00:00:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5555','2005-07-10T03:08:55.000','2551','79','2005-07-11T01:36:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5556','2005-07-10T03:10:17.000','4483','354','2005-07-14T02:47:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5557','2005-07-10T03:10:21.000','1433','346','2005-07-11T21:34:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5558','2005-07-10T03:12:08.000','1123','96','2005-07-14T03:09:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5559','2005-07-10T03:13:07.000','4122','496','2005-07-18T08:33:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5560','2005-07-10T03:13:24.000','720','231','2005-07-19T06:03:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5561','2005-07-10T03:15:24.000','1048','369','2005-07-15T06:46:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5562','2005-07-10T03:17:42.000','3604','300','2005-07-12T03:26:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5563','2005-07-10T03:21:02.000','2258','362','2005-07-14T07:40:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5564','2005-07-10T03:23:05.000','196','355','2005-07-16T07:46:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5565','2005-07-10T03:29:48.000','3368','14','2005-07-17T04:43:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5566','2005-07-10T03:30:17.000','1343','124','2005-07-13T06:32:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5567','2005-07-10T03:36:46.000','1616','147','2005-07-15T23:22:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5568','2005-07-10T03:36:56.000','1130','424','2005-07-11T08:35:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5569','2005-07-10T03:38:32.000','2835','69','2005-07-16T00:02:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5570','2005-07-10T03:46:47.000','2013','374','2005-07-17T09:28:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5571','2005-07-10T03:48:20.000','1084','76','2005-07-11T02:09:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5572','2005-07-10T03:49:00.000','2709','458','2005-07-14T01:25:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5573','2005-07-10T03:50:47.000','2957','170','2005-07-17T06:40:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5574','2005-07-10T03:54:38.000','2307','163','2005-07-19T07:20:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5575','2005-07-10T03:55:50.000','2316','107','2005-07-12T08:40:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5576','2005-07-10T03:57:05.000','1453','217','2005-07-13T02:16:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5577','2005-07-10T03:58:40.000','3779','266','2005-07-14T03:36:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5578','2005-07-10T04:00:31.000','4543','378','2005-07-16T08:06:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5579','2005-07-10T04:04:29.000','945','203','2005-07-14T04:31:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5580','2005-07-10T04:05:49.000','2753','521','2005-07-18T22:36:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5581','2005-07-10T04:06:06.000','3450','306','2005-07-15T08:31:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5582','2005-07-10T04:08:25.000','3341','305','2005-07-13T06:04:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5583','2005-07-10T04:08:48.000','1242','391','2005-07-19T07:59:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5584','2005-07-10T04:15:25.000','2606','289','2005-07-16T22:54:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5585','2005-07-10T04:15:43.000','3524','63','2005-07-15T08:24:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5586','2005-07-10T04:17:06.000','2965','427','2005-07-18T07:11:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5587','2005-07-10T04:17:25.000','4485','531','2005-07-15T01:41:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5588','2005-07-10T04:21:10.000','1166','535','2005-07-16T02:58:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5589','2005-07-10T04:22:58.000','3673','296','2005-07-10T23:13:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5590','2005-07-10T04:23:11.000','4442','407','2005-07-19T09:03:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5591','2005-07-10T04:25:03.000','378','374','2005-07-16T04:21:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5592','2005-07-10T04:26:13.000','2471','222','2005-07-19T02:32:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5593','2005-07-10T04:33:13.000','702','287','2005-07-17T08:44:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5594','2005-07-10T04:33:36.000','61','440','2005-07-12T08:13:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5595','2005-07-10T04:33:45.000','264','572','2005-07-16T04:04:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5596','2005-07-10T04:43:14.000','1662','240','2005-07-11T22:58:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5597','2005-07-10T04:47:57.000','4264','576','2005-07-17T01:54:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5598','2005-07-10T04:48:29.000','3412','397','2005-07-18T10:33:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5599','2005-07-10T04:52:04.000','3054','391','2005-07-13T05:19:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5600','2005-07-10T04:55:45.000','3713','138','2005-07-18T03:10:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5601','2005-07-10T04:56:55.000','3062','511','2005-07-11T00:14:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5602','2005-07-10T05:02:22.000','3544','253','2005-07-14T23:40:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5603','2005-07-10T05:04:54.000','1308','74','2005-07-12T01:54:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5604','2005-07-10T05:05:00.000','3702','78','2005-07-12T08:04:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5605','2005-07-10T05:06:45.000','2964','273','2005-07-15T02:51:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5606','2005-07-10T05:07:55.000','2896','51','2005-07-15T00:14:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5607','2005-07-10T05:08:10.000','4257','52','2005-07-15T00:40:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5608','2005-07-10T05:08:26.000','3854','384','2005-07-10T23:24:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5609','2005-07-10T05:09:46.000','1553','492','2005-07-12T10:38:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5610','2005-07-10T05:09:52.000','481','131','2005-07-13T07:08:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5611','2005-07-10T05:13:43.000','2832','424','2005-07-16T05:56:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5612','2005-07-10T05:15:12.000','2363','472','2005-07-17T09:50:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5613','2005-07-10T05:15:43.000','4517','220','2005-07-13T05:17:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5614','2005-07-10T05:16:56.000','133','371','2005-07-13T02:03:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5615','2005-07-10T05:18:51.000','1521','173','2005-07-17T11:05:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5616','2005-07-10T05:21:11.000','4014','238','2005-07-18T08:42:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5617','2005-07-10T05:28:50.000','2324','342','2005-07-12T00:02:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5618','2005-07-10T05:28:58.000','757','316','2005-07-18T01:38:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5619','2005-07-10T05:29:33.000','113','204','2005-07-15T00:40:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5620','2005-07-10T05:30:52.000','2980','92','2005-07-16T04:13:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5621','2005-07-10T05:34:10.000','552','310','2005-07-14T02:49:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5622','2005-07-10T05:39:37.000','1783','568','2005-07-15T00:48:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5623','2005-07-10T05:41:38.000','4464','229','2005-07-14T01:01:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5624','2005-07-10T05:43:16.000','1015','114','2005-07-12T05:33:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5625','2005-07-10T05:44:02.000','1751','114','2005-07-12T00:03:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5626','2005-07-10T05:49:35.000','3029','389','2005-07-15T08:05:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5627','2005-07-10T05:51:12.000','244','136','2005-07-17T09:56:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5628','2005-07-10T05:56:40.000','4040','87','2005-07-17T11:13:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5629','2005-07-10T06:02:25.000','400','546','2005-07-16T07:33:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5630','2005-07-10T06:08:14.000','1151','537','2005-07-14T03:37:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5631','2005-07-10T06:15:45.000','2095','595','2005-07-17T09:53:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5632','2005-07-10T06:17:06.000','2632','404','2005-07-17T02:32:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5633','2005-07-10T06:22:24.000','1056','480','2005-07-11T05:59:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5634','2005-07-10T06:25:48.000','323','487','2005-07-17T09:07:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5635','2005-07-10T06:28:39.000','1457','222','2005-07-17T08:35:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5636','2005-07-10T06:31:24.000','4116','2','2005-07-13T02:36:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5637','2005-07-10T06:31:37.000','4436','45','2005-07-17T01:16:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5638','2005-07-10T06:32:49.000','1528','570','2005-07-13T04:32:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5639','2005-07-10T06:33:39.000','2452','249','2005-07-19T07:47:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5640','2005-07-10T06:38:00.000','2706','574','2005-07-18T08:56:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5641','2005-07-10T06:43:43.000','3568','50','2005-07-15T06:33:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5642','2005-07-10T06:46:08.000','3630','299','2005-07-13T10:03:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5643','2005-07-10T06:49:00.000','796','34','2005-07-14T01:53:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5644','2005-07-10T06:57:44.000','4069','476','2005-07-15T03:52:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5645','2005-07-10T06:58:21.000','1586','333','2005-07-18T04:19:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5646','2005-07-10T07:08:09.000','1471','166','2005-07-14T03:48:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5647','2005-07-10T07:08:40.000','1466','128','2005-07-13T05:19:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5648','2005-07-10T07:09:21.000','4359','24','2005-07-16T07:23:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5649','2005-07-10T07:15:07.000','1349','336','2005-07-12T11:57:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5650','2005-07-10T07:17:01.000','2793','461','2005-07-15T11:59:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5651','2005-07-10T07:17:13.000','301','239','2005-07-15T12:13:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5652','2005-07-10T07:18:58.000','927','42','2005-07-19T07:52:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5653','2005-07-10T07:21:27.000','919','28','2005-07-16T01:58:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5654','2005-07-10T07:24:46.000','3419','490','2005-07-14T07:39:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5655','2005-07-10T07:31:06.000','3470','113','2005-07-17T08:22:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5656','2005-07-10T07:31:07.000','4138','159','2005-07-15T04:44:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5657','2005-07-10T07:33:43.000','4342','508','2005-07-18T01:55:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5658','2005-07-10T07:34:08.000','4402','165','2005-07-19T04:21:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5659','2005-07-10T07:45:40.000','4265','9','2005-07-15T05:20:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5660','2005-07-10T07:46:12.000','1404','171','2005-07-17T07:48:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5661','2005-07-10T07:53:51.000','1878','108','2005-07-14T12:57:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5662','2005-07-10T07:59:24.000','219','502','2005-07-14T13:06:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5663','2005-07-10T08:01:33.000','3078','530','2005-07-15T03:36:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5664','2005-07-10T08:04:41.000','2375','469','2005-07-17T10:29:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5665','2005-07-10T08:10:08.000','1175','415','2005-07-11T05:22:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5666','2005-07-10T08:10:29.000','2225','242','2005-07-17T04:54:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5667','2005-07-10T08:11:03.000','683','336','2005-07-15T08:23:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5668','2005-07-10T08:11:05.000','309','211','2005-07-16T13:15:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5669','2005-07-10T08:12:53.000','1173','323','2005-07-11T05:48:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5670','2005-07-10T08:14:52.000','610','121','2005-07-14T04:13:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5671','2005-07-10T08:18:22.000','1304','268','2005-07-11T07:03:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5672','2005-07-10T08:19:38.000','2326','158','2005-07-16T06:28:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5673','2005-07-10T08:21:54.000','4018','117','2005-07-11T05:54:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5674','2005-07-10T08:26:26.000','548','258','2005-07-16T02:43:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5675','2005-07-10T08:31:06.000','2134','376','2005-07-17T11:48:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5676','2005-07-10T08:38:32.000','3595','153','2005-07-13T10:11:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5677','2005-07-10T08:41:28.000','2647','105','2005-07-12T09:05:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5678','2005-07-10T08:42:42.000','4366','96','2005-07-19T03:48:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5679','2005-07-10T08:44:02.000','389','138','2005-07-14T05:30:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5680','2005-07-10T08:47:36.000','3503','199','2005-07-17T06:10:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5681','2005-07-10T08:48:39.000','4176','50','2005-07-18T07:17:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5682','2005-07-10T08:51:39.000','17','302','2005-07-12T14:44:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5683','2005-07-10T08:52:13.000','4433','285','2005-07-19T10:25:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5684','2005-07-10T08:59:03.000','99','132','2005-07-15T07:21:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5685','2005-07-10T09:01:38.000','1462','170','2005-07-17T10:58:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5686','2005-07-10T09:06:03.000','717','521','2005-07-11T10:59:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5687','2005-07-10T09:07:19.000','2170','363','2005-07-16T11:17:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5688','2005-07-10T09:16:08.000','3036','598','2005-07-15T09:44:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5689','2005-07-10T09:24:17.000','1731','381','2005-07-15T05:36:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5690','2005-07-10T09:26:49.000','1326','362','2005-07-19T07:17:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5691','2005-07-10T09:29:49.000','3526','466','2005-07-16T13:37:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5692','2005-07-10T09:32:22.000','59','244','2005-07-15T15:20:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5693','2005-07-10T09:35:43.000','2167','208','2005-07-12T08:05:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5694','2005-07-10T09:40:38.000','3476','57','2005-07-14T09:16:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5695','2005-07-10T09:43:40.000','440','459','2005-07-13T15:04:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5696','2005-07-10T09:44:32.000','128','96','2005-07-12T13:38:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5697','2005-07-10T09:44:44.000','934','515','2005-07-12T12:13:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5698','2005-07-10T09:47:00.000','639','46','2005-07-16T06:26:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5699','2005-07-10T09:48:04.000','958','211','2005-07-17T09:07:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5700','2005-07-10T09:49:42.000','3961','87','2005-07-19T04:20:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5701','2005-07-10T09:56:24.000','2395','91','2005-07-16T15:11:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5702','2005-07-10T10:00:01.000','3349','324','2005-07-11T15:29:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5703','2005-07-10T10:04:15.000','1585','132','2005-07-16T07:43:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5704','2005-07-10T10:06:29.000','2104','591','2005-07-17T10:48:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5705','2005-07-10T10:09:17.000','4030','300','2005-07-19T07:24:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5706','2005-07-10T10:21:46.000','3701','255','2005-07-16T04:37:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5707','2005-07-10T10:26:14.000','708','581','2005-07-18T06:19:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5708','2005-07-10T10:29:19.000','571','484','2005-07-18T06:50:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5709','2005-07-10T10:31:52.000','732','302','2005-07-12T10:47:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5710','2005-07-10T10:32:52.000','2843','265','2005-07-18T06:28:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5711','2005-07-10T10:37:20.000','3988','481','2005-07-13T11:20:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5712','2005-07-10T10:40:32.000','3480','304','2005-07-12T11:45:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5713','2005-07-10T10:46:15.000','1213','572','2005-07-19T14:34:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5714','2005-07-10T10:46:57.000','3706','17','2005-07-18T14:07:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5715','2005-07-10T10:48:03.000','1638','132','2005-07-18T11:27:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5716','2005-07-10T10:59:23.000','3416','102','2005-07-16T12:25:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5717','2005-07-10T11:02:03.000','529','15','2005-07-13T13:00:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5718','2005-07-10T11:03:20.000','3719','20','2005-07-19T15:38:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5719','2005-07-10T11:07:40.000','2100','94','2005-07-15T14:14:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5720','2005-07-10T11:09:12.000','576','339','2005-07-16T07:31:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5721','2005-07-10T11:09:35.000','2348','5','2005-07-17T16:41:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5722','2005-07-10T11:10:04.000','2890','556','2005-07-12T16:31:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5723','2005-07-10T11:14:48.000','605','33','2005-07-11T15:46:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5724','2005-07-10T11:18:12.000','3597','289','2005-07-16T14:53:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5725','2005-07-10T11:21:21.000','4293','426','2005-07-14T05:34:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5726','2005-07-10T11:22:08.000','3582','131','2005-07-13T05:55:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5727','2005-07-10T11:25:28.000','3338','550','2005-07-11T11:03:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5728','2005-07-10T11:26:14.000','636','335','2005-07-15T12:55:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5729','2005-07-10T11:27:25.000','4137','188','2005-07-15T06:13:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5730','2005-07-10T11:28:32.000','1903','301','2005-07-11T11:45:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5731','2005-07-10T11:31:52.000','2960','440','2005-07-14T11:44:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5732','2005-07-10T11:36:32.000','2833','597','2005-07-12T13:09:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5733','2005-07-10T11:37:24.000','3806','415','2005-07-11T12:34:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5734','2005-07-10T11:37:28.000','399','447','2005-07-16T11:10:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5735','2005-07-10T11:39:15.000','3259','65','2005-07-19T09:52:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5736','2005-07-10T11:45:48.000','1172','27','2005-07-13T16:40:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5737','2005-07-10T11:50:04.000','1118','218','2005-07-13T10:37:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5738','2005-07-10T11:50:51.000','200','187','2005-07-19T17:46:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5739','2005-07-10T11:51:50.000','163','219','2005-07-19T17:40:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5740','2005-07-10T11:51:58.000','2147','325','2005-07-12T07:53:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5741','2005-07-10T11:55:40.000','2041','513','2005-07-16T15:02:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5742','2005-07-10T11:56:18.000','3975','596','2005-07-19T06:59:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5743','2005-07-10T11:57:38.000','593','297','2005-07-19T15:38:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5744','2005-07-10T12:08:33.000','1372','437','2005-07-14T12:34:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5745','2005-07-10T12:10:11.000','41','305','2005-07-19T06:56:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5746','2005-07-10T12:15:12.000','3071','82','2005-07-16T07:02:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5747','2005-07-10T12:15:33.000','4562','583','2005-07-18T10:11:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5748','2005-07-10T12:19:59.000','1618','99','2005-07-12T12:59:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5749','2005-07-10T12:20:36.000','1768','304','2005-07-19T10:39:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5750','2005-07-10T12:20:41.000','3855','330','2005-07-17T08:25:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5751','2005-07-10T12:25:11.000','387','479','2005-07-11T15:23:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5752','2005-07-10T12:27:38.000','4444','86','2005-07-18T09:22:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5753','2005-07-10T12:29:43.000','3639','444','2005-07-17T12:50:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5754','2005-07-10T12:32:43.000','162','291','2005-07-12T13:11:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5755','2005-07-10T12:38:56.000','2760','2','2005-07-19T17:02:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5756','2005-07-10T12:39:28.000','130','183','2005-07-11T14:08:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5757','2005-07-10T12:40:17.000','1827','101','2005-07-12T14:02:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5758','2005-07-10T12:42:43.000','502','363','2005-07-16T10:18:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5759','2005-07-10T12:43:22.000','816','591','2005-07-16T16:42:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5760','2005-07-10T12:44:48.000','1050','154','2005-07-14T12:25:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5761','2005-07-10T12:45:36.000','1763','287','2005-07-13T10:05:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5762','2005-07-10T12:48:01.000','1815','217','2005-07-18T16:43:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5763','2005-07-10T12:58:12.000','753','397','2005-07-14T08:52:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5764','2005-07-10T12:58:16.000','1556','245','2005-07-19T07:28:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5765','2005-07-10T13:03:02.000','2619','293','2005-07-16T09:31:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5766','2005-07-10T13:07:31.000','7','406','2005-07-16T13:03:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5767','2005-07-10T13:13:18.000','2871','32','2005-07-17T14:41:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5768','2005-07-10T13:15:26.000','345','196','2005-07-15T09:42:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5769','2005-07-10T13:17:58.000','4052','141','2005-07-11T11:32:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5770','2005-07-10T13:21:28.000','914','71','2005-07-11T08:59:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5771','2005-07-10T13:26:45.000','3275','153','2005-07-14T15:43:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5772','2005-07-10T13:27:40.000','3635','21','2005-07-17T08:24:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5773','2005-07-10T13:31:09.000','3277','180','2005-07-15T08:21:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5774','2005-07-10T13:31:56.000','326','113','2005-07-18T07:32:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5775','2005-07-10T13:34:26.000','2175','325','2005-07-15T10:01:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5776','2005-07-10T13:35:22.000','3592','568','2005-07-12T17:58:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5777','2005-07-10T13:38:41.000','3959','40','2005-07-17T15:48:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5778','2005-07-10T13:41:37.000','4435','324','2005-07-14T16:26:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5779','2005-07-10T13:45:54.000','3266','244','2005-07-15T18:13:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5780','2005-07-10T13:46:23.000','168','516','2005-07-14T17:19:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5781','2005-07-10T13:49:30.000','3191','167','2005-07-11T12:11:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5782','2005-07-10T13:52:56.000','2514','440','2005-07-15T09:32:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5783','2005-07-10T13:55:33.000','3331','385','2005-07-16T12:13:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5784','2005-07-10T14:03:28.000','2323','422','2005-07-16T16:22:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5785','2005-07-10T14:06:03.000','142','211','2005-07-17T17:59:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5786','2005-07-10T14:06:44.000','2290','350','2005-07-14T19:55:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5787','2005-07-10T14:08:49.000','1075','44','2005-07-19T18:29:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5788','2005-07-10T14:10:22.000','1707','63','2005-07-14T19:46:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5789','2005-07-10T14:11:26.000','2601','571','2005-07-18T16:19:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5790','2005-07-10T14:15:21.000','1696','235','2005-07-14T08:53:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5791','2005-07-10T14:16:22.000','2795','319','2005-07-19T13:38:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5792','2005-07-10T14:22:19.000','4234','92','2005-07-19T09:08:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5793','2005-07-10T14:33:00.000','2927','268','2005-07-13T19:27:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5794','2005-07-10T14:34:53.000','1164','198','2005-07-17T11:50:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5795','2005-07-10T14:36:29.000','3958','304','2005-07-14T13:26:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5796','2005-07-10T14:42:54.000','1631','286','2005-07-17T08:47:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5797','2005-07-10T14:43:52.000','1880','384','2005-07-13T16:12:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5798','2005-07-10T14:45:09.000','331','107','2005-07-16T13:43:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5799','2005-07-10T14:53:35.000','3045','520','2005-07-14T16:18:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5800','2005-07-10T14:58:36.000','2466','411','2005-07-11T19:50:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5801','2005-07-10T14:59:05.000','3511','439','2005-07-14T17:55:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5802','2005-07-10T15:02:17.000','2295','520','2005-07-19T15:43:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5803','2005-07-10T15:05:42.000','1982','244','2005-07-15T10:19:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5804','2005-07-10T15:06:31.000','2168','137','2005-07-14T11:00:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5805','2005-07-10T15:08:41.000','3553','532','2005-07-19T16:35:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5806','2005-07-10T15:11:54.000','29','108','2005-07-15T11:51:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5807','2005-07-10T15:16:30.000','2092','301','2005-07-11T14:02:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5808','2005-07-10T15:17:33.000','2310','170','2005-07-14T12:14:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5809','2005-07-10T15:19:30.000','1748','461','2005-07-13T12:31:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5810','2005-07-10T15:22:04.000','1426','482','2005-07-18T21:05:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5811','2005-07-10T15:27:04.000','4007','441','2005-07-12T17:20:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5812','2005-07-10T15:27:56.000','1681','581','2005-07-18T15:37:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5813','2005-07-10T15:34:37.000','942','512','2005-07-17T16:14:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5814','2005-07-10T15:46:50.000','2537','71','2005-07-13T15:28:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5815','2005-07-10T15:48:19.000','2934','22','2005-07-13T12:09:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5816','2005-07-10T15:48:47.000','1746','382','2005-07-13T11:51:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5817','2005-07-10T15:49:12.000','2993','28','2005-07-18T19:30:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5818','2005-07-10T15:51:12.000','3940','334','2005-07-14T14:10:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5819','2005-07-10T15:56:20.000','3439','347','2005-07-12T19:59:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5820','2005-07-10T16:04:59.000','1511','485','2005-07-16T12:10:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5821','2005-07-10T16:07:16.000','147','302','2005-07-14T19:48:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5822','2005-07-10T16:10:39.000','1385','38','2005-07-13T19:05:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5823','2005-07-10T16:19:52.000','1879','483','2005-07-11T12:33:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5824','2005-07-10T16:19:53.000','1980','449','2005-07-12T11:17:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5825','2005-07-10T16:20:30.000','3843','444','2005-07-11T18:58:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5826','2005-07-10T16:21:02.000','4104','254','2005-07-17T21:08:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5827','2005-07-10T16:22:20.000','1296','290','2005-07-15T21:13:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5828','2005-07-10T16:27:25.000','2999','156','2005-07-11T18:42:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5829','2005-07-10T16:29:41.000','3405','118','2005-07-14T22:03:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5830','2005-07-10T16:34:00.000','2358','59','2005-07-18T16:42:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5831','2005-07-10T16:34:02.000','830','43','2005-07-11T14:27:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5832','2005-07-10T16:34:48.000','2387','63','2005-07-17T17:25:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5833','2005-07-10T16:39:24.000','3829','187','2005-07-17T12:52:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5834','2005-07-10T16:44:12.000','85','360','2005-07-14T11:34:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5835','2005-07-10T16:44:58.000','800','11','2005-07-17T16:03:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5836','2005-07-10T16:49:02.000','1842','310','2005-07-11T22:35:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5837','2005-07-10T16:57:50.000','1648','478','2005-07-18T14:07:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5838','2005-07-10T17:04:56.000','1627','202','2005-07-11T15:15:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5839','2005-07-10T17:08:30.000','252','367','2005-07-13T21:21:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5840','2005-07-10T17:09:09.000','1073','72','2005-07-15T22:52:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5841','2005-07-10T17:11:31.000','1230','525','2005-07-18T15:50:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5842','2005-07-10T17:11:37.000','139','247','2005-07-14T21:43:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5843','2005-07-10T17:14:27.000','1615','599','2005-07-15T21:18:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5844','2005-07-10T17:14:43.000','609','147','2005-07-12T19:27:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5845','2005-07-10T17:23:14.000','2882','334','2005-07-12T16:29:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5846','2005-07-10T17:25:24.000','938','233','2005-07-12T13:41:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5847','2005-07-10T17:27:42.000','4403','220','2005-07-12T14:51:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5848','2005-07-10T17:28:14.000','4549','409','2005-07-14T11:54:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5849','2005-07-10T17:32:33.000','1632','44','2005-07-19T22:39:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5850','2005-07-10T17:36:27.000','4015','531','2005-07-15T16:44:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5851','2005-07-10T17:40:47.000','3944','510','2005-07-11T19:24:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5852','2005-07-10T17:43:30.000','3890','484','2005-07-15T15:05:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5853','2005-07-10T17:45:13.000','3026','520','2005-07-17T21:37:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5854','2005-07-10T17:47:34.000','997','547','2005-07-13T20:14:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5855','2005-07-10T17:54:06.000','2457','166','2005-07-18T15:41:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5856','2005-07-10T17:57:32.000','497','314','2005-07-11T13:57:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5857','2005-07-10T17:59:29.000','1265','29','2005-07-18T18:13:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5858','2005-07-10T18:00:07.000','2913','257','2005-07-11T20:01:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5859','2005-07-10T18:02:02.000','131','220','2005-07-11T23:24:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5860','2005-07-10T18:08:49.000','3897','180','2005-07-16T16:43:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5861','2005-07-10T18:14:22.000','3881','277','2005-07-14T15:32:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5862','2005-07-10T18:20:48.000','2075','157','2005-07-17T00:09:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5863','2005-07-10T18:25:23.000','2557','419','2005-07-15T23:49:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5864','2005-07-10T18:29:57.000','4380','437','2005-07-19T14:27:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5865','2005-07-10T18:31:05.000','1382','126','2005-07-12T18:29:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5866','2005-07-10T18:35:14.000','457','484','2005-07-19T19:41:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5867','2005-07-10T18:39:01.000','730','321','2005-07-19T21:56:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5868','2005-07-10T18:39:16.000','452','429','2005-07-15T21:19:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5869','2005-07-10T18:40:09.000','2157','40','2005-07-17T18:42:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5870','2005-07-10T18:40:25.000','1524','438','2005-07-12T15:39:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5871','2005-07-10T18:46:08.000','3288','307','2005-07-16T17:32:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5872','2005-07-10T18:54:05.000','270','364','2005-07-19T15:41:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5873','2005-07-10T19:02:10.000','3151','354','2005-07-14T19:13:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5874','2005-07-10T19:02:51.000','2255','131','2005-07-16T13:14:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5875','2005-07-10T19:06:47.000','964','575','2005-07-18T17:33:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5876','2005-07-10T19:07:15.000','4445','578','2005-07-14T17:29:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5877','2005-07-10T19:08:51.000','1520','537','2005-07-19T19:48:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5878','2005-07-10T19:09:57.000','3805','271','2005-07-16T17:22:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5879','2005-07-10T19:12:47.000','3851','430','2005-07-16T16:32:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5880','2005-07-10T19:14:58.000','359','482','2005-07-17T01:13:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5881','2005-07-10T19:19:43.000','236','25','2005-07-12T20:11:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5882','2005-07-10T19:20:34.000','2830','319','2005-07-11T18:39:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5883','2005-07-10T19:25:21.000','2820','17','2005-07-16T20:50:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5884','2005-07-10T19:31:38.000','916','498','2005-07-11T20:30:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5885','2005-07-10T19:33:50.000','3129','331','2005-07-17T00:26:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5886','2005-07-10T19:36:25.000','907','215','2005-07-11T22:24:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5887','2005-07-10T19:45:47.000','2602','532','2005-07-15T22:15:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5888','2005-07-10T19:52:17.000','1620','268','2005-07-18T20:32:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5889','2005-07-10T19:54:41.000','1706','491','2005-07-12T20:08:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5890','2005-07-10T20:00:25.000','1463','535','2005-07-18T17:57:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5891','2005-07-10T20:01:17.000','4355','184','2005-07-12T00:15:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5892','2005-07-10T20:02:42.000','4322','333','2005-07-11T20:02:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5893','2005-07-10T20:05:30.000','1689','439','2005-07-14T23:05:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5894','2005-07-10T20:09:34.000','2264','194','2005-07-17T15:39:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5895','2005-07-10T20:13:19.000','2272','164','2005-07-17T17:51:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5896','2005-07-10T20:15:56.000','731','357','2005-07-12T00:39:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5897','2005-07-10T20:16:14.000','740','413','2005-07-19T15:49:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5898','2005-07-10T20:18:09.000','3257','538','2005-07-16T14:44:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5899','2005-07-10T20:21:52.000','1391','388','2005-07-13T00:46:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5900','2005-07-10T20:21:54.000','1081','419','2005-07-17T00:26:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5901','2005-07-10T20:22:12.000','86','165','2005-07-19T16:43:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5902','2005-07-10T20:31:24.000','2727','228','2005-07-11T20:50:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5903','2005-07-10T20:39:04.000','1388','573','2005-07-11T17:41:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5904','2005-07-10T20:39:44.000','350','531','2005-07-13T17:57:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5905','2005-07-10T20:41:09.000','3891','10','2005-07-19T14:49:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5906','2005-07-10T20:41:41.000','514','323','2005-07-14T00:12:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5907','2005-07-10T20:41:41.000','4432','168','2005-07-15T21:18:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5908','2005-07-10T20:44:14.000','810','156','2005-07-13T15:05:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5909','2005-07-10T20:46:13.000','2333','44','2005-07-14T18:01:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5910','2005-07-10T20:51:34.000','1039','464','2005-07-19T14:54:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5911','2005-07-10T20:51:42.000','4140','420','2005-07-14T21:58:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5912','2005-07-10T20:58:22.000','1187','351','2005-07-17T01:15:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5913','2005-07-10T20:58:55.000','2767','277','2005-07-13T15:18:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5914','2005-07-10T21:01:12.000','2639','372','2005-07-16T18:27:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5915','2005-07-10T21:12:16.000','2464','66','2005-07-15T16:59:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5916','2005-07-10T21:26:31.000','2267','35','2005-07-19T20:23:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5917','2005-07-10T21:30:22.000','2910','74','2005-07-12T18:54:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5918','2005-07-10T21:32:06.000','120','34','2005-07-19T21:35:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5919','2005-07-10T21:32:14.000','164','92','2005-07-12T16:47:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5920','2005-07-10T21:33:58.000','1893','221','2005-07-17T19:41:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5921','2005-07-10T21:35:12.000','3920','7','2005-07-18T19:59:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5922','2005-07-10T21:36:53.000','1392','271','2005-07-16T02:51:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5923','2005-07-10T21:40:06.000','1817','401','2005-07-13T00:01:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5924','2005-07-10T21:41:23.000','629','191','2005-07-16T21:33:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5925','2005-07-10T21:41:27.000','3724','503','2005-07-18T18:35:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5926','2005-07-10T21:53:42.000','2840','282','2005-07-20T01:04:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5927','2005-07-10T21:57:14.000','807','70','2005-07-16T19:32:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5928','2005-07-10T21:58:30.000','4132','50','2005-07-15T19:41:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5929','2005-07-10T21:59:29.000','4303','54','2005-07-14T20:20:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5930','2005-07-10T21:59:32.000','2338','254','2005-07-11T18:40:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5931','2005-07-10T22:04:19.000','2259','341','2005-07-13T00:45:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5932','2005-07-10T22:05:15.000','2269','523','2005-07-12T17:04:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5933','2005-07-10T22:06:48.000','4372','419','2005-07-12T23:58:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5934','2005-07-10T22:07:59.000','3825','576','2005-07-15T21:07:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5935','2005-07-10T22:11:04.000','3371','258','2005-07-19T18:12:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5936','2005-07-10T22:14:30.000','1951','522','2005-07-15T01:32:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5937','2005-07-10T22:16:08.000','1579','580','2005-07-16T03:08:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5938','2005-07-10T22:17:42.000','2834','236','2005-07-16T22:38:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5939','2005-07-10T22:30:05.000','4491','207','2005-07-14T00:02:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5940','2005-07-10T22:31:01.000','3295','292','2005-07-14T00:52:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5941','2005-07-10T22:40:47.000','492','43','2005-07-17T00:19:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5942','2005-07-10T22:47:17.000','2861','317','2005-07-17T01:54:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5943','2005-07-10T22:48:13.000','3019','255','2005-07-16T01:33:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5944','2005-07-10T22:51:44.000','3904','432','2005-07-18T17:54:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5945','2005-07-10T22:52:42.000','427','374','2005-07-11T21:52:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5946','2005-07-10T22:57:29.000','1629','308','2005-07-12T00:08:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5947','2005-07-10T23:07:42.000','327','331','2005-07-18T23:13:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5948','2005-07-10T23:12:08.000','3260','57','2005-07-18T19:06:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5949','2005-07-10T23:13:00.000','4397','496','2005-07-14T01:10:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5950','2005-07-10T23:13:45.000','4319','585','2005-07-13T02:35:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5951','2005-07-10T23:14:29.000','2501','589','2005-07-13T01:01:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5952','2005-07-10T23:18:20.000','3406','595','2005-07-16T17:42:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5953','2005-07-10T23:21:35.000','992','386','2005-07-14T20:48:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5954','2005-07-10T23:22:01.000','2627','32','2005-07-14T04:42:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5955','2005-07-10T23:22:10.000','834','409','2005-07-17T17:55:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5956','2005-07-10T23:23:08.000','2536','499','2005-07-13T17:36:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5957','2005-07-10T23:24:02.000','2517','210','2005-07-12T20:28:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5958','2005-07-10T23:31:51.000','3468','430','2005-07-19T00:36:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5959','2005-07-10T23:35:36.000','3169','436','2005-07-13T02:19:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5960','2005-07-10T23:38:34.000','3884','239','2005-07-11T19:21:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5961','2005-07-10T23:43:23.000','3537','21','2005-07-15T05:21:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5962','2005-07-10T23:45:22.000','1292','507','2005-07-13T03:49:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5963','2005-07-10T23:47:08.000','4434','35','2005-07-12T04:27:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5964','2005-07-10T23:47:18.000','3981','456','2005-07-12T03:55:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5965','2005-07-10T23:51:52.000','4476','348','2005-07-11T23:29:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5966','2005-07-10T23:59:27.000','2076','384','2005-07-14T23:38:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5967','2005-07-11T00:02:19.000','2125','215','2005-07-18T23:08:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5968','2005-07-11T00:03:11.000','3273','554','2005-07-19T18:46:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5969','2005-07-11T00:03:22.000','4177','433','2005-07-18T01:28:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5970','2005-07-11T00:04:50.000','1514','94','2005-07-19T03:36:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5971','2005-07-11T00:05:58.000','2191','84','2005-07-19T04:50:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5972','2005-07-11T00:08:54.000','4577','30','2005-07-17T21:01:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5973','2005-07-11T00:09:17.000','1194','165','2005-07-14T19:18:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5974','2005-07-11T00:10:37.000','3984','517','2005-07-18T18:48:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5975','2005-07-11T00:14:19.000','2997','15','2005-07-16T04:21:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5976','2005-07-11T00:16:35.000','1693','505','2005-07-20T01:30:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5977','2005-07-11T00:16:38.000','4011','484','2005-07-19T21:00:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5978','2005-07-11T00:16:54.000','1720','508','2005-07-19T18:55:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5979','2005-07-11T00:17:09.000','1736','251','2005-07-14T00:38:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5980','2005-07-11T00:18:21.000','1777','309','2005-07-14T21:26:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5981','2005-07-11T00:19:04.000','2151','241','2005-07-13T19:10:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5982','2005-07-11T00:24:44.000','2329','403','2005-07-14T04:42:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5983','2005-07-11T00:34:11.000','351','127','2005-07-15T05:37:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5984','2005-07-11T00:44:36.000','2801','178','2005-07-15T00:04:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5985','2005-07-11T00:51:58.000','1108','506','2005-07-14T22:02:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5986','2005-07-11T00:54:56.000','1624','171','2005-07-13T22:52:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5987','2005-07-11T00:55:31.000','1000','447','2005-07-16T06:28:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5988','2005-07-11T00:55:38.000','151','158','2005-07-13T21:36:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5989','2005-07-11T00:57:53.000','696','283','2005-07-15T02:24:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5990','2005-07-11T01:03:14.000','1561','432','2005-07-15T19:32:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5991','2005-07-11T01:03:38.000','3623','590','2005-07-12T22:32:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5992','2005-07-11T01:06:21.000','4216','54','2005-07-13T19:15:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5993','2005-07-11T01:06:41.000','3588','529','2005-07-14T19:19:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5994','2005-07-11T01:14:10.000','4287','295','2005-07-12T00:42:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5995','2005-07-11T01:15:39.000','4357','360','2005-07-20T05:01:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5996','2005-07-11T01:18:33.000','4263','223','2005-07-17T04:18:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5997','2005-07-11T01:19:50.000','3542','128','2005-07-16T06:29:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5998','2005-07-11T01:20:46.000','1458','250','2005-07-15T21:41:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('5999','2005-07-11T01:21:22.000','211','450','2005-07-19T01:35:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6000','2005-07-11T01:23:06.000','1986','371','2005-07-12T04:39:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6001','2005-07-11T01:24:44.000','1779','45','2005-07-11T22:55:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6002','2005-07-11T01:27:49.000','4422','45','2005-07-12T06:02:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6003','2005-07-11T01:28:33.000','296','527','2005-07-17T21:24:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6004','2005-07-11T01:34:25.000','1756','204','2005-07-18T00:48:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6005','2005-07-11T01:36:42.000','809','78','2005-07-14T04:47:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6006','2005-07-11T01:38:42.000','4201','399','2005-07-17T05:18:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6007','2005-07-11T01:43:06.000','4393','289','2005-07-17T04:46:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6008','2005-07-11T01:51:29.000','1227','216','2005-07-18T01:39:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6009','2005-07-11T01:51:58.000','494','470','2005-07-18T07:12:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6010','2005-07-11T01:52:28.000','771','285','2005-07-13T03:13:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6011','2005-07-11T01:54:48.000','3899','527','2005-07-18T07:17:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6012','2005-07-11T02:00:12.000','2609','258','2005-07-17T02:49:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6013','2005-07-11T02:02:03.000','3774','543','2005-07-14T02:07:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6014','2005-07-11T02:02:55.000','3748','397','2005-07-12T23:49:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6015','2005-07-11T02:04:12.000','295','596','2005-07-13T02:43:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6016','2005-07-11T02:04:45.000','651','296','2005-07-17T22:22:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6017','2005-07-11T02:05:32.000','4088','596','2005-07-14T22:50:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6018','2005-07-11T02:06:36.000','4555','500','2005-07-12T02:16:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6019','2005-07-11T02:08:29.000','3483','9','2005-07-13T02:19:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6020','2005-07-11T02:08:55.000','1974','71','2005-07-16T22:07:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6021','2005-07-11T02:10:18.000','3949','173','2005-07-13T05:19:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6022','2005-07-11T02:15:53.000','2435','469','2005-07-13T03:40:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6023','2005-07-11T02:15:57.000','3794','456','2005-07-15T21:30:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6024','2005-07-11T02:16:47.000','2923','271','2005-07-12T05:54:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6025','2005-07-11T02:18:13.000','3306','113','2005-07-11T23:30:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6026','2005-07-11T02:21:43.000','3936','409','2005-07-13T03:49:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6027','2005-07-11T02:26:29.000','4536','513','2005-07-18T23:05:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6028','2005-07-11T02:31:44.000','784','450','2005-07-14T03:18:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6029','2005-07-11T02:36:46.000','2030','520','2005-07-14T20:51:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6030','2005-07-11T02:37:51.000','95','36','2005-07-16T22:34:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6031','2005-07-11T02:42:14.000','1530','224','2005-07-14T03:24:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6032','2005-07-11T02:49:01.000','3792','28','2005-07-18T05:05:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6033','2005-07-11T02:59:34.000','2819','322','2005-07-16T03:48:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6034','2005-07-11T03:00:50.000','1735','324','2005-07-16T06:19:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6035','2005-07-11T03:01:45.000','3474','176','2005-07-14T01:04:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6036','2005-07-11T03:02:28.000','2553','297','2005-07-15T22:12:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6037','2005-07-11T03:06:54.000','1886','386','2005-07-12T22:46:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6038','2005-07-11T03:10:37.000','1555','243','2005-07-19T05:14:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6039','2005-07-11T03:12:19.000','1776','137','2005-07-19T05:46:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6040','2005-07-11T03:14:26.000','2161','511','2005-07-14T01:12:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6041','2005-07-11T03:14:58.000','2815','551','2005-07-13T00:48:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6042','2005-07-11T03:17:04.000','2153','5','2005-07-19T07:08:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6043','2005-07-11T03:18:10.000','3303','430','2005-07-12T05:50:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6044','2005-07-11T03:18:39.000','1270','481','2005-07-13T06:58:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6045','2005-07-11T03:21:05.000','2003','39','2005-07-17T23:10:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6046','2005-07-11T03:21:49.000','1935','569','2005-07-19T23:58:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6047','2005-07-11T03:27:01.000','4147','235','2005-07-16T06:42:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6048','2005-07-11T03:32:23.000','975','154','2005-07-14T07:39:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6049','2005-07-11T03:32:32.000','2582','236','2005-07-15T06:57:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6050','2005-07-11T03:34:29.000','825','527','2005-07-15T02:55:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6051','2005-07-11T03:46:41.000','2675','435','2005-07-11T22:36:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6052','2005-07-11T03:51:27.000','881','75','2005-07-16T02:55:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6053','2005-07-11T03:51:59.000','2836','237','2005-07-19T09:13:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6054','2005-07-11T03:58:39.000','1176','354','2005-07-13T23:08:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6055','2005-07-11T03:59:08.000','595','125','2005-07-18T05:35:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6056','2005-07-11T04:01:27.000','3069','145','2005-07-12T04:14:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6057','2005-07-11T04:03:40.000','1340','187','2005-07-17T01:34:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6058','2005-07-11T04:03:51.000','3761','498','2005-07-14T03:52:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6059','2005-07-11T04:03:54.000','1437','394','2005-07-18T01:35:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6060','2005-07-11T04:06:17.000','3146','342','2005-07-12T03:05:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6061','2005-07-11T04:06:25.000','1859','392','2005-07-11T23:11:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6062','2005-07-11T04:11:58.000','3301','408','2005-07-15T05:00:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6063','2005-07-11T04:16:51.000','1715','519','2005-07-13T08:35:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6064','2005-07-11T04:23:18.000','265','297','2005-07-19T02:21:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6065','2005-07-11T04:25:51.000','1007','562','2005-07-17T08:19:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6066','2005-07-11T04:32:42.000','1877','155','2005-07-15T03:56:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6067','2005-07-11T04:34:49.000','2097','186','2005-07-16T09:33:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6068','2005-07-11T04:41:09.000','2331','265','2005-07-14T04:45:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6069','2005-07-11T04:44:59.000','256','553','2005-07-13T01:00:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6070','2005-07-11T04:47:42.000','1679','267','2005-07-13T01:49:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6071','2005-07-11T04:50:03.000','889','179','2005-07-19T23:52:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6072','2005-07-11T04:52:40.000','1790','339','2005-07-18T01:02:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6073','2005-07-11T04:54:31.000','4243','466','2005-07-20T07:23:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6074','2005-07-11T04:59:56.000','2876','259','2005-07-13T23:31:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6075','2005-07-11T05:03:03.000','2160','283','2005-07-12T01:28:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6076','2005-07-11T05:05:30.000','1792','143','2005-07-18T04:22:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6077','2005-07-11T05:06:08.000','2154','542','2005-07-16T10:29:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6078','2005-07-11T05:06:52.000','3985','91','2005-07-17T06:13:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6079','2005-07-11T05:07:14.000','1494','119','2005-07-17T08:45:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6080','2005-07-11T05:08:11.000','2682','115','2005-07-16T09:54:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6081','2005-07-11T05:11:09.000','2286','72','2005-07-13T05:33:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6082','2005-07-11T05:12:41.000','1091','82','2005-07-16T03:40:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6083','2005-07-11T05:12:49.000','3183','285','2005-07-15T00:46:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6084','2005-07-11T05:16:20.000','1334','479','2005-07-19T01:38:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6085','2005-07-11T05:24:36.000','312','155','2005-07-16T03:49:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6086','2005-07-11T05:29:03.000','1505','420','2005-07-16T01:17:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6087','2005-07-11T05:29:22.000','198','155','2005-07-12T23:33:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6088','2005-07-11T05:40:35.000','3796','498','2005-07-17T07:14:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6089','2005-07-11T05:45:59.000','3298','580','2005-07-17T11:04:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6090','2005-07-11T05:47:08.000','71','241','2005-07-20T07:52:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6091','2005-07-11T05:49:18.000','580','383','2005-07-15T07:26:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6092','2005-07-11T05:51:31.000','2129','75','2005-07-17T03:42:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6093','2005-07-11T05:52:50.000','1868','117','2005-07-20T11:45:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6094','2005-07-11T05:54:42.000','2684','285','2005-07-18T08:19:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6095','2005-07-11T06:06:41.000','727','501','2005-07-19T06:14:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6096','2005-07-11T06:18:04.000','2720','420','2005-07-14T01:15:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6097','2005-07-11T06:21:43.000','297','416','2005-07-16T10:04:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6098','2005-07-11T06:23:28.000','3016','525','2005-07-17T04:05:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6099','2005-07-11T06:24:44.000','3865','469','2005-07-15T08:03:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6100','2005-07-11T06:40:31.000','3485','16','2005-07-14T10:59:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6101','2005-07-11T06:50:33.000','2618','508','2005-07-18T01:52:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6102','2005-07-11T06:53:09.000','4305','146','2005-07-17T07:05:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6103','2005-07-11T06:59:55.000','262','540','2005-07-16T09:30:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6104','2005-07-11T07:01:35.000','3531','389','2005-07-17T02:29:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6105','2005-07-11T07:03:19.000','3501','595','2005-07-19T06:46:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6106','2005-07-11T07:05:06.000','2714','185','2005-07-20T09:27:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6107','2005-07-11T07:07:09.000','3798','304','2005-07-14T07:32:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6108','2005-07-11T07:19:24.000','4296','572','2005-07-13T12:38:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6109','2005-07-11T07:20:57.000','3603','163','2005-07-13T07:29:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6110','2005-07-11T07:23:47.000','541','405','2005-07-20T03:17:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6111','2005-07-11T07:26:57.000','3504','300','2005-07-13T10:43:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6112','2005-07-11T07:28:05.000','1311','366','2005-07-18T07:29:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6113','2005-07-11T07:31:08.000','4437','115','2005-07-20T11:01:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6114','2005-07-11T07:33:48.000','479','404','2005-07-18T06:13:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6115','2005-07-11T07:36:50.000','3415','27','2005-07-13T11:30:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6116','2005-07-11T07:37:38.000','247','381','2005-07-14T11:53:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6117','2005-07-11T07:39:38.000','2613','135','2005-07-18T12:07:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6118','2005-07-11T07:43:08.000','3013','13','2005-07-20T03:17:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6119','2005-07-11T07:44:46.000','4281','472','2005-07-20T04:41:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6120','2005-07-11T07:49:53.000','3299','268','2005-07-19T04:56:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6121','2005-07-11T07:55:27.000','1613','347','2005-07-16T03:43:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6122','2005-07-11T07:58:07.000','2212','32','2005-07-16T09:52:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6123','2005-07-11T08:02:27.000','1354','200','2005-07-15T08:58:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6124','2005-07-11T08:02:32.000','2022','368','2005-07-12T05:58:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6125','2005-07-11T08:03:35.000','2439','307','2005-07-18T12:46:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6126','2005-07-11T08:06:56.000','1069','230','2005-07-16T11:42:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6127','2005-07-11T08:06:59.000','285','355','2005-07-12T09:01:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6128','2005-07-11T08:15:08.000','2050','18','2005-07-13T03:36:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6129','2005-07-11T08:15:09.000','3875','222','2005-07-18T13:00:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6130','2005-07-11T08:19:56.000','2547','538','2005-07-16T12:02:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6131','2005-07-11T08:22:05.000','3313','107','2005-07-14T07:40:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6132','2005-07-11T08:24:44.000','3229','319','2005-07-13T06:41:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6133','2005-07-11T08:25:22.000','1992','107','2005-07-13T13:17:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6134','2005-07-11T08:28:19.000','3225','305','2005-07-18T09:20:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6135','2005-07-11T08:32:23.000','833','325','2005-07-17T08:43:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6136','2005-07-11T08:34:09.000','205','346','2005-07-14T06:11:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6137','2005-07-11T08:34:20.000','2029','67','2005-07-13T03:31:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6138','2005-07-11T08:36:04.000','1808','438','2005-07-13T10:30:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6139','2005-07-11T08:39:33.000','3065','206','2005-07-17T08:00:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6140','2005-07-11T08:40:47.000','2749','363','2005-07-14T07:26:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6141','2005-07-11T08:52:16.000','2279','228','2005-07-17T03:00:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6142','2005-07-11T08:54:09.000','1722','136','2005-07-18T05:23:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6143','2005-07-11T09:02:37.000','1030','169','2005-07-19T05:57:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6144','2005-07-11T09:02:53.000','1077','554','2005-07-15T10:58:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6145','2005-07-11T09:07:01.000','1359','540','2005-07-19T08:21:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6146','2005-07-11T09:09:59.000','3374','11','2005-07-20T11:42:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6147','2005-07-11T09:13:08.000','910','35','2005-07-17T03:48:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6148','2005-07-11T09:14:22.000','4318','410','2005-07-12T08:01:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6149','2005-07-11T09:19:31.000','4337','26','2005-07-17T14:45:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6150','2005-07-11T09:23:56.000','1110','418','2005-07-15T10:56:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6151','2005-07-11T09:25:17.000','352','476','2005-07-12T05:11:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6152','2005-07-11T09:25:52.000','560','361','2005-07-17T07:40:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6153','2005-07-11T09:31:04.000','105','47','2005-07-19T03:41:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6154','2005-07-11T09:32:19.000','2717','368','2005-07-16T15:10:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6155','2005-07-11T09:45:31.000','785','229','2005-07-18T08:09:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6156','2005-07-11T09:45:48.000','302','297','2005-07-15T04:51:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6157','2005-07-11T09:48:16.000','4481','133','2005-07-16T05:00:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6158','2005-07-11T09:50:24.000','3954','92','2005-07-13T04:49:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6159','2005-07-11T09:55:34.000','126','225','2005-07-13T10:01:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6160','2005-07-11T10:08:13.000','2716','110','2005-07-14T08:18:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6161','2005-07-11T10:11:54.000','3681','524','2005-07-15T12:12:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6162','2005-07-11T10:12:30.000','786','79','2005-07-19T06:02:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6163','2005-07-11T10:13:46.000','1330','1','2005-07-19T13:15:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6164','2005-07-11T10:16:23.000','2755','47','2005-07-14T11:21:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6165','2005-07-11T10:17:29.000','3540','9','2005-07-17T07:27:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6166','2005-07-11T10:19:05.000','967','503','2005-07-12T14:30:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6167','2005-07-11T10:21:21.000','3255','200','2005-07-14T15:38:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6168','2005-07-11T10:21:38.000','284','77','2005-07-14T09:55:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6169','2005-07-11T10:25:56.000','2781','148','2005-07-19T07:18:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6170','2005-07-11T10:29:21.000','278','580','2005-07-16T05:13:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6171','2005-07-11T10:29:35.000','448','491','2005-07-16T12:01:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6172','2005-07-11T10:32:09.000','3514','219','2005-07-14T16:23:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6173','2005-07-11T10:33:11.000','4252','419','2005-07-15T10:57:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6174','2005-07-11T10:36:28.000','3123','7','2005-07-18T16:19:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6175','2005-07-11T10:44:37.000','3037','195','2005-07-15T08:13:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6176','2005-07-11T10:48:21.000','2969','279','2005-07-12T15:54:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6177','2005-07-11T10:53:49.000','313','589','2005-07-17T14:54:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6178','2005-07-11T10:59:09.000','2777','91','2005-07-16T11:19:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6179','2005-07-11T10:59:59.000','3665','42','2005-07-17T06:02:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6180','2005-07-11T11:06:50.000','4401','351','2005-07-19T09:03:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6181','2005-07-11T11:10:11.000','4398','200','2005-07-15T09:33:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6182','2005-07-11T11:11:38.000','2562','540','2005-07-17T08:33:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6183','2005-07-11T11:14:35.000','856','402','2005-07-16T15:35:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6184','2005-07-11T11:19:21.000','1131','146','2005-07-19T07:35:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6185','2005-07-11T11:25:09.000','4331','294','2005-07-18T12:09:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6186','2005-07-11T11:26:41.000','2086','128','2005-07-17T12:02:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6187','2005-07-11T11:28:51.000','3344','500','2005-07-12T15:44:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6188','2005-07-11T11:31:47.000','189','114','2005-07-15T09:28:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6189','2005-07-11T11:36:03.000','3800','552','2005-07-20T15:33:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6190','2005-07-11T11:36:18.000','2564','321','2005-07-19T17:05:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6191','2005-07-11T11:37:52.000','3448','480','2005-07-17T12:45:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6192','2005-07-11T11:44:41.000','4573','314','2005-07-19T10:12:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6193','2005-07-11T11:46:57.000','465','189','2005-07-19T14:11:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6194','2005-07-11T11:51:00.000','1049','83','2005-07-15T12:34:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6195','2005-07-11T12:00:32.000','4193','319','2005-07-16T15:00:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6196','2005-07-11T12:05:46.000','995','429','2005-07-18T08:27:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6197','2005-07-11T12:09:51.000','4156','596','2005-07-12T06:15:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6198','2005-07-11T12:12:17.000','3345','470','2005-07-18T07:40:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6199','2005-07-11T12:16:03.000','4329','80','2005-07-18T15:33:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6200','2005-07-11T12:16:42.000','3258','137','2005-07-17T09:27:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6201','2005-07-11T12:18:07.000','4530','559','2005-07-12T12:11:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6202','2005-07-11T12:24:25.000','1424','373','2005-07-18T08:13:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6203','2005-07-11T12:28:57.000','1001','408','2005-07-15T14:10:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6204','2005-07-11T12:29:22.000','2572','362','2005-07-13T10:41:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6205','2005-07-11T12:31:24.000','3442','303','2005-07-13T11:31:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6206','2005-07-11T12:32:14.000','1368','459','2005-07-15T15:01:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6207','2005-07-11T12:34:24.000','3226','143','2005-07-14T10:15:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6208','2005-07-11T12:34:56.000','672','31','2005-07-19T15:17:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6209','2005-07-11T12:36:05.000','3091','219','2005-07-17T14:48:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6210','2005-07-11T12:36:43.000','931','209','2005-07-17T17:45:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6211','2005-07-11T12:39:01.000','2699','6','2005-07-20T15:59:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6212','2005-07-11T12:40:48.000','3962','337','2005-07-15T17:49:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6213','2005-07-11T12:43:07.000','485','23','2005-07-16T07:23:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6214','2005-07-11T12:49:48.000','1258','49','2005-07-18T07:41:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6215','2005-07-11T12:52:36.000','316','390','2005-07-12T08:33:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6216','2005-07-11T12:57:05.000','3571','387','2005-07-13T12:31:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6217','2005-07-11T13:13:45.000','1090','177','2005-07-19T16:37:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6218','2005-07-11T13:14:58.000','815','410','2005-07-16T08:13:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6219','2005-07-11T13:18:37.000','38','303','2005-07-13T13:18:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6220','2005-07-11T13:22:06.000','1717','421','2005-07-12T17:46:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6221','2005-07-11T13:24:27.000','1699','393','2005-07-15T17:51:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6222','2005-07-11T13:25:49.000','2066','386','2005-07-13T14:32:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6223','2005-07-11T13:27:09.000','3754','192','2005-07-12T14:02:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6224','2005-07-11T13:42:18.000','3274','475','2005-07-16T09:28:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6225','2005-07-11T13:45:14.000','2483','204','2005-07-14T10:23:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6226','2005-07-11T13:48:11.000','2758','134','2005-07-15T17:18:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6227','2005-07-11T13:56:46.000','1654','210','2005-07-18T12:53:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6228','2005-07-11T13:58:36.000','2281','367','2005-07-17T19:03:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6229','2005-07-11T13:59:50.000','3137','399','2005-07-20T09:26:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6230','2005-07-11T14:02:19.000','2260','490','2005-07-17T08:11:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6231','2005-07-11T14:02:36.000','2526','122','2005-07-13T19:04:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6232','2005-07-11T14:08:27.000','2492','590','2005-07-20T19:34:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6233','2005-07-11T14:10:47.000','3731','378','2005-07-15T15:13:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6234','2005-07-11T14:16:10.000','2911','232','2005-07-19T19:55:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6235','2005-07-11T14:17:51.000','2659','379','2005-07-17T11:14:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6236','2005-07-11T14:18:17.000','3813','338','2005-07-14T08:47:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6237','2005-07-11T14:19:12.000','2215','166','2005-07-15T15:05:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6238','2005-07-11T14:20:18.000','3749','23','2005-07-14T18:34:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6239','2005-07-11T14:20:48.000','4107','132','2005-07-17T13:41:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6240','2005-07-11T14:32:41.000','640','524','2005-07-20T18:38:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6241','2005-07-11T14:40:48.000','4449','74','2005-07-18T09:51:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6242','2005-07-11T14:45:04.000','670','245','2005-07-12T18:34:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6243','2005-07-11T14:53:25.000','3456','26','2005-07-15T09:26:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6244','2005-07-11T14:53:38.000','1558','383','2005-07-12T16:42:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6245','2005-07-11T14:56:57.000','512','241','2005-07-16T14:35:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6246','2005-07-11T14:57:51.000','2376','172','2005-07-19T19:10:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6247','2005-07-11T15:00:05.000','2504','589','2005-07-18T13:47:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6248','2005-07-11T15:01:54.000','2686','6','2005-07-19T16:58:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6249','2005-07-11T15:02:02.000','4334','30','2005-07-14T11:37:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6250','2005-07-11T15:02:04.000','4087','458','2005-07-17T10:54:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6251','2005-07-11T15:06:20.000','3956','230','2005-07-18T20:11:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6252','2005-07-11T15:06:29.000','1294','295','2005-07-16T14:07:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6253','2005-07-11T15:07:19.000','1425','570','2005-07-13T11:00:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6254','2005-07-11T15:10:18.000','2038','20','2005-07-17T14:20:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6255','2005-07-11T15:11:33.000','1459','319','2005-07-15T19:55:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6256','2005-07-11T15:19:22.000','480','307','2005-07-13T12:43:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6257','2005-07-11T15:23:46.000','3253','492','2005-07-14T17:26:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6258','2005-07-11T15:24:32.000','632','417','2005-07-18T18:29:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6259','2005-07-11T15:25:52.000','3007','84','2005-07-13T11:54:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6260','2005-07-11T15:26:29.000','4308','454','2005-07-13T17:37:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6261','2005-07-11T15:28:34.000','694','386','2005-07-14T17:54:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6262','2005-07-11T15:33:24.000','4136','355','2005-07-17T12:40:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6263','2005-07-11T15:33:50.000','2391','336','2005-07-17T12:49:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6264','2005-07-11T15:42:35.000','4246','565','2005-07-12T11:29:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6265','2005-07-11T15:43:51.000','3931','477','2005-07-12T12:51:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6266','2005-07-11T15:45:39.000','941','397','2005-07-15T18:29:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6267','2005-07-11T15:53:00.000','2152','20','2005-07-17T18:09:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6268','2005-07-11T15:55:34.000','1154','125','2005-07-19T17:25:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6269','2005-07-11T15:58:43.000','3915','167','2005-07-13T13:25:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6270','2005-07-11T15:59:10.000','2308','292','2005-07-18T10:29:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6271','2005-07-11T16:01:35.000','1246','467','2005-07-20T12:07:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6272','2005-07-11T16:03:49.000','3103','240','2005-07-15T19:54:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6273','2005-07-11T16:08:41.000','2403','152','2005-07-14T16:41:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6274','2005-07-11T16:09:42.000','2998','472','2005-07-19T20:46:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6275','2005-07-11T16:12:11.000','3599','333','2005-07-17T20:19:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6276','2005-07-11T16:15:50.000','1826','284','2005-07-19T20:50:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6277','2005-07-11T16:19:01.000','4023','92','2005-07-18T21:00:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6278','2005-07-11T16:20:02.000','2232','558','2005-07-19T19:29:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6279','2005-07-11T16:26:07.000','1254','49','2005-07-17T21:05:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6280','2005-07-11T16:36:17.000','4055','33','2005-07-13T14:04:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6281','2005-07-11T16:38:16.000','835','236','2005-07-13T10:57:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6282','2005-07-11T16:46:22.000','4453','60','2005-07-15T13:19:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6283','2005-07-11T16:47:32.000','3319','402','2005-07-17T21:46:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6284','2005-07-11T16:51:39.000','2938','177','2005-07-15T19:59:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6285','2005-07-11T16:52:07.000','2140','444','2005-07-13T21:33:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6286','2005-07-11T16:55:35.000','1070','140','2005-07-13T22:51:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6287','2005-07-11T17:00:04.000','35','93','2005-07-12T13:16:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6288','2005-07-11T17:01:52.000','3235','357','2005-07-19T15:11:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6289','2005-07-11T17:06:39.000','3185','99','2005-07-12T15:54:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6290','2005-07-11T17:12:42.000','2634','66','2005-07-19T21:53:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6291','2005-07-11T17:16:40.000','3126','262','2005-07-13T18:24:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6292','2005-07-11T17:23:33.000','4375','505','2005-07-12T16:27:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6293','2005-07-11T17:24:57.000','4260','471','2005-07-13T18:45:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6294','2005-07-11T17:25:55.000','1732','463','2005-07-15T17:48:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6295','2005-07-11T17:30:58.000','1393','7','2005-07-15T15:50:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6296','2005-07-11T17:34:04.000','4202','484','2005-07-17T21:12:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6297','2005-07-11T17:37:22.000','2738','69','2005-07-19T13:54:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6298','2005-07-11T17:42:33.000','3906','256','2005-07-13T18:14:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6299','2005-07-11T17:45:08.000','4125','324','2005-07-13T16:36:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6300','2005-07-11T17:50:09.000','1269','283','2005-07-18T13:11:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6301','2005-07-11T17:54:09.000','3528','275','2005-07-18T20:42:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6302','2005-07-11T17:55:38.000','3221','391','2005-07-17T22:11:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6303','2005-07-11T17:55:43.000','846','236','2005-07-13T12:50:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6304','2005-07-11T18:02:16.000','4183','579','2005-07-14T14:01:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6305','2005-07-11T18:02:25.000','1544','337','2005-07-20T13:29:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6306','2005-07-11T18:04:26.000','486','208','2005-07-20T14:22:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6307','2005-07-11T18:04:29.000','4029','345','2005-07-17T23:40:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6308','2005-07-11T18:08:41.000','3155','472','2005-07-19T15:48:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6309','2005-07-11T18:13:24.000','1054','232','2005-07-13T23:11:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6310','2005-07-11T18:14:05.000','3064','537','2005-07-16T15:39:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6311','2005-07-11T18:18:52.000','1789','373','2005-07-16T17:52:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6312','2005-07-11T18:19:02.000','2188','417','2005-07-18T00:00:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6313','2005-07-11T18:29:52.000','2976','283','2005-07-14T21:34:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6314','2005-07-11T18:32:44.000','4128','55','2005-07-17T23:58:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6315','2005-07-11T18:42:49.000','608','374','2005-07-12T23:19:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6316','2005-07-11T18:44:52.000','1910','526','2005-07-19T23:35:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6317','2005-07-11T18:47:41.000','4206','225','2005-07-14T18:18:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6318','2005-07-11T18:48:22.000','2048','425','2005-07-12T13:39:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6319','2005-07-11T18:50:45.000','3739','233','2005-07-12T15:26:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6320','2005-07-11T18:50:55.000','441','511','2005-07-13T22:46:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6321','2005-07-11T18:51:02.000','2655','388','2005-07-14T20:57:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6322','2005-07-11T18:58:20.000','4115','403','2005-07-14T16:41:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6323','2005-07-11T19:02:19.000','1352','346','2005-07-14T15:54:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6324','2005-07-11T19:02:34.000','655','386','2005-07-17T15:57:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6325','2005-07-11T19:06:01.000','4556','542','2005-07-18T18:25:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6326','2005-07-11T19:06:55.000','2137','563','2005-07-12T20:41:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6327','2005-07-11T19:07:29.000','909','146','2005-07-15T16:09:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6328','2005-07-11T19:09:33.000','999','260','2005-07-12T20:16:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6329','2005-07-11T19:10:38.000','2763','352','2005-07-19T14:46:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6330','2005-07-11T19:15:42.000','3917','119','2005-07-17T19:10:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6331','2005-07-11T19:17:21.000','1356','295','2005-07-18T18:35:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6332','2005-07-11T19:19:06.000','1733','538','2005-07-13T13:51:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6333','2005-07-11T19:20:16.000','2610','285','2005-07-17T15:33:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6334','2005-07-11T19:20:44.000','948','168','2005-07-19T18:49:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6335','2005-07-11T19:25:15.000','2757','396','2005-07-16T17:02:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6336','2005-07-11T19:30:13.000','1229','471','2005-07-20T21:27:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6337','2005-07-11T19:30:47.000','3967','47','2005-07-19T20:27:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6338','2005-07-11T19:39:41.000','1691','54','2005-07-18T01:13:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6339','2005-07-11T19:45:32.000','2401','145','2005-07-18T22:34:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6340','2005-07-11T19:46:05.000','2374','264','2005-07-20T16:51:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6341','2005-07-11T19:48:02.000','3580','448','2005-07-15T01:31:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6342','2005-07-11T19:48:24.000','1851','403','2005-07-13T14:09:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6343','2005-07-11T19:51:35.000','513','147','2005-07-12T19:13:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6344','2005-07-11T20:04:43.000','3074','78','2005-07-18T14:35:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6345','2005-07-11T20:05:18.000','4332','532','2005-07-20T17:28:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6346','2005-07-11T20:08:34.000','4066','445','2005-07-16T16:35:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6347','2005-07-11T20:18:53.000','3160','178','2005-07-16T20:45:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6348','2005-07-11T20:21:18.000','21','66','2005-07-19T15:56:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6349','2005-07-11T20:25:05.000','1581','216','2005-07-21T00:35:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6350','2005-07-11T20:30:15.000','2853','225','2005-07-16T21:30:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6351','2005-07-11T20:31:44.000','1852','507','2005-07-18T17:16:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6352','2005-07-11T20:34:13.000','1143','235','2005-07-13T19:49:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6353','2005-07-11T20:48:56.000','699','130','2005-07-21T00:11:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6354','2005-07-11T20:54:27.000','3203','176','2005-07-18T23:46:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6355','2005-07-11T20:56:29.000','2472','482','2005-07-20T01:50:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6356','2005-07-11T20:57:48.000','2645','149','2005-07-12T22:40:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6357','2005-07-11T20:58:51.000','658','252','2005-07-12T15:06:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6358','2005-07-11T21:03:12.000','4527','567','2005-07-15T20:06:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6359','2005-07-11T21:06:17.000','1656','30','2005-07-16T02:51:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6360','2005-07-11T21:07:40.000','3075','338','2005-07-16T15:11:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6361','2005-07-11T21:09:14.000','2903','561','2005-07-14T18:26:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6362','2005-07-11T21:09:31.000','4259','358','2005-07-13T23:08:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6363','2005-07-11T21:13:19.000','4167','344','2005-07-20T15:44:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6364','2005-07-11T21:14:48.000','4146','160','2005-07-20T23:20:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6365','2005-07-11T21:17:40.000','4550','566','2005-07-14T20:53:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6366','2005-07-11T21:18:16.000','3989','366','2005-07-17T00:21:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6367','2005-07-11T21:18:29.000','1465','357','2005-07-15T01:05:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6368','2005-07-11T21:19:01.000','3666','588','2005-07-13T17:56:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6369','2005-07-11T21:23:36.000','1086','252','2005-07-13T22:23:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6370','2005-07-11T21:28:32.000','1410','99','2005-07-20T02:51:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6371','2005-07-11T21:31:51.000','4297','265','2005-07-16T23:10:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6372','2005-07-11T21:35:06.000','741','64','2005-07-15T02:30:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6373','2005-07-11T21:35:20.000','1042','115','2005-07-13T23:22:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6374','2005-07-11T21:36:10.000','266','244','2005-07-17T15:50:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6375','2005-07-11T21:39:46.000','1936','8','2005-07-18T02:12:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6376','2005-07-11T21:40:23.000','1834','263','2005-07-13T23:16:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6377','2005-07-11T21:41:16.000','4017','118','2005-07-15T20:05:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6378','2005-07-11T21:45:23.000','3170','145','2005-07-14T16:56:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6379','2005-07-11T21:51:25.000','522','287','2005-07-17T03:38:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6380','2005-07-11T21:55:40.000','3378','172','2005-07-17T20:42:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6381','2005-07-11T21:58:48.000','2584','340','2005-07-16T16:18:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6382','2005-07-11T21:58:53.000','3223','336','2005-07-17T21:18:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6383','2005-07-11T22:06:53.000','4275','486','2005-07-17T16:09:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6384','2005-07-11T22:07:26.000','491','313','2005-07-16T22:39:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6385','2005-07-11T22:07:32.000','1830','69','2005-07-20T16:57:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6386','2005-07-11T22:14:57.000','633','593','2005-07-15T16:41:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6387','2005-07-11T22:15:56.000','1726','384','2005-07-14T20:20:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6388','2005-07-11T22:17:16.000','3506','525','2005-07-19T23:50:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6389','2005-07-11T22:18:20.000','2268','274','2005-07-16T16:57:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6390','2005-07-11T22:19:23.000','3057','77','2005-07-15T20:10:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6391','2005-07-11T22:23:09.000','1745','264','2005-07-15T23:02:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6392','2005-07-11T22:25:19.000','4406','468','2005-07-16T04:24:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6393','2005-07-11T22:28:12.000','3802','164','2005-07-14T18:03:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6394','2005-07-11T22:29:15.000','2574','52','2005-07-20T02:19:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6395','2005-07-11T22:29:29.000','3058','264','2005-07-18T00:50:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6396','2005-07-11T22:31:08.000','2394','507','2005-07-19T17:19:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6397','2005-07-11T22:34:02.000','2423','287','2005-07-13T23:01:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6398','2005-07-11T22:34:49.000','1409','296','2005-07-17T17:58:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6399','2005-07-11T22:39:05.000','2031','288','2005-07-16T01:12:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6400','2005-07-11T22:43:44.000','3289','536','2005-07-19T03:58:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6401','2005-07-11T22:44:34.000','1427','35','2005-07-12T22:18:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6402','2005-07-11T22:46:10.000','2576','66','2005-07-16T04:02:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6403','2005-07-11T22:46:25.000','1019','238','2005-07-13T22:15:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6404','2005-07-11T22:49:50.000','1183','526','2005-07-14T18:29:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6405','2005-07-11T22:53:12.000','3983','357','2005-07-18T23:02:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6406','2005-07-11T22:55:27.000','4439','392','2005-07-20T04:50:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6407','2005-07-11T23:02:19.000','775','140','2005-07-21T00:30:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6408','2005-07-11T23:03:02.000','2008','350','2005-07-19T23:09:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6409','2005-07-11T23:05:49.000','3859','537','2005-07-13T00:13:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6410','2005-07-11T23:08:06.000','1127','560','2005-07-19T19:57:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6411','2005-07-11T23:10:50.000','4347','124','2005-07-19T17:15:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6412','2005-07-11T23:19:21.000','3797','220','2005-07-16T19:48:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6413','2005-07-11T23:26:11.000','4446','251','2005-07-17T21:58:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6414','2005-07-11T23:26:13.000','814','502','2005-07-18T17:29:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6415','2005-07-11T23:27:52.000','4175','84','2005-07-19T22:29:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6416','2005-07-11T23:29:14.000','1063','158','2005-07-13T20:20:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6417','2005-07-11T23:35:11.000','3042','80','2005-07-18T20:00:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6418','2005-07-11T23:36:27.000','3101','185','2005-07-16T18:42:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6419','2005-07-11T23:36:38.000','3683','311','2005-07-13T03:23:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6420','2005-07-11T23:38:49.000','4443','206','2005-07-17T17:46:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6421','2005-07-11T23:45:25.000','4477','479','2005-07-15T20:45:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6422','2005-07-11T23:46:19.000','762','257','2005-07-20T22:12:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6423','2005-07-11T23:47:31.000','892','427','2005-07-19T18:16:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6424','2005-07-11T23:49:37.000','3040','359','2005-07-21T00:53:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6425','2005-07-11T23:54:52.000','2487','339','2005-07-13T18:37:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6426','2005-07-11T23:56:38.000','498','495','2005-07-21T05:22:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6427','2005-07-11T23:57:34.000','1043','122','2005-07-14T18:05:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6428','2005-07-12T00:01:51.000','4365','187','2005-07-20T22:02:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6429','2005-07-12T00:02:50.000','141','342','2005-07-21T02:08:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6430','2005-07-12T00:03:34.000','178','390','2005-07-15T03:11:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6431','2005-07-12T00:03:57.000','3471','458','2005-07-20T03:47:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6432','2005-07-12T00:09:41.000','970','293','2005-07-20T20:06:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6433','2005-07-12T00:12:02.000','1357','101','2005-07-21T04:25:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6434','2005-07-12T00:14:25.000','1478','102','2005-07-20T19:54:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6435','2005-07-12T00:16:19.000','1957','561','2005-07-17T19:15:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6436','2005-07-12T00:18:42.000','3758','122','2005-07-13T03:57:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6437','2005-07-12T00:20:29.000','4539','355','2005-07-12T22:26:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6438','2005-07-12T00:23:01.000','412','211','2005-07-17T22:45:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6439','2005-07-12T00:23:48.000','3463','406','2005-07-13T00:54:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6440','2005-07-12T00:25:04.000','2148','269','2005-07-13T04:52:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6441','2005-07-12T00:27:08.000','2489','505','2005-07-14T03:12:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6442','2005-07-12T00:29:45.000','1273','360','2005-07-15T19:37:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6443','2005-07-12T00:35:51.000','895','155','2005-07-16T04:50:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6444','2005-07-12T00:36:02.000','2214','168','2005-07-18T05:53:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6445','2005-07-12T00:37:02.000','582','385','2005-07-17T22:05:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6446','2005-07-12T00:44:08.000','3634','473','2005-07-14T20:39:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6447','2005-07-12T00:45:17.000','3945','482','2005-07-18T05:56:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6448','2005-07-12T00:45:59.000','2663','160','2005-07-17T00:34:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6449','2005-07-12T00:48:58.000','4395','117','2005-07-21T02:57:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6450','2005-07-12T00:49:05.000','2413','32','2005-07-13T01:54:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6451','2005-07-12T00:52:19.000','1008','381','2005-07-16T21:30:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6452','2005-07-12T00:57:31.000','109','388','2005-07-14T20:41:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6453','2005-07-12T00:59:53.000','2506','169','2005-07-14T19:17:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6454','2005-07-12T01:00:12.000','4028','446','2005-07-16T22:12:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6455','2005-07-12T01:01:58.000','4267','277','2005-07-16T02:42:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6456','2005-07-12T01:05:11.000','259','387','2005-07-20T23:26:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6457','2005-07-12T01:06:35.000','2970','64','2005-07-14T03:27:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6458','2005-07-12T01:08:52.000','2809','138','2005-07-16T20:22:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6459','2005-07-12T01:12:03.000','4025','557','2005-07-15T23:48:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6460','2005-07-12T01:13:44.000','2402','371','2005-07-17T04:51:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6461','2005-07-12T01:14:03.000','1799','135','2005-07-19T21:12:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6462','2005-07-12T01:15:24.000','4534','414','2005-07-19T05:11:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6463','2005-07-12T01:16:11.000','2930','391','2005-07-13T01:37:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6464','2005-07-12T01:16:40.000','3100','303','2005-07-20T00:53:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6465','2005-07-12T01:17:11.000','2047','207','2005-07-20T00:29:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6466','2005-07-12T01:21:03.000','3369','235','2005-07-14T04:05:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6467','2005-07-12T01:22:03.000','2067','457','2005-07-20T04:37:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6468','2005-07-12T01:27:09.000','4560','541','2005-07-20T00:37:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6469','2005-07-12T01:29:27.000','3830','147','2005-07-16T20:22:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6470','2005-07-12T01:29:41.000','1680','240','2005-07-15T21:33:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6471','2005-07-12T01:31:06.000','2253','397','2005-07-13T05:26:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6472','2005-07-12T01:33:25.000','3780','183','2005-07-15T20:26:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6473','2005-07-12T01:35:40.000','527','594','2005-07-20T20:11:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6474','2005-07-12T01:36:46.000','310','43','2005-07-16T07:24:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6475','2005-07-12T01:36:57.000','2035','74','2005-07-17T21:22:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6476','2005-07-12T01:37:48.000','978','28','2005-07-12T20:21:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6477','2005-07-12T01:38:42.000','804','181','2005-07-17T05:19:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6478','2005-07-12T01:41:44.000','2589','483','2005-07-15T20:48:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6479','2005-07-12T01:49:00.000','2587','558','2005-07-21T04:26:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6480','2005-07-12T01:49:29.000','3076','309','2005-07-17T01:00:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6481','2005-07-12T01:50:15.000','2392','128','2005-07-20T03:03:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6482','2005-07-12T01:50:21.000','4135','57','2005-07-14T06:49:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6483','2005-07-12T01:59:20.000','1053','263','2005-07-12T22:22:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6484','2005-07-12T02:04:10.000','4093','556','2005-07-17T23:18:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6485','2005-07-12T02:07:59.000','1224','319','2005-07-19T22:56:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6486','2005-07-12T02:09:36.000','4008','75','2005-07-14T03:04:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6487','2005-07-12T02:17:00.000','4000','277','2005-07-19T00:57:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6488','2005-07-12T02:20:09.000','3974','169','2005-07-20T00:53:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6489','2005-07-12T02:22:46.000','1821','268','2005-07-17T06:16:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6490','2005-07-12T02:28:03.000','2249','548','2005-07-19T03:06:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6491','2005-07-12T02:28:31.000','2803','415','2005-07-21T00:38:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6492','2005-07-12T02:28:40.000','466','590','2005-07-17T05:58:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6493','2005-07-12T02:40:41.000','16','184','2005-07-16T04:56:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6494','2005-07-12T02:42:51.000','1124','57','2005-07-20T06:57:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6495','2005-07-12T02:57:02.000','2440','19','2005-07-14T08:35:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6496','2005-07-12T02:57:39.000','3550','139','2005-07-20T01:43:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6497','2005-07-12T03:04:29.000','933','222','2005-07-17T21:36:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6498','2005-07-12T03:05:38.000','243','48','2005-07-19T07:12:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6499','2005-07-12T03:11:18.000','3165','474','2005-07-21T07:50:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6500','2005-07-12T03:11:23.000','4521','577','2005-07-13T00:51:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6501','2005-07-12T03:11:55.000','2851','219','2005-07-16T02:08:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6502','2005-07-12T03:15:45.000','1641','40','2005-07-17T08:47:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6503','2005-07-12T03:18:07.000','1319','120','2005-07-15T00:05:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6504','2005-07-12T03:19:14.000','3786','535','2005-07-17T01:13:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6505','2005-07-12T03:27:37.000','3986','415','2005-07-17T22:42:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6506','2005-07-12T03:28:22.000','386','423','2005-07-17T22:43:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6507','2005-07-12T03:33:12.000','2463','118','2005-07-20T03:56:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6508','2005-07-12T03:34:50.000','1474','597','2005-07-17T02:57:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6509','2005-07-12T03:35:01.000','2468','427','2005-07-13T06:50:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6510','2005-07-12T03:35:39.000','905','446','2005-07-21T01:41:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6511','2005-07-12T03:39:29.000','1350','322','2005-07-17T01:01:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6512','2005-07-12T03:42:49.000','1703','68','2005-07-13T05:01:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6513','2005-07-12T03:44:43.000','2671','393','2005-07-13T05:54:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6514','2005-07-12T03:47:44.000','3562','73','2005-07-20T00:11:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6515','2005-07-12T03:50:32.000','706','261','2005-07-15T03:54:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6516','2005-07-12T03:51:54.000','863','291','2005-07-14T03:41:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6517','2005-07-12T03:52:39.000','185','387','2005-07-20T08:00:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6518','2005-07-12T03:59:42.000','2698','288','2005-07-19T22:21:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6519','2005-07-12T04:00:36.000','4149','598','2005-07-19T01:15:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6520','2005-07-12T04:05:16.000','1535','270','2005-07-15T08:26:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6521','2005-07-12T04:06:11.000','3293','49','2005-07-21T05:50:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6522','2005-07-12T04:11:58.000','3916','142','2005-07-15T08:32:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6523','2005-07-12T04:14:19.000','1848','574','2005-07-17T00:38:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6524','2005-07-12T04:14:35.000','1467','376','2005-07-17T03:59:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6525','2005-07-12T04:17:15.000','1408','103','2005-07-18T23:11:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6526','2005-07-12T04:21:20.000','1718','225','2005-07-18T23:45:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6527','2005-07-12T04:23:06.000','538','65','2005-07-17T00:20:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6528','2005-07-12T04:29:44.000','3824','598','2005-07-18T02:39:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6529','2005-07-12T04:31:04.000','1058','503','2005-07-17T07:09:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6530','2005-07-12T04:33:19.000','3410','75','2005-07-15T08:26:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6531','2005-07-12T04:35:24.000','4231','510','2005-07-16T05:37:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6532','2005-07-12T04:38:32.000','2361','225','2005-07-13T03:54:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6533','2005-07-12T04:39:38.000','3853','366','2005-07-18T05:29:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6534','2005-07-12T04:39:43.000','2359','577','2005-07-16T06:33:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6535','2005-07-12T04:43:43.000','1921','446','2005-07-17T04:52:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6536','2005-07-12T04:44:25.000','3521','289','2005-07-18T01:52:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6537','2005-07-12T04:46:30.000','3381','207','2005-07-19T03:04:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6538','2005-07-12T04:50:26.000','1987','529','2005-07-20T23:44:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6539','2005-07-12T04:50:49.000','2275','259','2005-07-19T03:23:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6540','2005-07-12T04:51:13.000','937','156','2005-07-21T03:38:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6541','2005-07-12T04:53:41.000','1795','529','2005-07-17T23:17:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6542','2005-07-12T04:53:49.000','2421','359','2005-07-13T01:48:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6543','2005-07-12T04:54:32.000','2568','264','2005-07-15T09:50:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6544','2005-07-12T04:56:15.000','1218','97','2005-07-17T08:28:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6545','2005-07-12T04:56:30.000','4447','376','2005-07-20T05:41:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6546','2005-07-12T04:57:17.000','393','105','2005-07-17T09:29:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6547','2005-07-12T04:57:46.000','2656','262','2005-07-18T08:36:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6548','2005-07-12T05:00:46.000','2480','488','2005-07-19T04:40:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6549','2005-07-12T05:02:01.000','2688','493','2005-07-20T06:19:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6550','2005-07-12T05:03:14.000','2184','112','2005-07-19T04:06:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6551','2005-07-12T05:03:43.000','282','567','2005-07-13T10:44:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6552','2005-07-12T05:05:06.000','766','493','2005-07-13T05:12:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6553','2005-07-12T05:06:39.000','1137','265','2005-07-21T10:37:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6554','2005-07-12T05:07:26.000','2741','178','2005-07-21T06:06:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6555','2005-07-12T05:08:16.000','1282','188','2005-07-14T04:09:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6556','2005-07-12T05:10:16.000','3901','570','2005-07-13T04:16:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6557','2005-07-12T05:12:03.000','1442','116','2005-07-20T06:49:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6558','2005-07-12T05:16:07.000','2195','164','2005-07-13T05:32:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6559','2005-07-12T05:20:35.000','458','353','2005-07-16T08:44:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6560','2005-07-12T05:22:06.000','433','54','2005-07-15T00:04:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6561','2005-07-12T05:24:02.000','4568','528','2005-07-16T03:43:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6562','2005-07-12T05:26:26.000','3969','27','2005-07-16T05:10:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6563','2005-07-12T05:34:09.000','87','438','2005-07-21T07:37:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6564','2005-07-12T05:34:44.000','2320','210','2005-07-18T06:12:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6565','2005-07-12T05:39:50.000','2751','35','2005-07-13T01:07:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6566','2005-07-12T05:42:53.000','1822','178','2005-07-19T01:23:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6567','2005-07-12T05:43:09.000','1336','198','2005-07-19T08:18:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6568','2005-07-12T05:45:47.000','4203','13','2005-07-15T05:18:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6569','2005-07-12T05:47:40.000','759','183','2005-07-20T06:23:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6570','2005-07-12T05:50:31.000','2082','217','2005-07-13T09:58:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6571','2005-07-12T05:51:47.000','3700','140','2005-07-15T11:31:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6572','2005-07-12T05:56:38.000','3121','35','2005-07-16T10:41:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6573','2005-07-12T06:03:40.000','3308','239','2005-07-13T11:49:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6574','2005-07-12T06:04:22.000','621','115','2005-07-18T03:19:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6575','2005-07-12T06:12:53.000','1414','598','2005-07-18T07:55:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6576','2005-07-12T06:13:41.000','339','362','2005-07-16T03:22:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6577','2005-07-12T06:15:05.000','4191','439','2005-07-15T06:23:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6578','2005-07-12T06:15:41.000','2304','229','2005-07-15T10:43:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6580','2005-07-12T06:26:10.000','1543','31','2005-07-13T06:44:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6581','2005-07-12T06:26:49.000','2121','468','2005-07-14T05:07:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6582','2005-07-12T06:28:12.000','2077','420','2005-07-19T06:19:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6583','2005-07-12T06:42:31.000','2343','462','2005-07-15T07:51:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6584','2005-07-12T06:43:36.000','1800','472','2005-07-16T12:18:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6585','2005-07-12T06:50:52.000','2064','136','2005-07-21T06:51:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6586','2005-07-12T06:56:24.000','3860','93','2005-07-17T09:36:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6587','2005-07-12T06:56:26.000','238','419','2005-07-20T05:53:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6588','2005-07-12T06:57:40.000','1257','420','2005-07-16T04:27:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6589','2005-07-12T07:06:29.000','1595','424','2005-07-14T12:06:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6590','2005-07-12T07:08:21.000','1067','442','2005-07-18T06:16:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6591','2005-07-12T07:13:46.000','2846','509','2005-07-16T05:15:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6592','2005-07-12T07:19:35.000','3481','273','2005-07-19T07:15:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6593','2005-07-12T07:21:17.000','3441','356','2005-07-14T02:35:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6594','2005-07-12T07:25:43.000','4458','517','2005-07-13T07:59:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6595','2005-07-12T07:25:48.000','1286','458','2005-07-20T02:24:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6596','2005-07-12T07:32:59.000','890','409','2005-07-13T02:47:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6597','2005-07-12T07:37:02.000','979','479','2005-07-16T10:24:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6598','2005-07-12T07:38:25.000','2049','532','2005-07-19T07:58:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6599','2005-07-12T07:41:14.000','4348','519','2005-07-21T02:45:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6600','2005-07-12T07:41:48.000','3315','389','2005-07-18T12:36:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6601','2005-07-12T07:44:49.000','1640','464','2005-07-20T03:22:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6602','2005-07-12T07:50:24.000','2382','214','2005-07-20T03:25:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6603','2005-07-12T07:52:55.000','3583','425','2005-07-16T13:19:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6604','2005-07-12T07:57:45.000','822','365','2005-07-16T05:41:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6605','2005-07-12T08:01:07.000','2892','547','2005-07-19T03:12:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6606','2005-07-12T08:03:40.000','2805','178','2005-07-13T09:05:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6607','2005-07-12T08:08:50.000','337','562','2005-07-20T09:17:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6608','2005-07-12T08:16:50.000','3577','244','2005-07-18T07:08:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6609','2005-07-12T08:19:41.000','3332','133','2005-07-19T08:19:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6610','2005-07-12T08:20:02.000','645','353','2005-07-21T09:16:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6611','2005-07-12T08:20:23.000','1604','286','2005-07-16T07:19:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6612','2005-07-12T08:28:33.000','235','152','2005-07-17T06:25:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6613','2005-07-12T08:30:07.000','3421','460','2005-07-14T10:25:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6614','2005-07-12T08:33:49.000','3004','144','2005-07-18T07:28:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6615','2005-07-12T08:36:22.000','23','438','2005-07-20T09:03:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6616','2005-07-12T08:37:30.000','1833','179','2005-07-20T10:33:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6617','2005-07-12T08:39:56.000','2292','248','2005-07-14T09:32:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6618','2005-07-12T08:41:42.000','4266','327','2005-07-14T05:34:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6619','2005-07-12T08:50:48.000','4062','305','2005-07-14T11:54:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6620','2005-07-12T08:51:03.000','2362','337','2005-07-16T03:59:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6621','2005-07-12T08:57:30.000','2229','561','2005-07-14T09:47:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6622','2005-07-12T09:04:11.000','4350','325','2005-07-13T04:27:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6623','2005-07-12T09:05:34.000','4412','302','2005-07-19T13:54:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6624','2005-07-12T09:05:50.000','3946','335','2005-07-18T13:59:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6625','2005-07-12T09:06:40.000','735','443','2005-07-21T04:57:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6626','2005-07-12T09:16:24.000','2418','269','2005-07-17T04:06:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6627','2005-07-12T09:16:46.000','626','565','2005-07-17T10:58:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6628','2005-07-12T09:18:08.000','2894','211','2005-07-21T04:27:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6629','2005-07-12T09:18:35.000','2855','582','2005-07-20T11:34:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6630','2005-07-12T09:30:05.000','1843','462','2005-07-14T08:29:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6631','2005-07-12T09:31:43.000','2340','204','2005-07-15T05:00:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6632','2005-07-12T09:33:10.000','2929','442','2005-07-15T11:36:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6633','2005-07-12T09:35:42.000','2908','150','2005-07-13T12:56:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6634','2005-07-12T09:37:18.000','2943','50','2005-07-13T09:28:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6635','2005-07-12T09:47:58.000','515','273','2005-07-16T15:43:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6636','2005-07-12T09:49:46.000','3270','441','2005-07-14T12:15:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6637','2005-07-12T09:57:39.000','2852','164','2005-07-19T08:40:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6638','2005-07-12T09:58:02.000','207','87','2005-07-13T09:40:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6639','2005-07-12T10:00:44.000','3385','587','2005-07-19T04:56:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6640','2005-07-12T10:27:19.000','2794','148','2005-07-21T06:28:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6641','2005-07-12T10:33:14.000','2165','334','2005-07-20T08:24:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6642','2005-07-12T10:37:52.000','201','441','2005-07-13T15:13:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6643','2005-07-12T10:39:22.000','174','88','2005-07-18T13:52:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6644','2005-07-12T10:39:39.000','2667','285','2005-07-14T11:50:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6645','2005-07-12T10:39:55.000','2858','73','2005-07-17T07:41:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6646','2005-07-12T10:41:34.000','4061','508','2005-07-15T05:31:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6647','2005-07-12T10:43:53.000','1841','8','2005-07-14T05:37:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6648','2005-07-12T10:46:30.000','718','356','2005-07-14T16:15:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6649','2005-07-12T10:51:09.000','70','57','2005-07-14T16:05:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6650','2005-07-12T10:57:10.000','1589','526','2005-07-14T07:24:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6651','2005-07-12T10:57:28.000','98','447','2005-07-15T06:06:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6652','2005-07-12T10:59:38.000','2200','518','2005-07-13T13:52:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6653','2005-07-12T11:06:17.000','614','25','2005-07-19T16:52:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6654','2005-07-12T11:06:28.000','2870','458','2005-07-20T10:27:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6655','2005-07-12T11:08:32.000','3937','100','2005-07-15T15:17:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6656','2005-07-12T11:09:47.000','2282','330','2005-07-14T05:50:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6657','2005-07-12T11:11:36.000','3697','553','2005-07-16T15:56:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6658','2005-07-12T11:13:21.000','172','27','2005-07-17T09:10:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6659','2005-07-12T11:18:05.000','2285','134','2005-07-16T16:45:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6660','2005-07-12T11:20:12.000','446','598','2005-07-20T12:58:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6661','2005-07-12T11:20:39.000','2367','315','2005-07-16T08:17:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6662','2005-07-12T11:21:06.000','1464','99','2005-07-13T13:00:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6663','2005-07-12T11:27:35.000','4364','5','2005-07-21T16:35:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6664','2005-07-12T11:28:22.000','4578','351','2005-07-15T09:30:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6665','2005-07-12T11:29:14.000','2912','587','2005-07-19T11:26:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6666','2005-07-12T11:32:15.000','3194','314','2005-07-14T16:09:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6667','2005-07-12T11:36:22.000','215','50','2005-07-19T12:53:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6668','2005-07-12T11:37:45.000','1498','199','2005-07-14T13:28:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6669','2005-07-12T11:39:55.000','1420','355','2005-07-20T05:56:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6670','2005-07-12T11:44:33.000','3106','249','2005-07-19T07:54:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6671','2005-07-12T11:48:48.000','955','526','2005-07-19T16:55:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6672','2005-07-12T11:49:16.000','375','439','2005-07-13T07:03:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6673','2005-07-12T11:50:56.000','1997','322','2005-07-13T14:27:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6674','2005-07-12T11:51:54.000','2385','399','2005-07-13T16:57:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6675','2005-07-12T11:53:06.000','2124','523','2005-07-13T06:09:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6676','2005-07-12T11:53:40.000','2294','571','2005-07-19T09:15:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6677','2005-07-12T11:58:14.000','2389','516','2005-07-21T06:05:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6678','2005-07-12T11:58:36.000','3473','330','2005-07-15T17:50:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6679','2005-07-12T12:01:07.000','3664','586','2005-07-14T11:36:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6680','2005-07-12T12:01:56.000','2887','43','2005-07-16T17:32:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6681','2005-07-12T12:04:12.000','854','368','2005-07-19T11:01:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6682','2005-07-12T12:12:43.000','1984','339','2005-07-21T10:49:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6683','2005-07-12T12:14:05.000','3433','244','2005-07-17T14:02:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6684','2005-07-12T12:14:42.000','2817','583','2005-07-21T11:07:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6685','2005-07-12T12:16:28.000','1434','5','2005-07-19T17:03:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6686','2005-07-12T12:18:38.000','3804','6','2005-07-13T17:56:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6687','2005-07-12T12:19:23.000','2736','128','2005-07-19T17:12:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6688','2005-07-12T12:22:12.000','2377','246','2005-07-14T14:05:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6689','2005-07-12T12:22:13.000','1568','525','2005-07-16T07:44:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6690','2005-07-12T12:23:02.000','4254','447','2005-07-16T15:39:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6691','2005-07-12T12:26:38.000','403','192','2005-07-18T13:26:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6692','2005-07-12T12:35:39.000','2837','372','2005-07-20T11:20:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6693','2005-07-12T12:37:00.000','2014','573','2005-07-20T09:36:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6694','2005-07-12T12:39:23.000','586','204','2005-07-19T14:47:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6695','2005-07-12T12:39:39.000','3088','550','2005-07-17T13:36:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6696','2005-07-12T12:44:04.000','299','273','2005-07-16T14:17:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6697','2005-07-12T12:44:57.000','210','103','2005-07-19T13:02:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6698','2005-07-12T12:45:00.000','4419','64','2005-07-16T11:16:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6699','2005-07-12T12:45:21.000','3411','565','2005-07-15T12:59:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6700','2005-07-12T12:47:22.000','3063','184','2005-07-21T16:04:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6701','2005-07-12T12:47:59.000','3428','454','2005-07-13T10:28:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6702','2005-07-12T12:48:03.000','233','164','2005-07-13T11:55:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6703','2005-07-12T12:50:19.000','46','470','2005-07-16T13:41:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6704','2005-07-12T12:50:24.000','1590','595','2005-07-20T16:41:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6705','2005-07-12T12:53:11.000','4268','363','2005-07-13T07:17:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6706','2005-07-12T12:59:16.000','4552','267','2005-07-19T10:37:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6707','2005-07-12T13:07:55.000','406','80','2005-07-16T16:26:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6708','2005-07-12T13:10:55.000','372','82','2005-07-21T07:36:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6709','2005-07-12T13:20:41.000','4049','322','2005-07-16T10:37:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6710','2005-07-12T13:23:09.000','806','462','2005-07-20T10:10:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6711','2005-07-12T13:23:40.000','2247','257','2005-07-20T11:45:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6712','2005-07-12T13:24:47.000','4581','226','2005-07-20T09:35:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6713','2005-07-12T13:27:36.000','4218','557','2005-07-16T11:14:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6714','2005-07-12T13:29:06.000','1947','370','2005-07-18T16:02:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6715','2005-07-12T13:32:28.000','643','386','2005-07-15T17:01:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6716','2005-07-12T13:34:58.000','2783','367','2005-07-19T15:09:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6717','2005-07-12T13:35:02.000','523','273','2005-07-20T15:03:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6718','2005-07-12T13:38:06.000','2283','541','2005-07-18T09:05:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6719','2005-07-12T13:40:37.000','739','330','2005-07-15T15:23:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6720','2005-07-12T13:41:16.000','2704','151','2005-07-13T14:41:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6721','2005-07-12T13:42:58.000','2798','462','2005-07-19T16:39:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6722','2005-07-12T13:44:03.000','3124','211','2005-07-19T12:43:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6723','2005-07-12T13:44:57.000','2678','499','2005-07-14T15:57:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6724','2005-07-12T13:45:15.000','2486','262','2005-07-19T19:18:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6725','2005-07-12T13:47:17.000','831','213','2005-07-17T13:31:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6726','2005-07-12T13:48:14.000','4494','97','2005-07-16T11:11:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6727','2005-07-12T13:54:25.000','3793','407','2005-07-14T17:29:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6728','2005-07-12T13:56:48.000','2113','414','2005-07-15T18:49:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6729','2005-07-12T13:58:23.000','2495','455','2005-07-19T09:34:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6730','2005-07-12T13:58:25.000','1552','532','2005-07-20T13:01:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6731','2005-07-12T13:58:27.000','844','593','2005-07-15T10:04:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6732','2005-07-12T13:58:51.000','1913','299','2005-07-17T17:42:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6733','2005-07-12T14:04:01.000','1476','585','2005-07-21T18:57:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6734','2005-07-12T14:04:24.000','2248','446','2005-07-21T19:47:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6735','2005-07-12T14:08:20.000','276','428','2005-07-18T09:41:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6736','2005-07-12T14:16:50.000','530','342','2005-07-15T16:26:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6737','2005-07-12T14:16:52.000','315','304','2005-07-18T19:48:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6738','2005-07-12T14:17:55.000','1197','366','2005-07-21T10:11:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6739','2005-07-12T14:22:08.000','1221','71','2005-07-18T16:57:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6740','2005-07-12T14:22:08.000','2431','139','2005-07-14T14:35:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6741','2005-07-12T14:24:16.000','237','359','2005-07-15T08:31:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6742','2005-07-12T14:25:31.000','4242','558','2005-07-17T08:50:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6743','2005-07-12T14:29:25.000','158','261','2005-07-13T13:13:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6744','2005-07-12T14:30:28.000','2565','64','2005-07-14T16:20:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6745','2005-07-12T14:30:51.000','1331','524','2005-07-13T13:42:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6746','2005-07-12T14:33:01.000','3127','537','2005-07-17T19:52:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6747','2005-07-12T14:33:21.000','3651','126','2005-07-13T09:59:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6748','2005-07-12T14:39:27.000','3655','540','2005-07-18T13:40:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6749','2005-07-12T14:43:05.000','2895','334','2005-07-21T15:13:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6750','2005-07-12T14:49:39.000','3838','459','2005-07-18T18:43:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6751','2005-07-12T14:50:34.000','1749','312','2005-07-15T19:39:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6752','2005-07-12T14:53:15.000','3392','453','2005-07-20T09:23:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6753','2005-07-12T14:55:42.000','2591','147','2005-07-18T19:16:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6754','2005-07-12T14:59:24.000','1460','114','2005-07-14T11:04:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6755','2005-07-12T15:07:49.000','2542','126','2005-07-21T18:43:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6756','2005-07-12T15:08:28.000','1174','531','2005-07-13T14:25:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6757','2005-07-12T15:09:48.000','547','558','2005-07-17T15:04:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6758','2005-07-12T15:13:49.000','4098','546','2005-07-20T09:31:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6759','2005-07-12T15:14:48.000','3624','49','2005-07-15T11:29:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6760','2005-07-12T15:16:00.000','501','502','2005-07-20T13:20:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6761','2005-07-12T15:17:42.000','3645','7','2005-07-18T17:59:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6762','2005-07-12T15:25:33.000','3857','262','2005-07-21T18:57:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6763','2005-07-12T15:26:34.000','3364','314','2005-07-18T16:38:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6764','2005-07-12T15:29:27.000','4407','396','2005-07-21T20:00:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6765','2005-07-12T15:30:47.000','2571','433','2005-07-19T14:19:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6766','2005-07-12T15:32:01.000','3615','171','2005-07-18T14:03:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6767','2005-07-12T15:46:55.000','1819','208','2005-07-17T17:36:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6768','2005-07-12T15:47:51.000','3418','151','2005-07-19T21:17:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6769','2005-07-12T15:48:54.000','1687','63','2005-07-21T14:39:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6770','2005-07-12T15:49:40.000','2080','360','2005-07-20T10:14:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6771','2005-07-12T15:54:40.000','1113','396','2005-07-17T15:56:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6772','2005-07-12T15:55:35.000','3810','89','2005-07-18T10:47:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6773','2005-07-12T15:55:39.000','3346','12','2005-07-18T17:52:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6774','2005-07-12T15:56:08.000','868','171','2005-07-13T18:42:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6775','2005-07-12T16:01:44.000','2909','383','2005-07-19T14:11:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6776','2005-07-12T16:02:09.000','2398','348','2005-07-20T16:31:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6777','2005-07-12T16:04:40.000','4089','351','2005-07-20T15:05:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6778','2005-07-12T16:06:00.000','4503','381','2005-07-14T21:57:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6779','2005-07-12T16:10:50.000','4468','404','2005-07-17T14:51:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6780','2005-07-12T16:18:12.000','1255','121','2005-07-13T17:56:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6781','2005-07-12T16:21:47.000','3783','533','2005-07-15T19:52:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6782','2005-07-12T16:23:25.000','2742','199','2005-07-20T18:46:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6783','2005-07-12T16:27:56.000','3633','506','2005-07-13T12:11:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6784','2005-07-12T16:28:49.000','197','578','2005-07-15T17:27:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6785','2005-07-12T16:30:57.000','4448','69','2005-07-18T20:46:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6786','2005-07-12T16:32:33.000','2011','546','2005-07-16T12:42:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6787','2005-07-12T16:33:28.000','1481','342','2005-07-18T21:48:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6788','2005-07-12T16:33:44.000','1162','460','2005-07-20T15:38:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6789','2005-07-12T16:34:40.000','1973','76','2005-07-14T17:02:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6790','2005-07-12T16:34:59.000','4486','400','2005-07-17T21:43:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6791','2005-07-12T16:35:07.000','1495','144','2005-07-20T15:32:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6792','2005-07-12T16:37:28.000','510','571','2005-07-20T11:20:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6793','2005-07-12T16:37:55.000','103','148','2005-07-21T16:04:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6794','2005-07-12T16:38:23.000','813','233','2005-07-20T17:36:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6795','2005-07-12T16:41:00.000','1489','245','2005-07-21T20:52:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6796','2005-07-12T16:44:16.000','227','291','2005-07-16T14:48:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6797','2005-07-12T16:47:06.000','1536','469','2005-07-14T14:38:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6798','2005-07-12T16:49:11.000','275','115','2005-07-19T12:11:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6799','2005-07-12T16:52:13.000','2778','42','2005-07-14T15:11:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6800','2005-07-12T17:03:56.000','3742','599','2005-07-21T20:32:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6801','2005-07-12T17:09:08.000','872','500','2005-07-21T22:25:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6802','2005-07-12T17:14:17.000','2942','298','2005-07-17T11:54:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6803','2005-07-12T17:21:49.000','2676','490','2005-07-14T18:01:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6804','2005-07-12T17:22:06.000','1554','269','2005-07-21T11:37:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6805','2005-07-12T17:23:01.000','1758','262','2005-07-21T19:38:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6806','2005-07-12T17:31:43.000','656','179','2005-07-17T14:36:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6807','2005-07-12T17:33:53.000','669','376','2005-07-18T16:28:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6808','2005-07-12T17:36:42.000','362','263','2005-07-18T23:33:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6809','2005-07-12T17:51:54.000','3455','168','2005-07-17T15:10:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6810','2005-07-12T17:54:19.000','2802','485','2005-07-20T16:58:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6811','2005-07-12T17:54:33.000','1572','107','2005-07-20T17:39:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6812','2005-07-12T18:03:25.000','2227','553','2005-07-20T18:33:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6813','2005-07-12T18:03:50.000','135','54','2005-07-16T16:30:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6814','2005-07-12T18:11:58.000','1863','579','2005-07-18T20:37:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6815','2005-07-12T18:14:10.000','3236','468','2005-07-17T14:16:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6816','2005-07-12T18:18:50.000','2963','290','2005-07-18T21:09:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6817','2005-07-12T18:19:57.000','184','135','2005-07-19T22:53:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6818','2005-07-12T18:20:54.000','1013','153','2005-07-21T00:03:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6819','2005-07-12T18:21:01.000','1253','198','2005-07-13T21:14:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6820','2005-07-12T18:21:30.000','223','243','2005-07-14T15:14:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6821','2005-07-12T18:22:10.000','623','363','2005-07-14T13:25:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6822','2005-07-12T18:23:39.000','1592','300','2005-07-19T21:06:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6823','2005-07-12T18:24:31.000','795','557','2005-07-17T23:13:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6824','2005-07-12T18:26:46.000','858','579','2005-07-21T15:23:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6825','2005-07-12T18:28:12.000','2342','281','2005-07-15T19:24:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6826','2005-07-12T18:32:02.000','1708','408','2005-07-16T23:21:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6827','2005-07-12T18:33:45.000','1529','283','2005-07-13T19:09:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6828','2005-07-12T18:38:51.000','874','502','2005-07-14T20:10:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6829','2005-07-12T18:38:59.000','4184','361','2005-07-16T23:25:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6830','2005-07-12T18:42:55.000','1943','578','2005-07-17T17:58:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6831','2005-07-12T18:44:04.000','924','163','2005-07-16T21:39:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6832','2005-07-12T18:51:41.000','444','220','2005-07-20T13:29:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6833','2005-07-12T18:53:34.000','912','301','2005-07-19T22:21:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6834','2005-07-12T18:53:37.000','897','533','2005-07-19T13:42:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6835','2005-07-12T18:58:03.000','1444','367','2005-07-18T00:41:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6836','2005-07-12T18:58:05.000','2744','113','2005-07-15T17:45:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6837','2005-07-12T18:59:45.000','1203','533','2005-07-21T22:47:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6838','2005-07-12T19:01:30.000','3492','354','2005-07-17T23:42:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6839','2005-07-12T19:03:19.000','3900','357','2005-07-15T23:48:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6840','2005-07-12T19:03:22.000','1381','323','2005-07-21T18:34:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6841','2005-07-12T19:04:24.000','2265','108','2005-07-14T23:58:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6842','2005-07-12T19:07:55.000','3376','366','2005-07-19T22:47:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6843','2005-07-12T19:14:05.000','746','561','2005-07-20T23:15:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6844','2005-07-12T19:14:53.000','3211','482','2005-07-18T16:07:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6845','2005-07-12T19:20:41.000','3833','414','2005-07-14T15:27:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6846','2005-07-12T19:20:45.000','1214','18','2005-07-17T00:06:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6847','2005-07-12T19:22:37.000','346','63','2005-07-21T18:53:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6848','2005-07-12T19:24:07.000','1782','433','2005-07-14T17:03:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6849','2005-07-12T19:29:19.000','4307','479','2005-07-19T22:03:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6850','2005-07-12T19:30:42.000','1145','433','2005-07-17T21:26:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6851','2005-07-12T19:32:14.000','664','280','2005-07-17T21:03:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6852','2005-07-12T19:33:49.000','2182','75','2005-07-13T20:01:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6853','2005-07-12T19:38:11.000','4006','299','2005-07-20T00:14:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6854','2005-07-12T19:38:57.000','3173','151','2005-07-16T16:28:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6855','2005-07-12T19:46:29.000','2657','24','2005-07-15T16:56:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6856','2005-07-12T19:50:16.000','4338','275','2005-07-14T22:25:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6857','2005-07-12T19:53:30.000','424','196','2005-07-13T15:22:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6858','2005-07-12T19:53:51.000','1095','516','2005-07-19T14:12:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6859','2005-07-12T19:53:57.000','4108','321','2005-07-17T19:48:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6860','2005-07-12T19:54:17.000','2907','91','2005-07-18T13:59:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6861','2005-07-12T19:56:52.000','354','83','2005-07-13T16:02:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6862','2005-07-12T19:58:09.000','3477','231','2005-07-18T15:48:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6863','2005-07-12T19:58:34.000','229','484','2005-07-21T16:57:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6864','2005-07-12T19:59:25.000','2252','38','2005-07-19T15:52:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6865','2005-07-12T20:02:40.000','1428','175','2005-07-20T00:39:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6866','2005-07-12T20:03:44.000','2481','312','2005-07-15T01:55:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6867','2005-07-12T20:06:47.000','3354','190','2005-07-19T16:59:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6868','2005-07-12T20:10:17.000','719','306','2005-07-15T22:34:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6869','2005-07-12T20:12:06.000','3546','278','2005-07-13T18:37:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6870','2005-07-12T20:13:45.000','3102','13','2005-07-16T22:09:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6871','2005-07-12T20:13:49.000','3612','204','2005-07-14T20:11:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6872','2005-07-12T20:15:04.000','3246','86','2005-07-18T18:19:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6873','2005-07-12T20:20:50.000','802','161','2005-07-17T01:51:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6874','2005-07-12T20:20:53.000','4478','539','2005-07-19T19:41:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6875','2005-07-12T20:23:05.000','3420','172','2005-07-19T00:09:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6876','2005-07-12T20:32:50.000','34','531','2005-07-16T21:12:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6877','2005-07-12T20:32:58.000','3968','231','2005-07-18T18:01:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6878','2005-07-12T20:37:13.000','2428','363','2005-07-19T20:13:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6879','2005-07-12T20:37:37.000','1901','416','2005-07-20T15:40:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6880','2005-07-12T20:41:35.000','1473','229','2005-07-17T02:22:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6881','2005-07-12T20:46:35.000','2496','346','2005-07-21T00:26:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6882','2005-07-12T20:50:39.000','2469','166','2005-07-14T21:01:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6883','2005-07-12T20:50:48.000','468','596','2005-07-19T16:00:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6884','2005-07-12T20:52:41.000','3642','17','2005-07-20T23:13:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6885','2005-07-12T20:56:04.000','3972','159','2005-07-15T19:21:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6886','2005-07-12T20:58:04.000','4533','429','2005-07-18T16:56:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6887','2005-07-12T21:00:23.000','4487','542','2005-07-21T17:46:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6888','2005-07-12T21:01:11.000','1896','490','2005-07-17T21:49:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6889','2005-07-12T21:01:22.000','2919','198','2005-07-20T20:16:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6890','2005-07-12T21:03:03.000','2538','473','2005-07-14T00:47:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6891','2005-07-12T21:07:35.000','3189','507','2005-07-14T16:59:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6892','2005-07-12T21:10:04.000','1567','138','2005-07-13T23:03:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6893','2005-07-12T21:20:11.000','2611','377','2005-07-21T18:55:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6894','2005-07-12T21:20:50.000','1347','315','2005-07-20T23:42:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6895','2005-07-12T21:23:59.000','2935','599','2005-07-19T20:47:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6896','2005-07-12T21:25:37.000','1266','111','2005-07-20T23:51:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6897','2005-07-12T21:30:41.000','170','13','2005-07-15T03:19:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6898','2005-07-12T21:39:04.000','1725','557','2005-07-15T20:30:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6899','2005-07-12T21:44:16.000','3565','483','2005-07-21T22:21:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6900','2005-07-12T21:45:25.000','129','292','2005-07-19T21:19:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6901','2005-07-12T21:46:33.000','4574','158','2005-07-16T21:36:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6902','2005-07-12T21:57:16.000','314','485','2005-07-14T20:56:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6903','2005-07-12T21:58:15.000','3690','517','2005-07-14T01:38:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6904','2005-07-12T22:02:09.000','2312','465','2005-07-17T16:42:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6905','2005-07-12T22:02:18.000','763','25','2005-07-18T23:30:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6906','2005-07-12T22:03:02.000','1435','335','2005-07-15T00:35:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6907','2005-07-12T22:03:49.000','2516','575','2005-07-18T19:18:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6908','2005-07-12T22:08:46.000','3161','529','2005-07-21T00:21:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6909','2005-07-12T22:09:30.000','769','174','2005-07-17T02:05:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6910','2005-07-12T22:11:21.000','1290','546','2005-07-21T02:35:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6911','2005-07-12T22:14:34.000','901','361','2005-07-18T20:17:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6912','2005-07-12T22:17:16.000','1701','471','2005-07-19T18:18:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6913','2005-07-12T22:18:12.000','569','443','2005-07-14T23:03:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6914','2005-07-12T22:26:56.000','496','361','2005-07-17T20:03:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6915','2005-07-12T22:28:09.000','1243','559','2005-07-14T00:53:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6916','2005-07-12T22:29:18.000','3311','88','2005-07-19T16:46:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6917','2005-07-12T22:30:15.000','3048','23','2005-07-20T03:20:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6918','2005-07-12T22:30:29.000','4085','140','2005-07-19T22:51:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6919','2005-07-12T22:32:17.000','1122','540','2005-07-18T20:09:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6920','2005-07-12T22:32:58.000','2301','109','2005-07-19T20:29:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6921','2005-07-12T22:39:03.000','3322','265','2005-07-21T18:54:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6922','2005-07-12T22:39:48.000','1114','371','2005-07-14T18:35:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6923','2005-07-12T22:40:48.000','2642','490','2005-07-19T23:07:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6924','2005-07-26T22:51:53.000','1257','502','2005-08-03T19:04:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6925','2005-07-26T22:52:32.000','2919','42','2005-07-29T21:22:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6926','2005-07-26T22:52:45.000','1276','354','2005-07-28T18:32:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6927','2005-07-26T22:56:00.000','4511','470','2005-08-05T03:16:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6928','2005-07-26T22:56:21.000','3605','487','2005-07-30T04:46:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6929','2005-07-26T22:59:19.000','3339','508','2005-08-03T22:40:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6930','2005-07-26T23:00:01.000','2989','393','2005-08-04T01:57:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6931','2005-07-26T23:02:57.000','2794','333','2005-07-28T04:48:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6932','2005-07-26T23:08:04.000','4517','463','2005-08-05T01:35:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6933','2005-07-26T23:09:23.000','1334','385','2005-07-31T20:50:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6934','2005-07-26T23:11:03.000','455','107','2005-08-04T19:18:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6935','2005-07-26T23:13:10.000','2771','435','2005-07-27T18:09:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6936','2005-07-26T23:13:34.000','60','538','2005-07-30T19:14:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6937','2005-07-26T23:15:50.000','1768','592','2005-07-27T19:14:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6938','2005-07-26T23:16:04.000','2058','427','2005-08-05T00:59:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6939','2005-07-26T23:17:51.000','278','354','2005-08-03T21:12:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6940','2005-07-26T23:18:35.000','3876','149','2005-08-05T01:44:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6941','2005-07-26T23:18:49.000','1575','441','2005-07-31T00:23:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6942','2005-07-26T23:27:40.000','1203','470','2005-07-31T03:17:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6943','2005-07-26T23:28:13.000','2436','21','2005-07-30T02:22:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6944','2005-07-26T23:34:02.000','1168','373','2005-08-05T01:27:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6945','2005-07-26T23:35:29.000','1627','560','2005-07-28T00:12:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6946','2005-07-26T23:40:07.000','1854','181','2005-08-04T01:18:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6947','2005-07-26T23:42:03.000','760','200','2005-08-02T05:06:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6948','2005-07-26T23:43:49.000','3088','228','2005-07-27T21:24:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6949','2005-07-26T23:44:12.000','1594','103','2005-07-30T05:39:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6950','2005-07-26T23:45:33.000','197','503','2005-07-31T04:40:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6951','2005-07-26T23:47:31.000','3348','98','2005-07-31T22:17:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6952','2005-07-26T23:51:27.000','4288','290','2005-07-30T02:45:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6953','2005-07-26T23:52:47.000','2910','306','2005-07-30T23:07:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6954','2005-07-26T23:55:13.000','1112','584','2005-07-28T19:01:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6955','2005-07-26T23:55:48.000','1104','469','2005-08-02T03:25:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6956','2005-07-26T23:55:57.000','2499','240','2005-08-03T21:41:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6957','2005-07-27T00:00:00.000','2231','518','2005-07-29T19:32:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6958','2005-07-27T00:02:41.000','657','333','2005-07-28T00:53:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6959','2005-07-27T00:07:51.000','1618','452','2005-07-27T20:45:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6960','2005-07-27T00:08:33.000','192','421','2005-08-03T20:58:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6961','2005-07-27T00:10:49.000','2205','38','2005-07-30T00:26:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6962','2005-07-27T00:10:58.000','4500','245','2005-07-30T02:11:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6963','2005-07-27T00:13:02.000','4284','489','2005-08-03T18:13:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6964','2005-07-27T00:15:04.000','1537','404','2005-07-31T00:04:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6965','2005-07-27T00:15:18.000','74','185','2005-07-28T04:30:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6966','2005-07-27T00:15:35.000','1577','45','2005-08-05T03:04:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6967','2005-07-27T00:16:31.000','1145','296','2005-08-03T22:19:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6968','2005-07-27T00:16:45.000','1662','370','2005-07-30T23:16:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6969','2005-07-27T00:23:54.000','2650','579','2005-08-03T04:34:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6970','2005-07-27T00:26:14.000','17','418','2005-08-03T20:00:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6971','2005-07-27T00:26:17.000','3493','366','2005-08-01T03:59:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6972','2005-07-27T00:31:25.000','1716','434','2005-07-28T22:15:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6973','2005-07-27T00:32:04.000','4572','564','2005-07-29T01:05:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6974','2005-07-27T00:39:16.000','2924','122','2005-08-04T01:59:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6975','2005-07-27T00:39:54.000','3328','527','2005-08-02T19:49:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6976','2005-07-27T00:40:01.000','3096','41','2005-07-31T22:30:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6977','2005-07-27T00:40:50.000','3545','429','2005-08-02T19:08:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6978','2005-07-27T00:47:40.000','3645','132','2005-07-31T04:32:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6979','2005-07-27T00:49:53.000','1001','141','2005-07-31T03:59:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6980','2005-07-27T00:50:30.000','1127','164','2005-08-03T23:35:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6981','2005-07-27T00:51:38.000','154','362','2005-07-28T01:06:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6982','2005-07-27T00:53:41.000','3843','284','2005-07-31T06:19:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6983','2005-07-27T00:55:03.000','1758','443','2005-08-01T21:19:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6984','2005-07-27T00:56:30.000','2407','297','2005-08-02T01:14:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6985','2005-07-27T00:57:42.000','1834','448','2005-07-31T00:53:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6986','2005-07-27T00:59:05.000','2104','262','2005-07-29T00:31:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6987','2005-07-27T00:59:50.000','3134','334','2005-07-28T01:47:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6988','2005-07-27T01:00:08.000','756','316','2005-07-31T04:35:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6989','2005-07-27T01:00:34.000','4036','120','2005-07-30T23:53:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6990','2005-07-27T01:02:46.000','4065','146','2005-07-31T00:22:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6991','2005-07-27T01:03:06.000','319','307','2005-08-05T04:18:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6992','2005-07-27T01:04:45.000','3411','106','2005-07-28T02:34:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6993','2005-07-27T01:05:24.000','3114','154','2005-07-30T06:23:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6994','2005-07-27T01:08:26.000','4316','400','2005-08-04T22:58:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6995','2005-07-27T01:12:13.000','1630','66','2005-07-29T21:26:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6996','2005-07-27T01:13:45.000','3237','236','2005-07-28T20:43:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6997','2005-07-27T01:14:02.000','2130','342','2005-07-29T01:12:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6998','2005-07-27T01:16:29.000','788','300','2005-07-30T05:50:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('6999','2005-07-27T01:21:19.000','12','224','2005-07-29T20:33:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7000','2005-07-27T01:23:24.000','2024','31','2005-08-03T02:10:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7001','2005-07-27T01:25:34.000','1460','240','2005-07-31T23:30:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7002','2005-07-27T01:26:14.000','4157','349','2005-08-01T20:10:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7003','2005-07-27T01:32:06.000','636','161','2005-07-30T21:33:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7004','2005-07-27T01:36:05.000','4416','314','2005-08-03T23:46:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7005','2005-07-27T01:38:36.000','2438','446','2005-08-02T05:56:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7006','2005-07-27T01:42:20.000','3522','264','2005-08-03T03:19:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7007','2005-07-27T01:43:39.000','4186','257','2005-07-31T21:04:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7008','2005-07-27T01:44:03.000','3659','12','2005-07-28T21:19:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7009','2005-07-27T01:45:44.000','1585','414','2005-07-28T05:50:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7010','2005-07-27T01:56:01.000','3016','590','2005-07-30T04:40:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7011','2005-07-27T01:58:34.000','4082','254','2005-07-28T06:11:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7012','2005-07-27T02:01:03.000','779','239','2005-08-05T07:34:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7013','2005-07-27T02:03:21.000','3919','463','2005-07-31T22:12:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7014','2005-07-27T02:14:40.000','714','524','2005-08-03T00:32:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7015','2005-07-27T02:15:01.000','376','34','2005-07-28T07:46:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7016','2005-07-27T02:15:16.000','1425','423','2005-08-01T23:08:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7017','2005-07-27T02:16:03.000','753','176','2005-07-31T07:49:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7018','2005-07-27T02:20:22.000','1078','451','2005-08-02T05:04:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7019','2005-07-27T02:20:26.000','3837','491','2005-08-02T22:48:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7020','2005-07-27T02:24:27.000','3965','506','2005-07-29T01:27:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7021','2005-07-27T02:26:38.000','2690','380','2005-08-05T01:18:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7022','2005-07-27T02:31:15.000','1711','243','2005-07-29T02:52:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7023','2005-07-27T02:32:44.000','4196','303','2005-08-03T04:06:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7024','2005-07-27T02:36:40.000','3113','252','2005-07-28T06:58:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7025','2005-07-27T02:40:29.000','3530','176','2005-07-29T23:02:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7026','2005-07-27T02:48:58.000','3456','493','2005-07-29T03:41:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7027','2005-07-27T02:50:15.000','3280','61','2005-08-04T02:58:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7028','2005-07-27T02:54:25.000','834','179','2005-08-02T06:16:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7029','2005-07-27T02:57:43.000','2862','389','2005-07-30T08:24:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7030','2005-07-27T03:01:40.000','1277','550','2005-07-31T07:01:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7031','2005-07-27T03:02:07.000','1435','530','2005-08-02T07:14:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7032','2005-07-27T03:03:09.000','3397','269','2005-07-28T22:57:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7033','2005-07-27T03:03:25.000','2803','352','2005-07-28T01:57:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7034','2005-07-27T03:03:37.000','1712','281','2005-07-28T23:18:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7035','2005-07-27T03:06:09.000','2439','90','2005-08-02T21:59:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7036','2005-07-27T03:06:12.000','2569','70','2005-07-28T23:26:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7037','2005-07-27T03:06:44.000','3155','171','2005-08-02T04:51:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7038','2005-07-27T03:07:29.000','1909','518','2005-07-31T04:55:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7039','2005-07-27T03:11:48.000','1906','99','2005-08-01T23:55:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7040','2005-07-27T03:17:19.000','470','524','2005-07-29T07:03:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7041','2005-07-27T03:18:32.000','4212','379','2005-07-30T06:40:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7042','2005-07-27T03:20:18.000','399','188','2005-08-01T02:23:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7043','2005-07-27T03:24:23.000','3422','493','2005-08-05T02:55:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7044','2005-07-27T03:27:29.000','88','147','2005-08-01T07:00:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7045','2005-07-27T03:27:35.000','1788','64','2005-08-01T06:31:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7046','2005-07-27T03:27:56.000','3740','349','2005-07-30T00:54:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7047','2005-07-27T03:31:11.000','2866','236','2005-08-03T23:40:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7048','2005-07-27T03:31:48.000','3707','581','2005-08-05T07:30:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7049','2005-07-27T03:32:41.000','3043','332','2005-08-04T08:32:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7050','2005-07-27T03:33:17.000','1135','55','2005-08-02T03:12:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7051','2005-07-27T03:34:37.000','1310','184','2005-07-31T03:48:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7052','2005-07-27T03:36:38.000','3798','75','2005-08-03T21:51:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7053','2005-07-27T03:38:54.000','149','408','2005-07-31T01:13:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7054','2005-07-27T03:43:28.000','2661','179','2005-08-04T09:15:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7055','2005-07-27T03:45:42.000','4305','154','2005-07-30T05:11:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7056','2005-07-27T03:46:27.000','805','233','2005-08-05T07:46:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7057','2005-07-27T03:50:03.000','1196','320','2005-08-04T04:36:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7058','2005-07-27T03:50:46.000','716','90','2005-08-04T07:40:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7059','2005-07-27T03:51:02.000','129','578','2005-08-02T22:04:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7060','2005-07-27T03:51:04.000','3912','479','2005-08-03T07:53:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7061','2005-07-27T03:51:10.000','880','145','2005-07-31T05:36:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7062','2005-07-27T03:52:01.000','226','469','2005-08-03T08:26:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7063','2005-07-27T03:52:27.000','2125','58','2005-08-04T07:53:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7064','2005-07-27T03:53:29.000','4204','320','2005-08-03T06:32:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7065','2005-07-27T03:53:43.000','3570','536','2005-07-30T23:41:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7066','2005-07-27T03:53:52.000','1862','185','2005-08-05T03:32:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7067','2005-07-27T03:55:10.000','870','60','2005-08-01T02:56:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7068','2005-07-27T03:57:50.000','4465','568','2005-07-30T04:27:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7069','2005-07-27T03:59:35.000','2073','343','2005-08-05T03:33:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7070','2005-07-27T04:01:08.000','4182','280','2005-07-30T08:10:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7071','2005-07-27T04:01:15.000','4361','61','2005-08-03T05:18:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7072','2005-07-27T04:02:33.000','3899','260','2005-07-28T09:26:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7073','2005-07-27T04:03:26.000','3859','92','2005-08-03T05:50:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7074','2005-07-27T04:06:24.000','1390','165','2005-07-28T02:04:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7075','2005-07-27T04:11:40.000','4414','530','2005-08-03T08:16:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7076','2005-07-27T04:12:14.000','2821','333','2005-08-05T00:44:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7077','2005-07-27T04:13:02.000','3186','155','2005-07-31T23:15:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7078','2005-07-27T04:16:37.000','4518','545','2005-08-05T02:34:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7079','2005-07-27T04:21:58.000','4356','356','2005-08-04T08:08:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7080','2005-07-27T04:25:25.000','710','466','2005-08-04T04:22:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7081','2005-07-27T04:25:59.000','462','420','2005-08-01T00:14:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7082','2005-07-27T04:27:32.000','2032','64','2005-07-30T06:06:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7083','2005-07-27T04:28:39.000','2663','575','2005-07-30T04:35:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7084','2005-07-27T04:34:07.000','785','32','2005-08-05T00:21:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7085','2005-07-27T04:35:44.000','2603','223','2005-08-05T07:10:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7086','2005-07-27T04:39:46.000','2938','595','2005-08-05T00:32:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7087','2005-07-27T04:42:08.000','1159','22','2005-08-02T00:53:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7088','2005-07-27T04:42:28.000','373','88','2005-08-04T07:09:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7089','2005-07-27T04:43:42.000','1380','446','2005-07-30T10:04:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7090','2005-07-27T04:43:53.000','3495','218','2005-07-29T07:33:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7091','2005-07-27T04:44:10.000','2593','322','2005-07-31T07:14:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7092','2005-07-27T04:46:00.000','1433','345','2005-08-03T07:22:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7093','2005-07-27T04:47:00.000','3065','574','2005-07-31T10:15:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7094','2005-07-27T04:47:33.000','867','373','2005-07-31T04:07:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7095','2005-07-27T04:51:15.000','1008','551','2005-08-05T10:25:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7096','2005-07-27T04:54:42.000','2575','3','2005-08-03T01:42:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7097','2005-07-27T04:56:09.000','258','487','2005-07-31T05:47:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7098','2005-07-27T05:01:08.000','2555','359','2005-08-02T07:49:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7099','2005-07-27T05:03:44.000','3136','6','2005-07-29T00:12:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7100','2005-07-27T05:05:01.000','4224','413','2005-07-28T23:12:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7101','2005-07-27T05:06:34.000','2006','221','2005-07-29T06:12:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7102','2005-07-27T05:07:21.000','1081','411','2005-08-01T09:41:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7103','2005-07-27T05:08:59.000','1697','403','2005-07-29T03:42:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7104','2005-07-27T05:15:25.000','118','217','2005-08-01T05:36:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7105','2005-07-27T05:15:37.000','864','15','2005-07-28T05:49:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7106','2005-07-27T05:21:24.000','1415','201','2005-08-02T01:58:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7107','2005-07-27T05:22:04.000','1883','104','2005-08-02T06:38:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7108','2005-07-27T05:28:32.000','2720','355','2005-07-31T07:52:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7109','2005-07-27T05:28:57.000','1658','406','2005-08-04T10:41:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7110','2005-07-27T05:30:48.000','3289','157','2005-07-28T01:43:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7111','2005-07-27T05:38:16.000','1252','473','2005-07-29T04:28:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7112','2005-07-27T05:38:42.000','4056','101','2005-08-03T05:35:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7113','2005-07-27T05:41:20.000','1963','534','2005-07-30T04:50:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7114','2005-07-27T05:42:13.000','3892','121','2005-07-29T01:59:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7115','2005-07-27T05:42:58.000','3620','359','2005-08-02T05:35:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7116','2005-07-27T05:46:43.000','1755','209','2005-08-05T05:54:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7117','2005-07-27T05:48:36.000','2772','326','2005-08-01T00:33:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7118','2005-07-27T05:53:50.000','582','591','2005-08-05T04:19:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7119','2005-07-27T05:55:32.000','1732','102','2005-07-29T03:19:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7120','2005-07-27T05:56:39.000','416','98','2005-08-04T10:57:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7121','2005-07-27T05:58:32.000','1264','252','2005-07-29T06:14:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7122','2005-07-27T06:03:18.000','1699','172','2005-08-04T10:43:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7123','2005-07-27T06:08:48.000','134','232','2005-08-04T05:26:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7124','2005-07-27T06:09:30.000','3449','34','2005-08-02T09:31:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7125','2005-07-27T06:11:00.000','801','460','2005-08-04T09:41:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7126','2005-07-27T06:13:13.000','3240','582','2005-07-28T08:22:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7127','2005-07-27T06:13:48.000','273','486','2005-08-01T02:50:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7128','2005-07-27T06:14:36.000','143','529','2005-08-02T05:18:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7129','2005-07-27T06:18:01.000','1930','221','2005-07-28T02:38:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7130','2005-07-27T06:23:36.000','420','81','2005-07-28T10:23:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7131','2005-07-27T06:25:06.000','2832','585','2005-07-31T09:07:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7132','2005-07-27T06:28:34.000','3201','227','2005-08-05T06:02:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7133','2005-07-27T06:29:23.000','2995','496','2005-07-29T03:20:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7134','2005-07-27T06:33:06.000','1058','574','2005-07-28T06:15:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7135','2005-07-27T06:34:32.000','2959','172','2005-07-28T03:01:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7136','2005-07-27T06:38:25.000','1929','6','2005-08-03T05:13:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7137','2005-07-27T06:40:41.000','3957','483','2005-07-29T09:05:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7138','2005-07-27T06:47:13.000','1418','31','2005-08-03T01:12:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7139','2005-07-27T06:52:21.000','846','575','2005-07-30T01:45:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7140','2005-07-27T06:54:12.000','2028','35','2005-08-03T10:36:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7141','2005-07-27T06:55:27.000','3579','423','2005-08-01T11:10:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7142','2005-07-27T06:55:39.000','1743','396','2005-07-28T01:41:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7143','2005-07-27T06:56:31.000','2877','91','2005-07-31T04:38:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7144','2005-07-27T07:00:37.000','4506','485','2005-08-01T06:57:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7145','2005-07-27T07:01:00.000','3653','109','2005-07-31T02:31:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7146','2005-07-27T07:02:30.000','2245','323','2005-08-05T10:29:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7147','2005-07-27T07:02:34.000','990','192','2005-08-01T02:16:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7148','2005-07-27T07:04:09.000','1783','354','2005-08-03T10:20:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7149','2005-07-27T07:10:40.000','3902','242','2005-08-03T07:37:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7150','2005-07-27T07:11:14.000','457','191','2005-08-05T06:55:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7151','2005-07-27T07:14:31.000','1259','289','2005-08-01T01:35:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7152','2005-07-27T07:15:01.000','2338','370','2005-08-05T04:50:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7153','2005-07-27T07:15:38.000','2657','41','2005-07-28T09:56:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7154','2005-07-27T07:16:17.000','2019','518','2005-07-28T04:04:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7155','2005-07-27T07:18:46.000','171','23','2005-08-04T10:28:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7156','2005-07-27T07:19:34.000','34','154','2005-07-31T04:31:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7157','2005-07-27T07:20:28.000','1353','423','2005-08-02T07:19:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7158','2005-07-27T07:23:58.000','2432','38','2005-08-03T06:00:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7159','2005-07-27T07:24:00.000','1220','158','2005-08-05T11:13:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7160','2005-07-27T07:26:06.000','3905','71','2005-07-31T04:54:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7161','2005-07-27T07:26:32.000','378','572','2005-08-03T01:26:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7162','2005-07-27T07:32:45.000','2251','289','2005-07-30T03:48:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7163','2005-07-27T07:36:11.000','3666','38','2005-08-04T06:03:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7164','2005-07-27T07:36:34.000','527','284','2005-08-04T05:05:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7165','2005-07-27T07:36:46.000','497','243','2005-07-30T09:22:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7166','2005-07-27T07:36:56.000','1375','562','2005-08-02T03:46:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7167','2005-07-27T07:37:26.000','238','380','2005-08-03T06:39:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7168','2005-07-27T07:51:11.000','6','252','2005-08-01T04:08:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7169','2005-07-27T07:51:39.000','735','559','2005-08-01T06:42:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7170','2005-07-27T07:58:26.000','370','140','2005-07-28T02:30:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7171','2005-07-27T07:58:35.000','4381','406','2005-08-03T07:45:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7172','2005-07-27T07:59:16.000','2405','362','2005-08-01T04:46:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7173','2005-07-27T07:59:24.000','177','592','2005-07-28T02:23:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7174','2005-07-27T08:00:36.000','46','570','2005-08-01T03:11:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7175','2005-07-27T08:03:22.000','568','190','2005-08-01T02:47:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7176','2005-07-27T08:04:28.000','227','257','2005-07-29T14:00:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7177','2005-07-27T08:07:39.000','3818','133','2005-07-30T03:17:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7178','2005-07-27T08:09:25.000','1899','31','2005-07-29T13:00:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7179','2005-07-27T08:10:29.000','2365','537','2005-07-28T12:24:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7180','2005-07-27T08:14:34.000','460','215','2005-07-31T05:24:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7181','2005-07-27T08:14:34.000','2788','130','2005-07-28T03:09:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7182','2005-07-27T08:15:38.000','3209','97','2005-08-03T12:48:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7183','2005-07-27T08:18:38.000','3384','302','2005-08-01T03:24:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7184','2005-07-27T08:22:26.000','2324','457','2005-08-02T09:34:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7185','2005-07-27T08:23:54.000','2340','121','2005-07-30T09:50:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7186','2005-07-27T08:26:12.000','4005','584','2005-07-28T12:21:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7187','2005-07-27T08:27:58.000','2733','169','2005-08-05T09:05:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7188','2005-07-27T08:32:08.000','2199','259','2005-07-28T08:02:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7189','2005-07-27T08:35:02.000','4419','151','2005-07-30T14:00:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7190','2005-07-27T08:36:01.000','1330','372','2005-07-30T08:32:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7191','2005-07-27T08:36:15.000','4292','495','2005-08-03T08:54:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7192','2005-07-27T08:36:55.000','4329','532','2005-07-30T11:58:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7193','2005-07-27T08:37:00.000','1801','237','2005-07-30T12:51:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7194','2005-07-27T08:39:58.000','254','172','2005-08-01T03:12:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7195','2005-07-27T08:47:01.000','721','157','2005-07-30T08:40:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7196','2005-07-27T08:49:08.000','2998','118','2005-07-29T03:54:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7197','2005-07-27T08:49:32.000','2109','577','2005-07-31T13:50:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7198','2005-07-27T08:50:07.000','4283','520','2005-08-04T09:46:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7199','2005-07-27T08:53:23.000','3685','292','2005-08-03T10:01:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7200','2005-07-27T08:57:38.000','4406','78','2005-08-02T12:29:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7201','2005-07-27T08:57:40.000','482','598','2005-08-04T09:55:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7202','2005-07-27T09:00:20.000','109','560','2005-08-04T03:09:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7203','2005-07-27T09:01:23.000','1685','492','2005-08-04T14:14:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7204','2005-07-27T09:02:31.000','2512','531','2005-08-03T08:56:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7205','2005-07-27T09:06:13.000','2828','36','2005-08-05T07:11:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7206','2005-07-27T09:07:05.000','3752','373','2005-07-31T03:13:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7207','2005-07-27T09:13:26.000','336','51','2005-08-01T10:24:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7208','2005-07-27T09:16:28.000','1523','138','2005-07-28T09:40:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7209','2005-07-27T09:16:53.000','3766','49','2005-07-30T08:09:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7210','2005-07-27T09:19:05.000','1984','176','2005-07-28T04:35:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7211','2005-07-27T09:20:00.000','4445','285','2005-08-02T14:53:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7212','2005-07-27T09:21:22.000','2905','591','2005-08-01T04:47:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7213','2005-07-27T09:22:29.000','2836','502','2005-08-03T13:53:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7214','2005-07-27T09:23:33.000','802','309','2005-08-03T13:14:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7215','2005-07-27T09:24:00.000','2713','473','2005-08-05T07:37:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7216','2005-07-27T09:27:45.000','1812','292','2005-08-03T13:08:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7217','2005-07-27T09:31:44.000','2646','20','2005-07-29T10:48:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7218','2005-07-27T09:34:24.000','2458','530','2005-08-01T07:00:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7219','2005-07-27T09:35:36.000','4046','512','2005-07-29T04:44:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7220','2005-07-27T09:35:54.000','3867','79','2005-08-04T06:00:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7221','2005-07-27T09:37:35.000','3820','579','2005-07-28T11:25:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7222','2005-07-27T09:38:43.000','2330','206','2005-07-28T06:25:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7223','2005-07-27T09:42:27.000','2623','325','2005-08-04T04:02:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7224','2005-07-27T09:44:26.000','2701','106','2005-08-05T12:46:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7225','2005-07-27T09:47:12.000','632','306','2005-08-03T13:19:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7226','2005-07-27T09:47:53.000','3507','370','2005-08-01T08:24:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7227','2005-07-27T09:53:43.000','791','164','2005-08-05T09:36:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7228','2005-07-27T09:55:33.000','1693','481','2005-07-29T04:33:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7229','2005-07-27T10:00:54.000','978','182','2005-07-28T13:58:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7230','2005-07-27T10:01:41.000','1152','245','2005-08-02T11:00:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7231','2005-07-27T10:01:51.000','1638','86','2005-08-05T13:38:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7232','2005-07-27T10:04:19.000','1147','306','2005-07-28T09:43:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7233','2005-07-27T10:08:36.000','213','245','2005-07-31T16:00:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7234','2005-07-27T10:08:45.000','3873','372','2005-07-31T13:58:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7235','2005-07-27T10:09:30.000','1261','354','2005-08-05T11:44:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7236','2005-07-27T10:09:39.000','3004','218','2005-08-03T16:05:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7237','2005-07-27T10:12:36.000','1904','29','2005-07-31T08:40:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7238','2005-07-27T10:13:41.000','1197','116','2005-07-29T11:07:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7239','2005-07-27T10:20:27.000','1786','278','2005-07-29T10:15:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7240','2005-07-27T10:21:15.000','4565','324','2005-08-03T05:04:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7241','2005-07-27T10:25:49.000','2433','354','2005-07-28T05:30:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7242','2005-07-27T10:25:51.000','1966','565','2005-08-04T16:02:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7243','2005-07-27T10:26:11.000','1287','238','2005-07-29T11:43:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7244','2005-07-27T10:27:33.000','1329','339','2005-07-30T13:09:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7245','2005-07-27T10:29:06.000','260','95','2005-08-05T12:09:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7246','2005-07-27T10:30:41.000','2003','333','2005-07-30T05:44:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7247','2005-07-27T10:32:58.000','1445','102','2005-07-29T05:00:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7248','2005-07-27T10:37:45.000','4256','456','2005-08-01T13:13:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7249','2005-07-27T10:39:53.000','2441','425','2005-07-28T14:48:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7250','2005-07-27T10:44:09.000','3410','589','2005-07-28T11:47:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7251','2005-07-27T10:44:55.000','1737','360','2005-08-01T16:12:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7252','2005-07-27T10:45:28.000','3107','549','2005-08-04T06:24:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7253','2005-07-27T10:46:37.000','1950','236','2005-07-28T11:18:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7254','2005-07-27T10:48:50.000','2697','286','2005-07-28T10:34:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7255','2005-07-27T10:49:54.000','2101','502','2005-07-31T10:40:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7256','2005-07-27T10:58:32.000','4275','363','2005-07-29T08:58:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7257','2005-07-27T11:04:17.000','3302','480','2005-08-04T12:32:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7258','2005-07-27T11:05:54.000','2079','494','2005-08-02T11:36:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7259','2005-07-27T11:06:00.000','2345','406','2005-08-02T06:44:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7260','2005-07-27T11:09:28.000','3827','434','2005-08-03T09:41:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7261','2005-07-27T11:15:01.000','942','172','2005-07-28T09:42:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7262','2005-07-27T11:15:36.000','4097','522','2005-07-30T10:49:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7263','2005-07-27T11:17:22.000','725','324','2005-08-04T10:59:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7264','2005-07-27T11:18:58.000','2391','299','2005-08-03T07:43:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7265','2005-07-27T11:19:01.000','3465','290','2005-08-01T09:29:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7266','2005-07-27T11:22:17.000','3379','24','2005-08-04T05:45:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7267','2005-07-27T11:22:55.000','3661','122','2005-08-01T08:13:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7268','2005-07-27T11:23:09.000','2740','260','2005-08-01T12:42:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7269','2005-07-27T11:23:47.000','2089','209','2005-07-31T13:10:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7270','2005-07-27T11:29:02.000','1888','526','2005-08-05T08:04:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7271','2005-07-27T11:29:11.000','858','469','2005-08-05T15:33:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7272','2005-07-27T11:30:20.000','250','364','2005-07-29T17:16:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7273','2005-07-27T11:31:22.000','2465','1','2005-07-31T06:50:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7274','2005-07-27T11:35:34.000','4087','180','2005-08-01T07:10:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7275','2005-07-27T11:39:08.000','775','323','2005-07-30T13:37:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7276','2005-07-27T11:41:57.000','1665','314','2005-08-01T10:39:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7277','2005-07-27T11:48:37.000','1544','67','2005-08-03T07:20:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7278','2005-07-27T11:50:34.000','531','592','2005-08-01T10:22:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7279','2005-07-27T11:50:47.000','1424','12','2005-07-30T11:19:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7280','2005-07-27T11:50:52.000','236','342','2005-07-30T15:53:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7281','2005-07-27T11:59:20.000','1350','491','2005-08-04T12:48:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7282','2005-07-27T12:00:19.000','4418','276','2005-08-04T14:48:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7283','2005-07-27T12:02:41.000','3101','508','2005-08-05T07:25:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7284','2005-07-27T12:12:04.000','2336','52','2005-07-31T11:17:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7285','2005-07-27T12:14:06.000','2855','498','2005-08-03T14:57:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7286','2005-07-27T12:23:49.000','3452','498','2005-08-04T07:57:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7287','2005-07-27T12:24:12.000','926','198','2005-07-31T15:34:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7288','2005-07-27T12:24:59.000','45','226','2005-08-02T15:52:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7289','2005-07-27T12:26:51.000','2157','187','2005-08-02T18:20:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7290','2005-07-27T12:28:45.000','3652','423','2005-08-01T16:18:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7291','2005-07-27T12:30:47.000','310','263','2005-08-01T12:45:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7292','2005-07-27T12:34:14.000','795','468','2005-08-01T18:16:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7293','2005-07-27T12:37:28.000','3333','5','2005-07-30T15:12:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7294','2005-07-27T12:38:14.000','487','313','2005-07-30T13:01:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7295','2005-07-27T12:38:47.000','3396','462','2005-08-05T10:12:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7296','2005-07-27T12:39:48.000','1681','400','2005-08-04T18:24:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7297','2005-07-27T12:39:48.000','1855','135','2005-07-29T17:50:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7298','2005-07-27T12:45:14.000','1653','121','2005-07-30T07:02:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7299','2005-07-27T12:49:56.000','3002','286','2005-08-03T12:25:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7300','2005-07-27T12:50:17.000','4561','272','2005-08-04T18:43:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7301','2005-07-27T12:50:23.000','3367','93','2005-08-01T09:43:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7302','2005-07-27T12:52:13.000','4539','477','2005-07-29T15:13:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7303','2005-07-27T12:54:39.000','1398','163','2005-07-31T09:26:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7304','2005-07-27T12:56:56.000','1162','74','2005-08-05T09:19:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7305','2005-07-27T12:57:06.000','2464','229','2005-07-30T13:13:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7306','2005-07-27T12:57:26.000','2269','207','2005-08-03T09:35:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7307','2005-07-27T12:59:10.000','3882','595','2005-07-29T11:35:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7308','2005-07-27T13:00:25.000','1452','229','2005-08-03T16:04:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7309','2005-07-27T13:00:29.000','633','317','2005-07-29T12:15:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7310','2005-07-27T13:00:55.000','3711','103','2005-07-28T17:54:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7311','2005-07-27T13:02:54.000','2807','582','2005-08-04T09:52:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7312','2005-07-27T13:03:14.000','228','543','2005-07-31T07:56:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7313','2005-07-27T13:11:57.000','1884','396','2005-08-02T07:31:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7314','2005-07-27T13:13:32.000','1376','11','2005-08-03T09:24:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7315','2005-07-27T13:14:56.000','974','208','2005-08-03T08:44:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7316','2005-07-27T13:19:03.000','3344','114','2005-07-28T07:43:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7317','2005-07-27T13:19:41.000','1518','443','2005-07-29T16:16:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7318','2005-07-27T13:25:31.000','1954','301','2005-07-31T11:44:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7319','2005-07-27T13:31:25.000','2370','576','2005-08-04T07:31:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7320','2005-07-27T13:33:35.000','4348','241','2005-07-31T13:22:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7321','2005-07-27T13:33:38.000','3525','38','2005-08-03T07:35:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7322','2005-07-27T13:37:26.000','1810','508','2005-08-03T18:00:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7323','2005-07-27T13:39:40.000','3830','125','2005-07-29T08:45:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7324','2005-07-27T13:42:39.000','2572','462','2005-08-04T10:33:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7325','2005-07-27T13:46:55.000','1727','289','2005-07-28T14:21:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7326','2005-07-27T13:50:40.000','2844','432','2005-07-30T08:16:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7327','2005-07-27T13:53:26.000','4074','508','2005-08-04T17:58:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7328','2005-07-27T13:55:18.000','663','26','2005-08-01T19:52:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7329','2005-07-27T13:55:34.000','906','226','2005-08-04T15:15:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7330','2005-07-27T13:56:46.000','3705','237','2005-08-04T07:56:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7331','2005-07-27T13:57:50.000','2090','60','2005-07-31T08:59:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7332','2005-07-27T13:58:57.000','1761','151','2005-08-02T12:40:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7333','2005-07-27T13:59:11.000','1331','230','2005-07-30T16:04:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7334','2005-07-27T13:59:58.000','3006','461','2005-07-29T11:33:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7335','2005-07-27T14:06:50.000','1219','219','2005-08-05T18:27:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7336','2005-07-27T14:11:45.000','2706','46','2005-07-28T11:00:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7337','2005-07-27T14:12:04.000','3314','525','2005-08-03T14:57:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7338','2005-07-27T14:13:34.000','107','251','2005-08-03T18:36:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7339','2005-07-27T14:17:48.000','3343','316','2005-07-31T12:47:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7340','2005-07-27T14:18:10.000','1344','567','2005-07-30T09:57:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7341','2005-07-27T14:23:55.000','3567','498','2005-07-28T14:11:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7342','2005-07-27T14:25:17.000','4083','504','2005-08-04T10:02:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7343','2005-07-27T14:27:13.000','1177','526','2005-07-30T09:27:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7344','2005-07-27T14:29:28.000','1714','366','2005-07-31T15:36:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7345','2005-07-27T14:29:53.000','2434','572','2005-08-03T18:38:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7346','2005-07-27T14:30:42.000','741','2','2005-08-02T16:48:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7347','2005-07-27T14:31:24.000','3779','225','2005-07-31T16:19:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7348','2005-07-27T14:32:32.000','3238','43','2005-07-28T17:05:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7349','2005-07-27T14:33:00.000','861','195','2005-08-01T15:01:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7350','2005-07-27T14:34:14.000','737','410','2005-08-02T19:19:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7351','2005-07-27T14:37:36.000','2147','445','2005-07-30T09:58:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7352','2005-07-27T14:38:29.000','35','429','2005-07-28T14:24:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7353','2005-07-27T14:38:39.000','1308','357','2005-07-31T19:50:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7354','2005-07-27T14:42:11.000','2395','598','2005-08-03T18:19:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7355','2005-07-27T14:45:59.000','3803','115','2005-08-02T17:23:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7356','2005-07-27T14:47:35.000','309','397','2005-07-28T18:10:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7357','2005-07-27T14:48:31.000','1917','438','2005-08-02T18:07:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7358','2005-07-27T14:49:44.000','175','245','2005-07-28T20:00:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7359','2005-07-27T14:51:04.000','174','183','2005-07-31T16:03:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7360','2005-07-27T14:52:06.000','1312','467','2005-08-02T12:24:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7361','2005-07-27T14:53:55.000','4567','463','2005-07-31T19:48:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7362','2005-07-27T14:58:27.000','1902','419','2005-08-01T11:51:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7363','2005-07-27T14:58:29.000','1649','407','2005-08-05T09:02:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7364','2005-07-27T14:58:40.000','3046','592','2005-08-03T09:01:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7365','2005-07-27T15:00:20.000','3283','450','2005-07-30T12:58:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7366','2005-07-27T15:01:17.000','461','357','2005-08-04T20:28:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7367','2005-07-27T15:05:45.000','1738','383','2005-08-02T13:46:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7368','2005-07-27T15:06:05.000','2265','286','2005-07-31T14:10:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7369','2005-07-27T15:07:58.000','3889','139','2005-07-30T09:16:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7370','2005-07-27T15:15:53.000','2022','89','2005-08-03T19:53:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7371','2005-07-27T15:18:42.000','1807','577','2005-08-01T09:58:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7372','2005-07-27T15:18:42.000','3202','584','2005-08-01T15:18:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7373','2005-07-27T15:19:33.000','3074','488','2005-08-04T10:45:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7374','2005-07-27T15:20:57.000','3184','438','2005-08-05T13:09:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7375','2005-07-27T15:22:33.000','2970','381','2005-08-01T20:06:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7376','2005-07-27T15:23:02.000','488','2','2005-08-04T10:35:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7377','2005-07-27T15:31:28.000','1369','588','2005-08-02T19:59:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7378','2005-07-27T15:31:33.000','3297','144','2005-08-03T17:15:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7379','2005-07-27T15:36:43.000','424','415','2005-07-30T16:37:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7380','2005-07-27T15:37:01.000','988','348','2005-08-03T19:24:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7381','2005-07-27T15:40:26.000','1595','483','2005-08-02T17:26:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7382','2005-07-27T15:43:15.000','356','518','2005-07-28T11:18:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7383','2005-07-27T15:46:53.000','3860','50','2005-08-03T11:10:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7384','2005-07-27T15:49:45.000','3573','585','2005-08-04T15:17:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7385','2005-07-27T15:49:46.000','2996','56','2005-07-28T13:50:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7386','2005-07-27T15:52:10.000','3569','190','2005-08-04T15:13:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7387','2005-07-27T15:54:19.000','3274','233','2005-08-03T14:46:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7388','2005-07-27T15:54:19.000','4559','455','2005-08-01T17:02:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7389','2005-07-27T15:56:15.000','3822','156','2005-07-30T21:28:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7390','2005-07-27T15:59:19.000','1723','230','2005-08-04T10:09:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7391','2005-07-27T16:00:00.000','1153','531','2005-08-04T18:07:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7392','2005-07-27T16:01:05.000','3159','204','2005-08-01T17:23:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7393','2005-07-27T16:02:52.000','2369','181','2005-08-02T13:24:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7394','2005-07-27T16:03:08.000','2399','30','2005-08-04T11:27:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7395','2005-07-27T16:03:11.000','2888','411','2005-07-31T20:26:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7396','2005-07-27T16:03:53.000','3346','595','2005-08-05T10:36:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7397','2005-07-27T16:05:00.000','4474','245','2005-08-01T20:29:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7398','2005-07-27T16:07:22.000','1572','51','2005-08-05T16:16:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7399','2005-07-27T16:16:02.000','1682','526','2005-08-03T18:02:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7400','2005-07-27T16:16:37.000','2874','133','2005-07-31T12:34:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7401','2005-07-27T16:17:55.000','2759','583','2005-08-04T15:48:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7402','2005-07-27T16:19:40.000','2707','287','2005-08-05T14:48:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7403','2005-07-27T16:22:09.000','2551','163','2005-08-01T15:32:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7404','2005-07-27T16:24:43.000','2359','190','2005-07-29T11:40:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7405','2005-07-27T16:25:11.000','2312','42','2005-08-01T12:33:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7406','2005-07-27T16:25:45.000','1412','77','2005-08-05T20:39:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7407','2005-07-27T16:29:04.000','3093','410','2005-08-01T17:47:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7408','2005-07-27T16:31:40.000','625','371','2005-07-31T11:56:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7409','2005-07-27T16:38:24.000','2352','585','2005-07-30T18:06:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7410','2005-07-27T16:41:59.000','1559','337','2005-07-29T22:11:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7411','2005-07-27T16:42:30.000','515','302','2005-08-05T17:38:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7412','2005-07-27T16:44:34.000','950','582','2005-08-04T15:06:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7413','2005-07-27T16:45:40.000','2909','254','2005-07-31T12:02:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7414','2005-07-27T16:46:07.000','3276','265','2005-08-02T20:04:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7415','2005-07-27T16:50:59.000','4410','294','2005-08-02T11:21:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7416','2005-07-27T16:55:25.000','653','350','2005-07-29T11:27:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7417','2005-07-27T16:58:33.000','2952','214','2005-07-30T22:17:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7418','2005-07-27T16:59:09.000','3029','332','2005-07-29T15:08:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7419','2005-07-27T17:04:15.000','3454','352','2005-08-05T21:54:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7420','2005-07-27T17:09:39.000','3505','547','2005-07-30T12:30:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7421','2005-07-27T17:10:05.000','3548','70','2005-08-05T17:55:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7422','2005-07-27T17:10:42.000','3954','286','2005-08-03T19:32:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7423','2005-07-27T17:11:47.000','666','277','2005-07-29T12:29:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7424','2005-07-27T17:14:19.000','660','558','2005-08-01T19:21:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7425','2005-07-27T17:18:35.000','435','263','2005-08-02T11:18:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7426','2005-07-27T17:19:46.000','4420','239','2005-07-29T21:41:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7427','2005-07-27T17:20:16.000','2548','442','2005-08-03T20:38:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7428','2005-07-27T17:21:52.000','243','90','2005-08-05T17:13:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7429','2005-07-27T17:24:50.000','2160','515','2005-08-05T23:02:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7430','2005-07-27T17:26:14.000','4205','562','2005-08-01T13:02:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7431','2005-07-27T17:27:27.000','3931','589','2005-07-31T18:40:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7432','2005-07-27T17:31:40.000','3169','132','2005-07-28T17:44:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7433','2005-07-27T17:32:20.000','1748','282','2005-08-01T18:49:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7434','2005-07-27T17:34:40.000','2927','241','2005-07-29T15:01:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7435','2005-07-27T17:38:44.000','1574','380','2005-07-30T16:57:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7436','2005-07-27T17:39:12.000','299','45','2005-08-01T12:40:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7437','2005-07-27T17:39:18.000','2617','135','2005-07-28T18:33:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7438','2005-07-27T17:40:40.000','1364','52','2005-08-05T15:25:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7439','2005-07-27T17:42:31.000','4091','102','2005-08-05T16:34:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7440','2005-07-27T17:43:27.000','1476','484','2005-08-03T22:12:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7441','2005-07-27T17:46:53.000','4039','198','2005-07-31T23:05:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7442','2005-07-27T17:47:00.000','2471','105','2005-07-28T21:37:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7443','2005-07-27T17:47:43.000','703','380','2005-07-29T13:15:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7444','2005-07-27T17:49:16.000','120','531','2005-07-28T15:05:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7445','2005-07-27T17:57:15.000','4115','394','2005-07-31T20:24:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7446','2005-07-27T18:00:24.000','2337','486','2005-07-29T13:40:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7447','2005-07-27T18:02:08.000','1795','107','2005-07-29T21:15:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7448','2005-07-27T18:06:30.000','3584','175','2005-07-29T15:43:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7449','2005-07-27T18:17:41.000','2084','421','2005-08-01T18:52:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7450','2005-07-27T18:18:35.000','3496','191','2005-08-04T15:18:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7451','2005-07-27T18:18:41.000','2382','29','2005-08-03T13:55:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7452','2005-07-27T18:26:39.000','3482','285','2005-08-04T17:35:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7453','2005-07-27T18:27:13.000','2992','29','2005-07-29T23:52:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7454','2005-07-27T18:27:26.000','3248','75','2005-07-30T23:50:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7455','2005-07-27T18:34:41.000','3815','405','2005-07-31T17:32:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7456','2005-07-27T18:34:53.000','1959','501','2005-07-29T17:46:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7457','2005-07-27T18:35:17.000','3635','510','2005-07-30T12:41:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7458','2005-07-27T18:36:17.000','2964','327','2005-07-31T22:43:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7459','2005-07-27T18:40:20.000','2053','2','2005-08-02T21:07:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7460','2005-07-27T18:41:35.000','919','442','2005-07-29T15:16:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7461','2005-07-27T18:45:15.000','1236','476','2005-07-29T17:19:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7462','2005-07-27T18:47:47.000','878','114','2005-07-29T20:46:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7463','2005-07-27T18:48:32.000','3676','284','2005-07-29T23:54:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7464','2005-07-27T18:49:42.000','845','31','2005-07-28T20:45:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7465','2005-07-27T18:50:30.000','2357','115','2005-07-30T20:55:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7466','2005-07-27T18:51:17.000','2791','53','2005-07-31T16:58:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7467','2005-07-27T18:51:54.000','3869','240','2005-08-03T23:27:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7468','2005-07-27T18:52:27.000','3166','113','2005-08-03T19:29:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7469','2005-07-27T18:57:40.000','3723','189','2005-07-31T00:17:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7470','2005-07-27T19:01:03.000','289','564','2005-08-05T19:16:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7471','2005-07-27T19:02:19.000','1776','95','2005-07-30T15:12:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7472','2005-07-27T19:04:19.000','1535','103','2005-08-03T00:08:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7473','2005-07-27T19:05:40.000','401','341','2005-08-05T14:47:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7474','2005-07-27T19:07:17.000','2971','110','2005-07-30T00:37:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7475','2005-07-27T19:07:43.000','1670','255','2005-08-04T22:12:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7476','2005-07-27T19:08:56.000','2288','64','2005-07-31T16:36:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7477','2005-07-27T19:11:03.000','2692','355','2005-08-02T19:25:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7478','2005-07-27T19:16:02.000','3791','521','2005-08-04T22:30:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7479','2005-07-27T19:18:17.000','218','434','2005-07-30T18:55:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7480','2005-07-27T19:19:53.000','452','344','2005-08-02T01:01:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7481','2005-07-27T19:20:25.000','1804','240','2005-07-29T19:07:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7482','2005-07-27T19:24:16.000','485','348','2005-08-05T18:49:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7483','2005-07-27T19:25:00.000','3678','106','2005-07-29T21:19:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7484','2005-07-27T19:28:17.000','2746','211','2005-07-31T20:05:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7485','2005-07-27T19:29:09.000','631','362','2005-07-30T16:28:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7486','2005-07-27T19:29:24.000','4362','393','2005-08-02T20:46:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7487','2005-07-27T19:32:45.000','4451','58','2005-07-28T15:11:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7488','2005-07-27T19:36:15.000','554','365','2005-08-05T14:14:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7489','2005-07-27T19:39:38.000','3732','16','2005-07-30T23:10:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7490','2005-07-27T19:48:12.000','4503','595','2005-08-04T17:15:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7491','2005-07-27T19:53:23.000','4261','239','2005-07-28T23:25:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7492','2005-07-27T19:54:18.000','908','155','2005-07-31T15:36:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7493','2005-07-27T19:55:46.000','2868','177','2005-08-02T19:46:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7494','2005-07-27T19:56:31.000','2259','60','2005-07-30T14:28:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7495','2005-07-27T20:01:20.000','3446','426','2005-07-30T16:40:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7496','2005-07-27T20:04:05.000','2449','257','2005-08-02T20:12:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7497','2005-07-27T20:05:27.000','286','387','2005-07-30T22:47:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7498','2005-07-27T20:09:31.000','1144','455','2005-07-29T23:38:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7499','2005-07-27T20:10:28.000','3503','157','2005-07-30T16:24:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7500','2005-07-27T20:16:03.000','609','160','2005-07-29T18:50:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7501','2005-07-27T20:16:59.000','1464','587','2005-08-04T00:11:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7502','2005-07-27T20:19:08.000','3229','303','2005-07-28T18:32:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7503','2005-07-27T20:23:12.000','579','3','2005-08-05T18:46:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7504','2005-07-27T20:24:31.000','3354','283','2005-07-30T21:25:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7505','2005-07-27T20:28:03.000','1342','209','2005-08-03T17:04:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7506','2005-07-27T20:28:34.000','2091','527','2005-08-05T18:14:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7507','2005-07-27T20:31:48.000','3618','512','2005-08-02T17:27:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7508','2005-07-27T20:33:08.000','3401','465','2005-08-01T01:29:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7509','2005-07-27T20:37:19.000','4134','228','2005-08-04T19:35:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7510','2005-07-27T20:37:57.000','1617','257','2005-08-01T17:14:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7511','2005-07-27T20:38:40.000','4044','591','2005-08-04T22:36:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7512','2005-07-27T20:40:40.000','1343','352','2005-08-05T01:44:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7513','2005-07-27T20:51:04.000','939','411','2005-08-03T20:15:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7514','2005-07-27T20:51:49.000','400','44','2005-07-29T18:21:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7515','2005-07-27T20:52:37.000','1211','390','2005-08-02T20:17:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7516','2005-07-27T20:55:28.000','2178','134','2005-07-30T00:50:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7517','2005-07-27T20:57:07.000','3177','41','2005-08-04T15:08:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7518','2005-07-27T21:01:16.000','2676','257','2005-08-03T15:26:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7519','2005-07-27T21:01:41.000','4009','124','2005-08-05T19:15:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7520','2005-07-27T21:02:02.000','3875','191','2005-07-28T18:18:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7521','2005-07-27T21:04:42.000','3144','176','2005-08-03T16:06:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7522','2005-07-27T21:11:03.000','2038','478','2005-08-02T16:40:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7523','2005-07-27T21:11:23.000','4153','410','2005-07-28T16:37:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7524','2005-07-27T21:11:44.000','4295','225','2005-08-03T02:17:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7525','2005-07-27T21:13:28.000','4084','281','2005-08-04T19:44:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7526','2005-07-27T21:13:47.000','696','44','2005-08-05T15:23:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7527','2005-07-27T21:14:28.000','2124','426','2005-08-05T21:08:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7528','2005-07-27T21:15:25.000','1218','213','2005-08-03T19:12:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7529','2005-07-27T21:18:08.000','3644','145','2005-08-06T00:59:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7530','2005-07-27T21:18:58.000','3810','98','2005-07-31T01:51:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7531','2005-07-27T21:19:34.000','2393','221','2005-08-06T01:07:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7532','2005-07-27T21:20:52.000','677','34','2005-07-30T21:38:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7533','2005-07-27T21:24:33.000','1791','594','2005-08-05T16:33:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7534','2005-07-27T21:26:17.000','2276','282','2005-08-05T00:23:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7535','2005-07-27T21:32:39.000','772','123','2005-08-05T23:42:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7536','2005-07-27T21:34:09.000','3417','307','2005-08-02T03:26:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7537','2005-07-27T21:36:09.000','4456','269','2005-08-01T01:51:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7538','2005-07-27T21:38:04.000','2486','361','2005-08-02T03:14:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7539','2005-07-27T21:39:42.000','1849','423','2005-08-06T00:12:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7540','2005-07-27T21:39:55.000','2198','207','2005-08-04T18:10:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7541','2005-07-27T21:40:05.000','4100','206','2005-07-29T16:13:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7542','2005-07-27T21:43:04.000','1912','110','2005-07-30T00:02:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7543','2005-07-27T21:44:28.000','1289','526','2005-08-04T21:42:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7544','2005-07-27T21:47:37.000','766','249','2005-08-05T02:29:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7545','2005-07-27T21:48:03.000','2541','292','2005-08-01T22:23:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7546','2005-07-27T21:50:09.000','3683','494','2005-08-05T03:07:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7547','2005-07-27T21:51:48.000','1733','547','2005-08-06T01:05:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7548','2005-07-27T21:53:18.000','2194','484','2005-08-02T17:50:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7549','2005-07-27T21:53:21.000','1765','591','2005-08-05T18:53:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7550','2005-07-27T21:55:07.000','4488','71','2005-07-28T23:34:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7551','2005-07-27T21:59:15.000','2635','304','2005-07-31T19:54:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7552','2005-07-27T22:03:41.000','2166','16','2005-07-28T22:24:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7553','2005-07-27T22:11:36.000','1643','275','2005-08-03T17:52:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7554','2005-07-27T22:12:41.000','1805','135','2005-08-04T01:34:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7555','2005-07-27T22:17:05.000','3421','533','2005-08-02T02:50:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7556','2005-07-27T22:17:17.000','794','188','2005-07-28T19:17:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7557','2005-07-27T22:18:19.000','3152','131','2005-07-29T00:24:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7558','2005-07-27T22:19:08.000','550','80','2005-07-30T21:31:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7559','2005-07-27T22:20:03.000','661','149','2005-08-06T00:26:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7560','2005-07-27T22:20:17.000','3574','562','2005-08-02T23:00:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7561','2005-07-27T22:21:05.000','3433','291','2005-08-04T01:02:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7562','2005-07-27T22:25:15.000','4417','366','2005-08-01T01:21:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7563','2005-07-27T22:25:36.000','2709','453','2005-08-01T03:59:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7564','2005-07-27T22:31:17.000','2887','291','2005-08-01T01:05:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7565','2005-07-27T22:33:59.000','1028','114','2005-07-30T03:03:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7566','2005-07-27T22:34:45.000','1802','144','2005-08-01T22:20:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7567','2005-07-27T22:38:05.000','1066','504','2005-07-30T17:20:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7568','2005-07-27T22:38:53.000','1578','296','2005-07-29T00:51:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7569','2005-07-27T22:38:53.000','2315','528','2005-08-05T19:03:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7570','2005-07-27T22:40:06.000','3189','110','2005-07-28T23:14:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7571','2005-07-27T22:43:42.000','3850','368','2005-07-30T22:17:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7572','2005-07-27T22:44:29.000','3068','532','2005-08-01T03:04:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7573','2005-07-27T22:46:20.000','314','467','2005-08-04T01:55:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7574','2005-07-27T22:53:00.000','298','200','2005-07-29T18:39:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7575','2005-07-27T22:53:52.000','702','582','2005-07-29T02:02:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7576','2005-07-27T22:54:35.000','3374','446','2005-08-03T03:53:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7577','2005-07-27T22:56:07.000','2723','332','2005-08-05T21:23:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7578','2005-07-27T22:58:17.000','4210','332','2005-07-29T23:14:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7579','2005-07-27T23:06:41.000','501','352','2005-07-31T20:08:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7580','2005-07-27T23:07:40.000','338','28','2005-08-05T02:17:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7581','2005-07-27T23:14:35.000','2051','166','2005-07-29T21:30:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7582','2005-07-27T23:15:14.000','3941','128','2005-07-29T03:18:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7583','2005-07-27T23:15:22.000','2890','198','2005-08-04T04:39:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7584','2005-07-27T23:15:46.000','4390','338','2005-08-03T02:18:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7585','2005-07-27T23:18:22.000','467','440','2005-07-30T23:08:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7586','2005-07-27T23:19:29.000','15','316','2005-07-29T23:04:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7587','2005-07-27T23:23:03.000','655','113','2005-08-01T17:34:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7588','2005-07-27T23:23:31.000','4033','360','2005-08-04T02:54:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7589','2005-07-27T23:23:36.000','1569','32','2005-08-04T00:16:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7590','2005-07-27T23:24:24.000','2152','73','2005-07-28T19:53:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7591','2005-07-27T23:25:54.000','651','525','2005-08-02T22:54:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7592','2005-07-27T23:26:04.000','4105','316','2005-07-29T23:48:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7593','2005-07-27T23:28:47.000','1158','436','2005-08-02T19:51:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7594','2005-07-27T23:30:41.000','3230','424','2005-08-02T04:29:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7595','2005-07-27T23:32:23.000','4313','390','2005-08-03T05:28:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7596','2005-07-27T23:33:57.000','2097','275','2005-08-01T20:46:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7597','2005-07-27T23:35:49.000','2856','169','2005-07-30T21:38:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7598','2005-07-27T23:36:01.000','4545','438','2005-07-29T23:35:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7599','2005-07-27T23:38:46.000','3272','87','2005-07-28T22:52:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7600','2005-07-27T23:41:18.000','3492','107','2005-08-06T04:40:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7601','2005-07-27T23:48:15.000','903','228','2005-07-29T02:45:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7602','2005-07-27T23:48:35.000','2516','366','2005-08-04T17:58:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7603','2005-07-27T23:54:44.000','124','497','2005-07-29T01:24:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7604','2005-07-27T23:54:52.000','3720','406','2005-08-05T03:04:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7605','2005-07-27T23:57:01.000','1391','576','2005-08-03T04:11:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7606','2005-07-28T00:02:15.000','637','201','2005-07-29T03:14:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7607','2005-07-28T00:05:53.000','3914','293','2005-07-31T04:13:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7608','2005-07-28T00:08:36.000','1256','167','2005-07-28T18:13:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7609','2005-07-28T00:11:00.000','3655','179','2005-07-31T03:04:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7610','2005-07-28T00:11:35.000','1279','450','2005-07-31T00:33:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7611','2005-07-28T00:11:47.000','3347','467','2005-07-28T18:35:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7612','2005-07-28T00:11:55.000','1411','563','2005-07-30T00:47:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7613','2005-07-28T00:13:58.000','4253','202','2005-08-06T05:36:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7614','2005-07-28T00:14:38.000','3475','440','2005-07-29T18:18:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7615','2005-07-28T00:15:24.000','3884','373','2005-07-31T02:00:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7616','2005-07-28T00:15:26.000','3790','9','2005-07-30T21:52:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7617','2005-07-28T00:18:40.000','2904','340','2005-08-01T01:17:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7618','2005-07-28T00:24:14.000','774','271','2005-08-01T04:35:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7619','2005-07-28T00:25:41.000','1057','419','2005-07-30T04:35:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7620','2005-07-28T00:27:17.000','931','580','2005-07-31T02:04:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7621','2005-07-28T00:34:06.000','1833','88','2005-08-06T00:13:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7622','2005-07-28T00:37:34.000','4014','198','2005-07-31T23:27:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7623','2005-07-28T00:37:41.000','1146','459','2005-08-04T19:38:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7624','2005-07-28T00:37:44.000','2756','415','2005-07-30T21:26:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7625','2005-07-28T00:47:56.000','3129','382','2005-08-02T23:34:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7626','2005-07-28T00:49:01.000','4200','450','2005-07-31T00:43:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7627','2005-07-28T00:56:47.000','782','52','2005-08-02T04:16:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7628','2005-07-28T00:58:04.000','1240','516','2005-08-03T19:16:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7629','2005-07-28T01:00:09.000','2453','229','2005-07-30T06:49:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7630','2005-07-28T01:01:03.000','2798','351','2005-07-31T01:08:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7631','2005-07-28T01:01:15.000','2437','132','2005-08-01T06:16:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7632','2005-07-28T01:02:40.000','3233','181','2005-07-30T05:31:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7633','2005-07-28T01:03:41.000','4171','402','2005-08-01T23:54:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7634','2005-07-28T01:07:01.000','4487','365','2005-07-31T05:00:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7635','2005-07-28T01:08:11.000','55','413','2005-08-01T03:32:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7636','2005-07-28T01:08:36.000','202','51','2005-08-03T21:36:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7637','2005-07-28T01:12:25.000','87','91','2005-08-02T03:48:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7638','2005-07-28T01:13:26.000','1890','172','2005-07-28T20:34:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7639','2005-07-28T01:14:36.000','767','459','2005-07-29T00:19:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7640','2005-07-28T01:14:49.000','3014','229','2005-08-03T21:50:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7641','2005-07-28T01:15:45.000','1868','475','2005-08-04T23:50:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7642','2005-07-28T01:16:51.000','3995','523','2005-08-02T00:45:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7643','2005-07-28T01:19:44.000','4369','407','2005-08-04T21:16:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7644','2005-07-28T01:27:33.000','882','173','2005-07-31T22:58:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7645','2005-07-28T01:27:42.000','830','381','2005-08-03T07:16:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7646','2005-07-28T01:31:45.000','1615','255','2005-07-31T07:16:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7647','2005-07-28T01:35:17.000','3079','36','2005-08-01T00:14:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7648','2005-07-28T01:35:33.000','797','310','2005-08-04T06:21:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7649','2005-07-28T01:37:26.000','2704','318','2005-07-28T21:18:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7650','2005-07-28T01:47:20.000','701','290','2005-08-05T06:00:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7651','2005-07-28T01:48:32.000','2753','401','2005-08-03T03:10:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7652','2005-07-28T01:50:29.000','92','5','2005-07-30T22:23:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7653','2005-07-28T01:58:30.000','814','232','2005-07-28T23:32:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7654','2005-07-28T02:00:14.000','1009','360','2005-07-31T20:50:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7655','2005-07-28T02:01:11.000','2665','513','2005-07-30T23:12:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7656','2005-07-28T02:07:19.000','178','148','2005-07-31T04:05:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7657','2005-07-28T02:09:00.000','2319','518','2005-08-04T21:44:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7658','2005-07-28T02:09:12.000','1798','272','2005-07-30T00:54:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7659','2005-07-28T02:09:45.000','1622','584','2005-08-02T05:34:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7660','2005-07-28T02:10:10.000','4385','4','2005-07-30T04:29:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7661','2005-07-28T02:10:27.000','3060','256','2005-08-05T03:45:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7662','2005-07-28T02:16:08.000','1017','534','2005-08-03T21:51:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7663','2005-07-28T02:19:48.000','832','470','2005-07-30T21:43:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7664','2005-07-28T02:24:23.000','1989','461','2005-07-29T23:01:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7665','2005-07-28T02:28:30.000','1455','590','2005-07-31T20:42:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7666','2005-07-28T02:35:12.000','688','196','2005-08-05T05:43:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7667','2005-07-28T02:37:22.000','2415','443','2005-08-05T21:37:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7668','2005-07-28T02:41:31.000','3880','508','2005-08-02T06:08:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7669','2005-07-28T02:44:07.000','2624','483','2005-07-29T00:54:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7670','2005-07-28T02:44:25.000','1356','252','2005-07-29T21:55:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7671','2005-07-28T02:48:31.000','3464','442','2005-07-30T23:04:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7672','2005-07-28T02:49:41.000','573','542','2005-08-04T02:38:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7673','2005-07-28T02:53:53.000','2368','409','2005-08-06T00:07:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7674','2005-07-28T02:54:30.000','682','177','2005-08-05T23:09:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7675','2005-07-28T02:55:20.000','153','189','2005-07-31T05:27:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7676','2005-07-28T02:55:27.000','1110','508','2005-08-01T03:50:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7677','2005-07-28T02:56:37.000','4464','566','2005-07-31T02:21:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7678','2005-07-28T02:58:16.000','3398','510','2005-08-06T04:22:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7679','2005-07-28T02:58:39.000','1063','444','2005-08-02T04:58:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7680','2005-07-28T02:59:08.000','1784','559','2005-08-03T03:37:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7681','2005-07-28T03:07:09.000','1176','432','2005-07-29T08:30:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7682','2005-07-28T03:07:29.000','3296','400','2005-08-04T08:48:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7683','2005-07-28T03:11:29.000','1760','73','2005-08-04T00:14:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7684','2005-07-28T03:11:54.000','3365','40','2005-07-31T04:40:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7685','2005-07-28T03:13:00.000','2213','468','2005-08-01T00:29:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7686','2005-07-28T03:19:23.000','2144','184','2005-08-04T05:17:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7687','2005-07-28T03:20:26.000','689','325','2005-08-02T05:48:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7688','2005-07-28T03:20:47.000','1179','491','2005-08-06T06:07:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7689','2005-07-28T03:21:24.000','1803','253','2005-07-31T08:01:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7690','2005-07-28T03:26:21.000','1076','150','2005-07-29T00:08:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7691','2005-07-28T03:30:09.000','1579','112','2005-07-29T21:31:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7692','2005-07-28T03:30:21.000','267','392','2005-07-30T22:25:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7693','2005-07-28T03:31:22.000','2479','148','2005-07-31T06:42:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7694','2005-07-28T03:39:25.000','2892','538','2005-07-31T05:47:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7695','2005-07-28T03:41:13.000','2742','323','2005-08-06T05:06:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7696','2005-07-28T03:41:35.000','3463','56','2005-08-06T05:48:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7697','2005-07-28T03:43:45.000','3966','377','2005-08-03T07:55:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7698','2005-07-28T03:44:14.000','3650','561','2005-08-04T03:44:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7699','2005-07-28T03:52:21.000','4332','53','2005-08-01T05:00:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7700','2005-07-28T03:54:14.000','3546','124','2005-08-05T06:20:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7701','2005-07-28T03:54:28.000','1604','306','2005-08-01T08:39:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7702','2005-07-28T03:56:05.000','253','349','2005-07-31T03:29:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7703','2005-07-28T03:59:21.000','2150','3','2005-08-05T08:52:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7704','2005-07-28T04:02:13.000','2342','265','2005-08-04T00:51:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7705','2005-07-28T04:02:58.000','1072','22','2005-08-05T01:19:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7706','2005-07-28T04:03:17.000','994','263','2005-07-29T22:16:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7707','2005-07-28T04:07:47.000','2563','232','2005-07-29T02:02:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7708','2005-07-28T04:19:15.000','398','363','2005-08-04T04:41:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7709','2005-07-28T04:22:14.000','3800','81','2005-07-31T09:18:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7710','2005-07-28T04:24:07.000','3716','77','2005-08-03T22:49:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7711','2005-07-28T04:26:42.000','2695','426','2005-07-29T07:30:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7712','2005-07-28T04:29:53.000','3256','361','2005-08-02T00:57:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7713','2005-07-28T04:32:14.000','2018','572','2005-08-03T04:30:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7714','2005-07-28T04:32:30.000','940','70','2005-08-02T07:10:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7715','2005-07-28T04:32:38.000','3210','512','2005-08-05T00:37:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7716','2005-07-28T04:33:15.000','1493','284','2005-08-04T00:08:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7717','2005-07-28T04:33:54.000','730','459','2005-07-30T02:46:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7718','2005-07-28T04:37:59.000','3587','4','2005-07-29T09:20:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7719','2005-07-28T04:39:09.000','2481','286','2005-08-05T03:15:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7720','2005-07-28T04:41:44.000','185','520','2005-08-04T06:51:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7721','2005-07-28T04:42:58.000','2228','83','2005-07-31T07:52:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7722','2005-07-28T04:44:58.000','3828','309','2005-07-30T01:29:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7723','2005-07-28T04:45:37.000','3263','147','2005-07-30T09:03:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7724','2005-07-28T04:46:30.000','346','3','2005-08-04T08:41:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7725','2005-07-28T04:47:14.000','1922','326','2005-08-04T09:03:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7726','2005-07-28T04:52:19.000','2578','219','2005-08-04T09:05:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7727','2005-07-28T04:52:43.000','2274','123','2005-08-03T01:12:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7728','2005-07-28T04:56:33.000','492','130','2005-07-31T07:54:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7729','2005-07-28T04:57:57.000','1491','89','2005-07-30T09:38:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7730','2005-07-28T04:59:48.000','3118','155','2005-08-04T04:35:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7731','2005-07-28T05:01:18.000','1533','413','2005-07-29T02:22:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7732','2005-07-28T05:03:32.000','3597','158','2005-07-29T10:20:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7733','2005-07-28T05:04:47.000','10','82','2005-08-05T05:12:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7734','2005-07-28T05:08:44.000','2726','135','2005-07-30T09:42:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7735','2005-07-28T05:09:56.000','3949','372','2005-07-31T23:34:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7736','2005-07-28T05:12:04.000','4466','205','2005-08-05T02:28:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7737','2005-07-28T05:15:03.000','1235','494','2005-08-04T01:24:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7738','2005-07-28T05:21:42.000','80','10','2005-08-03T09:46:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7739','2005-07-28T05:21:51.000','1554','186','2005-07-30T02:06:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7740','2005-07-28T05:23:36.000','3613','395','2005-08-01T02:20:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7741','2005-07-28T05:25:55.000','3917','591','2005-08-02T02:40:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7742','2005-07-28T05:33:16.000','1808','49','2005-08-06T01:04:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7743','2005-07-28T05:36:13.000','2883','210','2005-08-03T11:28:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7744','2005-07-28T05:38:20.000','1863','288','2005-07-31T11:00:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7745','2005-07-28T05:46:28.000','1014','285','2005-08-06T07:44:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7746','2005-07-28T05:48:56.000','176','299','2005-08-04T07:33:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7747','2005-07-28T05:50:11.000','1775','78','2005-08-03T09:51:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7748','2005-07-28T05:52:23.000','3523','415','2005-07-31T01:35:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7749','2005-07-28T05:53:36.000','3585','232','2005-08-01T03:49:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7750','2005-07-28T05:55:30.000','820','220','2005-08-06T04:32:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7751','2005-07-28T05:56:13.000','4425','176','2005-08-05T08:08:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7752','2005-07-28T06:01:00.000','2218','209','2005-08-03T06:09:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7753','2005-07-28T06:09:19.000','3071','531','2005-08-06T06:17:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7754','2005-07-28T06:10:55.000','1981','138','2005-07-29T02:46:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7755','2005-07-28T06:22:18.000','1247','449','2005-08-06T11:38:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7756','2005-07-28T06:22:52.000','1611','469','2005-08-05T11:55:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7757','2005-07-28T06:23:00.000','3445','502','2005-07-30T12:02:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7758','2005-07-28T06:23:41.000','4333','356','2005-08-03T06:06:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7759','2005-07-28T06:28:45.000','3381','405','2005-08-03T11:38:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7760','2005-07-28T06:29:45.000','409','307','2005-08-03T01:36:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7761','2005-07-28T06:31:45.000','3568','112','2005-07-30T01:36:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7762','2005-07-28T06:34:23.000','3234','462','2005-08-05T09:55:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7763','2005-07-28T06:35:16.000','2461','116','2005-08-03T02:46:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7764','2005-07-28T06:40:05.000','3537','142','2005-07-30T02:51:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7765','2005-07-28T06:40:33.000','4098','294','2005-07-31T01:25:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7766','2005-07-28T06:41:57.000','2774','292','2005-08-06T11:21:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7767','2005-07-28T06:42:02.000','329','139','2005-08-05T11:19:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7768','2005-07-28T06:44:03.000','2450','123','2005-07-29T09:46:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7769','2005-07-28T06:45:23.000','3250','30','2005-07-30T12:18:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7770','2005-07-28T06:49:35.000','1486','507','2005-08-06T08:16:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7771','2005-07-28T06:52:12.000','1003','175','2005-07-30T12:48:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7772','2005-07-28T06:59:09.000','986','552','2005-08-01T10:49:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7773','2005-07-28T07:02:17.000','4143','380','2005-07-30T04:16:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7774','2005-07-28T07:03:25.000','3483','259','2005-08-03T02:05:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7775','2005-07-28T07:04:36.000','3795','475','2005-08-03T06:36:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7776','2005-07-28T07:04:36.000','4170','385','2005-08-01T09:32:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7777','2005-07-28T07:04:42.000','4422','287','2005-07-29T01:57:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7778','2005-07-28T07:10:11.000','1044','248','2005-08-05T05:09:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7779','2005-07-28T07:11:11.000','3663','414','2005-07-30T11:12:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7780','2005-07-28T07:11:55.000','3069','236','2005-08-06T05:41:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7781','2005-07-28T07:13:20.000','541','539','2005-08-06T05:43:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7782','2005-07-28T07:13:40.000','3770','199','2005-08-05T06:50:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7783','2005-07-28T07:14:43.000','3817','581','2005-08-01T05:03:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7784','2005-07-28T07:15:32.000','3611','505','2005-08-06T05:00:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7785','2005-07-28T07:16:11.000','4277','460','2005-08-02T03:43:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7786','2005-07-28T07:18:26.000','2285','222','2005-07-29T03:00:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7787','2005-07-28T07:19:02.000','2191','203','2005-08-06T02:38:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7788','2005-07-28T07:21:55.000','95','487','2005-08-03T06:33:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7789','2005-07-28T07:22:07.000','2837','426','2005-08-06T10:47:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7790','2005-07-28T07:22:35.000','2327','189','2005-07-30T02:59:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7791','2005-07-28T07:22:51.000','822','514','2005-07-30T03:09:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7792','2005-07-28T07:24:02.000','3736','236','2005-08-04T11:13:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7793','2005-07-28T07:26:14.000','24','32','2005-08-03T07:45:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7794','2005-07-28T07:28:03.000','4509','510','2005-08-06T12:32:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7795','2005-07-28T07:28:16.000','1278','38','2005-07-31T12:03:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7796','2005-07-28T07:39:39.000','622','419','2005-08-02T05:34:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7797','2005-07-28T07:41:07.000','4180','370','2005-07-31T04:13:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7798','2005-07-28T07:41:59.000','3281','236','2005-07-31T12:36:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7799','2005-07-28T07:42:09.000','2163','384','2005-08-02T10:02:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7800','2005-07-28T07:50:59.000','3386','499','2005-07-29T07:31:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7801','2005-07-28T07:51:56.000','2052','9','2005-07-30T12:18:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7802','2005-07-28T07:51:57.000','1108','298','2005-07-29T09:32:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7803','2005-07-28T07:52:13.000','3438','449','2005-08-03T13:35:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7804','2005-07-28T07:56:00.000','592','249','2005-07-30T10:33:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7805','2005-07-28T07:56:41.000','3204','366','2005-08-04T06:53:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7806','2005-07-28T07:58:17.000','4317','440','2005-08-06T10:15:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7807','2005-07-28T07:58:27.000','2204','504','2005-08-01T02:48:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7808','2005-07-28T07:58:56.000','4052','327','2005-08-02T10:49:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7809','2005-07-28T07:59:46.000','4150','94','2005-08-02T02:56:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7810','2005-07-28T08:00:38.000','30','537','2005-08-02T06:14:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7811','2005-07-28T08:06:01.000','3891','347','2005-07-30T10:08:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7812','2005-07-28T08:06:52.000','4556','237','2005-07-31T09:57:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7813','2005-07-28T08:08:27.000','4216','411','2005-07-30T03:08:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7814','2005-07-28T08:09:48.000','2662','258','2005-08-01T13:14:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7815','2005-07-28T08:14:11.000','3551','300','2005-07-30T02:34:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7816','2005-07-28T08:14:12.000','1422','283','2005-07-30T08:00:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7817','2005-07-28T08:20:55.000','600','259','2005-07-30T11:55:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7818','2005-07-28T08:25:00.000','1672','301','2005-07-29T14:07:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7819','2005-07-28T08:27:14.000','3182','100','2005-08-02T12:34:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7820','2005-07-28T08:28:51.000','4475','459','2005-08-05T10:00:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7821','2005-07-28T08:31:23.000','1184','433','2005-08-03T05:08:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7822','2005-07-28T08:31:45.000','1428','156','2005-07-31T11:06:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7823','2005-07-28T08:32:53.000','84','428','2005-08-06T11:59:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7824','2005-07-28T08:34:47.000','2241','153','2005-08-05T09:43:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7825','2005-07-28T08:34:57.000','4340','348','2005-08-06T02:45:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7826','2005-07-28T08:35:51.000','1473','214','2005-08-05T07:57:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7827','2005-07-28T08:37:22.000','659','422','2005-07-31T04:27:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7828','2005-07-28T08:40:46.000','1710','212','2005-07-30T14:22:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7829','2005-07-28T08:43:39.000','111','5','2005-08-04T14:33:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7830','2005-07-28T08:43:49.000','4492','144','2005-08-04T09:30:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7831','2005-07-28T08:44:21.000','4436','499','2005-07-30T03:25:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7832','2005-07-28T08:46:11.000','284','92','2005-08-04T06:55:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7833','2005-07-28T08:46:14.000','1166','263','2005-08-04T06:13:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7834','2005-07-28T08:46:43.000','4124','278','2005-07-31T07:09:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7835','2005-07-28T08:49:39.000','43','547','2005-08-02T07:16:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7836','2005-07-28T08:55:27.000','1770','481','2005-08-05T09:35:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7837','2005-07-28T08:58:32.000','115','374','2005-07-29T14:11:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7838','2005-07-28T09:00:21.000','2222','550','2005-07-29T05:52:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7839','2005-07-28T09:01:13.000','914','518','2005-08-04T11:46:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7840','2005-07-28T09:03:02.000','2899','482','2005-08-06T06:15:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7841','2005-07-28T09:04:45.000','1092','1','2005-07-30T12:37:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7842','2005-07-28T09:10:06.000','2447','276','2005-08-04T06:52:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7843','2005-07-28T09:10:22.000','3962','75','2005-08-01T11:27:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7844','2005-07-28T09:16:19.000','4220','187','2005-08-05T14:06:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7845','2005-07-28T09:18:07.000','38','352','2005-08-04T10:23:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7846','2005-07-28T09:21:18.000','4201','309','2005-08-06T07:10:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7847','2005-07-28T09:23:14.000','3602','323','2005-08-02T11:02:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7848','2005-07-28T09:24:31.000','162','509','2005-08-05T05:11:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7849','2005-07-28T09:30:02.000','996','423','2005-08-06T12:41:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7850','2005-07-28T09:31:13.000','2913','118','2005-08-02T14:06:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7851','2005-07-28T09:31:58.000','3596','253','2005-08-04T09:58:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7852','2005-07-28T09:34:29.000','3462','123','2005-07-30T05:48:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7853','2005-07-28T09:36:38.000','4053','318','2005-07-29T15:01:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7854','2005-07-28T09:42:31.000','3531','84','2005-08-02T09:25:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7855','2005-07-28T09:43:02.000','2474','288','2005-07-30T12:57:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7856','2005-07-28T09:48:24.000','2376','375','2005-07-29T09:49:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7857','2005-07-28T09:49:40.000','4027','500','2005-08-01T05:34:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7858','2005-07-28T09:50:18.000','992','144','2005-08-05T14:33:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7859','2005-07-28T09:57:17.000','3392','547','2005-08-04T06:04:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7860','2005-07-28T09:58:02.000','2400','241','2005-08-05T06:04:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7861','2005-07-28T10:02:01.000','1781','208','2005-08-06T13:17:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7862','2005-07-28T10:02:25.000','2507','299','2005-08-05T13:10:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7863','2005-07-28T10:05:46.000','1212','182','2005-07-29T14:42:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7864','2005-07-28T10:06:10.000','1238','20','2005-08-04T08:38:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7865','2005-07-28T10:07:04.000','2334','148','2005-08-06T08:16:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7866','2005-07-28T10:08:01.000','1602','101','2005-08-04T09:29:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7867','2005-07-28T10:08:54.000','713','297','2005-07-30T10:26:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7868','2005-07-28T10:08:55.000','3589','43','2005-07-30T11:52:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7869','2005-07-28T10:13:15.000','3005','298','2005-08-03T12:58:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7870','2005-07-28T10:16:03.000','970','240','2005-07-31T16:06:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7871','2005-07-28T10:16:37.000','3990','491','2005-08-05T11:24:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7872','2005-07-28T10:18:16.000','826','66','2005-07-31T10:57:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7873','2005-07-28T10:19:46.000','2947','82','2005-07-31T04:43:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7874','2005-07-28T10:21:52.000','2981','86','2005-08-06T16:19:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7875','2005-07-28T10:23:48.000','3693','504','2005-08-02T12:09:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7876','2005-07-28T10:24:22.000','3563','577','2005-08-04T07:15:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7877','2005-07-28T10:25:36.000','2576','65','2005-08-05T12:46:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7878','2005-07-28T10:27:10.000','1564','141','2005-07-29T11:22:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7879','2005-07-28T10:27:46.000','1969','125','2005-07-31T07:48:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7880','2005-07-28T10:30:37.000','3670','182','2005-08-03T08:05:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7881','2005-07-28T10:33:22.000','533','249','2005-08-02T12:10:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7882','2005-07-28T10:33:42.000','3922','516','2005-07-29T13:49:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7883','2005-07-28T10:37:20.000','447','526','2005-08-02T05:08:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7884','2005-07-28T10:37:24.000','3871','502','2005-07-31T10:31:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7885','2005-07-28T10:37:41.000','4294','260','2005-08-05T07:56:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7886','2005-07-28T10:37:55.000','237','352','2005-08-04T13:22:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7887','2005-07-28T10:40:12.000','2820','253','2005-08-02T06:09:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7888','2005-07-28T10:40:24.000','545','378','2005-08-01T16:18:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7889','2005-07-28T10:43:21.000','3123','416','2005-07-30T09:11:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7890','2005-07-28T10:43:40.000','3443','553','2005-07-31T06:07:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7891','2005-07-28T10:43:56.000','3637','560','2005-08-05T14:04:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7892','2005-07-28T10:46:58.000','2717','397','2005-07-30T16:03:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7893','2005-07-28T10:49:27.000','3058','479','2005-08-02T06:46:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7894','2005-07-28T10:53:58.000','3532','330','2005-08-02T13:42:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7895','2005-07-28T10:57:15.000','900','67','2005-08-02T15:10:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7896','2005-07-28T11:00:58.000','3561','389','2005-08-04T14:30:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7897','2005-07-28T11:01:51.000','1396','75','2005-07-31T13:13:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7898','2005-07-28T11:08:22.000','2680','499','2005-08-03T12:28:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7899','2005-07-28T11:10:12.000','4130','452','2005-08-02T13:20:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7900','2005-07-28T11:11:33.000','2781','154','2005-08-05T06:29:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7901','2005-07-28T11:12:12.000','4435','280','2005-08-01T08:13:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7902','2005-07-28T11:14:19.000','3066','356','2005-07-30T09:01:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7903','2005-07-28T11:20:36.000','2767','588','2005-07-31T09:16:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7904','2005-07-28T11:25:39.000','316','477','2005-08-06T08:22:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7905','2005-07-28T11:26:57.000','4287','455','2005-08-02T06:14:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7906','2005-07-28T11:31:42.000','1216','85','2005-08-01T11:56:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7907','2005-07-28T11:32:00.000','3252','433','2005-07-30T15:27:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7908','2005-07-28T11:32:57.000','3646','360','2005-08-03T13:30:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7909','2005-07-28T11:38:08.000','3355','210','2005-07-29T13:54:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7910','2005-07-28T11:44:56.000','2044','480','2005-08-05T14:37:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7911','2005-07-28T11:46:45.000','390','3','2005-07-29T07:19:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7912','2005-07-28T11:46:58.000','745','127','2005-08-05T12:50:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7913','2005-07-28T11:47:23.000','4001','459','2005-08-05T06:36:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7914','2005-07-28T11:48:08.000','2796','469','2005-07-30T14:14:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7915','2005-07-28T11:49:46.000','2088','186','2005-08-04T12:21:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7916','2005-07-28T11:49:53.000','3877','13','2005-07-29T15:01:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7917','2005-07-28T11:56:57.000','2071','416','2005-07-29T14:06:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7918','2005-07-28T11:58:53.000','63','473','2005-08-04T12:08:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7919','2005-07-28T11:59:45.000','2138','36','2005-08-06T11:19:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7920','2005-07-28T12:01:19.000','66','48','2005-08-05T07:08:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7921','2005-07-28T12:02:46.000','116','100','2005-08-01T12:08:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7922','2005-07-28T12:05:25.000','817','125','2005-08-02T12:13:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7923','2005-07-28T12:08:29.000','2273','458','2005-08-04T12:30:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7924','2005-07-28T12:08:53.000','656','97','2005-07-30T06:45:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7925','2005-07-28T12:10:02.000','1763','500','2005-08-02T15:50:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7926','2005-07-28T12:13:02.000','180','78','2005-08-05T08:54:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7927','2005-07-28T12:13:42.000','1263','27','2005-08-05T12:02:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7928','2005-07-28T12:15:51.000','912','473','2005-08-05T06:34:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7929','2005-07-28T12:16:40.000','2652','307','2005-07-31T13:09:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7930','2005-07-28T12:21:08.000','4181','320','2005-07-30T11:56:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7931','2005-07-28T12:23:41.000','1923','326','2005-08-06T09:49:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7932','2005-07-28T12:24:54.000','3738','462','2005-07-30T11:33:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7933','2005-07-28T12:27:27.000','3175','297','2005-07-29T10:34:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7934','2005-07-28T12:33:10.000','2642','332','2005-08-04T07:40:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7935','2005-07-28T12:33:17.000','3664','462','2005-08-04T14:40:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7936','2005-07-28T12:33:21.000','563','520','2005-07-30T13:31:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7937','2005-07-28T12:38:22.000','3944','323','2005-07-29T09:19:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7938','2005-07-28T12:39:11.000','2579','114','2005-08-04T16:56:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7939','2005-07-28T12:45:47.000','2004','37','2005-07-30T18:32:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7940','2005-07-28T12:46:47.000','901','409','2005-07-29T06:46:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7941','2005-07-28T12:47:20.000','439','566','2005-08-01T08:46:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7942','2005-07-28T12:49:44.000','1636','56','2005-07-31T18:07:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7943','2005-07-28T12:50:55.000','2914','346','2005-08-04T11:29:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7944','2005-07-28T12:51:22.000','3148','504','2005-07-30T12:19:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7945','2005-07-28T12:53:58.000','3326','316','2005-08-03T14:04:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7946','2005-07-28T13:01:22.000','99','90','2005-08-03T15:27:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7947','2005-07-28T13:05:50.000','2504','279','2005-08-02T11:16:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7948','2005-07-28T13:06:16.000','215','589','2005-08-05T08:38:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7949','2005-07-28T13:07:24.000','2145','487','2005-08-02T09:41:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7950','2005-07-28T13:21:00.000','2286','122','2005-08-05T18:47:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7951','2005-07-28T13:21:16.000','3979','237','2005-08-06T08:21:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7952','2005-07-28T13:23:49.000','3313','158','2005-08-01T08:50:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7953','2005-07-28T13:24:32.000','4471','319','2005-08-05T16:09:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7954','2005-07-28T13:25:05.000','3735','145','2005-07-29T18:50:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7955','2005-07-28T13:31:36.000','1519','522','2005-07-30T10:03:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7956','2005-07-28T13:32:17.000','4335','118','2005-08-06T14:51:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7957','2005-07-28T13:34:08.000','1623','78','2005-08-05T07:58:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7958','2005-07-28T13:34:34.000','421','593','2005-07-29T16:03:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7959','2005-07-28T13:43:20.000','1549','178','2005-08-02T12:13:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7960','2005-07-28T13:47:08.000','2718','324','2005-08-03T15:17:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7961','2005-07-28T13:47:21.000','3284','45','2005-08-01T09:33:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7962','2005-07-28T13:48:09.000','1746','126','2005-08-03T19:21:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7963','2005-07-28T13:48:38.000','921','247','2005-08-06T19:37:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7964','2005-07-28T13:49:58.000','2528','574','2005-08-03T10:03:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7965','2005-07-28T13:52:57.000','3671','134','2005-07-29T14:54:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7966','2005-07-28T13:53:54.000','2514','91','2005-08-06T15:32:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7967','2005-07-28T13:56:51.000','2040','187','2005-08-03T19:38:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7968','2005-07-28T13:57:35.000','3865','597','2005-08-04T13:40:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7969','2005-07-28T13:57:37.000','2224','123','2005-08-04T19:31:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7970','2005-07-28T13:58:38.000','998','507','2005-08-02T12:27:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7971','2005-07-28T14:00:47.000','1910','445','2005-08-02T10:01:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7972','2005-07-28T14:07:46.000','2930','269','2005-08-01T11:28:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7973','2005-07-28T14:10:06.000','3936','339','2005-07-29T11:26:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7974','2005-07-28T14:11:57.000','2442','380','2005-08-02T19:25:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7975','2005-07-28T14:12:47.000','2565','211','2005-08-05T09:18:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7976','2005-07-28T14:13:24.000','2296','205','2005-08-05T09:01:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7977','2005-07-28T14:15:54.000','3162','389','2005-08-01T18:58:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7978','2005-07-28T14:16:14.000','508','431','2005-08-01T12:53:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7979','2005-07-28T14:16:30.000','3303','94','2005-08-03T09:39:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7980','2005-07-28T14:16:49.000','1019','329','2005-08-05T09:20:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7981','2005-07-28T14:18:25.000','90','392','2005-08-04T15:21:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7982','2005-07-28T14:19:59.000','668','71','2005-07-29T14:09:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7983','2005-07-28T14:23:01.000','1836','115','2005-07-29T11:51:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7984','2005-07-28T14:27:51.000','2893','208','2005-08-04T17:34:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7985','2005-07-28T14:29:01.000','4022','388','2005-08-03T17:20:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7986','2005-07-28T14:30:13.000','1283','395','2005-08-05T09:35:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7987','2005-07-28T14:36:52.000','288','443','2005-08-05T16:49:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7988','2005-07-28T14:37:18.000','2906','517','2005-08-05T10:53:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7989','2005-07-28T14:39:05.000','3196','149','2005-08-05T13:58:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7990','2005-07-28T14:43:08.000','188','232','2005-08-01T10:51:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7991','2005-07-28T14:45:45.000','1133','59','2005-07-29T15:05:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7992','2005-07-28T14:53:06.000','1851','33','2005-07-29T18:17:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7993','2005-07-28T14:56:41.000','2926','353','2005-08-01T17:01:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7994','2005-07-28T14:56:54.000','2431','21','2005-07-30T09:56:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7995','2005-07-28T15:00:09.000','536','89','2005-08-01T12:33:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7996','2005-07-28T15:00:49.000','2171','408','2005-08-04T20:58:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7997','2005-07-28T15:02:25.000','1845','591','2005-08-04T14:35:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7998','2005-07-28T15:08:48.000','1397','598','2005-07-31T16:14:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('7999','2005-07-28T15:10:14.000','2750','170','2005-08-06T17:08:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8000','2005-07-28T15:10:25.000','1644','212','2005-08-06T19:15:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8001','2005-07-28T15:10:55.000','2570','10','2005-08-05T18:23:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8002','2005-07-28T15:11:00.000','22','449','2005-07-31T15:46:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8003','2005-07-28T15:11:27.000','2775','89','2005-08-04T18:35:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8004','2005-07-28T15:14:07.000','4428','393','2005-07-30T19:32:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8005','2005-07-28T15:15:11.000','670','488','2005-07-29T14:54:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8006','2005-07-28T15:15:41.000','3959','109','2005-08-05T19:29:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8007','2005-07-28T15:22:27.000','1942','525','2005-07-30T13:06:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8008','2005-07-28T15:25:55.000','2093','41','2005-08-04T13:16:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8009','2005-07-28T15:25:58.000','337','372','2005-08-04T10:16:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8010','2005-07-28T15:26:20.000','68','467','2005-08-04T18:39:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8011','2005-07-28T15:26:39.000','4274','497','2005-07-30T13:59:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8012','2005-07-28T15:29:00.000','1513','343','2005-08-05T12:28:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8013','2005-07-28T15:30:26.000','2074','403','2005-08-05T16:29:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8014','2005-07-28T15:32:07.000','2339','11','2005-07-31T20:52:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8015','2005-07-28T15:33:03.000','1814','23','2005-07-30T15:32:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8016','2005-07-28T15:35:41.000','516','391','2005-07-30T20:06:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8017','2005-07-28T15:35:41.000','1764','328','2005-08-01T19:12:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8018','2005-07-28T15:36:48.000','4129','377','2005-08-06T20:04:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8019','2005-07-28T15:37:43.000','1844','84','2005-08-04T15:40:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8020','2005-07-28T15:43:32.000','4459','498','2005-08-05T12:19:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8021','2005-07-28T15:45:24.000','1920','501','2005-08-04T10:49:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8022','2005-07-28T15:48:56.000','294','314','2005-08-06T13:40:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8023','2005-07-28T15:53:29.000','2133','411','2005-07-31T12:26:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8024','2005-07-28T15:55:40.000','1735','90','2005-08-02T09:56:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8025','2005-07-28T16:03:27.000','2932','421','2005-08-03T21:58:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8026','2005-07-28T16:05:38.000','4225','511','2005-07-29T21:28:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8027','2005-07-28T16:09:57.000','1335','436','2005-08-05T18:17:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8028','2005-07-28T16:11:15.000','2715','137','2005-08-05T15:11:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8029','2005-07-28T16:11:21.000','4273','61','2005-08-05T13:52:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8030','2005-07-28T16:12:53.000','2633','30','2005-07-31T17:15:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8031','2005-07-28T16:15:49.000','2196','40','2005-08-02T18:27:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8032','2005-07-28T16:17:00.000','431','230','2005-07-29T13:32:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8033','2005-07-28T16:18:23.000','4268','1','2005-07-30T17:56:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8034','2005-07-28T16:20:26.000','1997','502','2005-08-04T19:11:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8035','2005-07-28T16:23:01.000','1503','14','2005-08-05T10:52:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8036','2005-07-28T16:27:43.000','2741','412','2005-08-01T13:41:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8037','2005-07-28T16:31:20.000','3973','409','2005-07-31T12:18:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8038','2005-07-28T16:32:55.000','1225','30','2005-07-30T21:08:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8039','2005-07-28T16:35:16.000','1996','203','2005-07-30T14:49:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8040','2005-07-28T16:39:43.000','4543','163','2005-08-02T20:00:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8041','2005-07-28T16:39:56.000','763','357','2005-07-30T18:44:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8042','2005-07-28T16:45:11.000','4325','14','2005-08-04T17:16:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8043','2005-07-28T16:45:44.000','208','577','2005-08-01T12:26:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8044','2005-07-28T16:49:12.000','879','442','2005-08-02T22:41:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8045','2005-07-28T16:49:38.000','3427','368','2005-08-03T15:42:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8046','2005-07-28T16:49:41.000','2873','120','2005-07-31T21:33:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8047','2005-07-28T16:49:43.000','2936','292','2005-08-03T14:48:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8048','2005-07-28T16:50:26.000','2721','182','2005-08-06T19:20:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8049','2005-07-28T16:51:58.000','673','42','2005-07-31T22:18:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8050','2005-07-28T16:55:47.000','1864','488','2005-08-02T13:20:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8051','2005-07-28T16:56:16.000','4405','192','2005-07-29T22:48:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8052','2005-07-28T16:57:31.000','2460','166','2005-08-03T18:03:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8053','2005-07-28T16:59:41.000','1511','526','2005-08-03T22:28:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8054','2005-07-28T17:02:18.000','1062','225','2005-08-06T11:55:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8055','2005-07-28T17:02:32.000','4162','304','2005-07-31T22:05:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8056','2005-07-28T17:04:15.000','4018','589','2005-08-03T19:11:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8057','2005-07-28T17:07:13.000','4177','483','2005-08-03T16:25:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8058','2005-07-28T17:07:49.000','2148','404','2005-08-03T22:57:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8059','2005-07-28T17:09:59.000','2611','372','2005-07-31T15:42:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8060','2005-07-28T17:10:02.000','3765','577','2005-08-05T17:11:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8061','2005-07-28T17:12:53.000','650','467','2005-08-05T13:56:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8062','2005-07-28T17:15:06.000','1384','317','2005-07-30T16:56:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8063','2005-07-28T17:15:11.000','935','163','2005-08-04T16:45:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8064','2005-07-28T17:15:38.000','3788','488','2005-08-04T18:04:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8065','2005-07-28T17:15:48.000','413','220','2005-08-04T15:49:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8066','2005-07-28T17:20:09.000','3208','462','2005-07-31T18:36:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8067','2005-07-28T17:20:17.000','3923','209','2005-07-29T21:55:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8068','2005-07-28T17:22:28.000','209','216','2005-07-29T12:24:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8069','2005-07-28T17:23:46.000','2822','178','2005-07-30T16:19:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8070','2005-07-28T17:26:56.000','1606','89','2005-08-01T17:33:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8071','2005-07-28T17:27:48.000','2582','131','2005-08-03T11:48:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8072','2005-07-28T17:27:59.000','2347','99','2005-07-30T19:08:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8073','2005-07-28T17:29:02.000','630','314','2005-08-01T22:17:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8074','2005-07-28T17:33:39.000','1558','1','2005-07-29T20:17:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8075','2005-07-28T17:37:28.000','2175','61','2005-07-29T11:56:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8076','2005-07-28T17:45:58.000','214','17','2005-08-04T18:07:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8077','2005-07-28T17:54:35.000','3253','122','2005-07-29T19:28:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8078','2005-07-28T17:54:42.000','3839','407','2005-07-30T18:18:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8079','2005-07-28T17:58:36.000','3564','432','2005-07-29T14:48:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8080','2005-07-28T18:05:06.000','3035','406','2005-07-29T22:44:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8081','2005-07-28T18:06:46.000','4404','362','2005-08-04T18:54:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8082','2005-07-28T18:08:02.000','3089','423','2005-08-04T14:33:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8083','2005-07-28T18:09:48.000','2187','30','2005-08-04T21:47:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8084','2005-07-28T18:11:58.000','911','571','2005-08-03T23:41:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8085','2005-07-28T18:13:15.000','3059','552','2005-08-04T13:45:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8086','2005-07-28T18:17:14.000','1182','3','2005-07-30T18:22:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8087','2005-07-28T18:21:16.000','1913','295','2005-08-03T12:38:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8088','2005-07-28T18:23:49.000','2590','343','2005-08-06T23:25:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8089','2005-07-28T18:26:47.000','1414','50','2005-08-03T21:28:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8090','2005-07-28T18:27:29.000','1336','387','2005-08-02T14:08:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8091','2005-07-28T18:27:29.000','3025','126','2005-08-01T19:45:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8092','2005-07-28T18:28:07.000','2034','167','2005-07-30T19:17:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8093','2005-07-28T18:29:16.000','1427','533','2005-08-05T21:49:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8094','2005-07-28T18:30:28.000','4276','432','2005-08-05T17:37:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8095','2005-07-28T18:32:40.000','2685','42','2005-08-06T23:45:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8096','2005-07-28T18:32:46.000','502','506','2005-08-06T15:00:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8097','2005-07-28T18:32:49.000','2719','436','2005-08-06T16:09:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8098','2005-07-28T18:34:20.000','1757','41','2005-07-31T19:07:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8099','2005-07-28T18:35:12.000','3694','36','2005-07-30T15:44:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8100','2005-07-28T18:43:11.000','2859','11','2005-08-02T15:56:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8101','2005-07-28T18:47:23.000','731','6','2005-07-31T16:23:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8102','2005-07-28T18:49:43.000','4505','237','2005-08-03T23:04:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8103','2005-07-28T18:50:14.000','4472','397','2005-08-04T16:53:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8104','2005-07-28T18:59:36.000','1080','533','2005-08-03T22:05:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8105','2005-07-28T18:59:46.000','1316','314','2005-07-29T22:51:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8106','2005-07-28T19:02:46.000','963','137','2005-07-30T20:48:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8107','2005-07-28T19:03:16.000','1318','518','2005-08-05T17:18:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8108','2005-07-28T19:07:38.000','1600','295','2005-08-03T15:13:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8109','2005-07-28T19:07:44.000','652','407','2005-07-31T14:59:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8110','2005-07-28T19:07:45.000','1244','225','2005-08-04T22:12:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8111','2005-07-28T19:10:03.000','3226','148','2005-07-29T22:25:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8112','2005-07-28T19:11:07.000','2444','528','2005-08-03T18:41:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8113','2005-07-28T19:14:00.000','4269','541','2005-08-06T00:05:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8114','2005-07-28T19:14:06.000','815','509','2005-08-05T13:16:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8115','2005-07-28T19:14:17.000','2080','106','2005-08-03T14:58:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8116','2005-07-28T19:20:07.000','4497','1','2005-07-29T22:54:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8117','2005-07-28T19:20:16.000','1502','300','2005-08-05T23:55:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8118','2005-07-28T19:22:22.000','331','566','2005-08-01T22:13:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8119','2005-07-28T19:23:15.000','1542','398','2005-08-04T15:53:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8120','2005-07-28T19:24:24.000','3993','235','2005-07-31T14:31:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8121','2005-07-28T19:25:45.000','2229','363','2005-08-02T13:30:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8122','2005-07-28T19:27:37.000','2141','18','2005-07-29T19:48:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8123','2005-07-28T19:28:23.000','2256','138','2005-08-04T19:41:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8124','2005-07-28T19:28:58.000','1187','357','2005-07-31T00:45:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8125','2005-07-28T19:31:48.000','4330','96','2005-07-30T01:09:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8126','2005-07-28T19:32:41.000','719','537','2005-08-05T00:33:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8127','2005-07-28T19:45:19.000','4265','20','2005-07-31T22:07:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8128','2005-07-28T19:46:06.000','2872','71','2005-08-06T16:10:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8129','2005-07-28T19:47:02.000','2546','345','2005-07-31T21:33:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8130','2005-07-28T19:48:15.000','4055','499','2005-08-05T14:18:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8131','2005-07-28T19:55:21.000','437','281','2005-08-02T21:52:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8132','2005-07-28T19:57:31.000','1303','562','2005-08-02T22:16:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8133','2005-07-28T20:01:06.000','849','461','2005-08-01T20:01:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8134','2005-07-28T20:01:23.000','1695','41','2005-08-03T01:00:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8135','2005-07-28T20:03:25.000','1339','164','2005-08-03T01:28:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8136','2005-07-28T20:05:48.000','3434','429','2005-08-01T20:31:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8137','2005-07-28T20:07:18.000','3188','312','2005-08-03T17:41:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8138','2005-07-28T20:12:17.000','1258','371','2005-08-01T15:21:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8139','2005-07-28T20:16:30.000','3651','177','2005-08-03T18:00:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8140','2005-07-28T20:17:50.000','4270','119','2005-07-30T18:07:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8141','2005-07-28T20:21:19.000','361','523','2005-07-30T19:16:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8142','2005-07-28T20:21:54.000','1075','322','2005-07-31T18:39:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8143','2005-07-28T20:23:11.000','3629','429','2005-08-01T18:17:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8144','2005-07-28T20:30:55.000','3556','320','2005-07-31T18:10:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8145','2005-07-28T20:34:41.000','937','198','2005-08-05T15:28:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8146','2005-07-28T20:37:36.000','2430','476','2005-07-31T16:03:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8147','2005-07-28T20:37:56.000','628','228','2005-07-30T18:26:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8148','2005-07-28T20:39:47.000','537','347','2005-08-02T16:29:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8149','2005-07-28T20:48:12.000','1790','591','2005-08-01T20:07:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8150','2005-07-28T20:50:41.000','3489','497','2005-08-02T00:43:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8151','2005-07-28T20:50:52.000','4370','495','2005-07-31T14:50:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8152','2005-07-28T20:53:05.000','2557','46','2005-08-06T20:03:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8153','2005-07-28T20:55:49.000','2173','347','2005-08-01T15:56:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8154','2005-07-28T20:56:18.000','1180','285','2005-08-01T21:56:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8155','2005-07-28T20:57:06.000','3023','428','2005-08-02T18:40:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8156','2005-07-28T20:59:04.000','1977','257','2005-08-01T01:52:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8157','2005-07-28T21:06:45.000','915','566','2005-08-04T16:06:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8158','2005-07-28T21:08:46.000','4327','458','2005-08-01T21:50:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8159','2005-07-28T21:09:28.000','1118','47','2005-08-04T15:34:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8160','2005-07-28T21:10:30.000','2446','138','2005-08-05T16:52:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8161','2005-07-28T21:11:00.000','848','555','2005-08-03T23:32:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8162','2005-07-28T21:11:46.000','4393','107','2005-08-04T18:26:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8163','2005-07-28T21:11:48.000','1919','157','2005-07-31T18:30:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8164','2005-07-28T21:17:19.000','1674','461','2005-07-30T21:12:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8165','2005-07-28T21:23:06.000','3460','197','2005-08-01T21:32:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8166','2005-07-28T21:23:33.000','3906','42','2005-08-03T21:07:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8167','2005-07-28T21:25:45.000','3181','311','2005-08-04T18:04:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8168','2005-07-28T21:28:32.000','1120','365','2005-07-30T02:10:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8169','2005-07-28T21:29:46.000','4086','366','2005-08-06T22:29:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8170','2005-07-28T21:32:29.000','2495','40','2005-08-03T22:02:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8171','2005-07-28T21:32:57.000','3380','296','2005-07-30T21:19:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8172','2005-07-28T21:34:36.000','1237','329','2005-08-06T23:53:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8173','2005-07-28T21:35:44.000','4377','332','2005-08-06T19:15:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8174','2005-07-28T21:36:52.000','465','359','2005-08-04T00:32:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8175','2005-07-28T21:38:16.000','641','429','2005-08-07T01:34:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8176','2005-07-28T21:42:08.000','3527','347','2005-08-03T22:59:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8177','2005-07-28T21:43:54.000','3696','122','2005-08-02T22:38:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8178','2005-07-28T21:54:31.000','2825','503','2005-08-02T23:56:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8179','2005-07-28T22:05:13.000','2902','578','2005-07-30T21:57:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8180','2005-07-28T22:05:24.000','3236','281','2005-08-01T19:09:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8181','2005-07-28T22:18:38.000','357','522','2005-08-06T02:43:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8182','2005-07-28T22:19:12.000','4120','427','2005-08-01T22:40:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8183','2005-07-28T22:21:07.000','1545','119','2005-08-04T19:20:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8184','2005-07-28T22:22:35.000','1249','160','2005-07-31T19:30:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8185','2005-07-28T22:23:49.000','2452','568','2005-07-31T00:07:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8186','2005-07-28T22:30:27.000','4255','102','2005-07-31T21:08:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8187','2005-07-28T22:33:53.000','945','87','2005-08-03T03:54:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8188','2005-07-28T22:34:12.000','3826','10','2005-08-01T02:32:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8189','2005-07-28T22:36:26.000','3515','361','2005-08-04T00:12:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8190','2005-07-28T22:47:06.000','2290','267','2005-08-04T21:51:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8191','2005-07-28T22:47:14.000','1777','508','2005-07-31T23:13:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8192','2005-07-28T22:49:11.000','255','552','2005-07-30T04:13:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8193','2005-07-28T22:50:50.000','2402','15','2005-08-01T04:14:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8194','2005-07-28T22:51:44.000','1148','424','2005-07-29T17:13:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8195','2005-07-28T22:52:58.000','3989','590','2005-08-04T02:12:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8196','2005-07-28T22:56:11.000','3435','21','2005-08-06T04:53:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8197','2005-07-28T23:04:10.000','4126','407','2005-08-05T00:06:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8198','2005-07-28T23:08:05.000','1767','356','2005-08-06T00:43:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8199','2005-07-28T23:10:25.000','404','471','2005-08-04T23:30:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8200','2005-07-28T23:10:46.000','353','185','2005-07-29T18:35:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8201','2005-07-28T23:10:48.000','220','567','2005-08-01T00:50:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8202','2005-07-28T23:11:45.000','3802','75','2005-08-03T21:57:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8203','2005-07-28T23:14:56.000','3878','100','2005-07-31T04:19:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8204','2005-07-28T23:18:29.000','2472','398','2005-08-02T04:49:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8205','2005-07-28T23:18:48.000','2944','434','2005-07-30T00:37:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8206','2005-07-28T23:20:31.000','2979','422','2005-08-04T21:36:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8207','2005-07-28T23:26:31.000','1195','475','2005-08-06T03:26:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8208','2005-07-28T23:26:35.000','1362','530','2005-08-01T23:00:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8209','2005-07-28T23:29:28.000','2484','127','2005-08-07T04:22:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8210','2005-07-28T23:31:05.000','3424','300','2005-08-06T17:36:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8211','2005-07-28T23:34:22.000','1859','193','2005-08-04T21:18:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8212','2005-07-28T23:37:23.000','1305','159','2005-08-04T04:33:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8213','2005-07-28T23:37:33.000','3816','17','2005-07-31T00:32:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8214','2005-07-28T23:37:57.000','352','509','2005-08-07T00:29:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8215','2005-07-28T23:43:56.000','2921','437','2005-08-03T19:30:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8216','2005-07-28T23:43:59.000','2211','254','2005-08-06T05:05:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8217','2005-07-28T23:44:13.000','3747','206','2005-08-03T21:27:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8218','2005-07-28T23:45:41.000','2769','578','2005-08-02T00:14:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8219','2005-07-28T23:46:31.000','3609','227','2005-08-03T00:11:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8220','2005-07-28T23:46:41.000','1061','360','2005-07-31T22:14:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8221','2005-07-28T23:47:19.000','3138','496','2005-08-02T20:42:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8222','2005-07-28T23:51:53.000','2999','278','2005-08-05T22:48:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8223','2005-07-28T23:56:01.000','4508','282','2005-08-03T22:27:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8224','2005-07-28T23:59:02.000','1995','467','2005-08-02T04:54:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8225','2005-07-28T23:59:29.000','3631','41','2005-07-30T03:27:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8226','2005-07-29T00:01:04.000','3541','368','2005-08-01T19:08:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8227','2005-07-29T00:02:22.000','269','167','2005-07-31T04:05:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8228','2005-07-29T00:08:58.000','1955','72','2005-08-03T00:12:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8229','2005-07-29T00:09:08.000','4272','498','2005-07-31T19:29:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8230','2005-07-29T00:12:59.000','1937','2','2005-08-06T19:52:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8231','2005-07-29T00:14:37.000','1083','331','2005-07-31T19:12:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8232','2005-07-29T00:14:37.000','3255','526','2005-08-06T00:57:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8233','2005-07-29T00:16:23.000','1640','93','2005-08-03T05:17:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8234','2005-07-29T00:19:20.000','644','227','2005-08-03T19:16:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8235','2005-07-29T00:22:56.000','1581','320','2005-08-03T04:03:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8236','2005-07-29T00:27:04.000','1901','369','2005-07-31T05:02:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8237','2005-07-29T00:29:56.000','608','441','2005-08-06T03:10:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8238','2005-07-29T00:30:06.000','2941','320','2005-08-02T22:52:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8239','2005-07-29T00:31:39.000','3951','549','2005-07-29T19:33:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8240','2005-07-29T00:33:32.000','1975','509','2005-08-05T21:25:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8241','2005-07-29T00:33:36.000','4297','26','2005-08-03T01:31:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8242','2005-07-29T00:34:27.000','509','99','2005-08-05T23:13:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8243','2005-07-29T00:35:33.000','1873','481','2005-08-04T06:02:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8244','2005-07-29T00:35:34.000','1552','175','2005-08-05T04:18:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8245','2005-07-29T00:37:09.000','3330','555','2005-08-05T05:48:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8246','2005-07-29T00:38:41.000','1724','146','2005-08-05T06:28:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8247','2005-07-29T00:41:38.000','2607','539','2005-08-06T20:29:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8248','2005-07-29T00:41:56.000','2017','272','2005-08-05T18:53:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8249','2005-07-29T00:48:44.000','3331','57','2005-08-07T04:25:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8250','2005-07-29T00:49:15.000','4519','533','2005-08-04T02:53:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8251','2005-07-29T00:50:14.000','2317','408','2005-08-03T23:52:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8252','2005-07-29T00:54:17.000','3312','257','2005-07-31T20:34:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8253','2005-07-29T00:57:06.000','2388','76','2005-08-07T01:46:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8254','2005-07-29T00:59:31.000','1787','392','2005-08-03T23:43:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8255','2005-07-29T01:02:30.000','3715','224','2005-08-01T22:39:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8256','2005-07-29T01:02:42.000','1483','537','2005-07-31T22:29:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8257','2005-07-29T01:03:20.000','3024','566','2005-08-04T21:54:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8258','2005-07-29T01:03:42.000','1379','370','2005-08-04T22:08:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8259','2005-07-29T01:05:16.000','343','274','2005-08-01T23:27:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8260','2005-07-29T01:11:00.000','4249','366','2005-08-06T00:36:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8261','2005-07-29T01:11:05.000','1915','50','2005-08-04T03:13:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8262','2005-07-29T01:11:18.000','1341','563','2005-08-02T05:17:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8263','2005-07-29T01:11:23.000','28','5','2005-07-31T01:53:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8264','2005-07-29T01:18:50.000','2987','175','2005-08-03T05:31:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8265','2005-07-29T01:20:15.000','2389','409','2005-08-06T19:32:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8266','2005-07-29T01:20:16.000','1972','196','2005-07-30T04:31:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8267','2005-07-29T01:21:02.000','4107','131','2005-08-04T19:34:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8268','2005-07-29T01:23:23.000','4239','421','2005-08-05T01:36:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8269','2005-07-29T01:26:54.000','2778','376','2005-08-04T22:42:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8270','2005-07-29T01:27:22.000','3565','282','2005-07-29T20:55:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8271','2005-07-29T01:27:44.000','83','481','2005-08-07T05:01:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8272','2005-07-29T01:29:51.000','70','346','2005-08-03T21:56:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8273','2005-07-29T01:33:16.000','4244','532','2005-08-06T04:26:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8274','2005-07-29T01:34:32.000','2634','340','2005-08-01T20:15:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8275','2005-07-29T01:35:47.000','4432','336','2005-07-30T02:16:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8276','2005-07-29T01:38:43.000','2451','466','2005-08-03T23:00:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8277','2005-07-29T01:38:53.000','1296','13','2005-08-04T07:09:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8278','2005-07-29T01:42:55.000','768','265','2005-08-05T01:55:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8279','2005-07-29T01:43:37.000','3838','176','2005-08-03T02:36:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8280','2005-07-29T01:45:51.000','1208','195','2005-08-05T22:51:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8281','2005-07-29T01:46:00.000','899','441','2005-08-04T23:09:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8282','2005-07-29T01:49:04.000','980','462','2005-08-05T01:51:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8283','2005-07-29T01:52:22.000','2002','300','2005-08-05T03:22:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8284','2005-07-29T01:56:40.000','4371','446','2005-08-07T07:15:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8285','2005-07-29T02:00:18.000','678','56','2005-08-03T20:43:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8286','2005-07-29T02:02:46.000','4092','87','2005-08-06T06:00:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8287','2005-07-29T02:03:58.000','812','178','2005-08-07T02:11:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8288','2005-07-29T02:04:22.000','1822','55','2005-08-05T04:21:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8289','2005-07-29T02:23:24.000','4579','459','2005-08-06T03:23:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8290','2005-07-29T02:24:08.000','3823','462','2005-08-03T01:02:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8291','2005-07-29T02:28:25.000','2817','455','2005-08-03T20:57:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8292','2005-07-29T02:29:36.000','4003','192','2005-08-07T08:06:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8293','2005-07-29T02:30:50.000','831','71','2005-08-04T03:09:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8294','2005-07-29T02:32:41.000','1811','520','2005-08-02T06:28:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8295','2005-07-29T02:42:14.000','2065','406','2005-07-30T22:22:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8296','2005-07-29T02:43:25.000','2543','88','2005-08-01T00:23:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8297','2005-07-29T02:45:46.000','3774','349','2005-07-31T20:49:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8298','2005-07-29T02:47:36.000','952','493','2005-08-05T07:58:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8299','2005-07-29T02:56:00.000','1797','173','2005-07-30T22:35:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8300','2005-07-29T02:57:59.000','4364','222','2005-08-05T01:12:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8301','2005-07-29T03:00:08.000','562','101','2005-08-01T04:26:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8302','2005-07-29T03:01:24.000','1314','103','2005-07-30T01:08:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8303','2005-07-29T03:05:56.000','1620','574','2005-08-04T06:13:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8304','2005-07-29T03:08:30.000','4431','119','2005-08-02T03:04:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8305','2005-07-29T03:08:47.000','3916','566','2005-08-06T07:49:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8306','2005-07-29T03:12:26.000','1708','232','2005-08-01T23:26:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8307','2005-07-29T03:18:34.000','3197','39','2005-08-06T05:51:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8308','2005-07-29T03:22:15.000','601','582','2005-08-04T21:38:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8309','2005-07-29T03:22:20.000','2250','446','2005-08-01T06:30:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8310','2005-07-29T03:25:56.000','2637','238','2005-08-06T23:18:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8311','2005-07-29T03:26:07.000','3623','63','2005-08-02T01:46:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8312','2005-07-29T03:32:38.000','3996','143','2005-07-31T02:12:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8313','2005-07-29T03:34:21.000','2736','91','2005-08-02T01:32:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8314','2005-07-29T03:35:04.000','2182','118','2005-08-06T08:43:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8315','2005-07-29T03:37:07.000','1420','135','2005-07-29T23:22:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8316','2005-07-29T03:38:49.000','4118','549','2005-08-03T07:41:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8317','2005-07-29T03:39:07.000','3898','415','2005-08-03T00:14:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8318','2005-07-29T03:44:30.000','4524','167','2005-07-30T05:03:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8319','2005-07-29T03:44:52.000','747','280','2005-08-01T00:35:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8320','2005-07-29T03:49:58.000','1285','513','2005-08-03T01:00:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8321','2005-07-29T03:50:54.000','1875','354','2005-08-01T02:08:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8322','2005-07-29T03:52:49.000','301','541','2005-08-02T22:53:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8323','2005-07-29T03:52:59.000','2766','87','2005-08-06T01:49:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8324','2005-07-29T03:56:05.000','1467','98','2005-08-02T01:41:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8325','2005-07-29T03:57:27.000','932','362','2005-08-06T22:30:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8326','2005-07-29T03:58:49.000','108','1','2005-08-01T05:16:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8327','2005-07-29T04:00:52.000','2928','317','2005-07-31T08:27:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8328','2005-07-29T04:06:24.000','4454','314','2005-08-03T22:24:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8329','2005-07-29T04:06:33.000','3468','108','2005-08-06T01:46:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8330','2005-07-29T04:09:07.000','2294','412','2005-08-05T05:00:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8331','2005-07-29T04:13:29.000','18','148','2005-08-04T07:09:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8332','2005-07-29T04:16:00.000','1142','217','2005-08-03T03:34:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8333','2005-07-29T04:16:40.000','823','494','2005-08-02T10:10:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8334','2005-07-29T04:18:25.000','982','154','2005-08-07T07:18:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8335','2005-07-29T04:18:25.000','1719','143','2005-07-31T08:12:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8336','2005-07-29T04:20:42.000','2120','210','2005-08-05T10:17:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8337','2005-07-29T04:31:55.000','752','157','2005-08-02T02:38:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8338','2005-07-29T04:40:39.000','2257','389','2005-08-07T04:40:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8339','2005-07-29T04:41:13.000','1870','129','2005-07-30T09:01:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8340','2005-07-29T04:41:44.000','1553','386','2005-08-07T10:33:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8341','2005-07-29T04:42:01.000','4208','309','2005-08-04T00:58:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8342','2005-07-29T04:45:05.000','3301','572','2005-08-01T07:20:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8343','2005-07-29T04:45:16.000','4267','439','2005-08-02T03:37:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8344','2005-07-29T04:45:25.000','221','257','2005-08-06T01:53:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8345','2005-07-29T04:47:37.000','1034','129','2005-08-02T07:25:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8346','2005-07-29T04:48:22.000','2475','385','2005-08-01T04:22:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8347','2005-07-29T04:49:25.000','4407','157','2005-07-31T00:57:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8348','2005-07-29T04:49:26.000','4533','174','2005-08-05T03:26:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8349','2005-07-29T04:50:22.000','534','416','2005-08-05T08:50:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8350','2005-07-29T04:50:39.000','3726','513','2005-07-31T05:36:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8351','2005-07-29T04:50:53.000','2963','202','2005-07-30T07:28:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8352','2005-07-29T04:52:01.000','2710','168','2005-08-06T07:39:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8353','2005-07-29T04:52:10.000','26','585','2005-07-30T04:01:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8354','2005-07-29T04:56:26.000','4476','579','2005-08-01T08:04:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8355','2005-07-29T04:57:43.000','4569','270','2005-08-03T06:25:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8356','2005-07-29T04:58:56.000','2951','483','2005-08-06T03:07:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8357','2005-07-29T04:59:44.000','892','76','2005-08-01T04:26:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8358','2005-07-29T05:00:58.000','1449','372','2005-08-01T02:49:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8359','2005-07-29T05:02:12.000','140','531','2005-08-04T08:52:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8360','2005-07-29T05:08:00.000','4135','62','2005-08-02T00:40:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8361','2005-07-29T05:08:57.000','3404','360','2005-08-03T02:49:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8362','2005-07-29T05:09:11.000','2287','223','2005-08-04T00:08:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8363','2005-07-29T05:10:08.000','1607','302','2005-08-06T00:11:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8364','2005-07-29T05:10:31.000','1361','362','2005-07-30T04:02:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8365','2005-07-29T05:11:00.000','53','280','2005-07-30T05:30:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8366','2005-07-29T05:11:14.000','479','39','2005-08-05T01:48:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8367','2005-07-29T05:11:19.000','4551','383','2005-08-02T00:35:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8368','2005-07-29T05:15:41.000','1410','200','2005-08-07T01:35:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8369','2005-07-29T05:15:42.000','1456','507','2005-08-01T03:36:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8370','2005-07-29T05:16:21.000','1206','121','2005-08-06T23:16:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8371','2005-07-29T05:16:35.000','2466','396','2005-07-31T01:49:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8372','2005-07-29T05:18:08.000','754','523','2005-08-06T09:39:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8373','2005-07-29T05:19:53.000','2070','457','2005-08-04T04:39:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8374','2005-07-29T05:24:02.000','1084','589','2005-08-05T03:55:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8375','2005-07-29T05:25:30.000','3634','125','2005-08-04T01:43:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8376','2005-07-29T05:25:32.000','3588','43','2005-08-01T07:42:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8377','2005-07-29T05:27:40.000','270','73','2005-07-30T02:52:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8378','2005-07-29T05:28:35.000','3500','347','2005-08-02T05:55:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8379','2005-07-29T05:29:40.000','3907','193','2005-08-06T05:56:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8380','2005-07-29T05:31:29.000','2279','145','2005-08-02T01:27:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8381','2005-07-29T05:31:44.000','865','313','2005-07-31T09:20:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8382','2005-07-29T05:33:21.000','317','238','2005-08-03T03:38:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8383','2005-07-29T05:36:47.000','3809','495','2005-08-03T05:53:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8384','2005-07-29T05:38:43.000','3807','227','2005-08-01T07:31:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8385','2005-07-29T05:39:16.000','4108','233','2005-08-03T00:30:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8386','2005-07-29T05:45:30.000','388','435','2005-08-05T03:56:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8387','2005-07-29T05:47:27.000','910','428','2005-07-31T06:26:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8388','2005-07-29T05:48:15.000','770','178','2005-08-05T06:24:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8389','2005-07-29T05:50:09.000','1241','133','2005-08-06T05:15:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8390','2005-07-29T05:52:26.000','581','32','2005-08-04T08:12:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8391','2005-07-29T05:52:50.000','2134','36','2005-08-03T04:45:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8392','2005-07-29T06:00:27.000','1323','65','2005-08-02T00:30:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8393','2005-07-29T06:02:11.000','3369','504','2005-08-07T03:23:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8394','2005-07-29T06:02:14.000','3933','148','2005-08-03T08:15:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8395','2005-07-29T06:03:30.000','1471','535','2005-07-31T09:08:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8396','2005-07-29T06:07:00.000','3911','516','2005-07-30T05:32:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8397','2005-07-29T06:09:35.000','3542','518','2005-08-01T02:08:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8398','2005-07-29T06:12:40.000','348','220','2005-08-02T05:01:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8399','2005-07-29T06:20:18.000','233','286','2005-08-04T01:26:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8400','2005-07-29T06:23:56.000','3680','573','2005-07-31T02:41:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8401','2005-07-29T06:25:08.000','3121','232','2005-08-01T06:49:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8402','2005-07-29T06:25:45.000','186','47','2005-08-07T10:48:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8403','2005-07-29T06:26:39.000','1360','163','2005-08-02T05:37:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8404','2005-07-29T06:27:01.000','2086','65','2005-08-07T04:33:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8405','2005-07-29T06:28:19.000','2164','76','2005-08-07T08:14:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8406','2005-07-29T06:34:45.000','2047','274','2005-08-06T02:28:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8407','2005-07-29T06:37:02.000','2985','336','2005-08-04T03:13:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8408','2005-07-29T06:40:40.000','1841','90','2005-07-30T10:02:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8409','2005-07-29T06:41:22.000','4314','303','2005-07-31T11:21:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8410','2005-07-29T06:41:36.000','3448','277','2005-08-02T08:38:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8411','2005-07-29T06:44:23.000','3085','412','2005-08-07T03:56:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8412','2005-07-29T06:44:50.000','743','312','2005-08-06T05:04:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8413','2005-07-29T06:47:39.000','2762','104','2005-08-02T09:15:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8414','2005-07-29T06:48:35.000','1337','433','2005-08-06T10:54:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8415','2005-07-29T06:52:27.000','2903','128','2005-08-02T10:40:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8416','2005-07-29T06:52:54.000','1999','315','2005-08-05T09:50:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8417','2005-07-29T06:53:36.000','750','227','2005-08-06T09:31:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8418','2005-07-29T06:54:21.000','3081','355','2005-08-05T06:50:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8419','2005-07-29T06:54:48.000','4574','37','2005-08-06T05:02:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8420','2005-07-29T07:00:45.000','4184','376','2005-08-06T02:20:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8421','2005-07-29T07:00:47.000','3399','588','2005-08-02T08:03:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8422','2005-07-29T07:02:55.000','3104','7','2005-08-03T12:35:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8423','2005-07-29T07:02:57.000','187','468','2005-08-06T04:59:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8424','2005-07-29T07:06:03.000','366','138','2005-08-06T12:00:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8425','2005-07-29T07:06:21.000','3491','486','2005-08-05T07:57:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8426','2005-07-29T07:07:48.000','1840','564','2005-08-07T08:56:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8427','2005-07-29T07:08:36.000','1624','441','2005-07-30T11:54:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8428','2005-07-29T07:10:14.000','2545','398','2005-08-06T02:29:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8429','2005-07-29T07:11:49.000','2456','588','2005-07-31T02:45:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8430','2005-07-29T07:12:17.000','3377','219','2005-08-03T09:53:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8431','2005-07-29T07:12:48.000','1583','193','2005-08-01T10:03:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8432','2005-07-29T07:13:33.000','3896','572','2005-07-30T03:14:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8433','2005-07-29T07:19:16.000','1957','125','2005-08-05T03:29:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8434','2005-07-29T07:20:14.000','40','141','2005-07-30T08:50:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8435','2005-07-29T07:20:16.000','4462','520','2005-08-02T09:54:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8436','2005-07-29T07:21:20.000','2702','598','2005-07-31T12:56:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8437','2005-07-29T07:23:43.000','2118','96','2005-08-04T10:52:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8438','2005-07-29T07:25:42.000','720','97','2005-08-04T07:39:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8439','2005-07-29T07:28:43.000','182','224','2005-08-04T11:22:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8440','2005-07-29T07:31:26.000','489','175','2005-08-04T07:04:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8441','2005-07-29T07:33:05.000','1000','526','2005-08-04T04:00:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8442','2005-07-29T07:33:07.000','4345','185','2005-08-03T03:09:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8443','2005-07-29T07:33:12.000','1059','251','2005-08-02T01:36:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8444','2005-07-29T07:36:13.000','3329','213','2005-08-05T04:55:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8445','2005-07-29T07:37:48.000','2792','384','2005-08-04T10:43:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8446','2005-07-29T07:38:10.000','1593','235','2005-08-06T04:39:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8447','2005-07-29T07:38:14.000','930','11','2005-08-05T02:27:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8448','2005-07-29T07:41:54.000','4349','393','2005-08-02T13:12:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8449','2005-07-29T07:42:25.000','2610','273','2005-07-30T06:07:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8450','2005-07-29T07:44:05.000','484','401','2005-08-01T12:23:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8451','2005-07-29T07:44:56.000','3309','495','2005-08-06T02:29:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8452','2005-07-29T07:45:00.000','4312','16','2005-08-05T09:46:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8453','2005-07-29T07:46:29.000','2907','32','2005-07-30T07:07:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8454','2005-07-29T07:49:04.000','159','244','2005-08-03T04:43:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8455','2005-07-29T07:53:06.000','4043','404','2005-08-05T05:29:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8456','2005-07-29T07:58:31.000','671','388','2005-08-05T07:17:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8457','2005-07-29T07:59:03.000','3371','239','2005-08-04T08:42:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8458','2005-07-29T08:05:09.000','3857','317','2005-08-02T03:42:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8459','2005-07-29T08:05:40.000','3441','144','2005-08-04T03:24:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8460','2005-07-29T08:08:03.000','2826','329','2005-08-07T06:53:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8461','2005-07-29T08:11:31.000','3373','399','2005-08-06T09:23:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8462','2005-07-29T08:15:42.000','3633','200','2005-08-04T03:57:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8463','2005-07-29T08:17:51.000','466','203','2005-08-03T13:41:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8464','2005-07-29T08:18:20.000','2343','28','2005-08-03T04:50:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8465','2005-07-29T08:20:49.000','4109','238','2005-07-31T04:02:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8466','2005-07-29T08:24:47.000','4010','285','2005-07-31T03:43:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8467','2005-07-29T08:25:35.000','263','326','2005-08-07T03:28:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8468','2005-07-29T08:26:04.000','1338','282','2005-08-02T07:18:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8469','2005-07-29T08:26:27.000','2754','408','2005-08-05T04:26:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8470','2005-07-29T08:28:50.000','3717','159','2005-07-30T13:40:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8471','2005-07-29T08:32:11.000','1520','533','2005-08-01T13:55:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8472','2005-07-29T08:36:22.000','2975','196','2005-08-02T07:55:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8473','2005-07-29T08:36:53.000','4141','311','2005-07-31T12:14:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8474','2005-07-29T08:36:56.000','4346','323','2005-08-01T03:07:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8475','2005-07-29T08:37:41.000','3695','260','2005-08-04T10:03:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8476','2005-07-29T08:39:12.000','3741','470','2005-08-06T03:03:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8477','2005-07-29T08:40:36.000','3571','354','2005-08-06T08:28:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8478','2005-07-29T08:40:36.000','3742','162','2005-08-01T10:23:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8479','2005-07-29T08:42:04.000','1990','195','2005-08-01T03:10:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8480','2005-07-29T08:44:46.000','3512','467','2005-08-05T13:22:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8481','2005-07-29T08:45:57.000','1739','454','2005-08-01T12:50:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8482','2005-07-29T08:46:33.000','2686','405','2005-07-31T11:07:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8483','2005-07-29T08:50:18.000','2786','186','2005-08-03T06:46:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8484','2005-07-29T08:51:59.000','742','260','2005-07-30T09:07:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8485','2005-07-29T08:53:09.000','3172','420','2005-07-30T11:25:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8486','2005-07-29T08:53:38.000','1759','221','2005-08-01T14:12:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8487','2005-07-29T08:53:49.000','1893','82','2005-07-31T09:10:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8488','2005-07-29T08:57:38.000','2176','478','2005-08-02T04:16:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8489','2005-07-29T08:58:03.000','375','265','2005-08-02T07:50:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8490','2005-07-29T08:59:25.000','1943','367','2005-08-05T14:02:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8491','2005-07-29T09:02:13.000','1806','242','2005-08-03T04:32:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8492','2005-07-29T09:04:17.000','4553','266','2005-08-02T08:48:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8493','2005-07-29T09:04:31.000','664','390','2005-08-04T05:17:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8494','2005-07-29T09:04:32.000','3524','92','2005-07-31T10:30:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8495','2005-07-29T09:05:06.000','344','51','2005-08-06T05:48:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8496','2005-07-29T09:05:33.000','765','114','2005-08-02T06:32:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8497','2005-07-29T09:07:03.000','1837','593','2005-08-02T09:18:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8498','2005-07-29T09:07:38.000','4468','190','2005-08-04T07:01:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8499','2005-07-29T09:10:41.000','219','42','2005-08-05T10:01:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8500','2005-07-29T09:12:01.000','4516','348','2005-07-31T10:15:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8501','2005-07-29T09:12:51.000','1052','309','2005-07-30T11:19:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8502','2005-07-29T09:15:41.000','2149','457','2005-07-30T10:41:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8503','2005-07-29T09:16:50.000','1164','240','2005-08-04T11:34:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8504','2005-07-29T09:20:16.000','2295','561','2005-08-07T04:27:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8505','2005-07-29T09:22:52.000','1454','346','2005-08-06T05:23:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8506','2005-07-29T09:23:52.000','3714','506','2005-07-31T04:42:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8507','2005-07-29T09:29:44.000','3273','524','2005-08-07T05:48:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8508','2005-07-29T09:34:38.000','4173','484','2005-08-01T14:52:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8509','2005-07-29T09:38:19.000','1332','80','2005-08-04T11:45:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8510','2005-07-29T09:41:38.000','7','487','2005-08-05T05:30:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8511','2005-07-29T09:42:42.000','3667','598','2005-08-06T14:22:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8512','2005-07-29T09:48:03.000','4132','351','2005-07-31T13:40:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8513','2005-07-29T09:52:59.000','3156','142','2005-07-31T12:05:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8514','2005-07-29T09:53:33.000','3755','99','2005-07-30T06:34:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8515','2005-07-29T09:55:20.000','1071','477','2005-08-05T07:08:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8516','2005-07-29T10:00:03.000','981','337','2005-08-02T09:34:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8517','2005-07-29T10:00:48.000','2064','274','2005-08-06T14:37:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8518','2005-07-29T10:05:27.000','2311','385','2005-08-02T05:39:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8519','2005-07-29T10:09:43.000','1163','588','2005-08-03T08:14:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8520','2005-07-29T10:10:02.000','2440','103','2005-08-02T05:25:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8521','2005-07-29T10:12:45.000','2608','402','2005-08-07T04:37:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8522','2005-07-29T10:16:19.000','3636','363','2005-08-06T14:58:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8523','2005-07-29T10:18:27.000','3614','558','2005-08-04T09:31:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8524','2005-07-29T10:20:07.000','2110','124','2005-08-03T04:30:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8525','2005-07-29T10:20:19.000','1322','111','2005-07-30T05:49:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8526','2005-07-29T10:20:48.000','575','88','2005-08-03T14:15:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8527','2005-07-29T10:21:00.000','709','168','2005-08-05T16:05:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8528','2005-07-29T10:24:22.000','2107','428','2005-08-07T10:34:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8529','2005-07-29T10:24:31.000','1055','501','2005-08-01T16:06:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8530','2005-07-29T10:26:14.000','4528','233','2005-07-31T10:24:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8531','2005-07-29T10:26:15.000','1631','427','2005-08-06T09:28:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8532','2005-07-29T10:26:56.000','3045','546','2005-08-02T13:23:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8533','2005-07-29T10:29:16.000','551','542','2005-08-01T06:52:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8534','2005-07-29T10:30:13.000','4029','516','2005-08-02T04:47:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8535','2005-07-29T10:32:33.000','4489','536','2005-07-31T05:46:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8536','2005-07-29T10:37:23.000','4510','219','2005-07-31T07:21:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8537','2005-07-29T10:44:54.000','1012','447','2005-08-06T14:55:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8538','2005-07-29T10:45:17.000','3768','500','2005-08-04T15:12:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8539','2005-07-29T10:48:24.000','599','325','2005-07-30T06:29:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8540','2005-07-29T10:52:51.000','539','180','2005-08-07T11:44:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8541','2005-07-29T10:55:01.000','976','340','2005-07-31T10:53:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8542','2005-07-29T11:01:50.000','792','213','2005-07-30T08:19:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8543','2005-07-29T11:01:57.000','403','346','2005-08-03T06:03:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8544','2005-07-29T11:02:08.000','412','542','2005-08-06T15:06:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8545','2005-07-29T11:07:04.000','3261','3','2005-08-06T13:30:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8546','2005-07-29T11:08:48.000','3224','418','2005-08-03T16:50:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8547','2005-07-29T11:10:15.000','875','438','2005-08-03T12:50:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8548','2005-07-29T11:11:33.000','3366','14','2005-08-04T11:52:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8549','2005-07-29T11:12:13.000','1866','206','2005-08-06T06:04:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8550','2005-07-29T11:12:37.000','1340','70','2005-07-30T15:05:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8551','2005-07-29T11:13:11.000','2083','340','2005-08-05T05:17:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8552','2005-07-29T11:14:02.000','1987','490','2005-08-05T14:13:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8553','2005-07-29T11:15:36.000','2645','49','2005-08-07T16:37:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8554','2005-07-29T11:16:29.000','1563','582','2005-07-31T06:38:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8555','2005-07-29T11:18:01.000','2784','18','2005-07-30T10:47:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8556','2005-07-29T11:18:27.000','2793','231','2005-07-30T05:21:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8557','2005-07-29T11:19:59.000','1481','459','2005-08-07T12:50:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8558','2005-07-29T11:24:49.000','1160','169','2005-07-31T15:03:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8559','2005-07-29T11:25:54.000','2078','279','2005-08-04T10:16:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8560','2005-07-29T11:27:27.000','3499','430','2005-08-01T12:05:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8561','2005-07-29T11:29:12.000','2207','344','2005-08-05T09:17:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8562','2005-07-29T11:32:13.000','3595','255','2005-07-30T08:23:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8563','2005-07-29T11:32:58.000','61','67','2005-08-05T07:21:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8564','2005-07-29T11:33:00.000','2830','316','2005-08-05T15:35:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8565','2005-07-29T11:35:23.000','3211','280','2005-08-06T08:28:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8566','2005-07-29T11:35:46.000','2011','544','2005-07-30T13:50:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8567','2005-07-29T11:37:30.000','1612','594','2005-08-03T05:58:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8568','2005-07-29T11:38:22.000','1599','583','2005-08-04T13:22:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8569','2005-07-29T11:39:17.000','276','348','2005-07-31T07:50:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8570','2005-07-29T11:40:08.000','3094','131','2005-08-06T10:23:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8571','2005-07-29T11:48:39.000','1778','407','2005-08-03T06:35:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8572','2005-07-29T11:51:24.000','2815','267','2005-08-02T11:44:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8573','2005-07-29T11:51:25.000','1637','179','2005-08-07T08:53:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8574','2005-07-29T11:51:53.000','2949','71','2005-08-03T05:59:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8575','2005-07-29T11:52:47.000','1668','441','2005-08-03T08:14:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8576','2005-07-29T11:55:01.000','3552','157','2005-08-03T08:41:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8577','2005-07-29T11:56:30.000','520','328','2005-08-07T15:41:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8578','2005-07-29T11:58:14.000','3737','148','2005-08-03T06:25:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8579','2005-07-29T11:59:22.000','4045','250','2005-07-30T11:41:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8580','2005-07-29T12:00:27.000','4040','543','2005-08-04T16:39:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8581','2005-07-29T12:02:06.000','2102','254','2005-08-02T10:32:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8582','2005-07-29T12:03:27.000','841','162','2005-08-03T07:02:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8583','2005-07-29T12:04:50.000','3130','191','2005-08-04T17:21:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8584','2005-07-29T12:07:53.000','1656','482','2005-07-31T09:27:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8585','2005-07-29T12:14:18.000','512','516','2005-08-03T08:31:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8586','2005-07-29T12:16:34.000','2752','374','2005-08-07T06:48:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8587','2005-07-29T12:18:40.000','1941','108','2005-08-03T14:01:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8588','2005-07-29T12:22:20.000','2858','416','2005-07-31T10:49:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8589','2005-07-29T12:28:17.000','1628','293','2005-08-05T11:40:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8590','2005-07-29T12:32:20.000','2505','114','2005-08-07T08:00:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8591','2005-07-29T12:32:33.000','2568','418','2005-08-01T16:19:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8592','2005-07-29T12:33:58.000','1952','271','2005-08-04T07:14:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8593','2005-07-29T12:38:14.000','2601','181','2005-08-07T07:04:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8594','2005-07-29T12:42:13.000','4155','115','2005-08-02T07:38:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8595','2005-07-29T12:47:43.000','3225','423','2005-08-07T13:51:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8596','2005-07-29T12:48:54.000','59','233','2005-08-04T07:19:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8597','2005-07-29T12:55:55.000','4218','222','2005-08-05T18:54:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8598','2005-07-29T12:56:59.000','626','2','2005-08-01T08:39:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8599','2005-07-29T12:58:52.000','1169','545','2005-08-03T08:19:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8600','2005-07-29T13:01:19.000','1488','226','2005-07-31T15:40:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8601','2005-07-29T13:03:31.000','3247','181','2005-08-06T16:32:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8602','2005-07-29T13:04:27.000','4002','64','2005-08-03T12:21:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8603','2005-07-29T13:07:07.000','3007','594','2005-08-04T18:32:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8604','2005-07-29T13:07:13.000','3909','326','2005-07-31T18:00:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8605','2005-07-29T13:13:34.000','3805','224','2005-08-07T08:29:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8606','2005-07-29T13:14:24.000','4051','340','2005-07-30T14:52:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8607','2005-07-29T13:18:00.000','4290','336','2005-07-30T18:51:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8608','2005-07-29T13:18:52.000','2976','165','2005-07-30T19:01:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8609','2005-07-29T13:19:25.000','3997','354','2005-08-06T08:33:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8610','2005-07-29T13:25:02.000','4222','563','2005-08-03T08:10:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8611','2005-07-29T13:26:21.000','610','373','2005-08-07T18:20:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8612','2005-07-29T13:28:20.000','3518','392','2005-08-06T14:39:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8613','2005-07-29T13:30:58.000','394','411','2005-08-05T16:21:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8614','2005-07-29T13:32:05.000','604','552','2005-08-04T15:26:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8615','2005-07-29T13:36:01.000','4453','15','2005-08-03T13:15:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8616','2005-07-29T13:39:09.000','2583','493','2005-08-01T16:49:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8617','2005-07-29T13:46:14.000','385','441','2005-08-06T13:26:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8618','2005-07-29T13:48:20.000','985','270','2005-08-06T14:12:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8619','2005-07-29T13:50:08.000','2169','50','2005-08-06T13:15:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8620','2005-07-29T13:51:20.000','3718','306','2005-08-02T13:05:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8621','2005-07-29T13:52:42.000','2473','358','2005-07-30T11:42:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8622','2005-07-29T13:53:28.000','4076','98','2005-07-31T16:12:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8623','2005-07-29T13:55:11.000','458','142','2005-08-05T11:16:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8624','2005-07-29T13:55:36.000','4402','439','2005-08-02T12:23:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8625','2005-07-29T13:59:13.000','884','410','2005-08-07T17:56:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8626','2005-07-29T14:03:20.000','3092','148','2005-08-02T09:05:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8627','2005-07-29T14:05:12.000','4235','226','2005-08-05T16:53:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8628','2005-07-29T14:06:24.000','4484','550','2005-08-06T10:42:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8629','2005-07-29T14:06:35.000','853','567','2005-08-03T16:59:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8630','2005-07-29T14:07:59.000','1378','406','2005-08-03T13:18:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8631','2005-07-29T14:08:06.000','98','559','2005-08-05T14:57:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8632','2005-07-29T14:11:25.000','1666','563','2005-08-07T15:32:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8633','2005-07-29T14:19:53.000','3436','534','2005-08-01T11:31:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8634','2005-07-29T14:19:57.000','2023','335','2005-08-07T13:44:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8635','2005-07-29T14:22:48.000','2894','383','2005-08-01T11:59:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8636','2005-07-29T14:24:13.000','4308','252','2005-08-02T14:39:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8637','2005-07-29T14:30:11.000','1069','310','2005-08-04T14:00:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8638','2005-07-29T14:30:23.000','4060','571','2005-08-01T10:32:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8639','2005-07-29T14:30:31.000','3504','290','2005-08-02T16:04:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8640','2005-07-29T14:34:17.000','1874','257','2005-08-01T13:09:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8641','2005-07-29T14:37:30.000','3199','30','2005-08-02T19:32:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8642','2005-07-29T14:38:17.000','3947','522','2005-08-03T14:41:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8643','2005-07-29T14:45:23.000','381','59','2005-08-04T18:42:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8644','2005-07-29T14:45:45.000','4507','314','2005-08-03T20:10:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8645','2005-07-29T14:47:45.000','2532','535','2005-07-30T14:56:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8646','2005-07-29T14:48:48.000','89','302','2005-08-03T18:11:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8647','2005-07-29T14:52:59.000','556','307','2005-08-06T11:09:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8648','2005-07-29T14:56:21.000','160','416','2005-07-31T16:56:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8649','2005-07-29T14:57:33.000','789','69','2005-08-07T09:43:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8650','2005-07-29T14:59:04.000','1272','134','2005-08-04T13:13:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8651','2005-07-29T15:02:18.000','2095','61','2005-08-07T09:34:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8652','2005-07-29T15:02:54.000','2729','219','2005-08-07T17:21:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8653','2005-07-29T15:04:23.000','4440','230','2005-08-02T09:39:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8654','2005-07-29T15:04:27.000','3925','84','2005-08-07T18:37:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8655','2005-07-29T15:04:42.000','3986','232','2005-08-04T11:26:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8656','2005-07-29T15:05:52.000','1385','460','2005-07-31T20:57:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8657','2005-07-29T15:09:25.000','3194','236','2005-07-31T19:10:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8658','2005-07-29T15:16:37.000','2033','427','2005-08-07T20:45:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8659','2005-07-29T15:26:31.000','558','168','2005-08-06T19:05:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8660','2005-07-29T15:26:59.000','3122','566','2005-08-05T21:04:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8661','2005-07-29T15:28:24.000','3409','341','2005-08-05T20:04:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8662','2005-07-29T15:31:33.000','3758','362','2005-07-30T09:39:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8663','2005-07-29T15:33:18.000','1281','214','2005-07-30T18:03:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8664','2005-07-29T15:36:27.000','198','102','2005-08-04T20:11:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8665','2005-07-29T15:39:29.000','1113','265','2005-08-01T10:33:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8666','2005-07-29T15:39:38.000','3669','591','2005-08-06T17:12:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8667','2005-07-29T15:40:57.000','3439','25','2005-07-31T20:59:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8668','2005-07-29T15:41:31.000','4531','71','2005-08-01T16:20:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8669','2005-07-29T15:44:55.000','1667','401','2005-08-01T14:09:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8670','2005-07-29T15:49:03.000','2354','446','2005-08-01T20:19:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8671','2005-07-29T15:49:37.000','1431','577','2005-08-05T18:20:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8672','2005-07-29T15:49:48.000','405','495','2005-08-06T17:59:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8673','2005-07-29T15:50:14.000','2167','29','2005-08-03T18:30:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8674','2005-07-29T15:54:22.000','1744','412','2005-07-31T12:15:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8675','2005-07-29T15:56:18.000','1026','258','2005-07-30T18:50:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8676','2005-07-29T15:59:06.000','283','533','2005-08-05T19:12:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8677','2005-07-29T16:01:13.000','513','315','2005-08-07T19:21:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8678','2005-07-29T16:04:00.000','3991','210','2005-08-05T12:37:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8679','2005-07-29T16:07:47.000','3549','536','2005-08-02T18:37:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8680','2005-07-29T16:08:03.000','1227','330','2005-07-31T17:26:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8681','2005-07-29T16:12:01.000','4004','309','2005-08-01T18:14:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8682','2005-07-29T16:15:26.000','4328','348','2005-08-03T20:15:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8683','2005-07-29T16:15:43.000','3915','513','2005-08-07T19:19:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8684','2005-07-29T16:16:33.000','2457','185','2005-08-07T12:27:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8685','2005-07-29T16:17:05.000','1827','321','2005-08-07T17:44:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8686','2005-07-29T16:17:49.000','4160','52','2005-08-01T12:50:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8687','2005-07-29T16:19:17.000','222','117','2005-08-01T15:28:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8688','2005-07-29T16:31:32.000','2263','381','2005-07-30T12:39:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8689','2005-07-29T16:38:58.000','824','487','2005-08-01T17:09:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8690','2005-07-29T16:39:28.000','1292','291','2005-08-01T14:03:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8691','2005-07-29T16:41:23.000','672','446','2005-08-02T12:32:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8692','2005-07-29T16:43:39.000','3192','88','2005-08-01T15:54:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8693','2005-07-29T16:44:13.000','917','51','2005-08-01T15:56:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8694','2005-07-29T16:44:48.000','503','345','2005-08-06T16:28:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8695','2005-07-29T16:44:55.000','694','280','2005-08-07T12:47:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8696','2005-07-29T16:45:18.000','2553','178','2005-08-07T18:51:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8697','2005-07-29T16:46:07.000','443','291','2005-08-02T19:27:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8698','2005-07-29T16:52:17.000','2973','324','2005-08-04T13:20:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8699','2005-07-29T16:53:00.000','4080','123','2005-08-07T20:31:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8700','2005-07-29T16:56:01.000','3710','196','2005-07-31T16:19:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8701','2005-07-29T17:02:35.000','3158','245','2005-08-07T19:55:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8702','2005-07-29T17:04:37.000','2215','306','2005-08-05T15:30:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8703','2005-07-29T17:12:44.000','1065','439','2005-07-30T19:38:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8704','2005-07-29T17:13:45.000','2117','107','2005-08-03T20:03:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8705','2005-07-29T17:14:29.000','4038','2','2005-08-02T16:01:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8706','2005-07-29T17:19:15.000','2886','515','2005-08-03T22:52:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8707','2005-07-29T17:21:58.000','2525','157','2005-08-02T14:47:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8708','2005-07-29T17:24:13.000','4054','529','2005-08-04T13:57:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8709','2005-07-29T17:25:54.000','902','199','2005-08-02T22:35:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8710','2005-07-29T17:26:03.000','3391','566','2005-07-30T19:51:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8711','2005-07-29T17:27:15.000','3471','575','2005-07-31T12:57:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8712','2005-07-29T17:30:06.000','2800','41','2005-08-03T22:55:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8713','2005-07-29T17:31:19.000','473','433','2005-08-02T16:37:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8714','2005-07-29T17:31:40.000','4547','362','2005-08-04T16:12:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8715','2005-07-29T17:33:45.000','860','11','2005-08-01T17:30:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8716','2005-07-29T17:39:09.000','2123','48','2005-08-03T20:26:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8717','2005-07-29T17:40:45.000','1821','260','2005-08-01T22:38:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8718','2005-07-29T17:41:14.000','137','23','2005-08-01T18:22:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8719','2005-07-29T17:45:45.000','995','333','2005-08-01T13:53:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8720','2005-07-29T17:48:32.000','152','180','2005-08-04T14:30:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8721','2005-07-29T17:56:21.000','2416','312','2005-08-02T21:30:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8722','2005-07-29T17:58:58.000','1389','401','2005-08-07T23:40:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8723','2005-07-29T18:03:47.000','224','39','2005-08-06T18:53:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8724','2005-07-29T18:05:21.000','898','372','2005-08-01T15:41:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8725','2005-07-29T18:08:42.000','2385','421','2005-08-04T16:01:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8726','2005-07-29T18:09:22.000','897','409','2005-08-06T16:24:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8727','2005-07-29T18:09:57.000','3031','528','2005-08-03T13:41:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8728','2005-07-29T18:12:49.000','973','341','2005-08-06T22:45:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8729','2005-07-29T18:23:02.000','3342','83','2005-07-31T16:09:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8730','2005-07-29T18:23:34.000','4191','592','2005-08-01T19:56:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8731','2005-07-29T18:23:57.000','2638','179','2005-08-05T19:38:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8732','2005-07-29T18:25:03.000','1143','346','2005-08-07T18:56:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8733','2005-07-29T18:26:34.000','3187','450','2005-08-03T15:06:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8734','2005-07-29T18:28:15.000','2374','303','2005-08-05T23:38:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8735','2005-07-29T18:28:54.000','2881','570','2005-08-03T12:43:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8736','2005-07-29T18:31:15.000','1726','530','2005-07-30T16:24:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8737','2005-07-29T18:32:13.000','4154','298','2005-08-05T21:07:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8738','2005-07-29T18:32:47.000','3893','210','2005-08-02T13:05:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8739','2005-07-29T18:34:33.000','4310','326','2005-08-02T16:05:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8740','2005-07-29T18:41:31.000','3781','378','2005-08-01T18:38:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8741','2005-07-29T18:44:57.000','165','4','2005-08-03T18:25:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8742','2005-07-29T18:56:12.000','918','208','2005-08-03T16:42:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8743','2005-07-29T18:57:01.000','2664','282','2005-07-31T22:09:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8744','2005-07-29T18:58:24.000','1086','280','2005-08-05T17:56:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8745','2005-07-29T19:03:05.000','1766','293','2005-08-06T14:06:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8746','2005-07-29T19:03:15.000','2179','275','2005-07-30T17:06:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8747','2005-07-29T19:07:57.000','2584','70','2005-07-30T16:01:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8748','2005-07-29T19:08:37.000','2184','237','2005-08-01T16:24:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8749','2005-07-29T19:13:15.000','2252','456','2005-08-01T15:02:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8750','2005-07-29T19:14:21.000','3157','158','2005-07-31T17:22:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8751','2005-07-29T19:14:39.000','3467','386','2005-07-31T23:11:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8752','2005-07-29T19:15:07.000','4202','253','2005-07-31T13:27:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8753','2005-07-29T19:15:50.000','1345','560','2005-07-31T19:13:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8754','2005-07-29T19:18:30.000','1678','174','2005-08-05T18:39:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8755','2005-07-29T19:18:31.000','1498','372','2005-07-31T19:20:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8756','2005-07-29T19:18:57.000','4146','120','2005-08-02T20:07:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8757','2005-07-29T19:19:10.000','3473','462','2005-08-02T13:47:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8758','2005-07-29T19:20:49.000','2816','442','2005-08-05T21:57:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8759','2005-07-29T19:22:37.000','844','209','2005-08-07T15:36:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8760','2005-07-29T19:22:40.000','3566','118','2005-08-05T01:09:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8761','2005-07-29T19:26:47.000','1317','539','2005-08-08T00:09:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8762','2005-07-29T19:30:02.000','2765','463','2005-08-04T18:38:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8763','2005-07-29T19:38:24.000','374','510','2005-08-04T16:51:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8764','2005-07-29T19:39:04.000','2348','303','2005-08-01T13:52:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8765','2005-07-29T19:40:08.000','2631','538','2005-07-31T14:24:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8766','2005-07-29T19:41:04.000','3888','338','2005-08-02T00:41:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8767','2005-07-29T19:42:33.000','962','467','2005-08-01T20:52:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8768','2005-07-29T19:43:02.000','1601','468','2005-08-03T23:36:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8769','2005-07-29T19:45:33.000','2180','588','2005-08-05T22:09:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8770','2005-07-29T19:53:50.000','4025','499','2005-08-05T14:22:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8771','2005-07-29T19:54:41.000','3533','347','2005-08-03T20:38:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8772','2005-07-29T19:55:25.000','3526','122','2005-08-05T18:48:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8773','2005-07-29T19:55:34.000','131','592','2005-07-30T14:11:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8774','2005-07-29T20:05:04.000','315','161','2005-07-31T14:32:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8775','2005-07-29T20:05:38.000','1358','44','2005-07-30T21:13:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8776','2005-07-29T20:07:06.000','1565','587','2005-08-06T20:42:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8777','2005-07-29T20:10:21.000','2462','382','2005-07-30T20:32:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8778','2005-07-29T20:14:25.000','3654','582','2005-08-04T00:50:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8779','2005-07-29T20:15:00.000','3245','202','2005-08-03T21:17:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8780','2005-07-29T20:19:45.000','1095','328','2005-08-03T22:22:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8781','2005-07-29T20:20:16.000','3746','235','2005-07-30T16:19:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8782','2005-07-29T20:29:34.000','4379','365','2005-08-04T02:19:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8783','2005-07-29T20:31:28.000','2316','71','2005-08-02T19:33:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8784','2005-07-29T20:35:37.000','2308','580','2005-07-30T17:22:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8785','2005-07-29T20:36:26.000','216','42','2005-07-30T15:06:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8786','2005-07-29T20:39:49.000','2404','533','2005-08-03T18:08:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8787','2005-07-29T20:43:49.000','2366','222','2005-07-31T15:15:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8788','2005-07-29T20:46:44.000','3412','121','2005-08-03T02:25:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8789','2005-07-29T20:47:27.000','3062','71','2005-08-05T18:36:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8790','2005-07-29T20:51:41.000','751','323','2005-07-30T17:30:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8791','2005-07-29T20:53:23.000','1677','469','2005-07-31T18:14:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8792','2005-07-29T20:56:14.000','3764','203','2005-08-07T16:44:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8793','2005-07-29T20:57:22.000','1819','167','2005-08-02T01:40:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8794','2005-07-29T20:59:38.000','3509','320','2005-07-31T00:15:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8795','2005-07-29T21:04:14.000','1896','302','2005-07-31T02:58:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8796','2005-07-29T21:09:11.000','2234','74','2005-08-04T22:55:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8797','2005-07-29T21:10:37.000','2929','566','2005-08-07T21:43:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8798','2005-07-29T21:15:38.000','800','513','2005-08-05T02:46:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8799','2005-07-29T21:16:47.000','326','237','2005-08-07T22:09:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8800','2005-07-29T21:18:59.000','2082','207','2005-08-06T19:59:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8801','2005-07-29T21:25:22.000','1111','590','2005-08-01T00:02:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8802','2005-07-29T21:25:51.000','296','407','2005-07-30T18:15:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8803','2005-07-29T21:26:24.000','2814','86','2005-08-06T18:05:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8804','2005-07-29T21:28:19.000','4461','363','2005-08-01T20:15:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8805','2005-07-29T21:29:58.000','4041','39','2005-08-04T23:12:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8806','2005-07-29T21:36:34.000','4085','454','2005-08-02T00:58:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8807','2005-07-29T21:36:59.000','2612','396','2005-08-01T17:40:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8808','2005-07-29T21:39:07.000','593','173','2005-08-03T02:09:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8809','2005-07-29T21:42:49.000','3278','8','2005-08-04T01:13:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8810','2005-07-29T21:45:19.000','1233','431','2005-08-08T01:45:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8811','2005-07-29T21:46:21.000','2041','245','2005-08-07T16:51:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8812','2005-07-29T21:47:40.000','1172','563','2005-08-04T01:18:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8813','2005-07-29T21:47:55.000','3442','497','2005-08-05T01:16:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8814','2005-07-29T21:49:43.000','1492','487','2005-08-01T19:56:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8815','2005-07-29T21:51:26.000','3469','230','2005-08-03T22:37:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8816','2005-07-29T21:53:00.000','3984','209','2005-08-01T21:20:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8817','2005-07-29T22:09:08.000','2716','175','2005-08-01T19:07:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8818','2005-07-29T22:14:04.000','3090','98','2005-08-07T17:26:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8819','2005-07-29T22:14:26.000','3100','591','2005-08-06T23:02:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8820','2005-07-29T22:14:56.000','481','594','2005-08-05T23:36:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8821','2005-07-29T22:18:12.000','52','477','2005-08-05T22:00:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8822','2005-07-29T22:20:21.000','744','35','2005-08-06T03:00:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8823','2005-07-29T22:22:12.000','951','75','2005-08-07T21:03:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8824','2005-07-29T22:22:58.000','3506','164','2005-07-31T21:02:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8825','2005-07-29T22:24:16.000','881','101','2005-08-05T00:27:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8826','2005-07-29T22:30:16.000','1800','369','2005-07-30T19:43:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8827','2005-07-29T22:31:24.000','1517','157','2005-08-06T21:05:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8828','2005-07-29T22:32:54.000','1608','547','2005-07-30T20:41:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8829','2005-07-29T22:33:34.000','1466','173','2005-08-05T20:23:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8830','2005-07-29T22:34:35.000','1751','202','2005-08-05T20:12:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8831','2005-07-29T22:37:41.000','3520','13','2005-08-08T04:28:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8832','2005-07-29T22:37:49.000','380','125','2005-08-04T23:32:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8833','2005-07-29T22:39:36.000','1741','101','2005-08-05T21:19:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8834','2005-07-29T22:41:48.000','4477','243','2005-08-05T03:21:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8835','2005-07-29T22:44:35.000','2653','237','2005-08-05T23:28:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8836','2005-07-29T22:46:08.000','3265','14','2005-08-02T19:53:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8837','2005-07-29T22:49:00.000','42','372','2005-08-07T21:56:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8838','2005-07-29T22:52:23.000','133','550','2005-08-03T22:49:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8839','2005-07-29T22:52:34.000','3440','580','2005-08-05T03:24:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8840','2005-07-29T22:55:38.000','1484','295','2005-08-06T02:11:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8841','2005-07-29T22:56:07.000','3935','363','2005-08-01T21:21:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8842','2005-07-29T23:03:40.000','4203','292','2005-08-06T23:23:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8843','2005-07-29T23:04:25.000','406','294','2005-08-05T22:12:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8844','2005-07-29T23:05:08.000','327','244','2005-08-06T00:24:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8845','2005-07-29T23:06:13.000','3036','543','2005-08-02T20:16:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8846','2005-07-29T23:10:28.000','2912','108','2005-08-03T22:07:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8847','2005-07-29T23:13:41.000','4133','480','2005-07-31T23:55:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8848','2005-07-29T23:20:58.000','2972','545','2005-08-03T17:28:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8849','2005-07-29T23:21:01.000','4300','79','2005-08-03T20:01:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8850','2005-07-29T23:24:20.000','355','86','2005-07-31T00:43:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8851','2005-07-29T23:26:19.000','212','445','2005-08-05T03:59:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8852','2005-07-29T23:30:03.000','1138','42','2005-08-05T05:22:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8853','2005-07-29T23:34:21.000','2323','58','2005-07-31T21:20:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8854','2005-07-29T23:40:07.000','1365','527','2005-08-01T00:35:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8855','2005-07-29T23:40:10.000','4388','335','2005-08-02T18:07:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8856','2005-07-29T23:42:00.000','2942','365','2005-08-07T03:00:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8857','2005-07-29T23:44:22.000','1348','477','2005-07-31T21:32:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8858','2005-07-29T23:44:35.000','2378','558','2005-08-01T05:25:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8859','2005-07-29T23:44:43.000','603','216','2005-08-07T18:14:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8860','2005-07-29T23:45:57.000','2841','531','2005-08-06T02:14:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8861','2005-07-29T23:47:29.000','759','560','2005-08-07T01:27:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8862','2005-07-29T23:49:23.000','916','21','2005-08-04T20:11:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8863','2005-07-29T23:52:01.000','75','47','2005-08-04T20:28:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8864','2005-07-29T23:52:12.000','2321','167','2005-07-30T22:12:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8865','2005-07-29T23:54:54.000','1835','305','2005-07-31T05:10:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8866','2005-07-29T23:58:19.000','1530','44','2005-08-01T05:19:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8867','2005-07-30T00:02:18.000','1388','497','2005-08-04T00:44:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8868','2005-07-30T00:02:26.000','1229','512','2005-08-01T22:28:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8869','2005-07-30T00:06:32.000','4353','308','2005-07-31T20:49:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8870','2005-07-30T00:08:08.000','4104','90','2005-08-08T00:15:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8871','2005-07-30T00:12:41.000','4535','382','2005-08-08T03:53:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8872','2005-07-30T00:13:54.000','2669','186','2005-08-01T18:34:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8873','2005-07-30T00:14:32.000','3498','91','2005-08-04T20:42:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8874','2005-07-30T00:14:45.000','459','564','2005-08-02T22:34:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8875','2005-07-30T00:15:09.000','1294','121','2005-08-04T02:54:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8876','2005-07-30T00:15:09.000','2394','579','2005-08-02T23:56:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8877','2005-07-30T00:15:22.000','1140','417','2005-07-31T00:53:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8878','2005-07-30T00:15:57.000','440','25','2005-08-01T00:22:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8879','2005-07-30T00:16:02.000','2956','584','2005-08-06T20:10:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8880','2005-07-30T00:16:55.000','2920','51','2005-08-01T01:05:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8881','2005-07-30T00:22:31.000','2012','118','2005-08-04T19:10:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8882','2005-07-30T00:24:05.000','441','410','2005-08-03T19:48:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8883','2005-07-30T00:24:48.000','1421','168','2005-08-04T00:24:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8884','2005-07-30T00:26:22.000','3050','80','2005-08-05T03:24:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8885','2005-07-30T00:36:26.000','2984','135','2005-08-06T03:05:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8886','2005-07-30T00:36:31.000','1469','418','2005-08-08T06:18:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8887','2005-07-30T00:36:54.000','4119','389','2005-08-04T19:07:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8888','2005-07-30T00:39:36.000','2824','284','2005-08-01T02:28:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8889','2005-07-30T00:39:43.000','3457','558','2005-08-02T23:22:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8890','2005-07-30T00:42:06.000','3656','470','2005-08-05T21:04:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8891','2005-07-30T00:46:55.000','4093','435','2005-08-06T23:32:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8892','2005-07-30T00:47:03.000','1584','184','2005-08-06T03:23:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8893','2005-07-30T00:48:19.000','1048','147','2005-08-01T03:25:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8894','2005-07-30T00:48:31.000','2055','552','2005-07-31T05:49:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8895','2005-07-30T00:49:17.000','3217','494','2005-07-31T01:56:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8896','2005-07-30T00:51:21.000','3560','205','2005-07-31T22:33:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8897','2005-07-30T01:00:17.000','1964','459','2005-08-01T03:41:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8898','2005-07-30T01:02:20.000','3961','452','2005-08-05T22:02:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8899','2005-07-30T01:05:30.000','4148','252','2005-08-01T23:32:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8900','2005-07-30T01:07:03.000','3057','375','2005-08-06T04:07:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8901','2005-07-30T01:07:12.000','4392','28','2005-08-02T06:34:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8902','2005-07-30T01:08:06.000','2983','408','2005-08-05T00:00:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8903','2005-07-30T01:08:06.000','4546','406','2005-07-30T21:47:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8904','2005-07-30T01:08:33.000','3622','575','2005-08-04T02:33:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8905','2005-07-30T01:11:11.000','2154','240','2005-08-04T22:39:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8906','2005-07-30T01:21:39.000','2667','560','2005-08-07T02:14:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8907','2005-07-30T01:25:03.000','3239','576','2005-08-03T05:41:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8908','2005-07-30T01:26:05.000','4498','391','2005-07-31T20:39:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8909','2005-07-30T01:28:03.000','2606','556','2005-08-06T04:40:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8910','2005-07-30T01:29:48.000','1039','569','2005-07-31T21:33:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8911','2005-07-30T01:30:57.000','2159','445','2005-08-02T20:01:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8912','2005-07-30T01:31:25.000','1686','280','2005-08-02T07:14:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8913','2005-07-30T01:35:01.000','429','391','2005-08-06T06:13:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8914','2005-07-30T01:42:03.000','1347','32','2005-08-04T03:53:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8915','2005-07-30T01:42:09.000','3030','42','2005-08-04T23:29:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8916','2005-07-30T01:42:21.000','3852','377','2005-08-03T05:28:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8917','2005-07-30T01:47:02.000','4460','309','2005-08-05T21:10:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8918','2005-07-30T01:56:22.000','2544','424','2005-08-04T01:58:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8919','2005-07-30T01:57:03.000','4006','337','2005-08-08T05:14:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8920','2005-07-30T01:59:24.000','4079','78','2005-08-02T22:37:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8921','2005-07-30T02:04:02.000','1016','354','2005-07-31T06:18:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8922','2005-07-30T02:08:25.000','1696','446','2005-08-08T07:19:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8923','2005-07-30T02:08:49.000','2425','446','2005-08-03T23:45:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8924','2005-07-30T02:08:58.000','2291','38','2005-08-05T02:13:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8925','2005-07-30T02:09:14.000','3753','500','2005-07-30T21:39:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8926','2005-07-30T02:10:31.000','3677','510','2005-08-03T23:56:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8927','2005-07-30T02:13:31.000','272','15','2005-08-01T01:34:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8928','2005-07-30T02:18:19.000','706','366','2005-08-05T00:49:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8929','2005-07-30T02:28:22.000','3501','472','2005-08-06T06:13:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8930','2005-07-30T02:28:38.000','1107','202','2005-08-02T01:43:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8931','2005-07-30T02:30:07.000','16','268','2005-08-02T08:24:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8932','2005-07-30T02:31:26.000','4537','295','2005-08-04T02:17:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8933','2005-07-30T02:36:06.000','1664','260','2005-08-02T23:37:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8934','2005-07-30T02:37:05.000','3223','494','2005-08-01T20:42:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8935','2005-07-30T02:38:45.000','285','76','2005-08-02T07:11:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8936','2005-07-30T02:47:13.000','1408','227','2005-08-01T02:25:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8937','2005-07-30T02:53:21.000','2406','544','2005-08-08T03:33:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8938','2005-07-30T02:56:08.000','4031','92','2005-07-31T23:08:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8939','2005-07-30T02:56:53.000','4175','598','2005-08-01T21:19:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8940','2005-07-30T02:57:26.000','1566','212','2005-08-05T22:05:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8941','2005-07-30T02:59:21.000','4147','329','2005-08-02T05:18:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8942','2005-07-30T03:01:07.000','4375','77','2005-08-06T22:50:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8943','2005-07-30T03:06:48.000','3698','531','2005-08-02T00:59:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8944','2005-07-30T03:11:44.000','3513','172','2005-08-06T23:15:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8945','2005-07-30T03:11:48.000','1441','447','2005-08-07T07:53:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8946','2005-07-30T03:14:53.000','3510','257','2005-08-04T00:50:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8947','2005-07-30T03:15:37.000','341','24','2005-08-04T07:10:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8948','2005-07-30T03:16:18.000','948','597','2005-08-04T03:16:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8949','2005-07-30T03:17:02.000','2876','231','2005-08-08T07:38:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8950','2005-07-30T03:17:13.000','3015','11','2005-08-07T00:20:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8951','2005-07-30T03:18:24.000','127','336','2005-08-08T08:50:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8952','2005-07-30T03:20:38.000','4397','36','2005-08-02T02:54:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8953','2005-07-30T03:21:05.000','535','278','2005-08-02T05:24:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8954','2005-07-30T03:25:51.000','991','137','2005-08-06T05:10:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8955','2005-07-30T03:28:27.000','4532','405','2005-08-04T04:56:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8956','2005-07-30T03:32:29.000','2129','71','2005-08-01T03:08:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8957','2005-07-30T03:34:10.000','811','158','2005-08-06T07:05:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8958','2005-07-30T03:34:26.000','1556','536','2005-08-06T08:14:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8959','2005-07-30T03:35:49.000','3508','550','2005-08-06T02:02:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8960','2005-07-30T03:36:31.000','391','525','2005-08-01T23:46:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8961','2005-07-30T03:43:35.000','3679','211','2005-08-06T07:42:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8962','2005-07-30T03:43:45.000','4439','406','2005-08-07T00:33:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8963','2005-07-30T03:46:26.000','100','544','2005-08-08T06:12:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8964','2005-07-30T03:49:35.000','280','424','2005-08-06T23:28:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8965','2005-07-30T03:52:37.000','2419','599','2005-08-05T01:28:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8966','2005-07-30T03:54:12.000','1903','522','2005-07-31T04:51:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8967','2005-07-30T03:56:55.000','1536','480','2005-08-06T05:25:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8968','2005-07-30T03:57:32.000','2280','339','2005-07-31T00:09:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8969','2005-07-30T04:00:19.000','2043','121','2005-08-06T04:39:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8970','2005-07-30T04:02:05.000','2940','313','2005-08-07T03:40:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8971','2005-07-30T04:03:58.000','3572','35','2005-08-08T04:16:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8972','2005-07-30T04:06:25.000','1974','89','2005-08-04T22:49:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8973','2005-07-30T04:09:13.000','886','282','2005-08-07T22:30:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8974','2005-07-30T04:09:16.000','3376','425','2005-08-04T06:55:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8975','2005-07-30T04:10:18.000','3288','356','2005-08-07T01:06:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8976','2005-07-30T04:12:32.000','2135','507','2005-08-04T23:08:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8977','2005-07-30T04:14:07.000','4099','334','2005-08-05T23:45:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8978','2005-07-30T04:14:28.000','711','5','2005-08-06T09:08:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8979','2005-07-30T04:20:25.000','1394','529','2005-08-08T03:39:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8980','2005-07-30T04:22:15.000','3061','105','2005-08-04T08:16:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8981','2005-07-30T04:25:30.000','4413','310','2005-08-06T02:37:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8982','2005-07-30T04:31:02.000','1128','251','2005-07-31T04:22:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8983','2005-07-30T04:31:08.000','1861','144','2005-07-31T09:28:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8984','2005-07-30T04:31:50.000','2126','485','2005-08-04T03:24:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8985','2005-07-30T04:34:51.000','3179','12','2005-08-06T00:45:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8986','2005-07-30T04:37:20.000','3992','551','2005-07-31T23:54:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8987','2005-07-30T04:37:36.000','1434','135','2005-08-08T10:14:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8988','2005-07-30T04:38:49.000','777','487','2005-08-07T07:00:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8989','2005-07-30T04:39:19.000','954','575','2005-08-06T02:11:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8990','2005-07-30T04:41:42.000','1869','292','2005-08-07T22:50:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8991','2005-07-30T04:42:54.000','4540','474','2005-08-01T23:51:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8992','2005-07-30T04:44:18.000','4478','54','2005-08-01T00:29:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8993','2005-07-30T04:51:25.000','1891','382','2005-08-01T01:04:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8994','2005-07-30T04:51:32.000','1527','287','2005-08-07T09:41:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8995','2005-07-30T04:53:11.000','3575','331','2005-08-07T00:24:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8996','2005-07-30T04:53:23.000','1970','579','2005-07-31T06:01:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8997','2005-07-30T04:53:56.000','850','31','2005-08-03T07:10:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8998','2005-07-30T04:54:14.000','1573','120','2005-08-08T08:18:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('8999','2005-07-30T04:55:46.000','3458','424','2005-08-01T00:16:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9000','2005-07-30T04:58:55.000','3763','290','2005-08-08T04:01:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9001','2005-07-30T04:59:41.000','3682','440','2005-07-31T08:56:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9002','2005-07-30T05:02:21.000','1936','137','2005-07-31T04:58:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9003','2005-07-30T05:02:52.000','1605','507','2005-07-31T10:33:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9004','2005-07-30T05:04:27.000','3775','178','2005-07-31T00:49:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9005','2005-07-30T05:04:58.000','157','204','2005-08-03T07:41:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9006','2005-07-30T05:06:32.000','3315','49','2005-07-31T08:24:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9007','2005-07-30T05:09:32.000','2813','63','2005-08-02T06:12:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9008','2005-07-30T05:10:26.000','3592','371','2005-07-31T08:13:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9009','2005-07-30T05:12:01.000','4136','166','2005-08-07T10:58:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9010','2005-07-30T05:12:04.000','1698','152','2005-08-06T02:54:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9011','2005-07-30T05:16:29.000','2799','236','2005-08-05T06:57:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9012','2005-07-30T05:18:57.000','3604','494','2005-08-06T06:21:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9013','2005-07-30T05:19:20.000','2367','347','2005-08-04T01:35:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9014','2005-07-30T05:19:27.000','311','297','2005-08-01T01:10:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9015','2005-07-30T05:21:32.000','4128','203','2005-08-08T07:03:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9016','2005-07-30T05:26:13.000','4309','312','2005-08-04T00:25:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9017','2005-07-30T05:26:20.000','3325','319','2005-08-04T10:00:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9018','2005-07-30T05:28:40.000','1982','218','2005-08-07T01:34:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9019','2005-07-30T05:28:53.000','946','235','2005-08-03T02:16:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9020','2005-07-30T05:31:27.000','1700','142','2005-08-08T06:44:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9021','2005-07-30T05:34:24.000','674','498','2005-08-03T04:13:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9022','2005-07-30T05:34:45.000','4473','159','2005-08-03T23:57:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9023','2005-07-30T05:36:40.000','2911','148','2005-08-07T06:20:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9024','2005-07-30T05:44:42.000','164','329','2005-08-05T03:15:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9025','2005-07-30T05:50:08.000','2244','473','2005-07-31T09:58:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9026','2005-07-30T05:55:31.000','1524','423','2005-08-01T03:19:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9027','2005-07-30T05:58:27.000','449','72','2005-08-03T03:02:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9028','2005-07-30T06:00:35.000','2687','119','2005-08-02T01:35:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9029','2005-07-30T06:03:11.000','2220','52','2005-08-04T01:42:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9030','2005-07-30T06:05:38.000','2237','367','2005-08-03T00:19:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9031','2005-07-30T06:06:10.000','2377','2','2005-08-04T10:45:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9032','2005-07-30T06:06:54.000','4448','369','2005-08-01T05:27:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9033','2005-07-30T06:07:42.000','3416','35','2005-08-05T01:18:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9034','2005-07-30T06:10:58.000','3847','144','2005-08-08T05:00:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9035','2005-07-30T06:16:07.000','3785','243','2005-08-06T09:22:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9036','2005-07-30T06:18:38.000','790','18','2005-07-31T01:22:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9037','2005-07-30T06:23:14.000','3833','356','2005-08-08T06:25:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9038','2005-07-30T06:23:35.000','217','514','2005-08-06T11:10:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9039','2005-07-30T06:24:28.000','4493','485','2005-08-08T00:28:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9040','2005-07-30T06:31:45.000','392','33','2005-08-03T12:20:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9041','2005-07-30T06:32:36.000','1103','454','2005-08-01T10:28:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9042','2005-07-30T06:33:55.000','2770','398','2005-08-04T09:31:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9043','2005-07-30T06:34:07.000','4127','9','2005-08-02T01:16:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9044','2005-07-30T06:35:21.000','3796','319','2005-07-31T10:27:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9045','2005-07-30T06:36:57.000','4521','46','2005-08-08T01:51:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9046','2005-07-30T06:46:55.000','1736','215','2005-08-01T02:21:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9047','2005-07-30T06:56:33.000','256','522','2005-08-08T06:40:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9048','2005-07-30T06:57:07.000','3929','100','2005-08-05T00:57:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9049','2005-07-30T06:57:28.000','2620','417','2005-08-04T09:02:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9050','2005-07-30T06:59:55.000','106','40','2005-08-06T06:37:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9051','2005-07-30T07:05:54.000','1847','337','2005-08-07T09:12:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9052','2005-07-30T07:06:08.000','3351','408','2005-08-03T10:30:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9053','2005-07-30T07:07:39.000','2535','485','2005-08-01T09:22:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9054','2005-07-30T07:11:44.000','2860','209','2005-08-08T01:55:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9055','2005-07-30T07:13:07.000','634','512','2005-08-01T12:18:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9056','2005-07-30T07:13:20.000','4363','380','2005-08-03T07:36:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9057','2005-07-30T07:14:18.000','3141','202','2005-08-01T05:10:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9058','2005-07-30T07:15:45.000','4214','403','2005-07-31T02:57:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9059','2005-07-30T07:18:44.000','480','267','2005-08-08T08:39:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9060','2005-07-30T07:20:36.000','4360','87','2005-08-03T10:51:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9061','2005-07-30T07:21:52.000','1933','255','2005-08-08T10:52:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9062','2005-07-30T07:23:17.000','2780','358','2005-08-02T12:07:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9063','2005-07-30T07:24:34.000','2851','564','2005-08-05T01:28:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9064','2005-07-30T07:24:55.000','1417','194','2005-08-07T08:44:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9065','2005-07-30T07:25:09.000','349','238','2005-07-31T05:18:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9066','2005-07-30T07:28:54.000','196','171','2005-08-02T05:23:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9067','2005-07-30T07:31:01.000','3628','382','2005-08-04T11:44:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9068','2005-07-30T07:31:45.000','2264','78','2005-08-08T06:40:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9069','2005-07-30T07:39:59.000','1852','258','2005-08-02T04:10:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9070','2005-07-30T07:40:39.000','3690','276','2005-08-01T04:19:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9071','2005-07-30T07:40:58.000','3151','523','2005-08-01T06:59:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9072','2005-07-30T07:45:49.000','4536','106','2005-08-04T10:00:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9073','2005-07-30T07:49:56.000','2185','141','2005-08-05T06:25:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9074','2005-07-30T07:50:10.000','3244','84','2005-08-01T11:21:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9075','2005-07-30T07:55:14.000','1931','20','2005-08-02T13:49:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9076','2005-07-30T07:58:12.000','496','447','2005-08-08T06:04:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9077','2005-07-30T08:00:19.000','4324','471','2005-08-08T11:21:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9078','2005-07-30T08:01:00.000','955','300','2005-07-31T10:39:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9079','2005-07-30T08:02:00.000','2143','193','2005-07-31T04:02:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9080','2005-07-30T08:02:39.000','94','276','2005-08-06T12:02:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9081','2005-07-30T08:09:58.000','3040','572','2005-08-03T13:27:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9082','2005-07-30T08:11:22.000','4042','438','2005-08-06T09:26:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9083','2005-07-30T08:14:27.000','456','488','2005-08-07T14:02:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9084','2005-07-30T08:14:29.000','3950','171','2005-08-03T11:12:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9085','2005-07-30T08:17:24.000','3400','33','2005-08-03T09:35:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9086','2005-07-30T08:18:46.000','2779','57','2005-08-06T06:10:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9087','2005-07-30T08:19:47.000','4048','546','2005-08-02T07:15:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9088','2005-07-30T08:21:02.000','3407','245','2005-08-01T09:55:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9089','2005-07-30T08:23:39.000','490','369','2005-07-31T06:00:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9090','2005-07-30T08:24:42.000','3426','104','2005-08-08T06:17:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9091','2005-07-30T08:30:45.000','2249','66','2005-08-07T13:28:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9092','2005-07-30T08:30:56.000','1877','17','2005-08-06T08:09:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9093','2005-07-30T08:33:24.000','2208','96','2005-08-04T11:07:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9094','2005-07-30T08:35:10.000','2699','140','2005-08-07T08:18:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9095','2005-07-30T08:38:36.000','3019','511','2005-07-31T06:14:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9096','2005-07-30T08:39:23.000','540','216','2005-08-01T03:33:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9097','2005-07-30T08:40:35.000','570','173','2005-08-04T11:19:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9098','2005-07-30T08:44:21.000','1267','144','2005-08-08T12:31:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9099','2005-07-30T08:45:48.000','594','250','2005-08-01T03:18:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9100','2005-07-30T08:46:09.000','4117','4','2005-08-05T10:34:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9101','2005-07-30T08:47:13.000','3165','566','2005-08-02T12:52:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9102','2005-07-30T08:48:20.000','1154','276','2005-08-04T10:19:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9103','2005-07-30T08:49:26.000','3806','280','2005-07-31T14:15:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9104','2005-07-30T08:49:55.000','3372','322','2005-08-06T12:23:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9105','2005-07-30T08:50:25.000','4443','262','2005-08-05T06:08:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9106','2005-07-30T08:52:34.000','2935','148','2005-08-02T07:38:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9107','2005-07-30T08:52:45.000','1068','531','2005-08-05T08:39:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9108','2005-07-30T08:56:36.000','3977','490','2005-08-04T11:07:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9109','2005-07-30T08:58:24.000','787','266','2005-08-07T06:56:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9110','2005-07-30T09:05:42.000','1474','317','2005-08-03T05:15:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9111','2005-07-30T09:05:44.000','166','211','2005-08-04T14:27:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9112','2005-07-30T09:06:31.000','395','74','2005-08-04T05:12:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9113','2005-07-30T09:09:03.000','3903','374','2005-07-31T03:13:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9114','2005-07-30T09:13:21.000','893','18','2005-08-05T06:00:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9115','2005-07-30T09:13:55.000','3750','322','2005-08-04T04:02:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9116','2005-07-30T09:19:41.000','2917','446','2005-08-03T08:01:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9117','2005-07-30T09:20:59.000','3055','371','2005-08-07T08:47:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9118','2005-07-30T09:24:18.000','4538','172','2005-08-02T14:46:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9119','2005-07-30T09:25:56.000','275','305','2005-08-03T03:36:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9120','2005-07-30T09:26:08.000','139','473','2005-08-08T09:52:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9121','2005-07-30T09:36:26.000','3098','150','2005-08-05T15:17:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9122','2005-07-30T09:36:52.000','627','365','2005-08-05T13:20:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9123','2005-07-30T09:39:15.000','3748','293','2005-08-02T08:12:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9124','2005-07-30T09:43:12.000','4552','105','2005-08-06T06:17:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9125','2005-07-30T09:43:39.000','333','335','2005-08-07T14:02:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9126','2005-07-30T09:44:15.000','4495','590','2005-08-02T11:02:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9127','2005-07-30T09:46:36.000','4114','300','2005-07-31T07:43:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9128','2005-07-30T09:51:14.000','3647','372','2005-08-07T06:23:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9129','2005-07-30T09:51:21.000','2658','125','2005-08-07T08:50:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9130','2005-07-30T09:55:10.000','1715','354','2005-08-04T08:57:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9131','2005-07-30T09:55:57.000','623','142','2005-08-01T14:21:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9132','2005-07-30T09:56:00.000','402','159','2005-08-02T09:22:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9133','2005-07-30T09:59:00.000','408','576','2005-08-07T04:24:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9134','2005-07-30T10:00:21.000','3797','559','2005-08-01T05:01:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9135','2005-07-30T10:06:53.000','821','161','2005-08-03T13:57:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9136','2005-07-30T10:07:20.000','1734','57','2005-07-31T08:20:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9137','2005-07-30T10:09:24.000','840','459','2005-08-06T04:30:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9138','2005-07-30T10:11:52.000','2550','17','2005-07-31T07:05:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9139','2005-07-30T10:11:52.000','2809','133','2005-08-03T12:44:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9140','2005-07-30T10:12:01.000','4095','25','2005-08-06T09:16:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9141','2005-07-30T10:16:04.000','3087','484','2005-08-05T08:01:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9142','2005-07-30T10:21:03.000','4467','486','2005-08-04T15:14:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9143','2005-07-30T10:22:11.000','2962','511','2005-08-07T06:13:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9144','2005-07-30T10:22:15.000','718','381','2005-08-05T08:14:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9145','2005-07-30T10:27:55.000','559','176','2005-08-07T14:41:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9146','2005-07-30T10:32:08.000','483','302','2005-08-08T14:30:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9147','2005-07-30T10:38:59.000','4167','394','2005-08-02T11:45:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9148','2005-07-30T10:39:10.000','1407','333','2005-08-04T07:17:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9149','2005-07-30T10:45:12.000','2632','21','2005-08-01T09:40:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9150','2005-07-30T10:49:32.000','2834','213','2005-08-08T15:43:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9151','2005-07-30T10:50:53.000','3956','102','2005-08-07T08:19:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9152','2005-07-30T10:51:27.000','3607','595','2005-07-31T06:38:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9153','2005-07-30T10:58:16.000','3743','589','2005-08-03T06:16:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9154','2005-07-30T10:59:54.000','576','312','2005-08-05T16:47:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9155','2005-07-30T11:00:00.000','3787','107','2005-08-02T05:24:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9156','2005-07-30T11:04:55.000','1747','145','2005-07-31T14:10:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9157','2005-07-30T11:06:23.000','146','19','2005-08-05T05:29:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9158','2005-07-30T11:12:03.000','4017','16','2005-08-02T05:55:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9159','2005-07-30T11:16:37.000','1234','217','2005-08-03T10:32:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9160','2005-07-30T11:17:33.000','183','34','2005-08-06T15:16:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9161','2005-07-30T11:19:18.000','969','433','2005-08-02T05:32:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9162','2005-07-30T11:21:56.000','4198','184','2005-08-02T15:32:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9163','2005-07-30T11:23:22.000','4562','345','2005-07-31T07:34:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9164','2005-07-30T11:24:14.000','4434','342','2005-08-08T16:24:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9165','2005-07-30T11:24:28.000','4034','291','2005-08-03T09:38:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9166','2005-07-30T11:26:28.000','308','12','2005-08-04T12:32:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9167','2005-07-30T11:30:37.000','1785','162','2005-08-08T17:13:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9168','2005-07-30T11:31:17.000','2035','75','2005-08-08T16:56:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9169','2005-07-30T11:35:00.000','1567','245','2005-08-06T16:16:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9170','2005-07-30T11:35:24.000','4279','425','2005-08-05T05:36:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9171','2005-07-30T11:36:24.000','1832','189','2005-08-07T06:04:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9172','2005-07-30T11:36:38.000','695','437','2005-08-04T09:39:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9173','2005-07-30T11:40:10.000','2103','381','2005-08-04T05:40:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9174','2005-07-30T11:42:10.000','2636','144','2005-07-31T09:52:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9175','2005-07-30T11:47:48.000','358','133','2005-08-02T08:13:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9176','2005-07-30T11:50:54.000','2659','260','2005-08-02T14:25:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9177','2005-07-30T11:52:40.000','1088','400','2005-08-08T09:35:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9178','2005-07-30T11:58:50.000','2046','448','2005-08-08T15:24:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9179','2005-07-30T12:02:41.000','62','50','2005-08-05T15:23:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9180','2005-07-30T12:03:15.000','3479','442','2005-08-01T14:25:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9181','2005-07-30T12:05:58.000','3953','224','2005-08-02T06:22:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9182','2005-07-30T12:06:58.000','2533','165','2005-08-08T11:33:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9183','2005-07-30T12:09:56.000','4320','475','2005-08-06T11:50:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9184','2005-07-30T12:10:19.000','51','365','2005-08-01T07:35:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9185','2005-07-30T12:10:40.000','2268','426','2005-08-06T07:01:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9186','2005-07-30T12:13:48.000','4513','273','2005-07-31T11:59:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9187','2005-07-30T12:14:03.000','4008','469','2005-08-04T13:10:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9188','2005-07-30T12:19:54.000','727','195','2005-08-06T09:12:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9189','2005-07-30T12:20:59.000','4529','485','2005-08-06T16:15:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9190','2005-07-30T12:24:17.000','4421','177','2005-08-03T07:41:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9191','2005-07-30T12:25:51.000','500','314','2005-08-05T16:13:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9192','2005-07-30T12:26:26.000','2372','102','2005-08-04T07:54:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9193','2005-07-30T12:28:42.000','3470','69','2005-08-02T12:17:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9194','2005-07-30T12:28:45.000','2467','294','2005-08-06T14:38:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9195','2005-07-30T12:29:43.000','944','440','2005-08-04T12:35:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9196','2005-07-30T12:30:19.000','4298','251','2005-07-31T18:01:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9197','2005-07-30T12:31:36.000','3214','168','2005-08-03T09:05:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9198','2005-07-30T12:37:08.000','2371','105','2005-08-07T16:37:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9199','2005-07-30T12:38:00.000','4336','580','2005-08-01T07:09:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9200','2005-07-30T12:39:52.000','3277','137','2005-08-08T09:43:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9201','2005-07-30T12:42:21.000','4387','291','2005-08-08T06:50:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9202','2005-07-30T12:43:24.000','4525','466','2005-08-07T10:39:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9203','2005-07-30T12:43:40.000','2112','169','2005-08-01T09:31:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9204','2005-07-30T12:43:58.000','4378','43','2005-08-03T16:26:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9205','2005-07-30T12:46:40.000','4165','259','2005-08-08T14:58:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9206','2005-07-30T12:46:59.000','2021','404','2005-08-03T14:58:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9207','2005-07-30T12:49:57.000','1346','345','2005-07-31T14:32:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9208','2005-07-30T12:54:03.000','2751','339','2005-08-06T17:22:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9209','2005-07-30T12:55:36.000','3940','23','2005-08-03T11:31:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9210','2005-07-30T12:56:44.000','101','105','2005-08-08T09:41:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9211','2005-07-30T12:59:45.000','595','57','2005-08-07T18:17:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9212','2005-07-30T13:03:13.000','2111','73','2005-08-06T09:48:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9213','2005-07-30T13:07:11.000','184','388','2005-08-01T15:30:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9214','2005-07-30T13:10:14.000','2823','181','2005-08-06T14:22:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9215','2005-07-30T13:11:11.000','3591','128','2005-08-06T13:06:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9216','2005-07-30T13:11:19.000','2783','38','2005-07-31T11:27:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9217','2005-07-30T13:13:55.000','1561','112','2005-08-05T17:27:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9218','2005-07-30T13:14:35.000','119','172','2005-08-07T18:03:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9219','2005-07-30T13:15:21.000','771','329','2005-08-01T11:39:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9220','2005-07-30T13:17:27.000','2463','569','2005-08-07T11:34:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9221','2005-07-30T13:20:06.000','2496','113','2005-08-06T13:58:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9222','2005-07-30T13:21:08.000','3648','95','2005-08-08T10:42:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9223','2005-07-30T13:23:20.000','3231','595','2005-08-04T11:24:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9224','2005-07-30T13:25:37.000','2260','406','2005-08-01T15:13:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9225','2005-07-30T13:29:47.000','1992','391','2005-08-02T17:08:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9226','2005-07-30T13:31:20.000','4315','3','2005-08-06T16:42:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9227','2005-07-30T13:36:13.000','2353','522','2005-08-07T17:39:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9228','2005-07-30T13:36:57.000','2325','91','2005-08-05T10:43:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9229','2005-07-30T13:38:17.000','3780','276','2005-08-08T18:17:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9230','2005-07-30T13:39:42.000','1199','109','2005-07-31T19:20:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9231','2005-07-30T13:42:15.000','1587','489','2005-08-02T19:27:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9232','2005-07-30T13:43:00.000','1991','502','2005-08-02T11:39:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9233','2005-07-30T13:44:15.000','2320','357','2005-08-07T13:02:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9234','2005-07-30T13:45:54.000','1660','128','2005-08-02T15:33:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9235','2005-07-30T13:47:17.000','984','181','2005-08-06T17:15:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9236','2005-07-30T13:47:43.000','4030','2','2005-08-08T18:52:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9237','2005-07-30T13:48:17.000','2777','157','2005-07-31T13:57:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9238','2005-07-30T13:49:43.000','3356','12','2005-08-08T08:25:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9239','2005-07-30T13:50:52.000','1728','580','2005-08-06T16:28:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9240','2005-07-30T13:57:54.000','587','92','2005-08-03T12:23:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9241','2005-07-30T13:58:41.000','4145','187','2005-08-04T09:44:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9242','2005-07-30T14:03:58.000','755','306','2005-08-02T18:09:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9243','2005-07-30T14:06:27.000','876','516','2005-08-06T09:26:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9244','2005-07-30T14:06:53.000','3640','27','2005-08-03T19:46:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9245','2005-07-30T14:07:50.000','2586','116','2005-08-06T17:59:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9246','2005-07-30T14:12:31.000','3390','185','2005-08-02T14:25:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9247','2005-07-30T14:13:56.000','4106','426','2005-08-02T16:34:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9248','2005-07-30T14:14:11.000','1382','2','2005-08-05T11:19:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9249','2005-07-30T14:15:02.000','2015','296','2005-08-05T13:02:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9250','2005-07-30T14:18:16.000','4544','539','2005-08-04T12:31:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9251','2005-07-30T14:19:25.000','2948','390','2005-08-08T11:22:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9252','2005-07-30T14:19:59.000','2350','322','2005-08-07T15:17:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9253','2005-07-30T14:20:12.000','4183','151','2005-07-31T11:31:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9254','2005-07-30T14:26:11.000','495','33','2005-08-04T16:12:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9255','2005-07-30T14:26:46.000','1596','23','2005-08-07T18:16:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9256','2005-07-30T14:29:29.000','4021','19','2005-08-05T16:59:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9257','2005-07-30T14:30:38.000','2615','466','2005-08-04T17:57:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9258','2005-07-30T14:31:31.000','2007','275','2005-08-05T16:29:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9259','2005-07-30T14:37:44.000','97','138','2005-08-06T18:05:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9260','2005-07-30T14:38:22.000','3969','13','2005-08-07T18:47:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9261','2005-07-30T14:39:35.000','372','380','2005-08-08T11:26:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9262','2005-07-30T14:45:02.000','2322','349','2005-08-05T15:18:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9263','2005-07-30T14:48:24.000','73','410','2005-08-04T19:06:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9264','2005-07-30T14:51:36.000','4071','157','2005-08-02T10:06:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9265','2005-07-30T14:55:25.000','3700','560','2005-08-02T11:34:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9266','2005-07-30T14:59:01.000','1705','364','2005-07-31T17:01:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9267','2005-07-30T14:59:05.000','645','409','2005-08-04T10:17:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9268','2005-07-30T15:02:30.000','3593','592','2005-08-05T12:50:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9269','2005-07-30T15:02:33.000','548','435','2005-08-02T16:32:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9270','2005-07-30T15:03:16.000','700','232','2005-07-31T16:09:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9271','2005-07-30T15:04:31.000','2660','100','2005-07-31T20:33:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9272','2005-07-30T15:05:22.000','1352','553','2005-08-05T10:02:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9273','2005-07-30T15:05:36.000','1867','497','2005-08-08T09:07:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9274','2005-07-30T15:07:04.000','4424','47','2005-08-06T11:17:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9275','2005-07-30T15:09:15.000','1916','439','2005-07-31T10:23:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9276','2005-07-30T15:09:28.000','1528','237','2005-08-06T19:39:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9277','2005-07-30T15:13:45.000','3734','82','2005-08-05T10:25:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9278','2005-07-30T15:15:19.000','3782','581','2005-08-03T20:21:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9279','2005-07-30T15:15:21.000','1070','567','2005-08-07T18:46:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9280','2005-07-30T15:15:38.000','4103','286','2005-08-05T19:20:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9281','2005-07-30T15:15:51.000','3086','398','2005-08-05T12:58:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9282','2005-07-30T15:17:31.000','736','259','2005-08-07T20:46:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9283','2005-07-30T15:25:19.000','1858','360','2005-08-01T15:35:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9284','2005-07-30T15:25:19.000','3976','38','2005-08-01T17:45:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9285','2005-07-30T15:26:08.000','3686','273','2005-08-06T15:59:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9286','2005-07-30T15:32:28.000','2477','154','2005-07-31T20:42:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9287','2005-07-30T15:35:39.000','2048','551','2005-08-02T10:15:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9288','2005-07-30T15:56:39.000','2640','447','2005-08-04T13:25:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9289','2005-07-30T15:57:04.000','389','453','2005-08-07T18:46:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9290','2005-07-30T15:59:08.000','2275','500','2005-08-06T21:49:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9291','2005-07-30T16:03:39.000','2884','406','2005-08-05T11:11:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9292','2005-07-30T16:08:21.000','1702','11','2005-08-07T10:38:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9293','2005-07-30T16:12:28.000','1676','65','2005-08-05T18:34:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9294','2005-07-30T16:14:37.000','2468','433','2005-08-07T18:49:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9295','2005-07-30T16:18:39.000','494','102','2005-08-03T12:46:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9296','2005-07-30T16:21:13.000','4088','2','2005-08-08T11:57:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9297','2005-07-30T16:26:29.000','3502','191','2005-08-03T13:51:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9298','2005-07-30T16:27:53.000','2106','208','2005-08-07T12:32:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9299','2005-07-30T16:32:51.000','1515','555','2005-08-08T15:28:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9300','2005-07-30T16:33:12.000','1639','571','2005-08-05T15:56:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9301','2005-07-30T16:34:29.000','1073','174','2005-07-31T18:41:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9302','2005-07-30T16:34:57.000','2326','55','2005-07-31T11:08:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9303','2005-07-30T16:35:59.000','4299','186','2005-08-03T18:31:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9304','2005-07-30T16:41:34.000','2937','296','2005-08-02T13:55:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9305','2005-07-30T16:45:56.000','1224','82','2005-08-08T21:15:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9306','2005-07-30T16:47:17.000','3983','336','2005-08-02T22:15:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9307','2005-07-30T16:52:43.000','3831','538','2005-08-01T11:58:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9308','2005-07-30T16:53:21.000','2202','267','2005-08-08T15:33:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9309','2005-07-30T16:55:53.000','3616','30','2005-08-07T11:23:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9310','2005-07-30T16:57:09.000','2957','529','2005-08-03T18:14:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9311','2005-07-30T16:58:31.000','1432','178','2005-08-07T15:23:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9312','2005-07-30T16:59:17.000','2483','76','2005-08-03T17:24:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9313','2005-07-30T16:59:43.000','4070','41','2005-08-05T14:06:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9314','2005-07-30T17:05:19.000','2358','390','2005-07-31T12:19:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9315','2005-07-30T17:05:29.000','444','96','2005-08-01T12:47:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9316','2005-07-30T17:11:58.000','4409','366','2005-08-05T14:36:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9317','2005-07-30T17:13:37.000','4138','217','2005-08-08T11:33:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9318','2005-07-30T17:14:30.000','2426','314','2005-08-06T16:53:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9319','2005-07-30T17:15:27.000','4066','136','2005-08-03T14:03:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9320','2005-07-30T17:16:39.000','909','221','2005-08-06T18:43:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9321','2005-07-30T17:19:44.000','3558','112','2005-08-06T22:42:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9322','2005-07-30T17:21:39.000','223','439','2005-08-06T16:58:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9323','2005-07-30T17:21:44.000','3749','131','2005-08-03T16:28:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9324','2005-07-30T17:28:52.000','1231','332','2005-08-06T19:02:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9325','2005-07-30T17:29:19.000','1938','476','2005-08-08T12:55:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9326','2005-07-30T17:30:03.000','3772','588','2005-08-01T13:41:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9327','2005-07-30T17:31:03.000','345','373','2005-08-08T19:16:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9328','2005-07-30T17:32:11.000','1087','89','2005-08-05T13:36:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9329','2005-07-30T17:42:38.000','1293','593','2005-08-08T23:17:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9330','2005-07-30T17:44:24.000','4227','232','2005-08-08T17:39:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9331','2005-07-30T17:46:50.000','2248','274','2005-08-01T19:03:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9332','2005-07-30T17:53:39.000','1156','480','2005-08-02T12:25:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9333','2005-07-30T17:53:45.000','1377','437','2005-07-31T22:35:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9334','2005-07-30T17:56:38.000','1499','25','2005-08-03T21:27:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9335','2005-07-30T18:00:53.000','1006','522','2005-08-01T16:05:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9336','2005-07-30T18:01:15.000','1911','557','2005-08-05T23:10:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9337','2005-07-30T18:02:25.000','2363','90','2005-07-31T12:30:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9338','2005-07-30T18:03:13.000','1482','333','2005-08-08T23:57:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9339','2005-07-30T18:03:28.000','3171','68','2005-08-08T19:45:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9340','2005-07-30T18:07:16.000','3228','213','2005-08-04T14:33:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9341','2005-07-30T18:07:58.000','894','557','2005-08-01T17:43:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9342','2005-07-30T18:09:56.000','2318','552','2005-08-08T13:54:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9343','2005-07-30T18:13:13.000','3521','53','2005-08-02T13:48:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9344','2005-07-30T18:13:45.000','1005','396','2005-08-07T15:23:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9345','2005-07-30T18:13:51.000','2042','436','2005-08-07T13:45:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9346','2005-07-30T18:13:52.000','2845','196','2005-08-03T17:58:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9347','2005-07-30T18:16:03.000','3557','479','2005-08-05T18:35:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9348','2005-07-30T18:17:09.000','3128','87','2005-08-07T15:25:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9349','2005-07-30T18:20:08.000','3739','579','2005-08-08T22:06:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9350','2005-07-30T18:24:30.000','798','434','2005-08-02T15:34:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9351','2005-07-30T18:28:30.000','2063','107','2005-08-02T17:26:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9352','2005-07-30T18:29:26.000','2619','360','2005-07-31T19:43:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9353','2005-07-30T18:30:37.000','3581','283','2005-08-06T22:32:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9354','2005-07-30T18:32:51.000','510','595','2005-08-02T21:28:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9355','2005-07-30T18:35:25.000','1122','201','2005-08-03T20:33:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9356','2005-07-30T18:36:24.000','4188','60','2005-08-03T14:10:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9357','2005-07-30T18:37:00.000','3927','181','2005-08-08T19:57:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9358','2005-07-30T18:37:24.000','712','302','2005-08-07T23:34:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9359','2005-07-30T18:39:28.000','21','501','2005-07-31T15:39:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9360','2005-07-30T18:39:43.000','2119','186','2005-08-04T22:41:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9361','2005-07-30T18:43:49.000','4163','335','2005-08-06T21:24:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9362','2005-07-30T18:44:16.000','3357','420','2005-08-01T20:14:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9363','2005-07-30T18:44:23.000','873','323','2005-08-04T15:03:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9364','2005-07-30T18:44:44.000','306','87','2005-08-08T23:55:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9365','2005-07-30T18:46:02.000','1539','232','2005-08-03T20:15:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9366','2005-07-30T18:48:57.000','4013','557','2005-08-03T15:17:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9367','2005-07-30T18:49:58.000','793','557','2005-08-08T22:04:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9368','2005-07-30T18:50:53.000','3026','388','2005-08-05T17:56:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9369','2005-07-30T18:52:19.000','3538','36','2005-08-01T12:53:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9370','2005-07-30T18:57:29.000','4433','588','2005-08-01T21:35:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9371','2005-07-30T18:58:00.000','2980','4','2005-08-03T15:14:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9372','2005-07-30T19:04:30.000','4075','454','2005-08-09T00:18:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9373','2005-07-30T19:05:36.000','3478','180','2005-08-05T16:16:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9374','2005-07-30T19:10:03.000','103','302','2005-08-06T21:54:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9375','2005-07-30T19:10:17.000','3063','529','2005-08-02T23:00:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9376','2005-07-30T19:11:49.000','451','86','2005-08-04T18:14:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9377','2005-07-30T19:12:18.000','4164','421','2005-08-05T19:38:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9378','2005-07-30T19:12:54.000','2209','197','2005-08-05T18:16:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9379','2005-07-30T19:13:01.000','3855','452','2005-08-07T19:18:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9380','2005-07-30T19:17:31.000','4403','264','2005-08-01T20:46:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9381','2005-07-30T19:23:04.000','4064','329','2005-07-31T23:37:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9382','2005-07-30T19:23:44.000','2127','17','2005-08-06T16:20:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9383','2005-07-30T19:24:50.000','2806','416','2005-08-01T21:41:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9384','2005-07-30T19:25:35.000','2313','220','2005-08-08T21:50:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9385','2005-07-30T19:25:49.000','3453','570','2005-08-08T17:08:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9386','2005-07-30T19:26:21.000','1123','189','2005-08-05T21:00:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9387','2005-07-30T19:27:05.000','577','495','2005-08-07T21:19:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9388','2005-07-30T19:27:22.000','2116','332','2005-08-08T15:31:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9389','2005-07-30T19:27:59.000','3124','198','2005-08-04T18:25:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9390','2005-07-30T19:42:07.000','1794','103','2005-08-01T23:17:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9391','2005-07-30T19:48:41.000','665','273','2005-08-04T15:27:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9392','2005-07-30T19:50:13.000','2797','29','2005-08-03T22:38:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9393','2005-07-30T20:04:48.000','843','158','2005-08-02T15:52:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9394','2005-07-30T20:06:24.000','161','204','2005-08-06T22:36:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9395','2005-07-30T20:07:06.000','1298','306','2005-08-08T21:21:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9396','2005-07-30T20:07:24.000','1250','91','2005-08-03T21:20:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9397','2005-07-30T20:07:29.000','1550','373','2005-08-05T00:36:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9398','2005-07-30T20:09:00.000','1175','570','2005-08-01T23:35:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9399','2005-07-30T20:14:50.000','3668','569','2005-08-03T17:30:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9400','2005-07-30T20:15:58.000','3910','368','2005-08-03T21:21:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9401','2005-07-30T20:18:19.000','2057','331','2005-08-07T15:46:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9402','2005-07-30T20:18:27.000','2424','48','2005-08-07T21:29:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9403','2005-07-30T20:18:53.000','3466','267','2005-08-06T19:54:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9404','2005-07-30T20:21:35.000','3832','140','2005-08-02T15:52:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9405','2005-07-30T20:22:17.000','1983','463','2005-08-08T16:55:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9406','2005-07-30T20:24:00.000','3419','453','2005-08-07T19:50:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9407','2005-07-30T20:25:24.000','2594','585','2005-08-08T22:51:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9408','2005-07-30T20:32:09.000','4383','571','2005-08-04T20:14:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9409','2005-07-30T20:33:53.000','3053','156','2005-08-05T18:32:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9410','2005-07-30T20:38:05.000','1789','22','2005-07-31T19:57:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9411','2005-07-30T20:38:22.000','3484','536','2005-08-06T01:23:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9412','2005-07-30T20:44:10.000','2482','522','2005-08-06T21:13:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9413','2005-07-30T20:44:39.000','2618','290','2005-08-01T01:56:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9414','2005-07-30T20:46:02.000','578','484','2005-08-07T21:23:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9415','2005-07-30T20:48:31.000','3336','139','2005-08-05T19:45:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9416','2005-07-30T20:52:45.000','1470','265','2005-08-02T17:38:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9417','2005-07-30T20:54:55.000','2509','519','2005-08-04T00:54:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9418','2005-07-30T21:00:52.000','241','168','2005-08-08T15:56:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9419','2005-07-30T21:04:59.000','4427','142','2005-08-06T15:47:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9420','2005-07-30T21:05:18.000','147','72','2005-08-05T23:52:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9421','2005-07-30T21:08:32.000','2206','161','2005-08-02T00:43:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9422','2005-07-30T21:08:41.000','1843','470','2005-08-07T15:55:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9423','2005-07-30T21:10:14.000','3145','242','2005-08-07T16:34:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9424','2005-07-30T21:10:56.000','4499','256','2005-08-05T00:01:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9425','2005-07-30T21:11:21.000','271','295','2005-08-05T19:00:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9427','2005-07-30T21:16:33.000','1494','85','2005-08-05T17:23:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9428','2005-07-30T21:18:37.000','1948','335','2005-08-05T16:09:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9429','2005-07-30T21:19:26.000','1769','288','2005-08-07T18:39:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9430','2005-07-30T21:20:13.000','1529','367','2005-08-04T21:45:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9431','2005-07-30T21:24:22.000','3364','39','2005-08-03T01:22:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9432','2005-07-30T21:26:18.000','2489','570','2005-08-05T00:23:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9433','2005-07-30T21:28:17.000','1082','128','2005-08-08T18:20:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9434','2005-07-30T21:29:41.000','3792','13','2005-08-01T16:30:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9435','2005-07-30T21:31:02.000','3116','301','2005-08-05T22:34:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9436','2005-07-30T21:33:01.000','2329','268','2005-08-06T17:38:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9437','2005-07-30T21:36:04.000','1230','592','2005-08-08T01:26:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9438','2005-07-30T21:36:15.000','121','14','2005-08-07T16:54:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9439','2005-07-30T21:38:12.000','290','479','2005-08-06T00:03:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9440','2005-07-30T21:40:15.000','414','535','2005-08-04T15:45:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9441','2005-07-30T21:43:28.000','3982','519','2005-08-08T16:57:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9442','2005-07-30T21:44:31.000','44','75','2005-08-04T01:29:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9443','2005-07-30T21:45:46.000','1675','3','2005-08-05T21:22:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9444','2005-07-30T21:48:44.000','1134','259','2005-08-08T22:36:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9445','2005-07-30T21:50:42.000','1480','549','2005-08-05T18:34:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9446','2005-07-30T21:53:01.000','1880','477','2005-08-06T19:00:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9447','2005-07-30T21:54:22.000','1053','82','2005-08-09T01:07:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9448','2005-07-30T21:56:13.000','1213','278','2005-08-04T18:03:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9449','2005-07-30T22:02:34.000','2','581','2005-08-06T02:09:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9450','2005-07-30T22:04:04.000','1371','430','2005-08-05T18:39:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9451','2005-07-30T22:10:17.000','685','584','2005-08-07T02:53:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9452','2005-07-30T22:19:16.000','3178','130','2005-08-04T19:26:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9453','2005-07-30T22:20:04.000','1988','221','2005-08-08T02:27:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9454','2005-07-30T22:20:09.000','3028','81','2005-08-04T01:33:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9455','2005-07-30T22:20:29.000','2647','220','2005-08-08T20:08:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9456','2005-07-30T22:22:16.000','2068','534','2005-08-05T18:56:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9457','2005-07-30T22:23:05.000','2172','487','2005-07-31T23:07:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9458','2005-07-30T22:24:34.000','3105','343','2005-08-04T21:26:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9459','2005-07-30T22:24:46.000','1132','489','2005-08-02T00:44:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9460','2005-07-30T22:25:39.000','4463','580','2005-08-08T20:56:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9461','2005-07-30T22:29:13.000','1679','377','2005-08-05T20:55:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9462','2005-07-30T22:30:44.000','4090','192','2005-08-09T03:54:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9463','2005-07-30T22:30:57.000','883','352','2005-08-03T22:53:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9464','2005-07-30T22:31:31.000','3904','534','2005-08-07T01:10:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9465','2005-07-30T22:39:53.000','3084','2','2005-08-06T16:43:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9466','2005-07-30T22:44:36.000','2595','137','2005-08-07T02:35:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9467','2005-07-30T22:45:34.000','1905','202','2005-08-08T00:58:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9468','2005-07-30T22:53:52.000','4366','20','2005-08-07T00:22:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9469','2005-07-30T22:56:34.000','967','59','2005-08-07T03:16:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9470','2005-07-30T23:01:31.000','3908','566','2005-08-07T01:35:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9471','2005-07-30T23:02:36.000','2390','424','2005-08-04T17:49:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9472','2005-07-30T23:03:32.000','4178','404','2005-08-01T18:02:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9473','2005-07-30T23:04:13.000','1717','185','2005-08-04T21:48:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9474','2005-07-30T23:05:44.000','3771','206','2005-08-05T23:46:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9475','2005-07-30T23:06:33.000','2186','567','2005-08-04T23:23:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9476','2005-07-30T23:06:40.000','3599','197','2005-08-04T22:52:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9477','2005-07-30T23:07:22.000','1932','213','2005-08-04T20:54:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9478','2005-07-30T23:12:53.000','1139','283','2005-08-04T02:41:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9479','2005-07-30T23:22:09.000','3461','308','2005-07-31T22:26:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9480','2005-07-30T23:26:03.000','597','373','2005-08-04T21:18:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9481','2005-07-30T23:26:05.000','613','481','2005-08-04T17:46:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9482','2005-07-30T23:29:16.000','2421','348','2005-08-02T20:37:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9483','2005-07-30T23:31:31.000','1136','593','2005-08-09T04:29:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9484','2005-07-30T23:31:40.000','3389','26','2005-08-02T18:25:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9485','2005-07-30T23:32:40.000','3722','338','2005-08-08T17:44:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9486','2005-07-30T23:35:42.000','2787','403','2005-08-09T02:08:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9487','2005-07-30T23:40:22.000','2165','406','2005-08-01T22:29:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9488','2005-07-30T23:42:42.000','4221','528','2005-08-08T22:15:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9489','2005-07-30T23:43:32.000','4011','17','2005-07-31T20:45:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9490','2005-07-30T23:45:09.000','1302','487','2005-08-07T18:50:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9491','2005-07-30T23:45:23.000','3624','179','2005-08-01T00:33:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9492','2005-07-30T23:52:21.000','639','126','2005-08-08T20:50:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9493','2005-07-30T23:52:30.000','1522','5','2005-08-08T05:22:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9494','2005-07-30T23:52:46.000','3799','254','2005-08-05T23:13:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9495','2005-07-30T23:54:26.000','2128','397','2005-08-01T22:02:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9496','2005-07-30T23:55:20.000','453','125','2005-08-02T02:47:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9497','2005-07-30T23:56:54.000','933','595','2005-08-04T19:52:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9498','2005-07-30T23:56:55.000','1035','289','2005-08-03T18:34:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9499','2005-07-30T23:58:30.000','602','461','2005-08-01T00:55:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9500','2005-07-30T23:58:36.000','2808','241','2005-08-07T21:08:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9501','2005-07-30T23:59:21.000','4398','75','2005-08-05T19:50:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9502','2005-07-31T00:02:10.000','2700','471','2005-08-01T19:47:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9503','2005-07-31T00:02:38.000','1013','311','2005-08-06T06:01:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9504','2005-07-31T00:09:07.000','91','125','2005-08-02T05:44:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9505','2005-07-31T00:11:19.000','4047','543','2005-08-05T18:24:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9506','2005-07-31T00:19:01.000','3872','189','2005-08-02T00:20:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9507','2005-07-31T00:22:29.000','387','525','2005-08-07T05:59:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9508','2005-07-31T00:22:39.000','1204','316','2005-08-04T05:40:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9509','2005-07-31T00:22:42.000','818','320','2005-08-03T23:24:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9510','2005-07-31T00:24:17.000','2301','494','2005-08-08T18:47:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9511','2005-07-31T00:25:05.000','964','549','2005-08-09T02:46:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9512','2005-07-31T00:26:30.000','3786','173','2005-08-04T23:43:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9513','2005-07-31T00:28:30.000','396','317','2005-08-01T00:22:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9514','2005-07-31T00:29:44.000','1892','243','2005-08-02T23:49:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9515','2005-07-31T00:35:05.000','3099','264','2005-08-02T23:35:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9516','2005-07-31T00:40:58.000','3519','424','2005-08-07T02:13:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9517','2005-07-31T00:41:23.000','3299','170','2005-08-02T23:08:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9518','2005-07-31T00:43:26.000','2714','215','2005-08-04T19:12:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9519','2005-07-31T00:45:57.000','3767','235','2005-08-06T00:59:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9520','2005-07-31T00:50:54.000','1306','299','2005-08-04T20:05:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9521','2005-07-31T00:52:24.000','1423','227','2005-08-06T03:33:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9522','2005-07-31T00:55:11.000','4266','294','2005-08-03T06:41:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9523','2005-07-31T00:56:09.000','891','356','2005-08-05T05:44:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9524','2005-07-31T01:01:06.000','1796','535','2005-08-04T04:06:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9525','2005-07-31T01:02:18.000','2990','246','2005-08-06T21:31:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9526','2005-07-31T01:02:22.000','417','342','2005-08-04T03:00:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9527','2005-07-31T01:02:24.000','2539','200','2005-08-09T02:08:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9528','2005-07-31T01:05:04.000','193','241','2005-08-07T01:16:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9529','2005-07-31T01:05:26.000','816','123','2005-08-02T22:30:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9530','2005-07-31T01:09:06.000','1718','148','2005-08-04T23:47:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9531','2005-07-31T01:11:53.000','4550','268','2005-08-07T02:49:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9532','2005-07-31T01:16:51.000','1309','488','2005-08-01T20:23:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9533','2005-07-31T01:18:10.000','4156','522','2005-08-07T19:58:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9534','2005-07-31T01:18:27.000','4457','519','2005-08-06T00:28:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9535','2005-07-31T01:18:53.000','2413','485','2005-08-04T03:04:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9536','2005-07-31T01:19:02.000','2547','310','2005-08-02T19:38:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9537','2005-07-31T01:23:00.000','546','488','2005-08-01T01:16:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9538','2005-07-31T01:25:22.000','3402','68','2005-08-06T00:10:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9539','2005-07-31T01:36:19.000','3793','436','2005-08-04T23:47:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9540','2005-07-31T01:40:06.000','2200','365','2005-08-01T01:09:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9541','2005-07-31T01:40:14.000','1774','422','2005-08-05T06:34:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9542','2005-07-31T01:41:48.000','2243','595','2005-08-01T00:49:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9543','2005-07-31T01:43:34.000','956','369','2005-08-01T06:49:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9544','2005-07-31T01:44:51.000','2383','28','2005-08-05T05:25:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9545','2005-07-31T01:46:24.000','3451','594','2005-08-09T06:11:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9546','2005-07-31T01:47:40.000','211','63','2005-08-02T07:25:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9547','2005-07-31T01:52:34.000','2414','440','2005-08-03T23:12:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9548','2005-07-31T01:54:19.000','3038','576','2005-08-05T00:50:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9549','2005-07-31T01:57:04.000','2409','63','2005-08-07T21:00:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9550','2005-07-31T01:57:34.000','2233','583','2005-08-08T23:33:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9551','2005-07-31T02:04:58.000','1260','30','2005-08-06T04:07:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9552','2005-07-31T02:05:32.000','3544','261','2005-08-01T06:59:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9553','2005-07-31T02:06:34.000','4187','579','2005-08-08T02:20:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9554','2005-07-31T02:06:49.000','2581','490','2005-08-01T22:27:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9555','2005-07-31T02:11:16.000','2108','382','2005-08-03T06:58:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9556','2005-07-31T02:13:30.000','3269','521','2005-08-08T06:46:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9557','2005-07-31T02:14:01.000','708','328','2005-08-05T23:55:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9558','2005-07-31T02:14:35.000','1161','418','2005-08-06T03:00:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9559','2005-07-31T02:15:53.000','2882','159','2005-08-08T02:38:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9560','2005-07-31T02:17:27.000','4236','471','2005-08-07T03:33:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9561','2005-07-31T02:22:13.000','1079','58','2005-08-03T07:00:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9562','2005-07-31T02:23:20.000','1571','116','2005-08-06T21:01:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9563','2005-07-31T02:28:39.000','3858','167','2005-08-05T22:10:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9564','2005-07-31T02:31:37.000','383','377','2005-08-03T22:57:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9565','2005-07-31T02:32:00.000','3621','485','2005-08-04T05:45:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9566','2005-07-31T02:32:10.000','643','346','2005-08-02T23:54:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9567','2005-07-31T02:36:11.000','3688','37','2005-08-07T01:19:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9568','2005-07-31T02:37:44.000','1248','358','2005-08-02T07:07:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9569','2005-07-31T02:39:38.000','813','405','2005-08-02T05:09:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9570','2005-07-31T02:40:37.000','591','385','2005-08-01T01:59:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9571','2005-07-31T02:42:18.000','2219','1','2005-08-02T23:26:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9572','2005-07-31T02:44:10.000','1453','283','2005-08-01T03:30:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9573','2005-07-31T02:45:38.000','3745','59','2005-08-09T04:31:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9574','2005-07-31T02:49:20.000','2782','233','2005-08-05T02:36:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9575','2005-07-31T02:51:53.000','3971','193','2005-08-03T20:54:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9576','2005-07-31T02:52:59.000','3327','145','2005-08-05T23:35:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9577','2005-07-31T02:53:33.000','2423','526','2005-08-07T05:56:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9578','2005-07-31T02:54:31.000','2965','115','2005-08-02T02:48:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9579','2005-07-31T02:59:20.000','3547','35','2005-08-06T03:52:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9580','2005-07-31T03:01:11.000','532','22','2005-08-05T06:01:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9581','2005-07-31T03:03:07.000','2588','302','2005-08-05T23:01:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9582','2005-07-31T03:05:19.000','3913','347','2005-08-04T07:26:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9583','2005-07-31T03:05:21.000','3543','568','2005-08-06T00:14:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9584','2005-07-31T03:05:48.000','419','141','2005-08-01T05:50:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9585','2005-07-31T03:05:55.000','3249','197','2005-08-02T23:54:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9586','2005-07-31T03:07:16.000','3987','415','2005-08-04T00:39:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9587','2005-07-31T03:10:30.000','2966','235','2005-08-06T06:54:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9588','2005-07-31T03:13:13.000','1368','499','2005-08-02T04:06:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9589','2005-07-31T03:13:29.000','2604','574','2005-08-09T01:51:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9590','2005-07-31T03:17:16.000','2293','585','2005-08-08T04:24:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9591','2005-07-31T03:19:28.000','504','97','2005-08-01T07:30:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9592','2005-07-31T03:21:16.000','1828','14','2005-08-05T08:32:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9593','2005-07-31T03:22:30.000','1223','28','2005-08-05T08:23:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9594','2005-07-31T03:23:52.000','4382','148','2005-08-04T23:06:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9595','2005-07-31T03:27:58.000','2829','3','2005-08-03T05:58:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9596','2005-07-31T03:28:47.000','2847','55','2005-08-04T03:43:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9597','2005-07-31T03:29:07.000','3317','61','2005-08-09T03:33:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9598','2005-07-31T03:30:41.000','1105','468','2005-08-04T03:54:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9599','2005-07-31T03:32:06.000','3164','502','2005-08-04T07:47:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9600','2005-07-31T03:35:34.000','3731','464','2005-08-08T22:50:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9601','2005-07-31T03:42:17.000','1592','553','2005-08-04T02:02:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9602','2005-07-31T03:42:51.000','3173','386','2005-08-01T08:39:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9603','2005-07-31T03:43:43.000','2266','541','2005-08-02T00:11:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9604','2005-07-31T03:47:12.000','4342','580','2005-08-03T06:48:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9605','2005-07-31T03:50:07.000','1477','94','2005-08-07T09:15:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9606','2005-07-31T03:50:46.000','1357','253','2005-08-01T05:29:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9607','2005-07-31T03:51:06.000','3414','294','2005-08-02T00:18:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9608','2005-07-31T03:51:52.000','363','397','2005-08-06T05:38:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9609','2005-07-31T03:53:24.000','693','112','2005-08-05T08:32:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9610','2005-07-31T03:54:05.000','3110','16','2005-08-06T23:11:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9611','2005-07-31T03:54:43.000','1976','215','2005-08-05T03:54:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9612','2005-07-31T03:58:31.000','2142','69','2005-08-04T07:34:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9613','2005-07-31T03:58:53.000','3251','188','2005-08-02T00:10:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9614','2005-07-31T03:59:31.000','2955','548','2005-08-08T04:19:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9615','2005-07-31T03:59:56.000','3370','50','2005-08-02T00:46:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9616','2005-07-31T04:05:01.000','1210','550','2005-08-05T00:10:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9617','2005-07-31T04:15:38.000','529','102','2005-08-02T04:24:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9618','2005-07-31T04:16:14.000','2688','253','2005-08-07T02:43:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9619','2005-07-31T04:17:02.000','1730','138','2005-08-05T06:36:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9620','2005-07-31T04:19:18.000','2177','576','2005-08-08T09:20:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9621','2005-07-31T04:21:08.000','325','38','2005-08-08T03:50:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9622','2005-07-31T04:21:45.000','2255','411','2005-08-02T09:20:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9623','2005-07-31T04:30:02.000','113','360','2005-08-06T23:34:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9624','2005-07-31T04:30:03.000','3480','7','2005-08-06T09:13:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9625','2005-07-31T04:30:48.000','1703','445','2005-08-03T01:12:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9626','2005-07-31T04:37:41.000','2216','546','2005-08-08T04:00:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9627','2005-07-31T04:42:46.000','471','12','2005-08-08T00:42:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9628','2005-07-31T04:51:11.000','1387','565','2005-07-31T23:11:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9629','2005-07-31T04:54:43.000','2773','8','2005-08-02T08:36:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9630','2005-07-31T04:57:07.000','2008','599','2005-08-07T10:55:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9631','2005-07-31T05:02:00.000','321','595','2005-08-02T02:04:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9632','2005-07-31T05:02:23.000','3368','217','2005-08-06T04:49:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9633','2005-07-31T05:04:08.000','1141','334','2005-08-06T00:52:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9634','2005-07-31T05:06:02.000','924','444','2005-08-04T06:53:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9635','2005-07-31T05:12:27.000','1687','371','2005-08-02T00:24:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9636','2005-07-31T05:12:59.000','1725','27','2005-08-09T07:31:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9637','2005-07-31T05:18:54.000','3013','130','2005-08-03T01:23:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9638','2005-07-31T05:30:27.000','1616','436','2005-08-09T02:04:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9639','2005-07-31T05:32:10.000','1373','459','2005-08-03T07:04:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9640','2005-07-31T05:33:25.000','1067','67','2005-08-09T09:41:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9641','2005-07-31T05:33:48.000','1085','30','2005-08-04T07:43:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9642','2005-07-31T05:33:57.000','3550','68','2005-08-05T04:54:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9643','2005-07-31T05:35:48.000','3576','538','2005-08-08T04:28:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9644','2005-07-31T05:40:35.000','4577','441','2005-08-09T08:18:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9645','2005-07-31T05:42:49.000','3413','519','2005-08-04T00:08:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9646','2005-07-31T05:43:28.000','3756','89','2005-08-08T04:00:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9647','2005-07-31T05:45:15.000','3415','475','2005-08-06T08:54:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9648','2005-07-31T05:46:03.000','4063','72','2005-08-09T04:36:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9649','2005-07-31T05:46:54.000','1588','51','2005-08-04T08:42:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9650','2005-07-31T05:47:32.000','2997','414','2005-08-04T00:50:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9651','2005-07-31T05:48:49.000','4059','324','2005-08-04T06:53:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9652','2005-07-31T05:49:53.000','448','207','2005-08-06T07:38:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9653','2005-07-31T05:55:38.000','1451','383','2005-08-03T09:35:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9654','2005-07-31T05:57:42.000','3286','506','2005-08-06T04:19:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9655','2005-07-31T05:57:54.000','3403','435','2005-08-06T02:00:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9656','2005-07-31T06:00:21.000','4215','39','2005-08-05T04:36:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9657','2005-07-31T06:00:41.000','2681','402','2005-08-06T06:51:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9658','2005-07-31T06:00:52.000','2332','282','2005-08-09T04:47:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9659','2005-07-31T06:02:14.000','4262','360','2005-08-07T00:54:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9660','2005-07-31T06:03:17.000','1090','406','2005-08-07T06:59:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9661','2005-07-31T06:06:37.000','2693','237','2005-08-04T07:37:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9662','2005-07-31T06:09:53.000','2757','96','2005-08-08T00:50:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9663','2005-07-31T06:10:48.000','2099','339','2005-08-01T11:40:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9664','2005-07-31T06:12:08.000','360','13','2005-08-04T02:19:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9665','2005-07-31T06:17:33.000','2863','478','2005-08-04T08:53:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9666','2005-07-31T06:20:58.000','4318','592','2005-08-06T06:09:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9667','2005-07-31T06:23:52.000','4289','523','2005-08-09T09:12:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9668','2005-07-31T06:31:03.000','1647','378','2005-08-07T06:19:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9669','2005-07-31T06:31:36.000','4496','277','2005-08-08T03:05:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9670','2005-07-31T06:33:33.000','3709','349','2005-08-07T04:51:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9671','2005-07-31T06:33:41.000','920','133','2005-08-02T07:50:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9672','2005-07-31T06:34:06.000','4394','183','2005-08-08T10:29:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9673','2005-07-31T06:34:55.000','339','27','2005-08-09T09:15:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9674','2005-07-31T06:36:53.000','3213','297','2005-08-06T02:50:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9675','2005-07-31T06:37:07.000','2523','243','2005-08-03T07:03:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9676','2005-07-31T06:39:13.000','681','239','2005-08-05T09:31:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9677','2005-07-31T06:39:45.000','3200','274','2005-08-01T02:37:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9678','2005-07-31T06:40:47.000','3430','383','2005-08-02T00:57:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9679','2005-07-31T06:41:19.000','3819','599','2005-08-02T07:23:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9680','2005-07-31T06:41:46.000','3010','84','2005-08-01T11:02:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9681','2005-07-31T06:42:09.000','64','160','2005-08-06T08:21:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9682','2005-07-31T06:47:10.000','2427','425','2005-08-04T09:07:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9683','2005-07-31T06:47:13.000','856','141','2005-08-04T05:52:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9684','2005-07-31T06:48:33.000','362','591','2005-08-01T07:07:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9685','2005-07-31T06:49:18.000','3097','165','2005-08-04T03:19:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9686','2005-07-31T06:50:06.000','3825','386','2005-08-06T08:41:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9687','2005-07-31T06:52:54.000','3540','470','2005-08-01T03:40:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9688','2005-07-31T06:56:08.000','1304','566','2005-08-08T03:31:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9689','2005-07-31T07:00:08.000','819','498','2005-08-04T03:33:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9690','2005-07-31T07:06:29.000','4449','468','2005-08-06T09:45:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9691','2005-07-31T07:09:55.000','2626','50','2005-08-09T02:29:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9692','2005-07-31T07:11:04.000','3481','295','2005-08-07T06:34:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9693','2005-07-31T07:11:50.000','1031','273','2005-08-08T09:55:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9694','2005-07-31T07:13:16.000','3447','508','2005-08-06T09:12:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9695','2005-07-31T07:13:30.000','726','95','2005-08-07T05:38:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9696','2005-07-31T07:13:46.000','2703','156','2005-08-03T10:49:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9697','2005-07-31T07:23:11.000','762','479','2005-08-05T08:04:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9698','2005-07-31T07:24:35.000','3477','594','2005-08-09T04:52:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9699','2005-07-31T07:29:25.000','199','21','2005-08-06T01:35:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9700','2005-07-31T07:29:59.000','2678','40','2005-08-02T09:53:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9701','2005-07-31T07:32:21.000','4581','401','2005-08-01T05:07:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9702','2005-07-31T07:34:07.000','3353','525','2005-08-02T06:13:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9703','2005-07-31T07:34:52.000','2708','57','2005-08-03T13:33:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9704','2005-07-31T07:39:32.000','1402','385','2005-08-06T01:50:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9705','2005-07-31T07:40:33.000','4158','28','2005-08-01T03:50:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9706','2005-07-31T07:43:19.000','142','508','2005-08-05T11:11:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9707','2005-07-31T07:44:18.000','203','351','2005-08-08T12:45:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9708','2005-07-31T07:45:33.000','3264','12','2005-08-08T08:56:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9709','2005-07-31T08:04:55.000','2096','137','2005-08-07T08:58:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9710','2005-07-31T08:05:31.000','3486','380','2005-08-09T03:29:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9711','2005-07-31T08:06:41.000','1525','231','2005-08-02T10:30:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9712','2005-07-31T08:13:11.000','2487','219','2005-08-08T12:40:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9713','2005-07-31T08:13:28.000','929','158','2005-08-07T10:11:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9714','2005-07-31T08:15:32.000','1532','144','2005-08-03T08:33:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9715','2005-07-31T08:16:58.000','3319','237','2005-08-04T11:13:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9716','2005-07-31T08:23:53.000','3385','287','2005-08-08T12:03:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9717','2005-07-31T08:24:41.000','4207','114','2005-08-04T02:51:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9718','2005-07-31T08:25:03.000','2747','23','2005-08-08T04:16:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9719','2005-07-31T08:25:13.000','335','584','2005-08-05T08:22:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9720','2005-07-31T08:25:21.000','1282','587','2005-08-07T11:30:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9721','2005-07-31T08:28:46.000','3942','196','2005-08-05T14:03:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9722','2005-07-31T08:29:48.000','4260','125','2005-08-07T07:52:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9723','2005-07-31T08:31:18.000','3968','24','2005-08-03T10:25:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9724','2005-07-31T08:33:08.000','518','130','2005-08-08T04:50:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9725','2005-07-31T08:35:18.000','3960','503','2005-08-03T03:46:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9726','2005-07-31T08:37:07.000','1701','162','2005-08-09T06:09:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9727','2005-07-31T08:39:13.000','3076','536','2005-08-03T07:54:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9728','2005-07-31T08:40:54.000','3630','399','2005-08-03T04:14:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9729','2005-07-31T08:43:43.000','4199','273','2005-08-01T13:25:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9730','2005-07-31T08:50:08.000','2605','242','2005-08-08T12:21:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9731','2005-07-31T08:54:47.000','3713','349','2005-08-05T03:47:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9732','2005-07-31T08:56:08.000','3262','288','2005-08-07T11:05:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9733','2005-07-31T08:57:35.000','1255','575','2005-08-04T04:47:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9734','2005-07-31T08:57:45.000','3320','125','2005-08-05T11:57:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9735','2005-07-31T08:57:49.000','4228','315','2005-08-08T13:51:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9736','2005-07-31T08:58:40.000','2072','13','2005-08-09T08:34:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9737','2005-07-31T08:59:18.000','1720','475','2005-08-03T12:19:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9738','2005-07-31T09:04:14.000','2278','568','2005-08-05T14:40:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9739','2005-07-31T09:08:03.000','1328','343','2005-08-04T13:57:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9740','2005-07-31T09:08:03.000','3497','443','2005-08-06T04:48:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9741','2005-07-31T09:09:22.000','1971','495','2005-08-07T10:01:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9742','2005-07-31T09:10:20.000','4058','48','2005-08-08T10:07:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9743','2005-07-31T09:12:42.000','1740','476','2005-08-06T11:57:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9744','2005-07-31T09:15:38.000','839','459','2005-08-03T10:31:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9745','2005-07-31T09:16:14.000','3610','217','2005-08-07T12:11:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9746','2005-07-31T09:16:48.000','1459','308','2005-08-07T06:36:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9747','2005-07-31T09:16:57.000','2455','106','2005-08-08T06:47:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9748','2005-07-31T09:17:56.000','3308','550','2005-08-02T14:54:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9749','2005-07-31T09:18:33.000','658','52','2005-08-06T07:41:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9750','2005-07-31T09:19:46.000','3174','527','2005-08-06T08:07:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9751','2005-07-31T09:20:50.000','36','202','2005-08-01T05:34:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9752','2005-07-31T09:22:02.000','249','199','2005-08-02T14:34:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9753','2005-07-31T09:22:38.000','3529','98','2005-08-01T08:45:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9754','2005-07-31T09:23:43.000','3751','479','2005-08-08T06:04:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9755','2005-07-31T09:24:55.000','86','108','2005-08-07T06:00:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9756','2005-07-31T09:25:00.000','207','400','2005-08-02T05:11:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9757','2005-07-31T09:25:14.000','2596','408','2005-08-01T14:43:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9758','2005-07-31T09:25:38.000','1307','160','2005-08-03T14:16:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9759','2005-07-31T09:25:57.000','2950','574','2005-08-07T12:56:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9760','2005-07-31T09:29:33.000','426','511','2005-08-09T07:32:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9761','2005-07-31T09:31:54.000','3778','60','2005-08-03T11:02:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9762','2005-07-31T09:32:54.000','155','540','2005-08-05T04:55:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9763','2005-07-31T09:34:03.000','126','393','2005-08-08T05:30:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9764','2005-07-31T09:42:58.000','3761','136','2005-08-07T07:22:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9765','2005-07-31T09:44:40.000','472','551','2005-08-05T10:57:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9766','2005-07-31T09:46:29.000','4049','570','2005-08-01T05:08:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9767','2005-07-31T09:46:49.000','3432','89','2005-08-03T11:20:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9768','2005-07-31T09:48:41.000','2656','582','2005-08-08T11:40:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9769','2005-07-31T09:52:16.000','2958','484','2005-08-06T09:26:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9770','2005-07-31T09:52:40.000','1226','317','2005-08-09T06:44:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9771','2005-07-31T09:55:36.000','4123','398','2005-08-04T10:11:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9772','2005-07-31T09:56:07.000','3639','147','2005-08-01T13:50:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9773','2005-07-31T09:56:56.000','4555','376','2005-08-04T09:38:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9774','2005-07-31T09:57:51.000','4174','306','2005-08-02T09:08:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9775','2005-07-31T10:00:00.000','2818','162','2005-08-01T08:57:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9776','2005-07-31T10:01:03.000','2524','73','2005-08-03T07:20:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9777','2005-07-31T10:01:06.000','225','539','2005-08-08T04:44:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9778','2005-07-31T10:02:04.000','304','230','2005-08-04T07:44:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9779','2005-07-31T10:08:33.000','1280','402','2005-08-03T14:56:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9780','2005-07-31T10:10:22.000','3241','102','2005-08-02T11:43:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9781','2005-07-31T10:13:02.000','2310','155','2005-08-09T14:46:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9782','2005-07-31T10:14:26.000','2397','438','2005-08-06T16:11:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9783','2005-07-31T10:15:46.000','836','75','2005-08-09T13:22:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9784','2005-07-31T10:21:32.000','2761','362','2005-08-07T09:20:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9785','2005-07-31T10:22:15.000','4101','587','2005-08-02T10:02:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9786','2005-07-31T10:25:21.000','2560','586','2005-08-03T04:28:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9787','2005-07-31T10:26:19.000','3559','272','2005-08-09T09:02:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9788','2005-07-31T10:28:21.000','4367','344','2005-08-09T13:45:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9789','2005-07-31T10:30:25.000','619','137','2005-08-03T14:58:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9790','2005-07-31T10:34:08.000','3643','284','2005-08-04T11:19:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9791','2005-07-31T10:35:22.000','3642','300','2005-08-03T05:34:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9792','2005-07-31T10:43:41.000','3163','292','2005-08-07T10:18:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9793','2005-07-31T10:45:11.000','4576','295','2005-08-03T14:29:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9794','2005-07-31T10:47:01.000','1771','403','2005-08-02T06:52:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9795','2005-07-31T10:47:19.000','2005','63','2005-08-04T09:32:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9796','2005-07-31T10:52:43.000','1038','539','2005-08-09T06:08:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9797','2005-07-31T10:53:44.000','687','52','2005-08-09T05:51:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9798','2005-07-31T10:55:18.000','3759','55','2005-08-01T07:37:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9799','2005-07-31T10:58:32.000','3008','494','2005-08-01T12:08:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9800','2005-07-31T11:00:58.000','2153','257','2005-08-02T10:13:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9801','2005-07-31T11:03:13.000','3033','158','2005-08-04T10:55:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9802','2005-07-31T11:04:20.000','2156','594','2005-08-03T05:28:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9803','2005-07-31T11:06:02.000','3783','520','2005-08-01T06:25:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9804','2005-07-31T11:07:39.000','2490','196','2005-08-09T11:57:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9805','2005-07-31T11:11:10.000','4179','36','2005-08-03T07:36:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9806','2005-07-31T11:13:49.000','245','46','2005-08-04T06:18:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9807','2005-07-31T11:13:52.000','2137','267','2005-08-02T07:34:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9808','2005-07-31T11:17:22.000','3259','583','2005-08-07T15:54:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9809','2005-07-31T11:19:21.000','359','286','2005-08-08T12:43:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9810','2005-07-31T11:22:41.000','2066','545','2005-08-01T09:40:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9811','2005-07-31T11:23:45.000','3305','77','2005-08-06T15:51:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9812','2005-07-31T11:28:07.000','1540','57','2005-08-01T12:35:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9813','2005-07-31T11:29:23.000','1706','245','2005-08-07T08:01:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9814','2005-07-31T11:29:46.000','136','79','2005-08-08T15:49:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9815','2005-07-31T11:30:51.000','2728','540','2005-08-08T12:52:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9816','2005-07-31T11:32:58.000','4560','3','2005-08-04T17:12:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9817','2005-07-31T11:33:31.000','4019','170','2005-08-08T14:49:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9818','2005-07-31T11:34:32.000','1254','183','2005-08-04T08:20:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9819','2005-07-31T11:39:13.000','1927','292','2005-08-06T09:11:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9820','2005-07-31T11:46:57.000','499','279','2005-08-08T13:35:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9821','2005-07-31T11:47:54.000','386','271','2005-08-08T06:21:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9822','2005-07-31T11:48:25.000','2469','381','2005-08-05T15:52:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9823','2005-07-31T11:49:00.000','4423','129','2005-08-07T09:06:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9824','2005-07-31T11:49:55.000','4368','404','2005-08-07T16:54:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9825','2005-07-31T11:50:51.000','4322','390','2005-08-02T07:18:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9826','2005-07-31T11:51:46.000','2649','595','2005-08-09T17:18:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9827','2005-07-31T11:56:55.000','3840','329','2005-08-09T16:29:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9828','2005-07-31T11:56:57.000','3845','376','2005-08-02T17:05:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9829','2005-07-31T11:58:38.000','231','435','2005-08-07T08:11:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9830','2005-07-31T11:59:05.000','170','112','2005-08-06T10:38:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9831','2005-07-31T11:59:32.000','1961','192','2005-08-04T07:14:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9832','2005-07-31T12:01:49.000','3126','64','2005-08-08T09:21:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9833','2005-07-31T12:05:01.000','4243','368','2005-08-09T09:25:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9834','2005-07-31T12:05:42.000','2292','340','2005-08-07T15:26:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9835','2005-07-31T12:07:35.000','1051','328','2005-08-04T07:32:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9836','2005-07-31T12:12:00.000','2870','313','2005-08-09T06:53:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9837','2005-07-31T12:14:19.000','3488','573','2005-08-09T17:08:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9838','2005-07-31T12:18:49.000','3866','208','2005-08-03T16:49:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9839','2005-07-31T12:21:16.000','1591','561','2005-08-09T13:41:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9840','2005-07-31T12:23:18.000','364','388','2005-08-06T15:59:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9841','2005-07-31T12:24:19.000','4554','238','2005-08-09T15:31:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9842','2005-07-31T12:24:58.000','2896','261','2005-08-02T11:01:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9843','2005-07-31T12:25:28.000','2923','532','2005-08-01T09:51:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9844','2005-07-31T12:26:31.000','3930','181','2005-08-05T13:58:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9845','2005-07-31T12:28:05.000','2417','79','2005-08-06T06:47:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9846','2005-07-31T12:30:12.000','4240','573','2005-08-05T08:24:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9847','2005-07-31T12:33:43.000','1137','174','2005-08-04T14:15:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9848','2005-07-31T12:44:33.000','3290','346','2005-08-07T13:49:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9849','2005-07-31T12:44:34.000','2230','429','2005-08-02T16:49:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9850','2005-07-31T12:46:52.000','1461','497','2005-08-04T10:52:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9851','2005-07-31T12:50:24.000','25','49','2005-08-08T08:30:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9852','2005-07-31T12:52:17.000','4257','415','2005-08-05T07:59:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9853','2005-07-31T12:58:20.000','1782','221','2005-08-04T10:47:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9854','2005-07-31T12:59:34.000','1049','441','2005-08-03T07:20:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9855','2005-07-31T13:00:33.000','1246','326','2005-08-03T16:18:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9856','2005-07-31T13:00:35.000','723','347','2005-08-07T18:07:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9857','2005-07-31T13:00:53.000','3316','168','2005-08-09T15:56:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9858','2005-07-31T13:02:07.000','252','128','2005-08-03T15:14:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9859','2005-07-31T13:02:55.000','4094','127','2005-08-05T11:04:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9860','2005-07-31T13:03:24.000','3266','585','2005-08-07T07:28:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9861','2005-07-31T13:04:14.000','1050','264','2005-08-09T15:22:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9862','2005-07-31T13:05:03.000','474','513','2005-08-01T09:05:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9863','2005-07-31T13:05:29.000','19','239','2005-08-08T12:33:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9864','2005-07-31T13:06:54.000','3619','394','2005-08-02T11:47:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9865','2005-07-31T13:10:45.000','1355','580','2005-08-02T09:19:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9866','2005-07-31T13:13:50.000','3555','374','2005-08-07T15:11:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9867','2005-07-31T13:17:04.000','2485','83','2005-08-05T07:17:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9868','2005-07-31T13:20:08.000','266','378','2005-08-01T18:17:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9869','2005-07-31T13:21:54.000','783','261','2005-08-07T09:09:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9870','2005-07-31T13:22:51.000','442','195','2005-08-05T16:04:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9871','2005-07-31T13:25:46.000','194','109','2005-08-01T13:12:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9872','2005-07-31T13:27:55.000','1021','376','2005-08-04T14:33:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9873','2005-07-31T13:32:18.000','667','442','2005-08-06T11:15:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9874','2005-07-31T13:32:31.000','2476','482','2005-08-07T09:50:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9875','2005-07-31T13:37:41.000','2878','421','2005-08-03T15:17:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9876','2005-07-31T13:37:51.000','828','347','2005-08-07T18:05:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9877','2005-07-31T13:41:57.000','1299','559','2005-08-06T15:27:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9878','2005-07-31T13:42:02.000','1753','424','2005-08-05T10:15:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9879','2005-07-31T13:45:32.000','1935','178','2005-08-07T17:12:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9880','2005-07-31T13:49:02.000','3590','64','2005-08-08T10:31:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9881','2005-07-31T13:50:38.000','4209','412','2005-08-06T08:58:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9882','2005-07-31T13:53:33.000','1429','311','2005-08-09T15:55:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9883','2005-07-31T13:53:37.000','4286','356','2005-08-06T15:45:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9884','2005-07-31T13:56:24.000','511','590','2005-08-01T16:59:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9885','2005-07-31T13:59:32.000','3600','461','2005-08-07T12:30:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9886','2005-07-31T14:00:13.000','1386','519','2005-08-08T19:30:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9887','2005-07-31T14:00:32.000','436','549','2005-08-05T19:16:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9888','2005-07-31T14:00:53.000','4400','5','2005-08-08T18:51:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9889','2005-07-31T14:02:50.000','2842','143','2005-08-05T12:09:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9890','2005-07-31T14:04:44.000','1024','151','2005-08-01T11:24:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9891','2005-07-31T14:05:44.000','3359','462','2005-08-02T16:21:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9892','2005-07-31T14:06:25.000','1045','251','2005-08-03T18:11:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9893','2005-07-31T14:07:21.000','2445','179','2005-08-01T09:20:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9894','2005-07-31T14:07:44.000','3724','199','2005-08-05T18:01:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9895','2005-07-31T14:07:56.000','835','560','2005-08-05T14:56:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9896','2005-07-31T14:09:48.000','2591','586','2005-08-01T20:02:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9897','2005-07-31T14:11:57.000','3945','538','2005-08-02T12:20:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9898','2005-07-31T14:12:03.000','2151','359','2005-08-01T12:27:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9899','2005-07-31T14:12:36.000','3352','168','2005-08-08T08:59:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9900','2005-07-31T14:15:05.000','3132','453','2005-08-07T11:58:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9901','2005-07-31T14:20:59.000','3332','277','2005-08-03T09:30:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9902','2005-07-31T14:24:33.000','486','218','2005-08-09T11:11:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9903','2005-07-31T14:31:44.000','1621','316','2005-08-08T20:03:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9904','2005-07-31T14:34:17.000','4089','428','2005-08-08T17:19:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9905','2005-07-31T14:37:03.000','2839','519','2005-08-01T15:55:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9906','2005-07-31T14:38:12.000','4241','204','2005-08-01T13:56:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9907','2005-07-31T14:39:50.000','4282','120','2005-08-09T09:39:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9908','2005-07-31T14:39:52.000','4408','27','2005-08-09T09:46:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9909','2005-07-31T14:43:34.000','2600','587','2005-08-09T15:31:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9910','2005-07-31T14:47:57.000','368','122','2005-08-05T18:20:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9911','2005-07-31T14:48:01.000','3879','112','2005-08-06T11:55:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9912','2005-07-31T14:49:04.000','3119','367','2005-08-03T15:40:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9913','2005-07-31T14:51:04.000','3744','229','2005-08-06T12:12:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9914','2005-07-31T14:51:19.000','3147','530','2005-08-05T09:51:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9915','2005-07-31T14:52:26.000','2933','566','2005-08-03T11:53:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9916','2005-07-31T14:54:52.000','949','432','2005-08-07T13:18:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9917','2005-07-31T14:55:11.000','3829','159','2005-08-02T13:58:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9918','2005-07-31T14:55:22.000','2519','283','2005-08-04T09:02:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9919','2005-07-31T14:55:46.000','3205','291','2005-08-08T11:43:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9920','2005-07-31T14:57:13.000','3108','139','2005-08-03T18:58:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9921','2005-07-31T14:59:21.000','1004','332','2005-08-01T12:40:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9922','2005-07-31T14:59:37.000','3615','25','2005-08-06T14:05:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9923','2005-07-31T15:00:15.000','1635','209','2005-08-05T11:09:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9924','2005-07-31T15:04:57.000','1986','64','2005-08-05T20:07:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9925','2005-07-31T15:08:47.000','2351','24','2005-08-02T20:27:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9926','2005-07-31T15:11:51.000','3733','472','2005-08-09T18:26:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9927','2005-07-31T15:12:13.000','999','346','2005-08-01T11:37:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9928','2005-07-31T15:13:57.000','3627','53','2005-08-06T20:39:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9929','2005-07-31T15:17:24.000','2521','564','2005-08-03T17:27:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9930','2005-07-31T15:18:03.000','4491','304','2005-08-01T12:36:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9931','2005-07-31T15:18:19.000','3455','183','2005-08-04T14:23:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9932','2005-07-31T15:19:48.000','1691','264','2005-08-05T21:09:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9933','2005-07-31T15:24:46.000','2349','111','2005-08-01T10:00:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9934','2005-07-31T15:25:26.000','2492','236','2005-08-05T17:13:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9935','2005-07-31T15:27:07.000','2247','10','2005-08-05T11:23:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9936','2005-07-31T15:27:41.000','979','153','2005-08-06T16:25:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9937','2005-07-31T15:28:10.000','3697','521','2005-08-06T21:20:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9938','2005-07-31T15:28:47.000','2871','63','2005-08-09T21:24:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9939','2005-07-31T15:29:00.000','3049','538','2005-08-08T11:09:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9940','2005-07-31T15:29:06.000','3975','388','2005-08-06T14:26:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9941','2005-07-31T15:31:25.000','1756','175','2005-08-05T17:23:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9942','2005-07-31T15:35:43.000','4573','545','2005-08-07T17:37:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9943','2005-07-31T15:37:29.000','887','494','2005-08-09T18:25:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9944','2005-07-31T15:44:43.000','2540','241','2005-08-08T10:30:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9945','2005-07-31T15:47:51.000','2075','309','2005-08-02T19:06:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9946','2005-07-31T15:48:54.000','2100','29','2005-08-03T12:42:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9947','2005-07-31T15:49:40.000','1173','138','2005-08-08T11:11:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9948','2005-07-31T15:49:41.000','806','342','2005-08-06T12:36:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9949','2005-07-31T15:50:10.000','3258','309','2005-08-01T17:53:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9950','2005-07-31T15:50:22.000','1657','572','2005-08-08T19:10:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9951','2005-07-31T15:51:16.000','4412','95','2005-08-03T14:54:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9952','2005-07-31T15:52:37.000','1634','128','2005-08-06T10:50:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9953','2005-07-31T15:56:35.000','1646','211','2005-08-02T12:01:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9954','2005-07-31T15:57:07.000','1830','463','2005-08-05T12:04:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9955','2005-07-31T16:01:26.000','1745','342','2005-08-04T11:15:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9956','2005-07-31T16:03:47.000','4485','342','2005-08-01T16:40:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9957','2005-07-31T16:03:55.000','1857','85','2005-08-04T15:16:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9958','2005-07-31T16:03:56.000','4142','157','2005-08-04T15:21:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9959','2005-07-31T16:04:22.000','340','199','2005-08-03T21:51:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9960','2005-07-31T16:05:52.000','1022','569','2005-08-05T14:15:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9961','2005-07-31T16:07:50.000','1856','40','2005-08-07T18:37:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9962','2005-07-31T16:10:36.000','1951','576','2005-08-02T17:09:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9963','2005-07-31T16:16:46.000','1609','573','2005-08-02T22:00:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9964','2005-07-31T16:17:39.000','3149','191','2005-08-03T15:03:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9965','2005-07-31T16:19:32.000','3946','101','2005-08-05T20:18:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9966','2005-07-31T16:26:46.000','4137','373','2005-08-03T14:29:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9967','2005-07-31T16:31:17.000','958','537','2005-08-06T13:52:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9968','2005-07-31T16:32:16.000','2666','363','2005-08-08T12:23:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9969','2005-07-31T16:38:12.000','938','151','2005-08-05T11:45:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9970','2005-07-31T16:38:24.000','2846','578','2005-08-02T12:59:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9971','2005-07-31T16:42:16.000','2674','573','2005-08-09T18:08:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9972','2005-07-31T16:42:43.000','190','506','2005-08-02T11:05:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9973','2005-07-31T16:49:31.000','1850','369','2005-08-03T22:03:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9974','2005-07-31T16:51:11.000','430','503','2005-08-05T16:04:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9975','2005-07-31T16:53:43.000','2564','40','2005-08-07T20:13:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9976','2005-07-31T16:57:49.000','4219','579','2005-08-03T16:33:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9977','2005-07-31T16:58:42.000','2300','363','2005-08-09T13:34:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9978','2005-07-31T16:59:51.000','2812','427','2005-08-06T16:48:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9979','2005-07-31T17:00:07.000','646','576','2005-08-08T20:40:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9980','2005-07-31T17:02:00.000','122','225','2005-08-08T11:11:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9981','2005-07-31T17:08:31.000','1354','321','2005-08-01T22:46:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9982','2005-07-31T17:09:02.000','2698','428','2005-08-02T13:02:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9983','2005-07-31T17:09:36.000','350','129','2005-08-08T20:26:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9984','2005-07-31T17:12:23.000','433','432','2005-08-01T21:04:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9985','2005-07-31T17:14:47.000','1831','85','2005-08-01T12:11:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9986','2005-07-31T17:16:50.000','1242','124','2005-08-05T18:34:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9987','2005-07-31T17:22:35.000','1619','15','2005-08-01T21:19:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9988','2005-07-31T17:22:36.000','3844','243','2005-08-07T18:35:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9989','2005-07-31T17:22:39.000','1713','79','2005-08-01T18:55:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9990','2005-07-31T17:24:21.000','4481','555','2005-08-09T17:14:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9991','2005-07-31T17:26:27.000','3662','414','2005-08-03T17:36:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9992','2005-07-31T17:29:48.000','4242','304','2005-08-09T13:02:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9993','2005-07-31T17:30:20.000','2503','225','2005-08-01T20:53:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9994','2005-07-31T17:30:31.000','2155','195','2005-08-01T11:35:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9995','2005-07-31T17:30:47.000','1978','180','2005-08-04T12:20:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9996','2005-07-31T17:32:03.000','3271','104','2005-08-06T16:17:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9997','2005-07-31T17:37:30.000','640','579','2005-08-02T14:49:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9998','2005-07-31T17:40:35.000','2549','30','2005-08-04T18:15:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('9999','2005-07-31T17:40:53.000','1438','543','2005-08-01T14:25:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10000','2005-07-31T17:41:05.000','3221','576','2005-08-02T20:51:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10001','2005-07-31T17:46:18.000','2188','244','2005-08-07T20:38:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10002','2005-07-31T17:48:16.000','1002','323','2005-08-06T16:15:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10003','2005-07-31T17:48:51.000','1603','13','2005-08-02T14:23:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10004','2005-07-31T17:51:23.000','2396','570','2005-08-03T19:12:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10005','2005-07-31T17:53:51.000','928','454','2005-08-09T21:39:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10006','2005-07-31T17:54:35.000','2538','470','2005-08-02T20:40:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10007','2005-07-31T17:54:58.000','293','445','2005-08-05T17:24:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10008','2005-07-31T17:59:36.000','2589','91','2005-08-03T22:43:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10009','2005-07-31T18:00:28.000','4441','437','2005-08-08T22:24:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10010','2005-07-31T18:01:36.000','2655','373','2005-08-07T20:27:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10011','2005-07-31T18:02:41.000','606','128','2005-08-08T17:04:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10012','2005-07-31T18:06:06.000','2554','513','2005-08-09T16:47:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10013','2005-07-31T18:08:21.000','2364','377','2005-08-08T13:22:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10014','2005-07-31T18:10:56.000','2344','443','2005-08-02T23:36:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10015','2005-07-31T18:11:17.000','67','153','2005-08-03T15:48:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10016','2005-07-31T18:13:06.000','2183','478','2005-08-09T22:11:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10017','2005-07-31T18:13:22.000','1495','424','2005-08-05T16:03:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10018','2005-07-31T18:15:14.000','3708','481','2005-08-05T14:44:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10019','2005-07-31T18:20:56.000','2114','536','2005-08-07T14:25:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10020','2005-07-31T18:21:08.000','302','526','2005-08-02T14:03:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10021','2005-07-31T18:24:39.000','3235','597','2005-08-01T19:16:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10022','2005-07-31T18:25:30.000','1900','115','2005-08-04T13:35:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10023','2005-07-31T18:25:51.000','384','318','2005-08-09T18:00:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10024','2005-07-31T18:26:36.000','265','129','2005-08-09T16:16:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10025','2005-07-31T18:29:09.000','475','565','2005-08-07T14:20:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10026','2005-07-31T18:31:51.000','39','332','2005-08-03T21:14:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10027','2005-07-31T18:33:51.000','525','287','2005-08-09T18:40:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10028','2005-07-31T18:35:54.000','2305','323','2005-08-01T13:01:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10029','2005-07-31T18:37:47.000','505','578','2005-08-06T14:58:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10030','2005-07-31T18:39:36.000','1392','325','2005-08-03T15:29:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10031','2005-07-31T18:40:15.000','3048','96','2005-08-03T14:38:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10032','2005-07-31T18:41:55.000','2331','126','2005-08-04T22:45:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10033','2005-07-31T18:44:29.000','4480','381','2005-08-04T19:52:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10034','2005-07-31T18:45:30.000','354','442','2005-08-04T21:13:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10035','2005-07-31T18:46:46.000','2694','333','2005-08-04T20:33:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10036','2005-07-31T18:47:20.000','41','491','2005-08-03T22:53:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10037','2005-07-31T18:48:08.000','438','58','2005-08-09T19:11:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10038','2005-07-31T18:49:12.000','3727','112','2005-08-01T18:02:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10039','2005-07-31T18:50:40.000','4391','111','2005-08-01T18:49:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10040','2005-07-31T18:54:15.000','2281','268','2005-08-05T17:33:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10041','2005-07-31T19:01:02.000','2994','379','2005-08-07T21:32:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10042','2005-07-31T19:01:25.000','123','204','2005-08-06T14:21:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10043','2005-07-31T19:02:07.000','2558','222','2005-08-07T17:58:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10044','2005-07-31T19:02:33.000','3349','388','2005-08-05T13:24:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10045','2005-07-31T19:04:35.000','58','118','2005-08-07T16:53:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10046','2005-07-31T19:07:11.000','4302','50','2005-08-03T13:25:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10047','2005-07-31T19:07:43.000','4195','244','2005-08-07T00:20:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10048','2005-07-31T19:08:56.000','3821','267','2005-08-05T20:15:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10049','2005-07-31T19:11:11.000','854','457','2005-08-03T22:15:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10050','2005-07-31T19:13:29.000','295','230','2005-08-06T15:44:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10051','2005-07-31T19:14:20.000','163','74','2005-08-05T19:45:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10052','2005-07-31T19:15:13.000','3307','39','2005-08-07T22:47:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10053','2005-07-31T19:15:39.000','4102','223','2005-08-07T22:32:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10054','2005-07-31T19:15:52.000','2303','598','2005-08-04T19:54:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10055','2005-07-31T19:15:58.000','2725','336','2005-08-05T20:23:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10056','2005-07-31T19:19:13.000','281','237','2005-08-01T16:09:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10057','2005-07-31T19:20:18.000','3485','230','2005-08-08T17:59:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10058','2005-07-31T19:20:21.000','758','237','2005-08-04T00:41:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10059','2005-07-31T19:20:49.000','2020','274','2005-08-03T14:39:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10060','2005-07-31T19:23:00.000','1979','42','2005-08-08T19:07:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10061','2005-07-31T19:23:25.000','1401','390','2005-08-04T19:38:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10062','2005-07-31T19:24:55.000','1815','333','2005-08-03T22:51:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10063','2005-07-31T19:25:13.000','3003','517','2005-08-09T15:55:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10064','2005-07-31T19:27:02.000','3140','41','2005-08-06T21:15:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10065','2005-07-31T19:27:34.000','1426','495','2005-08-01T13:45:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10066','2005-07-31T19:30:01.000','4285','123','2005-08-01T14:45:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10067','2005-07-31T19:37:58.000','1940','148','2005-08-04T17:32:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10068','2005-07-31T19:39:38.000','4000','58','2005-08-05T22:49:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10069','2005-07-31T19:43:18.000','2168','270','2005-08-06T19:40:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10070','2005-07-31T19:46:29.000','1010','325','2005-08-03T22:21:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10071','2005-07-31T19:49:35.000','2360','353','2005-08-03T00:00:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10072','2005-07-31T19:50:37.000','3963','520','2005-08-03T00:25:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10073','2005-07-31T19:53:15.000','4246','584','2005-08-05T23:12:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10074','2005-07-31T19:57:16.000','1268','69','2005-08-04T00:54:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10075','2005-07-31T19:58:42.000','2037','469','2005-08-08T19:49:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10076','2005-07-31T20:00:34.000','1117','555','2005-08-10T00:37:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10077','2005-07-31T20:01:06.000','2333','19','2005-08-09T16:07:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10078','2005-07-31T20:02:02.000','3198','151','2005-08-04T00:45:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10079','2005-07-31T20:05:45.000','4541','486','2005-08-04T16:25:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10080','2005-07-31T20:07:10.000','4355','62','2005-08-04T23:07:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10081','2005-07-31T20:07:44.000','3183','443','2005-08-06T20:04:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10082','2005-07-31T20:09:32.000','1275','76','2005-08-01T15:41:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10083','2005-07-31T20:10:19.000','2585','449','2005-08-06T23:18:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10084','2005-07-31T20:11:29.000','524','528','2005-08-06T22:28:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10085','2005-07-31T20:12:02.000','2556','392','2005-08-03T00:03:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10086','2005-07-31T20:14:08.000','2853','205','2005-08-07T01:33:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10087','2005-07-31T20:15:22.000','1393','245','2005-08-07T01:33:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10088','2005-07-31T20:16:21.000','4293','46','2005-08-01T22:47:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10089','2005-07-31T20:17:09.000','248','160','2005-08-01T19:14:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10090','2005-07-31T20:22:01.000','4023','533','2005-08-04T17:30:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10091','2005-07-31T20:23:13.000','1878','135','2005-08-02T21:58:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10092','2005-07-31T20:28:09.000','4151','364','2005-08-01T21:37:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10093','2005-07-31T20:30:32.000','3943','162','2005-08-04T00:04:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10094','2005-07-31T20:31:18.000','2865','596','2005-08-06T18:31:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10095','2005-07-31T20:38:35.000','4062','370','2005-08-02T02:33:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10096','2005-07-31T20:38:58.000','3606','290','2005-08-06T02:34:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10097','2005-07-31T20:39:38.000','784','519','2005-08-08T22:22:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10098','2005-07-31T20:41:17.000','1324','155','2005-08-02T00:06:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10099','2005-07-31T20:47:14.000','1960','220','2005-08-02T17:25:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10100','2005-07-31T20:47:18.000','4050','330','2005-08-03T16:58:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10101','2005-07-31T20:47:29.000','2513','119','2005-08-04T21:28:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10102','2005-07-31T20:49:10.000','4078','170','2005-08-08T20:15:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10103','2005-07-31T20:49:13.000','77','25','2005-08-05T15:55:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10104','2005-07-31T20:49:14.000','3358','186','2005-08-05T01:11:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10105','2005-07-31T20:54:20.000','112','286','2005-08-09T17:45:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10106','2005-07-31T21:00:47.000','3444','556','2005-08-02T20:11:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10107','2005-07-31T21:01:46.000','1326','414','2005-08-09T01:33:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10108','2005-07-31T21:02:14.000','3703','326','2005-08-01T18:28:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10109','2005-07-31T21:04:49.000','2852','403','2005-08-08T19:25:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10110','2005-07-31T21:06:12.000','4081','138','2005-08-03T02:03:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10111','2005-07-31T21:08:33.000','3474','38','2005-08-06T02:58:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10112','2005-07-31T21:08:56.000','2643','198','2005-08-01T23:35:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10113','2005-07-31T21:10:03.000','3974','461','2005-08-02T21:13:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10114','2005-07-31T21:12:58.000','3881','218','2005-08-02T19:45:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10115','2005-07-31T21:13:47.000','2731','68','2005-08-10T00:44:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10116','2005-07-31T21:14:02.000','738','28','2005-08-03T01:48:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10117','2005-07-31T21:14:31.000','1894','459','2005-08-01T15:59:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10118','2005-07-31T21:16:31.000','1209','143','2005-08-03T02:32:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10119','2005-07-31T21:20:59.000','54','351','2005-08-02T23:14:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10120','2005-07-31T21:24:24.000','1709','396','2005-08-03T17:44:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10121','2005-07-31T21:24:53.000','2969','425','2005-08-03T22:24:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10122','2005-07-31T21:29:28.000','4229','196','2005-08-09T00:04:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10123','2005-07-31T21:30:46.000','4564','487','2005-08-06T16:28:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10124','2005-07-31T21:31:49.000','1956','396','2005-08-04T00:06:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10125','2005-07-31T21:33:03.000','493','178','2005-08-01T19:10:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10126','2005-07-31T21:36:07.000','3','39','2005-08-03T23:59:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10127','2005-07-31T21:39:48.000','717','478','2005-08-06T00:10:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10128','2005-07-31T21:40:04.000','2559','508','2005-08-02T02:21:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10129','2005-07-31T21:41:35.000','2848','564','2005-08-05T17:05:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10130','2005-07-31T21:44:30.000','3964','95','2005-08-04T17:06:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10131','2005-07-31T21:45:28.000','4169','510','2005-08-04T00:19:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10132','2005-07-31T21:50:24.000','3934','23','2005-08-07T23:37:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10133','2005-07-31T21:55:07.000','614','234','2005-08-08T23:04:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10134','2005-07-31T21:56:10.000','4483','311','2005-08-06T21:20:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10135','2005-07-31T21:57:32.000','4193','307','2005-08-05T22:23:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10136','2005-07-31T21:58:56.000','3142','2','2005-08-03T19:44:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10137','2005-07-31T22:01:41.000','612','236','2005-08-07T22:24:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10138','2005-07-31T22:02:09.000','179','225','2005-08-07T20:46:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10139','2005-07-31T22:02:20.000','407','441','2005-08-04T02:09:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10140','2005-07-31T22:03:20.000','2494','550','2005-08-07T23:15:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10141','2005-07-31T22:08:29.000','8','8','2005-08-06T16:59:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10142','2005-07-31T22:10:54.000','1839','257','2005-08-09T19:04:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10143','2005-07-31T22:11:43.000','2139','271','2005-08-09T17:48:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10144','2005-07-31T22:13:52.000','3011','49','2005-08-05T19:27:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10145','2005-07-31T22:15:13.000','2511','361','2005-08-06T23:26:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10146','2005-07-31T22:17:56.000','1721','559','2005-08-02T21:27:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10147','2005-07-31T22:18:43.000','1351','198','2005-08-02T23:08:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10148','2005-07-31T22:19:16.000','1381','63','2005-08-05T00:15:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10149','2005-07-31T22:20:46.000','890','276','2005-08-07T23:12:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10150','2005-07-31T22:22:00.000','2328','419','2005-08-05T01:17:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10151','2005-07-31T22:22:37.000','4442','361','2005-08-01T22:20:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10152','2005-07-31T22:28:05.000','1114','244','2005-08-08T22:39:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10153','2005-07-31T22:30:10.000','2945','297','2005-08-06T02:32:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10154','2005-07-31T22:30:49.000','2745','149','2005-08-07T03:05:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10155','2005-07-31T22:31:43.000','3176','235','2005-08-07T02:43:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10156','2005-07-31T22:36:00.000','141','179','2005-08-02T00:03:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10157','2005-07-31T22:38:48.000','2960','232','2005-08-01T21:38:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10158','2005-07-31T22:40:31.000','1626','393','2005-08-08T18:25:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10159','2005-07-31T22:54:30.000','1174','515','2005-08-03T00:43:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10160','2005-07-31T23:07:40.000','863','295','2005-08-05T23:34:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10161','2005-07-31T23:09:41.000','2651','120','2005-08-02T20:46:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10162','2005-07-31T23:11:01.000','1327','475','2005-08-07T01:52:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10163','2005-07-31T23:12:34.000','2811','425','2005-08-01T22:47:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10164','2005-07-31T23:17:57.000','1405','89','2005-08-05T19:43:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10165','2005-07-31T23:21:23.000','3476','50','2005-08-06T18:06:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10166','2005-07-31T23:22:20.000','4304','484','2005-08-07T18:06:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10167','2005-07-31T23:24:31.000','1222','129','2005-08-06T17:42:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10168','2005-07-31T23:25:24.000','4548','570','2005-08-02T19:03:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10169','2005-07-31T23:27:13.000','2675','57','2005-08-05T20:32:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10170','2005-07-31T23:27:31.000','804','41','2005-08-08T04:53:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10171','2005-07-31T23:29:05.000','1367','401','2005-08-03T19:39:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10172','2005-07-31T23:29:51.000','2506','426','2005-08-09T01:57:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10173','2005-07-31T23:36:59.000','2527','326','2005-08-08T20:20:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10174','2005-07-31T23:40:08.000','2459','359','2005-08-06T21:08:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10175','2005-07-31T23:40:11.000','3672','137','2005-08-09T02:22:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10176','2005-07-31T23:40:35.000','1181','19','2005-08-09T00:46:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10177','2005-07-31T23:42:33.000','2242','279','2005-08-03T01:30:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10178','2005-07-31T23:43:04.000','1582','491','2005-08-03T00:43:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10179','2005-07-31T23:49:54.000','2136','131','2005-08-01T20:46:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10180','2005-07-31T23:57:43.000','757','50','2005-08-09T04:04:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10181','2005-08-01T00:00:44.000','3111','113','2005-08-04T19:33:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10182','2005-08-01T00:08:01.000','4112','578','2005-08-09T18:14:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10183','2005-08-01T00:08:01.000','4319','377','2005-08-09T20:41:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10184','2005-08-01T00:09:33.000','2785','77','2005-08-05T04:12:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10185','2005-08-01T00:12:11.000','1266','64','2005-08-03T03:03:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10186','2005-08-01T00:12:36.000','4563','294','2005-08-07T05:08:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10187','2005-08-01T00:15:49.000','1629','400','2005-08-05T01:00:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10188','2005-08-01T00:19:41.000','1221','331','2005-08-08T00:19:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10189','2005-08-01T00:25:00.000','616','509','2005-08-03T06:01:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10190','2005-08-01T00:27:53.000','4411','138','2005-08-01T20:32:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10191','2005-08-01T00:28:38.000','1131','196','2005-08-06T02:23:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10192','2005-08-01T00:33:00.000','1632','569','2005-08-05T03:37:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10193','2005-08-01T00:33:27.000','2036','358','2005-08-07T20:15:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10194','2005-08-01T00:33:52.000','1447','290','2005-08-06T04:50:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10195','2005-08-01T00:34:42.000','2691','396','2005-08-08T05:04:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10196','2005-08-01T00:34:51.000','3070','199','2005-08-05T03:43:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10197','2005-08-01T00:35:25.000','1186','127','2005-08-07T06:04:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10198','2005-08-01T00:36:15.000','1297','366','2005-08-07T06:18:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10199','2005-08-01T00:38:55.000','3665','526','2005-08-05T03:41:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10200','2005-08-01T00:39:05.000','580','421','2005-08-05T01:07:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10201','2005-08-01T00:42:18.000','3649','299','2005-08-08T20:49:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10202','2005-08-01T00:43:18.000','1099','306','2005-08-08T23:26:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10203','2005-08-01T00:45:27.000','1096','157','2005-08-04T22:45:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10204','2005-08-01T00:47:39.000','764','572','2005-08-05T01:11:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10205','2005-08-01T00:48:24.000','33','87','2005-08-06T23:53:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10206','2005-08-01T00:52:40.000','4479','90','2005-08-10T02:36:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10207','2005-08-01T00:53:01.000','2925','334','2005-08-05T05:51:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10208','2005-08-01T00:54:51.000','3324','246','2005-08-04T22:39:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10209','2005-08-01T00:56:47.000','2429','303','2005-08-03T19:58:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10210','2005-08-01T00:58:52.000','49','391','2005-08-10T01:16:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10211','2005-08-01T01:01:16.000','810','530','2005-08-10T01:31:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10212','2005-08-01T01:01:35.000','3728','324','2005-08-02T23:02:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10213','2005-08-01T01:03:18.000','1462','106','2005-08-09T20:07:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10214','2005-08-01T01:04:15.000','648','597','2005-08-01T19:31:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10215','2005-08-01T01:04:28.000','838','345','2005-08-09T21:43:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10216','2005-08-01T01:06:27.000','3603','436','2005-08-08T22:41:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10217','2005-08-01T01:07:27.000','1193','389','2005-08-09T00:42:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10218','2005-08-01T01:09:44.000','3886','101','2005-08-05T20:08:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10219','2005-08-01T01:10:33.000','2262','505','2005-08-10T02:45:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10220','2005-08-01T01:13:22.000','3920','294','2005-08-04T22:57:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10221','2005-08-01T01:16:50.000','3051','373','2005-08-03T05:35:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10222','2005-08-01T01:17:42.000','1214','295','2005-08-08T02:45:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10223','2005-08-01T01:23:15.000','1370','522','2005-08-02T19:39:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10224','2005-08-01T01:31:56.000','1443','587','2005-08-05T21:21:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10225','2005-08-01T01:38:40.000','3131','498','2005-08-06T20:00:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10226','2005-08-01T01:40:04.000','3067','107','2005-08-08T01:02:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10227','2005-08-01T01:42:22.000','872','571','2005-08-09T23:45:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10228','2005-08-01T01:43:18.000','1742','106','2005-08-06T22:10:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10229','2005-08-01T01:45:26.000','3459','175','2005-08-10T06:21:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10230','2005-08-01T01:49:36.000','76','398','2005-08-05T01:29:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10231','2005-08-01T01:50:49.000','1056','511','2005-08-06T03:12:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10232','2005-08-01T01:50:55.000','586','512','2005-08-03T04:12:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10233','2005-08-01T01:54:23.000','4571','459','2005-08-10T00:23:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10234','2005-08-01T01:56:20.000','1641','207','2005-08-09T01:51:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10235','2005-08-01T01:57:48.000','2850','30','2005-08-10T07:38:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10236','2005-08-01T02:05:34.000','3754','470','2005-08-01T23:40:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10237','2005-08-01T02:07:32.000','432','313','2005-08-07T03:54:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10238','2005-08-01T02:08:05.000','561','192','2005-08-02T01:52:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10239','2005-08-01T02:09:22.000','1232','467','2005-08-04T01:35:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10240','2005-08-01T02:09:33.000','4494','109','2005-08-07T02:22:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10241','2005-08-01T02:12:25.000','1526','161','2005-08-08T00:37:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10242','2005-08-01T02:18:12.000','1825','342','2005-08-02T22:32:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10243','2005-08-01T02:18:46.000','2236','132','2005-08-06T21:45:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10244','2005-08-01T02:20:01.000','567','51','2005-08-06T23:06:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10245','2005-08-01T02:24:09.000','2880','163','2005-08-02T02:31:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10246','2005-08-01T02:29:50.000','3598','261','2005-08-09T01:17:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10247','2005-08-01T02:34:06.000','4035','189','2005-08-09T02:33:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10248','2005-08-01T02:35:28.000','2146','298','2005-08-08T02:24:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10249','2005-08-01T02:35:39.000','135','437','2005-08-06T06:50:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10250','2005-08-01T02:38:42.000','3706','116','2005-08-07T03:59:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10251','2005-08-01T02:39:12.000','2986','39','2005-08-06T03:51:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10252','2005-08-01T02:39:39.000','2380','86','2005-08-10T00:40:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10253','2005-08-01T02:39:49.000','1406','101','2005-08-08T04:28:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10254','2005-08-01T02:42:03.000','2238','416','2005-08-05T23:31:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10255','2005-08-01T02:46:13.000','4558','459','2005-08-03T05:54:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10256','2005-08-01T02:47:11.000','780','58','2005-08-05T05:21:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10257','2005-08-01T02:49:43.000','2403','543','2005-08-04T04:45:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10258','2005-08-01T02:51:09.000','2062','469','2005-08-08T23:57:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10259','2005-08-01T02:52:05.000','1881','566','2005-08-03T20:54:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10260','2005-08-01T02:58:07.000','2864','461','2005-08-05T02:06:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10261','2005-08-01T02:58:27.000','2346','50','2005-08-01T21:55:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10262','2005-08-01T03:01:26.000','3842','181','2005-08-08T08:03:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10263','2005-08-01T03:02:48.000','2420','415','2005-08-08T02:16:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10264','2005-08-01T03:03:12.000','1374','297','2005-08-08T00:34:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10265','2005-08-01T03:05:04.000','3338','510','2005-08-08T08:09:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10266','2005-08-01T03:05:59.000','476','49','2005-08-06T06:23:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10267','2005-08-01T03:07:26.000','3883','72','2005-08-07T22:49:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10268','2005-08-01T03:08:56.000','2755','138','2005-08-08T02:41:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10269','2005-08-01T03:09:26.000','2537','39','2005-08-02T00:01:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10270','2005-08-01T03:10:24.000','2025','168','2005-08-07T03:04:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10271','2005-08-01T03:13:39.000','3692','6','2005-08-07T23:40:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10272','2005-08-01T03:14:34.000','128','273','2005-08-10T05:56:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10273','2005-08-01T03:14:47.000','1458','212','2005-08-07T03:59:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10274','2005-08-01T03:16:51.000','2916','375','2005-08-04T22:22:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10275','2005-08-01T03:20:08.000','669','463','2005-08-08T06:48:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10276','2005-08-01T03:22:23.000','2201','48','2005-08-03T07:59:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10277','2005-08-01T03:22:41.000','1472','176','2005-08-05T05:07:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10278','2005-08-01T03:25:27.000','2497','154','2005-08-08T07:52:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10279','2005-08-01T03:26:44.000','3794','247','2005-08-07T22:35:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10280','2005-08-01T03:27:15.000','1457','542','2005-08-07T23:01:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10281','2005-08-01T03:28:33.000','1047','549','2005-08-02T05:06:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10282','2005-08-01T03:29:10.000','617','472','2005-08-07T06:16:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10283','2005-08-01T03:29:45.000','4237','462','2005-08-07T04:19:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10284','2005-08-01T03:33:19.000','2879','20','2005-08-09T07:58:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10285','2005-08-01T03:35:11.000','4523','167','2005-08-05T03:55:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10286','2005-08-01T03:35:58.000','498','532','2005-08-10T05:17:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10287','2005-08-01T03:37:01.000','125','141','2005-08-05T23:03:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10288','2005-08-01T03:38:42.000','572','63','2005-08-06T04:34:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10289','2005-08-01T03:39:48.000','3153','566','2005-08-08T02:56:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10290','2005-08-01T03:39:50.000','4542','364','2005-08-08T22:29:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10291','2005-08-01T03:39:57.000','2056','420','2005-08-05T02:05:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10292','2005-08-01T03:42:40.000','2562','340','2005-08-01T23:36:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10293','2005-08-01T03:44:26.000','1570','258','2005-08-05T04:16:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10294','2005-08-01T03:48:12.000','528','28','2005-08-09T01:19:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10295','2005-08-01T03:53:49.000','2355','123','2005-08-10T03:56:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10296','2005-08-01T04:04:37.000','1958','573','2005-08-01T23:59:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10297','2005-08-01T04:05:04.000','2795','289','2005-08-09T06:08:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10298','2005-08-01T04:06:03.000','1383','323','2005-08-05T05:59:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10299','2005-08-01T04:08:04.000','1125','369','2005-08-04T08:11:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10300','2005-08-01T04:08:11.000','4334','207','2005-08-04T00:24:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10301','2005-08-01T04:09:37.000','3072','583','2005-08-04T23:14:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10302','2005-08-01T04:12:08.000','1043','144','2005-08-01T22:12:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10303','2005-08-01T04:13:33.000','936','479','2005-08-06T02:16:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10304','2005-08-01T04:14:12.000','1538','346','2005-08-07T22:38:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10305','2005-08-01T04:16:16.000','2946','160','2005-08-07T23:47:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10306','2005-08-01T04:19:18.000','2819','541','2005-08-09T02:16:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10307','2005-08-01T04:21:54.000','975','332','2005-08-04T09:24:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10308','2005-08-01T04:22:49.000','588','240','2005-08-09T04:39:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10309','2005-08-01T04:24:18.000','1505','156','2005-08-09T08:32:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10310','2005-08-01T04:24:47.000','9','271','2005-08-04T05:36:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10311','2005-08-01T04:27:59.000','4211','151','2005-08-02T08:51:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10312','2005-08-01T04:29:06.000','4389','172','2005-08-08T04:52:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10313','2005-08-01T04:29:29.000','1194','80','2005-08-04T08:12:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10314','2005-08-01T04:31:18.000','1548','252','2005-08-06T01:49:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10315','2005-08-01T04:34:45.000','895','258','2005-08-07T05:27:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10316','2005-08-01T04:34:57.000','1907','469','2005-08-06T02:34:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10317','2005-08-01T04:35:34.000','110','561','2005-08-06T02:27:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10318','2005-08-01T04:36:53.000','885','548','2005-08-04T00:54:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10319','2005-08-01T04:37:19.000','3120','394','2005-08-05T03:18:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10320','2005-08-01T04:39:26.000','2298','152','2005-08-08T06:01:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10321','2005-08-01T04:40:02.000','4512','177','2005-08-03T04:18:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10322','2005-08-01T04:44:13.000','1543','535','2005-08-08T00:20:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10323','2005-08-01T04:44:58.000','3539','577','2005-08-06T07:56:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10324','2005-08-01T04:49:06.000','523','25','2005-08-09T08:04:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10325','2005-08-01T04:52:12.000','2749','258','2005-08-08T09:31:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10326','2005-08-01T04:55:34.000','3856','325','2005-08-02T05:18:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10327','2005-08-01T04:55:35.000','328','382','2005-08-07T08:17:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10328','2005-08-01T04:56:10.000','1191','85','2005-08-01T23:22:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10329','2005-08-01T04:56:13.000','2289','302','2005-08-03T03:54:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10330','2005-08-01T04:57:04.000','1580','7','2005-08-07T23:00:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10331','2005-08-01T04:57:14.000','4152','575','2005-08-07T06:46:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10332','2005-08-01T04:57:32.000','642','258','2005-08-10T02:42:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10333','2005-08-01T04:58:32.000','3955','499','2005-08-04T00:51:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10334','2005-08-01T04:58:42.000','3387','445','2005-08-09T02:00:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10335','2005-08-01T04:59:30.000','323','33','2005-08-05T02:26:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10336','2005-08-01T04:59:53.000','1091','370','2005-08-03T08:05:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10337','2005-08-01T05:01:46.000','307','451','2005-08-10T02:41:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10338','2005-08-01T05:03:03.000','1295','339','2005-08-09T05:13:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10339','2005-08-01T05:05:50.000','615','363','2005-08-10T07:15:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10340','2005-08-01T05:07:03.000','3608','568','2005-08-06T01:03:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10341','2005-08-01T05:10:02.000','3304','445','2005-08-07T11:01:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10342','2005-08-01T05:11:11.000','332','140','2005-08-10T00:27:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10343','2005-08-01T05:15:47.000','2627','267','2005-08-02T04:48:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10344','2005-08-01T05:18:23.000','3673','367','2005-08-06T05:20:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10345','2005-08-01T05:18:56.000','3985','42','2005-08-04T01:34:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10346','2005-08-01T05:19:23.000','4192','476','2005-08-06T01:00:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10347','2005-08-01T05:20:03.000','953','574','2005-08-04T10:03:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10348','2005-08-01T05:23:00.000','2076','14','2005-08-04T01:12:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10349','2005-08-01T05:27:13.000','114','295','2005-08-08T10:15:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10350','2005-08-01T05:30:05.000','2067','78','2005-08-05T09:59:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10351','2005-08-01T05:32:13.000','3725','173','2005-08-08T09:48:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10352','2005-08-01T05:44:36.000','1288','564','2005-08-05T07:15:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10353','2005-08-01T05:46:33.000','1446','535','2005-08-08T09:14:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10354','2005-08-01T05:47:10.000','1680','416','2005-08-06T09:04:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10355','2005-08-01T05:47:37.000','2158','161','2005-08-02T09:28:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10356','2005-08-01T05:49:17.000','313','56','2005-08-10T05:57:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10357','2005-08-01T05:49:49.000','3102','475','2005-08-04T02:34:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10358','2005-08-01T05:50:07.000','3039','517','2005-08-03T08:18:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10359','2005-08-01T05:52:21.000','259','369','2005-08-06T05:52:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10360','2005-08-01T05:52:53.000','1129','443','2005-08-05T10:55:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10361','2005-08-01T05:53:49.000','318','529','2005-08-10T00:42:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10362','2005-08-01T05:55:13.000','72','181','2005-08-10T10:23:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10363','2005-08-01T06:01:52.000','320','174','2005-08-05T03:56:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10364','2005-08-01T06:06:49.000','1842','317','2005-08-09T06:05:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10365','2005-08-01T06:08:44.000','4032','442','2005-08-06T02:07:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10366','2005-08-01T06:09:37.000','2654','119','2005-08-05T03:19:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10367','2005-08-01T06:12:19.000','3408','242','2005-08-04T12:11:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10368','2005-08-01T06:13:38.000','3535','593','2005-08-08T04:40:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10369','2005-08-01T06:13:44.000','2534','424','2005-08-07T09:46:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10370','2005-08-01T06:18:04.000','4358','546','2005-08-05T01:41:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10371','2005-08-01T06:20:29.000','923','327','2005-08-04T00:31:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10372','2005-08-01T06:23:48.000','635','419','2005-08-06T03:47:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10373','2005-08-01T06:24:26.000','1754','588','2005-08-02T12:07:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10374','2005-08-01T06:25:27.000','4351','307','2005-08-07T05:44:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10375','2005-08-01T06:26:22.000','857','202','2005-08-06T02:51:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10376','2005-08-01T06:27:13.000','4194','474','2005-08-07T06:11:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10377','2005-08-01T06:28:28.000','2401','559','2005-08-10T05:45:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10378','2005-08-01T06:30:04.000','4110','113','2005-08-06T09:10:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10379','2005-08-01T06:34:29.000','3103','141','2005-08-06T07:49:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10380','2005-08-01T06:34:36.000','2225','533','2005-08-02T09:08:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10381','2005-08-01T06:36:37.000','522','412','2005-08-05T11:17:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10382','2005-08-01T06:36:45.000','4455','242','2005-08-02T06:06:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10383','2005-08-01T06:37:16.000','4166','592','2005-08-03T07:36:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10384','2005-08-01T06:39:14.000','2622','366','2005-08-02T03:06:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10385','2005-08-01T06:39:55.000','778','179','2005-08-06T02:16:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10386','2005-08-01T06:42:20.000','1568','26','2005-08-07T06:12:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10387','2005-08-01T06:42:31.000','1651','87','2005-08-08T07:44:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10388','2005-08-01T06:42:44.000','3180','99','2005-08-09T11:43:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10389','2005-08-01T06:46:43.000','3534','346','2005-08-08T07:07:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10390','2005-08-01T06:46:48.000','1489','502','2005-08-09T02:55:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10391','2005-08-01T06:49:05.000','2203','357','2005-08-04T01:51:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10392','2005-08-01T06:50:26.000','3017','12','2005-08-10T10:52:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10393','2005-08-01T06:52:50.000','808','258','2005-08-05T08:45:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10394','2005-08-01T06:58:17.000','1655','128','2005-08-05T02:09:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10395','2005-08-01T07:08:22.000','279','129','2005-08-05T08:00:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10396','2005-08-01T07:08:46.000','2982','284','2005-08-08T03:47:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10397','2005-08-01T07:11:27.000','4168','504','2005-08-03T07:51:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10398','2005-08-01T07:11:49.000','4306','174','2005-08-04T05:54:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10399','2005-08-01T07:13:39.000','2515','204','2005-08-10T06:56:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10400','2005-08-01T07:18:24.000','3897','132','2005-08-10T08:38:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10401','2005-08-01T07:27:09.000','1560','564','2005-08-02T01:38:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10402','2005-08-01T07:27:19.000','274','410','2005-08-04T12:30:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10403','2005-08-01T07:30:45.000','1968','494','2005-08-03T03:03:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10404','2005-08-01T07:31:25.000','2580','253','2005-08-07T09:23:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10405','2005-08-01T07:35:25.000','3641','463','2005-08-05T05:38:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10406','2005-08-01T07:37:05.000','2614','391','2005-08-02T06:11:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10407','2005-08-01T07:38:07.000','543','101','2005-08-02T05:38:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10408','2005-08-01T07:42:10.000','4144','334','2005-08-09T02:29:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10409','2005-08-01T07:49:15.000','2804','449','2005-08-02T13:42:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10410','2005-08-01T07:53:29.000','3901','247','2005-08-10T08:56:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10411','2005-08-01T07:56:32.000','1946','522','2005-08-10T04:58:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10412','2005-08-01T07:57:16.000','1555','325','2005-08-04T11:44:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10413','2005-08-01T07:59:39.000','1018','376','2005-08-08T03:55:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10414','2005-08-01T08:03:55.000','1271','361','2005-08-04T08:44:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10415','2005-08-01T08:05:59.000','2597','591','2005-08-04T13:46:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10416','2005-08-01T08:08:39.000','2629','449','2005-08-10T09:26:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10417','2005-08-01T08:10:36.000','3675','427','2005-08-02T03:42:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10418','2005-08-01T08:11:07.000','1692','248','2005-08-04T11:12:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10419','2005-08-01T08:13:22.000','415','66','2005-08-06T04:45:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10420','2005-08-01T08:13:53.000','3490','354','2005-08-06T08:05:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10421','2005-08-01T08:14:10.000','925','262','2005-08-03T05:56:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10422','2005-08-01T08:17:11.000','37','166','2005-08-10T10:08:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10423','2005-08-01T08:19:53.000','739','7','2005-08-08T10:25:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10424','2005-08-01T08:22:54.000','1921','88','2005-08-06T13:44:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10425','2005-08-01T08:23:25.000','322','447','2005-08-05T04:29:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10426','2005-08-01T08:26:08.000','1325','305','2005-08-09T04:09:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10427','2005-08-01T08:30:11.000','2978','356','2005-08-07T06:18:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10428','2005-08-01T08:30:11.000','4245','46','2005-08-02T09:30:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10429','2005-08-01T08:34:18.000','3894','511','2005-08-10T12:38:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10430','2005-08-01T08:37:06.000','1150','471','2005-08-03T07:25:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10431','2005-08-01T08:41:54.000','1074','138','2005-08-07T09:44:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10432','2005-08-01T08:43:21.000','4238','450','2005-08-08T13:09:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10433','2005-08-01T08:45:56.000','1508','517','2005-08-05T09:46:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10434','2005-08-01T08:47:00.000','4073','73','2005-08-06T08:34:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10435','2005-08-01T08:50:51.000','1934','392','2005-08-08T12:23:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10436','2005-08-01T08:50:59.000','4026','455','2005-08-04T05:23:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10437','2005-08-01T08:51:04.000','14','1','2005-08-10T12:12:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10438','2005-08-01T08:53:04.000','4217','316','2005-08-09T06:39:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10439','2005-08-01T08:54:26.000','2711','332','2005-08-08T14:04:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10440','2005-08-01T08:54:32.000','842','299','2005-08-02T10:59:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10441','2005-08-01T08:55:56.000','4122','176','2005-08-03T10:26:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10442','2005-08-01T08:58:08.000','4570','40','2005-08-05T09:07:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10443','2005-08-01T09:01:04.000','1965','403','2005-08-04T09:07:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10444','2005-08-01T09:01:40.000','3242','106','2005-08-09T11:31:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10445','2005-08-01T09:02:15.000','3582','211','2005-08-08T10:26:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10446','2005-08-01T09:02:17.000','2671','95','2005-08-04T10:00:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10447','2005-08-01T09:04:58.000','1198','241','2005-08-08T06:24:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10448','2005-08-01T09:09:31.000','2254','311','2005-08-02T09:55:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10449','2005-08-01T09:09:59.000','1395','213','2005-08-05T11:25:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10450','2005-08-01T09:10:03.000','234','380','2005-08-08T12:34:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10451','2005-08-01T09:11:25.000','2435','9','2005-08-03T12:37:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10452','2005-08-01T09:11:36.000','1973','442','2005-08-04T13:28:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10453','2005-08-01T09:13:27.000','1531','188','2005-08-08T11:34:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10454','2005-08-01T09:14:00.000','397','9','2005-08-04T04:52:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10455','2005-08-01T09:15:00.000','4197','99','2005-08-05T13:35:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10456','2005-08-01T09:17:21.000','4339','81','2005-08-06T10:30:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10457','2005-08-01T09:17:34.000','3052','121','2005-08-06T07:28:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10458','2005-08-01T09:19:48.000','1500','309','2005-08-02T10:16:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10459','2005-08-01T09:20:09.000','201','131','2005-08-03T11:36:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10460','2005-08-01T09:31:00.000','4504','197','2005-08-09T09:28:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10461','2005-08-01T09:32:53.000','3212','270','2005-08-09T10:19:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10462','2005-08-01T09:38:28.000','4526','193','2005-08-02T09:52:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10463','2005-08-01T09:39:43.000','1301','291','2005-08-10T03:42:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10464','2005-08-01T09:43:14.000','464','427','2005-08-06T09:01:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10465','2005-08-01T09:45:25.000','4384','534','2005-08-10T09:08:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10466','2005-08-01T09:45:26.000','138','2','2005-08-06T06:28:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10467','2005-08-01T09:45:58.000','3773','412','2005-08-09T10:17:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10468','2005-08-01T09:48:29.000','2115','129','2005-08-05T09:58:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10469','2005-08-01T09:51:11.000','3054','466','2005-08-05T06:53:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10470','2005-08-01T09:52:26.000','82','523','2005-08-05T06:52:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10471','2005-08-01T09:52:37.000','1684','135','2005-08-07T09:40:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10472','2005-08-01T09:54:41.000','506','405','2005-08-04T13:31:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10473','2005-08-01T09:56:24.000','3034','329','2005-08-10T12:36:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10474','2005-08-01T10:01:42.000','4482','488','2005-08-08T12:32:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10475','2005-08-01T10:03:17.000','2931','115','2005-08-10T15:50:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10476','2005-08-01T10:03:20.000','1993','263','2005-08-10T06:52:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10477','2005-08-01T10:04:17.000','235','506','2005-08-06T11:32:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10478','2005-08-01T10:09:06.000','3885','417','2005-08-06T05:05:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10479','2005-08-01T10:11:25.000','4580','275','2005-08-06T04:52:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10480','2005-08-01T10:13:41.000','553','560','2005-08-03T10:27:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10481','2005-08-01T10:17:26.000','229','170','2005-08-09T08:50:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10482','2005-08-01T10:17:47.000','48','358','2005-08-02T15:04:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10483','2005-08-01T10:19:45.000','1521','129','2005-08-04T09:29:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10484','2005-08-01T10:19:53.000','1908','400','2005-08-03T05:36:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10485','2005-08-01T10:20:34.000','29','50','2005-08-09T09:20:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10486','2005-08-01T10:23:43.000','2454','527','2005-08-05T07:11:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10487','2005-08-01T10:26:34.000','1121','577','2005-08-07T16:11:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10488','2005-08-01T10:27:27.000','297','423','2005-08-02T11:05:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10489','2005-08-01T10:27:42.000','4067','54','2005-08-07T12:56:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10490','2005-08-01T10:37:11.000','4365','329','2005-08-03T10:01:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10491','2005-08-01T10:38:27.000','3091','24','2005-08-04T04:55:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10492','2005-08-01T10:42:28.000','1669','334','2005-08-02T07:05:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10493','2005-08-01T10:43:12.000','2375','285','2005-08-07T08:13:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10494','2005-08-01T10:45:21.000','847','188','2005-08-02T12:34:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10495','2005-08-01T10:45:51.000','2232','41','2005-08-06T08:11:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10496','2005-08-01T10:53:16.000','411','525','2005-08-08T10:34:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10497','2005-08-01T10:55:59.000','1060','499','2005-08-07T11:15:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10498','2005-08-01T10:56:48.000','2672','355','2005-08-03T15:46:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10499','2005-08-01T11:00:20.000','3293','459','2005-08-10T11:52:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10500','2005-08-01T11:01:01.000','469','477','2005-08-06T08:59:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10501','2005-08-01T11:04:46.000','1792','351','2005-08-02T12:10:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10502','2005-08-01T11:06:39.000','3193','357','2005-08-05T07:11:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10503','2005-08-01T11:07:44.000','1823','357','2005-08-08T08:22:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10504','2005-08-01T11:10:55.000','3345','530','2005-08-10T10:16:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10505','2005-08-01T11:13:59.000','2977','426','2005-08-05T07:20:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10506','2005-08-01T11:16:05.000','1171','216','2005-08-03T05:37:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10507','2005-08-01T11:22:20.000','367','45','2005-08-04T13:18:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10508','2005-08-01T11:23:27.000','3890','431','2005-08-02T10:17:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10509','2005-08-01T11:25:28.000','96','504','2005-08-10T09:19:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10510','2005-08-01T11:28:30.000','410','259','2005-08-07T11:37:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10511','2005-08-01T11:32:16.000','3874','487','2005-08-04T09:38:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10512','2005-08-01T11:36:19.000','3294','438','2005-08-09T06:52:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10513','2005-08-01T11:37:34.000','4057','105','2005-08-02T17:15:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10514','2005-08-01T11:39:26.000','1512','7','2005-08-03T07:53:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10515','2005-08-01T11:41:33.000','874','383','2005-08-08T06:23:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10516','2005-08-01T11:41:55.000','3924','449','2005-08-08T17:16:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10517','2005-08-01T11:41:57.000','2299','199','2005-08-05T06:14:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10518','2005-08-01T11:44:08.000','4444','556','2005-08-07T07:58:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10519','2005-08-01T11:44:13.000','1967','456','2005-08-09T16:57:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10520','2005-08-01T11:45:58.000','4396','543','2005-08-06T17:28:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10521','2005-08-01T11:46:17.000','662','346','2005-08-05T11:06:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10522','2005-08-01T11:48:51.000','4159','254','2005-08-05T12:40:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10523','2005-08-01T11:52:32.000','2408','34','2005-08-02T10:47:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10524','2005-08-01T11:53:12.000','4116','38','2005-08-08T10:40:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10525','2005-08-01T11:53:17.000','3811','36','2005-08-07T07:24:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10526','2005-08-01T11:55:33.000','27','14','2005-08-08T16:42:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10527','2005-08-01T11:55:54.000','4530','431','2005-08-05T15:56:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10528','2005-08-01T11:56:22.000','4401','564','2005-08-07T07:13:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10529','2005-08-01T12:00:02.000','851','444','2005-08-08T16:18:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10530','2005-08-01T12:01:17.000','3216','520','2005-08-06T09:55:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10531','2005-08-01T12:06:30.000','3846','459','2005-08-04T10:23:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10532','2005-08-01T12:06:35.000','746','191','2005-08-07T16:04:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10533','2005-08-01T12:14:16.000','1924','593','2005-08-09T17:13:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10534','2005-08-01T12:15:11.000','4354','397','2005-08-04T17:06:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10535','2005-08-01T12:21:13.000','1838','284','2005-08-09T08:58:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10536','2005-08-01T12:21:53.000','1251','86','2005-08-04T13:08:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10537','2005-08-01T12:22:28.000','2140','418','2005-08-08T07:27:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10538','2005-08-01T12:22:41.000','686','37','2005-08-02T10:31:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10539','2005-08-01T12:23:00.000','3341','232','2005-08-07T10:25:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10540','2005-08-01T12:24:42.000','4121','84','2005-08-03T08:39:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10541','2005-08-01T12:24:54.000','1413','234','2005-08-03T16:18:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10542','2005-08-01T12:32:23.000','1102','465','2005-08-08T16:26:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10543','2005-08-01T12:36:09.000','624','29','2005-08-07T07:42:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10544','2005-08-01T12:36:21.000','3195','589','2005-08-07T12:25:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10545','2005-08-01T12:37:46.000','4230','425','2005-08-04T16:02:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10546','2005-08-01T12:44:17.000','1589','362','2005-08-06T16:26:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10547','2005-08-01T12:44:17.000','1707','403','2005-08-08T06:53:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10548','2005-08-01T12:44:32.000','1914','85','2005-08-07T09:17:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10549','2005-08-01T12:46:39.000','3719','61','2005-08-06T17:17:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10550','2005-08-01T12:46:52.000','1980','129','2005-08-05T16:48:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10551','2005-08-01T12:48:55.000','2974','294','2005-08-10T16:11:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10552','2005-08-01T12:49:44.000','4263','119','2005-08-04T16:20:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10553','2005-08-01T12:54:06.000','2768','415','2005-08-06T15:27:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10554','2005-08-01T12:56:19.000','3220','209','2005-08-03T09:44:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10555','2005-08-01T12:56:38.000','377','487','2005-08-10T18:19:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10556','2005-08-01T12:58:42.000','144','117','2005-08-03T07:18:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10557','2005-08-01T12:59:24.000','240','385','2005-08-04T17:08:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10558','2005-08-01T13:00:20.000','4399','117','2005-08-05T16:31:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10559','2005-08-01T13:02:58.000','2861','174','2005-08-09T10:03:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10560','2005-08-01T13:04:57.000','1534','427','2005-08-05T18:25:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10561','2005-08-01T13:05:35.000','2195','8','2005-08-04T08:34:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10562','2005-08-01T13:05:52.000','1947','178','2005-08-02T17:05:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10563','2005-08-01T13:06:03.000','1885','214','2005-08-09T08:39:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10564','2005-08-01T13:07:34.000','4469','387','2005-08-06T15:14:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10565','2005-08-01T13:08:27.000','347','165','2005-08-02T10:30:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10566','2005-08-01T13:12:11.000','3988','269','2005-08-05T11:16:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10567','2005-08-01T13:16:01.000','2744','212','2005-08-05T14:59:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10568','2005-08-01T13:17:28.000','3009','130','2005-08-08T17:04:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10569','2005-08-01T13:18:23.000','611','179','2005-08-10T13:33:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10570','2005-08-01T13:23:06.000','369','21','2005-08-05T15:30:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10571','2005-08-01T13:25:30.000','3660','308','2005-08-02T16:43:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10572','2005-08-01T13:26:53.000','1239','386','2005-08-07T18:47:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10573','2005-08-01T13:27:24.000','4252','585','2005-08-04T15:09:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10574','2005-08-01T13:36:51.000','679','287','2005-08-10T13:25:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10575','2005-08-01T13:41:41.000','4447','251','2005-08-08T11:30:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10576','2005-08-01T13:46:02.000','1876','180','2005-08-05T10:19:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10577','2005-08-01T13:46:38.000','2240','428','2005-08-06T11:35:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10578','2005-08-01T13:48:02.000','3704','113','2005-08-07T13:40:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10579','2005-08-01T13:48:22.000','4068','270','2005-08-07T11:51:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10580','2005-08-01T13:51:14.000','590','234','2005-08-08T11:49:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10581','2005-08-01T13:52:30.000','2801','217','2005-08-10T19:11:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10582','2005-08-01T13:54:22.000','2536','233','2005-08-05T16:46:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10583','2005-08-01T13:54:35.000','704','125','2005-08-03T18:21:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10584','2005-08-01T13:58:47.000','715','86','2005-08-06T13:38:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10585','2005-08-01T14:00:42.000','2670','228','2005-08-09T11:42:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10586','2005-08-01T14:00:59.000','3306','583','2005-08-06T10:00:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10587','2005-08-01T14:03:38.000','3000','521','2005-08-08T19:59:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10588','2005-08-01T14:10:21.000','2384','49','2005-08-03T13:47:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10589','2005-08-01T14:11:09.000','4280','375','2005-08-09T09:28:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10590','2005-08-01T14:11:53.000','740','78','2005-08-04T20:04:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10591','2005-08-01T14:12:29.000','3360','52','2005-08-04T08:46:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10592','2005-08-01T14:13:00.000','829','265','2005-08-09T13:03:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10593','2005-08-01T14:13:19.000','1886','144','2005-08-06T08:48:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10594','2005-08-01T14:14:59.000','1826','53','2005-08-07T10:48:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10595','2005-08-01T14:16:28.000','966','137','2005-08-03T10:37:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10596','2005-08-01T14:18:57.000','803','112','2005-08-07T14:59:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10597','2005-08-01T14:19:48.000','3292','3','2005-08-08T20:01:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10598','2005-08-01T14:23:36.000','2341','397','2005-08-10T14:07:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10599','2005-08-01T14:23:58.000','2422','271','2005-08-06T10:45:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10600','2005-08-01T14:25:21.000','3900','294','2005-08-06T18:00:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10601','2005-08-01T14:25:40.000','2843','420','2005-08-10T09:07:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10602','2005-08-01T14:30:23.000','1506','111','2005-08-07T15:20:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10603','2005-08-01T14:30:35.000','4024','394','2005-08-05T11:13:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10604','2005-08-01T14:35:08.000','2833','250','2005-08-08T10:19:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10605','2005-08-01T14:36:26.000','680','341','2005-08-06T12:04:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10606','2005-08-01T14:39:15.000','81','335','2005-08-08T11:31:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10607','2005-08-01T14:44:43.000','3999','438','2005-08-02T16:39:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10608','2005-08-01T14:48:41.000','3835','381','2005-08-04T17:32:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10609','2005-08-01T14:48:45.000','2587','5','2005-08-04T13:41:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10610','2005-08-01T14:49:41.000','1865','396','2005-08-03T13:07:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10611','2005-08-01T14:53:52.000','957','135','2005-08-07T09:15:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10612','2005-08-01T14:55:31.000','287','554','2005-08-06T19:01:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10613','2005-08-01T14:56:14.000','4357','527','2005-08-07T09:33:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10614','2005-08-01T14:57:00.000','232','533','2005-08-10T09:31:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10615','2005-08-01T14:58:14.000','2639','34','2005-08-02T13:38:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10616','2005-08-01T14:59:50.000','1094','20','2005-08-07T11:38:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10617','2005-08-01T15:05:52.000','4344','476','2005-08-09T18:54:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10618','2005-08-01T15:06:38.000','3729','386','2005-08-06T15:52:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10619','2005-08-01T15:07:04.000','2189','132','2005-08-07T11:42:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10620','2005-08-01T15:09:17.000','3064','183','2005-08-09T13:58:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10621','2005-08-01T15:10:26.000','1650','172','2005-08-04T10:58:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10622','2005-08-01T15:12:00.000','3044','171','2005-08-08T14:09:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10623','2005-08-01T15:22:38.000','4426','494','2005-08-03T11:03:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10624','2005-08-01T15:27:05.000','3801','74','2005-08-05T19:50:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10625','2005-08-01T15:27:10.000','3022','5','2005-08-02T13:16:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10626','2005-08-01T15:32:41.000','1042','122','2005-08-05T18:08:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10627','2005-08-01T15:33:03.000','2026','472','2005-08-02T21:26:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10628','2005-08-01T15:33:19.000','427','285','2005-08-05T17:27:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10629','2005-08-01T15:33:32.000','997','575','2005-08-08T12:40:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10630','2005-08-01T15:34:46.000','2335','39','2005-08-03T10:50:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10631','2005-08-01T15:35:14.000','2712','304','2005-08-03T10:48:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10632','2005-08-01T15:36:56.000','1290','406','2005-08-05T17:32:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10633','2005-08-01T15:37:17.000','3125','475','2005-08-10T14:30:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10634','2005-08-01T15:37:48.000','445','592','2005-08-02T12:11:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10635','2005-08-01T15:37:58.000','547','52','2005-08-07T11:15:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10636','2005-08-01T15:40:35.000','621','385','2005-08-05T18:46:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10637','2005-08-01T15:44:09.000','1243','161','2005-08-04T14:42:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10638','2005-08-01T15:44:20.000','2239','132','2005-08-08T16:05:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10639','2005-08-01T15:44:43.000','1015','39','2005-08-10T13:51:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10640','2005-08-01T15:44:51.000','3020','375','2005-08-06T15:52:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10641','2005-08-01T15:44:57.000','972','285','2005-08-04T18:15:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10642','2005-08-01T15:45:11.000','2573','294','2005-08-02T20:13:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10643','2005-08-01T15:48:33.000','3853','495','2005-08-06T20:24:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10644','2005-08-01T15:52:00.000','4374','7','2005-08-08T16:08:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10645','2005-08-01T15:52:01.000','3864','130','2005-08-09T18:58:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10646','2005-08-01T15:57:55.000','1752','209','2005-08-02T19:08:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10647','2005-08-01T16:08:46.000','3137','115','2005-08-06T20:37:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10648','2005-08-01T16:08:52.000','691','270','2005-08-05T20:17:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10649','2005-08-01T16:11:40.000','1032','278','2005-08-06T14:09:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10650','2005-08-01T16:18:45.000','2306','242','2005-08-09T16:29:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10651','2005-08-01T16:20:22.000','1541','404','2005-08-03T15:53:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10652','2005-08-01T16:24:08.000','1633','241','2005-08-03T16:00:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10653','2005-08-01T16:28:07.000','1190','75','2005-08-07T21:22:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10654','2005-08-01T16:31:35.000','2522','399','2005-08-05T12:04:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10655','2005-08-01T16:33:27.000','1399','385','2005-08-08T17:17:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10656','2005-08-01T16:38:04.000','2571','80','2005-08-09T19:37:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10657','2005-08-01T16:38:44.000','3075','590','2005-08-06T16:05:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10658','2005-08-01T16:39:18.000','2943','469','2005-08-09T18:17:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10659','2005-08-01T16:40:34.000','786','238','2005-08-09T21:00:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10660','2005-08-01T16:48:01.000','2518','253','2005-08-07T14:42:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10661','2005-08-01T16:48:31.000','3311','177','2005-08-02T21:02:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10662','2005-08-01T16:50:57.000','2857','151','2005-08-03T17:19:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10663','2005-08-01T16:51:08.000','4258','433','2005-08-08T21:17:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10664','2005-08-01T16:51:15.000','3167','337','2005-08-04T19:14:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10665','2005-08-01T16:56:17.000','3594','133','2005-08-03T18:58:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10666','2005-08-01T16:56:36.000','1945','197','2005-08-07T22:23:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10667','2005-08-01T16:58:22.000','3937','340','2005-08-10T15:41:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10668','2005-08-01T17:00:27.000','2085','58','2005-08-02T14:49:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10669','2005-08-01T17:03:28.000','2121','559','2005-08-08T21:34:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10670','2005-08-01T17:07:16.000','156','512','2005-08-10T11:46:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10671','2005-08-01T17:09:59.000','4430','10','2005-08-09T21:36:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10672','2005-08-01T17:10:54.000','3674','375','2005-08-07T12:19:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10673','2005-08-01T17:11:51.000','2735','528','2005-08-03T13:32:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10674','2005-08-01T17:11:52.000','1962','340','2005-08-08T19:34:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10675','2005-08-01T17:11:57.000','649','522','2005-08-10T17:18:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10676','2005-08-01T17:14:15.000','629','79','2005-08-04T12:34:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10677','2005-08-01T17:24:35.000','4350','483','2005-08-04T20:03:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10678','2005-08-01T17:26:24.000','4438','56','2005-08-05T22:55:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10679','2005-08-01T17:27:58.000','4437','198','2005-08-08T16:06:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10680','2005-08-01T17:28:05.000','2498','60','2005-08-04T19:34:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10681','2005-08-01T17:30:35.000','1468','119','2005-08-02T14:48:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10682','2005-08-01T17:32:53.000','4557','18','2005-08-06T15:49:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10683','2005-08-01T17:33:03.000','244','246','2005-08-04T23:12:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10684','2005-08-01T17:47:00.000','1985','244','2005-08-09T15:00:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10685','2005-08-01T17:49:38.000','2029','200','2005-08-07T21:04:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10686','2005-08-01T17:51:21.000','2542','150','2005-08-03T19:01:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10687','2005-08-01T17:53:02.000','3191','16','2005-08-05T19:16:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10688','2005-08-01T17:53:43.000','3161','449','2005-08-09T21:50:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10689','2005-08-01T18:04:18.000','1442','568','2005-08-05T21:17:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10690','2005-08-01T18:05:54.000','807','80','2005-08-10T21:43:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10691','2005-08-01T18:09:53.000','4281','276','2005-08-03T16:32:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10692','2005-08-01T18:12:35.000','371','596','2005-08-07T13:06:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10693','2005-08-01T18:14:14.000','2387','444','2005-08-03T22:00:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10694','2005-08-01T18:15:07.000','3429','98','2005-08-10T15:38:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10695','2005-08-01T18:16:20.000','3612','374','2005-08-03T12:21:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10696','2005-08-01T18:18:13.000','47','120','2005-08-04T14:09:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10697','2005-08-01T18:20:23.000','3115','519','2005-08-07T21:18:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10698','2005-08-01T18:24:41.000','2738','135','2005-08-08T18:59:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10699','2005-08-01T18:24:51.000','1029','125','2005-08-06T20:18:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10700','2005-08-01T18:26:31.000','4259','203','2005-08-07T19:51:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10701','2005-08-01T18:28:17.000','3958','538','2005-08-09T21:51:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10702','2005-08-01T18:34:59.000','2802','560','2005-08-09T23:44:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10703','2005-08-01T18:37:39.000','1818','181','2005-08-07T23:50:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10704','2005-08-01T18:38:02.000','960','594','2005-08-08T20:19:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10705','2005-08-01T18:38:54.000','4338','381','2005-08-04T18:00:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10706','2005-08-01T18:41:28.000','1183','147','2005-08-10T14:30:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10707','2005-08-01T18:41:34.000','1165','558','2005-08-06T12:41:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10708','2005-08-01T18:43:28.000','3978','567','2005-08-09T15:24:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10709','2005-08-01T18:43:57.000','282','418','2005-08-06T13:17:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10710','2005-08-01T18:44:36.000','3082','177','2005-08-03T13:17:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10711','2005-08-01T18:45:09.000','4278','400','2005-08-02T19:47:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10712','2005-08-01T18:47:56.000','1188','532','2005-08-07T19:26:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10713','2005-08-01T18:50:05.000','2030','369','2005-08-05T00:43:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10714','2005-08-01T18:51:29.000','1465','64','2005-08-04T18:49:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10715','2005-08-01T18:51:48.000','1054','386','2005-08-06T14:44:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10716','2005-08-01T18:53:48.000','3405','515','2005-08-04T13:49:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10717','2005-08-01T18:53:53.000','2934','365','2005-08-05T21:28:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10718','2005-08-01T18:55:38.000','2763','394','2005-08-04T14:45:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10719','2005-08-01T19:00:28.000','3861','188','2005-08-07T17:04:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10720','2005-08-01T19:04:33.000','3712','326','2005-08-06T23:12:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10721','2005-08-01T19:05:18.000','904','18','2005-08-09T20:45:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10722','2005-08-01T19:07:08.000','2849','90','2005-08-04T14:09:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10723','2005-08-01T19:10:49.000','2526','580','2005-08-08T19:21:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10724','2005-08-01T19:10:59.000','3425','576','2005-08-07T18:44:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10725','2005-08-01T19:11:04.000','4486','534','2005-08-07T18:16:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10726','2005-08-01T19:14:53.000','749','75','2005-08-08T23:56:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10727','2005-08-01T19:15:08.000','2049','16','2005-08-03T13:52:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10728','2005-08-01T19:15:09.000','3133','309','2005-08-04T19:35:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10729','2005-08-01T19:21:11.000','2918','595','2005-08-07T21:20:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10730','2005-08-01T19:21:42.000','1793','368','2005-08-10T21:18:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10731','2005-08-01T19:21:48.000','4248','278','2005-08-08T22:01:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10732','2005-08-01T19:25:18.000','2810','538','2005-08-10T22:26:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10733','2005-08-01T19:28:01.000','3980','560','2005-08-09T18:41:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10734','2005-08-01T19:28:47.000','1130','21','2005-08-03T00:41:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10735','2005-08-01T19:29:45.000','4061','544','2005-08-02T19:50:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10736','2005-08-01T19:30:21.000','2227','272','2005-08-02T22:37:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10737','2005-08-01T19:31:24.000','1773','149','2005-08-10T19:17:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10738','2005-08-01T19:39:08.000','544','377','2005-08-10T20:37:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10739','2005-08-01T19:46:11.000','3160','197','2005-08-06T21:08:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10740','2005-08-01T19:50:32.000','3215','144','2005-08-07T23:25:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10741','2005-08-01T19:52:52.000','3300','469','2005-08-04T19:58:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10742','2005-08-01T19:53:13.000','3658','416','2005-08-10T15:05:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10743','2005-08-01T19:55:09.000','4206','197','2005-08-03T19:29:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10744','2005-08-01T19:56:49.000','565','439','2005-08-09T16:33:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10745','2005-08-01T19:57:06.000','446','307','2005-08-07T18:04:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10746','2005-08-01T19:58:49.000','305','508','2005-08-10T19:00:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10747','2005-08-01T19:59:41.000','4527','266','2005-08-10T00:00:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10748','2005-08-01T20:01:24.000','3769','181','2005-08-05T19:55:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10749','2005-08-01T20:02:01.000','2953','214','2005-08-03T14:20:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10750','2005-08-01T20:06:00.000','3206','201','2005-08-07T15:48:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10751','2005-08-01T20:06:10.000','3257','518','2005-08-10T22:36:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10752','2005-08-01T20:08:49.000','3203','147','2005-08-10T15:41:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10753','2005-08-01T20:09:24.000','1557','273','2005-08-09T19:31:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10754','2005-08-01T20:12:33.000','2122','460','2005-08-10T01:07:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10755','2005-08-01T20:14:14.000','1217','239','2005-08-07T01:04:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10756','2005-08-01T20:17:03.000','4247','596','2005-08-08T18:31:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10757','2005-08-01T20:22:44.000','102','188','2005-08-04T19:48:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10758','2005-08-01T20:22:51.000','191','373','2005-08-10T16:11:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10759','2005-08-01T20:22:51.000','3528','256','2005-08-07T22:07:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10760','2005-08-01T20:25:20.000','1311','497','2005-08-09T16:57:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10761','2005-08-01T20:25:35.000','3967','36','2005-08-08T15:20:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10762','2005-08-01T20:28:39.000','1363','208','2005-08-05T17:36:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10763','2005-08-01T20:32:27.000','987','276','2005-08-05T01:24:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10764','2005-08-01T20:32:42.000','3808','357','2005-08-03T22:14:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10765','2005-08-01T20:34:51.000','566','337','2005-08-04T00:02:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10766','2005-08-01T20:36:29.000','947','420','2005-08-04T00:30:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10767','2005-08-01T20:37:23.000','2875','488','2005-08-04T23:15:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10768','2005-08-01T20:39:32.000','454','273','2005-08-10T19:41:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10769','2005-08-01T20:43:02.000','3222','348','2005-08-05T02:32:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10770','2005-08-01T20:45:39.000','2567','262','2005-08-04T19:21:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10771','2005-08-01T20:49:35.000','1274','485','2005-08-10T16:58:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10772','2005-08-01T20:51:10.000','132','485','2005-08-10T15:50:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10773','2005-08-01T20:53:45.000','3854','181','2005-08-07T00:16:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10774','2005-08-01T20:54:33.000','4231','407','2005-08-08T20:59:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10775','2005-08-01T20:59:52.000','4190','263','2005-08-04T19:31:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10776','2005-08-01T20:59:58.000','1598','565','2005-08-10T20:33:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10777','2005-08-01T21:03:50.000','3487','493','2005-08-06T19:29:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10778','2005-08-01T21:11:39.000','1939','220','2005-08-02T22:59:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10779','2005-08-01T21:11:54.000','2092','578','2005-08-09T21:00:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10780','2005-08-01T21:14:24.000','1450','51','2005-08-07T16:32:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10781','2005-08-01T21:22:41.000','1321','259','2005-08-06T01:02:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10782','2005-08-01T21:23:25.000','1507','577','2005-08-03T20:15:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10783','2005-08-01T21:23:37.000','1192','495','2005-08-09T20:18:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10784','2005-08-01T21:24:28.000','3494','208','2005-08-09T19:23:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10785','2005-08-01T21:24:55.000','2282','397','2005-08-06T17:47:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10786','2005-08-01T21:29:34.000','50','490','2005-08-10T17:27:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10787','2005-08-01T21:35:01.000','3246','127','2005-08-10T23:30:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10788','2005-08-01T21:37:10.000','3350','160','2005-08-03T01:33:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10789','2005-08-01T21:37:55.000','3298','403','2005-08-07T17:01:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10790','2005-08-01T21:38:37.000','3080','274','2005-08-08T17:20:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10791','2005-08-01T21:41:52.000','2061','338','2005-08-04T03:28:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10792','2005-08-01T21:44:24.000','1037','264','2005-08-02T19:48:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10793','2005-08-01T21:48:03.000','3018','225','2005-08-10T19:16:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10794','2005-08-01T21:51:15.000','889','27','2005-08-10T18:51:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10795','2005-08-01T21:56:37.000','2748','76','2005-08-03T01:36:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10796','2005-08-01T21:56:41.000','2113','534','2005-08-05T01:09:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10797','2005-08-01T22:02:51.000','1731','308','2005-08-03T23:07:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10798','2005-08-01T22:03:10.000','382','141','2005-08-08T01:34:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10799','2005-08-01T22:03:31.000','3282','145','2005-08-06T20:19:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10800','2005-08-01T22:07:44.000','507','583','2005-08-05T22:45:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10801','2005-08-01T22:09:35.000','3757','116','2005-08-08T22:23:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10802','2005-08-01T22:18:32.000','3998','178','2005-08-10T18:41:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10803','2005-08-01T22:22:07.000','3318','46','2005-08-08T02:37:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10804','2005-08-01T22:22:11.000','2915','596','2005-08-03T03:42:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10805','2005-08-01T22:23:37.000','557','203','2005-08-05T01:22:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10806','2005-08-01T22:25:29.000','3553','89','2005-08-04T18:46:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10807','2005-08-01T22:26:10.000','1673','287','2005-08-05T21:55:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10808','2005-08-01T22:37:11.000','596','480','2005-08-09T02:37:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10809','2005-08-01T22:39:27.000','1167','340','2005-08-03T03:44:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10810','2005-08-01T22:40:39.000','2314','376','2005-08-06T19:47:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10811','2005-08-01T22:41:15.000','4012','209','2005-08-10T00:10:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10812','2005-08-01T22:41:16.000','3762','11','2005-08-07T00:50:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10813','2005-08-01T22:43:00.000','3580','456','2005-08-03T21:43:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10814','2005-08-01T22:43:12.000','2758','49','2005-08-05T02:35:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10815','2005-08-01T22:46:21.000','877','62','2005-08-03T02:43:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10816','2005-08-01T22:48:57.000','905','129','2005-08-10T04:39:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10817','2005-08-01T22:51:08.000','3056','501','2005-08-10T16:55:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10818','2005-08-01T22:52:45.000','4549','309','2005-08-06T04:07:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10819','2005-08-01T22:52:57.000','983','308','2005-08-06T00:08:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10820','2005-08-01T22:53:40.000','1487','97','2005-08-02T17:59:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10821','2005-08-01T22:54:27.000','2016','522','2005-08-07T02:15:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10822','2005-08-01T22:54:28.000','3895','343','2005-08-02T17:19:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10823','2005-08-01T22:59:10.000','3322','405','2005-08-08T23:44:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10824','2005-08-01T23:00:22.000','3948','482','2005-08-04T04:14:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10825','2005-08-01T23:05:33.000','4386','587','2005-08-04T04:33:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10826','2005-08-01T23:07:56.000','1228','476','2005-08-08T04:10:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10827','2005-08-01T23:13:00.000','1590','46','2005-08-08T02:51:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10828','2005-08-01T23:16:10.000','2448','471','2005-08-09T21:17:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10829','2005-08-01T23:17:06.000','168','554','2005-08-09T17:22:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10830','2005-08-01T23:18:06.000','4176','148','2005-08-06T23:15:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10831','2005-08-01T23:22:45.000','1496','78','2005-08-07T01:05:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10832','2005-08-01T23:24:53.000','4096','487','2005-08-06T23:18:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10833','2005-08-01T23:25:55.000','4380','422','2005-08-10T18:01:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10834','2005-08-01T23:28:00.000','2270','252','2005-08-07T01:21:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10835','2005-08-01T23:28:49.000','351','90','2005-08-10T21:28:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10836','2005-08-01T23:29:58.000','4534','217','2005-08-07T23:03:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10837','2005-08-01T23:30:22.000','1816','410','2005-08-07T23:02:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10838','2005-08-01T23:36:10.000','69','387','2005-08-05T04:55:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10839','2005-08-01T23:37:39.000','2867','482','2005-08-02T20:18:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10840','2005-08-01T23:38:34.000','583','593','2005-08-07T02:36:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10841','2005-08-01T23:39:21.000','4337','102','2005-08-07T20:47:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10842','2005-08-01T23:41:24.000','1300','137','2005-08-11T03:48:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10843','2005-08-01T23:43:03.000','1286','192','2005-08-09T23:49:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10844','2005-08-01T23:46:58.000','1516','333','2005-08-09T19:42:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10845','2005-08-01T23:47:03.000','2737','42','2005-08-08T01:57:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10846','2005-08-01T23:47:54.000','2277','441','2005-08-08T01:10:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10847','2005-08-01T23:49:33.000','1200','280','2005-08-10T05:37:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10848','2005-08-01T23:50:22.000','2630','368','2005-08-06T00:52:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10849','2005-08-01T23:51:00.000','1683','278','2005-08-10T19:59:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10850','2005-08-01T23:53:45.000','1853','199','2005-08-10T21:11:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10851','2005-08-01T23:58:45.000','1359','154','2005-08-04T00:59:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10852','2005-08-02T00:00:33.000','3862','27','2005-08-03T23:09:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10853','2005-08-02T00:00:54.000','2682','41','2005-08-10T05:37:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10854','2005-08-02T00:02:06.000','3295','356','2005-08-02T21:55:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10855','2005-08-02T00:06:37.000','1366','274','2005-08-03T00:39:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10856','2005-08-02T00:07:14.000','2010','451','2005-08-04T02:48:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10857','2005-08-02T00:07:20.000','2961','360','2005-08-04T02:35:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10858','2005-08-02T00:08:39.000','852','312','2005-08-05T00:58:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10859','2005-08-02T00:11:39.000','277','375','2005-08-08T19:52:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10860','2005-08-02T00:12:32.000','2827','25','2005-08-04T03:50:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10861','2005-08-02T00:12:46.000','2162','131','2005-08-09T04:09:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10862','2005-08-02T00:17:34.000','1077','176','2005-08-08T00:31:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10863','2005-08-02T00:18:07.000','1170','161','2005-08-10T06:16:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10864','2005-08-02T00:18:59.000','1694','134','2005-08-08T22:20:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10865','2005-08-02T00:22:46.000','1485','201','2005-08-09T05:08:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10866','2005-08-02T00:22:49.000','117','424','2005-08-07T04:38:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10867','2005-08-02T00:24:15.000','2577','473','2005-08-05T21:09:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10868','2005-08-02T00:25:15.000','2443','562','2005-08-10T02:31:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10869','2005-08-02T00:26:54.000','2967','568','2005-08-04T03:40:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10870','2005-08-02T00:27:12.000','1509','33','2005-08-02T20:00:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10871','2005-08-02T00:27:24.000','104','75','2005-08-05T06:25:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10872','2005-08-02T00:27:50.000','2470','84','2005-08-06T20:34:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10873','2005-08-02T00:30:34.000','169','506','2005-08-07T00:16:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10874','2005-08-02T00:31:00.000','2552','230','2005-08-07T05:04:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10875','2005-08-02T00:31:44.000','862','175','2005-08-05T22:24:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10876','2005-08-02T00:31:58.000','2161','559','2005-08-05T21:45:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10877','2005-08-02T00:32:04.000','3337','487','2005-08-07T19:44:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10878','2005-08-02T00:33:12.000','3511','45','2005-08-07T06:02:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10879','2005-08-02T00:33:20.000','4415','334','2005-08-09T04:13:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10880','2005-08-02T00:34:12.000','450','528','2005-08-06T21:15:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10881','2005-08-02T00:38:14.000','781','253','2005-08-09T22:02:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10882','2005-08-02T00:47:16.000','1349','54','2005-08-09T22:11:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10883','2005-08-02T00:47:19.000','4','301','2005-08-03T00:02:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10884','2005-08-02T00:47:33.000','3702','569','2005-08-03T04:38:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10885','2005-08-02T00:51:37.000','4223','493','2005-08-09T20:49:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10886','2005-08-02T00:52:34.000','943','77','2005-08-08T00:30:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10887','2005-08-02T00:52:35.000','3450','573','2005-08-03T05:37:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10888','2005-08-02T00:52:45.000','2412','428','2005-08-03T03:07:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10889','2005-08-02T00:54:33.000','2098','64','2005-08-07T19:42:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10890','2005-08-02T00:58:46.000','78','210','2005-08-10T02:13:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10891','2005-08-02T01:09:55.000','1269','201','2005-08-05T05:03:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10892','2005-08-02T01:12:06.000','3243','109','2005-08-09T23:53:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10893','2005-08-02T01:12:13.000','2529','306','2005-08-11T05:53:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10894','2005-08-02T01:12:35.000','598','51','2005-08-09T22:55:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10895','2005-08-02T01:16:59.000','93','77','2005-08-03T02:41:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10896','2005-08-02T01:19:33.000','2283','505','2005-08-08T06:54:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10897','2005-08-02T01:23:42.000','291','338','2005-08-03T23:27:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10898','2005-08-02T01:29:57.000','3814','23','2005-08-06T00:07:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10899','2005-08-02T01:30:21.000','859','29','2005-08-06T05:01:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10900','2005-08-02T01:34:26.000','1749','139','2005-08-07T00:52:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10901','2005-08-02T01:35:44.000','3813','290','2005-08-04T21:20:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10902','2005-08-02T01:35:46.000','3863','486','2005-08-09T01:59:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10903','2005-08-02T01:41:59.000','2696','547','2005-08-06T23:03:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10904','2005-08-02T01:43:02.000','3681','593','2005-08-04T04:34:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10905','2005-08-02T01:45:59.000','2835','439','2005-08-04T22:28:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10906','2005-08-02T01:47:04.000','3139','463','2005-08-07T20:41:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10907','2005-08-02T01:51:48.000','1430','561','2005-08-02T19:53:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10908','2005-08-02T01:53:06.000','1284','269','2005-08-04T02:46:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10909','2005-08-02T01:53:59.000','3516','413','2005-08-03T04:36:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10910','2005-08-02T01:54:34.000','2428','266','2005-08-10T04:04:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10911','2005-08-02T01:58:36.000','769','195','2005-08-08T07:37:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10912','2005-08-02T02:00:03.000','732','477','2005-08-06T05:55:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10913','2005-08-02T02:04:03.000','3388','565','2005-08-09T03:21:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10914','2005-08-02T02:04:43.000','585','584','2005-08-06T03:00:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10915','2005-08-02T02:05:04.000','4568','418','2005-08-10T21:58:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10916','2005-08-02T02:05:59.000','3841','25','2005-08-06T03:46:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10917','2005-08-02T02:06:18.000','3146','378','2005-08-03T22:42:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10918','2005-08-02T02:10:56.000','3418','2','2005-08-02T21:23:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10919','2005-08-02T02:11:03.000','868','115','2005-08-04T01:49:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10920','2005-08-02T02:14:10.000','3106','531','2005-08-06T23:36:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10921','2005-08-02T02:14:33.000','1820','555','2005-08-09T20:58:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10922','2005-08-02T02:14:40.000','4522','539','2005-08-06T06:04:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10923','2005-08-02T02:15:01.000','2602','239','2005-08-03T04:18:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10924','2005-08-02T02:20:19.000','589','540','2005-08-11T05:50:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10925','2005-08-02T02:24:38.000','1475','98','2005-08-03T05:06:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10926','2005-08-02T02:26:37.000','4016','460','2005-08-09T20:55:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10927','2005-08-02T02:31:15.000','4125','288','2005-08-10T20:41:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10928','2005-08-02T02:34:12.000','2885','211','2005-08-07T21:13:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10929','2005-08-02T02:35:44.000','913','305','2005-08-05T03:52:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10930','2005-08-02T02:38:07.000','2027','206','2005-08-08T05:15:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10931','2005-08-02T02:44:59.000','3268','545','2005-08-04T02:02:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10932','2005-08-02T02:46:22.000','1688','595','2005-08-06T01:49:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10933','2005-08-02T02:50:49.000','3970','313','2005-08-08T04:39:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10934','2005-08-02T02:52:18.000','4458','142','2005-08-06T01:23:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10935','2005-08-02T02:54:53.000','4373','42','2005-08-10T00:07:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10936','2005-08-02T02:55:04.000','463','445','2005-08-11T07:56:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10937','2005-08-02T03:00:18.000','1320','416','2005-08-11T03:44:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10938','2005-08-02T03:05:22.000','3918','502','2005-08-05T08:31:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10939','2005-08-02T03:06:20.000','2131','161','2005-08-04T01:22:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10940','2005-08-02T03:08:29.000','3760','120','2005-08-07T21:28:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10941','2005-08-02T03:11:33.000','2132','531','2005-08-10T07:31:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10942','2005-08-02T03:16:31.000','2304','78','2005-08-11T02:46:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10943','2005-08-02T03:17:29.000','1036','377','2005-08-03T00:50:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10944','2005-08-02T03:20:03.000','2373','470','2005-08-04T04:13:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10945','2005-08-02T03:20:23.000','3684','532','2005-08-09T03:23:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10946','2005-08-02T03:20:39.000','4271','56','2005-08-05T02:59:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10947','2005-08-02T03:23:17.000','2510','500','2005-08-07T05:25:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10948','2005-08-02T03:23:23.000','4429','220','2005-08-05T23:18:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10949','2005-08-02T03:24:04.000','2309','389','2005-08-06T08:36:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10950','2005-08-02T03:25:08.000','707','451','2005-08-07T23:11:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10951','2005-08-02T03:26:35.000','173','144','2005-08-07T22:03:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10952','2005-08-02T03:28:21.000','3218','111','2005-08-09T01:41:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10953','2005-08-02T03:28:38.000','1510','483','2005-08-11T03:53:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10954','2005-08-02T03:30:24.000','3406','20','2005-08-08T05:52:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10955','2005-08-02T03:32:34.000','618','490','2005-08-09T21:53:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10956','2005-08-02T03:33:14.000','4372','54','2005-08-09T09:20:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10957','2005-08-02T03:33:30.000','1652','447','2005-08-10T06:19:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10958','2005-08-02T03:37:13.000','2174','160','2005-08-04T23:28:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10959','2005-08-02T03:39:39.000','4233','431','2005-08-11T07:20:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10960','2005-08-02T03:46:18.000','3536','399','2005-08-11T01:29:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10961','2005-08-02T03:47:55.000','1416','375','2005-08-09T02:03:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10962','2005-08-02T03:48:13.000','1953','538','2005-08-07T00:04:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10963','2005-08-02T03:48:17.000','4501','36','2005-08-02T22:15:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10964','2005-08-02T03:56:23.000','2356','36','2005-08-09T23:11:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10965','2005-08-02T04:00:19.000','2192','580','2005-08-09T03:27:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10966','2005-08-02T04:00:47.000','478','584','2005-08-08T01:58:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10967','2005-08-02T04:02:16.000','683','149','2005-08-09T07:57:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10968','2005-08-02T04:03:13.000','888','234','2005-08-11T08:36:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10969','2005-08-02T04:04:32.000','1898','244','2005-08-09T23:18:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10970','2005-08-02T04:06:46.000','1202','260','2005-08-10T04:27:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10971','2005-08-02T04:08:17.000','2789','383','2005-08-09T00:02:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10972','2005-08-02T04:08:25.000','1928','348','2005-08-09T23:25:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10973','2005-08-02T04:09:42.000','3562','127','2005-08-08T05:24:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10974','2005-08-02T04:10:52.000','690','491','2005-08-09T08:26:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10975','2005-08-02T04:11:25.000','2616','361','2005-08-04T04:39:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10976','2005-08-02T04:11:48.000','2418','326','2005-08-06T06:30:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10977','2005-08-02T04:12:17.000','2302','300','2005-08-06T06:52:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10978','2005-08-02T04:12:27.000','1597','487','2005-08-10T08:19:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10979','2005-08-02T04:16:37.000','2625','160','2005-08-06T00:01:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10980','2005-08-02T04:17:32.000','150','547','2005-08-04T05:12:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10981','2005-08-02T04:17:53.000','3699','305','2005-08-09T03:45:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10982','2005-08-02T04:19:11.000','2508','345','2005-08-04T00:20:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10983','2005-08-02T04:24:23.000','4502','380','2005-08-09T08:05:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10984','2005-08-02T04:30:02.000','1813','450','2005-08-10T02:51:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10985','2005-08-02T04:30:19.000','2734','186','2005-08-03T05:18:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10986','2005-08-02T04:35:24.000','555','597','2005-08-09T07:34:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10987','2005-08-02T04:36:52.000','968','349','2005-08-04T00:03:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10988','2005-08-02T04:38:17.000','1157','509','2005-08-09T00:09:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10989','2005-08-02T04:40:54.000','2272','7','2005-08-09T03:39:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10990','2005-08-02T04:41:06.000','262','111','2005-08-10T05:02:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10991','2005-08-02T04:41:12.000','2854','77','2005-08-05T05:36:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10992','2005-08-02T04:41:17.000','11','180','2005-08-09T02:13:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10993','2005-08-02T04:45:01.000','292','383','2005-08-04T03:32:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10994','2005-08-02T04:46:53.000','647','323','2005-08-11T10:30:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10995','2005-08-02T04:48:00.000','2891','340','2005-08-07T05:00:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10996','2005-08-02T04:48:11.000','2235','26','2005-08-06T08:00:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10997','2005-08-02T04:49:02.000','300','334','2005-08-10T08:13:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10998','2005-08-02T04:50:55.000','1479','435','2005-08-11T03:43:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('10999','2005-08-02T04:53:13.000','2013','227','2005-08-06T04:36:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11000','2005-08-02T04:56:14.000','264','265','2005-08-07T01:39:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11001','2005-08-02T04:56:45.000','3701','5','2005-08-11T08:04:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11002','2005-08-02T05:02:56.000','3073','583','2005-08-05T07:04:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11003','2005-08-02T05:03:05.000','4301','272','2005-08-05T10:48:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11004','2005-08-02T05:04:18.000','200','45','2005-08-11T00:03:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11005','2005-08-02T05:05:23.000','1547','216','2005-08-07T23:28:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11006','2005-08-02T05:05:52.000','2776','473','2005-08-05T03:33:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11007','2005-08-02T05:05:53.000','4172','98','2005-08-05T01:56:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11008','2005-08-02T05:06:17.000','2831','375','2005-08-10T01:22:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11009','2005-08-02T05:06:23.000','2574','596','2005-08-08T03:02:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11010','2005-08-02T05:06:27.000','869','326','2005-08-03T23:47:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11011','2005-08-02T05:07:07.000','3981','256','2005-08-09T07:16:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11012','2005-08-02T05:09:42.000','542','162','2005-08-05T07:22:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11013','2005-08-02T05:10:54.000','2993','527','2005-08-10T08:59:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11014','2005-08-02T05:12:22.000','393','269','2005-08-07T09:33:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11015','2005-08-02T05:13:00.000','4331','138','2005-08-08T04:18:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11016','2005-08-02T05:19:13.000','4446','116','2005-08-05T05:31:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11017','2005-08-02T05:19:51.000','4140','480','2005-08-09T00:36:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11018','2005-08-02T05:27:53.000','2988','197','2005-08-07T10:48:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11019','2005-08-02T05:29:31.000','3227','112','2005-08-04T00:42:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11020','2005-08-02T05:29:48.000','1645','242','2005-08-06T05:36:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11021','2005-08-02T05:30:11.000','2069','385','2005-08-05T05:50:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11022','2005-08-02T05:35:03.000','827','206','2005-08-09T10:20:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11023','2005-08-02T05:36:38.000','3617','6','2005-08-10T05:39:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11024','2005-08-02T05:38:31.000','2284','427','2005-08-11T04:47:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11025','2005-08-02T05:39:12.000','2253','419','2005-08-08T00:09:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11026','2005-08-02T05:46:05.000','3554','531','2005-08-07T06:27:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11027','2005-08-02T05:47:10.000','571','412','2005-08-05T23:51:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11028','2005-08-02T05:48:20.000','2764','66','2005-08-10T11:21:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11029','2005-08-02T05:51:10.000','1023','45','2005-08-05T04:15:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11030','2005-08-02T05:51:20.000','1437','569','2005-08-06T04:20:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11031','2005-08-02T05:52:58.000','1205','361','2005-08-07T07:14:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11032','2005-08-02T05:53:35.000','1119','359','2005-08-05T02:58:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11033','2005-08-02T05:54:17.000','3323','155','2005-08-09T10:50:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11034','2005-08-02T05:54:53.000','2939','586','2005-08-09T04:14:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11035','2005-08-02T05:55:39.000','3776','305','2005-08-08T06:46:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11036','2005-08-02T05:56:29.000','2054','502','2005-08-05T05:00:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11037','2005-08-02T05:58:12.000','4291','220','2005-08-07T11:26:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11038','2005-08-02T05:59:42.000','4452','403','2005-08-08T04:37:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11039','2005-08-02T06:00:53.000','549','170','2005-08-05T06:19:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11040','2005-08-02T06:03:22.000','2297','223','2005-08-03T07:58:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11041','2005-08-02T06:03:53.000','1897','435','2005-08-03T11:57:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11042','2005-08-02T06:04:33.000','4149','439','2005-08-11T01:30:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11043','2005-08-02T06:04:44.000','65','573','2005-08-06T11:37:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11044','2005-08-02T06:05:27.000','2922','122','2005-08-06T05:15:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11045','2005-08-02T06:07:54.000','2214','402','2005-08-08T00:37:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11046','2005-08-02T06:08:34.000','2105','526','2005-08-06T08:45:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11047','2005-08-02T06:09:20.000','2267','416','2005-08-11T08:36:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11048','2005-08-02T06:15:07.000','206','491','2005-08-04T02:47:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11049','2005-08-02T06:15:40.000','4352','38','2005-08-11T10:09:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11050','2005-08-02T06:17:16.000','2077','234','2005-08-09T05:58:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11051','2005-08-02T06:23:39.000','4189','446','2005-08-06T06:46:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11052','2005-08-02T06:26:19.000','1089','331','2005-08-06T04:20:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11053','2005-08-02T06:27:13.000','2599','50','2005-08-09T11:24:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11054','2005-08-02T06:33:07.000','728','577','2005-08-10T02:52:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11055','2005-08-02T06:36:05.000','3851','182','2005-08-06T00:36:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11056','2005-08-02T06:36:27.000','1404','88','2005-08-10T06:02:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11057','2005-08-02T06:38:19.000','3143','137','2005-08-11T03:43:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11058','2005-08-02T06:38:44.000','3270','274','2005-08-06T06:45:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11059','2005-08-02T06:41:38.000','428','189','2005-08-09T04:34:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11060','2005-08-02T06:48:18.000','3395','496','2005-08-10T11:49:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11061','2005-08-02T06:50:18.000','809','245','2005-08-07T07:41:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11062','2005-08-02T06:52:54.000','2014','346','2005-08-07T10:59:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11063','2005-08-02T06:53:48.000','2261','461','2005-08-05T03:38:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11064','2005-08-02T06:55:17.000','3012','338','2005-08-06T03:29:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11065','2005-08-02T06:57:55.000','2226','357','2005-08-06T01:31:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11066','2005-08-02T06:58:32.000','4213','373','2005-08-10T01:27:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11067','2005-08-02T07:03:24.000','965','85','2005-08-10T08:59:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11068','2005-08-02T07:08:07.000','1262','52','2005-08-09T11:15:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11069','2005-08-02T07:09:34.000','57','4','2005-08-08T08:39:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11070','2005-08-02T07:10:39.000','4020','298','2005-08-03T07:43:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11071','2005-08-02T07:10:53.000','4264','294','2005-08-07T09:58:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11072','2005-08-02T07:10:57.000','3078','21','2005-08-04T07:42:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11073','2005-08-02T07:13:03.000','4232','234','2005-08-03T05:46:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11074','2005-08-02T07:21:43.000','1439','277','2005-08-08T05:18:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11075','2005-08-02T07:24:23.000','3027','503','2005-08-08T04:55:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11076','2005-08-02T07:24:47.000','837','211','2005-08-10T09:16:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11077','2005-08-02T07:26:43.000','4254','158','2005-08-09T10:34:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11078','2005-08-02T07:26:58.000','2362','587','2005-08-07T01:59:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11079','2005-08-02T07:29:10.000','3185','29','2005-08-07T01:59:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11080','2005-08-02T07:29:56.000','4303','571','2005-08-08T05:58:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11081','2005-08-02T07:30:14.000','3804','513','2005-08-09T08:50:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11082','2005-08-02T07:30:19.000','3037','190','2005-08-07T05:20:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11083','2005-08-02T07:32:01.000','4395','295','2005-08-08T02:23:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11084','2005-08-02T07:34:19.000','32','369','2005-08-07T09:30:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11085','2005-08-02T07:36:44.000','3207','276','2005-08-04T03:32:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11086','2005-08-02T07:38:44.000','552','371','2005-08-11T06:30:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11087','2005-08-02T07:41:41.000','654','2','2005-08-10T10:37:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11088','2005-08-02T07:48:31.000','2739','138','2005-08-05T08:09:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11089','2005-08-02T07:52:20.000','825','421','2005-08-07T07:24:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11090','2005-08-02T07:56:40.000','2743','89','2005-08-10T07:58:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11091','2005-08-02T07:56:41.000','1659','423','2005-08-07T05:35:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11092','2005-08-02T07:58:50.000','569','60','2005-08-04T03:23:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11093','2005-08-02T07:59:49.000','239','82','2005-08-11T06:01:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11094','2005-08-02T08:03:02.000','3095','18','2005-08-03T11:34:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11095','2005-08-02T08:03:20.000','3517','278','2005-08-10T05:20:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11096','2005-08-02T08:05:19.000','1436','34','2005-08-04T07:28:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11097','2005-08-02T08:05:46.000','2493','575','2005-08-10T12:00:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11098','2005-08-02T08:06:18.000','158','570','2005-08-11T04:50:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11099','2005-08-02T08:07:12.000','1444','102','2005-08-07T12:11:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11100','2005-08-02T08:08:00.000','3047','65','2005-08-10T07:19:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11101','2005-08-02T08:08:24.000','2621','80','2005-08-06T05:55:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11102','2005-08-02T08:08:30.000','3112','73','2005-08-04T09:16:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11103','2005-08-02T08:09:54.000','1879','158','2005-08-07T12:05:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11104','2005-08-02T08:09:58.000','3042','196','2005-08-05T11:55:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11105','2005-08-02T08:13:31.000','3170','245','2005-08-03T11:08:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11106','2005-08-02T08:17:38.000','2307','287','2005-08-03T07:54:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11107','2005-08-02T08:19:38.000','2217','410','2005-08-07T08:46:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11108','2005-08-02T08:20:01.000','560','447','2005-08-03T13:22:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11109','2005-08-02T08:20:29.000','2683','479','2005-08-09T11:35:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11110','2005-08-02T08:20:31.000','4311','4','2005-08-04T05:06:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11111','2005-08-02T08:21:27.000','334','378','2005-08-06T07:48:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11112','2005-08-02T08:25:14.000','526','207','2005-08-03T08:41:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11113','2005-08-02T08:26:24.000','1654','231','2005-08-07T09:24:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11114','2005-08-02T08:26:45.000','1273','572','2005-08-03T08:41:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11115','2005-08-02T08:31:06.000','3812','408','2005-08-04T02:36:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11116','2005-08-02T08:34:40.000','434','344','2005-08-09T04:56:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11117','2005-08-02T08:36:03.000','1613','474','2005-08-05T06:56:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11118','2005-08-02T08:44:18.000','2411','15','2005-08-05T08:08:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11119','2005-08-02T08:44:44.000','4307','489','2005-08-10T11:32:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11120','2005-08-02T08:47:04.000','4185','322','2005-08-05T05:33:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11121','2005-08-02T08:48:31.000','1025','572','2005-08-04T05:08:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11122','2005-08-02T08:49:09.000','3021','383','2005-08-08T04:33:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11123','2005-08-02T08:54:17.000','1926','150','2005-08-09T11:11:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11124','2005-08-02T08:55:25.000','698','249','2005-08-10T10:59:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11125','2005-08-02T08:55:35.000','2081','237','2005-08-03T09:12:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11126','2005-08-02T08:59:04.000','3310','47','2005-08-04T11:00:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11127','2005-08-02T09:00:59.000','1106','351','2005-08-05T11:54:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11128','2005-08-02T09:03:25.000','3472','386','2005-08-09T04:36:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11129','2005-08-02T09:08:44.000','23','566','2005-08-04T04:00:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11130','2005-08-02T09:08:59.000','684','329','2005-08-09T07:50:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11131','2005-08-02T09:10:04.000','1860','293','2005-08-08T09:59:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11132','2005-08-02T09:14:09.000','2212','398','2005-08-08T06:39:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11133','2005-08-02T09:15:45.000','675','120','2005-08-04T10:39:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11134','2005-08-02T09:19:22.000','2641','372','2005-08-11T03:56:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11135','2005-08-02T09:22:25.000','799','32','2005-08-04T14:30:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11136','2005-08-02T09:22:57.000','1315','559','2005-08-08T14:12:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11137','2005-08-02T09:25:31.000','2500','310','2005-08-08T08:10:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11138','2005-08-02T09:26:16.000','4250','458','2005-08-11T07:50:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11139','2005-08-02T09:27:36.000','1011','236','2005-08-08T14:07:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11140','2005-08-02T09:27:45.000','3836','132','2005-08-05T04:10:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11141','2005-08-02T09:29:11.000','1614','15','2005-08-04T07:50:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11142','2005-08-02T09:30:11.000','2954','306','2005-08-05T06:52:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11143','2005-08-02T09:32:54.000','3382','100','2005-08-05T12:04:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11144','2005-08-02T09:39:17.000','2724','376','2005-08-03T11:53:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11145','2005-08-02T09:43:24.000','1270','291','2005-08-05T15:29:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11146','2005-08-02T09:45:32.000','2488','552','2005-08-07T07:33:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11147','2005-08-02T09:45:54.000','1562','597','2005-08-07T07:28:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11148','2005-08-02T09:47:08.000','2991','230','2005-08-08T10:57:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11149','2005-08-02T09:51:43.000','3254','358','2005-08-11T09:40:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11150','2005-08-02T09:51:46.000','2193','527','2005-08-05T09:03:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11151','2005-08-02T09:52:44.000','3939','391','2005-08-05T06:29:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11152','2005-08-02T09:53:36.000','3887','494','2005-08-11T14:58:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11153','2005-08-02T09:54:19.000','1546','220','2005-08-10T14:57:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11154','2005-08-02T09:54:50.000','697','160','2005-08-06T14:48:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11155','2005-08-02T09:55:28.000','2001','73','2005-08-03T06:00:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11156','2005-08-02T09:56:06.000','907','465','2005-08-04T13:36:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11157','2005-08-02T09:58:15.000','1313','244','2005-08-06T04:23:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11158','2005-08-02T09:58:28.000','530','190','2005-08-10T13:54:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11159','2005-08-02T10:00:55.000','4575','249','2005-08-05T10:38:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11160','2005-08-02T10:05:30.000','3260','436','2005-08-07T08:30:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11161','2005-08-02T10:05:57.000','3321','503','2005-08-06T05:05:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11162','2005-08-02T10:07:54.000','1809','277','2005-08-05T11:35:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11163','2005-08-02T10:08:40.000','1925','505','2005-08-05T14:59:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11164','2005-08-02T10:10:56.000','4450','580','2005-08-10T11:20:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11165','2005-08-02T10:12:17.000','2059','513','2005-08-04T11:09:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11166','2005-08-02T10:14:58.000','638','11','2005-08-11T11:43:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11167','2005-08-02T10:15:51.000','148','451','2005-08-09T09:18:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11168','2005-08-02T10:19:42.000','468','555','2005-08-04T08:42:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11169','2005-08-02T10:19:42.000','2392','329','2005-08-07T05:45:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11170','2005-08-02T10:21:53.000','1333','547','2005-08-08T11:08:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11171','2005-08-02T10:23:41.000','3117','339','2005-08-04T14:22:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11172','2005-08-02T10:27:52.000','1207','76','2005-08-11T12:47:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11173','2005-08-02T10:28:00.000','4296','146','2005-08-10T14:53:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11174','2005-08-02T10:32:11.000','1551','328','2005-08-09T12:30:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11175','2005-08-02T10:38:47.000','85','164','2005-08-07T07:11:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11176','2005-08-02T10:39:43.000','1448','37','2005-08-09T14:42:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11177','2005-08-02T10:43:48.000','1149','2','2005-08-10T10:55:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11178','2005-08-02T10:48:10.000','2613','342','2005-08-06T06:07:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11179','2005-08-02T10:50:06.000','4376','5','2005-08-04T05:24:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11180','2005-08-02T10:54:30.000','3632','534','2005-08-11T15:55:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11181','2005-08-02T10:55:03.000','3127','557','2005-08-07T10:43:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11182','2005-08-02T10:55:14.000','605','54','2005-08-06T05:58:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11183','2005-08-02T11:00:32.000','833','102','2005-08-04T08:59:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11184','2005-08-02T11:01:26.000','871','259','2005-08-11T06:29:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11185','2005-08-02T11:04:35.000','1215','469','2005-08-05T13:48:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11186','2005-08-02T11:12:08.000','733','353','2005-08-03T10:46:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11187','2005-08-02T11:16:19.000','3626','410','2005-08-11T06:11:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11188','2005-08-02T11:17:11.000','1372','485','2005-08-08T16:46:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11189','2005-08-02T11:17:23.000','729','565','2005-08-09T16:30:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11190','2005-08-02T11:21:34.000','922','254','2005-08-05T05:23:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11191','2005-08-02T11:24:07.000','1097','571','2005-08-10T10:39:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11192','2005-08-02T11:29:41.000','1998','349','2005-08-07T06:01:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11193','2005-08-02T11:31:33.000','2246','292','2005-08-04T14:00:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11194','2005-08-02T11:35:53.000','2732','135','2005-08-10T11:28:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11195','2005-08-02T11:42:23.000','4359','177','2005-08-03T08:29:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11196','2005-08-02T11:42:40.000','2648','126','2005-08-10T11:58:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11197','2005-08-02T11:45:07.000','3041','122','2005-08-03T09:07:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11198','2005-08-02T11:45:15.000','2908','540','2005-08-10T11:42:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11199','2005-08-02T11:47:40.000','3926','578','2005-08-10T06:52:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11200','2005-08-02T11:48:36.000','2730','98','2005-08-07T08:35:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11201','2005-08-02T11:49:16.000','1501','195','2005-08-11T08:39:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11202','2005-08-02T11:51:57.000','3625','231','2005-08-08T09:41:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11203','2005-08-02T11:52:41.000','4520','92','2005-08-10T15:52:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11204','2005-08-02T11:56:31.000','3578','247','2005-08-06T14:16:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11205','2005-08-02T11:56:54.000','4321','552','2005-08-05T08:24:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11206','2005-08-02T11:58:03.000','4131','72','2005-08-07T12:36:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11207','2005-08-02T12:01:30.000','4470','481','2005-08-05T07:56:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11208','2005-08-02T12:02:37.000','4566','320','2005-08-05T10:56:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11209','2005-08-02T12:09:45.000','3219','24','2005-08-07T08:52:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11210','2005-08-02T12:15:54.000','422','202','2005-08-04T16:18:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11211','2005-08-02T12:16:48.000','1722','245','2005-08-03T10:40:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11212','2005-08-02T12:18:29.000','4007','343','2005-08-05T16:05:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11213','2005-08-02T12:18:35.000','1007','584','2005-08-05T08:44:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11214','2005-08-02T12:19:50.000','2722','407','2005-08-11T06:38:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11215','2005-08-02T12:20:42.000','379','197','2005-08-06T14:01:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11216','2005-08-02T12:23:43.000','1109','473','2005-08-03T13:19:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11217','2005-08-02T12:26:31.000','1201','417','2005-08-09T09:53:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11218','2005-08-02T12:29:12.000','1126','500','2005-08-10T16:13:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11219','2005-08-02T12:30:20.000','2889','461','2005-08-08T13:42:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11220','2005-08-02T12:31:41.000','3777','84','2005-08-05T08:23:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11221','2005-08-02T12:32:12.000','1689','146','2005-08-03T17:13:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11222','2005-08-02T12:32:28.000','1780','407','2005-08-11T18:15:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11223','2005-08-02T12:34:27.000','1994','597','2005-08-07T14:21:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11224','2005-08-02T12:40:38.000','3938','181','2005-08-04T10:02:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11225','2005-08-02T12:43:27.000','3721','159','2005-08-04T18:41:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11226','2005-08-02T12:47:30.000','79','282','2005-08-06T11:24:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11227','2005-08-02T12:48:05.000','1101','65','2005-08-11T14:08:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11228','2005-08-02T12:55:23.000','2561','144','2005-08-08T12:31:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11229','2005-08-02T12:56:37.000','941','332','2005-08-11T11:13:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11230','2005-08-02T12:59:08.000','1463','257','2005-08-04T13:42:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11231','2005-08-02T13:02:11.000','1100','90','2005-08-07T10:05:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11232','2005-08-02T13:04:12.000','971','8','2005-08-10T15:39:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11233','2005-08-02T13:06:11.000','2221','266','2005-08-08T15:02:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11234','2005-08-02T13:12:17.000','1020','27','2005-08-05T17:37:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11235','2005-08-02T13:13:21.000','2501','127','2005-08-03T07:17:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11236','2005-08-02T13:17:21.000','145','420','2005-08-09T09:53:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11237','2005-08-02T13:24:01.000','2668','426','2005-08-05T11:41:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11238','2005-08-02T13:25:50.000','2705','506','2005-08-08T19:12:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11239','2005-08-02T13:27:11.000','189','111','2005-08-03T14:36:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11240','2005-08-02T13:28:30.000','2170','597','2005-08-05T11:40:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11241','2005-08-02T13:29:24.000','3657','543','2005-08-11T11:36:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11242','2005-08-02T13:32:00.000','1041','434','2005-08-10T19:24:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11243','2005-08-02T13:32:48.000','2517','361','2005-08-11T18:55:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11244','2005-08-02T13:33:24.000','3423','142','2005-08-10T10:18:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11245','2005-08-02T13:33:50.000','2609','92','2005-08-04T10:20:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11246','2005-08-02T13:33:56.000','3577','550','2005-08-03T08:52:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11247','2005-08-02T13:34:08.000','1661','441','2005-08-06T16:23:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11248','2005-08-02T13:35:34.000','4139','312','2005-08-03T10:37:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11249','2005-08-02T13:35:40.000','3394','157','2005-08-07T11:22:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11250','2005-08-02T13:35:42.000','2223','279','2005-08-10T12:32:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11251','2005-08-02T13:40:49.000','2181','532','2005-08-09T14:16:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11252','2005-08-02T13:42:13.000','2410','337','2005-08-06T19:04:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11253','2005-08-02T13:42:44.000','2898','303','2005-08-09T17:06:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11254','2005-08-02T13:43:49.000','56','315','2005-08-08T13:16:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11255','2005-08-02T13:44:30.000','3393','569','2005-08-03T12:00:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11256','2005-08-02T13:44:53.000','2060','2','2005-08-04T16:39:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11257','2005-08-02T13:45:05.000','105','468','2005-08-11T16:37:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11258','2005-08-02T13:45:39.000','1576','242','2005-08-06T07:57:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11259','2005-08-02T13:46:30.000','896','330','2005-08-07T14:03:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11260','2005-08-02T13:52:19.000','4015','207','2005-08-06T08:13:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11261','2005-08-02T13:54:26.000','31','204','2005-08-10T19:04:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11262','2005-08-02T13:58:55.000','71','348','2005-08-05T18:09:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11263','2005-08-02T14:02:19.000','1189','421','2005-08-07T14:03:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11264','2005-08-02T14:05:18.000','3420','360','2005-08-10T08:46:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11265','2005-08-02T14:05:42.000','3870','531','2005-08-11T15:27:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11266','2005-08-02T14:07:35.000','3972','99','2005-08-04T13:31:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11267','2005-08-02T14:09:08.000','2045','244','2005-08-10T12:33:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11268','2005-08-02T14:10:39.000','3275','558','2005-08-04T14:35:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11269','2005-08-02T14:11:41.000','2398','297','2005-08-08T18:53:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11270','2005-08-02T14:18:07.000','1882','418','2005-08-03T08:20:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11271','2005-08-02T14:18:22.000','4323','93','2005-08-07T09:35:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11272','2005-08-02T14:20:27.000','4111','158','2005-08-07T12:24:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11273','2005-08-02T14:20:55.000','3383','541','2005-08-07T12:57:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11274','2005-08-02T14:24:08.000','1253','70','2005-08-11T14:56:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11275','2005-08-02T14:25:58.000','2838','464','2005-08-07T11:20:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11276','2005-08-02T14:28:46.000','4226','190','2005-08-04T14:00:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11277','2005-08-02T14:28:50.000','2050','68','2005-08-04T13:50:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11278','2005-08-02T14:29:43.000','961','143','2005-08-07T10:13:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11279','2005-08-02T14:30:03.000','151','125','2005-08-10T09:49:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11280','2005-08-02T14:34:33.000','1846','134','2005-08-08T15:40:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11281','2005-08-02T14:35:01.000','2210','137','2005-08-07T17:28:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11282','2005-08-02T14:35:03.000','1824','273','2005-08-03T16:02:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11283','2005-08-02T14:39:46.000','312','134','2005-08-05T10:19:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11284','2005-08-02T14:42:45.000','172','8','2005-08-04T11:55:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11285','2005-08-02T14:44:02.000','3849','585','2005-08-11T16:45:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11286','2005-08-02T14:44:22.000','1319','207','2005-08-10T09:01:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11287','2005-08-02T14:49:51.000','927','55','2005-08-09T09:19:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11288','2005-08-02T14:54:08.000','1478','298','2005-08-11T12:22:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11289','2005-08-02T14:55:00.000','2869','10','2005-08-11T13:57:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11290','2005-08-02T14:57:44.000','425','582','2005-08-09T19:36:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11291','2005-08-02T14:57:58.000','491','417','2005-08-11T09:04:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11292','2005-08-02T14:58:41.000','210','13','2005-08-06T14:38:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11293','2005-08-02T15:00:43.000','1514','475','2005-08-11T17:49:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11294','2005-08-02T15:08:27.000','855','411','2005-08-03T18:28:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11295','2005-08-02T15:10:06.000','423','67','2005-08-10T09:52:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11296','2005-08-02T15:15:27.000','247','154','2005-08-11T16:12:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11297','2005-08-02T15:22:47.000','2531','62','2005-08-11T18:45:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11298','2005-08-02T15:32:32.000','1663','35','2005-08-06T20:22:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11299','2005-08-02T15:36:52.000','3232','1','2005-08-10T16:40:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11300','2005-08-02T15:37:42.000','3032','552','2005-08-11T14:25:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11301','2005-08-02T15:37:59.000','676','502','2005-08-04T10:57:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11302','2005-08-02T15:38:03.000','1918','51','2005-08-09T10:33:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11303','2005-08-02T15:39:18.000','1817','417','2005-08-05T10:59:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11304','2005-08-02T15:40:10.000','2592','413','2005-08-06T16:12:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11305','2005-08-02T15:44:55.000','1690','341','2005-08-08T16:42:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11306','2005-08-02T15:45:10.000','13','247','2005-08-03T21:14:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11307','2005-08-02T15:48:08.000','1490','15','2005-08-06T20:33:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11308','2005-08-02T15:50:44.000','699','16','2005-08-05T11:38:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11309','2005-08-02T15:50:55.000','607','275','2005-08-09T18:28:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11310','2005-08-02T15:51:58.000','3601','415','2005-08-07T12:34:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11311','2005-08-02T15:53:48.000','204','197','2005-08-03T16:32:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11312','2005-08-02T15:56:51.000','1093','190','2005-08-07T20:56:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11313','2005-08-02T16:02:51.000','2689','419','2005-08-03T14:54:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11314','2005-08-02T16:04:08.000','2790','26','2005-08-04T18:47:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11315','2005-08-02T16:05:17.000','1116','13','2005-08-05T16:33:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11316','2005-08-02T16:07:49.000','521','108','2005-08-10T13:22:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11317','2005-08-02T16:08:52.000','1889','502','2005-08-08T21:12:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11318','2005-08-02T16:09:11.000','2386','532','2005-08-07T11:28:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11319','2005-08-02T16:10:09.000','4069','178','2005-08-09T11:21:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11320','2005-08-02T16:13:28.000','3362','550','2005-08-05T21:23:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11321','2005-08-02T16:15:07.000','205','266','2005-08-04T20:35:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11322','2005-08-02T16:23:17.000','761','418','2005-08-09T19:55:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11323','2005-08-02T16:29:57.000','3784','419','2005-08-06T16:01:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11324','2005-08-02T16:31:17.000','2900','540','2005-08-08T15:38:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11325','2005-08-02T16:33:11.000','4514','422','2005-08-08T13:42:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11326','2005-08-02T16:34:29.000','1762','530','2005-08-03T17:40:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11327','2005-08-02T16:40:47.000','773','361','2005-08-03T22:13:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11328','2005-08-02T16:42:38.000','2031','219','2005-08-04T21:02:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11329','2005-08-02T16:42:52.000','2677','399','2005-08-08T16:45:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11330','2005-08-02T16:45:33.000','4326','75','2005-08-04T15:15:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11331','2005-08-02T16:49:01.000','3789','568','2005-08-09T19:15:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11332','2005-08-02T16:52:57.000','2381','467','2005-08-04T14:13:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11333','2005-08-02T16:53:00.000','3335','225','2005-08-07T20:49:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11334','2005-08-02T16:53:20.000','1504','560','2005-08-11T20:47:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11335','2005-08-02T16:57:37.000','2968','157','2005-08-09T19:43:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11336','2005-08-02T16:58:56.000','1949','473','2005-08-06T16:56:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11337','2005-08-02T16:59:09.000','3428','366','2005-08-10T20:41:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11338','2005-08-02T17:00:12.000','3689','26','2005-08-03T18:54:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11339','2005-08-02T17:02:06.000','705','263','2005-08-08T21:12:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11340','2005-08-02T17:05:43.000','1403','366','2005-08-09T13:25:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11341','2005-08-02T17:09:24.000','3586','15','2005-08-09T19:48:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11342','2005-08-02T17:11:35.000','4251','179','2005-08-07T15:04:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11343','2005-08-02T17:12:30.000','564','466','2005-08-09T12:08:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11344','2005-08-02T17:13:26.000','365','38','2005-08-07T16:44:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11345','2005-08-02T17:14:19.000','1895','405','2005-08-11T14:02:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11346','2005-08-02T17:15:38.000','584','100','2005-08-04T13:31:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11347','2005-08-02T17:18:07.000','195','217','2005-08-05T12:30:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11348','2005-08-02T17:18:38.000','1704','389','2005-08-06T16:11:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11349','2005-08-02T17:21:49.000','1871','73','2005-08-06T18:40:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11350','2005-08-02T17:22:59.000','1265','598','2005-08-09T19:56:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11351','2005-08-02T17:28:07.000','242','198','2005-08-09T21:55:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11352','2005-08-02T17:29:39.000','2760','546','2005-08-10T15:31:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11353','2005-08-02T17:34:45.000','1729','444','2005-08-09T16:01:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11354','2005-08-02T17:35:10.000','1887','569','2005-08-09T12:07:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11355','2005-08-02T17:37:43.000','2673','185','2005-08-05T19:59:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11356','2005-08-02T17:42:40.000','303','200','2005-08-11T23:29:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11357','2005-08-02T17:42:49.000','2644','148','2005-08-11T18:14:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11358','2005-08-02T17:45:02.000','2361','56','2005-08-11T18:16:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11359','2005-08-02T17:45:55.000','1648','466','2005-08-10T20:53:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11360','2005-08-02T17:46:04.000','1750','66','2005-08-04T21:02:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11361','2005-08-02T17:46:34.000','1124','547','2005-08-03T15:21:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11362','2005-08-02T17:47:25.000','2628','331','2005-08-07T20:14:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11363','2005-08-02T17:48:39.000','3190','274','2005-08-05T17:20:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11364','2005-08-02T17:53:36.000','4515','44','2005-08-03T14:16:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11365','2005-08-02T18:00:09.000','1151','508','2005-08-04T13:40:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11366','2005-08-02T18:01:25.000','3583','280','2005-08-11T15:02:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11367','2005-08-02T18:01:38.000','1440','1','2005-08-04T13:19:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11368','2005-08-02T18:03:05.000','866','153','2005-08-07T20:40:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11369','2005-08-02T18:04:41.000','2480','480','2005-08-09T18:41:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11370','2005-08-02T18:06:01.000','3077','146','2005-08-04T15:10:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11371','2005-08-02T18:07:36.000','324','561','2005-08-06T17:52:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11372','2005-08-02T18:10:50.000','796','327','2005-08-07T17:58:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11373','2005-08-02T18:14:12.000','181','267','2005-08-06T23:37:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11374','2005-08-02T18:14:54.000','2805','424','2005-08-04T18:22:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11375','2005-08-02T18:14:56.000','1064','346','2005-08-08T23:29:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11376','2005-08-02T18:16:00.000','2530','177','2005-08-11T23:38:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11377','2005-08-02T18:16:47.000','3334','119','2005-08-08T13:46:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11378','2005-08-02T18:16:52.000','3824','188','2005-08-03T14:25:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11379','2005-08-02T18:16:55.000','251','61','2005-08-07T18:12:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11380','2005-08-02T18:17:32.000','1046','551','2005-08-03T19:26:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11381','2005-08-02T18:19:29.000','993','451','2005-08-08T20:39:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11382','2005-08-02T18:20:52.000','3848','407','2005-08-07T17:06:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11383','2005-08-02T18:22:05.000','257','445','2005-08-11T17:18:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11384','2005-08-02T18:23:01.000','2840','225','2005-08-05T17:59:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11385','2005-08-02T18:23:11.000','2478','192','2005-08-06T12:37:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11386','2005-08-02T18:24:03.000','519','183','2005-08-06T21:22:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11387','2005-08-02T18:32:38.000','2491','481','2005-08-07T19:08:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11388','2005-08-02T18:35:55.000','477','369','2005-08-09T21:56:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11389','2005-08-02T18:39:12.000','3267','270','2005-08-03T23:23:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11390','2005-08-02T18:39:16.000','3135','294','2005-08-04T21:43:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11391','2005-08-02T18:40:12.000','2039','403','2005-08-10T15:55:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11392','2005-08-02T18:41:11.000','261','146','2005-08-11T21:41:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11393','2005-08-02T18:44:29.000','1033','501','2005-08-11T23:58:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11394','2005-08-02T18:44:45.000','2087','257','2005-08-06T22:51:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11395','2005-08-02T18:47:44.000','4234','225','2005-08-10T17:07:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11396','2005-08-02T18:48:29.000','1155','59','2005-08-04T16:05:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11397','2005-08-02T18:53:14.000','2566','470','2005-08-09T18:09:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11398','2005-08-02T18:55:15.000','3952','6','2005-08-10T19:50:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11399','2005-08-02T18:56:28.000','2094','565','2005-08-11T23:19:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11400','2005-08-02T19:00:52.000','3150','9','2005-08-09T19:45:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11401','2005-08-02T19:05:06.000','1799','544','2005-08-09T22:34:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11402','2005-08-02T19:07:21.000','3291','561','2005-08-07T20:59:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11403','2005-08-02T19:10:21.000','4072','587','2005-08-04T00:44:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11404','2005-08-02T19:12:40.000','3285','60','2005-08-11T22:38:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11405','2005-08-02T19:13:39.000','418','10','2005-08-07T19:19:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11406','2005-08-02T19:16:10.000','2502','525','2005-08-04T20:51:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11407','2005-08-02T19:18:43.000','3437','513','2005-08-08T16:15:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11408','2005-08-02T19:25:13.000','1779','83','2005-08-06T17:12:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11409','2005-08-02T19:26:51.000','3691','418','2005-08-07T19:55:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11410','2005-08-02T19:29:01.000','692','592','2005-08-11T16:50:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11411','2005-08-02T19:29:47.000','1497','141','2005-08-09T16:27:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11412','2005-08-02T19:32:51.000','2271','141','2005-08-11T22:16:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11413','2005-08-02T19:35:19.000','1115','297','2005-08-05T21:33:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11414','2005-08-02T19:43:07.000','1772','353','2005-08-07T15:22:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11415','2005-08-02T19:43:38.000','2197','572','2005-08-10T15:13:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11416','2005-08-02T19:44:04.000','1848','58','2005-08-11T15:30:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11417','2005-08-02T19:44:46.000','3083','437','2005-08-11T21:43:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11418','2005-08-02T19:45:33.000','4490','91','2005-08-06T17:40:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11419','2005-08-02T19:46:38.000','514','444','2005-08-11T14:49:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11420','2005-08-02T19:47:56.000','3928','158','2005-08-05T21:48:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11421','2005-08-02T19:51:53.000','3361','473','2005-08-12T00:50:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11422','2005-08-02T19:52:08.000','342','72','2005-08-11T18:40:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11423','2005-08-02T19:57:13.000','3431','241','2005-08-06T00:54:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11424','2005-08-02T19:57:42.000','1030','84','2005-08-10T16:57:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11425','2005-08-02T19:58:48.000','989','419','2005-08-03T19:30:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11426','2005-08-02T20:00:09.000','130','572','2005-08-09T01:30:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11427','2005-08-02T20:02:39.000','3287','403','2005-08-04T22:26:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11428','2005-08-02T20:03:10.000','722','326','2005-08-04T01:55:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11429','2005-08-02T20:03:52.000','1098','348','2005-08-10T16:38:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11430','2005-08-02T20:04:36.000','2258','140','2005-08-08T19:43:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11431','2005-08-02T20:05:16.000','1409','271','2005-08-04T00:05:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11432','2005-08-02T20:10:01.000','959','540','2005-08-07T01:28:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11433','2005-08-02T20:13:10.000','1','518','2005-08-11T21:35:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11434','2005-08-02T20:13:14.000','3154','391','2005-08-05T15:01:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11435','2005-08-02T20:14:23.000','1625','502','2005-08-05T20:40:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11436','2005-08-02T20:16:06.000','3834','106','2005-08-05T20:40:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11437','2005-08-02T20:20:06.000','2679','225','2005-08-05T22:17:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11438','2005-08-02T20:21:08.000','1040','372','2005-08-10T22:12:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11439','2005-08-02T20:22:45.000','2897','18','2005-08-04T18:30:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11440','2005-08-02T20:24:02.000','2727','306','2005-08-07T16:42:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11441','2005-08-02T20:25:41.000','1027','389','2005-08-05T00:05:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11442','2005-08-02T20:26:19.000','2598','208','2005-08-07T00:33:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11443','2005-08-02T20:29:30.000','1291','581','2005-08-07T01:08:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11444','2005-08-02T20:32:55.000','1419','28','2005-08-08T23:21:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11445','2005-08-02T20:33:35.000','3340','108','2005-08-08T16:02:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11446','2005-08-02T20:33:37.000','748','342','2005-08-03T18:22:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11447','2005-08-02T20:36:25.000','3868','508','2005-08-07T18:52:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11448','2005-08-02T20:44:33.000','1185','496','2005-08-05T22:58:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11449','2005-08-02T20:44:43.000','3279','443','2005-08-07T23:47:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11450','2005-08-02T20:45:54.000','2009','214','2005-08-08T17:17:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11451','2005-08-02T20:45:56.000','776','515','2005-08-06T21:42:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11452','2005-08-02T20:59:52.000','1245','35','2005-08-12T01:16:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11453','2005-08-02T21:00:05.000','4578','84','2005-08-08T22:03:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11454','2005-08-02T21:04:39.000','2901','199','2005-08-05T19:03:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11455','2005-08-02T21:07:06.000','2000','498','2005-08-12T01:21:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11456','2005-08-02T21:14:04.000','3638','322','2005-08-07T19:49:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11457','2005-08-02T21:14:16.000','1642','379','2005-08-10T02:39:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11458','2005-08-02T21:24:02.000','3514','575','2005-08-04T01:32:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11459','2005-08-02T21:25:25.000','3730','392','2005-08-04T19:57:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11460','2005-08-02T21:28:03.000','4113','403','2005-08-08T18:24:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11461','2005-08-02T21:35:00.000','4343','65','2005-08-05T01:34:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11462','2005-08-02T21:36:46.000','167','268','2005-08-10T01:48:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11463','2005-08-02T21:37:36.000','1944','138','2005-08-08T03:11:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11464','2005-08-02T21:42:07.000','538','577','2005-08-03T21:44:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11465','2005-08-02T21:43:52.000','2190','447','2005-08-10T22:24:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11466','2005-08-02T21:46:46.000','3363','556','2005-08-06T01:42:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11467','2005-08-02T21:47:07.000','246','117','2005-08-09T00:50:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11468','2005-08-02T21:47:26.000','3168','413','2005-08-05T02:30:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11469','2005-08-02T21:48:09.000','230','77','2005-08-06T18:37:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11470','2005-08-02T21:48:28.000','2379','346','2005-08-05T23:58:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11471','2005-08-02T21:49:03.000','3378','355','2005-08-08T00:17:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11472','2005-08-02T21:49:06.000','1829','410','2005-08-11T20:17:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11473','2005-08-02T21:52:03.000','620','536','2005-08-09T02:01:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11474','2005-08-02T21:53:08.000','574','214','2005-08-05T22:36:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11475','2005-08-02T21:55:09.000','3687','194','2005-08-09T20:28:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11476','2005-08-02T22:03:47.000','724','144','2005-08-09T02:19:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11477','2005-08-02T22:09:01.000','1671','47','2005-08-07T03:46:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11478','2005-08-02T22:09:05.000','3932','197','2005-08-04T18:02:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11479','2005-08-02T22:18:13.000','4077','237','2005-08-12T00:43:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11480','2005-08-02T22:18:24.000','4161','14','2005-08-04T21:22:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11481','2005-08-02T22:18:41.000','4028','234','2005-08-09T23:43:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11482','2005-08-02T22:24:31.000','1400','134','2005-08-04T01:48:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11483','2005-08-02T22:28:22.000','1586','45','2005-08-11T18:06:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11484','2005-08-02T22:28:23.000','330','165','2005-08-04T20:51:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11485','2005-08-02T22:33:25.000','1872','326','2005-08-04T23:26:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11486','2005-08-02T22:34:06.000','1610','236','2005-08-09T00:46:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11487','2005-08-02T22:35:05.000','734','239','2005-08-08T00:54:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11488','2005-08-02T22:35:15.000','2520','45','2005-08-09T00:28:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11489','2005-08-02T22:35:28.000','3001','474','2005-08-04T00:29:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11490','2005-08-02T22:36:00.000','1178','156','2005-08-09T16:36:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11491','2005-08-02T22:44:50.000','268','307','2005-08-11T01:55:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11492','2005-08-02T22:46:47.000','4037','349','2005-08-09T19:54:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11493','2005-08-02T22:47:00.000','3375','124','2005-08-10T20:53:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11494','2005-08-02T22:51:23.000','3994','579','2005-08-09T01:52:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11495','2005-08-16T22:51:20.000','1265','247','2005-08-23T00:44:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11496','2006-02-14T15:16:03.000','2047','155',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11497','2005-08-16T22:52:30.000','436','12','2005-08-21T19:52:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11498','2005-08-16T22:52:54.000','487','482','2005-08-25T03:27:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11499','2005-08-16T22:54:12.000','3857','172','2005-08-24T03:37:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11500','2005-08-16T23:01:22.000','4003','584','2005-08-24T22:54:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11501','2005-08-16T23:04:53.000','2147','23','2005-08-19T20:57:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11502','2005-08-16T23:06:30.000','4470','11','2005-08-19T03:49:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11503','2005-08-16T23:10:34.000','1496','526','2005-08-25T03:55:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11504','2005-08-16T23:16:46.000','2132','350','2005-08-18T20:49:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11505','2005-08-16T23:18:47.000','3344','34','2005-08-23T19:52:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11506','2005-08-16T23:25:48.000','1529','565','2005-08-22T18:17:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11507','2005-08-16T23:26:43.000','4197','236','2005-08-24T22:48:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11508','2005-08-16T23:27:36.000','2688','19','2005-08-25T01:34:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11509','2005-08-16T23:29:53.000','2750','273','2005-08-19T02:09:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11510','2005-08-16T23:30:07.000','2997','400','2005-08-25T17:35:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11511','2005-08-16T23:39:59.000','2127','397','2005-08-18T18:04:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11512','2005-08-16T23:51:06.000','1248','373','2005-08-26T02:06:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11513','2005-08-16T23:51:33.000','4473','499','2005-08-24T01:37:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11514','2005-08-16T23:53:10.000','4240','423','2005-08-23T22:04:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11515','2005-08-16T23:54:34.000','1053','279','2005-08-21T19:00:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11516','2005-08-16T23:54:47.000','1860','90','2005-08-17T20:05:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11517','2005-08-16T23:56:28.000','4266','280','2005-08-21T22:40:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11518','2005-08-16T23:59:49.000','3297','407','2005-08-17T22:51:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11519','2005-08-17T00:01:27.000','1034','381','2005-08-19T04:54:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11520','2005-08-17T00:04:28.000','3536','119','2005-08-26T02:03:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11521','2005-08-17T00:04:54.000','463','229','2005-08-21T00:57:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11522','2005-08-17T00:05:05.000','2033','599','2005-08-24T04:56:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11523','2005-08-17T00:10:10.000','1329','421','2005-08-24T22:39:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11524','2005-08-17T00:10:55.000','317','533','2005-08-23T05:30:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11525','2005-08-17T00:15:31.000','1107','174','2005-08-20T21:14:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11526','2005-08-17T00:17:38.000','2419','572','2005-08-18T03:59:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11527','2005-08-17T00:25:06.000','162','264','2005-08-22T21:13:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11528','2005-08-17T00:27:23.000','893','14','2005-08-22T06:12:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11529','2005-08-17T00:28:01.000','3071','4','2005-08-19T04:47:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11530','2005-08-17T00:29:00.000','365','400','2005-08-22T03:22:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11531','2005-08-17T00:30:04.000','1817','278','2005-08-20T01:12:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11532','2005-08-17T00:34:14.000','1947','413','2005-08-22T19:37:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11533','2005-08-17T00:34:53.000','4252','264','2005-08-22T06:10:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11534','2005-08-17T00:35:27.000','2414','144','2005-08-24T01:36:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11535','2005-08-17T00:39:54.000','1649','356','2005-08-24T20:46:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11536','2005-08-17T00:40:03.000','2735','428','2005-08-21T19:11:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11537','2005-08-17T00:41:08.000','190','474','2005-08-19T00:25:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11538','2005-08-17T00:44:04.000','554','431','2005-08-18T03:43:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11539','2005-08-17T00:45:41.000','2064','264','2005-08-19T06:03:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11540','2005-08-17T00:48:03.000','3385','370','2005-08-25T03:46:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11541','2006-02-14T15:16:03.000','2026','335',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11542','2005-08-17T00:51:32.000','2155','7','2005-08-24T20:29:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11543','2005-08-17T00:54:28.000','2860','238','2005-08-25T04:31:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11544','2005-08-17T00:55:07.000','836','439','2005-08-22T19:25:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11545','2005-08-17T00:56:06.000','3198','257','2005-08-25T22:47:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11546','2005-08-17T00:57:36.000','2522','24','2005-08-18T23:16:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11547','2005-08-17T00:59:24.000','737','114','2005-08-20T04:03:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11548','2005-08-17T00:59:47.000','480','323','2005-08-22T05:09:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11549','2005-08-17T01:01:48.000','945','402','2005-08-19T21:24:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11550','2005-08-17T01:02:06.000','2972','339','2005-08-22T21:44:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11551','2005-08-17T01:03:49.000','3356','168','2005-08-18T22:31:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11552','2005-08-17T01:04:29.000','1143','230','2005-08-23T23:07:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11553','2005-08-17T01:04:31.000','3317','360','2005-08-24T00:44:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11554','2005-08-17T01:05:17.000','2212','460','2005-08-20T06:20:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11555','2005-08-17T01:08:59.000','2569','372','2005-08-18T06:09:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11556','2005-08-17T01:11:53.000','373','9','2005-08-18T23:41:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11557','2005-08-17T01:19:20.000','2376','416','2005-08-24T02:25:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11558','2005-08-17T01:19:52.000','1681','403','2005-08-19T00:47:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11559','2005-08-17T01:20:26.000','1812','385','2005-08-24T03:11:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11560','2005-08-17T01:20:30.000','2316','320','2005-08-18T04:29:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11561','2005-08-17T01:23:09.000','189','149','2005-08-23T21:02:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11562','2005-08-17T01:23:39.000','2992','424','2005-08-26T06:16:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11563','2006-02-14T15:16:03.000','1545','83',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11564','2005-08-17T01:27:49.000','2237','332','2005-08-19T22:07:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11565','2005-08-17T01:28:05.000','173','83','2005-08-23T23:33:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11566','2005-08-17T01:28:35.000','4020','520','2005-08-20T22:42:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11567','2005-08-17T01:28:43.000','567','558','2005-08-24T20:20:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11568','2005-08-17T01:30:01.000','183','342','2005-08-18T22:21:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11569','2005-08-17T01:31:04.000','2592','504','2005-08-24T03:36:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11570','2005-08-17T01:34:32.000','2466','343','2005-08-24T05:47:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11571','2005-08-17T01:37:51.000','203','296','2005-08-17T20:30:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11572','2005-08-17T01:37:55.000','3512','515','2005-08-19T06:22:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11573','2005-08-17T01:38:18.000','639','146','2005-08-19T05:06:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11574','2005-08-17T01:38:19.000','3596','277','2005-08-18T20:30:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11575','2005-08-17T01:50:26.000','1725','319','2005-08-18T00:43:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11576','2005-08-17T01:53:20.000','327','293','2005-08-19T00:15:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11577','2006-02-14T15:16:03.000','4106','219',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11578','2005-08-17T01:54:13.000','192','590','2005-08-26T02:00:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11579','2005-08-17T01:57:49.000','4256','356','2005-08-22T02:42:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11580','2005-08-17T01:59:07.000','1346','436','2005-08-21T06:18:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11581','2005-08-17T02:03:02.000','1249','231','2005-08-24T03:53:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11582','2005-08-17T02:03:49.000','2115','339','2005-08-24T03:29:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11583','2005-08-17T02:08:13.000','133','542','2005-08-20T23:13:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11584','2005-08-17T02:13:26.000','3906','479','2005-08-22T01:24:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11585','2005-08-17T02:14:36.000','753','297','2005-08-20T07:37:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11586','2005-08-17T02:20:42.000','3140','465','2005-08-26T05:01:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11587','2005-08-17T02:21:03.000','1319','156','2005-08-25T21:02:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11588','2005-08-17T02:26:23.000','2480','565','2005-08-22T02:32:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11589','2005-08-17T02:28:22.000','3480','554','2005-08-25T00:08:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11590','2005-08-17T02:28:33.000','3600','491','2005-08-20T03:13:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11591','2005-08-17T02:29:41.000','1670','6','2005-08-23T20:47:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11592','2005-08-17T02:36:04.000','720','383','2005-08-19T00:31:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11593','2006-02-14T15:16:03.000','817','99',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11594','2005-08-17T02:47:02.000','319','198','2005-08-22T05:14:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11595','2005-08-17T02:53:14.000','466','350','2005-08-26T02:05:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11596','2005-08-17T02:53:55.000','1674','290','2005-08-26T02:19:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11597','2005-08-17T03:02:56.000','4073','272','2005-08-26T04:47:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11598','2005-08-17T03:03:07.000','1949','319','2005-08-22T21:05:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11599','2005-08-17T03:08:10.000','3749','112','2005-08-25T05:01:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11600','2005-08-17T03:12:04.000','1978','400','2005-08-23T07:10:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11601','2005-08-17T03:14:47.000','1098','471','2005-08-20T00:21:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11602','2005-08-17T03:21:19.000','2082','391','2005-08-19T05:23:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11603','2005-08-17T03:22:10.000','3910','406','2005-08-18T06:48:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11604','2005-08-17T03:28:27.000','1820','388','2005-08-19T05:38:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11605','2005-08-17T03:30:57.000','1292','455','2005-08-24T07:02:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11606','2005-08-17T03:32:43.000','4138','499','2005-08-18T04:30:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11607','2005-08-17T03:36:06.000','4345','242','2005-08-20T01:06:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11608','2005-08-17T03:36:52.000','1673','448','2005-08-25T07:17:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11609','2005-08-17T03:41:11.000','351','73','2005-08-25T01:30:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11610','2005-08-17T03:43:37.000','3048','275','2005-08-20T22:14:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11611','2006-02-14T15:16:03.000','1857','192',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11612','2005-08-17T03:48:51.000','375','526','2005-08-20T03:03:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11613','2005-08-17T03:50:33.000','2486','126','2005-08-25T00:37:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11614','2005-08-17T03:52:18.000','805','2','2005-08-20T07:04:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11615','2005-08-17T03:54:35.000','4331','436','2005-08-23T06:54:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11616','2005-08-17T04:00:01.000','2588','36','2005-08-20T23:03:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11617','2005-08-17T04:00:40.000','1898','324','2005-08-18T00:36:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11618','2005-08-17T04:01:36.000','954','175','2005-08-23T01:02:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11619','2005-08-17T04:03:26.000','3652','374','2005-08-22T03:07:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11620','2005-08-17T04:06:22.000','3801','502','2005-08-17T23:53:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11621','2005-08-17T04:13:45.000','3708','216','2005-08-26T01:00:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11622','2005-08-17T04:15:46.000','499','220','2005-08-24T04:48:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11623','2005-08-17T04:15:47.000','759','163','2005-08-19T04:11:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11624','2005-08-17T04:17:42.000','606','527','2005-08-18T02:46:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11625','2005-08-17T04:18:52.000','712','521','2005-08-25T03:05:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11626','2005-08-17T04:25:42.000','4279','266','2005-08-23T05:46:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11627','2005-08-17T04:25:47.000','3945','168','2005-08-26T02:54:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11628','2005-08-17T04:27:18.000','3656','256','2005-08-25T01:12:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11629','2005-08-17T04:27:24.000','786','299','2005-08-26T10:25:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11630','2005-08-17T04:27:46.000','688','72','2005-08-19T09:58:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11631','2005-08-17T04:28:56.000','59','168','2005-08-24T00:42:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11632','2005-08-17T04:29:32.000','2551','238','2005-08-22T03:44:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11633','2005-08-17T04:30:09.000','1706','468','2005-08-20T06:56:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11634','2005-08-17T04:31:49.000','2576','206','2005-08-21T02:51:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11635','2005-08-17T04:33:17.000','2642','98','2005-08-21T07:50:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11636','2005-08-17T04:36:31.000','791','276','2005-08-24T00:03:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11637','2005-08-17T04:36:39.000','479','283','2005-08-18T02:17:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11638','2005-08-17T04:39:09.000','3421','152','2005-08-25T06:42:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11639','2005-08-17T04:43:29.000','3985','462','2005-08-25T01:04:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11640','2005-08-17T04:44:33.000','1718','501','2005-08-21T09:29:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11641','2005-08-17T04:45:39.000','2717','79','2005-08-20T10:38:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11642','2005-08-17T04:48:05.000','3790','25','2005-08-18T01:53:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11643','2005-08-17T04:49:35.000','1378','197','2005-08-24T07:05:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11644','2005-08-17T04:49:46.000','1760','438','2005-08-24T08:49:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11645','2005-08-17T04:50:56.000','4261','35','2005-08-25T23:03:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11646','2006-02-14T15:16:03.000','478','11',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11647','2005-08-17T04:54:14.000','3016','110','2005-08-23T04:16:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11648','2005-08-17T04:56:16.000','3362','465','2005-08-26T00:53:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11649','2005-08-17T04:59:26.000','3222','217','2005-08-20T04:02:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11650','2005-08-17T05:00:03.000','3979','418','2005-08-22T01:45:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11651','2005-08-17T05:02:25.000','3681','143','2005-08-24T08:15:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11652','2006-02-14T15:16:03.000','1622','597',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11653','2005-08-17T05:06:10.000','4475','358','2005-08-24T03:09:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11654','2005-08-17T05:06:19.000','1048','218','2005-08-18T04:32:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11655','2005-08-17T05:11:07.000','1699','113','2005-08-26T10:18:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11656','2005-08-17T05:11:09.000','1451','56','2005-08-25T07:51:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11657','2006-02-14T15:16:03.000','3043','53',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11658','2005-08-17T05:19:17.000','2008','422','2005-08-24T07:03:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11659','2005-08-17T05:20:45.000','2881','112','2005-08-22T10:18:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11660','2005-08-17T05:22:42.000','4081','525','2005-08-23T01:03:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11661','2005-08-17T05:25:57.000','1008','27','2005-08-25T04:37:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11662','2005-08-17T05:27:37.000','2730','177','2005-08-26T09:56:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11663','2005-08-17T05:30:19.000','3798','373','2005-08-25T08:14:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11664','2005-08-17T05:35:52.000','1343','433','2005-08-18T02:40:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11665','2005-08-17T05:36:57.000','334','254','2005-08-23T01:38:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11666','2005-08-17T05:45:10.000','250','531','2005-08-19T06:47:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11667','2005-08-17T05:46:55.000','1516','582','2005-08-26T08:19:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11668','2005-08-17T05:47:32.000','2162','249','2005-08-20T03:11:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11669','2005-08-17T05:48:51.000','3224','487','2005-08-22T01:22:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11670','2005-08-17T05:48:59.000','4437','286','2005-08-19T08:51:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11671','2005-08-17T05:50:21.000','3569','338','2005-08-20T03:43:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11672','2006-02-14T15:16:03.000','3947','521',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11673','2005-08-17T05:54:15.000','823','303','2005-08-21T08:12:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11674','2005-08-17T05:56:27.000','582','306','2005-08-24T08:50:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11675','2005-08-17T05:57:54.000','1322','514','2005-08-21T23:57:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11676','2006-02-14T15:16:03.000','4496','216',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11677','2005-08-17T06:06:26.000','2206','407','2005-08-20T04:35:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11678','2005-08-17T06:07:39.000','3511','176','2005-08-21T10:51:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11679','2005-08-17T06:08:54.000','3337','72','2005-08-21T07:50:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11680','2005-08-17T06:12:27.000','4538','221','2005-08-23T08:54:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11681','2005-08-17T06:13:30.000','1260','543','2005-08-26T01:29:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11682','2005-08-17T06:13:40.000','2544','387','2005-08-18T06:11:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11683','2005-08-17T06:15:17.000','2603','66','2005-08-26T05:33:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11684','2005-08-17T06:27:15.000','4277','517','2005-08-22T02:11:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11685','2005-08-17T06:39:16.000','3552','51','2005-08-22T04:20:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11686','2005-08-17T06:39:30.000','1393','392','2005-08-21T10:19:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11687','2005-08-17T06:39:59.000','1977','169','2005-08-23T04:53:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11688','2005-08-17T06:41:58.000','2229','82','2005-08-25T04:38:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11689','2005-08-17T06:42:08.000','2390','419','2005-08-26T06:09:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11690','2005-08-17T06:44:22.000','3934','267','2005-08-24T03:49:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11691','2005-08-17T06:51:05.000','2529','515','2005-08-24T09:53:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11692','2005-08-17T06:52:41.000','1222','350','2005-08-24T12:17:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11693','2005-08-17T06:56:56.000','793','221','2005-08-24T06:20:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11694','2005-08-17T06:57:30.000','3540','410','2005-08-24T07:52:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11695','2005-08-17T07:01:08.000','1110','386','2005-08-21T09:21:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11696','2005-08-17T07:01:09.000','3816','522','2005-08-21T09:12:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11697','2005-08-17T07:09:19.000','383','329','2005-08-19T02:02:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11698','2005-08-17T07:09:59.000','3946','353','2005-08-19T04:31:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11699','2005-08-17T07:11:58.000','3997','339','2005-08-26T12:08:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11700','2005-08-17T07:12:31.000','2365','104','2005-08-18T04:21:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11701','2005-08-17T07:15:47.000','993','34','2005-08-19T01:44:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11702','2005-08-17T07:18:56.000','3286','526','2005-08-24T06:33:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11703','2005-08-17T07:19:29.000','1692','279','2005-08-20T09:35:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11704','2005-08-17T07:21:22.000','1099','135','2005-08-25T06:06:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11705','2005-08-17T07:22:25.000','4242','489','2005-08-18T06:42:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11706','2005-08-17T07:23:46.000','4234','414','2005-08-18T10:13:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11707','2005-08-17T07:24:59.000','1030','581','2005-08-24T10:40:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11708','2005-08-17T07:26:47.000','76','582','2005-08-22T04:11:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11709','2006-02-14T15:16:03.000','1720','330',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11710','2005-08-17T07:29:44.000','613','553','2005-08-19T02:06:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11711','2005-08-17T07:30:55.000','1503','470','2005-08-18T09:21:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11712','2005-08-17T07:32:51.000','3607','203','2005-08-21T09:18:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11713','2005-08-17T07:34:05.000','1919','590','2005-08-25T07:49:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11714','2005-08-17T07:34:55.000','17','151','2005-08-18T04:07:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11715','2005-08-17T07:40:55.000','1615','452','2005-08-25T11:19:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11716','2005-08-17T07:40:55.000','3054','287','2005-08-21T05:56:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11717','2005-08-17T07:44:09.000','1371','566','2005-08-20T09:39:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11718','2005-08-17T07:44:42.000','3673','555','2005-08-23T03:02:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11719','2005-08-17T07:46:05.000','2054','338','2005-08-23T08:52:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11720','2005-08-17T07:46:54.000','1707','121','2005-08-26T04:19:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11721','2005-08-17T07:49:17.000','1923','46','2005-08-18T04:08:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11722','2005-08-17T07:53:03.000','2430','321','2005-08-22T06:56:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11723','2005-08-17T07:56:22.000','1665','341','2005-08-22T03:49:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11724','2005-08-17T08:04:44.000','4484','207','2005-08-25T03:25:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11725','2005-08-17T08:09:00.000','519','45','2005-08-18T09:50:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11726','2005-08-17T08:11:10.000','4438','266','2005-08-22T05:45:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11727','2005-08-17T08:12:20.000','98','6','2005-08-19T12:45:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11728','2005-08-17T08:12:26.000','726','444','2005-08-18T03:26:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11729','2005-08-17T08:14:41.000','2819','215','2005-08-22T02:54:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11730','2005-08-17T08:22:00.000','3817','98','2005-08-22T05:43:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11731','2005-08-17T08:24:35.000','917','52','2005-08-24T02:54:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11732','2005-08-17T08:29:46.000','460','137','2005-08-23T14:21:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11733','2005-08-17T08:31:03.000','439','251','2005-08-21T05:44:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11734','2005-08-17T08:34:22.000','4063','337','2005-08-25T11:56:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11735','2005-08-17T08:35:42.000','2555','452','2005-08-26T11:04:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11736','2005-08-17T08:40:55.000','4217','535','2005-08-26T09:03:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11737','2005-08-17T08:42:08.000','4128','549','2005-08-19T08:14:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11738','2005-08-17T08:45:55.000','3042','347','2005-08-26T07:09:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11739','2006-02-14T15:16:03.000','4568','373',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11740','2005-08-17T08:48:31.000','2441','27','2005-08-24T07:47:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11741','2005-08-17T08:48:39.000','1819','473','2005-08-20T07:37:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11742','2005-08-17T08:48:43.000','596','470','2005-08-23T07:18:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11743','2005-08-17T08:49:05.000','294','336','2005-08-22T08:53:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11744','2005-08-17T08:54:30.000','297','26','2005-08-25T03:28:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11745','2005-08-17T09:00:01.000','4018','240','2005-08-26T14:29:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11746','2005-08-17T09:03:24.000','4571','299','2005-08-25T06:08:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11747','2005-08-17T09:03:31.000','1041','555','2005-08-19T08:23:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11748','2005-08-17T09:04:02.000','1175','595','2005-08-21T12:22:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11749','2005-08-17T09:04:03.000','4141','567','2005-08-19T09:32:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11750','2005-08-17T09:07:00.000','665','190','2005-08-23T08:16:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11751','2005-08-17T09:07:56.000','3309','51','2005-08-26T13:16:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11752','2005-08-17T09:10:55.000','1833','481','2005-08-18T06:22:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11753','2005-08-17T09:11:52.000','2599','43','2005-08-25T05:03:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11754','2006-02-14T15:16:03.000','3747','163',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11755','2005-08-17T09:15:35.000','3457','513','2005-08-23T06:28:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11756','2005-08-17T09:29:22.000','1798','198','2005-08-21T12:17:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11757','2006-02-14T15:16:03.000','1295','550',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11758','2005-08-17T09:33:02.000','11','533','2005-08-24T05:03:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11759','2005-08-17T09:41:23.000','2655','108','2005-08-19T11:58:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11760','2005-08-17T09:44:22.000','626','545','2005-08-24T14:39:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11761','2005-08-17T09:44:59.000','2230','13','2005-08-25T07:46:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11762','2005-08-17T09:48:06.000','1204','244','2005-08-26T13:12:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11763','2005-08-17T09:51:39.000','872','586','2005-08-21T10:15:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11764','2005-08-17T09:51:54.000','4502','252','2005-08-20T07:11:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11765','2005-08-17T09:55:28.000','4311','308','2005-08-19T15:53:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11766','2005-08-17T09:58:40.000','2999','544','2005-08-21T04:59:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11767','2005-08-17T10:00:40.000','2374','77','2005-08-25T04:14:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11768','2005-08-17T10:02:29.000','1307','564','2005-08-23T10:26:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11769','2005-08-17T10:04:49.000','1406','418','2005-08-20T09:22:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11770','2005-08-17T10:05:05.000','2862','475','2005-08-20T15:59:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11771','2005-08-17T10:17:09.000','2575','324','2005-08-25T10:58:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11772','2005-08-17T10:18:57.000','1021','237','2005-08-26T12:48:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11773','2005-08-17T10:19:51.000','1886','384','2005-08-23T04:30:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11774','2005-08-17T10:20:39.000','1679','488','2005-08-23T13:37:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11775','2005-08-17T10:25:53.000','256','574','2005-08-22T08:37:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11776','2005-08-17T10:27:19.000','2400','306','2005-08-20T14:02:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11777','2005-08-17T10:27:19.000','4065','83','2005-08-26T13:10:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11778','2005-08-17T10:31:40.000','1306','213','2005-08-25T13:53:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11779','2005-08-17T10:31:58.000','181','126','2005-08-24T15:28:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11780','2005-08-17T10:34:24.000','2268','297','2005-08-21T04:55:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11781','2005-08-17T10:37:00.000','1853','506','2005-08-21T12:03:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11782','2006-02-14T15:16:03.000','4098','354',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11783','2005-08-17T10:39:24.000','979','152','2005-08-21T12:43:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11784','2005-08-17T10:48:05.000','3101','297','2005-08-19T06:47:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11785','2005-08-17T10:54:46.000','2760','182','2005-08-23T14:15:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11786','2005-08-17T10:57:40.000','1487','435','2005-08-24T06:48:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11787','2005-08-17T10:59:00.000','1980','195','2005-08-19T05:56:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11788','2005-08-17T10:59:18.000','1310','560','2005-08-22T11:12:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11789','2005-08-17T10:59:24.000','851','150','2005-08-26T16:17:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11790','2005-08-17T11:00:08.000','2384','451','2005-08-20T05:15:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11791','2005-08-17T11:01:11.000','3640','219','2005-08-22T06:31:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11792','2005-08-17T11:03:53.000','3703','376','2005-08-26T06:34:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11793','2005-08-17T11:05:53.000','1955','352','2005-08-25T12:25:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11794','2005-08-17T11:08:48.000','3486','453','2005-08-20T13:36:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11795','2005-08-17T11:13:38.000','2220','565','2005-08-19T14:20:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11796','2005-08-17T11:16:47.000','3983','435','2005-08-18T16:55:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11797','2005-08-17T11:17:21.000','1142','546','2005-08-18T09:14:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11798','2005-08-17T11:21:43.000','3974','448','2005-08-25T07:43:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11799','2005-08-17T11:25:25.000','40','501','2005-08-25T13:03:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11800','2005-08-17T11:29:52.000','2284','350','2005-08-21T08:37:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11801','2005-08-17T11:30:11.000','659','126','2005-08-23T09:54:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11802','2005-08-17T11:32:51.000','2815','221','2005-08-22T10:56:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11803','2005-08-17T11:42:08.000','3648','160','2005-08-22T07:45:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11804','2005-08-17T11:42:45.000','1040','556','2005-08-25T07:11:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11805','2005-08-17T11:48:47.000','1208','208','2005-08-26T11:06:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11806','2005-08-17T11:49:28.000','3203','125','2005-08-22T15:42:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11807','2005-08-17T11:51:15.000','4052','201','2005-08-21T11:47:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11808','2005-08-17T11:51:16.000','4042','462','2005-08-18T14:01:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11809','2005-08-17T11:51:39.000','1136','305','2005-08-24T17:14:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11810','2005-08-17T11:56:48.000','1548','270','2005-08-20T17:39:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11811','2005-08-17T11:59:18.000','195','130','2005-08-18T09:13:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11812','2005-08-17T12:00:54.000','119','132','2005-08-18T16:08:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11813','2005-08-17T12:06:54.000','1074','36','2005-08-21T17:52:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11814','2005-08-17T12:09:20.000','3462','509','2005-08-25T16:56:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11815','2005-08-17T12:13:26.000','272','192','2005-08-22T17:15:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11816','2005-08-17T12:14:16.000','3897','224','2005-08-19T06:15:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11817','2005-08-17T12:20:01.000','2297','38','2005-08-19T18:06:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11818','2005-08-17T12:22:04.000','213','512','2005-08-25T15:59:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11819','2005-08-17T12:25:17.000','656','208','2005-08-19T16:12:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11820','2005-08-17T12:25:33.000','2801','401','2005-08-19T07:04:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11821','2005-08-17T12:27:55.000','2711','20','2005-08-18T07:07:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11822','2005-08-17T12:32:39.000','1317','263','2005-08-18T12:30:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11823','2005-08-17T12:36:37.000','2626','352','2005-08-22T11:10:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11824','2005-08-17T12:37:54.000','2639','1','2005-08-19T10:11:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11825','2005-08-17T12:43:30.000','2656','296','2005-08-20T15:25:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11826','2005-08-17T12:43:46.000','1837','536','2005-08-19T16:59:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11827','2005-08-17T12:44:27.000','3064','523','2005-08-24T13:31:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11828','2005-08-17T12:48:28.000','2593','268','2005-08-24T09:24:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11829','2005-08-17T12:52:04.000','2207','563','2005-08-19T10:50:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11830','2005-08-17T12:53:15.000','3713','522','2005-08-25T08:08:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11831','2005-08-17T12:54:47.000','4562','32','2005-08-21T11:21:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11832','2005-08-17T12:55:31.000','2331','125','2005-08-19T08:31:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11833','2005-08-17T13:00:33.000','3728','424','2005-08-18T13:45:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11834','2005-08-17T13:00:40.000','2407','261','2005-08-22T12:50:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11835','2005-08-17T13:03:13.000','2796','479','2005-08-19T10:50:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11836','2005-08-17T13:03:36.000','2253','198','2005-08-19T17:15:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11837','2005-08-17T13:04:41.000','1085','81','2005-08-26T14:19:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11838','2005-08-17T13:06:00.000','3576','161','2005-08-20T11:44:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11839','2005-08-17T13:08:45.000','2282','80','2005-08-18T15:05:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11840','2005-08-17T13:09:01.000','1824','491','2005-08-19T17:42:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11841','2005-08-17T13:12:20.000','1524','270','2005-08-21T11:16:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11842','2005-08-17T13:13:37.000','2680','422','2005-08-20T08:32:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11843','2005-08-17T13:14:50.000','3091','187','2005-08-22T11:31:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11844','2005-08-17T13:16:04.000','3791','368','2005-08-18T10:16:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11845','2005-08-17T13:16:38.000','14','65','2005-08-18T11:21:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11846','2005-08-17T13:18:29.000','3306','283','2005-08-22T18:05:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11847','2006-02-14T15:16:03.000','1784','337',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11848','2006-02-14T15:16:03.000','3680','152',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11849','2005-08-17T13:24:55.000','1191','92','2005-08-22T12:50:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11850','2005-08-17T13:30:15.000','1437','80','2005-08-21T17:24:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11851','2005-08-17T13:30:27.000','3225','376','2005-08-20T15:34:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11852','2005-08-17T13:38:27.000','2358','596','2005-08-24T08:50:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11853','2005-08-17T13:39:32.000','3888','6','2005-08-23T18:44:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11854','2005-08-17T13:42:52.000','137','313','2005-08-26T14:04:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11855','2005-08-17T13:43:07.000','1062','535','2005-08-26T08:07:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11856','2005-08-17T13:44:49.000','305','28','2005-08-21T17:20:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11857','2005-08-17T13:48:30.000','101','146','2005-08-18T15:55:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11858','2005-08-17T13:50:31.000','3483','503','2005-08-19T08:45:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11859','2005-08-17T13:51:20.000','423','144','2005-08-21T13:47:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11860','2005-08-17T13:52:26.000','4354','257','2005-08-24T14:47:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11861','2005-08-17T13:53:47.000','2674','232','2005-08-21T16:07:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11862','2005-08-17T13:54:53.000','2604','529','2005-08-19T10:48:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11863','2005-08-17T13:56:01.000','1003','112','2005-08-23T18:38:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11864','2005-08-17T14:02:01.000','2985','96','2005-08-21T19:54:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11865','2005-08-17T14:03:46.000','2577','345','2005-08-19T08:39:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11866','2006-02-14T15:16:03.000','2758','200',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11867','2005-08-17T14:04:28.000','938','434','2005-08-21T10:08:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11868','2005-08-17T14:05:34.000','2909','445','2005-08-19T15:47:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11869','2005-08-17T14:10:22.000','3453','19','2005-08-24T18:39:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11870','2005-08-17T14:11:28.000','4251','432','2005-08-24T16:43:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11871','2005-08-17T14:11:44.000','3013','484','2005-08-18T17:50:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11872','2005-08-17T14:11:45.000','4306','113','2005-08-21T17:02:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11873','2005-08-17T14:14:39.000','4021','554','2005-08-18T17:20:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11874','2005-08-17T14:16:40.000','2637','467','2005-08-18T15:51:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11875','2005-08-17T14:16:48.000','1787','294','2005-08-26T14:20:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11876','2005-08-17T14:18:21.000','3982','426','2005-08-20T19:48:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11877','2005-08-17T14:21:11.000','4528','445','2005-08-25T19:46:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11878','2005-08-17T14:23:52.000','255','549','2005-08-21T14:23:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11879','2005-08-17T14:25:09.000','2500','312','2005-08-26T09:19:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11880','2005-08-17T14:28:28.000','1539','597','2005-08-26T12:32:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11881','2005-08-17T14:31:56.000','3124','272','2005-08-21T11:05:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11882','2005-08-17T14:33:41.000','2401','234','2005-08-26T17:25:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11883','2005-08-17T14:41:28.000','221','551','2005-08-19T09:54:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11884','2005-08-17T14:43:23.000','797','178','2005-08-25T15:38:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11885','2005-08-17T14:53:53.000','3931','481','2005-08-22T10:59:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11886','2005-08-17T14:58:51.000','608','204','2005-08-19T16:07:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11887','2005-08-17T15:03:13.000','3290','54','2005-08-19T09:49:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11888','2005-08-17T15:04:05.000','1100','160','2005-08-25T18:52:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11889','2005-08-17T15:08:27.000','293','395','2005-08-18T17:10:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11890','2005-08-17T15:08:43.000','3023','487','2005-08-26T14:56:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11891','2005-08-17T15:11:55.000','2619','115','2005-08-22T11:11:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11892','2005-08-17T15:13:21.000','746','227','2005-08-21T09:19:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11893','2005-08-17T15:13:29.000','2321','496','2005-08-25T11:09:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11894','2005-08-17T15:15:01.000','1223','67','2005-08-26T13:49:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11895','2005-08-17T15:15:07.000','2156','236','2005-08-18T11:00:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11896','2005-08-17T15:19:54.000','259','436','2005-08-24T18:22:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11897','2005-08-17T15:24:06.000','3904','238','2005-08-23T11:50:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11898','2005-08-17T15:24:12.000','3163','169','2005-08-24T13:36:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11899','2005-08-17T15:29:12.000','3179','84','2005-08-24T17:41:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11900','2005-08-17T15:30:44.000','1931','239','2005-08-19T16:12:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11901','2005-08-17T15:35:47.000','4274','70','2005-08-20T10:33:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11902','2005-08-17T15:37:34.000','1387','63','2005-08-22T17:28:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11903','2005-08-17T15:37:45.000','1196','542','2005-08-23T18:31:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11904','2005-08-17T15:39:26.000','2846','145','2005-08-21T18:24:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11905','2005-08-17T15:40:18.000','2725','349','2005-08-26T15:14:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11906','2005-08-17T15:40:46.000','325','478','2005-08-20T15:20:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11907','2005-08-17T15:40:47.000','3928','505','2005-08-20T19:55:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11908','2005-08-17T15:43:09.000','3390','314','2005-08-24T14:32:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11909','2006-02-14T15:16:03.000','871','474',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11910','2005-08-17T15:44:37.000','4254','418','2005-08-19T10:58:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11911','2005-08-17T15:51:35.000','3578','472','2005-08-26T20:26:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11912','2005-08-17T15:51:49.000','744','573','2005-08-24T18:48:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11913','2005-08-17T15:53:17.000','741','295','2005-08-24T18:50:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11914','2005-08-17T16:04:42.000','1634','230','2005-08-22T19:29:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11915','2005-08-17T16:05:28.000','1557','269','2005-08-25T19:53:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11916','2005-08-17T16:05:51.000','2631','86','2005-08-20T10:23:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11917','2005-08-17T16:08:17.000','1608','270','2005-08-20T20:01:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11918','2005-08-17T16:08:42.000','2169','533','2005-08-20T20:12:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11919','2005-08-17T16:08:49.000','4497','40','2005-08-20T16:59:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11920','2005-08-17T16:10:19.000','4253','402','2005-08-20T13:54:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11921','2005-08-17T16:12:27.000','494','485','2005-08-25T22:07:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11922','2005-08-17T16:20:37.000','3707','15','2005-08-26T16:53:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11923','2005-08-17T16:21:47.000','1907','72','2005-08-18T14:26:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11924','2005-08-17T16:22:05.000','1711','202','2005-08-26T12:34:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11925','2005-08-17T16:23:04.000','1441','370','2005-08-21T11:38:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11926','2005-08-17T16:25:02.000','2111','516','2005-08-22T11:36:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11927','2005-08-17T16:25:03.000','3134','178','2005-08-23T16:41:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11928','2005-08-17T16:28:24.000','79','261','2005-08-23T17:50:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11929','2005-08-17T16:28:51.000','3765','327','2005-08-25T19:36:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11930','2005-08-17T16:28:53.000','1299','5','2005-08-25T10:31:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11931','2005-08-17T16:35:14.000','2022','242','2005-08-19T19:16:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11932','2005-08-17T16:36:12.000','151','364','2005-08-18T19:34:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11933','2005-08-17T16:38:20.000','2574','438','2005-08-22T14:31:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11934','2005-08-17T16:40:00.000','1230','596','2005-08-20T20:13:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11935','2005-08-17T16:42:13.000','1640','66','2005-08-22T20:38:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11936','2005-08-17T16:45:34.000','1127','380','2005-08-21T13:33:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11937','2005-08-17T16:48:36.000','2926','515','2005-08-24T19:01:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11938','2005-08-17T16:54:54.000','3927','426','2005-08-24T19:18:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11939','2005-08-17T16:55:57.000','3305','516','2005-08-24T21:36:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11940','2005-08-17T16:56:28.000','1188','163','2005-08-18T15:09:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11941','2005-08-17T16:56:57.000','159','566','2005-08-24T16:29:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11942','2006-02-14T15:16:03.000','4094','576',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11943','2005-08-17T17:00:42.000','4466','69','2005-08-26T22:07:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11944','2005-08-17T17:02:42.000','27','389','2005-08-21T16:40:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11945','2005-08-17T17:05:33.000','1108','380','2005-08-20T18:37:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11946','2005-08-17T17:05:53.000','2953','569','2005-08-19T13:56:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11947','2005-08-17T17:08:13.000','2928','220','2005-08-23T21:53:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11948','2005-08-17T17:11:05.000','3329','40','2005-08-25T21:16:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11949','2005-08-17T17:12:26.000','854','198','2005-08-23T20:48:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11950','2005-08-17T17:13:16.000','4412','190','2005-08-26T21:25:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11951','2005-08-17T17:14:02.000','1394','155','2005-08-26T12:04:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11952','2005-08-17T17:14:57.000','2411','288','2005-08-19T19:15:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11953','2005-08-17T17:16:42.000','2993','399','2005-08-23T18:28:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11954','2005-08-17T17:18:36.000','220','145','2005-08-18T19:49:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11955','2005-08-17T17:21:35.000','1221','319','2005-08-24T22:06:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11956','2005-08-17T17:22:05.000','2533','457','2005-08-25T22:19:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11957','2005-08-17T17:22:29.000','1924','198','2005-08-23T21:47:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11958','2005-08-17T17:23:20.000','2061','217','2005-08-24T14:47:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11959','2005-08-17T17:23:35.000','2694','101','2005-08-20T20:57:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11960','2005-08-17T17:24:30.000','3924','84','2005-08-18T14:28:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11961','2005-08-17T17:28:01.000','2015','276','2005-08-21T20:43:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11962','2005-08-17T17:34:38.000','4384','29','2005-08-21T12:59:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11963','2005-08-17T17:35:47.000','232','211','2005-08-23T16:19:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11964','2005-08-17T17:37:03.000','2225','309','2005-08-25T11:55:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11965','2005-08-17T17:39:45.000','194','490','2005-08-19T12:05:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11966','2005-08-17T17:40:04.000','3702','283','2005-08-20T15:45:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11967','2005-08-17T17:45:00.000','1151','521','2005-08-22T13:03:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11968','2005-08-17T17:47:34.000','698','239','2005-08-18T19:40:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11969','2005-08-17T17:49:37.000','668','550','2005-08-19T19:45:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11970','2005-08-17T17:53:09.000','1779','21','2005-08-24T14:41:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11971','2005-08-17T17:53:42.000','2756','131','2005-08-18T12:11:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11972','2005-08-17T17:55:46.000','1282','308','2005-08-22T15:31:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11973','2005-08-17T17:55:58.000','1472','131','2005-08-21T19:55:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11974','2005-08-17T17:56:48.000','1609','485','2005-08-21T19:14:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11975','2005-08-17T17:58:39.000','3843','458','2005-08-20T19:11:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11976','2005-08-17T17:59:19.000','498','373','2005-08-23T14:51:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11977','2005-08-17T18:01:15.000','1528','536','2005-08-23T23:03:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11978','2005-08-17T18:02:10.000','4380','499','2005-08-18T20:40:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11979','2005-08-17T18:07:13.000','568','255','2005-08-19T23:12:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11980','2005-08-17T18:10:18.000','4165','589','2005-08-20T13:28:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11981','2005-08-17T18:10:40.000','3228','294','2005-08-20T16:56:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11982','2005-08-17T18:13:07.000','118','186','2005-08-18T19:06:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11983','2005-08-17T18:13:55.000','2580','304','2005-08-23T18:27:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11984','2005-08-17T18:16:30.000','3577','96','2005-08-24T21:09:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11985','2005-08-17T18:19:44.000','2208','198','2005-08-18T19:14:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11986','2005-08-17T18:21:58.000','1610','352','2005-08-18T13:05:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11987','2005-08-17T18:21:59.000','1478','494','2005-08-25T19:20:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11988','2005-08-17T18:23:50.000','3429','62','2005-08-18T22:30:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11989','2005-08-17T18:23:58.000','3686','439','2005-08-20T20:31:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11990','2005-08-17T18:26:22.000','3012','17','2005-08-19T14:34:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11991','2005-08-17T18:27:08.000','940','361','2005-08-25T14:07:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11992','2005-08-17T18:27:22.000','4132','136','2005-08-26T22:38:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11993','2005-08-17T18:27:49.000','295','303','2005-08-21T00:04:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11994','2005-08-17T18:29:35.000','3428','319','2005-08-25T23:39:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11995','2006-02-14T15:16:03.000','3953','69',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11996','2005-08-17T18:34:37.000','2720','510','2005-08-20T22:25:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11997','2005-08-17T18:34:38.000','2193','411','2005-08-26T00:12:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11998','2005-08-17T18:46:21.000','4258','299','2005-08-18T20:29:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('11999','2005-08-17T18:47:07.000','4333','125','2005-08-20T23:26:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12000','2005-08-17T18:49:44.000','2256','149','2005-08-24T16:34:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12001','2006-02-14T15:16:03.000','4158','52',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12002','2005-08-17T18:56:02.000','1386','75','2005-08-20T17:36:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12003','2005-08-17T18:56:05.000','3868','70','2005-08-18T23:52:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12004','2005-08-17T18:56:53.000','2690','499','2005-08-26T14:56:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12005','2005-08-17T18:56:55.000','2062','403','2005-08-25T20:23:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12006','2005-08-17T19:09:12.000','4072','272','2005-08-24T13:50:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12007','2005-08-17T19:10:34.000','3007','268','2005-08-24T14:09:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12008','2005-08-17T19:16:18.000','865','562','2005-08-18T14:24:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12009','2006-02-14T15:16:03.000','2134','296',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12010','2005-08-17T19:17:54.000','1076','554','2005-08-26T00:41:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12011','2005-08-17T19:19:44.000','495','313','2005-08-23T00:56:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12012','2005-08-17T19:20:48.000','2698','69','2005-08-22T16:50:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12013','2005-08-17T19:23:02.000','3530','586','2005-08-23T00:31:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12014','2005-08-17T19:29:44.000','1778','554','2005-08-23T20:40:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12015','2005-08-17T19:32:44.000','593','11','2005-08-23T13:36:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12016','2005-08-17T19:33:24.000','2109','327','2005-08-21T19:59:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12017','2005-08-17T19:33:49.000','344','573','2005-08-22T01:16:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12018','2005-08-17T19:44:46.000','1921','319','2005-08-26T20:24:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12019','2005-08-17T19:48:55.000','2566','90','2005-08-21T18:20:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12020','2005-08-17T19:50:33.000','3258','72','2005-08-25T17:54:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12021','2005-08-17T19:52:43.000','3977','27','2005-08-23T21:49:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12022','2005-08-17T19:52:45.000','2067','461','2005-08-18T18:26:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12023','2005-08-17T19:54:54.000','247','22','2005-08-26T23:03:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12024','2005-08-17T19:57:34.000','2398','484','2005-08-21T23:00:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12025','2005-08-17T19:59:06.000','4019','209','2005-08-23T14:39:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12026','2005-08-17T20:00:10.000','1568','468','2005-08-26T01:54:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12027','2005-08-17T20:01:12.000','45','285','2005-08-26T21:08:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12028','2005-08-17T20:03:47.000','607','316','2005-08-23T17:09:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12029','2005-08-17T20:07:01.000','3516','148','2005-08-19T19:36:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12030','2005-08-17T20:10:48.000','449','434','2005-08-19T00:32:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12031','2005-08-17T20:11:35.000','2793','10','2005-08-24T23:48:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12032','2005-08-17T20:14:26.000','1106','141','2005-08-26T16:01:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12033','2005-08-17T20:14:34.000','2731','321','2005-08-26T00:22:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12034','2005-08-17T20:15:31.000','834','321','2005-08-24T15:46:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12035','2005-08-17T20:18:06.000','2335','469','2005-08-21T16:41:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12036','2005-08-17T20:19:06.000','3620','85','2005-08-18T19:57:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12037','2005-08-17T20:21:35.000','766','356','2005-08-22T17:16:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12038','2005-08-17T20:28:26.000','3794','148','2005-08-20T23:09:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12039','2005-08-17T20:29:08.000','4404','563','2005-08-23T21:20:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12040','2005-08-17T20:29:56.000','1288','558','2005-08-26T22:17:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12041','2005-08-17T20:34:33.000','2389','295','2005-08-19T00:47:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12042','2005-08-17T20:36:37.000','1772','570','2005-08-21T15:03:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12043','2005-08-17T20:38:21.000','3706','592','2005-08-22T16:52:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12044','2005-08-17T20:39:37.000','3377','388','2005-08-19T18:34:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12045','2005-08-17T20:40:46.000','469','556','2005-08-20T18:18:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12046','2005-08-17T20:47:46.000','3895','435','2005-08-19T16:09:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12047','2005-08-17T20:48:32.000','3886','251','2005-08-26T00:07:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12048','2005-08-17T20:49:24.000','3773','466','2005-08-27T02:01:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12049','2005-08-17T20:53:27.000','2433','178','2005-08-26T19:45:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12050','2005-08-17T20:55:25.000','2348','405','2005-08-22T20:31:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12051','2005-08-17T20:56:15.000','4001','579','2005-08-25T19:08:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12052','2005-08-17T20:57:02.000','99','536','2005-08-25T19:04:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12053','2005-08-17T20:57:27.000','4448','280','2005-08-20T19:51:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12054','2005-08-17T20:59:56.000','3780','53','2005-08-23T19:57:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12055','2005-08-17T21:02:19.000','1481','35','2005-08-18T15:24:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12056','2005-08-17T21:03:48.000','1091','460','2005-08-21T22:42:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12057','2005-08-17T21:04:35.000','1878','263','2005-08-25T00:17:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12058','2005-08-17T21:07:41.000','2438','540','2005-08-26T16:07:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12059','2005-08-17T21:09:23.000','4111','393','2005-08-25T23:09:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12060','2005-08-17T21:11:57.000','2373','127','2005-08-21T01:42:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12061','2005-08-17T21:13:35.000','144','532','2005-08-22T19:18:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12062','2005-08-17T21:24:47.000','1791','330','2005-08-20T20:35:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12063','2005-08-17T21:24:48.000','1141','550','2005-08-23T22:10:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12064','2006-02-14T15:16:03.000','298','284',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12065','2005-08-17T21:31:46.000','3644','77','2005-08-26T02:26:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12066','2006-02-14T15:16:03.000','2474','267',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12067','2005-08-17T21:36:47.000','2013','514','2005-08-22T01:10:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12068','2005-08-17T21:37:08.000','4327','388','2005-08-26T00:10:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12069','2005-08-17T21:39:40.000','631','389','2005-08-22T01:12:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12070','2005-08-17T21:46:47.000','1357','158','2005-08-22T22:59:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12071','2005-08-17T21:49:14.000','1874','507','2005-08-22T18:20:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12072','2005-08-17T21:50:25.000','209','61','2005-08-25T22:36:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12073','2005-08-17T21:50:39.000','2939','173','2005-08-21T02:59:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12074','2005-08-17T21:50:57.000','711','417','2005-08-20T00:58:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12075','2005-08-17T21:54:55.000','3147','125','2005-08-23T23:04:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12076','2005-08-17T21:58:19.000','4278','298','2005-08-20T22:10:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12077','2005-08-17T21:59:14.000','3589','550','2005-08-22T03:23:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12078','2005-08-17T22:00:22.000','684','137','2005-08-24T02:54:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12079','2005-08-17T22:04:17.000','646','230','2005-08-24T20:22:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12080','2005-08-17T22:08:04.000','1491','394','2005-08-19T22:55:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12081','2005-08-17T22:10:46.000','620','597','2005-08-22T22:37:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12082','2005-08-17T22:13:15.000','3435','521','2005-08-24T18:30:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12083','2005-08-17T22:13:37.000','1985','474','2005-08-19T19:01:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12084','2005-08-17T22:16:49.000','2706','60','2005-08-24T17:42:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12085','2005-08-17T22:17:09.000','600','31','2005-08-21T01:45:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12086','2005-08-17T22:20:01.000','3963','140','2005-08-26T02:14:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12087','2005-08-17T22:20:12.000','324','144','2005-08-20T02:11:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12088','2005-08-17T22:20:16.000','1754','360','2005-08-25T23:30:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12089','2005-08-17T22:20:29.000','651','538','2005-08-24T02:12:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12090','2005-08-17T22:21:43.000','3392','391','2005-08-20T23:53:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12091','2005-08-17T22:22:50.000','2161','555','2005-08-27T03:55:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12092','2005-08-17T22:28:15.000','3964','38','2005-08-18T16:46:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12093','2005-08-17T22:28:40.000','216','141','2005-08-22T02:05:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12094','2005-08-17T22:31:04.000','1050','130','2005-08-23T22:45:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12095','2005-08-17T22:32:37.000','1089','46','2005-08-20T04:00:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12096','2005-08-17T22:32:50.000','44','463','2005-08-25T03:33:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12097','2005-08-17T22:35:24.000','4135','325','2005-08-18T20:31:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12098','2005-08-17T22:38:31.000','534','545','2005-08-20T01:56:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12099','2005-08-17T22:38:54.000','1743','195','2005-08-18T21:29:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12100','2005-08-17T22:41:10.000','4365','391','2005-08-24T21:31:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12101','2006-02-14T15:16:03.000','1556','479',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12102','2005-08-17T22:45:26.000','4268','392','2005-08-24T01:47:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12103','2005-08-17T22:49:09.000','4363','153','2005-08-24T21:53:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12104','2005-08-17T22:53:00.000','4551','16','2005-08-23T19:49:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12105','2005-08-17T22:54:45.000','2848','390','2005-08-21T00:33:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12106','2005-08-17T22:55:32.000','3234','465','2005-08-19T23:55:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12107','2005-08-17T22:56:24.000','1060','141','2005-08-24T19:36:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12108','2005-08-17T22:56:39.000','1675','207','2005-08-26T19:37:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12109','2005-08-17T22:58:35.000','1423','509','2005-08-25T19:44:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12110','2005-08-17T22:59:46.000','2984','511','2005-08-23T17:51:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12111','2005-08-17T22:59:55.000','2905','317','2005-08-22T19:33:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12112','2005-08-17T23:00:31.000','4290','576','2005-08-25T02:05:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12113','2005-08-17T23:01:00.000','2707','393','2005-08-25T03:57:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12114','2005-08-17T23:02:00.000','1405','65','2005-08-26T18:02:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12115','2005-08-17T23:04:15.000','1228','457','2005-08-20T22:25:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12116','2006-02-14T15:16:03.000','3082','560',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12117','2005-08-17T23:11:12.000','4140','303','2005-08-22T23:56:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12118','2005-08-17T23:14:25.000','158','89','2005-08-26T22:26:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12119','2005-08-17T23:16:44.000','4298','567','2005-08-20T02:13:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12120','2005-08-17T23:16:46.000','2912','323','2005-08-19T00:11:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12121','2005-08-17T23:20:40.000','3423','69','2005-08-22T21:30:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12122','2005-08-17T23:20:45.000','4030','375','2005-08-25T04:23:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12123','2005-08-17T23:22:18.000','361','497','2005-08-19T23:36:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12124','2005-08-17T23:22:46.000','2036','22','2005-08-21T01:40:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12125','2005-08-17T23:24:25.000','136','573','2005-08-25T03:08:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12126','2005-08-17T23:25:21.000','2304','302','2005-08-23T21:51:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12127','2006-02-14T15:16:03.000','4218','582',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12128','2005-08-17T23:31:09.000','2252','415','2005-08-24T05:07:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12129','2005-08-17T23:31:25.000','891','146','2005-08-26T19:10:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12130','2006-02-14T15:16:03.000','1358','516',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12131','2005-08-17T23:34:16.000','3380','21','2005-08-26T01:18:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12132','2005-08-17T23:37:03.000','2600','403','2005-08-22T04:53:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12133','2005-08-17T23:47:16.000','1958','132','2005-08-19T03:46:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12134','2005-08-17T23:49:43.000','2682','288','2005-08-21T21:00:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12135','2005-08-17T23:50:24.000','1019','381','2005-08-23T18:01:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12136','2005-08-17T23:51:30.000','3944','527','2005-08-23T01:35:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12137','2005-08-17T23:52:26.000','3632','109','2005-08-27T00:19:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12138','2005-08-17T23:55:54.000','388','317','2005-08-26T23:32:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12139','2005-08-17T23:57:13.000','1537','342','2005-08-24T19:13:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12140','2005-08-17T23:57:55.000','322','408','2005-08-21T20:09:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12141','2006-02-14T15:16:03.000','731','101',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12142','2005-08-18T00:04:12.000','3748','373','2005-08-24T01:24:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12143','2005-08-18T00:06:26.000','2876','117','2005-08-24T02:45:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12144','2006-02-14T15:16:03.000','512','587',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12145','2005-08-18T00:10:04.000','3482','5','2005-08-26T00:51:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12146','2005-08-18T00:10:04.000','3833','434','2005-08-25T19:18:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12147','2005-08-18T00:10:20.000','705','41','2005-08-23T20:36:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12148','2005-08-18T00:13:15.000','2409','254','2005-08-20T01:27:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12149','2005-08-18T00:13:51.000','3696','277','2005-08-26T19:47:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12150','2005-08-18T00:13:55.000','3781','555','2005-08-20T23:35:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12151','2005-08-18T00:14:03.000','1976','4','2005-08-18T23:52:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12152','2005-08-18T00:21:35.000','2797','367','2005-08-22T02:51:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12153','2005-08-18T00:22:30.000','3929','387','2005-08-23T04:13:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12154','2005-08-18T00:23:56.000','2491','163','2005-08-21T00:31:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12155','2005-08-18T00:24:30.000','2065','315','2005-08-18T19:12:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12156','2005-08-18T00:27:33.000','3270','212','2005-08-26T01:43:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12157','2005-08-18T00:33:45.000','2311','569','2005-08-22T19:33:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12158','2005-08-18T00:34:20.000','4121','289','2005-08-22T20:10:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12159','2005-08-18T00:36:09.000','2243','106','2005-08-27T06:31:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12160','2005-08-18T00:37:59.000','1328','481','2005-08-19T20:51:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12161','2005-08-18T00:41:46.000','2420','444','2005-08-26T22:59:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12162','2005-08-18T00:44:30.000','2697','284','2005-08-25T03:34:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12163','2005-08-18T00:46:01.000','1349','455','2005-08-22T06:16:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12164','2005-08-18T00:46:38.000','3849','587','2005-08-19T04:38:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12165','2005-08-18T00:53:37.000','4215','24','2005-08-27T00:09:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12166','2005-08-18T00:57:06.000','3627','184','2005-08-26T03:13:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12167','2005-08-18T01:00:02.000','3085','338','2005-08-21T00:04:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12168','2005-08-18T01:03:52.000','2859','535','2005-08-18T20:19:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12169','2005-08-18T01:05:54.000','2281','323','2005-08-24T02:16:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12170','2005-08-18T01:06:10.000','1125','289','2005-08-25T02:40:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12171','2005-08-18T01:06:13.000','454','457','2005-08-22T19:39:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12172','2005-08-18T01:07:00.000','1162','226','2005-08-22T21:01:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12173','2005-08-18T01:08:34.000','2830','41','2005-08-24T20:52:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12174','2005-08-18T01:08:53.000','1458','101','2005-08-20T03:28:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12175','2005-08-18T01:10:17.000','4558','328','2005-08-19T05:25:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12176','2005-08-18T01:10:33.000','3873','255','2005-08-24T02:45:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12177','2005-08-18T01:15:47.000','522','470','2005-08-24T23:23:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12178','2005-08-18T01:17:32.000','1152','276','2005-08-25T19:32:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12179','2005-08-18T01:21:21.000','1499','222','2005-08-19T00:59:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12180','2005-08-18T01:28:15.000','2276','20','2005-08-20T20:52:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12181','2005-08-18T01:28:18.000','532','81','2005-08-23T21:17:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12182','2005-08-18T01:30:19.000','296','555','2005-08-21T05:52:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12183','2005-08-18T01:34:13.000','3153','344','2005-08-24T04:38:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12184','2005-08-18T01:36:00.000','1723','51','2005-08-21T01:59:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12185','2005-08-18T01:40:14.000','1558','588','2005-08-25T05:04:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12186','2005-08-18T01:43:36.000','1342','312','2005-08-23T07:13:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12187','2005-08-18T01:45:50.000','3360','38','2005-08-22T20:12:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12188','2005-08-18T01:51:43.000','2989','456','2005-08-18T22:23:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12189','2005-08-18T01:51:44.000','1764','363','2005-08-26T01:01:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12190','2005-08-18T01:54:44.000','2464','28','2005-08-27T04:32:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12191','2005-08-18T01:57:11.000','2667','316','2005-08-22T22:53:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12192','2005-08-18T02:01:40.000','3450','270','2005-08-21T05:45:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12193','2005-08-18T02:03:59.000','1086','290','2005-08-25T05:32:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12194','2005-08-18T02:04:47.000','292','558','2005-08-25T20:45:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12195','2005-08-18T02:07:49.000','943','347','2005-08-19T23:54:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12196','2005-08-18T02:08:48.000','4302','111','2005-08-26T00:39:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12197','2005-08-18T02:08:58.000','3687','564','2005-08-26T21:54:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12198','2005-08-18T02:09:20.000','1628','86','2005-08-21T21:28:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12199','2005-08-18T02:09:23.000','424','96','2005-08-22T20:33:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12200','2005-08-18T02:12:33.000','840','52','2005-08-18T20:47:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12201','2005-08-18T02:14:06.000','3676','540','2005-08-23T04:44:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12202','2005-08-18T02:14:08.000','672','563','2005-08-24T04:35:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12203','2005-08-18T02:18:52.000','4228','591','2005-08-22T21:01:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12204','2005-08-18T02:20:35.000','304','575','2005-08-26T01:27:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12205','2005-08-18T02:21:08.000','774','437','2005-08-27T00:08:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12206','2005-08-18T02:22:20.000','3275','254','2005-08-23T05:36:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12207','2005-08-18T02:24:07.000','3745','265','2005-08-22T07:53:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12208','2005-08-18T02:25:25.000','2039','551','2005-08-20T04:53:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12209','2005-08-18T02:27:20.000','279','243','2005-08-21T00:41:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12210','2005-08-18T02:27:29.000','3035','217','2005-08-20T23:32:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12211','2005-08-18T02:31:18.000','1484','19','2005-08-26T02:36:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12212','2005-08-18T02:33:29.000','3898','449','2005-08-25T07:10:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12213','2005-08-18T02:33:55.000','4058','157','2005-08-24T03:14:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12214','2005-08-18T02:34:22.000','2094','231','2005-08-21T07:48:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12215','2005-08-18T02:35:39.000','4095','47','2005-08-24T00:36:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12216','2005-08-18T02:37:07.000','4139','131','2005-08-19T02:09:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12217','2005-08-18T02:44:44.000','2556','105','2005-08-24T03:27:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12218','2005-08-18T02:48:14.000','1933','70','2005-08-21T01:52:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12219','2005-08-18T02:49:54.000','2249','271','2005-08-23T07:52:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12220','2005-08-18T02:50:02.000','982','530','2005-08-22T00:20:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12221','2005-08-18T02:50:51.000','2488','98','2005-08-27T06:22:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12222','2006-02-14T15:16:03.000','3949','22',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12223','2005-08-18T02:58:40.000','4142','397','2005-08-23T23:30:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12224','2005-08-18T02:59:09.000','1781','372','2005-08-19T06:22:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12225','2005-08-18T03:00:11.000','1876','306','2005-08-24T05:01:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12226','2005-08-18T03:00:48.000','682','234','2005-08-25T00:43:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12227','2005-08-18T03:04:28.000','3671','591','2005-08-21T08:52:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12228','2005-08-18T03:08:10.000','2772','9','2005-08-20T02:48:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12229','2005-08-18T03:08:23.000','1123','382','2005-08-22T03:42:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12230','2005-08-18T03:11:04.000','1910','231','2005-08-27T04:06:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12231','2005-08-18T03:11:44.000','1115','231','2005-08-24T03:26:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12232','2005-08-18T03:14:14.000','2399','87','2005-08-19T05:44:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12233','2005-08-18T03:16:54.000','174','535','2005-08-22T04:48:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12234','2005-08-18T03:17:33.000','3823','352','2005-08-25T04:44:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12235','2005-08-18T03:17:50.000','957','595','2005-08-20T02:49:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12236','2005-08-18T03:19:29.000','1190','474','2005-08-23T07:39:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12237','2005-08-18T03:24:38.000','4422','381','2005-08-25T09:05:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12238','2005-08-18T03:25:08.000','4043','46','2005-08-20T02:41:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12239','2005-08-18T03:26:42.000','1948','75','2005-08-24T23:48:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12240','2005-08-18T03:27:11.000','1168','30','2005-08-26T04:34:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12241','2005-08-18T03:33:17.000','1261','248','2005-08-21T03:13:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12242','2005-08-18T03:37:31.000','2095','121','2005-08-25T06:50:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12243','2005-08-18T03:38:54.000','1829','354','2005-08-27T06:56:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12244','2005-08-18T03:39:11.000','4441','362','2005-08-21T02:57:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12245','2005-08-18T03:46:40.000','2960','576','2005-08-24T22:27:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12246','2005-08-18T03:48:41.000','3199','258','2005-08-25T05:12:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12247','2005-08-18T03:51:51.000','2264','254','2005-08-24T05:36:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12248','2005-08-18T03:53:18.000','2120','562','2005-08-22T04:53:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12249','2005-08-18T03:53:34.000','3586','135','2005-08-21T01:14:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12250','2005-08-18T03:57:29.000','921','1','2005-08-22T23:05:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12251','2005-08-18T03:59:02.000','3044','276','2005-08-19T02:38:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12252','2005-08-18T03:59:51.000','127','350','2005-08-25T08:54:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12253','2005-08-18T04:00:50.000','566','446','2005-08-19T04:43:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12254','2005-08-18T04:05:29.000','2858','6','2005-08-23T04:17:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12255','2005-08-18T04:07:20.000','2100','266','2005-08-21T22:19:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12256','2005-08-18T04:09:39.000','2975','572','2005-08-22T01:53:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12257','2005-08-18T04:11:03.000','269','87','2005-08-25T01:20:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12258','2005-08-18T04:11:13.000','2861','83','2005-08-21T23:40:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12259','2005-08-18T04:14:35.000','2904','429','2005-08-18T22:30:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12260','2005-08-18T04:15:43.000','1352','150','2005-08-26T23:31:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12261','2005-08-18T04:16:06.000','4076','485','2005-08-27T08:04:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12262','2005-08-18T04:16:15.000','591','125','2005-08-20T09:16:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12263','2005-08-18T04:16:18.000','4053','131','2005-08-21T07:22:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12264','2005-08-18T04:17:33.000','3073','87','2005-08-26T08:07:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12265','2005-08-18T04:22:01.000','537','247','2005-08-20T03:22:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12266','2005-08-18T04:22:31.000','2192','467','2005-08-19T04:25:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12267','2005-08-18T04:24:30.000','652','388','2005-08-26T03:01:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12268','2005-08-18T04:26:54.000','93','39','2005-08-23T06:40:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12269','2005-08-18T04:27:54.000','724','573','2005-08-25T07:03:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12270','2005-08-18T04:32:05.000','2456','190','2005-08-21T01:37:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12271','2005-08-18T04:33:11.000','3866','471','2005-08-20T23:10:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12272','2005-08-18T04:39:10.000','1964','15','2005-08-24T09:41:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12273','2005-08-18T04:40:50.000','3539','431','2005-08-25T01:44:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12274','2005-08-18T04:41:47.000','265','47','2005-08-27T07:00:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12275','2005-08-18T04:42:02.000','1474','507','2005-08-25T00:50:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12276','2005-08-18T04:43:22.000','4491','397','2005-08-22T01:49:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12277','2006-02-14T15:16:03.000','407','33',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12278','2005-08-18T04:46:45.000','3205','294','2005-08-24T08:59:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12279','2005-08-18T04:47:30.000','4159','421','2005-08-19T09:47:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12280','2005-08-18T04:49:27.000','4032','46','2005-08-21T03:39:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12281','2005-08-18T04:50:32.000','4576','417','2005-08-21T00:14:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12282','2005-08-18T04:54:20.000','3623','173','2005-08-23T05:28:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12283','2005-08-18T04:54:25.000','574','240','2005-08-23T04:02:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12284','2005-08-18T04:55:49.000','3162','147','2005-08-22T08:45:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12285','2005-08-18T04:56:43.000','3531','215','2005-08-19T23:32:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12286','2005-08-18T04:57:59.000','3729','34','2005-08-18T23:20:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12287','2005-08-18T04:58:06.000','2238','136','2005-08-24T00:06:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12288','2005-08-18T05:01:20.000','4401','523','2005-08-25T09:51:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12289','2005-08-18T05:05:28.000','443','575','2005-08-26T09:02:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12290','2005-08-18T05:08:03.000','4100','283','2005-08-23T08:10:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12291','2005-08-18T05:08:37.000','4270','73','2005-08-23T09:01:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12292','2005-08-18T05:08:54.000','1417','58','2005-08-27T02:51:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12293','2005-08-18T05:13:36.000','614','514','2005-08-25T04:00:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12294','2005-08-18T05:14:44.000','2479','4','2005-08-27T01:32:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12295','2005-08-18T05:15:46.000','1651','532','2005-08-26T02:23:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12296','2005-08-18T05:16:28.000','2091','258','2005-08-22T10:32:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12297','2005-08-18T05:19:57.000','903','436','2005-08-21T00:53:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12298','2005-08-18T05:30:31.000','904','46','2005-08-27T07:33:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12299','2005-08-18T05:32:32.000','892','176','2005-08-22T08:14:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12300','2005-08-18T05:36:14.000','3213','540','2005-08-25T00:20:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12301','2005-08-18T05:36:20.000','2293','317','2005-08-23T03:15:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12302','2005-08-18T05:41:39.000','765','514','2005-08-22T06:02:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12303','2005-08-18T05:43:22.000','1604','245','2005-08-27T08:54:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12304','2005-08-18T05:44:29.000','1381','228','2005-08-24T04:31:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12305','2005-08-18T05:46:29.000','4463','534','2005-08-22T11:14:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12306','2005-08-18T05:47:55.000','3853','541','2005-08-21T01:56:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12307','2005-08-18T05:48:23.000','2679','187','2005-08-26T02:32:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12308','2005-08-18T05:48:53.000','2877','569','2005-08-22T09:03:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12309','2005-08-18T05:58:40.000','762','9','2005-08-20T02:20:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12310','2005-08-18T06:02:34.000','3814','385','2005-08-24T01:08:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12311','2005-08-18T06:07:00.000','1650','211','2005-08-21T07:54:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12312','2005-08-18T06:07:26.000','80','185','2005-08-21T02:07:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12313','2005-08-18T06:07:31.000','2053','180','2005-08-27T00:20:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12314','2005-08-18T06:10:02.000','2204','455','2005-08-25T02:48:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12315','2005-08-18T06:15:06.000','2012','579','2005-08-24T07:45:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12316','2005-08-18T06:16:09.000','4325','94','2005-08-27T05:54:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12317','2005-08-18T06:17:06.000','90','510','2005-08-22T08:56:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12318','2005-08-18T06:21:56.000','3694','332','2005-08-27T06:07:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12319','2005-08-18T06:26:45.000','999','368','2005-08-23T01:35:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12320','2005-08-18T06:26:51.000','3248','267','2005-08-20T04:00:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12321','2005-08-18T06:27:05.000','516','274','2005-08-24T02:26:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12322','2005-08-18T06:35:28.000','4235','365','2005-08-23T07:34:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12323','2005-08-18T06:36:22.000','4107','336','2005-08-26T11:36:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12324','2005-08-18T06:38:20.000','2436','221','2005-08-20T02:28:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12325','2005-08-18T06:41:30.000','1844','404','2005-08-26T02:49:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12326','2005-08-18T06:41:59.000','1865','114','2005-08-19T10:16:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12327','2005-08-18T06:43:22.000','2425','261','2005-08-25T10:50:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12328','2005-08-18T06:43:56.000','1355','77','2005-08-23T10:19:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12329','2005-08-18T06:44:30.000','3127','397','2005-08-25T04:05:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12330','2005-08-18T06:46:33.000','889','587','2005-08-26T11:35:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12331','2005-08-18T06:47:19.000','4565','483','2005-08-25T05:51:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12332','2005-08-18T06:51:05.000','627','235','2005-08-20T04:28:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12333','2005-08-18T06:51:39.000','4370','18','2005-08-21T01:44:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12334','2005-08-18T06:52:36.000','2629','160','2005-08-25T12:06:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12335','2005-08-18T06:59:15.000','2776','150','2005-08-20T06:47:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12336','2005-08-18T06:59:41.000','2484','75','2005-08-23T01:36:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12337','2005-08-18T07:02:24.000','4221','117','2005-08-20T10:11:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12338','2005-08-18T07:04:24.000','274','408','2005-08-19T08:36:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12339','2005-08-18T07:05:06.000','1600','370','2005-08-19T02:27:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12340','2005-08-18T07:07:01.000','3561','239','2005-08-20T05:06:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12341','2005-08-18T07:09:27.000','130','154','2005-08-21T03:44:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12342','2005-08-18T07:12:46.000','1408','63','2005-08-21T07:44:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12343','2005-08-18T07:15:13.000','448','507','2005-08-27T11:07:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12344','2005-08-18T07:15:19.000','3675','269','2005-08-24T04:58:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12345','2005-08-18T07:16:58.000','2359','44','2005-08-25T05:50:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12346','2005-08-18T07:17:55.000','1200','265','2005-08-21T11:35:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12347','2005-08-18T07:18:10.000','1788','454','2005-08-19T05:49:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12348','2005-08-18T07:21:47.000','434','186','2005-08-25T04:41:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12349','2005-08-18T07:23:42.000','4191','545','2005-08-19T04:25:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12350','2005-08-18T07:29:46.000','1333','172','2005-08-21T12:50:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12351','2005-08-18T07:32:12.000','2299','95','2005-08-24T04:29:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12352','2006-02-14T15:16:03.000','643','155',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12353','2005-08-18T07:33:08.000','1594','141','2005-08-21T03:42:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12354','2005-08-18T07:34:07.000','2913','499','2005-08-26T05:56:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12355','2005-08-18T07:36:23.000','4112','452','2005-08-20T08:59:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12356','2005-08-18T07:37:05.000','493','529','2005-08-24T10:49:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12357','2005-08-18T07:40:52.000','166','19','2005-08-22T02:51:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12358','2005-08-18T07:41:43.000','504','16','2005-08-20T03:46:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12359','2005-08-18T07:44:05.000','4172','28','2005-08-19T02:26:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12360','2005-08-18T07:46:35.000','929','123','2005-08-26T12:01:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12361','2005-08-18T07:47:31.000','1418','250','2005-08-22T12:08:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12362','2005-08-18T07:48:05.000','3131','367','2005-08-20T05:16:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12363','2005-08-18T07:52:49.000','3447','181','2005-08-26T03:20:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12364','2005-08-18T07:55:09.000','3398','84','2005-08-19T05:29:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12365','2005-08-18T07:55:09.000','4350','303','2005-08-24T05:42:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12366','2005-08-18T07:55:14.000','3799','115','2005-08-22T06:12:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12367','2005-08-18T07:57:14.000','1822','7','2005-08-27T07:07:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12368','2005-08-18T07:57:38.000','3777','392','2005-08-25T05:49:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12369','2005-08-18T07:57:43.000','484','337','2005-08-26T09:36:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12370','2005-08-18T07:57:47.000','3343','503','2005-08-22T11:32:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12371','2005-08-18T08:02:46.000','622','451','2005-08-19T02:50:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12372','2005-08-18T08:04:35.000','2982','131','2005-08-27T08:13:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12373','2005-08-18T08:07:25.000','777','367','2005-08-27T03:41:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12374','2005-08-18T08:07:45.000','939','74','2005-08-26T10:42:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12375','2005-08-18T08:20:08.000','3508','365','2005-08-21T08:50:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12376','2005-08-18T08:20:29.000','852','116','2005-08-20T13:20:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12377','2005-08-18T08:26:05.000','4564','31','2005-08-23T02:51:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12378','2005-08-18T08:26:13.000','4418','266','2005-08-19T07:21:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12379','2005-08-18T08:26:48.000','2879','99','2005-08-19T10:08:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12380','2005-08-18T08:27:28.000','55','215','2005-08-25T02:58:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12381','2005-08-18T08:31:43.000','3651','190','2005-08-23T12:24:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12382','2005-08-18T08:32:33.000','3049','566','2005-08-26T03:45:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12383','2005-08-18T08:36:03.000','1641','295','2005-08-23T03:30:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12384','2005-08-18T08:36:58.000','2557','193','2005-08-23T05:08:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12385','2005-08-18T08:39:33.000','3143','146','2005-08-21T14:22:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12386','2005-08-18T08:45:57.000','3303','199','2005-08-24T04:50:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12387','2005-08-18T08:46:24.000','3604','530','2005-08-21T02:56:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12388','2005-08-18T08:48:09.000','4016','555','2005-08-26T09:05:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12389','2005-08-18T08:48:36.000','1891','394','2005-08-22T08:59:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12390','2005-08-18T08:51:42.000','3603','377','2005-08-23T13:06:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12391','2005-08-18T08:52:53.000','1507','307','2005-08-22T12:15:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12392','2005-08-18T08:57:58.000','2695','113','2005-08-25T05:20:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12393','2005-08-18T09:02:41.000','2435','396','2005-08-26T12:47:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12394','2005-08-18T09:05:15.000','3605','330','2005-08-23T11:10:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12395','2005-08-18T09:06:30.000','2020','541','2005-08-21T12:09:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12396','2005-08-18T09:11:23.000','3624','40','2005-08-26T05:35:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12397','2005-08-18T09:12:52.000','1872','371','2005-08-27T10:44:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12398','2005-08-18T09:13:24.000','4247','321','2005-08-27T14:58:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12399','2005-08-18T09:13:42.000','3950','347','2005-08-27T11:44:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12400','2005-08-18T09:19:12.000','1767','10','2005-08-26T06:52:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12401','2005-08-18T09:20:51.000','4314','479','2005-08-21T05:50:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12402','2005-08-18T09:27:34.000','385','123','2005-08-25T13:10:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12403','2005-08-18T09:31:05.000','2124','440','2005-08-23T09:54:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12404','2005-08-18T09:36:34.000','1097','342','2005-08-23T10:12:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12405','2005-08-18T09:37:30.000','228','266','2005-08-27T13:11:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12406','2005-08-18T09:38:02.000','4368','510','2005-08-22T12:56:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12407','2005-08-18T09:39:26.000','391','220','2005-08-24T05:19:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12408','2005-08-18T09:40:38.000','2360','143','2005-08-19T04:45:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12409','2005-08-18T09:43:58.000','2568','64','2005-08-19T15:02:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12410','2005-08-18T09:45:33.000','1904','210','2005-08-27T08:50:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12411','2005-08-18T09:47:57.000','1234','181','2005-08-21T05:54:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12412','2005-08-18T09:49:52.000','1578','75','2005-08-23T12:32:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12413','2005-08-18T09:50:34.000','3466','366','2005-08-23T05:57:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12414','2005-08-18T09:50:40.000','4454','32','2005-08-26T06:45:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12415','2005-08-18T09:54:01.000','392','443','2005-08-24T15:41:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12416','2005-08-18T09:56:48.000','3784','515','2005-08-22T12:34:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12417','2005-08-18T09:57:00.000','3500','71','2005-08-19T08:56:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12418','2005-08-18T09:59:36.000','4186','241','2005-08-19T11:35:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12419','2005-08-18T10:01:48.000','3111','133','2005-08-19T13:40:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12420','2005-08-18T10:01:50.000','452','477','2005-08-22T08:14:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12421','2005-08-18T10:04:06.000','4067','158','2005-08-24T08:45:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12422','2005-08-18T10:13:12.000','1855','451','2005-08-20T14:36:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12423','2005-08-18T10:14:52.000','1014','470','2005-08-26T13:16:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12424','2005-08-18T10:16:57.000','2055','319','2005-08-27T04:41:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12425','2005-08-18T10:18:06.000','2000','405','2005-08-27T08:16:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12426','2005-08-18T10:24:11.000','799','75','2005-08-22T15:34:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12427','2005-08-18T10:24:17.000','1759','333','2005-08-27T14:22:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12428','2005-08-18T10:24:21.000','3735','121','2005-08-24T05:12:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12429','2005-08-18T10:26:46.000','2994','436','2005-08-27T13:23:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12430','2005-08-18T10:32:41.000','2840','196','2005-08-22T16:16:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12431','2005-08-18T10:34:59.000','4461','89','2005-08-22T14:42:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12432','2005-08-18T10:35:13.000','2543','263','2005-08-26T08:20:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12433','2005-08-18T10:37:49.000','1776','552','2005-08-19T08:00:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12434','2005-08-18T10:38:08.000','3078','314','2005-08-22T16:14:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12435','2005-08-18T10:38:31.000','3211','160','2005-08-26T15:18:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12436','2005-08-18T10:41:05.000','3761','499','2005-08-23T07:36:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12437','2005-08-18T10:42:43.000','4036','467','2005-08-26T11:58:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12438','2005-08-18T10:42:52.000','2043','186','2005-08-25T11:42:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12439','2005-08-18T10:44:57.000','3204','153','2005-08-22T06:51:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12440','2005-08-18T10:47:35.000','2779','474','2005-08-21T11:10:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12441','2005-08-18T10:47:57.000','2163','561','2005-08-26T07:11:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12442','2005-08-18T10:50:07.000','78','270','2005-08-21T08:06:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12443','2005-08-18T10:50:59.000','2048','233','2005-08-26T07:48:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12444','2005-08-18T10:53:12.000','1639','285','2005-08-19T13:54:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12445','2005-08-18T10:56:20.000','3347','350','2005-08-21T16:46:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12446','2005-08-18T10:56:29.000','2138','448','2005-08-23T05:30:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12447','2005-08-18T10:57:01.000','4084','469','2005-08-27T06:05:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12448','2005-08-18T10:59:04.000','3889','72','2005-08-21T06:45:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12449','2005-08-18T11:03:04.000','663','285','2005-08-19T07:34:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12450','2005-08-18T11:04:04.000','3439','518','2005-08-22T07:24:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12451','2005-08-18T11:04:42.000','2780','183','2005-08-20T08:20:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12452','2005-08-18T11:14:35.000','4260','358','2005-08-27T09:09:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12453','2005-08-18T11:17:07.000','2487','104','2005-08-25T12:34:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12454','2005-08-18T11:19:02.000','4219','184','2005-08-19T12:00:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12455','2005-08-18T11:19:47.000','4478','46','2005-08-22T16:08:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12456','2005-08-18T11:21:51.000','4578','85','2005-08-21T13:28:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12457','2006-02-14T15:16:03.000','2145','80',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12458','2005-08-18T11:22:53.000','4579','277','2005-08-22T14:30:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12459','2005-08-18T11:25:11.000','421','39','2005-08-22T06:13:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12460','2005-08-18T11:25:13.000','3550','419','2005-08-27T06:27:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12461','2005-08-18T11:28:14.000','1569','27','2005-08-21T09:47:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12462','2005-08-18T11:28:55.000','890','574','2005-08-20T12:06:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12463','2005-08-18T11:31:34.000','30','214','2005-08-23T12:04:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12464','2005-08-18T11:33:34.000','1954','157','2005-08-27T14:33:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12465','2005-08-18T11:35:02.000','1733','486','2005-08-21T11:52:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12466','2005-08-18T11:36:55.000','2686','462','2005-08-23T13:46:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12467','2005-08-18T11:40:09.000','1414','212','2005-08-19T13:33:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12468','2005-08-18T11:41:47.000','1689','80','2005-08-24T16:43:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12469','2005-08-18T11:53:07.000','2395','237','2005-08-24T16:00:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12470','2005-08-18T11:55:42.000','1290','82','2005-08-24T08:27:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12471','2005-08-18T11:57:00.000','242','101','2005-08-26T13:17:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12472','2005-08-18T11:58:48.000','4458','297','2005-08-27T16:37:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12473','2005-08-18T11:59:44.000','1237','303','2005-08-21T13:38:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12474','2005-08-18T12:10:03.000','2240','78','2005-08-27T17:05:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12475','2005-08-18T12:14:21.000','3118','401','2005-08-24T14:43:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12476','2005-08-18T12:22:40.000','2784','122','2005-08-20T17:29:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12477','2005-08-18T12:25:01.000','4516','74','2005-08-25T17:25:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12478','2005-08-18T12:25:16.000','4512','42','2005-08-22T06:27:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12479','2005-08-18T12:26:37.000','1119','401','2005-08-21T18:08:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12480','2005-08-18T12:26:43.000','3339','446','2005-08-26T13:23:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12481','2005-08-18T12:31:34.000','2424','218','2005-08-21T16:08:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12482','2005-08-18T12:37:36.000','3778','247','2005-08-26T09:53:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12483','2005-08-18T12:38:37.000','1805','488','2005-08-24T13:26:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12484','2005-08-18T12:39:37.000','3690','300','2005-08-24T08:47:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12485','2005-08-18T12:41:41.000','422','345','2005-08-22T16:38:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12486','2005-08-18T12:42:50.000','2991','515','2005-08-27T13:41:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12487','2005-08-18T12:45:24.000','2554','485','2005-08-22T12:39:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12488','2005-08-18T12:48:22.000','3323','29','2005-08-19T16:19:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12489','2006-02-14T15:16:03.000','387','60',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12490','2005-08-18T12:48:45.000','1577','187','2005-08-27T15:53:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12491','2005-08-18T12:48:45.000','2354','247','2005-08-22T12:40:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12492','2005-08-18T12:49:04.000','2839','224','2005-08-26T17:55:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12493','2005-08-18T12:53:38.000','3029','487','2005-08-27T13:15:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12494','2005-08-18T12:53:49.000','3845','522','2005-08-26T15:52:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12495','2005-08-18T12:56:37.000','1225','102','2005-08-22T06:58:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12496','2005-08-18T12:58:25.000','456','489','2005-08-27T18:43:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12497','2005-08-18T12:58:40.000','824','388','2005-08-24T08:24:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12498','2005-08-18T13:01:08.000','1063','408','2005-08-21T13:12:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12499','2005-08-18T13:05:37.000','2611','42','2005-08-19T07:41:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12500','2005-08-18T13:05:51.000','36','310','2005-08-19T14:54:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12501','2005-08-18T13:13:13.000','728','173','2005-08-23T07:24:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12502','2005-08-18T13:16:31.000','2153','235','2005-08-19T17:47:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12503','2005-08-18T13:16:46.000','3548','379','2005-08-19T10:24:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12504','2005-08-18T13:17:07.000','4429','44','2005-08-24T09:13:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12505','2005-08-18T13:17:30.000','3741','406','2005-08-23T18:03:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12506','2006-02-14T15:16:03.000','1132','114',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12507','2005-08-18T13:19:13.000','199','584','2005-08-27T11:48:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12508','2005-08-18T13:20:13.000','1059','29','2005-08-22T12:55:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12509','2005-08-18T13:21:52.000','2462','175','2005-08-20T12:14:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12510','2005-08-18T13:22:25.000','3051','394','2005-08-27T17:38:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12511','2005-08-18T13:23:19.000','919','447','2005-08-22T11:43:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12512','2005-08-18T13:28:27.000','3959','148','2005-08-26T19:08:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12513','2005-08-18T13:31:45.000','29','527','2005-08-25T08:26:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12514','2005-08-18T13:33:55.000','3310','400','2005-08-23T12:50:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12515','2005-08-18T13:39:26.000','2703','63','2005-08-22T09:05:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12516','2005-08-18T13:39:53.000','1332','302','2005-08-20T08:33:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12517','2005-08-18T13:40:20.000','2908','520','2005-08-27T14:04:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12518','2005-08-18T13:41:32.000','3860','264','2005-08-23T13:01:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12519','2005-08-18T13:42:14.000','2394','203','2005-08-24T16:44:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12520','2005-08-18T13:42:45.000','681','52','2005-08-23T12:54:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12521','2005-08-18T13:43:07.000','1022','369','2005-08-21T07:53:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12522','2005-08-18T13:45:40.000','4435','342','2005-08-27T17:05:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12523','2005-08-18T13:45:41.000','888','230','2005-08-27T10:46:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12524','2006-02-14T15:16:03.000','857','438',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12525','2005-08-18T13:48:31.000','2357','96','2005-08-23T13:04:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12526','2005-08-18T13:48:43.000','3541','54','2005-08-19T10:05:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12527','2005-08-18T13:48:46.000','2536','459','2005-08-26T13:31:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12528','2005-08-18T13:52:41.000','3381','398','2005-08-27T09:09:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12529','2005-08-18T13:53:36.000','1956','382','2005-08-19T18:20:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12530','2005-08-18T13:54:48.000','1054','521','2005-08-26T08:58:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12531','2005-08-18T13:57:50.000','2771','27','2005-08-22T09:46:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12532','2005-08-18T13:57:58.000','114','184','2005-08-24T14:58:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12533','2005-08-18T14:01:40.000','795','331','2005-08-20T15:32:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12534','2005-08-18T14:04:41.000','995','187','2005-08-25T16:57:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12535','2005-08-18T14:05:22.000','2944','516','2005-08-25T16:35:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12536','2005-08-18T14:06:06.000','2343','373','2005-08-25T14:21:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12537','2005-08-18T14:06:39.000','57','56','2005-08-25T09:36:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12538','2005-08-18T14:09:09.000','1373','118','2005-08-23T19:12:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12539','2005-08-18T14:10:09.000','3259','136','2005-08-19T19:44:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12540','2005-08-18T14:17:30.000','2826','304','2005-08-26T15:33:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12541','2005-08-18T14:18:30.000','4357','584','2005-08-26T10:24:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12542','2005-08-18T14:21:11.000','1920','230','2005-08-20T16:06:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12543','2005-08-18T14:23:55.000','330','324','2005-08-20T12:42:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12544','2005-08-18T14:25:51.000','3783','354','2005-08-26T18:42:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12545','2005-08-18T14:28:00.000','1988','168','2005-08-26T14:10:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12546','2005-08-18T14:29:37.000','610','30','2005-08-26T09:47:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12547','2005-08-18T14:29:39.000','3046','591','2005-08-22T16:52:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12548','2005-08-18T14:35:26.000','750','426','2005-08-27T18:58:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12549','2005-08-18T14:38:07.000','1010','377','2005-08-21T08:45:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12550','2005-08-18T14:40:38.000','4267','138','2005-08-19T13:33:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12551','2005-08-18T14:46:26.000','2195','15','2005-08-19T16:59:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12552','2005-08-18T14:46:34.000','4303','413','2005-08-20T11:02:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12553','2005-08-18T14:46:54.000','2893','454','2005-08-22T13:41:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12554','2005-08-18T14:47:28.000','715','404','2005-08-25T14:34:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12555','2005-08-18T14:49:22.000','4434','557','2005-08-26T14:11:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12556','2005-08-18T14:49:55.000','1984','3','2005-08-24T15:20:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12557','2005-08-18T14:51:03.000','313','364','2005-08-19T13:30:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12558','2005-08-18T14:52:35.000','167','289','2005-08-26T09:45:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12559','2005-08-18T14:53:58.000','39','513','2005-08-25T20:22:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12560','2005-08-18T14:54:19.000','829','596','2005-08-27T13:39:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12561','2005-08-18T14:58:51.000','812','392','2005-08-20T10:53:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12562','2005-08-18T15:00:03.000','529','212','2005-08-23T12:55:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12563','2005-08-18T15:08:29.000','2552','393','2005-08-27T15:15:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12564','2005-08-18T15:11:35.000','263','348','2005-08-22T11:45:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12565','2005-08-18T15:12:17.000','1284','211','2005-08-19T12:26:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12566','2005-08-18T15:13:04.000','1684','407','2005-08-21T19:29:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12567','2005-08-18T15:14:36.000','2931','308','2005-08-26T18:56:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12568','2005-08-18T15:15:44.000','2654','569','2005-08-22T19:32:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12569','2005-08-18T15:20:46.000','1009','29','2005-08-24T12:38:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12570','2005-08-18T15:23:31.000','3973','211','2005-08-22T09:59:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12571','2005-08-18T15:31:18.000','1013','591','2005-08-23T15:20:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12572','2005-08-18T15:32:54.000','1366','253','2005-08-21T10:30:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12573','2005-08-18T15:32:57.000','1416','182','2005-08-21T18:29:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12574','2006-02-14T15:16:03.000','177','317',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12575','2005-08-18T15:37:42.000','3441','117','2005-08-25T19:17:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12576','2005-08-18T15:38:31.000','329','119','2005-08-22T21:29:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12577','2005-08-18T15:39:46.000','4134','16','2005-08-25T18:05:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12578','2005-08-18T15:47:11.000','930','514','2005-08-21T10:55:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12579','2005-08-18T15:47:49.000','3021','547','2005-08-20T18:12:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12580','2005-08-18T15:49:08.000','1197','53','2005-08-24T11:03:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12581','2005-08-18T15:49:15.000','4309','70','2005-08-23T20:18:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12582','2005-08-18T15:51:12.000','4467','462','2005-08-20T12:05:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12583','2005-08-18T15:51:36.000','3090','108','2005-08-20T18:47:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12584','2005-08-18T15:51:36.000','4487','371','2005-08-25T19:21:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12585','2005-08-18T15:52:12.000','773','110','2005-08-22T21:00:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12586','2005-08-18T15:54:39.000','4245','460','2005-08-21T19:29:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12587','2005-08-18T16:03:13.000','3081','499','2005-08-25T19:30:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12588','2005-08-18T16:04:45.000','694','415','2005-08-23T20:30:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12589','2005-08-18T16:06:31.000','956','275','2005-08-27T17:20:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12590','2005-08-18T16:11:35.000','2624','308','2005-08-23T10:35:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12591','2005-08-18T16:16:41.000','723','546','2005-08-24T10:29:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12592','2005-08-18T16:17:50.000','1618','305','2005-08-25T20:20:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12593','2005-08-18T16:17:54.000','4092','72','2005-08-21T18:02:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12594','2005-08-18T16:24:24.000','4421','198','2005-08-25T15:45:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12595','2005-08-18T16:27:08.000','1662','286','2005-08-19T14:53:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12596','2005-08-18T16:29:35.000','3662','378','2005-08-24T16:48:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12597','2005-08-18T16:34:02.000','3804','474','2005-08-25T17:30:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12598','2005-08-18T16:34:03.000','3159','340','2005-08-22T16:44:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12599','2005-08-18T16:42:45.000','2032','34','2005-08-23T18:27:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12600','2005-08-18T16:44:24.000','1475','171','2005-08-25T17:28:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12601','2005-08-18T16:47:52.000','3099','598','2005-08-24T11:05:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12602','2005-08-18T16:49:50.000','2001','533','2005-08-21T11:13:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12603','2005-08-18T16:56:20.000','2769','119','2005-08-25T11:50:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12604','2005-08-18T16:58:48.000','4127','12','2005-08-19T19:36:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12605','2005-08-18T16:59:37.000','1359','496','2005-08-20T18:09:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12606','2005-08-18T17:02:21.000','359','275','2005-08-24T22:38:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12607','2005-08-18T17:03:49.000','2130','526','2005-08-19T18:29:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12608','2005-08-18T17:05:15.000','624','366','2005-08-23T17:00:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12609','2005-08-18T17:06:22.000','2327','486','2005-08-20T21:30:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12610','2006-02-14T15:16:03.000','3181','269',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12611','2005-08-18T17:09:42.000','1925','359','2005-08-24T11:57:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12612','2005-08-18T17:10:05.000','1035','129','2005-08-26T15:55:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12613','2005-08-18T17:16:01.000','3877','8','2005-08-23T18:40:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12614','2005-08-18T17:16:03.000','2233','60','2005-08-26T16:56:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12615','2005-08-18T17:16:07.000','2191','29','2005-08-27T12:57:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12616','2005-08-18T17:22:41.000','2952','476','2005-08-25T18:52:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12617','2005-08-18T17:22:48.000','3573','564','2005-08-24T17:40:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12618','2005-08-18T17:24:02.000','302','117','2005-08-19T15:22:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12619','2005-08-18T17:24:15.000','980','592','2005-08-21T15:56:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12620','2005-08-18T17:26:38.000','2663','221','2005-08-25T13:24:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12621','2005-08-18T17:31:36.000','4566','439','2005-08-24T16:43:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12622','2005-08-18T17:34:11.000','278','529','2005-08-24T16:10:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12623','2005-08-18T17:34:19.000','3670','177','2005-08-20T21:30:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12624','2005-08-18T17:35:00.000','1135','434','2005-08-27T12:18:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12625','2005-08-18T17:36:19.000','2645','108','2005-08-23T11:42:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12626','2005-08-18T17:36:45.000','4230','361','2005-08-26T17:12:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12627','2005-08-18T17:37:11.000','3760','150','2005-08-19T14:59:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12628','2005-08-18T17:40:25.000','3210','520','2005-08-25T13:39:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12629','2005-08-18T17:40:33.000','1705','459','2005-08-26T21:09:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12630','2005-08-18T17:49:28.000','1457','452','2005-08-24T12:23:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12631','2005-08-18T17:52:51.000','2782','339','2005-08-25T14:40:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12632','2005-08-18T17:54:21.000','827','381','2005-08-22T18:58:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12633','2005-08-18T17:55:38.000','4341','469','2005-08-23T17:19:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12634','2005-08-18T17:58:14.000','1037','549','2005-08-19T21:08:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12635','2005-08-18T18:00:23.000','331','15','2005-08-23T16:40:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12636','2005-08-18T18:00:29.000','1645','380','2005-08-26T20:08:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12637','2005-08-18T18:06:53.000','4005','145','2005-08-19T17:36:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12638','2005-08-18T18:11:39.000','2849','172','2005-08-25T21:54:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12639','2005-08-18T18:13:05.000','562','500','2005-08-27T16:00:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12640','2005-08-18T18:14:49.000','1715','544','2005-08-24T21:25:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12641','2005-08-18T18:18:08.000','776','467','2005-08-19T23:17:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12642','2005-08-18T18:19:16.000','2080','167','2005-08-20T17:30:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12643','2005-08-18T18:21:06.000','2245','165','2005-08-24T14:26:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12644','2005-08-18T18:22:27.000','1511','300','2005-08-26T00:01:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12645','2006-02-14T15:16:03.000','1658','457',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12646','2005-08-18T18:25:06.000','3103','388','2005-08-24T18:45:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12647','2005-08-18T18:29:51.000','323','520','2005-08-27T22:51:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12648','2005-08-18T18:30:21.000','3545','519','2005-08-25T19:17:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12649','2005-08-18T18:31:47.000','3201','530','2005-08-22T21:07:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12650','2005-08-18T18:33:20.000','3237','276','2005-08-21T17:45:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12651','2005-08-18T18:36:16.000','8','34','2005-08-22T22:01:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12652','2005-08-18T18:48:58.000','2118','9','2005-08-21T14:15:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12653','2005-08-18T18:53:17.000','3353','78','2005-08-26T14:08:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12654','2005-08-18T18:56:40.000','2217','438','2005-08-20T17:51:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12655','2005-08-18T18:57:44.000','859','533','2005-08-27T22:40:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12656','2005-08-18T18:58:35.000','3981','286','2005-08-21T00:41:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12657','2005-08-18T19:02:16.000','3621','100','2005-08-21T14:59:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12658','2005-08-18T19:05:42.000','4320','193','2005-08-19T19:08:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12659','2005-08-18T19:05:49.000','336','329','2005-08-24T22:12:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12660','2005-08-18T19:07:23.000','414','21','2005-08-27T17:20:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12661','2005-08-18T19:10:10.000','1547','333','2005-08-22T20:30:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12662','2005-08-18T19:10:41.000','1412','75','2005-08-23T16:59:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12663','2005-08-18T19:10:52.000','1163','375','2005-08-19T15:46:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12664','2005-08-18T19:10:54.000','2732','577','2005-08-25T19:19:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12665','2006-02-14T15:16:03.000','1701','410',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12666','2005-08-18T19:11:41.000','4156','251','2005-08-21T18:04:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12667','2005-08-18T19:11:45.000','104','545','2005-08-27T13:34:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12668','2005-08-18T19:16:47.000','1986','14','2005-08-19T16:31:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12669','2005-08-18T19:17:47.000','4530','433','2005-08-24T14:55:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12670','2005-08-18T19:17:58.000','1716','580','2005-08-23T20:54:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12671','2005-08-18T19:19:59.000','1734','577','2005-08-23T17:53:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12672','2006-02-14T15:16:03.000','1722','228',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12673','2005-08-18T19:21:56.000','4204','535','2005-08-26T22:44:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12674','2005-08-18T19:24:56.000','636','185','2005-08-26T22:16:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12675','2005-08-18T19:34:02.000','569','140','2005-08-23T13:36:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12676','2005-08-18T19:34:40.000','2581','393','2005-08-20T18:03:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12677','2005-08-18T19:36:05.000','1311','334','2005-08-22T21:23:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12678','2005-08-18T19:41:27.000','2504','181','2005-08-23T15:14:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12679','2005-08-18T19:42:11.000','1535','463','2005-08-25T01:01:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12680','2005-08-18T19:43:46.000','833','259','2005-08-27T00:08:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12681','2005-08-18T19:48:06.000','1570','518','2005-08-23T15:05:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12682','2006-02-14T15:16:03.000','1148','245',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12683','2005-08-18T19:50:43.000','1802','166','2005-08-26T00:47:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12684','2005-08-18T19:51:27.000','978','196','2005-08-19T15:56:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12685','2005-08-18T19:51:29.000','4283','114','2005-08-27T14:58:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12686','2005-08-18T19:55:09.000','501','385','2005-08-26T14:17:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12687','2005-08-18T19:57:39.000','3092','285','2005-08-27T01:36:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12688','2005-08-18T19:59:54.000','2315','65','2005-08-26T18:52:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12689','2005-08-18T20:06:34.000','1066','296','2005-08-22T20:11:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12690','2005-08-18T20:06:57.000','3574','361','2005-08-24T20:54:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12691','2005-08-18T20:07:46.000','3744','534','2005-08-26T18:49:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12692','2005-08-18T20:09:19.000','2781','273','2005-08-21T00:14:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12693','2005-08-18T20:10:19.000','1543','584','2005-08-25T21:11:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12694','2005-08-18T20:10:39.000','1741','268','2005-08-25T20:47:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12695','2005-08-18T20:11:35.000','446','483','2005-08-25T18:29:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12696','2005-08-18T20:13:08.000','3989','374','2005-08-19T18:02:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12697','2005-08-18T20:14:56.000','2774','152','2005-08-23T21:54:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12698','2006-02-14T15:16:03.000','3657','497',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12699','2005-08-18T20:20:59.000','3695','66','2005-08-22T17:00:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12700','2005-08-18T20:24:46.000','540','397','2005-08-23T21:50:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12701','2005-08-18T20:26:47.000','2337','489','2005-08-26T23:36:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12702','2005-08-18T20:30:33.000','1884','474','2005-08-27T01:22:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12703','2005-08-18T20:37:13.000','1278','453','2005-08-26T16:13:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12704','2005-08-18T20:43:00.000','51','93','2005-08-21T22:28:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12705','2005-08-18T20:44:14.000','2342','517','2005-08-23T20:46:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12706','2005-08-18T20:44:34.000','1079','170','2005-08-26T21:47:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12707','2005-08-18T20:52:02.000','1565','426','2005-08-25T19:03:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12708','2005-08-18T20:59:17.000','3448','28','2005-08-24T22:40:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12709','2005-08-18T20:59:51.000','3878','476','2005-08-26T01:21:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12710','2005-08-18T21:02:50.000','3011','310','2005-08-26T15:07:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12711','2005-08-18T21:03:32.000','2530','122','2005-08-26T17:31:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12712','2005-08-18T21:04:13.000','2628','444','2005-08-25T18:15:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12713','2005-08-18T21:07:28.000','1505','56','2005-08-24T17:46:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12714','2005-08-18T21:08:01.000','868','372','2005-08-27T17:09:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12715','2005-08-18T21:09:38.000','3768','266','2005-08-21T20:25:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12716','2006-02-14T15:16:03.000','858','570',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12717','2005-08-18T21:15:40.000','3551','167','2005-08-20T00:59:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12718','2005-08-18T21:21:44.000','3221','176','2005-08-20T01:01:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12719','2006-02-14T15:16:03.000','1094','87',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12720','2005-08-18T21:28:42.000','2676','419','2005-08-25T18:02:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12721','2005-08-18T21:30:12.000','1045','239','2005-08-22T22:45:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12722','2005-08-18T21:33:53.000','913','416','2005-08-27T23:47:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12723','2005-08-18T21:34:16.000','4167','430','2005-08-22T22:37:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12724','2005-08-18T21:37:20.000','2224','242','2005-08-27T21:56:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12725','2005-08-18T21:43:09.000','4071','51','2005-08-23T18:50:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12726','2005-08-18T21:44:46.000','20','397','2005-08-19T21:58:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12727','2005-08-18T21:45:15.000','15','178','2005-08-24T15:52:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12728','2005-08-18T21:47:48.000','3156','129','2005-08-25T16:13:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12729','2005-08-18T21:52:59.000','3711','424','2005-08-21T00:02:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12730','2005-08-18T21:55:01.000','75','7','2005-08-22T01:23:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12731','2005-08-18T21:55:38.000','1719','128','2005-08-23T20:30:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12732','2005-08-18T21:57:50.000','3307','535','2005-08-19T18:28:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12733','2005-08-18T21:59:00.000','3243','144','2005-08-24T02:25:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12734','2005-08-18T22:04:52.000','3619','121','2005-08-25T00:34:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12735','2005-08-18T22:04:54.000','3679','383','2005-08-23T21:19:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12736','2006-02-14T15:16:03.000','3591','244',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12737','2005-08-18T22:11:37.000','736','204','2005-08-26T04:08:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12738','2005-08-18T22:11:47.000','4313','589','2005-08-27T17:55:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12739','2005-08-18T22:15:18.000','4129','292','2005-08-27T00:37:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12740','2005-08-18T22:17:04.000','1157','330','2005-08-23T23:42:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12741','2005-08-18T22:17:05.000','2084','435','2005-08-25T20:07:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12742','2005-08-18T22:22:03.000','1742','68','2005-08-22T04:01:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12743','2005-08-18T22:22:31.000','2630','565','2005-08-27T00:31:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12744','2005-08-18T22:22:36.000','3815','593','2005-08-24T00:26:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12745','2005-08-18T22:22:45.000','262','24','2005-08-20T01:44:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12746','2006-02-14T15:16:03.000','1012','211',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12747','2005-08-18T22:28:22.000','4075','549','2005-08-22T22:25:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12748','2005-08-18T22:29:05.000','3249','373','2005-08-24T18:25:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12749','2005-08-18T22:31:21.000','828','388','2005-08-20T22:53:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12750','2005-08-18T22:32:39.000','3717','535','2005-08-26T01:54:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12751','2005-08-18T22:33:22.000','2791','352','2005-08-20T20:28:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12752','2005-08-18T22:33:36.000','3595','514','2005-08-27T23:55:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12753','2005-08-18T22:37:39.000','1494','470','2005-08-27T00:21:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12754','2005-08-18T22:37:41.000','4154','134','2005-08-27T20:17:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12755','2005-08-18T22:38:47.000','105','439','2005-08-22T23:58:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12756','2005-08-18T22:52:13.000','1840','89','2005-08-21T17:22:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12757','2005-08-18T22:57:45.000','1095','147','2005-08-21T22:43:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12758','2005-08-18T22:58:34.000','2279','30','2005-08-22T23:33:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12759','2006-02-14T15:16:03.000','4193','354',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12760','2005-08-18T23:03:19.000','4188','363','2005-08-24T17:53:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12761','2005-08-18T23:05:22.000','2684','364','2005-08-22T01:08:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12762','2005-08-18T23:06:54.000','3909','502','2005-08-21T18:30:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12763','2005-08-18T23:07:01.000','393','472','2005-08-21T18:45:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12764','2005-08-18T23:14:15.000','26','183','2005-08-22T20:23:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12765','2005-08-18T23:21:50.000','2244','298','2005-08-28T04:42:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12766','2005-08-18T23:25:20.000','3737','50','2005-08-27T04:43:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12767','2005-08-18T23:25:49.000','3351','432','2005-08-28T02:40:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12768','2005-08-18T23:26:11.000','1993','458','2005-08-19T20:31:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12769','2005-08-18T23:26:40.000','926','504','2005-08-25T03:03:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12770','2005-08-18T23:29:00.000','1654','575','2005-08-26T20:57:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12771','2005-08-18T23:29:23.000','3076','484','2005-08-22T17:31:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12772','2005-08-18T23:29:25.000','1179','397','2005-08-23T20:32:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12773','2005-08-18T23:32:19.000','4390','360','2005-08-27T04:40:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12774','2005-08-18T23:34:22.000','3601','21','2005-08-28T05:00:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12775','2005-08-18T23:35:56.000','4374','54','2005-08-26T18:37:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12776','2005-08-18T23:37:33.000','2345','55','2005-08-23T03:07:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12777','2005-08-18T23:39:22.000','3467','130','2005-08-27T20:28:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12778','2005-08-18T23:40:23.000','3626','290','2005-08-19T18:14:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12779','2005-08-18T23:44:00.000','1814','325','2005-08-26T05:27:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12780','2005-08-18T23:48:16.000','54','373','2005-08-20T18:13:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12781','2005-08-18T23:50:24.000','1187','168','2005-08-21T02:31:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12782','2005-08-18T23:56:23.000','1454','495','2005-08-25T18:47:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12783','2005-08-19T00:01:14.000','1109','503','2005-08-21T22:02:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12784','2005-08-19T00:02:46.000','447','513','2005-08-20T04:39:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12785','2005-08-19T00:05:49.000','4190','145','2005-08-21T04:39:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12786','2006-02-14T15:16:03.000','97','512',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12787','2005-08-19T00:07:58.000','2023','278','2005-08-24T00:42:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12788','2005-08-19T00:15:09.000','644','90','2005-08-27T21:54:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12789','2005-08-19T00:16:19.000','2412','557','2005-08-25T00:18:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12790','2005-08-19T00:16:54.000','1281','44','2005-08-26T02:00:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12791','2005-08-19T00:17:09.000','3594','573','2005-08-22T23:46:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12792','2006-02-14T15:16:03.000','1435','405',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12793','2005-08-19T00:20:36.000','1195','403','2005-08-28T02:43:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12794','2005-08-19T00:20:37.000','1586','336','2005-08-26T01:48:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12795','2005-08-19T00:21:52.000','2745','360','2005-08-22T22:13:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12796','2005-08-19T00:22:24.000','1285','368','2005-08-19T22:53:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12797','2005-08-19T00:24:08.000','1595','5','2005-08-21T22:53:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12798','2005-08-19T00:24:33.000','4244','534','2005-08-21T23:01:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12799','2005-08-19T00:27:01.000','3885','197','2005-08-22T03:30:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12800','2005-08-19T00:27:11.000','257','545','2005-08-22T01:08:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12801','2005-08-19T00:27:19.000','960','202','2005-08-26T03:10:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12802','2005-08-19T00:27:41.000','2461','462','2005-08-28T03:24:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12803','2005-08-19T00:28:21.000','1058','390','2005-08-23T02:02:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12804','2005-08-19T00:33:15.000','147','365','2005-08-28T02:16:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12805','2005-08-19T00:36:34.000','2964','345','2005-08-26T20:38:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12806','2005-08-19T00:37:26.000','4488','423','2005-08-23T18:49:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12807','2005-08-19T00:38:46.000','2323','513','2005-08-28T03:37:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12808','2005-08-19T00:40:41.000','3920','55','2005-08-21T06:39:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12809','2005-08-19T00:42:24.000','2005','22','2005-08-23T06:06:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12810','2005-08-19T00:44:10.000','1340','250','2005-08-22T22:30:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12811','2005-08-19T00:51:28.000','641','54','2005-08-24T01:57:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12812','2005-08-19T00:54:02.000','4024','450','2005-08-22T20:35:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12813','2005-08-19T00:54:22.000','3285','500','2005-08-19T21:17:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12814','2005-08-19T00:58:24.000','204','465','2005-08-21T05:46:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12815','2005-08-19T00:59:42.000','435','588','2005-08-25T21:43:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12816','2005-08-19T01:04:05.000','4051','342','2005-08-24T01:25:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12817','2005-08-19T01:04:35.000','1246','113','2005-08-25T21:14:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12818','2005-08-19T01:04:59.000','3069','528','2005-08-26T21:39:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12819','2005-08-19T01:05:05.000','1117','542','2005-08-22T05:50:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12820','2005-08-19T01:05:08.000','2936','127','2005-08-21T05:37:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12821','2005-08-19T01:07:02.000','3418','41','2005-08-23T01:22:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12822','2005-08-19T01:15:24.000','419','426','2005-08-20T06:38:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12823','2005-08-19T01:15:47.000','426','316','2005-08-22T05:32:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12824','2005-08-19T01:18:00.000','1875','247','2005-08-22T01:12:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12825','2005-08-19T01:23:58.000','4495','328','2005-08-20T00:19:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12826','2005-08-19T01:25:11.000','1277','439','2005-08-27T01:22:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12827','2005-08-19T01:27:23.000','880','253','2005-08-27T02:22:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12828','2005-08-19T01:37:47.000','4208','378','2005-08-24T22:31:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12829','2005-08-19T01:38:18.000','1129','326','2005-08-25T22:23:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12830','2005-08-19T01:40:25.000','4080','409','2005-08-20T23:49:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12831','2005-08-19T01:40:43.000','1916','183','2005-08-28T05:22:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12832','2005-08-19T01:41:44.000','2820','563','2005-08-24T23:15:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12833','2005-08-19T01:42:28.000','3723','59','2005-08-26T20:13:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12834','2005-08-19T01:47:30.000','757','133','2005-08-24T20:08:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12835','2005-08-19T01:47:45.000','1477','124','2005-08-26T00:58:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12836','2005-08-19T01:48:33.000','1380','196','2005-08-23T04:46:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12837','2005-08-19T01:51:09.000','2288','495','2005-08-22T07:14:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12838','2005-08-19T01:51:50.000','1207','308','2005-08-27T23:12:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12839','2005-08-19T01:53:43.000','1970','360','2005-08-28T02:27:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12840','2005-08-19T01:54:11.000','2098','182','2005-08-28T01:11:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12841','2005-08-19T01:55:55.000','4233','257','2005-08-24T02:56:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12842','2005-08-19T01:57:21.000','2540','119','2005-08-28T01:10:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12843','2005-08-19T01:58:54.000','3279','128','2005-08-20T00:20:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12844','2005-08-19T01:59:08.000','4146','584','2005-08-24T22:21:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12845','2005-08-19T02:02:37.000','1698','106','2005-08-22T01:08:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12846','2005-08-19T02:03:26.000','286','305','2005-08-25T07:39:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12847','2005-08-19T02:04:07.000','384','91','2005-08-23T20:13:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12848','2005-08-19T02:05:11.000','2833','539','2005-08-24T05:27:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12849','2005-08-19T02:05:37.000','3489','280','2005-08-23T07:00:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12850','2005-08-19T02:08:06.000','1816','440','2005-08-20T21:06:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12851','2005-08-19T02:12:12.000','3311','194','2005-08-25T23:51:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12852','2005-08-19T02:12:40.000','2446','260','2005-08-19T23:42:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12853','2005-08-19T02:15:32.000','3753','232','2005-08-27T21:26:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12854','2005-08-19T02:18:51.000','4577','362','2005-08-24T04:16:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12855','2005-08-19T02:18:58.000','2900','242','2005-08-19T20:50:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12856','2005-08-19T02:19:13.000','132','4','2005-08-23T07:49:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12857','2005-08-19T02:20:13.000','4307','443','2005-08-20T20:20:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12858','2005-08-19T02:22:16.000','3024','144','2005-08-26T07:25:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12859','2005-08-19T02:23:23.000','2289','139','2005-08-28T04:55:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12860','2005-08-19T02:24:41.000','778','548','2005-08-25T07:43:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12861','2005-08-19T02:30:24.000','3115','287','2005-08-22T08:23:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12862','2005-08-19T02:31:59.000','473','198','2005-08-26T08:16:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12863','2005-08-19T02:35:59.000','780','234','2005-08-21T21:13:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12864','2005-08-19T02:38:26.000','4481','465','2005-08-22T21:42:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12865','2005-08-19T02:38:50.000','3437','460','2005-08-21T02:33:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12866','2005-08-19T02:39:47.000','1766','229','2005-08-27T02:14:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12867','2005-08-19T02:40:11.000','4499','330','2005-08-20T04:01:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12868','2005-08-19T02:47:19.000','4054','551','2005-08-20T00:30:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12869','2005-08-19T02:50:36.000','3939','99','2005-08-26T21:38:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12870','2005-08-19T02:54:38.000','991','86','2005-08-27T00:45:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12871','2005-08-19T02:55:36.000','2625','217','2005-08-22T01:00:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12872','2005-08-19T02:57:37.000','1975','54','2005-08-22T23:23:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12873','2005-08-19T03:05:41.000','2140','138','2005-08-22T06:57:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12874','2005-08-19T03:07:57.000','848','254','2005-08-22T22:42:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12875','2005-08-19T03:10:21.000','1708','483','2005-08-26T01:00:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12876','2005-08-19T03:12:19.000','803','356','2005-08-20T02:24:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12877','2005-08-19T03:16:58.000','1016','40','2005-08-25T02:10:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12878','2005-08-19T03:17:08.000','1182','596','2005-08-23T03:44:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12879','2005-08-19T03:22:55.000','3556','210','2005-08-24T22:00:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12880','2005-08-19T03:27:17.000','3386','552','2005-08-28T06:16:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12881','2005-08-19T03:28:13.000','1432','121','2005-08-25T05:25:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12882','2005-08-19T03:33:46.000','911','153','2005-08-21T22:49:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12883','2005-08-19T03:33:47.000','964','555','2005-08-23T21:55:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12884','2005-08-19T03:34:04.000','2768','348','2005-08-28T01:00:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12885','2005-08-19T03:37:25.000','883','185','2005-08-20T22:10:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12886','2005-08-19T03:38:32.000','2157','174','2005-08-26T02:17:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12887','2005-08-19T03:38:54.000','1214','150','2005-08-27T08:45:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12888','2005-08-19T03:41:09.000','4398','146','2005-08-24T07:09:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12889','2005-08-19T03:41:31.000','4376','515','2005-08-27T00:46:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12890','2005-08-19T03:42:08.000','3831','150','2005-08-19T23:08:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12891','2006-02-14T15:16:03.000','2764','388',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12892','2005-08-19T03:46:34.000','1044','121','2005-08-21T05:11:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12893','2005-08-19T03:46:43.000','168','498','2005-08-20T08:38:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12894','2005-08-19T03:49:28.000','4581','541','2005-08-25T01:51:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12895','2005-08-19T03:50:48.000','4372','396','2005-08-26T09:13:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12896','2005-08-19T03:52:44.000','148','220','2005-08-24T22:27:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12897','2006-02-14T15:16:03.000','1512','178',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12898','2005-08-19T03:54:34.000','1555','586','2005-08-23T08:14:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12899','2005-08-19T04:03:34.000','830','105','2005-08-20T08:34:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12900','2005-08-19T04:03:49.000','849','408','2005-08-24T22:11:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12901','2006-02-14T15:16:03.000','2799','180',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12902','2006-02-14T15:16:03.000','464','91',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12903','2005-08-19T04:09:38.000','2340','302','2005-08-26T03:24:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12904','2005-08-19T04:10:50.000','459','257','2005-08-27T23:24:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12905','2005-08-19T04:13:37.000','1043','480','2005-08-26T23:52:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12906','2005-08-19T04:13:43.000','2060','401','2005-08-20T04:24:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12907','2005-08-19T04:16:13.000','2844','422','2005-08-27T02:43:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12908','2005-08-19T04:19:05.000','175','340','2005-08-25T09:50:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12909','2005-08-19T04:20:25.000','4300','210','2005-08-24T06:40:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12910','2005-08-19T04:23:13.000','3968','128','2005-08-20T22:27:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12911','2005-08-19T04:24:10.000','1770','367','2005-08-26T00:35:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12912','2005-08-19T04:24:35.000','1747','364','2005-08-27T07:13:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12913','2005-08-19T04:25:39.000','3719','356','2005-08-25T07:23:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12914','2005-08-19T04:25:59.000','4396','501','2005-08-23T08:04:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12915','2006-02-14T15:16:03.000','2651','516',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12916','2005-08-19T04:27:05.000','2277','157','2005-08-21T02:33:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12917','2005-08-19T04:27:11.000','107','152','2005-08-20T03:04:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12918','2005-08-19T04:31:36.000','972','13','2005-08-25T05:50:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12919','2005-08-19T04:32:15.000','2121','263','2005-08-24T05:56:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12920','2005-08-19T04:32:32.000','2516','511','2005-08-27T00:44:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12921','2005-08-19T04:47:48.000','781','234','2005-08-25T00:07:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12922','2005-08-19T04:48:48.000','342','25','2005-08-23T23:32:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12923','2005-08-19T04:50:20.000','1390','531','2005-08-22T10:42:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12924','2005-08-19T04:51:47.000','3807','519','2005-08-26T07:50:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12925','2005-08-19T04:59:01.000','3361','57','2005-08-27T02:03:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12926','2005-08-19T05:00:16.000','23','336','2005-08-26T06:12:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12927','2005-08-19T05:02:46.000','1171','223','2005-08-23T01:08:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12928','2005-08-19T05:04:09.000','4531','353','2005-08-24T09:09:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12929','2005-08-19T05:05:23.000','1531','310','2005-08-25T04:37:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12930','2005-08-19T05:11:32.000','4410','414','2005-08-22T02:20:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12931','2005-08-19T05:11:47.000','3070','407','2005-08-21T00:59:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12932','2005-08-19T05:17:30.000','2295','416','2005-08-21T09:24:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12933','2005-08-19T05:18:20.000','4103','589','2005-08-27T00:13:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12934','2005-08-19T05:18:42.000','3242','591','2005-08-24T10:42:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12935','2005-08-19T05:20:25.000','193','279','2005-08-21T03:10:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12936','2005-08-19T05:25:06.000','654','387','2005-08-28T08:21:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12937','2005-08-19T05:25:30.000','3826','348','2005-08-22T10:40:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12938','2006-02-14T15:16:03.000','3987','28',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12939','2005-08-19T05:38:25.000','3375','181','2005-08-23T23:52:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12940','2005-08-19T05:38:29.000','2222','340','2005-08-20T08:15:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12941','2005-08-19T05:39:26.000','2951','195','2005-08-22T09:50:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12942','2005-08-19T05:40:36.000','3938','103','2005-08-27T02:04:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12943','2005-08-19T05:46:26.000','3930','547','2005-08-22T03:26:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12944','2005-08-19T05:48:12.000','2956','148','2005-08-28T10:10:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12945','2005-08-19T05:51:46.000','3638','312','2005-08-23T11:22:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12946','2005-08-19T05:53:34.000','2066','444','2005-08-20T07:30:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12947','2005-08-19T05:54:21.000','935','499','2005-08-22T09:17:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12948','2005-08-19T05:55:14.000','4173','442','2005-08-22T01:05:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12949','2005-08-19T05:55:52.000','4209','279','2005-08-23T00:01:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12950','2005-08-19T05:55:58.000','1064','463','2005-08-23T08:05:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12951','2005-08-19T05:56:44.000','2143','70','2005-08-24T11:28:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12952','2005-08-19T06:00:52.000','2460','228','2005-08-20T02:17:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12953','2005-08-19T06:04:07.000','3954','429','2005-08-28T11:05:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12954','2005-08-19T06:04:34.000','3592','63','2005-08-28T02:12:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12955','2005-08-19T06:05:58.000','2040','410','2005-08-26T04:24:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12956','2005-08-19T06:06:26.000','3613','241','2005-08-28T08:37:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12957','2005-08-19T06:12:44.000','2219','512','2005-08-28T10:49:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12958','2005-08-19T06:19:21.000','4214','569','2005-08-20T02:21:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12959','2006-02-14T15:16:03.000','1540','284',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12960','2005-08-19T06:21:52.000','3498','152','2005-08-25T04:16:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12961','2005-08-19T06:22:37.000','4529','386','2005-08-23T00:49:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12962','2005-08-19T06:22:48.000','575','171','2005-08-27T07:47:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12963','2005-08-19T06:26:04.000','1521','2','2005-08-23T11:37:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12964','2005-08-19T06:29:13.000','2854','142','2005-08-22T12:23:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12965','2005-08-19T06:33:00.000','4308','430','2005-08-22T02:02:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12966','2005-08-19T06:37:48.000','3196','69','2005-08-26T03:59:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12967','2005-08-19T06:37:51.000','3404','170','2005-08-25T06:58:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12968','2005-08-19T06:38:18.000','3108','166','2005-08-20T08:29:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12969','2005-08-19T06:38:59.000','191','224','2005-08-25T09:09:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12970','2006-02-14T15:16:03.000','3999','216',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12971','2005-08-19T06:42:43.000','3504','492','2005-08-23T10:49:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12972','2005-08-19T06:43:28.000','1218','55','2005-08-27T11:30:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12973','2005-08-19T06:48:11.000','128','163','2005-08-22T07:18:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12974','2005-08-19T06:51:02.000','3599','218','2005-08-25T11:48:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12975','2005-08-19T06:51:19.000','3300','236','2005-08-25T04:22:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12976','2005-08-19T06:52:58.000','66','592','2005-08-26T11:23:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12977','2005-08-19T06:55:33.000','2004','388','2005-08-27T07:38:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12978','2005-08-19T06:57:27.000','3252','167','2005-08-20T09:10:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12979','2005-08-19T07:00:35.000','1227','267','2005-08-21T06:12:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12980','2005-08-19T07:03:14.000','1854','144','2005-08-26T05:07:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12981','2005-08-19T07:04:00.000','3925','481','2005-08-21T09:17:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12982','2005-08-19T07:06:34.000','1258','44','2005-08-21T06:53:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12983','2005-08-19T07:06:51.000','406','148','2005-08-28T10:35:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12984','2005-08-19T07:06:51.000','4211','537','2005-08-22T04:04:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12985','2005-08-19T07:08:05.000','4133','83','2005-08-24T02:25:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12986','2005-08-19T07:09:36.000','1145','210','2005-08-22T05:01:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12987','2005-08-19T07:11:44.000','3665','134','2005-08-20T04:17:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12988','2006-02-14T15:16:03.000','81','236',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12989','2005-08-19T07:19:04.000','2929','306','2005-08-21T10:58:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12990','2005-08-19T07:20:39.000','1825','360','2005-08-21T12:31:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12991','2005-08-19T07:21:24.000','2227','126','2005-08-21T04:31:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12992','2005-08-19T07:23:06.000','3022','597','2005-08-23T06:11:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12993','2005-08-19T07:24:03.000','4225','484','2005-08-26T07:15:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12994','2005-08-19T07:26:10.000','3809','506','2005-08-20T07:02:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12995','2005-08-19T07:26:30.000','2069','566','2005-08-25T12:47:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12996','2005-08-19T07:31:32.000','4445','380','2005-08-25T11:59:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12997','2005-08-19T07:31:46.000','1661','311','2005-08-24T09:20:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12998','2005-08-19T07:32:16.000','2301','354','2005-08-24T01:56:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('12999','2005-08-19T07:34:53.000','661','24','2005-08-26T03:57:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13000','2005-08-19T07:36:42.000','2341','141','2005-08-22T08:50:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13001','2005-08-19T07:36:44.000','2505','254','2005-08-22T13:06:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13002','2005-08-19T07:37:58.000','3892','477','2005-08-26T11:32:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13003','2005-08-19T07:39:29.000','3431','451','2005-08-23T05:48:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13004','2005-08-19T07:40:08.000','771','442','2005-08-20T11:49:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13005','2005-08-19T07:45:42.000','3417','104','2005-08-20T12:45:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13006','2005-08-19T07:47:16.000','3157','134','2005-08-21T06:17:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13007','2005-08-19T07:47:43.000','4280','430','2005-08-26T02:48:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13008','2006-02-14T15:16:03.000','1838','181',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13009','2005-08-19T07:50:35.000','677','376','2005-08-21T06:04:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13010','2005-08-19T07:52:21.000','825','413','2005-08-27T12:51:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13011','2005-08-19T07:53:58.000','1998','529','2005-08-24T12:00:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13012','2005-08-19T07:54:59.000','1690','145','2005-08-26T09:50:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13013','2005-08-19T07:55:51.000','841','293','2005-08-26T05:14:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13014','2005-08-19T07:56:08.000','3400','344','2005-08-21T10:20:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13015','2005-08-19T07:56:51.000','3461','126','2005-08-28T07:05:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13016','2005-08-19T07:57:14.000','3095','175','2005-08-23T03:29:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13017','2005-08-19T08:02:24.000','2160','104','2005-08-26T07:32:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13018','2005-08-19T08:04:50.000','2122','168','2005-08-26T11:46:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13019','2005-08-19T08:07:43.000','2827','597','2005-08-20T12:09:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13020','2005-08-19T08:07:50.000','4501','92','2005-08-28T11:42:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13021','2005-08-19T08:08:04.000','1242','309','2005-08-26T12:04:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13022','2006-02-14T15:16:03.000','2266','336',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13023','2005-08-19T08:13:54.000','1566','69','2005-08-27T13:18:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13024','2005-08-19T08:19:21.000','2917','401','2005-08-27T05:18:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13025','2006-02-14T15:16:03.000','4066','269',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13026','2005-08-19T08:22:45.000','3026','79','2005-08-21T09:31:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13027','2005-08-19T08:25:16.000','3756','128','2005-08-25T13:42:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13028','2005-08-19T08:27:23.000','2165','371','2005-08-24T03:46:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13029','2005-08-19T08:28:04.000','3283','293','2005-08-22T12:25:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13030','2005-08-19T08:28:11.000','2614','240','2005-08-24T07:20:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13031','2005-08-19T08:30:04.000','1525','567','2005-08-23T09:35:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13032','2005-08-19T08:31:50.000','3699','82','2005-08-23T04:00:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13033','2005-08-19T08:34:39.000','1682','344','2005-08-28T10:13:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13034','2005-08-19T08:41:29.000','990','387','2005-08-20T07:36:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13035','2005-08-19T08:46:45.000','4082','135','2005-08-22T11:42:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13036','2005-08-19T08:48:37.000','1469','20','2005-08-22T04:13:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13037','2005-08-19T08:53:57.000','65','275','2005-08-28T08:56:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13038','2005-08-19T08:55:16.000','2226','532','2005-08-25T12:23:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13039','2005-08-19T08:55:19.000','1952','370','2005-08-20T07:39:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13040','2005-08-19T09:04:24.000','4113','425','2005-08-23T12:36:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13041','2005-08-19T09:05:38.000','1576','462','2005-08-27T06:34:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13042','2005-08-19T09:06:08.000','1047','414','2005-08-22T13:46:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13043','2005-08-19T09:07:13.000','24','127','2005-08-27T07:49:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13044','2005-08-19T09:14:31.000','809','142','2005-08-20T11:16:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13045','2005-08-19T09:17:35.000','389','254','2005-08-23T12:04:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13046','2005-08-19T09:21:10.000','965','37','2005-08-26T13:00:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13047','2005-08-19T09:24:49.000','2704','394','2005-08-24T11:06:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13048','2005-08-19T09:25:06.000','1029','486','2005-08-28T11:18:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13049','2005-08-19T09:25:40.000','4122','53','2005-08-27T10:19:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13050','2005-08-19T09:31:23.000','3682','131','2005-08-26T06:56:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13051','2005-08-19T09:31:33.000','4064','90','2005-08-28T06:15:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13052','2005-08-19T09:31:42.000','3036','502','2005-08-28T15:11:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13053','2005-08-19T09:31:48.000','2044','140','2005-08-28T07:51:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13054','2005-08-19T09:34:02.000','2983','325','2005-08-23T05:25:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13055','2005-08-19T09:36:28.000','3580','485','2005-08-24T05:53:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13056','2006-02-14T15:16:03.000','3751','115',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13057','2005-08-19T09:40:05.000','876','105','2005-08-28T13:22:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13058','2005-08-19T09:40:53.000','2437','24','2005-08-26T05:48:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13059','2005-08-19T09:42:01.000','3810','341','2005-08-21T12:07:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13060','2005-08-19T09:43:25.000','507','22','2005-08-28T15:22:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13061','2005-08-19T09:43:39.000','730','576','2005-08-24T10:03:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13062','2005-08-19T09:44:17.000','1790','385','2005-08-27T11:42:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13063','2005-08-19T09:45:41.000','1192','5','2005-08-24T09:11:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13064','2005-08-19T09:46:53.000','4131','588','2005-08-21T08:29:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13065','2005-08-19T09:48:52.000','1887','518','2005-08-22T07:12:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13066','2005-08-19T09:50:39.000','3730','336','2005-08-22T14:01:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13067','2005-08-19T09:51:17.000','3825','172','2005-08-25T09:58:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13068','2005-08-19T09:55:16.000','3019','1','2005-08-20T14:44:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13069','2005-08-19T09:55:20.000','368','299','2005-08-24T04:10:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13070','2005-08-19T09:56:23.000','2214','235','2005-08-24T09:08:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13071','2005-08-19T10:01:07.000','527','578','2005-08-26T14:26:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13072','2005-08-19T10:03:30.000','2313','447','2005-08-22T14:27:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13073','2005-08-19T10:05:38.000','855','506','2005-08-26T07:37:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13074','2005-08-19T10:06:53.000','3266','341','2005-08-28T09:56:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13075','2005-08-19T10:10:10.000','4125','224','2005-08-21T08:44:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13076','2005-08-19T10:10:26.000','1226','201','2005-08-22T05:41:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13077','2005-08-19T10:15:19.000','433','241','2005-08-21T06:51:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13078','2005-08-19T10:16:43.000','4104','479','2005-08-27T11:35:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13079','2006-02-14T15:16:03.000','733','107',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13080','2005-08-19T10:18:00.000','4222','452','2005-08-22T06:37:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13081','2005-08-19T10:19:06.000','3077','170','2005-08-20T05:49:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13082','2005-08-19T10:19:19.000','2117','387','2005-08-28T05:02:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13083','2005-08-19T10:26:45.000','3469','455','2005-08-23T05:31:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13084','2005-08-19T10:27:25.000','3792','204','2005-08-26T07:32:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13085','2005-08-19T10:28:22.000','360','215','2005-08-22T07:37:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13086','2005-08-19T10:32:28.000','3712','350','2005-08-26T07:57:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13087','2005-08-19T10:33:52.000','2693','171','2005-08-27T09:15:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13088','2005-08-19T10:36:11.000','4281','457','2005-08-21T09:12:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13089','2005-08-19T10:38:56.000','1783','63','2005-08-24T12:41:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13090','2005-08-19T10:39:54.000','1447','52','2005-08-28T10:31:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13091','2005-08-19T10:40:10.000','1815','127','2005-08-23T09:03:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13092','2005-08-19T10:41:09.000','4359','480','2005-08-25T05:11:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13093','2005-08-19T10:46:16.000','1667','160','2005-08-26T08:05:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13094','2005-08-19T10:47:58.000','3178','494','2005-08-21T06:20:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13095','2005-08-19T10:48:10.000','520','508','2005-08-28T06:15:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13096','2005-08-19T10:49:03.000','420','13','2005-08-21T05:33:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13097','2005-08-19T10:50:43.000','4194','157','2005-08-24T11:10:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13098','2005-08-19T10:51:59.000','3770','51','2005-08-24T11:27:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13099','2005-08-19T10:55:19.000','969','436','2005-08-27T10:54:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13100','2005-08-19T10:55:45.000','916','451','2005-08-25T12:28:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13101','2005-08-19T11:01:54.000','1804','39','2005-08-27T16:06:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13102','2005-08-19T11:02:03.000','2885','285','2005-08-28T13:05:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13103','2005-08-19T11:05:51.000','1751','274','2005-08-26T09:16:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13104','2005-08-19T11:06:06.000','310','591','2005-08-21T13:50:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13105','2005-08-19T11:06:16.000','729','279','2005-08-27T15:21:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13106','2006-02-14T15:16:03.000','3212','440',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13107','2005-08-19T11:13:58.000','3870','356','2005-08-20T15:03:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13108','2006-02-14T15:16:03.000','3630','73',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13109','2005-08-19T11:23:20.000','46','259','2005-08-25T17:05:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13110','2005-08-19T11:24:37.000','62','447','2005-08-21T05:48:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13111','2005-08-19T11:25:10.000','580','26','2005-08-21T05:52:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13112','2005-08-19T11:27:10.000','2074','259','2005-08-22T05:32:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13113','2005-08-19T11:27:20.000','2393','573','2005-08-23T12:40:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13114','2005-08-19T11:27:32.000','4342','550','2005-08-28T11:21:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13115','2005-08-19T11:27:43.000','1961','84','2005-08-20T10:58:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13116','2005-08-19T11:31:41.000','1544','150','2005-08-27T16:05:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13117','2005-08-19T11:33:20.000','3430','385','2005-08-20T11:55:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13118','2005-08-19T11:39:58.000','470','181','2005-08-25T14:44:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13119','2005-08-19T11:44:59.000','1401','240','2005-08-20T12:30:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13120','2005-08-19T11:47:38.000','2273','314','2005-08-26T08:20:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13121','2005-08-19T11:51:39.000','3517','251','2005-08-22T11:50:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13122','2005-08-19T11:53:49.000','3319','277','2005-08-26T16:01:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13123','2005-08-19T11:55:13.000','2804','220','2005-08-21T05:55:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13124','2005-08-19T11:55:59.000','2105','78','2005-08-26T06:01:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13125','2005-08-19T11:57:49.000','3722','192','2005-08-26T07:53:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13126','2005-08-19T12:00:28.000','1392','253','2005-08-28T17:27:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13127','2005-08-19T12:04:03.000','2582','178','2005-08-27T13:56:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13128','2005-08-19T12:04:16.000','485','206','2005-08-26T16:06:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13129','2005-08-19T12:05:04.000','4455','274','2005-08-26T10:24:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13130','2005-08-19T12:06:42.000','2006','254','2005-08-23T12:08:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13131','2005-08-19T12:08:13.000','1466','480','2005-08-27T13:43:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13132','2005-08-19T12:10:57.000','1748','529','2005-08-27T12:22:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13133','2005-08-19T12:11:03.000','1635','523','2005-08-28T12:36:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13134','2005-08-19T12:14:14.000','1354','184','2005-08-20T11:52:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13135','2005-08-19T12:22:52.000','1585','361','2005-08-21T14:04:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13136','2005-08-19T12:24:23.000','2532','50','2005-08-28T08:37:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13137','2005-08-19T12:26:32.000','4431','20','2005-08-22T13:26:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13138','2005-08-19T12:30:01.000','3138','214','2005-08-21T06:35:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13139','2005-08-19T12:32:10.000','2099','554','2005-08-24T12:12:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13140','2005-08-19T12:35:56.000','4210','323','2005-08-27T18:24:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13141','2005-08-19T12:41:41.000','4545','376','2005-08-21T08:17:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13142','2005-08-19T12:42:28.000','1404','269','2005-08-26T14:52:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13143','2005-08-19T12:44:38.000','1655','371','2005-08-25T10:59:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13144','2005-08-19T12:45:55.000','3766','456','2005-08-27T10:37:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13145','2005-08-19T12:53:53.000','1383','72','2005-08-23T08:06:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13146','2005-08-19T12:54:42.000','1463','116','2005-08-26T07:31:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13147','2005-08-19T12:55:09.000','3490','37','2005-08-22T18:10:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13148','2005-08-19T12:55:30.000','1762','137','2005-08-21T11:01:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13149','2005-08-19T13:07:12.000','1436','40','2005-08-28T18:12:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13150','2005-08-19T13:08:19.000','1514','457','2005-08-25T18:00:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13151','2005-08-19T13:08:23.000','3045','16','2005-08-20T12:38:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13152','2005-08-19T13:09:32.000','3571','597','2005-08-25T14:47:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13153','2005-08-19T13:09:47.000','3896','431','2005-08-23T17:35:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13154','2005-08-19T13:09:54.000','2465','255','2005-08-26T16:40:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13155','2005-08-19T13:10:23.000','290','442','2005-08-25T19:07:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13156','2005-08-19T13:10:42.000','770','512','2005-08-25T15:08:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13157','2005-08-19T13:12:28.000','4391','592','2005-08-20T10:41:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13158','2005-08-19T13:18:10.000','944','327','2005-08-25T09:27:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13159','2005-08-19T13:19:59.000','2300','497','2005-08-21T09:22:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13160','2005-08-19T13:21:04.000','410','484','2005-08-22T18:49:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13161','2006-02-14T15:16:03.000','986','175',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13162','2005-08-19T13:28:26.000','1845','478','2005-08-24T17:37:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13163','2005-08-19T13:29:46.000','3068','57','2005-08-22T07:48:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13164','2005-08-19T13:30:55.000','1104','145','2005-08-26T10:12:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13165','2005-08-19T13:34:10.000','138','289','2005-08-21T18:33:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13166','2005-08-19T13:36:28.000','4386','504','2005-08-22T07:57:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13167','2005-08-19T13:36:41.000','557','120','2005-08-23T15:29:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13168','2005-08-19T13:37:28.000','2210','186','2005-08-27T17:54:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13169','2005-08-19T13:43:35.000','1709','141','2005-08-26T09:31:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13170','2005-08-19T13:45:48.000','1072','176','2005-08-27T11:00:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13171','2005-08-19T13:48:54.000','1765','122','2005-08-27T18:57:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13172','2005-08-19T13:49:07.000','1301','298','2005-08-20T19:39:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13173','2005-08-19T13:50:36.000','1304','29','2005-08-26T12:34:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13174','2005-08-19T13:52:50.000','2303','482','2005-08-22T14:43:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13175','2005-08-19T13:54:53.000','3187','239','2005-08-20T16:25:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13176','2005-08-19T13:56:54.000','2269','1','2005-08-23T08:50:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13177','2005-08-19T13:56:58.000','3172','126','2005-08-23T13:13:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13178','2006-02-14T15:16:03.000','693','394',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13179','2005-08-19T13:59:53.000','1624','104','2005-08-25T12:10:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13180','2005-08-19T14:00:38.000','3443','322','2005-08-20T09:56:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13181','2005-08-19T14:00:56.000','1256','128','2005-08-24T13:52:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13182','2006-02-14T15:16:03.000','364','496',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13183','2005-08-19T14:09:26.000','2404','301','2005-08-28T08:44:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13184','2005-08-19T14:16:18.000','4395','393','2005-08-20T08:44:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13185','2005-08-19T14:22:30.000','241','174','2005-08-20T10:13:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13186','2005-08-19T14:23:19.000','2802','176','2005-08-28T11:26:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13187','2005-08-19T14:24:48.000','1944','543','2005-08-20T19:37:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13188','2005-08-19T14:27:03.000','583','472','2005-08-28T09:15:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13189','2005-08-19T14:27:16.000','3444','368','2005-08-28T10:34:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13190','2005-08-19T14:27:59.000','4316','290','2005-08-26T13:45:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13191','2005-08-19T14:28:48.000','2753','371','2005-08-23T12:53:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13192','2005-08-19T14:30:06.000','966','532','2005-08-27T15:20:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13193','2005-08-19T14:33:45.000','523','118','2005-08-28T08:46:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13194','2005-08-19T14:34:12.000','2473','58','2005-08-26T10:18:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13195','2005-08-19T14:39:14.000','2537','565','2005-08-24T10:30:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13196','2005-08-19T14:40:32.000','458','202','2005-08-26T18:15:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13197','2005-08-19T14:44:03.000','3190','358','2005-08-22T10:11:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13198','2005-08-19T14:47:18.000','4273','169','2005-08-21T18:09:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13199','2005-08-19T14:53:22.000','4291','339','2005-08-27T19:03:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13200','2005-08-19T14:55:58.000','2746','577','2005-08-27T11:35:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13201','2005-08-19T14:56:05.000','111','508','2005-08-25T14:37:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13202','2005-08-19T14:58:30.000','3546','381','2005-08-27T17:10:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13203','2005-08-19T15:00:58.000','804','257','2005-08-27T15:38:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13204','2005-08-19T15:02:48.000','4524','152','2005-08-24T18:07:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13205','2005-08-19T15:05:26.000','2616','495','2005-08-25T10:41:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13206','2005-08-19T15:05:34.000','2477','504','2005-08-21T20:37:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13207','2005-08-19T15:14:38.000','674','58','2005-08-27T16:09:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13208','2005-08-19T15:18:55.000','609','435','2005-08-24T11:59:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13209','2006-02-14T15:16:03.000','1574','5',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13210','2005-08-19T15:23:38.000','2789','487','2005-08-21T11:57:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13211','2005-08-19T15:23:41.000','1968','289','2005-08-22T16:58:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13212','2005-08-19T15:24:07.000','3691','158','2005-08-24T21:03:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13213','2005-08-19T15:25:48.000','1546','13','2005-08-22T09:32:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13214','2005-08-19T15:31:06.000','2675','157','2005-08-20T19:58:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13215','2005-08-19T15:35:38.000','3740','460','2005-08-27T12:16:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13216','2005-08-19T15:36:05.000','4335','422','2005-08-25T19:03:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13217','2005-08-19T15:38:39.000','616','565','2005-08-21T14:33:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13218','2005-08-19T15:39:39.000','4148','257','2005-08-22T17:28:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13219','2005-08-19T15:40:28.000','2075','288','2005-08-22T21:20:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13220','2005-08-19T15:42:32.000','1017','448','2005-08-25T13:37:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13221','2005-08-19T15:45:47.000','120','468','2005-08-26T21:10:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13222','2005-08-19T15:47:58.000','1656','91','2005-08-26T12:43:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13223','2005-08-19T15:52:04.000','332','461','2005-08-22T16:27:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13224','2005-08-19T15:52:13.000','3086','526','2005-08-28T20:53:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13225','2005-08-19T15:54:33.000','1420','562','2005-08-25T16:40:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13226','2005-08-19T16:05:36.000','2850','46','2005-08-21T10:07:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13227','2005-08-19T16:05:38.000','2759','288','2005-08-20T21:39:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13228','2005-08-19T16:08:16.000','2497','571','2005-08-20T18:55:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13229','2005-08-19T16:08:33.000','634','283','2005-08-22T19:54:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13230','2005-08-19T16:12:07.000','3645','151','2005-08-21T12:19:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13231','2005-08-19T16:12:49.000','2126','280','2005-08-27T17:14:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13232','2005-08-19T16:13:32.000','2370','206','2005-08-28T14:42:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13233','2005-08-19T16:14:41.000','1057','279','2005-08-24T21:13:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13234','2005-08-19T16:17:15.000','976','559','2005-08-27T12:36:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13235','2005-08-19T16:17:53.000','3902','367','2005-08-27T14:57:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13236','2005-08-19T16:18:24.000','4574','267','2005-08-27T17:48:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13237','2005-08-19T16:18:36.000','1272','169','2005-08-25T15:22:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13238','2005-08-19T16:20:56.000','985','348','2005-08-23T15:51:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13239','2005-08-19T16:22:13.000','3296','541','2005-08-23T19:26:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13240','2005-08-19T16:22:14.000','1411','179','2005-08-20T13:24:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13241','2005-08-19T16:25:00.000','3106','33','2005-08-26T12:27:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13242','2005-08-19T16:28:47.000','230','414','2005-08-24T22:13:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13243','2005-08-19T16:33:16.000','355','251','2005-08-25T13:19:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13244','2005-08-19T16:43:04.000','3246','298','2005-08-22T15:21:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13245','2005-08-19T16:43:41.000','1001','261','2005-08-20T21:17:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13246','2006-02-14T15:16:03.000','1849','411',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13247','2005-08-19T16:45:59.000','1271','24','2005-08-25T15:25:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13248','2005-08-19T16:47:41.000','2864','559','2005-08-28T18:11:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13249','2005-08-19T16:47:41.000','3084','377','2005-08-20T13:30:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13250','2005-08-19T16:47:55.000','2524','448','2005-08-26T16:54:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13251','2005-08-19T16:48:37.000','4216','111','2005-08-20T16:33:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13252','2005-08-19T16:50:50.000','775','451','2005-08-22T22:09:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13253','2005-08-19T16:53:56.000','472','399','2005-08-20T11:38:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13254','2005-08-19T16:54:01.000','3412','532','2005-08-27T19:50:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13255','2005-08-19T16:54:12.000','1101','150','2005-08-28T17:00:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13256','2005-08-19T16:54:12.000','2719','289','2005-08-28T16:54:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13257','2005-08-19T17:01:20.000','164','300','2005-08-24T17:26:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13258','2005-08-19T17:05:37.000','2246','349','2005-08-24T17:36:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13259','2005-08-19T17:08:53.000','2518','458','2005-08-23T14:14:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13260','2005-08-19T17:09:22.000','578','251','2005-08-24T21:31:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13261','2006-02-14T15:16:03.000','3538','417',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13262','2005-08-19T17:20:15.000','4483','184','2005-08-26T18:28:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13263','2005-08-19T17:26:55.000','214','206','2005-08-28T20:07:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13264','2005-08-19T17:27:10.000','1881','109','2005-08-27T16:00:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13265','2005-08-19T17:29:00.000','3933','314','2005-08-20T12:59:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13266','2005-08-19T17:31:20.000','1326','571','2005-08-21T11:41:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13267','2005-08-19T17:31:36.000','550','335','2005-08-21T13:47:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13268','2005-08-19T17:33:50.000','1166','255','2005-08-25T17:15:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13269','2005-08-19T17:34:00.000','2382','461','2005-08-20T15:17:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13270','2005-08-19T17:41:16.000','405','159','2005-08-23T20:22:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13271','2005-08-19T17:42:06.000','3872','242','2005-08-27T18:39:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13272','2005-08-19T17:49:13.000','2531','145','2005-08-23T15:49:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13273','2005-08-19T17:49:13.000','4181','433','2005-08-21T14:15:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13274','2005-08-19T17:50:03.000','704','272','2005-08-20T14:39:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13275','2005-08-19T17:53:38.000','710','377','2005-08-23T16:29:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13276','2005-08-19T17:53:42.000','625','516','2005-08-28T20:49:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13277','2005-08-19T17:57:35.000','3820','316','2005-08-25T15:45:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13278','2005-08-19T17:57:53.000','2691','282','2005-08-22T23:16:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13279','2005-08-19T18:02:18.000','2472','343','2005-08-24T22:15:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13280','2005-08-19T18:02:51.000','218','368','2005-08-21T23:17:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13281','2005-08-19T18:07:47.000','113','220','2005-08-20T21:51:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13282','2005-08-19T18:08:18.000','4373','59','2005-08-24T14:08:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13283','2005-08-19T18:10:19.000','2602','180','2005-08-23T16:09:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13284','2005-08-19T18:12:31.000','2128','338','2005-08-25T21:26:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13285','2005-08-19T18:18:44.000','2139','182','2005-08-20T12:33:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13286','2005-08-19T18:28:07.000','2685','245','2005-08-22T17:23:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13287','2005-08-19T18:28:24.000','2716','569','2005-08-26T20:13:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13288','2005-08-19T18:30:10.000','3558','162','2005-08-20T19:20:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13289','2005-08-19T18:31:30.000','3527','497','2005-08-20T13:43:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13290','2005-08-19T18:31:50.000','4174','23','2005-08-25T15:49:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13291','2005-08-19T18:32:11.000','1631','243','2005-08-20T18:22:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13292','2005-08-19T18:35:32.000','1336','171','2005-08-22T00:27:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13293','2005-08-19T18:35:52.000','380','399','2005-08-23T17:18:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13294','2005-08-19T18:36:35.000','156','534','2005-08-20T13:57:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13295','2006-02-14T15:16:03.000','2408','229',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13296','2005-08-19T18:43:53.000','1728','300','2005-08-21T23:30:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13297','2005-08-19T18:45:49.000','3818','359','2005-08-22T14:58:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13298','2006-02-14T15:16:03.000','2133','361',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13299','2005-08-19T18:46:33.000','4385','373','2005-08-22T20:45:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13300','2005-08-19T18:46:56.000','842','531','2005-08-28T20:23:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13301','2005-08-19T18:53:15.000','2261','494','2005-08-26T21:37:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13302','2005-08-19T18:54:26.000','4041','51','2005-08-21T23:01:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13303','2005-08-19T18:55:21.000','34','184','2005-08-23T18:49:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13304','2005-08-19T18:56:32.000','2979','405','2005-08-23T20:04:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13305','2005-08-19T18:57:05.000','2386','337','2005-08-28T22:28:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13306','2005-08-19T18:57:29.000','2742','229','2005-08-20T20:09:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13307','2005-08-19T18:58:44.000','2242','547','2005-08-22T00:15:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13308','2005-08-19T18:59:42.000','3189','414','2005-08-28T13:21:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13309','2005-08-19T19:04:00.000','2108','91','2005-08-28T23:08:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13310','2005-08-19T19:05:16.000','2563','311','2005-08-23T22:47:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13311','2005-08-19T19:07:09.000','3890','520','2005-08-20T23:07:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13312','2005-08-19T19:09:14.000','2891','418','2005-08-23T00:50:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13313','2005-08-19T19:11:41.000','3709','580','2005-08-21T23:53:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13314','2005-08-19T19:12:43.000','2899','347','2005-08-27T00:20:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13315','2005-08-19T19:16:18.000','3151','54','2005-08-21T20:58:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13316','2005-08-19T19:23:30.000','4450','10','2005-08-22T23:37:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13317','2005-08-19T19:25:42.000','3349','20','2005-08-20T20:57:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13318','2005-08-19T19:33:57.000','1389','413','2005-08-21T17:52:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13319','2005-08-19T19:35:13.000','2496','438','2005-08-27T17:59:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13320','2005-08-19T19:35:33.000','4522','172','2005-08-24T20:09:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13321','2005-08-19T19:40:37.000','4183','280','2005-08-21T19:09:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13322','2005-08-19T19:43:08.000','2149','559','2005-08-24T16:30:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13323','2005-08-19T19:48:07.000','1055','133','2005-08-23T15:28:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13324','2005-08-19T19:51:00.000','4349','564','2005-08-20T20:26:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13325','2005-08-19T19:52:02.000','2388','334','2005-08-22T21:14:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13326','2005-08-19T19:52:52.000','429','576','2005-08-20T18:56:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13327','2005-08-19T19:55:45.000','1808','72','2005-08-22T15:05:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13328','2005-08-19T19:56:01.000','605','462','2005-08-20T22:16:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13329','2005-08-19T19:56:55.000','3136','373','2005-08-25T01:19:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13330','2005-08-19T19:59:21.000','4276','297','2005-08-20T15:34:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13331','2005-08-19T20:00:25.000','3867','23','2005-08-21T17:03:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13332','2005-08-19T20:00:51.000','3144','503','2005-08-25T14:30:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13333','2006-02-14T15:16:03.000','1092','64',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13334','2005-08-19T20:02:33.000','461','379','2005-08-22T00:45:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13335','2005-08-19T20:03:18.000','1861','74','2005-08-24T20:09:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13336','2005-08-19T20:03:22.000','1011','289','2005-08-24T23:42:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13337','2005-08-19T20:06:57.000','3584','374','2005-08-20T16:31:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13338','2005-08-19T20:09:59.000','3739','86','2005-08-23T22:59:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13339','2005-08-19T20:18:36.000','1428','15','2005-08-28T21:34:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13340','2005-08-19T20:18:39.000','4358','45','2005-08-28T21:06:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13341','2005-08-19T20:18:53.000','1749','460','2005-08-27T14:36:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13342','2005-08-19T20:21:36.000','3476','172','2005-08-21T16:26:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13343','2005-08-19T20:22:08.000','1032','591','2005-08-27T17:21:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13344','2005-08-19T20:22:44.000','4392','514','2005-08-25T18:39:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13345','2005-08-19T20:25:24.000','47','55','2005-08-27T20:38:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13346','2005-08-19T20:28:21.000','4541','131','2005-08-28T00:28:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13347','2005-08-19T20:28:48.000','4038','562','2005-08-28T19:33:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13348','2005-08-19T20:31:48.000','275','456','2005-08-21T21:01:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13349','2005-08-19T20:43:16.000','4262','234','2005-08-20T16:21:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13350','2005-08-19T20:44:00.000','3523','214','2005-08-27T01:23:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13351','2006-02-14T15:16:03.000','4130','42',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13352','2005-08-19T20:51:40.000','2689','80','2005-08-24T01:22:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13353','2005-08-19T20:53:43.000','2790','131','2005-08-25T01:25:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13354','2005-08-19T20:55:23.000','1356','213','2005-08-27T20:09:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13355','2005-08-19T20:59:19.000','585','396','2005-08-23T21:44:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13356','2005-08-19T21:02:21.000','2713','324','2005-08-24T00:31:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13357','2005-08-19T21:02:59.000','3295','393','2005-08-25T23:46:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13358','2005-08-19T21:04:20.000','1510','439','2005-08-24T20:49:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13359','2005-08-19T21:04:49.000','4175','434','2005-08-27T01:46:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13360','2005-08-19T21:05:11.000','3396','327','2005-08-24T16:05:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13361','2005-08-19T21:07:22.000','4289','107','2005-08-21T21:26:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13362','2005-08-19T21:07:54.000','869','565','2005-08-20T17:29:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13363','2005-08-19T21:07:59.000','588','288','2005-08-21T17:08:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13364','2005-08-19T21:09:30.000','2773','236','2005-08-25T18:37:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13365','2005-08-19T21:12:37.000','4136','307','2005-08-25T19:56:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13366','2005-08-19T21:14:45.000','602','259','2005-08-21T03:06:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13367','2005-08-19T21:19:27.000','4569','290','2005-08-24T15:22:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13368','2005-08-19T21:19:35.000','1073','342','2005-08-21T16:12:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13369','2005-08-19T21:19:47.000','2728','116','2005-08-24T23:25:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13370','2005-08-19T21:20:11.000','239','101','2005-08-25T22:51:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13371','2005-08-19T21:21:47.000','3401','34','2005-08-26T16:17:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13372','2005-08-19T21:23:19.000','3366','150','2005-08-24T22:12:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13373','2005-08-19T21:23:31.000','4045','7','2005-08-25T22:38:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13374','2006-02-14T15:16:03.000','2721','227',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13375','2005-08-19T21:31:31.000','949','120','2005-08-29T00:17:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13376','2005-08-19T21:31:45.000','898','40','2005-08-22T01:14:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13377','2005-08-19T21:32:23.000','1316','572','2005-08-25T22:24:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13378','2005-08-19T21:33:35.000','2708','368','2005-08-20T22:47:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13379','2005-08-19T21:33:39.000','1623','227','2005-08-22T21:00:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13380','2005-08-19T21:36:58.000','4250','451','2005-08-22T23:55:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13381','2005-08-19T21:37:57.000','2823','21','2005-08-21T18:07:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13382','2005-08-19T21:38:41.000','3720','436','2005-08-28T15:49:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13383','2005-08-19T21:38:44.000','3193','434','2005-08-28T23:22:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13384','2005-08-19T21:38:51.000','1462','440','2005-08-23T17:55:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13385','2005-08-19T21:39:35.000','4323','252','2005-08-22T22:38:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13386','2005-08-19T21:43:58.000','4476','324','2005-08-24T20:29:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13387','2005-08-19T21:46:10.000','123','504','2005-08-24T01:16:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13388','2005-08-19T21:46:49.000','942','317','2005-08-27T16:18:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13389','2005-08-19T21:52:51.000','3352','257','2005-08-25T02:38:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13390','2006-02-14T15:16:03.000','2855','135',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13391','2005-08-19T22:01:42.000','4220','16','2005-08-24T22:20:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13392','2005-08-19T22:03:22.000','692','409','2005-08-28T19:27:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13393','2005-08-19T22:03:46.000','958','15','2005-08-28T19:19:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13394','2005-08-19T22:05:19.000','2597','45','2005-08-21T23:53:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13395','2005-08-19T22:05:40.000','53','80','2005-08-22T01:31:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13396','2005-08-19T22:06:09.000','4169','517','2005-08-23T23:26:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13397','2005-08-19T22:06:35.000','3863','379','2005-08-29T01:11:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13398','2005-08-19T22:08:48.000','3376','405','2005-08-23T03:24:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13399','2005-08-19T22:09:28.000','2309','21','2005-08-25T20:25:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13400','2005-08-19T22:11:44.000','2173','179','2005-08-20T23:27:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13401','2005-08-19T22:16:16.000','488','139','2005-08-25T19:01:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13402','2005-08-19T22:16:53.000','3264','372','2005-08-22T22:28:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13403','2005-08-19T22:18:07.000','3241','3','2005-08-27T19:23:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13404','2005-08-19T22:18:42.000','416','414','2005-08-23T16:29:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13405','2005-08-19T22:20:49.000','1554','181','2005-08-28T21:21:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13406','2005-08-19T22:22:01.000','3031','113','2005-08-22T18:16:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13407','2005-08-19T22:26:26.000','2512','131','2005-08-22T16:34:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13408','2005-08-19T22:34:51.000','2795','575','2005-08-21T03:30:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13409','2005-08-19T22:36:26.000','873','214','2005-08-22T01:52:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13410','2005-08-19T22:41:44.000','1421','104','2005-08-26T18:05:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13411','2005-08-19T22:43:38.000','4425','21','2005-08-26T18:29:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13412','2005-08-19T22:46:35.000','2806','404','2005-08-26T18:06:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13413','2005-08-19T22:46:46.000','1501','390','2005-08-24T22:52:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13414','2005-08-19T22:47:34.000','4126','438','2005-08-21T02:50:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13415','2005-08-19T22:48:09.000','1105','181','2005-08-25T02:09:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13416','2005-08-19T22:48:48.000','1075','204','2005-08-21T22:09:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13417','2005-08-19T22:51:39.000','92','468','2005-08-23T03:34:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13418','2005-08-19T22:53:56.000','2113','246','2005-08-28T02:05:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13419','2006-02-14T15:16:03.000','3507','537',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13420','2005-08-19T22:57:25.000','1796','102','2005-08-28T22:46:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13421','2006-02-14T15:16:03.000','9','366',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13422','2005-08-19T23:07:24.000','3835','404','2005-08-28T04:12:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13423','2005-08-19T23:07:42.000','546','311','2005-08-26T20:45:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13424','2005-08-19T23:10:09.000','4340','216','2005-08-23T02:25:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13425','2005-08-19T23:11:44.000','2274','340','2005-08-25T21:19:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13426','2005-08-19T23:15:00.000','3409','213','2005-08-21T01:53:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13427','2005-08-19T23:19:02.000','3120','239','2005-08-21T18:30:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13428','2006-02-14T15:16:03.000','106','44',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13429','2005-08-19T23:25:37.000','3677','23','2005-08-28T01:04:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13430','2005-08-19T23:25:43.000','2852','381','2005-08-22T18:41:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13431','2005-08-19T23:28:15.000','1700','229','2005-08-25T04:44:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13432','2005-08-19T23:29:06.000','2216','78','2005-08-23T00:57:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13433','2005-08-19T23:30:53.000','1647','171','2005-08-22T05:18:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13434','2005-08-19T23:34:26.000','2073','221','2005-08-23T18:33:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13435','2005-08-19T23:35:44.000','3919','30','2005-08-24T18:14:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13436','2005-08-19T23:36:25.000','2499','29','2005-08-23T18:38:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13437','2005-08-19T23:37:52.000','2292','67','2005-08-28T22:17:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13438','2005-08-19T23:38:02.000','1750','520','2005-08-26T21:36:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13439','2005-08-19T23:42:16.000','3535','551','2005-08-26T21:24:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13440','2005-08-19T23:42:52.000','2842','260','2005-08-25T19:19:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13441','2005-08-19T23:48:23.000','3188','125','2005-08-28T23:47:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13442','2005-08-19T23:50:45.000','2432','356','2005-08-27T22:01:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13443','2005-08-19T23:53:42.000','3161','236','2005-08-28T05:37:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13444','2005-08-20T00:00:24.000','2564','37','2005-08-21T05:59:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13445','2005-08-20T00:05:33.000','1630','495','2005-08-21T21:20:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13446','2005-08-20T00:06:13.000','3226','488','2005-08-22T19:56:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13447','2005-08-20T00:09:36.000','285','542','2005-08-25T01:22:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13448','2005-08-20T00:12:43.000','2870','327','2005-08-25T02:33:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13449','2005-08-20T00:17:01.000','1297','400','2005-08-23T20:42:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13450','2005-08-20T00:18:15.000','135','61','2005-08-24T19:36:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13451','2005-08-20T00:18:25.000','3837','6','2005-08-29T01:08:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13452','2005-08-20T00:20:07.000','2449','430','2005-08-25T05:43:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13453','2005-08-20T00:30:51.000','2203','164','2005-08-28T18:43:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13454','2005-08-20T00:30:52.000','1553','430','2005-08-27T19:45:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13455','2005-08-20T00:32:17.000','1315','133','2005-08-26T19:33:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13456','2005-08-20T00:33:19.000','1644','13','2005-08-22T01:47:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13457','2005-08-20T00:33:22.000','1220','256','2005-08-26T21:37:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13458','2005-08-20T00:35:30.000','4223','228','2005-08-21T20:51:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13459','2005-08-20T00:45:40.000','3666','114','2005-08-29T02:53:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13460','2005-08-20T00:48:24.000','244','410','2005-08-28T04:13:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13461','2005-08-20T00:49:04.000','2621','421','2005-08-28T02:49:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13462','2005-08-20T00:49:19.000','3865','489','2005-08-26T06:21:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13463','2005-08-20T00:50:54.000','510','21','2005-08-28T23:00:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13464','2006-02-14T15:16:03.000','4292','576',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13465','2005-08-20T00:54:14.000','1305','575','2005-08-21T20:55:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13466','2005-08-20T00:55:16.000','3088','262','2005-08-22T22:48:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13467','2005-08-20T00:56:44.000','696','373','2005-08-20T20:16:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13468','2005-08-20T00:56:44.000','1851','266','2005-08-29T06:26:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13469','2005-08-20T00:59:36.000','1410','235','2005-08-24T22:41:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13470','2005-08-20T01:01:16.000','3097','141','2005-08-21T03:19:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13471','2005-08-20T01:02:26.000','1391','296','2005-08-25T06:37:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13472','2005-08-20T01:03:31.000','3074','137','2005-08-28T02:54:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13473','2005-08-20T01:03:50.000','381','390','2005-08-22T02:33:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13474','2005-08-20T01:04:32.000','1209','116','2005-08-21T20:26:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13475','2005-08-20T01:05:05.000','3214','68','2005-08-20T20:22:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13476','2005-08-20T01:06:04.000','2866','7','2005-08-24T23:56:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13477','2005-08-20T01:07:00.000','1442','222','2005-08-26T02:47:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13478','2005-08-20T01:07:14.000','2190','466','2005-08-22T03:41:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13479','2005-08-20T01:09:11.000','1262','87','2005-08-26T05:35:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13480','2005-08-20T01:10:27.000','206','16','2005-08-27T22:18:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13481','2005-08-20T01:11:12.000','2678','157','2005-08-26T23:07:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13482','2005-08-20T01:14:30.000','1627','183','2005-08-24T04:57:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13483','2005-08-20T01:16:38.000','2550','441','2005-08-21T20:43:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13484','2005-08-20T01:16:52.000','1533','152','2005-08-22T23:47:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13485','2005-08-20T01:20:14.000','3802','379','2005-08-22T01:28:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13486','2006-02-14T15:16:03.000','4460','274',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13487','2005-08-20T01:27:05.000','2609','458','2005-08-24T00:41:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13488','2005-08-20T01:28:42.000','867','444','2005-08-25T06:17:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13489','2005-08-20T01:29:06.000','2934','443','2005-08-27T21:11:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13490','2005-08-20T01:29:29.000','238','18','2005-08-21T22:36:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13491','2005-08-20T01:30:56.000','2503','258','2005-08-28T23:26:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13492','2005-08-20T01:32:04.000','1155','462','2005-08-29T02:14:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13493','2005-08-20T01:33:36.000','2927','37','2005-08-24T06:32:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13494','2005-08-20T01:36:34.000','1632','414','2005-08-21T06:52:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13495','2005-08-20T01:40:25.000','3881','92','2005-08-23T06:32:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13496','2005-08-20T01:42:29.000','3040','454','2005-08-29T06:47:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13497','2005-08-20T01:46:38.000','1296','481','2005-08-26T05:37:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13498','2005-08-20T01:51:23.000','1603','578','2005-08-24T05:32:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13499','2005-08-20T01:52:30.000','1893','300','2005-08-28T04:57:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13500','2005-08-20T01:54:39.000','1353','577','2005-08-25T21:23:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13501','2005-08-20T01:56:20.000','4369','390','2005-08-22T23:07:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13502','2005-08-20T01:58:15.000','1324','309','2005-08-21T20:21:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13503','2005-08-20T02:00:33.000','453','15','2005-08-28T21:03:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13504','2005-08-20T02:01:48.000','4322','293','2005-08-25T21:52:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13505','2005-08-20T02:05:57.000','914','536','2005-08-23T05:52:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13506','2005-08-20T02:07:06.000','1334','261','2005-08-26T08:06:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13507','2005-08-20T02:10:27.000','3324','478','2005-08-23T04:03:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13508','2005-08-20T02:12:54.000','4120','408','2005-08-28T21:47:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13509','2005-08-20T02:14:16.000','3698','128','2005-08-22T06:36:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13510','2005-08-20T02:18:30.000','691','107','2005-08-27T01:33:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13511','2005-08-20T02:21:40.000','2973','23','2005-08-21T03:26:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13512','2005-08-20T02:27:13.000','4508','62','2005-08-28T04:40:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13513','2005-08-20T02:27:53.000','1653','454','2005-08-22T06:10:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13514','2005-08-20T02:28:09.000','3407','96','2005-08-25T00:41:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13515','2005-08-20T02:29:47.000','3438','194','2005-08-23T08:12:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13516','2005-08-20T02:32:45.000','4286','95','2005-08-27T04:38:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13517','2005-08-20T02:33:17.000','533','186','2005-08-23T22:40:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13518','2005-08-20T02:36:17.000','352','528','2005-08-24T08:06:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13519','2005-08-20T02:37:07.000','182','12','2005-08-23T01:26:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13520','2005-08-20T02:41:46.000','3326','74','2005-08-22T01:53:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13521','2005-08-20T02:42:28.000','2586','384','2005-08-22T06:12:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13522','2005-08-20T02:44:06.000','2940','343','2005-08-28T05:30:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13523','2005-08-20T02:47:03.000','163','572','2005-08-28T07:43:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13524','2005-08-20T02:48:43.000','4557','593','2005-08-27T03:14:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13525','2005-08-20T02:50:44.000','3514','111','2005-08-26T22:58:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13526','2005-08-20T02:58:42.000','1966','277','2005-08-27T22:36:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13527','2005-08-20T03:00:47.000','4424','521','2005-08-25T01:03:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13528','2005-08-20T03:03:31.000','1847','202','2005-08-26T03:09:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13529','2005-08-20T03:07:47.000','1979','193','2005-08-21T21:50:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13530','2005-08-20T03:12:43.000','597','156','2005-08-23T09:01:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13531','2005-08-20T03:26:10.000','2778','156','2005-08-25T03:41:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13532','2005-08-20T03:29:28.000','1433','168','2005-08-23T22:53:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13533','2005-08-20T03:30:00.000','1801','436','2005-08-27T05:53:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13534','2006-02-14T15:16:03.000','2476','75',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13535','2005-08-20T03:30:25.000','1563','86','2005-08-28T04:35:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13536','2005-08-20T03:35:16.000','667','183','2005-08-25T04:06:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13537','2005-08-20T03:39:15.000','2521','418','2005-08-23T22:03:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13538','2006-02-14T15:16:03.000','581','279',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13539','2005-08-20T03:40:27.000','3110','518','2005-08-27T07:15:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13540','2005-08-20T03:41:23.000','3785','557','2005-08-27T09:09:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13541','2005-08-20T03:41:41.000','1363','15','2005-08-24T23:14:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13542','2005-08-20T03:41:57.000','4543','147','2005-08-29T03:21:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13543','2005-08-20T03:43:13.000','2142','163','2005-08-29T07:14:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13544','2005-08-20T03:44:26.000','58','538','2005-08-27T22:11:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13545','2005-08-20T03:50:15.000','615','417','2005-08-27T22:24:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13546','2005-08-20T03:50:24.000','2492','390','2005-08-28T03:04:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13547','2005-08-20T03:53:16.000','3122','456','2005-08-25T04:02:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13548','2005-08-20T03:53:20.000','4389','319','2005-08-27T21:54:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13549','2005-08-20T03:58:41.000','508','274','2005-08-28T22:49:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13550','2005-08-20T03:58:51.000','208','206','2005-08-28T00:45:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13551','2005-08-20T04:00:30.000','1049','503','2005-08-21T06:26:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13552','2005-08-20T04:03:51.000','758','578','2005-08-23T02:48:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13553','2005-08-20T04:07:21.000','4407','314','2005-08-28T09:55:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13554','2005-08-20T04:08:39.000','2648','569','2005-08-28T07:11:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13555','2005-08-20T04:09:50.000','3176','93','2005-08-29T05:20:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13556','2005-08-20T04:10:26.000','3914','266','2005-08-26T06:45:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13557','2005-08-20T04:12:41.000','2290','23','2005-08-21T02:33:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13558','2005-08-20T04:13:17.000','1551','564','2005-08-24T06:38:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13559','2005-08-20T04:16:07.000','2413','444','2005-08-24T23:23:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13560','2005-08-20T04:17:16.000','820','56','2005-08-28T08:38:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13561','2006-02-14T15:16:03.000','3202','530',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13562','2005-08-20T04:31:45.000','4547','36','2005-08-25T09:59:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13563','2005-08-20T04:33:31.000','599','366','2005-08-24T07:08:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13564','2005-08-20T04:34:46.000','678','36','2005-08-28T23:18:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13565','2005-08-20T04:38:52.000','3378','214','2005-08-27T07:17:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13566','2005-08-20T04:45:32.000','4397','558','2005-08-28T02:12:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13567','2005-08-20T04:49:21.000','543','242','2005-08-26T10:27:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13568','2005-08-20T05:02:46.000','1243','151','2005-08-27T03:12:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13569','2005-08-20T05:02:59.000','1934','496','2005-08-28T00:51:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13570','2005-08-20T05:04:57.000','2808','188','2005-08-24T06:19:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13571','2005-08-20T05:05:14.000','1251','458','2005-08-25T03:59:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13572','2005-08-20T05:07:27.000','660','11','2005-08-23T23:33:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13573','2005-08-20T05:10:14.000','3032','59','2005-08-22T00:59:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13574','2005-08-20T05:10:39.000','2383','552','2005-08-21T02:21:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13575','2005-08-20T05:15:20.000','2729','339','2005-08-28T07:36:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13576','2005-08-20T05:19:56.000','2669','223','2005-08-22T09:08:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13577','2006-02-14T15:16:03.000','3844','448',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13578','2006-02-14T15:16:03.000','4301','352',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13579','2005-08-20T05:22:06.000','4237','333','2005-08-28T02:33:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13580','2005-08-20T05:23:34.000','4419','526','2005-08-23T02:45:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13581','2005-08-20T05:26:15.000','1753','119','2005-08-21T11:07:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13582','2005-08-20T05:28:11.000','211','166','2005-08-23T02:06:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13583','2005-08-20T05:29:45.000','176','74','2005-08-26T06:49:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13584','2006-02-14T15:16:03.000','3966','548',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13585','2005-08-20T05:32:23.000','3314','470','2005-08-27T23:36:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13586','2005-08-20T05:40:33.000','4544','445','2005-08-25T01:32:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13587','2006-02-14T15:16:03.000','2455','431',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13588','2005-08-20T05:47:11.000','702','279','2005-08-28T02:45:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13589','2005-08-20T05:47:25.000','3216','574','2005-08-23T01:29:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13590','2005-08-20T05:48:59.000','4417','264','2005-08-25T00:44:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13591','2005-08-20T05:50:05.000','3089','390','2005-08-27T08:43:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13592','2005-08-20T05:50:35.000','1509','470','2005-08-23T04:52:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13593','2005-08-20T05:50:52.000','261','585','2005-08-27T05:28:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13594','2005-08-20T05:53:31.000','3424','7','2005-08-23T09:01:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13595','2005-08-20T05:54:27.000','673','545','2005-08-29T01:25:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13596','2005-08-20T05:58:58.000','482','513','2005-08-27T08:35:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13597','2005-08-20T05:59:05.000','3697','72','2005-08-24T05:38:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13598','2005-08-20T05:59:17.000','2803','259','2005-08-29T01:02:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13599','2005-08-20T06:00:03.000','3333','150','2005-08-29T07:56:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13600','2005-08-20T06:00:25.000','431','528','2005-08-28T02:39:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13601','2005-08-20T06:01:15.000','2166','189','2005-08-29T06:14:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13602','2005-08-20T06:02:02.000','2805','348','2005-08-27T04:51:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13603','2005-08-20T06:02:48.000','937','362','2005-08-29T09:39:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13604','2005-08-20T06:03:33.000','4352','353','2005-08-21T07:06:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13605','2005-08-20T06:06:17.000','4446','522','2005-08-26T00:53:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13606','2005-08-20T06:07:01.000','83','146','2005-08-27T04:59:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13607','2005-08-20T06:08:42.000','2692','491','2005-08-21T01:59:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13608','2005-08-20T06:10:44.000','4110','193','2005-08-24T07:08:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13609','2005-08-20T06:11:51.000','299','328','2005-08-23T04:13:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13610','2005-08-20T06:14:12.000','2526','3','2005-08-26T00:44:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13611','2005-08-20T06:20:42.000','1460','112','2005-08-28T10:07:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13612','2005-08-20T06:22:08.000','675','505','2005-08-28T02:22:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13613','2005-08-20T06:23:53.000','2415','201','2005-08-29T11:40:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13614','2005-08-20T06:28:37.000','3736','381','2005-08-22T07:54:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13615','2005-08-20T06:28:53.000','1864','539','2005-08-27T11:40:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13616','2005-08-20T06:30:33.000','1694','194','2005-08-27T09:29:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13617','2005-08-20T06:35:30.000','4059','526','2005-08-29T09:03:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13618','2005-08-20T06:36:46.000','390','390','2005-08-29T05:17:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13619','2005-08-20T06:39:26.000','1068','365','2005-08-23T05:22:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13620','2005-08-20T06:41:27.000','2361','92','2005-08-24T11:02:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13621','2005-08-20T06:43:44.000','3754','581','2005-08-23T06:25:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13622','2005-08-20T06:45:32.000','3355','335','2005-08-25T02:40:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13623','2005-08-20T06:49:46.000','3948','321','2005-08-25T05:19:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13624','2005-08-20T06:51:02.000','430','63','2005-08-29T02:39:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13625','2005-08-20T06:52:03.000','60','422','2005-08-27T07:43:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13626','2005-08-20T06:55:24.000','594','524','2005-08-29T12:32:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13627','2005-08-20T06:59:00.000','603','329','2005-08-29T11:43:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13628','2005-08-20T07:03:53.000','1006','500','2005-08-22T11:27:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13629','2005-08-20T07:04:07.000','1834','392','2005-08-25T12:36:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13630','2005-08-20T07:05:56.000','3346','244','2005-08-29T04:15:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13631','2005-08-20T07:07:37.000','1015','535','2005-08-22T04:01:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13632','2005-08-20T07:10:52.000','4008','409','2005-08-29T10:19:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13633','2005-08-20T07:13:47.000','3227','301','2005-08-24T11:25:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13634','2005-08-20T07:16:45.000','850','411','2005-08-22T03:38:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13635','2005-08-20T07:17:35.000','669','286','2005-08-29T06:27:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13636','2005-08-20T07:20:09.000','1467','349','2005-08-23T09:58:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13637','2005-08-20T07:21:15.000','2298','342','2005-08-24T10:13:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13638','2005-08-20T07:21:15.000','3255','493','2005-08-23T11:09:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13639','2005-08-20T07:22:07.000','2489','562','2005-08-23T11:24:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13640','2005-08-20T07:22:53.000','3427','541','2005-08-21T11:54:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13641','2005-08-20T07:34:42.000','367','281','2005-08-26T05:18:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13642','2005-08-20T07:42:17.000','4415','452','2005-08-29T10:49:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13643','2005-08-20T07:42:24.000','2443','398','2005-08-26T09:13:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13644','2005-08-20T07:46:30.000','970','464','2005-08-27T01:54:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13645','2005-08-20T07:47:05.000','157','387','2005-08-23T02:58:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13646','2005-08-20T07:47:08.000','1347','242','2005-08-29T08:33:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13647','2005-08-20T07:48:07.000','3269','519','2005-08-28T07:56:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13648','2005-08-20T07:48:10.000','3921','596','2005-08-22T12:15:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13649','2005-08-20T07:48:38.000','1495','259','2005-08-23T07:43:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13650','2005-08-20T07:49:06.000','2644','322','2005-08-28T10:11:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13651','2005-08-20T07:50:08.000','1082','256','2005-08-21T07:11:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13652','2005-08-20T07:52:34.000','2548','67','2005-08-23T08:58:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13653','2005-08-20T07:54:54.000','4029','129','2005-08-29T06:43:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13654','2005-08-20T07:58:21.000','1582','469','2005-08-21T09:40:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13655','2005-08-20T07:59:13.000','4294','207','2005-08-22T12:04:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13656','2005-08-20T08:01:07.000','3180','411','2005-08-28T13:16:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13657','2005-08-20T08:01:39.000','1752','414','2005-08-23T07:31:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13658','2005-08-20T08:02:22.000','3827','487','2005-08-28T06:00:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13659','2005-08-20T08:05:52.000','3610','520','2005-08-24T12:38:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13660','2005-08-20T08:05:56.000','3972','72','2005-08-22T13:22:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13661','2005-08-20T08:05:59.000','3996','471','2005-08-29T12:15:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13662','2005-08-20T08:11:58.000','3880','592','2005-08-26T13:34:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13663','2005-08-20T08:12:33.000','3969','240','2005-08-27T03:23:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13664','2005-08-20T08:18:36.000','3750','264','2005-08-26T11:04:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13665','2005-08-20T08:19:20.000','117','291','2005-08-28T06:26:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13666','2005-08-20T08:20:19.000','2007','451','2005-08-22T03:22:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13667','2005-08-20T08:25:34.000','3856','280','2005-08-24T07:04:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13668','2005-08-20T08:26:06.000','3659','123','2005-08-25T05:52:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13669','2005-08-20T08:26:32.000','4504','261','2005-08-27T08:10:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13670','2005-08-20T08:27:01.000','1951','147','2005-08-29T05:59:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13671','2005-08-20T08:27:03.000','1473','201','2005-08-26T03:56:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13672','2005-08-20T08:27:27.000','2068','201','2005-08-22T06:15:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13673','2005-08-20T08:27:30.000','343','332','2005-08-26T05:14:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13674','2005-08-20T08:30:54.000','3397','36','2005-08-22T02:59:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13675','2005-08-20T08:32:51.000','350','493','2005-08-27T03:52:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13676','2005-08-20T08:33:21.000','3170','103','2005-08-25T02:51:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13677','2005-08-20T08:34:41.000','4013','15','2005-08-26T11:51:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13678','2005-08-20T08:38:24.000','1118','337','2005-08-27T13:54:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13679','2005-08-20T08:39:34.000','2878','229','2005-08-29T10:06:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13680','2005-08-20T08:44:06.000','2822','70','2005-08-27T09:58:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13681','2005-08-20T08:47:37.000','3039','328','2005-08-27T09:47:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13682','2005-08-20T08:50:39.000','287','30','2005-08-21T09:05:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13683','2005-08-20T08:54:55.000','1729','255','2005-08-24T14:10:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13684','2005-08-20T08:55:53.000','2213','348','2005-08-25T08:11:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13685','2005-08-20T08:57:11.000','3336','260','2005-08-27T07:26:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13686','2005-08-20T08:57:28.000','666','306','2005-08-24T07:21:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13687','2005-08-20T08:57:51.000','3629','290','2005-08-22T07:02:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13688','2005-08-20T08:59:38.000','1116','572','2005-08-28T04:54:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13689','2005-08-20T09:04:30.000','819','336','2005-08-22T05:38:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13690','2005-08-20T09:07:27.000','3721','513','2005-08-23T08:03:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13691','2005-08-20T09:07:39.000','676','548','2005-08-28T15:03:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13692','2005-08-20T09:07:52.000','1928','65','2005-08-21T05:17:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13693','2005-08-20T09:11:42.000','933','552','2005-08-24T15:00:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13694','2005-08-20T09:13:23.000','3654','454','2005-08-28T06:10:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13695','2005-08-20T09:13:25.000','3114','258','2005-08-27T11:51:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13696','2005-08-20T09:16:15.000','1279','206','2005-08-21T03:33:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13697','2005-08-20T09:21:08.000','291','76','2005-08-29T12:33:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13698','2005-08-20T09:24:26.000','3829','364','2005-08-22T05:04:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13699','2005-08-20T09:26:14.000','3913','21','2005-08-29T08:16:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13700','2005-08-20T09:26:17.000','4229','265','2005-08-27T05:49:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13701','2005-08-20T09:27:05.000','1643','564','2005-08-21T14:54:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13702','2005-08-20T09:27:20.000','700','296','2005-08-29T15:04:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13703','2005-08-20T09:29:35.000','2296','356','2005-08-27T08:03:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13704','2005-08-20T09:32:04.000','3373','4','2005-08-23T14:29:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13705','2005-08-20T09:32:23.000','3663','451','2005-08-21T13:51:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13706','2005-08-20T09:32:56.000','3005','363','2005-08-28T05:22:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13707','2005-08-20T09:33:58.000','826','232','2005-08-23T07:44:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13708','2005-08-20T09:34:07.000','2236','218','2005-08-26T10:17:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13709','2005-08-20T09:34:51.000','4089','422','2005-08-23T04:13:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13710','2005-08-20T09:35:20.000','756','333','2005-08-21T05:29:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13711','2005-08-20T09:35:20.000','2318','453','2005-08-28T09:06:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13712','2005-08-20T09:38:04.000','1039','581','2005-08-21T06:10:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13713','2006-02-14T15:16:03.000','3075','267',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13714','2005-08-20T09:41:09.000','2659','277','2005-08-22T06:28:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13715','2005-08-20T09:43:06.000','1028','292','2005-08-27T10:22:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13716','2005-08-20T09:48:32.000','86','386','2005-08-26T07:20:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13717','2005-08-20T09:50:52.000','1629','300','2005-08-28T11:32:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13718','2005-08-20T09:53:44.000','205','19','2005-08-29T13:46:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13719','2006-02-14T15:16:03.000','3547','208',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13720','2005-08-20T10:01:39.000','813','427','2005-08-27T08:26:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13721','2005-08-20T10:02:59.000','1444','297','2005-08-24T07:02:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13722','2005-08-20T10:03:45.000','1581','422','2005-08-25T04:26:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13723','2005-08-20T10:05:30.000','411','110','2005-08-27T07:43:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13724','2005-08-20T10:07:28.000','200','80','2005-08-24T07:47:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13725','2005-08-20T10:08:27.000','3861','306','2005-08-28T06:52:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13726','2005-08-20T10:08:40.000','2258','214','2005-08-23T14:58:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13727','2005-08-20T10:08:53.000','4201','85','2005-08-27T09:30:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13728','2005-08-20T10:11:07.000','1962','157','2005-08-23T10:32:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13729','2005-08-20T10:17:08.000','4108','415','2005-08-28T15:35:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13730','2005-08-20T10:17:09.000','1330','548','2005-08-28T10:45:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13731','2005-08-20T10:22:08.000','1133','450','2005-08-21T12:04:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13732','2005-08-20T10:24:41.000','1138','17','2005-08-22T04:44:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13733','2005-08-20T10:25:12.000','3994','85','2005-08-21T10:49:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13734','2005-08-20T10:29:57.000','4561','374','2005-08-25T14:41:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13735','2005-08-20T10:31:01.000','1813','35','2005-08-26T05:00:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13736','2005-08-20T10:31:23.000','3369','32','2005-08-28T06:51:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13737','2005-08-20T10:41:50.000','4319','200','2005-08-25T14:33:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13738','2005-08-20T10:42:42.000','2748','273','2005-08-25T09:32:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13739','2005-08-20T10:45:10.000','3027','441','2005-08-28T08:46:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13740','2005-08-20T10:48:43.000','4366','21','2005-08-29T15:30:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13741','2005-08-20T10:48:47.000','3887','195','2005-08-21T11:19:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13742','2005-08-20T10:49:15.000','1377','580','2005-08-21T11:05:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13743','2005-08-20T10:51:27.000','3693','57','2005-08-24T15:54:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13744','2005-08-20T10:51:45.000','2962','408','2005-08-25T06:42:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13745','2005-08-20T10:53:49.000','1264','142','2005-08-25T13:25:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13746','2005-08-20T10:55:28.000','3742','520','2005-08-25T07:48:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13747','2005-08-20T10:56:06.000','3332','74','2005-08-29T10:29:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13748','2005-08-20T10:59:54.000','2198','410','2005-08-23T12:33:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13749','2005-08-20T11:00:37.000','2811','282','2005-08-26T12:04:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13750','2005-08-20T11:11:42.000','3363','246','2005-08-29T16:16:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13751','2005-08-20T11:17:03.000','185','105','2005-08-22T14:12:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13752','2005-08-20T11:17:45.000','1794','77','2005-08-29T13:25:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13753','2006-02-14T15:16:03.000','3746','495',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13754','2005-08-20T11:18:08.000','1740','108','2005-08-22T11:55:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13755','2005-08-20T11:18:53.000','1927','342','2005-08-27T06:51:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13756','2006-02-14T15:16:03.000','1146','252',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13757','2005-08-20T11:20:12.000','1147','14','2005-08-23T10:14:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13758','2005-08-20T11:21:26.000','864','255','2005-08-29T14:37:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13759','2005-08-20T11:24:48.000','595','269','2005-08-29T10:29:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13760','2005-08-20T11:26:33.000','3459','436','2005-08-27T11:12:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13761','2005-08-20T11:28:50.000','3149','376','2005-08-21T12:05:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13762','2005-08-20T11:29:32.000','451','566','2005-08-23T17:25:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13763','2005-08-20T11:37:56.000','4171','469','2005-08-26T13:12:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13764','2005-08-20T11:38:16.000','989','386','2005-08-27T08:01:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13765','2005-08-20T11:39:00.000','2104','219','2005-08-21T06:05:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13766','2005-08-20T11:42:01.000','1313','189','2005-08-27T13:44:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13767','2005-08-20T11:43:36.000','2739','506','2005-08-22T17:10:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13768','2005-08-20T11:43:43.000','3847','198','2005-08-27T07:56:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13769','2005-08-20T11:43:52.000','2868','56','2005-08-28T13:19:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13770','2005-08-20T11:45:54.000','998','538','2005-08-22T17:08:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13771','2005-08-20T11:47:21.000','2278','512','2005-08-22T17:09:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13772','2005-08-20T11:47:52.000','2038','387','2005-08-28T05:50:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13773','2005-08-20T11:50:14.000','3389','64','2005-08-26T12:35:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13774','2005-08-20T11:54:01.000','735','244','2005-08-22T13:25:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13775','2005-08-20T11:56:30.000','1858','116','2005-08-28T12:48:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13776','2005-08-20T11:57:06.000','2439','137','2005-08-26T10:55:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13777','2005-08-20T12:03:35.000','3587','29','2005-08-27T10:13:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13778','2005-08-20T12:03:44.000','2385','539','2005-08-28T12:09:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13779','2005-08-20T12:03:54.000','63','440','2005-08-28T15:24:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13780','2006-02-14T15:16:03.000','1775','14',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13781','2005-08-20T12:06:45.000','971','368','2005-08-26T06:50:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13782','2005-08-20T12:09:26.000','577','305','2005-08-23T08:31:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13783','2005-08-20T12:11:03.000','2643','28','2005-08-21T15:53:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13784','2005-08-20T12:11:28.000','3087','431','2005-08-25T08:11:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13785','2005-08-20T12:11:46.000','379','453','2005-08-21T06:39:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13786','2005-08-20T12:13:24.000','515','94','2005-08-28T07:24:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13787','2005-08-20T12:15:23.000','253','188','2005-08-27T06:24:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13788','2005-08-20T12:15:41.000','3177','393','2005-08-28T16:28:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13789','2005-08-20T12:16:38.000','2523','53','2005-08-25T07:29:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13790','2005-08-20T12:17:27.000','1385','11','2005-08-25T12:20:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13791','2005-08-20T12:21:05.000','1890','67','2005-08-22T17:58:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13792','2005-08-20T12:21:37.000','4157','78','2005-08-27T14:28:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13793','2005-08-20T12:22:04.000','2598','424','2005-08-27T09:51:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13794','2005-08-20T12:25:32.000','2148','557','2005-08-23T06:38:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13795','2005-08-20T12:32:09.000','2837','331','2005-08-21T17:28:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13796','2005-08-20T12:32:32.000','28','209','2005-08-29T10:48:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13797','2005-08-20T12:33:36.000','2857','529','2005-08-25T18:03:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13798','2006-02-14T15:16:03.000','526','15',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13799','2005-08-20T12:36:42.000','4413','196','2005-08-28T08:47:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13800','2005-08-20T12:40:48.000','1552','407','2005-08-22T15:06:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13801','2005-08-20T12:40:53.000','1464','433','2005-08-21T16:29:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13802','2005-08-20T12:44:53.000','2079','156','2005-08-22T09:18:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13803','2005-08-20T12:46:17.000','1084','486','2005-08-24T15:44:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13804','2005-08-20T12:46:32.000','2232','19','2005-08-29T14:04:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13805','2005-08-20T12:53:12.000','349','454','2005-08-27T15:21:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13806','2005-08-20T12:53:46.000','444','341','2005-08-21T10:36:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13807','2005-08-20T12:55:40.000','3822','4','2005-08-28T09:06:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13808','2005-08-20T12:55:43.000','3689','262','2005-08-29T11:01:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13809','2005-08-20T12:56:03.000','1597','207','2005-08-27T11:58:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13810','2005-08-20T12:59:38.000','2228','450','2005-08-21T17:40:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13811','2005-08-20T13:00:30.000','1235','168','2005-08-24T10:18:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13812','2005-08-20T13:01:43.000','2788','122','2005-08-22T16:32:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13813','2005-08-20T13:03:26.000','601','455','2005-08-25T08:42:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13814','2005-08-20T13:07:23.000','2129','436','2005-08-22T16:23:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13815','2005-08-20T13:08:53.000','3388','582','2005-08-29T13:11:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13816','2005-08-20T13:13:56.000','273','27','2005-08-25T09:46:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13817','2005-08-20T13:15:30.000','1935','293','2005-08-22T18:48:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13818','2005-08-20T13:20:09.000','1283','495','2005-08-21T18:41:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13819','2005-08-20T13:23:15.000','1459','296','2005-08-22T16:02:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13820','2005-08-20T13:26:37.000','3191','81','2005-08-27T14:05:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13821','2005-08-20T13:33:47.000','2402','355','2005-08-25T18:09:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13822','2005-08-20T13:39:28.000','807','499','2005-08-24T07:40:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13823','2005-08-20T13:42:10.000','3875','89','2005-08-22T18:45:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13824','2005-08-20T13:43:12.000','2845','413','2005-08-22T17:26:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13825','2005-08-20T13:43:22.000','2135','167','2005-08-29T19:13:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13826','2005-08-20T13:46:38.000','401','436','2005-08-29T13:07:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13827','2005-08-20T13:47:19.000','1103','342','2005-08-28T09:13:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13828','2005-08-20T13:49:52.000','2391','450','2005-08-25T07:49:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13829','2005-08-20T13:50:17.000','3980','146','2005-08-24T11:30:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13830','2005-08-20T13:57:59.000','2874','61','2005-08-25T11:29:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13831','2005-08-20T13:59:35.000','570','480','2005-08-24T12:50:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13832','2005-08-20T14:00:25.000','3299','29','2005-08-28T10:11:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13833','2005-08-20T14:00:29.000','792','175','2005-08-29T12:01:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13834','2005-08-20T14:03:08.000','875','426','2005-08-22T10:12:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13835','2005-08-20T14:06:33.000','3738','143','2005-08-26T12:15:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13836','2005-08-20T14:18:16.000','4271','375','2005-08-21T18:13:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13837','2005-08-20T14:19:03.000','3220','67','2005-08-22T16:25:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13838','2005-08-20T14:22:46.000','1134','437','2005-08-29T12:28:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13839','2005-08-20T14:23:16.000','1056','437','2005-08-26T19:11:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13840','2005-08-20T14:23:20.000','1211','40','2005-08-28T11:53:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13841','2005-08-20T14:25:18.000','3277','203','2005-08-29T15:49:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13842','2005-08-20T14:29:37.000','4337','180','2005-08-29T18:19:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13843','2005-08-20T14:30:01.000','3058','308','2005-08-27T10:06:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13844','2005-08-20T14:30:26.000','983','179','2005-08-29T17:08:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13845','2005-08-20T14:31:21.000','3993','559','2005-08-29T18:29:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13846','2005-08-20T14:32:31.000','3289','257','2005-08-28T16:58:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13847','2005-08-20T14:33:59.000','2647','82','2005-08-25T08:49:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13848','2005-08-20T14:37:49.000','802','447','2005-08-25T13:15:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13849','2005-08-20T14:42:34.000','3774','261','2005-08-24T13:09:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13850','2005-08-20T14:43:03.000','3030','546','2005-08-27T11:41:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13851','2005-08-20T14:44:22.000','3278','80','2005-08-22T18:10:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13852','2005-08-20T14:45:23.000','85','535','2005-08-22T16:47:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13853','2005-08-20T14:47:02.000','1680','186','2005-08-26T20:32:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13854','2005-08-20T14:48:42.000','4192','158','2005-08-21T14:55:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13855','2005-08-20T14:48:55.000','1617','96','2005-08-28T14:45:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13856','2005-08-20T14:49:32.000','4196','407','2005-08-29T12:37:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13857','2005-08-20T14:50:06.000','2542','366','2005-08-24T10:38:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13858','2005-08-20T14:50:57.000','2167','33','2005-08-23T12:10:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13859','2005-08-20T14:53:43.000','4381','504','2005-08-28T09:50:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13860','2005-08-20T14:55:09.000','558','275','2005-08-22T20:42:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13861','2005-08-20T14:56:53.000','303','154','2005-08-22T18:13:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13862','2005-08-20T14:57:01.000','3271','170','2005-08-27T10:48:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13863','2005-08-20T14:57:50.000','2417','563','2005-08-29T15:36:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13864','2005-08-20T14:59:55.000','3935','214','2005-08-22T09:30:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13865','2005-08-20T15:04:09.000','3647','275','2005-08-24T10:06:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13866','2005-08-20T15:05:29.000','3432','343','2005-08-23T11:27:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13867','2005-08-20T15:05:42.000','4514','591','2005-08-29T10:48:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13868','2005-08-20T15:06:26.000','3173','51','2005-08-22T19:08:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13869','2005-08-20T15:08:57.000','1990','386','2005-08-29T13:13:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13870','2005-08-20T15:09:16.000','563','167','2005-08-28T10:00:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13871','2005-08-20T15:10:13.000','3206','372','2005-08-29T19:43:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13872','2005-08-20T15:10:30.000','2416','421','2005-08-24T10:14:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13873','2005-08-20T15:11:11.000','1683','306','2005-08-22T20:13:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13874','2005-08-20T15:11:48.000','72','86','2005-08-21T18:26:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13875','2005-08-20T15:13:11.000','348','83','2005-08-21T13:11:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13876','2005-08-20T15:15:28.000','3137','334','2005-08-23T12:42:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13877','2005-08-20T15:16:18.000','3387','5','2005-08-22T18:20:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13878','2005-08-20T15:17:38.000','49','481','2005-08-21T21:11:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13879','2005-08-20T15:18:10.000','4022','112','2005-08-22T19:23:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13880','2005-08-20T15:18:20.000','3911','268','2005-08-24T18:03:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13881','2005-08-20T15:18:55.000','2831','144','2005-08-25T11:25:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13882','2005-08-20T15:23:26.000','3245','51','2005-08-22T13:03:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13883','2005-08-20T15:28:53.000','584','568','2005-08-21T13:11:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13884','2005-08-20T15:30:51.000','3182','466','2005-08-26T13:34:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13885','2005-08-20T15:32:09.000','3195','537','2005-08-26T15:54:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13886','2005-08-20T15:34:43.000','2248','73','2005-08-26T11:48:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13887','2005-08-20T15:39:00.000','4002','413','2005-08-24T16:17:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13888','2005-08-20T15:39:42.000','1943','297','2005-08-28T13:41:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13889','2005-08-20T15:40:06.000','4406','501','2005-08-22T14:09:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13890','2005-08-20T15:41:00.000','2965','54','2005-08-22T16:00:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13891','2005-08-20T15:42:05.000','2042','289','2005-08-25T13:26:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13892','2005-08-20T15:50:17.000','1236','337','2005-08-29T13:33:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13893','2005-08-20T15:52:52.000','3503','390','2005-08-27T16:21:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13894','2005-08-20T15:55:20.000','2649','360','2005-08-26T17:26:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13895','2005-08-20T15:58:28.000','3060','12','2005-08-26T15:07:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13896','2005-08-20T15:59:56.000','1338','278','2005-08-21T20:14:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13897','2005-08-20T16:02:28.000','628','258','2005-08-23T14:29:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13898','2006-02-14T15:16:03.000','4007','369',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13899','2005-08-20T16:05:11.000','427','204','2005-08-23T15:14:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13900','2005-08-20T16:05:41.000','1140','66','2005-08-22T15:13:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13901','2005-08-20T16:06:53.000','3281','166','2005-08-28T11:30:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13902','2005-08-20T16:07:08.000','1165','275','2005-08-24T16:43:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13903','2005-08-20T16:07:55.000','1676','272','2005-08-25T18:26:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13904','2005-08-20T16:11:34.000','721','93','2005-08-26T12:46:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13905','2005-08-20T16:12:48.000','2714','437','2005-08-28T16:05:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13906','2005-08-20T16:16:03.000','3960','87','2005-08-21T13:29:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13907','2005-08-20T16:17:27.000','806','328','2005-08-24T20:14:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13908','2005-08-20T16:21:40.000','3661','532','2005-08-29T21:16:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13909','2005-08-20T16:26:36.000','1508','309','2005-08-21T20:59:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13910','2005-08-20T16:30:49.000','252','133','2005-08-24T13:30:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13911','2005-08-20T16:31:33.000','4400','304','2005-08-28T19:26:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13912','2005-08-20T16:32:10.000','968','207','2005-08-29T17:37:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13913','2005-08-20T16:37:35.000','4259','197','2005-08-26T13:12:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13914','2005-08-20T16:38:57.000','3037','237','2005-08-26T14:53:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13915','2005-08-20T16:42:53.000','1180','129','2005-08-23T20:30:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13916','2005-08-20T16:43:02.000','2971','302','2005-08-25T19:21:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13917','2005-08-20T16:43:28.000','4326','10','2005-08-29T16:44:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13918','2005-08-20T16:47:32.000','3301','248','2005-08-21T12:00:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13919','2005-08-20T16:47:34.000','909','129','2005-08-23T21:27:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13920','2005-08-20T16:51:18.000','3200','460','2005-08-27T16:05:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13921','2005-08-20T16:57:11.000','3943','59','2005-08-22T19:25:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13922','2005-08-20T17:02:37.000','1398','237','2005-08-29T19:28:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13923','2005-08-20T17:05:02.000','3129','588','2005-08-27T11:22:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13924','2005-08-20T17:05:18.000','3066','444','2005-08-23T16:54:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13925','2005-08-20T17:05:34.000','4034','565','2005-08-27T15:32:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13926','2005-08-20T17:09:27.000','932','158','2005-08-28T13:42:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13927','2005-08-20T17:11:58.000','4284','417','2005-08-24T12:44:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13928','2005-08-20T17:12:28.000','1121','244','2005-08-21T13:33:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13929','2005-08-20T17:13:48.000','946','57','2005-08-28T15:19:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13930','2005-08-20T17:15:06.000','3585','58','2005-08-21T14:29:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13931','2005-08-20T17:16:10.000','3884','32','2005-08-27T12:03:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13932','2005-08-20T17:17:00.000','471','441','2005-08-24T14:06:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13933','2005-08-20T17:17:07.000','647','159','2005-08-22T18:10:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13934','2005-08-20T17:18:48.000','4567','457','2005-08-26T15:31:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13935','2005-08-20T17:20:49.000','4426','205','2005-08-24T16:52:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13936','2005-08-20T17:22:35.000','1731','364','2005-08-23T20:07:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13937','2005-08-20T17:22:51.000','1755','172','2005-08-27T15:51:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13938','2005-08-20T17:24:45.000','3743','463','2005-08-21T18:39:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13939','2005-08-20T17:28:01.000','2700','585','2005-08-23T14:40:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13940','2005-08-20T17:28:57.000','2638','187','2005-08-27T22:07:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13941','2006-02-14T15:16:03.000','2727','476',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13942','2005-08-20T17:30:52.000','4403','211','2005-08-25T13:46:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13943','2005-08-20T17:31:18.000','22','464','2005-08-24T11:33:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13944','2005-08-20T17:41:16.000','3685','408','2005-08-23T12:02:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13945','2005-08-20T17:43:56.000','3328','270','2005-08-26T19:19:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13946','2005-08-20T17:44:32.000','3564','529','2005-08-28T19:19:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13947','2005-08-20T17:46:06.000','2562','218','2005-08-29T23:44:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13948','2005-08-20T17:50:48.000','4033','410','2005-08-25T20:56:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13949','2005-08-20T17:55:13.000','1518','34','2005-08-22T20:49:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13950','2005-08-20T17:58:00.000','3978','93','2005-08-29T23:23:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13951','2005-08-20T17:58:11.000','2034','40','2005-08-26T14:50:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13952','2006-02-14T15:16:03.000','224','199',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13953','2005-08-20T18:00:37.000','1818','371','2005-08-28T14:52:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13954','2005-08-20T18:02:41.000','3812','207','2005-08-27T21:52:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13955','2005-08-20T18:05:12.000','2613','273','2005-08-29T18:25:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13956','2005-08-20T18:08:19.000','3757','484','2005-08-29T17:03:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13957','2005-08-20T18:09:04.000','2889','179','2005-08-23T16:52:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13958','2005-08-20T18:11:44.000','2380','33','2005-08-28T14:59:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13959','2005-08-20T18:16:21.000','2283','142','2005-08-22T13:56:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13960','2005-08-20T18:16:26.000','4177','459','2005-08-29T14:06:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13961','2005-08-20T18:16:34.000','2271','129','2005-08-21T16:14:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13962','2005-08-20T18:18:06.000','1434','348','2005-08-24T22:16:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13963','2005-08-20T18:20:18.000','4145','368','2005-08-24T21:26:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13964','2005-08-20T18:24:26.000','108','128','2005-08-21T21:19:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13965','2006-02-14T15:16:03.000','670','324',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13966','2005-08-20T18:28:28.000','4520','260','2005-08-22T16:49:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13967','2005-08-20T18:28:46.000','2751','459','2005-08-26T17:37:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13968','2006-02-14T15:16:03.000','3715','15',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13969','2005-08-20T18:42:40.000','1836','237','2005-08-27T17:33:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13970','2005-08-20T18:43:34.000','1942','418','2005-08-22T15:17:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13971','2005-08-20T18:44:53.000','1678','64','2005-08-22T16:25:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13972','2005-08-20T18:52:17.000','1687','553','2005-08-28T15:19:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13973','2005-08-20T18:52:43.000','1181','58','2005-08-21T19:11:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13974','2005-08-20T18:54:59.000','1912','479','2005-08-28T13:02:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13975','2005-08-20T18:58:23.000','3821','286','2005-08-25T20:58:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13976','2005-08-20T19:02:16.000','1785','278','2005-08-25T17:58:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13977','2005-08-20T19:02:34.000','1126','115','2005-08-24T14:14:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13978','2005-08-20T19:03:25.000','1263','260','2005-08-27T18:02:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13979','2005-08-20T19:03:49.000','2998','211','2005-08-24T21:23:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13980','2005-08-20T19:04:40.000','1067','391','2005-08-21T18:36:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13981','2005-08-20T19:07:20.000','3342','249','2005-08-23T15:13:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13982','2005-08-20T19:08:25.000','2901','448','2005-08-28T15:59:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13983','2005-08-20T19:08:32.000','457','231','2005-08-29T23:45:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13984','2005-08-20T19:12:30.000','2183','473','2005-08-29T22:04:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13985','2005-08-20T19:13:06.000','1081','339','2005-08-24T21:24:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13986','2005-08-20T19:13:23.000','3701','152','2005-08-22T20:59:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13987','2005-08-20T19:19:30.000','1443','246','2005-08-23T15:37:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13988','2005-08-20T19:21:28.000','3567','466','2005-08-21T22:20:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13989','2005-08-20T19:27:50.000','1470','252','2005-08-28T15:17:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13990','2005-08-20T19:29:23.000','2272','481','2005-08-25T18:50:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13991','2005-08-20T19:29:44.000','1971','296','2005-08-24T21:10:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13992','2005-08-20T19:30:35.000','2798','136','2005-08-24T19:09:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13993','2005-08-20T19:32:29.000','1158','93','2005-08-26T16:59:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13994','2005-08-20T19:33:21.000','142','180','2005-08-24T20:55:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13995','2005-08-20T19:34:43.000','3789','381','2005-08-25T22:25:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13996','2005-08-20T19:45:43.000','3341','306','2005-08-22T16:47:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13997','2005-08-20T19:51:28.000','2330','175','2005-08-26T01:29:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13998','2005-08-20T19:52:38.000','3936','530','2005-08-26T14:57:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('13999','2005-08-20T19:53:32.000','4149','239','2005-08-26T19:01:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14000','2005-08-20T20:06:05.000','3907','276','2005-08-28T17:02:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14001','2005-08-20T20:07:15.000','1318','120','2005-08-27T00:50:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14002','2005-08-20T20:12:19.000','87','33','2005-08-23T00:23:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14003','2005-08-20T20:16:06.000','3165','256','2005-08-28T14:36:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14004','2005-08-20T20:16:35.000','3445','358','2005-08-28T17:23:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14005','2005-08-20T20:19:05.000','1415','135','2005-08-26T01:42:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14006','2005-08-20T20:21:36.000','2189','186','2005-08-21T15:26:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14007','2005-08-20T20:22:47.000','374','284','2005-08-28T20:40:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14008','2005-08-20T20:26:00.000','2427','560','2005-08-28T17:23:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14009','2005-08-20T20:26:53.000','3004','382','2005-08-21T23:32:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14010','2005-08-20T20:29:46.000','934','537','2005-08-26T17:37:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14011','2005-08-20T20:32:56.000','1212','379','2005-08-28T21:44:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14012','2005-08-20T20:42:12.000','1866','274','2005-08-23T23:10:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14013','2005-08-20T20:42:50.000','3941','496','2005-08-25T21:37:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14014','2005-08-20T20:47:09.000','2188','335','2005-08-21T22:08:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14015','2005-08-20T20:47:43.000','3145','554','2005-08-26T19:37:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14016','2005-08-20T20:52:03.000','509','220','2005-08-23T18:04:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14017','2005-08-20T20:55:32.000','920','230','2005-08-23T16:12:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14018','2006-02-14T15:16:03.000','2136','533',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14019','2005-08-20T20:59:15.000','1929','202','2005-08-28T17:29:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14020','2005-08-20T20:59:43.000','2257','72','2005-08-23T17:11:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14021','2005-08-20T21:02:12.000','4394','147','2005-08-27T22:15:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14022','2005-08-20T21:08:49.000','4068','170','2005-08-29T21:57:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14023','2005-08-20T21:10:32.000','2668','304','2005-08-23T20:57:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14024','2005-08-20T21:13:58.000','1492','87','2005-08-29T23:02:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14025','2005-08-20T21:19:36.000','4521','37','2005-08-29T23:39:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14026','2005-08-20T21:21:08.000','115','231','2005-08-22T23:19:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14027','2005-08-20T21:21:34.000','284','432','2005-08-28T17:46:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14028','2005-08-20T21:23:03.000','4061','158','2005-08-25T17:29:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14029','2005-08-20T21:23:11.000','2653','219','2005-08-22T18:01:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14030','2005-08-20T21:23:54.000','1027','127','2005-08-27T01:19:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14031','2005-08-20T21:24:24.000','440','361','2005-08-23T21:47:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14032','2005-08-20T21:26:55.000','3542','317','2005-08-26T19:19:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14033','2005-08-20T21:30:53.000','525','243','2005-08-23T01:45:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14034','2005-08-20T21:31:52.000','3484','200','2005-08-29T00:13:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14035','2005-08-20T21:31:58.000','2035','260','2005-08-22T16:28:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14036','2005-08-20T21:35:27.000','202','256','2005-08-23T03:29:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14037','2005-08-20T21:35:58.000','3655','372','2005-08-29T23:06:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14038','2005-08-20T21:39:23.000','1069','589','2005-08-27T23:57:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14039','2005-08-20T21:39:43.000','4187','383','2005-08-24T19:03:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14040','2005-08-20T21:43:44.000','905','17','2005-08-25T16:30:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14041','2005-08-20T21:45:23.000','52','247','2005-08-26T01:42:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14042','2005-08-20T21:45:51.000','505','322','2005-08-23T19:57:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14043','2005-08-20T21:46:43.000','1485','586','2005-08-21T18:27:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14044','2005-08-20T21:48:38.000','1422','145','2005-08-29T02:56:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14045','2005-08-20T21:50:11.000','3010','509','2005-08-25T19:03:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14046','2005-08-20T21:53:21.000','2352','524','2005-08-23T17:51:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14047','2005-08-20T22:00:43.000','186','579','2005-08-24T03:17:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14048','2005-08-20T22:03:18.000','3475','105','2005-08-25T02:57:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14049','2005-08-20T22:08:55.000','1335','112','2005-08-28T20:24:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14050','2005-08-20T22:09:04.000','1737','596','2005-08-26T01:39:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14051','2005-08-20T22:09:51.000','4012','362','2005-08-29T04:04:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14052','2005-08-20T22:11:46.000','3893','514','2005-08-22T20:26:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14053','2005-08-20T22:13:59.000','2177','5','2005-08-26T20:50:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14054','2005-08-20T22:17:01.000','338','50','2005-08-21T21:34:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14055','2005-08-20T22:18:00.000','1571','148','2005-08-22T02:09:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14056','2005-08-20T22:18:53.000','1300','22','2005-08-27T01:05:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14057','2005-08-20T22:22:59.000','1526','333','2005-08-25T16:58:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14058','2005-08-20T22:24:35.000','178','430','2005-08-30T02:26:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14059','2005-08-20T22:24:44.000','2045','141','2005-08-26T21:25:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14060','2006-02-14T15:16:03.000','3100','175',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14061','2005-08-20T22:32:11.000','73','53','2005-08-22T19:28:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14062','2005-08-20T22:34:34.000','2841','239','2005-08-25T17:11:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14063','2005-08-20T22:36:40.000','1215','275','2005-08-25T00:18:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14064','2005-08-20T22:39:16.000','2938','103','2005-08-22T00:45:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14065','2005-08-20T22:40:47.000','3758','190','2005-08-24T01:47:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14066','2005-08-20T22:45:58.000','2444','274','2005-08-29T00:23:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14067','2005-08-20T22:49:23.000','1376','259','2005-08-29T22:28:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14068','2005-08-20T22:50:59.000','818','412','2005-08-29T00:45:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14069','2005-08-20T22:51:25.000','2239','197','2005-08-30T00:30:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14070','2005-08-20T22:56:34.000','846','581','2005-08-29T22:02:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14071','2005-08-20T23:01:56.000','2471','550','2005-08-22T02:14:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14072','2005-08-20T23:07:10.000','2387','515','2005-08-23T03:38:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14073','2005-08-20T23:12:57.000','2996','230','2005-08-28T18:47:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14074','2005-08-20T23:16:07.000','1303','506','2005-08-26T04:45:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14075','2005-08-20T23:18:54.000','3793','32','2005-08-26T21:59:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14076','2005-08-20T23:20:10.000','1070','574','2005-08-24T04:00:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14077','2005-08-20T23:24:07.000','3184','21','2005-08-29T02:53:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14078','2005-08-20T23:26:40.000','1642','396','2005-08-28T02:30:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14079','2005-08-20T23:29:25.000','3528','348','2005-08-25T04:16:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14080','2005-08-20T23:29:50.000','3962','266','2005-08-26T00:33:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14081','2005-08-20T23:35:13.000','589','392','2005-08-28T01:41:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14082','2005-08-20T23:42:00.000','3767','179','2005-08-27T00:59:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14083','2005-08-20T23:42:31.000','1823','176','2005-08-28T21:44:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14084','2005-08-20T23:42:46.000','900','37','2005-08-24T20:06:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14085','2005-08-20T23:46:24.000','3506','471','2005-08-29T02:31:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14086','2005-08-20T23:47:54.000','3244','253','2005-08-27T22:49:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14087','2005-08-20T23:53:40.000','2368','289','2005-08-26T20:22:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14088','2005-08-20T23:57:24.000','1184','518','2005-08-28T21:49:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14089','2005-08-20T23:59:02.000','1400','425','2005-08-27T00:19:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14090','2005-08-21T00:11:16.000','3254','168','2005-08-23T19:48:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14091','2005-08-21T00:11:17.000','3304','53','2005-08-27T18:38:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14092','2005-08-21T00:14:32.000','1596','273','2005-08-24T22:22:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14093','2005-08-21T00:21:29.000','1176','177','2005-08-22T04:01:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14094','2005-08-21T00:21:35.000','3674','471','2005-08-23T05:27:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14095','2005-08-21T00:25:45.000','1550','489','2005-08-28T23:00:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14096','2005-08-21T00:27:46.000','2089','342','2005-08-22T22:53:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14097','2005-08-21T00:28:48.000','4351','88','2005-08-29T22:15:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14098','2005-08-21T00:30:32.000','6','554',NULL,'2','2006-02-23T04:12:08.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14099','2005-08-21T00:31:03.000','2452','224','2005-08-27T03:18:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14100','2005-08-21T00:31:07.000','4295','397','2005-08-25T05:31:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14101','2005-08-21T00:33:03.000','1892','19','2005-08-24T01:59:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14102','2005-08-21T00:35:21.000','3772','584','2005-08-30T04:51:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14103','2005-08-21T00:37:00.000','1438','409','2005-08-25T22:09:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14104','2005-08-21T00:37:44.000','912','178','2005-08-21T22:55:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14105','2005-08-21T00:44:34.000','1111','71','2005-08-29T19:00:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14106','2005-08-21T00:46:01.000','2673','315','2005-08-27T23:44:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14107','2006-02-14T15:16:03.000','3998','251',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14108','2005-08-21T00:52:45.000','4339','243','2005-08-21T19:35:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14109','2005-08-21T00:52:58.000','1046','180','2005-08-22T00:09:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14110','2005-08-21T00:53:09.000','2709','35','2005-08-24T05:33:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14111','2005-08-21T00:59:01.000','1294','130','2005-08-22T20:43:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14112','2005-08-21T01:00:46.000','734','141','2005-08-27T03:46:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14113','2005-08-21T01:03:30.000','931','288','2005-08-23T06:46:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14114','2005-08-21T01:07:11.000','2270','8','2005-08-24T20:33:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14115','2005-08-21T01:10:29.000','1945','257','2005-08-24T01:21:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14116','2005-08-21T01:11:17.000','2356','142','2005-08-24T23:45:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14117','2005-08-21T01:11:59.000','573','493','2005-08-22T06:56:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14118','2005-08-21T01:13:37.000','2605','337','2005-08-28T02:35:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14119','2005-08-21T01:15:59.000','129','53','2005-08-27T23:36:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14120','2005-08-21T01:25:00.000','4069','302','2005-08-24T23:21:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14121','2005-08-21T01:26:33.000','4207','417','2005-08-28T22:47:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14122','2005-08-21T01:29:01.000','3955','86','2005-08-27T05:31:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14123','2005-08-21T01:31:25.000','143','66','2005-08-23T02:32:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14124','2005-08-21T01:31:51.000','311','35','2005-08-24T22:20:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14125','2005-08-21T01:32:16.000','2174','265','2005-08-26T00:09:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14126','2005-08-21T01:32:17.000','2738','215','2005-08-23T01:02:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14127','2005-08-21T01:33:32.000','4532','550','2005-08-22T02:47:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14128','2005-08-21T01:35:58.000','2594','81','2005-08-21T21:23:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14129','2005-08-21T01:42:15.000','3572','362','2005-08-23T20:04:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14130','2005-08-21T01:43:11.000','3859','352','2005-08-27T21:16:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14131','2005-08-21T01:43:40.000','4382','267','2005-08-29T02:00:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14132','2005-08-21T01:43:58.000','3806','91','2005-08-26T20:16:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14133','2005-08-21T01:44:14.000','2463','453','2005-08-30T02:19:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14134','2005-08-21T01:45:54.000','2159','497','2005-08-24T01:36:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14135','2005-08-21T01:53:54.000','347','59','2005-08-27T05:57:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14136','2005-08-21T01:57:26.000','268','135','2005-08-28T01:11:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14137','2006-02-14T15:16:03.000','2346','53',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14138','2005-08-21T01:59:37.000','1238','121','2005-08-30T01:17:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14139','2005-08-21T02:04:33.000','2280','561','2005-08-22T04:16:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14140','2005-08-21T02:04:57.000','2070','65','2005-08-29T06:41:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14141','2005-08-21T02:07:22.000','4527','190','2005-08-30T07:32:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14142','2005-08-21T02:07:43.000','1479','544','2005-08-23T02:37:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14143','2005-08-21T02:10:32.000','2549','146','2005-08-23T23:50:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14144','2005-08-21T02:10:57.000','2366','46','2005-08-28T01:02:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14145','2005-08-21T02:11:38.000','150','314','2005-08-22T22:19:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14146','2005-08-21T02:13:31.000','2151','192','2005-08-24T22:47:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14147','2005-08-21T02:14:03.000','1476','366','2005-08-27T22:38:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14148','2005-08-21T02:17:49.000','1605','528','2005-08-22T00:12:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14149','2005-08-21T02:22:47.000','3371','518','2005-08-24T02:36:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14150','2005-08-21T02:23:03.000','2324','161','2005-08-25T22:50:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14151','2005-08-21T02:23:25.000','2785','426','2005-08-30T07:08:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14152','2005-08-21T02:23:50.000','2561','379','2005-08-25T06:05:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14153','2005-08-21T02:24:33.000','1502','120','2005-08-27T05:28:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14154','2005-08-21T02:30:00.000','951','468','2005-08-28T01:41:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14155','2005-08-21T02:31:35.000','769','148','2005-08-27T06:00:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14156','2005-08-21T02:35:16.000','437','147','2005-08-27T01:32:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14157','2005-08-21T02:43:15.000','4471','128','2005-08-24T02:47:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14158','2005-08-21T02:43:20.000','474','114','2005-08-28T02:19:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14159','2005-08-21T02:45:58.000','3231','144','2005-08-27T04:53:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14160','2006-02-14T15:16:03.000','2428','493',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14161','2005-08-21T02:51:59.000','2744','21','2005-08-28T21:38:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14162','2005-08-21T02:55:34.000','3788','315','2005-08-27T00:13:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14163','2005-08-21T02:56:52.000','1007','204','2005-08-21T21:03:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14164','2005-08-21T02:58:02.000','2381','274','2005-08-29T23:17:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14165','2005-08-21T02:59:17.000','4151','150','2005-08-24T23:09:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14166','2005-08-21T02:59:31.000','2457','190','2005-08-24T23:19:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14167','2005-08-21T02:59:48.000','1005','64','2005-08-29T22:17:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14168','2005-08-21T03:00:03.000','1321','49','2005-08-29T06:04:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14169','2005-08-21T03:00:31.000','3800','396','2005-08-30T01:16:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14170','2005-08-21T03:00:39.000','894','259','2005-08-27T23:07:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14171','2005-08-21T03:00:42.000','4179','320','2005-08-24T00:54:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14172','2006-02-14T15:16:03.000','2158','450',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14173','2005-08-21T03:01:01.000','3175','152','2005-08-22T02:40:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14174','2005-08-21T03:01:45.000','1862','29','2005-08-22T07:19:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14175','2006-02-14T15:16:03.000','2021','452',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14176','2005-08-21T03:09:23.000','4420','556','2005-08-26T21:26:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14177','2005-08-21T03:11:33.000','409','121','2005-08-28T21:41:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14178','2005-08-21T03:13:45.000','2178','524','2005-08-22T01:50:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14179','2005-08-21T03:14:27.000','3956','79','2005-08-26T00:46:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14180','2005-08-21T03:16:15.000','796','262','2005-08-24T22:31:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14181','2005-08-21T03:16:30.000','197','210','2005-08-29T06:25:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14182','2005-08-21T03:17:10.000','2422','519','2005-08-24T21:46:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14183','2005-08-21T03:24:29.000','1888','26','2005-08-22T07:25:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14184','2005-08-21T03:24:50.000','3759','148','2005-08-29T01:46:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14185','2005-08-21T03:28:37.000','3957','579','2005-08-26T01:15:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14186','2005-08-21T03:31:07.000','3158','461','2005-08-28T07:29:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14187','2005-08-21T03:32:03.000','4031','275','2005-08-25T03:29:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14188','2005-08-21T03:32:04.000','4492','548','2005-08-22T07:26:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14189','2005-08-21T03:32:17.000','2209','127','2005-08-22T04:46:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14190','2005-08-21T03:35:21.000','4203','517','2005-08-29T07:35:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14191','2005-08-21T03:35:58.000','301','423','2005-08-28T00:28:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14192','2005-08-21T03:37:42.000','3563','26','2005-08-28T05:31:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14193','2005-08-21T03:38:27.000','513','25','2005-08-28T09:16:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14194','2005-08-21T03:40:11.000','2003','138','2005-08-26T07:38:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14195','2005-08-21T03:40:35.000','3732','93','2005-08-23T01:22:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14196','2005-08-21T03:40:40.000','4477','281','2005-08-25T05:55:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14197','2005-08-21T03:47:25.000','340','469','2005-08-30T09:15:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14198','2005-08-21T03:48:31.000','465','381','2005-08-24T07:10:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14199','2005-08-21T03:48:43.000','658','442','2005-08-23T04:01:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14200','2005-08-21T03:51:27.000','2339','349','2005-08-29T22:00:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14201','2005-08-21T03:51:34.000','314','427','2005-08-30T03:42:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14202','2005-08-21T03:51:52.000','1995','473','2005-08-22T09:35:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14203','2005-08-21T03:51:52.000','3668','95','2005-08-24T06:13:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14204','2006-02-14T15:16:03.000','4334','287',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14205','2005-08-21T03:57:15.000','315','406','2005-08-30T08:46:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14206','2005-08-21T03:59:26.000','860','279','2005-08-26T03:52:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14207','2005-08-21T04:08:19.000','1327','569','2005-08-29T07:59:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14208','2005-08-21T04:09:18.000','4180','299','2005-08-22T03:29:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14209','2005-08-21T04:17:56.000','896','472','2005-08-27T06:57:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14210','2005-08-21T04:28:02.000','1867','468','2005-08-24T02:14:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14211','2005-08-21T04:29:11.000','300','372','2005-08-24T02:50:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14212','2005-08-21T04:29:26.000','4540','354','2005-08-24T00:46:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14213','2005-08-21T04:30:47.000','382','511','2005-08-24T23:01:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14214','2005-08-21T04:30:49.000','4510','198','2005-08-26T04:42:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14215','2005-08-21T04:34:11.000','35','54','2005-08-27T10:30:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14216','2006-02-14T15:16:03.000','3763','186',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14217','2005-08-21T04:37:56.000','2847','66','2005-08-26T03:55:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14218','2005-08-21T04:43:59.000','4087','104','2005-08-27T10:29:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14219','2006-02-14T15:16:03.000','3718','334',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14220','2006-02-14T15:16:03.000','2618','162',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14221','2005-08-21T04:49:41.000','3824','51','2005-08-29T23:52:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14222','2005-08-21T04:49:48.000','714','7','2005-08-25T05:34:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14223','2005-08-21T04:51:51.000','514','392','2005-08-29T00:37:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14224','2005-08-21T04:53:08.000','3634','323','2005-08-27T04:12:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14225','2005-08-21T04:53:37.000','984','4','2005-08-25T23:39:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14226','2005-08-21T04:55:37.000','1793','316','2005-08-24T04:32:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14227','2005-08-21T04:56:31.000','4102','277','2005-08-22T05:04:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14228','2005-08-21T04:57:08.000','2016','71','2005-08-25T00:06:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14229','2005-08-21T04:57:15.000','4479','186','2005-08-26T10:00:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14230','2005-08-21T04:57:29.000','844','584','2005-08-27T08:14:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14231','2005-08-21T05:04:34.000','1244','307','2005-08-23T04:58:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14232','2005-08-21T05:07:02.000','2710','176','2005-08-29T06:57:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14233','2005-08-21T05:07:08.000','2943','599','2005-08-28T03:20:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14234','2005-08-21T05:07:12.000','1439','271','2005-08-23T06:44:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14235','2005-08-21T05:08:42.000','125','558','2005-08-29T23:36:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14236','2005-08-21T05:13:16.000','172','25','2005-08-26T04:03:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14237','2005-08-21T05:15:00.000','3284','410','2005-08-25T10:06:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14238','2005-08-21T05:16:40.000','3148','192','2005-08-30T02:13:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14239','2005-08-21T05:18:57.000','1559','416','2005-08-22T00:12:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14240','2005-08-21T05:19:39.000','3294','12','2005-08-22T23:25:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14241','2005-08-21T05:24:55.000','2547','291','2005-08-30T03:33:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14242','2005-08-21T05:25:59.000','1588','68','2005-08-27T07:22:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14243','2006-02-14T15:16:03.000','1489','264',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14244','2005-08-21T05:29:55.000','1150','43','2005-08-24T01:06:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14245','2005-08-21T05:30:54.000','975','354','2005-08-26T07:02:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14246','2005-08-21T05:34:09.000','3499','120','2005-08-26T06:12:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14247','2005-08-21T05:35:17.000','267','302','2005-08-26T03:22:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14248','2005-08-21T05:35:57.000','725','293','2005-08-28T05:53:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14249','2005-08-21T05:38:05.000','695','268','2005-08-28T09:07:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14250','2005-08-21T05:39:35.000','3008','313','2005-08-28T10:06:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14251','2005-08-21T05:42:20.000','139','486','2005-08-26T06:20:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14252','2005-08-21T05:44:07.000','2660','13','2005-08-29T08:53:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14253','2005-08-21T05:47:52.000','4246','456','2005-08-25T04:28:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14254','2005-08-21T05:51:28.000','1549','589','2005-08-29T06:05:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14255','2005-08-21T05:51:37.000','3125','492','2005-08-29T10:00:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14256','2005-08-21T05:52:27.000','2922','331','2005-08-29T02:10:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14257','2005-08-21T05:52:57.000','3830','178','2005-08-29T03:18:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14258','2005-08-21T05:56:36.000','752','359','2005-08-26T06:14:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14259','2005-08-21T06:00:22.000','3705','583','2005-08-22T05:38:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14260','2005-08-21T06:01:08.000','2961','40','2005-08-29T09:01:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14261','2005-08-21T06:07:24.000','1426','166','2005-08-26T09:57:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14262','2005-08-21T06:08:13.000','1430','324','2005-08-30T10:55:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14263','2005-08-21T06:08:15.000','2595','533','2005-08-29T09:22:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14264','2005-08-21T06:18:22.000','3426','295','2005-08-25T08:08:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14265','2005-08-21T06:20:14.000','3116','134','2005-08-23T09:05:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14266','2005-08-21T06:20:51.000','3543','269','2005-08-23T00:44:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14267','2006-02-14T15:16:03.000','2199','527',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14268','2005-08-21T06:21:24.000','2442','278','2005-08-23T05:39:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14269','2005-08-21T06:22:07.000','531','241','2005-08-30T00:41:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14270','2005-08-21T06:22:18.000','4083','171','2005-08-27T08:04:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14271','2005-08-21T06:23:29.000','4506','224','2005-08-27T04:49:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14272','2005-08-21T06:24:55.000','3908','243','2005-08-28T02:25:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14273','2005-08-21T06:26:48.000','2640','388','2005-08-30T10:34:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14274','2005-08-21T06:29:20.000','3183','405','2005-08-26T06:25:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14275','2005-08-21T06:30:30.000','3238','163','2005-08-25T12:28:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14276','2005-08-21T06:34:05.000','3637','318','2005-08-28T10:13:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14277','2005-08-21T06:34:41.000','2652','566','2005-08-28T10:53:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14278','2006-02-14T15:16:03.000','2334','557',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14279','2005-08-21T06:39:08.000','3325','387','2005-08-29T11:01:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14280','2005-08-21T06:39:58.000','1561','481','2005-08-23T04:50:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14281','2005-08-21T06:40:48.000','1848','166','2005-08-26T11:42:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14282','2005-08-21T06:41:29.000','3107','450','2005-08-22T12:37:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14283','2005-08-21T06:44:14.000','3052','253','2005-08-24T01:01:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14284','2005-08-21T06:44:37.000','633','486','2005-08-28T05:03:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14285','2005-08-21T06:50:48.000','402','249','2005-08-28T11:35:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14286','2005-08-21T06:53:53.000','2377','558','2005-08-27T11:37:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14287','2005-08-21T06:53:59.000','2426','427','2005-08-25T03:10:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14288','2005-08-21T06:57:34.000','587','512','2005-08-26T11:32:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14289','2005-08-21T06:58:49.000','1185','103','2005-08-25T11:29:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14290','2005-08-21T07:02:59.000','790','366','2005-08-28T02:57:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14291','2005-08-21T07:03:05.000','3988','56','2005-08-26T12:56:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14292','2005-08-21T07:06:20.000','1959','251','2005-08-22T01:39:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14293','2005-08-21T07:06:47.000','3555','364','2005-08-22T05:07:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14294','2005-08-21T07:07:26.000','354','455','2005-08-22T02:20:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14295','2005-08-21T07:09:27.000','2187','336','2005-08-22T01:27:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14296','2005-08-21T07:13:23.000','3813','275','2005-08-26T11:14:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14297','2005-08-21T07:13:46.000','1712','566','2005-08-25T09:07:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14298','2005-08-21T07:17:10.000','4317','410','2005-08-25T10:10:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14299','2005-08-21T07:18:57.000','4028','342','2005-08-24T01:28:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14300','2005-08-21T07:19:37.000','690','382','2005-08-25T12:06:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14301','2005-08-21T07:19:48.000','283','162','2005-08-28T02:06:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14302','2005-08-21T07:19:57.000','1287','511','2005-08-28T02:59:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14303','2005-08-21T07:22:43.000','992','475','2005-08-24T11:52:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14304','2005-08-21T07:23:10.000','2650','417','2005-08-26T11:21:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14305','2005-08-21T07:29:05.000','2056','58','2005-08-27T08:18:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14306','2005-08-21T07:32:35.000','4027','453','2005-08-30T05:53:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14307','2005-08-21T07:34:52.000','2894','328','2005-08-29T09:45:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14308','2005-08-21T07:43:21.000','3478','419','2005-08-25T02:39:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14309','2005-08-21T07:44:17.000','4447','468','2005-08-30T07:23:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14310','2005-08-21T07:44:32.000','95','177','2005-08-22T09:02:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14311','2005-08-21T07:45:47.000','1761','69','2005-08-27T02:23:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14312','2005-08-21T07:48:34.000','1090','238','2005-08-23T04:45:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14313','2005-08-21T07:49:53.000','3384','468','2005-08-30T05:52:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14314','2005-08-21T07:50:14.000','4115','178','2005-08-24T10:47:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14315','2005-08-21T07:56:39.000','1164','459','2005-08-27T04:52:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14316','2005-08-21T07:59:47.000','386','64','2005-08-23T02:20:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14317','2005-08-21T08:00:40.000','2090','471','2005-08-27T06:52:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14318','2006-02-14T15:16:03.000','1042','508',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14319','2005-08-21T08:00:55.000','4480','410','2005-08-26T05:04:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14320','2005-08-21T08:04:40.000','3121','199','2005-08-22T02:09:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14321','2005-08-21T08:05:12.000','967','236','2005-08-23T02:17:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14322','2005-08-21T08:06:30.000','2818','221','2005-08-29T10:12:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14323','2005-08-21T08:08:43.000','1257','97','2005-08-25T10:44:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14324','2005-08-21T08:10:56.000','1361','155','2005-08-30T12:09:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14325','2005-08-21T08:15:38.000','4432','313','2005-08-23T08:08:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14326','2005-08-21T08:15:41.000','1052','17','2005-08-27T05:22:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14327','2005-08-21T08:18:18.000','553','457','2005-08-30T02:21:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14328','2005-08-21T08:18:20.000','3194','489','2005-08-25T03:05:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14329','2005-08-21T08:22:56.000','3544','6','2005-08-28T02:22:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14330','2005-08-21T08:29:20.000','763','84','2005-08-30T03:59:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14331','2005-08-21T08:29:38.000','3128','372','2005-08-29T13:18:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14332','2005-08-21T08:30:43.000','1388','496','2005-08-29T10:51:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14333','2005-08-21T08:31:03.000','2976','93','2005-08-28T03:39:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14334','2005-08-21T08:32:32.000','1448','595','2005-08-25T02:53:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14335','2005-08-21T08:33:07.000','2610','263','2005-08-26T14:16:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14336','2005-08-21T08:33:42.000','3166','362','2005-08-23T03:27:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14337','2005-08-21T08:34:26.000','3529','506','2005-08-24T11:31:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14338','2005-08-21T08:36:03.000','1789','205','2005-08-24T12:31:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14339','2005-08-21T08:37:15.000','1744','30','2005-08-26T03:37:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14340','2005-08-21T08:38:21.000','2181','230','2005-08-25T09:25:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14341','2005-08-21T08:38:24.000','4498','560','2005-08-26T12:36:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14342','2005-08-21T08:39:26.000','2749','559','2005-08-23T11:40:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14343','2005-08-21T08:40:21.000','3769','238','2005-08-29T03:06:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14344','2005-08-21T08:40:56.000','1562','341','2005-08-27T12:40:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14345','2005-08-21T08:41:15.000','1726','598','2005-08-24T11:59:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14346','2005-08-21T08:42:26.000','109','17','2005-08-23T09:18:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14347','2005-08-21T08:42:31.000','3862','214','2005-08-25T07:11:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14348','2005-08-21T08:54:26.000','885','496','2005-08-24T02:55:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14349','2005-08-21T08:54:53.000','96','119','2005-08-30T14:27:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14350','2005-08-21T08:58:38.000','3174','222','2005-08-30T03:29:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14351','2005-08-21T09:04:20.000','2037','66','2005-08-25T05:27:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14352','2005-08-21T09:06:29.000','1224','527','2005-08-28T13:36:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14353','2005-08-21T09:07:50.000','1612','129','2005-08-22T10:31:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14354','2005-08-21T09:08:14.000','1137','382','2005-08-30T05:27:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14355','2005-08-21T09:08:29.000','649','271','2005-08-27T10:08:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14356','2005-08-21T09:08:51.000','3169','65','2005-08-24T04:36:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14357','2005-08-21T09:13:09.000','2906','233','2005-08-22T05:41:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14358','2005-08-21T09:14:28.000','861','112','2005-08-24T05:05:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14359','2005-08-21T09:16:19.000','1841','401','2005-08-22T09:28:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14360','2005-08-21T09:16:40.000','2677','246','2005-08-29T11:43:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14361','2006-02-14T15:16:03.000','1231','191',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14362','2005-08-21T09:19:49.000','1992','312','2005-08-26T11:06:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14363','2005-08-21T09:20:03.000','2579','560','2005-08-23T14:26:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14364','2005-08-21T09:25:11.000','3513','236','2005-08-29T09:04:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14365','2005-08-21T09:25:13.000','618','457','2005-08-27T11:48:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14366','2005-08-21T09:31:39.000','4011','524','2005-08-26T11:55:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14367','2005-08-21T09:31:44.000','870','244','2005-08-26T03:54:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14368','2005-08-21T09:31:47.000','2063','351','2005-08-30T04:17:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14369','2005-08-21T09:33:44.000','1636','392','2005-08-25T08:56:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14370','2005-08-21T09:35:14.000','3520','161','2005-08-27T05:21:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14371','2005-08-21T09:37:16.000','2197','221','2005-08-27T13:50:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14372','2005-08-21T09:39:50.000','1953','520','2005-08-28T13:36:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14373','2005-08-21T09:44:53.000','4433','268','2005-08-25T15:37:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14374','2006-02-14T15:16:03.000','236','213',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14375','2005-08-21T09:46:35.000','2507','550','2005-08-26T10:24:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14376','2005-08-21T09:48:56.000','1936','582','2005-08-22T12:15:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14377','2005-08-21T09:49:28.000','1325','6','2005-08-29T13:34:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14378','2005-08-21T09:50:02.000','810','515','2005-08-30T09:07:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14379','2005-08-21T09:53:03.000','3062','136','2005-08-24T14:32:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14380','2005-08-21T09:53:52.000','1523','198','2005-08-25T05:03:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14381','2005-08-21T09:55:47.000','811','391','2005-08-25T08:23:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14382','2005-08-21T10:01:03.000','4119','119','2005-08-22T13:21:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14383','2005-08-21T10:02:05.000','1941','482','2005-08-24T12:21:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14384','2005-08-21T10:02:37.000','2429','371','2005-08-26T08:20:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14385','2005-08-21T10:02:55.000','4356','317','2005-08-25T07:19:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14386','2005-08-21T10:06:34.000','3402','514','2005-08-25T14:19:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14387','2005-08-21T10:10:01.000','1286','295','2005-08-28T14:16:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14388','2005-08-21T10:15:13.000','1078','274','2005-08-30T13:41:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14389','2005-08-21T10:15:20.000','2718','145','2005-08-27T05:39:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14390','2005-08-21T10:15:38.000','3951','366','2005-08-28T05:50:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14391','2005-08-21T10:16:27.000','3117','205','2005-08-23T07:00:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14392','2005-08-21T10:19:25.000','847','586','2005-08-28T15:57:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14393','2005-08-21T10:22:51.000','3937','368','2005-08-29T08:28:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14394','2005-08-21T10:23:10.000','4555','118','2005-08-28T09:33:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14395','2005-08-21T10:24:00.000','632','506','2005-08-28T12:23:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14396','2005-08-21T10:24:54.000','3855','353','2005-08-22T04:49:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14397','2005-08-21T10:25:56.000','3883','47','2005-08-24T07:48:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14398','2005-08-21T10:27:21.000','357','505','2005-08-23T10:46:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14399','2005-08-21T10:33:23.000','3582','188','2005-08-27T08:00:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14400','2005-08-21T10:33:45.000','3891','569','2005-08-26T12:05:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14401','2005-08-21T10:36:20.000','3468','407','2005-08-30T06:45:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14402','2005-08-21T10:38:17.000','749','467','2005-08-27T08:36:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14403','2005-08-21T10:40:34.000','3581','297','2005-08-29T11:29:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14404','2005-08-21T10:43:04.000','3660','192','2005-08-30T10:00:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14405','2005-08-21T10:45:01.000','2777','470','2005-08-30T04:48:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14406','2005-08-21T10:46:35.000','2741','181','2005-08-28T15:55:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14407','2005-08-21T10:46:51.000','2403','500','2005-08-25T09:28:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14408','2005-08-21T10:47:24.000','222','593','2005-08-27T08:18:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14409','2005-08-21T10:53:35.000','1161','314','2005-08-25T10:40:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14410','2005-08-21T10:54:49.000','839','196','2005-08-26T08:28:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14411','2005-08-21T10:54:57.000','2125','502','2005-08-22T13:17:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14412','2005-08-21T11:02:09.000','212','121','2005-08-29T06:44:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14413','2005-08-21T11:06:33.000','50','367','2005-08-29T16:10:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14414','2005-08-21T11:08:17.000','1757','515','2005-08-23T08:37:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14415','2006-02-14T15:16:03.000','2670','561',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14416','2005-08-21T11:11:46.000','3002','384','2005-08-25T12:33:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14417','2005-08-21T11:13:35.000','1768','596','2005-08-25T11:27:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14418','2005-08-21T11:14:26.000','89','442','2005-08-28T08:34:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14419','2005-08-21T11:15:46.000','3146','221','2005-08-30T16:37:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14420','2005-08-21T11:16:15.000','2495','551','2005-08-24T06:06:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14421','2005-08-21T11:20:21.000','4402','406','2005-08-24T06:26:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14422','2005-08-21T11:21:46.000','1382','361','2005-08-25T13:15:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14423','2005-08-21T11:23:59.000','2873','521','2005-08-26T11:52:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14424','2005-08-21T11:24:11.000','2535','489','2005-08-29T13:13:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14425','2006-02-14T15:16:03.000','2752','560',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14426','2006-02-14T15:16:03.000','2902','315',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14427','2005-08-21T11:26:06.000','2353','163','2005-08-27T10:39:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14428','2005-08-21T11:27:07.000','1614','458','2005-08-29T09:50:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14429','2005-08-21T11:29:43.000','2513','66','2005-08-24T12:05:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14430','2005-08-21T11:31:11.000','2623','5','2005-08-26T06:29:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14431','2005-08-21T11:31:15.000','1572','106','2005-08-26T11:22:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14432','2005-08-21T11:36:15.000','2294','138','2005-08-24T08:02:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14433','2005-08-21T11:36:34.000','732','401','2005-08-26T08:51:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14434','2005-08-21T11:40:46.000','2085','549','2005-08-24T05:50:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14435','2005-08-21T11:44:37.000','2919','169','2005-08-24T08:04:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14436','2005-08-21T11:48:27.000','3473','560','2005-08-25T15:49:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14437','2005-08-21T11:48:32.000','1504','136','2005-08-25T11:06:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14438','2005-08-21T11:51:10.000','1621','392','2005-08-28T17:10:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14439','2005-08-21T11:52:41.000','3903','564','2005-08-30T10:36:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14440','2005-08-21T11:59:04.000','3495','194','2005-08-23T10:10:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14441','2005-08-21T11:59:38.000','1210','260','2005-08-26T11:17:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14442','2005-08-21T12:00:21.000','122','205','2005-08-23T17:00:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14443','2005-08-21T12:06:32.000','376','447','2005-08-29T13:44:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14444','2005-08-21T12:07:25.000','2211','225','2005-08-28T08:36:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14445','2005-08-21T12:07:42.000','3186','256','2005-08-22T17:51:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14446','2005-08-21T12:10:41.000','4367','21','2005-08-26T14:42:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14447','2005-08-21T12:12:05.000','1889','584','2005-08-27T14:47:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14448','2005-08-21T12:13:10.000','1937','263','2005-08-30T08:46:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14449','2005-08-21T12:13:18.000','653','529','2005-08-27T15:41:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14450','2005-08-21T12:21:25.000','1194','48','2005-08-26T14:35:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14451','2005-08-21T12:21:44.000','3967','467','2005-08-22T15:07:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14452','2005-08-21T12:23:20.000','4231','325','2005-08-27T06:26:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14453','2005-08-21T12:33:34.000','3312','237','2005-08-27T11:10:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14454','2005-08-21T12:35:49.000','2475','150','2005-08-22T16:28:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14455','2005-08-21T12:36:11.000','3442','68','2005-08-27T08:12:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14456','2005-08-21T12:38:09.000','2520','125','2005-08-26T08:29:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14457','2005-08-21T12:47:38.000','4288','340','2005-08-25T13:07:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14458','2005-08-21T12:47:53.000','1769','256','2005-08-30T17:09:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14459','2005-08-21T12:48:08.000','1532','98','2005-08-27T10:50:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14460','2005-08-21T12:48:48.000','4137','120','2005-08-30T16:34:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14461','2005-08-21T12:50:33.000','371','42','2005-08-30T13:35:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14462','2005-08-21T12:50:57.000','2201','96','2005-08-27T10:42:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14463','2005-08-21T12:51:49.000','1403','365','2005-08-29T12:17:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14464','2005-08-21T12:52:54.000','2310','121','2005-08-25T16:42:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14465','2005-08-21T12:54:22.000','4206','262','2005-08-28T10:46:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14466','2005-08-21T13:03:13.000','923','442','2005-08-22T15:19:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14467','2005-08-21T13:03:33.000','1498','522','2005-08-28T15:28:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14468','2005-08-21T13:07:10.000','4168','224','2005-08-30T19:05:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14469','2005-08-21T13:07:24.000','1957','554','2005-08-24T10:37:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14470','2005-08-21T13:09:41.000','3899','379','2005-08-23T10:20:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14471','2005-08-21T13:10:40.000','1254','395','2005-08-26T16:49:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14472','2005-08-21T13:13:57.000','4097','184','2005-08-23T14:04:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14473','2005-08-21T13:19:03.000','2747','298','2005-08-23T15:12:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14474','2005-08-21T13:22:48.000','2632','294','2005-08-27T14:13:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14475','2005-08-21T13:24:32.000','3164','2','2005-08-27T08:59:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14476','2005-08-21T13:31:07.000','2821','101','2005-08-23T17:06:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14477','2005-08-21T13:32:38.000','1564','126','2005-08-25T18:02:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14478','2005-08-21T13:33:28.000','2990','231','2005-08-25T13:33:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14479','2005-08-21T13:35:54.000','2235','324','2005-08-29T12:12:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14480','2005-08-21T13:36:40.000','229','411','2005-08-26T08:39:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14481','2005-08-21T13:41:14.000','4099','367','2005-08-30T07:53:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14482','2005-08-21T13:42:45.000','2765','23','2005-08-27T11:55:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14483','2005-08-21T13:43:59.000','37','275','2005-08-28T16:38:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14484','2005-08-21T13:47:29.000','3714','418','2005-08-23T18:25:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14485','2005-08-21T13:52:07.000','1637','241','2005-08-30T13:06:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14486','2005-08-21T13:52:54.000','3119','138','2005-08-23T07:58:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14487','2005-08-21T13:53:33.000','2578','526','2005-08-29T19:32:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14488','2006-02-14T15:16:03.000','4202','75',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14489','2005-08-21T13:53:59.000','2312','9','2005-08-30T15:45:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14490','2005-08-21T13:54:15.000','1771','205','2005-08-28T19:08:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14491','2005-08-21T13:55:39.000','2072','226','2005-08-29T17:51:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14492','2005-08-21T13:59:08.000','1591','266','2005-08-23T11:09:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14493','2005-08-21T14:01:44.000','2590','389','2005-08-28T17:20:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14494','2005-08-21T14:02:50.000','169','5','2005-08-22T16:45:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14495','2005-08-21T14:04:39.000','3215','429','2005-08-22T16:53:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14496','2005-08-21T14:07:35.000','2185','223','2005-08-24T12:31:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14497','2005-08-21T14:09:47.000','3240','254','2005-08-22T11:10:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14498','2005-08-21T14:10:44.000','3971','544','2005-08-23T08:29:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14499','2005-08-21T14:11:19.000','4109','292','2005-08-23T16:10:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14500','2005-08-21T14:11:30.000','2024','451','2005-08-27T12:19:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14501','2005-08-21T14:14:38.000','3588','576','2005-08-25T17:58:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14502','2005-08-21T14:22:28.000','2986','378','2005-08-23T10:40:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14503','2006-02-14T15:16:03.000','2144','188',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14504','2005-08-21T14:23:01.000','4536','312','2005-08-27T13:56:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14505','2005-08-21T14:26:28.000','2172','203','2005-08-29T17:34:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14506','2005-08-21T14:32:27.000','4493','537','2005-08-24T19:02:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14507','2005-08-21T14:32:45.000','1969','175','2005-08-28T09:50:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14508','2005-08-21T14:33:58.000','703','396','2005-08-27T10:45:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14509','2005-08-21T14:39:58.000','541','520','2005-08-26T13:19:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14510','2005-08-21T14:44:41.000','1868','547','2005-08-30T20:19:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14511','2005-08-21T14:45:34.000','4452','16','2005-08-28T10:36:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14512','2005-08-21T14:47:09.000','579','51','2005-08-24T18:10:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14513','2005-08-21T14:51:35.000','4265','185','2005-08-24T13:24:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14514','2005-08-21T14:51:52.000','1259','295','2005-08-30T10:40:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14515','2005-08-21T14:52:14.000','2215','242','2005-08-27T10:27:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14516','2006-02-14T15:16:03.000','713','457',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14517','2005-08-21T14:57:03.000','3568','311','2005-08-24T13:52:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14518','2005-08-21T14:58:58.000','2734','82','2005-08-24T13:19:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14519','2005-08-21T14:59:29.000','1541','403','2005-08-22T11:48:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14520','2005-08-21T15:00:49.000','4533','150','2005-08-30T19:04:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14521','2005-08-21T15:01:32.000','1538','200','2005-08-28T19:12:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14522','2005-08-21T15:01:34.000','2101','535','2005-08-25T16:37:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14523','2005-08-21T15:03:45.000','345','433','2005-08-22T18:06:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14524','2005-08-21T15:05:27.000','4409','374','2005-08-29T12:07:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14525','2005-08-21T15:06:49.000','3020','420','2005-08-22T16:30:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14526','2006-02-14T15:16:03.000','1799','534',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14527','2005-08-21T15:07:42.000','3496','232','2005-08-23T12:31:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14528','2005-08-21T15:08:05.000','4305','46','2005-08-26T15:58:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14529','2005-08-21T15:08:31.000','1774','380','2005-08-29T17:15:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14530','2005-08-21T15:10:50.000','1905','77','2005-08-26T09:20:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14531','2006-02-14T15:16:03.000','4296','568',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14532','2005-08-21T15:15:03.000','2057','37','2005-08-25T17:41:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14533','2005-08-21T15:15:19.000','2202','586','2005-08-26T12:47:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14534','2005-08-21T15:16:29.000','2514','56','2005-08-26T16:18:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14535','2005-08-21T15:22:37.000','530','412','2005-08-29T19:23:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14536','2005-08-21T15:22:50.000','2615','48','2005-08-27T17:03:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14537','2005-08-21T15:24:24.000','3755','405','2005-08-23T17:14:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14538','2005-08-21T15:28:15.000','3348','471','2005-08-22T19:55:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14539','2005-08-21T15:29:47.000','3340','41','2005-08-28T19:01:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14540','2005-08-21T15:34:23.000','2362','28','2005-08-27T11:51:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14541','2005-08-21T15:34:32.000','1275','576','2005-08-25T13:18:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14542','2005-08-21T15:36:34.000','1247','101','2005-08-27T20:24:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14543','2005-08-21T15:39:01.000','709','579','2005-08-28T09:47:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14544','2005-08-21T15:41:01.000','2445','589','2005-08-24T15:20:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14545','2005-08-21T15:44:23.000','2459','13','2005-08-29T20:09:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14546','2005-08-21T15:50:50.000','1515','466','2005-08-23T11:37:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14547','2005-08-21T15:51:38.000','1172','265','2005-08-26T15:35:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14548','2005-08-21T15:53:52.000','226','299','2005-08-25T15:39:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14549','2005-08-21T15:54:21.000','4117','155','2005-08-22T17:22:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14550','2005-08-21T15:56:39.000','2814','473','2005-08-23T21:40:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14551','2005-08-21T15:57:25.000','496','521','2005-08-28T11:10:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14552','2005-08-21T15:59:27.000','1991','477','2005-08-27T11:46:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14553','2005-08-21T15:59:40.000','3160','434','2005-08-23T11:54:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14554','2005-08-21T16:03:01.000','31','38','2005-08-26T13:09:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14555','2005-08-21T16:03:02.000','1926','440','2005-08-23T14:18:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14556','2005-08-21T16:03:27.000','475','265','2005-08-29T15:49:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14557','2005-08-21T16:05:11.000','483','490','2005-08-27T16:37:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14558','2005-08-21T16:10:50.000','3958','273','2005-08-28T16:36:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14559','2005-08-21T16:11:35.000','3842','433','2005-08-30T15:26:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14560','2005-08-21T16:13:47.000','1616','579','2005-08-26T15:19:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14561','2005-08-21T16:20:43.000','2498','443','2005-08-27T16:48:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14562','2005-08-21T16:22:59.000','3501','107','2005-08-22T21:15:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14563','2005-08-21T16:23:53.000','3984','212','2005-08-25T11:30:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14564','2005-08-21T16:24:43.000','3250','22','2005-08-26T16:58:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14565','2005-08-21T16:24:45.000','4160','250','2005-08-25T14:42:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14566','2005-08-21T16:25:05.000','84','87','2005-08-26T10:31:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14567','2005-08-21T16:27:25.000','3805','214','2005-08-26T10:47:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14568','2005-08-21T16:30:48.000','3331','582','2005-08-22T13:49:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14569','2005-08-21T16:31:22.000','884','15','2005-08-25T21:27:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14570','2005-08-21T16:32:32.000','955','32','2005-08-30T12:03:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14571','2005-08-21T16:40:26.000','2218','296','2005-08-29T17:10:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14572','2005-08-21T16:44:31.000','1397','538','2005-08-26T16:35:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14573','2005-08-21T16:44:32.000','2423','240','2005-08-23T14:01:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14574','2005-08-21T16:50:34.000','1611','62','2005-08-26T14:24:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14575','2005-08-21T16:51:34.000','3752','159','2005-08-30T20:13:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14576','2005-08-21T16:52:03.000','1189','45','2005-08-28T19:43:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14577','2005-08-21T16:52:29.000','1965','126','2005-08-26T12:30:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14578','2005-08-21T16:53:38.000','3141','389','2005-08-28T20:36:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14579','2005-08-21T16:54:47.000','1205','260','2005-08-28T12:35:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14580','2005-08-21T16:56:39.000','1440','448','2005-08-28T15:25:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14581','2005-08-21T17:07:08.000','751','243','2005-08-26T16:02:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14582','2005-08-21T17:08:33.000','1004','438','2005-08-29T18:04:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14583','2005-08-21T17:11:47.000','1203','455','2005-08-24T16:16:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14584','2005-08-21T17:15:33.000','2617','481','2005-08-24T20:24:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14585','2005-08-21T17:18:33.000','82','30','2005-08-26T11:36:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14586','2005-08-21T17:19:09.000','3094','182','2005-08-26T17:00:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14587','2005-08-21T17:20:55.000','2329','250','2005-08-26T17:17:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14588','2005-08-21T17:25:53.000','1350','219','2005-08-28T21:47:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14589','2005-08-21T17:28:55.000','2810','179','2005-08-22T23:06:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14590','2005-08-21T17:29:10.000','2633','526','2005-08-28T20:15:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14591','2005-08-21T17:30:09.000','3410','538','2005-08-24T12:27:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14592','2005-08-21T17:30:17.000','2681','563','2005-08-22T20:06:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14593','2005-08-21T17:33:18.000','1399','564','2005-08-24T22:11:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14594','2005-08-21T17:34:24.000','2978','62','2005-08-26T22:04:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14595','2005-08-21T17:35:17.000','1879','118','2005-08-27T12:11:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14596','2005-08-21T17:38:37.000','2010','472','2005-08-30T20:28:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14597','2005-08-21T17:39:41.000','1160','472','2005-08-25T14:07:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14598','2005-08-21T17:40:05.000','1113','359','2005-08-29T18:16:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14599','2005-08-21T17:43:42.000','4575','599','2005-08-22T18:53:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14600','2005-08-21T17:45:21.000','3532','255','2005-08-28T19:03:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14601','2005-08-21T17:45:52.000','548','406','2005-08-29T15:10:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14602','2005-08-21T17:48:49.000','3771','370','2005-08-28T21:38:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14603','2005-08-21T17:51:06.000','94','26','2005-08-28T15:36:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14604','2006-02-14T15:16:03.000','1024','585',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14605','2005-08-21T17:56:06.000','476','394','2005-08-24T18:35:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14606','2006-02-14T15:16:03.000','2291','592',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14607','2005-08-21T17:56:50.000','4518','417','2005-08-22T17:44:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14608','2005-08-21T17:57:22.000','3321','90','2005-08-25T13:20:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14609','2005-08-21T17:57:26.000','1206','551','2005-08-25T14:04:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14610','2005-08-21T17:59:09.000','1894','260','2005-08-29T21:36:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14611','2005-08-21T18:01:41.000','4078','443','2005-08-26T12:34:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14612','2005-08-21T18:03:15.000','4105','445','2005-08-27T13:39:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14613','2005-08-21T18:03:20.000','3841','20','2005-08-26T19:46:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14614','2005-08-21T18:03:51.000','3053','468','2005-08-30T13:37:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14615','2005-08-21T18:06:32.000','2332','171','2005-08-30T13:19:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14616','2006-02-14T15:16:03.000','4537','532',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14617','2005-08-21T18:07:40.000','3562','51','2005-08-24T23:48:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14618','2005-08-21T18:09:51.000','4490','270','2005-08-28T22:47:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14619','2005-08-21T18:10:03.000','1589','338','2005-08-23T13:40:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14620','2005-08-21T18:10:43.000','3272','78','2005-08-22T15:19:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14621','2005-08-21T18:17:59.000','3622','344','2005-08-23T14:16:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14622','2005-08-21T18:25:59.000','2702','559','2005-08-31T00:11:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14623','2005-08-21T18:29:13.000','901','33','2005-08-26T20:48:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14624','2005-08-21T18:32:42.000','4','344','2005-08-23T21:09:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14625','2005-08-21T18:34:21.000','2661','507','2005-08-29T21:41:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14626','2005-08-21T18:35:44.000','1038','554','2005-08-25T23:54:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14627','2005-08-21T18:35:54.000','2470','49','2005-08-30T21:17:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14628','2005-08-21T18:37:24.000','3636','331','2005-08-27T20:25:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14629','2005-08-21T18:39:52.000','761','148','2005-08-25T19:14:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14630','2005-08-21T18:43:44.000','4049','294','2005-08-29T17:08:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14631','2005-08-21T18:47:49.000','782','209','2005-08-28T16:54:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14632','2005-08-21T18:48:06.000','2807','38','2005-08-25T00:33:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14633','2005-08-21T18:51:10.000','2137','551','2005-08-25T13:07:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14634','2005-08-21T18:51:28.000','486','494','2005-08-29T19:30:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14635','2005-08-21T18:51:43.000','2171','108','2005-08-27T16:30:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14636','2005-08-21T18:59:17.000','1671','339','2005-08-23T13:19:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14637','2005-08-21T19:01:00.000','1846','76','2005-08-26T23:03:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14638','2005-08-21T19:01:36.000','3583','216','2005-08-22T15:09:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14639','2005-08-21T19:01:39.000','3510','210','2005-08-26T14:08:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14640','2005-08-21T19:03:19.000','1880','253','2005-08-27T00:37:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14641','2005-08-21T19:05:23.000','2205','147','2005-08-22T22:30:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14642','2005-08-21T19:09:40.000','1280','81','2005-08-30T13:25:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14643','2005-08-21T19:11:58.000','798','119','2005-08-29T19:52:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14644','2005-08-21T19:12:12.000','3905','453','2005-08-29T17:08:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14645','2005-08-21T19:12:47.000','2369','334','2005-08-25T21:42:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14646','2005-08-21T19:14:48.000','948','186','2005-08-23T17:15:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14647','2005-08-21T19:15:33.000','3854','36','2005-08-30T18:58:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14648','2005-08-21T19:18:01.000','2250','284','2005-08-25T14:59:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14649','2005-08-21T19:19:21.000','4074','43','2005-08-22T17:23:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14650','2005-08-21T19:24:51.000','1274','190','2005-08-25T13:58:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14651','2005-08-21T19:31:09.000','4037','544','2005-08-28T14:26:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14652','2005-08-21T19:32:05.000','4163','453','2005-08-23T23:33:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14653','2005-08-21T19:35:59.000','491','593','2005-08-24T15:31:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14654','2005-08-21T19:36:59.000','687','173','2005-08-23T22:03:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14655','2005-08-21T19:37:10.000','785','253','2005-08-22T15:43:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14656','2005-08-21T19:39:28.000','4205','201','2005-08-24T01:36:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14657','2005-08-21T19:39:43.000','477','244','2005-08-26T22:39:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14658','2005-08-21T19:41:50.000','1465','473','2005-08-25T16:11:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14659','2005-08-21T19:42:36.000','928','119','2005-08-26T14:06:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14660','2005-08-21T19:43:21.000','3433','452','2005-08-22T20:42:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14661','2005-08-21T19:44:21.000','745','469','2005-08-27T14:35:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14662','2005-08-21T19:45:27.000','2969','403','2005-08-23T14:44:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14663','2005-08-21T19:47:55.000','2351','150','2005-08-27T17:36:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14664','2005-08-21T19:48:47.000','4377','153','2005-08-27T16:47:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14665','2005-08-21T19:49:46.000','2896','58','2005-08-30T18:00:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14666','2005-08-21T19:51:09.000','2560','122','2005-08-30T22:42:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14667','2005-08-21T19:51:11.000','2608','55','2005-08-23T17:37:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14668','2005-08-21T19:51:30.000','1450','152','2005-08-29T19:38:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14669','2005-08-21T19:54:06.000','3154','317','2005-08-25T23:12:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14670','2005-08-21T19:54:11.000','4324','537','2005-08-27T21:42:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14671','2005-08-21T19:59:30.000','2622','53','2005-08-22T19:39:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14672','2005-08-21T19:59:33.000','4144','325','2005-08-30T19:40:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14673','2005-08-21T20:01:18.000','1827','445','2005-08-25T18:55:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14674','2005-08-21T20:01:34.000','572','300','2005-08-27T18:33:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14675','2005-08-21T20:01:51.000','328','170','2005-08-26T14:30:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14676','2005-08-21T20:02:18.000','877','49','2005-08-26T21:55:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14677','2005-08-21T20:12:30.000','4411','26','2005-08-28T15:11:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14678','2005-08-21T20:12:43.000','1911','383','2005-08-31T02:11:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14679','2005-08-21T20:14:58.000','1520','193','2005-08-23T23:39:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14680','2005-08-21T20:19:52.000','4469','524','2005-08-28T17:10:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14681','2005-08-21T20:25:13.000','1083','212','2005-08-30T19:48:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14682','2005-08-21T20:25:57.000','2974','314','2005-08-28T00:42:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14683','2005-08-21T20:27:44.000','3850','342','2005-08-29T16:54:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14684','2005-08-21T20:28:26.000','3593','369','2005-08-28T19:01:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14685','2005-08-21T20:31:25.000','1320','69','2005-08-22T21:02:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14686','2005-08-21T20:32:08.000','814','34','2005-08-26T18:07:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14687','2005-08-21T20:32:16.000','306','550','2005-08-26T16:17:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14688','2005-08-21T20:32:37.000','2573','219','2005-08-27T00:06:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14689','2005-08-21T20:33:00.000','1124','463','2005-08-22T18:10:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14690','2005-08-21T20:42:25.000','3649','456','2005-08-29T18:42:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14691','2005-08-21T20:42:29.000','2131','404','2005-08-24T01:22:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14692','2005-08-21T20:43:21.000','1908','192','2005-08-28T19:02:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14693','2005-08-21T20:44:19.000','3454','269','2005-08-29T00:37:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14694','2005-08-21T20:46:42.000','2767','363','2005-08-23T16:18:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14695','2005-08-21T20:46:47.000','412','206','2005-08-22T22:25:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14696','2005-08-21T20:48:05.000','3776','435','2005-08-25T14:55:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14697','2005-08-21T20:49:21.000','48','409','2005-08-26T01:39:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14698','2005-08-21T20:49:58.000','4255','196','2005-08-29T20:13:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14699','2005-08-21T20:50:48.000','1427','3','2005-08-29T18:08:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14700','2005-08-21T20:53:40.000','3446','360','2005-08-23T22:01:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14701','2005-08-21T20:54:32.000','3034','34','2005-08-30T16:46:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14702','2005-08-21T21:00:03.000','4096','345','2005-08-30T16:59:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14703','2005-08-21T21:01:19.000','4329','29','2005-08-22T15:13:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14704','2005-08-21T21:02:22.000','4062','248','2005-08-27T23:10:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14705','2005-08-21T21:02:55.000','2493','243','2005-08-25T20:20:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14706','2005-08-21T21:04:42.000','4494','589','2005-08-22T19:55:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14707','2005-08-21T21:06:29.000','2916','530','2005-08-30T23:37:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14708','2005-08-21T21:07:23.000','2828','226','2005-08-28T15:47:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14709','2005-08-21T21:07:59.000','1856','300','2005-08-31T02:19:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14710','2005-08-21T21:15:23.000','1922','587','2005-08-30T19:45:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14711','2005-08-21T21:22:07.000','1973','448','2005-08-30T16:24:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14712','2005-08-21T21:22:56.000','1198','226','2005-08-25T01:53:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14713','2005-08-21T21:27:24.000','3350','148','2005-08-23T20:26:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14714','2005-08-21T21:27:43.000','1','279','2005-08-30T22:26:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14715','2005-08-21T21:28:18.000','4453','287','2005-08-26T22:13:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14716','2005-08-21T21:29:55.000','2285','78','2005-08-23T18:34:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14717','2005-08-21T21:30:39.000','3839','366','2005-08-26T16:58:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14718','2005-08-21T21:39:25.000','3618','340','2005-08-26T22:07:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14719','2005-08-21T21:41:57.000','4091','599','2005-08-25T20:37:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14720','2005-08-21T21:43:53.000','3617','395','2005-08-25T18:21:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14721','2005-08-21T21:50:51.000','4257','349','2005-08-30T19:21:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14722','2005-08-21T21:50:53.000','2930','236','2005-08-30T03:13:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14723','2005-08-21T21:52:32.000','2755','548','2005-08-31T00:03:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14724','2005-08-21T21:53:47.000','3559','552','2005-08-23T20:14:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14725','2005-08-21T22:02:08.000','4427','403','2005-08-23T03:59:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14726','2005-08-21T22:08:52.000','4556','216','2005-08-22T18:28:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14727','2005-08-21T22:12:45.000','650','275','2005-08-25T00:46:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14728','2005-08-21T22:15:36.000','2671','474','2005-08-25T17:14:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14729','2005-08-21T22:16:57.000','2483','289','2005-08-27T21:32:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14730','2005-08-21T22:21:11.000','2949','439','2005-08-30T03:02:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14731','2005-08-21T22:21:49.000','1351','154','2005-08-24T16:27:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14732','2005-08-21T22:22:29.000','1915','482','2005-08-23T18:34:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14733','2005-08-21T22:22:33.000','398','408','2005-08-26T21:01:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14734','2006-02-14T15:16:03.000','1369','448',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14735','2005-08-21T22:25:09.000','950','35','2005-08-23T21:16:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14736','2005-08-21T22:25:53.000','207','139','2005-08-25T19:01:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14737','2005-08-21T22:27:11.000','1842','124','2005-08-25T18:51:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14738','2005-08-21T22:29:13.000','3315','521','2005-08-29T21:19:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14739','2005-08-21T22:33:22.000','4026','226','2005-08-22T19:45:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14740','2005-08-21T22:35:33.000','1717','333','2005-08-26T17:49:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14741','2006-02-14T15:16:03.000','612','60',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14742','2005-08-21T22:39:01.000','2988','421','2005-08-26T00:17:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14743','2005-08-21T22:41:56.000','4570','2','2005-08-29T00:18:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14744','2005-08-21T22:45:21.000','800','213','2005-08-29T23:57:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14745','2005-08-21T22:53:01.000','4399','277','2005-08-23T23:22:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14746','2005-08-21T22:54:02.000','3197','284','2005-08-27T17:04:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14747','2005-08-21T23:00:02.000','201','153','2005-08-26T18:58:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14748','2005-08-21T23:02:02.000','1697','81','2005-08-28T05:01:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14749','2005-08-21T23:08:33.000','831','235','2005-08-29T20:46:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14750','2005-08-21T23:09:32.000','918','303','2005-08-30T00:46:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14751','2005-08-21T23:11:23.000','1156','195','2005-08-30T20:01:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14752','2005-08-21T23:11:42.000','1252','362','2005-08-28T22:12:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14753','2005-08-21T23:11:43.000','1803','155','2005-08-22T22:25:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14754','2005-08-21T23:17:26.000','2355','137','2005-08-29T18:55:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14755','2005-08-21T23:18:08.000','862','328','2005-08-27T01:06:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14756','2005-08-21T23:21:23.000','564','288','2005-08-24T01:44:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14757','2005-08-21T23:23:37.000','1154','473','2005-08-26T23:24:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14758','2005-08-21T23:24:52.000','2372','339','2005-08-27T04:25:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14759','2005-08-21T23:28:58.000','3871','362','2005-08-31T00:35:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14760','2006-02-14T15:16:03.000','1367','355',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14761','2005-08-21T23:30:28.000','2657','490','2005-08-26T03:26:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14762','2005-08-21T23:33:57.000','4249','1','2005-08-23T01:30:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14763','2005-08-21T23:34:00.000','1480','116','2005-08-31T03:58:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14764','2005-08-21T23:37:47.000','1270','529','2005-08-24T00:23:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14765','2005-08-21T23:40:28.000','2817','435','2005-08-25T04:55:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14766','2005-08-21T23:42:20.000','768','523','2005-08-26T03:46:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14767','2005-08-21T23:43:00.000','1232','69','2005-08-29T05:26:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14768','2005-08-21T23:44:53.000','3465','570','2005-08-27T20:33:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14769','2006-02-14T15:16:03.000','1800','361',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14770','2005-08-21T23:47:16.000','2977','372','2005-08-25T04:48:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14771','2005-08-21T23:50:15.000','2665','149','2005-08-28T22:55:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14772','2005-08-21T23:50:39.000','4047','411','2005-08-30T20:44:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14773','2005-08-21T23:50:57.000','2541','413','2005-08-26T04:45:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14774','2005-08-21T23:52:32.000','3185','252','2005-08-26T23:42:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14775','2005-08-21T23:53:07.000','4044','400','2005-08-22T18:07:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14776','2005-08-21T23:53:35.000','3488','15','2005-08-24T02:00:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14777','2005-08-21T23:55:50.000','237','389','2005-08-28T04:31:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14778','2005-08-21T23:56:30.000','2152','396','2005-08-26T00:07:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14779','2005-08-22T00:00:56.000','1087','279','2005-08-31T00:01:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14780','2005-08-22T00:06:33.000','3171','491','2005-08-22T22:02:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14781','2005-08-22T00:15:12.000','3458','71','2005-08-29T21:02:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14782','2005-08-22T00:17:20.000','1727','211','2005-08-23T01:24:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14783','2005-08-22T00:21:57.000','3419','332','2005-08-28T01:27:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14784','2005-08-22T00:23:13.000','441','117','2005-08-28T03:42:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14785','2005-08-22T00:24:37.000','1981','560','2005-08-25T04:15:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14786','2005-08-22T00:24:42.000','2959','370','2005-08-25T19:36:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14787','2005-08-22T00:25:59.000','2634','38','2005-08-28T22:30:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14788','2005-08-22T00:27:59.000','1917','139','2005-08-29T23:54:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14789','2005-08-22T00:29:39.000','2344','279','2005-08-25T02:25:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14790','2005-08-22T00:34:17.000','1002','397','2005-08-31T02:27:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14791','2005-08-22T00:35:55.000','1490','317','2005-08-30T20:23:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14792','2005-08-22T00:36:41.000','4436','396','2005-08-30T18:58:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14793','2005-08-22T00:37:57.000','4285','154','2005-08-29T05:44:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14794','2005-08-22T00:39:31.000','413','156','2005-08-28T20:08:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14795','2005-08-22T00:40:22.000','1695','303','2005-08-26T01:37:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14796','2005-08-22T00:40:49.000','941','441','2005-08-30T03:59:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14797','2005-08-22T00:41:24.000','1131','546','2005-08-23T18:51:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14798','2005-08-22T00:44:08.000','7','92','2005-08-27T02:18:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14799','2005-08-22T00:44:57.000','1276','454','2005-08-24T20:08:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14800','2005-08-22T00:46:18.000','3554','533','2005-08-26T01:44:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14801','2005-08-22T00:46:54.000','1677','184','2005-08-30T19:03:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14802','2005-08-22T00:48:23.000','707','505','2005-08-28T01:02:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14803','2005-08-22T00:49:10.000','2525','278','2005-08-22T23:44:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14804','2005-08-22T00:51:25.000','372','94','2005-08-26T21:15:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14805','2005-08-22T00:52:01.000','783','169','2005-08-23T03:28:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14806','2005-08-22T00:53:08.000','2049','231','2005-08-23T06:26:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14807','2005-08-22T00:57:43.000','335','90','2005-08-26T23:40:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14808','2005-08-22T00:58:35.000','1657','362','2005-08-29T20:16:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14809','2005-08-22T01:00:42.000','1077','188','2005-08-29T19:55:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14810','2005-08-22T01:08:34.000','1982','78','2005-08-25T07:00:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14811','2005-08-22T01:09:04.000','1613','53','2005-08-26T19:30:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14812','2005-08-22T01:10:32.000','4282','211','2005-08-26T05:21:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14813','2005-08-22T01:11:37.000','3364','142','2005-08-24T05:57:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14814','2005-08-22T01:12:14.000','3109','250','2005-08-27T23:24:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14815','2005-08-22T01:12:44.000','1183','314','2005-08-24T01:42:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14816','2005-08-22T01:15:51.000','4086','534','2005-08-28T04:11:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14817','2005-08-22T01:17:16.000','910','215','2005-08-27T02:43:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14818','2005-08-22T01:17:18.000','1619','580','2005-08-26T05:40:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14819','2005-08-22T01:17:19.000','2890','410','2005-08-30T05:54:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14820','2005-08-22T01:18:37.000','1409','52','2005-08-23T19:44:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14821','2005-08-22T01:20:19.000','3155','62','2005-08-29T03:06:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14822','2005-08-22T01:21:14.000','2835','52','2005-08-30T03:59:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14823','2005-08-22T01:24:42.000','680','503','2005-08-22T19:45:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14824','2005-08-22T01:27:51.000','4162','594','2005-08-23T03:24:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14825','2005-08-22T01:27:57.000','1449','1','2005-08-27T07:01:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14826','2005-08-22T01:32:14.000','4023','426','2005-08-23T03:52:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14827','2005-08-22T01:32:32.000','2267','88','2005-08-31T06:21:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14828','2005-08-22T01:34:05.000','4114','319','2005-08-27T06:27:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14829','2005-08-22T01:35:37.000','3606','546','2005-08-23T19:55:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14830','2005-08-22T01:37:19.000','637','590','2005-08-27T20:10:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14831','2005-08-22T01:40:49.000','3370','156','2005-08-23T02:47:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14832','2005-08-22T01:43:29.000','1828','494','2005-08-29T07:19:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14833','2005-08-22T01:45:18.000','1960','551','2005-08-28T21:24:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14834','2005-08-22T01:45:58.000','3105','262','2005-08-28T20:52:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14835','2005-08-22T01:49:07.000','755','404','2005-08-30T04:28:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14836','2005-08-22T01:52:26.000','4287','418','2005-08-22T23:39:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14837','2005-08-22T01:54:52.000','2251','43','2005-08-29T02:24:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14838','2005-08-22T01:57:34.000','506','404','2005-08-25T06:34:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14839','2005-08-22T01:58:15.000','3440','567','2005-08-24T05:24:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14840','2005-08-22T01:58:42.000','1240','354','2005-08-29T22:32:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14841','2005-08-22T02:03:30.000','4017','384','2005-08-28T02:08:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14842','2005-08-22T02:04:38.000','2511','467','2005-08-30T06:46:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14843','2005-08-22T02:05:25.000','3000','454','2005-08-28T22:11:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14844','2005-08-22T02:09:12.000','145','513','2005-08-31T05:43:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14845','2005-08-22T02:12:44.000','69','292','2005-08-24T02:36:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14846','2005-08-22T02:13:48.000','3840','309','2005-08-30T05:39:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14847','2005-08-22T02:13:51.000','2995','327','2005-08-29T03:42:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14848','2005-08-22T02:14:19.000','395','218','2005-08-26T02:54:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14849','2005-08-22T02:15:26.000','3354','177','2005-08-28T00:56:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14850','2005-08-22T02:16:55.000','2405','435','2005-08-26T21:08:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14851','2005-08-22T02:20:44.000','1139','180','2005-08-26T08:02:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14852','2005-08-22T02:25:53.000','2262','352','2005-08-25T04:27:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14853','2005-08-22T02:26:33.000','3575','388','2005-08-31T02:49:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14854','2005-08-22T02:26:47.000','1989','117','2005-08-23T05:53:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14855','2005-08-22T02:27:32.000','1668','187','2005-08-31T03:35:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14856','2005-08-22T02:31:51.000','3292','151','2005-08-26T23:41:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14857','2005-08-22T02:42:39.000','4150','232','2005-08-24T21:26:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14858','2005-08-22T02:46:18.000','366','499','2005-08-30T08:22:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14859','2005-08-22T02:46:35.000','2150','463','2005-08-24T22:37:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14860','2005-08-22T02:47:07.000','1368','418','2005-08-28T00:00:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14861','2005-08-22T02:48:05.000','1806','422','2005-08-27T00:50:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14862','2005-08-22T02:51:41.000','3479','78','2005-08-28T06:30:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14863','2005-08-22T02:57:04.000','779','440','2005-08-30T03:24:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14864','2005-08-22T02:57:06.000','2872','460','2005-08-22T22:19:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14865','2005-08-22T03:06:38.000','3775','94','2005-08-23T04:26:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14866','2005-08-22T03:11:35.000','2607','445','2005-08-30T00:10:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14867','2005-08-22T03:14:46.000','271','114','2005-08-25T03:53:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14868','2005-08-22T03:15:01.000','4383','160','2005-08-25T01:24:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14869','2005-08-22T03:20:26.000','455','21','2005-08-23T05:25:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14870','2005-08-22T03:23:20.000','2170','512','2005-08-23T06:50:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14871','2005-08-22T03:23:24.000','3411','204','2005-08-23T22:23:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14872','2005-08-22T03:23:41.000','962','15','2005-08-29T23:25:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14873','2005-08-22T03:31:06.000','3533','314','2005-08-31T05:34:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14874','2005-08-22T03:32:05.000','1782','268','2005-08-24T07:02:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14875','2005-08-22T03:34:39.000','3912','513','2005-08-26T03:40:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14876','2005-08-22T03:39:29.000','3669','210','2005-08-23T06:53:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14877','2005-08-22T03:39:56.000','974','266','2005-08-24T03:41:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14878','2006-02-14T15:16:03.000','1202','441',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14879','2005-08-22T03:42:12.000','2154','148','2005-08-27T06:14:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14880','2005-08-22T03:44:36.000','3615','224','2005-08-24T05:45:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14881','2005-08-22T03:47:39.000','210','425','2005-08-26T05:58:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14882','2005-08-22T03:52:21.000','12','417','2005-08-25T04:50:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14883','2005-08-22T03:55:02.000','1946','177','2005-08-28T02:51:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14884','2005-08-22T03:57:08.000','2957','547','2005-08-23T07:11:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14885','2005-08-22T03:58:29.000','2097','248','2005-08-30T05:26:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14886','2005-08-22T03:59:01.000','4330','379','2005-08-23T01:22:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14887','2005-08-22T04:04:31.000','56','421','2005-08-31T02:30:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14888','2005-08-22T04:09:18.000','3345','91','2005-08-23T07:34:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14889','2005-08-22T04:10:10.000','1579','299','2005-08-24T06:23:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14890','2005-08-22T04:10:49.000','517','346','2005-08-30T23:23:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14891','2005-08-22T04:11:02.000','288','482','2005-08-27T03:22:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14892','2005-08-22T04:15:05.000','3061','82','2005-08-31T06:07:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14893','2005-08-22T04:15:48.000','2336','461','2005-08-30T08:05:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14894','2005-08-22T04:16:56.000','3494','347','2005-08-24T00:30:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14895','2005-08-22T04:19:23.000','4462','340','2005-08-27T04:02:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14896','2005-08-22T04:20:55.000','2508','569','2005-08-29T05:11:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14897','2005-08-22T04:22:31.000','1607','175','2005-08-26T00:09:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14898','2005-08-22T04:26:34.000','1736','299','2005-08-31T10:04:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14899','2005-08-22T04:26:38.000','3700','304','2005-08-31T08:36:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14900','2005-08-22T04:27:48.000','3420','329','2005-08-25T03:50:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14901','2005-08-22T04:31:37.000','4297','258','2005-08-29T08:24:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14902','2005-08-22T04:31:50.000','866','423','2005-08-23T23:47:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14903','2005-08-22T04:31:50.000','1795','51','2005-08-25T22:53:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14904','2005-08-22T04:32:01.000','722','71','2005-08-29T05:21:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14905','2005-08-22T04:34:22.000','4166','286','2005-08-26T04:00:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14906','2005-08-22T04:38:18.000','153','366','2005-08-29T23:03:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14907','2005-08-22T04:44:09.000','2469','116','2005-08-25T09:53:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14908','2005-08-22T04:44:10.000','102','349','2005-08-25T05:09:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14909','2005-08-22T04:48:44.000','1997','155','2005-08-25T04:59:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14910','2005-08-22T04:50:52.000','1266','540','2005-08-25T04:14:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14911','2005-08-22T04:51:42.000','353','273','2005-08-28T05:37:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14912','2005-08-22T04:51:42.000','2658','404','2005-08-23T23:50:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14913','2005-08-22T04:52:13.000','3609','503','2005-08-23T06:49:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14914','2005-08-22T04:53:35.000','4348','156','2005-08-26T10:35:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14915','2006-02-14T15:16:03.000','112','349',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14916','2005-08-22T04:56:57.000','2110','80','2005-08-24T06:36:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14917','2005-08-22T05:03:59.000','377','289','2005-08-29T04:00:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14918','2005-08-22T05:06:38.000','4056','154','2005-08-30T01:44:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14919','2005-08-22T05:07:17.000','1587','244','2005-08-30T06:41:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14920','2005-08-22T05:08:58.000','3357','106','2005-08-23T02:51:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14921','2005-08-22T05:12:24.000','3724','284','2005-08-26T08:20:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14922','2005-08-22T05:13:05.000','2322','151','2005-08-30T04:59:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14923','2005-08-22T05:13:33.000','3434','460','2005-08-28T01:39:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14924','2005-08-22T05:15:17.000','4189','118','2005-08-23T10:11:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14925','2005-08-22T05:16:16.000','442','128','2005-08-30T02:47:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14926','2005-08-22T05:18:44.000','2448','357','2005-08-26T02:18:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14927','2005-08-22T05:31:53.000','952','193','2005-08-27T07:04:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14928','2006-02-14T15:16:03.000','4375','472',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14929','2005-08-22T05:32:38.000','4195','546','2005-08-28T00:02:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14930','2005-08-22T05:38:32.000','2875','584','2005-08-30T07:21:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14931','2005-08-22T05:38:55.000','657','63','2005-08-28T04:15:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14932','2005-08-22T05:40:39.000','2259','516','2005-08-23T11:02:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14933','2006-02-14T15:16:03.000','1186','21',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14934','2005-08-22T05:47:15.000','815','226','2005-08-26T11:32:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14935','2005-08-22T05:47:31.000','2025','380','2005-08-29T00:33:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14936','2005-08-22T05:51:26.000','3710','241','2005-08-29T10:21:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14937','2005-08-22T05:51:59.000','1241','348','2005-08-31T01:45:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14938','2005-08-22T05:52:39.000','408','541','2005-08-31T11:43:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14939','2005-08-22T05:53:52.000','719','328','2005-08-27T06:20:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14940','2005-08-22T05:54:03.000','2635','46','2005-08-24T05:52:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14941','2005-08-22T05:58:23.000','2328','574','2005-08-28T10:58:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14942','2005-08-22T05:58:27.000','32','471','2005-08-31T10:08:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14943','2005-08-22T05:59:59.000','3515','265','2005-08-26T10:31:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14944','2005-08-22T06:01:26.000','535','153','2005-08-24T10:33:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14945','2005-08-22T06:05:38.000','1567','304','2005-08-29T12:01:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14946','2005-08-22T06:07:10.000','1395','308','2005-08-28T05:25:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14947','2005-08-22T06:07:52.000','3497','68','2005-08-28T01:12:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14948','2005-08-22T06:10:53.000','2914','488','2005-08-28T11:24:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14949','2005-08-22T06:12:16.000','2434','111','2005-08-25T08:25:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14950','2005-08-22T06:17:12.000','635','362','2005-08-27T08:48:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14951','2005-08-22T06:19:37.000','2800','197','2005-08-30T05:51:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14952','2005-08-22T06:20:07.000','2950','575','2005-08-28T01:18:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14953','2005-08-22T06:23:54.000','816','182','2005-08-28T03:19:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14954','2006-02-14T15:16:03.000','3608','525',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14955','2005-08-22T06:25:52.000','1534','445','2005-08-25T12:13:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14956','2005-08-22T06:26:16.000','3650','571','2005-08-25T11:06:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14957','2005-08-22T06:29:34.000','1384','323','2005-08-26T04:52:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14958','2005-08-22T06:30:10.000','1710','347','2005-08-28T09:43:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14959','2005-08-22T06:30:28.000','2009','569','2005-08-25T09:48:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14960','2005-08-22T06:31:36.000','3316','147','2005-08-29T07:10:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14961','2005-08-22T06:35:50.000','3274','52','2005-08-31T04:07:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14962','2005-08-22T06:37:43.000','3104','449','2005-08-29T03:44:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14963','2005-08-22T06:38:10.000','2672','384','2005-08-31T05:35:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14964','2005-08-22T06:39:24.000','2302','500','2005-08-26T06:05:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14965','2005-08-22T06:45:53.000','1036','148','2005-08-27T10:05:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14966','2005-08-22T06:45:57.000','679','259','2005-08-31T10:02:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14967','2005-08-22T06:46:03.000','289','67','2005-08-23T01:02:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14968','2005-08-22T06:46:59.000','3302','129','2005-08-29T07:36:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14969','2005-08-22T06:49:15.000','4060','120','2005-08-29T05:52:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14970','2005-08-22T06:49:29.000','536','529','2005-08-29T08:47:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14971','2005-08-22T06:52:49.000','1883','378','2005-08-28T06:27:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14972','2005-08-22T06:53:21.000','3422','310','2005-08-29T02:25:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14973','2005-08-22T06:59:28.000','2888','201','2005-08-30T02:28:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14974','2005-08-22T07:04:25.000','2596','157','2005-08-27T12:39:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14975','2005-08-22T07:07:50.000','924','244','2005-08-28T07:23:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14976','2005-08-22T07:10:26.000','77','581','2005-08-28T07:22:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14977','2005-08-22T07:12:53.000','4093','59','2005-08-30T08:11:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14978','2005-08-22T07:13:15.000','699','94','2005-08-25T12:26:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14979','2005-08-22T07:16:36.000','2320','387','2005-08-24T02:29:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14980','2005-08-22T07:16:45.000','2701','518','2005-08-26T06:04:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14981','2005-08-22T07:19:05.000','1239','544','2005-08-26T03:08:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14982','2005-08-22T07:20:55.000','2333','542','2005-08-31T04:35:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14983','2005-08-22T07:32:23.000','3579','363','2005-08-30T11:39:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14984','2005-08-22T07:35:31.000','1704','334','2005-08-30T02:32:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14985','2005-08-22T07:35:56.000','2017','29','2005-08-29T13:17:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14986','2005-08-22T07:37:24.000','1493','278','2005-08-23T04:22:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14987','2005-08-22T07:41:08.000','1513','138','2005-08-24T03:15:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14988','2005-08-22T07:46:05.000','2114','186','2005-08-29T06:43:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14989','2005-08-22T07:47:07.000','1431','58','2005-08-26T04:42:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14990','2005-08-22T07:48:01.000','4057','198','2005-08-24T06:41:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14991','2005-08-22T07:50:44.000','708','172','2005-08-30T06:32:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14992','2005-08-22T07:51:47.000','4430','415','2005-08-25T08:17:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14993','2005-08-22T07:52:18.000','3416','437','2005-08-27T02:13:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14994','2005-08-22T07:52:24.000','1601','509','2005-08-26T09:57:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14995','2005-08-22T07:52:31.000','4178','482','2005-08-24T05:16:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14996','2005-08-22T07:52:41.000','1178','411','2005-08-29T02:35:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14997','2005-08-22T07:53:00.000','2724','29','2005-08-28T03:47:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14998','2005-08-22T07:53:14.000','3852','92','2005-08-24T03:46:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('14999','2005-08-22T07:54:47.000','3399','594','2005-08-23T08:39:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15000','2005-08-22T07:54:58.000','3080','161','2005-08-24T12:46:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15001','2005-08-22T08:00:49.000','2869','186','2005-08-27T05:53:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15002','2005-08-22T08:06:00.000','4198','242','2005-08-24T10:48:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15003','2005-08-22T08:11:24.000','4009','167','2005-08-28T08:49:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15004','2005-08-22T08:15:21.000','4464','375','2005-08-28T10:35:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15005','2005-08-22T08:15:44.000','2897','335','2005-08-24T09:52:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15006','2005-08-22T08:20:15.000','2967','97','2005-08-23T11:57:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15007','2005-08-22T08:21:21.000','3692','165','2005-08-27T04:44:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15008','2005-08-22T08:24:32.000','961','277','2005-08-31T13:48:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15009','2005-08-22T08:27:27.000','4025','325','2005-08-26T05:57:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15010','2005-08-22T08:30:17.000','171','508','2005-08-29T13:24:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15011','2005-08-22T08:31:07.000','2722','329','2005-08-24T04:47:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15012','2005-08-22T08:42:32.000','1584','454','2005-08-28T05:04:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15013','2005-08-22T08:42:45.000','141','141','2005-08-24T05:20:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15014','2005-08-22T08:43:11.000','3678','373','2005-08-31T02:55:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15015','2005-08-22T08:43:50.000','3067','14','2005-08-31T06:53:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15016','2005-08-22T08:47:35.000','879','434','2005-08-28T14:23:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15017','2005-08-22T08:47:44.000','3975','144','2005-08-29T08:16:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15018','2005-08-22T08:52:38.000','394','504','2005-08-25T08:08:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15019','2005-08-22T08:52:53.000','3425','450','2005-08-25T13:07:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15020','2005-08-22T08:54:12.000','3460','267','2005-08-27T04:54:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15021','2006-02-14T15:16:03.000','418','100',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15022','2005-08-22T08:55:43.000','249','506','2005-08-31T05:35:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15023','2005-08-22T08:56:48.000','358','296','2005-08-29T08:13:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15024','2005-08-22T08:57:10.000','1831','139','2005-08-24T10:39:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15025','2005-08-22T08:57:24.000','2107','257','2005-08-24T06:09:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15026','2005-08-22T09:01:52.000','4328','66','2005-08-28T09:21:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15027','2005-08-22T09:03:04.000','326','478','2005-08-29T04:03:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15028','2005-08-22T09:03:44.000','4248','37','2005-08-30T11:28:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15029','2005-08-22T09:04:53.000','2234','139','2005-08-25T09:03:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15030','2005-08-22T09:10:21.000','3168','341','2005-08-24T06:00:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15031','2005-08-22T09:11:48.000','3926','430','2005-08-27T06:11:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15032','2005-08-22T09:14:09.000','3414','467','2005-08-25T09:50:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15033','2005-08-22T09:25:24.000','2431','168','2005-08-28T09:56:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15034','2005-08-22T09:33:08.000','1331','235','2005-08-29T13:04:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15035','2005-08-22T09:34:32.000','339','513','2005-08-28T10:23:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15036','2005-08-22T09:36:00.000','874','280','2005-08-23T08:12:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15037','2005-08-22T09:36:33.000','4517','234','2005-08-31T11:20:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15038','2005-08-22T09:37:27.000','1685','3','2005-08-23T14:39:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15039','2005-08-22T09:37:54.000','895','180','2005-08-28T12:23:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15040','2005-08-22T09:41:09.000','3207','523','2005-08-23T12:49:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15041','2005-08-22T09:43:18.000','1913','372','2005-08-23T11:04:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15042','2005-08-22T09:47:37.000','3796','553','2005-08-31T04:42:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15043','2005-08-22T09:49:32.000','3797','182','2005-08-28T13:50:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15044','2005-08-22T09:51:54.000','4513','439','2005-08-31T12:45:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15045','2005-08-22T09:53:23.000','3485','161','2005-08-26T10:09:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15046','2005-08-22T09:54:54.000','1536','474','2005-08-26T07:34:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15047','2005-08-22T09:57:16.000','1309','19','2005-08-23T11:39:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15048','2005-08-22T10:00:04.000','2895','27','2005-08-26T08:26:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15049','2005-08-22T10:06:28.000','1573','102','2005-08-26T15:12:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15050','2005-08-22T10:07:52.000','3961','167','2005-08-23T04:45:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15051','2005-08-22T10:08:50.000','1419','300','2005-08-28T10:23:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15052','2005-08-22T10:09:19.000','2349','147','2005-08-31T09:27:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15053','2005-08-22T10:13:09.000','1065','374','2005-08-28T12:42:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15054','2005-08-22T10:14:33.000','2314','44','2005-08-25T15:07:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15055','2005-08-22T10:14:39.000','623','125','2005-08-25T07:25:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15056','2005-08-22T10:15:54.000','1871','503','2005-08-25T07:21:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15057','2005-08-22T10:19:58.000','4534','20','2005-08-28T05:12:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15058','2005-08-22T10:20:55.000','3537','288','2005-08-26T12:37:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15059','2005-08-22T10:22:00.000','4079','564','2005-08-29T07:01:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15060','2005-08-22T10:24:32.000','2740','63','2005-08-31T11:17:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15061','2005-08-22T10:29:44.000','3436','90','2005-08-24T14:40:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15062','2005-08-22T10:34:39.000','4393','139','2005-08-26T13:09:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15063','2005-08-22T10:39:51.000','1159','30','2005-08-25T16:03:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15064','2005-08-22T10:41:58.000','1233','425','2005-08-28T13:34:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15065','2005-08-22T10:46:44.000','468','510','2005-08-27T09:40:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15066','2005-08-22T10:49:06.000','2712','530','2005-08-23T10:25:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15067','2005-08-22T10:49:21.000','3684','461','2005-08-24T09:01:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15068','2005-08-22T10:50:13.000','3268','373','2005-08-26T05:04:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15069','2005-08-22T10:55:42.000','592','568','2005-08-28T06:59:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15070','2005-08-22T10:55:45.000','2687','441','2005-08-26T09:23:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15071','2005-08-22T10:58:43.000','417','541','2005-08-31T14:53:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15072','2005-08-22T10:58:45.000','2871','405','2005-08-30T16:18:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15073','2005-08-22T11:01:15.000','3970','336','2005-08-31T09:23:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15074','2005-08-22T11:02:52.000','3112','567','2005-08-28T07:59:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15075','2005-08-22T11:04:52.000','1938','535','2005-08-30T05:06:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15076','2005-08-22T11:05:34.000','4170','287','2005-08-27T14:40:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15077','2005-08-22T11:09:18.000','3142','503','2005-08-29T08:41:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15078','2005-08-22T11:09:31.000','3001','197','2005-08-25T12:16:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15079','2005-08-22T11:09:56.000','4552','540','2005-08-24T15:40:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15080','2005-08-22T11:11:51.000','927','133','2005-08-23T13:09:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15081','2005-08-22T11:14:31.000','2501','313','2005-08-28T14:23:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15082','2005-08-22T11:17:06.000','2046','137','2005-08-28T06:40:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15083','2005-08-22T11:17:37.000','1691','397','2005-08-28T06:27:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15084','2005-08-22T11:17:59.000','821','287','2005-08-23T09:23:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15085','2005-08-22T11:19:22.000','1669','67','2005-08-25T09:04:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15086','2005-08-22T11:21:08.000','264','494','2005-08-30T08:18:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15087','2005-08-22T11:24:09.000','233','404','2005-08-27T16:42:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15088','2005-08-22T11:28:26.000','4199','377','2005-08-24T15:46:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15089','2005-08-22T11:34:06.000','3288','61','2005-08-31T12:45:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15090','2005-08-22T11:34:33.000','2918','582','2005-08-31T06:09:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15091','2005-08-22T11:34:43.000','2092','477','2005-08-23T16:52:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15092','2005-08-22T11:36:16.000','2418','464','2005-08-28T09:49:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15093','2005-08-22T11:39:03.000','3534','60','2005-08-23T06:16:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15094','2006-02-14T15:16:03.000','922','424',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15095','2005-08-22T11:41:35.000','489','202','2005-08-25T16:44:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15096','2005-08-22T11:43:04.000','1983','33','2005-08-29T12:16:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15097','2005-08-22T11:43:42.000','2838','475','2005-08-27T10:25:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15098','2005-08-22T11:48:19.000','4414','88','2005-08-31T11:07:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15099','2005-08-22T11:49:16.000','1940','86','2005-08-26T06:38:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15100','2005-08-22T11:55:03.000','4489','312','2005-08-25T14:55:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15101','2005-08-22T11:56:02.000','683','335','2005-08-28T13:08:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15102','2005-08-22T11:58:58.000','2317','555','2005-08-29T08:37:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15103','2005-08-22T12:01:06.000','853','101','2005-08-25T14:40:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15104','2005-08-22T12:01:16.000','4550','359','2005-08-27T17:48:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15105','2005-08-22T12:01:33.000','3965','338','2005-08-26T14:29:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15106','2005-08-22T12:01:48.000','399','155','2005-08-27T16:12:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15107','2005-08-22T12:05:02.000','2378','376','2005-08-23T11:09:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15108','2005-08-22T12:10:07.000','3463','447','2005-08-26T14:46:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15109','2005-08-22T12:12:58.000','565','588','2005-08-30T07:20:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15110','2005-08-22T12:16:46.000','1379','72','2005-08-26T13:36:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15111','2005-08-22T12:21:43.000','4101','119','2005-08-24T09:31:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15112','2005-08-22T12:21:49.000','2832','160','2005-08-27T11:03:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15113','2005-08-22T12:23:59.000','4338','424','2005-08-27T09:59:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15114','2005-08-22T12:24:55.000','2481','121','2005-08-31T17:06:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15115','2005-08-22T12:28:01.000','1739','33','2005-08-26T16:12:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15116','2005-08-22T12:35:40.000','518','217','2005-08-23T17:58:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15117','2005-08-22T12:38:20.000','2502','292','2005-08-27T07:36:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15118','2005-08-22T12:38:37.000','2081','473','2005-08-29T14:01:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15119','2005-08-22T12:41:33.000','4526','288','2005-08-23T14:44:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15120','2005-08-22T12:42:47.000','3083','11','2005-08-23T14:21:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15121','2005-08-22T12:46:37.000','2981','415','2005-08-25T17:42:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15122','2005-08-22T12:47:45.000','1686','91','2005-08-29T13:18:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15123','2005-08-22T12:48:44.000','1455','445','2005-08-27T11:07:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15124','2005-08-22T12:51:38.000','1598','39','2005-08-26T09:05:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15125','2005-08-22T12:53:22.000','3942','221','2005-08-29T18:44:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15126','2005-08-22T12:53:58.000','1902','459','2005-08-28T07:39:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15127','2005-08-22T12:56:29.000','2397','287','2005-08-26T10:58:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15128','2005-08-22T12:57:26.000','3229','457','2005-08-30T11:35:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15129','2005-08-22T13:03:52.000','3782','234','2005-08-29T10:56:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15130','2005-08-22T13:04:32.000','2375','536','2005-08-30T17:24:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15131','2005-08-22T13:06:26.000','1930','119','2005-08-30T16:43:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15132','2005-08-22T13:11:25.000','3474','393','2005-08-27T17:04:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15133','2005-08-22T13:17:43.000','3408','137','2005-08-26T08:40:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15134','2005-08-22T13:18:25.000','4442','22','2005-08-29T18:03:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15135','2005-08-22T13:19:19.000','555','284','2005-08-27T17:09:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15136','2005-08-22T13:19:25.000','2606','435','2005-08-24T07:28:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15137','2005-08-22T13:20:28.000','856','241','2005-08-26T09:35:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15138','2005-08-22T13:36:30.000','2467','50','2005-08-27T15:35:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15139','2005-08-22T13:38:11.000','2018','237','2005-08-30T09:00:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15140','2005-08-22T13:39:20.000','1402','414','2005-08-30T18:19:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15141','2005-08-22T13:41:49.000','227','541','2005-08-28T15:25:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15142','2005-08-22T13:44:32.000','1337','351','2005-08-29T14:19:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15143','2005-08-22T13:46:24.000','1519','274','2005-08-25T09:47:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15144','2005-08-22T13:49:18.000','559','527','2005-08-26T11:11:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15145','2005-08-22T13:53:04.000','2179','2','2005-08-31T15:51:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15146','2005-08-22T13:57:55.000','3102','72','2005-08-28T12:57:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15147','2005-08-22T13:58:23.000','2553','4','2005-08-28T14:33:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15148','2005-08-22T13:59:19.000','3704','359','2005-08-31T13:59:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15149','2005-08-22T14:08:06.000','3059','537','2005-08-25T08:25:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15150','2005-08-22T14:12:05.000','1797','161','2005-08-27T12:47:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15151','2005-08-22T14:23:11.000','4070','463','2005-08-30T14:01:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15152','2005-08-22T14:25:21.000','739','123','2005-08-31T14:28:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15153','2005-08-22T14:26:01.000','1051','512','2005-08-27T14:17:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15154','2005-08-22T14:27:37.000','3395','106','2005-08-29T20:04:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15155','2005-08-22T14:27:46.000','2641','43','2005-08-23T17:46:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15156','2005-08-22T14:29:11.000','1174','494','2005-08-30T17:48:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15157','2005-08-22T14:30:09.000','1909','580','2005-08-29T18:28:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15158','2005-08-22T14:30:39.000','3614','588','2005-08-27T15:55:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15159','2005-08-22T14:32:25.000','4355','525','2005-08-24T11:19:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15160','2005-08-22T14:33:50.000','4321','249','2005-08-28T11:26:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15161','2005-08-22T14:37:22.000','1445','20','2005-08-27T17:40:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15162','2005-08-22T14:41:05.000','1756','439','2005-08-27T20:23:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15163','2005-08-22T14:43:13.000','3597','100','2005-08-26T14:26:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15164','2005-08-22T14:47:53.000','997','193','2005-08-25T16:05:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15165','2005-08-22T14:59:30.000','3664','168','2005-08-29T15:46:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15166','2005-08-22T15:05:37.000','1530','504','2005-08-30T12:22:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15167','2006-02-14T15:16:03.000','973','190',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15168','2005-08-22T15:14:20.000','3218','526','2005-08-25T20:12:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15169','2005-08-22T15:21:56.000','794','76','2005-08-28T09:40:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15170','2005-08-22T15:22:15.000','2123','521','2005-08-23T20:32:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15171','2005-08-22T15:23:59.000','1201','119','2005-08-28T12:05:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15172','2005-08-22T15:25:33.000','2367','511','2005-08-23T17:29:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15173','2005-08-22T15:26:29.000','2585','338','2005-08-29T14:03:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15174','2005-08-22T15:26:36.000','19','111','2005-08-31T10:47:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15175','2005-08-22T15:29:15.000','4318','380','2005-08-27T15:11:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15176','2005-08-22T15:30:25.000','3063','115','2005-08-31T20:00:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15177','2005-08-22T15:34:49.000','838','493','2005-08-26T12:54:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15178','2005-08-22T15:36:04.000','1745','15','2005-08-26T21:00:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15179','2005-08-22T15:36:22.000','450','328','2005-08-31T19:57:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15180','2005-08-22T15:42:57.000','234','532','2005-08-24T12:49:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15181','2005-08-22T15:46:20.000','3900','266','2005-08-27T09:56:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15182','2005-08-22T15:47:05.000','645','443','2005-08-25T11:55:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15183','2005-08-22T15:49:54.000','2696','268','2005-08-25T12:29:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15184','2005-08-22T15:51:12.000','1193','471','2005-08-24T19:23:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15185','2005-08-22T15:52:50.000','2948','472','2005-08-31T20:38:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15186','2005-08-22T15:52:57.000','1323','104','2005-08-24T21:12:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15187','2005-08-22T15:53:32.000','2338','461','2005-08-27T14:21:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15188','2005-08-22T15:55:48.000','131','478','2005-08-29T19:10:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15189','2005-08-22T15:56:42.000','2559','398','2005-08-29T12:20:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15190','2005-08-22T15:57:38.000','2096','84','2005-08-24T13:46:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15191','2006-02-14T15:16:03.000','3688','75',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15192','2005-08-22T16:06:23.000','4213','216','2005-08-27T13:12:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15193','2005-08-22T16:06:49.000','1033','40','2005-08-25T17:23:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15194','2005-08-22T16:07:34.000','1217','332','2005-08-26T19:16:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15195','2005-08-22T16:08:23.000','1080','508','2005-08-30T17:56:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15196','2005-08-22T16:11:32.000','1413','181','2005-08-30T22:06:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15197','2005-08-22T16:14:25.000','2915','159','2005-08-26T16:22:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15198','2005-08-22T16:15:33.000','1253','396','2005-08-29T20:49:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15199','2005-08-22T16:17:49.000','18','216','2005-08-25T20:12:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15200','2005-08-22T16:22:53.000','1000','374','2005-08-24T10:25:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15201','2005-08-22T16:24:42.000','4456','301','2005-08-31T17:54:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15202','2005-08-22T16:26:53.000','2119','374','2005-08-23T13:49:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15203','2005-08-22T16:28:00.000','743','568','2005-08-26T16:55:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15204','2005-08-22T16:30:43.000','1471','317','2005-08-26T20:37:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15205','2005-08-22T16:32:23.000','3276','489','2005-08-27T16:08:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15206','2005-08-22T16:33:39.000','3901','524','2005-08-31T11:41:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15207','2005-08-22T16:35:25.000','1149','442','2005-08-23T14:06:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15208','2005-08-22T16:35:47.000','4346','267','2005-08-30T15:16:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15209','2005-08-22T16:37:32.000','1620','588','2005-08-25T19:04:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15210','2005-08-22T16:37:36.000','3811','332','2005-08-29T11:54:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15211','2005-08-22T16:40:21.000','3025','410','2005-08-28T13:33:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15212','2005-08-22T16:44:26.000','2182','562','2005-08-27T20:26:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15213','2005-08-22T16:49:02.000','2002','166','2005-08-31T20:22:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15214','2005-08-22T16:53:29.000','1500','574','2005-08-24T14:17:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15215','2005-08-22T16:55:26.000','1906','344','2005-08-25T20:19:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15216','2005-08-22T16:57:02.000','1633','166','2005-08-24T16:11:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15217','2005-08-22T16:58:31.000','91','90','2005-08-23T22:33:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15218','2005-08-22T16:59:05.000','10','139','2005-08-30T17:01:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15219','2005-08-22T17:00:31.000','3313','544','2005-08-31T20:16:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15220','2005-08-22T17:02:23.000','187','128','2005-08-28T21:02:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15221','2005-08-22T17:12:29.000','110','253','2005-08-24T20:46:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15222','2005-08-22T17:12:30.000','1360','390','2005-08-27T15:10:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15223','2005-08-22T17:13:39.000','2263','541','2005-08-27T11:17:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15224','2005-08-22T17:18:05.000','33','81','2005-08-29T14:35:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15225','2005-08-22T17:18:32.000','1646','224','2005-08-24T17:25:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15226','2005-08-22T17:20:17.000','318','54','2005-08-31T15:36:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15227','2005-08-22T17:22:41.000','2987','151','2005-08-23T20:59:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15228','2005-08-22T17:27:23.000','2485','48','2005-08-29T11:38:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15229','2005-08-22T17:30:25.000','320','63','2005-08-23T14:13:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15230','2005-08-22T17:31:41.000','2572','466','2005-08-25T21:57:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15231','2005-08-22T17:32:57.000','2980','187','2005-08-25T13:06:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15232','2005-08-22T17:37:02.000','61','5','2005-08-25T18:45:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15233','2005-08-22T17:41:53.000','4405','197','2005-08-24T12:59:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15234','2006-02-14T15:16:03.000','908','228',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15235','2005-08-22T17:43:12.000','2726','416','2005-08-29T23:03:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15236','2005-08-22T17:44:27.000','4124','557','2005-08-24T23:25:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15237','2005-08-22T17:44:30.000','4485','148','2005-08-24T12:51:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15238','2005-08-22T17:46:12.000','403','70','2005-08-29T16:41:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15239','2005-08-22T17:46:17.000','1809','501','2005-08-26T19:03:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15240','2005-08-22T17:46:41.000','2014','11','2005-08-23T15:08:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15241','2005-08-22T17:47:40.000','832','337','2005-08-29T15:28:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15242','2005-08-22T17:48:10.000','2106','364','2005-08-27T23:32:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15243','2005-08-22T17:48:28.000','4408','308','2005-08-31T13:22:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15244','2005-08-22T17:48:42.000','1486','271','2005-08-28T13:17:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15245','2005-08-22T17:49:35.000','2545','298','2005-08-26T18:25:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15246','2005-08-22T17:50:49.000','3786','100','2005-08-30T22:21:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15247','2005-08-22T17:52:05.000','4572','250','2005-08-31T21:37:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15248','2005-08-22T17:53:06.000','977','20','2005-08-25T18:43:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15249','2005-08-22T17:58:27.000','121','444','2005-08-30T14:55:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15250','2005-08-22T18:03:11.000','2176','143','2005-08-27T12:19:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15251','2005-08-22T18:03:57.000','1994','285','2005-08-23T20:56:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15252','2005-08-22T18:04:22.000','1821','453','2005-08-25T17:14:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15253','2005-08-22T18:05:21.000','4143','333','2005-08-23T18:06:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15254','2005-08-22T18:13:07.000','3762','209','2005-08-24T21:55:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15255','2005-08-22T18:16:50.000','3415','84','2005-08-28T14:14:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15256','2005-08-22T18:20:07.000','1873','198','2005-08-28T12:57:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15257','2005-08-22T18:21:04.000','915','223','2005-08-30T20:13:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15258','2005-08-22T18:22:44.000','788','293','2005-08-25T16:54:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15259','2005-08-22T18:23:23.000','3261','488','2005-08-27T13:06:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15260','2005-08-22T18:24:16.000','3135','274','2005-08-24T21:26:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15261','2005-08-22T18:24:34.000','2200','140','2005-08-27T19:53:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15262','2005-08-22T18:25:21.000','2534','298','2005-08-28T22:19:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15263','2005-08-22T18:27:33.000','184','324','2005-08-30T14:05:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15264','2005-08-22T18:27:38.000','4459','440','2005-08-24T12:39:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15265','2005-08-22T18:35:59.000','1763','512','2005-08-28T21:18:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15266','2005-08-22T18:37:24.000','1870','124','2005-08-23T17:34:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15267','2005-08-22T18:37:48.000','2966','153','2005-08-24T00:22:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15268','2005-08-22T18:39:11.000','1245','301','2005-08-26T21:46:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15269','2005-08-22T18:39:44.000','524','275','2005-08-24T17:29:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15270','2005-08-22T18:48:42.000','4123','262','2005-08-28T15:38:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15271','2005-08-22T18:48:48.000','4232','59','2005-08-30T00:45:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15272','2005-08-22T18:49:40.000','1664','422','2005-08-28T21:22:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15273','2005-08-22T18:53:28.000','2558','422','2005-08-30T18:58:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15274','2005-08-22T18:55:52.000','3519','515','2005-08-23T20:02:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15275','2005-08-22T18:57:39.000','1522','597','2005-08-23T19:00:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15276','2005-08-22T18:59:01.000','4523','490','2005-08-23T19:49:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15277','2005-08-22T19:02:48.000','1780','217','2005-08-31T18:53:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15278','2005-08-22T19:06:47.000','2454','472','2005-08-25T01:00:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15279','2005-08-22T19:08:49.000','1088','363','2005-08-30T00:38:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15280','2005-08-22T19:09:52.000','3464','317','2005-08-28T00:39:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15281','2005-08-22T19:10:26.000','3992','543','2005-08-27T21:55:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15282','2006-02-14T15:16:03.000','1932','163',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15283','2005-08-22T19:16:04.000','1688','219','2005-08-31T21:05:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15284','2005-08-22T19:17:08.000','2265','393','2005-08-29T13:28:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15285','2005-08-22T19:17:24.000','481','233','2005-08-25T00:25:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15286','2005-08-22T19:17:56.000','3731','74','2005-08-29T16:08:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15287','2005-08-22T19:19:37.000','308','535','2005-08-29T16:05:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15288','2005-08-22T19:23:58.000','1999','475','2005-08-26T23:28:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15289','2005-08-22T19:27:24.000','1026','513','2005-08-30T22:21:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15290','2005-08-22T19:28:02.000','270','404','2005-08-31T20:04:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15291','2005-08-22T19:28:04.000','1461','494','2005-08-26T15:07:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15292','2005-08-22T19:28:56.000','3072','337','2005-08-28T22:39:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15293','2006-02-14T15:16:03.000','1219','263',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15294','2006-02-14T15:16:03.000','70','108',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15295','2005-08-22T19:36:21.000','2164','186','2005-08-31T00:07:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15296','2005-08-22T19:37:20.000','2715','55','2005-08-24T15:16:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15297','2006-02-14T15:16:03.000','3192','327',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15298','2005-08-22T19:41:37.000','1446','1','2005-08-28T22:49:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15299','2005-08-22T19:42:57.000','767','381','2005-08-23T15:29:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15300','2005-08-22T19:44:00.000','2319','399','2005-08-25T22:49:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15301','2005-08-22T19:44:16.000','619','454','2005-08-26T22:57:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15302','2005-08-22T19:44:53.000','188','320','2005-08-24T18:13:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15303','2005-08-22T19:44:59.000','1672','390','2005-08-30T21:59:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15304','2005-08-22T19:45:57.000','4332','112','2005-08-28T00:21:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15305','2005-08-22T19:46:05.000','671','529','2005-08-27T19:11:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15306','2005-08-22T19:46:36.000','521','340','2005-08-27T14:09:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15307','2005-08-22T19:54:26.000','4525','598','2005-08-29T01:38:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15308','2005-08-22T19:54:31.000','987','329','2005-08-26T23:09:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15309','2005-08-22T19:54:52.000','2743','141','2005-08-24T23:00:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15310','2005-08-22T19:56:41.000','2546','360','2005-08-24T16:32:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15311','2005-08-22T19:56:52.000','3612','176','2005-08-31T20:15:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15312','2005-08-22T19:58:15.000','2509','280','2005-08-25T19:21:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15313','2005-08-22T19:59:42.000','2587','333','2005-08-24T15:03:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15314','2006-02-14T15:16:03.000','2754','412',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15315','2005-08-22T20:03:46.000','312','1','2005-08-30T01:51:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15316','2005-08-22T20:07:03.000','1830','422','2005-08-27T18:45:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15317','2005-08-22T20:14:13.000','2325','512','2005-08-29T18:32:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15318','2005-08-22T20:15:16.000','1738','60','2005-08-25T14:17:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15319','2005-08-22T20:17:17.000','3041','188','2005-08-25T01:06:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15320','2005-08-22T20:17:49.000','648','407','2005-08-28T17:31:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15321','2005-08-22T20:20:04.000','4152','384','2005-08-24T23:26:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15322','2005-08-22T20:20:30.000','3553','263','2005-08-25T01:26:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15323','2005-08-22T20:22:40.000','1153','178','2005-08-26T00:35:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15324','2005-08-22T20:23:13.000','161','93','2005-08-29T18:23:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15325','2005-08-22T20:27:38.000','3549','74','2005-08-23T15:24:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15326','2006-02-14T15:16:03.000','3320','58',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15327','2005-08-22T20:31:24.000','1018','450','2005-08-30T23:52:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15328','2005-08-22T20:31:38.000','4546','274','2005-08-29T20:17:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15329','2005-08-22T20:32:39.000','1900','521','2005-08-23T17:15:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15330','2005-08-22T20:35:30.000','689','427','2005-08-30T21:54:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15331','2005-08-22T20:37:57.000','146','147','2005-08-25T21:56:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15332','2005-08-22T20:41:53.000','3368','162','2005-08-24T01:45:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15333','2005-08-22T20:44:06.000','1839','142','2005-08-29T22:34:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15334','2005-08-22T20:44:35.000','3882','407','2005-08-29T23:03:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15335','2005-08-22T20:44:55.000','1593','363','2005-08-28T21:43:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15336','2005-08-22T20:47:48.000','490','461','2005-08-31T18:17:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15337','2005-08-22T20:49:51.000','280','237','2005-08-26T23:27:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15338','2005-08-22T20:51:24.000','502','13','2005-08-24T23:41:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15339','2005-08-22T20:52:12.000','1660','331','2005-08-26T00:36:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15340','2005-08-22T20:55:56.000','3653','313','2005-08-27T18:52:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15341','2005-08-22T20:56:31.000','3359','91','2005-08-30T17:25:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15342','2005-08-22T20:56:41.000','3287','459','2005-08-26T22:51:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15343','2005-08-22T21:01:25.000','2589','538','2005-08-28T16:15:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15344','2005-08-22T21:01:48.000','3560','193','2005-08-27T15:47:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15345','2005-08-22T21:05:50.000','3481','277','2005-08-26T20:30:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15346','2005-08-22T21:06:00.000','3525','266','2005-08-28T22:08:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15347','2005-08-22T21:12:19.000','3764','519','2005-08-24T20:12:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15348','2005-08-22T21:13:46.000','3846','587','2005-08-24T17:06:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15349','2005-08-22T21:13:51.000','4055','587','2005-08-23T20:55:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15350','2005-08-22T21:15:29.000','1170','488','2005-08-24T02:56:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15351','2005-08-22T21:15:46.000','3260','154','2005-08-23T17:38:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15352','2005-08-22T21:16:54.000','16','560','2005-08-31T00:38:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15353','2005-08-22T21:18:08.000','3470','368','2005-08-25T20:29:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15354','2005-08-22T21:18:59.000','4212','412','2005-08-27T20:12:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15355','2005-08-22T21:19:24.000','3477','493','2005-08-28T20:36:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15356','2005-08-22T21:24:19.000','4507','539','2005-08-25T22:32:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15357','2005-08-22T21:28:59.000','727','24','2005-08-25T17:15:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15358','2005-08-22T21:29:14.000','822','448','2005-08-31T00:10:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15359','2005-08-22T21:34:00.000','4505','77','2005-08-29T18:59:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15360','2005-08-22T21:36:51.000','1950','531','2005-08-24T16:46:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15361','2005-08-22T21:39:45.000','1407','380','2005-08-23T17:32:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15362','2005-08-22T21:40:20.000','1023','497','2005-08-29T15:55:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15363','2005-08-22T21:41:40.000','2326','480','2005-08-23T21:40:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15364','2005-08-22T21:41:41.000','4184','204','2005-08-28T00:49:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15365','2005-08-22T21:42:17.000','3382','327','2005-09-01T03:14:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15366','2005-08-22T21:45:57.000','1453','374','2005-08-30T16:35:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15367','2005-08-22T21:47:53.000','160','355','2005-08-27T17:54:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15368','2005-08-22T21:57:15.000','1130','370','2005-08-29T16:28:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15369','2005-08-22T21:58:06.000','881','121','2005-08-26T00:27:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15370','2005-08-22T21:59:29.000','67','10','2005-08-27T16:32:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15371','2006-02-14T15:16:03.000','3672','94',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15372','2005-08-22T21:59:51.000','3876','273','2005-08-23T17:01:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15373','2005-08-22T22:08:11.000','4439','14','2005-08-24T01:05:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15374','2005-08-22T22:09:09.000','4275','8','2005-08-31T01:10:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15375','2005-08-22T22:12:02.000','3864','191','2005-08-24T00:50:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15376','2005-08-22T22:21:35.000','2963','390','2005-08-28T20:56:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15377','2005-08-22T22:22:33.000','3405','551','2005-08-29T18:41:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15378','2005-08-22T22:25:17.000','1483','340','2005-08-30T17:04:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15379','2005-08-22T22:26:13.000','1899','148','2005-08-31T18:19:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15380','2005-08-22T22:28:15.000','3642','423','2005-08-28T23:21:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15381','2005-08-22T22:28:36.000','845','110','2005-08-24T19:26:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15382','2005-08-22T22:30:50.000','333','376','2005-08-24T04:07:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15383','2005-08-22T22:31:20.000','686','405','2005-08-28T17:43:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15384','2005-08-22T22:34:44.000','3208','26','2005-08-23T23:25:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15385','2005-08-22T22:37:34.000','140','434','2005-08-26T00:36:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15386','2005-08-22T22:41:14.000','3056','327','2005-08-29T22:29:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15387','2005-08-22T22:49:13.000','3879','323','2005-08-29T01:49:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15388','2005-08-22T22:49:23.000','3995','50','2005-09-01T03:50:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15389','2005-08-22T22:51:13.000','2077','231','2005-08-28T23:46:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15390','2005-08-22T22:57:25.000','462','551','2005-08-31T18:06:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15391','2005-08-22T23:01:45.000','3918','482','2005-08-29T02:59:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15392','2005-08-22T23:02:15.000','538','410','2005-09-01T01:14:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15393','2005-08-22T23:04:09.000','2924','443','2005-08-27T02:23:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15394','2005-08-22T23:04:21.000','3455','507','2005-08-25T20:53:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15395','2005-08-22T23:06:25.000','2880','526','2005-08-30T19:18:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15396','2005-08-22T23:07:57.000','4050','319','2005-08-28T19:39:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15397','2005-08-22T23:08:46.000','1482','261','2005-08-25T20:58:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15398','2005-08-22T23:10:49.000','4451','109','2005-08-28T00:49:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15399','2005-08-22T23:11:59.000','3858','379','2005-08-26T22:16:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15400','2005-08-22T23:13:03.000','2664','473','2005-08-28T18:34:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15401','2005-08-22T23:13:10.000','1721','103','2005-09-01T03:44:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15402','2005-08-22T23:17:41.000','1575','293','2005-08-30T20:07:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15403','2005-08-22T23:18:10.000','4315','581','2005-08-23T18:08:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15404','2005-08-22T23:19:44.000','3557','211','2005-08-30T19:58:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15405','2005-08-22T23:20:41.000','3263','596','2005-08-25T23:53:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15406','2005-08-22T23:21:22.000','400','227','2005-08-28T22:21:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15407','2006-02-14T15:16:03.000','3330','42',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15408','2005-08-22T23:26:32.000','165','156','2005-08-30T20:22:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15409','2005-08-22T23:26:32.000','560','188','2005-08-24T22:44:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15410','2005-08-22T23:27:43.000','2052','403','2005-08-29T05:12:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15411','2005-08-22T23:35:41.000','4423','461','2005-08-26T00:51:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15412','2005-08-22T23:37:11.000','1267','199','2005-08-28T23:26:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15413','2005-08-22T23:38:01.000','2494','476','2005-08-23T19:27:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15414','2005-08-22T23:43:54.000','718','532','2005-08-30T18:26:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15415','2005-08-22T23:48:56.000','4176','204','2005-09-01T02:05:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15416','2005-08-22T23:51:23.000','1167','383','2005-08-29T20:03:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15417','2005-08-22T23:54:04.000','1826','305','2005-08-26T22:25:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15418','2005-08-22T23:54:14.000','808','205','2005-08-28T04:23:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15419','2005-08-22T23:54:36.000','1120','450','2005-08-25T00:52:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15420','2005-08-22T23:55:51.000','1396','161','2005-08-31T20:09:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15421','2005-08-22T23:56:37.000','3','541','2005-08-25T18:58:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15422','2005-08-22T23:58:09.000','2601','309','2005-08-30T19:03:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15423','2006-02-14T15:16:03.000','1786','596',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15424','2005-08-23T00:03:01.000','3452','138','2005-08-27T23:27:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15425','2005-08-23T00:05:57.000','551','259','2005-09-01T05:08:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15426','2005-08-23T00:07:19.000','3280','347','2005-08-26T23:19:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15427','2005-08-23T00:07:53.000','2775','448','2005-09-01T02:55:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15428','2005-08-23T00:11:52.000','4379','402','2005-08-24T02:35:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15429','2005-08-23T00:20:31.000','740','241','2005-08-23T20:22:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15430','2006-02-14T15:16:03.000','4353','282',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15431','2005-08-23T00:26:47.000','3251','550','2005-08-31T23:26:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15432','2005-08-23T00:26:52.000','1896','117','2005-08-27T06:11:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15433','2005-08-23T00:27:18.000','155','198','2005-08-26T21:36:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15434','2005-08-23T00:28:16.000','4378','518','2005-08-26T04:27:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15435','2005-08-23T00:28:19.000','2103','468','2005-08-26T00:44:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15436','2005-08-23T00:30:26.000','1527','505','2005-08-28T06:29:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15437','2005-08-23T00:31:09.000','4236','368','2005-08-30T06:17:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15438','2005-08-23T00:31:57.000','2030','46','2005-08-26T20:02:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15439','2005-08-23T00:34:28.000','3848','136','2005-08-27T01:07:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15440','2005-08-23T00:37:21.000','2254','559','2005-08-24T23:24:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15441','2006-02-14T15:16:03.000','258','422',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15442','2005-08-23T00:42:49.000','1452','42','2005-08-27T00:35:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15443','2005-08-23T00:44:15.000','742','598','2005-09-01T05:33:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15444','2005-08-23T00:46:52.000','959','153','2005-08-29T20:37:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15445','2005-08-23T00:48:29.000','196','28','2005-08-28T00:33:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15446','2005-08-23T00:49:24.000','503','379','2005-08-26T02:09:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15447','2005-08-23T00:53:57.000','4090','331','2005-08-29T06:19:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15448','2005-08-23T00:55:24.000','2903','490','2005-08-25T02:20:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15449','2005-08-23T00:55:43.000','2856','461','2005-08-28T03:41:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15450','2005-08-23T00:56:01.000','1102','322','2005-08-24T01:00:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15451','2005-08-23T00:56:27.000','231','514','2005-08-24T00:15:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15452','2005-08-23T00:57:12.000','717','115','2005-08-28T00:19:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15453','2005-08-23T01:01:01.000','2','359','2005-08-30T20:08:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15454','2006-02-14T15:16:03.000','2946','142',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15455','2005-08-23T01:05:00.000','3991','238','2005-08-26T22:56:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15456','2005-08-23T01:07:01.000','2451','262','2005-08-24T23:28:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15457','2005-08-23T01:07:37.000','4539','306','2005-08-26T19:46:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15458','2006-02-14T15:16:03.000','25','590',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15459','2005-08-23T01:09:48.000','2058','346','2005-08-24T04:52:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15460','2005-08-23T01:10:42.000','2907','20','2005-08-28T20:49:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15461','2005-08-23T01:13:52.000','4542','103','2005-08-30T00:44:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15462','2005-08-23T01:14:01.000','3267','389','2005-08-29T19:52:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15463','2005-08-23T01:15:07.000','863','127','2005-08-29T06:50:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15464','2005-08-23T01:15:18.000','3235','62','2005-08-29T02:58:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15465','2005-08-23T01:16:33.000','362','520','2005-08-28T20:08:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15466','2005-08-23T01:16:55.000','571','418','2005-08-29T22:57:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15467','2005-08-23T01:22:12.000','3658','103','2005-08-29T23:42:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15468','2005-08-23T01:25:30.000','2440','399','2005-08-28T01:40:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15469','2005-08-23T01:29:59.000','1939','597','2005-08-27T04:02:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15470','2005-08-23T01:35:12.000','3009','416','2005-09-01T05:33:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15471','2005-08-23T01:38:48.000','2591','139','2005-08-31T19:47:48.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15472','2005-08-23T01:39:05.000','4293','226','2005-08-25T04:43:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15473','2005-08-23T01:39:10.000','356','259','2005-08-25T03:48:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15474','2005-08-23T01:39:10.000','3015','188','2005-08-23T21:46:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15475','2005-08-23T01:44:43.000','4503','562','2005-08-23T23:53:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15476','2005-08-23T01:45:07.000','2478','433','2005-08-26T21:07:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15477','2005-08-23T01:46:35.000','2406','142','2005-08-28T22:12:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15478','2005-08-23T01:50:31.000','4563','167','2005-08-27T21:40:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15479','2005-08-23T01:50:53.000','4182','149','2005-08-29T00:53:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15480','2005-08-23T01:57:20.000','3298','577','2005-08-26T04:43:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15481','2005-08-23T01:59:14.000','3262','414','2005-08-27T04:38:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15482','2005-08-23T02:01:20.000','3923','181','2005-08-24T03:25:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15483','2005-08-23T02:02:53.000','2970','173','2005-08-26T04:13:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15484','2005-08-23T02:04:49.000','642','342','2005-08-24T05:46:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15485','2005-08-23T02:04:57.000','281','114','2005-08-28T07:05:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15486','2005-08-23T02:05:20.000','1666','502','2005-08-29T07:52:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15487','2005-08-23T02:05:51.000','2636','469','2005-08-25T04:45:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15488','2005-08-23T02:06:01.000','4535','385','2005-08-29T21:35:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15489','2005-08-23T02:06:41.000','764','285','2005-08-25T06:50:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15490','2005-08-23T02:08:18.000','3922','493','2005-08-30T06:15:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15491','2005-08-23T02:08:40.000','2059','28','2005-08-23T20:23:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15492','2005-08-23T02:13:46.000','1298','520','2005-08-26T21:53:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15493','2005-08-23T02:20:53.000','3521','308','2005-08-25T23:02:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15494','2005-08-23T02:25:09.000','2968','455','2005-08-27T00:18:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15495','2005-08-23T02:26:10.000','4310','193','2005-08-30T01:07:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15496','2005-08-23T02:30:23.000','1863','275','2005-08-31T03:31:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15497','2006-02-14T15:16:03.000','363','107',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15498','2005-08-23T02:33:27.000','1583','83','2005-08-23T22:30:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15499','2005-08-23T02:37:19.000','630','488','2005-08-23T20:57:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15500','2005-08-23T02:39:37.000','886','74','2005-08-27T06:42:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15501','2005-08-23T02:39:56.000','4468','138','2005-08-25T04:39:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15502','2005-08-23T02:40:04.000','3219','433','2005-08-31T00:36:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15503','2005-08-23T02:44:49.000','4519','582','2005-08-27T06:33:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15504','2005-08-23T02:45:21.000','1967','315','2005-09-01T03:24:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15505','2005-08-23T02:46:13.000','1144','375','2005-08-26T23:34:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15506','2005-08-23T02:48:24.000','1914','553','2005-08-28T04:10:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15507','2005-08-23T02:48:26.000','3130','563','2005-08-27T01:32:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15508','2005-08-23T02:49:04.000','4035','293','2005-08-29T00:58:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15509','2005-08-23T02:51:24.000','1291','6','2005-08-31T06:21:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15510','2005-08-23T02:51:27.000','3239','209','2005-09-01T02:44:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15511','2005-08-23T02:55:42.000','3327','303','2005-08-31T03:14:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15512','2005-08-23T02:57:30.000','4336','25','2005-08-25T01:47:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15513','2005-08-23T03:01:56.000','3779','147','2005-08-24T23:46:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15514','2005-08-23T03:03:40.000','2824','366','2005-08-24T01:06:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15515','2005-08-23T03:03:53.000','3940','307','2005-08-25T08:27:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15516','2005-08-23T03:12:54.000','219','82','2005-08-30T04:02:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15517','2005-08-23T03:13:01.000','2221','187','2005-08-25T21:14:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15518','2005-08-23T03:19:34.000','3522','410','2005-08-24T02:55:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15519','2005-08-23T03:23:32.000','542','443','2005-08-25T03:48:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15520','2005-08-23T03:30:45.000','1792','163','2005-09-01T00:20:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15521','2005-08-23T03:30:51.000','134','331','2005-08-28T22:09:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15522','2005-08-23T03:32:31.000','2396','468','2005-08-30T02:17:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15523','2005-08-23T03:32:36.000','2570','432','2005-08-26T22:08:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15524','2005-08-23T03:36:26.000','2886','68','2005-08-26T06:28:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15525','2005-08-23T03:43:32.000','3509','123','2005-08-25T07:31:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15526','2005-08-23T03:44:30.000','2892','516','2005-08-30T08:19:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15527','2005-08-23T03:44:51.000','88','393','2005-08-25T03:09:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15528','2005-08-23T03:45:40.000','3033','114','2005-08-25T01:16:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15529','2005-08-23T03:46:47.000','4015','19','2005-08-24T00:59:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15530','2005-08-23T03:50:48.000','154','167','2005-08-28T22:17:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15531','2005-08-23T03:52:36.000','2410','355','2005-08-25T23:21:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15532','2006-02-14T15:16:03.000','1061','23',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15533','2005-08-23T03:54:39.000','1895','400','2005-08-26T08:27:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15534','2005-08-23T03:55:54.000','544','169','2005-08-24T03:54:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15535','2005-08-23T03:58:02.000','2371','346','2005-08-25T05:06:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15536','2005-08-23T03:58:28.000','4004','98','2005-08-31T03:28:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15537','2005-08-23T04:00:30.000','2958','137','2005-08-24T01:45:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15538','2005-08-23T04:07:37.000','4226','211','2005-08-28T07:37:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15539','2005-08-23T04:09:03.000','2853','582','2005-08-26T04:01:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15540','2005-08-23T04:12:52.000','1696','197','2005-08-31T04:25:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15541','2005-08-23T04:13:53.000','2762','148','2005-08-29T05:51:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15542','2006-02-14T15:16:03.000','21','111',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15543','2005-08-23T04:15:41.000','3836','282','2005-09-01T05:09:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15544','2005-08-23T04:17:56.000','1918','30','2005-09-01T00:43:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15545','2005-08-23T04:20:16.000','843','513','2005-08-29T08:22:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15546','2005-08-23T04:20:38.000','2087','223','2005-09-01T09:57:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15547','2005-08-23T04:25:50.000','1488','69','2005-08-26T00:57:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15548','2005-08-23T04:26:20.000','2350','334','2005-08-28T01:27:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15549','2005-08-23T04:27:06.000','369','170','2005-09-01T06:07:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15550','2005-08-23T04:27:54.000','1375','465','2005-08-29T01:29:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15551','2005-08-23T04:28:25.000','3570','345','2005-08-26T07:19:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15552','2005-08-23T04:33:23.000','4347','527','2005-09-01T10:25:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15553','2005-08-23T04:33:39.000','1659','232','2005-08-25T07:53:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15554','2005-08-23T04:48:12.000','198','280','2005-08-29T05:11:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15555','2005-08-23T04:51:52.000','1869','347','2005-08-24T01:01:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15556','2005-08-23T04:52:16.000','3683','108','2005-09-01T02:05:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15557','2005-08-23T04:52:17.000','3641','444','2005-08-30T02:15:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15558','2005-08-23T04:52:22.000','638','474','2005-09-01T02:26:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15559','2005-08-23T04:55:05.000','1773','517','2005-08-30T09:01:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15560','2005-08-23T05:01:13.000','3616','107','2005-09-01T05:02:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15561','2005-08-23T05:02:31.000','68','469','2005-09-01T02:51:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15562','2005-08-23T05:04:33.000','4238','149','2005-08-27T09:58:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15563','2005-08-23T05:08:58.000','170','372','2005-08-24T04:24:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15564','2005-08-23T05:10:42.000','1268','353','2005-08-30T03:17:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15565','2005-08-23T05:13:09.000','71','546','2005-08-30T08:58:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15566','2005-08-23T05:17:23.000','4344','76','2005-09-01T08:09:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15567','2005-08-23T05:20:36.000','2506','54','2005-08-24T10:09:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15568','2005-08-23T05:24:09.000','988','556','2005-08-27T08:57:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15569','2005-08-23T05:24:29.000','1071','313','2005-08-30T08:23:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15570','2005-08-23T05:24:55.000','4014','557','2005-08-31T07:06:55.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15571','2005-08-23T05:26:30.000','716','57','2005-08-29T00:54:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15572','2005-08-23T05:28:01.000','2816','506','2005-08-27T00:14:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15573','2005-08-23T05:28:36.000','3133','561','2005-08-27T05:37:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15574','2005-08-23T05:29:32.000','3253','130','2005-09-01T01:25:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15575','2005-08-23T05:30:19.000','3916','218','2005-08-27T05:19:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15576','2005-08-23T05:32:03.000','3257','595','2005-08-26T02:31:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15577','2006-02-14T15:16:03.000','539','29',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15578','2005-08-23T05:37:13.000','2829','302','2005-08-27T01:11:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15579','2005-08-23T05:38:41.000','3986','480','2005-08-29T09:18:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15580','2005-08-23T05:39:06.000','754','279','2005-09-01T01:14:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15581','2005-08-23T05:42:13.000','4010','462','2005-08-28T00:03:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15582','2005-08-23T05:45:44.000','4264','297','2005-08-25T07:54:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15583','2005-08-23T05:47:55.000','4299','215','2005-08-26T01:46:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15584','2005-08-23T05:49:21.000','3526','500','2005-08-27T04:49:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15585','2005-08-23T05:55:22.000','1177','545','2005-08-24T11:45:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15586','2005-08-23T05:57:04.000','3232','148','2005-08-31T01:59:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15587','2005-08-23T06:00:28.000','2510','499','2005-08-29T10:15:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15588','2005-08-23T06:02:35.000','1810','503','2005-08-30T04:01:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15589','2005-08-23T06:03:31.000','2379','22','2005-08-30T07:44:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15590','2005-08-23T06:09:44.000','4048','599','2005-09-01T06:53:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15591','2005-08-23T06:11:52.000','64','62','2005-08-25T05:34:52.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15593','2005-08-23T06:15:09.000','3734','153','2005-08-27T07:47:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15594','2005-08-23T06:18:43.000','4227','567','2005-09-01T09:09:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15595','2005-08-23T06:19:12.000','4046','264','2005-08-31T04:52:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15596','2005-08-23T06:19:51.000','3834','186','2005-08-25T03:32:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15597','2005-08-23T06:21:20.000','3795','420','2005-08-28T02:47:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15598','2005-08-23T06:23:26.000','2794','66','2005-09-01T05:43:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15599','2005-08-23T06:25:07.000','4560','103','2005-08-29T00:48:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15600','2005-08-23T06:31:24.000','2260','113','2005-08-28T06:53:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15601','2005-08-23T06:33:26.000','3643','579','2005-08-24T04:10:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15602','2005-08-23T06:41:07.000','1429','81','2005-08-24T07:16:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15603','2005-08-23T06:41:32.000','2565','6','2005-08-28T08:51:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15604','2005-08-23T06:44:19.000','4000','458','2005-08-29T07:17:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15605','2005-08-23T06:48:47.000','3152','544','2005-08-28T06:09:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15606','2005-08-23T06:50:27.000','1811','279','2005-08-28T04:23:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15607','2005-08-23T06:54:06.000','4118','484','2005-08-26T05:03:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15608','2005-08-23T06:55:26.000','2921','454','2005-08-28T10:24:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15609','2005-08-23T06:56:04.000','1730','256','2005-09-01T03:25:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15610','2005-08-23T06:56:15.000','2076','215','2005-08-24T07:37:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15611','2005-08-23T06:56:18.000','1713','184','2005-08-25T06:10:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15612','2005-08-23T06:59:07.000','3367','305','2005-09-01T11:26:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15613','2005-08-23T07:03:19.000','307','461','2005-08-31T07:50:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15614','2005-08-23T07:05:15.000','1216','287','2005-09-01T11:41:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15615','2005-08-23T07:06:00.000','899','584','2005-08-30T11:21:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15616','2005-08-23T07:06:38.000','2947','70','2005-08-30T04:16:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15617','2005-08-23T07:07:22.000','4085','569','2005-08-27T01:24:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15618','2005-08-23T07:07:58.000','1903','60','2005-08-29T03:48:58.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15619','2005-08-23T07:10:14.000','2468','3','2005-08-26T07:21:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15620','2005-08-23T07:10:22.000','1173','270','2005-08-28T06:51:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15621','2005-08-23T07:13:43.000','3832','123','2005-08-29T08:19:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15622','2005-08-23T07:22:02.000','3335','302','2005-09-01T06:08:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15623','2005-08-23T07:23:29.000','3003','525','2005-08-31T01:47:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15624','2005-08-23T07:24:27.000','396','105','2005-08-29T12:36:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15625','2005-08-23T07:25:29.000','4200','207','2005-08-27T13:17:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15626','2005-08-23T07:25:34.000','640','370','2005-08-28T11:01:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15627','2005-08-23T07:25:38.000','1364','453','2005-08-31T02:53:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15628','2005-08-23T07:28:04.000','1348','408','2005-08-26T04:23:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15629','2005-08-23T07:28:22.000','3725','286','2005-08-29T06:29:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15630','2005-08-23T07:29:13.000','3590','580','2005-08-31T04:33:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15631','2005-08-23T07:30:23.000','2458','93','2005-08-24T07:23:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15632','2005-08-23T07:30:26.000','2941','60','2005-08-24T07:53:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15633','2005-08-23T07:31:10.000','882','497','2005-08-26T04:35:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15634','2005-08-23T07:34:18.000','2517','576','2005-08-24T12:00:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15635','2005-08-23T07:43:00.000','3308','4','2005-08-27T10:47:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15636','2005-08-23T07:50:46.000','1169','380','2005-08-26T07:59:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15637','2005-08-23T07:53:38.000','445','172','2005-08-29T03:16:38.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15638','2005-08-23T07:54:54.000','3358','563','2005-08-30T13:33:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15639','2005-08-23T08:03:25.000','42','214','2005-08-24T10:21:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15640','2005-08-23T08:04:40.000','3505','262','2005-08-24T06:38:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15641','2005-08-23T08:06:49.000','3126','240','2005-08-24T13:17:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15642','2005-08-23T08:09:11.000','2627','160','2005-08-28T05:57:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15643','2005-08-23T08:13:26.000','103','298','2005-08-25T05:18:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15644','2006-02-14T15:16:03.000','3139','43',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15645','2006-02-14T15:16:03.000','3838','214',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15646','2005-08-23T08:19:55.000','3217','114','2005-08-29T02:32:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15647','2005-08-23T08:23:56.000','2051','251','2005-08-26T11:00:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15648','2005-08-23T08:27:57.000','4039','80','2005-08-30T08:53:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15649','2005-08-23T08:28:03.000','415','60','2005-08-30T05:11:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15650','2005-08-23T08:29:53.000','2447','353','2005-08-25T07:23:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15651','2005-08-23T08:31:49.000','3393','451','2005-08-26T02:57:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15652','2005-08-23T08:34:10.000','4440','578','2005-08-30T12:31:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15653','2005-08-23T08:34:42.000','2736','439','2005-09-01T03:07:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15654','2005-08-23T08:34:53.000','4360','471','2005-08-30T04:18:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15655','2006-02-14T15:16:03.000','604','359',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15656','2005-08-23T08:38:58.000','4239','334','2005-08-24T04:08:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15657','2005-08-23T08:42:40.000','1897','36','2005-09-01T13:08:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15658','2005-08-23T08:48:43.000','3565','22','2005-08-25T05:38:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15659','2005-08-23T08:48:43.000','4573','131','2005-08-27T14:19:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15660','2005-08-23T08:51:21.000','3223','388','2005-08-28T06:26:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15661','2005-08-23T08:52:03.000','1599','346','2005-08-30T08:17:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15662','2005-08-23T08:52:50.000','3028','223','2005-08-24T08:08:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15663','2005-08-23T08:54:26.000','3291','291','2005-08-29T02:56:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15664','2005-08-23T08:57:11.000','2029','351','2005-08-31T14:19:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15665','2005-08-23T08:59:12.000','3471','487','2005-08-24T12:50:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15666','2005-08-23T09:01:10.000','3406','586','2005-08-31T12:32:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15667','2005-08-23T09:02:03.000','1302','73','2005-08-24T05:47:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15668','2005-08-23T09:02:04.000','1963','38','2005-08-29T03:17:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15669','2005-08-23T09:06:17.000','1542','334','2005-08-30T08:10:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15670','2005-08-23T09:07:11.000','2834','211','2005-08-31T04:32:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15671','2005-08-23T09:08:16.000','3716','112','2005-08-29T14:01:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15672','2005-08-23T09:09:18.000','701','210','2005-08-27T06:19:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15673','2005-08-23T09:12:50.000','3096','321','2005-08-29T12:45:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15674','2005-08-23T09:16:39.000','4482','90','2005-09-01T11:57:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15675','2005-08-23T09:18:52.000','4153','293','2005-08-30T14:59:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15676','2005-08-23T09:23:08.000','3874','353','2005-08-30T06:19:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15677','2005-08-23T09:23:36.000','2050','109','2005-08-27T05:01:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15678','2005-08-23T09:23:45.000','1345','413','2005-08-27T11:38:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15679','2005-08-23T09:27:29.000','2945','103','2005-08-28T09:14:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15680','2005-08-23T09:33:22.000','1370','169','2005-08-31T13:29:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15681','2005-08-23T09:35:34.000','2813','61','2005-08-27T08:33:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15682','2005-08-23T09:37:34.000','3293','31','2005-08-31T06:01:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15683','2005-08-23T09:38:17.000','3787','168','2005-08-30T12:31:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15684','2005-08-23T09:40:04.000','3976','586','2005-08-28T15:28:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15685','2005-08-23T09:41:28.000','370','491','2005-08-30T10:11:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15686','2005-08-23T09:42:21.000','2041','206','2005-08-29T12:22:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15687','2005-08-23T09:46:33.000','276','112','2005-09-01T06:07:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15688','2005-08-23T09:48:45.000','2851','105','2005-08-30T10:28:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15689','2005-08-23T09:52:55.000','248','259','2005-08-29T11:15:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15690','2005-08-23T09:53:30.000','2102','554','2005-08-29T10:27:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15691','2005-08-23T09:53:54.000','784','200','2005-08-27T10:14:54.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15692','2005-08-23T10:00:02.000','1852','503','2005-08-24T05:25:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15693','2005-08-23T10:00:24.000','748','94','2005-08-25T08:23:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15694','2005-08-23T10:02:46.000','3017','506','2005-08-31T05:46:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15695','2006-02-14T15:16:03.000','2954','300',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15696','2005-08-23T10:04:17.000','2836','93','2005-08-25T08:47:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15697','2005-08-23T10:04:36.000','1987','380','2005-08-24T05:00:36.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15698','2005-08-23T10:11:40.000','4465','395','2005-08-28T08:50:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15699','2005-08-23T10:20:35.000','4155','501','2005-08-30T13:56:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15700','2005-08-23T10:21:21.000','2935','552','2005-08-24T15:37:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15701','2005-08-23T10:22:21.000','2942','516','2005-08-24T10:52:21.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15702','2005-08-23T10:23:28.000','1602','56','2005-08-29T11:08:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15703','2005-08-23T10:23:48.000','2883','322','2005-09-01T06:54:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15704','2005-08-23T10:25:45.000','738','71','2005-08-29T16:06:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15705','2005-08-23T10:32:52.000','936','356','2005-08-29T13:18:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15706','2005-08-23T10:32:52.000','4486','220','2005-08-24T07:03:52.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15707','2005-08-23T10:35:45.000','3646','91','2005-08-27T10:57:45.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15708','2005-08-23T10:35:51.000','1974','46','2005-08-27T16:02:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15709','2005-08-23T10:36:00.000','346','206','2005-08-28T06:18:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15710','2006-02-14T15:16:03.000','1020','421',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15711','2005-08-23T10:43:00.000','789','297','2005-08-29T16:29:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15712','2005-08-23T10:43:56.000','1882','351','2005-08-29T15:35:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15713','2005-08-23T10:56:15.000','337','432','2005-08-29T09:14:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15714','2006-02-14T15:16:03.000','2083','56',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15715','2005-08-23T10:57:40.000','3808','86','2005-08-28T12:40:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15716','2005-08-23T11:02:00.000','2812','408','2005-08-28T14:46:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15717','2006-02-14T15:16:03.000','902','208',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15718','2005-08-23T11:05:17.000','2180','276','2005-08-28T12:50:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15719','2005-08-23T11:08:46.000','3990','599','2005-08-25T07:25:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15720','2005-08-23T11:15:20.000','2490','456','2005-08-31T09:49:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15721','2005-08-23T11:16:16.000','685','154','2005-08-28T10:21:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15722','2005-08-23T11:16:29.000','2809','26','2005-09-01T13:24:29.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15723','2005-08-23T11:17:26.000','3915','504','2005-08-31T13:58:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15724','2005-08-23T11:22:09.000','1025','478','2005-08-28T12:56:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15725','2005-08-23T11:25:00.000','378','599','2005-08-26T11:46:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15726','2005-08-23T11:28:26.000','906','503','2005-08-28T11:23:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15727','2005-08-23T11:28:49.000','2184','416','2005-08-24T06:24:49.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15728','2005-08-23T11:30:32.000','2567','323','2005-08-28T09:52:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15729','2006-02-14T15:16:03.000','2699','193',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15730','2005-08-23T11:32:35.000','947','147','2005-08-30T13:46:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15731','2005-08-23T11:33:25.000','3403','118','2005-08-24T07:19:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15732','2005-08-23T11:35:12.000','3247','412','2005-08-26T12:50:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15733','2005-08-23T11:37:32.000','4185','512','2005-08-28T16:27:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15734','2005-08-23T11:40:08.000','3952','302','2005-08-27T08:16:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15735','2006-02-14T15:16:03.000','3167','295',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15736','2005-08-23T11:40:30.000','4272','127','2005-08-30T12:40:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15737','2005-08-23T11:52:18.000','996','83','2005-08-28T15:28:18.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15738','2005-08-23T11:55:50.000','556','38','2005-08-30T15:07:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15739','2005-08-23T11:56:22.000','266','74','2005-08-29T16:10:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15740','2005-08-23T12:07:51.000','100','229','2005-08-24T13:23:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15741','2005-08-23T12:10:54.000','4243','126','2005-08-24T10:08:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15742','2005-08-23T12:11:37.000','1339','200','2005-08-31T07:28:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15743','2005-08-23T12:12:05.000','1625','139','2005-08-26T11:35:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15744','2005-08-23T12:15:51.000','2364','59','2005-08-31T17:19:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15745','2006-02-14T15:16:03.000','2737','43',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15746','2005-08-23T12:26:19.000','2241','246','2005-08-26T09:51:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15747','2005-08-23T12:29:24.000','1517','381','2005-08-31T08:27:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15748','2005-08-23T12:33:00.000','2757','380','2005-08-25T15:15:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15749','2005-08-23T12:33:41.000','4224','575','2005-08-24T10:52:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15750','2005-08-23T12:36:05.000','4474','496','2005-08-24T17:40:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15751','2005-08-23T12:41:07.000','697','199','2005-08-29T07:03:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15752','2005-08-23T12:41:38.000','2112','17','2005-09-01T14:06:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15753','2005-08-23T12:43:30.000','3451','144','2005-09-01T09:07:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15754','2005-08-23T12:43:42.000','2306','356','2005-08-27T17:45:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15755','2005-08-23T12:46:38.000','511','423','2005-08-25T12:59:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15756','2005-08-23T12:47:05.000','878','112','2005-08-28T08:34:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15757','2005-08-23T12:47:16.000','1308','356','2005-08-29T17:19:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15758','2005-08-23T12:47:26.000','152','46','2005-08-29T11:05:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15759','2005-08-23T12:47:37.000','1341','361','2005-09-01T11:28:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15760','2005-08-23T12:50:00.000','3050','273','2005-08-29T15:41:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15761','2005-08-23T12:55:51.000','4362','416','2005-08-26T16:51:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15762','2005-08-23T13:01:43.000','887','351','2005-08-26T16:35:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15763','2005-08-23T13:02:59.000','124','158','2005-08-24T17:45:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15764','2005-08-23T13:05:10.000','2937','8','2005-08-25T16:15:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15765','2005-08-23T13:06:19.000','1250','408','2005-08-31T12:18:19.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15766','2005-08-23T13:10:16.000','1996','436','2005-08-30T09:27:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15767','2005-08-23T13:14:15.000','3492','241','2005-08-27T14:43:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15768','2005-08-23T13:14:47.000','662','267','2005-08-29T14:17:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15769','2005-08-23T13:16:15.000','2392','276','2005-08-28T18:31:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15770','2005-08-23T13:18:16.000','1424','113','2005-08-29T11:31:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15771','2005-08-23T13:18:46.000','3667','262','2005-08-26T07:29:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15772','2005-08-23T13:22:56.000','4343','202','2005-08-26T10:35:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15773','2005-08-23T13:24:57.000','1626','189','2005-08-31T14:16:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15774','2005-08-23T13:25:08.000','1273','254','2005-08-28T10:08:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15775','2005-08-23T13:25:44.000','2146','173','2005-09-01T16:56:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15776','2005-08-23T13:26:01.000','43','514','2005-08-29T18:17:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15777','2005-08-23T13:29:08.000','4241','130','2005-08-27T18:50:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15778','2006-02-14T15:16:03.000','1269','234',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15779','2005-08-23T13:33:46.000','1560','419','2005-08-28T08:40:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15780','2006-02-14T15:16:03.000','2911','120',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15781','2005-08-23T13:41:05.000','4449','412','2005-08-31T13:11:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15782','2005-08-23T13:43:26.000','3282','245','2005-08-30T14:03:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15783','2005-08-23T13:45:44.000','397','247','2005-08-26T09:18:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15784','2005-08-23T13:46:00.000','126','425','2005-08-30T11:49:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15785','2005-08-23T13:46:27.000','1758','543','2005-08-27T10:16:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15786','2005-08-23T13:48:34.000','3132','371','2005-08-27T15:59:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15787','2005-08-23T13:51:57.000','2932','123','2005-08-27T17:06:57.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15788','2005-08-23T13:54:39.000','13','269','2005-08-26T10:17:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15789','2005-08-23T13:56:40.000','1213','350','2005-08-27T15:25:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15790','2005-08-23T14:01:07.000','2887','233','2005-08-30T10:32:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15791','2005-08-23T14:02:13.000','4147','445','2005-09-01T09:03:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15792','2005-08-23T14:05:37.000','2175','581','2005-08-28T10:54:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15793','2005-08-23T14:06:19.000','2863','22','2005-08-24T19:59:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15794','2006-02-14T15:16:03.000','3917','579',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15795','2005-08-23T14:07:56.000','4371','417','2005-08-25T12:10:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15796','2005-08-23T14:12:22.000','1425','158','2005-08-28T17:03:22.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15797','2005-08-23T14:13:47.000','497','503','2005-08-25T09:16:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15798','2005-08-23T14:23:03.000','3803','203','2005-08-30T17:39:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15799','2005-08-23T14:23:23.000','2519','215','2005-08-24T17:15:23.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15800','2005-08-23T14:23:44.000','963','43','2005-08-29T17:04:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15801','2005-08-23T14:26:04.000','1590','165','2005-08-28T15:04:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15802','2005-08-23T14:26:51.000','41','158','2005-08-29T16:28:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15803','2005-08-23T14:27:07.000','500','105','2005-08-28T12:01:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15804','2005-08-23T14:29:16.000','3338','585','2005-08-26T08:41:16.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15805','2005-08-23T14:31:19.000','4511','8','2005-08-25T19:01:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15806','2005-08-23T14:31:50.000','2683','166','2005-08-27T16:08:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15807','2005-08-23T14:35:10.000','2705','350','2005-08-29T19:06:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15808','2005-08-23T14:38:37.000','1663','446','2005-08-27T14:45:37.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15809','2005-08-23T14:42:07.000','1885','431','2005-08-27T15:00:07.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15810','2005-08-23T14:43:15.000','2196','171','2005-08-25T17:41:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15811','2005-08-23T14:43:46.000','3487','300','2005-08-27T16:43:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15812','2005-08-23T14:47:26.000','4457','45','2005-09-01T10:51:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15813','2006-02-14T15:16:03.000','981','9',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15814','2005-08-23T14:52:50.000','4361','459','2005-08-27T16:12:50.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15815','2005-08-23T14:55:47.000','316','444','2005-08-24T12:37:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15816','2005-08-23T14:58:06.000','3628','31','2005-08-28T13:30:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15817','2005-08-23T14:59:51.000','598','348','2005-08-25T15:27:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15818','2005-08-23T14:59:58.000','2620','439','2005-08-27T13:13:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15819','2005-08-23T15:01:54.000','3639','274','2005-08-31T20:01:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15820','2005-08-23T15:03:13.000','4553','308','2005-08-25T20:12:13.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15821','2005-08-23T15:03:58.000','1714','233','2005-08-24T17:46:58.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15822','2005-08-23T15:05:59.000','3602','492','2005-08-24T11:13:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15823','2005-08-23T15:08:00.000','3047','81','2005-08-24T17:52:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15824','2005-08-23T15:09:17.000','2933','371','2005-08-28T15:14:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15825','2005-08-23T15:10:42.000','149','346','2005-08-29T09:28:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15826','2005-08-23T15:15:02.000','215','311','2005-08-31T20:39:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15827','2005-08-23T15:15:19.000','1732','346','2005-08-24T10:50:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15828','2005-08-23T15:16:32.000','428','327','2005-08-29T12:20:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15829','2005-08-23T15:17:14.000','4387','30','2005-08-27T13:04:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15830','2005-08-23T15:19:15.000','309','467','2005-08-25T18:42:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15831','2005-08-23T15:21:19.000','3123','401','2005-08-24T15:47:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15832','2005-08-23T15:21:35.000','1468','537','2005-08-30T15:01:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15833','2005-08-23T15:22:15.000','801','349','2005-08-31T14:54:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15834','2005-08-23T15:23:50.000','217','165','2005-09-01T19:31:50.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15835','2005-08-23T15:25:27.000','1362','128','2005-09-01T16:14:27.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15836','2005-08-23T15:29:17.000','260','468','2005-08-26T11:44:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15837','2005-08-23T15:29:41.000','4388','283','2005-08-27T18:17:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15838','2005-08-23T15:30:48.000','2194','579','2005-08-31T11:20:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15839','2005-08-23T15:34:46.000','3726','294','2005-08-30T21:00:46.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15840','2005-08-23T15:34:49.000','1901','316','2005-08-24T16:54:49.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15841','2005-08-23T15:35:59.000','2865','571','2005-08-30T19:30:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15842','2005-08-23T15:36:05.000','1850','146','2005-08-30T14:05:05.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15843','2005-08-23T15:37:31.000','611','215','2005-08-28T18:41:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15844','2005-08-23T15:38:12.000','2027','119','2005-08-26T15:18:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15845','2005-08-23T15:38:34.000','4312','89','2005-08-25T10:06:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15846','2005-08-23T15:39:18.000','3635','47','2005-08-27T14:28:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15847','2005-08-23T15:39:38.000','2287','163','2005-08-24T11:46:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15848','2005-08-23T15:41:12.000','2141','336','2005-08-26T10:29:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15849','2005-08-23T15:41:20.000','4077','482','2005-08-27T15:47:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15850','2005-08-23T15:45:42.000','586','563','2005-08-27T19:24:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15851','2005-08-23T15:46:33.000','2286','469','2005-08-29T15:52:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15852','2005-08-23T15:47:02.000','1506','140','2005-08-25T19:37:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15853','2005-08-23T15:54:20.000','225','500','2005-08-24T18:53:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15854','2005-08-23T15:58:05.000','1648','464','2005-08-26T19:23:05.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15855','2005-08-23T15:59:01.000','2528','192','2005-08-29T20:26:01.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15856','2005-08-23T15:59:12.000','3379','395','2005-08-25T15:36:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15857','2005-08-23T15:59:51.000','2733','575','2005-08-26T12:01:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15858','2005-08-23T16:07:15.000','4515','81','2005-08-25T19:36:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15859','2005-08-23T16:08:15.000','4269','465','2005-08-28T11:08:15.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15860','2005-08-23T16:08:40.000','2583','41','2005-08-28T15:35:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15861','2005-08-23T16:15:45.000','1859','256','2005-09-01T11:37:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15862','2006-02-14T15:16:03.000','925','215',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15863','2005-08-23T16:17:09.000','2783','328','2005-08-28T16:10:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15864','2005-08-23T16:18:12.000','3014','256','2005-08-29T17:10:12.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15865','2005-08-23T16:18:25.000','2031','482','2005-08-26T10:57:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15866','2005-08-23T16:19:02.000','3828','296','2005-08-31T12:29:02.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15867','2006-02-14T15:16:03.000','837','505',NULL,'2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15868','2005-08-23T16:19:14.000','2186','306','2005-08-29T16:14:14.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15869','2005-08-23T16:22:20.000','1344','357','2005-08-27T11:52:20.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15870','2005-08-23T16:23:08.000','590','251','2005-08-28T20:30:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15871','2005-08-23T16:24:24.000','425','57','2005-09-01T13:48:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15872','2005-08-23T16:27:24.000','3391','212','2005-08-31T11:57:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15873','2005-08-23T16:27:59.000','4548','577','2005-08-26T11:11:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15874','2005-08-23T16:30:55.000','621','132','2005-08-28T20:57:55.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15875','2006-02-14T15:16:03.000','3611','41',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15876','2005-08-23T16:32:10.000','1735','87','2005-08-24T18:16:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15877','2005-08-23T16:33:33.000','2307','559','2005-08-26T10:36:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15878','2005-08-23T16:34:31.000','1592','493','2005-08-27T21:51:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15879','2005-08-23T16:42:53.000','235','482','2005-08-29T16:21:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15880','2005-08-23T16:43:54.000','2538','528','2005-08-31T14:40:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15881','2005-08-23T16:44:25.000','617','383','2005-08-29T13:58:25.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15882','2005-08-23T16:44:31.000','2028','312','2005-09-01T15:44:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15883','2005-08-23T16:44:56.000','2792','550','2005-08-24T22:42:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15884','2005-08-23T16:45:28.000','2255','81','2005-08-27T20:18:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15885','2005-08-23T16:50:43.000','2116','565','2005-08-29T20:19:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15886','2005-08-23T16:50:53.000','3038','91','2005-08-26T15:38:53.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15887','2005-08-23T16:54:09.000','4263','201','2005-08-26T13:20:09.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15888','2005-08-23T16:56:14.000','2955','321','2005-08-31T14:32:14.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15889','2005-08-23T16:57:43.000','787','137','2005-08-27T22:14:43.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15890','2005-08-23T16:58:12.000','3625','87','2005-08-24T12:23:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15891','2005-08-23T17:00:12.000','2168','52','2005-08-31T21:12:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15892','2005-08-23T17:01:00.000','1365','174','2005-08-28T12:50:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15893','2005-08-23T17:02:00.000','2571','438','2005-08-30T12:45:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15894','2006-02-14T15:16:03.000','4416','168',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15895','2005-08-23T17:09:31.000','2275','342','2005-08-30T17:15:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15896','2005-08-23T17:09:56.000','528','585','2005-08-31T14:51:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15897','2005-08-23T17:12:31.000','1652','15','2005-08-30T17:22:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15898','2005-08-23T17:13:01.000','3502','88','2005-08-29T11:22:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15899','2005-08-23T17:16:28.000','3851','596','2005-08-29T21:46:28.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15900','2005-08-23T17:16:30.000','1112','562','2005-08-27T18:02:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15901','2005-08-23T17:19:17.000','2761','226','2005-08-30T14:24:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15902','2005-08-23T17:28:03.000','4500','172','2005-08-30T18:36:03.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15903','2005-08-23T17:30:40.000','1289','267','2005-08-29T14:12:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15904','2005-08-23T17:32:19.000','179','37','2005-08-24T21:05:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15905','2005-08-23T17:33:04.000','3631','59','2005-08-26T17:38:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15906','2005-08-23T17:36:00.000','3230','445','2005-08-28T15:32:00.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15907','2005-08-23T17:39:35.000','2898','2','2005-08-25T23:23:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15908','2005-08-23T17:42:00.000','2453','135','2005-08-31T22:32:00.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15909','2005-08-23T17:42:42.000','404','452','2005-08-26T20:25:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15910','2005-08-23T17:43:16.000','254','456','2005-08-24T21:55:16.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15911','2005-08-23T17:44:53.000','3006','582','2005-09-01T19:14:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15912','2005-08-23T17:47:40.000','3079','229','2005-08-31T14:43:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15913','2005-08-23T17:48:30.000','3894','93','2005-08-31T21:17:30.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15914','2005-08-23T17:49:26.000','747','557','2005-08-24T12:20:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15915','2005-08-23T17:52:01.000','3566','167','2005-08-24T20:40:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15916','2005-08-23T17:56:01.000','4580','327','2005-08-31T21:49:01.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15917','2005-08-23T17:57:28.000','2093','589','2005-08-29T20:03:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15918','2005-08-23T17:57:35.000','1456','262','2005-08-28T14:16:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15919','2005-08-23T18:01:31.000','1746','497','2005-08-24T16:27:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15920','2005-08-23T18:05:10.000','243','212','2005-08-26T18:09:10.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15921','2005-08-23T18:06:54.000','223','522','2005-08-30T20:19:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15922','2005-08-23T18:07:31.000','1702','263','2005-09-01T22:27:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15923','2005-08-23T18:08:19.000','1693','276','2005-08-26T18:06:19.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15924','2005-08-23T18:08:59.000','1114','541','2005-08-27T12:20:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15925','2005-08-23T18:15:06.000','3394','440','2005-08-26T18:09:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15926','2005-08-23T18:20:56.000','2231','151','2005-08-24T18:20:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15927','2005-08-23T18:23:11.000','2450','401','2005-08-24T15:09:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15928','2005-08-23T18:23:24.000','2086','75','2005-09-01T23:43:24.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15929','2005-08-23T18:23:30.000','1832','477','2005-08-27T17:04:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15930','2005-08-23T18:26:51.000','180','379','2005-08-31T16:12:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15931','2005-08-23T18:28:09.000','1128','237','2005-08-28T23:08:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15932','2005-08-23T18:31:40.000','4554','405','2005-08-24T16:30:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15933','2005-08-23T18:36:44.000','3493','176','2005-08-26T12:41:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15934','2005-08-23T18:40:41.000','994','216','2005-08-25T00:18:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15935','2005-08-23T18:41:11.000','907','361','2005-08-25T20:59:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15936','2005-08-23T18:43:11.000','1293','411','2005-08-26T00:19:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15937','2005-08-23T18:43:22.000','2882','194','2005-08-24T22:53:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15938','2005-08-23T18:43:31.000','2884','341','2005-08-31T00:26:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15939','2005-08-23T18:44:21.000','3209','382','2005-09-01T17:25:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15940','2005-08-23T18:45:06.000','1606','86','2005-08-30T13:00:06.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15941','2005-08-23T18:46:44.000','4304','424','2005-08-31T17:31:44.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15942','2005-08-23T18:48:40.000','1096','210','2005-09-01T18:39:40.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15943','2005-08-23T18:49:32.000','706','462','2005-08-27T19:20:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15944','2005-08-23T18:50:54.000','4559','348','2005-08-25T18:04:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15945','2005-08-23T18:51:41.000','3633','43','2005-08-28T18:42:41.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15946','2005-08-23T18:54:07.000','4549','561','2005-08-28T21:21:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15947','2005-08-23T18:54:32.000','1877','580','2005-08-24T22:39:32.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15948','2005-08-23T18:59:33.000','432','520','2005-08-31T13:02:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15949','2005-08-23T19:06:04.000','1199','386','2005-08-26T18:39:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15950','2005-08-23T19:09:39.000','1374','280','2005-08-31T17:03:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15951','2005-08-23T19:10:32.000','3018','446','2005-08-29T14:17:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15952','2005-08-23T19:11:29.000','1314','224','2005-08-28T14:41:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15953','2005-08-23T19:13:46.000','3727','540','2005-08-28T23:05:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15954','2005-08-23T19:14:07.000','576','460','2005-08-24T20:21:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15955','2005-08-23T19:19:06.000','2247','349','2005-08-31T23:34:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15956','2005-08-23T19:19:21.000','2763','354','2005-08-25T22:15:21.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15957','2005-08-23T19:21:22.000','74','418','2005-08-31T16:42:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15958','2005-08-23T19:22:36.000','4164','492','2005-08-30T01:03:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15959','2005-08-23T19:27:04.000','547','415','2005-08-24T15:24:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15960','2005-08-23T19:35:42.000','1497','431','2005-08-26T17:36:42.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15961','2005-08-23T19:35:42.000','4006','200','2005-08-30T22:52:42.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15962','2005-08-23T19:42:04.000','3491','160','2005-08-25T23:53:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15963','2005-08-23T19:42:46.000','3819','134','2005-08-25T22:12:46.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15964','2005-08-23T19:45:25.000','251','141','2005-08-26T22:43:25.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15965','2005-08-23T19:46:39.000','3449','509','2005-08-24T20:08:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15966','2006-02-14T15:16:03.000','4472','374',NULL,'1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15967','2005-08-23T19:50:06.000','321','257','2005-08-29T14:51:06.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15968','2005-08-23T19:51:29.000','3598','257','2005-08-24T15:07:29.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15969','2005-08-23T19:51:30.000','1807','327','2005-08-31T23:50:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15970','2005-08-23T19:54:24.000','4509','395','2005-08-24T18:07:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15971','2005-08-23T19:59:33.000','3456','187','2005-09-02T01:28:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15972','2005-08-23T20:00:30.000','4428','25','2005-08-30T00:25:30.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15973','2005-08-23T20:04:41.000','2766','343','2005-09-01T20:08:41.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15974','2005-08-23T20:06:04.000','3518','201','2005-08-27T17:33:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15975','2005-08-23T20:06:23.000','2723','174','2005-08-27T19:52:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15976','2005-08-23T20:07:08.000','835','227','2005-08-25T01:47:08.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15977','2005-08-23T20:07:10.000','1031','550','2005-09-01T22:12:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15978','2005-08-23T20:08:18.000','4444','536','2005-08-31T17:35:18.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15979','2005-08-23T20:08:26.000','3733','536','2005-08-26T19:19:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15980','2005-08-23T20:10:13.000','3365','196','2005-08-24T17:44:13.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15981','2005-08-23T20:12:17.000','2867','489','2005-08-30T20:43:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15982','2005-08-23T20:13:31.000','2920','370','2005-09-01T21:51:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15983','2005-08-23T20:13:38.000','3318','464','2005-08-30T18:42:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15984','2005-08-23T20:16:27.000','2011','495','2005-08-27T01:43:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15985','2005-08-23T20:20:23.000','2646','179','2005-08-26T20:55:23.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15986','2005-08-23T20:20:37.000','3472','226','2005-08-29T20:49:37.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15987','2005-08-23T20:22:17.000','3150','302','2005-08-31T21:46:17.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15988','2005-08-23T20:23:08.000','3932','400','2005-08-28T20:50:08.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15989','2005-08-23T20:24:36.000','38','96','2005-08-26T20:35:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15990','2005-08-23T20:25:11.000','3233','512','2005-08-25T15:01:11.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15991','2005-08-23T20:27:34.000','2078','203','2005-08-28T16:48:34.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15992','2005-08-23T20:28:32.000','3334','589','2005-08-24T21:35:32.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15993','2005-08-23T20:28:44.000','1638','12','2005-08-27T16:23:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15994','2005-08-23T20:29:10.000','438','595','2005-08-28T01:41:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15995','2005-08-23T20:29:56.000','1122','377','2005-08-30T18:09:56.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15996','2005-08-23T20:31:38.000','3098','151','2005-08-29T20:58:38.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15997','2005-08-23T20:40:31.000','2843','447','2005-08-26T19:47:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15998','2005-08-23T20:41:09.000','1229','545','2005-08-27T00:20:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('15999','2005-08-23T20:44:10.000','2584','377','2005-08-31T02:38:10.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('16000','2005-08-23T20:44:36.000','282','71','2005-08-25T02:29:36.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('16001','2005-08-23T20:45:53.000','245','108','2005-08-27T15:52:53.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('16002','2005-08-23T20:47:12.000','2770','73','2005-08-27T23:07:12.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('16003','2005-08-23T20:47:28.000','3413','577','2005-08-31T23:22:28.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('16004','2005-08-23T20:53:20.000','2223','147','2005-08-31T15:15:20.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('16005','2005-08-23T21:00:22.000','3265','466','2005-09-02T02:35:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('16006','2005-08-23T21:01:09.000','240','533','2005-08-25T19:33:09.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('16007','2005-08-23T21:02:43.000','3236','126','2005-08-30T23:37:43.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('16008','2005-08-23T21:04:51.000','3273','189','2005-08-31T22:09:51.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('16009','2005-08-23T21:07:59.000','3055','133','2005-08-29T16:54:59.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('16010','2005-08-23T21:10:24.000','2539','173','2005-08-25T17:58:24.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('16011','2005-08-23T21:11:33.000','1093','389','2005-08-31T17:51:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('16012','2005-08-23T21:13:39.000','2421','80','2005-08-30T23:52:39.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('16013','2005-08-23T21:17:17.000','561','462','2005-08-26T21:15:17.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('16014','2005-08-23T21:18:31.000','3322','532','2005-08-31T17:28:31.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('16015','2005-08-23T21:25:03.000','3113','50','2005-08-24T20:05:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('16016','2005-08-23T21:26:35.000','3374','595','2005-08-28T16:06:35.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('16017','2005-08-23T21:27:11.000','664','535','2005-08-24T23:22:11.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('16018','2005-08-23T21:27:35.000','897','439','2005-08-30T00:36:35.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('16019','2005-08-23T21:30:45.000','3093','278','2005-08-27T23:45:45.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('16020','2005-08-23T21:34:33.000','277','311','2005-09-01T18:17:33.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('16021','2005-08-23T21:37:59.000','3057','314','2005-08-31T01:52:59.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('16022','2005-08-23T21:44:27.000','2925','504','2005-08-28T01:52:27.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('16023','2005-08-23T21:45:02.000','2347','124','2005-08-24T21:28:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('16024','2005-08-23T21:46:47.000','2910','473','2005-08-27T02:06:47.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('16025','2005-08-23T21:48:54.000','1777','569','2005-08-24T22:05:54.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('16026','2005-08-23T21:49:22.000','467','484','2005-08-27T00:47:22.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('16027','2005-08-23T21:49:33.000','1724','160','2005-08-30T16:19:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('16028','2005-08-23T21:52:56.000','2515','119','2005-08-30T18:16:56.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('16029','2005-08-23T21:54:02.000','953','143','2005-08-29T23:55:02.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('16030','2005-08-23T21:56:04.000','4161','137','2005-08-31T01:24:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('16031','2005-08-23T21:59:26.000','1843','102','2005-08-29T20:15:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('16032','2005-08-23T21:59:57.000','2527','447','2005-08-31T22:46:57.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('16033','2005-08-23T22:06:15.000','760','226','2005-09-01T02:36:15.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('16034','2005-08-23T22:06:34.000','655','502','2005-08-29T18:44:34.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('16035','2005-08-23T22:08:04.000','549','37','2005-08-28T03:46:04.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('16036','2005-08-23T22:12:44.000','1372','425','2005-08-25T17:48:44.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('16037','2005-08-23T22:13:04.000','341','45','2005-09-01T02:48:04.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('16038','2005-08-23T22:14:31.000','2612','172','2005-08-30T03:28:31.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('16039','2005-08-23T22:18:51.000','545','78','2005-08-31T19:55:51.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('16040','2005-08-23T22:19:33.000','3524','195','2005-09-02T02:19:33.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('16041','2005-08-23T22:20:26.000','4116','121','2005-08-25T20:14:26.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('16042','2005-08-23T22:20:40.000','629','131','2005-08-24T17:54:40.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('16043','2005-08-23T22:21:03.000','3869','526','2005-08-31T03:09:03.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('16044','2005-08-23T22:24:39.000','1312','468','2005-08-25T04:08:39.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('16045','2005-08-23T22:25:26.000','772','14','2005-08-25T23:54:26.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('16046','2005-08-23T22:26:47.000','4364','74','2005-08-27T18:02:47.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('16047','2005-08-23T22:42:48.000','2088','114','2005-08-25T02:48:48.000','2','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('16048','2005-08-23T22:43:07.000','2019','103','2005-08-31T21:33:07.000','1','2006-02-15T21:30:53.000')
;
Insert into rental
 (rental_id,rental_date,inventory_id,customer_id,return_date,staff_id,last_update)
Values
('16049','2005-08-23T22:50:12.000','2666','393','2005-08-30T01:01:12.000','2','2006-02-15T21:30:53.000')
;

SET IDENTITY_INSERT rental OFF

-- End of Script
--
--
-- Automatically generated by Advanced ETl Processor
-- http://www.etl-tools.com/
-- table country
-- Start of script

SET IDENTITY_INSERT payment ON

Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1','1','1','76','2.99','2005-05-25T11:30:37.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2','1','1','573','0.99','2005-05-28T10:35:23.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3','1','1','1185','5.99','2005-06-15T00:54:12.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4','1','2','1422','0.99','2005-06-15T18:02:53.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5','1','2','1476','9.99','2005-06-15T21:08:46.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6','1','1','1725','4.99','2005-06-16T15:18:57.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7','1','1','2308','4.99','2005-06-18T08:41:48.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8','1','2','2363','0.99','2005-06-18T13:33:59.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9','1','1','3284','3.99','2005-06-21T06:24:45.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10','1','2','4526','5.99','2005-07-08T03:17:05.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11','1','1','4611','5.99','2005-07-08T07:33:56.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12','1','1','5244','4.99','2005-07-09T13:24:07.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13','1','1','5326','4.99','2005-07-09T16:38:01.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14','1','1','6163','7.99','2005-07-11T10:13:46.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15','1','2','7273','2.99','2005-07-27T11:31:22.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('16','1','1','7841','4.99','2005-07-28T09:04:45.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('17','1','2','8033','4.99','2005-07-28T16:18:23.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('18','1','1','8074','0.99','2005-07-28T17:33:39.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('19','1','2','8116','0.99','2005-07-28T19:20:07.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('20','1','2','8326','2.99','2005-07-29T03:58:49.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('21','1','2','9571','2.99','2005-07-31T02:42:18.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('22','1','2','10437','4.99','2005-08-01T08:51:04.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('23','1','2','11299','3.99','2005-08-02T15:36:52.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('24','1','1','11367','0.99','2005-08-02T18:01:38.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('25','1','2','11824','4.99','2005-08-17T12:37:54.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('26','1','1','12250','0.99','2005-08-18T03:57:29.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('27','1','2','13068','0.99','2005-08-19T09:55:16.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('28','1','2','13176','2.99','2005-08-19T13:56:54.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('29','1','1','14762','0.99','2005-08-21T23:33:57.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('30','1','1','14825','1.99','2005-08-22T01:27:57.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('31','1','2','15298','2.99','2005-08-22T19:41:37.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('32','1','1','15315','5.99','2005-08-22T20:03:46.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('33','2','1','320','4.99','2005-05-27T00:09:24.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('34','2','1','2128','2.99','2005-06-17T20:54:58.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('35','2','1','5636','2.99','2005-07-10T06:31:24.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('36','2','1','5755','6.99','2005-07-10T12:38:56.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('37','2','2','7346','4.99','2005-07-27T14:30:42.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('38','2','1','7376','5.99','2005-07-27T15:23:02.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('39','2','2','7459','5.99','2005-07-27T18:40:20.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('40','2','2','8230','5.99','2005-07-29T00:12:59.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('41','2','1','8598','2.99','2005-07-29T12:56:59.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('42','2','2','8705','5.99','2005-07-29T17:14:29.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('43','2','1','9031','4.99','2005-07-30T06:06:10.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('44','2','2','9236','10.99','2005-07-30T13:47:43.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('45','2','2','9248','0.99','2005-07-30T14:14:11.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('46','2','2','9296','6.99','2005-07-30T16:21:13.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('47','2','2','9465','6.99','2005-07-30T22:39:53.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('48','2','1','10136','2.99','2005-07-31T21:58:56.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('49','2','1','10466','0.99','2005-08-01T09:45:26.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('50','2','1','10918','0.99','2005-08-02T02:10:56.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('51','2','1','11087','5.99','2005-08-02T07:41:41.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('52','2','1','11177','6.99','2005-08-02T10:43:48.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('53','2','2','11256','2.99','2005-08-02T13:44:53.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('54','2','1','11614','2.99','2005-08-17T03:52:18.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('55','2','1','12963','2.99','2005-08-19T06:26:04.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('56','2','1','14475','4.99','2005-08-21T13:24:32.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('57','2','2','14743','5.99','2005-08-21T22:41:56.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('58','2','2','15145','4.99','2005-08-22T13:53:04.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('59','2','2','15907','4.99','2005-08-23T17:39:35.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('60','3','1','435','1.99','2005-05-27T17:17:09.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('61','3','1','830','2.99','2005-05-29T22:43:55.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('62','3','1','1546','8.99','2005-06-16T01:34:05.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('63','3','1','1726','6.99','2005-06-16T15:19:10.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('64','3','2','1911','6.99','2005-06-17T05:15:15.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('65','3','1','2628','2.99','2005-06-19T08:34:53.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('66','3','1','4180','4.99','2005-07-07T10:23:25.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('67','3','1','4725','4.99','2005-07-08T12:47:11.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('68','3','1','7096','5.99','2005-07-27T04:54:42.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('69','3','2','7503','10.99','2005-07-27T20:23:12.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('70','3','2','7703','7.99','2005-07-28T03:59:21.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('71','3','2','7724','6.99','2005-07-28T04:46:30.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('72','3','1','7911','4.99','2005-07-28T11:46:45.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('73','3','2','8086','4.99','2005-07-28T18:17:14.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('74','3','1','8545','2.99','2005-07-29T11:07:04.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('75','3','1','9226','1.99','2005-07-30T13:31:20.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('76','3','2','9443','3.99','2005-07-30T21:45:46.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('77','3','1','9595','2.99','2005-07-31T03:27:58.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('78','3','2','9816','4.99','2005-07-31T11:32:58.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('79','3','2','10597','5.99','2005-08-01T14:19:48.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('80','3','2','12556','4.99','2005-08-18T14:49:55.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('81','3','1','13403','8.99','2005-08-19T22:18:07.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('82','3','2','13610','2.99','2005-08-20T06:14:12.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('83','3','2','14699','8.99','2005-08-21T20:50:48.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('84','3','2','15038','0.99','2005-08-22T09:37:27.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('85','3','1','15619','2.99','2005-08-23T07:10:14.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('86','4','1','1297','4.99','2005-06-15T09:31:28.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('87','4','1','1633','0.99','2005-06-16T08:08:40.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('88','4','2','1707','2.99','2005-06-16T14:01:27.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('89','4','2','1735','0.99','2005-06-16T15:51:52.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('90','4','2','2043','0.99','2005-06-17T14:31:12.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('91','4','1','2642','5.99','2005-06-19T09:39:01.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('92','4','1','7660','2.99','2005-07-28T02:10:10.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('93','4','2','7718','2.99','2005-07-28T04:37:59.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('94','4','1','8741','3.99','2005-07-29T18:44:57.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('95','4','1','9100','5.99','2005-07-30T08:46:09.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('96','4','1','9371','5.99','2005-07-30T18:58:00.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('97','4','2','11069','0.99','2005-08-02T07:09:34.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('98','4','1','11110','2.99','2005-08-02T08:20:31.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('99','4','2','11529','4.99','2005-08-17T00:28:01.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('100','4','1','12151','2.99','2005-08-18T00:14:03.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('101','4','2','12294','8.99','2005-08-18T05:14:44.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('102','4','2','12856','1.99','2005-08-19T02:19:13.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('103','4','1','13704','2.99','2005-08-20T09:32:04.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('104','4','1','13807','6.99','2005-08-20T12:55:40.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('105','4','2','14225','4.99','2005-08-21T04:53:37.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('106','4','1','15147','2.99','2005-08-22T13:58:23.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('107','4','2','15635','1.99','2005-08-23T07:43:00.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('108','5','1','731','0.99','2005-05-29T07:25:16.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('109','5','1','1085','6.99','2005-05-31T11:15:43.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('110','5','1','1142','1.99','2005-05-31T19:46:38.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('111','5','1','1502','3.99','2005-06-15T22:03:14.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('112','5','2','1631','2.99','2005-06-16T08:01:02.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('113','5','2','2063','4.99','2005-06-17T15:56:53.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('114','5','2','2570','2.99','2005-06-19T04:20:13.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('115','5','2','3126','4.99','2005-06-20T18:38:22.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('116','5','2','3677','4.99','2005-07-06T09:11:58.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('117','5','2','4889','2.99','2005-07-08T20:04:43.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('118','5','1','5016','4.99','2005-07-09T01:57:57.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('119','5','2','5118','5.99','2005-07-09T07:13:52.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('120','5','2','5156','1.99','2005-07-09T08:51:42.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('121','5','2','5721','0.99','2005-07-10T11:09:35.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('122','5','1','6042','8.99','2005-07-11T03:17:04.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('123','5','1','6663','3.99','2005-07-12T11:27:35.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('124','5','2','6685','4.99','2005-07-12T12:16:28.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('125','5','2','7293','0.99','2005-07-27T12:37:28.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('126','5','2','7652','0.99','2005-07-28T01:50:29.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('127','5','2','7829','3.99','2005-07-28T08:43:39.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('128','5','1','8263','2.99','2005-07-29T01:11:23.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('129','5','1','8978','1.99','2005-07-30T04:14:28.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('130','5','1','9493','4.99','2005-07-30T23:52:30.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('131','5','1','9888','3.99','2005-07-31T14:00:53.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('132','5','2','10609','4.99','2005-08-01T14:48:45.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('133','5','1','10625','0.99','2005-08-01T15:27:10.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('134','5','2','11001','4.99','2005-08-02T04:56:45.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('135','5','1','11179','4.99','2005-08-02T10:50:06.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('136','5','2','11930','3.99','2005-08-17T16:28:53.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('137','5','1','12145','9.99','2005-08-18T00:10:04.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('138','5','1','12797','2.99','2005-08-19T00:24:08.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('139','5','1','13063','1.99','2005-08-19T09:45:41.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('140','5','2','13877','0.99','2005-08-20T15:16:18.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('141','5','2','14053','6.99','2005-08-20T22:13:59.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('142','5','1','14430','6.99','2005-08-21T11:31:11.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('143','5','2','14494','2.99','2005-08-21T14:02:50.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('144','5','2','15232','0.99','2005-08-22T17:37:02.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('145','5','2','13209','0.99','2006-02-14T15:16:03.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('146','6','2','57','4.99','2005-05-25T08:43:32.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('147','6','1','577','2.99','2005-05-28T11:09:14.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('148','6','2','916','0.99','2005-05-30T11:25:01.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('149','6','1','1575','3.99','2005-06-16T03:41:38.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('150','6','2','1841','2.99','2005-06-16T23:44:13.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('151','6','1','1966','0.99','2005-06-17T09:19:45.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('152','6','1','2345','0.99','2005-06-18T12:03:23.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('153','6','2','3983','0.99','2005-07-06T23:14:21.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('154','6','2','4278','2.99','2005-07-07T14:53:24.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('155','6','1','5553','0.99','2005-07-10T03:03:35.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('156','6','2','6211','5.99','2005-07-11T12:39:01.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('157','6','1','6248','7.99','2005-07-11T15:01:54.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('158','6','2','6686','0.99','2005-07-12T12:18:38.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('159','6','2','7099','2.99','2005-07-27T05:03:44.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('160','6','2','7136','2.99','2005-07-27T06:38:25.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('161','6','1','8101','0.99','2005-07-28T18:47:23.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('162','6','1','10271','2.99','2005-08-01T03:13:39.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('163','6','1','11023','2.99','2005-08-02T05:36:38.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('164','6','1','11398','3.99','2005-08-02T18:55:15.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('165','6','1','11591','6.99','2005-08-17T02:29:41.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('166','6','1','11727','0.99','2005-08-17T08:12:20.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('167','6','1','11853','0.99','2005-08-17T13:39:32.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('168','6','2','12254','2.99','2005-08-18T04:05:29.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('169','6','2','13451','6.99','2005-08-20T00:18:25.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('170','6','1','14329','7.99','2005-08-21T08:22:56.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('171','6','1','14377','4.99','2005-08-21T09:49:28.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('172','6','1','15509','5.99','2005-08-23T02:51:24.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('173','6','2','15603','0.99','2005-08-23T06:41:32.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('174','7','2','46','5.99','2005-05-25T06:04:08.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('175','7','2','117','0.99','2005-05-25T19:30:46.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('176','7','2','748','2.99','2005-05-29T09:27:00.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('177','7','1','975','4.99','2005-05-30T21:07:15.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('178','7','1','1063','5.99','2005-05-31T08:44:29.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('179','7','2','1810','0.99','2005-06-16T21:06:00.000','2006-02-15T22:12:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('180','7','1','2250','2.99','2005-06-18T05:03:36.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('181','7','1','2709','0.99','2005-06-19T14:00:26.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('182','7','1','2888','4.99','2005-06-20T01:50:56.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('183','7','1','3007','0.99','2005-06-20T10:11:53.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('184','7','2','3639','5.99','2005-07-06T07:09:17.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('185','7','2','4238','2.99','2005-07-07T13:22:20.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('186','7','2','4787','5.99','2005-07-08T16:16:04.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('187','7','1','4856','4.99','2005-07-08T18:47:38.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('188','7','1','5441','8.99','2005-07-09T21:52:05.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('189','7','1','5921','7.99','2005-07-10T21:35:12.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('190','7','1','6174','1.99','2005-07-11T10:36:28.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('191','7','1','6295','2.99','2005-07-11T17:30:58.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('192','7','2','6761','3.99','2005-07-12T15:17:42.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('193','7','2','8422','5.99','2005-07-29T07:02:55.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('194','7','2','9624','7.99','2005-07-31T04:30:03.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('195','7','2','10330','6.99','2005-08-01T04:57:04.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('196','7','1','10423','5.99','2005-08-01T08:19:53.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('197','7','1','10514','4.99','2005-08-01T11:39:26.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('198','7','2','10644','4.99','2005-08-01T15:52:00.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('199','7','2','10989','3.99','2005-08-02T04:40:54.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('200','7','2','11542','7.99','2005-08-17T00:51:32.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('201','7','1','12367','8.99','2005-08-18T07:57:14.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('202','7','1','12730','2.99','2005-08-18T21:55:01.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('203','7','2','13373','2.99','2005-08-19T21:23:31.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('204','7','1','13476','2.99','2005-08-20T01:06:04.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('205','7','1','13594','0.99','2005-08-20T05:53:31.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('206','7','1','14222','5.99','2005-08-21T04:49:48.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('207','8','2','866','6.99','2005-05-30T03:43:54.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('208','8','2','1305','2.99','2005-06-15T09:59:16.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('209','8','1','2095','5.99','2005-06-17T18:21:35.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('210','8','2','3114','4.99','2005-06-20T17:57:47.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('211','8','1','3475','5.99','2005-07-05T23:01:21.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('212','8','1','4003','0.99','2005-07-07T00:09:02.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('213','8','2','4175','2.99','2005-07-07T10:02:03.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('214','8','2','4409','3.99','2005-07-07T21:47:29.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('215','8','1','4503','3.99','2005-07-08T02:17:12.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('216','8','1','5300','2.99','2005-07-09T15:40:46.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('217','8','2','5341','2.99','2005-07-09T17:13:23.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('218','8','1','6375','4.99','2005-07-11T21:39:46.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('219','8','1','6647','0.99','2005-07-12T10:43:53.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('220','8','1','8809','1.99','2005-07-29T21:42:49.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('221','8','2','9629','2.99','2005-07-31T04:54:43.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('222','8','2','10141','0.99','2005-07-31T22:08:29.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('223','8','2','10561','2.99','2005-08-01T13:05:35.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('224','8','1','11232','9.99','2005-08-02T13:04:12.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('225','8','2','11284','2.99','2005-08-02T14:42:45.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('226','8','1','12613','2.99','2005-08-18T17:16:01.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('227','8','1','14114','0.99','2005-08-21T01:07:11.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('228','8','1','15374','7.99','2005-08-22T22:09:09.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('229','8','1','15764','2.99','2005-08-23T13:05:10.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('230','8','1','15805','4.99','2005-08-23T14:31:19.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('231','9','2','350','4.99','2005-05-27T05:01:28.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('232','9','2','877','0.99','2005-05-30T05:48:59.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('233','9','2','1075','4.99','2005-05-31T10:13:34.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('234','9','2','3142','7.99','2005-06-20T19:59:28.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('235','9','2','3262','4.99','2005-06-21T04:08:43.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('236','9','1','4454','2.99','2005-07-07T23:37:00.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('237','9','2','4748','0.99','2005-07-08T13:59:38.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('238','9','1','4796','1.99','2005-07-08T16:35:44.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('239','9','1','5659','2.99','2005-07-10T07:45:40.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('240','9','2','6019','4.99','2005-07-11T02:08:29.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('241','9','1','6165','5.99','2005-07-11T10:17:29.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('242','9','2','7616','0.99','2005-07-28T00:15:26.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('243','9','1','7801','2.99','2005-07-28T07:51:56.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('244','9','1','9043','4.99','2005-07-30T06:34:07.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('245','9','1','10451','0.99','2005-08-01T09:11:25.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('246','9','1','10454','4.99','2005-08-01T09:14:00.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('247','9','2','11400','5.99','2005-08-02T19:00:52.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('248','9','1','11556','0.99','2005-08-17T01:11:53.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('249','9','1','12228','2.99','2005-08-18T03:08:10.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('250','9','1','12309','2.99','2005-08-18T05:58:40.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('251','9','2','12652','4.99','2005-08-18T18:48:58.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('252','9','2','14489','7.99','2005-08-21T13:53:59.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('253','9','1','15813','4.99','2006-02-14T15:16:03.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('254','10','2','1140','4.99','2005-05-31T19:36:30.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('255','10','1','1801','4.99','2005-06-16T20:21:53.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('256','10','1','1995','4.99','2005-06-17T11:11:14.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('257','10','2','2222','3.99','2005-06-18T03:26:23.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('258','10','1','2814','0.99','2005-06-19T20:01:59.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('259','10','1','2865','0.99','2005-06-20T00:00:55.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('260','10','2','3790','3.99','2005-07-06T14:13:45.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('261','10','2','4042','4.99','2005-07-07T03:06:40.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('262','10','1','4255','1.99','2005-07-07T14:14:13.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('263','10','1','5038','7.99','2005-07-09T03:12:52.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('264','10','2','5068','2.99','2005-07-09T04:53:18.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('265','10','1','5444','0.99','2005-07-09T21:58:57.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('266','10','1','5905','2.99','2005-07-10T20:41:09.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('267','10','1','7738','2.99','2005-07-28T05:21:42.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('268','10','2','8001','6.99','2005-07-28T15:10:55.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('269','10','2','8188','4.99','2005-07-28T22:34:12.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('270','10','1','9935','4.99','2005-07-31T15:27:07.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('271','10','2','10671','8.99','2005-08-01T17:09:59.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('272','10','2','11289','2.99','2005-08-02T14:55:00.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('273','10','1','11405','0.99','2005-08-02T19:13:39.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('274','10','2','12031','2.99','2005-08-17T20:11:35.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('275','10','2','12400','2.99','2005-08-18T09:19:12.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('276','10','2','13316','4.99','2005-08-19T19:23:30.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('277','10','2','13917','2.99','2005-08-20T16:43:28.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('278','10','1','15370','5.99','2005-08-22T21:59:29.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('279','11','1','987','6.99','2005-05-30T22:59:12.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('280','11','1','1470','6.99','2005-06-15T20:53:07.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('281','11','1','1939','7.99','2005-06-17T07:26:45.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('282','11','1','3192','0.99','2005-06-20T23:49:12.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('283','11','2','4608','2.99','2005-07-08T07:19:11.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('284','11','1','4943','4.99','2005-07-08T22:43:05.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('285','11','2','5835','5.99','2005-07-10T16:44:58.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('286','11','2','6146','6.99','2005-07-11T09:09:59.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('287','11','1','7314','4.99','2005-07-27T13:13:32.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('288','11','1','8014','4.99','2005-07-28T15:32:07.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('289','11','2','8100','2.99','2005-07-28T18:43:11.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('290','11','2','8447','1.99','2005-07-29T07:38:14.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('291','11','1','8715','0.99','2005-07-29T17:33:45.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('292','11','1','8950','9.99','2005-07-30T03:17:13.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('293','11','2','9292','6.99','2005-07-30T16:08:21.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('294','11','1','10812','4.99','2005-08-01T22:41:16.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('295','11','2','11166','6.99','2005-08-02T10:14:58.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('296','11','2','11502','0.99','2005-08-16T23:06:30.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('297','11','2','12015','5.99','2005-08-17T19:32:44.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('298','11','2','13572','0.99','2005-08-20T05:07:27.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('299','11','1','13790','4.99','2005-08-20T12:17:27.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('300','11','1','15120','0.99','2005-08-22T12:42:47.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('301','11','2','15240','2.99','2005-08-22T17:46:41.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('302','11','1','11646','0.99','2006-02-14T15:16:03.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('303','12','1','988','4.99','2005-05-30T23:08:03.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('304','12','1','1084','4.99','2005-05-31T11:10:17.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('305','12','2','1752','5.99','2005-06-16T17:02:55.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('306','12','2','2434','5.99','2005-06-18T18:11:51.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('307','12','2','2500','5.99','2005-06-18T23:07:12.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('308','12','2','2623','4.99','2005-06-19T08:11:51.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('309','12','2','3135','2.99','2005-06-20T19:33:52.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('310','12','1','3411','0.99','2005-06-21T16:31:27.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('311','12','1','3870','3.99','2005-07-06T17:57:54.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('312','12','1','5071','0.99','2005-07-09T05:00:39.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('313','12','1','5074','0.99','2005-07-09T05:06:24.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('314','12','2','5111','0.99','2005-07-09T07:02:19.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('315','12','2','5242','3.99','2005-07-09T13:20:25.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('316','12','1','6773','2.99','2005-07-12T15:55:39.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('317','12','2','7008','0.99','2005-07-27T01:44:03.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('318','12','2','7279','0.99','2005-07-27T11:50:47.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('319','12','2','8985','0.99','2005-07-30T04:34:51.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('320','12','2','9166','4.99','2005-07-30T11:26:28.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('321','12','2','9238','5.99','2005-07-30T13:49:43.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('322','12','1','9627','5.99','2005-07-31T04:42:46.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('323','12','2','9708','5.99','2005-07-31T07:45:33.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('324','12','2','10392','10.99','2005-08-01T06:50:26.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('325','12','2','11497','0.99','2005-08-16T22:52:30.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('326','12','1','12604','4.99','2005-08-18T16:58:48.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('327','12','2','13519','0.99','2005-08-20T02:37:07.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('328','12','2','13895','2.99','2005-08-20T15:58:28.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('329','12','2','14240','4.99','2005-08-21T05:19:39.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('330','12','1','15993','0.99','2005-08-23T20:28:44.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('331','13','1','1933','2.99','2005-06-17T06:54:42.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('332','13','1','2209','4.99','2005-06-18T02:24:01.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('333','13','1','2952','2.99','2005-06-20T06:26:57.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('334','13','1','3047','8.99','2005-06-20T12:45:33.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('335','13','2','3946','2.99','2005-07-06T21:39:24.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('336','13','1','6118','8.99','2005-07-11T07:43:08.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('337','13','1','6568','2.99','2005-07-12T05:45:47.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('338','13','1','6870','0.99','2005-07-12T20:13:45.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('339','13','1','6897','2.99','2005-07-12T21:30:41.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('340','13','1','7916','2.99','2005-07-28T11:49:53.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('341','13','1','8277','2.99','2005-07-29T01:38:53.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('342','13','2','8831','11.99','2005-07-29T22:37:41.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('343','13','2','9260','9.99','2005-07-30T14:38:22.000','2006-02-15T22:12:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('344','13','2','9434','0.99','2005-07-30T21:29:41.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('345','13','1','9664','0.99','2005-07-31T06:12:08.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('346','13','1','9736','7.99','2005-07-31T08:58:40.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('347','13','1','10003','4.99','2005-07-31T17:48:51.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('348','13','1','11292','4.99','2005-08-02T14:58:41.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('349','13','2','11315','0.99','2005-08-02T16:05:17.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('350','13','2','11761','5.99','2005-08-17T09:44:59.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('351','13','2','12918','7.99','2005-08-19T04:31:36.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('352','13','2','13096','4.99','2005-08-19T10:49:03.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('353','13','2','13213','0.99','2005-08-19T15:25:48.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('354','13','1','13456','0.99','2005-08-20T00:33:19.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('355','13','1','14252','9.99','2005-08-21T05:44:07.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('356','13','2','14545','7.99','2005-08-21T15:44:23.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('357','13','1','15338','4.99','2005-08-22T20:51:24.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('358','14','1','151','0.99','2005-05-26T00:37:28.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('359','14','1','346','9.99','2005-05-27T04:34:41.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('360','14','1','525','5.99','2005-05-28T04:25:33.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('361','14','1','671','2.99','2005-05-28T22:04:30.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('362','14','2','815','0.99','2005-05-29T20:24:28.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('363','14','2','1360','4.99','2005-06-15T13:32:15.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('364','14','1','3707','2.99','2005-07-06T10:21:49.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('365','14','1','4952','0.99','2005-07-08T23:00:07.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('366','14','1','5104','0.99','2005-07-09T06:37:07.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('367','14','2','5317','7.99','2005-07-09T16:10:25.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('368','14','1','5383','4.99','2005-07-09T19:14:32.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('369','14','1','5565','7.99','2005-07-10T03:29:48.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('370','14','1','8035','6.99','2005-07-28T16:23:01.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('371','14','1','8042','0.99','2005-07-28T16:45:11.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('372','14','1','8548','3.99','2005-07-29T11:11:33.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('373','14','2','8836','4.99','2005-07-29T22:46:08.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('374','14','2','9438','4.99','2005-07-30T21:36:15.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('375','14','1','9592','2.99','2005-07-31T03:21:16.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('376','14','1','10348','2.99','2005-08-01T05:23:00.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('377','14','2','10526','6.99','2005-08-01T11:55:33.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('378','14','1','11480','4.99','2005-08-02T22:18:24.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('379','14','2','11528','3.99','2005-08-17T00:27:23.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('380','14','1','12668','2.99','2005-08-18T19:16:47.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('381','14','1','13757','4.99','2005-08-20T11:20:12.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('382','14','2','15015','6.99','2005-08-22T08:43:50.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('383','14','1','15373','0.99','2005-08-22T22:08:11.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('384','14','1','16045','0.99','2005-08-23T22:25:26.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('385','14','1','13780','4.99','2006-02-14T15:16:03.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('386','15','1','2486','2.99','2005-06-18T21:26:56.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('387','15','1','2937','5.99','2005-06-20T05:15:37.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('388','15','2','3182','0.99','2005-06-20T22:52:18.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('389','15','1','3550','7.99','2005-07-06T02:29:21.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('390','15','1','4127','5.99','2005-07-07T07:26:19.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('391','15','1','5717','2.99','2005-07-10T11:02:03.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('392','15','2','5975','2.99','2005-07-11T00:14:19.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('393','15','1','7105','4.99','2005-07-27T05:15:37.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('394','15','1','8193','0.99','2005-07-28T22:50:50.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('395','15','2','8615','6.99','2005-07-29T13:36:01.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('396','15','2','8927','4.99','2005-07-30T02:13:31.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('397','15','1','9987','2.99','2005-07-31T17:22:35.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('398','15','1','11118','2.99','2005-08-02T08:44:18.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('399','15','1','11141','2.99','2005-08-02T09:29:11.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('400','15','2','11307','2.99','2005-08-02T15:48:08.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('401','15','2','11341','2.99','2005-08-02T17:09:24.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('402','15','1','11922','7.99','2005-08-17T16:20:37.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('403','15','2','12272','2.99','2005-08-18T04:39:10.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('404','15','2','12551','2.99','2005-08-18T14:46:26.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('405','15','1','12635','2.99','2005-08-18T18:00:23.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('406','15','2','13339','8.99','2005-08-19T20:18:36.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('407','15','1','13393','5.99','2005-08-19T22:03:46.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('408','15','2','13503','5.99','2005-08-20T02:00:33.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('409','15','1','13541','4.99','2005-08-20T03:41:41.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('410','15','2','13677','3.99','2005-08-20T08:34:41.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('411','15','2','14569','0.99','2005-08-21T16:31:22.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('412','15','2','14776','4.99','2005-08-21T23:53:35.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('413','15','2','14872','8.99','2005-08-22T03:23:41.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('414','15','1','15178','0.99','2005-08-22T15:36:04.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('415','15','1','15897','4.99','2005-08-23T17:12:31.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('416','15','1','13798','3.98','2006-02-14T15:16:03.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('417','15','2','13968','0','2006-02-14T15:16:03.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('418','16','1','335','3.99','2005-05-27T03:07:10.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('419','16','1','593','2.99','2005-05-28T13:33:23.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('420','16','2','887','0.99','2005-05-30T07:10:00.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('421','16','1','1017','2.99','2005-05-31T02:53:36.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('422','16','2','1934','6.99','2005-06-17T07:04:57.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('423','16','1','1944','7.99','2005-06-17T07:50:53.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('424','16','1',NULL,'1.99','2005-06-18T04:56:12.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('425','16','1','2960','7.99','2005-06-20T07:10:09.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('426','16','2','3348','0.99','2005-06-21T11:16:42.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('427','16','1','3548','0.99','2005-07-06T02:23:39.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('428','16','2','4219','2.99','2005-07-07T12:11:22.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('429','16','2','4263','3.99','2005-07-07T14:24:44.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('430','16','2','4517','4.99','2005-07-08T02:45:19.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('431','16','1','6100','4.99','2005-07-11T06:40:31.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('432','16','2','7489','0.99','2005-07-27T19:39:38.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('433','16','2','7552','2.99','2005-07-27T22:03:41.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('434','16','2','8452','5.99','2005-07-29T07:45:00.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('435','16','2','9158','0.99','2005-07-30T11:12:03.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('436','16','2','9610','5.99','2005-07-31T03:54:05.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('437','16','2','10687','2.99','2005-08-01T17:53:02.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('438','16','2','10727','2.99','2005-08-01T19:15:08.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('439','16','2','11308','0.99','2005-08-02T15:50:44.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('440','16','2','12104','2.99','2005-08-17T22:53:00.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('441','16','1','12358','4.99','2005-08-18T07:41:43.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('442','16','1','12577','7.99','2005-08-18T15:39:46.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('443','16','2','13151','4.99','2005-08-19T13:08:23.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('444','16','1','13391','4.99','2005-08-19T22:01:42.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('445','16','1','13480','6.99','2005-08-20T01:10:27.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('446','16','1','14511','8.99','2005-08-21T14:45:34.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('447','17','2','287','2.99','2005-05-26T19:44:54.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('448','17','1','580','2.99','2005-05-28T11:19:53.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('449','17','2','884','4.99','2005-05-30T06:41:32.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('450','17','2','2175','5.99','2005-06-18T00:17:58.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('451','17','1','2684','8.99','2005-06-19T12:29:08.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('452','17','2','3269','5.99','2005-06-21T05:06:30.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('453','17','1','5714','3.99','2005-07-10T10:46:57.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('454','17','1','5883','3.99','2005-07-10T19:25:21.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('455','17','2','6884','1.99','2005-07-12T20:52:41.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('456','17','2','8076','8.99','2005-07-28T17:45:58.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('457','17','1','8213','2.99','2005-07-28T23:37:33.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('458','17','2','9092','8.99','2005-07-30T08:30:56.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('459','17','1','9138','2.99','2005-07-30T10:11:52.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('460','17','2','9382','8.99','2005-07-30T19:23:44.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('461','17','1','9489','0.99','2005-07-30T23:43:32.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('462','17','2','11990','4.99','2005-08-17T18:26:22.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('463','17','1','13732','2.99','2005-08-20T10:24:41.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('464','17','1','14040','2.99','2005-08-20T21:43:44.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('465','17','2','14326','2.99','2005-08-21T08:15:41.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('466','17','1','14346','2.99','2005-08-21T08:42:26.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('467','17','2','15752','5.99','2005-08-23T12:41:38.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('468','18','1','50','2.99','2005-05-25T06:44:53.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('469','18','1','116','4.99','2005-05-25T19:27:51.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('470','18','1','692','4.99','2005-05-29T01:32:10.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('471','18','2','1451','5.99','2005-06-15T19:30:18.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('472','18','2','1783','4.99','2005-06-16T19:23:23.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('473','18','2','2112','5.99','2005-06-17T19:52:42.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('474','18','1','2990','8.99','2005-06-20T09:02:51.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('475','18','2','4672','3.99','2005-07-08T10:15:38.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('476','18','2','4724','3.99','2005-07-08T12:46:30.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('477','18','2','4923','3.99','2005-07-08T21:44:39.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('478','18','2','6128','2.99','2005-07-11T08:15:08.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('479','18','1','6846','0.99','2005-07-12T19:20:45.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('480','18','2','8122','2.99','2005-07-28T19:27:37.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('481','18','1','8555','4.99','2005-07-29T11:18:01.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('482','18','1','9036','4.99','2005-07-30T06:18:38.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('483','18','2','9114','4.99','2005-07-30T09:13:21.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('484','18','1','10682','4.99','2005-08-01T17:32:53.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('485','18','2','10721','1.99','2005-08-01T19:05:18.000','2006-02-15T22:12:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('486','18','2','11094','4.99','2005-08-02T08:03:02.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('487','18','2','11439','4.99','2005-08-02T20:22:45.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('488','18','2','12333','0.99','2005-08-18T06:51:39.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('489','18','2','13490','0.99','2005-08-20T01:29:29.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('490','19','2','18','0.99','2005-05-25T01:10:47.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('491','19','2','110','9.99','2005-05-25T18:43:49.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('492','19','1','179','6.99','2005-05-26T04:26:06.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('493','19','1','337','2.99','2005-05-27T03:22:30.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('494','19','2','591','2.99','2005-05-28T13:11:04.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('495','19','2','696','2.99','2005-05-29T01:59:10.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('496','19','1','2657','2.99','2005-06-19T10:42:59.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('497','19','1','2848','2.99','2005-06-19T22:55:37.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('498','19','2','3423','2.99','2005-06-21T17:38:02.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('499','19','2','3549','4.99','2005-07-06T02:24:55.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('500','19','2','6495','4.99','2005-07-12T02:57:02.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('501','19','1','9157','5.99','2005-07-30T11:06:23.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('502','19','1','9256','0.99','2005-07-30T14:29:29.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('503','19','2','10077','9.99','2005-07-31T20:01:06.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('504','19','1','10176','7.99','2005-07-31T23:40:35.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('505','19','2','11508','8.99','2005-08-16T23:27:36.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('506','19','1','11869','5.99','2005-08-17T14:10:22.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('507','19','1','12211','9.99','2005-08-18T02:31:18.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('508','19','2','12357','2.99','2005-08-18T07:40:52.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('509','19','1','13718','8.99','2005-08-20T09:53:44.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('510','19','2','13804','8.99','2005-08-20T12:46:32.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('511','19','1','14101','4.99','2005-08-21T00:33:03.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('512','19','1','15047','2.99','2005-08-22T09:57:16.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('513','19','2','15529','0.99','2005-08-23T03:46:47.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('514','20','2','202','2.99','2005-05-26T07:27:36.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('515','20','2','497','6.99','2005-05-28T00:54:39.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('516','20','2','546','1.99','2005-05-28T07:16:25.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('517','20','2','1558','0.99','2005-06-16T02:33:53.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('518','20','2','2136','3.99','2005-06-17T21:16:41.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('519','20','2','2343','4.99','2005-06-18T11:46:26.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('520','20','1','3350','4.99','2005-06-21T11:21:38.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('521','20','2','4011','3.99','2005-07-07T00:48:25.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('522','20','1','4407','2.99','2005-07-07T21:39:45.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('523','20','1','5718','2.99','2005-07-10T11:03:20.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('524','20','1','6254','2.99','2005-07-11T15:10:18.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('525','20','2','6267','6.99','2005-07-11T15:53:00.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('526','20','2','7217','4.99','2005-07-27T09:31:44.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('527','20','2','7864','5.99','2005-07-28T10:06:10.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('528','20','2','8127','2.99','2005-07-28T19:45:19.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('529','20','2','9075','4.99','2005-07-30T07:55:14.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('530','20','2','9468','3.99','2005-07-30T22:53:52.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('531','20','2','10284','4.99','2005-08-01T03:33:19.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('532','20','1','10616','7.99','2005-08-01T14:59:50.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('533','20','1','10954','1.99','2005-08-02T03:30:24.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('534','20','1','11821','0.99','2005-08-17T12:27:55.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('535','20','1','12180','0.99','2005-08-18T01:28:15.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('536','20','2','13036','4.99','2005-08-19T08:48:37.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('537','20','1','13137','4.99','2005-08-19T12:26:32.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('538','20','2','13317','2.99','2005-08-19T19:25:42.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('539','20','2','14613','2.99','2005-08-21T18:03:20.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('540','20','2','15057','6.99','2005-08-22T10:19:58.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('541','20','1','15161','1.99','2005-08-22T14:37:22.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('542','20','2','15248','0.99','2005-08-22T17:53:06.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('543','20','1','15460','2.99','2005-08-23T01:10:42.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('544','21','1','260','3.99','2005-05-26T15:42:20.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('545','21','2','463','3.99','2005-05-27T20:11:47.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('546','21','1','570','0.99','2005-05-28T10:15:04.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('547','21','2','2235','7.99','2005-06-18T04:08:50.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('548','21','1','2268','4.99','2005-06-18T06:13:41.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('549','21','1','2393','2.99','2005-06-18T15:37:55.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('550','21','2','2830','4.99','2005-06-19T21:14:33.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('551','21','1','3212','10.99','2005-06-21T01:04:35.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('552','21','2','5107','4.99','2005-07-09T06:42:32.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('553','21','1','5772','3.99','2005-07-10T13:27:40.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('554','21','1','5961','2.99','2005-07-10T23:43:23.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('555','21','2','6943','1.99','2005-07-26T23:28:13.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('556','21','1','7994','0.99','2005-07-28T14:56:54.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('557','21','2','8196','6.99','2005-07-28T22:56:11.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('558','21','2','8862','2.99','2005-07-29T23:49:23.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('559','21','2','9149','0.99','2005-07-30T10:45:12.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('560','21','1','9699','5.99','2005-07-31T07:29:25.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('561','21','2','10570','4.99','2005-08-01T13:23:06.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('562','21','1','10734','0.99','2005-08-01T19:28:47.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('563','21','2','11072','0.99','2005-08-02T07:10:57.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('564','21','2','11970','0.99','2005-08-17T17:53:09.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('565','21','2','12131','2.99','2005-08-17T23:34:16.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('566','21','2','12660','4.99','2005-08-18T19:07:23.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('567','21','1','12774','6.99','2005-08-18T23:34:22.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('568','21','1','13381','2.99','2005-08-19T21:37:57.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('569','21','2','13399','4.99','2005-08-19T22:09:28.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('570','21','1','13411','4.99','2005-08-19T22:43:38.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('571','21','1','13463','8.99','2005-08-20T00:50:54.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('572','21','1','13699','9.99','2005-08-20T09:26:14.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('573','21','1','13740','4.99','2005-08-20T10:48:43.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('574','21','2','14077','8.99','2005-08-20T23:24:07.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('575','21','2','14161','2.99','2005-08-21T02:51:59.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('576','21','2','14446','2.99','2005-08-21T12:10:41.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('577','21','1','14869','4.99','2005-08-22T03:20:26.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('578','21','1','14933','2.99','2006-02-14T15:16:03.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('579','22','1','370','4.99','2005-05-27T07:49:43.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('580','22','1','556','4.99','2005-05-28T08:31:36.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('581','22','2','820','8.99','2005-05-29T21:07:22.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('582','22','1','3419','2.99','2005-06-21T17:18:01.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('583','22','2','4215','2.99','2005-07-07T12:00:52.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('584','22','1','5294','6.99','2005-07-09T15:23:42.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('585','22','1','5815','2.99','2005-07-10T15:48:19.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('586','22','1','7087','4.99','2005-07-27T04:42:08.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('587','22','1','7705','7.99','2005-07-28T04:02:58.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('588','22','2','9410','0.99','2005-07-30T20:38:05.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('589','22','1','9580','4.99','2005-07-31T03:01:11.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('590','22','1','12023','5.99','2005-08-17T19:54:54.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('591','22','1','12124','2.99','2005-08-17T23:22:46.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('592','22','2','12809','0.99','2005-08-19T00:42:24.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('593','22','2','13060','9.99','2005-08-19T09:43:25.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('594','22','1','14056','2.99','2005-08-20T22:18:53.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('595','22','1','14564','6.99','2005-08-21T16:24:43.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('596','22','1','15134','7.99','2005-08-22T13:18:25.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('597','22','1','15589','6.99','2005-08-23T06:03:31.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('598','22','1','15658','4.99','2005-08-23T08:48:43.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('599','22','1','15793','4.99','2005-08-23T14:06:19.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('600','22','1','12222','4.99','2006-02-14T15:16:03.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('601','23','1','129','8.99','2005-05-25T21:20:03.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('602','23','1','654','2.99','2005-05-28T20:15:30.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('603','23','2','1090','0.99','2005-05-31T12:03:44.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('604','23','1','2753','1.99','2005-06-19T16:44:35.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('605','23','1','2827','0.99','2005-06-19T20:50:01.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('606','23','1','3015','5.99','2005-06-20T10:48:56.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('607','23','1','3055','4.99','2005-06-20T13:19:58.000','2006-02-15T22:12:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('608','23','1','3461','2.99','2005-06-21T21:49:18.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('609','23','2','3736','3.99','2005-07-06T11:43:44.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('610','23','2','3781','2.99','2005-07-06T13:53:41.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('611','23','2','4853','2.99','2005-07-08T18:43:18.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('612','23','1','6213','2.99','2005-07-11T12:43:07.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('613','23','1','6238','2.99','2005-07-11T14:20:18.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('614','23','2','6917','5.99','2005-07-12T22:30:15.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('615','23','1','7155','7.99','2005-07-27T07:18:46.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('616','23','1','8015','2.99','2005-07-28T15:33:03.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('617','23','2','8718','0.99','2005-07-29T17:41:14.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('618','23','2','9209','5.99','2005-07-30T12:55:36.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('619','23','2','9255','9.99','2005-07-30T14:26:46.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('620','23','2','9718','3.99','2005-07-31T08:25:03.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('621','23','1','10132','6.99','2005-07-31T21:50:24.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('622','23','1','10898','2.99','2005-08-02T01:29:57.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('623','23','2','11501','2.99','2005-08-16T23:04:53.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('624','23','2','13290','2.99','2005-08-19T18:31:50.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('625','23','2','13331','4.99','2005-08-19T20:00:25.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('626','23','2','13429','6.99','2005-08-19T23:25:37.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('627','23','2','13511','0.99','2005-08-20T02:21:40.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('628','23','2','13557','0.99','2005-08-20T04:12:41.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('629','23','2','14482','2.99','2005-08-21T13:42:45.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('630','23','2','15532','2.99','2006-02-14T15:16:03.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('631','24','2','1007','6.99','2005-05-31T01:02:28.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('632','24','2','1077','2.99','2005-05-31T10:22:54.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('633','24','1','1716','2.99','2005-06-16T14:39:31.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('634','24','1','2070','2.99','2005-06-17T16:27:51.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('635','24','2','2116','4.99','2005-06-17T20:16:12.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('636','24','1','2451','5.99','2005-06-18T19:28:02.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('637','24','2','2963','7.99','2005-06-20T07:33:09.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('638','24','2','3649','7.99','2005-07-06T07:32:42.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('639','24','2','4378','2.99','2005-07-07T20:29:08.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('640','24','1','5310','0.99','2005-07-09T16:00:34.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('641','24','2','5648','0.99','2005-07-10T07:09:21.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('642','24','1','6855','4.99','2005-07-12T19:46:29.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('643','24','1','7266','1.99','2005-07-27T11:22:17.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('644','24','1','8947','4.99','2005-07-30T03:15:37.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('645','24','1','9723','0.99','2005-07-31T08:31:18.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('646','24','2','9925','0.99','2005-07-31T15:08:47.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('647','24','2','10491','2.99','2005-08-01T10:38:27.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('648','24','1','11209','2.99','2005-08-02T12:09:45.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('649','24','2','11546','2.99','2005-08-17T00:57:36.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('650','24','2','12165','8.99','2005-08-18T00:53:37.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('651','24','1','12745','2.99','2005-08-18T22:22:45.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('652','24','1','12999','1.99','2005-08-19T07:34:53.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('653','24','2','13058','4.99','2005-08-19T09:40:53.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('654','24','1','13247','0.99','2005-08-19T16:45:59.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('655','24','2','15357','4.99','2005-08-22T21:28:59.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('656','25','1','90','7.99','2005-05-25T14:31:25.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('657','25','2','1033','2.99','2005-05-31T04:50:07.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('658','25','1','1338','4.99','2005-06-15T12:17:34.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('659','25','1','1365','2.99','2005-06-15T14:09:55.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('660','25','2','1754','6.99','2005-06-16T17:13:23.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('661','25','2','2625','8.99','2005-06-19T08:23:11.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('662','25','1','2901','4.99','2005-06-20T02:41:28.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('663','25','1','3447','4.99','2005-06-21T20:53:31.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('664','25','1','4282','2.99','2005-07-07T15:26:31.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('665','25','1','4319','0.99','2005-07-07T17:50:27.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('666','25','2','4404','2.99','2005-07-07T21:31:53.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('667','25','1','5881','2.99','2005-07-10T19:19:43.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('668','25','1','6653','4.99','2005-07-12T11:06:17.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('669','25','2','6905','2.99','2005-07-12T22:02:18.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('670','25','2','8667','2.99','2005-07-29T15:40:57.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('671','25','2','8878','0.99','2005-07-30T00:15:57.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('672','25','1','9140','8.99','2005-07-30T10:12:01.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('673','25','2','9334','2.99','2005-07-30T17:56:38.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('674','25','2','9922','2.99','2005-07-31T14:59:37.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('675','25','2','10103','2.99','2005-07-31T20:49:13.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('676','25','1','10324','5.99','2005-08-01T04:49:06.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('677','25','2','10860','2.99','2005-08-02T00:12:32.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('678','25','1','10916','2.99','2005-08-02T02:05:59.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('679','25','1','11642','0.99','2005-08-17T04:48:05.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('680','25','1','12922','0.99','2005-08-19T04:48:48.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('681','25','1','14193','4.99','2005-08-21T03:38:27.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('682','25','1','14236','4.99','2005-08-21T05:13:16.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('683','25','1','15512','0.99','2005-08-23T02:57:30.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('684','25','1','15972','5.99','2005-08-23T20:00:30.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('685','26','1','796','2.99','2005-05-29T16:59:44.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('686','26','2','1105','2.99','2005-05-31T14:33:56.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('687','26','1','1440','5.99','2005-06-15T18:53:14.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('688','26','2','1706','4.99','2005-06-16T14:01:02.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('689','26','1','2093','9.99','2005-06-17T18:14:08.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('690','26','2','2416','3.99','2005-06-18T17:07:34.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('691','26','2','2421','6.99','2005-06-18T17:25:05.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('692','26','1','2532','4.99','2005-06-19T01:27:46.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('693','26','1','2745','4.99','2005-06-19T16:21:19.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('694','26','1','4065','2.99','2005-07-07T04:32:28.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('695','26','1','4274','4.99','2005-07-07T14:42:04.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('696','26','1','4382','4.99','2005-07-07T20:41:03.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('697','26','2','4402','0.99','2005-07-07T21:28:46.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('698','26','1','4431','6.99','2005-07-07T22:39:02.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('699','26','1','4536','3.99','2005-07-08T03:43:22.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('700','26','1','4641','6.99','2005-07-08T09:09:46.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('701','26','1','5437','2.99','2005-07-09T21:32:29.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('702','26','1','6149','1.99','2005-07-11T09:19:31.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('703','26','2','6243','2.99','2005-07-11T14:53:25.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('704','26','2','7328','0.99','2005-07-27T13:55:18.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('705','26','1','8241','4.99','2005-07-29T00:33:36.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('706','26','1','9484','0.99','2005-07-30T23:31:40.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('707','26','1','10386','3.99','2005-08-01T06:42:20.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('708','26','1','10996','3.99','2005-08-02T04:48:11.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('709','26','2','11314','2.99','2005-08-02T16:04:08.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('710','26','1','11338','0.99','2005-08-02T17:00:12.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('711','26','1','11744','5.99','2005-08-17T08:54:30.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('712','26','2','13111','4.99','2005-08-19T11:25:10.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('713','26','2','14183','4.99','2005-08-21T03:24:29.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('714','26','2','14192','8.99','2005-08-21T03:37:42.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('715','26','2','14603','1.99','2005-08-21T17:51:06.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('716','26','1','14677','7.99','2005-08-21T20:12:30.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('717','26','1','15384','2.99','2005-08-22T22:34:44.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('718','26','1','15722','7.99','2005-08-23T11:16:29.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('719','27','2','787','2.99','2005-05-29T16:03:03.000','2006-02-15T22:12:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('720','27','1','1310','4.99','2005-06-15T10:11:42.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('721','27','2','1480','4.99','2005-06-15T21:17:17.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('722','27','2','1699','2.99','2005-06-16T13:05:09.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('723','27','2','1960','3.99','2005-06-17T08:59:57.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('724','27','2','2512','2.99','2005-06-18T23:48:47.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('725','27','1','2815','4.99','2005-06-19T20:03:29.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('726','27','1','3038','1.99','2005-06-20T12:28:59.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('727','27','2','3420','3.99','2005-06-21T17:22:36.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('728','27','2','4038','0.99','2005-07-07T02:52:53.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('729','27','1','4510','5.99','2005-07-08T02:34:51.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('730','27','1','5552','0.99','2005-07-10T03:01:19.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('731','27','1','5736','4.99','2005-07-10T11:45:48.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('732','27','2','6115','0.99','2005-07-11T07:36:50.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('733','27','2','6562','5.99','2005-07-12T05:26:26.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('734','27','2','6658','4.99','2005-07-12T11:13:21.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('735','27','1','7927','1.99','2005-07-28T12:13:42.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('736','27','2','9244','0.99','2005-07-30T14:06:53.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('737','27','2','9636','5.99','2005-07-31T05:12:59.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('738','27','1','9673','7.99','2005-07-31T06:34:55.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('739','27','1','9908','4.99','2005-07-31T14:39:52.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('740','27','1','10794','7.99','2005-08-01T21:51:15.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('741','27','1','10852','4.99','2005-08-02T00:00:33.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('742','27','1','11234','0.99','2005-08-02T13:12:17.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('743','27','1','11661','8.99','2005-08-17T05:25:57.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('744','27','2','11740','6.99','2005-08-17T08:48:31.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('745','27','2','12021','5.99','2005-08-17T19:52:43.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('746','27','2','12461','0.99','2005-08-18T11:28:14.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('747','27','1','12531','2.99','2005-08-18T13:57:50.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('748','27','2','13816','4.99','2005-08-20T13:13:56.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('749','27','1','15048','0.99','2005-08-22T10:00:04.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('750','28','2','388','2.99','2005-05-27T10:37:27.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('751','28','1','868','2.99','2005-05-30T04:19:55.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('752','28','2','1240','2.99','2005-06-15T04:58:07.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('753','28','1','1543','4.99','2005-06-16T01:24:08.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('754','28','2','2299','3.99','2005-06-18T08:18:52.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('755','28','2','2604','0.99','2005-06-19T06:30:10.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('756','28','1','3231','0.99','2005-06-21T02:25:00.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('757','28','1','3845','0.99','2005-07-06T16:38:14.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('758','28','2','4704','0.99','2005-07-08T11:45:35.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('759','28','2','4951','4.99','2005-07-08T22:58:21.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('760','28','2','5653','2.99','2005-07-10T07:21:27.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('761','28','1','5817','5.99','2005-07-10T15:49:12.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('762','28','2','6032','0.99','2005-07-11T02:49:01.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('763','28','2','6476','0.99','2005-07-12T01:37:48.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('764','28','1','7580','9.99','2005-07-27T23:07:40.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('765','28','1','8464','4.99','2005-07-29T08:18:20.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('766','28','1','8901','2.99','2005-07-30T01:07:12.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('767','28','2','9544','2.99','2005-07-31T01:44:51.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('768','28','2','9593','4.99','2005-07-31T03:22:30.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('769','28','2','9705','4.99','2005-07-31T07:40:33.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('770','28','2','10116','2.99','2005-07-31T21:14:02.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('771','28','2','10294','6.99','2005-08-01T03:48:12.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('772','28','1','11444','2.99','2005-08-02T20:32:55.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('773','28','1','11856','3.99','2005-08-17T13:44:49.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('774','28','2','12190','2.99','2005-08-18T01:54:44.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('775','28','1','12359','0.99','2005-08-18T07:44:05.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('776','28','1','12708','2.99','2005-08-18T20:59:17.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('777','28','2','13783','4.99','2005-08-20T12:11:03.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('778','28','2','14540','2.99','2005-08-21T15:34:23.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('779','28','1','15445','4.99','2005-08-23T00:48:29.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('780','28','1','15491','2.99','2005-08-23T02:08:40.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('781','28','2','12938','2.99','2006-02-14T15:16:03.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('782','29','2','194','1.99','2005-05-26T06:52:33.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('783','29','1','2655','0.99','2005-06-19T10:38:42.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('784','29','1','2673','0.99','2005-06-19T11:42:20.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('785','29','1','2701','7.99','2005-06-19T13:33:06.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('786','29','1','2735','2.99','2005-06-19T15:42:07.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('787','29','2','2801','2.99','2005-06-19T19:18:09.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('788','29','2','2923','2.99','2005-06-20T04:16:07.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('789','29','1','3324','2.99','2005-06-21T08:49:16.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('790','29','2','4262','6.99','2005-07-07T14:24:30.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('791','29','1','4313','0.99','2005-07-07T17:36:56.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('792','29','2','4535','0.99','2005-07-08T03:40:46.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('793','29','2','5442','10.99','2005-07-09T21:55:19.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('794','29','1','5857','1.99','2005-07-10T17:59:29.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('795','29','2','7237','3.99','2005-07-27T10:12:36.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('796','29','1','7451','6.99','2005-07-27T18:18:41.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('797','29','1','7453','0.99','2005-07-27T18:27:13.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('798','29','2','8673','2.99','2005-07-29T15:50:14.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('799','29','2','9392','4.99','2005-07-30T19:50:13.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('800','29','1','9946','4.99','2005-07-31T15:48:54.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('801','29','1','10543','5.99','2005-08-01T12:36:09.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('802','29','2','10899','1.99','2005-08-02T01:30:21.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('803','29','1','11079','4.99','2005-08-02T07:29:10.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('804','29','2','11962','2.99','2005-08-17T17:34:38.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('805','29','1','12488','4.99','2005-08-18T12:48:22.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('806','29','1','12508','2.99','2005-08-18T13:20:13.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('807','29','2','12569','6.99','2005-08-18T15:20:46.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('808','29','2','12615','6.99','2005-08-18T17:16:07.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('809','29','2','13173','2.99','2005-08-19T13:50:36.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('810','29','1','13436','0.99','2005-08-19T23:36:25.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('811','29','2','13777','2.99','2005-08-20T12:03:35.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('812','29','1','13832','3.99','2005-08-20T14:00:25.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('813','29','1','14174','0.99','2005-08-21T03:01:45.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('814','29','1','14703','4.99','2005-08-21T21:01:19.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('815','29','1','14985','7.99','2005-08-22T07:35:56.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('816','29','1','14997','5.99','2005-08-22T07:53:00.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('817','29','2','15577','0.99','2006-02-14T15:16:03.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('818','30','2','1874','1.99','2005-06-17T02:39:20.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('819','30','2','1895','2.99','2005-06-17T04:25:12.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('820','30','2','2154','4.99','2005-06-17T22:59:42.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('821','30','2','2730','2.99','2005-06-19T15:10:09.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('822','30','1','3964','4.99','2005-07-06T22:23:02.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('823','30','2','4471','2.99','2005-07-08T00:21:29.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('824','30','2','4642','2.99','2005-07-08T09:13:28.000','2006-02-15T22:12:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('825','30','2','5028','5.99','2005-07-09T02:34:45.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('826','30','1','5108','9.99','2005-07-09T06:44:30.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('827','30','1','5289','0.99','2005-07-09T15:14:08.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('828','30','2','5972','7.99','2005-07-11T00:08:54.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('829','30','1','6249','0.99','2005-07-11T15:02:02.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('830','30','2','6359','2.99','2005-07-11T21:06:17.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('831','30','2','7394','2.99','2005-07-27T16:03:08.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('832','30','2','7769','4.99','2005-07-28T06:45:23.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('833','30','1','8030','4.99','2005-07-28T16:12:53.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('834','30','2','8038','4.99','2005-07-28T16:32:55.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('835','30','1','8083','4.99','2005-07-28T18:09:48.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('836','30','1','8641','2.99','2005-07-29T14:37:30.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('837','30','2','9309','2.99','2005-07-30T16:55:53.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('838','30','2','9551','0.99','2005-07-31T02:04:58.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('839','30','1','9641','0.99','2005-07-31T05:33:48.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('840','30','1','9998','2.99','2005-07-31T17:40:35.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('841','30','1','10235','6.99','2005-08-01T01:57:48.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('842','30','1','12240','2.99','2005-08-18T03:27:11.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('843','30','1','12546','2.99','2005-08-18T14:29:37.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('844','30','2','12758','0.99','2005-08-18T22:58:34.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('845','30','1','13435','0.99','2005-08-19T23:35:44.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('846','30','1','13682','4.99','2005-08-20T08:50:39.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('847','30','1','14339','0.99','2005-08-21T08:37:15.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('848','30','1','14585','2.99','2005-08-21T17:18:33.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('849','30','1','15063','4.99','2005-08-22T10:39:51.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('850','30','1','15544','4.99','2005-08-23T04:17:56.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('851','30','2','15829','2.99','2005-08-23T15:17:14.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('852','31','2','1656','4.99','2005-06-16T10:05:40.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('853','31','1','1838','1.99','2005-06-16T23:20:16.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('854','31','1','2233','0.99','2005-06-18T03:57:36.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('855','31','2','2341','6.99','2005-06-18T11:35:30.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('856','31','1','2396','7.99','2005-06-18T15:49:48.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('857','31','2','2438','0.99','2005-06-18T18:34:21.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('858','31','1','2530','0.99','2005-06-19T01:20:00.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('859','31','2','2648','4.99','2005-06-19T10:06:20.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('860','31','2','3117','2.99','2005-06-20T18:05:15.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('861','31','2','3172','1.99','2005-06-20T22:19:25.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('862','31','1','3205','0.99','2005-06-21T00:38:47.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('863','31','1','3701','4.99','2005-07-06T10:12:45.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('864','31','2','3967','4.99','2005-07-06T22:45:10.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('865','31','1','4122','6.99','2005-07-07T07:15:35.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('866','31','2','4738','9.99','2005-07-08T13:24:58.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('867','31','1','6208','3.99','2005-07-11T12:34:56.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('868','31','2','6580','4.99','2005-07-12T06:26:10.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('869','31','1','7000','1.99','2005-07-27T01:23:24.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('870','31','2','7138','3.99','2005-07-27T06:47:13.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('871','31','2','7178','2.99','2005-07-27T08:09:25.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('872','31','2','7464','2.99','2005-07-27T18:49:42.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('873','31','2','8997','0.99','2005-07-30T04:53:56.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('874','31','2','12085','4.99','2005-08-17T22:17:09.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('875','31','1','12377','0.99','2005-08-18T08:26:05.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('876','31','2','15682','6.99','2005-08-23T09:37:34.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('877','31','2','15816','6.99','2005-08-23T14:58:06.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('878','32','2','483','4.99','2005-05-27T23:00:25.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('879','32','2','803','4.99','2005-05-29T17:52:30.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('880','32','2','1067','4.99','2005-05-31T09:12:13.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('881','32','2','1887','6.99','2005-06-17T03:53:18.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('882','32','2','2160','0.99','2005-06-17T23:39:11.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('883','32','2','2624','5.99','2005-06-19T08:22:09.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('884','32','2','2891','1.99','2005-06-20T02:02:05.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('885','32','1','3500','2.99','2005-07-06T00:11:13.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('886','32','1','4434','2.99','2005-07-07T22:48:34.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('887','32','2','4771','2.99','2005-07-08T15:33:32.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('888','32','2','4899','0.99','2005-07-08T20:37:11.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('889','32','1','5307','9.99','2005-07-09T15:57:15.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('890','32','1','5767','0.99','2005-07-10T13:13:18.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('891','32','1','5954','2.99','2005-07-10T23:22:01.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('892','32','1','6122','3.99','2005-07-11T07:58:07.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('893','32','2','6450','2.99','2005-07-12T00:49:05.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('894','32','1','7084','6.99','2005-07-27T04:34:07.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('895','32','1','7589','5.99','2005-07-27T23:23:36.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('896','32','1','7793','2.99','2005-07-28T07:26:14.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('897','32','2','8390','5.99','2005-07-29T05:52:26.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('898','32','2','8453','2.99','2005-07-29T07:46:29.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('899','32','2','8914','2.99','2005-07-30T01:42:03.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('900','32','1','11135','4.99','2005-08-02T09:22:25.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('901','32','2','11831','4.99','2005-08-17T12:54:47.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('902','32','2','12414','9.99','2005-08-18T09:50:40.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('903','32','1','13736','8.99','2005-08-20T10:31:23.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('904','32','1','13931','1.99','2005-08-20T17:16:10.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('905','32','1','14075','0.99','2005-08-20T23:18:54.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('906','32','2','14570','5.99','2005-08-21T16:32:32.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('907','33','1','165','2.99','2005-05-26T02:28:36.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('908','33','1','1301','10.99','2005-06-15T09:46:33.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('909','33','2','3173','8.99','2005-06-20T22:21:10.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('910','33','1','4095','5.99','2005-07-07T06:01:48.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('911','33','1','5421','0.99','2005-07-09T20:49:12.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('912','33','1','5723','4.99','2005-07-10T11:14:48.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('913','33','2','6280','0.99','2005-07-11T16:36:17.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('914','33','1','7992','4.99','2005-07-28T14:53:06.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('915','33','1','9040','4.99','2005-07-30T06:31:45.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('916','33','2','9085','4.99','2005-07-30T08:17:24.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('917','33','1','9254','1.99','2005-07-30T14:26:11.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('918','33','2','10335','2.99','2005-08-01T04:59:30.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('919','33','1','10870','4.99','2005-08-02T00:27:12.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('920','33','1','13241','7.99','2005-08-19T16:25:00.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('921','33','1','13858','2.99','2005-08-20T14:50:57.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('922','33','1','13958','7.99','2005-08-20T18:11:44.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('923','33','1','14002','0.99','2005-08-20T20:12:19.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('924','33','1','14623','0.99','2005-08-21T18:29:13.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('925','33','1','15096','5.99','2005-08-22T11:43:04.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('926','33','2','15115','2.99','2005-08-22T12:28:01.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('927','33','1','12277','0.99','2006-02-14T15:16:03.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('928','34','1','1900','4.99','2005-06-17T04:29:58.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('929','34','2','2257','5.99','2005-06-18T05:29:52.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('930','34','1','3150','0.99','2005-06-20T20:35:28.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('931','34','2','3508','3.99','2005-07-06T00:24:25.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('932','34','1','3911','2.99','2005-07-06T20:09:11.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('933','34','1','5188','4.99','2005-07-09T10:22:31.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('934','34','2','5643','4.99','2005-07-10T06:49:00.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('935','34','2','5918','5.99','2005-07-10T21:32:06.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('936','34','2','7015','2.99','2005-07-27T02:15:01.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('937','34','2','7124','2.99','2005-07-27T06:09:30.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('938','34','1','7532','0.99','2005-07-27T21:20:52.000','2006-02-15T22:12:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('939','34','1','9160','3.99','2005-07-30T11:17:33.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('940','34','1','10523','0.99','2005-08-01T11:52:32.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('941','34','1','10615','4.99','2005-08-01T14:58:14.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('942','34','2','11096','0.99','2005-08-02T08:05:19.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('943','34','1','11505','2.99','2005-08-16T23:18:47.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('944','34','2','11701','4.99','2005-08-17T07:15:47.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('945','34','2','12286','2.99','2005-08-18T04:57:59.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('946','34','1','12599','2.99','2005-08-18T16:42:45.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('947','34','1','12651','0.99','2005-08-18T18:36:16.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('948','34','1','13371','4.99','2005-08-19T21:21:47.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('949','34','2','13949','2.99','2005-08-20T17:55:13.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('950','34','1','14686','5.99','2005-08-21T20:32:08.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('951','34','2','14701','7.99','2005-08-21T20:54:32.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('952','35','2','47','3.99','2005-05-25T06:05:20.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('953','35','1','424','6.99','2005-05-27T15:34:01.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('954','35','1','1579','0.99','2005-06-16T04:09:08.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('955','35','1','1989','2.99','2005-06-17T10:47:24.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('956','35','1','2229','4.99','2005-06-18T03:50:18.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('957','35','1','2231','0.99','2005-06-18T03:52:14.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('958','35','1','2743','2.99','2005-06-19T16:15:56.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('959','35','2','3112','4.99','2005-06-20T17:53:30.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('960','35','2','3597','2.99','2005-07-06T05:03:59.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('961','35','2','4098','4.99','2005-07-07T06:14:51.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('962','35','2','4990','0.99','2005-07-09T00:48:49.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('963','35','1','5013','2.99','2005-07-09T01:46:45.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('964','35','2','5323','0.99','2005-07-09T16:34:07.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('965','35','1','5916','5.99','2005-07-10T21:26:31.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('966','35','1','5963','0.99','2005-07-10T23:47:08.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('967','35','1','6147','5.99','2005-07-11T09:13:08.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('968','35','1','6401','4.99','2005-07-11T22:44:34.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('969','35','1','6565','4.99','2005-07-12T05:39:50.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('970','35','1','6572','4.99','2005-07-12T05:56:38.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('971','35','1','7140','4.99','2005-07-27T06:54:12.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('972','35','1','8822','6.99','2005-07-29T22:20:21.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('973','35','1','8971','5.99','2005-07-30T04:03:58.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('974','35','2','9033','2.99','2005-07-30T06:07:42.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('975','35','1','9579','6.99','2005-07-31T02:59:20.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('976','35','1','11298','1.99','2005-08-02T15:32:32.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('977','35','1','11452','7.99','2005-08-02T20:59:52.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('978','35','1','11645','4.99','2005-08-17T04:50:56.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('979','35','1','12055','4.99','2005-08-17T21:02:19.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('980','35','1','13735','2.99','2005-08-20T10:31:01.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('981','35','1','14110','0.99','2005-08-21T00:53:09.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('982','35','2','14124','2.99','2005-08-21T01:31:51.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('983','35','2','14735','4.99','2005-08-21T22:25:09.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('984','36','1','349','0.99','2005-05-27T04:53:11.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('985','36','1','716','0.99','2005-05-29T04:35:29.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('986','36','2','2741','0.99','2005-06-19T16:05:41.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('987','36','2','4135','0.99','2005-07-07T08:15:03.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('988','36','2','4560','4.99','2005-07-08T04:58:48.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('989','36','2','4762','4.99','2005-07-08T14:54:42.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('990','36','1','5403','0.99','2005-07-09T20:07:09.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('991','36','2','6030','0.99','2005-07-11T02:37:51.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('992','36','1','7205','6.99','2005-07-27T09:06:13.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('993','36','1','7647','0.99','2005-07-28T01:35:17.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('994','36','2','7919','6.99','2005-07-28T11:59:45.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('995','36','2','8099','0.99','2005-07-28T18:35:12.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('996','36','1','8391','2.99','2005-07-29T05:52:50.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('997','36','1','8952','4.99','2005-07-30T03:20:38.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('998','36','1','9369','2.99','2005-07-30T18:52:19.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('999','36','2','9805','0.99','2005-07-31T11:11:10.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1000','36','2','10525','2.99','2005-08-01T11:53:17.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1001','36','2','10761','2.99','2005-08-01T20:25:35.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1002','36','1','10963','0.99','2005-08-02T03:48:17.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1003','36','2','10964','6.99','2005-08-02T03:56:23.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1004','36','2','11616','4.99','2005-08-17T04:00:01.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1005','36','1','11813','4.99','2005-08-17T12:06:54.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1006','36','2','13562','2.99','2005-08-20T04:31:45.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1007','36','2','13564','1.99','2005-08-20T04:34:46.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1008','36','1','13674','4.99','2005-08-20T08:30:54.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1009','36','1','14647','9.99','2005-08-21T19:15:33.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1010','36','2','15657','4.99','2005-08-23T08:42:40.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1011','37','1','25','0.99','2005-05-25T03:21:20.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1012','37','1','923','2.99','2005-05-30T11:58:50.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1013','37','1','1583','4.99','2005-06-16T04:44:23.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1014','37','2','1812','1.99','2005-06-16T21:08:46.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1015','37','2','1854','3.99','2005-06-17T00:43:57.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1016','37','2','3472','7.99','2005-07-05T22:56:33.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1017','37','1','3734','5.99','2005-07-06T11:40:27.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1018','37','1','5425','5.99','2005-07-09T21:02:26.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1019','37','2','7939','0.99','2005-07-28T12:45:47.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1020','37','1','8419','9.99','2005-07-29T06:54:48.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1021','37','1','9567','5.99','2005-07-31T02:36:11.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1022','37','1','10538','2.99','2005-08-01T12:22:41.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1023','37','1','11176','3.99','2005-08-02T10:39:43.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1024','37','1','13046','7.99','2005-08-19T09:21:10.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1025','37','2','13147','4.99','2005-08-19T12:55:09.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1026','37','2','13444','0.99','2005-08-20T00:00:24.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1027','37','2','13493','3.99','2005-08-20T01:33:36.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1028','37','2','14025','8.99','2005-08-20T21:19:36.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1029','37','1','14084','0.99','2005-08-20T23:42:46.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1030','37','2','14532','2.99','2005-08-21T15:15:03.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1031','37','1','15028','3.99','2005-08-22T09:03:44.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1032','37','1','15904','0.99','2005-08-23T17:32:19.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1033','37','2','16035','0.99','2005-08-23T22:08:04.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1034','38','2','1250','2.99','2005-06-15T05:55:40.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1035','38','1','2550','1.99','2005-06-19T02:49:55.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1036','38','2','2605','1.99','2005-06-19T06:48:01.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1037','38','2','3003','4.99','2005-06-20T10:00:51.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1038','38','2','3392','3.99','2005-06-21T15:12:44.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1039','38','1','4202','5.99','2005-07-07T11:23:48.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1040','38','2','4228','1.99','2005-07-07T12:42:02.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1041','38','1','4300','4.99','2005-07-07T16:36:16.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1042','38','2','4644','4.99','2005-07-08T09:14:29.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1043','38','1','5273','2.99','2005-07-09T14:31:24.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1044','38','2','5460','2.99','2005-07-09T22:46:14.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1045','38','1','5822','2.99','2005-07-10T16:10:39.000','2006-02-15T22:12:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1046','38','1','6864','5.99','2005-07-12T19:59:25.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1047','38','1','6961','0.99','2005-07-27T00:10:49.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1048','38','2','7158','4.99','2005-07-27T07:23:58.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1049','38','2','7163','5.99','2005-07-27T07:36:11.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1050','38','2','7321','5.99','2005-07-27T13:33:38.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1051','38','1','7795','0.99','2005-07-28T07:28:16.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1052','38','2','8924','3.99','2005-07-30T02:08:58.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1053','38','2','9216','0.99','2005-07-30T13:11:19.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1054','38','1','9284','0.99','2005-07-30T15:25:19.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1055','38','1','9621','4.99','2005-07-31T04:21:08.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1056','38','2','10111','2.99','2005-07-31T21:08:33.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1057','38','2','10524','6.99','2005-08-01T11:53:12.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1058','38','2','11049','3.99','2005-08-02T06:15:40.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1059','38','1','11344','2.99','2005-08-02T17:13:26.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1060','38','1','11817','4.99','2005-08-17T12:20:01.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1061','38','2','12092','0.99','2005-08-17T22:28:15.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1062','38','2','12187','1.99','2005-08-18T01:45:50.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1063','38','1','14554','4.99','2005-08-21T16:03:01.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1064','38','2','14632','2.99','2005-08-21T18:48:06.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1065','38','1','14787','6.99','2005-08-22T00:25:59.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1066','38','1','15668','2.99','2005-08-23T09:02:04.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1067','38','1','15738','5.99','2005-08-23T11:55:50.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1068','39','1','1625','5.99','2005-06-16T07:49:08.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1069','39','1','1905','4.99','2005-06-17T04:51:43.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1070','39','2','2135','0.99','2005-06-17T21:14:02.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1071','39','2','2439','4.99','2005-06-18T18:35:04.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1072','39','1','2631','4.99','2005-06-19T08:49:53.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1073','39','1','2876','4.99','2005-06-20T01:06:34.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1074','39','1','4419','5.99','2005-07-07T22:06:24.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1075','39','2','4695','8.99','2005-07-08T11:07:59.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1076','39','2','4712','6.99','2005-07-08T12:10:50.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1077','39','2','4727','7.99','2005-07-08T12:54:15.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1078','39','1','5451','4.99','2005-07-09T22:22:10.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1079','39','2','5515','2.99','2005-07-10T01:12:44.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1080','39','1','6045','2.99','2005-07-11T03:21:05.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1081','39','2','8307','6.99','2005-07-29T03:18:34.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1082','39','2','8366','1.99','2005-07-29T05:11:14.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1083','39','2','8723','7.99','2005-07-29T18:03:47.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1084','39','1','8805','2.99','2005-07-29T21:29:58.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1085','39','1','9431','1.99','2005-07-30T21:24:22.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1086','39','1','9656','4.99','2005-07-31T06:00:21.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1087','39','2','10052','4.99','2005-07-31T19:15:13.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1088','39','1','10126','0.99','2005-07-31T21:36:07.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1089','39','1','10251','4.99','2005-08-01T02:39:12.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1090','39','2','10269','4.99','2005-08-01T03:09:26.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1091','39','2','10630','0.99','2005-08-01T15:34:46.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1092','39','1','10639','9.99','2005-08-01T15:44:43.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1093','39','2','12268','0.99','2005-08-18T04:26:54.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1094','39','2','12459','4.99','2005-08-18T11:25:11.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1095','39','2','13101','7.99','2005-08-19T11:01:54.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1096','39','2','15124','5.99','2005-08-22T12:51:38.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1097','40','1','128','4.99','2005-05-25T21:19:53.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1098','40','2','2470','7.99','2005-06-18T20:28:31.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1099','40','2','2896','2.99','2005-06-20T02:33:42.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1100','40','1','2993','4.99','2005-06-20T09:12:12.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1101','40','1','3428','0.99','2005-06-21T18:39:34.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1102','40','2','5001','1.99','2005-07-09T01:17:04.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1103','40','2','5777','2.99','2005-07-10T13:38:41.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1104','40','1','5869','5.99','2005-07-10T18:40:09.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1105','40','1','6502','0.99','2005-07-12T03:15:45.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1106','40','2','7684','0.99','2005-07-28T03:11:54.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1107','40','2','8031','0.99','2005-07-28T16:15:49.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1108','40','2','8170','3.99','2005-07-28T21:32:29.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1109','40','1','9050','8.99','2005-07-30T06:59:55.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1110','40','2','9700','4.99','2005-07-31T07:29:59.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1111','40','2','9961','6.99','2005-07-31T16:07:50.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1112','40','1','9975','1.99','2005-07-31T16:53:43.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1113','40','1','10442','2.99','2005-08-01T08:58:08.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1114','40','2','11919','0.99','2005-08-17T16:08:49.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1115','40','2','11948','3.99','2005-08-17T17:11:05.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1116','40','2','12396','9.99','2005-08-18T09:11:23.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1117','40','2','12877','2.99','2005-08-19T03:16:58.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1118','40','1','13149','6.99','2005-08-19T13:07:12.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1119','40','1','13376','0.99','2005-08-19T21:31:45.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1120','40','1','13840','5.99','2005-08-20T14:23:20.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1121','40','1','13951','2.99','2005-08-20T17:58:11.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1122','40','1','14260','6.99','2005-08-21T06:01:08.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1123','40','1','15193','2.99','2005-08-22T16:06:49.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1124','41','1','2563','4.99','2005-06-19T03:24:17.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1125','41','2','3246','7.99','2005-06-21T03:10:01.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1126','41','2','3827','2.99','2005-07-06T15:52:03.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1127','41','2','4294','9.99','2005-07-07T15:56:23.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1128','41','1','4543','4.99','2005-07-08T04:06:55.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1129','41','1','4575','2.99','2005-07-08T05:49:14.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1130','41','1','6976','4.99','2005-07-27T00:40:01.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1131','41','2','7153','4.99','2005-07-27T07:15:38.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1132','41','1','7517','1.99','2005-07-27T20:57:07.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1133','41','2','8008','6.99','2005-07-28T15:25:55.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1134','41','1','8098','0.99','2005-07-28T18:34:20.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1135','41','1','8134','6.99','2005-07-28T20:01:23.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1136','41','2','8225','2.99','2005-07-28T23:59:29.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1137','41','1','8712','2.99','2005-07-29T17:30:06.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1138','41','2','9313','5.99','2005-07-30T16:59:43.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1139','41','1','10064','2.99','2005-07-31T19:27:02.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1140','41','1','10170','7.99','2005-07-31T23:27:31.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1141','41','2','10495','4.99','2005-08-01T10:45:51.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1142','41','1','10853','5.99','2005-08-02T00:00:54.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1143','41','2','12147','2.99','2005-08-18T00:10:20.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1144','41','2','12173','3.99','2005-08-18T01:08:34.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1145','41','2','12821','0.99','2005-08-19T01:07:02.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1146','41','2','14539','7.99','2005-08-21T15:29:47.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1147','41','2','15860','4.99','2005-08-23T16:08:40.000','2006-02-15T22:12:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1148','41','1','15875','2.99','2006-02-14T15:16:03.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1149','42','1','635','5.99','2005-05-28T17:46:57.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1150','42','2','1534','0.99','2005-06-16T00:49:32.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1151','42','2','2056','2.99','2005-06-17T15:27:33.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1152','42','1','2170','3.99','2005-06-17T23:57:34.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1153','42','1','2302','4.99','2005-06-18T08:27:33.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1154','42','2','4391','2.99','2005-07-07T21:09:38.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1155','42','2','5199','4.99','2005-07-09T10:50:56.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1156','42','2','5517','5.99','2005-07-10T01:15:00.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1157','42','2','5652','3.99','2005-07-10T07:18:58.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1158','42','1','6179','2.99','2005-07-11T10:59:59.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1159','42','1','6799','2.99','2005-07-12T16:52:13.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1160','42','1','6925','0.99','2005-07-26T22:52:32.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1161','42','1','7405','3.99','2005-07-27T16:25:11.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1162','42','1','8049','0.99','2005-07-28T16:51:58.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1163','42','1','8095','6.99','2005-07-28T18:32:40.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1164','42','1','8166','2.99','2005-07-28T21:23:33.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1165','42','1','8499','3.99','2005-07-29T09:10:41.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1166','42','2','8785','2.99','2005-07-29T20:36:26.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1167','42','2','8852','3.99','2005-07-29T23:30:03.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1168','42','2','8915','3.99','2005-07-30T01:42:09.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1169','42','2','10060','6.99','2005-07-31T19:23:00.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1170','42','2','10345','2.99','2005-08-01T05:18:56.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1171','42','2','10845','2.99','2005-08-01T23:47:03.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1172','42','1','10935','5.99','2005-08-02T02:54:53.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1173','42','1','12478','4.99','2005-08-18T12:25:16.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1174','42','2','12499','2.99','2005-08-18T13:05:37.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1175','42','1','14461','7.99','2005-08-21T12:50:33.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1176','42','1','15442','2.99','2005-08-23T00:42:49.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1177','42','1','13351','5.98','2006-02-14T15:16:03.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1178','42','1','15407','0','2006-02-14T15:16:03.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1179','43','2','123','4.99','2005-05-25T20:26:42.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1180','43','1','652','4.99','2005-05-28T20:08:47.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1181','43','2','1544','4.99','2005-06-16T01:28:22.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1182','43','2','3683','1.99','2005-07-06T09:25:56.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1183','43','1','4498','2.99','2005-07-08T02:07:50.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1184','43','1','5162','4.99','2005-07-09T09:00:11.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1185','43','1','5401','4.99','2005-07-09T19:59:10.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1186','43','1','5831','2.99','2005-07-10T16:34:02.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1187','43','2','5941','4.99','2005-07-10T22:40:47.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1188','43','1','6474','3.99','2005-07-12T01:36:46.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1189','43','2','6680','0.99','2005-07-12T12:01:56.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1190','43','1','7348','4.99','2005-07-27T14:32:32.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1191','43','2','7868','4.99','2005-07-28T10:08:55.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1192','43','2','8376','4.99','2005-07-29T05:25:32.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1193','43','1','9204','4.99','2005-07-30T12:43:58.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1194','43','1','11753','4.99','2005-08-17T09:11:52.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1195','43','1','14244','2.99','2005-08-21T05:29:55.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1196','43','1','14649','4.99','2005-08-21T19:19:21.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1197','43','2','14837','4.99','2005-08-22T01:54:52.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1198','43','2','15155','4.99','2005-08-22T14:27:46.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1199','43','2','15800','6.99','2005-08-23T14:23:44.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1200','43','2','15945','2.99','2005-08-23T18:51:41.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1201','43','2','15644','3.98','2006-02-14T15:16:03.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1202','43','1','15745','0','2006-02-14T15:16:03.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1203','44','1','29','0.99','2005-05-25T03:47:12.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1204','44','1','99','4.99','2005-05-25T16:50:20.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1205','44','1','407','2.99','2005-05-27T13:57:38.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1206','44','2','721','0.99','2005-05-29T05:28:47.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1207','44','1','904','2.99','2005-05-30T10:19:42.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1208','44','1','1497','3.99','2005-06-15T21:56:39.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1209','44','1','2369','2.99','2005-06-18T14:25:29.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1210','44','1','2809','3.99','2005-06-19T19:40:27.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1211','44','2','2866','4.99','2005-06-20T00:01:36.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1212','44','2','4390','0.99','2005-07-07T20:59:06.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1213','44','2','4723','9.99','2005-07-08T12:44:59.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1214','44','1','5551','3.99','2005-07-10T03:01:09.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1215','44','1','5787','8.99','2005-07-10T14:08:49.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1216','44','2','5849','6.99','2005-07-10T17:32:33.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1217','44','2','5909','4.99','2005-07-10T20:46:13.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1218','44','1','7514','0.99','2005-07-27T20:51:49.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1219','44','2','7526','6.99','2005-07-27T21:13:47.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1220','44','2','8775','4.99','2005-07-29T20:05:38.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1221','44','1','8866','4.99','2005-07-29T23:58:19.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1222','44','1','11364','2.99','2005-08-02T17:53:36.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1223','44','2','12345','3.99','2005-08-18T07:16:58.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1224','44','1','12504','4.99','2005-08-18T13:17:07.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1225','44','1','12790','6.99','2005-08-19T00:16:54.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1226','44','2','12982','4.99','2005-08-19T07:06:34.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1227','44','2','15054','2.99','2005-08-22T10:14:33.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1228','44','2','13428','4.99','2006-02-14T15:16:03.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1229','45','2','277','2.99','2005-05-26T17:32:11.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1230','45','1','1806','4.99','2005-06-16T20:41:57.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1231','45','2','1979','2.99','2005-06-17T09:45:30.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1232','45','2','2722','4.99','2005-06-19T14:55:17.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1233','45','1','3391','3.99','2005-06-21T15:11:02.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1234','45','2','3444','0.99','2005-06-21T20:39:39.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1235','45','1','4843','0.99','2005-07-08T18:27:28.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1236','45','1','5181','6.99','2005-07-09T10:07:27.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1237','45','1','5405','7.99','2005-07-09T20:11:49.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1238','45','1','5637','0.99','2005-07-10T06:31:37.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1239','45','2','6001','0.99','2005-07-11T01:24:44.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1240','45','2','6002','2.99','2005-07-11T01:27:49.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1241','45','1','6966','9.99','2005-07-27T00:15:35.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1242','45','1','7436','2.99','2005-07-27T17:39:12.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1243','45','1','7961','3.99','2005-07-28T13:47:21.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1244','45','1','10507','2.99','2005-08-01T11:22:20.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1245','45','2','10878','6.99','2005-08-02T00:33:12.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1246','45','1','11004','8.99','2005-08-02T05:04:18.000','2006-02-15T22:12:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1247','45','1','11029','4.99','2005-08-02T05:51:10.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1248','45','2','11483','2.99','2005-08-02T22:28:22.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1249','45','2','11488','3.99','2005-08-02T22:35:15.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1250','45','1','11725','2.99','2005-08-17T08:09:00.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1251','45','1','13340','3.99','2005-08-19T20:18:39.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1252','45','2','13394','4.99','2005-08-19T22:05:19.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1253','45','1','14576','6.99','2005-08-21T16:52:03.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1254','45','1','15812','10.99','2005-08-23T14:47:26.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1255','45','2','16037','7.99','2005-08-23T22:13:04.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1256','46','2','401','2.99','2005-05-27T12:57:55.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1257','46','2','432','4.99','2005-05-27T16:40:29.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1258','46','1','938','2.99','2005-05-30T14:47:31.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1259','46','1','1166','4.99','2005-06-14T23:17:03.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1260','46','2','1214','4.99','2005-06-15T03:18:40.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1261','46','2','2144','0.99','2005-06-17T22:05:40.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1262','46','1','2203','2.99','2005-06-18T02:10:42.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1263','46','2','2965','8.99','2005-06-20T07:33:38.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1264','46','2','2975','4.99','2005-06-20T08:06:18.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1265','46','2','3439','4.99','2005-06-21T19:36:15.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1266','46','2','3855','2.99','2005-07-06T17:03:48.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1267','46','1','3916','4.99','2005-07-06T20:18:50.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1268','46','2','5698','4.99','2005-07-10T09:47:00.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1269','46','1','7336','0.99','2005-07-27T14:11:45.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1270','46','2','8152','3.99','2005-07-28T20:53:05.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1271','46','2','9045','8.99','2005-07-30T06:36:57.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1272','46','2','9806','2.99','2005-07-31T11:13:49.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1273','46','1','10088','2.99','2005-07-31T20:16:21.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1274','46','2','10428','4.99','2005-08-01T08:30:11.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1275','46','1','10803','4.99','2005-08-01T22:22:07.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1276','46','1','10827','5.99','2005-08-01T23:13:00.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1277','46','1','11721','0.99','2005-08-17T07:49:17.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1278','46','2','12095','4.99','2005-08-17T22:32:37.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1279','46','2','12238','2.99','2005-08-18T03:25:08.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1280','46','2','12280','4.99','2005-08-18T04:49:27.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1281','46','1','12298','2.99','2005-08-18T05:30:31.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1282','46','2','12455','4.99','2005-08-18T11:19:47.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1283','46','1','13226','0.99','2005-08-19T16:05:36.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1284','46','2','14144','4.99','2005-08-21T02:10:57.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1285','46','2','14528','6.99','2005-08-21T15:08:05.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1286','46','1','14940','4.99','2005-08-22T05:54:03.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1287','46','1','15438','2.99','2005-08-23T00:31:57.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1288','46','1','15708','0.99','2005-08-23T10:35:51.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1289','46','1','15758','5.99','2005-08-23T12:47:26.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1290','47','2','175','3.99','2005-05-26T03:46:26.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1291','47','2','207','4.99','2005-05-26T08:04:38.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1292','47','1','300','6.99','2005-05-26T20:57:00.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1293','47','1','1882','4.99','2005-06-17T03:17:21.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1294','47','1','2307','6.99','2005-06-18T08:34:59.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1295','47','2','3320','5.99','2005-06-21T08:29:41.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1296','47','1','3631','4.99','2005-07-06T06:36:53.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1297','47','2','4064','5.99','2005-07-07T04:29:20.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1298','47','1','5174','0.99','2005-07-09T09:31:59.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1299','47','2','6153','9.99','2005-07-11T09:31:04.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1300','47','2','6164','0.99','2005-07-11T10:16:23.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1301','47','1','6337','3.99','2005-07-11T19:30:47.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1302','47','2','8159','4.99','2005-07-28T21:09:28.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1303','47','2','8402','6.99','2005-07-29T06:25:45.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1304','47','1','8863','3.99','2005-07-29T23:52:01.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1305','47','2','9274','4.99','2005-07-30T15:07:04.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1306','47','1','11126','0.99','2005-08-02T08:59:04.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1307','47','2','11477','5.99','2005-08-02T22:09:01.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1308','47','1','12215','7.99','2005-08-18T02:35:39.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1309','47','2','12274','7.99','2005-08-18T04:41:47.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1310','47','1','14397','0.99','2005-08-21T10:25:56.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1311','47','2','15846','2.99','2005-08-23T15:39:18.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1312','48','2','72','0.99','2005-05-25T10:52:13.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1313','48','1','297','2.99','2005-05-26T20:48:48.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1314','48','1','390','4.99','2005-05-27T11:02:26.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1315','48','2','1689','9.99','2005-06-16T12:18:41.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1316','48','2','2822','0.99','2005-06-19T20:29:24.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1317','48','2','3758','4.99','2005-07-06T12:43:11.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1318','48','1','4367','2.99','2005-07-07T19:52:01.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1319','48','2','5148','6.99','2005-07-09T08:22:46.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1320','48','2','6498','3.99','2005-07-12T03:05:38.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1321','48','1','7920','2.99','2005-07-28T12:01:19.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1322','48','1','8716','6.99','2005-07-29T17:39:09.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1323','48','1','9402','7.99','2005-07-30T20:18:27.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1324','48','2','9742','7.99','2005-07-31T09:10:20.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1325','48','2','10276','2.99','2005-08-01T03:22:23.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1326','48','2','14450','1.99','2005-08-21T12:21:25.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1327','48','2','14536','2.99','2005-08-21T15:22:50.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1328','48','1','15228','3.99','2005-08-22T17:27:23.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1329','49','2','96','1.99','2005-05-25T16:32:19.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1330','49','1','239','3.99','2005-05-26T12:30:26.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1331','49','2','846','2.99','2005-05-30T01:17:45.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1332','49','2','1010','4.99','2005-05-31T01:57:32.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1333','49','1','1164','0.99','2005-06-14T23:16:26.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1334','49','2','1237','9.99','2005-06-15T04:44:10.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1335','49','2','1688','0.99','2005-06-16T12:11:20.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1336','49','2','1777','6.99','2005-06-16T18:52:12.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1337','49','2','3235','4.99','2005-06-21T02:46:17.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1338','49','2','3575','4.99','2005-07-06T03:36:19.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1339','49','2','3615','0.99','2005-07-06T05:47:47.000','2006-02-15T22:12:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1340','49','1','5491','2.99','2005-07-10T00:09:45.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1341','49','1','6214','4.99','2005-07-11T12:49:48.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1342','49','1','6279','6.99','2005-07-11T16:26:07.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1343','49','1','6521','7.99','2005-07-12T04:06:11.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1344','49','2','6759','4.99','2005-07-12T15:14:48.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1345','49','2','7209','4.99','2005-07-27T09:16:53.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1346','49','2','7742','8.99','2005-07-28T05:33:16.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1347','49','2','8553','10.99','2005-07-29T11:15:36.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1348','49','2','9006','0.99','2005-07-30T05:06:32.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1349','49','1','9851','4.99','2005-07-31T12:50:24.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1350','49','1','10144','4.99','2005-07-31T22:13:52.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1351','49','1','10266','0.99','2005-08-01T03:05:59.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1352','49','1','10588','2.99','2005-08-01T14:10:21.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1353','49','1','10814','2.99','2005-08-01T22:43:12.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1354','49','2','14168','5.99','2005-08-21T03:00:03.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1355','49','1','14627','6.99','2005-08-21T18:35:54.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1356','49','1','14676','2.99','2005-08-21T20:02:18.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1357','50','1','763','4.99','2005-05-29T11:32:15.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1358','50','1','794','4.99','2005-05-29T16:44:11.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1359','50','1','905','4.99','2005-05-30T10:25:00.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1360','50','1','1029','4.99','2005-05-31T03:52:02.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1361','50','2','1136','4.99','2005-05-31T19:19:36.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1362','50','1','1223','2.99','2005-06-15T03:38:53.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1363','50','1','1785','4.99','2005-06-16T19:27:12.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1364','50','2','3000','0.99','2005-06-20T09:32:33.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1365','50','2','3169','2.99','2005-06-20T21:55:54.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1366','50','2','4149','2.99','2005-07-07T08:40:17.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1367','50','2','5290','4.99','2005-07-09T15:14:47.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1368','50','2','5641','4.99','2005-07-10T06:43:43.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1369','50','2','5681','9.99','2005-07-10T08:48:39.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1370','50','1','5928','6.99','2005-07-10T21:58:30.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1371','50','2','6634','0.99','2005-07-12T09:37:18.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1372','50','1','6667','8.99','2005-07-12T11:36:22.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1373','50','1','7383','4.99','2005-07-27T15:46:53.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1374','50','1','8089','0.99','2005-07-28T18:26:47.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1375','50','1','8261','0.99','2005-07-29T01:11:05.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1376','50','1','8619','5.99','2005-07-29T13:50:08.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1377','50','2','9179','0.99','2005-07-30T12:02:41.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1378','50','1','9615','4.99','2005-07-31T03:59:56.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1379','50','2','9691','10.99','2005-07-31T07:09:55.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1380','50','2','10046','2.99','2005-07-31T19:07:11.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1381','50','2','10165','0.99','2005-07-31T23:21:23.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1382','50','2','10180','6.99','2005-07-31T23:57:43.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1383','50','2','10261','4.99','2005-08-01T02:58:27.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1384','50','2','10485','7.99','2005-08-01T10:20:34.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1385','50','2','11053','3.99','2005-08-02T06:27:13.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1386','50','1','12766','6.99','2005-08-18T23:25:20.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1387','50','2','13136','7.99','2005-08-19T12:24:23.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1388','50','1','14054','4.99','2005-08-20T22:17:01.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1389','50','2','15138','2.99','2005-08-22T13:36:30.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1390','50','2','15388','6.99','2005-08-22T22:49:23.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1391','50','1','16015','4.99','2005-08-23T21:25:03.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1392','51','2','119','4.99','2005-05-25T19:37:02.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1393','51','1','661','4.99','2005-05-28T21:01:25.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1394','51','2','1028','4.99','2005-05-31T03:48:05.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1395','51','2','1373','1.99','2005-06-15T14:48:04.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1396','51','1','1477','0.99','2005-06-15T21:11:18.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1397','51','1','3525','9.99','2005-07-06T01:02:39.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1398','51','1','5230','2.99','2005-07-09T12:30:23.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1399','51','2','5304','5.99','2005-07-09T15:48:06.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1400','51','1','5473','7.99','2005-07-09T23:19:11.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1401','51','1','5606','4.99','2005-07-10T05:07:55.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1402','51','1','7207','5.99','2005-07-27T09:13:26.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1403','51','1','7398','6.99','2005-07-27T16:07:22.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1404','51','1','7636','5.99','2005-07-28T01:08:36.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1405','51','1','8495','4.99','2005-07-29T09:05:06.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1406','51','1','8693','0.99','2005-07-29T16:44:13.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1407','51','1','8880','0.99','2005-07-30T00:16:55.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1408','51','2','9649','0.99','2005-07-31T05:46:54.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1409','51','2','10244','4.99','2005-08-01T02:20:01.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1410','51','1','10780','2.99','2005-08-01T21:14:24.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1411','51','1','10894','0.99','2005-08-02T01:12:35.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1412','51','1','11302','2.99','2005-08-02T15:38:03.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1413','51','2','11685','4.99','2005-08-17T06:39:16.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1414','51','2','11751','6.99','2005-08-17T09:07:56.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1415','51','1','12184','0.99','2005-08-18T01:36:00.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1416','51','1','12725','4.99','2005-08-18T21:43:09.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1417','51','2','13098','2.99','2005-08-19T10:51:59.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1418','51','1','13302','2.99','2005-08-19T18:54:26.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1419','51','1','13868','0.99','2005-08-20T15:06:26.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1420','51','2','13882','2.99','2005-08-20T15:23:26.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1421','51','2','14221','6.99','2005-08-21T04:49:41.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1422','51','2','14512','4.99','2005-08-21T14:47:09.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1423','51','1','14617','4.99','2005-08-21T18:07:40.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1424','51','1','14903','4.99','2005-08-22T04:31:50.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1425','52','1','874','0.99','2005-05-30T05:36:21.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1426','52','1','1196','4.99','2005-06-15T01:38:31.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1427','52','2','2232','0.99','2005-06-18T03:54:31.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1428','52','1','2862','2.99','2005-06-19T23:47:24.000','2006-02-15T22:12:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1429','52','2','3196','4.99','2005-06-21T00:02:28.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1430','52','1','3997','1.99','2005-07-06T23:46:52.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1431','52','1','5308','0.99','2005-07-09T15:58:38.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1432','52','2','5313','3.99','2005-07-09T16:04:45.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1433','52','1','5607','2.99','2005-07-10T05:08:10.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1434','52','1','6394','7.99','2005-07-11T22:29:15.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1435','52','2','7284','0.99','2005-07-27T12:12:04.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1436','52','2','7438','5.99','2005-07-27T17:40:40.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1437','52','2','7627','4.99','2005-07-28T00:56:47.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1438','52','1','8686','4.99','2005-07-29T16:17:49.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1439','52','1','9029','4.99','2005-07-30T06:03:11.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1440','52','2','9749','3.99','2005-07-31T09:18:33.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1441','52','2','9797','4.99','2005-07-31T10:53:44.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1442','52','2','10591','0.99','2005-08-01T14:12:29.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1443','52','1','10635','0.99','2005-08-01T15:37:58.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1444','52','1','11068','0.99','2005-08-02T07:08:07.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1445','52','1','11731','3.99','2005-08-17T08:24:35.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1446','52','2','12200','2.99','2005-08-18T02:12:33.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1447','52','2','12520','0.99','2005-08-18T13:42:45.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1448','52','2','13090','5.99','2005-08-19T10:39:54.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1449','52','2','14820','2.99','2005-08-22T01:18:37.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1450','52','1','14822','5.99','2005-08-22T01:21:14.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1451','52','2','14961','6.99','2005-08-22T06:35:50.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1452','52','2','15891','5.99','2005-08-23T17:00:12.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1453','52','1','12001','4.99','2006-02-14T15:16:03.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1454','53','1','88','3.99','2005-05-25T14:13:54.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1455','53','1','378','2.99','2005-05-27T09:23:22.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1456','53','1','751','0.99','2005-05-29T09:55:43.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1457','53','2','783','5.99','2005-05-29T14:41:18.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1458','53','2','856','9.99','2005-05-30T02:01:21.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1459','53','1','1107','2.99','2005-05-31T15:04:05.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1460','53','1','1964','0.99','2005-06-17T09:10:09.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1461','53','1','2388','2.99','2005-06-18T15:26:30.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1462','53','1','2903','2.99','2005-06-20T02:49:01.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1463','53','2','3140','2.99','2005-06-20T19:47:12.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1464','53','2','3244','0.99','2005-06-21T03:01:10.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1465','53','2','3591','2.99','2005-07-06T04:37:10.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1466','53','2','3898','4.99','2005-07-06T19:12:37.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1467','53','2','5185','2.99','2005-07-09T10:14:39.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1468','53','2','7466','2.99','2005-07-27T18:51:17.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1469','53','1','7699','4.99','2005-07-28T03:52:21.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1470','53','1','9343','4.99','2005-07-30T18:13:13.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1471','53','1','9928','7.99','2005-07-31T15:13:57.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1472','53','1','10594','3.99','2005-08-01T14:14:59.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1473','53','1','12054','5.99','2005-08-17T20:59:56.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1474','53','1','12580','2.99','2005-08-18T15:49:08.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1475','53','1','13049','5.99','2005-08-19T09:25:40.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1476','53','2','13789','2.99','2005-08-20T12:16:38.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1477','53','1','14061','2.99','2005-08-20T22:32:11.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1478','53','2','14091','0.99','2005-08-21T00:11:17.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1479','53','2','14119','5.99','2005-08-21T01:15:59.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1480','53','1','14671','4.99','2005-08-21T19:59:30.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1481','53','2','14811','0.99','2005-08-22T01:09:04.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1482','53','2','11657','7.98','2006-02-14T15:16:03.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1483','53','1','14137','0','2006-02-14T15:16:03.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1484','54','2','198','4.99','2005-05-26T07:03:49.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1485','54','2','441','4.99','2005-05-27T18:11:05.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1486','54','2','545','3.99','2005-05-28T07:10:20.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1487','54','1','1556','4.99','2005-06-16T02:19:02.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1488','54','1','1571','2.99','2005-06-16T03:22:00.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1489','54','2','2323','6.99','2005-06-18T09:55:02.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1490','54','1','2647','4.99','2005-06-19T09:57:56.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1491','54','2','4657','4.99','2005-07-08T09:51:02.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1492','54','2','5055','1.99','2005-07-09T04:05:28.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1493','54','1','5929','2.99','2005-07-10T21:59:29.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1494','54','1','5992','2.99','2005-07-11T01:06:21.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1495','54','1','6338','7.99','2005-07-11T19:39:41.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1496','54','2','6560','2.99','2005-07-12T05:22:06.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1497','54','1','6813','0.99','2005-07-12T18:03:50.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1498','54','2','8992','4.99','2005-07-30T04:44:18.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1499','54','2','10489','5.99','2005-08-01T10:27:42.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1500','54','2','10882','5.99','2005-08-02T00:47:16.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1501','54','1','10956','4.99','2005-08-02T03:33:14.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1502','54','1','11182','4.99','2005-08-02T10:55:14.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1503','54','2','11887','2.99','2005-08-17T15:03:13.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1504','54','1','12526','2.99','2005-08-18T13:48:43.000','2006-02-15T22:12:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1505','54','2','12775','5.99','2005-08-18T23:35:56.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1506','54','1','12811','4.99','2005-08-19T00:51:28.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1507','54','2','12872','0.99','2005-08-19T02:57:37.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1508','54','2','13315','2.99','2005-08-19T19:16:18.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1509','54','1','13890','0.99','2005-08-20T15:41:00.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1510','54','1','14215','4.99','2005-08-21T04:34:11.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1511','54','1','15226','10.99','2005-08-22T17:20:17.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1512','54','1','15567','4.99','2005-08-23T05:20:36.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1513','55','1','555','4.99','2005-05-28T08:31:14.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1514','55','1','1027','9.99','2005-05-31T03:46:19.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1515','55','1','1048','0.99','2005-05-31T06:49:53.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1516','55','2','1825','2.99','2005-06-16T21:53:05.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1517','55','2','2062','2.99','2005-06-17T15:56:43.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1518','55','1','2904','2.99','2005-06-20T02:54:06.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1519','55','1','2976','4.99','2005-06-20T08:09:11.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1520','55','1','3149','4.99','2005-06-20T20:34:55.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1521','55','1','4671','4.99','2005-07-08T10:15:32.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1522','55','2','6314','7.99','2005-07-11T18:32:44.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1523','55','2','7050','4.99','2005-07-27T03:33:17.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1524','55','2','8288','6.99','2005-07-29T02:04:22.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1525','55','1','9302','2.99','2005-07-30T16:34:57.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1526','55','2','9596','5.99','2005-07-31T03:28:47.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1527','55','2','9798','2.99','2005-07-31T10:55:18.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1528','55','2','11287','1.99','2005-08-02T14:49:51.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1529','55','1','12776','4.99','2005-08-18T23:37:33.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1530','55','1','12808','4.99','2005-08-19T00:40:41.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1531','55','2','12972','1.99','2005-08-19T06:43:28.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1532','55','1','13345','6.99','2005-08-19T20:25:24.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1533','55','1','14667','2.99','2005-08-21T19:51:11.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1534','55','1','15296','4.99','2005-08-22T19:37:20.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1535','56','1','130','3.99','2005-05-25T21:21:56.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1536','56','1','341','5.99','2005-05-27T04:01:42.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1537','56','1','496','2.99','2005-05-28T00:43:41.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1538','56','1','569','6.99','2005-05-28T10:12:41.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1539','56','2','1795','6.99','2005-06-16T20:09:01.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1540','56','1','2140','0.99','2005-06-17T21:40:29.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1541','56','1','2485','4.99','2005-06-18T21:26:03.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1542','56','1','2989','0.99','2005-06-20T08:59:37.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1543','56','1','3718','7.99','2005-07-06T10:57:56.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1544','56','2','3771','2.99','2005-07-06T13:19:34.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1545','56','1','4097','3.99','2005-07-07T06:10:55.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1546','56','2','4702','4.99','2005-07-08T11:41:36.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1547','56','1','5142','4.99','2005-07-09T08:05:23.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1548','56','1','7385','2.99','2005-07-27T15:49:46.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1549','56','1','7696','7.99','2005-07-28T03:41:35.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1550','56','2','7942','0.99','2005-07-28T12:49:44.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1551','56','1','8285','0.99','2005-07-29T02:00:18.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1552','56','2','10356','6.99','2005-08-01T05:49:17.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1553','56','2','10678','0.99','2005-08-01T17:26:24.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1554','56','1','10946','4.99','2005-08-02T03:20:39.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1555','56','1','11358','5.99','2005-08-02T17:45:02.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1556','56','1','11656','4.99','2005-08-17T05:11:09.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1557','56','2','12537','1.99','2005-08-18T14:06:39.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1558','56','2','12713','4.99','2005-08-18T21:07:28.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1559','56','2','13560','8.99','2005-08-20T04:17:16.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1560','56','1','13769','5.99','2005-08-20T11:43:52.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1561','56','2','14291','3.99','2005-08-21T07:03:05.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1562','56','2','14534','0.99','2005-08-21T15:16:29.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1563','56','2','15702','7.99','2005-08-23T10:23:28.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1564','56','2','15714','4.99','2006-02-14T15:16:03.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1565','57','2','152','9.99','2005-05-26T00:41:10.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1566','57','2','943','4.99','2005-05-30T15:20:19.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1567','57','1','2058','5.99','2005-06-17T15:34:41.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1568','57','1','2105','0.99','2005-06-17T19:15:45.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1569','57','1','2360','4.99','2005-06-18T13:11:13.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1570','57','2','2910','7.99','2005-06-20T03:31:18.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1571','57','1','3357','0.99','2005-06-21T11:55:42.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1572','57','1','3727','4.99','2005-07-06T11:16:43.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1573','57','2','4226','4.99','2005-07-07T12:37:56.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1574','57','1','5060','4.99','2005-07-09T04:28:03.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1575','57','1','5694','0.99','2005-07-10T09:40:38.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1576','57','2','5948','2.99','2005-07-10T23:12:08.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1577','57','2','6482','4.99','2005-07-12T01:50:21.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1578','57','1','6494','1.99','2005-07-12T02:42:51.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1579','57','2','6649','4.99','2005-07-12T10:51:09.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1580','57','2','8249','5.99','2005-07-29T00:48:44.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1581','57','1','9086','0.99','2005-07-30T08:18:46.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1582','57','2','9136','0.99','2005-07-30T10:07:20.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1583','57','1','9211','1.99','2005-07-30T12:59:45.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1584','57','1','9703','0.99','2005-07-31T07:34:52.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1585','57','2','9812','2.99','2005-07-31T11:28:07.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1586','57','2','10169','4.99','2005-07-31T23:27:13.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1587','57','2','12925','5.99','2005-08-19T04:59:01.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1588','57','2','13163','0.99','2005-08-19T13:29:46.000','2006-02-15T22:12:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1589','57','2','13743','0.99','2005-08-20T10:51:27.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1590','57','2','13929','9.99','2005-08-20T17:13:48.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1591','57','2','15571','0.99','2005-08-23T05:26:30.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1592','57','2','15871','9.99','2005-08-23T16:24:24.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1593','58','1','230','0.99','2005-05-26T11:31:50.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1594','58','2','276','7.99','2005-05-26T17:16:07.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1595','58','2','761','0.99','2005-05-29T11:09:01.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1596','58','1','2191','4.99','2005-06-18T01:33:09.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1597','58','2','2543','0.99','2005-06-19T02:14:11.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1598','58','1','2906','0.99','2005-06-20T03:04:56.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1599','58','1','3685','4.99','2005-07-06T09:30:45.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1600','58','2','4131','4.99','2005-07-07T07:53:18.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1601','58','2','5439','1.99','2005-07-09T21:39:35.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1602','58','1','7063','9.99','2005-07-27T03:52:27.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1603','58','2','7487','4.99','2005-07-27T19:32:45.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1604','58','1','8853','0.99','2005-07-29T23:34:21.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1605','58','2','9561','2.99','2005-07-31T02:22:13.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1606','58','2','10037','2.99','2005-07-31T18:48:08.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1607','58','1','10068','4.99','2005-07-31T19:39:38.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1608','58','2','10256','4.99','2005-08-01T02:47:11.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1609','58','1','10668','0.99','2005-08-01T17:00:27.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1610','58','1','11416','6.99','2005-08-02T19:44:04.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1611','58','2','12292','8.99','2005-08-18T05:08:54.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1612','58','1','13194','6.99','2005-08-19T14:34:12.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1613','58','1','13207','3.99','2005-08-19T15:14:38.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1614','58','1','13930','2.99','2005-08-20T17:15:06.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1615','58','2','13973','4.99','2005-08-20T18:52:43.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1616','58','2','14305','5.99','2005-08-21T07:29:05.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1617','58','1','14665','6.99','2005-08-21T19:49:46.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1618','58','1','14989','4.99','2005-08-22T07:47:07.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1619','58','2','15326','0.99','2006-02-14T15:16:03.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1620','59','2','212','4.99','2005-05-26T08:34:41.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1621','59','2','951','2.99','2005-05-30T16:10:35.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1622','59','1','1154','5.99','2005-05-31T21:42:09.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1623','59','1','1269','2.99','2005-06-15T07:29:59.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1624','59','1','1728','3.99','2005-06-16T15:29:29.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1625','59','1','2921','3.99','2005-06-20T04:13:04.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1626','59','2','4148','2.99','2005-07-07T08:36:58.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1627','59','1','4384','4.99','2005-07-07T20:46:45.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1628','59','1','4631','4.99','2005-07-08T08:38:22.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1629','59','1','4891','3.99','2005-07-08T20:06:19.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1630','59','2','5195','8.99','2005-07-09T10:39:31.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1631','59','1','5207','3.99','2005-07-09T11:15:44.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1632','59','1','5830','4.99','2005-07-10T16:34:00.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1633','59','1','7991','4.99','2005-07-28T14:45:45.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1634','59','2','8643','4.99','2005-07-29T14:45:23.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1635','59','1','9469','8.99','2005-07-30T22:56:34.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1636','59','2','9573','6.99','2005-07-31T02:45:38.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1637','59','2','11396','4.99','2005-08-02T18:48:29.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1638','59','1','12833','5.99','2005-08-19T01:42:28.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1639','59','2','13282','2.99','2005-08-19T18:08:18.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1640','59','1','13573','2.99','2005-08-20T05:10:14.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1641','59','2','13921','4.99','2005-08-20T16:57:11.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1642','59','1','14135','5.99','2005-08-21T01:53:54.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1643','59','1','14977','5.99','2005-08-22T07:12:53.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1644','59','2','15271','5.99','2005-08-22T18:48:48.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1645','59','2','15744','4.99','2005-08-23T12:15:51.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1646','59','2','15905','2.99','2005-08-23T17:33:04.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1647','60','1','318','4.99','2005-05-26T23:37:39.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1648','60','2','706','1.99','2005-05-29T03:05:49.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1649','60','2','934','2.99','2005-05-30T13:24:46.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1650','60','2','1482','4.99','2005-06-15T21:18:16.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1651','60','2','2394','4.99','2005-06-18T15:42:30.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1652','60','2','3473','2.99','2005-07-05T22:57:34.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1653','60','1','3849','2.99','2005-07-06T16:49:43.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1654','60','1','6282','5.99','2005-07-11T16:46:22.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1655','60','2','7067','0.99','2005-07-27T03:55:10.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1656','60','1','7331','3.99','2005-07-27T13:57:50.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1657','60','1','7494','0.99','2005-07-27T19:56:31.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1658','60','1','9356','4.99','2005-07-30T18:36:24.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1659','60','1','9761','4.99','2005-07-31T09:31:54.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1660','60','2','10680','0.99','2005-08-01T17:28:05.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1661','60','1','11092','4.99','2005-08-02T07:58:50.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1662','60','1','11404','8.99','2005-08-02T19:12:40.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1663','60','1','12084','1.99','2005-08-17T22:16:49.000','2006-02-15T22:12:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1664','60','2','12614','7.99','2005-08-18T17:16:03.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1665','60','1','15093','2.99','2005-08-22T11:39:03.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1666','60','1','15318','2.99','2005-08-22T20:15:16.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1667','60','1','15618','5.99','2005-08-23T07:07:58.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1668','60','1','15632','0.99','2005-08-23T07:30:26.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1669','60','1','15649','2.99','2005-08-23T08:28:03.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1670','60','2','12489','9.98','2006-02-14T15:16:03.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1671','60','2','14741','0','2006-02-14T15:16:03.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1672','61','1','1157','0.99','2005-05-31T22:47:45.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1673','61','1','7027','7.99','2005-07-27T02:50:15.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1674','61','2','7071','1.99','2005-07-27T04:01:15.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1675','61','2','8029','6.99','2005-07-28T16:11:21.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1676','61','2','8075','4.99','2005-07-28T17:37:28.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1677','61','1','8651','3.99','2005-07-29T15:02:18.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1678','61','2','9597','6.99','2005-07-31T03:29:07.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1679','61','2','10549','0.99','2005-08-01T12:46:39.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1680','61','2','11379','2.99','2005-08-02T18:16:55.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1681','61','1','12072','9.99','2005-08-17T21:50:25.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1682','61','1','13450','0.99','2005-08-20T00:18:15.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1683','61','1','13830','0.99','2005-08-20T13:57:59.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1684','61','2','15089','6.99','2005-08-22T11:34:06.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1685','61','1','15681','1.99','2005-08-23T09:35:34.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1686','62','2','885','0.99','2005-05-30T06:54:28.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1687','62','1','947','4.99','2005-05-30T15:36:57.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1688','62','2','1241','6.99','2005-06-15T04:59:43.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1689','62','1','1486','0.99','2005-06-15T21:25:30.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1690','62','1','1587','0.99','2005-06-16T04:52:28.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1691','62','2','3021','4.99','2005-06-20T11:13:01.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1692','62','1','3035','5.99','2005-06-20T12:17:03.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1693','62','1','3287','0.99','2005-06-21T06:32:39.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1694','62','1','3327','3.99','2005-06-21T09:04:50.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1695','62','2','3843','2.99','2005-07-06T16:35:40.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1696','62','2','4159','4.99','2005-07-07T09:10:57.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1697','62','2','5292','2.99','2005-07-09T15:16:54.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1698','62','2','8360','4.99','2005-07-29T05:08:00.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1699','62','2','10080','0.99','2005-07-31T20:07:10.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1700','62','1','10815','2.99','2005-08-01T22:46:21.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1701','62','1','11297','5.99','2005-08-02T15:22:47.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1702','62','1','11988','0.99','2005-08-17T18:23:50.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1703','62','2','13512','8.99','2005-08-20T02:27:13.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1704','62','2','14574','1.99','2005-08-21T16:50:34.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1705','62','2','14594','2.99','2005-08-21T17:34:24.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1706','62','2','14821','4.99','2005-08-22T01:20:19.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1707','62','1','15464','6.99','2005-08-23T01:15:18.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1708','62','1','15591','0.99','2005-08-23T06:11:52.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1709','63','2','1818','0.99','2005-06-16T21:30:34.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1710','63','2','3923','8.99','2005-07-06T20:34:10.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1711','63','1','4587','4.99','2005-07-08T06:16:26.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1712','63','1','5585','6.99','2005-07-10T04:15:43.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1713','63','2','5788','4.99','2005-07-10T14:10:22.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1714','63','2','5832','4.99','2005-07-10T16:34:48.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1715','63','2','6769','3.99','2005-07-12T15:48:54.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1716','63','2','6847','8.99','2005-07-12T19:22:37.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1717','63','2','8311','5.99','2005-07-29T03:26:07.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1718','63','2','9007','0.99','2005-07-30T05:09:32.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1719','63','1','9546','4.99','2005-07-31T01:47:40.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1720','63','2','9549','3.99','2005-07-31T01:57:04.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1721','63','1','9795','0.99','2005-07-31T10:47:19.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1722','63','2','9938','2.99','2005-07-31T15:28:47.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1723','63','2','10148','0.99','2005-07-31T22:19:16.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1724','63','1','10288','6.99','2005-08-01T03:38:42.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1725','63','1','11902','4.99','2005-08-17T15:37:34.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1726','63','2','12342','2.99','2005-08-18T07:12:46.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1727','63','2','12515','0.99','2005-08-18T13:39:26.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1728','63','1','12954','7.99','2005-08-19T06:04:34.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1729','63','1','13089','0.99','2005-08-19T10:38:56.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1730','63','1','13624','8.99','2005-08-20T06:51:02.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1731','63','1','14931','3.99','2005-08-22T05:38:55.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1732','63','1','15060','5.99','2005-08-22T10:24:32.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1733','63','1','15229','2.99','2005-08-22T17:30:25.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1734','64','1','494','4.99','2005-05-28T00:39:31.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1735','64','1','587','0.99','2005-05-28T12:05:33.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1736','64','1','1001','2.99','2005-05-31T00:46:31.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1737','64','2','1335','0.99','2005-06-15T11:51:30.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1738','64','1','2060','2.99','2005-06-17T15:42:42.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1739','64','2','3982','0.99','2005-07-06T23:14:16.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1740','64','1','4288','4.99','2005-07-07T15:38:25.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1741','64','1','4690','1.99','2005-07-08T11:04:02.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1742','64','2','4819','5.99','2005-07-08T17:19:15.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1743','64','2','4971','5.99','2005-07-08T23:54:49.000','2006-02-15T22:12:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1744','64','1','5114','3.99','2005-07-09T07:07:05.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1745','64','2','5279','2.99','2005-07-09T14:46:36.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1746','64','1','5432','0.99','2005-07-09T21:21:25.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1747','64','2','6372','2.99','2005-07-11T21:35:06.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1748','64','2','6457','0.99','2005-07-12T01:06:35.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1749','64','2','6698','1.99','2005-07-12T12:45:00.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1750','64','2','6744','0.99','2005-07-12T14:30:28.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1751','64','2','7045','0.99','2005-07-27T03:27:35.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1752','64','1','7082','2.99','2005-07-27T04:27:32.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1753','64','1','7476','1.99','2005-07-27T19:08:56.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1754','64','2','8602','4.99','2005-07-29T13:04:27.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1755','64','1','9832','2.99','2005-07-31T12:01:49.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1756','64','1','9880','6.99','2005-07-31T13:49:02.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1757','64','1','9924','3.99','2005-07-31T15:04:57.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1758','64','2','10185','0.99','2005-08-01T00:12:11.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1759','64','2','10714','4.99','2005-08-01T18:51:29.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1760','64','1','10889','4.99','2005-08-02T00:54:33.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1761','64','1','12409','0.99','2005-08-18T09:43:58.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1762','64','1','13773','2.99','2005-08-20T11:50:14.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1763','64','1','13971','0.99','2005-08-20T18:44:53.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1764','64','1','14167','5.99','2005-08-21T02:59:48.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1765','64','2','14316','0.99','2005-08-21T07:59:47.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1766','64','2','13333','4.99','2006-02-14T15:16:03.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1767','65','1','295','4.99','2005-05-26T20:33:20.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1768','65','2','657','0.99','2005-05-28T20:23:09.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1769','65','1','2173','7.99','2005-06-18T00:08:20.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1770','65','1','3051','4.99','2005-06-20T13:06:52.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1771','65','1','3535','4.99','2005-07-06T01:32:46.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1772','65','1','4240','4.99','2005-07-07T13:33:12.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1773','65','2','4635','3.99','2005-07-08T08:42:40.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1774','65','1','5735','3.99','2005-07-10T11:39:15.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1775','65','2','6527','0.99','2005-07-12T04:23:06.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1776','65','1','7877','6.99','2005-07-28T10:25:36.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1777','65','2','8392','1.99','2005-07-29T06:00:27.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1778','65','2','8404','5.99','2005-07-29T06:27:01.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1779','65','1','9293','3.99','2005-07-30T16:12:28.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1780','65','2','11100','5.99','2005-08-02T08:08:00.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1781','65','1','11227','8.99','2005-08-02T12:48:05.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1782','65','2','11461','4.99','2005-08-02T21:35:00.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1783','65','2','11845','2.99','2005-08-17T13:16:38.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1784','65','1','12114','7.99','2005-08-17T23:02:00.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1785','65','1','12688','6.99','2005-08-18T19:59:54.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1786','65','2','13692','0.99','2005-08-20T09:07:52.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1787','65','2','14140','6.99','2005-08-21T02:04:57.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1788','65','1','14356','0.99','2005-08-21T09:08:51.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1789','66','2','933','4.99','2005-05-30T13:08:45.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1790','66','1','1236','2.99','2005-06-15T04:34:27.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1791','66','1','1907','2.99','2005-06-17T05:08:27.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1792','66','1','2106','4.99','2005-06-17T19:29:03.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1793','66','2','2571','2.99','2005-06-19T04:20:14.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1794','66','1','2577','4.99','2005-06-19T04:36:03.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1795','66','1','3334','3.99','2005-06-21T10:04:33.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1796','66','2','3395','6.99','2005-06-21T15:19:19.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1797','66','1','3573','4.99','2005-07-06T03:33:48.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1798','66','2','3757','2.99','2005-07-06T12:42:26.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1799','66','2','4088','2.99','2005-07-07T05:31:55.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1800','66','1','4108','4.99','2005-07-07T06:38:31.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1801','66','2','4165','6.99','2005-07-07T09:23:27.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1802','66','2','4911','5.99','2005-07-08T21:20:26.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1803','66','2','5915','0.99','2005-07-10T21:12:16.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1804','66','1','6290','8.99','2005-07-11T17:12:42.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1805','66','2','6348','5.99','2005-07-11T20:21:18.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1806','66','1','6402','3.99','2005-07-11T22:46:10.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1807','66','1','6995','2.99','2005-07-27T01:12:13.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1808','66','1','7872','2.99','2005-07-28T10:18:16.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1809','66','1','9091','5.99','2005-07-30T08:30:45.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1810','66','1','10419','0.99','2005-08-01T08:13:22.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1811','66','2','11028','5.99','2005-08-02T05:48:20.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1812','66','2','11360','2.99','2005-08-02T17:46:04.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1813','66','1','11683','5.99','2005-08-17T06:15:17.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1814','66','1','11935','0.99','2005-08-17T16:42:13.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1815','66','1','12699','0.99','2005-08-18T20:20:59.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1816','66','1','13900','2.99','2005-08-20T16:05:41.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1817','66','2','14123','2.99','2005-08-21T01:31:25.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1818','66','1','14217','6.99','2005-08-21T04:37:56.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1819','66','2','14351','2.99','2005-08-21T09:04:20.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1820','66','2','14429','0.99','2005-08-21T11:29:43.000','2006-02-15T22:12:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1821','66','2','15026','4.99','2005-08-22T09:01:52.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1822','66','1','15598','8.99','2005-08-23T06:23:26.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1823','67','2','331','9.99','2005-05-27T02:22:26.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1824','67','1','767','2.99','2005-05-29T12:20:19.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1825','67','1','2064','3.99','2005-06-17T15:57:56.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1826','67','1','2542','3.99','2005-06-19T02:08:39.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1827','67','2','2810','0.99','2005-06-19T19:44:12.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1828','67','1','3359','4.99','2005-06-21T12:08:18.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1829','67','2','4090','4.99','2005-07-07T05:47:33.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1830','67','2','5399','2.99','2005-07-09T19:52:44.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1831','67','2','5510','2.99','2005-07-10T00:58:37.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1832','67','1','6137','2.99','2005-07-11T08:34:20.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1833','67','2','7277','5.99','2005-07-27T11:48:37.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1834','67','2','7895','0.99','2005-07-28T10:57:15.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1835','67','2','8563','1.99','2005-07-29T11:32:58.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1836','67','1','9640','7.99','2005-07-31T05:33:25.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1837','67','1','11295','8.99','2005-08-02T15:10:06.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1838','67','1','11894','8.99','2005-08-17T15:15:01.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1839','67','2','13437','4.99','2005-08-19T23:37:52.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1840','67','1','13652','2.99','2005-08-20T07:52:34.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1841','67','2','13791','4.99','2005-08-20T12:21:05.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1842','67','2','13837','2.99','2005-08-20T14:19:03.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1843','67','2','14967','4.99','2005-08-22T06:46:03.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1844','67','2','15085','2.99','2005-08-22T11:19:22.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1845','68','2','1828','5.99','2005-06-16T22:04:34.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1846','68','2','1957','8.99','2005-06-17T08:50:58.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1847','68','2','2633','2.99','2005-06-19T08:53:10.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1848','68','2','2662','4.99','2005-06-19T10:53:42.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1849','68','1','2686','2.99','2005-06-19T12:44:20.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1850','68','1','3598','0.99','2005-07-06T05:11:04.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1851','68','2','3801','4.99','2005-07-06T15:05:50.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1852','68','1','3864','0.99','2005-07-06T17:41:42.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1853','68','2','4555','6.99','2005-07-08T04:48:36.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1854','68','1','4925','3.99','2005-07-08T21:56:00.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1855','68','1','6512','4.99','2005-07-12T03:42:49.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1856','68','2','9339','3.99','2005-07-30T18:03:28.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1857','68','1','9538','3.99','2005-07-31T01:25:22.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1858','68','2','9642','4.99','2005-07-31T05:33:57.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1859','68','1','10115','7.99','2005-07-31T21:13:47.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1860','68','1','11277','2.99','2005-08-02T14:28:50.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1861','68','2','12742','2.99','2005-08-18T22:22:03.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1862','68','2','13475','4.99','2005-08-20T01:05:05.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1863','68','2','14242','0.99','2005-08-21T05:25:59.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1864','68','2','14455','5.99','2005-08-21T12:36:11.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1865','68','1','14947','1.99','2005-08-22T06:07:52.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1866','68','1','15524','4.99','2005-08-23T03:36:26.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1867','69','2','584','4.99','2005-05-28T11:49:00.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1868','69','2','765','1.99','2005-05-29T11:38:34.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1869','69','1','1549','2.99','2005-06-16T01:57:15.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1870','69','1','3358','4.99','2005-06-21T11:56:40.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1871','69','1','3883','8.99','2005-07-06T18:39:38.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1872','69','1','4265','0.99','2005-07-07T14:27:51.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1873','69','1','4427','0.99','2005-07-07T22:28:51.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1874','69','2','5569','3.99','2005-07-10T03:38:32.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1875','69','2','6297','4.99','2005-07-11T17:37:22.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1876','69','1','6385','6.99','2005-07-11T22:07:32.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1877','69','2','6785','6.99','2005-07-12T16:30:57.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1878','69','2','8649','6.99','2005-07-29T14:57:33.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1879','69','2','9193','2.99','2005-07-30T12:28:42.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1880','69','1','9612','2.99','2005-07-31T03:58:31.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1881','69','2','10074','0.99','2005-07-31T19:57:16.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1882','69','1','11943','3.99','2005-08-17T17:00:42.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1883','69','1','12012','2.99','2005-08-17T19:20:48.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1884','69','1','12121','2.99','2005-08-17T23:20:40.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1885','69','1','12966','5.99','2005-08-19T06:37:48.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1886','69','1','13023','5.99','2005-08-19T08:13:54.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1887','69','2','14311','3.99','2005-08-21T07:45:47.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1888','69','2','14685','0.99','2005-08-21T20:31:25.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1889','69','2','14767','2.99','2005-08-21T23:43:00.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1890','69','1','15547','2.99','2005-08-23T04:25:50.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1891','69','2','11995','0.99','2006-02-14T15:16:03.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1892','70','2','1044','4.99','2005-05-31T06:24:44.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1893','70','1','2472','4.99','2005-06-18T20:32:40.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1894','70','1','4061','0.99','2005-07-07T04:13:35.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1895','70','1','5927','5.99','2005-07-10T21:57:14.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1896','70','2','7036','4.99','2005-07-27T03:06:12.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1897','70','2','7421','7.99','2005-07-27T17:10:05.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1898','70','1','7714','2.99','2005-07-28T04:32:30.000','2006-02-15T22:12:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1899','70','2','8550','0.99','2005-07-29T11:12:37.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1900','70','1','8747','2.99','2005-07-29T19:07:57.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1901','70','1','11274','9.99','2005-08-02T14:24:08.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1902','70','1','11901','2.99','2005-08-17T15:35:47.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1903','70','1','12003','4.99','2005-08-17T18:56:05.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1904','70','2','12218','4.99','2005-08-18T02:48:14.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1905','70','1','12581','6.99','2005-08-18T15:49:15.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1906','70','1','12951','3.99','2005-08-19T05:56:44.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1907','70','2','13680','4.99','2005-08-20T08:44:06.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1908','70','2','15238','0.99','2005-08-22T17:46:12.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1909','70','1','15616','3.99','2005-08-23T07:06:38.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1910','71','1','199','2.99','2005-05-26T07:11:58.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1911','71','1','272','9.99','2005-05-26T16:27:11.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1912','71','2','1873','2.99','2005-06-17T02:38:28.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1913','71','1','2374','4.99','2005-06-18T14:44:06.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1914','71','2','3345','5.99','2005-06-21T11:05:07.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1915','71','2','4614','4.99','2005-07-08T07:45:17.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1916','71','2','5281','1.99','2005-07-09T14:55:07.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1917','71','2','5358','3.99','2005-07-09T18:09:21.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1918','71','1','5543','8.99','2005-07-10T02:48:03.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1919','71','1','5770','4.99','2005-07-10T13:21:28.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1920','71','2','5814','4.99','2005-07-10T15:46:50.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1921','71','2','6020','0.99','2005-07-11T02:08:55.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1922','71','1','6739','5.99','2005-07-12T14:22:08.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1923','71','2','7160','0.99','2005-07-27T07:26:06.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1924','71','1','7550','4.99','2005-07-27T21:55:07.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1925','71','2','7982','4.99','2005-07-28T14:19:59.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1926','71','2','8128','2.99','2005-07-28T19:46:06.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1927','71','1','8293','2.99','2005-07-29T02:30:50.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1928','71','1','8574','1.99','2005-07-29T11:51:53.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1929','71','1','8668','4.99','2005-07-29T15:41:31.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1930','71','1','8783','3.99','2005-07-29T20:31:28.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1931','71','1','8789','4.99','2005-07-29T20:47:27.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1932','71','1','8956','0.99','2005-07-30T03:32:29.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1933','71','1','12417','4.99','2005-08-18T09:57:00.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1934','71','1','14105','7.99','2005-08-21T00:44:34.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1935','71','1','14228','3.99','2005-08-21T04:57:08.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1936','71','2','14781','4.99','2005-08-22T00:15:12.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1937','71','2','14904','3.99','2005-08-22T04:32:01.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1938','71','1','15704','4.99','2005-08-23T10:25:45.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1939','71','1','16000','0.99','2005-08-23T20:44:36.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1940','72','2','785','4.99','2005-05-29T15:08:41.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1941','72','2','845','4.99','2005-05-30T01:17:25.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1942','72','2','1047','0.99','2005-05-31T06:45:57.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1943','72','2','2294','4.99','2005-06-18T07:46:34.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1944','72','1','3700','0.99','2005-07-06T10:12:19.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1945','72','2','5223','4.99','2005-07-09T12:06:03.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1946','72','1','5302','4.99','2005-07-09T15:42:36.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1947','72','1','5424','0.99','2005-07-09T20:59:09.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1948','72','1','5840','4.99','2005-07-10T17:09:09.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1949','72','2','6081','0.99','2005-07-11T05:11:09.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1950','72','2','8228','4.99','2005-07-29T00:08:58.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1951','72','1','9027','2.99','2005-07-30T05:58:27.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1952','72','2','9420','5.99','2005-07-30T21:05:18.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1953','72','2','9648','4.99','2005-07-31T05:46:03.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1954','72','2','10267','0.99','2005-08-01T03:07:26.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1955','72','2','11206','6.99','2005-08-02T11:58:03.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1956','72','2','11422','5.99','2005-08-02T19:52:08.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1957','72','1','11630','2.99','2005-08-17T04:27:46.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1958','72','1','11679','4.99','2005-08-17T06:08:54.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1959','72','1','11923','2.99','2005-08-17T16:21:47.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1960','72','2','12020','2.99','2005-08-17T19:50:33.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1961','72','1','12448','0.99','2005-08-18T10:59:04.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1962','72','2','12593','0.99','2005-08-18T16:17:54.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1963','72','1','13145','0.99','2005-08-19T12:53:53.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1964','72','2','13327','4.99','2005-08-19T19:55:45.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1965','72','2','13597','0.99','2005-08-20T05:59:05.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1966','72','2','13660','4.99','2005-08-20T08:05:56.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1967','72','1','14020','0.99','2005-08-20T20:59:43.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1968','72','2','15110','0.99','2005-08-22T12:16:46.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1969','72','2','15146','2.99','2005-08-22T13:57:55.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1970','73','1','70','2.99','2005-05-25T10:15:23.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1971','73','2','1133','4.99','2005-05-31T19:12:21.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1972','73','1','1669','0.99','2005-06-16T10:20:20.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1973','73','2','2940','4.99','2005-06-20T05:20:01.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1974','73','2','4327','2.99','2005-07-07T18:01:39.000','2006-02-15T22:12:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1975','73','1','4789','4.99','2005-07-08T16:22:01.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1976','73','2','5021','4.99','2005-07-09T02:09:41.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1977','73','1','6514','9.99','2005-07-12T03:47:44.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1978','73','1','6645','2.99','2005-07-12T10:39:55.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1979','73','1','7590','4.99','2005-07-27T23:24:24.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1980','73','1','7683','4.99','2005-07-28T03:11:29.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1981','73','1','8377','4.99','2005-07-29T05:27:40.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1982','73','1','9212','2.99','2005-07-30T13:03:13.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1983','73','1','9776','2.99','2005-07-31T10:01:03.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1984','73','2','10434','4.99','2005-08-01T08:47:00.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1985','73','1','11102','4.99','2005-08-02T08:08:30.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1986','73','2','11155','0.99','2005-08-02T09:55:28.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1987','73','2','11349','4.99','2005-08-02T17:21:49.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1988','73','2','11609','3.99','2005-08-17T03:41:11.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1989','73','2','12291','4.99','2005-08-18T05:08:37.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1990','73','1','13886','4.99','2005-08-20T15:34:43.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1991','73','1','15667','0.99','2005-08-23T09:02:03.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1992','73','2','16002','2.99','2005-08-23T20:47:12.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1993','73','2','13108','2.99','2006-02-14T15:16:03.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1994','74','2','1121','6.99','2005-05-31T16:37:36.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1995','74','1','2498','1.99','2005-06-18T22:56:26.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1996','74','2','2517','0.99','2005-06-19T00:11:26.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1997','74','1','3020','1.99','2005-06-20T11:12:04.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1998','74','2','3445','7.99','2005-06-21T20:40:28.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('1999','74','2','3819','3.99','2005-07-06T15:35:06.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2000','74','1','5530','2.99','2005-07-10T02:13:49.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2001','74','2','5603','2.99','2005-07-10T05:04:54.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2002','74','2','5917','4.99','2005-07-10T21:30:22.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2003','74','1','6241','7.99','2005-07-11T14:40:48.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2004','74','1','6475','2.99','2005-07-12T01:36:57.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2005','74','1','7304','6.99','2005-07-27T12:56:56.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2006','74','2','8796','5.99','2005-07-29T21:09:11.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2007','74','2','9112','4.99','2005-07-30T09:06:31.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2008','74','2','10051','3.99','2005-07-31T19:14:20.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2009','74','1','10624','0.99','2005-08-01T15:27:05.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2010','74','2','12374','3.99','2005-08-18T08:07:45.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2011','74','2','12477','3.99','2005-08-18T12:25:01.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2012','74','2','13335','0.99','2005-08-19T20:03:18.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2013','74','2','13520','0.99','2005-08-20T02:41:46.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2014','74','1','13583','1.99','2005-08-20T05:29:45.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2015','74','2','13747','5.99','2005-08-20T10:56:06.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2016','74','1','15286','4.99','2005-08-22T19:17:56.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2017','74','2','15325','4.99','2005-08-22T20:27:38.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2018','74','2','15500','0.99','2005-08-23T02:39:37.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2019','74','2','15739','4.99','2005-08-23T11:56:22.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2020','74','1','16046','0.99','2005-08-23T22:26:47.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2021','75','1','180','4.99','2005-05-26T04:46:23.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2022','75','2','268','0.99','2005-05-26T16:19:08.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2023','75','1','1920','4.99','2005-06-17T06:00:23.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2024','75','1','2161','7.99','2005-06-17T23:39:50.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2025','75','2','2738','4.99','2005-06-19T15:56:30.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2026','75','2','3062','6.99','2005-06-20T13:50:00.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2027','75','1','3210','4.99','2005-06-21T01:00:25.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2028','75','1','3711','0.99','2005-07-06T10:46:15.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2029','75','2','4179','2.99','2005-07-07T10:17:15.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2030','75','2','4511','0.99','2005-07-08T02:36:21.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2031','75','1','4639','5.99','2005-07-08T08:57:21.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2032','75','2','5260','2.99','2005-07-09T14:05:45.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2033','75','2','6052','0.99','2005-07-11T03:51:27.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2034','75','1','6092','3.99','2005-07-11T05:51:31.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2035','75','1','6486','0.99','2005-07-12T02:09:36.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2036','75','2','6530','0.99','2005-07-12T04:33:19.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2037','75','2','6852','2.99','2005-07-12T19:33:49.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2038','75','1','7052','2.99','2005-07-27T03:36:38.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2039','75','1','7454','4.99','2005-07-27T18:27:26.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2040','75','1','7843','0.99','2005-07-28T09:10:22.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2041','75','2','7897','2.99','2005-07-28T11:01:51.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2042','75','2','8202','1.99','2005-07-28T23:11:45.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2043','75','1','8823','6.99','2005-07-29T22:22:12.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2044','75','2','9168','5.99','2005-07-30T11:31:17.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2045','75','2','9442','4.99','2005-07-30T21:44:31.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2046','75','2','9501','4.99','2005-07-30T23:59:21.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2047','75','1','9783','9.99','2005-07-31T10:15:46.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2048','75','2','10653','5.99','2005-08-01T16:28:07.000','2006-02-15T22:12:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2049','75','1','10726','3.99','2005-08-01T19:14:53.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2050','75','1','10871','4.99','2005-08-02T00:27:24.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2051','75','1','11330','0.99','2005-08-02T16:45:33.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2052','75','1','12002','2.99','2005-08-17T18:56:02.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2053','75','2','12239','0.99','2005-08-18T03:26:42.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2054','75','1','12336','1.99','2005-08-18T06:59:41.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2055','75','1','12412','5.99','2005-08-18T09:49:52.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2056','75','1','12426','4.99','2005-08-18T10:24:11.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2057','75','1','12662','0.99','2005-08-18T19:10:41.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2058','75','2','15928','5.99','2005-08-23T18:23:24.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2059','75','2','13534','8.97','2006-02-14T15:16:03.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2060','75','1','14488','0','2006-02-14T15:16:03.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2061','75','2','15191','0','2006-02-14T15:16:03.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2062','76','2','574','1.99','2005-05-28T10:44:28.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2063','76','1','926','0.99','2005-05-30T12:15:54.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2064','76','2','1487','0.99','2005-06-15T21:27:42.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2065','76','1','1791','6.99','2005-06-16T20:04:28.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2066','76','2','2111','0.99','2005-06-17T19:47:21.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2067','76','2','2397','1.99','2005-06-18T15:51:25.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2068','76','1','2894','0.99','2005-06-20T02:22:42.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2069','76','2','3416','0.99','2005-06-21T17:05:29.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2070','76','2','4099','4.99','2005-07-07T06:20:33.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2071','76','2','5571','0.99','2005-07-10T03:48:20.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2072','76','2','6789','0.99','2005-07-12T16:34:40.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2073','76','2','8253','6.99','2005-07-29T00:57:06.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2074','76','2','8357','2.99','2005-07-29T04:59:44.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2075','76','2','8405','3.99','2005-07-29T06:28:19.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2076','76','1','8935','0.99','2005-07-30T02:38:45.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2077','76','2','9312','2.99','2005-07-30T16:59:17.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2078','76','2','10082','0.99','2005-07-31T20:09:32.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2079','76','2','10795','4.99','2005-08-01T21:56:37.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2080','76','2','11172','7.99','2005-08-02T10:27:52.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2081','76','2','13697','3.99','2005-08-20T09:21:08.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2082','76','1','14637','2.99','2005-08-21T19:01:00.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2083','76','2','15169','4.99','2005-08-22T15:21:56.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2084','76','1','15566','10.99','2005-08-23T05:17:23.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2085','77','2','319','2.99','2005-05-26T23:52:13.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2086','77','1','419','1.99','2005-05-27T15:15:11.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2087','77','2','561','2.99','2005-05-28T08:54:06.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2088','77','1','586','0.99','2005-05-28T12:03:00.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2089','77','1','760','5.99','2005-05-29T11:07:25.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2090','77','1','1710','4.99','2005-06-16T14:11:24.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2091','77','1','2354','3.99','2005-06-18T12:54:18.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2092','77','2','2452','8.99','2005-06-18T19:29:21.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2093','77','1','3151','2.99','2005-06-20T20:36:53.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2094','77','2','3238','0.99','2005-06-21T02:48:21.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2095','77','2','4928','0.99','2005-07-08T22:05:41.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2096','77','2','6168','0.99','2005-07-11T10:21:38.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2097','77','2','6390','2.99','2005-07-11T22:19:23.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2098','77','1','7406','3.99','2005-07-27T16:25:45.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2099','77','1','7710','0.99','2005-07-28T04:24:07.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2100','77','2','8942','4.99','2005-07-30T03:01:07.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2101','77','1','9811','0.99','2005-07-31T11:23:45.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2102','77','2','10184','4.99','2005-08-01T00:09:33.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2103','77','1','10886','2.99','2005-08-02T00:52:34.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2104','77','1','10895','0.99','2005-08-02T01:16:59.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2105','77','2','10991','0.99','2005-08-02T04:41:12.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2106','77','1','11469','2.99','2005-08-02T21:48:09.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2107','77','2','11767','7.99','2005-08-17T10:00:40.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2108','77','1','12065','6.99','2005-08-17T21:31:46.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2109','77','2','12328','1.99','2005-08-18T06:43:56.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2110','77','2','13752','9.99','2005-08-20T11:17:45.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2111','77','2','14530','4.99','2005-08-21T15:10:50.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2112','77','2','15359','2.99','2005-08-22T21:34:00.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2113','78','1','2207','2.99','2005-06-18T02:19:21.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2114','78','2','2949','6.99','2005-06-20T06:05:53.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2115','78','2','3248','7.99','2005-06-21T03:12:21.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2116','78','1','3593','4.99','2005-07-06T04:39:52.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2117','78','2','4227','5.99','2005-07-07T12:41:36.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2118','78','2','4627','2.99','2005-07-08T08:24:39.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2119','78','2','4778','0.99','2005-07-08T15:51:51.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2120','78','1','5078','1.99','2005-07-09T05:20:24.000','2006-02-15T22:12:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2121','78','2','5604','0.99','2005-07-10T05:05:00.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2122','78','1','6005','0.99','2005-07-11T01:36:42.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2123','78','1','6344','4.99','2005-07-11T20:04:43.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2124','78','2','7200','1.99','2005-07-27T08:57:38.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2125','78','2','7747','4.99','2005-07-28T05:50:11.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2126','78','2','7926','3.99','2005-07-28T12:13:02.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2127','78','1','7957','6.99','2005-07-28T13:34:08.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2128','78','2','8920','4.99','2005-07-30T01:59:24.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2129','78','1','9068','5.99','2005-07-30T07:31:45.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2130','78','2','10350','3.99','2005-08-01T05:30:05.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2131','78','1','10590','2.99','2005-08-01T14:11:53.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2132','78','1','10831','7.99','2005-08-01T23:22:45.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2133','78','1','10942','10.99','2005-08-02T03:16:31.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2134','78','2','12474','8.99','2005-08-18T12:10:03.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2135','78','2','12653','4.99','2005-08-18T18:53:17.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2136','78','2','13124','5.99','2005-08-19T11:55:59.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2137','78','1','13432','0.99','2005-08-19T23:29:06.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2138','78','2','13792','5.99','2005-08-20T12:21:37.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2139','78','2','14620','2.99','2005-08-21T18:10:43.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2140','78','1','14716','0.99','2005-08-21T21:29:55.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2141','78','1','14810','2.99','2005-08-22T01:08:34.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2142','78','2','14862','7.99','2005-08-22T02:51:41.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2143','78','2','16039','2.99','2005-08-23T22:18:51.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2144','79','1','840','4.99','2005-05-30T00:28:41.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2145','79','1','859','2.99','2005-05-30T02:36:20.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2146','79','1','928','2.99','2005-05-30T12:27:14.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2147','79','2','3096','4.99','2005-06-20T16:17:56.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2148','79','2','3178','2.99','2005-06-20T22:35:12.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2149','79','1','3641','0.99','2005-07-06T07:17:09.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2150','79','1','3748','2.99','2005-07-06T12:11:22.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2151','79','2','4049','4.99','2005-07-07T03:34:53.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2152','79','1','4530','4.99','2005-07-08T03:27:05.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2153','79','2','4736','4.99','2005-07-08T13:22:55.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2154','79','2','5205','2.99','2005-07-09T10:56:37.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2155','79','1','5555','2.99','2005-07-10T03:08:55.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2156','79','2','6162','5.99','2005-07-11T10:12:30.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2157','79','1','7220','9.99','2005-07-27T09:35:54.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2158','79','1','8849','2.99','2005-07-29T23:21:01.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2159','79','1','9814','1.99','2005-07-31T11:29:46.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2160','79','2','9845','6.99','2005-07-31T12:28:05.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2161','79','1','9989','0.99','2005-07-31T17:22:39.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2162','79','1','10676','2.99','2005-08-01T17:14:15.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2163','79','2','11641','4.99','2005-08-17T04:45:39.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2164','79','2','13026','2.99','2005-08-19T08:22:45.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2165','79','1','14179','0.99','2005-08-21T03:14:27.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2166','80','1','2596','2.99','2005-06-19T05:48:26.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2167','80','2','2805','8.99','2005-06-19T19:29:17.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2168','80','1','3367','3.99','2005-06-21T13:08:21.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2169','80','2','3623','4.99','2005-07-06T06:05:23.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2170','80','2','4268','8.99','2005-07-07T14:36:05.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2171','80','2','4299','3.99','2005-07-07T16:33:48.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2172','80','1','4688','5.99','2005-07-08T11:03:29.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2173','80','2','5420','3.99','2005-07-09T20:48:42.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2174','80','2','5452','4.99','2005-07-09T22:23:21.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2175','80','1','6199','5.99','2005-07-11T12:16:03.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2176','80','2','6417','6.99','2005-07-11T23:35:11.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2177','80','2','6707','1.99','2005-07-12T13:07:55.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2178','80','2','7558','0.99','2005-07-27T22:19:08.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2179','80','1','8509','5.99','2005-07-29T09:38:19.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2180','80','1','8884','6.99','2005-07-30T00:26:22.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2181','80','1','10313','0.99','2005-08-01T04:29:29.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2182','80','1','10656','6.99','2005-08-01T16:38:04.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2183','80','1','10690','8.99','2005-08-01T18:05:54.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2184','80','2','11101','5.99','2005-08-02T08:08:24.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2185','80','2','11839','0.99','2005-08-17T13:08:45.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2186','80','1','11850','1.99','2005-08-17T13:30:15.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2187','80','2','12468','2.99','2005-08-18T11:41:47.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2188','80','1','13352','4.99','2005-08-19T20:51:40.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2189','80','2','13395','0.99','2005-08-19T22:05:40.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2190','80','1','13724','4.99','2005-08-20T10:07:28.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2191','80','2','13851','0.99','2005-08-20T14:44:22.000','2006-02-15T22:12:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2192','80','1','14916','0.99','2005-08-22T04:56:57.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2193','80','1','15648','8.99','2005-08-23T08:27:57.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2194','80','1','16012','5.99','2005-08-23T21:13:39.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2195','80','2','12457','2.99','2006-02-14T15:16:03.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2196','81','1','289','0.99','2005-05-26T20:01:09.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2197','81','1','2714','1.99','2005-06-19T14:26:09.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2198','81','1','2854','5.99','2005-06-19T23:11:48.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2199','81','1','3229','4.99','2005-06-21T02:20:41.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2200','81','1','3879','2.99','2005-07-06T18:31:20.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2201','81','2','4983','9.99','2005-07-09T00:34:16.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2202','81','1','5468','0.99','2005-07-09T23:06:09.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2203','81','2','7130','4.99','2005-07-27T06:23:36.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2204','81','1','7709','0.99','2005-07-28T04:22:14.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2205','81','2','9454','3.99','2005-07-30T22:20:09.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2206','81','2','10456','0.99','2005-08-01T09:17:21.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2207','81','1','11837','5.99','2005-08-17T13:04:41.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2208','81','2','12181','4.99','2005-08-18T01:28:18.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2209','81','2','13820','5.99','2005-08-20T13:26:37.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2210','81','1','14128','4.99','2005-08-21T01:35:58.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2211','81','1','14642','3.99','2005-08-21T19:09:40.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2212','81','2','14748','7.99','2005-08-21T23:02:02.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2213','81','1','15224','5.99','2005-08-22T17:18:05.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2214','81','1','15602','4.99','2005-08-23T06:41:07.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2215','81','1','15823','4.99','2005-08-23T15:08:00.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2216','81','1','15858','2.99','2005-08-23T16:07:15.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2217','81','2','15884','1.99','2005-08-23T16:45:28.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2218','82','2','145','2.99','2005-05-25T23:59:03.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2219','82','2','288','8.99','2005-05-26T19:47:49.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2220','82','1','1438','0.99','2005-06-15T18:38:51.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2221','82','2','1570','0.99','2005-06-16T03:21:33.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2222','82','1','2506','8.99','2005-06-18T23:29:53.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2223','82','1','2819','8.99','2005-06-19T20:13:33.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2224','82','2','3332','0.99','2005-06-21T09:55:12.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2225','82','1','3680','2.99','2005-07-06T09:16:10.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2226','82','1','4598','6.99','2005-07-08T06:46:26.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2227','82','2','5746','4.99','2005-07-10T12:15:12.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2228','82','2','6082','6.99','2005-07-11T05:12:41.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2229','82','2','6708','6.99','2005-07-12T13:10:55.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2230','82','2','7733','9.99','2005-07-28T05:04:47.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2231','82','2','7873','0.99','2005-07-28T10:19:46.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2232','82','1','8487','4.99','2005-07-29T08:53:49.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2233','82','2','9277','3.99','2005-07-30T15:13:45.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2234','82','1','9305','8.99','2005-07-30T16:45:56.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2235','82','1','9447','6.99','2005-07-30T21:54:22.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2236','82','1','11093','4.99','2005-08-02T07:59:49.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2237','82','2','11688','5.99','2005-08-17T06:41:58.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2238','82','1','12470','3.99','2005-08-18T11:55:42.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2239','82','1','13032','0.99','2005-08-19T08:31:50.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2240','82','2','13847','6.99','2005-08-20T14:33:59.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2241','82','2','14518','0.99','2005-08-21T14:58:58.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2242','82','2','14892','4.99','2005-08-22T04:15:05.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2243','82','2','15516','3.99','2005-08-23T03:12:54.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2244','83','2','222','0.99','2005-05-26T10:14:38.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2245','83','2','950','0.99','2005-05-30T16:06:08.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2246','83','2','989','2.99','2005-05-30T23:11:51.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2247','83','1','1354','5.99','2005-06-15T13:13:49.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2248','83','1','1591','5.99','2005-06-16T05:12:37.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2249','83','2','1617','3.99','2005-06-16T07:06:06.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2250','83','2','3230','4.99','2005-06-21T02:23:16.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2251','83','2','3722','6.99','2005-07-06T11:10:27.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2252','83','1','3754','2.99','2005-07-06T12:35:44.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2253','83','1','5218','0.99','2005-07-09T11:57:12.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2254','83','2','5394','6.99','2005-07-09T19:36:15.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2255','83','2','6194','2.99','2005-07-11T11:51:00.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2256','83','2','6861','2.99','2005-07-12T19:56:52.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2257','83','2','7721','0.99','2005-07-28T04:42:58.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2258','83','2','8729','4.99','2005-07-29T18:23:02.000','2006-02-15T22:12:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2259','83','1','9867','1.99','2005-07-31T13:17:04.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2260','83','1','11408','0.99','2005-08-02T19:25:13.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2261','83','1','11565','5.99','2005-08-17T01:28:05.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2262','83','2','11777','4.99','2005-08-17T10:27:19.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2263','83','1','12258','4.99','2005-08-18T04:11:13.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2264','83','2','12985','5.99','2005-08-19T07:08:05.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2265','83','1','13875','4.99','2005-08-20T15:13:11.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2266','83','2','15498','4.99','2005-08-23T02:33:27.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2267','83','2','15737','5.99','2005-08-23T11:52:18.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2268','83','2','11563','4.99','2006-02-14T15:16:03.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2269','84','2','408','0.99','2005-05-27T13:57:39.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2270','84','1','739','6.99','2005-05-29T08:28:18.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2271','84','1','834','4.99','2005-05-29T23:24:30.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2272','84','2','1195','0.99','2005-06-15T01:37:38.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2273','84','2','1320','4.99','2005-06-15T10:42:13.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2274','84','2','1815','0.99','2005-06-16T21:16:07.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2275','84','1','2012','5.99','2005-06-17T11:57:15.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2276','84','2','2042','0.99','2005-06-17T14:31:02.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2277','84','2','2409','0.99','2005-06-18T16:53:33.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2278','84','2','4079','6.99','2005-07-07T05:06:27.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2279','84','2','4838','6.99','2005-07-08T18:11:00.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2280','84','1','5221','5.99','2005-07-09T12:02:23.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2281','84','1','5237','0.99','2005-07-09T12:56:58.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2282','84','1','5971','5.99','2005-07-11T00:05:58.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2283','84','2','6259','2.99','2005-07-11T15:25:52.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2284','84','2','6415','9.99','2005-07-11T23:27:52.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2285','84','1','7854','2.99','2005-07-28T09:42:31.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2286','84','2','8019','4.99','2005-07-28T15:37:43.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2287','84','1','8654','8.99','2005-07-29T15:04:27.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2288','84','2','9074','2.99','2005-07-30T07:50:10.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2289','84','2','9680','4.99','2005-07-31T06:41:46.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2290','84','2','10540','0.99','2005-08-01T12:24:42.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2291','84','1','10872','2.99','2005-08-02T00:27:50.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2292','84','2','11220','4.99','2005-08-02T12:31:41.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2293','84','2','11424','3.99','2005-08-02T19:57:42.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2294','84','2','11453','7.99','2005-08-02T21:00:05.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2295','84','2','11899','0.99','2005-08-17T15:29:12.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2296','84','2','11960','4.99','2005-08-17T17:24:30.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2297','84','2','12364','4.99','2005-08-18T07:55:09.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2298','84','2','13115','2.99','2005-08-19T11:27:43.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2299','84','1','14330','5.99','2005-08-21T08:29:20.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2300','84','1','15190','4.99','2005-08-22T15:57:38.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2301','84','1','15255','2.99','2005-08-22T18:16:50.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2302','85','1','690','9.99','2005-05-29T00:54:53.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2303','85','2','908','4.99','2005-05-30T10:38:37.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2304','85','1','1685','1.99','2005-06-16T12:06:57.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2305','85','1','2131','5.99','2005-06-17T21:02:25.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2306','85','2','2794','0.99','2005-06-19T18:53:05.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2307','85','1','3165','4.99','2005-06-20T21:29:17.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2308','85','1','3307','1.99','2005-06-21T07:52:30.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2309','85','2','3418','3.99','2005-06-21T17:06:38.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2310','85','2','4451','0.99','2005-07-07T23:29:54.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2311','85','1','4705','2.99','2005-07-08T11:50:38.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2312','85','1','5051','4.99','2005-07-09T03:57:53.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2313','85','1','5519','0.99','2005-07-10T01:18:32.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2314','85','2','7906','0.99','2005-07-28T11:31:42.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2315','85','2','9427','7.99','2005-07-30T21:16:33.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2316','85','2','9957','4.99','2005-07-31T16:03:55.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2317','85','1','9985','2.99','2005-07-31T17:14:47.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2318','85','1','10328','4.99','2005-08-01T04:56:10.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2319','85','1','10548','0.99','2005-08-01T12:44:32.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2320','85','2','11067','8.99','2005-08-02T07:03:24.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2321','85','2','12036','0.99','2005-08-17T20:19:06.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2322','85','1','12456','4.99','2005-08-18T11:21:51.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2323','85','1','13727','3.99','2005-08-20T10:08:53.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2324','85','2','13733','0.99','2005-08-20T10:25:12.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2325','86','1','66','1.99','2005-05-25T09:35:12.000','2006-02-15T22:12:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2326','86','2','1640','4.99','2005-06-16T08:35:39.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2327','86','2','1822','0.99','2005-06-16T21:43:45.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2328','86','2','1924','2.99','2005-06-17T06:13:34.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2329','86','1','2141','4.99','2005-06-17T21:41:34.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2330','86','1','2518','4.99','2005-06-19T00:16:23.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2331','86','1','3207','0.99','2005-06-21T00:43:16.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2332','86','2','3270','4.99','2005-06-21T05:07:31.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2333','86','1','3611','0.99','2005-07-06T05:37:18.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2334','86','2','3945','4.99','2005-07-06T21:35:00.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2335','86','1','4235','2.99','2005-07-07T13:05:52.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2336','86','1','4571','9.99','2005-07-08T05:34:41.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2337','86','2','5295','0.99','2005-07-09T15:25:06.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2338','86','1','5752','8.99','2005-07-10T12:27:38.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2339','86','2','6872','7.99','2005-07-12T20:15:04.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2340','86','1','7231','2.99','2005-07-27T10:01:51.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2341','86','1','7874','10.99','2005-07-28T10:21:52.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2342','86','2','8803','5.99','2005-07-29T21:26:24.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2343','86','1','8850','2.99','2005-07-29T23:24:20.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2344','86','2','9376','4.99','2005-07-30T19:11:49.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2345','86','2','10252','8.99','2005-08-01T02:39:39.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2346','86','2','10536','4.99','2005-08-01T12:21:53.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2347','86','2','10584','6.99','2005-08-01T13:58:47.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2348','86','2','11916','0.99','2005-08-17T16:05:51.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2349','86','1','12198','2.99','2005-08-18T02:09:20.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2350','86','2','12870','3.99','2005-08-19T02:54:38.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2351','86','2','13338','4.99','2005-08-19T20:09:59.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2352','86','1','13535','4.99','2005-08-20T03:30:25.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2353','86','1','13874','2.99','2005-08-20T15:11:48.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2354','86','2','14122','1.99','2005-08-21T01:29:01.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2355','86','2','15099','4.99','2005-08-22T11:49:16.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2356','86','1','15715','1.99','2005-08-23T10:57:40.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2357','86','2','15940','5.99','2005-08-23T18:45:06.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2358','87','2','451','4.99','2005-05-27T19:27:54.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2359','87','1','674','2.99','2005-05-28T22:11:35.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2360','87','2','1580','4.99','2005-06-16T04:12:25.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2361','87','1','1904','2.99','2005-06-17T04:45:41.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2362','87','2','2408','2.99','2005-06-18T16:50:44.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2363','87','1','2516','4.99','2005-06-19T00:03:28.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2364','87','2','3122','9.99','2005-06-20T18:25:57.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2365','87','1','5084','7.99','2005-07-09T05:33:27.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2366','87','1','5628','3.99','2005-07-10T05:56:40.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2367','87','2','5700','4.99','2005-07-10T09:49:42.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2368','87','1','6638','4.99','2005-07-12T09:58:02.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2369','87','2','7599','2.99','2005-07-27T23:38:46.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2370','87','2','8187','7.99','2005-07-28T22:33:53.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2371','87','1','8286','5.99','2005-07-29T02:02:46.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2372','87','2','8323','4.99','2005-07-29T03:52:59.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2373','87','2','9060','0.99','2005-07-30T07:20:36.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2374','87','1','9348','2.99','2005-07-30T18:17:09.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2375','87','2','9364','8.99','2005-07-30T18:44:44.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2376','87','2','10205','4.99','2005-08-01T00:48:24.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2377','87','1','10387','4.99','2005-08-01T06:42:31.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2378','87','1','12232','0.99','2005-08-18T03:14:14.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2379','87','1','12257','8.99','2005-08-18T04:11:03.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2380','87','1','12264','5.99','2005-08-18T04:17:33.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2381','87','1','13479','0.99','2005-08-20T01:09:11.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2382','87','1','13906','0.99','2005-08-20T16:16:03.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2383','87','2','14024','10.99','2005-08-20T21:13:58.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2384','87','1','14566','2.99','2005-08-21T16:25:05.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2385','87','1','15876','2.99','2005-08-23T16:32:10.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2386','87','2','15890','4.99','2005-08-23T16:58:12.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2387','87','2','12719','4.99','2006-02-14T15:16:03.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2388','88','2','36','2.99','2005-05-25T04:36:26.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2389','88','1','1433','2.99','2005-06-15T18:30:00.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2390','88','1','2483','7.99','2005-06-18T21:22:23.000','2006-02-15T22:12:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2391','88','1','2878','2.99','2005-06-20T01:09:14.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2392','88','2','3524','0.99','2005-07-06T01:01:51.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2393','88','2','3620','0.99','2005-07-06T06:01:50.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2394','88','2','3673','5.99','2005-07-06T09:02:09.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2395','88','1','3846','5.99','2005-07-06T16:43:10.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2396','88','1','6643','1.99','2005-07-12T10:39:22.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2397','88','1','6916','4.99','2005-07-12T22:29:18.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2398','88','1','7088','5.99','2005-07-27T04:42:28.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2399','88','1','7621','8.99','2005-07-28T00:34:06.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2400','88','1','8296','2.99','2005-07-29T02:43:25.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2401','88','2','8526','2.99','2005-07-29T10:20:48.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2402','88','1','8692','2.99','2005-07-29T16:43:39.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2403','88','1','10424','0.99','2005-08-01T08:22:54.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2404','88','1','11056','6.99','2005-08-02T06:36:27.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2405','88','2','14097','2.99','2005-08-21T00:28:48.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2406','88','2','14827','5.99','2005-08-22T01:32:32.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2407','88','2','15098','3.99','2005-08-22T11:48:19.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2408','88','1','15898','4.99','2005-08-23T17:13:01.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2409','89','2','141','2.99','2005-05-25T23:34:53.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2410','89','2','588','0.99','2005-05-28T12:08:37.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2411','89','1','740','5.99','2005-05-29T08:30:36.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2412','89','1','1252','8.99','2005-06-15T06:05:18.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2413','89','2','1407','7.99','2005-06-15T16:45:07.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2414','89','1','1948','4.99','2005-06-17T08:06:53.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2415','89','1','2523','0.99','2005-06-19T00:45:56.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2416','89','1','2835','7.99','2005-06-19T21:44:11.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2417','89','2','4152','4.99','2005-07-07T08:50:33.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2418','89','1','4488','0.99','2005-07-08T01:22:23.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2419','89','1','4764','8.99','2005-07-08T15:01:25.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2420','89','2','5144','7.99','2005-07-09T08:09:53.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2421','89','2','5436','2.99','2005-07-09T21:31:11.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2422','89','1','5483','2.99','2005-07-09T23:54:09.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2423','89','1','6772','2.99','2005-07-12T15:55:35.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2424','89','2','7370','7.99','2005-07-27T15:15:53.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2425','89','2','7729','4.99','2005-07-28T04:57:57.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2426','89','2','7995','4.99','2005-07-28T15:00:09.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2427','89','1','8003','2.99','2005-07-28T15:11:27.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2428','89','2','8070','2.99','2005-07-28T17:26:56.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2429','89','2','8972','0.99','2005-07-30T04:06:25.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2430','89','1','9328','2.99','2005-07-30T17:32:11.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2431','89','2','9646','2.99','2005-07-31T05:43:28.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2432','89','2','9767','0.99','2005-07-31T09:46:49.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2433','89','2','10164','4.99','2005-07-31T23:17:57.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2434','89','2','10806','4.99','2005-08-01T22:25:29.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2435','89','1','11090','3.99','2005-08-02T07:56:40.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2436','89','1','12118','3.99','2005-08-17T23:14:25.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2437','89','2','12431','2.99','2005-08-18T10:34:59.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2438','89','1','12756','2.99','2005-08-18T22:52:13.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2439','89','1','13823','2.99','2005-08-20T13:42:10.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2440','89','1','15845','2.99','2005-08-23T15:38:34.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2441','90','2','2033','0.99','2005-06-17T13:24:43.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2442','90','2','2584','6.99','2005-06-19T05:02:36.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2443','90','2','3132','0.99','2005-06-20T19:09:46.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2444','90','2','3729','3.99','2005-07-06T11:30:29.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2445','90','2','4371','4.99','2005-07-07T20:06:45.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2446','90','2','5272','0.99','2005-07-09T14:26:01.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2447','90','2','5539','3.99','2005-07-10T02:42:58.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2448','90','2','7035','5.99','2005-07-27T03:06:09.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2449','90','2','7058','1.99','2005-07-27T03:50:46.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2450','90','1','7428','5.99','2005-07-27T17:21:52.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2451','90','1','7946','6.99','2005-07-28T13:01:22.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2452','90','1','8024','2.99','2005-07-28T15:55:40.000','2006-02-15T22:12:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2453','90','1','8408','0.99','2005-07-29T06:40:40.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2454','90','2','8870','9.99','2005-07-30T00:08:08.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2455','90','2','9337','2.99','2005-07-30T18:02:25.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2456','90','2','10206','7.99','2005-08-01T00:52:40.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2457','90','1','10722','4.99','2005-08-01T19:07:08.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2458','90','1','10835','4.99','2005-08-01T23:28:49.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2459','90','2','11231','4.99','2005-08-02T13:02:11.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2460','90','1','11516','0.99','2005-08-16T23:54:47.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2461','90','2','12019','0.99','2005-08-17T19:48:55.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2462','90','1','12788','2.99','2005-08-19T00:15:09.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2463','90','1','13051','4.99','2005-08-19T09:31:33.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2464','90','1','14608','1.99','2005-08-21T17:57:22.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2465','90','1','14807','4.99','2005-08-22T00:57:43.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2466','90','2','15061','0.99','2005-08-22T10:29:44.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2467','90','2','15217','0.99','2005-08-22T16:58:31.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2468','90','1','15674','7.99','2005-08-23T09:16:39.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2469','91','2','216','5.99','2005-05-26T09:17:43.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2470','91','1','1299','4.99','2005-06-15T09:34:50.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2471','91','1','2457','3.99','2005-06-18T19:38:20.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2472','91','1','2908','0.99','2005-06-20T03:16:52.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2473','91','2','3384','2.99','2005-06-21T14:07:35.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2474','91','2','3802','0.99','2005-07-06T15:06:09.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2475','91','2','4103','2.99','2005-07-07T06:25:28.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2476','91','1','4245','4.99','2005-07-07T13:48:33.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2477','91','1','4321','4.99','2005-07-07T17:52:38.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2478','91','1','4673','4.99','2005-07-08T10:16:00.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2479','91','2','5025','4.99','2005-07-09T02:28:24.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2480','91','2','5187','1.99','2005-07-09T10:19:51.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2481','91','2','5701','0.99','2005-07-10T09:56:24.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2482','91','1','6078','4.99','2005-07-11T05:06:52.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2483','91','1','6178','2.99','2005-07-11T10:59:09.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2484','91','2','6860','2.99','2005-07-12T19:54:17.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2485','91','2','7143','0.99','2005-07-27T06:56:31.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2486','91','2','7637','0.99','2005-07-28T01:12:25.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2487','91','1','7966','4.99','2005-07-28T13:53:54.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2488','91','1','8313','0.99','2005-07-29T03:34:21.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2489','91','2','8873','0.99','2005-07-30T00:14:32.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2490','91','2','9228','2.99','2005-07-30T13:36:57.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2491','91','2','9396','4.99','2005-07-30T20:07:24.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2492','91','2','10008','4.99','2005-07-31T17:59:36.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2493','91','2','11418','0.99','2005-08-02T19:45:33.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2494','91','1','12847','0.99','2005-08-19T02:04:07.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2495','91','2','13222','4.99','2005-08-19T15:47:58.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2496','91','2','13309','4.99','2005-08-19T19:04:00.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2497','91','1','14132','0.99','2005-08-21T01:43:58.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2498','91','2','14888','2.99','2005-08-22T04:09:18.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2499','91','1','15122','1.99','2005-08-22T12:47:45.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2500','91','1','15341','4.99','2005-08-22T20:56:31.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2501','91','1','15707','1.99','2005-08-23T10:35:45.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2502','91','2','15886','4.99','2005-08-23T16:50:53.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2503','91','1','12902','4.99','2006-02-14T15:16:03.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2504','92','1','271','5.99','2005-05-26T16:22:01.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2505','92','1','456','4.99','2005-05-27T19:50:06.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2506','92','2','2084','4.99','2005-06-17T17:17:19.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2507','92','1','2521','0.99','2005-06-19T00:41:08.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2508','92','1','2740','8.99','2005-06-19T15:59:04.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2509','92','2','3595','8.99','2005-07-06T04:59:49.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2510','92','2','3716','7.99','2005-07-06T10:52:32.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2511','92','1','4360','2.99','2005-07-07T19:31:12.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2512','92','2','4828','4.99','2005-07-08T17:52:29.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2513','92','2','5497','5.99','2005-07-10T00:23:23.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2514','92','2','5620','7.99','2005-07-10T05:30:52.000','2006-02-15T22:12:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2515','92','1','5792','6.99','2005-07-10T14:22:19.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2516','92','2','5919','2.99','2005-07-10T21:32:14.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2517','92','1','6158','0.99','2005-07-11T09:50:24.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2518','92','2','6277','6.99','2005-07-11T16:19:01.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2519','92','1','7073','4.99','2005-07-27T04:03:26.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2520','92','1','7832','1.99','2005-07-28T08:46:11.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2521','92','1','8494','4.99','2005-07-29T09:04:32.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2522','92','1','8938','4.99','2005-07-30T02:56:08.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2523','92','1','9240','4.99','2005-07-30T13:57:54.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2524','92','2','11203','4.99','2005-08-02T11:52:41.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2525','92','2','11245','2.99','2005-08-02T13:33:50.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2526','92','1','11849','4.99','2005-08-17T13:24:55.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2527','92','2','13020','5.99','2005-08-19T08:07:50.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2528','92','1','13495','0.99','2005-08-20T01:40:25.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2529','92','1','13620','2.99','2005-08-20T06:41:27.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2530','92','1','14798','0.99','2005-08-22T00:44:08.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2531','92','2','14998','4.99','2005-08-22T07:53:14.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2532','93','2','113','2.99','2005-05-25T19:07:40.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2533','93','2','420','6.99','2005-05-27T15:19:38.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2534','93','1','1025','4.99','2005-05-31T03:41:37.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2535','93','2','2256','4.99','2005-06-18T05:21:56.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2536','93','1','3109','0.99','2005-06-20T17:33:55.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2537','93','1','4733','2.99','2005-07-08T13:12:07.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2538','93','2','5130','4.99','2005-07-09T07:29:45.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2539','93','2','6287','4.99','2005-07-11T17:00:04.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2540','93','1','6586','4.99','2005-07-12T06:56:24.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2541','93','1','7301','2.99','2005-07-27T12:50:23.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2542','93','1','8233','0.99','2005-07-29T00:16:23.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2543','93','2','11271','5.99','2005-08-02T14:18:22.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2544','93','1','12704','4.99','2005-08-18T20:43:00.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2545','93','1','13555','2.99','2005-08-20T04:09:50.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2546','93','2','13904','2.99','2005-08-20T16:11:34.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2547','93','1','13950','8.99','2005-08-20T17:58:00.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2548','93','1','13993','4.99','2005-08-20T19:32:29.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2549','93','1','14195','0.99','2005-08-21T03:40:35.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2550','93','2','14333','4.99','2005-08-21T08:31:03.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2551','93','2','15324','5.99','2005-08-22T20:23:13.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2552','93','2','15631','2.99','2005-08-23T07:30:23.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2553','93','1','15696','0.99','2005-08-23T10:04:17.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2554','93','2','15913','1.99','2005-08-23T17:48:30.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2555','94','1','127','2.99','2005-05-25T21:10:40.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2556','94','2','629','4.99','2005-05-28T17:19:15.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2557','94','2','1213','2.99','2005-06-15T03:14:05.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2558','94','1','1367','4.99','2005-06-15T14:25:17.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2559','94','2','1734','3.99','2005-06-16T15:49:30.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2560','94','2','2620','4.99','2005-06-19T08:06:29.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2561','94','1','2816','2.99','2005-06-19T20:04:23.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2562','94','2','4044','0.99','2005-07-07T03:22:23.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2563','94','1','4287','8.99','2005-07-07T15:37:31.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2564','94','2','5719','4.99','2005-07-10T11:07:40.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2565','94','2','5970','4.99','2005-07-11T00:04:50.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2566','94','2','7809','2.99','2005-07-28T07:59:46.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2567','94','2','7979','0.99','2005-07-28T14:16:30.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2568','94','1','9605','4.99','2005-07-31T03:50:07.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2569','94','1','12316','2.99','2005-08-18T06:16:09.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2570','94','1','13786','5.99','2005-08-20T12:13:24.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2571','94','2','14804','1.99','2005-08-22T00:51:25.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2572','94','1','14865','4.99','2005-08-22T03:06:38.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2573','94','1','14978','0.99','2005-08-22T07:13:15.000','2006-02-15T22:12:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2574','94','1','15693','0.99','2005-08-23T10:00:24.000','2006-02-15T22:12:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2575','94','1','15371','4.99','2006-02-14T15:16:03.000','2006-02-15T22:12:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2576','95','1','490','4.99','2005-05-28T00:09:56.000','2006-02-15T22:12:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2577','95','2','1174','2.99','2005-06-15T00:12:51.000','2006-02-15T22:12:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2578','95','2','1261','1.99','2005-06-15T06:52:57.000','2006-02-15T22:12:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2579','95','2','3056','2.99','2005-06-20T13:20:58.000','2006-02-15T22:12:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2580','95','2','3426','0.99','2005-06-21T18:12:10.000','2006-02-15T22:12:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2581','95','1','3633','1.99','2005-07-06T06:43:26.000','2006-02-15T22:12:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2582','95','2','4000','4.99','2005-07-06T23:58:37.000','2006-02-15T22:12:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2583','95','1','4835','5.99','2005-07-08T18:08:13.000','2006-02-15T22:12:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2584','95','2','7245','5.99','2005-07-27T10:29:06.000','2006-02-15T22:12:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2585','95','1','7471','4.99','2005-07-27T19:02:19.000','2006-02-15T22:12:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2586','95','1','9222','6.99','2005-07-30T13:21:08.000','2006-02-15T22:12:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2587','95','1','9695','6.99','2005-07-31T07:13:30.000','2006-02-15T22:12:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2588','95','1','9951','4.99','2005-07-31T15:51:16.000','2006-02-15T22:12:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2589','95','1','10130','0.99','2005-07-31T21:44:30.000','2006-02-15T22:12:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2590','95','2','10446','0.99','2005-08-01T09:02:17.000','2006-02-15T22:12:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2591','95','2','12351','5.99','2005-08-18T07:32:12.000','2006-02-15T22:12:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2592','95','2','13516','7.99','2005-08-20T02:32:45.000','2006-02-15T22:12:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2593','95','2','14203','4.99','2005-08-21T03:51:52.000','2006-02-15T22:12:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2594','96','1','1266','3.99','2005-06-15T07:11:39.000','2006-02-15T22:12:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2595','96','2','1413','7.99','2005-06-15T17:25:07.000','2006-02-15T22:12:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2596','96','2','1437','0.99','2005-06-15T18:37:04.000','2006-02-15T22:12:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2597','96','1','2372','0.99','2005-06-18T14:37:37.000','2006-02-15T22:12:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2598','96','2','2973','5.99','2005-06-20T07:59:27.000','2006-02-15T22:12:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2599','96','1','3308','0.99','2005-06-21T07:58:36.000','2006-02-15T22:12:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2600','96','2','3463','0.99','2005-06-21T22:00:00.000','2006-02-15T22:12:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2601','96','1','3720','2.99','2005-07-06T11:06:57.000','2006-02-15T22:12:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2602','96','2','3742','2.99','2005-07-06T12:01:38.000','2006-02-15T22:12:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2603','96','1','4961','4.99','2005-07-08T23:35:53.000','2006-02-15T22:12:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2604','96','1','5558','0.99','2005-07-10T03:12:08.000','2006-02-15T22:12:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2605','96','1','5678','4.99','2005-07-10T08:42:42.000','2006-02-15T22:12:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2606','96','1','5696','2.99','2005-07-10T09:44:32.000','2006-02-15T22:12:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2607','96','2','8125','4.99','2005-07-28T19:31:48.000','2006-02-15T22:12:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2608','96','1','8437','6.99','2005-07-29T07:23:43.000','2006-02-15T22:12:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2609','96','2','9093','3.99','2005-07-30T08:33:24.000','2006-02-15T22:12:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2610','96','1','9315','4.99','2005-07-30T17:05:29.000','2006-02-15T22:12:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2611','96','1','9662','3.99','2005-07-31T06:09:53.000','2006-02-15T22:12:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2612','96','2','10031','4.99','2005-07-31T18:40:15.000','2006-02-15T22:12:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2613','96','2','11864','4.99','2005-08-17T14:02:01.000','2006-02-15T22:12:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2614','96','1','11984','3.99','2005-08-17T18:16:30.000','2006-02-15T22:12:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2615','96','1','12199','4.99','2005-08-18T02:09:23.000','2006-02-15T22:12:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2616','96','2','12525','4.99','2005-08-18T13:48:31.000','2006-02-15T22:12:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2617','96','1','13514','0.99','2005-08-20T02:28:09.000','2006-02-15T22:12:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2618','96','1','13855','4.99','2005-08-20T14:48:55.000','2006-02-15T22:12:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2619','96','1','14462','3.99','2005-08-21T12:50:57.000','2006-02-15T22:12:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2620','96','2','15989','4.99','2005-08-23T20:24:36.000','2006-02-15T22:12:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2621','97','2','2083','2.99','2005-06-17T17:14:00.000','2006-02-15T22:12:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2622','97','2','2790','4.99','2005-06-19T18:49:45.000','2006-02-15T22:12:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2623','97','1','3459','0.99','2005-06-21T21:45:47.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2624','97','1','3540','2.99','2005-07-06T01:47:20.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2625','97','2','3565','0.99','2005-07-06T03:02:58.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2626','97','2','3818','4.99','2005-07-06T15:33:31.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2627','97','2','4312','4.99','2005-07-07T17:34:59.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2628','97','1','4508','4.99','2005-07-08T02:28:41.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2629','97','2','5454','4.99','2005-07-09T22:24:25.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2630','97','1','6544','0.99','2005-07-12T04:56:15.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2631','97','1','6726','0.99','2005-07-12T13:48:14.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2632','97','2','7182','5.99','2005-07-27T08:15:38.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2633','97','2','7924','0.99','2005-07-28T12:08:53.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2634','97','2','8438','2.99','2005-07-29T07:25:42.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2635','97','1','9591','4.99','2005-07-31T03:19:28.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2636','97','1','10820','2.99','2005-08-01T22:53:40.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2637','97','2','14323','4.99','2005-08-21T08:08:43.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2638','97','1','15006','0.99','2005-08-22T08:20:15.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2639','98','2','214','3.99','2005-05-26T08:48:49.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2640','98','1','1362','3.99','2005-06-15T13:53:32.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2641','98','2','1590','5.99','2005-06-16T05:11:41.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2642','98','1','2213','4.99','2005-06-18T02:36:47.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2643','98','1','2445','0.99','2005-06-18T19:02:11.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2644','98','2','2601','4.99','2005-06-19T06:09:44.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2645','98','2','3399','4.99','2005-06-21T15:47:48.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2646','98','2','3682','7.99','2005-07-06T09:22:48.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2647','98','1','4549','4.99','2005-07-08T04:25:03.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2648','98','2','6951','2.99','2005-07-26T23:47:31.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2649','98','2','7120','3.99','2005-07-27T05:56:39.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2650','98','1','7530','0.99','2005-07-27T21:18:58.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2651','98','1','8324','5.99','2005-07-29T03:56:05.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2652','98','2','8622','4.99','2005-07-29T13:53:28.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2653','98','2','8818','5.99','2005-07-29T22:14:04.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2654','98','1','9753','2.99','2005-07-31T09:22:38.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2655','98','2','10694','3.99','2005-08-01T18:15:07.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2656','98','1','10925','2.99','2005-08-02T02:24:38.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2657','98','2','11007','0.99','2005-08-02T05:05:53.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2658','98','2','11200','2.99','2005-08-02T11:48:36.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2659','98','1','11635','5.99','2005-08-17T04:33:17.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2660','98','1','11730','2.99','2005-08-17T08:22:00.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2661','98','2','12221','5.99','2005-08-18T02:50:51.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2662','98','2','14459','1.99','2005-08-21T12:48:08.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2663','98','1','15536','7.99','2005-08-23T03:58:28.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2664','99','2','867','0.99','2005-05-30T03:54:43.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2665','99','1','1858','4.99','2005-06-17T01:13:11.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2666','99','1','2368','2.99','2005-06-18T14:10:27.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2667','99','2','3780','6.99','2005-07-06T13:52:02.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2668','99','2','4170','2.99','2005-07-07T09:44:36.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2669','99','2','4344','4.99','2005-07-07T18:50:47.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2670','99','1','4589','0.99','2005-07-08T06:26:04.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2671','99','2','4800','4.99','2005-07-08T16:51:08.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2672','99','2','4954','2.99','2005-07-08T23:14:16.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2673','99','2','5035','2.99','2005-07-09T02:51:34.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2674','99','1','5748','2.99','2005-07-10T12:19:59.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2675','99','1','6289','2.99','2005-07-11T17:06:39.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2676','99','1','6370','3.99','2005-07-11T21:28:32.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2677','99','2','6662','4.99','2005-07-12T11:21:06.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2678','99','1','7039','4.99','2005-07-27T03:11:48.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2679','99','1','8072','0.99','2005-07-28T17:27:59.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2680','99','2','8242','7.99','2005-07-29T00:34:27.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2681','99','2','8514','0.99','2005-07-29T09:53:33.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2682','99','2','10388','7.99','2005-08-01T06:42:44.000','2006-02-15T22:12:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2683','99','1','10455','1.99','2005-08-01T09:15:00.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2684','99','2','11266','4.99','2005-08-02T14:07:35.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2685','99','2','12379','0.99','2005-08-18T08:26:48.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2686','99','2','12869','8.99','2005-08-19T02:50:36.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2687','99','1','11593','0.99','2006-02-14T15:16:03.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2688','100','1','71','0.99','2005-05-25T10:26:39.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2689','100','2','1216','4.99','2005-06-15T03:23:48.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2690','100','1','1340','3.99','2005-06-15T12:24:15.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2691','100','1','1427','2.99','2005-06-15T18:17:28.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2692','100','2','3468','6.99','2005-06-21T22:43:45.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2693','100','2','3602','5.99','2005-07-06T05:23:10.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2694','100','1','3800','8.99','2005-07-06T15:01:27.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2695','100','1','4209','2.99','2005-07-07T11:35:08.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2696','100','1','4970','8.99','2005-07-08T23:54:29.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2697','100','2','4980','6.99','2005-07-09T00:26:59.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2698','100','2','5238','4.99','2005-07-09T13:11:14.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2699','100','2','5355','6.99','2005-07-09T18:07:17.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2700','100','1','6655','4.99','2005-07-12T11:08:32.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2701','100','2','7819','4.99','2005-07-28T08:27:14.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2702','100','1','7921','1.99','2005-07-28T12:02:46.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2703','100','2','8203','0.99','2005-07-28T23:14:56.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2704','100','2','9048','5.99','2005-07-30T06:57:07.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2705','100','1','9271','4.99','2005-07-30T15:04:31.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2706','100','1','11143','0.99','2005-08-02T09:32:54.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2707','100','2','11346','4.99','2005-08-02T17:15:38.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2708','100','1','12657','0.99','2005-08-18T19:02:16.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2709','100','1','15163','0.99','2005-08-22T14:43:13.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2710','100','2','15246','3.99','2005-08-22T17:50:49.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2711','100','2','15021','0.99','2006-02-14T15:16:03.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2712','101','1','468','9.99','2005-05-27T21:13:10.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2713','101','1','4975','2.99','2005-07-09T00:02:46.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2714','101','2','5100','2.99','2005-07-09T06:16:03.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2715','101','1','5132','5.99','2005-07-09T07:40:32.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2716','101','2','5198','2.99','2005-07-09T10:49:10.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2717','101','1','5757','2.99','2005-07-10T12:40:17.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2718','101','2','6433','5.99','2005-07-12T00:12:02.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2719','101','2','7112','5.99','2005-07-27T05:38:42.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2720','101','2','7866','8.99','2005-07-28T10:08:01.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2721','101','1','8301','0.99','2005-07-29T03:00:08.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2722','101','2','8825','1.99','2005-07-29T22:24:16.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2723','101','2','8833','4.99','2005-07-29T22:39:36.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2724','101','2','9965','6.99','2005-07-31T16:19:32.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2725','101','2','10218','0.99','2005-08-01T01:09:44.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2726','101','1','10253','6.99','2005-08-01T02:39:49.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2727','101','1','10407','0.99','2005-08-01T07:38:07.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2728','101','2','11959','4.99','2005-08-17T17:23:35.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2729','101','2','12174','2.99','2005-08-18T01:08:53.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2730','101','1','12471','4.99','2005-08-18T11:57:00.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2731','101','2','13370','1.99','2005-08-19T21:20:11.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2732','101','1','14476','0.99','2005-08-21T13:31:07.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2733','101','2','14542','3.99','2005-08-21T15:36:34.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2734','101','2','15103','2.99','2005-08-22T12:01:06.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2735','101','2','12141','0.99','2006-02-14T15:16:03.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2736','102','1','247','4.99','2005-05-26T14:01:05.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2737','102','1','358','0.99','2005-05-27T06:43:59.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2738','102','2','562','1.99','2005-05-28T09:01:21.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2739','102','2','1215','2.99','2005-06-15T03:21:00.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2740','102','2','2419','8.99','2005-06-18T17:21:24.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2741','102','2','3520','1.99','2005-07-06T00:58:27.000','2006-02-15T22:13:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2742','102','2','3630','1.99','2005-07-06T06:27:15.000','2006-02-15T22:13:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2743','102','2','3665','4.99','2005-07-06T08:23:08.000','2006-02-15T22:13:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2744','102','1','4089','6.99','2005-07-07T05:45:59.000','2006-02-15T22:13:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2745','102','2','4777','3.99','2005-07-08T15:48:34.000','2006-02-15T22:13:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2746','102','1','4997','6.99','2005-07-09T01:06:03.000','2006-02-15T22:13:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2747','102','1','5009','5.99','2005-07-09T01:32:17.000','2006-02-15T22:13:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2748','102','1','5109','4.99','2005-07-09T06:48:49.000','2006-02-15T22:13:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2749','102','2','5509','5.99','2005-07-10T00:54:46.000','2006-02-15T22:13:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2750','102','1','5716','2.99','2005-07-10T10:59:23.000','2006-02-15T22:13:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2751','102','2','6434','5.99','2005-07-12T00:14:25.000','2006-02-15T22:13:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2752','102','2','7119','0.99','2005-07-27T05:55:32.000','2006-02-15T22:13:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2753','102','2','7247','0.99','2005-07-27T10:32:58.000','2006-02-15T22:13:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2754','102','2','7439','6.99','2005-07-27T17:42:31.000','2006-02-15T22:13:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2755','102','1','8186','0.99','2005-07-28T22:30:27.000','2006-02-15T22:13:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2756','102','1','8664','5.99','2005-07-29T15:36:27.000','2006-02-15T22:13:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2757','102','2','9151','3.99','2005-07-30T10:50:53.000','2006-02-15T22:13:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2758','102','1','9192','2.99','2005-07-30T12:26:26.000','2006-02-15T22:13:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2759','102','2','9295','0.99','2005-07-30T16:18:39.000','2006-02-15T22:13:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2760','102','2','9617','2.99','2005-07-31T04:15:38.000','2006-02-15T22:13:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2761','102','1','9780','4.99','2005-07-31T10:10:22.000','2006-02-15T22:13:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2762','102','2','10841','1.99','2005-08-01T23:39:21.000','2006-02-15T22:13:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2763','102','2','11099','4.99','2005-08-02T08:07:12.000','2006-02-15T22:13:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2764','102','1','11183','4.99','2005-08-02T11:00:32.000','2006-02-15T22:13:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2765','102','2','12495','4.99','2005-08-18T12:56:37.000','2006-02-15T22:13:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2766','102','1','13420','9.99','2005-08-19T22:57:25.000','2006-02-15T22:13:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2767','102','1','15049','1.99','2005-08-22T10:06:28.000','2006-02-15T22:13:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2768','102','2','16031','3.99','2005-08-23T21:59:26.000','2006-02-15T22:13:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2769','103','1','240','7.99','2005-05-26T12:40:23.000','2006-02-15T22:13:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2770','103','1','658','9.99','2005-05-28T20:23:23.000','2006-02-15T22:13:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2771','103','2','1396','4.99','2005-06-15T16:22:38.000','2006-02-15T22:13:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2772','103','1','2118','0.99','2005-06-17T20:28:29.000','2006-02-15T22:13:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2773','103','1','2197','0.99','2005-06-18T01:50:27.000','2006-02-15T22:13:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2774','103','1','2724','0.99','2005-06-19T14:57:54.000','2006-02-15T22:13:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2775','103','2','3750','6.99','2005-07-06T12:19:28.000','2006-02-15T22:13:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2776','103','1','3850','4.99','2005-07-06T16:51:21.000','2006-02-15T22:13:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2777','103','2','4040','6.99','2005-07-07T03:02:40.000','2006-02-15T22:13:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2778','103','1','4213','2.99','2005-07-07T11:53:49.000','2006-02-15T22:13:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2779','103','1','4357','1.99','2005-07-07T19:24:39.000','2006-02-15T22:13:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2780','103','2','4872','4.99','2005-07-08T19:23:16.000','2006-02-15T22:13:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2781','103','2','5163','4.99','2005-07-09T09:00:28.000','2006-02-15T22:13:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2782','103','1','6525','5.99','2005-07-12T04:17:15.000','2006-02-15T22:13:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2783','103','2','6697','6.99','2005-07-12T12:44:57.000','2006-02-15T22:13:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2784','103','2','6949','2.99','2005-07-26T23:44:12.000','2006-02-15T22:13:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2785','103','1','7310','0.99','2005-07-27T13:00:55.000','2006-02-15T22:13:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2786','103','2','7472','6.99','2005-07-27T19:04:19.000','2006-02-15T22:13:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2787','103','1','8302','0.99','2005-07-29T03:01:24.000','2006-02-15T22:13:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2788','103','1','8520','4.99','2005-07-29T10:10:02.000','2006-02-15T22:13:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2789','103','2','9390','4.99','2005-07-30T19:42:07.000','2006-02-15T22:13:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2790','103','2','12942','7.99','2005-08-19T05:40:36.000','2006-02-15T22:13:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2791','103','1','13676','0.99','2005-08-20T08:33:21.000','2006-02-15T22:13:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2792','103','2','14064','2.99','2005-08-20T22:39:16.000','2006-02-15T22:13:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2793','103','2','14289','4.99','2005-08-21T06:58:49.000','2006-02-15T22:13:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2794','103','2','15401','8.99','2005-08-22T23:13:10.000','2006-02-15T22:13:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2795','103','1','15461','5.99','2005-08-23T01:13:52.000','2006-02-15T22:13:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2796','103','1','15467','3.99','2005-08-23T01:22:12.000','2006-02-15T22:13:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2797','103','1','15599','5.99','2005-08-23T06:25:07.000','2006-02-15T22:13:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2798','103','2','15679','0.99','2005-08-23T09:27:29.000','2006-02-15T22:13:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2799','103','2','16048','8.99','2005-08-23T22:43:07.000','2006-02-15T22:13:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2800','104','1','163','10.99','2005-05-26T02:26:23.000','2006-02-15T22:13:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2801','104','2','808','3.99','2005-05-29T19:08:20.000','2006-02-15T22:13:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2802','104','2','1287','3.99','2005-06-15T08:41:38.000','2006-02-15T22:13:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2803','104','1','2107','0.99','2005-06-17T19:31:16.000','2006-02-15T22:13:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2804','104','2','2928','0.99','2005-06-20T04:43:45.000','2006-02-15T22:13:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2805','104','2','3273','2.99','2005-06-21T05:24:17.000','2006-02-15T22:13:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2806','104','2','4012','4.99','2005-07-07T00:56:09.000','2006-02-15T22:13:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2807','104','2','4438','6.99','2005-07-07T22:56:17.000','2006-02-15T22:13:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2808','104','2','4520','4.99','2005-07-08T02:53:46.000','2006-02-15T22:13:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2809','104','1','4529','7.99','2005-07-08T03:26:20.000','2006-02-15T22:13:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2810','104','1','4917','2.99','2005-07-08T21:32:30.000','2006-02-15T22:13:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2811','104','1','5376','1.99','2005-07-09T18:54:08.000','2006-02-15T22:13:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2812','104','2','7107','2.99','2005-07-27T05:22:04.000','2006-02-15T22:13:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2813','104','1','8413','1.99','2005-07-29T06:47:39.000','2006-02-15T22:13:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2814','104','1','9090','3.99','2005-07-30T08:24:42.000','2006-02-15T22:13:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2815','104','2','9996','5.99','2005-07-31T17:32:03.000','2006-02-15T22:13:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2816','104','1','11700','2.99','2005-08-17T07:12:31.000','2006-02-15T22:13:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2817','104','1','12453','3.99','2005-08-18T11:17:07.000','2006-02-15T22:13:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2818','104','1','13005','0.99','2005-08-19T07:45:42.000','2006-02-15T22:13:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2819','104','1','13017','1.99','2005-08-19T08:02:24.000','2006-02-15T22:13:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2820','104','1','13179','4.99','2005-08-19T13:59:53.000','2006-02-15T22:13:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2821','104','1','13410','3.99','2005-08-19T22:41:44.000','2006-02-15T22:13:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2822','104','1','14218','3.99','2005-08-21T04:43:59.000','2006-02-15T22:13:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2823','104','2','15186','0.99','2005-08-22T15:52:57.000','2006-02-15T22:13:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2824','105','1','327','8.99','2005-05-27T01:18:57.000','2006-02-15T22:13:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2825','105','2','473','7.99','2005-05-27T21:36:34.000','2006-02-15T22:13:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2826','105','1','485','2.99','2005-05-27T23:40:52.000','2006-02-15T22:13:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2827','105','1','779','6.99','2005-05-29T14:17:17.000','2006-02-15T22:13:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2828','105','2','1789','3.99','2005-06-16T19:49:18.000','2006-02-15T22:13:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2829','105','2','1991','3.99','2005-06-17T10:49:23.000','2006-02-15T22:13:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2830','105','2','2635','3.99','2005-06-19T09:08:45.000','2006-02-15T22:13:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2831','105','2','5261','4.99','2005-07-09T14:06:56.000','2006-02-15T22:13:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2832','105','1','5429','4.99','2005-07-09T21:14:03.000','2006-02-15T22:13:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2833','105','2','5542','2.99','2005-07-10T02:45:53.000','2006-02-15T22:13:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2834','105','2','5677','4.99','2005-07-10T08:41:28.000','2006-02-15T22:13:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2835','105','2','6546','4.99','2005-07-12T04:57:17.000','2006-02-15T22:13:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2836','105','1','7442','2.99','2005-07-27T17:47:00.000','2006-02-15T22:13:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2837','105','2','8980','2.99','2005-07-30T04:22:15.000','2006-02-15T22:13:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2838','105','2','9124','3.99','2005-07-30T09:43:12.000','2006-02-15T22:13:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2839','105','2','9198','5.99','2005-07-30T12:37:08.000','2006-02-15T22:13:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2840','105','2','9210','9.99','2005-07-30T12:56:44.000','2006-02-15T22:13:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2841','105','1','10513','4.99','2005-08-01T11:37:34.000','2006-02-15T22:13:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2842','105','1','12217','0.99','2005-08-18T02:44:44.000','2006-02-15T22:13:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2843','105','2','12899','2.99','2005-08-19T04:03:34.000','2006-02-15T22:13:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2844','105','1','13057','6.99','2005-08-19T09:40:05.000','2006-02-15T22:13:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2845','105','1','13751','2.99','2005-08-20T11:17:03.000','2006-02-15T22:13:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2846','105','2','14048','0.99','2005-08-20T22:03:18.000','2006-02-15T22:13:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2847','105','2','15624','4.99','2005-08-23T07:24:27.000','2006-02-15T22:13:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2848','105','2','15688','4.99','2005-08-23T09:48:45.000','2006-02-15T22:13:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2849','105','2','15803','2.99','2005-08-23T14:27:07.000','2006-02-15T22:13:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2850','106','2','552','3.99','2005-05-28T07:53:38.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2851','106','2','1156','0.99','2005-05-31T22:37:34.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2852','106','1','2295','4.99','2005-06-18T07:56:18.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2853','106','1','3023','4.99','2005-06-20T11:18:11.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2854','106','1','4229','4.99','2005-07-07T12:43:23.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2855','106','2','4277','2.99','2005-07-07T14:52:12.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2856','106','1','4665','3.99','2005-07-08T10:04:24.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2857','106','2','5453','3.99','2005-07-09T22:24:11.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2858','106','2','6992','0.99','2005-07-27T01:04:45.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2859','106','1','7224','3.99','2005-07-27T09:44:26.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2860','106','1','7483','4.99','2005-07-27T19:25:00.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2861','106','1','8115','4.99','2005-07-28T19:14:17.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2862','106','2','9072','2.99','2005-07-30T07:45:49.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2863','106','2','9747','7.99','2005-07-31T09:16:57.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2864','106','2','10213','8.99','2005-08-01T01:03:18.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2865','106','1','10228','2.99','2005-08-01T01:43:18.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2866','106','1','10444','8.99','2005-08-01T09:01:40.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2867','106','2','11436','0.99','2005-08-02T20:16:06.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2868','106','1','12159','7.99','2005-08-18T00:36:09.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2869','106','1','12845','2.99','2005-08-19T02:02:37.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2870','106','2','14431','2.99','2005-08-21T11:31:15.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2871','106','1','14920','0.99','2005-08-22T05:08:58.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2872','106','1','15154','6.99','2005-08-22T14:27:37.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2873','107','1','170','5.99','2005-05-26T03:11:12.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2874','107','1','1026','5.99','2005-05-31T03:45:26.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2875','107','2','1243','2.99','2005-06-15T05:07:32.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2876','107','2','2693','6.99','2005-06-19T13:11:47.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2877','107','2','2860','4.99','2005-06-19T23:20:40.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2878','107','2','2897','3.99','2005-06-20T02:34:23.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2879','107','1','3033','3.99','2005-06-20T12:02:05.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2880','107','2','3120','0.99','2005-06-20T18:19:29.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2881','107','2','3174','0.99','2005-06-20T22:24:00.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2882','107','2','3824','6.99','2005-07-06T15:43:15.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2883','107','2','5311','4.99','2005-07-09T16:02:54.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2884','107','2','5575','2.99','2005-07-10T03:55:50.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2885','107','2','5798','3.99','2005-07-10T14:45:09.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2886','107','2','6131','2.99','2005-07-11T08:22:05.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2887','107','2','6133','0.99','2005-07-11T08:25:22.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2888','107','1','6811','5.99','2005-07-12T17:54:33.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2889','107','2','6934','6.99','2005-07-26T23:11:03.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2890','107','2','7447','4.99','2005-07-27T18:02:08.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2891','107','1','7600','7.99','2005-07-27T23:41:18.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2892','107','1','8162','4.99','2005-07-28T21:11:46.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2893','107','2','8704','1.99','2005-07-29T17:13:45.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2894','107','1','9155','2.99','2005-07-30T11:00:00.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2895','107','2','9351','2.99','2005-07-30T18:28:30.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2896','107','1','10226','4.99','2005-08-01T01:40:04.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2897','107','2','13361','4.99','2005-08-19T21:07:22.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2898','107','1','13510','6.99','2005-08-20T02:18:30.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2899','107','1','14562','4.99','2005-08-21T16:22:59.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2900','107','1','15560','3.99','2005-08-23T05:01:13.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2901','107','1','13079','1.98','2006-02-14T15:16:03.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2902','107','1','15497','0','2006-02-14T15:16:03.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2903','108','1','105','4.99','2005-05-25T17:54:12.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2904','108','2','1055','0.99','2005-05-31T07:47:18.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2905','108','2','1372','4.99','2005-06-15T14:45:48.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2906','108','1','1425','2.99','2005-06-15T18:13:46.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2907','108','1','2061','8.99','2005-06-17T15:47:00.000','2006-02-15T22:13:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2908','108','1','2210','2.99','2005-06-18T02:27:01.000','2006-02-15T22:13:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2909','108','2','3116','4.99','2005-06-20T18:04:55.000','2006-02-15T22:13:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2910','108','1','3875','0.99','2005-07-06T18:15:39.000','2006-02-15T22:13:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2911','108','2','4082','2.99','2005-07-07T05:11:53.000','2006-02-15T22:13:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2912','108','1','4303','1.99','2005-07-07T16:57:32.000','2006-02-15T22:13:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2913','108','1','4650','4.99','2005-07-08T09:32:08.000','2006-02-15T22:13:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2914','108','1','4754','0.99','2005-07-08T14:20:01.000','2006-02-15T22:13:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2915','108','2','5274','6.99','2005-07-09T14:34:09.000','2006-02-15T22:13:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2916','108','1','5661','5.99','2005-07-10T07:53:51.000','2006-02-15T22:13:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2917','108','2','5806','4.99','2005-07-10T15:11:54.000','2006-02-15T22:13:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2918','108','1','6841','0.99','2005-07-12T19:04:24.000','2006-02-15T22:13:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2919','108','2','8329','5.99','2005-07-29T04:06:33.000','2006-02-15T22:13:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2920','108','2','8587','4.99','2005-07-29T12:18:40.000','2006-02-15T22:13:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2921','108','1','8846','4.99','2005-07-29T23:10:28.000','2006-02-15T22:13:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2922','108','2','9755','4.99','2005-07-31T09:24:55.000','2006-02-15T22:13:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2923','108','1','11316','5.99','2005-08-02T16:07:49.000','2006-02-15T22:13:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2924','108','2','11445','6.99','2005-08-02T20:33:35.000','2006-02-15T22:13:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2925','108','2','11759','2.99','2005-08-17T09:41:23.000','2006-02-15T22:13:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2926','108','1','12583','2.99','2005-08-18T15:51:36.000','2006-02-15T22:13:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2927','108','2','12625','6.99','2005-08-18T17:36:19.000','2006-02-15T22:13:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2928','108','2','13754','2.99','2005-08-20T11:18:08.000','2006-02-15T22:13:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2929','108','2','14635','3.99','2005-08-21T18:51:43.000','2006-02-15T22:13:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2930','108','2','15556','8.99','2005-08-23T04:52:16.000','2006-02-15T22:13:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2931','108','1','16001','2.99','2005-08-23T20:45:53.000','2006-02-15T22:13:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2932','108','1','15294','4.99','2006-02-14T15:16:03.000','2006-02-15T22:13:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2933','109','1','203','5.99','2005-05-26T07:27:57.000','2006-02-15T22:13:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2934','109','1','386','0.99','2005-05-27T10:26:31.000','2006-02-15T22:13:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2935','109','2','622','3.99','2005-05-28T15:58:22.000','2006-02-15T22:13:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2936','109','1','698','0.99','2005-05-29T02:10:52.000','2006-02-15T22:13:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2937','109','1','1061','7.99','2005-05-31T08:27:58.000','2006-02-15T22:13:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2938','109','1','1106','4.99','2005-05-31T14:36:52.000','2006-02-15T22:13:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2939','109','1','1115','2.99','2005-05-31T16:07:09.000','2006-02-15T22:13:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2940','109','2','1581','2.99','2005-06-16T04:28:45.000','2006-02-15T22:13:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2941','109','2','1891','3.99','2005-06-17T04:16:44.000','2006-02-15T22:13:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2942','109','2','2198','6.99','2005-06-18T01:51:22.000','2006-02-15T22:13:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2943','109','2','2679','5.99','2005-06-19T12:12:30.000','2006-02-15T22:13:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2944','109','2','3076','5.99','2005-06-20T15:01:19.000','2006-02-15T22:13:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2945','109','1','4921','4.99','2005-07-08T21:43:21.000','2006-02-15T22:13:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2946','109','1','5027','2.99','2005-07-09T02:32:37.000','2006-02-15T22:13:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2947','109','2','5296','2.99','2005-07-09T15:26:27.000','2006-02-15T22:13:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2948','109','2','6920','6.99','2005-07-12T22:32:58.000','2006-02-15T22:13:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2949','109','2','7145','0.99','2005-07-27T07:01:00.000','2006-02-15T22:13:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2950','109','1','8006','3.99','2005-07-28T15:15:41.000','2006-02-15T22:13:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2951','109','1','9230','0.99','2005-07-30T13:39:42.000','2006-02-15T22:13:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2952','109','1','9871','2.99','2005-07-31T13:25:46.000','2006-02-15T22:13:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2953','109','2','10240','0.99','2005-08-01T02:09:33.000','2006-02-15T22:13:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2954','109','2','10892','3.99','2005-08-02T01:12:06.000','2006-02-15T22:13:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2955','109','2','12137','6.99','2005-08-17T23:52:26.000','2006-02-15T22:13:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2956','109','1','13264','3.99','2005-08-19T17:27:10.000','2006-02-15T22:13:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2957','109','2','15398','7.99','2005-08-22T23:10:49.000','2006-02-15T22:13:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2958','109','2','15677','2.99','2005-08-23T09:23:36.000','2006-02-15T22:13:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2959','110','1','515','7.99','2005-05-28T03:10:10.000','2006-02-15T22:13:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2960','110','2','538','1.99','2005-05-28T06:21:05.000','2006-02-15T22:13:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2961','110','2','1528','8.99','2005-06-16T00:32:52.000','2006-02-15T22:13:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2962','110','1','3587','4.99','2005-07-06T04:27:52.000','2006-02-15T22:13:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2963','110','1','4317','2.99','2005-07-07T17:44:49.000','2006-02-15T22:13:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2964','110','2','4827','4.99','2005-07-08T17:46:30.000','2006-02-15T22:13:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2965','110','1','6160','4.99','2005-07-11T10:08:13.000','2006-02-15T22:13:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2966','110','1','7474','0.99','2005-07-27T19:07:17.000','2006-02-15T22:13:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2967','110','2','7542','0.99','2005-07-27T21:43:04.000','2006-02-15T22:13:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2968','110','1','7570','2.99','2005-07-27T22:40:06.000','2006-02-15T22:13:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2969','110','1','11647','7.99','2005-08-17T04:54:14.000','2006-02-15T22:13:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2970','110','2','12585','3.99','2005-08-18T15:52:12.000','2006-02-15T22:13:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2971','110','1','13723','2.99','2005-08-20T10:05:30.000','2006-02-15T22:13:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2972','110','2','15381','2.99','2005-08-22T22:28:36.000','2006-02-15T22:13:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2973','111','2','505','2.99','2005-05-28T02:06:37.000','2006-02-15T22:13:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2974','111','1','1593','6.99','2005-06-16T05:14:52.000','2006-02-15T22:13:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2975','111','2','1974','2.99','2005-06-17T09:30:05.000','2006-02-15T22:13:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2976','111','2','1999','1.99','2005-06-17T11:30:08.000','2006-02-15T22:13:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2977','111','2','2297','4.99','2005-06-18T08:17:41.000','2006-02-15T22:13:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2978','111','2','3087','2.99','2005-06-20T15:53:59.000','2006-02-15T22:13:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2979','111','2','3333','2.99','2005-06-21T10:01:36.000','2006-02-15T22:13:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2980','111','2','3485','1.99','2005-07-05T23:25:54.000','2006-02-15T22:13:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2981','111','1','3551','3.99','2005-07-06T02:33:48.000','2006-02-15T22:13:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2982','111','2','3963','9.99','2005-07-06T22:19:17.000','2006-02-15T22:13:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2983','111','1','4249','4.99','2005-07-07T14:05:17.000','2006-02-15T22:13:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2984','111','2','4286','0.99','2005-07-07T15:36:44.000','2006-02-15T22:13:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2985','111','1','6896','2.99','2005-07-12T21:25:37.000','2006-02-15T22:13:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2986','111','2','8525','0.99','2005-07-29T10:20:19.000','2006-02-15T22:13:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2987','111','2','9933','0.99','2005-07-31T15:24:46.000','2006-02-15T22:13:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2988','111','2','10039','2.99','2005-07-31T18:50:40.000','2006-02-15T22:13:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2989','111','2','10602','4.99','2005-08-01T14:30:23.000','2006-02-15T22:13:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2990','111','1','10952','4.99','2005-08-02T03:28:21.000','2006-02-15T22:13:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2991','111','2','10990','4.99','2005-08-02T04:41:06.000','2006-02-15T22:13:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2992','111','2','11239','2.99','2005-08-02T13:27:11.000','2006-02-15T22:13:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2993','111','2','12196','3.99','2005-08-18T02:08:48.000','2006-02-15T22:13:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2994','111','2','13251','2.99','2005-08-19T16:48:37.000','2006-02-15T22:13:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2995','111','2','13525','5.99','2005-08-20T02:50:44.000','2006-02-15T22:13:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2996','111','1','14949','0.99','2005-08-22T06:12:16.000','2006-02-15T22:13:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2997','111','2','15174','6.99','2005-08-22T15:26:36.000','2006-02-15T22:13:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2998','111','2','15542','2.99','2006-02-14T15:16:03.000','2006-02-15T22:13:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('2999','112','1','396','0.99','2005-05-27T11:47:04.000','2006-02-15T22:13:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3000','112','2','701','2.99','2005-05-29T02:26:27.000','2006-02-15T22:13:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3001','112','1','1835','4.99','2005-06-16T23:05:36.000','2006-02-15T22:13:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3002','112','2','1930','2.99','2005-06-17T06:50:46.000','2006-02-15T22:13:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3003','112','1','2193','4.99','2005-06-18T01:38:45.000','2006-02-15T22:13:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3004','112','2','3018','2.99','2005-06-20T11:10:35.000','2006-02-15T22:13:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3005','112','1','5351','4.99','2005-07-09T17:40:52.000','2006-02-15T22:13:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3006','112','1','5385','2.99','2005-07-09T19:18:11.000','2006-02-15T22:13:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3007','112','2','6550','2.99','2005-07-12T05:03:14.000','2006-02-15T22:13:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3008','112','2','7691','4.99','2005-07-28T03:30:09.000','2006-02-15T22:13:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3009','112','2','7761','4.99','2005-07-28T06:31:45.000','2006-02-15T22:13:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3010','112','1','9217','4.99','2005-07-30T13:13:55.000','2006-02-15T22:13:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3011','112','2','9321','6.99','2005-07-30T17:19:44.000','2006-02-15T22:13:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3012','112','2','9609','4.99','2005-07-31T03:53:24.000','2006-02-15T22:13:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3013','112','1','9830','5.99','2005-07-31T11:59:05.000','2006-02-15T22:13:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3014','112','2','9911','3.99','2005-07-31T14:48:01.000','2006-02-15T22:13:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3015','112','1','10038','2.99','2005-07-31T18:49:12.000','2006-02-15T22:13:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3016','112','2','10596','5.99','2005-08-01T14:18:57.000','2006-02-15T22:13:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3017','112','1','11019','2.99','2005-08-02T05:29:31.000','2006-02-15T22:13:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3018','112','1','11599','7.99','2005-08-17T03:08:10.000','2006-02-15T22:13:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3019','112','2','11659','4.99','2005-08-17T05:20:45.000','2006-02-15T22:13:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3020','112','2','11863','3.99','2005-08-17T13:56:01.000','2006-02-15T22:13:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3021','112','2','13611','8.99','2005-08-20T06:20:42.000','2006-02-15T22:13:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3022','112','2','13879','2.99','2005-08-20T15:18:10.000','2006-02-15T22:13:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3023','112','2','14049','5.99','2005-08-20T22:08:55.000','2006-02-15T22:13:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3024','112','1','14358','0.99','2005-08-21T09:14:28.000','2006-02-15T22:13:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3025','112','2','15304','4.99','2005-08-22T19:45:57.000','2006-02-15T22:13:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3026','112','1','15671','0.99','2005-08-23T09:08:16.000','2006-02-15T22:13:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3027','112','1','15687','8.99','2005-08-23T09:46:33.000','2006-02-15T22:13:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3028','112','1','15756','2.99','2005-08-23T12:47:05.000','2006-02-15T22:13:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3029','113','1','510','0.99','2005-05-28T02:52:14.000','2006-02-15T22:13:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3030','113','2','776','0.99','2005-05-29T13:35:35.000','2006-02-15T22:13:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3031','113','2','2077','4.99','2005-06-17T16:46:11.000','2006-02-15T22:13:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3032','113','1','2282','2.99','2005-06-18T06:48:23.000','2006-02-15T22:13:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3033','113','1','2783','2.99','2005-06-19T18:29:10.000','2006-02-15T22:13:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3034','113','2','3004','0.99','2005-06-20T10:04:36.000','2006-02-15T22:13:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3035','113','1','3124','8.99','2005-06-20T18:28:19.000','2006-02-15T22:13:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3036','113','1','3162','6.99','2005-06-20T21:21:15.000','2006-02-15T22:13:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3037','113','2','3657','5.99','2005-07-06T07:55:30.000','2006-02-15T22:13:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3038','113','1','4333','2.99','2005-07-07T18:31:50.000','2006-02-15T22:13:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3039','113','2','5189','2.99','2005-07-09T10:23:21.000','2006-02-15T22:13:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3040','113','2','5324','2.99','2005-07-09T16:34:18.000','2006-02-15T22:13:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3041','113','2','5655','4.99','2005-07-10T07:31:06.000','2006-02-15T22:13:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3042','113','1','5774','5.99','2005-07-10T13:31:56.000','2006-02-15T22:13:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3043','113','1','6025','0.99','2005-07-11T02:18:13.000','2006-02-15T22:13:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3044','113','1','6836','0.99','2005-07-12T18:58:05.000','2006-02-15T22:13:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3045','113','2','7468','5.99','2005-07-27T18:52:27.000','2006-02-15T22:13:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3046','113','2','7587','2.99','2005-07-27T23:23:03.000','2006-02-15T22:13:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3047','113','2','9221','6.99','2005-07-30T13:20:06.000','2006-02-15T22:13:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3048','113','2','10181','4.99','2005-08-01T00:00:44.000','2006-02-15T22:13:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3049','113','1','10378','0.99','2005-08-01T06:30:04.000','2006-02-15T22:13:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3050','113','2','10578','1.99','2005-08-01T13:48:02.000','2006-02-15T22:13:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3051','113','2','11655','7.99','2005-08-17T05:11:07.000','2006-02-15T22:13:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3052','113','1','11872','5.99','2005-08-17T14:11:45.000','2006-02-15T22:13:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3053','113','1','12392','5.99','2005-08-18T08:57:58.000','2006-02-15T22:13:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3054','113','2','12817','3.99','2005-08-19T01:04:35.000','2006-02-15T22:13:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3055','113','2','13406','2.99','2005-08-19T22:22:01.000','2006-02-15T22:13:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3056','113','1','15600','1.99','2005-08-23T06:31:24.000','2006-02-15T22:13:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3057','113','1','15770','2.99','2005-08-23T13:18:16.000','2006-02-15T22:13:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3058','114','1','205','4.99','2005-05-26T07:59:37.000','2006-02-15T22:13:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3059','114','1','255','4.99','2005-05-26T14:52:15.000','2006-02-15T22:13:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3060','114','2','889','2.99','2005-05-30T07:14:53.000','2006-02-15T22:13:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3061','114','1','2059','2.99','2005-06-17T15:36:12.000','2006-02-15T22:13:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3062','114','2','2680','7.99','2005-06-19T12:13:37.000','2006-02-15T22:13:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3063','114','1','3094','2.99','2005-06-20T16:06:51.000','2006-02-15T22:13:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3064','114','2','3144','5.99','2005-06-20T20:14:20.000','2006-02-15T22:13:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3065','114','1','3484','4.99','2005-07-05T23:23:11.000','2006-02-15T22:13:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3066','114','1','3924','2.99','2005-07-06T20:38:02.000','2006-02-15T22:13:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3067','114','1','4025','0.99','2005-07-07T02:13:24.000','2006-02-15T22:13:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3068','114','1','5418','0.99','2005-07-09T20:41:35.000','2006-02-15T22:13:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3069','114','2','5624','4.99','2005-07-10T05:43:16.000','2006-02-15T22:13:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3070','114','1','5625','2.99','2005-07-10T05:44:02.000','2006-02-15T22:13:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3071','114','1','6188','2.99','2005-07-11T11:31:47.000','2006-02-15T22:13:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3072','114','1','6754','4.99','2005-07-12T14:59:24.000','2006-02-15T22:13:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3073','114','2','7316','2.99','2005-07-27T13:19:03.000','2006-02-15T22:13:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3074','114','2','7462','2.99','2005-07-27T18:47:47.000','2006-02-15T22:13:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3075','114','2','7565','2.99','2005-07-27T22:33:59.000','2006-02-15T22:13:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3076','114','2','7938','5.99','2005-07-28T12:39:11.000','2006-02-15T22:13:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3077','114','2','8496','4.99','2005-07-29T09:05:33.000','2006-02-15T22:13:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3078','114','1','8590','10.99','2005-07-29T12:32:20.000','2006-02-15T22:13:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3079','114','1','9717','4.99','2005-07-31T08:24:41.000','2006-02-15T22:13:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3080','114','1','11547','4.99','2005-08-17T00:59:24.000','2006-02-15T22:13:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3081','114','2','12326','0.99','2005-08-18T06:41:59.000','2006-02-15T22:13:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3082','114','1','12685','6.99','2005-08-18T19:51:29.000','2006-02-15T22:13:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3083','114','2','13459','6.99','2005-08-20T00:45:40.000','2006-02-15T22:13:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3084','114','2','14158','5.99','2005-08-21T02:43:20.000','2006-02-15T22:13:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3085','114','1','14867','4.99','2005-08-22T03:14:46.000','2006-02-15T22:13:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3086','114','1','15485','0.99','2005-08-23T02:04:57.000','2006-02-15T22:13:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3087','114','1','15528','2.99','2005-08-23T03:45:40.000','2006-02-15T22:13:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3088','114','2','15646','3.99','2005-08-23T08:19:55.000','2006-02-15T22:13:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3089','114','1','16047','0.99','2005-08-23T22:42:48.000','2006-02-15T22:13:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3090','114','2','12506','4.99','2006-02-14T15:16:03.000','2006-02-15T22:13:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3091','115','1','915','0.99','2005-05-30T11:20:27.000','2006-02-15T22:13:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3092','115','1','983','0.99','2005-05-30T22:15:51.000','2006-02-15T22:13:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3093','115','1','1102','2.99','2005-05-31T14:20:29.000','2006-02-15T22:13:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3094','115','2','1361','0.99','2005-06-15T13:37:38.000','2006-02-15T22:13:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3095','115','2','1515','2.99','2005-06-15T23:07:50.000','2006-02-15T22:13:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3096','115','1','3289','6.99','2005-06-21T06:41:48.000','2006-02-15T22:13:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3097','115','2','3544','0.99','2005-07-06T02:06:32.000','2006-02-15T22:13:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3098','115','1','3624','0.99','2005-07-06T06:06:27.000','2006-02-15T22:13:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3099','115','1','4780','1.99','2005-07-08T16:06:51.000','2006-02-15T22:13:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3100','115','1','5245','4.99','2005-07-09T13:24:14.000','2006-02-15T22:13:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3101','115','1','6080','2.99','2005-07-11T05:08:11.000','2006-02-15T22:13:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3102','115','2','6113','2.99','2005-07-11T07:31:08.000','2006-02-15T22:13:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3103','115','1','6373','0.99','2005-07-11T21:35:20.000','2006-02-15T22:13:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3104','115','1','6574','5.99','2005-07-12T06:04:22.000','2006-02-15T22:13:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3105','115','1','6798','6.99','2005-07-12T16:49:11.000','2006-02-15T22:13:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3106','115','2','7355','1.99','2005-07-27T14:45:59.000','2006-02-15T22:13:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3107','115','2','7465','4.99','2005-07-27T18:50:30.000','2006-02-15T22:13:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3108','115','1','7983','4.99','2005-07-28T14:23:01.000','2006-02-15T22:13:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3109','115','1','8594','4.99','2005-07-29T12:42:13.000','2006-02-15T22:13:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3110','115','2','9578','0.99','2005-07-31T02:54:31.000','2006-02-15T22:13:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3111','115','2','10022','3.99','2005-07-31T18:25:30.000','2006-02-15T22:13:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3112','115','2','10475','4.99','2005-08-01T10:03:17.000','2006-02-15T22:13:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3113','115','2','10647','2.99','2005-08-01T16:08:46.000','2006-02-15T22:13:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3114','115','2','10919','0.99','2005-08-02T02:11:03.000','2006-02-15T22:13:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3115','115','1','11891','2.99','2005-08-17T15:11:55.000','2006-02-15T22:13:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3116','115','2','12366','0.99','2005-08-18T07:55:14.000','2006-02-15T22:13:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3117','115','2','13977','0.99','2005-08-20T19:02:34.000','2006-02-15T22:13:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3118','115','1','15176','6.99','2005-08-22T15:30:25.000','2006-02-15T22:13:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3119','115','2','15452','0.99','2005-08-23T00:57:12.000','2006-02-15T22:13:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3120','115','2','13056','2.99','2006-02-14T15:16:03.000','2006-02-15T22:13:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3121','116','1','1058','4.99','2005-05-31T08:04:17.000','2006-02-15T22:13:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3122','116','2','1332','0.99','2005-06-15T11:36:01.000','2006-02-15T22:13:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3123','116','2','1533','0.99','2005-06-16T00:46:02.000','2006-02-15T22:13:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3124','116','2','1762','4.99','2005-06-16T17:50:19.000','2006-02-15T22:13:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3125','116','2','1913','4.99','2005-06-17T05:19:47.000','2006-02-15T22:13:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3126','116','1','2639','4.99','2005-06-19T09:24:02.000','2006-02-15T22:13:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3127','116','1','2861','3.99','2005-06-19T23:21:34.000','2006-02-15T22:13:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3128','116','2','3908','6.99','2005-07-06T19:47:26.000','2006-02-15T22:13:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3129','116','2','3940','2.99','2005-07-06T21:16:59.000','2006-02-15T22:13:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3130','116','1','4027','0.99','2005-07-07T02:19:01.000','2006-02-15T22:13:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3131','116','2','4737','4.99','2005-07-08T13:23:53.000','2006-02-15T22:13:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3132','116','2','5169','2.99','2005-07-09T09:22:25.000','2006-02-15T22:13:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3133','116','1','6557','4.99','2005-07-12T05:12:03.000','2006-02-15T22:13:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3134','116','1','7238','0.99','2005-07-27T10:13:41.000','2006-02-15T22:13:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3135','116','2','7763','5.99','2005-07-28T06:35:16.000','2006-02-15T22:13:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3136','116','2','9245','6.99','2005-07-30T14:07:50.000','2006-02-15T22:13:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3137','116','1','9562','3.99','2005-07-31T02:23:20.000','2006-02-15T22:13:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3138','116','2','10250','1.99','2005-08-01T02:38:42.000','2006-02-15T22:13:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3139','116','1','10801','1.99','2005-08-01T22:09:35.000','2006-02-15T22:13:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3140','116','2','11016','4.99','2005-08-02T05:19:13.000','2006-02-15T22:13:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3141','116','2','12376','2.99','2005-08-18T08:20:29.000','2006-02-15T22:13:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3142','116','2','13146','7.99','2005-08-19T12:54:42.000','2006-02-15T22:13:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3143','116','1','13369','0.99','2005-08-19T21:19:47.000','2006-02-15T22:13:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3144','116','1','13474','0.99','2005-08-20T01:04:32.000','2006-02-15T22:13:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3145','116','1','13775','6.99','2005-08-20T11:56:30.000','2006-02-15T22:13:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3146','116','2','14763','11.99','2005-08-21T23:34:00.000','2006-02-15T22:13:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3147','116','1','14907','2.99','2005-08-22T04:44:09.000','2006-02-15T22:13:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3148','117','1','700','0.99','2005-05-29T02:18:54.000','2006-02-15T22:13:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3149','117','2','1114','0.99','2005-05-31T16:00:33.000','2006-02-15T22:13:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3150','117','1','1755','2.99','2005-06-16T17:18:44.000','2006-02-15T22:13:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3151','117','2','3218','2.99','2005-06-21T01:38:09.000','2006-02-15T22:13:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3152','117','2','5506','5.99','2005-07-10T00:45:48.000','2006-02-15T22:13:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3153','117','1','5673','0.99','2005-07-10T08:21:54.000','2006-02-15T22:13:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3154','117','1','6093','9.99','2005-07-11T05:52:50.000','2006-02-15T22:13:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3155','117','1','6449','6.99','2005-07-12T00:48:58.000','2006-02-15T22:13:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3156','117','1','8687','2.99','2005-07-29T16:19:17.000','2006-02-15T22:13:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3157','117','2','10556','2.99','2005-08-01T12:58:42.000','2006-02-15T22:13:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3158','117','1','10558','4.99','2005-08-01T13:00:20.000','2006-02-15T22:13:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3159','117','2','11467','3.99','2005-08-02T21:47:07.000','2006-02-15T22:13:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3160','117','1','12143','2.99','2005-08-18T00:06:26.000','2006-02-15T22:13:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3161','117','1','12337','2.99','2005-08-18T07:02:24.000','2006-02-15T22:13:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3162','117','1','12575','6.99','2005-08-18T15:37:42.000','2006-02-15T22:13:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3163','117','1','12618','4.99','2005-08-18T17:24:02.000','2006-02-15T22:13:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3164','117','1','14784','0.99','2005-08-22T00:23:13.000','2006-02-15T22:13:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3165','117','2','14854','2.99','2005-08-22T02:26:47.000','2006-02-15T22:13:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3166','117','1','15432','2.99','2005-08-23T00:26:52.000','2006-02-15T22:13:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3167','118','2','351','5.99','2005-05-27T05:39:03.000','2006-02-15T22:13:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3168','118','2','1766','4.99','2005-06-16T17:59:37.000','2006-02-15T22:13:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3169','118','2','2217','0.99','2005-06-18T03:12:29.000','2006-02-15T22:13:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3170','118','1','3263','4.99','2005-06-21T04:15:52.000','2006-02-15T22:13:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3171','118','1','4966','0.99','2005-07-08T23:47:25.000','2006-02-15T22:13:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3172','118','1','5829','1.99','2005-07-10T16:29:41.000','2006-02-15T22:13:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3173','118','1','6377','0.99','2005-07-11T21:41:16.000','2006-02-15T22:13:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3174','118','1','6507','1.99','2005-07-12T03:33:12.000','2006-02-15T22:13:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3175','118','1','7196','2.99','2005-07-27T08:49:08.000','2006-02-15T22:13:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3176','118','1','7850','4.99','2005-07-28T09:31:13.000','2006-02-15T22:13:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3177','118','2','7956','4.99','2005-07-28T13:32:17.000','2006-02-15T22:13:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3178','118','1','8314','3.99','2005-07-29T03:35:04.000','2006-02-15T22:13:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3179','118','2','8760','7.99','2005-07-29T19:22:40.000','2006-02-15T22:13:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3180','118','1','8881','4.99','2005-07-30T00:22:31.000','2006-02-15T22:13:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3181','118','2','10045','1.99','2005-07-31T19:04:35.000','2006-02-15T22:13:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3182','118','2','12538','2.99','2005-08-18T14:09:09.000','2006-02-15T22:13:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3183','118','2','13193','6.99','2005-08-19T14:33:45.000','2006-02-15T22:13:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3184','118','2','14394','5.99','2005-08-21T10:23:10.000','2006-02-15T22:13:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3185','118','2','14595','7.99','2005-08-21T17:35:17.000','2006-02-15T22:13:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3186','118','1','14924','2.99','2005-08-22T05:15:17.000','2006-02-15T22:13:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3187','118','1','15731','0.99','2005-08-23T11:33:25.000','2006-02-15T22:13:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3188','119','2','67','0.99','2005-05-25T09:41:01.000','2006-02-15T22:13:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3189','119','1','235','5.99','2005-05-26T11:51:09.000','2006-02-15T22:13:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3190','119','2','540','6.99','2005-05-28T06:40:25.000','2006-02-15T22:13:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3191','119','1','1179','7.99','2005-06-15T00:36:50.000','2006-02-15T22:13:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3192','119','2','2009','2.99','2005-06-17T11:48:31.000','2006-02-15T22:13:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3193','119','2','3388','5.99','2005-06-21T14:34:51.000','2006-02-15T22:13:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3194','119','2','4840','8.99','2005-07-08T18:18:16.000','2006-02-15T22:13:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3195','119','1','5176','5.99','2005-07-09T09:39:31.000','2006-02-15T22:13:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3196','119','1','5268','0.99','2005-07-09T14:22:43.000','2006-02-15T22:13:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3197','119','1','6079','7.99','2005-07-11T05:07:14.000','2006-02-15T22:13:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3198','119','2','6330','0.99','2005-07-11T19:15:42.000','2006-02-15T22:13:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3199','119','2','8140','4.99','2005-07-28T20:17:50.000','2006-02-15T22:13:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3200','119','1','8183','5.99','2005-07-28T22:21:07.000','2006-02-15T22:13:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3201','119','1','8304','4.99','2005-07-29T03:08:30.000','2006-02-15T22:13:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3202','119','2','9028','2.99','2005-07-30T06:00:35.000','2006-02-15T22:13:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3203','119','1','10101','0.99','2005-07-31T20:47:29.000','2006-02-15T22:13:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3204','119','1','10366','3.99','2005-08-01T06:09:37.000','2006-02-15T22:13:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3205','119','2','10552','2.99','2005-08-01T12:49:44.000','2006-02-15T22:13:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3206','119','1','10681','4.99','2005-08-01T17:30:35.000','2006-02-15T22:13:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3207','119','2','11377','2.99','2005-08-02T18:16:47.000','2006-02-15T22:13:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3208','119','1','11520','5.99','2005-08-17T00:04:28.000','2006-02-15T22:13:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3209','119','2','12576','2.99','2005-08-18T15:38:31.000','2006-02-15T22:13:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3210','119','2','12603','3.99','2005-08-18T16:56:20.000','2006-02-15T22:13:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3211','119','2','12842','6.99','2005-08-19T01:57:21.000','2006-02-15T22:13:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3212','119','1','13581','4.99','2005-08-20T05:26:15.000','2006-02-15T22:13:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3213','119','2','14349','3.99','2005-08-21T08:54:53.000','2006-02-15T22:13:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3214','119','2','14382','2.99','2005-08-21T10:01:03.000','2006-02-15T22:13:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3215','119','2','14643','6.99','2005-08-21T19:11:58.000','2006-02-15T22:13:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3216','119','2','14659','0.99','2005-08-21T19:42:36.000','2006-02-15T22:13:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3217','119','1','15111','4.99','2005-08-22T12:21:43.000','2006-02-15T22:13:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3218','119','2','15131','3.99','2005-08-22T13:06:26.000','2006-02-15T22:13:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3219','119','2','15171','6.99','2005-08-22T15:23:59.000','2006-02-15T22:13:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3220','119','1','15844','2.99','2005-08-23T15:38:12.000','2006-02-15T22:13:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3221','119','2','16028','3.99','2005-08-23T21:52:56.000','2006-02-15T22:13:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3222','120','2','68','7.99','2005-05-25T09:47:31.000','2006-02-15T22:13:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3223','120','2','532','0.99','2005-05-28T05:36:58.000','2006-02-15T22:13:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3224','120','1','1374','3.99','2005-06-15T14:49:54.000','2006-02-15T22:13:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3225','120','1','1820','4.99','2005-06-16T21:34:50.000','2006-02-15T22:13:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3226','120','2','1932','2.99','2005-06-17T06:54:41.000','2006-02-15T22:13:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3227','120','1','2169','4.99','2005-06-17T23:57:23.000','2006-02-15T22:13:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3228','120','1','2803','9.99','2005-06-19T19:18:27.000','2006-02-15T22:13:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3229','120','1','3133','2.99','2005-06-20T19:18:32.000','2006-02-15T22:13:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3230','120','1','4001','5.99','2005-07-07T00:07:00.000','2006-02-15T22:13:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3231','120','2','4272','3.99','2005-07-07T14:39:20.000','2006-02-15T22:13:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3232','120','2','4342','0.99','2005-07-07T18:47:03.000','2006-02-15T22:13:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3233','120','2','4666','9.99','2005-07-08T10:05:02.000','2006-02-15T22:13:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3234','120','1','4942','1.99','2005-07-08T22:42:47.000','2006-02-15T22:13:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3235','120','2','5288','1.99','2005-07-09T15:13:07.000','2006-02-15T22:13:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3236','120','2','6503','0.99','2005-07-12T03:18:07.000','2006-02-15T22:13:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3237','120','1','6989','4.99','2005-07-27T01:00:34.000','2006-02-15T22:13:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3238','120','2','8046','0.99','2005-07-28T16:49:41.000','2006-02-15T22:13:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3239','120','2','8756','1.99','2005-07-29T19:18:57.000','2006-02-15T22:13:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3240','120','1','8998','6.99','2005-07-30T04:54:14.000','2006-02-15T22:13:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3241','120','2','9907','6.99','2005-07-31T14:39:50.000','2006-02-15T22:13:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3242','120','2','10161','0.99','2005-07-31T23:09:41.000','2006-02-15T22:13:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3243','120','2','10696','4.99','2005-08-01T18:18:13.000','2006-02-15T22:13:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3244','120','1','10940','3.99','2005-08-02T03:08:29.000','2006-02-15T22:13:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3245','120','2','11133','0.99','2005-08-02T09:15:45.000','2006-02-15T22:13:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3246','120','2','13167','2.99','2005-08-19T13:36:41.000','2006-02-15T22:13:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3247','120','2','13375','7.99','2005-08-19T21:31:31.000','2006-02-15T22:13:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3248','120','1','14001','2.99','2005-08-20T20:07:15.000','2006-02-15T22:13:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3249','120','1','14153','4.99','2005-08-21T02:24:33.000','2006-02-15T22:13:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3250','120','1','14246','4.99','2005-08-21T05:34:09.000','2006-02-15T22:13:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3251','120','2','14460','9.99','2005-08-21T12:48:48.000','2006-02-15T22:13:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3252','120','2','14969','6.99','2005-08-22T06:49:15.000','2006-02-15T22:13:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3253','120','1','15780','4.99','2006-02-14T15:16:03.000','2006-02-15T22:13:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3254','121','1','217','4.99','2005-05-26T09:24:26.000','2006-02-15T22:13:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3255','121','1','1634','2.99','2005-06-16T08:16:05.000','2006-02-15T22:13:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3256','121','1','1833','1.99','2005-06-16T22:45:03.000','2006-02-15T22:13:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3257','121','2','5670','0.99','2005-07-10T08:14:52.000','2006-02-15T22:13:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3258','121','2','6780','4.99','2005-07-12T16:18:12.000','2006-02-15T22:13:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3259','121','2','7114','0.99','2005-07-27T05:42:13.000','2006-02-15T22:13:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3260','121','1','7185','0.99','2005-07-27T08:23:54.000','2006-02-15T22:13:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3261','121','2','7298','2.99','2005-07-27T12:45:14.000','2006-02-15T22:13:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3262','121','1','8370','6.99','2005-07-29T05:16:21.000','2006-02-15T22:13:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3263','121','2','8788','1.99','2005-07-29T20:46:44.000','2006-02-15T22:13:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3264','121','2','8875','2.99','2005-07-30T00:15:09.000','2006-02-15T22:13:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3265','121','2','8969','8.99','2005-07-30T04:00:19.000','2006-02-15T22:13:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3266','121','2','10457','5.99','2005-08-01T09:17:34.000','2006-02-15T22:13:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3267','121','2','11720','8.99','2005-08-17T07:46:54.000','2006-02-15T22:13:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3268','121','2','12242','1.99','2005-08-18T03:37:31.000','2006-02-15T22:13:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3269','121','2','12428','3.99','2005-08-18T10:24:21.000','2006-02-15T22:13:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3270','121','2','12734','1.99','2005-08-18T22:04:52.000','2006-02-15T22:13:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3271','121','1','12881','5.99','2005-08-19T03:28:13.000','2006-02-15T22:13:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3272','121','2','12892','0.99','2005-08-19T03:46:34.000','2006-02-15T22:13:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3273','121','1','14138','7.99','2005-08-21T01:59:37.000','2006-02-15T22:13:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3274','121','1','14177','4.99','2005-08-21T03:11:33.000','2006-02-15T22:13:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3275','121','2','14412','9.99','2005-08-21T11:02:09.000','2006-02-15T22:13:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3276','121','1','14464','2.99','2005-08-21T12:52:54.000','2006-02-15T22:13:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3277','121','2','15114','7.99','2005-08-22T12:24:55.000','2006-02-15T22:13:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3278','121','1','15369','0.99','2005-08-22T21:58:06.000','2006-02-15T22:13:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3279','121','1','16041','2.99','2005-08-23T22:20:26.000','2006-02-15T22:13:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3280','122','2','853','0.99','2005-05-30T01:43:31.000','2006-02-15T22:13:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3281','122','2','1135','4.99','2005-05-31T19:15:11.000','2006-02-15T22:13:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3282','122','1','1211','0.99','2005-06-15T03:01:20.000','2006-02-15T22:13:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3283','122','2','1442','7.99','2005-06-15T18:55:34.000','2006-02-15T22:13:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3284','122','2','2240','3.99','2005-06-18T04:28:27.000','2006-02-15T22:13:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3285','122','1','2253','0.99','2005-06-18T05:11:43.000','2006-02-15T22:13:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3286','122','1','2482','4.99','2005-06-18T21:10:44.000','2006-02-15T22:13:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3287','122','2','2595','4.99','2005-06-19T05:43:55.000','2006-02-15T22:13:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3288','122','2','2834','1.99','2005-06-19T21:41:46.000','2006-02-15T22:13:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3289','122','1','3778','2.99','2005-07-06T13:44:48.000','2006-02-15T22:13:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3290','122','2','3986','4.99','2005-07-06T23:25:13.000','2006-02-15T22:13:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3291','122','1','4239','7.99','2005-07-07T13:23:17.000','2006-02-15T22:13:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3292','122','1','4568','4.99','2005-07-08T05:23:59.000','2006-02-15T22:13:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3293','122','2','5235','6.99','2005-07-09T12:54:25.000','2006-02-15T22:13:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3294','122','2','6231','0.99','2005-07-11T14:02:36.000','2006-02-15T22:13:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3295','122','1','6427','0.99','2005-07-11T23:57:34.000','2006-02-15T22:13:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3296','122','1','6436','0.99','2005-07-12T00:18:42.000','2006-02-15T22:13:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3297','122','2','6974','7.99','2005-07-27T00:39:16.000','2006-02-15T22:13:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3298','122','1','7267','2.99','2005-07-27T11:22:55.000','2006-02-15T22:13:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3299','122','2','7950','4.99','2005-07-28T13:21:00.000','2006-02-15T22:13:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3300','122','1','8077','2.99','2005-07-28T17:54:35.000','2006-02-15T22:13:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3301','122','2','8177','0.99','2005-07-28T21:43:54.000','2006-02-15T22:13:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3302','122','1','8772','5.99','2005-07-29T19:55:25.000','2006-02-15T22:13:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3303','122','2','9910','4.99','2005-07-31T14:47:57.000','2006-02-15T22:13:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3304','122','1','10626','1.99','2005-08-01T15:32:41.000','2006-02-15T22:13:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3305','122','2','11044','3.99','2005-08-02T06:05:27.000','2006-02-15T22:13:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3306','122','2','11197','2.99','2005-08-02T11:45:07.000','2006-02-15T22:13:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3307','122','2','12476','4.99','2005-08-18T12:22:40.000','2006-02-15T22:13:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3308','122','2','12711','4.99','2005-08-18T21:03:32.000','2006-02-15T22:13:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3309','122','1','13171','2.99','2005-08-19T13:48:54.000','2006-02-15T22:13:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3310','122','1','13812','4.99','2005-08-20T13:01:43.000','2006-02-15T22:13:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3311','122','2','14666','5.99','2005-08-21T19:51:09.000','2006-02-15T22:13:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3312','123','1','992','2.99','2005-05-30T23:47:56.000','2006-02-15T22:13:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3313','123','2','1490','4.99','2005-06-15T21:42:17.000','2006-02-15T22:13:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3314','123','1','1751','0.99','2005-06-16T17:00:14.000','2006-02-15T22:13:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3315','123','2','1775','4.99','2005-06-16T18:28:19.000','2006-02-15T22:13:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3316','123','2','1951','0.99','2005-06-17T08:30:35.000','2006-02-15T22:13:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3317','123','1','2594','2.99','2005-06-19T05:43:43.000','2006-02-15T22:13:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3318','123','1','4442','3.99','2005-07-07T23:05:30.000','2006-02-15T22:13:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3319','123','1','4860','8.99','2005-07-08T18:54:07.000','2006-02-15T22:13:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3320','123','2','7535','4.99','2005-07-27T21:32:39.000','2006-02-15T22:13:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3321','123','1','7727','2.99','2005-07-28T04:52:43.000','2006-02-15T22:13:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3322','123','2','7768','0.99','2005-07-28T06:44:03.000','2006-02-15T22:13:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3323','123','1','7852','2.99','2005-07-28T09:34:29.000','2006-02-15T22:13:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3324','123','1','7969','5.99','2005-07-28T13:57:37.000','2006-02-15T22:13:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3325','123','2','8699','4.99','2005-07-29T16:53:00.000','2006-02-15T22:13:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3326','123','2','9529','4.99','2005-07-31T01:05:26.000','2006-02-15T22:13:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3327','123','1','10066','4.99','2005-07-31T19:30:01.000','2006-02-15T22:13:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3328','123','2','10295','8.99','2005-08-01T03:53:49.000','2006-02-15T22:13:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3329','123','1','12360','2.99','2005-08-18T07:46:35.000','2006-02-15T22:13:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3330','123','1','12402','3.99','2005-08-18T09:27:34.000','2006-02-15T22:13:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3331','123','1','13668','2.99','2005-08-20T08:26:06.000','2006-02-15T22:13:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3332','123','2','15152','7.99','2005-08-22T14:25:21.000','2006-02-15T22:13:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3333','123','2','15525','4.99','2005-08-23T03:43:32.000','2006-02-15T22:13:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3334','123','1','15621','1.99','2005-08-23T07:13:43.000','2006-02-15T22:13:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3335','123','2','15787','2.99','2005-08-23T13:51:57.000','2006-02-15T22:13:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3336','124','1','775','0.99','2005-05-29T13:23:26.000','2006-02-15T22:13:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3337','124','2','1039','4.99','2005-05-31T05:32:29.000','2006-02-15T22:13:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3338','124','2','1057','3.99','2005-05-31T07:58:06.000','2006-02-15T22:13:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3339','124','2','1130','5.99','2005-05-31T18:13:57.000','2006-02-15T22:13:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3340','124','2','2336','1.99','2005-06-18T11:00:05.000','2006-02-15T22:13:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3341','124','1','4341','7.99','2005-07-07T18:44:23.000','2006-02-15T22:13:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3342','124','2','4709','2.99','2005-07-08T12:04:34.000','2006-02-15T22:13:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3343','124','1','5566','2.99','2005-07-10T03:30:17.000','2006-02-15T22:13:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3344','124','1','6411','2.99','2005-07-11T23:10:50.000','2006-02-15T22:13:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3345','124','1','7519','6.99','2005-07-27T21:01:41.000','2006-02-15T22:13:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3346','124','2','7700','8.99','2005-07-28T03:54:14.000','2006-02-15T22:13:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3347','124','2','8524','0.99','2005-07-29T10:20:07.000','2006-02-15T22:13:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3348','124','1','9986','3.99','2005-07-31T17:16:50.000','2006-02-15T22:13:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3349','124','2','11493','5.99','2005-08-02T22:47:00.000','2006-02-15T22:13:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3350','124','1','12835','4.99','2005-08-19T01:47:45.000','2006-02-15T22:13:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3351','124','2','14737','0.99','2005-08-21T22:27:11.000','2006-02-15T22:13:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3352','124','2','15266','4.99','2005-08-22T18:37:24.000','2006-02-15T22:13:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3353','124','2','16023','0.99','2005-08-23T21:45:02.000','2006-02-15T22:13:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3354','125','2','185','3.99','2005-05-26T05:30:03.000','2006-02-15T22:13:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3355','125','1','1481','2.99','2005-06-15T21:17:58.000','2006-02-15T22:13:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3356','125','1','2355','3.99','2005-06-18T12:57:06.000','2006-02-15T22:13:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3357','125','1','2826','7.99','2005-06-19T20:41:35.000','2006-02-15T22:13:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3358','125','1','3118','4.99','2005-06-20T18:05:57.000','2006-02-15T22:13:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3359','125','1','3617','4.99','2005-07-06T05:58:06.000','2006-02-15T22:13:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3360','125','1','5200','2.99','2005-07-09T10:52:09.000','2006-02-15T22:13:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3361','125','2','5523','7.99','2005-07-10T01:47:55.000','2006-02-15T22:13:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3362','125','1','6055','0.99','2005-07-11T03:59:08.000','2006-02-15T22:13:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3363','125','2','6268','6.99','2005-07-11T15:55:34.000','2006-02-15T22:13:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3364','125','1','7323','4.99','2005-07-27T13:39:40.000','2006-02-15T22:13:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3365','125','2','7879','0.99','2005-07-28T10:27:46.000','2006-02-15T22:13:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3366','125','2','7922','0.99','2005-07-28T12:05:25.000','2006-02-15T22:13:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3367','125','2','8375','2.99','2005-07-29T05:25:30.000','2006-02-15T22:13:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3368','125','1','8433','2.99','2005-07-29T07:19:16.000','2006-02-15T22:13:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3369','125','1','8832','4.99','2005-07-29T22:37:49.000','2006-02-15T22:13:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3370','125','1','9129','9.99','2005-07-30T09:51:21.000','2006-02-15T22:13:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3371','125','1','9496','4.99','2005-07-30T23:55:20.000','2006-02-15T22:13:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3372','125','2','9504','0.99','2005-07-31T00:09:07.000','2006-02-15T22:13:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3373','125','1','9722','4.99','2005-07-31T08:29:48.000','2006-02-15T22:13:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3374','125','2','9734','2.99','2005-07-31T08:57:45.000','2006-02-15T22:13:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3375','125','1','10583','2.99','2005-08-01T13:54:35.000','2006-02-15T22:13:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3376','125','1','10699','2.99','2005-08-01T18:24:51.000','2006-02-15T22:13:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3377','125','2','11279','7.99','2005-08-02T14:30:03.000','2006-02-15T22:13:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3378','125','1','11806','4.99','2005-08-17T11:49:28.000','2006-02-15T22:13:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3379','125','1','11832','4.99','2005-08-17T12:55:31.000','2006-02-15T22:13:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3380','125','1','11999','0.99','2005-08-17T18:47:07.000','2006-02-15T22:13:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3381','125','1','12075','4.99','2005-08-17T21:54:55.000','2006-02-15T22:13:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3382','125','2','12262','2.99','2005-08-18T04:16:15.000','2006-02-15T22:13:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3383','125','2','13441','6.99','2005-08-19T23:48:23.000','2006-02-15T22:13:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3384','125','2','14456','2.99','2005-08-21T12:38:09.000','2006-02-15T22:13:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3385','125','1','15055','2.99','2005-08-22T10:14:39.000','2006-02-15T22:13:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3386','126','1','9','4.99','2005-05-25T00:00:40.000','2006-02-15T22:13:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3387','126','1','752','4.99','2005-05-29T10:14:15.000','2006-02-15T22:13:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3388','126','2','1054','4.99','2005-05-31T07:33:25.000','2006-02-15T22:13:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3389','126','1','3450','2.99','2005-06-21T21:01:57.000','2006-02-15T22:13:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3390','126','2','3502','5.99','2005-07-06T00:15:06.000','2006-02-15T22:13:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3391','126','1','3725','4.99','2005-07-06T11:15:04.000','2006-02-15T22:13:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3392','126','1','3804','7.99','2005-07-06T15:08:08.000','2006-02-15T22:13:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3393','126','1','4691','0.99','2005-07-08T11:04:53.000','2006-02-15T22:13:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3394','126','2','4730','2.99','2005-07-08T12:59:49.000','2006-02-15T22:13:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3395','126','2','5137','0.99','2005-07-09T08:00:34.000','2006-02-15T22:13:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3396','126','1','5865','0.99','2005-07-10T18:31:05.000','2006-02-15T22:13:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3397','126','1','6747','0.99','2005-07-12T14:33:21.000','2006-02-15T22:13:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3398','126','2','6755','6.99','2005-07-12T15:07:49.000','2006-02-15T22:13:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3399','126','1','7962','0.99','2005-07-28T13:48:09.000','2006-02-15T22:13:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3400','126','1','8091','2.99','2005-07-28T18:27:29.000','2006-02-15T22:13:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3401','126','1','9492','6.99','2005-07-30T23:52:21.000','2006-02-15T22:13:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3402','126','2','10032','4.99','2005-07-31T18:41:55.000','2006-02-15T22:13:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3403','126','1','11196','9.99','2005-08-02T11:42:40.000','2006-02-15T22:13:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3404','126','2','11613','4.99','2005-08-17T03:50:33.000','2006-02-15T22:13:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3405','126','1','11779','3.99','2005-08-17T10:31:58.000','2006-02-15T22:13:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3406','126','1','11801','0.99','2005-08-17T11:30:11.000','2006-02-15T22:13:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3407','126','2','12991','2.99','2005-08-19T07:21:24.000','2006-02-15T22:13:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3408','126','2','13015','7.99','2005-08-19T07:56:51.000','2006-02-15T22:13:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3409','126','2','13177','0.99','2005-08-19T13:56:58.000','2006-02-15T22:13:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3410','126','2','14477','2.99','2005-08-21T13:32:38.000','2006-02-15T22:13:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3411','126','2','14577','2.99','2005-08-21T16:52:29.000','2006-02-15T22:13:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3412','126','2','15741','4.99','2005-08-23T12:10:54.000','2006-02-15T22:13:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3413','126','1','16007','7.99','2005-08-23T21:02:43.000','2006-02-15T22:13:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3414','127','1','452','0.99','2005-05-27T19:30:33.000','2006-02-15T22:13:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3415','127','1','708','0.99','2005-05-29T03:23:47.000','2006-02-15T22:13:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3416','127','1','1293','4.99','2005-06-15T09:06:24.000','2006-02-15T22:13:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3417','127','2','1803','2.99','2005-06-16T20:32:47.000','2006-02-15T22:13:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3418','127','2','2412','3.99','2005-06-18T16:58:58.000','2006-02-15T22:13:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3419','127','1','4652','5.99','2005-07-08T09:47:51.000','2006-02-15T22:13:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3420','127','2','4811','5.99','2005-07-08T17:04:24.000','2006-02-15T22:13:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3421','127','2','5499','2.99','2005-07-10T00:27:45.000','2006-02-15T22:13:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3422','127','2','5983','2.99','2005-07-11T00:34:11.000','2006-02-15T22:13:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3423','127','1','7912','4.99','2005-07-28T11:46:58.000','2006-02-15T22:13:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3424','127','2','8209','6.99','2005-07-28T23:29:28.000','2006-02-15T22:13:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3425','127','1','9859','6.99','2005-07-31T13:02:55.000','2006-02-15T22:13:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3426','127','1','10197','2.99','2005-08-01T00:35:25.000','2006-02-15T22:13:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3427','127','1','10787','10.99','2005-08-01T21:35:01.000','2006-02-15T22:13:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3428','127','1','10973','7.99','2005-08-02T04:09:42.000','2006-02-15T22:13:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3429','127','1','11235','0.99','2005-08-02T13:13:21.000','2006-02-15T22:13:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3430','127','2','12060','4.99','2005-08-17T21:11:57.000','2006-02-15T22:13:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3431','127','2','12820','2.99','2005-08-19T01:05:08.000','2006-02-15T22:13:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3432','127','2','13043','4.99','2005-08-19T09:07:13.000','2006-02-15T22:13:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3433','127','1','13091','2.99','2005-08-19T10:40:10.000','2006-02-15T22:13:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3434','127','2','14030','2.99','2005-08-20T21:23:54.000','2006-02-15T22:13:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3435','127','1','14189','2.99','2005-08-21T03:32:17.000','2006-02-15T22:13:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3436','127','1','15463','5.99','2005-08-23T01:15:07.000','2006-02-15T22:13:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3437','127','2','15736','5.99','2005-08-23T11:40:30.000','2006-02-15T22:13:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3438','128','2','888','5.99','2005-05-30T07:13:14.000','2006-02-15T22:13:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3439','128','2','1131','2.99','2005-05-31T18:44:19.000','2006-02-15T22:13:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3440','128','2','2519','7.99','2005-06-19T00:19:21.000','2006-02-15T22:13:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3441','128','1','2565','0.99','2005-06-19T03:44:03.000','2006-02-15T22:13:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3442','128','1','3751','0.99','2005-07-06T12:23:41.000','2006-02-15T22:13:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3443','128','2','3995','5.99','2005-07-06T23:43:03.000','2006-02-15T22:13:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3444','128','1','5270','2.99','2005-07-09T14:23:46.000','2006-02-15T22:13:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3445','128','1','5647','4.99','2005-07-10T07:08:40.000','2006-02-15T22:13:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3446','128','2','5997','4.99','2005-07-11T01:19:50.000','2006-02-15T22:13:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3447','128','2','6186','2.99','2005-07-11T11:26:41.000','2006-02-15T22:13:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3448','128','2','6481','6.99','2005-07-12T01:50:15.000','2006-02-15T22:13:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3449','128','2','6687','2.99','2005-07-12T12:19:23.000','2006-02-15T22:13:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3450','128','2','7582','4.99','2005-07-27T23:15:14.000','2006-02-15T22:13:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3451','128','2','8415','2.99','2005-07-29T06:52:27.000','2006-02-15T22:13:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3452','128','2','9215','5.99','2005-07-30T13:11:11.000','2006-02-15T22:13:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3453','128','2','9234','2.99','2005-07-30T13:45:54.000','2006-02-15T22:13:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3454','128','1','9433','5.99','2005-07-30T21:28:17.000','2006-02-15T22:13:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3455','128','2','9858','2.99','2005-07-31T13:02:07.000','2006-02-15T22:13:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3456','128','1','9952','3.99','2005-07-31T15:52:37.000','2006-02-15T22:13:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3457','128','1','10011','2.99','2005-07-31T18:02:41.000','2006-02-15T22:13:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3458','128','1','10394','2.99','2005-08-01T06:58:17.000','2006-02-15T22:13:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3459','128','2','12731','2.99','2005-08-18T21:55:38.000','2006-02-15T22:13:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3460','128','2','12843','2.99','2005-08-19T01:58:54.000','2006-02-15T22:13:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3461','128','2','12910','0.99','2005-08-19T04:23:13.000','2006-02-15T22:13:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3462','128','2','13027','0.99','2005-08-19T08:25:16.000','2006-02-15T22:13:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3463','128','2','13181','5.99','2005-08-19T14:00:56.000','2006-02-15T22:13:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3464','128','1','13509','0.99','2005-08-20T02:14:16.000','2006-02-15T22:13:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3465','128','2','13964','2.99','2005-08-20T18:24:26.000','2006-02-15T22:13:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3466','128','2','14157','0.99','2005-08-21T02:43:15.000','2006-02-15T22:13:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3467','128','1','14925','8.99','2005-08-22T05:16:16.000','2006-02-15T22:13:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3468','128','1','15220','3.99','2005-08-22T17:02:23.000','2006-02-15T22:13:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3469','128','1','15835','8.99','2005-08-23T15:25:27.000','2006-02-15T22:13:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3470','129','2','1732','0.99','2005-06-16T15:34:41.000','2006-02-15T22:13:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3471','129','1','2727','3.99','2005-06-19T15:02:39.000','2006-02-15T22:13:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3472','129','2','2768','0.99','2005-06-19T17:46:52.000','2006-02-15T22:13:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3473','129','2','2795','4.99','2005-06-19T18:58:53.000','2006-02-15T22:13:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3474','129','1','3183','4.99','2005-06-20T22:55:55.000','2006-02-15T22:13:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3475','129','1','3219','3.99','2005-06-21T01:43:26.000','2006-02-15T22:13:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3476','129','1','3689','0.99','2005-07-06T09:43:01.000','2006-02-15T22:13:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3477','129','2','3900','4.99','2005-07-06T19:21:28.000','2006-02-15T22:13:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3478','129','2','3936','0.99','2005-07-06T21:15:03.000','2006-02-15T22:13:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3479','129','2','4256','2.99','2005-07-07T14:14:36.000','2006-02-15T22:13:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3480','129','1','4602','0.99','2005-07-08T06:52:40.000','2006-02-15T22:13:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3481','129','1','4896','2.99','2005-07-08T20:23:15.000','2006-02-15T22:13:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3482','129','1','4996','0.99','2005-07-09T00:59:46.000','2006-02-15T22:13:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3483','129','1','5127','0.99','2005-07-09T07:25:47.000','2006-02-15T22:13:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3484','129','2','5350','4.99','2005-07-09T17:39:30.000','2006-02-15T22:13:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3485','129','1','8339','4.99','2005-07-29T04:41:13.000','2006-02-15T22:13:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3486','129','1','8345','2.99','2005-07-29T04:47:37.000','2006-02-15T22:13:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3487','129','2','9823','4.99','2005-07-31T11:49:00.000','2006-02-15T22:13:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3488','129','1','9983','7.99','2005-07-31T17:09:36.000','2006-02-15T22:13:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3489','129','1','10024','7.99','2005-07-31T18:26:36.000','2006-02-15T22:13:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3490','129','2','10167','5.99','2005-07-31T23:24:31.000','2006-02-15T22:13:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3491','129','2','10395','2.99','2005-08-01T07:08:22.000','2006-02-15T22:13:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3492','129','1','10468','0.99','2005-08-01T09:48:29.000','2006-02-15T22:13:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3493','129','1','10483','2.99','2005-08-01T10:19:45.000','2006-02-15T22:13:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3494','129','2','10550','2.99','2005-08-01T12:46:52.000','2006-02-15T22:13:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3495','129','2','10816','4.99','2005-08-01T22:48:57.000','2006-02-15T22:13:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3496','129','2','12612','3.99','2005-08-18T17:10:05.000','2006-02-15T22:13:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3497','129','2','12728','4.99','2005-08-18T21:47:48.000','2006-02-15T22:13:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3498','129','2','13653','10.99','2005-08-20T07:54:54.000','2006-02-15T22:13:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3499','129','1','13915','4.99','2005-08-20T16:42:53.000','2006-02-15T22:13:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3500','129','1','13919','4.99','2005-08-20T16:47:34.000','2006-02-15T22:13:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3501','129','1','13961','0.99','2005-08-20T18:16:34.000','2006-02-15T22:13:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3502','129','1','14353','0.99','2005-08-21T09:07:50.000','2006-02-15T22:13:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3503','129','2','14968','1.99','2005-08-22T06:46:59.000','2006-02-15T22:13:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3504','130','1','1','2.99','2005-05-24T22:53:30.000','2006-02-15T22:13:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3505','130','1','746','2.99','2005-05-29T09:25:10.000','2006-02-15T22:13:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3506','130','1','1630','2.99','2005-06-16T07:55:01.000','2006-02-15T22:13:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3507','130','2','1864','2.99','2005-06-17T01:39:47.000','2006-02-15T22:13:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3508','130','2','2163','2.99','2005-06-17T23:46:16.000','2006-02-15T22:13:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3509','130','2','2292','2.99','2005-06-18T07:37:48.000','2006-02-15T22:13:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3510','130','1','2535','2.99','2005-06-19T01:39:04.000','2006-02-15T22:13:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3511','130','1','2982','6.99','2005-06-20T08:38:29.000','2006-02-15T22:13:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3512','130','2','4339','4.99','2005-07-07T18:41:42.000','2006-02-15T22:13:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3513','130','2','4485','4.99','2005-07-08T01:07:54.000','2006-02-15T22:13:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3514','130','1','6353','3.99','2005-07-11T20:48:56.000','2006-02-15T22:13:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3515','130','1','7181','4.99','2005-07-27T08:14:34.000','2006-02-15T22:13:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3516','130','1','7728','0.99','2005-07-28T04:56:33.000','2006-02-15T22:13:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3517','130','1','9452','0.99','2005-07-30T22:19:16.000','2006-02-15T22:13:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3518','130','2','9637','4.99','2005-07-31T05:18:54.000','2006-02-15T22:13:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3519','130','2','9724','5.99','2005-07-31T08:33:08.000','2006-02-15T22:13:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3520','130','2','10568','2.99','2005-08-01T13:17:28.000','2006-02-15T22:13:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3521','130','2','10645','5.99','2005-08-01T15:52:01.000','2006-02-15T22:13:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3522','130','1','11811','2.99','2005-08-17T11:59:18.000','2006-02-15T22:13:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3523','130','1','12094','2.99','2005-08-17T22:31:04.000','2006-02-15T22:13:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3524','130','1','12777','6.99','2005-08-18T23:39:22.000','2006-02-15T22:13:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3525','130','2','14111','0.99','2005-08-21T00:59:01.000','2006-02-15T22:13:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3526','130','2','15574','5.99','2005-08-23T05:29:32.000','2006-02-15T22:13:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3527','130','1','15777','4.99','2005-08-23T13:29:08.000','2006-02-15T22:13:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3528','131','2','55','2.99','2005-05-25T08:26:13.000','2006-02-15T22:13:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3529','131','1','83','4.99','2005-05-25T12:30:15.000','2006-02-15T22:13:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3530','131','2','944','7.99','2005-05-30T15:26:24.000','2006-02-15T22:13:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3531','131','1','1646','9.99','2005-06-16T09:12:53.000','2006-02-15T22:13:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3532','131','2','1768','4.99','2005-06-16T18:02:06.000','2006-02-15T22:13:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3533','131','1','3515','2.99','2005-07-06T00:48:55.000','2006-02-15T22:13:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3534','131','1','5233','4.99','2005-07-09T12:44:26.000','2006-02-15T22:13:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3535','131','1','5395','4.99','2005-07-09T19:42:37.000','2006-02-15T22:13:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3536','131','1','5610','2.99','2005-07-10T05:09:52.000','2006-02-15T22:13:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3537','131','2','5726','2.99','2005-07-10T11:22:08.000','2006-02-15T22:13:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3538','131','1','5874','3.99','2005-07-10T19:02:51.000','2006-02-15T22:13:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3539','131','1','7557','2.99','2005-07-27T22:18:19.000','2006-02-15T22:13:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3540','131','2','8071','0.99','2005-07-28T17:27:48.000','2006-02-15T22:13:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3541','131','1','8267','6.99','2005-07-29T01:21:02.000','2006-02-15T22:13:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3542','131','1','8570','8.99','2005-07-29T11:40:08.000','2006-02-15T22:13:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3543','131','1','9323','3.99','2005-07-30T17:21:44.000','2006-02-15T22:13:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3544','131','1','10179','2.99','2005-07-31T23:49:54.000','2006-02-15T22:13:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3545','131','1','10459','4.99','2005-08-01T09:20:09.000','2006-02-15T22:13:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3546','131','1','10861','1.99','2005-08-02T00:12:46.000','2006-02-15T22:13:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3547','131','2','11971','0.99','2005-08-17T17:53:42.000','2006-02-15T22:13:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3548','131','1','11973','2.99','2005-08-17T17:55:58.000','2006-02-15T22:13:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3549','131','1','12216','0.99','2005-08-18T02:37:07.000','2006-02-15T22:13:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3550','131','2','12263','0.99','2005-08-18T04:16:18.000','2006-02-15T22:13:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3551','131','1','12372','9.99','2005-08-18T08:04:35.000','2006-02-15T22:13:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3552','131','2','13050','6.99','2005-08-19T09:31:23.000','2006-02-15T22:13:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3553','131','2','13346','7.99','2005-08-19T20:28:21.000','2006-02-15T22:13:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3554','131','2','13353','2.99','2005-08-19T20:53:43.000','2006-02-15T22:13:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3555','131','1','13407','0.99','2005-08-19T22:26:26.000','2006-02-15T22:13:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3556','131','2','15659','2.99','2005-08-23T08:48:43.000','2006-02-15T22:13:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3557','131','1','16042','2.99','2005-08-23T22:20:40.000','2006-02-15T22:13:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3558','132','1','1843','0.99','2005-06-16T23:53:42.000','2006-02-15T22:13:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3559','132','1','2208','4.99','2005-06-18T02:22:07.000','2006-02-15T22:13:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3560','132','1','2384','0.99','2005-06-18T15:18:49.000','2006-02-15T22:13:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3561','132','2','2608','2.99','2005-06-19T07:10:36.000','2006-02-15T22:13:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3562','132','2','2924','4.99','2005-06-20T04:20:14.000','2006-02-15T22:13:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3563','132','1','3121','4.99','2005-06-20T18:23:30.000','2006-02-15T22:13:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3564','132','1','3706','0.99','2005-07-06T10:18:01.000','2006-02-15T22:13:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3565','132','2','3825','2.99','2005-07-06T15:50:03.000','2006-02-15T22:13:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3566','132','1','4168','4.99','2005-07-07T09:37:24.000','2006-02-15T22:13:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3567','132','1','4534','4.99','2005-07-08T03:36:55.000','2006-02-15T22:13:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3568','132','1','4557','5.99','2005-07-08T04:49:15.000','2006-02-15T22:13:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3569','132','2','4903','0.99','2005-07-08T20:50:05.000','2006-02-15T22:13:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3570','132','1','5391','2.99','2005-07-09T19:28:34.000','2006-02-15T22:13:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3571','132','2','5684','5.99','2005-07-10T08:59:03.000','2006-02-15T22:13:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3572','132','1','5703','0.99','2005-07-10T10:04:15.000','2006-02-15T22:13:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3573','132','2','5715','1.99','2005-07-10T10:48:03.000','2006-02-15T22:13:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3574','132','1','6239','6.99','2005-07-11T14:20:48.000','2006-02-15T22:13:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3575','132','1','6978','1.99','2005-07-27T00:47:40.000','2006-02-15T22:13:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3576','132','2','7432','0.99','2005-07-27T17:31:40.000','2006-02-15T22:13:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3577','132','1','7631','1.99','2005-07-28T01:01:15.000','2006-02-15T22:13:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3578','132','2','10243','4.99','2005-08-01T02:18:46.000','2006-02-15T22:13:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3579','132','1','10400','6.99','2005-08-01T07:18:24.000','2006-02-15T22:13:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3580','132','2','10619','3.99','2005-08-01T15:07:04.000','2006-02-15T22:13:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3581','132','1','10638','6.99','2005-08-01T15:44:20.000','2006-02-15T22:13:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3582','132','2','11140','0.99','2005-08-02T09:27:45.000','2006-02-15T22:13:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3583','132','2','11812','0.99','2005-08-17T12:00:54.000','2006-02-15T22:13:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3584','132','2','12133','0.99','2005-08-17T23:47:16.000','2006-02-15T22:13:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3585','132','1','15874','4.99','2005-08-23T16:30:55.000','2006-02-15T22:13:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3586','133','1','275','6.99','2005-05-26T17:09:53.000','2006-02-15T22:13:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3587','133','2','447','2.99','2005-05-27T18:57:02.000','2006-02-15T22:13:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3588','133','2','1522','3.99','2005-06-16T00:17:39.000','2006-02-15T22:13:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3589','133','2','2665','7.99','2005-06-19T11:12:35.000','2006-02-15T22:13:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3590','133','1','3006','0.99','2005-06-20T10:10:29.000','2006-02-15T22:13:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3591','133','2','3365','0.99','2005-06-21T12:55:48.000','2006-02-15T22:13:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3592','133','2','4506','6.99','2005-07-08T02:22:18.000','2006-02-15T22:13:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3593','133','2','4566','2.99','2005-07-08T05:18:50.000','2006-02-15T22:13:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3594','133','1','4681','6.99','2005-07-08T10:36:03.000','2006-02-15T22:13:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3595','133','2','4829','2.99','2005-07-08T17:54:18.000','2006-02-15T22:13:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3596','133','2','5063','2.99','2005-07-09T04:37:31.000','2006-02-15T22:13:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3597','133','1','6157','4.99','2005-07-11T09:48:16.000','2006-02-15T22:13:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3598','133','1','6609','3.99','2005-07-12T08:19:41.000','2006-02-15T22:13:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3599','133','1','7177','2.99','2005-07-27T08:07:39.000','2006-02-15T22:13:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3600','133','1','7400','0.99','2005-07-27T16:16:37.000','2006-02-15T22:13:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3601','133','2','8389','6.99','2005-07-29T05:50:09.000','2006-02-15T22:13:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3602','133','2','9139','2.99','2005-07-30T10:11:52.000','2006-02-15T22:13:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3603','133','1','9175','0.99','2005-07-30T11:47:48.000','2006-02-15T22:13:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3604','133','2','9671','0.99','2005-07-31T06:33:41.000','2006-02-15T22:13:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3605','133','1','10665','0.99','2005-08-01T16:56:17.000','2006-02-15T22:13:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3606','133','1','12419','4.99','2005-08-18T10:01:48.000','2006-02-15T22:13:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3607','133','1','12834','4.99','2005-08-19T01:47:30.000','2006-02-15T22:13:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3608','133','2','13323','2.99','2005-08-19T19:48:07.000','2006-02-15T22:13:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3609','133','1','13455','1.99','2005-08-20T00:32:17.000','2006-02-15T22:13:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3610','133','2','13910','2.99','2005-08-20T16:30:49.000','2006-02-15T22:13:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3611','133','2','15080','0.99','2005-08-22T11:11:51.000','2006-02-15T22:13:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3612','133','1','16009','6.99','2005-08-23T21:07:59.000','2006-02-15T22:13:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3613','134','1','366','3.99','2005-05-27T07:33:54.000','2006-02-15T22:13:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3614','134','2','798','0.99','2005-05-29T17:23:43.000','2006-02-15T22:13:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3615','134','1','814','6.99','2005-05-29T20:16:12.000','2006-02-15T22:13:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3616','134','2','1124','4.99','2005-05-31T16:49:34.000','2006-02-15T22:13:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3617','134','1','1618','9.99','2005-06-16T07:08:38.000','2006-02-15T22:13:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3618','134','2','1784','0.99','2005-06-16T19:25:32.000','2006-02-15T22:13:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3619','134','2','1881','0.99','2005-06-17T03:09:56.000','2006-02-15T22:13:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3620','134','1','3267','5.99','2005-06-21T04:55:21.000','2006-02-15T22:13:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3621','134','1','5315','4.99','2005-07-09T16:09:19.000','2006-02-15T22:13:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3622','134','2','6226','2.99','2005-07-11T13:48:11.000','2006-02-15T22:13:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3623','134','1','6659','0.99','2005-07-12T11:18:05.000','2006-02-15T22:13:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3624','134','2','7516','2.99','2005-07-27T20:55:28.000','2006-02-15T22:13:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3625','134','2','7965','4.99','2005-07-28T13:52:57.000','2006-02-15T22:13:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3626','134','2','8650','1.99','2005-07-29T14:59:04.000','2006-02-15T22:13:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3627','134','1','10864','6.99','2005-08-02T00:18:59.000','2006-02-15T22:13:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3628','134','1','11280','3.99','2005-08-02T14:34:33.000','2006-02-15T22:13:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3629','134','1','11283','4.99','2005-08-02T14:39:46.000','2006-02-15T22:13:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3630','134','2','11482','4.99','2005-08-02T22:24:31.000','2006-02-15T22:13:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3631','134','1','12754','7.99','2005-08-18T22:37:41.000','2006-02-15T22:13:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3632','134','2','12987','2.99','2005-08-19T07:11:44.000','2006-02-15T22:13:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3633','134','2','13006','2.99','2005-08-19T07:47:16.000','2006-02-15T22:13:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3634','134','2','14265','2.99','2005-08-21T06:20:14.000','2006-02-15T22:13:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3635','134','2','15963','2.99','2005-08-23T19:42:46.000','2006-02-15T22:13:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3636','135','1','78','5.99','2005-05-25T11:35:18.000','2006-02-15T22:13:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3637','135','2','753','3.99','2005-05-29T10:16:42.000','2006-02-15T22:13:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3638','135','2','1272','0.99','2005-06-15T07:42:58.000','2006-02-15T22:13:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3639','135','2','1671','1.99','2005-06-16T10:30:22.000','2006-02-15T22:13:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3640','135','2','2941','2.99','2005-06-20T05:22:18.000','2006-02-15T22:13:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3641','135','1','4102','0.99','2005-07-07T06:25:19.000','2006-02-15T22:13:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3642','135','2','5054','7.99','2005-07-09T04:01:02.000','2006-02-15T22:13:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3643','135','1','5541','0.99','2005-07-10T02:44:27.000','2006-02-15T22:13:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3644','135','1','6117','3.99','2005-07-11T07:39:38.000','2006-02-15T22:13:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3645','135','1','6461','3.99','2005-07-12T01:14:03.000','2006-02-15T22:13:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3646','135','1','6817','3.99','2005-07-12T18:19:57.000','2006-02-15T22:13:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3647','135','2','7297','4.99','2005-07-27T12:39:48.000','2006-02-15T22:13:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3648','135','1','7437','0.99','2005-07-27T17:39:18.000','2006-02-15T22:13:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3649','135','1','7554','7.99','2005-07-27T22:12:41.000','2006-02-15T22:13:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3650','135','1','7734','0.99','2005-07-28T05:08:44.000','2006-02-15T22:13:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3651','135','1','8315','0.99','2005-07-29T03:37:07.000','2006-02-15T22:13:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3652','135','2','8885','7.99','2005-07-30T00:36:26.000','2006-02-15T22:13:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3653','135','1','8987','6.99','2005-07-30T04:37:36.000','2006-02-15T22:13:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3654','135','2','10091','4.99','2005-07-31T20:23:13.000','2006-02-15T22:13:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3655','135','2','10471','0.99','2005-08-01T09:52:37.000','2006-02-15T22:13:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3656','135','1','10611','2.99','2005-08-01T14:53:52.000','2006-02-15T22:13:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3657','135','1','10698','3.99','2005-08-01T18:24:41.000','2006-02-15T22:13:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3658','135','2','11194','5.99','2005-08-02T11:35:53.000','2006-02-15T22:13:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3659','135','1','11704','7.99','2005-08-17T07:21:22.000','2006-02-15T22:13:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3660','135','1','12249','2.99','2005-08-18T03:53:34.000','2006-02-15T22:13:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3661','135','1','13035','0.99','2005-08-19T08:46:45.000','2006-02-15T22:13:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3662','135','1','14005','0.99','2005-08-20T20:19:05.000','2006-02-15T22:13:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3663','135','2','14136','5.99','2005-08-21T01:57:26.000','2006-02-15T22:13:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3664','135','2','15908','2.99','2005-08-23T17:42:00.000','2006-02-15T22:13:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3665','135','1','13390','0.99','2006-02-14T15:16:03.000','2006-02-15T22:13:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3666','136','2','1150','2.99','2005-05-31T21:20:09.000','2006-02-15T22:13:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3667','136','2','2104','2.99','2005-06-17T19:14:30.000','2006-02-15T22:13:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3668','136','1','4927','0.99','2005-07-08T22:05:35.000','2006-02-15T22:13:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3669','136','1','5627','3.99','2005-07-10T05:51:12.000','2006-02-15T22:13:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3670','136','2','6142','3.99','2005-07-11T08:54:09.000','2006-02-15T22:13:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3671','136','1','6585','8.99','2005-07-12T06:50:52.000','2006-02-15T22:13:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3672','136','2','9319','0.99','2005-07-30T17:15:27.000','2006-02-15T22:13:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3673','136','2','9764','5.99','2005-07-31T09:42:58.000','2006-02-15T22:13:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3674','136','2','11992','10.99','2005-08-17T18:27:22.000','2006-02-15T22:13:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3675','136','1','12287','5.99','2005-08-18T04:58:06.000','2006-02-15T22:13:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3676','136','2','12539','0.99','2005-08-18T14:10:09.000','2006-02-15T22:13:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3677','136','2','13992','4.99','2005-08-20T19:30:35.000','2006-02-15T22:13:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3678','136','2','14379','0.99','2005-08-21T09:53:03.000','2006-02-15T22:13:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3679','136','1','14437','2.99','2005-08-21T11:48:32.000','2006-02-15T22:13:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3680','136','1','15439','4.99','2005-08-23T00:34:28.000','2006-02-15T22:13:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3681','137','1','925','2.99','2005-05-30T12:13:52.000','2006-02-15T22:13:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3682','137','1','2469','6.99','2005-06-18T20:24:23.000','2006-02-15T22:13:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3683','137','1','2785','2.99','2005-06-19T18:43:57.000','2006-02-15T22:13:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3684','137','2','3058','3.99','2005-06-20T13:28:35.000','2006-02-15T22:13:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3685','137','1','3436','5.99','2005-06-21T19:16:09.000','2006-02-15T22:13:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3686','137','2','3589','4.99','2005-07-06T04:30:18.000','2006-02-15T22:13:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3687','137','2','3676','5.99','2005-07-06T09:10:37.000','2006-02-15T22:13:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3688','137','2','3874','6.99','2005-07-06T18:06:12.000','2006-02-15T22:13:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3689','137','1','4332','6.99','2005-07-07T18:25:26.000','2006-02-15T22:13:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3690','137','2','4474','3.99','2005-07-08T00:26:56.000','2006-02-15T22:13:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3691','137','1','5106','2.99','2005-07-09T06:40:24.000','2006-02-15T22:13:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3692','137','1','5443','3.99','2005-07-09T21:56:09.000','2006-02-15T22:13:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3693','137','1','5804','2.99','2005-07-10T15:06:31.000','2006-02-15T22:13:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3694','137','1','6039','6.99','2005-07-11T03:12:19.000','2006-02-15T22:13:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3695','137','2','6200','0.99','2005-07-11T12:16:42.000','2006-02-15T22:13:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3696','137','1','8028','8.99','2005-07-28T16:11:15.000','2006-02-15T22:13:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3697','137','1','8106','4.99','2005-07-28T19:02:46.000','2006-02-15T22:13:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3698','137','2','8954','2.99','2005-07-30T03:25:51.000','2006-02-15T22:13:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3699','137','1','9002','4.99','2005-07-30T05:02:21.000','2006-02-15T22:13:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3700','137','2','9200','4.99','2005-07-30T12:39:52.000','2006-02-15T22:13:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3701','137','2','9466','7.99','2005-07-30T22:44:36.000','2006-02-15T22:13:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3702','137','1','9709','4.99','2005-07-31T08:04:55.000','2006-02-15T22:13:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3703','137','1','9789','2.99','2005-07-31T10:30:25.000','2006-02-15T22:13:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3704','137','1','10175','6.99','2005-07-31T23:40:11.000','2006-02-15T22:13:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3705','137','2','10595','4.99','2005-08-01T14:16:28.000','2006-02-15T22:13:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3706','137','2','10842','5.99','2005-08-01T23:41:24.000','2006-02-15T22:13:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3707','137','2','11057','4.99','2005-08-02T06:38:19.000','2006-02-15T22:13:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3708','137','1','11281','3.99','2005-08-02T14:35:01.000','2006-02-15T22:13:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3709','137','2','11732','3.99','2005-08-17T08:29:46.000','2006-02-15T22:13:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3710','137','1','12078','2.99','2005-08-17T22:00:22.000','2006-02-15T22:13:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3711','137','1','13148','0.99','2005-08-19T12:55:30.000','2006-02-15T22:13:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3712','137','1','13472','5.99','2005-08-20T01:03:31.000','2006-02-15T22:13:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3713','137','1','13776','5.99','2005-08-20T11:57:06.000','2006-02-15T22:13:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3714','137','1','14754','7.99','2005-08-21T23:17:26.000','2006-02-15T22:13:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3715','137','2','15082','7.99','2005-08-22T11:17:06.000','2006-02-15T22:13:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3716','137','1','15133','0.99','2005-08-22T13:17:43.000','2006-02-15T22:13:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3717','137','2','15537','2.99','2005-08-23T04:00:30.000','2006-02-15T22:13:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3718','137','2','15889','4.99','2005-08-23T16:57:43.000','2006-02-15T22:13:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3719','137','1','16030','9.99','2005-08-23T21:56:04.000','2006-02-15T22:13:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3720','138','1','523','2.99','2005-05-28T03:53:26.000','2006-02-15T22:13:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3721','138','1','1020','0.99','2005-05-31T03:06:08.000','2006-02-15T22:13:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3722','138','2','1316','0.99','2005-06-15T10:26:23.000','2006-02-15T22:13:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3723','138','2','2038','0.99','2005-06-17T14:00:51.000','2006-02-15T22:13:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3724','138','1','2731','7.99','2005-06-19T15:14:55.000','2006-02-15T22:13:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3725','138','2','3481','2.99','2005-07-05T23:13:07.000','2006-02-15T22:13:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3726','138','1','5378','0.99','2005-07-09T19:05:56.000','2006-02-15T22:13:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3727','138','1','5600','1.99','2005-07-10T04:55:45.000','2006-02-15T22:13:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3728','138','1','5679','4.99','2005-07-10T08:44:02.000','2006-02-15T22:13:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3729','138','1','6458','2.99','2005-07-12T01:08:52.000','2006-02-15T22:13:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3730','138','1','6892','0.99','2005-07-12T21:10:04.000','2006-02-15T22:13:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3731','138','1','7208','2.99','2005-07-27T09:16:28.000','2006-02-15T22:13:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3732','138','1','7754','2.99','2005-07-28T06:10:55.000','2006-02-15T22:13:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3733','138','2','8123','4.99','2005-07-28T19:28:23.000','2006-02-15T22:13:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3734','138','2','8160','3.99','2005-07-28T21:10:30.000','2006-02-15T22:13:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3735','138','1','8424','3.99','2005-07-29T07:06:03.000','2006-02-15T22:13:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3736','138','2','9259','1.99','2005-07-30T14:37:44.000','2006-02-15T22:13:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3737','138','1','9619','0.99','2005-07-31T04:17:02.000','2006-02-15T22:13:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3738','138','1','9947','9.99','2005-07-31T15:49:40.000','2006-02-15T22:13:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3739','138','1','10110','0.99','2005-07-31T21:06:12.000','2006-02-15T22:13:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3740','138','2','10190','4.99','2005-08-01T00:27:53.000','2006-02-15T22:13:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3741','138','1','10268','3.99','2005-08-01T03:08:56.000','2006-02-15T22:13:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3742','138','1','10431','5.99','2005-08-01T08:41:54.000','2006-02-15T22:13:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3743','138','1','11015','4.99','2005-08-02T05:13:00.000','2006-02-15T22:13:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3744','138','1','11088','0.99','2005-08-02T07:48:31.000','2006-02-15T22:13:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3745','138','1','11463','0.99','2005-08-02T21:37:36.000','2006-02-15T22:13:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3746','138','2','12550','2.99','2005-08-18T14:40:38.000','2006-02-15T22:13:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3747','138','2','12873','2.99','2005-08-19T03:05:41.000','2006-02-15T22:13:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3748','138','1','14194','1.99','2005-08-21T03:40:11.000','2006-02-15T22:13:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3749','138','2','14432','4.99','2005-08-21T11:36:15.000','2006-02-15T22:13:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3750','138','2','14486','4.99','2005-08-21T13:52:54.000','2006-02-15T22:13:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3751','138','1','14987','4.99','2005-08-22T07:41:08.000','2006-02-15T22:13:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3752','138','1','15424','2.99','2005-08-23T00:03:01.000','2006-02-15T22:13:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3753','138','1','15501','0.99','2005-08-23T02:39:56.000','2006-02-15T22:13:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3754','139','2','1169','2.99','2005-06-14T23:42:56.000','2006-02-15T22:13:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3755','139','1','1736','2.99','2005-06-16T15:52:32.000','2006-02-15T22:13:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3756','139','1','2659','0.99','2005-06-19T10:47:42.000','2006-02-15T22:13:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3757','139','2','2718','7.99','2005-06-19T14:49:42.000','2006-02-15T22:13:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3758','139','2','4660','0.99','2005-07-08T09:54:47.000','2006-02-15T22:13:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3759','139','2','4663','2.99','2005-07-08T09:59:18.000','2006-02-15T22:13:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3760','139','2','5092','2.99','2005-07-09T05:57:39.000','2006-02-15T22:13:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3761','139','2','5265','7.99','2005-07-09T14:15:01.000','2006-02-15T22:13:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3762','139','1','5390','6.99','2005-07-09T19:26:22.000','2006-02-15T22:13:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3763','139','1','5494','6.99','2005-07-10T00:15:00.000','2006-02-15T22:13:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3764','139','1','6496','6.99','2005-07-12T02:57:39.000','2006-02-15T22:13:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3765','139','2','6740','0.99','2005-07-12T14:22:08.000','2006-02-15T22:13:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3766','139','1','7369','0.99','2005-07-27T15:07:58.000','2006-02-15T22:13:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3767','139','2','7767','5.99','2005-07-28T06:42:02.000','2006-02-15T22:13:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3768','139','2','9415','2.99','2005-07-30T20:48:31.000','2006-02-15T22:13:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3769','139','2','9920','4.99','2005-07-31T14:57:13.000','2006-02-15T22:13:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3770','139','1','10900','2.99','2005-08-02T01:34:26.000','2006-02-15T22:13:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3771','139','1','12859','6.99','2005-08-19T02:23:23.000','2006-02-15T22:13:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3772','139','2','13401','3.99','2005-08-19T22:16:16.000','2006-02-15T22:13:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3773','139','2','14736','5.99','2005-08-21T22:25:53.000','2006-02-15T22:13:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3774','139','1','14788','2.99','2005-08-22T00:27:59.000','2006-02-15T22:13:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3775','139','1','15024','2.99','2005-08-22T08:57:10.000','2006-02-15T22:13:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3776','139','2','15029','2.99','2005-08-22T09:04:53.000','2006-02-15T22:13:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3777','139','1','15062','2.99','2005-08-22T10:34:39.000','2006-02-15T22:13:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3778','139','1','15218','9.99','2005-08-22T16:59:05.000','2006-02-15T22:13:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3779','139','1','15471','3.99','2005-08-23T01:38:48.000','2006-02-15T22:13:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3780','139','1','15743','0.99','2005-08-23T12:12:05.000','2006-02-15T22:13:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3781','140','1','1586','4.99','2005-06-16T04:51:18.000','2006-02-15T22:13:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3782','140','1','1687','2.99','2005-06-16T12:09:20.000','2006-02-15T22:13:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3783','140','2','2332','6.99','2005-06-18T10:53:51.000','2006-02-15T22:13:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3784','140','2','3171','0.99','2005-06-20T22:15:47.000','2006-02-15T22:13:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3785','140','1','6286','4.99','2005-07-11T16:55:35.000','2006-02-15T22:13:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3786','140','1','6407','9.99','2005-07-11T23:02:19.000','2006-02-15T22:13:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3787','140','2','6571','0.99','2005-07-12T05:51:47.000','2006-02-15T22:13:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3788','140','1','6918','2.99','2005-07-12T22:30:29.000','2006-02-15T22:13:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3789','140','1','7170','4.99','2005-07-27T07:58:26.000','2006-02-15T22:13:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3790','140','1','9094','4.99','2005-07-30T08:35:10.000','2006-02-15T22:13:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3791','140','1','9404','0.99','2005-07-30T20:21:35.000','2006-02-15T22:13:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3792','140','1','10342','6.99','2005-08-01T05:11:11.000','2006-02-15T22:13:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3793','140','2','11430','3.99','2005-08-02T20:04:36.000','2006-02-15T22:13:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3794','140','1','12086','4.99','2005-08-17T22:20:01.000','2006-02-15T22:13:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3795','140','1','12675','4.99','2005-08-18T19:34:02.000','2006-02-15T22:13:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3796','140','2','13053','10.99','2005-08-19T09:31:48.000','2006-02-15T22:13:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3797','140','1','15261','2.99','2005-08-22T18:24:34.000','2006-02-15T22:13:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3798','140','1','15852','2.99','2005-08-23T15:47:02.000','2006-02-15T22:13:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3799','141','2','930','2.99','2005-05-30T12:44:57.000','2006-02-15T22:13:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3800','141','2','1242','7.99','2005-06-15T05:05:07.000','2006-02-15T22:13:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3801','141','2','2895','7.99','2005-06-20T02:26:31.000','2006-02-15T22:13:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3802','141','1','3434','4.99','2005-06-21T19:08:28.000','2006-02-15T22:13:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3803','141','1','4057','1.99','2005-07-07T04:00:20.000','2006-02-15T22:13:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3804','141','2','4297','0.99','2005-07-07T16:24:09.000','2006-02-15T22:13:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3805','141','1','4656','5.99','2005-07-08T09:50:10.000','2006-02-15T22:13:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3806','141','2','5062','2.99','2005-07-09T04:36:49.000','2006-02-15T22:13:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3807','141','1','5769','0.99','2005-07-10T13:17:58.000','2006-02-15T22:13:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3808','141','2','6979','4.99','2005-07-27T00:49:53.000','2006-02-15T22:13:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3809','141','2','7878','2.99','2005-07-28T10:27:10.000','2006-02-15T22:13:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3810','141','1','8434','4.99','2005-07-29T07:20:14.000','2006-02-15T22:13:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3811','141','2','9073','7.99','2005-07-30T07:49:56.000','2006-02-15T22:13:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3812','141','1','9584','4.99','2005-07-31T03:05:48.000','2006-02-15T22:13:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3813','141','2','9683','2.99','2005-07-31T06:47:13.000','2006-02-15T22:13:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3814','141','1','10287','3.99','2005-08-01T03:37:01.000','2006-02-15T22:13:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3815','141','1','10379','1.99','2005-08-01T06:34:29.000','2006-02-15T22:13:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3816','141','1','10798','4.99','2005-08-01T22:03:10.000','2006-02-15T22:13:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3817','141','1','11411','2.99','2005-08-02T19:29:47.000','2006-02-15T22:13:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3818','141','1','11412','5.99','2005-08-02T19:32:51.000','2006-02-15T22:13:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3819','141','1','12032','5.99','2005-08-17T20:14:26.000','2006-02-15T22:13:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3820','141','1','12093','2.99','2005-08-17T22:28:40.000','2006-02-15T22:13:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3821','141','2','12107','3.99','2005-08-17T22:56:24.000','2006-02-15T22:13:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3822','141','2','12353','2.99','2005-08-18T07:33:08.000','2006-02-15T22:13:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3823','141','1','13000','0.99','2005-08-19T07:36:42.000','2006-02-15T22:13:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3824','141','2','13169','2.99','2005-08-19T13:43:35.000','2006-02-15T22:13:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3825','141','2','13470','4.99','2005-08-20T01:01:16.000','2006-02-15T22:13:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3826','141','2','14059','7.99','2005-08-20T22:24:44.000','2006-02-15T22:13:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3827','141','1','14112','2.99','2005-08-21T01:00:46.000','2006-02-15T22:13:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3828','141','1','15013','4.99','2005-08-22T08:42:45.000','2006-02-15T22:13:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3829','141','1','15309','0.99','2005-08-22T19:54:52.000','2006-02-15T22:13:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3830','141','1','15964','2.99','2005-08-23T19:45:25.000','2006-02-15T22:13:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3831','142','2','11','8.99','2005-05-25T00:09:02.000','2006-02-15T22:13:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3832','142','1','148','0.99','2005-05-26T00:25:23.000','2006-02-15T22:13:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3833','142','1','575','9.99','2005-05-28T10:56:09.000','2006-02-15T22:13:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3834','142','1','1268','1.99','2005-06-15T07:29:30.000','2006-02-15T22:13:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3835','142','1','3214','2.99','2005-06-21T01:08:26.000','2006-02-15T22:13:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3836','142','2','3492','2.99','2005-07-05T23:44:37.000','2006-02-15T22:13:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3837','142','2','4497','4.99','2005-07-08T01:51:32.000','2006-02-15T22:13:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3838','142','1','4531','4.99','2005-07-08T03:27:59.000','2006-02-15T22:13:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3839','142','1','6522','0.99','2005-07-12T04:11:58.000','2006-02-15T22:13:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3840','142','1','7764','2.99','2005-07-28T06:40:05.000','2006-02-15T22:13:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3841','142','2','8513','2.99','2005-07-29T09:52:59.000','2006-02-15T22:13:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3842','142','2','8623','4.99','2005-07-29T13:55:11.000','2006-02-15T22:13:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3843','142','1','9020','7.99','2005-07-30T05:31:27.000','2006-02-15T22:13:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3844','142','1','9131','2.99','2005-07-30T09:55:57.000','2006-02-15T22:13:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3845','142','1','9419','5.99','2005-07-30T21:04:59.000','2006-02-15T22:13:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3846','142','2','10934','5.99','2005-08-02T02:52:18.000','2006-02-15T22:13:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3847','142','2','11244','5.99','2005-08-02T13:33:24.000','2006-02-15T22:13:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3848','142','1','12964','0.99','2005-08-19T06:29:13.000','2006-02-15T22:13:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3849','142','1','13044','0.99','2005-08-19T09:14:31.000','2006-02-15T22:13:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3850','142','2','13745','0.99','2005-08-20T10:53:49.000','2006-02-15T22:13:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3851','142','1','13959','0.99','2005-08-20T18:16:21.000','2006-02-15T22:13:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3852','142','2','14116','4.99','2005-08-21T01:11:17.000','2006-02-15T22:13:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3853','142','2','14813','0.99','2005-08-22T01:11:37.000','2006-02-15T22:13:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3854','142','2','15333','2.99','2005-08-22T20:44:06.000','2006-02-15T22:13:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3855','142','1','15477','1.99','2005-08-23T01:46:35.000','2006-02-15T22:13:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3856','142','1','15454','0.99','2006-02-14T15:16:03.000','2006-02-15T22:13:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3857','143','1','221','2.99','2005-05-26T10:14:09.000','2006-02-15T22:13:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3858','143','1','312','2.99','2005-05-26T22:52:19.000','2006-02-15T22:13:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3859','143','2','1898','1.99','2005-06-17T04:28:11.000','2006-02-15T22:13:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3860','143','1','1942','4.99','2005-06-17T07:43:39.000','2006-02-15T22:13:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3861','143','2','2251','3.99','2005-06-18T05:05:08.000','2006-02-15T22:13:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3862','143','1','2574','0.99','2005-06-19T04:23:52.000','2006-02-15T22:13:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3863','143','1','2588','4.99','2005-06-19T05:20:31.000','2006-02-15T22:13:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3864','143','1','4031','7.99','2005-07-07T02:32:07.000','2006-02-15T22:13:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3865','143','2','4221','0.99','2005-07-07T12:18:57.000','2006-02-15T22:13:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3866','143','1','4585','7.99','2005-07-08T06:11:58.000','2006-02-15T22:13:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3867','143','2','6076','6.99','2005-07-11T05:05:30.000','2006-02-15T22:13:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3868','143','2','6207','4.99','2005-07-11T12:34:24.000','2006-02-15T22:13:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3869','143','1','8312','0.99','2005-07-29T03:32:38.000','2006-02-15T22:13:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3870','143','1','8335','0.99','2005-07-29T04:18:25.000','2006-02-15T22:13:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3871','143','2','9889','1.99','2005-07-31T14:02:50.000','2006-02-15T22:13:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3872','143','1','10118','0.99','2005-07-31T21:16:31.000','2006-02-15T22:13:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3873','143','1','11278','6.99','2005-08-02T14:29:43.000','2006-02-15T22:13:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3874','143','2','11651','6.99','2005-08-17T05:02:25.000','2006-02-15T22:13:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3875','143','1','12408','2.99','2005-08-18T09:40:38.000','2006-02-15T22:13:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3876','143','2','13835','4.99','2005-08-20T14:06:33.000','2006-02-15T22:13:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3877','143','1','15250','5.99','2005-08-22T18:03:11.000','2006-02-15T22:13:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3878','143','1','16029','4.99','2005-08-23T21:54:02.000','2006-02-15T22:13:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3879','144','1','323','2.99','2005-05-27T00:49:27.000','2006-02-15T22:13:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3880','144','2','345','2.99','2005-05-27T04:32:25.000','2006-02-15T22:13:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3881','144','1','1814','5.99','2005-06-16T21:15:22.000','2006-02-15T22:13:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3882','144','1','1943','0.99','2005-06-17T07:49:17.000','2006-02-15T22:13:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3883','144','1','2756','4.99','2005-06-19T16:57:42.000','2006-02-15T22:13:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3884','144','2','3019','4.99','2005-06-20T11:11:52.000','2006-02-15T22:13:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3885','144','1','3145','2.99','2005-06-20T20:21:17.000','2006-02-15T22:13:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3886','144','1','3321','2.99','2005-06-21T08:33:26.000','2006-02-15T22:13:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3887','144','1','4726','6.99','2005-07-08T12:50:54.000','2006-02-15T22:13:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3888','144','2','4818','3.99','2005-07-08T17:18:22.000','2006-02-15T22:13:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3889','144','2','5049','0.99','2005-07-09T03:54:12.000','2006-02-15T22:13:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3890','144','2','5374','8.99','2005-07-09T18:52:08.000','2006-02-15T22:13:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3891','144','2','5408','7.99','2005-07-09T20:16:51.000','2006-02-15T22:13:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3892','144','2','5526','7.99','2005-07-10T02:04:03.000','2006-02-15T22:13:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3893','144','2','6614','7.99','2005-07-12T08:33:49.000','2006-02-15T22:13:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3894','144','2','6791','9.99','2005-07-12T16:35:07.000','2006-02-15T22:13:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3895','144','2','7378','5.99','2005-07-27T15:31:33.000','2006-02-15T22:13:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3896','144','2','7566','2.99','2005-07-27T22:34:45.000','2006-02-15T22:13:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3897','144','1','7830','0.99','2005-07-28T08:43:49.000','2006-02-15T22:13:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3898','144','1','7858','3.99','2005-07-28T09:50:18.000','2006-02-15T22:13:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3899','144','2','8459','5.99','2005-07-29T08:05:40.000','2006-02-15T22:13:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3900','144','1','8983','0.99','2005-07-30T04:31:08.000','2006-02-15T22:13:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3901','144','1','9034','7.99','2005-07-30T06:10:58.000','2006-02-15T22:13:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3902','144','1','9098','3.99','2005-07-30T08:44:21.000','2006-02-15T22:13:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3903','144','2','9174','4.99','2005-07-30T11:42:10.000','2006-02-15T22:13:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3904','144','2','9714','0.99','2005-07-31T08:15:32.000','2006-02-15T22:13:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3905','144','1','10302','0.99','2005-08-01T04:12:08.000','2006-02-15T22:13:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3906','144','1','10593','4.99','2005-08-01T14:13:19.000','2006-02-15T22:13:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3907','144','1','10740','5.99','2005-08-01T19:50:32.000','2006-02-15T22:13:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3908','144','1','10951','4.99','2005-08-02T03:26:35.000','2006-02-15T22:13:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3909','144','1','11228','2.99','2005-08-02T12:55:23.000','2006-02-15T22:13:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3910','144','2','11476','6.99','2005-08-02T22:03:47.000','2006-02-15T22:13:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3911','144','1','11534','7.99','2005-08-17T00:35:27.000','2006-02-15T22:13:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3912','144','1','11859','4.99','2005-08-17T13:51:20.000','2006-02-15T22:13:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3913','144','2','12087','2.99','2005-08-17T22:20:12.000','2006-02-15T22:13:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3914','144','2','12733','2.99','2005-08-18T21:59:00.000','2006-02-15T22:13:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3915','144','1','12858','3.99','2005-08-19T02:22:16.000','2006-02-15T22:13:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3916','144','2','12980','6.99','2005-08-19T07:03:14.000','2006-02-15T22:13:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3917','144','2','13881','2.99','2005-08-20T15:18:55.000','2006-02-15T22:13:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3918','144','2','14159','2.99','2005-08-21T02:45:58.000','2006-02-15T22:13:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3919','144','1','15017','1.99','2005-08-22T08:47:44.000','2006-02-15T22:13:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3920','144','1','15753','7.99','2005-08-23T12:43:30.000','2006-02-15T22:13:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3921','145','1','500','0.99','2005-05-28T01:05:25.000','2006-02-15T22:13:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3922','145','2','2271','4.99','2005-06-18T06:29:52.000','2006-02-15T22:13:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3923','145','2','2614','0.99','2005-06-19T07:28:11.000','2006-02-15T22:13:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3924','145','1','3647','5.99','2005-07-06T07:29:17.000','2006-02-15T22:13:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3925','145','2','4201','8.99','2005-07-07T11:19:51.000','2006-02-15T22:13:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3926','145','1','4364','4.99','2005-07-07T19:46:51.000','2006-02-15T22:13:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3927','145','2','4405','6.99','2005-07-07T21:33:16.000','2006-02-15T22:13:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3928','145','1','4470','2.99','2005-07-08T00:20:57.000','2006-02-15T22:13:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3929','145','2','4817','2.99','2005-07-08T17:17:31.000','2006-02-15T22:13:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3930','145','2','6056','2.99','2005-07-11T04:01:27.000','2006-02-15T22:13:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3931','145','1','6339','1.99','2005-07-11T19:45:32.000','2006-02-15T22:13:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3932','145','2','6378','0.99','2005-07-11T21:45:23.000','2006-02-15T22:13:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3933','145','2','7061','2.99','2005-07-27T03:51:10.000','2006-02-15T22:13:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3934','145','1','7529','7.99','2005-07-27T21:18:08.000','2006-02-15T22:13:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3935','145','2','7954','0.99','2005-07-28T13:25:05.000','2006-02-15T22:13:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3936','145','1','8380','0.99','2005-07-29T05:31:29.000','2006-02-15T22:13:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3937','145','1','9156','2.99','2005-07-30T11:04:55.000','2006-02-15T22:13:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3938','145','2','9576','0.99','2005-07-31T02:52:59.000','2006-02-15T22:13:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3939','145','2','10799','4.99','2005-08-01T22:03:31.000','2006-02-15T22:13:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3940','145','2','11904','5.99','2005-08-17T15:39:26.000','2006-02-15T22:13:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3941','145','2','11954','2.99','2005-08-17T17:18:36.000','2006-02-15T22:13:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3942','145','1','12637','2.99','2005-08-18T18:06:53.000','2006-02-15T22:13:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3943','145','2','12785','2.99','2005-08-19T00:05:49.000','2006-02-15T22:13:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3944','145','2','13012','7.99','2005-08-19T07:54:59.000','2006-02-15T22:13:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3945','145','1','13164','3.99','2005-08-19T13:30:55.000','2006-02-15T22:13:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3946','145','2','13272','0.99','2005-08-19T17:49:13.000','2006-02-15T22:13:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3947','145','2','14044','5.99','2005-08-20T21:48:38.000','2006-02-15T22:13:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3948','145','2','14389','6.99','2005-08-21T10:15:20.000','2006-02-15T22:13:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3949','146','2','762','7.99','2005-05-29T11:15:51.000','2006-02-15T22:13:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3950','146','1','1073','4.99','2005-05-31T09:55:04.000','2006-02-15T22:13:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3951','146','2','1209','7.99','2005-06-15T02:31:12.000','2006-02-15T22:13:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3952','146','2','1724','1.99','2005-06-16T15:15:43.000','2006-02-15T22:13:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3953','146','2','2099','2.99','2005-06-17T18:47:26.000','2006-02-15T22:13:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3954','146','1','2242','3.99','2005-06-18T04:32:28.000','2006-02-15T22:13:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3955','146','1','2342','2.99','2005-06-18T11:42:40.000','2006-02-15T22:13:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3956','146','1','2800','0.99','2005-06-19T19:15:56.000','2006-02-15T22:13:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3957','146','1','3131','4.99','2005-06-20T19:08:00.000','2006-02-15T22:13:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3958','146','1','4849','6.99','2005-07-08T18:34:34.000','2006-02-15T22:13:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3959','146','2','5000','4.99','2005-07-09T01:16:13.000','2006-02-15T22:13:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3960','146','1','6102','7.99','2005-07-11T06:53:09.000','2006-02-15T22:13:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3961','146','2','6184','6.99','2005-07-11T11:19:21.000','2006-02-15T22:13:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3962','146','1','6327','4.99','2005-07-11T19:07:29.000','2006-02-15T22:13:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3963','146','1','6990','0.99','2005-07-27T01:02:46.000','2006-02-15T22:13:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3964','146','2','8246','3.99','2005-07-29T00:38:41.000','2006-02-15T22:13:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3965','146','2','11173','7.99','2005-08-02T10:28:00.000','2006-02-15T22:13:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3966','146','1','11221','2.99','2005-08-02T12:32:12.000','2006-02-15T22:13:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3967','146','2','11370','0.99','2005-08-02T18:06:01.000','2006-02-15T22:13:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3968','146','2','11392','5.99','2005-08-02T18:41:11.000','2006-02-15T22:13:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3969','146','1','11573','4.99','2005-08-17T01:38:18.000','2006-02-15T22:13:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3970','146','1','11857','4.99','2005-08-17T13:48:30.000','2006-02-15T22:13:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3971','146','1','12129','7.99','2005-08-17T23:31:25.000','2006-02-15T22:13:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3972','146','1','12385','2.99','2005-08-18T08:39:33.000','2006-02-15T22:13:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3973','146','1','12888','4.99','2005-08-19T03:41:09.000','2006-02-15T22:13:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3974','146','1','13606','4.99','2005-08-20T06:07:01.000','2006-02-15T22:13:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3975','146','2','13829','4.99','2005-08-20T13:50:17.000','2006-02-15T22:13:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3976','146','2','14143','2.99','2005-08-21T02:10:32.000','2006-02-15T22:13:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3977','146','1','15842','6.99','2005-08-23T15:36:05.000','2006-02-15T22:13:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3978','147','1','362','0.99','2005-05-27T07:10:25.000','2006-02-15T22:13:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3979','147','1','509','0.99','2005-05-28T02:51:12.000','2006-02-15T22:13:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3980','147','1','2171','0.99','2005-06-18T00:06:04.000','2006-02-15T22:13:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3981','147','1','2456','6.99','2005-06-18T19:36:50.000','2006-02-15T22:13:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3982','147','2','2859','2.99','2005-06-19T23:18:42.000','2006-02-15T22:13:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3983','147','2','3011','5.99','2005-06-20T10:39:10.000','2006-02-15T22:13:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3984','147','2','3919','7.99','2005-07-06T20:26:21.000','2006-02-15T22:13:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3985','147','2','3956','2.99','2005-07-06T22:01:51.000','2006-02-15T22:13:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3986','147','2','4792','0.99','2005-07-08T16:29:38.000','2006-02-15T22:13:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3987','147','2','5044','0.99','2005-07-09T03:30:25.000','2006-02-15T22:13:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3988','147','1','5567','2.99','2005-07-10T03:36:46.000','2006-02-15T22:13:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3989','147','1','5844','0.99','2005-07-10T17:14:43.000','2006-02-15T22:13:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3990','147','2','6343','0.99','2005-07-11T19:51:35.000','2006-02-15T22:13:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3991','147','2','6469','4.99','2005-07-12T01:29:27.000','2006-02-15T22:13:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3992','147','2','6753','2.99','2005-07-12T14:55:42.000','2006-02-15T22:13:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3993','147','2','7044','0.99','2005-07-27T03:27:29.000','2006-02-15T22:13:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3994','147','1','7723','0.99','2005-07-28T04:45:37.000','2006-02-15T22:13:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3995','147','1','8893','2.99','2005-07-30T00:48:19.000','2006-02-15T22:13:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3996','147','2','9772','0.99','2005-07-31T09:56:07.000','2006-02-15T22:13:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3997','147','1','10706','7.99','2005-08-01T18:41:28.000','2006-02-15T22:13:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3998','147','2','10752','8.99','2005-08-01T20:08:49.000','2006-02-15T22:13:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('3999','147','1','12284','4.99','2005-08-18T04:55:49.000','2006-02-15T22:13:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4000','147','1','12757','4.99','2005-08-18T22:57:45.000','2006-02-15T22:13:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4001','147','2','13542','4.99','2005-08-20T03:41:57.000','2006-02-15T22:13:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4002','147','2','13670','3.99','2005-08-20T08:27:01.000','2006-02-15T22:13:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4003','147','2','14021','4.99','2005-08-20T21:02:12.000','2006-02-15T22:13:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4004','147','1','14156','0.99','2005-08-21T02:35:16.000','2006-02-15T22:13:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4005','147','2','14641','0.99','2005-08-21T19:05:23.000','2006-02-15T22:13:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4006','147','2','14960','4.99','2005-08-22T06:31:36.000','2006-02-15T22:13:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4007','147','1','15052','2.99','2005-08-22T10:09:19.000','2006-02-15T22:13:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4008','147','2','15331','4.99','2005-08-22T20:37:57.000','2006-02-15T22:13:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4009','147','2','15513','4.99','2005-08-23T03:01:56.000','2006-02-15T22:13:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4010','147','1','15730','8.99','2005-08-23T11:32:35.000','2006-02-15T22:13:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4011','147','2','16004','6.99','2005-08-23T20:53:20.000','2006-02-15T22:13:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4012','148','1','682','4.99','2005-05-28T23:53:18.000','2006-02-15T22:13:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4013','148','1','1501','1.99','2005-06-15T22:02:35.000','2006-02-15T22:13:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4014','148','2','1517','6.99','2005-06-15T23:20:26.000','2006-02-15T22:13:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4015','148','2','2751','3.99','2005-06-19T16:39:23.000','2006-02-15T22:13:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4016','148','2','2843','3.99','2005-06-19T22:36:39.000','2006-02-15T22:13:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4017','148','2','2847','5.99','2005-06-19T22:54:01.000','2006-02-15T22:13:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4018','148','1','3653','0.99','2005-07-06T07:45:13.000','2006-02-15T22:13:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4019','148','1','4080','0.99','2005-07-07T05:09:54.000','2006-02-15T22:13:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4020','148','1','4746','2.99','2005-07-08T13:47:55.000','2006-02-15T22:13:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4021','148','1','4950','2.99','2005-07-08T22:58:07.000','2006-02-15T22:13:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4022','148','1','5034','4.99','2005-07-09T02:48:15.000','2006-02-15T22:13:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4023','148','1','5372','4.99','2005-07-09T18:48:39.000','2006-02-15T22:13:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4024','148','1','6169','1.99','2005-07-11T10:25:56.000','2006-02-15T22:13:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4025','148','1','6640','8.99','2005-07-12T10:27:19.000','2006-02-15T22:13:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4026','148','2','6793','10.99','2005-07-12T16:37:55.000','2006-02-15T22:13:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4027','148','1','7656','0.99','2005-07-28T02:07:19.000','2006-02-15T22:13:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4028','148','2','7693','4.99','2005-07-28T03:31:22.000','2006-02-15T22:13:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4029','148','1','7865','9.99','2005-07-28T10:07:04.000','2006-02-15T22:13:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4030','148','2','8111','4.99','2005-07-28T19:10:03.000','2006-02-15T22:13:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4031','148','2','8331','3.99','2005-07-29T04:13:29.000','2006-02-15T22:13:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4032','148','1','8394','4.99','2005-07-29T06:02:14.000','2006-02-15T22:13:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4033','148','2','8578','4.99','2005-07-29T11:58:14.000','2006-02-15T22:13:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4034','148','2','8626','4.99','2005-07-29T14:03:20.000','2006-02-15T22:13:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4035','148','1','9023','5.99','2005-07-30T05:36:40.000','2006-02-15T22:13:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4036','148','1','9106','2.99','2005-07-30T08:52:34.000','2006-02-15T22:13:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4037','148','1','9530','1.99','2005-07-31T01:09:06.000','2006-02-15T22:13:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4038','148','1','9594','4.99','2005-07-31T03:23:52.000','2006-02-15T22:13:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4039','148','2','10067','4.99','2005-07-31T19:37:58.000','2006-02-15T22:13:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4040','148','2','10830','6.99','2005-08-01T23:18:06.000','2006-02-15T22:13:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4041','148','1','11357','10.99','2005-08-02T17:42:49.000','2006-02-15T22:13:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4042','148','1','12029','2.99','2005-08-17T20:07:01.000','2006-02-15T22:13:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4043','148','2','12038','0.99','2005-08-17T20:28:26.000','2006-02-15T22:13:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4044','148','2','12512','3.99','2005-08-18T13:28:27.000','2006-02-15T22:13:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4045','148','1','12944','6.99','2005-08-19T05:48:12.000','2006-02-15T22:13:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4046','148','1','12983','6.99','2005-08-19T07:06:51.000','2006-02-15T22:13:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4047','148','1','14055','0.99','2005-08-20T22:18:00.000','2006-02-15T22:13:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4048','148','1','14155','4.99','2005-08-21T02:31:35.000','2006-02-15T22:13:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4049','148','2','14184','6.99','2005-08-21T03:24:50.000','2006-02-15T22:13:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4050','148','2','14629','2.99','2005-08-21T18:39:52.000','2006-02-15T22:13:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4051','148','2','14713','0.99','2005-08-21T21:27:24.000','2006-02-15T22:13:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4052','148','2','14879','5.99','2005-08-22T03:42:12.000','2006-02-15T22:13:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4053','148','2','14965','2.99','2005-08-22T06:45:53.000','2006-02-15T22:13:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4054','148','2','15237','4.99','2005-08-22T17:44:30.000','2006-02-15T22:13:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4055','148','2','15379','8.99','2005-08-22T22:26:13.000','2006-02-15T22:13:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4056','148','1','15541','3.99','2005-08-23T04:13:53.000','2006-02-15T22:13:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4057','148','2','15586','3.99','2005-08-23T05:57:04.000','2006-02-15T22:13:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4058','149','1','764','4.99','2005-05-29T11:37:35.000','2006-02-15T22:13:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4059','149','2','1521','2.99','2005-06-15T23:58:53.000','2006-02-15T22:13:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4060','149','1','1800','2.99','2005-06-16T20:18:46.000','2006-02-15T22:13:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4061','149','2','1996','6.99','2005-06-17T11:17:45.000','2006-02-15T22:13:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4062','149','2','2194','4.99','2005-06-18T01:41:37.000','2006-02-15T22:13:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4063','149','1','2305','5.99','2005-06-18T08:31:18.000','2006-02-15T22:13:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4064','149','2','2383','7.99','2005-06-18T15:17:59.000','2006-02-15T22:13:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4065','149','1','2752','0.99','2005-06-19T16:44:18.000','2006-02-15T22:13:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4066','149','1','3894','2.99','2005-07-06T19:01:39.000','2006-02-15T22:13:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4067','149','1','3939','6.99','2005-07-06T21:16:32.000','2006-02-15T22:13:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4068','149','1','4766','3.99','2005-07-08T15:16:04.000','2006-02-15T22:13:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4069','149','1','4837','0.99','2005-07-08T18:09:12.000','2006-02-15T22:13:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4070','149','1','5091','2.99','2005-07-09T05:52:54.000','2006-02-15T22:13:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4071','149','1','5298','10.99','2005-07-09T15:36:17.000','2006-02-15T22:13:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4072','149','1','6356','4.99','2005-07-11T20:57:48.000','2006-02-15T22:13:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4073','149','2','6940','5.99','2005-07-26T23:18:35.000','2006-02-15T22:13:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4074','149','2','7559','4.99','2005-07-27T22:20:03.000','2006-02-15T22:13:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4075','149','1','7989','6.99','2005-07-28T14:39:05.000','2006-02-15T22:13:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4076','149','2','10154','2.99','2005-07-31T22:30:49.000','2006-02-15T22:13:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4077','149','2','10737','7.99','2005-08-01T19:31:24.000','2006-02-15T22:13:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4078','149','2','10967','0.99','2005-08-02T04:02:16.000','2006-02-15T22:13:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4079','149','1','11561','2.99','2005-08-17T01:23:09.000','2006-02-15T22:13:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4080','149','1','12000','4.99','2005-08-17T18:49:44.000','2006-02-15T22:13:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4081','149','1','14771','3.99','2005-08-21T23:50:15.000','2006-02-15T22:13:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4082','149','2','15479','4.99','2005-08-23T01:50:53.000','2006-02-15T22:13:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4083','149','2','15562','2.99','2005-08-23T05:04:33.000','2006-02-15T22:13:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4084','150','1','422','3.99','2005-05-27T15:31:55.000','2006-02-15T22:13:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4085','150','1','609','2.99','2005-05-28T15:04:02.000','2006-02-15T22:13:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4086','150','1','995','3.99','2005-05-31T00:06:02.000','2006-02-15T22:13:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4087','150','2','3187','1.99','2005-06-20T23:06:07.000','2006-02-15T22:13:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4088','150','1','3456','5.99','2005-06-21T21:19:47.000','2006-02-15T22:13:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4089','150','1','4271','6.99','2005-07-07T14:38:52.000','2006-02-15T22:13:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4090','150','1','6633','2.99','2005-07-12T09:35:42.000','2006-02-15T22:13:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4091','150','2','7690','4.99','2005-07-28T03:26:21.000','2006-02-15T22:13:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4092','150','1','9121','2.99','2005-07-30T09:36:26.000','2006-02-15T22:13:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4093','150','1','10686','2.99','2005-08-01T17:51:21.000','2006-02-15T22:13:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4094','150','2','11123','2.99','2005-08-02T08:54:17.000','2006-02-15T22:13:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4095','150','2','11789','6.99','2005-08-17T10:59:24.000','2006-02-15T22:13:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4096','150','2','12260','6.99','2005-08-18T04:15:43.000','2006-02-15T22:13:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4097','150','2','12335','2.99','2005-08-18T06:59:15.000','2006-02-15T22:13:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4098','150','2','12627','2.99','2005-08-18T17:37:11.000','2006-02-15T22:13:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4099','150','1','12887','1.99','2005-08-19T03:38:54.000','2006-02-15T22:13:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4100','150','2','12890','0.99','2005-08-19T03:42:08.000','2006-02-15T22:13:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4101','150','1','13116','6.99','2005-08-19T11:31:41.000','2006-02-15T22:13:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4102','150','2','13255','8.99','2005-08-19T16:54:12.000','2006-02-15T22:13:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4103','150','1','13372','2.99','2005-08-19T21:23:19.000','2006-02-15T22:13:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4104','150','2','13599','5.99','2005-08-20T06:00:03.000','2006-02-15T22:13:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4105','150','2','14165','0.99','2005-08-21T02:59:17.000','2006-02-15T22:13:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4106','150','2','14454','2.99','2005-08-21T12:35:49.000','2006-02-15T22:13:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4107','150','2','14520','9.99','2005-08-21T15:00:49.000','2006-02-15T22:13:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4108','150','1','14663','0.99','2005-08-21T19:47:55.000','2006-02-15T22:13:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4109','151','2','164','4.99','2005-05-26T02:26:49.000','2006-02-15T22:13:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4110','151','2','418','5.99','2005-05-27T15:13:17.000','2006-02-15T22:13:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4111','151','2','2474','2.99','2005-06-18T20:51:34.000','2006-02-15T22:13:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4112','151','2','2947','2.99','2005-06-20T06:00:21.000','2006-02-15T22:13:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4113','151','1','3017','3.99','2005-06-20T11:08:56.000','2006-02-15T22:13:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4114','151','2','3089','0.99','2005-06-20T15:57:01.000','2006-02-15T22:13:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4115','151','2','3390','2.99','2005-06-21T15:10:50.000','2006-02-15T22:13:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4116','151','1','4376','2.99','2005-07-07T20:24:33.000','2006-02-15T22:13:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4117','151','2','6720','0.99','2005-07-12T13:41:16.000','2006-02-15T22:13:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4118','151','2','6768','3.99','2005-07-12T15:47:51.000','2006-02-15T22:13:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4119','151','2','6854','0.99','2005-07-12T19:38:57.000','2006-02-15T22:13:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4120','151','1','7189','0.99','2005-07-27T08:35:02.000','2006-02-15T22:13:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4121','151','2','7332','3.99','2005-07-27T13:58:57.000','2006-02-15T22:13:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4122','151','1','9253','4.99','2005-07-30T14:20:12.000','2006-02-15T22:13:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4123','151','1','9890','4.99','2005-07-31T14:04:44.000','2006-02-15T22:13:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4124','151','1','9969','2.99','2005-07-31T16:38:12.000','2006-02-15T22:13:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4125','151','1','10078','2.99','2005-07-31T20:02:02.000','2006-02-15T22:13:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4126','151','1','10311','4.99','2005-08-01T04:27:59.000','2006-02-15T22:13:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4127','151','1','10662','2.99','2005-08-01T16:50:57.000','2006-02-15T22:13:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4128','151','2','11714','2.99','2005-08-17T07:34:55.000','2006-02-15T22:13:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4129','151','2','13230','0.99','2005-08-19T16:12:07.000','2006-02-15T22:13:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4130','151','1','13568','5.99','2005-08-20T05:02:46.000','2006-02-15T22:13:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4131','151','1','14856','4.99','2005-08-22T02:31:51.000','2006-02-15T22:13:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4132','151','2','14922','3.99','2005-08-22T05:13:05.000','2006-02-15T22:13:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4133','151','1','15227','4.99','2005-08-22T17:22:41.000','2006-02-15T22:13:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4134','151','1','15926','2.99','2005-08-23T18:20:56.000','2006-02-15T22:13:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4135','151','2','15996','2.99','2005-08-23T20:31:38.000','2006-02-15T22:13:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4136','152','2','359','4.99','2005-05-27T06:48:33.000','2006-02-15T22:13:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4137','152','1','745','4.99','2005-05-29T09:22:57.000','2006-02-15T22:13:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4138','152','1','2882','4.99','2005-06-20T01:26:26.000','2006-02-15T22:13:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4139','152','2','3577','2.99','2005-07-06T03:40:36.000','2006-02-15T22:13:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4140','152','1','3786','7.99','2005-07-06T14:00:41.000','2006-02-15T22:13:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4141','152','1','4974','4.99','2005-07-09T00:00:36.000','2006-02-15T22:13:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4142','152','1','6273','0.99','2005-07-11T16:08:41.000','2006-02-15T22:13:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4143','152','1','6612','2.99','2005-07-12T08:28:33.000','2006-02-15T22:13:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4144','152','1','9010','5.99','2005-07-30T05:12:04.000','2006-02-15T22:13:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4145','152','1','10320','6.99','2005-08-01T04:39:26.000','2006-02-15T22:13:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4146','152','2','11638','6.99','2005-08-17T04:39:09.000','2006-02-15T22:13:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4147','152','2','11783','0.99','2005-08-17T10:39:24.000','2006-02-15T22:13:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4148','152','1','12697','2.99','2005-08-18T20:14:56.000','2006-02-15T22:13:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4149','152','1','12917','4.99','2005-08-19T04:27:11.000','2006-02-15T22:13:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4150','152','2','12960','1.99','2005-08-19T06:21:52.000','2006-02-15T22:13:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4151','152','1','13204','4.99','2005-08-19T15:02:48.000','2006-02-15T22:13:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4152','152','2','13484','0.99','2005-08-20T01:16:52.000','2006-02-15T22:13:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4153','152','1','13986','0.99','2005-08-20T19:13:23.000','2006-02-15T22:13:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4154','152','1','14173','0.99','2005-08-21T03:01:01.000','2006-02-15T22:13:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4155','152','2','14668','4.99','2005-08-21T19:51:30.000','2006-02-15T22:13:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4156','152','2','11848','4.99','2006-02-14T15:16:03.000','2006-02-15T22:13:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4157','153','1','2224','0.99','2005-06-18T03:33:58.000','2006-02-15T22:13:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4158','153','1','2649','0.99','2005-06-19T10:20:09.000','2006-02-15T22:13:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4159','153','1','2893','4.99','2005-06-20T02:22:08.000','2006-02-15T22:13:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4160','153','1','2945','5.99','2005-06-20T05:49:27.000','2006-02-15T22:13:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4161','153','1','3795','0.99','2005-07-06T14:37:41.000','2006-02-15T22:13:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4162','153','1','3949','0.99','2005-07-06T21:46:36.000','2006-02-15T22:13:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4163','153','1','4194','5.99','2005-07-07T10:59:39.000','2006-02-15T22:13:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4164','153','2','4670','5.99','2005-07-08T10:14:18.000','2006-02-15T22:13:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4165','153','2','5676','0.99','2005-07-10T08:38:32.000','2006-02-15T22:13:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4166','153','2','5771','0.99','2005-07-10T13:26:45.000','2006-02-15T22:13:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4167','153','2','6818','9.99','2005-07-12T18:20:54.000','2006-02-15T22:13:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4168','153','2','7824','7.99','2005-07-28T08:34:47.000','2006-02-15T22:13:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4169','153','2','9936','0.99','2005-07-31T15:27:41.000','2006-02-15T22:13:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4170','153','2','10015','4.99','2005-07-31T18:11:17.000','2006-02-15T22:13:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4171','153','2','11368','4.99','2005-08-02T18:03:05.000','2006-02-15T22:13:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4172','153','1','12103','1.99','2005-08-17T22:49:09.000','2006-02-15T22:13:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4173','153','1','12439','3.99','2005-08-18T10:44:57.000','2006-02-15T22:13:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4174','153','1','12882','4.99','2005-08-19T03:33:46.000','2006-02-15T22:13:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4175','153','1','14664','4.99','2005-08-21T19:48:47.000','2006-02-15T22:13:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4176','153','1','14747','4.99','2005-08-21T23:00:02.000','2006-02-15T22:13:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4177','153','1','14944','4.99','2005-08-22T06:01:26.000','2006-02-15T22:13:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4178','153','2','15267','0.99','2005-08-22T18:37:48.000','2006-02-15T22:13:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4179','153','2','15444','7.99','2005-08-23T00:46:52.000','2006-02-15T22:13:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4180','153','1','15593','1.99','2005-08-23T06:15:09.000','2006-02-15T22:13:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4181','154','1','469','5.99','2005-05-27T21:14:26.000','2006-02-15T22:13:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4182','154','2','865','7.99','2005-05-30T03:39:44.000','2006-02-15T22:13:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4183','154','2','978','5.99','2005-05-30T21:30:52.000','2006-02-15T22:13:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4184','154','1','1963','0.99','2005-06-17T09:09:31.000','2006-02-15T22:13:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4185','154','1','2886','4.99','2005-06-20T01:38:39.000','2006-02-15T22:13:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4186','154','1','2985','2.99','2005-06-20T08:45:08.000','2006-02-15T22:13:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4187','154','2','3806','7.99','2005-07-06T15:09:41.000','2006-02-15T22:13:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4188','154','2','3912','0.99','2005-07-06T20:10:03.000','2006-02-15T22:13:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4189','154','2','4132','4.99','2005-07-07T08:06:07.000','2006-02-15T22:13:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4190','154','1','4252','2.99','2005-07-07T14:13:05.000','2006-02-15T22:13:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4191','154','1','4850','5.99','2005-07-08T18:39:31.000','2006-02-15T22:13:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4192','154','1','5101','0.99','2005-07-09T06:21:29.000','2006-02-15T22:13:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4193','154','2','5760','2.99','2005-07-10T12:44:48.000','2006-02-15T22:13:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4194','154','1','6048','0.99','2005-07-11T03:32:23.000','2006-02-15T22:13:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4195','154','2','6993','4.99','2005-07-27T01:05:24.000','2006-02-15T22:13:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4196','154','1','7055','4.99','2005-07-27T03:45:42.000','2006-02-15T22:13:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4197','154','1','7156','4.99','2005-07-27T07:19:34.000','2006-02-15T22:13:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4198','154','2','7900','1.99','2005-07-28T11:11:33.000','2006-02-15T22:13:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4199','154','2','8334','7.99','2005-07-29T04:18:25.000','2006-02-15T22:13:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4200','154','2','9286','2.99','2005-07-30T15:32:28.000','2006-02-15T22:13:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4201','154','1','10278','6.99','2005-08-01T03:25:27.000','2006-02-15T22:13:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4202','154','1','10851','4.99','2005-08-01T23:58:45.000','2006-02-15T22:13:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4203','154','1','11296','5.99','2005-08-02T15:15:27.000','2006-02-15T22:13:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4204','154','1','12341','0.99','2005-08-18T07:09:27.000','2006-02-15T22:13:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4205','154','2','13861','4.99','2005-08-20T14:56:53.000','2006-02-15T22:13:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4206','154','2','14731','2.99','2005-08-21T22:21:49.000','2006-02-15T22:13:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4207','154','2','14793','7.99','2005-08-22T00:37:57.000','2006-02-15T22:13:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4208','154','1','14918','6.99','2005-08-22T05:06:38.000','2006-02-15T22:13:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4209','154','1','15351','0.99','2005-08-22T21:15:46.000','2006-02-15T22:13:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4210','154','1','15721','2.99','2005-08-23T11:16:16.000','2006-02-15T22:13:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4211','155','1','568','2.99','2005-05-28T09:57:36.000','2006-02-15T22:13:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4212','155','2','1519','1.99','2005-06-15T23:55:27.000','2006-02-15T22:13:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4213','155','1','1554','7.99','2005-06-16T02:16:47.000','2006-02-15T22:13:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4214','155','1','2028','7.99','2005-06-17T13:08:08.000','2006-02-15T22:13:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4215','155','1','2869','4.99','2005-06-20T00:09:25.000','2006-02-15T22:13:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4216','155','2','3405','4.99','2005-06-21T15:58:25.000','2006-02-15T22:13:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4217','155','1','5128','1.99','2005-07-09T07:25:54.000','2006-02-15T22:13:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4218','155','1','6066','5.99','2005-07-11T04:32:42.000','2006-02-15T22:13:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4219','155','1','6085','4.99','2005-07-11T05:24:36.000','2006-02-15T22:13:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4220','155','2','6087','4.99','2005-07-11T05:29:22.000','2006-02-15T22:13:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4221','155','1','6443','2.99','2005-07-12T00:35:51.000','2006-02-15T22:13:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4222','155','1','7077','3.99','2005-07-27T04:13:02.000','2006-02-15T22:13:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4223','155','1','7492','2.99','2005-07-27T19:54:18.000','2006-02-15T22:13:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4224','155','2','7730','5.99','2005-07-28T04:59:48.000','2006-02-15T22:13:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4225','155','2','9781','7.99','2005-07-31T10:13:02.000','2006-02-15T22:13:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4226','155','1','10098','0.99','2005-07-31T20:41:17.000','2006-02-15T22:13:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4227','155','1','11033','4.99','2005-08-02T05:54:17.000','2006-02-15T22:13:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4228','155','2','11951','5.99','2005-08-17T17:14:02.000','2006-02-15T22:13:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4229','155','1','14324','8.99','2005-08-21T08:10:56.000','2006-02-15T22:13:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4230','155','2','14549','2.99','2005-08-21T15:54:21.000','2006-02-15T22:13:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4231','155','1','14753','2.99','2005-08-21T23:11:43.000','2006-02-15T22:13:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4232','155','2','14909','0.99','2005-08-22T04:48:44.000','2006-02-15T22:13:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4233','155','1','15106','0.99','2005-08-22T12:01:48.000','2006-02-15T22:13:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4234','155','2','11496','7.98','2006-02-14T15:16:03.000','2006-02-15T22:13:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4235','155','1','12352','0','2006-02-14T15:16:03.000','2006-02-15T22:13:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4236','156','2','899','6.99','2005-05-30T09:29:30.000','2006-02-15T22:13:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4237','156','1','1052','4.99','2005-05-31T07:07:03.000','2006-02-15T22:13:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4238','156','2','2089','9.99','2005-06-17T17:45:09.000','2006-02-15T22:13:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4239','156','2','2221','0.99','2005-06-18T03:24:56.000','2006-02-15T22:13:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4240','156','1','2658','4.99','2005-06-19T10:43:42.000','2006-02-15T22:13:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4241','156','1','2782','0.99','2005-06-19T18:25:07.000','2006-02-15T22:13:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4242','156','2','4394','2.99','2005-07-07T21:12:45.000','2006-02-15T22:13:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4243','156','2','5534','4.99','2005-07-10T02:26:49.000','2006-02-15T22:13:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4244','156','1','5828','2.99','2005-07-10T16:27:25.000','2006-02-15T22:13:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4245','156','2','5908','0.99','2005-07-10T20:44:14.000','2006-02-15T22:13:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4246','156','2','6540','6.99','2005-07-12T04:51:13.000','2006-02-15T22:13:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4247','156','2','7389','2.99','2005-07-27T15:56:15.000','2006-02-15T22:13:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4248','156','2','7822','4.99','2005-07-28T08:31:45.000','2006-02-15T22:13:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4249','156','1','9409','6.99','2005-07-30T20:33:53.000','2006-02-15T22:13:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4250','156','1','9696','0.99','2005-07-31T07:13:46.000','2006-02-15T22:13:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4251','156','2','10309','6.99','2005-08-01T04:24:18.000','2006-02-15T22:13:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4252','156','2','11490','2.99','2005-08-02T22:36:00.000','2006-02-15T22:13:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4253','156','1','11587','5.99','2005-08-17T02:21:03.000','2006-02-15T22:13:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4254','156','2','13530','0.99','2005-08-20T03:12:43.000','2006-02-15T22:13:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4255','156','2','13531','2.99','2005-08-20T03:26:10.000','2006-02-15T22:13:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4256','156','2','13802','2.99','2005-08-20T12:44:53.000','2006-02-15T22:13:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4257','156','1','14794','1.99','2005-08-22T00:39:31.000','2006-02-15T22:13:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4258','156','2','14831','4.99','2005-08-22T01:40:49.000','2006-02-15T22:13:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4259','156','1','14914','0.99','2005-08-22T04:53:35.000','2006-02-15T22:13:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4260','156','1','15408','6.99','2005-08-22T23:26:32.000','2006-02-15T22:13:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4261','157','2','352','0.99','2005-05-27T05:48:19.000','2006-02-15T22:13:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4262','157','1','642','4.99','2005-05-28T18:49:12.000','2006-02-15T22:13:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4263','157','2','2340','0.99','2005-06-18T11:30:56.000','2006-02-15T22:13:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4264','157','1','3739','0.99','2005-07-06T11:54:18.000','2006-02-15T22:13:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4265','157','1','4253','5.99','2005-07-07T14:13:13.000','2006-02-15T22:13:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4266','157','2','4435','3.99','2005-07-07T22:51:04.000','2006-02-15T22:13:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4267','157','1','4919','0.99','2005-07-08T21:41:54.000','2006-02-15T22:13:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4268','157','1','5862','4.99','2005-07-10T18:20:48.000','2006-02-15T22:13:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4269','157','1','7110','2.99','2005-07-27T05:30:48.000','2006-02-15T22:13:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4270','157','2','7195','2.99','2005-07-27T08:47:01.000','2006-02-15T22:13:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4271','157','2','7499','4.99','2005-07-27T20:10:28.000','2006-02-15T22:13:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4272','157','2','8163','0.99','2005-07-28T21:11:48.000','2006-02-15T22:13:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4273','157','2','8337','0.99','2005-07-29T04:31:55.000','2006-02-15T22:13:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4274','157','2','8347','0.99','2005-07-29T04:49:25.000','2006-02-15T22:13:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4275','157','2','8576','4.99','2005-07-29T11:55:01.000','2006-02-15T22:13:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4276','157','1','8707','0.99','2005-07-29T17:21:58.000','2006-02-15T22:13:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4277','157','1','8827','4.99','2005-07-29T22:31:24.000','2006-02-15T22:13:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4278','157','2','9237','2.99','2005-07-30T13:48:17.000','2006-02-15T22:13:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4279','157','2','9264','4.99','2005-07-30T14:51:36.000','2006-02-15T22:13:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4280','157','1','9958','2.99','2005-07-31T16:03:56.000','2006-02-15T22:13:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4281','157','1','10203','4.99','2005-08-01T00:45:27.000','2006-02-15T22:13:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4282','157','2','11249','4.99','2005-08-02T13:35:40.000','2006-02-15T22:13:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4283','157','2','11335','4.99','2005-08-02T16:57:37.000','2006-02-15T22:13:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4284','157','1','12213','5.99','2005-08-18T02:33:55.000','2006-02-15T22:13:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4285','157','1','12464','6.99','2005-08-18T11:33:34.000','2006-02-15T22:13:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4286','157','1','12916','0.99','2005-08-19T04:27:05.000','2006-02-15T22:13:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4287','157','1','13097','4.99','2005-08-19T10:50:43.000','2006-02-15T22:13:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4288','157','1','13214','4.99','2005-08-19T15:31:06.000','2006-02-15T22:13:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4289','157','1','13481','6.99','2005-08-20T01:11:12.000','2006-02-15T22:13:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4290','157','1','13728','2.99','2005-08-20T10:11:07.000','2006-02-15T22:13:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4291','157','2','14974','4.99','2005-08-22T07:04:25.000','2006-02-15T22:13:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4292','158','2','245','4.99','2005-05-26T13:46:59.000','2006-02-15T22:13:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4293','158','1','293','5.99','2005-05-26T20:27:02.000','2006-02-15T22:13:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4294','158','1','1380','0.99','2005-06-15T15:13:10.000','2006-02-15T22:13:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4295','158','2','1790','4.99','2005-06-16T19:58:40.000','2006-02-15T22:13:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4296','158','2','2035','6.99','2005-06-17T13:45:09.000','2006-02-15T22:13:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4297','158','2','3203','8.99','2005-06-21T00:34:56.000','2006-02-15T22:13:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4298','158','1','4117','8.99','2005-07-07T06:58:14.000','2006-02-15T22:13:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4299','158','1','5672','2.99','2005-07-10T08:19:38.000','2006-02-15T22:13:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4300','158','1','5988','4.99','2005-07-11T00:55:38.000','2006-02-15T22:13:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4301','158','1','6416','2.99','2005-07-11T23:29:14.000','2006-02-15T22:13:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4302','158','2','6901','5.99','2005-07-12T21:46:33.000','2006-02-15T22:13:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4303','158','2','7159','2.99','2005-07-27T07:24:00.000','2006-02-15T22:13:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4304','158','1','7732','0.99','2005-07-28T05:03:32.000','2006-02-15T22:13:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4305','158','2','7952','2.99','2005-07-28T13:23:49.000','2006-02-15T22:13:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4306','158','1','8750','2.99','2005-07-29T19:14:21.000','2006-02-15T22:13:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4307','158','1','8957','1.99','2005-07-30T03:34:10.000','2006-02-15T22:13:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4308','158','1','9393','2.99','2005-07-30T20:04:48.000','2006-02-15T22:13:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4309','158','1','9713','1.99','2005-07-31T08:13:28.000','2006-02-15T22:13:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4310','158','1','9801','2.99','2005-07-31T11:03:13.000','2006-02-15T22:13:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4311','158','2','11077','4.99','2005-08-02T07:26:43.000','2006-02-15T22:13:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4312','158','1','11103','6.99','2005-08-02T08:09:54.000','2006-02-15T22:13:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4313','158','1','11272','0.99','2005-08-02T14:20:27.000','2006-02-15T22:13:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4314','158','1','11420','2.99','2005-08-02T19:47:56.000','2006-02-15T22:13:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4315','158','2','12070','1.99','2005-08-17T21:46:47.000','2006-02-15T22:13:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4316','158','2','12421','5.99','2005-08-18T10:04:06.000','2006-02-15T22:13:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4317','158','2','13212','1.99','2005-08-19T15:24:07.000','2006-02-15T22:13:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4318','158','2','13854','2.99','2005-08-20T14:48:42.000','2006-02-15T22:13:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4319','158','1','13926','2.99','2005-08-20T17:09:27.000','2006-02-15T22:13:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4320','158','2','14028','0.99','2005-08-20T21:23:03.000','2006-02-15T22:13:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4321','158','1','15763','2.99','2005-08-23T13:02:59.000','2006-02-15T22:13:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4322','158','1','15796','5.99','2005-08-23T14:12:22.000','2006-02-15T22:13:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4323','158','1','15802','5.99','2005-08-23T14:26:51.000','2006-02-15T22:13:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4324','159','2','475','2.99','2005-05-27T22:16:26.000','2006-02-15T22:13:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4325','159','2','549','1.99','2005-05-28T07:35:37.000','2006-02-15T22:13:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4326','159','1','598','0.99','2005-05-28T14:04:50.000','2006-02-15T22:13:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4327','159','1','832','3.99','2005-05-29T22:51:20.000','2006-02-15T22:13:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4328','159','1','1695','0.99','2005-06-16T12:40:28.000','2006-02-15T22:13:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4329','159','1','2572','0.99','2005-06-19T04:21:26.000','2006-02-15T22:13:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4330','159','2','3914','5.99','2005-07-06T20:11:10.000','2006-02-15T22:13:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4331','159','2','4273','4.99','2005-07-07T14:40:22.000','2006-02-15T22:13:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4332','159','2','5656','0.99','2005-07-10T07:31:07.000','2006-02-15T22:13:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4333','159','2','6885','4.99','2005-07-12T20:56:04.000','2006-02-15T22:13:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4334','159','2','8212','2.99','2005-07-28T23:37:23.000','2006-02-15T22:13:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4335','159','1','8470','0.99','2005-07-29T08:28:50.000','2006-02-15T22:13:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4336','159','2','9022','3.99','2005-07-30T05:34:45.000','2006-02-15T22:13:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4337','159','2','9132','0.99','2005-07-30T09:56:00.000','2006-02-15T22:13:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4338','159','1','9559','7.99','2005-07-31T02:15:53.000','2006-02-15T22:13:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4339','159','1','9917','4.99','2005-07-31T14:55:11.000','2006-02-15T22:13:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4340','159','2','11225','4.99','2005-08-02T12:43:27.000','2006-02-15T22:13:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4341','159','2','13270','1.99','2005-08-19T17:41:16.000','2006-02-15T22:13:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4342','159','1','13933','0.99','2005-08-20T17:17:07.000','2006-02-15T22:13:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4343','159','2','14575','8.99','2005-08-21T16:51:34.000','2006-02-15T22:13:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4344','159','1','15197','0.99','2005-08-22T16:14:25.000','2006-02-15T22:13:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4345','160','2','2314','4.99','2005-06-18T09:03:19.000','2006-02-15T22:13:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4346','160','1','2465','2.99','2005-06-18T20:07:02.000','2006-02-15T22:13:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4347','160','2','2873','2.99','2005-06-20T00:41:25.000','2006-02-15T22:13:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4348','160','1','4842','0.99','2005-07-08T18:21:30.000','2006-02-15T22:13:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4349','160','1','4908','5.99','2005-07-08T21:05:44.000','2006-02-15T22:13:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4350','160','2','6364','6.99','2005-07-11T21:14:48.000','2006-02-15T22:13:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4351','160','2','6448','1.99','2005-07-12T00:45:59.000','2006-02-15T22:13:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4352','160','2','7500','0.99','2005-07-27T20:16:03.000','2006-02-15T22:13:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4353','160','1','8184','4.99','2005-07-28T22:22:35.000','2006-02-15T22:13:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4354','160','1','9681','0.99','2005-07-31T06:42:09.000','2006-02-15T22:13:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4355','160','2','9758','2.99','2005-07-31T09:25:38.000','2006-02-15T22:13:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4356','160','2','10089','2.99','2005-07-31T20:17:09.000','2006-02-15T22:13:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4357','160','1','10305','2.99','2005-08-01T04:16:16.000','2006-02-15T22:13:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4358','160','2','10788','0.99','2005-08-01T21:37:10.000','2006-02-15T22:13:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4359','160','2','10958','4.99','2005-08-02T03:37:13.000','2006-02-15T22:13:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4360','160','2','10979','5.99','2005-08-02T04:16:37.000','2006-02-15T22:13:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4361','160','2','11154','2.99','2005-08-02T09:54:50.000','2006-02-15T22:13:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4362','160','1','11803','2.99','2005-08-17T11:42:08.000','2006-02-15T22:13:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4363','160','1','11888','7.99','2005-08-17T15:04:05.000','2006-02-15T22:13:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4364','160','2','12334','2.99','2005-08-18T06:52:36.000','2006-02-15T22:13:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4365','160','1','12435','7.99','2005-08-18T10:38:31.000','2006-02-15T22:13:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4366','160','2','13093','6.99','2005-08-19T10:46:16.000','2006-02-15T22:13:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4367','160','1','14868','4.99','2005-08-22T03:15:01.000','2006-02-15T22:13:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4368','160','1','15112','2.99','2005-08-22T12:21:49.000','2006-02-15T22:13:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4369','160','2','15642','2.99','2005-08-23T08:09:11.000','2006-02-15T22:13:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4370','160','1','15962','4.99','2005-08-23T19:42:04.000','2006-02-15T22:13:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4371','160','1','16027','3.99','2005-08-23T21:49:33.000','2006-02-15T22:13:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4372','161','2','428','2.99','2005-05-27T16:10:58.000','2006-02-15T22:13:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4373','161','2','477','3.99','2005-05-27T22:33:33.000','2006-02-15T22:13:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4374','161','1','520','5.99','2005-05-28T03:27:37.000','2006-02-15T22:13:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4375','161','2','539','0.99','2005-05-28T06:26:16.000','2006-02-15T22:13:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4376','161','1','612','2.99','2005-05-28T15:24:54.000','2006-02-15T22:13:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4377','161','1','1003','0.99','2005-05-31T00:48:20.000','2006-02-15T22:13:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4378','161','1','1856','2.99','2005-06-17T01:02:00.000','2006-02-15T22:13:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4379','161','1','3075','3.99','2005-06-20T14:52:19.000','2006-02-15T22:13:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4380','161','1','3948','4.99','2005-07-06T21:45:53.000','2006-02-15T22:13:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4381','161','2','4187','0.99','2005-07-07T10:41:31.000','2006-02-15T22:13:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4382','161','2','4248','6.99','2005-07-07T13:59:20.000','2006-02-15T22:13:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4383','161','1','4490','2.99','2005-07-08T01:26:32.000','2006-02-15T22:13:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4384','161','2','5349','6.99','2005-07-09T17:35:35.000','2006-02-15T22:13:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4385','161','2','6873','4.99','2005-07-12T20:20:50.000','2006-02-15T22:13:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4386','161','1','7003','2.99','2005-07-27T01:32:06.000','2006-02-15T22:13:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4387','161','2','8774','4.99','2005-07-29T20:05:04.000','2006-02-15T22:13:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4388','161','1','9135','4.99','2005-07-30T10:06:53.000','2006-02-15T22:13:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4389','161','2','9421','0.99','2005-07-30T21:08:32.000','2006-02-15T22:13:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4390','161','1','10241','5.99','2005-08-01T02:12:25.000','2006-02-15T22:13:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4391','161','1','10355','0.99','2005-08-01T05:47:37.000','2006-02-15T22:13:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4392','161','1','10637','2.99','2005-08-01T15:44:09.000','2006-02-15T22:13:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4393','161','1','10863','6.99','2005-08-02T00:18:07.000','2006-02-15T22:13:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4394','161','2','10939','0.99','2005-08-02T03:06:20.000','2006-02-15T22:13:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4395','161','1','11838','2.99','2005-08-17T13:06:00.000','2006-02-15T22:13:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4396','161','2','14150','0.99','2005-08-21T02:23:03.000','2006-02-15T22:13:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4397','161','1','14370','7.99','2005-08-21T09:35:14.000','2006-02-15T22:13:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4398','161','1','15000','0.99','2005-08-22T07:54:58.000','2006-02-15T22:13:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4399','161','2','15045','5.99','2005-08-22T09:53:23.000','2006-02-15T22:13:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4400','161','2','15150','2.99','2005-08-22T14:12:05.000','2006-02-15T22:13:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4401','161','1','15420','5.99','2005-08-22T23:55:51.000','2006-02-15T22:13:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4402','162','1','285','1.99','2005-05-26T19:41:40.000','2006-02-15T22:13:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4403','162','1','501','4.99','2005-05-28T01:09:36.000','2006-02-15T22:13:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4404','162','1','688','4.99','2005-05-29T00:45:24.000','2006-02-15T22:13:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4405','162','2','1339','4.99','2005-06-15T12:21:56.000','2006-02-15T22:13:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4406','162','1','2366','0.99','2005-06-18T13:46:39.000','2006-02-15T22:13:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4407','162','1','2547','4.99','2005-06-19T02:44:17.000','2006-02-15T22:13:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4408','162','1','3040','0.99','2005-06-20T12:34:13.000','2006-02-15T22:13:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4409','162','2','3180','0.99','2005-06-20T22:48:44.000','2006-02-15T22:13:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4410','162','2','4982','2.99','2005-07-09T00:30:52.000','2006-02-15T22:13:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4411','162','2','8478','4.99','2005-07-29T08:40:36.000','2006-02-15T22:13:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4412','162','1','8582','4.99','2005-07-29T12:03:27.000','2006-02-15T22:13:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4413','162','2','9167','4.99','2005-07-30T11:30:37.000','2006-02-15T22:13:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4414','162','1','9726','7.99','2005-07-31T08:37:07.000','2006-02-15T22:13:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4415','162','1','9775','0.99','2005-07-31T10:00:00.000','2006-02-15T22:13:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4416','162','2','10093','5.99','2005-07-31T20:30:32.000','2006-02-15T22:13:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4417','162','2','11012','0.99','2005-08-02T05:09:42.000','2006-02-15T22:13:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4418','162','1','13288','4.99','2005-08-19T18:30:10.000','2006-02-15T22:13:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4419','162','2','14301','1.99','2005-08-21T07:19:48.000','2006-02-15T22:13:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4420','162','1','15332','4.99','2005-08-22T20:41:53.000','2006-02-15T22:13:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4421','162','1','14220','0.99','2006-02-14T15:16:03.000','2006-02-15T22:13:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4422','163','2','1265','4.99','2005-06-15T07:00:50.000','2006-02-15T22:13:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4423','163','2','2000','2.99','2005-06-17T11:32:30.000','2006-02-15T22:13:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4424','163','2','2110','7.99','2005-06-17T19:45:49.000','2006-02-15T22:13:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4425','163','2','2536','5.99','2005-06-19T01:41:34.000','2006-02-15T22:13:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4426','163','1','2994','6.99','2005-06-20T09:17:05.000','2006-02-15T22:13:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4427','163','1','3179','0.99','2005-06-20T22:37:59.000','2006-02-15T22:13:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4428','163','2','3915','3.99','2005-07-06T20:16:46.000','2006-02-15T22:13:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4429','163','1','4126','1.99','2005-07-07T07:24:11.000','2006-02-15T22:13:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4430','163','2','5549','4.99','2005-07-10T02:58:29.000','2006-02-15T22:13:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4431','163','1','5574','10.99','2005-07-10T03:54:38.000','2006-02-15T22:13:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4432','163','1','6109','0.99','2005-07-11T07:20:57.000','2006-02-15T22:13:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4433','163','1','6831','1.99','2005-07-12T18:44:04.000','2006-02-15T22:13:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4434','163','1','7303','1.99','2005-07-27T12:54:39.000','2006-02-15T22:13:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4435','163','1','7403','2.99','2005-07-27T16:22:09.000','2006-02-15T22:13:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4436','163','2','8040','0.99','2005-07-28T16:39:43.000','2006-02-15T22:13:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4437','163','2','8063','4.99','2005-07-28T17:15:11.000','2006-02-15T22:13:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4438','163','2','8403','4.99','2005-07-29T06:26:39.000','2006-02-15T22:13:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4439','163','2','10245','0.99','2005-08-01T02:24:09.000','2006-02-15T22:13:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4440','163','2','11623','2.99','2005-08-17T04:15:47.000','2006-02-15T22:13:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4441','163','2','11940','4.99','2005-08-17T16:56:28.000','2006-02-15T22:13:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4442','163','1','12154','2.99','2005-08-18T00:23:56.000','2006-02-15T22:13:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4443','163','2','12973','2.99','2005-08-19T06:48:11.000','2006-02-15T22:13:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4444','163','2','13543','7.99','2005-08-20T03:43:13.000','2006-02-15T22:13:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4445','163','2','14275','4.99','2005-08-21T06:30:30.000','2006-02-15T22:13:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4446','163','2','14427','5.99','2005-08-21T11:26:06.000','2006-02-15T22:13:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4447','163','1','15520','8.99','2005-08-23T03:30:45.000','2006-02-15T22:13:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4448','163','1','15847','0.99','2005-08-23T15:39:38.000','2006-02-15T22:13:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4449','163','2','11754','7.98','2006-02-14T15:16:03.000','2006-02-15T22:13:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4450','163','1','15282','0','2006-02-14T15:16:03.000','2006-02-15T22:13:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4451','164','2','1011','1.99','2005-05-31T02:05:39.000','2006-02-15T22:13:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4452','164','2','1713','4.99','2005-06-16T14:28:33.000','2006-02-15T22:13:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4453','164','2','2589','2.99','2005-06-19T05:21:27.000','2006-02-15T22:13:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4454','164','1','3082','8.99','2005-06-20T15:32:11.000','2006-02-15T22:13:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4455','164','2','4548','4.99','2005-07-08T04:21:54.000','2006-02-15T22:13:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4456','164','1','5895','3.99','2005-07-10T20:13:19.000','2006-02-15T22:13:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4457','164','1','6393','0.99','2005-07-11T22:28:12.000','2006-02-15T22:13:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4458','164','2','6558','2.99','2005-07-12T05:16:07.000','2006-02-15T22:13:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4459','164','1','6637','4.99','2005-07-12T09:57:39.000','2006-02-15T22:13:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4460','164','2','6702','0.99','2005-07-12T12:48:03.000','2006-02-15T22:13:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4461','164','1','6980','3.99','2005-07-27T00:50:30.000','2006-02-15T22:13:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4462','164','1','7227','6.99','2005-07-27T09:53:43.000','2006-02-15T22:13:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4463','164','2','8135','3.99','2005-07-28T20:03:25.000','2006-02-15T22:13:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4464','164','2','8824','4.99','2005-07-29T22:22:58.000','2006-02-15T22:13:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4465','164','2','11175','2.99','2005-08-02T10:38:47.000','2006-02-15T22:13:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4466','164','2','13453','5.99','2005-08-20T00:30:51.000','2006-02-15T22:13:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4467','165','2','338','4.99','2005-05-27T03:42:52.000','2006-02-15T22:13:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4468','165','1','2013','3.99','2005-06-17T12:03:01.000','2006-02-15T22:13:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4469','165','2','3195','2.99','2005-06-21T00:02:10.000','2006-02-15T22:13:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4470','165','2','3531','4.99','2005-07-06T01:24:08.000','2006-02-15T22:13:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4471','165','1','3784','5.99','2005-07-06T13:57:56.000','2006-02-15T22:13:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4472','165','2','4304','0.99','2005-07-07T17:01:19.000','2006-02-15T22:13:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4473','165','2','4945','2.99','2005-07-08T22:45:02.000','2006-02-15T22:13:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4474','165','1','5472','4.99','2005-07-09T23:16:40.000','2006-02-15T22:13:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4475','165','2','5658','4.99','2005-07-10T07:34:08.000','2006-02-15T22:13:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4476','165','2','5901','6.99','2005-07-10T20:22:12.000','2006-02-15T22:13:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4477','165','1','5973','0.99','2005-07-11T00:09:17.000','2006-02-15T22:13:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4478','165','1','7074','2.99','2005-07-27T04:06:24.000','2006-02-15T22:13:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4479','165','1','8608','0.99','2005-07-29T13:18:52.000','2006-02-15T22:13:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4480','165','2','9182','7.99','2005-07-30T12:06:58.000','2006-02-15T22:13:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4481','165','2','9685','4.99','2005-07-31T06:49:18.000','2006-02-15T22:13:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4482','165','1','10565','4.99','2005-08-01T13:08:27.000','2006-02-15T22:13:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4483','165','1','11484','2.99','2005-08-02T22:28:23.000','2006-02-15T22:13:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4484','165','2','12643','4.99','2005-08-18T18:21:06.000','2006-02-15T22:13:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4485','165','2','15007','1.99','2005-08-22T08:21:21.000','2006-02-15T22:13:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4486','165','1','15801','3.99','2005-08-23T14:26:04.000','2006-02-15T22:13:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4487','165','2','15834','5.99','2005-08-23T15:23:50.000','2006-02-15T22:13:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4488','166','1','662','1.99','2005-05-28T21:09:31.000','2006-02-15T22:13:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4489','166','2','1412','2.99','2005-06-15T17:09:48.000','2006-02-15T22:13:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4490','166','1','2211','3.99','2005-06-18T02:29:10.000','2006-02-15T22:13:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4491','166','1','2874','5.99','2005-06-20T00:42:26.000','2006-02-15T22:13:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4492','166','1','3085','0.99','2005-06-20T15:42:33.000','2006-02-15T22:13:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4493','166','2','3606','2.99','2005-07-06T05:28:02.000','2006-02-15T22:13:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4494','166','1','3642','2.99','2005-07-06T07:18:20.000','2006-02-15T22:13:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4495','166','2','4389','6.99','2005-07-07T20:58:58.000','2006-02-15T22:13:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4496','166','1','4658','0.99','2005-07-08T09:51:11.000','2006-02-15T22:13:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4497','166','1','5184','4.99','2005-07-09T10:14:34.000','2006-02-15T22:13:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4498','166','2','5380','4.99','2005-07-09T19:08:44.000','2006-02-15T22:13:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4499','166','1','5646','2.99','2005-07-10T07:08:09.000','2006-02-15T22:13:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4500','166','1','5855','7.99','2005-07-10T17:54:06.000','2006-02-15T22:13:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4501','166','2','6237','0.99','2005-07-11T14:19:12.000','2006-02-15T22:13:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4502','166','2','6882','2.99','2005-07-12T20:50:39.000','2006-02-15T22:13:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4503','166','1','7581','2.99','2005-07-27T23:14:35.000','2006-02-15T22:13:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4504','166','1','8052','5.99','2005-07-28T16:57:31.000','2006-02-15T22:13:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4505','166','1','9009','8.99','2005-07-30T05:12:01.000','2006-02-15T22:13:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4506','166','2','10422','7.99','2005-08-01T08:17:11.000','2006-02-15T22:13:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4507','166','2','12683','4.99','2005-08-18T19:50:43.000','2006-02-15T22:13:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4508','166','1','12968','4.99','2005-08-19T06:38:18.000','2006-02-15T22:13:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4509','166','2','13582','4.99','2005-08-20T05:28:11.000','2006-02-15T22:13:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4510','166','2','13901','7.99','2005-08-20T16:06:53.000','2006-02-15T22:13:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4511','166','2','14261','5.99','2005-08-21T06:07:24.000','2006-02-15T22:13:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4512','166','2','14281','2.99','2005-08-21T06:40:48.000','2006-02-15T22:13:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4513','166','1','15213','5.99','2005-08-22T16:49:02.000','2006-02-15T22:13:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4514','166','2','15216','2.99','2005-08-22T16:57:02.000','2006-02-15T22:13:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4515','166','2','15806','1.99','2005-08-23T14:31:50.000','2006-02-15T22:13:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4516','167','1','280','2.99','2005-05-26T18:36:58.000','2006-02-15T22:13:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4517','167','1','365','2.99','2005-05-27T07:31:20.000','2006-02-15T22:13:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4518','167','1','927','4.99','2005-05-30T12:16:40.000','2006-02-15T22:13:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4519','167','1','1416','3.99','2005-06-15T17:44:57.000','2006-02-15T22:13:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4520','167','1','1509','5.99','2005-06-15T22:35:53.000','2006-02-15T22:13:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4521','167','2','2381','5.99','2005-06-18T15:00:30.000','2006-02-15T22:13:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4522','167','2','3518','4.99','2005-07-06T00:56:03.000','2006-02-15T22:13:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4523','167','2','4493','0.99','2005-07-08T01:40:24.000','2006-02-15T22:13:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4524','167','2','5131','0.99','2005-07-09T07:35:03.000','2006-02-15T22:13:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4525','167','1','5178','4.99','2005-07-09T09:59:52.000','2006-02-15T22:13:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4526','167','1','5191','0.99','2005-07-09T10:26:48.000','2006-02-15T22:13:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4527','167','1','5413','4.99','2005-07-09T20:28:42.000','2006-02-15T22:13:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4528','167','1','5781','2.99','2005-07-10T13:49:30.000','2006-02-15T22:13:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4529','167','2','6269','4.99','2005-07-11T15:58:43.000','2006-02-15T22:13:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4530','167','1','7608','4.99','2005-07-28T00:08:36.000','2006-02-15T22:13:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4531','167','1','8092','2.99','2005-07-28T18:28:07.000','2006-02-15T22:13:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4532','167','2','8227','4.99','2005-07-29T00:02:22.000','2006-02-15T22:13:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4533','167','1','8318','2.99','2005-07-29T03:44:30.000','2006-02-15T22:13:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4534','167','1','8793','0.99','2005-07-29T20:57:22.000','2006-02-15T22:13:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4535','167','2','8864','0.99','2005-07-29T23:52:12.000','2006-02-15T22:13:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4536','167','2','9563','4.99','2005-07-31T02:28:39.000','2006-02-15T22:13:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4537','167','2','10285','3.99','2005-08-01T03:35:11.000','2006-02-15T22:13:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4538','167','1','12642','4.99','2005-08-18T18:19:16.000','2006-02-15T22:13:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4539','167','2','12717','4.99','2005-08-18T21:15:40.000','2006-02-15T22:13:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4540','167','1','12978','4.99','2005-08-19T06:57:27.000','2006-02-15T22:13:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4541','167','1','13825','6.99','2005-08-20T13:43:22.000','2006-02-15T22:13:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4542','167','1','13870','1.99','2005-08-20T15:09:16.000','2006-02-15T22:13:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4543','167','1','15003','3.99','2005-08-22T08:11:24.000','2006-02-15T22:13:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4544','167','1','15050','0.99','2005-08-22T10:07:52.000','2006-02-15T22:13:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4545','167','2','15478','0.99','2005-08-23T01:50:31.000','2006-02-15T22:13:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4546','167','2','15530','4.99','2005-08-23T03:50:48.000','2006-02-15T22:13:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4547','167','2','15915','4.99','2005-08-23T17:52:01.000','2006-02-15T22:13:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4548','168','2','404','0.99','2005-05-27T13:31:51.000','2006-02-15T22:13:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4549','168','1','488','4.99','2005-05-28T00:07:50.000','2006-02-15T22:13:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4550','168','2','1222','4.99','2005-06-15T03:38:49.000','2006-02-15T22:13:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4551','168','1','3530','2.99','2005-07-06T01:22:45.000','2006-02-15T22:13:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4552','168','1','4308','5.99','2005-07-07T17:29:16.000','2006-02-15T22:13:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4553','168','2','4363','5.99','2005-07-07T19:43:28.000','2006-02-15T22:13:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4554','168','2','4953','2.99','2005-07-08T23:09:48.000','2006-02-15T22:13:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4555','168','1','5459','0.99','2005-07-09T22:43:56.000','2006-02-15T22:13:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4556','168','1','5907','5.99','2005-07-10T20:41:41.000','2006-02-15T22:13:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4557','168','1','6334','5.99','2005-07-11T19:20:44.000','2006-02-15T22:13:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4558','168','2','6444','0.99','2005-07-12T00:36:02.000','2006-02-15T22:13:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4559','168','2','6809','3.99','2005-07-12T17:51:54.000','2006-02-15T22:13:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4560','168','2','8352','1.99','2005-07-29T04:52:01.000','2006-02-15T22:13:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4561','168','1','8527','1.99','2005-07-29T10:21:00.000','2006-02-15T22:13:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4562','168','2','8659','6.99','2005-07-29T15:26:31.000','2006-02-15T22:13:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4563','168','2','8883','1.99','2005-07-30T00:24:48.000','2006-02-15T22:13:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4564','168','2','9197','4.99','2005-07-30T12:31:36.000','2006-02-15T22:13:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4565','168','1','9418','4.99','2005-07-30T21:00:52.000','2006-02-15T22:13:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4566','168','2','9857','6.99','2005-07-31T13:00:53.000','2006-02-15T22:13:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4567','168','2','9899','4.99','2005-07-31T14:12:36.000','2006-02-15T22:13:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4568','168','2','10270','0.99','2005-08-01T03:10:24.000','2006-02-15T22:13:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4569','168','1','11551','0.99','2005-08-17T01:03:49.000','2006-02-15T22:13:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4570','168','1','11627','10.99','2005-08-17T04:25:47.000','2006-02-15T22:13:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4571','168','1','11631','1.99','2005-08-17T04:28:56.000','2006-02-15T22:13:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4572','168','1','12545','6.99','2005-08-18T14:28:00.000','2006-02-15T22:13:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4573','168','1','12781','2.99','2005-08-18T23:50:24.000','2006-02-15T22:13:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4574','168','1','13018','8.99','2005-08-19T08:04:50.000','2006-02-15T22:13:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4575','168','2','13532','4.99','2005-08-20T03:29:28.000','2006-02-15T22:13:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4576','168','2','13811','0.99','2005-08-20T13:00:30.000','2006-02-15T22:13:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4577','168','1','14090','2.99','2005-08-21T00:11:16.000','2006-02-15T22:13:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4578','168','1','15033','3.99','2005-08-22T09:25:24.000','2006-02-15T22:13:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4579','168','1','15165','2.99','2005-08-22T14:59:30.000','2006-02-15T22:13:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4580','168','2','15683','2.99','2005-08-23T09:38:17.000','2006-02-15T22:13:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4581','168','1','15894','0.99','2006-02-14T15:16:03.000','2006-02-15T22:13:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4582','169','2','527','3.99','2005-05-28T04:28:38.000','2006-02-15T22:13:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4583','169','1','1087','4.99','2005-05-31T11:18:08.000','2006-02-15T22:13:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4584','169','1','2023','4.99','2005-06-17T12:52:58.000','2006-02-15T22:13:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4585','169','1','3261','2.99','2005-06-21T04:07:41.000','2006-02-15T22:13:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4586','169','1','3493','8.99','2005-07-05T23:46:19.000','2006-02-15T22:13:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4587','169','1','4687','4.99','2005-07-08T10:54:19.000','2006-02-15T22:13:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4588','169','1','5066','2.99','2005-07-09T04:48:50.000','2006-02-15T22:13:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4589','169','1','6143','3.99','2005-07-11T09:02:37.000','2006-02-15T22:13:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4590','169','2','6453','4.99','2005-07-12T00:59:53.000','2006-02-15T22:13:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4591','169','2','6488','9.99','2005-07-12T02:20:09.000','2006-02-15T22:13:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4592','169','2','7187','6.99','2005-07-27T08:27:58.000','2006-02-15T22:13:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4593','169','1','7597','0.99','2005-07-27T23:35:49.000','2006-02-15T22:13:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4594','169','2','8558','4.99','2005-07-29T11:24:49.000','2006-02-15T22:13:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4595','169','2','9203','0.99','2005-07-30T12:43:40.000','2006-02-15T22:13:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4596','169','2','11687','5.99','2005-08-17T06:39:59.000','2006-02-15T22:13:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4597','169','1','11898','5.99','2005-08-17T15:24:12.000','2006-02-15T22:13:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4598','169','2','13198','2.99','2005-08-19T14:47:18.000','2006-02-15T22:13:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4599','169','2','13237','1.99','2005-08-19T16:18:36.000','2006-02-15T22:13:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4600','169','2','14435','0.99','2005-08-21T11:44:37.000','2006-02-15T22:13:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4601','169','2','14805','4.99','2005-08-22T00:52:01.000','2006-02-15T22:13:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4602','169','2','15534','0.99','2005-08-23T03:55:54.000','2006-02-15T22:13:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4603','169','2','15680','4.99','2005-08-23T09:33:22.000','2006-02-15T22:13:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4604','170','1','211','2.99','2005-05-26T08:33:10.000','2006-02-15T22:13:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4605','170','1','377','5.99','2005-05-27T09:04:05.000','2006-02-15T22:13:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4606','170','2','504','0.99','2005-05-28T02:05:34.000','2006-02-15T22:13:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4607','170','2','2117','0.99','2005-06-17T20:24:00.000','2006-02-15T22:13:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4608','170','2','2413','8.99','2005-06-18T16:59:34.000','2006-02-15T22:13:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4609','170','2','3651','4.99','2005-07-06T07:40:31.000','2006-02-15T22:13:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4610','170','1','3749','4.99','2005-07-06T12:18:03.000','2006-02-15T22:13:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4611','170','2','4113','4.99','2005-07-07T06:49:52.000','2006-02-15T22:13:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4612','170','2','4468','0.99','2005-07-08T00:17:59.000','2006-02-15T22:13:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4613','170','2','5075','0.99','2005-07-09T05:12:07.000','2006-02-15T22:13:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4614','170','1','5573','4.99','2005-07-10T03:50:47.000','2006-02-15T22:13:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4615','170','2','5685','7.99','2005-07-10T09:01:38.000','2006-02-15T22:13:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4616','170','2','5808','2.99','2005-07-10T15:17:33.000','2006-02-15T22:13:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4617','170','1','7999','7.99','2005-07-28T15:10:14.000','2006-02-15T22:13:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4618','170','2','9517','2.99','2005-07-31T00:41:23.000','2006-02-15T22:13:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4619','170','1','9817','2.99','2005-07-31T11:33:31.000','2006-02-15T22:13:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4620','170','1','10102','9.99','2005-07-31T20:49:10.000','2006-02-15T22:13:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4621','170','2','10481','5.99','2005-08-01T10:17:26.000','2006-02-15T22:13:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4622','170','1','11039','0.99','2005-08-02T06:00:53.000','2006-02-15T22:13:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4623','170','2','12706','3.99','2005-08-18T20:44:34.000','2006-02-15T22:13:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4624','170','1','12967','3.99','2005-08-19T06:37:51.000','2006-02-15T22:13:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4625','170','1','13081','0.99','2005-08-19T10:19:06.000','2006-02-15T22:13:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4626','170','2','13862','6.99','2005-08-20T14:57:01.000','2006-02-15T22:13:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4627','170','2','14022','8.99','2005-08-20T21:08:49.000','2006-02-15T22:13:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4628','170','2','14675','2.99','2005-08-21T20:01:51.000','2006-02-15T22:13:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4629','170','1','15549','7.99','2005-08-23T04:27:06.000','2006-02-15T22:13:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4630','171','2','804','9.99','2005-05-29T18:10:24.000','2006-02-15T22:13:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4631','171','2','1676','0.99','2005-06-16T11:06:09.000','2006-02-15T22:13:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4632','171','2','2004','4.99','2005-06-17T11:43:38.000','2006-02-15T22:13:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4633','171','2','2199','5.99','2005-06-18T01:57:56.000','2006-02-15T22:13:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4634','171','1','2497','4.99','2005-06-18T22:50:40.000','2006-02-15T22:13:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4635','171','2','2599','5.99','2005-06-19T06:06:07.000','2006-02-15T22:13:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4636','171','2','2788','2.99','2005-06-19T18:48:11.000','2006-02-15T22:13:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4637','171','2','3338','6.99','2005-06-21T10:27:31.000','2006-02-15T22:13:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4638','171','1','3621','0.99','2005-07-06T06:03:55.000','2006-02-15T22:13:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4639','171','2','3745','2.99','2005-07-06T12:10:32.000','2006-02-15T22:13:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4640','171','1','5660','5.99','2005-07-10T07:46:12.000','2006-02-15T22:13:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4641','171','1','5986','4.99','2005-07-11T00:54:56.000','2006-02-15T22:13:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4642','171','1','6766','2.99','2005-07-12T15:32:01.000','2006-02-15T22:13:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4643','171','2','6774','0.99','2005-07-12T15:56:08.000','2006-02-15T22:13:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4644','171','1','7037','3.99','2005-07-27T03:06:44.000','2006-02-15T22:13:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4645','171','2','9066','4.99','2005-07-30T07:28:54.000','2006-02-15T22:13:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4646','171','2','9084','5.99','2005-07-30T08:14:29.000','2006-02-15T22:13:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4647','171','2','10622','4.99','2005-08-01T15:12:00.000','2006-02-15T22:13:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4648','171','1','12600','4.99','2005-08-18T16:44:24.000','2006-02-15T22:13:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4649','171','1','12962','5.99','2005-08-19T06:22:48.000','2006-02-15T22:13:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4650','171','2','13087','6.99','2005-08-19T10:33:52.000','2006-02-15T22:13:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4651','171','2','13292','0.99','2005-08-19T18:35:32.000','2006-02-15T22:13:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4652','171','2','13433','0.99','2005-08-19T23:30:53.000','2006-02-15T22:13:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4653','171','1','14270','1.99','2005-08-21T06:22:18.000','2006-02-15T22:13:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4654','171','2','14615','9.99','2005-08-21T18:06:32.000','2006-02-15T22:13:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4655','171','2','15810','0.99','2005-08-23T14:43:15.000','2006-02-15T22:13:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4656','172','2','449','3.99','2005-05-27T19:13:15.000','2006-02-15T22:13:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4657','172','1','685','6.99','2005-05-29T00:17:51.000','2006-02-15T22:13:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4658','172','1','837','0.99','2005-05-30T00:02:08.000','2006-02-15T22:13:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4659','172','2','1507','0.99','2005-06-15T22:25:26.000','2006-02-15T22:13:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4660','172','1','2052','0.99','2005-06-17T15:14:43.000','2006-02-15T22:13:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4661','172','2','3032','1.99','2005-06-20T11:58:30.000','2006-02-15T22:13:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4662','172','1','4820','5.99','2005-07-08T17:25:23.000','2006-02-15T22:13:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4663','172','1','4821','4.99','2005-07-08T17:28:08.000','2006-02-15T22:13:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4664','172','2','4878','6.99','2005-07-08T19:33:49.000','2006-02-15T22:13:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4665','172','2','6246','7.99','2005-07-11T14:57:51.000','2006-02-15T22:13:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4666','172','1','6380','0.99','2005-07-11T21:55:40.000','2006-02-15T22:13:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4667','172','1','6875','5.99','2005-07-12T20:23:05.000','2006-02-15T22:13:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4668','172','1','7122','6.99','2005-07-27T06:03:18.000','2006-02-15T22:13:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4669','172','1','7135','2.99','2005-07-27T06:34:32.000','2006-02-15T22:13:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4670','172','1','7194','3.99','2005-07-27T08:39:58.000','2006-02-15T22:13:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4671','172','2','7261','2.99','2005-07-27T11:15:01.000','2006-02-15T22:13:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4672','172','1','7638','4.99','2005-07-28T01:13:26.000','2006-02-15T22:13:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4673','172','2','8944','6.99','2005-07-30T03:11:44.000','2006-02-15T22:13:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4674','172','1','9118','2.99','2005-07-30T09:24:18.000','2006-02-15T22:13:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4675','172','2','9218','5.99','2005-07-30T13:14:35.000','2006-02-15T22:13:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4676','172','1','10312','3.99','2005-08-01T04:29:06.000','2006-02-15T22:13:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4677','172','2','10621','0.99','2005-08-01T15:10:26.000','2006-02-15T22:13:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4678','172','2','11499','6.99','2005-08-16T22:54:12.000','2006-02-15T22:13:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4679','172','2','12350','4.99','2005-08-18T07:29:46.000','2006-02-15T22:13:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4680','172','2','12638','8.99','2005-08-18T18:11:39.000','2006-02-15T22:13:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4681','172','2','13067','5.99','2005-08-19T09:51:17.000','2006-02-15T22:13:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4682','172','2','13320','4.99','2005-08-19T19:35:33.000','2006-02-15T22:13:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4683','172','1','13342','0.99','2005-08-19T20:21:36.000','2006-02-15T22:13:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4684','172','2','13937','4.99','2005-08-20T17:22:51.000','2006-02-15T22:13:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4685','172','1','14991','4.99','2005-08-22T07:50:44.000','2006-02-15T22:13:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4686','172','2','15637','2.99','2005-08-23T07:53:38.000','2006-02-15T22:13:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4687','172','1','15902','3.99','2005-08-23T17:28:03.000','2006-02-15T22:13:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4688','172','2','16038','3.99','2005-08-23T22:14:31.000','2006-02-15T22:13:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4689','173','2','578','2.99','2005-05-28T11:15:48.000','2006-02-15T22:13:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4690','173','1','628','4.99','2005-05-28T17:05:46.000','2006-02-15T22:13:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4691','173','2','1188','2.99','2005-06-15T01:04:07.000','2006-02-15T22:13:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4692','173','2','2435','4.99','2005-06-18T18:12:26.000','2006-02-15T22:13:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4693','173','1','2602','2.99','2005-06-19T06:10:08.000','2006-02-15T22:13:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4694','173','2','3224','0.99','2005-06-21T02:11:36.000','2006-02-15T22:13:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4695','173','1','3336','4.99','2005-06-21T10:14:27.000','2006-02-15T22:13:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4696','173','2','3717','0.99','2005-07-06T10:53:34.000','2006-02-15T22:13:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4697','173','1','4904','7.99','2005-07-08T20:53:27.000','2006-02-15T22:13:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4698','173','2','5430','2.99','2005-07-09T21:19:54.000','2006-02-15T22:13:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4699','173','2','5485','4.99','2005-07-09T23:55:25.000','2006-02-15T22:13:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4700','173','1','5488','2.99','2005-07-10T00:02:06.000','2006-02-15T22:13:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4701','173','2','5531','2.99','2005-07-10T02:13:59.000','2006-02-15T22:13:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4702','173','1','5615','3.99','2005-07-10T05:18:51.000','2006-02-15T22:13:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4703','173','2','6021','4.99','2005-07-11T02:10:18.000','2006-02-15T22:13:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4704','173','1','7644','0.99','2005-07-28T01:27:33.000','2006-02-15T22:13:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4705','173','2','8299','2.99','2005-07-29T02:56:00.000','2006-02-15T22:13:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4706','173','2','8808','4.99','2005-07-29T21:39:07.000','2006-02-15T22:13:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4707','173','2','8829','8.99','2005-07-29T22:33:34.000','2006-02-15T22:13:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4708','173','1','9097','4.99','2005-07-30T08:40:35.000','2006-02-15T22:13:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4709','173','2','9512','2.99','2005-07-31T00:26:30.000','2006-02-15T22:13:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4710','173','1','10351','5.99','2005-08-01T05:32:13.000','2006-02-15T22:13:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4711','173','2','12073','2.99','2005-08-17T21:50:39.000','2006-02-15T22:13:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4712','173','1','12282','6.99','2005-08-18T04:54:20.000','2006-02-15T22:13:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4713','173','2','12501','4.99','2005-08-18T13:13:13.000','2006-02-15T22:13:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4714','173','1','14654','2.99','2005-08-21T19:36:59.000','2006-02-15T22:13:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4715','173','2','15483','0.99','2005-08-23T02:02:53.000','2006-02-15T22:13:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4716','173','1','15775','8.99','2005-08-23T13:25:44.000','2006-02-15T22:13:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4717','173','1','16010','2.99','2005-08-23T21:10:24.000','2006-02-15T22:13:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4718','174','1','41','5.99','2005-05-25T05:12:29.000','2006-02-15T22:13:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4719','174','2','1071','4.99','2005-05-31T09:48:56.000','2006-02-15T22:13:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4720','174','2','1566','7.99','2005-06-16T03:13:20.000','2006-02-15T22:13:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4721','174','1','1609','0.99','2005-06-16T06:34:59.000','2006-02-15T22:13:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4722','174','1','2326','5.99','2005-06-18T10:14:22.000','2006-02-15T22:13:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4723','174','2','3446','1.99','2005-06-21T20:45:51.000','2006-02-15T22:13:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4724','174','2','4803','1.99','2005-07-08T16:56:34.000','2006-02-15T22:13:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4725','174','2','5414','4.99','2005-07-09T20:29:36.000','2006-02-15T22:13:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4726','174','1','6909','4.99','2005-07-12T22:09:30.000','2006-02-15T22:13:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4727','174','2','8348','7.99','2005-07-29T04:49:26.000','2006-02-15T22:13:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4728','174','1','8754','4.99','2005-07-29T19:18:30.000','2006-02-15T22:13:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4729','174','1','9301','4.99','2005-07-30T16:34:29.000','2006-02-15T22:13:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4730','174','1','9847','2.99','2005-07-31T12:33:43.000','2006-02-15T22:13:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4731','174','1','10363','2.99','2005-08-01T06:01:52.000','2006-02-15T22:13:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4732','174','2','10398','4.99','2005-08-01T07:11:49.000','2006-02-15T22:13:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4733','174','1','10559','8.99','2005-08-01T13:02:58.000','2006-02-15T22:13:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4734','174','1','11525','0.99','2005-08-17T00:15:31.000','2006-02-15T22:13:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4735','174','2','12886','5.99','2005-08-19T03:38:32.000','2006-02-15T22:13:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4736','174','1','13185','0.99','2005-08-19T14:22:30.000','2006-02-15T22:13:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4737','174','1','15892','1.99','2005-08-23T17:01:00.000','2006-02-15T22:13:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4738','174','1','15975','4.99','2005-08-23T20:06:23.000','2006-02-15T22:13:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4739','175','2','1495','0.99','2005-06-15T21:54:31.000','2006-02-15T22:13:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4740','175','2','3266','4.99','2005-06-21T04:49:07.000','2006-02-15T22:13:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4741','175','1','3625','4.99','2005-07-06T06:12:52.000','2006-02-15T22:13:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4742','175','2','4167','5.99','2005-07-07T09:37:08.000','2006-02-15T22:13:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4743','175','1','5232','1.99','2005-07-09T12:35:08.000','2006-02-15T22:13:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4744','175','2','6865','7.99','2005-07-12T20:02:40.000','2006-02-15T22:13:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4745','175','1','7448','2.99','2005-07-27T18:06:30.000','2006-02-15T22:13:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4746','175','1','7771','0.99','2005-07-28T06:52:12.000','2006-02-15T22:13:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4747','175','1','8244','2.99','2005-07-29T00:35:34.000','2006-02-15T22:13:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4748','175','1','8264','4.99','2005-07-29T01:18:50.000','2006-02-15T22:13:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4749','175','1','8440','3.99','2005-07-29T07:31:26.000','2006-02-15T22:13:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4750','175','1','8817','4.99','2005-07-29T22:09:08.000','2006-02-15T22:13:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4751','175','2','9941','4.99','2005-07-31T15:31:25.000','2006-02-15T22:13:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4752','175','2','10229','7.99','2005-08-01T01:45:26.000','2006-02-15T22:13:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4753','175','1','10875','0.99','2005-08-02T00:31:44.000','2006-02-15T22:13:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4754','175','2','11618','4.99','2005-08-17T04:01:36.000','2006-02-15T22:13:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4755','175','1','12509','0.99','2005-08-18T13:21:52.000','2006-02-15T22:13:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4756','175','1','13016','4.99','2005-08-19T07:57:14.000','2006-02-15T22:13:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4757','175','2','13833','6.99','2005-08-20T14:00:29.000','2006-02-15T22:13:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4758','175','2','13997','6.99','2005-08-20T19:51:28.000','2006-02-15T22:13:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4759','175','2','14507','4.99','2005-08-21T14:32:45.000','2006-02-15T22:13:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4760','175','2','14897','2.99','2005-08-22T04:22:31.000','2006-02-15T22:13:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4761','175','2','14060','3.98','2006-02-14T15:16:03.000','2006-02-15T22:13:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4762','175','2','13161','0','2006-02-14T15:16:03.000','2006-02-15T22:13:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4763','176','1','172','0.99','2005-05-26T03:17:42.000','2006-02-15T22:13:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4764','176','2','380','6.99','2005-05-27T09:34:39.000','2006-02-15T22:13:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4765','176','1','553','3.99','2005-05-28T08:14:44.000','2006-02-15T22:13:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4766','176','1','663','1.99','2005-05-28T21:23:02.000','2006-02-15T22:13:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4767','176','1','1062','7.99','2005-05-31T08:38:20.000','2006-02-15T22:13:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4768','176','1','1291','5.99','2005-06-15T08:55:01.000','2006-02-15T22:13:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4769','176','1','1741','7.99','2005-06-16T16:31:37.000','2006-02-15T22:13:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4770','176','1','1836','6.99','2005-06-16T23:13:05.000','2006-02-15T22:13:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4771','176','1','2181','8.99','2005-06-18T00:48:31.000','2006-02-15T22:13:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4772','176','1','2218','2.99','2005-06-18T03:13:13.000','2006-02-15T22:13:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4773','176','2','2427','2.99','2005-06-18T17:45:00.000','2006-02-15T22:13:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4774','176','2','2503','1.99','2005-06-18T23:17:19.000','2006-02-15T22:13:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4775','176','1','2922','4.99','2005-06-20T04:13:47.000','2006-02-15T22:13:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4776','176','1','3643','4.99','2005-07-06T07:20:08.000','2006-02-15T22:13:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4777','176','2','3931','6.99','2005-07-06T21:03:46.000','2006-02-15T22:13:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4778','176','2','4121','3.99','2005-07-07T07:13:50.000','2006-02-15T22:13:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4779','176','1','6035','2.99','2005-07-11T03:01:45.000','2006-02-15T22:13:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4780','176','1','6354','6.99','2005-07-11T20:54:27.000','2006-02-15T22:13:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4781','176','1','7017','4.99','2005-07-27T02:16:03.000','2006-02-15T22:13:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4782','176','1','7025','2.99','2005-07-27T02:40:29.000','2006-02-15T22:13:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4783','176','1','7210','2.99','2005-07-27T09:19:05.000','2006-02-15T22:13:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4784','176','2','7521','2.99','2005-07-27T21:04:42.000','2006-02-15T22:13:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4785','176','1','7751','5.99','2005-07-28T05:56:13.000','2006-02-15T22:13:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4786','176','1','8279','2.99','2005-07-29T01:43:37.000','2006-02-15T22:13:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4787','176','2','9145','6.99','2005-07-30T10:27:55.000','2006-02-15T22:13:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4788','176','1','10277','2.99','2005-08-01T03:22:41.000','2006-02-15T22:13:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4789','176','2','10441','0.99','2005-08-01T08:55:56.000','2006-02-15T22:13:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4790','176','1','10862','2.99','2005-08-02T00:17:34.000','2006-02-15T22:13:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4791','176','1','11678','5.99','2005-08-17T06:07:39.000','2006-02-15T22:13:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4792','176','1','12299','2.99','2005-08-18T05:32:32.000','2006-02-15T22:13:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4793','176','1','12718','2.99','2005-08-18T21:21:44.000','2006-02-15T22:13:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4794','176','1','13170','7.99','2005-08-19T13:45:48.000','2006-02-15T22:13:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4795','176','2','13186','5.99','2005-08-19T14:23:19.000','2006-02-15T22:13:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4796','176','1','14083','7.99','2005-08-20T23:42:31.000','2006-02-15T22:13:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4797','176','2','14232','1.99','2005-08-21T05:07:02.000','2006-02-15T22:13:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4798','176','2','15311','4.99','2005-08-22T19:56:52.000','2006-02-15T22:13:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4799','176','1','15933','4.99','2005-08-23T18:36:44.000','2006-02-15T22:13:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4800','177','1','1393','2.99','2005-06-15T16:12:50.000','2006-02-15T22:13:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4801','177','1','1524','2.99','2005-06-16T00:25:52.000','2006-02-15T22:13:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4802','177','2','1621','4.99','2005-06-16T07:24:12.000','2006-02-15T22:13:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4803','177','1','1738','0.99','2005-06-16T16:07:27.000','2006-02-15T22:13:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4804','177','2','2467','2.99','2005-06-18T20:20:05.000','2006-02-15T22:13:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4805','177','1','4760','0.99','2005-07-08T14:48:07.000','2006-02-15T22:13:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4806','177','2','6217','9.99','2005-07-11T13:13:45.000','2006-02-15T22:13:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4807','177','1','6284','2.99','2005-07-11T16:51:39.000','2006-02-15T22:13:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4808','177','1','7493','3.99','2005-07-27T19:55:46.000','2006-02-15T22:13:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4809','177','2','7674','1.99','2005-07-28T02:54:30.000','2006-02-15T22:13:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4810','177','1','8139','0.99','2005-07-28T20:16:30.000','2006-02-15T22:13:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4811','177','2','9190','1.99','2005-07-30T12:24:17.000','2006-02-15T22:13:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4812','177','2','10321','4.99','2005-08-01T04:40:02.000','2006-02-15T22:13:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4813','177','1','10661','2.99','2005-08-01T16:48:31.000','2006-02-15T22:13:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4814','177','1','10710','0.99','2005-08-01T18:44:36.000','2006-02-15T22:13:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4815','177','1','11195','0.99','2005-08-02T11:42:23.000','2006-02-15T22:13:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4816','177','1','11376','5.99','2005-08-02T18:16:00.000','2006-02-15T22:13:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4817','177','2','11662','6.99','2005-08-17T05:27:37.000','2006-02-15T22:13:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4818','177','1','12623','4.99','2005-08-18T17:34:19.000','2006-02-15T22:13:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4819','177','2','14093','0.99','2005-08-21T00:21:29.000','2006-02-15T22:13:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4820','177','2','14310','0.99','2005-08-21T07:44:32.000','2006-02-15T22:13:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4821','177','2','14849','2.99','2005-08-22T02:15:26.000','2006-02-15T22:13:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4822','177','2','14883','0.99','2005-08-22T03:55:02.000','2006-02-15T22:13:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4823','178','1','1292','6.99','2005-06-15T09:03:52.000','2006-02-15T22:13:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4824','178','2','1458','6.99','2005-06-15T20:24:05.000','2006-02-15T22:13:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4825','178','2','1568','2.99','2005-06-16T03:14:01.000','2006-02-15T22:13:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4826','178','2','1745','3.99','2005-06-16T16:41:16.000','2006-02-15T22:13:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4827','178','2','2124','1.99','2005-06-17T20:49:14.000','2006-02-15T22:13:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4828','178','1','2293','4.99','2005-06-18T07:45:03.000','2006-02-15T22:13:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4829','178','2','2844','6.99','2005-06-19T22:40:12.000','2006-02-15T22:13:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4830','178','1','2898','9.99','2005-06-20T02:38:06.000','2006-02-15T22:13:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4831','178','1','4915','2.99','2005-07-08T21:31:22.000','2006-02-15T22:13:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4832','178','1','5015','2.99','2005-07-09T01:54:24.000','2006-02-15T22:13:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4833','178','1','5057','4.99','2005-07-09T04:20:29.000','2006-02-15T22:13:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4834','178','1','5094','10.99','2005-07-09T05:59:47.000','2006-02-15T22:13:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4835','178','1','5984','2.99','2005-07-11T00:44:36.000','2006-02-15T22:13:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4836','178','2','6347','4.99','2005-07-11T20:18:53.000','2006-02-15T22:13:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4837','178','1','6554','5.99','2005-07-12T05:07:26.000','2006-02-15T22:13:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4838','178','1','6566','6.99','2005-07-12T05:42:53.000','2006-02-15T22:13:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4839','178','2','6606','2.99','2005-07-12T08:03:40.000','2006-02-15T22:13:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4840','178','1','7959','4.99','2005-07-28T13:43:20.000','2006-02-15T22:13:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4841','178','2','8069','0.99','2005-07-28T17:23:46.000','2006-02-15T22:13:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4842','178','1','8287','3.99','2005-07-29T02:03:58.000','2006-02-15T22:13:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4843','178','2','8388','5.99','2005-07-29T05:48:15.000','2006-02-15T22:13:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4844','178','2','8696','4.99','2005-07-29T16:45:18.000','2006-02-15T22:13:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4845','178','2','9004','4.99','2005-07-30T05:04:27.000','2006-02-15T22:13:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4846','178','1','9311','7.99','2005-07-30T16:58:31.000','2006-02-15T22:13:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4847','178','2','9879','4.99','2005-07-31T13:45:32.000','2006-02-15T22:13:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4848','178','2','10125','0.99','2005-07-31T21:33:03.000','2006-02-15T22:13:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4849','178','2','10562','0.99','2005-08-01T13:05:52.000','2006-02-15T22:13:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4850','178','1','10802','5.99','2005-08-01T22:18:32.000','2006-02-15T22:13:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4851','178','2','11319','6.99','2005-08-02T16:10:09.000','2006-02-15T22:13:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4852','178','2','11884','6.99','2005-08-17T14:43:23.000','2006-02-15T22:13:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4853','178','2','11927','3.99','2005-08-17T16:25:03.000','2006-02-15T22:13:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4854','178','2','12049','6.99','2005-08-17T20:53:27.000','2006-02-15T22:13:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4855','178','2','12727','2.99','2005-08-18T21:45:15.000','2006-02-15T22:13:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4856','178','1','13127','2.99','2005-08-19T12:04:03.000','2006-02-15T22:13:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4857','178','1','14104','4.99','2005-08-21T00:37:44.000','2006-02-15T22:13:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4858','178','1','14257','7.99','2005-08-21T05:52:57.000','2006-02-15T22:13:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4859','178','2','14314','2.99','2005-08-21T07:50:14.000','2006-02-15T22:13:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4860','178','1','15323','4.99','2005-08-22T20:22:40.000','2006-02-15T22:13:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4861','178','1','12897','4.99','2006-02-14T15:16:03.000','2006-02-15T22:13:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4862','179','1','502','0.99','2005-05-28T01:34:43.000','2006-02-15T22:13:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4863','179','1','759','6.99','2005-05-29T10:57:57.000','2006-02-15T22:13:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4864','179','1','1046','4.99','2005-05-31T06:42:30.000','2006-02-15T22:13:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4865','179','2','1286','7.99','2005-06-15T08:41:13.000','2006-02-15T22:13:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4866','179','1','2613','4.99','2005-06-19T07:25:50.000','2006-02-15T22:13:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4867','179','1','3671','6.99','2005-07-06T09:01:29.000','2006-02-15T22:13:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4868','179','1','3844','0.99','2005-07-06T16:37:58.000','2006-02-15T22:13:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4869','179','1','4618','2.99','2005-07-08T08:00:20.000','2006-02-15T22:13:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4870','179','2','6071','6.99','2005-07-11T04:50:03.000','2006-02-15T22:13:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4871','179','1','6616','7.99','2005-07-12T08:37:30.000','2006-02-15T22:13:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4872','179','1','6806','2.99','2005-07-12T17:31:43.000','2006-02-15T22:13:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4873','179','1','7028','6.99','2005-07-27T02:54:25.000','2006-02-15T22:13:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4874','179','1','7054','4.99','2005-07-27T03:43:28.000','2006-02-15T22:13:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4875','179','1','7609','4.99','2005-07-28T00:11:00.000','2006-02-15T22:13:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4876','179','1','8573','2.99','2005-07-29T11:51:25.000','2006-02-15T22:13:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4877','179','1','8731','8.99','2005-07-29T18:23:57.000','2006-02-15T22:13:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4878','179','2','9491','4.99','2005-07-30T23:45:23.000','2006-02-15T22:13:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4879','179','2','9893','0.99','2005-07-31T14:07:21.000','2006-02-15T22:13:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4880','179','1','10156','4.99','2005-07-31T22:36:00.000','2006-02-15T22:13:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4881','179','1','10385','4.99','2005-08-01T06:39:55.000','2006-02-15T22:13:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4882','179','2','10569','3.99','2005-08-01T13:18:23.000','2006-02-15T22:13:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4883','179','1','11342','0.99','2005-08-02T17:11:35.000','2006-02-15T22:13:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4884','179','2','13240','0.99','2005-08-19T16:22:14.000','2006-02-15T22:13:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4885','179','1','13400','4.99','2005-08-19T22:11:44.000','2006-02-15T22:13:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4886','179','2','13844','7.99','2005-08-20T14:30:26.000','2006-02-15T22:13:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4887','179','2','13957','0.99','2005-08-20T18:09:04.000','2006-02-15T22:13:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4888','179','2','14082','7.99','2005-08-20T23:42:00.000','2006-02-15T22:13:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4889','179','1','14589','0.99','2005-08-21T17:28:55.000','2006-02-15T22:13:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4890','179','1','15985','4.99','2005-08-23T20:20:23.000','2006-02-15T22:13:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4891','180','1','1122','2.99','2005-05-31T16:39:33.000','2006-02-15T22:13:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4892','180','2','2700','2.99','2005-06-19T13:31:52.000','2006-02-15T22:13:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4893','180','1','2798','2.99','2005-06-19T19:07:48.000','2006-02-15T22:13:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4894','180','2','4826','7.99','2005-07-08T17:44:25.000','2006-02-15T22:13:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4895','180','1','4924','9.99','2005-07-08T21:55:25.000','2006-02-15T22:13:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4896','180','2','5384','0.99','2005-07-09T19:17:46.000','2006-02-15T22:13:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4897','180','2','5773','0.99','2005-07-10T13:31:09.000','2006-02-15T22:13:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4898','180','1','5860','3.99','2005-07-10T18:08:49.000','2006-02-15T22:13:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4899','180','1','7274','2.99','2005-07-27T11:35:34.000','2006-02-15T22:13:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4900','180','2','8540','2.99','2005-07-29T10:52:51.000','2006-02-15T22:13:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4901','180','2','8720','5.99','2005-07-29T17:48:32.000','2006-02-15T22:13:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4902','180','1','9373','0.99','2005-07-30T19:05:36.000','2006-02-15T22:13:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4903','180','2','9995','3.99','2005-07-31T17:30:47.000','2006-02-15T22:13:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4904','180','1','10576','5.99','2005-08-01T13:46:02.000','2006-02-15T22:13:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4905','180','1','10992','8.99','2005-08-02T04:41:17.000','2006-02-15T22:13:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4906','180','1','12313','8.99','2005-08-18T06:07:31.000','2006-02-15T22:13:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4907','180','1','13283','2.99','2005-08-19T18:10:19.000','2006-02-15T22:13:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4908','180','2','13842','4.99','2005-08-20T14:29:37.000','2006-02-15T22:13:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4909','180','1','13994','2.99','2005-08-20T19:33:21.000','2006-02-15T22:13:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4910','180','1','14109','0.99','2005-08-21T00:52:58.000','2006-02-15T22:13:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4911','180','1','14851','2.99','2005-08-22T02:20:44.000','2006-02-15T22:13:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4912','180','1','15039','4.99','2005-08-22T09:37:54.000','2006-02-15T22:13:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4913','180','1','12901','4.99','2006-02-14T15:16:03.000','2006-02-15T22:13:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4914','181','2','579','6.99','2005-05-28T11:19:23.000','2006-02-15T22:13:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4915','181','1','1638','2.99','2005-06-16T08:32:36.000','2006-02-15T22:13:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4916','181','1','2645','5.99','2005-06-19T09:50:35.000','2006-02-15T22:13:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4917','181','2','3449','5.99','2005-06-21T21:01:27.000','2006-02-15T22:13:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4918','181','2','3469','4.99','2005-06-21T22:48:59.000','2006-02-15T22:13:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4919','181','1','3862','6.99','2005-07-06T17:35:22.000','2006-02-15T22:13:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4920','181','2','4428','4.99','2005-07-07T22:29:40.000','2006-02-15T22:13:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4921','181','2','6477','4.99','2005-07-12T01:38:42.000','2006-02-15T22:13:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4922','181','1','6946','8.99','2005-07-26T23:40:07.000','2006-02-15T22:13:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4923','181','1','7393','0.99','2005-07-27T16:02:52.000','2006-02-15T22:13:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4924','181','1','7632','4.99','2005-07-28T01:02:40.000','2006-02-15T22:13:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4925','181','1','8593','5.99','2005-07-29T12:38:14.000','2006-02-15T22:13:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4926','181','1','8601','9.99','2005-07-29T13:03:31.000','2006-02-15T22:13:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4927','181','2','9214','4.99','2005-07-30T13:10:14.000','2006-02-15T22:13:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4928','181','2','9235','5.99','2005-07-30T13:47:17.000','2006-02-15T22:13:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4929','181','1','9357','8.99','2005-07-30T18:37:00.000','2006-02-15T22:13:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4930','181','1','9844','4.99','2005-07-31T12:26:31.000','2006-02-15T22:13:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4931','181','2','10262','4.99','2005-08-01T03:01:26.000','2006-02-15T22:13:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4932','181','2','10362','6.99','2005-08-01T05:55:13.000','2006-02-15T22:13:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4933','181','2','10703','2.99','2005-08-01T18:37:39.000','2006-02-15T22:13:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4934','181','1','10748','4.99','2005-08-01T20:01:24.000','2006-02-15T22:13:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4935','181','1','10773','6.99','2005-08-01T20:53:45.000','2006-02-15T22:13:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4936','181','2','11224','4.99','2005-08-02T12:40:38.000','2006-02-15T22:13:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4937','181','1','12363','7.99','2005-08-18T07:52:49.000','2006-02-15T22:13:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4938','181','1','12411','0.99','2005-08-18T09:47:57.000','2006-02-15T22:13:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4939','181','1','12678','2.99','2005-08-18T19:41:27.000','2006-02-15T22:13:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4940','181','2','12939','2.99','2005-08-19T05:38:25.000','2006-02-15T22:13:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4941','181','2','13118','4.99','2005-08-19T11:39:58.000','2006-02-15T22:13:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4942','181','2','13405','4.99','2005-08-19T22:20:49.000','2006-02-15T22:13:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4943','181','2','13415','2.99','2005-08-19T22:48:09.000','2006-02-15T22:13:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4944','181','2','14406','3.99','2005-08-21T10:46:35.000','2006-02-15T22:13:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4945','181','2','15196','2.99','2005-08-22T16:11:32.000','2006-02-15T22:13:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4946','181','2','15482','4.99','2005-08-23T02:01:20.000','2006-02-15T22:13:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4947','181','2','13008','2.99','2006-02-14T15:16:03.000','2006-02-15T22:13:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4948','182','2','161','0.99','2005-05-26T01:51:48.000','2006-02-15T22:13:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4949','182','2','425','3.99','2005-05-27T15:51:30.000','2006-02-15T22:13:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4950','182','2','1542','3.99','2005-06-16T01:20:05.000','2006-02-15T22:13:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4951','182','1','2049','2.99','2005-06-17T14:58:36.000','2006-02-15T22:13:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4952','182','2','2120','5.99','2005-06-17T20:36:50.000','2006-02-15T22:13:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4953','182','1','2234','0.99','2005-06-18T04:01:28.000','2006-02-15T22:13:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4954','182','1','3509','2.99','2005-07-06T00:24:57.000','2006-02-15T22:13:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4955','182','1','3697','6.99','2005-07-06T10:07:22.000','2006-02-15T22:13:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4956','182','1','4174','2.99','2005-07-07T09:59:49.000','2006-02-15T22:13:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4957','182','1','4349','0.99','2005-07-07T19:02:37.000','2006-02-15T22:13:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4958','182','2','4513','1.99','2005-07-08T02:39:59.000','2006-02-15T22:13:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4959','182','2','4591','3.99','2005-07-08T06:29:43.000','2006-02-15T22:13:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4960','182','2','4784','0.99','2005-07-08T16:09:56.000','2006-02-15T22:13:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4961','182','1','5521','2.99','2005-07-10T01:31:22.000','2006-02-15T22:13:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4962','182','2','7229','0.99','2005-07-27T10:00:54.000','2006-02-15T22:13:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4963','182','2','7863','0.99','2005-07-28T10:05:46.000','2006-02-15T22:13:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4964','182','2','7880','4.99','2005-07-28T10:30:37.000','2006-02-15T22:13:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4965','182','2','8048','8.99','2005-07-28T16:50:26.000','2006-02-15T22:13:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4966','182','1','11055','4.99','2005-08-02T06:36:05.000','2006-02-15T22:13:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4967','182','2','11785','3.99','2005-08-17T10:54:46.000','2006-02-15T22:13:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4968','182','1','12573','4.99','2005-08-18T15:32:57.000','2006-02-15T22:13:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4969','182','1','12840','6.99','2005-08-19T01:54:11.000','2006-02-15T22:13:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4970','182','1','13285','2.99','2005-08-19T18:18:44.000','2006-02-15T22:13:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4971','182','1','14586','5.99','2005-08-21T17:19:09.000','2006-02-15T22:13:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4972','182','1','14953','6.99','2005-08-22T06:23:54.000','2006-02-15T22:13:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4973','182','1','15043','1.99','2005-08-22T09:49:32.000','2006-02-15T22:13:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4974','183','1','382','0.99','2005-05-27T10:12:00.000','2006-02-15T22:13:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4975','183','1','1279','0.99','2005-06-15T08:13:57.000','2006-02-15T22:13:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4976','183','2','2188','1.99','2005-06-18T01:19:04.000','2006-02-15T22:13:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4977','183','2','2471','5.99','2005-06-18T20:31:00.000','2006-02-15T22:13:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4978','183','1','3381','5.99','2005-06-21T14:02:59.000','2006-02-15T22:13:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4979','183','1','3869','2.99','2005-07-06T17:56:46.000','2006-02-15T22:13:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4980','183','2','4134','0.99','2005-07-07T08:14:24.000','2006-02-15T22:13:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4981','183','2','4157','2.99','2005-07-07T09:04:26.000','2006-02-15T22:13:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4982','183','1','5069','1.99','2005-07-09T04:56:30.000','2006-02-15T22:13:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4983','183','2','5756','0.99','2005-07-10T12:39:28.000','2006-02-15T22:13:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4984','183','1','6472','4.99','2005-07-12T01:33:25.000','2006-02-15T22:13:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4985','183','1','6569','4.99','2005-07-12T05:47:40.000','2006-02-15T22:13:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4986','183','2','7359','0.99','2005-07-27T14:51:04.000','2006-02-15T22:13:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4987','183','2','9672','5.99','2005-07-31T06:34:06.000','2006-02-15T22:13:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4988','183','1','9818','4.99','2005-07-31T11:34:32.000','2006-02-15T22:13:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4989','183','2','9931','2.99','2005-07-31T15:18:19.000','2006-02-15T22:13:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4990','183','2','10620','5.99','2005-08-01T15:09:17.000','2006-02-15T22:13:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4991','183','2','11386','2.99','2005-08-02T18:24:03.000','2006-02-15T22:13:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4992','183','2','12451','0.99','2005-08-18T11:04:42.000','2006-02-15T22:13:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4993','183','2','12764','3.99','2005-08-18T23:14:15.000','2006-02-15T22:13:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4994','183','2','12831','3.99','2005-08-19T01:40:43.000','2006-02-15T22:13:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4995','183','1','13482','2.99','2005-08-20T01:14:30.000','2006-02-15T22:13:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4996','183','1','13536','4.99','2005-08-20T03:35:16.000','2006-02-15T22:13:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4997','184','1','196','2.99','2005-05-26T06:55:58.000','2006-02-15T22:13:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4998','184','2','534','4.99','2005-05-28T06:15:25.000','2006-02-15T22:13:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('4999','184','1','567','1.99','2005-05-28T09:56:20.000','2006-02-15T22:13:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5000','184','2','1976','2.99','2005-06-17T09:38:08.000','2006-02-15T22:13:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5001','184','1','2312','0.99','2005-06-18T08:55:46.000','2006-02-15T22:13:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5002','184','1','4314','0.99','2005-07-07T17:38:31.000','2006-02-15T22:13:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5003','184','2','4882','6.99','2005-07-08T19:42:03.000','2006-02-15T22:13:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5004','184','1','5891','0.99','2005-07-10T20:01:17.000','2006-02-15T22:13:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5005','184','2','6493','2.99','2005-07-12T02:40:41.000','2006-02-15T22:13:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5006','184','2','6700','6.99','2005-07-12T12:47:22.000','2006-02-15T22:13:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5007','184','2','7051','4.99','2005-07-27T03:34:37.000','2006-02-15T22:13:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5008','184','2','7686','6.99','2005-07-28T03:19:23.000','2006-02-15T22:13:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5009','184','1','8892','4.99','2005-07-30T00:47:03.000','2006-02-15T22:13:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5010','184','1','9162','0.99','2005-07-30T11:21:56.000','2006-02-15T22:13:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5011','184','2','12166','9.99','2005-08-18T00:57:06.000','2006-02-15T22:13:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5012','184','2','12454','2.99','2005-08-18T11:19:02.000','2006-02-15T22:13:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5013','184','1','12532','2.99','2005-08-18T13:57:58.000','2006-02-15T22:13:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5014','184','1','13134','0.99','2005-08-19T12:14:14.000','2006-02-15T22:13:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5015','184','1','13262','5.99','2005-08-19T17:20:15.000','2006-02-15T22:13:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5016','184','1','13303','4.99','2005-08-19T18:55:21.000','2006-02-15T22:13:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5017','184','2','14472','4.99','2005-08-21T13:13:57.000','2006-02-15T22:13:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5018','184','1','14801','5.99','2005-08-22T00:46:54.000','2006-02-15T22:13:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5019','184','2','15611','0.99','2005-08-23T06:56:18.000','2006-02-15T22:13:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5020','185','2','20','2.99','2005-05-25T01:48:41.000','2006-02-15T22:13:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5021','185','2','154','0.99','2005-05-26T00:55:56.000','2006-02-15T22:13:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5022','185','1','646','0.99','2005-05-28T19:16:14.000','2006-02-15T22:13:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5023','185','1','2459','4.99','2005-06-18T19:44:08.000','2006-02-15T22:13:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5024','185','1','3314','4.99','2005-06-21T08:17:00.000','2006-02-15T22:13:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5025','185','1','3325','4.99','2005-06-21T08:51:44.000','2006-02-15T22:13:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5026','185','1','4186','9.99','2005-07-07T10:32:25.000','2006-02-15T22:13:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5027','185','1','4524','2.99','2005-07-08T03:10:48.000','2006-02-15T22:13:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5028','185','2','4822','7.99','2005-07-08T17:28:47.000','2006-02-15T22:13:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5029','185','2','6106','2.99','2005-07-11T07:05:06.000','2006-02-15T22:13:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5030','185','1','6418','1.99','2005-07-11T23:36:27.000','2006-02-15T22:13:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5031','185','1','6965','2.99','2005-07-27T00:15:18.000','2006-02-15T22:13:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5032','185','1','7066','4.99','2005-07-27T03:53:52.000','2006-02-15T22:13:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5033','185','1','8200','2.99','2005-07-28T23:10:46.000','2006-02-15T22:13:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5034','185','2','8442','0.99','2005-07-29T07:33:07.000','2006-02-15T22:13:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5035','185','1','8684','8.99','2005-07-29T16:16:33.000','2006-02-15T22:13:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5036','185','2','9246','0.99','2005-07-30T14:12:31.000','2006-02-15T22:13:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5037','185','2','9473','2.99','2005-07-30T23:04:13.000','2006-02-15T22:13:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5038','185','2','11355','0.99','2005-08-02T17:37:43.000','2006-02-15T22:13:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5039','185','1','12312','2.99','2005-08-18T06:07:26.000','2006-02-15T22:13:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5040','185','1','12674','5.99','2005-08-18T19:24:56.000','2006-02-15T22:13:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5041','185','1','12885','0.99','2005-08-19T03:37:25.000','2006-02-15T22:13:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5042','185','2','14513','2.99','2005-08-21T14:51:35.000','2006-02-15T22:13:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5043','186','1','581','1.99','2005-05-28T11:20:29.000','2006-02-15T22:13:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5044','186','2','958','0.99','2005-05-30T17:58:03.000','2006-02-15T22:13:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5045','186','1','1192','4.99','2005-06-15T01:18:39.000','2006-02-15T22:13:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5046','186','1','1300','2.99','2005-06-15T09:36:19.000','2006-02-15T22:13:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5047','186','1','1663','2.99','2005-06-16T10:14:15.000','2006-02-15T22:13:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5048','186','2','2132','4.99','2005-06-17T21:05:06.000','2006-02-15T22:13:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5049','186','2','2875','4.99','2005-06-20T00:47:18.000','2006-02-15T22:13:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5050','186','1','3039','4.99','2005-06-20T12:32:30.000','2006-02-15T22:13:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5051','186','2','6067','4.99','2005-07-11T04:34:49.000','2006-02-15T22:13:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5052','186','2','7739','0.99','2005-07-28T05:21:51.000','2006-02-15T22:13:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5053','186','1','7915','3.99','2005-07-28T11:49:46.000','2006-02-15T22:13:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5054','186','1','8483','4.99','2005-07-29T08:50:18.000','2006-02-15T22:13:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5055','186','2','8872','0.99','2005-07-30T00:13:54.000','2006-02-15T22:13:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5056','186','2','9303','2.99','2005-07-30T16:35:59.000','2006-02-15T22:13:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5057','186','2','9360','5.99','2005-07-30T18:39:43.000','2006-02-15T22:13:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5058','186','1','10104','1.99','2005-07-31T20:49:14.000','2006-02-15T22:13:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5059','186','1','10985','0.99','2005-08-02T04:30:19.000','2006-02-15T22:13:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5060','186','1','11982','0.99','2005-08-17T18:13:07.000','2006-02-15T22:13:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5061','186','1','12348','5.99','2005-08-18T07:21:47.000','2006-02-15T22:13:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5062','186','1','12438','8.99','2005-08-18T10:42:52.000','2006-02-15T22:13:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5063','186','1','13168','6.99','2005-08-19T13:37:28.000','2006-02-15T22:13:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5064','186','2','13517','4.99','2005-08-20T02:33:17.000','2006-02-15T22:13:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5065','186','1','13853','3.99','2005-08-20T14:47:02.000','2006-02-15T22:13:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5066','186','1','14006','2.99','2005-08-20T20:21:36.000','2006-02-15T22:13:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5067','186','2','14229','4.99','2005-08-21T04:57:15.000','2006-02-15T22:13:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5068','186','2','14646','4.99','2005-08-21T19:14:48.000','2006-02-15T22:13:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5069','186','2','14988','3.99','2005-08-22T07:46:05.000','2006-02-15T22:13:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5070','186','2','15001','0.99','2005-08-22T08:00:49.000','2006-02-15T22:13:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5071','186','2','15295','3.99','2005-08-22T19:36:21.000','2006-02-15T22:13:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5072','186','1','15596','0.99','2005-08-23T06:19:51.000','2006-02-15T22:13:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5073','186','1','14216','2.99','2006-02-14T15:16:03.000','2006-02-15T22:13:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5074','187','1','252','7.99','2005-05-26T14:39:53.000','2006-02-15T22:13:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5075','187','2','1323','6.99','2005-06-15T10:55:17.000','2006-02-15T22:13:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5076','187','2','1462','4.99','2005-06-15T20:37:40.000','2006-02-15T22:13:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5077','187','2','1592','0.99','2005-06-16T05:14:37.000','2006-02-15T22:13:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5078','187','2','2127','0.99','2005-06-17T20:54:48.000','2006-02-15T22:13:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5079','187','2','2533','0.99','2005-06-19T01:34:26.000','2006-02-15T22:13:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5080','187','1','2742','5.99','2005-06-19T16:05:47.000','2006-02-15T22:13:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5081','187','1','3402','2.99','2005-06-21T15:54:37.000','2006-02-15T22:13:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5082','187','2','3709','10.99','2005-07-06T10:26:56.000','2006-02-15T22:13:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5083','187','1','4429','4.99','2005-07-07T22:32:47.000','2006-02-15T22:13:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5084','187','2','5366','0.99','2005-07-09T18:28:37.000','2006-02-15T22:13:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5085','187','1','5738','8.99','2005-07-10T11:50:51.000','2006-02-15T22:13:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5086','187','2','5833','6.99','2005-07-10T16:39:24.000','2006-02-15T22:13:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5087','187','1','6057','3.99','2005-07-11T04:03:40.000','2006-02-15T22:13:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5088','187','2','6428','2.99','2005-07-12T00:01:51.000','2006-02-15T22:13:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5089','187','2','7289','4.99','2005-07-27T12:26:51.000','2006-02-15T22:13:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5090','187','2','7844','7.99','2005-07-28T09:16:19.000','2006-02-15T22:13:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5091','187','2','7967','7.99','2005-07-28T13:56:51.000','2006-02-15T22:13:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5092','187','1','9241','2.99','2005-07-30T13:58:41.000','2006-02-15T22:13:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5093','187','1','11843','2.99','2005-08-17T13:14:50.000','2006-02-15T22:13:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5094','187','2','12307','8.99','2005-08-18T05:48:23.000','2006-02-15T22:13:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5095','187','2','12490','9.99','2005-08-18T12:48:45.000','2006-02-15T22:13:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5096','187','1','12534','7.99','2005-08-18T14:04:41.000','2006-02-15T22:13:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5097','187','2','13940','8.99','2005-08-20T17:28:57.000','2006-02-15T22:13:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5098','187','2','14855','8.99','2005-08-22T02:27:32.000','2006-02-15T22:13:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5099','187','2','15231','4.99','2005-08-22T17:32:57.000','2006-02-15T22:13:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5100','187','2','15517','2.99','2005-08-23T03:13:01.000','2006-02-15T22:13:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5101','187','2','15971','7.99','2005-08-23T19:59:33.000','2006-02-15T22:13:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5102','188','2','1527','2.99','2005-06-16T00:31:40.000','2006-02-15T22:13:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5103','188','2','1927','0.99','2005-06-17T06:48:19.000','2006-02-15T22:13:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5104','188','1','2515','4.99','2005-06-18T23:57:31.000','2006-02-15T22:13:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5105','188','2','2733','4.99','2005-06-19T15:21:53.000','2006-02-15T22:13:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5106','188','2','3848','3.99','2005-07-06T16:47:32.000','2006-02-15T22:13:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5107','188','2','4150','2.99','2005-07-07T08:43:22.000','2006-02-15T22:13:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5108','188','2','5356','2.99','2005-07-09T18:08:28.000','2006-02-15T22:13:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5109','188','2','5729','5.99','2005-07-10T11:27:25.000','2006-02-15T22:13:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5110','188','2','6555','4.99','2005-07-12T05:08:16.000','2006-02-15T22:13:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5111','188','2','7042','0.99','2005-07-27T03:20:18.000','2006-02-15T22:13:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5112','188','1','7556','4.99','2005-07-27T22:17:17.000','2006-02-15T22:13:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5113','188','2','9613','4.99','2005-07-31T03:58:53.000','2006-02-15T22:13:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5114','188','2','10453','5.99','2005-08-01T09:13:27.000','2006-02-15T22:13:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5115','188','1','10494','0.99','2005-08-01T10:45:21.000','2006-02-15T22:13:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5116','188','2','10719','4.99','2005-08-01T19:00:28.000','2006-02-15T22:13:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5117','188','2','10757','4.99','2005-08-01T20:22:44.000','2006-02-15T22:13:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5118','188','2','11378','2.99','2005-08-02T18:16:52.000','2006-02-15T22:13:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5119','188','1','13570','2.99','2005-08-20T05:04:57.000','2006-02-15T22:13:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5120','188','1','13787','5.99','2005-08-20T12:15:23.000','2006-02-15T22:13:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5121','188','1','14399','2.99','2005-08-21T10:33:23.000','2006-02-15T22:13:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5122','188','2','14809','2.99','2005-08-22T01:00:42.000','2006-02-15T22:13:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5123','188','2','15319','2.99','2005-08-22T20:17:17.000','2006-02-15T22:13:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5124','188','2','15409','0.99','2005-08-22T23:26:32.000','2006-02-15T22:13:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5125','188','2','15474','4.99','2005-08-23T01:39:10.000','2006-02-15T22:13:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5126','188','1','14503','2.99','2006-02-14T15:16:03.000','2006-02-15T22:13:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5127','189','2','1117','5.99','2005-05-31T16:15:31.000','2006-02-15T22:13:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5128','189','1','1541','0.99','2005-06-16T01:15:59.000','2006-02-15T22:13:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5129','189','1','1834','0.99','2005-06-16T22:49:08.000','2006-02-15T22:13:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5130','189','2','2905','1.99','2005-06-20T02:56:16.000','2006-02-15T22:13:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5131','189','1','3108','6.99','2005-06-20T17:28:43.000','2006-02-15T22:13:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5132','189','1','3346','2.99','2005-06-21T11:06:53.000','2006-02-15T22:13:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5133','189','1','3763','0.99','2005-07-06T12:56:31.000','2006-02-15T22:13:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5134','189','2','3813','4.99','2005-07-06T15:23:34.000','2006-02-15T22:13:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5135','189','2','4203','0.99','2005-07-07T11:24:14.000','2006-02-15T22:13:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5136','189','1','6193','5.99','2005-07-11T11:46:57.000','2006-02-15T22:13:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5137','189','1','7469','4.99','2005-07-27T18:57:40.000','2006-02-15T22:13:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5138','189','1','7675','4.99','2005-07-28T02:55:20.000','2006-02-15T22:13:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5139','189','2','7790','2.99','2005-07-28T07:22:35.000','2006-02-15T22:13:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5140','189','2','9171','5.99','2005-07-30T11:36:24.000','2006-02-15T22:13:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5141','189','2','9386','0.99','2005-07-30T19:26:21.000','2006-02-15T22:13:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5142','189','1','9506','4.99','2005-07-31T00:19:01.000','2006-02-15T22:13:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5143','189','1','10247','9.99','2005-08-01T02:34:06.000','2006-02-15T22:13:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5144','189','2','11059','6.99','2005-08-02T06:41:38.000','2006-02-15T22:13:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5145','189','2','13601','6.99','2005-08-20T06:01:15.000','2006-02-15T22:13:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5146','189','1','13766','3.99','2005-08-20T11:42:01.000','2006-02-15T22:13:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5147','189','1','15773','1.99','2005-08-23T13:24:57.000','2006-02-15T22:13:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5148','189','1','16008','5.99','2005-08-23T21:04:51.000','2006-02-15T22:13:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5149','190','2','430','4.99','2005-05-27T16:22:10.000','2006-02-15T22:13:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5150','190','1','693','2.99','2005-05-29T01:42:31.000','2006-02-15T22:13:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5151','190','1','1319','2.99','2005-06-15T10:39:05.000','2006-02-15T22:13:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5152','190','1','1347','2.99','2005-06-15T12:43:43.000','2006-02-15T22:13:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5153','190','1','2057','4.99','2005-06-17T15:31:58.000','2006-02-15T22:13:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5154','190','1','2568','3.99','2005-06-19T04:09:03.000','2006-02-15T22:13:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5155','190','1','3386','4.99','2005-06-21T14:21:06.000','2006-02-15T22:13:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5156','190','2','4005','5.99','2005-07-07T00:22:26.000','2006-02-15T22:13:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5157','190','1','4140','2.99','2005-07-07T08:19:10.000','2006-02-15T22:13:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5158','190','2','6867','3.99','2005-07-12T20:06:47.000','2006-02-15T22:13:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5159','190','1','7175','4.99','2005-07-27T08:03:22.000','2006-02-15T22:13:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5160','190','1','7386','5.99','2005-07-27T15:52:10.000','2006-02-15T22:13:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5161','190','2','7404','2.99','2005-07-27T16:24:43.000','2006-02-15T22:13:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5162','190','1','8498','0.99','2005-07-29T09:07:38.000','2006-02-15T22:13:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5163','190','1','11082','5.99','2005-08-02T07:30:19.000','2006-02-15T22:13:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5164','190','2','11158','6.99','2005-08-02T09:58:28.000','2006-02-15T22:13:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5165','190','2','11276','4.99','2005-08-02T14:28:46.000','2006-02-15T22:13:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5166','190','2','11312','6.99','2005-08-02T15:56:51.000','2006-02-15T22:13:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5167','190','2','11750','0.99','2005-08-17T09:07:00.000','2006-02-15T22:13:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5168','190','2','11950','9.99','2005-08-17T17:13:16.000','2006-02-15T22:13:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5169','190','1','12270','2.99','2005-08-18T04:32:05.000','2006-02-15T22:13:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5170','190','2','12381','0.99','2005-08-18T08:31:43.000','2006-02-15T22:13:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5171','190','2','14065','0.99','2005-08-20T22:40:47.000','2006-02-15T22:13:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5172','190','2','14141','4.99','2005-08-21T02:07:22.000','2006-02-15T22:13:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5173','190','2','14166','2.99','2005-08-21T02:59:31.000','2006-02-15T22:13:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5174','190','2','14650','0.99','2005-08-21T19:24:51.000','2006-02-15T22:13:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5175','190','2','15167','4.99','2006-02-14T15:16:03.000','2006-02-15T22:13:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5176','191','1','1134','2.99','2005-05-31T19:14:15.000','2006-02-15T22:13:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5177','191','2','1152','4.99','2005-05-31T21:32:17.000','2006-02-15T22:13:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5178','191','2','1173','2.99','2005-06-14T23:54:46.000','2006-02-15T22:13:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5179','191','1','1278','0.99','2005-06-15T08:09:12.000','2006-02-15T22:13:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5180','191','1','1677','2.99','2005-06-16T11:07:11.000','2006-02-15T22:13:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5181','191','2','1870','2.99','2005-06-17T02:24:36.000','2006-02-15T22:13:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5182','191','1','2051','4.99','2005-06-17T15:10:16.000','2006-02-15T22:13:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5183','191','2','2555','2.99','2005-06-19T03:07:02.000','2006-02-15T22:13:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5184','191','1','5338','2.99','2005-07-09T17:07:07.000','2006-02-15T22:13:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5185','191','2','5397','5.99','2005-07-09T19:43:51.000','2006-02-15T22:13:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5186','191','1','5924','5.99','2005-07-10T21:41:23.000','2006-02-15T22:13:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5187','191','1','7150','6.99','2005-07-27T07:11:14.000','2006-02-15T22:13:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5188','191','1','7450','3.99','2005-07-27T18:18:35.000','2006-02-15T22:13:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5189','191','1','7520','2.99','2005-07-27T21:02:02.000','2006-02-15T22:13:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5190','191','2','8583','0.99','2005-07-29T12:04:50.000','2006-02-15T22:13:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5191','191','1','9297','4.99','2005-07-30T16:26:29.000','2006-02-15T22:13:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5192','191','1','9964','4.99','2005-07-31T16:17:39.000','2006-02-15T22:13:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5193','191','2','10532','2.99','2005-08-01T12:06:35.000','2006-02-15T22:13:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5194','191','2','15375','4.99','2005-08-22T22:12:02.000','2006-02-15T22:13:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5195','191','1','14361','0.99','2006-02-14T15:16:03.000','2006-02-15T22:13:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5196','192','1','895','1.99','2005-05-30T08:50:43.000','2006-02-15T22:13:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5197','192','1','2760','3.99','2005-06-19T17:16:33.000','2006-02-15T22:13:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5198','192','1','3902','2.99','2005-07-06T19:25:18.000','2006-02-15T22:13:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5199','192','1','4469','4.99','2005-07-08T00:18:32.000','2006-02-15T22:13:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5200','192','1','5400','2.99','2005-07-09T19:56:40.000','2006-02-15T22:13:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5201','192','2','6223','0.99','2005-07-11T13:27:09.000','2006-02-15T22:13:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5202','192','2','6691','0.99','2005-07-12T12:26:38.000','2006-02-15T22:13:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5203','192','2','7147','2.99','2005-07-27T07:02:34.000','2006-02-15T22:13:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5204','192','2','8051','0.99','2005-07-28T16:56:16.000','2006-02-15T22:13:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5205','192','2','8292','7.99','2005-07-29T02:29:36.000','2006-02-15T22:13:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5206','192','1','9462','7.99','2005-07-30T22:30:44.000','2006-02-15T22:13:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5207','192','1','9831','2.99','2005-07-31T11:59:32.000','2006-02-15T22:13:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5208','192','2','10238','0.99','2005-08-01T02:08:05.000','2006-02-15T22:13:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5209','192','1','10843','7.99','2005-08-01T23:43:03.000','2006-02-15T22:13:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5210','192','1','11385','4.99','2005-08-02T18:23:11.000','2006-02-15T22:13:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5211','192','1','11815','4.99','2005-08-17T12:13:26.000','2006-02-15T22:13:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5212','192','1','13125','5.99','2005-08-19T11:57:49.000','2006-02-15T22:13:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5213','192','2','14146','4.99','2005-08-21T02:13:31.000','2006-02-15T22:13:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5214','192','2','14238','7.99','2005-08-21T05:16:40.000','2006-02-15T22:13:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5215','192','1','14404','4.99','2005-08-21T10:43:04.000','2006-02-15T22:13:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5216','192','2','14692','6.99','2005-08-21T20:43:21.000','2006-02-15T22:13:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5217','192','2','15855','2.99','2005-08-23T15:59:01.000','2006-02-15T22:13:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5218','192','1','11611','4.99','2006-02-14T15:16:03.000','2006-02-15T22:13:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5219','193','2','273','2.99','2005-05-26T16:29:36.000','2006-02-15T22:13:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5220','193','2','464','0.99','2005-05-27T20:42:44.000','2006-02-15T22:13:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5221','193','1','1325','4.99','2005-06-15T11:03:24.000','2006-02-15T22:13:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5222','193','2','2377','6.99','2005-06-18T14:56:23.000','2006-02-15T22:13:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5223','193','2','2841','6.99','2005-06-19T22:21:06.000','2006-02-15T22:13:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5224','193','2','2846','4.99','2005-06-19T22:52:14.000','2006-02-15T22:13:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5225','193','2','2880','2.99','2005-06-20T01:24:54.000','2006-02-15T22:13:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5226','193','1','3297','8.99','2005-06-21T07:08:19.000','2006-02-15T22:13:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5227','193','1','4892','6.99','2005-07-08T20:06:25.000','2006-02-15T22:13:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5228','193','1','8211','2.99','2005-07-28T23:34:22.000','2006-02-15T22:13:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5229','193','1','8379','4.99','2005-07-29T05:29:40.000','2006-02-15T22:13:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5230','193','1','8431','4.99','2005-07-29T07:12:48.000','2006-02-15T22:13:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5231','193','1','9079','2.99','2005-07-30T08:02:00.000','2006-02-15T22:13:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5232','193','1','9575','4.99','2005-07-31T02:51:53.000','2006-02-15T22:13:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5233','193','2','10462','2.99','2005-08-01T09:38:28.000','2006-02-15T22:13:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5234','193','2','12384','0.99','2005-08-18T08:36:58.000','2006-02-15T22:13:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5235','193','2','12658','4.99','2005-08-18T19:05:42.000','2006-02-15T22:13:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5236','193','1','13529','2.99','2005-08-20T03:07:47.000','2006-02-15T22:13:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5237','193','1','13608','0.99','2005-08-20T06:10:44.000','2006-02-15T22:13:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5238','193','1','14679','2.99','2005-08-21T20:14:58.000','2006-02-15T22:13:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5239','193','1','14927','4.99','2005-08-22T05:31:53.000','2006-02-15T22:13:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5240','193','2','15164','4.99','2005-08-22T14:47:53.000','2006-02-15T22:13:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5241','193','2','15344','6.99','2005-08-22T21:01:48.000','2006-02-15T22:13:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5242','193','2','15495','5.99','2005-08-23T02:26:10.000','2006-02-15T22:13:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5243','193','2','15729','2.99','2006-02-14T15:16:03.000','2006-02-15T22:13:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5244','194','2','334','4.99','2005-05-27T03:03:07.000','2006-02-15T22:13:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5245','194','2','677','7.99','2005-05-28T23:00:08.000','2006-02-15T22:13:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5246','194','1','1430','0.99','2005-06-15T18:24:55.000','2006-02-15T22:13:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5247','194','1','2245','7.99','2005-06-18T04:52:59.000','2006-02-15T22:13:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5248','194','1','2347','2.99','2005-06-18T12:12:29.000','2006-02-15T22:13:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5249','194','1','2463','3.99','2005-06-18T20:01:43.000','2006-02-15T22:13:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5250','194','1','2807','3.99','2005-06-19T19:32:53.000','2006-02-15T22:13:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5251','194','2','4231','7.99','2005-07-07T12:48:19.000','2006-02-15T22:13:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5252','194','2','5146','2.99','2005-07-09T08:14:58.000','2006-02-15T22:13:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5253','194','1','5291','2.99','2005-07-09T15:15:02.000','2006-02-15T22:13:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5254','194','2','5894','3.99','2005-07-10T20:09:34.000','2006-02-15T22:13:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5255','194','1','9064','7.99','2005-07-30T07:24:55.000','2006-02-15T22:13:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5256','194','2','11475','5.99','2005-08-02T21:55:09.000','2006-02-15T22:13:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5257','194','2','12851','3.99','2005-08-19T02:12:12.000','2006-02-15T22:13:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5258','194','1','13515','0.99','2005-08-20T02:29:47.000','2006-02-15T22:13:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5259','194','2','13616','7.99','2005-08-20T06:30:33.000','2006-02-15T22:13:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5260','194','1','14440','4.99','2005-08-21T11:59:04.000','2006-02-15T22:13:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5261','194','2','15937','4.99','2005-08-23T18:43:22.000','2006-02-15T22:13:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5262','195','1','4234','6.99','2005-07-07T13:01:35.000','2006-02-15T22:13:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5263','195','1','4315','2.99','2005-07-07T17:40:26.000','2006-02-15T22:13:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5264','195','1','5228','4.99','2005-07-09T12:26:01.000','2006-02-15T22:13:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5265','195','1','5536','0.99','2005-07-10T02:29:42.000','2006-02-15T22:13:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5266','195','2','6175','4.99','2005-07-11T10:44:37.000','2006-02-15T22:13:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5267','195','1','7349','2.99','2005-07-27T14:33:00.000','2006-02-15T22:13:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5268','195','2','8280','4.99','2005-07-29T01:45:51.000','2006-02-15T22:13:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5269','195','2','8479','0.99','2005-07-29T08:42:04.000','2006-02-15T22:13:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5270','195','2','9188','6.99','2005-07-30T12:19:54.000','2006-02-15T22:13:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5271','195','1','9870','5.99','2005-07-31T13:22:51.000','2006-02-15T22:13:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5272','195','1','9994','4.99','2005-07-31T17:30:31.000','2006-02-15T22:13:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5273','195','2','10911','4.99','2005-08-02T01:58:36.000','2006-02-15T22:14:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5274','195','1','11201','7.99','2005-08-02T11:49:16.000','2006-02-15T22:14:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5275','195','2','11787','2.99','2005-08-17T10:59:00.000','2006-02-15T22:14:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5276','195','2','12099','0.99','2005-08-17T22:38:54.000','2006-02-15T22:14:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5277','195','2','12941','0.99','2005-08-19T05:39:26.000','2006-02-15T22:14:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5278','195','2','13741','0.99','2005-08-20T10:48:47.000','2006-02-15T22:14:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5279','195','2','14751','7.99','2005-08-21T23:11:23.000','2006-02-15T22:14:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5280','195','2','16040','11.99','2005-08-23T22:19:33.000','2006-02-15T22:14:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5281','196','2','106','11.99','2005-05-25T18:18:19.000','2006-02-15T22:14:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5282','196','2','178','5.99','2005-05-26T04:21:46.000','2006-02-15T22:14:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5283','196','2','491','2.99','2005-05-28T00:13:35.000','2006-02-15T22:14:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5284','196','1','1053','1.99','2005-05-31T07:12:44.000','2006-02-15T22:14:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5285','196','1','1182','5.99','2005-06-15T00:45:21.000','2006-02-15T22:14:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5286','196','1','1348','2.99','2005-06-15T12:45:30.000','2006-02-15T22:14:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5287','196','2','1600','0.99','2005-06-16T06:04:12.000','2006-02-15T22:14:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5288','196','1','2681','0.99','2005-06-19T12:15:27.000','2006-02-15T22:14:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5289','196','2','2912','4.99','2005-06-20T03:32:45.000','2006-02-15T22:14:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5290','196','1','3104','4.99','2005-06-20T17:06:46.000','2006-02-15T22:14:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5291','196','2','3271','5.99','2005-06-21T05:16:10.000','2006-02-15T22:14:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5292','196','2','3342','4.99','2005-06-21T10:46:36.000','2006-02-15T22:14:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5293','196','1','4879','2.99','2005-07-08T19:34:55.000','2006-02-15T22:14:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5294','196','2','4999','4.99','2005-07-09T01:12:57.000','2006-02-15T22:14:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5295','196','2','5143','4.99','2005-07-09T08:07:07.000','2006-02-15T22:14:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5296','196','2','5353','3.99','2005-07-09T18:04:29.000','2006-02-15T22:14:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5297','196','2','5768','4.99','2005-07-10T13:15:26.000','2006-02-15T22:14:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5298','196','2','6857','4.99','2005-07-12T19:53:30.000','2006-02-15T22:14:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5299','196','2','7666','3.99','2005-07-28T02:35:12.000','2006-02-15T22:14:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5300','196','2','8266','0.99','2005-07-29T01:20:16.000','2006-02-15T22:14:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5301','196','2','8472','1.99','2005-07-29T08:36:22.000','2006-02-15T22:14:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5302','196','2','8700','0.99','2005-07-29T16:56:01.000','2006-02-15T22:14:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5303','196','1','9346','5.99','2005-07-30T18:13:52.000','2006-02-15T22:14:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5304','196','1','9721','6.99','2005-07-31T08:28:46.000','2006-02-15T22:14:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5305','196','1','9804','4.99','2005-07-31T11:07:39.000','2006-02-15T22:14:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5306','196','2','10122','10.99','2005-07-31T21:29:28.000','2006-02-15T22:14:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5307','196','1','10191','4.99','2005-08-01T00:28:38.000','2006-02-15T22:14:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5308','196','1','11104','2.99','2005-08-02T08:09:58.000','2006-02-15T22:14:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5309','196','2','12430','0.99','2005-08-18T10:32:41.000','2006-02-15T22:14:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5310','196','2','12684','0.99','2005-08-18T19:51:27.000','2006-02-15T22:14:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5311','196','2','12836','0.99','2005-08-19T01:48:33.000','2006-02-15T22:14:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5312','196','1','13799','8.99','2005-08-20T12:36:42.000','2006-02-15T22:14:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5313','196','2','14410','5.99','2005-08-21T10:54:49.000','2006-02-15T22:14:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5314','196','1','14698','5.99','2005-08-21T20:49:58.000','2006-02-15T22:14:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5315','196','2','15980','0.99','2005-08-23T20:10:13.000','2006-02-15T22:14:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5316','197','2','94','2.99','2005-05-25T16:03:42.000','2006-02-15T22:14:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5317','197','1','215','0.99','2005-05-26T09:02:47.000','2006-02-15T22:14:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5318','197','1','391','2.99','2005-05-27T11:03:55.000','2006-02-15T22:14:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5319','197','2','649','1.99','2005-05-28T19:35:45.000','2006-02-15T22:14:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5320','197','1','683','2.99','2005-05-29T00:09:48.000','2006-02-15T22:14:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5321','197','2','730','3.99','2005-05-29T07:00:59.000','2006-02-15T22:14:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5322','197','1','903','3.99','2005-05-30T10:11:29.000','2006-02-15T22:14:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5323','197','1','918','0.99','2005-05-30T11:32:24.000','2006-02-15T22:14:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5324','197','2','1175','2.99','2005-06-15T00:15:15.000','2006-02-15T22:14:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5325','197','1','1363','0.99','2005-06-15T14:05:11.000','2006-02-15T22:14:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5326','197','1','1503','2.99','2005-06-15T22:07:09.000','2006-02-15T22:14:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5327','197','2','1605','8.99','2005-06-16T06:17:55.000','2006-02-15T22:14:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5328','197','2','1919','4.99','2005-06-17T05:40:52.000','2006-02-15T22:14:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5329','197','1','2090','2.99','2005-06-17T18:06:14.000','2006-02-15T22:14:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5330','197','1','2750','4.99','2005-06-19T16:37:24.000','2006-02-15T22:14:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5331','197','2','2781','2.99','2005-06-19T18:24:42.000','2006-02-15T22:14:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5332','197','1','4486','8.99','2005-07-08T01:09:09.000','2006-02-15T22:14:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5333','197','2','4739','4.99','2005-07-08T13:25:57.000','2006-02-15T22:14:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5334','197','2','5182','6.99','2005-07-09T10:08:10.000','2006-02-15T22:14:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5335','197','2','5344','0.99','2005-07-09T17:27:05.000','2006-02-15T22:14:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5336','197','1','8165','2.99','2005-07-28T21:23:06.000','2006-02-15T22:14:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5337','197','2','9378','4.99','2005-07-30T19:12:54.000','2006-02-15T22:14:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5338','197','1','9476','0.99','2005-07-30T23:06:40.000','2006-02-15T22:14:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5339','197','2','9585','4.99','2005-07-31T03:05:55.000','2006-02-15T22:14:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5340','197','2','10460','3.99','2005-08-01T09:31:00.000','2006-02-15T22:14:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5341','197','2','10666','0.99','2005-08-01T16:56:36.000','2006-02-15T22:14:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5342','197','2','10739','4.99','2005-08-01T19:46:11.000','2006-02-15T22:14:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5343','197','1','10743','2.99','2005-08-01T19:55:09.000','2006-02-15T22:14:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5344','197','1','11018','4.99','2005-08-02T05:27:53.000','2006-02-15T22:14:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5345','197','1','11215','4.99','2005-08-02T12:20:42.000','2006-02-15T22:14:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5346','197','1','11311','4.99','2005-08-02T15:53:48.000','2006-02-15T22:14:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5347','197','1','11478','2.99','2005-08-02T22:09:05.000','2006-02-15T22:14:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5348','197','1','11643','1.99','2005-08-17T04:49:35.000','2006-02-15T22:14:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5349','197','1','12799','0.99','2005-08-19T00:27:01.000','2006-02-15T22:14:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5350','197','2','13913','3.99','2005-08-20T16:37:35.000','2006-02-15T22:14:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5351','197','1','14069','9.99','2005-08-20T22:51:25.000','2006-02-15T22:14:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5352','197','2','14951','4.99','2005-08-22T06:19:37.000','2006-02-15T22:14:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5353','197','1','15078','2.99','2005-08-22T11:09:31.000','2006-02-15T22:14:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5354','197','2','15233','0.99','2005-08-22T17:41:53.000','2006-02-15T22:14:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5355','197','1','15540','8.99','2005-08-23T04:12:52.000','2006-02-15T22:14:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5356','198','1','357','0.99','2005-05-27T06:37:15.000','2006-02-15T22:14:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5357','198','1','582','4.99','2005-05-28T11:33:46.000','2006-02-15T22:14:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5358','198','2','639','2.99','2005-05-28T18:25:02.000','2006-02-15T22:14:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5359','198','1','932','2.99','2005-05-30T12:55:36.000','2006-02-15T22:14:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5360','198','2','1132','4.99','2005-05-31T18:44:53.000','2006-02-15T22:14:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5361','198','2','2185','0.99','2005-06-18T01:12:22.000','2006-02-15T22:14:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5362','198','2','3770','2.99','2005-07-06T13:14:28.000','2006-02-15T22:14:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5363','198','2','4588','2.99','2005-07-08T06:18:01.000','2006-02-15T22:14:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5364','198','2','4750','0.99','2005-07-08T14:07:03.000','2006-02-15T22:14:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5365','198','2','5794','4.99','2005-07-10T14:34:53.000','2006-02-15T22:14:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5366','198','2','6567','4.99','2005-07-12T05:43:09.000','2006-02-15T22:14:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5367','198','1','6819','4.99','2005-07-12T18:21:01.000','2006-02-15T22:14:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5368','198','2','6889','4.99','2005-07-12T21:01:22.000','2006-02-15T22:14:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5369','198','1','7287','0.99','2005-07-27T12:24:12.000','2006-02-15T22:14:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5370','198','1','7441','5.99','2005-07-27T17:46:53.000','2006-02-15T22:14:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5371','198','1','7583','2.99','2005-07-27T23:15:22.000','2006-02-15T22:14:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5372','198','2','7622','0.99','2005-07-28T00:37:34.000','2006-02-15T22:14:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5373','198','1','8145','5.99','2005-07-28T20:34:41.000','2006-02-15T22:14:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5374','198','2','9389','0.99','2005-07-30T19:27:59.000','2006-02-15T22:14:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5375','198','1','10112','4.99','2005-07-31T21:08:56.000','2006-02-15T22:14:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5376','198','1','10147','2.99','2005-07-31T22:18:43.000','2006-02-15T22:14:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5377','198','1','10679','0.99','2005-08-01T17:27:58.000','2006-02-15T22:14:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5378','198','1','11351','3.99','2005-08-02T17:28:07.000','2006-02-15T22:14:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5379','198','1','11594','6.99','2005-08-17T02:47:02.000','2006-02-15T22:14:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5380','198','1','11756','2.99','2005-08-17T09:29:22.000','2006-02-15T22:14:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5381','198','1','11836','4.99','2005-08-17T13:03:36.000','2006-02-15T22:14:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5382','198','2','11949','2.99','2005-08-17T17:12:26.000','2006-02-15T22:14:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5383','198','1','11957','1.99','2005-08-17T17:22:29.000','2006-02-15T22:14:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5384','198','2','11985','2.99','2005-08-17T18:19:44.000','2006-02-15T22:14:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5385','198','2','12594','4.99','2005-08-18T16:24:24.000','2006-02-15T22:14:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5386','198','1','12862','5.99','2005-08-19T02:31:59.000','2006-02-15T22:14:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5387','198','1','13768','5.99','2005-08-20T11:43:43.000','2006-02-15T22:14:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5388','198','1','14214','5.99','2005-08-21T04:30:49.000','2006-02-15T22:14:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5389','198','2','14380','2.99','2005-08-21T09:53:52.000','2006-02-15T22:14:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5390','198','2','14990','4.99','2005-08-22T07:48:01.000','2006-02-15T22:14:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5391','198','1','15256','6.99','2005-08-22T18:20:07.000','2006-02-15T22:14:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5392','198','1','15433','4.99','2005-08-23T00:27:18.000','2006-02-15T22:14:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5393','199','1','499','7.99','2005-05-28T01:05:07.000','2006-02-15T22:14:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5394','199','1','1406','4.99','2005-06-15T16:44:00.000','2006-02-15T22:14:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5395','199','1','1910','2.99','2005-06-17T05:11:27.000','2006-02-15T22:14:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5396','199','1','3299','0.99','2005-06-21T07:23:34.000','2006-02-15T22:14:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5397','199','1','4499','2.99','2005-07-08T02:08:48.000','2006-02-15T22:14:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5398','199','2','4580','8.99','2005-07-08T06:04:23.000','2006-02-15T22:14:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5399','199','1','4976','4.99','2005-07-09T00:03:30.000','2006-02-15T22:14:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5400','199','2','5398','2.99','2005-07-09T19:44:58.000','2006-02-15T22:14:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5401','199','2','5680','5.99','2005-07-10T08:47:36.000','2006-02-15T22:14:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5402','199','2','6668','2.99','2005-07-12T11:37:45.000','2006-02-15T22:14:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5403','199','2','6782','4.99','2005-07-12T16:23:25.000','2006-02-15T22:14:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5404','199','1','7782','4.99','2005-07-28T07:13:40.000','2006-02-15T22:14:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5405','199','1','8709','0.99','2005-07-29T17:25:54.000','2006-02-15T22:14:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5406','199','1','9752','2.99','2005-07-31T09:22:02.000','2006-02-15T22:14:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5407','199','2','9894','4.99','2005-07-31T14:07:44.000','2006-02-15T22:14:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5408','199','1','9959','4.99','2005-07-31T16:04:22.000','2006-02-15T22:14:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5409','199','1','10196','2.99','2005-08-01T00:34:51.000','2006-02-15T22:14:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5410','199','2','10517','4.99','2005-08-01T11:41:57.000','2006-02-15T22:14:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5411','199','1','10850','8.99','2005-08-01T23:53:45.000','2006-02-15T22:14:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5412','199','1','11454','2.99','2005-08-02T21:04:39.000','2006-02-15T22:14:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5413','199','1','12386','0.99','2005-08-18T08:45:57.000','2006-02-15T22:14:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5414','199','2','14320','4.99','2005-08-21T08:04:40.000','2006-02-15T22:14:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5415','199','2','15412','0.99','2005-08-22T23:37:11.000','2006-02-15T22:14:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5416','199','2','15751','3.99','2005-08-23T12:41:07.000','2006-02-15T22:14:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5417','199','2','13952','2.99','2006-02-14T15:16:03.000','2006-02-15T22:14:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5418','200','2','270','9.99','2005-05-26T16:20:56.000','2006-02-15T22:14:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5419','200','2','1296','1.99','2005-06-15T09:23:59.000','2006-02-15T22:14:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5420','200','2','1309','4.99','2005-06-15T10:10:49.000','2006-02-15T22:14:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5421','200','2','1899','6.99','2005-06-17T04:29:15.000','2006-02-15T22:14:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5422','200','1','2227','4.99','2005-06-18T03:43:23.000','2006-02-15T22:14:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5423','200','2','2667','3.99','2005-06-19T11:28:46.000','2006-02-15T22:14:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5424','200','2','2717','4.99','2005-06-19T14:46:10.000','2006-02-15T22:14:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5425','200','1','3190','3.99','2005-06-20T23:27:15.000','2006-02-15T22:14:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5426','200','1','3580','4.99','2005-07-06T03:48:44.000','2006-02-15T22:14:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5427','200','1','5110','2.99','2005-07-09T06:57:25.000','2006-02-15T22:14:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5428','200','1','6123','0.99','2005-07-11T08:02:27.000','2006-02-15T22:14:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5429','200','2','6167','2.99','2005-07-11T10:21:21.000','2006-02-15T22:14:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5430','200','1','6181','4.99','2005-07-11T11:10:11.000','2006-02-15T22:14:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5431','200','1','6947','3.99','2005-07-26T23:42:03.000','2006-02-15T22:14:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5432','200','1','7574','2.99','2005-07-27T22:53:00.000','2006-02-15T22:14:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5433','200','2','8368','3.99','2005-07-29T05:15:41.000','2006-02-15T22:14:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5434','200','2','8462','2.99','2005-07-29T08:15:42.000','2006-02-15T22:14:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5435','200','1','9527','6.99','2005-07-31T01:02:24.000','2006-02-15T22:14:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5436','200','1','10685','2.99','2005-08-01T17:49:38.000','2006-02-15T22:14:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5437','200','1','11356','8.99','2005-08-02T17:42:40.000','2006-02-15T22:14:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5438','200','1','13737','5.99','2005-08-20T10:41:50.000','2006-02-15T22:14:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5439','200','1','14034','10.99','2005-08-20T21:31:52.000','2006-02-15T22:14:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5440','200','2','14521','6.99','2005-08-21T15:01:32.000','2006-02-15T22:14:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5441','200','2','15691','4.99','2005-08-23T09:53:54.000','2006-02-15T22:14:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5442','200','2','15742','5.99','2005-08-23T12:11:37.000','2006-02-15T22:14:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5443','200','1','15961','6.99','2005-08-23T19:35:42.000','2006-02-15T22:14:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5444','200','2','11866','2.99','2006-02-14T15:16:03.000','2006-02-15T22:14:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5445','201','1','311','3.99','2005-05-26T22:51:37.000','2006-02-15T22:14:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5446','201','1','670','6.99','2005-05-28T22:04:03.000','2006-02-15T22:14:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5447','201','2','756','5.99','2005-05-29T10:28:45.000','2006-02-15T22:14:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5448','201','1','2047','1.99','2005-06-17T14:40:58.000','2006-02-15T22:14:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5449','201','1','2157','3.99','2005-06-17T23:30:52.000','2006-02-15T22:14:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5450','201','2','2359','6.99','2005-06-18T13:04:42.000','2006-02-15T22:14:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5451','201','1','3106','4.99','2005-06-20T17:18:06.000','2006-02-15T22:14:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5452','201','1','3364','7.99','2005-06-21T12:37:46.000','2006-02-15T22:14:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5453','201','2','3528','4.99','2005-07-06T01:13:27.000','2006-02-15T22:14:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5454','201','2','3708','6.99','2005-07-06T10:23:27.000','2006-02-15T22:14:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5455','201','1','7106','0.99','2005-07-27T05:21:24.000','2006-02-15T22:14:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5456','201','2','7606','2.99','2005-07-28T00:02:15.000','2006-02-15T22:14:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5457','201','2','9355','0.99','2005-07-30T18:35:25.000','2006-02-15T22:14:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5458','201','2','10750','5.99','2005-08-01T20:06:00.000','2006-02-15T22:14:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5459','201','2','10865','3.99','2005-08-02T00:22:46.000','2006-02-15T22:14:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5460','201','1','10891','0.99','2005-08-02T01:09:55.000','2006-02-15T22:14:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5461','201','2','11807','0.99','2005-08-17T11:51:15.000','2006-02-15T22:14:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5462','201','2','13076','4.99','2005-08-19T10:10:26.000','2006-02-15T22:14:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5463','201','2','13613','9.99','2005-08-20T06:23:53.000','2006-02-15T22:14:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5464','201','2','13671','3.99','2005-08-20T08:27:03.000','2006-02-15T22:14:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5465','201','2','13672','2.99','2005-08-20T08:27:27.000','2006-02-15T22:14:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5466','201','2','14656','2.99','2005-08-21T19:39:28.000','2006-02-15T22:14:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5467','201','1','14973','2.99','2005-08-22T06:59:28.000','2006-02-15T22:14:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5468','201','1','15887','2.99','2005-08-23T16:54:09.000','2006-02-15T22:14:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5469','201','2','15974','5.99','2005-08-23T20:06:04.000','2006-02-15T22:14:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5470','202','1','1474','2.99','2005-06-15T20:55:42.000','2006-02-15T22:14:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5471','202','1','1535','4.99','2005-06-16T00:52:04.000','2006-02-15T22:14:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5472','202','1','3008','0.99','2005-06-20T10:23:25.000','2006-02-15T22:14:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5473','202','2','3148','0.99','2005-06-20T20:27:18.000','2006-02-15T22:14:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5474','202','1','3861','8.99','2005-07-06T17:24:49.000','2006-02-15T22:14:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5475','202','2','4567','4.99','2005-07-08T05:20:04.000','2006-02-15T22:14:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5476','202','2','5194','2.99','2005-07-09T10:31:34.000','2006-02-15T22:14:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5477','202','1','5297','2.99','2005-07-09T15:32:29.000','2006-02-15T22:14:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5478','202','2','5838','2.99','2005-07-10T17:04:56.000','2006-02-15T22:14:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5479','202','1','7613','2.99','2005-07-28T00:13:58.000','2006-02-15T22:14:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5480','202','1','8351','2.99','2005-07-29T04:50:53.000','2006-02-15T22:14:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5481','202','1','8779','2.99','2005-07-29T20:15:00.000','2006-02-15T22:14:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5482','202','1','8830','2.99','2005-07-29T22:34:35.000','2006-02-15T22:14:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5483','202','2','8930','0.99','2005-07-30T02:28:38.000','2006-02-15T22:14:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5484','202','2','9057','2.99','2005-07-30T07:14:18.000','2006-02-15T22:14:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5485','202','2','9467','8.99','2005-07-30T22:45:34.000','2006-02-15T22:14:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5486','202','2','9751','4.99','2005-07-31T09:20:50.000','2006-02-15T22:14:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5487','202','1','10375','2.99','2005-08-01T06:26:22.000','2006-02-15T22:14:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5488','202','1','11210','4.99','2005-08-02T12:15:54.000','2006-02-15T22:14:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5489','202','2','11924','4.99','2005-08-17T16:22:05.000','2006-02-15T22:14:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5490','202','2','12801','8.99','2005-08-19T00:27:19.000','2006-02-15T22:14:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5491','202','1','13196','4.99','2005-08-19T14:40:32.000','2006-02-15T22:14:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5492','202','1','13528','3.99','2005-08-20T03:03:31.000','2006-02-15T22:14:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5493','202','1','14019','3.99','2005-08-20T20:59:15.000','2006-02-15T22:14:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5494','202','1','15095','0.99','2005-08-22T11:41:35.000','2006-02-15T22:14:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5495','202','2','15772','4.99','2005-08-23T13:22:56.000','2006-02-15T22:14:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5496','203','1','314','0.99','2005-05-26T23:09:41.000','2006-02-15T22:14:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5497','203','1','1217','4.99','2005-06-15T03:24:14.000','2006-02-15T22:14:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5498','203','1','1715','2.99','2005-06-16T14:37:12.000','2006-02-15T22:14:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5499','203','2','2939','7.99','2005-06-20T05:18:16.000','2006-02-15T22:14:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5500','203','2','3406','2.99','2005-06-21T16:00:18.000','2006-02-15T22:14:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5501','203','2','4136','2.99','2005-07-07T08:15:52.000','2006-02-15T22:14:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5502','203','2','5579','5.99','2005-07-10T04:04:29.000','2006-02-15T22:14:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5503','203','2','7787','6.99','2005-07-28T07:19:02.000','2006-02-15T22:14:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5504','203','1','8039','0.99','2005-07-28T16:35:16.000','2006-02-15T22:14:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5505','203','1','8463','4.99','2005-07-29T08:17:51.000','2006-02-15T22:14:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5506','203','1','8792','7.99','2005-07-29T20:56:14.000','2006-02-15T22:14:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5507','203','2','9015','10.99','2005-07-30T05:21:32.000','2006-02-15T22:14:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5508','203','2','10700','3.99','2005-08-01T18:26:31.000','2006-02-15T22:14:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5509','203','2','10805','2.99','2005-08-01T22:23:37.000','2006-02-15T22:14:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5510','203','1','11712','2.99','2005-08-17T07:32:51.000','2006-02-15T22:14:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5511','203','1','12519','0.99','2005-08-18T13:42:14.000','2006-02-15T22:14:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5512','203','2','13841','4.99','2005-08-20T14:25:18.000','2006-02-15T22:14:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5513','203','2','14505','5.99','2005-08-21T14:26:28.000','2006-02-15T22:14:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5514','203','2','15798','2.99','2005-08-23T14:23:03.000','2006-02-15T22:14:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5515','203','2','15991','2.99','2005-08-23T20:27:34.000','2006-02-15T22:14:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5516','204','2','251','0.99','2005-05-26T14:35:40.000','2006-02-15T22:14:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5517','204','2','399','4.99','2005-05-27T12:48:38.000','2006-02-15T22:14:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5518','204','2','857','4.99','2005-05-30T02:01:23.000','2006-02-15T22:14:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5519','204','1','1016','1.99','2005-05-31T02:49:43.000','2006-02-15T22:14:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5520','204','1','1321','2.99','2005-06-15T10:49:17.000','2006-02-15T22:14:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5521','204','1','1616','7.99','2005-06-16T07:04:52.000','2006-02-15T22:14:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5522','204','1','1871','4.99','2005-06-17T02:25:12.000','2006-02-15T22:14:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5523','204','2','1894','7.99','2005-06-17T04:18:48.000','2006-02-15T22:14:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5524','204','2','2186','2.99','2005-06-18T01:15:27.000','2006-02-15T22:14:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5525','204','2','2734','4.99','2005-06-19T15:36:27.000','2006-02-15T22:14:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5526','204','1','4043','0.99','2005-07-07T03:09:50.000','2006-02-15T22:14:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5527','204','1','4979','4.99','2005-07-09T00:24:34.000','2006-02-15T22:14:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5528','204','2','5145','0.99','2005-07-09T08:13:25.000','2006-02-15T22:14:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5529','204','1','5619','2.99','2005-07-10T05:29:33.000','2006-02-15T22:14:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5530','204','2','6004','4.99','2005-07-11T01:34:25.000','2006-02-15T22:14:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5531','204','2','6225','2.99','2005-07-11T13:45:14.000','2006-02-15T22:14:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5532','204','2','6631','0.99','2005-07-12T09:31:43.000','2006-02-15T22:14:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5533','204','1','6694','6.99','2005-07-12T12:39:23.000','2006-02-15T22:14:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5534','204','2','6871','2.99','2005-07-12T20:13:49.000','2006-02-15T22:14:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5535','204','1','7392','4.99','2005-07-27T16:01:05.000','2006-02-15T22:14:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5536','204','2','9005','0.99','2005-07-30T05:04:58.000','2006-02-15T22:14:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5537','204','1','9394','5.99','2005-07-30T20:06:24.000','2006-02-15T22:14:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5538','204','2','9906','4.99','2005-07-31T14:38:12.000','2006-02-15T22:14:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5539','204','2','10042','2.99','2005-07-31T19:01:25.000','2006-02-15T22:14:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5540','204','2','10399','5.99','2005-08-01T07:13:39.000','2006-02-15T22:14:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5541','204','1','11261','7.99','2005-08-02T13:54:26.000','2006-02-15T22:14:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5542','204','2','11886','0.99','2005-08-17T14:58:51.000','2006-02-15T22:14:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5543','204','1','12737','6.99','2005-08-18T22:11:37.000','2006-02-15T22:14:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5544','204','1','13084','0.99','2005-08-19T10:27:25.000','2006-02-15T22:14:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5545','204','1','13416','4.99','2005-08-19T22:48:48.000','2006-02-15T22:14:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5546','204','2','13899','2.99','2005-08-20T16:05:11.000','2006-02-15T22:14:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5547','204','2','14163','4.99','2005-08-21T02:56:52.000','2006-02-15T22:14:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5548','204','1','14871','0.99','2005-08-22T03:23:24.000','2006-02-15T22:14:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5549','204','1','15364','4.99','2005-08-22T21:41:41.000','2006-02-15T22:14:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5550','204','2','15415','11.99','2005-08-22T23:48:56.000','2006-02-15T22:14:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5551','205','1','1238','2.99','2005-06-15T04:49:08.000','2006-02-15T22:14:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5552','205','1','1357','4.99','2005-06-15T13:26:23.000','2006-02-15T22:14:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5553','205','1','1767','0.99','2005-06-16T18:01:36.000','2006-02-15T22:14:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5554','205','2','2237','5.99','2005-06-18T04:17:44.000','2006-02-15T22:14:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5555','205','1','3601','7.99','2005-07-06T05:20:25.000','2006-02-15T22:14:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5556','205','2','4230','3.99','2005-07-07T12:46:47.000','2006-02-15T22:14:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5557','205','2','4377','7.99','2005-07-07T20:28:57.000','2006-02-15T22:14:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5558','205','1','4729','4.99','2005-07-08T12:59:40.000','2006-02-15T22:14:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5559','205','1','7736','2.99','2005-07-28T05:12:04.000','2006-02-15T22:14:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5560','205','2','7976','7.99','2005-07-28T14:13:24.000','2006-02-15T22:14:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5561','205','2','8896','4.99','2005-07-30T00:51:21.000','2006-02-15T22:14:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5562','205','2','10086','4.99','2005-07-31T20:14:08.000','2006-02-15T22:14:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5563','205','1','13935','2.99','2005-08-20T17:20:49.000','2006-02-15T22:14:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5564','205','1','14338','0.99','2005-08-21T08:36:03.000','2006-02-15T22:14:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5565','205','2','14391','4.99','2005-08-21T10:16:27.000','2006-02-15T22:14:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5566','205','1','14442','2.99','2005-08-21T12:00:21.000','2006-02-15T22:14:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5567','205','2','14490','6.99','2005-08-21T13:54:15.000','2006-02-15T22:14:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5568','205','2','15418','0.99','2005-08-22T23:54:14.000','2006-02-15T22:14:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5569','206','2','1872','0.99','2005-06-17T02:27:03.000','2006-02-15T22:14:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5570','206','2','2477','5.99','2005-06-18T20:58:46.000','2006-02-15T22:14:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5571','206','2','3012','4.99','2005-06-20T10:43:13.000','2006-02-15T22:14:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5572','206','1','3533','5.99','2005-07-06T01:26:44.000','2006-02-15T22:14:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5573','206','2','3831','0.99','2005-07-06T16:06:35.000','2006-02-15T22:14:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5574','206','1','3847','4.99','2005-07-06T16:44:41.000','2006-02-15T22:14:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5575','206','2','4068','4.99','2005-07-07T04:34:38.000','2006-02-15T22:14:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5576','206','2','4107','4.99','2005-07-07T06:36:32.000','2006-02-15T22:14:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5577','206','2','4823','4.99','2005-07-08T17:28:54.000','2006-02-15T22:14:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5578','206','1','6139','3.99','2005-07-11T08:39:33.000','2006-02-15T22:14:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5579','206','1','6420','6.99','2005-07-11T23:38:49.000','2006-02-15T22:14:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5580','206','1','7222','4.99','2005-07-27T09:38:43.000','2006-02-15T22:14:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5581','206','2','7541','4.99','2005-07-27T21:40:05.000','2006-02-15T22:14:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5582','206','1','8217','5.99','2005-07-28T23:44:13.000','2006-02-15T22:14:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5583','206','1','8549','3.99','2005-07-29T11:12:13.000','2006-02-15T22:14:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5584','206','2','9474','2.99','2005-07-30T23:05:44.000','2006-02-15T22:14:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5585','206','2','10930','3.99','2005-08-02T02:38:07.000','2006-02-15T22:14:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5586','206','1','11022','2.99','2005-08-02T05:35:03.000','2006-02-15T22:14:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5587','206','2','11634','2.99','2005-08-17T04:31:49.000','2006-02-15T22:14:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5588','206','1','13128','4.99','2005-08-19T12:04:16.000','2006-02-15T22:14:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5589','206','2','13232','2.99','2005-08-19T16:13:32.000','2006-02-15T22:14:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5590','206','2','13263','10.99','2005-08-19T17:26:55.000','2006-02-15T22:14:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5591','206','2','13550','9.99','2005-08-20T03:58:51.000','2006-02-15T22:14:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5592','206','2','13696','0.99','2005-08-20T09:16:15.000','2006-02-15T22:14:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5593','206','2','14695','0.99','2005-08-21T20:46:47.000','2006-02-15T22:14:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5594','206','2','15686','7.99','2005-08-23T09:42:21.000','2006-02-15T22:14:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5595','206','1','15709','4.99','2005-08-23T10:36:00.000','2006-02-15T22:14:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5596','207','1','39','0.99','2005-05-25T04:51:46.000','2006-02-15T22:14:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5597','207','1','44','0.99','2005-05-25T05:53:23.000','2006-02-15T22:14:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5598','207','1','659','0.99','2005-05-28T20:27:53.000','2006-02-15T22:14:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5599','207','2','826','6.99','2005-05-29T21:56:15.000','2006-02-15T22:14:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5600','207','2','896','3.99','2005-05-30T09:03:52.000','2006-02-15T22:14:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5601','207','2','1144','3.99','2005-05-31T20:04:10.000','2006-02-15T22:14:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5602','207','2','1945','3.99','2005-06-17T07:51:26.000','2006-02-15T22:14:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5603','207','2','3584','2.99','2005-07-06T04:16:43.000','2006-02-15T22:14:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5604','207','2','3687','9.99','2005-07-06T09:38:33.000','2006-02-15T22:14:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5605','207','1','4018','2.99','2005-07-07T01:10:33.000','2006-02-15T22:14:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5606','207','2','4713','5.99','2005-07-08T12:12:33.000','2006-02-15T22:14:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5607','207','1','4816','0.99','2005-07-08T17:14:14.000','2006-02-15T22:14:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5608','207','2','5007','0.99','2005-07-09T01:26:22.000','2006-02-15T22:14:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5609','207','1','5258','0.99','2005-07-09T13:56:56.000','2006-02-15T22:14:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5610','207','1','5259','4.99','2005-07-09T14:02:50.000','2006-02-15T22:14:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5611','207','2','5939','0.99','2005-07-10T22:30:05.000','2006-02-15T22:14:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5612','207','2','6465','5.99','2005-07-12T01:17:11.000','2006-02-15T22:14:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5613','207','1','6537','0.99','2005-07-12T04:46:30.000','2006-02-15T22:14:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5614','207','2','7306','5.99','2005-07-27T12:57:26.000','2006-02-15T22:14:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5615','207','1','7540','5.99','2005-07-27T21:39:55.000','2006-02-15T22:14:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5616','207','1','8800','5.99','2005-07-29T21:18:59.000','2006-02-15T22:14:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5617','207','2','9652','2.99','2005-07-31T05:49:53.000','2006-02-15T22:14:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5618','207','2','10234','3.99','2005-08-01T01:56:20.000','2006-02-15T22:14:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5619','207','2','10300','0.99','2005-08-01T04:08:11.000','2006-02-15T22:14:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5620','207','1','11112','2.99','2005-08-02T08:25:14.000','2006-02-15T22:14:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5621','207','2','11260','0.99','2005-08-02T13:52:19.000','2006-02-15T22:14:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5622','207','2','11286','5.99','2005-08-02T14:44:22.000','2006-02-15T22:14:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5623','207','1','11724','6.99','2005-08-17T08:04:44.000','2006-02-15T22:14:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5624','207','2','12108','6.99','2005-08-17T22:56:39.000','2006-02-15T22:14:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5625','207','2','13655','2.99','2005-08-20T07:59:13.000','2006-02-15T22:14:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5626','207','2','13809','8.99','2005-08-20T12:56:03.000','2006-02-15T22:14:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5627','207','2','13912','9.99','2005-08-20T16:32:10.000','2006-02-15T22:14:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5628','207','2','13954','3.99','2005-08-20T18:02:41.000','2006-02-15T22:14:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5629','207','1','15625','1.99','2005-08-23T07:25:29.000','2006-02-15T22:14:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5630','208','1','100','4.99','2005-05-25T16:50:28.000','2006-02-15T22:14:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5631','208','1','1805','0.99','2005-06-16T20:36:00.000','2006-02-15T22:14:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5632','208','1','1949','5.99','2005-06-17T08:19:22.000','2006-02-15T22:14:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5633','208','2','2592','0.99','2005-06-19T05:36:54.000','2006-02-15T22:14:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5634','208','1','2695','2.99','2005-06-19T13:25:53.000','2006-02-15T22:14:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5635','208','2','2907','0.99','2005-06-20T03:15:09.000','2006-02-15T22:14:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5636','208','2','3811','2.99','2005-07-06T15:20:37.000','2006-02-15T22:14:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5637','208','1','4354','5.99','2005-07-07T19:21:02.000','2006-02-15T22:14:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5638','208','2','4985','4.99','2005-07-09T00:36:02.000','2006-02-15T22:14:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5639','208','1','5117','2.99','2005-07-09T07:11:22.000','2006-02-15T22:14:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5640','208','2','5693','2.99','2005-07-10T09:35:43.000','2006-02-15T22:14:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5641','208','2','6306','6.99','2005-07-11T18:04:26.000','2006-02-15T22:14:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5642','208','1','6767','1.99','2005-07-12T15:46:55.000','2006-02-15T22:14:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5643','208','1','7315','0.99','2005-07-27T13:14:56.000','2006-02-15T22:14:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5644','208','1','7861','2.99','2005-07-28T10:02:01.000','2006-02-15T22:14:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5645','208','2','7984','2.99','2005-07-28T14:27:51.000','2006-02-15T22:14:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5646','208','1','8742','1.99','2005-07-29T18:56:12.000','2006-02-15T22:14:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5647','208','2','9298','3.99','2005-07-30T16:27:53.000','2006-02-15T22:14:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5648','208','1','9838','4.99','2005-07-31T12:18:49.000','2006-02-15T22:14:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5649','208','2','10762','4.99','2005-08-01T20:28:39.000','2006-02-15T22:14:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5650','208','2','10784','5.99','2005-08-01T21:24:28.000','2006-02-15T22:14:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5651','208','2','11442','2.99','2005-08-02T20:26:19.000','2006-02-15T22:14:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5652','208','2','11805','6.99','2005-08-17T11:48:47.000','2006-02-15T22:14:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5653','208','2','11819','0.99','2005-08-17T12:25:17.000','2006-02-15T22:14:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5654','208','1','13719','5.98','2006-02-14T15:16:03.000','2006-02-15T22:14:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5655','208','1','15717','0','2006-02-14T15:16:03.000','2006-02-15T22:14:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5656','209','2','340','9.99','2005-05-27T03:55:25.000','2006-02-15T22:14:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5657','209','1','471','0.99','2005-05-27T21:32:42.000','2006-02-15T22:14:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5658','209','2','1143','2.99','2005-05-31T19:53:03.000','2006-02-15T22:14:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5659','209','2','1201','4.99','2005-06-15T02:06:28.000','2006-02-15T22:14:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5660','209','1','1657','4.99','2005-06-16T10:06:49.000','2006-02-15T22:14:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5661','209','1','2650','4.99','2005-06-19T10:21:45.000','2006-02-15T22:14:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5662','209','1','2796','4.99','2005-06-19T19:00:37.000','2006-02-15T22:14:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5663','209','2','3504','2.99','2005-07-06T00:18:29.000','2006-02-15T22:14:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5664','209','2','4071','5.99','2005-07-07T04:37:26.000','2006-02-15T22:14:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5665','209','1','4309','5.99','2005-07-07T17:29:41.000','2006-02-15T22:14:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5666','209','2','4810','4.99','2005-07-08T17:04:06.000','2006-02-15T22:14:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5667','209','1','4907','4.99','2005-07-08T21:01:41.000','2006-02-15T22:14:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5668','209','2','5170','3.99','2005-07-09T09:24:19.000','2006-02-15T22:14:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5669','209','2','5219','5.99','2005-07-09T11:57:55.000','2006-02-15T22:14:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5670','209','1','6210','0.99','2005-07-11T12:36:43.000','2006-02-15T22:14:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5671','209','1','7116','6.99','2005-07-27T05:46:43.000','2006-02-15T22:14:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5672','209','1','7269','3.99','2005-07-27T11:23:47.000','2006-02-15T22:14:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5673','209','1','7505','4.99','2005-07-27T20:28:03.000','2006-02-15T22:14:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5674','209','2','7752','5.99','2005-07-28T06:01:00.000','2006-02-15T22:14:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5675','209','1','8067','4.99','2005-07-28T17:20:17.000','2006-02-15T22:14:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5676','209','2','8759','8.99','2005-07-29T19:22:37.000','2006-02-15T22:14:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5677','209','2','8816','2.99','2005-07-29T21:53:00.000','2006-02-15T22:14:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5678','209','2','9054','6.99','2005-07-30T07:11:44.000','2006-02-15T22:14:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5679','209','1','9923','0.99','2005-07-31T15:00:15.000','2006-02-15T22:14:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5680','209','2','10554','2.99','2005-08-01T12:56:19.000','2006-02-15T22:14:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5681','209','1','10646','4.99','2005-08-01T15:57:55.000','2006-02-15T22:14:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5682','209','2','10811','6.99','2005-08-01T22:41:15.000','2006-02-15T22:14:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5683','209','1','12025','0.99','2005-08-17T19:59:06.000','2006-02-15T22:14:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5684','209','1','13796','8.99','2005-08-20T12:32:32.000','2006-02-15T22:14:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5685','209','2','14631','6.99','2005-08-21T18:47:49.000','2006-02-15T22:14:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5686','209','1','15254','2.99','2005-08-22T18:13:07.000','2006-02-15T22:14:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5687','209','2','15510','9.99','2005-08-23T02:51:27.000','2006-02-15T22:14:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5688','210','1','953','2.99','2005-05-30T16:34:02.000','2006-02-15T22:14:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5689','210','2','1177','2.99','2005-06-15T00:33:04.000','2006-02-15T22:14:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5690','210','2','2856','0.99','2005-06-19T23:13:04.000','2006-02-15T22:14:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5691','210','2','3563','4.99','2005-07-06T02:57:01.000','2006-02-15T22:14:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5692','210','2','3884','4.99','2005-07-06T18:41:33.000','2006-02-15T22:14:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5693','210','2','4270','0.99','2005-07-07T14:38:41.000','2006-02-15T22:14:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5694','210','1','4306','2.99','2005-07-07T17:12:32.000','2006-02-15T22:14:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5695','210','1','4334','0.99','2005-07-07T18:32:04.000','2006-02-15T22:14:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5696','210','2','4388','7.99','2005-07-07T20:58:03.000','2006-02-15T22:14:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5697','210','1','4620','5.99','2005-07-08T08:01:44.000','2006-02-15T22:14:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5698','210','1','4871','6.99','2005-07-08T19:19:52.000','2006-02-15T22:14:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5699','210','1','4893','4.99','2005-07-08T20:19:55.000','2006-02-15T22:14:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5700','210','1','4989','3.99','2005-07-09T00:46:56.000','2006-02-15T22:14:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5701','210','2','5957','0.99','2005-07-10T23:24:02.000','2006-02-15T22:14:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5702','210','2','6227','4.99','2005-07-11T13:56:46.000','2006-02-15T22:14:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5703','210','1','6564','1.99','2005-07-12T05:34:44.000','2006-02-15T22:14:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5704','210','1','7743','5.99','2005-07-28T05:36:13.000','2006-02-15T22:14:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5705','210','2','7909','0.99','2005-07-28T11:38:08.000','2006-02-15T22:14:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5706','210','2','8336','8.99','2005-07-29T04:20:42.000','2006-02-15T22:14:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5707','210','2','8678','3.99','2005-07-29T16:04:00.000','2006-02-15T22:14:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5708','210','2','8738','0.99','2005-07-29T18:32:47.000','2006-02-15T22:14:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5709','210','2','10890','4.99','2005-08-02T00:58:46.000','2006-02-15T22:14:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5710','210','2','12410','8.99','2005-08-18T09:45:33.000','2006-02-15T22:14:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5711','210','1','12879','4.99','2005-08-19T03:22:55.000','2006-02-15T22:14:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5712','210','2','12909','2.99','2005-08-19T04:20:25.000','2006-02-15T22:14:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5713','210','2','12986','4.99','2005-08-19T07:09:36.000','2006-02-15T22:14:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5714','210','1','14181','7.99','2005-08-21T03:16:30.000','2006-02-15T22:14:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5715','210','2','14639','6.99','2005-08-21T19:01:39.000','2006-02-15T22:14:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5716','210','2','14876','4.99','2005-08-22T03:39:29.000','2006-02-15T22:14:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5717','210','2','15672','0.99','2005-08-23T09:09:18.000','2006-02-15T22:14:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5718','210','2','15942','8.99','2005-08-23T18:48:40.000','2006-02-15T22:14:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5719','211','1','238','4.99','2005-05-26T12:30:22.000','2006-02-15T22:14:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5720','211','2','2812','8.99','2005-06-19T19:58:16.000','2006-02-15T22:14:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5721','211','2','3437','6.99','2005-06-21T19:20:17.000','2006-02-15T22:14:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5722','211','2','3937','8.99','2005-07-06T21:15:38.000','2006-02-15T22:14:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5723','211','2','4060','2.99','2005-07-07T04:10:13.000','2006-02-15T22:14:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5724','211','2','4441','5.99','2005-07-07T23:04:23.000','2006-02-15T22:14:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5725','211','2','4479','2.99','2005-07-08T00:52:35.000','2006-02-15T22:14:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5726','211','1','4857','2.99','2005-07-08T18:52:07.000','2006-02-15T22:14:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5727','211','1','5668','5.99','2005-07-10T08:11:05.000','2006-02-15T22:14:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5728','211','2','5699','3.99','2005-07-10T09:48:04.000','2006-02-15T22:14:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5729','211','2','5785','4.99','2005-07-10T14:06:03.000','2006-02-15T22:14:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5730','211','2','6438','0.99','2005-07-12T00:23:01.000','2006-02-15T22:14:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5731','211','1','6628','4.99','2005-07-12T09:18:08.000','2006-02-15T22:14:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5732','211','1','6722','1.99','2005-07-12T13:44:03.000','2006-02-15T22:14:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5733','211','2','7484','0.99','2005-07-27T19:28:17.000','2006-02-15T22:14:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5734','211','1','7975','2.99','2005-07-28T14:12:47.000','2006-02-15T22:14:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5735','211','2','8961','6.99','2005-07-30T03:43:35.000','2006-02-15T22:14:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5736','211','1','9111','3.99','2005-07-30T09:05:44.000','2006-02-15T22:14:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5737','211','1','9953','0.99','2005-07-31T15:56:35.000','2006-02-15T22:14:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5738','211','1','10445','2.99','2005-08-01T09:02:15.000','2006-02-15T22:14:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5739','211','2','10928','4.99','2005-08-02T02:34:12.000','2006-02-15T22:14:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5740','211','2','11076','8.99','2005-08-02T07:24:47.000','2006-02-15T22:14:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5741','211','2','11963','3.99','2005-08-17T17:35:47.000','2006-02-15T22:14:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5742','211','2','12311','0.99','2005-08-18T06:07:00.000','2006-02-15T22:14:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5743','211','2','12565','4.99','2005-08-18T15:12:17.000','2006-02-15T22:14:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5744','211','2','12570','5.99','2005-08-18T15:23:31.000','2006-02-15T22:14:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5745','211','2','13942','2.99','2005-08-20T17:30:52.000','2006-02-15T22:14:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5746','211','1','13979','2.99','2005-08-20T19:03:49.000','2006-02-15T22:14:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5747','211','2','14782','0.99','2005-08-22T00:17:20.000','2006-02-15T22:14:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5748','211','2','14812','1.99','2005-08-22T01:10:32.000','2006-02-15T22:14:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5749','211','1','15404','7.99','2005-08-22T23:19:44.000','2006-02-15T22:14:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5750','211','2','15538','6.99','2005-08-23T04:07:37.000','2006-02-15T22:14:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5751','211','2','15670','5.99','2005-08-23T09:07:11.000','2006-02-15T22:14:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5752','211','2','12746','4.99','2006-02-14T15:16:03.000','2006-02-15T22:14:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5753','212','1','1356','0.99','2005-06-15T13:17:01.000','2006-02-15T22:14:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5754','212','2','1379','0.99','2005-06-15T15:05:10.000','2006-02-15T22:14:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5755','212','1','1637','2.99','2005-06-16T08:29:58.000','2006-02-15T22:14:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5756','212','2','2739','9.99','2005-06-19T15:58:38.000','2006-02-15T22:14:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5757','212','2','4708','10.99','2005-07-08T11:59:19.000','2006-02-15T22:14:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5758','212','2','4798','3.99','2005-07-08T16:45:16.000','2006-02-15T22:14:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5759','212','2','4916','6.99','2005-07-08T21:32:17.000','2006-02-15T22:14:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5760','212','1','5115','6.99','2005-07-09T07:07:18.000','2006-02-15T22:14:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5761','212','2','7828','2.99','2005-07-28T08:40:46.000','2006-02-15T22:14:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5762','212','2','8000','4.99','2005-07-28T15:10:25.000','2006-02-15T22:14:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5763','212','1','8940','3.99','2005-07-30T02:57:26.000','2006-02-15T22:14:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5764','212','2','10273','4.99','2005-08-01T03:14:47.000','2006-02-15T22:14:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5765','212','2','10567','0.99','2005-08-01T13:16:01.000','2006-02-15T22:14:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5766','212','1','12156','7.99','2005-08-18T00:27:33.000','2006-02-15T22:14:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5767','212','2','12467','0.99','2005-08-18T11:40:09.000','2006-02-15T22:14:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5768','212','2','12562','3.99','2005-08-18T15:00:03.000','2006-02-15T22:14:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5769','212','1','14563','2.99','2005-08-21T16:23:53.000','2006-02-15T22:14:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5770','212','2','14681','5.99','2005-08-21T20:25:13.000','2006-02-15T22:14:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5771','212','1','15872','4.99','2005-08-23T16:27:24.000','2006-02-15T22:14:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5772','212','2','15920','2.99','2005-08-23T18:05:10.000','2006-02-15T22:14:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5773','213','2','385','0.99','2005-05-27T10:23:25.000','2006-02-15T22:14:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5774','213','1','1489','0.99','2005-06-15T21:41:38.000','2006-02-15T22:14:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5775','213','2','1936','4.99','2005-06-17T07:15:41.000','2006-02-15T22:14:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5776','213','1','2322','5.99','2005-06-18T09:44:21.000','2006-02-15T22:14:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5777','213','1','2509','0.99','2005-06-18T23:44:08.000','2006-02-15T22:14:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5778','213','2','2569','6.99','2005-06-19T04:19:04.000','2006-02-15T22:14:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5779','213','1','2889','4.99','2005-06-20T01:54:08.000','2006-02-15T22:14:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5780','213','2','2946','4.99','2005-06-20T05:50:40.000','2006-02-15T22:14:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5781','213','1','3252','2.99','2005-06-21T03:25:26.000','2006-02-15T22:14:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5782','213','1','3313','2.99','2005-06-21T08:11:18.000','2006-02-15T22:14:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5783','213','2','3989','4.99','2005-07-06T23:30:54.000','2006-02-15T22:14:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5784','213','2','4236','4.99','2005-07-07T13:12:07.000','2006-02-15T22:14:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5785','213','1','4655','8.99','2005-07-08T09:49:22.000','2006-02-15T22:14:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5786','213','2','5159','4.99','2005-07-09T08:55:52.000','2006-02-15T22:14:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5787','213','1','5431','0.99','2005-07-09T21:21:11.000','2006-02-15T22:14:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5788','213','2','6725','2.99','2005-07-12T13:47:17.000','2006-02-15T22:14:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5789','213','2','7528','0.99','2005-07-27T21:15:25.000','2006-02-15T22:14:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5790','213','2','8444','2.99','2005-07-29T07:36:13.000','2006-02-15T22:14:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5791','213','2','8542','4.99','2005-07-29T11:01:50.000','2006-02-15T22:14:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5792','213','2','9150','6.99','2005-07-30T10:49:32.000','2006-02-15T22:14:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5793','213','2','9340','2.99','2005-07-30T18:07:16.000','2006-02-15T22:14:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5794','213','1','9477','4.99','2005-07-30T23:07:22.000','2006-02-15T22:14:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5795','213','1','10449','2.99','2005-08-01T09:09:59.000','2006-02-15T22:14:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5796','213','2','11778','3.99','2005-08-17T10:31:40.000','2006-02-15T22:14:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5797','213','1','13354','4.99','2005-08-19T20:55:23.000','2006-02-15T22:14:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5798','213','2','13426','0.99','2005-08-19T23:15:00.000','2006-02-15T22:14:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5799','213','1','14744','6.99','2005-08-21T22:45:21.000','2006-02-15T22:14:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5800','213','2','14374','2.99','2006-02-14T15:16:03.000','2006-02-15T22:14:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5801','214','1','242','1.99','2005-05-26T13:05:08.000','2006-02-15T22:14:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5802','214','1','278','3.99','2005-05-26T17:40:58.000','2006-02-15T22:14:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5803','214','1','1076','2.99','2005-05-31T10:14:31.000','2006-02-15T22:14:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5804','214','2','1093','2.99','2005-05-31T12:32:26.000','2006-02-15T22:14:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5805','214','2','1112','0.99','2005-05-31T15:51:39.000','2006-02-15T22:14:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5806','214','2','1275','4.99','2005-06-15T07:55:43.000','2006-02-15T22:14:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5807','214','2','2085','2.99','2005-06-17T17:30:56.000','2006-02-15T22:14:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5808','214','2','2868','2.99','2005-06-20T00:08:58.000','2006-02-15T22:14:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5809','214','2','4211','0.99','2005-07-07T11:50:41.000','2006-02-15T22:14:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5810','214','1','4783','3.99','2005-07-08T16:09:24.000','2006-02-15T22:14:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5811','214','2','4984','3.99','2005-07-09T00:35:31.000','2006-02-15T22:14:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5812','214','2','5172','2.99','2005-07-09T09:31:27.000','2006-02-15T22:14:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5813','214','1','6602','7.99','2005-07-12T07:50:24.000','2006-02-15T22:14:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5814','214','2','7417','4.99','2005-07-27T16:58:33.000','2006-02-15T22:14:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5815','214','2','7826','5.99','2005-07-28T08:35:51.000','2006-02-15T22:14:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5816','214','1','8663','4.99','2005-07-29T15:33:18.000','2006-02-15T22:14:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5817','214','1','10563','3.99','2005-08-01T13:06:03.000','2006-02-15T22:14:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5818','214','2','10749','4.99','2005-08-01T20:02:01.000','2006-02-15T22:14:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5819','214','2','11450','2.99','2005-08-02T20:45:54.000','2006-02-15T22:14:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5820','214','2','11474','4.99','2005-08-02T21:53:08.000','2006-02-15T22:14:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5821','214','2','12463','4.99','2005-08-18T11:31:34.000','2006-02-15T22:14:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5822','214','2','13138','2.99','2005-08-19T12:30:01.000','2006-02-15T22:14:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5823','214','2','13350','9.99','2005-08-19T20:44:00.000','2006-02-15T22:14:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5824','214','1','13409','2.99','2005-08-19T22:36:26.000','2006-02-15T22:14:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5825','214','1','13565','0.99','2005-08-20T04:38:52.000','2006-02-15T22:14:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5826','214','1','13726','0.99','2005-08-20T10:08:40.000','2006-02-15T22:14:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5827','214','1','13864','4.99','2005-08-20T14:59:55.000','2006-02-15T22:14:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5828','214','2','14347','4.99','2005-08-21T08:42:31.000','2006-02-15T22:14:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5829','214','1','14567','0.99','2005-08-21T16:27:25.000','2006-02-15T22:14:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5830','214','2','15639','2.99','2005-08-23T08:03:25.000','2006-02-15T22:14:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5831','214','2','15645','2.99','2006-02-14T15:16:03.000','2006-02-15T22:14:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5832','215','1','711','4.99','2005-05-29T03:49:03.000','2006-02-15T22:14:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5833','215','2','1080','4.99','2005-05-31T10:55:26.000','2006-02-15T22:14:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5834','215','2','1376','4.99','2005-06-15T14:59:06.000','2006-02-15T22:14:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5835','215','2','1599','4.99','2005-06-16T06:03:33.000','2006-02-15T22:14:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5836','215','2','1845','4.99','2005-06-16T23:56:11.000','2006-02-15T22:14:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5837','215','2','2006','2.99','2005-06-17T11:47:03.000','2006-02-15T22:14:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5838','215','2','2918','2.99','2005-06-20T04:09:04.000','2006-02-15T22:14:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5839','215','1','3143','2.99','2005-06-20T20:01:52.000','2006-02-15T22:14:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5840','215','2','4940','8.99','2005-07-08T22:36:06.000','2006-02-15T22:14:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5841','215','1','5886','2.99','2005-07-10T19:36:25.000','2006-02-15T22:14:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5842','215','2','5967','8.99','2005-07-11T00:02:19.000','2006-02-15T22:14:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5843','215','1','7180','1.99','2005-07-27T08:14:34.000','2006-02-15T22:14:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5844','215','2','9046','2.99','2005-07-30T06:46:55.000','2006-02-15T22:14:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5845','215','1','9518','0.99','2005-07-31T00:43:26.000','2006-02-15T22:14:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5846','215','2','9611','4.99','2005-07-31T03:54:43.000','2006-02-15T22:14:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5847','215','1','11729','2.99','2005-08-17T08:14:41.000','2006-02-15T22:14:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5848','215','2','12285','2.99','2005-08-18T04:56:43.000','2006-02-15T22:14:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5849','215','1','12380','1.99','2005-08-18T08:27:28.000','2006-02-15T22:14:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5850','215','2','13085','0.99','2005-08-19T10:28:22.000','2006-02-15T22:14:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5851','215','2','14126','0.99','2005-08-21T01:32:17.000','2006-02-15T22:14:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5852','215','2','14817','4.99','2005-08-22T01:17:16.000','2006-02-15T22:14:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5853','215','1','15583','2.99','2005-08-23T05:47:55.000','2006-02-15T22:14:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5854','215','2','15610','2.99','2005-08-23T06:56:15.000','2006-02-15T22:14:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5855','215','2','15799','2.99','2005-08-23T14:23:23.000','2006-02-15T22:14:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5856','215','1','15843','0.99','2005-08-23T15:37:31.000','2006-02-15T22:14:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5857','215','2','15862','0.99','2006-02-14T15:16:03.000','2006-02-15T22:14:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5858','216','1','997','4.99','2005-05-31T00:08:25.000','2006-02-15T22:14:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5859','216','2','1461','6.99','2005-06-15T20:32:08.000','2006-02-15T22:14:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5860','216','1','1664','0.99','2005-06-16T10:15:20.000','2006-02-15T22:14:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5861','216','1','1672','3.99','2005-06-16T10:37:34.000','2006-02-15T22:14:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5862','216','2','2351','0.99','2005-06-18T12:27:57.000','2006-02-15T22:14:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5863','216','1','3432','2.99','2005-06-21T19:02:03.000','2006-02-15T22:14:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5864','216','2','4161','2.99','2005-07-07T09:15:11.000','2006-02-15T22:14:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5865','216','1','6008','6.99','2005-07-11T01:51:29.000','2006-02-15T22:14:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5866','216','2','6349','7.99','2005-07-11T20:25:05.000','2006-02-15T22:14:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5867','216','1','8068','4.99','2005-07-28T17:22:28.000','2006-02-15T22:14:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5868','216','2','8859','8.99','2005-07-29T23:44:43.000','2006-02-15T22:14:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5869','216','1','9096','0.99','2005-07-30T08:39:23.000','2006-02-15T22:14:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5870','216','1','10506','4.99','2005-08-01T11:16:05.000','2006-02-15T22:14:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5871','216','1','11005','0.99','2005-08-02T05:05:23.000','2006-02-15T22:14:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5872','216','2','11621','7.99','2005-08-17T04:13:45.000','2006-02-15T22:14:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5873','216','2','13424','0.99','2005-08-19T23:10:09.000','2006-02-15T22:14:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5874','216','2','14638','2.99','2005-08-21T19:01:36.000','2006-02-15T22:14:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5875','216','2','14726','4.99','2005-08-21T22:08:52.000','2006-02-15T22:14:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5876','216','1','15192','4.99','2005-08-22T16:06:23.000','2006-02-15T22:14:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5877','216','2','15199','2.99','2005-08-22T16:17:49.000','2006-02-15T22:14:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5878','216','2','15934','4.99','2005-08-23T18:40:41.000','2006-02-15T22:14:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5879','216','1','12970','5.98','2006-02-14T15:16:03.000','2006-02-15T22:14:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5880','216','1','11676','0','2006-02-14T15:16:03.000','2006-02-15T22:14:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5881','217','2','828','2.99','2005-05-29T22:14:55.000','2006-02-15T22:14:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5882','217','2','1141','8.99','2005-05-31T19:42:02.000','2006-02-15T22:14:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5883','217','1','1322','2.99','2005-06-15T10:55:09.000','2006-02-15T22:14:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5884','217','1','2076','6.99','2005-06-17T16:43:47.000','2006-02-15T22:14:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5885','217','1','2842','4.99','2005-06-19T22:34:20.000','2006-02-15T22:14:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5886','217','2','5576','2.99','2005-07-10T03:57:05.000','2006-02-15T22:14:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5887','217','2','5762','3.99','2005-07-10T12:48:01.000','2006-02-15T22:14:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5888','217','2','6570','4.99','2005-07-12T05:50:31.000','2006-02-15T22:14:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5889','217','2','7104','2.99','2005-07-27T05:15:25.000','2006-02-15T22:14:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5890','217','2','8332','4.99','2005-07-29T04:16:00.000','2006-02-15T22:14:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5891','217','1','9159','0.99','2005-07-30T11:16:37.000','2006-02-15T22:14:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5892','217','2','9317','2.99','2005-07-30T17:13:37.000','2006-02-15T22:14:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5893','217','2','9632','6.99','2005-07-31T05:02:23.000','2006-02-15T22:14:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5894','217','2','9745','2.99','2005-07-31T09:16:14.000','2006-02-15T22:14:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5895','217','1','10581','5.99','2005-08-01T13:52:30.000','2006-02-15T22:14:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5896','217','1','10836','6.99','2005-08-01T23:29:58.000','2006-02-15T22:14:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5897','217','1','11347','2.99','2005-08-02T17:18:07.000','2006-02-15T22:14:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5898','217','1','11649','2.99','2005-08-17T04:59:26.000','2006-02-15T22:14:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5899','217','1','11958','4.99','2005-08-17T17:23:20.000','2006-02-15T22:14:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5900','217','2','12210','4.99','2005-08-18T02:27:29.000','2006-02-15T22:14:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5901','217','1','12871','4.99','2005-08-19T02:55:36.000','2006-02-15T22:14:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5902','217','2','15116','0.99','2005-08-22T12:35:40.000','2006-02-15T22:14:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5903','217','2','15277','2.99','2005-08-22T19:02:48.000','2006-02-15T22:14:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5904','218','1','1459','2.99','2005-06-15T20:25:53.000','2006-02-15T22:14:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5905','218','1','2262','0.99','2005-06-18T05:49:46.000','2006-02-15T22:14:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5906','218','1','2267','0.99','2005-06-18T06:10:23.000','2006-02-15T22:14:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5907','218','1','4898','6.99','2005-07-08T20:31:43.000','2006-02-15T22:14:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5908','218','1','5226','0.99','2005-07-09T12:10:44.000','2006-02-15T22:14:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5909','218','2','5737','0.99','2005-07-10T11:50:04.000','2006-02-15T22:14:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5910','218','2','7090','4.99','2005-07-27T04:43:53.000','2006-02-15T22:14:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5911','218','1','7236','8.99','2005-07-27T10:09:39.000','2006-02-15T22:14:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5912','218','2','9018','6.99','2005-07-30T05:28:40.000','2006-02-15T22:14:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5913','218','2','9902','6.99','2005-07-31T14:24:33.000','2006-02-15T22:14:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5914','218','1','10114','0.99','2005-07-31T21:12:58.000','2006-02-15T22:14:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5915','218','1','11654','2.99','2005-08-17T05:06:19.000','2006-02-15T22:14:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5916','218','2','12481','2.99','2005-08-18T12:31:34.000','2006-02-15T22:14:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5917','218','1','12974','0.99','2005-08-19T06:51:02.000','2006-02-15T22:14:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5918','218','2','13708','5.99','2005-08-20T09:34:07.000','2006-02-15T22:14:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5919','218','2','13947','5.99','2005-08-20T17:46:06.000','2006-02-15T22:14:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5920','218','2','14848','4.99','2005-08-22T02:14:19.000','2006-02-15T22:14:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5921','218','2','15575','0.99','2005-08-23T05:30:19.000','2006-02-15T22:14:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5922','219','1','414','0.99','2005-05-27T14:48:20.000','2006-02-15T22:14:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5923','219','2','2417','3.99','2005-06-18T17:12:01.000','2006-02-15T22:14:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5924','219','2','2580','0.99','2005-06-19T04:44:30.000','2006-02-15T22:14:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5925','219','2','4678','0.99','2005-07-08T10:30:40.000','2006-02-15T22:14:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5926','219','2','4910','7.99','2005-07-08T21:13:56.000','2006-02-15T22:14:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5927','219','2','5123','0.99','2005-07-09T07:20:30.000','2006-02-15T22:14:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5928','219','2','5416','4.99','2005-07-09T20:33:50.000','2006-02-15T22:14:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5929','219','2','5475','4.99','2005-07-09T23:31:38.000','2006-02-15T22:14:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5930','219','2','5739','7.99','2005-07-10T11:51:50.000','2006-02-15T22:14:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5931','219','2','6172','4.99','2005-07-11T10:32:09.000','2006-02-15T22:14:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5932','219','1','6209','2.99','2005-07-11T12:36:05.000','2006-02-15T22:14:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5933','219','2','6501','1.99','2005-07-12T03:11:55.000','2006-02-15T22:14:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5934','219','2','7335','2.99','2005-07-27T14:06:50.000','2006-02-15T22:14:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5935','219','1','7726','5.99','2005-07-28T04:52:19.000','2006-02-15T22:14:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5936','219','1','8430','0.99','2005-07-29T07:12:17.000','2006-02-15T22:14:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5937','219','2','8536','4.99','2005-07-29T10:37:23.000','2006-02-15T22:14:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5938','219','1','8652','6.99','2005-07-29T15:02:54.000','2006-02-15T22:14:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5939','219','1','9712','4.99','2005-07-31T08:13:11.000','2006-02-15T22:14:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5940','219','1','11328','2.99','2005-08-02T16:42:38.000','2006-02-15T22:14:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5941','219','2','11791','0.99','2005-08-17T11:01:11.000','2006-02-15T22:14:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5942','219','1','13765','4.99','2005-08-20T11:39:00.000','2006-02-15T22:14:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5943','219','2','14029','0.99','2005-08-20T21:23:11.000','2006-02-15T22:14:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5944','219','1','14588','5.99','2005-08-21T17:25:53.000','2006-02-15T22:14:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5945','219','1','14688','4.99','2005-08-21T20:32:37.000','2006-02-15T22:14:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5946','219','1','15283','4.99','2005-08-22T19:16:04.000','2006-02-15T22:14:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5947','219','1','11577','4.99','2006-02-14T15:16:03.000','2006-02-15T22:14:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5948','220','2','409','0.99','2005-05-27T14:10:58.000','2006-02-15T22:14:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5949','220','1','480','3.99','2005-05-27T22:47:39.000','2006-02-15T22:14:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5950','220','1','1832','0.99','2005-06-16T22:35:20.000','2006-02-15T22:14:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5951','220','2','4918','2.99','2005-07-08T21:37:31.000','2006-02-15T22:14:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5952','220','2','5613','2.99','2005-07-10T05:15:43.000','2006-02-15T22:14:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5953','220','2','5847','2.99','2005-07-10T17:27:42.000','2006-02-15T22:14:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5954','220','2','5859','0.99','2005-07-10T18:02:02.000','2006-02-15T22:14:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5955','220','2','6412','0.99','2005-07-11T23:19:21.000','2006-02-15T22:14:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5956','220','2','6832','8.99','2005-07-12T18:51:41.000','2006-02-15T22:14:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5957','220','2','7750','9.99','2005-07-28T05:55:30.000','2006-02-15T22:14:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5958','220','1','8065','2.99','2005-07-28T17:15:48.000','2006-02-15T22:14:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5959','220','1','8398','4.99','2005-07-29T06:12:40.000','2006-02-15T22:14:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5960','220','2','9384','7.99','2005-07-30T19:25:35.000','2006-02-15T22:14:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5961','220','2','9455','10.99','2005-07-30T22:20:29.000','2006-02-15T22:14:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5962','220','1','10099','2.99','2005-07-31T20:47:14.000','2006-02-15T22:14:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5963','220','2','10778','4.99','2005-08-01T21:11:39.000','2006-02-15T22:14:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5964','220','1','10948','4.99','2005-08-02T03:23:23.000','2006-02-15T22:14:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5965','220','1','11037','0.99','2005-08-02T05:58:12.000','2006-02-15T22:14:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5966','220','1','11153','3.99','2005-08-02T09:54:19.000','2006-02-15T22:14:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5967','220','1','11622','4.99','2005-08-17T04:15:46.000','2006-02-15T22:14:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5968','220','2','11947','2.99','2005-08-17T17:08:13.000','2006-02-15T22:14:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5969','220','1','12407','4.99','2005-08-18T09:39:26.000','2006-02-15T22:14:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5970','220','1','12896','4.99','2005-08-19T03:52:44.000','2006-02-15T22:14:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5971','220','2','13123','2.99','2005-08-19T11:55:13.000','2006-02-15T22:14:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5972','220','1','13281','2.99','2005-08-19T18:07:47.000','2006-02-15T22:14:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5973','220','2','14016','4.99','2005-08-20T20:52:03.000','2006-02-15T22:14:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5974','220','2','15706','4.99','2005-08-23T10:32:52.000','2006-02-15T22:14:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5975','221','2','226','4.99','2005-05-26T10:44:04.000','2006-02-15T22:14:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5976','221','1','1369','0.99','2005-06-15T14:29:14.000','2006-02-15T22:14:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5977','221','1','2331','2.99','2005-06-18T10:50:09.000','2006-02-15T22:14:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5978','221','2','2473','2.99','2005-06-18T20:42:45.000','2006-02-15T22:14:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5979','221','1','2660','10.99','2005-06-19T10:50:02.000','2006-02-15T22:14:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5980','221','1','3200','5.99','2005-06-21T00:22:47.000','2006-02-15T22:14:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5981','221','1','4293','4.99','2005-07-07T15:53:47.000','2006-02-15T22:14:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5982','221','2','4649','4.99','2005-07-08T09:32:05.000','2006-02-15T22:14:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5983','221','1','4693','6.99','2005-07-08T11:07:36.000','2006-02-15T22:14:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5984','221','1','5058','5.99','2005-07-09T04:20:35.000','2006-02-15T22:14:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5985','221','2','5920','5.99','2005-07-10T21:33:58.000','2006-02-15T22:14:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5986','221','1','7101','2.99','2005-07-27T05:06:34.000','2006-02-15T22:14:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5987','221','1','7129','0.99','2005-07-27T06:18:01.000','2006-02-15T22:14:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5988','221','2','7531','8.99','2005-07-27T21:19:34.000','2006-02-15T22:14:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5989','221','2','8486','0.99','2005-07-29T08:53:38.000','2006-02-15T22:14:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5990','221','1','9320','6.99','2005-07-30T17:16:39.000','2006-02-15T22:14:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5991','221','1','9453','7.99','2005-07-30T22:20:04.000','2006-02-15T22:14:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5992','221','2','9853','0.99','2005-07-31T12:58:20.000','2006-02-15T22:14:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5993','221','2','11680','4.99','2005-08-17T06:12:27.000','2006-02-15T22:14:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5994','221','1','11693','4.99','2005-08-17T06:56:56.000','2006-02-15T22:14:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5995','221','1','11802','2.99','2005-08-17T11:32:51.000','2006-02-15T22:14:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5996','221','1','12324','0.99','2005-08-18T06:38:20.000','2006-02-15T22:14:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5997','221','2','12620','3.99','2005-08-18T17:26:38.000','2006-02-15T22:14:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5998','221','2','13434','2.99','2005-08-19T23:34:26.000','2006-02-15T22:14:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('5999','221','2','14322','5.99','2005-08-21T08:06:30.000','2006-02-15T22:14:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6000','221','2','14371','0.99','2005-08-21T09:37:16.000','2006-02-15T22:14:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6001','221','1','14419','7.99','2005-08-21T11:15:46.000','2006-02-15T22:14:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6002','221','1','15125','8.99','2005-08-22T12:53:22.000','2006-02-15T22:14:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6003','222','1','5','6.99','2005-05-24T23:05:21.000','2006-02-15T22:14:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6004','222','1','134','4.99','2005-05-25T21:48:41.000','2006-02-15T22:14:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6005','222','2','416','0.99','2005-05-27T15:02:10.000','2006-02-15T22:14:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6006','222','2','809','3.99','2005-05-29T19:10:20.000','2006-02-15T22:14:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6007','222','2','1006','2.99','2005-05-31T00:57:08.000','2006-02-15T22:14:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6008','222','1','1368','8.99','2005-06-15T14:27:47.000','2006-02-15T22:14:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6009','222','2','2603','6.99','2005-06-19T06:21:25.000','2006-02-15T22:14:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6010','222','2','5209','8.99','2005-07-09T11:22:39.000','2006-02-15T22:14:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6011','222','1','5266','3.99','2005-07-09T14:17:40.000','2006-02-15T22:14:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6012','222','2','5592','6.99','2005-07-10T04:26:13.000','2006-02-15T22:14:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6013','222','2','5635','5.99','2005-07-10T06:28:39.000','2006-02-15T22:14:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6014','222','2','6129','2.99','2005-07-11T08:15:09.000','2006-02-15T22:14:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6015','222','1','6497','0.99','2005-07-12T03:04:29.000','2006-02-15T22:14:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6016','222','2','7786','0.99','2005-07-28T07:18:26.000','2006-02-15T22:14:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6017','222','1','8300','1.99','2005-07-29T02:57:59.000','2006-02-15T22:14:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6018','222','2','8597','6.99','2005-07-29T12:55:55.000','2006-02-15T22:14:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6019','222','1','8787','4.99','2005-07-29T20:43:49.000','2006-02-15T22:14:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6020','222','2','10043','1.99','2005-07-31T19:02:07.000','2006-02-15T22:14:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6021','222','2','12179','2.99','2005-08-18T01:21:21.000','2006-02-15T22:14:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6022','222','1','13477','2.99','2005-08-20T01:07:00.000','2006-02-15T22:14:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6023','222','2','14350','2.99','2005-08-21T08:58:38.000','2006-02-15T22:14:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6024','223','2','524','2.99','2005-05-28T03:57:28.000','2006-02-15T22:14:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6025','223','2','1839','5.99','2005-06-16T23:22:22.000','2006-02-15T22:14:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6026','223','1','2334','4.99','2005-06-18T10:56:24.000','2006-02-15T22:14:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6027','223','1','3513','5.99','2005-07-06T00:45:57.000','2006-02-15T22:14:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6028','223','1','3705','0.99','2005-07-06T10:17:59.000','2006-02-15T22:14:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6029','223','1','4874','4.99','2005-07-08T19:23:38.000','2006-02-15T22:14:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6030','223','2','5996','2.99','2005-07-11T01:18:33.000','2006-02-15T22:14:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6031','223','2','7085','5.99','2005-07-27T04:35:44.000','2006-02-15T22:14:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6032','223','2','8362','3.99','2005-07-29T05:09:11.000','2006-02-15T22:14:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6033','223','2','10053','7.99','2005-07-31T19:15:39.000','2006-02-15T22:14:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6034','223','2','11040','4.99','2005-08-02T06:03:22.000','2006-02-15T22:14:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6035','223','1','12927','5.99','2005-08-19T05:02:46.000','2006-02-15T22:14:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6036','223','1','13576','0.99','2005-08-20T05:19:56.000','2006-02-15T22:14:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6037','223','2','14496','4.99','2005-08-21T14:07:35.000','2006-02-15T22:14:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6038','223','1','15257','7.99','2005-08-22T18:21:04.000','2006-02-15T22:14:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6039','223','2','15546','5.99','2005-08-23T04:20:38.000','2006-02-15T22:14:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6040','223','1','15662','2.99','2005-08-23T08:52:50.000','2006-02-15T22:14:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6041','224','1','1424','7.99','2005-06-15T18:08:14.000','2006-02-15T22:14:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6042','224','1','2277','2.99','2005-06-18T06:35:03.000','2006-02-15T22:14:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6043','224','2','3282','4.99','2005-06-21T06:18:42.000','2006-02-15T22:14:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6044','224','1','4118','2.99','2005-07-07T07:03:30.000','2006-02-15T22:14:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6045','224','2','4411','3.99','2005-07-07T21:54:58.000','2006-02-15T22:14:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6046','224','1','4697','2.99','2005-07-08T11:19:14.000','2006-02-15T22:14:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6047','224','1','6031','4.99','2005-07-11T02:42:14.000','2006-02-15T22:14:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6048','224','2','6999','2.99','2005-07-27T01:21:19.000','2006-02-15T22:14:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6049','224','2','8255','0.99','2005-07-29T01:02:30.000','2006-02-15T22:14:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6050','224','2','8439','2.99','2005-07-29T07:28:43.000','2006-02-15T22:14:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6051','224','1','8605','4.99','2005-07-29T13:13:34.000','2006-02-15T22:14:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6052','224','1','9181','0.99','2005-07-30T12:05:58.000','2006-02-15T22:14:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6053','224','1','11816','0.99','2005-08-17T12:14:16.000','2006-02-15T22:14:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6054','224','1','12492','4.99','2005-08-18T12:49:04.000','2006-02-15T22:14:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6055','224','1','12969','2.99','2005-08-19T06:38:59.000','2006-02-15T22:14:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6056','224','2','13075','4.99','2005-08-19T10:10:10.000','2006-02-15T22:14:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6057','224','2','14099','0.99','2005-08-21T00:31:03.000','2006-02-15T22:14:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6058','224','2','14271','5.99','2005-08-21T06:23:29.000','2006-02-15T22:14:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6059','224','2','14468','5.99','2005-08-21T13:07:10.000','2006-02-15T22:14:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6060','224','2','14880','2.99','2005-08-22T03:44:36.000','2006-02-15T22:14:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6061','224','1','15225','0.99','2005-08-22T17:18:32.000','2006-02-15T22:14:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6062','224','1','15952','1.99','2005-08-23T19:11:29.000','2006-02-15T22:14:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6063','225','1','812','4.99','2005-05-29T20:00:30.000','2006-02-15T22:14:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6064','225','1','963','3.99','2005-05-30T18:52:53.000','2006-02-15T22:14:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6065','225','2','2226','7.99','2005-06-18T03:39:56.000','2006-02-15T22:14:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6066','225','2','3574','4.99','2005-07-06T03:36:01.000','2006-02-15T22:14:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6067','225','1','4345','7.99','2005-07-07T18:52:57.000','2006-02-15T22:14:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6068','225','1','4824','7.99','2005-07-08T17:37:39.000','2006-02-15T22:14:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6069','225','2','4955','2.99','2005-07-08T23:16:21.000','2006-02-15T22:14:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6070','225','1','5067','4.99','2005-07-09T04:52:35.000','2006-02-15T22:14:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6071','225','1','6159','2.99','2005-07-11T09:55:34.000','2006-02-15T22:14:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6072','225','1','6317','2.99','2005-07-11T18:47:41.000','2006-02-15T22:14:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6073','225','2','6350','2.99','2005-07-11T20:30:15.000','2006-02-15T22:14:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6074','225','1','6526','3.99','2005-07-12T04:21:20.000','2006-02-15T22:14:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6075','225','2','6532','2.99','2005-07-12T04:38:32.000','2006-02-15T22:14:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6076','225','2','7347','4.99','2005-07-27T14:31:24.000','2006-02-15T22:14:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6077','225','1','7524','6.99','2005-07-27T21:11:44.000','2006-02-15T22:14:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6078','225','1','8054','7.99','2005-07-28T17:02:18.000','2006-02-15T22:14:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6079','225','2','8110','4.99','2005-07-28T19:07:45.000','2006-02-15T22:14:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6080','225','1','9980','4.99','2005-07-31T17:02:00.000','2006-02-15T22:14:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6081','225','2','9993','2.99','2005-07-31T17:30:20.000','2006-02-15T22:14:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6082','225','2','10138','2.99','2005-07-31T22:02:09.000','2006-02-15T22:14:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6083','225','1','10793','2.99','2005-08-01T21:48:03.000','2006-02-15T22:14:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6084','225','2','11333','1.99','2005-08-02T16:53:00.000','2006-02-15T22:14:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6085','225','2','11384','0.99','2005-08-02T18:23:01.000','2006-02-15T22:14:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6086','225','2','11395','5.99','2005-08-02T18:47:44.000','2006-02-15T22:14:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6087','225','2','11437','4.99','2005-08-02T20:20:06.000','2006-02-15T22:14:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6088','225','2','14444','5.99','2005-08-21T12:07:25.000','2006-02-15T22:14:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6089','226','2','3414','2.99','2005-06-21T16:58:50.000','2006-02-15T22:14:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6090','226','1','3466','4.99','2005-06-21T22:13:33.000','2006-02-15T22:14:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6091','226','1','3721','4.99','2005-07-06T11:10:09.000','2006-02-15T22:14:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6092','226','1','4324','4.99','2005-07-07T17:57:56.000','2006-02-15T22:14:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6093','226','1','5282','2.99','2005-07-09T15:01:23.000','2006-02-15T22:14:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6094','226','1','5419','2.99','2005-07-09T20:47:36.000','2006-02-15T22:14:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6095','226','1','6712','9.99','2005-07-12T13:24:47.000','2006-02-15T22:14:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6096','226','2','7288','5.99','2005-07-27T12:24:59.000','2006-02-15T22:14:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6097','226','1','7329','3.99','2005-07-27T13:55:34.000','2006-02-15T22:14:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6098','226','2','8600','2.99','2005-07-29T13:01:19.000','2006-02-15T22:14:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6099','226','1','8627','2.99','2005-07-29T14:05:12.000','2006-02-15T22:14:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6100','226','1','12172','1.99','2005-08-18T01:07:00.000','2006-02-15T22:14:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6101','226','1','14491','6.99','2005-08-21T13:55:39.000','2006-02-15T22:14:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6102','226','1','14708','4.99','2005-08-21T21:07:23.000','2006-02-15T22:14:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6103','226','1','14712','0.99','2005-08-21T21:22:56.000','2006-02-15T22:14:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6104','226','2','14739','0.99','2005-08-21T22:33:22.000','2006-02-15T22:14:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6105','226','2','14934','4.99','2005-08-22T05:47:15.000','2006-02-15T22:14:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6106','226','2','15472','2.99','2005-08-23T01:39:05.000','2006-02-15T22:14:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6107','226','1','15901','4.99','2005-08-23T17:19:17.000','2006-02-15T22:14:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6108','226','1','15986','2.99','2005-08-23T20:20:37.000','2006-02-15T22:14:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6109','226','1','16033','5.99','2005-08-23T22:06:15.000','2006-02-15T22:14:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6110','227','1','111','4.99','2005-05-25T18:45:19.000','2006-02-15T22:14:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6111','227','1','1023','3.99','2005-05-31T03:26:50.000','2006-02-15T22:14:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6112','227','1','1679','2.99','2005-06-16T11:11:01.000','2006-02-15T22:14:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6113','227','2','2155','1.99','2005-06-17T23:07:29.000','2006-02-15T22:14:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6114','227','1','2164','6.99','2005-06-17T23:46:21.000','2006-02-15T22:14:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6115','227','2','3065','0.99','2005-06-20T13:53:53.000','2006-02-15T22:14:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6116','227','1','3576','5.99','2005-07-06T03:40:01.000','2006-02-15T22:14:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6117','227','2','4340','2.99','2005-07-07T18:41:46.000','2006-02-15T22:14:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6118','227','2','4459','4.99','2005-07-07T23:48:52.000','2006-02-15T22:14:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6119','227','1','4680','2.99','2005-07-08T10:35:28.000','2006-02-15T22:14:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6120','227','1','5046','3.99','2005-07-09T03:34:57.000','2006-02-15T22:14:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6121','227','1','7132','7.99','2005-07-27T06:28:34.000','2006-02-15T22:14:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6122','227','1','8219','2.99','2005-07-28T23:46:31.000','2006-02-15T22:14:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6123','227','1','8234','0.99','2005-07-29T00:19:20.000','2006-02-15T22:14:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6124','227','1','8384','0.99','2005-07-29T05:38:43.000','2006-02-15T22:14:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6125','227','2','8417','4.99','2005-07-29T06:53:36.000','2006-02-15T22:14:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6126','227','1','8936','2.99','2005-07-30T02:47:13.000','2006-02-15T22:14:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6127','227','2','9521','2.99','2005-07-31T00:52:24.000','2006-02-15T22:14:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6128','227','2','10999','3.99','2005-08-02T04:53:13.000','2006-02-15T22:14:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6129','227','2','11892','0.99','2005-08-17T15:13:21.000','2006-02-15T22:14:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6130','227','2','13379','4.99','2005-08-19T21:33:39.000','2006-02-15T22:14:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6131','227','2','15406','0.99','2005-08-22T23:21:22.000','2006-02-15T22:14:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6132','227','2','15976','4.99','2005-08-23T20:07:08.000','2006-02-15T22:14:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6133','227','2','13374','4.99','2006-02-14T15:16:03.000','2006-02-15T22:14:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6134','228','2','492','4.99','2005-05-28T00:24:58.000','2006-02-15T22:14:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6135','228','2','1070','0.99','2005-05-31T09:39:56.000','2006-02-15T22:14:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6136','228','2','2284','3.99','2005-06-18T06:59:51.000','2006-02-15T22:14:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6137','228','2','2863','2.99','2005-06-19T23:58:38.000','2006-02-15T22:14:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6138','228','2','2934','2.99','2005-06-20T05:05:53.000','2006-02-15T22:14:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6139','228','2','3433','3.99','2005-06-21T19:07:19.000','2006-02-15T22:14:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6140','228','2','3538','0.99','2005-07-06T01:37:07.000','2006-02-15T22:14:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6141','228','2','3710','8.99','2005-07-06T10:28:53.000','2006-02-15T22:14:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6142','228','1','3715','6.99','2005-07-06T10:51:48.000','2006-02-15T22:14:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6143','228','2','3796','0.99','2005-07-06T14:45:22.000','2006-02-15T22:14:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6144','228','1','4217','3.99','2005-07-07T12:08:59.000','2006-02-15T22:14:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6145','228','1','4636','4.99','2005-07-08T08:44:32.000','2006-02-15T22:14:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6146','228','1','4909','0.99','2005-07-08T21:07:24.000','2006-02-15T22:14:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6147','228','1','5151','2.99','2005-07-09T08:31:03.000','2006-02-15T22:14:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6148','228','1','5320','4.99','2005-07-09T16:23:32.000','2006-02-15T22:14:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6149','228','2','5902','0.99','2005-07-10T20:31:24.000','2006-02-15T22:14:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6150','228','2','6141','1.99','2005-07-11T08:52:16.000','2006-02-15T22:14:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6151','228','1','6948','2.99','2005-07-26T23:43:49.000','2006-02-15T22:14:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6152','228','2','7509','8.99','2005-07-27T20:37:19.000','2006-02-15T22:14:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6153','228','1','7601','0.99','2005-07-27T23:48:15.000','2006-02-15T22:14:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6154','228','1','8147','2.99','2005-07-28T20:37:56.000','2006-02-15T22:14:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6155','228','1','10585','4.99','2005-08-01T14:00:42.000','2006-02-15T22:14:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6156','228','1','12304','0.99','2005-08-18T05:44:29.000','2006-02-15T22:14:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6157','228','2','12952','2.99','2005-08-19T06:00:52.000','2006-02-15T22:14:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6158','228','2','13458','4.99','2005-08-20T00:35:30.000','2006-02-15T22:14:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6159','228','2','12672','3.98','2006-02-14T15:16:03.000','2006-02-15T22:14:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6160','228','1','15234','0','2006-02-14T15:16:03.000','2006-02-15T22:14:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6161','229','1','2200','4.99','2005-06-18T01:59:16.000','2006-02-15T22:14:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6162','229','1','3208','0.99','2005-06-21T00:50:03.000','2006-02-15T22:14:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6163','229','1','3277','7.99','2005-06-21T05:36:37.000','2006-02-15T22:14:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6164','229','2','3280','0.99','2005-06-21T06:08:12.000','2006-02-15T22:14:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6165','229','2','3933','4.99','2005-07-06T21:06:37.000','2006-02-15T22:14:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6166','229','2','4458','2.99','2005-07-07T23:47:47.000','2006-02-15T22:14:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6167','229','1','4515','4.99','2005-07-08T02:42:03.000','2006-02-15T22:14:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6168','229','2','4694','0.99','2005-07-08T11:07:37.000','2006-02-15T22:14:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6169','229','1','5623','2.99','2005-07-10T05:41:38.000','2006-02-15T22:14:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6170','229','2','6155','4.99','2005-07-11T09:45:31.000','2006-02-15T22:14:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6171','229','2','6578','4.99','2005-07-12T06:15:41.000','2006-02-15T22:14:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6172','229','1','6880','2.99','2005-07-12T20:41:35.000','2006-02-15T22:14:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6173','229','2','7305','0.99','2005-07-27T12:57:06.000','2006-02-15T22:14:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6174','229','2','7308','5.99','2005-07-27T13:00:25.000','2006-02-15T22:14:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6175','229','2','7629','0.99','2005-07-28T01:00:09.000','2006-02-15T22:14:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6176','229','2','7640','7.99','2005-07-28T01:14:49.000','2006-02-15T22:14:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6177','229','2','9913','3.99','2005-07-31T14:51:04.000','2006-02-15T22:14:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6178','229','1','11521','4.99','2005-08-17T00:04:54.000','2006-02-15T22:14:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6179','229','1','12866','2.99','2005-08-19T02:39:47.000','2006-02-15T22:14:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6180','229','2','13306','0.99','2005-08-19T18:57:29.000','2006-02-15T22:14:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6181','229','2','13431','4.99','2005-08-19T23:28:15.000','2006-02-15T22:14:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6182','229','1','13679','5.99','2005-08-20T08:39:34.000','2006-02-15T22:14:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6183','229','1','15740','4.99','2005-08-23T12:07:51.000','2006-02-15T22:14:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6184','229','2','15912','2.99','2005-08-23T17:47:40.000','2006-02-15T22:14:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6185','229','2','13295','0.99','2006-02-14T15:16:03.000','2006-02-15T22:14:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6186','230','1','32','0.99','2005-05-25T04:06:21.000','2006-02-15T22:14:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6187','230','1','1078','4.99','2005-05-31T10:28:33.000','2006-02-15T22:14:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6188','230','2','1468','3.99','2005-06-15T20:48:22.000','2006-02-15T22:14:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6189','230','1','1744','4.99','2005-06-16T16:39:58.000','2006-02-15T22:14:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6190','230','2','1793','0.99','2005-06-16T20:07:27.000','2006-02-15T22:14:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6191','230','2','2450','8.99','2005-06-18T19:25:47.000','2006-02-15T22:14:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6192','230','2','2675','0.99','2005-06-19T11:52:15.000','2006-02-15T22:14:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6193','230','1','2777','0.99','2005-06-19T18:16:26.000','2006-02-15T22:14:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6194','230','1','4509','3.99','2005-07-08T02:32:38.000','2006-02-15T22:14:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6195','230','1','4935','0.99','2005-07-08T22:20:56.000','2006-02-15T22:14:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6196','230','1','5045','4.99','2005-07-09T03:33:32.000','2006-02-15T22:14:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6197','230','1','5061','0.99','2005-07-09T04:30:50.000','2006-02-15T22:14:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6198','230','2','5269','2.99','2005-07-09T14:23:05.000','2006-02-15T22:14:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6199','230','2','6126','4.99','2005-07-11T08:06:56.000','2006-02-15T22:14:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6200','230','1','6251','2.99','2005-07-11T15:06:20.000','2006-02-15T22:14:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6201','230','2','7333','4.99','2005-07-27T13:59:11.000','2006-02-15T22:14:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6202','230','2','7390','4.99','2005-07-27T15:59:19.000','2006-02-15T22:14:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6203','230','2','8032','4.99','2005-07-28T16:17:00.000','2006-02-15T22:14:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6204','230','2','8653','0.99','2005-07-29T15:04:23.000','2006-02-15T22:14:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6205','230','1','8815','2.99','2005-07-29T21:51:26.000','2006-02-15T22:14:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6206','230','2','9778','3.99','2005-07-31T10:02:04.000','2006-02-15T22:14:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6207','230','2','10050','3.99','2005-07-31T19:13:29.000','2006-02-15T22:14:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6208','230','1','10057','9.99','2005-07-31T19:20:18.000','2006-02-15T22:14:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6209','230','2','10874','2.99','2005-08-02T00:31:00.000','2006-02-15T22:14:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6210','230','2','11148','5.99','2005-08-02T09:47:08.000','2006-02-15T22:14:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6211','230','1','11552','5.99','2005-08-17T01:04:29.000','2006-02-15T22:14:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6212','230','2','11914','2.99','2005-08-17T16:04:42.000','2006-02-15T22:14:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6213','230','1','12079','1.99','2005-08-17T22:04:17.000','2006-02-15T22:14:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6214','230','2','12523','7.99','2005-08-18T13:45:41.000','2006-02-15T22:14:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6215','230','2','12542','0.99','2005-08-18T14:21:11.000','2006-02-15T22:14:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6216','230','2','14017','0.99','2005-08-20T20:55:32.000','2006-02-15T22:14:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6217','230','1','14073','5.99','2005-08-20T23:12:57.000','2006-02-15T22:14:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6218','230','1','14340','2.99','2005-08-21T08:38:21.000','2006-02-15T22:14:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6219','231','1','329','5.99','2005-05-27T01:57:14.000','2006-02-15T22:14:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6220','231','1','479','6.99','2005-05-27T22:39:10.000','2006-02-15T22:14:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6221','231','1','512','8.99','2005-05-28T03:07:50.000','2006-02-15T22:14:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6222','231','2','2423','0.99','2005-06-18T17:32:08.000','2006-02-15T22:14:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6223','231','2','3561','9.99','2005-07-06T02:54:33.000','2006-02-15T22:14:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6224','231','1','3839','2.99','2005-07-06T16:30:30.000','2006-02-15T22:14:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6225','231','2','4289','0.99','2005-07-07T15:45:58.000','2006-02-15T22:14:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6226','231','2','4969','0.99','2005-07-08T23:51:26.000','2006-02-15T22:14:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6227','231','1','5096','2.99','2005-07-09T06:08:23.000','2006-02-15T22:14:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6228','231','1','5560','5.99','2005-07-10T03:13:24.000','2006-02-15T22:14:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6229','231','1','6862','0.99','2005-07-12T19:58:09.000','2006-02-15T22:14:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6230','231','1','6877','1.99','2005-07-12T20:32:58.000','2006-02-15T22:14:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6231','231','1','8556','0.99','2005-07-29T11:18:27.000','2006-02-15T22:14:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6232','231','2','8949','5.99','2005-07-30T03:17:02.000','2006-02-15T22:14:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6233','231','2','9711','2.99','2005-07-31T08:06:41.000','2006-02-15T22:14:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6234','231','2','11113','2.99','2005-08-02T08:26:24.000','2006-02-15T22:14:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6235','231','1','11202','7.99','2005-08-02T11:51:57.000','2006-02-15T22:14:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6236','231','1','11581','5.99','2005-08-17T02:03:02.000','2006-02-15T22:14:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6237','231','1','12214','0.99','2005-08-18T02:34:22.000','2006-02-15T22:14:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6238','231','2','12230','8.99','2005-08-18T03:11:04.000','2006-02-15T22:14:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6239','231','1','12231','3.99','2005-08-18T03:11:44.000','2006-02-15T22:14:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6240','231','2','13983','6.99','2005-08-20T19:08:32.000','2006-02-15T22:14:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6241','231','1','14026','0.99','2005-08-20T21:21:08.000','2006-02-15T22:14:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6242','231','1','14478','4.99','2005-08-21T13:33:28.000','2006-02-15T22:14:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6243','231','2','14806','2.99','2005-08-22T00:53:08.000','2006-02-15T22:14:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6244','231','1','15389','3.99','2005-08-22T22:51:13.000','2006-02-15T22:14:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6245','232','1','28','4.99','2005-05-25T03:42:37.000','2006-02-15T22:14:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6246','232','1','805','3.99','2005-05-29T18:18:18.000','2006-02-15T22:14:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6247','232','2','1619','0.99','2005-06-16T07:14:13.000','2006-02-15T22:14:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6248','232','1','2833','8.99','2005-06-19T21:34:54.000','2006-02-15T22:14:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6249','232','2','6234','5.99','2005-07-11T14:16:10.000','2006-02-15T22:14:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6250','232','1','6309','2.99','2005-07-11T18:13:24.000','2006-02-15T22:14:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6251','232','1','7123','5.99','2005-07-27T06:08:48.000','2006-02-15T22:14:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6252','232','2','7653','4.99','2005-07-28T01:58:30.000','2006-02-15T22:14:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6253','232','2','7707','0.99','2005-07-28T04:07:47.000','2006-02-15T22:14:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6254','232','1','7749','2.99','2005-07-28T05:53:36.000','2006-02-15T22:14:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6255','232','1','7990','2.99','2005-07-28T14:43:08.000','2006-02-15T22:14:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6256','232','1','8306','2.99','2005-07-29T03:12:26.000','2006-02-15T22:14:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6257','232','2','8401','4.99','2005-07-29T06:25:08.000','2006-02-15T22:14:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6258','232','2','8655','4.99','2005-07-29T15:04:42.000','2006-02-15T22:14:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6259','232','2','9270','0.99','2005-07-30T15:03:16.000','2006-02-15T22:14:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6260','232','2','9330','10.99','2005-07-30T17:44:24.000','2006-02-15T22:14:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6261','232','2','9365','2.99','2005-07-30T18:46:02.000','2006-02-15T22:14:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6262','232','2','10157','2.99','2005-07-31T22:38:48.000','2006-02-15T22:14:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6263','232','1','10539','6.99','2005-08-01T12:23:00.000','2006-02-15T22:14:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6264','232','2','11861','0.99','2005-08-17T13:53:47.000','2006-02-15T22:14:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6265','232','2','12853','2.99','2005-08-19T02:15:32.000','2006-02-15T22:14:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6266','232','2','13707','2.99','2005-08-20T09:33:58.000','2006-02-15T22:14:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6267','232','2','14527','0.99','2005-08-21T15:07:42.000','2006-02-15T22:14:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6268','232','2','14857','0.99','2005-08-22T02:42:39.000','2006-02-15T22:14:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6269','232','2','15553','2.99','2005-08-23T04:33:39.000','2006-02-15T22:14:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6270','233','2','1992','2.99','2005-06-17T10:58:53.000','2006-02-15T22:14:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6271','233','2','2244','2.99','2005-06-18T04:46:33.000','2006-02-15T22:14:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6272','233','1','2424','2.99','2005-06-18T17:35:08.000','2006-02-15T22:14:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6273','233','2','2443','4.99','2005-06-18T18:52:30.000','2006-02-15T22:14:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6274','233','1','3832','2.99','2005-07-06T16:12:23.000','2006-02-15T22:14:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6275','233','1','4015','5.99','2005-07-07T00:59:46.000','2006-02-15T22:14:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6276','233','1','4885','4.99','2005-07-08T19:51:17.000','2006-02-15T22:14:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6277','233','2','5267','5.99','2005-07-09T14:21:10.000','2006-02-15T22:14:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6278','233','1','5846','2.99','2005-07-10T17:25:24.000','2006-02-15T22:14:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6279','233','1','6319','4.99','2005-07-11T18:50:45.000','2006-02-15T22:14:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6280','233','1','6794','2.99','2005-07-12T16:38:23.000','2006-02-15T22:14:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6281','233','1','7056','8.99','2005-07-27T03:46:27.000','2006-02-15T22:14:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6282','233','2','7387','4.99','2005-07-27T15:54:19.000','2006-02-15T22:14:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6283','233','2','8385','5.99','2005-07-29T05:39:16.000','2006-02-15T22:14:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6284','233','2','8530','2.99','2005-07-29T10:26:14.000','2006-02-15T22:14:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6285','233','2','8596','0.99','2005-07-29T12:48:54.000','2006-02-15T22:14:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6286','233','1','9574','0.99','2005-07-31T02:49:20.000','2006-02-15T22:14:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6287','233','1','10582','4.99','2005-08-01T13:54:22.000','2006-02-15T22:14:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6288','233','1','12443','5.99','2005-08-18T10:50:59.000','2006-02-15T22:14:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6289','233','2','14357','2.99','2005-08-21T09:13:09.000','2006-02-15T22:14:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6290','233','2','15285','2.99','2005-08-22T19:17:24.000','2006-02-15T22:14:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6291','233','1','15790','1.99','2005-08-23T14:01:07.000','2006-02-15T22:14:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6292','233','2','15821','0.99','2005-08-23T15:03:58.000','2006-02-15T22:14:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6293','234','2','1125','4.99','2005-05-31T17:23:44.000','2006-02-15T22:14:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6294','234','2','1245','3.99','2005-06-15T05:09:01.000','2006-02-15T22:14:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6295','234','2','1645','0.99','2005-06-16T09:10:06.000','2006-02-15T22:14:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6296','234','1','1674','2.99','2005-06-16T10:57:00.000','2006-02-15T22:14:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6297','234','2','1993','5.99','2005-06-17T10:59:24.000','2006-02-15T22:14:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6298','234','1','2005','4.99','2005-06-17T11:44:54.000','2006-02-15T22:14:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6299','234','2','2511','5.99','2005-06-18T23:45:30.000','2006-02-15T22:14:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6300','234','2','3185','6.99','2005-06-20T22:58:01.000','2006-02-15T22:14:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6301','234','2','3199','4.99','2005-06-21T00:12:40.000','2006-02-15T22:14:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6302','234','2','4686','0.99','2005-07-08T10:53:39.000','2006-02-15T22:14:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6303','234','1','4721','7.99','2005-07-08T12:39:31.000','2006-02-15T22:14:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6304','234','2','10133','5.99','2005-07-31T21:55:07.000','2006-02-15T22:14:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6305','234','2','10541','0.99','2005-08-01T12:24:54.000','2006-02-15T22:14:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6306','234','2','10580','6.99','2005-08-01T13:51:14.000','2006-02-15T22:14:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6307','234','2','10968','7.99','2005-08-02T04:03:13.000','2006-02-15T22:14:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6308','234','1','11050','4.99','2005-08-02T06:17:16.000','2006-02-15T22:14:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6309','234','1','11073','0.99','2005-08-02T07:13:03.000','2006-02-15T22:14:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6310','234','1','11481','3.99','2005-08-02T22:18:41.000','2006-02-15T22:14:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6311','234','1','11882','3.99','2005-08-17T14:33:41.000','2006-02-15T22:14:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6312','234','1','12226','0.99','2005-08-18T03:00:48.000','2006-02-15T22:14:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6313','234','2','12863','4.99','2005-08-19T02:35:59.000','2006-02-15T22:14:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6314','234','1','12921','5.99','2005-08-19T04:47:48.000','2006-02-15T22:14:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6315','234','2','13349','2.99','2005-08-19T20:43:16.000','2006-02-15T22:14:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6316','234','2','15037','5.99','2005-08-22T09:36:33.000','2006-02-15T22:14:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6317','234','1','15129','2.99','2005-08-22T13:03:52.000','2006-02-15T22:14:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6318','234','1','15778','0.99','2006-02-14T15:16:03.000','2006-02-15T22:14:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6319','235','2','807','2.99','2005-05-29T18:50:50.000','2006-02-15T22:14:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6320','235','1','1148','0.99','2005-05-31T20:38:40.000','2006-02-15T22:14:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6321','235','1','1493','4.99','2005-06-15T21:50:32.000','2006-02-15T22:14:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6322','235','2','1811','0.99','2005-06-16T21:06:20.000','2006-02-15T22:14:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6323','235','2','3581','2.99','2005-07-06T03:57:35.000','2006-02-15T22:14:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6324','235','1','3752','6.99','2005-07-06T12:30:12.000','2006-02-15T22:14:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6325','235','1','3968','4.99','2005-07-06T22:47:09.000','2006-02-15T22:14:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6326','235','2','4592','2.99','2005-07-08T06:31:28.000','2006-02-15T22:14:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6327','235','1','5790','4.99','2005-07-10T14:15:21.000','2006-02-15T22:14:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6328','235','1','6047','2.99','2005-07-11T03:27:01.000','2006-02-15T22:14:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6329','235','2','6352','4.99','2005-07-11T20:34:13.000','2006-02-15T22:14:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6330','235','2','6466','4.99','2005-07-12T01:21:03.000','2006-02-15T22:14:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6331','235','1','8120','0.99','2005-07-28T19:24:24.000','2006-02-15T22:14:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6332','235','2','8446','6.99','2005-07-29T07:38:10.000','2006-02-15T22:14:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6333','235','2','8781','0.99','2005-07-29T20:20:16.000','2006-02-15T22:14:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6334','235','1','9019','5.99','2005-07-30T05:28:53.000','2006-02-15T22:14:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6335','235','2','9519','6.99','2005-07-31T00:45:57.000','2006-02-15T22:14:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6336','235','1','9587','3.99','2005-07-31T03:10:30.000','2006-02-15T22:14:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6337','235','2','10155','0.99','2005-07-31T22:31:43.000','2006-02-15T22:14:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6338','235','2','12332','2.99','2005-08-18T06:51:05.000','2006-02-15T22:14:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6339','235','1','12502','4.99','2005-08-18T13:16:31.000','2006-02-15T22:14:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6340','235','2','13070','0.99','2005-08-19T09:56:23.000','2006-02-15T22:14:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6341','235','1','13469','0.99','2005-08-20T00:59:36.000','2006-02-15T22:14:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6342','235','2','14749','3.99','2005-08-21T23:08:33.000','2006-02-15T22:14:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6343','235','1','15034','6.99','2005-08-22T09:33:08.000','2006-02-15T22:14:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6344','236','2','262','2.99','2005-05-26T15:46:56.000','2006-02-15T22:14:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6345','236','2','344','2.99','2005-05-27T04:30:22.000','2006-02-15T22:14:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6346','236','1','1032','2.99','2005-05-31T04:28:43.000','2006-02-15T22:14:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6347','236','1','1262','0.99','2005-06-15T06:54:53.000','2006-02-15T22:14:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6348','236','2','1308','5.99','2005-06-15T10:07:48.000','2006-02-15T22:14:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6349','236','2','2139','8.99','2005-06-17T21:29:34.000','2006-02-15T22:14:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6350','236','2','2311','6.99','2005-06-18T08:51:29.000','2006-02-15T22:14:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6351','236','1','2630','2.99','2005-06-19T08:47:21.000','2006-02-15T22:14:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6352','236','2','2840','3.99','2005-06-19T22:17:44.000','2006-02-15T22:14:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6353','236','1','3353','4.99','2005-06-21T11:29:23.000','2006-02-15T22:14:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6354','236','2','3460','2.99','2005-06-21T21:46:56.000','2006-02-15T22:14:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6355','236','1','3645','0.99','2005-07-06T07:22:09.000','2006-02-15T22:14:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6356','236','2','3857','4.99','2005-07-06T17:07:54.000','2006-02-15T22:14:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6357','236','2','4749','4.99','2005-07-08T14:05:58.000','2006-02-15T22:14:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6358','236','1','4959','0.99','2005-07-08T23:22:23.000','2006-02-15T22:14:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6359','236','1','5404','2.99','2005-07-09T20:10:43.000','2006-02-15T22:14:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6360','236','1','5545','3.99','2005-07-10T02:50:29.000','2006-02-15T22:14:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6361','236','2','5938','3.99','2005-07-10T22:17:42.000','2006-02-15T22:14:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6362','236','2','6049','0.99','2005-07-11T03:32:32.000','2006-02-15T22:14:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6363','236','2','6281','4.99','2005-07-11T16:38:16.000','2006-02-15T22:14:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6364','236','1','6303','2.99','2005-07-11T17:55:43.000','2006-02-15T22:14:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6365','236','2','6996','4.99','2005-07-27T01:13:45.000','2006-02-15T22:14:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6366','236','2','7047','4.99','2005-07-27T03:31:11.000','2006-02-15T22:14:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6367','236','2','7253','0.99','2005-07-27T10:46:37.000','2006-02-15T22:14:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6368','236','1','7780','5.99','2005-07-28T07:11:55.000','2006-02-15T22:14:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6369','236','1','7792','4.99','2005-07-28T07:24:02.000','2006-02-15T22:14:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6370','236','2','7798','2.99','2005-07-28T07:41:59.000','2006-02-15T22:14:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6371','236','1','8657','2.99','2005-07-29T15:09:25.000','2006-02-15T22:14:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6372','236','1','9011','5.99','2005-07-30T05:16:29.000','2006-02-15T22:14:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6373','236','1','9934','2.99','2005-07-31T15:25:26.000','2006-02-15T22:14:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6374','236','2','10137','4.99','2005-07-31T22:01:41.000','2006-02-15T22:14:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6375','236','2','11139','6.99','2005-08-02T09:27:36.000','2006-02-15T22:14:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6376','236','2','11486','3.99','2005-08-02T22:34:06.000','2006-02-15T22:14:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6377','236','2','11507','5.99','2005-08-16T23:26:43.000','2006-02-15T22:14:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6378','236','1','11895','4.99','2005-08-17T15:15:07.000','2006-02-15T22:14:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6379','236','1','12975','2.99','2005-08-19T06:51:19.000','2006-02-15T22:14:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6380','236','1','13364','2.99','2005-08-19T21:09:30.000','2006-02-15T22:14:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6381','236','1','13443','7.99','2005-08-19T23:53:42.000','2006-02-15T22:14:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6382','236','2','14321','4.99','2005-08-21T08:05:12.000','2006-02-15T22:14:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6383','236','1','14364','7.99','2005-08-21T09:25:11.000','2006-02-15T22:14:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6384','236','2','14722','4.99','2005-08-21T21:50:53.000','2006-02-15T22:14:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6385','236','1','12988','0.99','2006-02-14T15:16:03.000','2006-02-15T22:14:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6386','237','2','133','0.99','2005-05-25T21:48:30.000','2006-02-15T22:14:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6387','237','1','182','4.99','2005-05-26T04:49:17.000','2006-02-15T22:14:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6388','237','1','1500','0.99','2005-06-15T22:00:45.000','2006-02-15T22:14:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6389','237','2','1518','0.99','2005-06-15T23:36:37.000','2006-02-15T22:14:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6390','237','1','2156','4.99','2005-06-17T23:08:12.000','2006-02-15T22:14:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6391','237','1','2492','2.99','2005-06-18T22:04:15.000','2006-02-15T22:14:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6392','237','2','3069','2.99','2005-06-20T14:13:00.000','2006-02-15T22:14:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6393','237','1','4844','4.99','2005-07-08T18:28:13.000','2006-02-15T22:14:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6394','237','2','6053','4.99','2005-07-11T03:51:59.000','2006-02-15T22:14:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6395','237','1','7193','2.99','2005-07-27T08:37:00.000','2006-02-15T22:14:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6396','237','2','7330','3.99','2005-07-27T13:56:46.000','2006-02-15T22:14:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6397','237','1','7812','4.99','2005-07-28T08:06:52.000','2006-02-15T22:14:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6398','237','2','7951','8.99','2005-07-28T13:21:16.000','2006-02-15T22:14:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6399','237','2','8102','2.99','2005-07-28T18:49:43.000','2006-02-15T22:14:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6400','237','2','8748','2.99','2005-07-29T19:08:37.000','2006-02-15T22:14:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6401','237','2','8799','6.99','2005-07-29T21:16:47.000','2006-02-15T22:14:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6402','237','1','8835','3.99','2005-07-29T22:44:35.000','2006-02-15T22:14:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6403','237','1','9276','5.99','2005-07-30T15:09:28.000','2006-02-15T22:14:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6404','237','1','9661','4.99','2005-07-31T06:06:37.000','2006-02-15T22:14:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6405','237','2','9715','1.99','2005-07-31T08:16:58.000','2006-02-15T22:14:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6406','237','2','10056','0.99','2005-07-31T19:19:13.000','2006-02-15T22:14:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6407','237','2','10058','2.99','2005-07-31T19:20:21.000','2006-02-15T22:14:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6408','237','2','11125','4.99','2005-08-02T08:55:35.000','2006-02-15T22:14:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6409','237','2','11479','11.99','2005-08-02T22:18:13.000','2006-02-15T22:14:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6410','237','2','11772','5.99','2005-08-17T10:18:57.000','2006-02-15T22:14:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6411','237','1','12469','0.99','2005-08-18T11:53:07.000','2006-02-15T22:14:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6412','237','2','13914','6.99','2005-08-20T16:38:57.000','2006-02-15T22:14:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6413','237','2','13922','6.99','2005-08-20T17:02:37.000','2006-02-15T22:14:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6414','237','2','13969','6.99','2005-08-20T18:42:40.000','2006-02-15T22:14:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6415','237','2','14453','3.99','2005-08-21T12:33:34.000','2006-02-15T22:14:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6416','237','2','15139','8.99','2005-08-22T13:38:11.000','2006-02-15T22:14:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6417','237','1','15337','0.99','2005-08-22T20:49:51.000','2006-02-15T22:14:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6418','237','2','15931','1.99','2005-08-23T18:28:09.000','2006-02-15T22:14:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6419','238','2','315','4.99','2005-05-26T23:12:55.000','2006-02-15T22:14:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6420','238','1','842','2.99','2005-05-30T00:32:04.000','2006-02-15T22:14:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6421','238','1','1199','2.99','2005-06-15T01:58:50.000','2006-02-15T22:14:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6422','238','1','1660','4.99','2005-06-16T10:12:55.000','2006-02-15T22:14:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6423','238','1','3181','2.99','2005-06-20T22:51:02.000','2006-02-15T22:14:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6424','238','1','4143','0.99','2005-07-07T08:22:07.000','2006-02-15T22:14:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6425','238','1','5616','5.99','2005-07-10T05:21:11.000','2006-02-15T22:14:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6426','238','2','6403','0.99','2005-07-11T22:46:25.000','2006-02-15T22:14:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6427','238','2','7243','4.99','2005-07-27T10:26:11.000','2006-02-15T22:14:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6428','238','1','8310','8.99','2005-07-29T03:25:56.000','2006-02-15T22:14:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6429','238','1','8382','6.99','2005-07-29T05:33:21.000','2006-02-15T22:14:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6430','238','1','8465','0.99','2005-07-29T08:20:49.000','2006-02-15T22:14:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6431','238','1','9065','4.99','2005-07-30T07:25:09.000','2006-02-15T22:14:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6432','238','2','9841','7.99','2005-07-31T12:24:19.000','2006-02-15T22:14:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6433','238','1','10659','5.99','2005-08-01T16:40:34.000','2006-02-15T22:14:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6434','238','2','11543','5.99','2005-08-17T00:54:28.000','2006-02-15T22:14:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6435','238','2','11632','2.99','2005-08-17T04:29:32.000','2006-02-15T22:14:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6436','238','1','11897','2.99','2005-08-17T15:24:06.000','2006-02-15T22:14:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6437','238','1','14312','4.99','2005-08-21T07:48:34.000','2006-02-15T22:14:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6438','238','1','14343','8.99','2005-08-21T08:40:21.000','2006-02-15T22:14:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6439','238','1','15455','0.99','2005-08-23T01:05:00.000','2006-02-15T22:14:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6440','239','2','8','4.99','2005-05-24T23:31:46.000','2006-02-15T22:14:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6441','239','1','444','2.99','2005-05-27T18:39:15.000','2006-02-15T22:14:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6442','239','1','621','4.99','2005-05-28T15:58:12.000','2006-02-15T22:14:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6443','239','1','636','6.99','2005-05-28T17:47:58.000','2006-02-15T22:14:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6444','239','1','1022','7.99','2005-05-31T03:16:45.000','2006-02-15T22:14:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6445','239','2','1082','5.99','2005-05-31T11:02:01.000','2006-02-15T22:14:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6446','239','1','1160','4.99','2005-06-14T23:00:34.000','2006-02-15T22:14:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6447','239','2','1560','4.99','2005-06-16T02:36:43.000','2006-02-15T22:14:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6448','239','2','2215','2.99','2005-06-18T02:48:21.000','2006-02-15T22:14:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6449','239','1','2390','4.99','2005-06-18T15:29:26.000','2006-02-15T22:14:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6450','239','1','3383','5.99','2005-06-21T14:07:19.000','2006-02-15T22:14:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6451','239','2','3547','0.99','2005-07-06T02:18:06.000','2006-02-15T22:14:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6452','239','1','3552','5.99','2005-07-06T02:34:09.000','2006-02-15T22:14:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6453','239','2','4920','7.99','2005-07-08T21:42:10.000','2006-02-15T22:14:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6454','239','2','5651','4.99','2005-07-10T07:17:13.000','2006-02-15T22:14:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6455','239','1','5960','0.99','2005-07-10T23:38:34.000','2006-02-15T22:14:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6456','239','1','6573','0.99','2005-07-12T06:03:40.000','2006-02-15T22:14:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6457','239','2','7012','8.99','2005-07-27T02:01:03.000','2006-02-15T22:14:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6458','239','1','7426','0.99','2005-07-27T17:19:46.000','2006-02-15T22:14:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6459','239','2','7491','2.99','2005-07-27T19:53:23.000','2006-02-15T22:14:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6460','239','1','8457','6.99','2005-07-29T07:59:03.000','2006-02-15T22:14:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6461','239','2','9676','0.99','2005-07-31T06:39:13.000','2006-02-15T22:14:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6462','239','1','9863','5.99','2005-07-31T13:05:29.000','2006-02-15T22:14:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6463','239','1','10755','0.99','2005-08-01T20:14:14.000','2006-02-15T22:14:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6464','239','2','10923','2.99','2005-08-02T02:15:01.000','2006-02-15T22:14:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6465','239','1','11487','2.99','2005-08-02T22:35:05.000','2006-02-15T22:14:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6466','239','2','11900','4.99','2005-08-17T15:30:44.000','2006-02-15T22:14:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6467','239','1','11968','0.99','2005-08-17T17:47:34.000','2006-02-15T22:14:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6468','239','1','12340','4.99','2005-08-18T07:07:01.000','2006-02-15T22:14:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6469','239','1','12721','1.99','2005-08-18T21:30:12.000','2006-02-15T22:14:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6470','239','1','13175','4.99','2005-08-19T13:54:53.000','2006-02-15T22:14:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6471','239','2','13427','4.99','2005-08-19T23:19:02.000','2006-02-15T22:14:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6472','239','2','13999','3.99','2005-08-20T19:53:32.000','2006-02-15T22:14:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6473','239','2','14062','1.99','2005-08-20T22:34:34.000','2006-02-15T22:14:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6474','240','1','246','2.99','2005-05-26T13:57:07.000','2006-02-15T22:14:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6475','240','1','460','2.99','2005-05-27T20:02:03.000','2006-02-15T22:14:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6476','240','1','643','4.99','2005-05-28T18:52:11.000','2006-02-15T22:14:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6477','240','2','2196','3.99','2005-06-18T01:47:07.000','2006-02-15T22:14:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6478','240','1','2264','4.99','2005-06-18T05:58:45.000','2006-02-15T22:14:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6479','240','2','2872','5.99','2005-06-20T00:38:21.000','2006-02-15T22:14:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6480','240','2','4305','4.99','2005-07-07T17:07:11.000','2006-02-15T22:14:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6481','240','2','5262','4.99','2005-07-09T14:08:01.000','2006-02-15T22:14:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6482','240','1','5596','0.99','2005-07-10T04:43:14.000','2006-02-15T22:14:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6483','240','1','6272','0.99','2005-07-11T16:03:49.000','2006-02-15T22:14:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6484','240','2','6470','0.99','2005-07-12T01:29:41.000','2006-02-15T22:14:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6485','240','1','6956','4.99','2005-07-26T23:55:57.000','2006-02-15T22:14:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6486','240','1','7001','4.99','2005-07-27T01:25:34.000','2006-02-15T22:14:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6487','240','1','7467','8.99','2005-07-27T18:51:54.000','2006-02-15T22:14:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6488','240','2','7481','4.99','2005-07-27T19:20:25.000','2006-02-15T22:14:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6489','240','1','7870','4.99','2005-07-28T10:16:03.000','2006-02-15T22:14:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6490','240','2','8503','3.99','2005-07-29T09:16:50.000','2006-02-15T22:14:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6491','240','2','8905','5.99','2005-07-30T01:11:11.000','2006-02-15T22:14:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6492','240','1','10308','7.99','2005-08-01T04:22:49.000','2006-02-15T22:14:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6493','240','1','11745','3.99','2005-08-17T09:00:01.000','2006-02-15T22:14:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6494','240','2','12283','6.99','2005-08-18T04:54:25.000','2006-02-15T22:14:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6495','240','2','13030','2.99','2005-08-19T08:28:11.000','2006-02-15T22:14:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6496','240','2','13119','4.99','2005-08-19T11:44:59.000','2006-02-15T22:14:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6497','240','1','13663','8.99','2005-08-20T08:12:33.000','2006-02-15T22:14:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6498','240','2','14573','2.99','2005-08-21T16:44:32.000','2006-02-15T22:14:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6499','240','2','15641','0.99','2005-08-23T08:06:49.000','2006-02-15T22:14:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6500','241','1','627','7.99','2005-05-28T17:04:43.000','2006-02-15T22:14:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6501','241','1','1059','3.99','2005-05-31T08:20:43.000','2006-02-15T22:14:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6502','241','2','2428','0.99','2005-06-18T17:47:34.000','2006-02-15T22:14:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6503','241','1','2455','0.99','2005-06-18T19:33:06.000','2006-02-15T22:14:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6504','241','2','2478','5.99','2005-06-18T21:01:21.000','2006-02-15T22:14:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6505','241','2','2683','2.99','2005-06-19T12:27:19.000','2006-02-15T22:14:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6506','241','2','3258','0.99','2005-06-21T03:53:58.000','2006-02-15T22:14:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6507','241','2','3822','0.99','2005-07-06T15:41:15.000','2006-02-15T22:14:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6508','241','1','4731','0.99','2005-07-08T13:08:18.000','2006-02-15T22:14:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6509','241','2','5017','2.99','2005-07-09T02:00:16.000','2006-02-15T22:14:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6510','241','1','5211','0.99','2005-07-09T11:26:50.000','2006-02-15T22:14:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6511','241','1','5438','4.99','2005-07-09T21:34:32.000','2006-02-15T22:14:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6512','241','2','5525','3.99','2005-07-10T02:03:08.000','2006-02-15T22:14:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6513','241','1','5981','4.99','2005-07-11T00:19:04.000','2006-02-15T22:14:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6514','241','2','6090','6.99','2005-07-11T05:47:08.000','2006-02-15T22:14:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6515','241','2','6245','2.99','2005-07-11T14:56:57.000','2006-02-15T22:14:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6516','241','1','7320','0.99','2005-07-27T13:33:35.000','2006-02-15T22:14:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6517','241','1','7434','2.99','2005-07-27T17:34:40.000','2006-02-15T22:14:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6518','241','1','7860','2.99','2005-07-28T09:58:02.000','2006-02-15T22:14:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6519','241','1','9500','6.99','2005-07-30T23:58:36.000','2006-02-15T22:14:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6520','241','1','9528','3.99','2005-07-31T01:05:04.000','2006-02-15T22:14:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6521','241','1','9944','5.99','2005-07-31T15:44:43.000','2006-02-15T22:14:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6522','241','2','10447','3.99','2005-08-01T09:04:58.000','2006-02-15T22:14:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6523','241','1','10652','2.99','2005-08-01T16:24:08.000','2006-02-15T22:14:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6524','241','1','11423','1.99','2005-08-02T19:57:13.000','2006-02-15T22:14:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6525','241','2','12418','4.99','2005-08-18T09:59:36.000','2006-02-15T22:14:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6526','241','1','12956','4.99','2005-08-19T06:06:26.000','2006-02-15T22:14:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6527','241','2','13077','2.99','2005-08-19T10:15:19.000','2006-02-15T22:14:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6528','241','2','14269','7.99','2005-08-21T06:22:07.000','2006-02-15T22:14:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6529','241','2','14485','2.99','2005-08-21T13:52:07.000','2006-02-15T22:14:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6530','241','1','14936','0.99','2005-08-22T05:51:26.000','2006-02-15T22:14:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6531','241','2','15137','2.99','2005-08-22T13:20:28.000','2006-02-15T22:14:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6532','241','1','15429','2.99','2005-08-23T00:20:31.000','2006-02-15T22:14:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6533','241','1','15767','4.99','2005-08-23T13:14:15.000','2006-02-15T22:14:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6534','242','1','108','2.99','2005-05-25T18:30:05.000','2006-02-15T22:14:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6535','242','2','283','3.99','2005-05-26T19:05:05.000','2006-02-15T22:14:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6536','242','2','881','4.99','2005-05-30T06:15:36.000','2006-02-15T22:14:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6537','242','2','1304','4.99','2005-06-15T09:56:02.000','2006-02-15T22:14:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6538','242','1','1384','4.99','2005-06-15T15:22:03.000','2006-02-15T22:14:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6539','242','1','1483','4.99','2005-06-15T21:21:58.000','2006-02-15T22:14:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6540','242','2','1702','4.99','2005-06-16T13:21:05.000','2006-02-15T22:14:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6541','242','1','2691','4.99','2005-06-19T13:06:50.000','2006-02-15T22:14:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6542','242','2','2942','4.99','2005-06-20T05:27:31.000','2006-02-15T22:14:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6543','242','1','3471','4.99','2005-07-05T22:51:44.000','2006-02-15T22:14:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6544','242','2','3604','0.99','2005-07-06T05:25:22.000','2006-02-15T22:14:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6545','242','1','4426','4.99','2005-07-07T22:28:32.000','2006-02-15T22:14:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6546','242','2','4895','1.99','2005-07-08T20:22:05.000','2006-02-15T22:14:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6547','242','2','5666','5.99','2005-07-10T08:10:29.000','2006-02-15T22:14:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6548','242','2','7149','3.99','2005-07-27T07:10:40.000','2006-02-15T22:14:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6549','242','1','8491','4.99','2005-07-29T09:02:13.000','2006-02-15T22:14:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6550','242','1','9423','3.99','2005-07-30T21:10:14.000','2006-02-15T22:14:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6551','242','1','9730','6.99','2005-07-31T08:50:08.000','2006-02-15T22:14:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6552','242','2','10367','0.99','2005-08-01T06:12:19.000','2006-02-15T22:14:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6553','242','2','10382','4.99','2005-08-01T06:36:45.000','2006-02-15T22:14:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6554','242','2','10650','9.99','2005-08-01T16:18:45.000','2006-02-15T22:14:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6555','242','2','11020','0.99','2005-08-02T05:29:48.000','2006-02-15T22:14:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6556','242','1','11258','4.99','2005-08-02T13:45:39.000','2006-02-15T22:14:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6557','242','2','11607','0.99','2005-08-17T03:36:06.000','2006-02-15T22:14:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6558','242','1','11931','4.99','2005-08-17T16:35:14.000','2006-02-15T22:14:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6559','242','2','12724','7.99','2005-08-18T21:37:20.000','2006-02-15T22:14:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6560','242','1','12855','4.99','2005-08-19T02:18:58.000','2006-02-15T22:14:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6561','242','1','13271','9.99','2005-08-19T17:42:06.000','2006-02-15T22:14:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6562','242','2','13567','0.99','2005-08-20T04:49:21.000','2006-02-15T22:14:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6563','242','2','13646','5.99','2005-08-20T07:47:08.000','2006-02-15T22:14:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6564','242','1','14515','0.99','2005-08-21T14:52:14.000','2006-02-15T22:14:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6565','242','1','15002','0.99','2005-08-22T08:06:00.000','2006-02-15T22:14:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6566','243','1','188','4.99','2005-05-26T05:47:12.000','2006-02-15T22:14:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6567','243','1','1405','5.99','2005-06-15T16:41:26.000','2006-02-15T22:14:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6568','243','1','1452','0.99','2005-06-15T19:32:52.000','2006-02-15T22:14:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6569','243','2','2757','5.99','2005-06-19T17:01:14.000','2006-02-15T22:14:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6570','243','2','3854','5.99','2005-07-06T17:02:33.000','2006-02-15T22:14:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6571','243','1','3965','4.99','2005-07-06T22:36:20.000','2006-02-15T22:14:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6572','243','1','4831','0.99','2005-07-08T18:00:14.000','2006-02-15T22:14:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6573','243','1','5502','0.99','2005-07-10T00:34:15.000','2006-02-15T22:14:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6574','243','2','6038','3.99','2005-07-11T03:10:37.000','2006-02-15T22:14:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6575','243','2','6820','2.99','2005-07-12T18:21:30.000','2006-02-15T22:14:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6576','243','2','7022','2.99','2005-07-27T02:31:15.000','2006-02-15T22:14:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6577','243','2','7165','0.99','2005-07-27T07:36:46.000','2006-02-15T22:14:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6578','243','1','8834','4.99','2005-07-29T22:41:48.000','2006-02-15T22:14:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6579','243','2','9035','2.99','2005-07-30T06:16:07.000','2006-02-15T22:14:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6580','243','2','9514','4.99','2005-07-31T00:29:44.000','2006-02-15T22:14:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6581','243','2','9675','2.99','2005-07-31T06:37:07.000','2006-02-15T22:14:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6582','243','2','9988','5.99','2005-07-31T17:22:36.000','2006-02-15T22:14:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6583','243','1','12209','2.99','2005-08-18T02:27:20.000','2006-02-15T22:14:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6584','243','1','13291','2.99','2005-08-19T18:32:11.000','2006-02-15T22:14:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6585','243','1','14033','2.99','2005-08-20T21:30:53.000','2006-02-15T22:14:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6586','243','1','14108','0.99','2005-08-21T00:52:45.000','2006-02-15T22:14:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6587','243','1','14272','3.99','2005-08-21T06:24:55.000','2006-02-15T22:14:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6588','243','2','14581','1.99','2005-08-21T17:07:08.000','2006-02-15T22:14:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6589','243','2','14705','2.99','2005-08-21T21:02:55.000','2006-02-15T22:14:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6590','244','2','592','4.99','2005-05-28T13:21:08.000','2006-02-15T22:14:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6591','244','1','797','1.99','2005-05-29T17:12:17.000','2006-02-15T22:14:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6592','244','2','1189','6.99','2005-06-15T01:04:22.000','2006-02-15T22:14:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6593','244','1','1595','5.99','2005-06-16T05:23:46.000','2006-02-15T22:14:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6594','244','2','2955','3.99','2005-06-20T06:46:35.000','2006-02-15T22:14:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6595','244','1','4814','4.99','2005-07-08T17:11:09.000','2006-02-15T22:14:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6596','244','2','5387','4.99','2005-07-09T19:25:14.000','2006-02-15T22:14:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6597','244','2','5461','0.99','2005-07-09T22:48:04.000','2006-02-15T22:14:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6598','244','2','5692','0.99','2005-07-10T09:32:22.000','2006-02-15T22:14:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6599','244','1','5779','4.99','2005-07-10T13:45:54.000','2006-02-15T22:14:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6600','244','1','5803','3.99','2005-07-10T15:05:42.000','2006-02-15T22:14:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6601','244','2','6374','4.99','2005-07-11T21:36:10.000','2006-02-15T22:14:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6602','244','2','6608','2.99','2005-07-12T08:16:50.000','2006-02-15T22:14:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6603','244','2','6683','2.99','2005-07-12T12:14:05.000','2006-02-15T22:14:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6604','244','2','8454','0.99','2005-07-29T07:49:04.000','2006-02-15T22:14:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6605','244','2','8844','5.99','2005-07-29T23:05:08.000','2006-02-15T22:14:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6606','244','1','10001','4.99','2005-07-31T17:46:18.000','2006-02-15T22:14:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6607','244','2','10047','4.99','2005-07-31T19:07:43.000','2006-02-15T22:14:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6608','244','1','10152','5.99','2005-07-31T22:28:05.000','2006-02-15T22:14:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6609','244','2','10684','6.99','2005-08-01T17:47:00.000','2006-02-15T22:14:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6610','244','2','10969','2.99','2005-08-02T04:04:32.000','2006-02-15T22:14:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6611','244','2','11157','0.99','2005-08-02T09:58:15.000','2006-02-15T22:14:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6612','244','1','11267','9.99','2005-08-02T14:09:08.000','2006-02-15T22:14:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6613','244','1','11762','9.99','2005-08-17T09:48:06.000','2006-02-15T22:14:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6614','244','1','13630','4.99','2005-08-20T07:05:56.000','2006-02-15T22:14:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6615','244','2','13774','0.99','2005-08-20T11:54:01.000','2006-02-15T22:14:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6616','244','1','13928','0.99','2005-08-20T17:12:28.000','2006-02-15T22:14:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6617','244','1','14367','0.99','2005-08-21T09:31:44.000','2006-02-15T22:14:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6618','244','2','14657','0.99','2005-08-21T19:39:43.000','2006-02-15T22:14:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6619','244','1','14919','1.99','2005-08-22T05:07:17.000','2006-02-15T22:14:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6620','244','1','14975','3.99','2005-08-22T07:07:50.000','2006-02-15T22:14:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6621','244','2','12736','4.99','2006-02-14T15:16:03.000','2006-02-15T22:14:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6622','245','2','79','4.99','2005-05-25T12:11:07.000','2006-02-15T22:14:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6623','245','1','241','0.99','2005-05-26T12:49:01.000','2006-02-15T22:14:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6624','245','1','519','7.99','2005-05-28T03:22:33.000','2006-02-15T22:14:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6625','245','1','719','2.99','2005-05-29T05:16:05.000','2006-02-15T22:14:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6626','245','2','725','2.99','2005-05-29T06:03:41.000','2006-02-15T22:14:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6627','245','2','948','8.99','2005-05-30T15:44:27.000','2006-02-15T22:14:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6628','245','1','1377','2.99','2005-06-15T15:02:03.000','2006-02-15T22:14:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6629','245','1','2122','2.99','2005-06-17T20:48:27.000','2006-02-15T22:14:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6630','245','1','3157','2.99','2005-06-20T21:07:54.000','2006-02-15T22:14:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6631','245','1','3634','2.99','2005-07-06T06:51:14.000','2006-02-15T22:14:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6632','245','2','5321','2.99','2005-07-09T16:26:33.000','2006-02-15T22:14:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6633','245','1','5764','4.99','2005-07-10T12:58:16.000','2006-02-15T22:14:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6634','245','2','6242','2.99','2005-07-11T14:45:04.000','2006-02-15T22:14:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6635','245','1','6795','5.99','2005-07-12T16:41:00.000','2006-02-15T22:14:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6636','245','2','6962','0.99','2005-07-27T00:10:58.000','2006-02-15T22:14:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6637','245','1','7230','4.99','2005-07-27T10:01:41.000','2006-02-15T22:14:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6638','245','2','7233','5.99','2005-07-27T10:08:36.000','2006-02-15T22:14:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6639','245','1','7358','0.99','2005-07-27T14:49:44.000','2006-02-15T22:14:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6640','245','2','7397','4.99','2005-07-27T16:05:00.000','2006-02-15T22:14:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6641','245','2','8701','6.99','2005-07-29T17:02:35.000','2006-02-15T22:14:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6642','245','1','8811','10.99','2005-07-29T21:46:21.000','2006-02-15T22:14:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6643','245','2','9088','0.99','2005-07-30T08:21:02.000','2006-02-15T22:14:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6644','245','2','9169','4.99','2005-07-30T11:35:00.000','2006-02-15T22:14:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6645','245','1','9813','6.99','2005-07-31T11:29:23.000','2006-02-15T22:14:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6646','245','1','10087','3.99','2005-07-31T20:15:22.000','2006-02-15T22:14:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6647','245','2','11061','0.99','2005-08-02T06:50:18.000','2006-02-15T22:14:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6648','245','1','11105','0.99','2005-08-02T08:13:31.000','2006-02-15T22:14:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6649','245','1','11211','0.99','2005-08-02T12:16:48.000','2006-02-15T22:14:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6650','245','1','12303','7.99','2005-08-18T05:43:22.000','2006-02-15T22:14:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6651','245','1','13286','0.99','2005-08-19T18:28:07.000','2006-02-15T22:14:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6652','245','1','15782','6.99','2005-08-23T13:43:26.000','2006-02-15T22:14:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6653','245','2','12682','2.99','2006-02-14T15:16:03.000','2006-02-15T22:14:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6654','246','1','124','6.99','2005-05-25T20:46:11.000','2006-02-15T22:14:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6655','246','2','421','8.99','2005-05-27T15:30:13.000','2006-02-15T22:14:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6656','246','2','434','5.99','2005-05-27T16:54:27.000','2006-02-15T22:14:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6657','246','1','699','3.99','2005-05-29T02:11:44.000','2006-02-15T22:14:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6658','246','1','1051','4.99','2005-05-31T07:02:09.000','2006-02-15T22:14:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6659','246','2','1448','1.99','2005-06-15T19:17:16.000','2006-02-15T22:14:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6660','246','1','1968','2.99','2005-06-17T09:20:36.000','2006-02-15T22:14:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6661','246','2','2704','1.99','2005-06-19T13:50:10.000','2006-02-15T22:14:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6662','246','1','2725','0.99','2005-06-19T15:01:23.000','2006-02-15T22:14:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6663','246','1','3152','4.99','2005-06-20T20:42:41.000','2006-02-15T22:14:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6664','246','1','4092','7.99','2005-07-07T05:54:18.000','2006-02-15T22:14:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6665','246','2','4905','4.99','2005-07-08T20:56:00.000','2006-02-15T22:14:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6666','246','2','4994','2.99','2005-07-09T00:54:13.000','2006-02-15T22:14:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6667','246','2','5347','0.99','2005-07-09T17:31:32.000','2006-02-15T22:14:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6668','246','1','6688','4.99','2005-07-12T12:22:12.000','2006-02-15T22:14:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6669','246','2','9525','5.99','2005-07-31T01:02:18.000','2006-02-15T22:14:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6670','246','2','10208','4.99','2005-08-01T00:54:51.000','2006-02-15T22:14:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6671','246','2','10683','2.99','2005-08-01T17:33:03.000','2006-02-15T22:14:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6672','246','2','13418','5.99','2005-08-19T22:53:56.000','2006-02-15T22:14:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6673','246','1','13750','6.99','2005-08-20T11:11:42.000','2006-02-15T22:14:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6674','246','1','13987','4.99','2005-08-20T19:19:30.000','2006-02-15T22:14:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6675','246','1','14360','6.99','2005-08-21T09:16:40.000','2006-02-15T22:14:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6676','246','1','15746','2.99','2005-08-23T12:26:19.000','2006-02-15T22:14:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6677','247','1','189','4.99','2005-05-26T06:01:41.000','2006-02-15T22:14:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6678','247','2','448','3.99','2005-05-27T19:03:08.000','2006-02-15T22:14:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6679','247','1','450','6.99','2005-05-27T19:18:54.000','2006-02-15T22:14:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6680','247','1','2288','5.99','2005-06-18T07:23:17.000','2006-02-15T22:14:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6681','247','2','3955','2.99','2005-07-06T21:58:08.000','2006-02-15T22:14:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6682','247','2','4198','6.99','2005-07-07T11:08:11.000','2006-02-15T22:14:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6683','247','1','4492','2.99','2005-07-08T01:32:04.000','2006-02-15T22:14:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6684','247','2','4995','2.99','2005-07-09T00:57:46.000','2006-02-15T22:14:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6685','247','1','5328','6.99','2005-07-09T16:48:29.000','2006-02-15T22:14:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6686','247','1','5842','4.99','2005-07-10T17:11:37.000','2006-02-15T22:14:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6687','247','1','7963','5.99','2005-07-28T13:48:38.000','2006-02-15T22:14:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6688','247','1','10279','1.99','2005-08-01T03:26:44.000','2006-02-15T22:14:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6689','247','1','10410','6.99','2005-08-01T07:53:29.000','2006-02-15T22:14:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6690','247','2','11204','2.99','2005-08-02T11:56:31.000','2006-02-15T22:14:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6691','247','2','11306','2.99','2005-08-02T15:45:10.000','2006-02-15T22:14:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6692','247','1','11495','0.99','2005-08-16T22:51:20.000','2006-02-15T22:14:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6693','247','2','12265','4.99','2005-08-18T04:22:01.000','2006-02-15T22:14:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6694','247','1','12482','7.99','2005-08-18T12:37:36.000','2006-02-15T22:14:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6695','247','1','12491','4.99','2005-08-18T12:48:45.000','2006-02-15T22:14:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6696','247','1','12824','4.99','2005-08-19T01:18:00.000','2006-02-15T22:14:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6697','247','1','14041','4.99','2005-08-20T21:45:23.000','2006-02-15T22:14:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6698','247','1','15783','4.99','2005-08-23T13:45:44.000','2006-02-15T22:14:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6699','248','2','330','7.99','2005-05-27T02:15:30.000','2006-02-15T22:14:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6700','248','1','618','4.99','2005-05-28T15:50:07.000','2006-02-15T22:14:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6701','248','1','2066','3.99','2005-06-17T16:07:08.000','2006-02-15T22:14:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6702','248','2','2371','0.99','2005-06-18T14:35:29.000','2006-02-15T22:14:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6703','248','1','3910','0.99','2005-07-06T20:05:18.000','2006-02-15T22:14:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6704','248','2','4541','4.99','2005-07-08T04:04:19.000','2006-02-15T22:14:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6705','248','1','4841','0.99','2005-07-08T18:18:23.000','2006-02-15T22:14:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6706','248','1','5370','2.99','2005-07-09T18:43:19.000','2006-02-15T22:14:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6707','248','2','6617','2.99','2005-07-12T08:39:56.000','2006-02-15T22:14:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6708','248','2','7778','5.99','2005-07-28T07:10:11.000','2006-02-15T22:14:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6709','248','2','10418','4.99','2005-08-01T08:11:07.000','2006-02-15T22:14:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6710','248','1','12241','0.99','2005-08-18T03:33:17.000','2006-02-15T22:14:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6711','248','1','13918','0.99','2005-08-20T16:47:32.000','2006-02-15T22:14:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6712','248','2','14704','0.99','2005-08-21T21:02:22.000','2006-02-15T22:14:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6713','248','2','14885','5.99','2005-08-22T03:58:29.000','2006-02-15T22:14:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6714','249','2','316','4.99','2005-05-26T23:22:55.000','2006-02-15T22:14:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6715','249','2','400','2.99','2005-05-27T12:51:44.000','2006-02-15T22:14:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6716','249','1','438','6.99','2005-05-27T17:52:34.000','2006-02-15T22:14:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6717','249','1','597','3.99','2005-05-28T14:01:02.000','2006-02-15T22:14:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6718','249','1','1204','0.99','2005-06-15T02:21:46.000','2006-02-15T22:14:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6719','249','1','1473','5.99','2005-06-15T20:55:20.000','2006-02-15T22:14:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6720','249','2','1753','2.99','2005-06-16T17:08:17.000','2006-02-15T22:14:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6721','249','2','2129','1.99','2005-06-17T20:58:32.000','2006-02-15T22:14:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6722','249','2','3175','7.99','2005-06-20T22:30:23.000','2006-02-15T22:14:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6723','249','1','4352','9.99','2005-07-07T19:15:58.000','2006-02-15T22:14:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6724','249','1','5011','4.99','2005-07-09T01:44:40.000','2006-02-15T22:14:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6725','249','1','5275','4.99','2005-07-09T14:34:18.000','2006-02-15T22:14:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6726','249','2','5639','3.99','2005-07-10T06:33:39.000','2006-02-15T22:14:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6727','249','2','6670','7.99','2005-07-12T11:44:33.000','2006-02-15T22:14:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6728','249','1','7544','7.99','2005-07-27T21:47:37.000','2006-02-15T22:14:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6729','249','1','7804','2.99','2005-07-28T07:56:00.000','2006-02-15T22:14:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6730','249','2','7881','4.99','2005-07-28T10:33:22.000','2006-02-15T22:14:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6731','249','1','11124','1.99','2005-08-02T08:55:25.000','2006-02-15T22:14:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6732','249','1','11159','4.99','2005-08-02T10:00:55.000','2006-02-15T22:14:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6733','249','2','11668','0.99','2005-08-17T05:47:32.000','2006-02-15T22:14:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6734','249','2','13981','4.99','2005-08-20T19:07:20.000','2006-02-15T22:14:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6735','249','2','14285','0.99','2005-08-21T06:50:48.000','2006-02-15T22:14:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6736','249','1','15160','6.99','2005-08-22T14:33:50.000','2006-02-15T22:14:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6737','250','1','61','5.99','2005-05-25T09:01:57.000','2006-02-15T22:14:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6738','250','1','176','3.99','2005-05-26T03:47:39.000','2006-02-15T22:14:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6739','250','1','637','4.99','2005-05-28T18:14:29.000','2006-02-15T22:14:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6740','250','2','687','0.99','2005-05-29T00:32:09.000','2006-02-15T22:14:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6741','250','1','1146','2.99','2005-05-31T20:34:45.000','2006-02-15T22:14:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6742','250','1','2432','4.99','2005-06-18T17:59:18.000','2006-02-15T22:14:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6743','250','1','3635','4.99','2005-07-06T06:55:36.000','2006-02-15T22:14:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6744','250','1','3951','3.99','2005-07-06T21:50:41.000','2006-02-15T22:14:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6745','250','1','5479','2.99','2005-07-09T23:47:33.000','2006-02-15T22:14:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6746','250','1','5540','0.99','2005-07-10T02:44:21.000','2006-02-15T22:14:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6747','250','1','5998','2.99','2005-07-11T01:20:46.000','2006-02-15T22:14:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6748','250','1','8579','2.99','2005-07-29T11:59:22.000','2006-02-15T22:14:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6749','250','2','9099','0.99','2005-07-30T08:45:48.000','2006-02-15T22:14:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6750','250','2','10604','4.99','2005-08-01T14:35:08.000','2006-02-15T22:14:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6751','250','1','12361','0.99','2005-08-18T07:47:31.000','2006-02-15T22:14:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6752','250','1','12810','0.99','2005-08-19T00:44:10.000','2006-02-15T22:14:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6753','250','2','14565','4.99','2005-08-21T16:24:45.000','2006-02-15T22:14:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6754','250','1','14587','5.99','2005-08-21T17:20:55.000','2006-02-15T22:14:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6755','250','2','14814','4.99','2005-08-22T01:12:14.000','2006-02-15T22:14:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6756','250','2','15247','6.99','2005-08-22T17:52:05.000','2006-02-15T22:14:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6757','251','1','264','2.99','2005-05-26T16:00:49.000','2006-02-15T22:14:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6758','251','1','309','1.99','2005-05-26T22:38:10.000','2006-02-15T22:14:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6759','251','2','393','2.99','2005-05-27T11:18:25.000','2006-02-15T22:14:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6760','251','2','1069','3.99','2005-05-31T09:32:31.000','2006-02-15T22:14:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6761','251','1','1091','4.99','2005-05-31T12:11:04.000','2006-02-15T22:14:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6762','251','2','1155','2.99','2005-05-31T22:17:11.000','2006-02-15T22:14:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6763','251','1','2238','6.99','2005-06-18T04:22:06.000','2006-02-15T22:14:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6764','251','2','3422','7.99','2005-06-21T17:24:40.000','2006-02-15T22:14:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6765','251','1','3464','2.99','2005-06-21T22:08:58.000','2006-02-15T22:14:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6766','251','1','3799','4.99','2005-07-06T15:00:14.000','2006-02-15T22:14:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6767','251','2','4026','3.99','2005-07-07T02:15:48.000','2006-02-15T22:14:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6768','251','2','4848','2.99','2005-07-08T18:30:16.000','2006-02-15T22:14:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6769','251','2','5012','2.99','2005-07-09T01:45:04.000','2006-02-15T22:14:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6770','251','2','5979','2.99','2005-07-11T00:17:09.000','2006-02-15T22:14:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6771','251','2','6413','6.99','2005-07-11T23:26:11.000','2006-02-15T22:14:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6772','251','2','7338','8.99','2005-07-27T14:13:34.000','2006-02-15T22:14:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6773','251','2','8443','2.99','2005-07-29T07:33:12.000','2006-02-15T22:14:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6774','251','2','8982','0.99','2005-07-30T04:31:02.000','2006-02-15T22:14:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6775','251','1','9196','2.99','2005-07-30T12:30:19.000','2006-02-15T22:14:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6776','251','1','9892','0.99','2005-07-31T14:06:25.000','2006-02-15T22:14:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6777','251','1','10575','7.99','2005-08-01T13:41:41.000','2006-02-15T22:14:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6778','251','1','11733','0.99','2005-08-17T08:31:03.000','2006-02-15T22:14:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6779','251','2','12047','3.99','2005-08-17T20:48:32.000','2006-02-15T22:14:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6780','251','2','12666','4.99','2005-08-18T19:11:41.000','2006-02-15T22:14:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6781','251','2','13121','2.99','2005-08-19T11:51:39.000','2006-02-15T22:14:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6782','251','1','13243','2.99','2005-08-19T16:33:16.000','2006-02-15T22:14:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6783','251','2','13260','6.99','2005-08-19T17:09:22.000','2006-02-15T22:14:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6784','251','1','14292','0.99','2005-08-21T07:06:20.000','2006-02-15T22:14:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6785','251','2','15647','2.99','2005-08-23T08:23:56.000','2006-02-15T22:14:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6786','251','2','15870','4.99','2005-08-23T16:23:08.000','2006-02-15T22:14:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6787','251','1','14107','0.99','2006-02-14T15:16:03.000','2006-02-15T22:14:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6788','252','1','707','4.99','2005-05-29T03:18:19.000','2006-02-15T22:14:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6789','252','1','1095','0.99','2005-05-31T13:15:41.000','2006-02-15T22:14:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6790','252','1','1395','5.99','2005-06-15T16:21:04.000','2006-02-15T22:14:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6791','252','2','2716','4.99','2005-06-19T14:40:17.000','2006-02-15T22:14:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6792','252','1','2968','0.99','2005-06-20T07:41:47.000','2006-02-15T22:14:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6793','252','2','4372','0.99','2005-07-07T20:09:01.000','2006-02-15T22:14:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6794','252','2','5554','2.99','2005-07-10T03:03:38.000','2006-02-15T22:14:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6795','252','1','6357','0.99','2005-07-11T20:58:51.000','2006-02-15T22:14:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6796','252','2','6369','0.99','2005-07-11T21:23:36.000','2006-02-15T22:14:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6797','252','1','7024','4.99','2005-07-27T02:36:40.000','2006-02-15T22:14:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6798','252','2','7121','0.99','2005-07-27T05:58:32.000','2006-02-15T22:14:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6799','252','2','7168','0.99','2005-07-27T07:51:11.000','2006-02-15T22:14:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6800','252','1','7670','0.99','2005-07-28T02:44:25.000','2006-02-15T22:14:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6801','252','1','8636','5.99','2005-07-29T14:24:13.000','2006-02-15T22:14:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6802','252','1','8899','0.99','2005-07-30T01:05:30.000','2006-02-15T22:14:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6803','252','2','10314','0.99','2005-08-01T04:31:18.000','2006-02-15T22:14:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6804','252','2','10834','2.99','2005-08-01T23:28:00.000','2006-02-15T22:14:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6805','252','2','11764','0.99','2005-08-17T09:51:54.000','2006-02-15T22:14:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6806','252','1','13385','4.99','2005-08-19T21:39:35.000','2006-02-15T22:14:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6807','252','2','13989','5.99','2005-08-20T19:27:50.000','2006-02-15T22:14:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6808','252','1','14774','4.99','2005-08-21T23:52:32.000','2006-02-15T22:14:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6809','252','2','13756','4.99','2006-02-14T15:16:03.000','2006-02-15T22:14:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6810','253','1','566','6.99','2005-05-28T09:51:39.000','2006-02-15T22:14:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6811','253','1','648','0.99','2005-05-28T19:25:54.000','2006-02-15T22:14:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6812','253','1','986','2.99','2005-05-30T22:22:52.000','2006-02-15T22:14:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6813','253','2','1378','1.99','2005-06-15T15:03:15.000','2006-02-15T22:14:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6814','253','2','1606','6.99','2005-06-16T06:18:31.000','2006-02-15T22:14:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6815','253','2','2081','5.99','2005-06-17T17:05:02.000','2006-02-15T22:14:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6816','253','1','2142','4.99','2005-06-17T21:55:43.000','2006-02-15T22:14:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6817','253','1','2454','4.99','2005-06-18T19:32:51.000','2006-02-15T22:14:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6818','253','2','2636','4.99','2005-06-19T09:13:06.000','2006-02-15T22:14:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6819','253','1','3658','7.99','2005-07-06T08:01:08.000','2006-02-15T22:14:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6820','253','1','5505','2.99','2005-07-10T00:38:48.000','2006-02-15T22:14:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6821','253','1','5602','4.99','2005-07-10T05:02:22.000','2006-02-15T22:14:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6822','253','2','7689','2.99','2005-07-28T03:21:24.000','2006-02-15T22:14:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6823','253','2','7851','0.99','2005-07-28T09:31:58.000','2006-02-15T22:14:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6824','253','2','7887','2.99','2005-07-28T10:40:12.000','2006-02-15T22:14:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6825','253','2','8752','2.99','2005-07-29T19:15:07.000','2006-02-15T22:14:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6826','253','2','9606','0.99','2005-07-31T03:50:46.000','2006-02-15T22:14:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6827','253','2','9618','6.99','2005-07-31T04:16:14.000','2006-02-15T22:14:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6828','253','2','10404','4.99','2005-08-01T07:31:25.000','2006-02-15T22:14:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6829','253','1','10660','2.99','2005-08-01T16:48:01.000','2006-02-15T22:14:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6830','253','2','10881','6.99','2005-08-02T00:38:14.000','2006-02-15T22:14:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6831','253','1','12572','0.99','2005-08-18T15:32:54.000','2006-02-15T22:14:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6832','253','2','12827','5.99','2005-08-19T01:27:23.000','2006-02-15T22:14:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6833','253','1','13126','5.99','2005-08-19T12:00:28.000','2006-02-15T22:14:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6834','253','2','14086','3.99','2005-08-20T23:47:54.000','2006-02-15T22:14:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6835','253','2','14283','4.99','2005-08-21T06:44:14.000','2006-02-15T22:14:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6836','253','1','14640','7.99','2005-08-21T19:03:19.000','2006-02-15T22:14:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6837','253','2','14655','4.99','2005-08-21T19:37:10.000','2006-02-15T22:14:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6838','253','2','15221','2.99','2005-08-22T17:12:29.000','2006-02-15T22:14:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6839','254','1','183','2.99','2005-05-26T05:01:18.000','2006-02-15T22:14:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6840','254','1','1108','5.99','2005-05-31T15:05:12.000','2006-02-15T22:14:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6841','254','1','1285','2.99','2005-06-15T08:33:06.000','2006-02-15T22:14:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6842','254','2','1390','0.99','2005-06-15T16:06:29.000','2006-02-15T22:14:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6843','254','1','2082','2.99','2005-06-17T17:13:32.000','2006-02-15T22:14:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6844','254','1','2138','2.99','2005-06-17T21:28:14.000','2006-02-15T22:14:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6845','254','2','2687','3.99','2005-06-19T12:46:52.000','2006-02-15T22:14:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6846','254','1','3882','4.99','2005-07-06T18:38:21.000','2006-02-15T22:14:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6847','254','2','5042','2.99','2005-07-09T03:20:30.000','2006-02-15T22:14:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6848','254','1','5072','3.99','2005-07-09T05:01:58.000','2006-02-15T22:14:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6849','254','2','5080','2.99','2005-07-09T05:23:55.000','2006-02-15T22:14:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6850','254','1','5537','0.99','2005-07-10T02:35:41.000','2006-02-15T22:14:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6851','254','1','5550','5.99','2005-07-10T02:58:35.000','2006-02-15T22:14:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6852','254','1','5826','7.99','2005-07-10T16:21:02.000','2006-02-15T22:14:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6853','254','2','5930','4.99','2005-07-10T21:59:32.000','2006-02-15T22:14:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6854','254','2','7011','0.99','2005-07-27T01:58:34.000','2006-02-15T22:14:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6855','254','1','7413','4.99','2005-07-27T16:45:40.000','2006-02-15T22:14:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6856','254','2','8216','7.99','2005-07-28T23:43:59.000','2006-02-15T22:14:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6857','254','2','8581','4.99','2005-07-29T12:02:06.000','2006-02-15T22:14:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6858','254','2','9494','1.99','2005-07-30T23:52:46.000','2006-02-15T22:14:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6859','254','1','10522','4.99','2005-08-01T11:48:51.000','2006-02-15T22:14:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6860','254','1','11190','0.99','2005-08-02T11:21:34.000','2006-02-15T22:14:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6861','254','1','11665','6.99','2005-08-17T05:36:57.000','2006-02-15T22:14:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6862','254','2','12148','0.99','2005-08-18T00:13:15.000','2006-02-15T22:14:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6863','254','1','12206','0.99','2005-08-18T02:22:20.000','2006-02-15T22:14:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6864','254','1','12247','2.99','2005-08-18T03:51:51.000','2006-02-15T22:14:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6865','254','1','12874','0.99','2005-08-19T03:07:57.000','2006-02-15T22:14:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6866','254','2','13001','4.99','2005-08-19T07:36:44.000','2006-02-15T22:14:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6867','254','1','13045','4.99','2005-08-19T09:17:35.000','2006-02-15T22:14:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6868','254','2','13130','2.99','2005-08-19T12:06:42.000','2006-02-15T22:14:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6869','254','2','14497','4.99','2005-08-21T14:09:47.000','2006-02-15T22:14:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6870','254','1','15774','0.99','2005-08-23T13:25:08.000','2006-02-15T22:14:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6871','255','1','1235','2.99','2005-06-15T04:31:28.000','2006-02-15T22:14:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6872','255','1','1420','6.99','2005-06-15T17:56:14.000','2006-02-15T22:14:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6873','255','2','1681','2.99','2005-06-16T11:38:17.000','2006-02-15T22:14:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6874','255','2','3442','2.99','2005-06-21T20:06:51.000','2006-02-15T22:14:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6875','255','1','4547','0.99','2005-07-08T04:20:19.000','2006-02-15T22:14:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6876','255','1','5706','1.99','2005-07-10T10:21:46.000','2006-02-15T22:14:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6877','255','1','5943','0.99','2005-07-10T22:48:13.000','2006-02-15T22:14:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6878','255','2','7475','8.99','2005-07-27T19:07:43.000','2006-02-15T22:14:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6879','255','1','7646','2.99','2005-07-28T01:31:45.000','2006-02-15T22:14:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6880','255','1','8562','0.99','2005-07-29T11:32:13.000','2006-02-15T22:14:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6881','255','1','9061','6.99','2005-07-30T07:21:52.000','2006-02-15T22:14:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6882','255','2','11979','4.99','2005-08-17T18:07:13.000','2006-02-15T22:14:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6883','255','2','12176','7.99','2005-08-18T01:10:33.000','2006-02-15T22:14:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6884','255','2','13154','2.99','2005-08-19T13:09:54.000','2006-02-15T22:14:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6885','255','1','13268','0.99','2005-08-19T17:33:50.000','2006-02-15T22:14:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6886','255','2','13683','0.99','2005-08-20T08:54:55.000','2006-02-15T22:14:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6887','255','1','13758','8.99','2005-08-20T11:21:26.000','2006-02-15T22:14:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6888','255','2','14600','3.99','2005-08-21T17:45:21.000','2006-02-15T22:14:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6889','256','1','51','4.99','2005-05-25T06:49:10.000','2006-02-15T22:14:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6890','256','1','232','0.99','2005-05-26T11:38:05.000','2006-02-15T22:14:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6891','256','2','738','4.99','2005-05-29T08:20:08.000','2006-02-15T22:14:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6892','256','1','935','2.99','2005-05-30T13:29:36.000','2006-02-15T22:14:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6893','256','1','1116','0.99','2005-05-31T16:10:46.000','2006-02-15T22:14:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6894','256','1','1555','2.99','2005-06-16T02:17:07.000','2006-02-15T22:14:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6895','256','2','1965','0.99','2005-06-17T09:17:39.000','2006-02-15T22:14:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6896','256','2','1973','4.99','2005-06-17T09:26:15.000','2006-02-15T22:14:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6897','256','2','2230','4.99','2005-06-18T03:50:49.000','2006-02-15T22:14:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6898','256','1','2380','6.99','2005-06-18T15:00:04.000','2006-02-15T22:14:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6899','256','2','2561','4.99','2005-06-19T03:14:52.000','2006-02-15T22:14:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6900','256','1','2839','4.99','2005-06-19T22:07:24.000','2006-02-15T22:14:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6901','256','1','4130','0.99','2005-07-07T07:51:53.000','2006-02-15T22:14:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6902','256','2','4182','0.99','2005-07-07T10:28:00.000','2006-02-15T22:14:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6903','256','1','5179','2.99','2005-07-09T10:00:44.000','2006-02-15T22:14:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6904','256','1','6298','0.99','2005-07-11T17:42:33.000','2006-02-15T22:14:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6905','256','1','7661','3.99','2005-07-28T02:10:27.000','2006-02-15T22:14:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6906','256','2','9424','2.99','2005-07-30T21:10:56.000','2006-02-15T22:14:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6907','256','2','10759','4.99','2005-08-01T20:22:51.000','2006-02-15T22:14:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6908','256','2','11011','2.99','2005-08-02T05:07:07.000','2006-02-15T22:14:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6909','256','2','11628','8.99','2005-08-17T04:27:18.000','2006-02-15T22:14:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6910','256','2','13457','0.99','2005-08-20T00:33:22.000','2006-02-15T22:14:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6911','256','1','13651','0.99','2005-08-20T07:50:08.000','2006-02-15T22:14:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6912','256','1','14003','6.99','2005-08-20T20:16:06.000','2006-02-15T22:14:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6913','256','2','14036','4.99','2005-08-20T21:35:27.000','2006-02-15T22:14:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6914','256','2','14445','2.99','2005-08-21T12:07:42.000','2006-02-15T22:14:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6915','256','2','14458','3.99','2005-08-21T12:47:53.000','2006-02-15T22:14:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6916','256','2','15609','2.99','2005-08-23T06:56:04.000','2006-02-15T22:14:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6917','256','2','15861','4.99','2005-08-23T16:15:45.000','2006-02-15T22:14:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6918','256','1','15864','7.99','2005-08-23T16:18:12.000','2006-02-15T22:14:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6919','257','2','139','2.99','2005-05-25T23:00:21.000','2006-02-15T22:14:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6920','257','2','244','2.99','2005-05-26T13:40:40.000','2006-02-15T22:14:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6921','257','2','705','2.99','2005-05-29T02:48:52.000','2006-02-15T22:14:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6922','257','1','2557','0.99','2005-06-19T03:08:51.000','2006-02-15T22:14:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6923','257','2','3083','4.99','2005-06-20T15:33:47.000','2006-02-15T22:14:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6924','257','2','4462','6.99','2005-07-08T00:02:49.000','2006-02-15T22:14:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6925','257','2','4574','4.99','2005-07-08T05:39:42.000','2006-02-15T22:14:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6926','257','1','5495','6.99','2005-07-10T00:16:54.000','2006-02-15T22:14:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6927','257','1','5858','4.99','2005-07-10T18:00:07.000','2006-02-15T22:14:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6928','257','1','6422','5.99','2005-07-11T23:46:19.000','2006-02-15T22:14:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6929','257','2','6711','5.99','2005-07-12T13:23:40.000','2006-02-15T22:14:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6930','257','2','7007','4.99','2005-07-27T01:43:39.000','2006-02-15T22:14:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6931','257','1','7176','2.99','2005-07-27T08:04:28.000','2006-02-15T22:14:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6932','257','1','7496','1.99','2005-07-27T20:04:05.000','2006-02-15T22:14:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6933','257','2','7510','2.99','2005-07-27T20:37:57.000','2006-02-15T22:14:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6934','257','2','7518','5.99','2005-07-27T21:01:16.000','2006-02-15T22:14:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6935','257','2','8156','3.99','2005-07-28T20:59:04.000','2006-02-15T22:14:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6936','257','2','8252','2.99','2005-07-29T00:54:17.000','2006-02-15T22:14:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6937','257','1','8344','4.99','2005-07-29T04:45:25.000','2006-02-15T22:14:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6938','257','1','8640','4.99','2005-07-29T14:34:17.000','2006-02-15T22:14:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6939','257','2','8946','6.99','2005-07-30T03:14:53.000','2006-02-15T22:14:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6940','257','1','9800','4.99','2005-07-31T11:00:58.000','2006-02-15T22:14:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6941','257','2','10142','4.99','2005-07-31T22:10:54.000','2006-02-15T22:14:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6942','257','1','11230','4.99','2005-08-02T12:59:08.000','2006-02-15T22:14:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6943','257','1','11394','0.99','2005-08-02T18:44:45.000','2006-02-15T22:14:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6944','257','2','11545','6.99','2005-08-17T00:56:06.000','2006-02-15T22:14:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6945','257','2','11860','1.99','2005-08-17T13:52:26.000','2006-02-15T22:14:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6946','257','2','12841','2.99','2005-08-19T01:55:55.000','2006-02-15T22:14:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6947','257','1','12904','5.99','2005-08-19T04:10:50.000','2006-02-15T22:14:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6948','257','2','13203','7.99','2005-08-19T15:00:58.000','2006-02-15T22:14:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6949','257','2','13218','0.99','2005-08-19T15:39:39.000','2006-02-15T22:14:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6950','257','1','13389','2.99','2005-08-19T21:52:51.000','2006-02-15T22:14:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6951','257','2','13846','5.99','2005-08-20T14:32:31.000','2006-02-15T22:14:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6952','257','2','14115','0.99','2005-08-21T01:10:29.000','2006-02-15T22:14:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6953','257','1','15025','0.99','2005-08-22T08:57:24.000','2006-02-15T22:14:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6954','257','1','15967','2.99','2005-08-23T19:50:06.000','2006-02-15T22:14:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6955','257','2','15968','0.99','2005-08-23T19:51:29.000','2006-02-15T22:14:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6956','258','1','1743','2.99','2005-06-16T16:38:10.000','2006-02-15T22:14:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6957','258','2','2678','0.99','2005-06-19T12:12:23.000','2006-02-15T22:14:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6958','258','2','2931','8.99','2005-06-20T04:50:45.000','2006-02-15T22:14:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6959','258','2','4408','2.99','2005-07-07T21:41:06.000','2006-02-15T22:14:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6960','258','1','4677','5.99','2005-07-08T10:30:36.000','2006-02-15T22:14:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6961','258','2','4897','0.99','2005-07-08T20:25:11.000','2006-02-15T22:14:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6962','258','2','5312','5.99','2005-07-09T16:03:09.000','2006-02-15T22:14:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6963','258','1','5674','0.99','2005-07-10T08:26:26.000','2006-02-15T22:14:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6964','258','1','5935','9.99','2005-07-10T22:11:04.000','2006-02-15T22:14:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6965','258','2','6012','4.99','2005-07-11T02:00:12.000','2006-02-15T22:14:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6966','258','1','7814','2.99','2005-07-28T08:09:48.000','2006-02-15T22:14:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6967','258','1','8675','4.99','2005-07-29T15:56:18.000','2006-02-15T22:14:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6968','258','2','9069','4.99','2005-07-30T07:39:59.000','2006-02-15T22:14:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6969','258','2','10293','1.99','2005-08-01T03:44:26.000','2006-02-15T22:14:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6970','258','2','10315','4.99','2005-08-01T04:34:45.000','2006-02-15T22:14:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6971','258','1','10325','5.99','2005-08-01T04:52:12.000','2006-02-15T22:14:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6972','258','2','10332','6.99','2005-08-01T04:57:32.000','2006-02-15T22:14:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6973','258','1','10393','0.99','2005-08-01T06:52:50.000','2006-02-15T22:14:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6974','258','1','12246','5.99','2005-08-18T03:48:41.000','2006-02-15T22:14:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6975','258','2','12296','3.99','2005-08-18T05:16:28.000','2006-02-15T22:14:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6976','258','1','13491','4.99','2005-08-20T01:30:56.000','2006-02-15T22:14:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6977','258','1','13695','6.99','2005-08-20T09:13:25.000','2006-02-15T22:14:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6978','258','2','13897','2.99','2005-08-20T16:02:28.000','2006-02-15T22:14:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6979','258','2','14901','6.99','2005-08-22T04:31:37.000','2006-02-15T22:14:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6980','259','2','722','6.99','2005-05-29T05:30:31.000','2006-02-15T22:14:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6981','259','2','901','2.99','2005-05-30T09:40:40.000','2006-02-15T22:14:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6982','259','1','1147','5.99','2005-05-31T20:37:52.000','2006-02-15T22:14:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6983','259','1','1641','7.99','2005-06-16T08:46:26.000','2006-02-15T22:14:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6984','259','2','1723','7.99','2005-06-16T15:14:18.000','2006-02-15T22:14:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6985','259','2','1813','2.99','2005-06-16T21:11:00.000','2006-02-15T22:14:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6986','259','2','2375','5.99','2005-06-18T14:47:29.000','2006-02-15T22:14:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6987','259','2','4199','5.99','2005-07-07T11:13:07.000','2006-02-15T22:14:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6988','259','2','4489','4.99','2005-07-08T01:23:58.000','2006-02-15T22:14:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6989','259','1','6074','0.99','2005-07-11T04:59:56.000','2006-02-15T22:14:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6990','259','2','6539','3.99','2005-07-12T04:50:49.000','2006-02-15T22:14:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6991','259','2','7188','2.99','2005-07-27T08:32:08.000','2006-02-15T22:14:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6992','259','2','7774','7.99','2005-07-28T07:03:25.000','2006-02-15T22:14:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6993','259','1','7817','4.99','2005-07-28T08:20:55.000','2006-02-15T22:14:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6994','259','2','9205','6.99','2005-07-30T12:46:40.000','2006-02-15T22:14:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6995','259','1','9282','6.99','2005-07-30T15:17:31.000','2006-02-15T22:14:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6996','259','1','9444','7.99','2005-07-30T21:48:44.000','2006-02-15T22:14:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6997','259','1','10510','3.99','2005-08-01T11:28:30.000','2006-02-15T22:14:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6998','259','1','10781','2.99','2005-08-01T21:22:41.000','2006-02-15T22:14:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('6999','259','1','11184','3.99','2005-08-02T11:01:26.000','2006-02-15T22:14:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7000','259','2','12680','6.99','2005-08-18T19:43:46.000','2006-02-15T22:14:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7001','259','1','13109','4.99','2005-08-19T11:23:20.000','2006-02-15T22:14:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7002','259','2','13112','2.99','2005-08-19T11:27:10.000','2006-02-15T22:14:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7003','259','2','13366','4.99','2005-08-19T21:14:45.000','2006-02-15T22:14:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7004','259','1','13598','5.99','2005-08-20T05:59:17.000','2006-02-15T22:14:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7005','259','2','13649','4.99','2005-08-20T07:48:38.000','2006-02-15T22:14:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7006','259','2','14067','6.99','2005-08-20T22:49:23.000','2006-02-15T22:14:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7007','259','2','14170','4.99','2005-08-21T03:00:39.000','2006-02-15T22:14:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7008','259','2','14966','2.99','2005-08-22T06:45:57.000','2006-02-15T22:14:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7009','259','1','15425','10.99','2005-08-23T00:05:57.000','2006-02-15T22:14:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7010','259','1','15473','2.99','2005-08-23T01:39:10.000','2006-02-15T22:14:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7011','259','2',NULL,'1.99','2005-08-23T06:13:16.000','2006-02-15T22:14:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7012','259','1','15689','2.99','2005-08-23T09:52:55.000','2006-02-15T22:14:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7013','260','1','1101','8.99','2005-05-31T14:13:59.000','2006-02-15T22:14:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7014','260','1','1626','3.99','2005-06-16T07:49:47.000','2006-02-15T22:14:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7015','260','2','2001','2.99','2005-06-17T11:35:09.000','2006-02-15T22:14:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7016','260','2','2040','2.99','2005-06-17T14:18:37.000','2006-02-15T22:14:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7017','260','1','2091','10.99','2005-06-17T18:09:04.000','2006-02-15T22:14:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7018','260','1','2178','0.99','2005-06-18T00:38:35.000','2006-02-15T22:14:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7019','260','1','2823','7.99','2005-06-19T20:30:21.000','2006-02-15T22:14:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7020','260','2','2958','3.99','2005-06-20T06:56:20.000','2006-02-15T22:14:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7021','260','1','3193','0.99','2005-06-20T23:52:30.000','2006-02-15T22:14:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7022','260','2','4054','0.99','2005-07-07T03:42:07.000','2006-02-15T22:14:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7023','260','2','4741','6.99','2005-07-08T13:31:23.000','2006-02-15T22:14:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7024','260','1','4870','2.99','2005-07-08T19:14:45.000','2006-02-15T22:14:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7025','260','2','6328','2.99','2005-07-11T19:09:33.000','2006-02-15T22:14:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7026','260','2','7072','0.99','2005-07-27T04:02:33.000','2006-02-15T22:14:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7027','260','1','7268','1.99','2005-07-27T11:23:09.000','2006-02-15T22:14:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7028','260','1','7885','7.99','2005-07-28T10:37:41.000','2006-02-15T22:14:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7029','260','1','8475','1.99','2005-07-29T08:37:41.000','2006-02-15T22:14:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7030','260','1','8484','2.99','2005-07-29T08:51:59.000','2006-02-15T22:14:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7031','260','1','8717','0.99','2005-07-29T17:40:45.000','2006-02-15T22:14:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7032','260','1','8933','0.99','2005-07-30T02:36:06.000','2006-02-15T22:14:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7033','260','2','9176','4.99','2005-07-30T11:50:54.000','2006-02-15T22:14:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7034','260','2','10970','8.99','2005-08-02T04:06:46.000','2006-02-15T22:14:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7035','260','1','12852','0.99','2005-08-19T02:12:40.000','2006-02-15T22:14:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7036','260','2','13440','2.99','2005-08-19T23:42:52.000','2006-02-15T22:14:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7037','260','1','13685','3.99','2005-08-20T08:57:11.000','2006-02-15T22:14:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7038','260','1','13966','2.99','2005-08-20T18:28:28.000','2006-02-15T22:14:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7039','260','2','13978','0.99','2005-08-20T19:03:25.000','2006-02-15T22:14:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7040','260','2','14035','2.99','2005-08-20T21:31:58.000','2006-02-15T22:14:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7041','260','2','14441','2.99','2005-08-21T11:59:38.000','2006-02-15T22:14:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7042','260','1','14579','7.99','2005-08-21T16:54:47.000','2006-02-15T22:14:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7043','260','1','14610','6.99','2005-08-21T17:59:09.000','2006-02-15T22:14:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7044','261','1','12','4.99','2005-05-25T00:19:27.000','2006-02-15T22:14:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7045','261','2','465','3.99','2005-05-27T20:44:36.000','2006-02-15T22:14:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7046','261','2','542','6.99','2005-05-28T06:42:13.000','2006-02-15T22:14:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7047','261','1','792','0.99','2005-05-29T16:32:10.000','2006-02-15T22:14:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7048','261','1','1760','2.99','2005-06-16T17:48:37.000','2006-02-15T22:14:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7049','261','1','1877','5.99','2005-06-17T02:54:16.000','2006-02-15T22:15:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7050','261','2','1988','8.99','2005-06-17T10:42:34.000','2006-02-15T22:15:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7051','261','2','2072','3.99','2005-06-17T16:33:32.000','2006-02-15T22:15:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7052','261','2','2392','0.99','2005-06-18T15:34:18.000','2006-02-15T22:15:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7053','261','1','3363','0.99','2005-06-21T12:25:07.000','2006-02-15T22:15:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7054','261','1','5122','3.99','2005-07-09T07:19:35.000','2006-02-15T22:15:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7055','261','1','5449','5.99','2005-07-09T22:12:01.000','2006-02-15T22:15:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7056','261','2','6515','2.99','2005-07-12T03:50:32.000','2006-02-15T22:15:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7057','261','1','6743','0.99','2005-07-12T14:29:25.000','2006-02-15T22:15:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7058','261','2','9552','4.99','2005-07-31T02:05:32.000','2006-02-15T22:15:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7059','261','1','9842','4.99','2005-07-31T12:24:58.000','2006-02-15T22:15:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7060','261','1','9869','4.99','2005-07-31T13:21:54.000','2006-02-15T22:15:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7061','261','2','10246','1.99','2005-08-01T02:29:50.000','2006-02-15T22:15:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7062','261','1','11834','1.99','2005-08-17T13:00:40.000','2006-02-15T22:15:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7063','261','2','11928','2.99','2005-08-17T16:28:24.000','2006-02-15T22:15:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7064','261','1','12327','6.99','2005-08-18T06:43:22.000','2006-02-15T22:15:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7065','261','2','13245','4.99','2005-08-19T16:43:41.000','2006-02-15T22:15:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7066','261','2','13506','5.99','2005-08-20T02:07:06.000','2006-02-15T22:15:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7067','261','1','13669','2.99','2005-08-20T08:26:32.000','2006-02-15T22:15:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7068','261','1','13849','4.99','2005-08-20T14:42:34.000','2006-02-15T22:15:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7069','261','2','15397','4.99','2005-08-22T23:08:46.000','2006-02-15T22:15:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7070','262','2','984','4.99','2005-05-30T22:17:17.000','2006-02-15T22:15:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7071','262','1','1563','2.99','2005-06-16T02:46:28.000','2006-02-15T22:15:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7072','262','1','2771','6.99','2005-06-19T17:54:48.000','2006-02-15T22:15:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7073','262','2','2850','8.99','2005-06-19T23:06:28.000','2006-02-15T22:15:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7074','262','1','2915','1.99','2005-06-20T03:57:17.000','2006-02-15T22:15:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7075','262','1','3521','1.99','2005-07-06T01:00:11.000','2006-02-15T22:15:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7076','262','1','3699','3.99','2005-07-06T10:11:25.000','2006-02-15T22:15:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7077','262','1','4501','0.99','2005-07-08T02:12:00.000','2006-02-15T22:15:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7078','262','2','5503','0.99','2005-07-10T00:35:37.000','2006-02-15T22:15:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7079','262','1','6291','0.99','2005-07-11T17:16:40.000','2006-02-15T22:15:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7080','262','2','6547','7.99','2005-07-12T04:57:46.000','2006-02-15T22:15:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7081','262','1','6724','3.99','2005-07-12T13:45:15.000','2006-02-15T22:15:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7082','262','2','6762','7.99','2005-07-12T15:25:33.000','2006-02-15T22:15:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7083','262','1','6805','6.99','2005-07-12T17:23:01.000','2006-02-15T22:15:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7084','262','1','6986','4.99','2005-07-27T00:59:05.000','2006-02-15T22:15:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7085','262','1','9105','6.99','2005-07-30T08:50:25.000','2006-02-15T22:15:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7086','262','2','10421','0.99','2005-08-01T08:14:10.000','2006-02-15T22:15:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7087','262','2','10770','0.99','2005-08-01T20:45:39.000','2006-02-15T22:15:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7088','262','2','13466','2.99','2005-08-20T00:55:16.000','2006-02-15T22:15:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7089','262','1','13808','5.99','2005-08-20T12:55:43.000','2006-02-15T22:15:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7090','262','1','14180','4.99','2005-08-21T03:16:15.000','2006-02-15T22:15:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7091','262','2','14465','3.99','2005-08-21T12:54:22.000','2006-02-15T22:15:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7092','262','2','14834','6.99','2005-08-22T01:45:58.000','2006-02-15T22:15:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7093','262','2','15270','3.99','2005-08-22T18:48:42.000','2006-02-15T22:15:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7094','262','1','15456','0.99','2005-08-23T01:07:01.000','2006-02-15T22:15:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7095','262','1','15640','4.99','2005-08-23T08:04:40.000','2006-02-15T22:15:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7096','262','2','15771','4.99','2005-08-23T13:18:46.000','2006-02-15T22:15:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7097','262','1','15918','3.99','2005-08-23T17:57:35.000','2006-02-15T22:15:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7098','263','1','97','4.99','2005-05-25T16:34:24.000','2006-02-15T22:15:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7099','263','1','266','0.99','2005-05-26T16:08:05.000','2006-02-15T22:15:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7100','263','2','2126','8.99','2005-06-17T20:54:36.000','2006-02-15T22:15:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7101','263','2','3257','1.99','2005-06-21T03:47:19.000','2006-02-15T22:15:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7102','263','1','3578','4.99','2005-07-06T03:47:05.000','2006-02-15T22:15:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7103','263','2','3773','2.99','2005-07-06T13:23:34.000','2006-02-15T22:15:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7104','263','2','4637','0.99','2005-07-08T08:49:54.000','2006-02-15T22:15:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7105','263','2','4682','2.99','2005-07-08T10:38:27.000','2006-02-15T22:15:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7106','263','2','5125','2.99','2005-07-09T07:25:28.000','2006-02-15T22:15:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7107','263','2','5254','1.99','2005-07-09T13:50:11.000','2006-02-15T22:15:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7108','263','2','6376','4.99','2005-07-11T21:40:23.000','2006-02-15T22:15:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7109','263','1','6483','2.99','2005-07-12T01:59:20.000','2006-02-15T22:15:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7110','263','1','6808','1.99','2005-07-12T17:36:42.000','2006-02-15T22:15:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7111','263','2','7291','4.99','2005-07-27T12:30:47.000','2006-02-15T22:15:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7112','263','1','7425','4.99','2005-07-27T17:18:35.000','2006-02-15T22:15:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7113','263','1','7706','4.99','2005-07-28T04:03:17.000','2006-02-15T22:15:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7114','263','2','7833','1.99','2005-07-28T08:46:14.000','2006-02-15T22:15:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7115','263','1','10476','6.99','2005-08-01T10:03:20.000','2006-02-15T22:15:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7116','263','1','10775','2.99','2005-08-01T20:59:52.000','2006-02-15T22:15:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7117','263','1','11339','2.99','2005-08-02T17:02:06.000','2006-02-15T22:15:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7118','263','1','11822','0.99','2005-08-17T12:32:39.000','2006-02-15T22:15:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7119','263','2','12057','9.99','2005-08-17T21:04:35.000','2006-02-15T22:15:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7120','263','2','12432','5.99','2005-08-18T10:35:13.000','2006-02-15T22:15:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7121','263','2','12919','6.99','2005-08-19T04:32:15.000','2006-02-15T22:15:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7122','263','1','14335','3.99','2005-08-21T08:33:07.000','2006-02-15T22:15:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7123','263','2','14448','6.99','2005-08-21T12:13:10.000','2006-02-15T22:15:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7124','263','1','15322','4.99','2005-08-22T20:20:30.000','2006-02-15T22:15:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7125','263','2','15922','7.99','2005-08-23T18:07:31.000','2006-02-15T22:15:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7126','263','1','15293','0.99','2006-02-14T15:16:03.000','2006-02-15T22:15:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7127','264','2','1165','3.99','2005-06-14T23:16:27.000','2006-02-15T22:15:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7128','264','1','1206','4.99','2005-06-15T02:27:07.000','2006-02-15T22:15:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7129','264','1','3028','0.99','2005-06-20T11:50:52.000','2006-02-15T22:15:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7130','264','1','3403','3.99','2005-06-21T15:55:06.000','2006-02-15T22:15:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7131','264','1','3618','6.99','2005-07-06T05:58:45.000','2006-02-15T22:15:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7132','264','1','4328','4.99','2005-07-07T18:03:17.000','2006-02-15T22:15:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7133','264','1','4539','0.99','2005-07-08T04:01:02.000','2006-02-15T22:15:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7134','264','1','6340','8.99','2005-07-11T19:46:05.000','2006-02-15T22:15:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7135','264','2','6391','0.99','2005-07-11T22:23:09.000','2006-02-15T22:15:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7136','264','1','6395','2.99','2005-07-11T22:29:29.000','2006-02-15T22:15:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7137','264','1','6543','0.99','2005-07-12T04:54:32.000','2006-02-15T22:15:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7138','264','1','7006','8.99','2005-07-27T01:42:20.000','2006-02-15T22:15:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7139','264','2','9380','2.99','2005-07-30T19:17:31.000','2006-02-15T22:15:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7140','264','2','9515','0.99','2005-07-31T00:35:05.000','2006-02-15T22:15:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7141','264','1','9861','5.99','2005-07-31T13:04:14.000','2006-02-15T22:15:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7142','264','1','9932','5.99','2005-07-31T15:19:48.000','2006-02-15T22:15:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7143','264','2','10792','2.99','2005-08-01T21:44:24.000','2006-02-15T22:15:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7144','264','1','11527','3.99','2005-08-17T00:25:06.000','2006-02-15T22:15:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7145','264','2','11533','0.99','2005-08-17T00:34:53.000','2006-02-15T22:15:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7146','264','1','11539','2.99','2005-08-17T00:45:41.000','2006-02-15T22:15:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7147','264','1','12518','4.99','2005-08-18T13:41:32.000','2006-02-15T22:15:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7148','264','2','13590','2.99','2005-08-20T05:48:59.000','2006-02-15T22:15:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7149','264','1','13664','5.99','2005-08-20T08:18:36.000','2006-02-15T22:15:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7150','264','1','15595','4.99','2005-08-23T06:19:12.000','2006-02-15T22:15:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7151','264','2','14243','2.99','2006-02-14T15:16:03.000','2006-02-15T22:15:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7152','265','2','74','0.99','2005-05-25T11:09:48.000','2006-02-15T22:15:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7153','265','2','2027','7.99','2005-06-17T13:06:56.000','2006-02-15T22:15:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7154','265','2','2562','4.99','2005-06-19T03:15:05.000','2006-02-15T22:15:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7155','265','1','2598','2.99','2005-06-19T05:59:57.000','2006-02-15T22:15:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7156','265','1','3823','2.99','2005-07-06T15:41:27.000','2006-02-15T22:15:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7157','265','1','4610','0.99','2005-07-08T07:28:05.000','2006-02-15T22:15:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7158','265','1','4797','2.99','2005-07-08T16:39:05.000','2006-02-15T22:15:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7159','265','2','5029','7.99','2005-07-09T02:35:32.000','2006-02-15T22:15:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7160','265','1','5417','4.99','2005-07-09T20:34:09.000','2006-02-15T22:15:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7161','265','1','5710','9.99','2005-07-10T10:32:52.000','2006-02-15T22:15:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7162','265','1','6068','4.99','2005-07-11T04:41:09.000','2006-02-15T22:15:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7163','265','2','6371','4.99','2005-07-11T21:31:51.000','2006-02-15T22:15:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7164','265','2','6553','5.99','2005-07-12T05:06:39.000','2006-02-15T22:15:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7165','265','2','6921','6.99','2005-07-12T22:39:03.000','2006-02-15T22:15:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7166','265','2','7414','1.99','2005-07-27T16:46:07.000','2006-02-15T22:15:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7167','265','1','7704','2.99','2005-07-28T04:02:13.000','2006-02-15T22:15:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7168','265','1','8278','5.99','2005-07-29T01:42:55.000','2006-02-15T22:15:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7169','265','2','8489','2.99','2005-07-29T08:58:03.000','2006-02-15T22:15:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7170','265','2','8665','0.99','2005-07-29T15:39:29.000','2006-02-15T22:15:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7171','265','1','9416','2.99','2005-07-30T20:52:45.000','2006-02-15T22:15:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7172','265','2','10592','3.99','2005-08-01T14:13:00.000','2006-02-15T22:15:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7173','265','2','11000','3.99','2005-08-02T04:56:14.000','2006-02-15T22:15:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7174','265','1','12207','1.99','2005-08-18T02:24:07.000','2006-02-15T22:15:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7175','265','2','12346','4.99','2005-08-18T07:17:55.000','2006-02-15T22:15:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7176','265','2','13700','8.99','2005-08-20T09:26:17.000','2006-02-15T22:15:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7177','265','2','14125','4.99','2005-08-21T01:32:16.000','2006-02-15T22:15:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7178','265','1','14547','6.99','2005-08-21T15:51:38.000','2006-02-15T22:15:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7179','265','2','14556','6.99','2005-08-21T16:03:27.000','2006-02-15T22:15:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7180','265','1','14943','2.99','2005-08-22T05:59:59.000','2006-02-15T22:15:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7181','266','1','86','1.99','2005-05-25T13:36:12.000','2006-02-15T22:15:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7182','266','2','651','2.99','2005-05-28T19:46:50.000','2006-02-15T22:15:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7183','266','2','1280','5.99','2005-06-15T08:16:06.000','2006-02-15T22:15:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7184','266','2','2065','4.99','2005-06-17T16:03:46.000','2006-02-15T22:15:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7185','266','2','3002','4.99','2005-06-20T09:56:12.000','2006-02-15T22:15:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7186','266','1','3059','4.99','2005-06-20T13:38:41.000','2006-02-15T22:15:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7187','266','2','3585','0.99','2005-07-06T04:22:36.000','2006-02-15T22:15:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7188','266','2','5362','5.99','2005-07-09T18:16:08.000','2006-02-15T22:15:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7189','266','1','5577','4.99','2005-07-10T03:58:40.000','2006-02-15T22:15:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7190','266','1','8492','2.99','2005-07-29T09:04:17.000','2006-02-15T22:15:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7191','266','2','9109','5.99','2005-07-30T08:58:24.000','2006-02-15T22:15:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7192','266','2','10747','4.99','2005-08-01T19:59:41.000','2006-02-15T22:15:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7193','266','2','10910','5.99','2005-08-02T01:54:34.000','2006-02-15T22:15:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7194','266','2','11233','5.99','2005-08-02T13:06:11.000','2006-02-15T22:15:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7195','266','1','11321','4.99','2005-08-02T16:15:07.000','2006-02-15T22:15:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7196','266','2','11626','0.99','2005-08-17T04:25:42.000','2006-02-15T22:15:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7197','266','1','11726','0.99','2005-08-17T08:11:10.000','2006-02-15T22:15:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7198','266','1','12255','4.99','2005-08-18T04:07:20.000','2006-02-15T22:15:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7199','266','2','12378','0.99','2005-08-18T08:26:13.000','2006-02-15T22:15:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7200','266','1','12405','6.99','2005-08-18T09:37:30.000','2006-02-15T22:15:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7201','266','1','12715','4.99','2005-08-18T21:09:38.000','2006-02-15T22:15:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7202','266','1','13468','8.99','2005-08-20T00:56:44.000','2006-02-15T22:15:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7203','266','1','13556','6.99','2005-08-20T04:10:26.000','2006-02-15T22:15:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7204','266','1','14080','1.99','2005-08-20T23:29:50.000','2006-02-15T22:15:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7205','266','1','14492','2.99','2005-08-21T13:59:08.000','2006-02-15T22:15:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7206','266','1','14877','0.99','2005-08-22T03:39:56.000','2006-02-15T22:15:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7207','266','1','15181','2.99','2005-08-22T15:46:20.000','2006-02-15T22:15:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7208','266','1','15346','4.99','2005-08-22T21:06:00.000','2006-02-15T22:15:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7209','267','2','91','6.99','2005-05-25T14:57:22.000','2006-02-15T22:15:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7210','267','1','436','4.99','2005-05-27T17:21:04.000','2006-02-15T22:15:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7211','267','2','1030','4.99','2005-05-31T04:06:47.000','2006-02-15T22:15:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7212','267','2','1257','4.99','2005-06-15T06:15:36.000','2006-02-15T22:15:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7213','267','2','1349','4.99','2005-06-15T12:49:02.000','2006-02-15T22:15:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7214','267','2','2265','2.99','2005-06-18T06:03:27.000','2006-02-15T22:15:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7215','267','2','2578','7.99','2005-06-19T04:40:06.000','2006-02-15T22:15:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7216','267','1','2582','6.99','2005-06-19T04:56:27.000','2006-02-15T22:15:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7217','267','2','2699','2.99','2005-06-19T13:29:28.000','2006-02-15T22:15:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7218','267','2','2754','4.99','2005-06-19T16:55:59.000','2006-02-15T22:15:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7219','267','1','2877','1.99','2005-06-20T01:07:16.000','2006-02-15T22:15:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7220','267','2','3090','0.99','2005-06-20T16:00:19.000','2006-02-15T22:15:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7221','267','1','3817','2.99','2005-07-06T15:31:45.000','2006-02-15T22:15:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7222','267','1','5340','6.99','2005-07-09T17:11:35.000','2006-02-15T22:15:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7223','267','1','6070','0.99','2005-07-11T04:47:42.000','2006-02-15T22:15:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7224','267','1','6706','3.99','2005-07-12T12:59:16.000','2006-02-15T22:15:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7225','267','1','8190','4.99','2005-07-28T22:47:06.000','2006-02-15T22:15:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7226','267','1','8572','1.99','2005-07-29T11:51:24.000','2006-02-15T22:15:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7227','267','2','9059','3.99','2005-07-30T07:18:44.000','2006-02-15T22:15:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7228','267','1','9308','6.99','2005-07-30T16:53:21.000','2006-02-15T22:15:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7229','267','2','9403','4.99','2005-07-30T20:18:53.000','2006-02-15T22:15:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7230','267','2','9807','2.99','2005-07-31T11:13:52.000','2006-02-15T22:15:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7231','267','2','10048','4.99','2005-07-31T19:08:56.000','2006-02-15T22:15:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7232','267','1','10343','2.99','2005-08-01T05:15:47.000','2006-02-15T22:15:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7233','267','2','11373','0.99','2005-08-02T18:14:12.000','2006-02-15T22:15:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7234','267','1','11690','6.99','2005-08-17T06:44:22.000','2006-02-15T22:15:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7235','267','1','12320','4.99','2005-08-18T06:26:51.000','2006-02-15T22:15:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7236','267','1','12979','4.99','2005-08-19T07:00:35.000','2006-02-15T22:15:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7237','267','2','13236','9.99','2005-08-19T16:18:24.000','2006-02-15T22:15:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7238','267','1','14131','5.99','2005-08-21T01:43:40.000','2006-02-15T22:15:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7239','267','2','15020','3.99','2005-08-22T08:54:12.000','2006-02-15T22:15:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7240','267','1','15208','3.99','2005-08-22T16:35:47.000','2006-02-15T22:15:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7241','267','1','15768','0.99','2005-08-23T13:14:47.000','2006-02-15T22:15:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7242','267','1','15903','3.99','2005-08-23T17:30:40.000','2006-02-15T22:15:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7243','267','2','12066','7.98','2006-02-14T15:16:03.000','2006-02-15T22:15:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7244','267','2','13713','0','2006-02-14T15:16:03.000','2006-02-15T22:15:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7245','268','1','1394','2.99','2005-06-15T16:17:21.000','2006-02-15T22:15:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7246','268','2','1450','4.99','2005-06-15T19:22:08.000','2006-02-15T22:15:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7247','268','2','1551','3.99','2005-06-16T02:01:15.000','2006-02-15T22:15:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7248','268','1','2133','0.99','2005-06-17T21:10:05.000','2006-02-15T22:15:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7249','268','2','2324','4.99','2005-06-18T10:00:33.000','2006-02-15T22:15:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7250','268','2','2858','2.99','2005-06-19T23:17:11.000','2006-02-15T22:15:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7251','268','1','3066','3.99','2005-06-20T13:55:41.000','2006-02-15T22:15:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7252','268','1','3361','1.99','2005-06-21T12:14:23.000','2006-02-15T22:15:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7253','268','2','3670','4.99','2005-07-06T08:56:43.000','2006-02-15T22:15:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7254','268','2','4626','4.99','2005-07-08T08:18:21.000','2006-02-15T22:15:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7255','268','1','5039','7.99','2005-07-09T03:14:45.000','2006-02-15T22:15:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7256','268','2','5671','2.99','2005-07-10T08:18:22.000','2006-02-15T22:15:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7257','268','2','5793','2.99','2005-07-10T14:33:00.000','2006-02-15T22:15:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7258','268','2','5888','6.99','2005-07-10T19:52:17.000','2006-02-15T22:15:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7259','268','1','6120','3.99','2005-07-11T07:49:53.000','2006-02-15T22:15:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7260','268','2','6489','1.99','2005-07-12T02:22:46.000','2006-02-15T22:15:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7261','268','1','8931','2.99','2005-07-30T02:30:07.000','2006-02-15T22:15:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7262','268','2','9436','7.99','2005-07-30T21:33:01.000','2006-02-15T22:15:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7263','268','2','9531','3.99','2005-07-31T01:11:53.000','2006-02-15T22:15:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7264','268','1','10040','1.99','2005-07-31T18:54:15.000','2006-02-15T22:15:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7265','268','2','11462','7.99','2005-08-02T21:36:46.000','2006-02-15T22:15:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7266','268','2','11828','6.99','2005-08-17T12:48:28.000','2006-02-15T22:15:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7267','268','2','12007','2.99','2005-08-17T19:10:34.000','2006-02-15T22:15:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7268','268','2','12694','4.99','2005-08-18T20:10:39.000','2006-02-15T22:15:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7269','268','2','13880','5.99','2005-08-20T15:18:20.000','2006-02-15T22:15:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7270','268','2','14249','4.99','2005-08-21T05:38:05.000','2006-02-15T22:15:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7271','268','2','14373','4.99','2005-08-21T09:44:53.000','2006-02-15T22:15:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7272','268','1','14874','0.99','2005-08-22T03:32:05.000','2006-02-15T22:15:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7273','268','2','15183','2.99','2005-08-22T15:49:54.000','2006-02-15T22:15:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7274','269','2','7','1.99','2005-05-24T23:11:53.000','2006-02-15T22:15:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7275','269','1','98','0.99','2005-05-25T16:48:24.000','2006-02-15T22:15:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7276','269','2','678','6.99','2005-05-28T23:15:48.000','2006-02-15T22:15:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7277','269','2','703','0.99','2005-05-29T02:29:36.000','2006-02-15T22:15:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7278','269','1','750','4.99','2005-05-29T09:41:40.000','2006-02-15T22:15:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7279','269','2','1099','2.99','2005-05-31T13:54:48.000','2006-02-15T22:15:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7280','269','1','1334','3.99','2005-06-15T11:43:09.000','2006-02-15T22:15:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7281','269','2','1909','2.99','2005-06-17T05:11:04.000','2006-02-15T22:15:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7282','269','2','2493','6.99','2005-06-18T22:12:09.000','2006-02-15T22:15:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7283','269','1','4125','9.99','2005-07-07T07:20:29.000','2006-02-15T22:15:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7284','269','2','4804','0.99','2005-07-08T16:57:30.000','2006-02-15T22:15:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7285','269','2','4880','6.99','2005-07-08T19:36:17.000','2006-02-15T22:15:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7286','269','1','6440','2.99','2005-07-12T00:25:04.000','2006-02-15T22:15:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7287','269','1','6626','5.99','2005-07-12T09:16:24.000','2006-02-15T22:15:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7288','269','2','6804','4.99','2005-07-12T17:22:06.000','2006-02-15T22:15:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7289','269','1','7032','4.99','2005-07-27T03:03:09.000','2006-02-15T22:15:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7290','269','1','7537','6.99','2005-07-27T21:36:09.000','2006-02-15T22:15:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7291','269','1','7972','2.99','2005-07-28T14:07:46.000','2006-02-15T22:15:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7292','269','2','10566','2.99','2005-08-01T13:12:11.000','2006-02-15T22:15:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7293','269','1','10908','4.99','2005-08-02T01:53:06.000','2006-02-15T22:15:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7294','269','1','11014','4.99','2005-08-02T05:12:22.000','2006-02-15T22:15:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7295','269','1','11915','3.99','2005-08-17T16:05:28.000','2006-02-15T22:15:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7296','269','1','12344','4.99','2005-08-18T07:15:19.000','2006-02-15T22:15:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7297','269','2','13142','5.99','2005-08-19T12:42:28.000','2006-02-15T22:15:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7298','269','2','13759','2.99','2005-08-20T11:24:48.000','2006-02-15T22:15:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7299','269','1','14266','4.99','2005-08-21T06:20:51.000','2006-02-15T22:15:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7300','269','2','14693','6.99','2005-08-21T20:44:19.000','2006-02-15T22:15:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7301','269','2','15788','2.99','2005-08-23T13:54:39.000','2006-02-15T22:15:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7302','269','1','13025','3.98','2006-02-14T15:16:03.000','2006-02-15T22:15:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7303','269','2','12610','0','2006-02-14T15:16:03.000','2006-02-15T22:15:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7304','270','1','193','1.99','2005-05-26T06:41:48.000','2006-02-15T22:15:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7305','270','1','1040','4.99','2005-05-31T05:35:16.000','2006-02-15T22:15:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7306','270','1','1345','4.99','2005-06-15T12:32:13.000','2006-02-15T22:15:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7307','270','1','1896','6.99','2005-06-17T04:25:46.000','2006-02-15T22:15:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7308','270','1','2115','3.99','2005-06-17T20:02:16.000','2006-02-15T22:15:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7309','270','2','3164','5.99','2005-06-20T21:29:00.000','2006-02-15T22:15:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7310','270','1','3501','3.99','2005-07-06T00:11:28.000','2006-02-15T22:15:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7311','270','1','3987','9.99','2005-07-06T23:28:24.000','2006-02-15T22:15:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7312','270','2','5533','0.99','2005-07-10T02:19:28.000','2006-02-15T22:15:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7313','270','2','6520','4.99','2005-07-12T04:05:16.000','2006-02-15T22:15:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7314','270','1','8355','2.99','2005-07-29T04:57:43.000','2006-02-15T22:15:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7315','270','2','8618','3.99','2005-07-29T13:48:20.000','2006-02-15T22:15:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7316','270','1','10069','3.99','2005-07-31T19:43:18.000','2006-02-15T22:15:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7317','270','1','10461','7.99','2005-08-01T09:32:53.000','2006-02-15T22:15:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7318','270','2','10579','5.99','2005-08-01T13:48:22.000','2006-02-15T22:15:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7319','270','2','10648','4.99','2005-08-01T16:08:52.000','2006-02-15T22:15:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7320','270','1','11389','2.99','2005-08-02T18:39:12.000','2006-02-15T22:15:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7321','270','1','11810','0.99','2005-08-17T11:56:48.000','2006-02-15T22:15:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7322','270','2','11841','2.99','2005-08-17T13:12:20.000','2006-02-15T22:15:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7323','270','1','11917','2.99','2005-08-17T16:08:17.000','2006-02-15T22:15:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7324','270','1','12192','2.99','2005-08-18T02:01:40.000','2006-02-15T22:15:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7325','270','1','12442','2.99','2005-08-18T10:50:07.000','2006-02-15T22:15:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7326','270','2','13945','1.99','2005-08-20T17:43:56.000','2006-02-15T22:15:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7327','270','1','14618','0.99','2005-08-21T18:09:51.000','2006-02-15T22:15:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7328','270','2','15620','6.99','2005-08-23T07:10:22.000','2006-02-15T22:15:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7329','271','1','1096','8.99','2005-05-31T13:30:49.000','2006-02-15T22:15:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7330','271','2','1852','2.99','2005-06-17T00:38:20.000','2006-02-15T22:15:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7331','271','1','3640','1.99','2005-07-06T07:12:26.000','2006-02-15T22:15:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7332','271','2','4545','2.99','2005-07-08T04:17:47.000','2006-02-15T22:15:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7333','271','2','5878','1.99','2005-07-10T19:09:57.000','2006-02-15T22:15:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7334','271','1','5922','2.99','2005-07-10T21:36:53.000','2006-02-15T22:15:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7335','271','1','6024','2.99','2005-07-11T02:16:47.000','2006-02-15T22:15:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7336','271','1','7618','3.99','2005-07-28T00:24:14.000','2006-02-15T22:15:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7337','271','1','8592','0.99','2005-07-29T12:33:58.000','2006-02-15T22:15:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7338','271','1','9821','4.99','2005-07-31T11:47:54.000','2006-02-15T22:15:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7339','271','2','10143','7.99','2005-07-31T22:11:43.000','2006-02-15T22:15:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7340','271','2','10310','4.99','2005-08-01T04:24:47.000','2006-02-15T22:15:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7341','271','1','10599','3.99','2005-08-01T14:23:58.000','2006-02-15T22:15:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7342','271','1','11431','2.99','2005-08-02T20:05:16.000','2006-02-15T22:15:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7343','271','1','12219','4.99','2005-08-18T02:49:54.000','2006-02-15T22:15:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7344','271','2','14234','0.99','2005-08-21T05:07:12.000','2006-02-15T22:15:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7345','271','2','14355','4.99','2005-08-21T09:08:29.000','2006-02-15T22:15:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7346','271','1','15244','2.99','2005-08-22T17:48:42.000','2006-02-15T22:15:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7347','272','1','33','0.99','2005-05-25T04:18:51.000','2006-02-15T22:15:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7348','272','1','405','6.99','2005-05-27T13:32:39.000','2006-02-15T22:15:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7349','272','1','1041','6.99','2005-05-31T05:46:23.000','2006-02-15T22:15:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7350','272','1','1072','0.99','2005-05-31T09:52:50.000','2006-02-15T22:15:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7351','272','2','1604','4.99','2005-06-16T06:14:25.000','2006-02-15T22:15:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7352','272','2','2546','5.99','2005-06-19T02:39:39.000','2006-02-15T22:15:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7353','272','1','3323','5.99','2005-06-21T08:45:33.000','2006-02-15T22:15:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7354','272','2','5047','3.99','2005-07-09T03:44:15.000','2006-02-15T22:15:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7355','272','2','5158','2.99','2005-07-09T08:53:09.000','2006-02-15T22:15:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7356','272','2','7300','7.99','2005-07-27T12:50:17.000','2006-02-15T22:15:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7357','272','2','7658','2.99','2005-07-28T02:09:12.000','2006-02-15T22:15:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7358','272','1','8248','7.99','2005-07-29T00:41:56.000','2006-02-15T22:15:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7359','272','2','9787','10.99','2005-07-31T10:26:19.000','2006-02-15T22:15:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7360','272','1','10736','2.99','2005-08-01T19:30:21.000','2006-02-15T22:15:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7361','272','2','11003','2.99','2005-08-02T05:03:05.000','2006-02-15T22:15:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7362','272','2','11597','8.99','2005-08-17T03:02:56.000','2006-02-15T22:15:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7363','272','1','11881','0.99','2005-08-17T14:31:56.000','2006-02-15T22:15:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7364','272','2','12006','6.99','2005-08-17T19:09:12.000','2006-02-15T22:15:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7365','272','2','13274','2.99','2005-08-19T17:50:03.000','2006-02-15T22:15:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7366','272','1','13903','2.99','2005-08-20T16:07:55.000','2006-02-15T22:15:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7367','273','2','122','3.99','2005-05-25T19:46:21.000','2006-02-15T22:15:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7368','273','2','980','0.99','2005-05-30T21:45:19.000','2006-02-15T22:15:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7369','273','2','1391','6.99','2005-06-15T16:11:21.000','2006-02-15T22:15:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7370','273','2','1747','6.99','2005-06-16T16:53:33.000','2006-02-15T22:15:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7371','273','2','1765','4.99','2005-06-16T17:56:10.000','2006-02-15T22:15:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7372','273','1','2301','1.99','2005-06-18T08:24:03.000','2006-02-15T22:15:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7373','273','1','3202','0.99','2005-06-21T00:33:47.000','2006-02-15T22:15:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7374','273','2','3556','2.99','2005-07-06T02:46:13.000','2006-02-15T22:15:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7375','273','1','4937','5.99','2005-07-08T22:29:59.000','2006-02-15T22:15:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7376','273','1','5256','7.99','2005-07-09T13:55:45.000','2006-02-15T22:15:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7377','273','2','5435','7.99','2005-07-09T21:28:07.000','2006-02-15T22:15:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7378','273','1','5605','2.99','2005-07-10T05:06:45.000','2006-02-15T22:15:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7379','273','1','6592','8.99','2005-07-12T07:19:35.000','2006-02-15T22:15:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7380','273','1','6635','1.99','2005-07-12T09:47:58.000','2006-02-15T22:15:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7381','273','2','6696','2.99','2005-07-12T12:44:04.000','2006-02-15T22:15:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7382','273','1','6717','5.99','2005-07-12T13:35:02.000','2006-02-15T22:15:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7383','273','1','8449','2.99','2005-07-29T07:42:25.000','2006-02-15T22:15:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7384','273','1','9186','4.99','2005-07-30T12:13:48.000','2006-02-15T22:15:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7385','273','2','9285','5.99','2005-07-30T15:26:08.000','2006-02-15T22:15:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7386','273','2','9391','0.99','2005-07-30T19:48:41.000','2006-02-15T22:15:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7387','273','2','9693','3.99','2005-07-31T07:11:50.000','2006-02-15T22:15:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7388','273','2','9729','0.99','2005-07-31T08:43:43.000','2006-02-15T22:15:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7389','273','1','10272','8.99','2005-08-01T03:14:34.000','2006-02-15T22:15:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7390','273','1','10753','3.99','2005-08-01T20:09:24.000','2006-02-15T22:15:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7391','273','1','10768','6.99','2005-08-01T20:39:32.000','2006-02-15T22:15:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7392','273','1','11282','4.99','2005-08-02T14:35:03.000','2006-02-15T22:15:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7393','273','2','11509','4.99','2005-08-16T23:29:53.000','2006-02-15T22:15:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7394','273','1','12692','0.99','2005-08-18T20:09:19.000','2006-02-15T22:15:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7395','273','2','13738','4.99','2005-08-20T10:42:42.000','2006-02-15T22:15:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7396','273','1','13955','5.99','2005-08-20T18:05:12.000','2006-02-15T22:15:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7397','273','2','14092','4.99','2005-08-21T00:14:32.000','2006-02-15T22:15:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7398','273','2','14558','2.99','2005-08-21T16:10:50.000','2006-02-15T22:15:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7399','273','2','14911','2.99','2005-08-22T04:51:42.000','2006-02-15T22:15:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7400','273','2','15372','2.99','2005-08-22T21:59:51.000','2006-02-15T22:15:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7401','273','1','15760','6.99','2005-08-23T12:50:00.000','2006-02-15T22:15:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7402','274','1','147','2.99','2005-05-26T00:17:50.000','2006-02-15T22:15:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7403','274','1','208','4.99','2005-05-26T08:10:22.000','2006-02-15T22:15:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7404','274','2','301','2.99','2005-05-26T21:06:14.000','2006-02-15T22:15:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7405','274','1','394','5.99','2005-05-27T11:26:11.000','2006-02-15T22:15:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7406','274','2','474','2.99','2005-05-27T22:11:56.000','2006-02-15T22:15:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7407','274','1','892','4.99','2005-05-30T08:02:56.000','2006-02-15T22:15:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7408','274','1','2098','0.99','2005-06-17T18:42:09.000','2006-02-15T22:15:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7409','274','2','3291','9.99','2005-06-21T06:55:36.000','2006-02-15T22:15:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7410','274','2','3532','5.99','2005-07-06T01:24:38.000','2006-02-15T22:15:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7411','274','1','4147','2.99','2005-07-07T08:32:12.000','2006-02-15T22:15:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7412','274','2','4582','2.99','2005-07-08T06:09:09.000','2006-02-15T22:15:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7413','274','2','6389','3.99','2005-07-11T22:18:20.000','2006-02-15T22:15:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7414','274','2','8259','0.99','2005-07-29T01:05:16.000','2006-02-15T22:15:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7415','274','2','8406','5.99','2005-07-29T06:34:45.000','2006-02-15T22:15:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7416','274','2','8517','7.99','2005-07-29T10:00:48.000','2006-02-15T22:15:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7417','274','1','9331','4.99','2005-07-30T17:46:50.000','2006-02-15T22:15:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7418','274','1','9677','4.99','2005-07-31T06:39:45.000','2006-02-15T22:15:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7419','274','2','10059','4.99','2005-07-31T19:20:49.000','2006-02-15T22:15:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7420','274','1','10790','1.99','2005-08-01T21:38:37.000','2006-02-15T22:15:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7421','274','2','10855','0.99','2005-08-02T00:06:37.000','2006-02-15T22:15:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7422','274','1','11058','3.99','2005-08-02T06:38:44.000','2006-02-15T22:15:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7423','274','2','11363','2.99','2005-08-02T17:48:39.000','2006-02-15T22:15:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7424','274','1','12321','3.99','2005-08-18T06:27:05.000','2006-02-15T22:15:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7425','274','1','13103','2.99','2005-08-19T11:05:51.000','2006-02-15T22:15:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7426','274','2','13129','8.99','2005-08-19T12:05:04.000','2006-02-15T22:15:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7427','274','1','13549','8.99','2005-08-20T03:58:41.000','2006-02-15T22:15:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7428','274','1','14012','0.99','2005-08-20T20:42:12.000','2006-02-15T22:15:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7429','274','1','14066','7.99','2005-08-20T22:45:58.000','2006-02-15T22:15:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7430','274','2','14164','7.99','2005-08-21T02:58:02.000','2006-02-15T22:15:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7431','274','1','14388','4.99','2005-08-21T10:15:13.000','2006-02-15T22:15:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7432','274','2','15143','2.99','2005-08-22T13:46:24.000','2006-02-15T22:15:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7433','274','1','15260','2.99','2005-08-22T18:24:16.000','2006-02-15T22:15:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7434','274','2','15328','2.99','2005-08-22T20:31:38.000','2006-02-15T22:15:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7435','274','2','15819','3.99','2005-08-23T15:01:54.000','2006-02-15T22:15:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7436','274','1','13486','0.99','2006-02-14T15:16:03.000','2006-02-15T22:15:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7437','275','2','336','2.99','2005-05-27T03:15:23.000','2006-02-15T22:15:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7438','275','2','1797','3.99','2005-06-16T20:13:03.000','2006-02-15T22:15:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7439','275','2','2414','0.99','2005-06-18T17:01:55.000','2006-02-15T22:15:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7440','275','1','2646','4.99','2005-06-19T09:56:01.000','2006-02-15T22:15:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7441','275','1','3355','2.99','2005-06-21T11:30:47.000','2006-02-15T22:15:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7442','275','2','4396','0.99','2005-07-07T21:14:19.000','2006-02-15T22:15:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7443','275','1','4634','0.99','2005-07-08T08:40:02.000','2006-02-15T22:15:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7444','275','2','4912','9.99','2005-07-08T21:26:11.000','2006-02-15T22:15:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7445','275','2','6301','5.99','2005-07-11T17:54:09.000','2006-02-15T22:15:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7446','275','2','6856','0.99','2005-07-12T19:50:16.000','2006-02-15T22:15:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7447','275','1','7553','2.99','2005-07-27T22:11:36.000','2006-02-15T22:15:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7448','275','2','7596','4.99','2005-07-27T23:33:57.000','2006-02-15T22:15:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7449','275','1','8746','2.99','2005-07-29T19:03:15.000','2006-02-15T22:15:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7450','275','2','9258','2.99','2005-07-30T14:31:31.000','2006-02-15T22:15:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7451','275','1','10479','6.99','2005-08-01T10:11:25.000','2006-02-15T22:15:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7452','275','2','11309','1.99','2005-08-02T15:50:55.000','2006-02-15T22:15:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7453','275','1','11610','4.99','2005-08-17T03:43:37.000','2006-02-15T22:15:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7454','275','2','12589','5.99','2005-08-18T16:06:31.000','2006-02-15T22:15:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7455','275','1','12606','1.99','2005-08-18T17:02:21.000','2006-02-15T22:15:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7456','275','1','13037','3.99','2005-08-19T08:53:57.000','2006-02-15T22:15:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7457','275','2','13860','2.99','2005-08-20T14:55:09.000','2006-02-15T22:15:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7458','275','2','13865','1.99','2005-08-20T15:04:09.000','2006-02-15T22:15:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7459','275','2','13902','0.99','2005-08-20T16:07:08.000','2006-02-15T22:15:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7460','275','2','14063','0.99','2005-08-20T22:36:40.000','2006-02-15T22:15:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7461','275','1','14187','5.99','2005-08-21T03:32:03.000','2006-02-15T22:15:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7462','275','1','14296','2.99','2005-08-21T07:13:23.000','2006-02-15T22:15:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7463','275','2','14483','5.99','2005-08-21T13:43:59.000','2006-02-15T22:15:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7464','275','2','14727','4.99','2005-08-21T22:12:45.000','2006-02-15T22:15:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7465','275','2','15269','2.99','2005-08-22T18:39:44.000','2006-02-15T22:15:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7466','275','2','15496','3.99','2005-08-23T02:30:23.000','2006-02-15T22:15:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7467','276','1','736','3.99','2005-05-29T08:10:07.000','2006-02-15T22:15:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7468','276','1','860','10.99','2005-05-30T02:45:16.000','2006-02-15T22:15:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7469','276','1','1352','0.99','2005-06-15T12:58:27.000','2006-02-15T22:15:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7470','276','2','2763','4.99','2005-06-19T17:23:34.000','2006-02-15T22:15:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7471','276','2','3064','6.99','2005-06-20T13:53:13.000','2006-02-15T22:15:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7472','276','2','3714','2.99','2005-07-06T10:51:28.000','2006-02-15T22:15:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7473','276','1','4715','0.99','2005-07-08T12:15:37.000','2006-02-15T22:15:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7474','276','2','5186','4.99','2005-07-09T10:18:40.000','2006-02-15T22:15:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7475','276','2','5246','4.99','2005-07-09T13:25:18.000','2006-02-15T22:15:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7476','276','2','7282','5.99','2005-07-27T12:00:19.000','2006-02-15T22:15:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7477','276','2','7842','2.99','2005-07-28T09:10:06.000','2006-02-15T22:15:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7478','276','1','9070','0.99','2005-07-30T07:40:39.000','2006-02-15T22:15:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7479','276','1','9080','1.99','2005-07-30T08:02:39.000','2006-02-15T22:15:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7480','276','1','9102','4.99','2005-07-30T08:48:20.000','2006-02-15T22:15:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7481','276','1','9229','8.99','2005-07-30T13:38:17.000','2006-02-15T22:15:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7482','276','2','10149','5.99','2005-07-31T22:20:46.000','2006-02-15T22:15:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7483','276','2','10691','0.99','2005-08-01T18:09:53.000','2006-02-15T22:15:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7484','276','1','10763','2.99','2005-08-01T20:32:27.000','2006-02-15T22:15:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7485','276','2','11085','2.99','2005-08-02T07:36:44.000','2006-02-15T22:15:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7486','276','1','11636','4.99','2005-08-17T04:36:31.000','2006-02-15T22:15:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7487','276','2','11961','3.99','2005-08-17T17:28:01.000','2006-02-15T22:15:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7488','276','2','12178','5.99','2005-08-18T01:17:32.000','2006-02-15T22:15:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7489','276','2','12251','4.99','2005-08-18T03:59:02.000','2006-02-15T22:15:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7490','276','1','12650','4.99','2005-08-18T18:33:20.000','2006-02-15T22:15:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7491','276','1','14000','4.99','2005-08-20T20:06:05.000','2006-02-15T22:15:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7492','276','2','15718','2.99','2005-08-23T11:05:17.000','2006-02-15T22:15:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7493','276','1','15769','3.99','2005-08-23T13:16:15.000','2006-02-15T22:15:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7494','276','2','15923','4.99','2005-08-23T18:08:19.000','2006-02-15T22:15:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7495','277','2','308','6.99','2005-05-26T22:01:39.000','2006-02-15T22:15:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7496','277','1','1331','2.99','2005-06-15T11:34:33.000','2006-02-15T22:15:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7497','277','2','1717','2.99','2005-06-16T14:47:16.000','2006-02-15T22:15:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7498','277','2','2162','3.99','2005-06-17T23:45:47.000','2006-02-15T22:15:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7499','277','2','2723','4.99','2005-06-19T14:55:23.000','2006-02-15T22:15:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7500','277','1','3247','5.99','2005-06-21T03:12:15.000','2006-02-15T22:15:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7501','277','2','3274','4.99','2005-06-21T05:30:36.000','2006-02-15T22:15:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7502','277','1','3344','2.99','2005-06-21T10:57:27.000','2006-02-15T22:15:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7503','277','2','3740','5.99','2005-07-06T11:55:35.000','2006-02-15T22:15:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7504','277','2','3897','2.99','2005-07-06T19:11:43.000','2006-02-15T22:15:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7505','277','1','4290','4.99','2005-07-07T15:47:10.000','2006-02-15T22:15:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7506','277','2','4987','5.99','2005-07-09T00:45:41.000','2006-02-15T22:15:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7507','277','1','5861','0.99','2005-07-10T18:14:22.000','2006-02-15T22:15:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7508','277','1','5913','2.99','2005-07-10T20:58:55.000','2006-02-15T22:15:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7509','277','2','6455','2.99','2005-07-12T01:01:58.000','2006-02-15T22:15:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7510','277','1','6487','5.99','2005-07-12T02:17:00.000','2006-02-15T22:15:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7511','277','2','7423','4.99','2005-07-27T17:11:47.000','2006-02-15T22:15:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7512','277','2','8410','2.99','2005-07-29T06:41:36.000','2006-02-15T22:15:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7513','277','2','9669','4.99','2005-07-31T06:31:36.000','2006-02-15T22:15:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7514','277','1','9901','0.99','2005-07-31T14:20:59.000','2006-02-15T22:15:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7515','277','2','11074','3.99','2005-08-02T07:21:43.000','2006-02-15T22:15:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7516','277','2','11162','4.99','2005-08-02T10:07:54.000','2006-02-15T22:15:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7517','277','2','11574','0.99','2005-08-17T01:38:19.000','2006-02-15T22:15:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7518','277','2','12149','3.99','2005-08-18T00:13:51.000','2006-02-15T22:15:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7519','277','1','12458','5.99','2005-08-18T11:22:53.000','2006-02-15T22:15:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7520','277','1','13122','4.99','2005-08-19T11:53:49.000','2006-02-15T22:15:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7521','277','2','13526','4.99','2005-08-20T02:58:42.000','2006-02-15T22:15:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7522','277','1','13714','4.99','2005-08-20T09:41:09.000','2006-02-15T22:15:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7523','277','2','14227','4.99','2005-08-21T04:56:31.000','2006-02-15T22:15:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7524','277','2','14745','4.99','2005-08-21T22:53:01.000','2006-02-15T22:15:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7525','277','1','15008','10.99','2005-08-22T08:24:32.000','2006-02-15T22:15:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7526','277','1','15345','5.99','2005-08-22T21:05:50.000','2006-02-15T22:15:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7527','278','1','1092','4.99','2005-05-31T12:15:57.000','2006-02-15T22:15:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7528','278','2','1387','0.99','2005-06-15T15:40:56.000','2006-02-15T22:15:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7529','278','1','1978','2.99','2005-06-17T09:42:34.000','2006-02-15T22:15:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7530','278','2','2078','4.99','2005-06-17T16:48:55.000','2006-02-15T22:15:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7531','278','1','3453','2.99','2005-06-21T21:12:11.000','2006-02-15T22:15:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7532','278','1','3776','2.99','2005-07-06T13:31:37.000','2006-02-15T22:15:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7533','278','1','4430','4.99','2005-07-07T22:35:24.000','2006-02-15T22:15:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7534','278','2','4866','8.99','2005-07-08T19:09:59.000','2006-02-15T22:15:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7535','278','2','6869','4.99','2005-07-12T20:12:06.000','2006-02-15T22:15:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7536','278','1','7239','0.99','2005-07-27T10:20:27.000','2006-02-15T22:15:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7537','278','2','7834','0.99','2005-07-28T08:46:43.000','2006-02-15T22:15:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7538','278','2','8222','5.99','2005-07-28T23:51:53.000','2006-02-15T22:15:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7539','278','1','8953','4.99','2005-07-30T03:21:05.000','2006-02-15T22:15:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7540','278','2','9448','2.99','2005-07-30T21:56:13.000','2006-02-15T22:15:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7541','278','1','10649','2.99','2005-08-01T16:11:40.000','2006-02-15T22:15:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7542','278','1','10731','2.99','2005-08-01T19:21:48.000','2006-02-15T22:15:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7543','278','2','10849','3.99','2005-08-01T23:51:00.000','2006-02-15T22:15:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7544','278','1','11095','5.99','2005-08-02T08:03:20.000','2006-02-15T22:15:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7545','278','2','11531','0.99','2005-08-17T00:30:04.000','2006-02-15T22:15:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7546','278','1','12787','0.99','2005-08-19T00:07:58.000','2006-02-15T22:15:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7547','278','1','13896','0.99','2005-08-20T15:59:56.000','2006-02-15T22:15:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7548','278','2','13976','0.99','2005-08-20T19:02:16.000','2006-02-15T22:15:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7549','278','1','14268','2.99','2005-08-21T06:21:24.000','2006-02-15T22:15:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7550','278','2','14803','0.99','2005-08-22T00:49:10.000','2006-02-15T22:15:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7551','278','1','14986','4.99','2005-08-22T07:37:24.000','2006-02-15T22:15:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7552','278','1','16019','4.99','2005-08-23T21:30:45.000','2006-02-15T22:15:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7553','279','1','979','2.99','2005-05-30T21:37:11.000','2006-02-15T22:15:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7554','279','2','1019','0.99','2005-05-31T03:05:07.000','2006-02-15T22:15:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7555','279','1','1178','2.99','2005-06-15T00:36:40.000','2006-02-15T22:15:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7556','279','1','2147','4.99','2005-06-17T22:28:13.000','2006-02-15T22:15:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7557','279','1','3215','0.99','2005-06-21T01:11:32.000','2006-02-15T22:15:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7558','279','1','3374','2.99','2005-06-21T13:36:30.000','2006-02-15T22:15:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7559','279','1','3375','4.99','2005-06-21T13:37:18.000','2006-02-15T22:15:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7560','279','1','4476','4.99','2005-07-08T00:34:25.000','2006-02-15T22:15:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7561','279','1','4978','7.99','2005-07-09T00:22:02.000','2006-02-15T22:15:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7562','279','2','5248','2.99','2005-07-09T13:29:44.000','2006-02-15T22:15:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7563','279','1','5361','9.99','2005-07-09T18:15:32.000','2006-02-15T22:15:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7564','279','1','6176','0.99','2005-07-11T10:48:21.000','2006-02-15T22:15:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7565','279','1','7947','2.99','2005-07-28T13:05:50.000','2006-02-15T22:15:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7566','279','2','8559','3.99','2005-07-29T11:25:54.000','2006-02-15T22:15:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7567','279','2','9820','5.99','2005-07-31T11:46:57.000','2006-02-15T22:15:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7568','279','2','10177','2.99','2005-07-31T23:42:33.000','2006-02-15T22:15:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7569','279','2','11250','6.99','2005-08-02T13:35:42.000','2006-02-15T22:15:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7570','279','1','11515','2.99','2005-08-16T23:54:34.000','2006-02-15T22:15:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7571','279','1','11703','4.99','2005-08-17T07:19:29.000','2006-02-15T22:15:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7572','279','2','12935','2.99','2005-08-19T05:20:25.000','2006-02-15T22:15:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7573','279','1','12949','4.99','2005-08-19T05:55:52.000','2006-02-15T22:15:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7574','279','1','13105','7.99','2005-08-19T11:06:16.000','2006-02-15T22:15:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7575','279','1','13233','2.99','2005-08-19T16:14:41.000','2006-02-15T22:15:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7576','279','2','13588','4.99','2005-08-20T05:47:11.000','2006-02-15T22:15:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7577','279','2','14206','2.99','2005-08-21T03:59:26.000','2006-02-15T22:15:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7578','279','1','14714','3.99','2005-08-21T21:27:43.000','2006-02-15T22:15:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7579','279','1','14779','5.99','2005-08-22T00:00:56.000','2006-02-15T22:15:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7580','279','1','14789','4.99','2005-08-22T00:29:39.000','2006-02-15T22:15:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7581','279','2','15580','6.99','2005-08-23T05:39:06.000','2006-02-15T22:15:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7582','279','1','15606','2.99','2005-08-23T06:50:27.000','2006-02-15T22:15:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7583','279','2','13538','4.99','2006-02-14T15:16:03.000','2006-02-15T22:15:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7584','280','1','1014','4.99','2005-05-31T02:39:16.000','2006-02-15T22:15:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7585','280','1','2656','3.99','2005-06-19T10:42:33.000','2006-02-15T22:15:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7586','280','2','3009','4.99','2005-06-20T10:24:44.000','2006-02-15T22:15:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7587','280','2','3097','0.99','2005-06-20T16:26:14.000','2006-02-15T22:15:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7588','280','1','4616','4.99','2005-07-08T07:48:12.000','2006-02-15T22:15:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7589','280','2','6851','0.99','2005-07-12T19:32:14.000','2006-02-15T22:15:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7590','280','1','7070','4.99','2005-07-27T04:01:08.000','2006-02-15T22:15:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7591','280','2','7901','0.99','2005-07-28T11:12:12.000','2006-02-15T22:15:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7592','280','2','8319','0.99','2005-07-29T03:44:52.000','2006-02-15T22:15:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7593','280','1','8365','0.99','2005-07-29T05:11:00.000','2006-02-15T22:15:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7594','280','1','8565','7.99','2005-07-29T11:35:23.000','2006-02-15T22:15:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7595','280','2','8695','6.99','2005-07-29T16:44:55.000','2006-02-15T22:15:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7596','280','2','8744','3.99','2005-07-29T18:58:24.000','2006-02-15T22:15:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7597','280','1','8912','0.99','2005-07-30T01:31:25.000','2006-02-15T22:15:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7598','280','2','9103','0.99','2005-07-30T08:49:26.000','2006-02-15T22:15:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7599','280','1','10847','9.99','2005-08-01T23:49:33.000','2006-02-15T22:15:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7600','280','1','11366','4.99','2005-08-02T18:01:25.000','2006-02-15T22:15:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7601','280','1','11517','2.99','2005-08-16T23:56:28.000','2006-02-15T22:15:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7602','280','1','12053','4.99','2005-08-17T20:57:27.000','2006-02-15T22:15:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7603','280','1','12849','5.99','2005-08-19T02:05:37.000','2006-02-15T22:15:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7604','280','2','13231','9.99','2005-08-19T16:12:49.000','2006-02-15T22:15:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7605','280','1','13321','4.99','2005-08-19T19:40:37.000','2006-02-15T22:15:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7606','280','1','13667','4.99','2005-08-20T08:25:34.000','2006-02-15T22:15:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7607','280','2','15036','2.99','2005-08-22T09:36:00.000','2006-02-15T22:15:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7608','280','1','15312','4.99','2005-08-22T19:58:15.000','2006-02-15T22:15:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7609','280','2','15554','5.99','2005-08-23T04:48:12.000','2006-02-15T22:15:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7610','280','2','15950','5.99','2005-08-23T19:09:39.000','2006-02-15T22:15:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7611','281','2','650','2.99','2005-05-28T19:45:40.000','2006-02-15T22:15:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7612','281','2','754','2.99','2005-05-29T10:18:59.000','2006-02-15T22:15:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7613','281','2','1485','5.99','2005-06-15T21:24:10.000','2006-02-15T22:15:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7614','281','1','2254','5.99','2005-06-18T05:15:14.000','2006-02-15T22:15:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7615','281','1','4607','0.99','2005-07-08T07:15:14.000','2006-02-15T22:15:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7616','281','2','4864','6.99','2005-07-08T19:05:34.000','2006-02-15T22:15:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7617','281','2','5410','5.99','2005-07-09T20:21:10.000','2006-02-15T22:15:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7618','281','2','6825','0.99','2005-07-12T18:28:12.000','2006-02-15T22:15:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7619','281','2','7034','2.99','2005-07-27T03:03:37.000','2006-02-15T22:15:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7620','281','1','7525','3.99','2005-07-27T21:13:28.000','2006-02-15T22:15:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7621','281','2','8131','0.99','2005-07-28T19:55:21.000','2006-02-15T22:15:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7622','281','2','8180','4.99','2005-07-28T22:05:24.000','2006-02-15T22:15:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7623','281','1','13641','2.99','2005-08-20T07:34:42.000','2006-02-15T22:15:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7624','281','1','14196','1.99','2005-08-21T03:40:40.000','2006-02-15T22:15:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7625','282','2','48','1.99','2005-05-25T06:20:46.000','2006-02-15T22:15:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7626','282','2','282','6.99','2005-05-26T18:56:26.000','2006-02-15T22:15:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7627','282','2','564','0.99','2005-05-28T09:12:09.000','2006-02-15T22:15:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7628','282','1','2016','2.99','2005-06-17T12:18:36.000','2006-02-15T22:15:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7629','282','2','2176','2.99','2005-06-18T00:29:51.000','2006-02-15T22:15:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7630','282','2','3408','4.99','2005-06-21T16:15:11.000','2006-02-15T22:15:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7631','282','1','3417','2.99','2005-06-21T17:06:20.000','2006-02-15T22:15:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7632','282','2','3675','2.99','2005-07-06T09:09:19.000','2006-02-15T22:15:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7633','282','1','3885','2.99','2005-07-06T18:43:43.000','2006-02-15T22:15:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7634','282','1','4359','2.99','2005-07-07T19:30:20.000','2006-02-15T22:15:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7635','282','2','4412','4.99','2005-07-07T21:56:53.000','2006-02-15T22:15:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7636','282','1','5113','0.99','2005-07-09T07:06:18.000','2006-02-15T22:15:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7637','282','2','5319','8.99','2005-07-09T16:17:44.000','2006-02-15T22:15:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7638','282','1','5926','6.99','2005-07-10T21:53:42.000','2006-02-15T22:15:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7639','282','1','7433','2.99','2005-07-27T17:32:20.000','2006-02-15T22:15:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7640','282','2','7534','3.99','2005-07-27T21:26:17.000','2006-02-15T22:15:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7641','282','1','8223','6.99','2005-07-28T23:56:01.000','2006-02-15T22:15:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7642','282','2','8270','4.99','2005-07-29T01:27:22.000','2006-02-15T22:15:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7643','282','2','8468','1.99','2005-07-29T08:26:04.000','2006-02-15T22:15:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7644','282','2','8743','0.99','2005-07-29T18:57:01.000','2006-02-15T22:15:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7645','282','2','8973','1.99','2005-07-30T04:09:13.000','2006-02-15T22:15:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7646','282','2','9658','9.99','2005-07-31T06:00:52.000','2006-02-15T22:15:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7647','282','2','11226','2.99','2005-08-02T12:47:30.000','2006-02-15T22:15:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7648','282','1','13278','2.99','2005-08-19T17:57:53.000','2006-02-15T22:15:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7649','282','2','13749','2.99','2005-08-20T11:00:37.000','2006-02-15T22:15:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7650','282','2','15543','4.99','2005-08-23T04:15:41.000','2006-02-15T22:15:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7651','282','2','15430','0.99','2006-02-14T15:16:03.000','2006-02-15T22:15:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7652','283','1','1749','0.99','2005-06-16T16:56:00.000','2006-02-15T22:15:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7653','283','2','1796','2.99','2005-06-16T20:10:43.000','2006-02-15T22:15:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7654','283','2','2333','2.99','2005-06-18T10:55:54.000','2006-02-15T22:15:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7655','283','1','2685','2.99','2005-06-19T12:35:21.000','2006-02-15T22:15:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7656','283','2','2849','7.99','2005-06-19T23:06:00.000','2006-02-15T22:15:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7657','283','1','3534','4.99','2005-07-06T01:32:27.000','2006-02-15T22:15:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7658','283','1','3568','6.99','2005-07-06T03:11:57.000','2006-02-15T22:15:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7659','283','2','3590','4.99','2005-07-06T04:35:12.000','2006-02-15T22:15:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7660','283','2','3672','0.99','2005-07-06T09:01:56.000','2006-02-15T22:15:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7661','283','2','4683','2.99','2005-07-08T10:38:28.000','2006-02-15T22:15:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7662','283','2','4876','1.99','2005-07-08T19:27:50.000','2006-02-15T22:15:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7663','283','2','5989','2.99','2005-07-11T00:57:53.000','2006-02-15T22:15:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7664','283','1','6075','0.99','2005-07-11T05:03:03.000','2006-02-15T22:15:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7665','283','1','6300','1.99','2005-07-11T17:50:09.000','2006-02-15T22:15:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7666','283','2','6313','0.99','2005-07-11T18:29:52.000','2006-02-15T22:15:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7667','283','1','6827','4.99','2005-07-12T18:33:45.000','2006-02-15T22:15:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7668','283','1','7504','0.99','2005-07-27T20:24:31.000','2006-02-15T22:15:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7669','283','1','7816','0.99','2005-07-28T08:14:12.000','2006-02-15T22:15:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7670','283','2','9353','4.99','2005-07-30T18:30:37.000','2006-02-15T22:15:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7671','283','2','9478','2.99','2005-07-30T23:12:53.000','2006-02-15T22:15:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7672','283','2','9572','2.99','2005-07-31T02:44:10.000','2006-02-15T22:15:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7673','283','2','9918','2.99','2005-07-31T14:55:22.000','2006-02-15T22:15:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7674','283','1','11637','0.99','2005-08-17T04:36:39.000','2006-02-15T22:15:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7675','283','2','11846','2.99','2005-08-17T13:18:29.000','2006-02-15T22:15:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7676','283','2','11966','0.99','2005-08-17T17:40:04.000','2006-02-15T22:15:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7677','283','1','12290','6.99','2005-08-18T05:08:03.000','2006-02-15T22:15:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7678','283','1','13229','2.99','2005-08-19T16:08:33.000','2006-02-15T22:15:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7679','283','1','15837','2.99','2005-08-23T15:29:41.000','2006-02-15T22:15:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7680','284','2','423','0.99','2005-05-27T15:32:57.000','2006-02-15T22:15:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7681','284','2','791','0.99','2005-05-29T16:30:42.000','2006-02-15T22:15:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7682','284','1','1145','6.99','2005-05-31T20:13:45.000','2006-02-15T22:15:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7683','284','1','1171','0.99','2005-06-14T23:50:11.000','2006-02-15T22:15:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7684','284','2','2813','6.99','2005-06-19T20:01:47.000','2006-02-15T22:15:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7685','284','2','3296','0.99','2005-06-21T07:04:53.000','2006-02-15T22:15:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7686','284','1','3572','0.99','2005-07-06T03:33:23.000','2006-02-15T22:15:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7687','284','2','4081','2.99','2005-07-07T05:10:08.000','2006-02-15T22:15:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7688','284','1','4759','7.99','2005-07-08T14:39:22.000','2006-02-15T22:15:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7689','284','2','4931','7.99','2005-07-08T22:16:18.000','2006-02-15T22:15:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7690','284','1','5161','6.99','2005-07-09T08:57:56.000','2006-02-15T22:15:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7691','284','1','6276','5.99','2005-07-11T16:15:50.000','2006-02-15T22:15:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7692','284','2','6982','2.99','2005-07-27T00:53:41.000','2006-02-15T22:15:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7693','284','1','7164','6.99','2005-07-27T07:36:34.000','2006-02-15T22:15:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7694','284','1','7463','4.99','2005-07-27T18:48:32.000','2006-02-15T22:15:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7695','284','2','7716','8.99','2005-07-28T04:33:15.000','2006-02-15T22:15:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7696','284','1','8888','2.99','2005-07-30T00:39:36.000','2006-02-15T22:15:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7697','284','1','9790','0.99','2005-07-31T10:34:08.000','2006-02-15T22:15:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7698','284','1','10396','7.99','2005-08-01T07:08:46.000','2006-02-15T22:15:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7699','284','1','10535','4.99','2005-08-01T12:21:13.000','2006-02-15T22:15:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7700','284','2','12162','3.99','2005-08-18T00:44:30.000','2006-02-15T22:15:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7701','284','1','14007','5.99','2005-08-20T20:22:47.000','2006-02-15T22:15:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7702','284','1','14648','4.99','2005-08-21T19:18:01.000','2006-02-15T22:15:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7703','284','2','14746','4.99','2005-08-21T22:54:02.000','2006-02-15T22:15:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7704','284','1','14921','4.99','2005-08-22T05:12:24.000','2006-02-15T22:15:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7705','284','2','15135','3.99','2005-08-22T13:19:19.000','2006-02-15T22:15:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7706','284','1','12064','5.98','2006-02-14T15:16:03.000','2006-02-15T22:15:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7707','284','2','12959','0','2006-02-14T15:16:03.000','2006-02-15T22:15:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7708','285','2','1161','7.99','2005-06-14T23:07:08.000','2006-02-15T22:15:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7709','285','2','1302','3.99','2005-06-15T09:48:37.000','2006-02-15T22:15:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7710','285','1','2249','5.99','2005-06-18T05:03:08.000','2006-02-15T22:15:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7711','285','2','4007','6.99','2005-07-07T00:26:05.000','2006-02-15T22:15:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7712','285','2','5112','2.99','2005-07-09T07:04:04.000','2006-02-15T22:15:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7713','285','1','5683','9.99','2005-07-10T08:52:13.000','2006-02-15T22:15:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7714','285','1','6010','0.99','2005-07-11T01:52:28.000','2006-02-15T22:15:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7715','285','2','6083','3.99','2005-07-11T05:12:49.000','2006-02-15T22:15:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7716','285','1','6094','4.99','2005-07-11T05:54:42.000','2006-02-15T22:15:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7717','285','2','6333','4.99','2005-07-11T19:20:16.000','2006-02-15T22:15:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7718','285','2','6644','0.99','2005-07-12T10:39:39.000','2006-02-15T22:15:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7719','285','1','7211','6.99','2005-07-27T09:20:00.000','2006-02-15T22:15:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7720','285','1','7452','9.99','2005-07-27T18:26:39.000','2006-02-15T22:15:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7721','285','1','7745','9.99','2005-07-28T05:46:28.000','2006-02-15T22:15:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7722','285','1','8154','4.99','2005-07-28T20:56:18.000','2006-02-15T22:15:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7723','285','2','8466','0.99','2005-07-29T08:24:47.000','2006-02-15T22:15:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7724','285','1','10493','5.99','2005-08-01T10:43:12.000','2006-02-15T22:15:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7725','285','2','10628','2.99','2005-08-01T15:33:19.000','2006-02-15T22:15:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7726','285','1','10641','4.99','2005-08-01T15:44:57.000','2006-02-15T22:15:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7727','285','1','12027','8.99','2005-08-17T20:01:12.000','2006-02-15T22:15:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7728','285','1','12444','0.99','2005-08-18T10:53:12.000','2006-02-15T22:15:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7729','285','1','12449','0.99','2005-08-18T11:03:04.000','2006-02-15T22:15:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7730','285','2','12687','9.99','2005-08-18T19:57:39.000','2006-02-15T22:15:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7731','285','2','13102','7.99','2005-08-19T11:02:03.000','2006-02-15T22:15:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7732','285','2','15251','0.99','2005-08-22T18:03:57.000','2006-02-15T22:15:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7733','285','1','15489','4.99','2005-08-23T02:06:41.000','2006-02-15T22:15:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7734','286','2','81','6.99','2005-05-25T12:15:19.000','2006-02-15T22:15:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7735','286','1','1690','8.99','2005-06-16T12:24:18.000','2006-02-15T22:15:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7736','286','1','2195','4.99','2005-06-18T01:44:46.000','2006-02-15T22:15:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7737','286','2','3592','4.99','2005-07-06T04:38:50.000','2006-02-15T22:15:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7738','286','2','3692','3.99','2005-07-06T09:54:12.000','2006-02-15T22:15:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7739','286','2','4242','6.99','2005-07-07T13:39:01.000','2006-02-15T22:15:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7740','286','2','4461','9.99','2005-07-07T23:59:43.000','2006-02-15T22:15:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7741','286','1','4707','4.99','2005-07-08T11:57:28.000','2006-02-15T22:15:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7742','286','1','4894','2.99','2005-07-08T20:21:31.000','2006-02-15T22:15:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7743','286','1','5796','4.99','2005-07-10T14:42:54.000','2006-02-15T22:15:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7744','286','2','6611','2.99','2005-07-12T08:20:23.000','2006-02-15T22:15:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7745','286','1','7254','2.99','2005-07-27T10:48:50.000','2006-02-15T22:15:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7746','286','1','7299','2.99','2005-07-27T12:49:56.000','2006-02-15T22:15:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7747','286','1','7368','0.99','2005-07-27T15:06:05.000','2006-02-15T22:15:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7748','286','1','7422','2.99','2005-07-27T17:10:42.000','2006-02-15T22:15:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7749','286','1','7719','6.99','2005-07-28T04:39:09.000','2006-02-15T22:15:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7750','286','2','8399','0.99','2005-07-29T06:20:18.000','2006-02-15T22:15:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7751','286','2','9280','6.99','2005-07-30T15:15:38.000','2006-02-15T22:15:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7752','286','1','9809','3.99','2005-07-31T11:19:21.000','2006-02-15T22:15:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7753','286','2','10105','5.99','2005-07-31T20:54:20.000','2006-02-15T22:15:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7754','286','2','11670','0.99','2005-08-17T05:48:59.000','2006-02-15T22:15:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7755','286','2','12595','0.99','2005-08-18T16:27:08.000','2006-02-15T22:15:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7756','286','1','12656','0.99','2005-08-18T18:58:35.000','2006-02-15T22:15:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7757','286','2','13635','5.99','2005-08-20T07:17:35.000','2006-02-15T22:15:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7758','286','1','13975','4.99','2005-08-20T18:58:23.000','2006-02-15T22:15:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7759','286','1','14905','0.99','2005-08-22T04:34:22.000','2006-02-15T22:15:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7760','286','2','15629','4.99','2005-08-23T07:28:22.000','2006-02-15T22:15:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7761','287','2','498','0.99','2005-05-28T01:01:21.000','2006-02-15T22:15:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7762','287','1','655','2.99','2005-05-28T20:16:20.000','2006-02-15T22:15:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7763','287','2','964','2.99','2005-05-30T18:53:21.000','2006-02-15T22:15:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7764','287','1','1247','7.99','2005-06-15T05:16:40.000','2006-02-15T22:15:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7765','287','2','1642','2.99','2005-06-16T08:54:15.000','2006-02-15T22:15:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7766','287','2','2286','9.99','2005-06-18T07:02:32.000','2006-02-15T22:15:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7767','287','2','2612','6.99','2005-06-19T07:19:41.000','2006-02-15T22:15:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7768','287','2','4877','4.99','2005-07-08T19:31:02.000','2006-02-15T22:15:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7769','287','2','5346','1.99','2005-07-09T17:29:01.000','2006-02-15T22:15:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7770','287','1','5593','3.99','2005-07-10T04:33:13.000','2006-02-15T22:15:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7771','287','2','5761','0.99','2005-07-10T12:45:36.000','2006-02-15T22:15:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7772','287','2','6379','3.99','2005-07-11T21:51:25.000','2006-02-15T22:15:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7773','287','1','6397','2.99','2005-07-11T22:34:02.000','2006-02-15T22:15:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7774','287','2','7402','2.99','2005-07-27T16:19:40.000','2006-02-15T22:15:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7775','287','2','7777','2.99','2005-07-28T07:04:42.000','2006-02-15T22:15:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7776','287','2','8994','6.99','2005-07-30T04:51:32.000','2006-02-15T22:15:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7777','287','2','9716','1.99','2005-07-31T08:23:53.000','2006-02-15T22:15:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7778','287','1','10027','6.99','2005-07-31T18:33:51.000','2006-02-15T22:15:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7779','287','2','10574','2.99','2005-08-01T13:36:51.000','2006-02-15T22:15:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7780','287','2','10807','4.99','2005-08-01T22:26:10.000','2006-02-15T22:15:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7781','287','2','11106','4.99','2005-08-02T08:17:38.000','2006-02-15T22:15:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7782','287','1','11716','4.99','2005-08-17T07:40:55.000','2006-02-15T22:15:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7783','287','2','12861','2.99','2005-08-19T02:30:24.000','2006-02-15T22:15:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7784','287','2','14715','6.99','2005-08-21T21:28:18.000','2006-02-15T22:15:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7785','287','2','15076','1.99','2005-08-22T11:05:34.000','2006-02-15T22:15:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7786','287','1','15084','4.99','2005-08-22T11:17:59.000','2006-02-15T22:15:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7787','287','2','15127','0.99','2005-08-22T12:56:29.000','2006-02-15T22:15:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7788','287','1','15614','2.99','2005-08-23T07:05:15.000','2006-02-15T22:15:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7789','287','2','14204','0.99','2006-02-14T15:16:03.000','2006-02-15T22:15:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7790','288','2','93','3.99','2005-05-25T15:54:16.000','2006-02-15T22:15:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7791','288','2','427','6.99','2005-05-27T16:10:04.000','2006-02-15T22:15:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7792','288','1','503','4.99','2005-05-28T01:35:25.000','2006-02-15T22:15:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7793','288','2','565','5.99','2005-05-28T09:26:31.000','2006-02-15T22:15:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7794','288','1','1466','5.99','2005-06-15T20:46:04.000','2006-02-15T22:15:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7795','288','1','3958','3.99','2005-07-06T22:07:33.000','2006-02-15T22:15:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7796','288','1','4692','2.99','2005-07-08T11:07:06.000','2006-02-15T22:15:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7797','288','2','4758','0.99','2005-07-08T14:38:02.000','2006-02-15T22:15:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7798','288','1','6399','2.99','2005-07-11T22:39:05.000','2006-02-15T22:15:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7799','288','2','6518','3.99','2005-07-12T03:59:42.000','2006-02-15T22:15:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7800','288','2','7744','0.99','2005-07-28T05:38:20.000','2006-02-15T22:15:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7801','288','2','7855','2.99','2005-07-28T09:43:02.000','2006-02-15T22:15:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7802','288','2','9429','2.99','2005-07-30T21:19:26.000','2006-02-15T22:15:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7803','288','1','9732','0.99','2005-07-31T08:56:08.000','2006-02-15T22:15:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7804','288','1','10927','9.99','2005-08-02T02:31:15.000','2006-02-15T22:15:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7805','288','2','11952','2.99','2005-08-17T17:14:57.000','2006-02-15T22:15:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7806','288','1','12134','1.99','2005-08-17T23:49:43.000','2006-02-15T22:15:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7807','288','1','13219','2.99','2005-08-19T15:40:28.000','2006-02-15T22:15:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7808','288','1','13227','0.99','2005-08-19T16:05:38.000','2006-02-15T22:15:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7809','288','2','13363','2.99','2005-08-19T21:07:59.000','2006-02-15T22:15:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7810','288','2','14113','0.99','2005-08-21T01:03:30.000','2006-02-15T22:15:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7811','288','2','14756','0.99','2005-08-21T23:21:23.000','2006-02-15T22:15:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7812','288','2','15058','2.99','2005-08-22T10:20:55.000','2006-02-15T22:15:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7813','288','1','15119','2.99','2005-08-22T12:41:33.000','2006-02-15T22:15:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7814','289','2','1880','4.99','2005-06-17T03:08:59.000','2006-02-15T22:15:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7815','289','2','2316','0.99','2005-06-18T09:04:59.000','2006-02-15T22:15:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7816','289','1','2387','6.99','2005-06-18T15:24:19.000','2006-02-15T22:15:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7817','289','1','2784','10.99','2005-06-19T18:40:29.000','2006-02-15T22:15:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7818','289','2','2948','6.99','2005-06-20T06:02:35.000','2006-02-15T22:15:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7819','289','2','3123','6.99','2005-06-20T18:26:14.000','2006-02-15T22:15:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7820','289','1','3588','2.99','2005-07-06T04:29:13.000','2006-02-15T22:15:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7821','289','2','4622','0.99','2005-07-08T08:02:42.000','2006-02-15T22:15:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7822','289','1','5089','4.99','2005-07-09T05:45:40.000','2006-02-15T22:15:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7823','289','2','5342','8.99','2005-07-09T17:20:03.000','2006-02-15T22:15:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7824','289','2','5584','4.99','2005-07-10T04:15:25.000','2006-02-15T22:15:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7825','289','2','5724','0.99','2005-07-10T11:18:12.000','2006-02-15T22:15:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7826','289','2','6007','3.99','2005-07-11T01:43:06.000','2006-02-15T22:15:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7827','289','2','6536','7.99','2005-07-12T04:44:25.000','2006-02-15T22:15:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7828','289','1','7151','4.99','2005-07-27T07:14:31.000','2006-02-15T22:15:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7829','289','1','7162','4.99','2005-07-27T07:32:45.000','2006-02-15T22:15:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7830','289','2','7325','0.99','2005-07-27T13:46:55.000','2006-02-15T22:15:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7831','289','1','9498','2.99','2005-07-30T23:56:55.000','2006-02-15T22:15:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7832','289','2','10297','7.99','2005-08-01T04:05:04.000','2006-02-15T22:15:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7833','289','1','12158','1.99','2005-08-18T00:34:20.000','2006-02-15T22:15:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7834','289','1','12170','0.99','2005-08-18T01:06:10.000','2006-02-15T22:15:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7835','289','2','12558','7.99','2005-08-18T14:52:35.000','2006-02-15T22:15:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7836','289','2','13165','0.99','2005-08-19T13:34:10.000','2006-02-15T22:15:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7837','289','2','13211','0.99','2005-08-19T15:23:41.000','2006-02-15T22:15:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7838','289','2','13256','9.99','2005-08-19T16:54:12.000','2006-02-15T22:15:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7839','289','2','13336','5.99','2005-08-19T20:03:22.000','2006-02-15T22:15:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7840','289','2','13891','6.99','2005-08-20T15:42:05.000','2006-02-15T22:15:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7841','289','1','14087','0.99','2005-08-20T23:53:40.000','2006-02-15T22:15:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7842','289','2','14729','4.99','2005-08-21T22:16:57.000','2006-02-15T22:15:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7843','289','2','14917','4.99','2005-08-22T05:03:59.000','2006-02-15T22:15:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7844','290','1','160','2.99','2005-05-26T01:46:20.000','2006-02-15T22:15:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7845','290','1','1220','6.99','2005-06-15T03:26:15.000','2006-02-15T22:15:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7846','290','2','1336','8.99','2005-06-15T12:01:34.000','2006-02-15T22:15:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7847','290','2','1496','4.99','2005-06-15T21:55:58.000','2006-02-15T22:15:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7848','290','2','1532','0.99','2005-06-16T00:41:31.000','2006-02-15T22:15:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7849','290','1','3013','3.99','2005-06-20T10:45:09.000','2006-02-15T22:15:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7850','290','2','4039','4.99','2005-07-07T02:57:59.000','2006-02-15T22:15:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7851','290','1','4073','0.99','2005-07-07T04:49:13.000','2006-02-15T22:15:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7852','290','2','4416','0.99','2005-07-07T22:04:36.000','2006-02-15T22:15:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7853','290','1','5105','2.99','2005-07-09T06:38:59.000','2006-02-15T22:15:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7854','290','2','5214','5.99','2005-07-09T11:43:08.000','2006-02-15T22:15:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7855','290','2','5827','2.99','2005-07-10T16:22:20.000','2006-02-15T22:15:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7856','290','2','6816','4.99','2005-07-12T18:18:50.000','2006-02-15T22:15:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7857','290','1','6952','4.99','2005-07-26T23:51:27.000','2006-02-15T22:15:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7858','290','2','7265','2.99','2005-07-27T11:19:01.000','2006-02-15T22:15:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7859','290','1','7650','1.99','2005-07-28T01:47:20.000','2006-02-15T22:15:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7860','290','1','8639','4.99','2005-07-29T14:30:31.000','2006-02-15T22:15:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7861','290','1','9000','7.99','2005-07-30T04:58:55.000','2006-02-15T22:15:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7862','290','1','9413','0.99','2005-07-30T20:44:39.000','2006-02-15T22:15:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7863','290','2','10096','3.99','2005-07-31T20:38:58.000','2006-02-15T22:15:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7864','290','1','10194','1.99','2005-08-01T00:33:52.000','2006-02-15T22:15:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7865','290','1','10901','2.99','2005-08-02T01:35:44.000','2006-02-15T22:15:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7866','290','1','11596','6.99','2005-08-17T02:53:55.000','2006-02-15T22:15:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7867','290','2','12193','3.99','2005-08-18T02:03:59.000','2006-02-15T22:15:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7868','290','2','12778','4.99','2005-08-18T23:40:23.000','2006-02-15T22:15:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7869','290','2','13190','1.99','2005-08-19T14:27:59.000','2006-02-15T22:15:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7870','290','1','13367','2.99','2005-08-19T21:19:27.000','2006-02-15T22:15:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7871','290','2','13687','2.99','2005-08-20T08:57:51.000','2006-02-15T22:15:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7872','291','1','54','4.99','2005-05-25T07:23:25.000','2006-02-15T22:15:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7873','291','2','747','4.99','2005-05-29T09:26:34.000','2006-02-15T22:15:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7874','291','1','1012','2.99','2005-05-31T02:18:05.000','2006-02-15T22:15:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7875','291','1','1191','2.99','2005-06-15T01:10:35.000','2006-02-15T22:15:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7876','291','1','2300','2.99','2005-06-18T08:22:34.000','2006-02-15T22:15:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7877','291','2','3042','2.99','2005-06-20T12:38:27.000','2006-02-15T22:15:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7878','291','2','3512','4.99','2005-07-06T00:43:06.000','2006-02-15T22:15:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7879','291','2','4862','3.99','2005-07-08T19:02:46.000','2006-02-15T22:15:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7880','291','2','5754','2.99','2005-07-10T12:32:43.000','2006-02-15T22:15:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7881','291','2','6516','4.99','2005-07-12T03:51:54.000','2006-02-15T22:15:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7882','291','1','6796','2.99','2005-07-12T16:44:16.000','2006-02-15T22:15:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7883','291','1','7561','5.99','2005-07-27T22:21:05.000','2006-02-15T22:15:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7884','291','2','7564','0.99','2005-07-27T22:31:17.000','2006-02-15T22:15:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7885','291','1','8690','0.99','2005-07-29T16:39:28.000','2006-02-15T22:15:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7886','291','2','8697','4.99','2005-07-29T16:46:07.000','2006-02-15T22:15:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7887','291','1','9165','5.99','2005-07-30T11:24:28.000','2006-02-15T22:15:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7888','291','2','9201','5.99','2005-07-30T12:42:21.000','2006-02-15T22:15:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7889','291','2','9919','7.99','2005-07-31T14:55:46.000','2006-02-15T22:15:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7890','291','1','10463','4.99','2005-08-01T09:39:43.000','2006-02-15T22:15:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7891','291','2','11145','0.99','2005-08-02T09:43:24.000','2006-02-15T22:15:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7892','291','1','13665','5.99','2005-08-20T08:19:20.000','2006-02-15T22:15:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7893','291','2','14241','4.99','2005-08-21T05:24:55.000','2006-02-15T22:15:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7894','291','2','15663','3.99','2005-08-23T08:54:26.000','2006-02-15T22:15:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7895','292','1','324','0.99','2005-05-27T01:00:04.000','2006-02-15T22:15:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7896','292','1','1901','3.99','2005-06-17T04:35:19.000','2006-02-15T22:15:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7897','292','2','2258','3.99','2005-06-18T05:30:36.000','2006-02-15T22:15:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7898','292','1','2838','3.99','2005-06-19T22:06:06.000','2006-02-15T22:15:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7899','292','2','3328','2.99','2005-06-21T09:08:44.000','2006-02-15T22:15:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7900','292','2','3557','0.99','2005-07-06T02:48:39.000','2006-02-15T22:15:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7901','292','1','4200','4.99','2005-07-07T11:15:11.000','2006-02-15T22:15:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7902','292','2','5095','4.99','2005-07-09T06:08:22.000','2006-02-15T22:15:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7903','292','2','5257','0.99','2005-07-09T13:56:43.000','2006-02-15T22:15:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7904','292','1','5940','4.99','2005-07-10T22:31:01.000','2006-02-15T22:15:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7905','292','1','6270','8.99','2005-07-11T15:59:10.000','2006-02-15T22:15:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7906','292','1','6900','6.99','2005-07-12T21:45:25.000','2006-02-15T22:15:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7907','292','2','7199','5.99','2005-07-27T08:53:23.000','2006-02-15T22:15:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7908','292','1','7216','2.99','2005-07-27T09:27:45.000','2006-02-15T22:15:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7909','292','1','7545','2.99','2005-07-27T21:48:03.000','2006-02-15T22:15:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7910','292','1','7766','4.99','2005-07-28T06:41:57.000','2006-02-15T22:15:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7911','292','1','8047','2.99','2005-07-28T16:49:43.000','2006-02-15T22:15:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7912','292','2','8842','4.99','2005-07-29T23:03:40.000','2006-02-15T22:15:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7913','292','1','8990','8.99','2005-07-30T04:41:42.000','2006-02-15T22:15:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7914','292','1','9792','5.99','2005-07-31T10:43:41.000','2006-02-15T22:15:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7915','292','2','9819','1.99','2005-07-31T11:39:13.000','2006-02-15T22:15:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7916','292','1','11193','4.99','2005-08-02T11:31:33.000','2006-02-15T22:15:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7917','292','1','12739','10.99','2005-08-18T22:15:18.000','2006-02-15T22:15:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7918','292','1','13715','2.99','2005-08-20T09:43:06.000','2006-02-15T22:15:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7919','292','1','14499','0.99','2005-08-21T14:11:19.000','2006-02-15T22:15:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7920','292','2','14845','4.99','2005-08-22T02:12:44.000','2006-02-15T22:15:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7921','292','1','15117','2.99','2005-08-22T12:38:20.000','2006-02-15T22:15:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7922','293','2','445','0.99','2005-05-27T18:42:57.000','2006-02-15T22:15:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7923','293','1','924','4.99','2005-05-30T12:10:59.000','2006-02-15T22:15:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7924','293','2','1034','8.99','2005-05-31T04:53:40.000','2006-02-15T22:15:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7925','293','1','1589','9.99','2005-06-16T04:58:03.000','2006-02-15T22:15:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7926','293','1','1829','5.99','2005-06-16T22:14:21.000','2006-02-15T22:15:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7927','293','2','1860','4.99','2005-06-17T01:17:12.000','2006-02-15T22:15:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7928','293','1','2386','4.99','2005-06-18T15:22:51.000','2006-02-15T22:15:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7929','293','2','3025','2.99','2005-06-20T11:46:48.000','2006-02-15T22:15:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7930','293','1','3290','1.99','2005-06-21T06:45:34.000','2006-02-15T22:15:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7931','293','2','3452','4.99','2005-06-21T21:11:27.000','2006-02-15T22:15:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7932','293','1','3906','3.99','2005-07-06T19:35:55.000','2006-02-15T22:15:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7933','293','2','4343','0.99','2005-07-07T18:48:54.000','2006-02-15T22:15:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7934','293','2','4542','4.99','2005-07-08T04:06:30.000','2006-02-15T22:15:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7935','293','2','4944','6.99','2005-07-08T22:44:28.000','2006-02-15T22:15:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7936','293','2','5765','3.99','2005-07-10T13:03:02.000','2006-02-15T22:15:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7937','293','1','6432','9.99','2005-07-12T00:09:41.000','2006-02-15T22:15:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7938','293','2','7607','4.99','2005-07-28T00:05:53.000','2006-02-15T22:15:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7939','293','1','8589','4.99','2005-07-29T12:28:17.000','2006-02-15T22:15:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7940','293','1','8745','2.99','2005-07-29T19:03:05.000','2006-02-15T22:15:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7941','293','2','9123','2.99','2005-07-30T09:39:15.000','2006-02-15T22:15:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7942','293','2','11131','1.99','2005-08-02T09:10:04.000','2006-02-15T22:15:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7943','293','1','11576','2.99','2005-08-17T01:53:20.000','2006-02-15T22:15:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7944','293','2','13013','6.99','2005-08-19T07:55:51.000','2006-02-15T22:15:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7945','293','1','13029','2.99','2005-08-19T08:28:04.000','2006-02-15T22:15:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7946','293','2','13504','5.99','2005-08-20T02:01:48.000','2006-02-15T22:15:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7947','293','1','13817','4.99','2005-08-20T13:15:30.000','2006-02-15T22:15:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7948','293','1','14248','6.99','2005-08-21T05:35:57.000','2006-02-15T22:15:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7949','293','1','15258','4.99','2005-08-22T18:22:44.000','2006-02-15T22:15:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7950','293','1','15402','8.99','2005-08-22T23:17:41.000','2006-02-15T22:15:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7951','293','1','15508','7.99','2005-08-23T02:49:04.000','2006-02-15T22:15:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7952','293','2','15675','5.99','2005-08-23T09:18:52.000','2006-02-15T22:15:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7953','294','1','595','1.99','2005-05-28T13:59:54.000','2006-02-15T22:15:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7954','294','1','2900','2.99','2005-06-20T02:40:04.000','2006-02-15T22:15:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7955','294','2','3330','2.99','2005-06-21T09:22:37.000','2006-02-15T22:15:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7956','294','1','3681','4.99','2005-07-06T09:19:30.000','2006-02-15T22:15:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7957','294','2','4019','4.99','2005-07-07T01:27:44.000','2006-02-15T22:15:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7958','294','1','4786','7.99','2005-07-08T16:13:05.000','2006-02-15T22:15:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7959','294','2','6185','5.99','2005-07-11T11:25:09.000','2006-02-15T22:15:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7960','294','2','7415','6.99','2005-07-27T16:50:59.000','2006-02-15T22:15:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7961','294','1','7765','4.99','2005-07-28T06:40:33.000','2006-02-15T22:15:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7962','294','2','8843','4.99','2005-07-29T23:04:25.000','2006-02-15T22:15:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7963','294','2','9194','2.99','2005-07-30T12:28:45.000','2006-02-15T22:15:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7964','294','1','9522','2.99','2005-07-31T00:55:11.000','2006-02-15T22:15:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7965','294','2','9607','0.99','2005-07-31T03:51:06.000','2006-02-15T22:15:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7966','294','2','10186','0.99','2005-08-01T00:12:36.000','2006-02-15T22:15:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7967','294','2','10220','4.99','2005-08-01T01:13:22.000','2006-02-15T22:15:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7968','294','1','10551','6.99','2005-08-01T12:48:55.000','2006-02-15T22:15:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7969','294','2','10600','2.99','2005-08-01T14:25:21.000','2006-02-15T22:15:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7970','294','2','10642','4.99','2005-08-01T15:45:11.000','2006-02-15T22:15:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7971','294','2','11071','2.99','2005-08-02T07:10:53.000','2006-02-15T22:15:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7972','294','1','11390','2.99','2005-08-02T18:39:16.000','2006-02-15T22:15:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7973','294','2','11875','4.99','2005-08-17T14:16:48.000','2006-02-15T22:15:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7974','294','2','11981','2.99','2005-08-17T18:10:40.000','2006-02-15T22:15:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7975','294','1','12278','5.99','2005-08-18T04:46:45.000','2006-02-15T22:15:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7976','294','1','14474','2.99','2005-08-21T13:22:48.000','2006-02-15T22:15:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7977','294','2','14630','7.99','2005-08-21T18:43:44.000','2006-02-15T22:15:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7978','294','1','15839','5.99','2005-08-23T15:34:46.000','2006-02-15T22:15:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7979','295','2','371','3.99','2005-05-27T08:08:18.000','2006-02-15T22:15:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7980','295','1','1184','5.99','2005-06-15T00:49:36.000','2006-02-15T22:15:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7981','295','1','1328','2.99','2005-06-15T11:23:27.000','2006-02-15T22:15:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7982','295','2','1935','2.99','2005-06-17T07:14:15.000','2006-02-15T22:15:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7983','295','1','2054','2.99','2005-06-17T15:26:37.000','2006-02-15T22:15:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7984','295','1','2431','1.99','2005-06-18T17:53:03.000','2006-02-15T22:15:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7985','295','1','2638','1.99','2005-06-19T09:23:30.000','2006-02-15T22:15:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7986','295','1','2999','2.99','2005-06-20T09:30:34.000','2006-02-15T22:15:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7987','295','1','3198','1.99','2005-06-21T00:08:54.000','2006-02-15T22:15:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7988','295','2','3394','8.99','2005-06-21T15:17:39.000','2006-02-15T22:15:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7989','295','2','3496','1.99','2005-07-05T23:59:15.000','2006-02-15T22:15:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7990','295','1','3876','9.99','2005-07-06T18:21:13.000','2006-02-15T22:15:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7991','295','1','4164','1.99','2005-07-07T09:20:11.000','2006-02-15T22:15:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7992','295','1','4432','1.99','2005-07-07T22:40:02.000','2006-02-15T22:15:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7993','295','1','5019','2.99','2005-07-09T02:04:32.000','2006-02-15T22:15:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7994','295','2','5053','4.99','2005-07-09T03:59:46.000','2006-02-15T22:15:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7995','295','2','5283','2.99','2005-07-09T15:07:17.000','2006-02-15T22:15:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7996','295','2','5994','4.99','2005-07-11T01:14:10.000','2006-02-15T22:15:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7997','295','1','6252','2.99','2005-07-11T15:06:29.000','2006-02-15T22:15:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7998','295','2','6331','3.99','2005-07-11T19:17:21.000','2006-02-15T22:15:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('7999','295','2','8087','0.99','2005-07-28T18:21:16.000','2006-02-15T22:15:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8000','295','1','8108','7.99','2005-07-28T19:07:38.000','2006-02-15T22:15:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8001','295','1','8840','9.99','2005-07-29T22:55:38.000','2006-02-15T22:15:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8002','295','2','8932','2.99','2005-07-30T02:31:26.000','2006-02-15T22:15:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8003','295','1','9425','7.99','2005-07-30T21:11:21.000','2006-02-15T22:15:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8004','295','2','9692','8.99','2005-07-31T07:11:04.000','2006-02-15T22:15:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8005','295','2','9793','4.99','2005-07-31T10:45:11.000','2006-02-15T22:15:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8006','295','2','10160','4.99','2005-07-31T23:07:40.000','2006-02-15T22:15:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8007','295','2','10222','0.99','2005-08-01T01:17:42.000','2006-02-15T22:15:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8008','295','1','10349','3.99','2005-08-01T05:27:13.000','2006-02-15T22:15:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8009','295','2','11083','4.99','2005-08-02T07:32:01.000','2006-02-15T22:15:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8010','295','2','11913','5.99','2005-08-17T15:53:17.000','2006-02-15T22:15:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8011','295','2','12041','4.99','2005-08-17T20:34:33.000','2006-02-15T22:15:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8012','295','1','12383','0.99','2005-08-18T08:36:03.000','2006-02-15T22:15:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8013','295','1','14264','0.99','2005-08-21T06:18:22.000','2006-02-15T22:15:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8014','295','1','14387','6.99','2005-08-21T10:10:01.000','2006-02-15T22:15:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8015','295','1','14514','6.99','2005-08-21T14:51:52.000','2006-02-15T22:15:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8016','295','2','15735','0.99','2006-02-14T15:16:03.000','2006-02-15T22:15:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8017','296','2','162','4.99','2005-05-26T02:02:05.000','2006-02-15T22:15:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8018','296','1','511','5.99','2005-05-28T03:04:04.000','2006-02-15T22:15:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8019','296','1','869','4.99','2005-05-30T04:22:06.000','2006-02-15T22:15:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8020','296','2','956','2.99','2005-05-30T17:30:28.000','2006-02-15T22:15:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8021','296','2','1659','4.99','2005-06-16T10:11:46.000','2006-02-15T22:15:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8022','296','1','3034','0.99','2005-06-20T12:15:50.000','2006-02-15T22:15:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8023','296','2','3119','0.99','2005-06-20T18:11:44.000','2006-02-15T22:15:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8024','296','2','3486','7.99','2005-07-05T23:29:55.000','2006-02-15T22:15:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8025','296','1','3810','2.99','2005-07-06T15:18:44.000','2006-02-15T22:15:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8026','296','1','4480','4.99','2005-07-08T00:56:30.000','2006-02-15T22:15:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8027','296','2','5090','0.99','2005-07-09T05:48:22.000','2006-02-15T22:15:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8028','296','1','5589','4.99','2005-07-10T04:22:58.000','2006-02-15T22:15:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8029','296','2','6016','4.99','2005-07-11T02:04:45.000','2006-02-15T22:15:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8030','296','1','6398','5.99','2005-07-11T22:34:49.000','2006-02-15T22:15:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8031','296','1','6967','6.99','2005-07-27T00:16:31.000','2006-02-15T22:15:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8032','296','2','7568','4.99','2005-07-27T22:38:53.000','2006-02-15T22:15:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8033','296','2','8171','0.99','2005-07-28T21:32:57.000','2006-02-15T22:15:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8034','296','1','9249','5.99','2005-07-30T14:15:02.000','2006-02-15T22:15:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8035','296','1','9304','2.99','2005-07-30T16:41:34.000','2006-02-15T22:15:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8036','296','2','11571','4.99','2005-08-17T01:37:51.000','2006-02-15T22:15:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8037','296','2','11825','4.99','2005-08-17T12:43:30.000','2006-02-15T22:15:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8038','296','2','12689','3.99','2005-08-18T20:06:34.000','2006-02-15T22:15:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8039','296','2','13471','2.99','2005-08-20T01:02:26.000','2006-02-15T22:15:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8040','296','1','13702','2.99','2005-08-20T09:27:20.000','2006-02-15T22:15:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8041','296','1','13819','4.99','2005-08-20T13:23:15.000','2006-02-15T22:15:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8042','296','1','13991','1.99','2005-08-20T19:29:44.000','2006-02-15T22:15:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8043','296','2','14571','7.99','2005-08-21T16:40:26.000','2006-02-15T22:15:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8044','296','2','15023','2.99','2005-08-22T08:56:48.000','2006-02-15T22:15:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8045','296','2','15866','7.99','2005-08-23T16:19:02.000','2006-02-15T22:15:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8046','296','1','12009','2.99','2006-02-14T15:16:03.000','2006-02-15T22:15:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8047','297','2','143','0.99','2005-05-25T23:45:52.000','2006-02-15T22:15:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8048','297','1','954','3.99','2005-05-30T16:57:29.000','2006-02-15T22:15:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8049','297','1','1409','3.99','2005-06-15T16:58:12.000','2006-02-15T22:15:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8050','297','1','2067','2.99','2005-06-17T16:11:08.000','2006-02-15T22:15:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8051','297','1','2202','8.99','2005-06-18T02:09:24.000','2006-02-15T22:15:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8052','297','1','2260','2.99','2005-06-18T05:38:36.000','2006-02-15T22:15:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8053','297','2','2339','4.99','2005-06-18T11:29:22.000','2006-02-15T22:15:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8054','297','1','3582','0.99','2005-07-06T04:10:35.000','2006-02-15T22:15:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8055','297','2','4621','2.99','2005-07-08T08:02:18.000','2006-02-15T22:15:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8056','297','1','4929','5.99','2005-07-08T22:06:18.000','2006-02-15T22:15:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8057','297','1','5743','8.99','2005-07-10T11:57:38.000','2006-02-15T22:15:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8058','297','2','6036','2.99','2005-07-11T03:02:28.000','2006-02-15T22:15:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8059','297','1','6064','6.99','2005-07-11T04:23:18.000','2006-02-15T22:15:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8060','297','1','6156','4.99','2005-07-11T09:45:48.000','2006-02-15T22:15:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8061','297','1','6984','2.99','2005-07-27T00:56:30.000','2006-02-15T22:15:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8062','297','2','7867','0.99','2005-07-28T10:08:54.000','2006-02-15T22:15:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8063','297','1','7933','0.99','2005-07-28T12:27:27.000','2006-02-15T22:15:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8064','297','2','9014','2.99','2005-07-30T05:19:27.000','2006-02-15T22:15:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8065','297','2','9674','5.99','2005-07-31T06:36:53.000','2006-02-15T22:15:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8066','297','1','10153','0.99','2005-07-31T22:30:10.000','2006-02-15T22:15:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8067','297','2','10264','4.99','2005-08-01T03:03:12.000','2006-02-15T22:15:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8068','297','2','11269','0.99','2005-08-02T14:11:41.000','2006-02-15T22:15:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8069','297','2','11413','0.99','2005-08-02T19:35:19.000','2006-02-15T22:15:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8070','297','2','11585','4.99','2005-08-17T02:14:36.000','2006-02-15T22:15:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8071','297','1','11780','2.99','2005-08-17T10:34:24.000','2006-02-15T22:15:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8072','297','1','11784','0.99','2005-08-17T10:48:05.000','2006-02-15T22:15:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8073','297','1','12472','10.99','2005-08-18T11:58:48.000','2006-02-15T22:15:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8074','297','1','13330','2.99','2005-08-19T19:59:21.000','2006-02-15T22:15:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8075','297','2','13721','4.99','2005-08-20T10:02:59.000','2006-02-15T22:15:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8076','297','1','13888','1.99','2005-08-20T15:39:42.000','2006-02-15T22:15:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8077','297','1','14403','5.99','2005-08-21T10:40:34.000','2006-02-15T22:15:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8078','297','2','15582','2.99','2005-08-23T05:45:44.000','2006-02-15T22:15:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8079','297','1','15711','4.99','2005-08-23T10:43:00.000','2006-02-15T22:15:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8080','298','1','383','3.99','2005-05-27T10:12:20.000','2006-02-15T22:15:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8081','298','2','1454','4.99','2005-06-15T19:49:41.000','2006-02-15T22:15:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8082','298','2','2385','3.99','2005-06-18T15:22:40.000','2006-02-15T22:15:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8083','298','2','3095','4.99','2005-06-20T16:16:53.000','2006-02-15T22:15:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8084','298','2','3400','4.99','2005-06-21T15:50:30.000','2006-02-15T22:15:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8085','298','2','3479','0.99','2005-07-05T23:08:53.000','2006-02-15T22:15:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8086','298','1','3728','2.99','2005-07-06T11:29:00.000','2006-02-15T22:15:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8087','298','2','4291','2.99','2005-07-07T15:47:47.000','2006-02-15T22:15:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8088','298','1','4936','3.99','2005-07-08T22:24:50.000','2006-02-15T22:15:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8089','298','2','5166','2.99','2005-07-09T09:15:48.000','2006-02-15T22:15:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8090','298','1','5247','2.99','2005-07-09T13:26:28.000','2006-02-15T22:15:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8091','298','2','6802','0.99','2005-07-12T17:14:17.000','2006-02-15T22:15:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8092','298','2','7802','0.99','2005-07-28T07:51:57.000','2006-02-15T22:15:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8093','298','1','7869','7.99','2005-07-28T10:13:15.000','2006-02-15T22:15:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8094','298','2','8737','5.99','2005-07-29T18:32:13.000','2006-02-15T22:15:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8095','298','2','10248','6.99','2005-08-01T02:35:28.000','2006-02-15T22:15:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8096','298','1','11070','0.99','2005-08-02T07:10:39.000','2006-02-15T22:15:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8097','298','2','11288','6.99','2005-08-02T14:54:08.000','2006-02-15T22:15:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8098','298','2','12076','0.99','2005-08-17T21:58:19.000','2006-02-15T22:15:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8099','298','1','12765','8.99','2005-08-18T23:21:50.000','2006-02-15T22:15:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8100','298','1','13172','0.99','2005-08-19T13:49:07.000','2006-02-15T22:15:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8101','298','1','13244','4.99','2005-08-19T16:43:04.000','2006-02-15T22:15:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8102','298','2','14473','0.99','2005-08-21T13:19:03.000','2006-02-15T22:15:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8103','298','1','15245','3.99','2005-08-22T17:49:35.000','2006-02-15T22:15:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8104','298','2','15262','4.99','2005-08-22T18:25:21.000','2006-02-15T22:15:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8105','298','1','15643','4.99','2005-08-23T08:13:26.000','2006-02-15T22:15:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8106','299','1','332','5.99','2005-05-27T02:27:10.000','2006-02-15T22:15:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8107','299','2','606','8.99','2005-05-28T14:48:39.000','2006-02-15T22:15:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8108','299','1','1650','8.99','2005-06-16T09:23:20.000','2006-02-15T22:15:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8109','299','2','2664','4.99','2005-06-19T11:11:23.000','2006-02-15T22:15:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8110','299','1','2774','2.99','2005-06-19T18:05:11.000','2006-02-15T22:15:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8111','299','2','2791','4.99','2005-06-19T18:51:27.000','2006-02-15T22:15:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8112','299','1','3074','0.99','2005-06-20T14:41:41.000','2006-02-15T22:15:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8113','299','2','3223','2.99','2005-06-21T02:06:45.000','2006-02-15T22:15:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8114','299','1','3288','5.99','2005-06-21T06:36:59.000','2006-02-15T22:15:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8115','299','2','3497','0.99','2005-07-06T00:00:03.000','2006-02-15T22:15:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8116','299','2','4153','5.99','2005-07-07T08:53:08.000','2006-02-15T22:15:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8117','299','1','4350','2.99','2005-07-07T19:02:41.000','2006-02-15T22:15:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8118','299','2','5033','1.99','2005-07-09T02:42:01.000','2006-02-15T22:15:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8119','299','1','5642','2.99','2005-07-10T06:46:08.000','2006-02-15T22:15:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8120','299','2','6732','0.99','2005-07-12T13:58:51.000','2006-02-15T22:15:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8121','299','1','6853','7.99','2005-07-12T19:38:11.000','2006-02-15T22:15:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8122','299','1','7264','4.99','2005-07-27T11:18:58.000','2006-02-15T22:15:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8123','299','1','7746','2.99','2005-07-28T05:48:56.000','2006-02-15T22:15:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8124','299','2','7862','9.99','2005-07-28T10:02:25.000','2006-02-15T22:15:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8125','299','1','9520','2.99','2005-07-31T00:50:54.000','2006-02-15T22:15:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8126','299','1','10201','0.99','2005-08-01T00:42:18.000','2006-02-15T22:15:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8127','299','2','10440','2.99','2005-08-01T08:54:32.000','2006-02-15T22:15:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8128','299','1','11629','6.99','2005-08-17T04:27:24.000','2006-02-15T22:15:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8129','299','1','11746','5.99','2005-08-17T09:03:24.000','2006-02-15T22:15:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8130','299','1','11998','0.99','2005-08-17T18:46:21.000','2006-02-15T22:15:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8131','299','1','13069','4.99','2005-08-19T09:55:20.000','2006-02-15T22:15:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8132','299','2','14208','0.99','2005-08-21T04:09:18.000','2006-02-15T22:15:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8133','299','1','14548','3.99','2005-08-21T15:53:52.000','2006-02-15T22:15:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8134','299','2','14889','4.99','2005-08-22T04:10:10.000','2006-02-15T22:15:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8135','299','2','14898','6.99','2005-08-22T04:26:34.000','2006-02-15T22:15:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8136','300','2','457','0.99','2005-05-27T19:52:29.000','2006-02-15T22:15:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8137','300','1','780','3.99','2005-05-29T14:18:32.000','2006-02-15T22:15:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8138','300','1','1111','4.99','2005-05-31T15:24:19.000','2006-02-15T22:15:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8139','300','2','1381','0.99','2005-06-15T15:17:21.000','2006-02-15T22:15:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8140','300','1','3177','2.99','2005-06-20T22:32:44.000','2006-02-15T22:15:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8141','300','1','3775','0.99','2005-07-06T13:27:33.000','2006-02-15T22:15:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8142','300','1','4030','0.99','2005-07-07T02:25:42.000','2006-02-15T22:15:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8143','300','2','5562','2.99','2005-07-10T03:17:42.000','2006-02-15T22:15:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8144','300','1','5705','10.99','2005-07-10T10:09:17.000','2006-02-15T22:15:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8145','300','2','6111','4.99','2005-07-11T07:26:57.000','2006-02-15T22:15:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8146','300','1','6822','5.99','2005-07-12T18:23:39.000','2006-02-15T22:15:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8147','300','1','6998','4.99','2005-07-27T01:16:29.000','2006-02-15T22:15:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8148','300','1','7815','4.99','2005-07-28T08:14:11.000','2006-02-15T22:15:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8149','300','1','8117','6.99','2005-07-28T19:20:16.000','2006-02-15T22:15:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8150','300','1','8210','6.99','2005-07-28T23:31:05.000','2006-02-15T22:15:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8151','300','1','8283','3.99','2005-07-29T01:52:22.000','2006-02-15T22:15:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8152','300','1','9078','0.99','2005-07-30T08:01:00.000','2006-02-15T22:15:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8153','300','2','9127','2.99','2005-07-30T09:46:36.000','2006-02-15T22:15:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8154','300','2','9791','0.99','2005-07-31T10:35:22.000','2006-02-15T22:15:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8155','300','1','10977','4.99','2005-08-02T04:12:17.000','2006-02-15T22:15:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8156','300','2','12484','2.99','2005-08-18T12:39:37.000','2006-02-15T22:15:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8157','300','2','12644','5.99','2005-08-18T18:22:27.000','2006-02-15T22:15:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8158','300','2','13257','3.99','2005-08-19T17:01:20.000','2006-02-15T22:15:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8159','300','1','13296','0.99','2005-08-19T18:43:53.000','2006-02-15T22:15:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8160','300','2','13499','6.99','2005-08-20T01:52:30.000','2006-02-15T22:15:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8161','300','1','13717','5.99','2005-08-20T09:50:52.000','2006-02-15T22:15:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8162','300','1','14674','7.99','2005-08-21T20:01:34.000','2006-02-15T22:15:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8163','300','1','14709','9.99','2005-08-21T21:07:59.000','2006-02-15T22:15:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8164','300','2','15051','2.99','2005-08-22T10:08:50.000','2006-02-15T22:15:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8165','300','2','15811','5.99','2005-08-23T14:43:46.000','2006-02-15T22:15:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8166','300','1','15695','4.99','2006-02-14T15:16:03.000','2006-02-15T22:15:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8167','301','2','27','4.99','2005-05-25T03:41:50.000','2006-02-15T22:15:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8168','301','2','227','5.99','2005-05-26T10:51:46.000','2006-02-15T22:15:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8169','301','1','955','0.99','2005-05-30T16:59:03.000','2006-02-15T22:15:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8170','301','1','1853','0.99','2005-06-17T00:39:54.000','2006-02-15T22:15:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8171','301','1','2611','4.99','2005-06-19T07:18:17.000','2006-02-15T22:15:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8172','301','2','2925','2.99','2005-06-20T04:23:49.000','2006-02-15T22:15:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8173','301','2','4316','4.99','2005-07-07T17:44:22.000','2006-02-15T22:15:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8174','301','2','4834','3.99','2005-07-08T18:07:45.000','2006-02-15T22:15:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8175','301','1','5119','6.99','2005-07-09T07:14:18.000','2006-02-15T22:15:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8176','301','2','5511','4.99','2005-07-10T01:00:00.000','2006-02-15T22:15:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8177','301','2','5730','2.99','2005-07-10T11:28:32.000','2006-02-15T22:15:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8178','301','2','5807','2.99','2005-07-10T15:16:30.000','2006-02-15T22:15:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8179','301','2','6833','6.99','2005-07-12T18:53:34.000','2006-02-15T22:15:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8180','301','2','7318','4.99','2005-07-27T13:25:31.000','2006-02-15T22:15:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8181','301','2','7818','4.99','2005-07-28T08:25:00.000','2006-02-15T22:15:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8182','301','2','9435','4.99','2005-07-30T21:31:02.000','2006-02-15T22:15:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8183','301','1','10883','0.99','2005-08-02T00:47:19.000','2006-02-15T22:15:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8184','301','2','13183','5.99','2005-08-19T14:09:26.000','2006-02-15T22:15:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8185','301','2','13633','2.99','2005-08-20T07:13:47.000','2006-02-15T22:15:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8186','301','1','15201','10.99','2005-08-22T16:24:42.000','2006-02-15T22:15:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8187','301','1','15268','1.99','2005-08-22T18:39:11.000','2006-02-15T22:15:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8188','302','2','38','4.99','2005-05-25T04:47:44.000','2006-02-15T22:15:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8189','302','2','92','5.99','2005-05-25T15:38:46.000','2006-02-15T22:15:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8190','302','1','1231','2.99','2005-06-15T04:04:41.000','2006-02-15T22:15:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8191','302','2','4676','4.99','2005-07-08T10:26:02.000','2006-02-15T22:15:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8192','302','2','5498','0.99','2005-07-10T00:27:21.000','2006-02-15T22:15:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8193','302','2','5682','2.99','2005-07-10T08:51:39.000','2006-02-15T22:15:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8194','302','2','5709','0.99','2005-07-10T10:31:52.000','2006-02-15T22:15:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8195','302','2','5821','4.99','2005-07-10T16:07:16.000','2006-02-15T22:15:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8196','302','2','6623','7.99','2005-07-12T09:05:34.000','2006-02-15T22:15:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8197','302','1','7183','0.99','2005-07-27T08:18:38.000','2006-02-15T22:15:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8198','302','1','7411','6.99','2005-07-27T16:42:30.000','2006-02-15T22:15:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8199','302','1','8363','6.99','2005-07-29T05:10:08.000','2006-02-15T22:15:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8200','302','2','8646','0.99','2005-07-29T14:48:48.000','2006-02-15T22:15:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8201','302','1','8795','2.99','2005-07-29T21:04:14.000','2006-02-15T22:15:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8202','302','1','9146','7.99','2005-07-30T10:32:08.000','2006-02-15T22:15:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8203','302','2','9358','2.99','2005-07-30T18:37:24.000','2006-02-15T22:15:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8204','302','1','9374','8.99','2005-07-30T19:10:03.000','2006-02-15T22:15:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8205','302','2','9581','5.99','2005-07-31T03:03:07.000','2006-02-15T22:15:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8206','302','2','10329','0.99','2005-08-01T04:56:13.000','2006-02-15T22:15:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8207','302','1','12126','7.99','2005-08-17T23:25:21.000','2006-02-15T22:15:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8208','302','2','12516','4.99','2005-08-18T13:39:53.000','2006-02-15T22:15:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8209','302','1','12903','2.99','2005-08-19T04:09:38.000','2006-02-15T22:15:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8210','302','1','13916','2.99','2005-08-20T16:43:02.000','2006-02-15T22:15:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8211','302','1','14120','4.99','2005-08-21T01:25:00.000','2006-02-15T22:15:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8212','302','2','14247','3.99','2005-08-21T05:35:17.000','2006-02-15T22:15:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8213','302','2','15578','2.99','2005-08-23T05:37:13.000','2006-02-15T22:15:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8214','302','1','15622','5.99','2005-08-23T07:22:02.000','2006-02-15T22:15:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8215','302','2','15734','0.99','2005-08-23T11:40:08.000','2006-02-15T22:15:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8216','302','2','15987','6.99','2005-08-23T20:22:17.000','2006-02-15T22:15:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8217','303','1','265','0.99','2005-05-26T16:07:38.000','2006-02-15T22:15:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8218','303','1','871','2.99','2005-05-30T05:01:30.000','2006-02-15T22:15:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8219','303','2','1050','4.99','2005-05-31T07:01:27.000','2006-02-15T22:15:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8220','303','2','1970','4.99','2005-06-17T09:23:16.000','2006-02-15T22:15:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8221','303','1','2223','8.99','2005-06-18T03:27:03.000','2006-02-15T22:15:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8222','303','1','3077','3.99','2005-06-20T15:05:18.000','2006-02-15T22:15:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8223','303','1','3107','2.99','2005-06-20T17:26:05.000','2006-02-15T22:15:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8224','303','1','5140','4.99','2005-07-09T08:04:59.000','2006-02-15T22:15:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8225','303','1','6205','4.99','2005-07-11T12:31:24.000','2006-02-15T22:15:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8226','303','2','6219','4.99','2005-07-11T13:18:37.000','2006-02-15T22:15:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8227','303','1','6464','4.99','2005-07-12T01:16:40.000','2006-02-15T22:15:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8228','303','1','7023','4.99','2005-07-27T02:32:44.000','2006-02-15T22:15:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8229','303','2','7502','2.99','2005-07-27T20:19:08.000','2006-02-15T22:15:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8230','303','1','8409','0.99','2005-07-29T06:41:22.000','2006-02-15T22:15:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8231','303','2','8734','6.99','2005-07-29T18:28:15.000','2006-02-15T22:15:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8232','303','2','8764','0.99','2005-07-29T19:39:04.000','2006-02-15T22:15:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8233','303','2','10209','2.99','2005-08-01T00:56:47.000','2006-02-15T22:15:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8234','303','1','11253','4.99','2005-08-02T13:42:44.000','2006-02-15T22:15:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8235','303','2','11673','2.99','2005-08-17T05:54:15.000','2006-02-15T22:15:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8236','303','2','11993','2.99','2005-08-17T18:27:49.000','2006-02-15T22:15:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8237','303','2','12117','0.99','2005-08-17T23:11:12.000','2006-02-15T22:15:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8238','303','1','12365','0.99','2005-08-18T07:55:09.000','2006-02-15T22:15:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8239','303','2','12473','2.99','2005-08-18T11:59:44.000','2006-02-15T22:15:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8240','303','1','14750','5.99','2005-08-21T23:09:32.000','2006-02-15T22:15:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8241','303','2','14795','4.99','2005-08-22T00:40:22.000','2006-02-15T22:15:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8242','303','1','15511','3.99','2005-08-23T02:55:42.000','2006-02-15T22:15:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8243','304','1','135','10.99','2005-05-25T21:58:58.000','2006-02-15T22:15:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8244','304','1','415','0.99','2005-05-27T14:51:45.000','2006-02-15T22:15:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8245','304','2','937','2.99','2005-05-30T14:47:31.000','2006-02-15T22:15:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8246','304','1','1414','6.99','2005-06-15T17:26:32.000','2006-02-15T22:15:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8247','304','2','1525','4.99','2005-06-16T00:26:07.000','2006-02-15T22:15:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8248','304','1','2039','3.99','2005-06-17T14:03:43.000','2006-02-15T22:15:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8249','304','2','2902','4.99','2005-06-20T02:45:35.000','2006-02-15T22:15:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8250','304','1','4466','6.99','2005-07-08T00:12:53.000','2006-02-15T22:15:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8251','304','2','4812','8.99','2005-07-08T17:07:11.000','2006-02-15T22:15:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8252','304','1','5411','2.99','2005-07-09T20:23:38.000','2006-02-15T22:15:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8253','304','1','5712','4.99','2005-07-10T10:40:32.000','2006-02-15T22:15:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8254','304','2','5749','3.99','2005-07-10T12:20:36.000','2006-02-15T22:15:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8255','304','2','5795','0.99','2005-07-10T14:36:29.000','2006-02-15T22:15:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8256','304','2','6107','0.99','2005-07-11T07:07:09.000','2006-02-15T22:15:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8257','304','1','6737','4.99','2005-07-12T14:16:52.000','2006-02-15T22:15:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8258','304','2','7551','4.99','2005-07-27T21:59:15.000','2006-02-15T22:15:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8259','304','2','8055','4.99','2005-07-28T17:02:32.000','2006-02-15T22:15:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8260','304','1','9930','0.99','2005-07-31T15:18:03.000','2006-02-15T22:15:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8261','304','1','9992','6.99','2005-07-31T17:29:48.000','2006-02-15T22:15:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8262','304','1','10631','0.99','2005-08-01T15:35:14.000','2006-02-15T22:15:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8263','304','2','11983','4.99','2005-08-17T18:13:55.000','2006-02-15T22:15:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8264','304','1','12540','5.99','2005-08-18T14:17:30.000','2006-02-15T22:15:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8265','304','2','13911','3.99','2005-08-20T16:31:33.000','2006-02-15T22:15:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8266','304','1','14023','0.99','2005-08-20T21:10:32.000','2006-02-15T22:15:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8267','304','1','14899','4.99','2005-08-22T04:26:38.000','2006-02-15T22:15:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8268','304','1','14945','4.99','2005-08-22T06:05:38.000','2006-02-15T22:15:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8269','305','2','69','2.99','2005-05-25T10:10:14.000','2006-02-15T22:15:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8270','305','1','1574','4.99','2005-06-16T03:39:56.000','2006-02-15T22:15:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8271','305','2','1884','0.99','2005-06-17T03:19:20.000','2006-02-15T22:15:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8272','305','1','2166','11.99','2005-06-17T23:51:21.000','2006-02-15T22:15:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8273','305','1','3387','0.99','2005-06-21T14:21:49.000','2006-02-15T22:15:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8274','305','2','4260','4.99','2005-07-07T14:22:45.000','2006-02-15T22:15:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8275','305','1','4638','2.99','2005-07-08T08:57:20.000','2006-02-15T22:15:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8276','305','2','5041','0.99','2005-07-09T03:18:51.000','2006-02-15T22:15:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8277','305','1','5052','2.99','2005-07-09T03:59:43.000','2006-02-15T22:15:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8278','305','2','5582','4.99','2005-07-10T04:08:25.000','2006-02-15T22:15:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8279','305','1','5745','8.99','2005-07-10T12:10:11.000','2006-02-15T22:15:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8280','305','1','6134','7.99','2005-07-11T08:28:19.000','2006-02-15T22:15:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8281','305','2','6619','0.99','2005-07-12T08:50:48.000','2006-02-15T22:15:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8282','305','2','8865','4.99','2005-07-29T23:54:54.000','2006-02-15T22:15:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8283','305','2','9119','4.99','2005-07-30T09:25:56.000','2006-02-15T22:15:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8284','305','2','10426','4.99','2005-08-01T08:26:08.000','2006-02-15T22:15:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8285','305','2','10929','4.99','2005-08-02T02:35:44.000','2006-02-15T22:15:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8286','305','1','10981','2.99','2005-08-02T04:17:53.000','2006-02-15T22:15:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8287','305','2','11035','5.99','2005-08-02T05:55:39.000','2006-02-15T22:15:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8288','305','2','11809','3.99','2005-08-17T11:51:39.000','2006-02-15T22:15:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8289','305','2','12592','3.99','2005-08-18T16:17:50.000','2006-02-15T22:15:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8290','305','2','12846','0.99','2005-08-19T02:03:26.000','2006-02-15T22:15:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8291','305','1','13782','4.99','2005-08-20T12:09:26.000','2006-02-15T22:15:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8292','305','2','15417','2.99','2005-08-22T23:54:04.000','2006-02-15T22:15:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8293','305','1','15612','6.99','2005-08-23T06:59:07.000','2006-02-15T22:15:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8294','306','2','375','3.99','2005-05-27T08:49:21.000','2006-02-15T22:15:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8295','306','2','672','6.99','2005-05-28T22:05:29.000','2006-02-15T22:15:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8296','306','2','1172','0.99','2005-06-14T23:54:34.000','2006-02-15T22:15:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8297','306','2','2836','6.99','2005-06-19T21:58:21.000','2006-02-15T22:15:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8298','306','1','3814','6.99','2005-07-06T15:23:56.000','2006-02-15T22:15:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8299','306','2','4484','5.99','2005-07-08T01:05:57.000','2006-02-15T22:15:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8300','306','2','4596','1.99','2005-07-08T06:41:25.000','2006-02-15T22:15:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8301','306','2','5581','2.99','2005-07-10T04:06:06.000','2006-02-15T22:15:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8302','306','2','6868','2.99','2005-07-12T20:10:17.000','2006-02-15T22:15:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8303','306','1','6953','4.99','2005-07-26T23:52:47.000','2006-02-15T22:15:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8304','306','1','7225','6.99','2005-07-27T09:47:12.000','2006-02-15T22:15:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8305','306','1','7232','4.99','2005-07-27T10:04:19.000','2006-02-15T22:15:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8306','306','2','7701','2.99','2005-07-28T03:54:28.000','2006-02-15T22:15:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8307','306','2','8620','0.99','2005-07-29T13:51:20.000','2006-02-15T22:15:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8308','306','1','8702','0.99','2005-07-29T17:04:37.000','2006-02-15T22:15:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8309','306','2','9242','4.99','2005-07-30T14:03:58.000','2006-02-15T22:15:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8310','306','2','9395','4.99','2005-07-30T20:07:06.000','2006-02-15T22:15:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8311','306','1','9774','0.99','2005-07-31T09:57:51.000','2006-02-15T22:15:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8312','306','1','10202','6.99','2005-08-01T00:43:18.000','2006-02-15T22:15:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8313','306','2','10893','5.99','2005-08-02T01:12:13.000','2006-02-15T22:15:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8314','306','2','11142','4.99','2005-08-02T09:30:11.000','2006-02-15T22:15:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8315','306','1','11440','0.99','2005-08-02T20:24:02.000','2006-02-15T22:15:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8316','306','2','11674','6.99','2005-08-17T05:56:27.000','2006-02-15T22:15:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8317','306','2','11776','0.99','2005-08-17T10:27:19.000','2006-02-15T22:15:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8318','306','1','12225','7.99','2005-08-18T03:00:11.000','2006-02-15T22:15:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8319','306','1','12989','2.99','2005-08-19T07:19:04.000','2006-02-15T22:15:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8320','306','1','13686','4.99','2005-08-20T08:57:28.000','2006-02-15T22:15:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8321','306','2','13725','5.99','2005-08-20T10:08:27.000','2006-02-15T22:15:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8322','306','1','13873','0.99','2005-08-20T15:11:11.000','2006-02-15T22:15:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8323','306','1','13996','4.99','2005-08-20T19:45:43.000','2006-02-15T22:15:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8324','306','1','15457','2.99','2005-08-23T01:07:37.000','2006-02-15T22:15:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8325','306','2','15868','7.99','2005-08-23T16:19:14.000','2006-02-15T22:15:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8326','307','2','413','4.99','2005-05-27T14:45:37.000','2006-02-15T22:15:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8327','307','1','535','4.99','2005-05-28T06:16:32.000','2006-02-15T22:15:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8328','307','1','614','1.99','2005-05-28T15:33:28.000','2006-02-15T22:15:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8329','307','1','970','6.99','2005-05-30T19:50:28.000','2006-02-15T22:15:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8330','307','2','2152','2.99','2005-06-17T22:53:27.000','2006-02-15T22:15:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8331','307','1','2167','0.99','2005-06-17T23:51:28.000','2006-02-15T22:15:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8332','307','1','2787','4.99','2005-06-19T18:47:00.000','2006-02-15T22:15:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8333','307','1','2881','2.99','2005-06-20T01:26:18.000','2006-02-15T22:15:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8334','307','2','3057','5.99','2005-06-20T13:22:48.000','2006-02-15T22:15:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8335','307','1','3209','4.99','2005-06-21T00:51:06.000','2006-02-15T22:15:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8336','307','1','3962','6.99','2005-07-06T22:13:45.000','2006-02-15T22:15:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8337','307','1','3985','4.99','2005-07-06T23:24:03.000','2006-02-15T22:15:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8338','307','1','4522','2.99','2005-07-08T03:03:12.000','2006-02-15T22:15:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8339','307','1','4868','4.99','2005-07-08T19:13:50.000','2006-02-15T22:15:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8340','307','1','5871','3.99','2005-07-10T18:46:08.000','2006-02-15T22:15:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8341','307','2','6125','6.99','2005-07-11T08:03:35.000','2006-02-15T22:15:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8342','307','1','6256','0.99','2005-07-11T15:19:22.000','2006-02-15T22:15:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8343','307','1','6991','10.99','2005-07-27T01:03:06.000','2006-02-15T22:15:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8344','307','1','7536','2.99','2005-07-27T21:34:09.000','2006-02-15T22:15:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8345','307','1','7760','3.99','2005-07-28T06:29:45.000','2006-02-15T22:15:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8346','307','1','7929','0.99','2005-07-28T12:16:40.000','2006-02-15T22:15:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8347','307','1','8647','6.99','2005-07-29T14:52:59.000','2006-02-15T22:15:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8348','307','1','10135','4.99','2005-07-31T21:57:32.000','2006-02-15T22:15:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8349','307','1','10374','0.99','2005-08-01T06:25:27.000','2006-02-15T22:15:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8350','307','1','10745','2.99','2005-08-01T19:57:06.000','2006-02-15T22:15:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8351','307','1','11491','7.99','2005-08-02T22:44:50.000','2006-02-15T22:15:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8352','307','2','12391','4.99','2005-08-18T08:52:53.000','2006-02-15T22:15:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8353','307','2','13365','6.99','2005-08-19T21:12:37.000','2006-02-15T22:15:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8354','307','1','14231','0.99','2005-08-21T05:04:34.000','2006-02-15T22:15:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8355','307','2','15515','4.99','2005-08-23T03:03:53.000','2006-02-15T22:15:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8356','308','2','589','3.99','2005-05-28T12:27:50.000','2006-02-15T22:15:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8357','308','1','2037','0.99','2005-06-17T13:54:20.000','2006-02-15T22:15:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8358','308','1','2094','0.99','2005-06-17T18:18:56.000','2006-02-15T22:15:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8359','308','2','2168','4.99','2005-06-17T23:53:24.000','2006-02-15T22:15:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8360','308','1','2346','7.99','2005-06-18T12:08:16.000','2006-02-15T22:15:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8361','308','2','2448','4.99','2005-06-18T19:13:45.000','2006-02-15T22:15:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8362','308','1','4002','3.99','2005-07-07T00:08:18.000','2006-02-15T22:15:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8363','308','1','4285','8.99','2005-07-07T15:34:35.000','2006-02-15T22:15:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8364','308','1','5946','2.99','2005-07-10T22:57:29.000','2006-02-15T22:15:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8365','308','2','8869','0.99','2005-07-30T00:06:32.000','2006-02-15T22:15:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8366','308','1','9479','2.99','2005-07-30T23:22:09.000','2006-02-15T22:15:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8367','308','1','9746','7.99','2005-07-31T09:16:48.000','2006-02-15T22:15:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8368','308','1','10571','2.99','2005-08-01T13:25:30.000','2006-02-15T22:15:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8369','308','2','10797','0.99','2005-08-01T22:02:51.000','2006-02-15T22:15:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8370','308','1','10819','4.99','2005-08-01T22:52:57.000','2006-02-15T22:15:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8371','308','1','11765','2.99','2005-08-17T09:55:28.000','2006-02-15T22:15:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8372','308','1','11972','4.99','2005-08-17T17:55:46.000','2006-02-15T22:15:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8373','308','2','12567','3.99','2005-08-18T15:14:36.000','2006-02-15T22:15:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8374','308','1','12590','6.99','2005-08-18T16:11:35.000','2006-02-15T22:15:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8375','308','2','12838','6.99','2005-08-19T01:51:50.000','2006-02-15T22:15:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8376','308','1','13843','2.99','2005-08-20T14:30:01.000','2006-02-15T22:15:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8377','308','2','14946','2.99','2005-08-22T06:07:10.000','2006-02-15T22:15:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8378','308','1','15243','4.99','2005-08-22T17:48:28.000','2006-02-15T22:15:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8379','308','2','15493','4.99','2005-08-23T02:20:53.000','2006-02-15T22:15:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8380','308','2','15820','2.99','2005-08-23T15:03:13.000','2006-02-15T22:15:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8381','309','2','218','6.99','2005-05-26T09:27:09.000','2006-02-15T22:15:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8382','309','2','723','0.99','2005-05-29T05:34:44.000','2006-02-15T22:15:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8383','309','1','1837','4.99','2005-06-16T23:16:15.000','2006-02-15T22:15:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8384','309','2','2560','9.99','2005-06-19T03:12:42.000','2006-02-15T22:15:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8385','309','2','2644','3.99','2005-06-19T09:42:30.000','2006-02-15T22:15:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8386','309','2','2688','6.99','2005-06-19T12:50:56.000','2006-02-15T22:15:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8387','309','2','3837','4.99','2005-07-06T16:27:43.000','2006-02-15T22:15:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8388','309','2','3896','7.99','2005-07-06T19:09:15.000','2006-02-15T22:15:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8389','309','2','4172','4.99','2005-07-07T09:49:09.000','2006-02-15T22:15:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8390','309','1','4540','4.99','2005-07-08T04:03:28.000','2006-02-15T22:15:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8391','309','2','5305','8.99','2005-07-09T15:55:36.000','2006-02-15T22:15:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8392','309','1','5980','4.99','2005-07-11T00:18:21.000','2006-02-15T22:15:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8393','309','2','6480','4.99','2005-07-12T01:49:29.000','2006-02-15T22:15:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8394','309','2','7214','5.99','2005-07-27T09:23:33.000','2006-02-15T22:15:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8395','309','2','7722','4.99','2005-07-28T04:44:58.000','2006-02-15T22:15:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8396','309','1','7846','5.99','2005-07-28T09:21:18.000','2006-02-15T22:15:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8397','309','1','8341','4.99','2005-07-29T04:42:01.000','2006-02-15T22:15:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8398','309','1','8501','2.99','2005-07-29T09:12:51.000','2006-02-15T22:15:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8399','309','1','8681','2.99','2005-07-29T16:12:01.000','2006-02-15T22:15:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8400','309','1','8917','2.99','2005-07-30T01:47:02.000','2006-02-15T22:15:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8401','309','2','9945','2.99','2005-07-31T15:47:51.000','2006-02-15T22:15:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8402','309','1','9949','0.99','2005-07-31T15:50:10.000','2006-02-15T22:15:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8403','309','1','10458','2.99','2005-08-01T09:19:48.000','2006-02-15T22:15:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8404','309','1','10728','0.99','2005-08-01T19:15:09.000','2006-02-15T22:15:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8405','309','1','10818','2.99','2005-08-01T22:52:45.000','2006-02-15T22:15:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8406','309','2','11964','6.99','2005-08-17T17:37:03.000','2006-02-15T22:15:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8407','309','2','13021','5.99','2005-08-19T08:08:04.000','2006-02-15T22:15:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8408','309','2','13502','0.99','2005-08-20T01:58:15.000','2006-02-15T22:15:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8409','309','2','13909','4.99','2005-08-20T16:26:36.000','2006-02-15T22:15:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8410','309','2','14846','5.99','2005-08-22T02:13:48.000','2006-02-15T22:15:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8411','309','2','15422','4.99','2005-08-22T23:58:09.000','2006-02-15T22:15:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8412','310','2','104','0.99','2005-05-25T17:46:33.000','2006-02-15T22:15:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8413','310','2','1162','4.99','2005-06-14T23:09:38.000','2006-02-15T22:15:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8414','310','2','1333','2.99','2005-06-15T11:37:08.000','2006-02-15T22:15:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8415','310','2','1918','3.99','2005-06-17T05:40:14.000','2006-02-15T22:15:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8416','310','2','2088','6.99','2005-06-17T17:35:30.000','2006-02-15T22:15:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8417','310','1','2480','5.99','2005-06-18T21:04:09.000','2006-02-15T22:15:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8418','310','1','2618','2.99','2005-06-19T08:03:01.000','2006-02-15T22:15:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8419','310','2','3830','10.99','2005-07-06T16:01:16.000','2006-02-15T22:15:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8420','310','1','4072','0.99','2005-07-07T04:48:02.000','2006-02-15T22:15:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8421','310','1','5621','5.99','2005-07-10T05:34:10.000','2006-02-15T22:15:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8422','310','2','5836','0.99','2005-07-10T16:49:02.000','2006-02-15T22:15:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8423','310','1','7648','5.99','2005-07-28T01:35:33.000','2006-02-15T22:15:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8424','310','2','8637','5.99','2005-07-29T14:30:11.000','2006-02-15T22:15:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8425','310','1','8981','7.99','2005-07-30T04:25:30.000','2006-02-15T22:15:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8426','310','1','9536','2.99','2005-07-31T01:19:02.000','2006-02-15T22:15:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8427','310','2','11137','2.99','2005-08-02T09:25:31.000','2006-02-15T22:15:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8428','310','2','12500','4.99','2005-08-18T13:05:51.000','2006-02-15T22:15:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8429','310','2','12710','7.99','2005-08-18T21:02:50.000','2006-02-15T22:15:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8430','310','1','12929','4.99','2005-08-19T05:05:23.000','2006-02-15T22:15:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8431','310','1','14972','5.99','2005-08-22T06:53:21.000','2006-02-15T22:15:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8432','311','2','274','5.99','2005-05-26T16:48:51.000','2006-02-15T22:15:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8433','311','2','544','6.99','2005-05-28T07:03:00.000','2006-02-15T22:15:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8434','311','1','952','2.99','2005-05-30T16:28:07.000','2006-02-15T22:15:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8435','311','2','990','3.99','2005-05-30T23:25:14.000','2006-02-15T22:15:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8436','311','2','1128','6.99','2005-05-31T17:49:26.000','2006-02-15T22:15:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8437','311','1','1622','4.99','2005-06-16T07:33:18.000','2006-02-15T22:15:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8438','311','2','1955','0.99','2005-06-17T08:40:22.000','2006-02-15T22:15:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8439','311','2','2967','6.99','2005-06-20T07:40:35.000','2006-02-15T22:15:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8440','311','2','4836','3.99','2005-07-08T18:09:08.000','2006-02-15T22:15:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8441','311','2','5224','5.99','2005-07-09T12:07:27.000','2006-02-15T22:15:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8442','311','2','6419','4.99','2005-07-11T23:36:38.000','2006-02-15T22:15:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8443','311','2','8167','6.99','2005-07-28T21:25:45.000','2006-02-15T22:15:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8444','311','1','8473','2.99','2005-07-29T08:36:53.000','2006-02-15T22:15:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8445','311','1','9503','6.99','2005-07-31T00:02:38.000','2006-02-15T22:15:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8446','311','2','9882','8.99','2005-07-31T13:53:33.000','2006-02-15T22:15:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8447','311','1','10134','4.99','2005-07-31T21:56:10.000','2006-02-15T22:15:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8448','311','2','10448','4.99','2005-08-01T09:09:31.000','2006-02-15T22:15:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8449','311','1','12997','2.99','2005-08-19T07:31:46.000','2006-02-15T22:15:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8450','311','2','13310','0.99','2005-08-19T19:05:16.000','2006-02-15T22:15:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8451','311','2','13423','1.99','2005-08-19T23:07:42.000','2006-02-15T22:15:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8452','311','2','14517','4.99','2005-08-21T14:57:03.000','2006-02-15T22:15:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8453','311','2','15826','9.99','2005-08-23T15:15:02.000','2006-02-15T22:15:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8454','311','1','16020','8.99','2005-08-23T21:34:33.000','2006-02-15T22:15:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8455','312','2','229','4.99','2005-05-26T11:19:20.000','2006-02-15T22:15:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8456','312','1','530','0.99','2005-05-28T05:13:01.000','2006-02-15T22:15:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8457','312','2','1049','4.99','2005-05-31T06:57:04.000','2006-02-15T22:15:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8458','312','2','1079','6.99','2005-05-31T10:48:17.000','2006-02-15T22:15:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8459','312','2','1419','0.99','2005-06-15T17:54:50.000','2006-02-15T22:15:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8460','312','2','3457','3.99','2005-06-21T21:42:33.000','2006-02-15T22:15:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8461','312','1','3766','2.99','2005-07-06T13:04:35.000','2006-02-15T22:15:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8462','312','1','3792','1.99','2005-07-06T14:26:38.000','2006-02-15T22:15:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8463','312','1','4647','3.99','2005-07-08T09:27:36.000','2006-02-15T22:15:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8464','312','1','5031','5.99','2005-07-09T02:36:37.000','2006-02-15T22:15:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8465','312','2','6751','2.99','2005-07-12T14:50:34.000','2006-02-15T22:15:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8466','312','1','6866','2.99','2005-07-12T20:03:44.000','2006-02-15T22:15:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8467','312','1','8137','4.99','2005-07-28T20:07:18.000','2006-02-15T22:15:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8468','312','1','8412','6.99','2005-07-29T06:44:50.000','2006-02-15T22:15:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8469','312','1','8721','4.99','2005-07-29T17:56:21.000','2006-02-15T22:15:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8470','312','1','9016','6.99','2005-07-30T05:26:13.000','2006-02-15T22:15:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8471','312','1','9154','3.99','2005-07-30T10:59:54.000','2006-02-15T22:15:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8472','312','2','10858','2.99','2005-08-02T00:08:39.000','2006-02-15T22:15:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8473','312','2','11248','0.99','2005-08-02T13:35:34.000','2006-02-15T22:15:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8474','312','2','11879','5.99','2005-08-17T14:25:09.000','2006-02-15T22:15:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8475','312','1','12186','2.99','2005-08-18T01:43:36.000','2006-02-15T22:15:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8476','312','1','12945','0.99','2005-08-19T05:51:46.000','2006-02-15T22:15:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8477','312','2','14362','2.99','2005-08-21T09:19:49.000','2006-02-15T22:15:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8478','312','1','14504','3.99','2005-08-21T14:23:01.000','2006-02-15T22:15:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8479','312','1','15100','4.99','2005-08-22T11:55:03.000','2006-02-15T22:15:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8480','312','1','15882','6.99','2005-08-23T16:44:31.000','2006-02-15T22:15:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8481','313','2','669','4.99','2005-05-28T22:03:25.000','2006-02-15T22:15:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8482','313','2','712','2.99','2005-05-29T04:02:24.000','2006-02-15T22:15:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8483','313','2','781','0.99','2005-05-29T14:23:58.000','2006-02-15T22:15:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8484','313','2','843','0.99','2005-05-30T00:44:24.000','2006-02-15T22:15:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8485','313','2','1312','2.99','2005-06-15T10:16:27.000','2006-02-15T22:15:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8486','313','1','2617','7.99','2005-06-19T07:48:31.000','2006-02-15T22:15:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8487','313','2','2711','4.99','2005-06-19T14:12:22.000','2006-02-15T22:15:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8488','313','2','4552','2.99','2005-07-08T04:36:35.000','2006-02-15T22:15:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8489','313','1','5255','5.99','2005-07-09T13:51:08.000','2006-02-15T22:15:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8490','313','1','6384','2.99','2005-07-11T22:07:26.000','2006-02-15T22:15:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8491','313','2','7294','0.99','2005-07-27T12:38:14.000','2006-02-15T22:15:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8492','313','2','8381','4.99','2005-07-29T05:31:44.000','2006-02-15T22:15:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8493','313','1','8970','3.99','2005-07-30T04:02:05.000','2006-02-15T22:15:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8494','313','2','9836','2.99','2005-07-31T12:12:00.000','2006-02-15T22:15:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8495','313','2','10237','5.99','2005-08-01T02:07:32.000','2006-02-15T22:15:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8496','313','2','10933','7.99','2005-08-02T02:50:49.000','2006-02-15T22:15:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8497','313','2','11854','2.99','2005-08-17T13:42:52.000','2006-02-15T22:15:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8498','313','2','12011','2.99','2005-08-17T19:19:44.000','2006-02-15T22:15:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8499','313','2','14250','2.99','2005-08-21T05:39:35.000','2006-02-15T22:15:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8500','313','1','14325','4.99','2005-08-21T08:15:38.000','2006-02-15T22:15:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8501','313','2','15081','2.99','2005-08-22T11:14:31.000','2006-02-15T22:15:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8502','313','1','15340','0.99','2005-08-22T20:55:56.000','2006-02-15T22:15:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8503','313','2','15569','6.99','2005-08-23T05:24:29.000','2006-02-15T22:15:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8504','314','1','80','5.99','2005-05-25T12:12:07.000','2006-02-15T22:15:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8505','314','1','440','4.99','2005-05-27T18:00:35.000','2006-02-15T22:15:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8506','314','1','1598','3.99','2005-06-16T06:02:39.000','2006-02-15T22:15:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8507','314','1','1624','2.99','2005-06-16T07:48:57.000','2006-02-15T22:15:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8508','314','1','3517','0.99','2005-07-06T00:52:35.000','2006-02-15T22:15:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8509','314','1','3656','2.99','2005-07-06T07:55:22.000','2006-02-15T22:15:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8510','314','1','3808','0.99','2005-07-06T15:15:35.000','2006-02-15T22:15:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8511','314','2','4386','0.99','2005-07-07T20:55:19.000','2006-02-15T22:15:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8512','314','2','5241','4.99','2005-07-09T13:19:14.000','2006-02-15T22:15:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8513','314','2','5856','0.99','2005-07-10T17:57:32.000','2006-02-15T22:15:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8514','314','1','6192','5.99','2005-07-11T11:44:41.000','2006-02-15T22:15:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8515','314','1','6666','2.99','2005-07-12T11:32:15.000','2006-02-15T22:15:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8516','314','1','6763','3.99','2005-07-12T15:26:34.000','2006-02-15T22:15:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8517','314','2','7004','4.99','2005-07-27T01:36:05.000','2006-02-15T22:15:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8518','314','1','7276','2.99','2005-07-27T11:41:57.000','2006-02-15T22:15:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8519','314','2','8022','6.99','2005-07-28T15:48:56.000','2006-02-15T22:15:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8520','314','1','8073','3.99','2005-07-28T17:29:02.000','2006-02-15T22:15:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8521','314','2','8105','0.99','2005-07-28T18:59:46.000','2006-02-15T22:15:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8522','314','2','8328','6.99','2005-07-29T04:06:24.000','2006-02-15T22:15:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8523','314','2','8644','4.99','2005-07-29T14:45:45.000','2006-02-15T22:15:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8524','314','2','9191','3.99','2005-07-30T12:25:51.000','2006-02-15T22:15:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8525','314','2','9318','6.99','2005-07-30T17:14:30.000','2006-02-15T22:15:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8526','314','2','11908','3.99','2005-08-17T15:43:09.000','2006-02-15T22:15:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8527','314','1','12434','0.99','2005-08-18T10:38:08.000','2006-02-15T22:15:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8528','314','2','13120','3.99','2005-08-19T11:47:38.000','2006-02-15T22:15:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8529','314','1','13265','2.99','2005-08-19T17:29:00.000','2006-02-15T22:15:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8530','314','2','13553','3.99','2005-08-20T04:07:21.000','2006-02-15T22:15:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8531','314','2','14145','4.99','2005-08-21T02:11:38.000','2006-02-15T22:15:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8532','314','1','14409','4.99','2005-08-21T10:53:35.000','2006-02-15T22:15:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8533','314','2','14682','4.99','2005-08-21T20:25:57.000','2006-02-15T22:15:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8534','314','2','14815','4.99','2005-08-22T01:12:44.000','2006-02-15T22:15:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8535','314','2','14873','5.99','2005-08-22T03:31:06.000','2006-02-15T22:15:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8536','314','2','16021','3.99','2005-08-23T21:37:59.000','2006-02-15T22:15:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8537','315','1','537','8.99','2005-05-28T06:20:55.000','2006-02-15T22:15:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8538','315','1','551','4.99','2005-05-28T07:44:18.000','2006-02-15T22:15:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8539','315','1','1701','2.99','2005-06-16T13:18:48.000','2006-02-15T22:15:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8540','315','1','4021','2.99','2005-07-07T01:46:44.000','2006-02-15T22:15:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8541','315','1','4992','4.99','2005-07-09T00:49:37.000','2006-02-15T22:15:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8542','315','2','5126','6.99','2005-07-09T07:25:35.000','2006-02-15T22:15:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8543','315','1','6661','4.99','2005-07-12T11:20:39.000','2006-02-15T22:15:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8544','315','1','6894','4.99','2005-07-12T21:20:50.000','2006-02-15T22:15:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8545','315','1','8416','5.99','2005-07-29T06:52:54.000','2006-02-15T22:15:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8546','315','2','8677','6.99','2005-07-29T16:01:13.000','2006-02-15T22:15:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8547','315','2','9735','9.99','2005-07-31T08:57:49.000','2006-02-15T22:15:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8548','315','2','11254','0.99','2005-08-02T13:43:49.000','2006-02-15T22:15:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8549','315','2','12155','2.99','2005-08-18T00:24:30.000','2006-02-15T22:15:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8550','315','1','14106','2.99','2005-08-21T00:46:01.000','2006-02-15T22:15:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8551','315','2','14162','2.99','2005-08-21T02:55:34.000','2006-02-15T22:15:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8552','315','1','15504','6.99','2005-08-23T02:45:21.000','2006-02-15T22:15:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8553','315','2','14426','2.99','2006-02-14T15:16:03.000','2006-02-15T22:15:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8554','316','1','16','4.99','2005-05-25T00:43:11.000','2006-02-15T22:15:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8555','316','1','644','8.99','2005-05-28T18:59:12.000','2006-02-15T22:15:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8556','316','1','1065','1.99','2005-05-31T08:54:56.000','2006-02-15T22:15:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8557','316','1','1317','4.99','2005-06-15T10:30:19.000','2006-02-15T22:15:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8558','316','2','1350','4.99','2005-06-15T12:50:25.000','2006-02-15T22:15:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8559','316','1','2032','4.99','2005-06-17T13:24:07.000','2006-02-15T22:15:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8560','316','2','2338','4.99','2005-06-18T11:24:54.000','2006-02-15T22:15:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8561','316','2','2491','1.99','2005-06-18T22:01:31.000','2006-02-15T22:15:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8562','316','1','2820','4.99','2005-06-19T20:20:33.000','2006-02-15T22:15:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8563','316','2','3373','8.99','2005-06-21T13:35:32.000','2006-02-15T22:15:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8564','316','1','4379','2.99','2005-07-07T20:32:30.000','2006-02-15T22:15:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8565','316','2','5102','3.99','2005-07-09T06:25:48.000','2006-02-15T22:15:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8566','316','2','5544','7.99','2005-07-10T02:48:07.000','2006-02-15T22:15:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8567','316','1','5618','5.99','2005-07-10T05:28:58.000','2006-02-15T22:15:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8568','316','2','6988','4.99','2005-07-27T01:00:08.000','2006-02-15T22:15:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8569','316','2','7339','2.99','2005-07-27T14:17:48.000','2006-02-15T22:15:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8570','316','2','7586','2.99','2005-07-27T23:19:29.000','2006-02-15T22:15:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8571','316','1','7592','4.99','2005-07-27T23:26:04.000','2006-02-15T22:15:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8572','316','1','7945','1.99','2005-07-28T12:53:58.000','2006-02-15T22:15:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8573','316','1','8564','4.99','2005-07-29T11:33:00.000','2006-02-15T22:16:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8574','316','1','9508','4.99','2005-07-31T00:22:39.000','2006-02-15T22:16:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8575','316','2','9903','6.99','2005-07-31T14:31:44.000','2006-02-15T22:16:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8576','316','1','10438','7.99','2005-08-01T08:53:04.000','2006-02-15T22:16:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8577','316','1','12028','0.99','2005-08-17T20:03:47.000','2006-02-15T22:16:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8578','316','2','12191','0.99','2005-08-18T01:57:11.000','2006-02-15T22:16:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8579','316','2','12823','2.99','2005-08-19T01:15:47.000','2006-02-15T22:16:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8580','316','2','13277','5.99','2005-08-19T17:57:35.000','2006-02-15T22:16:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8581','316','1','14226','2.99','2005-08-21T04:55:37.000','2006-02-15T22:16:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8582','316','2','15840','2.99','2005-08-23T15:34:49.000','2006-02-15T22:16:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8583','317','1','107','6.99','2005-05-25T18:28:09.000','2006-02-15T22:16:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8584','317','2','2287','6.99','2005-06-18T07:04:36.000','2006-02-15T22:16:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8585','317','2','3029','2.99','2005-06-20T11:51:30.000','2006-02-15T22:16:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8586','317','1','3251','0.99','2005-06-21T03:20:37.000','2006-02-15T22:16:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8587','317','1','4138','0.99','2005-07-07T08:17:13.000','2006-02-15T22:16:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8588','317','1','4177','8.99','2005-07-07T10:12:36.000','2006-02-15T22:16:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8589','317','2','4700','0.99','2005-07-08T11:37:21.000','2006-02-15T22:16:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8590','317','1','5548','0.99','2005-07-10T02:56:45.000','2006-02-15T22:16:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8591','317','2','5942','7.99','2005-07-10T22:47:17.000','2006-02-15T22:16:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8592','317','1','7309','2.99','2005-07-27T13:00:29.000','2006-02-15T22:16:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8593','317','2','8062','2.99','2005-07-28T17:15:06.000','2006-02-15T22:16:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8594','317','1','8327','2.99','2005-07-29T04:00:52.000','2006-02-15T22:16:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8595','317','1','8458','4.99','2005-07-29T08:05:09.000','2006-02-15T22:16:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8596','317','1','9110','2.99','2005-07-30T09:05:42.000','2006-02-15T22:16:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8597','317','2','9513','4.99','2005-07-31T00:28:30.000','2006-02-15T22:16:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8598','317','1','9770','8.99','2005-07-31T09:52:40.000','2006-02-15T22:16:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8599','317','1','10364','2.99','2005-08-01T06:06:49.000','2006-02-15T22:16:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8600','317','2','12111','2.99','2005-08-17T22:59:55.000','2006-02-15T22:16:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8601','317','2','12138','7.99','2005-08-17T23:55:54.000','2006-02-15T22:16:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8602','317','2','12301','2.99','2005-08-18T05:36:20.000','2006-02-15T22:16:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8603','317','1','13388','4.99','2005-08-19T21:46:49.000','2006-02-15T22:16:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8604','317','1','14032','5.99','2005-08-20T21:26:55.000','2006-02-15T22:16:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8605','317','2','14385','0.99','2005-08-21T10:02:55.000','2006-02-15T22:16:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8606','317','2','14669','2.99','2005-08-21T19:54:06.000','2006-02-15T22:16:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8607','317','1','14791','4.99','2005-08-22T00:35:55.000','2006-02-15T22:16:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8608','317','1','15204','2.99','2005-08-22T16:30:43.000','2006-02-15T22:16:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8609','317','1','15280','4.99','2005-08-22T19:09:52.000','2006-02-15T22:16:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8610','317','1','12574','0.99','2006-02-14T15:16:03.000','2006-02-15T22:16:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8611','318','1','224','9.99','2005-05-26T10:18:27.000','2006-02-15T22:16:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8612','318','1','2634','2.99','2005-06-19T08:55:17.000','2006-02-15T22:16:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8613','318','1','2643','2.99','2005-06-19T09:39:27.000','2006-02-15T22:16:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8614','318','2','3337','0.99','2005-06-21T10:24:35.000','2006-02-15T22:16:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8615','318','2','3376','7.99','2005-06-21T13:43:02.000','2006-02-15T22:16:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8616','318','1','3732','4.99','2005-07-06T11:33:37.000','2006-02-15T22:16:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8617','318','2','3974','2.99','2005-07-06T22:59:16.000','2006-02-15T22:16:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8618','318','1','4356','8.99','2005-07-07T19:21:22.000','2006-02-15T22:16:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8619','318','1','7649','0.99','2005-07-28T01:37:26.000','2006-02-15T22:16:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8620','318','2','7853','0.99','2005-07-28T09:36:38.000','2006-02-15T22:16:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8621','318','2','10023','5.99','2005-07-31T18:25:51.000','2006-02-15T22:16:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8622','318','1','14276','2.99','2005-08-21T06:34:05.000','2006-02-15T22:16:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8623','319','1','15','9.99','2005-05-25T00:39:22.000','2006-02-15T22:16:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8624','319','1','149','3.99','2005-05-26T00:28:05.000','2006-02-15T22:16:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8625','319','1','439','2.99','2005-05-27T17:54:48.000','2006-02-15T22:16:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8626','319','1','1632','2.99','2005-06-16T08:03:42.000','2006-02-15T22:16:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8627','319','1','1892','4.99','2005-06-17T04:17:33.000','2006-02-15T22:16:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8628','319','2','2021','3.99','2005-06-17T12:41:18.000','2006-02-15T22:16:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8629','319','2','2703','4.99','2005-06-19T13:36:06.000','2006-02-15T22:16:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8630','319','2','2884','0.99','2005-06-20T01:31:16.000','2006-02-15T22:16:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8631','319','2','3256','3.99','2005-06-21T03:45:42.000','2006-02-15T22:16:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8632','319','2','4119','3.99','2005-07-07T07:06:03.000','2006-02-15T22:16:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8633','319','2','4295','2.99','2005-07-07T16:08:51.000','2006-02-15T22:16:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8634','319','1','4630','4.99','2005-07-08T08:33:38.000','2006-02-15T22:16:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8635','319','1','5791','8.99','2005-07-10T14:16:22.000','2006-02-15T22:16:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8636','319','1','5882','2.99','2005-07-10T19:20:34.000','2006-02-15T22:16:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8637','319','2','6132','2.99','2005-07-11T08:24:44.000','2006-02-15T22:16:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8638','319','1','6195','4.99','2005-07-11T12:00:32.000','2006-02-15T22:16:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8639','319','1','6255','4.99','2005-07-11T15:11:33.000','2006-02-15T22:16:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8640','319','1','6485','6.99','2005-07-12T02:07:59.000','2006-02-15T22:16:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8641','319','2','7953','2.99','2005-07-28T13:24:32.000','2006-02-15T22:16:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8642','319','2','9017','4.99','2005-07-30T05:26:20.000','2006-02-15T22:16:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8643','319','2','9044','0.99','2005-07-30T06:35:21.000','2006-02-15T22:16:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8644','319','1','11575','0.99','2005-08-17T01:50:26.000','2006-02-15T22:16:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8645','319','2','11598','0.99','2005-08-17T03:03:07.000','2006-02-15T22:16:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8646','319','1','11955','6.99','2005-08-17T17:21:35.000','2006-02-15T22:16:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8647','319','2','11994','2.99','2005-08-17T18:29:35.000','2006-02-15T22:16:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8648','319','1','12018','4.99','2005-08-17T19:44:46.000','2006-02-15T22:16:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8649','319','2','12424','8.99','2005-08-18T10:16:57.000','2006-02-15T22:16:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8650','319','1','13548','3.99','2005-08-20T03:53:20.000','2006-02-15T22:16:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8651','319','2','14828','4.99','2005-08-22T01:34:05.000','2006-02-15T22:16:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8652','319','2','15396','5.99','2005-08-22T23:07:57.000','2006-02-15T22:16:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8653','320','2','1258','4.99','2005-06-15T06:21:30.000','2006-02-15T22:16:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8654','320','2','1484','3.99','2005-06-15T21:22:35.000','2006-02-15T22:16:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8655','320','2','1567','1.99','2005-06-16T03:13:30.000','2006-02-15T22:16:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8656','320','1','2216','4.99','2005-06-18T03:08:17.000','2006-02-15T22:16:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8657','320','2','2883','7.99','2005-06-20T01:29:10.000','2006-02-15T22:16:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8658','320','2','3519','0.99','2005-07-06T00:57:29.000','2006-02-15T22:16:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8659','320','2','3756','4.99','2005-07-06T12:40:38.000','2006-02-15T22:16:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8660','320','2','4173','2.99','2005-07-07T09:57:26.000','2006-02-15T22:16:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8661','320','2','7057','4.99','2005-07-27T03:50:03.000','2006-02-15T22:16:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8662','320','2','7064','3.99','2005-07-27T03:53:29.000','2006-02-15T22:16:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8663','320','2','7930','4.99','2005-07-28T12:21:08.000','2006-02-15T22:16:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8664','320','2','8144','4.99','2005-07-28T20:30:55.000','2006-02-15T22:16:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8665','320','2','8235','4.99','2005-07-29T00:22:56.000','2006-02-15T22:16:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8666','320','1','8238','0.99','2005-07-29T00:30:06.000','2006-02-15T22:16:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8667','320','2','8794','4.99','2005-07-29T20:59:38.000','2006-02-15T22:16:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8668','320','1','9509','0.99','2005-07-31T00:22:42.000','2006-02-15T22:16:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8669','320','1','11208','0.99','2005-08-02T12:02:37.000','2006-02-15T22:16:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8670','320','2','11560','2.99','2005-08-17T01:20:30.000','2006-02-15T22:16:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8671','320','2','14171','0.99','2005-08-21T03:00:42.000','2006-02-15T22:16:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8672','320','1','15302','2.99','2005-08-22T19:44:53.000','2006-02-15T22:16:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8673','321','2','200','4.99','2005-05-26T07:12:21.000','2006-02-15T22:16:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8674','321','1','620','5.99','2005-05-28T15:54:45.000','2006-02-15T22:16:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8675','321','2','818','4.99','2005-05-29T20:47:53.000','2006-02-15T22:16:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8676','321','2','1750','5.99','2005-06-16T16:57:36.000','2006-02-15T22:16:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8677','321','1','3410','0.99','2005-06-21T16:20:47.000','2006-02-15T22:16:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8678','321','2','3901','5.99','2005-07-06T19:24:55.000','2006-02-15T22:16:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8679','321','1','3920','4.99','2005-07-06T20:26:40.000','2006-02-15T22:16:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8680','321','2','4281','4.99','2005-07-07T15:17:50.000','2006-02-15T22:16:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8681','321','1','4318','5.99','2005-07-07T17:47:50.000','2006-02-15T22:16:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8682','321','2','5202','2.99','2005-07-09T10:53:48.000','2006-02-15T22:16:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8683','321','2','5867','8.99','2005-07-10T18:39:01.000','2006-02-15T22:16:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8684','321','2','6190','2.99','2005-07-11T11:36:18.000','2006-02-15T22:16:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8685','321','1','6859','5.99','2005-07-12T19:53:57.000','2006-02-15T22:16:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8686','321','2','8685','6.99','2005-07-29T16:17:05.000','2006-02-15T22:16:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8687','321','1','9981','0.99','2005-07-31T17:08:31.000','2006-02-15T22:16:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8688','321','1','11722','2.99','2005-08-17T07:53:03.000','2006-02-15T22:16:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8689','321','1','12033','6.99','2005-08-17T20:14:34.000','2006-02-15T22:16:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8690','321','2','12034','7.99','2005-08-17T20:15:31.000','2006-02-15T22:16:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8691','321','1','12398','4.99','2005-08-18T09:13:24.000','2006-02-15T22:16:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8692','321','2','13623','6.99','2005-08-20T06:49:46.000','2006-02-15T22:16:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8693','321','1','15673','6.99','2005-08-23T09:12:50.000','2006-02-15T22:16:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8694','321','2','15888','5.99','2005-08-23T16:56:14.000','2006-02-15T22:16:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8695','322','2','166','0.99','2005-05-26T02:49:11.000','2006-02-15T22:16:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8696','322','1','269','4.99','2005-05-26T16:19:46.000','2006-02-15T22:16:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8697','322','1','1386','2.99','2005-06-15T15:38:58.000','2006-02-15T22:16:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8698','322','1','1588','8.99','2005-06-16T04:53:21.000','2006-02-15T22:16:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8699','322','2','2481','4.99','2005-06-18T21:08:30.000','2006-02-15T22:16:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8700','322','1','2554','0.99','2005-06-19T03:05:38.000','2006-02-15T22:16:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8701','322','1','2983','7.99','2005-06-20T08:41:42.000','2006-02-15T22:16:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8702','322','2','3054','5.99','2005-06-20T13:16:41.000','2006-02-15T22:16:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8703','322','2','3413','8.99','2005-06-21T16:57:07.000','2006-02-15T22:16:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8704','322','1','3478','0.99','2005-07-05T23:05:44.000','2006-02-15T22:16:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8705','322','2','3627','1.99','2005-07-06T06:19:25.000','2006-02-15T22:16:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8706','322','1','3646','4.99','2005-07-06T07:28:59.000','2006-02-15T22:16:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8707','322','2','6033','2.99','2005-07-11T02:59:34.000','2006-02-15T22:16:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8708','322','1','6511','3.99','2005-07-12T03:39:29.000','2006-02-15T22:16:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8709','322','2','6673','0.99','2005-07-12T11:50:56.000','2006-02-15T22:16:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8710','322','2','6709','4.99','2005-07-12T13:20:41.000','2006-02-15T22:16:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8711','322','1','7091','4.99','2005-07-27T04:44:10.000','2006-02-15T22:16:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8712','322','2','8142','4.99','2005-07-28T20:21:54.000','2006-02-15T22:16:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8713','322','1','9104','7.99','2005-07-30T08:49:55.000','2006-02-15T22:16:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8714','322','1','9115','4.99','2005-07-30T09:13:55.000','2006-02-15T22:16:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8715','322','1','9252','1.99','2005-07-30T14:19:59.000','2006-02-15T22:16:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8716','322','2','11120','4.99','2005-08-02T08:47:04.000','2006-02-15T22:16:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8717','322','2','11456','0.99','2005-08-02T21:14:04.000','2006-02-15T22:16:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8718','322','2','13180','4.99','2005-08-19T14:00:38.000','2006-02-15T22:16:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8719','322','1','13650','9.99','2005-08-20T07:49:06.000','2006-02-15T22:16:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8720','322','2','14042','4.99','2005-08-20T21:45:51.000','2006-02-15T22:16:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8721','322','1','15450','0.99','2005-08-23T00:56:01.000','2006-02-15T22:16:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8722','322','2','15703','8.99','2005-08-23T10:23:48.000','2006-02-15T22:16:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8723','323','1','58','4.99','2005-05-25T08:53:14.000','2006-02-15T22:16:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8724','323','2','729','2.99','2005-05-29T06:35:13.000','2006-02-15T22:16:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8725','323','1','878','5.99','2005-05-30T05:49:13.000','2006-02-15T22:16:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8726','323','2','1167','0.99','2005-06-14T23:25:58.000','2006-02-15T22:16:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8727','323','2','1786','2.99','2005-06-16T19:30:54.000','2006-02-15T22:16:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8728','323','1','2933','4.99','2005-06-20T04:52:23.000','2006-02-15T22:16:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8729','323','2','3704','6.99','2005-07-06T10:16:45.000','2006-02-15T22:16:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8730','323','2','4572','1.99','2005-07-08T05:36:59.000','2006-02-15T22:16:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8731','323','2','5669','4.99','2005-07-10T08:12:53.000','2006-02-15T22:16:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8732','323','2','5906','1.99','2005-07-10T20:41:41.000','2006-02-15T22:16:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8733','323','1','6840','3.99','2005-07-12T19:03:22.000','2006-02-15T22:16:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8734','323','2','7146','7.99','2005-07-27T07:02:30.000','2006-02-15T22:16:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8735','323','2','7275','2.99','2005-07-27T11:39:08.000','2006-02-15T22:16:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8736','323','2','7695','5.99','2005-07-28T03:41:13.000','2006-02-15T22:16:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8737','323','1','7847','1.99','2005-07-28T09:23:14.000','2006-02-15T22:16:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8738','323','2','7937','4.99','2005-07-28T12:38:22.000','2006-02-15T22:16:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8739','323','2','8474','0.99','2005-07-29T08:36:56.000','2006-02-15T22:16:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8740','323','1','8790','0.99','2005-07-29T20:51:41.000','2006-02-15T22:16:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8741','323','1','9363','2.99','2005-07-30T18:44:23.000','2006-02-15T22:16:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8742','323','2','10002','4.99','2005-07-31T17:48:16.000','2006-02-15T22:16:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8743','323','1','10028','4.99','2005-07-31T18:35:54.000','2006-02-15T22:16:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8744','323','1','10298','0.99','2005-08-01T04:06:03.000','2006-02-15T22:16:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8745','323','1','10994','3.99','2005-08-02T04:46:53.000','2006-02-15T22:16:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8746','323','2','11548','0.99','2005-08-17T00:59:47.000','2006-02-15T22:16:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8747','323','1','12120','4.99','2005-08-17T23:16:46.000','2006-02-15T22:16:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8748','323','1','12169','2.99','2005-08-18T01:05:54.000','2006-02-15T22:16:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8749','323','1','13140','5.99','2005-08-19T12:35:56.000','2006-02-15T22:16:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8750','323','1','14224','2.99','2005-08-21T04:53:08.000','2006-02-15T22:16:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8751','323','1','14957','3.99','2005-08-22T06:29:34.000','2006-02-15T22:16:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8752','323','1','15387','4.99','2005-08-22T22:49:13.000','2006-02-15T22:16:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8753','323','1','15728','0.99','2005-08-23T11:30:32.000','2006-02-15T22:16:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8754','324','2','563','3.99','2005-05-28T09:10:49.000','2006-02-15T22:16:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8755','324','1','1740','0.99','2005-06-16T16:29:00.000','2006-02-15T22:16:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8756','324','2','2590','2.99','2005-06-19T05:31:40.000','2006-02-15T22:16:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8757','324','1','3947','4.99','2005-07-06T21:42:21.000','2006-02-15T22:16:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8758','324','1','4197','0.99','2005-07-07T11:07:52.000','2006-02-15T22:16:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8759','324','2','4368','4.99','2005-07-07T19:55:19.000','2006-02-15T22:16:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8760','324','2','5702','2.99','2005-07-10T10:00:01.000','2006-02-15T22:16:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8761','324','1','5778','0.99','2005-07-10T13:41:37.000','2006-02-15T22:16:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8762','324','1','6034','2.99','2005-07-11T03:00:50.000','2006-02-15T22:16:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8763','324','2','6299','4.99','2005-07-11T17:45:08.000','2006-02-15T22:16:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8764','324','2','7240','3.99','2005-07-27T10:21:15.000','2006-02-15T22:16:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8765','324','1','7263','7.99','2005-07-27T11:17:22.000','2006-02-15T22:16:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8766','324','2','7960','6.99','2005-07-28T13:47:08.000','2006-02-15T22:16:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8767','324','1','8698','3.99','2005-07-29T16:52:17.000','2006-02-15T22:16:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8768','324','1','9651','4.99','2005-07-31T05:48:49.000','2006-02-15T22:16:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8769','324','2','10212','2.99','2005-08-01T01:01:35.000','2006-02-15T22:16:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8770','324','1','11617','2.99','2005-08-17T04:00:40.000','2006-02-15T22:16:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8771','324','1','11771','6.99','2005-08-17T10:17:09.000','2006-02-15T22:16:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8772','324','2','12543','2.99','2005-08-18T14:23:55.000','2006-02-15T22:16:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8773','324','2','13356','0.99','2005-08-19T21:02:21.000','2006-02-15T22:16:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8774','324','1','13386','2.99','2005-08-19T21:43:58.000','2006-02-15T22:16:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8775','324','1','14262','8.99','2005-08-21T06:08:13.000','2006-02-15T22:16:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8776','324','2','14479','7.99','2005-08-21T13:35:54.000','2006-02-15T22:16:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8777','324','1','15263','4.99','2005-08-22T18:27:33.000','2006-02-15T22:16:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8778','324','2','13965','2.99','2006-02-14T15:16:03.000','2006-02-15T22:16:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8779','325','1','131','5.99','2005-05-25T21:42:46.000','2006-02-15T22:16:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8780','325','2','2502','4.99','2005-06-18T23:12:13.000','2006-02-15T22:16:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8781','325','2','2507','4.99','2005-06-18T23:39:22.000','2006-02-15T22:16:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8782','325','2','2808','2.99','2005-06-19T19:34:45.000','2006-02-15T22:16:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8783','325','1','5470','5.99','2005-07-09T23:10:49.000','2006-02-15T22:16:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8784','325','2','5740','2.99','2005-07-10T11:51:58.000','2006-02-15T22:16:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8785','325','1','5775','4.99','2005-07-10T13:34:26.000','2006-02-15T22:16:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8786','325','2','6135','4.99','2005-07-11T08:32:23.000','2006-02-15T22:16:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8787','325','2','6622','0.99','2005-07-12T09:04:11.000','2006-02-15T22:16:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8788','325','2','7223','9.99','2005-07-27T09:42:27.000','2006-02-15T22:16:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8789','325','2','7687','2.99','2005-07-28T03:20:26.000','2006-02-15T22:16:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8790','325','2','8539','0.99','2005-07-29T10:48:24.000','2006-02-15T22:16:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8791','325','2','10030','2.99','2005-07-31T18:39:36.000','2006-02-15T22:16:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8792','325','1','10070','4.99','2005-07-31T19:46:29.000','2006-02-15T22:16:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8793','325','2','10326','4.99','2005-08-01T04:55:34.000','2006-02-15T22:16:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8794','325','1','10412','0.99','2005-08-01T07:57:16.000','2006-02-15T22:16:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8795','325','2','12097','4.99','2005-08-17T22:35:24.000','2006-02-15T22:16:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8796','325','1','12779','3.99','2005-08-18T23:44:00.000','2006-02-15T22:16:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8797','325','2','13054','4.99','2005-08-19T09:34:02.000','2006-02-15T22:16:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8798','325','2','14452','3.99','2005-08-21T12:23:20.000','2006-02-15T22:16:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8799','325','1','14672','5.99','2005-08-21T19:59:33.000','2006-02-15T22:16:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8800','325','2','15009','0.99','2005-08-22T08:27:27.000','2006-02-15T22:16:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8801','326','1','875','6.99','2005-05-30T05:38:24.000','2006-02-15T22:16:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8802','326','2','981','4.99','2005-05-30T21:52:42.000','2006-02-15T22:16:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8803','326','2','1149','3.99','2005-05-31T21:03:17.000','2006-02-15T22:16:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8804','326','1','1311','4.99','2005-06-15T10:11:59.000','2006-02-15T22:16:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8805','326','2','2086','0.99','2005-06-17T17:32:07.000','2006-02-15T22:16:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8806','326','2','2317','4.99','2005-06-18T09:12:18.000','2006-02-15T22:16:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8807','326','1','3441','4.99','2005-06-21T20:00:12.000','2006-02-15T22:16:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8808','326','2','3886','0.99','2005-07-06T18:44:24.000','2006-02-15T22:16:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8809','326','1','4160','7.99','2005-07-07T09:13:17.000','2006-02-15T22:16:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8810','326','1','5147','5.99','2005-07-09T08:17:41.000','2006-02-15T22:16:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8811','326','1','7117','2.99','2005-07-27T05:48:36.000','2006-02-15T22:16:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8812','326','2','7725','2.99','2005-07-28T04:47:14.000','2006-02-15T22:16:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8813','326','2','7931','4.99','2005-07-28T12:23:41.000','2006-02-15T22:16:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8814','326','1','8467','5.99','2005-07-29T08:25:35.000','2006-02-15T22:16:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8815','326','1','8604','4.99','2005-07-29T13:07:13.000','2006-02-15T22:16:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8816','326','2','8739','2.99','2005-07-29T18:34:33.000','2006-02-15T22:16:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8817','326','2','9855','0.99','2005-07-31T13:00:33.000','2006-02-15T22:16:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8818','326','1','10108','0.99','2005-07-31T21:02:14.000','2006-02-15T22:16:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8819','326','2','10173','4.99','2005-07-31T23:36:59.000','2006-02-15T22:16:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8820','326','2','10720','0.99','2005-08-01T19:04:33.000','2006-02-15T22:16:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8821','326','2','10976','4.99','2005-08-02T04:11:48.000','2006-02-15T22:16:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8822','326','2','11010','0.99','2005-08-02T05:06:27.000','2006-02-15T22:16:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8823','326','2','11428','2.99','2005-08-02T20:03:10.000','2006-02-15T22:16:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8824','326','2','11485','4.99','2005-08-02T22:33:25.000','2006-02-15T22:16:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8825','326','2','12829','2.99','2005-08-19T01:38:18.000','2006-02-15T22:16:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8826','327','1','653','6.99','2005-05-28T20:12:20.000','2006-02-15T22:16:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8827','327','1','1294','4.99','2005-06-15T09:09:27.000','2006-02-15T22:16:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8828','327','2','1577','3.99','2005-06-16T04:03:28.000','2006-02-15T22:16:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8829','327','2','1929','6.99','2005-06-17T06:49:30.000','2006-02-15T22:16:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8830','327','1','2273','4.99','2005-06-18T06:30:02.000','2006-02-15T22:16:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8831','327','2','2304','5.99','2005-06-18T08:30:15.000','2006-02-15T22:16:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8832','327','2','2637','3.99','2005-06-19T09:20:56.000','2006-02-15T22:16:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8833','327','1','4445','4.99','2005-07-07T23:08:22.000','2006-02-15T22:16:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8834','327','1','4521','0.99','2005-07-08T02:57:56.000','2006-02-15T22:16:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8835','327','1','6618','2.99','2005-07-12T08:41:42.000','2006-02-15T22:16:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8836','327','2','7458','1.99','2005-07-27T18:36:17.000','2006-02-15T22:16:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8837','327','2','7808','1.99','2005-07-28T07:58:56.000','2006-02-15T22:16:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8838','327','1','10371','0.99','2005-08-01T06:20:29.000','2006-02-15T22:16:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8839','327','1','11372','4.99','2005-08-02T18:10:50.000','2006-02-15T22:16:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8840','327','2','11929','6.99','2005-08-17T16:28:51.000','2006-02-15T22:16:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8841','327','1','12016','0.99','2005-08-17T19:33:24.000','2006-02-15T22:16:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8842','327','2','13158','2.99','2005-08-19T13:18:10.000','2006-02-15T22:16:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8843','327','1','13360','4.99','2005-08-19T21:05:11.000','2006-02-15T22:16:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8844','327','1','13448','0.99','2005-08-20T00:12:43.000','2006-02-15T22:16:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8845','327','1','14847','4.99','2005-08-22T02:13:51.000','2006-02-15T22:16:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8846','327','2','15365','3.99','2005-08-22T21:42:17.000','2006-02-15T22:16:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8847','327','1','15386','2.99','2005-08-22T22:41:14.000','2006-02-15T22:16:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8848','327','1','15828','5.99','2005-08-23T15:16:32.000','2006-02-15T22:16:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8849','327','1','15916','9.99','2005-08-23T17:56:01.000','2006-02-15T22:16:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8850','327','2','15969','7.99','2005-08-23T19:51:30.000','2006-02-15T22:16:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8851','327','1','15297','2.99','2006-02-14T15:16:03.000','2006-02-15T22:16:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8852','328','2','862','2.99','2005-05-30T03:09:11.000','2006-02-15T22:16:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8853','328','2','1670','2.99','2005-06-16T10:26:33.000','2006-02-15T22:16:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8854','328','2','1980','6.99','2005-06-17T09:48:05.000','2006-02-15T22:16:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8855','328','2','2243','5.99','2005-06-18T04:33:03.000','2006-02-15T22:16:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8856','328','1','3024','4.99','2005-06-20T11:29:17.000','2006-02-15T22:16:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8857','328','1','3239','0.99','2005-06-21T02:48:40.000','2006-02-15T22:16:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8858','328','1','5450','4.99','2005-07-09T22:13:25.000','2006-02-15T22:16:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8859','328','1','8017','1.99','2005-07-28T15:35:41.000','2006-02-15T22:16:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8860','328','1','8577','6.99','2005-07-29T11:56:30.000','2006-02-15T22:16:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8861','328','2','8780','4.99','2005-07-29T20:19:45.000','2006-02-15T22:16:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8862','328','2','9557','2.99','2005-07-31T02:14:01.000','2006-02-15T22:16:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8863','328','1','9835','2.99','2005-07-31T12:07:35.000','2006-02-15T22:16:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8864','328','1','11174','2.99','2005-08-02T10:32:11.000','2006-02-15T22:16:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8865','328','1','12175','4.99','2005-08-18T01:10:17.000','2006-02-15T22:16:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8866','328','2','12825','0.99','2005-08-19T01:23:58.000','2006-02-15T22:16:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8867','328','1','13609','2.99','2005-08-20T06:11:51.000','2006-02-15T22:16:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8868','328','2','13681','7.99','2005-08-20T08:47:37.000','2006-02-15T22:16:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8869','328','1','13907','3.99','2005-08-20T16:17:27.000','2006-02-15T22:16:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8870','328','2','14307','3.99','2005-08-21T07:34:52.000','2006-02-15T22:16:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8871','328','1','14755','3.99','2005-08-21T23:18:08.000','2006-02-15T22:16:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8872','328','2','14939','2.99','2005-08-22T05:53:52.000','2006-02-15T22:16:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8873','328','1','15179','4.99','2005-08-22T15:36:22.000','2006-02-15T22:16:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8874','328','1','15863','0.99','2005-08-23T16:17:09.000','2006-02-15T22:16:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8875','329','1','1183','2.99','2005-06-15T00:49:19.000','2006-02-15T22:16:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8876','329','1','2010','5.99','2005-06-17T11:54:15.000','2006-02-15T22:16:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8877','329','2','2024','0.99','2005-06-17T13:00:51.000','2006-02-15T22:16:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8878','329','1','2151','0.99','2005-06-17T22:52:37.000','2006-02-15T22:16:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8879','329','1','2303','2.99','2005-06-18T08:27:59.000','2006-02-15T22:16:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8880','329','2','2702','2.99','2005-06-19T13:35:56.000','2006-02-15T22:16:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8881','329','1','3052','5.99','2005-06-20T13:09:19.000','2006-02-15T22:16:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8882','329','2','3053','0.99','2005-06-20T13:10:30.000','2006-02-15T22:16:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8883','329','2','3268','4.99','2005-06-21T04:55:49.000','2006-02-15T22:16:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8884','329','2','3976','2.99','2005-07-06T23:00:20.000','2006-02-15T22:16:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8885','329','2','4076','4.99','2005-07-07T04:52:15.000','2006-02-15T22:16:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8886','329','1','4415','4.99','2005-07-07T22:01:43.000','2006-02-15T22:16:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8887','329','1','4465','1.99','2005-07-08T00:07:45.000','2006-02-15T22:16:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8888','329','2','4674','2.99','2005-07-08T10:19:28.000','2006-02-15T22:16:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8889','329','1','7980','4.99','2005-07-28T14:16:49.000','2006-02-15T22:16:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8890','329','2','8172','7.99','2005-07-28T21:34:36.000','2006-02-15T22:16:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8891','329','1','8460','6.99','2005-07-29T08:08:03.000','2006-02-15T22:16:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8892','329','2','8941','0.99','2005-07-30T02:59:21.000','2006-02-15T22:16:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8893','329','2','9024','4.99','2005-07-30T05:44:42.000','2006-02-15T22:16:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8894','329','2','9219','0.99','2005-07-30T13:15:21.000','2006-02-15T22:16:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8895','329','1','9381','0.99','2005-07-30T19:23:04.000','2006-02-15T22:16:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8896','329','1','9827','6.99','2005-07-31T11:56:55.000','2006-02-15T22:16:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8897','329','1','10473','7.99','2005-08-01T09:56:24.000','2006-02-15T22:16:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8898','329','2','10490','0.99','2005-08-01T10:37:11.000','2006-02-15T22:16:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8899','329','1','11130','2.99','2005-08-02T09:08:59.000','2006-02-15T22:16:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8900','329','2','11169','3.99','2005-08-02T10:19:42.000','2006-02-15T22:16:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8901','329','2','11697','0.99','2005-08-17T07:09:19.000','2006-02-15T22:16:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8902','329','1','12659','6.99','2005-08-18T19:05:49.000','2006-02-15T22:16:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8903','329','1','13627','8.99','2005-08-20T06:59:00.000','2006-02-15T22:16:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8904','329','1','14900','4.99','2005-08-22T04:27:48.000','2006-02-15T22:16:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8905','329','2','15011','4.99','2005-08-22T08:31:07.000','2006-02-15T22:16:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8906','329','1','15308','2.99','2005-08-22T19:54:31.000','2006-02-15T22:16:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8907','330','1','704','3.99','2005-05-29T02:44:43.000','2006-02-15T22:16:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8908','330','2','967','7.99','2005-05-30T19:12:06.000','2006-02-15T22:16:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8909','330','1','1219','6.99','2005-06-15T03:25:59.000','2006-02-15T22:16:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8910','330','2','1511','5.99','2005-06-15T22:45:06.000','2006-02-15T22:16:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8911','330','2','2885','0.99','2005-06-20T01:33:42.000','2006-02-15T22:16:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8912','330','1','2936','4.99','2005-06-20T05:09:27.000','2006-02-15T22:16:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8913','330','2','3061','2.99','2005-06-20T13:48:21.000','2006-02-15T22:16:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8914','330','2','3603','4.99','2005-07-06T05:25:03.000','2006-02-15T22:16:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8915','330','2','3659','2.99','2005-07-06T08:03:14.000','2006-02-15T22:16:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8916','330','2','3760','2.99','2005-07-06T12:49:28.000','2006-02-15T22:16:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8917','330','1','4124','1.99','2005-07-07T07:19:54.000','2006-02-15T22:16:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8918','330','2','5149','2.99','2005-07-09T08:28:23.000','2006-02-15T22:16:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8919','330','1','5750','5.99','2005-07-10T12:20:41.000','2006-02-15T22:16:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8920','330','1','6656','0.99','2005-07-12T11:09:47.000','2006-02-15T22:16:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8921','330','2','6678','2.99','2005-07-12T11:58:36.000','2006-02-15T22:16:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8922','330','1','6719','2.99','2005-07-12T13:40:37.000','2006-02-15T22:16:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8923','330','2','7894','2.99','2005-07-28T10:53:58.000','2006-02-15T22:16:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8924','330','1','8680','4.99','2005-07-29T16:08:03.000','2006-02-15T22:16:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8925','330','2','10100','4.99','2005-07-31T20:47:18.000','2006-02-15T22:16:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8926','330','2','11259','3.99','2005-08-02T13:46:30.000','2006-02-15T22:16:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8927','330','1','12062','2.99','2005-08-17T21:24:47.000','2006-02-15T22:16:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8928','330','1','12394','2.99','2005-08-18T09:05:15.000','2006-02-15T22:16:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8929','330','1','12740','4.99','2005-08-18T22:17:04.000','2006-02-15T22:16:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8930','330','1','12867','0.99','2005-08-19T02:40:11.000','2006-02-15T22:16:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8931','330','2','11709','2.99','2006-02-14T15:16:03.000','2006-02-15T22:16:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8932','331','2','87','0.99','2005-05-25T13:52:43.000','2006-02-15T22:16:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8933','331','1','996','2.99','2005-05-31T00:06:20.000','2006-02-15T22:16:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8934','331','1','1415','2.99','2005-06-15T17:31:57.000','2006-02-15T22:16:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8935','331','2','2528','6.99','2005-06-19T01:14:12.000','2006-02-15T22:16:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8936','331','1','2587','2.99','2005-06-19T05:06:14.000','2006-02-15T22:16:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8937','331','1','3505','4.99','2005-07-06T00:19:32.000','2006-02-15T22:16:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8938','331','1','3613','4.99','2005-07-06T05:45:53.000','2006-02-15T22:16:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8939','331','2','3871','8.99','2005-07-06T17:58:51.000','2006-02-15T22:16:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8940','331','1','4051','4.99','2005-07-07T03:37:28.000','2006-02-15T22:16:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8941','331','2','4063','5.99','2005-07-07T04:23:57.000','2006-02-15T22:16:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8942','331','1','4326','10.99','2005-07-07T18:01:22.000','2006-02-15T22:16:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8943','331','1','5152','2.99','2005-07-09T08:34:44.000','2006-02-15T22:16:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8944','331','1','5885','1.99','2005-07-10T19:33:50.000','2006-02-15T22:16:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8945','331','1','5947','5.99','2005-07-10T23:07:42.000','2006-02-15T22:16:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8946','331','1','8231','0.99','2005-07-29T00:14:37.000','2006-02-15T22:16:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8947','331','2','8995','4.99','2005-07-30T04:53:11.000','2006-02-15T22:16:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8948','331','1','9401','5.99','2005-07-30T20:18:19.000','2006-02-15T22:16:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8949','331','2','10188','6.99','2005-08-01T00:19:41.000','2006-02-15T22:16:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8950','331','1','11052','5.99','2005-08-02T06:26:19.000','2006-02-15T22:16:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8951','331','1','11362','2.99','2005-08-02T17:47:25.000','2006-02-15T22:16:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8952','331','2','12533','4.99','2005-08-18T14:01:40.000','2006-02-15T22:16:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8953','331','1','13795','0.99','2005-08-20T12:32:09.000','2006-02-15T22:16:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8954','331','1','14256','7.99','2005-08-21T05:52:27.000','2006-02-15T22:16:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8955','331','1','14628','1.99','2005-08-21T18:37:24.000','2006-02-15T22:16:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8956','331','1','15339','2.99','2005-08-22T20:52:12.000','2006-02-15T22:16:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8957','331','2','15447','3.99','2005-08-23T00:53:57.000','2006-02-15T22:16:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8958','331','1','15521','2.99','2005-08-23T03:30:51.000','2006-02-15T22:16:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8959','332','2','600','3.99','2005-05-28T14:08:19.000','2006-02-15T22:16:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8960','332','1','1000','6.99','2005-05-31T00:25:56.000','2006-02-15T22:16:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8961','332','1','4100','6.99','2005-07-07T06:20:52.000','2006-02-15T22:16:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8962','332','1','4302','6.99','2005-07-07T16:47:53.000','2006-02-15T22:16:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8963','332','2','5116','2.99','2005-07-09T07:10:12.000','2006-02-15T22:16:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8964','332','1','5277','1.99','2005-07-09T14:40:42.000','2006-02-15T22:16:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8965','332','2','5381','2.99','2005-07-09T19:11:11.000','2006-02-15T22:16:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8966','332','2','5388','0.99','2005-07-09T19:25:25.000','2006-02-15T22:16:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8967','332','1','5440','0.99','2005-07-09T21:45:17.000','2006-02-15T22:16:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8968','332','2','7049','7.99','2005-07-27T03:32:41.000','2006-02-15T22:16:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8969','332','2','7418','2.99','2005-07-27T16:59:09.000','2006-02-15T22:16:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8970','332','2','7577','8.99','2005-07-27T22:56:07.000','2006-02-15T22:16:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8971','332','2','7578','4.99','2005-07-27T22:58:17.000','2006-02-15T22:16:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8972','332','2','7934','8.99','2005-07-28T12:33:10.000','2006-02-15T22:16:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8973','332','2','8173','6.99','2005-07-28T21:35:44.000','2006-02-15T22:16:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8974','332','1','9324','1.99','2005-07-30T17:28:52.000','2006-02-15T22:16:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8975','332','1','9388','5.99','2005-07-30T19:27:22.000','2006-02-15T22:16:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8976','332','1','9921','0.99','2005-07-31T14:59:21.000','2006-02-15T22:16:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8977','332','1','10026','4.99','2005-07-31T18:31:51.000','2006-02-15T22:16:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8978','332','1','10307','0.99','2005-08-01T04:21:54.000','2006-02-15T22:16:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8979','332','2','10439','0.99','2005-08-01T08:54:26.000','2006-02-15T22:16:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8980','332','1','11229','5.99','2005-08-02T12:56:37.000','2006-02-15T22:16:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8981','332','2','11564','2.99','2005-08-17T01:27:49.000','2006-02-15T22:16:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8982','332','2','12318','4.99','2005-08-18T06:21:56.000','2006-02-15T22:16:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8983','332','2','13673','2.99','2005-08-20T08:27:30.000','2006-02-15T22:16:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8984','332','2','14783','4.99','2005-08-22T00:21:57.000','2006-02-15T22:16:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8985','332','2','15194','0.99','2005-08-22T16:07:34.000','2006-02-15T22:16:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8986','332','1','15210','3.99','2005-08-22T16:37:36.000','2006-02-15T22:16:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8987','333','1','4','4.99','2005-05-24T23:04:41.000','2006-02-15T22:16:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8988','333','1','1667','2.99','2005-06-16T10:18:59.000','2006-02-15T22:16:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8989','333','1','2149','6.99','2005-06-17T22:50:00.000','2006-02-15T22:16:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8990','333','1','2929','1.99','2005-06-20T04:47:39.000','2006-02-15T22:16:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8991','333','1','3110','2.99','2005-06-20T17:40:12.000','2006-02-15T22:16:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8992','333','2','5032','0.99','2005-07-09T02:39:47.000','2006-02-15T22:16:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8993','333','1','5645','1.99','2005-07-10T06:58:21.000','2006-02-15T22:16:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8994','333','2','5892','4.99','2005-07-10T20:02:42.000','2006-02-15T22:16:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8995','333','2','6275','0.99','2005-07-11T16:12:11.000','2006-02-15T22:16:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8996','333','2','6931','4.99','2005-07-26T23:02:57.000','2006-02-15T22:16:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8997','333','2','6958','0.99','2005-07-27T00:02:41.000','2006-02-15T22:16:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8998','333','2','7076','6.99','2005-07-27T04:12:14.000','2006-02-15T22:16:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('8999','333','2','7246','0.99','2005-07-27T10:30:41.000','2006-02-15T22:16:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9000','333','1','8719','4.99','2005-07-29T17:45:45.000','2006-02-15T22:16:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9001','333','2','9148','4.99','2005-07-30T10:39:10.000','2006-02-15T22:16:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9002','333','2','9338','10.99','2005-07-30T18:03:13.000','2006-02-15T22:16:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9003','333','2','10035','4.99','2005-07-31T18:46:46.000','2006-02-15T22:16:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9004','333','1','10062','2.99','2005-07-31T19:24:55.000','2006-02-15T22:16:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9005','333','2','10844','4.99','2005-08-01T23:46:58.000','2006-02-15T22:16:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9006','333','1','12427','6.99','2005-08-18T10:24:17.000','2006-02-15T22:16:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9007','333','2','12661','0.99','2005-08-18T19:10:10.000','2006-02-15T22:16:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9008','333','1','13579','3.99','2005-08-20T05:22:06.000','2006-02-15T22:16:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9009','333','2','13710','4.99','2005-08-20T09:35:20.000','2006-02-15T22:16:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9010','333','1','14057','4.99','2005-08-20T22:22:59.000','2006-02-15T22:16:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9011','333','1','14740','2.99','2005-08-21T22:35:33.000','2006-02-15T22:16:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9012','333','2','15253','2.99','2005-08-22T18:05:21.000','2006-02-15T22:16:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9013','333','1','15313','4.99','2005-08-22T19:59:42.000','2006-02-15T22:16:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9014','334','1','13','6.99','2005-05-25T00:22:55.000','2006-02-15T22:16:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9015','334','1','431','8.99','2005-05-27T16:31:05.000','2006-02-15T22:16:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9016','334','2','1187','4.99','2005-06-15T00:58:50.000','2006-02-15T22:16:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9017','334','1','1298','4.99','2005-06-15T09:32:53.000','2006-02-15T22:16:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9018','334','2','2476','0.99','2005-06-18T20:57:12.000','2006-02-15T22:16:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9019','334','1','3662','4.99','2005-07-06T08:11:48.000','2006-02-15T22:16:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9020','334','1','4603','6.99','2005-07-08T06:57:07.000','2006-02-15T22:16:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9021','334','2','5014','4.99','2005-07-09T01:51:49.000','2006-02-15T22:16:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9022','334','2','5434','0.99','2005-07-09T21:25:20.000','2006-02-15T22:16:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9023','334','2','5818','5.99','2005-07-10T15:51:12.000','2006-02-15T22:16:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9024','334','1','5845','4.99','2005-07-10T17:23:14.000','2006-02-15T22:16:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9025','334','2','6641','5.99','2005-07-12T10:33:14.000','2006-02-15T22:16:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9026','334','2','6749','4.99','2005-07-12T14:43:05.000','2006-02-15T22:16:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9027','334','1','6987','2.99','2005-07-27T00:59:50.000','2006-02-15T22:16:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9028','334','1','8977','7.99','2005-07-30T04:14:07.000','2006-02-15T22:16:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9029','334','1','9633','2.99','2005-07-31T05:04:08.000','2006-02-15T22:16:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9030','334','1','10207','3.99','2005-08-01T00:53:01.000','2006-02-15T22:16:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9031','334','1','10408','4.99','2005-08-01T07:42:10.000','2006-02-15T22:16:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9032','334','1','10492','2.99','2005-08-01T10:42:28.000','2006-02-15T22:16:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9033','334','1','10879','1.99','2005-08-02T00:33:20.000','2006-02-15T22:16:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9034','334','2','10997','7.99','2005-08-02T04:49:02.000','2006-02-15T22:16:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9035','334','2','12677','4.99','2005-08-18T19:36:05.000','2006-02-15T22:16:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9036','334','2','13325','4.99','2005-08-19T19:52:02.000','2006-02-15T22:16:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9037','334','1','13876','2.99','2005-08-20T15:15:28.000','2006-02-15T22:16:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9038','334','1','14645','0.99','2005-08-21T19:12:47.000','2006-02-15T22:16:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9039','334','1','14984','7.99','2005-08-22T07:35:31.000','2006-02-15T22:16:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9040','334','2','15548','0.99','2005-08-23T04:26:20.000','2006-02-15T22:16:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9041','334','2','15656','4.99','2005-08-23T08:38:58.000','2006-02-15T22:16:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9042','334','1','15669','3.99','2005-08-23T09:06:17.000','2006-02-15T22:16:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9043','334','1','14219','0.99','2006-02-14T15:16:03.000','2006-02-15T22:16:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9044','335','1','3329','4.99','2005-06-21T09:20:31.000','2006-02-15T22:16:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9045','335','1','3607','0.99','2005-07-06T05:30:09.000','2006-02-15T22:16:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9046','335','2','4016','0.99','2005-07-07T01:05:50.000','2006-02-15T22:16:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9047','335','2','4032','2.99','2005-07-07T02:34:13.000','2006-02-15T22:16:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9048','335','1','4279','4.99','2005-07-07T15:01:53.000','2006-02-15T22:16:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9049','335','1','4387','8.99','2005-07-07T20:56:47.000','2006-02-15T22:16:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9050','335','1','5024','4.99','2005-07-09T02:25:12.000','2006-02-15T22:16:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9051','335','1','5252','0.99','2005-07-09T13:40:44.000','2006-02-15T22:16:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9052','335','2','5728','2.99','2005-07-10T11:26:14.000','2006-02-15T22:16:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9053','335','1','6624','7.99','2005-07-12T09:05:50.000','2006-02-15T22:16:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9054','335','1','6906','0.99','2005-07-12T22:03:02.000','2006-02-15T22:16:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9055','335','2','8634','3.99','2005-07-29T14:19:57.000','2006-02-15T22:16:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9056','335','1','8855','2.99','2005-07-29T23:40:10.000','2006-02-15T22:16:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9057','335','1','9125','5.99','2005-07-30T09:43:39.000','2006-02-15T22:16:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9058','335','2','9361','4.99','2005-07-30T18:43:49.000','2006-02-15T22:16:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9059','335','1','9428','0.99','2005-07-30T21:18:37.000','2006-02-15T22:16:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9060','335','2','10606','4.99','2005-08-01T14:39:15.000','2006-02-15T22:16:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9061','335','2','13267','0.99','2005-08-19T17:31:36.000','2006-02-15T22:16:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9062','335','1','13622','1.99','2005-08-20T06:45:32.000','2006-02-15T22:16:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9063','335','1','14014','2.99','2005-08-20T20:47:09.000','2006-02-15T22:16:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9064','335','2','15005','4.99','2005-08-22T08:15:44.000','2006-02-15T22:16:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9065','335','2','15101','0.99','2005-08-22T11:56:02.000','2006-02-15T22:16:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9066','335','2','11541','0.99','2006-02-14T15:16:03.000','2006-02-15T22:16:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9067','336','1','1478','2.99','2005-06-15T21:12:13.000','2006-02-15T22:16:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9068','336','2','2212','2.99','2005-06-18T02:36:10.000','2006-02-15T22:16:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9069','336','2','2475','2.99','2005-06-18T20:52:46.000','2006-02-15T22:16:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9070','336','1','2575','2.99','2005-06-19T04:32:52.000','2006-02-15T22:16:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9071','336','2','2719','4.99','2005-06-19T14:50:19.000','2006-02-15T22:16:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9072','336','1','2954','2.99','2005-06-20T06:45:00.000','2006-02-15T22:16:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9073','336','2','3204','4.99','2005-06-21T00:37:50.000','2006-02-15T22:16:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9074','336','2','3349','0.99','2005-06-21T11:17:35.000','2006-02-15T22:16:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9075','336','2','4323','5.99','2005-07-07T17:55:53.000','2006-02-15T22:16:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9076','336','1','4595','2.99','2005-07-08T06:40:25.000','2006-02-15T22:16:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9077','336','2','5649','2.99','2005-07-10T07:15:07.000','2006-02-15T22:16:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9078','336','2','5667','0.99','2005-07-10T08:11:03.000','2006-02-15T22:16:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9079','336','2','6263','4.99','2005-07-11T15:33:50.000','2006-02-15T22:16:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9080','336','2','6382','6.99','2005-07-11T21:58:53.000','2006-02-15T22:16:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9081','336','2','8275','4.99','2005-07-29T01:35:47.000','2006-02-15T22:16:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9082','336','1','8407','6.99','2005-07-29T06:37:02.000','2006-02-15T22:16:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9083','336','2','8607','4.99','2005-07-29T13:18:00.000','2006-02-15T22:16:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9084','336','2','8951','8.99','2005-07-30T03:18:24.000','2006-02-15T22:16:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9085','336','2','9306','0.99','2005-07-30T16:47:17.000','2006-02-15T22:16:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9086','336','1','10055','0.99','2005-07-31T19:15:58.000','2006-02-15T22:16:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9087','336','2','11743','2.99','2005-08-17T08:49:05.000','2006-02-15T22:16:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9088','336','1','12323','8.99','2005-08-18T06:36:22.000','2006-02-15T22:16:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9089','336','2','12794','0.99','2005-08-19T00:20:37.000','2006-02-15T22:16:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9090','336','2','12926','3.99','2005-08-19T05:00:16.000','2006-02-15T22:16:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9091','336','2','13066','0.99','2005-08-19T09:50:39.000','2006-02-15T22:16:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9092','336','2','13689','4.99','2005-08-20T09:04:30.000','2006-02-15T22:16:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9093','336','1','14295','2.99','2005-08-21T07:09:27.000','2006-02-15T22:16:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9094','336','1','15073','10.99','2005-08-22T11:01:15.000','2006-02-15T22:16:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9095','336','2','15848','2.99','2005-08-23T15:41:12.000','2006-02-15T22:16:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9096','336','1','13022','0.99','2006-02-14T15:16:03.000','2006-02-15T22:16:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9097','337','1','374','6.99','2005-05-27T08:26:30.000','2006-02-15T22:16:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9098','337','1','572','4.99','2005-05-28T10:30:13.000','2006-02-15T22:16:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9099','337','1','839','8.99','2005-05-30T00:28:12.000','2006-02-15T22:16:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9100','337','2','1969','4.99','2005-06-17T09:22:22.000','2006-02-15T22:16:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9101','337','1','2014','5.99','2005-06-17T12:03:28.000','2006-02-15T22:16:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9102','337','1','3626','5.99','2005-07-06T06:15:35.000','2006-02-15T22:16:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9103','337','1','4091','6.99','2005-07-07T05:53:38.000','2006-02-15T22:16:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9104','337','2','4093','4.99','2005-07-07T05:54:50.000','2006-02-15T22:16:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9105','337','2','4855','4.99','2005-07-08T18:45:50.000','2006-02-15T22:16:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9106','337','1','5050','2.99','2005-07-09T03:54:38.000','2006-02-15T22:16:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9107','337','1','6212','0.99','2005-07-11T12:40:48.000','2006-02-15T22:16:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9108','337','2','6305','7.99','2005-07-11T18:02:25.000','2006-02-15T22:16:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9109','337','1','6620','2.99','2005-07-12T08:51:03.000','2006-02-15T22:16:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9110','337','1','7410','4.99','2005-07-27T16:41:59.000','2006-02-15T22:16:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9111','337','1','8516','4.99','2005-07-29T10:00:03.000','2006-02-15T22:16:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9112','337','2','8919','8.99','2005-07-30T01:57:03.000','2006-02-15T22:16:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9113','337','2','9051','5.99','2005-07-30T07:05:54.000','2006-02-15T22:16:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9114','337','1','10664','0.99','2005-08-01T16:51:15.000','2006-02-15T22:16:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9115','337','2','10765','0.99','2005-08-01T20:34:51.000','2006-02-15T22:16:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9116','337','2','11252','2.99','2005-08-02T13:42:13.000','2006-02-15T22:16:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9117','337','1','11734','3.99','2005-08-17T08:34:22.000','2006-02-15T22:16:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9118','337','1','12369','6.99','2005-08-18T07:57:43.000','2006-02-15T22:16:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9119','337','2','13305','6.99','2005-08-19T18:57:05.000','2006-02-15T22:16:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9120','337','1','13678','4.99','2005-08-20T08:38:24.000','2006-02-15T22:16:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9121','337','2','13892','3.99','2005-08-20T15:50:17.000','2006-02-15T22:16:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9122','337','2','14118','5.99','2005-08-21T01:13:37.000','2006-02-15T22:16:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9123','337','2','15241','4.99','2005-08-22T17:47:40.000','2006-02-15T22:16:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9124','337','1','15292','4.99','2005-08-22T19:28:56.000','2006-02-15T22:16:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9125','337','2','11847','0.99','2006-02-14T15:16:03.000','2006-02-15T22:16:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9126','338','1','675','0.99','2005-05-28T22:22:44.000','2006-02-15T22:16:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9127','338','2','1510','4.99','2005-06-15T22:39:34.000','2006-02-15T22:16:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9128','338','1','1807','5.99','2005-06-16T20:58:59.000','2006-02-15T22:16:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9129','338','2','1952','4.99','2005-06-17T08:33:02.000','2006-02-15T22:16:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9130','338','1','2148','6.99','2005-06-17T22:44:35.000','2006-02-15T22:16:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9131','338','1','2179','0.99','2005-06-18T00:41:36.000','2006-02-15T22:16:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9132','338','1','2495','4.99','2005-06-18T22:15:42.000','2006-02-15T22:16:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9133','338','1','3458','5.99','2005-06-21T21:42:49.000','2006-02-15T22:16:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9134','338','1','3516','0.99','2005-07-06T00:50:30.000','2006-02-15T22:16:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9135','338','2','3772','2.99','2005-07-06T13:22:53.000','2006-02-15T22:16:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9136','338','2','4104','5.99','2005-07-07T06:25:41.000','2006-02-15T22:16:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9137','338','2','4779','4.99','2005-07-08T15:53:41.000','2006-02-15T22:16:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9138','338','1','5309','4.99','2005-07-09T16:00:16.000','2006-02-15T22:16:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9139','338','1','6236','2.99','2005-07-11T14:18:17.000','2006-02-15T22:16:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9140','338','1','6360','4.99','2005-07-11T21:07:40.000','2006-02-15T22:16:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9141','338','2','7584','3.99','2005-07-27T23:15:46.000','2006-02-15T22:16:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9142','338','1','8766','0.99','2005-07-29T19:41:04.000','2006-02-15T22:16:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9143','338','1','9485','7.99','2005-07-30T23:32:40.000','2006-02-15T22:16:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9144','338','2','10791','2.99','2005-08-01T21:41:52.000','2006-02-15T22:16:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9145','338','1','10897','0.99','2005-08-02T01:23:42.000','2006-02-15T22:16:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9146','338','2','11064','4.99','2005-08-02T06:55:17.000','2006-02-15T22:16:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9147','338','2','11671','4.99','2005-08-17T05:50:21.000','2006-02-15T22:16:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9148','338','2','11719','5.99','2005-08-17T07:46:05.000','2006-02-15T22:16:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9149','338','1','12167','2.99','2005-08-18T01:00:02.000','2006-02-15T22:16:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9150','338','1','13284','3.99','2005-08-19T18:12:31.000','2006-02-15T22:16:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9151','338','1','14619','2.99','2005-08-21T18:10:03.000','2006-02-15T22:16:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9152','338','2','15105','0.99','2005-08-22T12:01:33.000','2006-02-15T22:16:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9153','338','2','15173','6.99','2005-08-22T15:26:29.000','2006-02-15T22:16:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9154','339','1','876','5.99','2005-05-30T05:41:22.000','2006-02-15T22:16:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9155','339','2','1432','3.99','2005-06-15T18:27:24.000','2006-02-15T22:16:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9156','339','1','1536','4.99','2005-06-16T00:52:22.000','2006-02-15T22:16:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9157','339','2','1629','4.99','2005-06-16T07:53:47.000','2006-02-15T22:16:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9158','339','1','3146','6.99','2005-06-20T20:21:48.000','2006-02-15T22:16:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9159','339','1','3335','4.99','2005-06-21T10:09:08.000','2006-02-15T22:16:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9160','339','2','3536','2.99','2005-07-06T01:36:11.000','2006-02-15T22:16:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9161','339','1','4243','4.99','2005-07-07T13:39:58.000','2006-02-15T22:16:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9162','339','1','4467','0.99','2005-07-08T00:13:52.000','2006-02-15T22:16:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9163','339','2','4967','3.99','2005-07-08T23:48:03.000','2006-02-15T22:16:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9164','339','1','5720','3.99','2005-07-10T11:09:12.000','2006-02-15T22:16:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9165','339','1','6072','6.99','2005-07-11T04:52:40.000','2006-02-15T22:16:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9166','339','1','6425','0.99','2005-07-11T23:54:52.000','2006-02-15T22:16:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9167','339','2','6682','7.99','2005-07-12T12:12:43.000','2006-02-15T22:16:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9168','339','2','7244','2.99','2005-07-27T10:27:33.000','2006-02-15T22:16:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9169','339','2','7973','4.99','2005-07-28T14:10:06.000','2006-02-15T22:16:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9170','339','1','8968','0.99','2005-07-30T03:57:32.000','2006-02-15T22:16:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9171','339','2','9208','5.99','2005-07-30T12:54:03.000','2006-02-15T22:16:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9172','339','1','9663','4.99','2005-07-31T06:10:48.000','2006-02-15T22:16:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9173','339','2','10338','3.99','2005-08-01T05:03:03.000','2006-02-15T22:16:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9174','339','2','11171','4.99','2005-08-02T10:23:41.000','2006-02-15T22:16:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9175','339','1','11550','2.99','2005-08-17T01:02:06.000','2006-02-15T22:16:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9176','339','2','11582','3.99','2005-08-17T02:03:49.000','2006-02-15T22:16:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9177','339','2','11699','5.99','2005-08-17T07:11:58.000','2006-02-15T22:16:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9178','339','1','12631','0.99','2005-08-18T17:52:51.000','2006-02-15T22:16:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9179','339','1','13199','3.99','2005-08-19T14:53:22.000','2006-02-15T22:16:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9180','339','1','13575','5.99','2005-08-20T05:15:20.000','2006-02-15T22:16:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9181','339','1','13985','0.99','2005-08-20T19:13:06.000','2006-02-15T22:16:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9182','339','1','14636','4.99','2005-08-21T18:59:17.000','2006-02-15T22:16:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9183','339','2','14758','3.99','2005-08-21T23:24:52.000','2006-02-15T22:16:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9184','340','2','1205','4.99','2005-06-15T02:25:56.000','2006-02-15T22:16:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9185','340','1','1697','3.99','2005-06-16T12:55:20.000','2006-02-15T22:16:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9186','340','1','2177','5.99','2005-06-18T00:34:45.000','2006-02-15T22:16:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9187','340','2','2183','4.99','2005-06-18T01:06:01.000','2006-02-15T22:16:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9188','340','2','2607','5.99','2005-06-19T06:55:01.000','2006-02-15T22:16:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9189','340','1','2653','5.99','2005-06-19T10:36:53.000','2006-02-15T22:16:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9190','340','1','3264','0.99','2005-06-21T04:19:03.000','2006-02-15T22:16:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9191','340','1','3455','2.99','2005-06-21T21:17:51.000','2006-02-15T22:16:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9192','340','2','4475','2.99','2005-07-08T00:27:30.000','2006-02-15T22:16:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9193','340','1','4742','0.99','2005-07-08T13:35:23.000','2006-02-15T22:16:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9194','340','2','6381','4.99','2005-07-11T21:58:48.000','2006-02-15T22:16:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9195','340','2','7617','2.99','2005-07-28T00:18:40.000','2006-02-15T22:16:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9196','340','2','8274','4.99','2005-07-29T01:34:32.000','2006-02-15T22:16:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9197','340','1','8541','0.99','2005-07-29T10:55:01.000','2006-02-15T22:16:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9198','340','2','8551','4.99','2005-07-29T11:13:11.000','2006-02-15T22:16:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9199','340','1','8606','4.99','2005-07-29T13:14:24.000','2006-02-15T22:16:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9200','340','1','9834','2.99','2005-07-31T12:05:42.000','2006-02-15T22:16:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9201','340','1','10292','2.99','2005-08-01T03:42:40.000','2006-02-15T22:16:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9202','340','1','10667','8.99','2005-08-01T16:58:22.000','2006-02-15T22:16:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9203','340','2','10674','3.99','2005-08-01T17:11:52.000','2006-02-15T22:16:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9204','340','1','10809','0.99','2005-08-01T22:39:27.000','2006-02-15T22:16:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9205','340','1','10995','0.99','2005-08-02T04:48:00.000','2006-02-15T22:16:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9206','340','2','12598','4.99','2005-08-18T16:34:03.000','2006-02-15T22:16:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9207','340','2','12908','1.99','2005-08-19T04:19:05.000','2006-02-15T22:16:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9208','340','2','12940','2.99','2005-08-19T05:38:29.000','2006-02-15T22:16:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9209','340','1','13425','2.99','2005-08-19T23:11:44.000','2006-02-15T22:16:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9210','340','1','14457','4.99','2005-08-21T12:47:38.000','2006-02-15T22:16:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9211','340','2','14718','0.99','2005-08-21T21:39:25.000','2006-02-15T22:16:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9212','340','1','14895','2.99','2005-08-22T04:19:23.000','2006-02-15T22:16:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9213','340','2','15306','2.99','2005-08-22T19:46:36.000','2006-02-15T22:16:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9214','340','1','15378','9.99','2005-08-22T22:25:17.000','2006-02-15T22:16:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9215','341','1','1318','2.99','2005-06-15T10:34:26.000','2006-02-15T22:16:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9216','341','2','1520','7.99','2005-06-15T23:57:20.000','2006-02-15T22:16:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9217','341','1','1778','1.99','2005-06-16T18:54:48.000','2006-02-15T22:16:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9218','341','1','1849','7.99','2005-06-17T00:13:19.000','2006-02-15T22:16:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9219','341','2','2829','2.99','2005-06-19T21:11:30.000','2006-02-15T22:16:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9220','341','2','3130','7.99','2005-06-20T19:03:22.000','2006-02-15T22:16:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9221','341','1','3382','5.99','2005-06-21T14:05:23.000','2006-02-15T22:16:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9222','341','2','3938','4.99','2005-07-06T21:15:45.000','2006-02-15T22:16:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9223','341','1','4624','2.99','2005-07-08T08:12:17.000','2006-02-15T22:16:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9224','341','2','5487','4.99','2005-07-10T00:01:50.000','2006-02-15T22:16:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9225','341','2','5931','0.99','2005-07-10T22:04:19.000','2006-02-15T22:16:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9226','341','2','7473','2.99','2005-07-27T19:05:40.000','2006-02-15T22:16:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9227','341','1','8661','2.99','2005-07-29T15:28:24.000','2006-02-15T22:16:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9228','341','1','8728','9.99','2005-07-29T18:12:49.000','2006-02-15T22:16:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9229','341','2','10605','0.99','2005-08-01T14:36:26.000','2006-02-15T22:16:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9230','341','1','11305','6.99','2005-08-02T15:44:55.000','2006-02-15T22:16:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9231','341','1','11723','2.99','2005-08-17T07:56:22.000','2006-02-15T22:16:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9232','341','2','13059','0.99','2005-08-19T09:42:01.000','2006-02-15T22:16:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9233','341','2','13074','8.99','2005-08-19T10:06:53.000','2006-02-15T22:16:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9234','341','2','13806','4.99','2005-08-20T12:53:46.000','2006-02-15T22:16:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9235','341','2','14344','4.99','2005-08-21T08:40:56.000','2006-02-15T22:16:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9236','341','2','15030','0.99','2005-08-22T09:10:21.000','2006-02-15T22:16:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9237','341','2','15938','6.99','2005-08-23T18:43:31.000','2006-02-15T22:16:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9238','342','2','2190','5.99','2005-06-18T01:29:51.000','2006-02-15T22:16:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9239','342','1','2914','5.99','2005-06-20T03:43:18.000','2006-02-15T22:16:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9240','342','1','3081','2.99','2005-06-20T15:29:13.000','2006-02-15T22:16:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9241','342','1','5617','0.99','2005-07-10T05:28:50.000','2006-02-15T22:16:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9242','342','2','6060','4.99','2005-07-11T04:06:17.000','2006-02-15T22:16:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9243','342','2','6429','8.99','2005-07-12T00:02:50.000','2006-02-15T22:16:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9244','342','1','6736','2.99','2005-07-12T14:16:50.000','2006-02-15T22:16:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9245','342','2','6787','7.99','2005-07-12T16:33:28.000','2006-02-15T22:16:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9246','342','2','6997','0.99','2005-07-27T01:14:02.000','2006-02-15T22:16:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9247','342','2','7280','2.99','2005-07-27T11:50:52.000','2006-02-15T22:16:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9248','342','1','9164','2.99','2005-07-30T11:24:14.000','2006-02-15T22:16:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9249','342','1','9526','0.99','2005-07-31T01:02:22.000','2006-02-15T22:16:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9250','342','2','9948','5.99','2005-07-31T15:49:41.000','2006-02-15T22:16:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9251','342','1','9955','0.99','2005-07-31T16:01:26.000','2006-02-15T22:16:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9252','342','2','9956','4.99','2005-07-31T16:03:47.000','2006-02-15T22:16:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9253','342','1','10242','4.99','2005-08-01T02:18:12.000','2006-02-15T22:16:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9254','342','2','11178','2.99','2005-08-02T10:48:10.000','2006-02-15T22:16:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9255','342','2','11446','0.99','2005-08-02T20:33:37.000','2006-02-15T22:16:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9256','342','1','11568','0.99','2005-08-17T01:30:01.000','2006-02-15T22:16:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9257','342','1','12139','6.99','2005-08-17T23:57:13.000','2006-02-15T22:16:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9258','342','1','12404','4.99','2005-08-18T09:36:34.000','2006-02-15T22:16:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9259','342','1','12522','2.99','2005-08-18T13:45:40.000','2006-02-15T22:16:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9260','342','2','12816','4.99','2005-08-19T01:04:05.000','2006-02-15T22:16:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9261','342','2','13368','4.99','2005-08-19T21:19:35.000','2006-02-15T22:16:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9262','342','2','13637','4.99','2005-08-20T07:21:15.000','2006-02-15T22:16:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9263','342','1','13755','2.99','2005-08-20T11:18:53.000','2006-02-15T22:16:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9264','342','2','13827','4.99','2005-08-20T13:47:19.000','2006-02-15T22:16:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9265','342','2','14096','2.99','2005-08-21T00:27:46.000','2006-02-15T22:16:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9266','342','2','14299','0.99','2005-08-21T07:18:57.000','2006-02-15T22:16:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9267','342','2','14683','8.99','2005-08-21T20:27:44.000','2006-02-15T22:16:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9268','342','1','15484','4.99','2005-08-23T02:04:49.000','2006-02-15T22:16:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9269','342','1','15895','3.99','2005-08-23T17:09:31.000','2006-02-15T22:16:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9270','343','2','102','3.99','2005-05-25T17:22:10.000','2006-02-15T22:16:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9271','343','1','455','3.99','2005-05-27T19:43:29.000','2006-02-15T22:16:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9272','343','2','1547','4.99','2005-06-16T01:42:24.000','2006-02-15T22:16:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9273','343','1','1564','6.99','2005-06-16T02:47:07.000','2006-02-15T22:16:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9274','343','2','1879','0.99','2005-06-17T02:57:34.000','2006-02-15T22:16:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9275','343','2','1922','0.99','2005-06-17T06:04:25.000','2006-02-15T22:16:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9276','343','2','2461','6.99','2005-06-18T19:58:12.000','2006-02-15T22:16:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9277','343','1','2980','8.99','2005-06-20T08:35:03.000','2006-02-15T22:16:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9278','343','1','3407','0.99','2005-06-21T16:14:02.000','2006-02-15T22:16:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9279','343','1','3978','5.99','2005-07-06T23:04:33.000','2006-02-15T22:16:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9280','343','1','4472','7.99','2005-07-08T00:22:06.000','2006-02-15T22:16:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9281','343','2','5097','4.99','2005-07-09T06:09:51.000','2006-02-15T22:16:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9282','343','1','5337','3.99','2005-07-09T17:03:50.000','2006-02-15T22:16:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9283','343','1','7069','6.99','2005-07-27T03:59:35.000','2006-02-15T22:16:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9284','343','2','8012','5.99','2005-07-28T15:29:00.000','2006-02-15T22:16:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9285','343','2','8088','9.99','2005-07-28T18:23:49.000','2006-02-15T22:16:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9286','343','2','9458','5.99','2005-07-30T22:24:34.000','2006-02-15T22:16:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9287','343','2','9739','2.99','2005-07-31T09:08:03.000','2006-02-15T22:16:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9288','343','1','10822','0.99','2005-08-01T22:54:28.000','2006-02-15T22:16:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9289','343','1','11212','0.99','2005-08-02T12:18:29.000','2006-02-15T22:16:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9290','343','2','11570','2.99','2005-08-17T01:34:32.000','2006-02-15T22:16:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9291','343','2','13279','4.99','2005-08-19T18:02:18.000','2006-02-15T22:16:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9292','343','2','13522','3.99','2005-08-20T02:44:06.000','2006-02-15T22:16:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9293','343','2','13866','0.99','2005-08-20T15:05:29.000','2006-02-15T22:16:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9294','343','2','15973','5.99','2005-08-23T20:04:41.000','2006-02-15T22:16:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9295','344','2','157','2.99','2005-05-26T01:25:21.000','2006-02-15T22:16:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9296','344','2','813','5.99','2005-05-29T20:14:34.000','2006-02-15T22:16:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9297','344','1','1341','3.99','2005-06-15T12:26:18.000','2006-02-15T22:16:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9298','344','2','1475','4.99','2005-06-15T21:08:01.000','2006-02-15T22:16:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9299','344','1','1731','0.99','2005-06-16T15:32:12.000','2006-02-15T22:16:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9300','344','2','4028','5.99','2005-07-07T02:19:14.000','2006-02-15T22:16:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9301','344','2','4347','3.99','2005-07-07T18:58:57.000','2006-02-15T22:16:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9302','344','2','6363','5.99','2005-07-11T21:13:19.000','2006-02-15T22:16:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9303','344','2','7480','4.99','2005-07-27T19:19:53.000','2006-02-15T22:16:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9304','344','2','8561','2.99','2005-07-29T11:29:12.000','2006-02-15T22:16:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9305','344','2','9788','4.99','2005-07-31T10:28:21.000','2006-02-15T22:16:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9306','344','2','11116','5.99','2005-08-02T08:34:40.000','2006-02-15T22:16:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9307','344','2','12183','5.99','2005-08-18T01:34:13.000','2006-02-15T22:16:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9308','344','2','13014','4.99','2005-08-19T07:56:08.000','2006-02-15T22:16:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9309','344','1','13033','3.99','2005-08-19T08:34:39.000','2006-02-15T22:16:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9310','344','1','14621','0.99','2005-08-21T18:17:59.000','2006-02-15T22:16:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9311','344','2','14624','0.99','2005-08-21T18:32:42.000','2006-02-15T22:16:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9312','344','1','15215','2.99','2005-08-22T16:55:26.000','2006-02-15T22:16:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9313','345','1','206','0.99','2005-05-26T08:01:54.000','2006-02-15T22:16:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9314','345','1','363','0.99','2005-05-27T07:14:00.000','2006-02-15T22:16:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9315','345','2','1210','0.99','2005-06-15T02:57:51.000','2006-02-15T22:16:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9316','345','1','1457','4.99','2005-06-15T20:05:49.000','2006-02-15T22:16:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9317','345','2','1550','0.99','2005-06-16T01:58:35.000','2006-02-15T22:16:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9318','345','2','2766','4.99','2005-06-19T17:45:15.000','2006-02-15T22:16:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9319','345','2','4422','2.99','2005-07-07T22:09:45.000','2006-02-15T22:16:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9320','345','1','4425','2.99','2005-07-07T22:22:44.000','2006-02-15T22:16:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9321','345','2','4450','4.99','2005-07-07T23:20:05.000','2006-02-15T22:16:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9322','345','2','5508','3.99','2005-07-10T00:50:01.000','2006-02-15T22:16:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9323','345','1','6307','7.99','2005-07-11T18:04:29.000','2006-02-15T22:16:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9324','345','1','7092','6.99','2005-07-27T04:46:00.000','2006-02-15T22:16:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9325','345','2','8129','2.99','2005-07-28T19:47:02.000','2006-02-15T22:16:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9326','345','2','8694','8.99','2005-07-29T16:44:48.000','2006-02-15T22:16:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9327','345','1','9163','4.99','2005-07-30T11:23:22.000','2006-02-15T22:16:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9328','345','2','9207','2.99','2005-07-30T12:49:57.000','2006-02-15T22:16:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9329','345','2','10215','8.99','2005-08-01T01:04:28.000','2006-02-15T22:16:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9330','345','2','10982','4.99','2005-08-02T04:19:11.000','2006-02-15T22:16:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9331','345','1','11865','2.99','2005-08-17T14:03:46.000','2006-02-15T22:16:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9332','345','1','12485','4.99','2005-08-18T12:41:41.000','2006-02-15T22:16:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9333','345','2','12805','4.99','2005-08-19T00:36:34.000','2006-02-15T22:16:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9334','345','1','14702','10.99','2005-08-21T21:00:03.000','2006-02-15T22:16:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9335','345','1','15551','4.99','2005-08-23T04:28:25.000','2006-02-15T22:16:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9336','346','1','65','4.99','2005-05-25T09:32:03.000','2006-02-15T22:16:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9337','346','1','810','4.99','2005-05-29T19:12:04.000','2006-02-15T22:16:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9338','346','1','1994','5.99','2005-06-17T11:07:06.000','2006-02-15T22:16:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9339','346','2','3372','2.99','2005-06-21T13:34:19.000','2006-02-15T22:16:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9340','346','1','3421','2.99','2005-06-21T17:22:58.000','2006-02-15T22:16:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9341','346','2','4420','4.99','2005-07-07T22:07:31.000','2006-02-15T22:16:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9342','346','1','4958','8.99','2005-07-08T23:19:52.000','2006-02-15T22:16:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9343','346','1','5428','4.99','2005-07-09T21:12:50.000','2006-02-15T22:16:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9344','346','2','5557','4.99','2005-07-10T03:10:21.000','2006-02-15T22:16:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9345','346','2','6136','4.99','2005-07-11T08:34:09.000','2006-02-15T22:16:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9346','346','2','6323','2.99','2005-07-11T19:02:19.000','2006-02-15T22:16:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9347','346','2','6881','8.99','2005-07-12T20:46:35.000','2006-02-15T22:16:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9348','346','2','7943','6.99','2005-07-28T12:50:55.000','2006-02-15T22:16:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9349','346','2','8272','5.99','2005-07-29T01:29:51.000','2006-02-15T22:16:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9350','346','1','8505','6.99','2005-07-29T09:22:52.000','2006-02-15T22:16:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9351','346','2','8543','0.99','2005-07-29T11:01:57.000','2006-02-15T22:16:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9352','346','2','8732','8.99','2005-07-29T18:25:03.000','2006-02-15T22:16:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9353','346','2','9566','4.99','2005-07-31T02:32:10.000','2006-02-15T22:16:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9354','346','1','9848','4.99','2005-07-31T12:44:33.000','2006-02-15T22:16:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9355','346','1','9927','2.99','2005-07-31T15:12:13.000','2006-02-15T22:16:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9356','346','1','10304','5.99','2005-08-01T04:14:12.000','2006-02-15T22:16:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9357','346','2','10389','3.99','2005-08-01T06:46:43.000','2006-02-15T22:16:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9358','346','2','10521','0.99','2005-08-01T11:46:17.000','2006-02-15T22:16:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9359','346','2','11062','4.99','2005-08-02T06:52:54.000','2006-02-15T22:16:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9360','346','1','11375','4.99','2005-08-02T18:14:56.000','2006-02-15T22:16:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9361','346','2','11470','2.99','2005-08-02T21:48:28.000','2006-02-15T22:16:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9362','346','1','14890','5.99','2005-08-22T04:10:49.000','2006-02-15T22:16:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9363','346','2','15459','2.99','2005-08-23T01:09:48.000','2006-02-15T22:16:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9364','346','1','15535','0.99','2005-08-23T03:58:02.000','2006-02-15T22:16:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9365','346','1','15661','8.99','2005-08-23T08:52:03.000','2006-02-15T22:16:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9366','346','2','15825','5.99','2005-08-23T15:10:42.000','2006-02-15T22:16:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9367','346','1','15827','0.99','2005-08-23T15:15:19.000','2006-02-15T22:16:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9368','347','2','1711','8.99','2005-06-16T14:11:52.000','2006-02-15T22:16:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9369','347','2','2274','0.99','2005-06-18T06:31:15.000','2006-02-15T22:16:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9370','347','1','3026','4.99','2005-06-20T11:48:00.000','2006-02-15T22:16:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9371','347','1','3092','8.99','2005-06-20T16:04:42.000','2006-02-15T22:16:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9372','347','1','3326','7.99','2005-06-21T09:04:50.000','2006-02-15T22:16:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9373','347','2','3605','0.99','2005-07-06T05:27:15.000','2006-02-15T22:16:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9374','347','2','3666','4.99','2005-07-06T08:27:43.000','2006-02-15T22:16:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9375','347','1','4232','5.99','2005-07-07T12:49:12.000','2006-02-15T22:16:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9376','347','1','4523','6.99','2005-07-08T03:06:59.000','2006-02-15T22:16:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9377','347','2','5471','0.99','2005-07-09T23:11:52.000','2006-02-15T22:16:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9378','347','1','5819','2.99','2005-07-10T15:56:20.000','2006-02-15T22:16:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9379','347','2','6121','1.99','2005-07-11T07:55:27.000','2006-02-15T22:16:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9380','347','1','7811','0.99','2005-07-28T08:06:01.000','2006-02-15T22:16:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9381','347','2','8148','4.99','2005-07-28T20:39:47.000','2006-02-15T22:16:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9382','347','2','8153','4.99','2005-07-28T20:55:49.000','2006-02-15T22:16:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9383','347','2','8176','4.99','2005-07-28T21:42:08.000','2006-02-15T22:16:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9384','347','2','8378','4.99','2005-07-29T05:28:35.000','2006-02-15T22:16:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9385','347','2','8771','2.99','2005-07-29T19:54:41.000','2006-02-15T22:16:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9386','347','1','9013','4.99','2005-07-30T05:19:20.000','2006-02-15T22:16:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9387','347','1','9582','4.99','2005-07-31T03:05:19.000','2006-02-15T22:16:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9388','347','1','9856','3.99','2005-07-31T13:00:35.000','2006-02-15T22:16:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9389','347','1','9876','2.99','2005-07-31T13:37:51.000','2006-02-15T22:16:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9390','347','2','11738','8.99','2005-08-17T08:45:55.000','2006-02-15T22:16:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9391','347','1','12195','2.99','2005-08-18T02:07:49.000','2006-02-15T22:16:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9392','347','2','12399','10.99','2005-08-18T09:13:42.000','2006-02-15T22:16:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9393','347','2','13314','5.99','2005-08-19T19:12:43.000','2006-02-15T22:16:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9394','347','2','14894','4.99','2005-08-22T04:16:56.000','2006-02-15T22:16:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9395','347','2','14958','2.99','2005-08-22T06:30:10.000','2006-02-15T22:16:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9396','347','2','15426','2.99','2005-08-23T00:07:19.000','2006-02-15T22:16:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9397','347','2','15555','4.99','2005-08-23T04:51:52.000','2006-02-15T22:16:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9398','348','2','153','0.99','2005-05-26T00:47:47.000','2006-02-15T22:16:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9399','348','2','821','0.99','2005-05-29T21:31:12.000','2006-02-15T22:16:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9400','348','1','1654','2.99','2005-06-16T09:42:48.000','2006-02-15T22:16:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9401','348','1','2041','8.99','2005-06-17T14:19:00.000','2006-02-15T22:16:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9402','348','2','2499','0.99','2005-06-18T23:01:36.000','2006-02-15T22:16:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9403','348','2','3494','4.99','2005-07-05T23:47:30.000','2006-02-15T22:16:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9404','348','2','3610','4.99','2005-07-06T05:36:59.000','2006-02-15T22:16:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9405','348','2','4556','9.99','2005-07-08T04:48:41.000','2006-02-15T22:16:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9406','348','2','4633','0.99','2005-07-08T08:39:39.000','2006-02-15T22:16:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9407','348','1','4699','0.99','2005-07-08T11:36:56.000','2006-02-15T22:16:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9408','348','1','4807','8.99','2005-07-08T17:01:48.000','2006-02-15T22:16:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9409','348','1','5345','4.99','2005-07-09T17:28:18.000','2006-02-15T22:16:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9410','348','2','5965','0.99','2005-07-10T23:51:52.000','2006-02-15T22:16:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9411','348','2','6776','2.99','2005-07-12T16:02:09.000','2006-02-15T22:16:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9412','348','2','7380','2.99','2005-07-27T15:37:01.000','2006-02-15T22:16:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9413','348','1','7482','6.99','2005-07-27T19:24:16.000','2006-02-15T22:16:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9414','348','2','7825','4.99','2005-07-28T08:34:57.000','2006-02-15T22:16:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9415','348','1','8500','2.99','2005-07-29T09:12:01.000','2006-02-15T22:16:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9416','348','1','8569','4.99','2005-07-29T11:39:17.000','2006-02-15T22:16:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9417','348','2','8682','4.99','2005-07-29T16:15:26.000','2006-02-15T22:16:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9418','348','2','9482','2.99','2005-07-30T23:29:16.000','2006-02-15T22:16:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9419','348','1','10769','2.99','2005-08-01T20:43:02.000','2006-02-15T22:16:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9420','348','2','10972','2.99','2005-08-02T04:08:25.000','2006-02-15T22:16:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9421','348','1','11262','2.99','2005-08-02T13:58:55.000','2006-02-15T22:16:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9422','348','1','11429','7.99','2005-08-02T20:03:52.000','2006-02-15T22:16:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9423','348','2','12564','2.99','2005-08-18T15:11:35.000','2006-02-15T22:16:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9424','348','2','12884','5.99','2005-08-19T03:34:04.000','2006-02-15T22:16:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9425','348','2','12937','4.99','2005-08-19T05:25:30.000','2006-02-15T22:16:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9426','348','2','13238','2.99','2005-08-19T16:20:56.000','2006-02-15T22:16:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9427','348','2','13602','5.99','2005-08-20T06:02:02.000','2006-02-15T22:16:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9428','348','2','13684','0.99','2005-08-20T08:55:53.000','2006-02-15T22:16:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9429','348','1','13962','1.99','2005-08-20T18:18:06.000','2006-02-15T22:16:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9430','348','2','14079','3.99','2005-08-20T23:29:25.000','2006-02-15T22:16:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9431','348','2','14937','7.99','2005-08-22T05:51:59.000','2006-02-15T22:16:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9432','348','2','15817','0.99','2005-08-23T14:59:51.000','2006-02-15T22:16:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9433','348','1','15944','4.99','2005-08-23T18:50:54.000','2006-02-15T22:16:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9434','349','1','890','4.99','2005-05-30T07:43:04.000','2006-02-15T22:16:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9435','349','1','1197','2.99','2005-06-15T01:42:46.000','2006-02-15T22:16:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9436','349','1','1523','0.99','2005-06-16T00:18:40.000','2006-02-15T22:16:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9437','349','2','2987','6.99','2005-06-20T08:55:50.000','2006-02-15T22:16:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9438','349','1','3067','8.99','2005-06-20T13:59:21.000','2006-02-15T22:16:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9439','349','2','3488','3.99','2005-07-05T23:32:49.000','2006-02-15T22:16:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9440','349','1','4190','2.99','2005-07-07T10:52:39.000','2006-02-15T22:16:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9441','349','2','4494','5.99','2005-07-08T01:42:45.000','2006-02-15T22:16:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9442','349','1','4881','0.99','2005-07-08T19:40:34.000','2006-02-15T22:16:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9443','349','1','5433','4.99','2005-07-09T21:22:00.000','2006-02-15T22:16:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9444','349','1','7002','4.99','2005-07-27T01:26:14.000','2006-02-15T22:16:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9445','349','1','7046','4.99','2005-07-27T03:27:56.000','2006-02-15T22:16:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9446','349','2','7702','2.99','2005-07-28T03:56:05.000','2006-02-15T22:16:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9447','349','2','8297','4.99','2005-07-29T02:45:46.000','2006-02-15T22:16:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9448','349','1','9262','1.99','2005-07-30T14:45:02.000','2006-02-15T22:16:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9449','349','1','9670','5.99','2005-07-31T06:33:33.000','2006-02-15T22:16:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9450','349','1','9731','0.99','2005-07-31T08:54:47.000','2006-02-15T22:16:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9451','349','1','10987','4.99','2005-08-02T04:36:52.000','2006-02-15T22:16:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9452','349','2','11192','4.99','2005-08-02T11:29:41.000','2006-02-15T22:16:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9453','349','2','11492','8.99','2005-08-02T22:46:47.000','2006-02-15T22:16:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9454','349','1','11905','3.99','2005-08-17T15:40:18.000','2006-02-15T22:16:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9455','349','1','13258','4.99','2005-08-19T17:05:37.000','2006-02-15T22:16:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9456','349','2','13636','4.99','2005-08-20T07:20:09.000','2006-02-15T22:16:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9457','349','2','14200','6.99','2005-08-21T03:51:27.000','2006-02-15T22:16:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9458','349','2','14721','6.99','2005-08-21T21:50:51.000','2006-02-15T22:16:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9459','349','2','14908','4.99','2005-08-22T04:44:10.000','2006-02-15T22:16:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9460','349','1','15833','6.99','2005-08-23T15:22:15.000','2006-02-15T22:16:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9461','349','1','15955','5.99','2005-08-23T19:19:06.000','2006-02-15T22:16:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9462','349','1','14915','2.99','2006-02-14T15:16:03.000','2006-02-15T22:16:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9463','350','1','24','4.99','2005-05-25T02:53:02.000','2006-02-15T22:16:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9464','350','1','802','4.99','2005-05-29T17:38:59.000','2006-02-15T22:16:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9465','350','2','2011','3.99','2005-06-17T11:56:09.000','2006-02-15T22:16:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9466','350','1','2619','0.99','2005-06-19T08:03:12.000','2006-02-15T22:16:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9467','350','1','3079','2.99','2005-06-20T15:13:40.000','2006-02-15T22:16:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9468','350','2','3206','0.99','2005-06-21T00:39:39.000','2006-02-15T22:16:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9469','350','1','3529','0.99','2005-07-06T01:15:26.000','2006-02-15T22:16:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9470','350','1','3893','5.99','2005-07-06T18:59:31.000','2006-02-15T22:16:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9471','350','1','4767','2.99','2005-07-08T15:18:53.000','2006-02-15T22:16:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9472','350','1','5240','0.99','2005-07-09T13:14:48.000','2006-02-15T22:16:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9473','350','1','5303','2.99','2005-07-09T15:44:09.000','2006-02-15T22:16:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9474','350','1','5786','1.99','2005-07-10T14:06:44.000','2006-02-15T22:16:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9475','350','2','6408','3.99','2005-07-11T23:03:02.000','2006-02-15T22:16:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9476','350','2','7416','4.99','2005-07-27T16:55:25.000','2006-02-15T22:16:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9477','350','2','11504','0.99','2005-08-16T23:16:46.000','2006-02-15T22:16:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9478','350','2','11595','6.99','2005-08-17T02:53:14.000','2006-02-15T22:16:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9479','350','2','11692','6.99','2005-08-17T06:52:41.000','2006-02-15T22:16:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9480','350','1','11800','0.99','2005-08-17T11:29:52.000','2006-02-15T22:16:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9481','350','2','12252','6.99','2005-08-18T03:59:51.000','2006-02-15T22:16:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9482','350','2','12445','2.99','2005-08-18T10:56:20.000','2006-02-15T22:16:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9483','350','2','13086','0.99','2005-08-19T10:32:28.000','2006-02-15T22:16:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9484','350','2','15789','1.99','2005-08-23T13:56:40.000','2006-02-15T22:16:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9485','350','1','15807','0.99','2005-08-23T14:35:10.000','2006-02-15T22:16:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9486','351','1','1137','1.99','2005-05-31T19:20:14.000','2006-02-15T22:16:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9487','351','2','1792','5.99','2005-06-16T20:04:50.000','2006-02-15T22:16:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9488','351','1','1869','0.99','2005-06-17T02:08:00.000','2006-02-15T22:16:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9489','351','1','2759','2.99','2005-06-19T17:10:24.000','2006-02-15T22:16:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9490','351','1','3836','2.99','2005-07-06T16:26:04.000','2006-02-15T22:16:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9491','351','1','4544','0.99','2005-07-08T04:11:04.000','2006-02-15T22:16:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9492','351','1','4756','1.99','2005-07-08T14:24:00.000','2006-02-15T22:16:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9493','351','2','4761','5.99','2005-07-08T14:51:45.000','2006-02-15T22:16:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9494','351','1','5280','0.99','2005-07-09T14:55:07.000','2006-02-15T22:16:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9495','351','1','5912','3.99','2005-07-10T20:58:22.000','2006-02-15T22:16:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9496','351','2','6180','3.99','2005-07-11T11:06:50.000','2006-02-15T22:16:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9497','351','1','6664','4.99','2005-07-12T11:28:22.000','2006-02-15T22:16:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9498','351','2','6777','5.99','2005-07-12T16:04:40.000','2006-02-15T22:16:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9499','351','2','7630','4.99','2005-07-28T01:01:03.000','2006-02-15T22:16:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9500','351','2','8512','4.99','2005-07-29T09:48:03.000','2006-02-15T22:16:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9501','351','1','9707','7.99','2005-07-31T07:44:18.000','2006-02-15T22:16:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9502','351','2','10119','0.99','2005-07-31T21:20:59.000','2006-02-15T22:16:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9503','351','2','10501','2.99','2005-08-01T11:04:46.000','2006-02-15T22:16:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9504','351','2','11127','0.99','2005-08-02T09:00:59.000','2006-02-15T22:16:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9505','351','1','14368','6.99','2005-08-21T09:31:47.000','2006-02-15T22:16:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9506','351','2','15142','4.99','2005-08-22T13:44:32.000','2006-02-15T22:16:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9507','351','1','15664','4.99','2005-08-23T08:57:11.000','2006-02-15T22:16:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9508','351','2','15712','2.99','2005-08-23T10:43:56.000','2006-02-15T22:16:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9509','351','1','15762','2.99','2005-08-23T13:01:43.000','2006-02-15T22:16:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9510','352','1','784','2.99','2005-05-29T14:44:22.000','2006-02-15T22:16:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9511','352','1','1498','0.99','2005-06-15T21:58:00.000','2006-02-15T22:16:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9512','352','1','1649','4.99','2005-06-16T09:20:33.000','2006-02-15T22:16:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9513','352','1','1678','4.99','2005-06-16T11:08:28.000','2006-02-15T22:16:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9514','352','1','1780','4.99','2005-06-16T19:11:45.000','2006-02-15T22:16:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9515','352','2','3331','4.99','2005-06-21T09:37:53.000','2006-02-15T22:16:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9516','352','2','4116','4.99','2005-07-07T06:56:13.000','2006-02-15T22:16:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9517','352','2','6329','5.99','2005-07-11T19:10:38.000','2006-02-15T22:16:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9518','352','1','7033','2.99','2005-07-27T03:03:25.000','2006-02-15T22:16:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9519','352','1','7419','7.99','2005-07-27T17:04:15.000','2006-02-15T22:16:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9520','352','2','7512','6.99','2005-07-27T20:40:40.000','2006-02-15T22:16:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9521','352','1','7579','4.99','2005-07-27T23:06:41.000','2006-02-15T22:16:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9522','352','1','7845','5.99','2005-07-28T09:18:07.000','2006-02-15T22:16:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9523','352','1','7886','2.99','2005-07-28T10:37:55.000','2006-02-15T22:16:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9524','352','1','9463','0.99','2005-07-30T22:30:57.000','2006-02-15T22:16:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9525','352','1','11793','5.99','2005-08-17T11:05:53.000','2006-02-15T22:16:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9526','352','1','11823','6.99','2005-08-17T12:36:37.000','2006-02-15T22:16:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9527','352','2','11986','0.99','2005-08-17T18:21:58.000','2006-02-15T22:16:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9528','352','2','12234','5.99','2005-08-18T03:17:33.000','2006-02-15T22:16:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9529','352','1','12751','2.99','2005-08-18T22:33:22.000','2006-02-15T22:16:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9530','352','1','14130','4.99','2005-08-21T01:43:11.000','2006-02-15T22:16:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9531','352','2','14852','0.99','2005-08-22T02:25:53.000','2006-02-15T22:16:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9532','352','2','13578','2.99','2006-02-14T15:16:03.000','2006-02-15T22:16:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9533','353','2','1103','6.99','2005-05-31T14:24:18.000','2006-02-15T22:16:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9534','353','2','1359','2.99','2005-06-15T13:30:30.000','2006-02-15T22:16:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9535','353','2','1928','7.99','2005-06-17T06:48:31.000','2006-02-15T22:16:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9536','353','2','3233','6.99','2005-06-21T02:39:31.000','2006-02-15T22:16:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9537','353','2','4380','5.99','2005-07-07T20:35:00.000','2006-02-15T22:16:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9538','353','2','6559','1.99','2005-07-12T05:20:35.000','2006-02-15T22:16:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9539','353','1','6610','3.99','2005-07-12T08:20:02.000','2006-02-15T22:16:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9540','353','2','7993','3.99','2005-07-28T14:56:41.000','2006-02-15T22:16:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9541','353','2','10071','2.99','2005-07-31T19:49:35.000','2006-02-15T22:16:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9542','353','1','11186','0.99','2005-08-02T11:12:08.000','2006-02-15T22:16:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9543','353','2','11414','4.99','2005-08-02T19:43:07.000','2006-02-15T22:16:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9544','353','2','11698','4.99','2005-08-17T07:09:59.000','2006-02-15T22:16:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9545','353','1','12928','5.99','2005-08-19T05:04:09.000','2006-02-15T22:16:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9546','353','2','13604','0.99','2005-08-20T06:03:33.000','2006-02-15T22:16:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9547','353','1','14396','4.99','2005-08-21T10:24:54.000','2006-02-15T22:16:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9548','353','1','15564','1.99','2005-08-23T05:10:42.000','2006-02-15T22:16:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9549','353','2','15650','0.99','2005-08-23T08:29:53.000','2006-02-15T22:16:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9550','353','2','15676','2.99','2005-08-23T09:23:08.000','2006-02-15T22:16:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9551','354','1','140','0.99','2005-05-25T23:34:22.000','2006-02-15T22:16:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9552','354','2','158','1.99','2005-05-26T01:27:11.000','2006-02-15T22:16:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9553','354','2','402','0.99','2005-05-27T13:17:18.000','2006-02-15T22:16:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9554','354','1','1491','0.99','2005-06-15T21:48:18.000','2006-02-15T22:16:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9555','354','1','2275','4.99','2005-06-18T06:31:29.000','2006-02-15T22:16:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9556','354','1','2769','6.99','2005-06-19T17:52:14.000','2006-02-15T22:16:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9557','354','1','3139','2.99','2005-06-20T19:44:45.000','2006-02-15T22:16:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9558','354','2','3821','2.99','2005-07-06T15:36:20.000','2006-02-15T22:16:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9559','354','2','4034','0.99','2005-07-07T02:36:33.000','2006-02-15T22:16:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9560','354','1','4449','5.99','2005-07-07T23:18:58.000','2006-02-15T22:16:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9561','354','2','4745','2.99','2005-07-08T13:45:09.000','2006-02-15T22:16:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9562','354','1','5354','4.99','2005-07-09T18:04:33.000','2006-02-15T22:16:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9563','354','2','5556','4.99','2005-07-10T03:10:17.000','2006-02-15T22:16:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9564','354','1','5873','3.99','2005-07-10T19:02:10.000','2006-02-15T22:16:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9565','354','1','6054','0.99','2005-07-11T03:58:39.000','2006-02-15T22:16:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9566','354','1','6838','4.99','2005-07-12T19:01:30.000','2006-02-15T22:16:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9567','354','1','6926','0.99','2005-07-26T22:52:45.000','2006-02-15T22:16:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9568','354','1','6939','5.99','2005-07-26T23:17:51.000','2006-02-15T22:16:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9569','354','2','7148','0.99','2005-07-27T07:04:09.000','2006-02-15T22:16:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9570','354','2','7235','2.99','2005-07-27T10:09:30.000','2006-02-15T22:16:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9571','354','2','7241','0.99','2005-07-27T10:25:49.000','2006-02-15T22:16:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9572','354','2','8321','4.99','2005-07-29T03:50:54.000','2006-02-15T22:16:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9573','354','2','8477','8.99','2005-07-29T08:40:36.000','2006-02-15T22:16:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9574','354','1','8609','4.99','2005-07-29T13:19:25.000','2006-02-15T22:16:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9575','354','2','8921','0.99','2005-07-30T02:04:02.000','2006-02-15T22:16:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9576','354','1','9130','2.99','2005-07-30T09:55:10.000','2006-02-15T22:16:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9577','354','1','10420','6.99','2005-08-01T08:13:53.000','2006-02-15T22:16:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9578','354','2','12243','6.99','2005-08-18T03:38:54.000','2006-02-15T22:16:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9579','354','1','12544','3.99','2005-08-18T14:25:51.000','2006-02-15T22:16:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9580','354','1','12998','4.99','2005-08-19T07:32:16.000','2006-02-15T22:16:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9581','354','2','14212','2.99','2005-08-21T04:29:26.000','2006-02-15T22:16:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9582','354','2','14245','0.99','2005-08-21T05:30:54.000','2006-02-15T22:16:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9583','354','1','14840','5.99','2005-08-22T01:58:42.000','2006-02-15T22:16:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9584','354','2','15956','0.99','2005-08-23T19:19:21.000','2006-02-15T22:16:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9585','354','1','12759','7.98','2006-02-14T15:16:03.000','2006-02-15T22:16:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9586','354','1','11782','0','2006-02-14T15:16:03.000','2006-02-15T22:16:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9587','355','1','1110','3.99','2005-05-31T15:22:51.000','2006-02-15T22:16:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9588','355','2','1488','0.99','2005-06-15T21:39:54.000','2006-02-15T22:16:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9589','355','1','1612','2.99','2005-06-16T06:52:05.000','2006-02-15T22:16:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9590','355','1','3567','5.99','2005-07-06T03:09:36.000','2006-02-15T22:16:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9591','355','1','3730','6.99','2005-07-06T11:31:24.000','2006-02-15T22:16:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9592','355','1','5210','4.99','2005-07-09T11:24:19.000','2006-02-15T22:16:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9593','355','1','5564','5.99','2005-07-10T03:23:05.000','2006-02-15T22:16:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9594','355','1','6127','0.99','2005-07-11T08:06:59.000','2006-02-15T22:16:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9595','355','2','6262','6.99','2005-07-11T15:33:24.000','2006-02-15T22:16:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9596','355','1','6437','2.99','2005-07-12T00:20:29.000','2006-02-15T22:16:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9597','355','2','6669','4.99','2005-07-12T11:39:55.000','2006-02-15T22:16:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9598','355','2','7108','4.99','2005-07-27T05:28:32.000','2006-02-15T22:16:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9599','355','2','7477','5.99','2005-07-27T19:11:03.000','2006-02-15T22:16:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9600','355','2','8418','1.99','2005-07-29T06:54:21.000','2006-02-15T22:16:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9601','355','1','10498','0.99','2005-08-01T10:56:48.000','2006-02-15T22:16:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9602','355','2','11471','0.99','2005-08-02T21:49:03.000','2006-02-15T22:16:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9603','355','2','13821','1.99','2005-08-20T13:33:47.000','2006-02-15T22:16:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9604','355','1','15367','3.99','2005-08-22T21:47:53.000','2006-02-15T22:16:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9605','355','2','15531','2.99','2005-08-23T03:52:36.000','2006-02-15T22:16:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9606','355','1','14760','0.99','2006-02-14T15:16:03.000','2006-02-15T22:16:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9607','356','2','1088','4.99','2005-05-31T11:35:13.000','2006-02-15T22:16:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9608','356','1','1410','0.99','2005-06-15T16:59:46.000','2006-02-15T22:16:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9609','356','1','2405','2.99','2005-06-18T16:36:38.000','2006-02-15T22:16:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9610','356','1','2433','4.99','2005-06-18T18:10:17.000','2006-02-15T22:16:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9611','356','2','3829','6.99','2005-07-06T15:59:40.000','2006-02-15T22:16:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9612','356','2','4599','4.99','2005-07-08T06:48:26.000','2006-02-15T22:16:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9613','356','1','5513','0.99','2005-07-10T01:05:41.000','2006-02-15T22:16:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9614','356','1','6593','4.99','2005-07-12T07:21:17.000','2006-02-15T22:16:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9615','356','1','6648','0.99','2005-07-12T10:46:30.000','2006-02-15T22:16:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9616','356','1','7079','2.99','2005-07-27T04:21:58.000','2006-02-15T22:16:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9617','356','1','7758','1.99','2005-07-28T06:23:41.000','2006-02-15T22:16:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9618','356','1','7902','0.99','2005-07-28T11:14:19.000','2006-02-15T22:16:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9619','356','1','8198','3.99','2005-07-28T23:08:05.000','2006-02-15T22:16:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9620','356','1','8975','5.99','2005-07-30T04:10:18.000','2006-02-15T22:16:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9621','356','2','9037','4.99','2005-07-30T06:23:14.000','2006-02-15T22:16:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9622','356','2','9523','3.99','2005-07-31T00:56:09.000','2006-02-15T22:16:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9623','356','2','9883','6.99','2005-07-31T13:53:37.000','2006-02-15T22:16:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9624','356','1','10427','3.99','2005-08-01T08:30:11.000','2006-02-15T22:16:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9625','356','1','10854','4.99','2005-08-02T00:02:06.000','2006-02-15T22:16:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9626','356','1','11535','3.99','2005-08-17T00:39:54.000','2006-02-15T22:16:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9627','356','2','11579','2.99','2005-08-17T01:57:49.000','2006-02-15T22:16:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9628','356','2','12037','4.99','2005-08-17T20:21:35.000','2006-02-15T22:16:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9629','356','2','12876','2.99','2005-08-19T03:12:19.000','2006-02-15T22:16:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9630','356','1','12913','0.99','2005-08-19T04:25:39.000','2006-02-15T22:16:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9631','356','2','13107','4.99','2005-08-19T11:13:58.000','2006-02-15T22:16:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9632','356','2','13442','5.99','2005-08-19T23:50:45.000','2006-02-15T22:16:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9633','356','2','13703','6.99','2005-08-20T09:29:35.000','2006-02-15T22:16:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9634','356','1','15705','4.99','2005-08-23T10:32:52.000','2006-02-15T22:16:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9635','356','2','15754','5.99','2005-08-23T12:43:42.000','2006-02-15T22:16:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9636','356','1','15757','2.99','2005-08-23T12:47:16.000','2006-02-15T22:16:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9637','357','1','144','2.99','2005-05-25T23:49:56.000','2006-02-15T22:16:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9638','357','1','824','4.99','2005-05-29T21:45:32.000','2006-02-15T22:16:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9639','357','2','945','0.99','2005-05-30T15:33:17.000','2006-02-15T22:16:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9640','357','2','1246','5.99','2005-06-15T05:11:19.000','2006-02-15T22:16:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9641','357','1','1788','1.99','2005-06-16T19:47:18.000','2006-02-15T22:16:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9642','357','2','1971','1.99','2005-06-17T09:23:59.000','2006-02-15T22:16:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9643','357','2','2153','6.99','2005-06-17T22:58:04.000','2006-02-15T22:16:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9644','357','1','3865','3.99','2005-07-06T17:46:57.000','2006-02-15T22:16:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9645','357','1','4478','0.99','2005-07-08T00:39:08.000','2006-02-15T22:16:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9646','357','1','5896','0.99','2005-07-10T20:15:56.000','2006-02-15T22:16:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9647','357','1','6288','8.99','2005-07-11T17:01:52.000','2006-02-15T22:16:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9648','357','2','6367','4.99','2005-07-11T21:18:29.000','2006-02-15T22:16:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9649','357','2','6405','2.99','2005-07-11T22:53:12.000','2006-02-15T22:16:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9650','357','1','6839','0.99','2005-07-12T19:03:19.000','2006-02-15T22:16:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9651','357','1','7353','2.99','2005-07-27T14:38:39.000','2006-02-15T22:16:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9652','357','1','7366','5.99','2005-07-27T15:01:17.000','2006-02-15T22:16:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9653','357','2','8041','2.99','2005-07-28T16:39:56.000','2006-02-15T22:16:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9654','357','1','8124','2.99','2005-07-28T19:28:58.000','2006-02-15T22:16:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9655','357','2','9233','3.99','2005-07-30T13:44:15.000','2006-02-15T22:16:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9656','357','2','10391','2.99','2005-08-01T06:49:05.000','2006-02-15T22:16:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9657','357','1','10502','2.99','2005-08-01T11:06:39.000','2006-02-15T22:16:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9658','357','1','10503','6.99','2005-08-01T11:07:44.000','2006-02-15T22:16:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9659','357','2','10764','0.99','2005-08-01T20:32:42.000','2006-02-15T22:16:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9660','357','2','11065','2.99','2005-08-02T06:57:55.000','2006-02-15T22:16:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9661','357','1','14926','0.99','2005-08-22T05:18:44.000','2006-02-15T22:16:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9662','357','2','15869','2.99','2005-08-23T16:22:20.000','2006-02-15T22:16:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9663','358','2','858','4.99','2005-05-30T02:10:32.000','2006-02-15T22:16:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9664','358','1','1455','2.99','2005-06-15T19:51:06.000','2006-02-15T22:16:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9665','358','2','1908','0.99','2005-06-17T05:10:36.000','2006-02-15T22:16:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9666','358','1','2114','5.99','2005-06-17T20:00:25.000','2006-02-15T22:16:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9667','358','1','2721','2.99','2005-06-19T14:53:24.000','2006-02-15T22:16:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9668','358','1','2749','2.99','2005-06-19T16:27:35.000','2006-02-15T22:16:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9669','358','1','3245','2.99','2005-06-21T03:06:11.000','2006-02-15T22:16:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9670','358','1','3753','2.99','2005-07-06T12:34:06.000','2006-02-15T22:16:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9671','358','1','3809','2.99','2005-07-06T15:16:37.000','2006-02-15T22:16:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9672','358','2','5023','5.99','2005-07-09T02:23:16.000','2006-02-15T22:16:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9673','358','1','6362','2.99','2005-07-11T21:09:31.000','2006-02-15T22:16:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9674','358','1','8621','2.99','2005-07-29T13:52:42.000','2006-02-15T22:16:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9675','358','2','9062','0.99','2005-07-30T07:23:17.000','2006-02-15T22:16:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9676','358','1','9568','0.99','2005-07-31T02:37:44.000','2006-02-15T22:16:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9677','358','1','10193','2.99','2005-08-01T00:33:27.000','2006-02-15T22:16:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9678','358','1','10482','4.99','2005-08-01T10:17:47.000','2006-02-15T22:16:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9679','358','2','11149','5.99','2005-08-02T09:51:43.000','2006-02-15T22:16:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9680','358','2','11653','4.99','2005-08-17T05:06:10.000','2006-02-15T22:16:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9681','358','1','12452','6.99','2005-08-18T11:14:35.000','2006-02-15T22:16:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9682','358','1','13197','2.99','2005-08-19T14:44:03.000','2006-02-15T22:16:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9683','358','1','14004','7.99','2005-08-20T20:16:35.000','2006-02-15T22:16:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9684','359','1','284','8.99','2005-05-26T19:21:44.000','2006-02-15T22:16:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9685','359','2','392','2.99','2005-05-27T11:14:42.000','2006-02-15T22:16:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9686','359','1','528','3.99','2005-05-28T04:30:05.000','2006-02-15T22:16:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9687','359','2','1329','4.99','2005-06-15T11:25:06.000','2006-02-15T22:16:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9688','359','2','1770','1.99','2005-06-16T18:07:55.000','2006-02-15T22:16:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9689','359','1','2401','0.99','2005-06-18T16:22:03.000','2006-02-15T22:16:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9690','359','1','2736','4.99','2005-06-19T15:43:20.000','2006-02-15T22:16:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9691','359','2','4830','7.99','2005-07-08T17:56:23.000','2006-02-15T22:16:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9692','359','2','6424','9.99','2005-07-11T23:49:37.000','2006-02-15T22:16:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9693','359','1','6542','2.99','2005-07-12T04:53:49.000','2006-02-15T22:16:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9694','359','2','6741','0.99','2005-07-12T14:24:16.000','2006-02-15T22:16:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9695','359','2','7098','0.99','2005-07-27T05:01:08.000','2006-02-15T22:16:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9696','359','1','7115','0.99','2005-07-27T05:42:58.000','2006-02-15T22:16:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9697','359','1','8174','4.99','2005-07-28T21:36:52.000','2006-02-15T22:16:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9698','359','1','9898','4.99','2005-07-31T14:12:03.000','2006-02-15T22:16:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9699','359','2','10174','5.99','2005-07-31T23:40:08.000','2006-02-15T22:16:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9700','359','1','11032','4.99','2005-08-02T05:53:35.000','2006-02-15T22:16:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9701','359','1','12611','1.99','2005-08-18T17:09:42.000','2006-02-15T22:16:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9702','359','2','13297','2.99','2005-08-19T18:45:49.000','2006-02-15T22:16:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9703','359','1','14258','1.99','2005-08-21T05:56:36.000','2006-02-15T22:16:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9704','359','2','14598','5.99','2005-08-21T17:40:05.000','2006-02-15T22:16:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9705','359','1','15104','2.99','2005-08-22T12:01:16.000','2006-02-15T22:16:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9706','359','1','15148','4.99','2005-08-22T13:59:19.000','2006-02-15T22:16:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9707','359','1','15453','1.99','2005-08-23T01:01:01.000','2006-02-15T22:16:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9708','359','2','15655','4.99','2006-02-14T15:16:03.000','2006-02-15T22:16:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9709','360','1','633','0.99','2005-05-28T17:37:59.000','2006-02-15T22:16:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9710','360','2','777','4.99','2005-05-29T14:07:58.000','2006-02-15T22:16:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9711','360','2','1492','0.99','2005-06-15T21:48:35.000','2006-02-15T22:16:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9712','360','2','2402','6.99','2005-06-18T16:24:45.000','2006-02-15T22:16:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9713','360','2','2541','3.99','2005-06-19T02:08:10.000','2006-02-15T22:16:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9714','360','2','2780','6.99','2005-06-19T18:19:33.000','2006-02-15T22:16:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9715','360','1','4056','4.99','2005-07-07T03:57:36.000','2006-02-15T22:16:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9716','360','1','4487','7.99','2005-07-08T01:20:22.000','2006-02-15T22:16:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9717','360','2','5456','2.99','2005-07-09T22:31:45.000','2006-02-15T22:16:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9718','360','1','5834','1.99','2005-07-10T16:44:12.000','2006-02-15T22:16:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9719','360','1','5995','3.99','2005-07-11T01:15:39.000','2006-02-15T22:16:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9720','360','1','6442','0.99','2005-07-12T00:29:45.000','2006-02-15T22:16:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9721','360','2','6770','5.99','2005-07-12T15:49:40.000','2006-02-15T22:16:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9722','360','1','7251','2.99','2005-07-27T10:44:55.000','2006-02-15T22:16:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9723','360','2','7588','9.99','2005-07-27T23:23:31.000','2006-02-15T22:16:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9724','360','1','7654','4.99','2005-07-28T02:00:14.000','2006-02-15T22:16:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9725','360','2','7908','3.99','2005-07-28T11:32:57.000','2006-02-15T22:16:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9726','360','1','8220','2.99','2005-07-28T23:46:41.000','2006-02-15T22:16:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9727','360','2','8361','2.99','2005-07-29T05:08:57.000','2006-02-15T22:16:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9728','360','1','9283','4.99','2005-07-30T15:25:19.000','2006-02-15T22:16:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9729','360','2','9352','0.99','2005-07-30T18:29:26.000','2006-02-15T22:16:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9730','360','1','9623','2.99','2005-07-31T04:30:02.000','2006-02-15T22:16:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9731','360','2','9659','3.99','2005-07-31T06:02:14.000','2006-02-15T22:16:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9732','360','2','10857','2.99','2005-08-02T00:07:20.000','2006-02-15T22:16:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9733','360','2','11264','6.99','2005-08-02T14:05:18.000','2006-02-15T22:16:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9734','360','2','11553','4.99','2005-08-17T01:04:31.000','2006-02-15T22:16:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9735','360','2','12088','5.99','2005-08-17T22:20:16.000','2006-02-15T22:16:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9736','360','1','12773','5.99','2005-08-18T23:32:19.000','2006-02-15T22:16:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9737','360','2','12795','0.99','2005-08-19T00:21:52.000','2006-02-15T22:16:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9738','360','1','12839','6.99','2005-08-19T01:53:43.000','2006-02-15T22:16:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9739','360','1','12990','4.99','2005-08-19T07:20:39.000','2006-02-15T22:16:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9740','360','2','13894','7.99','2005-08-20T15:55:20.000','2006-02-15T22:16:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9741','360','1','14700','4.99','2005-08-21T20:53:40.000','2006-02-15T22:16:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9742','360','1','15310','2.99','2005-08-22T19:56:41.000','2006-02-15T22:16:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9743','361','1','368','5.99','2005-05-27T07:42:29.000','2006-02-15T22:16:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9744','361','2','1120','4.99','2005-05-31T16:37:14.000','2006-02-15T22:16:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9745','361','2','2353','4.99','2005-06-18T12:53:25.000','2006-02-15T22:16:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9746','361','2','2558','1.99','2005-06-19T03:09:16.000','2006-02-15T22:16:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9747','361','1','2851','2.99','2005-06-19T23:07:03.000','2006-02-15T22:16:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9748','361','2','3303','2.99','2005-06-21T07:34:14.000','2006-02-15T22:16:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9749','361','2','5154','2.99','2005-07-09T08:46:18.000','2006-02-15T22:16:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9750','361','1','6152','0.99','2005-07-11T09:25:52.000','2006-02-15T22:16:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9751','361','2','6829','4.99','2005-07-12T18:38:59.000','2006-02-15T22:16:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9752','361','2','6911','0.99','2005-07-12T22:14:34.000','2006-02-15T22:16:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9753','361','1','6914','1.99','2005-07-12T22:26:56.000','2006-02-15T22:16:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9754','361','1','7538','2.99','2005-07-27T21:38:04.000','2006-02-15T22:16:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9755','361','2','7712','2.99','2005-07-28T04:29:53.000','2006-02-15T22:16:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9756','361','2','8189','4.99','2005-07-28T22:36:26.000','2006-02-15T22:16:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9757','361','1','10145','1.99','2005-07-31T22:15:13.000','2006-02-15T22:16:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9758','361','1','10151','4.99','2005-07-31T22:22:37.000','2006-02-15T22:16:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9759','361','1','10414','0.99','2005-08-01T08:03:55.000','2006-02-15T22:16:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9760','361','2','10975','0.99','2005-08-02T04:11:25.000','2006-02-15T22:16:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9761','361','2','11031','5.99','2005-08-02T05:52:58.000','2006-02-15T22:16:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9762','361','2','11243','5.99','2005-08-02T13:32:48.000','2006-02-15T22:16:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9763','361','1','11327','2.99','2005-08-02T16:40:47.000','2006-02-15T22:16:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9764','361','1','11991','3.99','2005-08-17T18:27:08.000','2006-02-15T22:16:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9765','361','2','12626','5.99','2005-08-18T17:36:45.000','2006-02-15T22:16:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9766','361','2','12690','2.99','2005-08-18T20:06:57.000','2006-02-15T22:16:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9767','361','1','13135','0.99','2005-08-19T12:22:52.000','2006-02-15T22:16:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9768','361','2','14031','0.99','2005-08-20T21:24:24.000','2006-02-15T22:16:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9769','361','1','14422','0.99','2005-08-21T11:21:46.000','2006-02-15T22:16:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9770','361','1','15759','6.99','2005-08-23T12:47:37.000','2006-02-15T22:16:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9771','361','2','15935','2.99','2005-08-23T18:41:11.000','2006-02-15T22:16:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9772','361','1','13298','3.98','2006-02-14T15:16:03.000','2006-02-15T22:16:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9773','361','1','14769','0','2006-02-14T15:16:03.000','2006-02-15T22:16:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9774','362','2','1035','4.99','2005-05-31T05:01:09.000','2006-02-15T22:16:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9775','362','1','1429','2.99','2005-06-15T18:24:10.000','2006-02-15T22:16:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9776','362','1','1529','2.99','2005-06-16T00:37:35.000','2006-02-15T22:16:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9777','362','1','1615','2.99','2005-06-16T07:00:28.000','2006-02-15T22:16:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9778','362','2','3197','2.99','2005-06-21T00:07:23.000','2006-02-15T22:16:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9779','362','2','3393','2.99','2005-06-21T15:14:27.000','2006-02-15T22:16:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9780','362','2','4646','8.99','2005-07-08T09:23:26.000','2006-02-15T22:16:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9781','362','1','5227','4.99','2005-07-09T12:16:39.000','2006-02-15T22:16:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9782','362','2','5563','1.99','2005-07-10T03:21:02.000','2006-02-15T22:16:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9783','362','2','5690','5.99','2005-07-10T09:26:49.000','2006-02-15T22:16:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9784','362','1','6204','4.99','2005-07-11T12:29:22.000','2006-02-15T22:16:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9785','362','2','6576','4.99','2005-07-12T06:13:41.000','2006-02-15T22:16:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9786','362','1','6981','4.99','2005-07-27T00:51:38.000','2006-02-15T22:16:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9787','362','1','7172','1.99','2005-07-27T07:59:16.000','2006-02-15T22:16:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9788','362','1','7485','2.99','2005-07-27T19:29:09.000','2006-02-15T22:16:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9789','362','1','8081','2.99','2005-07-28T18:06:46.000','2006-02-15T22:16:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9790','362','2','8325','2.99','2005-07-29T03:57:27.000','2006-02-15T22:16:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9791','362','2','8364','4.99','2005-07-29T05:10:31.000','2006-02-15T22:16:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9792','362','1','8662','0.99','2005-07-29T15:31:33.000','2006-02-15T22:16:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9793','362','1','8714','2.99','2005-07-29T17:31:40.000','2006-02-15T22:16:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9794','362','1','9784','4.99','2005-07-31T10:21:32.000','2006-02-15T22:16:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9795','362','2','10546','3.99','2005-08-01T12:44:17.000','2006-02-15T22:16:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9796','362','2','12244','4.99','2005-08-18T03:39:11.000','2006-02-15T22:16:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9797','362','1','12854','6.99','2005-08-19T02:18:51.000','2006-02-15T22:16:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9798','362','1','13603','6.99','2005-08-20T06:02:48.000','2006-02-15T22:16:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9799','362','2','14051','6.99','2005-08-20T22:09:51.000','2006-02-15T22:16:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9800','362','2','14129','2.99','2005-08-21T01:42:15.000','2006-02-15T22:16:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9801','362','2','14336','4.99','2005-08-21T08:33:42.000','2006-02-15T22:16:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9802','362','1','14752','5.99','2005-08-21T23:11:42.000','2006-02-15T22:16:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9803','362','1','14759','11.99','2005-08-21T23:28:58.000','2006-02-15T22:16:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9804','362','1','14808','4.99','2005-08-22T00:58:35.000','2006-02-15T22:16:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9805','362','1','14950','2.99','2005-08-22T06:17:12.000','2006-02-15T22:16:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9806','363','1','733','3.99','2005-05-29T07:35:21.000','2006-02-15T22:16:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9807','363','2','1426','4.99','2005-06-15T18:16:24.000','2006-02-15T22:16:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9808','363','2','1569','4.99','2005-06-16T03:19:09.000','2006-02-15T22:16:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9809','363','1','1847','4.99','2005-06-17T00:05:22.000','2006-02-15T22:16:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9810','363','1','2540','4.99','2005-06-19T02:04:48.000','2006-02-15T22:16:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9811','363','2','3281','2.99','2005-06-21T06:08:47.000','2006-02-15T22:16:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9812','363','1','3726','3.99','2005-07-06T11:15:49.000','2006-02-15T22:16:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9813','363','2','5687','3.99','2005-07-10T09:07:19.000','2006-02-15T22:16:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9814','363','1','5758','6.99','2005-07-10T12:42:43.000','2006-02-15T22:16:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9815','363','2','6140','4.99','2005-07-11T08:40:47.000','2006-02-15T22:16:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9816','363','2','6705','4.99','2005-07-12T12:53:11.000','2006-02-15T22:16:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9817','363','2','6821','2.99','2005-07-12T18:22:10.000','2006-02-15T22:16:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9818','363','2','6878','4.99','2005-07-12T20:37:13.000','2006-02-15T22:16:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9819','363','1','7256','2.99','2005-07-27T10:58:32.000','2006-02-15T22:16:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9820','363','2','7708','4.99','2005-07-28T04:19:15.000','2006-02-15T22:16:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9821','363','2','8121','2.99','2005-07-28T19:25:45.000','2006-02-15T22:16:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9822','363','2','8522','3.99','2005-07-29T10:16:19.000','2006-02-15T22:16:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9823','363','2','8804','2.99','2005-07-29T21:28:19.000','2006-02-15T22:16:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9824','363','2','8841','4.99','2005-07-29T22:56:07.000','2006-02-15T22:16:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9825','363','1','9968','4.99','2005-07-31T16:32:16.000','2006-02-15T22:16:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9826','363','1','9977','8.99','2005-07-31T16:58:42.000','2006-02-15T22:16:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9827','363','1','10339','6.99','2005-08-01T05:05:50.000','2006-02-15T22:16:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9828','363','2','12189','5.99','2005-08-18T01:51:44.000','2006-02-15T22:16:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9829','363','2','12760','4.99','2005-08-18T23:03:19.000','2006-02-15T22:16:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9830','363','1','13706','9.99','2005-08-20T09:32:56.000','2006-02-15T22:16:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9831','363','1','14694','2.99','2005-08-21T20:46:42.000','2006-02-15T22:16:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9832','363','1','14983','5.99','2005-08-22T07:32:23.000','2006-02-15T22:16:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9833','363','2','15279','4.99','2005-08-22T19:08:49.000','2006-02-15T22:16:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9834','363','1','15335','4.99','2005-08-22T20:44:55.000','2006-02-15T22:16:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9835','364','1','462','5.99','2005-05-27T20:10:36.000','2006-02-15T22:16:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9836','364','1','1722','2.99','2005-06-16T15:12:52.000','2006-02-15T22:16:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9837','364','2','2442','2.99','2005-06-18T18:49:18.000','2006-02-15T22:16:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9838','364','2','2606','4.99','2005-06-19T06:51:32.000','2006-02-15T22:16:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9839','364','2','2857','4.99','2005-06-19T23:15:15.000','2006-02-15T22:16:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9840','364','2','2962','3.99','2005-06-20T07:31:55.000','2006-02-15T22:16:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9841','364','1','3678','4.99','2005-07-06T09:15:15.000','2006-02-15T22:16:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9842','364','2','3961','4.99','2005-07-06T22:11:43.000','2006-02-15T22:16:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9843','364','1','4047','0.99','2005-07-07T03:28:49.000','2006-02-15T22:16:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9844','364','2','4689','4.99','2005-07-08T11:03:47.000','2006-02-15T22:16:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9845','364','1','5872','10.99','2005-07-10T18:54:05.000','2006-02-15T22:16:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9846','364','1','7272','2.99','2005-07-27T11:30:20.000','2006-02-15T22:16:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9847','364','2','9266','4.99','2005-07-30T14:59:01.000','2006-02-15T22:16:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9848','364','1','10092','0.99','2005-07-31T20:28:09.000','2006-02-15T22:16:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9849','364','2','10290','5.99','2005-08-01T03:39:50.000','2006-02-15T22:16:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9850','364','2','11932','4.99','2005-08-17T16:36:12.000','2006-02-15T22:16:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9851','364','1','12557','4.99','2005-08-18T14:51:03.000','2006-02-15T22:16:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9852','364','1','12761','1.99','2005-08-18T23:05:22.000','2006-02-15T22:16:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9853','364','2','12912','3.99','2005-08-19T04:24:35.000','2006-02-15T22:16:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9854','364','1','13698','4.99','2005-08-20T09:24:26.000','2006-02-15T22:16:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9855','364','2','13936','0.99','2005-08-20T17:22:35.000','2006-02-15T22:17:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9856','364','2','14293','4.99','2005-08-21T07:06:47.000','2006-02-15T22:17:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9857','364','1','15242','0.99','2005-08-22T17:48:10.000','2006-02-15T22:17:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9858','365','2','120','5.99','2005-05-25T19:37:47.000','2006-02-15T22:17:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9859','365','1','231','4.99','2005-05-26T11:31:59.000','2006-02-15T22:17:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9860','365','1','1303','1.99','2005-06-15T09:55:57.000','2006-02-15T22:17:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9861','365','1','1578','6.99','2005-06-16T04:08:16.000','2006-02-15T22:17:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9862','365','1','1983','4.99','2005-06-17T10:22:13.000','2006-02-15T22:17:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9863','365','1','2525','2.99','2005-06-19T00:48:22.000','2006-02-15T22:17:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9864','365','2','3156','0.99','2005-06-20T21:03:46.000','2006-02-15T22:17:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9865','365','1','4583','1.99','2005-07-08T06:09:44.000','2006-02-15T22:17:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9866','365','1','6604','4.99','2005-07-12T07:57:45.000','2006-02-15T22:17:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9867','365','1','7488','7.99','2005-07-27T19:36:15.000','2006-02-15T22:17:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9868','365','2','7634','4.99','2005-07-28T01:07:01.000','2006-02-15T22:17:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9869','365','1','8168','4.99','2005-07-28T21:28:32.000','2006-02-15T22:17:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9870','365','2','8782','4.99','2005-07-29T20:29:34.000','2006-02-15T22:17:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9871','365','1','8856','3.99','2005-07-29T23:42:00.000','2006-02-15T22:17:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9872','365','1','9122','2.99','2005-07-30T09:36:52.000','2006-02-15T22:17:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9873','365','2','9184','4.99','2005-07-30T12:10:19.000','2006-02-15T22:17:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9874','365','2','9540','2.99','2005-07-31T01:40:06.000','2006-02-15T22:17:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9875','365','2','10717','2.99','2005-08-01T18:53:53.000','2006-02-15T22:17:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9876','365','2','12322','2.99','2005-08-18T06:35:28.000','2006-02-15T22:17:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9877','365','2','12375','4.99','2005-08-18T08:20:08.000','2006-02-15T22:17:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9878','365','1','12804','8.99','2005-08-19T00:33:15.000','2006-02-15T22:17:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9879','365','1','13619','2.99','2005-08-20T06:39:26.000','2006-02-15T22:17:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9880','365','2','14463','6.99','2005-08-21T12:51:49.000','2006-02-15T22:17:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9881','366','2','911','6.99','2005-05-30T10:50:22.000','2006-02-15T22:17:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9882','366','2','1401','1.99','2005-06-15T16:30:22.000','2006-02-15T22:17:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9883','366','2','2214','0.99','2005-06-18T02:44:37.000','2006-02-15T22:17:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9884','366','2','3632','4.99','2005-07-06T06:38:21.000','2006-02-15T22:17:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9885','366','1','3834','2.99','2005-07-06T16:19:56.000','2006-02-15T22:17:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9886','366','2','4276','2.99','2005-07-07T14:50:59.000','2006-02-15T22:17:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9887','366','1','4569','5.99','2005-07-08T05:30:51.000','2006-02-15T22:17:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9888','366','2','5364','0.99','2005-07-09T18:24:48.000','2006-02-15T22:17:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9889','366','1','6112','6.99','2005-07-11T07:28:05.000','2006-02-15T22:17:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9890','366','1','6366','4.99','2005-07-11T21:18:16.000','2006-02-15T22:17:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9891','366','2','6533','6.99','2005-07-12T04:39:38.000','2006-02-15T22:17:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9892','366','2','6738','5.99','2005-07-12T14:17:55.000','2006-02-15T22:17:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9893','366','1','6842','0.99','2005-07-12T19:07:55.000','2006-02-15T22:17:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9894','366','2','6971','4.99','2005-07-27T00:26:17.000','2006-02-15T22:17:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9895','366','1','7344','1.99','2005-07-27T14:29:28.000','2006-02-15T22:17:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9896','366','1','7562','2.99','2005-07-27T22:25:15.000','2006-02-15T22:17:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9897','366','2','7602','4.99','2005-07-27T23:48:35.000','2006-02-15T22:17:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9898','366','1','7805','6.99','2005-07-28T07:56:41.000','2006-02-15T22:17:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9899','366','2','8169','4.99','2005-07-28T21:29:46.000','2006-02-15T22:17:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9900','366','2','8260','1.99','2005-07-29T01:11:00.000','2006-02-15T22:17:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9901','366','2','8928','2.99','2005-07-30T02:18:19.000','2006-02-15T22:17:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9902','366','1','9316','6.99','2005-07-30T17:11:58.000','2006-02-15T22:17:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9903','366','1','10198','2.99','2005-08-01T00:36:15.000','2006-02-15T22:17:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9904','366','1','10384','4.99','2005-08-01T06:39:14.000','2006-02-15T22:17:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9905','366','2','11337','2.99','2005-08-02T16:59:09.000','2006-02-15T22:17:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9906','366','2','11340','5.99','2005-08-02T17:05:43.000','2006-02-15T22:17:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9907','366','2','12413','2.99','2005-08-18T09:50:34.000','2006-02-15T22:17:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9908','366','1','12608','4.99','2005-08-18T17:05:15.000','2006-02-15T22:17:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9909','366','2','13563','0.99','2005-08-20T04:33:31.000','2006-02-15T22:17:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9910','366','1','13857','2.99','2005-08-20T14:50:06.000','2006-02-15T22:17:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9911','366','1','14147','4.99','2005-08-21T02:14:03.000','2006-02-15T22:17:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9912','366','1','14290','4.99','2005-08-21T07:02:59.000','2006-02-15T22:17:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9913','366','1','14390','2.99','2005-08-21T10:15:38.000','2006-02-15T22:17:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9914','366','1','14717','2.99','2005-08-21T21:30:39.000','2006-02-15T22:17:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9915','366','1','14906','6.99','2005-08-22T04:38:18.000','2006-02-15T22:17:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9916','366','1','15514','2.99','2005-08-23T03:03:40.000','2006-02-15T22:17:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9917','366','1','13421','4.99','2006-02-14T15:16:03.000','2006-02-15T22:17:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9918','367','1','939','0.99','2005-05-30T14:49:34.000','2006-02-15T22:17:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9919','367','1','1089','2.99','2005-05-31T11:38:29.000','2006-02-15T22:17:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9920','367','1','3078','0.99','2005-06-20T15:09:48.000','2006-02-15T22:17:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9921','367','1','4251','8.99','2005-07-07T14:11:55.000','2006-02-15T22:17:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9922','367','2','5490','4.99','2005-07-10T00:09:11.000','2006-02-15T22:17:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9923','367','2','5538','4.99','2005-07-10T02:39:40.000','2006-02-15T22:17:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9924','367','2','5839','2.99','2005-07-10T17:08:30.000','2006-02-15T22:17:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9925','367','2','6228','2.99','2005-07-11T13:58:36.000','2006-02-15T22:17:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9926','367','1','6716','0.99','2005-07-12T13:34:58.000','2006-02-15T22:17:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9927','367','2','6835','5.99','2005-07-12T18:58:03.000','2006-02-15T22:17:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9928','367','2','8490','0.99','2005-07-29T08:59:25.000','2006-02-15T22:17:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9929','367','1','9030','3.99','2005-07-30T06:05:38.000','2006-02-15T22:17:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9930','367','1','9430','4.99','2005-07-30T21:20:13.000','2006-02-15T22:17:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9931','367','1','9912','4.99','2005-07-31T14:49:04.000','2006-02-15T22:17:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9932','367','2','10344','4.99','2005-08-01T05:18:23.000','2006-02-15T22:17:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9933','367','1','12152','4.99','2005-08-18T00:21:35.000','2006-02-15T22:17:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9934','367','2','12362','0.99','2005-08-18T07:48:05.000','2006-02-15T22:17:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9935','367','2','12373','8.99','2005-08-18T08:07:25.000','2006-02-15T22:17:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9936','367','2','12911','6.99','2005-08-19T04:24:10.000','2006-02-15T22:17:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9937','367','2','13235','4.99','2005-08-19T16:17:53.000','2006-02-15T22:17:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9938','367','1','14413','6.99','2005-08-21T11:06:33.000','2006-02-15T22:17:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9939','367','1','14481','10.99','2005-08-21T13:41:14.000','2006-02-15T22:17:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9940','368','1','64','5.99','2005-05-25T09:21:29.000','2006-02-15T22:17:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9941','368','1','125','5.99','2005-05-25T20:48:50.000','2006-02-15T22:17:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9942','368','1','836','2.99','2005-05-29T23:56:42.000','2006-02-15T22:17:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9943','368','1','949','2.99','2005-05-30T15:50:39.000','2006-02-15T22:17:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9944','368','1','1186','0.99','2005-06-15T00:56:45.000','2006-02-15T22:17:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9945','368','1','1513','9.99','2005-06-15T22:53:30.000','2006-02-15T22:17:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9946','368','1','2531','4.99','2005-06-19T01:20:49.000','2006-02-15T22:17:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9947','368','1','2694','4.99','2005-06-19T13:17:21.000','2006-02-15T22:17:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9948','368','1','2744','4.99','2005-06-19T16:20:40.000','2006-02-15T22:17:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9949','368','2','3275','4.99','2005-06-21T05:33:04.000','2006-02-15T22:17:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9950','368','2','3608','4.99','2005-07-06T05:35:39.000','2006-02-15T22:17:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9951','368','2','4066','0.99','2005-07-07T04:34:09.000','2006-02-15T22:17:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9952','368','1','4584','0.99','2005-07-08T06:11:02.000','2006-02-15T22:17:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9953','368','2','4913','8.99','2005-07-08T21:27:48.000','2006-02-15T22:17:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9954','368','1','6124','4.99','2005-07-11T08:02:32.000','2006-02-15T22:17:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9955','368','1','6154','5.99','2005-07-11T09:32:19.000','2006-02-15T22:17:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9956','368','1','6681','2.99','2005-07-12T12:04:12.000','2006-02-15T22:17:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9957','368','2','7571','4.99','2005-07-27T22:43:42.000','2006-02-15T22:17:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9958','368','1','8045','0.99','2005-07-28T16:49:38.000','2006-02-15T22:17:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9959','368','2','8226','2.99','2005-07-29T00:01:04.000','2006-02-15T22:17:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9960','368','1','9400','5.99','2005-07-30T20:15:58.000','2006-02-15T22:17:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9961','368','1','9833','6.99','2005-07-31T12:05:01.000','2006-02-15T22:17:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9962','368','2','10730','8.99','2005-08-01T19:21:42.000','2006-02-15T22:17:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9963','368','2','10848','1.99','2005-08-01T23:50:22.000','2006-02-15T22:17:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9964','368','1','11844','0.99','2005-08-17T13:16:04.000','2006-02-15T22:17:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9965','368','2','12319','2.99','2005-08-18T06:26:45.000','2006-02-15T22:17:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9966','368','1','12796','4.99','2005-08-19T00:22:24.000','2006-02-15T22:17:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9967','368','2','13189','8.99','2005-08-19T14:27:16.000','2006-02-15T22:17:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9968','368','2','13280','2.99','2005-08-19T18:02:51.000','2006-02-15T22:17:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9969','368','2','13378','0.99','2005-08-19T21:33:35.000','2006-02-15T22:17:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9970','368','2','13781','7.99','2005-08-20T12:06:45.000','2006-02-15T22:17:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9971','368','2','13963','1.99','2005-08-20T18:20:18.000','2006-02-15T22:17:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9972','368','1','14393','7.99','2005-08-21T10:22:51.000','2006-02-15T22:17:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9973','368','1','15353','2.99','2005-08-22T21:18:08.000','2006-02-15T22:17:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9974','368','1','15437','2.99','2005-08-23T00:31:09.000','2006-02-15T22:17:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9975','369','1','31','4.99','2005-05-25T04:05:17.000','2006-02-15T22:17:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9976','369','1','294','4.99','2005-05-26T20:29:57.000','2006-02-15T22:17:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9977','369','2','854','0.99','2005-05-30T01:56:11.000','2006-02-15T22:17:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9978','369','2','913','7.99','2005-05-30T11:04:58.000','2006-02-15T22:17:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9979','369','1','1224','0.99','2005-06-15T03:44:25.000','2006-02-15T22:17:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9980','369','1','3490','6.99','2005-07-05T23:37:13.000','2006-02-15T22:17:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9981','369','2','3903','2.99','2005-07-06T19:27:32.000','2006-02-15T22:17:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9982','369','2','4859','4.99','2005-07-08T18:54:04.000','2006-02-15T22:17:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9983','369','1','5043','1.99','2005-07-09T03:25:18.000','2006-02-15T22:17:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9984','369','2','5496','7.99','2005-07-10T00:20:23.000','2006-02-15T22:17:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9985','369','2','5561','2.99','2005-07-10T03:15:24.000','2006-02-15T22:17:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9986','369','1','8236','2.99','2005-07-29T00:27:04.000','2006-02-15T22:17:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9987','369','2','8826','2.99','2005-07-29T22:30:16.000','2006-02-15T22:17:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9988','369','2','9032','4.99','2005-07-30T06:06:54.000','2006-02-15T22:17:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9989','369','1','9089','0.99','2005-07-30T08:23:39.000','2006-02-15T22:17:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9990','369','2','9543','0.99','2005-07-31T01:43:34.000','2006-02-15T22:17:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9991','369','1','9973','4.99','2005-07-31T16:49:31.000','2006-02-15T22:17:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9992','369','1','10299','0.99','2005-08-01T04:08:04.000','2006-02-15T22:17:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9993','369','2','10359','3.99','2005-08-01T05:52:21.000','2006-02-15T22:17:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9994','369','2','10713','2.99','2005-08-01T18:50:05.000','2006-02-15T22:17:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9995','369','1','11084','4.99','2005-08-02T07:34:19.000','2006-02-15T22:17:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9996','369','2','11388','1.99','2005-08-02T18:35:55.000','2006-02-15T22:17:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9997','369','1','12521','0.99','2005-08-18T13:43:07.000','2006-02-15T22:17:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9998','369','2','14684','5.99','2005-08-21T20:28:26.000','2006-02-15T22:17:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('9999','369','1','13898','0.99','2006-02-14T15:16:03.000','2006-02-15T22:17:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10000','370','2','1190','6.99','2005-06-15T01:05:32.000','2006-02-15T22:17:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10001','370','2','4400','7.99','2005-07-07T21:22:26.000','2006-02-15T22:17:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10002','370','2','6714','0.99','2005-07-12T13:29:06.000','2006-02-15T22:17:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10003','370','1','6968','0.99','2005-07-27T00:16:45.000','2006-02-15T22:17:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10004','370','2','7152','7.99','2005-07-27T07:15:01.000','2006-02-15T22:17:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10005','370','1','7226','6.99','2005-07-27T09:47:53.000','2006-02-15T22:17:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10006','370','2','7797','0.99','2005-07-28T07:41:07.000','2006-02-15T22:17:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10007','370','2','8258','0.99','2005-07-29T01:03:42.000','2006-02-15T22:17:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10008','370','2','10095','0.99','2005-07-31T20:38:35.000','2006-02-15T22:17:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10009','370','1','10336','4.99','2005-08-01T04:59:53.000','2006-02-15T22:17:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10010','370','1','11540','1.99','2005-08-17T00:48:03.000','2006-02-15T22:17:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10011','370','2','11925','0.99','2005-08-17T16:23:04.000','2006-02-15T22:17:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10012','370','1','12339','4.99','2005-08-18T07:05:06.000','2006-02-15T22:17:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10013','370','1','13039','0.99','2005-08-19T08:55:19.000','2006-02-15T22:17:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10014','370','1','14602','3.99','2005-08-21T17:48:49.000','2006-02-15T22:17:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10015','370','2','14786','2.99','2005-08-22T00:24:42.000','2006-02-15T22:17:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10016','370','2','15368','3.99','2005-08-22T21:57:15.000','2006-02-15T22:17:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10017','370','1','15626','4.99','2005-08-23T07:25:34.000','2006-02-15T22:17:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10018','370','1','15982','5.99','2005-08-23T20:13:31.000','2006-02-15T22:17:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10019','371','1','26','3.99','2005-05-25T03:36:50.000','2006-02-15T22:17:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10020','371','2','286','6.99','2005-05-26T19:44:51.000','2006-02-15T22:17:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10021','371','2','381','4.99','2005-05-27T09:43:25.000','2006-02-15T22:17:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10022','371','1','384','5.99','2005-05-27T10:18:20.000','2006-02-15T22:17:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10023','371','1','825','0.99','2005-05-29T21:49:41.000','2006-02-15T22:17:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10024','371','1','829','2.99','2005-05-29T22:16:42.000','2006-02-15T22:17:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10025','371','2','1212','2.99','2005-06-15T03:03:33.000','2006-02-15T22:17:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10026','371','1','1218','1.99','2005-06-15T03:24:44.000','2006-02-15T22:17:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10027','371','1','1573','6.99','2005-06-16T03:31:39.000','2006-02-15T22:17:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10028','371','2','1675','5.99','2005-06-16T11:04:47.000','2006-02-15T22:17:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10029','371','2','2837','0.99','2005-06-19T22:03:50.000','2006-02-15T22:17:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10030','371','1','3176','3.99','2005-06-20T22:31:54.000','2006-02-15T22:17:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10031','371','2','3396','0.99','2005-06-21T15:23:08.000','2006-02-15T22:17:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10032','371','2','4115','8.99','2005-07-07T06:52:23.000','2006-02-15T22:17:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10033','371','1','4612','1.99','2005-07-08T07:40:44.000','2006-02-15T22:17:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10034','371','1','5171','4.99','2005-07-09T09:26:55.000','2006-02-15T22:17:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10035','371','2','5614','0.99','2005-07-10T05:16:56.000','2006-02-15T22:17:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10036','371','1','6000','2.99','2005-07-11T01:23:06.000','2006-02-15T22:17:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10037','371','1','6460','1.99','2005-07-12T01:13:44.000','2006-02-15T22:17:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10038','371','1','6922','0.99','2005-07-12T22:39:48.000','2006-02-15T22:17:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10039','371','1','7408','3.99','2005-07-27T16:31:40.000','2006-02-15T22:17:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10040','371','1','8138','4.99','2005-07-28T20:12:17.000','2006-02-15T22:17:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10041','371','1','9008','4.99','2005-07-30T05:10:26.000','2006-02-15T22:17:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10042','371','1','9117','8.99','2005-07-30T09:20:59.000','2006-02-15T22:17:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10043','371','1','9635','0.99','2005-07-31T05:12:27.000','2006-02-15T22:17:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10044','371','1','11086','10.99','2005-08-02T07:38:44.000','2006-02-15T22:17:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10045','371','2','12397','9.99','2005-08-18T09:12:52.000','2006-02-15T22:17:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10046','371','2','12584','7.99','2005-08-18T15:51:36.000','2006-02-15T22:17:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10047','371','1','13028','2.99','2005-08-19T08:27:23.000','2006-02-15T22:17:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10048','371','2','13143','3.99','2005-08-19T12:44:38.000','2006-02-15T22:17:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10049','371','1','13191','4.99','2005-08-19T14:28:48.000','2006-02-15T22:17:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10050','371','2','13953','4.99','2005-08-20T18:00:37.000','2006-02-15T22:17:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10051','371','1','14384','2.99','2005-08-21T10:02:37.000','2006-02-15T22:17:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10052','371','1','15786','0.99','2005-08-23T13:48:34.000','2006-02-15T22:17:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10053','371','1','15824','2.99','2005-08-23T15:09:17.000','2006-02-15T22:17:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10054','372','1','617','2.99','2005-05-28T15:49:14.000','2006-02-15T22:17:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10055','372','1','638','2.99','2005-05-28T18:24:43.000','2006-02-15T22:17:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10056','372','1','2315','2.99','2005-06-18T09:03:39.000','2006-02-15T22:17:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10057','372','1','2959','4.99','2005-06-20T07:07:54.000','2006-02-15T22:17:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10058','372','1','3283','3.99','2005-06-21T06:19:07.000','2006-02-15T22:17:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10059','372','1','5229','4.99','2005-07-09T12:30:18.000','2006-02-15T22:17:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10060','372','1','5314','2.99','2005-07-09T16:05:28.000','2006-02-15T22:17:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10061','372','1','5352','2.99','2005-07-09T17:54:58.000','2006-02-15T22:17:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10062','372','1','5501','6.99','2005-07-10T00:33:48.000','2006-02-15T22:17:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10063','372','2','5914','7.99','2005-07-10T21:01:12.000','2006-02-15T22:17:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10064','372','2','6692','4.99','2005-07-12T12:35:39.000','2006-02-15T22:17:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10065','372','1','7190','4.99','2005-07-27T08:36:01.000','2006-02-15T22:17:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10066','372','2','7234','5.99','2005-07-27T10:08:45.000','2006-02-15T22:17:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10067','372','2','7735','4.99','2005-07-28T05:09:56.000','2006-02-15T22:17:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10068','372','2','8009','7.99','2005-07-28T15:25:58.000','2006-02-15T22:17:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10069','372','1','8059','2.99','2005-07-28T17:09:59.000','2006-02-15T22:17:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10070','372','1','8358','0.99','2005-07-29T05:00:58.000','2006-02-15T22:17:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10071','372','1','8724','0.99','2005-07-29T18:05:21.000','2006-02-15T22:17:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10072','372','1','8755','2.99','2005-07-29T19:18:31.000','2006-02-15T22:17:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10073','372','2','8837','8.99','2005-07-29T22:49:00.000','2006-02-15T22:17:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10074','372','1','9128','5.99','2005-07-30T09:51:14.000','2006-02-15T22:17:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10075','372','2','11134','10.99','2005-08-02T09:19:22.000','2006-02-15T22:17:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10076','372','2','11438','3.99','2005-08-02T20:21:08.000','2006-02-15T22:17:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10077','372','2','11555','4.99','2005-08-17T01:08:59.000','2006-02-15T22:17:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10078','372','1','12224','0.99','2005-08-18T02:59:09.000','2006-02-15T22:17:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10079','372','1','12714','3.99','2005-08-18T21:08:01.000','2006-02-15T22:17:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10080','372','2','13402','4.99','2005-08-19T22:16:53.000','2006-02-15T22:17:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10081','372','2','13871','8.99','2005-08-20T15:10:13.000','2006-02-15T22:17:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10082','372','2','14037','9.99','2005-08-20T21:35:58.000','2006-02-15T22:17:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10083','372','1','14211','4.99','2005-08-21T04:29:11.000','2006-02-15T22:17:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10084','372','1','14331','2.99','2005-08-21T08:29:38.000','2006-02-15T22:17:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10085','372','1','14770','1.99','2005-08-21T23:47:16.000','2006-02-15T22:17:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10086','372','2','15041','0.99','2005-08-22T09:43:18.000','2006-02-15T22:17:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10087','372','1','15563','2.99','2005-08-23T05:08:58.000','2006-02-15T22:17:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10088','373','2','257','4.99','2005-05-26T15:27:05.000','2006-02-15T22:17:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10089','373','1','1472','6.99','2005-06-15T20:54:55.000','2006-02-15T22:17:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10090','373','1','3161','2.99','2005-06-20T21:21:01.000','2006-02-15T22:17:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10091','373','2','3609','2.99','2005-07-06T05:36:22.000','2006-02-15T22:17:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10092','373','2','3667','4.99','2005-07-06T08:36:34.000','2006-02-15T22:17:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10093','373','1','4325','7.99','2005-07-07T17:59:24.000','2006-02-15T22:17:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10094','373','1','5120','5.99','2005-07-09T07:14:23.000','2006-02-15T22:17:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10095','373','1','6202','3.99','2005-07-11T12:24:25.000','2006-02-15T22:17:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10096','373','2','6311','0.99','2005-07-11T18:18:52.000','2006-02-15T22:17:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10097','373','1','6944','4.99','2005-07-26T23:34:02.000','2006-02-15T22:17:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10098','373','1','7094','0.99','2005-07-27T04:47:33.000','2006-02-15T22:17:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10099','373','2','7206','3.99','2005-07-27T09:07:05.000','2006-02-15T22:17:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10100','373','1','7615','0.99','2005-07-28T00:15:24.000','2006-02-15T22:17:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10101','373','1','8611','3.99','2005-07-29T13:26:21.000','2006-02-15T22:17:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10102','373','2','9327','8.99','2005-07-30T17:31:03.000','2006-02-15T22:17:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10103','373','1','9397','4.99','2005-07-30T20:07:29.000','2006-02-15T22:17:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10104','373','2','9480','0.99','2005-07-30T23:26:03.000','2006-02-15T22:17:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10105','373','1','9966','4.99','2005-07-31T16:26:46.000','2006-02-15T22:17:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10106','373','1','10010','6.99','2005-07-31T18:01:36.000','2006-02-15T22:17:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10107','373','1','10221','4.99','2005-08-01T01:16:50.000','2006-02-15T22:17:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10108','373','1','10758','5.99','2005-08-01T20:22:51.000','2006-02-15T22:17:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10109','373','2','11066','7.99','2005-08-02T06:58:32.000','2006-02-15T22:17:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10110','373','2','11512','7.99','2005-08-16T23:51:06.000','2006-02-15T22:17:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10111','373','2','11663','3.99','2005-08-17T05:30:19.000','2006-02-15T22:17:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10112','373','2','11976','3.99','2005-08-17T17:59:19.000','2006-02-15T22:17:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10113','373','1','12142','5.99','2005-08-18T00:04:12.000','2006-02-15T22:17:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10114','373','2','12536','5.99','2005-08-18T14:06:06.000','2006-02-15T22:17:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10115','373','1','12748','7.99','2005-08-18T22:29:05.000','2006-02-15T22:17:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10116','373','2','12780','0.99','2005-08-18T23:48:16.000','2006-02-15T22:17:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10117','373','2','13299','2.99','2005-08-19T18:46:33.000','2006-02-15T22:17:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10118','373','1','13329','3.99','2005-08-19T19:56:55.000','2006-02-15T22:17:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10119','373','2','13467','2.99','2005-08-20T00:56:44.000','2006-02-15T22:17:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10120','373','2','15014','6.99','2005-08-22T08:43:11.000','2006-02-15T22:17:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10121','373','1','15068','3.99','2005-08-22T10:50:13.000','2006-02-15T22:17:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10122','373','1','11739','0.99','2006-02-14T15:16:03.000','2006-02-15T22:17:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10123','374','1','521','0.99','2005-05-28T03:32:22.000','2006-02-15T22:17:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10124','374','2','910','2.99','2005-05-30T10:46:16.000','2006-02-15T22:17:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10125','374','2','919','0.99','2005-05-30T11:35:06.000','2006-02-15T22:17:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10126','374','1','1548','1.99','2005-06-16T01:43:33.000','2006-02-15T22:17:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10127','374','2','2046','1.99','2005-06-17T14:39:50.000','2006-02-15T22:17:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10128','374','2','2487','4.99','2005-06-18T21:32:54.000','2006-02-15T22:17:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10129','374','2','2641','2.99','2005-06-19T09:38:33.000','2006-02-15T22:17:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10130','374','1','3797','1.99','2005-07-06T14:54:52.000','2006-02-15T22:17:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10131','374','1','5463','4.99','2005-07-09T22:57:02.000','2006-02-15T22:17:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10132','374','1','5570','6.99','2005-07-10T03:46:47.000','2006-02-15T22:17:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10133','374','2','5591','3.99','2005-07-10T04:25:03.000','2006-02-15T22:17:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10134','374','2','5945','2.99','2005-07-10T22:52:42.000','2006-02-15T22:17:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10135','374','2','6315','0.99','2005-07-11T18:42:49.000','2006-02-15T22:17:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10136','374','2','7837','0.99','2005-07-28T08:58:32.000','2006-02-15T22:17:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10137','374','2','8586','7.99','2005-07-29T12:16:34.000','2006-02-15T22:17:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10138','374','2','9113','0.99','2005-07-30T09:09:03.000','2006-02-15T22:17:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10139','374','1','9866','6.99','2005-07-31T13:13:50.000','2006-02-15T22:17:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10140','374','1','10695','2.99','2005-08-01T18:16:20.000','2006-02-15T22:17:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10141','374','1','11619','0.99','2005-08-17T04:03:26.000','2006-02-15T22:17:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10142','374','2','12696','2.99','2005-08-18T20:13:08.000','2006-02-15T22:17:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10143','374','1','13337','2.99','2005-08-19T20:06:57.000','2006-02-15T22:17:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10144','374','2','13734','4.99','2005-08-20T10:29:57.000','2006-02-15T22:17:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10145','374','2','14524','8.99','2005-08-21T15:05:27.000','2006-02-15T22:17:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10146','374','2','15053','5.99','2005-08-22T10:13:09.000','2006-02-15T22:17:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10147','374','1','15200','2.99','2005-08-22T16:22:53.000','2006-02-15T22:17:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10148','374','2','15202','4.99','2005-08-22T16:26:53.000','2006-02-15T22:17:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10149','374','2','15366','6.99','2005-08-22T21:45:57.000','2006-02-15T22:17:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10150','374','2','15966','2.99','2006-02-14T15:16:03.000','2006-02-15T22:17:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10151','375','2','307','8.99','2005-05-26T21:48:13.000','2006-02-15T22:17:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10152','375','1','412','4.99','2005-05-27T14:17:23.000','2006-02-15T22:17:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10153','375','2','749','4.99','2005-05-29T09:33:33.000','2006-02-15T22:17:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10154','375','1','873','2.99','2005-05-30T05:15:20.000','2006-02-15T22:17:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10155','375','2','1404','2.99','2005-06-15T16:38:53.000','2006-02-15T22:17:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10156','375','1','1499','5.99','2005-06-15T21:58:07.000','2006-02-15T22:17:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10157','375','1','2236','4.99','2005-06-18T04:12:33.000','2006-02-15T22:17:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10158','375','1','3981','6.99','2005-07-06T23:12:12.000','2006-02-15T22:17:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10159','375','2','4335','4.99','2005-07-07T18:33:57.000','2006-02-15T22:17:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10160','375','2','5474','2.99','2005-07-09T23:23:57.000','2006-02-15T22:17:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10161','375','1','7856','4.99','2005-07-28T09:48:24.000','2006-02-15T22:17:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10162','375','2','8900','2.99','2005-07-30T01:07:03.000','2006-02-15T22:17:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10163','375','1','10274','0.99','2005-08-01T03:16:51.000','2006-02-15T22:17:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10164','375','2','10589','1.99','2005-08-01T14:11:09.000','2006-02-15T22:17:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10165','375','1','10640','0.99','2005-08-01T15:44:51.000','2006-02-15T22:17:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10166','375','1','10672','4.99','2005-08-01T17:10:54.000','2006-02-15T22:17:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10167','375','1','10859','5.99','2005-08-02T00:11:39.000','2006-02-15T22:17:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10168','375','1','10961','6.99','2005-08-02T03:47:55.000','2006-02-15T22:17:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10169','375','2','11008','5.99','2005-08-02T05:06:17.000','2006-02-15T22:17:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10170','375','2','12122','9.99','2005-08-17T23:20:45.000','2006-02-15T22:17:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10171','375','2','12663','0.99','2005-08-18T19:10:52.000','2006-02-15T22:17:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10172','375','1','13836','4.99','2005-08-20T14:18:16.000','2006-02-15T22:17:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10173','375','1','15004','2.99','2005-08-22T08:15:21.000','2006-02-15T22:17:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10174','375','1','15505','4.99','2005-08-23T02:46:13.000','2006-02-15T22:17:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10175','376','1','554','0.99','2005-05-28T08:23:16.000','2006-02-15T22:17:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10176','376','2','1208','0.99','2005-06-15T02:30:03.000','2006-02-15T22:17:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10177','376','1','2779','0.99','2005-06-19T18:19:07.000','2006-02-15T22:17:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10178','376','2','3719','2.99','2005-07-06T11:05:55.000','2006-02-15T22:17:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10179','376','1','4163','0.99','2005-07-07T09:19:28.000','2006-02-15T22:17:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10180','376','2','4166','8.99','2005-07-07T09:33:30.000','2006-02-15T22:17:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10181','376','1','4320','3.99','2005-07-07T17:51:59.000','2006-02-15T22:17:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10182','376','1','4554','5.99','2005-07-08T04:48:03.000','2006-02-15T22:17:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10183','376','1','4869','4.99','2005-07-08T19:14:05.000','2006-02-15T22:17:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10184','376','1','5675','4.99','2005-07-10T08:31:06.000','2006-02-15T22:17:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10185','376','1','6524','6.99','2005-07-12T04:14:35.000','2006-02-15T22:17:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10186','376','1','6545','8.99','2005-07-12T04:56:30.000','2006-02-15T22:17:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10187','376','2','6807','2.99','2005-07-12T17:33:53.000','2006-02-15T22:17:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10188','376','1','8269','2.99','2005-07-29T01:26:54.000','2006-02-15T22:17:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10189','376','1','8420','5.99','2005-07-29T07:00:45.000','2006-02-15T22:17:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10190','376','1','9773','4.99','2005-07-31T09:56:56.000','2006-02-15T22:17:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10191','376','1','9828','2.99','2005-07-31T11:56:57.000','2006-02-15T22:17:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10192','376','1','9872','0.99','2005-07-31T13:27:55.000','2006-02-15T22:17:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10193','376','2','10413','3.99','2005-08-01T07:59:39.000','2006-02-15T22:17:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10194','376','1','10810','3.99','2005-08-01T22:40:39.000','2006-02-15T22:17:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10195','376','1','11144','4.99','2005-08-02T09:39:17.000','2006-02-15T22:17:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10196','376','2','11792','4.99','2005-08-17T11:03:53.000','2006-02-15T22:17:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10197','376','1','11851','4.99','2005-08-17T13:30:27.000','2006-02-15T22:17:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10198','376','1','13009','0.99','2005-08-19T07:50:35.000','2006-02-15T22:17:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10199','376','1','13141','0.99','2005-08-19T12:41:41.000','2006-02-15T22:17:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10200','376','2','13761','4.99','2005-08-20T11:28:50.000','2006-02-15T22:17:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10201','376','1','15107','4.99','2005-08-22T12:05:02.000','2006-02-15T22:17:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10202','376','1','15382','2.99','2005-08-22T22:30:50.000','2006-02-15T22:17:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10203','377','2','2556','3.99','2005-06-19T03:07:32.000','2006-02-15T22:17:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10204','377','1','3080','1.99','2005-06-20T15:22:32.000','2006-02-15T22:17:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10205','377','2','3086','0.99','2005-06-20T15:42:40.000','2006-02-15T22:17:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10206','377','2','3136','2.99','2005-06-20T19:39:08.000','2006-02-15T22:17:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10207','377','2','3443','4.99','2005-06-21T20:19:00.000','2006-02-15T22:17:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10208','377','1','3858','2.99','2005-07-06T17:17:57.000','2006-02-15T22:17:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10209','377','2','4053','0.99','2005-07-07T03:39:22.000','2006-02-15T22:17:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10210','377','1','4077','0.99','2005-07-07T04:53:40.000','2006-02-15T22:17:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10211','377','1','4225','0.99','2005-07-07T12:24:37.000','2006-02-15T22:17:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10212','377','2','6893','7.99','2005-07-12T21:20:11.000','2006-02-15T22:17:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10213','377','1','7697','1.99','2005-07-28T03:43:45.000','2006-02-15T22:17:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10214','377','2','8018','10.99','2005-07-28T15:36:48.000','2006-02-15T22:17:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10215','377','2','8916','4.99','2005-07-30T01:42:21.000','2006-02-15T22:17:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10216','377','2','9461','3.99','2005-07-30T22:29:13.000','2006-02-15T22:17:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10217','377','1','9564','0.99','2005-07-31T02:31:37.000','2006-02-15T22:17:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10218','377','1','10013','4.99','2005-07-31T18:08:21.000','2006-02-15T22:17:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10219','377','1','10183','8.99','2005-08-01T00:08:01.000','2006-02-15T22:17:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10220','377','1','10738','3.99','2005-08-01T19:39:08.000','2006-02-15T22:17:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10221','377','1','10943','2.99','2005-08-02T03:17:29.000','2006-02-15T22:17:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10222','377','1','12390','1.99','2005-08-18T08:51:42.000','2006-02-15T22:17:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10223','377','1','12549','4.99','2005-08-18T14:38:07.000','2006-02-15T22:17:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10224','377','1','13249','2.99','2005-08-19T16:47:41.000','2006-02-15T22:17:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10225','377','1','13275','0.99','2005-08-19T17:53:38.000','2006-02-15T22:17:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10226','377','2','15088','0.99','2005-08-22T11:28:26.000','2006-02-15T22:17:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10227','377','1','15995','0.99','2005-08-23T20:29:56.000','2006-02-15T22:17:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10228','377','1','15999','7.99','2005-08-23T20:44:10.000','2006-02-15T22:17:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10229','378','1','347','0.99','2005-05-27T04:40:33.000','2006-02-15T22:17:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10230','378','2','1623','4.99','2005-06-16T07:48:50.000','2006-02-15T22:17:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10231','378','1','1662','5.99','2005-06-16T10:13:35.000','2006-02-15T22:17:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10232','378','2','2134','7.99','2005-06-17T21:13:44.000','2006-02-15T22:17:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10233','378','2','2713','4.99','2005-06-19T14:23:09.000','2006-02-15T22:17:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10234','378','1','3759','4.99','2005-07-06T12:46:38.000','2006-02-15T22:17:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10235','378','2','4755','0.99','2005-07-08T14:23:41.000','2006-02-15T22:17:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10236','378','1','5578','1.99','2005-07-10T04:00:31.000','2006-02-15T22:17:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10237','378','2','6233','1.99','2005-07-11T14:10:47.000','2006-02-15T22:17:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10238','378','1','7888','0.99','2005-07-28T10:40:24.000','2006-02-15T22:17:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10239','378','2','8740','2.99','2005-07-29T18:41:31.000','2006-02-15T22:17:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10240','378','2','9668','3.99','2005-07-31T06:31:03.000','2006-02-15T22:17:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10241','378','1','9868','2.99','2005-07-31T13:20:08.000','2006-02-15T22:17:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10242','378','1','10917','4.99','2005-08-02T02:06:18.000','2006-02-15T22:17:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10243','378','1','11111','4.99','2005-08-02T08:21:27.000','2006-02-15T22:17:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10244','378','1','12596','2.99','2005-08-18T16:29:35.000','2006-02-15T22:17:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10245','378','1','12828','4.99','2005-08-19T01:37:47.000','2006-02-15T22:17:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10246','378','2','14502','4.99','2005-08-21T14:22:28.000','2006-02-15T22:17:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10247','378','1','14971','2.99','2005-08-22T06:52:49.000','2006-02-15T22:17:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10248','379','2','209','4.99','2005-05-26T08:14:01.000','2006-02-15T22:17:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10249','379','1','863','4.99','2005-05-30T03:14:59.000','2006-02-15T22:17:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10250','379','1','1383','8.99','2005-06-15T15:20:06.000','2006-02-15T22:17:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10251','379','1','2313','5.99','2005-06-18T08:56:45.000','2006-02-15T22:17:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10252','379','1','2926','2.99','2005-06-20T04:37:45.000','2006-02-15T22:17:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10253','379','1','3788','4.99','2005-07-06T14:02:02.000','2006-02-15T22:17:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10254','379','2','4740','2.99','2005-07-08T13:30:35.000','2006-02-15T22:17:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10255','379','1','5402','4.99','2005-07-09T20:01:58.000','2006-02-15T22:17:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10256','379','1','6235','7.99','2005-07-11T14:17:51.000','2006-02-15T22:17:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10257','379','2','7041','4.99','2005-07-27T03:18:32.000','2006-02-15T22:17:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10258','379','1','10041','4.99','2005-07-31T19:01:02.000','2006-02-15T22:17:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10259','379','2','11457','3.99','2005-08-02T21:14:16.000','2006-02-15T22:17:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10260','379','1','12503','4.99','2005-08-18T13:16:46.000','2006-02-15T22:17:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10261','379','1','13334','0.99','2005-08-19T20:02:33.000','2006-02-15T22:17:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10262','379','2','13397','7.99','2005-08-19T22:06:35.000','2006-02-15T22:17:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10263','379','1','13485','0.99','2005-08-20T01:20:14.000','2006-02-15T22:17:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10264','379','1','14011','5.99','2005-08-20T20:32:56.000','2006-02-15T22:17:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10265','379','2','14152','2.99','2005-08-21T02:23:50.000','2006-02-15T22:17:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10266','379','1','14470','0.99','2005-08-21T13:09:41.000','2006-02-15T22:17:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10267','379','1','14886','4.99','2005-08-22T03:59:01.000','2006-02-15T22:17:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10268','379','2','15399','4.99','2005-08-22T23:11:59.000','2006-02-15T22:17:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10269','379','1','15446','4.99','2005-08-23T00:49:24.000','2006-02-15T22:17:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10270','379','2','15930','3.99','2005-08-23T18:26:51.000','2006-02-15T22:17:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10271','380','1','847','3.99','2005-05-30T01:18:15.000','2006-02-15T22:17:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10272','380','1','1868','3.99','2005-06-17T02:03:22.000','2006-02-15T22:17:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10273','380','1','1984','2.99','2005-06-17T10:25:28.000','2006-02-15T22:17:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10274','380','1','2018','3.99','2005-06-17T12:35:58.000','2006-02-15T22:17:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10275','380','1','2440','2.99','2005-06-18T18:41:09.000','2006-02-15T22:17:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10276','380','1','2464','4.99','2005-06-18T20:06:05.000','2006-02-15T22:17:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10277','380','2','2998','1.99','2005-06-20T09:30:22.000','2006-02-15T22:17:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10278','380','2','3099','1.99','2005-06-20T16:44:33.000','2006-02-15T22:17:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10279','380','1','3260','4.99','2005-06-21T03:59:13.000','2006-02-15T22:17:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10280','380','1','3637','2.99','2005-07-06T07:06:31.000','2006-02-15T22:17:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10281','380','1','3688','4.99','2005-07-06T09:41:53.000','2006-02-15T22:17:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10282','380','1','4675','2.99','2005-07-08T10:24:22.000','2006-02-15T22:17:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10283','380','2','4706','4.99','2005-07-08T11:51:41.000','2006-02-15T22:17:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10284','380','2','5339','0.99','2005-07-09T17:09:17.000','2006-02-15T22:17:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10285','380','2','7021','8.99','2005-07-27T02:26:38.000','2006-02-15T22:17:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10286','380','2','7167','2.99','2005-07-27T07:37:26.000','2006-02-15T22:17:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10287','380','2','7435','0.99','2005-07-27T17:38:44.000','2006-02-15T22:17:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10288','380','2','7443','2.99','2005-07-27T17:47:43.000','2006-02-15T22:17:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10289','380','1','7773','2.99','2005-07-28T07:02:17.000','2006-02-15T22:17:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10290','380','1','7974','3.99','2005-07-28T14:11:57.000','2006-02-15T22:17:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10291','380','1','9056','0.99','2005-07-30T07:13:20.000','2006-02-15T22:17:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10292','380','1','9261','6.99','2005-07-30T14:39:35.000','2006-02-15T22:17:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10293','380','1','9710','10.99','2005-07-31T08:05:31.000','2006-02-15T22:17:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10294','380','2','10450','1.99','2005-08-01T09:10:03.000','2006-02-15T22:17:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10295','380','1','10983','3.99','2005-08-02T04:24:23.000','2006-02-15T22:17:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10296','380','1','11936','0.99','2005-08-17T16:45:34.000','2006-02-15T22:17:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10297','380','2','11945','0.99','2005-08-17T17:05:33.000','2006-02-15T22:17:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10298','380','1','12636','3.99','2005-08-18T18:00:29.000','2006-02-15T22:17:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10299','380','1','12996','6.99','2005-08-19T07:31:32.000','2006-02-15T22:17:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10300','380','1','14529','6.99','2005-08-21T15:08:31.000','2006-02-15T22:17:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10301','380','1','14935','1.99','2005-08-22T05:47:31.000','2006-02-15T22:17:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10302','380','2','15175','5.99','2005-08-22T15:29:15.000','2006-02-15T22:17:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10303','380','1','15361','2.99','2005-08-22T21:39:45.000','2006-02-15T22:17:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10304','380','2','15636','2.99','2005-08-23T07:50:46.000','2006-02-15T22:17:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10305','380','1','15697','2.99','2005-08-23T10:04:36.000','2006-02-15T22:17:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10306','380','2','15748','2.99','2005-08-23T12:33:00.000','2006-02-15T22:17:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10307','381','2','169','0.99','2005-05-26T03:09:30.000','2006-02-15T22:17:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10308','381','2','406','2.99','2005-05-27T13:46:46.000','2006-02-15T22:17:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10309','381','1','835','2.99','2005-05-29T23:37:00.000','2006-02-15T22:17:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10310','381','1','1402','3.99','2005-06-15T16:31:08.000','2006-02-15T22:17:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10311','381','1','1878','1.99','2005-06-17T02:55:32.000','2006-02-15T22:17:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10312','381','2','2410','2.99','2005-06-18T16:55:08.000','2006-02-15T22:17:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10313','381','1','2418','4.99','2005-06-18T17:14:42.000','2006-02-15T22:17:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10314','381','2','3425','2.99','2005-06-21T18:07:07.000','2006-02-15T22:17:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10315','381','2','3812','0.99','2005-07-06T15:22:19.000','2006-02-15T22:17:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10316','381','2','3970','2.99','2005-07-06T22:48:17.000','2006-02-15T22:17:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10317','381','1','4735','0.99','2005-07-08T13:12:27.000','2006-02-15T22:17:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10318','381','2','5689','0.99','2005-07-10T09:24:17.000','2006-02-15T22:17:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10319','381','2','6116','2.99','2005-07-11T07:37:38.000','2006-02-15T22:17:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10320','381','2','6451','4.99','2005-07-12T00:52:19.000','2006-02-15T22:17:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10321','381','2','6778','2.99','2005-07-12T16:06:00.000','2006-02-15T22:17:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10322','381','1','7375','2.99','2005-07-27T15:22:33.000','2006-02-15T22:17:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10323','381','1','7645','2.99','2005-07-28T01:27:42.000','2006-02-15T22:17:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10324','381','2','8688','0.99','2005-07-29T16:31:32.000','2006-02-15T22:17:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10325','381','2','9144','0.99','2005-07-30T10:22:15.000','2006-02-15T22:17:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10326','381','2','9173','4.99','2005-07-30T11:40:10.000','2006-02-15T22:17:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10327','381','1','9822','2.99','2005-07-31T11:48:25.000','2006-02-15T22:17:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10328','381','2','10033','4.99','2005-07-31T18:44:29.000','2006-02-15T22:17:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10329','381','1','10608','0.99','2005-08-01T14:48:41.000','2006-02-15T22:17:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10330','381','2','10705','0.99','2005-08-01T18:38:54.000','2006-02-15T22:17:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10331','381','1','11519','2.99','2005-08-17T00:01:27.000','2006-02-15T22:17:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10332','381','2','12135','2.99','2005-08-17T23:50:24.000','2006-02-15T22:17:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10333','381','2','12237','4.99','2005-08-18T03:24:38.000','2006-02-15T22:17:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10334','381','2','12632','2.99','2005-08-18T17:54:21.000','2006-02-15T22:17:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10335','381','2','13202','8.99','2005-08-19T14:58:30.000','2006-02-15T22:17:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10336','381','2','13430','0.99','2005-08-19T23:25:43.000','2006-02-15T22:17:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10337','381','1','13614','0.99','2005-08-20T06:28:37.000','2006-02-15T22:17:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10338','381','2','13995','2.99','2005-08-20T19:34:43.000','2006-02-15T22:17:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10339','381','1','14198','4.99','2005-08-21T03:48:31.000','2006-02-15T22:17:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10340','381','2','15299','4.99','2005-08-22T19:42:57.000','2006-02-15T22:17:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10341','381','1','15747','4.99','2005-08-23T12:29:24.000','2006-02-15T22:17:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10342','382','2','356','2.99','2005-05-27T06:32:30.000','2006-02-15T22:17:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10343','382','1','522','2.99','2005-05-28T03:33:20.000','2006-02-15T22:17:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10344','382','1','2389','0.99','2005-06-18T15:27:47.000','2006-02-15T22:17:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10345','382','1','2468','4.99','2005-06-18T20:23:52.000','2006-02-15T22:17:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10346','382','1','2489','1.99','2005-06-18T22:00:44.000','2006-02-15T22:17:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10347','382','1','2514','2.99','2005-06-18T23:56:44.000','2006-02-15T22:17:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10348','382','2','3125','4.99','2005-06-20T18:31:58.000','2006-02-15T22:17:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10349','382','2','3480','3.99','2005-07-05T23:11:43.000','2006-02-15T22:17:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10350','382','2','4351','4.99','2005-07-07T19:04:24.000','2006-02-15T22:17:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10351','382','1','5004','4.99','2005-07-09T01:20:50.000','2006-02-15T22:17:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10352','382','1','5816','0.99','2005-07-10T15:48:47.000','2006-02-15T22:17:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10353','382','2','7625','0.99','2005-07-28T00:47:56.000','2006-02-15T22:17:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10354','382','2','8777','0.99','2005-07-29T20:10:21.000','2006-02-15T22:17:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10355','382','1','8871','9.99','2005-07-30T00:12:41.000','2006-02-15T22:17:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10356','382','1','8993','4.99','2005-07-30T04:51:25.000','2006-02-15T22:17:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10357','382','1','9067','6.99','2005-07-30T07:31:01.000','2006-02-15T22:17:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10358','382','2','9555','0.99','2005-07-31T02:11:16.000','2006-02-15T22:17:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10359','382','2','10327','3.99','2005-08-01T04:55:35.000','2006-02-15T22:17:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10360','382','2','12229','0.99','2005-08-18T03:08:23.000','2006-02-15T22:17:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10361','382','2','12529','0.99','2005-08-18T13:53:36.000','2006-02-15T22:17:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10362','382','1','14009','4.99','2005-08-20T20:26:53.000','2006-02-15T22:17:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10363','382','2','14300','4.99','2005-08-21T07:19:37.000','2006-02-15T22:17:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10364','382','2','14354','5.99','2005-08-21T09:08:14.000','2006-02-15T22:17:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10365','382','2','15939','7.99','2005-08-23T18:44:21.000','2006-02-15T22:17:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10366','383','2','63','0.99','2005-05-25T09:19:16.000','2006-02-15T22:17:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10367','383','1','766','8.99','2005-05-29T11:47:02.000','2006-02-15T22:17:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10368','383','1','1831','7.99','2005-06-16T22:22:17.000','2006-02-15T22:17:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10369','383','2','2228','2.99','2005-06-18T03:44:50.000','2006-02-15T22:17:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10370','383','1','2252','2.99','2005-06-18T05:05:18.000','2006-02-15T22:17:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10371','383','2','2318','2.99','2005-06-18T09:13:54.000','2006-02-15T22:17:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10372','383','1','2609','7.99','2005-06-19T07:13:12.000','2006-02-15T22:17:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10373','383','1','3091','2.99','2005-06-20T16:02:59.000','2006-02-15T22:17:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10374','383','2','4747','5.99','2005-07-08T13:53:01.000','2006-02-15T22:17:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10375','383','2','6091','4.99','2005-07-11T05:49:18.000','2006-02-15T22:17:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10376','383','2','6244','0.99','2005-07-11T14:53:38.000','2006-02-15T22:17:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10377','383','1','6775','4.99','2005-07-12T16:01:44.000','2006-02-15T22:17:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10378','383','1','7367','3.99','2005-07-27T15:05:45.000','2006-02-15T22:17:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10379','383','2','8367','2.99','2005-07-29T05:11:19.000','2006-02-15T22:17:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10380','383','1','8635','0.99','2005-07-29T14:22:48.000','2006-02-15T22:17:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10381','383','1','9653','0.99','2005-07-31T05:55:38.000','2006-02-15T22:17:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10382','383','1','9678','0.99','2005-07-31T06:40:47.000','2006-02-15T22:17:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10383','383','2','10515','4.99','2005-08-01T11:41:33.000','2006-02-15T22:17:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10384','383','1','10971','4.99','2005-08-02T04:08:17.000','2006-02-15T22:17:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10385','383','2','10993','0.99','2005-08-02T04:45:01.000','2006-02-15T22:17:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10386','383','2','11122','0.99','2005-08-02T08:49:09.000','2006-02-15T22:17:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10387','383','1','11592','2.99','2005-08-17T02:36:04.000','2006-02-15T22:17:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10388','383','1','12735','4.99','2005-08-18T22:04:54.000','2006-02-15T22:17:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10389','383','2','14039','4.99','2005-08-20T21:39:43.000','2006-02-15T22:17:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10390','383','2','14678','4.99','2005-08-21T20:12:43.000','2006-02-15T22:17:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10391','383','1','15416','1.99','2005-08-22T23:51:23.000','2006-02-15T22:17:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10392','383','1','15881','6.99','2005-08-23T16:44:25.000','2006-02-15T22:17:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10393','384','2','103','4.99','2005-05-25T17:30:42.000','2006-02-15T22:17:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10394','384','2','279','2.99','2005-05-26T18:02:50.000','2006-02-15T22:17:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10395','384','1','898','0.99','2005-05-30T09:26:19.000','2006-02-15T22:17:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10396','384','2','1013','2.99','2005-05-31T02:37:00.000','2006-02-15T22:17:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10397','384','1','1961','0.99','2005-06-17T09:02:58.000','2006-02-15T22:17:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10398','384','2','2020','0.99','2005-06-17T12:39:50.000','2006-02-15T22:17:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10399','384','1','2378','7.99','2005-06-18T14:57:49.000','2006-02-15T22:17:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10400','384','2','2510','5.99','2005-06-18T23:44:21.000','2006-02-15T22:17:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10401','384','2','2935','3.99','2005-06-20T05:07:24.000','2006-02-15T22:17:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10402','384','1','3088','9.99','2005-06-20T15:56:05.000','2006-02-15T22:17:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10403','384','2','3101','4.99','2005-06-20T16:48:58.000','2006-02-15T22:17:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10404','384','2','4424','0.99','2005-07-07T22:14:43.000','2006-02-15T22:17:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10405','384','2','5250','0.99','2005-07-09T13:35:32.000','2006-02-15T22:17:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10406','384','1','5608','4.99','2005-07-10T05:08:26.000','2006-02-15T22:17:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10407','384','2','5797','4.99','2005-07-10T14:43:52.000','2006-02-15T22:17:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10408','384','2','5966','2.99','2005-07-10T23:59:27.000','2006-02-15T22:17:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10409','384','2','6387','0.99','2005-07-11T22:15:56.000','2006-02-15T22:17:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10410','384','2','7799','0.99','2005-07-28T07:42:09.000','2006-02-15T22:17:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10411','384','1','8445','1.99','2005-07-29T07:37:48.000','2006-02-15T22:17:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10412','384','2','11773','5.99','2005-08-17T10:19:51.000','2006-02-15T22:17:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10413','384','2','13521','2.99','2005-08-20T02:42:28.000','2006-02-15T22:17:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10414','384','2','14416','2.99','2005-08-21T11:11:46.000','2006-02-15T22:17:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10415','384','1','14841','0.99','2005-08-22T02:03:30.000','2006-02-15T22:17:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10416','384','1','14963','5.99','2005-08-22T06:38:10.000','2006-02-15T22:17:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10417','384','2','15321','4.99','2005-08-22T20:20:04.000','2006-02-15T22:17:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10418','385','1','917','2.99','2005-05-30T11:27:06.000','2006-02-15T22:17:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10419','385','2','1038','4.99','2005-05-31T05:23:47.000','2006-02-15T22:17:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10420','385','1','1746','2.99','2005-06-16T16:41:19.000','2006-02-15T22:17:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10421','385','1','1937','0.99','2005-06-17T07:16:46.000','2006-02-15T22:17:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10422','385','1','3105','0.99','2005-06-20T17:11:46.000','2006-02-15T22:17:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10423','385','2','3878','8.99','2005-07-06T18:27:09.000','2006-02-15T22:17:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10424','385','2','3953','0.99','2005-07-06T21:54:55.000','2006-02-15T22:17:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10425','385','1','4714','6.99','2005-07-08T12:12:48.000','2006-02-15T22:17:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10426','385','1','5783','2.99','2005-07-10T13:55:33.000','2006-02-15T22:17:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10427','385','1','6445','4.99','2005-07-12T00:37:02.000','2006-02-15T22:17:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10428','385','2','6933','4.99','2005-07-26T23:09:23.000','2006-02-15T22:17:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10429','385','2','7776','0.99','2005-07-28T07:04:36.000','2006-02-15T22:17:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10430','385','1','8346','2.99','2005-07-29T04:48:22.000','2006-02-15T22:17:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10431','385','1','8518','2.99','2005-07-29T10:05:27.000','2006-02-15T22:17:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10432','385','1','9570','2.99','2005-07-31T02:40:37.000','2006-02-15T22:17:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10433','385','1','9704','4.99','2005-07-31T07:39:32.000','2006-02-15T22:17:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10434','385','1','10557','0.99','2005-08-01T12:59:24.000','2006-02-15T22:17:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10435','385','1','10636','3.99','2005-08-01T15:40:35.000','2006-02-15T22:17:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10436','385','1','10655','4.99','2005-08-01T16:33:27.000','2006-02-15T22:17:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10437','385','1','11021','2.99','2005-08-02T05:30:11.000','2006-02-15T22:17:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10438','385','1','11559','2.99','2005-08-17T01:20:26.000','2006-02-15T22:17:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10439','385','2','12310','2.99','2005-08-18T06:02:34.000','2006-02-15T22:17:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10440','385','2','12686','8.99','2005-08-18T19:55:09.000','2006-02-15T22:17:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10441','385','2','13062','7.99','2005-08-19T09:44:17.000','2006-02-15T22:17:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10442','385','1','13117','0.99','2005-08-19T11:33:20.000','2006-02-15T22:17:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10443','385','1','15488','6.99','2005-08-23T02:06:01.000','2006-02-15T22:17:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10444','386','1','583','7.99','2005-05-28T11:48:55.000','2006-02-15T22:17:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10445','386','2','1585','3.99','2005-06-16T04:51:13.000','2006-02-15T22:17:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10446','386','1','1608','2.99','2005-06-16T06:28:57.000','2006-02-15T22:17:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10447','386','2','1819','5.99','2005-06-16T21:32:50.000','2006-02-15T22:17:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10448','386','1','2732','0.99','2005-06-19T15:19:39.000','2006-02-15T22:17:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10449','386','1','3351','2.99','2005-06-21T11:21:39.000','2006-02-15T22:17:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10450','386','2','3783','6.99','2005-07-06T13:57:31.000','2006-02-15T22:17:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10451','386','1','4189','8.99','2005-07-07T10:51:07.000','2006-02-15T22:17:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10452','386','1','5524','0.99','2005-07-10T01:49:24.000','2006-02-15T22:17:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10453','386','1','5953','2.99','2005-07-10T23:21:35.000','2006-02-15T22:17:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10454','386','1','6037','4.99','2005-07-11T03:06:54.000','2006-02-15T22:17:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10455','386','1','6222','2.99','2005-07-11T13:25:49.000','2006-02-15T22:17:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10456','386','2','6261','2.99','2005-07-11T15:28:34.000','2006-02-15T22:17:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10457','386','1','6324','3.99','2005-07-11T19:02:34.000','2006-02-15T22:17:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10458','386','2','6715','4.99','2005-07-12T13:32:28.000','2006-02-15T22:17:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10459','386','2','8340','4.99','2005-07-29T04:41:44.000','2006-02-15T22:17:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10460','386','1','8751','2.99','2005-07-29T19:14:39.000','2006-02-15T22:17:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10461','386','2','9602','0.99','2005-07-31T03:42:51.000','2006-02-15T22:17:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10462','386','1','9686','5.99','2005-07-31T06:50:06.000','2006-02-15T22:17:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10463','386','1','10572','4.99','2005-08-01T13:26:53.000','2006-02-15T22:17:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10464','386','2','10618','3.99','2005-08-01T15:06:38.000','2006-02-15T22:17:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10465','386','1','10715','2.99','2005-08-01T18:51:48.000','2006-02-15T22:17:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10466','386','2','11128','2.99','2005-08-02T09:03:25.000','2006-02-15T22:17:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10467','386','2','11695','4.99','2005-08-17T07:01:08.000','2006-02-15T22:17:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10468','386','2','12961','2.99','2005-08-19T06:22:37.000','2006-02-15T22:17:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10469','386','1','13716','3.99','2005-08-20T09:48:32.000','2006-02-15T22:17:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10470','386','1','13764','2.99','2005-08-20T11:38:16.000','2006-02-15T22:17:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10471','386','2','13869','6.99','2005-08-20T15:08:57.000','2006-02-15T22:17:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10472','386','1','15949','0.99','2005-08-23T19:06:04.000','2006-02-15T22:17:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10473','387','2','302','4.99','2005-05-26T21:13:46.000','2006-02-15T22:17:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10474','387','1','697','7.99','2005-05-29T02:04:04.000','2006-02-15T22:17:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10475','387','1','841','4.99','2005-05-30T00:31:17.000','2006-02-15T22:17:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10476','387','1','1127','3.99','2005-05-31T17:45:49.000','2006-02-15T22:17:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10477','387','1','1464','0.99','2005-06-15T20:38:14.000','2006-02-15T22:17:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10478','387','2','1465','0.99','2005-06-15T20:43:08.000','2006-02-15T22:17:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10479','387','1','2068','0.99','2005-06-17T16:11:46.000','2006-02-15T22:17:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10480','387','2','2100','0.99','2005-06-17T18:53:21.000','2006-02-15T22:17:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10481','387','2','2981','5.99','2005-06-20T08:35:17.000','2006-02-15T22:17:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10482','387','2','3378','4.99','2005-06-21T13:51:28.000','2006-02-15T22:17:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10483','387','2','6216','4.99','2005-07-11T12:57:05.000','2006-02-15T22:17:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10484','387','2','6456','6.99','2005-07-12T01:05:11.000','2006-02-15T22:17:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10485','387','1','6517','5.99','2005-07-12T03:52:39.000','2006-02-15T22:17:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10486','387','1','7497','0.99','2005-07-27T20:05:27.000','2006-02-15T22:17:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10487','387','1','8090','2.99','2005-07-28T18:27:29.000','2006-02-15T22:17:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10488','387','1','10564','0.99','2005-08-01T13:07:34.000','2006-02-15T22:17:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10489','387','1','10838','4.99','2005-08-01T23:36:10.000','2006-02-15T22:17:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10490','387','2','11682','2.99','2005-08-17T06:13:40.000','2006-02-15T22:17:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10491','387','2','12153','4.99','2005-08-18T00:22:30.000','2006-02-15T22:17:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10492','387','1','12936','6.99','2005-08-19T05:25:06.000','2006-02-15T22:17:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10493','387','2','13034','2.99','2005-08-19T08:41:29.000','2006-02-15T22:17:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10494','387','1','13082','5.99','2005-08-19T10:19:19.000','2006-02-15T22:17:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10495','387','2','13645','0.99','2005-08-20T07:47:05.000','2006-02-15T22:17:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10496','387','2','13772','4.99','2005-08-20T11:47:52.000','2006-02-15T22:17:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10497','387','2','14279','5.99','2005-08-21T06:39:08.000','2006-02-15T22:17:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10498','387','2','14979','0.99','2005-08-22T07:16:36.000','2006-02-15T22:17:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10499','388','2','21','4.99','2005-05-25T01:59:46.000','2006-02-15T22:17:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10500','388','2','411','4.99','2005-05-27T14:14:14.000','2006-02-15T22:17:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10501','388','2','1276','6.99','2005-06-15T08:00:13.000','2006-02-15T22:17:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10502','388','1','2145','0.99','2005-06-17T22:10:36.000','2006-02-15T22:17:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10503','388','1','2537','5.99','2005-06-19T01:52:21.000','2006-02-15T22:17:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10504','388','1','2692','4.99','2005-06-19T13:08:19.000','2006-02-15T22:17:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10505','388','2','3159','7.99','2005-06-20T21:11:50.000','2006-02-15T22:17:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10506','388','2','4947','5.99','2005-07-08T22:49:37.000','2006-02-15T22:17:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10507','388','2','5899','2.99','2005-07-10T20:21:52.000','2006-02-15T22:17:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10508','388','2','6321','2.99','2005-07-11T18:51:02.000','2006-02-15T22:17:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10509','388','1','6452','2.99','2005-07-12T00:57:31.000','2006-02-15T22:17:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10510','388','2','7985','5.99','2005-07-28T14:29:01.000','2006-02-15T22:17:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10511','388','2','8456','3.99','2005-07-29T07:58:31.000','2006-02-15T22:17:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10512','388','2','9213','0.99','2005-07-30T13:07:11.000','2006-02-15T22:17:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10513','388','2','9368','2.99','2005-07-30T18:50:53.000','2006-02-15T22:17:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10514','388','2','9840','2.99','2005-07-31T12:23:18.000','2006-02-15T22:17:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10515','388','2','9940','0.99','2005-07-31T15:29:06.000','2006-02-15T22:17:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10516','388','2','10044','2.99','2005-07-31T19:02:33.000','2006-02-15T22:17:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10517','388','2','11604','0.99','2005-08-17T03:28:27.000','2006-02-15T22:17:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10518','388','2','12044','0.99','2005-08-17T20:39:37.000','2006-02-15T22:17:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10519','388','1','12068','2.99','2005-08-17T21:37:08.000','2006-02-15T22:17:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10520','388','2','12267','6.99','2005-08-18T04:24:30.000','2006-02-15T22:17:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10521','388','2','12497','4.99','2005-08-18T12:58:40.000','2006-02-15T22:17:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10522','388','2','12646','2.99','2005-08-18T18:25:06.000','2006-02-15T22:17:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10523','388','1','12749','2.99','2005-08-18T22:31:21.000','2006-02-15T22:17:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10524','388','1','12977','4.99','2005-08-19T06:55:33.000','2006-02-15T22:17:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10525','388','1','14273','10.99','2005-08-21T06:26:48.000','2006-02-15T22:17:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10526','388','2','14853','5.99','2005-08-22T02:26:33.000','2006-02-15T22:17:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10527','388','2','15660','5.99','2005-08-23T08:51:21.000','2006-02-15T22:17:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10528','388','1','12891','0.99','2006-02-14T15:16:03.000','2006-02-15T22:17:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10529','389','1','998','4.99','2005-05-31T00:16:57.000','2006-02-15T22:17:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10530','389','1','1763','4.99','2005-06-16T17:51:01.000','2006-02-15T22:17:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10531','389','1','1946','4.99','2005-06-17T07:58:39.000','2006-02-15T22:17:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10532','389','1','2552','3.99','2005-06-19T03:01:29.000','2006-02-15T22:17:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10533','389','2','3527','0.99','2005-07-06T01:11:08.000','2006-02-15T22:17:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10534','389','1','4443','6.99','2005-07-07T23:05:53.000','2006-02-15T22:17:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10535','389','1','5249','0.99','2005-07-09T13:33:53.000','2006-02-15T22:17:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10536','389','2','5626','3.99','2005-07-10T05:49:35.000','2006-02-15T22:17:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10537','389','2','6104','2.99','2005-07-11T07:01:35.000','2006-02-15T22:17:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10538','389','1','6600','3.99','2005-07-12T07:41:48.000','2006-02-15T22:17:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10539','389','1','7029','4.99','2005-07-27T02:57:43.000','2006-02-15T22:17:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10540','389','1','7896','8.99','2005-07-28T11:00:58.000','2006-02-15T22:17:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10541','389','2','7977','4.99','2005-07-28T14:15:54.000','2006-02-15T22:17:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10542','389','1','8338','6.99','2005-07-29T04:40:39.000','2006-02-15T22:17:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10543','389','1','8887','4.99','2005-07-30T00:36:54.000','2006-02-15T22:17:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10544','389','1','10217','4.99','2005-08-01T01:07:27.000','2006-02-15T22:17:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10545','389','1','10949','2.99','2005-08-02T03:24:04.000','2006-02-15T22:17:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10546','389','2','11348','4.99','2005-08-02T17:18:38.000','2006-02-15T22:17:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10547','389','2','11441','2.99','2005-08-02T20:25:41.000','2006-02-15T22:17:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10548','389','2','11944','3.99','2005-08-17T17:02:42.000','2006-02-15T22:17:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10549','389','2','12069','4.99','2005-08-17T21:39:40.000','2006-02-15T22:17:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10550','389','2','14493','7.99','2005-08-21T14:01:44.000','2006-02-15T22:17:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10551','389','1','14578','2.99','2005-08-21T16:53:38.000','2006-02-15T22:17:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10552','389','1','14777','2.99','2005-08-21T23:55:50.000','2006-02-15T22:17:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10553','389','1','15462','5.99','2005-08-23T01:14:01.000','2006-02-15T22:17:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10554','389','2','16011','9.99','2005-08-23T21:11:33.000','2006-02-15T22:17:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10555','390','1','254','4.99','2005-05-26T14:43:48.000','2006-02-15T22:17:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10556','390','2','912','4.99','2005-05-30T10:58:33.000','2006-02-15T22:17:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10557','390','2','1539','5.99','2005-06-16T01:11:25.000','2006-02-15T22:17:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10558','390','2','1730','2.99','2005-06-16T15:30:01.000','2006-02-15T22:17:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10559','390','2','1893','2.99','2005-06-17T04:18:37.000','2006-02-15T22:17:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10560','390','1','2330','7.99','2005-06-18T10:41:19.000','2006-02-15T22:17:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10561','390','1','3147','5.99','2005-06-20T20:25:17.000','2006-02-15T22:17:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10562','390','1','3999','2.99','2005-07-06T23:50:54.000','2006-02-15T22:17:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10563','390','1','4022','4.99','2005-07-07T01:50:06.000','2006-02-15T22:17:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10564','390','2','4191','3.99','2005-07-07T10:56:14.000','2006-02-15T22:17:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10565','390','2','4310','2.99','2005-07-07T17:30:56.000','2006-02-15T22:17:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10566','390','1','4968','5.99','2005-07-08T23:49:19.000','2006-02-15T22:17:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10567','390','1','6215','4.99','2005-07-11T12:52:36.000','2006-02-15T22:17:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10568','390','1','6430','0.99','2005-07-12T00:03:34.000','2006-02-15T22:17:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10569','390','2','7515','3.99','2005-07-27T20:52:37.000','2006-02-15T22:17:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10570','390','1','7595','5.99','2005-07-27T23:32:23.000','2006-02-15T22:17:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10571','390','1','8493','0.99','2005-07-29T09:04:31.000','2006-02-15T22:17:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10572','390','1','9251','5.99','2005-07-30T14:19:25.000','2006-02-15T22:17:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10573','390','2','9314','2.99','2005-07-30T17:05:19.000','2006-02-15T22:17:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10574','390','1','9825','4.99','2005-07-31T11:50:51.000','2006-02-15T22:17:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10575','390','1','10061','4.99','2005-07-31T19:23:25.000','2006-02-15T22:17:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10576','390','1','12105','5.99','2005-08-17T22:54:45.000','2006-02-15T22:17:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10577','390','2','12803','2.99','2005-08-19T00:28:21.000','2006-02-15T22:17:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10578','390','1','13413','3.99','2005-08-19T22:46:46.000','2006-02-15T22:17:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10579','390','1','13473','4.99','2005-08-20T01:03:50.000','2006-02-15T22:17:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10580','390','1','13501','0.99','2005-08-20T01:56:20.000','2006-02-15T22:17:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10581','390','2','13546','3.99','2005-08-20T03:50:24.000','2006-02-15T22:17:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10582','390','2','13591','3.99','2005-08-20T05:50:05.000','2006-02-15T22:17:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10583','390','2','13618','7.99','2005-08-20T06:36:46.000','2006-02-15T22:17:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10584','390','2','13893','5.99','2005-08-20T15:52:52.000','2006-02-15T22:17:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10585','390','2','15222','4.99','2005-08-22T17:12:30.000','2006-02-15T22:17:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10586','390','2','15303','8.99','2005-08-22T19:44:59.000','2006-02-15T22:17:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10587','390','2','15376','4.99','2005-08-22T22:21:35.000','2006-02-15T22:17:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10588','391','2','73','4.99','2005-05-25T11:00:07.000','2006-02-15T22:17:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10589','391','1','210','2.99','2005-05-26T08:14:15.000','2006-02-15T22:17:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10590','391','1','317','5.99','2005-05-26T23:23:56.000','2006-02-15T22:17:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10591','391','2','870','2.99','2005-05-30T04:25:47.000','2006-02-15T22:17:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10592','391','1','891','7.99','2005-05-30T07:43:12.000','2006-02-15T22:17:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10593','391','2','1232','0.99','2005-06-15T04:18:10.000','2006-02-15T22:17:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10594','391','2','1931','0.99','2005-06-17T06:51:56.000','2006-02-15T22:17:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10595','391','1','2045','2.99','2005-06-17T14:38:11.000','2006-02-15T22:17:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10596','391','1','2690','2.99','2005-06-19T13:00:02.000','2006-02-15T22:17:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10597','391','2','3163','2.99','2005-06-20T21:22:13.000','2006-02-15T22:17:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10598','391','1','4188','5.99','2005-07-07T10:45:29.000','2006-02-15T22:17:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10599','391','1','4716','0.99','2005-07-08T12:18:51.000','2006-02-15T22:17:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10600','391','2','4753','0.99','2005-07-08T14:18:41.000','2006-02-15T22:17:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10601','391','2','5583','7.99','2005-07-10T04:08:48.000','2006-02-15T22:17:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10602','391','1','5599','4.99','2005-07-10T04:52:04.000','2006-02-15T22:17:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10603','391','1','6302','3.99','2005-07-11T17:55:38.000','2006-02-15T22:17:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10604','391','1','6463','2.99','2005-07-12T01:16:11.000','2006-02-15T22:17:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10605','391','2','8016','0.99','2005-07-28T15:35:41.000','2006-02-15T22:17:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10606','391','1','8908','0.99','2005-07-30T01:26:05.000','2006-02-15T22:17:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10607','391','2','8913','6.99','2005-07-30T01:35:01.000','2006-02-15T22:17:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10608','391','1','9225','0.99','2005-07-30T13:29:47.000','2006-02-15T22:17:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10609','391','1','10210','7.99','2005-08-01T00:58:52.000','2006-02-15T22:17:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10610','391','2','10406','2.99','2005-08-01T07:37:05.000','2006-02-15T22:17:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10611','391','1','11151','4.99','2005-08-02T09:52:44.000','2006-02-15T22:17:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10612','391','2','11434','2.99','2005-08-02T20:13:14.000','2006-02-15T22:17:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10613','391','1','11602','4.99','2005-08-17T03:21:19.000','2006-02-15T22:17:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10614','391','1','12090','0.99','2005-08-17T22:21:43.000','2006-02-15T22:17:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10615','391','1','12100','1.99','2005-08-17T22:41:10.000','2006-02-15T22:17:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10616','391','1','13980','2.99','2005-08-20T19:04:40.000','2006-02-15T22:17:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10617','391','1','14381','0.99','2005-08-21T09:55:47.000','2006-02-15T22:17:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10618','392','2','1530','6.99','2005-06-16T00:38:07.000','2006-02-15T22:17:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10619','392','2','1764','2.99','2005-06-16T17:51:54.000','2006-02-15T22:17:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10620','392','2','2289','2.99','2005-06-18T07:29:43.000','2006-02-15T22:17:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10621','392','2','2890','4.99','2005-06-20T02:00:45.000','2006-02-15T22:17:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10622','392','1','3566','2.99','2005-07-06T03:08:51.000','2006-02-15T22:17:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10623','392','2','6061','0.99','2005-07-11T04:06:25.000','2006-02-15T22:17:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10624','392','2','6406','2.99','2005-07-11T22:55:27.000','2006-02-15T22:17:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10625','392','1','7692','2.99','2005-07-28T03:30:21.000','2006-02-15T22:17:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10626','392','1','7981','1.99','2005-07-28T14:18:25.000','2006-02-15T22:17:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10627','392','1','8254','0.99','2005-07-29T00:59:31.000','2006-02-15T22:17:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10628','392','2','8612','9.99','2005-07-29T13:28:20.000','2006-02-15T22:17:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10629','392','2','10085','0.99','2005-07-31T20:12:02.000','2006-02-15T22:17:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10630','392','1','10435','4.99','2005-08-01T08:50:51.000','2006-02-15T22:17:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10631','392','1','11459','0.99','2005-08-02T21:25:25.000','2006-02-15T22:17:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10632','392','1','11686','2.99','2005-08-17T06:39:30.000','2006-02-15T22:17:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10633','392','2','12102','6.99','2005-08-17T22:45:26.000','2006-02-15T22:17:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10634','392','1','12368','6.99','2005-08-18T07:57:38.000','2006-02-15T22:17:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10635','392','2','12561','0.99','2005-08-18T14:58:51.000','2006-02-15T22:17:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10636','392','1','13629','4.99','2005-08-20T07:04:07.000','2006-02-15T22:17:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10637','392','2','14081','7.99','2005-08-20T23:35:13.000','2006-02-15T22:17:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10638','392','1','14223','5.99','2005-08-21T04:51:51.000','2006-02-15T22:17:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10639','392','2','14369','0.99','2005-08-21T09:33:44.000','2006-02-15T22:17:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10640','392','2','14438','5.99','2005-08-21T11:51:10.000','2006-02-15T22:17:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10641','393','1','599','4.99','2005-05-28T14:05:57.000','2006-02-15T22:17:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10642','393','2','886','0.99','2005-05-30T06:54:51.000','2006-02-15T22:17:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10643','393','1','1611','6.99','2005-06-16T06:41:35.000','2006-02-15T22:17:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10644','393','2','1915','1.99','2005-06-17T05:28:28.000','2006-02-15T22:17:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10645','393','2','2219','2.99','2005-06-18T03:16:54.000','2006-02-15T22:17:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10646','393','1','2319','4.99','2005-06-18T09:24:22.000','2006-02-15T22:17:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10647','393','2','3001','2.99','2005-06-20T09:50:16.000','2006-02-15T22:17:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10648','393','2','4275','2.99','2005-07-07T14:43:51.000','2006-02-15T22:17:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10649','393','2','4546','8.99','2005-07-08T04:18:36.000','2006-02-15T22:17:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10650','393','2','4632','5.99','2005-07-08T08:38:57.000','2006-02-15T22:17:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10651','393','2','4791','7.99','2005-07-08T16:27:24.000','2006-02-15T22:17:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10652','393','1','5099','4.99','2005-07-09T06:14:30.000','2006-02-15T22:17:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10653','393','1','6221','2.99','2005-07-11T13:24:27.000','2006-02-15T22:17:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10654','393','2','6513','0.99','2005-07-12T03:44:43.000','2006-02-15T22:17:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10655','393','1','6930','8.99','2005-07-26T23:00:01.000','2006-02-15T22:17:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10656','393','2','7486','0.99','2005-07-27T19:29:24.000','2006-02-15T22:17:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10657','393','2','8004','4.99','2005-07-28T15:14:07.000','2006-02-15T22:17:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10658','393','2','8448','0.99','2005-07-29T07:41:54.000','2006-02-15T22:17:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10659','393','2','9763','7.99','2005-07-31T09:34:03.000','2006-02-15T22:17:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10660','393','1','10158','1.99','2005-07-31T22:40:31.000','2006-02-15T22:17:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10661','393','2','12059','2.99','2005-08-17T21:09:23.000','2006-02-15T22:17:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10662','393','1','12113','1.99','2005-08-17T23:01:00.000','2006-02-15T22:17:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10663','393','1','12563','4.99','2005-08-18T15:08:29.000','2006-02-15T22:17:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10664','393','1','12676','0.99','2005-08-18T19:34:40.000','2006-02-15T22:17:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10665','393','1','13184','4.99','2005-08-19T14:16:18.000','2006-02-15T22:17:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10666','393','2','13357','4.99','2005-08-19T21:02:59.000','2006-02-15T22:17:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10667','393','2','13788','1.99','2005-08-20T12:15:41.000','2006-02-15T22:17:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10668','393','1','15132','2.99','2005-08-22T13:11:25.000','2006-02-15T22:17:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10669','393','2','15284','3.99','2005-08-22T19:17:08.000','2006-02-15T22:17:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10670','393','2','15527','0.99','2005-08-23T03:44:51.000','2006-02-15T22:17:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10671','393','2','16049','3.99','2005-08-23T22:50:12.000','2006-02-15T22:17:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10672','394','1','213','3.99','2005-05-26T08:44:08.000','2006-02-15T22:17:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10673','394','1','977','2.99','2005-05-30T21:22:26.000','2006-02-15T22:17:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10674','394','2','1324','4.99','2005-06-15T11:02:45.000','2006-02-15T22:17:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10675','394','2','3543','0.99','2005-07-06T02:01:08.000','2006-02-15T22:17:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10676','394','1','3873','6.99','2005-07-06T18:03:16.000','2006-02-15T22:17:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10677','394','2','4009','2.99','2005-07-07T00:28:55.000','2006-02-15T22:17:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10678','394','1','4307','6.99','2005-07-07T17:20:39.000','2006-02-15T22:17:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10679','394','2','5183','4.99','2005-07-09T10:13:45.000','2006-02-15T22:17:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10680','394','1','5535','4.99','2005-07-10T02:27:42.000','2006-02-15T22:17:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10681','394','2','6059','4.99','2005-07-11T04:03:54.000','2006-02-15T22:17:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10682','394','2','7445','3.99','2005-07-27T17:57:15.000','2006-02-15T22:17:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10683','394','1','9147','0.99','2005-07-30T10:38:59.000','2006-02-15T22:17:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10684','394','2','9864','0.99','2005-07-31T13:06:54.000','2006-02-15T22:17:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10685','394','1','10319','4.99','2005-08-01T04:37:19.000','2006-02-15T22:17:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10686','394','1','10603','0.99','2005-08-01T14:30:35.000','2006-02-15T22:17:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10687','394','1','10718','0.99','2005-08-01T18:55:38.000','2006-02-15T22:17:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10688','394','1','12080','4.99','2005-08-17T22:08:04.000','2006-02-15T22:17:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10689','394','1','12389','4.99','2005-08-18T08:48:36.000','2006-02-15T22:17:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10690','394','2','12510','9.99','2005-08-18T13:22:25.000','2006-02-15T22:17:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10691','394','2','13047','0.99','2005-08-19T09:24:49.000','2006-02-15T22:17:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10692','394','1','14605','0.99','2005-08-21T17:56:06.000','2006-02-15T22:17:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10693','394','2','13178','4.99','2006-02-14T15:16:03.000','2006-02-15T22:17:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10694','395','1','1270','0.99','2005-06-15T07:30:22.000','2006-02-15T22:17:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10695','395','1','1562','0.99','2005-06-16T02:46:27.000','2006-02-15T22:17:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10696','395','2','1603','0.99','2005-06-16T06:14:03.000','2006-02-15T22:17:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10697','395','1','3030','4.99','2005-06-20T11:51:59.000','2006-02-15T22:17:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10698','395','1','3310','0.99','2005-06-21T08:04:51.000','2006-02-15T22:17:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10699','395','1','3389','6.99','2005-06-21T14:37:55.000','2006-02-15T22:17:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10700','395','2','3684','0.99','2005-07-06T09:29:22.000','2006-02-15T22:17:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10701','395','1','4185','5.99','2005-07-07T10:31:05.000','2006-02-15T22:17:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10702','395','1','4393','4.99','2005-07-07T21:12:36.000','2006-02-15T22:17:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10703','395','1','5087','0.99','2005-07-09T05:44:28.000','2006-02-15T22:17:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10704','395','2','5136','0.99','2005-07-09T07:55:01.000','2006-02-15T22:17:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10705','395','1','7740','2.99','2005-07-28T05:23:36.000','2006-02-15T22:17:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10706','395','2','7986','7.99','2005-07-28T14:30:13.000','2006-02-15T22:17:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10707','395','1','11889','0.99','2005-08-17T15:08:27.000','2006-02-15T22:17:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10708','395','1','14471','5.99','2005-08-21T13:10:40.000','2006-02-15T22:17:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10709','395','2','14720','0.99','2005-08-21T21:43:53.000','2006-02-15T22:17:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10710','395','1','15698','2.99','2005-08-23T10:11:40.000','2006-02-15T22:17:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10711','395','1','15856','0.99','2005-08-23T15:59:12.000','2006-02-15T22:17:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10712','395','1','15970','4.99','2005-08-23T19:54:24.000','2006-02-15T22:17:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10713','396','2','641','5.99','2005-05-28T18:45:47.000','2006-02-15T22:17:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10714','396','2','1370','1.99','2005-06-15T14:31:05.000','2006-02-15T22:17:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10715','396','2','1385','4.99','2005-06-15T15:28:23.000','2006-02-15T22:17:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10716','396','2','1408','6.99','2005-06-15T16:57:58.000','2006-02-15T22:17:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10717','396','2','3909','6.99','2005-07-06T19:54:41.000','2006-02-15T22:17:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10718','396','1','5059','1.99','2005-07-09T04:28:01.000','2006-02-15T22:17:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10719','396','2','6335','2.99','2005-07-11T19:25:15.000','2006-02-15T22:17:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10720','396','2','6764','4.99','2005-07-12T15:29:27.000','2006-02-15T22:17:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10721','396','2','6771','2.99','2005-07-12T15:54:40.000','2006-02-15T22:17:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10722','396','2','7142','0.99','2005-07-27T06:55:39.000','2006-02-15T22:17:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10723','396','2','7313','2.99','2005-07-27T13:11:57.000','2006-02-15T22:17:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10724','396','2','8371','2.99','2005-07-29T05:16:35.000','2006-02-15T22:17:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10725','396','2','8807','2.99','2005-07-29T21:36:59.000','2006-02-15T22:17:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10726','396','1','9344','5.99','2005-07-30T18:13:45.000','2006-02-15T22:17:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10727','396','2','10120','2.99','2005-07-31T21:24:24.000','2006-02-15T22:17:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10728','396','2','10124','0.99','2005-07-31T21:31:49.000','2006-02-15T22:17:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10729','396','2','10195','6.99','2005-08-01T00:34:42.000','2006-02-15T22:17:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10730','396','2','10610','0.99','2005-08-01T14:49:41.000','2006-02-15T22:17:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10731','396','2','12393','5.99','2005-08-18T09:02:41.000','2006-02-15T22:17:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10732','396','1','12895','4.99','2005-08-19T03:50:48.000','2006-02-15T22:17:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10733','396','2','13355','4.99','2005-08-19T20:59:19.000','2006-02-15T22:17:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10734','396','1','14078','3.99','2005-08-20T23:26:40.000','2006-02-15T22:17:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10735','396','1','14169','4.99','2005-08-21T03:00:31.000','2006-02-15T22:17:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10736','396','1','14508','2.99','2005-08-21T14:33:58.000','2006-02-15T22:17:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10737','396','2','14778','5.99','2005-08-21T23:56:30.000','2006-02-15T22:17:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10738','396','1','14792','1.99','2005-08-22T00:36:41.000','2006-02-15T22:17:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10739','396','2','15198','7.99','2005-08-22T16:15:33.000','2006-02-15T22:17:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10740','397','2','1002','0.99','2005-05-31T00:47:56.000','2006-02-15T22:17:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10741','397','1','1769','5.99','2005-06-16T18:07:48.000','2006-02-15T22:17:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10742','397','2','3027','1.99','2005-06-20T11:50:30.000','2006-02-15T22:17:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10743','397','1','3489','5.99','2005-07-05T23:33:40.000','2006-02-15T22:17:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10744','397','1','4036','0.99','2005-07-07T02:48:00.000','2006-02-15T22:17:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10745','397','2','5103','4.99','2005-07-09T06:34:40.000','2006-02-15T22:17:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10746','397','2','5598','4.99','2005-07-10T04:48:29.000','2006-02-15T22:17:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10747','397','2','5763','4.99','2005-07-10T12:58:12.000','2006-02-15T22:17:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10748','397','2','6014','2.99','2005-07-11T02:02:55.000','2006-02-15T22:17:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10749','397','2','6266','2.99','2005-07-11T15:45:39.000','2006-02-15T22:17:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10750','397','1','6471','4.99','2005-07-12T01:31:06.000','2006-02-15T22:17:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10751','397','2','7356','2.99','2005-07-27T14:47:35.000','2006-02-15T22:17:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10752','397','2','7892','4.99','2005-07-28T10:46:58.000','2006-02-15T22:17:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10753','397','1','8103','6.99','2005-07-28T18:50:14.000','2006-02-15T22:17:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10754','397','1','9495','0.99','2005-07-30T23:54:26.000','2006-02-15T22:17:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10755','397','2','9608','1.99','2005-07-31T03:51:52.000','2006-02-15T22:17:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10756','397','1','10534','0.99','2005-08-01T12:15:11.000','2006-02-15T22:17:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10757','397','2','10598','4.99','2005-08-01T14:23:36.000','2006-02-15T22:17:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10758','397','1','10785','1.99','2005-08-01T21:24:55.000','2006-02-15T22:17:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10759','397','2','11511','4.99','2005-08-16T23:39:59.000','2006-02-15T22:17:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10760','397','2','12223','2.99','2005-08-18T02:58:40.000','2006-02-15T22:17:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10761','397','1','12276','0.99','2005-08-18T04:43:22.000','2006-02-15T22:17:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10762','397','2','12329','1.99','2005-08-18T06:44:30.000','2006-02-15T22:17:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10763','397','2','12700','0.99','2005-08-18T20:24:46.000','2006-02-15T22:17:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10764','397','2','12726','2.99','2005-08-18T21:44:46.000','2006-02-15T22:17:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10765','397','1','12772','4.99','2005-08-18T23:29:25.000','2006-02-15T22:17:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10766','397','2','14100','3.99','2005-08-21T00:31:07.000','2006-02-15T22:17:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10767','397','1','14790','6.99','2005-08-22T00:34:17.000','2006-02-15T22:17:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10768','397','1','15083','6.99','2005-08-22T11:17:37.000','2006-02-15T22:17:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10769','398','1','486','4.99','2005-05-27T23:51:12.000','2006-02-15T22:17:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10770','398','2','1228','2.99','2005-06-15T03:50:36.000','2006-02-15T22:17:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10771','398','1','2087','6.99','2005-06-17T17:35:10.000','2006-02-15T22:17:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10772','398','2','3141','9.99','2005-06-20T19:55:47.000','2006-02-15T22:17:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10773','398','2','5234','5.99','2005-07-09T12:44:47.000','2006-02-15T22:17:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10774','398','2','8119','3.99','2005-07-28T19:23:15.000','2006-02-15T22:17:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10775','398','2','8204','4.99','2005-07-28T23:18:29.000','2006-02-15T22:17:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10776','398','1','8428','7.99','2005-07-29T07:10:14.000','2006-02-15T22:17:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10777','398','1','9042','2.99','2005-07-30T06:33:55.000','2006-02-15T22:17:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10778','398','2','9281','5.99','2005-07-30T15:15:51.000','2006-02-15T22:17:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10779','398','1','9771','1.99','2005-07-31T09:55:36.000','2006-02-15T22:17:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10780','398','1','10230','2.99','2005-08-01T01:49:36.000','2006-02-15T22:17:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10781','398','2','11132','4.99','2005-08-02T09:14:09.000','2006-02-15T22:17:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10782','398','2','12528','2.99','2005-08-18T13:52:41.000','2006-02-15T22:17:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10783','398','2','13643','4.99','2005-08-20T07:42:24.000','2006-02-15T22:17:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10784','398','1','15189','3.99','2005-08-22T15:56:42.000','2006-02-15T22:17:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10785','399','2','10','5.99','2005-05-25T00:02:21.000','2006-02-15T22:17:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10786','399','2','694','6.99','2005-05-29T01:49:43.000','2006-02-15T22:17:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10787','399','2','883','4.99','2005-05-30T06:21:05.000','2006-02-15T22:17:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10788','399','2','2961','2.99','2005-06-20T07:29:15.000','2006-02-15T22:17:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10789','399','1','3036','5.99','2005-06-20T12:18:31.000','2006-02-15T22:17:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10790','399','2','4957','0.99','2005-07-08T23:18:48.000','2006-02-15T22:17:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10791','399','2','4981','4.99','2005-07-09T00:29:29.000','2006-02-15T22:17:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10792','399','1','5507','0.99','2005-07-10T00:49:04.000','2006-02-15T22:17:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10793','399','2','6006','2.99','2005-07-11T01:38:42.000','2006-02-15T22:17:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10794','399','2','6229','6.99','2005-07-11T13:59:50.000','2006-02-15T22:17:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10795','399','2','6674','4.99','2005-07-12T11:51:54.000','2006-02-15T22:17:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10796','399','2','8461','5.99','2005-07-29T08:11:31.000','2006-02-15T22:17:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10797','399','2','9728','2.99','2005-07-31T08:40:54.000','2006-02-15T22:17:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10798','399','2','10654','2.99','2005-08-01T16:31:35.000','2006-02-15T22:17:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10799','399','2','10960','5.99','2005-08-02T03:46:18.000','2006-02-15T22:17:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10800','399','1','11329','4.99','2005-08-02T16:42:52.000','2006-02-15T22:17:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10801','399','1','11953','3.99','2005-08-17T17:16:42.000','2006-02-15T22:17:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10802','399','1','13253','4.99','2005-08-19T16:53:56.000','2006-02-15T22:17:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10803','399','2','13293','4.99','2005-08-19T18:35:52.000','2006-02-15T22:17:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10804','399','1','15300','0.99','2005-08-22T19:44:00.000','2006-02-15T22:17:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10805','399','1','15468','4.99','2005-08-23T01:25:30.000','2006-02-15T22:17:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10806','400','1','95','3.99','2005-05-25T16:12:52.000','2006-02-15T22:17:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10807','400','2','171','6.99','2005-05-26T03:14:15.000','2006-02-15T22:17:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10808','400','2','516','1.99','2005-05-28T03:11:47.000','2006-02-15T22:17:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10809','400','2','894','5.99','2005-05-30T08:31:31.000','2006-02-15T22:17:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10810','400','2','1364','0.99','2005-06-15T14:05:32.000','2006-02-15T22:17:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10811','400','1','1917','3.99','2005-06-17T05:36:07.000','2006-02-15T22:17:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10812','400','2','1923','6.99','2005-06-17T06:06:10.000','2006-02-15T22:17:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10813','400','1','4573','6.99','2005-07-08T05:38:46.000','2006-02-15T22:17:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10814','400','1','4645','2.99','2005-07-08T09:20:09.000','2006-02-15T22:17:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10815','400','2','5212','6.99','2005-07-09T11:37:47.000','2006-02-15T22:17:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10816','400','2','5222','5.99','2005-07-09T12:05:45.000','2006-02-15T22:17:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10817','400','2','6790','5.99','2005-07-12T16:34:59.000','2006-02-15T22:17:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10818','400','2','6994','2.99','2005-07-27T01:08:26.000','2006-02-15T22:17:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10819','400','2','7296','2.99','2005-07-27T12:39:48.000','2006-02-15T22:17:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10820','400','1','7682','5.99','2005-07-28T03:07:29.000','2006-02-15T22:17:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10821','400','2','9177','5.99','2005-07-30T11:52:40.000','2006-02-15T22:17:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10822','400','2','9756','4.99','2005-07-31T09:25:00.000','2006-02-15T22:17:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10823','400','1','10187','2.99','2005-08-01T00:15:49.000','2006-02-15T22:17:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10824','400','2','10484','2.99','2005-08-01T10:19:53.000','2006-02-15T22:17:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10825','400','1','10711','0.99','2005-08-01T18:45:09.000','2006-02-15T22:17:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10826','400','2','11510','6.99','2005-08-16T23:30:07.000','2006-02-15T22:17:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10827','400','2','11530','2.99','2005-08-17T00:29:00.000','2006-02-15T22:17:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10828','400','1','11600','5.99','2005-08-17T03:12:04.000','2006-02-15T22:17:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10829','400','1','12514','2.99','2005-08-18T13:33:55.000','2006-02-15T22:17:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10830','400','2','13449','2.99','2005-08-20T00:17:01.000','2006-02-15T22:17:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10831','400','1','14775','2.99','2005-08-21T23:53:07.000','2006-02-15T22:17:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10832','400','2','15533','4.99','2005-08-23T03:54:39.000','2006-02-15T22:17:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10833','400','2','15988','4.99','2005-08-23T20:23:08.000','2006-02-15T22:17:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10834','401','2','167','4.99','2005-05-26T02:50:31.000','2006-02-15T22:17:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10835','401','2','446','4.99','2005-05-27T18:48:41.000','2006-02-15T22:17:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10836','401','2','811','1.99','2005-05-29T19:30:42.000','2006-02-15T22:17:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10837','401','1','4059','0.99','2005-07-07T04:04:26.000','2006-02-15T22:17:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10838','401','2','4292','7.99','2005-07-07T15:48:38.000','2006-02-15T22:17:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10839','401','2','5923','0.99','2005-07-10T21:40:06.000','2006-02-15T22:17:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10840','401','1',NULL,'0.99','2005-07-12T06:26:10.000','2006-02-15T22:17:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10841','401','2','7651','4.99','2005-07-28T01:48:32.000','2006-02-15T22:17:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10842','401','1','8450','2.99','2005-07-29T07:44:05.000','2006-02-15T22:17:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10843','401','2','8669','2.99','2005-07-29T15:44:55.000','2006-02-15T22:17:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10844','401','1','8722','8.99','2005-07-29T17:58:58.000','2006-02-15T22:17:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10845','401','2','9701','4.99','2005-07-31T07:32:21.000','2006-02-15T22:17:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10846','401','2','10171','0.99','2005-07-31T23:29:05.000','2006-02-15T22:17:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10847','401','1','11820','2.99','2005-08-17T12:25:33.000','2006-02-15T22:17:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10848','401','1','12475','4.99','2005-08-18T12:14:21.000','2006-02-15T22:17:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10849','401','2','12479','4.99','2005-08-18T12:26:37.000','2006-02-15T22:17:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10850','401','1','12906','2.99','2005-08-19T04:13:43.000','2006-02-15T22:17:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10851','401','1','13024','4.99','2005-08-19T08:19:21.000','2006-02-15T22:17:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10852','401','1','14359','0.99','2005-08-21T09:16:19.000','2006-02-15T22:17:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10853','401','2','14433','1.99','2005-08-21T11:36:34.000','2006-02-15T22:17:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10854','401','1','15831','0.99','2005-08-23T15:21:19.000','2006-02-15T22:17:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10855','401','1','15927','0.99','2005-08-23T18:23:11.000','2006-02-15T22:17:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10856','402','2','801','1.99','2005-05-29T17:35:50.000','2006-02-15T22:17:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10857','402','2','1194','4.99','2005-06-15T01:25:08.000','2006-02-15T22:17:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10858','402','2','2490','4.99','2005-06-18T22:00:50.000','2006-02-15T22:17:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10859','402','2','2913','2.99','2005-06-20T03:42:27.000','2006-02-15T22:17:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10860','402','2','3564','6.99','2005-07-06T03:02:13.000','2006-02-15T22:17:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10861','402','2','3612','3.99','2005-07-06T05:37:26.000','2006-02-15T22:17:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10862','402','2','3755','5.99','2005-07-06T12:37:16.000','2006-02-15T22:17:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10863','402','1','4399','2.99','2005-07-07T21:20:28.000','2006-02-15T22:17:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10864','402','2','4604','3.99','2005-07-08T06:58:43.000','2006-02-15T22:17:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10865','402','2','5329','4.99','2005-07-09T16:49:46.000','2006-02-15T22:17:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10866','402','2','6183','2.99','2005-07-11T11:14:35.000','2006-02-15T22:17:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10867','402','1','6283','3.99','2005-07-11T16:47:32.000','2006-02-15T22:17:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10868','402','1','7633','0.99','2005-07-28T01:03:41.000','2006-02-15T22:17:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10869','402','2','8521','7.99','2005-07-29T10:12:45.000','2006-02-15T22:17:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10870','402','1','9657','6.99','2005-07-31T06:00:41.000','2006-02-15T22:17:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10871','402','2','9779','0.99','2005-07-31T10:08:33.000','2006-02-15T22:17:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10872','402','2','11045','0.99','2005-08-02T06:07:54.000','2006-02-15T22:17:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10873','402','2','11549','4.99','2005-08-17T01:01:48.000','2006-02-15T22:17:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10874','402','2','11920','0.99','2005-08-17T16:10:19.000','2006-02-15T22:17:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10875','402','1','15428','4.99','2005-08-23T00:11:52.000','2006-02-15T22:17:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10876','403','1','442','2.99','2005-05-27T18:12:13.000','2006-02-15T22:17:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10877','403','1','517','0.99','2005-05-28T03:17:57.000','2006-02-15T22:17:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10878','403','2','1221','4.99','2005-06-15T03:35:16.000','2006-02-15T22:17:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10879','403','1','1249','8.99','2005-06-15T05:38:09.000','2006-02-15T22:17:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10880','403','2','2488','3.99','2005-06-18T21:38:26.000','2006-02-15T22:17:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10881','403','1','2927','4.99','2005-06-20T04:41:41.000','2006-02-15T22:17:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10882','403','2','3049','6.99','2005-06-20T12:51:01.000','2006-02-15T22:17:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10883','403','1','3356','5.99','2005-06-21T11:38:45.000','2006-02-15T22:17:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10884','403','1','3644','6.99','2005-07-06T07:20:11.000','2006-02-15T22:17:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10885','403','2','3737','3.99','2005-07-06T11:45:53.000','2006-02-15T22:17:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10886','403','2','4096','4.99','2005-07-07T06:09:11.000','2006-02-15T22:17:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10887','403','1','5982','4.99','2005-07-11T00:24:44.000','2006-02-15T22:17:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10888','403','2','6322','2.99','2005-07-11T18:58:20.000','2006-02-15T22:17:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10889','403','1','6342','4.99','2005-07-11T19:48:24.000','2006-02-15T22:17:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10890','403','1','7103','4.99','2005-07-27T05:08:59.000','2006-02-15T22:17:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10891','403','2','8013','5.99','2005-07-28T15:30:26.000','2006-02-15T22:17:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10892','403','1','9058','2.99','2005-07-30T07:15:45.000','2006-02-15T22:17:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10893','403','2','9486','7.99','2005-07-30T23:35:42.000','2006-02-15T22:17:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10894','403','2','9794','4.99','2005-07-31T10:47:01.000','2006-02-15T22:17:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10895','403','2','10109','5.99','2005-07-31T21:04:49.000','2006-02-15T22:17:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10896','403','1','10443','2.99','2005-08-01T09:01:04.000','2006-02-15T22:17:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10897','403','1','10547','6.99','2005-08-01T12:44:17.000','2006-02-15T22:17:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10898','403','2','10789','2.99','2005-08-01T21:37:55.000','2006-02-15T22:17:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10899','403','1','11038','7.99','2005-08-02T05:59:42.000','2006-02-15T22:17:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10900','403','2','11391','9.99','2005-08-02T18:40:12.000','2006-02-15T22:17:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10901','403','2','11427','2.99','2005-08-02T20:02:39.000','2006-02-15T22:17:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10902','403','2','11460','0.99','2005-08-02T21:28:03.000','2006-02-15T22:17:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10903','403','2','11558','0.99','2005-08-17T01:19:52.000','2006-02-15T22:17:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10904','403','2','12005','5.99','2005-08-17T18:56:55.000','2006-02-15T22:17:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10905','403','1','12132','2.99','2005-08-17T23:37:03.000','2006-02-15T22:17:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10906','403','1','12793','5.99','2005-08-19T00:20:36.000','2006-02-15T22:17:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10907','403','1','14519','2.99','2005-08-21T14:59:29.000','2006-02-15T22:17:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10908','403','1','14662','0.99','2005-08-21T19:45:27.000','2006-02-15T22:17:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10909','403','2','14725','4.99','2005-08-21T22:02:08.000','2006-02-15T22:17:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10910','403','1','15410','4.99','2005-08-22T23:27:43.000','2006-02-15T22:17:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10911','404','2','1081','5.99','2005-05-31T10:56:32.000','2006-02-15T22:17:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10912','404','2','1506','2.99','2005-06-15T22:19:37.000','2006-02-15T22:17:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10913','404','2','1840','4.99','2005-06-16T23:39:34.000','2006-02-15T22:17:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10914','404','1','2715','4.99','2005-06-19T14:29:35.000','2006-02-15T22:17:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10915','404','1','2951','2.99','2005-06-20T06:23:01.000','2006-02-15T22:17:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10916','404','1','3927','2.99','2005-07-06T20:48:14.000','2006-02-15T22:17:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10917','404','1','4495','2.99','2005-07-08T01:43:46.000','2006-02-15T22:17:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10918','404','2','4615','8.99','2005-07-08T07:46:53.000','2006-02-15T22:17:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10919','404','1','4653','4.99','2005-07-08T09:48:01.000','2006-02-15T22:17:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10920','404','1','4963','4.99','2005-07-08T23:38:40.000','2006-02-15T22:17:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10921','404','1','5632','3.99','2005-07-10T06:17:06.000','2006-02-15T22:17:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10922','404','1','6114','1.99','2005-07-11T07:33:48.000','2006-02-15T22:17:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10923','404','2','6779','0.99','2005-07-12T16:10:50.000','2006-02-15T22:17:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10924','404','1','6964','4.99','2005-07-27T00:15:04.000','2006-02-15T22:17:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10925','404','1','8058','5.99','2005-07-28T17:07:49.000','2006-02-15T22:17:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10926','404','1','8455','3.99','2005-07-29T07:53:06.000','2006-02-15T22:17:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10927','404','1','9206','4.99','2005-07-30T12:46:59.000','2006-02-15T22:17:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10928','404','1','9472','4.99','2005-07-30T23:03:32.000','2006-02-15T22:17:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10929','404','2','9824','2.99','2005-07-31T11:49:55.000','2006-02-15T22:17:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10930','404','1','10651','2.99','2005-08-01T16:20:22.000','2006-02-15T22:17:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10931','404','1','12325','5.99','2005-08-18T06:41:30.000','2006-02-15T22:17:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10932','404','1','12554','8.99','2005-08-18T14:47:28.000','2006-02-15T22:17:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10933','404','2','13412','5.99','2005-08-19T22:46:35.000','2006-02-15T22:17:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10934','404','1','13422','4.99','2005-08-19T23:07:24.000','2006-02-15T22:17:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10935','404','1','14691','0.99','2005-08-21T20:42:29.000','2006-02-15T22:17:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10936','404','2','14835','5.99','2005-08-22T01:49:07.000','2006-02-15T22:17:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10937','404','2','14838','4.99','2005-08-22T01:57:34.000','2006-02-15T22:17:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10938','404','2','14912','4.99','2005-08-22T04:51:42.000','2006-02-15T22:17:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10939','404','2','15087','0.99','2005-08-22T11:24:09.000','2006-02-15T22:17:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10940','404','2','15290','10.99','2005-08-22T19:28:02.000','2006-02-15T22:17:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10941','405','1','121','2.99','2005-05-25T19:41:29.000','2006-02-15T22:17:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10942','405','2','770','4.99','2005-05-29T12:56:50.000','2006-02-15T22:17:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10943','405','2','1315','4.99','2005-06-15T10:23:08.000','2006-02-15T22:17:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10944','405','1','1888','0.99','2005-06-17T03:58:36.000','2006-02-15T22:17:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10945','405','2','1953','5.99','2005-06-17T08:34:57.000','2006-02-15T22:17:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10946','405','2','2654','3.99','2005-06-19T10:37:54.000','2006-02-15T22:17:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10947','405','1','3240','4.99','2005-06-21T02:53:17.000','2006-02-15T22:17:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10948','405','1','3253','5.99','2005-06-21T03:25:37.000','2006-02-15T22:17:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10949','405','2','4223','0.99','2005-07-07T12:23:54.000','2006-02-15T22:17:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10950','405','2','4401','0.99','2005-07-07T21:26:27.000','2006-02-15T22:17:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10951','405','2','5040','7.99','2005-07-09T03:16:34.000','2006-02-15T22:17:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10952','405','1','5231','0.99','2005-07-09T12:35:02.000','2006-02-15T22:17:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10953','405','2','5512','1.99','2005-07-10T01:05:38.000','2006-02-15T22:17:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10954','405','1','6110','2.99','2005-07-11T07:23:47.000','2006-02-15T22:17:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10955','405','1','7455','2.99','2005-07-27T18:34:41.000','2006-02-15T22:17:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10956','405','1','7759','0.99','2005-07-28T06:28:45.000','2006-02-15T22:17:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10957','405','2','8482','2.99','2005-07-29T08:46:33.000','2006-02-15T22:17:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10958','405','1','8955','5.99','2005-07-30T03:28:27.000','2006-02-15T22:17:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10959','405','1','9569','0.99','2005-07-31T02:39:38.000','2006-02-15T22:17:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10960','405','1','10472','4.99','2005-08-01T09:54:41.000','2006-02-15T22:17:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10961','405','2','10823','4.99','2005-08-01T22:59:10.000','2006-02-15T22:17:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10962','405','1','11345','7.99','2005-08-02T17:14:19.000','2006-02-15T22:17:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10963','405','1','12050','0.99','2005-08-17T20:55:25.000','2006-02-15T22:17:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10964','405','2','12425','5.99','2005-08-18T10:18:06.000','2006-02-15T22:17:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10965','405','1','13304','1.99','2005-08-19T18:56:32.000','2006-02-15T22:17:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10966','405','1','13398','0.99','2005-08-19T22:08:48.000','2006-02-15T22:17:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10967','405','1','14274','4.99','2005-08-21T06:29:20.000','2006-02-15T22:17:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10968','405','2','14537','0.99','2005-08-21T15:24:24.000','2006-02-15T22:17:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10969','405','1','15072','1.99','2005-08-22T10:58:45.000','2006-02-15T22:17:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10970','405','2','15383','2.99','2005-08-22T22:31:20.000','2006-02-15T22:17:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10971','405','1','15932','4.99','2005-08-23T18:31:40.000','2006-02-15T22:17:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10972','405','1','12792','0.99','2006-02-14T15:16:03.000','2006-02-15T22:17:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10973','406','1','855','0.99','2005-05-30T02:00:28.000','2006-02-15T22:17:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10974','406','1','2113','4.99','2005-06-17T19:57:46.000','2006-02-15T22:17:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10975','406','2','2150','3.99','2005-06-17T22:50:36.000','2006-02-15T22:17:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10976','406','1','2241','2.99','2005-06-18T04:31:41.000','2006-02-15T22:17:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10977','406','2','2325','0.99','2005-06-18T10:08:07.000','2006-02-15T22:17:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10978','406','2','2585','0.99','2005-06-19T05:05:03.000','2006-02-15T22:17:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10979','406','1','3186','7.99','2005-06-20T23:04:20.000','2006-02-15T22:17:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10980','406','1','3306','4.99','2005-06-21T07:46:58.000','2006-02-15T22:17:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10981','406','2','4264','4.99','2005-07-07T14:25:28.000','2006-02-15T22:17:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10982','406','2','5098','4.99','2005-07-09T06:13:54.000','2006-02-15T22:17:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10983','406','2','5263','0.99','2005-07-09T14:10:36.000','2006-02-15T22:17:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10984','406','1','5766','0.99','2005-07-10T13:07:31.000','2006-02-15T22:17:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10985','406','2','6439','2.99','2005-07-12T00:23:48.000','2006-02-15T22:17:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10986','406','2','7109','5.99','2005-07-27T05:28:57.000','2006-02-15T22:17:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10987','406','1','7171','4.99','2005-07-27T07:58:35.000','2006-02-15T22:17:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10988','406','1','7259','4.99','2005-07-27T11:06:00.000','2006-02-15T22:17:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10989','406','2','7604','7.99','2005-07-27T23:54:52.000','2006-02-15T22:17:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10990','406','2','8080','4.99','2005-07-28T18:05:06.000','2006-02-15T22:17:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10991','406','2','8295','2.99','2005-07-29T02:42:14.000','2006-02-15T22:17:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10992','406','2','8630','0.99','2005-07-29T14:07:59.000','2006-02-15T22:17:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10993','406','1','8903','0.99','2005-07-30T01:08:06.000','2006-02-15T22:17:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10994','406','2','8962','1.99','2005-07-30T03:43:45.000','2006-02-15T22:17:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10995','406','2','9224','0.99','2005-07-30T13:25:37.000','2006-02-15T22:17:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10996','406','1','9291','4.99','2005-07-30T16:03:39.000','2006-02-15T22:17:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10997','406','2','9487','2.99','2005-07-30T23:40:22.000','2006-02-15T22:17:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10998','406','1','9660','8.99','2005-07-31T06:03:17.000','2006-02-15T22:17:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('10999','406','1','10632','1.99','2005-08-01T15:36:56.000','2006-02-15T22:17:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11000','406','1','11603','4.99','2005-08-17T03:22:10.000','2006-02-15T22:17:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11001','406','2','12505','5.99','2005-08-18T13:17:30.000','2006-02-15T22:17:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11002','406','2','14205','6.99','2005-08-21T03:57:15.000','2006-02-15T22:17:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11003','406','2','14421','2.99','2005-08-21T11:20:21.000','2006-02-15T22:17:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11004','406','2','14601','2.99','2005-08-21T17:45:52.000','2006-02-15T22:17:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11005','407','1','619','7.99','2005-05-28T15:52:26.000','2006-02-15T22:17:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11006','407','1','1698','2.99','2005-06-16T13:04:42.000','2006-02-15T22:17:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11007','407','2','2597','0.99','2005-06-19T05:53:46.000','2006-02-15T22:17:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11008','407','1','4296','0.99','2005-07-07T16:16:03.000','2006-02-15T22:17:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11009','407','1','5070','4.99','2005-07-09T04:58:26.000','2006-02-15T22:17:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11010','407','2','5590','9.99','2005-07-10T04:23:11.000','2006-02-15T22:17:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11011','407','1','6727','0.99','2005-07-12T13:54:25.000','2006-02-15T22:17:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11012','407','1','7363','5.99','2005-07-27T14:58:29.000','2006-02-15T22:17:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11013','407','2','7643','4.99','2005-07-28T01:19:44.000','2006-02-15T22:17:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11014','407','1','8078','2.99','2005-07-28T17:54:42.000','2006-02-15T22:17:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11015','407','1','8109','4.99','2005-07-28T19:07:44.000','2006-02-15T22:17:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11016','407','1','8197','9.99','2005-07-28T23:04:10.000','2006-02-15T22:17:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11017','407','2','8571','0.99','2005-07-29T11:48:39.000','2006-02-15T22:17:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11018','407','1','8802','2.99','2005-07-29T21:25:51.000','2006-02-15T22:17:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11019','407','2','10774','4.99','2005-08-01T20:54:33.000','2006-02-15T22:17:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11020','407','1','11214','8.99','2005-08-02T12:19:50.000','2006-02-15T22:17:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11021','407','1','11222','2.99','2005-08-02T12:32:28.000','2006-02-15T22:18:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11022','407','2','11382','5.99','2005-08-02T18:20:52.000','2006-02-15T22:18:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11023','407','2','11518','4.99','2005-08-16T23:59:49.000','2006-02-15T22:18:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11024','407','1','11677','0.99','2005-08-17T06:06:26.000','2006-02-15T22:18:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11025','407','2','12566','0.99','2005-08-18T15:13:04.000','2006-02-15T22:18:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11026','407','2','12931','2.99','2005-08-19T05:11:47.000','2006-02-15T22:18:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11027','407','1','13800','0.99','2005-08-20T12:40:48.000','2006-02-15T22:18:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11028','407','2','13856','6.99','2005-08-20T14:49:32.000','2006-02-15T22:18:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11029','407','2','14401','6.99','2005-08-21T10:36:20.000','2006-02-15T22:18:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11030','407','2','15320','0.99','2005-08-22T20:17:49.000','2006-02-15T22:18:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11031','407','2','15334','1.99','2005-08-22T20:44:35.000','2006-02-15T22:18:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11032','408','2','3','3.99','2005-05-24T23:03:39.000','2006-02-15T22:18:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11033','408','2','59','5.99','2005-05-25T08:56:42.000','2006-02-15T22:18:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11034','408','1','526','2.99','2005-05-28T04:27:37.000','2006-02-15T22:18:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11035','408','2','2479','4.99','2005-06-18T21:03:08.000','2006-02-15T22:18:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11036','408','1','2564','2.99','2005-06-19T03:41:10.000','2006-02-15T22:18:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11037','408','2','2728','2.99','2005-06-19T15:04:04.000','2006-02-15T22:18:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11038','408','2','4330','3.99','2005-07-07T18:09:41.000','2006-02-15T22:18:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11039','408','2','5073','0.99','2005-07-09T05:02:35.000','2006-02-15T22:18:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11040','408','1','6062','0.99','2005-07-11T04:11:58.000','2006-02-15T22:18:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11041','408','2','6203','4.99','2005-07-11T12:28:57.000','2006-02-15T22:18:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11042','408','2','6826','2.99','2005-07-12T18:32:02.000','2006-02-15T22:18:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11043','408','1','7053','4.99','2005-07-27T03:38:54.000','2006-02-15T22:18:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11044','408','2','7996','4.99','2005-07-28T15:00:49.000','2006-02-15T22:18:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11045','408','2','8251','4.99','2005-07-29T00:50:14.000','2006-02-15T22:18:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11046','408','2','8469','3.99','2005-07-29T08:26:27.000','2006-02-15T22:18:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11047','408','2','8902','6.99','2005-07-30T01:08:06.000','2006-02-15T22:18:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11048','408','1','9052','0.99','2005-07-30T07:06:08.000','2006-02-15T22:18:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11049','408','2','9757','4.99','2005-07-31T09:25:14.000','2006-02-15T22:18:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11050','408','2','11115','2.99','2005-08-02T08:31:06.000','2006-02-15T22:18:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11051','408','1','12140','2.99','2005-08-17T23:57:55.000','2006-02-15T22:18:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11052','408','1','12338','4.99','2005-08-18T07:04:24.000','2006-02-15T22:18:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11053','408','1','12498','2.99','2005-08-18T13:01:08.000','2006-02-15T22:18:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11054','408','2','12900','0.99','2005-08-19T04:03:49.000','2006-02-15T22:18:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11055','408','1','13508','7.99','2005-08-20T02:12:54.000','2006-02-15T22:18:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11056','408','2','13744','3.99','2005-08-20T10:51:45.000','2006-02-15T22:18:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11057','408','1','13944','2.99','2005-08-20T17:41:16.000','2006-02-15T22:18:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11058','408','2','14733','4.99','2005-08-21T22:22:33.000','2006-02-15T22:18:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11059','408','1','15628','2.99','2005-08-23T07:28:04.000','2006-02-15T22:18:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11060','408','2','15716','1.99','2005-08-23T11:02:00.000','2006-02-15T22:18:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11061','408','1','15765','6.99','2005-08-23T13:06:19.000','2006-02-15T22:18:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11062','409','1','310','6.99','2005-05-26T22:41:07.000','2006-02-15T22:18:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11063','409','2','1226','5.99','2005-06-15T03:46:10.000','2006-02-15T22:18:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11064','409','2','2310','8.99','2005-06-18T08:45:59.000','2006-02-15T22:18:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11065','409','1','3866','5.99','2005-07-06T17:47:20.000','2006-02-15T22:18:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11066','409','2','4550','4.99','2005-07-08T04:34:00.000','2006-02-15T22:18:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11067','409','1','5175','3.99','2005-07-09T09:34:28.000','2006-02-15T22:18:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11068','409','2','5306','5.99','2005-07-09T15:56:45.000','2006-02-15T22:18:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11069','409','1','5422','0.99','2005-07-09T20:55:47.000','2006-02-15T22:18:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11070','409','1','5848','2.99','2005-07-10T17:28:14.000','2006-02-15T22:18:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11071','409','1','5955','7.99','2005-07-10T23:22:10.000','2006-02-15T22:18:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11072','409','2','6026','4.99','2005-07-11T02:21:43.000','2006-02-15T22:18:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11073','409','1','6596','2.99','2005-07-12T07:32:59.000','2006-02-15T22:18:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11074','409','2','7673','2.99','2005-07-28T02:53:53.000','2006-02-15T22:18:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11075','409','2','7940','0.99','2005-07-28T12:46:47.000','2006-02-15T22:18:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11076','409','1','8037','4.99','2005-07-28T16:31:20.000','2006-02-15T22:18:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11077','409','2','8265','5.99','2005-07-29T01:20:15.000','2006-02-15T22:18:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11078','409','1','8726','1.99','2005-07-29T18:09:22.000','2006-02-15T22:18:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11079','409','2','9267','0.99','2005-07-30T14:59:05.000','2006-02-15T22:18:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11080','409','2','12830','0.99','2005-08-19T01:40:25.000','2006-02-15T22:18:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11081','409','1','13392','8.99','2005-08-19T22:03:22.000','2006-02-15T22:18:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11082','409','2','13632','6.99','2005-08-20T07:10:52.000','2006-02-15T22:18:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11083','409','1','14103','1.99','2005-08-21T00:37:00.000','2006-02-15T22:18:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11084','409','1','14697','4.99','2005-08-21T20:49:21.000','2006-02-15T22:18:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11085','410','1','1514','2.99','2005-06-15T22:57:34.000','2006-02-15T22:18:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11086','410','1','2073','2.99','2005-06-17T16:33:59.000','2006-02-15T22:18:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11087','410','1','2255','4.99','2005-06-18T05:21:12.000','2006-02-15T22:18:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11088','410','2','2400','5.99','2005-06-18T16:10:46.000','2006-02-15T22:18:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11089','410','2','2971','0.99','2005-06-20T07:56:00.000','2006-02-15T22:18:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11090','410','1','3249','4.99','2005-06-21T03:13:19.000','2006-02-15T22:18:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11091','410','2','4062','0.99','2005-07-07T04:22:27.000','2006-02-15T22:18:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11092','410','1','4267','0.99','2005-07-07T14:35:30.000','2006-02-15T22:18:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11093','410','1','5150','3.99','2005-07-09T08:28:40.000','2006-02-15T22:18:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11094','410','1','5192','4.99','2005-07-09T10:27:09.000','2006-02-15T22:18:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11095','410','2','5330','5.99','2005-07-09T16:53:57.000','2006-02-15T22:18:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11096','410','1','5336','2.99','2005-07-09T17:01:08.000','2006-02-15T22:18:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11097','410','1','6148','4.99','2005-07-11T09:14:22.000','2006-02-15T22:18:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11098','410','2','6218','5.99','2005-07-11T13:14:58.000','2006-02-15T22:18:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11099','410','2','7350','4.99','2005-07-27T14:34:14.000','2006-02-15T22:18:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11100','410','2','7407','5.99','2005-07-27T16:29:04.000','2006-02-15T22:18:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11101','410','1','7523','4.99','2005-07-27T21:11:23.000','2006-02-15T22:18:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11102','410','2','8625','3.99','2005-07-29T13:59:13.000','2006-02-15T22:18:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11103','410','1','8882','0.99','2005-07-30T00:24:05.000','2006-02-15T22:18:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11104','410','1','9263','2.99','2005-07-30T14:48:24.000','2006-02-15T22:18:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11105','410','1','10402','4.99','2005-08-01T07:27:19.000','2006-02-15T22:18:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11106','410','1','10837','2.99','2005-08-01T23:30:22.000','2006-02-15T22:18:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11107','410','1','11107','0.99','2005-08-02T08:19:38.000','2006-02-15T22:18:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11108','410','1','11187','10.99','2005-08-02T11:16:19.000','2006-02-15T22:18:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11109','410','1','11472','6.99','2005-08-02T21:49:06.000','2006-02-15T22:18:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11110','410','1','11694','6.99','2005-08-17T06:57:30.000','2006-02-15T22:18:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11111','410','2','12955','8.99','2005-08-19T06:05:58.000','2006-02-15T22:18:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11112','410','1','13460','4.99','2005-08-20T00:48:24.000','2006-02-15T22:18:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11113','410','2','13748','2.99','2005-08-20T10:59:54.000','2006-02-15T22:18:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11114','410','2','13948','6.99','2005-08-20T17:50:48.000','2006-02-15T22:18:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11115','410','1','14237','3.99','2005-08-21T05:15:00.000','2006-02-15T22:18:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11116','410','2','14298','4.99','2005-08-21T07:17:10.000','2006-02-15T22:18:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11117','410','1','14319','4.99','2005-08-21T08:00:55.000','2006-02-15T22:18:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11118','410','2','14819','2.99','2005-08-22T01:17:19.000','2006-02-15T22:18:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11119','410','1','15211','2.99','2005-08-22T16:40:21.000','2006-02-15T22:18:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11120','410','2','15392','3.99','2005-08-22T23:02:15.000','2006-02-15T22:18:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11121','410','1','15518','4.99','2005-08-23T03:19:34.000','2006-02-15T22:18:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11122','410','1','12665','2.99','2006-02-14T15:16:03.000','2006-02-15T22:18:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11123','411','2','686','4.99','2005-05-29T00:27:10.000','2006-02-15T22:18:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11124','411','2','972','1.99','2005-05-30T20:21:07.000','2006-02-15T22:18:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11125','411','1','1985','0.99','2005-06-17T10:31:37.000','2006-02-15T22:18:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11126','411','2','1997','2.99','2005-06-17T11:19:43.000','2006-02-15T22:18:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11127','411','2','2712','0.99','2005-06-19T14:20:13.000','2006-02-15T22:18:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11128','411','1','3928','2.99','2005-07-06T20:52:09.000','2006-02-15T22:18:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11129','411','2','4146','0.99','2005-07-07T08:30:16.000','2006-02-15T22:18:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11130','411','1','4246','2.99','2005-07-07T13:49:03.000','2006-02-15T22:18:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11131','411','2','5357','5.99','2005-07-09T18:08:59.000','2006-02-15T22:18:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11132','411','1','5800','2.99','2005-07-10T14:58:36.000','2006-02-15T22:18:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11133','411','1','7102','1.99','2005-07-27T05:07:21.000','2006-02-15T22:18:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11134','411','2','7395','0.99','2005-07-27T16:03:11.000','2006-02-15T22:18:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11135','411','1','7513','2.99','2005-07-27T20:51:04.000','2006-02-15T22:18:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11136','411','1','7813','2.99','2005-07-28T08:08:27.000','2006-02-15T22:18:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11137','411','1','8023','0.99','2005-07-28T15:53:29.000','2006-02-15T22:18:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11138','411','2','8613','5.99','2005-07-29T13:30:58.000','2006-02-15T22:18:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11139','411','2','9622','0.99','2005-07-31T04:21:45.000','2006-02-15T22:18:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11140','411','2','11294','2.99','2005-08-02T15:08:27.000','2006-02-15T22:18:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11141','411','1','11997','5.99','2005-08-17T18:34:38.000','2006-02-15T22:18:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11142','411','2','13634','0.99','2005-08-20T07:16:45.000','2006-02-15T22:18:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11143','411','2','13656','7.99','2005-08-20T08:01:07.000','2006-02-15T22:18:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11144','411','2','14480','2.99','2005-08-21T13:36:40.000','2006-02-15T22:18:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11145','411','1','14772','5.99','2005-08-21T23:50:39.000','2006-02-15T22:18:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11146','411','2','14996','2.99','2005-08-22T07:52:41.000','2006-02-15T22:18:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11147','411','1','15936','0.99','2005-08-23T18:43:11.000','2006-02-15T22:18:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11148','411','2','13246','4.99','2006-02-14T15:16:03.000','2006-02-15T22:18:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11149','412','2','191','0.99','2005-05-26T06:14:06.000','2006-02-15T22:18:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11150','412','1','333','4.99','2005-05-27T02:52:21.000','2006-02-15T22:18:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11151','412','1','717','0.99','2005-05-29T04:37:44.000','2006-02-15T22:18:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11152','412','2','1043','3.99','2005-05-31T06:11:40.000','2006-02-15T22:18:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11153','412','1','3292','2.99','2005-06-21T06:59:11.000','2006-02-15T22:18:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11154','412','2','3888','0.99','2005-07-06T18:54:20.000','2006-02-15T22:18:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11155','412','2','4074','0.99','2005-07-07T04:49:49.000','2006-02-15T22:18:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11156','412','1','8036','0.99','2005-07-28T16:27:43.000','2006-02-15T22:18:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11157','412','2','8330','8.99','2005-07-29T04:09:07.000','2006-02-15T22:18:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11158','412','1','8411','8.99','2005-07-29T06:44:23.000','2006-02-15T22:18:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11159','412','1','8674','0.99','2005-07-29T15:54:22.000','2006-02-15T22:18:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11160','412','1','9881','4.99','2005-07-31T13:50:38.000','2006-02-15T22:18:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11161','412','2','10381','2.99','2005-08-01T06:36:37.000','2006-02-15T22:18:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11162','412','1','10467','5.99','2005-08-01T09:45:58.000','2006-02-15T22:18:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11163','412','2','11027','4.99','2005-08-02T05:47:10.000','2006-02-15T22:18:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11164','412','1','14068','3.99','2005-08-20T22:50:59.000','2006-02-15T22:18:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11165','412','1','14535','6.99','2005-08-21T15:22:37.000','2006-02-15T22:18:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11166','412','2','15354','4.99','2005-08-22T21:18:59.000','2006-02-15T22:18:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11167','412','2','15732','4.99','2005-08-23T11:35:12.000','2006-02-15T22:18:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11168','412','1','15781','8.99','2005-08-23T13:41:05.000','2006-02-15T22:18:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11169','412','1','15314','0.99','2006-02-14T15:16:03.000','2006-02-15T22:18:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11170','413','1','40','4.99','2005-05-25T05:09:04.000','2006-02-15T22:18:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11171','413','1','999','4.99','2005-05-31T00:25:10.000','2006-02-15T22:18:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11172','413','2','2130','5.99','2005-06-17T21:00:44.000','2006-02-15T22:18:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11173','413','2','2545','4.99','2005-06-19T02:23:36.000','2006-02-15T22:18:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11174','413','1','3762','4.99','2005-07-06T12:52:49.000','2006-02-15T22:18:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11175','413','2','4491','0.99','2005-07-08T01:30:46.000','2006-02-15T22:18:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11176','413','1','5897','7.99','2005-07-10T20:16:14.000','2006-02-15T22:18:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11177','413','2','7100','4.99','2005-07-27T05:05:01.000','2006-02-15T22:18:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11178','413','1','7635','0.99','2005-07-28T01:08:11.000','2006-02-15T22:18:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11179','413','2','7731','0.99','2005-07-28T05:01:18.000','2006-02-15T22:18:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11180','413','1','10909','2.99','2005-08-02T01:53:59.000','2006-02-15T22:18:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11181','413','2','11304','2.99','2005-08-02T15:40:10.000','2006-02-15T22:18:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11182','413','1','11468','0.99','2005-08-02T21:47:26.000','2006-02-15T22:18:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11183','413','1','11532','0.99','2005-08-17T00:34:14.000','2006-02-15T22:18:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11184','413','2','12552','2.99','2005-08-18T14:46:34.000','2006-02-15T22:18:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11185','413','1','13010','3.99','2005-08-19T07:52:21.000','2006-02-15T22:18:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11186','413','1','13318','2.99','2005-08-19T19:33:57.000','2006-02-15T22:18:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11187','413','2','13824','4.99','2005-08-20T13:43:12.000','2006-02-15T22:18:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11188','413','2','13887','4.99','2005-08-20T15:39:00.000','2006-02-15T22:18:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11189','413','1','14773','2.99','2005-08-21T23:50:57.000','2006-02-15T22:18:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11190','413','1','15678','2.99','2005-08-23T09:23:45.000','2006-02-15T22:18:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11191','414','1','85','4.99','2005-05-25T13:05:34.000','2006-02-15T22:18:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11192','414','1','261','3.99','2005-05-26T15:44:23.000','2006-02-15T22:18:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11193','414','1','2246','4.99','2005-06-18T04:54:29.000','2006-02-15T22:18:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11194','414','1','2559','9.99','2005-06-19T03:09:46.000','2006-02-15T22:18:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11195','414','1','3318','5.99','2005-06-21T08:23:05.000','2006-02-15T22:18:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11196','414','1','3957','10.99','2005-07-06T22:05:47.000','2006-02-15T22:18:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11197','414','1','4437','3.99','2005-07-07T22:55:41.000','2006-02-15T22:18:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11198','414','2','6462','7.99','2005-07-12T01:15:24.000','2006-02-15T22:18:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11199','414','2','6728','0.99','2005-07-12T13:56:48.000','2006-02-15T22:18:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11200','414','2','6845','0.99','2005-07-12T19:20:41.000','2006-02-15T22:18:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11201','414','1','7009','0.99','2005-07-27T01:45:44.000','2006-02-15T22:18:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11202','414','1','7779','2.99','2005-07-28T07:11:11.000','2006-02-15T22:18:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11203','414','1','9650','2.99','2005-07-31T05:47:32.000','2006-02-15T22:18:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11204','414','2','9991','2.99','2005-07-31T17:26:27.000','2006-02-15T22:18:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11205','414','2','10107','5.99','2005-07-31T21:01:46.000','2006-02-15T22:18:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11206','414','1','11706','0.99','2005-08-17T07:23:46.000','2006-02-15T22:18:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11207','414','2','12930','4.99','2005-08-19T05:11:32.000','2006-02-15T22:18:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11208','414','1','13042','0.99','2005-08-19T09:06:08.000','2006-02-15T22:18:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11209','414','1','13242','2.99','2005-08-19T16:28:47.000','2006-02-15T22:18:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11210','414','1','13308','7.99','2005-08-19T18:59:42.000','2006-02-15T22:18:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11211','414','1','13404','0.99','2005-08-19T22:18:42.000','2006-02-15T22:18:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11212','414','2','13494','2.99','2005-08-20T01:36:34.000','2006-02-15T22:18:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11213','414','2','13657','4.99','2005-08-20T08:01:39.000','2006-02-15T22:18:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11214','414','1','15140','6.99','2005-08-22T13:39:20.000','2006-02-15T22:18:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11215','414','2','15481','0.99','2005-08-23T01:59:14.000','2006-02-15T22:18:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11216','415','2','665','4.99','2005-05-28T21:38:39.000','2006-02-15T22:18:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11217','415','2','1867','4.99','2005-06-17T02:01:37.000','2006-02-15T22:18:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11218','415','1','3211','2.99','2005-06-21T01:01:29.000','2006-02-15T22:18:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11219','415','2','4926','8.99','2005-07-08T22:01:48.000','2006-02-15T22:18:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11220','415','2','5665','0.99','2005-07-10T08:10:08.000','2006-02-15T22:18:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11221','415','2','5733','0.99','2005-07-10T11:37:24.000','2006-02-15T22:18:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11222','415','2','6491','5.99','2005-07-12T02:28:31.000','2006-02-15T22:18:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11223','415','1','6505','3.99','2005-07-12T03:27:37.000','2006-02-15T22:18:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11224','415','1','7379','4.99','2005-07-27T15:36:43.000','2006-02-15T22:18:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11225','415','2','7624','0.99','2005-07-28T00:37:44.000','2006-02-15T22:18:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11226','415','1','7748','4.99','2005-07-28T05:52:23.000','2006-02-15T22:18:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11227','415','2','8317','2.99','2005-07-29T03:39:07.000','2006-02-15T22:18:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11228','415','2','9586','2.99','2005-07-31T03:07:16.000','2006-02-15T22:18:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11229','415','1','9852','2.99','2005-07-31T12:52:17.000','2006-02-15T22:18:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11230','415','1','10263','5.99','2005-08-01T03:02:48.000','2006-02-15T22:18:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11231','415','1','10553','2.99','2005-08-01T12:54:06.000','2006-02-15T22:18:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11232','415','2','11310','1.99','2005-08-02T15:51:58.000','2006-02-15T22:18:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11233','415','2','12128','5.99','2005-08-17T23:31:09.000','2006-02-15T22:18:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11234','415','2','12588','2.99','2005-08-18T16:04:45.000','2006-02-15T22:18:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11235','415','2','13729','8.99','2005-08-20T10:17:08.000','2006-02-15T22:18:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11236','415','1','14992','4.99','2005-08-22T07:51:47.000','2006-02-15T22:18:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11237','415','2','15121','4.99','2005-08-22T12:46:37.000','2006-02-15T22:18:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11238','415','1','15959','0.99','2005-08-23T19:27:04.000','2006-02-15T22:18:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11239','416','2','253','0.99','2005-05-26T14:43:14.000','2006-02-15T22:18:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11240','416','2','724','3.99','2005-05-29T05:53:23.000','2006-02-15T22:18:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11241','416','2','1031','2.99','2005-05-31T04:23:01.000','2006-02-15T22:18:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11242','416','2','1158','2.99','2005-06-14T22:53:33.000','2006-02-15T22:18:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11243','416','1','1343','4.99','2005-06-15T12:27:19.000','2006-02-15T22:18:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11244','416','2','1553','0.99','2005-06-16T02:02:44.000','2006-02-15T22:18:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11245','416','2','1596','2.99','2005-06-16T05:30:58.000','2006-02-15T22:18:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11246','416','2','1771','0.99','2005-06-16T18:12:17.000','2006-02-15T22:18:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11247','416','1','3833','3.99','2005-07-06T16:18:28.000','2006-02-15T22:18:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11248','416','1','3868','2.99','2005-07-06T17:54:13.000','2006-02-15T22:18:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11249','416','1','6097','2.99','2005-07-11T06:21:43.000','2006-02-15T22:18:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11250','416','1','6879','7.99','2005-07-12T20:37:37.000','2006-02-15T22:18:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11251','416','1','7889','0.99','2005-07-28T10:43:21.000','2006-02-15T22:18:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11252','416','1','7917','2.99','2005-07-28T11:56:57.000','2006-02-15T22:18:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11253','416','2','8349','5.99','2005-07-29T04:50:22.000','2006-02-15T22:18:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11254','416','2','8588','2.99','2005-07-29T12:22:20.000','2006-02-15T22:18:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11255','416','2','8648','2.99','2005-07-29T14:56:21.000','2006-02-15T22:18:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11256','416','2','9383','2.99','2005-07-30T19:24:50.000','2006-02-15T22:18:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11257','416','1','10254','3.99','2005-08-01T02:42:03.000','2006-02-15T22:18:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11258','416','1','10354','2.99','2005-08-01T05:47:10.000','2006-02-15T22:18:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11259','416','1','10742','6.99','2005-08-01T19:53:13.000','2006-02-15T22:18:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11260','416','1','10937','6.99','2005-08-02T03:00:18.000','2006-02-15T22:18:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11261','416','2','11047','5.99','2005-08-02T06:09:20.000','2006-02-15T22:18:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11262','416','1','11557','6.99','2005-08-17T01:19:20.000','2006-02-15T22:18:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11263','416','1','12722','8.99','2005-08-18T21:33:53.000','2006-02-15T22:18:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11264','416','1','12932','4.99','2005-08-19T05:17:30.000','2006-02-15T22:18:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11265','416','1','14239','4.99','2005-08-21T05:18:57.000','2006-02-15T22:18:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11266','416','1','15235','1.99','2005-08-22T17:43:12.000','2006-02-15T22:18:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11267','416','2','15470','4.99','2005-08-23T01:35:12.000','2006-02-15T22:18:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11268','416','1','15727','2.99','2005-08-23T11:28:49.000','2006-02-15T22:18:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11269','416','2','15761','0.99','2005-08-23T12:55:51.000','2006-02-15T22:18:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11270','417','1','267','4.99','2005-05-26T16:16:21.000','2006-02-15T22:18:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11271','417','2','630','8.99','2005-05-28T17:24:51.000','2006-02-15T22:18:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11272','417','2','833','4.99','2005-05-29T23:21:56.000','2006-02-15T22:18:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11273','417','1','1921','3.99','2005-06-17T06:04:16.000','2006-02-15T22:18:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11274','417','1','3952','4.99','2005-07-06T21:51:31.000','2006-02-15T22:18:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11275','417','1','4418','2.99','2005-07-07T22:05:30.000','2006-02-15T22:18:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11276','417','1','4421','9.99','2005-07-07T22:07:55.000','2006-02-15T22:18:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11277','417','2','6258','6.99','2005-07-11T15:24:32.000','2006-02-15T22:18:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11278','417','1','6312','4.99','2005-07-11T18:19:02.000','2006-02-15T22:18:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11279','417','1','8877','2.99','2005-07-30T00:15:22.000','2006-02-15T22:18:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11280','417','2','9049','2.99','2005-07-30T06:57:28.000','2006-02-15T22:18:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11281','417','1','10478','0.99','2005-08-01T10:09:06.000','2006-02-15T22:18:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11282','417','1','11217','7.99','2005-08-02T12:26:31.000','2006-02-15T22:18:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11283','417','1','11291','6.99','2005-08-02T14:57:58.000','2006-02-15T22:18:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11284','417','2','11303','0.99','2005-08-02T15:39:18.000','2006-02-15T22:18:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11285','417','2','12074','0.99','2005-08-17T21:50:57.000','2006-02-15T22:18:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11286','417','2','12281','4.99','2005-08-18T04:50:32.000','2006-02-15T22:18:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11287','417','1','13545','4.99','2005-08-20T03:50:15.000','2006-02-15T22:18:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11288','417','1','13927','1.99','2005-08-20T17:11:58.000','2006-02-15T22:18:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11289','417','2','14121','4.99','2005-08-21T01:26:33.000','2006-02-15T22:18:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11290','417','1','14304','6.99','2005-08-21T07:23:10.000','2006-02-15T22:18:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11291','417','1','14607','2.99','2005-08-21T17:56:50.000','2006-02-15T22:18:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11292','417','2','14882','2.99','2005-08-22T03:52:21.000','2006-02-15T22:18:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11293','417','1','15795','0.99','2005-08-23T14:07:56.000','2006-02-15T22:18:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11294','417','2','13261','2.99','2006-02-14T15:16:03.000','2006-02-15T22:18:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11295','418','1','2825','2.99','2005-06-19T20:32:19.000','2006-02-15T22:18:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11296','418','2','2943','2.99','2005-06-20T05:43:05.000','2006-02-15T22:18:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11297','418','2','2969','2.99','2005-06-20T07:44:27.000','2006-02-15T22:18:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11298','418','1','3805','0.99','2005-07-06T15:08:42.000','2006-02-15T22:18:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11299','418','2','4852','7.99','2005-07-08T18:43:15.000','2006-02-15T22:18:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11300','418','1','4865','2.99','2005-07-08T19:09:04.000','2006-02-15T22:18:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11301','418','1','4938','0.99','2005-07-08T22:32:53.000','2006-02-15T22:18:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11302','418','1','6150','4.99','2005-07-11T09:23:56.000','2006-02-15T22:18:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11303','418','1','6970','4.99','2005-07-27T00:26:14.000','2006-02-15T22:18:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11304','418','2','8546','5.99','2005-07-29T11:08:48.000','2006-02-15T22:18:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11305','418','2','8591','0.99','2005-07-29T12:32:33.000','2006-02-15T22:18:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11306','418','2','8886','10.99','2005-07-30T00:36:31.000','2006-02-15T22:18:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11307','418','1','9558','4.99','2005-07-31T02:14:35.000','2006-02-15T22:18:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11308','418','2','10537','5.99','2005-08-01T12:22:28.000','2006-02-15T22:18:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11309','418','1','10709','0.99','2005-08-01T18:43:57.000','2006-02-15T22:18:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11310','418','2','10915','2.99','2005-08-02T02:05:04.000','2006-02-15T22:18:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11311','418','1','11270','2.99','2005-08-02T14:18:07.000','2006-02-15T22:18:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11312','418','2','11322','3.99','2005-08-02T16:23:17.000','2006-02-15T22:18:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11313','418','2','11409','1.99','2005-08-02T19:26:51.000','2006-02-15T22:18:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11314','418','1','11650','4.99','2005-08-17T05:00:03.000','2006-02-15T22:18:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11315','418','1','11769','2.99','2005-08-17T10:04:49.000','2006-02-15T22:18:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11316','418','1','11910','0.99','2005-08-17T15:44:37.000','2006-02-15T22:18:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11317','418','2','13312','0.99','2005-08-19T19:09:14.000','2006-02-15T22:18:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11318','418','1','13537','2.99','2005-08-20T03:39:15.000','2006-02-15T22:18:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11319','418','1','13970','0.99','2005-08-20T18:43:34.000','2006-02-15T22:18:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11320','418','1','14484','0.99','2005-08-21T13:47:29.000','2006-02-15T22:18:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11321','418','1','14836','4.99','2005-08-22T01:52:26.000','2006-02-15T22:18:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11322','418','2','14860','2.99','2005-08-22T02:47:07.000','2006-02-15T22:18:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11323','418','1','15466','4.99','2005-08-23T01:16:55.000','2006-02-15T22:18:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11324','418','2','15957','5.99','2005-08-23T19:21:22.000','2006-02-15T22:18:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11325','419','1','62','2.99','2005-05-25T09:18:52.000','2006-02-15T22:18:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11326','419','2','2793','2.99','2005-06-19T18:52:37.000','2006-02-15T22:18:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11327','419','1','3596','0.99','2005-07-06T05:03:11.000','2006-02-15T22:18:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11328','419','1','3694','4.99','2005-07-06T10:01:23.000','2006-02-15T22:18:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11329','419','1','4224','0.99','2005-07-07T12:24:21.000','2006-02-15T22:18:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11330','419','2','5333','5.99','2005-07-09T16:59:38.000','2006-02-15T22:18:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11331','419','2','5863','0.99','2005-07-10T18:25:23.000','2006-02-15T22:18:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11332','419','1','5900','3.99','2005-07-10T20:21:54.000','2006-02-15T22:18:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11333','419','2','5933','0.99','2005-07-10T22:06:48.000','2006-02-15T22:18:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11334','419','2','6173','0.99','2005-07-11T10:33:11.000','2006-02-15T22:18:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11335','419','2','6587','3.99','2005-07-12T06:56:26.000','2006-02-15T22:18:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11336','419','1','7362','4.99','2005-07-27T14:58:27.000','2006-02-15T22:18:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11337','419','1','7619','2.99','2005-07-28T00:25:41.000','2006-02-15T22:18:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11338','419','1','7796','4.99','2005-07-28T07:39:39.000','2006-02-15T22:18:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11339','419','1','10150','2.99','2005-07-31T22:22:00.000','2006-02-15T22:18:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11340','419','1','10372','2.99','2005-08-01T06:23:48.000','2006-02-15T22:18:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11341','419','2','11025','4.99','2005-08-02T05:39:12.000','2006-02-15T22:18:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11342','419','1','11313','2.99','2005-08-02T16:02:51.000','2006-02-15T22:18:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11343','419','2','11323','2.99','2005-08-02T16:29:57.000','2006-02-15T22:18:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11344','419','1','11425','2.99','2005-08-02T19:58:48.000','2006-02-15T22:18:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11345','419','2','11689','6.99','2005-08-17T06:42:08.000','2006-02-15T22:18:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11346','419','1','12460','7.99','2005-08-18T11:25:13.000','2006-02-15T22:18:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11347','419','1','12720','5.99','2005-08-18T21:28:42.000','2006-02-15T22:18:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11348','419','2','14308','0.99','2005-08-21T07:43:21.000','2006-02-15T22:18:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11349','419','2','15779','4.99','2005-08-23T13:33:46.000','2006-02-15T22:18:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11350','420','2','744','4.99','2005-05-29T09:13:08.000','2006-02-15T22:18:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11351','420','2','2672','3.99','2005-06-19T11:42:04.000','2006-02-15T22:18:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11352','420','1','2698','0.99','2005-06-19T13:29:11.000','2006-02-15T22:18:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11353','420','1','2726','0.99','2005-06-19T15:02:20.000','2006-02-15T22:18:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11354','420','1','4176','4.99','2005-07-07T10:03:34.000','2006-02-15T22:18:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11355','420','2','5081','4.99','2005-07-09T05:25:20.000','2006-02-15T22:18:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11356','420','1','5168','4.99','2005-07-09T09:20:01.000','2006-02-15T22:18:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11357','420','2','5911','0.99','2005-07-10T20:51:42.000','2006-02-15T22:18:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11358','420','2','6086','3.99','2005-07-11T05:29:03.000','2006-02-15T22:18:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11359','420','2','6096','4.99','2005-07-11T06:18:04.000','2006-02-15T22:18:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11360','420','2','6582','4.99','2005-07-12T06:28:12.000','2006-02-15T22:18:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11361','420','1','6588','4.99','2005-07-12T06:57:40.000','2006-02-15T22:18:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11362','420','2','7081','2.99','2005-07-27T04:25:59.000','2006-02-15T22:18:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11363','420','2','8485','0.99','2005-07-29T08:53:09.000','2006-02-15T22:18:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11364','420','1','9362','0.99','2005-07-30T18:44:16.000','2006-02-15T22:18:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11365','420','2','10291','4.99','2005-08-01T03:39:57.000','2006-02-15T22:18:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11366','420','2','10601','10.99','2005-08-01T14:25:40.000','2006-02-15T22:18:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11367','420','1','10766','4.99','2005-08-01T20:36:29.000','2006-02-15T22:18:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11368','420','2','11236','5.99','2005-08-02T13:17:21.000','2006-02-15T22:18:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11369','420','2','14525','0.99','2005-08-21T15:06:49.000','2006-02-15T22:18:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11370','420','2','15597','0.99','2005-08-23T06:21:20.000','2006-02-15T22:18:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11371','421','1','507','0.99','2005-05-28T02:31:19.000','2006-02-15T22:18:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11372','421','1','931','0.99','2005-05-30T12:53:01.000','2006-02-15T22:18:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11373','421','1','1693','4.99','2005-06-16T12:39:51.000','2006-02-15T22:18:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11374','421','2','2407','2.99','2005-06-18T16:50:41.000','2006-02-15T22:18:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11375','421','1','3170','4.99','2005-06-20T22:02:54.000','2006-02-15T22:18:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11376','421','1','3491','7.99','2005-07-05T23:41:08.000','2006-02-15T22:18:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11377','421','2','3703','5.99','2005-07-06T10:15:26.000','2006-02-15T22:18:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11378','421','1','3988','8.99','2005-07-06T23:30:42.000','2006-02-15T22:18:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11379','421','2','4456','5.99','2005-07-07T23:45:21.000','2006-02-15T22:18:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11380','421','1','6220','0.99','2005-07-11T13:22:06.000','2006-02-15T22:18:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11381','421','2','6960','3.99','2005-07-27T00:08:33.000','2006-02-15T22:18:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11382','421','2','7449','4.99','2005-07-27T18:17:41.000','2006-02-15T22:18:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11383','421','2','8025','2.99','2005-07-28T16:03:27.000','2006-02-15T22:18:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11384','421','1','8268','4.99','2005-07-29T01:23:23.000','2006-02-15T22:18:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11385','421','1','8725','4.99','2005-07-29T18:08:42.000','2006-02-15T22:18:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11386','421','2','9377','4.99','2005-07-30T19:12:18.000','2006-02-15T22:18:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11387','421','2','9875','0.99','2005-07-31T13:37:41.000','2006-02-15T22:18:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11388','421','1','10200','4.99','2005-08-01T00:39:05.000','2006-02-15T22:18:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11389','421','2','11089','2.99','2005-08-02T07:52:20.000','2006-02-15T22:18:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11390','421','1','11263','4.99','2005-08-02T14:02:19.000','2006-02-15T22:18:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11391','421','1','11523','3.99','2005-08-17T00:10:10.000','2006-02-15T22:18:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11392','421','1','12279','4.99','2005-08-18T04:47:30.000','2006-02-15T22:18:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11393','421','2','13461','9.99','2005-08-20T00:49:04.000','2006-02-15T22:18:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11394','421','1','13872','4.99','2005-08-20T15:10:30.000','2006-02-15T22:18:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11395','421','1','14742','4.99','2005-08-21T22:39:01.000','2006-02-15T22:18:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11396','421','1','14887','3.99','2005-08-22T04:04:31.000','2006-02-15T22:18:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11397','421','2','15710','0.99','2006-02-14T15:16:03.000','2006-02-15T22:18:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11398','422','1','398','0.99','2005-05-27T12:44:03.000','2006-02-15T22:18:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11399','422','1','1846','0.99','2005-06-17T00:02:44.000','2006-02-15T22:18:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11400','422','1','1897','4.99','2005-06-17T04:26:23.000','2006-02-15T22:18:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11401','422','2','2747','2.99','2005-06-19T16:22:07.000','2006-02-15T22:18:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11402','422','1','2778','5.99','2005-06-19T18:18:12.000','2006-02-15T22:18:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11403','422','1','3553','4.99','2005-07-06T02:35:41.000','2006-02-15T22:18:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11404','422','2','4463','2.99','2005-07-08T00:04:59.000','2006-02-15T22:18:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11405','422','2','4504','0.99','2005-07-08T02:19:27.000','2006-02-15T22:18:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11406','422','1','5784','1.99','2005-07-10T14:03:28.000','2006-02-15T22:18:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11407','422','2','7827','0.99','2005-07-28T08:37:22.000','2006-02-15T22:18:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11408','422','2','8206','4.99','2005-07-28T23:20:31.000','2006-02-15T22:18:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11409','422','2','9541','4.99','2005-07-31T01:40:14.000','2006-02-15T22:18:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11410','422','2','10833','6.99','2005-08-01T23:25:55.000','2006-02-15T22:18:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11411','422','2','11325','6.99','2005-08-02T16:33:11.000','2006-02-15T22:18:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11412','422','1','11658','2.99','2005-08-17T05:19:17.000','2006-02-15T22:18:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11413','422','1','11842','4.99','2005-08-17T13:13:37.000','2006-02-15T22:18:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11414','422','1','12907','9.99','2005-08-19T04:16:13.000','2006-02-15T22:18:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11415','422','2','13216','1.99','2005-08-19T15:36:05.000','2006-02-15T22:18:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11416','422','2','13625','1.99','2005-08-20T06:52:03.000','2006-02-15T22:18:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11417','422','2','13709','0.99','2005-08-20T09:34:51.000','2006-02-15T22:18:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11418','422','2','13722','4.99','2005-08-20T10:03:45.000','2006-02-15T22:18:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11419','422','1','14861','4.99','2005-08-22T02:48:05.000','2006-02-15T22:18:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11420','422','1','15272','3.99','2005-08-22T18:49:40.000','2006-02-15T22:18:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11421','422','1','15273','2.99','2005-08-22T18:53:28.000','2006-02-15T22:18:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11422','422','2','15316','2.99','2005-08-22T20:07:03.000','2006-02-15T22:18:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11423','422','2','15441','2.99','2006-02-14T15:16:03.000','2006-02-15T22:18:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11424','423','1','1504','3.99','2005-06-15T22:08:06.000','2006-02-15T22:18:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11425','423','2','1827','0.99','2005-06-16T21:54:40.000','2006-02-15T22:18:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11426','423','1','2600','6.99','2005-06-19T06:07:25.000','2006-02-15T22:18:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11427','423','2','2758','6.99','2005-06-19T17:04:35.000','2006-02-15T22:18:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11428','423','1','3072','8.99','2005-06-20T14:21:31.000','2006-02-15T22:18:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11429','423','2','4105','0.99','2005-07-07T06:31:00.000','2006-02-15T22:18:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11430','423','1','4250','0.99','2005-07-07T14:08:11.000','2006-02-15T22:18:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11431','423','1','4679','2.99','2005-07-08T10:33:14.000','2006-02-15T22:18:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11432','423','1','6506','1.99','2005-07-12T03:28:22.000','2006-02-15T22:18:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11433','423','1','7016','5.99','2005-07-27T02:15:16.000','2006-02-15T22:18:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11434','423','2','7141','2.99','2005-07-27T06:55:27.000','2006-02-15T22:18:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11435','423','1','7157','4.99','2005-07-27T07:20:28.000','2006-02-15T22:18:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11436','423','1','7290','0.99','2005-07-27T12:28:45.000','2006-02-15T22:18:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11437','423','2','7539','9.99','2005-07-27T21:39:42.000','2006-02-15T22:18:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11438','423','1','7849','9.99','2005-07-28T09:30:02.000','2006-02-15T22:18:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11439','423','2','8082','3.99','2005-07-28T18:08:02.000','2006-02-15T22:18:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11440','423','2','8595','9.99','2005-07-29T12:47:43.000','2006-02-15T22:18:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11441','423','2','9026','2.99','2005-07-30T05:55:31.000','2006-02-15T22:18:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11442','423','1','10488','2.99','2005-08-01T10:27:27.000','2006-02-15T22:18:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11443','423','1','11091','2.99','2005-08-02T07:56:41.000','2006-02-15T22:18:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11444','423','2','11514','4.99','2005-08-16T23:53:10.000','2006-02-15T22:18:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11445','423','2','12806','4.99','2005-08-19T00:37:26.000','2006-02-15T22:18:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11446','423','2','14191','6.99','2005-08-21T03:35:58.000','2006-02-15T22:18:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11447','423','2','14902','4.99','2005-08-22T04:31:50.000','2006-02-15T22:18:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11448','423','1','15380','0.99','2005-08-22T22:28:15.000','2006-02-15T22:18:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11449','423','1','15755','4.99','2005-08-23T12:46:38.000','2006-02-15T22:18:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11450','424','2','403','0.99','2005-05-27T13:28:52.000','2006-02-15T22:18:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11451','424','2','3044','4.99','2005-06-20T12:38:49.000','2006-02-15T22:18:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11452','424','1','3166','6.99','2005-06-20T21:32:32.000','2006-02-15T22:18:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11453','424','2','3404','0.99','2005-06-21T15:57:52.000','2006-02-15T22:18:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11454','424','2','3746','0.99','2005-07-06T12:10:51.000','2006-02-15T22:18:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11455','424','2','4512','0.99','2005-07-08T02:38:56.000','2006-02-15T22:18:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11456','424','2','4559','0.99','2005-07-08T04:56:49.000','2006-02-15T22:18:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11457','424','2','4696','5.99','2005-07-08T11:12:27.000','2006-02-15T22:18:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11458','424','1','5568','0.99','2005-07-10T03:36:56.000','2006-02-15T22:18:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11459','424','1','5611','3.99','2005-07-10T05:13:43.000','2006-02-15T22:18:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11460','424','1','6589','2.99','2005-07-12T07:06:29.000','2006-02-15T22:18:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11461','424','1','7594','2.99','2005-07-27T23:30:41.000','2006-02-15T22:18:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11462','424','2','8194','2.99','2005-07-28T22:51:44.000','2006-02-15T22:18:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11463','424','1','8918','4.99','2005-07-30T01:56:22.000','2006-02-15T22:18:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11464','424','2','8964','1.99','2005-07-30T03:49:35.000','2006-02-15T22:18:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11465','424','2','8999','2.99','2005-07-30T04:55:46.000','2006-02-15T22:18:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11466','424','1','9471','4.99','2005-07-30T23:02:36.000','2006-02-15T22:18:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11467','424','1','9516','8.99','2005-07-31T00:40:58.000','2006-02-15T22:18:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11468','424','2','9878','4.99','2005-07-31T13:42:02.000','2006-02-15T22:18:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11469','424','1','10017','6.99','2005-07-31T18:13:22.000','2006-02-15T22:18:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11470','424','2','10369','4.99','2005-08-01T06:13:44.000','2006-02-15T22:18:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11471','424','1','10866','2.99','2005-08-02T00:22:49.000','2006-02-15T22:18:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11472','424','2','11374','2.99','2005-08-02T18:14:54.000','2006-02-15T22:18:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11473','424','2','11562','6.99','2005-08-17T01:23:39.000','2006-02-15T22:18:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11474','424','2','11833','2.99','2005-08-17T13:00:33.000','2006-02-15T22:18:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11475','424','2','12729','0.99','2005-08-18T21:52:59.000','2006-02-15T22:18:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11476','424','2','13793','3.99','2005-08-20T12:22:04.000','2006-02-15T22:18:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11477','424','2','15113','0.99','2005-08-22T12:23:59.000','2006-02-15T22:18:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11478','424','2','15941','9.99','2005-08-23T18:46:44.000','2006-02-15T22:18:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11479','424','1','15094','0.99','2006-02-14T15:16:03.000','2006-02-15T22:18:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11480','425','2','1098','5.99','2005-05-31T13:51:48.000','2006-02-15T22:18:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11481','425','1','3276','6.99','2005-06-21T05:35:52.000','2006-02-15T22:18:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11482','425','1','3807','4.99','2005-07-06T15:11:44.000','2006-02-15T22:18:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11483','425','2','4361','2.99','2005-07-07T19:33:23.000','2006-02-15T22:18:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11484','425','2','4362','5.99','2005-07-07T19:35:30.000','2006-02-15T22:18:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11485','425','2','4483','8.99','2005-07-08T01:03:12.000','2006-02-15T22:18:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11486','425','1','4659','2.99','2005-07-08T09:53:28.000','2006-02-15T22:18:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11487','425','1','4884','7.99','2005-07-08T19:49:17.000','2006-02-15T22:18:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11488','425','1','4939','7.99','2005-07-08T22:35:30.000','2006-02-15T22:18:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11489','425','2','5363','2.99','2005-07-09T18:18:49.000','2006-02-15T22:18:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11490','425','1','5371','4.99','2005-07-09T18:47:48.000','2006-02-15T22:18:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11491','425','2','6318','2.99','2005-07-11T18:48:22.000','2006-02-15T22:18:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11492','425','1','6603','2.99','2005-07-12T07:52:55.000','2006-02-15T22:18:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11493','425','1','7249','4.99','2005-07-27T10:39:53.000','2006-02-15T22:18:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11494','425','1','8974','0.99','2005-07-30T04:09:16.000','2006-02-15T22:18:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11495','425','1','9170','0.99','2005-07-30T11:35:24.000','2006-02-15T22:18:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11496','425','2','9682','2.99','2005-07-31T06:47:10.000','2006-02-15T22:18:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11497','425','1','10121','0.99','2005-07-31T21:24:53.000','2006-02-15T22:18:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11498','425','2','10163','0.99','2005-07-31T23:12:34.000','2006-02-15T22:18:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11499','425','1','10545','0.99','2005-08-01T12:37:46.000','2006-02-15T22:18:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11500','425','2','13040','0.99','2005-08-19T09:04:24.000','2006-02-15T22:18:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11501','425','2','14089','5.99','2005-08-20T23:59:02.000','2006-02-15T22:18:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11502','425','2','14881','4.99','2005-08-22T03:47:39.000','2006-02-15T22:18:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11503','425','1','15064','0.99','2005-08-22T10:41:58.000','2006-02-15T22:18:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11504','425','2','15784','6.99','2005-08-23T13:46:00.000','2006-02-15T22:18:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11505','425','2','16036','2.99','2005-08-23T22:12:44.000','2006-02-15T22:18:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11506','426','2','604','0.99','2005-05-28T14:37:07.000','2006-02-15T22:18:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11507','426','1','1709','6.99','2005-06-16T14:10:15.000','2006-02-15T22:18:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11508','426','1','1842','7.99','2005-06-16T23:45:59.000','2006-02-15T22:18:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11509','426','1','2204','2.99','2005-06-18T02:11:38.000','2006-02-15T22:18:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11510','426','1','2804','0.99','2005-06-19T19:24:54.000','2006-02-15T22:18:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11511','426','1','3243','0.99','2005-06-21T03:00:11.000','2006-02-15T22:18:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11512','426','2','4114','2.99','2005-07-07T06:51:12.000','2006-02-15T22:18:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11513','426','2','4398','4.99','2005-07-07T21:18:44.000','2006-02-15T22:18:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11514','426','1','4900','4.99','2005-07-08T20:38:06.000','2006-02-15T22:18:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11515','426','1','5725','3.99','2005-07-10T11:21:21.000','2006-02-15T22:18:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11516','426','1','7495','4.99','2005-07-27T20:01:20.000','2006-02-15T22:18:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11517','426','1','7527','10.99','2005-07-27T21:14:28.000','2006-02-15T22:18:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11518','426','1','7711','4.99','2005-07-28T04:26:42.000','2006-02-15T22:18:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11519','426','1','7789','5.99','2005-07-28T07:22:07.000','2006-02-15T22:18:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11520','426','1','9185','5.99','2005-07-30T12:10:40.000','2006-02-15T22:18:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11521','426','2','9247','4.99','2005-07-30T14:13:56.000','2006-02-15T22:18:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11522','426','2','10172','10.99','2005-07-31T23:29:51.000','2006-02-15T22:18:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11523','426','1','10505','1.99','2005-08-01T11:13:59.000','2006-02-15T22:18:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11524','426','2','11237','0.99','2005-08-02T13:24:01.000','2006-02-15T22:18:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11525','426','2','11876','0.99','2005-08-17T14:18:21.000','2006-02-15T22:18:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11526','426','2','11938','6.99','2005-08-17T16:54:54.000','2006-02-15T22:18:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11527','426','2','12548','5.99','2005-08-18T14:35:26.000','2006-02-15T22:18:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11528','426','2','12707','4.99','2005-08-18T20:52:02.000','2006-02-15T22:18:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11529','426','1','12822','4.99','2005-08-19T01:15:24.000','2006-02-15T22:18:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11530','426','2','13834','2.99','2005-08-20T14:03:08.000','2006-02-15T22:18:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11531','426','2','14151','6.99','2005-08-21T02:23:25.000','2006-02-15T22:18:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11532','426','2','14826','2.99','2005-08-22T01:32:14.000','2006-02-15T22:18:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11533','427','2','82','6.99','2005-05-25T12:17:46.000','2006-02-15T22:18:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11534','427','1','1342','5.99','2005-06-15T12:26:21.000','2006-02-15T22:18:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11535','427','2','1628','3.99','2005-06-16T07:52:55.000','2006-02-15T22:18:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11536','427','1','1648','5.99','2005-06-16T09:17:07.000','2006-02-15T22:18:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11537','427','1','1857','1.99','2005-06-17T01:12:58.000','2006-02-15T22:18:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11538','427','2','2466','0.99','2005-06-18T20:18:42.000','2006-02-15T22:18:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11539','427','1','4793','3.99','2005-07-08T16:30:01.000','2006-02-15T22:18:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11540','427','2','5476','2.99','2005-07-09T23:37:09.000','2006-02-15T22:18:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11541','427','2','5586','5.99','2005-07-10T04:17:06.000','2006-02-15T22:18:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11542','427','1','6423','6.99','2005-07-11T23:47:31.000','2006-02-15T22:18:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11543','427','1','6509','2.99','2005-07-12T03:35:01.000','2006-02-15T22:18:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11544','427','2','6938','7.99','2005-07-26T23:16:04.000','2006-02-15T22:18:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11545','427','2','8182','3.99','2005-07-28T22:19:12.000','2006-02-15T22:18:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11546','427','1','8531','5.99','2005-07-29T10:26:15.000','2006-02-15T22:18:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11547','427','2','8658','5.99','2005-07-29T15:16:37.000','2006-02-15T22:18:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11548','427','2','9978','2.99','2005-07-31T16:59:51.000','2006-02-15T22:18:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11549','427','1','10417','4.99','2005-08-01T08:10:36.000','2006-02-15T22:18:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11550','427','1','10464','5.99','2005-08-01T09:43:14.000','2006-02-15T22:18:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11551','427','2','10560','4.99','2005-08-01T13:04:57.000','2006-02-15T22:18:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11552','427','1','11024','5.99','2005-08-02T05:38:31.000','2006-02-15T22:18:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11553','427','1','13720','1.99','2005-08-20T10:01:39.000','2006-02-15T22:18:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11554','427','2','14201','6.99','2005-08-21T03:51:34.000','2006-02-15T22:18:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11555','427','1','14287','3.99','2005-08-21T06:53:59.000','2006-02-15T22:18:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11556','427','1','15330','3.99','2005-08-22T20:35:30.000','2006-02-15T22:18:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11557','428','2','634','4.99','2005-05-28T17:40:35.000','2006-02-15T22:18:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11558','428','1','1227','3.99','2005-06-15T03:50:03.000','2006-02-15T22:18:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11559','428','2','1471','2.99','2005-06-15T20:53:26.000','2006-02-15T22:18:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11560','428','1','1601','3.99','2005-06-16T06:11:13.000','2006-02-15T22:18:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11561','428','1','2677','2.99','2005-06-19T12:01:59.000','2006-02-15T22:18:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11562','428','2','3377','0.99','2005-06-21T13:51:12.000','2006-02-15T22:18:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11563','428','1','3702','2.99','2005-07-06T10:13:56.000','2006-02-15T22:18:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11564','428','1','3925','5.99','2005-07-06T20:41:44.000','2006-02-15T22:18:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11565','428','1','4151','0.99','2005-07-07T08:49:02.000','2006-02-15T22:18:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11566','428','1','5373','4.99','2005-07-09T18:48:57.000','2006-02-15T22:18:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11567','428','1','6735','5.99','2005-07-12T14:08:20.000','2006-02-15T22:18:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11568','428','1','7823','6.99','2005-07-28T08:32:53.000','2006-02-15T22:18:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11569','428','1','8155','2.99','2005-07-28T20:57:06.000','2006-02-15T22:18:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11570','428','2','8387','4.99','2005-07-29T05:47:27.000','2006-02-15T22:18:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11571','428','2','8528','4.99','2005-07-29T10:24:22.000','2006-02-15T22:18:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11572','428','1','9904','5.99','2005-07-31T14:34:17.000','2006-02-15T22:18:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11573','428','2','9982','2.99','2005-07-31T17:09:02.000','2006-02-15T22:18:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11574','428','2','10577','4.99','2005-08-01T13:46:38.000','2006-02-15T22:18:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11575','428','2','10888','2.99','2005-08-02T00:52:45.000','2006-02-15T22:18:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11576','428','2','11536','0.99','2005-08-17T00:40:03.000','2006-02-15T22:18:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11577','429','2','150','5.99','2005-05-26T00:28:39.000','2006-02-15T22:18:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11578','429','2','290','2.99','2005-05-26T20:08:33.000','2006-02-15T22:18:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11579','429','2','601','7.99','2005-05-28T14:08:22.000','2006-02-15T22:18:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11580','429','2','799','4.99','2005-05-29T17:24:48.000','2006-02-15T22:18:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11581','429','2','844','4.99','2005-05-30T00:58:20.000','2006-02-15T22:18:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11582','429','2','1781','5.99','2005-06-16T19:20:24.000','2006-02-15T22:18:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11583','429','2','1798','2.99','2005-06-16T20:16:15.000','2006-02-15T22:18:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11584','429','2','1916','7.99','2005-06-17T05:29:59.000','2006-02-15T22:18:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11585','429','1','3409','2.99','2005-06-21T16:17:38.000','2006-02-15T22:18:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11586','429','2','5868','4.99','2005-07-10T18:39:16.000','2006-02-15T22:18:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11587','429','2','6196','7.99','2005-07-11T12:05:46.000','2006-02-15T22:18:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11588','429','2','6886','6.99','2005-07-12T20:58:04.000','2006-02-15T22:18:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11589','429','1','6977','6.99','2005-07-27T00:40:50.000','2006-02-15T22:18:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11590','429','2','7352','4.99','2005-07-27T14:38:29.000','2006-02-15T22:18:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11591','429','2','8136','1.99','2005-07-28T20:05:48.000','2006-02-15T22:18:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11592','429','2','8143','2.99','2005-07-28T20:23:11.000','2006-02-15T22:18:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11593','429','2','8175','7.99','2005-07-28T21:38:16.000','2006-02-15T22:18:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11594','429','1','9849','0.99','2005-07-31T12:44:34.000','2006-02-15T22:18:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11595','429','1','12259','2.99','2005-08-18T04:14:35.000','2006-02-15T22:18:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11596','429','1','12953','4.99','2005-08-19T06:04:07.000','2006-02-15T22:18:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11597','429','2','14495','4.99','2005-08-21T14:04:39.000','2006-02-15T22:18:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11598','430','2','30','2.99','2005-05-25T04:01:32.000','2006-02-15T22:18:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11599','430','1','364','4.99','2005-05-27T07:20:12.000','2006-02-15T22:18:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11600','430','2','1207','0.99','2005-06-15T02:27:08.000','2006-02-15T22:18:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11601','430','1','1274','2.99','2005-06-15T07:52:52.000','2006-02-15T22:18:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11602','430','1','1538','2.99','2005-06-16T01:05:50.000','2006-02-15T22:18:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11603','430','1','1759','6.99','2005-06-16T17:46:37.000','2006-02-15T22:18:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11604','430','2','2892','0.99','2005-06-20T02:06:39.000','2006-02-15T22:18:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11605','430','2','3153','0.99','2005-06-20T20:44:15.000','2006-02-15T22:18:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11606','430','1','5002','4.99','2005-07-09T01:17:08.000','2006-02-15T22:18:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11607','430','1','5217','5.99','2005-07-09T11:56:50.000','2006-02-15T22:18:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11608','430','2','5879','6.99','2005-07-10T19:12:47.000','2006-02-15T22:18:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11609','430','1','5958','6.99','2005-07-10T23:31:51.000','2006-02-15T22:18:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11610','430','2','6043','0.99','2005-07-11T03:18:10.000','2006-02-15T22:18:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11611','430','1','8560','4.99','2005-07-29T11:27:27.000','2006-02-15T22:18:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11612','430','2','9450','2.99','2005-07-30T22:04:04.000','2006-02-15T22:18:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11613','430','1','12723','0.99','2005-08-18T21:34:16.000','2006-02-15T22:18:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11614','430','1','12965','4.99','2005-08-19T06:33:00.000','2006-02-15T22:18:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11615','430','1','13007','0.99','2005-08-19T07:47:43.000','2006-02-15T22:18:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11616','430','2','13452','0.99','2005-08-20T00:20:07.000','2006-02-15T22:18:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11617','430','2','13454','2.99','2005-08-20T00:30:52.000','2006-02-15T22:18:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11618','430','1','14058','5.99','2005-08-20T22:24:35.000','2006-02-15T22:18:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11619','430','1','15031','4.99','2005-08-22T09:11:48.000','2006-02-15T22:18:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11620','431','2','1126','2.99','2005-05-31T17:27:45.000','2006-02-15T22:18:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11621','431','2','1561','2.99','2005-06-16T02:41:30.000','2006-02-15T22:18:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11622','431','1','2096','4.99','2005-06-17T18:33:04.000','2006-02-15T22:18:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11623','431','1','2269','3.99','2005-06-18T06:20:54.000','2006-02-15T22:18:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11624','431','2','2281','4.99','2005-06-18T06:47:29.000','2006-02-15T22:18:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11625','431','2','2761','2.99','2005-06-19T17:22:17.000','2006-02-15T22:18:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11626','431','2','3304','6.99','2005-06-21T07:43:40.000','2006-02-15T22:18:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11627','431','2','3369','8.99','2005-06-21T13:20:31.000','2006-02-15T22:18:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11628','431','1','4144','3.99','2005-07-07T08:25:44.000','2006-02-15T22:18:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11629','431','1','4801','2.99','2005-07-08T16:51:36.000','2006-02-15T22:18:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11630','431','1','4863','0.99','2005-07-08T19:03:15.000','2006-02-15T22:18:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11631','431','2','7978','4.99','2005-07-28T14:16:14.000','2006-02-15T22:18:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11632','431','2','8810','4.99','2005-07-29T21:45:19.000','2006-02-15T22:18:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11633','431','2','10508','0.99','2005-08-01T11:23:27.000','2006-02-15T22:18:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11634','431','1','10527','4.99','2005-08-01T11:55:54.000','2006-02-15T22:18:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11635','431','2','10959','6.99','2005-08-02T03:39:39.000','2006-02-15T22:18:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11636','431','2','11538','2.99','2005-08-17T00:44:04.000','2006-02-15T22:18:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11637','431','1','12273','6.99','2005-08-18T04:40:50.000','2006-02-15T22:18:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11638','431','2','13153','1.99','2005-08-19T13:09:47.000','2006-02-15T22:18:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11639','431','1','13784','4.99','2005-08-20T12:11:28.000','2006-02-15T22:18:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11640','431','1','15809','2.99','2005-08-23T14:42:07.000','2006-02-15T22:18:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11641','431','1','15960','2.99','2005-08-23T19:35:42.000','2006-02-15T22:18:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11642','431','2','13587','2.99','2006-02-14T15:16:03.000','2006-02-15T22:18:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11643','432','2','326','7.99','2005-05-27T01:10:11.000','2006-02-15T22:18:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11644','432','1','550','5.99','2005-05-28T07:39:16.000','2006-02-15T22:18:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11645','432','1','897','8.99','2005-05-30T09:10:01.000','2006-02-15T22:18:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11646','432','2','1180','5.99','2005-06-15T00:39:01.000','2006-02-15T22:18:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11647','432','2','1597','2.99','2005-06-16T05:47:03.000','2006-02-15T22:18:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11648','432','2','3194','4.99','2005-06-20T23:59:57.000','2006-02-15T22:18:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11649','432','1','4965','5.99','2005-07-08T23:46:57.000','2006-02-15T22:18:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11650','432','1','4973','4.99','2005-07-08T23:58:18.000','2006-02-15T22:18:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11651','432','1','5204','2.99','2005-07-09T10:54:14.000','2006-02-15T22:18:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11652','432','1','5322','6.99','2005-07-09T16:28:13.000','2006-02-15T22:18:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11653','432','1','5944','4.99','2005-07-10T22:51:44.000','2006-02-15T22:18:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11654','432','1','5990','4.99','2005-07-11T01:03:14.000','2006-02-15T22:18:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11655','432','2','7326','4.99','2005-07-27T13:50:40.000','2006-02-15T22:18:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11656','432','2','7681','0.99','2005-07-28T03:07:09.000','2006-02-15T22:18:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11657','432','2','8079','4.99','2005-07-28T17:58:36.000','2006-02-15T22:18:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11658','432','2','8094','6.99','2005-07-28T18:30:28.000','2006-02-15T22:18:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11659','432','2','9916','4.99','2005-07-31T14:54:52.000','2006-02-15T22:18:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11660','432','2','9984','2.99','2005-07-31T17:12:23.000','2006-02-15T22:18:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11661','432','2','11870','0.99','2005-08-17T14:11:28.000','2006-02-15T22:18:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11662','432','1','12767','6.99','2005-08-18T23:25:49.000','2006-02-15T22:18:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11663','432','1','14027','2.99','2005-08-20T21:21:34.000','2006-02-15T22:18:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11664','432','1','15523','4.99','2005-08-23T03:32:36.000','2006-02-15T22:18:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11665','432','1','15713','6.99','2005-08-23T10:56:15.000','2006-02-15T22:18:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11666','433','2','146','8.99','2005-05-26T00:07:11.000','2006-02-15T22:18:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11667','433','1','691','10.99','2005-05-29T01:01:26.000','2006-02-15T22:18:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11668','433','2','4087','6.99','2005-07-07T05:30:56.000','2006-02-15T22:18:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11669','433','2','4158','0.99','2005-07-07T09:05:42.000','2006-02-15T22:18:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11670','433','2','4988','7.99','2005-07-09T00:46:14.000','2006-02-15T22:18:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11671','433','2','5457','0.99','2005-07-09T22:33:14.000','2006-02-15T22:18:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11672','433','1','5969','8.99','2005-07-11T00:03:22.000','2006-02-15T22:18:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11673','433','1','6765','5.99','2005-07-12T15:30:47.000','2006-02-15T22:18:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11674','433','1','6848','0.99','2005-07-12T19:24:07.000','2006-02-15T22:18:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11675','433','1','6850','4.99','2005-07-12T19:30:42.000','2006-02-15T22:18:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11676','433','1','7821','4.99','2005-07-28T08:31:23.000','2006-02-15T22:18:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11677','433','2','7907','4.99','2005-07-28T11:32:00.000','2006-02-15T22:18:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11678','433','1','8414','5.99','2005-07-29T06:48:35.000','2006-02-15T22:18:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11679','433','1','8713','2.99','2005-07-29T17:31:19.000','2006-02-15T22:18:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11680','433','2','9161','4.99','2005-07-30T11:19:18.000','2006-02-15T22:18:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11681','433','1','9294','3.99','2005-07-30T16:14:37.000','2006-02-15T22:18:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11682','433','1','10663','4.99','2005-08-01T16:51:08.000','2006-02-15T22:18:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11683','433','1','11664','2.99','2005-08-17T05:35:52.000','2006-02-15T22:18:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11684','433','2','12669','6.99','2005-08-18T19:17:47.000','2006-02-15T22:18:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11685','433','2','13273','4.99','2005-08-19T17:49:13.000','2006-02-15T22:18:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11686','433','1','13801','4.99','2005-08-20T12:40:53.000','2006-02-15T22:18:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11687','433','2','14523','4.99','2005-08-21T15:03:45.000','2006-02-15T22:18:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11688','433','1','14559','6.99','2005-08-21T16:11:35.000','2006-02-15T22:18:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11689','433','2','15476','4.99','2005-08-23T01:45:07.000','2006-02-15T22:18:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11690','433','1','15502','5.99','2005-08-23T02:40:04.000','2006-02-15T22:18:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11691','434','2','508','5.99','2005-05-28T02:40:50.000','2006-02-15T22:18:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11692','434','1','1225','0.99','2005-06-15T03:45:35.000','2006-02-15T22:18:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11693','434','2','1584','5.99','2005-06-16T04:50:50.000','2006-02-15T22:18:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11694','434','2','2415','7.99','2005-06-18T17:02:42.000','2006-02-15T22:18:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11695','434','1','2430','3.99','2005-06-18T17:51:46.000','2006-02-15T22:18:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11696','434','1','2494','3.99','2005-06-18T22:15:09.000','2006-02-15T22:18:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11697','434','1','3014','2.99','2005-06-20T10:45:20.000','2006-02-15T22:18:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11698','434','2','3037','2.99','2005-06-20T12:28:03.000','2006-02-15T22:18:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11699','434','1','4414','2.99','2005-07-07T22:00:21.000','2006-02-15T22:18:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11700','434','2','4654','6.99','2005-07-08T09:48:03.000','2006-02-15T22:18:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11701','434','2','4960','10.99','2005-07-08T23:27:16.000','2006-02-15T22:18:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11702','434','2','5464','2.99','2005-07-09T22:58:14.000','2006-02-15T22:18:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11703','434','2','6972','0.99','2005-07-27T00:31:25.000','2006-02-15T22:18:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11704','434','1','7260','6.99','2005-07-27T11:09:28.000','2006-02-15T22:18:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11705','434','2','7479','2.99','2005-07-27T19:18:17.000','2006-02-15T22:18:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11706','434','1','8205','0.99','2005-07-28T23:18:48.000','2006-02-15T22:18:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11707','434','1','9350','4.99','2005-07-30T18:24:30.000','2006-02-15T22:18:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11708','434','1','11242','3.99','2005-08-02T13:32:00.000','2006-02-15T22:18:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11709','434','1','11867','2.99','2005-08-17T14:04:28.000','2006-02-15T22:18:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11710','434','2','12030','2.99','2005-08-17T20:10:48.000','2006-02-15T22:18:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11711','434','2','12146','2.99','2005-08-18T00:10:04.000','2006-02-15T22:18:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11712','434','2','12624','7.99','2005-08-18T17:35:00.000','2006-02-15T22:18:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11713','434','2','13359','9.99','2005-08-19T21:04:49.000','2006-02-15T22:18:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11714','434','1','13383','7.99','2005-08-19T21:38:44.000','2006-02-15T22:18:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11715','434','2','14553','4.99','2005-08-21T15:59:40.000','2006-02-15T22:18:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11716','434','2','15016','3.99','2005-08-22T08:47:35.000','2006-02-15T22:18:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11717','434','2','15385','4.99','2005-08-22T22:37:34.000','2006-02-15T22:18:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11718','435','1','757','7.99','2005-05-29T10:29:47.000','2006-02-15T22:18:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11719','435','1','806','4.99','2005-05-29T18:31:30.000','2006-02-15T22:18:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11720','435','2','1443','0.99','2005-06-15T18:57:51.000','2006-02-15T22:18:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11721','435','1','2984','0.99','2005-06-20T08:43:44.000','2006-02-15T22:18:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11722','435','1','3690','0.99','2005-07-06T09:46:03.000','2006-02-15T22:18:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11723','435','1','3918','8.99','2005-07-06T20:26:15.000','2006-02-15T22:18:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11724','435','2','5220','4.99','2005-07-09T11:59:04.000','2006-02-15T22:18:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11725','435','2','6051','4.99','2005-07-11T03:46:41.000','2006-02-15T22:18:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11726','435','1','6935','2.99','2005-07-26T23:13:10.000','2006-02-15T22:18:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11727','435','1','8386','5.99','2005-07-29T05:45:30.000','2006-02-15T22:18:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11728','435','2','8891','4.99','2005-07-30T00:46:55.000','2006-02-15T22:18:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11729','435','2','9269','0.99','2005-07-30T15:02:33.000','2006-02-15T22:18:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11730','435','1','9655','3.99','2005-07-31T05:57:54.000','2006-02-15T22:18:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11731','435','2','9829','4.99','2005-07-31T11:58:38.000','2006-02-15T22:18:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11732','435','1','10998','6.99','2005-08-02T04:50:55.000','2006-02-15T22:18:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11733','435','1','11041','2.99','2005-08-02T06:03:53.000','2006-02-15T22:18:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11734','435','1','11786','3.99','2005-08-17T10:57:40.000','2006-02-15T22:18:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11735','435','1','11796','0.99','2005-08-17T11:16:47.000','2006-02-15T22:18:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11736','435','2','12046','0.99','2005-08-17T20:47:46.000','2006-02-15T22:18:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11737','435','1','12741','4.99','2005-08-18T22:17:05.000','2006-02-15T22:18:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11738','435','2','13208','0.99','2005-08-19T15:18:55.000','2006-02-15T22:18:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11739','435','1','14696','4.99','2005-08-21T20:48:05.000','2006-02-15T22:18:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11740','435','1','14765','1.99','2005-08-21T23:40:28.000','2006-02-15T22:18:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11741','435','1','14850','0.99','2005-08-22T02:16:55.000','2006-02-15T22:18:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11742','435','1','15136','2.99','2005-08-22T13:19:25.000','2006-02-15T22:18:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11743','436','1','45','7.99','2005-05-25T05:59:39.000','2006-02-15T22:18:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11744','436','1','256','3.99','2005-05-26T15:20:58.000','2006-02-15T22:18:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11745','436','1','848','5.99','2005-05-30T01:19:53.000','2006-02-15T22:18:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11746','436','1','2291','9.99','2005-06-18T07:36:46.000','2006-02-15T22:18:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11747','436','2','3851','1.99','2005-07-06T16:54:12.000','2006-02-15T22:18:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11748','436','2','3944','2.99','2005-07-06T21:34:11.000','2006-02-15T22:18:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11749','436','2','4643','0.99','2005-07-08T09:13:56.000','2006-02-15T22:18:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11750','436','2','4751','2.99','2005-07-08T14:07:52.000','2006-02-15T22:18:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11751','436','1','4782','4.99','2005-07-08T16:08:51.000','2006-02-15T22:18:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11752','436','1','5959','0.99','2005-07-10T23:35:36.000','2006-02-15T22:18:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11753','436','1','7593','4.99','2005-07-27T23:28:47.000','2006-02-15T22:18:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11754','436','2','8027','5.99','2005-07-28T16:09:57.000','2006-02-15T22:18:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11755','436','2','8097','9.99','2005-07-28T18:32:49.000','2006-02-15T22:18:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11756','436','1','9345','9.99','2005-07-30T18:13:51.000','2006-02-15T22:18:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11757','436','1','9539','0.99','2005-07-31T01:36:19.000','2006-02-15T22:18:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11758','436','1','9638','5.99','2005-07-31T05:30:27.000','2006-02-15T22:18:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11759','436','2','10216','3.99','2005-08-01T01:06:27.000','2006-02-15T22:18:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11760','436','2','11160','0.99','2005-08-02T10:05:30.000','2006-02-15T22:18:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11761','436','1','11580','2.99','2005-08-17T01:59:07.000','2006-02-15T22:18:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11762','436','2','11615','4.99','2005-08-17T03:54:35.000','2006-02-15T22:18:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11763','436','2','11896','5.99','2005-08-17T15:19:54.000','2006-02-15T22:18:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11764','436','2','12297','0.99','2005-08-18T05:19:57.000','2006-02-15T22:18:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11765','436','2','12429','6.99','2005-08-18T10:26:46.000','2006-02-15T22:18:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11766','436','2','13099','9.99','2005-08-19T10:55:19.000','2006-02-15T22:18:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11767','436','2','13382','7.99','2005-08-19T21:38:41.000','2006-02-15T22:18:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11768','436','1','13533','3.99','2005-08-20T03:30:00.000','2006-02-15T22:18:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11769','436','1','13760','5.99','2005-08-20T11:26:33.000','2006-02-15T22:18:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11770','436','1','13814','0.99','2005-08-20T13:07:23.000','2006-02-15T22:18:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11771','436','2','13826','2.99','2005-08-20T13:46:38.000','2006-02-15T22:18:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11772','436','2','15766','4.99','2005-08-23T13:10:16.000','2006-02-15T22:18:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11773','437','1','192','2.99','2005-05-26T06:20:37.000','2006-02-15T22:18:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11774','437','2','656','4.99','2005-05-28T20:18:24.000','2006-02-15T22:18:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11775','437','1','666','5.99','2005-05-28T21:48:51.000','2006-02-15T22:18:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11776','437','2','2239','5.99','2005-06-18T04:23:54.000','2006-02-15T22:18:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11777','437','1','2792','2.99','2005-06-19T18:52:25.000','2006-02-15T22:18:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11778','437','2','3265','2.99','2005-06-21T04:23:13.000','2006-02-15T22:18:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11779','437','1','3747','4.99','2005-07-06T12:11:14.000','2006-02-15T22:18:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11780','437','2','4765','4.99','2005-07-08T15:08:45.000','2006-02-15T22:18:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11781','437','2','5085','4.99','2005-07-09T05:36:49.000','2006-02-15T22:18:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11782','437','1','5167','1.99','2005-07-09T09:18:43.000','2006-02-15T22:18:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11783','437','2','5744','2.99','2005-07-10T12:08:33.000','2006-02-15T22:18:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11784','437','2','5864','6.99','2005-07-10T18:29:57.000','2006-02-15T22:18:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11785','437','2','8215','2.99','2005-07-28T23:43:56.000','2006-02-15T22:18:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11786','437','2','9172','2.99','2005-07-30T11:36:38.000','2006-02-15T22:18:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11787','437','2','9333','2.99','2005-07-30T17:53:45.000','2006-02-15T22:18:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11788','437','2','10009','8.99','2005-07-31T18:00:28.000','2006-02-15T22:18:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11789','437','2','10249','0.99','2005-08-01T02:35:39.000','2006-02-15T22:18:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11790','437','2','11417','3.99','2005-08-02T19:44:46.000','2006-02-15T22:18:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11791','437','1','12205','8.99','2005-08-18T02:21:08.000','2006-02-15T22:18:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11792','437','2','13838','7.99','2005-08-20T14:22:46.000','2006-02-15T22:18:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11793','437','1','13839','2.99','2005-08-20T14:23:16.000','2006-02-15T22:18:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11794','437','1','13905','1.99','2005-08-20T16:12:48.000','2006-02-15T22:18:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11795','437','1','14993','1.99','2005-08-22T07:52:18.000','2006-02-15T22:18:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11796','438','2','23','4.99','2005-05-25T02:40:21.000','2006-02-15T22:18:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11797','438','2','1036','0.99','2005-05-31T05:21:10.000','2006-02-15T22:18:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11798','438','1','1138','6.99','2005-05-31T19:30:27.000','2006-02-15T22:18:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11799','438','1','1431','4.99','2005-06-15T18:26:29.000','2006-02-15T22:18:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11800','438','2','1779','0.99','2005-06-16T18:55:11.000','2006-02-15T22:18:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11801','438','2','2206','0.99','2005-06-18T02:14:45.000','2006-02-15T22:18:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11802','438','1','2591','4.99','2005-06-19T05:32:22.000','2006-02-15T22:18:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11803','438','1','3315','4.99','2005-06-21T08:17:04.000','2006-02-15T22:18:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11804','438','2','3368','0.99','2005-06-21T13:18:38.000','2006-02-15T22:18:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11805','438','1','4355','4.99','2005-07-07T19:21:19.000','2006-02-15T22:18:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11806','438','2','4446','2.99','2005-07-07T23:12:16.000','2006-02-15T22:18:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11807','438','2','5316','4.99','2005-07-09T16:09:42.000','2006-02-15T22:18:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11808','438','2','5426','4.99','2005-07-09T21:04:47.000','2006-02-15T22:18:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11809','438','1','5870','2.99','2005-07-10T18:40:25.000','2006-02-15T22:18:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11810','438','2','6138','4.99','2005-07-11T08:36:04.000','2006-02-15T22:18:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11811','438','1','6563','3.99','2005-07-12T05:34:09.000','2006-02-15T22:18:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11812','438','2','6615','4.99','2005-07-12T08:36:22.000','2006-02-15T22:18:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11813','438','2','7357','1.99','2005-07-27T14:48:31.000','2006-02-15T22:18:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11814','438','2','7374','8.99','2005-07-27T15:20:57.000','2006-02-15T22:18:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11815','438','1','7598','0.99','2005-07-27T23:36:01.000','2006-02-15T22:18:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11816','438','2','8547','2.99','2005-07-29T11:10:15.000','2006-02-15T22:18:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11817','438','1','9082','3.99','2005-07-30T08:11:22.000','2006-02-15T22:18:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11818','438','2','9782','0.99','2005-07-31T10:14:26.000','2006-02-15T22:18:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11819','438','1','10512','6.99','2005-08-01T11:36:19.000','2006-02-15T22:18:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11820','438','1','10607','4.99','2005-08-01T14:44:43.000','2006-02-15T22:18:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11821','438','2','11644','4.99','2005-08-17T04:49:46.000','2006-02-15T22:18:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11822','438','2','11933','4.99','2005-08-17T16:38:20.000','2006-02-15T22:18:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11823','438','2','12654','0.99','2005-08-18T18:56:40.000','2006-02-15T22:18:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11824','438','2','13319','7.99','2005-08-19T19:35:13.000','2006-02-15T22:18:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11825','438','1','13414','4.99','2005-08-19T22:47:34.000','2006-02-15T22:18:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11826','438','2','14582','5.99','2005-08-21T17:08:33.000','2006-02-15T22:18:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11827','438','2','15893','5.99','2005-08-23T17:02:00.000','2006-02-15T22:18:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11828','438','2','12524','0.99','2006-02-14T15:16:03.000','2006-02-15T22:18:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11829','439','1','126','2.99','2005-05-25T21:07:59.000','2006-02-15T22:18:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11830','439','2','367','0.99','2005-05-27T07:37:02.000','2006-02-15T22:18:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11831','439','1','786','9.99','2005-05-29T15:17:28.000','2006-02-15T22:18:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11832','439','1','1264','4.99','2005-06-15T06:59:39.000','2006-02-15T22:18:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11833','439','2','1557','0.99','2005-06-16T02:28:35.000','2006-02-15T22:18:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11834','439','2','2097','4.99','2005-06-17T18:40:04.000','2006-02-15T22:18:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11835','439','1','2621','2.99','2005-06-19T08:07:31.000','2006-02-15T22:18:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11836','439','1','2992','2.99','2005-06-20T09:11:51.000','2006-02-15T22:18:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11837','439','1','3294','6.99','2005-06-21T07:03:23.000','2006-02-15T22:18:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11838','439','2','3774','5.99','2005-07-06T13:25:07.000','2006-02-15T22:18:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11839','439','1','4528','2.99','2005-07-08T03:24:54.000','2006-02-15T22:18:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11840','439','1','4813','4.99','2005-07-08T17:09:56.000','2006-02-15T22:18:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11841','439','2','5801','5.99','2005-07-10T14:59:05.000','2006-02-15T22:18:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11842','439','1','5893','2.99','2005-07-10T20:05:30.000','2006-02-15T22:18:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11843','439','1','6577','2.99','2005-07-12T06:15:05.000','2006-02-15T22:18:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11844','439','2','6672','2.99','2005-07-12T11:49:16.000','2006-02-15T22:18:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11845','439','1','8343','2.99','2005-07-29T04:45:16.000','2006-02-15T22:18:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11846','439','1','8624','2.99','2005-07-29T13:55:36.000','2006-02-15T22:18:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11847','439','2','8703','2.99','2005-07-29T17:12:44.000','2006-02-15T22:18:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11848','439','1','9275','0.99','2005-07-30T15:09:15.000','2006-02-15T22:18:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11849','439','1','9322','6.99','2005-07-30T17:21:39.000','2006-02-15T22:18:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11850','439','2','10744','1.99','2005-08-01T19:56:49.000','2006-02-15T22:18:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11851','439','1','10905','2.99','2005-08-02T01:45:59.000','2006-02-15T22:18:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11852','439','2','11042','6.99','2005-08-02T06:04:33.000','2006-02-15T22:18:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11853','439','2','11544','5.99','2005-08-17T00:55:07.000','2006-02-15T22:18:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11854','439','1','11989','2.99','2005-08-17T18:23:58.000','2006-02-15T22:18:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11855','439','1','12621','2.99','2005-08-18T17:31:36.000','2006-02-15T22:18:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11856','439','2','12755','5.99','2005-08-18T22:38:47.000','2006-02-15T22:18:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11857','439','2','12826','3.99','2005-08-19T01:25:11.000','2006-02-15T22:18:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11858','439','2','13358','4.99','2005-08-19T21:04:20.000','2006-02-15T22:18:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11859','439','2','14730','5.99','2005-08-21T22:21:11.000','2006-02-15T22:18:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11860','439','2','15044','9.99','2005-08-22T09:51:54.000','2006-02-15T22:18:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11861','439','2','15162','4.99','2005-08-22T14:41:05.000','2006-02-15T22:18:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11862','439','2','15653','4.99','2005-08-23T08:34:42.000','2006-02-15T22:18:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11863','439','1','15818','1.99','2005-08-23T14:59:58.000','2006-02-15T22:18:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11864','439','1','16018','0.99','2005-08-23T21:27:35.000','2006-02-15T22:18:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11865','440','2','957','4.99','2005-05-30T17:53:29.000','2006-02-15T22:18:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11866','440','1','4301','2.99','2005-07-07T16:37:23.000','2006-02-15T22:18:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11867','440','1','4946','7.99','2005-07-08T22:46:23.000','2006-02-15T22:18:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11868','440','2','5423','2.99','2005-07-09T20:56:48.000','2006-02-15T22:18:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11869','440','2','5594','0.99','2005-07-10T04:33:36.000','2006-02-15T22:18:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11870','440','2','5731','2.99','2005-07-10T11:31:52.000','2006-02-15T22:18:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11871','440','2','5782','0.99','2005-07-10T13:52:56.000','2006-02-15T22:18:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11872','440','2','7585','4.99','2005-07-27T23:18:22.000','2006-02-15T22:18:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11873','440','1','7614','0.99','2005-07-28T00:14:38.000','2006-02-15T22:18:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11874','440','1','7806','9.99','2005-07-28T07:58:17.000','2006-02-15T22:18:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11875','440','1','9001','4.99','2005-07-30T04:59:41.000','2006-02-15T22:18:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11876','440','1','9195','2.99','2005-07-30T12:29:43.000','2006-02-15T22:18:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11877','440','1','9547','4.99','2005-07-31T01:52:34.000','2006-02-15T22:18:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11878','440','2','12403','6.99','2005-08-18T09:31:05.000','2006-02-15T22:18:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11879','440','1','12850','0.99','2005-08-19T02:08:06.000','2006-02-15T22:18:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11880','440','2','13384','4.99','2005-08-19T21:38:51.000','2006-02-15T22:18:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11881','440','2','13779','2.99','2005-08-20T12:03:54.000','2006-02-15T22:18:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11882','440','1','14555','0.99','2005-08-21T16:03:02.000','2006-02-15T22:18:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11883','440','2','14863','7.99','2005-08-22T02:57:04.000','2006-02-15T22:18:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11884','440','2','15264','0.99','2005-08-22T18:27:38.000','2006-02-15T22:18:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11885','440','1','15925','4.99','2005-08-23T18:15:06.000','2006-02-15T22:18:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11886','440','1','13106','4.99','2006-02-14T15:16:03.000','2006-02-15T22:18:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11887','441','1','823','4.99','2005-05-29T21:39:37.000','2006-02-15T22:18:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11888','441','1','1602','4.99','2005-06-16T06:12:40.000','2006-02-15T22:18:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11889','441','2','2328','4.99','2005-06-18T10:17:21.000','2006-02-15T22:18:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11890','441','2','3629','0.99','2005-07-06T06:23:22.000','2006-02-15T22:18:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11891','441','2','3695','2.99','2005-07-06T10:02:08.000','2006-02-15T22:18:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11892','441','1','4084','8.99','2005-07-07T05:16:00.000','2006-02-15T22:18:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11893','441','2','4208','0.99','2005-07-07T11:34:22.000','2006-02-15T22:18:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11894','441','2','5129','2.99','2005-07-09T07:28:33.000','2006-02-15T22:18:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11895','441','1','5811','0.99','2005-07-10T15:27:04.000','2006-02-15T22:18:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11896','441','2','6636','2.99','2005-07-12T09:49:46.000','2006-02-15T22:18:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11897','441','1','6642','4.99','2005-07-12T10:37:52.000','2006-02-15T22:18:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11898','441','1','6941','5.99','2005-07-26T23:18:49.000','2006-02-15T22:18:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11899','441','2','8237','2.99','2005-07-29T00:29:56.000','2006-02-15T22:18:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11900','441','1','8281','0.99','2005-07-29T01:46:00.000','2006-02-15T22:18:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11901','441','1','8427','4.99','2005-07-29T07:08:36.000','2006-02-15T22:18:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11902','441','1','8575','4.99','2005-07-29T11:52:47.000','2006-02-15T22:18:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11903','441','2','8617','4.99','2005-07-29T13:46:14.000','2006-02-15T22:18:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11904','441','2','9644','10.99','2005-07-31T05:40:35.000','2006-02-15T22:18:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11905','441','2','9854','2.99','2005-07-31T12:59:34.000','2006-02-15T22:18:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11906','441','2','10139','1.99','2005-07-31T22:02:20.000','2006-02-15T22:18:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11907','441','1','10846','1.99','2005-08-01T23:47:54.000','2006-02-15T22:18:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11908','441','2','11247','1.99','2005-08-02T13:34:08.000','2006-02-15T22:18:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11909','441','2','13483','2.99','2005-08-20T01:16:38.000','2006-02-15T22:18:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11910','441','2','13739','4.99','2005-08-20T10:45:10.000','2006-02-15T22:18:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11911','441','1','13932','4.99','2005-08-20T17:17:00.000','2006-02-15T22:18:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11912','441','2','14796','4.99','2005-08-22T00:40:49.000','2006-02-15T22:18:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11913','441','2','15070','3.99','2005-08-22T10:55:45.000','2006-02-15T22:18:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11914','441','1','14878','4.99','2006-02-14T15:16:03.000','2006-02-15T22:18:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11915','442','2','466','0.99','2005-05-27T20:57:07.000','2006-02-15T22:18:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11916','442','2','558','6.99','2005-05-28T08:38:43.000','2006-02-15T22:18:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11917','442','1','632','5.99','2005-05-28T17:37:50.000','2006-02-15T22:18:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11918','442','1','1251','5.99','2005-06-15T05:58:55.000','2006-02-15T22:18:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11919','442','2','1358','0.99','2005-06-15T13:28:48.000','2006-02-15T22:18:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11920','442','2','1576','8.99','2005-06-16T03:54:39.000','2006-02-15T22:18:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11921','442','1','1774','2.99','2005-06-16T18:27:52.000','2006-02-15T22:18:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11922','442','2','3545','4.99','2005-07-06T02:16:17.000','2006-02-15T22:18:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11923','442','1','3661','2.99','2005-07-06T08:10:02.000','2006-02-15T22:18:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11924','442','1','4052','5.99','2005-07-07T03:38:22.000','2006-02-15T22:18:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11925','442','1','4058','2.99','2005-07-07T04:02:50.000','2006-02-15T22:18:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11926','442','2','4365','2.99','2005-07-07T19:47:46.000','2006-02-15T22:18:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11927','442','2','4577','3.99','2005-07-08T05:59:00.000','2006-02-15T22:18:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11928','442','2','6590','4.99','2005-07-12T07:08:21.000','2006-02-15T22:18:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11929','442','2','6632','2.99','2005-07-12T09:33:10.000','2006-02-15T22:18:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11930','442','2','7427','2.99','2005-07-27T17:20:16.000','2006-02-15T22:18:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11931','442','1','7460','0.99','2005-07-27T18:41:35.000','2006-02-15T22:18:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11932','442','1','7671','2.99','2005-07-28T02:48:31.000','2006-02-15T22:18:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11933','442','1','8044','2.99','2005-07-28T16:49:12.000','2006-02-15T22:18:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11934','442','1','8758','4.99','2005-07-29T19:20:49.000','2006-02-15T22:18:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11935','442','1','9180','4.99','2005-07-30T12:03:15.000','2006-02-15T22:18:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11936','442','2','9873','5.99','2005-07-31T13:32:18.000','2006-02-15T22:18:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11937','442','1','10034','2.99','2005-07-31T18:45:30.000','2006-02-15T22:18:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11938','442','2','10365','6.99','2005-08-01T06:08:44.000','2006-02-15T22:18:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11939','442','2','10452','0.99','2005-08-01T09:11:36.000','2006-02-15T22:18:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11940','442','1','12948','0.99','2005-08-19T05:55:14.000','2006-02-15T22:18:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11941','442','2','13004','0.99','2005-08-19T07:40:08.000','2006-02-15T22:18:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11942','442','1','13155','7.99','2005-08-19T13:10:23.000','2006-02-15T22:18:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11943','442','2','14199','0.99','2005-08-21T03:48:43.000','2006-02-15T22:18:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11944','442','1','14418','1.99','2005-08-21T11:14:26.000','2006-02-15T22:18:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11945','442','1','14466','0.99','2005-08-21T13:03:13.000','2006-02-15T22:18:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11946','442','2','15207','2.99','2005-08-22T16:35:25.000','2006-02-15T22:18:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11947','443','2','1068','4.99','2005-05-31T09:32:15.000','2006-02-15T22:18:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11948','443','1','2871','2.99','2005-06-20T00:27:49.000','2006-02-15T22:18:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11949','443','2','3510','5.99','2005-07-06T00:27:41.000','2006-02-15T22:18:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11950','443','2','6625','5.99','2005-07-12T09:06:40.000','2006-02-15T22:18:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11951','443','1','6913','4.99','2005-07-12T22:18:12.000','2006-02-15T22:18:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11952','443','2','6983','2.99','2005-07-27T00:55:03.000','2006-02-15T22:18:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11953','443','1','7317','2.99','2005-07-27T13:19:41.000','2006-02-15T22:18:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11954','443','1','7667','8.99','2005-07-28T02:37:22.000','2006-02-15T22:18:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11955','443','1','7987','9.99','2005-07-28T14:36:52.000','2006-02-15T22:18:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11956','443','2','9740','1.99','2005-07-31T09:08:03.000','2006-02-15T22:18:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11957','443','1','10014','4.99','2005-07-31T18:10:56.000','2006-02-15T22:18:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11958','443','2','10081','5.99','2005-07-31T20:07:44.000','2006-02-15T22:18:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11959','443','2','10360','0.99','2005-08-01T05:52:53.000','2006-02-15T22:18:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11960','443','1','11449','4.99','2005-08-02T20:44:43.000','2006-02-15T22:18:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11961','443','1','12415','4.99','2005-08-18T09:54:01.000','2006-02-15T22:18:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11962','443','2','12857','4.99','2005-08-19T02:20:13.000','2006-02-15T22:18:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11963','443','1','13489','2.99','2005-08-20T01:29:06.000','2006-02-15T22:18:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11964','443','1','14561','2.99','2005-08-21T16:20:43.000','2006-02-15T22:18:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11965','443','2','14611','6.99','2005-08-21T18:01:41.000','2006-02-15T22:18:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11966','443','1','15182','0.99','2005-08-22T15:47:05.000','2006-02-15T22:18:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11967','443','2','15393','4.99','2005-08-22T23:04:09.000','2006-02-15T22:18:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11968','443','1','15519','0.99','2005-08-23T03:23:32.000','2006-02-15T22:18:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11969','444','1','201','8.99','2005-05-26T07:13:45.000','2006-02-15T22:18:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11970','444','1','557','0.99','2005-05-28T08:36:22.000','2006-02-15T22:18:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11971','444','1','1239','0.99','2005-06-15T04:53:01.000','2006-02-15T22:18:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11972','444','2','1397','3.99','2005-06-15T16:25:26.000','2006-02-15T22:18:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11973','444','2','1441','1.99','2005-06-15T18:54:21.000','2006-02-15T22:18:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11974','444','1','2551','4.99','2005-06-19T02:51:04.000','2006-02-15T22:18:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11975','444','2','3301','7.99','2005-06-21T07:32:25.000','2006-02-15T22:18:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11976','444','2','3415','5.99','2005-06-21T16:59:49.000','2006-02-15T22:18:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11977','444','2','3498','4.99','2005-07-06T00:02:08.000','2006-02-15T22:18:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11978','444','1','3539','0.99','2005-07-06T01:39:08.000','2006-02-15T22:18:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11979','444','2','4648','6.99','2005-07-08T09:31:27.000','2006-02-15T22:18:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11980','444','1','5753','2.99','2005-07-10T12:29:43.000','2006-02-15T22:18:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11981','444','2','5825','2.99','2005-07-10T16:20:30.000','2006-02-15T22:18:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11982','444','2','6285','2.99','2005-07-11T16:52:07.000','2006-02-15T22:18:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11983','444','2','7679','3.99','2005-07-28T02:58:39.000','2006-02-15T22:18:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11984','444','2','9634','1.99','2005-07-31T05:06:02.000','2006-02-15T22:18:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11985','444','1','10529','4.99','2005-08-01T12:00:02.000','2006-02-15T22:18:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11986','444','1','10693','4.99','2005-08-01T18:14:14.000','2006-02-15T22:18:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11987','444','2','11353','0.99','2005-08-02T17:34:45.000','2006-02-15T22:18:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11988','444','2','11419','6.99','2005-08-02T19:46:38.000','2006-02-15T22:18:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11989','444','1','11728','4.99','2005-08-17T08:12:26.000','2006-02-15T22:18:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11990','444','1','12161','6.99','2005-08-18T00:41:46.000','2006-02-15T22:18:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11991','444','2','12712','2.99','2005-08-18T21:04:13.000','2006-02-15T22:18:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11992','444','2','12946','2.99','2005-08-19T05:53:34.000','2006-02-15T22:18:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11993','444','1','13488','0.99','2005-08-20T01:28:42.000','2006-02-15T22:18:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11994','444','2','13559','2.99','2005-08-20T04:16:07.000','2006-02-15T22:18:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11995','444','1','13924','0.99','2005-08-20T17:05:18.000','2006-02-15T22:18:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11996','444','1','15249','4.99','2005-08-22T17:58:27.000','2006-02-15T22:18:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11997','444','1','15557','0.99','2005-08-23T04:52:17.000','2006-02-15T22:18:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11998','444','2','15815','4.99','2005-08-23T14:55:47.000','2006-02-15T22:18:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('11999','445','1','481','2.99','2005-05-27T22:49:27.000','2006-02-15T22:18:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12000','445','1','960','2.99','2005-05-30T18:13:23.000','2006-02-15T22:18:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12001','445','1','4041','0.99','2005-07-07T03:03:33.000','2006-02-15T22:18:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12002','445','1','4193','0.99','2005-07-07T10:57:21.000','2006-02-15T22:18:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12003','445','2','5225','2.99','2005-07-09T12:10:16.000','2006-02-15T22:18:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12004','445','1','6346','0.99','2005-07-11T20:08:34.000','2006-02-15T22:18:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12005','445','2','7351','2.99','2005-07-27T14:37:36.000','2006-02-15T22:18:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12006','445','2','7971','4.99','2005-07-28T14:00:47.000','2006-02-15T22:18:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12007','445','1','8851','8.99','2005-07-29T23:26:19.000','2006-02-15T22:18:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12008','445','2','8911','0.99','2005-07-30T01:30:57.000','2006-02-15T22:18:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12009','445','2','9625','4.99','2005-07-31T04:30:48.000','2006-02-15T22:18:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12010','445','1','10007','0.99','2005-07-31T17:54:58.000','2006-02-15T22:18:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12011','445','2','10334','1.99','2005-08-01T04:58:42.000','2006-02-15T22:18:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12012','445','2','10341','0.99','2005-08-01T05:10:02.000','2006-02-15T22:18:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12013','445','2','10936','9.99','2005-08-02T02:55:04.000','2006-02-15T22:18:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12014','445','1','11383','7.99','2005-08-02T18:22:05.000','2006-02-15T22:18:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12015','445','1','11868','4.99','2005-08-17T14:05:34.000','2006-02-15T22:18:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12016','445','1','11877','3.99','2005-08-17T14:21:11.000','2006-02-15T22:18:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12017','445','2','13586','0.99','2005-08-20T05:40:33.000','2006-02-15T22:18:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12018','445','1','14612','6.99','2005-08-21T18:03:15.000','2006-02-15T22:18:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12019','445','2','14673','2.99','2005-08-21T20:01:18.000','2006-02-15T22:18:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12020','445','1','14866','6.99','2005-08-22T03:11:35.000','2006-02-15T22:18:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12021','445','1','14955','4.99','2005-08-22T06:25:52.000','2006-02-15T22:18:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12022','445','1','15123','3.99','2005-08-22T12:48:44.000','2006-02-15T22:18:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12023','445','1','15791','6.99','2005-08-23T14:02:13.000','2006-02-15T22:18:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12024','445','2','15906','2.99','2005-08-23T17:36:00.000','2006-02-15T22:18:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12025','446','2','14','0.99','2005-05-25T00:31:15.000','2006-02-15T22:18:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12026','446','1','236','0.99','2005-05-26T11:53:49.000','2006-02-15T22:18:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12027','446','1','355','4.99','2005-05-27T06:15:33.000','2006-02-15T22:18:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12028','446','1','2248','4.99','2005-06-18T04:59:48.000','2006-02-15T22:18:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12029','446','2','2335','3.99','2005-06-18T10:59:36.000','2006-02-15T22:18:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12030','446','2','2520','6.99','2005-06-19T00:29:00.000','2006-02-15T22:18:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12031','446','2','2710','0.99','2005-06-19T14:03:56.000','2006-02-15T22:18:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12032','446','1','3060','2.99','2005-06-20T13:47:20.000','2006-02-15T22:18:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12033','446','2','3168','0.99','2005-06-20T21:46:01.000','2006-02-15T22:18:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12034','446','2','4358','4.99','2005-07-07T19:27:04.000','2006-02-15T22:18:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12035','446','2','5393','4.99','2005-07-09T19:35:12.000','2006-02-15T22:18:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12036','446','2','5409','2.99','2005-07-09T20:17:19.000','2006-02-15T22:18:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12037','446','2','6454','0.99','2005-07-12T01:00:12.000','2006-02-15T22:18:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12038','446','1','6510','4.99','2005-07-12T03:35:39.000','2006-02-15T22:18:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12039','446','1','6535','0.99','2005-07-12T04:43:43.000','2006-02-15T22:18:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12040','446','1','6734','6.99','2005-07-12T14:04:24.000','2006-02-15T22:18:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12041','446','1','7005','5.99','2005-07-27T01:38:36.000','2006-02-15T22:18:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12042','446','2','7089','0.99','2005-07-27T04:43:42.000','2006-02-15T22:18:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12043','446','1','7576','4.99','2005-07-27T22:54:35.000','2006-02-15T22:18:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12044','446','2','8284','6.99','2005-07-29T01:56:40.000','2006-02-15T22:18:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12045','446','1','8309','4.99','2005-07-29T03:22:20.000','2006-02-15T22:18:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12046','446','2','8670','4.99','2005-07-29T15:49:03.000','2006-02-15T22:18:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12047','446','2','8691','0.99','2005-07-29T16:41:23.000','2006-02-15T22:18:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12048','446','2','8922','9.99','2005-07-30T02:08:25.000','2006-02-15T22:18:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12049','446','1','8923','3.99','2005-07-30T02:08:49.000','2006-02-15T22:18:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12050','446','1','9116','0.99','2005-07-30T09:19:41.000','2006-02-15T22:18:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12051','446','1','11051','3.99','2005-08-02T06:23:39.000','2006-02-15T22:18:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12052','446','2','12253','0.99','2005-08-18T04:00:50.000','2006-02-15T22:18:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12053','446','2','12480','8.99','2005-08-18T12:26:43.000','2006-02-15T22:18:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12054','446','1','15808','1.99','2005-08-23T14:38:37.000','2006-02-15T22:18:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12055','446','2','15951','0.99','2005-08-23T19:10:32.000','2006-02-15T22:18:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12056','447','1','461','2.99','2005-05-27T20:08:55.000','2006-02-15T22:18:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12057','447','2','732','0.99','2005-05-29T07:32:51.000','2006-02-15T22:18:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12058','447','2','1230','0.99','2005-06-15T04:04:09.000','2006-02-15T22:18:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12059','447','2','1890','2.99','2005-06-17T04:06:13.000','2006-02-15T22:18:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12060','447','1','2025','4.99','2005-06-17T13:04:00.000','2006-02-15T22:18:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12061','447','2','2285','4.99','2005-06-18T07:00:54.000','2006-02-15T22:18:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12062','447','2','4403','4.99','2005-07-07T21:29:40.000','2006-02-15T22:18:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12063','447','1','4858','6.99','2005-07-08T18:53:24.000','2006-02-15T22:18:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12064','447','1','5331','4.99','2005-07-09T16:54:06.000','2006-02-15T22:18:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12065','447','1','5734','0.99','2005-07-10T11:37:28.000','2006-02-15T22:18:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12066','447','2','5987','2.99','2005-07-11T00:55:31.000','2006-02-15T22:18:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12067','447','1','6651','0.99','2005-07-12T10:57:28.000','2006-02-15T22:18:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12068','447','1','6690','1.99','2005-07-12T12:23:02.000','2006-02-15T22:18:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12069','447','1','8537','8.99','2005-07-29T10:44:54.000','2006-02-15T22:18:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12070','447','2','8945','4.99','2005-07-30T03:11:48.000','2006-02-15T22:18:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12071','447','2','9076','5.99','2005-07-30T07:58:12.000','2006-02-15T22:18:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12072','447','1','9288','6.99','2005-07-30T15:56:39.000','2006-02-15T22:18:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12073','447','1','10425','2.99','2005-08-01T08:23:25.000','2006-02-15T22:18:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12074','447','2','10957','5.99','2005-08-02T03:33:30.000','2006-02-15T22:18:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12075','447','2','11108','0.99','2005-08-02T08:20:01.000','2006-02-15T22:18:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12076','447','1','11465','5.99','2005-08-02T21:43:52.000','2006-02-15T22:18:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12077','447','2','12511','0.99','2005-08-18T13:23:19.000','2006-02-15T22:18:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12078','447','1','13072','2.99','2005-08-19T10:03:30.000','2006-02-15T22:18:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12079','447','2','13110','0.99','2005-08-19T11:24:37.000','2006-02-15T22:18:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12080','447','1','13848','4.99','2005-08-20T14:37:49.000','2006-02-15T22:18:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12081','447','2','14443','5.99','2005-08-21T12:06:32.000','2006-02-15T22:18:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12082','447','1','15108','2.99','2005-08-22T12:10:07.000','2006-02-15T22:18:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12083','447','1','15997','4.99','2005-08-23T20:40:31.000','2006-02-15T22:19:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12084','447','2','16032','4.99','2005-08-23T21:59:57.000','2006-02-15T22:19:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12085','448','1','299','4.99','2005-05-26T20:55:36.000','2006-02-15T22:19:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12086','448','2','1123','2.99','2005-05-31T16:48:43.000','2006-02-15T22:19:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12087','448','1','1313','5.99','2005-06-15T10:18:34.000','2006-02-15T22:19:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12088','448','2','1823','7.99','2005-06-16T21:48:16.000','2006-02-15T22:19:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12089','448','2','2697','0.99','2005-06-19T13:29:08.000','2006-02-15T22:19:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12090','448','2','3225','3.99','2005-06-21T02:16:55.000','2006-02-15T22:19:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12091','448','2','3347','5.99','2005-06-21T11:08:32.000','2006-02-15T22:19:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12092','448','2','3959','5.99','2005-07-06T22:07:58.000','2006-02-15T22:19:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12093','448','2','3992','6.99','2005-07-06T23:36:56.000','2006-02-15T22:19:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12094','448','2','4024','0.99','2005-07-07T02:11:23.000','2006-02-15T22:19:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12095','448','2','4206','2.99','2005-07-07T11:32:16.000','2006-02-15T22:19:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12096','448','1','4406','1.99','2005-07-07T21:35:16.000','2006-02-15T22:19:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12097','448','2','4537','2.99','2005-07-08T03:48:40.000','2006-02-15T22:19:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12098','448','2','4558','2.99','2005-07-08T04:55:26.000','2006-02-15T22:19:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12099','448','2','6341','2.99','2005-07-11T19:48:02.000','2006-02-15T22:19:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12100','448','2','6985','4.99','2005-07-27T00:57:42.000','2006-02-15T22:19:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12101','448','1','9178','10.99','2005-07-30T11:58:50.000','2006-02-15T22:19:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12102','448','2','11608','8.99','2005-08-17T03:36:52.000','2006-02-15T22:19:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12103','448','1','11798','9.99','2005-08-17T11:21:43.000','2006-02-15T22:19:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12104','448','1','12446','2.99','2005-08-18T10:56:29.000','2006-02-15T22:19:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12105','448','1','13220','2.99','2005-08-19T15:42:32.000','2006-02-15T22:19:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12106','448','2','13250','3.99','2005-08-19T16:47:55.000','2006-02-15T22:19:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12107','448','1','13982','3.99','2005-08-20T19:08:25.000','2006-02-15T22:19:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12108','448','1','14580','3.99','2005-08-21T16:56:39.000','2006-02-15T22:19:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12109','448','1','14711','2.99','2005-08-21T21:22:07.000','2006-02-15T22:19:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12110','448','2','15358','9.99','2005-08-22T21:29:14.000','2006-02-15T22:19:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12111','448','1','15427','4.99','2005-08-23T00:07:53.000','2006-02-15T22:19:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12112','448','2','14734','3.98','2006-02-14T15:16:03.000','2006-02-15T22:19:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12113','448','1','13577','0','2006-02-14T15:16:03.000','2006-02-15T22:19:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12114','449','2','263','4.99','2005-05-26T15:47:40.000','2006-02-15T22:19:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12115','449','2','325','5.99','2005-05-27T01:09:55.000','2006-02-15T22:19:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12116','449','1','849','7.99','2005-05-30T01:23:07.000','2006-02-15T22:19:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12117','449','2','1295','4.99','2005-06-15T09:17:20.000','2006-02-15T22:19:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12118','449','1','2348','0.99','2005-06-18T12:15:43.000','2006-02-15T22:19:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12119','449','2','2970','2.99','2005-06-20T07:51:51.000','2006-02-15T22:19:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12120','449','1','3503','0.99','2005-07-06T00:17:24.000','2006-02-15T22:19:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12121','449','1','3977','8.99','2005-07-06T23:00:49.000','2006-02-15T22:19:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12122','449','2','4433','3.99','2005-07-07T22:45:41.000','2006-02-15T22:19:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12123','449','1','5824','2.99','2005-07-10T16:19:53.000','2006-02-15T22:19:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12124','449','2','7755','6.99','2005-07-28T06:22:18.000','2006-02-15T22:19:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12125','449','2','7803','3.99','2005-07-28T07:52:13.000','2006-02-15T22:19:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12126','449','2','8002','2.99','2005-07-28T15:11:00.000','2006-02-15T22:19:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12127','449','2','10083','5.99','2005-07-31T20:10:19.000','2006-02-15T22:19:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12128','449','2','10409','2.99','2005-08-01T07:49:15.000','2006-02-15T22:19:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12129','449','1','10416','4.99','2005-08-01T08:08:39.000','2006-02-15T22:19:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12130','449','1','10516','6.99','2005-08-01T11:41:55.000','2006-02-15T22:19:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12131','449','2','10688','6.99','2005-08-01T17:53:43.000','2006-02-15T22:19:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12132','449','1','12212','4.99','2005-08-18T02:33:29.000','2006-02-15T22:19:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12133','449','2','14962','7.99','2005-08-22T06:37:43.000','2006-02-15T22:19:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12134','450','2','548','3.99','2005-05-28T07:34:56.000','2006-02-15T22:19:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12135','450','2','1639','4.99','2005-06-16T08:33:39.000','2006-02-15T22:19:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12136','450','1','1739','0.99','2005-06-16T16:09:38.000','2006-02-15T22:19:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12137','450','2','1914','2.99','2005-06-17T05:25:54.000','2006-02-15T22:19:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12138','450','2','2278','0.99','2005-06-18T06:37:57.000','2006-02-15T22:19:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12139','450','1','2501','4.99','2005-06-18T23:10:11.000','2006-02-15T22:19:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12140','450','1','2626','2.99','2005-06-19T08:28:44.000','2006-02-15T22:19:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12141','450','1','3155','4.99','2005-06-20T21:02:38.000','2006-02-15T22:19:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12142','450','1','3570','3.99','2005-07-06T03:23:43.000','2006-02-15T22:19:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12143','450','1','5999','7.99','2005-07-11T01:21:22.000','2006-02-15T22:19:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12144','450','1','6028','4.99','2005-07-11T02:31:44.000','2006-02-15T22:19:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12145','450','2','7365','2.99','2005-07-27T15:00:20.000','2006-02-15T22:19:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12146','450','1','7610','0.99','2005-07-28T00:11:35.000','2006-02-15T22:19:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12147','450','1','7626','0.99','2005-07-28T00:49:01.000','2006-02-15T22:19:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12148','450','2','8733','4.99','2005-07-29T18:26:34.000','2006-02-15T22:19:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12149','450','2','10432','2.99','2005-08-01T08:43:21.000','2006-02-15T22:19:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12150','450','1','10984','3.99','2005-08-02T04:30:02.000','2006-02-15T22:19:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12151','450','2','12812','0.99','2005-08-19T00:54:02.000','2006-02-15T22:19:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12152','450','2','13731','4.99','2005-08-20T10:22:08.000','2006-02-15T22:19:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12153','450','1','13810','0.99','2005-08-20T12:59:38.000','2006-02-15T22:19:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12154','450','1','13828','4.99','2005-08-20T13:49:52.000','2006-02-15T22:19:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12155','450','1','14282','4.99','2005-08-21T06:41:29.000','2006-02-15T22:19:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12156','450','2','15019','0.99','2005-08-22T08:52:53.000','2006-02-15T22:19:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12157','450','1','15327','4.99','2005-08-22T20:31:24.000','2006-02-15T22:19:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12158','450','2','15419','4.99','2005-08-22T23:54:36.000','2006-02-15T22:19:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12159','450','1','14172','0.99','2006-02-14T15:16:03.000','2006-02-15T22:19:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12160','451','2','77','0.99','2005-05-25T11:31:59.000','2006-02-15T22:19:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12161','451','2','328','2.99','2005-05-27T01:29:31.000','2006-02-15T22:19:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12162','451','2','1113','2.99','2005-05-31T15:58:44.000','2006-02-15T22:19:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12163','451','1','1202','0.99','2005-06-15T02:08:04.000','2006-02-15T22:19:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12164','451','1','1851','0.99','2005-06-17T00:32:26.000','2006-02-15T22:19:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12165','451','1','1940','6.99','2005-06-17T07:42:22.000','2006-02-15T22:19:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12166','451','1','2671','1.99','2005-06-19T11:33:11.000','2006-02-15T22:19:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12167','451','1','2909','3.99','2005-06-20T03:19:10.000','2006-02-15T22:19:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12168','451','2','2917','0.99','2005-06-20T04:08:35.000','2006-02-15T22:19:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12169','451','1','3316','6.99','2005-06-21T08:20:18.000','2006-02-15T22:19:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12170','451','2','3826','4.99','2005-07-06T15:51:58.000','2006-02-15T22:19:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12171','451','1','4538','2.99','2005-07-08T03:56:29.000','2006-02-15T22:19:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12172','451','1','4794','8.99','2005-07-08T16:30:11.000','2006-02-15T22:19:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12173','451','2','4930','4.99','2005-07-08T22:15:48.000','2006-02-15T22:19:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12174','451','1','5005','3.99','2005-07-09T01:21:44.000','2006-02-15T22:19:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12175','451','2','5518','8.99','2005-07-10T01:15:11.000','2006-02-15T22:19:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12176','451','1','7018','2.99','2005-07-27T02:20:22.000','2006-02-15T22:19:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12177','451','2','10337','8.99','2005-08-01T05:01:46.000','2006-02-15T22:19:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12178','451','1','10856','2.99','2005-08-02T00:07:14.000','2006-02-15T22:19:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12179','451','2','10950','2.99','2005-08-02T03:25:08.000','2006-02-15T22:19:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12180','451','2','11167','6.99','2005-08-02T10:15:51.000','2006-02-15T22:19:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12181','451','2','11381','6.99','2005-08-02T18:19:29.000','2006-02-15T22:19:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12182','451','1','11790','2.99','2005-08-17T11:00:08.000','2006-02-15T22:19:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12183','451','2','12371','2.99','2005-08-18T08:02:46.000','2006-02-15T22:19:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12184','451','1','12422','4.99','2005-08-18T10:13:12.000','2006-02-15T22:19:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12185','451','2','13003','1.99','2005-08-19T07:39:29.000','2006-02-15T22:19:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12186','451','2','13100','2.99','2005-08-19T10:55:45.000','2006-02-15T22:19:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12187','451','2','13252','2.99','2005-08-19T16:50:50.000','2006-02-15T22:19:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12188','451','2','13380','0.99','2005-08-19T21:36:58.000','2006-02-15T22:19:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12189','451','1','13666','2.99','2005-08-20T08:20:19.000','2006-02-15T22:19:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12190','451','1','13705','2.99','2005-08-20T09:32:23.000','2006-02-15T22:19:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12191','451','2','14500','0.99','2005-08-21T14:11:30.000','2006-02-15T22:19:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12192','451','1','15651','4.99','2005-08-23T08:31:49.000','2006-02-15T22:19:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12193','452','1','354','2.99','2005-05-27T06:12:26.000','2006-02-15T22:19:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12194','452','2','714','2.99','2005-05-29T04:15:21.000','2006-02-15T22:19:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12195','452','1','726','1.99','2005-05-29T06:05:29.000','2006-02-15T22:19:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12196','452','2','1203','4.99','2005-06-15T02:09:02.000','2006-02-15T22:19:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12197','452','1','1512','5.99','2005-06-15T22:53:03.000','2006-02-15T22:19:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12198','452','1','1794','3.99','2005-06-16T20:08:37.000','2006-02-15T22:19:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12199','452','1','2263','0.99','2005-06-18T05:57:47.000','2006-02-15T22:19:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12200','452','2','2266','4.99','2005-06-18T06:05:02.000','2006-02-15T22:19:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12201','452','1','2504','0.99','2005-06-18T23:19:53.000','2006-02-15T22:19:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12202','452','2','2661','0.99','2005-06-19T10:50:52.000','2006-02-15T22:19:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12203','452','2','3638','3.99','2005-07-06T07:08:17.000','2006-02-15T22:19:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12204','452','1','3791','2.99','2005-07-06T14:24:56.000','2006-02-15T22:19:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12205','452','2','3907','6.99','2005-07-06T19:39:14.000','2006-02-15T22:19:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12206','452','1','4348','0.99','2005-07-07T19:02:05.000','2006-02-15T22:19:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12207','452','2','4353','4.99','2005-07-07T19:19:05.000','2006-02-15T22:19:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12208','452','2','4417','2.99','2005-07-07T22:05:05.000','2006-02-15T22:19:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12209','452','1','4720','0.99','2005-07-08T12:34:34.000','2006-02-15T22:19:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12210','452','1','5177','1.99','2005-07-09T09:43:21.000','2006-02-15T22:19:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12211','452','2','5480','0.99','2005-07-09T23:49:07.000','2006-02-15T22:19:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12212','452','2','6959','2.99','2005-07-27T00:07:51.000','2006-02-15T22:19:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12213','452','2','7899','6.99','2005-07-28T11:10:12.000','2006-02-15T22:19:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12214','452','1','8898','1.99','2005-07-30T01:02:20.000','2006-02-15T22:19:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12215','452','2','9379','6.99','2005-07-30T19:13:01.000','2006-02-15T22:19:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12216','452','2','11715','4.99','2005-08-17T07:40:55.000','2006-02-15T22:19:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12217','452','1','11735','3.99','2005-08-17T08:35:42.000','2006-02-15T22:19:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12218','452','1','12355','0.99','2005-08-18T07:36:23.000','2006-02-15T22:19:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12219','452','1','12630','4.99','2005-08-18T17:49:28.000','2006-02-15T22:19:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12220','452','1','13080','4.99','2005-08-19T10:18:00.000','2006-02-15T22:19:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12221','452','1','13642','3.99','2005-08-20T07:42:17.000','2006-02-15T22:19:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12222','452','1','14660','0.99','2005-08-21T19:43:21.000','2006-02-15T22:19:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12223','452','1','15909','0.99','2005-08-23T17:42:42.000','2006-02-15T22:19:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12224','452','1','14175','4.99','2006-02-14T15:16:03.000','2006-02-15T22:19:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12225','453','2','2852','5.99','2005-06-19T23:08:50.000','2006-02-15T22:19:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12226','453','1','2853','7.99','2005-06-19T23:09:41.000','2006-02-15T22:19:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12227','453','2','2887','4.99','2005-06-20T01:39:43.000','2006-02-15T22:19:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12228','453','2','3929','0.99','2005-07-06T20:52:39.000','2006-02-15T22:19:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12229','453','2','4033','8.99','2005-07-07T02:35:46.000','2006-02-15T22:19:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12230','453','1','4717','4.99','2005-07-08T12:22:43.000','2006-02-15T22:19:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12231','453','2','4805','2.99','2005-07-08T16:59:12.000','2006-02-15T22:19:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12232','453','2','5359','6.99','2005-07-09T18:10:52.000','2006-02-15T22:19:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12233','453','1','6752','4.99','2005-07-12T14:53:15.000','2006-02-15T22:19:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12234','453','1','7563','0.99','2005-07-27T22:25:36.000','2006-02-15T22:19:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12235','453','2','9289','6.99','2005-07-30T15:57:04.000','2006-02-15T22:19:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12236','453','2','9406','6.99','2005-07-30T20:24:00.000','2006-02-15T22:19:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12237','453','2','9900','1.99','2005-07-31T14:15:05.000','2006-02-15T22:19:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12238','453','1','11794','4.99','2005-08-17T11:08:48.000','2006-02-15T22:19:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12239','453','1','12703','2.99','2005-08-18T20:37:13.000','2006-02-15T22:19:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12240','453','1','13711','7.99','2005-08-20T09:35:20.000','2006-02-15T22:19:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12241','453','1','13785','4.99','2005-08-20T12:11:46.000','2006-02-15T22:19:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12242','453','1','14133','2.99','2005-08-21T01:44:14.000','2006-02-15T22:19:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12243','453','2','14306','5.99','2005-08-21T07:32:35.000','2006-02-15T22:19:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12244','453','2','14644','4.99','2005-08-21T19:12:12.000','2006-02-15T22:19:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12245','453','1','14652','4.99','2005-08-21T19:32:05.000','2006-02-15T22:19:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12246','453','1','15252','0.99','2005-08-22T18:04:22.000','2006-02-15T22:19:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12247','453','2','15627','4.99','2005-08-23T07:25:38.000','2006-02-15T22:19:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12248','454','1','735','7.99','2005-05-29T08:08:13.000','2006-02-15T22:19:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12249','454','2','1647','4.99','2005-06-16T09:14:58.000','2006-02-15T22:19:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12250','454','2','1844','7.99','2005-06-16T23:53:53.000','2006-02-15T22:19:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12251','454','1','1861','1.99','2005-06-17T01:17:31.000','2006-02-15T22:19:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12252','454','1','1938','4.99','2005-06-17T07:18:36.000','2006-02-15T22:19:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12253','454','2','2048','5.99','2005-06-17T14:55:29.000','2006-02-15T22:19:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12254','454','2','2182','5.99','2005-06-18T00:56:18.000','2006-02-15T22:19:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12255','454','1','2437','2.99','2005-06-18T18:30:26.000','2006-02-15T22:19:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12256','454','2','2666','9.99','2005-06-19T11:17:12.000','2006-02-15T22:19:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12257','454','1','3221','2.99','2005-06-21T01:49:47.000','2006-02-15T22:19:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12258','454','1','3362','4.99','2005-06-21T12:19:54.000','2006-02-15T22:19:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12259','454','1','3622','7.99','2005-07-06T06:05:04.000','2006-02-15T22:19:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12260','454','2','4562','4.99','2005-07-08T05:08:32.000','2006-02-15T22:19:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12261','454','2','5088','4.99','2005-07-09T05:45:16.000','2006-02-15T22:19:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12262','454','2','5446','2.99','2005-07-09T21:59:55.000','2006-02-15T22:19:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12263','454','2','6260','4.99','2005-07-11T15:26:29.000','2006-02-15T22:19:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12264','454','2','6701','0.99','2005-07-12T12:47:59.000','2006-02-15T22:19:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12265','454','2','8481','2.99','2005-07-29T08:45:57.000','2006-02-15T22:19:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12266','454','1','8806','0.99','2005-07-29T21:36:34.000','2006-02-15T22:19:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12267','454','2','9041','0.99','2005-07-30T06:32:36.000','2006-02-15T22:19:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12268','454','1','9372','9.99','2005-07-30T19:04:30.000','2006-02-15T22:19:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12269','454','1','10005','3.99','2005-07-31T17:53:51.000','2006-02-15T22:19:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12270','454','2','12347','0.99','2005-08-18T07:18:10.000','2006-02-15T22:19:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12271','454','1','12553','0.99','2005-08-18T14:46:54.000','2006-02-15T22:19:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12272','454','2','13496','8.99','2005-08-20T01:42:29.000','2006-02-15T22:19:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12273','454','2','13513','2.99','2005-08-20T02:27:53.000','2006-02-15T22:19:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12274','454','2','13694','8.99','2005-08-20T09:13:23.000','2006-02-15T22:19:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12275','454','1','13805','6.99','2005-08-20T12:53:12.000','2006-02-15T22:19:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12276','454','1','14799','0.99','2005-08-22T00:44:57.000','2006-02-15T22:19:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12277','454','2','14843','2.99','2005-08-22T02:05:25.000','2006-02-15T22:19:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12278','454','2','15012','4.99','2005-08-22T08:42:32.000','2006-02-15T22:19:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12279','454','1','15301','3.99','2005-08-22T19:44:16.000','2006-02-15T22:19:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12280','454','2','15608','1.99','2005-08-23T06:55:26.000','2006-02-15T22:19:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12281','455','2','115','0.99','2005-05-25T19:13:25.000','2006-02-15T22:19:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12282','455','2','343','0.99','2005-05-27T04:13:41.000','2006-02-15T22:19:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12283','455','2','1382','1.99','2005-06-15T15:18:08.000','2006-02-15T22:19:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12284','455','1','1802','1.99','2005-06-16T20:23:30.000','2006-02-15T22:19:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12285','455','1','1906','2.99','2005-06-17T04:53:35.000','2006-02-15T22:19:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12286','455','2','2356','0.99','2005-06-18T12:59:23.000','2006-02-15T22:19:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12287','455','2','4195','2.99','2005-07-07T11:00:02.000','2006-02-15T22:19:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12288','455','1','4861','8.99','2005-07-08T18:57:30.000','2006-02-15T22:19:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12289','455','1','4964','2.99','2005-07-08T23:46:38.000','2006-02-15T22:19:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12290','455','1','5504','6.99','2005-07-10T00:36:38.000','2006-02-15T22:19:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12291','455','2','6729','4.99','2005-07-12T13:58:23.000','2006-02-15T22:19:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12292','455','1','7388','4.99','2005-07-27T15:54:19.000','2006-02-15T22:19:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12293','455','2','7498','4.99','2005-07-27T20:09:31.000','2006-02-15T22:19:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12294','455','2','7905','5.99','2005-07-28T11:26:57.000','2006-02-15T22:19:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12295','455','2','8291','2.99','2005-07-29T02:28:25.000','2006-02-15T22:19:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12296','455','1','10436','0.99','2005-08-01T08:50:59.000','2006-02-15T22:19:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12297','455','1','11605','4.99','2005-08-17T03:30:57.000','2006-02-15T22:19:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12298','455','1','12163','2.99','2005-08-18T00:46:01.000','2006-02-15T22:19:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12299','455','1','12314','4.99','2005-08-18T06:10:02.000','2006-02-15T22:19:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12300','455','2','13083','2.99','2005-08-19T10:26:45.000','2006-02-15T22:19:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12301','455','2','13813','4.99','2005-08-20T13:03:26.000','2006-02-15T22:19:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12302','455','1','14294','2.99','2005-08-21T07:07:26.000','2006-02-15T22:19:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12303','455','2','14583','4.99','2005-08-21T17:11:47.000','2006-02-15T22:19:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12304','455','1','15494','1.99','2005-08-23T02:25:09.000','2006-02-15T22:19:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12305','456','2','19','4.99','2005-05-25T01:17:24.000','2006-02-15T22:19:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12306','456','1','1288','2.99','2005-06-15T08:41:52.000','2006-02-15T22:19:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12307','456','1','1700','0.99','2005-06-16T13:18:23.000','2006-02-15T22:19:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12308','456','2','2103','5.99','2005-06-17T19:13:10.000','2006-02-15T22:19:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12309','456','2','2146','6.99','2005-06-17T22:26:23.000','2006-02-15T22:19:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12310','456','1','2192','4.99','2005-06-18T01:35:47.000','2006-02-15T22:19:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12311','456','1','2404','0.99','2005-06-18T16:33:48.000','2006-02-15T22:19:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12312','456','1','2581','2.99','2005-06-19T04:54:13.000','2006-02-15T22:19:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12313','456','1','3743','7.99','2005-07-06T12:03:54.000','2006-02-15T22:19:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12314','456','2','3881','2.99','2005-07-06T18:35:37.000','2006-02-15T22:19:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12315','456','1','4141','3.99','2005-07-07T08:19:20.000','2006-02-15T22:19:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12316','456','2','5964','0.99','2005-07-10T23:47:18.000','2006-02-15T22:19:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12317','456','2','6023','0.99','2005-07-11T02:15:57.000','2006-02-15T22:19:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12318','456','2','7248','2.99','2005-07-27T10:37:45.000','2006-02-15T22:19:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12319','456','1','8749','4.99','2005-07-29T19:13:15.000','2006-02-15T22:19:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12320','456','2','10519','5.99','2005-08-01T11:44:13.000','2006-02-15T22:19:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12321','456','1','10813','2.99','2005-08-01T22:43:00.000','2006-02-15T22:19:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12322','456','1','12188','4.99','2005-08-18T01:51:43.000','2006-02-15T22:19:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12323','456','1','13144','8.99','2005-08-19T12:45:55.000','2006-02-15T22:19:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12324','456','1','13348','4.99','2005-08-19T20:31:48.000','2006-02-15T22:19:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12325','456','1','13547','4.99','2005-08-20T03:53:16.000','2006-02-15T22:19:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12326','456','2','14253','2.99','2005-08-21T05:47:52.000','2006-02-15T22:19:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12327','456','2','14690','1.99','2005-08-21T20:42:25.000','2006-02-15T22:19:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12328','456','1','15720','3.99','2005-08-23T11:15:20.000','2006-02-15T22:19:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12329','456','1','15910','2.99','2005-08-23T17:43:16.000','2006-02-15T22:19:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12330','457','2','1024','7.99','2005-05-31T03:30:19.000','2006-02-15T22:19:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12331','457','2','1453','4.99','2005-06-15T19:36:39.000','2006-02-15T22:19:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12332','457','2','1727','0.99','2005-06-16T15:21:47.000','2006-02-15T22:19:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12333','457','1','2030','0.99','2005-06-17T13:13:27.000','2006-02-15T22:19:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12334','457','1','2172','7.99','2005-06-18T00:06:16.000','2006-02-15T22:19:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12335','457','1','2670','4.99','2005-06-19T11:30:16.000','2006-02-15T22:19:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12336','457','1','2762','3.99','2005-06-19T17:22:31.000','2006-02-15T22:19:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12337','457','1','2811','0.99','2005-06-19T19:53:30.000','2006-02-15T22:19:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12338','457','2','3115','2.99','2005-06-20T17:59:05.000','2006-02-15T22:19:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12339','457','2','3184','2.99','2005-06-20T22:57:44.000','2006-02-15T22:19:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12340','457','2','4600','5.99','2005-07-08T06:48:37.000','2006-02-15T22:19:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12341','457','1','5500','0.99','2005-07-10T00:28:17.000','2006-02-15T22:19:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12342','457','1','6467','7.99','2005-07-12T01:22:03.000','2006-02-15T22:19:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12343','457','1','7184','1.99','2005-07-27T08:22:26.000','2006-02-15T22:19:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12344','457','2','8373','4.99','2005-07-29T05:19:53.000','2006-02-15T22:19:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12345','457','1','8502','2.99','2005-07-29T09:15:41.000','2006-02-15T22:19:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12346','457','1','10049','2.99','2005-07-31T19:11:11.000','2006-02-15T22:19:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12347','457','2','11956','6.99','2005-08-17T17:22:05.000','2006-02-15T22:19:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12348','457','1','12115','4.99','2005-08-17T23:04:15.000','2006-02-15T22:19:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12349','457','1','12171','4.99','2005-08-18T01:06:13.000','2006-02-15T22:19:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12350','457','1','13088','0.99','2005-08-19T10:36:11.000','2006-02-15T22:19:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12351','457','1','13150','2.99','2005-08-19T13:08:19.000','2006-02-15T22:19:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12352','457','2','13934','0.99','2005-08-20T17:18:48.000','2006-02-15T22:19:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12353','457','2','14327','10.99','2005-08-21T08:18:18.000','2006-02-15T22:19:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12354','457','1','14365','6.99','2005-08-21T09:25:13.000','2006-02-15T22:19:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12355','457','1','15128','3.99','2005-08-22T12:57:26.000','2006-02-15T22:19:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12356','457','1','12645','3.98','2006-02-14T15:16:03.000','2006-02-15T22:19:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12357','457','2','14516','0','2006-02-14T15:16:03.000','2006-02-15T22:19:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12358','458','2','2629','5.99','2005-06-19T08:42:12.000','2006-02-15T22:19:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12359','458','2','3322','0.99','2005-06-21T08:42:37.000','2006-02-15T22:19:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12360','458','2','4525','2.99','2005-07-08T03:15:00.000','2006-02-15T22:19:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12361','458','1','5412','2.99','2005-07-09T20:23:52.000','2006-02-15T22:19:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12362','458','1','5572','0.99','2005-07-10T03:49:00.000','2006-02-15T22:19:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12363','458','2','6250','3.99','2005-07-11T15:02:04.000','2006-02-15T22:19:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12364','458','1','6431','5.99','2005-07-12T00:03:57.000','2006-02-15T22:19:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12365','458','2','6595','7.99','2005-07-12T07:25:48.000','2006-02-15T22:19:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12366','458','1','6654','1.99','2005-07-12T11:06:28.000','2006-02-15T22:19:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12367','458','2','7923','3.99','2005-07-28T12:08:29.000','2006-02-15T22:19:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12368','458','1','8158','0.99','2005-07-28T21:08:46.000','2006-02-15T22:19:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12369','458','2','11138','2.99','2005-08-02T09:26:16.000','2006-02-15T22:19:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12370','458','2','11975','2.99','2005-08-17T17:58:39.000','2006-02-15T22:19:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12371','458','2','12768','0.99','2005-08-18T23:26:11.000','2006-02-15T22:19:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12372','458','2','13259','2.99','2005-08-19T17:08:53.000','2006-02-15T22:19:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12373','458','2','13487','2.99','2005-08-20T01:27:05.000','2006-02-15T22:19:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12374','458','2','13571','4.99','2005-08-20T05:05:14.000','2006-02-15T22:19:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12375','458','2','14428','4.99','2005-08-21T11:27:07.000','2006-02-15T22:19:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12376','458','1','15604','4.99','2005-08-23T06:44:19.000','2006-02-15T22:19:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12377','459','2','2','2.99','2005-05-24T22:54:33.000','2006-02-15T22:19:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12378','459','2','1876','0.99','2005-06-17T02:50:51.000','2006-02-15T22:19:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12379','459','2','1977','2.99','2005-06-17T09:38:22.000','2006-02-15T22:19:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12380','459','2','2075','4.99','2005-06-17T16:40:33.000','2006-02-15T22:19:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12381','459','1','2899','0.99','2005-06-20T02:39:21.000','2006-02-15T22:19:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12382','459','2','3041','4.99','2005-06-20T12:35:44.000','2006-02-15T22:19:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12383','459','2','3045','0.99','2005-06-20T12:42:00.000','2006-02-15T22:19:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12384','459','2','3234','9.99','2005-06-21T02:39:44.000','2006-02-15T22:19:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12385','459','1','3506','2.99','2005-07-06T00:22:29.000','2006-02-15T22:19:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12386','459','2','4519','2.99','2005-07-08T02:51:23.000','2006-02-15T22:19:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12387','459','1','5301','3.99','2005-07-09T15:42:10.000','2006-02-15T22:19:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12388','459','1','5695','0.99','2005-07-10T09:43:40.000','2006-02-15T22:19:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12389','459','1','6206','0.99','2005-07-11T12:32:14.000','2006-02-15T22:19:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12390','459','2','6750','3.99','2005-07-12T14:49:39.000','2006-02-15T22:19:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12391','459','1','7623','6.99','2005-07-28T00:37:41.000','2006-02-15T22:19:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12392','459','2','7639','4.99','2005-07-28T01:14:36.000','2006-02-15T22:19:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12393','459','1','7717','4.99','2005-07-28T04:33:54.000','2006-02-15T22:19:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12394','459','1','7820','5.99','2005-07-28T08:28:51.000','2006-02-15T22:19:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12395','459','1','7913','6.99','2005-07-28T11:47:23.000','2006-02-15T22:19:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12396','459','1','8289','9.99','2005-07-29T02:23:24.000','2006-02-15T22:19:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12397','459','2','8557','10.99','2005-07-29T11:19:59.000','2006-02-15T22:19:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12398','459','1','8897','2.99','2005-07-30T01:00:17.000','2006-02-15T22:19:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12399','459','1','9137','6.99','2005-07-30T10:09:24.000','2006-02-15T22:19:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12400','459','2','9639','2.99','2005-07-31T05:32:10.000','2006-02-15T22:19:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12401','459','1','9744','4.99','2005-07-31T09:15:38.000','2006-02-15T22:19:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12402','459','2','10117','4.99','2005-07-31T21:14:31.000','2006-02-15T22:19:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12403','459','1','10233','6.99','2005-08-01T01:54:23.000','2006-02-15T22:19:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12404','459','2','10255','4.99','2005-08-01T02:46:13.000','2006-02-15T22:19:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12405','459','1','10499','7.99','2005-08-01T11:00:20.000','2006-02-15T22:19:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12406','459','1','10531','2.99','2005-08-01T12:06:30.000','2006-02-15T22:19:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12407','459','1','12527','6.99','2005-08-18T13:48:46.000','2006-02-15T22:19:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12408','459','1','12629','7.99','2005-08-18T17:40:33.000','2006-02-15T22:19:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12409','459','2','13960','10.99','2005-08-20T18:16:26.000','2006-02-15T22:19:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12410','459','1','13967','4.99','2005-08-20T18:28:46.000','2006-02-15T22:19:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12411','459','1','14315','3.99','2005-08-21T07:56:39.000','2006-02-15T22:19:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12412','459','1','15126','5.99','2005-08-22T12:53:58.000','2006-02-15T22:19:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12413','459','2','15342','2.99','2005-08-22T20:56:41.000','2006-02-15T22:19:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12414','459','1','15814','0.99','2005-08-23T14:52:50.000','2006-02-15T22:19:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12415','460','1','223','4.99','2005-05-26T10:15:23.000','2006-02-15T22:19:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12416','460','2','298','0.99','2005-05-26T20:52:26.000','2006-02-15T22:19:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12417','460','1','880','0.99','2005-05-30T06:12:33.000','2006-02-15T22:19:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12418','460','2','1064','4.99','2005-05-31T08:50:07.000','2006-02-15T22:19:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12419','460','2','1392','0.99','2005-06-15T16:12:27.000','2006-02-15T22:19:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12420','460','2','3820','4.99','2005-07-06T15:35:26.000','2006-02-15T22:19:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12421','460','1','4452','7.99','2005-07-07T23:31:54.000','2006-02-15T22:19:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12422','460','2','5482','3.99','2005-07-09T23:53:04.000','2006-02-15T22:19:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12423','460','1','6613','4.99','2005-07-12T08:30:07.000','2006-02-15T22:19:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12424','460','1','6788','5.99','2005-07-12T16:33:44.000','2006-02-15T22:19:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12425','460','1','7125','6.99','2005-07-27T06:11:00.000','2006-02-15T22:19:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12426','460','1','7785','3.99','2005-07-28T07:16:11.000','2006-02-15T22:19:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12427','460','2','8656','2.99','2005-07-29T15:05:52.000','2006-02-15T22:19:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12428','460','2','10754','10.99','2005-08-01T20:12:33.000','2006-02-15T22:19:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12429','460','1','10926','1.99','2005-08-02T02:26:37.000','2006-02-15T22:19:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12430','460','2','11554','2.99','2005-08-17T01:05:17.000','2006-02-15T22:19:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12431','460','1','12056','5.99','2005-08-17T21:03:48.000','2006-02-15T22:19:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12432','460','2','12586','4.99','2005-08-18T15:54:39.000','2006-02-15T22:19:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12433','460','1','12865','0.99','2005-08-19T02:38:50.000','2006-02-15T22:19:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12434','460','2','13215','8.99','2005-08-19T15:35:38.000','2006-02-15T22:19:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12435','460','1','13341','3.99','2005-08-19T20:18:53.000','2006-02-15T22:19:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12436','460','2','13920','5.99','2005-08-20T16:51:18.000','2006-02-15T22:19:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12437','460','2','14864','0.99','2005-08-22T02:57:06.000','2006-02-15T22:19:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12438','460','1','14923','3.99','2005-08-22T05:13:33.000','2006-02-15T22:19:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12439','460','2','15954','2.99','2005-08-23T19:14:07.000','2006-02-15T22:19:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12440','461','1','684','6.99','2005-05-29T00:13:15.000','2006-02-15T22:19:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12441','461','2','3127','5.99','2005-06-20T18:39:43.000','2006-02-15T22:19:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12442','461','2','3319','4.99','2005-06-21T08:25:46.000','2006-02-15T22:19:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12443','461','2','3698','0.99','2005-07-06T10:09:20.000','2006-02-15T22:19:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12444','461','2','4586','2.99','2005-07-08T06:12:33.000','2006-02-15T22:19:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12445','461','1','5650','0.99','2005-07-10T07:17:01.000','2006-02-15T22:19:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12446','461','1','5809','2.99','2005-07-10T15:19:30.000','2006-02-15T22:19:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12447','461','2','7334','2.99','2005-07-27T13:59:58.000','2006-02-15T22:19:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12448','461','2','7664','2.99','2005-07-28T02:24:23.000','2006-02-15T22:19:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12449','461','2','8133','0.99','2005-07-28T20:01:06.000','2006-02-15T22:19:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12450','461','2','8164','0.99','2005-07-28T21:17:19.000','2006-02-15T22:19:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12451','461','2','9499','4.99','2005-07-30T23:58:30.000','2006-02-15T22:19:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12452','461','1','9885','0.99','2005-07-31T13:59:32.000','2006-02-15T22:19:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12453','461','2','10113','4.99','2005-07-31T21:10:03.000','2006-02-15T22:19:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12454','461','1','10260','2.99','2005-08-01T02:58:07.000','2006-02-15T22:19:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12455','461','2','11063','0.99','2005-08-02T06:53:48.000','2006-02-15T22:19:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12456','461','2','11219','0.99','2005-08-02T12:30:20.000','2006-02-15T22:19:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12457','461','2','12022','2.99','2005-08-17T19:52:45.000','2006-02-15T22:19:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12458','461','1','13223','2.99','2005-08-19T15:52:04.000','2006-02-15T22:19:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12459','461','1','13269','2.99','2005-08-19T17:34:00.000','2006-02-15T22:19:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12460','461','1','14186','4.99','2005-08-21T03:31:07.000','2006-02-15T22:19:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12461','461','1','14893','4.99','2005-08-22T04:15:48.000','2006-02-15T22:19:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12462','461','1','15067','2.99','2005-08-22T10:49:21.000','2006-02-15T22:19:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12463','461','2','15187','4.99','2005-08-22T15:53:32.000','2006-02-15T22:19:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12464','461','1','15336','6.99','2005-08-22T20:47:48.000','2006-02-15T22:19:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12465','461','2','15411','2.99','2005-08-22T23:35:41.000','2006-02-15T22:19:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12466','461','2','15449','2.99','2005-08-23T00:55:43.000','2006-02-15T22:19:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12467','461','2','15613','7.99','2005-08-23T07:03:19.000','2006-02-15T22:19:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12468','462','2','156','2.99','2005-05-26T01:19:05.000','2006-02-15T22:19:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12469','462','2','590','3.99','2005-05-28T13:06:50.000','2006-02-15T22:19:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12470','462','2','1773','5.99','2005-06-16T18:13:43.000','2006-02-15T22:19:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12471','462','2','1926','9.99','2005-06-17T06:24:30.000','2006-02-15T22:19:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12472','462','1','3279','4.99','2005-06-21T06:05:53.000','2006-02-15T22:19:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12473','462','1','4500','4.99','2005-07-08T02:10:01.000','2006-02-15T22:19:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12474','462','2','4728','3.99','2005-07-08T12:59:01.000','2006-02-15T22:19:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12475','462','1','6583','4.99','2005-07-12T06:42:31.000','2006-02-15T22:19:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12476','462','1','6630','0.99','2005-07-12T09:30:05.000','2006-02-15T22:19:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12477','462','1','6710','7.99','2005-07-12T13:23:09.000','2006-02-15T22:19:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12478','462','1','6721','6.99','2005-07-12T13:42:58.000','2006-02-15T22:19:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12479','462','2','7295','8.99','2005-07-27T12:38:47.000','2006-02-15T22:19:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12480','462','1','7324','6.99','2005-07-27T13:42:39.000','2006-02-15T22:19:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12481','462','1','7762','8.99','2005-07-28T06:34:23.000','2006-02-15T22:19:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12482','462','1','7932','4.99','2005-07-28T12:24:54.000','2006-02-15T22:19:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12483','462','2','7935','2.99','2005-07-28T12:33:17.000','2006-02-15T22:19:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12484','462','1','8066','2.99','2005-07-28T17:20:09.000','2006-02-15T22:19:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12485','462','1','8282','0.99','2005-07-29T01:49:04.000','2006-02-15T22:19:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12486','462','1','8290','3.99','2005-07-29T02:24:08.000','2006-02-15T22:19:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12487','462','2','8757','2.99','2005-07-29T19:19:10.000','2006-02-15T22:19:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12488','462','1','9891','0.99','2005-07-31T14:05:44.000','2006-02-15T22:19:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12489','462','1','10283','2.99','2005-08-01T03:29:45.000','2006-02-15T22:19:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12490','462','2','11639','6.99','2005-08-17T04:43:29.000','2006-02-15T22:19:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12491','462','1','11808','2.99','2005-08-17T11:51:16.000','2006-02-15T22:19:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12492','462','1','12466','4.99','2005-08-18T11:36:55.000','2006-02-15T22:19:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12493','462','2','12582','0.99','2005-08-18T15:51:12.000','2006-02-15T22:19:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12494','462','1','12802','8.99','2005-08-19T00:27:41.000','2006-02-15T22:19:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12495','462','2','13041','8.99','2005-08-19T09:05:38.000','2006-02-15T22:19:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12496','462','1','13328','4.99','2005-08-19T19:56:01.000','2006-02-15T22:19:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12497','462','1','13492','7.99','2005-08-20T01:32:04.000','2006-02-15T22:19:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12498','462','2','15581','2.99','2005-08-23T05:42:13.000','2006-02-15T22:19:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12499','462','1','15943','2.99','2005-08-23T18:49:32.000','2006-02-15T22:19:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12500','462','1','16013','0.99','2005-08-23T21:17:17.000','2006-02-15T22:19:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12501','463','1','560','1.99','2005-05-28T08:53:02.000','2006-02-15T22:19:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12502','463','1','1284','2.99','2005-06-15T08:27:33.000','2006-02-15T22:19:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12503','463','2','2527','4.99','2005-06-19T01:10:31.000','2006-02-15T22:19:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12504','463','1','3217','2.99','2005-06-21T01:28:12.000','2006-02-15T22:19:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12505','463','1','3309','4.99','2005-06-21T08:00:49.000','2006-02-15T22:19:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12506','463','1','5026','2.99','2005-07-09T02:32:34.000','2006-02-15T22:19:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12507','463','1','5157','2.99','2005-07-09T08:52:12.000','2006-02-15T22:19:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12508','463','1','5448','0.99','2005-07-09T22:11:14.000','2006-02-15T22:19:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12509','463','2','6294','0.99','2005-07-11T17:25:55.000','2006-02-15T22:19:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12510','463','1','6932','6.99','2005-07-26T23:08:04.000','2006-02-15T22:19:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12511','463','1','7013','0.99','2005-07-27T02:03:21.000','2006-02-15T22:19:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12512','463','1','7361','0.99','2005-07-27T14:53:55.000','2006-02-15T22:19:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12513','463','1','8762','2.99','2005-07-29T19:30:02.000','2006-02-15T22:19:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12514','463','2','9405','7.99','2005-07-30T20:22:17.000','2006-02-15T22:19:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12515','463','1','9954','2.99','2005-07-31T15:57:07.000','2006-02-15T22:19:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12516','463','1','10275','3.99','2005-08-01T03:20:08.000','2006-02-15T22:19:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12517','463','2','10405','0.99','2005-08-01T07:35:25.000','2006-02-15T22:19:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12518','463','2','10906','2.99','2005-08-02T01:47:04.000','2006-02-15T22:19:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12519','463','2','12096','7.99','2005-08-17T22:32:50.000','2006-02-15T22:19:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12520','463','2','12679','6.99','2005-08-18T19:42:11.000','2006-02-15T22:19:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12521','463','1','12950','2.99','2005-08-19T05:55:58.000','2006-02-15T22:19:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12522','463','2','13938','4.99','2005-08-20T17:24:45.000','2006-02-15T22:19:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12523','463','1','14689','0.99','2005-08-21T20:33:00.000','2006-02-15T22:19:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12524','463','1','14859','2.99','2005-08-22T02:46:35.000','2006-02-15T22:19:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12525','463','2','15151','7.99','2005-08-22T14:23:11.000','2006-02-15T22:19:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12526','464','1','305','3.99','2005-05-26T21:22:07.000','2006-02-15T22:19:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12527','464','2','373','1.99','2005-05-27T08:16:25.000','2006-02-15T22:19:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12528','464','2','1277','4.99','2005-06-15T08:01:29.000','2006-02-15T22:19:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12529','464','1','3167','2.99','2005-06-20T21:42:29.000','2006-02-15T22:19:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12530','464','1','3761','4.99','2005-07-06T12:52:44.000','2006-02-15T22:19:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12531','464','1','4337','5.99','2005-07-07T18:36:37.000','2006-02-15T22:19:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12532','464','2','5455','6.99','2005-07-09T22:28:45.000','2006-02-15T22:19:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12533','464','1','5910','4.99','2005-07-10T20:51:34.000','2006-02-15T22:19:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12534','464','2','6601','3.99','2005-07-12T07:44:49.000','2006-02-15T22:19:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12535','464','1','9600','5.99','2005-07-31T03:35:34.000','2006-02-15T22:19:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12536','464','2','11275','1.99','2005-08-02T14:25:58.000','2006-02-15T22:19:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12537','464','1','13644','8.99','2005-08-20T07:46:30.000','2006-02-15T22:19:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12538','464','2','13943','2.99','2005-08-20T17:31:18.000','2006-02-15T22:19:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12539','464','1','15092','6.99','2005-08-22T11:36:16.000','2006-02-15T22:19:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12540','464','2','15854','0.99','2005-08-23T15:58:05.000','2006-02-15T22:19:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12541','464','1','15983','4.99','2005-08-23T20:13:38.000','2006-02-15T22:19:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12542','465','2','640','0.99','2005-05-28T18:43:26.000','2006-02-15T22:19:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12543','465','1','1337','2.99','2005-06-15T12:12:42.000','2006-02-15T22:19:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12544','465','1','2079','4.99','2005-06-17T16:49:45.000','2006-02-15T22:19:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12545','465','1','2159','8.99','2005-06-17T23:37:29.000','2006-02-15T22:19:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12546','465','2','2524','0.99','2005-06-19T00:48:11.000','2006-02-15T22:19:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12547','465','1','4763','0.99','2005-07-08T14:57:32.000','2006-02-15T22:19:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12548','465','2','6904','3.99','2005-07-12T22:02:09.000','2006-02-15T22:19:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12549','465','2','7508','2.99','2005-07-27T20:33:08.000','2006-02-15T22:19:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12550','465','1','10542','3.99','2005-08-01T12:32:23.000','2006-02-15T22:19:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12551','465','1','11156','2.99','2005-08-02T09:56:06.000','2006-02-15T22:19:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12552','465','1','11586','4.99','2005-08-17T02:20:42.000','2006-02-15T22:19:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12553','465','2','11648','6.99','2005-08-17T04:56:16.000','2006-02-15T22:19:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12554','465','2','12106','4.99','2005-08-17T22:55:32.000','2006-02-15T22:19:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12555','465','1','12814','4.99','2005-08-19T00:58:24.000','2006-02-15T22:19:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12556','465','1','12864','4.99','2005-08-19T02:38:26.000','2006-02-15T22:19:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12557','465','1','15550','3.99','2005-08-23T04:27:54.000','2006-02-15T22:19:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12558','465','2','15859','4.99','2005-08-23T16:08:15.000','2006-02-15T22:19:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12559','466','2','1104','2.99','2005-05-31T14:30:01.000','2006-02-15T22:19:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12560','466','2','1808','7.99','2005-06-16T20:59:35.000','2006-02-15T22:19:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12561','466','2','2446','8.99','2005-06-18T19:04:41.000','2006-02-15T22:19:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12562','466','1','3022','3.99','2005-06-20T11:17:20.000','2006-02-15T22:19:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12563','466','2','3237','4.99','2005-06-21T02:47:56.000','2006-02-15T22:19:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12564','466','2','3343','2.99','2005-06-21T10:56:59.000','2006-02-15T22:19:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12565','466','2','5048','0.99','2005-07-09T03:46:33.000','2006-02-15T22:19:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12566','466','1','5691','4.99','2005-07-10T09:29:49.000','2006-02-15T22:19:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12567','466','1','6073','6.99','2005-07-11T04:54:31.000','2006-02-15T22:19:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12568','466','2','7080','2.99','2005-07-27T04:25:25.000','2006-02-15T22:19:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12569','466','2','8276','0.99','2005-07-29T01:38:43.000','2006-02-15T22:19:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12570','466','1','9202','3.99','2005-07-30T12:43:24.000','2006-02-15T22:19:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12571','466','1','9257','2.99','2005-07-30T14:30:38.000','2006-02-15T22:19:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12572','466','1','10469','4.99','2005-08-01T09:51:11.000','2006-02-15T22:19:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12573','466','2','11343','0.99','2005-08-02T17:12:30.000','2006-02-15T22:19:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12574','466','1','11359','4.99','2005-08-02T17:45:55.000','2006-02-15T22:19:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12575','466','1','12048','7.99','2005-08-17T20:49:24.000','2006-02-15T22:19:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12576','466','1','13478','2.99','2005-08-20T01:07:14.000','2006-02-15T22:19:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12577','466','1','13884','5.99','2005-08-20T15:30:51.000','2006-02-15T22:19:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12578','466','1','13988','4.99','2005-08-20T19:21:28.000','2006-02-15T22:19:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12579','466','2','14546','2.99','2005-08-21T15:50:50.000','2006-02-15T22:19:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12580','466','2','15230','4.99','2005-08-22T17:31:41.000','2006-02-15T22:19:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12581','466','1','16005','7.99','2005-08-23T21:00:22.000','2006-02-15T22:19:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12582','467','2','225','4.99','2005-05-26T10:27:50.000','2006-02-15T22:19:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12583','467','1','1737','8.99','2005-06-16T15:59:44.000','2006-02-15T22:19:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12584','467','2','2121','4.99','2005-06-17T20:38:54.000','2006-02-15T22:19:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12585','467','2','2870','9.99','2005-06-20T00:17:46.000','2006-02-15T22:19:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12586','467','1','3250','6.99','2005-06-21T03:16:36.000','2006-02-15T22:19:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12587','467','1','4216','0.99','2005-07-07T12:01:34.000','2006-02-15T22:19:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12588','467','2','4222','4.99','2005-07-07T12:20:21.000','2006-02-15T22:19:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12589','467','1','4259','4.99','2005-07-07T14:22:18.000','2006-02-15T22:19:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12590','467','2','5160','4.99','2005-07-09T08:57:07.000','2006-02-15T22:19:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12591','467','2','6271','6.99','2005-07-11T16:01:35.000','2006-02-15T22:19:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12592','467','2','7360','2.99','2005-07-27T14:52:06.000','2006-02-15T22:19:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12593','467','2','7573','5.99','2005-07-27T22:46:20.000','2006-02-15T22:19:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12594','467','1','7611','2.99','2005-07-28T00:11:47.000','2006-02-15T22:19:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12595','467','1','8010','7.99','2005-07-28T15:26:20.000','2006-02-15T22:19:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12596','467','2','8061','6.99','2005-07-28T17:12:53.000','2006-02-15T22:19:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12597','467','2','8224','2.99','2005-07-28T23:59:02.000','2006-02-15T22:19:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12598','467','2','8480','8.99','2005-07-29T08:44:46.000','2006-02-15T22:19:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12599','467','1','8767','4.99','2005-07-29T19:42:33.000','2006-02-15T22:19:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12600','467','2','10239','0.99','2005-08-01T02:09:22.000','2006-02-15T22:19:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12601','467','2','11332','2.99','2005-08-02T16:52:57.000','2006-02-15T22:19:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12602','467','1','11874','4.99','2005-08-17T14:16:40.000','2006-02-15T22:19:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12603','467','1','12266','2.99','2005-08-18T04:22:31.000','2006-02-15T22:19:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12604','467','1','12437','9.99','2005-08-18T10:42:43.000','2006-02-15T22:19:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12605','467','1','12641','2.99','2005-08-18T18:18:08.000','2006-02-15T22:19:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12606','467','1','14402','2.99','2005-08-21T10:38:17.000','2006-02-15T22:19:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12607','467','1','14451','0.99','2005-08-21T12:21:44.000','2006-02-15T22:19:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12608','467','1','14842','3.99','2005-08-22T02:04:38.000','2006-02-15T22:19:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12609','467','1','15032','0.99','2005-08-22T09:14:09.000','2006-02-15T22:19:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12610','467','2','15830','2.99','2005-08-23T15:19:15.000','2006-02-15T22:19:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12611','468','2','101','6.99','2005-05-25T17:17:04.000','2006-02-15T22:19:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12612','468','1','186','4.99','2005-05-26T05:32:52.000','2006-02-15T22:19:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12613','468','2','296','6.99','2005-05-26T20:35:19.000','2006-02-15T22:19:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12614','468','2','459','0.99','2005-05-27T20:00:04.000','2006-02-15T22:19:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12615','468','1','673','0.99','2005-05-28T22:07:30.000','2006-02-15T22:19:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12616','468','2','1229','2.99','2005-06-15T03:53:13.000','2006-02-15T22:19:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12617','468','1','1627','8.99','2005-06-16T07:51:09.000','2006-02-15T22:19:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12618','468','1','1821','2.99','2005-06-16T21:42:49.000','2006-02-15T22:19:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12619','468','1','1975','2.99','2005-06-17T09:32:10.000','2006-02-15T22:19:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12620','468','2','2462','4.99','2005-06-18T20:00:15.000','2006-02-15T22:19:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12621','468','1','2831','0.99','2005-06-19T21:17:06.000','2006-02-15T22:19:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12622','468','2','3724','2.99','2005-07-06T11:12:48.000','2006-02-15T22:19:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12623','468','1','3840','5.99','2005-07-06T16:30:59.000','2006-02-15T22:19:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12624','468','2','4184','3.99','2005-07-07T10:30:08.000','2006-02-15T22:19:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12625','468','2','4527','3.99','2005-07-08T03:20:10.000','2006-02-15T22:19:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12626','468','1','5285','2.99','2005-07-09T15:10:44.000','2006-02-15T22:19:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12627','468','1','6392','0.99','2005-07-11T22:25:19.000','2006-02-15T22:19:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12628','468','1','6581','4.99','2005-07-12T06:26:49.000','2006-02-15T22:19:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12629','468','2','6815','5.99','2005-07-12T18:14:10.000','2006-02-15T22:19:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12630','468','2','7292','4.99','2005-07-27T12:34:14.000','2006-02-15T22:19:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12631','468','1','7685','0.99','2005-07-28T03:13:00.000','2006-02-15T22:19:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12632','468','2','8423','5.99','2005-07-29T07:02:57.000','2006-02-15T22:19:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12633','468','2','8768','6.99','2005-07-29T19:43:02.000','2006-02-15T22:19:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12634','468','1','9598','0.99','2005-07-31T03:30:41.000','2006-02-15T22:19:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12635','468','1','9690','6.99','2005-07-31T07:06:29.000','2006-02-15T22:19:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12636','468','2','11257','10.99','2005-08-02T13:45:05.000','2006-02-15T22:19:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12637','468','2','11633','4.99','2005-08-17T04:30:09.000','2006-02-15T22:19:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12638','468','2','12026','6.99','2005-08-17T20:00:10.000','2006-02-15T22:19:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12639','468','2','13221','3.99','2005-08-19T15:45:47.000','2006-02-15T22:19:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12640','468','1','13417','0.99','2005-08-19T22:51:39.000','2006-02-15T22:19:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12641','468','2','14154','4.99','2005-08-21T02:30:00.000','2006-02-15T22:19:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12642','468','2','14210','4.99','2005-08-21T04:28:02.000','2006-02-15T22:19:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12643','468','1','14309','9.99','2005-08-21T07:44:17.000','2006-02-15T22:19:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12644','468','1','14313','2.99','2005-08-21T07:49:53.000','2006-02-15T22:19:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12645','468','1','14614','9.99','2005-08-21T18:03:51.000','2006-02-15T22:19:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12646','468','2','15435','4.99','2005-08-23T00:28:19.000','2006-02-15T22:19:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12647','468','1','15522','1.99','2005-08-23T03:32:31.000','2006-02-15T22:19:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12648','468','1','15836','2.99','2005-08-23T15:29:17.000','2006-02-15T22:19:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12649','468','2','16044','0.99','2005-08-23T22:24:39.000','2006-02-15T22:19:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12650','469','1','168','0.99','2005-05-26T03:07:43.000','2006-02-15T22:19:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12651','469','2','506','7.99','2005-05-28T02:09:19.000','2006-02-15T22:19:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12652','469','2','529','4.99','2005-05-28T04:34:17.000','2006-02-15T22:19:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12653','469','2','936','1.99','2005-05-30T13:52:49.000','2006-02-15T22:19:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12654','469','1','1119','2.99','2005-05-31T16:34:27.000','2006-02-15T22:19:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12655','469','2','1399','0.99','2005-06-15T16:29:51.000','2006-02-15T22:19:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12656','469','1','1680','9.99','2005-06-16T11:17:22.000','2006-02-15T22:19:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12657','469','2','3522','4.99','2005-07-06T01:00:21.000','2006-02-15T22:19:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12658','469','1','3526','10.99','2005-07-06T01:03:29.000','2006-02-15T22:19:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12659','469','2','4067','3.99','2005-07-07T04:34:23.000','2006-02-15T22:19:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12660','469','2','4123','0.99','2005-07-07T07:16:19.000','2006-02-15T22:19:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12661','469','1','5133','0.99','2005-07-09T07:43:22.000','2006-02-15T22:19:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12662','469','1','5299','3.99','2005-07-09T15:38:09.000','2006-02-15T22:19:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12663','469','2','5664','6.99','2005-07-10T08:04:41.000','2006-02-15T22:19:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12664','469','2','6022','0.99','2005-07-11T02:15:53.000','2006-02-15T22:19:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12665','469','2','6099','4.99','2005-07-11T06:24:44.000','2006-02-15T22:19:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12666','469','1','6797','4.99','2005-07-12T16:47:06.000','2006-02-15T22:19:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12667','469','1','6955','3.99','2005-07-26T23:55:48.000','2006-02-15T22:19:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12668','469','2','7062','6.99','2005-07-27T03:52:01.000','2006-02-15T22:19:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12669','469','2','7271','6.99','2005-07-27T11:29:11.000','2006-02-15T22:19:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12670','469','2','7756','4.99','2005-07-28T06:22:52.000','2006-02-15T22:19:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12671','469','1','7914','4.99','2005-07-28T11:48:08.000','2006-02-15T22:19:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12672','469','2','8791','0.99','2005-07-29T20:53:23.000','2006-02-15T22:19:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12673','469','1','9187','2.99','2005-07-30T12:14:03.000','2006-02-15T22:19:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12674','469','2','10075','4.99','2005-07-31T19:58:42.000','2006-02-15T22:19:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12675','469','1','10258','4.99','2005-08-01T02:51:09.000','2006-02-15T22:19:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12676','469','1','10316','4.99','2005-08-01T04:34:57.000','2006-02-15T22:19:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12677','469','1','10658','2.99','2005-08-01T16:39:18.000','2006-02-15T22:19:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12678','469','1','10741','2.99','2005-08-01T19:52:52.000','2006-02-15T22:19:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12679','469','2','11185','0.99','2005-08-02T11:04:35.000','2006-02-15T22:19:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12680','469','2','12035','0.99','2005-08-17T20:18:06.000','2006-02-15T22:19:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12681','469','1','12447','4.99','2005-08-18T10:57:01.000','2006-02-15T22:19:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12682','469','1','12633','6.99','2005-08-18T17:55:38.000','2006-02-15T22:19:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12683','469','1','13654','4.99','2005-08-20T07:58:21.000','2006-02-15T22:19:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12684','469','1','13763','2.99','2005-08-20T11:37:56.000','2006-02-15T22:19:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12685','469','2','14197','7.99','2005-08-21T03:47:25.000','2006-02-15T22:19:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12686','469','2','14661','2.99','2005-08-21T19:44:21.000','2006-02-15T22:19:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12687','469','1','15487','4.99','2005-08-23T02:05:51.000','2006-02-15T22:19:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12688','469','1','15561','9.99','2005-08-23T05:02:31.000','2006-02-15T22:19:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12689','469','1','15851','2.99','2005-08-23T15:46:33.000','2006-02-15T22:19:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12690','470','2','60','2.99','2005-05-25T08:58:25.000','2006-02-15T22:19:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12691','470','2','1256','0.99','2005-06-15T06:13:57.000','2006-02-15T22:19:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12692','470','1','1283','0.99','2005-06-15T08:27:30.000','2006-02-15T22:19:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12693','470','2','1594','7.99','2005-06-16T05:15:12.000','2006-02-15T22:19:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12694','470','1','3764','5.99','2005-07-06T13:01:03.000','2006-02-15T22:19:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12695','470','1','3841','4.99','2005-07-06T16:34:00.000','2006-02-15T22:19:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12696','470','1','3922','4.99','2005-07-06T20:32:27.000','2006-02-15T22:19:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12697','470','1','4373','4.99','2005-07-07T20:10:59.000','2006-02-15T22:19:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12698','470','2','4502','6.99','2005-07-08T02:12:04.000','2006-02-15T22:19:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12699','470','2','5082','4.99','2005-07-09T05:28:38.000','2006-02-15T22:19:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12700','470','1','6009','3.99','2005-07-11T01:51:58.000','2006-02-15T22:19:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12701','470','1','6198','2.99','2005-07-11T12:12:17.000','2006-02-15T22:19:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12702','470','2','6703','4.99','2005-07-12T12:50:19.000','2006-02-15T22:19:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12703','470','1','6927','10.99','2005-07-26T22:56:00.000','2006-02-15T22:19:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12704','470','1','6942','5.99','2005-07-26T23:27:40.000','2006-02-15T22:19:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12705','470','1','7663','4.99','2005-07-28T02:19:48.000','2006-02-15T22:19:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12706','470','2','8476','8.99','2005-07-29T08:39:12.000','2006-02-15T22:19:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12707','470','1','8890','6.99','2005-07-30T00:42:06.000','2006-02-15T22:19:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12708','470','1','9422','5.99','2005-07-30T21:08:41.000','2006-02-15T22:19:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12709','470','1','9687','2.99','2005-07-31T06:52:54.000','2006-02-15T22:19:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12710','470','1','10006','4.99','2005-07-31T17:54:35.000','2006-02-15T22:19:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12711','470','1','10236','0.99','2005-08-01T02:05:34.000','2006-02-15T22:19:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12712','470','2','10944','4.99','2005-08-02T03:20:03.000','2006-02-15T22:19:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12713','470','2','11397','1.99','2005-08-02T18:53:14.000','2006-02-15T22:19:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12714','470','2','11711','2.99','2005-08-17T07:30:55.000','2006-02-15T22:19:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12715','470','1','11742','0.99','2005-08-17T08:48:43.000','2006-02-15T22:19:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12716','470','2','12177','3.99','2005-08-18T01:15:47.000','2006-02-15T22:19:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12717','470','2','12423','8.99','2005-08-18T10:14:52.000','2006-02-15T22:19:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12718','470','1','12753','10.99','2005-08-18T22:37:39.000','2006-02-15T22:19:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12719','470','2','13585','4.99','2005-08-20T05:32:23.000','2006-02-15T22:19:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12720','470','1','13592','4.99','2005-08-20T05:50:35.000','2006-02-15T22:19:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12721','470','2','14405','4.99','2005-08-21T10:45:01.000','2006-02-15T22:19:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12722','471','1','616','2.99','2005-05-28T15:45:39.000','2006-02-15T22:19:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12723','471','1','1447','4.99','2005-06-15T19:13:51.000','2006-02-15T22:19:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12724','471','2','1449','2.99','2005-06-15T19:19:16.000','2006-02-15T22:19:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12725','471','2','2165','2.99','2005-06-17T23:51:10.000','2006-02-15T22:19:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12726','471','2','2350','4.99','2005-06-18T12:25:29.000','2006-02-15T22:19:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12727','471','2','3073','4.99','2005-06-20T14:33:26.000','2006-02-15T22:19:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12728','471','1','3917','0.99','2005-07-06T20:19:29.000','2006-02-15T22:19:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12729','471','1','4020','2.99','2005-07-07T01:42:22.000','2006-02-15T22:19:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12730','471','2','6293','2.99','2005-07-11T17:24:57.000','2006-02-15T22:19:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12731','471','1','6336','8.99','2005-07-11T19:30:13.000','2006-02-15T22:19:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12732','471','1','6912','5.99','2005-07-12T22:17:16.000','2006-02-15T22:19:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12733','471','1','8199','0.99','2005-07-28T23:10:25.000','2006-02-15T22:19:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12734','471','1','9077','2.99','2005-07-30T08:00:19.000','2006-02-15T22:19:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12735','471','1','9502','0.99','2005-07-31T00:02:10.000','2006-02-15T22:19:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12736','471','2','9560','2.99','2005-07-31T02:17:27.000','2006-02-15T22:19:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12737','471','1','10430','2.99','2005-08-01T08:37:06.000','2006-02-15T22:19:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12738','471','2','10828','3.99','2005-08-01T23:16:10.000','2006-02-15T22:19:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12739','471','2','11601','4.99','2005-08-17T03:14:47.000','2006-02-15T22:19:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12740','471','1','12271','4.99','2005-08-18T04:33:11.000','2006-02-15T22:19:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12741','471','1','13661','5.99','2005-08-20T08:05:59.000','2006-02-15T22:19:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12742','471','1','14085','7.99','2005-08-20T23:46:24.000','2006-02-15T22:19:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12743','471','1','14094','4.99','2005-08-21T00:21:35.000','2006-02-15T22:19:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12744','471','1','14317','5.99','2005-08-21T08:00:40.000','2006-02-15T22:19:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12745','471','2','14538','2.99','2005-08-21T15:28:15.000','2006-02-15T22:19:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12746','471','2','14942','7.99','2005-08-22T05:58:27.000','2006-02-15T22:19:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12747','471','2','15184','0.99','2005-08-22T15:51:12.000','2006-02-15T22:19:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12748','471','1','15654','1.99','2005-08-23T08:34:53.000','2006-02-15T22:19:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12749','472','2','142','0.99','2005-05-25T23:43:47.000','2006-02-15T22:19:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12750','472','2','249','2.99','2005-05-26T14:19:09.000','2006-02-15T22:19:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12751','472','2','800','0.99','2005-05-29T17:28:12.000','2006-02-15T22:19:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12752','472','2','994','4.99','2005-05-30T23:55:36.000','2006-02-15T22:19:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12753','472','1','1389','4.99','2005-06-15T15:49:01.000','2006-02-15T22:19:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12754','472','2','1776','6.99','2005-06-16T18:46:58.000','2006-02-15T22:19:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12755','472','1','2538','5.99','2005-06-19T01:56:59.000','2006-02-15T22:19:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12756','472','1','2974','0.99','2005-06-20T08:00:24.000','2006-02-15T22:19:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12757','472','1','2991','4.99','2005-06-20T09:10:43.000','2006-02-15T22:19:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12758','472','1','3254','0.99','2005-06-21T03:27:10.000','2006-02-15T22:19:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12759','472','2','3815','6.99','2005-07-06T15:26:36.000','2006-02-15T22:19:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12760','472','2','5318','2.99','2005-07-09T16:11:33.000','2006-02-15T22:19:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12761','472','1','5612','3.99','2005-07-10T05:15:12.000','2006-02-15T22:19:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12762','472','1','6119','6.99','2005-07-11T07:44:46.000','2006-02-15T22:19:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12763','472','2','6274','5.99','2005-07-11T16:09:42.000','2006-02-15T22:19:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12764','472','1','6308','5.99','2005-07-11T18:08:41.000','2006-02-15T22:19:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12765','472','1','6584','2.99','2005-07-12T06:43:36.000','2006-02-15T22:19:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12766','472','2','8929','5.99','2005-07-30T02:28:22.000','2006-02-15T22:19:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12767','472','2','9926','6.99','2005-07-31T15:11:51.000','2006-02-15T22:19:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12768','472','1','10282','6.99','2005-08-01T03:29:10.000','2006-02-15T22:19:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12769','472','1','10627','0.99','2005-08-01T15:33:03.000','2006-02-15T22:19:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12770','472','1','11911','6.99','2005-08-17T15:51:35.000','2006-02-15T22:19:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12771','472','2','12763','4.99','2005-08-18T23:07:01.000','2006-02-15T22:19:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12772','472','2','13188','8.99','2005-08-19T14:27:03.000','2006-02-15T22:19:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12773','472','1','14209','4.99','2005-08-21T04:17:56.000','2006-02-15T22:19:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12774','472','2','14596','4.99','2005-08-21T17:38:37.000','2006-02-15T22:19:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12775','472','1','14597','4.99','2005-08-21T17:39:41.000','2006-02-15T22:19:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12776','472','2','15185','5.99','2005-08-22T15:52:50.000','2006-02-15T22:19:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12777','472','2','15278','2.99','2005-08-22T19:06:47.000','2006-02-15T22:19:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12778','472','2','14928','4.99','2006-02-14T15:16:03.000','2006-02-15T22:19:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12779','473','1','348','4.99','2005-05-27T04:50:56.000','2006-02-15T22:19:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12780','473','2','942','2.99','2005-05-30T15:05:47.000','2006-02-15T22:19:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12781','473','2','973','3.99','2005-05-30T20:27:45.000','2006-02-15T22:19:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12782','473','2','1748','0.99','2005-06-16T16:54:03.000','2006-02-15T22:19:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12783','473','1','2125','2.99','2005-06-17T20:53:42.000','2006-02-15T22:19:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12784','473','2','2553','4.99','2005-06-19T03:04:59.000','2006-02-15T22:19:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12785','473','2','2748','4.99','2005-06-19T16:22:26.000','2006-02-15T22:19:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12786','473','1','3971','0.99','2005-07-06T22:50:40.000','2006-02-15T22:19:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12787','473','2','4006','4.99','2005-07-07T00:25:29.000','2006-02-15T22:19:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12788','473','2','4625','4.99','2005-07-08T08:14:26.000','2006-02-15T22:19:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12789','473','1','4873','0.99','2005-07-08T19:23:32.000','2006-02-15T22:19:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12790','473','2','5447','5.99','2005-07-09T22:09:28.000','2006-02-15T22:19:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12791','473','1','6446','2.99','2005-07-12T00:44:08.000','2006-02-15T22:19:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12792','473','2','6890','4.99','2005-07-12T21:03:03.000','2006-02-15T22:19:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12793','473','1','7111','4.99','2005-07-27T05:38:16.000','2006-02-15T22:19:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12794','473','1','7215','2.99','2005-07-27T09:24:00.000','2006-02-15T22:19:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12795','473','2','7918','1.99','2005-07-28T11:58:53.000','2006-02-15T22:19:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12796','473','2','7928','7.99','2005-07-28T12:15:51.000','2006-02-15T22:19:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12797','473','1','9025','4.99','2005-07-30T05:50:08.000','2006-02-15T22:19:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12798','473','2','9120','8.99','2005-07-30T09:26:08.000','2006-02-15T22:19:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12799','473','1','10867','2.99','2005-08-02T00:24:15.000','2006-02-15T22:19:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12800','473','2','11006','2.99','2005-08-02T05:05:52.000','2006-02-15T22:19:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12801','473','1','11216','4.99','2005-08-02T12:23:43.000','2006-02-15T22:19:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12802','473','1','11336','0.99','2005-08-02T16:58:56.000','2006-02-15T22:19:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12803','473','2','11421','7.99','2005-08-02T19:51:53.000','2006-02-15T22:19:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12804','473','1','11741','0.99','2005-08-17T08:48:39.000','2006-02-15T22:19:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12805','473','2','13984','4.99','2005-08-20T19:12:30.000','2006-02-15T22:19:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12806','473','2','14202','0.99','2005-08-21T03:51:52.000','2006-02-15T22:19:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12807','473','2','14550','0.99','2005-08-21T15:56:39.000','2006-02-15T22:19:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12808','473','2','14658','4.99','2005-08-21T19:41:50.000','2006-02-15T22:19:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12809','473','2','14757','4.99','2005-08-21T23:23:37.000','2006-02-15T22:19:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12810','473','1','15118','4.99','2005-08-22T12:38:37.000','2006-02-15T22:19:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12811','473','2','15400','2.99','2005-08-22T23:13:03.000','2006-02-15T22:19:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12812','473','2','16024','4.99','2005-08-23T21:46:47.000','2006-02-15T22:19:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12813','474','1','816','7.99','2005-05-29T20:26:39.000','2006-02-15T22:19:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12814','474','1','1758','8.99','2005-06-16T17:39:39.000','2006-02-15T22:19:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12815','474','2','2944','7.99','2005-06-20T05:43:42.000','2006-02-15T22:19:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12816','474','2','3787','4.99','2005-07-06T14:02:01.000','2006-02-15T22:19:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12817','474','2','4048','1.99','2005-07-07T03:30:52.000','2006-02-15T22:19:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12818','474','1','4481','2.99','2005-07-08T00:58:15.000','2006-02-15T22:19:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12819','474','1','4533','0.99','2005-07-08T03:32:01.000','2006-02-15T22:19:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12820','474','2','4785','0.99','2005-07-08T16:10:19.000','2006-02-15T22:19:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12821','474','1','4809','2.99','2005-07-08T17:03:22.000','2006-02-15T22:19:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12822','474','2','4886','4.99','2005-07-08T19:53:22.000','2006-02-15T22:19:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12823','474','1','5251','0.99','2005-07-09T13:36:10.000','2006-02-15T22:19:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12824','474','1','6499','7.99','2005-07-12T03:11:18.000','2006-02-15T22:19:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12825','474','1','8991','2.99','2005-07-30T04:42:54.000','2006-02-15T22:19:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12826','474','2','10376','5.99','2005-08-01T06:27:13.000','2006-02-15T22:19:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12827','474','2','11117','0.99','2005-08-02T08:36:03.000','2006-02-15T22:19:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12828','474','1','11489','2.99','2005-08-02T22:35:28.000','2006-02-15T22:19:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12829','474','2','11537','2.99','2005-08-17T00:41:08.000','2006-02-15T22:19:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12830','474','1','12083','2.99','2005-08-17T22:13:37.000','2006-02-15T22:19:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12831','474','1','12236','4.99','2005-08-18T03:19:29.000','2006-02-15T22:19:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12832','474','1','12440','0.99','2005-08-18T10:47:35.000','2006-02-15T22:19:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12833','474','2','12597','2.99','2005-08-18T16:34:02.000','2006-02-15T22:19:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12834','474','1','12702','4.99','2005-08-18T20:30:33.000','2006-02-15T22:19:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12835','474','1','14728','0.99','2005-08-21T22:15:36.000','2006-02-15T22:19:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12836','474','2','15046','4.99','2005-08-22T09:54:54.000','2006-02-15T22:19:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12837','474','1','15558','6.99','2005-08-23T04:52:22.000','2006-02-15T22:19:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12838','474','1','11909','0.99','2006-02-14T15:16:03.000','2006-02-15T22:19:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12839','475','2','417','4.99','2005-05-27T15:07:27.000','2006-02-15T22:19:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12840','475','1','702','0.99','2005-05-29T02:27:30.000','2006-02-15T22:19:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12841','475','2','3980','5.99','2005-07-06T23:11:11.000','2006-02-15T22:19:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12842','475','1','4013','6.99','2005-07-07T00:58:00.000','2006-02-15T22:19:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12843','475','1','4617','4.99','2005-07-08T07:55:08.000','2006-02-15T22:19:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12844','475','2','5379','0.99','2005-07-09T19:08:03.000','2006-02-15T22:19:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12845','475','1','5407','0.99','2005-07-09T20:16:07.000','2006-02-15T22:19:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12846','475','2','5415','9.99','2005-07-09T20:30:03.000','2006-02-15T22:19:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12847','475','2','5469','2.99','2005-07-09T23:08:07.000','2006-02-15T22:19:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12848','475','1','6224','4.99','2005-07-11T13:42:18.000','2006-02-15T22:19:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12849','475','1','7641','7.99','2005-07-28T01:15:45.000','2006-02-15T22:19:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12850','475','1','7775','1.99','2005-07-28T07:04:36.000','2006-02-15T22:19:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12851','475','2','8207','5.99','2005-07-28T23:26:31.000','2006-02-15T22:19:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12852','475','1','9183','7.99','2005-07-30T12:09:56.000','2006-02-15T22:19:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12853','475','1','9647','2.99','2005-07-31T05:45:15.000','2006-02-15T22:19:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12854','475','1','9737','2.99','2005-07-31T08:59:18.000','2006-02-15T22:19:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12855','475','2','10162','3.99','2005-07-31T23:11:01.000','2006-02-15T22:19:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12856','475','1','10357','0.99','2005-08-01T05:49:49.000','2006-02-15T22:19:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12857','475','1','10633','3.99','2005-08-01T15:37:17.000','2006-02-15T22:19:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12858','475','1','11293','5.99','2005-08-02T15:00:43.000','2006-02-15T22:19:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12859','475','1','11770','4.99','2005-08-17T10:05:05.000','2006-02-15T22:19:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12860','475','2','14303','2.99','2005-08-21T07:22:43.000','2006-02-15T22:19:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12861','475','1','15097','1.99','2005-08-22T11:43:42.000','2006-02-15T22:19:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12862','475','1','15288','4.99','2005-08-22T19:23:58.000','2006-02-15T22:19:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12863','476','1','489','4.99','2005-05-28T00:09:12.000','2006-02-15T22:19:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12864','476','1','771','2.99','2005-05-29T12:59:14.000','2006-02-15T22:19:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12865','476','1','1682','3.99','2005-06-16T11:54:25.000','2006-02-15T22:19:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12866','476','1','2080','0.99','2005-06-17T16:59:40.000','2006-02-15T22:19:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12867','476','2','2508','4.99','2005-06-18T23:43:58.000','2006-02-15T22:19:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12868','476','2','3448','2.99','2005-06-21T20:59:20.000','2006-02-15T22:19:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12869','476','2','3477','7.99','2005-07-05T23:05:17.000','2006-02-15T22:19:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12870','476','1','4010','5.99','2005-07-07T00:47:00.000','2006-02-15T22:19:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12871','476','2','4171','4.99','2005-07-07T09:49:04.000','2006-02-15T22:19:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12872','476','2','5644','4.99','2005-07-10T06:57:44.000','2006-02-15T22:19:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12873','476','1','6151','2.99','2005-07-11T09:25:17.000','2006-02-15T22:19:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12874','476','1','7461','0.99','2005-07-27T18:45:15.000','2006-02-15T22:19:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12875','476','1','8146','0.99','2005-07-28T20:37:36.000','2006-02-15T22:19:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12876','476','2','9325','6.99','2005-07-30T17:29:19.000','2006-02-15T22:19:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12877','476','2','9743','3.99','2005-07-31T09:12:42.000','2006-02-15T22:19:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12878','476','1','10346','4.99','2005-08-01T05:19:23.000','2006-02-15T22:19:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12879','476','1','10617','9.99','2005-08-01T15:05:52.000','2006-02-15T22:19:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12880','476','1','10826','6.99','2005-08-01T23:07:56.000','2006-02-15T22:19:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12881','476','1','12616','4.99','2005-08-18T17:22:41.000','2006-02-15T22:19:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12882','476','2','12709','5.99','2005-08-18T20:59:51.000','2006-02-15T22:19:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12883','476','1','15413','0.99','2005-08-22T23:38:01.000','2006-02-15T22:19:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12884','476','1','13941','0.99','2006-02-14T15:16:03.000','2006-02-15T22:19:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12885','477','1','882','2.99','2005-05-30T06:16:06.000','2006-02-15T22:19:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12886','477','1','1714','6.99','2005-06-16T14:29:59.000','2006-02-15T22:19:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12887','477','1','2187','2.99','2005-06-18T01:17:27.000','2006-02-15T22:19:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12888','477','1','2306','10.99','2005-06-18T08:33:23.000','2006-02-15T22:19:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12889','477','2','2676','4.99','2005-06-19T11:54:57.000','2006-02-15T22:19:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12890','477','2','4237','5.99','2005-07-07T13:16:55.000','2006-02-15T22:19:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12891','477','1','4283','2.99','2005-07-07T15:29:35.000','2006-02-15T22:19:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12892','477','2','4956','7.99','2005-07-08T23:17:10.000','2006-02-15T22:19:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12893','477','2','6265','2.99','2005-07-11T15:43:51.000','2006-02-15T22:19:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12894','477','2','7302','2.99','2005-07-27T12:52:13.000','2006-02-15T22:19:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12895','477','2','7904','10.99','2005-07-28T11:25:39.000','2006-02-15T22:19:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12896','477','1','8515','6.99','2005-07-29T09:55:20.000','2006-02-15T22:19:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12897','477','1','8821','5.99','2005-07-29T22:18:12.000','2006-02-15T22:19:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12898','477','2','8857','2.99','2005-07-29T23:44:22.000','2006-02-15T22:19:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12899','477','2','9446','8.99','2005-07-30T21:53:01.000','2006-02-15T22:19:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12900','477','1','10500','4.99','2005-08-01T11:01:01.000','2006-02-15T22:19:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12901','477','2','10912','0.99','2005-08-02T02:00:03.000','2006-02-15T22:19:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12902','477','2','12420','4.99','2005-08-18T10:01:50.000','2006-02-15T22:19:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12903','477','1','13002','0.99','2005-08-19T07:37:58.000','2006-02-15T22:19:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12904','477','2','14552','3.99','2005-08-21T15:59:27.000','2006-02-15T22:19:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12905','477','2','15091','2.99','2005-08-22T11:34:43.000','2006-02-15T22:19:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12906','477','1','15929','2.99','2005-08-23T18:23:30.000','2006-02-15T22:19:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12907','478','1','1708','0.99','2005-06-16T14:08:44.000','2006-02-15T22:19:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12908','478','2','2358','4.99','2005-06-18T13:00:51.000','2006-02-15T22:19:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12909','478','1','2529','6.99','2005-06-19T01:18:27.000','2006-02-15T22:19:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12910','478','2','2616','8.99','2005-06-19T07:33:00.000','2006-02-15T22:19:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12911','478','2','2765','4.99','2005-06-19T17:34:39.000','2006-02-15T22:19:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12912','478','2','3259','4.99','2005-06-21T03:57:15.000','2006-02-15T22:19:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12913','478','1','3691','4.99','2005-07-06T09:46:12.000','2006-02-15T22:19:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12914','478','1','5837','4.99','2005-07-10T16:57:50.000','2006-02-15T22:19:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12915','478','1','7522','2.99','2005-07-27T21:11:03.000','2006-02-15T22:19:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12916','478','2','8488','4.99','2005-07-29T08:57:38.000','2006-02-15T22:19:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12917','478','1','9665','4.99','2005-07-31T06:17:33.000','2006-02-15T22:19:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12918','478','2','10016','4.99','2005-07-31T18:13:06.000','2006-02-15T22:19:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12919','478','2','10127','0.99','2005-07-31T21:39:48.000','2006-02-15T22:19:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12920','478','1','11906','2.99','2005-08-17T15:40:46.000','2006-02-15T22:19:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12921','478','2','13162','2.99','2005-08-19T13:28:26.000','2006-02-15T22:19:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12922','478','2','13507','4.99','2005-08-20T02:10:27.000','2006-02-15T22:19:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12923','478','1','15027','4.99','2005-08-22T09:03:04.000','2006-02-15T22:19:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12924','478','2','15188','4.99','2005-08-22T15:55:48.000','2006-02-15T22:19:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12925','478','1','15724','4.99','2005-08-23T11:22:09.000','2006-02-15T22:19:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12926','479','2','132','3.99','2005-05-25T21:46:54.000','2006-02-15T22:19:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12927','479','1','709','7.99','2005-05-29T03:48:01.000','2006-02-15T22:19:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12928','479','1','1902','2.99','2005-06-17T04:35:52.000','2006-02-15T22:19:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12929','479','2','1947','3.99','2005-06-17T08:02:20.000','2006-02-15T22:19:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12930','479','2','1987','2.99','2005-06-17T10:40:36.000','2006-02-15T22:19:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12931','479','2','2071','3.99','2005-06-17T16:33:17.000','2006-02-15T22:19:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12932','479','2','2376','2.99','2005-06-18T14:55:30.000','2006-02-15T22:19:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12933','479','2','2764','6.99','2005-06-19T17:27:25.000','2006-02-15T22:19:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12934','479','2','3537','6.99','2005-07-06T01:36:53.000','2006-02-15T22:19:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12935','479','1','3798','0.99','2005-07-06T14:57:53.000','2006-02-15T22:19:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12936','479','2','4183','8.99','2005-07-07T10:28:33.000','2006-02-15T22:19:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12937','479','1','5481','0.99','2005-07-09T23:51:57.000','2006-02-15T22:19:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12938','479','1','5751','4.99','2005-07-10T12:25:11.000','2006-02-15T22:19:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12939','479','2','6084','7.99','2005-07-11T05:16:20.000','2006-02-15T22:19:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12940','479','1','6421','1.99','2005-07-11T23:45:25.000','2006-02-15T22:19:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12941','479','1','6597','0.99','2005-07-12T07:37:02.000','2006-02-15T22:19:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12942','479','2','6849','8.99','2005-07-12T19:29:19.000','2006-02-15T22:19:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12943','479','1','7060','7.99','2005-07-27T03:51:04.000','2006-02-15T22:19:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12944','479','2','7893','2.99','2005-07-28T10:49:27.000','2006-02-15T22:19:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12945','479','1','9347','5.99','2005-07-30T18:16:03.000','2006-02-15T22:19:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12946','479','1','9439','8.99','2005-07-30T21:38:12.000','2006-02-15T22:19:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12947','479','2','9697','2.99','2005-07-31T07:23:11.000','2006-02-15T22:19:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12948','479','2','9754','7.99','2005-07-31T09:23:43.000','2006-02-15T22:19:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12949','479','2','10303','4.99','2005-08-01T04:13:33.000','2006-02-15T22:19:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12950','479','2','11109','4.99','2005-08-02T08:20:29.000','2006-02-15T22:19:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12951','479','2','11584','1.99','2005-08-17T02:13:26.000','2006-02-15T22:19:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12952','479','2','11835','4.99','2005-08-17T13:03:13.000','2006-02-15T22:19:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12953','479','2','12401','0.99','2005-08-18T09:20:51.000','2006-02-15T22:19:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12954','479','2','13078','8.99','2005-08-19T10:16:43.000','2006-02-15T22:19:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12955','479','1','13974','2.99','2005-08-20T18:54:59.000','2006-02-15T22:19:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12956','479','1','12101','0.99','2006-02-14T15:16:03.000','2006-02-15T22:19:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12957','480','1','518','0.99','2005-05-28T03:18:02.000','2006-02-15T22:19:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12958','480','1','720','6.99','2005-05-29T05:17:30.000','2006-02-15T22:19:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12959','480','2','822','9.99','2005-05-29T21:36:00.000','2006-02-15T22:19:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12960','480','1','1353','0.99','2005-06-15T13:13:36.000','2006-02-15T22:19:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12961','480','1','1733','0.99','2005-06-16T15:37:07.000','2006-02-15T22:19:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12962','480','2','3507','7.99','2005-07-06T00:23:43.000','2006-02-15T22:19:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12963','480','2','5633','2.99','2005-07-10T06:22:24.000','2006-02-15T22:19:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12964','480','1','6191','2.99','2005-07-11T11:37:52.000','2006-02-15T22:19:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12965','480','1','7257','2.99','2005-07-27T11:04:17.000','2006-02-15T22:19:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12966','480','2','7910','9.99','2005-07-28T11:44:56.000','2006-02-15T22:19:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12967','480','2','8847','4.99','2005-07-29T23:13:41.000','2006-02-15T22:19:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12968','480','1','8967','6.99','2005-07-30T03:56:55.000','2006-02-15T22:19:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12969','480','2','9332','4.99','2005-07-30T17:53:39.000','2006-02-15T22:19:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12970','480','2','10808','1.99','2005-08-01T22:37:11.000','2006-02-15T22:19:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12971','480','2','11017','0.99','2005-08-02T05:19:51.000','2006-02-15T22:19:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12972','480','1','11369','5.99','2005-08-02T18:04:41.000','2006-02-15T22:19:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12973','480','2','12905','4.99','2005-08-19T04:13:37.000','2006-02-15T22:19:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12974','480','2','13092','0.99','2005-08-19T10:41:09.000','2006-02-15T22:19:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12975','480','2','13131','9.99','2005-08-19T12:08:13.000','2006-02-15T22:19:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12976','480','1','13831','4.99','2005-08-20T13:59:35.000','2006-02-15T22:19:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12977','480','2','15363','2.99','2005-08-22T21:41:40.000','2006-02-15T22:19:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12978','480','2','15579','4.99','2005-08-23T05:38:41.000','2006-02-15T22:19:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12979','481','2','1109','5.99','2005-05-31T15:12:15.000','2006-02-15T22:19:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12980','481','2','1168','2.99','2005-06-14T23:35:09.000','2006-02-15T22:19:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12981','481','2','2296','4.99','2005-06-18T08:10:42.000','2006-02-15T22:19:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12982','481','2','3285','4.99','2005-06-21T06:30:13.000','2006-02-15T22:19:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12983','481','2','3293','0.99','2005-06-21T06:59:33.000','2006-02-15T22:19:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12984','481','1','3863','0.99','2005-07-06T17:40:18.000','2006-02-15T22:19:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12985','481','1','4473','2.99','2005-07-08T00:22:10.000','2006-02-15T22:19:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12986','481','1','4505','1.99','2005-07-08T02:20:04.000','2006-02-15T22:19:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12987','481','1','4532','0.99','2005-07-08T03:30:39.000','2006-02-15T22:19:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12988','481','1','4668','10.99','2005-07-08T10:11:45.000','2006-02-15T22:19:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12989','481','2','5711','2.99','2005-07-10T10:37:20.000','2006-02-15T22:19:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12990','481','1','6044','0.99','2005-07-11T03:18:39.000','2006-02-15T22:19:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12991','481','1','7228','4.99','2005-07-27T09:55:33.000','2006-02-15T22:19:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12992','481','2','7836','7.99','2005-07-28T08:55:27.000','2006-02-15T22:19:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12993','481','1','8243','6.99','2005-07-29T00:35:33.000','2006-02-15T22:19:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12994','481','2','8271','6.99','2005-07-29T01:27:44.000','2006-02-15T22:19:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12995','481','1','9481','4.99','2005-07-30T23:26:05.000','2006-02-15T22:19:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12996','481','1','10018','3.99','2005-07-31T18:15:14.000','2006-02-15T22:19:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12997','481','2','11207','0.99','2005-08-02T12:01:30.000','2006-02-15T22:19:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12998','481','2','11387','2.99','2005-08-02T18:32:38.000','2006-02-15T22:19:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('12999','481','1','11752','4.99','2005-08-17T09:10:55.000','2006-02-15T22:19:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13000','481','1','11885','4.99','2005-08-17T14:53:53.000','2006-02-15T22:19:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13001','481','2','12160','2.99','2005-08-18T00:37:59.000','2006-02-15T22:19:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13002','481','1','12981','4.99','2005-08-19T07:04:00.000','2006-02-15T22:19:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13003','481','2','13497','2.99','2005-08-20T01:46:38.000','2006-02-15T22:19:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13004','481','2','13878','4.99','2005-08-20T15:17:38.000','2006-02-15T22:19:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13005','481','1','13990','1.99','2005-08-20T19:29:23.000','2006-02-15T22:19:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13006','481','2','14280','4.99','2005-08-21T06:39:58.000','2006-02-15T22:19:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13007','481','2','14584','0.99','2005-08-21T17:15:33.000','2006-02-15T22:19:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13008','482','1','259','8.99','2005-05-26T15:32:46.000','2006-02-15T22:19:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13009','482','2','680','2.99','2005-05-28T23:27:26.000','2006-02-15T22:19:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13010','482','2','879','0.99','2005-05-30T05:49:42.000','2006-02-15T22:19:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13011','482','2','3048','2.99','2005-06-20T12:49:55.000','2006-02-15T22:19:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13012','482','2','3255','0.99','2005-06-21T03:39:52.000','2006-02-15T22:19:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13013','482','2','3650','2.99','2005-07-06T07:34:15.000','2006-02-15T22:19:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13014','482','1','4768','4.99','2005-07-08T15:28:20.000','2006-02-15T22:19:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13015','482','1','5334','4.99','2005-07-09T17:00:13.000','2006-02-15T22:19:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13016','482','1','5466','4.99','2005-07-09T23:03:21.000','2006-02-15T22:19:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13017','482','2','5810','8.99','2005-07-10T15:22:04.000','2006-02-15T22:19:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13018','482','2','5880','2.99','2005-07-10T19:14:58.000','2006-02-15T22:19:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13019','482','1','6355','8.99','2005-07-11T20:56:29.000','2006-02-15T22:19:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13020','482','2','6447','7.99','2005-07-12T00:45:17.000','2006-02-15T22:19:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13021','482','2','6844','5.99','2005-07-12T19:14:53.000','2006-02-15T22:19:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13022','482','2','7840','6.99','2005-07-28T09:03:02.000','2006-02-15T22:19:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13023','482','2','8584','2.99','2005-07-29T12:07:53.000','2006-02-15T22:19:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13024','482','2','9874','6.99','2005-07-31T13:32:31.000','2006-02-15T22:19:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13025','482','2','10824','4.99','2005-08-01T23:00:22.000','2006-02-15T22:19:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13026','482','2','10839','2.99','2005-08-01T23:37:39.000','2006-02-15T22:19:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13027','482','2','11498','6.99','2005-08-16T22:52:54.000','2006-02-15T22:19:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13028','482','1','13174','4.99','2005-08-19T13:52:50.000','2006-02-15T22:19:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13029','482','2','14383','4.99','2005-08-21T10:02:05.000','2006-02-15T22:19:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13030','482','2','14732','0.99','2005-08-21T22:22:29.000','2006-02-15T22:19:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13031','482','2','14891','6.99','2005-08-22T04:11:02.000','2006-02-15T22:19:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13032','482','2','14995','4.99','2005-08-22T07:52:31.000','2006-02-15T22:19:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13033','482','1','15391','0.99','2005-08-22T23:01:45.000','2006-02-15T22:19:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13034','482','1','15849','5.99','2005-08-23T15:41:20.000','2006-02-15T22:19:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13035','482','2','15865','2.99','2005-08-23T16:18:25.000','2006-02-15T22:19:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13036','482','1','15879','3.99','2005-08-23T16:42:53.000','2006-02-15T22:19:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13037','483','2','742','6.99','2005-05-29T08:36:30.000','2006-02-15T22:19:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13038','483','1','2855','4.99','2005-06-19T23:11:49.000','2006-02-15T22:19:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13039','483','2','2867','0.99','2005-06-20T00:08:38.000','2006-02-15T22:19:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13040','483','1','3380','8.99','2005-06-21T13:58:46.000','2006-02-15T22:19:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13041','483','2','3559','4.99','2005-07-06T02:49:42.000','2006-02-15T22:19:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13042','483','1','5823','4.99','2005-07-10T16:19:52.000','2006-02-15T22:19:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13043','483','2','6478','4.99','2005-07-12T01:41:44.000','2006-02-15T22:19:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13044','483','2','6899','9.99','2005-07-12T21:44:16.000','2006-02-15T22:19:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13045','483','2','7137','0.99','2005-07-27T06:40:41.000','2006-02-15T22:19:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13046','483','1','7381','4.99','2005-07-27T15:40:26.000','2006-02-15T22:19:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13047','483','1','7669','4.99','2005-07-28T02:44:07.000','2006-02-15T22:19:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13048','483','1','8057','7.99','2005-07-28T17:07:13.000','2006-02-15T22:19:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13049','483','1','8356','4.99','2005-07-29T04:58:56.000','2006-02-15T22:19:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13050','483','2','10677','0.99','2005-08-01T17:24:35.000','2006-02-15T22:19:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13051','483','1','10953','6.99','2005-08-02T03:28:38.000','2006-02-15T22:19:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13052','483','2','12331','3.99','2005-08-18T06:47:19.000','2006-02-15T22:19:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13053','483','2','12695','2.99','2005-08-18T20:11:35.000','2006-02-15T22:19:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13054','483','2','12875','2.99','2005-08-19T03:10:21.000','2006-02-15T22:19:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13055','484','2','35','4.99','2005-05-25T04:24:36.000','2006-02-15T22:19:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13056','484','2','668','2.99','2005-05-28T21:54:45.000','2006-02-15T22:19:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13057','484','2','727','2.99','2005-05-29T06:08:15.000','2006-02-15T22:19:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13058','484','1','1351','3.99','2005-06-15T12:51:03.000','2006-02-15T22:19:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13059','484','2','1643','3.99','2005-06-16T08:55:35.000','2006-02-15T22:19:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13060','484','1','2015','4.99','2005-06-17T12:16:29.000','2006-02-15T22:19:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13061','484','1','2044','5.99','2005-06-17T14:37:57.000','2006-02-15T22:19:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13062','484','1','4214','4.99','2005-07-07T11:54:33.000','2006-02-15T22:19:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13063','484','1','5389','2.99','2005-07-09T19:25:45.000','2006-02-15T22:19:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13064','484','2','5708','6.99','2005-07-10T10:29:19.000','2006-02-15T22:19:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13065','484','1','5852','0.99','2005-07-10T17:43:30.000','2006-02-15T22:19:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13066','484','2','5866','6.99','2005-07-10T18:35:14.000','2006-02-15T22:19:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13067','484','2','5977','5.99','2005-07-11T00:16:38.000','2006-02-15T22:19:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13068','484','2','6296','2.99','2005-07-11T17:34:04.000','2006-02-15T22:19:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13069','484','1','6863','6.99','2005-07-12T19:58:34.000','2006-02-15T22:19:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13070','484','2','7440','4.99','2005-07-27T17:43:27.000','2006-02-15T22:19:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13071','484','2','7548','2.99','2005-07-27T21:53:18.000','2006-02-15T22:19:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13072','484','2','8508','0.99','2005-07-29T09:34:38.000','2006-02-15T22:19:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13073','484','2','9141','5.99','2005-07-30T10:16:04.000','2006-02-15T22:19:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13074','484','2','9414','9.99','2005-07-30T20:46:02.000','2006-02-15T22:19:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13075','484','1','9769','4.99','2005-07-31T09:52:16.000','2006-02-15T22:19:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13076','484','2','10166','8.99','2005-07-31T23:22:20.000','2006-02-15T22:19:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13077','484','2','11871','4.99','2005-08-17T14:11:44.000','2006-02-15T22:19:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13078','484','1','12024','0.99','2005-08-17T19:57:34.000','2006-02-15T22:19:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13079','484','1','12771','4.99','2005-08-18T23:29:23.000','2006-02-15T22:19:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13080','484','1','12993','7.99','2005-08-19T07:24:03.000','2006-02-15T22:19:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13081','484','2','13160','0.99','2005-08-19T13:21:04.000','2006-02-15T22:19:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13082','484','2','13956','3.99','2005-08-20T18:08:19.000','2006-02-15T22:19:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13083','484','1','15607','2.99','2005-08-23T06:54:06.000','2006-02-15T22:19:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13084','484','1','16026','4.99','2005-08-23T21:49:22.000','2006-02-15T22:19:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13085','485','1','1009','2.99','2005-05-31T01:47:35.000','2006-02-15T22:19:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13086','485','2','1684','2.99','2005-06-16T11:57:34.000','2006-02-15T22:19:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13087','485','1','1721','8.99','2005-06-16T15:01:36.000','2006-02-15T22:19:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13088','485','2','3579','0.99','2005-07-06T03:47:47.000','2006-02-15T22:19:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13089','485','1','3899','1.99','2005-07-06T19:12:40.000','2006-02-15T22:19:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13090','485','1','3904','0.99','2005-07-06T19:30:57.000','2006-02-15T22:19:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13091','485','2','4137','3.99','2005-07-07T08:17:06.000','2006-02-15T22:19:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13092','485','2','4667','2.99','2005-07-08T10:06:26.000','2006-02-15T22:19:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13093','485','1','5193','2.99','2005-07-09T10:28:18.000','2006-02-15T22:19:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13094','485','1','5343','3.99','2005-07-09T17:23:43.000','2006-02-15T22:19:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13095','485','1','5367','3.99','2005-07-09T18:39:15.000','2006-02-15T22:19:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13096','485','1','5820','4.99','2005-07-10T16:04:59.000','2006-02-15T22:19:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13097','485','2','6810','4.99','2005-07-12T17:54:19.000','2006-02-15T22:19:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13098','485','2','6902','4.99','2005-07-12T21:57:16.000','2006-02-15T22:19:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13099','485','1','7144','4.99','2005-07-27T07:00:37.000','2006-02-15T22:19:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13100','485','2','8984','6.99','2005-07-30T04:31:50.000','2006-02-15T22:19:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13101','485','2','9039','2.99','2005-07-30T06:24:28.000','2006-02-15T22:19:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13102','485','1','9053','4.99','2005-07-30T07:07:39.000','2006-02-15T22:19:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13103','485','2','9189','2.99','2005-07-30T12:20:59.000','2006-02-15T22:19:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13104','485','1','9535','2.99','2005-07-31T01:18:53.000','2006-02-15T22:19:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13105','485','1','9565','0.99','2005-07-31T02:32:00.000','2006-02-15T22:19:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13106','485','1','10771','4.99','2005-08-01T20:49:35.000','2006-02-15T22:19:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13107','485','2','10772','6.99','2005-08-01T20:51:10.000','2006-02-15T22:19:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13108','485','2','11188','3.99','2005-08-02T11:17:11.000','2006-02-15T22:19:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13109','485','1','11921','4.99','2005-08-17T16:12:27.000','2006-02-15T22:19:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13110','485','1','11974','2.99','2005-08-17T17:56:48.000','2006-02-15T22:19:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13111','485','2','12261','8.99','2005-08-18T04:16:06.000','2006-02-15T22:19:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13112','485','2','12487','0.99','2005-08-18T12:45:24.000','2006-02-15T22:19:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13113','485','2','13055','2.99','2005-08-19T09:36:28.000','2006-02-15T22:19:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13114','486','1','909','8.99','2005-05-30T10:43:38.000','2006-02-15T22:19:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13115','486','2','946','2.99','2005-05-30T15:35:08.000','2006-02-15T22:19:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13116','486','2','1129','0.99','2005-05-31T18:00:48.000','2006-02-15T22:19:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13117','486','1','2036','4.99','2005-06-17T13:46:52.000','2006-02-15T22:20:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13118','486','1','2102','5.99','2005-06-17T19:05:22.000','2006-02-15T22:20:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13119','486','2','2566','2.99','2005-06-19T03:45:39.000','2006-02-15T22:20:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13120','486','2','2797','2.99','2005-06-19T19:04:32.000','2006-02-15T22:20:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13121','486','1','3835','4.99','2005-07-06T16:22:45.000','2006-02-15T22:20:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13122','486','2','4110','4.99','2005-07-07T06:44:27.000','2006-02-15T22:20:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13123','486','1','4205','4.99','2005-07-07T11:25:39.000','2006-02-15T22:20:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13124','486','1','4381','2.99','2005-07-07T20:37:53.000','2006-02-15T22:20:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13125','486','1','4772','7.99','2005-07-08T15:41:11.000','2006-02-15T22:20:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13126','486','2','5006','4.99','2005-07-09T01:24:07.000','2006-02-15T22:20:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13127','486','2','6383','4.99','2005-07-11T22:06:53.000','2006-02-15T22:20:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13128','486','2','7127','4.99','2005-07-27T06:13:48.000','2006-02-15T22:20:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13129','486','2','7446','4.99','2005-07-27T18:00:24.000','2006-02-15T22:20:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13130','486','2','8425','8.99','2005-07-29T07:06:21.000','2006-02-15T22:20:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13131','486','2','9142','0.99','2005-07-30T10:21:03.000','2006-02-15T22:20:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13132','486','1','10079','2.99','2005-07-31T20:05:45.000','2006-02-15T22:20:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13133','486','2','10902','4.99','2005-08-02T01:35:46.000','2006-02-15T22:20:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13134','486','1','12465','0.99','2005-08-18T11:35:02.000','2006-02-15T22:20:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13135','486','2','12609','2.99','2005-08-18T17:06:22.000','2006-02-15T22:20:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13136','486','1','13048','4.99','2005-08-19T09:25:06.000','2006-02-15T22:20:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13137','486','2','13803','0.99','2005-08-20T12:46:17.000','2006-02-15T22:20:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13138','486','2','14251','4.99','2005-08-21T05:42:20.000','2006-02-15T22:20:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13139','486','2','14284','4.99','2005-08-21T06:44:37.000','2006-02-15T22:20:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13140','487','2','3100','3.99','2005-06-20T16:47:57.000','2006-02-15T22:20:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13141','487','2','3994','1.99','2005-07-06T23:39:01.000','2006-02-15T22:20:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13142','487','2','4854','2.99','2005-07-08T18:44:44.000','2006-02-15T22:20:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13143','487','1','5634','3.99','2005-07-10T06:25:48.000','2006-02-15T22:20:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13144','487','1','6928','2.99','2005-07-26T22:56:21.000','2006-02-15T22:20:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13145','487','1','7097','2.99','2005-07-27T04:56:09.000','2006-02-15T22:20:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13146','487','1','7788','0.99','2005-07-28T07:21:55.000','2006-02-15T22:20:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13147','487','2','7949','4.99','2005-07-28T13:07:24.000','2006-02-15T22:20:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13148','487','2','8510','1.99','2005-07-29T09:41:38.000','2006-02-15T22:20:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13149','487','2','8689','2.99','2005-07-29T16:38:58.000','2006-02-15T22:20:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13150','487','1','8814','4.99','2005-07-29T21:49:43.000','2006-02-15T22:20:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13151','487','1','8988','7.99','2005-07-30T04:38:49.000','2006-02-15T22:20:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13152','487','2','9457','2.99','2005-07-30T22:23:05.000','2006-02-15T22:20:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13153','487','1','9490','3.99','2005-07-30T23:45:09.000','2006-02-15T22:20:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13154','487','2','10123','0.99','2005-07-31T21:30:46.000','2006-02-15T22:20:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13155','487','2','10511','2.99','2005-08-01T11:32:16.000','2006-02-15T22:20:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13156','487','2','10555','6.99','2005-08-01T12:56:38.000','2006-02-15T22:20:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13157','487','1','10832','6.99','2005-08-01T23:24:53.000','2006-02-15T22:20:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13158','487','2','10877','5.99','2005-08-02T00:32:04.000','2006-02-15T22:20:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13159','487','1','10978','9.99','2005-08-02T04:12:27.000','2006-02-15T22:20:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13160','487','1','11669','5.99','2005-08-17T05:48:51.000','2006-02-15T22:20:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13161','487','2','11890','5.99','2005-08-17T15:08:43.000','2006-02-15T22:20:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13162','487','1','12493','7.99','2005-08-18T12:53:38.000','2006-02-15T22:20:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13163','487','2','13210','4.99','2005-08-19T15:23:38.000','2006-02-15T22:20:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13164','487','1','13658','7.99','2005-08-20T08:02:22.000','2006-02-15T22:20:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13165','487','2','15665','2.99','2005-08-23T08:59:12.000','2006-02-15T22:20:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13166','488','2','1655','3.99','2005-06-16T09:51:39.000','2006-02-15T22:20:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13167','488','2','1704','5.99','2005-06-16T13:45:56.000','2006-02-15T22:20:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13168','488','2','4133','6.99','2005-07-07T08:12:26.000','2006-02-15T22:20:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13169','488','2','4233','5.99','2005-07-07T13:00:20.000','2006-02-15T22:20:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13170','488','1','5141','8.99','2005-07-09T08:05:14.000','2006-02-15T22:20:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13171','488','2','6548','5.99','2005-07-12T05:00:46.000','2006-02-15T22:20:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13172','488','1','7373','5.99','2005-07-27T15:19:33.000','2006-02-15T22:20:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13173','488','1','8005','2.99','2005-07-28T15:15:11.000','2006-02-15T22:20:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13174','488','2','8050','0.99','2005-07-28T16:55:47.000','2006-02-15T22:20:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13175','488','2','8064','2.99','2005-07-28T17:15:38.000','2006-02-15T22:20:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13176','488','2','9083','5.99','2005-07-30T08:14:27.000','2006-02-15T22:20:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13177','488','1','9532','2.99','2005-07-31T01:16:51.000','2006-02-15T22:20:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13178','488','1','9537','0.99','2005-07-31T01:23:00.000','2006-02-15T22:20:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13179','488','2','10474','5.99','2005-08-01T10:01:42.000','2006-02-15T22:20:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13180','488','1','10767','0.99','2005-08-01T20:37:23.000','2006-02-15T22:20:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13181','488','1','11774','3.99','2005-08-17T10:20:39.000','2006-02-15T22:20:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13182','488','2','12483','5.99','2005-08-18T12:38:37.000','2006-02-15T22:20:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13183','488','2','13446','4.99','2005-08-20T00:06:13.000','2006-02-15T22:20:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13184','488','2','14948','5.99','2005-08-22T06:10:53.000','2006-02-15T22:20:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13185','488','2','15259','0.99','2005-08-22T18:23:23.000','2006-02-15T22:20:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13186','488','1','15350','2.99','2005-08-22T21:15:29.000','2006-02-15T22:20:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13187','488','2','15499','2.99','2005-08-23T02:37:19.000','2006-02-15T22:20:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13188','489','1','219','4.99','2005-05-26T09:41:45.000','2006-02-15T22:20:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13189','489','2','513','2.99','2005-05-28T03:08:10.000','2006-02-15T22:20:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13190','489','2','1614','3.99','2005-06-16T06:58:02.000','2006-02-15T22:20:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13191','489','1','2201','0.99','2005-06-18T02:08:27.000','2006-02-15T22:20:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13192','489','1','2370','7.99','2005-06-18T14:29:54.000','2006-02-15T22:20:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13193','489','1','2802','4.99','2005-06-19T19:18:17.000','2006-02-15T22:20:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13194','489','2','3816','2.99','2005-07-06T15:27:04.000','2006-02-15T22:20:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13195','489','1','4774','3.99','2005-07-08T15:42:28.000','2006-02-15T22:20:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13196','489','1','6963','4.99','2005-07-27T00:13:02.000','2006-02-15T22:20:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13197','489','2','9231','0.99','2005-07-30T13:42:15.000','2006-02-15T22:20:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13198','489','1','9459','4.99','2005-07-30T22:24:46.000','2006-02-15T22:20:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13199','489','2','11119','9.99','2005-08-02T08:44:44.000','2006-02-15T22:20:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13200','489','1','11705','4.99','2005-08-17T07:22:25.000','2006-02-15T22:20:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13201','489','1','12496','6.99','2005-08-18T12:58:25.000','2006-02-15T22:20:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13202','489','2','12701','6.99','2005-08-18T20:26:47.000','2006-02-15T22:20:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13203','489','1','13462','4.99','2005-08-20T00:49:19.000','2006-02-15T22:20:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13204','489','2','14095','5.99','2005-08-21T00:25:45.000','2006-02-15T22:20:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13205','489','2','14328','2.99','2005-08-21T08:18:20.000','2006-02-15T22:20:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13206','489','2','14424','6.99','2005-08-21T11:24:11.000','2006-02-15T22:20:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13207','489','1','15205','0.99','2005-08-22T16:32:23.000','2006-02-15T22:20:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13208','489','1','15981','4.99','2005-08-23T20:12:17.000','2006-02-15T22:20:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13209','490','2','585','6.99','2005-05-28T11:50:45.000','2006-02-15T22:20:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13210','490','2','676','4.99','2005-05-28T22:27:51.000','2006-02-15T22:20:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13211','490','1','1665','3.99','2005-06-16T10:16:02.000','2006-02-15T22:20:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13212','490','1','3476','4.99','2005-07-05T23:02:37.000','2006-02-15T22:20:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13213','490','2','3932','4.99','2005-07-06T21:06:17.000','2006-02-15T22:20:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13214','490','1','4083','2.99','2005-07-07T05:13:15.000','2006-02-15T22:20:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13215','490','1','4906','5.99','2005-07-08T20:59:13.000','2006-02-15T22:20:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13216','490','2','5173','7.99','2005-07-09T09:31:44.000','2006-02-15T22:20:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13217','490','2','5489','0.99','2005-07-10T00:07:03.000','2006-02-15T22:20:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13218','490','1','5654','4.99','2005-07-10T07:24:46.000','2006-02-15T22:20:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13219','490','2','6230','2.99','2005-07-11T14:02:19.000','2006-02-15T22:20:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13220','490','1','6803','4.99','2005-07-12T17:21:49.000','2006-02-15T22:20:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13221','490','2','6888','2.99','2005-07-12T21:01:11.000','2006-02-15T22:20:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13222','490','2','6923','8.99','2005-07-12T22:40:48.000','2006-02-15T22:20:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13223','490','1','8552','5.99','2005-07-29T11:14:02.000','2006-02-15T22:20:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13224','490','2','9108','4.99','2005-07-30T08:56:36.000','2006-02-15T22:20:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13225','490','1','9554','0.99','2005-07-31T02:06:49.000','2006-02-15T22:20:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13226','490','1','10786','7.99','2005-08-01T21:29:34.000','2006-02-15T22:20:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13227','490','1','10955','7.99','2005-08-02T03:32:34.000','2006-02-15T22:20:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13228','490','2','11965','2.99','2005-08-17T17:39:45.000','2006-02-15T22:20:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13229','490','2','14557','4.99','2005-08-21T16:05:11.000','2006-02-15T22:20:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13230','490','2','14761','6.99','2005-08-21T23:30:28.000','2006-02-15T22:20:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13231','490','2','15276','2.99','2005-08-22T18:59:01.000','2006-02-15T22:20:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13232','490','1','15448','2.99','2005-08-23T00:55:24.000','2006-02-15T22:20:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13233','491','1','484','2.99','2005-05-27T23:26:45.000','2006-02-15T22:20:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13234','491','2','1097','0.99','2005-05-31T13:38:42.000','2006-02-15T22:20:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13235','491','2','1198','2.99','2005-06-15T01:48:58.000','2006-02-15T22:20:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13236','491','1','1371','4.99','2005-06-15T14:38:15.000','2006-02-15T22:20:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13237','491','2','2026','4.99','2005-06-17T13:05:38.000','2006-02-15T22:20:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13238','491','1','2259','4.99','2005-06-18T05:37:45.000','2006-02-15T22:20:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13239','491','2','2391','4.99','2005-06-18T15:33:30.000','2006-02-15T22:20:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13240','491','2','3031','4.99','2005-06-20T11:52:49.000','2006-02-15T22:20:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13241','491','1','3440','3.99','2005-06-21T19:58:18.000','2006-02-15T22:20:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13242','491','1','4046','8.99','2005-07-07T03:27:59.000','2006-02-15T22:20:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13243','491','1','4392','2.99','2005-07-07T21:11:02.000','2006-02-15T22:20:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13244','491','2','5134','6.99','2005-07-09T07:53:12.000','2006-02-15T22:20:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13245','491','1','5889','4.99','2005-07-10T19:54:41.000','2006-02-15T22:20:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13246','491','2','6171','2.99','2005-07-11T10:29:35.000','2006-02-15T22:20:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13247','491','2','7019','3.99','2005-07-27T02:20:26.000','2006-02-15T22:20:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13248','491','2','7281','6.99','2005-07-27T11:59:20.000','2006-02-15T22:20:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13249','491','2','7688','7.99','2005-07-28T03:20:47.000','2006-02-15T22:20:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13250','491','1','7871','6.99','2005-07-28T10:16:37.000','2006-02-15T22:20:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13251','491','2','10036','2.99','2005-07-31T18:47:20.000','2006-02-15T22:20:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13252','491','2','10178','4.99','2005-07-31T23:43:04.000','2006-02-15T22:20:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13253','491','2','10974','6.99','2005-08-02T04:10:52.000','2006-02-15T22:20:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13254','491','1','11048','4.99','2005-08-02T06:15:07.000','2006-02-15T22:20:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13255','491','1','11590','0.99','2005-08-17T02:28:33.000','2006-02-15T22:20:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13256','491','1','11840','4.99','2005-08-17T13:09:01.000','2006-02-15T22:20:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13257','491','2','13607','2.99','2005-08-20T06:08:42.000','2006-02-15T22:20:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13258','491','1','14780','0.99','2005-08-22T00:06:33.000','2006-02-15T22:20:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13259','491','2','15685','5.99','2005-08-23T09:41:28.000','2006-02-15T22:20:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13260','492','1','84','2.99','2005-05-25T12:36:30.000','2006-02-15T22:20:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13261','492','2','1691','1.99','2005-06-16T12:24:28.000','2006-02-15T22:20:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13262','492','2','1855','4.99','2005-06-17T00:54:58.000','2006-02-15T22:20:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13263','492','2','1956','4.99','2005-06-17T08:43:32.000','2006-02-15T22:20:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13264','492','1','3298','9.99','2005-06-21T07:09:44.000','2006-02-15T22:20:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13265','492','2','4128','8.99','2005-07-07T07:35:25.000','2006-02-15T22:20:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13266','492','1','4142','2.99','2005-07-07T08:19:45.000','2006-02-15T22:20:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13267','492','2','4258','6.99','2005-07-07T14:20:59.000','2006-02-15T22:20:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13268','492','2','5325','0.99','2005-07-09T16:35:47.000','2006-02-15T22:20:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13269','492','1','5609','0.99','2005-07-10T05:09:46.000','2006-02-15T22:20:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13270','492','1','6257','2.99','2005-07-11T15:23:46.000','2006-02-15T22:20:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13271','492','2','7203','2.99','2005-07-27T09:01:23.000','2006-02-15T22:20:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13272','492','2','12971','4.99','2005-08-19T06:42:43.000','2006-02-15T22:20:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13273','492','1','14255','2.99','2005-08-21T05:51:37.000','2006-02-15T22:20:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13274','492','2','15822','0.99','2005-08-23T15:05:59.000','2006-02-15T22:20:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13275','492','1','15958','4.99','2005-08-23T19:22:36.000','2006-02-15T22:20:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13276','493','1','543','7.99','2005-05-28T06:43:34.000','2006-02-15T22:20:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13277','493','2','2109','3.99','2005-06-17T19:41:42.000','2006-02-15T22:20:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13278','493','1','2365','4.99','2005-06-18T13:45:34.000','2006-02-15T22:20:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13279','493','1','2579','0.99','2005-06-19T04:40:44.000','2006-02-15T22:20:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13280','493','1','2864','2.99','2005-06-20T00:00:52.000','2006-02-15T22:20:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13281','493','2','3586','4.99','2005-07-06T04:24:42.000','2006-02-15T22:20:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13282','493','1','3655','5.99','2005-07-06T07:52:54.000','2006-02-15T22:20:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13283','493','1','6549','7.99','2005-07-12T05:02:01.000','2006-02-15T22:20:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13284','493','1','6552','4.99','2005-07-12T05:05:06.000','2006-02-15T22:20:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13285','493','1','7026','2.99','2005-07-27T02:48:58.000','2006-02-15T22:20:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13286','493','2','7043','7.99','2005-07-27T03:24:23.000','2006-02-15T22:20:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13287','493','1','8298','4.99','2005-07-29T02:47:36.000','2006-02-15T22:20:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13288','493','1','8616','2.99','2005-07-29T13:39:09.000','2006-02-15T22:20:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13289','493','1','10777','6.99','2005-08-01T21:03:50.000','2006-02-15T22:20:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13290','493','2','10885','7.99','2005-08-02T00:51:37.000','2006-02-15T22:20:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13291','493','1','13638','2.99','2005-08-20T07:21:15.000','2006-02-15T22:20:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13292','493','2','13675','6.99','2005-08-20T08:32:51.000','2006-02-15T22:20:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13293','493','1','14117','4.99','2005-08-21T01:11:59.000','2006-02-15T22:20:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13294','493','2','15177','4.99','2005-08-22T15:34:49.000','2006-02-15T22:20:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13295','493','1','15355','0.99','2005-08-22T21:19:24.000','2006-02-15T22:20:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13296','493','1','15490','6.99','2005-08-23T02:08:18.000','2006-02-15T22:20:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13297','493','2','15878','2.99','2005-08-23T16:34:31.000','2006-02-15T22:20:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13298','493','2','14160','2.99','2006-02-14T15:16:03.000','2006-02-15T22:20:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13299','494','1','608','4.99','2005-05-28T15:03:44.000','2006-02-15T22:20:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13300','494','1','1683','2.99','2005-06-16T11:54:55.000','2006-02-15T22:20:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13301','494','1','3511','0.99','2005-07-06T00:42:01.000','2006-02-15T22:20:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13302','494','2','3803','2.99','2005-07-06T15:06:55.000','2006-02-15T22:20:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13303','494','2','3913','0.99','2005-07-06T20:11:00.000','2006-02-15T22:20:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13304','494','1','4086','3.99','2005-07-07T05:26:06.000','2006-02-15T22:20:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13305','494','2','4397','5.99','2005-07-07T21:14:54.000','2006-02-15T22:20:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13306','494','2','4551','7.99','2005-07-08T04:36:21.000','2006-02-15T22:20:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13307','494','2','5083','4.99','2005-07-09T05:30:32.000','2006-02-15T22:20:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13308','494','1','5180','2.99','2005-07-09T10:06:53.000','2006-02-15T22:20:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13309','494','2','7258','3.99','2005-07-27T11:05:54.000','2006-02-15T22:20:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13310','494','2','7546','8.99','2005-07-27T21:50:09.000','2006-02-15T22:20:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13311','494','2','7737','1.99','2005-07-28T05:15:03.000','2006-02-15T22:20:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13312','494','2','8333','2.99','2005-07-29T04:16:40.000','2006-02-15T22:20:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13313','494','2','8895','2.99','2005-07-30T00:49:17.000','2006-02-15T22:20:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13314','494','1','8934','4.99','2005-07-30T02:37:05.000','2006-02-15T22:20:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13315','494','2','9012','4.99','2005-07-30T05:18:57.000','2006-02-15T22:20:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13316','494','2','9510','7.99','2005-07-31T00:24:17.000','2006-02-15T22:20:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13317','494','1','9799','2.99','2005-07-31T10:58:32.000','2006-02-15T22:20:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13318','494','2','9943','7.99','2005-07-31T15:37:29.000','2006-02-15T22:20:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13319','494','1','10403','0.99','2005-08-01T07:30:45.000','2006-02-15T22:20:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13320','494','1','10623','2.99','2005-08-01T15:22:38.000','2006-02-15T22:20:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13321','494','2','11152','3.99','2005-08-02T09:53:36.000','2006-02-15T22:20:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13322','494','1','11987','5.99','2005-08-17T18:21:59.000','2006-02-15T22:20:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13323','494','2','13094','0.99','2005-08-19T10:47:58.000','2006-02-15T22:20:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13324','494','2','13301','3.99','2005-08-19T18:53:15.000','2006-02-15T22:20:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13325','494','2','14634','5.99','2005-08-21T18:51:28.000','2006-02-15T22:20:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13326','494','1','14832','4.99','2005-08-22T01:43:29.000','2006-02-15T22:20:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13327','494','1','15086','6.99','2005-08-22T11:21:08.000','2006-02-15T22:20:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13328','494','2','15156','9.99','2005-08-22T14:29:11.000','2006-02-15T22:20:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13329','494','2','15291','4.99','2005-08-22T19:28:04.000','2006-02-15T22:20:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13330','495','2','623','4.99','2005-05-28T16:01:28.000','2006-02-15T22:20:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13331','495','2','741','4.99','2005-05-29T08:35:49.000','2006-02-15T22:20:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13332','495','2','2074','2.99','2005-06-17T16:40:03.000','2006-02-15T22:20:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13333','495','1','2349','4.99','2005-06-18T12:25:14.000','2006-02-15T22:20:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13334','495','1','2549','7.99','2005-06-19T02:46:39.000','2006-02-15T22:20:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13335','495','1','3129','3.99','2005-06-20T18:57:48.000','2006-02-15T22:20:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13336','495','2','3966','2.99','2005-07-06T22:38:49.000','2006-02-15T22:20:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13337','495','2','5484','7.99','2005-07-09T23:54:37.000','2006-02-15T22:20:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13338','495','2','6426','7.99','2005-07-11T23:56:38.000','2006-02-15T22:20:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13339','495','2','7191','2.99','2005-07-27T08:36:15.000','2006-02-15T22:20:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13340','495','1','8151','0.99','2005-07-28T20:50:52.000','2006-02-15T22:20:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13341','495','1','8383','1.99','2005-07-29T05:36:47.000','2006-02-15T22:20:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13342','495','1','8451','5.99','2005-07-29T07:44:56.000','2006-02-15T22:20:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13343','495','1','8672','5.99','2005-07-29T15:49:48.000','2006-02-15T22:20:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13344','495','1','9387','9.99','2005-07-30T19:27:05.000','2006-02-15T22:20:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13345','495','1','9741','4.99','2005-07-31T09:09:22.000','2006-02-15T22:20:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13346','495','2','10065','4.99','2005-07-31T19:27:34.000','2006-02-15T22:20:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13347','495','2','10643','5.99','2005-08-01T15:48:33.000','2006-02-15T22:20:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13348','495','1','10783','4.99','2005-08-01T21:23:37.000','2006-02-15T22:20:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13349','495','1','12782','5.99','2005-08-18T23:56:23.000','2006-02-15T22:20:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13350','495','2','12837','0.99','2005-08-19T01:51:09.000','2006-02-15T22:20:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13351','495','2','13205','3.99','2005-08-19T15:05:26.000','2006-02-15T22:20:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13352','495','2','13445','2.99','2005-08-20T00:05:33.000','2006-02-15T22:20:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13353','495','2','13818','4.99','2005-08-20T13:20:09.000','2006-02-15T22:20:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13354','495','1','15984','2.99','2005-08-23T20:16:27.000','2006-02-15T22:20:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13355','495','2','13753','0.99','2006-02-14T15:16:03.000','2006-02-15T22:20:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13356','496','2','322','4.99','2005-05-27T00:47:35.000','2006-02-15T22:20:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13357','496','2','966','0.99','2005-05-30T19:00:37.000','2006-02-15T22:20:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13358','496','1','2567','2.99','2005-06-19T04:04:46.000','2006-02-15T22:20:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13359','496','2','3569','3.99','2005-07-06T03:17:23.000','2006-02-15T22:20:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13360','496','1','4070','2.99','2005-07-07T04:37:09.000','2006-02-15T22:20:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13361','496','1','4261','4.99','2005-07-07T14:23:56.000','2006-02-15T22:20:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13362','496','1','4269','0.99','2005-07-07T14:38:33.000','2006-02-15T22:20:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13363','496','1','5559','5.99','2005-07-10T03:13:07.000','2006-02-15T22:20:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13364','496','2','5949','4.99','2005-07-10T23:13:00.000','2006-02-15T22:20:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13365','496','1','7133','2.99','2005-07-27T06:29:23.000','2006-02-15T22:20:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13366','496','2','8221','2.99','2005-07-28T23:47:19.000','2006-02-15T22:20:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13367','496','1','11060','7.99','2005-08-02T06:48:18.000','2006-02-15T22:20:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13368','496','2','11448','4.99','2005-08-02T20:44:33.000','2006-02-15T22:20:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13369','496','1','11893','3.99','2005-08-17T15:13:29.000','2006-02-15T22:20:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13370','496','2','12605','4.99','2005-08-18T16:59:37.000','2006-02-15T22:20:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13371','496','1','13569','5.99','2005-08-20T05:02:59.000','2006-02-15T22:20:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13372','496','2','14013','6.99','2005-08-20T20:42:50.000','2006-02-15T22:20:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13373','496','1','14332','7.99','2005-08-21T08:30:43.000','2006-02-15T22:20:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13374','496','1','14348','0.99','2005-08-21T08:54:26.000','2006-02-15T22:20:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13375','496','2','15750','2.99','2005-08-23T12:36:05.000','2006-02-15T22:20:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13376','496','1','13182','2.99','2006-02-14T15:16:03.000','2006-02-15T22:20:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13377','497','1','1100','7.99','2005-05-31T14:03:21.000','2006-02-15T22:20:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13378','497','2','2180','8.99','2005-06-18T00:47:43.000','2006-02-15T22:20:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13379','497','1','2298','5.99','2005-06-18T08:18:29.000','2006-02-15T22:20:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13380','497','1','2406','2.99','2005-06-18T16:39:37.000','2006-02-15T22:20:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13381','497','2','2818','4.99','2005-06-19T20:05:52.000','2006-02-15T22:20:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13382','497','1','3696','2.99','2005-07-06T10:04:55.000','2006-02-15T22:20:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13383','497','2','4218','7.99','2005-07-07T12:10:24.000','2006-02-15T22:20:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13384','497','1','4516','4.99','2005-07-08T02:43:41.000','2006-02-15T22:20:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13385','497','1','4578','0.99','2005-07-08T06:00:17.000','2006-02-15T22:20:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13386','497','2','4795','0.99','2005-07-08T16:32:54.000','2006-02-15T22:20:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13387','497','1','5030','4.99','2005-07-09T02:35:43.000','2006-02-15T22:20:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13388','497','1','5239','4.99','2005-07-09T13:12:35.000','2006-02-15T22:20:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13389','497','2','7603','2.99','2005-07-27T23:54:44.000','2006-02-15T22:20:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13390','497','2','8011','2.99','2005-07-28T15:26:39.000','2006-02-15T22:20:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13391','497','1','8150','6.99','2005-07-28T20:50:41.000','2006-02-15T22:20:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13392','497','2','8813','6.99','2005-07-29T21:47:55.000','2006-02-15T22:20:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13393','497','2','8867','4.99','2005-07-30T00:02:18.000','2006-02-15T22:20:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13394','497','1','9273','9.99','2005-07-30T15:05:36.000','2006-02-15T22:20:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13395','497','2','9850','4.99','2005-07-31T12:46:52.000','2006-02-15T22:20:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13396','497','2','10760','7.99','2005-08-01T20:25:20.000','2006-02-15T22:20:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13397','497','1','12123','0.99','2005-08-17T23:22:18.000','2006-02-15T22:20:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13398','497','1','13159','4.99','2005-08-19T13:19:59.000','2006-02-15T22:20:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13399','497','1','13289','2.99','2005-08-19T18:31:30.000','2006-02-15T22:20:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13400','497','2','14134','0.99','2005-08-21T01:45:54.000','2006-02-15T22:20:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13401','497','1','15362','5.99','2005-08-22T21:40:20.000','2006-02-15T22:20:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13402','497','2','15633','0.99','2005-08-23T07:31:10.000','2006-02-15T22:20:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13403','497','1','15919','0.99','2005-08-23T18:01:31.000','2006-02-15T22:20:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13404','497','1','12698','4.99','2006-02-14T15:16:03.000','2006-02-15T22:20:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13405','498','2','49','2.99','2005-05-25T06:39:35.000','2006-02-15T22:20:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13406','498','1','429','8.99','2005-05-27T16:21:26.000','2006-02-15T22:20:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13407','498','2','718','2.99','2005-05-29T04:52:23.000','2006-02-15T22:20:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13408','498','1','1253','6.99','2005-06-15T06:06:33.000','2006-02-15T22:20:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13409','498','1','1782','2.99','2005-06-16T19:21:12.000','2006-02-15T22:20:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13410','498','1','2344','2.99','2005-06-18T12:01:47.000','2006-02-15T22:20:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13411','498','1','2449','4.99','2005-06-18T19:18:36.000','2006-02-15T22:20:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13412','498','1','3098','0.99','2005-06-20T16:37:01.000','2006-02-15T22:20:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13413','498','2','3360','0.99','2005-06-21T12:12:41.000','2006-02-15T22:20:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13414','498','2','3828','0.99','2005-07-06T15:57:30.000','2006-02-15T22:20:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13415','498','2','3856','2.99','2005-07-06T17:04:46.000','2006-02-15T22:20:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13416','498','1','4311','4.99','2005-07-07T17:31:14.000','2006-02-15T22:20:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13417','498','2','4972','2.99','2005-07-08T23:56:09.000','2006-02-15T22:20:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13418','498','1','5286','2.99','2005-07-09T15:11:41.000','2006-02-15T22:20:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13419','498','2','5884','0.99','2005-07-10T19:31:38.000','2006-02-15T22:20:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13420','498','1','6058','2.99','2005-07-11T04:03:51.000','2006-02-15T22:20:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13421','498','1','6088','1.99','2005-07-11T05:40:35.000','2006-02-15T22:20:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13422','498','1','7285','4.99','2005-07-27T12:14:06.000','2006-02-15T22:20:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13423','498','1','7286','6.99','2005-07-27T12:23:49.000','2006-02-15T22:20:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13424','498','1','7341','4.99','2005-07-27T14:23:55.000','2006-02-15T22:20:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13425','498','2','8020','4.99','2005-07-28T15:43:32.000','2006-02-15T22:20:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13426','498','1','8229','2.99','2005-07-29T00:09:08.000','2006-02-15T22:20:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13427','498','2','9021','0.99','2005-07-30T05:34:24.000','2006-02-15T22:20:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13428','498','2','9689','4.99','2005-07-31T07:00:08.000','2006-02-15T22:20:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13429','498','1','10225','0.99','2005-08-01T01:38:40.000','2006-02-15T22:20:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13430','498','1','11455','6.99','2005-08-02T21:07:06.000','2006-02-15T22:20:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13431','498','1','12893','2.99','2005-08-19T03:46:43.000','2006-02-15T22:20:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13432','499','2','89','2.99','2005-05-25T14:28:29.000','2006-02-15T22:20:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13433','499','1','1355','2.99','2005-06-15T13:13:59.000','2006-02-15T22:20:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13434','499','2','1526','4.99','2005-06-16T00:27:51.000','2006-02-15T22:20:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13435','499','2','1830','4.99','2005-06-16T22:18:43.000','2006-02-15T22:20:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13436','499','2','3241','1.99','2005-06-21T02:54:32.000','2006-02-15T22:20:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13437','499','1','3794','4.99','2005-07-06T14:35:26.000','2006-02-15T22:20:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13438','499','1','5022','2.99','2005-07-09T02:10:54.000','2006-02-15T22:20:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13439','499','2','5392','2.99','2005-07-09T19:32:30.000','2006-02-15T22:20:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13440','499','2','5427','3.99','2005-07-09T21:12:26.000','2006-02-15T22:20:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13441','499','1','5956','4.99','2005-07-10T23:23:08.000','2006-02-15T22:20:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13442','499','2','6723','4.99','2005-07-12T13:44:57.000','2006-02-15T22:20:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13443','499','1','7800','0.99','2005-07-28T07:50:59.000','2006-02-15T22:20:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13444','499','1','7831','0.99','2005-07-28T08:44:21.000','2006-02-15T22:20:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13445','499','1','7898','6.99','2005-07-28T11:08:22.000','2006-02-15T22:20:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13446','499','2','8130','4.99','2005-07-28T19:48:15.000','2006-02-15T22:20:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13447','499','1','8770','3.99','2005-07-29T19:53:50.000','2006-02-15T22:20:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13448','499','1','9588','0.99','2005-07-31T03:13:13.000','2006-02-15T22:20:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13449','499','2','10333','0.99','2005-08-01T04:58:32.000','2006-02-15T22:20:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13450','499','2','10497','2.99','2005-08-01T10:55:59.000','2006-02-15T22:20:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13451','499','1','11513','7.99','2005-08-16T23:51:33.000','2006-02-15T22:20:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13452','499','2','11606','0.99','2005-08-17T03:32:43.000','2006-02-15T22:20:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13453','499','2','11978','4.99','2005-08-17T18:02:10.000','2006-02-15T22:20:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13454','499','1','12004','8.99','2005-08-17T18:56:53.000','2006-02-15T22:20:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13455','499','1','12354','7.99','2005-08-18T07:34:07.000','2006-02-15T22:20:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13456','499','1','12436','3.99','2005-08-18T10:41:05.000','2006-02-15T22:20:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13457','499','1','12587','1.99','2005-08-18T16:03:13.000','2006-02-15T22:20:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13458','499','2','12947','4.99','2005-08-19T05:54:21.000','2006-02-15T22:20:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13459','499','2','13822','3.99','2005-08-20T13:39:28.000','2006-02-15T22:20:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13460','499','1','14858','3.99','2005-08-22T02:46:18.000','2006-02-15T22:20:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13461','499','1','15587','7.99','2005-08-23T06:00:28.000','2006-02-15T22:20:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13462','500','1','112','8.99','2005-05-25T18:57:24.000','2006-02-15T22:20:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13463','500','1','389','8.99','2005-05-27T10:45:41.000','2006-02-15T22:20:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13464','500','1','610','0.99','2005-05-28T15:15:25.000','2006-02-15T22:20:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13465','500','1','1375','5.99','2005-06-15T14:54:56.000','2006-02-15T22:20:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13466','500','2','1388','5.99','2005-06-15T15:48:41.000','2006-02-15T22:20:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13467','500','2','2189','3.99','2005-06-18T01:20:26.000','2006-02-15T22:20:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13468','500','2','2526','6.99','2005-06-19T01:03:07.000','2006-02-15T22:20:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13469','500','1','2996','2.99','2005-06-20T09:20:29.000','2006-02-15T22:20:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13470','500','2','3926','4.99','2005-07-06T20:42:35.000','2006-02-15T22:20:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13471','500','1','4561','0.99','2005-07-08T05:02:43.000','2006-02-15T22:20:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13472','500','2','4790','4.99','2005-07-08T16:25:27.000','2006-02-15T22:20:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13473','500','2','6018','4.99','2005-07-11T02:06:36.000','2006-02-15T22:20:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13474','500','2','6187','2.99','2005-07-11T11:28:51.000','2006-02-15T22:20:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13475','500','2','6801','3.99','2005-07-12T17:09:08.000','2006-02-15T22:20:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13476','500','1','7857','0.99','2005-07-28T09:49:40.000','2006-02-15T22:20:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13477','500','1','7925','2.99','2005-07-28T12:10:02.000','2006-02-15T22:20:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13478','500','1','8538','6.99','2005-07-29T10:45:17.000','2006-02-15T22:20:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13479','500','1','8925','0.99','2005-07-30T02:09:14.000','2006-02-15T22:20:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13480','500','2','9290','3.99','2005-07-30T15:59:08.000','2006-02-15T22:20:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13481','500','1','10947','6.99','2005-08-02T03:23:17.000','2006-02-15T22:20:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13482','500','2','11218','1.99','2005-08-02T12:29:12.000','2006-02-15T22:20:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13483','500','1','12639','2.99','2005-08-18T18:13:05.000','2006-02-15T22:20:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13484','500','2','12813','2.99','2005-08-19T00:54:22.000','2006-02-15T22:20:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13485','500','2','13628','4.99','2005-08-20T07:03:53.000','2006-02-15T22:20:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13486','500','1','14407','0.99','2005-08-21T10:46:51.000','2006-02-15T22:20:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13487','500','1','14964','4.99','2005-08-22T06:39:24.000','2006-02-15T22:20:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13488','500','1','15584','2.99','2005-08-23T05:49:21.000','2006-02-15T22:20:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13489','500','1','15853','2.99','2005-08-23T15:54:20.000','2006-02-15T22:20:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13490','501','1','493','0.99','2005-05-28T00:34:11.000','2006-02-15T22:20:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13491','501','1','605','1.99','2005-05-28T14:39:10.000','2006-02-15T22:20:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13492','501','2','3222','5.99','2005-06-21T01:50:29.000','2006-02-15T22:20:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13493','501','1','3412','7.99','2005-06-21T16:44:31.000','2006-02-15T22:20:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13494','501','2','3541','6.99','2005-07-06T01:50:11.000','2006-02-15T22:20:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13495','501','2','3723','6.99','2005-07-06T11:12:02.000','2006-02-15T22:20:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13496','501','2','4769','2.99','2005-07-08T15:29:16.000','2006-02-15T22:20:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13497','501','2','5520','1.99','2005-07-10T01:30:41.000','2006-02-15T22:20:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13498','501','2','6095','7.99','2005-07-11T06:06:41.000','2006-02-15T22:20:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13499','501','1','7456','0.99','2005-07-27T18:34:53.000','2006-02-15T22:20:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13500','501','1','8021','2.99','2005-07-28T15:45:24.000','2006-02-15T22:20:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13501','501','2','8529','2.99','2005-07-29T10:24:31.000','2006-02-15T22:20:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13502','501','1','9359','2.99','2005-07-30T18:39:28.000','2006-02-15T22:20:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13503','501','1','10817','4.99','2005-08-01T22:51:08.000','2006-02-15T22:20:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13504','501','2','11393','4.99','2005-08-02T18:44:29.000','2006-02-15T22:20:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13505','501','1','11640','1.99','2005-08-17T04:44:33.000','2006-02-15T22:20:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13506','501','2','11799','6.99','2005-08-17T11:25:25.000','2006-02-15T22:20:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13507','501','1','12914','4.99','2005-08-19T04:25:59.000','2006-02-15T22:20:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13508','501','2','13889','0.99','2005-08-20T15:40:06.000','2006-02-15T22:20:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13509','501','1','15239','4.99','2005-08-22T17:46:17.000','2006-02-15T22:20:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13510','501','1','15699','5.99','2005-08-23T10:20:35.000','2006-02-15T22:20:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13511','502','2','258','2.99','2005-05-26T15:28:14.000','2006-02-15T22:20:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13512','502','1','861','0.99','2005-05-30T02:48:32.000','2006-02-15T22:20:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13513','502','1','893','2.99','2005-05-30T08:06:59.000','2006-02-15T22:20:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13514','502','2','965','0.99','2005-05-30T19:00:14.000','2006-02-15T22:20:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13515','502','2','1696','7.99','2005-06-16T12:50:01.000','2006-02-15T22:20:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13516','502','2','2420','0.99','2005-06-18T17:22:28.000','2006-02-15T22:20:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13517','502','1','2911','0.99','2005-06-20T03:32:37.000','2006-02-15T22:20:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13518','502','2','3614','2.99','2005-07-06T05:46:05.000','2006-02-15T22:20:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13519','502','1','4606','2.99','2005-07-08T07:05:50.000','2006-02-15T22:20:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13520','502','2','5368','5.99','2005-07-09T18:41:59.000','2006-02-15T22:20:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13521','502','2','5662','2.99','2005-07-10T07:59:24.000','2006-02-15T22:20:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13522','502','2','6414','7.99','2005-07-11T23:26:13.000','2006-02-15T22:20:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13523','502','1','6760','8.99','2005-07-12T15:16:00.000','2006-02-15T22:20:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13524','502','2','6828','2.99','2005-07-12T18:38:51.000','2006-02-15T22:20:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13525','502','2','6924','8.99','2005-07-26T22:51:53.000','2006-02-15T22:20:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13526','502','2','7213','3.99','2005-07-27T09:22:29.000','2006-02-15T22:20:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13527','502','1','7255','4.99','2005-07-27T10:49:54.000','2006-02-15T22:20:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13528','502','1','7757','4.99','2005-07-28T06:23:00.000','2006-02-15T22:20:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13529','502','1','7884','4.99','2005-07-28T10:37:24.000','2006-02-15T22:20:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13530','502','2','8034','4.99','2005-07-28T16:20:26.000','2006-02-15T22:20:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13531','502','2','9232','0.99','2005-07-30T13:43:00.000','2006-02-15T22:20:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13532','502','1','9599','4.99','2005-07-31T03:32:06.000','2006-02-15T22:20:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13533','502','2','10390','4.99','2005-08-01T06:46:48.000','2006-02-15T22:20:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13534','502','1','10938','0.99','2005-08-02T03:05:22.000','2006-02-15T22:20:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13535','502','2','11036','4.99','2005-08-02T05:56:29.000','2006-02-15T22:20:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13536','502','1','11301','0.99','2005-08-02T15:37:59.000','2006-02-15T22:20:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13537','502','1','11317','4.99','2005-08-02T16:08:52.000','2006-02-15T22:20:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13538','502','1','11435','0.99','2005-08-02T20:14:23.000','2006-02-15T22:20:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13539','502','1','11620','0.99','2005-08-17T04:06:22.000','2006-02-15T22:20:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13540','502','1','12762','4.99','2005-08-18T23:06:54.000','2006-02-15T22:20:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13541','502','1','13052','9.99','2005-08-19T09:31:42.000','2006-02-15T22:20:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13542','502','1','14411','4.99','2005-08-21T10:54:57.000','2006-02-15T22:20:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13543','502','1','15486','3.99','2005-08-23T02:05:20.000','2006-02-15T22:20:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13544','502','1','16034','3.99','2005-08-23T22:06:34.000','2006-02-15T22:20:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13545','503','2','109','1.99','2005-05-25T18:40:20.000','2006-02-15T22:20:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13546','503','1','353','5.99','2005-05-27T06:03:39.000','2006-02-15T22:20:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13547','503','1','631','2.99','2005-05-28T17:36:32.000','2006-02-15T22:20:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13548','503','1','1074','4.99','2005-05-31T10:04:42.000','2006-02-15T22:20:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13549','503','2','2108','4.99','2005-06-17T19:35:26.000','2006-02-15T22:20:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13550','503','1','2225','2.99','2005-06-18T03:35:40.000','2006-02-15T22:20:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13551','503','2','3430','0.99','2005-06-21T18:46:08.000','2006-02-15T22:20:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13552','503','2','3935','6.99','2005-07-06T21:08:29.000','2006-02-15T22:20:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13553','503','2','4570','2.99','2005-07-08T05:33:59.000','2006-02-15T22:20:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13554','503','2','5465','2.99','2005-07-09T23:01:13.000','2006-02-15T22:20:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13555','503','1','5925','6.99','2005-07-10T21:41:27.000','2006-02-15T22:20:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13556','503','1','6166','4.99','2005-07-11T10:19:05.000','2006-02-15T22:20:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13557','503','1','6529','2.99','2005-07-12T04:31:04.000','2006-02-15T22:20:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13558','503','2','6950','4.99','2005-07-26T23:45:33.000','2006-02-15T22:20:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13559','503','1','8178','2.99','2005-07-28T21:54:31.000','2006-02-15T22:20:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13560','503','2','9725','0.99','2005-07-31T08:35:18.000','2006-02-15T22:20:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13561','503','1','9974','4.99','2005-07-31T16:51:11.000','2006-02-15T22:20:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13562','503','2','11075','2.99','2005-08-02T07:24:23.000','2006-02-15T22:20:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13563','503','1','11161','1.99','2005-08-02T10:05:57.000','2006-02-15T22:20:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13564','503','1','11858','4.99','2005-08-17T13:50:31.000','2006-02-15T22:20:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13565','503','2','12370','2.99','2005-08-18T07:57:47.000','2006-02-15T22:20:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13566','503','2','12783','4.99','2005-08-19T00:01:14.000','2006-02-15T22:20:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13567','503','1','13332','2.99','2005-08-19T20:00:51.000','2006-02-15T22:20:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13568','503','1','13551','2.99','2005-08-20T04:00:30.000','2006-02-15T22:20:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13569','503','1','14823','0.99','2005-08-22T01:24:42.000','2006-02-15T22:20:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13570','503','1','14913','2.99','2005-08-22T04:52:13.000','2006-02-15T22:20:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13571','503','2','15056','4.99','2005-08-22T10:15:54.000','2006-02-15T22:20:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13572','503','2','15077','2.99','2005-08-22T11:09:18.000','2006-02-15T22:20:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13573','503','1','15588','3.99','2005-08-23T06:02:35.000','2006-02-15T22:20:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13574','503','1','15692','4.99','2005-08-23T10:00:02.000','2006-02-15T22:20:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13575','503','1','15726','2.99','2005-08-23T11:28:26.000','2006-02-15T22:20:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13576','503','1','15797','0.99','2005-08-23T14:13:47.000','2006-02-15T22:20:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13577','504','2','136','5.99','2005-05-25T22:02:30.000','2006-02-15T22:20:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13578','504','2','470','4.99','2005-05-27T21:17:08.000','2006-02-15T22:20:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13579','504','1','838','4.99','2005-05-30T00:27:57.000','2006-02-15T22:20:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13580','504','1','2720','1.99','2005-06-19T14:51:55.000','2006-02-15T22:20:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13581','504','1','2938','6.99','2005-06-20T05:17:22.000','2006-02-15T22:20:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13582','504','2','3712','9.99','2005-07-06T10:47:35.000','2006-02-15T22:20:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13583','504','1','3713','6.99','2005-07-06T10:49:30.000','2006-02-15T22:20:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13584','504','1','4329','5.99','2005-07-07T18:04:16.000','2006-02-15T22:20:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13585','504','1','4757','0.99','2005-07-08T14:36:51.000','2006-02-15T22:20:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13586','504','2','5153','6.99','2005-07-09T08:35:05.000','2006-02-15T22:20:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13587','504','2','7342','3.99','2005-07-27T14:25:17.000','2006-02-15T22:20:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13588','504','1','7567','2.99','2005-07-27T22:38:05.000','2006-02-15T22:20:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13589','504','2','7807','2.99','2005-07-28T07:58:27.000','2006-02-15T22:20:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13590','504','2','7875','1.99','2005-07-28T10:23:48.000','2006-02-15T22:20:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13591','504','2','7944','4.99','2005-07-28T12:51:22.000','2006-02-15T22:20:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13592','504','1','8393','9.99','2005-07-29T06:02:11.000','2006-02-15T22:20:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13593','504','2','10397','0.99','2005-08-01T07:11:27.000','2006-02-15T22:20:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13594','504','2','10509','3.99','2005-08-01T11:25:28.000','2006-02-15T22:20:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13595','504','2','11569','2.99','2005-08-17T01:31:04.000','2006-02-15T22:20:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13596','504','1','12769','1.99','2005-08-18T23:26:40.000','2006-02-15T22:20:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13597','504','1','13166','2.99','2005-08-19T13:36:28.000','2006-02-15T22:20:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13598','504','2','13206','2.99','2005-08-19T15:05:34.000','2006-02-15T22:20:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13599','504','2','13387','2.99','2005-08-19T21:46:10.000','2006-02-15T22:20:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13600','504','2','13859','5.99','2005-08-20T14:53:43.000','2006-02-15T22:20:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13601','504','2','15018','4.99','2005-08-22T08:52:38.000','2006-02-15T22:20:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13602','504','1','15166','6.99','2005-08-22T15:05:37.000','2006-02-15T22:20:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13603','504','1','15723','8.99','2005-08-23T11:17:26.000','2006-02-15T22:20:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13604','504','2','16022','4.99','2005-08-23T21:44:27.000','2006-02-15T22:20:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13605','505','1','159','2.99','2005-05-26T01:34:28.000','2006-02-15T22:20:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13606','505','1','645','2.99','2005-05-28T19:14:09.000','2006-02-15T22:20:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13607','505','2','1799','5.99','2005-06-16T20:17:20.000','2006-02-15T22:20:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13608','505','2','1886','4.99','2005-06-17T03:36:02.000','2006-02-15T22:20:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13609','505','1','2773','7.99','2005-06-19T18:04:18.000','2006-02-15T22:20:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13610','505','1','3137','5.99','2005-06-20T19:41:28.000','2006-02-15T22:20:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13611','505','2','4008','5.99','2005-07-07T00:26:43.000','2006-02-15T22:20:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13612','505','1','4507','6.99','2005-07-08T02:22:45.000','2006-02-15T22:20:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13613','505','2','5976','9.99','2005-07-11T00:16:35.000','2006-02-15T22:20:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13614','505','2','6292','4.99','2005-07-11T17:23:33.000','2006-02-15T22:20:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13615','505','1','6441','0.99','2005-07-12T00:27:08.000','2006-02-15T22:20:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13616','505','1','7784','4.99','2005-07-28T07:15:32.000','2006-02-15T22:20:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13617','505','2','10219','5.99','2005-08-01T01:10:33.000','2006-02-15T22:20:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13618','505','1','10896','2.99','2005-08-02T01:19:33.000','2006-02-15T22:20:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13619','505','1','11163','0.99','2005-08-02T10:08:40.000','2006-02-15T22:20:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13620','505','1','11907','2.99','2005-08-17T15:40:47.000','2006-02-15T22:20:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13621','505','2','13612','3.99','2005-08-20T06:22:08.000','2006-02-15T22:20:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13622','505','1','14398','2.99','2005-08-21T10:27:21.000','2006-02-15T22:20:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13623','505','1','14802','2.99','2005-08-22T00:48:23.000','2006-02-15T22:20:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13624','505','1','15436','4.99','2005-08-23T00:30:26.000','2006-02-15T22:20:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13625','505','2','15867','4.99','2006-02-14T15:16:03.000','2006-02-15T22:20:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13626','506','1','114','3.99','2005-05-25T19:12:42.000','2006-02-15T22:20:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13627','506','2','387','2.99','2005-05-27T10:35:27.000','2006-02-15T22:20:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13628','506','2','410','3.99','2005-05-27T14:11:22.000','2006-02-15T22:20:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13629','506','1','547','8.99','2005-05-28T07:24:28.000','2006-02-15T22:20:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13630','506','2','907','0.99','2005-05-30T10:37:27.000','2006-02-15T22:20:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13631','506','1','1042','2.99','2005-05-31T05:53:00.000','2006-02-15T22:20:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13632','506','2','1153','4.99','2005-05-31T21:36:44.000','2006-02-15T22:20:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13633','506','1','1446','6.99','2005-06-15T19:13:45.000','2006-02-15T22:20:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13634','506','1','1467','2.99','2005-06-15T20:47:10.000','2006-02-15T22:20:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13635','506','2','1565','0.99','2005-06-16T03:13:09.000','2006-02-15T22:20:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13636','506','1','2755','9.99','2005-06-19T16:56:31.000','2006-02-15T22:20:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13637','506','2','2824','6.99','2005-06-19T20:31:45.000','2006-02-15T22:20:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13638','506','2','4594','7.99','2005-07-08T06:40:06.000','2006-02-15T22:20:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13639','506','2','4640','6.99','2005-07-08T08:59:34.000','2006-02-15T22:20:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13640','506','2','4806','8.99','2005-07-08T17:01:02.000','2006-02-15T22:20:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13641','506','2','5985','0.99','2005-07-11T00:51:58.000','2006-02-15T22:20:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13642','506','1','6783','2.99','2005-07-12T16:27:56.000','2006-02-15T22:20:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13643','506','1','7020','0.99','2005-07-27T02:24:27.000','2006-02-15T22:20:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13644','506','2','8096','9.99','2005-07-28T18:32:46.000','2006-02-15T22:20:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13645','506','2','8506','0.99','2005-07-29T09:23:52.000','2006-02-15T22:20:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13646','506','2','9654','3.99','2005-07-31T05:57:42.000','2006-02-15T22:20:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13647','506','2','9972','2.99','2005-07-31T16:42:43.000','2006-02-15T22:20:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13648','506','1','10477','2.99','2005-08-01T10:04:17.000','2006-02-15T22:20:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13649','506','1','10873','4.99','2005-08-02T00:30:34.000','2006-02-15T22:20:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13650','506','2','11238','0.99','2005-08-02T13:25:50.000','2006-02-15T22:20:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13651','506','2','11781','4.99','2005-08-17T10:37:00.000','2006-02-15T22:20:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13652','506','1','12994','0.99','2005-08-19T07:26:10.000','2006-02-15T22:20:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13653','506','2','13073','2.99','2005-08-19T10:05:38.000','2006-02-15T22:20:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13654','506','2','13767','0.99','2005-08-20T11:43:36.000','2006-02-15T22:20:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13655','506','1','14074','1.99','2005-08-20T23:16:07.000','2006-02-15T22:20:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13656','506','1','14337','2.99','2005-08-21T08:34:26.000','2006-02-15T22:20:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13657','506','2','14395','6.99','2005-08-21T10:24:00.000','2006-02-15T22:20:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13658','506','2','15022','5.99','2005-08-22T08:55:43.000','2006-02-15T22:20:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13659','506','2','15572','1.99','2005-08-23T05:28:01.000','2006-02-15T22:20:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13660','506','1','15694','9.99','2005-08-23T10:02:46.000','2006-02-15T22:20:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13661','507','1','52','0.99','2005-05-25T06:51:29.000','2006-02-15T22:20:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13662','507','2','713','4.99','2005-05-29T04:10:17.000','2006-02-15T22:20:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13663','507','2','1307','4.99','2005-06-15T10:06:15.000','2006-02-15T22:20:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13664','507','1','2143','4.99','2005-06-17T21:58:13.000','2006-02-15T22:20:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13665','507','2','2283','4.99','2005-06-18T06:56:06.000','2006-02-15T22:20:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13666','507','1','3660','4.99','2005-07-06T08:07:29.000','2006-02-15T22:20:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13667','507','1','3880','2.99','2005-07-06T18:32:49.000','2006-02-15T22:20:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13668','507','2','4440','0.99','2005-07-07T23:00:58.000','2006-02-15T22:20:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13669','507','2','4455','2.99','2005-07-07T23:43:46.000','2006-02-15T22:20:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13670','507','2','4744','0.99','2005-07-08T13:43:57.000','2006-02-15T22:20:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13671','507','2','4901','2.99','2005-07-08T20:44:51.000','2006-02-15T22:20:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13672','507','1','5962','0.99','2005-07-10T23:45:22.000','2006-02-15T22:20:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13673','507','1','6351','6.99','2005-07-11T20:31:44.000','2006-02-15T22:20:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13674','507','1','6396','1.99','2005-07-11T22:31:08.000','2006-02-15T22:20:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13675','507','1','6891','2.99','2005-07-12T21:07:35.000','2006-02-15T22:20:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13676','507','2','7770','5.99','2005-07-28T06:49:35.000','2006-02-15T22:20:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13677','507','1','7970','5.99','2005-07-28T13:58:38.000','2006-02-15T22:20:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13678','507','2','8369','2.99','2005-07-29T05:15:42.000','2006-02-15T22:20:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13679','507','2','8976','2.99','2005-07-30T04:12:32.000','2006-02-15T22:20:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13680','507','1','9003','2.99','2005-07-30T05:02:52.000','2006-02-15T22:20:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13681','507','2','12071','6.99','2005-08-17T21:49:14.000','2006-02-15T22:20:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13682','507','2','12275','4.99','2005-08-18T04:42:02.000','2006-02-15T22:20:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13683','507','1','12343','4.99','2005-08-18T07:15:13.000','2006-02-15T22:20:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13684','507','2','14625','4.99','2005-08-21T18:34:21.000','2006-02-15T22:20:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13685','507','1','15394','2.99','2005-08-22T23:04:21.000','2006-02-15T22:20:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13686','508','1','369','2.99','2005-05-27T07:46:49.000','2006-02-15T22:20:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13687','508','2','921','2.99','2005-05-30T11:53:09.000','2006-02-15T22:20:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13688','508','2','1661','4.99','2005-06-16T10:12:57.000','2006-02-15T22:20:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13689','508','2','5657','9.99','2005-07-10T07:33:43.000','2006-02-15T22:20:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13690','508','2','5978','6.99','2005-07-11T00:16:54.000','2006-02-15T22:20:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13691','508','1','6101','4.99','2005-07-11T06:50:33.000','2006-02-15T22:20:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13692','508','2','6646','0.99','2005-07-12T10:41:34.000','2006-02-15T22:20:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13693','508','2','6929','8.99','2005-07-26T22:59:19.000','2006-02-15T22:20:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13694','508','1','7283','5.99','2005-07-27T12:02:41.000','2006-02-15T22:20:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13695','508','2','7322','3.99','2005-07-27T13:37:26.000','2006-02-15T22:20:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13696','508','2','7327','7.99','2005-07-27T13:53:26.000','2006-02-15T22:20:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13697','508','2','7668','2.99','2005-07-28T02:41:31.000','2006-02-15T22:20:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13698','508','2','7676','4.99','2005-07-28T02:55:27.000','2006-02-15T22:20:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13699','508','2','8191','4.99','2005-07-28T22:47:14.000','2006-02-15T22:20:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13700','508','2','9694','5.99','2005-07-31T07:13:16.000','2006-02-15T22:20:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13701','508','1','9706','2.99','2005-07-31T07:43:19.000','2006-02-15T22:20:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13702','508','2','10128','2.99','2005-07-31T21:40:04.000','2006-02-15T22:20:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13703','508','1','10746','8.99','2005-08-01T19:58:49.000','2006-02-15T22:20:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13704','508','1','11365','2.99','2005-08-02T18:00:09.000','2006-02-15T22:20:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13705','508','2','11447','6.99','2005-08-02T20:36:25.000','2006-02-15T22:20:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13706','508','1','13095','6.99','2005-08-19T10:48:10.000','2006-02-15T22:20:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13707','508','2','13201','2.99','2005-08-19T14:56:05.000','2006-02-15T22:20:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13708','508','1','15010','6.99','2005-08-22T08:30:17.000','2006-02-15T22:20:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13709','508','1','15195','4.99','2005-08-22T16:08:23.000','2006-02-15T22:20:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13710','508','1','14318','0.99','2006-02-14T15:16:03.000','2006-02-15T22:20:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13711','509','1','22','4.99','2005-05-25T02:19:23.000','2006-02-15T22:20:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13712','509','1','831','8.99','2005-05-29T22:50:25.000','2006-02-15T22:20:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13713','509','1','1267','2.99','2005-06-15T07:21:21.000','2006-02-15T22:20:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13714','509','2','2919','4.99','2005-06-20T04:10:16.000','2006-02-15T22:20:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13715','509','2','4139','1.99','2005-07-07T08:17:35.000','2006-02-15T22:20:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13716','509','2','4266','4.99','2005-07-07T14:34:50.000','2006-02-15T22:20:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13717','509','2','4832','2.99','2005-07-08T18:07:05.000','2006-02-15T22:20:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13718','509','2','5008','2.99','2005-07-09T01:31:42.000','2006-02-15T22:20:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13719','509','1','6591','5.99','2005-07-12T07:13:46.000','2006-02-15T22:20:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13720','509','1','7848','6.99','2005-07-28T09:24:31.000','2006-02-15T22:20:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13721','509','1','8114','8.99','2005-07-28T19:14:06.000','2006-02-15T22:20:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13722','509','1','8214','5.99','2005-07-28T23:37:57.000','2006-02-15T22:20:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13723','509','2','8240','0.99','2005-07-29T00:33:32.000','2006-02-15T22:20:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13724','509','1','10189','4.99','2005-08-01T00:25:00.000','2006-02-15T22:20:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13725','509','2','10988','5.99','2005-08-02T04:38:17.000','2006-02-15T22:20:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13726','509','1','11814','6.99','2005-08-17T12:09:20.000','2006-02-15T22:20:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13727','509','2','12109','4.99','2005-08-17T22:58:35.000','2006-02-15T22:20:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13728','509','2','14045','4.99','2005-08-20T21:50:11.000','2006-02-15T22:20:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13729','509','2','14994','5.99','2005-08-22T07:52:24.000','2006-02-15T22:20:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13730','509','1','15965','2.99','2005-08-23T19:46:39.000','2006-02-15T22:20:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13731','510','1','75','8.99','2005-05-25T11:13:34.000','2006-02-15T22:20:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13732','510','1','372','5.99','2005-05-27T08:13:58.000','2006-02-15T22:20:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13733','510','2','1118','4.99','2005-05-31T16:23:02.000','2006-02-15T22:20:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13734','510','2','1435','5.99','2005-06-15T18:32:30.000','2006-02-15T22:20:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13735','510','2','1757','0.99','2005-06-16T17:32:24.000','2006-02-15T22:20:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13736','510','2','1925','0.99','2005-06-17T06:16:47.000','2006-02-15T22:20:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13737','510','1','2729','8.99','2005-06-19T15:06:15.000','2006-02-15T22:20:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13738','510','2','2806','0.99','2005-06-19T19:30:48.000','2006-02-15T22:20:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13739','510','2','2817','0.99','2005-06-19T20:05:22.000','2006-02-15T22:20:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13740','510','2','3352','8.99','2005-06-21T11:26:29.000','2006-02-15T22:20:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13741','510','2','3465','5.99','2005-06-21T22:10:01.000','2006-02-15T22:20:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13742','510','2','3744','2.99','2005-07-06T12:10:02.000','2006-02-15T22:20:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13743','510','1','4014','4.99','2005-07-07T00:58:54.000','2006-02-15T22:20:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13744','510','2','5851','4.99','2005-07-10T17:40:47.000','2006-02-15T22:20:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13745','510','1','6531','1.99','2005-07-12T04:35:24.000','2006-02-15T22:20:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13746','510','1','7457','2.99','2005-07-27T18:35:17.000','2006-02-15T22:20:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13747','510','1','7678','8.99','2005-07-28T02:58:16.000','2006-02-15T22:20:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13748','510','2','7794','9.99','2005-07-28T07:28:03.000','2006-02-15T22:20:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13749','510','2','8763','3.99','2005-07-29T19:38:24.000','2006-02-15T22:20:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13750','510','1','8926','4.99','2005-07-30T02:10:31.000','2006-02-15T22:20:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13751','510','1','10131','0.99','2005-07-31T21:45:28.000','2006-02-15T22:20:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13752','510','2','10265','7.99','2005-08-01T03:05:04.000','2006-02-15T22:20:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13753','510','2','11996','4.99','2005-08-17T18:34:37.000','2006-02-15T22:20:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13754','510','1','12317','0.99','2005-08-18T06:17:06.000','2006-02-15T22:20:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13755','510','2','12406','2.99','2005-08-18T09:38:02.000','2006-02-15T22:20:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13756','510','1','15065','4.99','2005-08-22T10:46:44.000','2006-02-15T22:20:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13757','511','1','56','2.99','2005-05-25T08:28:11.000','2006-02-15T22:20:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13758','511','1','819','3.99','2005-05-29T21:00:32.000','2006-02-15T22:20:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13759','511','2','1281','2.99','2005-06-15T08:21:39.000','2006-02-15T22:20:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13760','511','1','1508','2.99','2005-06-15T22:33:24.000','2006-02-15T22:20:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13761','511','2','2966','10.99','2005-06-20T07:39:33.000','2006-02-15T22:20:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13762','511','2','3366','4.99','2005-06-21T13:03:37.000','2006-02-15T22:20:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13763','511','2','3600','4.99','2005-07-06T05:19:42.000','2006-02-15T22:20:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13764','511','1','3852','0.99','2005-07-06T16:57:49.000','2006-02-15T22:20:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13765','511','1','4482','4.99','2005-07-08T01:01:18.000','2006-02-15T22:20:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13766','511','2','5164','3.99','2005-07-09T09:03:14.000','2006-02-15T22:20:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13767','511','1','5601','0.99','2005-07-10T04:56:55.000','2006-02-15T22:20:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13768','511','2','6040','0.99','2005-07-11T03:14:26.000','2006-02-15T22:20:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13769','511','1','6320','0.99','2005-07-11T18:50:55.000','2006-02-15T22:20:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13770','511','1','8026','4.99','2005-07-28T16:05:38.000','2006-02-15T22:20:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13771','511','1','9095','0.99','2005-07-30T08:38:36.000','2006-02-15T22:20:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13772','511','1','9143','6.99','2005-07-30T10:22:11.000','2006-02-15T22:20:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13773','511','1','9760','4.99','2005-07-31T09:29:33.000','2006-02-15T22:20:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13774','511','1','10231','2.99','2005-08-01T01:50:49.000','2006-02-15T22:20:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13775','511','2','10429','2.99','2005-08-01T08:34:18.000','2006-02-15T22:20:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13776','511','2','12110','6.99','2005-08-17T22:59:46.000','2006-02-15T22:20:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13777','511','1','12920','4.99','2005-08-19T04:32:32.000','2006-02-15T22:20:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13778','511','1','14213','4.99','2005-08-21T04:30:47.000','2006-02-15T22:20:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13779','511','1','14302','6.99','2005-08-21T07:19:57.000','2006-02-15T22:20:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13780','511','1','15172','4.99','2005-08-22T15:25:33.000','2006-02-15T22:20:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13781','512','1','1176','6.99','2005-06-15T00:28:37.000','2006-02-15T22:20:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13782','512','2','2029','4.99','2005-06-17T13:10:59.000','2006-02-15T22:20:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13783','512','1','2364','2.99','2005-06-18T13:37:32.000','2006-02-15T22:20:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13784','512','1','4752','5.99','2005-07-08T14:15:20.000','2006-02-15T22:20:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13785','512','1','4799','0.99','2005-07-08T16:49:27.000','2006-02-15T22:20:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13786','512','1','5064','6.99','2005-07-09T04:38:51.000','2006-02-15T22:20:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13787','512','2','5813','3.99','2005-07-10T15:34:37.000','2006-02-15T22:20:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13788','512','1','7219','2.99','2005-07-27T09:35:36.000','2006-02-15T22:20:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13789','512','1','7507','0.99','2005-07-27T20:31:48.000','2006-02-15T22:20:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13790','512','1','7715','6.99','2005-07-28T04:32:38.000','2006-02-15T22:20:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13791','512','2','8868','4.99','2005-07-30T00:02:26.000','2006-02-15T22:20:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13792','512','1','9055','2.99','2005-07-30T07:13:07.000','2006-02-15T22:20:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13793','512','2','10232','4.99','2005-08-01T01:50:55.000','2006-02-15T22:20:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13794','512','2','10670','3.99','2005-08-01T17:07:16.000','2006-02-15T22:20:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13795','512','2','11818','9.99','2005-08-17T12:22:04.000','2006-02-15T22:20:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13796','512','2','12957','8.99','2005-08-19T06:12:44.000','2006-02-15T22:20:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13797','512','2','13156','4.99','2005-08-19T13:10:42.000','2006-02-15T22:20:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13798','512','2','13771','0.99','2005-08-20T11:47:21.000','2006-02-15T22:20:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13799','512','1','14288','4.99','2005-08-21T06:57:34.000','2006-02-15T22:20:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13800','512','1','14870','2.99','2005-08-22T03:23:20.000','2006-02-15T22:20:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13801','512','1','15153','2.99','2005-08-22T14:26:01.000','2006-02-15T22:20:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13802','512','2','15265','3.99','2005-08-22T18:35:59.000','2006-02-15T22:20:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13803','512','1','15317','3.99','2005-08-22T20:14:13.000','2006-02-15T22:20:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13804','512','2','15733','4.99','2005-08-23T11:37:32.000','2006-02-15T22:20:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13805','512','2','15990','4.99','2005-08-23T20:25:11.000','2006-02-15T22:20:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13806','512','1','12786','0.99','2006-02-14T15:16:03.000','2006-02-15T22:20:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13807','513','2','993','4.99','2005-05-30T23:54:19.000','2006-02-15T22:20:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13808','513','1','1607','2.99','2005-06-16T06:25:35.000','2006-02-15T22:20:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13809','513','2','2290','7.99','2005-06-18T07:34:37.000','2006-02-15T22:20:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13810','513','2','2737','1.99','2005-06-19T15:48:33.000','2006-02-15T22:20:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13811','513','2','3872','0.99','2005-07-06T18:00:19.000','2006-02-15T22:20:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13812','513','2','4055','2.99','2005-07-07T03:49:13.000','2006-02-15T22:20:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13813','513','2','4178','4.99','2005-07-07T10:14:31.000','2006-02-15T22:20:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13814','513','2','4220','4.99','2005-07-07T12:12:36.000','2006-02-15T22:20:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13815','513','1','5741','7.99','2005-07-10T11:55:40.000','2006-02-15T22:20:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13816','513','1','6027','4.99','2005-07-11T02:26:29.000','2006-02-15T22:20:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13817','513','1','7655','0.99','2005-07-28T02:01:11.000','2006-02-15T22:20:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13818','513','2','8320','4.99','2005-07-29T03:49:58.000','2006-02-15T22:20:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13819','513','1','8350','4.99','2005-07-29T04:50:39.000','2006-02-15T22:20:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13820','513','2','8683','9.99','2005-07-29T16:15:43.000','2006-02-15T22:20:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13821','513','1','8798','5.99','2005-07-29T21:15:38.000','2006-02-15T22:20:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13822','513','2','9862','2.99','2005-07-31T13:05:03.000','2006-02-15T22:20:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13823','513','1','10012','3.99','2005-07-31T18:06:06.000','2006-02-15T22:20:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13824','513','2','11081','2.99','2005-08-02T07:30:14.000','2006-02-15T22:20:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13825','513','1','11165','2.99','2005-08-02T10:12:17.000','2006-02-15T22:20:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13826','513','1','11407','3.99','2005-08-02T19:18:43.000','2006-02-15T22:20:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13827','513','1','11755','3.99','2005-08-17T09:15:35.000','2006-02-15T22:20:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13828','513','1','12559','5.99','2005-08-18T14:53:58.000','2006-02-15T22:20:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13829','513','2','12784','2.99','2005-08-19T00:02:46.000','2006-02-15T22:20:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13830','513','2','12807','4.99','2005-08-19T00:38:46.000','2006-02-15T22:20:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13831','513','1','13596','5.99','2005-08-20T05:58:58.000','2006-02-15T22:20:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13832','513','1','13690','4.99','2005-08-20T09:07:27.000','2006-02-15T22:20:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13833','513','2','14844','7.99','2005-08-22T02:09:12.000','2006-02-15T22:20:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13834','513','1','14875','4.99','2005-08-22T03:34:39.000','2006-02-15T22:20:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13835','513','1','15035','4.99','2005-08-22T09:34:32.000','2006-02-15T22:20:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13836','513','2','15289','6.99','2005-08-22T19:27:24.000','2006-02-15T22:20:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13837','513','2','15545','5.99','2005-08-23T04:20:16.000','2006-02-15T22:20:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13838','514','2','536','4.99','2005-05-28T06:17:33.000','2006-02-15T22:20:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13839','514','2','1692','4.99','2005-06-16T12:30:19.000','2006-02-15T22:20:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13840','514','1','2002','3.99','2005-06-17T11:39:58.000','2006-02-15T22:20:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13841','514','2','2362','0.99','2005-06-18T13:31:15.000','2006-02-15T22:20:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13842','514','1','2789','0.99','2005-06-19T18:48:21.000','2006-02-15T22:20:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13843','514','2','3084','2.99','2005-06-20T15:35:24.000','2006-02-15T22:20:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13844','514','1','3385','0.99','2005-06-21T14:16:48.000','2006-02-15T22:20:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13845','514','2','3668','5.99','2005-07-06T08:36:48.000','2006-02-15T22:20:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13846','514','2','3860','2.99','2005-07-06T17:20:24.000','2006-02-15T22:20:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13847','514','1','7791','4.99','2005-07-28T07:22:51.000','2006-02-15T22:20:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13848','514','1','9038','3.99','2005-07-30T06:23:35.000','2006-02-15T22:20:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13849','514','1','11675','1.99','2005-08-17T05:57:54.000','2006-02-15T22:20:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13850','514','2','12067','4.99','2005-08-17T21:36:47.000','2006-02-15T22:20:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13851','514','1','12293','4.99','2005-08-18T05:13:36.000','2006-02-15T22:20:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13852','514','1','12302','4.99','2005-08-18T05:41:39.000','2006-02-15T22:20:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13853','514','2','12578','0.99','2005-08-18T15:47:11.000','2006-02-15T22:20:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13854','514','1','12752','2.99','2005-08-18T22:33:36.000','2006-02-15T22:20:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13855','514','2','13344','3.99','2005-08-19T20:22:44.000','2006-02-15T22:20:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13856','514','1','14052','0.99','2005-08-20T22:11:46.000','2006-02-15T22:20:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13857','514','1','14386','1.99','2005-08-21T10:06:34.000','2006-02-15T22:20:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13858','514','1','15451','2.99','2005-08-23T00:56:27.000','2006-02-15T22:20:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13859','514','1','15776','5.99','2005-08-23T13:26:01.000','2006-02-15T22:20:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13860','515','2','187','8.99','2005-05-26T05:42:37.000','2006-02-15T22:20:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13861','515','2','292','6.99','2005-05-26T20:22:12.000','2006-02-15T22:20:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13862','515','1','1244','4.99','2005-06-15T05:08:40.000','2006-02-15T22:20:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13863','515','2','1531','5.99','2005-06-16T00:40:34.000','2006-02-15T22:20:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13864','515','2','2003','4.99','2005-06-17T11:40:35.000','2006-02-15T22:20:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13865','515','2','2484','4.99','2005-06-18T21:25:23.000','2006-02-15T22:20:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13866','515','2','2513','0.99','2005-06-18T23:53:15.000','2006-02-15T22:20:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13867','515','2','3063','3.99','2005-06-20T13:52:03.000','2006-02-15T22:20:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13868','515','2','3782','0.99','2005-07-06T13:57:03.000','2006-02-15T22:20:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13869','515','2','4111','6.99','2005-07-07T06:47:56.000','2006-02-15T22:20:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13870','515','2','5216','0.99','2005-07-09T11:54:58.000','2006-02-15T22:20:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13871','515','2','5546','2.99','2005-07-10T02:50:37.000','2006-02-15T22:20:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13872','515','2','5697','4.99','2005-07-10T09:44:44.000','2006-02-15T22:20:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13873','515','2','7429','3.99','2005-07-27T17:24:50.000','2006-02-15T22:20:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13874','515','1','8706','4.99','2005-07-29T17:19:15.000','2006-02-15T22:20:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13875','515','1','10159','4.99','2005-07-31T22:54:30.000','2006-02-15T22:20:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13876','515','2','10716','0.99','2005-08-01T18:53:48.000','2006-02-15T22:20:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13877','515','1','11451','3.99','2005-08-02T20:45:56.000','2006-02-15T22:20:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13878','515','2','11572','4.99','2005-08-17T01:37:55.000','2006-02-15T22:20:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13879','515','1','11691','3.99','2005-08-17T06:51:05.000','2006-02-15T22:20:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13880','515','2','11937','6.99','2005-08-17T16:48:36.000','2006-02-15T22:20:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13881','515','2','12416','2.99','2005-08-18T09:56:48.000','2006-02-15T22:20:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13882','515','1','12486','8.99','2005-08-18T12:42:50.000','2006-02-15T22:20:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13883','515','1','12889','5.99','2005-08-19T03:41:31.000','2006-02-15T22:20:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13884','515','2','14072','4.99','2005-08-20T23:07:10.000','2006-02-15T22:20:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13885','515','2','14378','3.99','2005-08-21T09:50:02.000','2006-02-15T22:20:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13886','515','2','14414','0.99','2005-08-21T11:08:17.000','2006-02-15T22:20:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13887','515','2','15274','4.99','2005-08-22T18:55:52.000','2006-02-15T22:20:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13888','516','2','339','3.99','2005-05-27T03:47:18.000','2006-02-15T22:20:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13889','516','1','571','1.99','2005-05-28T10:17:41.000','2006-02-15T22:20:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13890','516','2','1159','4.99','2005-06-14T22:55:13.000','2006-02-15T22:20:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13891','516','1','1200','1.99','2005-06-15T01:59:51.000','2006-02-15T22:20:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13892','516','1','1718','10.99','2005-06-16T14:52:02.000','2006-02-15T22:20:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13893','516','1','2017','0.99','2005-06-17T12:33:30.000','2006-02-15T22:20:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13894','516','2','3068','0.99','2005-06-20T14:02:22.000','2006-02-15T22:20:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13895','516','1','3431','2.99','2005-06-21T18:46:48.000','2006-02-15T22:20:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13896','516','2','5780','3.99','2005-07-10T13:46:23.000','2006-02-15T22:20:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13897','516','2','6677','6.99','2005-07-12T11:58:14.000','2006-02-15T22:20:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13898','516','1','6858','6.99','2005-07-12T19:53:51.000','2006-02-15T22:20:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13899','516','1','7628','4.99','2005-07-28T00:58:04.000','2006-02-15T22:20:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13900','516','1','7882','4.99','2005-07-28T10:33:42.000','2006-02-15T22:20:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13901','516','2','8396','4.99','2005-07-29T06:07:00.000','2006-02-15T22:20:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13902','516','2','8534','5.99','2005-07-29T10:30:13.000','2006-02-15T22:20:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13903','516','2','8585','2.99','2005-07-29T12:14:18.000','2006-02-15T22:20:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13904','516','2','9243','4.99','2005-07-30T14:06:27.000','2006-02-15T22:20:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13905','516','2','11926','0.99','2005-08-17T16:25:02.000','2006-02-15T22:20:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13906','516','2','11939','1.99','2005-08-17T16:55:57.000','2006-02-15T22:20:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13907','516','1','12535','1.99','2005-08-18T14:05:22.000','2006-02-15T22:20:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13908','516','1','13276','8.99','2005-08-19T17:53:42.000','2006-02-15T22:20:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13909','516','1','14932','0.99','2005-08-22T05:40:39.000','2006-02-15T22:20:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13910','516','1','15526','0.99','2005-08-23T03:44:30.000','2006-02-15T22:20:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13911','516','1','15701','0.99','2005-08-23T10:22:21.000','2006-02-15T22:20:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13912','516','1','12130','5.98','2006-02-14T15:16:03.000','2006-02-15T22:20:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13913','516','1','12915','0','2006-02-14T15:16:03.000','2006-02-15T22:20:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13914','517','2','850','4.99','2005-05-30T01:35:12.000','2006-02-15T22:20:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13915','517','2','1653','4.99','2005-06-16T09:34:45.000','2006-02-15T22:20:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13916','517','1','1809','8.99','2005-06-16T21:00:20.000','2006-02-15T22:20:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13917','517','1','1850','4.99','2005-06-17T00:31:35.000','2006-02-15T22:20:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13918','517','2','2534','2.99','2005-06-19T01:38:39.000','2006-02-15T22:20:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13919','517','1','3113','0.99','2005-06-20T17:56:40.000','2006-02-15T22:20:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13920','517','2','4094','2.99','2005-07-07T06:00:21.000','2006-02-15T22:20:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13921','517','1','4109','4.99','2005-07-07T06:39:43.000','2006-02-15T22:20:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13922','517','1','4369','4.99','2005-07-07T20:01:38.000','2006-02-15T22:20:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13923','517','2','4374','4.99','2005-07-07T20:13:58.000','2006-02-15T22:20:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13924','517','2','4934','0.99','2005-07-08T22:18:42.000','2006-02-15T22:20:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13925','517','1','4993','2.99','2005-07-09T00:49:47.000','2006-02-15T22:20:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13926','517','1','5206','7.99','2005-07-09T11:11:01.000','2006-02-15T22:20:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13927','517','2','5974','5.99','2005-07-11T00:10:37.000','2006-02-15T22:20:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13928','517','2','6594','4.99','2005-07-12T07:25:43.000','2006-02-15T22:20:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13929','517','2','6903','0.99','2005-07-12T21:58:15.000','2006-02-15T22:20:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13930','517','2','7988','3.99','2005-07-28T14:37:18.000','2006-02-15T22:20:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13931','517','1','10063','4.99','2005-07-31T19:25:13.000','2006-02-15T22:20:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13932','517','2','10358','4.99','2005-08-01T05:50:07.000','2006-02-15T22:20:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13933','517','2','10433','4.99','2005-08-01T08:45:56.000','2006-02-15T22:20:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13934','517','1','11684','3.99','2005-08-17T06:27:15.000','2006-02-15T22:20:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13935','517','2','12705','0.99','2005-08-18T20:44:14.000','2006-02-15T22:20:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13936','517','1','13396','0.99','2005-08-19T22:06:09.000','2006-02-15T22:20:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13937','517','2','14190','4.99','2005-08-21T03:35:21.000','2006-02-15T22:20:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13938','517','1','15559','5.99','2005-08-23T04:55:05.000','2006-02-15T22:20:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13939','518','1','710','2.99','2005-05-29T03:48:36.000','2006-02-15T22:20:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13940','518','2','1552','5.99','2005-06-16T02:01:37.000','2006-02-15T22:20:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13941','518','2','3311','0.99','2005-06-21T08:05:27.000','2006-02-15T22:20:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13942','518','1','3652','0.99','2005-07-06T07:44:30.000','2006-02-15T22:20:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13943','518','2','4029','7.99','2005-07-07T02:19:44.000','2006-02-15T22:20:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13944','518','2','4661','4.99','2005-07-08T09:55:06.000','2006-02-15T22:20:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13945','518','2','4948','6.99','2005-07-08T22:54:21.000','2006-02-15T22:20:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13946','518','1','6652','2.99','2005-07-12T10:59:38.000','2006-02-15T22:20:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13947','518','1','6957','2.99','2005-07-27T00:00:00.000','2006-02-15T22:20:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13948','518','2','7038','3.99','2005-07-27T03:07:29.000','2006-02-15T22:20:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13949','518','2','7154','4.99','2005-07-27T07:16:17.000','2006-02-15T22:20:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13950','518','2','7382','2.99','2005-07-27T15:43:15.000','2006-02-15T22:20:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13951','518','1','7657','2.99','2005-07-28T02:09:00.000','2006-02-15T22:20:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13952','518','2','7839','6.99','2005-07-28T09:01:13.000','2006-02-15T22:20:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13953','518','1','8107','3.99','2005-07-28T19:03:16.000','2006-02-15T22:20:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13954','518','1','8397','2.99','2005-07-29T06:09:35.000','2006-02-15T22:20:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13955','518','1','10751','5.99','2005-08-01T20:06:10.000','2006-02-15T22:20:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13956','518','2','11433','3.99','2005-08-02T20:13:10.000','2006-02-15T22:20:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13957','518','2','12450','2.99','2005-08-18T11:04:04.000','2006-02-15T22:20:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13958','518','2','12681','2.99','2005-08-18T19:48:06.000','2006-02-15T22:20:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13959','518','1','13065','4.99','2005-08-19T09:48:52.000','2006-02-15T22:20:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13960','518','1','13539','6.99','2005-08-20T03:40:27.000','2006-02-15T22:20:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13961','518','1','14088','6.99','2005-08-20T23:57:24.000','2006-02-15T22:20:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13962','518','1','14149','4.99','2005-08-21T02:22:47.000','2006-02-15T22:20:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13963','518','2','14980','0.99','2005-08-22T07:16:45.000','2006-02-15T22:20:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13964','518','2','15434','4.99','2005-08-23T00:28:16.000','2006-02-15T22:20:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13965','519','1','1056','3.99','2005-05-31T07:48:07.000','2006-02-15T22:20:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13966','519','1','1941','2.99','2005-06-17T07:42:45.000','2006-02-15T22:20:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13967','519','2','2505','8.99','2005-06-18T23:28:27.000','2006-02-15T22:20:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13968','519','2','2997','5.99','2005-06-20T09:23:45.000','2006-02-15T22:20:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13969','519','2','4564','0.99','2005-07-08T05:09:38.000','2006-02-15T22:20:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13970','519','2','4773','2.99','2005-07-08T15:41:39.000','2006-02-15T22:20:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13971','519','2','5236','0.99','2005-07-09T12:56:29.000','2006-02-15T22:20:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13972','519','2','5547','5.99','2005-07-10T02:52:47.000','2006-02-15T22:20:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13973','519','2','6063','0.99','2005-07-11T04:16:51.000','2006-02-15T22:20:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13974','519','1','6599','3.99','2005-07-12T07:41:14.000','2006-02-15T22:20:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13975','519','1','9417','6.99','2005-07-30T20:54:55.000','2006-02-15T22:20:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13976','519','2','9441','4.99','2005-07-30T21:43:28.000','2006-02-15T22:20:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13977','519','2','9534','7.99','2005-07-31T01:18:27.000','2006-02-15T22:20:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13978','519','2','9645','0.99','2005-07-31T05:42:49.000','2006-02-15T22:20:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13979','519','2','9886','7.99','2005-07-31T14:00:13.000','2006-02-15T22:20:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13980','519','1','9905','0.99','2005-07-31T14:37:03.000','2006-02-15T22:20:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13981','519','1','10097','5.99','2005-07-31T20:39:38.000','2006-02-15T22:20:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13982','519','2','10697','4.99','2005-08-01T18:20:23.000','2006-02-15T22:20:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13983','519','2','12648','7.99','2005-08-18T18:30:21.000','2006-02-15T22:20:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13984','519','2','12924','2.99','2005-08-19T04:51:47.000','2006-02-15T22:20:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13985','519','1','13647','7.99','2005-08-20T07:48:07.000','2006-02-15T22:20:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13986','519','1','14182','2.99','2005-08-21T03:17:10.000','2006-02-15T22:20:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13987','519','2','15347','2.99','2005-08-22T21:12:19.000','2006-02-15T22:20:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13988','520','1','962','6.99','2005-05-30T18:45:17.000','2006-02-15T22:20:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13989','520','1','1411','0.99','2005-06-15T17:05:36.000','2006-02-15T22:20:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13990','520','2','2174','6.99','2005-06-18T00:09:01.000','2006-02-15T22:20:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13991','520','1','2772','4.99','2005-06-19T17:59:27.000','2006-02-15T22:20:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13992','520','2','3482','4.99','2005-07-05T23:13:22.000','2006-02-15T22:20:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13993','520','1','3499','7.99','2005-07-06T00:04:20.000','2006-02-15T22:20:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13994','520','2','4346','2.99','2005-07-07T18:58:45.000','2006-02-15T22:20:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13995','520','2','5799','4.99','2005-07-10T14:53:35.000','2006-02-15T22:20:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13996','520','1','5802','10.99','2005-07-10T15:02:17.000','2006-02-15T22:20:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13997','520','1','5853','3.99','2005-07-10T17:45:13.000','2006-02-15T22:20:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13998','520','1','6029','2.99','2005-07-11T02:36:46.000','2006-02-15T22:20:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('13999','520','2','7198','5.99','2005-07-27T08:50:07.000','2006-02-15T22:20:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14000','520','1','7720','4.99','2005-07-28T04:41:44.000','2006-02-15T22:20:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14001','520','1','7936','0.99','2005-07-28T12:33:21.000','2006-02-15T22:20:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14002','520','1','8294','2.99','2005-07-29T02:32:41.000','2006-02-15T22:20:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14003','520','2','8435','2.99','2005-07-29T07:20:16.000','2006-02-15T22:20:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14004','520','1','9803','2.99','2005-07-31T11:06:02.000','2006-02-15T22:20:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14005','520','1','10072','0.99','2005-07-31T19:50:37.000','2006-02-15T22:20:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14006','520','2','10530','4.99','2005-08-01T12:01:17.000','2006-02-15T22:20:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14007','520','1','11566','0.99','2005-08-17T01:28:35.000','2006-02-15T22:20:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14008','520','1','12517','4.99','2005-08-18T13:40:20.000','2006-02-15T22:20:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14009','520','1','12628','5.99','2005-08-18T17:40:25.000','2006-02-15T22:20:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14010','520','1','12647','5.99','2005-08-18T18:29:51.000','2006-02-15T22:20:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14011','520','1','13311','0.99','2005-08-19T19:07:09.000','2006-02-15T22:20:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14012','520','2','13438','2.99','2005-08-19T23:38:02.000','2006-02-15T22:20:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14013','520','2','13659','2.99','2005-08-20T08:05:52.000','2006-02-15T22:20:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14014','520','2','13746','5.99','2005-08-20T10:55:28.000','2006-02-15T22:20:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14015','520','1','14372','4.99','2005-08-21T09:39:50.000','2006-02-15T22:20:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14016','520','1','14509','0.99','2005-08-21T14:39:58.000','2006-02-15T22:20:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14017','520','1','15465','0.99','2005-08-23T01:16:33.000','2006-02-15T22:20:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14018','520','2','15492','2.99','2005-08-23T02:13:46.000','2006-02-15T22:20:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14019','520','1','15948','7.99','2005-08-23T18:59:33.000','2006-02-15T22:20:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14020','521','1','1761','0.99','2005-06-16T17:49:57.000','2006-02-15T22:20:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14021','521','2','2053','0.99','2005-06-17T15:19:34.000','2006-02-15T22:20:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14022','521','2','4284','0.99','2005-07-07T15:31:57.000','2006-02-15T22:20:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14023','521','2','4439','2.99','2005-07-07T22:57:30.000','2006-02-15T22:20:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14024','521','1','5276','2.99','2005-07-09T14:35:13.000','2006-02-15T22:20:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14025','521','2','5458','4.99','2005-07-09T22:35:49.000','2006-02-15T22:20:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14026','521','2','5580','6.99','2005-07-10T04:05:49.000','2006-02-15T22:20:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14027','521','2','5686','0.99','2005-07-10T09:06:03.000','2006-02-15T22:20:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14028','521','1','7478','1.99','2005-07-27T19:16:02.000','2006-02-15T22:20:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14029','521','1','9556','7.99','2005-07-31T02:13:30.000','2006-02-15T22:20:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14030','521','2','9937','1.99','2005-07-31T15:28:10.000','2006-02-15T22:20:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14031','521','1','10587','2.99','2005-08-01T14:03:38.000','2006-02-15T22:20:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14032','521','2','11625','2.99','2005-08-17T04:18:52.000','2006-02-15T22:20:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14033','521','1','11967','3.99','2005-08-17T17:45:00.000','2006-02-15T22:20:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14034','521','2','12082','4.99','2005-08-17T22:13:15.000','2006-02-15T22:20:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14035','521','1','12530','4.99','2005-08-18T13:54:48.000','2006-02-15T22:20:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14036','521','1','13527','2.99','2005-08-20T03:00:47.000','2006-02-15T22:20:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14037','521','1','14423','0.99','2005-08-21T11:23:59.000','2006-02-15T22:20:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14038','521','2','14551','3.99','2005-08-21T15:57:25.000','2006-02-15T22:20:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14039','521','2','14738','5.99','2005-08-21T22:29:13.000','2006-02-15T22:20:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14040','521','2','15170','4.99','2005-08-22T15:22:15.000','2006-02-15T22:20:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14041','521','2','15329','2.99','2005-08-22T20:32:39.000','2006-02-15T22:20:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14042','521','2','11672','4.99','2006-02-14T15:16:03.000','2006-02-15T22:20:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14043','522','2','426','5.99','2005-05-27T15:56:57.000','2006-02-15T22:20:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14044','522','1','1289','3.99','2005-06-15T08:44:09.000','2006-02-15T22:20:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14045','522','2','3102','8.99','2005-06-20T16:55:55.000','2006-02-15T22:20:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14046','522','1','3188','2.99','2005-06-20T23:10:27.000','2006-02-15T22:20:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14047','522','2','3191','0.99','2005-06-20T23:46:39.000','2006-02-15T22:20:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14048','522','1','3594','0.99','2005-07-06T04:42:47.000','2006-02-15T22:20:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14049','522','2','4078','4.99','2005-07-07T05:05:05.000','2006-02-15T22:20:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14050','522','2','4563','9.99','2005-07-08T05:08:55.000','2006-02-15T22:20:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14051','522','2','4701','4.99','2005-07-08T11:38:48.000','2006-02-15T22:20:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14052','522','2','5271','6.99','2005-07-09T14:25:01.000','2006-02-15T22:20:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14053','522','2','5514','6.99','2005-07-10T01:09:42.000','2006-02-15T22:20:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14054','522','2','5532','4.99','2005-07-10T02:17:31.000','2006-02-15T22:20:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14055','522','2','5936','0.99','2005-07-10T22:14:30.000','2006-02-15T22:20:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14056','522','2','7262','4.99','2005-07-27T11:15:36.000','2006-02-15T22:20:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14057','522','1','7955','2.99','2005-07-28T13:31:36.000','2006-02-15T22:20:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14058','522','2','8181','4.99','2005-07-28T22:18:38.000','2006-02-15T22:20:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14059','522','1','8642','6.99','2005-07-29T14:38:17.000','2006-02-15T22:20:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14060','522','1','8966','2.99','2005-07-30T03:54:12.000','2006-02-15T22:20:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14061','522','1','9047','7.99','2005-07-30T06:56:33.000','2006-02-15T22:20:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14062','522','2','9227','7.99','2005-07-30T13:36:13.000','2006-02-15T22:20:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14063','522','1','9335','4.99','2005-07-30T18:00:53.000','2006-02-15T22:20:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14064','522','1','9412','5.99','2005-07-30T20:44:10.000','2006-02-15T22:20:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14065','522','2','9533','5.99','2005-07-31T01:18:10.000','2006-02-15T22:20:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14066','522','2','10223','0.99','2005-08-01T01:23:15.000','2006-02-15T22:20:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14067','522','1','10411','3.99','2005-08-01T07:56:32.000','2006-02-15T22:20:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14068','522','1','10675','7.99','2005-08-01T17:11:57.000','2006-02-15T22:20:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14069','522','2','10821','5.99','2005-08-01T22:54:27.000','2006-02-15T22:20:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14070','522','2','11696','2.99','2005-08-17T07:01:09.000','2006-02-15T22:20:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14071','522','2','11830','1.99','2005-08-17T12:53:15.000','2006-02-15T22:20:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14072','522','2','12494','6.99','2005-08-18T12:53:49.000','2006-02-15T22:20:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14073','522','2','13605','6.99','2005-08-20T06:06:17.000','2006-02-15T22:20:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14074','522','2','14467','2.99','2005-08-21T13:03:33.000','2006-02-15T22:20:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14075','522','1','15921','6.99','2005-08-23T18:06:54.000','2006-02-15T22:20:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14076','523','1','42','4.99','2005-05-25T05:24:58.000','2006-02-15T22:20:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14077','523','2','664','0.99','2005-05-28T21:31:08.000','2006-02-15T22:20:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14078','523','2','1729','6.99','2005-06-16T15:29:47.000','2006-02-15T22:20:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14079','523','1','2447','8.99','2005-06-18T19:10:55.000','2006-02-15T22:20:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14080','523','1','2583','7.99','2005-06-19T05:01:40.000','2006-02-15T22:20:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14081','523','2','2669','0.99','2005-06-19T11:28:52.000','2006-02-15T22:20:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14082','523','1','4605','4.99','2005-07-08T07:00:14.000','2006-02-15T22:20:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14083','523','2','5155','2.99','2005-07-09T08:46:54.000','2006-02-15T22:21:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14084','523','1','5287','6.99','2005-07-09T15:11:54.000','2006-02-15T22:21:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14085','523','2','5932','2.99','2005-07-10T22:05:15.000','2006-02-15T22:21:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14086','523','2','6675','4.99','2005-07-12T11:53:06.000','2006-02-15T22:21:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14087','523','2','7642','1.99','2005-07-28T01:16:51.000','2006-02-15T22:21:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14088','523','2','8141','0.99','2005-07-28T20:21:19.000','2006-02-15T22:21:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14089','523','1','8372','5.99','2005-07-29T05:18:08.000','2006-02-15T22:21:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14090','523','1','9071','2.99','2005-07-30T07:40:58.000','2006-02-15T22:21:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14091','523','2','9667','6.99','2005-07-31T06:23:52.000','2006-02-15T22:21:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14092','523','2','10470','1.99','2005-08-01T09:52:26.000','2006-02-15T22:21:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14093','523','1','11827','4.99','2005-08-17T12:44:27.000','2006-02-15T22:21:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14094','523','1','12288','2.99','2005-08-18T05:01:20.000','2006-02-15T22:21:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14095','523','1','13133','2.99','2005-08-19T12:11:03.000','2006-02-15T22:21:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14096','523','1','14766','4.99','2005-08-21T23:42:20.000','2006-02-15T22:21:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14097','523','1','15040','2.99','2005-08-22T09:41:09.000','2006-02-15T22:21:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14098','524','2','118','0.99','2005-05-25T19:31:18.000','2006-02-15T22:21:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14099','524','1','982','4.99','2005-05-30T22:15:24.000','2006-02-15T22:21:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14100','524','1','1306','1.99','2005-06-15T09:59:24.000','2006-02-15T22:21:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14101','524','2','1651','4.99','2005-06-16T09:24:38.000','2006-02-15T22:21:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14102','524','2','3454','2.99','2005-06-21T21:12:13.000','2006-02-15T22:21:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14103','524','1','4366','5.99','2005-07-07T19:48:36.000','2006-02-15T22:21:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14104','524','2','5037','4.99','2005-07-09T02:59:10.000','2006-02-15T22:21:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14105','524','2','6161','4.99','2005-07-11T10:11:54.000','2006-02-15T22:21:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14106','524','1','6240','6.99','2005-07-11T14:32:41.000','2006-02-15T22:21:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14107','524','2','6745','4.99','2005-07-12T14:30:51.000','2006-02-15T22:21:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14108','524','2','7014','8.99','2005-07-27T02:14:40.000','2006-02-15T22:21:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14109','524','1','7040','4.99','2005-07-27T03:17:19.000','2006-02-15T22:21:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14110','524','1','8507','6.99','2005-07-29T09:29:44.000','2006-02-15T22:21:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14111','524','2','13626','2.99','2005-08-20T06:55:24.000','2006-02-15T22:21:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14112','524','2','14046','4.99','2005-08-20T21:53:21.000','2006-02-15T22:21:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14113','524','1','14178','2.99','2005-08-21T03:13:45.000','2006-02-15T22:21:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14114','524','1','14366','2.99','2005-08-21T09:31:39.000','2006-02-15T22:21:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14115','524','2','14680','1.99','2005-08-21T20:19:52.000','2006-02-15T22:21:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14116','524','2','15206','6.99','2005-08-22T16:33:39.000','2006-02-15T22:21:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14117','525','1','437','5.99','2005-05-27T17:47:22.000','2006-02-15T22:21:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14118','525','2','1772','2.99','2005-06-16T18:12:54.000','2006-02-15T22:21:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14119','525','1','3993','6.99','2005-07-06T23:37:06.000','2006-02-15T22:21:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14120','525','1','5841','2.99','2005-07-10T17:11:31.000','2006-02-15T22:21:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14121','525','2','6098','7.99','2005-07-11T06:23:28.000','2006-02-15T22:21:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14122','525','2','6388','6.99','2005-07-11T22:17:16.000','2006-02-15T22:21:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14123','525','1','6689','1.99','2005-07-12T12:22:13.000','2006-02-15T22:21:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14124','525','2','7337','4.99','2005-07-27T14:12:04.000','2006-02-15T22:21:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14125','525','2','7591','4.99','2005-07-27T23:25:54.000','2006-02-15T22:21:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14126','525','1','8007','0.99','2005-07-28T15:22:27.000','2006-02-15T22:21:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14127','525','1','8960','4.99','2005-07-30T03:36:31.000','2006-02-15T22:21:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14128','525','2','9507','5.99','2005-07-31T00:22:29.000','2006-02-15T22:21:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14129','525','1','9702','0.99','2005-07-31T07:34:07.000','2006-02-15T22:21:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14130','525','1','10496','2.99','2005-08-01T10:53:16.000','2006-02-15T22:21:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14131','525','2','11406','2.99','2005-08-02T19:16:10.000','2006-02-15T22:21:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14132','525','1','11660','1.99','2005-08-17T05:22:42.000','2006-02-15T22:21:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14133','525','1','15159','0.99','2005-08-22T14:32:25.000','2006-02-15T22:21:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14134','525','2','15623','3.99','2005-08-23T07:23:29.000','2006-02-15T22:21:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14135','525','1','14954','2.99','2006-02-14T15:16:03.000','2006-02-15T22:21:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14136','526','1','495','4.99','2005-05-28T00:40:48.000','2006-02-15T22:21:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14137','526','2','679','4.99','2005-05-28T23:24:57.000','2006-02-15T22:21:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14138','526','2','1015','2.99','2005-05-31T02:44:57.000','2006-02-15T22:21:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14139','526','1','1255','4.99','2005-06-15T06:13:45.000','2006-02-15T22:21:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14140','526','2','1848','0.99','2005-06-17T00:07:07.000','2006-02-15T22:21:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14141','526','2','1865','7.99','2005-06-17T01:49:36.000','2006-02-15T22:21:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14142','526','2','1972','2.99','2005-06-17T09:25:49.000','2006-02-15T22:21:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14143','526','1','1981','2.99','2005-06-17T10:03:34.000','2006-02-15T22:21:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14144','526','2','2398','4.99','2005-06-18T15:56:53.000','2006-02-15T22:21:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14145','526','1','2828','2.99','2005-06-19T20:51:33.000','2006-02-15T22:21:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14146','526','2','2932','6.99','2005-06-20T04:51:19.000','2006-02-15T22:21:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14147','526','1','3339','6.99','2005-06-21T10:37:11.000','2006-02-15T22:21:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14148','526','1','3619','1.99','2005-07-06T05:59:44.000','2006-02-15T22:21:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14149','526','2','3905','5.99','2005-07-06T19:33:34.000','2006-02-15T22:21:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14150','526','1','4423','6.99','2005-07-07T22:11:28.000','2006-02-15T22:21:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14151','526','2','5056','2.99','2005-07-09T04:13:45.000','2006-02-15T22:21:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14152','526','2','5121','3.99','2005-07-09T07:18:31.000','2006-02-15T22:21:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14153','526','1','6316','7.99','2005-07-11T18:44:52.000','2006-02-15T22:21:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14154','526','1','6404','4.99','2005-07-11T22:49:50.000','2006-02-15T22:21:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14155','526','2','6650','2.99','2005-07-12T10:57:10.000','2006-02-15T22:21:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14156','526','1','6671','3.99','2005-07-12T11:48:48.000','2006-02-15T22:21:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14157','526','2','7270','7.99','2005-07-27T11:29:02.000','2006-02-15T22:21:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14158','526','2','7343','0.99','2005-07-27T14:27:13.000','2006-02-15T22:21:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14159','526','2','7399','1.99','2005-07-27T16:16:02.000','2006-02-15T22:21:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14160','526','2','7543','5.99','2005-07-27T21:44:28.000','2006-02-15T22:21:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14161','526','2','7883','2.99','2005-07-28T10:37:20.000','2006-02-15T22:21:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14162','526','1','8053','4.99','2005-07-28T16:59:41.000','2006-02-15T22:21:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14163','526','1','8232','4.99','2005-07-29T00:14:37.000','2006-02-15T22:21:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14164','526','1','8441','2.99','2005-07-29T07:33:05.000','2006-02-15T22:21:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14165','526','2','9577','6.99','2005-07-31T02:53:33.000','2006-02-15T22:21:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14166','526','2','10020','4.99','2005-07-31T18:21:08.000','2006-02-15T22:21:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14167','526','2','10199','2.99','2005-08-01T00:38:55.000','2006-02-15T22:21:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14168','526','2','11046','4.99','2005-08-02T06:08:34.000','2006-02-15T22:21:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14169','526','1','11503','10.99','2005-08-16T23:10:34.000','2006-02-15T22:21:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14170','526','1','11612','2.99','2005-08-17T03:48:51.000','2006-02-15T22:21:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14171','526','2','11702','4.99','2005-08-17T07:18:56.000','2006-02-15T22:21:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14172','526','1','12607','0.99','2005-08-18T17:03:49.000','2006-02-15T22:21:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14173','526','2','13224','8.99','2005-08-19T15:52:13.000','2006-02-15T22:21:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14174','526','2','13580','0.99','2005-08-20T05:23:34.000','2006-02-15T22:21:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14175','526','1','13617','8.99','2005-08-20T06:35:30.000','2006-02-15T22:21:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14176','526','2','14487','6.99','2005-08-21T13:53:33.000','2006-02-15T22:21:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14177','526','1','14590','7.99','2005-08-21T17:29:10.000','2006-02-15T22:21:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14178','526','1','15168','2.99','2005-08-22T15:14:20.000','2006-02-15T22:21:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14179','526','1','15395','4.99','2005-08-22T23:06:25.000','2006-02-15T22:21:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14180','526','1','16043','9.99','2005-08-23T22:21:03.000','2006-02-15T22:21:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14181','527','1','1398','2.99','2005-06-15T16:28:42.000','2006-02-15T22:21:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14182','527','1','2422','0.99','2005-06-18T17:28:57.000','2006-02-15T22:21:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14183','527','2','2496','0.99','2005-06-18T22:20:11.000','2006-02-15T22:21:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14184','527','1','2539','2.99','2005-06-19T01:58:39.000','2006-02-15T22:21:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14185','527','1','4888','0.99','2005-07-08T20:04:27.000','2006-02-15T22:21:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14186','527','1','5365','0.99','2005-07-09T18:27:00.000','2006-02-15T22:21:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14187','527','2','6003','3.99','2005-07-11T01:28:33.000','2006-02-15T22:21:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14188','527','2','6011','4.99','2005-07-11T01:54:48.000','2006-02-15T22:21:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14189','527','1','6050','2.99','2005-07-11T03:34:29.000','2006-02-15T22:21:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14190','527','2','6975','1.99','2005-07-27T00:39:54.000','2006-02-15T22:21:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14191','527','1','7506','8.99','2005-07-27T20:28:34.000','2006-02-15T22:21:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14192','527','1','8854','0.99','2005-07-29T23:40:07.000','2006-02-15T22:21:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14193','527','2','9750','0.99','2005-07-31T09:19:46.000','2006-02-15T22:21:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14194','527','2','10486','3.99','2005-08-01T10:23:43.000','2006-02-15T22:21:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14195','527','2','10613','0.99','2005-08-01T14:56:14.000','2006-02-15T22:21:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14196','527','1','11013','5.99','2005-08-02T05:10:54.000','2006-02-15T22:21:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14197','527','1','11150','2.99','2005-08-02T09:51:46.000','2006-02-15T22:21:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14198','527','1','11624','0.99','2005-08-17T04:17:42.000','2006-02-15T22:21:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14199','527','1','12136','7.99','2005-08-17T23:51:30.000','2006-02-15T22:21:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14200','527','1','12513','6.99','2005-08-18T13:31:45.000','2006-02-15T22:21:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14201','527','1','14352','6.99','2005-08-21T09:06:29.000','2006-02-15T22:21:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14202','527','1','15144','2.99','2005-08-22T13:49:18.000','2006-02-15T22:21:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14203','527','1','15552','3.99','2005-08-23T04:33:23.000','2006-02-15T22:21:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14204','527','1','14267','2.99','2006-02-14T15:16:03.000','2006-02-15T22:21:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14205','528','1','204','0.99','2005-05-26T07:30:37.000','2006-02-15T22:21:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14206','528','2','472','0.99','2005-05-27T21:36:15.000','2006-02-15T22:21:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14207','528','1','533','5.99','2005-05-28T06:14:46.000','2006-02-15T22:21:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14208','528','2','695','3.99','2005-05-29T01:50:53.000','2006-02-15T22:21:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14209','528','2','793','5.99','2005-05-29T16:44:08.000','2006-02-15T22:21:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14210','528','2','1875','2.99','2005-06-17T02:45:10.000','2006-02-15T22:21:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14211','528','1','2019','4.99','2005-06-17T12:38:44.000','2006-02-15T22:21:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14212','528','2','3654','4.99','2005-07-06T07:45:31.000','2006-02-15T22:21:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14213','528','1','3664','0.99','2005-07-06T08:15:57.000','2006-02-15T22:21:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14214','528','2','4050','9.99','2005-07-07T03:35:33.000','2006-02-15T22:21:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14215','528','1','4593','5.99','2005-07-08T06:38:12.000','2006-02-15T22:21:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14216','528','2','5215','3.99','2005-07-09T11:47:58.000','2006-02-15T22:21:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14217','528','2','6561','0.99','2005-07-12T05:24:02.000','2006-02-15T22:21:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14218','528','1','7569','7.99','2005-07-27T22:38:53.000','2006-02-15T22:21:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14219','528','2','8112','4.99','2005-07-28T19:11:07.000','2006-02-15T22:21:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14220','528','1','8727','3.99','2005-07-29T18:09:57.000','2006-02-15T22:21:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14221','528','2','9488','8.99','2005-07-30T23:42:42.000','2006-02-15T22:21:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14222','528','1','10084','3.99','2005-07-31T20:11:29.000','2006-02-15T22:21:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14223','528','1','10673','0.99','2005-08-01T17:11:51.000','2006-02-15T22:21:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14224','528','1','10880','2.99','2005-08-02T00:34:12.000','2006-02-15T22:21:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14225','528','1','12818','3.99','2005-08-19T01:04:59.000','2006-02-15T22:21:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14226','528','2','13518','2.99','2005-08-20T02:36:17.000','2006-02-15T22:21:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14227','528','1','13600','7.99','2005-08-20T06:00:25.000','2006-02-15T22:21:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14228','528','2','14148','2.99','2005-08-21T02:17:49.000','2006-02-15T22:21:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14229','528','2','15880','6.99','2005-08-23T16:43:54.000','2006-02-15T22:21:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14230','529','1','453','2.99','2005-05-27T19:31:16.000','2006-02-15T22:21:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14231','529','1','1234','1.99','2005-06-15T04:21:52.000','2006-02-15T22:21:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14232','529','2','1686','0.99','2005-06-16T12:08:20.000','2006-02-15T22:21:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14233','529','2','3354','0.99','2005-06-21T11:29:49.000','2006-02-15T22:21:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14234','529','2','4045','0.99','2005-07-07T03:26:14.000','2006-02-15T22:21:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14235','529','2','4254','0.99','2005-07-07T14:13:52.000','2006-02-15T22:21:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14236','529','2','4444','5.99','2005-07-07T23:07:44.000','2006-02-15T22:21:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14237','529','1','4553','0.99','2005-07-08T04:43:41.000','2006-02-15T22:21:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14238','529','1','5993','4.99','2005-07-11T01:06:41.000','2006-02-15T22:21:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14239','529','2','6538','6.99','2005-07-12T04:50:26.000','2006-02-15T22:21:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14240','529','2','6541','5.99','2005-07-12T04:53:41.000','2006-02-15T22:21:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14241','529','1','6908','7.99','2005-07-12T22:08:46.000','2006-02-15T22:21:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14242','529','1','7128','3.99','2005-07-27T06:14:36.000','2006-02-15T22:21:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14243','529','2','8708','2.99','2005-07-29T17:24:13.000','2006-02-15T22:21:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14244','529','1','8979','5.99','2005-07-30T04:20:25.000','2006-02-15T22:21:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14245','529','2','9310','4.99','2005-07-30T16:57:09.000','2006-02-15T22:21:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14246','529','2','9375','0.99','2005-07-30T19:10:17.000','2006-02-15T22:21:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14247','529','2','10361','10.99','2005-08-01T05:53:49.000','2006-02-15T22:21:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14248','529','1','11862','2.99','2005-08-17T13:54:53.000','2006-02-15T22:21:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14249','529','2','12356','2.99','2005-08-18T07:37:05.000','2006-02-15T22:21:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14250','529','1','12622','3.99','2005-08-18T17:34:11.000','2006-02-15T22:21:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14251','529','1','13011','4.99','2005-08-19T07:53:58.000','2006-02-15T22:21:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14252','529','2','13132','3.99','2005-08-19T12:10:57.000','2006-02-15T22:21:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14253','529','1','13797','2.99','2005-08-20T12:33:36.000','2006-02-15T22:21:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14254','529','2','13946','9.99','2005-08-20T17:44:32.000','2006-02-15T22:21:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14255','529','2','14449','4.99','2005-08-21T12:13:18.000','2006-02-15T22:21:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14256','529','2','14764','0.99','2005-08-21T23:37:47.000','2006-02-15T22:21:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14257','529','1','14970','5.99','2005-08-22T06:49:29.000','2006-02-15T22:21:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14258','529','2','15305','2.99','2005-08-22T19:46:05.000','2006-02-15T22:21:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14259','530','1','851','0.99','2005-05-30T01:35:15.000','2006-02-15T22:21:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14260','530','2','1273','1.99','2005-06-15T07:52:35.000','2006-02-15T22:21:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14261','530','1','1516','0.99','2005-06-15T23:11:10.000','2006-02-15T22:21:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14262','530','1','2158','2.99','2005-06-17T23:36:27.000','2006-02-15T22:21:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14263','530','2','3669','2.99','2005-07-06T08:38:29.000','2006-02-15T22:21:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14264','530','2','3887','4.99','2005-07-06T18:46:34.000','2006-02-15T22:21:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14265','530','2','5663','0.99','2005-07-10T08:01:33.000','2006-02-15T22:21:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14266','530','1','7031','3.99','2005-07-27T03:02:07.000','2006-02-15T22:21:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14267','530','2','7075','1.99','2005-07-27T04:11:40.000','2006-02-15T22:21:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14268','530','1','7218','4.99','2005-07-27T09:34:24.000','2006-02-15T22:21:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14269','530','2','8208','4.99','2005-07-28T23:26:35.000','2006-02-15T22:21:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14270','530','1','8736','0.99','2005-07-29T18:31:15.000','2006-02-15T22:21:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14271','530','1','9914','4.99','2005-07-31T14:51:19.000','2006-02-15T22:21:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14272','530','2','10211','3.99','2005-08-01T01:01:16.000','2006-02-15T22:21:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14273','530','2','10504','4.99','2005-08-01T11:10:55.000','2006-02-15T22:21:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14274','530','1','11326','0.99','2005-08-02T16:34:29.000','2006-02-15T22:21:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14275','530','1','12220','4.99','2005-08-18T02:50:02.000','2006-02-15T22:21:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14276','530','1','12387','2.99','2005-08-18T08:46:24.000','2006-02-15T22:21:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14277','530','1','12649','4.99','2005-08-18T18:31:47.000','2006-02-15T22:21:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14278','530','1','13998','5.99','2005-08-20T19:52:38.000','2006-02-15T22:21:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14279','530','2','14707','5.99','2005-08-21T21:06:29.000','2006-02-15T22:21:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14280','530','2','15066','0.99','2005-08-22T10:49:06.000','2006-02-15T22:21:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14281','530','1','13561','2.99','2006-02-14T15:16:03.000','2006-02-15T22:21:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14282','531','1','233','4.99','2005-05-26T11:43:44.000','2006-02-15T22:21:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14283','531','1','681','2.99','2005-05-28T23:39:44.000','2006-02-15T22:21:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14284','531','2','2972','2.99','2005-06-20T07:57:54.000','2006-02-15T22:21:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14285','531','2','3921','5.99','2005-07-06T20:29:48.000','2006-02-15T22:21:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14286','531','1','5587','5.99','2005-07-10T04:17:25.000','2006-02-15T22:21:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14287','531','2','5850','0.99','2005-07-10T17:36:27.000','2006-02-15T22:21:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14288','531','2','5904','4.99','2005-07-10T20:39:44.000','2006-02-15T22:21:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14289','531','1','6756','4.99','2005-07-12T15:08:28.000','2006-02-15T22:21:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14290','531','1','6876','4.99','2005-07-12T20:32:50.000','2006-02-15T22:21:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14291','531','2','7204','2.99','2005-07-27T09:02:31.000','2006-02-15T22:21:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14292','531','1','7391','6.99','2005-07-27T16:00:00.000','2006-02-15T22:21:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14293','531','2','7444','2.99','2005-07-27T17:49:16.000','2006-02-15T22:21:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14294','531','2','7753','6.99','2005-07-28T06:09:19.000','2006-02-15T22:21:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14295','531','2','8359','5.99','2005-07-29T05:02:12.000','2006-02-15T22:21:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14296','531','2','8860','4.99','2005-07-29T23:45:57.000','2006-02-15T22:21:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14297','531','2','8943','0.99','2005-07-30T03:06:48.000','2006-02-15T22:21:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14298','531','2','9107','4.99','2005-07-30T08:52:45.000','2006-02-15T22:21:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14299','531','2','10920','4.99','2005-08-02T02:14:10.000','2006-02-15T22:21:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14300','531','1','10941','5.99','2005-08-02T03:11:33.000','2006-02-15T22:21:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14301','531','2','11026','4.99','2005-08-02T05:46:05.000','2006-02-15T22:21:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14302','531','1','11265','10.99','2005-08-02T14:05:42.000','2006-02-15T22:21:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14303','531','1','11666','2.99','2005-08-17T05:45:10.000','2006-02-15T22:21:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14304','531','1','12923','2.99','2005-08-19T04:50:20.000','2006-02-15T22:21:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14305','531','2','13300','8.99','2005-08-19T18:46:56.000','2006-02-15T22:21:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14306','531','2','15360','0.99','2005-08-22T21:36:51.000','2006-02-15T22:21:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14307','532','1','43','2.99','2005-05-25T05:39:25.000','2006-02-15T22:21:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14308','532','1','1694','4.99','2005-06-16T12:40:23.000','2006-02-15T22:21:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14309','532','2','2821','3.99','2005-06-19T20:26:52.000','2006-02-15T22:21:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14310','532','1','4336','2.99','2005-07-07T18:34:36.000','2006-02-15T22:21:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14311','532','2','4962','4.99','2005-07-08T23:36:13.000','2006-02-15T22:21:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14312','532','2','5190','2.99','2005-07-09T10:25:24.000','2006-02-15T22:21:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14313','532','1','5253','7.99','2005-07-09T13:41:17.000','2006-02-15T22:21:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14314','532','2','5278','4.99','2005-07-09T14:44:23.000','2006-02-15T22:21:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14315','532','2','5805','8.99','2005-07-10T15:08:41.000','2006-02-15T22:21:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14316','532','1','5887','2.99','2005-07-10T19:45:47.000','2006-02-15T22:21:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14317','532','2','6345','7.99','2005-07-11T20:05:18.000','2006-02-15T22:21:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14318','532','2','6598','4.99','2005-07-12T07:38:25.000','2006-02-15T22:21:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14319','532','1','6730','3.99','2005-07-12T13:58:25.000','2006-02-15T22:21:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14320','532','1','7192','4.99','2005-07-27T08:36:55.000','2006-02-15T22:21:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14321','532','2','7572','2.99','2005-07-27T22:44:29.000','2006-02-15T22:21:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14322','532','1','8273','5.99','2005-07-29T01:33:16.000','2006-02-15T22:21:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14323','532','1','9843','2.99','2005-07-31T12:25:28.000','2006-02-15T22:21:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14324','532','2','10286','6.99','2005-08-01T03:35:58.000','2006-02-15T22:21:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14325','532','2','10712','5.99','2005-08-01T18:47:56.000','2006-02-15T22:21:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14326','532','1','10945','5.99','2005-08-02T03:20:23.000','2006-02-15T22:21:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14327','532','2','11251','2.99','2005-08-02T13:40:49.000','2006-02-15T22:21:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14328','532','2','11318','4.99','2005-08-02T16:09:11.000','2006-02-15T22:21:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14329','532','2','12061','3.99','2005-08-17T21:13:35.000','2006-02-15T22:21:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14330','532','2','12295','5.99','2005-08-18T05:15:46.000','2006-02-15T22:21:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14331','532','2','13038','4.99','2005-08-19T08:55:16.000','2006-02-15T22:21:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14332','532','1','13192','8.99','2005-08-19T14:30:06.000','2006-02-15T22:21:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14333','532','1','13254','4.99','2005-08-19T16:54:01.000','2006-02-15T22:21:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14334','532','1','13908','4.99','2005-08-20T16:21:40.000','2006-02-15T22:21:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14335','532','2','15180','0.99','2005-08-22T15:42:57.000','2006-02-15T22:21:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14336','532','2','15414','1.99','2005-08-22T23:43:54.000','2006-02-15T22:21:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14337','532','1','16014','5.99','2005-08-23T21:18:31.000','2006-02-15T22:21:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14338','532','1','14616','0.99','2006-02-14T15:16:03.000','2006-02-15T22:21:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14339','533','1','173','0.99','2005-05-26T03:42:10.000','2006-02-15T22:21:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14340','533','2','190','1.99','2005-05-26T06:11:28.000','2006-02-15T22:21:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14341','533','1','615','5.99','2005-05-28T15:35:52.000','2006-02-15T22:21:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14342','533','1','1421','5.99','2005-06-15T17:57:04.000','2006-02-15T22:21:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14343','533','1','1652','0.99','2005-06-16T09:31:37.000','2006-02-15T22:21:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14344','533','1','1859','0.99','2005-06-17T01:13:38.000','2006-02-15T22:21:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14345','533','1','1954','2.99','2005-06-17T08:37:55.000','2006-02-15T22:21:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14346','533','2','2770','6.99','2005-06-19T17:54:22.000','2006-02-15T22:21:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14347','533','1','2956','0.99','2005-06-20T06:47:23.000','2006-02-15T22:21:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14348','533','1','4112','8.99','2005-07-07T06:49:09.000','2006-02-15T22:21:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14349','533','1','4788','4.99','2005-07-08T16:17:35.000','2006-02-15T22:21:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14350','533','2','6781','2.99','2005-07-12T16:21:47.000','2006-02-15T22:21:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14351','533','2','6834','0.99','2005-07-12T18:53:37.000','2006-02-15T22:21:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14352','533','2','6837','9.99','2005-07-12T18:59:45.000','2006-02-15T22:21:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14353','533','2','7555','4.99','2005-07-27T22:17:05.000','2006-02-15T22:21:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14354','533','1','8093','8.99','2005-07-28T18:29:16.000','2006-02-15T22:21:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14355','533','2','8104','2.99','2005-07-28T18:59:36.000','2006-02-15T22:21:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14356','533','2','8250','2.99','2005-07-29T00:49:15.000','2006-02-15T22:21:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14357','533','1','8471','2.99','2005-07-29T08:32:11.000','2006-02-15T22:21:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14358','533','1','8676','1.99','2005-07-29T15:59:06.000','2006-02-15T22:21:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14359','533','2','8786','1.99','2005-07-29T20:39:49.000','2006-02-15T22:21:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14360','533','2','10090','3.99','2005-07-31T20:22:01.000','2006-02-15T22:21:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14361','533','1','10380','2.99','2005-08-01T06:34:36.000','2006-02-15T22:21:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14362','533','1','10614','6.99','2005-08-01T14:57:00.000','2006-02-15T22:21:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14363','533','2','11524','7.99','2005-08-17T00:10:55.000','2006-02-15T22:21:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14364','533','1','11758','8.99','2005-08-17T09:33:02.000','2006-02-15T22:21:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14365','533','1','11918','2.99','2005-08-17T16:08:42.000','2006-02-15T22:21:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14366','533','1','12602','0.99','2005-08-18T16:49:50.000','2006-02-15T22:21:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14367','533','1','12655','6.99','2005-08-18T18:57:44.000','2006-02-15T22:21:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14368','533','1','14263','7.99','2005-08-21T06:08:15.000','2006-02-15T22:21:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14369','533','1','14800','4.99','2005-08-22T00:46:18.000','2006-02-15T22:21:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14370','533','2','16006','0.99','2005-08-23T21:01:09.000','2006-02-15T22:21:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14371','533','2','14018','2.99','2006-02-14T15:16:03.000','2006-02-15T22:21:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14372','534','2','304','5.99','2005-05-26T21:21:28.000','2006-02-15T22:21:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14373','534','2','940','0.99','2005-05-30T15:01:02.000','2006-02-15T22:21:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14374','534','1','1610','4.99','2005-06-16T06:36:33.000','2006-02-15T22:21:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14375','534','1','1673','2.99','2005-06-16T10:40:17.000','2006-02-15T22:21:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14376','534','1','2436','0.99','2005-06-18T18:13:32.000','2006-02-15T22:21:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14377','534','2','3213','1.99','2005-06-21T01:05:19.000','2006-02-15T22:21:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14378','534','1','3216','4.99','2005-06-21T01:19:37.000','2006-02-15T22:21:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14379','534','1','3735','2.99','2005-07-06T11:42:04.000','2006-02-15T22:21:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14380','534','2','4998','4.99','2005-07-09T01:07:21.000','2006-02-15T22:21:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14381','534','2','7113','2.99','2005-07-27T05:41:20.000','2006-02-15T22:21:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14382','534','1','7662','2.99','2005-07-28T02:16:08.000','2006-02-15T22:21:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14383','534','2','8633','0.99','2005-07-29T14:19:53.000','2006-02-15T22:21:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14384','534','1','9456','5.99','2005-07-30T22:22:16.000','2006-02-15T22:21:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14385','534','2','9464','4.99','2005-07-30T22:31:31.000','2006-02-15T22:21:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14386','534','2','10465','5.99','2005-08-01T09:45:25.000','2006-02-15T22:21:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14387','534','2','10725','6.99','2005-08-01T19:11:04.000','2006-02-15T22:21:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14388','534','1','10796','0.99','2005-08-01T21:56:41.000','2006-02-15T22:21:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14389','534','2','11180','5.99','2005-08-02T10:54:30.000','2006-02-15T22:21:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14390','534','2','12305','2.99','2005-08-18T05:46:29.000','2006-02-15T22:21:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14391','534','1','12691','5.99','2005-08-18T20:07:46.000','2006-02-15T22:21:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14392','534','2','12798','4.99','2005-08-19T00:24:33.000','2006-02-15T22:21:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14393','534','2','13294','0.99','2005-08-19T18:36:35.000','2006-02-15T22:21:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14394','534','2','14816','1.99','2005-08-22T01:15:51.000','2006-02-15T22:21:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14395','534','1','14526','2.99','2006-02-14T15:16:03.000','2006-02-15T22:21:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14396','535','1','37','0.99','2005-05-25T04:44:31.000','2006-02-15T22:21:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14397','535','2','541','2.99','2005-05-28T06:41:58.000','2006-02-15T22:21:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14398','535','1','778','3.99','2005-05-29T14:09:53.000','2006-02-15T22:21:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14399','535','2','959','4.99','2005-05-30T18:07:00.000','2006-02-15T22:21:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14400','535','1','1712','4.99','2005-06-16T14:25:09.000','2006-02-15T22:21:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14401','535','1','3228','4.99','2005-06-21T02:20:24.000','2006-02-15T22:21:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14402','535','1','4331','4.99','2005-07-07T18:22:30.000','2006-02-15T22:21:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14403','535','1','4718','6.99','2005-07-08T12:32:08.000','2006-02-15T22:21:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14404','535','1','4743','2.99','2005-07-08T13:42:36.000','2006-02-15T22:21:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14405','535','2','4914','6.99','2005-07-08T21:30:53.000','2006-02-15T22:21:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14406','535','1','5588','0.99','2005-07-10T04:21:10.000','2006-02-15T22:21:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14407','535','2','5890','8.99','2005-07-10T20:00:25.000','2006-02-15T22:21:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14408','535','1','6504','2.99','2005-07-12T03:19:14.000','2006-02-15T22:21:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14409','535','1','8395','2.99','2005-07-29T06:03:30.000','2006-02-15T22:21:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14410','535','1','8645','4.99','2005-07-29T14:47:45.000','2006-02-15T22:21:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14411','535','2','9440','0.99','2005-07-30T21:40:15.000','2006-02-15T22:21:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14412','535','1','9524','4.99','2005-07-31T01:01:06.000','2006-02-15T22:21:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14413','535','2','10322','5.99','2005-08-01T04:44:13.000','2006-02-15T22:21:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14414','535','2','10353','3.99','2005-08-01T05:46:33.000','2006-02-15T22:21:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14415','535','2','11736','8.99','2005-08-17T08:40:55.000','2006-02-15T22:21:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14416','535','1','11855','7.99','2005-08-17T13:43:07.000','2006-02-15T22:21:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14417','535','2','12168','2.99','2005-08-18T01:03:52.000','2006-02-15T22:21:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14418','535','1','12233','0.99','2005-08-18T03:16:54.000','2006-02-15T22:21:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14419','535','2','12673','4.99','2005-08-18T19:21:56.000','2006-02-15T22:21:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14420','535','1','12732','0.99','2005-08-18T21:57:50.000','2006-02-15T22:21:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14421','535','2','12750','1.99','2005-08-18T22:32:39.000','2006-02-15T22:21:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14422','535','1','13631','4.99','2005-08-20T07:07:37.000','2006-02-15T22:21:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14423','535','1','13852','0.99','2005-08-20T14:45:23.000','2006-02-15T22:21:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14424','535','1','14522','4.99','2005-08-21T15:01:34.000','2006-02-15T22:21:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14425','535','2','15075','5.99','2005-08-22T11:04:52.000','2006-02-15T22:21:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14426','535','1','15287','6.99','2005-08-22T19:19:37.000','2006-02-15T22:21:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14427','535','1','16017','0.99','2005-08-23T21:27:11.000','2006-02-15T22:21:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14428','536','1','237','0.99','2005-05-26T12:15:13.000','2006-02-15T22:21:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14429','536','1','929','6.99','2005-05-30T12:32:39.000','2006-02-15T22:21:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14430','536','1','1582','4.99','2005-06-16T04:31:57.000','2006-02-15T22:21:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14431','536','2','1962','2.99','2005-06-17T09:08:58.000','2006-02-15T22:21:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14432','536','2','2403','2.99','2005-06-18T16:33:22.000','2006-02-15T22:21:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14433','536','1','3483','4.99','2005-07-05T23:13:51.000','2006-02-15T22:21:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14434','536','1','3514','0.99','2005-07-06T00:46:54.000','2006-02-15T22:21:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14435','536','1','4448','2.99','2005-07-07T23:17:12.000','2006-02-15T22:21:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14436','536','2','5196','0.99','2005-07-09T10:43:34.000','2006-02-15T22:21:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14437','536','1','6400','5.99','2005-07-11T22:43:44.000','2006-02-15T22:21:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14438','536','1','7065','4.99','2005-07-27T03:53:43.000','2006-02-15T22:21:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14439','536','2','8535','4.99','2005-07-29T10:32:33.000','2006-02-15T22:21:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14440','536','1','8679','4.99','2005-07-29T16:07:47.000','2006-02-15T22:21:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14441','536','1','8958','2.99','2005-07-30T03:34:26.000','2006-02-15T22:21:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14442','536','1','9411','8.99','2005-07-30T20:38:22.000','2006-02-15T22:21:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14443','536','1','9727','4.99','2005-07-31T08:39:13.000','2006-02-15T22:21:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14444','536','2','10019','3.99','2005-07-31T18:20:56.000','2006-02-15T22:21:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14445','536','1','11473','6.99','2005-08-02T21:52:03.000','2006-02-15T22:21:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14446','536','1','11826','2.99','2005-08-17T12:43:46.000','2006-02-15T22:21:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14447','536','2','11977','4.99','2005-08-17T18:01:15.000','2006-02-15T22:21:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14448','536','2','12052','8.99','2005-08-17T20:57:02.000','2006-02-15T22:21:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14449','536','2','13505','4.99','2005-08-20T02:05:57.000','2006-02-15T22:21:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14450','536','1','15130','7.99','2005-08-22T13:04:32.000','2006-02-15T22:21:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14451','536','1','15978','8.99','2005-08-23T20:08:18.000','2006-02-15T22:21:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14452','536','1','15979','0.99','2005-08-23T20:08:26.000','2006-02-15T22:21:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14453','537','2','603','4.99','2005-05-28T14:27:51.000','2006-02-15T22:21:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14454','537','1','1445','2.99','2005-06-15T19:10:07.000','2006-02-15T22:21:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14455','537','2','2184','2.99','2005-06-18T01:10:36.000','2006-02-15T22:21:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14456','537','1','2586','8.99','2005-06-19T05:05:11.000','2006-02-15T22:21:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14457','537','2','3134','8.99','2005-06-20T19:29:09.000','2006-02-15T22:21:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14458','537','1','3555','0.99','2005-07-06T02:45:35.000','2006-02-15T22:21:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14459','537','2','3853','0.99','2005-07-06T16:59:20.000','2006-02-15T22:21:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14460','537','1','5630','2.99','2005-07-10T06:08:14.000','2006-02-15T22:21:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14461','537','2','5877','5.99','2005-07-10T19:08:51.000','2006-02-15T22:21:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14462','537','2','6310','2.99','2005-07-11T18:14:05.000','2006-02-15T22:21:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14463','537','1','6409','4.99','2005-07-11T23:05:49.000','2006-02-15T22:21:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14464','537','1','6746','0.99','2005-07-12T14:33:01.000','2006-02-15T22:21:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14465','537','1','7179','2.99','2005-07-27T08:10:29.000','2006-02-15T22:21:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14466','537','2','7810','4.99','2005-07-28T08:00:38.000','2006-02-15T22:21:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14467','537','2','8126','4.99','2005-07-28T19:32:41.000','2006-02-15T22:21:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14468','537','2','8256','4.99','2005-07-29T01:02:42.000','2006-02-15T22:21:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14469','537','1','9967','2.99','2005-07-31T16:31:17.000','2006-02-15T22:21:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14470','537','2','12984','4.99','2005-08-19T07:06:51.000','2006-02-15T22:21:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14471','537','2','13885','4.99','2005-08-20T15:32:09.000','2006-02-15T22:21:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14472','537','1','14010','4.99','2005-08-20T20:29:46.000','2006-02-15T22:21:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14473','537','2','14506','0.99','2005-08-21T14:32:27.000','2006-02-15T22:21:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14474','537','1','14670','0.99','2005-08-21T19:54:11.000','2006-02-15T22:21:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14475','537','1','15149','2.99','2005-08-22T14:08:06.000','2006-02-15T22:21:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14476','537','1','15832','8.99','2005-08-23T15:21:35.000','2006-02-15T22:21:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14477','537','1','13419','4.99','2006-02-14T15:16:03.000','2006-02-15T22:21:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14478','538','2','594','2.99','2005-05-28T13:41:56.000','2006-02-15T22:21:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14479','538','2','734','4.99','2005-05-29T07:38:52.000','2006-02-15T22:21:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14480','538','1','1314','5.99','2005-06-15T10:21:45.000','2006-02-15T22:21:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14481','538','1','1912','4.99','2005-06-17T05:18:32.000','2006-02-15T22:21:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14482','538','1','2682','4.99','2005-06-19T12:18:17.000','2006-02-15T22:21:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14483','538','2','3189','2.99','2005-06-20T23:19:33.000','2006-02-15T22:21:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14484','538','2','3554','4.99','2005-07-06T02:37:10.000','2006-02-15T22:21:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14485','538','2','5135','8.99','2005-07-09T07:53:22.000','2006-02-15T22:21:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14486','538','1','5369','4.99','2005-07-09T18:42:16.000','2006-02-15T22:21:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14487','538','1','5486','2.99','2005-07-09T23:57:44.000','2006-02-15T22:21:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14488','538','1','5898','2.99','2005-07-10T20:18:09.000','2006-02-15T22:21:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14489','538','2','6130','2.99','2005-07-11T08:19:56.000','2006-02-15T22:21:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14490','538','1','6332','0.99','2005-07-11T19:19:06.000','2006-02-15T22:21:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14491','538','2','6936','0.99','2005-07-26T23:13:34.000','2006-02-15T22:21:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14492','538','1','7694','0.99','2005-07-28T03:39:25.000','2006-02-15T22:21:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14493','538','1','8765','0.99','2005-07-29T19:40:08.000','2006-02-15T22:21:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14494','538','1','9307','0.99','2005-07-30T16:52:43.000','2006-02-15T22:21:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14495','538','1','9643','4.99','2005-07-31T05:35:48.000','2006-02-15T22:21:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14496','538','2','9897','4.99','2005-07-31T14:11:57.000','2006-02-15T22:21:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14497','538','2','9939','8.99','2005-07-31T15:29:00.000','2006-02-15T22:21:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14498','538','2','10701','3.99','2005-08-01T18:28:17.000','2006-02-15T22:21:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14499','538','1','10732','5.99','2005-08-01T19:25:18.000','2006-02-15T22:21:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14500','538','1','10962','4.99','2005-08-02T03:48:13.000','2006-02-15T22:21:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14501','538','2','12089','5.99','2005-08-17T22:20:29.000','2006-02-15T22:21:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14502','538','1','13544','1.99','2005-08-20T03:44:26.000','2006-02-15T22:21:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14503','538','2','13770','4.99','2005-08-20T11:45:54.000','2006-02-15T22:21:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14504','538','2','14572','2.99','2005-08-21T16:44:31.000','2006-02-15T22:21:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14505','538','1','14591','0.99','2005-08-21T17:30:09.000','2006-02-15T22:21:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14506','538','1','15343','6.99','2005-08-22T21:01:25.000','2006-02-15T22:21:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14507','539','2','250','4.99','2005-05-26T14:30:24.000','2006-02-15T22:21:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14508','539','1','342','0.99','2005-05-27T04:11:04.000','2006-02-15T22:21:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14509','539','2','1282','3.99','2005-06-15T08:25:33.000','2006-02-15T22:21:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14510','539','1','1327','0.99','2005-06-15T11:11:39.000','2006-02-15T22:21:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14511','539','2','1444','4.99','2005-06-15T19:08:16.000','2006-02-15T22:21:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14512','539','1','4035','2.99','2005-07-07T02:45:02.000','2006-02-15T22:21:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14513','539','1','4247','0.99','2005-07-07T13:51:54.000','2006-02-15T22:21:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14514','539','2','5086','4.99','2005-07-09T05:40:04.000','2006-02-15T22:21:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14515','539','2','5139','7.99','2005-07-09T08:01:51.000','2006-02-15T22:21:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14516','539','2','5493','2.99','2005-07-10T00:11:44.000','2006-02-15T22:21:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14517','539','2','6874','5.99','2005-07-12T20:20:53.000','2006-02-15T22:21:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14518','539','1','7781','2.99','2005-07-28T07:13:20.000','2006-02-15T22:21:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14519','539','2','8247','6.99','2005-07-29T00:41:38.000','2006-02-15T22:21:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14520','539','2','8761','5.99','2005-07-29T19:26:47.000','2006-02-15T22:21:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14521','539','2','9250','0.99','2005-07-30T14:18:16.000','2006-02-15T22:21:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14522','539','1','9777','7.99','2005-07-31T10:01:06.000','2006-02-15T22:21:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14523','539','1','9796','4.99','2005-07-31T10:52:43.000','2006-02-15T22:21:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14524','539','2','10922','3.99','2005-08-02T02:14:40.000','2006-02-15T22:21:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14525','539','1','12848','2.99','2005-08-19T02:05:11.000','2006-02-15T22:21:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14526','539','2','13615','2.99','2005-08-20T06:28:53.000','2006-02-15T22:21:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14527','539','2','13778','5.99','2005-08-20T12:03:44.000','2006-02-15T22:21:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14528','539','1','15356','2.99','2005-08-22T21:24:19.000','2006-02-15T22:21:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14529','540','2','1263','2.99','2005-06-15T06:56:39.000','2006-02-15T22:21:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14530','540','2','1290','4.99','2005-06-15T08:52:44.000','2006-02-15T22:21:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14531','540','2','2640','2.99','2005-06-19T09:26:13.000','2006-02-15T22:21:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14532','540','1','2953','3.99','2005-06-20T06:39:11.000','2006-02-15T22:21:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14533','540','1','3340','3.99','2005-06-21T10:37:23.000','2006-02-15T22:21:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14534','540','2','4628','4.99','2005-07-08T08:25:52.000','2006-02-15T22:21:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14535','540','2','4991','4.99','2005-07-09T00:49:03.000','2006-02-15T22:21:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14536','540','1','6103','2.99','2005-07-11T06:59:55.000','2006-02-15T22:21:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14537','540','2','6145','7.99','2005-07-11T09:07:01.000','2006-02-15T22:21:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14538','540','2','6182','2.99','2005-07-11T11:11:38.000','2006-02-15T22:21:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14539','540','1','6748','6.99','2005-07-12T14:39:27.000','2006-02-15T22:21:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14540','540','1','6919','0.99','2005-07-12T22:32:17.000','2006-02-15T22:21:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14541','540','2','9762','4.99','2005-07-31T09:32:54.000','2006-02-15T22:21:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14542','540','2','9815','2.99','2005-07-31T11:30:51.000','2006-02-15T22:21:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14543','540','1','10924','8.99','2005-08-02T02:20:19.000','2006-02-15T22:21:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14544','540','1','11198','3.99','2005-08-02T11:45:15.000','2006-02-15T22:21:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14545','540','2','11324','4.99','2005-08-02T16:31:17.000','2006-02-15T22:21:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14546','540','2','11432','6.99','2005-08-02T20:10:01.000','2006-02-15T22:21:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14547','540','2','12058','8.99','2005-08-17T21:07:41.000','2006-02-15T22:21:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14548','540','2','12201','4.99','2005-08-18T02:14:06.000','2006-02-15T22:21:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14549','540','1','12300','6.99','2005-08-18T05:36:14.000','2006-02-15T22:21:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14550','540','2','14910','0.99','2005-08-22T04:50:52.000','2006-02-15T22:21:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14551','540','2','15079','2.99','2005-08-22T11:09:56.000','2006-02-15T22:21:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14552','540','2','15953','3.99','2005-08-23T19:13:46.000','2006-02-15T22:21:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14553','541','1','1021','7.99','2005-05-31T03:16:15.000','2006-02-15T22:21:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14554','541','1','1066','4.99','2005-05-31T09:07:33.000','2006-02-15T22:21:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14555','541','2','1986','2.99','2005-06-17T10:34:59.000','2006-02-15T22:21:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14556','541','1','2708','6.99','2005-06-19T13:59:05.000','2006-02-15T22:21:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14557','541','1','5018','2.99','2005-07-09T02:01:05.000','2006-02-15T22:21:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14558','541','2','5197','4.99','2005-07-09T10:43:54.000','2006-02-15T22:21:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14559','541','2','6468','7.99','2005-07-12T01:27:09.000','2006-02-15T22:21:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14560','541','2','6718','2.99','2005-07-12T13:38:06.000','2006-02-15T22:21:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14561','541','1','8113','8.99','2005-07-28T19:14:00.000','2006-02-15T22:21:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14562','541','1','8322','4.99','2005-07-29T03:52:49.000','2006-02-15T22:21:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14563','541','2','9603','0.99','2005-07-31T03:43:43.000','2006-02-15T22:21:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14564','541','1','10306','5.99','2005-08-01T04:19:18.000','2006-02-15T22:21:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14565','541','2','11273','0.99','2005-08-02T14:20:55.000','2006-02-15T22:21:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14566','541','1','12306','4.99','2005-08-18T05:47:55.000','2006-02-15T22:21:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14567','541','2','12395','4.99','2005-08-18T09:06:30.000','2006-02-15T22:21:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14568','541','1','12894','7.99','2005-08-19T03:49:28.000','2006-02-15T22:21:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14569','541','2','13239','4.99','2005-08-19T16:22:13.000','2006-02-15T22:21:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14570','541','2','13640','0.99','2005-08-20T07:22:53.000','2006-02-15T22:21:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14571','541','2','14938','6.99','2005-08-22T05:52:39.000','2006-02-15T22:21:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14572','541','1','15071','4.99','2005-08-22T10:58:43.000','2006-02-15T22:21:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14573','541','2','15141','3.99','2005-08-22T13:41:49.000','2006-02-15T22:21:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14574','541','1','15223','1.99','2005-08-22T17:13:39.000','2006-02-15T22:21:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14575','541','1','15421','0.99','2005-08-22T23:56:37.000','2006-02-15T22:21:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14576','541','2','15924','1.99','2005-08-23T18:08:59.000','2006-02-15T22:21:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14577','542','1','220','4.99','2005-05-26T10:06:49.000','2006-02-15T22:21:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14578','542','2','376','4.99','2005-05-27T08:58:15.000','2006-02-15T22:21:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14579','542','1','2610','4.99','2005-06-19T07:16:20.000','2006-02-15T22:21:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14580','542','2','2957','10.99','2005-06-20T06:53:47.000','2006-02-15T22:21:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14581','542','2','5293','0.99','2005-07-09T15:17:23.000','2006-02-15T22:21:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14582','542','1','5477','6.99','2005-07-09T23:43:49.000','2006-02-15T22:21:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14583','542','2','6077','5.99','2005-07-11T05:06:08.000','2006-02-15T22:21:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14584','542','2','6325','5.99','2005-07-11T19:06:01.000','2006-02-15T22:21:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14585','542','1','6887','9.99','2005-07-12T21:00:23.000','2006-02-15T22:21:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14586','542','2','7672','8.99','2005-07-28T02:49:41.000','2006-02-15T22:21:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14587','542','1','8533','4.99','2005-07-29T10:29:16.000','2006-02-15T22:21:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14588','542','2','8544','3.99','2005-07-29T11:02:08.000','2006-02-15T22:21:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14589','542','1','10280','4.99','2005-08-01T03:27:15.000','2006-02-15T22:21:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14590','542','2','11583','0.99','2005-08-17T02:08:13.000','2006-02-15T22:21:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14591','542','2','11903','2.99','2005-08-17T15:37:45.000','2006-02-15T22:21:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14592','542','1','12819','0.99','2005-08-19T01:05:05.000','2006-02-15T22:21:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14593','542','1','13447','0.99','2005-08-20T00:09:36.000','2006-02-15T22:21:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14594','542','2','14982','9.99','2005-08-22T07:20:55.000','2006-02-15T22:21:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14595','543','1','243','6.99','2005-05-26T13:06:05.000','2006-02-15T22:21:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14596','543','2','476','1.99','2005-05-27T22:31:36.000','2006-02-15T22:21:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14597','543','2','1720','4.99','2005-06-16T15:00:14.000','2006-02-15T22:21:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14598','543','1','2426','2.99','2005-06-18T17:40:44.000','2006-02-15T22:21:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14599','543','2','3070','4.99','2005-06-20T14:15:39.000','2006-02-15T22:21:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14600','543','1','3128','2.99','2005-06-20T18:41:47.000','2006-02-15T22:21:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14601','543','2','3467','5.99','2005-06-21T22:19:25.000','2006-02-15T22:21:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14602','543','1','4887','2.99','2005-07-08T19:59:14.000','2006-02-15T22:21:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14603','543','2','5467','4.99','2005-07-09T23:05:47.000','2006-02-15T22:21:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14604','543','2','6013','4.99','2005-07-11T02:02:03.000','2006-02-15T22:21:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14605','543','2','7312','2.99','2005-07-27T13:03:14.000','2006-02-15T22:21:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14606','543','1','8580','2.99','2005-07-29T12:00:27.000','2006-02-15T22:21:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14607','543','2','8845','4.99','2005-07-29T23:06:13.000','2006-02-15T22:21:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14608','543','1','9505','2.99','2005-07-31T00:11:19.000','2006-02-15T22:21:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14609','543','1','9999','0.99','2005-07-31T17:40:53.000','2006-02-15T22:21:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14610','543','2','10257','0.99','2005-08-01T02:49:43.000','2006-02-15T22:21:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14611','543','1','10520','4.99','2005-08-01T11:45:58.000','2006-02-15T22:21:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14612','543','2','11241','9.99','2005-08-02T13:29:24.000','2006-02-15T22:21:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14613','543','1','11681','2.99','2005-08-17T06:13:30.000','2006-02-15T22:21:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14614','543','1','13187','0.99','2005-08-19T14:24:48.000','2006-02-15T22:21:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14615','543','2','15281','1.99','2005-08-22T19:10:26.000','2006-02-15T22:21:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14616','543','1','15785','1.99','2005-08-23T13:46:27.000','2006-02-15T22:21:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14617','544','1','397','2.99','2005-05-27T12:29:02.000','2006-02-15T22:21:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14618','544','1','864','2.99','2005-05-30T03:27:17.000','2006-02-15T22:21:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14619','544','1','1248','1.99','2005-06-15T05:33:52.000','2006-02-15T22:21:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14620','544','2','1434','10.99','2005-06-15T18:30:46.000','2006-02-15T22:21:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14621','544','1','2373','0.99','2005-06-18T14:37:57.000','2006-02-15T22:21:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14622','544','1','2395','2.99','2005-06-18T15:45:15.000','2006-02-15T22:21:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14623','544','1','4395','0.99','2005-07-07T21:13:22.000','2006-02-15T22:21:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14624','544','1','4703','2.99','2005-07-08T11:44:56.000','2006-02-15T22:21:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14625','544','2','4847','6.99','2005-07-08T18:29:13.000','2006-02-15T22:21:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14626','544','2','8566','2.99','2005-07-29T11:35:46.000','2006-02-15T22:21:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14627','544','1','8937','5.99','2005-07-30T02:53:21.000','2006-02-15T22:21:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14628','544','1','8963','9.99','2005-07-30T03:46:26.000','2006-02-15T22:21:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14629','544','1','10735','0.99','2005-08-01T19:29:45.000','2006-02-15T22:21:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14630','544','1','11401','3.99','2005-08-02T19:05:06.000','2006-02-15T22:21:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14631','544','2','11766','2.99','2005-08-17T09:58:40.000','2006-02-15T22:21:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14632','544','2','12640','3.99','2005-08-18T18:14:49.000','2006-02-15T22:21:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14633','544','2','14142','4.99','2005-08-21T02:07:43.000','2006-02-15T22:21:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14634','544','1','14498','4.99','2005-08-21T14:10:44.000','2006-02-15T22:21:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14635','544','2','14651','8.99','2005-08-21T19:31:09.000','2006-02-15T22:21:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14636','544','1','14981','2.99','2005-08-22T07:19:05.000','2006-02-15T22:21:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14637','544','1','15219','6.99','2005-08-22T17:00:31.000','2006-02-15T22:21:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14638','544','1','15605','4.99','2005-08-23T06:48:47.000','2006-02-15T22:21:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14639','545','2','248','0.99','2005-05-26T14:07:58.000','2006-02-15T22:21:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14640','545','2','715','3.99','2005-05-29T04:22:41.000','2006-02-15T22:21:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14641','545','1','2123','2.99','2005-06-17T20:48:30.000','2006-02-15T22:21:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14642','545','2','3693','8.99','2005-07-06T09:56:09.000','2006-02-15T22:21:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14643','545','1','3975','5.99','2005-07-06T23:00:09.000','2006-02-15T22:21:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14644','545','1','4597','5.99','2005-07-08T06:43:42.000','2006-02-15T22:21:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14645','545','1','5264','0.99','2005-07-09T14:11:28.000','2006-02-15T22:21:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14646','545','1','7078','5.99','2005-07-27T04:16:37.000','2006-02-15T22:21:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14647','545','2','8599','3.99','2005-07-29T12:58:52.000','2006-02-15T22:21:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14648','545','2','8848','2.99','2005-07-29T23:20:58.000','2006-02-15T22:21:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14649','545','2','9810','2.99','2005-07-31T11:22:41.000','2006-02-15T22:21:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14650','545','2','9942','4.99','2005-07-31T15:35:43.000','2006-02-15T22:21:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14651','545','2','10931','2.99','2005-08-02T02:44:59.000','2006-02-15T22:21:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14652','545','2','11760','2.99','2005-08-17T09:44:22.000','2006-02-15T22:21:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14653','545','1','12098','4.99','2005-08-17T22:38:31.000','2006-02-15T22:21:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14654','545','1','12349','2.99','2005-08-18T07:23:42.000','2006-02-15T22:21:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14655','545','2','12667','10.99','2005-08-18T19:11:45.000','2006-02-15T22:21:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14656','545','1','12800','2.99','2005-08-19T00:27:11.000','2006-02-15T22:21:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14657','545','1','13595','4.99','2005-08-20T05:54:27.000','2006-02-15T22:21:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14658','545','1','15585','0.99','2005-08-23T05:55:22.000','2006-02-15T22:21:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14659','545','2','15998','4.99','2005-08-23T20:41:09.000','2006-02-15T22:21:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14660','546','1','197','5.99','2005-05-26T06:59:21.000','2006-02-15T22:21:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14661','546','1','482','6.99','2005-05-27T22:53:02.000','2006-02-15T22:21:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14662','546','1','1181','1.99','2005-06-15T00:42:17.000','2006-02-15T22:21:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14663','546','2','1403','0.99','2005-06-15T16:31:59.000','2006-02-15T22:21:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14664','546','1','1787','3.99','2005-06-16T19:30:59.000','2006-02-15T22:21:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14665','546','1','2361','5.99','2005-06-18T13:19:05.000','2006-02-15T22:21:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14666','546','1','3738','4.99','2005-07-06T11:50:57.000','2006-02-15T22:21:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14667','546','2','4664','0.99','2005-07-08T10:01:28.000','2006-02-15T22:21:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14668','546','1','4734','0.99','2005-07-08T13:12:12.000','2006-02-15T22:21:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14669','546','1','5629','0.99','2005-07-10T06:02:25.000','2006-02-15T22:21:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14670','546','2','6758','9.99','2005-07-12T15:13:49.000','2006-02-15T22:21:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14671','546','1','6786','2.99','2005-07-12T16:32:33.000','2006-02-15T22:21:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14672','546','2','6910','6.99','2005-07-12T22:11:21.000','2006-02-15T22:21:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14673','546','1','8532','4.99','2005-07-29T10:26:56.000','2006-02-15T22:21:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14674','546','1','9087','4.99','2005-07-30T08:19:47.000','2006-02-15T22:21:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14675','546','1',NULL,'3.99','2005-07-30T21:16:20.000','2006-02-15T22:21:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14676','546','2','9626','1.99','2005-07-31T04:37:41.000','2006-02-15T22:21:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14677','546','2','10370','0.99','2005-08-01T06:18:04.000','2006-02-15T22:21:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14678','546','2','11352','5.99','2005-08-02T17:29:39.000','2006-02-15T22:21:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14679','546','1','11797','4.99','2005-08-17T11:17:21.000','2006-02-15T22:21:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14680','546','2','12591','2.99','2005-08-18T16:16:41.000','2006-02-15T22:21:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14681','546','2','13850','5.99','2005-08-20T14:43:03.000','2006-02-15T22:21:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14682','546','1','14797','4.99','2005-08-22T00:41:24.000','2006-02-15T22:21:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14683','546','1','14829','2.99','2005-08-22T01:35:37.000','2006-02-15T22:21:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14684','546','1','14929','3.99','2005-08-22T05:32:38.000','2006-02-15T22:21:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14685','546','2','15565','4.99','2005-08-23T05:13:09.000','2006-02-15T22:21:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14686','547','1','306','0.99','2005-05-26T21:31:57.000','2006-02-15T22:21:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14687','547','2','443','8.99','2005-05-27T18:35:20.000','2006-02-15T22:21:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14688','547','2','1094','1.99','2005-05-31T13:03:49.000','2006-02-15T22:21:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14689','547','2','2022','8.99','2005-06-17T12:44:39.000','2006-02-15T22:21:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14690','547','2','3679','4.99','2005-07-06T09:15:57.000','2006-02-15T22:21:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14691','547','1','3765','4.99','2005-07-06T13:01:47.000','2006-02-15T22:21:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14692','547','2','5327','4.99','2005-07-09T16:39:49.000','2006-02-15T22:21:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14693','547','2','5854','4.99','2005-07-10T17:47:34.000','2006-02-15T22:21:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14694','547','1','6605','0.99','2005-07-12T08:01:07.000','2006-02-15T22:21:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14695','547','2','7420','4.99','2005-07-27T17:09:39.000','2006-02-15T22:21:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14696','547','2','7547','3.99','2005-07-27T21:51:48.000','2006-02-15T22:21:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14697','547','1','7835','4.99','2005-07-28T08:49:39.000','2006-02-15T22:21:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14698','547','1','7859','3.99','2005-07-28T09:57:17.000','2006-02-15T22:21:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14699','547','1','8828','2.99','2005-07-29T22:32:54.000','2006-02-15T22:21:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14700','547','1','10903','2.99','2005-08-02T01:41:59.000','2006-02-15T22:21:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14701','547','1','10980','4.99','2005-08-02T04:17:32.000','2006-02-15T22:21:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14702','547','2','11170','5.99','2005-08-02T10:21:53.000','2006-02-15T22:21:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14703','547','2','11361','0.99','2005-08-02T17:46:34.000','2006-02-15T22:21:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14704','547','1','12579','0.99','2005-08-18T15:47:49.000','2006-02-15T22:21:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14705','547','2','12943','2.99','2005-08-19T05:46:26.000','2006-02-15T22:21:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14706','547','2','13307','2.99','2005-08-19T18:58:44.000','2006-02-15T22:21:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14707','547','1','14510','9.99','2005-08-21T14:44:41.000','2006-02-15T22:21:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14708','547','2','14884','4.99','2005-08-22T03:57:08.000','2006-02-15T22:21:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14709','548','2','177','6.99','2005-05-26T04:14:29.000','2006-02-15T22:21:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14710','548','1','743','4.99','2005-05-29T08:39:02.000','2006-02-15T22:21:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14711','548','2','872','3.99','2005-05-30T05:03:04.000','2006-02-15T22:21:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14712','548','1','1326','1.99','2005-06-15T11:07:39.000','2006-02-15T22:21:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14713','548','1','2280','2.99','2005-06-18T06:46:54.000','2006-02-15T22:21:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14714','548','2','2978','0.99','2005-06-20T08:25:16.000','2006-02-15T22:21:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14715','548','1','3686','2.99','2005-07-06T09:37:50.000','2006-02-15T22:21:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14716','548','2','3777','2.99','2005-07-06T13:36:48.000','2006-02-15T22:21:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14717','548','1','4155','7.99','2005-07-07T09:00:49.000','2006-02-15T22:21:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14718','548','2','5138','4.99','2005-07-09T08:00:46.000','2006-02-15T22:21:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14719','548','2','6490','4.99','2005-07-12T02:28:03.000','2006-02-15T22:21:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14720','548','1','9614','5.99','2005-07-31T03:59:31.000','2006-02-15T22:21:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14721','548','2','10318','0.99','2005-08-01T04:36:53.000','2006-02-15T22:21:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14722','548','1','12860','5.99','2005-08-19T02:24:41.000','2006-02-15T22:21:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14723','548','1','13691','3.99','2005-08-20T09:07:39.000','2006-02-15T22:21:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14724','548','2','13730','7.99','2005-08-20T10:17:09.000','2006-02-15T22:21:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14725','548','2','14188','0.99','2005-08-21T03:32:04.000','2006-02-15T22:21:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14726','548','2','14723','6.99','2005-08-21T21:52:32.000','2006-02-15T22:21:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14727','548','1','13584','0.99','2006-02-14T15:16:03.000','2006-02-15T22:21:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14728','549','1','6','0.99','2005-05-24T23:08:07.000','2006-02-15T22:21:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14729','549','2','852','4.99','2005-05-30T01:36:57.000','2006-02-15T22:21:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14730','549','1','906','3.99','2005-05-30T10:30:38.000','2006-02-15T22:21:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14731','549','2','1086','4.99','2005-05-31T11:17:37.000','2006-02-15T22:21:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14732','549','1','2050','2.99','2005-06-17T15:07:30.000','2006-02-15T22:21:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14733','549','2','3523','2.99','2005-07-06T01:01:38.000','2006-02-15T22:21:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14734','549','2','3892','4.99','2005-07-06T18:58:58.000','2006-02-15T22:21:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14735','549','1','4447','0.99','2005-07-07T23:15:28.000','2006-02-15T22:21:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14736','549','1','7252','7.99','2005-07-27T10:45:28.000','2006-02-15T22:21:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14737','549','2','8239','0.99','2005-07-29T00:31:39.000','2006-02-15T22:21:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14738','549','1','8316','4.99','2005-07-29T03:38:49.000','2006-02-15T22:21:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14739','549','2','9445','7.99','2005-07-30T21:50:42.000','2006-02-15T22:21:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14740','549','2','9511','9.99','2005-07-31T00:25:05.000','2006-02-15T22:21:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14741','549','2','9887','0.99','2005-07-31T14:00:32.000','2006-02-15T22:21:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14742','549','2','10281','0.99','2005-08-01T03:28:33.000','2006-02-15T22:21:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14743','549','2','11737','4.99','2005-08-17T08:42:08.000','2006-02-15T22:21:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14744','549','2','11878','2.99','2005-08-17T14:23:52.000','2006-02-15T22:21:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14745','549','2','12634','2.99','2005-08-18T17:58:14.000','2006-02-15T22:21:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14746','549','2','12747','4.99','2005-08-18T22:28:22.000','2006-02-15T22:21:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14747','549','1','14434','0.99','2005-08-21T11:40:46.000','2006-02-15T22:21:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14748','550','2','922','7.99','2005-05-30T11:55:55.000','2006-02-15T22:21:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14749','550','1','1233','6.99','2005-06-15T04:18:37.000','2006-02-15T22:21:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14750','550','1','1863','3.99','2005-06-17T01:31:46.000','2006-02-15T22:21:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14751','550','2','1883','4.99','2005-06-17T03:18:51.000','2006-02-15T22:21:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14752','550','1','3154','2.99','2005-06-20T20:44:40.000','2006-02-15T22:21:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14753','550','2','3236','9.99','2005-06-21T02:47:43.000','2006-02-15T22:21:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14754','550','1','3272','10.99','2005-06-21T05:18:27.000','2006-02-15T22:21:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14755','550','1','3979','4.99','2005-07-06T23:04:35.000','2006-02-15T22:21:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14756','550','1','5727','4.99','2005-07-10T11:25:28.000','2006-02-15T22:21:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14757','550','1','6695','2.99','2005-07-12T12:39:39.000','2006-02-15T22:21:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14758','550','1','7030','0.99','2005-07-27T03:01:40.000','2006-02-15T22:21:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14759','550','2','7838','2.99','2005-07-28T09:00:21.000','2006-02-15T22:21:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14760','550','1','8628','6.99','2005-07-29T14:06:24.000','2006-02-15T22:21:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14761','550','2','8838','2.99','2005-07-29T22:52:23.000','2006-02-15T22:21:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14762','550','1','8959','8.99','2005-07-30T03:35:49.000','2006-02-15T22:21:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14763','550','1','9616','2.99','2005-07-31T04:05:01.000','2006-02-15T22:21:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14764','550','1','9748','0.99','2005-07-31T09:17:56.000','2006-02-15T22:21:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14765','550','2','10140','4.99','2005-07-31T22:03:20.000','2006-02-15T22:21:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14766','550','1','11246','2.99','2005-08-02T13:33:56.000','2006-02-15T22:21:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14767','550','2','11320','0.99','2005-08-02T16:13:28.000','2006-02-15T22:21:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14768','550','1','11969','4.99','2005-08-17T17:49:37.000','2006-02-15T22:21:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14769','550','1','12063','2.99','2005-08-17T21:24:48.000','2006-02-15T22:21:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14770','550','2','12077','4.99','2005-08-17T21:59:14.000','2006-02-15T22:21:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14771','550','1','13114','10.99','2005-08-19T11:27:32.000','2006-02-15T22:21:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14772','550','2','14071','2.99','2005-08-20T23:01:56.000','2006-02-15T22:21:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14773','550','2','14127','4.99','2005-08-21T01:33:32.000','2006-02-15T22:21:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14774','550','2','14375','6.99','2005-08-21T09:46:35.000','2006-02-15T22:21:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14775','550','1','14687','4.99','2005-08-21T20:32:16.000','2006-02-15T22:21:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14776','550','2','15431','9.99','2005-08-23T00:26:47.000','2006-02-15T22:21:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14777','550','1','15883','0.99','2005-08-23T16:44:56.000','2006-02-15T22:21:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14778','550','2','15977','4.99','2005-08-23T20:07:10.000','2006-02-15T22:21:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14779','550','2','11757','2.99','2006-02-14T15:16:03.000','2006-02-15T22:21:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14780','551','2','155','7.99','2005-05-26T01:15:05.000','2006-02-15T22:21:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14781','551','1','728','2.99','2005-05-29T06:12:38.000','2006-02-15T22:21:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14782','551','1','795','0.99','2005-05-29T16:57:39.000','2006-02-15T22:21:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14783','551','2','969','4.99','2005-05-30T19:23:48.000','2006-02-15T22:21:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14784','551','2','1005','3.99','2005-05-31T00:53:25.000','2006-02-15T22:21:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14785','551','2','2069','4.99','2005-06-17T16:19:39.000','2006-02-15T22:21:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14786','551','1','2776','3.99','2005-06-19T18:16:24.000','2006-02-15T22:21:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14787','551','2','3996','5.99','2005-07-06T23:46:43.000','2006-02-15T22:21:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14788','551','1','5201','1.99','2005-07-09T10:52:53.000','2006-02-15T22:21:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14789','551','2','5528','0.99','2005-07-10T02:09:21.000','2006-02-15T22:21:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14790','551','1','6041','0.99','2005-07-11T03:14:58.000','2006-02-15T22:21:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14791','551','2','7095','9.99','2005-07-27T04:51:15.000','2006-02-15T22:21:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14792','551','1','8986','0.99','2005-07-30T04:37:20.000','2006-02-15T22:21:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14793','551','1','9287','2.99','2005-07-30T15:35:39.000','2006-02-15T22:21:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14794','551','2','9765','4.99','2005-07-31T09:44:40.000','2006-02-15T22:21:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14795','551','2','11380','0.99','2005-08-02T18:17:32.000','2006-02-15T22:21:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14796','551','2','11883','2.99','2005-08-17T14:41:28.000','2006-02-15T22:21:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14797','551','2','12208','4.99','2005-08-18T02:25:25.000','2006-02-15T22:21:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14798','551','2','12868','0.99','2005-08-19T02:47:19.000','2006-02-15T22:21:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14799','551','1','13439','3.99','2005-08-19T23:42:16.000','2006-02-15T22:21:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14800','551','1','14420','0.99','2005-08-21T11:16:15.000','2006-02-15T22:21:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14801','551','2','14609','4.99','2005-08-21T17:57:26.000','2006-02-15T22:21:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14802','551','2','14633','2.99','2005-08-21T18:51:10.000','2006-02-15T22:21:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14803','551','1','14833','2.99','2005-08-22T01:45:18.000','2006-02-15T22:21:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14804','551','1','15377','4.99','2005-08-22T22:22:33.000','2006-02-15T22:21:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14805','551','2','15390','6.99','2005-08-22T22:57:25.000','2006-02-15T22:21:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14806','552','2','174','0.99','2005-05-26T03:44:10.000','2006-02-15T22:21:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14807','552','2','2320','0.99','2005-06-18T09:24:50.000','2006-02-15T22:21:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14808','552','2','3397','4.99','2005-06-21T15:30:11.000','2006-02-15T22:21:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14809','552','1','4477','6.99','2005-07-08T00:38:24.000','2006-02-15T22:21:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14810','552','1','5213','7.99','2005-07-09T11:39:43.000','2006-02-15T22:21:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14811','552','2','6189','4.99','2005-07-11T11:36:03.000','2006-02-15T22:21:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14812','552','1','7772','2.99','2005-07-28T06:59:09.000','2006-02-15T22:21:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14813','552','1','8085','2.99','2005-07-28T18:13:15.000','2006-02-15T22:21:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14814','552','2','8192','2.99','2005-07-28T22:49:11.000','2006-02-15T22:21:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14815','552','2','8614','5.99','2005-07-29T13:32:05.000','2006-02-15T22:21:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14816','552','2','8894','4.99','2005-07-30T00:48:31.000','2006-02-15T22:21:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14817','552','1','9342','8.99','2005-07-30T18:09:56.000','2006-02-15T22:21:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14818','552','1','11146','1.99','2005-08-02T09:45:32.000','2006-02-15T22:21:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14819','552','2','11205','4.99','2005-08-02T11:56:54.000','2006-02-15T22:21:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14820','552','2','11300','7.99','2005-08-02T15:37:42.000','2006-02-15T22:21:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14821','552','2','12433','4.99','2005-08-18T10:37:49.000','2006-02-15T22:21:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14822','552','2','12880','2.99','2005-08-19T03:27:17.000','2006-02-15T22:21:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14823','552','2','13574','2.99','2005-08-20T05:10:39.000','2006-02-15T22:21:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14824','552','1','13693','0.99','2005-08-20T09:11:42.000','2006-02-15T22:21:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14825','552','2','14724','4.99','2005-08-21T21:53:47.000','2006-02-15T22:21:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14826','552','2','15700','2.99','2005-08-23T10:21:21.000','2006-02-15T22:21:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14827','553','2','789','4.99','2005-05-29T16:17:07.000','2006-02-15T22:21:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14828','553','2','1862','3.99','2005-06-17T01:29:30.000','2006-02-15T22:21:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14829','553','1','2460','8.99','2005-06-18T19:54:13.000','2006-02-15T22:21:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14830','553','2','3103','6.99','2005-06-20T16:58:19.000','2006-02-15T22:21:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14831','553','1','3495','6.99','2005-07-05T23:50:04.000','2006-02-15T22:21:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14832','553','2','3793','4.99','2005-07-06T14:32:44.000','2006-02-15T22:21:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14833','553','2','3859','2.99','2005-07-06T17:18:15.000','2006-02-15T22:21:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14834','553','1','3890','4.99','2005-07-06T18:58:15.000','2006-02-15T22:21:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14835','553','2','3891','4.99','2005-07-06T18:58:25.000','2006-02-15T22:21:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14836','553','2','3942','4.99','2005-07-06T21:21:34.000','2006-02-15T22:21:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14837','553','1','4257','4.99','2005-07-07T14:18:41.000','2006-02-15T22:21:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14838','553','2','4662','0.99','2005-07-08T09:58:54.000','2006-02-15T22:21:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14839','553','2','4845','4.99','2005-07-08T18:28:20.000','2006-02-15T22:21:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14840','553','2','4941','3.99','2005-07-08T22:39:10.000','2006-02-15T22:21:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14841','553','1','6069','2.99','2005-07-11T04:44:59.000','2006-02-15T22:21:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14842','553','2','6657','0.99','2005-07-12T11:11:36.000','2006-02-15T22:21:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14843','553','1','6812','6.99','2005-07-12T18:03:25.000','2006-02-15T22:21:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14844','553','1','7890','4.99','2005-07-28T10:43:40.000','2006-02-15T22:21:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14845','553','2','9272','4.99','2005-07-30T15:05:22.000','2006-02-15T22:21:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14846','553','2','9601','2.99','2005-07-31T03:42:17.000','2006-02-15T22:21:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14847','553','2','11710','4.99','2005-08-17T07:29:44.000','2006-02-15T22:21:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14848','553','1','13972','2.99','2005-08-20T18:52:17.000','2006-02-15T22:21:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14849','553','1','15042','4.99','2005-08-22T09:47:37.000','2006-02-15T22:21:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14850','553','1','15506','0.99','2005-08-23T02:48:24.000','2006-02-15T22:21:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14851','554','1','607','2.99','2005-05-28T15:02:41.000','2006-02-15T22:21:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14852','554','1','817','2.99','2005-05-29T20:39:14.000','2006-02-15T22:21:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14853','554','1','1959','4.99','2005-06-17T08:54:10.000','2006-02-15T22:21:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14854','554','1','2279','6.99','2005-06-18T06:38:22.000','2006-02-15T22:21:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14855','554','2','3278','2.99','2005-06-21T05:41:30.000','2006-02-15T22:21:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14856','554','1','3312','6.99','2005-06-21T08:05:32.000','2006-02-15T22:21:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14857','554','2','4902','4.99','2005-07-08T20:49:30.000','2006-02-15T22:21:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14858','554','1','5527','2.99','2005-07-10T02:06:01.000','2006-02-15T22:21:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14859','554','1','5968','5.99','2005-07-11T00:03:11.000','2006-02-15T22:21:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14860','554','1','6144','2.99','2005-07-11T09:02:53.000','2006-02-15T22:21:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14861','554','1','10612','6.99','2005-08-01T14:55:31.000','2006-02-15T22:21:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14862','554','2','10829','7.99','2005-08-01T23:17:06.000','2006-02-15T22:21:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14863','554','2','11589','9.99','2005-08-17T02:28:22.000','2006-02-15T22:21:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14864','554','1','11873','0.99','2005-08-17T14:14:39.000','2006-02-15T22:21:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14865','554','1','12010','8.99','2005-08-17T19:17:54.000','2006-02-15T22:21:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14866','554','1','12014','0.99','2005-08-17T19:29:44.000','2006-02-15T22:21:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14867','554','2','13139','4.99','2005-08-19T12:32:10.000','2006-02-15T22:21:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14868','554','2','14015','2.99','2005-08-20T20:47:43.000','2006-02-15T22:21:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14869','554','1','14098','3.99','2005-08-21T00:30:32.000','2006-02-15T22:21:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14870','554','1','14469','0.99','2005-08-21T13:07:24.000','2006-02-15T22:21:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14871','554','1','14626','2.99','2005-08-21T18:35:44.000','2006-02-15T22:21:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14872','554','2','15690','4.99','2005-08-23T09:53:30.000','2006-02-15T22:21:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14873','555','2','3232','1.99','2005-06-21T02:30:37.000','2006-02-15T22:21:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14874','555','2','4875','2.99','2005-07-08T19:24:17.000','2006-02-15T22:21:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14875','555','1','8161','0.99','2005-07-28T21:11:00.000','2006-02-15T22:21:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14876','555','1','8245','3.99','2005-07-29T00:37:09.000','2006-02-15T22:21:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14877','555','1','9299','5.99','2005-07-30T16:32:51.000','2006-02-15T22:21:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14878','555','2','9990','7.99','2005-07-31T17:24:21.000','2006-02-15T22:21:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14879','555','2','10076','7.99','2005-07-31T20:00:34.000','2006-02-15T22:21:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14880','555','1','10921','3.99','2005-08-02T02:14:33.000','2006-02-15T22:21:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14881','555','1','11168','4.99','2005-08-02T10:19:42.000','2006-02-15T22:21:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14882','555','1','11718','4.99','2005-08-17T07:44:42.000','2006-02-15T22:21:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14883','555','2','11747','2.99','2005-08-17T09:03:31.000','2006-02-15T22:21:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14884','555','2','12091','4.99','2005-08-17T22:22:50.000','2006-02-15T22:21:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14885','555','2','12150','2.99','2005-08-18T00:13:55.000','2006-02-15T22:21:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14886','555','2','12182','2.99','2005-08-18T01:30:19.000','2006-02-15T22:21:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14887','555','1','12388','2.99','2005-08-18T08:48:09.000','2006-02-15T22:21:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14888','555','1','12883','4.99','2005-08-19T03:33:47.000','2006-02-15T22:21:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14889','555','2','15102','6.99','2005-08-22T11:58:58.000','2006-02-15T22:21:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14890','556','1','184','0.99','2005-05-26T05:29:49.000','2006-02-15T22:21:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14891','556','2','772','5.99','2005-05-29T13:08:06.000','2006-02-15T22:21:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14892','556','1','1083','3.99','2005-05-31T11:04:48.000','2006-02-15T22:21:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14893','556','1','2092','6.99','2005-06-17T18:12:16.000','2006-02-15T22:21:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14894','556','2','2593','5.99','2005-06-19T05:40:11.000','2006-02-15T22:21:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14895','556','2','2986','0.99','2005-06-20T08:50:28.000','2006-02-15T22:21:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14896','556','1','3093','4.99','2005-06-20T16:06:14.000','2006-02-15T22:21:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14897','556','2','3438','6.99','2005-06-21T19:31:40.000','2006-02-15T22:21:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14898','556','2','4719','2.99','2005-07-08T12:33:00.000','2006-02-15T22:21:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14899','556','2','4839','3.99','2005-07-08T18:13:10.000','2006-02-15T22:21:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14900','556','1','4846','0.99','2005-07-08T18:29:05.000','2006-02-15T22:21:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14901','556','2','5722','0.99','2005-07-10T11:10:04.000','2006-02-15T22:21:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14902','556','2','6484','2.99','2005-07-12T02:04:10.000','2006-02-15T22:21:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14903','556','1','8909','5.99','2005-07-30T01:28:03.000','2006-02-15T22:21:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14904','556','2','10106','4.99','2005-07-31T21:00:47.000','2006-02-15T22:21:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14905','556','2','10518','6.99','2005-08-01T11:44:08.000','2006-02-15T22:21:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14906','556','1','11466','1.99','2005-08-02T21:46:46.000','2006-02-15T22:21:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14907','556','2','11804','3.99','2005-08-17T11:42:45.000','2006-02-15T22:21:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14908','556','1','12045','4.99','2005-08-17T20:40:46.000','2006-02-15T22:21:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14909','556','1','14176','2.99','2005-08-21T03:09:23.000','2006-02-15T22:21:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14910','556','1','15568','2.99','2005-08-23T05:24:09.000','2006-02-15T22:21:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14911','557','2','467','4.99','2005-05-27T21:10:03.000','2006-02-15T22:21:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14912','557','1','478','4.99','2005-05-27T22:38:20.000','2006-02-15T22:21:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14913','557','1','1666','0.99','2005-06-16T10:17:19.000','2006-02-15T22:21:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14914','557','2','2988','6.99','2005-06-20T08:59:08.000','2006-02-15T22:21:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14915','557','1','3050','3.99','2005-06-20T13:03:03.000','2006-02-15T22:21:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14916','557','1','4651','0.99','2005-07-08T09:39:39.000','2006-02-15T22:21:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14917','557','1','4851','1.99','2005-07-08T18:40:05.000','2006-02-15T22:21:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14918','557','1','6459','0.99','2005-07-12T01:12:03.000','2006-02-15T22:21:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14919','557','2','6713','3.99','2005-07-12T13:27:36.000','2006-02-15T22:21:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14920','557','2','6823','4.99','2005-07-12T18:24:31.000','2006-02-15T22:21:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14921','557','2','6898','0.99','2005-07-12T21:39:04.000','2006-02-15T22:21:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14922','557','1','9336','0.99','2005-07-30T18:01:15.000','2006-02-15T22:21:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14923','557','1','9341','2.99','2005-07-30T18:07:58.000','2006-02-15T22:21:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14924','557','2','9366','1.99','2005-07-30T18:48:57.000','2006-02-15T22:21:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14925','557','2','9367','6.99','2005-07-30T18:49:58.000','2006-02-15T22:21:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14926','557','1','11181','0.99','2005-08-02T10:55:03.000','2006-02-15T22:21:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14927','557','1','12555','1.99','2005-08-18T14:49:22.000','2006-02-15T22:21:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14928','557','1','12789','2.99','2005-08-19T00:16:19.000','2006-02-15T22:21:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14929','557','1','13540','2.99','2005-08-20T03:41:23.000','2006-02-15T22:21:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14930','557','2','13794','2.99','2005-08-20T12:25:32.000','2006-02-15T22:21:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14931','557','2','15236','0.99','2005-08-22T17:44:27.000','2006-02-15T22:21:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14932','557','2','15570','5.99','2005-08-23T05:24:55.000','2006-02-15T22:21:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14933','557','2','15914','0.99','2005-08-23T17:49:26.000','2006-02-15T22:21:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14934','557','1','14278','4.99','2006-02-14T15:16:03.000','2006-02-15T22:21:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14935','558','2','1967','4.99','2005-06-17T09:19:52.000','2006-02-15T22:21:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14936','558','1','2411','1.99','2005-06-18T16:55:54.000','2006-02-15T22:21:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14937','558','2','2544','4.99','2005-06-19T02:16:17.000','2006-02-15T22:21:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14938','558','2','3016','4.99','2005-06-20T10:55:08.000','2006-02-15T22:21:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14939','558','2','3451','10.99','2005-06-21T21:10:39.000','2006-02-15T22:21:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14940','558','1','3731','9.99','2005-07-06T11:33:36.000','2006-02-15T22:21:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14941','558','1','3954','0.99','2005-07-06T21:57:44.000','2006-02-15T22:21:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14942','558','1','3990','3.99','2005-07-06T23:32:44.000','2006-02-15T22:21:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14943','558','1','4192','5.99','2005-07-07T10:57:06.000','2006-02-15T22:21:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14944','558','1','4932','2.99','2005-07-08T22:17:40.000','2006-02-15T22:21:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14945','558','2','5375','6.99','2005-07-09T18:52:55.000','2006-02-15T22:21:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14946','558','1','5492','3.99','2005-07-10T00:11:09.000','2006-02-15T22:21:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14947','558','2','6278','7.99','2005-07-11T16:20:02.000','2006-02-15T22:21:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14948','558','2','6479','9.99','2005-07-12T01:49:00.000','2006-02-15T22:21:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14949','558','2','6742','4.99','2005-07-12T14:25:31.000','2006-02-15T22:21:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14950','558','1','6757','0.99','2005-07-12T15:09:48.000','2006-02-15T22:21:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14951','558','1','7424','0.99','2005-07-27T17:14:19.000','2006-02-15T22:21:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14952','558','1','8523','2.99','2005-07-29T10:18:27.000','2006-02-15T22:21:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14953','558','1','8858','4.99','2005-07-29T23:44:35.000','2006-02-15T22:21:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14954','558','1','8889','2.99','2005-07-30T00:39:43.000','2006-02-15T22:21:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14955','558','2','10707','0.99','2005-08-01T18:41:34.000','2006-02-15T22:21:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14956','558','1','11268','0.99','2005-08-02T14:10:39.000','2006-02-15T22:21:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14957','558','2','11567','5.99','2005-08-17T01:28:43.000','2006-02-15T22:21:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14958','558','2','12040','6.99','2005-08-17T20:29:56.000','2006-02-15T22:21:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14959','558','1','12194','1.99','2005-08-18T02:04:47.000','2006-02-15T22:21:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14960','558','2','13566','5.99','2005-08-20T04:45:32.000','2006-02-15T22:21:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14961','558','2','14235','7.99','2005-08-21T05:08:42.000','2006-02-15T22:21:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14962','558','1','14286','5.99','2005-08-21T06:53:53.000','2006-02-15T22:21:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14963','559','2','2576','4.99','2005-06-19T04:34:15.000','2006-02-15T22:21:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14964','559','1','2706','0.99','2005-06-19T13:56:51.000','2006-02-15T22:21:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14965','559','2','3046','4.99','2005-06-20T12:42:59.000','2006-02-15T22:21:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14966','559','1','3370','1.99','2005-06-21T13:27:01.000','2006-02-15T22:21:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14967','559','1','3674','5.99','2005-07-06T09:03:13.000','2006-02-15T22:21:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14968','559','1','4120','4.99','2005-07-07T07:07:03.000','2006-02-15T22:21:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14969','559','1','4370','7.99','2005-07-07T20:05:36.000','2006-02-15T22:21:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14970','559','2','5396','1.99','2005-07-09T19:42:52.000','2006-02-15T22:21:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14971','559','1','6201','4.99','2005-07-11T12:18:07.000','2006-02-15T22:21:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14972','559','1','6915','2.99','2005-07-12T22:28:09.000','2006-02-15T22:21:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14973','559','1','7169','1.99','2005-07-27T07:51:39.000','2006-02-15T22:21:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14974','559','1','7680','1.99','2005-07-28T02:59:08.000','2006-02-15T22:21:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14975','559','1','8631','1.99','2005-07-29T14:08:06.000','2006-02-15T22:21:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14976','559','2','9134','0.99','2005-07-30T10:00:21.000','2006-02-15T22:21:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14977','559','1','9877','2.99','2005-07-31T13:41:57.000','2006-02-15T22:21:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14978','559','2','10146','2.99','2005-07-31T22:17:56.000','2006-02-15T22:21:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14979','559','1','10377','3.99','2005-08-01T06:28:28.000','2006-02-15T22:21:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14980','559','1','10669','8.99','2005-08-01T17:03:28.000','2006-02-15T22:21:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14981','559','2','10876','0.99','2005-08-02T00:31:58.000','2006-02-15T22:21:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14982','559','2','11136','1.99','2005-08-02T09:22:57.000','2006-02-15T22:21:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14983','559','1','13234','1.99','2005-08-19T16:17:15.000','2006-02-15T22:21:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14984','559','2','13248','6.99','2005-08-19T16:47:41.000','2006-02-15T22:21:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14985','559','2','13322','4.99','2005-08-19T19:43:08.000','2006-02-15T22:21:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14986','559','1','13845','5.99','2005-08-20T14:31:21.000','2006-02-15T22:21:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14987','559','1','14342','4.99','2005-08-21T08:39:26.000','2006-02-15T22:22:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14988','559','2','14622','4.99','2005-08-21T18:25:59.000','2006-02-15T22:22:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14989','559','2','15440','4.99','2005-08-23T00:37:21.000','2006-02-15T22:22:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14990','559','1','15877','4.99','2005-08-23T16:33:33.000','2006-02-15T22:22:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14991','560','1','137','2.99','2005-05-25T22:25:18.000','2006-02-15T22:22:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14992','560','1','1271','4.99','2005-06-15T07:32:24.000','2006-02-15T22:22:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14993','560','2','1572','1.99','2005-06-16T03:23:22.000','2006-02-15T22:22:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14994','560','1','3941','4.99','2005-07-06T21:20:37.000','2006-02-15T22:22:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14995','560','1','4298','2.99','2005-07-07T16:27:25.000','2006-02-15T22:22:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14996','560','2','4375','9.99','2005-07-07T20:20:29.000','2006-02-15T22:22:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14997','560','1','4453','0.99','2005-07-07T23:32:39.000','2006-02-15T22:22:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14998','560','2','5208','2.99','2005-07-09T11:16:56.000','2006-02-15T22:22:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('14999','560','1','6410','4.99','2005-07-11T23:08:06.000','2006-02-15T22:22:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15000','560','1','6945','2.99','2005-07-26T23:35:29.000','2006-02-15T22:22:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15001','560','2','7202','4.99','2005-07-27T09:00:20.000','2006-02-15T22:22:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15002','560','1','7891','3.99','2005-07-28T10:43:56.000','2006-02-15T22:22:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15003','560','1','8753','2.99','2005-07-29T19:15:50.000','2006-02-15T22:22:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15004','560','2','8861','5.99','2005-07-29T23:47:29.000','2006-02-15T22:22:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15005','560','2','8906','4.99','2005-07-30T01:21:39.000','2006-02-15T22:22:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15006','560','1','9265','0.99','2005-07-30T14:55:25.000','2006-02-15T22:22:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15007','560','2','9895','5.99','2005-07-31T14:07:56.000','2006-02-15T22:22:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15008','560','2','10480','4.99','2005-08-01T10:13:41.000','2006-02-15T22:22:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15009','560','1','10702','4.99','2005-08-01T18:34:59.000','2006-02-15T22:22:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15010','560','1','10733','7.99','2005-08-01T19:28:01.000','2006-02-15T22:22:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15011','560','1','11334','7.99','2005-08-02T16:53:20.000','2006-02-15T22:22:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15012','560','1','11788','4.99','2005-08-17T10:59:18.000','2006-02-15T22:22:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15013','560','2','14008','5.99','2005-08-20T20:26:00.000','2006-02-15T22:22:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15014','560','1','14341','1.99','2005-08-21T08:38:24.000','2006-02-15T22:22:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15015','560','2','14363','4.99','2005-08-21T09:20:03.000','2006-02-15T22:22:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15016','560','1','14436','2.99','2005-08-21T11:48:27.000','2006-02-15T22:22:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15017','560','2','14785','2.99','2005-08-22T00:24:37.000','2006-02-15T22:22:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15018','560','1','15352','6.99','2005-08-22T21:16:54.000','2006-02-15T22:22:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15019','560','2','12116','5.98','2006-02-14T15:16:03.000','2006-02-15T22:22:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15020','560','2','14425','0','2006-02-14T15:16:03.000','2006-02-15T22:22:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15021','561','1','902','4.99','2005-05-30T09:53:36.000','2006-02-15T22:22:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15022','561','2','971','4.99','2005-05-30T20:10:52.000','2006-02-15T22:22:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15023','561','2','1193','2.99','2005-06-15T01:24:20.000','2006-02-15T22:22:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15024','561','2','1505','2.99','2005-06-15T22:12:50.000','2006-02-15T22:22:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15025','561','2','1620','4.99','2005-06-16T07:21:30.000','2006-02-15T22:22:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15026','561','1','2119','4.99','2005-06-17T20:34:42.000','2006-02-15T22:22:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15027','561','1','2357','5.99','2005-06-18T12:59:41.000','2006-02-15T22:22:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15028','561','1','2548','0.99','2005-06-19T02:45:35.000','2006-02-15T22:22:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15029','561','1','2950','4.99','2005-06-20T06:08:36.000','2006-02-15T22:22:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15030','561','1','3160','4.99','2005-06-20T21:20:51.000','2006-02-15T22:22:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15031','561','1','3427','0.99','2005-06-21T18:31:09.000','2006-02-15T22:22:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15032','561','2','6361','2.99','2005-07-11T21:09:14.000','2006-02-15T22:22:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15033','561','1','6435','0.99','2005-07-12T00:16:19.000','2006-02-15T22:22:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15034','561','1','6621','0.99','2005-07-12T08:57:30.000','2006-02-15T22:22:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15035','561','1','6843','4.99','2005-07-12T19:14:05.000','2006-02-15T22:22:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15036','561','1','7698','0.99','2005-07-28T03:44:14.000','2006-02-15T22:22:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15037','561','1','8504','10.99','2005-07-29T09:20:16.000','2006-02-15T22:22:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15038','561','2','9839','7.99','2005-07-31T12:21:16.000','2006-02-15T22:22:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15039','561','2','10317','2.99','2005-08-01T04:35:34.000','2006-02-15T22:22:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15040','561','1','10907','4.99','2005-08-02T01:51:48.000','2006-02-15T22:22:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15041','561','1','11371','2.99','2005-08-02T18:07:36.000','2006-02-15T22:22:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15042','561','2','11402','2.99','2005-08-02T19:07:21.000','2006-02-15T22:22:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15043','561','2','12441','2.99','2005-08-18T10:47:57.000','2006-02-15T22:22:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15044','561','2','14139','0.99','2005-08-21T02:04:33.000','2006-02-15T22:22:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15045','561','1','15573','0.99','2005-08-23T05:28:36.000','2006-02-15T22:22:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15046','561','1','15946','2.99','2005-08-23T18:54:07.000','2006-02-15T22:22:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15047','561','1','14415','0.99','2006-02-14T15:16:03.000','2006-02-15T22:22:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15048','562','2','788','2.99','2005-05-29T16:13:55.000','2006-02-15T22:22:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15049','562','1','941','2.99','2005-05-30T15:02:25.000','2006-02-15T22:22:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15050','562','1','1139','5.99','2005-05-31T19:34:52.000','2006-02-15T22:22:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15051','562','1','1998','3.99','2005-06-17T11:24:57.000','2006-02-15T22:22:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15052','562','1','2705','4.99','2005-06-19T13:54:30.000','2006-02-15T22:22:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15053','562','1','2746','3.99','2005-06-19T16:21:40.000','2006-02-15T22:22:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15054','562','2','3242','4.99','2005-06-21T02:56:24.000','2006-02-15T22:22:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15055','562','2','4732','5.99','2005-07-08T13:09:45.000','2006-02-15T22:22:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15056','562','1','4802','4.99','2005-07-08T16:55:17.000','2006-02-15T22:22:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15057','562','2','5360','0.99','2005-07-09T18:14:03.000','2006-02-15T22:22:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15058','562','2','6065','6.99','2005-07-11T04:25:51.000','2006-02-15T22:22:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15059','562','1','6607','8.99','2005-07-12T08:08:50.000','2006-02-15T22:22:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15060','562','2','7166','3.99','2005-07-27T07:36:56.000','2006-02-15T22:22:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15061','562','1','7430','2.99','2005-07-27T17:26:14.000','2006-02-15T22:22:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15062','562','2','7560','2.99','2005-07-27T22:20:17.000','2006-02-15T22:22:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15063','562','2','8132','0.99','2005-07-28T19:57:31.000','2006-02-15T22:22:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15064','562','2','10868','6.99','2005-08-02T00:25:15.000','2006-02-15T22:22:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15065','562','2','12008','4.99','2005-08-17T19:16:18.000','2006-02-15T22:22:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15066','562','1','12248','5.99','2005-08-18T03:53:18.000','2006-02-15T22:22:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15067','562','2','13225','2.99','2005-08-19T15:54:33.000','2006-02-15T22:22:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15068','562','2','13347','10.99','2005-08-19T20:28:48.000','2006-02-15T22:22:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15069','562','2','13639','0.99','2005-08-20T07:22:07.000','2006-02-15T22:22:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15070','562','1','15212','2.99','2005-08-22T16:44:26.000','2006-02-15T22:22:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15071','562','2','15475','2.99','2005-08-23T01:44:43.000','2006-02-15T22:22:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15072','562','1','15900','1.99','2005-08-23T17:16:30.000','2006-02-15T22:22:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15073','563','1','758','4.99','2005-05-29T10:31:56.000','2006-02-15T22:22:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15074','563','2','773','5.99','2005-05-29T13:18:05.000','2006-02-15T22:22:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15075','563','2','1545','4.99','2005-06-16T01:31:23.000','2006-02-15T22:22:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15076','563','2','2573','0.99','2005-06-19T04:23:18.000','2006-02-15T22:22:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15077','563','1','4106','1.99','2005-07-07T06:33:35.000','2006-02-15T22:22:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15078','563','2','4436','0.99','2005-07-07T22:52:04.000','2006-02-15T22:22:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15079','563','1','4565','3.99','2005-07-08T05:12:28.000','2006-02-15T22:22:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15080','563','2','4629','6.99','2005-07-08T08:31:26.000','2006-02-15T22:22:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15081','563','2','4711','2.99','2005-07-08T12:06:58.000','2006-02-15T22:22:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15082','563','2','4776','5.99','2005-07-08T15:44:20.000','2006-02-15T22:22:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15083','563','2','4808','3.99','2005-07-08T17:02:49.000','2006-02-15T22:22:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15084','563','2','4825','4.99','2005-07-08T17:43:01.000','2006-02-15T22:22:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15085','563','1','4883','0.99','2005-07-08T19:46:58.000','2006-02-15T22:22:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15086','563','1','5406','0.99','2005-07-09T20:13:23.000','2006-02-15T22:22:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15087','563','2','6326','2.99','2005-07-11T19:06:55.000','2006-02-15T22:22:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15088','563','2','7612','0.99','2005-07-28T00:11:55.000','2006-02-15T22:22:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15089','563','1','8262','1.99','2005-07-29T01:11:18.000','2006-02-15T22:22:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15090','563','1','8610','5.99','2005-07-29T13:25:02.000','2006-02-15T22:22:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15091','563','2','8632','6.99','2005-07-29T14:11:25.000','2006-02-15T22:22:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15092','563','2','8812','7.99','2005-07-29T21:47:40.000','2006-02-15T22:22:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15093','563','2','11829','0.99','2005-08-17T12:52:04.000','2006-02-15T22:22:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15094','563','1','12039','1.99','2005-08-17T20:29:08.000','2006-02-15T22:22:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15095','563','1','12202','1.99','2005-08-18T02:14:08.000','2006-02-15T22:22:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15096','563','1','12832','2.99','2005-08-19T01:41:44.000','2006-02-15T22:22:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15097','563','2','13863','9.99','2005-08-20T14:57:50.000','2006-02-15T22:22:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15098','563','2','14592','4.99','2005-08-21T17:30:17.000','2006-02-15T22:22:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15099','563','2','15507','0.99','2005-08-23T02:48:26.000','2006-02-15T22:22:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15100','563','2','15638','3.99','2005-08-23T07:54:54.000','2006-02-15T22:22:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15101','563','1','15850','4.99','2005-08-23T15:45:42.000','2006-02-15T22:22:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15102','564','2','195','5.99','2005-05-26T06:52:36.000','2006-02-15T22:22:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15103','564','1','985','2.99','2005-05-30T22:18:35.000','2006-02-15T22:22:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15104','564','2','1705','2.99','2005-06-16T13:59:42.000','2006-02-15T22:22:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15105','564','1','4196','2.99','2005-07-07T11:06:33.000','2006-02-15T22:22:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15106','564','2','4385','0.99','2005-07-07T20:48:38.000','2006-02-15T22:22:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15107','564','1','6973','2.99','2005-07-27T00:32:04.000','2006-02-15T22:22:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15108','564','2','7470','10.99','2005-07-27T19:01:03.000','2006-02-15T22:22:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15109','564','2','8426','4.99','2005-07-29T07:07:48.000','2006-02-15T22:22:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15110','564','1','8874','0.99','2005-07-30T00:14:45.000','2006-02-15T22:22:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15111','564','2','9063','3.99','2005-07-30T07:24:34.000','2006-02-15T22:22:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15112','564','2','9929','2.99','2005-07-31T15:17:24.000','2006-02-15T22:22:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15113','564','1','10129','6.99','2005-07-31T21:41:35.000','2006-02-15T22:22:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15114','564','2','10352','1.99','2005-08-01T05:44:36.000','2006-02-15T22:22:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15115','564','2','10401','4.99','2005-08-01T07:27:09.000','2006-02-15T22:22:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15116','564','1','10528','2.99','2005-08-01T11:56:22.000','2006-02-15T22:22:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15117','564','2','11768','2.99','2005-08-17T10:02:29.000','2006-02-15T22:22:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15118','564','2','12197','6.99','2005-08-18T02:08:58.000','2006-02-15T22:22:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15119','564','2','12617','2.99','2005-08-18T17:22:48.000','2006-02-15T22:22:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15120','564','2','13324','0.99','2005-08-19T19:51:00.000','2006-02-15T22:22:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15121','564','2','13558','0.99','2005-08-20T04:13:17.000','2006-02-15T22:22:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15122','564','1','13701','0.99','2005-08-20T09:27:05.000','2006-02-15T22:22:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15123','564','2','14439','5.99','2005-08-21T11:52:41.000','2006-02-15T22:22:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15124','564','1','14593','0.99','2005-08-21T17:33:18.000','2006-02-15T22:22:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15125','564','2','15059','8.99','2005-08-22T10:22:00.000','2006-02-15T22:22:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15126','565','1','458','6.99','2005-05-27T19:58:36.000','2006-02-15T22:22:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15127','565','1','1004','0.99','2005-05-31T00:48:36.000','2006-02-15T22:22:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15128','565','2','1460','4.99','2005-06-15T20:27:02.000','2006-02-15T22:22:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15129','565','1','2321','5.99','2005-06-18T09:42:42.000','2006-02-15T22:22:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15130','565','1','3300','5.99','2005-06-21T07:25:01.000','2006-02-15T22:22:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15131','565','2','3470','0.99','2005-07-05T22:49:24.000','2006-02-15T22:22:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15132','565','1','3838','2.99','2005-07-06T16:29:43.000','2006-02-15T22:22:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15133','565','1','4413','2.99','2005-07-07T22:00:04.000','2006-02-15T22:22:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15134','565','2','5020','0.99','2005-07-09T02:07:56.000','2006-02-15T22:22:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15135','565','1','5124','4.99','2005-07-09T07:25:19.000','2006-02-15T22:22:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15136','565','1','6264','2.99','2005-07-11T15:42:35.000','2006-02-15T22:22:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15137','565','1','6627','2.99','2005-07-12T09:16:46.000','2006-02-15T22:22:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15138','565','1','6699','0.99','2005-07-12T12:45:21.000','2006-02-15T22:22:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15139','565','2','7242','5.99','2005-07-27T10:25:51.000','2006-02-15T22:22:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15140','565','1','9628','2.99','2005-07-31T04:51:11.000','2006-02-15T22:22:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15141','565','1','10025','5.99','2005-07-31T18:29:09.000','2006-02-15T22:22:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15142','565','2','10776','10.99','2005-08-01T20:59:58.000','2006-02-15T22:22:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15143','565','2','10913','3.99','2005-08-02T02:04:03.000','2006-02-15T22:22:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15144','565','2','11189','6.99','2005-08-02T11:17:23.000','2006-02-15T22:22:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15145','565','1','11399','3.99','2005-08-02T18:56:28.000','2006-02-15T22:22:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15146','565','2','11506','4.99','2005-08-16T23:25:48.000','2006-02-15T22:22:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15147','565','1','11588','3.99','2005-08-17T02:26:23.000','2006-02-15T22:22:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15148','565','1','11795','2.99','2005-08-17T11:13:38.000','2006-02-15T22:22:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15149','565','2','12743','5.99','2005-08-18T22:22:31.000','2006-02-15T22:22:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15150','565','2','13195','4.99','2005-08-19T14:39:14.000','2006-02-15T22:22:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15151','565','2','13217','4.99','2005-08-19T15:38:39.000','2006-02-15T22:22:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15152','565','1','13362','0.99','2005-08-19T21:07:54.000','2006-02-15T22:22:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15153','565','1','13925','8.99','2005-08-20T17:05:34.000','2006-02-15T22:22:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15154','565','1','15885','2.99','2005-08-23T16:50:43.000','2006-02-15T22:22:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15155','566','2','234','5.99','2005-05-26T11:47:20.000','2006-02-15T22:22:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15156','566','2','768','4.99','2005-05-29T12:30:46.000','2006-02-15T22:22:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15157','566','1','1635','5.99','2005-06-16T08:26:56.000','2006-02-15T22:22:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15158','566','2','1982','4.99','2005-06-17T10:12:15.000','2006-02-15T22:22:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15159','566','1','2367','0.99','2005-06-18T14:00:31.000','2006-02-15T22:22:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15160','566','1','3379','4.99','2005-06-21T13:54:58.000','2006-02-15T22:22:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15161','566','2','3663','4.99','2005-07-06T08:15:47.000','2006-02-15T22:22:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15162','566','1','3943','0.99','2005-07-06T21:22:17.000','2006-02-15T22:22:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15163','566','1','3998','3.99','2005-07-06T23:49:20.000','2006-02-15T22:22:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15164','566','1','5079','9.99','2005-07-09T05:20:40.000','2006-02-15T22:22:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15165','566','2','6365','2.99','2005-07-11T21:17:40.000','2006-02-15T22:22:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15166','566','1','7677','2.99','2005-07-28T02:56:37.000','2006-02-15T22:22:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15167','566','2','7941','0.99','2005-07-28T12:47:20.000','2006-02-15T22:22:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15168','566','2','8118','2.99','2005-07-28T19:22:22.000','2006-02-15T22:22:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15169','566','1','8157','6.99','2005-07-28T21:06:45.000','2006-02-15T22:22:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15170','566','1','8257','2.99','2005-07-29T01:03:20.000','2006-02-15T22:22:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15171','566','2','8305','1.99','2005-07-29T03:08:47.000','2006-02-15T22:22:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15172','566','2','8660','6.99','2005-07-29T15:26:59.000','2006-02-15T22:22:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15173','566','1','8710','0.99','2005-07-29T17:26:03.000','2006-02-15T22:22:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15174','566','1','8797','4.99','2005-07-29T21:10:37.000','2006-02-15T22:22:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15175','566','2','9101','4.99','2005-07-30T08:47:13.000','2006-02-15T22:22:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15176','566','2','9470','4.99','2005-07-30T23:01:31.000','2006-02-15T22:22:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15177','566','1','9688','3.99','2005-07-31T06:56:08.000','2006-02-15T22:22:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15178','566','2','9915','2.99','2005-07-31T14:52:26.000','2006-02-15T22:22:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15179','566','2','10259','2.99','2005-08-01T02:52:05.000','2006-02-15T22:22:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15180','566','2','10289','6.99','2005-08-01T03:39:48.000','2006-02-15T22:22:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15181','566','2','11129','2.99','2005-08-02T09:08:44.000','2006-02-15T22:22:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15182','566','1','11717','0.99','2005-08-17T07:44:09.000','2006-02-15T22:22:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15183','566','1','11941','1.99','2005-08-17T16:56:57.000','2006-02-15T22:22:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15184','566','2','12382','8.99','2005-08-18T08:32:33.000','2006-02-15T22:22:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15185','566','2','12995','4.99','2005-08-19T07:26:30.000','2006-02-15T22:22:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15186','566','2','13762','4.99','2005-08-20T11:29:32.000','2006-02-15T22:22:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15187','566','1','14277','3.99','2005-08-21T06:34:41.000','2006-02-15T22:22:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15188','566','1','14297','2.99','2005-08-21T07:13:46.000','2006-02-15T22:22:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15189','567','2','2689','4.99','2005-06-19T12:58:53.000','2006-02-15T22:22:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15190','567','1','3010','2.99','2005-06-20T10:29:59.000','2006-02-15T22:22:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15191','567','1','3769','5.99','2005-07-06T13:11:33.000','2006-02-15T22:22:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15192','567','2','4457','0.99','2005-07-07T23:45:38.000','2006-02-15T22:22:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15193','567','2','4576','0.99','2005-07-08T05:51:19.000','2006-02-15T22:22:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15194','567','1','4949','4.99','2005-07-08T22:57:10.000','2006-02-15T22:22:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15195','567','2','6358','2.99','2005-07-11T21:03:12.000','2006-02-15T22:22:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15196','567','2','6551','0.99','2005-07-12T05:03:43.000','2006-02-15T22:22:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15197','567','2','7340','2.99','2005-07-27T14:18:10.000','2006-02-15T22:22:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15198','567','1','8201','2.99','2005-07-28T23:10:48.000','2006-02-15T22:22:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15199','567','1','8629','2.99','2005-07-29T14:06:35.000','2006-02-15T22:22:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15200','567','1','9279','7.99','2005-07-30T15:15:21.000','2006-02-15T22:22:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15201','567','1','9475','6.99','2005-07-30T23:06:33.000','2006-02-15T22:22:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15202','567','2','10708','7.99','2005-08-01T18:43:28.000','2006-02-15T22:22:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15203','567','2','11749','2.99','2005-08-17T09:04:03.000','2006-02-15T22:22:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15204','567','1','12119','2.99','2005-08-17T23:16:44.000','2006-02-15T22:22:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15205','567','2','13031','2.99','2005-08-19T08:30:04.000','2006-02-15T22:22:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15206','567','2','14839','2.99','2005-08-22T01:58:15.000','2006-02-15T22:22:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15207','567','2','15074','5.99','2005-08-22T11:02:52.000','2006-02-15T22:22:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15208','567','2','15594','10.99','2005-08-23T06:18:43.000','2006-02-15T22:22:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15209','568','2','1658','4.99','2005-06-16T10:07:10.000','2006-02-15T22:22:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15210','568','2','2382','4.99','2005-06-18T15:03:52.000','2006-02-15T22:22:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15211','568','2','2668','0.99','2005-06-19T11:28:47.000','2006-02-15T22:22:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15212','568','1','3227','4.99','2005-06-21T02:18:25.000','2006-02-15T22:22:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15213','568','2','3462','1.99','2005-06-21T21:52:52.000','2006-02-15T22:22:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15214','568','1','4322','2.99','2005-07-07T17:54:37.000','2006-02-15T22:22:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15215','568','2','5332','2.99','2005-07-09T16:59:23.000','2006-02-15T22:22:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15216','568','1','5622','0.99','2005-07-10T05:39:37.000','2006-02-15T22:22:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15217','568','1','5776','4.99','2005-07-10T13:35:22.000','2006-02-15T22:22:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15218','568','2','7068','2.99','2005-07-27T03:57:50.000','2006-02-15T22:22:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15219','568','2','8185','0.99','2005-07-28T22:23:49.000','2006-02-15T22:22:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15220','568','2','9583','6.99','2005-07-31T03:05:21.000','2006-02-15T22:22:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15221','568','1','9738','0.99','2005-07-31T09:04:14.000','2006-02-15T22:22:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15222','568','1','10340','2.99','2005-08-01T05:07:03.000','2006-02-15T22:22:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15223','568','2','10689','0.99','2005-08-01T18:04:18.000','2006-02-15T22:22:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15224','568','2','10869','0.99','2005-08-02T00:26:54.000','2006-02-15T22:22:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15225','568','1','11331','2.99','2005-08-02T16:49:01.000','2006-02-15T22:22:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15226','568','1','13883','4.99','2005-08-20T15:28:53.000','2006-02-15T22:22:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15227','568','2','15069','5.99','2005-08-22T10:55:42.000','2006-02-15T22:22:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15228','568','1','15203','2.99','2005-08-22T16:28:00.000','2006-02-15T22:22:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15229','568','2','14531','2.99','2006-02-14T15:16:03.000','2006-02-15T22:22:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15230','569','2','53','4.99','2005-05-25T07:19:16.000','2006-02-15T22:22:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15231','569','1','487','4.99','2005-05-28T00:00:30.000','2006-02-15T22:22:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15232','569','1','624','4.99','2005-05-28T16:13:22.000','2006-02-15T22:22:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15233','569','1','647','1.99','2005-05-28T19:22:52.000','2006-02-15T22:22:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15234','569','2','1037','3.99','2005-05-31T05:22:25.000','2006-02-15T22:22:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15235','569','1','1463','6.99','2005-06-15T20:37:51.000','2006-02-15T22:22:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15236','569','2','1668','5.99','2005-06-16T10:19:52.000','2006-02-15T22:22:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15237','569','1','4204','5.99','2005-07-07T11:24:18.000','2006-02-15T22:22:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15238','569','2','5003','0.99','2005-07-09T01:19:03.000','2006-02-15T22:22:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15239','569','2','6046','5.99','2005-07-11T03:21:49.000','2006-02-15T22:22:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15240','569','1','8910','2.99','2005-07-30T01:29:48.000','2006-02-15T22:22:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15241','569','2','9220','1.99','2005-07-30T13:17:27.000','2006-02-15T22:22:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15242','569','1','9399','4.99','2005-07-30T20:14:50.000','2006-02-15T22:22:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15243','569','2','9960','1.99','2005-07-31T16:05:52.000','2006-02-15T22:22:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15244','569','2','10192','2.99','2005-08-01T00:33:00.000','2006-02-15T22:22:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15245','569','2','10884','0.99','2005-08-02T00:47:33.000','2006-02-15T22:22:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15246','569','1','11030','1.99','2005-08-02T05:51:20.000','2006-02-15T22:22:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15247','569','2','11255','4.99','2005-08-02T13:44:30.000','2006-02-15T22:22:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15248','569','1','11354','6.99','2005-08-02T17:35:10.000','2006-02-15T22:22:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15249','569','1','11946','4.99','2005-08-17T17:05:53.000','2006-02-15T22:22:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15250','569','1','12157','2.99','2005-08-18T00:33:45.000','2006-02-15T22:22:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15251','569','2','12308','0.99','2005-08-18T05:48:53.000','2006-02-15T22:22:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15252','569','1','12568','3.99','2005-08-18T15:15:44.000','2006-02-15T22:22:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15253','569','2','12958','2.99','2005-08-19T06:19:21.000','2006-02-15T22:22:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15254','569','1','13287','7.99','2005-08-19T18:28:24.000','2006-02-15T22:22:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15255','569','2','13554','9.99','2005-08-20T04:08:39.000','2006-02-15T22:22:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15256','569','2','14207','4.99','2005-08-21T04:08:19.000','2006-02-15T22:22:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15257','569','2','14400','0.99','2005-08-21T10:33:45.000','2006-02-15T22:22:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15258','569','1','14896','8.99','2005-08-22T04:20:55.000','2006-02-15T22:22:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15259','569','1','14959','2.99','2005-08-22T06:30:28.000','2006-02-15T22:22:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15260','569','2','15617','0.99','2005-08-23T07:07:22.000','2006-02-15T22:22:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15261','569','2','16025','4.99','2005-08-23T21:48:54.000','2006-02-15T22:22:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15262','570','2','1060','7.99','2005-05-31T08:21:43.000','2006-02-15T22:22:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15263','570','1','1259','4.99','2005-06-15T06:37:55.000','2006-02-15T22:22:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15264','570','2','1417','4.99','2005-06-15T17:45:51.000','2006-02-15T22:22:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15265','570','2','1804','2.99','2005-06-16T20:33:15.000','2006-02-15T22:22:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15266','570','2','2008','5.99','2005-06-17T11:48:05.000','2006-02-15T22:22:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15267','570','2','2031','6.99','2005-06-17T13:14:03.000','2006-02-15T22:22:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15268','570','2','2261','3.99','2005-06-18T05:46:15.000','2006-02-15T22:22:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15269','570','2','3138','2.99','2005-06-20T19:43:45.000','2006-02-15T22:22:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15270','570','2','3984','0.99','2005-07-06T23:22:36.000','2006-02-15T22:22:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15271','570','1','4069','0.99','2005-07-07T04:35:06.000','2006-02-15T22:22:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15272','570','1','4698','0.99','2005-07-08T11:19:31.000','2006-02-15T22:22:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15273','570','2','5638','4.99','2005-07-10T06:32:49.000','2006-02-15T22:22:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15274','570','1','6253','4.99','2005-07-11T15:07:19.000','2006-02-15T22:22:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15275','570','1','6556','0.99','2005-07-12T05:10:16.000','2006-02-15T22:22:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15276','570','2','7174','4.99','2005-07-27T08:00:36.000','2006-02-15T22:22:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15277','570','2','8735','4.99','2005-07-29T18:28:54.000','2006-02-15T22:22:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15278','570','1','9385','7.99','2005-07-30T19:25:49.000','2006-02-15T22:22:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15279','570','1','9398','0.99','2005-07-30T20:09:00.000','2006-02-15T22:22:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15280','570','2','9432','2.99','2005-07-30T21:26:18.000','2006-02-15T22:22:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15281','570','1','9766','4.99','2005-07-31T09:46:29.000','2006-02-15T22:22:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15282','570','1','10004','0.99','2005-07-31T17:51:23.000','2006-02-15T22:22:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15283','570','2','10168','2.99','2005-07-31T23:25:24.000','2006-02-15T22:22:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15284','570','1','11098','3.99','2005-08-02T08:06:18.000','2006-02-15T22:22:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15285','570','2','12042','4.99','2005-08-17T20:36:37.000','2006-02-15T22:22:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15286','570','2','14768','3.99','2005-08-21T23:44:53.000','2006-02-15T22:22:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15287','570','1','12716','0.99','2006-02-14T15:16:03.000','2006-02-15T22:22:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15288','571','1','228','9.99','2005-05-26T10:54:28.000','2006-02-15T22:22:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15289','571','2','689','3.99','2005-05-29T00:46:53.000','2006-02-15T22:22:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15290','571','1','1254','4.99','2005-06-15T06:11:16.000','2006-02-15T22:22:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15291','571','2','1400','3.99','2005-06-15T16:29:56.000','2006-02-15T22:22:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15292','571','1','1756','4.99','2005-06-16T17:22:33.000','2006-02-15T22:22:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15293','571','2','1990','4.99','2005-06-17T10:48:44.000','2006-02-15T22:22:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15294','571','1','2327','2.99','2005-06-18T10:16:40.000','2006-02-15T22:22:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15295','571','1','2977','10.99','2005-06-20T08:15:27.000','2006-02-15T22:22:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15296','571','2','3616','2.99','2005-07-06T05:52:13.000','2006-02-15T22:22:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15297','571','1','4162','4.99','2005-07-07T09:17:26.000','2006-02-15T22:22:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15298','571','2','5789','4.99','2005-07-10T14:11:26.000','2006-02-15T22:22:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15299','571','2','6676','8.99','2005-07-12T11:53:40.000','2006-02-15T22:22:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15300','571','1','6792','8.99','2005-07-12T16:37:28.000','2006-02-15T22:22:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15301','571','1','8084','5.99','2005-07-28T18:11:58.000','2006-02-15T22:22:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15302','571','1','8638','4.99','2005-07-29T14:30:23.000','2006-02-15T22:22:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15303','571','2','9300','1.99','2005-07-30T16:33:12.000','2006-02-15T22:22:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15304','571','1','9408','4.99','2005-07-30T20:32:09.000','2006-02-15T22:22:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15305','571','1','10227','2.99','2005-08-01T01:42:22.000','2006-02-15T22:22:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15306','571','2','11080','2.99','2005-08-02T07:29:56.000','2006-02-15T22:22:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15307','571','2','11191','7.99','2005-08-02T11:24:07.000','2006-02-15T22:22:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15308','571','1','13228','2.99','2005-08-19T16:08:16.000','2006-02-15T22:22:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15309','571','2','13266','2.99','2005-08-19T17:31:20.000','2006-02-15T22:22:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15310','571','1','14956','0.99','2005-08-22T06:26:16.000','2006-02-15T22:22:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15311','571','1','15841','4.99','2005-08-23T15:35:59.000','2006-02-15T22:22:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15312','572','2','559','7.99','2005-05-28T08:39:02.000','2006-02-15T22:22:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15313','572','2','1889','10.99','2005-06-17T04:05:12.000','2006-02-15T22:22:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15314','572','1','2007','0.99','2005-06-17T11:47:17.000','2006-02-15T22:22:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15315','572','1','2458','0.99','2005-06-18T19:39:05.000','2006-02-15T22:22:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15316','572','1','4601','2.99','2005-07-08T06:49:10.000','2006-02-15T22:22:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15317','572','1','5595','4.99','2005-07-10T04:33:45.000','2006-02-15T22:22:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15318','572','1','5713','6.99','2005-07-10T10:46:15.000','2006-02-15T22:22:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15319','572','2','6108','2.99','2005-07-11T07:19:24.000','2006-02-15T22:22:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15320','572','1','7161','4.99','2005-07-27T07:26:32.000','2006-02-15T22:22:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15321','572','1','7345','4.99','2005-07-27T14:29:53.000','2006-02-15T22:22:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15322','572','2','7713','6.99','2005-07-28T04:32:14.000','2006-02-15T22:22:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15323','572','2','8342','0.99','2005-07-29T04:45:05.000','2006-02-15T22:22:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15324','572','1','8432','0.99','2005-07-29T07:13:33.000','2006-02-15T22:22:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15325','572','1','9081','3.99','2005-07-30T08:09:58.000','2006-02-15T22:22:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15326','572','2','9950','5.99','2005-07-31T15:50:22.000','2006-02-15T22:22:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15327','572','2','10204','4.99','2005-08-01T00:47:39.000','2006-02-15T22:22:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15328','572','1','11114','0.99','2005-08-02T08:26:45.000','2006-02-15T22:22:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15329','572','1','11121','4.99','2005-08-02T08:48:31.000','2006-02-15T22:22:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15330','572','2','11415','2.99','2005-08-02T19:43:38.000','2006-02-15T22:22:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15331','572','1','11426','4.99','2005-08-02T20:00:09.000','2006-02-15T22:22:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15332','572','1','11526','4.99','2005-08-17T00:17:38.000','2006-02-15T22:22:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15333','572','1','12256','1.99','2005-08-18T04:09:39.000','2006-02-15T22:22:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15334','572','2','13377','1.99','2005-08-19T21:32:23.000','2006-02-15T22:22:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15335','572','2','13523','6.99','2005-08-20T02:47:03.000','2006-02-15T22:22:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15336','572','1','13688','5.99','2005-08-20T08:59:38.000','2006-02-15T22:22:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15337','573','2','827','2.99','2005-05-29T21:58:43.000','2006-02-15T22:22:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15338','573','1','1613','4.99','2005-06-16T06:55:10.000','2006-02-15T22:22:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15339','573','2','2622','5.99','2005-06-19T08:10:41.000','2006-02-15T22:22:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15340','573','1','2995','1.99','2005-06-20T09:18:22.000','2006-02-15T22:22:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15341','573','1','3295','7.99','2005-06-21T07:04:17.000','2006-02-15T22:22:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15342','573','2','3768','0.99','2005-07-06T13:07:30.000','2006-02-15T22:22:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15343','573','1','3930','2.99','2005-07-06T20:54:07.000','2006-02-15T22:22:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15344','573','2','4023','4.99','2005-07-07T01:55:25.000','2006-02-15T22:22:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15345','573','1','4085','0.99','2005-07-07T05:25:39.000','2006-02-15T22:22:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15346','573','1','4609','0.99','2005-07-08T07:22:29.000','2006-02-15T22:22:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15347','573','1','4770','2.99','2005-07-08T15:29:46.000','2006-02-15T22:22:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15348','573','1','5036','5.99','2005-07-09T02:58:41.000','2006-02-15T22:22:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15349','573','2','5522','9.99','2005-07-10T01:46:29.000','2006-02-15T22:22:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15350','573','2','5903','2.99','2005-07-10T20:39:04.000','2006-02-15T22:22:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15351','573','1','6693','7.99','2005-07-12T12:37:00.000','2006-02-15T22:22:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15352','573','1','8400','4.99','2005-07-29T06:23:56.000','2006-02-15T22:22:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15353','573','2','9837','10.99','2005-07-31T12:14:19.000','2006-02-15T22:22:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15354','573','2','9846','4.99','2005-07-31T12:30:12.000','2006-02-15T22:22:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15355','573','2','9963','2.99','2005-07-31T16:16:46.000','2006-02-15T22:22:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15356','573','2','9971','5.99','2005-07-31T16:42:16.000','2006-02-15T22:22:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15357','573','1','10296','0.99','2005-08-01T04:04:37.000','2006-02-15T22:22:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15358','573','1','10887','2.99','2005-08-02T00:52:35.000','2006-02-15T22:22:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15359','573','1','11043','0.99','2005-08-02T06:04:44.000','2006-02-15T22:22:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15360','573','2','11912','5.99','2005-08-17T15:51:49.000','2006-02-15T22:22:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15361','573','1','12017','1.99','2005-08-17T19:33:49.000','2006-02-15T22:22:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15362','573','1','12125','1.99','2005-08-17T23:24:25.000','2006-02-15T22:22:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15363','573','1','12269','6.99','2005-08-18T04:27:54.000','2006-02-15T22:22:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15364','573','1','12791','0.99','2005-08-19T00:17:09.000','2006-02-15T22:22:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15365','573','2','13113','2.99','2005-08-19T11:27:20.000','2006-02-15T22:22:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15366','574','2','433','0.99','2005-05-27T16:40:40.000','2006-02-15T22:22:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15367','574','1','1559','0.99','2005-06-16T02:35:03.000','2006-02-15T22:22:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15368','574','2','1636','5.99','2005-06-16T08:28:54.000','2006-02-15T22:22:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15369','574','1','1817','0.99','2005-06-16T21:20:52.000','2006-02-15T22:22:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15370','574','1','2632','0.99','2005-06-19T08:51:47.000','2006-02-15T22:22:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15371','574','1','3220','6.99','2005-06-21T01:46:25.000','2006-02-15T22:22:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15372','574','1','3583','7.99','2005-07-06T04:10:43.000','2006-02-15T22:22:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15373','574','1','4004','4.99','2005-07-07T00:20:51.000','2006-02-15T22:22:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15374','574','1','4212','4.99','2005-07-07T11:53:14.000','2006-02-15T22:22:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15375','574','2','4890','2.99','2005-07-08T20:05:38.000','2006-02-15T22:22:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15376','574','2','5010','4.99','2005-07-09T01:33:23.000','2006-02-15T22:22:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15377','574','1','5076','3.99','2005-07-09T05:13:22.000','2006-02-15T22:22:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15378','574','1','5077','3.99','2005-07-09T05:18:01.000','2006-02-15T22:22:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15379','574','1','5640','2.99','2005-07-10T06:38:00.000','2006-02-15T22:22:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15380','574','1','6523','2.99','2005-07-12T04:14:19.000','2006-02-15T22:22:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15381','574','1','7093','1.99','2005-07-27T04:47:00.000','2006-02-15T22:22:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15382','574','1','7134','2.99','2005-07-27T06:33:06.000','2006-02-15T22:22:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15383','574','1','7964','2.99','2005-07-28T13:49:58.000','2006-02-15T22:22:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15384','574','1','8303','4.99','2005-07-29T03:05:56.000','2006-02-15T22:22:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15385','574','1','9589','7.99','2005-07-31T03:13:29.000','2006-02-15T22:22:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15386','574','1','9759','3.99','2005-07-31T09:25:57.000','2006-02-15T22:22:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15387','574','1','10347','4.99','2005-08-01T05:20:03.000','2006-02-15T22:22:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15388','574','2','11775','3.99','2005-08-17T10:25:53.000','2006-02-15T22:22:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15389','574','1','12462','2.99','2005-08-18T11:28:55.000','2006-02-15T22:22:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15390','574','1','13589','4.99','2005-08-20T05:47:25.000','2006-02-15T22:22:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15391','574','1','14076','4.99','2005-08-20T23:20:10.000','2006-02-15T22:22:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15392','574','2','14941','2.99','2005-08-22T05:58:23.000','2006-02-15T22:22:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15393','574','2','15214','2.99','2005-08-22T16:53:29.000','2006-02-15T22:22:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15394','575','1','17','2.99','2005-05-25T01:06:36.000','2006-02-15T22:22:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15395','575','1','395','0.99','2005-05-27T11:45:49.000','2006-02-15T22:22:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15396','575','2','454','4.99','2005-05-27T19:31:36.000','2006-02-15T22:22:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15397','575','2','769','2.99','2005-05-29T12:51:44.000','2006-02-15T22:22:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15398','575','1','774','4.99','2005-05-29T13:19:43.000','2006-02-15T22:22:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15399','575','2','1494','2.99','2005-06-15T21:54:20.000','2006-02-15T22:22:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15400','575','1','1824','2.99','2005-06-16T21:51:04.000','2006-02-15T22:22:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15401','575','2','1866','4.99','2005-06-17T01:53:19.000','2006-02-15T22:22:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15402','575','1','3558','6.99','2005-07-06T02:49:06.000','2006-02-15T22:22:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15403','575','2','5875','8.99','2005-07-10T19:06:47.000','2006-02-15T22:22:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15404','575','2','6907','2.99','2005-07-12T22:03:49.000','2006-02-15T22:22:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15405','575','1','7083','0.99','2005-07-27T04:28:39.000','2006-02-15T22:22:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15406','575','1','7139','2.99','2005-07-27T06:52:21.000','2006-02-15T22:22:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15407','575','2','8711','2.99','2005-07-29T17:27:15.000','2006-02-15T22:22:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15408','575','2','8904','0.99','2005-07-30T01:08:33.000','2006-02-15T22:22:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15409','575','2','8989','4.99','2005-07-30T04:39:19.000','2006-02-15T22:22:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15410','575','1','9733','4.99','2005-07-31T08:57:35.000','2006-02-15T22:22:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15411','575','1','10331','4.99','2005-08-01T04:57:14.000','2006-02-15T22:22:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15412','575','2','10629','7.99','2005-08-01T15:33:32.000','2006-02-15T22:22:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15413','575','1','11097','3.99','2005-08-02T08:05:46.000','2006-02-15T22:22:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15414','575','1','11458','4.99','2005-08-02T21:24:02.000','2006-02-15T22:22:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15415','575','1','12204','7.99','2005-08-18T02:20:35.000','2006-02-15T22:22:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15416','575','2','12289','8.99','2005-08-18T05:05:28.000','2006-02-15T22:22:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15417','575','2','12770','5.99','2005-08-18T23:29:00.000','2006-02-15T22:22:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15418','575','2','13408','4.99','2005-08-19T22:34:51.000','2006-02-15T22:22:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15419','575','2','13465','2.99','2005-08-20T00:54:14.000','2006-02-15T22:22:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15420','575','2','14952','2.99','2005-08-22T06:20:07.000','2006-02-15T22:22:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15421','575','2','15749','4.99','2005-08-23T12:33:41.000','2006-02-15T22:22:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15422','575','2','15857','0.99','2005-08-23T15:59:51.000','2006-02-15T22:22:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15423','576','2','755','2.99','2005-05-29T10:26:29.000','2006-02-15T22:22:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15424','576','1','968','0.99','2005-05-30T19:20:03.000','2006-02-15T22:22:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15425','576','1','1366','4.99','2005-06-15T14:21:00.000','2006-02-15T22:22:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15426','576','2','1742','2.99','2005-06-16T16:37:48.000','2006-02-15T22:22:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15427','576','1','2309','0.99','2005-06-18T08:43:24.000','2006-02-15T22:22:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15428','576','2','2444','8.99','2005-06-18T18:58:12.000','2006-02-15T22:22:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15429','576','1','2651','3.99','2005-06-19T10:22:56.000','2006-02-15T22:22:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15430','576','2','2799','4.99','2005-06-19T19:15:21.000','2006-02-15T22:22:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15431','576','2','3226','6.99','2005-06-21T02:18:14.000','2006-02-15T22:22:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15432','576','1','3877','4.99','2005-07-06T18:22:10.000','2006-02-15T22:22:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15433','576','2','3889','0.99','2005-07-06T18:56:25.000','2006-02-15T22:22:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15434','576','2','3934','4.99','2005-07-06T21:07:23.000','2006-02-15T22:22:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15435','576','1','4514','4.99','2005-07-08T02:41:25.000','2006-02-15T22:22:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15436','576','2','5597','3.99','2005-07-10T04:47:57.000','2006-02-15T22:22:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15437','576','1','5934','4.99','2005-07-10T22:07:59.000','2006-02-15T22:22:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15438','576','2','7319','1.99','2005-07-27T13:31:25.000','2006-02-15T22:22:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15439','576','1','7605','3.99','2005-07-27T23:57:01.000','2006-02-15T22:22:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15440','576','1','8907','4.99','2005-07-30T01:25:03.000','2006-02-15T22:22:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15441','576','1','9133','5.99','2005-07-30T09:59:00.000','2006-02-15T22:22:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15442','576','2','9548','5.99','2005-07-31T01:54:19.000','2006-02-15T22:22:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15443','576','2','9620','8.99','2005-07-31T04:19:18.000','2006-02-15T22:22:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15444','576','2','9962','0.99','2005-07-31T16:10:36.000','2006-02-15T22:22:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15445','576','1','9979','2.99','2005-07-31T17:00:07.000','2006-02-15T22:22:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15446','576','1','10000','2.99','2005-07-31T17:41:05.000','2006-02-15T22:22:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15447','576','2','10724','3.99','2005-08-01T19:10:59.000','2006-02-15T22:22:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15448','576','2','12112','5.99','2005-08-17T23:00:31.000','2006-02-15T22:22:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15449','576','1','12245','4.99','2005-08-18T03:46:40.000','2006-02-15T22:22:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15450','576','1','13061','4.99','2005-08-19T09:43:39.000','2006-02-15T22:22:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15451','576','1','13326','4.99','2005-08-19T19:52:52.000','2006-02-15T22:22:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15452','576','1','14501','4.99','2005-08-21T14:14:38.000','2006-02-15T22:22:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15453','576','1','14541','0.99','2005-08-21T15:34:32.000','2006-02-15T22:22:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15454','576','1','15634','0.99','2005-08-23T07:34:18.000','2006-02-15T22:22:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15455','576','2','11942','5.98','2006-02-14T15:16:03.000','2006-02-15T22:22:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15456','576','1','13464','0','2006-02-14T15:16:03.000','2006-02-15T22:22:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15457','577','2','291','5.99','2005-05-26T20:20:47.000','2006-02-15T22:22:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15458','577','2',NULL,'0.99','2005-05-27T00:46:39.000','2006-02-15T22:22:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15459','577','2','2399','3.99','2005-06-18T16:06:14.000','2006-02-15T22:22:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15460','577','2','3286','2.99','2005-06-21T06:31:29.000','2006-02-15T22:22:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15461','577','2','3401','6.99','2005-06-21T15:52:43.000','2006-02-15T22:22:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15462','577','2','3599','0.99','2005-07-06T05:16:36.000','2006-02-15T22:22:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15463','577','1','3785','7.99','2005-07-06T14:00:13.000','2006-02-15T22:22:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15464','577','1','4922','2.99','2005-07-08T21:44:00.000','2006-02-15T22:22:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15465','577','1','6500','2.99','2005-07-12T03:11:23.000','2006-02-15T22:22:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15466','577','2','6534','2.99','2005-07-12T04:39:43.000','2006-02-15T22:22:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15467','577','2','7197','0.99','2005-07-27T08:49:32.000','2006-02-15T22:22:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15468','577','1','7371','4.99','2005-07-27T15:18:42.000','2006-02-15T22:22:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15469','577','2','7876','8.99','2005-07-28T10:24:22.000','2006-02-15T22:22:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15470','577','1','8043','5.99','2005-07-28T16:45:44.000','2006-02-15T22:22:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15471','577','1','8060','6.99','2005-07-28T17:10:02.000','2006-02-15T22:22:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15472','577','2','8671','6.99','2005-07-29T15:49:37.000','2006-02-15T22:22:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15473','577','2','10323','4.99','2005-08-01T04:44:58.000','2006-02-15T22:22:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15474','577','1','10487','0.99','2005-08-01T10:26:34.000','2006-02-15T22:22:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15475','577','1','10782','4.99','2005-08-01T21:23:25.000','2006-02-15T22:22:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15476','577','1','11054','7.99','2005-08-02T06:33:07.000','2006-02-15T22:22:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15477','577','2','11464','0.99','2005-08-02T21:42:07.000','2006-02-15T22:22:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15478','577','1','12664','4.99','2005-08-18T19:10:54.000','2006-02-15T22:22:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15479','577','2','12671','0.99','2005-08-18T19:19:59.000','2006-02-15T22:22:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15480','577','2','13200','3.99','2005-08-19T14:55:58.000','2006-02-15T22:22:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15481','577','2','13500','3.99','2005-08-20T01:54:39.000','2006-02-15T22:22:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15482','577','2','15480','2.99','2005-08-23T01:57:20.000','2006-02-15T22:22:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15483','577','2','15873','2.99','2005-08-23T16:27:59.000','2006-02-15T22:22:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15484','577','2','16003','4.99','2005-08-23T20:47:28.000','2006-02-15T22:22:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15485','578','2','660','0.99','2005-05-28T20:53:31.000','2006-02-15T22:22:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15486','578','2','1826','6.99','2005-06-16T21:53:52.000','2006-02-15T22:22:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15487','578','2','2615','4.99','2005-06-19T07:29:13.000','2006-02-15T22:22:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15488','578','1','3305','2.99','2005-06-21T07:46:57.000','2006-02-15T22:22:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15489','578','2','4496','4.99','2005-07-08T01:44:19.000','2006-02-15T22:22:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15490','578','1','5377','4.99','2005-07-09T19:04:30.000','2006-02-15T22:22:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15491','578','1','5445','0.99','2005-07-09T21:59:41.000','2006-02-15T22:22:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15492','578','2','5876','4.99','2005-07-10T19:07:15.000','2006-02-15T22:22:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15493','578','1','6784','4.99','2005-07-12T16:28:49.000','2006-02-15T22:22:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15494','578','1','6830','0.99','2005-07-12T18:42:55.000','2006-02-15T22:22:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15495','578','2','7059','5.99','2005-07-27T03:51:02.000','2006-02-15T22:22:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15496','578','1','8179','2.99','2005-07-28T22:05:13.000','2006-02-15T22:22:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15497','578','1','8218','2.99','2005-07-28T23:45:41.000','2006-02-15T22:22:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15498','578','2','9970','4.99','2005-07-31T16:38:24.000','2006-02-15T22:22:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15499','578','1','10029','6.99','2005-07-31T18:37:47.000','2006-02-15T22:22:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15500','578','2','10182','2.99','2005-08-01T00:08:01.000','2006-02-15T22:22:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15501','578','1','10779','7.99','2005-08-01T21:11:54.000','2006-02-15T22:22:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15502','578','1','11199','7.99','2005-08-02T11:47:40.000','2006-02-15T22:22:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15503','578','2','13071','5.99','2005-08-19T10:01:07.000','2006-02-15T22:22:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15504','578','2','13498','5.99','2005-08-20T01:51:23.000','2006-02-15T22:22:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15505','578','2','13552','2.99','2005-08-20T04:03:51.000','2006-02-15T22:22:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15506','578','1','15652','0.99','2005-08-23T08:34:10.000','2006-02-15T22:22:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15507','579','2','2425','5.99','2005-06-18T17:37:45.000','2006-02-15T22:22:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15508','579','1','2522','3.99','2005-06-19T00:43:42.000','2006-02-15T22:22:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15509','579','1','3111','2.99','2005-06-20T17:46:47.000','2006-02-15T22:22:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15510','579','1','4619','9.99','2005-07-08T08:01:09.000','2006-02-15T22:22:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15511','579','1','4933','2.99','2005-07-08T22:18:29.000','2006-02-15T22:22:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15512','579','1','6304','4.99','2005-07-11T18:02:16.000','2006-02-15T22:22:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15513','579','2','6814','1.99','2005-07-12T18:11:58.000','2006-02-15T22:22:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15514','579','2','6824','6.99','2005-07-12T18:26:46.000','2006-02-15T22:22:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15515','579','2','6969','8.99','2005-07-27T00:23:54.000','2006-02-15T22:22:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15516','579','2','7221','2.99','2005-07-27T09:37:35.000','2006-02-15T22:22:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15517','579','1','8354','0.99','2005-07-29T04:56:26.000','2006-02-15T22:22:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15518','579','1','8876','0.99','2005-07-30T00:15:09.000','2006-02-15T22:22:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15519','579','1','8996','0.99','2005-07-30T04:53:23.000','2006-02-15T22:22:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15520','579','2','9349','9.99','2005-07-30T18:20:08.000','2006-02-15T22:22:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15521','579','2','9553','5.99','2005-07-31T02:06:34.000','2006-02-15T22:22:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15522','579','2','9976','2.99','2005-07-31T16:57:49.000','2006-02-15T22:22:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15523','579','2','9997','4.99','2005-07-31T17:37:30.000','2006-02-15T22:22:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15524','579','1','11494','3.99','2005-08-02T22:51:23.000','2006-02-15T22:22:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15525','579','2','12051','6.99','2005-08-17T20:56:15.000','2006-02-15T22:22:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15526','579','2','12315','5.99','2005-08-18T06:15:06.000','2006-02-15T22:22:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15527','579','2','14047','2.99','2005-08-20T22:00:43.000','2006-02-15T22:22:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15528','579','1','14185','0.99','2005-08-21T03:28:37.000','2006-02-15T22:22:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15529','579','1','14543','1.99','2005-08-21T15:39:01.000','2006-02-15T22:22:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15530','579','2','14560','2.99','2005-08-21T16:13:47.000','2006-02-15T22:22:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15531','579','2','15601','0.99','2005-08-23T06:33:26.000','2006-02-15T22:22:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15532','579','1','15838','4.99','2005-08-23T15:30:48.000','2006-02-15T22:22:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15533','579','2','15794','0.99','2006-02-14T15:16:03.000','2006-02-15T22:22:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15534','580','1','611','0.99','2005-05-28T15:18:18.000','2006-02-15T22:22:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15535','580','1','1469','0.99','2005-06-15T20:52:36.000','2006-02-15T22:22:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15536','580','2','3571','1.99','2005-07-06T03:32:31.000','2006-02-15T22:22:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15537','580','2','3867','1.99','2005-07-06T17:52:19.000','2006-02-15T22:22:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15538','580','2','4169','1.99','2005-07-07T09:39:18.000','2006-02-15T22:22:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15539','580','2','4590','3.99','2005-07-08T06:27:48.000','2006-02-15T22:22:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15540','580','1','5937','6.99','2005-07-10T22:16:08.000','2006-02-15T22:22:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15541','580','1','6089','2.99','2005-07-11T05:45:59.000','2006-02-15T22:22:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15542','580','2','6170','2.99','2005-07-11T10:29:21.000','2006-02-15T22:22:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15543','580','1','7620','0.99','2005-07-28T00:27:17.000','2006-02-15T22:22:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15544','580','2','8784','4.99','2005-07-29T20:35:37.000','2006-02-15T22:22:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15545','580','1','8839','3.99','2005-07-29T22:52:34.000','2006-02-15T22:22:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15546','580','1','9199','0.99','2005-07-30T12:38:00.000','2006-02-15T22:22:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15547','580','1','9239','3.99','2005-07-30T13:50:52.000','2006-02-15T22:22:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15548','580','1','9460','5.99','2005-07-30T22:25:39.000','2006-02-15T22:22:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15549','580','2','9604','4.99','2005-07-31T03:47:12.000','2006-02-15T22:22:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15550','580','2','9865','0.99','2005-07-31T13:10:45.000','2006-02-15T22:22:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15551','580','1','10723','3.99','2005-08-01T19:10:49.000','2006-02-15T22:22:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15552','580','2','10965','3.99','2005-08-02T04:00:19.000','2006-02-15T22:22:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15553','580','1','11164','8.99','2005-08-02T10:10:56.000','2006-02-15T22:22:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15554','580','2','12670','2.99','2005-08-18T19:17:58.000','2006-02-15T22:22:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15555','580','2','13313','2.99','2005-08-19T19:11:41.000','2006-02-15T22:22:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15556','580','2','13742','2.99','2005-08-20T10:49:15.000','2006-02-15T22:22:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15557','580','2','14818','2.99','2005-08-22T01:17:18.000','2006-02-15T22:22:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15558','580','1','15157','6.99','2005-08-22T14:30:09.000','2006-02-15T22:22:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15559','580','1','15630','6.99','2005-08-23T07:29:13.000','2006-02-15T22:22:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15560','580','1','15947','4.99','2005-08-23T18:54:32.000','2006-02-15T22:22:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15561','581','1','976','4.99','2005-05-30T21:11:19.000','2006-02-15T22:22:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15562','581','1','1151','4.99','2005-05-31T21:29:00.000','2006-02-15T22:22:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15563','581','2','1958','3.99','2005-06-17T08:52:01.000','2006-02-15T22:22:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15564','581','2','2101','2.99','2005-06-17T18:57:02.000','2006-02-15T22:22:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15565','581','1','2137','4.99','2005-06-17T21:18:28.000','2006-02-15T22:22:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15566','581','2','4210','2.99','2005-07-07T11:36:20.000','2006-02-15T22:22:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15567','581','2','4244','2.99','2005-07-07T13:41:58.000','2006-02-15T22:22:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15568','581','1','4338','4.99','2005-07-07T18:39:56.000','2006-02-15T22:22:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15569','581','2','4613','0.99','2005-07-08T07:44:49.000','2006-02-15T22:22:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15570','581','1','4669','5.99','2005-07-08T10:13:08.000','2006-02-15T22:22:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15571','581','1','4815','8.99','2005-07-08T17:12:51.000','2006-02-15T22:22:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15572','581','1','4833','1.99','2005-07-08T18:07:35.000','2006-02-15T22:22:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15573','581','1','5516','4.99','2005-07-10T01:13:52.000','2006-02-15T22:22:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15574','581','1','5707','4.99','2005-07-10T10:26:14.000','2006-02-15T22:22:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15575','581','2','5812','2.99','2005-07-10T15:27:56.000','2006-02-15T22:22:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15576','581','2','7048','7.99','2005-07-27T03:31:48.000','2006-02-15T22:22:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15577','581','1','7783','2.99','2005-07-28T07:14:43.000','2006-02-15T22:22:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15578','581','1','9278','2.99','2005-07-30T15:15:19.000','2006-02-15T22:22:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15579','581','1','9449','1.99','2005-07-30T22:02:34.000','2006-02-15T22:22:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15580','581','2','11443','2.99','2005-08-02T20:29:30.000','2006-02-15T22:22:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15581','581','2','11707','2.99','2005-08-17T07:24:59.000','2006-02-15T22:22:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15582','581','2','13621','0.99','2005-08-20T06:43:44.000','2006-02-15T22:22:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15583','581','2','13712','2.99','2005-08-20T09:38:04.000','2006-02-15T22:22:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15584','581','2','14070','8.99','2005-08-20T22:56:34.000','2006-02-15T22:22:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15585','581','1','14976','2.99','2005-08-22T07:10:26.000','2006-02-15T22:22:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15586','581','1','15403','0.99','2005-08-22T23:18:10.000','2006-02-15T22:22:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15587','581','2','15792','4.99','2005-08-23T14:05:37.000','2006-02-15T22:22:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15588','582','1','281','0.99','2005-05-26T18:49:35.000','2006-02-15T22:22:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15589','582','1','1719','2.99','2005-06-16T14:55:53.000','2006-02-15T22:22:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15590','582','1','2337','7.99','2005-06-18T11:15:27.000','2006-02-15T22:22:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15591','582','2','3071','0.99','2005-06-20T14:20:42.000','2006-02-15T22:22:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15592','582','1','3767','0.99','2005-07-06T13:07:27.000','2006-02-15T22:22:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15593','582','2','6629','5.99','2005-07-12T09:18:35.000','2006-02-15T22:22:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15594','582','2','7126','4.99','2005-07-27T06:13:13.000','2006-02-15T22:22:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15595','582','2','7311','6.99','2005-07-27T13:02:54.000','2006-02-15T22:22:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15596','582','2','7412','5.99','2005-07-27T16:44:34.000','2006-02-15T22:22:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15597','582','1','7575','2.99','2005-07-27T22:53:52.000','2006-02-15T22:22:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15598','582','2','8308','5.99','2005-07-29T03:22:15.000','2006-02-15T22:22:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15599','582','1','8554','2.99','2005-07-29T11:16:29.000','2006-02-15T22:22:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15600','582','1','8778','6.99','2005-07-29T20:14:25.000','2006-02-15T22:22:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15601','582','1','9768','9.99','2005-07-31T09:48:41.000','2006-02-15T22:22:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15602','582','2','11290','7.99','2005-08-02T14:57:44.000','2006-02-15T22:22:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15603','582','1','11667','5.99','2005-08-17T05:46:55.000','2006-02-15T22:22:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15604','582','1','11708','2.99','2005-08-17T07:26:47.000','2006-02-15T22:22:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15605','582','2','13815','5.99','2005-08-20T13:08:53.000','2006-02-15T22:22:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15606','582','1','14376','4.99','2005-08-21T09:48:56.000','2006-02-15T22:22:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15607','582','1','14568','0.99','2005-08-21T16:30:48.000','2006-02-15T22:22:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15608','582','1','15090','5.99','2005-08-22T11:34:33.000','2006-02-15T22:22:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15609','582','1','15503','2.99','2005-08-23T02:44:49.000','2006-02-15T22:22:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15610','582','1','15539','0.99','2005-08-23T04:09:03.000','2006-02-15T22:22:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15611','582','2','15911','4.99','2005-08-23T17:44:53.000','2006-02-15T22:22:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15612','582','2','12127','2.99','2006-02-14T15:16:03.000','2006-02-15T22:22:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15613','583','1','1428','3.99','2005-06-15T18:19:30.000','2006-02-15T22:22:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15614','583','1','2429','9.99','2005-06-18T17:48:28.000','2006-02-15T22:22:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15615','583','2','2663','4.99','2005-06-19T10:54:00.000','2006-02-15T22:22:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15616','583','2','2845','5.99','2005-06-19T22:46:37.000','2006-02-15T22:22:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15617','583','2','2879','3.99','2005-06-20T01:24:10.000','2006-02-15T22:22:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15618','583','1','3424','0.99','2005-06-21T17:42:51.000','2006-02-15T22:22:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15619','583','1','3779','2.99','2005-07-06T13:46:36.000','2006-02-15T22:22:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15620','583','1','3842','4.99','2005-07-06T16:34:32.000','2006-02-15T22:22:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15621','583','2','3991','9.99','2005-07-06T23:33:41.000','2006-02-15T22:22:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15622','583','1','4464','4.99','2005-07-08T00:07:18.000','2006-02-15T22:22:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15623','583','1','5462','0.99','2005-07-09T22:56:53.000','2006-02-15T22:22:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15624','583','1','5478','5.99','2005-07-09T23:45:15.000','2006-02-15T22:22:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15625','583','2','5747','7.99','2005-07-10T12:15:33.000','2006-02-15T22:22:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15626','583','2','6684','6.99','2005-07-12T12:14:42.000','2006-02-15T22:22:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15627','583','1','7401','5.99','2005-07-27T16:17:55.000','2006-02-15T22:22:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15628','583','2','8568','7.99','2005-07-29T11:38:22.000','2006-02-15T22:22:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15629','583','1','9550','7.99','2005-07-31T01:57:34.000','2006-02-15T22:22:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15630','583','2','9808','1.99','2005-07-31T11:17:22.000','2006-02-15T22:22:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15631','583','2','10301','4.99','2005-08-01T04:09:37.000','2006-02-15T22:22:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15632','583','2','10586','2.99','2005-08-01T14:00:59.000','2006-02-15T22:22:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15633','583','2','10800','4.99','2005-08-01T22:07:44.000','2006-02-15T22:22:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15634','583','2','11002','4.99','2005-08-02T05:02:56.000','2006-02-15T22:22:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15635','583','1','14259','0.99','2005-08-21T06:00:22.000','2006-02-15T22:22:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15636','584','2','379','4.99','2005-05-27T09:25:32.000','2006-02-15T22:22:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15637','584','1','626','4.99','2005-05-28T16:58:09.000','2006-02-15T22:22:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15638','584','1','920','4.99','2005-05-30T11:44:01.000','2006-02-15T22:22:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15639','584','2','1436','3.99','2005-06-15T18:35:40.000','2006-02-15T22:22:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15640','584','2','3317','6.99','2005-06-21T08:22:32.000','2006-02-15T22:22:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15641','584','2','3741','2.99','2005-07-06T12:00:18.000','2006-02-15T22:22:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15642','584','2','3895','7.99','2005-07-06T19:04:24.000','2006-02-15T22:22:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15643','584','1','4410','0.99','2005-07-07T21:48:16.000','2006-02-15T22:22:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15644','584','1','4977','0.99','2005-07-09T00:15:50.000','2006-02-15T22:22:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15645','584','2','6954','0.99','2005-07-26T23:55:13.000','2006-02-15T22:22:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15646','584','1','7186','2.99','2005-07-27T08:26:12.000','2006-02-15T22:22:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15647','584','1','7372','4.99','2005-07-27T15:18:42.000','2006-02-15T22:22:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15648','584','1','7659','4.99','2005-07-28T02:09:45.000','2006-02-15T22:22:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15649','584','2','8879','4.99','2005-07-30T00:16:02.000','2006-02-15T22:22:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15650','584','2','9451','3.99','2005-07-30T22:10:17.000','2006-02-15T22:22:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15651','584','1','9719','5.99','2005-07-31T08:25:13.000','2006-02-15T22:22:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15652','584','2','10073','2.99','2005-07-31T19:53:15.000','2006-02-15T22:22:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15653','584','1','10914','4.99','2005-08-02T02:04:43.000','2006-02-15T22:22:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15654','584','2','10966','0.99','2005-08-02T04:00:47.000','2006-02-15T22:22:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15655','584','1','11213','4.99','2005-08-02T12:18:35.000','2006-02-15T22:22:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15656','584','2','11500','6.99','2005-08-16T23:01:22.000','2006-02-15T22:22:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15657','584','2','12507','8.99','2005-08-18T13:19:13.000','2006-02-15T22:22:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15658','584','2','12541','2.99','2005-08-18T14:18:30.000','2006-02-15T22:22:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15659','584','2','12693','5.99','2005-08-18T20:10:19.000','2006-02-15T22:22:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15660','584','1','12844','2.99','2005-08-19T01:59:08.000','2006-02-15T22:22:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15661','584','2','14102','5.99','2005-08-21T00:35:21.000','2006-02-15T22:22:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15662','584','2','14230','5.99','2005-08-21T04:57:29.000','2006-02-15T22:22:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15663','584','2','14447','4.99','2005-08-21T12:12:05.000','2006-02-15T22:22:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15664','584','1','14930','1.99','2005-08-22T05:38:32.000','2006-02-15T22:22:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15665','584','1','15615','0.99','2005-08-23T07:06:00.000','2006-02-15T22:22:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15666','585','1','1344','0.99','2005-06-15T12:29:41.000','2006-02-15T22:22:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15667','585','2','1346','7.99','2005-06-15T12:39:52.000','2006-02-15T22:22:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15668','585','1','2674','0.99','2005-06-19T11:47:59.000','2006-02-15T22:22:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15669','585','1','2930','3.99','2005-06-20T04:50:29.000','2006-02-15T22:22:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15670','585','2','4156','4.99','2005-07-07T09:03:51.000','2006-02-15T22:22:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15671','585','2','4579','4.99','2005-07-08T06:01:56.000','2006-02-15T22:22:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15672','585','1','4684','9.99','2005-07-08T10:41:06.000','2006-02-15T22:22:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15673','585','2','5284','2.99','2005-07-09T15:08:21.000','2006-02-15T22:22:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15674','585','2','5950','4.99','2005-07-10T23:13:45.000','2006-02-15T22:22:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15675','585','2','6733','6.99','2005-07-12T14:04:01.000','2006-02-15T22:22:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15676','585','1','7131','2.99','2005-07-27T06:25:06.000','2006-02-15T22:22:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15677','585','1','7384','4.99','2005-07-27T15:49:45.000','2006-02-15T22:22:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15678','585','2','7409','4.99','2005-07-27T16:38:24.000','2006-02-15T22:22:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15679','585','2','8353','2.99','2005-07-29T04:52:10.000','2006-02-15T22:22:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15680','585','2','9407','8.99','2005-07-30T20:25:24.000','2006-02-15T22:22:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15681','585','1','9590','3.99','2005-07-31T03:17:16.000','2006-02-15T22:22:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15682','585','1','9860','6.99','2005-07-31T13:03:24.000','2006-02-15T22:22:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15683','585','2','10573','0.99','2005-08-01T13:27:24.000','2006-02-15T22:22:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15684','585','1','11285','9.99','2005-08-02T14:44:02.000','2006-02-15T22:22:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15685','585','2','13593','3.99','2005-08-20T05:50:52.000','2006-02-15T22:22:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15686','585','2','13939','0.99','2005-08-20T17:28:01.000','2006-02-15T22:22:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15687','585','1','15804','4.99','2005-08-23T14:29:16.000','2006-02-15T22:22:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15688','585','1','15896','6.99','2005-08-23T17:09:56.000','2006-02-15T22:22:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15689','585','2','14604','4.99','2006-02-14T15:16:03.000','2006-02-15T22:22:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15690','586','1','138','4.99','2005-05-25T22:48:22.000','2006-02-15T22:22:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15691','586','1','900','8.99','2005-05-30T09:38:41.000','2006-02-15T22:22:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15692','586','1','1260','2.99','2005-06-15T06:42:25.000','2006-02-15T22:22:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15693','586','2','1540','0.99','2005-06-16T01:14:56.000','2006-02-15T22:22:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15694','586','2','3487','6.99','2005-07-05T23:30:36.000','2006-02-15T22:22:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15695','586','2','3733','4.99','2005-07-06T11:33:55.000','2006-02-15T22:22:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15696','586','2','5382','2.99','2005-07-09T19:12:57.000','2006-02-15T22:22:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15697','586','1','6679','2.99','2005-07-12T12:01:07.000','2006-02-15T22:22:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15698','586','2','9786','2.99','2005-07-31T10:25:21.000','2006-02-15T22:22:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15699','586','2','9896','2.99','2005-07-31T14:09:48.000','2006-02-15T22:22:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15700','586','1','11034','2.99','2005-08-02T05:54:53.000','2006-02-15T22:22:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15701','586','1','11763','0.99','2005-08-17T09:51:39.000','2006-02-15T22:22:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15702','586','1','12013','4.99','2005-08-17T19:23:02.000','2006-02-15T22:22:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15703','586','1','12898','0.99','2005-08-19T03:54:34.000','2006-02-15T22:22:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15704','586','2','14043','2.99','2005-08-20T21:46:43.000','2006-02-15T22:22:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15705','586','1','14392','1.99','2005-08-21T10:19:25.000','2006-02-15T22:22:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15706','586','2','14533','2.99','2005-08-21T15:15:19.000','2006-02-15T22:22:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15707','586','1','15666','3.99','2005-08-23T09:01:10.000','2006-02-15T22:22:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15708','586','2','15684','0.99','2005-08-23T09:40:04.000','2006-02-15T22:22:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15709','587','1','181','4.99','2005-05-26T04:47:06.000','2006-02-15T22:22:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15710','587','1','361','0.99','2005-05-27T07:03:28.000','2006-02-15T22:22:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15711','587','2','1330','2.99','2005-06-15T11:29:17.000','2006-02-15T22:22:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15712','587','2','2034','4.99','2005-06-17T13:27:16.000','2006-02-15T22:22:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15713','587','1','2220','2.99','2005-06-18T03:21:36.000','2006-02-15T22:22:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15714','587','1','2329','4.99','2005-06-18T10:22:52.000','2006-02-15T22:22:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15715','587','2','3562','2.99','2005-07-06T02:54:36.000','2006-02-15T22:22:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15716','587','2','3969','0.99','2005-07-06T22:47:59.000','2006-02-15T22:22:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15717','587','2','5243','3.99','2005-07-09T13:22:08.000','2006-02-15T22:22:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15718','587','1','6639','0.99','2005-07-12T10:00:44.000','2006-02-15T22:22:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15719','587','2','6665','6.99','2005-07-12T11:29:14.000','2006-02-15T22:22:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15720','587','1','7501','8.99','2005-07-27T20:16:59.000','2006-02-15T22:22:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15721','587','2','8776','5.99','2005-07-29T20:07:06.000','2006-02-15T22:22:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15722','587','2','9720','6.99','2005-07-31T08:25:21.000','2006-02-15T22:22:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15723','587','2','9785','4.99','2005-07-31T10:22:15.000','2006-02-15T22:22:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15724','587','2','9909','5.99','2005-07-31T14:43:34.000','2006-02-15T22:22:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15725','587','2','10224','4.99','2005-08-01T01:31:56.000','2006-02-15T22:22:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15726','587','1','10825','2.99','2005-08-01T23:05:33.000','2006-02-15T22:22:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15727','587','1','11078','2.99','2005-08-02T07:26:58.000','2006-02-15T22:22:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15728','587','2','11403','4.99','2005-08-02T19:10:21.000','2006-02-15T22:22:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15729','587','2','12164','4.99','2005-08-18T00:46:38.000','2006-02-15T22:22:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15730','587','2','12330','6.99','2005-08-18T06:46:33.000','2006-02-15T22:22:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15731','587','2','14710','4.99','2005-08-21T21:15:23.000','2006-02-15T22:22:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15732','587','2','15348','2.99','2005-08-22T21:13:46.000','2006-02-15T22:22:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15733','587','2','15349','0.99','2005-08-22T21:13:51.000','2006-02-15T22:22:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15734','587','1','12144','0.99','2006-02-14T15:16:03.000','2006-02-15T22:22:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15735','588','1','576','2.99','2005-05-28T10:56:10.000','2006-02-15T22:22:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15736','588','1','961','4.99','2005-05-30T18:16:44.000','2006-02-15T22:22:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15737','588','2','1885','2.99','2005-06-17T03:35:59.000','2006-02-15T22:22:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15738','588','2','1903','6.99','2005-06-17T04:37:20.000','2006-02-15T22:22:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15739','588','2','2270','7.99','2005-06-18T06:29:01.000','2006-02-15T22:22:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15740','588','1','2453','2.99','2005-06-18T19:30:53.000','2006-02-15T22:22:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15741','588','2','2920','3.99','2005-06-20T04:12:46.000','2006-02-15T22:22:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15742','588','1','3628','4.99','2005-07-06T06:19:43.000','2006-02-15T22:22:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15743','588','1','4101','0.99','2005-07-07T06:25:11.000','2006-02-15T22:22:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15744','588','2','4207','5.99','2005-07-07T11:32:45.000','2006-02-15T22:23:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15745','588','2','5203','2.99','2005-07-09T10:53:59.000','2006-02-15T22:23:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15746','588','1','5335','4.99','2005-07-09T17:00:49.000','2006-02-15T22:23:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15747','588','1','6368','4.99','2005-07-11T21:19:01.000','2006-02-15T22:23:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15748','588','2','7377','2.99','2005-07-27T15:31:28.000','2006-02-15T22:23:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15749','588','2','7903','2.99','2005-07-28T11:20:36.000','2006-02-15T22:23:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15750','588','1','8421','4.99','2005-07-29T07:00:47.000','2006-02-15T22:23:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15751','588','1','8429','2.99','2005-07-29T07:11:49.000','2006-02-15T22:23:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15752','588','2','8519','2.99','2005-07-29T10:09:43.000','2006-02-15T22:23:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15753','588','1','8769','2.99','2005-07-29T19:45:33.000','2006-02-15T22:23:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15754','588','2','9326','2.99','2005-07-30T17:30:03.000','2006-02-15T22:23:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15755','588','2','9370','4.99','2005-07-30T18:57:29.000','2006-02-15T22:23:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15756','588','2','10373','4.99','2005-08-01T06:24:26.000','2006-02-15T22:23:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15757','588','1','12185','2.99','2005-08-18T01:40:14.000','2006-02-15T22:23:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15758','588','2','12815','4.99','2005-08-19T00:59:42.000','2006-02-15T22:23:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15759','588','1','13064','4.99','2005-08-19T09:46:53.000','2006-02-15T22:23:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15760','588','1','13923','1.99','2005-08-20T17:05:02.000','2006-02-15T22:23:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15761','588','1','15109','1.99','2005-08-22T12:12:58.000','2006-02-15T22:23:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15762','588','1','15158','2.99','2005-08-22T14:30:39.000','2006-02-15T22:23:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15763','588','1','15209','4.99','2005-08-22T16:37:32.000','2006-02-15T22:23:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15764','589','1','531','0.99','2005-05-28T05:23:38.000','2006-02-15T22:23:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15765','589','1','596','4.99','2005-05-28T14:00:03.000','2006-02-15T22:23:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15766','589','1','737','4.99','2005-05-29T08:11:31.000','2006-02-15T22:23:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15767','589','1','1439','4.99','2005-06-15T18:45:32.000','2006-02-15T22:23:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15768','589','2','1703','4.99','2005-06-16T13:28:44.000','2006-02-15T22:23:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15769','589','2','2652','8.99','2005-06-19T10:35:26.000','2006-02-15T22:23:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15770','589','1','2707','8.99','2005-06-19T13:57:08.000','2006-02-15T22:23:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15771','589','1','2979','2.99','2005-06-20T08:31:05.000','2006-02-15T22:23:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15772','589','2','4986','2.99','2005-07-09T00:44:33.000','2006-02-15T22:23:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15773','589','1','5951','0.99','2005-07-10T23:14:29.000','2006-02-15T22:23:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15774','589','2','6177','4.99','2005-07-11T10:53:49.000','2006-02-15T22:23:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15775','589','2','6247','3.99','2005-07-11T15:00:05.000','2006-02-15T22:23:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15776','589','2','7250','0.99','2005-07-27T10:44:09.000','2006-02-15T22:23:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15777','589','2','7431','3.99','2005-07-27T17:27:27.000','2006-02-15T22:23:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15778','589','2','7948','9.99','2005-07-28T13:06:16.000','2006-02-15T22:23:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15779','589','2','8056','0.99','2005-07-28T17:04:15.000','2006-02-15T22:23:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15780','589','1','8374','3.99','2005-07-29T05:24:02.000','2006-02-15T22:23:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15781','589','1','9153','4.99','2005-07-30T10:58:16.000','2006-02-15T22:23:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15782','589','2','10544','4.99','2005-08-01T12:36:21.000','2006-02-15T22:23:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15783','589','1','11980','4.99','2005-08-17T18:10:18.000','2006-02-15T22:23:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15784','589','1','12738','7.99','2005-08-18T22:11:47.000','2006-02-15T22:23:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15785','589','2','12933','8.99','2005-08-19T05:18:20.000','2006-02-15T22:23:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15786','589','1','14038','6.99','2005-08-20T21:39:23.000','2006-02-15T22:23:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15787','589','1','14254','6.99','2005-08-21T05:51:28.000','2006-02-15T22:23:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15788','589','1','14544','0.99','2005-08-21T15:41:01.000','2006-02-15T22:23:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15789','589','2','14706','0.99','2005-08-21T21:04:42.000','2006-02-15T22:23:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15790','589','2','15917','5.99','2005-08-23T17:57:28.000','2006-02-15T22:23:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15791','589','2','15992','0.99','2005-08-23T20:28:32.000','2006-02-15T22:23:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15792','590','1','602','3.99','2005-05-28T14:15:54.000','2006-02-15T22:23:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15793','590','2','1456','7.99','2005-06-15T20:00:11.000','2006-02-15T22:23:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15794','590','2','2352','2.99','2005-06-18T12:40:15.000','2006-02-15T22:23:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15795','590','2','2775','2.99','2005-06-19T18:14:20.000','2006-02-15T22:23:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15796','590','1','2916','6.99','2005-06-20T04:01:04.000','2006-02-15T22:23:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15797','590','1','2964','9.99','2005-06-20T07:33:29.000','2006-02-15T22:23:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15798','590','2','4685','4.99','2005-07-08T10:45:13.000','2006-02-15T22:23:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15799','590','1','4710','2.99','2005-07-08T12:04:53.000','2006-02-15T22:23:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15800','590','2','4722','4.99','2005-07-08T12:42:27.000','2006-02-15T22:23:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15801','590','1','5165','0.99','2005-07-09T09:08:53.000','2006-02-15T22:23:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15802','590','1','5529','2.99','2005-07-10T02:11:13.000','2006-02-15T22:23:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15803','590','1','5991','4.99','2005-07-11T01:03:38.000','2006-02-15T22:23:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15804','590','2','6232','4.99','2005-07-11T14:08:27.000','2006-02-15T22:23:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15805','590','2','6492','4.99','2005-07-12T02:28:40.000','2006-02-15T22:23:14.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15806','590','1','7010','4.99','2005-07-27T01:56:01.000','2006-02-15T22:23:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15807','590','2','7665','2.99','2005-07-28T02:28:30.000','2006-02-15T22:23:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15808','590','1','8195','5.99','2005-07-28T22:52:58.000','2006-02-15T22:23:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15809','590','1','8801','4.99','2005-07-29T21:25:22.000','2006-02-15T22:23:15.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15810','590','2','9126','0.99','2005-07-30T09:44:15.000','2006-02-15T22:23:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15811','590','1','9884','4.99','2005-07-31T13:56:24.000','2006-02-15T22:23:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15812','590','1','10657','4.99','2005-08-01T16:38:44.000','2006-02-15T22:23:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15813','590','2','11578','5.99','2005-08-17T01:54:13.000','2006-02-15T22:23:16.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15814','590','2','11713','3.99','2005-08-17T07:34:05.000','2006-02-15T22:23:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15815','590','1','14830','2.99','2005-08-22T01:37:19.000','2006-02-15T22:23:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15816','590','2','15458','2.99','2006-02-14T15:16:03.000','2006-02-15T22:23:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15817','591','1','1418','0.99','2005-06-15T17:51:27.000','2006-02-15T22:23:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15818','591','2','3341','2.99','2005-06-21T10:37:25.000','2006-02-15T22:23:17.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15819','591','2','3435','4.99','2005-06-21T19:14:58.000','2006-02-15T22:23:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15820','591','1','3636','0.99','2005-07-06T07:03:52.000','2006-02-15T22:23:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15821','591','2','4383','11.99','2005-07-07T20:45:51.000','2006-02-15T22:23:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15822','591','1','4581','6.99','2005-07-08T06:05:06.000','2006-02-15T22:23:18.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15823','591','1','5704','5.99','2005-07-10T10:06:29.000','2006-02-15T22:23:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15824','591','1','5759','6.99','2005-07-10T12:43:22.000','2006-02-15T22:23:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15825','591','1','7118','8.99','2005-07-27T05:53:50.000','2006-02-15T22:23:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15826','591','1','7212','2.99','2005-07-27T09:21:22.000','2006-02-15T22:23:19.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15827','591','2','7511','4.99','2005-07-27T20:38:40.000','2006-02-15T22:23:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15828','591','1','7549','3.99','2005-07-27T21:53:21.000','2006-02-15T22:23:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15829','591','2','7741','0.99','2005-07-28T05:25:55.000','2006-02-15T22:23:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15830','591','1','7997','4.99','2005-07-28T15:02:25.000','2006-02-15T22:23:20.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15831','591','1','8149','3.99','2005-07-28T20:48:12.000','2006-02-15T22:23:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15832','591','2','8666','5.99','2005-07-29T15:39:38.000','2006-02-15T22:23:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15833','591','2','8819','4.99','2005-07-29T22:14:26.000','2006-02-15T22:23:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15834','591','1','9684','0.99','2005-07-31T06:48:33.000','2006-02-15T22:23:21.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15835','591','1','10415','4.99','2005-08-01T08:05:59.000','2006-02-15T22:23:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15836','591','2','12203','5.99','2005-08-18T02:18:52.000','2006-02-15T22:23:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15837','591','2','12227','4.99','2005-08-18T03:04:28.000','2006-02-15T22:23:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15838','591','1','12547','4.99','2005-08-18T14:29:39.000','2006-02-15T22:23:22.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15839','591','1','12571','5.99','2005-08-18T15:31:18.000','2006-02-15T22:23:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15840','591','1','12934','5.99','2005-08-19T05:18:42.000','2006-02-15T22:23:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15841','591','2','13104','2.99','2005-08-19T11:06:06.000','2006-02-15T22:23:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15842','591','2','13343','3.99','2005-08-19T20:22:08.000','2006-02-15T22:23:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15843','591','1','13867','9.99','2005-08-20T15:05:42.000','2006-02-15T22:23:23.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15844','592','2','1163','6.99','2005-06-14T23:12:46.000','2006-02-15T22:23:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15845','592','2','1423','5.99','2005-06-15T18:08:12.000','2006-02-15T22:23:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15846','592','1','1479','2.99','2005-06-15T21:13:38.000','2006-02-15T22:23:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15847','592','1','2627','0.99','2005-06-19T08:32:00.000','2006-02-15T22:23:24.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15848','592','1','3158','7.99','2005-06-20T21:08:19.000','2006-02-15T22:23:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15849','592','2','3560','2.99','2005-07-06T02:51:37.000','2006-02-15T22:23:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15850','592','1','3973','11.99','2005-07-06T22:58:31.000','2006-02-15T22:23:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15851','592','1','4129','1.99','2005-07-07T07:37:03.000','2006-02-15T22:23:25.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15852','592','1','4145','9.99','2005-07-07T08:26:39.000','2006-02-15T22:23:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15853','592','1','4460','0.99','2005-07-07T23:50:14.000','2006-02-15T22:23:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15854','592','1','4518','2.99','2005-07-08T02:48:36.000','2006-02-15T22:23:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15855','592','1','6937','0.99','2005-07-26T23:15:50.000','2006-02-15T22:23:26.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15856','592','2','7173','0.99','2005-07-27T07:59:24.000','2006-02-15T22:23:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15857','592','1','7278','3.99','2005-07-27T11:50:34.000','2006-02-15T22:23:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15858','592','2','7364','4.99','2005-07-27T14:58:40.000','2006-02-15T22:23:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15859','592','1','8730','2.99','2005-07-29T18:23:34.000','2006-02-15T22:23:27.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15860','592','2','8773','0.99','2005-07-29T19:55:34.000','2006-02-15T22:23:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15861','592','1','9268','4.99','2005-07-30T15:02:30.000','2006-02-15T22:23:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15862','592','1','9437','3.99','2005-07-30T21:36:04.000','2006-02-15T22:23:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15863','592','2','9666','6.99','2005-07-31T06:20:58.000','2006-02-15T22:23:28.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15864','592','2','10383','0.99','2005-08-01T06:37:16.000','2006-02-15T22:23:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15865','592','2','10634','2.99','2005-08-01T15:37:48.000','2006-02-15T22:23:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15866','592','1','11410','8.99','2005-08-02T19:29:01.000','2006-02-15T22:23:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15867','592','2','12043','0.99','2005-08-17T20:38:21.000','2006-02-15T22:23:29.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15868','592','2','12619','0.99','2005-08-18T17:24:15.000','2006-02-15T22:23:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15869','592','1','12976','1.99','2005-08-19T06:52:58.000','2006-02-15T22:23:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15870','592','1','13157','2.99','2005-08-19T13:12:28.000','2006-02-15T22:23:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15871','592','2','13662','3.99','2005-08-20T08:11:58.000','2006-02-15T22:23:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15872','592','2','14606','0.99','2006-02-14T15:16:03.000','2006-02-15T22:23:30.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15873','593','1','790','2.99','2005-05-29T16:19:29.000','2006-02-15T22:23:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15874','593','1','991','8.99','2005-05-30T23:29:22.000','2006-02-15T22:23:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15875','593','2','2055','5.99','2005-06-17T15:27:03.000','2006-02-15T22:23:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15876','593','2','2205','4.99','2005-06-18T02:14:34.000','2006-02-15T22:23:31.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15877','593','1','2441','4.99','2005-06-18T18:45:11.000','2006-02-15T22:23:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15878','593','1','2832','4.99','2005-06-19T21:21:53.000','2006-02-15T22:23:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15879','593','2','3542','2.99','2005-07-06T01:51:42.000','2006-02-15T22:23:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15880','593','2','4075','2.99','2005-07-07T04:51:44.000','2006-02-15T22:23:32.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15881','593','2','4280','3.99','2005-07-07T15:09:31.000','2006-02-15T22:23:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15882','593','2','4623','0.99','2005-07-08T08:03:22.000','2006-02-15T22:23:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15883','593','2','4781','4.99','2005-07-08T16:06:55.000','2006-02-15T22:23:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15884','593','2','4867','0.99','2005-07-08T19:10:52.000','2006-02-15T22:23:33.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15885','593','1','6386','2.99','2005-07-11T22:14:57.000','2006-02-15T22:23:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15886','593','1','6731','2.99','2005-07-12T13:58:27.000','2006-02-15T22:23:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15887','593','2','7958','4.99','2005-07-28T13:34:34.000','2006-02-15T22:23:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15888','593','1','8497','2.99','2005-07-29T09:07:03.000','2006-02-15T22:23:34.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15889','593','2','9329','6.99','2005-07-30T17:42:38.000','2006-02-15T22:23:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15890','593','1','9483','6.99','2005-07-30T23:31:31.000','2006-02-15T22:23:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15891','593','1','10368','3.99','2005-08-01T06:13:38.000','2006-02-15T22:23:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15892','593','2','10533','3.99','2005-08-01T12:14:16.000','2006-02-15T22:23:35.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15893','593','1','10840','5.99','2005-08-01T23:38:34.000','2006-02-15T22:23:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15894','593','2','10904','4.99','2005-08-02T01:43:02.000','2006-02-15T22:23:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15895','593','2','12744','2.99','2005-08-18T22:22:36.000','2006-02-15T22:23:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15896','593','1','13524','6.99','2005-08-20T02:48:43.000','2006-02-15T22:23:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15897','593','1','14408','5.99','2005-08-21T10:47:24.000','2006-02-15T22:23:36.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15898','593','1','14653','0.99','2005-08-21T19:35:59.000','2006-02-15T22:23:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15899','594','1','313','4.99','2005-05-26T22:56:19.000','2006-02-15T22:23:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15900','594','1','360','8.99','2005-05-27T06:51:14.000','2006-02-15T22:23:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15901','594','2','1018','0.99','2005-05-31T02:53:42.000','2006-02-15T22:23:37.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15902','594','1','1045','6.99','2005-05-31T06:29:01.000','2006-02-15T22:23:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15903','594','2','1537','5.99','2005-06-16T00:52:51.000','2006-02-15T22:23:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15904','594','1','1816','4.99','2005-06-16T21:20:41.000','2006-02-15T22:23:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15905','594','1','1950','2.99','2005-06-17T08:26:52.000','2006-02-15T22:23:38.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15906','594','1','2276','6.99','2005-06-18T06:33:48.000','2006-02-15T22:23:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15907','594','2','2786','0.99','2005-06-19T18:46:43.000','2006-02-15T22:23:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15908','594','2','3302','1.99','2005-06-21T07:33:40.000','2006-02-15T22:23:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15909','594','2','3474','0.99','2005-07-05T22:59:53.000','2006-02-15T22:23:39.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15910','594','1','3546','4.99','2005-07-06T02:17:54.000','2006-02-15T22:23:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15911','594','2','3960','2.99','2005-07-06T22:08:53.000','2006-02-15T22:23:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15912','594','1','4037','5.99','2005-07-07T02:52:52.000','2006-02-15T22:23:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15913','594','1','4154','3.99','2005-07-07T08:58:23.000','2006-02-15T22:23:40.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15914','594','2','5386','2.99','2005-07-09T19:19:09.000','2006-02-15T22:23:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15915','594','1','6473','6.99','2005-07-12T01:35:40.000','2006-02-15T22:23:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15916','594','1','7533','8.99','2005-07-27T21:24:33.000','2006-02-15T22:23:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15917','594','1','8567','1.99','2005-07-29T11:37:30.000','2006-02-15T22:23:41.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15918','594','1','8603','2.99','2005-07-29T13:07:07.000','2006-02-15T22:23:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15919','594','2','8820','5.99','2005-07-29T22:14:56.000','2006-02-15T22:23:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15920','594','1','9545','7.99','2005-07-31T01:46:24.000','2006-02-15T22:23:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15921','594','1','9698','3.99','2005-07-31T07:24:35.000','2006-02-15T22:23:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15922','594','2','9802','4.99','2005-07-31T11:04:20.000','2006-02-15T22:23:42.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15923','594','2','10704','8.99','2005-08-01T18:38:02.000','2006-02-15T22:23:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15924','594','2','14824','4.99','2005-08-22T01:27:51.000','2006-02-15T22:23:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15925','594','1','14999','4.99','2005-08-22T07:54:47.000','2006-02-15T22:23:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15926','595','1','613','6.99','2005-05-28T15:27:22.000','2006-02-15T22:23:43.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15927','595','2','1170','2.99','2005-06-14T23:47:35.000','2006-02-15T22:23:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15928','595','2','3371','4.99','2005-06-21T13:27:22.000','2006-02-15T22:23:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15929','595','1','3789','9.99','2005-07-06T14:02:26.000','2006-02-15T22:23:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15930','595','1','4017','4.99','2005-07-07T01:08:18.000','2006-02-15T22:23:44.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15931','595','1','4241','4.99','2005-07-07T13:39:00.000','2006-02-15T22:23:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15932','595','2','4775','2.99','2005-07-08T15:44:05.000','2006-02-15T22:23:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15933','595','1','5631','1.99','2005-07-10T06:15:45.000','2006-02-15T22:23:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15934','595','1','5952','1.99','2005-07-10T23:18:20.000','2006-02-15T22:23:45.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15935','595','1','6105','6.99','2005-07-11T07:03:19.000','2006-02-15T22:23:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15936','595','1','6704','6.99','2005-07-12T12:50:24.000','2006-02-15T22:23:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15937','595','1','7086','4.99','2005-07-27T04:39:46.000','2006-02-15T22:23:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15938','595','2','7307','0.99','2005-07-27T12:59:10.000','2006-02-15T22:23:46.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15939','595','1','7396','4.99','2005-07-27T16:03:53.000','2006-02-15T22:23:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15940','595','2','7490','3.99','2005-07-27T19:48:12.000','2006-02-15T22:23:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15941','595','1','9152','2.99','2005-07-30T10:51:27.000','2006-02-15T22:23:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15942','595','2','9223','2.99','2005-07-30T13:23:20.000','2006-02-15T22:23:47.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15943','595','1','9354','4.99','2005-07-30T18:32:51.000','2006-02-15T22:23:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15944','595','2','9497','0.99','2005-07-30T23:56:54.000','2006-02-15T22:23:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15945','595','2','9542','4.99','2005-07-31T01:41:48.000','2006-02-15T22:23:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15946','595','1','9631','2.99','2005-07-31T05:02:00.000','2006-02-15T22:23:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15947','595','2','9826','10.99','2005-07-31T11:51:46.000','2006-02-15T22:23:48.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15948','595','1','10729','2.99','2005-08-01T19:21:11.000','2006-02-15T22:23:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15949','595','1','10932','2.99','2005-08-02T02:46:22.000','2006-02-15T22:23:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15950','595','2','11748','0.99','2005-08-17T09:04:02.000','2006-02-15T22:23:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15951','595','1','12235','0.99','2005-08-18T03:17:50.000','2006-02-15T22:23:49.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15952','595','1','14334','0.99','2005-08-21T08:32:32.000','2006-02-15T22:23:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15953','595','2','15576','2.99','2005-08-23T05:32:03.000','2006-02-15T22:23:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15954','595','2','15994','0.99','2005-08-23T20:29:10.000','2006-02-15T22:23:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15955','595','2','16016','2.99','2005-08-23T21:26:35.000','2006-02-15T22:23:50.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15956','596','2','303','4.99','2005-05-26T21:16:52.000','2006-02-15T22:23:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15957','596','2','625','0.99','2005-05-28T16:35:46.000','2006-02-15T22:23:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15958','596','2','667','4.99','2005-05-28T21:49:02.000','2006-02-15T22:23:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15959','596','2','782','1.99','2005-05-29T14:38:57.000','2006-02-15T22:23:51.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15960','596','1','914','2.99','2005-05-30T11:06:00.000','2006-02-15T22:23:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15961','596','1','974','6.99','2005-05-30T20:28:42.000','2006-02-15T22:23:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15962','596','1','1644','1.99','2005-06-16T08:58:18.000','2006-02-15T22:23:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15963','596','1','2767','1.99','2005-06-19T17:46:35.000','2006-02-15T22:23:52.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15964','596','2','5742','3.99','2005-07-10T11:56:18.000','2006-02-15T22:23:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15965','596','1','6015','2.99','2005-07-11T02:04:12.000','2006-02-15T22:23:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15966','596','1','6017','0.99','2005-07-11T02:05:32.000','2006-02-15T22:23:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15967','596','1','6197','4.99','2005-07-11T12:09:51.000','2006-02-15T22:23:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15968','596','2','6883','4.99','2005-07-12T20:50:48.000','2006-02-15T22:23:53.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15969','596','1','10094','3.99','2005-07-31T20:31:18.000','2006-02-15T22:23:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15970','596','2','10692','4.99','2005-08-01T18:12:35.000','2006-02-15T22:23:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15971','596','1','10756','2.99','2005-08-01T20:17:03.000','2006-02-15T22:23:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15972','596','2','10804','0.99','2005-08-01T22:22:11.000','2006-02-15T22:23:54.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15973','596','2','11009','4.99','2005-08-02T05:06:23.000','2006-02-15T22:23:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15974','596','2','11852','3.99','2005-08-17T13:38:27.000','2006-02-15T22:23:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15975','596','1','11934','0.99','2005-08-17T16:40:00.000','2006-02-15T22:23:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15976','596','2','12560','4.99','2005-08-18T14:54:19.000','2006-02-15T22:23:55.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15977','596','1','12878','4.99','2005-08-19T03:17:08.000','2006-02-15T22:23:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15978','596','1','13648','4.99','2005-08-20T07:48:10.000','2006-02-15T22:23:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15979','596','1','14050','3.99','2005-08-20T22:09:04.000','2006-02-15T22:23:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15980','596','1','14417','0.99','2005-08-21T11:13:35.000','2006-02-15T22:23:56.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15981','596','1','15405','0.99','2005-08-22T23:20:41.000','2006-02-15T22:23:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15982','596','1','15899','6.99','2005-08-23T17:16:28.000','2006-02-15T22:23:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15983','596','1','15423','0.99','2006-02-14T15:16:03.000','2006-02-15T22:23:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15984','597','2','34','2.99','2005-05-25T04:19:28.000','2006-02-15T22:23:57.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15985','597','2','514','8.99','2005-05-28T03:09:28.000','2006-02-15T22:23:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15986','597','1','2379','0.99','2005-06-18T14:59:39.000','2006-02-15T22:23:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15987','597','1','2696','4.99','2005-06-19T13:28:42.000','2006-02-15T22:23:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15988','597','1','3201','1.99','2005-06-21T00:30:26.000','2006-02-15T22:23:58.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15989','597','1','5093','0.99','2005-07-09T05:59:12.000','2006-02-15T22:23:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15990','597','1','5348','4.99','2005-07-09T17:34:11.000','2006-02-15T22:23:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15991','597','2','5732','2.99','2005-07-10T11:36:32.000','2006-02-15T22:23:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15992','597','1','6508','2.99','2005-07-12T03:34:50.000','2006-02-15T22:23:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15993','597','2','7968','4.99','2005-07-28T13:57:35.000','2006-02-15T22:23:59.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15994','597','2','8948','4.99','2005-07-30T03:16:18.000','2006-02-15T22:24:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15995','597','2','10021','4.99','2005-07-31T18:24:39.000','2006-02-15T22:24:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15996','597','1','10214','0.99','2005-08-01T01:04:15.000','2006-02-15T22:24:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15997','597','2','10986','5.99','2005-08-02T04:35:24.000','2006-02-15T22:24:00.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15998','597','2','11147','4.99','2005-08-02T09:45:54.000','2006-02-15T22:24:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('15999','597','2','11223','2.99','2005-08-02T12:34:27.000','2006-02-15T22:24:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('16000','597','1','11240','2.99','2005-08-02T13:28:30.000','2006-02-15T22:24:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('16001','597','1','11880','5.99','2005-08-17T14:28:28.000','2006-02-15T22:24:01.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('16002','597','1','12081','4.99','2005-08-17T22:10:46.000','2006-02-15T22:24:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('16003','597','1','12992','0.99','2005-08-19T07:23:06.000','2006-02-15T22:24:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('16004','597','2','13019','2.99','2005-08-19T08:07:43.000','2006-02-15T22:24:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('16005','597','1','13152','6.99','2005-08-19T13:09:32.000','2006-02-15T22:24:02.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('16006','597','2','15275','2.99','2005-08-22T18:57:39.000','2006-02-15T22:24:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('16007','597','1','15469','4.99','2005-08-23T01:29:59.000','2006-02-15T22:24:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('16008','597','1','11652','4.99','2006-02-14T15:16:03.000','2006-02-15T22:24:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('16009','598','1','3005','2.99','2005-06-20T10:10:29.000','2006-02-15T22:24:03.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('16010','598','1','3648','0.99','2005-07-06T07:30:41.000','2006-02-15T22:24:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('16011','598','2','3950','6.99','2005-07-06T21:48:44.000','2006-02-15T22:24:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('16012','598','1','3972','4.99','2005-07-06T22:53:57.000','2006-02-15T22:24:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('16013','598','1','4181','4.99','2005-07-07T10:27:54.000','2006-02-15T22:24:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('16014','598','2','5688','5.99','2005-07-10T09:16:08.000','2006-02-15T22:24:04.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('16015','598','1','6519','4.99','2005-07-12T04:00:36.000','2006-02-15T22:24:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('16016','598','2','6528','4.99','2005-07-12T04:29:44.000','2006-02-15T22:24:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('16017','598','2','6575','0.99','2005-07-12T06:12:53.000','2006-02-15T22:24:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('16018','598','2','6660','3.99','2005-07-12T11:20:12.000','2006-02-15T22:24:05.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('16019','598','2','7201','6.99','2005-07-27T08:57:40.000','2006-02-15T22:24:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('16020','598','2','7354','0.99','2005-07-27T14:42:11.000','2006-02-15T22:24:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('16021','598','1','7998','0.99','2005-07-28T15:08:48.000','2006-02-15T22:24:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('16022','598','2','8436','0.99','2005-07-29T07:21:20.000','2006-02-15T22:24:06.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('16023','598','1','8511','5.99','2005-07-29T09:42:42.000','2006-02-15T22:24:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('16024','598','1','8939','4.99','2005-07-30T02:56:53.000','2006-02-15T22:24:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('16025','598','1','10054','4.99','2005-07-31T19:15:52.000','2006-02-15T22:24:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('16026','598','2','11350','0.99','2005-08-02T17:22:59.000','2006-02-15T22:24:07.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('16027','598','2','12601','2.99','2005-08-18T16:47:52.000','2006-02-15T22:24:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('16028','598','2','14345','0.99','2005-08-21T08:41:15.000','2006-02-15T22:24:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('16029','598','2','15307','2.99','2005-08-22T19:54:26.000','2006-02-15T22:24:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('16030','598','1','15443','7.99','2005-08-23T00:44:15.000','2006-02-15T22:24:08.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('16031','599','2','1008','4.99','2005-05-31T01:18:56.000','2006-02-15T22:24:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('16032','599','1','2272','1.99','2005-06-18T06:29:53.000','2006-02-15T22:24:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('16033','599','2','3043','6.99','2005-06-20T12:38:35.000','2006-02-15T22:24:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('16034','599','2','3398','4.99','2005-06-21T15:34:38.000','2006-02-15T22:24:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('16035','599','1','3429','6.99','2005-06-21T18:46:05.000','2006-02-15T22:24:09.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('16036','599','1','5065','0.99','2005-07-09T04:42:00.000','2006-02-15T22:24:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('16037','599','1','5843','2.99','2005-07-10T17:14:27.000','2006-02-15T22:24:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('16038','599','2','6800','9.99','2005-07-12T17:03:56.000','2006-02-15T22:24:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('16039','599','2','6895','2.99','2005-07-12T21:23:59.000','2006-02-15T22:24:10.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('16040','599','1','8965','6.99','2005-07-30T03:52:37.000','2006-02-15T22:24:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('16041','599','2','9630','2.99','2005-07-31T04:57:07.000','2006-02-15T22:24:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('16042','599','2','9679','2.99','2005-07-31T06:41:19.000','2006-02-15T22:24:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('16043','599','2','11522','3.99','2005-08-17T00:05:05.000','2006-02-15T22:24:11.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('16044','599','1','14233','1.99','2005-08-21T05:07:08.000','2006-02-15T22:24:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('16045','599','1','14599','4.99','2005-08-21T17:43:42.000','2006-02-15T22:24:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('16046','599','1','14719','1.99','2005-08-21T21:41:57.000','2006-02-15T22:24:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('16047','599','2','15590','8.99','2005-08-23T06:09:44.000','2006-02-15T22:24:12.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('16048','599','2','15719','2.99','2005-08-23T11:08:46.000','2006-02-15T22:24:13.000')
;
Insert into payment
 (payment_id,customer_id,staff_id,rental_id,amount,payment_date,last_update)
Values
('16049','599','2','15725','2.99','2005-08-23T11:25:00.000','2006-02-15T22:24:13.000')
;

-- End of Script
--
--

SET IDENTITY_INSERT payment OFF

ALTER TABLE staff ADD CONSTRAINT fk_staff_address FOREIGN KEY (address_id) REFERENCES address (address_id) ON UPDATE CASCADE;
ALTER TABLE staff ADD CONSTRAINT fk_staff_store FOREIGN KEY (store_id) REFERENCES store (store_id) ON UPDATE CASCADE;
